#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 9
#define STATE_COUNT 4480
#define SYMBOL_COUNT 156
#define ALIAS_COUNT 2
#define TOKEN_COUNT 97
#define EXTERNAL_TOKEN_COUNT 15
#define MAX_ALIAS_SEQUENCE_LENGTH 8

enum {
  sym_heredoc_start = 1,
  sym__simple_heredoc_body = 2,
  sym__heredoc_body_beginning = 3,
  sym__heredoc_body_middle = 4,
  sym__heredoc_body_end = 5,
  sym_file_descriptor = 6,
  sym__empty_value = 7,
  sym__concat = 8,
  sym_variable_name = 9,
  sym_regex = 10,
  anon_sym_for = 11,
  anon_sym_in = 12,
  anon_sym_LPAREN_LPAREN = 13,
  anon_sym_RPAREN_RPAREN = 14,
  anon_sym_SEMI = 15,
  anon_sym_while = 16,
  anon_sym_do = 17,
  anon_sym_done = 18,
  anon_sym_if = 19,
  anon_sym_then = 20,
  anon_sym_fi = 21,
  anon_sym_elif = 22,
  anon_sym_else = 23,
  anon_sym_case = 24,
  anon_sym_esac = 25,
  anon_sym_PIPE = 26,
  anon_sym_RPAREN = 27,
  anon_sym_SEMI_SEMI = 28,
  anon_sym_function = 29,
  anon_sym_LPAREN = 30,
  anon_sym_LBRACE = 31,
  anon_sym_RBRACE = 32,
  anon_sym_PIPE_AMP = 33,
  anon_sym_AMP_AMP = 34,
  anon_sym_PIPE_PIPE = 35,
  anon_sym_BANG = 36,
  anon_sym_LBRACK = 37,
  anon_sym_RBRACK = 38,
  anon_sym_LBRACK_LBRACK = 39,
  anon_sym_RBRACK_RBRACK = 40,
  anon_sym_declare = 41,
  anon_sym_typeset = 42,
  anon_sym_export = 43,
  anon_sym_readonly = 44,
  anon_sym_local = 45,
  anon_sym_unset = 46,
  anon_sym_unsetenv = 47,
  anon_sym_EQ_TILDE = 48,
  anon_sym_EQ_EQ = 49,
  anon_sym_EQ = 50,
  anon_sym_PLUS_EQ = 51,
  anon_sym_LT = 52,
  anon_sym_GT = 53,
  anon_sym_GT_GT = 54,
  anon_sym_AMP_GT = 55,
  anon_sym_AMP_GT_GT = 56,
  anon_sym_LT_AMP = 57,
  anon_sym_GT_AMP = 58,
  anon_sym_LT_LT = 59,
  anon_sym_LT_LT_DASH = 60,
  anon_sym_LT_LT_LT = 61,
  anon_sym_BANG_EQ = 62,
  anon_sym_PLUS = 63,
  anon_sym_DASH = 64,
  anon_sym_DASH_EQ = 65,
  anon_sym_LT_EQ = 66,
  anon_sym_GT_EQ = 67,
  anon_sym_PLUS_PLUS = 68,
  anon_sym_DASH_DASH = 69,
  anon_sym_DOLLAR = 70,
  sym__special_character = 71,
  anon_sym_DQUOTE = 72,
  sym__string_content = 73,
  sym_raw_string = 74,
  anon_sym_POUND = 75,
  anon_sym_DOLLAR_LBRACE = 76,
  anon_sym_SLASH = 77,
  anon_sym_COLON = 78,
  anon_sym_COLON_QMARK = 79,
  anon_sym_COLON_DASH = 80,
  anon_sym_PERCENT = 81,
  anon_sym_DOLLAR_LPAREN = 82,
  anon_sym_BQUOTE = 83,
  anon_sym_LT_LPAREN = 84,
  anon_sym_GT_LPAREN = 85,
  sym_comment = 86,
  aux_sym_SLASH_BSLASHw_PLUS_SLASH = 87,
  anon_sym_STAR = 88,
  anon_sym_AT = 89,
  anon_sym_QMARK = 90,
  anon_sym_0 = 91,
  anon_sym__ = 92,
  sym_word = 93,
  sym_test_operator = 94,
  anon_sym_LF = 95,
  anon_sym_AMP = 96,
  sym_program = 97,
  sym__statements = 98,
  sym__terminated_statement = 99,
  sym_redirected_statement = 100,
  sym_for_statement = 101,
  sym_c_style_for_statement = 102,
  sym_while_statement = 103,
  sym_do_group = 104,
  sym_if_statement = 105,
  sym_elif_clause = 106,
  sym_else_clause = 107,
  sym_case_statement = 108,
  sym_case_item = 109,
  sym_last_case_item = 110,
  sym_function_definition = 111,
  sym_compound_statement = 112,
  sym_subshell = 113,
  sym_pipeline = 114,
  sym_list = 115,
  sym_negated_command = 116,
  sym_test_command = 117,
  sym_declaration_command = 118,
  sym_unset_command = 119,
  sym_command = 120,
  sym_command_name = 121,
  sym_variable_assignment = 122,
  sym_subscript = 123,
  sym_file_redirect = 124,
  sym_heredoc_redirect = 125,
  sym_heredoc_body = 126,
  sym_herestring_redirect = 127,
  sym__expression = 128,
  sym_binary_expression = 129,
  sym_unary_expression = 130,
  sym_postfix_expression = 131,
  sym_parenthesized_expression = 132,
  sym_concatenation = 133,
  sym_string = 134,
  sym_array = 135,
  sym_simple_expansion = 136,
  sym_string_expansion = 137,
  sym_expansion = 138,
  sym_command_substitution = 139,
  sym_process_substitution = 140,
  aux_sym__statements_repeat1 = 141,
  aux_sym_redirected_statement_repeat1 = 142,
  aux_sym_for_statement_repeat1 = 143,
  aux_sym_if_statement_repeat1 = 144,
  aux_sym_case_statement_repeat1 = 145,
  aux_sym_case_item_repeat1 = 146,
  aux_sym_declaration_command_repeat1 = 147,
  aux_sym_unset_command_repeat1 = 148,
  aux_sym_command_repeat1 = 149,
  aux_sym_command_repeat2 = 150,
  aux_sym_heredoc_body_repeat1 = 151,
  aux_sym__literal_repeat1 = 152,
  aux_sym_concatenation_repeat1 = 153,
  aux_sym_string_repeat1 = 154,
  aux_sym_expansion_repeat1 = 155,
  alias_sym_special_variable_name = 156,
  alias_sym_word = 157,
};

static const char *ts_symbol_names[] = {
  [sym_heredoc_start] = "heredoc_start",
  [sym__simple_heredoc_body] = "_simple_heredoc_body",
  [sym__heredoc_body_beginning] = "_heredoc_body_beginning",
  [sym__heredoc_body_middle] = "_heredoc_body_middle",
  [sym__heredoc_body_end] = "_heredoc_body_end",
  [sym_file_descriptor] = "file_descriptor",
  [sym__empty_value] = "_empty_value",
  [sym__concat] = "_concat",
  [sym_variable_name] = "variable_name",
  [sym_regex] = "regex",
  [ts_builtin_sym_end] = "END",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_LPAREN_LPAREN] = "((",
  [anon_sym_RPAREN_RPAREN] = "))",
  [anon_sym_SEMI] = ";",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_done] = "done",
  [anon_sym_if] = "if",
  [anon_sym_then] = "then",
  [anon_sym_fi] = "fi",
  [anon_sym_elif] = "elif",
  [anon_sym_else] = "else",
  [anon_sym_case] = "case",
  [anon_sym_esac] = "esac",
  [anon_sym_PIPE] = "|",
  [anon_sym_RPAREN] = ")",
  [anon_sym_SEMI_SEMI] = ";;",
  [anon_sym_function] = "function",
  [anon_sym_LPAREN] = "(",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_PIPE_AMP] = "|&",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_BANG] = "!",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LBRACK_LBRACK] = "[[",
  [anon_sym_RBRACK_RBRACK] = "]]",
  [anon_sym_declare] = "declare",
  [anon_sym_typeset] = "typeset",
  [anon_sym_export] = "export",
  [anon_sym_readonly] = "readonly",
  [anon_sym_local] = "local",
  [anon_sym_unset] = "unset",
  [anon_sym_unsetenv] = "unsetenv",
  [anon_sym_EQ_TILDE] = "=~",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_EQ] = "=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_AMP_GT] = "&>",
  [anon_sym_AMP_GT_GT] = "&>>",
  [anon_sym_LT_AMP] = "<&",
  [anon_sym_GT_AMP] = ">&",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_LT_LT_DASH] = "<<-",
  [anon_sym_LT_LT_LT] = "<<<",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_DOLLAR] = "$",
  [sym__special_character] = "_special_character",
  [anon_sym_DQUOTE] = "\"",
  [sym__string_content] = "_string_content",
  [sym_raw_string] = "raw_string",
  [anon_sym_POUND] = "#",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_SLASH] = "/",
  [anon_sym_COLON] = ":",
  [anon_sym_COLON_QMARK] = ":?",
  [anon_sym_COLON_DASH] = ":-",
  [anon_sym_PERCENT] = "%",
  [anon_sym_DOLLAR_LPAREN] = "$(",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_LT_LPAREN] = "<(",
  [anon_sym_GT_LPAREN] = ">(",
  [sym_comment] = "comment",
  [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = "variable_name",
  [anon_sym_STAR] = "special_variable_name",
  [anon_sym_AT] = "special_variable_name",
  [anon_sym_QMARK] = "special_variable_name",
  [anon_sym_0] = "special_variable_name",
  [anon_sym__] = "special_variable_name",
  [sym_word] = "word",
  [sym_test_operator] = "test_operator",
  [anon_sym_LF] = "\n",
  [anon_sym_AMP] = "&",
  [sym_program] = "program",
  [sym__statements] = "_statements",
  [sym__terminated_statement] = "_terminated_statement",
  [sym_redirected_statement] = "redirected_statement",
  [sym_for_statement] = "for_statement",
  [sym_c_style_for_statement] = "c_style_for_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_group] = "do_group",
  [sym_if_statement] = "if_statement",
  [sym_elif_clause] = "elif_clause",
  [sym_else_clause] = "else_clause",
  [sym_case_statement] = "case_statement",
  [sym_case_item] = "case_item",
  [sym_last_case_item] = "case_item",
  [sym_function_definition] = "function_definition",
  [sym_compound_statement] = "compound_statement",
  [sym_subshell] = "subshell",
  [sym_pipeline] = "pipeline",
  [sym_list] = "list",
  [sym_negated_command] = "negated_command",
  [sym_test_command] = "test_command",
  [sym_declaration_command] = "declaration_command",
  [sym_unset_command] = "unset_command",
  [sym_command] = "command",
  [sym_command_name] = "command_name",
  [sym_variable_assignment] = "variable_assignment",
  [sym_subscript] = "subscript",
  [sym_file_redirect] = "file_redirect",
  [sym_heredoc_redirect] = "heredoc_redirect",
  [sym_heredoc_body] = "heredoc_body",
  [sym_herestring_redirect] = "herestring_redirect",
  [sym__expression] = "_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_postfix_expression] = "postfix_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_concatenation] = "concatenation",
  [sym_string] = "string",
  [sym_array] = "array",
  [sym_simple_expansion] = "simple_expansion",
  [sym_string_expansion] = "string_expansion",
  [sym_expansion] = "expansion",
  [sym_command_substitution] = "command_substitution",
  [sym_process_substitution] = "process_substitution",
  [aux_sym__statements_repeat1] = "_statements_repeat1",
  [aux_sym_redirected_statement_repeat1] = "redirected_statement_repeat1",
  [aux_sym_for_statement_repeat1] = "for_statement_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym_case_statement_repeat1] = "case_statement_repeat1",
  [aux_sym_case_item_repeat1] = "case_item_repeat1",
  [aux_sym_declaration_command_repeat1] = "declaration_command_repeat1",
  [aux_sym_unset_command_repeat1] = "unset_command_repeat1",
  [aux_sym_command_repeat1] = "command_repeat1",
  [aux_sym_command_repeat2] = "command_repeat2",
  [aux_sym_heredoc_body_repeat1] = "heredoc_body_repeat1",
  [aux_sym__literal_repeat1] = "_literal_repeat1",
  [aux_sym_concatenation_repeat1] = "concatenation_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_expansion_repeat1] = "expansion_repeat1",
  [alias_sym_special_variable_name] = "special_variable_name",
  [alias_sym_word] = "word",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [sym_heredoc_start] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_heredoc_body] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_body_beginning] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_body_middle] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_body_end] = {
    .visible = false,
    .named = true,
  },
  [sym_file_descriptor] = {
    .visible = true,
    .named = true,
  },
  [sym__empty_value] = {
    .visible = false,
    .named = true,
  },
  [sym__concat] = {
    .visible = false,
    .named = true,
  },
  [sym_variable_name] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_done] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fi] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_esac] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_readonly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_local] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsetenv] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [sym__special_character] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym__string_content] = {
    .visible = false,
    .named = true,
  },
  [sym_raw_string] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_0] = {
    .visible = true,
    .named = true,
  },
  [anon_sym__] = {
    .visible = true,
    .named = true,
  },
  [sym_word] = {
    .visible = true,
    .named = true,
  },
  [sym_test_operator] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym__statements] = {
    .visible = false,
    .named = true,
  },
  [sym__terminated_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_redirected_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_c_style_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_group] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_elif_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_case_item] = {
    .visible = true,
    .named = true,
  },
  [sym_last_case_item] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_subshell] = {
    .visible = true,
    .named = true,
  },
  [sym_pipeline] = {
    .visible = true,
    .named = true,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym_negated_command] = {
    .visible = true,
    .named = true,
  },
  [sym_test_command] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_command] = {
    .visible = true,
    .named = true,
  },
  [sym_unset_command] = {
    .visible = true,
    .named = true,
  },
  [sym_command] = {
    .visible = true,
    .named = true,
  },
  [sym_command_name] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript] = {
    .visible = true,
    .named = true,
  },
  [sym_file_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_body] = {
    .visible = true,
    .named = true,
  },
  [sym_herestring_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_postfix_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenation] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_simple_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_string_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_command_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_process_substitution] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__statements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_redirected_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_item_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_unset_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_heredoc_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_expansion_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_special_variable_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_word] = {
    .visible = true,
    .named = true,
  },
};

static TSSymbol ts_alias_sequences[8][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [1] = {
    [0] = alias_sym_word,
  },
  [2] = {
    [1] = alias_sym_word,
  },
  [3] = {
    [1] = alias_sym_special_variable_name,
  },
  [4] = {
    [2] = alias_sym_word,
  },
  [5] = {
    [2] = alias_sym_special_variable_name,
  },
  [6] = {
    [3] = alias_sym_word,
  },
  [7] = {
    [4] = alias_sym_word,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(11);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(21);
      if (lookahead == '+')
        ADVANCE(22);
      if (lookahead == '-')
        ADVANCE(25);
      if (lookahead == '/')
        ADVANCE(29);
      if (lookahead == '0')
        ADVANCE(30);
      if (lookahead == ':')
        ADVANCE(31);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(36);
      if (lookahead == '=')
        ADVANCE(43);
      if (lookahead == '>')
        ADVANCE(46);
      if (lookahead == '?')
        ADVANCE(51);
      if (lookahead == '@')
        ADVANCE(52);
      if (lookahead == '[')
        ADVANCE(53);
      if (lookahead == '\\')
        ADVANCE(55);
      if (lookahead == ']')
        ADVANCE(56);
      if (lookahead == '_')
        ADVANCE(58);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(60);
      if (lookahead == 'f')
        ADVANCE(69);
      if (lookahead == 'i')
        ADVANCE(71);
      if (lookahead == '{')
        ADVANCE(73);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(0);
      ADVANCE(5);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 2:
      ACCEPT_TOKEN(anon_sym_LF);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 4:
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(5);
      END_STATE();
    case 5:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 6:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 7:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 8:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == '{')
        ADVANCE(10);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LPAREN);
      END_STATE();
    case 10:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(13);
      if (lookahead == '>')
        ADVANCE(14);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_AMP_GT);
      if (lookahead == '>')
        ADVANCE(15);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(anon_sym_AMP_GT_GT);
      END_STATE();
    case 16:
      if (lookahead == '\'')
        ADVANCE(17);
      if (lookahead != 0)
        ADVANCE(16);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(sym_raw_string);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      if (lookahead == '(')
        ADVANCE(19);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_LPAREN_LPAREN);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+')
        ADVANCE(23);
      if (lookahead == '=')
        ADVANCE(24);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ';' || lookahead > '>') &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-')
        ADVANCE(26);
      if (lookahead == '=')
        ADVANCE(27);
      if (lookahead == '\\')
        ADVANCE(4);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(28);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ';' || lookahead > '>') &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '`' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(sym_test_operator);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(28);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_0);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '-')
        ADVANCE(32);
      if (lookahead == '?')
        ADVANCE(33);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '?' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_COLON_DASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_COLON_QMARK);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_SEMI);
      if (lookahead == ';')
        ADVANCE(35);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_SEMI_SEMI);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(37);
      if (lookahead == '(')
        ADVANCE(38);
      if (lookahead == '<')
        ADVANCE(39);
      if (lookahead == '=')
        ADVANCE(42);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_LT_AMP);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_LT_LPAREN);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '-')
        ADVANCE(40);
      if (lookahead == '<')
        ADVANCE(41);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_LT_LT_DASH);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_LT_LT_LT);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(44);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == '~')
        ADVANCE(45);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ';' || lookahead > '>') &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(5);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_EQ_TILDE);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '&')
        ADVANCE(47);
      if (lookahead == '(')
        ADVANCE(48);
      if (lookahead == '=')
        ADVANCE(49);
      if (lookahead == '>')
        ADVANCE(50);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_GT_AMP);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_GT_LPAREN);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_AT);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '[')
        ADVANCE(54);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_LBRACK_LBRACK);
      END_STATE();
    case 55:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(0);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      if (lookahead == ']')
        ADVANCE(57);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_RBRACK_RBRACK);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym__);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'l')
        ADVANCE(61);
      if (lookahead == 's')
        ADVANCE(66);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'i')
        ADVANCE(62);
      if (lookahead == 's')
        ADVANCE(64);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'f')
        ADVANCE(63);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_elif);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'e')
        ADVANCE(65);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_else);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'a')
        ADVANCE(67);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          lookahead != 'a' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'c')
        ADVANCE(68);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_esac);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'i')
        ADVANCE(70);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_fi);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'n')
        ADVANCE(72);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '&')
        ADVANCE(75);
      if (lookahead == '|')
        ADVANCE(76);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_PIPE_AMP);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 78:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(80);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(53);
      if (lookahead == '\\')
        ADVANCE(83);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(73);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(78);
      if ((lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(79);
      END_STATE();
    case 80:
      if (lookahead == '>')
        ADVANCE(14);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(37);
      if (lookahead == '(')
        ADVANCE(38);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '&')
        ADVANCE(47);
      if (lookahead == '(')
        ADVANCE(48);
      if (lookahead == '>')
        ADVANCE(50);
      END_STATE();
    case 83:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(78);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(sym__special_character);
      END_STATE();
    case 85:
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == '+')
        ADVANCE(86);
      if (lookahead == ';')
        ADVANCE(88);
      if (lookahead == '=')
        ADVANCE(89);
      if (lookahead == '[')
        ADVANCE(90);
      if (lookahead == '\\')
        SKIP(91);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(85);
      END_STATE();
    case 86:
      if (lookahead == '=')
        ADVANCE(87);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 88:
      if (lookahead == ';')
        ADVANCE(35);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 91:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(85);
      END_STATE();
    case 92:
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '(')
        ADVANCE(93);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        SKIP(94);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(92);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    case 93:
      if (lookahead == '(')
        ADVANCE(19);
      END_STATE();
    case 94:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(92);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    case 96:
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(97);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '<')
        ADVANCE(99);
      if (lookahead == '>')
        ADVANCE(100);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(101);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(96);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(28);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '`' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 99:
      if (lookahead == '(')
        ADVANCE(38);
      END_STATE();
    case 100:
      if (lookahead == '(')
        ADVANCE(48);
      END_STATE();
    case 101:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(96);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 102:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(80);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(103);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(102);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 103:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(102);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 104:
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(80);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(53);
      if (lookahead == '\\')
        ADVANCE(105);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(73);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(104);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 105:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(104);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 106:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(80);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(53);
      if (lookahead == '\\')
        ADVANCE(107);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(106);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 107:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(106);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 108:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(110);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(108);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if ((lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(37);
      if (lookahead == '(')
        ADVANCE(38);
      if (lookahead == '<')
        ADVANCE(39);
      END_STATE();
    case 110:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(108);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 112:
      if (lookahead == '!')
        ADVANCE(113);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(114);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '*')
        ADVANCE(115);
      if (lookahead == '-')
        ADVANCE(116);
      if (lookahead == '0')
        ADVANCE(117);
      if (lookahead == '?')
        ADVANCE(118);
      if (lookahead == '@')
        ADVANCE(119);
      if (lookahead == '\\')
        SKIP(120);
      if (lookahead == '_')
        ADVANCE(121);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(112);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_0);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 120:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(112);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym__);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    case 122:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(123);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(124);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(122);
      if ((lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '=')
        ADVANCE(44);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == '~')
        ADVANCE(45);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ';' || lookahead > '>') &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(5);
      END_STATE();
    case 124:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(122);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 125:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(126);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\\')
        ADVANCE(130);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(131);
      if (lookahead != 0)
        ADVANCE(127);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(127);
      if (lookahead == '\\')
        ADVANCE(129);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\\')
        ADVANCE(128);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(127);
      END_STATE();
    case 128:
      if (lookahead == '\n')
        ADVANCE(127);
      if (lookahead != 0)
        ADVANCE(127);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\n')
        ADVANCE(127);
      if (lookahead != 0)
        ADVANCE(126);
      END_STATE();
    case 130:
      if (lookahead == '\n')
        ADVANCE(131);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(131);
      if (lookahead != 0)
        ADVANCE(127);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '#')
        ADVANCE(126);
      if (lookahead == '\\')
        ADVANCE(130);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(131);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(127);
      END_STATE();
    case 132:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(97);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(123);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(133);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(132);
      if ((lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 133:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(132);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 134:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '\\')
        SKIP(135);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(134);
      END_STATE();
    case 135:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(134);
      END_STATE();
    case 136:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(137);
      if (lookahead == '>')
        ADVANCE(138);
      if (lookahead == '\\')
        SKIP(139);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(136);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(37);
      if (lookahead == '<')
        ADVANCE(39);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '&')
        ADVANCE(47);
      if (lookahead == '>')
        ADVANCE(50);
      END_STATE();
    case 139:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(136);
      END_STATE();
    case 140:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(141);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(140);
      if ((lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 141:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(140);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 142:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(123);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(143);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(142);
      if ((lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 143:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(142);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 144:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(97);
      if (lookahead == '<')
        ADVANCE(99);
      if (lookahead == '>')
        ADVANCE(100);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(145);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(144);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 145:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(144);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 146:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(147);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(97);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(99);
      if (lookahead == '>')
        ADVANCE(100);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(148);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(146);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 148:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(146);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 149:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(147);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        SKIP(150);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == 'i')
        ADVANCE(151);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(149);
      END_STATE();
    case 150:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(149);
      END_STATE();
    case 151:
      if (lookahead == 'n')
        ADVANCE(152);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 153:
      if (lookahead == '!')
        ADVANCE(154);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(156);
      if (lookahead == ')')
        ADVANCE(157);
      if (lookahead == '+')
        ADVANCE(159);
      if (lookahead == '-')
        ADVANCE(161);
      if (lookahead == '<')
        ADVANCE(165);
      if (lookahead == '=')
        ADVANCE(166);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        SKIP(170);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(171);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(153);
      END_STATE();
    case 154:
      if (lookahead == '=')
        ADVANCE(155);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 156:
      if (lookahead == '&')
        ADVANCE(13);
      END_STATE();
    case 157:
      if (lookahead == ')')
        ADVANCE(158);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_RPAREN_RPAREN);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+')
        ADVANCE(160);
      if (lookahead == '=')
        ADVANCE(87);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-')
        ADVANCE(162);
      if (lookahead == '=')
        ADVANCE(163);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(164);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(sym_test_operator);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(164);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '=')
        ADVANCE(42);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(167);
      if (lookahead == '~')
        ADVANCE(168);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_EQ_TILDE);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=')
        ADVANCE(49);
      END_STATE();
    case 170:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(153);
      END_STATE();
    case 171:
      if (lookahead == '|')
        ADVANCE(76);
      END_STATE();
    case 172:
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '(')
        ADVANCE(97);
      if (lookahead == '\\')
        SKIP(173);
      if (lookahead == 'd')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(73);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(172);
      END_STATE();
    case 173:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(172);
      END_STATE();
    case 174:
      if (lookahead == 'o')
        ADVANCE(175);
      END_STATE();
    case 175:
      if (lookahead == 'n')
        ADVANCE(176);
      END_STATE();
    case 176:
      if (lookahead == 'e')
        ADVANCE(177);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_done);
      END_STATE();
    case 178:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(179);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(178);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if ((lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 179:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(178);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 180:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(97);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(123);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(181);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(180);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 181:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(180);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 182:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(137);
      if (lookahead == '>')
        ADVANCE(138);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        SKIP(183);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(182);
      END_STATE();
    case 183:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(182);
      END_STATE();
    case 184:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(185);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(184);
      if ((lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 185:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(184);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 186:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(137);
      if (lookahead == '>')
        ADVANCE(138);
      if (lookahead == '\\')
        SKIP(187);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'd')
        ADVANCE(174);
      if (lookahead == 'e')
        ADVANCE(188);
      if (lookahead == 'f')
        ADVANCE(197);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(186);
      END_STATE();
    case 187:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(186);
      END_STATE();
    case 188:
      if (lookahead == 'l')
        ADVANCE(189);
      if (lookahead == 's')
        ADVANCE(194);
      END_STATE();
    case 189:
      if (lookahead == 'i')
        ADVANCE(190);
      if (lookahead == 's')
        ADVANCE(192);
      END_STATE();
    case 190:
      if (lookahead == 'f')
        ADVANCE(191);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_elif);
      END_STATE();
    case 192:
      if (lookahead == 'e')
        ADVANCE(193);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 194:
      if (lookahead == 'a')
        ADVANCE(195);
      END_STATE();
    case 195:
      if (lookahead == 'c')
        ADVANCE(196);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_esac);
      END_STATE();
    case 197:
      if (lookahead == 'i')
        ADVANCE(198);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_fi);
      END_STATE();
    case 199:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(200);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(199);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 200:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(199);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 201:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(123);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(202);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(201);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 202:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(201);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 203:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(97);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(123);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(204);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(203);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 204:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(203);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 205:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(137);
      if (lookahead == '>')
        ADVANCE(138);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        SKIP(206);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(205);
      END_STATE();
    case 206:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(205);
      END_STATE();
    case 207:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(208);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(207);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 208:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(207);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 209:
      if (lookahead == '!')
        ADVANCE(154);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(156);
      if (lookahead == '+')
        ADVANCE(159);
      if (lookahead == '-')
        ADVANCE(161);
      if (lookahead == '<')
        ADVANCE(165);
      if (lookahead == '=')
        ADVANCE(166);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        SKIP(210);
      if (lookahead == ']')
        ADVANCE(211);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(171);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(209);
      END_STATE();
    case 210:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(209);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 212:
      if (lookahead == '!')
        ADVANCE(154);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(156);
      if (lookahead == '+')
        ADVANCE(159);
      if (lookahead == '-')
        ADVANCE(161);
      if (lookahead == '<')
        ADVANCE(165);
      if (lookahead == '=')
        ADVANCE(166);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        SKIP(213);
      if (lookahead == ']')
        ADVANCE(214);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(171);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(212);
      END_STATE();
    case 213:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(212);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(sym__special_character);
      if (lookahead == ']')
        ADVANCE(57);
      END_STATE();
    case 215:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(80);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == '<')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(216);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(215);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 216:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(215);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 217:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(114);
      if (lookahead == '*')
        ADVANCE(115);
      if (lookahead == '-')
        ADVANCE(116);
      if (lookahead == '0')
        ADVANCE(218);
      if (lookahead == '?')
        ADVANCE(118);
      if (lookahead == '@')
        ADVANCE(119);
      if (lookahead == '\\')
        ADVANCE(220);
      if (lookahead == '_')
        ADVANCE(222);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(221);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(219);
      if (lookahead != 0 &&
          (lookahead < '_' || lookahead > 'z'))
        ADVANCE(127);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(anon_sym_0);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(219);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(219);
      END_STATE();
    case 220:
      if (lookahead == '\n')
        ADVANCE(221);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(221);
      if (lookahead != 0)
        ADVANCE(127);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '*')
        ADVANCE(115);
      if (lookahead == '-')
        ADVANCE(116);
      if (lookahead == '0')
        ADVANCE(218);
      if (lookahead == '?')
        ADVANCE(118);
      if (lookahead == '@')
        ADVANCE(119);
      if (lookahead == '\\')
        ADVANCE(220);
      if (lookahead == '_')
        ADVANCE(222);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(221);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(219);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '_' || lookahead > 'z'))
        ADVANCE(127);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(anon_sym__);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(219);
      END_STATE();
    case 223:
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(114);
      if (lookahead == '*')
        ADVANCE(115);
      if (lookahead == '-')
        ADVANCE(116);
      if (lookahead == '0')
        ADVANCE(117);
      if (lookahead == '?')
        ADVANCE(118);
      if (lookahead == '@')
        ADVANCE(119);
      if (lookahead == '\\')
        SKIP(224);
      if (lookahead == '_')
        ADVANCE(121);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(223);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    case 224:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(223);
      END_STATE();
    case 225:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(11);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '-')
        ADVANCE(226);
      if (lookahead == '/')
        ADVANCE(29);
      if (lookahead == ':')
        ADVANCE(31);
      if (lookahead == '<')
        ADVANCE(99);
      if (lookahead == '=')
        ADVANCE(227);
      if (lookahead == '>')
        ADVANCE(100);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(228);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(225);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > ')') &&
          (lookahead < ':' || lookahead > '>') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 228:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(225);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 229:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(137);
      if (lookahead == '>')
        ADVANCE(138);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        SKIP(230);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(229);
      END_STATE();
    case 230:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(229);
      END_STATE();
    case 231:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(147);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '\\')
        SKIP(232);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'd')
        ADVANCE(174);
      if (lookahead == 'e')
        ADVANCE(188);
      if (lookahead == 'f')
        ADVANCE(197);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(231);
      END_STATE();
    case 232:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(231);
      END_STATE();
    case 233:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(80);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == ';')
        ADVANCE(88);
      if (lookahead == '<')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(53);
      if (lookahead == '\\')
        ADVANCE(234);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(73);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(233);
      if ((lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 234:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(233);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 235:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(147);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '\\')
        SKIP(236);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(235);
      END_STATE();
    case 236:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(235);
      END_STATE();
    case 237:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(99);
      if (lookahead == '>')
        ADVANCE(100);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(238);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(237);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 238:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(237);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 239:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(99);
      if (lookahead == '>')
        ADVANCE(100);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(240);
      if (lookahead == ']')
        ADVANCE(211);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(239);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 240:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(239);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 241:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '!')
        ADVANCE(154);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(242);
      if (lookahead == '+')
        ADVANCE(159);
      if (lookahead == '-')
        ADVANCE(161);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(165);
      if (lookahead == '=')
        ADVANCE(166);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        SKIP(243);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(171);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(241);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(13);
      END_STATE();
    case 243:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(241);
      END_STATE();
    case 244:
      if (lookahead == '!')
        ADVANCE(154);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(156);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == '+')
        ADVANCE(159);
      if (lookahead == '-')
        ADVANCE(161);
      if (lookahead == '<')
        ADVANCE(165);
      if (lookahead == '=')
        ADVANCE(166);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        SKIP(245);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(171);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(244);
      END_STATE();
    case 245:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(244);
      END_STATE();
    case 246:
      if (lookahead == '!')
        ADVANCE(154);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(156);
      if (lookahead == ')')
        ADVANCE(157);
      if (lookahead == '+')
        ADVANCE(159);
      if (lookahead == '-')
        ADVANCE(161);
      if (lookahead == '<')
        ADVANCE(165);
      if (lookahead == '=')
        ADVANCE(166);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '\\')
        SKIP(247);
      if (lookahead == ']')
        ADVANCE(248);
      if (lookahead == '|')
        ADVANCE(171);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(246);
      END_STATE();
    case 247:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(246);
      END_STATE();
    case 248:
      if (lookahead == ']')
        ADVANCE(57);
      END_STATE();
    case 249:
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(80);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(53);
      if (lookahead == '\\')
        ADVANCE(250);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'd')
        ADVANCE(251);
      if (lookahead == '{')
        ADVANCE(73);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(249);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 250:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(249);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'o')
        ADVANCE(252);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'n')
        ADVANCE(253);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'e')
        ADVANCE(254);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(anon_sym_done);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 255:
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(80);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(53);
      if (lookahead == '\\')
        ADVANCE(256);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(257);
      if (lookahead == 'f')
        ADVANCE(69);
      if (lookahead == '{')
        ADVANCE(73);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(255);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 256:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(255);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'l')
        ADVANCE(61);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 258:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(147);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '\\')
        SKIP(259);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(258);
      END_STATE();
    case 259:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(258);
      END_STATE();
    case 260:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(99);
      if (lookahead == '>')
        ADVANCE(100);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(261);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(260);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 261:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(260);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 262:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(11);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '-')
        ADVANCE(226);
      if (lookahead == ':')
        ADVANCE(31);
      if (lookahead == '<')
        ADVANCE(99);
      if (lookahead == '=')
        ADVANCE(227);
      if (lookahead == '>')
        ADVANCE(100);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(263);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(262);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > ')') &&
          (lookahead < ':' || lookahead > '>') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 263:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(262);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 264:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(137);
      if (lookahead == '>')
        ADVANCE(138);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        SKIP(265);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(264);
      END_STATE();
    case 265:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(264);
      END_STATE();
    case 266:
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '+')
        ADVANCE(86);
      if (lookahead == '=')
        ADVANCE(89);
      if (lookahead == '\\')
        SKIP(267);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(266);
      END_STATE();
    case 267:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(266);
      END_STATE();
    case 268:
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(97);
      if (lookahead == ')')
        ADVANCE(157);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '<')
        ADVANCE(99);
      if (lookahead == '>')
        ADVANCE(100);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(269);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(268);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 269:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(268);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 270:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(147);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(99);
      if (lookahead == '>')
        ADVANCE(100);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(271);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(270);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 271:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(270);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 272:
      if (lookahead == '!')
        ADVANCE(154);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(156);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == '+')
        ADVANCE(159);
      if (lookahead == '-')
        ADVANCE(161);
      if (lookahead == '<')
        ADVANCE(165);
      if (lookahead == '=')
        ADVANCE(166);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        SKIP(273);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(274);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(272);
      END_STATE();
    case 273:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(272);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|')
        ADVANCE(76);
      END_STATE();
    case 275:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(276);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'd')
        ADVANCE(277);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(275);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 276:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(275);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'o')
        ADVANCE(278);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'n')
        ADVANCE(279);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'e')
        ADVANCE(280);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(anon_sym_done);
      if (lookahead == '\\')
        ADVANCE(4);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 281:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(123);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(282);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'd')
        ADVANCE(251);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(281);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 282:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(281);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 283:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(97);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(123);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(284);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'd')
        ADVANCE(251);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(283);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 284:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(283);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 285:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(137);
      if (lookahead == '>')
        ADVANCE(138);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        SKIP(286);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == 'd')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(285);
      END_STATE();
    case 286:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(285);
      END_STATE();
    case 287:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(288);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'd')
        ADVANCE(251);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(287);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 288:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(287);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 289:
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(80);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(53);
      if (lookahead == '\\')
        ADVANCE(290);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'f')
        ADVANCE(69);
      if (lookahead == '{')
        ADVANCE(73);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(289);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 290:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(289);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 291:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(292);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(293);
      if (lookahead == 'f')
        ADVANCE(299);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(291);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 292:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(291);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'l')
        ADVANCE(294);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'i')
        ADVANCE(295);
      if (lookahead == 's')
        ADVANCE(297);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'f')
        ADVANCE(296);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(anon_sym_elif);
      if (lookahead == '\\')
        ADVANCE(4);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'e')
        ADVANCE(298);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(anon_sym_else);
      if (lookahead == '\\')
        ADVANCE(4);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'i')
        ADVANCE(300);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 300:
      ACCEPT_TOKEN(anon_sym_fi);
      if (lookahead == '\\')
        ADVANCE(4);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 301:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(123);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(302);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(257);
      if (lookahead == 'f')
        ADVANCE(69);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(301);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 302:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(301);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 303:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(97);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(123);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(304);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(257);
      if (lookahead == 'f')
        ADVANCE(69);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(303);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 304:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(303);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 305:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(137);
      if (lookahead == '>')
        ADVANCE(138);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        SKIP(306);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == 'e')
        ADVANCE(307);
      if (lookahead == 'f')
        ADVANCE(197);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(305);
      END_STATE();
    case 306:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(305);
      END_STATE();
    case 307:
      if (lookahead == 'l')
        ADVANCE(189);
      END_STATE();
    case 308:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(309);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(257);
      if (lookahead == 'f')
        ADVANCE(69);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(308);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 309:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(308);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 310:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(99);
      if (lookahead == '>')
        ADVANCE(100);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(311);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(312);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(310);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 311:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(310);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 312:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 's')
        ADVANCE(66);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 313:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(226);
      if (lookahead == '0')
        ADVANCE(314);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(123);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '?')
        ADVANCE(51);
      if (lookahead == '@')
        ADVANCE(52);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(315);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '_')
        ADVANCE(316);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(313);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if ((lookahead < '&' || lookahead > '*'))
        ADVANCE(5);
      END_STATE();
    case 314:
      ACCEPT_TOKEN(anon_sym_0);
      if (lookahead == '\\')
        ADVANCE(4);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 315:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(313);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 316:
      ACCEPT_TOKEN(anon_sym__);
      if (lookahead == '\\')
        ADVANCE(4);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 317:
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == ';')
        ADVANCE(318);
      if (lookahead == '\\')
        ADVANCE(319);
      if (lookahead == '{')
        ADVANCE(73);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(317);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 318:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 319:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(317);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 320:
      if (lookahead == '!')
        ADVANCE(154);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(114);
      if (lookahead == '&')
        ADVANCE(156);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ')')
        ADVANCE(157);
      if (lookahead == '*')
        ADVANCE(115);
      if (lookahead == '+')
        ADVANCE(159);
      if (lookahead == '-')
        ADVANCE(161);
      if (lookahead == '0')
        ADVANCE(117);
      if (lookahead == '<')
        ADVANCE(165);
      if (lookahead == '=')
        ADVANCE(166);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(118);
      if (lookahead == '@')
        ADVANCE(119);
      if (lookahead == '\\')
        SKIP(321);
      if (lookahead == ']')
        ADVANCE(248);
      if (lookahead == '_')
        ADVANCE(121);
      if (lookahead == '|')
        ADVANCE(171);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(320);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    case 321:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(320);
      END_STATE();
    case 322:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(147);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '\\')
        SKIP(323);
      if (lookahead == 'd')
        ADVANCE(174);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(322);
      END_STATE();
    case 323:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(322);
      END_STATE();
    case 324:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(325);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'f')
        ADVANCE(299);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(324);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 325:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(324);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 326:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(123);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(327);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'f')
        ADVANCE(69);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(326);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 327:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(326);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 328:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(97);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(123);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(329);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'f')
        ADVANCE(69);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(328);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 329:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(328);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 330:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(137);
      if (lookahead == '>')
        ADVANCE(138);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        SKIP(331);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == 'f')
        ADVANCE(197);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(330);
      END_STATE();
    case 331:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(330);
      END_STATE();
    case 332:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(333);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'f')
        ADVANCE(69);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(332);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 333:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(332);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 334:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(147);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '\\')
        SKIP(335);
      if (lookahead == 'e')
        ADVANCE(307);
      if (lookahead == 'f')
        ADVANCE(197);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(334);
      END_STATE();
    case 335:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(334);
      END_STATE();
    case 336:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(114);
      if (lookahead == '&')
        ADVANCE(147);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '*')
        ADVANCE(115);
      if (lookahead == '-')
        ADVANCE(116);
      if (lookahead == '0')
        ADVANCE(117);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '?')
        ADVANCE(118);
      if (lookahead == '@')
        ADVANCE(119);
      if (lookahead == '\\')
        SKIP(337);
      if (lookahead == '_')
        ADVANCE(121);
      if (lookahead == 'i')
        ADVANCE(338);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(336);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    case 337:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(336);
      END_STATE();
    case 338:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'n')
        ADVANCE(339);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    case 339:
      ACCEPT_TOKEN(anon_sym_in);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    case 340:
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        SKIP(341);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(342);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(340);
      END_STATE();
    case 341:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(340);
      END_STATE();
    case 342:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 343:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(137);
      if (lookahead == '>')
        ADVANCE(138);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        SKIP(344);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == 'e')
        ADVANCE(345);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(343);
      END_STATE();
    case 344:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(343);
      END_STATE();
    case 345:
      if (lookahead == 's')
        ADVANCE(194);
      END_STATE();
    case 346:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '*')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(226);
      if (lookahead == '0')
        ADVANCE(314);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(123);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '?')
        ADVANCE(51);
      if (lookahead == '@')
        ADVANCE(52);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(347);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '_')
        ADVANCE(316);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(346);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > '*'))
        ADVANCE(5);
      END_STATE();
    case 347:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(346);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 348:
      if (lookahead == '!')
        ADVANCE(154);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(114);
      if (lookahead == '&')
        ADVANCE(156);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '*')
        ADVANCE(115);
      if (lookahead == '+')
        ADVANCE(159);
      if (lookahead == '-')
        ADVANCE(161);
      if (lookahead == '0')
        ADVANCE(117);
      if (lookahead == '<')
        ADVANCE(165);
      if (lookahead == '=')
        ADVANCE(166);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(118);
      if (lookahead == '@')
        ADVANCE(119);
      if (lookahead == '\\')
        SKIP(349);
      if (lookahead == ']')
        ADVANCE(211);
      if (lookahead == '_')
        ADVANCE(121);
      if (lookahead == '|')
        ADVANCE(171);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(348);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    case 349:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(348);
      END_STATE();
    case 350:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(226);
      if (lookahead == '0')
        ADVANCE(314);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '?')
        ADVANCE(51);
      if (lookahead == '@')
        ADVANCE(52);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(351);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '_')
        ADVANCE(316);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(350);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if ((lookahead < '&' || lookahead > '*'))
        ADVANCE(5);
      END_STATE();
    case 351:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(350);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 352:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(80);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(226);
      if (lookahead == '0')
        ADVANCE(314);
      if (lookahead == '<')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '?')
        ADVANCE(51);
      if (lookahead == '@')
        ADVANCE(52);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(353);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '_')
        ADVANCE(316);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(352);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > '*') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 353:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(352);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 354:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(114);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '*')
        ADVANCE(115);
      if (lookahead == '-')
        ADVANCE(116);
      if (lookahead == '0')
        ADVANCE(117);
      if (lookahead == '?')
        ADVANCE(118);
      if (lookahead == '@')
        ADVANCE(119);
      if (lookahead == '\\')
        SKIP(355);
      if (lookahead == ']')
        ADVANCE(211);
      if (lookahead == '_')
        ADVANCE(121);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(354);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    case 355:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(354);
      END_STATE();
    case 356:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '!')
        ADVANCE(154);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(114);
      if (lookahead == '&')
        ADVANCE(242);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(115);
      if (lookahead == '+')
        ADVANCE(159);
      if (lookahead == '-')
        ADVANCE(161);
      if (lookahead == '0')
        ADVANCE(117);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(165);
      if (lookahead == '=')
        ADVANCE(166);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(118);
      if (lookahead == '@')
        ADVANCE(119);
      if (lookahead == '\\')
        SKIP(357);
      if (lookahead == '_')
        ADVANCE(121);
      if (lookahead == '|')
        ADVANCE(171);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(356);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    case 357:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(356);
      END_STATE();
    case 358:
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(80);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(88);
      if (lookahead == '<')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(53);
      if (lookahead == '\\')
        ADVANCE(359);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(312);
      if (lookahead == '{')
        ADVANCE(73);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(358);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 359:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(358);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 360:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '*')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(226);
      if (lookahead == '0')
        ADVANCE(314);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '?')
        ADVANCE(51);
      if (lookahead == '@')
        ADVANCE(52);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(361);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '_')
        ADVANCE(316);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(360);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > '*'))
        ADVANCE(5);
      END_STATE();
    case 361:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(360);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 362:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(11);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '*')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(226);
      if (lookahead == '0')
        ADVANCE(314);
      if (lookahead == ':')
        ADVANCE(31);
      if (lookahead == '<')
        ADVANCE(99);
      if (lookahead == '=')
        ADVANCE(227);
      if (lookahead == '>')
        ADVANCE(100);
      if (lookahead == '?')
        ADVANCE(51);
      if (lookahead == '@')
        ADVANCE(52);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(363);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '_')
        ADVANCE(316);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(362);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '*') &&
          (lookahead < '0' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 363:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(362);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 364:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(114);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(115);
      if (lookahead == '-')
        ADVANCE(116);
      if (lookahead == '0')
        ADVANCE(117);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(137);
      if (lookahead == '>')
        ADVANCE(138);
      if (lookahead == '?')
        ADVANCE(118);
      if (lookahead == '@')
        ADVANCE(119);
      if (lookahead == '\\')
        SKIP(365);
      if (lookahead == '_')
        ADVANCE(121);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(364);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    case 365:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(364);
      END_STATE();
    case 366:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(147);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '*')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(226);
      if (lookahead == '0')
        ADVANCE(314);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(99);
      if (lookahead == '>')
        ADVANCE(100);
      if (lookahead == '?')
        ADVANCE(51);
      if (lookahead == '@')
        ADVANCE(52);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(367);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '_')
        ADVANCE(316);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(366);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > '*') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 367:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(366);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 368:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '*')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(226);
      if (lookahead == '0')
        ADVANCE(314);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(123);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '?')
        ADVANCE(51);
      if (lookahead == '@')
        ADVANCE(52);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(369);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '_')
        ADVANCE(316);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'd')
        ADVANCE(277);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(368);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > '*'))
        ADVANCE(5);
      END_STATE();
    case 369:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(368);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 370:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(137);
      if (lookahead == '>')
        ADVANCE(138);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        SKIP(371);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == 'd')
        ADVANCE(174);
      if (lookahead == 'e')
        ADVANCE(188);
      if (lookahead == 'f')
        ADVANCE(197);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(370);
      END_STATE();
    case 371:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(370);
      END_STATE();
    case 372:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '*')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(226);
      if (lookahead == '0')
        ADVANCE(314);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(123);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '?')
        ADVANCE(51);
      if (lookahead == '@')
        ADVANCE(52);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(373);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '_')
        ADVANCE(316);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(293);
      if (lookahead == 'f')
        ADVANCE(299);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(372);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > '*'))
        ADVANCE(5);
      END_STATE();
    case 373:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(372);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 374:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(375);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(376);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(374);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 375:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(374);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 376:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 's')
        ADVANCE(377);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 377:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'a')
        ADVANCE(378);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 378:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'c')
        ADVANCE(379);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 379:
      ACCEPT_TOKEN(anon_sym_esac);
      if (lookahead == '\\')
        ADVANCE(4);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 380:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(123);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(381);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(312);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(380);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 381:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(380);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 382:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(97);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(123);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(383);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(312);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(382);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 383:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(382);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 384:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(385);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(312);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(384);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 385:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(384);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 386:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(114);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '*')
        ADVANCE(115);
      if (lookahead == '-')
        ADVANCE(116);
      if (lookahead == '0')
        ADVANCE(117);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(137);
      if (lookahead == '>')
        ADVANCE(138);
      if (lookahead == '?')
        ADVANCE(118);
      if (lookahead == '@')
        ADVANCE(119);
      if (lookahead == '\\')
        SKIP(387);
      if (lookahead == '_')
        ADVANCE(121);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(386);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    case 387:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(386);
      END_STATE();
    case 388:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '*')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(226);
      if (lookahead == '0')
        ADVANCE(314);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '?')
        ADVANCE(51);
      if (lookahead == '@')
        ADVANCE(52);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(389);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '_')
        ADVANCE(316);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'd')
        ADVANCE(277);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(388);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > '*'))
        ADVANCE(5);
      END_STATE();
    case 389:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(388);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 390:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '*')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(226);
      if (lookahead == '0')
        ADVANCE(314);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(123);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '?')
        ADVANCE(51);
      if (lookahead == '@')
        ADVANCE(52);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(391);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '_')
        ADVANCE(316);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'f')
        ADVANCE(299);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(390);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > '*'))
        ADVANCE(5);
      END_STATE();
    case 391:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(390);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 392:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '*')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(226);
      if (lookahead == '0')
        ADVANCE(314);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '?')
        ADVANCE(51);
      if (lookahead == '@')
        ADVANCE(52);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(393);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '_')
        ADVANCE(316);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(293);
      if (lookahead == 'f')
        ADVANCE(299);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(392);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > '*'))
        ADVANCE(5);
      END_STATE();
    case 393:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(392);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 394:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(114);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(115);
      if (lookahead == '-')
        ADVANCE(116);
      if (lookahead == '0')
        ADVANCE(117);
      if (lookahead == '?')
        ADVANCE(118);
      if (lookahead == '@')
        ADVANCE(119);
      if (lookahead == '\\')
        SKIP(395);
      if (lookahead == '_')
        ADVANCE(121);
      if (lookahead == '|')
        ADVANCE(342);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(394);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    case 395:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(394);
      END_STATE();
    case 396:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(147);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '\\')
        SKIP(397);
      if (lookahead == 'e')
        ADVANCE(345);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(396);
      END_STATE();
    case 397:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(396);
      END_STATE();
    case 398:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(114);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '*')
        ADVANCE(115);
      if (lookahead == '-')
        ADVANCE(116);
      if (lookahead == '0')
        ADVANCE(117);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(137);
      if (lookahead == '>')
        ADVANCE(138);
      if (lookahead == '?')
        ADVANCE(118);
      if (lookahead == '@')
        ADVANCE(119);
      if (lookahead == '\\')
        SKIP(399);
      if (lookahead == '_')
        ADVANCE(121);
      if (lookahead == 'd')
        ADVANCE(400);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(398);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    case 399:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(398);
      END_STATE();
    case 400:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'o')
        ADVANCE(401);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    case 401:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'n')
        ADVANCE(402);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    case 402:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'e')
        ADVANCE(403);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    case 403:
      ACCEPT_TOKEN(anon_sym_done);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    case 404:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '*')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(226);
      if (lookahead == '0')
        ADVANCE(314);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '?')
        ADVANCE(51);
      if (lookahead == '@')
        ADVANCE(52);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(405);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '_')
        ADVANCE(316);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'f')
        ADVANCE(299);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(404);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > '*'))
        ADVANCE(5);
      END_STATE();
    case 405:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(404);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 406:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(114);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '*')
        ADVANCE(115);
      if (lookahead == '-')
        ADVANCE(116);
      if (lookahead == '0')
        ADVANCE(117);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(137);
      if (lookahead == '>')
        ADVANCE(138);
      if (lookahead == '?')
        ADVANCE(118);
      if (lookahead == '@')
        ADVANCE(119);
      if (lookahead == '\\')
        SKIP(407);
      if (lookahead == '_')
        ADVANCE(121);
      if (lookahead == 'e')
        ADVANCE(408);
      if (lookahead == 'f')
        ADVANCE(414);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(406);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    case 407:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(406);
      END_STATE();
    case 408:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'l')
        ADVANCE(409);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    case 409:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'i')
        ADVANCE(410);
      if (lookahead == 's')
        ADVANCE(412);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    case 410:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'f')
        ADVANCE(411);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    case 411:
      ACCEPT_TOKEN(anon_sym_elif);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    case 412:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'e')
        ADVANCE(413);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    case 413:
      ACCEPT_TOKEN(anon_sym_else);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    case 414:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'i')
        ADVANCE(415);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    case 415:
      ACCEPT_TOKEN(anon_sym_fi);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    case 416:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(114);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '*')
        ADVANCE(115);
      if (lookahead == '-')
        ADVANCE(116);
      if (lookahead == '0')
        ADVANCE(117);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(137);
      if (lookahead == '>')
        ADVANCE(138);
      if (lookahead == '?')
        ADVANCE(118);
      if (lookahead == '@')
        ADVANCE(119);
      if (lookahead == '\\')
        SKIP(417);
      if (lookahead == '_')
        ADVANCE(121);
      if (lookahead == 'f')
        ADVANCE(414);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(416);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    case 417:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(416);
      END_STATE();
    case 418:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '*')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(226);
      if (lookahead == '0')
        ADVANCE(314);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(123);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '?')
        ADVANCE(51);
      if (lookahead == '@')
        ADVANCE(52);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(419);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '_')
        ADVANCE(316);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(376);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(418);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > '*'))
        ADVANCE(5);
      END_STATE();
    case 419:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(418);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 420:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '*')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(226);
      if (lookahead == '0')
        ADVANCE(314);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '?')
        ADVANCE(51);
      if (lookahead == '@')
        ADVANCE(52);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(421);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '_')
        ADVANCE(316);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(376);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(420);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > '*'))
        ADVANCE(5);
      END_STATE();
    case 421:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(420);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 422:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(114);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '*')
        ADVANCE(115);
      if (lookahead == '-')
        ADVANCE(116);
      if (lookahead == '0')
        ADVANCE(117);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(137);
      if (lookahead == '>')
        ADVANCE(138);
      if (lookahead == '?')
        ADVANCE(118);
      if (lookahead == '@')
        ADVANCE(119);
      if (lookahead == '\\')
        SKIP(423);
      if (lookahead == '_')
        ADVANCE(121);
      if (lookahead == 'e')
        ADVANCE(424);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(422);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    case 423:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(422);
      END_STATE();
    case 424:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 's')
        ADVANCE(425);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    case 425:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'a')
        ADVANCE(426);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    case 426:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == 'c')
        ADVANCE(427);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    case 427:
      ACCEPT_TOKEN(anon_sym_esac);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 'c')
        ADVANCE(1);
      if (lookahead == 'd')
        ADVANCE(5);
      if (lookahead == 'e')
        ADVANCE(13);
      if (lookahead == 'f')
        ADVANCE(19);
      if (lookahead == 'i')
        ADVANCE(29);
      if (lookahead == 'l')
        ADVANCE(31);
      if (lookahead == 'r')
        ADVANCE(36);
      if (lookahead == 't')
        ADVANCE(44);
      if (lookahead == 'u')
        ADVANCE(54);
      if (lookahead == 'w')
        ADVANCE(62);
      END_STATE();
    case 1:
      if (lookahead == 'a')
        ADVANCE(2);
      END_STATE();
    case 2:
      if (lookahead == 's')
        ADVANCE(3);
      END_STATE();
    case 3:
      if (lookahead == 'e')
        ADVANCE(4);
      END_STATE();
    case 4:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 5:
      if (lookahead == 'e')
        ADVANCE(6);
      if (lookahead == 'o')
        ADVANCE(12);
      END_STATE();
    case 6:
      if (lookahead == 'c')
        ADVANCE(7);
      END_STATE();
    case 7:
      if (lookahead == 'l')
        ADVANCE(8);
      END_STATE();
    case 8:
      if (lookahead == 'a')
        ADVANCE(9);
      END_STATE();
    case 9:
      if (lookahead == 'r')
        ADVANCE(10);
      END_STATE();
    case 10:
      if (lookahead == 'e')
        ADVANCE(11);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(anon_sym_declare);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 13:
      if (lookahead == 'x')
        ADVANCE(14);
      END_STATE();
    case 14:
      if (lookahead == 'p')
        ADVANCE(15);
      END_STATE();
    case 15:
      if (lookahead == 'o')
        ADVANCE(16);
      END_STATE();
    case 16:
      if (lookahead == 'r')
        ADVANCE(17);
      END_STATE();
    case 17:
      if (lookahead == 't')
        ADVANCE(18);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 19:
      if (lookahead == 'o')
        ADVANCE(20);
      if (lookahead == 'u')
        ADVANCE(22);
      END_STATE();
    case 20:
      if (lookahead == 'r')
        ADVANCE(21);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 22:
      if (lookahead == 'n')
        ADVANCE(23);
      END_STATE();
    case 23:
      if (lookahead == 'c')
        ADVANCE(24);
      END_STATE();
    case 24:
      if (lookahead == 't')
        ADVANCE(25);
      END_STATE();
    case 25:
      if (lookahead == 'i')
        ADVANCE(26);
      END_STATE();
    case 26:
      if (lookahead == 'o')
        ADVANCE(27);
      END_STATE();
    case 27:
      if (lookahead == 'n')
        ADVANCE(28);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 29:
      if (lookahead == 'f')
        ADVANCE(30);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 31:
      if (lookahead == 'o')
        ADVANCE(32);
      END_STATE();
    case 32:
      if (lookahead == 'c')
        ADVANCE(33);
      END_STATE();
    case 33:
      if (lookahead == 'a')
        ADVANCE(34);
      END_STATE();
    case 34:
      if (lookahead == 'l')
        ADVANCE(35);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_local);
      END_STATE();
    case 36:
      if (lookahead == 'e')
        ADVANCE(37);
      END_STATE();
    case 37:
      if (lookahead == 'a')
        ADVANCE(38);
      END_STATE();
    case 38:
      if (lookahead == 'd')
        ADVANCE(39);
      END_STATE();
    case 39:
      if (lookahead == 'o')
        ADVANCE(40);
      END_STATE();
    case 40:
      if (lookahead == 'n')
        ADVANCE(41);
      END_STATE();
    case 41:
      if (lookahead == 'l')
        ADVANCE(42);
      END_STATE();
    case 42:
      if (lookahead == 'y')
        ADVANCE(43);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_readonly);
      END_STATE();
    case 44:
      if (lookahead == 'h')
        ADVANCE(45);
      if (lookahead == 'y')
        ADVANCE(48);
      END_STATE();
    case 45:
      if (lookahead == 'e')
        ADVANCE(46);
      END_STATE();
    case 46:
      if (lookahead == 'n')
        ADVANCE(47);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 48:
      if (lookahead == 'p')
        ADVANCE(49);
      END_STATE();
    case 49:
      if (lookahead == 'e')
        ADVANCE(50);
      END_STATE();
    case 50:
      if (lookahead == 's')
        ADVANCE(51);
      END_STATE();
    case 51:
      if (lookahead == 'e')
        ADVANCE(52);
      END_STATE();
    case 52:
      if (lookahead == 't')
        ADVANCE(53);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_typeset);
      END_STATE();
    case 54:
      if (lookahead == 'n')
        ADVANCE(55);
      END_STATE();
    case 55:
      if (lookahead == 's')
        ADVANCE(56);
      END_STATE();
    case 56:
      if (lookahead == 'e')
        ADVANCE(57);
      END_STATE();
    case 57:
      if (lookahead == 't')
        ADVANCE(58);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_unset);
      if (lookahead == 'e')
        ADVANCE(59);
      END_STATE();
    case 59:
      if (lookahead == 'n')
        ADVANCE(60);
      END_STATE();
    case 60:
      if (lookahead == 'v')
        ADVANCE(61);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_unsetenv);
      END_STATE();
    case 62:
      if (lookahead == 'h')
        ADVANCE(63);
      END_STATE();
    case 63:
      if (lookahead == 'i')
        ADVANCE(64);
      END_STATE();
    case 64:
      if (lookahead == 'l')
        ADVANCE(65);
      END_STATE();
    case 65:
      if (lookahead == 'e')
        ADVANCE(66);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 78, .external_lex_state = 2},
  [2] = {.lex_state = 78},
  [3] = {.lex_state = 85},
  [4] = {.lex_state = 92},
  [5] = {.lex_state = 96},
  [6] = {.lex_state = 78, .external_lex_state = 2},
  [7] = {.lex_state = 78, .external_lex_state = 2},
  [8] = {.lex_state = 102},
  [9] = {.lex_state = 102},
  [10] = {.lex_state = 78, .external_lex_state = 2},
  [11] = {.lex_state = 104, .external_lex_state = 3},
  [12] = {.lex_state = 106, .external_lex_state = 2},
  [13] = {.lex_state = 96},
  [14] = {.lex_state = 96},
  [15] = {.lex_state = 108, .external_lex_state = 4},
  [16] = {.lex_state = 108, .external_lex_state = 5},
  [17] = {.lex_state = 102},
  [18] = {.lex_state = 112},
  [19] = {.lex_state = 122, .external_lex_state = 6},
  [20] = {.lex_state = 125},
  [21] = {.lex_state = 122, .external_lex_state = 6},
  [22] = {.lex_state = 112, .external_lex_state = 7},
  [23] = {.lex_state = 78, .external_lex_state = 2},
  [24] = {.lex_state = 78, .external_lex_state = 2},
  [25] = {.lex_state = 78, .external_lex_state = 2},
  [26] = {.lex_state = 132, .external_lex_state = 6},
  [27] = {.lex_state = 134},
  [28] = {.lex_state = 134},
  [29] = {.lex_state = 136, .external_lex_state = 5},
  [30] = {.lex_state = 122, .external_lex_state = 5},
  [31] = {.lex_state = 140, .external_lex_state = 4},
  [32] = {.lex_state = 85},
  [33] = {.lex_state = 142, .external_lex_state = 5},
  [34] = {.lex_state = 78, .external_lex_state = 2},
  [35] = {.lex_state = 102, .external_lex_state = 2},
  [36] = {.lex_state = 122, .external_lex_state = 5},
  [37] = {.lex_state = 102},
  [38] = {.lex_state = 102},
  [39] = {.lex_state = 144, .external_lex_state = 8},
  [40] = {.lex_state = 146, .external_lex_state = 9},
  [41] = {.lex_state = 149, .external_lex_state = 9},
  [42] = {.lex_state = 96},
  [43] = {.lex_state = 96},
  [44] = {.lex_state = 112},
  [45] = {.lex_state = 153, .external_lex_state = 10},
  [46] = {.lex_state = 125},
  [47] = {.lex_state = 153, .external_lex_state = 10},
  [48] = {.lex_state = 112, .external_lex_state = 7},
  [49] = {.lex_state = 78, .external_lex_state = 2},
  [50] = {.lex_state = 78, .external_lex_state = 2},
  [51] = {.lex_state = 78, .external_lex_state = 2},
  [52] = {.lex_state = 153},
  [53] = {.lex_state = 153},
  [54] = {.lex_state = 85},
  [55] = {.lex_state = 92},
  [56] = {.lex_state = 96},
  [57] = {.lex_state = 78, .external_lex_state = 2},
  [58] = {.lex_state = 78, .external_lex_state = 2},
  [59] = {.lex_state = 102},
  [60] = {.lex_state = 102},
  [61] = {.lex_state = 78, .external_lex_state = 2},
  [62] = {.lex_state = 104, .external_lex_state = 3},
  [63] = {.lex_state = 106, .external_lex_state = 2},
  [64] = {.lex_state = 96},
  [65] = {.lex_state = 96},
  [66] = {.lex_state = 108, .external_lex_state = 11},
  [67] = {.lex_state = 108, .external_lex_state = 12},
  [68] = {.lex_state = 112},
  [69] = {.lex_state = 122, .external_lex_state = 13},
  [70] = {.lex_state = 125},
  [71] = {.lex_state = 122, .external_lex_state = 13},
  [72] = {.lex_state = 112, .external_lex_state = 7},
  [73] = {.lex_state = 78, .external_lex_state = 2},
  [74] = {.lex_state = 78, .external_lex_state = 2},
  [75] = {.lex_state = 78, .external_lex_state = 2},
  [76] = {.lex_state = 132, .external_lex_state = 13},
  [77] = {.lex_state = 102},
  [78] = {.lex_state = 136, .external_lex_state = 12},
  [79] = {.lex_state = 122, .external_lex_state = 12},
  [80] = {.lex_state = 140, .external_lex_state = 11},
  [81] = {.lex_state = 85},
  [82] = {.lex_state = 122, .external_lex_state = 12},
  [83] = {.lex_state = 102, .external_lex_state = 2},
  [84] = {.lex_state = 122, .external_lex_state = 12},
  [85] = {.lex_state = 102},
  [86] = {.lex_state = 112},
  [87] = {.lex_state = 149, .external_lex_state = 14},
  [88] = {.lex_state = 125},
  [89] = {.lex_state = 149, .external_lex_state = 14},
  [90] = {.lex_state = 112, .external_lex_state = 7},
  [91] = {.lex_state = 78, .external_lex_state = 2},
  [92] = {.lex_state = 78, .external_lex_state = 2},
  [93] = {.lex_state = 78, .external_lex_state = 2},
  [94] = {.lex_state = 149, .external_lex_state = 9},
  [95] = {.lex_state = 149, .external_lex_state = 9},
  [96] = {.lex_state = 172},
  [97] = {.lex_state = 85},
  [98] = {.lex_state = 106, .external_lex_state = 2},
  [99] = {.lex_state = 178, .external_lex_state = 4},
  [100] = {.lex_state = 178, .external_lex_state = 5},
  [101] = {.lex_state = 142, .external_lex_state = 6},
  [102] = {.lex_state = 142, .external_lex_state = 6},
  [103] = {.lex_state = 180, .external_lex_state = 6},
  [104] = {.lex_state = 85},
  [105] = {.lex_state = 182, .external_lex_state = 5},
  [106] = {.lex_state = 142, .external_lex_state = 5},
  [107] = {.lex_state = 184, .external_lex_state = 4},
  [108] = {.lex_state = 85},
  [109] = {.lex_state = 78, .external_lex_state = 2},
  [110] = {.lex_state = 102, .external_lex_state = 2},
  [111] = {.lex_state = 142, .external_lex_state = 5},
  [112] = {.lex_state = 85},
  [113] = {.lex_state = 92},
  [114] = {.lex_state = 96},
  [115] = {.lex_state = 78, .external_lex_state = 2},
  [116] = {.lex_state = 78, .external_lex_state = 2},
  [117] = {.lex_state = 102},
  [118] = {.lex_state = 102},
  [119] = {.lex_state = 78, .external_lex_state = 2},
  [120] = {.lex_state = 104, .external_lex_state = 3},
  [121] = {.lex_state = 186, .external_lex_state = 5},
  [122] = {.lex_state = 106, .external_lex_state = 2},
  [123] = {.lex_state = 96},
  [124] = {.lex_state = 96},
  [125] = {.lex_state = 199, .external_lex_state = 15},
  [126] = {.lex_state = 199, .external_lex_state = 16},
  [127] = {.lex_state = 112},
  [128] = {.lex_state = 201, .external_lex_state = 17},
  [129] = {.lex_state = 125},
  [130] = {.lex_state = 201, .external_lex_state = 17},
  [131] = {.lex_state = 112, .external_lex_state = 7},
  [132] = {.lex_state = 78, .external_lex_state = 2},
  [133] = {.lex_state = 78, .external_lex_state = 2},
  [134] = {.lex_state = 78, .external_lex_state = 2},
  [135] = {.lex_state = 203, .external_lex_state = 17},
  [136] = {.lex_state = 92, .external_lex_state = 18},
  [137] = {.lex_state = 205, .external_lex_state = 16},
  [138] = {.lex_state = 201, .external_lex_state = 16},
  [139] = {.lex_state = 207, .external_lex_state = 15},
  [140] = {.lex_state = 85},
  [141] = {.lex_state = 201, .external_lex_state = 16},
  [142] = {.lex_state = 78, .external_lex_state = 2},
  [143] = {.lex_state = 102, .external_lex_state = 2},
  [144] = {.lex_state = 201, .external_lex_state = 16},
  [145] = {.lex_state = 85},
  [146] = {.lex_state = 186, .external_lex_state = 5},
  [147] = {.lex_state = 85},
  [148] = {.lex_state = 96},
  [149] = {.lex_state = 96},
  [150] = {.lex_state = 112},
  [151] = {.lex_state = 209, .external_lex_state = 19},
  [152] = {.lex_state = 125},
  [153] = {.lex_state = 209, .external_lex_state = 19},
  [154] = {.lex_state = 112, .external_lex_state = 7},
  [155] = {.lex_state = 78, .external_lex_state = 2},
  [156] = {.lex_state = 78, .external_lex_state = 2},
  [157] = {.lex_state = 78, .external_lex_state = 2},
  [158] = {.lex_state = 209, .external_lex_state = 20},
  [159] = {.lex_state = 209, .external_lex_state = 20},
  [160] = {.lex_state = 96},
  [161] = {.lex_state = 212, .external_lex_state = 10},
  [162] = {.lex_state = 212, .external_lex_state = 10},
  [163] = {.lex_state = 212},
  [164] = {.lex_state = 212},
  [165] = {.lex_state = 85},
  [166] = {.lex_state = 112},
  [167] = {.lex_state = 108, .external_lex_state = 21},
  [168] = {.lex_state = 125},
  [169] = {.lex_state = 108, .external_lex_state = 21},
  [170] = {.lex_state = 112, .external_lex_state = 7},
  [171] = {.lex_state = 78, .external_lex_state = 2},
  [172] = {.lex_state = 78, .external_lex_state = 2},
  [173] = {.lex_state = 78, .external_lex_state = 2},
  [174] = {.lex_state = 85},
  [175] = {.lex_state = 108, .external_lex_state = 4},
  [176] = {.lex_state = 108, .external_lex_state = 4},
  [177] = {.lex_state = 112},
  [178] = {.lex_state = 108, .external_lex_state = 6},
  [179] = {.lex_state = 125},
  [180] = {.lex_state = 108, .external_lex_state = 6},
  [181] = {.lex_state = 112, .external_lex_state = 7},
  [182] = {.lex_state = 78, .external_lex_state = 2},
  [183] = {.lex_state = 78, .external_lex_state = 2},
  [184] = {.lex_state = 78, .external_lex_state = 2},
  [185] = {.lex_state = 108, .external_lex_state = 5},
  [186] = {.lex_state = 108, .external_lex_state = 5},
  [187] = {.lex_state = 112},
  [188] = {.lex_state = 102, .external_lex_state = 22},
  [189] = {.lex_state = 125},
  [190] = {.lex_state = 102, .external_lex_state = 22},
  [191] = {.lex_state = 112, .external_lex_state = 7},
  [192] = {.lex_state = 78, .external_lex_state = 2},
  [193] = {.lex_state = 78, .external_lex_state = 2},
  [194] = {.lex_state = 78, .external_lex_state = 2},
  [195] = {.lex_state = 215, .external_lex_state = 2},
  [196] = {.lex_state = 102, .external_lex_state = 2},
  [197] = {.lex_state = 142, .external_lex_state = 6},
  [198] = {.lex_state = 142, .external_lex_state = 6},
  [199] = {.lex_state = 142, .external_lex_state = 6},
  [200] = {.lex_state = 102},
  [201] = {.lex_state = 122, .external_lex_state = 6},
  [202] = {.lex_state = 217},
  [203] = {.lex_state = 142, .external_lex_state = 6},
  [204] = {.lex_state = 125, .external_lex_state = 10},
  [205] = {.lex_state = 112, .external_lex_state = 7},
  [206] = {.lex_state = 78, .external_lex_state = 2},
  [207] = {.lex_state = 78, .external_lex_state = 2},
  [208] = {.lex_state = 125},
  [209] = {.lex_state = 85},
  [210] = {.lex_state = 223, .external_lex_state = 7},
  [211] = {.lex_state = 225, .external_lex_state = 18},
  [212] = {.lex_state = 225, .external_lex_state = 18},
  [213] = {.lex_state = 78},
  [214] = {.lex_state = 102},
  [215] = {.lex_state = 85},
  [216] = {.lex_state = 215, .external_lex_state = 2},
  [217] = {.lex_state = 85},
  [218] = {.lex_state = 106, .external_lex_state = 2},
  [219] = {.lex_state = 108, .external_lex_state = 4},
  [220] = {.lex_state = 108, .external_lex_state = 5},
  [221] = {.lex_state = 122, .external_lex_state = 6},
  [222] = {.lex_state = 122, .external_lex_state = 6},
  [223] = {.lex_state = 132, .external_lex_state = 6},
  [224] = {.lex_state = 78},
  [225] = {.lex_state = 229, .external_lex_state = 5},
  [226] = {.lex_state = 122, .external_lex_state = 5},
  [227] = {.lex_state = 140, .external_lex_state = 4},
  [228] = {.lex_state = 85},
  [229] = {.lex_state = 78, .external_lex_state = 2},
  [230] = {.lex_state = 102, .external_lex_state = 2},
  [231] = {.lex_state = 122, .external_lex_state = 5},
  [232] = {.lex_state = 85},
  [233] = {.lex_state = 85},
  [234] = {.lex_state = 231, .external_lex_state = 9},
  [235] = {.lex_state = 96, .external_lex_state = 23},
  [236] = {.lex_state = 78},
  [237] = {.lex_state = 233, .external_lex_state = 2},
  [238] = {.lex_state = 78, .external_lex_state = 2},
  [239] = {.lex_state = 78, .external_lex_state = 2},
  [240] = {.lex_state = 102},
  [241] = {.lex_state = 78, .external_lex_state = 24},
  [242] = {.lex_state = 102},
  [243] = {.lex_state = 235, .external_lex_state = 9},
  [244] = {.lex_state = 136, .external_lex_state = 5},
  [245] = {.lex_state = 237, .external_lex_state = 25},
  [246] = {.lex_state = 122, .external_lex_state = 6},
  [247] = {.lex_state = 122, .external_lex_state = 5},
  [248] = {.lex_state = 122, .external_lex_state = 5},
  [249] = {.lex_state = 136, .external_lex_state = 5},
  [250] = {.lex_state = 140, .external_lex_state = 4},
  [251] = {.lex_state = 78, .external_lex_state = 2},
  [252] = {.lex_state = 122, .external_lex_state = 5},
  [253] = {.lex_state = 102, .external_lex_state = 2},
  [254] = {.lex_state = 142, .external_lex_state = 5},
  [255] = {.lex_state = 122, .external_lex_state = 5},
  [256] = {.lex_state = 102, .external_lex_state = 22},
  [257] = {.lex_state = 215, .external_lex_state = 2},
  [258] = {.lex_state = 102, .external_lex_state = 2},
  [259] = {.lex_state = 239, .external_lex_state = 19},
  [260] = {.lex_state = 239, .external_lex_state = 19},
  [261] = {.lex_state = 239, .external_lex_state = 19},
  [262] = {.lex_state = 239, .external_lex_state = 19},
  [263] = {.lex_state = 184, .external_lex_state = 4},
  [264] = {.lex_state = 215},
  [265] = {.lex_state = 112},
  [266] = {.lex_state = 140, .external_lex_state = 21},
  [267] = {.lex_state = 125},
  [268] = {.lex_state = 140, .external_lex_state = 21},
  [269] = {.lex_state = 112, .external_lex_state = 7},
  [270] = {.lex_state = 78, .external_lex_state = 2},
  [271] = {.lex_state = 78, .external_lex_state = 2},
  [272] = {.lex_state = 78, .external_lex_state = 2},
  [273] = {.lex_state = 140, .external_lex_state = 4},
  [274] = {.lex_state = 146, .external_lex_state = 9},
  [275] = {.lex_state = 96},
  [276] = {.lex_state = 96},
  [277] = {.lex_state = 112},
  [278] = {.lex_state = 241, .external_lex_state = 14},
  [279] = {.lex_state = 125},
  [280] = {.lex_state = 241, .external_lex_state = 14},
  [281] = {.lex_state = 112, .external_lex_state = 7},
  [282] = {.lex_state = 78, .external_lex_state = 2},
  [283] = {.lex_state = 78, .external_lex_state = 2},
  [284] = {.lex_state = 78, .external_lex_state = 2},
  [285] = {.lex_state = 241, .external_lex_state = 9},
  [286] = {.lex_state = 241, .external_lex_state = 9},
  [287] = {.lex_state = 102},
  [288] = {.lex_state = 102},
  [289] = {.lex_state = 96},
  [290] = {.lex_state = 96},
  [291] = {.lex_state = 112},
  [292] = {.lex_state = 244, .external_lex_state = 10},
  [293] = {.lex_state = 125},
  [294] = {.lex_state = 244, .external_lex_state = 10},
  [295] = {.lex_state = 112, .external_lex_state = 7},
  [296] = {.lex_state = 78, .external_lex_state = 2},
  [297] = {.lex_state = 78, .external_lex_state = 2},
  [298] = {.lex_state = 78, .external_lex_state = 2},
  [299] = {.lex_state = 244},
  [300] = {.lex_state = 244},
  [301] = {.lex_state = 153},
  [302] = {.lex_state = 246, .external_lex_state = 10},
  [303] = {.lex_state = 246, .external_lex_state = 10},
  [304] = {.lex_state = 246, .external_lex_state = 10},
  [305] = {.lex_state = 102},
  [306] = {.lex_state = 153, .external_lex_state = 10},
  [307] = {.lex_state = 217},
  [308] = {.lex_state = 246, .external_lex_state = 10},
  [309] = {.lex_state = 125},
  [310] = {.lex_state = 85},
  [311] = {.lex_state = 223, .external_lex_state = 7},
  [312] = {.lex_state = 225, .external_lex_state = 18},
  [313] = {.lex_state = 225, .external_lex_state = 18},
  [314] = {.lex_state = 85},
  [315] = {.lex_state = 215, .external_lex_state = 2},
  [316] = {.lex_state = 78},
  [317] = {.lex_state = 85},
  [318] = {.lex_state = 186, .external_lex_state = 5},
  [319] = {.lex_state = 96},
  [320] = {.lex_state = 96, .external_lex_state = 25},
  [321] = {.lex_state = 246},
  [322] = {.lex_state = 153},
  [323] = {.lex_state = 153},
  [324] = {.lex_state = 144, .external_lex_state = 8},
  [325] = {.lex_state = 146, .external_lex_state = 9},
  [326] = {.lex_state = 149, .external_lex_state = 9},
  [327] = {.lex_state = 153},
  [328] = {.lex_state = 102},
  [329] = {.lex_state = 102},
  [330] = {.lex_state = 149, .external_lex_state = 14},
  [331] = {.lex_state = 149, .external_lex_state = 9},
  [332] = {.lex_state = 149, .external_lex_state = 9},
  [333] = {.lex_state = 172},
  [334] = {.lex_state = 85},
  [335] = {.lex_state = 136, .external_lex_state = 12},
  [336] = {.lex_state = 92, .external_lex_state = 18},
  [337] = {.lex_state = 136, .external_lex_state = 12},
  [338] = {.lex_state = 209, .external_lex_state = 20},
  [339] = {.lex_state = 212},
  [340] = {.lex_state = 85},
  [341] = {.lex_state = 112},
  [342] = {.lex_state = 108, .external_lex_state = 26},
  [343] = {.lex_state = 125},
  [344] = {.lex_state = 108, .external_lex_state = 26},
  [345] = {.lex_state = 112, .external_lex_state = 7},
  [346] = {.lex_state = 78, .external_lex_state = 2},
  [347] = {.lex_state = 78, .external_lex_state = 2},
  [348] = {.lex_state = 78, .external_lex_state = 2},
  [349] = {.lex_state = 85},
  [350] = {.lex_state = 108, .external_lex_state = 11},
  [351] = {.lex_state = 108, .external_lex_state = 11},
  [352] = {.lex_state = 112},
  [353] = {.lex_state = 108, .external_lex_state = 13},
  [354] = {.lex_state = 125},
  [355] = {.lex_state = 108, .external_lex_state = 13},
  [356] = {.lex_state = 112, .external_lex_state = 7},
  [357] = {.lex_state = 78, .external_lex_state = 2},
  [358] = {.lex_state = 78, .external_lex_state = 2},
  [359] = {.lex_state = 78, .external_lex_state = 2},
  [360] = {.lex_state = 108, .external_lex_state = 12},
  [361] = {.lex_state = 108, .external_lex_state = 12},
  [362] = {.lex_state = 122, .external_lex_state = 13},
  [363] = {.lex_state = 122, .external_lex_state = 13},
  [364] = {.lex_state = 122, .external_lex_state = 13},
  [365] = {.lex_state = 102},
  [366] = {.lex_state = 122, .external_lex_state = 13},
  [367] = {.lex_state = 217},
  [368] = {.lex_state = 122, .external_lex_state = 13},
  [369] = {.lex_state = 125},
  [370] = {.lex_state = 85},
  [371] = {.lex_state = 223, .external_lex_state = 7},
  [372] = {.lex_state = 225, .external_lex_state = 18},
  [373] = {.lex_state = 225, .external_lex_state = 18},
  [374] = {.lex_state = 85},
  [375] = {.lex_state = 215, .external_lex_state = 2},
  [376] = {.lex_state = 78},
  [377] = {.lex_state = 85},
  [378] = {.lex_state = 85},
  [379] = {.lex_state = 249, .external_lex_state = 2},
  [380] = {.lex_state = 186, .external_lex_state = 5},
  [381] = {.lex_state = 78},
  [382] = {.lex_state = 102},
  [383] = {.lex_state = 78, .external_lex_state = 2},
  [384] = {.lex_state = 78, .external_lex_state = 2},
  [385] = {.lex_state = 102},
  [386] = {.lex_state = 78, .external_lex_state = 24},
  [387] = {.lex_state = 102},
  [388] = {.lex_state = 136, .external_lex_state = 12},
  [389] = {.lex_state = 237, .external_lex_state = 25},
  [390] = {.lex_state = 122, .external_lex_state = 13},
  [391] = {.lex_state = 122, .external_lex_state = 12},
  [392] = {.lex_state = 122, .external_lex_state = 12},
  [393] = {.lex_state = 122, .external_lex_state = 12},
  [394] = {.lex_state = 122, .external_lex_state = 12},
  [395] = {.lex_state = 122, .external_lex_state = 12},
  [396] = {.lex_state = 255, .external_lex_state = 2},
  [397] = {.lex_state = 149, .external_lex_state = 14},
  [398] = {.lex_state = 149, .external_lex_state = 14},
  [399] = {.lex_state = 149, .external_lex_state = 14},
  [400] = {.lex_state = 102},
  [401] = {.lex_state = 149, .external_lex_state = 14},
  [402] = {.lex_state = 217},
  [403] = {.lex_state = 149, .external_lex_state = 14},
  [404] = {.lex_state = 125},
  [405] = {.lex_state = 146, .external_lex_state = 9},
  [406] = {.lex_state = 149},
  [407] = {.lex_state = 85},
  [408] = {.lex_state = 223, .external_lex_state = 7},
  [409] = {.lex_state = 225, .external_lex_state = 18},
  [410] = {.lex_state = 225, .external_lex_state = 18},
  [411] = {.lex_state = 85},
  [412] = {.lex_state = 215, .external_lex_state = 2},
  [413] = {.lex_state = 78},
  [414] = {.lex_state = 85},
  [415] = {.lex_state = 146, .external_lex_state = 9},
  [416] = {.lex_state = 149},
  [417] = {.lex_state = 149, .external_lex_state = 9},
  [418] = {.lex_state = 149, .external_lex_state = 9},
  [419] = {.lex_state = 85},
  [420] = {.lex_state = 186, .external_lex_state = 5},
  [421] = {.lex_state = 144, .external_lex_state = 8},
  [422] = {.lex_state = 85},
  [423] = {.lex_state = 178, .external_lex_state = 21},
  [424] = {.lex_state = 178, .external_lex_state = 21},
  [425] = {.lex_state = 85},
  [426] = {.lex_state = 178, .external_lex_state = 4},
  [427] = {.lex_state = 178, .external_lex_state = 4},
  [428] = {.lex_state = 178, .external_lex_state = 6},
  [429] = {.lex_state = 178, .external_lex_state = 6},
  [430] = {.lex_state = 178, .external_lex_state = 5},
  [431] = {.lex_state = 178, .external_lex_state = 5},
  [432] = {.lex_state = 142, .external_lex_state = 6},
  [433] = {.lex_state = 186, .external_lex_state = 5},
  [434] = {.lex_state = 78},
  [435] = {.lex_state = 78, .external_lex_state = 2},
  [436] = {.lex_state = 78, .external_lex_state = 2},
  [437] = {.lex_state = 102},
  [438] = {.lex_state = 102},
  [439] = {.lex_state = 182, .external_lex_state = 5},
  [440] = {.lex_state = 237, .external_lex_state = 25},
  [441] = {.lex_state = 142, .external_lex_state = 6},
  [442] = {.lex_state = 142, .external_lex_state = 5},
  [443] = {.lex_state = 142, .external_lex_state = 5},
  [444] = {.lex_state = 182, .external_lex_state = 5},
  [445] = {.lex_state = 184, .external_lex_state = 4},
  [446] = {.lex_state = 142, .external_lex_state = 5},
  [447] = {.lex_state = 142, .external_lex_state = 5},
  [448] = {.lex_state = 144, .external_lex_state = 8},
  [449] = {.lex_state = 146, .external_lex_state = 9},
  [450] = {.lex_state = 149, .external_lex_state = 9},
  [451] = {.lex_state = 153},
  [452] = {.lex_state = 102},
  [453] = {.lex_state = 102},
  [454] = {.lex_state = 149, .external_lex_state = 14},
  [455] = {.lex_state = 149, .external_lex_state = 9},
  [456] = {.lex_state = 149, .external_lex_state = 9},
  [457] = {.lex_state = 172},
  [458] = {.lex_state = 85},
  [459] = {.lex_state = 205, .external_lex_state = 16},
  [460] = {.lex_state = 92, .external_lex_state = 18},
  [461] = {.lex_state = 205, .external_lex_state = 16},
  [462] = {.lex_state = 209, .external_lex_state = 20},
  [463] = {.lex_state = 212},
  [464] = {.lex_state = 85},
  [465] = {.lex_state = 112},
  [466] = {.lex_state = 199, .external_lex_state = 27},
  [467] = {.lex_state = 125},
  [468] = {.lex_state = 199, .external_lex_state = 27},
  [469] = {.lex_state = 112, .external_lex_state = 7},
  [470] = {.lex_state = 78, .external_lex_state = 2},
  [471] = {.lex_state = 78, .external_lex_state = 2},
  [472] = {.lex_state = 78, .external_lex_state = 2},
  [473] = {.lex_state = 85},
  [474] = {.lex_state = 199, .external_lex_state = 15},
  [475] = {.lex_state = 199, .external_lex_state = 15},
  [476] = {.lex_state = 112},
  [477] = {.lex_state = 199, .external_lex_state = 17},
  [478] = {.lex_state = 125},
  [479] = {.lex_state = 199, .external_lex_state = 17},
  [480] = {.lex_state = 112, .external_lex_state = 7},
  [481] = {.lex_state = 78, .external_lex_state = 2},
  [482] = {.lex_state = 78, .external_lex_state = 2},
  [483] = {.lex_state = 78, .external_lex_state = 2},
  [484] = {.lex_state = 199, .external_lex_state = 16},
  [485] = {.lex_state = 199, .external_lex_state = 16},
  [486] = {.lex_state = 201, .external_lex_state = 17},
  [487] = {.lex_state = 201, .external_lex_state = 17},
  [488] = {.lex_state = 201, .external_lex_state = 17},
  [489] = {.lex_state = 102},
  [490] = {.lex_state = 201, .external_lex_state = 17},
  [491] = {.lex_state = 217},
  [492] = {.lex_state = 201, .external_lex_state = 17},
  [493] = {.lex_state = 125},
  [494] = {.lex_state = 85},
  [495] = {.lex_state = 223, .external_lex_state = 7},
  [496] = {.lex_state = 225, .external_lex_state = 18},
  [497] = {.lex_state = 225, .external_lex_state = 18},
  [498] = {.lex_state = 85},
  [499] = {.lex_state = 215, .external_lex_state = 2},
  [500] = {.lex_state = 78},
  [501] = {.lex_state = 85},
  [502] = {.lex_state = 85},
  [503] = {.lex_state = 186, .external_lex_state = 5},
  [504] = {.lex_state = 258, .external_lex_state = 28},
  [505] = {.lex_state = 96, .external_lex_state = 23},
  [506] = {.lex_state = 78},
  [507] = {.lex_state = 104, .external_lex_state = 3},
  [508] = {.lex_state = 78, .external_lex_state = 2},
  [509] = {.lex_state = 78, .external_lex_state = 2},
  [510] = {.lex_state = 102},
  [511] = {.lex_state = 78, .external_lex_state = 24},
  [512] = {.lex_state = 102},
  [513] = {.lex_state = 258, .external_lex_state = 28},
  [514] = {.lex_state = 205, .external_lex_state = 16},
  [515] = {.lex_state = 237, .external_lex_state = 25},
  [516] = {.lex_state = 201, .external_lex_state = 17},
  [517] = {.lex_state = 201, .external_lex_state = 16},
  [518] = {.lex_state = 201, .external_lex_state = 16},
  [519] = {.lex_state = 205, .external_lex_state = 16},
  [520] = {.lex_state = 207, .external_lex_state = 15},
  [521] = {.lex_state = 201, .external_lex_state = 16},
  [522] = {.lex_state = 201, .external_lex_state = 16},
  [523] = {.lex_state = 201, .external_lex_state = 16},
  [524] = {.lex_state = 144, .external_lex_state = 8},
  [525] = {.lex_state = 244},
  [526] = {.lex_state = 209, .external_lex_state = 20},
  [527] = {.lex_state = 209, .external_lex_state = 19},
  [528] = {.lex_state = 209, .external_lex_state = 19},
  [529] = {.lex_state = 209, .external_lex_state = 19},
  [530] = {.lex_state = 102},
  [531] = {.lex_state = 209, .external_lex_state = 19},
  [532] = {.lex_state = 217},
  [533] = {.lex_state = 209, .external_lex_state = 19},
  [534] = {.lex_state = 125},
  [535] = {.lex_state = 85},
  [536] = {.lex_state = 223, .external_lex_state = 7},
  [537] = {.lex_state = 225, .external_lex_state = 18},
  [538] = {.lex_state = 225, .external_lex_state = 18},
  [539] = {.lex_state = 85},
  [540] = {.lex_state = 215, .external_lex_state = 2},
  [541] = {.lex_state = 78},
  [542] = {.lex_state = 85},
  [543] = {.lex_state = 96},
  [544] = {.lex_state = 96, .external_lex_state = 25},
  [545] = {.lex_state = 209, .external_lex_state = 20},
  [546] = {.lex_state = 209, .external_lex_state = 20},
  [547] = {.lex_state = 209, .external_lex_state = 20},
  [548] = {.lex_state = 212},
  [549] = {.lex_state = 212, .external_lex_state = 10},
  [550] = {.lex_state = 96},
  [551] = {.lex_state = 96, .external_lex_state = 25},
  [552] = {.lex_state = 212},
  [553] = {.lex_state = 212},
  [554] = {.lex_state = 144, .external_lex_state = 8},
  [555] = {.lex_state = 178, .external_lex_state = 21},
  [556] = {.lex_state = 178, .external_lex_state = 21},
  [557] = {.lex_state = 178, .external_lex_state = 21},
  [558] = {.lex_state = 102},
  [559] = {.lex_state = 108, .external_lex_state = 21},
  [560] = {.lex_state = 217},
  [561] = {.lex_state = 178, .external_lex_state = 21},
  [562] = {.lex_state = 125},
  [563] = {.lex_state = 85},
  [564] = {.lex_state = 223, .external_lex_state = 7},
  [565] = {.lex_state = 225, .external_lex_state = 18},
  [566] = {.lex_state = 225, .external_lex_state = 18},
  [567] = {.lex_state = 85},
  [568] = {.lex_state = 215, .external_lex_state = 2},
  [569] = {.lex_state = 78},
  [570] = {.lex_state = 85},
  [571] = {.lex_state = 108, .external_lex_state = 4},
  [572] = {.lex_state = 178, .external_lex_state = 4},
  [573] = {.lex_state = 108, .external_lex_state = 4},
  [574] = {.lex_state = 178, .external_lex_state = 6},
  [575] = {.lex_state = 178, .external_lex_state = 6},
  [576] = {.lex_state = 178, .external_lex_state = 6},
  [577] = {.lex_state = 102},
  [578] = {.lex_state = 108, .external_lex_state = 6},
  [579] = {.lex_state = 217},
  [580] = {.lex_state = 178, .external_lex_state = 6},
  [581] = {.lex_state = 125},
  [582] = {.lex_state = 85},
  [583] = {.lex_state = 223, .external_lex_state = 7},
  [584] = {.lex_state = 225, .external_lex_state = 18},
  [585] = {.lex_state = 225, .external_lex_state = 18},
  [586] = {.lex_state = 85},
  [587] = {.lex_state = 215, .external_lex_state = 2},
  [588] = {.lex_state = 78},
  [589] = {.lex_state = 85},
  [590] = {.lex_state = 108, .external_lex_state = 5},
  [591] = {.lex_state = 178, .external_lex_state = 5},
  [592] = {.lex_state = 108, .external_lex_state = 5},
  [593] = {.lex_state = 215, .external_lex_state = 22},
  [594] = {.lex_state = 215, .external_lex_state = 22},
  [595] = {.lex_state = 215, .external_lex_state = 22},
  [596] = {.lex_state = 102},
  [597] = {.lex_state = 102, .external_lex_state = 22},
  [598] = {.lex_state = 217},
  [599] = {.lex_state = 215, .external_lex_state = 22},
  [600] = {.lex_state = 125},
  [601] = {.lex_state = 85},
  [602] = {.lex_state = 223, .external_lex_state = 7},
  [603] = {.lex_state = 225, .external_lex_state = 18},
  [604] = {.lex_state = 225, .external_lex_state = 18},
  [605] = {.lex_state = 85},
  [606] = {.lex_state = 215, .external_lex_state = 2},
  [607] = {.lex_state = 78},
  [608] = {.lex_state = 85},
  [609] = {.lex_state = 215, .external_lex_state = 2},
  [610] = {.lex_state = 102, .external_lex_state = 2},
  [611] = {.lex_state = 142, .external_lex_state = 6},
  [612] = {.lex_state = 102},
  [613] = {.lex_state = 122, .external_lex_state = 6},
  [614] = {.lex_state = 125, .external_lex_state = 10},
  [615] = {.lex_state = 142, .external_lex_state = 6},
  [616] = {.lex_state = 125, .external_lex_state = 10},
  [617] = {.lex_state = 125, .external_lex_state = 10},
  [618] = {.lex_state = 125},
  [619] = {.lex_state = 85},
  [620] = {.lex_state = 223, .external_lex_state = 7},
  [621] = {.lex_state = 225, .external_lex_state = 18},
  [622] = {.lex_state = 225, .external_lex_state = 18},
  [623] = {.lex_state = 85},
  [624] = {.lex_state = 215, .external_lex_state = 2},
  [625] = {.lex_state = 78},
  [626] = {.lex_state = 217},
  [627] = {.lex_state = 125},
  [628] = {.lex_state = 102},
  [629] = {.lex_state = 260, .external_lex_state = 18},
  [630] = {.lex_state = 85},
  [631] = {.lex_state = 225, .external_lex_state = 18},
  [632] = {.lex_state = 225, .external_lex_state = 18},
  [633] = {.lex_state = 142, .external_lex_state = 6},
  [634] = {.lex_state = 112},
  [635] = {.lex_state = 262, .external_lex_state = 29},
  [636] = {.lex_state = 125},
  [637] = {.lex_state = 262, .external_lex_state = 29},
  [638] = {.lex_state = 112, .external_lex_state = 7},
  [639] = {.lex_state = 262, .external_lex_state = 30},
  [640] = {.lex_state = 78, .external_lex_state = 2},
  [641] = {.lex_state = 78, .external_lex_state = 2},
  [642] = {.lex_state = 78, .external_lex_state = 2},
  [643] = {.lex_state = 262, .external_lex_state = 18},
  [644] = {.lex_state = 262, .external_lex_state = 18},
  [645] = {.lex_state = 142, .external_lex_state = 6},
  [646] = {.lex_state = 262, .external_lex_state = 30},
  [647] = {.lex_state = 262, .external_lex_state = 18},
  [648] = {.lex_state = 102},
  [649] = {.lex_state = 215, .external_lex_state = 22},
  [650] = {.lex_state = 215, .external_lex_state = 22},
  [651] = {.lex_state = 215, .external_lex_state = 2},
  [652] = {.lex_state = 142, .external_lex_state = 6},
  [653] = {.lex_state = 144, .external_lex_state = 8},
  [654] = {.lex_state = 85},
  [655] = {.lex_state = 108, .external_lex_state = 21},
  [656] = {.lex_state = 108, .external_lex_state = 21},
  [657] = {.lex_state = 85},
  [658] = {.lex_state = 108, .external_lex_state = 4},
  [659] = {.lex_state = 108, .external_lex_state = 4},
  [660] = {.lex_state = 108, .external_lex_state = 6},
  [661] = {.lex_state = 108, .external_lex_state = 6},
  [662] = {.lex_state = 108, .external_lex_state = 5},
  [663] = {.lex_state = 108, .external_lex_state = 5},
  [664] = {.lex_state = 122, .external_lex_state = 6},
  [665] = {.lex_state = 78},
  [666] = {.lex_state = 78, .external_lex_state = 2},
  [667] = {.lex_state = 78, .external_lex_state = 2},
  [668] = {.lex_state = 78, .external_lex_state = 2},
  [669] = {.lex_state = 102},
  [670] = {.lex_state = 102},
  [671] = {.lex_state = 146, .external_lex_state = 9},
  [672] = {.lex_state = 229, .external_lex_state = 5},
  [673] = {.lex_state = 237, .external_lex_state = 25},
  [674] = {.lex_state = 122, .external_lex_state = 6},
  [675] = {.lex_state = 122, .external_lex_state = 5},
  [676] = {.lex_state = 122, .external_lex_state = 5},
  [677] = {.lex_state = 229, .external_lex_state = 5},
  [678] = {.lex_state = 140, .external_lex_state = 4},
  [679] = {.lex_state = 122, .external_lex_state = 5},
  [680] = {.lex_state = 122, .external_lex_state = 5},
  [681] = {.lex_state = 142, .external_lex_state = 6},
  [682] = {.lex_state = 78},
  [683] = {.lex_state = 231, .external_lex_state = 9},
  [684] = {.lex_state = 112},
  [685] = {.lex_state = 112, .external_lex_state = 7},
  [686] = {.lex_state = 78, .external_lex_state = 2},
  [687] = {.lex_state = 78, .external_lex_state = 2},
  [688] = {.lex_state = 96, .external_lex_state = 23},
  [689] = {.lex_state = 102},
  [690] = {.lex_state = 136, .external_lex_state = 5},
  [691] = {.lex_state = 140, .external_lex_state = 4},
  [692] = {.lex_state = 136, .external_lex_state = 5},
  [693] = {.lex_state = 140, .external_lex_state = 4},
  [694] = {.lex_state = 264, .external_lex_state = 6},
  [695] = {.lex_state = 136, .external_lex_state = 6},
  [696] = {.lex_state = 186, .external_lex_state = 5},
  [697] = {.lex_state = 264, .external_lex_state = 5},
  [698] = {.lex_state = 186, .external_lex_state = 5},
  [699] = {.lex_state = 136, .external_lex_state = 6},
  [700] = {.lex_state = 186, .external_lex_state = 5},
  [701] = {.lex_state = 264, .external_lex_state = 5},
  [702] = {.lex_state = 233, .external_lex_state = 2},
  [703] = {.lex_state = 136, .external_lex_state = 5},
  [704] = {.lex_state = 142, .external_lex_state = 5},
  [705] = {.lex_state = 122, .external_lex_state = 6},
  [706] = {.lex_state = 122, .external_lex_state = 5},
  [707] = {.lex_state = 122, .external_lex_state = 5},
  [708] = {.lex_state = 233, .external_lex_state = 2},
  [709] = {.lex_state = 235, .external_lex_state = 9},
  [710] = {.lex_state = 106, .external_lex_state = 2},
  [711] = {.lex_state = 108, .external_lex_state = 4},
  [712] = {.lex_state = 108, .external_lex_state = 5},
  [713] = {.lex_state = 136, .external_lex_state = 5},
  [714] = {.lex_state = 122, .external_lex_state = 5},
  [715] = {.lex_state = 140, .external_lex_state = 4},
  [716] = {.lex_state = 102, .external_lex_state = 2},
  [717] = {.lex_state = 122, .external_lex_state = 5},
  [718] = {.lex_state = 239, .external_lex_state = 19},
  [719] = {.lex_state = 239, .external_lex_state = 20},
  [720] = {.lex_state = 266, .external_lex_state = 10},
  [721] = {.lex_state = 209, .external_lex_state = 20},
  [722] = {.lex_state = 209, .external_lex_state = 20},
  [723] = {.lex_state = 266, .external_lex_state = 10},
  [724] = {.lex_state = 239, .external_lex_state = 19},
  [725] = {.lex_state = 239, .external_lex_state = 19},
  [726] = {.lex_state = 184, .external_lex_state = 4},
  [727] = {.lex_state = 112},
  [728] = {.lex_state = 215, .external_lex_state = 10},
  [729] = {.lex_state = 125},
  [730] = {.lex_state = 215, .external_lex_state = 10},
  [731] = {.lex_state = 112, .external_lex_state = 7},
  [732] = {.lex_state = 78, .external_lex_state = 2},
  [733] = {.lex_state = 78, .external_lex_state = 2},
  [734] = {.lex_state = 78, .external_lex_state = 2},
  [735] = {.lex_state = 215},
  [736] = {.lex_state = 215},
  [737] = {.lex_state = 184, .external_lex_state = 21},
  [738] = {.lex_state = 184, .external_lex_state = 21},
  [739] = {.lex_state = 184, .external_lex_state = 21},
  [740] = {.lex_state = 102},
  [741] = {.lex_state = 140, .external_lex_state = 21},
  [742] = {.lex_state = 217},
  [743] = {.lex_state = 184, .external_lex_state = 21},
  [744] = {.lex_state = 125},
  [745] = {.lex_state = 85},
  [746] = {.lex_state = 223, .external_lex_state = 7},
  [747] = {.lex_state = 225, .external_lex_state = 18},
  [748] = {.lex_state = 225, .external_lex_state = 18},
  [749] = {.lex_state = 85},
  [750] = {.lex_state = 215, .external_lex_state = 2},
  [751] = {.lex_state = 78},
  [752] = {.lex_state = 85},
  [753] = {.lex_state = 184, .external_lex_state = 4},
  [754] = {.lex_state = 140, .external_lex_state = 4},
  [755] = {.lex_state = 268},
  [756] = {.lex_state = 241, .external_lex_state = 9},
  [757] = {.lex_state = 244},
  [758] = {.lex_state = 241, .external_lex_state = 9},
  [759] = {.lex_state = 241, .external_lex_state = 14},
  [760] = {.lex_state = 241, .external_lex_state = 14},
  [761] = {.lex_state = 241, .external_lex_state = 14},
  [762] = {.lex_state = 102},
  [763] = {.lex_state = 241, .external_lex_state = 14},
  [764] = {.lex_state = 217},
  [765] = {.lex_state = 241, .external_lex_state = 14},
  [766] = {.lex_state = 125},
  [767] = {.lex_state = 85},
  [768] = {.lex_state = 223, .external_lex_state = 7},
  [769] = {.lex_state = 225, .external_lex_state = 18},
  [770] = {.lex_state = 225, .external_lex_state = 18},
  [771] = {.lex_state = 85},
  [772] = {.lex_state = 215, .external_lex_state = 2},
  [773] = {.lex_state = 78},
  [774] = {.lex_state = 85},
  [775] = {.lex_state = 146, .external_lex_state = 9},
  [776] = {.lex_state = 96},
  [777] = {.lex_state = 96, .external_lex_state = 25},
  [778] = {.lex_state = 241, .external_lex_state = 9},
  [779] = {.lex_state = 241, .external_lex_state = 9},
  [780] = {.lex_state = 241, .external_lex_state = 9},
  [781] = {.lex_state = 112},
  [782] = {.lex_state = 270, .external_lex_state = 14},
  [783] = {.lex_state = 125},
  [784] = {.lex_state = 270, .external_lex_state = 14},
  [785] = {.lex_state = 112, .external_lex_state = 7},
  [786] = {.lex_state = 78, .external_lex_state = 2},
  [787] = {.lex_state = 78, .external_lex_state = 2},
  [788] = {.lex_state = 78, .external_lex_state = 2},
  [789] = {.lex_state = 270, .external_lex_state = 9},
  [790] = {.lex_state = 270, .external_lex_state = 9},
  [791] = {.lex_state = 186, .external_lex_state = 5},
  [792] = {.lex_state = 244},
  [793] = {.lex_state = 244},
  [794] = {.lex_state = 272, .external_lex_state = 10},
  [795] = {.lex_state = 272, .external_lex_state = 10},
  [796] = {.lex_state = 272, .external_lex_state = 10},
  [797] = {.lex_state = 102},
  [798] = {.lex_state = 244, .external_lex_state = 10},
  [799] = {.lex_state = 217},
  [800] = {.lex_state = 272, .external_lex_state = 10},
  [801] = {.lex_state = 125},
  [802] = {.lex_state = 85},
  [803] = {.lex_state = 223, .external_lex_state = 7},
  [804] = {.lex_state = 225, .external_lex_state = 18},
  [805] = {.lex_state = 225, .external_lex_state = 18},
  [806] = {.lex_state = 85},
  [807] = {.lex_state = 215, .external_lex_state = 2},
  [808] = {.lex_state = 78},
  [809] = {.lex_state = 85},
  [810] = {.lex_state = 246},
  [811] = {.lex_state = 96},
  [812] = {.lex_state = 96, .external_lex_state = 25},
  [813] = {.lex_state = 244},
  [814] = {.lex_state = 272},
  [815] = {.lex_state = 244},
  [816] = {.lex_state = 246, .external_lex_state = 10},
  [817] = {.lex_state = 102},
  [818] = {.lex_state = 153, .external_lex_state = 10},
  [819] = {.lex_state = 246, .external_lex_state = 10},
  [820] = {.lex_state = 217},
  [821] = {.lex_state = 260, .external_lex_state = 18},
  [822] = {.lex_state = 85},
  [823] = {.lex_state = 225, .external_lex_state = 18},
  [824] = {.lex_state = 225, .external_lex_state = 18},
  [825] = {.lex_state = 246, .external_lex_state = 10},
  [826] = {.lex_state = 262, .external_lex_state = 30},
  [827] = {.lex_state = 262, .external_lex_state = 18},
  [828] = {.lex_state = 246, .external_lex_state = 10},
  [829] = {.lex_state = 262, .external_lex_state = 30},
  [830] = {.lex_state = 262, .external_lex_state = 18},
  [831] = {.lex_state = 246, .external_lex_state = 10},
  [832] = {.lex_state = 246, .external_lex_state = 10},
  [833] = {.lex_state = 246},
  [834] = {.lex_state = 246},
  [835] = {.lex_state = 140, .external_lex_state = 11},
  [836] = {.lex_state = 215},
  [837] = {.lex_state = 112},
  [838] = {.lex_state = 140, .external_lex_state = 26},
  [839] = {.lex_state = 125},
  [840] = {.lex_state = 140, .external_lex_state = 26},
  [841] = {.lex_state = 112, .external_lex_state = 7},
  [842] = {.lex_state = 78, .external_lex_state = 2},
  [843] = {.lex_state = 78, .external_lex_state = 2},
  [844] = {.lex_state = 78, .external_lex_state = 2},
  [845] = {.lex_state = 140, .external_lex_state = 11},
  [846] = {.lex_state = 146, .external_lex_state = 9},
  [847] = {.lex_state = 241, .external_lex_state = 9},
  [848] = {.lex_state = 102},
  [849] = {.lex_state = 102},
  [850] = {.lex_state = 136, .external_lex_state = 12},
  [851] = {.lex_state = 249, .external_lex_state = 2},
  [852] = {.lex_state = 136, .external_lex_state = 12},
  [853] = {.lex_state = 255, .external_lex_state = 2},
  [854] = {.lex_state = 146, .external_lex_state = 9},
  [855] = {.lex_state = 149},
  [856] = {.lex_state = 146, .external_lex_state = 9},
  [857] = {.lex_state = 149},
  [858] = {.lex_state = 85},
  [859] = {.lex_state = 136, .external_lex_state = 12},
  [860] = {.lex_state = 136, .external_lex_state = 12},
  [861] = {.lex_state = 136, .external_lex_state = 12},
  [862] = {.lex_state = 144, .external_lex_state = 8},
  [863] = {.lex_state = 108, .external_lex_state = 26},
  [864] = {.lex_state = 108, .external_lex_state = 26},
  [865] = {.lex_state = 108, .external_lex_state = 26},
  [866] = {.lex_state = 102},
  [867] = {.lex_state = 108, .external_lex_state = 26},
  [868] = {.lex_state = 217},
  [869] = {.lex_state = 108, .external_lex_state = 26},
  [870] = {.lex_state = 125},
  [871] = {.lex_state = 85},
  [872] = {.lex_state = 223, .external_lex_state = 7},
  [873] = {.lex_state = 225, .external_lex_state = 18},
  [874] = {.lex_state = 225, .external_lex_state = 18},
  [875] = {.lex_state = 85},
  [876] = {.lex_state = 215, .external_lex_state = 2},
  [877] = {.lex_state = 78},
  [878] = {.lex_state = 85},
  [879] = {.lex_state = 108, .external_lex_state = 11},
  [880] = {.lex_state = 108, .external_lex_state = 11},
  [881] = {.lex_state = 108, .external_lex_state = 11},
  [882] = {.lex_state = 108, .external_lex_state = 13},
  [883] = {.lex_state = 108, .external_lex_state = 13},
  [884] = {.lex_state = 108, .external_lex_state = 13},
  [885] = {.lex_state = 102},
  [886] = {.lex_state = 108, .external_lex_state = 13},
  [887] = {.lex_state = 217},
  [888] = {.lex_state = 108, .external_lex_state = 13},
  [889] = {.lex_state = 125},
  [890] = {.lex_state = 85},
  [891] = {.lex_state = 223, .external_lex_state = 7},
  [892] = {.lex_state = 225, .external_lex_state = 18},
  [893] = {.lex_state = 225, .external_lex_state = 18},
  [894] = {.lex_state = 85},
  [895] = {.lex_state = 215, .external_lex_state = 2},
  [896] = {.lex_state = 78},
  [897] = {.lex_state = 85},
  [898] = {.lex_state = 108, .external_lex_state = 12},
  [899] = {.lex_state = 108, .external_lex_state = 12},
  [900] = {.lex_state = 108, .external_lex_state = 12},
  [901] = {.lex_state = 122, .external_lex_state = 13},
  [902] = {.lex_state = 102},
  [903] = {.lex_state = 122, .external_lex_state = 13},
  [904] = {.lex_state = 122, .external_lex_state = 13},
  [905] = {.lex_state = 217},
  [906] = {.lex_state = 260, .external_lex_state = 18},
  [907] = {.lex_state = 85},
  [908] = {.lex_state = 225, .external_lex_state = 18},
  [909] = {.lex_state = 225, .external_lex_state = 18},
  [910] = {.lex_state = 122, .external_lex_state = 13},
  [911] = {.lex_state = 262, .external_lex_state = 30},
  [912] = {.lex_state = 262, .external_lex_state = 18},
  [913] = {.lex_state = 122, .external_lex_state = 13},
  [914] = {.lex_state = 262, .external_lex_state = 30},
  [915] = {.lex_state = 262, .external_lex_state = 18},
  [916] = {.lex_state = 122, .external_lex_state = 13},
  [917] = {.lex_state = 122, .external_lex_state = 13},
  [918] = {.lex_state = 78},
  [919] = {.lex_state = 85},
  [920] = {.lex_state = 186, .external_lex_state = 5},
  [921] = {.lex_state = 106, .external_lex_state = 2},
  [922] = {.lex_state = 275, .external_lex_state = 4},
  [923] = {.lex_state = 275, .external_lex_state = 5},
  [924] = {.lex_state = 112},
  [925] = {.lex_state = 281, .external_lex_state = 6},
  [926] = {.lex_state = 125},
  [927] = {.lex_state = 281, .external_lex_state = 6},
  [928] = {.lex_state = 112, .external_lex_state = 7},
  [929] = {.lex_state = 78, .external_lex_state = 2},
  [930] = {.lex_state = 78, .external_lex_state = 2},
  [931] = {.lex_state = 78, .external_lex_state = 2},
  [932] = {.lex_state = 283, .external_lex_state = 6},
  [933] = {.lex_state = 172},
  [934] = {.lex_state = 285, .external_lex_state = 5},
  [935] = {.lex_state = 281, .external_lex_state = 5},
  [936] = {.lex_state = 287, .external_lex_state = 4},
  [937] = {.lex_state = 85},
  [938] = {.lex_state = 281, .external_lex_state = 5},
  [939] = {.lex_state = 78, .external_lex_state = 2},
  [940] = {.lex_state = 102, .external_lex_state = 2},
  [941] = {.lex_state = 281, .external_lex_state = 5},
  [942] = {.lex_state = 102},
  [943] = {.lex_state = 136, .external_lex_state = 12},
  [944] = {.lex_state = 140, .external_lex_state = 11},
  [945] = {.lex_state = 136, .external_lex_state = 12},
  [946] = {.lex_state = 140, .external_lex_state = 11},
  [947] = {.lex_state = 140, .external_lex_state = 13},
  [948] = {.lex_state = 136, .external_lex_state = 13},
  [949] = {.lex_state = 136, .external_lex_state = 12},
  [950] = {.lex_state = 140, .external_lex_state = 12},
  [951] = {.lex_state = 136, .external_lex_state = 12},
  [952] = {.lex_state = 136, .external_lex_state = 13},
  [953] = {.lex_state = 136, .external_lex_state = 12},
  [954] = {.lex_state = 140, .external_lex_state = 12},
  [955] = {.lex_state = 136, .external_lex_state = 12},
  [956] = {.lex_state = 122, .external_lex_state = 12},
  [957] = {.lex_state = 122, .external_lex_state = 13},
  [958] = {.lex_state = 122, .external_lex_state = 12},
  [959] = {.lex_state = 122, .external_lex_state = 12},
  [960] = {.lex_state = 122, .external_lex_state = 12},
  [961] = {.lex_state = 85},
  [962] = {.lex_state = 186, .external_lex_state = 5},
  [963] = {.lex_state = 78, .external_lex_state = 2},
  [964] = {.lex_state = 289, .external_lex_state = 2},
  [965] = {.lex_state = 106, .external_lex_state = 2},
  [966] = {.lex_state = 291, .external_lex_state = 4},
  [967] = {.lex_state = 291, .external_lex_state = 5},
  [968] = {.lex_state = 112},
  [969] = {.lex_state = 301, .external_lex_state = 6},
  [970] = {.lex_state = 125},
  [971] = {.lex_state = 301, .external_lex_state = 6},
  [972] = {.lex_state = 112, .external_lex_state = 7},
  [973] = {.lex_state = 78, .external_lex_state = 2},
  [974] = {.lex_state = 78, .external_lex_state = 2},
  [975] = {.lex_state = 78, .external_lex_state = 2},
  [976] = {.lex_state = 303, .external_lex_state = 6},
  [977] = {.lex_state = 305},
  [978] = {.lex_state = 305, .external_lex_state = 5},
  [979] = {.lex_state = 305},
  [980] = {.lex_state = 301, .external_lex_state = 5},
  [981] = {.lex_state = 308, .external_lex_state = 4},
  [982] = {.lex_state = 85},
  [983] = {.lex_state = 301, .external_lex_state = 5},
  [984] = {.lex_state = 78, .external_lex_state = 2},
  [985] = {.lex_state = 305},
  [986] = {.lex_state = 102, .external_lex_state = 2},
  [987] = {.lex_state = 301, .external_lex_state = 5},
  [988] = {.lex_state = 149, .external_lex_state = 14},
  [989] = {.lex_state = 102},
  [990] = {.lex_state = 149, .external_lex_state = 14},
  [991] = {.lex_state = 149, .external_lex_state = 14},
  [992] = {.lex_state = 217},
  [993] = {.lex_state = 310},
  [994] = {.lex_state = 146, .external_lex_state = 9},
  [995] = {.lex_state = 260, .external_lex_state = 18},
  [996] = {.lex_state = 85},
  [997] = {.lex_state = 225, .external_lex_state = 18},
  [998] = {.lex_state = 225, .external_lex_state = 18},
  [999] = {.lex_state = 149, .external_lex_state = 14},
  [1000] = {.lex_state = 262, .external_lex_state = 30},
  [1001] = {.lex_state = 262, .external_lex_state = 18},
  [1002] = {.lex_state = 149, .external_lex_state = 14},
  [1003] = {.lex_state = 262, .external_lex_state = 30},
  [1004] = {.lex_state = 262, .external_lex_state = 18},
  [1005] = {.lex_state = 149, .external_lex_state = 14},
  [1006] = {.lex_state = 149, .external_lex_state = 14},
  [1007] = {.lex_state = 310},
  [1008] = {.lex_state = 146, .external_lex_state = 9},
  [1009] = {.lex_state = 78},
  [1010] = {.lex_state = 184, .external_lex_state = 21},
  [1011] = {.lex_state = 184, .external_lex_state = 21},
  [1012] = {.lex_state = 184, .external_lex_state = 4},
  [1013] = {.lex_state = 144, .external_lex_state = 8},
  [1014] = {.lex_state = 178, .external_lex_state = 21},
  [1015] = {.lex_state = 178, .external_lex_state = 4},
  [1016] = {.lex_state = 178, .external_lex_state = 4},
  [1017] = {.lex_state = 178, .external_lex_state = 6},
  [1018] = {.lex_state = 178, .external_lex_state = 5},
  [1019] = {.lex_state = 178, .external_lex_state = 5},
  [1020] = {.lex_state = 142, .external_lex_state = 6},
  [1021] = {.lex_state = 102},
  [1022] = {.lex_state = 182, .external_lex_state = 5},
  [1023] = {.lex_state = 184, .external_lex_state = 4},
  [1024] = {.lex_state = 182, .external_lex_state = 5},
  [1025] = {.lex_state = 184, .external_lex_state = 4},
  [1026] = {.lex_state = 182, .external_lex_state = 6},
  [1027] = {.lex_state = 182, .external_lex_state = 6},
  [1028] = {.lex_state = 182, .external_lex_state = 5},
  [1029] = {.lex_state = 182, .external_lex_state = 6},
  [1030] = {.lex_state = 182, .external_lex_state = 5},
  [1031] = {.lex_state = 182, .external_lex_state = 5},
  [1032] = {.lex_state = 142, .external_lex_state = 6},
  [1033] = {.lex_state = 142, .external_lex_state = 5},
  [1034] = {.lex_state = 142, .external_lex_state = 5},
  [1035] = {.lex_state = 142, .external_lex_state = 5},
  [1036] = {.lex_state = 207, .external_lex_state = 15},
  [1037] = {.lex_state = 215},
  [1038] = {.lex_state = 112},
  [1039] = {.lex_state = 207, .external_lex_state = 27},
  [1040] = {.lex_state = 125},
  [1041] = {.lex_state = 207, .external_lex_state = 27},
  [1042] = {.lex_state = 112, .external_lex_state = 7},
  [1043] = {.lex_state = 78, .external_lex_state = 2},
  [1044] = {.lex_state = 78, .external_lex_state = 2},
  [1045] = {.lex_state = 78, .external_lex_state = 2},
  [1046] = {.lex_state = 207, .external_lex_state = 15},
  [1047] = {.lex_state = 146, .external_lex_state = 9},
  [1048] = {.lex_state = 241, .external_lex_state = 9},
  [1049] = {.lex_state = 102},
  [1050] = {.lex_state = 102},
  [1051] = {.lex_state = 205, .external_lex_state = 16},
  [1052] = {.lex_state = 249, .external_lex_state = 2},
  [1053] = {.lex_state = 205, .external_lex_state = 16},
  [1054] = {.lex_state = 255, .external_lex_state = 2},
  [1055] = {.lex_state = 146, .external_lex_state = 9},
  [1056] = {.lex_state = 149},
  [1057] = {.lex_state = 146, .external_lex_state = 9},
  [1058] = {.lex_state = 149},
  [1059] = {.lex_state = 85},
  [1060] = {.lex_state = 205, .external_lex_state = 16},
  [1061] = {.lex_state = 205, .external_lex_state = 16},
  [1062] = {.lex_state = 205, .external_lex_state = 16},
  [1063] = {.lex_state = 144, .external_lex_state = 8},
  [1064] = {.lex_state = 199, .external_lex_state = 27},
  [1065] = {.lex_state = 199, .external_lex_state = 27},
  [1066] = {.lex_state = 199, .external_lex_state = 27},
  [1067] = {.lex_state = 102},
  [1068] = {.lex_state = 199, .external_lex_state = 27},
  [1069] = {.lex_state = 217},
  [1070] = {.lex_state = 199, .external_lex_state = 27},
  [1071] = {.lex_state = 125},
  [1072] = {.lex_state = 85},
  [1073] = {.lex_state = 223, .external_lex_state = 7},
  [1074] = {.lex_state = 225, .external_lex_state = 18},
  [1075] = {.lex_state = 225, .external_lex_state = 18},
  [1076] = {.lex_state = 85},
  [1077] = {.lex_state = 215, .external_lex_state = 2},
  [1078] = {.lex_state = 78},
  [1079] = {.lex_state = 85},
  [1080] = {.lex_state = 199, .external_lex_state = 15},
  [1081] = {.lex_state = 199, .external_lex_state = 15},
  [1082] = {.lex_state = 199, .external_lex_state = 15},
  [1083] = {.lex_state = 199, .external_lex_state = 17},
  [1084] = {.lex_state = 199, .external_lex_state = 17},
  [1085] = {.lex_state = 199, .external_lex_state = 17},
  [1086] = {.lex_state = 102},
  [1087] = {.lex_state = 199, .external_lex_state = 17},
  [1088] = {.lex_state = 217},
  [1089] = {.lex_state = 199, .external_lex_state = 17},
  [1090] = {.lex_state = 125},
  [1091] = {.lex_state = 85},
  [1092] = {.lex_state = 223, .external_lex_state = 7},
  [1093] = {.lex_state = 225, .external_lex_state = 18},
  [1094] = {.lex_state = 225, .external_lex_state = 18},
  [1095] = {.lex_state = 85},
  [1096] = {.lex_state = 215, .external_lex_state = 2},
  [1097] = {.lex_state = 78},
  [1098] = {.lex_state = 85},
  [1099] = {.lex_state = 199, .external_lex_state = 16},
  [1100] = {.lex_state = 199, .external_lex_state = 16},
  [1101] = {.lex_state = 199, .external_lex_state = 16},
  [1102] = {.lex_state = 201, .external_lex_state = 17},
  [1103] = {.lex_state = 102},
  [1104] = {.lex_state = 201, .external_lex_state = 17},
  [1105] = {.lex_state = 201, .external_lex_state = 17},
  [1106] = {.lex_state = 217},
  [1107] = {.lex_state = 260, .external_lex_state = 18},
  [1108] = {.lex_state = 85},
  [1109] = {.lex_state = 225, .external_lex_state = 18},
  [1110] = {.lex_state = 225, .external_lex_state = 18},
  [1111] = {.lex_state = 201, .external_lex_state = 17},
  [1112] = {.lex_state = 262, .external_lex_state = 30},
  [1113] = {.lex_state = 262, .external_lex_state = 18},
  [1114] = {.lex_state = 201, .external_lex_state = 17},
  [1115] = {.lex_state = 262, .external_lex_state = 30},
  [1116] = {.lex_state = 262, .external_lex_state = 18},
  [1117] = {.lex_state = 201, .external_lex_state = 17},
  [1118] = {.lex_state = 201, .external_lex_state = 17},
  [1119] = {.lex_state = 78},
  [1120] = {.lex_state = 258, .external_lex_state = 28},
  [1121] = {.lex_state = 96, .external_lex_state = 23},
  [1122] = {.lex_state = 102},
  [1123] = {.lex_state = 205, .external_lex_state = 16},
  [1124] = {.lex_state = 207, .external_lex_state = 15},
  [1125] = {.lex_state = 205, .external_lex_state = 16},
  [1126] = {.lex_state = 207, .external_lex_state = 15},
  [1127] = {.lex_state = 205, .external_lex_state = 17},
  [1128] = {.lex_state = 205, .external_lex_state = 17},
  [1129] = {.lex_state = 205, .external_lex_state = 16},
  [1130] = {.lex_state = 205, .external_lex_state = 16},
  [1131] = {.lex_state = 205, .external_lex_state = 16},
  [1132] = {.lex_state = 205, .external_lex_state = 17},
  [1133] = {.lex_state = 205, .external_lex_state = 16},
  [1134] = {.lex_state = 205, .external_lex_state = 16},
  [1135] = {.lex_state = 104, .external_lex_state = 3},
  [1136] = {.lex_state = 205, .external_lex_state = 16},
  [1137] = {.lex_state = 201, .external_lex_state = 16},
  [1138] = {.lex_state = 201, .external_lex_state = 17},
  [1139] = {.lex_state = 201, .external_lex_state = 16},
  [1140] = {.lex_state = 201, .external_lex_state = 16},
  [1141] = {.lex_state = 104, .external_lex_state = 3},
  [1142] = {.lex_state = 258, .external_lex_state = 28},
  [1143] = {.lex_state = 201, .external_lex_state = 16},
  [1144] = {.lex_state = 102, .external_lex_state = 2},
  [1145] = {.lex_state = 215},
  [1146] = {.lex_state = 102, .external_lex_state = 22},
  [1147] = {.lex_state = 102, .external_lex_state = 2},
  [1148] = {.lex_state = 209, .external_lex_state = 20},
  [1149] = {.lex_state = 209, .external_lex_state = 19},
  [1150] = {.lex_state = 102},
  [1151] = {.lex_state = 209, .external_lex_state = 19},
  [1152] = {.lex_state = 209, .external_lex_state = 19},
  [1153] = {.lex_state = 217},
  [1154] = {.lex_state = 260, .external_lex_state = 18},
  [1155] = {.lex_state = 85},
  [1156] = {.lex_state = 225, .external_lex_state = 18},
  [1157] = {.lex_state = 225, .external_lex_state = 18},
  [1158] = {.lex_state = 209, .external_lex_state = 19},
  [1159] = {.lex_state = 262, .external_lex_state = 30},
  [1160] = {.lex_state = 262, .external_lex_state = 18},
  [1161] = {.lex_state = 209, .external_lex_state = 19},
  [1162] = {.lex_state = 262, .external_lex_state = 30},
  [1163] = {.lex_state = 262, .external_lex_state = 18},
  [1164] = {.lex_state = 209, .external_lex_state = 19},
  [1165] = {.lex_state = 209, .external_lex_state = 19},
  [1166] = {.lex_state = 209, .external_lex_state = 20},
  [1167] = {.lex_state = 209, .external_lex_state = 20},
  [1168] = {.lex_state = 212, .external_lex_state = 10},
  [1169] = {.lex_state = 178, .external_lex_state = 4},
  [1170] = {.lex_state = 215},
  [1171] = {.lex_state = 108, .external_lex_state = 21},
  [1172] = {.lex_state = 108, .external_lex_state = 4},
  [1173] = {.lex_state = 178, .external_lex_state = 21},
  [1174] = {.lex_state = 102},
  [1175] = {.lex_state = 108, .external_lex_state = 21},
  [1176] = {.lex_state = 178, .external_lex_state = 21},
  [1177] = {.lex_state = 217},
  [1178] = {.lex_state = 260, .external_lex_state = 18},
  [1179] = {.lex_state = 85},
  [1180] = {.lex_state = 225, .external_lex_state = 18},
  [1181] = {.lex_state = 225, .external_lex_state = 18},
  [1182] = {.lex_state = 178, .external_lex_state = 21},
  [1183] = {.lex_state = 262, .external_lex_state = 30},
  [1184] = {.lex_state = 262, .external_lex_state = 18},
  [1185] = {.lex_state = 178, .external_lex_state = 21},
  [1186] = {.lex_state = 262, .external_lex_state = 30},
  [1187] = {.lex_state = 262, .external_lex_state = 18},
  [1188] = {.lex_state = 178, .external_lex_state = 21},
  [1189] = {.lex_state = 178, .external_lex_state = 21},
  [1190] = {.lex_state = 178, .external_lex_state = 6},
  [1191] = {.lex_state = 102},
  [1192] = {.lex_state = 108, .external_lex_state = 6},
  [1193] = {.lex_state = 178, .external_lex_state = 6},
  [1194] = {.lex_state = 217},
  [1195] = {.lex_state = 260, .external_lex_state = 18},
  [1196] = {.lex_state = 85},
  [1197] = {.lex_state = 225, .external_lex_state = 18},
  [1198] = {.lex_state = 225, .external_lex_state = 18},
  [1199] = {.lex_state = 178, .external_lex_state = 6},
  [1200] = {.lex_state = 262, .external_lex_state = 30},
  [1201] = {.lex_state = 262, .external_lex_state = 18},
  [1202] = {.lex_state = 178, .external_lex_state = 6},
  [1203] = {.lex_state = 262, .external_lex_state = 30},
  [1204] = {.lex_state = 262, .external_lex_state = 18},
  [1205] = {.lex_state = 178, .external_lex_state = 6},
  [1206] = {.lex_state = 178, .external_lex_state = 6},
  [1207] = {.lex_state = 215, .external_lex_state = 22},
  [1208] = {.lex_state = 102},
  [1209] = {.lex_state = 102, .external_lex_state = 22},
  [1210] = {.lex_state = 215, .external_lex_state = 22},
  [1211] = {.lex_state = 217},
  [1212] = {.lex_state = 260, .external_lex_state = 18},
  [1213] = {.lex_state = 85},
  [1214] = {.lex_state = 225, .external_lex_state = 18},
  [1215] = {.lex_state = 225, .external_lex_state = 18},
  [1216] = {.lex_state = 215, .external_lex_state = 22},
  [1217] = {.lex_state = 262, .external_lex_state = 30},
  [1218] = {.lex_state = 262, .external_lex_state = 18},
  [1219] = {.lex_state = 215, .external_lex_state = 22},
  [1220] = {.lex_state = 262, .external_lex_state = 30},
  [1221] = {.lex_state = 262, .external_lex_state = 18},
  [1222] = {.lex_state = 215, .external_lex_state = 22},
  [1223] = {.lex_state = 215, .external_lex_state = 22},
  [1224] = {.lex_state = 313, .external_lex_state = 5},
  [1225] = {.lex_state = 125},
  [1226] = {.lex_state = 260, .external_lex_state = 18},
  [1227] = {.lex_state = 85},
  [1228] = {.lex_state = 225, .external_lex_state = 18},
  [1229] = {.lex_state = 225, .external_lex_state = 18},
  [1230] = {.lex_state = 125, .external_lex_state = 10},
  [1231] = {.lex_state = 262, .external_lex_state = 30},
  [1232] = {.lex_state = 262, .external_lex_state = 18},
  [1233] = {.lex_state = 125, .external_lex_state = 10},
  [1234] = {.lex_state = 262, .external_lex_state = 30},
  [1235] = {.lex_state = 262, .external_lex_state = 18},
  [1236] = {.lex_state = 125, .external_lex_state = 10},
  [1237] = {.lex_state = 142, .external_lex_state = 6},
  [1238] = {.lex_state = 217},
  [1239] = {.lex_state = 239, .external_lex_state = 19},
  [1240] = {.lex_state = 239, .external_lex_state = 19},
  [1241] = {.lex_state = 239, .external_lex_state = 19},
  [1242] = {.lex_state = 142, .external_lex_state = 6},
  [1243] = {.lex_state = 112},
  [1244] = {.lex_state = 92, .external_lex_state = 29},
  [1245] = {.lex_state = 125},
  [1246] = {.lex_state = 92, .external_lex_state = 29},
  [1247] = {.lex_state = 112, .external_lex_state = 7},
  [1248] = {.lex_state = 78, .external_lex_state = 2},
  [1249] = {.lex_state = 78, .external_lex_state = 2},
  [1250] = {.lex_state = 78, .external_lex_state = 2},
  [1251] = {.lex_state = 92, .external_lex_state = 18},
  [1252] = {.lex_state = 92, .external_lex_state = 18},
  [1253] = {.lex_state = 260, .external_lex_state = 18},
  [1254] = {.lex_state = 142, .external_lex_state = 6},
  [1255] = {.lex_state = 262, .external_lex_state = 30},
  [1256] = {.lex_state = 262, .external_lex_state = 18},
  [1257] = {.lex_state = 262, .external_lex_state = 30},
  [1258] = {.lex_state = 262, .external_lex_state = 18},
  [1259] = {.lex_state = 262, .external_lex_state = 29},
  [1260] = {.lex_state = 262, .external_lex_state = 29},
  [1261] = {.lex_state = 262, .external_lex_state = 29},
  [1262] = {.lex_state = 102},
  [1263] = {.lex_state = 262, .external_lex_state = 29},
  [1264] = {.lex_state = 217},
  [1265] = {.lex_state = 262, .external_lex_state = 29},
  [1266] = {.lex_state = 125},
  [1267] = {.lex_state = 85},
  [1268] = {.lex_state = 223, .external_lex_state = 7},
  [1269] = {.lex_state = 225, .external_lex_state = 18},
  [1270] = {.lex_state = 225, .external_lex_state = 18},
  [1271] = {.lex_state = 262, .external_lex_state = 18},
  [1272] = {.lex_state = 142, .external_lex_state = 6},
  [1273] = {.lex_state = 262, .external_lex_state = 18},
  [1274] = {.lex_state = 85},
  [1275] = {.lex_state = 215, .external_lex_state = 2},
  [1276] = {.lex_state = 78},
  [1277] = {.lex_state = 85},
  [1278] = {.lex_state = 262, .external_lex_state = 18},
  [1279] = {.lex_state = 262, .external_lex_state = 18},
  [1280] = {.lex_state = 262, .external_lex_state = 18},
  [1281] = {.lex_state = 262, .external_lex_state = 18},
  [1282] = {.lex_state = 215, .external_lex_state = 22},
  [1283] = {.lex_state = 215, .external_lex_state = 2},
  [1284] = {.lex_state = 215, .external_lex_state = 22},
  [1285] = {.lex_state = 215, .external_lex_state = 2},
  [1286] = {.lex_state = 140, .external_lex_state = 21},
  [1287] = {.lex_state = 140, .external_lex_state = 21},
  [1288] = {.lex_state = 140, .external_lex_state = 4},
  [1289] = {.lex_state = 144, .external_lex_state = 8},
  [1290] = {.lex_state = 108, .external_lex_state = 21},
  [1291] = {.lex_state = 108, .external_lex_state = 4},
  [1292] = {.lex_state = 108, .external_lex_state = 4},
  [1293] = {.lex_state = 108, .external_lex_state = 6},
  [1294] = {.lex_state = 108, .external_lex_state = 5},
  [1295] = {.lex_state = 108, .external_lex_state = 5},
  [1296] = {.lex_state = 122, .external_lex_state = 6},
  [1297] = {.lex_state = 102},
  [1298] = {.lex_state = 229, .external_lex_state = 5},
  [1299] = {.lex_state = 140, .external_lex_state = 4},
  [1300] = {.lex_state = 229, .external_lex_state = 5},
  [1301] = {.lex_state = 140, .external_lex_state = 4},
  [1302] = {.lex_state = 229, .external_lex_state = 6},
  [1303] = {.lex_state = 229, .external_lex_state = 6},
  [1304] = {.lex_state = 229, .external_lex_state = 5},
  [1305] = {.lex_state = 229, .external_lex_state = 6},
  [1306] = {.lex_state = 229, .external_lex_state = 5},
  [1307] = {.lex_state = 78, .external_lex_state = 2},
  [1308] = {.lex_state = 229, .external_lex_state = 5},
  [1309] = {.lex_state = 122, .external_lex_state = 6},
  [1310] = {.lex_state = 122, .external_lex_state = 5},
  [1311] = {.lex_state = 122, .external_lex_state = 5},
  [1312] = {.lex_state = 78, .external_lex_state = 2},
  [1313] = {.lex_state = 146, .external_lex_state = 9},
  [1314] = {.lex_state = 122, .external_lex_state = 5},
  [1315] = {.lex_state = 186, .external_lex_state = 5},
  [1316] = {.lex_state = 96, .external_lex_state = 23},
  [1317] = {.lex_state = 96, .external_lex_state = 23},
  [1318] = {.lex_state = 85},
  [1319] = {.lex_state = 223, .external_lex_state = 7},
  [1320] = {.lex_state = 225, .external_lex_state = 18},
  [1321] = {.lex_state = 225, .external_lex_state = 18},
  [1322] = {.lex_state = 85},
  [1323] = {.lex_state = 215, .external_lex_state = 2},
  [1324] = {.lex_state = 78},
  [1325] = {.lex_state = 231, .external_lex_state = 9},
  [1326] = {.lex_state = 96, .external_lex_state = 23},
  [1327] = {.lex_state = 136, .external_lex_state = 6},
  [1328] = {.lex_state = 186, .external_lex_state = 5},
  [1329] = {.lex_state = 264, .external_lex_state = 5},
  [1330] = {.lex_state = 136, .external_lex_state = 6},
  [1331] = {.lex_state = 264, .external_lex_state = 5},
  [1332] = {.lex_state = 233, .external_lex_state = 2},
  [1333] = {.lex_state = 108, .external_lex_state = 4},
  [1334] = {.lex_state = 108, .external_lex_state = 5},
  [1335] = {.lex_state = 78},
  [1336] = {.lex_state = 78, .external_lex_state = 2},
  [1337] = {.lex_state = 78, .external_lex_state = 2},
  [1338] = {.lex_state = 78, .external_lex_state = 2},
  [1339] = {.lex_state = 102},
  [1340] = {.lex_state = 102},
  [1341] = {.lex_state = 146, .external_lex_state = 9},
  [1342] = {.lex_state = 136, .external_lex_state = 5},
  [1343] = {.lex_state = 122, .external_lex_state = 5},
  [1344] = {.lex_state = 122, .external_lex_state = 5},
  [1345] = {.lex_state = 102},
  [1346] = {.lex_state = 239, .external_lex_state = 19},
  [1347] = {.lex_state = 266, .external_lex_state = 10},
  [1348] = {.lex_state = 85},
  [1349] = {.lex_state = 266, .external_lex_state = 10},
  [1350] = {.lex_state = 85},
  [1351] = {.lex_state = 215, .external_lex_state = 10},
  [1352] = {.lex_state = 215, .external_lex_state = 10},
  [1353] = {.lex_state = 215, .external_lex_state = 10},
  [1354] = {.lex_state = 102},
  [1355] = {.lex_state = 215, .external_lex_state = 10},
  [1356] = {.lex_state = 217},
  [1357] = {.lex_state = 215, .external_lex_state = 10},
  [1358] = {.lex_state = 125},
  [1359] = {.lex_state = 85},
  [1360] = {.lex_state = 223, .external_lex_state = 7},
  [1361] = {.lex_state = 225, .external_lex_state = 18},
  [1362] = {.lex_state = 225, .external_lex_state = 18},
  [1363] = {.lex_state = 85},
  [1364] = {.lex_state = 215, .external_lex_state = 2},
  [1365] = {.lex_state = 78},
  [1366] = {.lex_state = 85},
  [1367] = {.lex_state = 184, .external_lex_state = 4},
  [1368] = {.lex_state = 215},
  [1369] = {.lex_state = 215},
  [1370] = {.lex_state = 215},
  [1371] = {.lex_state = 184, .external_lex_state = 21},
  [1372] = {.lex_state = 102},
  [1373] = {.lex_state = 140, .external_lex_state = 21},
  [1374] = {.lex_state = 184, .external_lex_state = 21},
  [1375] = {.lex_state = 217},
  [1376] = {.lex_state = 260, .external_lex_state = 18},
  [1377] = {.lex_state = 85},
  [1378] = {.lex_state = 225, .external_lex_state = 18},
  [1379] = {.lex_state = 225, .external_lex_state = 18},
  [1380] = {.lex_state = 184, .external_lex_state = 21},
  [1381] = {.lex_state = 262, .external_lex_state = 30},
  [1382] = {.lex_state = 262, .external_lex_state = 18},
  [1383] = {.lex_state = 184, .external_lex_state = 21},
  [1384] = {.lex_state = 262, .external_lex_state = 30},
  [1385] = {.lex_state = 262, .external_lex_state = 18},
  [1386] = {.lex_state = 184, .external_lex_state = 21},
  [1387] = {.lex_state = 184, .external_lex_state = 21},
  [1388] = {.lex_state = 317},
  [1389] = {.lex_state = 153},
  [1390] = {.lex_state = 268},
  [1391] = {.lex_state = 241, .external_lex_state = 9},
  [1392] = {.lex_state = 241, .external_lex_state = 14},
  [1393] = {.lex_state = 102},
  [1394] = {.lex_state = 241, .external_lex_state = 14},
  [1395] = {.lex_state = 241, .external_lex_state = 14},
  [1396] = {.lex_state = 217},
  [1397] = {.lex_state = 260, .external_lex_state = 18},
  [1398] = {.lex_state = 85},
  [1399] = {.lex_state = 225, .external_lex_state = 18},
  [1400] = {.lex_state = 225, .external_lex_state = 18},
  [1401] = {.lex_state = 241, .external_lex_state = 14},
  [1402] = {.lex_state = 262, .external_lex_state = 30},
  [1403] = {.lex_state = 262, .external_lex_state = 18},
  [1404] = {.lex_state = 241, .external_lex_state = 14},
  [1405] = {.lex_state = 262, .external_lex_state = 30},
  [1406] = {.lex_state = 262, .external_lex_state = 18},
  [1407] = {.lex_state = 241, .external_lex_state = 14},
  [1408] = {.lex_state = 241, .external_lex_state = 14},
  [1409] = {.lex_state = 241, .external_lex_state = 9},
  [1410] = {.lex_state = 241, .external_lex_state = 9},
  [1411] = {.lex_state = 241, .external_lex_state = 9},
  [1412] = {.lex_state = 270, .external_lex_state = 14},
  [1413] = {.lex_state = 270, .external_lex_state = 14},
  [1414] = {.lex_state = 270, .external_lex_state = 14},
  [1415] = {.lex_state = 102},
  [1416] = {.lex_state = 270, .external_lex_state = 14},
  [1417] = {.lex_state = 217},
  [1418] = {.lex_state = 270, .external_lex_state = 14},
  [1419] = {.lex_state = 125},
  [1420] = {.lex_state = 85},
  [1421] = {.lex_state = 223, .external_lex_state = 7},
  [1422] = {.lex_state = 225, .external_lex_state = 18},
  [1423] = {.lex_state = 225, .external_lex_state = 18},
  [1424] = {.lex_state = 85},
  [1425] = {.lex_state = 215, .external_lex_state = 2},
  [1426] = {.lex_state = 78},
  [1427] = {.lex_state = 85},
  [1428] = {.lex_state = 102},
  [1429] = {.lex_state = 270, .external_lex_state = 9},
  [1430] = {.lex_state = 270, .external_lex_state = 9},
  [1431] = {.lex_state = 270, .external_lex_state = 9},
  [1432] = {.lex_state = 244},
  [1433] = {.lex_state = 272, .external_lex_state = 10},
  [1434] = {.lex_state = 102},
  [1435] = {.lex_state = 244, .external_lex_state = 10},
  [1436] = {.lex_state = 272, .external_lex_state = 10},
  [1437] = {.lex_state = 217},
  [1438] = {.lex_state = 260, .external_lex_state = 18},
  [1439] = {.lex_state = 85},
  [1440] = {.lex_state = 225, .external_lex_state = 18},
  [1441] = {.lex_state = 225, .external_lex_state = 18},
  [1442] = {.lex_state = 272, .external_lex_state = 10},
  [1443] = {.lex_state = 262, .external_lex_state = 30},
  [1444] = {.lex_state = 262, .external_lex_state = 18},
  [1445] = {.lex_state = 272, .external_lex_state = 10},
  [1446] = {.lex_state = 262, .external_lex_state = 30},
  [1447] = {.lex_state = 262, .external_lex_state = 18},
  [1448] = {.lex_state = 272, .external_lex_state = 10},
  [1449] = {.lex_state = 272, .external_lex_state = 10},
  [1450] = {.lex_state = 244},
  [1451] = {.lex_state = 244},
  [1452] = {.lex_state = 320},
  [1453] = {.lex_state = 246, .external_lex_state = 10},
  [1454] = {.lex_state = 246, .external_lex_state = 10},
  [1455] = {.lex_state = 92, .external_lex_state = 29},
  [1456] = {.lex_state = 92, .external_lex_state = 18},
  [1457] = {.lex_state = 92, .external_lex_state = 18},
  [1458] = {.lex_state = 260, .external_lex_state = 18},
  [1459] = {.lex_state = 246, .external_lex_state = 10},
  [1460] = {.lex_state = 262, .external_lex_state = 30},
  [1461] = {.lex_state = 262, .external_lex_state = 18},
  [1462] = {.lex_state = 262, .external_lex_state = 30},
  [1463] = {.lex_state = 262, .external_lex_state = 18},
  [1464] = {.lex_state = 262, .external_lex_state = 18},
  [1465] = {.lex_state = 246, .external_lex_state = 10},
  [1466] = {.lex_state = 262, .external_lex_state = 18},
  [1467] = {.lex_state = 262, .external_lex_state = 18},
  [1468] = {.lex_state = 140, .external_lex_state = 11},
  [1469] = {.lex_state = 215},
  [1470] = {.lex_state = 140, .external_lex_state = 26},
  [1471] = {.lex_state = 140, .external_lex_state = 26},
  [1472] = {.lex_state = 140, .external_lex_state = 26},
  [1473] = {.lex_state = 102},
  [1474] = {.lex_state = 140, .external_lex_state = 26},
  [1475] = {.lex_state = 217},
  [1476] = {.lex_state = 140, .external_lex_state = 26},
  [1477] = {.lex_state = 125},
  [1478] = {.lex_state = 85},
  [1479] = {.lex_state = 223, .external_lex_state = 7},
  [1480] = {.lex_state = 225, .external_lex_state = 18},
  [1481] = {.lex_state = 225, .external_lex_state = 18},
  [1482] = {.lex_state = 85},
  [1483] = {.lex_state = 215, .external_lex_state = 2},
  [1484] = {.lex_state = 78},
  [1485] = {.lex_state = 85},
  [1486] = {.lex_state = 140, .external_lex_state = 11},
  [1487] = {.lex_state = 140, .external_lex_state = 11},
  [1488] = {.lex_state = 268},
  [1489] = {.lex_state = 241, .external_lex_state = 9},
  [1490] = {.lex_state = 146, .external_lex_state = 9},
  [1491] = {.lex_state = 270, .external_lex_state = 9},
  [1492] = {.lex_state = 136, .external_lex_state = 12},
  [1493] = {.lex_state = 136, .external_lex_state = 12},
  [1494] = {.lex_state = 172},
  [1495] = {.lex_state = 136, .external_lex_state = 12},
  [1496] = {.lex_state = 305},
  [1497] = {.lex_state = 305},
  [1498] = {.lex_state = 305},
  [1499] = {.lex_state = 310},
  [1500] = {.lex_state = 146, .external_lex_state = 9},
  [1501] = {.lex_state = 310},
  [1502] = {.lex_state = 146, .external_lex_state = 9},
  [1503] = {.lex_state = 78},
  [1504] = {.lex_state = 108, .external_lex_state = 11},
  [1505] = {.lex_state = 215},
  [1506] = {.lex_state = 108, .external_lex_state = 26},
  [1507] = {.lex_state = 108, .external_lex_state = 11},
  [1508] = {.lex_state = 108, .external_lex_state = 26},
  [1509] = {.lex_state = 102},
  [1510] = {.lex_state = 108, .external_lex_state = 26},
  [1511] = {.lex_state = 108, .external_lex_state = 26},
  [1512] = {.lex_state = 217},
  [1513] = {.lex_state = 260, .external_lex_state = 18},
  [1514] = {.lex_state = 85},
  [1515] = {.lex_state = 225, .external_lex_state = 18},
  [1516] = {.lex_state = 225, .external_lex_state = 18},
  [1517] = {.lex_state = 108, .external_lex_state = 26},
  [1518] = {.lex_state = 262, .external_lex_state = 30},
  [1519] = {.lex_state = 262, .external_lex_state = 18},
  [1520] = {.lex_state = 108, .external_lex_state = 26},
  [1521] = {.lex_state = 262, .external_lex_state = 30},
  [1522] = {.lex_state = 262, .external_lex_state = 18},
  [1523] = {.lex_state = 108, .external_lex_state = 26},
  [1524] = {.lex_state = 108, .external_lex_state = 26},
  [1525] = {.lex_state = 108, .external_lex_state = 13},
  [1526] = {.lex_state = 102},
  [1527] = {.lex_state = 108, .external_lex_state = 13},
  [1528] = {.lex_state = 108, .external_lex_state = 13},
  [1529] = {.lex_state = 217},
  [1530] = {.lex_state = 260, .external_lex_state = 18},
  [1531] = {.lex_state = 85},
  [1532] = {.lex_state = 225, .external_lex_state = 18},
  [1533] = {.lex_state = 225, .external_lex_state = 18},
  [1534] = {.lex_state = 108, .external_lex_state = 13},
  [1535] = {.lex_state = 262, .external_lex_state = 30},
  [1536] = {.lex_state = 262, .external_lex_state = 18},
  [1537] = {.lex_state = 108, .external_lex_state = 13},
  [1538] = {.lex_state = 262, .external_lex_state = 30},
  [1539] = {.lex_state = 262, .external_lex_state = 18},
  [1540] = {.lex_state = 108, .external_lex_state = 13},
  [1541] = {.lex_state = 108, .external_lex_state = 13},
  [1542] = {.lex_state = 313, .external_lex_state = 12},
  [1543] = {.lex_state = 122, .external_lex_state = 13},
  [1544] = {.lex_state = 122, .external_lex_state = 13},
  [1545] = {.lex_state = 92, .external_lex_state = 29},
  [1546] = {.lex_state = 92, .external_lex_state = 18},
  [1547] = {.lex_state = 92, .external_lex_state = 18},
  [1548] = {.lex_state = 260, .external_lex_state = 18},
  [1549] = {.lex_state = 122, .external_lex_state = 13},
  [1550] = {.lex_state = 262, .external_lex_state = 30},
  [1551] = {.lex_state = 262, .external_lex_state = 18},
  [1552] = {.lex_state = 262, .external_lex_state = 30},
  [1553] = {.lex_state = 262, .external_lex_state = 18},
  [1554] = {.lex_state = 262, .external_lex_state = 18},
  [1555] = {.lex_state = 122, .external_lex_state = 13},
  [1556] = {.lex_state = 262, .external_lex_state = 18},
  [1557] = {.lex_state = 262, .external_lex_state = 18},
  [1558] = {.lex_state = 136, .external_lex_state = 12},
  [1559] = {.lex_state = 144, .external_lex_state = 8},
  [1560] = {.lex_state = 85},
  [1561] = {.lex_state = 112},
  [1562] = {.lex_state = 275, .external_lex_state = 21},
  [1563] = {.lex_state = 125},
  [1564] = {.lex_state = 275, .external_lex_state = 21},
  [1565] = {.lex_state = 112, .external_lex_state = 7},
  [1566] = {.lex_state = 78, .external_lex_state = 2},
  [1567] = {.lex_state = 78, .external_lex_state = 2},
  [1568] = {.lex_state = 78, .external_lex_state = 2},
  [1569] = {.lex_state = 85},
  [1570] = {.lex_state = 275, .external_lex_state = 4},
  [1571] = {.lex_state = 275, .external_lex_state = 4},
  [1572] = {.lex_state = 112},
  [1573] = {.lex_state = 275, .external_lex_state = 6},
  [1574] = {.lex_state = 125},
  [1575] = {.lex_state = 275, .external_lex_state = 6},
  [1576] = {.lex_state = 112, .external_lex_state = 7},
  [1577] = {.lex_state = 78, .external_lex_state = 2},
  [1578] = {.lex_state = 78, .external_lex_state = 2},
  [1579] = {.lex_state = 78, .external_lex_state = 2},
  [1580] = {.lex_state = 275, .external_lex_state = 5},
  [1581] = {.lex_state = 275, .external_lex_state = 5},
  [1582] = {.lex_state = 281, .external_lex_state = 6},
  [1583] = {.lex_state = 281, .external_lex_state = 6},
  [1584] = {.lex_state = 281, .external_lex_state = 6},
  [1585] = {.lex_state = 102},
  [1586] = {.lex_state = 281, .external_lex_state = 6},
  [1587] = {.lex_state = 217},
  [1588] = {.lex_state = 281, .external_lex_state = 6},
  [1589] = {.lex_state = 125},
  [1590] = {.lex_state = 85},
  [1591] = {.lex_state = 223, .external_lex_state = 7},
  [1592] = {.lex_state = 225, .external_lex_state = 18},
  [1593] = {.lex_state = 225, .external_lex_state = 18},
  [1594] = {.lex_state = 85},
  [1595] = {.lex_state = 215, .external_lex_state = 2},
  [1596] = {.lex_state = 78},
  [1597] = {.lex_state = 85},
  [1598] = {.lex_state = 186, .external_lex_state = 5},
  [1599] = {.lex_state = 78},
  [1600] = {.lex_state = 249, .external_lex_state = 2},
  [1601] = {.lex_state = 78, .external_lex_state = 2},
  [1602] = {.lex_state = 78, .external_lex_state = 2},
  [1603] = {.lex_state = 102},
  [1604] = {.lex_state = 102},
  [1605] = {.lex_state = 322, .external_lex_state = 9},
  [1606] = {.lex_state = 285, .external_lex_state = 5},
  [1607] = {.lex_state = 237, .external_lex_state = 25},
  [1608] = {.lex_state = 281, .external_lex_state = 6},
  [1609] = {.lex_state = 281, .external_lex_state = 5},
  [1610] = {.lex_state = 281, .external_lex_state = 5},
  [1611] = {.lex_state = 285, .external_lex_state = 5},
  [1612] = {.lex_state = 287, .external_lex_state = 4},
  [1613] = {.lex_state = 281, .external_lex_state = 5},
  [1614] = {.lex_state = 281, .external_lex_state = 5},
  [1615] = {.lex_state = 281, .external_lex_state = 5},
  [1616] = {.lex_state = 136, .external_lex_state = 13},
  [1617] = {.lex_state = 136, .external_lex_state = 12},
  [1618] = {.lex_state = 140, .external_lex_state = 12},
  [1619] = {.lex_state = 136, .external_lex_state = 13},
  [1620] = {.lex_state = 140, .external_lex_state = 12},
  [1621] = {.lex_state = 144, .external_lex_state = 8},
  [1622] = {.lex_state = 102},
  [1623] = {.lex_state = 85},
  [1624] = {.lex_state = 106, .external_lex_state = 2},
  [1625] = {.lex_state = 324, .external_lex_state = 4},
  [1626] = {.lex_state = 324, .external_lex_state = 5},
  [1627] = {.lex_state = 112},
  [1628] = {.lex_state = 326, .external_lex_state = 6},
  [1629] = {.lex_state = 125},
  [1630] = {.lex_state = 326, .external_lex_state = 6},
  [1631] = {.lex_state = 112, .external_lex_state = 7},
  [1632] = {.lex_state = 78, .external_lex_state = 2},
  [1633] = {.lex_state = 78, .external_lex_state = 2},
  [1634] = {.lex_state = 78, .external_lex_state = 2},
  [1635] = {.lex_state = 328, .external_lex_state = 6},
  [1636] = {.lex_state = 305},
  [1637] = {.lex_state = 330, .external_lex_state = 5},
  [1638] = {.lex_state = 326, .external_lex_state = 5},
  [1639] = {.lex_state = 332, .external_lex_state = 4},
  [1640] = {.lex_state = 85},
  [1641] = {.lex_state = 326, .external_lex_state = 5},
  [1642] = {.lex_state = 78, .external_lex_state = 2},
  [1643] = {.lex_state = 102, .external_lex_state = 2},
  [1644] = {.lex_state = 326, .external_lex_state = 5},
  [1645] = {.lex_state = 85},
  [1646] = {.lex_state = 112},
  [1647] = {.lex_state = 291, .external_lex_state = 21},
  [1648] = {.lex_state = 125},
  [1649] = {.lex_state = 291, .external_lex_state = 21},
  [1650] = {.lex_state = 112, .external_lex_state = 7},
  [1651] = {.lex_state = 78, .external_lex_state = 2},
  [1652] = {.lex_state = 78, .external_lex_state = 2},
  [1653] = {.lex_state = 78, .external_lex_state = 2},
  [1654] = {.lex_state = 85},
  [1655] = {.lex_state = 291, .external_lex_state = 4},
  [1656] = {.lex_state = 291, .external_lex_state = 4},
  [1657] = {.lex_state = 112},
  [1658] = {.lex_state = 291, .external_lex_state = 6},
  [1659] = {.lex_state = 125},
  [1660] = {.lex_state = 291, .external_lex_state = 6},
  [1661] = {.lex_state = 112, .external_lex_state = 7},
  [1662] = {.lex_state = 78, .external_lex_state = 2},
  [1663] = {.lex_state = 78, .external_lex_state = 2},
  [1664] = {.lex_state = 78, .external_lex_state = 2},
  [1665] = {.lex_state = 291, .external_lex_state = 5},
  [1666] = {.lex_state = 291, .external_lex_state = 5},
  [1667] = {.lex_state = 301, .external_lex_state = 6},
  [1668] = {.lex_state = 301, .external_lex_state = 6},
  [1669] = {.lex_state = 301, .external_lex_state = 6},
  [1670] = {.lex_state = 102},
  [1671] = {.lex_state = 301, .external_lex_state = 6},
  [1672] = {.lex_state = 217},
  [1673] = {.lex_state = 301, .external_lex_state = 6},
  [1674] = {.lex_state = 125},
  [1675] = {.lex_state = 85},
  [1676] = {.lex_state = 223, .external_lex_state = 7},
  [1677] = {.lex_state = 225, .external_lex_state = 18},
  [1678] = {.lex_state = 225, .external_lex_state = 18},
  [1679] = {.lex_state = 85},
  [1680] = {.lex_state = 215, .external_lex_state = 2},
  [1681] = {.lex_state = 78},
  [1682] = {.lex_state = 85},
  [1683] = {.lex_state = 186, .external_lex_state = 5},
  [1684] = {.lex_state = 305},
  [1685] = {.lex_state = 305},
  [1686] = {.lex_state = 78},
  [1687] = {.lex_state = 255, .external_lex_state = 2},
  [1688] = {.lex_state = 78, .external_lex_state = 2},
  [1689] = {.lex_state = 78, .external_lex_state = 2},
  [1690] = {.lex_state = 102},
  [1691] = {.lex_state = 102},
  [1692] = {.lex_state = 334, .external_lex_state = 9},
  [1693] = {.lex_state = 305, .external_lex_state = 5},
  [1694] = {.lex_state = 237, .external_lex_state = 25},
  [1695] = {.lex_state = 301, .external_lex_state = 6},
  [1696] = {.lex_state = 301, .external_lex_state = 5},
  [1697] = {.lex_state = 301, .external_lex_state = 5},
  [1698] = {.lex_state = 305, .external_lex_state = 5},
  [1699] = {.lex_state = 308, .external_lex_state = 4},
  [1700] = {.lex_state = 305},
  [1701] = {.lex_state = 301, .external_lex_state = 5},
  [1702] = {.lex_state = 301, .external_lex_state = 5},
  [1703] = {.lex_state = 301, .external_lex_state = 5},
  [1704] = {.lex_state = 336, .external_lex_state = 9},
  [1705] = {.lex_state = 149, .external_lex_state = 14},
  [1706] = {.lex_state = 186, .external_lex_state = 5},
  [1707] = {.lex_state = 340, .external_lex_state = 10},
  [1708] = {.lex_state = 340, .external_lex_state = 10},
  [1709] = {.lex_state = 343},
  [1710] = {.lex_state = 340},
  [1711] = {.lex_state = 102},
  [1712] = {.lex_state = 340},
  [1713] = {.lex_state = 310},
  [1714] = {.lex_state = 149, .external_lex_state = 14},
  [1715] = {.lex_state = 92, .external_lex_state = 29},
  [1716] = {.lex_state = 92, .external_lex_state = 18},
  [1717] = {.lex_state = 92, .external_lex_state = 18},
  [1718] = {.lex_state = 260, .external_lex_state = 18},
  [1719] = {.lex_state = 149, .external_lex_state = 14},
  [1720] = {.lex_state = 262, .external_lex_state = 30},
  [1721] = {.lex_state = 262, .external_lex_state = 18},
  [1722] = {.lex_state = 262, .external_lex_state = 30},
  [1723] = {.lex_state = 262, .external_lex_state = 18},
  [1724] = {.lex_state = 262, .external_lex_state = 18},
  [1725] = {.lex_state = 149, .external_lex_state = 14},
  [1726] = {.lex_state = 262, .external_lex_state = 18},
  [1727] = {.lex_state = 262, .external_lex_state = 18},
  [1728] = {.lex_state = 186, .external_lex_state = 5},
  [1729] = {.lex_state = 343},
  [1730] = {.lex_state = 102},
  [1731] = {.lex_state = 310},
  [1732] = {.lex_state = 186, .external_lex_state = 5},
  [1733] = {.lex_state = 184, .external_lex_state = 21},
  [1734] = {.lex_state = 184, .external_lex_state = 4},
  [1735] = {.lex_state = 178, .external_lex_state = 21},
  [1736] = {.lex_state = 178, .external_lex_state = 4},
  [1737] = {.lex_state = 178, .external_lex_state = 21},
  [1738] = {.lex_state = 178, .external_lex_state = 6},
  [1739] = {.lex_state = 182, .external_lex_state = 6},
  [1740] = {.lex_state = 182, .external_lex_state = 5},
  [1741] = {.lex_state = 182, .external_lex_state = 6},
  [1742] = {.lex_state = 182, .external_lex_state = 5},
  [1743] = {.lex_state = 207, .external_lex_state = 15},
  [1744] = {.lex_state = 215},
  [1745] = {.lex_state = 207, .external_lex_state = 27},
  [1746] = {.lex_state = 207, .external_lex_state = 27},
  [1747] = {.lex_state = 207, .external_lex_state = 27},
  [1748] = {.lex_state = 102},
  [1749] = {.lex_state = 207, .external_lex_state = 27},
  [1750] = {.lex_state = 217},
  [1751] = {.lex_state = 207, .external_lex_state = 27},
  [1752] = {.lex_state = 125},
  [1753] = {.lex_state = 85},
  [1754] = {.lex_state = 223, .external_lex_state = 7},
  [1755] = {.lex_state = 225, .external_lex_state = 18},
  [1756] = {.lex_state = 225, .external_lex_state = 18},
  [1757] = {.lex_state = 85},
  [1758] = {.lex_state = 215, .external_lex_state = 2},
  [1759] = {.lex_state = 78},
  [1760] = {.lex_state = 85},
  [1761] = {.lex_state = 207, .external_lex_state = 15},
  [1762] = {.lex_state = 207, .external_lex_state = 15},
  [1763] = {.lex_state = 268},
  [1764] = {.lex_state = 241, .external_lex_state = 9},
  [1765] = {.lex_state = 146, .external_lex_state = 9},
  [1766] = {.lex_state = 270, .external_lex_state = 9},
  [1767] = {.lex_state = 205, .external_lex_state = 16},
  [1768] = {.lex_state = 205, .external_lex_state = 16},
  [1769] = {.lex_state = 172},
  [1770] = {.lex_state = 205, .external_lex_state = 16},
  [1771] = {.lex_state = 305},
  [1772] = {.lex_state = 305},
  [1773] = {.lex_state = 305},
  [1774] = {.lex_state = 310},
  [1775] = {.lex_state = 146, .external_lex_state = 9},
  [1776] = {.lex_state = 310},
  [1777] = {.lex_state = 146, .external_lex_state = 9},
  [1778] = {.lex_state = 78},
  [1779] = {.lex_state = 199, .external_lex_state = 15},
  [1780] = {.lex_state = 215},
  [1781] = {.lex_state = 199, .external_lex_state = 27},
  [1782] = {.lex_state = 199, .external_lex_state = 15},
  [1783] = {.lex_state = 199, .external_lex_state = 27},
  [1784] = {.lex_state = 102},
  [1785] = {.lex_state = 199, .external_lex_state = 27},
  [1786] = {.lex_state = 199, .external_lex_state = 27},
  [1787] = {.lex_state = 217},
  [1788] = {.lex_state = 260, .external_lex_state = 18},
  [1789] = {.lex_state = 85},
  [1790] = {.lex_state = 225, .external_lex_state = 18},
  [1791] = {.lex_state = 225, .external_lex_state = 18},
  [1792] = {.lex_state = 199, .external_lex_state = 27},
  [1793] = {.lex_state = 262, .external_lex_state = 30},
  [1794] = {.lex_state = 262, .external_lex_state = 18},
  [1795] = {.lex_state = 199, .external_lex_state = 27},
  [1796] = {.lex_state = 262, .external_lex_state = 30},
  [1797] = {.lex_state = 262, .external_lex_state = 18},
  [1798] = {.lex_state = 199, .external_lex_state = 27},
  [1799] = {.lex_state = 199, .external_lex_state = 27},
  [1800] = {.lex_state = 199, .external_lex_state = 17},
  [1801] = {.lex_state = 102},
  [1802] = {.lex_state = 199, .external_lex_state = 17},
  [1803] = {.lex_state = 199, .external_lex_state = 17},
  [1804] = {.lex_state = 217},
  [1805] = {.lex_state = 260, .external_lex_state = 18},
  [1806] = {.lex_state = 85},
  [1807] = {.lex_state = 225, .external_lex_state = 18},
  [1808] = {.lex_state = 225, .external_lex_state = 18},
  [1809] = {.lex_state = 199, .external_lex_state = 17},
  [1810] = {.lex_state = 262, .external_lex_state = 30},
  [1811] = {.lex_state = 262, .external_lex_state = 18},
  [1812] = {.lex_state = 199, .external_lex_state = 17},
  [1813] = {.lex_state = 262, .external_lex_state = 30},
  [1814] = {.lex_state = 262, .external_lex_state = 18},
  [1815] = {.lex_state = 199, .external_lex_state = 17},
  [1816] = {.lex_state = 199, .external_lex_state = 17},
  [1817] = {.lex_state = 346, .external_lex_state = 16},
  [1818] = {.lex_state = 201, .external_lex_state = 17},
  [1819] = {.lex_state = 201, .external_lex_state = 17},
  [1820] = {.lex_state = 92, .external_lex_state = 29},
  [1821] = {.lex_state = 92, .external_lex_state = 18},
  [1822] = {.lex_state = 92, .external_lex_state = 18},
  [1823] = {.lex_state = 260, .external_lex_state = 18},
  [1824] = {.lex_state = 201, .external_lex_state = 17},
  [1825] = {.lex_state = 262, .external_lex_state = 30},
  [1826] = {.lex_state = 262, .external_lex_state = 18},
  [1827] = {.lex_state = 262, .external_lex_state = 30},
  [1828] = {.lex_state = 262, .external_lex_state = 18},
  [1829] = {.lex_state = 262, .external_lex_state = 18},
  [1830] = {.lex_state = 201, .external_lex_state = 17},
  [1831] = {.lex_state = 262, .external_lex_state = 18},
  [1832] = {.lex_state = 262, .external_lex_state = 18},
  [1833] = {.lex_state = 205, .external_lex_state = 16},
  [1834] = {.lex_state = 258, .external_lex_state = 28},
  [1835] = {.lex_state = 205, .external_lex_state = 17},
  [1836] = {.lex_state = 205, .external_lex_state = 16},
  [1837] = {.lex_state = 205, .external_lex_state = 16},
  [1838] = {.lex_state = 205, .external_lex_state = 17},
  [1839] = {.lex_state = 205, .external_lex_state = 16},
  [1840] = {.lex_state = 104, .external_lex_state = 3},
  [1841] = {.lex_state = 102, .external_lex_state = 2},
  [1842] = {.lex_state = 215},
  [1843] = {.lex_state = 348, .external_lex_state = 20},
  [1844] = {.lex_state = 209, .external_lex_state = 19},
  [1845] = {.lex_state = 209, .external_lex_state = 19},
  [1846] = {.lex_state = 92, .external_lex_state = 29},
  [1847] = {.lex_state = 92, .external_lex_state = 18},
  [1848] = {.lex_state = 92, .external_lex_state = 18},
  [1849] = {.lex_state = 260, .external_lex_state = 18},
  [1850] = {.lex_state = 209, .external_lex_state = 19},
  [1851] = {.lex_state = 262, .external_lex_state = 30},
  [1852] = {.lex_state = 262, .external_lex_state = 18},
  [1853] = {.lex_state = 262, .external_lex_state = 30},
  [1854] = {.lex_state = 262, .external_lex_state = 18},
  [1855] = {.lex_state = 262, .external_lex_state = 18},
  [1856] = {.lex_state = 209, .external_lex_state = 19},
  [1857] = {.lex_state = 262, .external_lex_state = 18},
  [1858] = {.lex_state = 262, .external_lex_state = 18},
  [1859] = {.lex_state = 178, .external_lex_state = 4},
  [1860] = {.lex_state = 215},
  [1861] = {.lex_state = 350, .external_lex_state = 4},
  [1862] = {.lex_state = 178, .external_lex_state = 21},
  [1863] = {.lex_state = 178, .external_lex_state = 21},
  [1864] = {.lex_state = 92, .external_lex_state = 29},
  [1865] = {.lex_state = 92, .external_lex_state = 18},
  [1866] = {.lex_state = 92, .external_lex_state = 18},
  [1867] = {.lex_state = 260, .external_lex_state = 18},
  [1868] = {.lex_state = 178, .external_lex_state = 21},
  [1869] = {.lex_state = 262, .external_lex_state = 30},
  [1870] = {.lex_state = 262, .external_lex_state = 18},
  [1871] = {.lex_state = 262, .external_lex_state = 30},
  [1872] = {.lex_state = 262, .external_lex_state = 18},
  [1873] = {.lex_state = 262, .external_lex_state = 18},
  [1874] = {.lex_state = 178, .external_lex_state = 21},
  [1875] = {.lex_state = 262, .external_lex_state = 18},
  [1876] = {.lex_state = 262, .external_lex_state = 18},
  [1877] = {.lex_state = 350, .external_lex_state = 5},
  [1878] = {.lex_state = 178, .external_lex_state = 6},
  [1879] = {.lex_state = 178, .external_lex_state = 6},
  [1880] = {.lex_state = 92, .external_lex_state = 29},
  [1881] = {.lex_state = 92, .external_lex_state = 18},
  [1882] = {.lex_state = 92, .external_lex_state = 18},
  [1883] = {.lex_state = 260, .external_lex_state = 18},
  [1884] = {.lex_state = 178, .external_lex_state = 6},
  [1885] = {.lex_state = 262, .external_lex_state = 30},
  [1886] = {.lex_state = 262, .external_lex_state = 18},
  [1887] = {.lex_state = 262, .external_lex_state = 30},
  [1888] = {.lex_state = 262, .external_lex_state = 18},
  [1889] = {.lex_state = 262, .external_lex_state = 18},
  [1890] = {.lex_state = 178, .external_lex_state = 6},
  [1891] = {.lex_state = 262, .external_lex_state = 18},
  [1892] = {.lex_state = 262, .external_lex_state = 18},
  [1893] = {.lex_state = 352, .external_lex_state = 2},
  [1894] = {.lex_state = 215, .external_lex_state = 22},
  [1895] = {.lex_state = 215, .external_lex_state = 22},
  [1896] = {.lex_state = 92, .external_lex_state = 29},
  [1897] = {.lex_state = 92, .external_lex_state = 18},
  [1898] = {.lex_state = 92, .external_lex_state = 18},
  [1899] = {.lex_state = 260, .external_lex_state = 18},
  [1900] = {.lex_state = 215, .external_lex_state = 22},
  [1901] = {.lex_state = 262, .external_lex_state = 30},
  [1902] = {.lex_state = 262, .external_lex_state = 18},
  [1903] = {.lex_state = 262, .external_lex_state = 30},
  [1904] = {.lex_state = 262, .external_lex_state = 18},
  [1905] = {.lex_state = 262, .external_lex_state = 18},
  [1906] = {.lex_state = 215, .external_lex_state = 22},
  [1907] = {.lex_state = 262, .external_lex_state = 18},
  [1908] = {.lex_state = 262, .external_lex_state = 18},
  [1909] = {.lex_state = 125, .external_lex_state = 10},
  [1910] = {.lex_state = 92, .external_lex_state = 29},
  [1911] = {.lex_state = 92, .external_lex_state = 18},
  [1912] = {.lex_state = 92, .external_lex_state = 18},
  [1913] = {.lex_state = 260, .external_lex_state = 18},
  [1914] = {.lex_state = 125, .external_lex_state = 10},
  [1915] = {.lex_state = 262, .external_lex_state = 30},
  [1916] = {.lex_state = 262, .external_lex_state = 18},
  [1917] = {.lex_state = 262, .external_lex_state = 30},
  [1918] = {.lex_state = 262, .external_lex_state = 18},
  [1919] = {.lex_state = 262, .external_lex_state = 18},
  [1920] = {.lex_state = 125, .external_lex_state = 10},
  [1921] = {.lex_state = 262, .external_lex_state = 18},
  [1922] = {.lex_state = 262, .external_lex_state = 18},
  [1923] = {.lex_state = 239, .external_lex_state = 20},
  [1924] = {.lex_state = 225, .external_lex_state = 29},
  [1925] = {.lex_state = 209, .external_lex_state = 20},
  [1926] = {.lex_state = 209, .external_lex_state = 20},
  [1927] = {.lex_state = 225, .external_lex_state = 29},
  [1928] = {.lex_state = 92, .external_lex_state = 29},
  [1929] = {.lex_state = 92, .external_lex_state = 29},
  [1930] = {.lex_state = 92, .external_lex_state = 29},
  [1931] = {.lex_state = 102},
  [1932] = {.lex_state = 92, .external_lex_state = 29},
  [1933] = {.lex_state = 217},
  [1934] = {.lex_state = 92, .external_lex_state = 29},
  [1935] = {.lex_state = 125},
  [1936] = {.lex_state = 142, .external_lex_state = 6},
  [1937] = {.lex_state = 85},
  [1938] = {.lex_state = 223, .external_lex_state = 7},
  [1939] = {.lex_state = 225, .external_lex_state = 18},
  [1940] = {.lex_state = 225, .external_lex_state = 18},
  [1941] = {.lex_state = 85},
  [1942] = {.lex_state = 215, .external_lex_state = 2},
  [1943] = {.lex_state = 78},
  [1944] = {.lex_state = 85},
  [1945] = {.lex_state = 142, .external_lex_state = 6},
  [1946] = {.lex_state = 92, .external_lex_state = 18},
  [1947] = {.lex_state = 92, .external_lex_state = 18},
  [1948] = {.lex_state = 92, .external_lex_state = 29},
  [1949] = {.lex_state = 92, .external_lex_state = 18},
  [1950] = {.lex_state = 92, .external_lex_state = 18},
  [1951] = {.lex_state = 262, .external_lex_state = 18},
  [1952] = {.lex_state = 142, .external_lex_state = 6},
  [1953] = {.lex_state = 262, .external_lex_state = 18},
  [1954] = {.lex_state = 262, .external_lex_state = 18},
  [1955] = {.lex_state = 262, .external_lex_state = 18},
  [1956] = {.lex_state = 262, .external_lex_state = 29},
  [1957] = {.lex_state = 102},
  [1958] = {.lex_state = 262, .external_lex_state = 29},
  [1959] = {.lex_state = 262, .external_lex_state = 29},
  [1960] = {.lex_state = 217},
  [1961] = {.lex_state = 260, .external_lex_state = 18},
  [1962] = {.lex_state = 85},
  [1963] = {.lex_state = 225, .external_lex_state = 18},
  [1964] = {.lex_state = 225, .external_lex_state = 18},
  [1965] = {.lex_state = 262, .external_lex_state = 29},
  [1966] = {.lex_state = 262, .external_lex_state = 30},
  [1967] = {.lex_state = 262, .external_lex_state = 18},
  [1968] = {.lex_state = 262, .external_lex_state = 29},
  [1969] = {.lex_state = 262, .external_lex_state = 30},
  [1970] = {.lex_state = 262, .external_lex_state = 18},
  [1971] = {.lex_state = 142, .external_lex_state = 6},
  [1972] = {.lex_state = 262, .external_lex_state = 18},
  [1973] = {.lex_state = 262, .external_lex_state = 29},
  [1974] = {.lex_state = 262, .external_lex_state = 29},
  [1975] = {.lex_state = 215, .external_lex_state = 22},
  [1976] = {.lex_state = 140, .external_lex_state = 21},
  [1977] = {.lex_state = 140, .external_lex_state = 4},
  [1978] = {.lex_state = 108, .external_lex_state = 21},
  [1979] = {.lex_state = 108, .external_lex_state = 4},
  [1980] = {.lex_state = 108, .external_lex_state = 21},
  [1981] = {.lex_state = 108, .external_lex_state = 6},
  [1982] = {.lex_state = 229, .external_lex_state = 6},
  [1983] = {.lex_state = 229, .external_lex_state = 5},
  [1984] = {.lex_state = 229, .external_lex_state = 6},
  [1985] = {.lex_state = 229, .external_lex_state = 5},
  [1986] = {.lex_state = 78, .external_lex_state = 2},
  [1987] = {.lex_state = 260, .external_lex_state = 18},
  [1988] = {.lex_state = 85},
  [1989] = {.lex_state = 225, .external_lex_state = 18},
  [1990] = {.lex_state = 225, .external_lex_state = 18},
  [1991] = {.lex_state = 96, .external_lex_state = 23},
  [1992] = {.lex_state = 262, .external_lex_state = 30},
  [1993] = {.lex_state = 262, .external_lex_state = 18},
  [1994] = {.lex_state = 96, .external_lex_state = 23},
  [1995] = {.lex_state = 262, .external_lex_state = 30},
  [1996] = {.lex_state = 262, .external_lex_state = 18},
  [1997] = {.lex_state = 96, .external_lex_state = 23},
  [1998] = {.lex_state = 102},
  [1999] = {.lex_state = 136, .external_lex_state = 6},
  [2000] = {.lex_state = 102},
  [2001] = {.lex_state = 136, .external_lex_state = 5},
  [2002] = {.lex_state = 140, .external_lex_state = 4},
  [2003] = {.lex_state = 136, .external_lex_state = 5},
  [2004] = {.lex_state = 140, .external_lex_state = 4},
  [2005] = {.lex_state = 264, .external_lex_state = 6},
  [2006] = {.lex_state = 136, .external_lex_state = 6},
  [2007] = {.lex_state = 264, .external_lex_state = 5},
  [2008] = {.lex_state = 136, .external_lex_state = 6},
  [2009] = {.lex_state = 264, .external_lex_state = 5},
  [2010] = {.lex_state = 78, .external_lex_state = 2},
  [2011] = {.lex_state = 136, .external_lex_state = 5},
  [2012] = {.lex_state = 122, .external_lex_state = 5},
  [2013] = {.lex_state = 354, .external_lex_state = 19},
  [2014] = {.lex_state = 85},
  [2015] = {.lex_state = 85},
  [2016] = {.lex_state = 215, .external_lex_state = 10},
  [2017] = {.lex_state = 102},
  [2018] = {.lex_state = 215, .external_lex_state = 10},
  [2019] = {.lex_state = 215, .external_lex_state = 10},
  [2020] = {.lex_state = 217},
  [2021] = {.lex_state = 260, .external_lex_state = 18},
  [2022] = {.lex_state = 85},
  [2023] = {.lex_state = 225, .external_lex_state = 18},
  [2024] = {.lex_state = 225, .external_lex_state = 18},
  [2025] = {.lex_state = 215, .external_lex_state = 10},
  [2026] = {.lex_state = 262, .external_lex_state = 30},
  [2027] = {.lex_state = 262, .external_lex_state = 18},
  [2028] = {.lex_state = 215, .external_lex_state = 10},
  [2029] = {.lex_state = 262, .external_lex_state = 30},
  [2030] = {.lex_state = 262, .external_lex_state = 18},
  [2031] = {.lex_state = 215, .external_lex_state = 10},
  [2032] = {.lex_state = 215, .external_lex_state = 10},
  [2033] = {.lex_state = 350, .external_lex_state = 4},
  [2034] = {.lex_state = 184, .external_lex_state = 21},
  [2035] = {.lex_state = 184, .external_lex_state = 21},
  [2036] = {.lex_state = 92, .external_lex_state = 29},
  [2037] = {.lex_state = 92, .external_lex_state = 18},
  [2038] = {.lex_state = 92, .external_lex_state = 18},
  [2039] = {.lex_state = 260, .external_lex_state = 18},
  [2040] = {.lex_state = 184, .external_lex_state = 21},
  [2041] = {.lex_state = 262, .external_lex_state = 30},
  [2042] = {.lex_state = 262, .external_lex_state = 18},
  [2043] = {.lex_state = 262, .external_lex_state = 30},
  [2044] = {.lex_state = 262, .external_lex_state = 18},
  [2045] = {.lex_state = 262, .external_lex_state = 18},
  [2046] = {.lex_state = 184, .external_lex_state = 21},
  [2047] = {.lex_state = 262, .external_lex_state = 18},
  [2048] = {.lex_state = 262, .external_lex_state = 18},
  [2049] = {.lex_state = 317},
  [2050] = {.lex_state = 186, .external_lex_state = 5},
  [2051] = {.lex_state = 317},
  [2052] = {.lex_state = 153},
  [2053] = {.lex_state = 356, .external_lex_state = 9},
  [2054] = {.lex_state = 241, .external_lex_state = 14},
  [2055] = {.lex_state = 241, .external_lex_state = 14},
  [2056] = {.lex_state = 92, .external_lex_state = 29},
  [2057] = {.lex_state = 92, .external_lex_state = 18},
  [2058] = {.lex_state = 92, .external_lex_state = 18},
  [2059] = {.lex_state = 260, .external_lex_state = 18},
  [2060] = {.lex_state = 241, .external_lex_state = 14},
  [2061] = {.lex_state = 262, .external_lex_state = 30},
  [2062] = {.lex_state = 262, .external_lex_state = 18},
  [2063] = {.lex_state = 262, .external_lex_state = 30},
  [2064] = {.lex_state = 262, .external_lex_state = 18},
  [2065] = {.lex_state = 262, .external_lex_state = 18},
  [2066] = {.lex_state = 241, .external_lex_state = 14},
  [2067] = {.lex_state = 262, .external_lex_state = 18},
  [2068] = {.lex_state = 262, .external_lex_state = 18},
  [2069] = {.lex_state = 268},
  [2070] = {.lex_state = 270, .external_lex_state = 14},
  [2071] = {.lex_state = 102},
  [2072] = {.lex_state = 270, .external_lex_state = 14},
  [2073] = {.lex_state = 270, .external_lex_state = 14},
  [2074] = {.lex_state = 217},
  [2075] = {.lex_state = 260, .external_lex_state = 18},
  [2076] = {.lex_state = 85},
  [2077] = {.lex_state = 225, .external_lex_state = 18},
  [2078] = {.lex_state = 225, .external_lex_state = 18},
  [2079] = {.lex_state = 270, .external_lex_state = 14},
  [2080] = {.lex_state = 262, .external_lex_state = 30},
  [2081] = {.lex_state = 262, .external_lex_state = 18},
  [2082] = {.lex_state = 270, .external_lex_state = 14},
  [2083] = {.lex_state = 262, .external_lex_state = 30},
  [2084] = {.lex_state = 262, .external_lex_state = 18},
  [2085] = {.lex_state = 270, .external_lex_state = 14},
  [2086] = {.lex_state = 270, .external_lex_state = 14},
  [2087] = {.lex_state = 186, .external_lex_state = 5},
  [2088] = {.lex_state = 356},
  [2089] = {.lex_state = 272, .external_lex_state = 10},
  [2090] = {.lex_state = 272, .external_lex_state = 10},
  [2091] = {.lex_state = 92, .external_lex_state = 29},
  [2092] = {.lex_state = 92, .external_lex_state = 18},
  [2093] = {.lex_state = 92, .external_lex_state = 18},
  [2094] = {.lex_state = 260, .external_lex_state = 18},
  [2095] = {.lex_state = 272, .external_lex_state = 10},
  [2096] = {.lex_state = 262, .external_lex_state = 30},
  [2097] = {.lex_state = 262, .external_lex_state = 18},
  [2098] = {.lex_state = 262, .external_lex_state = 30},
  [2099] = {.lex_state = 262, .external_lex_state = 18},
  [2100] = {.lex_state = 262, .external_lex_state = 18},
  [2101] = {.lex_state = 272, .external_lex_state = 10},
  [2102] = {.lex_state = 262, .external_lex_state = 18},
  [2103] = {.lex_state = 262, .external_lex_state = 18},
  [2104] = {.lex_state = 246, .external_lex_state = 10},
  [2105] = {.lex_state = 246, .external_lex_state = 10},
  [2106] = {.lex_state = 92, .external_lex_state = 29},
  [2107] = {.lex_state = 92, .external_lex_state = 18},
  [2108] = {.lex_state = 92, .external_lex_state = 18},
  [2109] = {.lex_state = 262, .external_lex_state = 18},
  [2110] = {.lex_state = 246, .external_lex_state = 10},
  [2111] = {.lex_state = 262, .external_lex_state = 18},
  [2112] = {.lex_state = 262, .external_lex_state = 18},
  [2113] = {.lex_state = 262, .external_lex_state = 18},
  [2114] = {.lex_state = 246, .external_lex_state = 10},
  [2115] = {.lex_state = 262, .external_lex_state = 18},
  [2116] = {.lex_state = 140, .external_lex_state = 11},
  [2117] = {.lex_state = 140, .external_lex_state = 26},
  [2118] = {.lex_state = 102},
  [2119] = {.lex_state = 140, .external_lex_state = 26},
  [2120] = {.lex_state = 140, .external_lex_state = 26},
  [2121] = {.lex_state = 217},
  [2122] = {.lex_state = 260, .external_lex_state = 18},
  [2123] = {.lex_state = 85},
  [2124] = {.lex_state = 225, .external_lex_state = 18},
  [2125] = {.lex_state = 225, .external_lex_state = 18},
  [2126] = {.lex_state = 140, .external_lex_state = 26},
  [2127] = {.lex_state = 262, .external_lex_state = 30},
  [2128] = {.lex_state = 262, .external_lex_state = 18},
  [2129] = {.lex_state = 140, .external_lex_state = 26},
  [2130] = {.lex_state = 262, .external_lex_state = 30},
  [2131] = {.lex_state = 262, .external_lex_state = 18},
  [2132] = {.lex_state = 140, .external_lex_state = 26},
  [2133] = {.lex_state = 140, .external_lex_state = 26},
  [2134] = {.lex_state = 317},
  [2135] = {.lex_state = 153},
  [2136] = {.lex_state = 268},
  [2137] = {.lex_state = 241, .external_lex_state = 9},
  [2138] = {.lex_state = 102},
  [2139] = {.lex_state = 136, .external_lex_state = 12},
  [2140] = {.lex_state = 136, .external_lex_state = 12},
  [2141] = {.lex_state = 305},
  [2142] = {.lex_state = 305},
  [2143] = {.lex_state = 136, .external_lex_state = 12},
  [2144] = {.lex_state = 343},
  [2145] = {.lex_state = 102},
  [2146] = {.lex_state = 310},
  [2147] = {.lex_state = 136, .external_lex_state = 12},
  [2148] = {.lex_state = 343},
  [2149] = {.lex_state = 102},
  [2150] = {.lex_state = 310},
  [2151] = {.lex_state = 136, .external_lex_state = 12},
  [2152] = {.lex_state = 108, .external_lex_state = 11},
  [2153] = {.lex_state = 215},
  [2154] = {.lex_state = 350, .external_lex_state = 11},
  [2155] = {.lex_state = 108, .external_lex_state = 26},
  [2156] = {.lex_state = 108, .external_lex_state = 26},
  [2157] = {.lex_state = 92, .external_lex_state = 29},
  [2158] = {.lex_state = 92, .external_lex_state = 18},
  [2159] = {.lex_state = 92, .external_lex_state = 18},
  [2160] = {.lex_state = 260, .external_lex_state = 18},
  [2161] = {.lex_state = 108, .external_lex_state = 26},
  [2162] = {.lex_state = 262, .external_lex_state = 30},
  [2163] = {.lex_state = 262, .external_lex_state = 18},
  [2164] = {.lex_state = 262, .external_lex_state = 30},
  [2165] = {.lex_state = 262, .external_lex_state = 18},
  [2166] = {.lex_state = 262, .external_lex_state = 18},
  [2167] = {.lex_state = 108, .external_lex_state = 26},
  [2168] = {.lex_state = 262, .external_lex_state = 18},
  [2169] = {.lex_state = 262, .external_lex_state = 18},
  [2170] = {.lex_state = 350, .external_lex_state = 12},
  [2171] = {.lex_state = 108, .external_lex_state = 13},
  [2172] = {.lex_state = 108, .external_lex_state = 13},
  [2173] = {.lex_state = 92, .external_lex_state = 29},
  [2174] = {.lex_state = 92, .external_lex_state = 18},
  [2175] = {.lex_state = 92, .external_lex_state = 18},
  [2176] = {.lex_state = 260, .external_lex_state = 18},
  [2177] = {.lex_state = 108, .external_lex_state = 13},
  [2178] = {.lex_state = 262, .external_lex_state = 30},
  [2179] = {.lex_state = 262, .external_lex_state = 18},
  [2180] = {.lex_state = 262, .external_lex_state = 30},
  [2181] = {.lex_state = 262, .external_lex_state = 18},
  [2182] = {.lex_state = 262, .external_lex_state = 18},
  [2183] = {.lex_state = 108, .external_lex_state = 13},
  [2184] = {.lex_state = 262, .external_lex_state = 18},
  [2185] = {.lex_state = 262, .external_lex_state = 18},
  [2186] = {.lex_state = 122, .external_lex_state = 13},
  [2187] = {.lex_state = 122, .external_lex_state = 13},
  [2188] = {.lex_state = 92, .external_lex_state = 29},
  [2189] = {.lex_state = 92, .external_lex_state = 18},
  [2190] = {.lex_state = 92, .external_lex_state = 18},
  [2191] = {.lex_state = 262, .external_lex_state = 18},
  [2192] = {.lex_state = 122, .external_lex_state = 13},
  [2193] = {.lex_state = 262, .external_lex_state = 18},
  [2194] = {.lex_state = 262, .external_lex_state = 18},
  [2195] = {.lex_state = 262, .external_lex_state = 18},
  [2196] = {.lex_state = 122, .external_lex_state = 13},
  [2197] = {.lex_state = 262, .external_lex_state = 18},
  [2198] = {.lex_state = 287, .external_lex_state = 4},
  [2199] = {.lex_state = 215},
  [2200] = {.lex_state = 112},
  [2201] = {.lex_state = 287, .external_lex_state = 21},
  [2202] = {.lex_state = 125},
  [2203] = {.lex_state = 287, .external_lex_state = 21},
  [2204] = {.lex_state = 112, .external_lex_state = 7},
  [2205] = {.lex_state = 78, .external_lex_state = 2},
  [2206] = {.lex_state = 78, .external_lex_state = 2},
  [2207] = {.lex_state = 78, .external_lex_state = 2},
  [2208] = {.lex_state = 287, .external_lex_state = 4},
  [2209] = {.lex_state = 144, .external_lex_state = 8},
  [2210] = {.lex_state = 275, .external_lex_state = 21},
  [2211] = {.lex_state = 275, .external_lex_state = 21},
  [2212] = {.lex_state = 275, .external_lex_state = 21},
  [2213] = {.lex_state = 102},
  [2214] = {.lex_state = 275, .external_lex_state = 21},
  [2215] = {.lex_state = 217},
  [2216] = {.lex_state = 275, .external_lex_state = 21},
  [2217] = {.lex_state = 125},
  [2218] = {.lex_state = 85},
  [2219] = {.lex_state = 223, .external_lex_state = 7},
  [2220] = {.lex_state = 225, .external_lex_state = 18},
  [2221] = {.lex_state = 225, .external_lex_state = 18},
  [2222] = {.lex_state = 85},
  [2223] = {.lex_state = 215, .external_lex_state = 2},
  [2224] = {.lex_state = 78},
  [2225] = {.lex_state = 85},
  [2226] = {.lex_state = 275, .external_lex_state = 4},
  [2227] = {.lex_state = 275, .external_lex_state = 4},
  [2228] = {.lex_state = 275, .external_lex_state = 4},
  [2229] = {.lex_state = 275, .external_lex_state = 6},
  [2230] = {.lex_state = 275, .external_lex_state = 6},
  [2231] = {.lex_state = 275, .external_lex_state = 6},
  [2232] = {.lex_state = 102},
  [2233] = {.lex_state = 275, .external_lex_state = 6},
  [2234] = {.lex_state = 217},
  [2235] = {.lex_state = 275, .external_lex_state = 6},
  [2236] = {.lex_state = 125},
  [2237] = {.lex_state = 85},
  [2238] = {.lex_state = 223, .external_lex_state = 7},
  [2239] = {.lex_state = 225, .external_lex_state = 18},
  [2240] = {.lex_state = 225, .external_lex_state = 18},
  [2241] = {.lex_state = 85},
  [2242] = {.lex_state = 215, .external_lex_state = 2},
  [2243] = {.lex_state = 78},
  [2244] = {.lex_state = 85},
  [2245] = {.lex_state = 275, .external_lex_state = 5},
  [2246] = {.lex_state = 275, .external_lex_state = 5},
  [2247] = {.lex_state = 275, .external_lex_state = 5},
  [2248] = {.lex_state = 281, .external_lex_state = 6},
  [2249] = {.lex_state = 102},
  [2250] = {.lex_state = 281, .external_lex_state = 6},
  [2251] = {.lex_state = 281, .external_lex_state = 6},
  [2252] = {.lex_state = 217},
  [2253] = {.lex_state = 260, .external_lex_state = 18},
  [2254] = {.lex_state = 85},
  [2255] = {.lex_state = 225, .external_lex_state = 18},
  [2256] = {.lex_state = 225, .external_lex_state = 18},
  [2257] = {.lex_state = 281, .external_lex_state = 6},
  [2258] = {.lex_state = 262, .external_lex_state = 30},
  [2259] = {.lex_state = 262, .external_lex_state = 18},
  [2260] = {.lex_state = 281, .external_lex_state = 6},
  [2261] = {.lex_state = 262, .external_lex_state = 30},
  [2262] = {.lex_state = 262, .external_lex_state = 18},
  [2263] = {.lex_state = 281, .external_lex_state = 6},
  [2264] = {.lex_state = 281, .external_lex_state = 6},
  [2265] = {.lex_state = 102},
  [2266] = {.lex_state = 285, .external_lex_state = 5},
  [2267] = {.lex_state = 287, .external_lex_state = 4},
  [2268] = {.lex_state = 285, .external_lex_state = 5},
  [2269] = {.lex_state = 287, .external_lex_state = 4},
  [2270] = {.lex_state = 112},
  [2271] = {.lex_state = 285, .external_lex_state = 6},
  [2272] = {.lex_state = 125},
  [2273] = {.lex_state = 285, .external_lex_state = 6},
  [2274] = {.lex_state = 112, .external_lex_state = 7},
  [2275] = {.lex_state = 78, .external_lex_state = 2},
  [2276] = {.lex_state = 78, .external_lex_state = 2},
  [2277] = {.lex_state = 78, .external_lex_state = 2},
  [2278] = {.lex_state = 285, .external_lex_state = 5},
  [2279] = {.lex_state = 285, .external_lex_state = 6},
  [2280] = {.lex_state = 285, .external_lex_state = 5},
  [2281] = {.lex_state = 249, .external_lex_state = 2},
  [2282] = {.lex_state = 285, .external_lex_state = 5},
  [2283] = {.lex_state = 281, .external_lex_state = 5},
  [2284] = {.lex_state = 281, .external_lex_state = 6},
  [2285] = {.lex_state = 281, .external_lex_state = 5},
  [2286] = {.lex_state = 281, .external_lex_state = 5},
  [2287] = {.lex_state = 249, .external_lex_state = 2},
  [2288] = {.lex_state = 322, .external_lex_state = 9},
  [2289] = {.lex_state = 281, .external_lex_state = 5},
  [2290] = {.lex_state = 102},
  [2291] = {.lex_state = 136, .external_lex_state = 13},
  [2292] = {.lex_state = 308, .external_lex_state = 4},
  [2293] = {.lex_state = 215},
  [2294] = {.lex_state = 112},
  [2295] = {.lex_state = 308, .external_lex_state = 21},
  [2296] = {.lex_state = 125},
  [2297] = {.lex_state = 308, .external_lex_state = 21},
  [2298] = {.lex_state = 112, .external_lex_state = 7},
  [2299] = {.lex_state = 78, .external_lex_state = 2},
  [2300] = {.lex_state = 78, .external_lex_state = 2},
  [2301] = {.lex_state = 78, .external_lex_state = 2},
  [2302] = {.lex_state = 308, .external_lex_state = 4},
  [2303] = {.lex_state = 255, .external_lex_state = 2},
  [2304] = {.lex_state = 144, .external_lex_state = 8},
  [2305] = {.lex_state = 85},
  [2306] = {.lex_state = 112},
  [2307] = {.lex_state = 324, .external_lex_state = 21},
  [2308] = {.lex_state = 125},
  [2309] = {.lex_state = 324, .external_lex_state = 21},
  [2310] = {.lex_state = 112, .external_lex_state = 7},
  [2311] = {.lex_state = 78, .external_lex_state = 2},
  [2312] = {.lex_state = 78, .external_lex_state = 2},
  [2313] = {.lex_state = 78, .external_lex_state = 2},
  [2314] = {.lex_state = 85},
  [2315] = {.lex_state = 324, .external_lex_state = 4},
  [2316] = {.lex_state = 324, .external_lex_state = 4},
  [2317] = {.lex_state = 112},
  [2318] = {.lex_state = 324, .external_lex_state = 6},
  [2319] = {.lex_state = 125},
  [2320] = {.lex_state = 324, .external_lex_state = 6},
  [2321] = {.lex_state = 112, .external_lex_state = 7},
  [2322] = {.lex_state = 78, .external_lex_state = 2},
  [2323] = {.lex_state = 78, .external_lex_state = 2},
  [2324] = {.lex_state = 78, .external_lex_state = 2},
  [2325] = {.lex_state = 324, .external_lex_state = 5},
  [2326] = {.lex_state = 324, .external_lex_state = 5},
  [2327] = {.lex_state = 326, .external_lex_state = 6},
  [2328] = {.lex_state = 326, .external_lex_state = 6},
  [2329] = {.lex_state = 326, .external_lex_state = 6},
  [2330] = {.lex_state = 102},
  [2331] = {.lex_state = 326, .external_lex_state = 6},
  [2332] = {.lex_state = 217},
  [2333] = {.lex_state = 326, .external_lex_state = 6},
  [2334] = {.lex_state = 125},
  [2335] = {.lex_state = 85},
  [2336] = {.lex_state = 223, .external_lex_state = 7},
  [2337] = {.lex_state = 225, .external_lex_state = 18},
  [2338] = {.lex_state = 225, .external_lex_state = 18},
  [2339] = {.lex_state = 85},
  [2340] = {.lex_state = 215, .external_lex_state = 2},
  [2341] = {.lex_state = 78},
  [2342] = {.lex_state = 85},
  [2343] = {.lex_state = 78},
  [2344] = {.lex_state = 289, .external_lex_state = 2},
  [2345] = {.lex_state = 78, .external_lex_state = 2},
  [2346] = {.lex_state = 78, .external_lex_state = 2},
  [2347] = {.lex_state = 102},
  [2348] = {.lex_state = 102},
  [2349] = {.lex_state = 334, .external_lex_state = 9},
  [2350] = {.lex_state = 330, .external_lex_state = 5},
  [2351] = {.lex_state = 237, .external_lex_state = 25},
  [2352] = {.lex_state = 326, .external_lex_state = 6},
  [2353] = {.lex_state = 326, .external_lex_state = 5},
  [2354] = {.lex_state = 326, .external_lex_state = 5},
  [2355] = {.lex_state = 330, .external_lex_state = 5},
  [2356] = {.lex_state = 332, .external_lex_state = 4},
  [2357] = {.lex_state = 326, .external_lex_state = 5},
  [2358] = {.lex_state = 326, .external_lex_state = 5},
  [2359] = {.lex_state = 326, .external_lex_state = 5},
  [2360] = {.lex_state = 144, .external_lex_state = 8},
  [2361] = {.lex_state = 291, .external_lex_state = 21},
  [2362] = {.lex_state = 291, .external_lex_state = 21},
  [2363] = {.lex_state = 291, .external_lex_state = 21},
  [2364] = {.lex_state = 102},
  [2365] = {.lex_state = 291, .external_lex_state = 21},
  [2366] = {.lex_state = 217},
  [2367] = {.lex_state = 291, .external_lex_state = 21},
  [2368] = {.lex_state = 125},
  [2369] = {.lex_state = 85},
  [2370] = {.lex_state = 223, .external_lex_state = 7},
  [2371] = {.lex_state = 225, .external_lex_state = 18},
  [2372] = {.lex_state = 225, .external_lex_state = 18},
  [2373] = {.lex_state = 85},
  [2374] = {.lex_state = 215, .external_lex_state = 2},
  [2375] = {.lex_state = 78},
  [2376] = {.lex_state = 85},
  [2377] = {.lex_state = 291, .external_lex_state = 4},
  [2378] = {.lex_state = 291, .external_lex_state = 4},
  [2379] = {.lex_state = 291, .external_lex_state = 4},
  [2380] = {.lex_state = 291, .external_lex_state = 6},
  [2381] = {.lex_state = 291, .external_lex_state = 6},
  [2382] = {.lex_state = 291, .external_lex_state = 6},
  [2383] = {.lex_state = 102},
  [2384] = {.lex_state = 291, .external_lex_state = 6},
  [2385] = {.lex_state = 217},
  [2386] = {.lex_state = 291, .external_lex_state = 6},
  [2387] = {.lex_state = 125},
  [2388] = {.lex_state = 85},
  [2389] = {.lex_state = 223, .external_lex_state = 7},
  [2390] = {.lex_state = 225, .external_lex_state = 18},
  [2391] = {.lex_state = 225, .external_lex_state = 18},
  [2392] = {.lex_state = 85},
  [2393] = {.lex_state = 215, .external_lex_state = 2},
  [2394] = {.lex_state = 78},
  [2395] = {.lex_state = 85},
  [2396] = {.lex_state = 291, .external_lex_state = 5},
  [2397] = {.lex_state = 291, .external_lex_state = 5},
  [2398] = {.lex_state = 291, .external_lex_state = 5},
  [2399] = {.lex_state = 301, .external_lex_state = 6},
  [2400] = {.lex_state = 102},
  [2401] = {.lex_state = 301, .external_lex_state = 6},
  [2402] = {.lex_state = 301, .external_lex_state = 6},
  [2403] = {.lex_state = 217},
  [2404] = {.lex_state = 260, .external_lex_state = 18},
  [2405] = {.lex_state = 85},
  [2406] = {.lex_state = 225, .external_lex_state = 18},
  [2407] = {.lex_state = 225, .external_lex_state = 18},
  [2408] = {.lex_state = 301, .external_lex_state = 6},
  [2409] = {.lex_state = 262, .external_lex_state = 30},
  [2410] = {.lex_state = 262, .external_lex_state = 18},
  [2411] = {.lex_state = 301, .external_lex_state = 6},
  [2412] = {.lex_state = 262, .external_lex_state = 30},
  [2413] = {.lex_state = 262, .external_lex_state = 18},
  [2414] = {.lex_state = 301, .external_lex_state = 6},
  [2415] = {.lex_state = 301, .external_lex_state = 6},
  [2416] = {.lex_state = 186, .external_lex_state = 5},
  [2417] = {.lex_state = 305},
  [2418] = {.lex_state = 102},
  [2419] = {.lex_state = 305, .external_lex_state = 5},
  [2420] = {.lex_state = 308, .external_lex_state = 4},
  [2421] = {.lex_state = 305, .external_lex_state = 5},
  [2422] = {.lex_state = 308, .external_lex_state = 4},
  [2423] = {.lex_state = 305, .external_lex_state = 6},
  [2424] = {.lex_state = 305, .external_lex_state = 6},
  [2425] = {.lex_state = 305, .external_lex_state = 5},
  [2426] = {.lex_state = 305, .external_lex_state = 6},
  [2427] = {.lex_state = 305, .external_lex_state = 5},
  [2428] = {.lex_state = 255, .external_lex_state = 2},
  [2429] = {.lex_state = 305, .external_lex_state = 5},
  [2430] = {.lex_state = 301, .external_lex_state = 5},
  [2431] = {.lex_state = 301, .external_lex_state = 6},
  [2432] = {.lex_state = 301, .external_lex_state = 5},
  [2433] = {.lex_state = 301, .external_lex_state = 5},
  [2434] = {.lex_state = 255, .external_lex_state = 2},
  [2435] = {.lex_state = 334, .external_lex_state = 9},
  [2436] = {.lex_state = 301, .external_lex_state = 5},
  [2437] = {.lex_state = 340, .external_lex_state = 10},
  [2438] = {.lex_state = 102},
  [2439] = {.lex_state = 358, .external_lex_state = 2},
  [2440] = {.lex_state = 340},
  [2441] = {.lex_state = 186, .external_lex_state = 5},
  [2442] = {.lex_state = 343},
  [2443] = {.lex_state = 102},
  [2444] = {.lex_state = 358, .external_lex_state = 2},
  [2445] = {.lex_state = 340},
  [2446] = {.lex_state = 340},
  [2447] = {.lex_state = 102},
  [2448] = {.lex_state = 149, .external_lex_state = 14},
  [2449] = {.lex_state = 149, .external_lex_state = 14},
  [2450] = {.lex_state = 92, .external_lex_state = 29},
  [2451] = {.lex_state = 92, .external_lex_state = 18},
  [2452] = {.lex_state = 92, .external_lex_state = 18},
  [2453] = {.lex_state = 262, .external_lex_state = 18},
  [2454] = {.lex_state = 149, .external_lex_state = 14},
  [2455] = {.lex_state = 262, .external_lex_state = 18},
  [2456] = {.lex_state = 262, .external_lex_state = 18},
  [2457] = {.lex_state = 262, .external_lex_state = 18},
  [2458] = {.lex_state = 149, .external_lex_state = 14},
  [2459] = {.lex_state = 262, .external_lex_state = 18},
  [2460] = {.lex_state = 186, .external_lex_state = 5},
  [2461] = {.lex_state = 343},
  [2462] = {.lex_state = 102},
  [2463] = {.lex_state = 184, .external_lex_state = 21},
  [2464] = {.lex_state = 182, .external_lex_state = 6},
  [2465] = {.lex_state = 207, .external_lex_state = 15},
  [2466] = {.lex_state = 207, .external_lex_state = 27},
  [2467] = {.lex_state = 102},
  [2468] = {.lex_state = 207, .external_lex_state = 27},
  [2469] = {.lex_state = 207, .external_lex_state = 27},
  [2470] = {.lex_state = 217},
  [2471] = {.lex_state = 260, .external_lex_state = 18},
  [2472] = {.lex_state = 85},
  [2473] = {.lex_state = 225, .external_lex_state = 18},
  [2474] = {.lex_state = 225, .external_lex_state = 18},
  [2475] = {.lex_state = 207, .external_lex_state = 27},
  [2476] = {.lex_state = 262, .external_lex_state = 30},
  [2477] = {.lex_state = 262, .external_lex_state = 18},
  [2478] = {.lex_state = 207, .external_lex_state = 27},
  [2479] = {.lex_state = 262, .external_lex_state = 30},
  [2480] = {.lex_state = 262, .external_lex_state = 18},
  [2481] = {.lex_state = 207, .external_lex_state = 27},
  [2482] = {.lex_state = 207, .external_lex_state = 27},
  [2483] = {.lex_state = 317},
  [2484] = {.lex_state = 153},
  [2485] = {.lex_state = 268},
  [2486] = {.lex_state = 241, .external_lex_state = 9},
  [2487] = {.lex_state = 102},
  [2488] = {.lex_state = 205, .external_lex_state = 16},
  [2489] = {.lex_state = 205, .external_lex_state = 16},
  [2490] = {.lex_state = 305},
  [2491] = {.lex_state = 305},
  [2492] = {.lex_state = 205, .external_lex_state = 16},
  [2493] = {.lex_state = 343},
  [2494] = {.lex_state = 102},
  [2495] = {.lex_state = 310},
  [2496] = {.lex_state = 205, .external_lex_state = 16},
  [2497] = {.lex_state = 343},
  [2498] = {.lex_state = 102},
  [2499] = {.lex_state = 310},
  [2500] = {.lex_state = 205, .external_lex_state = 16},
  [2501] = {.lex_state = 199, .external_lex_state = 15},
  [2502] = {.lex_state = 215},
  [2503] = {.lex_state = 360, .external_lex_state = 15},
  [2504] = {.lex_state = 199, .external_lex_state = 27},
  [2505] = {.lex_state = 199, .external_lex_state = 27},
  [2506] = {.lex_state = 92, .external_lex_state = 29},
  [2507] = {.lex_state = 92, .external_lex_state = 18},
  [2508] = {.lex_state = 92, .external_lex_state = 18},
  [2509] = {.lex_state = 260, .external_lex_state = 18},
  [2510] = {.lex_state = 199, .external_lex_state = 27},
  [2511] = {.lex_state = 262, .external_lex_state = 30},
  [2512] = {.lex_state = 262, .external_lex_state = 18},
  [2513] = {.lex_state = 262, .external_lex_state = 30},
  [2514] = {.lex_state = 262, .external_lex_state = 18},
  [2515] = {.lex_state = 262, .external_lex_state = 18},
  [2516] = {.lex_state = 199, .external_lex_state = 27},
  [2517] = {.lex_state = 262, .external_lex_state = 18},
  [2518] = {.lex_state = 262, .external_lex_state = 18},
  [2519] = {.lex_state = 360, .external_lex_state = 16},
  [2520] = {.lex_state = 199, .external_lex_state = 17},
  [2521] = {.lex_state = 199, .external_lex_state = 17},
  [2522] = {.lex_state = 92, .external_lex_state = 29},
  [2523] = {.lex_state = 92, .external_lex_state = 18},
  [2524] = {.lex_state = 92, .external_lex_state = 18},
  [2525] = {.lex_state = 260, .external_lex_state = 18},
  [2526] = {.lex_state = 199, .external_lex_state = 17},
  [2527] = {.lex_state = 262, .external_lex_state = 30},
  [2528] = {.lex_state = 262, .external_lex_state = 18},
  [2529] = {.lex_state = 262, .external_lex_state = 30},
  [2530] = {.lex_state = 262, .external_lex_state = 18},
  [2531] = {.lex_state = 262, .external_lex_state = 18},
  [2532] = {.lex_state = 199, .external_lex_state = 17},
  [2533] = {.lex_state = 262, .external_lex_state = 18},
  [2534] = {.lex_state = 262, .external_lex_state = 18},
  [2535] = {.lex_state = 201, .external_lex_state = 17},
  [2536] = {.lex_state = 201, .external_lex_state = 17},
  [2537] = {.lex_state = 92, .external_lex_state = 29},
  [2538] = {.lex_state = 92, .external_lex_state = 18},
  [2539] = {.lex_state = 92, .external_lex_state = 18},
  [2540] = {.lex_state = 262, .external_lex_state = 18},
  [2541] = {.lex_state = 201, .external_lex_state = 17},
  [2542] = {.lex_state = 262, .external_lex_state = 18},
  [2543] = {.lex_state = 262, .external_lex_state = 18},
  [2544] = {.lex_state = 262, .external_lex_state = 18},
  [2545] = {.lex_state = 201, .external_lex_state = 17},
  [2546] = {.lex_state = 262, .external_lex_state = 18},
  [2547] = {.lex_state = 102},
  [2548] = {.lex_state = 205, .external_lex_state = 17},
  [2549] = {.lex_state = 102, .external_lex_state = 2},
  [2550] = {.lex_state = 209, .external_lex_state = 19},
  [2551] = {.lex_state = 209, .external_lex_state = 19},
  [2552] = {.lex_state = 92, .external_lex_state = 29},
  [2553] = {.lex_state = 92, .external_lex_state = 18},
  [2554] = {.lex_state = 92, .external_lex_state = 18},
  [2555] = {.lex_state = 262, .external_lex_state = 18},
  [2556] = {.lex_state = 209, .external_lex_state = 19},
  [2557] = {.lex_state = 262, .external_lex_state = 18},
  [2558] = {.lex_state = 262, .external_lex_state = 18},
  [2559] = {.lex_state = 262, .external_lex_state = 18},
  [2560] = {.lex_state = 209, .external_lex_state = 19},
  [2561] = {.lex_state = 262, .external_lex_state = 18},
  [2562] = {.lex_state = 178, .external_lex_state = 4},
  [2563] = {.lex_state = 178, .external_lex_state = 21},
  [2564] = {.lex_state = 178, .external_lex_state = 21},
  [2565] = {.lex_state = 92, .external_lex_state = 29},
  [2566] = {.lex_state = 92, .external_lex_state = 18},
  [2567] = {.lex_state = 92, .external_lex_state = 18},
  [2568] = {.lex_state = 262, .external_lex_state = 18},
  [2569] = {.lex_state = 178, .external_lex_state = 21},
  [2570] = {.lex_state = 262, .external_lex_state = 18},
  [2571] = {.lex_state = 262, .external_lex_state = 18},
  [2572] = {.lex_state = 262, .external_lex_state = 18},
  [2573] = {.lex_state = 178, .external_lex_state = 21},
  [2574] = {.lex_state = 262, .external_lex_state = 18},
  [2575] = {.lex_state = 178, .external_lex_state = 6},
  [2576] = {.lex_state = 178, .external_lex_state = 6},
  [2577] = {.lex_state = 92, .external_lex_state = 29},
  [2578] = {.lex_state = 92, .external_lex_state = 18},
  [2579] = {.lex_state = 92, .external_lex_state = 18},
  [2580] = {.lex_state = 262, .external_lex_state = 18},
  [2581] = {.lex_state = 178, .external_lex_state = 6},
  [2582] = {.lex_state = 262, .external_lex_state = 18},
  [2583] = {.lex_state = 262, .external_lex_state = 18},
  [2584] = {.lex_state = 262, .external_lex_state = 18},
  [2585] = {.lex_state = 178, .external_lex_state = 6},
  [2586] = {.lex_state = 262, .external_lex_state = 18},
  [2587] = {.lex_state = 215, .external_lex_state = 22},
  [2588] = {.lex_state = 215, .external_lex_state = 22},
  [2589] = {.lex_state = 92, .external_lex_state = 29},
  [2590] = {.lex_state = 92, .external_lex_state = 18},
  [2591] = {.lex_state = 92, .external_lex_state = 18},
  [2592] = {.lex_state = 262, .external_lex_state = 18},
  [2593] = {.lex_state = 215, .external_lex_state = 22},
  [2594] = {.lex_state = 262, .external_lex_state = 18},
  [2595] = {.lex_state = 262, .external_lex_state = 18},
  [2596] = {.lex_state = 262, .external_lex_state = 18},
  [2597] = {.lex_state = 215, .external_lex_state = 22},
  [2598] = {.lex_state = 262, .external_lex_state = 18},
  [2599] = {.lex_state = 125, .external_lex_state = 10},
  [2600] = {.lex_state = 125, .external_lex_state = 10},
  [2601] = {.lex_state = 92, .external_lex_state = 29},
  [2602] = {.lex_state = 92, .external_lex_state = 18},
  [2603] = {.lex_state = 92, .external_lex_state = 18},
  [2604] = {.lex_state = 262, .external_lex_state = 18},
  [2605] = {.lex_state = 125, .external_lex_state = 10},
  [2606] = {.lex_state = 262, .external_lex_state = 18},
  [2607] = {.lex_state = 262, .external_lex_state = 18},
  [2608] = {.lex_state = 262, .external_lex_state = 18},
  [2609] = {.lex_state = 125, .external_lex_state = 10},
  [2610] = {.lex_state = 262, .external_lex_state = 18},
  [2611] = {.lex_state = 225, .external_lex_state = 29},
  [2612] = {.lex_state = 225, .external_lex_state = 18},
  [2613] = {.lex_state = 225, .external_lex_state = 29},
  [2614] = {.lex_state = 225, .external_lex_state = 18},
  [2615] = {.lex_state = 92, .external_lex_state = 29},
  [2616] = {.lex_state = 102},
  [2617] = {.lex_state = 92, .external_lex_state = 29},
  [2618] = {.lex_state = 92, .external_lex_state = 29},
  [2619] = {.lex_state = 217},
  [2620] = {.lex_state = 260, .external_lex_state = 18},
  [2621] = {.lex_state = 85},
  [2622] = {.lex_state = 225, .external_lex_state = 18},
  [2623] = {.lex_state = 225, .external_lex_state = 18},
  [2624] = {.lex_state = 92, .external_lex_state = 29},
  [2625] = {.lex_state = 262, .external_lex_state = 30},
  [2626] = {.lex_state = 262, .external_lex_state = 18},
  [2627] = {.lex_state = 92, .external_lex_state = 29},
  [2628] = {.lex_state = 262, .external_lex_state = 30},
  [2629] = {.lex_state = 262, .external_lex_state = 18},
  [2630] = {.lex_state = 92, .external_lex_state = 29},
  [2631] = {.lex_state = 92, .external_lex_state = 29},
  [2632] = {.lex_state = 142, .external_lex_state = 6},
  [2633] = {.lex_state = 142, .external_lex_state = 6},
  [2634] = {.lex_state = 142, .external_lex_state = 6},
  [2635] = {.lex_state = 262, .external_lex_state = 18},
  [2636] = {.lex_state = 262, .external_lex_state = 18},
  [2637] = {.lex_state = 362, .external_lex_state = 18},
  [2638] = {.lex_state = 262, .external_lex_state = 29},
  [2639] = {.lex_state = 262, .external_lex_state = 29},
  [2640] = {.lex_state = 92, .external_lex_state = 29},
  [2641] = {.lex_state = 92, .external_lex_state = 18},
  [2642] = {.lex_state = 92, .external_lex_state = 18},
  [2643] = {.lex_state = 260, .external_lex_state = 18},
  [2644] = {.lex_state = 262, .external_lex_state = 29},
  [2645] = {.lex_state = 262, .external_lex_state = 30},
  [2646] = {.lex_state = 262, .external_lex_state = 18},
  [2647] = {.lex_state = 262, .external_lex_state = 30},
  [2648] = {.lex_state = 262, .external_lex_state = 18},
  [2649] = {.lex_state = 262, .external_lex_state = 18},
  [2650] = {.lex_state = 262, .external_lex_state = 29},
  [2651] = {.lex_state = 262, .external_lex_state = 18},
  [2652] = {.lex_state = 262, .external_lex_state = 18},
  [2653] = {.lex_state = 142, .external_lex_state = 6},
  [2654] = {.lex_state = 140, .external_lex_state = 21},
  [2655] = {.lex_state = 229, .external_lex_state = 6},
  [2656] = {.lex_state = 96, .external_lex_state = 23},
  [2657] = {.lex_state = 92, .external_lex_state = 29},
  [2658] = {.lex_state = 92, .external_lex_state = 18},
  [2659] = {.lex_state = 92, .external_lex_state = 18},
  [2660] = {.lex_state = 260, .external_lex_state = 18},
  [2661] = {.lex_state = 96, .external_lex_state = 23},
  [2662] = {.lex_state = 262, .external_lex_state = 30},
  [2663] = {.lex_state = 262, .external_lex_state = 18},
  [2664] = {.lex_state = 262, .external_lex_state = 30},
  [2665] = {.lex_state = 262, .external_lex_state = 18},
  [2666] = {.lex_state = 262, .external_lex_state = 18},
  [2667] = {.lex_state = 96, .external_lex_state = 23},
  [2668] = {.lex_state = 262, .external_lex_state = 18},
  [2669] = {.lex_state = 262, .external_lex_state = 18},
  [2670] = {.lex_state = 364, .external_lex_state = 5},
  [2671] = {.lex_state = 136, .external_lex_state = 6},
  [2672] = {.lex_state = 264, .external_lex_state = 5},
  [2673] = {.lex_state = 136, .external_lex_state = 6},
  [2674] = {.lex_state = 264, .external_lex_state = 5},
  [2675] = {.lex_state = 352},
  [2676] = {.lex_state = 215, .external_lex_state = 10},
  [2677] = {.lex_state = 215, .external_lex_state = 10},
  [2678] = {.lex_state = 92, .external_lex_state = 29},
  [2679] = {.lex_state = 92, .external_lex_state = 18},
  [2680] = {.lex_state = 92, .external_lex_state = 18},
  [2681] = {.lex_state = 260, .external_lex_state = 18},
  [2682] = {.lex_state = 215, .external_lex_state = 10},
  [2683] = {.lex_state = 262, .external_lex_state = 30},
  [2684] = {.lex_state = 262, .external_lex_state = 18},
  [2685] = {.lex_state = 262, .external_lex_state = 30},
  [2686] = {.lex_state = 262, .external_lex_state = 18},
  [2687] = {.lex_state = 262, .external_lex_state = 18},
  [2688] = {.lex_state = 215, .external_lex_state = 10},
  [2689] = {.lex_state = 262, .external_lex_state = 18},
  [2690] = {.lex_state = 262, .external_lex_state = 18},
  [2691] = {.lex_state = 184, .external_lex_state = 21},
  [2692] = {.lex_state = 184, .external_lex_state = 21},
  [2693] = {.lex_state = 92, .external_lex_state = 29},
  [2694] = {.lex_state = 92, .external_lex_state = 18},
  [2695] = {.lex_state = 92, .external_lex_state = 18},
  [2696] = {.lex_state = 262, .external_lex_state = 18},
  [2697] = {.lex_state = 184, .external_lex_state = 21},
  [2698] = {.lex_state = 262, .external_lex_state = 18},
  [2699] = {.lex_state = 262, .external_lex_state = 18},
  [2700] = {.lex_state = 262, .external_lex_state = 18},
  [2701] = {.lex_state = 184, .external_lex_state = 21},
  [2702] = {.lex_state = 262, .external_lex_state = 18},
  [2703] = {.lex_state = 186, .external_lex_state = 5},
  [2704] = {.lex_state = 317},
  [2705] = {.lex_state = 317},
  [2706] = {.lex_state = 241, .external_lex_state = 14},
  [2707] = {.lex_state = 241, .external_lex_state = 14},
  [2708] = {.lex_state = 92, .external_lex_state = 29},
  [2709] = {.lex_state = 92, .external_lex_state = 18},
  [2710] = {.lex_state = 92, .external_lex_state = 18},
  [2711] = {.lex_state = 262, .external_lex_state = 18},
  [2712] = {.lex_state = 241, .external_lex_state = 14},
  [2713] = {.lex_state = 262, .external_lex_state = 18},
  [2714] = {.lex_state = 262, .external_lex_state = 18},
  [2715] = {.lex_state = 262, .external_lex_state = 18},
  [2716] = {.lex_state = 241, .external_lex_state = 14},
  [2717] = {.lex_state = 262, .external_lex_state = 18},
  [2718] = {.lex_state = 153},
  [2719] = {.lex_state = 366, .external_lex_state = 9},
  [2720] = {.lex_state = 270, .external_lex_state = 14},
  [2721] = {.lex_state = 270, .external_lex_state = 14},
  [2722] = {.lex_state = 92, .external_lex_state = 29},
  [2723] = {.lex_state = 92, .external_lex_state = 18},
  [2724] = {.lex_state = 92, .external_lex_state = 18},
  [2725] = {.lex_state = 260, .external_lex_state = 18},
  [2726] = {.lex_state = 270, .external_lex_state = 14},
  [2727] = {.lex_state = 262, .external_lex_state = 30},
  [2728] = {.lex_state = 262, .external_lex_state = 18},
  [2729] = {.lex_state = 262, .external_lex_state = 30},
  [2730] = {.lex_state = 262, .external_lex_state = 18},
  [2731] = {.lex_state = 262, .external_lex_state = 18},
  [2732] = {.lex_state = 270, .external_lex_state = 14},
  [2733] = {.lex_state = 262, .external_lex_state = 18},
  [2734] = {.lex_state = 262, .external_lex_state = 18},
  [2735] = {.lex_state = 272, .external_lex_state = 10},
  [2736] = {.lex_state = 272, .external_lex_state = 10},
  [2737] = {.lex_state = 92, .external_lex_state = 29},
  [2738] = {.lex_state = 92, .external_lex_state = 18},
  [2739] = {.lex_state = 92, .external_lex_state = 18},
  [2740] = {.lex_state = 262, .external_lex_state = 18},
  [2741] = {.lex_state = 272, .external_lex_state = 10},
  [2742] = {.lex_state = 262, .external_lex_state = 18},
  [2743] = {.lex_state = 262, .external_lex_state = 18},
  [2744] = {.lex_state = 262, .external_lex_state = 18},
  [2745] = {.lex_state = 272, .external_lex_state = 10},
  [2746] = {.lex_state = 262, .external_lex_state = 18},
  [2747] = {.lex_state = 246, .external_lex_state = 10},
  [2748] = {.lex_state = 246, .external_lex_state = 10},
  [2749] = {.lex_state = 246, .external_lex_state = 10},
  [2750] = {.lex_state = 262, .external_lex_state = 18},
  [2751] = {.lex_state = 262, .external_lex_state = 18},
  [2752] = {.lex_state = 246, .external_lex_state = 10},
  [2753] = {.lex_state = 350, .external_lex_state = 11},
  [2754] = {.lex_state = 140, .external_lex_state = 26},
  [2755] = {.lex_state = 140, .external_lex_state = 26},
  [2756] = {.lex_state = 92, .external_lex_state = 29},
  [2757] = {.lex_state = 92, .external_lex_state = 18},
  [2758] = {.lex_state = 92, .external_lex_state = 18},
  [2759] = {.lex_state = 260, .external_lex_state = 18},
  [2760] = {.lex_state = 140, .external_lex_state = 26},
  [2761] = {.lex_state = 262, .external_lex_state = 30},
  [2762] = {.lex_state = 262, .external_lex_state = 18},
  [2763] = {.lex_state = 262, .external_lex_state = 30},
  [2764] = {.lex_state = 262, .external_lex_state = 18},
  [2765] = {.lex_state = 262, .external_lex_state = 18},
  [2766] = {.lex_state = 140, .external_lex_state = 26},
  [2767] = {.lex_state = 262, .external_lex_state = 18},
  [2768] = {.lex_state = 262, .external_lex_state = 18},
  [2769] = {.lex_state = 317},
  [2770] = {.lex_state = 136, .external_lex_state = 12},
  [2771] = {.lex_state = 317},
  [2772] = {.lex_state = 153},
  [2773] = {.lex_state = 268},
  [2774] = {.lex_state = 136, .external_lex_state = 12},
  [2775] = {.lex_state = 136, .external_lex_state = 12},
  [2776] = {.lex_state = 305},
  [2777] = {.lex_state = 136, .external_lex_state = 12},
  [2778] = {.lex_state = 343},
  [2779] = {.lex_state = 102},
  [2780] = {.lex_state = 136, .external_lex_state = 12},
  [2781] = {.lex_state = 343},
  [2782] = {.lex_state = 102},
  [2783] = {.lex_state = 108, .external_lex_state = 11},
  [2784] = {.lex_state = 108, .external_lex_state = 26},
  [2785] = {.lex_state = 108, .external_lex_state = 26},
  [2786] = {.lex_state = 92, .external_lex_state = 29},
  [2787] = {.lex_state = 92, .external_lex_state = 18},
  [2788] = {.lex_state = 92, .external_lex_state = 18},
  [2789] = {.lex_state = 262, .external_lex_state = 18},
  [2790] = {.lex_state = 108, .external_lex_state = 26},
  [2791] = {.lex_state = 262, .external_lex_state = 18},
  [2792] = {.lex_state = 262, .external_lex_state = 18},
  [2793] = {.lex_state = 262, .external_lex_state = 18},
  [2794] = {.lex_state = 108, .external_lex_state = 26},
  [2795] = {.lex_state = 262, .external_lex_state = 18},
  [2796] = {.lex_state = 108, .external_lex_state = 13},
  [2797] = {.lex_state = 108, .external_lex_state = 13},
  [2798] = {.lex_state = 92, .external_lex_state = 29},
  [2799] = {.lex_state = 92, .external_lex_state = 18},
  [2800] = {.lex_state = 92, .external_lex_state = 18},
  [2801] = {.lex_state = 262, .external_lex_state = 18},
  [2802] = {.lex_state = 108, .external_lex_state = 13},
  [2803] = {.lex_state = 262, .external_lex_state = 18},
  [2804] = {.lex_state = 262, .external_lex_state = 18},
  [2805] = {.lex_state = 262, .external_lex_state = 18},
  [2806] = {.lex_state = 108, .external_lex_state = 13},
  [2807] = {.lex_state = 262, .external_lex_state = 18},
  [2808] = {.lex_state = 122, .external_lex_state = 13},
  [2809] = {.lex_state = 122, .external_lex_state = 13},
  [2810] = {.lex_state = 122, .external_lex_state = 13},
  [2811] = {.lex_state = 262, .external_lex_state = 18},
  [2812] = {.lex_state = 262, .external_lex_state = 18},
  [2813] = {.lex_state = 122, .external_lex_state = 13},
  [2814] = {.lex_state = 287, .external_lex_state = 4},
  [2815] = {.lex_state = 215},
  [2816] = {.lex_state = 287, .external_lex_state = 21},
  [2817] = {.lex_state = 287, .external_lex_state = 21},
  [2818] = {.lex_state = 287, .external_lex_state = 21},
  [2819] = {.lex_state = 102},
  [2820] = {.lex_state = 287, .external_lex_state = 21},
  [2821] = {.lex_state = 217},
  [2822] = {.lex_state = 287, .external_lex_state = 21},
  [2823] = {.lex_state = 125},
  [2824] = {.lex_state = 85},
  [2825] = {.lex_state = 223, .external_lex_state = 7},
  [2826] = {.lex_state = 225, .external_lex_state = 18},
  [2827] = {.lex_state = 225, .external_lex_state = 18},
  [2828] = {.lex_state = 85},
  [2829] = {.lex_state = 215, .external_lex_state = 2},
  [2830] = {.lex_state = 78},
  [2831] = {.lex_state = 85},
  [2832] = {.lex_state = 287, .external_lex_state = 4},
  [2833] = {.lex_state = 287, .external_lex_state = 4},
  [2834] = {.lex_state = 275, .external_lex_state = 4},
  [2835] = {.lex_state = 215},
  [2836] = {.lex_state = 275, .external_lex_state = 21},
  [2837] = {.lex_state = 275, .external_lex_state = 4},
  [2838] = {.lex_state = 275, .external_lex_state = 21},
  [2839] = {.lex_state = 102},
  [2840] = {.lex_state = 275, .external_lex_state = 21},
  [2841] = {.lex_state = 275, .external_lex_state = 21},
  [2842] = {.lex_state = 217},
  [2843] = {.lex_state = 260, .external_lex_state = 18},
  [2844] = {.lex_state = 85},
  [2845] = {.lex_state = 225, .external_lex_state = 18},
  [2846] = {.lex_state = 225, .external_lex_state = 18},
  [2847] = {.lex_state = 275, .external_lex_state = 21},
  [2848] = {.lex_state = 262, .external_lex_state = 30},
  [2849] = {.lex_state = 262, .external_lex_state = 18},
  [2850] = {.lex_state = 275, .external_lex_state = 21},
  [2851] = {.lex_state = 262, .external_lex_state = 30},
  [2852] = {.lex_state = 262, .external_lex_state = 18},
  [2853] = {.lex_state = 275, .external_lex_state = 21},
  [2854] = {.lex_state = 275, .external_lex_state = 21},
  [2855] = {.lex_state = 275, .external_lex_state = 6},
  [2856] = {.lex_state = 102},
  [2857] = {.lex_state = 275, .external_lex_state = 6},
  [2858] = {.lex_state = 275, .external_lex_state = 6},
  [2859] = {.lex_state = 217},
  [2860] = {.lex_state = 260, .external_lex_state = 18},
  [2861] = {.lex_state = 85},
  [2862] = {.lex_state = 225, .external_lex_state = 18},
  [2863] = {.lex_state = 225, .external_lex_state = 18},
  [2864] = {.lex_state = 275, .external_lex_state = 6},
  [2865] = {.lex_state = 262, .external_lex_state = 30},
  [2866] = {.lex_state = 262, .external_lex_state = 18},
  [2867] = {.lex_state = 275, .external_lex_state = 6},
  [2868] = {.lex_state = 262, .external_lex_state = 30},
  [2869] = {.lex_state = 262, .external_lex_state = 18},
  [2870] = {.lex_state = 275, .external_lex_state = 6},
  [2871] = {.lex_state = 275, .external_lex_state = 6},
  [2872] = {.lex_state = 368, .external_lex_state = 5},
  [2873] = {.lex_state = 281, .external_lex_state = 6},
  [2874] = {.lex_state = 281, .external_lex_state = 6},
  [2875] = {.lex_state = 92, .external_lex_state = 29},
  [2876] = {.lex_state = 92, .external_lex_state = 18},
  [2877] = {.lex_state = 92, .external_lex_state = 18},
  [2878] = {.lex_state = 260, .external_lex_state = 18},
  [2879] = {.lex_state = 281, .external_lex_state = 6},
  [2880] = {.lex_state = 262, .external_lex_state = 30},
  [2881] = {.lex_state = 262, .external_lex_state = 18},
  [2882] = {.lex_state = 262, .external_lex_state = 30},
  [2883] = {.lex_state = 262, .external_lex_state = 18},
  [2884] = {.lex_state = 262, .external_lex_state = 18},
  [2885] = {.lex_state = 281, .external_lex_state = 6},
  [2886] = {.lex_state = 262, .external_lex_state = 18},
  [2887] = {.lex_state = 262, .external_lex_state = 18},
  [2888] = {.lex_state = 285, .external_lex_state = 6},
  [2889] = {.lex_state = 285, .external_lex_state = 5},
  [2890] = {.lex_state = 370, .external_lex_state = 6},
  [2891] = {.lex_state = 370, .external_lex_state = 6},
  [2892] = {.lex_state = 370, .external_lex_state = 6},
  [2893] = {.lex_state = 102},
  [2894] = {.lex_state = 285, .external_lex_state = 6},
  [2895] = {.lex_state = 217},
  [2896] = {.lex_state = 370, .external_lex_state = 6},
  [2897] = {.lex_state = 125},
  [2898] = {.lex_state = 85},
  [2899] = {.lex_state = 223, .external_lex_state = 7},
  [2900] = {.lex_state = 225, .external_lex_state = 18},
  [2901] = {.lex_state = 225, .external_lex_state = 18},
  [2902] = {.lex_state = 85},
  [2903] = {.lex_state = 215, .external_lex_state = 2},
  [2904] = {.lex_state = 78},
  [2905] = {.lex_state = 85},
  [2906] = {.lex_state = 370, .external_lex_state = 5},
  [2907] = {.lex_state = 285, .external_lex_state = 5},
  [2908] = {.lex_state = 249, .external_lex_state = 2},
  [2909] = {.lex_state = 364, .external_lex_state = 12},
  [2910] = {.lex_state = 308, .external_lex_state = 4},
  [2911] = {.lex_state = 215},
  [2912] = {.lex_state = 308, .external_lex_state = 21},
  [2913] = {.lex_state = 308, .external_lex_state = 21},
  [2914] = {.lex_state = 308, .external_lex_state = 21},
  [2915] = {.lex_state = 102},
  [2916] = {.lex_state = 308, .external_lex_state = 21},
  [2917] = {.lex_state = 217},
  [2918] = {.lex_state = 308, .external_lex_state = 21},
  [2919] = {.lex_state = 125},
  [2920] = {.lex_state = 85},
  [2921] = {.lex_state = 223, .external_lex_state = 7},
  [2922] = {.lex_state = 225, .external_lex_state = 18},
  [2923] = {.lex_state = 225, .external_lex_state = 18},
  [2924] = {.lex_state = 85},
  [2925] = {.lex_state = 215, .external_lex_state = 2},
  [2926] = {.lex_state = 78},
  [2927] = {.lex_state = 85},
  [2928] = {.lex_state = 308, .external_lex_state = 4},
  [2929] = {.lex_state = 308, .external_lex_state = 4},
  [2930] = {.lex_state = 305},
  [2931] = {.lex_state = 332, .external_lex_state = 4},
  [2932] = {.lex_state = 215},
  [2933] = {.lex_state = 112},
  [2934] = {.lex_state = 332, .external_lex_state = 21},
  [2935] = {.lex_state = 125},
  [2936] = {.lex_state = 332, .external_lex_state = 21},
  [2937] = {.lex_state = 112, .external_lex_state = 7},
  [2938] = {.lex_state = 78, .external_lex_state = 2},
  [2939] = {.lex_state = 78, .external_lex_state = 2},
  [2940] = {.lex_state = 78, .external_lex_state = 2},
  [2941] = {.lex_state = 332, .external_lex_state = 4},
  [2942] = {.lex_state = 144, .external_lex_state = 8},
  [2943] = {.lex_state = 324, .external_lex_state = 21},
  [2944] = {.lex_state = 324, .external_lex_state = 21},
  [2945] = {.lex_state = 324, .external_lex_state = 21},
  [2946] = {.lex_state = 102},
  [2947] = {.lex_state = 324, .external_lex_state = 21},
  [2948] = {.lex_state = 217},
  [2949] = {.lex_state = 324, .external_lex_state = 21},
  [2950] = {.lex_state = 125},
  [2951] = {.lex_state = 85},
  [2952] = {.lex_state = 223, .external_lex_state = 7},
  [2953] = {.lex_state = 225, .external_lex_state = 18},
  [2954] = {.lex_state = 225, .external_lex_state = 18},
  [2955] = {.lex_state = 85},
  [2956] = {.lex_state = 215, .external_lex_state = 2},
  [2957] = {.lex_state = 78},
  [2958] = {.lex_state = 85},
  [2959] = {.lex_state = 324, .external_lex_state = 4},
  [2960] = {.lex_state = 324, .external_lex_state = 4},
  [2961] = {.lex_state = 324, .external_lex_state = 4},
  [2962] = {.lex_state = 324, .external_lex_state = 6},
  [2963] = {.lex_state = 324, .external_lex_state = 6},
  [2964] = {.lex_state = 324, .external_lex_state = 6},
  [2965] = {.lex_state = 102},
  [2966] = {.lex_state = 324, .external_lex_state = 6},
  [2967] = {.lex_state = 217},
  [2968] = {.lex_state = 324, .external_lex_state = 6},
  [2969] = {.lex_state = 125},
  [2970] = {.lex_state = 85},
  [2971] = {.lex_state = 223, .external_lex_state = 7},
  [2972] = {.lex_state = 225, .external_lex_state = 18},
  [2973] = {.lex_state = 225, .external_lex_state = 18},
  [2974] = {.lex_state = 85},
  [2975] = {.lex_state = 215, .external_lex_state = 2},
  [2976] = {.lex_state = 78},
  [2977] = {.lex_state = 85},
  [2978] = {.lex_state = 324, .external_lex_state = 5},
  [2979] = {.lex_state = 324, .external_lex_state = 5},
  [2980] = {.lex_state = 324, .external_lex_state = 5},
  [2981] = {.lex_state = 326, .external_lex_state = 6},
  [2982] = {.lex_state = 102},
  [2983] = {.lex_state = 326, .external_lex_state = 6},
  [2984] = {.lex_state = 326, .external_lex_state = 6},
  [2985] = {.lex_state = 217},
  [2986] = {.lex_state = 260, .external_lex_state = 18},
  [2987] = {.lex_state = 85},
  [2988] = {.lex_state = 225, .external_lex_state = 18},
  [2989] = {.lex_state = 225, .external_lex_state = 18},
  [2990] = {.lex_state = 326, .external_lex_state = 6},
  [2991] = {.lex_state = 262, .external_lex_state = 30},
  [2992] = {.lex_state = 262, .external_lex_state = 18},
  [2993] = {.lex_state = 326, .external_lex_state = 6},
  [2994] = {.lex_state = 262, .external_lex_state = 30},
  [2995] = {.lex_state = 262, .external_lex_state = 18},
  [2996] = {.lex_state = 326, .external_lex_state = 6},
  [2997] = {.lex_state = 326, .external_lex_state = 6},
  [2998] = {.lex_state = 102},
  [2999] = {.lex_state = 330, .external_lex_state = 5},
  [3000] = {.lex_state = 332, .external_lex_state = 4},
  [3001] = {.lex_state = 330, .external_lex_state = 5},
  [3002] = {.lex_state = 332, .external_lex_state = 4},
  [3003] = {.lex_state = 330, .external_lex_state = 6},
  [3004] = {.lex_state = 330, .external_lex_state = 6},
  [3005] = {.lex_state = 330, .external_lex_state = 5},
  [3006] = {.lex_state = 330, .external_lex_state = 6},
  [3007] = {.lex_state = 330, .external_lex_state = 5},
  [3008] = {.lex_state = 289, .external_lex_state = 2},
  [3009] = {.lex_state = 330, .external_lex_state = 5},
  [3010] = {.lex_state = 326, .external_lex_state = 5},
  [3011] = {.lex_state = 326, .external_lex_state = 6},
  [3012] = {.lex_state = 326, .external_lex_state = 5},
  [3013] = {.lex_state = 326, .external_lex_state = 5},
  [3014] = {.lex_state = 289, .external_lex_state = 2},
  [3015] = {.lex_state = 334, .external_lex_state = 9},
  [3016] = {.lex_state = 326, .external_lex_state = 5},
  [3017] = {.lex_state = 291, .external_lex_state = 4},
  [3018] = {.lex_state = 215},
  [3019] = {.lex_state = 291, .external_lex_state = 21},
  [3020] = {.lex_state = 291, .external_lex_state = 4},
  [3021] = {.lex_state = 291, .external_lex_state = 21},
  [3022] = {.lex_state = 102},
  [3023] = {.lex_state = 291, .external_lex_state = 21},
  [3024] = {.lex_state = 291, .external_lex_state = 21},
  [3025] = {.lex_state = 217},
  [3026] = {.lex_state = 260, .external_lex_state = 18},
  [3027] = {.lex_state = 85},
  [3028] = {.lex_state = 225, .external_lex_state = 18},
  [3029] = {.lex_state = 225, .external_lex_state = 18},
  [3030] = {.lex_state = 291, .external_lex_state = 21},
  [3031] = {.lex_state = 262, .external_lex_state = 30},
  [3032] = {.lex_state = 262, .external_lex_state = 18},
  [3033] = {.lex_state = 291, .external_lex_state = 21},
  [3034] = {.lex_state = 262, .external_lex_state = 30},
  [3035] = {.lex_state = 262, .external_lex_state = 18},
  [3036] = {.lex_state = 291, .external_lex_state = 21},
  [3037] = {.lex_state = 291, .external_lex_state = 21},
  [3038] = {.lex_state = 291, .external_lex_state = 6},
  [3039] = {.lex_state = 102},
  [3040] = {.lex_state = 291, .external_lex_state = 6},
  [3041] = {.lex_state = 291, .external_lex_state = 6},
  [3042] = {.lex_state = 217},
  [3043] = {.lex_state = 260, .external_lex_state = 18},
  [3044] = {.lex_state = 85},
  [3045] = {.lex_state = 225, .external_lex_state = 18},
  [3046] = {.lex_state = 225, .external_lex_state = 18},
  [3047] = {.lex_state = 291, .external_lex_state = 6},
  [3048] = {.lex_state = 262, .external_lex_state = 30},
  [3049] = {.lex_state = 262, .external_lex_state = 18},
  [3050] = {.lex_state = 291, .external_lex_state = 6},
  [3051] = {.lex_state = 262, .external_lex_state = 30},
  [3052] = {.lex_state = 262, .external_lex_state = 18},
  [3053] = {.lex_state = 291, .external_lex_state = 6},
  [3054] = {.lex_state = 291, .external_lex_state = 6},
  [3055] = {.lex_state = 372, .external_lex_state = 5},
  [3056] = {.lex_state = 301, .external_lex_state = 6},
  [3057] = {.lex_state = 301, .external_lex_state = 6},
  [3058] = {.lex_state = 92, .external_lex_state = 29},
  [3059] = {.lex_state = 92, .external_lex_state = 18},
  [3060] = {.lex_state = 92, .external_lex_state = 18},
  [3061] = {.lex_state = 260, .external_lex_state = 18},
  [3062] = {.lex_state = 301, .external_lex_state = 6},
  [3063] = {.lex_state = 262, .external_lex_state = 30},
  [3064] = {.lex_state = 262, .external_lex_state = 18},
  [3065] = {.lex_state = 262, .external_lex_state = 30},
  [3066] = {.lex_state = 262, .external_lex_state = 18},
  [3067] = {.lex_state = 262, .external_lex_state = 18},
  [3068] = {.lex_state = 301, .external_lex_state = 6},
  [3069] = {.lex_state = 262, .external_lex_state = 18},
  [3070] = {.lex_state = 262, .external_lex_state = 18},
  [3071] = {.lex_state = 186, .external_lex_state = 5},
  [3072] = {.lex_state = 305, .external_lex_state = 6},
  [3073] = {.lex_state = 305, .external_lex_state = 5},
  [3074] = {.lex_state = 305, .external_lex_state = 6},
  [3075] = {.lex_state = 305, .external_lex_state = 5},
  [3076] = {.lex_state = 255, .external_lex_state = 2},
  [3077] = {.lex_state = 102},
  [3078] = {.lex_state = 340, .external_lex_state = 10},
  [3079] = {.lex_state = 340, .external_lex_state = 10},
  [3080] = {.lex_state = 340},
  [3081] = {.lex_state = 340},
  [3082] = {.lex_state = 85},
  [3083] = {.lex_state = 310},
  [3084] = {.lex_state = 106, .external_lex_state = 2},
  [3085] = {.lex_state = 374, .external_lex_state = 4},
  [3086] = {.lex_state = 374, .external_lex_state = 5},
  [3087] = {.lex_state = 112},
  [3088] = {.lex_state = 380, .external_lex_state = 6},
  [3089] = {.lex_state = 125},
  [3090] = {.lex_state = 380, .external_lex_state = 6},
  [3091] = {.lex_state = 112, .external_lex_state = 7},
  [3092] = {.lex_state = 78, .external_lex_state = 2},
  [3093] = {.lex_state = 78, .external_lex_state = 2},
  [3094] = {.lex_state = 78, .external_lex_state = 2},
  [3095] = {.lex_state = 382, .external_lex_state = 6},
  [3096] = {.lex_state = 343},
  [3097] = {.lex_state = 343, .external_lex_state = 5},
  [3098] = {.lex_state = 380, .external_lex_state = 5},
  [3099] = {.lex_state = 384, .external_lex_state = 4},
  [3100] = {.lex_state = 85},
  [3101] = {.lex_state = 380, .external_lex_state = 5},
  [3102] = {.lex_state = 78, .external_lex_state = 2},
  [3103] = {.lex_state = 102, .external_lex_state = 2},
  [3104] = {.lex_state = 380, .external_lex_state = 5},
  [3105] = {.lex_state = 358, .external_lex_state = 2},
  [3106] = {.lex_state = 340},
  [3107] = {.lex_state = 186, .external_lex_state = 5},
  [3108] = {.lex_state = 340, .external_lex_state = 10},
  [3109] = {.lex_state = 340},
  [3110] = {.lex_state = 340},
  [3111] = {.lex_state = 310},
  [3112] = {.lex_state = 343},
  [3113] = {.lex_state = 358, .external_lex_state = 2},
  [3114] = {.lex_state = 343},
  [3115] = {.lex_state = 149, .external_lex_state = 14},
  [3116] = {.lex_state = 149, .external_lex_state = 14},
  [3117] = {.lex_state = 149, .external_lex_state = 14},
  [3118] = {.lex_state = 262, .external_lex_state = 18},
  [3119] = {.lex_state = 262, .external_lex_state = 18},
  [3120] = {.lex_state = 149, .external_lex_state = 14},
  [3121] = {.lex_state = 186, .external_lex_state = 5},
  [3122] = {.lex_state = 343},
  [3123] = {.lex_state = 360, .external_lex_state = 15},
  [3124] = {.lex_state = 207, .external_lex_state = 27},
  [3125] = {.lex_state = 207, .external_lex_state = 27},
  [3126] = {.lex_state = 92, .external_lex_state = 29},
  [3127] = {.lex_state = 92, .external_lex_state = 18},
  [3128] = {.lex_state = 92, .external_lex_state = 18},
  [3129] = {.lex_state = 260, .external_lex_state = 18},
  [3130] = {.lex_state = 207, .external_lex_state = 27},
  [3131] = {.lex_state = 262, .external_lex_state = 30},
  [3132] = {.lex_state = 262, .external_lex_state = 18},
  [3133] = {.lex_state = 262, .external_lex_state = 30},
  [3134] = {.lex_state = 262, .external_lex_state = 18},
  [3135] = {.lex_state = 262, .external_lex_state = 18},
  [3136] = {.lex_state = 207, .external_lex_state = 27},
  [3137] = {.lex_state = 262, .external_lex_state = 18},
  [3138] = {.lex_state = 262, .external_lex_state = 18},
  [3139] = {.lex_state = 317},
  [3140] = {.lex_state = 205, .external_lex_state = 16},
  [3141] = {.lex_state = 317},
  [3142] = {.lex_state = 153},
  [3143] = {.lex_state = 268},
  [3144] = {.lex_state = 205, .external_lex_state = 16},
  [3145] = {.lex_state = 205, .external_lex_state = 16},
  [3146] = {.lex_state = 305},
  [3147] = {.lex_state = 205, .external_lex_state = 16},
  [3148] = {.lex_state = 343},
  [3149] = {.lex_state = 102},
  [3150] = {.lex_state = 205, .external_lex_state = 16},
  [3151] = {.lex_state = 343},
  [3152] = {.lex_state = 102},
  [3153] = {.lex_state = 199, .external_lex_state = 15},
  [3154] = {.lex_state = 199, .external_lex_state = 27},
  [3155] = {.lex_state = 199, .external_lex_state = 27},
  [3156] = {.lex_state = 92, .external_lex_state = 29},
  [3157] = {.lex_state = 92, .external_lex_state = 18},
  [3158] = {.lex_state = 92, .external_lex_state = 18},
  [3159] = {.lex_state = 262, .external_lex_state = 18},
  [3160] = {.lex_state = 199, .external_lex_state = 27},
  [3161] = {.lex_state = 262, .external_lex_state = 18},
  [3162] = {.lex_state = 262, .external_lex_state = 18},
  [3163] = {.lex_state = 262, .external_lex_state = 18},
  [3164] = {.lex_state = 199, .external_lex_state = 27},
  [3165] = {.lex_state = 262, .external_lex_state = 18},
  [3166] = {.lex_state = 199, .external_lex_state = 17},
  [3167] = {.lex_state = 199, .external_lex_state = 17},
  [3168] = {.lex_state = 92, .external_lex_state = 29},
  [3169] = {.lex_state = 92, .external_lex_state = 18},
  [3170] = {.lex_state = 92, .external_lex_state = 18},
  [3171] = {.lex_state = 262, .external_lex_state = 18},
  [3172] = {.lex_state = 199, .external_lex_state = 17},
  [3173] = {.lex_state = 262, .external_lex_state = 18},
  [3174] = {.lex_state = 262, .external_lex_state = 18},
  [3175] = {.lex_state = 262, .external_lex_state = 18},
  [3176] = {.lex_state = 199, .external_lex_state = 17},
  [3177] = {.lex_state = 262, .external_lex_state = 18},
  [3178] = {.lex_state = 201, .external_lex_state = 17},
  [3179] = {.lex_state = 201, .external_lex_state = 17},
  [3180] = {.lex_state = 201, .external_lex_state = 17},
  [3181] = {.lex_state = 262, .external_lex_state = 18},
  [3182] = {.lex_state = 262, .external_lex_state = 18},
  [3183] = {.lex_state = 201, .external_lex_state = 17},
  [3184] = {.lex_state = 386, .external_lex_state = 16},
  [3185] = {.lex_state = 209, .external_lex_state = 19},
  [3186] = {.lex_state = 209, .external_lex_state = 19},
  [3187] = {.lex_state = 209, .external_lex_state = 19},
  [3188] = {.lex_state = 262, .external_lex_state = 18},
  [3189] = {.lex_state = 262, .external_lex_state = 18},
  [3190] = {.lex_state = 209, .external_lex_state = 19},
  [3191] = {.lex_state = 178, .external_lex_state = 21},
  [3192] = {.lex_state = 178, .external_lex_state = 21},
  [3193] = {.lex_state = 178, .external_lex_state = 21},
  [3194] = {.lex_state = 262, .external_lex_state = 18},
  [3195] = {.lex_state = 262, .external_lex_state = 18},
  [3196] = {.lex_state = 178, .external_lex_state = 21},
  [3197] = {.lex_state = 178, .external_lex_state = 6},
  [3198] = {.lex_state = 178, .external_lex_state = 6},
  [3199] = {.lex_state = 178, .external_lex_state = 6},
  [3200] = {.lex_state = 262, .external_lex_state = 18},
  [3201] = {.lex_state = 262, .external_lex_state = 18},
  [3202] = {.lex_state = 178, .external_lex_state = 6},
  [3203] = {.lex_state = 215, .external_lex_state = 22},
  [3204] = {.lex_state = 215, .external_lex_state = 22},
  [3205] = {.lex_state = 215, .external_lex_state = 22},
  [3206] = {.lex_state = 262, .external_lex_state = 18},
  [3207] = {.lex_state = 262, .external_lex_state = 18},
  [3208] = {.lex_state = 215, .external_lex_state = 22},
  [3209] = {.lex_state = 125, .external_lex_state = 10},
  [3210] = {.lex_state = 125, .external_lex_state = 10},
  [3211] = {.lex_state = 125, .external_lex_state = 10},
  [3212] = {.lex_state = 262, .external_lex_state = 18},
  [3213] = {.lex_state = 262, .external_lex_state = 18},
  [3214] = {.lex_state = 125, .external_lex_state = 10},
  [3215] = {.lex_state = 225, .external_lex_state = 18},
  [3216] = {.lex_state = 225, .external_lex_state = 18},
  [3217] = {.lex_state = 112, .external_lex_state = 18},
  [3218] = {.lex_state = 92, .external_lex_state = 29},
  [3219] = {.lex_state = 92, .external_lex_state = 29},
  [3220] = {.lex_state = 92, .external_lex_state = 29},
  [3221] = {.lex_state = 92, .external_lex_state = 18},
  [3222] = {.lex_state = 92, .external_lex_state = 18},
  [3223] = {.lex_state = 260, .external_lex_state = 18},
  [3224] = {.lex_state = 92, .external_lex_state = 29},
  [3225] = {.lex_state = 262, .external_lex_state = 30},
  [3226] = {.lex_state = 262, .external_lex_state = 18},
  [3227] = {.lex_state = 262, .external_lex_state = 30},
  [3228] = {.lex_state = 262, .external_lex_state = 18},
  [3229] = {.lex_state = 262, .external_lex_state = 18},
  [3230] = {.lex_state = 92, .external_lex_state = 29},
  [3231] = {.lex_state = 262, .external_lex_state = 18},
  [3232] = {.lex_state = 262, .external_lex_state = 18},
  [3233] = {.lex_state = 142, .external_lex_state = 6},
  [3234] = {.lex_state = 142, .external_lex_state = 6},
  [3235] = {.lex_state = 262, .external_lex_state = 29},
  [3236] = {.lex_state = 262, .external_lex_state = 29},
  [3237] = {.lex_state = 92, .external_lex_state = 29},
  [3238] = {.lex_state = 92, .external_lex_state = 18},
  [3239] = {.lex_state = 92, .external_lex_state = 18},
  [3240] = {.lex_state = 262, .external_lex_state = 18},
  [3241] = {.lex_state = 262, .external_lex_state = 29},
  [3242] = {.lex_state = 262, .external_lex_state = 18},
  [3243] = {.lex_state = 262, .external_lex_state = 18},
  [3244] = {.lex_state = 262, .external_lex_state = 18},
  [3245] = {.lex_state = 262, .external_lex_state = 29},
  [3246] = {.lex_state = 262, .external_lex_state = 18},
  [3247] = {.lex_state = 96, .external_lex_state = 23},
  [3248] = {.lex_state = 96, .external_lex_state = 23},
  [3249] = {.lex_state = 92, .external_lex_state = 29},
  [3250] = {.lex_state = 92, .external_lex_state = 18},
  [3251] = {.lex_state = 92, .external_lex_state = 18},
  [3252] = {.lex_state = 262, .external_lex_state = 18},
  [3253] = {.lex_state = 96, .external_lex_state = 23},
  [3254] = {.lex_state = 262, .external_lex_state = 18},
  [3255] = {.lex_state = 262, .external_lex_state = 18},
  [3256] = {.lex_state = 262, .external_lex_state = 18},
  [3257] = {.lex_state = 96, .external_lex_state = 23},
  [3258] = {.lex_state = 262, .external_lex_state = 18},
  [3259] = {.lex_state = 136, .external_lex_state = 6},
  [3260] = {.lex_state = 215, .external_lex_state = 10},
  [3261] = {.lex_state = 215, .external_lex_state = 10},
  [3262] = {.lex_state = 92, .external_lex_state = 29},
  [3263] = {.lex_state = 92, .external_lex_state = 18},
  [3264] = {.lex_state = 92, .external_lex_state = 18},
  [3265] = {.lex_state = 262, .external_lex_state = 18},
  [3266] = {.lex_state = 215, .external_lex_state = 10},
  [3267] = {.lex_state = 262, .external_lex_state = 18},
  [3268] = {.lex_state = 262, .external_lex_state = 18},
  [3269] = {.lex_state = 262, .external_lex_state = 18},
  [3270] = {.lex_state = 215, .external_lex_state = 10},
  [3271] = {.lex_state = 262, .external_lex_state = 18},
  [3272] = {.lex_state = 184, .external_lex_state = 21},
  [3273] = {.lex_state = 184, .external_lex_state = 21},
  [3274] = {.lex_state = 184, .external_lex_state = 21},
  [3275] = {.lex_state = 262, .external_lex_state = 18},
  [3276] = {.lex_state = 262, .external_lex_state = 18},
  [3277] = {.lex_state = 184, .external_lex_state = 21},
  [3278] = {.lex_state = 186, .external_lex_state = 5},
  [3279] = {.lex_state = 317},
  [3280] = {.lex_state = 241, .external_lex_state = 14},
  [3281] = {.lex_state = 241, .external_lex_state = 14},
  [3282] = {.lex_state = 241, .external_lex_state = 14},
  [3283] = {.lex_state = 262, .external_lex_state = 18},
  [3284] = {.lex_state = 262, .external_lex_state = 18},
  [3285] = {.lex_state = 241, .external_lex_state = 14},
  [3286] = {.lex_state = 317},
  [3287] = {.lex_state = 270, .external_lex_state = 14},
  [3288] = {.lex_state = 270, .external_lex_state = 14},
  [3289] = {.lex_state = 92, .external_lex_state = 29},
  [3290] = {.lex_state = 92, .external_lex_state = 18},
  [3291] = {.lex_state = 92, .external_lex_state = 18},
  [3292] = {.lex_state = 262, .external_lex_state = 18},
  [3293] = {.lex_state = 270, .external_lex_state = 14},
  [3294] = {.lex_state = 262, .external_lex_state = 18},
  [3295] = {.lex_state = 262, .external_lex_state = 18},
  [3296] = {.lex_state = 262, .external_lex_state = 18},
  [3297] = {.lex_state = 270, .external_lex_state = 14},
  [3298] = {.lex_state = 262, .external_lex_state = 18},
  [3299] = {.lex_state = 272, .external_lex_state = 10},
  [3300] = {.lex_state = 272, .external_lex_state = 10},
  [3301] = {.lex_state = 272, .external_lex_state = 10},
  [3302] = {.lex_state = 262, .external_lex_state = 18},
  [3303] = {.lex_state = 262, .external_lex_state = 18},
  [3304] = {.lex_state = 272, .external_lex_state = 10},
  [3305] = {.lex_state = 246, .external_lex_state = 10},
  [3306] = {.lex_state = 246, .external_lex_state = 10},
  [3307] = {.lex_state = 140, .external_lex_state = 26},
  [3308] = {.lex_state = 140, .external_lex_state = 26},
  [3309] = {.lex_state = 92, .external_lex_state = 29},
  [3310] = {.lex_state = 92, .external_lex_state = 18},
  [3311] = {.lex_state = 92, .external_lex_state = 18},
  [3312] = {.lex_state = 262, .external_lex_state = 18},
  [3313] = {.lex_state = 140, .external_lex_state = 26},
  [3314] = {.lex_state = 262, .external_lex_state = 18},
  [3315] = {.lex_state = 262, .external_lex_state = 18},
  [3316] = {.lex_state = 262, .external_lex_state = 18},
  [3317] = {.lex_state = 140, .external_lex_state = 26},
  [3318] = {.lex_state = 262, .external_lex_state = 18},
  [3319] = {.lex_state = 136, .external_lex_state = 12},
  [3320] = {.lex_state = 317},
  [3321] = {.lex_state = 317},
  [3322] = {.lex_state = 153},
  [3323] = {.lex_state = 136, .external_lex_state = 12},
  [3324] = {.lex_state = 136, .external_lex_state = 12},
  [3325] = {.lex_state = 343},
  [3326] = {.lex_state = 136, .external_lex_state = 12},
  [3327] = {.lex_state = 343},
  [3328] = {.lex_state = 108, .external_lex_state = 26},
  [3329] = {.lex_state = 108, .external_lex_state = 26},
  [3330] = {.lex_state = 108, .external_lex_state = 26},
  [3331] = {.lex_state = 262, .external_lex_state = 18},
  [3332] = {.lex_state = 262, .external_lex_state = 18},
  [3333] = {.lex_state = 108, .external_lex_state = 26},
  [3334] = {.lex_state = 108, .external_lex_state = 13},
  [3335] = {.lex_state = 108, .external_lex_state = 13},
  [3336] = {.lex_state = 108, .external_lex_state = 13},
  [3337] = {.lex_state = 262, .external_lex_state = 18},
  [3338] = {.lex_state = 262, .external_lex_state = 18},
  [3339] = {.lex_state = 108, .external_lex_state = 13},
  [3340] = {.lex_state = 122, .external_lex_state = 13},
  [3341] = {.lex_state = 122, .external_lex_state = 13},
  [3342] = {.lex_state = 287, .external_lex_state = 4},
  [3343] = {.lex_state = 287, .external_lex_state = 21},
  [3344] = {.lex_state = 102},
  [3345] = {.lex_state = 287, .external_lex_state = 21},
  [3346] = {.lex_state = 287, .external_lex_state = 21},
  [3347] = {.lex_state = 217},
  [3348] = {.lex_state = 260, .external_lex_state = 18},
  [3349] = {.lex_state = 85},
  [3350] = {.lex_state = 225, .external_lex_state = 18},
  [3351] = {.lex_state = 225, .external_lex_state = 18},
  [3352] = {.lex_state = 287, .external_lex_state = 21},
  [3353] = {.lex_state = 262, .external_lex_state = 30},
  [3354] = {.lex_state = 262, .external_lex_state = 18},
  [3355] = {.lex_state = 287, .external_lex_state = 21},
  [3356] = {.lex_state = 262, .external_lex_state = 30},
  [3357] = {.lex_state = 262, .external_lex_state = 18},
  [3358] = {.lex_state = 287, .external_lex_state = 21},
  [3359] = {.lex_state = 287, .external_lex_state = 21},
  [3360] = {.lex_state = 275, .external_lex_state = 4},
  [3361] = {.lex_state = 215},
  [3362] = {.lex_state = 388, .external_lex_state = 4},
  [3363] = {.lex_state = 275, .external_lex_state = 21},
  [3364] = {.lex_state = 275, .external_lex_state = 21},
  [3365] = {.lex_state = 92, .external_lex_state = 29},
  [3366] = {.lex_state = 92, .external_lex_state = 18},
  [3367] = {.lex_state = 92, .external_lex_state = 18},
  [3368] = {.lex_state = 260, .external_lex_state = 18},
  [3369] = {.lex_state = 275, .external_lex_state = 21},
  [3370] = {.lex_state = 262, .external_lex_state = 30},
  [3371] = {.lex_state = 262, .external_lex_state = 18},
  [3372] = {.lex_state = 262, .external_lex_state = 30},
  [3373] = {.lex_state = 262, .external_lex_state = 18},
  [3374] = {.lex_state = 262, .external_lex_state = 18},
  [3375] = {.lex_state = 275, .external_lex_state = 21},
  [3376] = {.lex_state = 262, .external_lex_state = 18},
  [3377] = {.lex_state = 262, .external_lex_state = 18},
  [3378] = {.lex_state = 388, .external_lex_state = 5},
  [3379] = {.lex_state = 275, .external_lex_state = 6},
  [3380] = {.lex_state = 275, .external_lex_state = 6},
  [3381] = {.lex_state = 92, .external_lex_state = 29},
  [3382] = {.lex_state = 92, .external_lex_state = 18},
  [3383] = {.lex_state = 92, .external_lex_state = 18},
  [3384] = {.lex_state = 260, .external_lex_state = 18},
  [3385] = {.lex_state = 275, .external_lex_state = 6},
  [3386] = {.lex_state = 262, .external_lex_state = 30},
  [3387] = {.lex_state = 262, .external_lex_state = 18},
  [3388] = {.lex_state = 262, .external_lex_state = 30},
  [3389] = {.lex_state = 262, .external_lex_state = 18},
  [3390] = {.lex_state = 262, .external_lex_state = 18},
  [3391] = {.lex_state = 275, .external_lex_state = 6},
  [3392] = {.lex_state = 262, .external_lex_state = 18},
  [3393] = {.lex_state = 262, .external_lex_state = 18},
  [3394] = {.lex_state = 281, .external_lex_state = 6},
  [3395] = {.lex_state = 281, .external_lex_state = 6},
  [3396] = {.lex_state = 92, .external_lex_state = 29},
  [3397] = {.lex_state = 92, .external_lex_state = 18},
  [3398] = {.lex_state = 92, .external_lex_state = 18},
  [3399] = {.lex_state = 262, .external_lex_state = 18},
  [3400] = {.lex_state = 281, .external_lex_state = 6},
  [3401] = {.lex_state = 262, .external_lex_state = 18},
  [3402] = {.lex_state = 262, .external_lex_state = 18},
  [3403] = {.lex_state = 262, .external_lex_state = 18},
  [3404] = {.lex_state = 281, .external_lex_state = 6},
  [3405] = {.lex_state = 262, .external_lex_state = 18},
  [3406] = {.lex_state = 370, .external_lex_state = 6},
  [3407] = {.lex_state = 102},
  [3408] = {.lex_state = 285, .external_lex_state = 6},
  [3409] = {.lex_state = 370, .external_lex_state = 6},
  [3410] = {.lex_state = 217},
  [3411] = {.lex_state = 260, .external_lex_state = 18},
  [3412] = {.lex_state = 85},
  [3413] = {.lex_state = 225, .external_lex_state = 18},
  [3414] = {.lex_state = 225, .external_lex_state = 18},
  [3415] = {.lex_state = 370, .external_lex_state = 6},
  [3416] = {.lex_state = 262, .external_lex_state = 30},
  [3417] = {.lex_state = 262, .external_lex_state = 18},
  [3418] = {.lex_state = 370, .external_lex_state = 6},
  [3419] = {.lex_state = 262, .external_lex_state = 30},
  [3420] = {.lex_state = 262, .external_lex_state = 18},
  [3421] = {.lex_state = 370, .external_lex_state = 6},
  [3422] = {.lex_state = 370, .external_lex_state = 6},
  [3423] = {.lex_state = 308, .external_lex_state = 4},
  [3424] = {.lex_state = 308, .external_lex_state = 21},
  [3425] = {.lex_state = 102},
  [3426] = {.lex_state = 308, .external_lex_state = 21},
  [3427] = {.lex_state = 308, .external_lex_state = 21},
  [3428] = {.lex_state = 217},
  [3429] = {.lex_state = 260, .external_lex_state = 18},
  [3430] = {.lex_state = 85},
  [3431] = {.lex_state = 225, .external_lex_state = 18},
  [3432] = {.lex_state = 225, .external_lex_state = 18},
  [3433] = {.lex_state = 308, .external_lex_state = 21},
  [3434] = {.lex_state = 262, .external_lex_state = 30},
  [3435] = {.lex_state = 262, .external_lex_state = 18},
  [3436] = {.lex_state = 308, .external_lex_state = 21},
  [3437] = {.lex_state = 262, .external_lex_state = 30},
  [3438] = {.lex_state = 262, .external_lex_state = 18},
  [3439] = {.lex_state = 308, .external_lex_state = 21},
  [3440] = {.lex_state = 308, .external_lex_state = 21},
  [3441] = {.lex_state = 332, .external_lex_state = 4},
  [3442] = {.lex_state = 215},
  [3443] = {.lex_state = 332, .external_lex_state = 21},
  [3444] = {.lex_state = 332, .external_lex_state = 21},
  [3445] = {.lex_state = 332, .external_lex_state = 21},
  [3446] = {.lex_state = 102},
  [3447] = {.lex_state = 332, .external_lex_state = 21},
  [3448] = {.lex_state = 217},
  [3449] = {.lex_state = 332, .external_lex_state = 21},
  [3450] = {.lex_state = 125},
  [3451] = {.lex_state = 85},
  [3452] = {.lex_state = 223, .external_lex_state = 7},
  [3453] = {.lex_state = 225, .external_lex_state = 18},
  [3454] = {.lex_state = 225, .external_lex_state = 18},
  [3455] = {.lex_state = 85},
  [3456] = {.lex_state = 215, .external_lex_state = 2},
  [3457] = {.lex_state = 78},
  [3458] = {.lex_state = 85},
  [3459] = {.lex_state = 332, .external_lex_state = 4},
  [3460] = {.lex_state = 332, .external_lex_state = 4},
  [3461] = {.lex_state = 324, .external_lex_state = 4},
  [3462] = {.lex_state = 215},
  [3463] = {.lex_state = 324, .external_lex_state = 21},
  [3464] = {.lex_state = 324, .external_lex_state = 4},
  [3465] = {.lex_state = 324, .external_lex_state = 21},
  [3466] = {.lex_state = 102},
  [3467] = {.lex_state = 324, .external_lex_state = 21},
  [3468] = {.lex_state = 324, .external_lex_state = 21},
  [3469] = {.lex_state = 217},
  [3470] = {.lex_state = 260, .external_lex_state = 18},
  [3471] = {.lex_state = 85},
  [3472] = {.lex_state = 225, .external_lex_state = 18},
  [3473] = {.lex_state = 225, .external_lex_state = 18},
  [3474] = {.lex_state = 324, .external_lex_state = 21},
  [3475] = {.lex_state = 262, .external_lex_state = 30},
  [3476] = {.lex_state = 262, .external_lex_state = 18},
  [3477] = {.lex_state = 324, .external_lex_state = 21},
  [3478] = {.lex_state = 262, .external_lex_state = 30},
  [3479] = {.lex_state = 262, .external_lex_state = 18},
  [3480] = {.lex_state = 324, .external_lex_state = 21},
  [3481] = {.lex_state = 324, .external_lex_state = 21},
  [3482] = {.lex_state = 324, .external_lex_state = 6},
  [3483] = {.lex_state = 102},
  [3484] = {.lex_state = 324, .external_lex_state = 6},
  [3485] = {.lex_state = 324, .external_lex_state = 6},
  [3486] = {.lex_state = 217},
  [3487] = {.lex_state = 260, .external_lex_state = 18},
  [3488] = {.lex_state = 85},
  [3489] = {.lex_state = 225, .external_lex_state = 18},
  [3490] = {.lex_state = 225, .external_lex_state = 18},
  [3491] = {.lex_state = 324, .external_lex_state = 6},
  [3492] = {.lex_state = 262, .external_lex_state = 30},
  [3493] = {.lex_state = 262, .external_lex_state = 18},
  [3494] = {.lex_state = 324, .external_lex_state = 6},
  [3495] = {.lex_state = 262, .external_lex_state = 30},
  [3496] = {.lex_state = 262, .external_lex_state = 18},
  [3497] = {.lex_state = 324, .external_lex_state = 6},
  [3498] = {.lex_state = 324, .external_lex_state = 6},
  [3499] = {.lex_state = 390, .external_lex_state = 5},
  [3500] = {.lex_state = 326, .external_lex_state = 6},
  [3501] = {.lex_state = 326, .external_lex_state = 6},
  [3502] = {.lex_state = 92, .external_lex_state = 29},
  [3503] = {.lex_state = 92, .external_lex_state = 18},
  [3504] = {.lex_state = 92, .external_lex_state = 18},
  [3505] = {.lex_state = 260, .external_lex_state = 18},
  [3506] = {.lex_state = 326, .external_lex_state = 6},
  [3507] = {.lex_state = 262, .external_lex_state = 30},
  [3508] = {.lex_state = 262, .external_lex_state = 18},
  [3509] = {.lex_state = 262, .external_lex_state = 30},
  [3510] = {.lex_state = 262, .external_lex_state = 18},
  [3511] = {.lex_state = 262, .external_lex_state = 18},
  [3512] = {.lex_state = 326, .external_lex_state = 6},
  [3513] = {.lex_state = 262, .external_lex_state = 18},
  [3514] = {.lex_state = 262, .external_lex_state = 18},
  [3515] = {.lex_state = 330, .external_lex_state = 6},
  [3516] = {.lex_state = 330, .external_lex_state = 5},
  [3517] = {.lex_state = 330, .external_lex_state = 6},
  [3518] = {.lex_state = 330, .external_lex_state = 5},
  [3519] = {.lex_state = 289, .external_lex_state = 2},
  [3520] = {.lex_state = 291, .external_lex_state = 4},
  [3521] = {.lex_state = 215},
  [3522] = {.lex_state = 392, .external_lex_state = 4},
  [3523] = {.lex_state = 291, .external_lex_state = 21},
  [3524] = {.lex_state = 291, .external_lex_state = 21},
  [3525] = {.lex_state = 92, .external_lex_state = 29},
  [3526] = {.lex_state = 92, .external_lex_state = 18},
  [3527] = {.lex_state = 92, .external_lex_state = 18},
  [3528] = {.lex_state = 260, .external_lex_state = 18},
  [3529] = {.lex_state = 291, .external_lex_state = 21},
  [3530] = {.lex_state = 262, .external_lex_state = 30},
  [3531] = {.lex_state = 262, .external_lex_state = 18},
  [3532] = {.lex_state = 262, .external_lex_state = 30},
  [3533] = {.lex_state = 262, .external_lex_state = 18},
  [3534] = {.lex_state = 262, .external_lex_state = 18},
  [3535] = {.lex_state = 291, .external_lex_state = 21},
  [3536] = {.lex_state = 262, .external_lex_state = 18},
  [3537] = {.lex_state = 262, .external_lex_state = 18},
  [3538] = {.lex_state = 392, .external_lex_state = 5},
  [3539] = {.lex_state = 291, .external_lex_state = 6},
  [3540] = {.lex_state = 291, .external_lex_state = 6},
  [3541] = {.lex_state = 92, .external_lex_state = 29},
  [3542] = {.lex_state = 92, .external_lex_state = 18},
  [3543] = {.lex_state = 92, .external_lex_state = 18},
  [3544] = {.lex_state = 260, .external_lex_state = 18},
  [3545] = {.lex_state = 291, .external_lex_state = 6},
  [3546] = {.lex_state = 262, .external_lex_state = 30},
  [3547] = {.lex_state = 262, .external_lex_state = 18},
  [3548] = {.lex_state = 262, .external_lex_state = 30},
  [3549] = {.lex_state = 262, .external_lex_state = 18},
  [3550] = {.lex_state = 262, .external_lex_state = 18},
  [3551] = {.lex_state = 291, .external_lex_state = 6},
  [3552] = {.lex_state = 262, .external_lex_state = 18},
  [3553] = {.lex_state = 262, .external_lex_state = 18},
  [3554] = {.lex_state = 301, .external_lex_state = 6},
  [3555] = {.lex_state = 301, .external_lex_state = 6},
  [3556] = {.lex_state = 92, .external_lex_state = 29},
  [3557] = {.lex_state = 92, .external_lex_state = 18},
  [3558] = {.lex_state = 92, .external_lex_state = 18},
  [3559] = {.lex_state = 262, .external_lex_state = 18},
  [3560] = {.lex_state = 301, .external_lex_state = 6},
  [3561] = {.lex_state = 262, .external_lex_state = 18},
  [3562] = {.lex_state = 262, .external_lex_state = 18},
  [3563] = {.lex_state = 262, .external_lex_state = 18},
  [3564] = {.lex_state = 301, .external_lex_state = 6},
  [3565] = {.lex_state = 262, .external_lex_state = 18},
  [3566] = {.lex_state = 102},
  [3567] = {.lex_state = 305, .external_lex_state = 6},
  [3568] = {.lex_state = 394},
  [3569] = {.lex_state = 144, .external_lex_state = 8},
  [3570] = {.lex_state = 85},
  [3571] = {.lex_state = 112},
  [3572] = {.lex_state = 374, .external_lex_state = 21},
  [3573] = {.lex_state = 125},
  [3574] = {.lex_state = 374, .external_lex_state = 21},
  [3575] = {.lex_state = 112, .external_lex_state = 7},
  [3576] = {.lex_state = 78, .external_lex_state = 2},
  [3577] = {.lex_state = 78, .external_lex_state = 2},
  [3578] = {.lex_state = 78, .external_lex_state = 2},
  [3579] = {.lex_state = 85},
  [3580] = {.lex_state = 374, .external_lex_state = 4},
  [3581] = {.lex_state = 374, .external_lex_state = 4},
  [3582] = {.lex_state = 112},
  [3583] = {.lex_state = 374, .external_lex_state = 6},
  [3584] = {.lex_state = 125},
  [3585] = {.lex_state = 374, .external_lex_state = 6},
  [3586] = {.lex_state = 112, .external_lex_state = 7},
  [3587] = {.lex_state = 78, .external_lex_state = 2},
  [3588] = {.lex_state = 78, .external_lex_state = 2},
  [3589] = {.lex_state = 78, .external_lex_state = 2},
  [3590] = {.lex_state = 374, .external_lex_state = 5},
  [3591] = {.lex_state = 374, .external_lex_state = 5},
  [3592] = {.lex_state = 380, .external_lex_state = 6},
  [3593] = {.lex_state = 380, .external_lex_state = 6},
  [3594] = {.lex_state = 380, .external_lex_state = 6},
  [3595] = {.lex_state = 102},
  [3596] = {.lex_state = 380, .external_lex_state = 6},
  [3597] = {.lex_state = 217},
  [3598] = {.lex_state = 380, .external_lex_state = 6},
  [3599] = {.lex_state = 125},
  [3600] = {.lex_state = 85},
  [3601] = {.lex_state = 223, .external_lex_state = 7},
  [3602] = {.lex_state = 225, .external_lex_state = 18},
  [3603] = {.lex_state = 225, .external_lex_state = 18},
  [3604] = {.lex_state = 85},
  [3605] = {.lex_state = 215, .external_lex_state = 2},
  [3606] = {.lex_state = 78},
  [3607] = {.lex_state = 85},
  [3608] = {.lex_state = 310},
  [3609] = {.lex_state = 78},
  [3610] = {.lex_state = 358, .external_lex_state = 2},
  [3611] = {.lex_state = 78, .external_lex_state = 2},
  [3612] = {.lex_state = 78, .external_lex_state = 2},
  [3613] = {.lex_state = 102},
  [3614] = {.lex_state = 102},
  [3615] = {.lex_state = 396, .external_lex_state = 9},
  [3616] = {.lex_state = 343, .external_lex_state = 5},
  [3617] = {.lex_state = 237, .external_lex_state = 25},
  [3618] = {.lex_state = 380, .external_lex_state = 6},
  [3619] = {.lex_state = 380, .external_lex_state = 5},
  [3620] = {.lex_state = 380, .external_lex_state = 5},
  [3621] = {.lex_state = 343, .external_lex_state = 5},
  [3622] = {.lex_state = 384, .external_lex_state = 4},
  [3623] = {.lex_state = 380, .external_lex_state = 5},
  [3624] = {.lex_state = 380, .external_lex_state = 5},
  [3625] = {.lex_state = 380, .external_lex_state = 5},
  [3626] = {.lex_state = 343},
  [3627] = {.lex_state = 233, .external_lex_state = 2},
  [3628] = {.lex_state = 340},
  [3629] = {.lex_state = 233, .external_lex_state = 2},
  [3630] = {.lex_state = 340},
  [3631] = {.lex_state = 310},
  [3632] = {.lex_state = 343},
  [3633] = {.lex_state = 186, .external_lex_state = 5},
  [3634] = {.lex_state = 149, .external_lex_state = 14},
  [3635] = {.lex_state = 149, .external_lex_state = 14},
  [3636] = {.lex_state = 186, .external_lex_state = 5},
  [3637] = {.lex_state = 207, .external_lex_state = 27},
  [3638] = {.lex_state = 207, .external_lex_state = 27},
  [3639] = {.lex_state = 92, .external_lex_state = 29},
  [3640] = {.lex_state = 92, .external_lex_state = 18},
  [3641] = {.lex_state = 92, .external_lex_state = 18},
  [3642] = {.lex_state = 262, .external_lex_state = 18},
  [3643] = {.lex_state = 207, .external_lex_state = 27},
  [3644] = {.lex_state = 262, .external_lex_state = 18},
  [3645] = {.lex_state = 262, .external_lex_state = 18},
  [3646] = {.lex_state = 262, .external_lex_state = 18},
  [3647] = {.lex_state = 207, .external_lex_state = 27},
  [3648] = {.lex_state = 262, .external_lex_state = 18},
  [3649] = {.lex_state = 205, .external_lex_state = 16},
  [3650] = {.lex_state = 317},
  [3651] = {.lex_state = 317},
  [3652] = {.lex_state = 153},
  [3653] = {.lex_state = 205, .external_lex_state = 16},
  [3654] = {.lex_state = 205, .external_lex_state = 16},
  [3655] = {.lex_state = 343},
  [3656] = {.lex_state = 205, .external_lex_state = 16},
  [3657] = {.lex_state = 343},
  [3658] = {.lex_state = 199, .external_lex_state = 27},
  [3659] = {.lex_state = 199, .external_lex_state = 27},
  [3660] = {.lex_state = 199, .external_lex_state = 27},
  [3661] = {.lex_state = 262, .external_lex_state = 18},
  [3662] = {.lex_state = 262, .external_lex_state = 18},
  [3663] = {.lex_state = 199, .external_lex_state = 27},
  [3664] = {.lex_state = 199, .external_lex_state = 17},
  [3665] = {.lex_state = 199, .external_lex_state = 17},
  [3666] = {.lex_state = 199, .external_lex_state = 17},
  [3667] = {.lex_state = 262, .external_lex_state = 18},
  [3668] = {.lex_state = 262, .external_lex_state = 18},
  [3669] = {.lex_state = 199, .external_lex_state = 17},
  [3670] = {.lex_state = 201, .external_lex_state = 17},
  [3671] = {.lex_state = 201, .external_lex_state = 17},
  [3672] = {.lex_state = 209, .external_lex_state = 19},
  [3673] = {.lex_state = 209, .external_lex_state = 19},
  [3674] = {.lex_state = 178, .external_lex_state = 21},
  [3675] = {.lex_state = 178, .external_lex_state = 21},
  [3676] = {.lex_state = 178, .external_lex_state = 6},
  [3677] = {.lex_state = 178, .external_lex_state = 6},
  [3678] = {.lex_state = 215, .external_lex_state = 22},
  [3679] = {.lex_state = 215, .external_lex_state = 22},
  [3680] = {.lex_state = 125, .external_lex_state = 10},
  [3681] = {.lex_state = 125, .external_lex_state = 10},
  [3682] = {.lex_state = 92, .external_lex_state = 29},
  [3683] = {.lex_state = 92, .external_lex_state = 29},
  [3684] = {.lex_state = 92, .external_lex_state = 29},
  [3685] = {.lex_state = 92, .external_lex_state = 18},
  [3686] = {.lex_state = 92, .external_lex_state = 18},
  [3687] = {.lex_state = 262, .external_lex_state = 18},
  [3688] = {.lex_state = 92, .external_lex_state = 29},
  [3689] = {.lex_state = 262, .external_lex_state = 18},
  [3690] = {.lex_state = 262, .external_lex_state = 18},
  [3691] = {.lex_state = 262, .external_lex_state = 18},
  [3692] = {.lex_state = 92, .external_lex_state = 29},
  [3693] = {.lex_state = 262, .external_lex_state = 18},
  [3694] = {.lex_state = 262, .external_lex_state = 29},
  [3695] = {.lex_state = 262, .external_lex_state = 29},
  [3696] = {.lex_state = 262, .external_lex_state = 29},
  [3697] = {.lex_state = 262, .external_lex_state = 18},
  [3698] = {.lex_state = 262, .external_lex_state = 18},
  [3699] = {.lex_state = 262, .external_lex_state = 29},
  [3700] = {.lex_state = 96, .external_lex_state = 23},
  [3701] = {.lex_state = 96, .external_lex_state = 23},
  [3702] = {.lex_state = 96, .external_lex_state = 23},
  [3703] = {.lex_state = 262, .external_lex_state = 18},
  [3704] = {.lex_state = 262, .external_lex_state = 18},
  [3705] = {.lex_state = 96, .external_lex_state = 23},
  [3706] = {.lex_state = 215, .external_lex_state = 10},
  [3707] = {.lex_state = 215, .external_lex_state = 10},
  [3708] = {.lex_state = 215, .external_lex_state = 10},
  [3709] = {.lex_state = 262, .external_lex_state = 18},
  [3710] = {.lex_state = 262, .external_lex_state = 18},
  [3711] = {.lex_state = 215, .external_lex_state = 10},
  [3712] = {.lex_state = 184, .external_lex_state = 21},
  [3713] = {.lex_state = 184, .external_lex_state = 21},
  [3714] = {.lex_state = 186, .external_lex_state = 5},
  [3715] = {.lex_state = 241, .external_lex_state = 14},
  [3716] = {.lex_state = 241, .external_lex_state = 14},
  [3717] = {.lex_state = 317},
  [3718] = {.lex_state = 270, .external_lex_state = 14},
  [3719] = {.lex_state = 270, .external_lex_state = 14},
  [3720] = {.lex_state = 270, .external_lex_state = 14},
  [3721] = {.lex_state = 262, .external_lex_state = 18},
  [3722] = {.lex_state = 262, .external_lex_state = 18},
  [3723] = {.lex_state = 270, .external_lex_state = 14},
  [3724] = {.lex_state = 272, .external_lex_state = 10},
  [3725] = {.lex_state = 272, .external_lex_state = 10},
  [3726] = {.lex_state = 140, .external_lex_state = 26},
  [3727] = {.lex_state = 140, .external_lex_state = 26},
  [3728] = {.lex_state = 140, .external_lex_state = 26},
  [3729] = {.lex_state = 262, .external_lex_state = 18},
  [3730] = {.lex_state = 262, .external_lex_state = 18},
  [3731] = {.lex_state = 140, .external_lex_state = 26},
  [3732] = {.lex_state = 136, .external_lex_state = 12},
  [3733] = {.lex_state = 317},
  [3734] = {.lex_state = 317},
  [3735] = {.lex_state = 136, .external_lex_state = 12},
  [3736] = {.lex_state = 136, .external_lex_state = 12},
  [3737] = {.lex_state = 108, .external_lex_state = 26},
  [3738] = {.lex_state = 108, .external_lex_state = 26},
  [3739] = {.lex_state = 108, .external_lex_state = 13},
  [3740] = {.lex_state = 108, .external_lex_state = 13},
  [3741] = {.lex_state = 388, .external_lex_state = 4},
  [3742] = {.lex_state = 287, .external_lex_state = 21},
  [3743] = {.lex_state = 287, .external_lex_state = 21},
  [3744] = {.lex_state = 92, .external_lex_state = 29},
  [3745] = {.lex_state = 92, .external_lex_state = 18},
  [3746] = {.lex_state = 92, .external_lex_state = 18},
  [3747] = {.lex_state = 260, .external_lex_state = 18},
  [3748] = {.lex_state = 287, .external_lex_state = 21},
  [3749] = {.lex_state = 262, .external_lex_state = 30},
  [3750] = {.lex_state = 262, .external_lex_state = 18},
  [3751] = {.lex_state = 262, .external_lex_state = 30},
  [3752] = {.lex_state = 262, .external_lex_state = 18},
  [3753] = {.lex_state = 262, .external_lex_state = 18},
  [3754] = {.lex_state = 287, .external_lex_state = 21},
  [3755] = {.lex_state = 262, .external_lex_state = 18},
  [3756] = {.lex_state = 262, .external_lex_state = 18},
  [3757] = {.lex_state = 275, .external_lex_state = 4},
  [3758] = {.lex_state = 275, .external_lex_state = 21},
  [3759] = {.lex_state = 275, .external_lex_state = 21},
  [3760] = {.lex_state = 92, .external_lex_state = 29},
  [3761] = {.lex_state = 92, .external_lex_state = 18},
  [3762] = {.lex_state = 92, .external_lex_state = 18},
  [3763] = {.lex_state = 262, .external_lex_state = 18},
  [3764] = {.lex_state = 275, .external_lex_state = 21},
  [3765] = {.lex_state = 262, .external_lex_state = 18},
  [3766] = {.lex_state = 262, .external_lex_state = 18},
  [3767] = {.lex_state = 262, .external_lex_state = 18},
  [3768] = {.lex_state = 275, .external_lex_state = 21},
  [3769] = {.lex_state = 262, .external_lex_state = 18},
  [3770] = {.lex_state = 275, .external_lex_state = 6},
  [3771] = {.lex_state = 275, .external_lex_state = 6},
  [3772] = {.lex_state = 92, .external_lex_state = 29},
  [3773] = {.lex_state = 92, .external_lex_state = 18},
  [3774] = {.lex_state = 92, .external_lex_state = 18},
  [3775] = {.lex_state = 262, .external_lex_state = 18},
  [3776] = {.lex_state = 275, .external_lex_state = 6},
  [3777] = {.lex_state = 262, .external_lex_state = 18},
  [3778] = {.lex_state = 262, .external_lex_state = 18},
  [3779] = {.lex_state = 262, .external_lex_state = 18},
  [3780] = {.lex_state = 275, .external_lex_state = 6},
  [3781] = {.lex_state = 262, .external_lex_state = 18},
  [3782] = {.lex_state = 281, .external_lex_state = 6},
  [3783] = {.lex_state = 281, .external_lex_state = 6},
  [3784] = {.lex_state = 281, .external_lex_state = 6},
  [3785] = {.lex_state = 262, .external_lex_state = 18},
  [3786] = {.lex_state = 262, .external_lex_state = 18},
  [3787] = {.lex_state = 281, .external_lex_state = 6},
  [3788] = {.lex_state = 398, .external_lex_state = 5},
  [3789] = {.lex_state = 370, .external_lex_state = 6},
  [3790] = {.lex_state = 370, .external_lex_state = 6},
  [3791] = {.lex_state = 92, .external_lex_state = 29},
  [3792] = {.lex_state = 92, .external_lex_state = 18},
  [3793] = {.lex_state = 92, .external_lex_state = 18},
  [3794] = {.lex_state = 260, .external_lex_state = 18},
  [3795] = {.lex_state = 370, .external_lex_state = 6},
  [3796] = {.lex_state = 262, .external_lex_state = 30},
  [3797] = {.lex_state = 262, .external_lex_state = 18},
  [3798] = {.lex_state = 262, .external_lex_state = 30},
  [3799] = {.lex_state = 262, .external_lex_state = 18},
  [3800] = {.lex_state = 262, .external_lex_state = 18},
  [3801] = {.lex_state = 370, .external_lex_state = 6},
  [3802] = {.lex_state = 262, .external_lex_state = 18},
  [3803] = {.lex_state = 262, .external_lex_state = 18},
  [3804] = {.lex_state = 392, .external_lex_state = 4},
  [3805] = {.lex_state = 308, .external_lex_state = 21},
  [3806] = {.lex_state = 308, .external_lex_state = 21},
  [3807] = {.lex_state = 92, .external_lex_state = 29},
  [3808] = {.lex_state = 92, .external_lex_state = 18},
  [3809] = {.lex_state = 92, .external_lex_state = 18},
  [3810] = {.lex_state = 260, .external_lex_state = 18},
  [3811] = {.lex_state = 308, .external_lex_state = 21},
  [3812] = {.lex_state = 262, .external_lex_state = 30},
  [3813] = {.lex_state = 262, .external_lex_state = 18},
  [3814] = {.lex_state = 262, .external_lex_state = 30},
  [3815] = {.lex_state = 262, .external_lex_state = 18},
  [3816] = {.lex_state = 262, .external_lex_state = 18},
  [3817] = {.lex_state = 308, .external_lex_state = 21},
  [3818] = {.lex_state = 262, .external_lex_state = 18},
  [3819] = {.lex_state = 262, .external_lex_state = 18},
  [3820] = {.lex_state = 332, .external_lex_state = 4},
  [3821] = {.lex_state = 332, .external_lex_state = 21},
  [3822] = {.lex_state = 102},
  [3823] = {.lex_state = 332, .external_lex_state = 21},
  [3824] = {.lex_state = 332, .external_lex_state = 21},
  [3825] = {.lex_state = 217},
  [3826] = {.lex_state = 260, .external_lex_state = 18},
  [3827] = {.lex_state = 85},
  [3828] = {.lex_state = 225, .external_lex_state = 18},
  [3829] = {.lex_state = 225, .external_lex_state = 18},
  [3830] = {.lex_state = 332, .external_lex_state = 21},
  [3831] = {.lex_state = 262, .external_lex_state = 30},
  [3832] = {.lex_state = 262, .external_lex_state = 18},
  [3833] = {.lex_state = 332, .external_lex_state = 21},
  [3834] = {.lex_state = 262, .external_lex_state = 30},
  [3835] = {.lex_state = 262, .external_lex_state = 18},
  [3836] = {.lex_state = 332, .external_lex_state = 21},
  [3837] = {.lex_state = 332, .external_lex_state = 21},
  [3838] = {.lex_state = 324, .external_lex_state = 4},
  [3839] = {.lex_state = 215},
  [3840] = {.lex_state = 404, .external_lex_state = 4},
  [3841] = {.lex_state = 324, .external_lex_state = 21},
  [3842] = {.lex_state = 324, .external_lex_state = 21},
  [3843] = {.lex_state = 92, .external_lex_state = 29},
  [3844] = {.lex_state = 92, .external_lex_state = 18},
  [3845] = {.lex_state = 92, .external_lex_state = 18},
  [3846] = {.lex_state = 260, .external_lex_state = 18},
  [3847] = {.lex_state = 324, .external_lex_state = 21},
  [3848] = {.lex_state = 262, .external_lex_state = 30},
  [3849] = {.lex_state = 262, .external_lex_state = 18},
  [3850] = {.lex_state = 262, .external_lex_state = 30},
  [3851] = {.lex_state = 262, .external_lex_state = 18},
  [3852] = {.lex_state = 262, .external_lex_state = 18},
  [3853] = {.lex_state = 324, .external_lex_state = 21},
  [3854] = {.lex_state = 262, .external_lex_state = 18},
  [3855] = {.lex_state = 262, .external_lex_state = 18},
  [3856] = {.lex_state = 404, .external_lex_state = 5},
  [3857] = {.lex_state = 324, .external_lex_state = 6},
  [3858] = {.lex_state = 324, .external_lex_state = 6},
  [3859] = {.lex_state = 92, .external_lex_state = 29},
  [3860] = {.lex_state = 92, .external_lex_state = 18},
  [3861] = {.lex_state = 92, .external_lex_state = 18},
  [3862] = {.lex_state = 260, .external_lex_state = 18},
  [3863] = {.lex_state = 324, .external_lex_state = 6},
  [3864] = {.lex_state = 262, .external_lex_state = 30},
  [3865] = {.lex_state = 262, .external_lex_state = 18},
  [3866] = {.lex_state = 262, .external_lex_state = 30},
  [3867] = {.lex_state = 262, .external_lex_state = 18},
  [3868] = {.lex_state = 262, .external_lex_state = 18},
  [3869] = {.lex_state = 324, .external_lex_state = 6},
  [3870] = {.lex_state = 262, .external_lex_state = 18},
  [3871] = {.lex_state = 262, .external_lex_state = 18},
  [3872] = {.lex_state = 326, .external_lex_state = 6},
  [3873] = {.lex_state = 326, .external_lex_state = 6},
  [3874] = {.lex_state = 92, .external_lex_state = 29},
  [3875] = {.lex_state = 92, .external_lex_state = 18},
  [3876] = {.lex_state = 92, .external_lex_state = 18},
  [3877] = {.lex_state = 262, .external_lex_state = 18},
  [3878] = {.lex_state = 326, .external_lex_state = 6},
  [3879] = {.lex_state = 262, .external_lex_state = 18},
  [3880] = {.lex_state = 262, .external_lex_state = 18},
  [3881] = {.lex_state = 262, .external_lex_state = 18},
  [3882] = {.lex_state = 326, .external_lex_state = 6},
  [3883] = {.lex_state = 262, .external_lex_state = 18},
  [3884] = {.lex_state = 102},
  [3885] = {.lex_state = 330, .external_lex_state = 6},
  [3886] = {.lex_state = 291, .external_lex_state = 4},
  [3887] = {.lex_state = 291, .external_lex_state = 21},
  [3888] = {.lex_state = 291, .external_lex_state = 21},
  [3889] = {.lex_state = 92, .external_lex_state = 29},
  [3890] = {.lex_state = 92, .external_lex_state = 18},
  [3891] = {.lex_state = 92, .external_lex_state = 18},
  [3892] = {.lex_state = 262, .external_lex_state = 18},
  [3893] = {.lex_state = 291, .external_lex_state = 21},
  [3894] = {.lex_state = 262, .external_lex_state = 18},
  [3895] = {.lex_state = 262, .external_lex_state = 18},
  [3896] = {.lex_state = 262, .external_lex_state = 18},
  [3897] = {.lex_state = 291, .external_lex_state = 21},
  [3898] = {.lex_state = 262, .external_lex_state = 18},
  [3899] = {.lex_state = 291, .external_lex_state = 6},
  [3900] = {.lex_state = 291, .external_lex_state = 6},
  [3901] = {.lex_state = 92, .external_lex_state = 29},
  [3902] = {.lex_state = 92, .external_lex_state = 18},
  [3903] = {.lex_state = 92, .external_lex_state = 18},
  [3904] = {.lex_state = 262, .external_lex_state = 18},
  [3905] = {.lex_state = 291, .external_lex_state = 6},
  [3906] = {.lex_state = 262, .external_lex_state = 18},
  [3907] = {.lex_state = 262, .external_lex_state = 18},
  [3908] = {.lex_state = 262, .external_lex_state = 18},
  [3909] = {.lex_state = 291, .external_lex_state = 6},
  [3910] = {.lex_state = 262, .external_lex_state = 18},
  [3911] = {.lex_state = 301, .external_lex_state = 6},
  [3912] = {.lex_state = 301, .external_lex_state = 6},
  [3913] = {.lex_state = 301, .external_lex_state = 6},
  [3914] = {.lex_state = 262, .external_lex_state = 18},
  [3915] = {.lex_state = 262, .external_lex_state = 18},
  [3916] = {.lex_state = 301, .external_lex_state = 6},
  [3917] = {.lex_state = 406, .external_lex_state = 5},
  [3918] = {.lex_state = 384, .external_lex_state = 4},
  [3919] = {.lex_state = 215},
  [3920] = {.lex_state = 112},
  [3921] = {.lex_state = 384, .external_lex_state = 21},
  [3922] = {.lex_state = 125},
  [3923] = {.lex_state = 384, .external_lex_state = 21},
  [3924] = {.lex_state = 112, .external_lex_state = 7},
  [3925] = {.lex_state = 78, .external_lex_state = 2},
  [3926] = {.lex_state = 78, .external_lex_state = 2},
  [3927] = {.lex_state = 78, .external_lex_state = 2},
  [3928] = {.lex_state = 384, .external_lex_state = 4},
  [3929] = {.lex_state = 144, .external_lex_state = 8},
  [3930] = {.lex_state = 374, .external_lex_state = 21},
  [3931] = {.lex_state = 374, .external_lex_state = 21},
  [3932] = {.lex_state = 374, .external_lex_state = 21},
  [3933] = {.lex_state = 102},
  [3934] = {.lex_state = 374, .external_lex_state = 21},
  [3935] = {.lex_state = 217},
  [3936] = {.lex_state = 374, .external_lex_state = 21},
  [3937] = {.lex_state = 125},
  [3938] = {.lex_state = 85},
  [3939] = {.lex_state = 223, .external_lex_state = 7},
  [3940] = {.lex_state = 225, .external_lex_state = 18},
  [3941] = {.lex_state = 225, .external_lex_state = 18},
  [3942] = {.lex_state = 85},
  [3943] = {.lex_state = 215, .external_lex_state = 2},
  [3944] = {.lex_state = 78},
  [3945] = {.lex_state = 85},
  [3946] = {.lex_state = 374, .external_lex_state = 4},
  [3947] = {.lex_state = 374, .external_lex_state = 4},
  [3948] = {.lex_state = 374, .external_lex_state = 4},
  [3949] = {.lex_state = 374, .external_lex_state = 6},
  [3950] = {.lex_state = 374, .external_lex_state = 6},
  [3951] = {.lex_state = 374, .external_lex_state = 6},
  [3952] = {.lex_state = 102},
  [3953] = {.lex_state = 374, .external_lex_state = 6},
  [3954] = {.lex_state = 217},
  [3955] = {.lex_state = 374, .external_lex_state = 6},
  [3956] = {.lex_state = 125},
  [3957] = {.lex_state = 85},
  [3958] = {.lex_state = 223, .external_lex_state = 7},
  [3959] = {.lex_state = 225, .external_lex_state = 18},
  [3960] = {.lex_state = 225, .external_lex_state = 18},
  [3961] = {.lex_state = 85},
  [3962] = {.lex_state = 215, .external_lex_state = 2},
  [3963] = {.lex_state = 78},
  [3964] = {.lex_state = 85},
  [3965] = {.lex_state = 374, .external_lex_state = 5},
  [3966] = {.lex_state = 374, .external_lex_state = 5},
  [3967] = {.lex_state = 374, .external_lex_state = 5},
  [3968] = {.lex_state = 380, .external_lex_state = 6},
  [3969] = {.lex_state = 102},
  [3970] = {.lex_state = 380, .external_lex_state = 6},
  [3971] = {.lex_state = 380, .external_lex_state = 6},
  [3972] = {.lex_state = 217},
  [3973] = {.lex_state = 260, .external_lex_state = 18},
  [3974] = {.lex_state = 85},
  [3975] = {.lex_state = 225, .external_lex_state = 18},
  [3976] = {.lex_state = 225, .external_lex_state = 18},
  [3977] = {.lex_state = 380, .external_lex_state = 6},
  [3978] = {.lex_state = 262, .external_lex_state = 30},
  [3979] = {.lex_state = 262, .external_lex_state = 18},
  [3980] = {.lex_state = 380, .external_lex_state = 6},
  [3981] = {.lex_state = 262, .external_lex_state = 30},
  [3982] = {.lex_state = 262, .external_lex_state = 18},
  [3983] = {.lex_state = 380, .external_lex_state = 6},
  [3984] = {.lex_state = 380, .external_lex_state = 6},
  [3985] = {.lex_state = 102},
  [3986] = {.lex_state = 343, .external_lex_state = 5},
  [3987] = {.lex_state = 384, .external_lex_state = 4},
  [3988] = {.lex_state = 343, .external_lex_state = 5},
  [3989] = {.lex_state = 384, .external_lex_state = 4},
  [3990] = {.lex_state = 343, .external_lex_state = 6},
  [3991] = {.lex_state = 343, .external_lex_state = 6},
  [3992] = {.lex_state = 343, .external_lex_state = 5},
  [3993] = {.lex_state = 343, .external_lex_state = 6},
  [3994] = {.lex_state = 343, .external_lex_state = 5},
  [3995] = {.lex_state = 358, .external_lex_state = 2},
  [3996] = {.lex_state = 343, .external_lex_state = 5},
  [3997] = {.lex_state = 380, .external_lex_state = 5},
  [3998] = {.lex_state = 380, .external_lex_state = 6},
  [3999] = {.lex_state = 380, .external_lex_state = 5},
  [4000] = {.lex_state = 380, .external_lex_state = 5},
  [4001] = {.lex_state = 358, .external_lex_state = 2},
  [4002] = {.lex_state = 396, .external_lex_state = 9},
  [4003] = {.lex_state = 380, .external_lex_state = 5},
  [4004] = {.lex_state = 310},
  [4005] = {.lex_state = 102},
  [4006] = {.lex_state = 85},
  [4007] = {.lex_state = 136, .external_lex_state = 5},
  [4008] = {.lex_state = 140, .external_lex_state = 4},
  [4009] = {.lex_state = 78, .external_lex_state = 2},
  [4010] = {.lex_state = 233, .external_lex_state = 2},
  [4011] = {.lex_state = 102},
  [4012] = {.lex_state = 85},
  [4013] = {.lex_state = 233, .external_lex_state = 2},
  [4014] = {.lex_state = 310},
  [4015] = {.lex_state = 207, .external_lex_state = 27},
  [4016] = {.lex_state = 207, .external_lex_state = 27},
  [4017] = {.lex_state = 207, .external_lex_state = 27},
  [4018] = {.lex_state = 262, .external_lex_state = 18},
  [4019] = {.lex_state = 262, .external_lex_state = 18},
  [4020] = {.lex_state = 207, .external_lex_state = 27},
  [4021] = {.lex_state = 205, .external_lex_state = 16},
  [4022] = {.lex_state = 317},
  [4023] = {.lex_state = 317},
  [4024] = {.lex_state = 205, .external_lex_state = 16},
  [4025] = {.lex_state = 205, .external_lex_state = 16},
  [4026] = {.lex_state = 199, .external_lex_state = 27},
  [4027] = {.lex_state = 199, .external_lex_state = 27},
  [4028] = {.lex_state = 199, .external_lex_state = 17},
  [4029] = {.lex_state = 199, .external_lex_state = 17},
  [4030] = {.lex_state = 92, .external_lex_state = 29},
  [4031] = {.lex_state = 92, .external_lex_state = 29},
  [4032] = {.lex_state = 92, .external_lex_state = 29},
  [4033] = {.lex_state = 262, .external_lex_state = 18},
  [4034] = {.lex_state = 262, .external_lex_state = 18},
  [4035] = {.lex_state = 92, .external_lex_state = 29},
  [4036] = {.lex_state = 262, .external_lex_state = 29},
  [4037] = {.lex_state = 262, .external_lex_state = 29},
  [4038] = {.lex_state = 96, .external_lex_state = 23},
  [4039] = {.lex_state = 96, .external_lex_state = 23},
  [4040] = {.lex_state = 215, .external_lex_state = 10},
  [4041] = {.lex_state = 215, .external_lex_state = 10},
  [4042] = {.lex_state = 186, .external_lex_state = 5},
  [4043] = {.lex_state = 270, .external_lex_state = 14},
  [4044] = {.lex_state = 270, .external_lex_state = 14},
  [4045] = {.lex_state = 140, .external_lex_state = 26},
  [4046] = {.lex_state = 140, .external_lex_state = 26},
  [4047] = {.lex_state = 136, .external_lex_state = 12},
  [4048] = {.lex_state = 317},
  [4049] = {.lex_state = 287, .external_lex_state = 21},
  [4050] = {.lex_state = 287, .external_lex_state = 21},
  [4051] = {.lex_state = 92, .external_lex_state = 29},
  [4052] = {.lex_state = 92, .external_lex_state = 18},
  [4053] = {.lex_state = 92, .external_lex_state = 18},
  [4054] = {.lex_state = 262, .external_lex_state = 18},
  [4055] = {.lex_state = 287, .external_lex_state = 21},
  [4056] = {.lex_state = 262, .external_lex_state = 18},
  [4057] = {.lex_state = 262, .external_lex_state = 18},
  [4058] = {.lex_state = 262, .external_lex_state = 18},
  [4059] = {.lex_state = 287, .external_lex_state = 21},
  [4060] = {.lex_state = 262, .external_lex_state = 18},
  [4061] = {.lex_state = 275, .external_lex_state = 21},
  [4062] = {.lex_state = 275, .external_lex_state = 21},
  [4063] = {.lex_state = 275, .external_lex_state = 21},
  [4064] = {.lex_state = 262, .external_lex_state = 18},
  [4065] = {.lex_state = 262, .external_lex_state = 18},
  [4066] = {.lex_state = 275, .external_lex_state = 21},
  [4067] = {.lex_state = 275, .external_lex_state = 6},
  [4068] = {.lex_state = 275, .external_lex_state = 6},
  [4069] = {.lex_state = 275, .external_lex_state = 6},
  [4070] = {.lex_state = 262, .external_lex_state = 18},
  [4071] = {.lex_state = 262, .external_lex_state = 18},
  [4072] = {.lex_state = 275, .external_lex_state = 6},
  [4073] = {.lex_state = 281, .external_lex_state = 6},
  [4074] = {.lex_state = 281, .external_lex_state = 6},
  [4075] = {.lex_state = 370, .external_lex_state = 6},
  [4076] = {.lex_state = 370, .external_lex_state = 6},
  [4077] = {.lex_state = 92, .external_lex_state = 29},
  [4078] = {.lex_state = 92, .external_lex_state = 18},
  [4079] = {.lex_state = 92, .external_lex_state = 18},
  [4080] = {.lex_state = 262, .external_lex_state = 18},
  [4081] = {.lex_state = 370, .external_lex_state = 6},
  [4082] = {.lex_state = 262, .external_lex_state = 18},
  [4083] = {.lex_state = 262, .external_lex_state = 18},
  [4084] = {.lex_state = 262, .external_lex_state = 18},
  [4085] = {.lex_state = 370, .external_lex_state = 6},
  [4086] = {.lex_state = 262, .external_lex_state = 18},
  [4087] = {.lex_state = 308, .external_lex_state = 21},
  [4088] = {.lex_state = 308, .external_lex_state = 21},
  [4089] = {.lex_state = 92, .external_lex_state = 29},
  [4090] = {.lex_state = 92, .external_lex_state = 18},
  [4091] = {.lex_state = 92, .external_lex_state = 18},
  [4092] = {.lex_state = 262, .external_lex_state = 18},
  [4093] = {.lex_state = 308, .external_lex_state = 21},
  [4094] = {.lex_state = 262, .external_lex_state = 18},
  [4095] = {.lex_state = 262, .external_lex_state = 18},
  [4096] = {.lex_state = 262, .external_lex_state = 18},
  [4097] = {.lex_state = 308, .external_lex_state = 21},
  [4098] = {.lex_state = 262, .external_lex_state = 18},
  [4099] = {.lex_state = 404, .external_lex_state = 4},
  [4100] = {.lex_state = 332, .external_lex_state = 21},
  [4101] = {.lex_state = 332, .external_lex_state = 21},
  [4102] = {.lex_state = 92, .external_lex_state = 29},
  [4103] = {.lex_state = 92, .external_lex_state = 18},
  [4104] = {.lex_state = 92, .external_lex_state = 18},
  [4105] = {.lex_state = 260, .external_lex_state = 18},
  [4106] = {.lex_state = 332, .external_lex_state = 21},
  [4107] = {.lex_state = 262, .external_lex_state = 30},
  [4108] = {.lex_state = 262, .external_lex_state = 18},
  [4109] = {.lex_state = 262, .external_lex_state = 30},
  [4110] = {.lex_state = 262, .external_lex_state = 18},
  [4111] = {.lex_state = 262, .external_lex_state = 18},
  [4112] = {.lex_state = 332, .external_lex_state = 21},
  [4113] = {.lex_state = 262, .external_lex_state = 18},
  [4114] = {.lex_state = 262, .external_lex_state = 18},
  [4115] = {.lex_state = 324, .external_lex_state = 4},
  [4116] = {.lex_state = 324, .external_lex_state = 21},
  [4117] = {.lex_state = 324, .external_lex_state = 21},
  [4118] = {.lex_state = 92, .external_lex_state = 29},
  [4119] = {.lex_state = 92, .external_lex_state = 18},
  [4120] = {.lex_state = 92, .external_lex_state = 18},
  [4121] = {.lex_state = 262, .external_lex_state = 18},
  [4122] = {.lex_state = 324, .external_lex_state = 21},
  [4123] = {.lex_state = 262, .external_lex_state = 18},
  [4124] = {.lex_state = 262, .external_lex_state = 18},
  [4125] = {.lex_state = 262, .external_lex_state = 18},
  [4126] = {.lex_state = 324, .external_lex_state = 21},
  [4127] = {.lex_state = 262, .external_lex_state = 18},
  [4128] = {.lex_state = 324, .external_lex_state = 6},
  [4129] = {.lex_state = 324, .external_lex_state = 6},
  [4130] = {.lex_state = 92, .external_lex_state = 29},
  [4131] = {.lex_state = 92, .external_lex_state = 18},
  [4132] = {.lex_state = 92, .external_lex_state = 18},
  [4133] = {.lex_state = 262, .external_lex_state = 18},
  [4134] = {.lex_state = 324, .external_lex_state = 6},
  [4135] = {.lex_state = 262, .external_lex_state = 18},
  [4136] = {.lex_state = 262, .external_lex_state = 18},
  [4137] = {.lex_state = 262, .external_lex_state = 18},
  [4138] = {.lex_state = 324, .external_lex_state = 6},
  [4139] = {.lex_state = 262, .external_lex_state = 18},
  [4140] = {.lex_state = 326, .external_lex_state = 6},
  [4141] = {.lex_state = 326, .external_lex_state = 6},
  [4142] = {.lex_state = 326, .external_lex_state = 6},
  [4143] = {.lex_state = 262, .external_lex_state = 18},
  [4144] = {.lex_state = 262, .external_lex_state = 18},
  [4145] = {.lex_state = 326, .external_lex_state = 6},
  [4146] = {.lex_state = 416, .external_lex_state = 5},
  [4147] = {.lex_state = 291, .external_lex_state = 21},
  [4148] = {.lex_state = 291, .external_lex_state = 21},
  [4149] = {.lex_state = 291, .external_lex_state = 21},
  [4150] = {.lex_state = 262, .external_lex_state = 18},
  [4151] = {.lex_state = 262, .external_lex_state = 18},
  [4152] = {.lex_state = 291, .external_lex_state = 21},
  [4153] = {.lex_state = 291, .external_lex_state = 6},
  [4154] = {.lex_state = 291, .external_lex_state = 6},
  [4155] = {.lex_state = 291, .external_lex_state = 6},
  [4156] = {.lex_state = 262, .external_lex_state = 18},
  [4157] = {.lex_state = 262, .external_lex_state = 18},
  [4158] = {.lex_state = 291, .external_lex_state = 6},
  [4159] = {.lex_state = 301, .external_lex_state = 6},
  [4160] = {.lex_state = 301, .external_lex_state = 6},
  [4161] = {.lex_state = 384, .external_lex_state = 4},
  [4162] = {.lex_state = 215},
  [4163] = {.lex_state = 384, .external_lex_state = 21},
  [4164] = {.lex_state = 384, .external_lex_state = 21},
  [4165] = {.lex_state = 384, .external_lex_state = 21},
  [4166] = {.lex_state = 102},
  [4167] = {.lex_state = 384, .external_lex_state = 21},
  [4168] = {.lex_state = 217},
  [4169] = {.lex_state = 384, .external_lex_state = 21},
  [4170] = {.lex_state = 125},
  [4171] = {.lex_state = 85},
  [4172] = {.lex_state = 223, .external_lex_state = 7},
  [4173] = {.lex_state = 225, .external_lex_state = 18},
  [4174] = {.lex_state = 225, .external_lex_state = 18},
  [4175] = {.lex_state = 85},
  [4176] = {.lex_state = 215, .external_lex_state = 2},
  [4177] = {.lex_state = 78},
  [4178] = {.lex_state = 85},
  [4179] = {.lex_state = 384, .external_lex_state = 4},
  [4180] = {.lex_state = 384, .external_lex_state = 4},
  [4181] = {.lex_state = 374, .external_lex_state = 4},
  [4182] = {.lex_state = 215},
  [4183] = {.lex_state = 374, .external_lex_state = 21},
  [4184] = {.lex_state = 374, .external_lex_state = 4},
  [4185] = {.lex_state = 374, .external_lex_state = 21},
  [4186] = {.lex_state = 102},
  [4187] = {.lex_state = 374, .external_lex_state = 21},
  [4188] = {.lex_state = 374, .external_lex_state = 21},
  [4189] = {.lex_state = 217},
  [4190] = {.lex_state = 260, .external_lex_state = 18},
  [4191] = {.lex_state = 85},
  [4192] = {.lex_state = 225, .external_lex_state = 18},
  [4193] = {.lex_state = 225, .external_lex_state = 18},
  [4194] = {.lex_state = 374, .external_lex_state = 21},
  [4195] = {.lex_state = 262, .external_lex_state = 30},
  [4196] = {.lex_state = 262, .external_lex_state = 18},
  [4197] = {.lex_state = 374, .external_lex_state = 21},
  [4198] = {.lex_state = 262, .external_lex_state = 30},
  [4199] = {.lex_state = 262, .external_lex_state = 18},
  [4200] = {.lex_state = 374, .external_lex_state = 21},
  [4201] = {.lex_state = 374, .external_lex_state = 21},
  [4202] = {.lex_state = 374, .external_lex_state = 6},
  [4203] = {.lex_state = 102},
  [4204] = {.lex_state = 374, .external_lex_state = 6},
  [4205] = {.lex_state = 374, .external_lex_state = 6},
  [4206] = {.lex_state = 217},
  [4207] = {.lex_state = 260, .external_lex_state = 18},
  [4208] = {.lex_state = 85},
  [4209] = {.lex_state = 225, .external_lex_state = 18},
  [4210] = {.lex_state = 225, .external_lex_state = 18},
  [4211] = {.lex_state = 374, .external_lex_state = 6},
  [4212] = {.lex_state = 262, .external_lex_state = 30},
  [4213] = {.lex_state = 262, .external_lex_state = 18},
  [4214] = {.lex_state = 374, .external_lex_state = 6},
  [4215] = {.lex_state = 262, .external_lex_state = 30},
  [4216] = {.lex_state = 262, .external_lex_state = 18},
  [4217] = {.lex_state = 374, .external_lex_state = 6},
  [4218] = {.lex_state = 374, .external_lex_state = 6},
  [4219] = {.lex_state = 418, .external_lex_state = 5},
  [4220] = {.lex_state = 380, .external_lex_state = 6},
  [4221] = {.lex_state = 380, .external_lex_state = 6},
  [4222] = {.lex_state = 92, .external_lex_state = 29},
  [4223] = {.lex_state = 92, .external_lex_state = 18},
  [4224] = {.lex_state = 92, .external_lex_state = 18},
  [4225] = {.lex_state = 260, .external_lex_state = 18},
  [4226] = {.lex_state = 380, .external_lex_state = 6},
  [4227] = {.lex_state = 262, .external_lex_state = 30},
  [4228] = {.lex_state = 262, .external_lex_state = 18},
  [4229] = {.lex_state = 262, .external_lex_state = 30},
  [4230] = {.lex_state = 262, .external_lex_state = 18},
  [4231] = {.lex_state = 262, .external_lex_state = 18},
  [4232] = {.lex_state = 380, .external_lex_state = 6},
  [4233] = {.lex_state = 262, .external_lex_state = 18},
  [4234] = {.lex_state = 262, .external_lex_state = 18},
  [4235] = {.lex_state = 343, .external_lex_state = 6},
  [4236] = {.lex_state = 343, .external_lex_state = 5},
  [4237] = {.lex_state = 343, .external_lex_state = 6},
  [4238] = {.lex_state = 343, .external_lex_state = 5},
  [4239] = {.lex_state = 358, .external_lex_state = 2},
  [4240] = {.lex_state = 102},
  [4241] = {.lex_state = 146, .external_lex_state = 9},
  [4242] = {.lex_state = 136, .external_lex_state = 5},
  [4243] = {.lex_state = 140, .external_lex_state = 4},
  [4244] = {.lex_state = 85},
  [4245] = {.lex_state = 102},
  [4246] = {.lex_state = 85},
  [4247] = {.lex_state = 207, .external_lex_state = 27},
  [4248] = {.lex_state = 207, .external_lex_state = 27},
  [4249] = {.lex_state = 205, .external_lex_state = 16},
  [4250] = {.lex_state = 317},
  [4251] = {.lex_state = 92, .external_lex_state = 29},
  [4252] = {.lex_state = 92, .external_lex_state = 29},
  [4253] = {.lex_state = 136, .external_lex_state = 12},
  [4254] = {.lex_state = 287, .external_lex_state = 21},
  [4255] = {.lex_state = 287, .external_lex_state = 21},
  [4256] = {.lex_state = 287, .external_lex_state = 21},
  [4257] = {.lex_state = 262, .external_lex_state = 18},
  [4258] = {.lex_state = 262, .external_lex_state = 18},
  [4259] = {.lex_state = 287, .external_lex_state = 21},
  [4260] = {.lex_state = 275, .external_lex_state = 21},
  [4261] = {.lex_state = 275, .external_lex_state = 21},
  [4262] = {.lex_state = 275, .external_lex_state = 6},
  [4263] = {.lex_state = 275, .external_lex_state = 6},
  [4264] = {.lex_state = 370, .external_lex_state = 6},
  [4265] = {.lex_state = 370, .external_lex_state = 6},
  [4266] = {.lex_state = 370, .external_lex_state = 6},
  [4267] = {.lex_state = 262, .external_lex_state = 18},
  [4268] = {.lex_state = 262, .external_lex_state = 18},
  [4269] = {.lex_state = 370, .external_lex_state = 6},
  [4270] = {.lex_state = 308, .external_lex_state = 21},
  [4271] = {.lex_state = 308, .external_lex_state = 21},
  [4272] = {.lex_state = 308, .external_lex_state = 21},
  [4273] = {.lex_state = 262, .external_lex_state = 18},
  [4274] = {.lex_state = 262, .external_lex_state = 18},
  [4275] = {.lex_state = 308, .external_lex_state = 21},
  [4276] = {.lex_state = 332, .external_lex_state = 21},
  [4277] = {.lex_state = 332, .external_lex_state = 21},
  [4278] = {.lex_state = 92, .external_lex_state = 29},
  [4279] = {.lex_state = 92, .external_lex_state = 18},
  [4280] = {.lex_state = 92, .external_lex_state = 18},
  [4281] = {.lex_state = 262, .external_lex_state = 18},
  [4282] = {.lex_state = 332, .external_lex_state = 21},
  [4283] = {.lex_state = 262, .external_lex_state = 18},
  [4284] = {.lex_state = 262, .external_lex_state = 18},
  [4285] = {.lex_state = 262, .external_lex_state = 18},
  [4286] = {.lex_state = 332, .external_lex_state = 21},
  [4287] = {.lex_state = 262, .external_lex_state = 18},
  [4288] = {.lex_state = 324, .external_lex_state = 21},
  [4289] = {.lex_state = 324, .external_lex_state = 21},
  [4290] = {.lex_state = 324, .external_lex_state = 21},
  [4291] = {.lex_state = 262, .external_lex_state = 18},
  [4292] = {.lex_state = 262, .external_lex_state = 18},
  [4293] = {.lex_state = 324, .external_lex_state = 21},
  [4294] = {.lex_state = 324, .external_lex_state = 6},
  [4295] = {.lex_state = 324, .external_lex_state = 6},
  [4296] = {.lex_state = 324, .external_lex_state = 6},
  [4297] = {.lex_state = 262, .external_lex_state = 18},
  [4298] = {.lex_state = 262, .external_lex_state = 18},
  [4299] = {.lex_state = 324, .external_lex_state = 6},
  [4300] = {.lex_state = 326, .external_lex_state = 6},
  [4301] = {.lex_state = 326, .external_lex_state = 6},
  [4302] = {.lex_state = 291, .external_lex_state = 21},
  [4303] = {.lex_state = 291, .external_lex_state = 21},
  [4304] = {.lex_state = 291, .external_lex_state = 6},
  [4305] = {.lex_state = 291, .external_lex_state = 6},
  [4306] = {.lex_state = 384, .external_lex_state = 4},
  [4307] = {.lex_state = 384, .external_lex_state = 21},
  [4308] = {.lex_state = 102},
  [4309] = {.lex_state = 384, .external_lex_state = 21},
  [4310] = {.lex_state = 384, .external_lex_state = 21},
  [4311] = {.lex_state = 217},
  [4312] = {.lex_state = 260, .external_lex_state = 18},
  [4313] = {.lex_state = 85},
  [4314] = {.lex_state = 225, .external_lex_state = 18},
  [4315] = {.lex_state = 225, .external_lex_state = 18},
  [4316] = {.lex_state = 384, .external_lex_state = 21},
  [4317] = {.lex_state = 262, .external_lex_state = 30},
  [4318] = {.lex_state = 262, .external_lex_state = 18},
  [4319] = {.lex_state = 384, .external_lex_state = 21},
  [4320] = {.lex_state = 262, .external_lex_state = 30},
  [4321] = {.lex_state = 262, .external_lex_state = 18},
  [4322] = {.lex_state = 384, .external_lex_state = 21},
  [4323] = {.lex_state = 384, .external_lex_state = 21},
  [4324] = {.lex_state = 374, .external_lex_state = 4},
  [4325] = {.lex_state = 215},
  [4326] = {.lex_state = 420, .external_lex_state = 4},
  [4327] = {.lex_state = 374, .external_lex_state = 21},
  [4328] = {.lex_state = 374, .external_lex_state = 21},
  [4329] = {.lex_state = 92, .external_lex_state = 29},
  [4330] = {.lex_state = 92, .external_lex_state = 18},
  [4331] = {.lex_state = 92, .external_lex_state = 18},
  [4332] = {.lex_state = 260, .external_lex_state = 18},
  [4333] = {.lex_state = 374, .external_lex_state = 21},
  [4334] = {.lex_state = 262, .external_lex_state = 30},
  [4335] = {.lex_state = 262, .external_lex_state = 18},
  [4336] = {.lex_state = 262, .external_lex_state = 30},
  [4337] = {.lex_state = 262, .external_lex_state = 18},
  [4338] = {.lex_state = 262, .external_lex_state = 18},
  [4339] = {.lex_state = 374, .external_lex_state = 21},
  [4340] = {.lex_state = 262, .external_lex_state = 18},
  [4341] = {.lex_state = 262, .external_lex_state = 18},
  [4342] = {.lex_state = 420, .external_lex_state = 5},
  [4343] = {.lex_state = 374, .external_lex_state = 6},
  [4344] = {.lex_state = 374, .external_lex_state = 6},
  [4345] = {.lex_state = 92, .external_lex_state = 29},
  [4346] = {.lex_state = 92, .external_lex_state = 18},
  [4347] = {.lex_state = 92, .external_lex_state = 18},
  [4348] = {.lex_state = 260, .external_lex_state = 18},
  [4349] = {.lex_state = 374, .external_lex_state = 6},
  [4350] = {.lex_state = 262, .external_lex_state = 30},
  [4351] = {.lex_state = 262, .external_lex_state = 18},
  [4352] = {.lex_state = 262, .external_lex_state = 30},
  [4353] = {.lex_state = 262, .external_lex_state = 18},
  [4354] = {.lex_state = 262, .external_lex_state = 18},
  [4355] = {.lex_state = 374, .external_lex_state = 6},
  [4356] = {.lex_state = 262, .external_lex_state = 18},
  [4357] = {.lex_state = 262, .external_lex_state = 18},
  [4358] = {.lex_state = 380, .external_lex_state = 6},
  [4359] = {.lex_state = 380, .external_lex_state = 6},
  [4360] = {.lex_state = 92, .external_lex_state = 29},
  [4361] = {.lex_state = 92, .external_lex_state = 18},
  [4362] = {.lex_state = 92, .external_lex_state = 18},
  [4363] = {.lex_state = 262, .external_lex_state = 18},
  [4364] = {.lex_state = 380, .external_lex_state = 6},
  [4365] = {.lex_state = 262, .external_lex_state = 18},
  [4366] = {.lex_state = 262, .external_lex_state = 18},
  [4367] = {.lex_state = 262, .external_lex_state = 18},
  [4368] = {.lex_state = 380, .external_lex_state = 6},
  [4369] = {.lex_state = 262, .external_lex_state = 18},
  [4370] = {.lex_state = 102},
  [4371] = {.lex_state = 343, .external_lex_state = 6},
  [4372] = {.lex_state = 146, .external_lex_state = 9},
  [4373] = {.lex_state = 102},
  [4374] = {.lex_state = 102},
  [4375] = {.lex_state = 205, .external_lex_state = 16},
  [4376] = {.lex_state = 287, .external_lex_state = 21},
  [4377] = {.lex_state = 287, .external_lex_state = 21},
  [4378] = {.lex_state = 370, .external_lex_state = 6},
  [4379] = {.lex_state = 370, .external_lex_state = 6},
  [4380] = {.lex_state = 308, .external_lex_state = 21},
  [4381] = {.lex_state = 308, .external_lex_state = 21},
  [4382] = {.lex_state = 332, .external_lex_state = 21},
  [4383] = {.lex_state = 332, .external_lex_state = 21},
  [4384] = {.lex_state = 332, .external_lex_state = 21},
  [4385] = {.lex_state = 262, .external_lex_state = 18},
  [4386] = {.lex_state = 262, .external_lex_state = 18},
  [4387] = {.lex_state = 332, .external_lex_state = 21},
  [4388] = {.lex_state = 324, .external_lex_state = 21},
  [4389] = {.lex_state = 324, .external_lex_state = 21},
  [4390] = {.lex_state = 324, .external_lex_state = 6},
  [4391] = {.lex_state = 324, .external_lex_state = 6},
  [4392] = {.lex_state = 420, .external_lex_state = 4},
  [4393] = {.lex_state = 384, .external_lex_state = 21},
  [4394] = {.lex_state = 384, .external_lex_state = 21},
  [4395] = {.lex_state = 92, .external_lex_state = 29},
  [4396] = {.lex_state = 92, .external_lex_state = 18},
  [4397] = {.lex_state = 92, .external_lex_state = 18},
  [4398] = {.lex_state = 260, .external_lex_state = 18},
  [4399] = {.lex_state = 384, .external_lex_state = 21},
  [4400] = {.lex_state = 262, .external_lex_state = 30},
  [4401] = {.lex_state = 262, .external_lex_state = 18},
  [4402] = {.lex_state = 262, .external_lex_state = 30},
  [4403] = {.lex_state = 262, .external_lex_state = 18},
  [4404] = {.lex_state = 262, .external_lex_state = 18},
  [4405] = {.lex_state = 384, .external_lex_state = 21},
  [4406] = {.lex_state = 262, .external_lex_state = 18},
  [4407] = {.lex_state = 262, .external_lex_state = 18},
  [4408] = {.lex_state = 374, .external_lex_state = 4},
  [4409] = {.lex_state = 374, .external_lex_state = 21},
  [4410] = {.lex_state = 374, .external_lex_state = 21},
  [4411] = {.lex_state = 92, .external_lex_state = 29},
  [4412] = {.lex_state = 92, .external_lex_state = 18},
  [4413] = {.lex_state = 92, .external_lex_state = 18},
  [4414] = {.lex_state = 262, .external_lex_state = 18},
  [4415] = {.lex_state = 374, .external_lex_state = 21},
  [4416] = {.lex_state = 262, .external_lex_state = 18},
  [4417] = {.lex_state = 262, .external_lex_state = 18},
  [4418] = {.lex_state = 262, .external_lex_state = 18},
  [4419] = {.lex_state = 374, .external_lex_state = 21},
  [4420] = {.lex_state = 262, .external_lex_state = 18},
  [4421] = {.lex_state = 374, .external_lex_state = 6},
  [4422] = {.lex_state = 374, .external_lex_state = 6},
  [4423] = {.lex_state = 92, .external_lex_state = 29},
  [4424] = {.lex_state = 92, .external_lex_state = 18},
  [4425] = {.lex_state = 92, .external_lex_state = 18},
  [4426] = {.lex_state = 262, .external_lex_state = 18},
  [4427] = {.lex_state = 374, .external_lex_state = 6},
  [4428] = {.lex_state = 262, .external_lex_state = 18},
  [4429] = {.lex_state = 262, .external_lex_state = 18},
  [4430] = {.lex_state = 262, .external_lex_state = 18},
  [4431] = {.lex_state = 374, .external_lex_state = 6},
  [4432] = {.lex_state = 262, .external_lex_state = 18},
  [4433] = {.lex_state = 380, .external_lex_state = 6},
  [4434] = {.lex_state = 380, .external_lex_state = 6},
  [4435] = {.lex_state = 380, .external_lex_state = 6},
  [4436] = {.lex_state = 262, .external_lex_state = 18},
  [4437] = {.lex_state = 262, .external_lex_state = 18},
  [4438] = {.lex_state = 380, .external_lex_state = 6},
  [4439] = {.lex_state = 422, .external_lex_state = 5},
  [4440] = {.lex_state = 332, .external_lex_state = 21},
  [4441] = {.lex_state = 332, .external_lex_state = 21},
  [4442] = {.lex_state = 384, .external_lex_state = 21},
  [4443] = {.lex_state = 384, .external_lex_state = 21},
  [4444] = {.lex_state = 92, .external_lex_state = 29},
  [4445] = {.lex_state = 92, .external_lex_state = 18},
  [4446] = {.lex_state = 92, .external_lex_state = 18},
  [4447] = {.lex_state = 262, .external_lex_state = 18},
  [4448] = {.lex_state = 384, .external_lex_state = 21},
  [4449] = {.lex_state = 262, .external_lex_state = 18},
  [4450] = {.lex_state = 262, .external_lex_state = 18},
  [4451] = {.lex_state = 262, .external_lex_state = 18},
  [4452] = {.lex_state = 384, .external_lex_state = 21},
  [4453] = {.lex_state = 262, .external_lex_state = 18},
  [4454] = {.lex_state = 374, .external_lex_state = 21},
  [4455] = {.lex_state = 374, .external_lex_state = 21},
  [4456] = {.lex_state = 374, .external_lex_state = 21},
  [4457] = {.lex_state = 262, .external_lex_state = 18},
  [4458] = {.lex_state = 262, .external_lex_state = 18},
  [4459] = {.lex_state = 374, .external_lex_state = 21},
  [4460] = {.lex_state = 374, .external_lex_state = 6},
  [4461] = {.lex_state = 374, .external_lex_state = 6},
  [4462] = {.lex_state = 374, .external_lex_state = 6},
  [4463] = {.lex_state = 262, .external_lex_state = 18},
  [4464] = {.lex_state = 262, .external_lex_state = 18},
  [4465] = {.lex_state = 374, .external_lex_state = 6},
  [4466] = {.lex_state = 380, .external_lex_state = 6},
  [4467] = {.lex_state = 380, .external_lex_state = 6},
  [4468] = {.lex_state = 384, .external_lex_state = 21},
  [4469] = {.lex_state = 384, .external_lex_state = 21},
  [4470] = {.lex_state = 384, .external_lex_state = 21},
  [4471] = {.lex_state = 262, .external_lex_state = 18},
  [4472] = {.lex_state = 262, .external_lex_state = 18},
  [4473] = {.lex_state = 384, .external_lex_state = 21},
  [4474] = {.lex_state = 374, .external_lex_state = 21},
  [4475] = {.lex_state = 374, .external_lex_state = 21},
  [4476] = {.lex_state = 374, .external_lex_state = 6},
  [4477] = {.lex_state = 374, .external_lex_state = 6},
  [4478] = {.lex_state = 384, .external_lex_state = 21},
  [4479] = {.lex_state = 384, .external_lex_state = 21},
};

enum {
  ts_external_token_heredoc_start,
  ts_external_token__simple_heredoc_body,
  ts_external_token__heredoc_body_beginning,
  ts_external_token__heredoc_body_middle,
  ts_external_token__heredoc_body_end,
  ts_external_token_file_descriptor,
  ts_external_token__empty_value,
  ts_external_token__concat,
  ts_external_token_variable_name,
  ts_external_token_regex,
  ts_external_token_RBRACE,
  ts_external_token_RBRACK,
  ts_external_token_LT_LT,
  ts_external_token_LT_LT_DASH,
  ts_external_token_LF,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token_heredoc_start] = sym_heredoc_start,
  [ts_external_token__simple_heredoc_body] = sym__simple_heredoc_body,
  [ts_external_token__heredoc_body_beginning] = sym__heredoc_body_beginning,
  [ts_external_token__heredoc_body_middle] = sym__heredoc_body_middle,
  [ts_external_token__heredoc_body_end] = sym__heredoc_body_end,
  [ts_external_token_file_descriptor] = sym_file_descriptor,
  [ts_external_token__empty_value] = sym__empty_value,
  [ts_external_token__concat] = sym__concat,
  [ts_external_token_variable_name] = sym_variable_name,
  [ts_external_token_regex] = sym_regex,
  [ts_external_token_RBRACE] = anon_sym_RBRACE,
  [ts_external_token_RBRACK] = anon_sym_RBRACK,
  [ts_external_token_LT_LT] = anon_sym_LT_LT,
  [ts_external_token_LT_LT_DASH] = anon_sym_LT_LT_DASH,
  [ts_external_token_LF] = anon_sym_LF,
};

static bool ts_external_scanner_states[31][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token_heredoc_start] = true,
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token__heredoc_body_middle] = true,
    [ts_external_token__heredoc_body_end] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__empty_value] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_regex] = true,
    [ts_external_token_RBRACE] = true,
    [ts_external_token_RBRACK] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_LF] = true,
  },
  [2] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_variable_name] = true,
  },
  [3] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_RBRACE] = true,
  },
  [4] = {
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_LF] = true,
  },
  [5] = {
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_LF] = true,
  },
  [6] = {
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_LF] = true,
  },
  [7] = {
    [ts_external_token_variable_name] = true,
  },
  [8] = {
    [ts_external_token__empty_value] = true,
  },
  [9] = {
    [ts_external_token_LF] = true,
  },
  [10] = {
    [ts_external_token__concat] = true,
  },
  [11] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_LF] = true,
  },
  [12] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_LF] = true,
  },
  [13] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_LF] = true,
  },
  [14] = {
    [ts_external_token__concat] = true,
    [ts_external_token_LF] = true,
  },
  [15] = {
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_RBRACE] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_LF] = true,
  },
  [16] = {
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_RBRACE] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_LF] = true,
  },
  [17] = {
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_RBRACE] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_LF] = true,
  },
  [18] = {
    [ts_external_token_RBRACE] = true,
  },
  [19] = {
    [ts_external_token__concat] = true,
    [ts_external_token_RBRACK] = true,
  },
  [20] = {
    [ts_external_token_RBRACK] = true,
  },
  [21] = {
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_LF] = true,
  },
  [22] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
  },
  [23] = {
    [ts_external_token__heredoc_body_middle] = true,
    [ts_external_token__heredoc_body_end] = true,
  },
  [24] = {
    [ts_external_token_heredoc_start] = true,
  },
  [25] = {
    [ts_external_token_regex] = true,
  },
  [26] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_LF] = true,
  },
  [27] = {
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_RBRACE] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_LF] = true,
  },
  [28] = {
    [ts_external_token_RBRACE] = true,
    [ts_external_token_LF] = true,
  },
  [29] = {
    [ts_external_token__concat] = true,
    [ts_external_token_RBRACE] = true,
  },
  [30] = {
    [ts_external_token_regex] = true,
    [ts_external_token_RBRACE] = true,
  },
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_heredoc_start] = ACTIONS(1),
    [sym__simple_heredoc_body] = ACTIONS(1),
    [sym__heredoc_body_beginning] = ACTIONS(1),
    [sym__heredoc_body_middle] = ACTIONS(1),
    [sym__heredoc_body_end] = ACTIONS(1),
    [sym_file_descriptor] = ACTIONS(1),
    [sym__empty_value] = ACTIONS(1),
    [sym__concat] = ACTIONS(1),
    [sym_variable_name] = ACTIONS(1),
    [sym_regex] = ACTIONS(1),
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(3),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_then] = ACTIONS(1),
    [anon_sym_fi] = ACTIONS(1),
    [anon_sym_elif] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_esac] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(3),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_SEMI_SEMI] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_PIPE_AMP] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(3),
    [anon_sym_RBRACK] = ACTIONS(3),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1),
    [anon_sym_declare] = ACTIONS(1),
    [anon_sym_typeset] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_readonly] = ACTIONS(1),
    [anon_sym_local] = ACTIONS(1),
    [anon_sym_unset] = ACTIONS(3),
    [anon_sym_unsetenv] = ACTIONS(1),
    [anon_sym_EQ_TILDE] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(3),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(3),
    [anon_sym_GT] = ACTIONS(3),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_AMP_GT] = ACTIONS(3),
    [anon_sym_AMP_GT_GT] = ACTIONS(1),
    [anon_sym_LT_AMP] = ACTIONS(1),
    [anon_sym_GT_AMP] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(3),
    [anon_sym_LT_LT_DASH] = ACTIONS(1),
    [anon_sym_LT_LT_LT] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(3),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(3),
    [sym__special_character] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [sym_raw_string] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(3),
    [anon_sym_COLON_QMARK] = ACTIONS(1),
    [anon_sym_COLON_DASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_LT_LPAREN] = ACTIONS(1),
    [anon_sym_GT_LPAREN] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_0] = ACTIONS(1),
    [anon_sym__] = ACTIONS(1),
    [sym_test_operator] = ACTIONS(1),
    [anon_sym_LF] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(3),
  },
  [1] = {
    [sym_program] = STATE(27),
    [sym__statements] = STATE(28),
    [sym_redirected_statement] = STATE(29),
    [sym_for_statement] = STATE(29),
    [sym_c_style_for_statement] = STATE(29),
    [sym_while_statement] = STATE(29),
    [sym_if_statement] = STATE(29),
    [sym_case_statement] = STATE(29),
    [sym_function_definition] = STATE(29),
    [sym_compound_statement] = STATE(29),
    [sym_subshell] = STATE(29),
    [sym_pipeline] = STATE(29),
    [sym_list] = STATE(29),
    [sym_negated_command] = STATE(29),
    [sym_test_command] = STATE(29),
    [sym_declaration_command] = STATE(29),
    [sym_unset_command] = STATE(29),
    [sym_command] = STATE(29),
    [sym_command_name] = STATE(30),
    [sym_variable_assignment] = STATE(31),
    [sym_subscript] = STATE(32),
    [sym_file_redirect] = STATE(35),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(21),
    [sym_simple_expansion] = STATE(21),
    [sym_string_expansion] = STATE(21),
    [sym_expansion] = STATE(21),
    [sym_command_substitution] = STATE(21),
    [sym_process_substitution] = STATE(21),
    [aux_sym__statements_repeat1] = STATE(34),
    [aux_sym_command_repeat1] = STATE(35),
    [aux_sym__literal_repeat1] = STATE(36),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(9),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(27),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(33),
    [anon_sym_typeset] = ACTIONS(33),
    [anon_sym_export] = ACTIONS(33),
    [anon_sym_readonly] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym_unset] = ACTIONS(35),
    [anon_sym_unsetenv] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(43),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(47),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(59),
  },
  [2] = {
    [anon_sym_LT] = ACTIONS(61),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_GT_GT] = ACTIONS(63),
    [anon_sym_AMP_GT] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(63),
    [anon_sym_LT_AMP] = ACTIONS(63),
    [anon_sym_GT_AMP] = ACTIONS(63),
    [sym_comment] = ACTIONS(57),
  },
  [3] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(67),
    [anon_sym_PLUS_EQ] = ACTIONS(67),
    [sym_comment] = ACTIONS(57),
  },
  [4] = {
    [anon_sym_LPAREN_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(71),
  },
  [5] = {
    [sym__expression] = STATE(52),
    [sym_binary_expression] = STATE(52),
    [sym_unary_expression] = STATE(52),
    [sym_postfix_expression] = STATE(52),
    [sym_parenthesized_expression] = STATE(52),
    [sym_concatenation] = STATE(52),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__literal_repeat1] = STATE(53),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_DOLLAR] = ACTIONS(77),
    [sym__special_character] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [6] = {
    [sym__terminated_statement] = STATE(77),
    [sym_redirected_statement] = STATE(78),
    [sym_for_statement] = STATE(78),
    [sym_c_style_for_statement] = STATE(78),
    [sym_while_statement] = STATE(78),
    [sym_if_statement] = STATE(78),
    [sym_case_statement] = STATE(78),
    [sym_function_definition] = STATE(78),
    [sym_compound_statement] = STATE(78),
    [sym_subshell] = STATE(78),
    [sym_pipeline] = STATE(78),
    [sym_list] = STATE(78),
    [sym_negated_command] = STATE(78),
    [sym_test_command] = STATE(78),
    [sym_declaration_command] = STATE(78),
    [sym_unset_command] = STATE(78),
    [sym_command] = STATE(78),
    [sym_command_name] = STATE(79),
    [sym_variable_assignment] = STATE(80),
    [sym_subscript] = STATE(81),
    [sym_file_redirect] = STATE(83),
    [sym_concatenation] = STATE(82),
    [sym_string] = STATE(71),
    [sym_simple_expansion] = STATE(71),
    [sym_string_expansion] = STATE(71),
    [sym_expansion] = STATE(71),
    [sym_command_substitution] = STATE(71),
    [sym_process_substitution] = STATE(71),
    [aux_sym_command_repeat1] = STATE(83),
    [aux_sym__literal_repeat1] = STATE(84),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_case] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(125),
    [sym__special_character] = ACTIONS(127),
    [anon_sym_DQUOTE] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(131),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [7] = {
    [sym__terminated_statement] = STATE(85),
    [sym_redirected_statement] = STATE(78),
    [sym_for_statement] = STATE(78),
    [sym_c_style_for_statement] = STATE(78),
    [sym_while_statement] = STATE(78),
    [sym_if_statement] = STATE(78),
    [sym_case_statement] = STATE(78),
    [sym_function_definition] = STATE(78),
    [sym_compound_statement] = STATE(78),
    [sym_subshell] = STATE(78),
    [sym_pipeline] = STATE(78),
    [sym_list] = STATE(78),
    [sym_negated_command] = STATE(78),
    [sym_test_command] = STATE(78),
    [sym_declaration_command] = STATE(78),
    [sym_unset_command] = STATE(78),
    [sym_command] = STATE(78),
    [sym_command_name] = STATE(79),
    [sym_variable_assignment] = STATE(80),
    [sym_subscript] = STATE(81),
    [sym_file_redirect] = STATE(83),
    [sym_concatenation] = STATE(82),
    [sym_string] = STATE(71),
    [sym_simple_expansion] = STATE(71),
    [sym_string_expansion] = STATE(71),
    [sym_expansion] = STATE(71),
    [sym_command_substitution] = STATE(71),
    [sym_process_substitution] = STATE(71),
    [aux_sym_command_repeat1] = STATE(83),
    [aux_sym__literal_repeat1] = STATE(84),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_case] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(125),
    [sym__special_character] = ACTIONS(127),
    [anon_sym_DQUOTE] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(131),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [8] = {
    [sym_concatenation] = STATE(94),
    [sym_string] = STATE(89),
    [sym_simple_expansion] = STATE(89),
    [sym_string_expansion] = STATE(89),
    [sym_expansion] = STATE(89),
    [sym_command_substitution] = STATE(89),
    [sym_process_substitution] = STATE(89),
    [aux_sym__literal_repeat1] = STATE(95),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [sym__special_character] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [sym_raw_string] = ACTIONS(149),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [anon_sym_LT_LPAREN] = ACTIONS(157),
    [anon_sym_GT_LPAREN] = ACTIONS(157),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(149),
  },
  [9] = {
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(159),
  },
  [10] = {
    [sym__statements] = STATE(104),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [11] = {
    [sym__statements] = STATE(136),
    [sym_redirected_statement] = STATE(137),
    [sym_for_statement] = STATE(137),
    [sym_c_style_for_statement] = STATE(137),
    [sym_while_statement] = STATE(137),
    [sym_if_statement] = STATE(137),
    [sym_case_statement] = STATE(137),
    [sym_function_definition] = STATE(137),
    [sym_compound_statement] = STATE(137),
    [sym_subshell] = STATE(137),
    [sym_pipeline] = STATE(137),
    [sym_list] = STATE(137),
    [sym_negated_command] = STATE(137),
    [sym_test_command] = STATE(137),
    [sym_declaration_command] = STATE(137),
    [sym_unset_command] = STATE(137),
    [sym_command] = STATE(137),
    [sym_command_name] = STATE(138),
    [sym_variable_assignment] = STATE(139),
    [sym_subscript] = STATE(140),
    [sym_file_redirect] = STATE(143),
    [sym_concatenation] = STATE(141),
    [sym_string] = STATE(130),
    [sym_simple_expansion] = STATE(130),
    [sym_string_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [sym_process_substitution] = STATE(130),
    [aux_sym__statements_repeat1] = STATE(142),
    [aux_sym_command_repeat1] = STATE(143),
    [aux_sym__literal_repeat1] = STATE(144),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(179),
    [anon_sym_while] = ACTIONS(181),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_case] = ACTIONS(185),
    [anon_sym_function] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_LBRACE] = ACTIONS(191),
    [anon_sym_RBRACE] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(199),
    [anon_sym_declare] = ACTIONS(201),
    [anon_sym_typeset] = ACTIONS(201),
    [anon_sym_export] = ACTIONS(201),
    [anon_sym_readonly] = ACTIONS(201),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_unset] = ACTIONS(203),
    [anon_sym_unsetenv] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(205),
    [sym__special_character] = ACTIONS(207),
    [anon_sym_DQUOTE] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(221),
  },
  [12] = {
    [sym_subshell] = STATE(146),
    [sym_test_command] = STATE(146),
    [sym_command] = STATE(146),
    [sym_command_name] = STATE(30),
    [sym_variable_assignment] = STATE(35),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(35),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(21),
    [sym_simple_expansion] = STATE(21),
    [sym_string_expansion] = STATE(21),
    [sym_expansion] = STATE(21),
    [sym_command_substitution] = STATE(21),
    [sym_process_substitution] = STATE(21),
    [aux_sym_command_repeat1] = STATE(35),
    [aux_sym__literal_repeat1] = STATE(36),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(43),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(47),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(47),
  },
  [13] = {
    [sym__expression] = STATE(158),
    [sym_binary_expression] = STATE(158),
    [sym_unary_expression] = STATE(158),
    [sym_postfix_expression] = STATE(158),
    [sym_parenthesized_expression] = STATE(158),
    [sym_concatenation] = STATE(158),
    [sym_string] = STATE(153),
    [sym_simple_expansion] = STATE(153),
    [sym_string_expansion] = STATE(153),
    [sym_expansion] = STATE(153),
    [sym_command_substitution] = STATE(153),
    [sym_process_substitution] = STATE(153),
    [aux_sym__literal_repeat1] = STATE(159),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_BANG] = ACTIONS(227),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__special_character] = ACTIONS(231),
    [anon_sym_DQUOTE] = ACTIONS(233),
    [sym_raw_string] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [anon_sym_LT_LPAREN] = ACTIONS(243),
    [anon_sym_GT_LPAREN] = ACTIONS(243),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(245),
    [sym_test_operator] = ACTIONS(247),
  },
  [14] = {
    [sym__expression] = STATE(163),
    [sym_binary_expression] = STATE(163),
    [sym_unary_expression] = STATE(163),
    [sym_postfix_expression] = STATE(163),
    [sym_parenthesized_expression] = STATE(163),
    [sym_concatenation] = STATE(163),
    [sym_string] = STATE(162),
    [sym_simple_expansion] = STATE(162),
    [sym_string_expansion] = STATE(162),
    [sym_expansion] = STATE(162),
    [sym_command_substitution] = STATE(162),
    [sym_process_substitution] = STATE(162),
    [aux_sym__literal_repeat1] = STATE(164),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(249),
    [anon_sym_DOLLAR] = ACTIONS(77),
    [sym__special_character] = ACTIONS(251),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(255),
    [sym_test_operator] = ACTIONS(257),
  },
  [15] = {
    [sym_variable_assignment] = STATE(175),
    [sym_subscript] = STATE(174),
    [sym_concatenation] = STATE(175),
    [sym_string] = STATE(169),
    [sym_simple_expansion] = STATE(169),
    [sym_string_expansion] = STATE(169),
    [sym_expansion] = STATE(169),
    [sym_command_substitution] = STATE(169),
    [sym_process_substitution] = STATE(169),
    [aux_sym_declaration_command_repeat1] = STATE(175),
    [aux_sym__literal_repeat1] = STATE(176),
    [sym__simple_heredoc_body] = ACTIONS(259),
    [sym__heredoc_body_beginning] = ACTIONS(259),
    [sym_file_descriptor] = ACTIONS(259),
    [sym_variable_name] = ACTIONS(261),
    [ts_builtin_sym_end] = ACTIONS(259),
    [anon_sym_SEMI] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_SEMI_SEMI] = ACTIONS(259),
    [anon_sym_PIPE_AMP] = ACTIONS(259),
    [anon_sym_AMP_AMP] = ACTIONS(259),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_LT] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_GT_GT] = ACTIONS(259),
    [anon_sym_AMP_GT] = ACTIONS(263),
    [anon_sym_AMP_GT_GT] = ACTIONS(259),
    [anon_sym_LT_AMP] = ACTIONS(259),
    [anon_sym_GT_AMP] = ACTIONS(259),
    [anon_sym_LT_LT] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(259),
    [anon_sym_LT_LT_LT] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(265),
    [sym__special_character] = ACTIONS(267),
    [anon_sym_DQUOTE] = ACTIONS(269),
    [sym_raw_string] = ACTIONS(271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(277),
    [anon_sym_LT_LPAREN] = ACTIONS(279),
    [anon_sym_GT_LPAREN] = ACTIONS(279),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(281),
    [sym_word] = ACTIONS(283),
    [anon_sym_LF] = ACTIONS(259),
    [anon_sym_AMP] = ACTIONS(263),
  },
  [16] = {
    [sym_concatenation] = STATE(185),
    [sym_string] = STATE(180),
    [sym_simple_expansion] = STATE(180),
    [sym_string_expansion] = STATE(180),
    [sym_expansion] = STATE(180),
    [sym_command_substitution] = STATE(180),
    [sym_process_substitution] = STATE(180),
    [aux_sym_unset_command_repeat1] = STATE(185),
    [aux_sym__literal_repeat1] = STATE(186),
    [sym__simple_heredoc_body] = ACTIONS(285),
    [sym__heredoc_body_beginning] = ACTIONS(285),
    [sym_file_descriptor] = ACTIONS(285),
    [ts_builtin_sym_end] = ACTIONS(285),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(285),
    [anon_sym_PIPE_AMP] = ACTIONS(285),
    [anon_sym_AMP_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(287),
    [anon_sym_GT] = ACTIONS(287),
    [anon_sym_GT_GT] = ACTIONS(285),
    [anon_sym_AMP_GT] = ACTIONS(287),
    [anon_sym_AMP_GT_GT] = ACTIONS(285),
    [anon_sym_LT_AMP] = ACTIONS(285),
    [anon_sym_GT_AMP] = ACTIONS(285),
    [anon_sym_LT_LT] = ACTIONS(287),
    [anon_sym_LT_LT_DASH] = ACTIONS(285),
    [anon_sym_LT_LT_LT] = ACTIONS(285),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym__special_character] = ACTIONS(291),
    [anon_sym_DQUOTE] = ACTIONS(293),
    [sym_raw_string] = ACTIONS(295),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(297),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(301),
    [anon_sym_LT_LPAREN] = ACTIONS(303),
    [anon_sym_GT_LPAREN] = ACTIONS(303),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(305),
    [sym_word] = ACTIONS(307),
    [anon_sym_LF] = ACTIONS(285),
    [anon_sym_AMP] = ACTIONS(287),
  },
  [17] = {
    [sym_concatenation] = STATE(195),
    [sym_string] = STATE(190),
    [sym_simple_expansion] = STATE(190),
    [sym_string_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [sym_process_substitution] = STATE(190),
    [aux_sym__literal_repeat1] = STATE(196),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [sym__special_character] = ACTIONS(311),
    [anon_sym_DQUOTE] = ACTIONS(313),
    [sym_raw_string] = ACTIONS(315),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(317),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(319),
    [anon_sym_BQUOTE] = ACTIONS(321),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(315),
  },
  [18] = {
    [sym_string] = STATE(198),
    [anon_sym_DASH] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(327),
    [anon_sym_POUND] = ACTIONS(325),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(331),
    [anon_sym_STAR] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_QMARK] = ACTIONS(333),
    [anon_sym_0] = ACTIONS(331),
    [anon_sym__] = ACTIONS(331),
  },
  [19] = {
    [aux_sym_concatenation_repeat1] = STATE(201),
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(337),
    [ts_builtin_sym_end] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_EQ_TILDE] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [20] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(208),
    [anon_sym_DOLLAR] = ACTIONS(341),
    [anon_sym_DQUOTE] = ACTIONS(343),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [21] = {
    [aux_sym_concatenation_repeat1] = STATE(201),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(337),
    [ts_builtin_sym_end] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [22] = {
    [sym_subscript] = STATE(212),
    [sym_variable_name] = ACTIONS(357),
    [anon_sym_BANG] = ACTIONS(359),
    [anon_sym_DASH] = ACTIONS(361),
    [anon_sym_DOLLAR] = ACTIONS(361),
    [anon_sym_POUND] = ACTIONS(359),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(365),
    [anon_sym_AT] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(365),
    [anon_sym_0] = ACTIONS(363),
    [anon_sym__] = ACTIONS(363),
  },
  [23] = {
    [sym__statements] = STATE(215),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(216),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [24] = {
    [sym__statements] = STATE(224),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [25] = {
    [sym__statements] = STATE(232),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [26] = {
    [aux_sym_concatenation_repeat1] = STATE(201),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(337),
    [ts_builtin_sym_end] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_LPAREN] = ACTIONS(387),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [27] = {
    [ts_builtin_sym_end] = ACTIONS(389),
    [sym_comment] = ACTIONS(57),
  },
  [28] = {
    [ts_builtin_sym_end] = ACTIONS(391),
    [sym_comment] = ACTIONS(57),
  },
  [29] = {
    [sym_file_redirect] = STATE(244),
    [sym_heredoc_redirect] = STATE(244),
    [sym_heredoc_body] = STATE(243),
    [sym_herestring_redirect] = STATE(244),
    [aux_sym_redirected_statement_repeat1] = STATE(244),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(397),
    [ts_builtin_sym_end] = ACTIONS(399),
    [anon_sym_SEMI] = ACTIONS(401),
    [anon_sym_PIPE] = ACTIONS(403),
    [anon_sym_SEMI_SEMI] = ACTIONS(405),
    [anon_sym_PIPE_AMP] = ACTIONS(407),
    [anon_sym_AMP_AMP] = ACTIONS(409),
    [anon_sym_PIPE_PIPE] = ACTIONS(409),
    [anon_sym_LT] = ACTIONS(411),
    [anon_sym_GT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(413),
    [anon_sym_AMP_GT] = ACTIONS(411),
    [anon_sym_AMP_GT_GT] = ACTIONS(413),
    [anon_sym_LT_AMP] = ACTIONS(413),
    [anon_sym_GT_AMP] = ACTIONS(413),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(419),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(405),
    [anon_sym_AMP] = ACTIONS(401),
  },
  [30] = {
    [sym_concatenation] = STATE(247),
    [sym_string] = STATE(246),
    [sym_simple_expansion] = STATE(246),
    [sym_string_expansion] = STATE(246),
    [sym_expansion] = STATE(246),
    [sym_command_substitution] = STATE(246),
    [sym_process_substitution] = STATE(246),
    [aux_sym_command_repeat2] = STATE(247),
    [aux_sym__literal_repeat1] = STATE(248),
    [sym__simple_heredoc_body] = ACTIONS(421),
    [sym__heredoc_body_beginning] = ACTIONS(421),
    [sym_file_descriptor] = ACTIONS(421),
    [ts_builtin_sym_end] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI_SEMI] = ACTIONS(421),
    [anon_sym_PIPE_AMP] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_AMP_GT] = ACTIONS(423),
    [anon_sym_AMP_GT_GT] = ACTIONS(421),
    [anon_sym_LT_AMP] = ACTIONS(421),
    [anon_sym_GT_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_LT_LT_DASH] = ACTIONS(421),
    [anon_sym_LT_LT_LT] = ACTIONS(421),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(427),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(429),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(431),
    [anon_sym_LF] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
  },
  [31] = {
    [sym_file_redirect] = STATE(244),
    [sym_heredoc_redirect] = STATE(244),
    [sym_heredoc_body] = STATE(243),
    [sym_herestring_redirect] = STATE(244),
    [aux_sym_redirected_statement_repeat1] = STATE(244),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [ts_builtin_sym_end] = ACTIONS(399),
    [anon_sym_SEMI] = ACTIONS(401),
    [anon_sym_PIPE] = ACTIONS(403),
    [anon_sym_SEMI_SEMI] = ACTIONS(405),
    [anon_sym_PIPE_AMP] = ACTIONS(407),
    [anon_sym_AMP_AMP] = ACTIONS(409),
    [anon_sym_PIPE_PIPE] = ACTIONS(409),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(419),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(405),
    [anon_sym_AMP] = ACTIONS(401),
  },
  [32] = {
    [anon_sym_EQ] = ACTIONS(67),
    [anon_sym_PLUS_EQ] = ACTIONS(67),
    [sym_comment] = ACTIONS(57),
  },
  [33] = {
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [ts_builtin_sym_end] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_RPAREN] = ACTIONS(353),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [34] = {
    [sym_redirected_statement] = STATE(249),
    [sym_for_statement] = STATE(249),
    [sym_c_style_for_statement] = STATE(249),
    [sym_while_statement] = STATE(249),
    [sym_if_statement] = STATE(249),
    [sym_case_statement] = STATE(249),
    [sym_function_definition] = STATE(249),
    [sym_compound_statement] = STATE(249),
    [sym_subshell] = STATE(249),
    [sym_pipeline] = STATE(249),
    [sym_list] = STATE(249),
    [sym_negated_command] = STATE(249),
    [sym_test_command] = STATE(249),
    [sym_declaration_command] = STATE(249),
    [sym_unset_command] = STATE(249),
    [sym_command] = STATE(249),
    [sym_command_name] = STATE(30),
    [sym_variable_assignment] = STATE(250),
    [sym_subscript] = STATE(32),
    [sym_file_redirect] = STATE(35),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(21),
    [sym_simple_expansion] = STATE(21),
    [sym_string_expansion] = STATE(21),
    [sym_expansion] = STATE(21),
    [sym_command_substitution] = STATE(21),
    [sym_process_substitution] = STATE(21),
    [aux_sym__statements_repeat1] = STATE(251),
    [aux_sym_command_repeat1] = STATE(35),
    [aux_sym__literal_repeat1] = STATE(36),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(27),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(33),
    [anon_sym_typeset] = ACTIONS(33),
    [anon_sym_export] = ACTIONS(33),
    [anon_sym_readonly] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym_unset] = ACTIONS(35),
    [anon_sym_unsetenv] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(43),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(47),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(59),
  },
  [35] = {
    [sym_command_name] = STATE(252),
    [sym_variable_assignment] = STATE(253),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(253),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(21),
    [sym_simple_expansion] = STATE(21),
    [sym_string_expansion] = STATE(21),
    [sym_expansion] = STATE(21),
    [sym_command_substitution] = STATE(21),
    [sym_process_substitution] = STATE(21),
    [aux_sym_command_repeat1] = STATE(253),
    [aux_sym__literal_repeat1] = STATE(36),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(427),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(47),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(47),
  },
  [36] = {
    [aux_sym__literal_repeat1] = STATE(255),
    [sym__simple_heredoc_body] = ACTIONS(437),
    [sym__heredoc_body_beginning] = ACTIONS(437),
    [sym_file_descriptor] = ACTIONS(437),
    [ts_builtin_sym_end] = ACTIONS(437),
    [anon_sym_SEMI] = ACTIONS(439),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI_SEMI] = ACTIONS(437),
    [anon_sym_PIPE_AMP] = ACTIONS(437),
    [anon_sym_AMP_AMP] = ACTIONS(437),
    [anon_sym_PIPE_PIPE] = ACTIONS(437),
    [anon_sym_EQ_TILDE] = ACTIONS(439),
    [anon_sym_EQ_EQ] = ACTIONS(439),
    [anon_sym_LT] = ACTIONS(439),
    [anon_sym_GT] = ACTIONS(439),
    [anon_sym_GT_GT] = ACTIONS(437),
    [anon_sym_AMP_GT] = ACTIONS(439),
    [anon_sym_AMP_GT_GT] = ACTIONS(437),
    [anon_sym_LT_AMP] = ACTIONS(437),
    [anon_sym_GT_AMP] = ACTIONS(437),
    [anon_sym_LT_LT] = ACTIONS(439),
    [anon_sym_LT_LT_DASH] = ACTIONS(437),
    [anon_sym_LT_LT_LT] = ACTIONS(437),
    [anon_sym_DOLLAR] = ACTIONS(439),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(437),
    [sym_raw_string] = ACTIONS(437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(437),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(437),
    [anon_sym_BQUOTE] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(437),
    [anon_sym_GT_LPAREN] = ACTIONS(437),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(439),
    [anon_sym_LF] = ACTIONS(437),
    [anon_sym_AMP] = ACTIONS(439),
  },
  [37] = {
    [sym_concatenation] = STATE(257),
    [sym_string] = STATE(256),
    [sym_simple_expansion] = STATE(256),
    [sym_string_expansion] = STATE(256),
    [sym_expansion] = STATE(256),
    [sym_command_substitution] = STATE(256),
    [sym_process_substitution] = STATE(256),
    [aux_sym__literal_repeat1] = STATE(258),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [sym__special_character] = ACTIONS(311),
    [anon_sym_DQUOTE] = ACTIONS(313),
    [sym_raw_string] = ACTIONS(443),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(317),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(319),
    [anon_sym_BQUOTE] = ACTIONS(321),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(443),
  },
  [38] = {
    [sym_concatenation] = STATE(261),
    [sym_string] = STATE(260),
    [sym_simple_expansion] = STATE(260),
    [sym_string_expansion] = STATE(260),
    [sym_expansion] = STATE(260),
    [sym_command_substitution] = STATE(260),
    [sym_process_substitution] = STATE(260),
    [aux_sym__literal_repeat1] = STATE(262),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__special_character] = ACTIONS(445),
    [anon_sym_DQUOTE] = ACTIONS(233),
    [sym_raw_string] = ACTIONS(447),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [anon_sym_LT_LPAREN] = ACTIONS(243),
    [anon_sym_GT_LPAREN] = ACTIONS(243),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(447),
  },
  [39] = {
    [sym_concatenation] = STATE(263),
    [sym_string] = STATE(268),
    [sym_array] = STATE(263),
    [sym_simple_expansion] = STATE(268),
    [sym_string_expansion] = STATE(268),
    [sym_expansion] = STATE(268),
    [sym_command_substitution] = STATE(268),
    [sym_process_substitution] = STATE(268),
    [aux_sym__literal_repeat1] = STATE(273),
    [sym__empty_value] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_DOLLAR] = ACTIONS(453),
    [sym__special_character] = ACTIONS(455),
    [anon_sym_DQUOTE] = ACTIONS(457),
    [sym_raw_string] = ACTIONS(459),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(461),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(463),
    [anon_sym_BQUOTE] = ACTIONS(465),
    [anon_sym_LT_LPAREN] = ACTIONS(467),
    [anon_sym_GT_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(459),
  },
  [40] = {
    [sym__expression] = STATE(285),
    [sym_binary_expression] = STATE(285),
    [sym_unary_expression] = STATE(285),
    [sym_postfix_expression] = STATE(285),
    [sym_parenthesized_expression] = STATE(285),
    [sym_concatenation] = STATE(285),
    [sym_string] = STATE(280),
    [sym_simple_expansion] = STATE(280),
    [sym_string_expansion] = STATE(280),
    [sym_expansion] = STATE(280),
    [sym_command_substitution] = STATE(280),
    [sym_process_substitution] = STATE(280),
    [aux_sym__literal_repeat1] = STATE(286),
    [anon_sym_SEMI] = ACTIONS(469),
    [anon_sym_SEMI_SEMI] = ACTIONS(471),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(475),
    [anon_sym_DOLLAR] = ACTIONS(477),
    [sym__special_character] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(481),
    [sym_raw_string] = ACTIONS(483),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(485),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(487),
    [anon_sym_BQUOTE] = ACTIONS(489),
    [anon_sym_LT_LPAREN] = ACTIONS(491),
    [anon_sym_GT_LPAREN] = ACTIONS(491),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(493),
    [sym_test_operator] = ACTIONS(495),
    [anon_sym_LF] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
  },
  [41] = {
    [anon_sym_in] = ACTIONS(497),
    [anon_sym_SEMI] = ACTIONS(499),
    [anon_sym_SEMI_SEMI] = ACTIONS(501),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
  },
  [42] = {
    [sym__expression] = STATE(299),
    [sym_binary_expression] = STATE(299),
    [sym_unary_expression] = STATE(299),
    [sym_postfix_expression] = STATE(299),
    [sym_parenthesized_expression] = STATE(299),
    [sym_concatenation] = STATE(299),
    [sym_string] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [sym_expansion] = STATE(294),
    [sym_command_substitution] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(300),
    [anon_sym_LPAREN] = ACTIONS(503),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_DOLLAR] = ACTIONS(507),
    [sym__special_character] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(513),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(523),
    [sym_test_operator] = ACTIONS(525),
  },
  [43] = {
    [sym__expression] = STATE(301),
    [sym_binary_expression] = STATE(301),
    [sym_unary_expression] = STATE(301),
    [sym_postfix_expression] = STATE(301),
    [sym_parenthesized_expression] = STATE(301),
    [sym_concatenation] = STATE(301),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__literal_repeat1] = STATE(53),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_DOLLAR] = ACTIONS(77),
    [sym__special_character] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [44] = {
    [sym_string] = STATE(303),
    [anon_sym_DASH] = ACTIONS(527),
    [anon_sym_DOLLAR] = ACTIONS(527),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(529),
    [anon_sym_POUND] = ACTIONS(527),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [anon_sym_QMARK] = ACTIONS(533),
    [anon_sym_0] = ACTIONS(531),
    [anon_sym__] = ACTIONS(531),
  },
  [45] = {
    [aux_sym_concatenation_repeat1] = STATE(306),
    [sym__concat] = ACTIONS(535),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_EQ_TILDE] = ACTIONS(335),
    [anon_sym_EQ_EQ] = ACTIONS(335),
    [anon_sym_EQ] = ACTIONS(339),
    [anon_sym_PLUS_EQ] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(335),
    [anon_sym_PLUS] = ACTIONS(339),
    [anon_sym_DASH] = ACTIONS(339),
    [anon_sym_DASH_EQ] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(335),
    [anon_sym_GT_EQ] = ACTIONS(335),
    [anon_sym_PLUS_PLUS] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(335),
    [sym__special_character] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(335),
  },
  [46] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(309),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [47] = {
    [aux_sym_concatenation_repeat1] = STATE(306),
    [sym__concat] = ACTIONS(535),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(541),
    [anon_sym_AMP_AMP] = ACTIONS(541),
    [anon_sym_PIPE_PIPE] = ACTIONS(541),
    [anon_sym_EQ_TILDE] = ACTIONS(541),
    [anon_sym_EQ_EQ] = ACTIONS(541),
    [anon_sym_EQ] = ACTIONS(543),
    [anon_sym_PLUS_EQ] = ACTIONS(541),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_BANG_EQ] = ACTIONS(541),
    [anon_sym_PLUS] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(543),
    [anon_sym_DASH_EQ] = ACTIONS(541),
    [anon_sym_LT_EQ] = ACTIONS(541),
    [anon_sym_GT_EQ] = ACTIONS(541),
    [anon_sym_PLUS_PLUS] = ACTIONS(541),
    [anon_sym_DASH_DASH] = ACTIONS(541),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(541),
  },
  [48] = {
    [sym_subscript] = STATE(313),
    [sym_variable_name] = ACTIONS(545),
    [anon_sym_BANG] = ACTIONS(547),
    [anon_sym_DASH] = ACTIONS(549),
    [anon_sym_DOLLAR] = ACTIONS(549),
    [anon_sym_POUND] = ACTIONS(547),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(551),
    [anon_sym_STAR] = ACTIONS(553),
    [anon_sym_AT] = ACTIONS(553),
    [anon_sym_QMARK] = ACTIONS(553),
    [anon_sym_0] = ACTIONS(551),
    [anon_sym__] = ACTIONS(551),
  },
  [49] = {
    [sym__statements] = STATE(314),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(315),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [50] = {
    [sym__statements] = STATE(316),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [51] = {
    [sym__statements] = STATE(317),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [52] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(555),
    [anon_sym_AMP_AMP] = ACTIONS(557),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(559),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_PLUS_EQ] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DASH_EQ] = ACTIONS(557),
    [anon_sym_LT_EQ] = ACTIONS(557),
    [anon_sym_GT_EQ] = ACTIONS(557),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(557),
  },
  [53] = {
    [aux_sym__literal_repeat1] = STATE(323),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(565),
    [anon_sym_AMP_AMP] = ACTIONS(565),
    [anon_sym_PIPE_PIPE] = ACTIONS(565),
    [anon_sym_EQ_TILDE] = ACTIONS(565),
    [anon_sym_EQ_EQ] = ACTIONS(565),
    [anon_sym_EQ] = ACTIONS(567),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_LT] = ACTIONS(567),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_LT_EQ] = ACTIONS(565),
    [anon_sym_GT_EQ] = ACTIONS(565),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [sym__special_character] = ACTIONS(569),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(565),
  },
  [54] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [sym_comment] = ACTIONS(57),
  },
  [55] = {
    [anon_sym_LPAREN_LPAREN] = ACTIONS(573),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(575),
  },
  [56] = {
    [sym__expression] = STATE(327),
    [sym_binary_expression] = STATE(327),
    [sym_unary_expression] = STATE(327),
    [sym_postfix_expression] = STATE(327),
    [sym_parenthesized_expression] = STATE(327),
    [sym_concatenation] = STATE(327),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__literal_repeat1] = STATE(53),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_DOLLAR] = ACTIONS(77),
    [sym__special_character] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [57] = {
    [sym__terminated_statement] = STATE(328),
    [sym_redirected_statement] = STATE(78),
    [sym_for_statement] = STATE(78),
    [sym_c_style_for_statement] = STATE(78),
    [sym_while_statement] = STATE(78),
    [sym_if_statement] = STATE(78),
    [sym_case_statement] = STATE(78),
    [sym_function_definition] = STATE(78),
    [sym_compound_statement] = STATE(78),
    [sym_subshell] = STATE(78),
    [sym_pipeline] = STATE(78),
    [sym_list] = STATE(78),
    [sym_negated_command] = STATE(78),
    [sym_test_command] = STATE(78),
    [sym_declaration_command] = STATE(78),
    [sym_unset_command] = STATE(78),
    [sym_command] = STATE(78),
    [sym_command_name] = STATE(79),
    [sym_variable_assignment] = STATE(80),
    [sym_subscript] = STATE(81),
    [sym_file_redirect] = STATE(83),
    [sym_concatenation] = STATE(82),
    [sym_string] = STATE(71),
    [sym_simple_expansion] = STATE(71),
    [sym_string_expansion] = STATE(71),
    [sym_expansion] = STATE(71),
    [sym_command_substitution] = STATE(71),
    [sym_process_substitution] = STATE(71),
    [aux_sym_command_repeat1] = STATE(83),
    [aux_sym__literal_repeat1] = STATE(84),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_case] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(125),
    [sym__special_character] = ACTIONS(127),
    [anon_sym_DQUOTE] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(131),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [58] = {
    [sym__terminated_statement] = STATE(329),
    [sym_redirected_statement] = STATE(78),
    [sym_for_statement] = STATE(78),
    [sym_c_style_for_statement] = STATE(78),
    [sym_while_statement] = STATE(78),
    [sym_if_statement] = STATE(78),
    [sym_case_statement] = STATE(78),
    [sym_function_definition] = STATE(78),
    [sym_compound_statement] = STATE(78),
    [sym_subshell] = STATE(78),
    [sym_pipeline] = STATE(78),
    [sym_list] = STATE(78),
    [sym_negated_command] = STATE(78),
    [sym_test_command] = STATE(78),
    [sym_declaration_command] = STATE(78),
    [sym_unset_command] = STATE(78),
    [sym_command] = STATE(78),
    [sym_command_name] = STATE(79),
    [sym_variable_assignment] = STATE(80),
    [sym_subscript] = STATE(81),
    [sym_file_redirect] = STATE(83),
    [sym_concatenation] = STATE(82),
    [sym_string] = STATE(71),
    [sym_simple_expansion] = STATE(71),
    [sym_string_expansion] = STATE(71),
    [sym_expansion] = STATE(71),
    [sym_command_substitution] = STATE(71),
    [sym_process_substitution] = STATE(71),
    [aux_sym_command_repeat1] = STATE(83),
    [aux_sym__literal_repeat1] = STATE(84),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_case] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(125),
    [sym__special_character] = ACTIONS(127),
    [anon_sym_DQUOTE] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(131),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [59] = {
    [sym_concatenation] = STATE(331),
    [sym_string] = STATE(330),
    [sym_simple_expansion] = STATE(330),
    [sym_string_expansion] = STATE(330),
    [sym_expansion] = STATE(330),
    [sym_command_substitution] = STATE(330),
    [sym_process_substitution] = STATE(330),
    [aux_sym__literal_repeat1] = STATE(332),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [sym__special_character] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [sym_raw_string] = ACTIONS(577),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [anon_sym_LT_LPAREN] = ACTIONS(157),
    [anon_sym_GT_LPAREN] = ACTIONS(157),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(577),
  },
  [60] = {
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(579),
  },
  [61] = {
    [sym__statements] = STATE(334),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [62] = {
    [sym__statements] = STATE(336),
    [sym_redirected_statement] = STATE(137),
    [sym_for_statement] = STATE(137),
    [sym_c_style_for_statement] = STATE(137),
    [sym_while_statement] = STATE(137),
    [sym_if_statement] = STATE(137),
    [sym_case_statement] = STATE(137),
    [sym_function_definition] = STATE(137),
    [sym_compound_statement] = STATE(137),
    [sym_subshell] = STATE(137),
    [sym_pipeline] = STATE(137),
    [sym_list] = STATE(137),
    [sym_negated_command] = STATE(137),
    [sym_test_command] = STATE(137),
    [sym_declaration_command] = STATE(137),
    [sym_unset_command] = STATE(137),
    [sym_command] = STATE(137),
    [sym_command_name] = STATE(138),
    [sym_variable_assignment] = STATE(139),
    [sym_subscript] = STATE(140),
    [sym_file_redirect] = STATE(143),
    [sym_concatenation] = STATE(141),
    [sym_string] = STATE(130),
    [sym_simple_expansion] = STATE(130),
    [sym_string_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [sym_process_substitution] = STATE(130),
    [aux_sym__statements_repeat1] = STATE(142),
    [aux_sym_command_repeat1] = STATE(143),
    [aux_sym__literal_repeat1] = STATE(144),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(179),
    [anon_sym_while] = ACTIONS(181),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_case] = ACTIONS(185),
    [anon_sym_function] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_LBRACE] = ACTIONS(191),
    [anon_sym_RBRACE] = ACTIONS(581),
    [anon_sym_BANG] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(199),
    [anon_sym_declare] = ACTIONS(201),
    [anon_sym_typeset] = ACTIONS(201),
    [anon_sym_export] = ACTIONS(201),
    [anon_sym_readonly] = ACTIONS(201),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_unset] = ACTIONS(203),
    [anon_sym_unsetenv] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(205),
    [sym__special_character] = ACTIONS(207),
    [anon_sym_DQUOTE] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(221),
  },
  [63] = {
    [sym_subshell] = STATE(337),
    [sym_test_command] = STATE(337),
    [sym_command] = STATE(337),
    [sym_command_name] = STATE(79),
    [sym_variable_assignment] = STATE(83),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(83),
    [sym_concatenation] = STATE(82),
    [sym_string] = STATE(71),
    [sym_simple_expansion] = STATE(71),
    [sym_string_expansion] = STATE(71),
    [sym_expansion] = STATE(71),
    [sym_command_substitution] = STATE(71),
    [sym_process_substitution] = STATE(71),
    [aux_sym_command_repeat1] = STATE(83),
    [aux_sym__literal_repeat1] = STATE(84),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(125),
    [sym__special_character] = ACTIONS(127),
    [anon_sym_DQUOTE] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(131),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(131),
  },
  [64] = {
    [sym__expression] = STATE(338),
    [sym_binary_expression] = STATE(338),
    [sym_unary_expression] = STATE(338),
    [sym_postfix_expression] = STATE(338),
    [sym_parenthesized_expression] = STATE(338),
    [sym_concatenation] = STATE(338),
    [sym_string] = STATE(153),
    [sym_simple_expansion] = STATE(153),
    [sym_string_expansion] = STATE(153),
    [sym_expansion] = STATE(153),
    [sym_command_substitution] = STATE(153),
    [sym_process_substitution] = STATE(153),
    [aux_sym__literal_repeat1] = STATE(159),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_BANG] = ACTIONS(227),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__special_character] = ACTIONS(231),
    [anon_sym_DQUOTE] = ACTIONS(233),
    [sym_raw_string] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [anon_sym_LT_LPAREN] = ACTIONS(243),
    [anon_sym_GT_LPAREN] = ACTIONS(243),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(245),
    [sym_test_operator] = ACTIONS(247),
  },
  [65] = {
    [sym__expression] = STATE(339),
    [sym_binary_expression] = STATE(339),
    [sym_unary_expression] = STATE(339),
    [sym_postfix_expression] = STATE(339),
    [sym_parenthesized_expression] = STATE(339),
    [sym_concatenation] = STATE(339),
    [sym_string] = STATE(162),
    [sym_simple_expansion] = STATE(162),
    [sym_string_expansion] = STATE(162),
    [sym_expansion] = STATE(162),
    [sym_command_substitution] = STATE(162),
    [sym_process_substitution] = STATE(162),
    [aux_sym__literal_repeat1] = STATE(164),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(249),
    [anon_sym_DOLLAR] = ACTIONS(77),
    [sym__special_character] = ACTIONS(251),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(255),
    [sym_test_operator] = ACTIONS(257),
  },
  [66] = {
    [sym_variable_assignment] = STATE(350),
    [sym_subscript] = STATE(349),
    [sym_concatenation] = STATE(350),
    [sym_string] = STATE(344),
    [sym_simple_expansion] = STATE(344),
    [sym_string_expansion] = STATE(344),
    [sym_expansion] = STATE(344),
    [sym_command_substitution] = STATE(344),
    [sym_process_substitution] = STATE(344),
    [aux_sym_declaration_command_repeat1] = STATE(350),
    [aux_sym__literal_repeat1] = STATE(351),
    [sym_file_descriptor] = ACTIONS(259),
    [sym_variable_name] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_SEMI_SEMI] = ACTIONS(259),
    [anon_sym_PIPE_AMP] = ACTIONS(259),
    [anon_sym_AMP_AMP] = ACTIONS(259),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_LT] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_GT_GT] = ACTIONS(259),
    [anon_sym_AMP_GT] = ACTIONS(263),
    [anon_sym_AMP_GT_GT] = ACTIONS(259),
    [anon_sym_LT_AMP] = ACTIONS(259),
    [anon_sym_GT_AMP] = ACTIONS(259),
    [anon_sym_LT_LT] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(259),
    [anon_sym_LT_LT_LT] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(585),
    [sym__special_character] = ACTIONS(587),
    [anon_sym_DQUOTE] = ACTIONS(589),
    [sym_raw_string] = ACTIONS(591),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(593),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(595),
    [anon_sym_BQUOTE] = ACTIONS(597),
    [anon_sym_LT_LPAREN] = ACTIONS(599),
    [anon_sym_GT_LPAREN] = ACTIONS(599),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(601),
    [sym_word] = ACTIONS(603),
    [anon_sym_LF] = ACTIONS(259),
    [anon_sym_AMP] = ACTIONS(263),
  },
  [67] = {
    [sym_concatenation] = STATE(360),
    [sym_string] = STATE(355),
    [sym_simple_expansion] = STATE(355),
    [sym_string_expansion] = STATE(355),
    [sym_expansion] = STATE(355),
    [sym_command_substitution] = STATE(355),
    [sym_process_substitution] = STATE(355),
    [aux_sym_unset_command_repeat1] = STATE(360),
    [aux_sym__literal_repeat1] = STATE(361),
    [sym_file_descriptor] = ACTIONS(285),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(285),
    [anon_sym_PIPE_AMP] = ACTIONS(285),
    [anon_sym_AMP_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(287),
    [anon_sym_GT] = ACTIONS(287),
    [anon_sym_GT_GT] = ACTIONS(285),
    [anon_sym_AMP_GT] = ACTIONS(287),
    [anon_sym_AMP_GT_GT] = ACTIONS(285),
    [anon_sym_LT_AMP] = ACTIONS(285),
    [anon_sym_GT_AMP] = ACTIONS(285),
    [anon_sym_LT_LT] = ACTIONS(287),
    [anon_sym_LT_LT_DASH] = ACTIONS(285),
    [anon_sym_LT_LT_LT] = ACTIONS(285),
    [anon_sym_DOLLAR] = ACTIONS(605),
    [sym__special_character] = ACTIONS(607),
    [anon_sym_DQUOTE] = ACTIONS(609),
    [sym_raw_string] = ACTIONS(611),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(613),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(615),
    [anon_sym_BQUOTE] = ACTIONS(617),
    [anon_sym_LT_LPAREN] = ACTIONS(619),
    [anon_sym_GT_LPAREN] = ACTIONS(619),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(621),
    [sym_word] = ACTIONS(623),
    [anon_sym_LF] = ACTIONS(285),
    [anon_sym_AMP] = ACTIONS(287),
  },
  [68] = {
    [sym_string] = STATE(363),
    [anon_sym_DASH] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(625),
    [anon_sym_DQUOTE] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(627),
    [anon_sym_POUND] = ACTIONS(625),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(629),
    [anon_sym_STAR] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(631),
    [anon_sym_QMARK] = ACTIONS(631),
    [anon_sym_0] = ACTIONS(629),
    [anon_sym__] = ACTIONS(629),
  },
  [69] = {
    [aux_sym_concatenation_repeat1] = STATE(366),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(633),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_EQ_TILDE] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [70] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(369),
    [anon_sym_DOLLAR] = ACTIONS(635),
    [anon_sym_DQUOTE] = ACTIONS(637),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [71] = {
    [aux_sym_concatenation_repeat1] = STATE(366),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(633),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [72] = {
    [sym_subscript] = STATE(373),
    [sym_variable_name] = ACTIONS(639),
    [anon_sym_BANG] = ACTIONS(641),
    [anon_sym_DASH] = ACTIONS(643),
    [anon_sym_DOLLAR] = ACTIONS(643),
    [anon_sym_POUND] = ACTIONS(641),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(645),
    [anon_sym_STAR] = ACTIONS(647),
    [anon_sym_AT] = ACTIONS(647),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_0] = ACTIONS(645),
    [anon_sym__] = ACTIONS(645),
  },
  [73] = {
    [sym__statements] = STATE(374),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(375),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [74] = {
    [sym__statements] = STATE(376),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [75] = {
    [sym__statements] = STATE(377),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [76] = {
    [aux_sym_concatenation_repeat1] = STATE(366),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(633),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_LPAREN] = ACTIONS(649),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [77] = {
    [sym_do_group] = STATE(380),
    [anon_sym_do] = ACTIONS(651),
    [sym_comment] = ACTIONS(57),
  },
  [78] = {
    [sym_file_redirect] = STATE(388),
    [sym_heredoc_redirect] = STATE(388),
    [sym_herestring_redirect] = STATE(388),
    [aux_sym_redirected_statement_repeat1] = STATE(388),
    [sym_file_descriptor] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(655),
    [anon_sym_PIPE] = ACTIONS(657),
    [anon_sym_SEMI_SEMI] = ACTIONS(659),
    [anon_sym_PIPE_AMP] = ACTIONS(661),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(665),
    [anon_sym_GT_GT] = ACTIONS(667),
    [anon_sym_AMP_GT] = ACTIONS(665),
    [anon_sym_AMP_GT_GT] = ACTIONS(667),
    [anon_sym_LT_AMP] = ACTIONS(667),
    [anon_sym_GT_AMP] = ACTIONS(667),
    [anon_sym_LT_LT] = ACTIONS(669),
    [anon_sym_LT_LT_DASH] = ACTIONS(671),
    [anon_sym_LT_LT_LT] = ACTIONS(673),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(659),
    [anon_sym_AMP] = ACTIONS(655),
  },
  [79] = {
    [sym_concatenation] = STATE(391),
    [sym_string] = STATE(390),
    [sym_simple_expansion] = STATE(390),
    [sym_string_expansion] = STATE(390),
    [sym_expansion] = STATE(390),
    [sym_command_substitution] = STATE(390),
    [sym_process_substitution] = STATE(390),
    [aux_sym_command_repeat2] = STATE(391),
    [aux_sym__literal_repeat1] = STATE(392),
    [sym_file_descriptor] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI_SEMI] = ACTIONS(421),
    [anon_sym_PIPE_AMP] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(675),
    [anon_sym_EQ_EQ] = ACTIONS(675),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_AMP_GT] = ACTIONS(423),
    [anon_sym_AMP_GT_GT] = ACTIONS(421),
    [anon_sym_LT_AMP] = ACTIONS(421),
    [anon_sym_GT_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_LT_LT_DASH] = ACTIONS(421),
    [anon_sym_LT_LT_LT] = ACTIONS(421),
    [anon_sym_DOLLAR] = ACTIONS(125),
    [sym__special_character] = ACTIONS(677),
    [anon_sym_DQUOTE] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(679),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(681),
    [anon_sym_LF] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
  },
  [80] = {
    [sym_file_redirect] = STATE(388),
    [sym_heredoc_redirect] = STATE(388),
    [sym_herestring_redirect] = STATE(388),
    [aux_sym_redirected_statement_repeat1] = STATE(388),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(655),
    [anon_sym_PIPE] = ACTIONS(657),
    [anon_sym_SEMI_SEMI] = ACTIONS(659),
    [anon_sym_PIPE_AMP] = ACTIONS(661),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(669),
    [anon_sym_LT_LT_DASH] = ACTIONS(671),
    [anon_sym_LT_LT_LT] = ACTIONS(673),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(659),
    [anon_sym_AMP] = ACTIONS(655),
  },
  [81] = {
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [sym_comment] = ACTIONS(57),
  },
  [82] = {
    [sym_file_descriptor] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [83] = {
    [sym_command_name] = STATE(393),
    [sym_variable_assignment] = STATE(253),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(253),
    [sym_concatenation] = STATE(82),
    [sym_string] = STATE(71),
    [sym_simple_expansion] = STATE(71),
    [sym_string_expansion] = STATE(71),
    [sym_expansion] = STATE(71),
    [sym_command_substitution] = STATE(71),
    [sym_process_substitution] = STATE(71),
    [aux_sym_command_repeat1] = STATE(253),
    [aux_sym__literal_repeat1] = STATE(84),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(125),
    [sym__special_character] = ACTIONS(677),
    [anon_sym_DQUOTE] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(131),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(131),
  },
  [84] = {
    [aux_sym__literal_repeat1] = STATE(395),
    [sym_file_descriptor] = ACTIONS(437),
    [anon_sym_SEMI] = ACTIONS(439),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI_SEMI] = ACTIONS(437),
    [anon_sym_PIPE_AMP] = ACTIONS(437),
    [anon_sym_AMP_AMP] = ACTIONS(437),
    [anon_sym_PIPE_PIPE] = ACTIONS(437),
    [anon_sym_EQ_TILDE] = ACTIONS(439),
    [anon_sym_EQ_EQ] = ACTIONS(439),
    [anon_sym_LT] = ACTIONS(439),
    [anon_sym_GT] = ACTIONS(439),
    [anon_sym_GT_GT] = ACTIONS(437),
    [anon_sym_AMP_GT] = ACTIONS(439),
    [anon_sym_AMP_GT_GT] = ACTIONS(437),
    [anon_sym_LT_AMP] = ACTIONS(437),
    [anon_sym_GT_AMP] = ACTIONS(437),
    [anon_sym_LT_LT] = ACTIONS(439),
    [anon_sym_LT_LT_DASH] = ACTIONS(437),
    [anon_sym_LT_LT_LT] = ACTIONS(437),
    [anon_sym_DOLLAR] = ACTIONS(439),
    [sym__special_character] = ACTIONS(683),
    [anon_sym_DQUOTE] = ACTIONS(437),
    [sym_raw_string] = ACTIONS(437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(437),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(437),
    [anon_sym_BQUOTE] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(437),
    [anon_sym_GT_LPAREN] = ACTIONS(437),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(439),
    [anon_sym_LF] = ACTIONS(437),
    [anon_sym_AMP] = ACTIONS(439),
  },
  [85] = {
    [anon_sym_then] = ACTIONS(685),
    [sym_comment] = ACTIONS(57),
  },
  [86] = {
    [sym_string] = STATE(398),
    [anon_sym_DASH] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(687),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [sym_raw_string] = ACTIONS(689),
    [anon_sym_POUND] = ACTIONS(687),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(691),
    [anon_sym_STAR] = ACTIONS(693),
    [anon_sym_AT] = ACTIONS(693),
    [anon_sym_QMARK] = ACTIONS(693),
    [anon_sym_0] = ACTIONS(691),
    [anon_sym__] = ACTIONS(691),
  },
  [87] = {
    [aux_sym_concatenation_repeat1] = STATE(401),
    [sym__concat] = ACTIONS(695),
    [anon_sym_in] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [sym__special_character] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(335),
  },
  [88] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(404),
    [anon_sym_DOLLAR] = ACTIONS(697),
    [anon_sym_DQUOTE] = ACTIONS(699),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [89] = {
    [aux_sym_concatenation_repeat1] = STATE(401),
    [sym__concat] = ACTIONS(695),
    [anon_sym_in] = ACTIONS(701),
    [anon_sym_SEMI] = ACTIONS(703),
    [anon_sym_SEMI_SEMI] = ACTIONS(705),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(705),
    [anon_sym_AMP] = ACTIONS(705),
  },
  [90] = {
    [sym_subscript] = STATE(410),
    [sym_variable_name] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(709),
    [anon_sym_DASH] = ACTIONS(711),
    [anon_sym_DOLLAR] = ACTIONS(711),
    [anon_sym_POUND] = ACTIONS(709),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_AT] = ACTIONS(715),
    [anon_sym_QMARK] = ACTIONS(715),
    [anon_sym_0] = ACTIONS(713),
    [anon_sym__] = ACTIONS(713),
  },
  [91] = {
    [sym__statements] = STATE(411),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(412),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [92] = {
    [sym__statements] = STATE(413),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [93] = {
    [sym__statements] = STATE(414),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [94] = {
    [anon_sym_in] = ACTIONS(701),
    [anon_sym_SEMI] = ACTIONS(703),
    [anon_sym_SEMI_SEMI] = ACTIONS(705),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(705),
    [anon_sym_AMP] = ACTIONS(705),
  },
  [95] = {
    [aux_sym__literal_repeat1] = STATE(418),
    [anon_sym_in] = ACTIONS(717),
    [anon_sym_SEMI] = ACTIONS(719),
    [anon_sym_SEMI_SEMI] = ACTIONS(721),
    [sym__special_character] = ACTIONS(723),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(721),
    [anon_sym_AMP] = ACTIONS(721),
  },
  [96] = {
    [sym_compound_statement] = STATE(420),
    [anon_sym_LPAREN] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(57),
  },
  [97] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(727),
    [anon_sym_PLUS_EQ] = ACTIONS(727),
    [sym_comment] = ACTIONS(57),
  },
  [98] = {
    [sym_subshell] = STATE(146),
    [sym_test_command] = STATE(146),
    [sym_command] = STATE(146),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(110),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(171),
  },
  [99] = {
    [sym_variable_assignment] = STATE(426),
    [sym_subscript] = STATE(425),
    [sym_concatenation] = STATE(426),
    [sym_string] = STATE(424),
    [sym_simple_expansion] = STATE(424),
    [sym_string_expansion] = STATE(424),
    [sym_expansion] = STATE(424),
    [sym_command_substitution] = STATE(424),
    [sym_process_substitution] = STATE(424),
    [aux_sym_declaration_command_repeat1] = STATE(426),
    [aux_sym__literal_repeat1] = STATE(427),
    [sym__simple_heredoc_body] = ACTIONS(259),
    [sym__heredoc_body_beginning] = ACTIONS(259),
    [sym_file_descriptor] = ACTIONS(259),
    [sym_variable_name] = ACTIONS(729),
    [anon_sym_SEMI] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_RPAREN] = ACTIONS(259),
    [anon_sym_SEMI_SEMI] = ACTIONS(259),
    [anon_sym_PIPE_AMP] = ACTIONS(259),
    [anon_sym_AMP_AMP] = ACTIONS(259),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_LT] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_GT_GT] = ACTIONS(259),
    [anon_sym_AMP_GT] = ACTIONS(263),
    [anon_sym_AMP_GT_GT] = ACTIONS(259),
    [anon_sym_LT_AMP] = ACTIONS(259),
    [anon_sym_GT_AMP] = ACTIONS(259),
    [anon_sym_LT_LT] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(259),
    [anon_sym_LT_LT_LT] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(265),
    [sym__special_character] = ACTIONS(731),
    [anon_sym_DQUOTE] = ACTIONS(269),
    [sym_raw_string] = ACTIONS(733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(277),
    [anon_sym_LT_LPAREN] = ACTIONS(279),
    [anon_sym_GT_LPAREN] = ACTIONS(279),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(735),
    [sym_word] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(259),
    [anon_sym_AMP] = ACTIONS(263),
  },
  [100] = {
    [sym_concatenation] = STATE(430),
    [sym_string] = STATE(429),
    [sym_simple_expansion] = STATE(429),
    [sym_string_expansion] = STATE(429),
    [sym_expansion] = STATE(429),
    [sym_command_substitution] = STATE(429),
    [sym_process_substitution] = STATE(429),
    [aux_sym_unset_command_repeat1] = STATE(430),
    [aux_sym__literal_repeat1] = STATE(431),
    [sym__simple_heredoc_body] = ACTIONS(285),
    [sym__heredoc_body_beginning] = ACTIONS(285),
    [sym_file_descriptor] = ACTIONS(285),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_RPAREN] = ACTIONS(285),
    [anon_sym_SEMI_SEMI] = ACTIONS(285),
    [anon_sym_PIPE_AMP] = ACTIONS(285),
    [anon_sym_AMP_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(287),
    [anon_sym_GT] = ACTIONS(287),
    [anon_sym_GT_GT] = ACTIONS(285),
    [anon_sym_AMP_GT] = ACTIONS(287),
    [anon_sym_AMP_GT_GT] = ACTIONS(285),
    [anon_sym_LT_AMP] = ACTIONS(285),
    [anon_sym_GT_AMP] = ACTIONS(285),
    [anon_sym_LT_LT] = ACTIONS(287),
    [anon_sym_LT_LT_DASH] = ACTIONS(285),
    [anon_sym_LT_LT_LT] = ACTIONS(285),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym__special_character] = ACTIONS(739),
    [anon_sym_DQUOTE] = ACTIONS(293),
    [sym_raw_string] = ACTIONS(741),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(297),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(301),
    [anon_sym_LT_LPAREN] = ACTIONS(303),
    [anon_sym_GT_LPAREN] = ACTIONS(303),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(743),
    [sym_word] = ACTIONS(745),
    [anon_sym_LF] = ACTIONS(285),
    [anon_sym_AMP] = ACTIONS(287),
  },
  [101] = {
    [aux_sym_concatenation_repeat1] = STATE(432),
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_RPAREN] = ACTIONS(335),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_EQ_TILDE] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [102] = {
    [aux_sym_concatenation_repeat1] = STATE(432),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_RPAREN] = ACTIONS(353),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [103] = {
    [aux_sym_concatenation_repeat1] = STATE(432),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_RPAREN] = ACTIONS(353),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_LPAREN] = ACTIONS(387),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [104] = {
    [anon_sym_RPAREN] = ACTIONS(747),
    [sym_comment] = ACTIONS(57),
  },
  [105] = {
    [sym_file_redirect] = STATE(439),
    [sym_heredoc_redirect] = STATE(439),
    [sym_heredoc_body] = STATE(243),
    [sym_herestring_redirect] = STATE(439),
    [aux_sym_redirected_statement_repeat1] = STATE(439),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(749),
    [anon_sym_SEMI] = ACTIONS(401),
    [anon_sym_PIPE] = ACTIONS(751),
    [anon_sym_RPAREN] = ACTIONS(399),
    [anon_sym_SEMI_SEMI] = ACTIONS(405),
    [anon_sym_PIPE_AMP] = ACTIONS(753),
    [anon_sym_AMP_AMP] = ACTIONS(755),
    [anon_sym_PIPE_PIPE] = ACTIONS(755),
    [anon_sym_LT] = ACTIONS(757),
    [anon_sym_GT] = ACTIONS(757),
    [anon_sym_GT_GT] = ACTIONS(759),
    [anon_sym_AMP_GT] = ACTIONS(757),
    [anon_sym_AMP_GT_GT] = ACTIONS(759),
    [anon_sym_LT_AMP] = ACTIONS(759),
    [anon_sym_GT_AMP] = ACTIONS(759),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(761),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(405),
    [anon_sym_AMP] = ACTIONS(401),
  },
  [106] = {
    [sym_concatenation] = STATE(442),
    [sym_string] = STATE(441),
    [sym_simple_expansion] = STATE(441),
    [sym_string_expansion] = STATE(441),
    [sym_expansion] = STATE(441),
    [sym_command_substitution] = STATE(441),
    [sym_process_substitution] = STATE(441),
    [aux_sym_command_repeat2] = STATE(442),
    [aux_sym__literal_repeat1] = STATE(443),
    [sym__simple_heredoc_body] = ACTIONS(421),
    [sym__heredoc_body_beginning] = ACTIONS(421),
    [sym_file_descriptor] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_RPAREN] = ACTIONS(421),
    [anon_sym_SEMI_SEMI] = ACTIONS(421),
    [anon_sym_PIPE_AMP] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(763),
    [anon_sym_EQ_EQ] = ACTIONS(763),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_AMP_GT] = ACTIONS(423),
    [anon_sym_AMP_GT_GT] = ACTIONS(421),
    [anon_sym_LT_AMP] = ACTIONS(421),
    [anon_sym_GT_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_LT_LT_DASH] = ACTIONS(421),
    [anon_sym_LT_LT_LT] = ACTIONS(421),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(767),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(769),
    [anon_sym_LF] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
  },
  [107] = {
    [sym_file_redirect] = STATE(439),
    [sym_heredoc_redirect] = STATE(439),
    [sym_heredoc_body] = STATE(243),
    [sym_herestring_redirect] = STATE(439),
    [aux_sym_redirected_statement_repeat1] = STATE(439),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(401),
    [anon_sym_PIPE] = ACTIONS(751),
    [anon_sym_RPAREN] = ACTIONS(399),
    [anon_sym_SEMI_SEMI] = ACTIONS(405),
    [anon_sym_PIPE_AMP] = ACTIONS(753),
    [anon_sym_AMP_AMP] = ACTIONS(755),
    [anon_sym_PIPE_PIPE] = ACTIONS(755),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(405),
    [anon_sym_AMP] = ACTIONS(401),
  },
  [108] = {
    [anon_sym_EQ] = ACTIONS(727),
    [anon_sym_PLUS_EQ] = ACTIONS(727),
    [sym_comment] = ACTIONS(57),
  },
  [109] = {
    [sym_redirected_statement] = STATE(444),
    [sym_for_statement] = STATE(444),
    [sym_c_style_for_statement] = STATE(444),
    [sym_while_statement] = STATE(444),
    [sym_if_statement] = STATE(444),
    [sym_case_statement] = STATE(444),
    [sym_function_definition] = STATE(444),
    [sym_compound_statement] = STATE(444),
    [sym_subshell] = STATE(444),
    [sym_pipeline] = STATE(444),
    [sym_list] = STATE(444),
    [sym_negated_command] = STATE(444),
    [sym_test_command] = STATE(444),
    [sym_declaration_command] = STATE(444),
    [sym_unset_command] = STATE(444),
    [sym_command] = STATE(444),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(445),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(251),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [110] = {
    [sym_command_name] = STATE(446),
    [sym_variable_assignment] = STATE(253),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(253),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym_command_repeat1] = STATE(253),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(171),
  },
  [111] = {
    [aux_sym__literal_repeat1] = STATE(447),
    [sym__simple_heredoc_body] = ACTIONS(437),
    [sym__heredoc_body_beginning] = ACTIONS(437),
    [sym_file_descriptor] = ACTIONS(437),
    [anon_sym_SEMI] = ACTIONS(439),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_RPAREN] = ACTIONS(437),
    [anon_sym_SEMI_SEMI] = ACTIONS(437),
    [anon_sym_PIPE_AMP] = ACTIONS(437),
    [anon_sym_AMP_AMP] = ACTIONS(437),
    [anon_sym_PIPE_PIPE] = ACTIONS(437),
    [anon_sym_EQ_TILDE] = ACTIONS(439),
    [anon_sym_EQ_EQ] = ACTIONS(439),
    [anon_sym_LT] = ACTIONS(439),
    [anon_sym_GT] = ACTIONS(439),
    [anon_sym_GT_GT] = ACTIONS(437),
    [anon_sym_AMP_GT] = ACTIONS(439),
    [anon_sym_AMP_GT_GT] = ACTIONS(437),
    [anon_sym_LT_AMP] = ACTIONS(437),
    [anon_sym_GT_AMP] = ACTIONS(437),
    [anon_sym_LT_LT] = ACTIONS(439),
    [anon_sym_LT_LT_DASH] = ACTIONS(437),
    [anon_sym_LT_LT_LT] = ACTIONS(437),
    [anon_sym_DOLLAR] = ACTIONS(439),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(437),
    [sym_raw_string] = ACTIONS(437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(437),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(437),
    [anon_sym_BQUOTE] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(437),
    [anon_sym_GT_LPAREN] = ACTIONS(437),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(439),
    [anon_sym_LF] = ACTIONS(437),
    [anon_sym_AMP] = ACTIONS(439),
  },
  [112] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_PLUS_EQ] = ACTIONS(771),
    [sym_comment] = ACTIONS(57),
  },
  [113] = {
    [anon_sym_LPAREN_LPAREN] = ACTIONS(773),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(775),
  },
  [114] = {
    [sym__expression] = STATE(451),
    [sym_binary_expression] = STATE(451),
    [sym_unary_expression] = STATE(451),
    [sym_postfix_expression] = STATE(451),
    [sym_parenthesized_expression] = STATE(451),
    [sym_concatenation] = STATE(451),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__literal_repeat1] = STATE(53),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_DOLLAR] = ACTIONS(77),
    [sym__special_character] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [115] = {
    [sym__terminated_statement] = STATE(452),
    [sym_redirected_statement] = STATE(78),
    [sym_for_statement] = STATE(78),
    [sym_c_style_for_statement] = STATE(78),
    [sym_while_statement] = STATE(78),
    [sym_if_statement] = STATE(78),
    [sym_case_statement] = STATE(78),
    [sym_function_definition] = STATE(78),
    [sym_compound_statement] = STATE(78),
    [sym_subshell] = STATE(78),
    [sym_pipeline] = STATE(78),
    [sym_list] = STATE(78),
    [sym_negated_command] = STATE(78),
    [sym_test_command] = STATE(78),
    [sym_declaration_command] = STATE(78),
    [sym_unset_command] = STATE(78),
    [sym_command] = STATE(78),
    [sym_command_name] = STATE(79),
    [sym_variable_assignment] = STATE(80),
    [sym_subscript] = STATE(81),
    [sym_file_redirect] = STATE(83),
    [sym_concatenation] = STATE(82),
    [sym_string] = STATE(71),
    [sym_simple_expansion] = STATE(71),
    [sym_string_expansion] = STATE(71),
    [sym_expansion] = STATE(71),
    [sym_command_substitution] = STATE(71),
    [sym_process_substitution] = STATE(71),
    [aux_sym_command_repeat1] = STATE(83),
    [aux_sym__literal_repeat1] = STATE(84),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_case] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(125),
    [sym__special_character] = ACTIONS(127),
    [anon_sym_DQUOTE] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(131),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [116] = {
    [sym__terminated_statement] = STATE(453),
    [sym_redirected_statement] = STATE(78),
    [sym_for_statement] = STATE(78),
    [sym_c_style_for_statement] = STATE(78),
    [sym_while_statement] = STATE(78),
    [sym_if_statement] = STATE(78),
    [sym_case_statement] = STATE(78),
    [sym_function_definition] = STATE(78),
    [sym_compound_statement] = STATE(78),
    [sym_subshell] = STATE(78),
    [sym_pipeline] = STATE(78),
    [sym_list] = STATE(78),
    [sym_negated_command] = STATE(78),
    [sym_test_command] = STATE(78),
    [sym_declaration_command] = STATE(78),
    [sym_unset_command] = STATE(78),
    [sym_command] = STATE(78),
    [sym_command_name] = STATE(79),
    [sym_variable_assignment] = STATE(80),
    [sym_subscript] = STATE(81),
    [sym_file_redirect] = STATE(83),
    [sym_concatenation] = STATE(82),
    [sym_string] = STATE(71),
    [sym_simple_expansion] = STATE(71),
    [sym_string_expansion] = STATE(71),
    [sym_expansion] = STATE(71),
    [sym_command_substitution] = STATE(71),
    [sym_process_substitution] = STATE(71),
    [aux_sym_command_repeat1] = STATE(83),
    [aux_sym__literal_repeat1] = STATE(84),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_case] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(125),
    [sym__special_character] = ACTIONS(127),
    [anon_sym_DQUOTE] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(131),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [117] = {
    [sym_concatenation] = STATE(455),
    [sym_string] = STATE(454),
    [sym_simple_expansion] = STATE(454),
    [sym_string_expansion] = STATE(454),
    [sym_expansion] = STATE(454),
    [sym_command_substitution] = STATE(454),
    [sym_process_substitution] = STATE(454),
    [aux_sym__literal_repeat1] = STATE(456),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [sym__special_character] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [sym_raw_string] = ACTIONS(777),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [anon_sym_LT_LPAREN] = ACTIONS(157),
    [anon_sym_GT_LPAREN] = ACTIONS(157),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(777),
  },
  [118] = {
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(779),
  },
  [119] = {
    [sym__statements] = STATE(458),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [120] = {
    [sym__statements] = STATE(460),
    [sym_redirected_statement] = STATE(137),
    [sym_for_statement] = STATE(137),
    [sym_c_style_for_statement] = STATE(137),
    [sym_while_statement] = STATE(137),
    [sym_if_statement] = STATE(137),
    [sym_case_statement] = STATE(137),
    [sym_function_definition] = STATE(137),
    [sym_compound_statement] = STATE(137),
    [sym_subshell] = STATE(137),
    [sym_pipeline] = STATE(137),
    [sym_list] = STATE(137),
    [sym_negated_command] = STATE(137),
    [sym_test_command] = STATE(137),
    [sym_declaration_command] = STATE(137),
    [sym_unset_command] = STATE(137),
    [sym_command] = STATE(137),
    [sym_command_name] = STATE(138),
    [sym_variable_assignment] = STATE(139),
    [sym_subscript] = STATE(140),
    [sym_file_redirect] = STATE(143),
    [sym_concatenation] = STATE(141),
    [sym_string] = STATE(130),
    [sym_simple_expansion] = STATE(130),
    [sym_string_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [sym_process_substitution] = STATE(130),
    [aux_sym__statements_repeat1] = STATE(142),
    [aux_sym_command_repeat1] = STATE(143),
    [aux_sym__literal_repeat1] = STATE(144),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(179),
    [anon_sym_while] = ACTIONS(181),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_case] = ACTIONS(185),
    [anon_sym_function] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_LBRACE] = ACTIONS(191),
    [anon_sym_RBRACE] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(199),
    [anon_sym_declare] = ACTIONS(201),
    [anon_sym_typeset] = ACTIONS(201),
    [anon_sym_export] = ACTIONS(201),
    [anon_sym_readonly] = ACTIONS(201),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_unset] = ACTIONS(203),
    [anon_sym_unsetenv] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(205),
    [sym__special_character] = ACTIONS(207),
    [anon_sym_DQUOTE] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(221),
  },
  [121] = {
    [sym__simple_heredoc_body] = ACTIONS(783),
    [sym__heredoc_body_beginning] = ACTIONS(783),
    [sym_file_descriptor] = ACTIONS(783),
    [ts_builtin_sym_end] = ACTIONS(783),
    [anon_sym_SEMI] = ACTIONS(785),
    [anon_sym_done] = ACTIONS(783),
    [anon_sym_fi] = ACTIONS(783),
    [anon_sym_elif] = ACTIONS(783),
    [anon_sym_else] = ACTIONS(783),
    [anon_sym_esac] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_RPAREN] = ACTIONS(783),
    [anon_sym_SEMI_SEMI] = ACTIONS(783),
    [anon_sym_PIPE_AMP] = ACTIONS(783),
    [anon_sym_AMP_AMP] = ACTIONS(783),
    [anon_sym_PIPE_PIPE] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(785),
    [anon_sym_GT] = ACTIONS(785),
    [anon_sym_GT_GT] = ACTIONS(783),
    [anon_sym_AMP_GT] = ACTIONS(785),
    [anon_sym_AMP_GT_GT] = ACTIONS(783),
    [anon_sym_LT_AMP] = ACTIONS(783),
    [anon_sym_GT_AMP] = ACTIONS(783),
    [anon_sym_LT_LT] = ACTIONS(785),
    [anon_sym_LT_LT_DASH] = ACTIONS(783),
    [anon_sym_LT_LT_LT] = ACTIONS(783),
    [anon_sym_BQUOTE] = ACTIONS(783),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(783),
    [anon_sym_AMP] = ACTIONS(785),
  },
  [122] = {
    [sym_subshell] = STATE(461),
    [sym_test_command] = STATE(461),
    [sym_command] = STATE(461),
    [sym_command_name] = STATE(138),
    [sym_variable_assignment] = STATE(143),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(143),
    [sym_concatenation] = STATE(141),
    [sym_string] = STATE(130),
    [sym_simple_expansion] = STATE(130),
    [sym_string_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [sym_process_substitution] = STATE(130),
    [aux_sym_command_repeat1] = STATE(143),
    [aux_sym__literal_repeat1] = STATE(144),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(179),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(199),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(205),
    [sym__special_character] = ACTIONS(207),
    [anon_sym_DQUOTE] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(211),
  },
  [123] = {
    [sym__expression] = STATE(462),
    [sym_binary_expression] = STATE(462),
    [sym_unary_expression] = STATE(462),
    [sym_postfix_expression] = STATE(462),
    [sym_parenthesized_expression] = STATE(462),
    [sym_concatenation] = STATE(462),
    [sym_string] = STATE(153),
    [sym_simple_expansion] = STATE(153),
    [sym_string_expansion] = STATE(153),
    [sym_expansion] = STATE(153),
    [sym_command_substitution] = STATE(153),
    [sym_process_substitution] = STATE(153),
    [aux_sym__literal_repeat1] = STATE(159),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_BANG] = ACTIONS(227),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__special_character] = ACTIONS(231),
    [anon_sym_DQUOTE] = ACTIONS(233),
    [sym_raw_string] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [anon_sym_LT_LPAREN] = ACTIONS(243),
    [anon_sym_GT_LPAREN] = ACTIONS(243),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(245),
    [sym_test_operator] = ACTIONS(247),
  },
  [124] = {
    [sym__expression] = STATE(463),
    [sym_binary_expression] = STATE(463),
    [sym_unary_expression] = STATE(463),
    [sym_postfix_expression] = STATE(463),
    [sym_parenthesized_expression] = STATE(463),
    [sym_concatenation] = STATE(463),
    [sym_string] = STATE(162),
    [sym_simple_expansion] = STATE(162),
    [sym_string_expansion] = STATE(162),
    [sym_expansion] = STATE(162),
    [sym_command_substitution] = STATE(162),
    [sym_process_substitution] = STATE(162),
    [aux_sym__literal_repeat1] = STATE(164),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(249),
    [anon_sym_DOLLAR] = ACTIONS(77),
    [sym__special_character] = ACTIONS(251),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(255),
    [sym_test_operator] = ACTIONS(257),
  },
  [125] = {
    [sym_variable_assignment] = STATE(474),
    [sym_subscript] = STATE(473),
    [sym_concatenation] = STATE(474),
    [sym_string] = STATE(468),
    [sym_simple_expansion] = STATE(468),
    [sym_string_expansion] = STATE(468),
    [sym_expansion] = STATE(468),
    [sym_command_substitution] = STATE(468),
    [sym_process_substitution] = STATE(468),
    [aux_sym_declaration_command_repeat1] = STATE(474),
    [aux_sym__literal_repeat1] = STATE(475),
    [sym__simple_heredoc_body] = ACTIONS(259),
    [sym__heredoc_body_beginning] = ACTIONS(259),
    [sym_file_descriptor] = ACTIONS(259),
    [sym_variable_name] = ACTIONS(787),
    [anon_sym_SEMI] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_SEMI_SEMI] = ACTIONS(259),
    [anon_sym_RBRACE] = ACTIONS(259),
    [anon_sym_PIPE_AMP] = ACTIONS(259),
    [anon_sym_AMP_AMP] = ACTIONS(259),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_LT] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_GT_GT] = ACTIONS(259),
    [anon_sym_AMP_GT] = ACTIONS(263),
    [anon_sym_AMP_GT_GT] = ACTIONS(259),
    [anon_sym_LT_AMP] = ACTIONS(259),
    [anon_sym_GT_AMP] = ACTIONS(259),
    [anon_sym_LT_LT] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(259),
    [anon_sym_LT_LT_LT] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(789),
    [sym__special_character] = ACTIONS(791),
    [anon_sym_DQUOTE] = ACTIONS(793),
    [sym_raw_string] = ACTIONS(795),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(797),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(799),
    [anon_sym_BQUOTE] = ACTIONS(801),
    [anon_sym_LT_LPAREN] = ACTIONS(803),
    [anon_sym_GT_LPAREN] = ACTIONS(803),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(805),
    [sym_word] = ACTIONS(807),
    [anon_sym_LF] = ACTIONS(259),
    [anon_sym_AMP] = ACTIONS(263),
  },
  [126] = {
    [sym_concatenation] = STATE(484),
    [sym_string] = STATE(479),
    [sym_simple_expansion] = STATE(479),
    [sym_string_expansion] = STATE(479),
    [sym_expansion] = STATE(479),
    [sym_command_substitution] = STATE(479),
    [sym_process_substitution] = STATE(479),
    [aux_sym_unset_command_repeat1] = STATE(484),
    [aux_sym__literal_repeat1] = STATE(485),
    [sym__simple_heredoc_body] = ACTIONS(285),
    [sym__heredoc_body_beginning] = ACTIONS(285),
    [sym_file_descriptor] = ACTIONS(285),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(285),
    [anon_sym_RBRACE] = ACTIONS(285),
    [anon_sym_PIPE_AMP] = ACTIONS(285),
    [anon_sym_AMP_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(287),
    [anon_sym_GT] = ACTIONS(287),
    [anon_sym_GT_GT] = ACTIONS(285),
    [anon_sym_AMP_GT] = ACTIONS(287),
    [anon_sym_AMP_GT_GT] = ACTIONS(285),
    [anon_sym_LT_AMP] = ACTIONS(285),
    [anon_sym_GT_AMP] = ACTIONS(285),
    [anon_sym_LT_LT] = ACTIONS(287),
    [anon_sym_LT_LT_DASH] = ACTIONS(285),
    [anon_sym_LT_LT_LT] = ACTIONS(285),
    [anon_sym_DOLLAR] = ACTIONS(809),
    [sym__special_character] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(813),
    [sym_raw_string] = ACTIONS(815),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(817),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(819),
    [anon_sym_BQUOTE] = ACTIONS(821),
    [anon_sym_LT_LPAREN] = ACTIONS(823),
    [anon_sym_GT_LPAREN] = ACTIONS(823),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(825),
    [sym_word] = ACTIONS(827),
    [anon_sym_LF] = ACTIONS(285),
    [anon_sym_AMP] = ACTIONS(287),
  },
  [127] = {
    [sym_string] = STATE(487),
    [anon_sym_DASH] = ACTIONS(829),
    [anon_sym_DOLLAR] = ACTIONS(829),
    [anon_sym_DQUOTE] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(831),
    [anon_sym_POUND] = ACTIONS(829),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(833),
    [anon_sym_STAR] = ACTIONS(835),
    [anon_sym_AT] = ACTIONS(835),
    [anon_sym_QMARK] = ACTIONS(835),
    [anon_sym_0] = ACTIONS(833),
    [anon_sym__] = ACTIONS(833),
  },
  [128] = {
    [aux_sym_concatenation_repeat1] = STATE(490),
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(837),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_RBRACE] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_EQ_TILDE] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [129] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(493),
    [anon_sym_DOLLAR] = ACTIONS(839),
    [anon_sym_DQUOTE] = ACTIONS(841),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [130] = {
    [aux_sym_concatenation_repeat1] = STATE(490),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(837),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_RBRACE] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym__special_character] = ACTIONS(355),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [131] = {
    [sym_subscript] = STATE(497),
    [sym_variable_name] = ACTIONS(843),
    [anon_sym_BANG] = ACTIONS(845),
    [anon_sym_DASH] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(847),
    [anon_sym_POUND] = ACTIONS(845),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(851),
    [anon_sym_AT] = ACTIONS(851),
    [anon_sym_QMARK] = ACTIONS(851),
    [anon_sym_0] = ACTIONS(849),
    [anon_sym__] = ACTIONS(849),
  },
  [132] = {
    [sym__statements] = STATE(498),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(499),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [133] = {
    [sym__statements] = STATE(500),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [134] = {
    [sym__statements] = STATE(501),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [135] = {
    [aux_sym_concatenation_repeat1] = STATE(490),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(837),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_LPAREN] = ACTIONS(853),
    [anon_sym_RBRACE] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym__special_character] = ACTIONS(355),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [136] = {
    [anon_sym_RBRACE] = ACTIONS(855),
    [sym_comment] = ACTIONS(57),
  },
  [137] = {
    [sym_file_redirect] = STATE(514),
    [sym_heredoc_redirect] = STATE(514),
    [sym_heredoc_body] = STATE(513),
    [sym_herestring_redirect] = STATE(514),
    [aux_sym_redirected_statement_repeat1] = STATE(514),
    [sym__simple_heredoc_body] = ACTIONS(857),
    [sym__heredoc_body_beginning] = ACTIONS(859),
    [sym_file_descriptor] = ACTIONS(861),
    [anon_sym_SEMI] = ACTIONS(863),
    [anon_sym_PIPE] = ACTIONS(865),
    [anon_sym_SEMI_SEMI] = ACTIONS(867),
    [anon_sym_RBRACE] = ACTIONS(399),
    [anon_sym_PIPE_AMP] = ACTIONS(869),
    [anon_sym_AMP_AMP] = ACTIONS(871),
    [anon_sym_PIPE_PIPE] = ACTIONS(871),
    [anon_sym_LT] = ACTIONS(873),
    [anon_sym_GT] = ACTIONS(873),
    [anon_sym_GT_GT] = ACTIONS(875),
    [anon_sym_AMP_GT] = ACTIONS(873),
    [anon_sym_AMP_GT_GT] = ACTIONS(875),
    [anon_sym_LT_AMP] = ACTIONS(875),
    [anon_sym_GT_AMP] = ACTIONS(875),
    [anon_sym_LT_LT] = ACTIONS(877),
    [anon_sym_LT_LT_DASH] = ACTIONS(879),
    [anon_sym_LT_LT_LT] = ACTIONS(881),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(867),
    [anon_sym_AMP] = ACTIONS(863),
  },
  [138] = {
    [sym_concatenation] = STATE(517),
    [sym_string] = STATE(516),
    [sym_simple_expansion] = STATE(516),
    [sym_string_expansion] = STATE(516),
    [sym_expansion] = STATE(516),
    [sym_command_substitution] = STATE(516),
    [sym_process_substitution] = STATE(516),
    [aux_sym_command_repeat2] = STATE(517),
    [aux_sym__literal_repeat1] = STATE(518),
    [sym__simple_heredoc_body] = ACTIONS(421),
    [sym__heredoc_body_beginning] = ACTIONS(421),
    [sym_file_descriptor] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI_SEMI] = ACTIONS(421),
    [anon_sym_RBRACE] = ACTIONS(421),
    [anon_sym_PIPE_AMP] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(883),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_AMP_GT] = ACTIONS(423),
    [anon_sym_AMP_GT_GT] = ACTIONS(421),
    [anon_sym_LT_AMP] = ACTIONS(421),
    [anon_sym_GT_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_LT_LT_DASH] = ACTIONS(421),
    [anon_sym_LT_LT_LT] = ACTIONS(421),
    [anon_sym_DOLLAR] = ACTIONS(205),
    [sym__special_character] = ACTIONS(207),
    [anon_sym_DQUOTE] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(885),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(887),
    [anon_sym_LF] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
  },
  [139] = {
    [sym_file_redirect] = STATE(514),
    [sym_heredoc_redirect] = STATE(514),
    [sym_heredoc_body] = STATE(513),
    [sym_herestring_redirect] = STATE(514),
    [aux_sym_redirected_statement_repeat1] = STATE(514),
    [sym__simple_heredoc_body] = ACTIONS(857),
    [sym__heredoc_body_beginning] = ACTIONS(859),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(863),
    [anon_sym_PIPE] = ACTIONS(865),
    [anon_sym_SEMI_SEMI] = ACTIONS(867),
    [anon_sym_RBRACE] = ACTIONS(399),
    [anon_sym_PIPE_AMP] = ACTIONS(869),
    [anon_sym_AMP_AMP] = ACTIONS(871),
    [anon_sym_PIPE_PIPE] = ACTIONS(871),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(877),
    [anon_sym_LT_LT_DASH] = ACTIONS(879),
    [anon_sym_LT_LT_LT] = ACTIONS(881),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(435),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(867),
    [anon_sym_AMP] = ACTIONS(863),
  },
  [140] = {
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_PLUS_EQ] = ACTIONS(771),
    [sym_comment] = ACTIONS(57),
  },
  [141] = {
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_RBRACE] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym__special_character] = ACTIONS(355),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [142] = {
    [sym_redirected_statement] = STATE(519),
    [sym_for_statement] = STATE(519),
    [sym_c_style_for_statement] = STATE(519),
    [sym_while_statement] = STATE(519),
    [sym_if_statement] = STATE(519),
    [sym_case_statement] = STATE(519),
    [sym_function_definition] = STATE(519),
    [sym_compound_statement] = STATE(519),
    [sym_subshell] = STATE(519),
    [sym_pipeline] = STATE(519),
    [sym_list] = STATE(519),
    [sym_negated_command] = STATE(519),
    [sym_test_command] = STATE(519),
    [sym_declaration_command] = STATE(519),
    [sym_unset_command] = STATE(519),
    [sym_command] = STATE(519),
    [sym_command_name] = STATE(138),
    [sym_variable_assignment] = STATE(520),
    [sym_subscript] = STATE(140),
    [sym_file_redirect] = STATE(143),
    [sym_concatenation] = STATE(141),
    [sym_string] = STATE(130),
    [sym_simple_expansion] = STATE(130),
    [sym_string_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [sym_process_substitution] = STATE(130),
    [aux_sym__statements_repeat1] = STATE(251),
    [aux_sym_command_repeat1] = STATE(143),
    [aux_sym__literal_repeat1] = STATE(144),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(179),
    [anon_sym_while] = ACTIONS(181),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_case] = ACTIONS(185),
    [anon_sym_function] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_LBRACE] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(199),
    [anon_sym_declare] = ACTIONS(201),
    [anon_sym_typeset] = ACTIONS(201),
    [anon_sym_export] = ACTIONS(201),
    [anon_sym_readonly] = ACTIONS(201),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_unset] = ACTIONS(203),
    [anon_sym_unsetenv] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(205),
    [sym__special_character] = ACTIONS(207),
    [anon_sym_DQUOTE] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(221),
  },
  [143] = {
    [sym_command_name] = STATE(521),
    [sym_variable_assignment] = STATE(253),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(253),
    [sym_concatenation] = STATE(141),
    [sym_string] = STATE(130),
    [sym_simple_expansion] = STATE(130),
    [sym_string_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [sym_process_substitution] = STATE(130),
    [aux_sym_command_repeat1] = STATE(253),
    [aux_sym__literal_repeat1] = STATE(144),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(205),
    [sym__special_character] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(211),
  },
  [144] = {
    [aux_sym__literal_repeat1] = STATE(523),
    [sym__simple_heredoc_body] = ACTIONS(437),
    [sym__heredoc_body_beginning] = ACTIONS(437),
    [sym_file_descriptor] = ACTIONS(437),
    [anon_sym_SEMI] = ACTIONS(439),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI_SEMI] = ACTIONS(437),
    [anon_sym_RBRACE] = ACTIONS(437),
    [anon_sym_PIPE_AMP] = ACTIONS(437),
    [anon_sym_AMP_AMP] = ACTIONS(437),
    [anon_sym_PIPE_PIPE] = ACTIONS(437),
    [anon_sym_EQ_TILDE] = ACTIONS(439),
    [anon_sym_EQ_EQ] = ACTIONS(439),
    [anon_sym_LT] = ACTIONS(439),
    [anon_sym_GT] = ACTIONS(439),
    [anon_sym_GT_GT] = ACTIONS(437),
    [anon_sym_AMP_GT] = ACTIONS(439),
    [anon_sym_AMP_GT_GT] = ACTIONS(437),
    [anon_sym_LT_AMP] = ACTIONS(437),
    [anon_sym_GT_AMP] = ACTIONS(437),
    [anon_sym_LT_LT] = ACTIONS(439),
    [anon_sym_LT_LT_DASH] = ACTIONS(437),
    [anon_sym_LT_LT_LT] = ACTIONS(437),
    [anon_sym_DOLLAR] = ACTIONS(439),
    [sym__special_character] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(437),
    [sym_raw_string] = ACTIONS(437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(437),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(437),
    [anon_sym_BQUOTE] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(437),
    [anon_sym_GT_LPAREN] = ACTIONS(437),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(439),
    [anon_sym_LF] = ACTIONS(437),
    [anon_sym_AMP] = ACTIONS(439),
  },
  [145] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(893),
    [anon_sym_PLUS_EQ] = ACTIONS(893),
    [sym_comment] = ACTIONS(57),
  },
  [146] = {
    [sym__simple_heredoc_body] = ACTIONS(895),
    [sym__heredoc_body_beginning] = ACTIONS(895),
    [sym_file_descriptor] = ACTIONS(895),
    [ts_builtin_sym_end] = ACTIONS(895),
    [anon_sym_SEMI] = ACTIONS(897),
    [anon_sym_done] = ACTIONS(895),
    [anon_sym_fi] = ACTIONS(895),
    [anon_sym_elif] = ACTIONS(895),
    [anon_sym_else] = ACTIONS(895),
    [anon_sym_esac] = ACTIONS(895),
    [anon_sym_PIPE] = ACTIONS(897),
    [anon_sym_RPAREN] = ACTIONS(895),
    [anon_sym_SEMI_SEMI] = ACTIONS(895),
    [anon_sym_PIPE_AMP] = ACTIONS(895),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(895),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(895),
    [anon_sym_LT_AMP] = ACTIONS(895),
    [anon_sym_GT_AMP] = ACTIONS(895),
    [anon_sym_LT_LT] = ACTIONS(897),
    [anon_sym_LT_LT_DASH] = ACTIONS(895),
    [anon_sym_LT_LT_LT] = ACTIONS(895),
    [anon_sym_BQUOTE] = ACTIONS(895),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(895),
    [anon_sym_AMP] = ACTIONS(897),
  },
  [147] = {
    [anon_sym_EQ] = ACTIONS(893),
    [anon_sym_PLUS_EQ] = ACTIONS(893),
    [sym_comment] = ACTIONS(57),
  },
  [148] = {
    [sym__expression] = STATE(525),
    [sym_binary_expression] = STATE(525),
    [sym_unary_expression] = STATE(525),
    [sym_postfix_expression] = STATE(525),
    [sym_parenthesized_expression] = STATE(525),
    [sym_concatenation] = STATE(525),
    [sym_string] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [sym_expansion] = STATE(294),
    [sym_command_substitution] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(300),
    [anon_sym_LPAREN] = ACTIONS(503),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_DOLLAR] = ACTIONS(507),
    [sym__special_character] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(513),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(523),
    [sym_test_operator] = ACTIONS(525),
  },
  [149] = {
    [sym__expression] = STATE(526),
    [sym_binary_expression] = STATE(526),
    [sym_unary_expression] = STATE(526),
    [sym_postfix_expression] = STATE(526),
    [sym_parenthesized_expression] = STATE(526),
    [sym_concatenation] = STATE(526),
    [sym_string] = STATE(153),
    [sym_simple_expansion] = STATE(153),
    [sym_string_expansion] = STATE(153),
    [sym_expansion] = STATE(153),
    [sym_command_substitution] = STATE(153),
    [sym_process_substitution] = STATE(153),
    [aux_sym__literal_repeat1] = STATE(159),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_BANG] = ACTIONS(227),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__special_character] = ACTIONS(231),
    [anon_sym_DQUOTE] = ACTIONS(233),
    [sym_raw_string] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [anon_sym_LT_LPAREN] = ACTIONS(243),
    [anon_sym_GT_LPAREN] = ACTIONS(243),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(245),
    [sym_test_operator] = ACTIONS(247),
  },
  [150] = {
    [sym_string] = STATE(528),
    [anon_sym_DASH] = ACTIONS(899),
    [anon_sym_DOLLAR] = ACTIONS(899),
    [anon_sym_DQUOTE] = ACTIONS(233),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_POUND] = ACTIONS(899),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(903),
    [anon_sym_STAR] = ACTIONS(905),
    [anon_sym_AT] = ACTIONS(905),
    [anon_sym_QMARK] = ACTIONS(905),
    [anon_sym_0] = ACTIONS(903),
    [anon_sym__] = ACTIONS(903),
  },
  [151] = {
    [aux_sym_concatenation_repeat1] = STATE(531),
    [sym__concat] = ACTIONS(907),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_RBRACK] = ACTIONS(335),
    [anon_sym_EQ_TILDE] = ACTIONS(335),
    [anon_sym_EQ_EQ] = ACTIONS(335),
    [anon_sym_EQ] = ACTIONS(339),
    [anon_sym_PLUS_EQ] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(335),
    [anon_sym_PLUS] = ACTIONS(339),
    [anon_sym_DASH] = ACTIONS(339),
    [anon_sym_DASH_EQ] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(335),
    [anon_sym_GT_EQ] = ACTIONS(335),
    [anon_sym_PLUS_PLUS] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(335),
    [sym__special_character] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(335),
  },
  [152] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(534),
    [anon_sym_DOLLAR] = ACTIONS(909),
    [anon_sym_DQUOTE] = ACTIONS(911),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [153] = {
    [aux_sym_concatenation_repeat1] = STATE(531),
    [sym__concat] = ACTIONS(907),
    [anon_sym_AMP_AMP] = ACTIONS(541),
    [anon_sym_PIPE_PIPE] = ACTIONS(541),
    [anon_sym_RBRACK] = ACTIONS(541),
    [anon_sym_EQ_TILDE] = ACTIONS(541),
    [anon_sym_EQ_EQ] = ACTIONS(541),
    [anon_sym_EQ] = ACTIONS(543),
    [anon_sym_PLUS_EQ] = ACTIONS(541),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_BANG_EQ] = ACTIONS(541),
    [anon_sym_PLUS] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(543),
    [anon_sym_DASH_EQ] = ACTIONS(541),
    [anon_sym_LT_EQ] = ACTIONS(541),
    [anon_sym_GT_EQ] = ACTIONS(541),
    [anon_sym_PLUS_PLUS] = ACTIONS(541),
    [anon_sym_DASH_DASH] = ACTIONS(541),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(541),
  },
  [154] = {
    [sym_subscript] = STATE(538),
    [sym_variable_name] = ACTIONS(913),
    [anon_sym_BANG] = ACTIONS(915),
    [anon_sym_DASH] = ACTIONS(917),
    [anon_sym_DOLLAR] = ACTIONS(917),
    [anon_sym_POUND] = ACTIONS(915),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(919),
    [anon_sym_STAR] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(921),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_0] = ACTIONS(919),
    [anon_sym__] = ACTIONS(919),
  },
  [155] = {
    [sym__statements] = STATE(539),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(540),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [156] = {
    [sym__statements] = STATE(541),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [157] = {
    [sym__statements] = STATE(542),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [158] = {
    [anon_sym_AMP_AMP] = ACTIONS(923),
    [anon_sym_PIPE_PIPE] = ACTIONS(923),
    [anon_sym_RBRACK] = ACTIONS(555),
    [anon_sym_EQ_TILDE] = ACTIONS(925),
    [anon_sym_EQ_EQ] = ACTIONS(925),
    [anon_sym_EQ] = ACTIONS(927),
    [anon_sym_PLUS_EQ] = ACTIONS(923),
    [anon_sym_LT] = ACTIONS(927),
    [anon_sym_GT] = ACTIONS(927),
    [anon_sym_BANG_EQ] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(927),
    [anon_sym_DASH_EQ] = ACTIONS(923),
    [anon_sym_LT_EQ] = ACTIONS(923),
    [anon_sym_GT_EQ] = ACTIONS(923),
    [anon_sym_PLUS_PLUS] = ACTIONS(929),
    [anon_sym_DASH_DASH] = ACTIONS(929),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(923),
  },
  [159] = {
    [aux_sym__literal_repeat1] = STATE(547),
    [anon_sym_AMP_AMP] = ACTIONS(565),
    [anon_sym_PIPE_PIPE] = ACTIONS(565),
    [anon_sym_RBRACK] = ACTIONS(565),
    [anon_sym_EQ_TILDE] = ACTIONS(565),
    [anon_sym_EQ_EQ] = ACTIONS(565),
    [anon_sym_EQ] = ACTIONS(567),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_LT] = ACTIONS(567),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_LT_EQ] = ACTIONS(565),
    [anon_sym_GT_EQ] = ACTIONS(565),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [sym__special_character] = ACTIONS(931),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(565),
  },
  [160] = {
    [sym__expression] = STATE(548),
    [sym_binary_expression] = STATE(548),
    [sym_unary_expression] = STATE(548),
    [sym_postfix_expression] = STATE(548),
    [sym_parenthesized_expression] = STATE(548),
    [sym_concatenation] = STATE(548),
    [sym_string] = STATE(162),
    [sym_simple_expansion] = STATE(162),
    [sym_string_expansion] = STATE(162),
    [sym_expansion] = STATE(162),
    [sym_command_substitution] = STATE(162),
    [sym_process_substitution] = STATE(162),
    [aux_sym__literal_repeat1] = STATE(164),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(249),
    [anon_sym_DOLLAR] = ACTIONS(77),
    [sym__special_character] = ACTIONS(251),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(255),
    [sym_test_operator] = ACTIONS(257),
  },
  [161] = {
    [aux_sym_concatenation_repeat1] = STATE(549),
    [sym__concat] = ACTIONS(535),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(335),
    [anon_sym_EQ_TILDE] = ACTIONS(335),
    [anon_sym_EQ_EQ] = ACTIONS(335),
    [anon_sym_EQ] = ACTIONS(339),
    [anon_sym_PLUS_EQ] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(335),
    [anon_sym_PLUS] = ACTIONS(339),
    [anon_sym_DASH] = ACTIONS(339),
    [anon_sym_DASH_EQ] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(335),
    [anon_sym_GT_EQ] = ACTIONS(335),
    [anon_sym_PLUS_PLUS] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(335),
    [sym__special_character] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(335),
  },
  [162] = {
    [aux_sym_concatenation_repeat1] = STATE(549),
    [sym__concat] = ACTIONS(535),
    [anon_sym_AMP_AMP] = ACTIONS(541),
    [anon_sym_PIPE_PIPE] = ACTIONS(541),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(541),
    [anon_sym_EQ_TILDE] = ACTIONS(541),
    [anon_sym_EQ_EQ] = ACTIONS(541),
    [anon_sym_EQ] = ACTIONS(543),
    [anon_sym_PLUS_EQ] = ACTIONS(541),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_BANG_EQ] = ACTIONS(541),
    [anon_sym_PLUS] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(543),
    [anon_sym_DASH_EQ] = ACTIONS(541),
    [anon_sym_LT_EQ] = ACTIONS(541),
    [anon_sym_GT_EQ] = ACTIONS(541),
    [anon_sym_PLUS_PLUS] = ACTIONS(541),
    [anon_sym_DASH_DASH] = ACTIONS(541),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(541),
  },
  [163] = {
    [anon_sym_AMP_AMP] = ACTIONS(933),
    [anon_sym_PIPE_PIPE] = ACTIONS(933),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(555),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(935),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_PLUS_EQ] = ACTIONS(933),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(933),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_DASH] = ACTIONS(937),
    [anon_sym_DASH_EQ] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(933),
    [anon_sym_GT_EQ] = ACTIONS(933),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(933),
  },
  [164] = {
    [aux_sym__literal_repeat1] = STATE(553),
    [anon_sym_AMP_AMP] = ACTIONS(565),
    [anon_sym_PIPE_PIPE] = ACTIONS(565),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(565),
    [anon_sym_EQ_TILDE] = ACTIONS(565),
    [anon_sym_EQ_EQ] = ACTIONS(565),
    [anon_sym_EQ] = ACTIONS(567),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_LT] = ACTIONS(567),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_LT_EQ] = ACTIONS(565),
    [anon_sym_GT_EQ] = ACTIONS(565),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [sym__special_character] = ACTIONS(939),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(565),
  },
  [165] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_PLUS_EQ] = ACTIONS(941),
    [sym_comment] = ACTIONS(57),
  },
  [166] = {
    [sym_string] = STATE(556),
    [anon_sym_DASH] = ACTIONS(943),
    [anon_sym_DOLLAR] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(269),
    [sym_raw_string] = ACTIONS(945),
    [anon_sym_POUND] = ACTIONS(943),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(947),
    [anon_sym_STAR] = ACTIONS(949),
    [anon_sym_AT] = ACTIONS(949),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_0] = ACTIONS(947),
    [anon_sym__] = ACTIONS(947),
  },
  [167] = {
    [aux_sym_concatenation_repeat1] = STATE(559),
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(335),
    [ts_builtin_sym_end] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(339),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [168] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(562),
    [anon_sym_DOLLAR] = ACTIONS(953),
    [anon_sym_DQUOTE] = ACTIONS(955),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [169] = {
    [aux_sym_concatenation_repeat1] = STATE(559),
    [sym__simple_heredoc_body] = ACTIONS(957),
    [sym__heredoc_body_beginning] = ACTIONS(957),
    [sym_file_descriptor] = ACTIONS(957),
    [sym__concat] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(957),
    [ts_builtin_sym_end] = ACTIONS(957),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_SEMI_SEMI] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_LT] = ACTIONS(959),
    [anon_sym_GT] = ACTIONS(959),
    [anon_sym_GT_GT] = ACTIONS(957),
    [anon_sym_AMP_GT] = ACTIONS(959),
    [anon_sym_AMP_GT_GT] = ACTIONS(957),
    [anon_sym_LT_AMP] = ACTIONS(957),
    [anon_sym_GT_AMP] = ACTIONS(957),
    [anon_sym_LT_LT] = ACTIONS(959),
    [anon_sym_LT_LT_DASH] = ACTIONS(957),
    [anon_sym_LT_LT_LT] = ACTIONS(957),
    [anon_sym_DOLLAR] = ACTIONS(959),
    [sym__special_character] = ACTIONS(957),
    [anon_sym_DQUOTE] = ACTIONS(957),
    [sym_raw_string] = ACTIONS(957),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(957),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(957),
    [anon_sym_BQUOTE] = ACTIONS(957),
    [anon_sym_LT_LPAREN] = ACTIONS(957),
    [anon_sym_GT_LPAREN] = ACTIONS(957),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(959),
    [sym_word] = ACTIONS(959),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
  },
  [170] = {
    [sym_subscript] = STATE(566),
    [sym_variable_name] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_DASH] = ACTIONS(965),
    [anon_sym_DOLLAR] = ACTIONS(965),
    [anon_sym_POUND] = ACTIONS(963),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(967),
    [anon_sym_STAR] = ACTIONS(969),
    [anon_sym_AT] = ACTIONS(969),
    [anon_sym_QMARK] = ACTIONS(969),
    [anon_sym_0] = ACTIONS(967),
    [anon_sym__] = ACTIONS(967),
  },
  [171] = {
    [sym__statements] = STATE(567),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(568),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [172] = {
    [sym__statements] = STATE(569),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [173] = {
    [sym__statements] = STATE(570),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [174] = {
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_PLUS_EQ] = ACTIONS(941),
    [sym_comment] = ACTIONS(57),
  },
  [175] = {
    [sym_variable_assignment] = STATE(571),
    [sym_subscript] = STATE(174),
    [sym_concatenation] = STATE(571),
    [sym_string] = STATE(169),
    [sym_simple_expansion] = STATE(169),
    [sym_string_expansion] = STATE(169),
    [sym_expansion] = STATE(169),
    [sym_command_substitution] = STATE(169),
    [sym_process_substitution] = STATE(169),
    [aux_sym_declaration_command_repeat1] = STATE(571),
    [aux_sym__literal_repeat1] = STATE(176),
    [sym__simple_heredoc_body] = ACTIONS(971),
    [sym__heredoc_body_beginning] = ACTIONS(971),
    [sym_file_descriptor] = ACTIONS(971),
    [sym_variable_name] = ACTIONS(261),
    [ts_builtin_sym_end] = ACTIONS(971),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_SEMI_SEMI] = ACTIONS(971),
    [anon_sym_PIPE_AMP] = ACTIONS(971),
    [anon_sym_AMP_AMP] = ACTIONS(971),
    [anon_sym_PIPE_PIPE] = ACTIONS(971),
    [anon_sym_LT] = ACTIONS(973),
    [anon_sym_GT] = ACTIONS(973),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_AMP_GT] = ACTIONS(973),
    [anon_sym_AMP_GT_GT] = ACTIONS(971),
    [anon_sym_LT_AMP] = ACTIONS(971),
    [anon_sym_GT_AMP] = ACTIONS(971),
    [anon_sym_LT_LT] = ACTIONS(973),
    [anon_sym_LT_LT_DASH] = ACTIONS(971),
    [anon_sym_LT_LT_LT] = ACTIONS(971),
    [anon_sym_DOLLAR] = ACTIONS(265),
    [sym__special_character] = ACTIONS(267),
    [anon_sym_DQUOTE] = ACTIONS(269),
    [sym_raw_string] = ACTIONS(271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(277),
    [anon_sym_LT_LPAREN] = ACTIONS(279),
    [anon_sym_GT_LPAREN] = ACTIONS(279),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(975),
    [sym_word] = ACTIONS(283),
    [anon_sym_LF] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(973),
  },
  [176] = {
    [aux_sym__literal_repeat1] = STATE(573),
    [sym__simple_heredoc_body] = ACTIONS(977),
    [sym__heredoc_body_beginning] = ACTIONS(977),
    [sym_file_descriptor] = ACTIONS(977),
    [sym_variable_name] = ACTIONS(977),
    [ts_builtin_sym_end] = ACTIONS(977),
    [anon_sym_SEMI] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(979),
    [anon_sym_SEMI_SEMI] = ACTIONS(977),
    [anon_sym_PIPE_AMP] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(977),
    [anon_sym_AMP_GT] = ACTIONS(979),
    [anon_sym_AMP_GT_GT] = ACTIONS(977),
    [anon_sym_LT_AMP] = ACTIONS(977),
    [anon_sym_GT_AMP] = ACTIONS(977),
    [anon_sym_LT_LT] = ACTIONS(979),
    [anon_sym_LT_LT_DASH] = ACTIONS(977),
    [anon_sym_LT_LT_LT] = ACTIONS(977),
    [anon_sym_DOLLAR] = ACTIONS(979),
    [sym__special_character] = ACTIONS(981),
    [anon_sym_DQUOTE] = ACTIONS(977),
    [sym_raw_string] = ACTIONS(977),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(977),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(977),
    [anon_sym_BQUOTE] = ACTIONS(977),
    [anon_sym_LT_LPAREN] = ACTIONS(977),
    [anon_sym_GT_LPAREN] = ACTIONS(977),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(979),
    [sym_word] = ACTIONS(979),
    [anon_sym_LF] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
  },
  [177] = {
    [sym_string] = STATE(575),
    [anon_sym_DASH] = ACTIONS(983),
    [anon_sym_DOLLAR] = ACTIONS(983),
    [anon_sym_DQUOTE] = ACTIONS(293),
    [sym_raw_string] = ACTIONS(985),
    [anon_sym_POUND] = ACTIONS(983),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(987),
    [anon_sym_STAR] = ACTIONS(989),
    [anon_sym_AT] = ACTIONS(989),
    [anon_sym_QMARK] = ACTIONS(989),
    [anon_sym_0] = ACTIONS(987),
    [anon_sym__] = ACTIONS(987),
  },
  [178] = {
    [aux_sym_concatenation_repeat1] = STATE(578),
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(991),
    [ts_builtin_sym_end] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(339),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [179] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(581),
    [anon_sym_DOLLAR] = ACTIONS(993),
    [anon_sym_DQUOTE] = ACTIONS(995),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [180] = {
    [aux_sym_concatenation_repeat1] = STATE(578),
    [sym__simple_heredoc_body] = ACTIONS(997),
    [sym__heredoc_body_beginning] = ACTIONS(997),
    [sym_file_descriptor] = ACTIONS(997),
    [sym__concat] = ACTIONS(991),
    [ts_builtin_sym_end] = ACTIONS(997),
    [anon_sym_SEMI] = ACTIONS(999),
    [anon_sym_PIPE] = ACTIONS(999),
    [anon_sym_SEMI_SEMI] = ACTIONS(997),
    [anon_sym_PIPE_AMP] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_LT] = ACTIONS(999),
    [anon_sym_GT] = ACTIONS(999),
    [anon_sym_GT_GT] = ACTIONS(997),
    [anon_sym_AMP_GT] = ACTIONS(999),
    [anon_sym_AMP_GT_GT] = ACTIONS(997),
    [anon_sym_LT_AMP] = ACTIONS(997),
    [anon_sym_GT_AMP] = ACTIONS(997),
    [anon_sym_LT_LT] = ACTIONS(999),
    [anon_sym_LT_LT_DASH] = ACTIONS(997),
    [anon_sym_LT_LT_LT] = ACTIONS(997),
    [anon_sym_DOLLAR] = ACTIONS(999),
    [sym__special_character] = ACTIONS(997),
    [anon_sym_DQUOTE] = ACTIONS(997),
    [sym_raw_string] = ACTIONS(997),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(997),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(997),
    [anon_sym_BQUOTE] = ACTIONS(997),
    [anon_sym_LT_LPAREN] = ACTIONS(997),
    [anon_sym_GT_LPAREN] = ACTIONS(997),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(999),
    [sym_word] = ACTIONS(999),
    [anon_sym_LF] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(999),
  },
  [181] = {
    [sym_subscript] = STATE(585),
    [sym_variable_name] = ACTIONS(1001),
    [anon_sym_BANG] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1005),
    [anon_sym_DOLLAR] = ACTIONS(1005),
    [anon_sym_POUND] = ACTIONS(1003),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1007),
    [anon_sym_STAR] = ACTIONS(1009),
    [anon_sym_AT] = ACTIONS(1009),
    [anon_sym_QMARK] = ACTIONS(1009),
    [anon_sym_0] = ACTIONS(1007),
    [anon_sym__] = ACTIONS(1007),
  },
  [182] = {
    [sym__statements] = STATE(586),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(587),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [183] = {
    [sym__statements] = STATE(588),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [184] = {
    [sym__statements] = STATE(589),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [185] = {
    [sym_concatenation] = STATE(590),
    [sym_string] = STATE(180),
    [sym_simple_expansion] = STATE(180),
    [sym_string_expansion] = STATE(180),
    [sym_expansion] = STATE(180),
    [sym_command_substitution] = STATE(180),
    [sym_process_substitution] = STATE(180),
    [aux_sym_unset_command_repeat1] = STATE(590),
    [aux_sym__literal_repeat1] = STATE(186),
    [sym__simple_heredoc_body] = ACTIONS(1011),
    [sym__heredoc_body_beginning] = ACTIONS(1011),
    [sym_file_descriptor] = ACTIONS(1011),
    [ts_builtin_sym_end] = ACTIONS(1011),
    [anon_sym_SEMI] = ACTIONS(1013),
    [anon_sym_PIPE] = ACTIONS(1013),
    [anon_sym_SEMI_SEMI] = ACTIONS(1011),
    [anon_sym_PIPE_AMP] = ACTIONS(1011),
    [anon_sym_AMP_AMP] = ACTIONS(1011),
    [anon_sym_PIPE_PIPE] = ACTIONS(1011),
    [anon_sym_LT] = ACTIONS(1013),
    [anon_sym_GT] = ACTIONS(1013),
    [anon_sym_GT_GT] = ACTIONS(1011),
    [anon_sym_AMP_GT] = ACTIONS(1013),
    [anon_sym_AMP_GT_GT] = ACTIONS(1011),
    [anon_sym_LT_AMP] = ACTIONS(1011),
    [anon_sym_GT_AMP] = ACTIONS(1011),
    [anon_sym_LT_LT] = ACTIONS(1013),
    [anon_sym_LT_LT_DASH] = ACTIONS(1011),
    [anon_sym_LT_LT_LT] = ACTIONS(1011),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym__special_character] = ACTIONS(291),
    [anon_sym_DQUOTE] = ACTIONS(293),
    [sym_raw_string] = ACTIONS(295),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(297),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(301),
    [anon_sym_LT_LPAREN] = ACTIONS(303),
    [anon_sym_GT_LPAREN] = ACTIONS(303),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1015),
    [sym_word] = ACTIONS(307),
    [anon_sym_LF] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(1013),
  },
  [186] = {
    [aux_sym__literal_repeat1] = STATE(592),
    [sym__simple_heredoc_body] = ACTIONS(1017),
    [sym__heredoc_body_beginning] = ACTIONS(1017),
    [sym_file_descriptor] = ACTIONS(1017),
    [ts_builtin_sym_end] = ACTIONS(1017),
    [anon_sym_SEMI] = ACTIONS(1019),
    [anon_sym_PIPE] = ACTIONS(1019),
    [anon_sym_SEMI_SEMI] = ACTIONS(1017),
    [anon_sym_PIPE_AMP] = ACTIONS(1017),
    [anon_sym_AMP_AMP] = ACTIONS(1017),
    [anon_sym_PIPE_PIPE] = ACTIONS(1017),
    [anon_sym_LT] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(1019),
    [anon_sym_GT_GT] = ACTIONS(1017),
    [anon_sym_AMP_GT] = ACTIONS(1019),
    [anon_sym_AMP_GT_GT] = ACTIONS(1017),
    [anon_sym_LT_AMP] = ACTIONS(1017),
    [anon_sym_GT_AMP] = ACTIONS(1017),
    [anon_sym_LT_LT] = ACTIONS(1019),
    [anon_sym_LT_LT_DASH] = ACTIONS(1017),
    [anon_sym_LT_LT_LT] = ACTIONS(1017),
    [anon_sym_DOLLAR] = ACTIONS(1019),
    [sym__special_character] = ACTIONS(1021),
    [anon_sym_DQUOTE] = ACTIONS(1017),
    [sym_raw_string] = ACTIONS(1017),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1017),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1017),
    [anon_sym_BQUOTE] = ACTIONS(1017),
    [anon_sym_LT_LPAREN] = ACTIONS(1017),
    [anon_sym_GT_LPAREN] = ACTIONS(1017),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1019),
    [sym_word] = ACTIONS(1019),
    [anon_sym_LF] = ACTIONS(1017),
    [anon_sym_AMP] = ACTIONS(1019),
  },
  [187] = {
    [sym_string] = STATE(594),
    [anon_sym_DASH] = ACTIONS(1023),
    [anon_sym_DOLLAR] = ACTIONS(1023),
    [anon_sym_DQUOTE] = ACTIONS(313),
    [sym_raw_string] = ACTIONS(1025),
    [anon_sym_POUND] = ACTIONS(1023),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1027),
    [anon_sym_STAR] = ACTIONS(1029),
    [anon_sym_AT] = ACTIONS(1029),
    [anon_sym_QMARK] = ACTIONS(1029),
    [anon_sym_0] = ACTIONS(1027),
    [anon_sym__] = ACTIONS(1027),
  },
  [188] = {
    [aux_sym_concatenation_repeat1] = STATE(597),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(1031),
    [sym_variable_name] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(335),
  },
  [189] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(600),
    [anon_sym_DOLLAR] = ACTIONS(1033),
    [anon_sym_DQUOTE] = ACTIONS(1035),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [190] = {
    [aux_sym_concatenation_repeat1] = STATE(597),
    [sym_file_descriptor] = ACTIONS(1037),
    [sym__concat] = ACTIONS(1031),
    [sym_variable_name] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1039),
    [anon_sym_GT] = ACTIONS(1039),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_AMP_GT] = ACTIONS(1039),
    [anon_sym_AMP_GT_GT] = ACTIONS(1037),
    [anon_sym_LT_AMP] = ACTIONS(1037),
    [anon_sym_GT_AMP] = ACTIONS(1037),
    [anon_sym_DOLLAR] = ACTIONS(1039),
    [sym__special_character] = ACTIONS(1037),
    [anon_sym_DQUOTE] = ACTIONS(1037),
    [sym_raw_string] = ACTIONS(1037),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1037),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1037),
    [anon_sym_BQUOTE] = ACTIONS(1037),
    [anon_sym_LT_LPAREN] = ACTIONS(1037),
    [anon_sym_GT_LPAREN] = ACTIONS(1037),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1037),
  },
  [191] = {
    [sym_subscript] = STATE(604),
    [sym_variable_name] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_DASH] = ACTIONS(1045),
    [anon_sym_DOLLAR] = ACTIONS(1045),
    [anon_sym_POUND] = ACTIONS(1043),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1047),
    [anon_sym_STAR] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(1049),
    [anon_sym_QMARK] = ACTIONS(1049),
    [anon_sym_0] = ACTIONS(1047),
    [anon_sym__] = ACTIONS(1047),
  },
  [192] = {
    [sym__statements] = STATE(605),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(606),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [193] = {
    [sym__statements] = STATE(607),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [194] = {
    [sym__statements] = STATE(608),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [195] = {
    [sym_file_descriptor] = ACTIONS(1037),
    [sym_variable_name] = ACTIONS(1037),
    [anon_sym_RPAREN] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1039),
    [anon_sym_GT] = ACTIONS(1039),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_AMP_GT] = ACTIONS(1039),
    [anon_sym_AMP_GT_GT] = ACTIONS(1037),
    [anon_sym_LT_AMP] = ACTIONS(1037),
    [anon_sym_GT_AMP] = ACTIONS(1037),
    [anon_sym_DOLLAR] = ACTIONS(1039),
    [sym__special_character] = ACTIONS(1037),
    [anon_sym_DQUOTE] = ACTIONS(1037),
    [sym_raw_string] = ACTIONS(1037),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1037),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1037),
    [anon_sym_BQUOTE] = ACTIONS(1037),
    [anon_sym_LT_LPAREN] = ACTIONS(1037),
    [anon_sym_GT_LPAREN] = ACTIONS(1037),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1037),
  },
  [196] = {
    [aux_sym__literal_repeat1] = STATE(610),
    [sym_file_descriptor] = ACTIONS(1051),
    [sym_variable_name] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT_GT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1051),
    [anon_sym_GT_AMP] = ACTIONS(1051),
    [anon_sym_DOLLAR] = ACTIONS(1053),
    [sym__special_character] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1051),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1051),
    [anon_sym_BQUOTE] = ACTIONS(1051),
    [anon_sym_LT_LPAREN] = ACTIONS(1051),
    [anon_sym_GT_LPAREN] = ACTIONS(1051),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1051),
  },
  [197] = {
    [sym__simple_heredoc_body] = ACTIONS(1057),
    [sym__heredoc_body_beginning] = ACTIONS(1057),
    [sym_file_descriptor] = ACTIONS(1057),
    [sym__concat] = ACTIONS(1057),
    [ts_builtin_sym_end] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_RPAREN] = ACTIONS(1057),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_PIPE_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_EQ_TILDE] = ACTIONS(1059),
    [anon_sym_EQ_EQ] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_AMP] = ACTIONS(1057),
    [anon_sym_GT_AMP] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_LT] = ACTIONS(1057),
    [anon_sym_DOLLAR] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [sym_raw_string] = ACTIONS(1057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1057),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1057),
    [anon_sym_BQUOTE] = ACTIONS(1057),
    [anon_sym_LT_LPAREN] = ACTIONS(1057),
    [anon_sym_GT_LPAREN] = ACTIONS(1057),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [198] = {
    [sym__simple_heredoc_body] = ACTIONS(1061),
    [sym__heredoc_body_beginning] = ACTIONS(1061),
    [sym_file_descriptor] = ACTIONS(1061),
    [sym__concat] = ACTIONS(1061),
    [ts_builtin_sym_end] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(1063),
    [anon_sym_PIPE] = ACTIONS(1063),
    [anon_sym_RPAREN] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE_AMP] = ACTIONS(1061),
    [anon_sym_AMP_AMP] = ACTIONS(1061),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_EQ_TILDE] = ACTIONS(1063),
    [anon_sym_EQ_EQ] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1063),
    [anon_sym_GT_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT_GT] = ACTIONS(1061),
    [anon_sym_LT_AMP] = ACTIONS(1061),
    [anon_sym_GT_AMP] = ACTIONS(1061),
    [anon_sym_LT_LT] = ACTIONS(1063),
    [anon_sym_LT_LT_DASH] = ACTIONS(1061),
    [anon_sym_LT_LT_LT] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1061),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1061),
    [anon_sym_LT_LPAREN] = ACTIONS(1061),
    [anon_sym_GT_LPAREN] = ACTIONS(1061),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1063),
    [anon_sym_LF] = ACTIONS(1061),
    [anon_sym_AMP] = ACTIONS(1063),
  },
  [199] = {
    [sym__simple_heredoc_body] = ACTIONS(1065),
    [sym__heredoc_body_beginning] = ACTIONS(1065),
    [sym_file_descriptor] = ACTIONS(1065),
    [sym__concat] = ACTIONS(1065),
    [ts_builtin_sym_end] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1067),
    [anon_sym_RPAREN] = ACTIONS(1065),
    [anon_sym_SEMI_SEMI] = ACTIONS(1065),
    [anon_sym_PIPE_AMP] = ACTIONS(1065),
    [anon_sym_AMP_AMP] = ACTIONS(1065),
    [anon_sym_PIPE_PIPE] = ACTIONS(1065),
    [anon_sym_EQ_TILDE] = ACTIONS(1067),
    [anon_sym_EQ_EQ] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_GT] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT] = ACTIONS(1067),
    [anon_sym_AMP_GT_GT] = ACTIONS(1065),
    [anon_sym_LT_AMP] = ACTIONS(1065),
    [anon_sym_GT_AMP] = ACTIONS(1065),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_LT_LT_DASH] = ACTIONS(1065),
    [anon_sym_LT_LT_LT] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1067),
    [sym__special_character] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LT_LPAREN] = ACTIONS(1065),
    [anon_sym_GT_LPAREN] = ACTIONS(1065),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1067),
    [anon_sym_LF] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1067),
  },
  [200] = {
    [sym_string] = STATE(611),
    [sym_simple_expansion] = STATE(611),
    [sym_string_expansion] = STATE(611),
    [sym_expansion] = STATE(611),
    [sym_command_substitution] = STATE(611),
    [sym_process_substitution] = STATE(611),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(1069),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1069),
  },
  [201] = {
    [aux_sym_concatenation_repeat1] = STATE(613),
    [sym__simple_heredoc_body] = ACTIONS(1071),
    [sym__heredoc_body_beginning] = ACTIONS(1071),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(1073),
    [ts_builtin_sym_end] = ACTIONS(1071),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_EQ_TILDE] = ACTIONS(1075),
    [anon_sym_EQ_EQ] = ACTIONS(1075),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [sym__special_character] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1075),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1075),
  },
  [202] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(1081),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [203] = {
    [sym__simple_heredoc_body] = ACTIONS(1089),
    [sym__heredoc_body_beginning] = ACTIONS(1089),
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(1089),
    [ts_builtin_sym_end] = ACTIONS(1089),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_SEMI_SEMI] = ACTIONS(1089),
    [anon_sym_PIPE_AMP] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_AMP] = ACTIONS(1089),
    [anon_sym_GT_AMP] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1089),
    [anon_sym_LT_LT_LT] = ACTIONS(1089),
    [anon_sym_DOLLAR] = ACTIONS(1091),
    [sym__special_character] = ACTIONS(1089),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1089),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1089),
    [anon_sym_GT_LPAREN] = ACTIONS(1089),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [204] = {
    [sym__concat] = ACTIONS(1093),
    [anon_sym_DOLLAR] = ACTIONS(1095),
    [anon_sym_DQUOTE] = ACTIONS(1095),
    [sym__string_content] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [sym_comment] = ACTIONS(329),
  },
  [205] = {
    [sym_subscript] = STATE(622),
    [sym_variable_name] = ACTIONS(1099),
    [anon_sym_BANG] = ACTIONS(1101),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_DOLLAR] = ACTIONS(1103),
    [anon_sym_POUND] = ACTIONS(1101),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1105),
    [anon_sym_STAR] = ACTIONS(1107),
    [anon_sym_AT] = ACTIONS(1107),
    [anon_sym_QMARK] = ACTIONS(1107),
    [anon_sym_0] = ACTIONS(1105),
    [anon_sym__] = ACTIONS(1105),
  },
  [206] = {
    [sym__statements] = STATE(623),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(624),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [207] = {
    [sym__statements] = STATE(625),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [208] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(627),
    [anon_sym_DOLLAR] = ACTIONS(1109),
    [anon_sym_DQUOTE] = ACTIONS(1081),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [209] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(1113),
    [sym_comment] = ACTIONS(57),
  },
  [210] = {
    [sym_subscript] = STATE(632),
    [sym_variable_name] = ACTIONS(1115),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1117),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1119),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_AT] = ACTIONS(1121),
    [anon_sym_QMARK] = ACTIONS(1121),
    [anon_sym_0] = ACTIONS(1119),
    [anon_sym__] = ACTIONS(1119),
  },
  [211] = {
    [sym_concatenation] = STATE(644),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(644),
    [anon_sym_RBRACE] = ACTIONS(1123),
    [anon_sym_EQ] = ACTIONS(1125),
    [anon_sym_DASH] = ACTIONS(1125),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(1135),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(1139),
    [anon_sym_COLON] = ACTIONS(1125),
    [anon_sym_COLON_QMARK] = ACTIONS(1125),
    [anon_sym_COLON_DASH] = ACTIONS(1125),
    [anon_sym_PERCENT] = ACTIONS(1125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [212] = {
    [sym_concatenation] = STATE(647),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(647),
    [anon_sym_RBRACE] = ACTIONS(1149),
    [anon_sym_EQ] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(1153),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(1155),
    [anon_sym_COLON] = ACTIONS(1151),
    [anon_sym_COLON_QMARK] = ACTIONS(1151),
    [anon_sym_COLON_DASH] = ACTIONS(1151),
    [anon_sym_PERCENT] = ACTIONS(1151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [213] = {
    [anon_sym_LT] = ACTIONS(1157),
    [anon_sym_GT] = ACTIONS(1157),
    [anon_sym_GT_GT] = ACTIONS(1159),
    [anon_sym_AMP_GT] = ACTIONS(1157),
    [anon_sym_AMP_GT_GT] = ACTIONS(1159),
    [anon_sym_LT_AMP] = ACTIONS(1159),
    [anon_sym_GT_AMP] = ACTIONS(1159),
    [sym_comment] = ACTIONS(57),
  },
  [214] = {
    [sym_concatenation] = STATE(195),
    [sym_string] = STATE(650),
    [sym_simple_expansion] = STATE(650),
    [sym_string_expansion] = STATE(650),
    [sym_expansion] = STATE(650),
    [sym_command_substitution] = STATE(650),
    [sym_process_substitution] = STATE(650),
    [aux_sym__literal_repeat1] = STATE(651),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [sym__special_character] = ACTIONS(1161),
    [anon_sym_DQUOTE] = ACTIONS(313),
    [sym_raw_string] = ACTIONS(1163),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(317),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(319),
    [anon_sym_BQUOTE] = ACTIONS(321),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1163),
  },
  [215] = {
    [anon_sym_RPAREN] = ACTIONS(1165),
    [sym_comment] = ACTIONS(57),
  },
  [216] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(1165),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [217] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(1167),
    [anon_sym_PLUS_EQ] = ACTIONS(1167),
    [sym_comment] = ACTIONS(57),
  },
  [218] = {
    [sym_subshell] = STATE(146),
    [sym_test_command] = STATE(146),
    [sym_command] = STATE(146),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(230),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(383),
  },
  [219] = {
    [sym_variable_assignment] = STATE(658),
    [sym_subscript] = STATE(657),
    [sym_concatenation] = STATE(658),
    [sym_string] = STATE(656),
    [sym_simple_expansion] = STATE(656),
    [sym_string_expansion] = STATE(656),
    [sym_expansion] = STATE(656),
    [sym_command_substitution] = STATE(656),
    [sym_process_substitution] = STATE(656),
    [aux_sym_declaration_command_repeat1] = STATE(658),
    [aux_sym__literal_repeat1] = STATE(659),
    [sym__simple_heredoc_body] = ACTIONS(259),
    [sym__heredoc_body_beginning] = ACTIONS(259),
    [sym_file_descriptor] = ACTIONS(259),
    [sym_variable_name] = ACTIONS(1169),
    [anon_sym_SEMI] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_SEMI_SEMI] = ACTIONS(259),
    [anon_sym_PIPE_AMP] = ACTIONS(259),
    [anon_sym_AMP_AMP] = ACTIONS(259),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_LT] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_GT_GT] = ACTIONS(259),
    [anon_sym_AMP_GT] = ACTIONS(263),
    [anon_sym_AMP_GT_GT] = ACTIONS(259),
    [anon_sym_LT_AMP] = ACTIONS(259),
    [anon_sym_GT_AMP] = ACTIONS(259),
    [anon_sym_LT_LT] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(259),
    [anon_sym_LT_LT_LT] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(265),
    [sym__special_character] = ACTIONS(1171),
    [anon_sym_DQUOTE] = ACTIONS(269),
    [sym_raw_string] = ACTIONS(1173),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(259),
    [anon_sym_LT_LPAREN] = ACTIONS(279),
    [anon_sym_GT_LPAREN] = ACTIONS(279),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1175),
    [sym_word] = ACTIONS(1177),
    [anon_sym_LF] = ACTIONS(259),
    [anon_sym_AMP] = ACTIONS(263),
  },
  [220] = {
    [sym_concatenation] = STATE(662),
    [sym_string] = STATE(661),
    [sym_simple_expansion] = STATE(661),
    [sym_string_expansion] = STATE(661),
    [sym_expansion] = STATE(661),
    [sym_command_substitution] = STATE(661),
    [sym_process_substitution] = STATE(661),
    [aux_sym_unset_command_repeat1] = STATE(662),
    [aux_sym__literal_repeat1] = STATE(663),
    [sym__simple_heredoc_body] = ACTIONS(285),
    [sym__heredoc_body_beginning] = ACTIONS(285),
    [sym_file_descriptor] = ACTIONS(285),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(285),
    [anon_sym_PIPE_AMP] = ACTIONS(285),
    [anon_sym_AMP_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(287),
    [anon_sym_GT] = ACTIONS(287),
    [anon_sym_GT_GT] = ACTIONS(285),
    [anon_sym_AMP_GT] = ACTIONS(287),
    [anon_sym_AMP_GT_GT] = ACTIONS(285),
    [anon_sym_LT_AMP] = ACTIONS(285),
    [anon_sym_GT_AMP] = ACTIONS(285),
    [anon_sym_LT_LT] = ACTIONS(287),
    [anon_sym_LT_LT_DASH] = ACTIONS(285),
    [anon_sym_LT_LT_LT] = ACTIONS(285),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym__special_character] = ACTIONS(1179),
    [anon_sym_DQUOTE] = ACTIONS(293),
    [sym_raw_string] = ACTIONS(1181),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(297),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(285),
    [anon_sym_LT_LPAREN] = ACTIONS(303),
    [anon_sym_GT_LPAREN] = ACTIONS(303),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1183),
    [sym_word] = ACTIONS(1185),
    [anon_sym_LF] = ACTIONS(285),
    [anon_sym_AMP] = ACTIONS(287),
  },
  [221] = {
    [aux_sym_concatenation_repeat1] = STATE(664),
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_EQ_TILDE] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [222] = {
    [aux_sym_concatenation_repeat1] = STATE(664),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [223] = {
    [aux_sym_concatenation_repeat1] = STATE(664),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_LPAREN] = ACTIONS(387),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [224] = {
    [anon_sym_BQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(57),
  },
  [225] = {
    [sym_file_redirect] = STATE(672),
    [sym_heredoc_redirect] = STATE(672),
    [sym_heredoc_body] = STATE(671),
    [sym_herestring_redirect] = STATE(672),
    [aux_sym_redirected_statement_repeat1] = STATE(672),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(1187),
    [anon_sym_SEMI] = ACTIONS(1189),
    [anon_sym_PIPE] = ACTIONS(1191),
    [anon_sym_SEMI_SEMI] = ACTIONS(1193),
    [anon_sym_PIPE_AMP] = ACTIONS(1195),
    [anon_sym_AMP_AMP] = ACTIONS(1197),
    [anon_sym_PIPE_PIPE] = ACTIONS(1197),
    [anon_sym_LT] = ACTIONS(1199),
    [anon_sym_GT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_AMP_GT] = ACTIONS(1199),
    [anon_sym_AMP_GT_GT] = ACTIONS(1201),
    [anon_sym_LT_AMP] = ACTIONS(1201),
    [anon_sym_GT_AMP] = ACTIONS(1201),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(1203),
    [anon_sym_BQUOTE] = ACTIONS(399),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1193),
    [anon_sym_AMP] = ACTIONS(1189),
  },
  [226] = {
    [sym_concatenation] = STATE(675),
    [sym_string] = STATE(674),
    [sym_simple_expansion] = STATE(674),
    [sym_string_expansion] = STATE(674),
    [sym_expansion] = STATE(674),
    [sym_command_substitution] = STATE(674),
    [sym_process_substitution] = STATE(674),
    [aux_sym_command_repeat2] = STATE(675),
    [aux_sym__literal_repeat1] = STATE(676),
    [sym__simple_heredoc_body] = ACTIONS(421),
    [sym__heredoc_body_beginning] = ACTIONS(421),
    [sym_file_descriptor] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI_SEMI] = ACTIONS(421),
    [anon_sym_PIPE_AMP] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(1205),
    [anon_sym_EQ_EQ] = ACTIONS(1205),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_AMP_GT] = ACTIONS(423),
    [anon_sym_AMP_GT_GT] = ACTIONS(421),
    [anon_sym_LT_AMP] = ACTIONS(421),
    [anon_sym_GT_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_LT_LT_DASH] = ACTIONS(421),
    [anon_sym_LT_LT_LT] = ACTIONS(421),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(1207),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1209),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(421),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1211),
    [anon_sym_LF] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
  },
  [227] = {
    [sym_file_redirect] = STATE(672),
    [sym_heredoc_redirect] = STATE(672),
    [sym_heredoc_body] = STATE(671),
    [sym_herestring_redirect] = STATE(672),
    [aux_sym_redirected_statement_repeat1] = STATE(672),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(1189),
    [anon_sym_PIPE] = ACTIONS(1191),
    [anon_sym_SEMI_SEMI] = ACTIONS(1193),
    [anon_sym_PIPE_AMP] = ACTIONS(1195),
    [anon_sym_AMP_AMP] = ACTIONS(1197),
    [anon_sym_PIPE_PIPE] = ACTIONS(1197),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(1203),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(399),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(1193),
    [anon_sym_AMP] = ACTIONS(1189),
  },
  [228] = {
    [anon_sym_EQ] = ACTIONS(1167),
    [anon_sym_PLUS_EQ] = ACTIONS(1167),
    [sym_comment] = ACTIONS(57),
  },
  [229] = {
    [sym_redirected_statement] = STATE(677),
    [sym_for_statement] = STATE(677),
    [sym_c_style_for_statement] = STATE(677),
    [sym_while_statement] = STATE(677),
    [sym_if_statement] = STATE(677),
    [sym_case_statement] = STATE(677),
    [sym_function_definition] = STATE(677),
    [sym_compound_statement] = STATE(677),
    [sym_subshell] = STATE(677),
    [sym_pipeline] = STATE(677),
    [sym_list] = STATE(677),
    [sym_negated_command] = STATE(677),
    [sym_test_command] = STATE(677),
    [sym_declaration_command] = STATE(677),
    [sym_unset_command] = STATE(677),
    [sym_command] = STATE(677),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(678),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(251),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [230] = {
    [sym_command_name] = STATE(679),
    [sym_variable_assignment] = STATE(253),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(253),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym_command_repeat1] = STATE(253),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(1207),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(383),
  },
  [231] = {
    [aux_sym__literal_repeat1] = STATE(680),
    [sym__simple_heredoc_body] = ACTIONS(437),
    [sym__heredoc_body_beginning] = ACTIONS(437),
    [sym_file_descriptor] = ACTIONS(437),
    [anon_sym_SEMI] = ACTIONS(439),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI_SEMI] = ACTIONS(437),
    [anon_sym_PIPE_AMP] = ACTIONS(437),
    [anon_sym_AMP_AMP] = ACTIONS(437),
    [anon_sym_PIPE_PIPE] = ACTIONS(437),
    [anon_sym_EQ_TILDE] = ACTIONS(439),
    [anon_sym_EQ_EQ] = ACTIONS(439),
    [anon_sym_LT] = ACTIONS(439),
    [anon_sym_GT] = ACTIONS(439),
    [anon_sym_GT_GT] = ACTIONS(437),
    [anon_sym_AMP_GT] = ACTIONS(439),
    [anon_sym_AMP_GT_GT] = ACTIONS(437),
    [anon_sym_LT_AMP] = ACTIONS(437),
    [anon_sym_GT_AMP] = ACTIONS(437),
    [anon_sym_LT_LT] = ACTIONS(439),
    [anon_sym_LT_LT_DASH] = ACTIONS(437),
    [anon_sym_LT_LT_LT] = ACTIONS(437),
    [anon_sym_DOLLAR] = ACTIONS(439),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(437),
    [sym_raw_string] = ACTIONS(437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(437),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(437),
    [anon_sym_BQUOTE] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(437),
    [anon_sym_GT_LPAREN] = ACTIONS(437),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(439),
    [anon_sym_LF] = ACTIONS(437),
    [anon_sym_AMP] = ACTIONS(439),
  },
  [232] = {
    [anon_sym_RPAREN] = ACTIONS(1213),
    [sym_comment] = ACTIONS(57),
  },
  [233] = {
    [anon_sym_RPAREN] = ACTIONS(1215),
    [sym_comment] = ACTIONS(57),
  },
  [234] = {
    [ts_builtin_sym_end] = ACTIONS(1217),
    [anon_sym_SEMI] = ACTIONS(1219),
    [anon_sym_done] = ACTIONS(1217),
    [anon_sym_fi] = ACTIONS(1217),
    [anon_sym_elif] = ACTIONS(1217),
    [anon_sym_else] = ACTIONS(1217),
    [anon_sym_esac] = ACTIONS(1217),
    [anon_sym_RPAREN] = ACTIONS(1217),
    [anon_sym_SEMI_SEMI] = ACTIONS(1217),
    [anon_sym_BQUOTE] = ACTIONS(1217),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1217),
    [anon_sym_AMP] = ACTIONS(1217),
  },
  [235] = {
    [sym_simple_expansion] = STATE(688),
    [sym_expansion] = STATE(688),
    [sym_command_substitution] = STATE(688),
    [aux_sym_heredoc_body_repeat1] = STATE(688),
    [sym__heredoc_body_middle] = ACTIONS(1221),
    [sym__heredoc_body_end] = ACTIONS(1223),
    [anon_sym_DOLLAR] = ACTIONS(1225),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1227),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1229),
    [anon_sym_BQUOTE] = ACTIONS(1231),
    [sym_comment] = ACTIONS(57),
  },
  [236] = {
    [anon_sym_LT] = ACTIONS(1233),
    [anon_sym_GT] = ACTIONS(1233),
    [anon_sym_GT_GT] = ACTIONS(1235),
    [anon_sym_AMP_GT] = ACTIONS(1233),
    [anon_sym_AMP_GT_GT] = ACTIONS(1235),
    [anon_sym_LT_AMP] = ACTIONS(1235),
    [anon_sym_GT_AMP] = ACTIONS(1235),
    [sym_comment] = ACTIONS(57),
  },
  [237] = {
    [sym_file_descriptor] = ACTIONS(1237),
    [sym_variable_name] = ACTIONS(1237),
    [ts_builtin_sym_end] = ACTIONS(1239),
    [anon_sym_for] = ACTIONS(1241),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1237),
    [anon_sym_while] = ACTIONS(1241),
    [anon_sym_if] = ACTIONS(1241),
    [anon_sym_case] = ACTIONS(1241),
    [anon_sym_RPAREN] = ACTIONS(1239),
    [anon_sym_SEMI_SEMI] = ACTIONS(1239),
    [anon_sym_function] = ACTIONS(1241),
    [anon_sym_LPAREN] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1237),
    [anon_sym_BANG] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(1241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1237),
    [anon_sym_declare] = ACTIONS(1241),
    [anon_sym_typeset] = ACTIONS(1241),
    [anon_sym_export] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_local] = ACTIONS(1241),
    [anon_sym_unset] = ACTIONS(1241),
    [anon_sym_unsetenv] = ACTIONS(1241),
    [anon_sym_LT] = ACTIONS(1241),
    [anon_sym_GT] = ACTIONS(1241),
    [anon_sym_GT_GT] = ACTIONS(1237),
    [anon_sym_AMP_GT] = ACTIONS(1241),
    [anon_sym_AMP_GT_GT] = ACTIONS(1237),
    [anon_sym_LT_AMP] = ACTIONS(1237),
    [anon_sym_GT_AMP] = ACTIONS(1237),
    [anon_sym_DOLLAR] = ACTIONS(1241),
    [sym__special_character] = ACTIONS(1241),
    [anon_sym_DQUOTE] = ACTIONS(1237),
    [sym_raw_string] = ACTIONS(1237),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1237),
    [anon_sym_BQUOTE] = ACTIONS(1237),
    [anon_sym_LT_LPAREN] = ACTIONS(1237),
    [anon_sym_GT_LPAREN] = ACTIONS(1237),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1241),
  },
  [238] = {
    [sym_redirected_statement] = STATE(690),
    [sym_for_statement] = STATE(690),
    [sym_c_style_for_statement] = STATE(690),
    [sym_while_statement] = STATE(690),
    [sym_if_statement] = STATE(690),
    [sym_case_statement] = STATE(690),
    [sym_function_definition] = STATE(690),
    [sym_compound_statement] = STATE(690),
    [sym_subshell] = STATE(690),
    [sym_pipeline] = STATE(690),
    [sym_list] = STATE(690),
    [sym_negated_command] = STATE(690),
    [sym_test_command] = STATE(690),
    [sym_declaration_command] = STATE(690),
    [sym_unset_command] = STATE(690),
    [sym_command] = STATE(690),
    [sym_command_name] = STATE(30),
    [sym_variable_assignment] = STATE(691),
    [sym_subscript] = STATE(32),
    [sym_file_redirect] = STATE(35),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(21),
    [sym_simple_expansion] = STATE(21),
    [sym_string_expansion] = STATE(21),
    [sym_expansion] = STATE(21),
    [sym_command_substitution] = STATE(21),
    [sym_process_substitution] = STATE(21),
    [aux_sym_command_repeat1] = STATE(35),
    [aux_sym__literal_repeat1] = STATE(36),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(27),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(33),
    [anon_sym_typeset] = ACTIONS(33),
    [anon_sym_export] = ACTIONS(33),
    [anon_sym_readonly] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym_unset] = ACTIONS(35),
    [anon_sym_unsetenv] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(43),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(47),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(59),
  },
  [239] = {
    [sym_redirected_statement] = STATE(692),
    [sym_for_statement] = STATE(692),
    [sym_c_style_for_statement] = STATE(692),
    [sym_while_statement] = STATE(692),
    [sym_if_statement] = STATE(692),
    [sym_case_statement] = STATE(692),
    [sym_function_definition] = STATE(692),
    [sym_compound_statement] = STATE(692),
    [sym_subshell] = STATE(692),
    [sym_pipeline] = STATE(692),
    [sym_list] = STATE(692),
    [sym_negated_command] = STATE(692),
    [sym_test_command] = STATE(692),
    [sym_declaration_command] = STATE(692),
    [sym_unset_command] = STATE(692),
    [sym_command] = STATE(692),
    [sym_command_name] = STATE(30),
    [sym_variable_assignment] = STATE(693),
    [sym_subscript] = STATE(32),
    [sym_file_redirect] = STATE(35),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(21),
    [sym_simple_expansion] = STATE(21),
    [sym_string_expansion] = STATE(21),
    [sym_expansion] = STATE(21),
    [sym_command_substitution] = STATE(21),
    [sym_process_substitution] = STATE(21),
    [aux_sym_command_repeat1] = STATE(35),
    [aux_sym__literal_repeat1] = STATE(36),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(27),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(33),
    [anon_sym_typeset] = ACTIONS(33),
    [anon_sym_export] = ACTIONS(33),
    [anon_sym_readonly] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym_unset] = ACTIONS(35),
    [anon_sym_unsetenv] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(43),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(47),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(59),
  },
  [240] = {
    [sym_concatenation] = STATE(696),
    [sym_string] = STATE(695),
    [sym_simple_expansion] = STATE(695),
    [sym_string_expansion] = STATE(695),
    [sym_expansion] = STATE(695),
    [sym_command_substitution] = STATE(695),
    [sym_process_substitution] = STATE(695),
    [aux_sym__literal_repeat1] = STATE(697),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(1243),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1245),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1245),
  },
  [241] = {
    [sym_heredoc_start] = ACTIONS(1247),
    [sym_comment] = ACTIONS(57),
  },
  [242] = {
    [sym_concatenation] = STATE(700),
    [sym_string] = STATE(699),
    [sym_simple_expansion] = STATE(699),
    [sym_string_expansion] = STATE(699),
    [sym_expansion] = STATE(699),
    [sym_command_substitution] = STATE(699),
    [sym_process_substitution] = STATE(699),
    [aux_sym__literal_repeat1] = STATE(701),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(1243),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1249),
  },
  [243] = {
    [ts_builtin_sym_end] = ACTIONS(1239),
    [anon_sym_SEMI] = ACTIONS(1251),
    [anon_sym_RPAREN] = ACTIONS(1239),
    [anon_sym_SEMI_SEMI] = ACTIONS(1253),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1253),
  },
  [244] = {
    [sym_file_redirect] = STATE(703),
    [sym_heredoc_redirect] = STATE(703),
    [sym_herestring_redirect] = STATE(703),
    [aux_sym_redirected_statement_repeat1] = STATE(703),
    [sym__simple_heredoc_body] = ACTIONS(1255),
    [sym__heredoc_body_beginning] = ACTIONS(1255),
    [sym_file_descriptor] = ACTIONS(397),
    [ts_builtin_sym_end] = ACTIONS(1255),
    [anon_sym_SEMI] = ACTIONS(1257),
    [anon_sym_PIPE] = ACTIONS(1257),
    [anon_sym_SEMI_SEMI] = ACTIONS(1255),
    [anon_sym_PIPE_AMP] = ACTIONS(1255),
    [anon_sym_AMP_AMP] = ACTIONS(1255),
    [anon_sym_PIPE_PIPE] = ACTIONS(1255),
    [anon_sym_LT] = ACTIONS(411),
    [anon_sym_GT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(413),
    [anon_sym_AMP_GT] = ACTIONS(411),
    [anon_sym_AMP_GT_GT] = ACTIONS(413),
    [anon_sym_LT_AMP] = ACTIONS(413),
    [anon_sym_GT_AMP] = ACTIONS(413),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(419),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1257),
  },
  [245] = {
    [sym_concatenation] = STATE(704),
    [sym_string] = STATE(705),
    [sym_simple_expansion] = STATE(705),
    [sym_string_expansion] = STATE(705),
    [sym_expansion] = STATE(705),
    [sym_command_substitution] = STATE(705),
    [sym_process_substitution] = STATE(705),
    [aux_sym__literal_repeat1] = STATE(706),
    [sym_regex] = ACTIONS(1259),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(427),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1261),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1261),
  },
  [246] = {
    [aux_sym_concatenation_repeat1] = STATE(201),
    [sym__simple_heredoc_body] = ACTIONS(1263),
    [sym__heredoc_body_beginning] = ACTIONS(1263),
    [sym_file_descriptor] = ACTIONS(1263),
    [sym__concat] = ACTIONS(337),
    [ts_builtin_sym_end] = ACTIONS(1263),
    [anon_sym_SEMI] = ACTIONS(1265),
    [anon_sym_PIPE] = ACTIONS(1265),
    [anon_sym_SEMI_SEMI] = ACTIONS(1263),
    [anon_sym_PIPE_AMP] = ACTIONS(1263),
    [anon_sym_AMP_AMP] = ACTIONS(1263),
    [anon_sym_PIPE_PIPE] = ACTIONS(1263),
    [anon_sym_EQ_TILDE] = ACTIONS(1265),
    [anon_sym_EQ_EQ] = ACTIONS(1265),
    [anon_sym_LT] = ACTIONS(1265),
    [anon_sym_GT] = ACTIONS(1265),
    [anon_sym_GT_GT] = ACTIONS(1263),
    [anon_sym_AMP_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT_GT] = ACTIONS(1263),
    [anon_sym_LT_AMP] = ACTIONS(1263),
    [anon_sym_GT_AMP] = ACTIONS(1263),
    [anon_sym_LT_LT] = ACTIONS(1265),
    [anon_sym_LT_LT_DASH] = ACTIONS(1263),
    [anon_sym_LT_LT_LT] = ACTIONS(1263),
    [anon_sym_DOLLAR] = ACTIONS(1265),
    [sym__special_character] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(1263),
    [sym_raw_string] = ACTIONS(1263),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1263),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1263),
    [anon_sym_BQUOTE] = ACTIONS(1263),
    [anon_sym_LT_LPAREN] = ACTIONS(1263),
    [anon_sym_GT_LPAREN] = ACTIONS(1263),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1265),
    [anon_sym_LF] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1265),
  },
  [247] = {
    [sym_concatenation] = STATE(707),
    [sym_string] = STATE(246),
    [sym_simple_expansion] = STATE(246),
    [sym_string_expansion] = STATE(246),
    [sym_expansion] = STATE(246),
    [sym_command_substitution] = STATE(246),
    [sym_process_substitution] = STATE(246),
    [aux_sym_command_repeat2] = STATE(707),
    [aux_sym__literal_repeat1] = STATE(248),
    [sym__simple_heredoc_body] = ACTIONS(1267),
    [sym__heredoc_body_beginning] = ACTIONS(1267),
    [sym_file_descriptor] = ACTIONS(1267),
    [ts_builtin_sym_end] = ACTIONS(1267),
    [anon_sym_SEMI] = ACTIONS(1269),
    [anon_sym_PIPE] = ACTIONS(1269),
    [anon_sym_SEMI_SEMI] = ACTIONS(1267),
    [anon_sym_PIPE_AMP] = ACTIONS(1267),
    [anon_sym_AMP_AMP] = ACTIONS(1267),
    [anon_sym_PIPE_PIPE] = ACTIONS(1267),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1269),
    [anon_sym_GT_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT_GT] = ACTIONS(1267),
    [anon_sym_LT_AMP] = ACTIONS(1267),
    [anon_sym_GT_AMP] = ACTIONS(1267),
    [anon_sym_LT_LT] = ACTIONS(1269),
    [anon_sym_LT_LT_DASH] = ACTIONS(1267),
    [anon_sym_LT_LT_LT] = ACTIONS(1267),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(427),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(429),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(431),
    [anon_sym_LF] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(1269),
  },
  [248] = {
    [aux_sym__literal_repeat1] = STATE(255),
    [sym__simple_heredoc_body] = ACTIONS(1271),
    [sym__heredoc_body_beginning] = ACTIONS(1271),
    [sym_file_descriptor] = ACTIONS(1271),
    [ts_builtin_sym_end] = ACTIONS(1271),
    [anon_sym_SEMI] = ACTIONS(1273),
    [anon_sym_PIPE] = ACTIONS(1273),
    [anon_sym_SEMI_SEMI] = ACTIONS(1271),
    [anon_sym_PIPE_AMP] = ACTIONS(1271),
    [anon_sym_AMP_AMP] = ACTIONS(1271),
    [anon_sym_PIPE_PIPE] = ACTIONS(1271),
    [anon_sym_EQ_TILDE] = ACTIONS(1273),
    [anon_sym_EQ_EQ] = ACTIONS(1273),
    [anon_sym_LT] = ACTIONS(1273),
    [anon_sym_GT] = ACTIONS(1273),
    [anon_sym_GT_GT] = ACTIONS(1271),
    [anon_sym_AMP_GT] = ACTIONS(1273),
    [anon_sym_AMP_GT_GT] = ACTIONS(1271),
    [anon_sym_LT_AMP] = ACTIONS(1271),
    [anon_sym_GT_AMP] = ACTIONS(1271),
    [anon_sym_LT_LT] = ACTIONS(1273),
    [anon_sym_LT_LT_DASH] = ACTIONS(1271),
    [anon_sym_LT_LT_LT] = ACTIONS(1271),
    [anon_sym_DOLLAR] = ACTIONS(1273),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [sym_raw_string] = ACTIONS(1271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1271),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1271),
    [anon_sym_BQUOTE] = ACTIONS(1271),
    [anon_sym_LT_LPAREN] = ACTIONS(1271),
    [anon_sym_GT_LPAREN] = ACTIONS(1271),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1273),
    [anon_sym_LF] = ACTIONS(1271),
    [anon_sym_AMP] = ACTIONS(1273),
  },
  [249] = {
    [sym_file_redirect] = STATE(244),
    [sym_heredoc_redirect] = STATE(244),
    [sym_heredoc_body] = STATE(709),
    [sym_herestring_redirect] = STATE(244),
    [aux_sym_redirected_statement_repeat1] = STATE(244),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(397),
    [ts_builtin_sym_end] = ACTIONS(1239),
    [anon_sym_SEMI] = ACTIONS(1275),
    [anon_sym_PIPE] = ACTIONS(403),
    [anon_sym_SEMI_SEMI] = ACTIONS(1277),
    [anon_sym_PIPE_AMP] = ACTIONS(407),
    [anon_sym_AMP_AMP] = ACTIONS(409),
    [anon_sym_PIPE_PIPE] = ACTIONS(409),
    [anon_sym_LT] = ACTIONS(411),
    [anon_sym_GT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(413),
    [anon_sym_AMP_GT] = ACTIONS(411),
    [anon_sym_AMP_GT_GT] = ACTIONS(413),
    [anon_sym_LT_AMP] = ACTIONS(413),
    [anon_sym_GT_AMP] = ACTIONS(413),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(419),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1275),
  },
  [250] = {
    [sym_file_redirect] = STATE(244),
    [sym_heredoc_redirect] = STATE(244),
    [sym_heredoc_body] = STATE(709),
    [sym_herestring_redirect] = STATE(244),
    [aux_sym_redirected_statement_repeat1] = STATE(244),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [ts_builtin_sym_end] = ACTIONS(1239),
    [anon_sym_SEMI] = ACTIONS(1275),
    [anon_sym_PIPE] = ACTIONS(403),
    [anon_sym_SEMI_SEMI] = ACTIONS(1277),
    [anon_sym_PIPE_AMP] = ACTIONS(407),
    [anon_sym_AMP_AMP] = ACTIONS(409),
    [anon_sym_PIPE_PIPE] = ACTIONS(409),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(419),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1275),
  },
  [251] = {
    [sym_redirected_statement] = STATE(713),
    [sym_for_statement] = STATE(713),
    [sym_c_style_for_statement] = STATE(713),
    [sym_while_statement] = STATE(713),
    [sym_if_statement] = STATE(713),
    [sym_case_statement] = STATE(713),
    [sym_function_definition] = STATE(713),
    [sym_compound_statement] = STATE(713),
    [sym_subshell] = STATE(713),
    [sym_pipeline] = STATE(713),
    [sym_list] = STATE(713),
    [sym_negated_command] = STATE(713),
    [sym_test_command] = STATE(713),
    [sym_declaration_command] = STATE(713),
    [sym_unset_command] = STATE(713),
    [sym_command] = STATE(713),
    [sym_command_name] = STATE(714),
    [sym_variable_assignment] = STATE(715),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(716),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(251),
    [aux_sym_command_repeat1] = STATE(716),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(1279),
    [sym_variable_name] = ACTIONS(1282),
    [anon_sym_for] = ACTIONS(1285),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1288),
    [anon_sym_while] = ACTIONS(1291),
    [anon_sym_if] = ACTIONS(1294),
    [anon_sym_case] = ACTIONS(1297),
    [anon_sym_function] = ACTIONS(1300),
    [anon_sym_LPAREN] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(1306),
    [anon_sym_BANG] = ACTIONS(1309),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1315),
    [anon_sym_declare] = ACTIONS(1318),
    [anon_sym_typeset] = ACTIONS(1318),
    [anon_sym_export] = ACTIONS(1318),
    [anon_sym_readonly] = ACTIONS(1318),
    [anon_sym_local] = ACTIONS(1318),
    [anon_sym_unset] = ACTIONS(1321),
    [anon_sym_unsetenv] = ACTIONS(1321),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_AMP_GT] = ACTIONS(1324),
    [anon_sym_AMP_GT_GT] = ACTIONS(1327),
    [anon_sym_LT_AMP] = ACTIONS(1327),
    [anon_sym_GT_AMP] = ACTIONS(1327),
    [anon_sym_DOLLAR] = ACTIONS(1330),
    [sym__special_character] = ACTIONS(1333),
    [anon_sym_DQUOTE] = ACTIONS(1336),
    [sym_raw_string] = ACTIONS(1339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1342),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1345),
    [anon_sym_BQUOTE] = ACTIONS(1348),
    [anon_sym_LT_LPAREN] = ACTIONS(1351),
    [anon_sym_GT_LPAREN] = ACTIONS(1351),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1354),
  },
  [252] = {
    [sym_concatenation] = STATE(717),
    [sym_string] = STATE(246),
    [sym_simple_expansion] = STATE(246),
    [sym_string_expansion] = STATE(246),
    [sym_expansion] = STATE(246),
    [sym_command_substitution] = STATE(246),
    [sym_process_substitution] = STATE(246),
    [aux_sym_command_repeat2] = STATE(717),
    [aux_sym__literal_repeat1] = STATE(248),
    [sym__simple_heredoc_body] = ACTIONS(1267),
    [sym__heredoc_body_beginning] = ACTIONS(1267),
    [sym_file_descriptor] = ACTIONS(1267),
    [ts_builtin_sym_end] = ACTIONS(1267),
    [anon_sym_SEMI] = ACTIONS(1269),
    [anon_sym_PIPE] = ACTIONS(1269),
    [anon_sym_SEMI_SEMI] = ACTIONS(1267),
    [anon_sym_PIPE_AMP] = ACTIONS(1267),
    [anon_sym_AMP_AMP] = ACTIONS(1267),
    [anon_sym_PIPE_PIPE] = ACTIONS(1267),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1269),
    [anon_sym_GT_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT_GT] = ACTIONS(1267),
    [anon_sym_LT_AMP] = ACTIONS(1267),
    [anon_sym_GT_AMP] = ACTIONS(1267),
    [anon_sym_LT_LT] = ACTIONS(1269),
    [anon_sym_LT_LT_DASH] = ACTIONS(1267),
    [anon_sym_LT_LT_LT] = ACTIONS(1267),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(427),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(429),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(431),
    [anon_sym_LF] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(1269),
  },
  [253] = {
    [sym_variable_assignment] = STATE(253),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(253),
    [aux_sym_command_repeat1] = STATE(253),
    [sym_file_descriptor] = ACTIONS(1357),
    [sym_variable_name] = ACTIONS(1360),
    [anon_sym_LT] = ACTIONS(1363),
    [anon_sym_GT] = ACTIONS(1363),
    [anon_sym_GT_GT] = ACTIONS(1366),
    [anon_sym_AMP_GT] = ACTIONS(1363),
    [anon_sym_AMP_GT_GT] = ACTIONS(1366),
    [anon_sym_LT_AMP] = ACTIONS(1366),
    [anon_sym_GT_AMP] = ACTIONS(1366),
    [anon_sym_DOLLAR] = ACTIONS(1369),
    [sym__special_character] = ACTIONS(1371),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [sym_raw_string] = ACTIONS(1371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [anon_sym_LT_LPAREN] = ACTIONS(1371),
    [anon_sym_GT_LPAREN] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1371),
  },
  [254] = {
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [ts_builtin_sym_end] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_RPAREN] = ACTIONS(335),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_EQ_TILDE] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [255] = {
    [aux_sym__literal_repeat1] = STATE(255),
    [sym__simple_heredoc_body] = ACTIONS(1373),
    [sym__heredoc_body_beginning] = ACTIONS(1373),
    [sym_file_descriptor] = ACTIONS(1373),
    [ts_builtin_sym_end] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE_AMP] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_EQ_TILDE] = ACTIONS(1375),
    [anon_sym_EQ_EQ] = ACTIONS(1375),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_LT_LT_DASH] = ACTIONS(1373),
    [anon_sym_LT_LT_LT] = ACTIONS(1373),
    [anon_sym_DOLLAR] = ACTIONS(1375),
    [sym__special_character] = ACTIONS(1377),
    [anon_sym_DQUOTE] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1373),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [anon_sym_LT_LPAREN] = ACTIONS(1373),
    [anon_sym_GT_LPAREN] = ACTIONS(1373),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1375),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
  },
  [256] = {
    [aux_sym_concatenation_repeat1] = STATE(597),
    [sym_file_descriptor] = ACTIONS(1380),
    [sym__concat] = ACTIONS(1031),
    [sym_variable_name] = ACTIONS(1380),
    [anon_sym_LT] = ACTIONS(1382),
    [anon_sym_GT] = ACTIONS(1382),
    [anon_sym_GT_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT] = ACTIONS(1382),
    [anon_sym_AMP_GT_GT] = ACTIONS(1380),
    [anon_sym_LT_AMP] = ACTIONS(1380),
    [anon_sym_GT_AMP] = ACTIONS(1380),
    [anon_sym_DOLLAR] = ACTIONS(1382),
    [sym__special_character] = ACTIONS(1380),
    [anon_sym_DQUOTE] = ACTIONS(1380),
    [sym_raw_string] = ACTIONS(1380),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1380),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1380),
    [anon_sym_BQUOTE] = ACTIONS(1380),
    [anon_sym_LT_LPAREN] = ACTIONS(1380),
    [anon_sym_GT_LPAREN] = ACTIONS(1380),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1380),
  },
  [257] = {
    [sym_file_descriptor] = ACTIONS(1380),
    [sym_variable_name] = ACTIONS(1380),
    [anon_sym_RPAREN] = ACTIONS(1380),
    [anon_sym_LT] = ACTIONS(1382),
    [anon_sym_GT] = ACTIONS(1382),
    [anon_sym_GT_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT] = ACTIONS(1382),
    [anon_sym_AMP_GT_GT] = ACTIONS(1380),
    [anon_sym_LT_AMP] = ACTIONS(1380),
    [anon_sym_GT_AMP] = ACTIONS(1380),
    [anon_sym_DOLLAR] = ACTIONS(1382),
    [sym__special_character] = ACTIONS(1380),
    [anon_sym_DQUOTE] = ACTIONS(1380),
    [sym_raw_string] = ACTIONS(1380),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1380),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1380),
    [anon_sym_BQUOTE] = ACTIONS(1380),
    [anon_sym_LT_LPAREN] = ACTIONS(1380),
    [anon_sym_GT_LPAREN] = ACTIONS(1380),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1380),
  },
  [258] = {
    [aux_sym__literal_repeat1] = STATE(610),
    [sym_file_descriptor] = ACTIONS(1384),
    [sym_variable_name] = ACTIONS(1384),
    [anon_sym_LT] = ACTIONS(1386),
    [anon_sym_GT] = ACTIONS(1386),
    [anon_sym_GT_GT] = ACTIONS(1384),
    [anon_sym_AMP_GT] = ACTIONS(1386),
    [anon_sym_AMP_GT_GT] = ACTIONS(1384),
    [anon_sym_LT_AMP] = ACTIONS(1384),
    [anon_sym_GT_AMP] = ACTIONS(1384),
    [anon_sym_DOLLAR] = ACTIONS(1386),
    [sym__special_character] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1384),
    [sym_raw_string] = ACTIONS(1384),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1384),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1384),
    [anon_sym_BQUOTE] = ACTIONS(1384),
    [anon_sym_LT_LPAREN] = ACTIONS(1384),
    [anon_sym_GT_LPAREN] = ACTIONS(1384),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1384),
  },
  [259] = {
    [aux_sym_concatenation_repeat1] = STATE(718),
    [sym__concat] = ACTIONS(335),
    [anon_sym_RBRACK] = ACTIONS(335),
    [sym__special_character] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
  },
  [260] = {
    [aux_sym_concatenation_repeat1] = STATE(718),
    [sym__concat] = ACTIONS(1388),
    [anon_sym_RBRACK] = ACTIONS(1390),
    [sym_comment] = ACTIONS(57),
  },
  [261] = {
    [sym__concat] = ACTIONS(1392),
    [anon_sym_RBRACK] = ACTIONS(1390),
    [sym_comment] = ACTIONS(57),
  },
  [262] = {
    [aux_sym__literal_repeat1] = STATE(725),
    [sym__concat] = ACTIONS(1394),
    [anon_sym_RBRACK] = ACTIONS(1396),
    [sym__special_character] = ACTIONS(1398),
    [sym_comment] = ACTIONS(57),
  },
  [263] = {
    [sym__simple_heredoc_body] = ACTIONS(1400),
    [sym__heredoc_body_beginning] = ACTIONS(1400),
    [sym_file_descriptor] = ACTIONS(1400),
    [sym_variable_name] = ACTIONS(1400),
    [ts_builtin_sym_end] = ACTIONS(1400),
    [anon_sym_SEMI] = ACTIONS(1402),
    [anon_sym_PIPE] = ACTIONS(1402),
    [anon_sym_RPAREN] = ACTIONS(1400),
    [anon_sym_SEMI_SEMI] = ACTIONS(1400),
    [anon_sym_PIPE_AMP] = ACTIONS(1400),
    [anon_sym_AMP_AMP] = ACTIONS(1400),
    [anon_sym_PIPE_PIPE] = ACTIONS(1400),
    [anon_sym_LT] = ACTIONS(1402),
    [anon_sym_GT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT] = ACTIONS(1402),
    [anon_sym_AMP_GT_GT] = ACTIONS(1400),
    [anon_sym_LT_AMP] = ACTIONS(1400),
    [anon_sym_GT_AMP] = ACTIONS(1400),
    [anon_sym_LT_LT] = ACTIONS(1402),
    [anon_sym_LT_LT_DASH] = ACTIONS(1400),
    [anon_sym_LT_LT_LT] = ACTIONS(1400),
    [anon_sym_DOLLAR] = ACTIONS(1402),
    [sym__special_character] = ACTIONS(1400),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1400),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1400),
    [anon_sym_BQUOTE] = ACTIONS(1400),
    [anon_sym_LT_LPAREN] = ACTIONS(1400),
    [anon_sym_GT_LPAREN] = ACTIONS(1400),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1402),
    [anon_sym_LF] = ACTIONS(1400),
    [anon_sym_AMP] = ACTIONS(1402),
  },
  [264] = {
    [sym_concatenation] = STATE(735),
    [sym_string] = STATE(730),
    [sym_simple_expansion] = STATE(730),
    [sym_string_expansion] = STATE(730),
    [sym_expansion] = STATE(730),
    [sym_command_substitution] = STATE(730),
    [sym_process_substitution] = STATE(730),
    [aux_sym_for_statement_repeat1] = STATE(735),
    [aux_sym__literal_repeat1] = STATE(736),
    [anon_sym_RPAREN] = ACTIONS(1404),
    [anon_sym_DOLLAR] = ACTIONS(1406),
    [sym__special_character] = ACTIONS(1408),
    [anon_sym_DQUOTE] = ACTIONS(1410),
    [sym_raw_string] = ACTIONS(1412),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1414),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1416),
    [anon_sym_BQUOTE] = ACTIONS(1418),
    [anon_sym_LT_LPAREN] = ACTIONS(1420),
    [anon_sym_GT_LPAREN] = ACTIONS(1420),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1412),
  },
  [265] = {
    [sym_string] = STATE(738),
    [anon_sym_DASH] = ACTIONS(1422),
    [anon_sym_DOLLAR] = ACTIONS(1422),
    [anon_sym_DQUOTE] = ACTIONS(457),
    [sym_raw_string] = ACTIONS(1424),
    [anon_sym_POUND] = ACTIONS(1422),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1426),
    [anon_sym_STAR] = ACTIONS(1428),
    [anon_sym_AT] = ACTIONS(1428),
    [anon_sym_QMARK] = ACTIONS(1428),
    [anon_sym_0] = ACTIONS(1426),
    [anon_sym__] = ACTIONS(1426),
  },
  [266] = {
    [aux_sym_concatenation_repeat1] = STATE(741),
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(1430),
    [sym_variable_name] = ACTIONS(335),
    [ts_builtin_sym_end] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [267] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(744),
    [anon_sym_DOLLAR] = ACTIONS(1432),
    [anon_sym_DQUOTE] = ACTIONS(1434),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [268] = {
    [aux_sym_concatenation_repeat1] = STATE(741),
    [sym__simple_heredoc_body] = ACTIONS(1400),
    [sym__heredoc_body_beginning] = ACTIONS(1400),
    [sym_file_descriptor] = ACTIONS(1400),
    [sym__concat] = ACTIONS(1430),
    [sym_variable_name] = ACTIONS(1400),
    [ts_builtin_sym_end] = ACTIONS(1400),
    [anon_sym_SEMI] = ACTIONS(1402),
    [anon_sym_PIPE] = ACTIONS(1402),
    [anon_sym_SEMI_SEMI] = ACTIONS(1400),
    [anon_sym_PIPE_AMP] = ACTIONS(1400),
    [anon_sym_AMP_AMP] = ACTIONS(1400),
    [anon_sym_PIPE_PIPE] = ACTIONS(1400),
    [anon_sym_LT] = ACTIONS(1402),
    [anon_sym_GT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT] = ACTIONS(1402),
    [anon_sym_AMP_GT_GT] = ACTIONS(1400),
    [anon_sym_LT_AMP] = ACTIONS(1400),
    [anon_sym_GT_AMP] = ACTIONS(1400),
    [anon_sym_LT_LT] = ACTIONS(1402),
    [anon_sym_LT_LT_DASH] = ACTIONS(1400),
    [anon_sym_LT_LT_LT] = ACTIONS(1400),
    [anon_sym_DOLLAR] = ACTIONS(1402),
    [sym__special_character] = ACTIONS(1400),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1400),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1400),
    [anon_sym_BQUOTE] = ACTIONS(1400),
    [anon_sym_LT_LPAREN] = ACTIONS(1400),
    [anon_sym_GT_LPAREN] = ACTIONS(1400),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1402),
    [anon_sym_LF] = ACTIONS(1400),
    [anon_sym_AMP] = ACTIONS(1402),
  },
  [269] = {
    [sym_subscript] = STATE(748),
    [sym_variable_name] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(1438),
    [anon_sym_DASH] = ACTIONS(1440),
    [anon_sym_DOLLAR] = ACTIONS(1440),
    [anon_sym_POUND] = ACTIONS(1438),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1444),
    [anon_sym_AT] = ACTIONS(1444),
    [anon_sym_QMARK] = ACTIONS(1444),
    [anon_sym_0] = ACTIONS(1442),
    [anon_sym__] = ACTIONS(1442),
  },
  [270] = {
    [sym__statements] = STATE(749),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(750),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [271] = {
    [sym__statements] = STATE(751),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [272] = {
    [sym__statements] = STATE(752),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [273] = {
    [aux_sym__literal_repeat1] = STATE(754),
    [sym__simple_heredoc_body] = ACTIONS(1446),
    [sym__heredoc_body_beginning] = ACTIONS(1446),
    [sym_file_descriptor] = ACTIONS(1446),
    [sym_variable_name] = ACTIONS(1446),
    [ts_builtin_sym_end] = ACTIONS(1446),
    [anon_sym_SEMI] = ACTIONS(1448),
    [anon_sym_PIPE] = ACTIONS(1448),
    [anon_sym_SEMI_SEMI] = ACTIONS(1446),
    [anon_sym_PIPE_AMP] = ACTIONS(1446),
    [anon_sym_AMP_AMP] = ACTIONS(1446),
    [anon_sym_PIPE_PIPE] = ACTIONS(1446),
    [anon_sym_LT] = ACTIONS(1448),
    [anon_sym_GT] = ACTIONS(1448),
    [anon_sym_GT_GT] = ACTIONS(1446),
    [anon_sym_AMP_GT] = ACTIONS(1448),
    [anon_sym_AMP_GT_GT] = ACTIONS(1446),
    [anon_sym_LT_AMP] = ACTIONS(1446),
    [anon_sym_GT_AMP] = ACTIONS(1446),
    [anon_sym_LT_LT] = ACTIONS(1448),
    [anon_sym_LT_LT_DASH] = ACTIONS(1446),
    [anon_sym_LT_LT_LT] = ACTIONS(1446),
    [anon_sym_DOLLAR] = ACTIONS(1448),
    [sym__special_character] = ACTIONS(1450),
    [anon_sym_DQUOTE] = ACTIONS(1446),
    [sym_raw_string] = ACTIONS(1446),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1446),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1446),
    [anon_sym_BQUOTE] = ACTIONS(1446),
    [anon_sym_LT_LPAREN] = ACTIONS(1446),
    [anon_sym_GT_LPAREN] = ACTIONS(1446),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1448),
    [anon_sym_LF] = ACTIONS(1446),
    [anon_sym_AMP] = ACTIONS(1448),
  },
  [274] = {
    [sym__expression] = STATE(756),
    [sym_binary_expression] = STATE(756),
    [sym_unary_expression] = STATE(756),
    [sym_postfix_expression] = STATE(756),
    [sym_parenthesized_expression] = STATE(756),
    [sym_concatenation] = STATE(756),
    [sym_string] = STATE(280),
    [sym_simple_expansion] = STATE(280),
    [sym_string_expansion] = STATE(280),
    [sym_expansion] = STATE(280),
    [sym_command_substitution] = STATE(280),
    [sym_process_substitution] = STATE(280),
    [aux_sym__literal_repeat1] = STATE(286),
    [anon_sym_SEMI] = ACTIONS(1452),
    [anon_sym_SEMI_SEMI] = ACTIONS(1454),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(475),
    [anon_sym_DOLLAR] = ACTIONS(477),
    [sym__special_character] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(481),
    [sym_raw_string] = ACTIONS(483),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(485),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(487),
    [anon_sym_BQUOTE] = ACTIONS(489),
    [anon_sym_LT_LPAREN] = ACTIONS(491),
    [anon_sym_GT_LPAREN] = ACTIONS(491),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(493),
    [sym_test_operator] = ACTIONS(495),
    [anon_sym_LF] = ACTIONS(1454),
    [anon_sym_AMP] = ACTIONS(1454),
  },
  [275] = {
    [sym__expression] = STATE(757),
    [sym_binary_expression] = STATE(757),
    [sym_unary_expression] = STATE(757),
    [sym_postfix_expression] = STATE(757),
    [sym_parenthesized_expression] = STATE(757),
    [sym_concatenation] = STATE(757),
    [sym_string] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [sym_expansion] = STATE(294),
    [sym_command_substitution] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(300),
    [anon_sym_LPAREN] = ACTIONS(503),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_DOLLAR] = ACTIONS(507),
    [sym__special_character] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(513),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(523),
    [sym_test_operator] = ACTIONS(525),
  },
  [276] = {
    [sym__expression] = STATE(758),
    [sym_binary_expression] = STATE(758),
    [sym_unary_expression] = STATE(758),
    [sym_postfix_expression] = STATE(758),
    [sym_parenthesized_expression] = STATE(758),
    [sym_concatenation] = STATE(758),
    [sym_string] = STATE(280),
    [sym_simple_expansion] = STATE(280),
    [sym_string_expansion] = STATE(280),
    [sym_expansion] = STATE(280),
    [sym_command_substitution] = STATE(280),
    [sym_process_substitution] = STATE(280),
    [aux_sym__literal_repeat1] = STATE(286),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(475),
    [anon_sym_DOLLAR] = ACTIONS(477),
    [sym__special_character] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(481),
    [sym_raw_string] = ACTIONS(483),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(485),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(487),
    [anon_sym_BQUOTE] = ACTIONS(489),
    [anon_sym_LT_LPAREN] = ACTIONS(491),
    [anon_sym_GT_LPAREN] = ACTIONS(491),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(493),
    [sym_test_operator] = ACTIONS(495),
  },
  [277] = {
    [sym_string] = STATE(760),
    [anon_sym_DASH] = ACTIONS(1456),
    [anon_sym_DOLLAR] = ACTIONS(1456),
    [anon_sym_DQUOTE] = ACTIONS(481),
    [sym_raw_string] = ACTIONS(1458),
    [anon_sym_POUND] = ACTIONS(1456),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AT] = ACTIONS(1462),
    [anon_sym_QMARK] = ACTIONS(1462),
    [anon_sym_0] = ACTIONS(1460),
    [anon_sym__] = ACTIONS(1460),
  },
  [278] = {
    [aux_sym_concatenation_repeat1] = STATE(763),
    [sym__concat] = ACTIONS(1464),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_EQ_TILDE] = ACTIONS(335),
    [anon_sym_EQ_EQ] = ACTIONS(335),
    [anon_sym_EQ] = ACTIONS(339),
    [anon_sym_PLUS_EQ] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(335),
    [anon_sym_PLUS] = ACTIONS(339),
    [anon_sym_DASH] = ACTIONS(339),
    [anon_sym_DASH_EQ] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(335),
    [anon_sym_GT_EQ] = ACTIONS(335),
    [anon_sym_PLUS_PLUS] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(335),
    [sym__special_character] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(335),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [279] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(766),
    [anon_sym_DOLLAR] = ACTIONS(1466),
    [anon_sym_DQUOTE] = ACTIONS(1468),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [280] = {
    [aux_sym_concatenation_repeat1] = STATE(763),
    [sym__concat] = ACTIONS(1464),
    [anon_sym_SEMI] = ACTIONS(543),
    [anon_sym_SEMI_SEMI] = ACTIONS(541),
    [anon_sym_AMP_AMP] = ACTIONS(541),
    [anon_sym_PIPE_PIPE] = ACTIONS(541),
    [anon_sym_EQ_TILDE] = ACTIONS(541),
    [anon_sym_EQ_EQ] = ACTIONS(541),
    [anon_sym_EQ] = ACTIONS(543),
    [anon_sym_PLUS_EQ] = ACTIONS(541),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_BANG_EQ] = ACTIONS(541),
    [anon_sym_PLUS] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(543),
    [anon_sym_DASH_EQ] = ACTIONS(541),
    [anon_sym_LT_EQ] = ACTIONS(541),
    [anon_sym_GT_EQ] = ACTIONS(541),
    [anon_sym_PLUS_PLUS] = ACTIONS(541),
    [anon_sym_DASH_DASH] = ACTIONS(541),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(541),
    [anon_sym_LF] = ACTIONS(541),
    [anon_sym_AMP] = ACTIONS(543),
  },
  [281] = {
    [sym_subscript] = STATE(770),
    [sym_variable_name] = ACTIONS(1470),
    [anon_sym_BANG] = ACTIONS(1472),
    [anon_sym_DASH] = ACTIONS(1474),
    [anon_sym_DOLLAR] = ACTIONS(1474),
    [anon_sym_POUND] = ACTIONS(1472),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1476),
    [anon_sym_STAR] = ACTIONS(1478),
    [anon_sym_AT] = ACTIONS(1478),
    [anon_sym_QMARK] = ACTIONS(1478),
    [anon_sym_0] = ACTIONS(1476),
    [anon_sym__] = ACTIONS(1476),
  },
  [282] = {
    [sym__statements] = STATE(771),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(772),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [283] = {
    [sym__statements] = STATE(773),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [284] = {
    [sym__statements] = STATE(774),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [285] = {
    [anon_sym_SEMI] = ACTIONS(1480),
    [anon_sym_SEMI_SEMI] = ACTIONS(1482),
    [anon_sym_AMP_AMP] = ACTIONS(1484),
    [anon_sym_PIPE_PIPE] = ACTIONS(1484),
    [anon_sym_EQ_TILDE] = ACTIONS(1486),
    [anon_sym_EQ_EQ] = ACTIONS(1486),
    [anon_sym_EQ] = ACTIONS(1488),
    [anon_sym_PLUS_EQ] = ACTIONS(1484),
    [anon_sym_LT] = ACTIONS(1488),
    [anon_sym_GT] = ACTIONS(1488),
    [anon_sym_BANG_EQ] = ACTIONS(1484),
    [anon_sym_PLUS] = ACTIONS(1488),
    [anon_sym_DASH] = ACTIONS(1488),
    [anon_sym_DASH_EQ] = ACTIONS(1484),
    [anon_sym_LT_EQ] = ACTIONS(1484),
    [anon_sym_GT_EQ] = ACTIONS(1484),
    [anon_sym_PLUS_PLUS] = ACTIONS(1490),
    [anon_sym_DASH_DASH] = ACTIONS(1490),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1484),
    [anon_sym_LF] = ACTIONS(1482),
    [anon_sym_AMP] = ACTIONS(1480),
  },
  [286] = {
    [aux_sym__literal_repeat1] = STATE(780),
    [anon_sym_SEMI] = ACTIONS(567),
    [anon_sym_SEMI_SEMI] = ACTIONS(565),
    [anon_sym_AMP_AMP] = ACTIONS(565),
    [anon_sym_PIPE_PIPE] = ACTIONS(565),
    [anon_sym_EQ_TILDE] = ACTIONS(565),
    [anon_sym_EQ_EQ] = ACTIONS(565),
    [anon_sym_EQ] = ACTIONS(567),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_LT] = ACTIONS(567),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_LT_EQ] = ACTIONS(565),
    [anon_sym_GT_EQ] = ACTIONS(565),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [sym__special_character] = ACTIONS(1492),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(565),
    [anon_sym_LF] = ACTIONS(565),
    [anon_sym_AMP] = ACTIONS(567),
  },
  [287] = {
    [sym_concatenation] = STATE(789),
    [sym_string] = STATE(784),
    [sym_simple_expansion] = STATE(784),
    [sym_string_expansion] = STATE(784),
    [sym_expansion] = STATE(784),
    [sym_command_substitution] = STATE(784),
    [sym_process_substitution] = STATE(784),
    [aux_sym_for_statement_repeat1] = STATE(789),
    [aux_sym__literal_repeat1] = STATE(790),
    [anon_sym_DOLLAR] = ACTIONS(1494),
    [sym__special_character] = ACTIONS(1496),
    [anon_sym_DQUOTE] = ACTIONS(1498),
    [sym_raw_string] = ACTIONS(1500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1502),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1504),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_LT_LPAREN] = ACTIONS(1508),
    [anon_sym_GT_LPAREN] = ACTIONS(1508),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1500),
  },
  [288] = {
    [sym_do_group] = STATE(791),
    [anon_sym_do] = ACTIONS(651),
    [sym_comment] = ACTIONS(57),
  },
  [289] = {
    [sym__expression] = STATE(792),
    [sym_binary_expression] = STATE(792),
    [sym_unary_expression] = STATE(792),
    [sym_postfix_expression] = STATE(792),
    [sym_parenthesized_expression] = STATE(792),
    [sym_concatenation] = STATE(792),
    [sym_string] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [sym_expansion] = STATE(294),
    [sym_command_substitution] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(300),
    [anon_sym_LPAREN] = ACTIONS(503),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_DOLLAR] = ACTIONS(507),
    [sym__special_character] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(513),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(523),
    [sym_test_operator] = ACTIONS(525),
  },
  [290] = {
    [sym__expression] = STATE(793),
    [sym_binary_expression] = STATE(793),
    [sym_unary_expression] = STATE(793),
    [sym_postfix_expression] = STATE(793),
    [sym_parenthesized_expression] = STATE(793),
    [sym_concatenation] = STATE(793),
    [sym_string] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [sym_expansion] = STATE(294),
    [sym_command_substitution] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(300),
    [anon_sym_LPAREN] = ACTIONS(503),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_DOLLAR] = ACTIONS(507),
    [sym__special_character] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(513),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(523),
    [sym_test_operator] = ACTIONS(525),
  },
  [291] = {
    [sym_string] = STATE(795),
    [anon_sym_DASH] = ACTIONS(1510),
    [anon_sym_DOLLAR] = ACTIONS(1510),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(1512),
    [anon_sym_POUND] = ACTIONS(1510),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1514),
    [anon_sym_STAR] = ACTIONS(1516),
    [anon_sym_AT] = ACTIONS(1516),
    [anon_sym_QMARK] = ACTIONS(1516),
    [anon_sym_0] = ACTIONS(1514),
    [anon_sym__] = ACTIONS(1514),
  },
  [292] = {
    [aux_sym_concatenation_repeat1] = STATE(798),
    [sym__concat] = ACTIONS(1518),
    [anon_sym_RPAREN] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_EQ_TILDE] = ACTIONS(335),
    [anon_sym_EQ_EQ] = ACTIONS(335),
    [anon_sym_EQ] = ACTIONS(339),
    [anon_sym_PLUS_EQ] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(335),
    [anon_sym_PLUS] = ACTIONS(339),
    [anon_sym_DASH] = ACTIONS(339),
    [anon_sym_DASH_EQ] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(335),
    [anon_sym_GT_EQ] = ACTIONS(335),
    [anon_sym_PLUS_PLUS] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(335),
    [sym__special_character] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(335),
  },
  [293] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(801),
    [anon_sym_DOLLAR] = ACTIONS(1520),
    [anon_sym_DQUOTE] = ACTIONS(1522),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [294] = {
    [aux_sym_concatenation_repeat1] = STATE(798),
    [sym__concat] = ACTIONS(1518),
    [anon_sym_RPAREN] = ACTIONS(541),
    [anon_sym_AMP_AMP] = ACTIONS(541),
    [anon_sym_PIPE_PIPE] = ACTIONS(541),
    [anon_sym_EQ_TILDE] = ACTIONS(541),
    [anon_sym_EQ_EQ] = ACTIONS(541),
    [anon_sym_EQ] = ACTIONS(543),
    [anon_sym_PLUS_EQ] = ACTIONS(541),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_BANG_EQ] = ACTIONS(541),
    [anon_sym_PLUS] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(543),
    [anon_sym_DASH_EQ] = ACTIONS(541),
    [anon_sym_LT_EQ] = ACTIONS(541),
    [anon_sym_GT_EQ] = ACTIONS(541),
    [anon_sym_PLUS_PLUS] = ACTIONS(541),
    [anon_sym_DASH_DASH] = ACTIONS(541),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(541),
  },
  [295] = {
    [sym_subscript] = STATE(805),
    [sym_variable_name] = ACTIONS(1524),
    [anon_sym_BANG] = ACTIONS(1526),
    [anon_sym_DASH] = ACTIONS(1528),
    [anon_sym_DOLLAR] = ACTIONS(1528),
    [anon_sym_POUND] = ACTIONS(1526),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1530),
    [anon_sym_STAR] = ACTIONS(1532),
    [anon_sym_AT] = ACTIONS(1532),
    [anon_sym_QMARK] = ACTIONS(1532),
    [anon_sym_0] = ACTIONS(1530),
    [anon_sym__] = ACTIONS(1530),
  },
  [296] = {
    [sym__statements] = STATE(806),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(807),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [297] = {
    [sym__statements] = STATE(808),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [298] = {
    [sym__statements] = STATE(809),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [299] = {
    [anon_sym_RPAREN] = ACTIONS(1534),
    [anon_sym_AMP_AMP] = ACTIONS(1536),
    [anon_sym_PIPE_PIPE] = ACTIONS(1536),
    [anon_sym_EQ_TILDE] = ACTIONS(1538),
    [anon_sym_EQ_EQ] = ACTIONS(1538),
    [anon_sym_EQ] = ACTIONS(1540),
    [anon_sym_PLUS_EQ] = ACTIONS(1536),
    [anon_sym_LT] = ACTIONS(1540),
    [anon_sym_GT] = ACTIONS(1540),
    [anon_sym_BANG_EQ] = ACTIONS(1536),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_DASH_EQ] = ACTIONS(1536),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_PLUS_PLUS] = ACTIONS(1542),
    [anon_sym_DASH_DASH] = ACTIONS(1542),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1536),
  },
  [300] = {
    [aux_sym__literal_repeat1] = STATE(815),
    [anon_sym_RPAREN] = ACTIONS(565),
    [anon_sym_AMP_AMP] = ACTIONS(565),
    [anon_sym_PIPE_PIPE] = ACTIONS(565),
    [anon_sym_EQ_TILDE] = ACTIONS(565),
    [anon_sym_EQ_EQ] = ACTIONS(565),
    [anon_sym_EQ] = ACTIONS(567),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_LT] = ACTIONS(567),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_LT_EQ] = ACTIONS(565),
    [anon_sym_GT_EQ] = ACTIONS(565),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [sym__special_character] = ACTIONS(1544),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(565),
  },
  [301] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1546),
    [anon_sym_AMP_AMP] = ACTIONS(557),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(559),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_PLUS_EQ] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DASH_EQ] = ACTIONS(557),
    [anon_sym_LT_EQ] = ACTIONS(557),
    [anon_sym_GT_EQ] = ACTIONS(557),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(557),
  },
  [302] = {
    [sym__concat] = ACTIONS(1057),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1057),
    [anon_sym_EQ_TILDE] = ACTIONS(1057),
    [anon_sym_EQ_EQ] = ACTIONS(1057),
    [anon_sym_EQ] = ACTIONS(1059),
    [anon_sym_PLUS_EQ] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_BANG_EQ] = ACTIONS(1057),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_DASH_EQ] = ACTIONS(1057),
    [anon_sym_LT_EQ] = ACTIONS(1057),
    [anon_sym_GT_EQ] = ACTIONS(1057),
    [anon_sym_PLUS_PLUS] = ACTIONS(1057),
    [anon_sym_DASH_DASH] = ACTIONS(1057),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1057),
  },
  [303] = {
    [sym__concat] = ACTIONS(1061),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1061),
    [anon_sym_AMP_AMP] = ACTIONS(1061),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1061),
    [anon_sym_EQ_TILDE] = ACTIONS(1061),
    [anon_sym_EQ_EQ] = ACTIONS(1061),
    [anon_sym_EQ] = ACTIONS(1063),
    [anon_sym_PLUS_EQ] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1063),
    [anon_sym_BANG_EQ] = ACTIONS(1061),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_DASH] = ACTIONS(1063),
    [anon_sym_DASH_EQ] = ACTIONS(1061),
    [anon_sym_LT_EQ] = ACTIONS(1061),
    [anon_sym_GT_EQ] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1061),
  },
  [304] = {
    [sym__concat] = ACTIONS(1065),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1065),
    [anon_sym_AMP_AMP] = ACTIONS(1065),
    [anon_sym_PIPE_PIPE] = ACTIONS(1065),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1065),
    [anon_sym_EQ_TILDE] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(1067),
    [anon_sym_PLUS_EQ] = ACTIONS(1065),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_GT] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DASH_EQ] = ACTIONS(1065),
    [anon_sym_LT_EQ] = ACTIONS(1065),
    [anon_sym_GT_EQ] = ACTIONS(1065),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1065),
  },
  [305] = {
    [sym_string] = STATE(816),
    [sym_simple_expansion] = STATE(816),
    [sym_string_expansion] = STATE(816),
    [sym_expansion] = STATE(816),
    [sym_command_substitution] = STATE(816),
    [sym_process_substitution] = STATE(816),
    [anon_sym_DOLLAR] = ACTIONS(77),
    [sym__special_character] = ACTIONS(1548),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(1548),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1548),
  },
  [306] = {
    [aux_sym_concatenation_repeat1] = STATE(818),
    [sym__concat] = ACTIONS(1550),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_EQ_TILDE] = ACTIONS(1071),
    [anon_sym_EQ_EQ] = ACTIONS(1071),
    [anon_sym_EQ] = ACTIONS(1075),
    [anon_sym_PLUS_EQ] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_BANG_EQ] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(1075),
    [anon_sym_DASH] = ACTIONS(1075),
    [anon_sym_DASH_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_PLUS_PLUS] = ACTIONS(1071),
    [anon_sym_DASH_DASH] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1071),
  },
  [307] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(1552),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [308] = {
    [sym__concat] = ACTIONS(1089),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_EQ_EQ] = ACTIONS(1089),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_DASH] = ACTIONS(1091),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1089),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_PLUS_PLUS] = ACTIONS(1089),
    [anon_sym_DASH_DASH] = ACTIONS(1089),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1089),
  },
  [309] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(627),
    [anon_sym_DOLLAR] = ACTIONS(1554),
    [anon_sym_DQUOTE] = ACTIONS(1552),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [310] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(1556),
    [sym_comment] = ACTIONS(57),
  },
  [311] = {
    [sym_subscript] = STATE(824),
    [sym_variable_name] = ACTIONS(1558),
    [anon_sym_DASH] = ACTIONS(1560),
    [anon_sym_DOLLAR] = ACTIONS(1560),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1564),
    [anon_sym_AT] = ACTIONS(1564),
    [anon_sym_QMARK] = ACTIONS(1564),
    [anon_sym_0] = ACTIONS(1562),
    [anon_sym__] = ACTIONS(1562),
  },
  [312] = {
    [sym_concatenation] = STATE(827),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(827),
    [anon_sym_RBRACE] = ACTIONS(1566),
    [anon_sym_EQ] = ACTIONS(1568),
    [anon_sym_DASH] = ACTIONS(1568),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(1570),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(1572),
    [anon_sym_COLON] = ACTIONS(1568),
    [anon_sym_COLON_QMARK] = ACTIONS(1568),
    [anon_sym_COLON_DASH] = ACTIONS(1568),
    [anon_sym_PERCENT] = ACTIONS(1568),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [313] = {
    [sym_concatenation] = STATE(830),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(830),
    [anon_sym_RBRACE] = ACTIONS(1574),
    [anon_sym_EQ] = ACTIONS(1576),
    [anon_sym_DASH] = ACTIONS(1576),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(1578),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_COLON] = ACTIONS(1576),
    [anon_sym_COLON_QMARK] = ACTIONS(1576),
    [anon_sym_COLON_DASH] = ACTIONS(1576),
    [anon_sym_PERCENT] = ACTIONS(1576),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [314] = {
    [anon_sym_RPAREN] = ACTIONS(1582),
    [sym_comment] = ACTIONS(57),
  },
  [315] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(1582),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [316] = {
    [anon_sym_BQUOTE] = ACTIONS(1582),
    [sym_comment] = ACTIONS(57),
  },
  [317] = {
    [anon_sym_RPAREN] = ACTIONS(1584),
    [sym_comment] = ACTIONS(57),
  },
  [318] = {
    [sym__simple_heredoc_body] = ACTIONS(1586),
    [sym__heredoc_body_beginning] = ACTIONS(1586),
    [sym_file_descriptor] = ACTIONS(1586),
    [ts_builtin_sym_end] = ACTIONS(1586),
    [anon_sym_SEMI] = ACTIONS(1588),
    [anon_sym_done] = ACTIONS(1586),
    [anon_sym_fi] = ACTIONS(1586),
    [anon_sym_elif] = ACTIONS(1586),
    [anon_sym_else] = ACTIONS(1586),
    [anon_sym_esac] = ACTIONS(1586),
    [anon_sym_PIPE] = ACTIONS(1588),
    [anon_sym_RPAREN] = ACTIONS(1586),
    [anon_sym_SEMI_SEMI] = ACTIONS(1586),
    [anon_sym_PIPE_AMP] = ACTIONS(1586),
    [anon_sym_AMP_AMP] = ACTIONS(1586),
    [anon_sym_PIPE_PIPE] = ACTIONS(1586),
    [anon_sym_LT] = ACTIONS(1588),
    [anon_sym_GT] = ACTIONS(1588),
    [anon_sym_GT_GT] = ACTIONS(1586),
    [anon_sym_AMP_GT] = ACTIONS(1588),
    [anon_sym_AMP_GT_GT] = ACTIONS(1586),
    [anon_sym_LT_AMP] = ACTIONS(1586),
    [anon_sym_GT_AMP] = ACTIONS(1586),
    [anon_sym_LT_LT] = ACTIONS(1588),
    [anon_sym_LT_LT_DASH] = ACTIONS(1586),
    [anon_sym_LT_LT_LT] = ACTIONS(1586),
    [anon_sym_BQUOTE] = ACTIONS(1586),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1586),
    [anon_sym_AMP] = ACTIONS(1588),
  },
  [319] = {
    [sym__expression] = STATE(833),
    [sym_binary_expression] = STATE(833),
    [sym_unary_expression] = STATE(833),
    [sym_postfix_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_concatenation] = STATE(833),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__literal_repeat1] = STATE(53),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_DOLLAR] = ACTIONS(77),
    [sym__special_character] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [320] = {
    [sym__expression] = STATE(833),
    [sym_binary_expression] = STATE(833),
    [sym_unary_expression] = STATE(833),
    [sym_postfix_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_concatenation] = STATE(833),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__literal_repeat1] = STATE(53),
    [sym_regex] = ACTIONS(1590),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_DOLLAR] = ACTIONS(77),
    [sym__special_character] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [321] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1592),
    [anon_sym_AMP_AMP] = ACTIONS(1592),
    [anon_sym_PIPE_PIPE] = ACTIONS(1592),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1592),
    [anon_sym_EQ_TILDE] = ACTIONS(1592),
    [anon_sym_EQ_EQ] = ACTIONS(1592),
    [anon_sym_EQ] = ACTIONS(1594),
    [anon_sym_PLUS_EQ] = ACTIONS(1592),
    [anon_sym_LT] = ACTIONS(1594),
    [anon_sym_GT] = ACTIONS(1594),
    [anon_sym_BANG_EQ] = ACTIONS(1592),
    [anon_sym_PLUS] = ACTIONS(1594),
    [anon_sym_DASH] = ACTIONS(1594),
    [anon_sym_DASH_EQ] = ACTIONS(1592),
    [anon_sym_LT_EQ] = ACTIONS(1592),
    [anon_sym_GT_EQ] = ACTIONS(1592),
    [anon_sym_PLUS_PLUS] = ACTIONS(1592),
    [anon_sym_DASH_DASH] = ACTIONS(1592),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1592),
  },
  [322] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_EQ_TILDE] = ACTIONS(335),
    [anon_sym_EQ_EQ] = ACTIONS(335),
    [anon_sym_EQ] = ACTIONS(339),
    [anon_sym_PLUS_EQ] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(335),
    [anon_sym_PLUS] = ACTIONS(339),
    [anon_sym_DASH] = ACTIONS(339),
    [anon_sym_DASH_EQ] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(335),
    [anon_sym_GT_EQ] = ACTIONS(335),
    [anon_sym_PLUS_PLUS] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(335),
    [sym__special_character] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(335),
  },
  [323] = {
    [aux_sym__literal_repeat1] = STATE(323),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_EQ_TILDE] = ACTIONS(1373),
    [anon_sym_EQ_EQ] = ACTIONS(1373),
    [anon_sym_EQ] = ACTIONS(1375),
    [anon_sym_PLUS_EQ] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_BANG_EQ] = ACTIONS(1373),
    [anon_sym_PLUS] = ACTIONS(1375),
    [anon_sym_DASH] = ACTIONS(1375),
    [anon_sym_DASH_EQ] = ACTIONS(1373),
    [anon_sym_LT_EQ] = ACTIONS(1373),
    [anon_sym_GT_EQ] = ACTIONS(1373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1373),
    [anon_sym_DASH_DASH] = ACTIONS(1373),
    [sym__special_character] = ACTIONS(1596),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1373),
  },
  [324] = {
    [sym_concatenation] = STATE(835),
    [sym_string] = STATE(840),
    [sym_array] = STATE(835),
    [sym_simple_expansion] = STATE(840),
    [sym_string_expansion] = STATE(840),
    [sym_expansion] = STATE(840),
    [sym_command_substitution] = STATE(840),
    [sym_process_substitution] = STATE(840),
    [aux_sym__literal_repeat1] = STATE(845),
    [sym__empty_value] = ACTIONS(1599),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_DOLLAR] = ACTIONS(1603),
    [sym__special_character] = ACTIONS(1605),
    [anon_sym_DQUOTE] = ACTIONS(1607),
    [sym_raw_string] = ACTIONS(1609),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1611),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1613),
    [anon_sym_BQUOTE] = ACTIONS(1615),
    [anon_sym_LT_LPAREN] = ACTIONS(1617),
    [anon_sym_GT_LPAREN] = ACTIONS(1617),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1609),
  },
  [325] = {
    [sym__expression] = STATE(847),
    [sym_binary_expression] = STATE(847),
    [sym_unary_expression] = STATE(847),
    [sym_postfix_expression] = STATE(847),
    [sym_parenthesized_expression] = STATE(847),
    [sym_concatenation] = STATE(847),
    [sym_string] = STATE(280),
    [sym_simple_expansion] = STATE(280),
    [sym_string_expansion] = STATE(280),
    [sym_expansion] = STATE(280),
    [sym_command_substitution] = STATE(280),
    [sym_process_substitution] = STATE(280),
    [aux_sym__literal_repeat1] = STATE(286),
    [anon_sym_SEMI] = ACTIONS(1619),
    [anon_sym_SEMI_SEMI] = ACTIONS(1621),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(475),
    [anon_sym_DOLLAR] = ACTIONS(477),
    [sym__special_character] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(481),
    [sym_raw_string] = ACTIONS(483),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(485),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(487),
    [anon_sym_BQUOTE] = ACTIONS(489),
    [anon_sym_LT_LPAREN] = ACTIONS(491),
    [anon_sym_GT_LPAREN] = ACTIONS(491),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(493),
    [sym_test_operator] = ACTIONS(495),
    [anon_sym_LF] = ACTIONS(1621),
    [anon_sym_AMP] = ACTIONS(1621),
  },
  [326] = {
    [anon_sym_in] = ACTIONS(1623),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_SEMI_SEMI] = ACTIONS(1627),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1627),
    [anon_sym_AMP] = ACTIONS(1627),
  },
  [327] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1629),
    [anon_sym_AMP_AMP] = ACTIONS(557),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(559),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_PLUS_EQ] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DASH_EQ] = ACTIONS(557),
    [anon_sym_LT_EQ] = ACTIONS(557),
    [anon_sym_GT_EQ] = ACTIONS(557),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(557),
  },
  [328] = {
    [sym_do_group] = STATE(852),
    [anon_sym_do] = ACTIONS(1631),
    [sym_comment] = ACTIONS(57),
  },
  [329] = {
    [anon_sym_then] = ACTIONS(1633),
    [sym_comment] = ACTIONS(57),
  },
  [330] = {
    [aux_sym_concatenation_repeat1] = STATE(401),
    [sym__concat] = ACTIONS(695),
    [anon_sym_in] = ACTIONS(1635),
    [anon_sym_SEMI] = ACTIONS(1637),
    [anon_sym_SEMI_SEMI] = ACTIONS(1639),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1639),
    [anon_sym_AMP] = ACTIONS(1639),
  },
  [331] = {
    [anon_sym_in] = ACTIONS(1635),
    [anon_sym_SEMI] = ACTIONS(1637),
    [anon_sym_SEMI_SEMI] = ACTIONS(1639),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1639),
    [anon_sym_AMP] = ACTIONS(1639),
  },
  [332] = {
    [aux_sym__literal_repeat1] = STATE(418),
    [anon_sym_in] = ACTIONS(1641),
    [anon_sym_SEMI] = ACTIONS(1643),
    [anon_sym_SEMI_SEMI] = ACTIONS(1645),
    [sym__special_character] = ACTIONS(723),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1645),
    [anon_sym_AMP] = ACTIONS(1645),
  },
  [333] = {
    [sym_compound_statement] = STATE(859),
    [anon_sym_LPAREN] = ACTIONS(1647),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_comment] = ACTIONS(57),
  },
  [334] = {
    [anon_sym_RPAREN] = ACTIONS(1649),
    [sym_comment] = ACTIONS(57),
  },
  [335] = {
    [sym_file_descriptor] = ACTIONS(783),
    [anon_sym_SEMI] = ACTIONS(785),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_SEMI_SEMI] = ACTIONS(783),
    [anon_sym_PIPE_AMP] = ACTIONS(783),
    [anon_sym_AMP_AMP] = ACTIONS(783),
    [anon_sym_PIPE_PIPE] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(785),
    [anon_sym_GT] = ACTIONS(785),
    [anon_sym_GT_GT] = ACTIONS(783),
    [anon_sym_AMP_GT] = ACTIONS(785),
    [anon_sym_AMP_GT_GT] = ACTIONS(783),
    [anon_sym_LT_AMP] = ACTIONS(783),
    [anon_sym_GT_AMP] = ACTIONS(783),
    [anon_sym_LT_LT] = ACTIONS(785),
    [anon_sym_LT_LT_DASH] = ACTIONS(783),
    [anon_sym_LT_LT_LT] = ACTIONS(783),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(783),
    [anon_sym_AMP] = ACTIONS(785),
  },
  [336] = {
    [anon_sym_RBRACE] = ACTIONS(1651),
    [sym_comment] = ACTIONS(57),
  },
  [337] = {
    [sym_file_descriptor] = ACTIONS(895),
    [anon_sym_SEMI] = ACTIONS(897),
    [anon_sym_PIPE] = ACTIONS(897),
    [anon_sym_SEMI_SEMI] = ACTIONS(895),
    [anon_sym_PIPE_AMP] = ACTIONS(895),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(895),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(895),
    [anon_sym_LT_AMP] = ACTIONS(895),
    [anon_sym_GT_AMP] = ACTIONS(895),
    [anon_sym_LT_LT] = ACTIONS(897),
    [anon_sym_LT_LT_DASH] = ACTIONS(895),
    [anon_sym_LT_LT_LT] = ACTIONS(895),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(895),
    [anon_sym_AMP] = ACTIONS(897),
  },
  [338] = {
    [anon_sym_AMP_AMP] = ACTIONS(923),
    [anon_sym_PIPE_PIPE] = ACTIONS(923),
    [anon_sym_RBRACK] = ACTIONS(1629),
    [anon_sym_EQ_TILDE] = ACTIONS(925),
    [anon_sym_EQ_EQ] = ACTIONS(925),
    [anon_sym_EQ] = ACTIONS(927),
    [anon_sym_PLUS_EQ] = ACTIONS(923),
    [anon_sym_LT] = ACTIONS(927),
    [anon_sym_GT] = ACTIONS(927),
    [anon_sym_BANG_EQ] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(927),
    [anon_sym_DASH_EQ] = ACTIONS(923),
    [anon_sym_LT_EQ] = ACTIONS(923),
    [anon_sym_GT_EQ] = ACTIONS(923),
    [anon_sym_PLUS_PLUS] = ACTIONS(929),
    [anon_sym_DASH_DASH] = ACTIONS(929),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(923),
  },
  [339] = {
    [anon_sym_AMP_AMP] = ACTIONS(933),
    [anon_sym_PIPE_PIPE] = ACTIONS(933),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1629),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(935),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_PLUS_EQ] = ACTIONS(933),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(933),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_DASH] = ACTIONS(937),
    [anon_sym_DASH_EQ] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(933),
    [anon_sym_GT_EQ] = ACTIONS(933),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(933),
  },
  [340] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(1653),
    [anon_sym_PLUS_EQ] = ACTIONS(1653),
    [sym_comment] = ACTIONS(57),
  },
  [341] = {
    [sym_string] = STATE(864),
    [anon_sym_DASH] = ACTIONS(1655),
    [anon_sym_DOLLAR] = ACTIONS(1655),
    [anon_sym_DQUOTE] = ACTIONS(589),
    [sym_raw_string] = ACTIONS(1657),
    [anon_sym_POUND] = ACTIONS(1655),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1659),
    [anon_sym_STAR] = ACTIONS(1661),
    [anon_sym_AT] = ACTIONS(1661),
    [anon_sym_QMARK] = ACTIONS(1661),
    [anon_sym_0] = ACTIONS(1659),
    [anon_sym__] = ACTIONS(1659),
  },
  [342] = {
    [aux_sym_concatenation_repeat1] = STATE(867),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(1663),
    [sym_variable_name] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(339),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [343] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(870),
    [anon_sym_DOLLAR] = ACTIONS(1665),
    [anon_sym_DQUOTE] = ACTIONS(1667),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [344] = {
    [aux_sym_concatenation_repeat1] = STATE(867),
    [sym_file_descriptor] = ACTIONS(957),
    [sym__concat] = ACTIONS(1663),
    [sym_variable_name] = ACTIONS(957),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_SEMI_SEMI] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_LT] = ACTIONS(959),
    [anon_sym_GT] = ACTIONS(959),
    [anon_sym_GT_GT] = ACTIONS(957),
    [anon_sym_AMP_GT] = ACTIONS(959),
    [anon_sym_AMP_GT_GT] = ACTIONS(957),
    [anon_sym_LT_AMP] = ACTIONS(957),
    [anon_sym_GT_AMP] = ACTIONS(957),
    [anon_sym_LT_LT] = ACTIONS(959),
    [anon_sym_LT_LT_DASH] = ACTIONS(957),
    [anon_sym_LT_LT_LT] = ACTIONS(957),
    [anon_sym_DOLLAR] = ACTIONS(959),
    [sym__special_character] = ACTIONS(957),
    [anon_sym_DQUOTE] = ACTIONS(957),
    [sym_raw_string] = ACTIONS(957),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(957),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(957),
    [anon_sym_BQUOTE] = ACTIONS(957),
    [anon_sym_LT_LPAREN] = ACTIONS(957),
    [anon_sym_GT_LPAREN] = ACTIONS(957),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(959),
    [sym_word] = ACTIONS(959),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
  },
  [345] = {
    [sym_subscript] = STATE(874),
    [sym_variable_name] = ACTIONS(1669),
    [anon_sym_BANG] = ACTIONS(1671),
    [anon_sym_DASH] = ACTIONS(1673),
    [anon_sym_DOLLAR] = ACTIONS(1673),
    [anon_sym_POUND] = ACTIONS(1671),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1675),
    [anon_sym_STAR] = ACTIONS(1677),
    [anon_sym_AT] = ACTIONS(1677),
    [anon_sym_QMARK] = ACTIONS(1677),
    [anon_sym_0] = ACTIONS(1675),
    [anon_sym__] = ACTIONS(1675),
  },
  [346] = {
    [sym__statements] = STATE(875),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(876),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [347] = {
    [sym__statements] = STATE(877),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [348] = {
    [sym__statements] = STATE(878),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [349] = {
    [anon_sym_EQ] = ACTIONS(1653),
    [anon_sym_PLUS_EQ] = ACTIONS(1653),
    [sym_comment] = ACTIONS(57),
  },
  [350] = {
    [sym_variable_assignment] = STATE(879),
    [sym_subscript] = STATE(349),
    [sym_concatenation] = STATE(879),
    [sym_string] = STATE(344),
    [sym_simple_expansion] = STATE(344),
    [sym_string_expansion] = STATE(344),
    [sym_expansion] = STATE(344),
    [sym_command_substitution] = STATE(344),
    [sym_process_substitution] = STATE(344),
    [aux_sym_declaration_command_repeat1] = STATE(879),
    [aux_sym__literal_repeat1] = STATE(351),
    [sym_file_descriptor] = ACTIONS(971),
    [sym_variable_name] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_SEMI_SEMI] = ACTIONS(971),
    [anon_sym_PIPE_AMP] = ACTIONS(971),
    [anon_sym_AMP_AMP] = ACTIONS(971),
    [anon_sym_PIPE_PIPE] = ACTIONS(971),
    [anon_sym_LT] = ACTIONS(973),
    [anon_sym_GT] = ACTIONS(973),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_AMP_GT] = ACTIONS(973),
    [anon_sym_AMP_GT_GT] = ACTIONS(971),
    [anon_sym_LT_AMP] = ACTIONS(971),
    [anon_sym_GT_AMP] = ACTIONS(971),
    [anon_sym_LT_LT] = ACTIONS(973),
    [anon_sym_LT_LT_DASH] = ACTIONS(971),
    [anon_sym_LT_LT_LT] = ACTIONS(971),
    [anon_sym_DOLLAR] = ACTIONS(585),
    [sym__special_character] = ACTIONS(587),
    [anon_sym_DQUOTE] = ACTIONS(589),
    [sym_raw_string] = ACTIONS(591),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(593),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(595),
    [anon_sym_BQUOTE] = ACTIONS(597),
    [anon_sym_LT_LPAREN] = ACTIONS(599),
    [anon_sym_GT_LPAREN] = ACTIONS(599),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1679),
    [sym_word] = ACTIONS(603),
    [anon_sym_LF] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(973),
  },
  [351] = {
    [aux_sym__literal_repeat1] = STATE(881),
    [sym_file_descriptor] = ACTIONS(977),
    [sym_variable_name] = ACTIONS(977),
    [anon_sym_SEMI] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(979),
    [anon_sym_SEMI_SEMI] = ACTIONS(977),
    [anon_sym_PIPE_AMP] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(977),
    [anon_sym_AMP_GT] = ACTIONS(979),
    [anon_sym_AMP_GT_GT] = ACTIONS(977),
    [anon_sym_LT_AMP] = ACTIONS(977),
    [anon_sym_GT_AMP] = ACTIONS(977),
    [anon_sym_LT_LT] = ACTIONS(979),
    [anon_sym_LT_LT_DASH] = ACTIONS(977),
    [anon_sym_LT_LT_LT] = ACTIONS(977),
    [anon_sym_DOLLAR] = ACTIONS(979),
    [sym__special_character] = ACTIONS(1681),
    [anon_sym_DQUOTE] = ACTIONS(977),
    [sym_raw_string] = ACTIONS(977),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(977),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(977),
    [anon_sym_BQUOTE] = ACTIONS(977),
    [anon_sym_LT_LPAREN] = ACTIONS(977),
    [anon_sym_GT_LPAREN] = ACTIONS(977),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(979),
    [sym_word] = ACTIONS(979),
    [anon_sym_LF] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
  },
  [352] = {
    [sym_string] = STATE(883),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_DOLLAR] = ACTIONS(1683),
    [anon_sym_DQUOTE] = ACTIONS(609),
    [sym_raw_string] = ACTIONS(1685),
    [anon_sym_POUND] = ACTIONS(1683),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1687),
    [anon_sym_STAR] = ACTIONS(1689),
    [anon_sym_AT] = ACTIONS(1689),
    [anon_sym_QMARK] = ACTIONS(1689),
    [anon_sym_0] = ACTIONS(1687),
    [anon_sym__] = ACTIONS(1687),
  },
  [353] = {
    [aux_sym_concatenation_repeat1] = STATE(886),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(1691),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(339),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [354] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(889),
    [anon_sym_DOLLAR] = ACTIONS(1693),
    [anon_sym_DQUOTE] = ACTIONS(1695),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [355] = {
    [aux_sym_concatenation_repeat1] = STATE(886),
    [sym_file_descriptor] = ACTIONS(997),
    [sym__concat] = ACTIONS(1691),
    [anon_sym_SEMI] = ACTIONS(999),
    [anon_sym_PIPE] = ACTIONS(999),
    [anon_sym_SEMI_SEMI] = ACTIONS(997),
    [anon_sym_PIPE_AMP] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_LT] = ACTIONS(999),
    [anon_sym_GT] = ACTIONS(999),
    [anon_sym_GT_GT] = ACTIONS(997),
    [anon_sym_AMP_GT] = ACTIONS(999),
    [anon_sym_AMP_GT_GT] = ACTIONS(997),
    [anon_sym_LT_AMP] = ACTIONS(997),
    [anon_sym_GT_AMP] = ACTIONS(997),
    [anon_sym_LT_LT] = ACTIONS(999),
    [anon_sym_LT_LT_DASH] = ACTIONS(997),
    [anon_sym_LT_LT_LT] = ACTIONS(997),
    [anon_sym_DOLLAR] = ACTIONS(999),
    [sym__special_character] = ACTIONS(997),
    [anon_sym_DQUOTE] = ACTIONS(997),
    [sym_raw_string] = ACTIONS(997),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(997),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(997),
    [anon_sym_BQUOTE] = ACTIONS(997),
    [anon_sym_LT_LPAREN] = ACTIONS(997),
    [anon_sym_GT_LPAREN] = ACTIONS(997),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(999),
    [sym_word] = ACTIONS(999),
    [anon_sym_LF] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(999),
  },
  [356] = {
    [sym_subscript] = STATE(893),
    [sym_variable_name] = ACTIONS(1697),
    [anon_sym_BANG] = ACTIONS(1699),
    [anon_sym_DASH] = ACTIONS(1701),
    [anon_sym_DOLLAR] = ACTIONS(1701),
    [anon_sym_POUND] = ACTIONS(1699),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1705),
    [anon_sym_AT] = ACTIONS(1705),
    [anon_sym_QMARK] = ACTIONS(1705),
    [anon_sym_0] = ACTIONS(1703),
    [anon_sym__] = ACTIONS(1703),
  },
  [357] = {
    [sym__statements] = STATE(894),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(895),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [358] = {
    [sym__statements] = STATE(896),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [359] = {
    [sym__statements] = STATE(897),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [360] = {
    [sym_concatenation] = STATE(898),
    [sym_string] = STATE(355),
    [sym_simple_expansion] = STATE(355),
    [sym_string_expansion] = STATE(355),
    [sym_expansion] = STATE(355),
    [sym_command_substitution] = STATE(355),
    [sym_process_substitution] = STATE(355),
    [aux_sym_unset_command_repeat1] = STATE(898),
    [aux_sym__literal_repeat1] = STATE(361),
    [sym_file_descriptor] = ACTIONS(1011),
    [anon_sym_SEMI] = ACTIONS(1013),
    [anon_sym_PIPE] = ACTIONS(1013),
    [anon_sym_SEMI_SEMI] = ACTIONS(1011),
    [anon_sym_PIPE_AMP] = ACTIONS(1011),
    [anon_sym_AMP_AMP] = ACTIONS(1011),
    [anon_sym_PIPE_PIPE] = ACTIONS(1011),
    [anon_sym_LT] = ACTIONS(1013),
    [anon_sym_GT] = ACTIONS(1013),
    [anon_sym_GT_GT] = ACTIONS(1011),
    [anon_sym_AMP_GT] = ACTIONS(1013),
    [anon_sym_AMP_GT_GT] = ACTIONS(1011),
    [anon_sym_LT_AMP] = ACTIONS(1011),
    [anon_sym_GT_AMP] = ACTIONS(1011),
    [anon_sym_LT_LT] = ACTIONS(1013),
    [anon_sym_LT_LT_DASH] = ACTIONS(1011),
    [anon_sym_LT_LT_LT] = ACTIONS(1011),
    [anon_sym_DOLLAR] = ACTIONS(605),
    [sym__special_character] = ACTIONS(607),
    [anon_sym_DQUOTE] = ACTIONS(609),
    [sym_raw_string] = ACTIONS(611),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(613),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(615),
    [anon_sym_BQUOTE] = ACTIONS(617),
    [anon_sym_LT_LPAREN] = ACTIONS(619),
    [anon_sym_GT_LPAREN] = ACTIONS(619),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1707),
    [sym_word] = ACTIONS(623),
    [anon_sym_LF] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(1013),
  },
  [361] = {
    [aux_sym__literal_repeat1] = STATE(900),
    [sym_file_descriptor] = ACTIONS(1017),
    [anon_sym_SEMI] = ACTIONS(1019),
    [anon_sym_PIPE] = ACTIONS(1019),
    [anon_sym_SEMI_SEMI] = ACTIONS(1017),
    [anon_sym_PIPE_AMP] = ACTIONS(1017),
    [anon_sym_AMP_AMP] = ACTIONS(1017),
    [anon_sym_PIPE_PIPE] = ACTIONS(1017),
    [anon_sym_LT] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(1019),
    [anon_sym_GT_GT] = ACTIONS(1017),
    [anon_sym_AMP_GT] = ACTIONS(1019),
    [anon_sym_AMP_GT_GT] = ACTIONS(1017),
    [anon_sym_LT_AMP] = ACTIONS(1017),
    [anon_sym_GT_AMP] = ACTIONS(1017),
    [anon_sym_LT_LT] = ACTIONS(1019),
    [anon_sym_LT_LT_DASH] = ACTIONS(1017),
    [anon_sym_LT_LT_LT] = ACTIONS(1017),
    [anon_sym_DOLLAR] = ACTIONS(1019),
    [sym__special_character] = ACTIONS(1709),
    [anon_sym_DQUOTE] = ACTIONS(1017),
    [sym_raw_string] = ACTIONS(1017),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1017),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1017),
    [anon_sym_BQUOTE] = ACTIONS(1017),
    [anon_sym_LT_LPAREN] = ACTIONS(1017),
    [anon_sym_GT_LPAREN] = ACTIONS(1017),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1019),
    [sym_word] = ACTIONS(1019),
    [anon_sym_LF] = ACTIONS(1017),
    [anon_sym_AMP] = ACTIONS(1019),
  },
  [362] = {
    [sym_file_descriptor] = ACTIONS(1057),
    [sym__concat] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_PIPE_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_EQ_TILDE] = ACTIONS(1059),
    [anon_sym_EQ_EQ] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_AMP] = ACTIONS(1057),
    [anon_sym_GT_AMP] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_LT] = ACTIONS(1057),
    [anon_sym_DOLLAR] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [sym_raw_string] = ACTIONS(1057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1057),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1057),
    [anon_sym_BQUOTE] = ACTIONS(1057),
    [anon_sym_LT_LPAREN] = ACTIONS(1057),
    [anon_sym_GT_LPAREN] = ACTIONS(1057),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [363] = {
    [sym_file_descriptor] = ACTIONS(1061),
    [sym__concat] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(1063),
    [anon_sym_PIPE] = ACTIONS(1063),
    [anon_sym_SEMI_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE_AMP] = ACTIONS(1061),
    [anon_sym_AMP_AMP] = ACTIONS(1061),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_EQ_TILDE] = ACTIONS(1063),
    [anon_sym_EQ_EQ] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1063),
    [anon_sym_GT_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT_GT] = ACTIONS(1061),
    [anon_sym_LT_AMP] = ACTIONS(1061),
    [anon_sym_GT_AMP] = ACTIONS(1061),
    [anon_sym_LT_LT] = ACTIONS(1063),
    [anon_sym_LT_LT_DASH] = ACTIONS(1061),
    [anon_sym_LT_LT_LT] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1061),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1061),
    [anon_sym_LT_LPAREN] = ACTIONS(1061),
    [anon_sym_GT_LPAREN] = ACTIONS(1061),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1063),
    [anon_sym_LF] = ACTIONS(1061),
    [anon_sym_AMP] = ACTIONS(1063),
  },
  [364] = {
    [sym_file_descriptor] = ACTIONS(1065),
    [sym__concat] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1067),
    [anon_sym_SEMI_SEMI] = ACTIONS(1065),
    [anon_sym_PIPE_AMP] = ACTIONS(1065),
    [anon_sym_AMP_AMP] = ACTIONS(1065),
    [anon_sym_PIPE_PIPE] = ACTIONS(1065),
    [anon_sym_EQ_TILDE] = ACTIONS(1067),
    [anon_sym_EQ_EQ] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_GT] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT] = ACTIONS(1067),
    [anon_sym_AMP_GT_GT] = ACTIONS(1065),
    [anon_sym_LT_AMP] = ACTIONS(1065),
    [anon_sym_GT_AMP] = ACTIONS(1065),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_LT_LT_DASH] = ACTIONS(1065),
    [anon_sym_LT_LT_LT] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1067),
    [sym__special_character] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LT_LPAREN] = ACTIONS(1065),
    [anon_sym_GT_LPAREN] = ACTIONS(1065),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1067),
    [anon_sym_LF] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1067),
  },
  [365] = {
    [sym_string] = STATE(901),
    [sym_simple_expansion] = STATE(901),
    [sym_string_expansion] = STATE(901),
    [sym_expansion] = STATE(901),
    [sym_command_substitution] = STATE(901),
    [sym_process_substitution] = STATE(901),
    [anon_sym_DOLLAR] = ACTIONS(125),
    [sym__special_character] = ACTIONS(1711),
    [anon_sym_DQUOTE] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(1711),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1711),
  },
  [366] = {
    [aux_sym_concatenation_repeat1] = STATE(903),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(1713),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_EQ_TILDE] = ACTIONS(1075),
    [anon_sym_EQ_EQ] = ACTIONS(1075),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [sym__special_character] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1075),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1075),
  },
  [367] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(1715),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [368] = {
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(1089),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1089),
    [anon_sym_PIPE_AMP] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_AMP] = ACTIONS(1089),
    [anon_sym_GT_AMP] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1089),
    [anon_sym_LT_LT_LT] = ACTIONS(1089),
    [anon_sym_DOLLAR] = ACTIONS(1091),
    [sym__special_character] = ACTIONS(1089),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1089),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1089),
    [anon_sym_GT_LPAREN] = ACTIONS(1089),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [369] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(627),
    [anon_sym_DOLLAR] = ACTIONS(1717),
    [anon_sym_DQUOTE] = ACTIONS(1715),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [370] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(1719),
    [sym_comment] = ACTIONS(57),
  },
  [371] = {
    [sym_subscript] = STATE(909),
    [sym_variable_name] = ACTIONS(1721),
    [anon_sym_DASH] = ACTIONS(1723),
    [anon_sym_DOLLAR] = ACTIONS(1723),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1725),
    [anon_sym_STAR] = ACTIONS(1727),
    [anon_sym_AT] = ACTIONS(1727),
    [anon_sym_QMARK] = ACTIONS(1727),
    [anon_sym_0] = ACTIONS(1725),
    [anon_sym__] = ACTIONS(1725),
  },
  [372] = {
    [sym_concatenation] = STATE(912),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(912),
    [anon_sym_RBRACE] = ACTIONS(1729),
    [anon_sym_EQ] = ACTIONS(1731),
    [anon_sym_DASH] = ACTIONS(1731),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(1733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(1735),
    [anon_sym_COLON] = ACTIONS(1731),
    [anon_sym_COLON_QMARK] = ACTIONS(1731),
    [anon_sym_COLON_DASH] = ACTIONS(1731),
    [anon_sym_PERCENT] = ACTIONS(1731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [373] = {
    [sym_concatenation] = STATE(915),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(915),
    [anon_sym_RBRACE] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(1739),
    [anon_sym_DASH] = ACTIONS(1739),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(1741),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(1743),
    [anon_sym_COLON] = ACTIONS(1739),
    [anon_sym_COLON_QMARK] = ACTIONS(1739),
    [anon_sym_COLON_DASH] = ACTIONS(1739),
    [anon_sym_PERCENT] = ACTIONS(1739),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [374] = {
    [anon_sym_RPAREN] = ACTIONS(1745),
    [sym_comment] = ACTIONS(57),
  },
  [375] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(1745),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [376] = {
    [anon_sym_BQUOTE] = ACTIONS(1745),
    [sym_comment] = ACTIONS(57),
  },
  [377] = {
    [anon_sym_RPAREN] = ACTIONS(1747),
    [sym_comment] = ACTIONS(57),
  },
  [378] = {
    [anon_sym_RPAREN] = ACTIONS(1749),
    [sym_comment] = ACTIONS(57),
  },
  [379] = {
    [sym__statements] = STATE(933),
    [sym_redirected_statement] = STATE(934),
    [sym_for_statement] = STATE(934),
    [sym_c_style_for_statement] = STATE(934),
    [sym_while_statement] = STATE(934),
    [sym_if_statement] = STATE(934),
    [sym_case_statement] = STATE(934),
    [sym_function_definition] = STATE(934),
    [sym_compound_statement] = STATE(934),
    [sym_subshell] = STATE(934),
    [sym_pipeline] = STATE(934),
    [sym_list] = STATE(934),
    [sym_negated_command] = STATE(934),
    [sym_test_command] = STATE(934),
    [sym_declaration_command] = STATE(934),
    [sym_unset_command] = STATE(934),
    [sym_command] = STATE(934),
    [sym_command_name] = STATE(935),
    [sym_variable_assignment] = STATE(936),
    [sym_subscript] = STATE(937),
    [sym_file_redirect] = STATE(940),
    [sym_concatenation] = STATE(938),
    [sym_string] = STATE(927),
    [sym_simple_expansion] = STATE(927),
    [sym_string_expansion] = STATE(927),
    [sym_expansion] = STATE(927),
    [sym_command_substitution] = STATE(927),
    [sym_process_substitution] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(939),
    [aux_sym_command_repeat1] = STATE(940),
    [aux_sym__literal_repeat1] = STATE(941),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(1751),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_done] = ACTIONS(1753),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1755),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(1757),
    [anon_sym_typeset] = ACTIONS(1757),
    [anon_sym_export] = ACTIONS(1757),
    [anon_sym_readonly] = ACTIONS(1757),
    [anon_sym_local] = ACTIONS(1757),
    [anon_sym_unset] = ACTIONS(1759),
    [anon_sym_unsetenv] = ACTIONS(1759),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(1761),
    [sym__special_character] = ACTIONS(1763),
    [anon_sym_DQUOTE] = ACTIONS(1765),
    [sym_raw_string] = ACTIONS(1767),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1769),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1771),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [anon_sym_LT_LPAREN] = ACTIONS(1775),
    [anon_sym_GT_LPAREN] = ACTIONS(1775),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1777),
  },
  [380] = {
    [sym__simple_heredoc_body] = ACTIONS(1779),
    [sym__heredoc_body_beginning] = ACTIONS(1779),
    [sym_file_descriptor] = ACTIONS(1779),
    [ts_builtin_sym_end] = ACTIONS(1779),
    [anon_sym_SEMI] = ACTIONS(1781),
    [anon_sym_done] = ACTIONS(1779),
    [anon_sym_fi] = ACTIONS(1779),
    [anon_sym_elif] = ACTIONS(1779),
    [anon_sym_else] = ACTIONS(1779),
    [anon_sym_esac] = ACTIONS(1779),
    [anon_sym_PIPE] = ACTIONS(1781),
    [anon_sym_RPAREN] = ACTIONS(1779),
    [anon_sym_SEMI_SEMI] = ACTIONS(1779),
    [anon_sym_PIPE_AMP] = ACTIONS(1779),
    [anon_sym_AMP_AMP] = ACTIONS(1779),
    [anon_sym_PIPE_PIPE] = ACTIONS(1779),
    [anon_sym_LT] = ACTIONS(1781),
    [anon_sym_GT] = ACTIONS(1781),
    [anon_sym_GT_GT] = ACTIONS(1779),
    [anon_sym_AMP_GT] = ACTIONS(1781),
    [anon_sym_AMP_GT_GT] = ACTIONS(1779),
    [anon_sym_LT_AMP] = ACTIONS(1779),
    [anon_sym_GT_AMP] = ACTIONS(1779),
    [anon_sym_LT_LT] = ACTIONS(1781),
    [anon_sym_LT_LT_DASH] = ACTIONS(1779),
    [anon_sym_LT_LT_LT] = ACTIONS(1779),
    [anon_sym_BQUOTE] = ACTIONS(1779),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1779),
    [anon_sym_AMP] = ACTIONS(1781),
  },
  [381] = {
    [anon_sym_LT] = ACTIONS(1783),
    [anon_sym_GT] = ACTIONS(1783),
    [anon_sym_GT_GT] = ACTIONS(1785),
    [anon_sym_AMP_GT] = ACTIONS(1783),
    [anon_sym_AMP_GT_GT] = ACTIONS(1785),
    [anon_sym_LT_AMP] = ACTIONS(1785),
    [anon_sym_GT_AMP] = ACTIONS(1785),
    [sym_comment] = ACTIONS(57),
  },
  [382] = {
    [anon_sym_do] = ACTIONS(1787),
    [anon_sym_then] = ACTIONS(1787),
    [sym_comment] = ACTIONS(57),
  },
  [383] = {
    [sym_redirected_statement] = STATE(943),
    [sym_for_statement] = STATE(943),
    [sym_c_style_for_statement] = STATE(943),
    [sym_while_statement] = STATE(943),
    [sym_if_statement] = STATE(943),
    [sym_case_statement] = STATE(943),
    [sym_function_definition] = STATE(943),
    [sym_compound_statement] = STATE(943),
    [sym_subshell] = STATE(943),
    [sym_pipeline] = STATE(943),
    [sym_list] = STATE(943),
    [sym_negated_command] = STATE(943),
    [sym_test_command] = STATE(943),
    [sym_declaration_command] = STATE(943),
    [sym_unset_command] = STATE(943),
    [sym_command] = STATE(943),
    [sym_command_name] = STATE(79),
    [sym_variable_assignment] = STATE(944),
    [sym_subscript] = STATE(81),
    [sym_file_redirect] = STATE(83),
    [sym_concatenation] = STATE(82),
    [sym_string] = STATE(71),
    [sym_simple_expansion] = STATE(71),
    [sym_string_expansion] = STATE(71),
    [sym_expansion] = STATE(71),
    [sym_command_substitution] = STATE(71),
    [sym_process_substitution] = STATE(71),
    [aux_sym_command_repeat1] = STATE(83),
    [aux_sym__literal_repeat1] = STATE(84),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_case] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(125),
    [sym__special_character] = ACTIONS(127),
    [anon_sym_DQUOTE] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(131),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [384] = {
    [sym_redirected_statement] = STATE(945),
    [sym_for_statement] = STATE(945),
    [sym_c_style_for_statement] = STATE(945),
    [sym_while_statement] = STATE(945),
    [sym_if_statement] = STATE(945),
    [sym_case_statement] = STATE(945),
    [sym_function_definition] = STATE(945),
    [sym_compound_statement] = STATE(945),
    [sym_subshell] = STATE(945),
    [sym_pipeline] = STATE(945),
    [sym_list] = STATE(945),
    [sym_negated_command] = STATE(945),
    [sym_test_command] = STATE(945),
    [sym_declaration_command] = STATE(945),
    [sym_unset_command] = STATE(945),
    [sym_command] = STATE(945),
    [sym_command_name] = STATE(79),
    [sym_variable_assignment] = STATE(946),
    [sym_subscript] = STATE(81),
    [sym_file_redirect] = STATE(83),
    [sym_concatenation] = STATE(82),
    [sym_string] = STATE(71),
    [sym_simple_expansion] = STATE(71),
    [sym_string_expansion] = STATE(71),
    [sym_expansion] = STATE(71),
    [sym_command_substitution] = STATE(71),
    [sym_process_substitution] = STATE(71),
    [aux_sym_command_repeat1] = STATE(83),
    [aux_sym__literal_repeat1] = STATE(84),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_case] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(125),
    [sym__special_character] = ACTIONS(127),
    [anon_sym_DQUOTE] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(131),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [385] = {
    [sym_concatenation] = STATE(949),
    [sym_string] = STATE(948),
    [sym_simple_expansion] = STATE(948),
    [sym_string_expansion] = STATE(948),
    [sym_expansion] = STATE(948),
    [sym_command_substitution] = STATE(948),
    [sym_process_substitution] = STATE(948),
    [aux_sym__literal_repeat1] = STATE(950),
    [anon_sym_DOLLAR] = ACTIONS(125),
    [sym__special_character] = ACTIONS(1789),
    [anon_sym_DQUOTE] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(1791),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1791),
  },
  [386] = {
    [sym_heredoc_start] = ACTIONS(1793),
    [sym_comment] = ACTIONS(57),
  },
  [387] = {
    [sym_concatenation] = STATE(953),
    [sym_string] = STATE(952),
    [sym_simple_expansion] = STATE(952),
    [sym_string_expansion] = STATE(952),
    [sym_expansion] = STATE(952),
    [sym_command_substitution] = STATE(952),
    [sym_process_substitution] = STATE(952),
    [aux_sym__literal_repeat1] = STATE(954),
    [anon_sym_DOLLAR] = ACTIONS(125),
    [sym__special_character] = ACTIONS(1789),
    [anon_sym_DQUOTE] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(1795),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1795),
  },
  [388] = {
    [sym_file_redirect] = STATE(955),
    [sym_heredoc_redirect] = STATE(955),
    [sym_herestring_redirect] = STATE(955),
    [aux_sym_redirected_statement_repeat1] = STATE(955),
    [sym_file_descriptor] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(1257),
    [anon_sym_PIPE] = ACTIONS(1257),
    [anon_sym_SEMI_SEMI] = ACTIONS(1255),
    [anon_sym_PIPE_AMP] = ACTIONS(1255),
    [anon_sym_AMP_AMP] = ACTIONS(1255),
    [anon_sym_PIPE_PIPE] = ACTIONS(1255),
    [anon_sym_LT] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(665),
    [anon_sym_GT_GT] = ACTIONS(667),
    [anon_sym_AMP_GT] = ACTIONS(665),
    [anon_sym_AMP_GT_GT] = ACTIONS(667),
    [anon_sym_LT_AMP] = ACTIONS(667),
    [anon_sym_GT_AMP] = ACTIONS(667),
    [anon_sym_LT_LT] = ACTIONS(669),
    [anon_sym_LT_LT_DASH] = ACTIONS(671),
    [anon_sym_LT_LT_LT] = ACTIONS(673),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1257),
  },
  [389] = {
    [sym_concatenation] = STATE(956),
    [sym_string] = STATE(957),
    [sym_simple_expansion] = STATE(957),
    [sym_string_expansion] = STATE(957),
    [sym_expansion] = STATE(957),
    [sym_command_substitution] = STATE(957),
    [sym_process_substitution] = STATE(957),
    [aux_sym__literal_repeat1] = STATE(958),
    [sym_regex] = ACTIONS(1797),
    [anon_sym_DOLLAR] = ACTIONS(125),
    [sym__special_character] = ACTIONS(677),
    [anon_sym_DQUOTE] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(1799),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1799),
  },
  [390] = {
    [aux_sym_concatenation_repeat1] = STATE(366),
    [sym_file_descriptor] = ACTIONS(1263),
    [sym__concat] = ACTIONS(633),
    [anon_sym_SEMI] = ACTIONS(1265),
    [anon_sym_PIPE] = ACTIONS(1265),
    [anon_sym_SEMI_SEMI] = ACTIONS(1263),
    [anon_sym_PIPE_AMP] = ACTIONS(1263),
    [anon_sym_AMP_AMP] = ACTIONS(1263),
    [anon_sym_PIPE_PIPE] = ACTIONS(1263),
    [anon_sym_EQ_TILDE] = ACTIONS(1265),
    [anon_sym_EQ_EQ] = ACTIONS(1265),
    [anon_sym_LT] = ACTIONS(1265),
    [anon_sym_GT] = ACTIONS(1265),
    [anon_sym_GT_GT] = ACTIONS(1263),
    [anon_sym_AMP_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT_GT] = ACTIONS(1263),
    [anon_sym_LT_AMP] = ACTIONS(1263),
    [anon_sym_GT_AMP] = ACTIONS(1263),
    [anon_sym_LT_LT] = ACTIONS(1265),
    [anon_sym_LT_LT_DASH] = ACTIONS(1263),
    [anon_sym_LT_LT_LT] = ACTIONS(1263),
    [anon_sym_DOLLAR] = ACTIONS(1265),
    [sym__special_character] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(1263),
    [sym_raw_string] = ACTIONS(1263),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1263),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1263),
    [anon_sym_BQUOTE] = ACTIONS(1263),
    [anon_sym_LT_LPAREN] = ACTIONS(1263),
    [anon_sym_GT_LPAREN] = ACTIONS(1263),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1265),
    [anon_sym_LF] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1265),
  },
  [391] = {
    [sym_concatenation] = STATE(959),
    [sym_string] = STATE(390),
    [sym_simple_expansion] = STATE(390),
    [sym_string_expansion] = STATE(390),
    [sym_expansion] = STATE(390),
    [sym_command_substitution] = STATE(390),
    [sym_process_substitution] = STATE(390),
    [aux_sym_command_repeat2] = STATE(959),
    [aux_sym__literal_repeat1] = STATE(392),
    [sym_file_descriptor] = ACTIONS(1267),
    [anon_sym_SEMI] = ACTIONS(1269),
    [anon_sym_PIPE] = ACTIONS(1269),
    [anon_sym_SEMI_SEMI] = ACTIONS(1267),
    [anon_sym_PIPE_AMP] = ACTIONS(1267),
    [anon_sym_AMP_AMP] = ACTIONS(1267),
    [anon_sym_PIPE_PIPE] = ACTIONS(1267),
    [anon_sym_EQ_TILDE] = ACTIONS(675),
    [anon_sym_EQ_EQ] = ACTIONS(675),
    [anon_sym_LT] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1269),
    [anon_sym_GT_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT_GT] = ACTIONS(1267),
    [anon_sym_LT_AMP] = ACTIONS(1267),
    [anon_sym_GT_AMP] = ACTIONS(1267),
    [anon_sym_LT_LT] = ACTIONS(1269),
    [anon_sym_LT_LT_DASH] = ACTIONS(1267),
    [anon_sym_LT_LT_LT] = ACTIONS(1267),
    [anon_sym_DOLLAR] = ACTIONS(125),
    [sym__special_character] = ACTIONS(677),
    [anon_sym_DQUOTE] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(679),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(681),
    [anon_sym_LF] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(1269),
  },
  [392] = {
    [aux_sym__literal_repeat1] = STATE(395),
    [sym_file_descriptor] = ACTIONS(1271),
    [anon_sym_SEMI] = ACTIONS(1273),
    [anon_sym_PIPE] = ACTIONS(1273),
    [anon_sym_SEMI_SEMI] = ACTIONS(1271),
    [anon_sym_PIPE_AMP] = ACTIONS(1271),
    [anon_sym_AMP_AMP] = ACTIONS(1271),
    [anon_sym_PIPE_PIPE] = ACTIONS(1271),
    [anon_sym_EQ_TILDE] = ACTIONS(1273),
    [anon_sym_EQ_EQ] = ACTIONS(1273),
    [anon_sym_LT] = ACTIONS(1273),
    [anon_sym_GT] = ACTIONS(1273),
    [anon_sym_GT_GT] = ACTIONS(1271),
    [anon_sym_AMP_GT] = ACTIONS(1273),
    [anon_sym_AMP_GT_GT] = ACTIONS(1271),
    [anon_sym_LT_AMP] = ACTIONS(1271),
    [anon_sym_GT_AMP] = ACTIONS(1271),
    [anon_sym_LT_LT] = ACTIONS(1273),
    [anon_sym_LT_LT_DASH] = ACTIONS(1271),
    [anon_sym_LT_LT_LT] = ACTIONS(1271),
    [anon_sym_DOLLAR] = ACTIONS(1273),
    [sym__special_character] = ACTIONS(683),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [sym_raw_string] = ACTIONS(1271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1271),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1271),
    [anon_sym_BQUOTE] = ACTIONS(1271),
    [anon_sym_LT_LPAREN] = ACTIONS(1271),
    [anon_sym_GT_LPAREN] = ACTIONS(1271),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1273),
    [anon_sym_LF] = ACTIONS(1271),
    [anon_sym_AMP] = ACTIONS(1273),
  },
  [393] = {
    [sym_concatenation] = STATE(960),
    [sym_string] = STATE(390),
    [sym_simple_expansion] = STATE(390),
    [sym_string_expansion] = STATE(390),
    [sym_expansion] = STATE(390),
    [sym_command_substitution] = STATE(390),
    [sym_process_substitution] = STATE(390),
    [aux_sym_command_repeat2] = STATE(960),
    [aux_sym__literal_repeat1] = STATE(392),
    [sym_file_descriptor] = ACTIONS(1267),
    [anon_sym_SEMI] = ACTIONS(1269),
    [anon_sym_PIPE] = ACTIONS(1269),
    [anon_sym_SEMI_SEMI] = ACTIONS(1267),
    [anon_sym_PIPE_AMP] = ACTIONS(1267),
    [anon_sym_AMP_AMP] = ACTIONS(1267),
    [anon_sym_PIPE_PIPE] = ACTIONS(1267),
    [anon_sym_EQ_TILDE] = ACTIONS(675),
    [anon_sym_EQ_EQ] = ACTIONS(675),
    [anon_sym_LT] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1269),
    [anon_sym_GT_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT_GT] = ACTIONS(1267),
    [anon_sym_LT_AMP] = ACTIONS(1267),
    [anon_sym_GT_AMP] = ACTIONS(1267),
    [anon_sym_LT_LT] = ACTIONS(1269),
    [anon_sym_LT_LT_DASH] = ACTIONS(1267),
    [anon_sym_LT_LT_LT] = ACTIONS(1267),
    [anon_sym_DOLLAR] = ACTIONS(125),
    [sym__special_character] = ACTIONS(677),
    [anon_sym_DQUOTE] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(679),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(681),
    [anon_sym_LF] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(1269),
  },
  [394] = {
    [sym_file_descriptor] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_EQ_TILDE] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [395] = {
    [aux_sym__literal_repeat1] = STATE(395),
    [sym_file_descriptor] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE_AMP] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_EQ_TILDE] = ACTIONS(1375),
    [anon_sym_EQ_EQ] = ACTIONS(1375),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_LT_LT_DASH] = ACTIONS(1373),
    [anon_sym_LT_LT_LT] = ACTIONS(1373),
    [anon_sym_DOLLAR] = ACTIONS(1375),
    [sym__special_character] = ACTIONS(1801),
    [anon_sym_DQUOTE] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1373),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [anon_sym_LT_LPAREN] = ACTIONS(1373),
    [anon_sym_GT_LPAREN] = ACTIONS(1373),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1375),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
  },
  [396] = {
    [sym__statements] = STATE(977),
    [sym_redirected_statement] = STATE(978),
    [sym_for_statement] = STATE(978),
    [sym_c_style_for_statement] = STATE(978),
    [sym_while_statement] = STATE(978),
    [sym_if_statement] = STATE(978),
    [sym_elif_clause] = STATE(985),
    [sym_else_clause] = STATE(979),
    [sym_case_statement] = STATE(978),
    [sym_function_definition] = STATE(978),
    [sym_compound_statement] = STATE(978),
    [sym_subshell] = STATE(978),
    [sym_pipeline] = STATE(978),
    [sym_list] = STATE(978),
    [sym_negated_command] = STATE(978),
    [sym_test_command] = STATE(978),
    [sym_declaration_command] = STATE(978),
    [sym_unset_command] = STATE(978),
    [sym_command] = STATE(978),
    [sym_command_name] = STATE(980),
    [sym_variable_assignment] = STATE(981),
    [sym_subscript] = STATE(982),
    [sym_file_redirect] = STATE(986),
    [sym_concatenation] = STATE(983),
    [sym_string] = STATE(971),
    [sym_simple_expansion] = STATE(971),
    [sym_string_expansion] = STATE(971),
    [sym_expansion] = STATE(971),
    [sym_command_substitution] = STATE(971),
    [sym_process_substitution] = STATE(971),
    [aux_sym__statements_repeat1] = STATE(984),
    [aux_sym_if_statement_repeat1] = STATE(985),
    [aux_sym_command_repeat1] = STATE(986),
    [aux_sym__literal_repeat1] = STATE(987),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(1804),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_fi] = ACTIONS(1806),
    [anon_sym_elif] = ACTIONS(1808),
    [anon_sym_else] = ACTIONS(1810),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1812),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(1814),
    [anon_sym_typeset] = ACTIONS(1814),
    [anon_sym_export] = ACTIONS(1814),
    [anon_sym_readonly] = ACTIONS(1814),
    [anon_sym_local] = ACTIONS(1814),
    [anon_sym_unset] = ACTIONS(1816),
    [anon_sym_unsetenv] = ACTIONS(1816),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(1818),
    [sym__special_character] = ACTIONS(1820),
    [anon_sym_DQUOTE] = ACTIONS(1822),
    [sym_raw_string] = ACTIONS(1824),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1826),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1828),
    [anon_sym_BQUOTE] = ACTIONS(1830),
    [anon_sym_LT_LPAREN] = ACTIONS(1832),
    [anon_sym_GT_LPAREN] = ACTIONS(1832),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1834),
  },
  [397] = {
    [sym__concat] = ACTIONS(1057),
    [anon_sym_in] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1057),
  },
  [398] = {
    [sym__concat] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(1063),
    [anon_sym_SEMI_SEMI] = ACTIONS(1061),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1061),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [399] = {
    [sym__concat] = ACTIONS(1065),
    [anon_sym_in] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_SEMI_SEMI] = ACTIONS(1065),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1065),
  },
  [400] = {
    [sym_string] = STATE(988),
    [sym_simple_expansion] = STATE(988),
    [sym_string_expansion] = STATE(988),
    [sym_expansion] = STATE(988),
    [sym_command_substitution] = STATE(988),
    [sym_process_substitution] = STATE(988),
    [anon_sym_DOLLAR] = ACTIONS(143),
    [sym__special_character] = ACTIONS(1836),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [sym_raw_string] = ACTIONS(1836),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [anon_sym_LT_LPAREN] = ACTIONS(157),
    [anon_sym_GT_LPAREN] = ACTIONS(157),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1836),
  },
  [401] = {
    [aux_sym_concatenation_repeat1] = STATE(990),
    [sym__concat] = ACTIONS(1838),
    [anon_sym_in] = ACTIONS(1071),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1071),
  },
  [402] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [403] = {
    [sym__concat] = ACTIONS(1089),
    [anon_sym_in] = ACTIONS(1089),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1089),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1089),
  },
  [404] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(627),
    [anon_sym_DOLLAR] = ACTIONS(1842),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [405] = {
    [anon_sym_SEMI] = ACTIONS(1844),
    [anon_sym_SEMI_SEMI] = ACTIONS(1846),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1846),
    [anon_sym_AMP] = ACTIONS(1846),
  },
  [406] = {
    [anon_sym_in] = ACTIONS(1848),
    [sym_comment] = ACTIONS(57),
  },
  [407] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(1850),
    [sym_comment] = ACTIONS(57),
  },
  [408] = {
    [sym_subscript] = STATE(998),
    [sym_variable_name] = ACTIONS(1852),
    [anon_sym_DASH] = ACTIONS(1854),
    [anon_sym_DOLLAR] = ACTIONS(1854),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1856),
    [anon_sym_STAR] = ACTIONS(1858),
    [anon_sym_AT] = ACTIONS(1858),
    [anon_sym_QMARK] = ACTIONS(1858),
    [anon_sym_0] = ACTIONS(1856),
    [anon_sym__] = ACTIONS(1856),
  },
  [409] = {
    [sym_concatenation] = STATE(1001),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1001),
    [anon_sym_RBRACE] = ACTIONS(1860),
    [anon_sym_EQ] = ACTIONS(1862),
    [anon_sym_DASH] = ACTIONS(1862),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(1864),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(1866),
    [anon_sym_COLON] = ACTIONS(1862),
    [anon_sym_COLON_QMARK] = ACTIONS(1862),
    [anon_sym_COLON_DASH] = ACTIONS(1862),
    [anon_sym_PERCENT] = ACTIONS(1862),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [410] = {
    [sym_concatenation] = STATE(1004),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1004),
    [anon_sym_RBRACE] = ACTIONS(1868),
    [anon_sym_EQ] = ACTIONS(1870),
    [anon_sym_DASH] = ACTIONS(1870),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(1872),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(1874),
    [anon_sym_COLON] = ACTIONS(1870),
    [anon_sym_COLON_QMARK] = ACTIONS(1870),
    [anon_sym_COLON_DASH] = ACTIONS(1870),
    [anon_sym_PERCENT] = ACTIONS(1870),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [411] = {
    [anon_sym_RPAREN] = ACTIONS(1876),
    [sym_comment] = ACTIONS(57),
  },
  [412] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(1876),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [413] = {
    [anon_sym_BQUOTE] = ACTIONS(1876),
    [sym_comment] = ACTIONS(57),
  },
  [414] = {
    [anon_sym_RPAREN] = ACTIONS(1878),
    [sym_comment] = ACTIONS(57),
  },
  [415] = {
    [anon_sym_SEMI] = ACTIONS(1880),
    [anon_sym_SEMI_SEMI] = ACTIONS(1882),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1882),
    [anon_sym_AMP] = ACTIONS(1882),
  },
  [416] = {
    [anon_sym_in] = ACTIONS(1884),
    [sym_comment] = ACTIONS(57),
  },
  [417] = {
    [anon_sym_in] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [sym__special_character] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(335),
  },
  [418] = {
    [aux_sym__literal_repeat1] = STATE(418),
    [anon_sym_in] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [sym__special_character] = ACTIONS(1886),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [419] = {
    [anon_sym_RPAREN] = ACTIONS(1889),
    [sym_comment] = ACTIONS(57),
  },
  [420] = {
    [sym__simple_heredoc_body] = ACTIONS(1891),
    [sym__heredoc_body_beginning] = ACTIONS(1891),
    [sym_file_descriptor] = ACTIONS(1891),
    [ts_builtin_sym_end] = ACTIONS(1891),
    [anon_sym_SEMI] = ACTIONS(1893),
    [anon_sym_done] = ACTIONS(1891),
    [anon_sym_fi] = ACTIONS(1891),
    [anon_sym_elif] = ACTIONS(1891),
    [anon_sym_else] = ACTIONS(1891),
    [anon_sym_esac] = ACTIONS(1891),
    [anon_sym_PIPE] = ACTIONS(1893),
    [anon_sym_RPAREN] = ACTIONS(1891),
    [anon_sym_SEMI_SEMI] = ACTIONS(1891),
    [anon_sym_PIPE_AMP] = ACTIONS(1891),
    [anon_sym_AMP_AMP] = ACTIONS(1891),
    [anon_sym_PIPE_PIPE] = ACTIONS(1891),
    [anon_sym_LT] = ACTIONS(1893),
    [anon_sym_GT] = ACTIONS(1893),
    [anon_sym_GT_GT] = ACTIONS(1891),
    [anon_sym_AMP_GT] = ACTIONS(1893),
    [anon_sym_AMP_GT_GT] = ACTIONS(1891),
    [anon_sym_LT_AMP] = ACTIONS(1891),
    [anon_sym_GT_AMP] = ACTIONS(1891),
    [anon_sym_LT_LT] = ACTIONS(1893),
    [anon_sym_LT_LT_DASH] = ACTIONS(1891),
    [anon_sym_LT_LT_LT] = ACTIONS(1891),
    [anon_sym_BQUOTE] = ACTIONS(1891),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1891),
    [anon_sym_AMP] = ACTIONS(1893),
  },
  [421] = {
    [sym_concatenation] = STATE(263),
    [sym_string] = STATE(1011),
    [sym_array] = STATE(263),
    [sym_simple_expansion] = STATE(1011),
    [sym_string_expansion] = STATE(1011),
    [sym_expansion] = STATE(1011),
    [sym_command_substitution] = STATE(1011),
    [sym_process_substitution] = STATE(1011),
    [aux_sym__literal_repeat1] = STATE(1012),
    [sym__empty_value] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_DOLLAR] = ACTIONS(453),
    [sym__special_character] = ACTIONS(1895),
    [anon_sym_DQUOTE] = ACTIONS(457),
    [sym_raw_string] = ACTIONS(1897),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(461),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(463),
    [anon_sym_BQUOTE] = ACTIONS(465),
    [anon_sym_LT_LPAREN] = ACTIONS(467),
    [anon_sym_GT_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1897),
  },
  [422] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(1899),
    [anon_sym_PLUS_EQ] = ACTIONS(1899),
    [sym_comment] = ACTIONS(57),
  },
  [423] = {
    [aux_sym_concatenation_repeat1] = STATE(1014),
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_RPAREN] = ACTIONS(335),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(339),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [424] = {
    [aux_sym_concatenation_repeat1] = STATE(1014),
    [sym__simple_heredoc_body] = ACTIONS(957),
    [sym__heredoc_body_beginning] = ACTIONS(957),
    [sym_file_descriptor] = ACTIONS(957),
    [sym__concat] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(957),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_RPAREN] = ACTIONS(957),
    [anon_sym_SEMI_SEMI] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_LT] = ACTIONS(959),
    [anon_sym_GT] = ACTIONS(959),
    [anon_sym_GT_GT] = ACTIONS(957),
    [anon_sym_AMP_GT] = ACTIONS(959),
    [anon_sym_AMP_GT_GT] = ACTIONS(957),
    [anon_sym_LT_AMP] = ACTIONS(957),
    [anon_sym_GT_AMP] = ACTIONS(957),
    [anon_sym_LT_LT] = ACTIONS(959),
    [anon_sym_LT_LT_DASH] = ACTIONS(957),
    [anon_sym_LT_LT_LT] = ACTIONS(957),
    [anon_sym_DOLLAR] = ACTIONS(959),
    [sym__special_character] = ACTIONS(957),
    [anon_sym_DQUOTE] = ACTIONS(957),
    [sym_raw_string] = ACTIONS(957),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(957),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(957),
    [anon_sym_BQUOTE] = ACTIONS(957),
    [anon_sym_LT_LPAREN] = ACTIONS(957),
    [anon_sym_GT_LPAREN] = ACTIONS(957),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(959),
    [sym_word] = ACTIONS(959),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
  },
  [425] = {
    [anon_sym_EQ] = ACTIONS(1899),
    [anon_sym_PLUS_EQ] = ACTIONS(1899),
    [sym_comment] = ACTIONS(57),
  },
  [426] = {
    [sym_variable_assignment] = STATE(1015),
    [sym_subscript] = STATE(425),
    [sym_concatenation] = STATE(1015),
    [sym_string] = STATE(424),
    [sym_simple_expansion] = STATE(424),
    [sym_string_expansion] = STATE(424),
    [sym_expansion] = STATE(424),
    [sym_command_substitution] = STATE(424),
    [sym_process_substitution] = STATE(424),
    [aux_sym_declaration_command_repeat1] = STATE(1015),
    [aux_sym__literal_repeat1] = STATE(427),
    [sym__simple_heredoc_body] = ACTIONS(971),
    [sym__heredoc_body_beginning] = ACTIONS(971),
    [sym_file_descriptor] = ACTIONS(971),
    [sym_variable_name] = ACTIONS(729),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_RPAREN] = ACTIONS(971),
    [anon_sym_SEMI_SEMI] = ACTIONS(971),
    [anon_sym_PIPE_AMP] = ACTIONS(971),
    [anon_sym_AMP_AMP] = ACTIONS(971),
    [anon_sym_PIPE_PIPE] = ACTIONS(971),
    [anon_sym_LT] = ACTIONS(973),
    [anon_sym_GT] = ACTIONS(973),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_AMP_GT] = ACTIONS(973),
    [anon_sym_AMP_GT_GT] = ACTIONS(971),
    [anon_sym_LT_AMP] = ACTIONS(971),
    [anon_sym_GT_AMP] = ACTIONS(971),
    [anon_sym_LT_LT] = ACTIONS(973),
    [anon_sym_LT_LT_DASH] = ACTIONS(971),
    [anon_sym_LT_LT_LT] = ACTIONS(971),
    [anon_sym_DOLLAR] = ACTIONS(265),
    [sym__special_character] = ACTIONS(731),
    [anon_sym_DQUOTE] = ACTIONS(269),
    [sym_raw_string] = ACTIONS(733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(277),
    [anon_sym_LT_LPAREN] = ACTIONS(279),
    [anon_sym_GT_LPAREN] = ACTIONS(279),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1901),
    [sym_word] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(973),
  },
  [427] = {
    [aux_sym__literal_repeat1] = STATE(1016),
    [sym__simple_heredoc_body] = ACTIONS(977),
    [sym__heredoc_body_beginning] = ACTIONS(977),
    [sym_file_descriptor] = ACTIONS(977),
    [sym_variable_name] = ACTIONS(977),
    [anon_sym_SEMI] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(979),
    [anon_sym_RPAREN] = ACTIONS(977),
    [anon_sym_SEMI_SEMI] = ACTIONS(977),
    [anon_sym_PIPE_AMP] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(977),
    [anon_sym_AMP_GT] = ACTIONS(979),
    [anon_sym_AMP_GT_GT] = ACTIONS(977),
    [anon_sym_LT_AMP] = ACTIONS(977),
    [anon_sym_GT_AMP] = ACTIONS(977),
    [anon_sym_LT_LT] = ACTIONS(979),
    [anon_sym_LT_LT_DASH] = ACTIONS(977),
    [anon_sym_LT_LT_LT] = ACTIONS(977),
    [anon_sym_DOLLAR] = ACTIONS(979),
    [sym__special_character] = ACTIONS(981),
    [anon_sym_DQUOTE] = ACTIONS(977),
    [sym_raw_string] = ACTIONS(977),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(977),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(977),
    [anon_sym_BQUOTE] = ACTIONS(977),
    [anon_sym_LT_LPAREN] = ACTIONS(977),
    [anon_sym_GT_LPAREN] = ACTIONS(977),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(979),
    [sym_word] = ACTIONS(979),
    [anon_sym_LF] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
  },
  [428] = {
    [aux_sym_concatenation_repeat1] = STATE(1017),
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(991),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_RPAREN] = ACTIONS(335),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(339),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [429] = {
    [aux_sym_concatenation_repeat1] = STATE(1017),
    [sym__simple_heredoc_body] = ACTIONS(997),
    [sym__heredoc_body_beginning] = ACTIONS(997),
    [sym_file_descriptor] = ACTIONS(997),
    [sym__concat] = ACTIONS(991),
    [anon_sym_SEMI] = ACTIONS(999),
    [anon_sym_PIPE] = ACTIONS(999),
    [anon_sym_RPAREN] = ACTIONS(997),
    [anon_sym_SEMI_SEMI] = ACTIONS(997),
    [anon_sym_PIPE_AMP] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_LT] = ACTIONS(999),
    [anon_sym_GT] = ACTIONS(999),
    [anon_sym_GT_GT] = ACTIONS(997),
    [anon_sym_AMP_GT] = ACTIONS(999),
    [anon_sym_AMP_GT_GT] = ACTIONS(997),
    [anon_sym_LT_AMP] = ACTIONS(997),
    [anon_sym_GT_AMP] = ACTIONS(997),
    [anon_sym_LT_LT] = ACTIONS(999),
    [anon_sym_LT_LT_DASH] = ACTIONS(997),
    [anon_sym_LT_LT_LT] = ACTIONS(997),
    [anon_sym_DOLLAR] = ACTIONS(999),
    [sym__special_character] = ACTIONS(997),
    [anon_sym_DQUOTE] = ACTIONS(997),
    [sym_raw_string] = ACTIONS(997),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(997),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(997),
    [anon_sym_BQUOTE] = ACTIONS(997),
    [anon_sym_LT_LPAREN] = ACTIONS(997),
    [anon_sym_GT_LPAREN] = ACTIONS(997),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(999),
    [sym_word] = ACTIONS(999),
    [anon_sym_LF] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(999),
  },
  [430] = {
    [sym_concatenation] = STATE(1018),
    [sym_string] = STATE(429),
    [sym_simple_expansion] = STATE(429),
    [sym_string_expansion] = STATE(429),
    [sym_expansion] = STATE(429),
    [sym_command_substitution] = STATE(429),
    [sym_process_substitution] = STATE(429),
    [aux_sym_unset_command_repeat1] = STATE(1018),
    [aux_sym__literal_repeat1] = STATE(431),
    [sym__simple_heredoc_body] = ACTIONS(1011),
    [sym__heredoc_body_beginning] = ACTIONS(1011),
    [sym_file_descriptor] = ACTIONS(1011),
    [anon_sym_SEMI] = ACTIONS(1013),
    [anon_sym_PIPE] = ACTIONS(1013),
    [anon_sym_RPAREN] = ACTIONS(1011),
    [anon_sym_SEMI_SEMI] = ACTIONS(1011),
    [anon_sym_PIPE_AMP] = ACTIONS(1011),
    [anon_sym_AMP_AMP] = ACTIONS(1011),
    [anon_sym_PIPE_PIPE] = ACTIONS(1011),
    [anon_sym_LT] = ACTIONS(1013),
    [anon_sym_GT] = ACTIONS(1013),
    [anon_sym_GT_GT] = ACTIONS(1011),
    [anon_sym_AMP_GT] = ACTIONS(1013),
    [anon_sym_AMP_GT_GT] = ACTIONS(1011),
    [anon_sym_LT_AMP] = ACTIONS(1011),
    [anon_sym_GT_AMP] = ACTIONS(1011),
    [anon_sym_LT_LT] = ACTIONS(1013),
    [anon_sym_LT_LT_DASH] = ACTIONS(1011),
    [anon_sym_LT_LT_LT] = ACTIONS(1011),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym__special_character] = ACTIONS(739),
    [anon_sym_DQUOTE] = ACTIONS(293),
    [sym_raw_string] = ACTIONS(741),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(297),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(301),
    [anon_sym_LT_LPAREN] = ACTIONS(303),
    [anon_sym_GT_LPAREN] = ACTIONS(303),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1903),
    [sym_word] = ACTIONS(745),
    [anon_sym_LF] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(1013),
  },
  [431] = {
    [aux_sym__literal_repeat1] = STATE(1019),
    [sym__simple_heredoc_body] = ACTIONS(1017),
    [sym__heredoc_body_beginning] = ACTIONS(1017),
    [sym_file_descriptor] = ACTIONS(1017),
    [anon_sym_SEMI] = ACTIONS(1019),
    [anon_sym_PIPE] = ACTIONS(1019),
    [anon_sym_RPAREN] = ACTIONS(1017),
    [anon_sym_SEMI_SEMI] = ACTIONS(1017),
    [anon_sym_PIPE_AMP] = ACTIONS(1017),
    [anon_sym_AMP_AMP] = ACTIONS(1017),
    [anon_sym_PIPE_PIPE] = ACTIONS(1017),
    [anon_sym_LT] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(1019),
    [anon_sym_GT_GT] = ACTIONS(1017),
    [anon_sym_AMP_GT] = ACTIONS(1019),
    [anon_sym_AMP_GT_GT] = ACTIONS(1017),
    [anon_sym_LT_AMP] = ACTIONS(1017),
    [anon_sym_GT_AMP] = ACTIONS(1017),
    [anon_sym_LT_LT] = ACTIONS(1019),
    [anon_sym_LT_LT_DASH] = ACTIONS(1017),
    [anon_sym_LT_LT_LT] = ACTIONS(1017),
    [anon_sym_DOLLAR] = ACTIONS(1019),
    [sym__special_character] = ACTIONS(1021),
    [anon_sym_DQUOTE] = ACTIONS(1017),
    [sym_raw_string] = ACTIONS(1017),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1017),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1017),
    [anon_sym_BQUOTE] = ACTIONS(1017),
    [anon_sym_LT_LPAREN] = ACTIONS(1017),
    [anon_sym_GT_LPAREN] = ACTIONS(1017),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1019),
    [sym_word] = ACTIONS(1019),
    [anon_sym_LF] = ACTIONS(1017),
    [anon_sym_AMP] = ACTIONS(1019),
  },
  [432] = {
    [aux_sym_concatenation_repeat1] = STATE(1020),
    [sym__simple_heredoc_body] = ACTIONS(1071),
    [sym__heredoc_body_beginning] = ACTIONS(1071),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(1073),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_RPAREN] = ACTIONS(1071),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_EQ_TILDE] = ACTIONS(1075),
    [anon_sym_EQ_EQ] = ACTIONS(1075),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [sym__special_character] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1075),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1075),
  },
  [433] = {
    [sym__simple_heredoc_body] = ACTIONS(1905),
    [sym__heredoc_body_beginning] = ACTIONS(1905),
    [sym_file_descriptor] = ACTIONS(1905),
    [ts_builtin_sym_end] = ACTIONS(1905),
    [anon_sym_SEMI] = ACTIONS(1907),
    [anon_sym_done] = ACTIONS(1905),
    [anon_sym_fi] = ACTIONS(1905),
    [anon_sym_elif] = ACTIONS(1905),
    [anon_sym_else] = ACTIONS(1905),
    [anon_sym_esac] = ACTIONS(1905),
    [anon_sym_PIPE] = ACTIONS(1907),
    [anon_sym_RPAREN] = ACTIONS(1905),
    [anon_sym_SEMI_SEMI] = ACTIONS(1905),
    [anon_sym_PIPE_AMP] = ACTIONS(1905),
    [anon_sym_AMP_AMP] = ACTIONS(1905),
    [anon_sym_PIPE_PIPE] = ACTIONS(1905),
    [anon_sym_LT] = ACTIONS(1907),
    [anon_sym_GT] = ACTIONS(1907),
    [anon_sym_GT_GT] = ACTIONS(1905),
    [anon_sym_AMP_GT] = ACTIONS(1907),
    [anon_sym_AMP_GT_GT] = ACTIONS(1905),
    [anon_sym_LT_AMP] = ACTIONS(1905),
    [anon_sym_GT_AMP] = ACTIONS(1905),
    [anon_sym_LT_LT] = ACTIONS(1907),
    [anon_sym_LT_LT_DASH] = ACTIONS(1905),
    [anon_sym_LT_LT_LT] = ACTIONS(1905),
    [anon_sym_BQUOTE] = ACTIONS(1905),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1905),
    [anon_sym_AMP] = ACTIONS(1907),
  },
  [434] = {
    [anon_sym_LT] = ACTIONS(1909),
    [anon_sym_GT] = ACTIONS(1909),
    [anon_sym_GT_GT] = ACTIONS(1911),
    [anon_sym_AMP_GT] = ACTIONS(1909),
    [anon_sym_AMP_GT_GT] = ACTIONS(1911),
    [anon_sym_LT_AMP] = ACTIONS(1911),
    [anon_sym_GT_AMP] = ACTIONS(1911),
    [sym_comment] = ACTIONS(57),
  },
  [435] = {
    [sym_redirected_statement] = STATE(1022),
    [sym_for_statement] = STATE(1022),
    [sym_c_style_for_statement] = STATE(1022),
    [sym_while_statement] = STATE(1022),
    [sym_if_statement] = STATE(1022),
    [sym_case_statement] = STATE(1022),
    [sym_function_definition] = STATE(1022),
    [sym_compound_statement] = STATE(1022),
    [sym_subshell] = STATE(1022),
    [sym_pipeline] = STATE(1022),
    [sym_list] = STATE(1022),
    [sym_negated_command] = STATE(1022),
    [sym_test_command] = STATE(1022),
    [sym_declaration_command] = STATE(1022),
    [sym_unset_command] = STATE(1022),
    [sym_command] = STATE(1022),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(1023),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [436] = {
    [sym_redirected_statement] = STATE(1024),
    [sym_for_statement] = STATE(1024),
    [sym_c_style_for_statement] = STATE(1024),
    [sym_while_statement] = STATE(1024),
    [sym_if_statement] = STATE(1024),
    [sym_case_statement] = STATE(1024),
    [sym_function_definition] = STATE(1024),
    [sym_compound_statement] = STATE(1024),
    [sym_subshell] = STATE(1024),
    [sym_pipeline] = STATE(1024),
    [sym_list] = STATE(1024),
    [sym_negated_command] = STATE(1024),
    [sym_test_command] = STATE(1024),
    [sym_declaration_command] = STATE(1024),
    [sym_unset_command] = STATE(1024),
    [sym_command] = STATE(1024),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(1025),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [437] = {
    [sym_concatenation] = STATE(696),
    [sym_string] = STATE(1027),
    [sym_simple_expansion] = STATE(1027),
    [sym_string_expansion] = STATE(1027),
    [sym_expansion] = STATE(1027),
    [sym_command_substitution] = STATE(1027),
    [sym_process_substitution] = STATE(1027),
    [aux_sym__literal_repeat1] = STATE(1028),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(1913),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1915),
  },
  [438] = {
    [sym_concatenation] = STATE(700),
    [sym_string] = STATE(1029),
    [sym_simple_expansion] = STATE(1029),
    [sym_string_expansion] = STATE(1029),
    [sym_expansion] = STATE(1029),
    [sym_command_substitution] = STATE(1029),
    [sym_process_substitution] = STATE(1029),
    [aux_sym__literal_repeat1] = STATE(1030),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(1913),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1917),
  },
  [439] = {
    [sym_file_redirect] = STATE(1031),
    [sym_heredoc_redirect] = STATE(1031),
    [sym_herestring_redirect] = STATE(1031),
    [aux_sym_redirected_statement_repeat1] = STATE(1031),
    [sym__simple_heredoc_body] = ACTIONS(1255),
    [sym__heredoc_body_beginning] = ACTIONS(1255),
    [sym_file_descriptor] = ACTIONS(749),
    [anon_sym_SEMI] = ACTIONS(1257),
    [anon_sym_PIPE] = ACTIONS(1257),
    [anon_sym_RPAREN] = ACTIONS(1255),
    [anon_sym_SEMI_SEMI] = ACTIONS(1255),
    [anon_sym_PIPE_AMP] = ACTIONS(1255),
    [anon_sym_AMP_AMP] = ACTIONS(1255),
    [anon_sym_PIPE_PIPE] = ACTIONS(1255),
    [anon_sym_LT] = ACTIONS(757),
    [anon_sym_GT] = ACTIONS(757),
    [anon_sym_GT_GT] = ACTIONS(759),
    [anon_sym_AMP_GT] = ACTIONS(757),
    [anon_sym_AMP_GT_GT] = ACTIONS(759),
    [anon_sym_LT_AMP] = ACTIONS(759),
    [anon_sym_GT_AMP] = ACTIONS(759),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(761),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1257),
  },
  [440] = {
    [sym_concatenation] = STATE(704),
    [sym_string] = STATE(1032),
    [sym_simple_expansion] = STATE(1032),
    [sym_string_expansion] = STATE(1032),
    [sym_expansion] = STATE(1032),
    [sym_command_substitution] = STATE(1032),
    [sym_process_substitution] = STATE(1032),
    [aux_sym__literal_repeat1] = STATE(1033),
    [sym_regex] = ACTIONS(1259),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1919),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1919),
  },
  [441] = {
    [aux_sym_concatenation_repeat1] = STATE(432),
    [sym__simple_heredoc_body] = ACTIONS(1263),
    [sym__heredoc_body_beginning] = ACTIONS(1263),
    [sym_file_descriptor] = ACTIONS(1263),
    [sym__concat] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(1265),
    [anon_sym_PIPE] = ACTIONS(1265),
    [anon_sym_RPAREN] = ACTIONS(1263),
    [anon_sym_SEMI_SEMI] = ACTIONS(1263),
    [anon_sym_PIPE_AMP] = ACTIONS(1263),
    [anon_sym_AMP_AMP] = ACTIONS(1263),
    [anon_sym_PIPE_PIPE] = ACTIONS(1263),
    [anon_sym_EQ_TILDE] = ACTIONS(1265),
    [anon_sym_EQ_EQ] = ACTIONS(1265),
    [anon_sym_LT] = ACTIONS(1265),
    [anon_sym_GT] = ACTIONS(1265),
    [anon_sym_GT_GT] = ACTIONS(1263),
    [anon_sym_AMP_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT_GT] = ACTIONS(1263),
    [anon_sym_LT_AMP] = ACTIONS(1263),
    [anon_sym_GT_AMP] = ACTIONS(1263),
    [anon_sym_LT_LT] = ACTIONS(1265),
    [anon_sym_LT_LT_DASH] = ACTIONS(1263),
    [anon_sym_LT_LT_LT] = ACTIONS(1263),
    [anon_sym_DOLLAR] = ACTIONS(1265),
    [sym__special_character] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(1263),
    [sym_raw_string] = ACTIONS(1263),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1263),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1263),
    [anon_sym_BQUOTE] = ACTIONS(1263),
    [anon_sym_LT_LPAREN] = ACTIONS(1263),
    [anon_sym_GT_LPAREN] = ACTIONS(1263),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1265),
    [anon_sym_LF] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1265),
  },
  [442] = {
    [sym_concatenation] = STATE(1034),
    [sym_string] = STATE(441),
    [sym_simple_expansion] = STATE(441),
    [sym_string_expansion] = STATE(441),
    [sym_expansion] = STATE(441),
    [sym_command_substitution] = STATE(441),
    [sym_process_substitution] = STATE(441),
    [aux_sym_command_repeat2] = STATE(1034),
    [aux_sym__literal_repeat1] = STATE(443),
    [sym__simple_heredoc_body] = ACTIONS(1267),
    [sym__heredoc_body_beginning] = ACTIONS(1267),
    [sym_file_descriptor] = ACTIONS(1267),
    [anon_sym_SEMI] = ACTIONS(1269),
    [anon_sym_PIPE] = ACTIONS(1269),
    [anon_sym_RPAREN] = ACTIONS(1267),
    [anon_sym_SEMI_SEMI] = ACTIONS(1267),
    [anon_sym_PIPE_AMP] = ACTIONS(1267),
    [anon_sym_AMP_AMP] = ACTIONS(1267),
    [anon_sym_PIPE_PIPE] = ACTIONS(1267),
    [anon_sym_EQ_TILDE] = ACTIONS(763),
    [anon_sym_EQ_EQ] = ACTIONS(763),
    [anon_sym_LT] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1269),
    [anon_sym_GT_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT_GT] = ACTIONS(1267),
    [anon_sym_LT_AMP] = ACTIONS(1267),
    [anon_sym_GT_AMP] = ACTIONS(1267),
    [anon_sym_LT_LT] = ACTIONS(1269),
    [anon_sym_LT_LT_DASH] = ACTIONS(1267),
    [anon_sym_LT_LT_LT] = ACTIONS(1267),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(767),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(769),
    [anon_sym_LF] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(1269),
  },
  [443] = {
    [aux_sym__literal_repeat1] = STATE(447),
    [sym__simple_heredoc_body] = ACTIONS(1271),
    [sym__heredoc_body_beginning] = ACTIONS(1271),
    [sym_file_descriptor] = ACTIONS(1271),
    [anon_sym_SEMI] = ACTIONS(1273),
    [anon_sym_PIPE] = ACTIONS(1273),
    [anon_sym_RPAREN] = ACTIONS(1271),
    [anon_sym_SEMI_SEMI] = ACTIONS(1271),
    [anon_sym_PIPE_AMP] = ACTIONS(1271),
    [anon_sym_AMP_AMP] = ACTIONS(1271),
    [anon_sym_PIPE_PIPE] = ACTIONS(1271),
    [anon_sym_EQ_TILDE] = ACTIONS(1273),
    [anon_sym_EQ_EQ] = ACTIONS(1273),
    [anon_sym_LT] = ACTIONS(1273),
    [anon_sym_GT] = ACTIONS(1273),
    [anon_sym_GT_GT] = ACTIONS(1271),
    [anon_sym_AMP_GT] = ACTIONS(1273),
    [anon_sym_AMP_GT_GT] = ACTIONS(1271),
    [anon_sym_LT_AMP] = ACTIONS(1271),
    [anon_sym_GT_AMP] = ACTIONS(1271),
    [anon_sym_LT_LT] = ACTIONS(1273),
    [anon_sym_LT_LT_DASH] = ACTIONS(1271),
    [anon_sym_LT_LT_LT] = ACTIONS(1271),
    [anon_sym_DOLLAR] = ACTIONS(1273),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [sym_raw_string] = ACTIONS(1271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1271),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1271),
    [anon_sym_BQUOTE] = ACTIONS(1271),
    [anon_sym_LT_LPAREN] = ACTIONS(1271),
    [anon_sym_GT_LPAREN] = ACTIONS(1271),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1273),
    [anon_sym_LF] = ACTIONS(1271),
    [anon_sym_AMP] = ACTIONS(1273),
  },
  [444] = {
    [sym_file_redirect] = STATE(439),
    [sym_heredoc_redirect] = STATE(439),
    [sym_heredoc_body] = STATE(709),
    [sym_herestring_redirect] = STATE(439),
    [aux_sym_redirected_statement_repeat1] = STATE(439),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(749),
    [anon_sym_SEMI] = ACTIONS(1275),
    [anon_sym_PIPE] = ACTIONS(751),
    [anon_sym_RPAREN] = ACTIONS(1239),
    [anon_sym_SEMI_SEMI] = ACTIONS(1277),
    [anon_sym_PIPE_AMP] = ACTIONS(753),
    [anon_sym_AMP_AMP] = ACTIONS(755),
    [anon_sym_PIPE_PIPE] = ACTIONS(755),
    [anon_sym_LT] = ACTIONS(757),
    [anon_sym_GT] = ACTIONS(757),
    [anon_sym_GT_GT] = ACTIONS(759),
    [anon_sym_AMP_GT] = ACTIONS(757),
    [anon_sym_AMP_GT_GT] = ACTIONS(759),
    [anon_sym_LT_AMP] = ACTIONS(759),
    [anon_sym_GT_AMP] = ACTIONS(759),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(761),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1275),
  },
  [445] = {
    [sym_file_redirect] = STATE(439),
    [sym_heredoc_redirect] = STATE(439),
    [sym_heredoc_body] = STATE(709),
    [sym_herestring_redirect] = STATE(439),
    [aux_sym_redirected_statement_repeat1] = STATE(439),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(1275),
    [anon_sym_PIPE] = ACTIONS(751),
    [anon_sym_RPAREN] = ACTIONS(1239),
    [anon_sym_SEMI_SEMI] = ACTIONS(1277),
    [anon_sym_PIPE_AMP] = ACTIONS(753),
    [anon_sym_AMP_AMP] = ACTIONS(755),
    [anon_sym_PIPE_PIPE] = ACTIONS(755),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(761),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1275),
  },
  [446] = {
    [sym_concatenation] = STATE(1035),
    [sym_string] = STATE(441),
    [sym_simple_expansion] = STATE(441),
    [sym_string_expansion] = STATE(441),
    [sym_expansion] = STATE(441),
    [sym_command_substitution] = STATE(441),
    [sym_process_substitution] = STATE(441),
    [aux_sym_command_repeat2] = STATE(1035),
    [aux_sym__literal_repeat1] = STATE(443),
    [sym__simple_heredoc_body] = ACTIONS(1267),
    [sym__heredoc_body_beginning] = ACTIONS(1267),
    [sym_file_descriptor] = ACTIONS(1267),
    [anon_sym_SEMI] = ACTIONS(1269),
    [anon_sym_PIPE] = ACTIONS(1269),
    [anon_sym_RPAREN] = ACTIONS(1267),
    [anon_sym_SEMI_SEMI] = ACTIONS(1267),
    [anon_sym_PIPE_AMP] = ACTIONS(1267),
    [anon_sym_AMP_AMP] = ACTIONS(1267),
    [anon_sym_PIPE_PIPE] = ACTIONS(1267),
    [anon_sym_EQ_TILDE] = ACTIONS(763),
    [anon_sym_EQ_EQ] = ACTIONS(763),
    [anon_sym_LT] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1269),
    [anon_sym_GT_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT_GT] = ACTIONS(1267),
    [anon_sym_LT_AMP] = ACTIONS(1267),
    [anon_sym_GT_AMP] = ACTIONS(1267),
    [anon_sym_LT_LT] = ACTIONS(1269),
    [anon_sym_LT_LT_DASH] = ACTIONS(1267),
    [anon_sym_LT_LT_LT] = ACTIONS(1267),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(767),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(769),
    [anon_sym_LF] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(1269),
  },
  [447] = {
    [aux_sym__literal_repeat1] = STATE(447),
    [sym__simple_heredoc_body] = ACTIONS(1373),
    [sym__heredoc_body_beginning] = ACTIONS(1373),
    [sym_file_descriptor] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_RPAREN] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE_AMP] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_EQ_TILDE] = ACTIONS(1375),
    [anon_sym_EQ_EQ] = ACTIONS(1375),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_LT_LT_DASH] = ACTIONS(1373),
    [anon_sym_LT_LT_LT] = ACTIONS(1373),
    [anon_sym_DOLLAR] = ACTIONS(1375),
    [sym__special_character] = ACTIONS(1377),
    [anon_sym_DQUOTE] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1373),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [anon_sym_LT_LPAREN] = ACTIONS(1373),
    [anon_sym_GT_LPAREN] = ACTIONS(1373),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1375),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
  },
  [448] = {
    [sym_concatenation] = STATE(1036),
    [sym_string] = STATE(1041),
    [sym_array] = STATE(1036),
    [sym_simple_expansion] = STATE(1041),
    [sym_string_expansion] = STATE(1041),
    [sym_expansion] = STATE(1041),
    [sym_command_substitution] = STATE(1041),
    [sym_process_substitution] = STATE(1041),
    [aux_sym__literal_repeat1] = STATE(1046),
    [sym__empty_value] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_DOLLAR] = ACTIONS(1925),
    [sym__special_character] = ACTIONS(1927),
    [anon_sym_DQUOTE] = ACTIONS(1929),
    [sym_raw_string] = ACTIONS(1931),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1933),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1935),
    [anon_sym_BQUOTE] = ACTIONS(1937),
    [anon_sym_LT_LPAREN] = ACTIONS(1939),
    [anon_sym_GT_LPAREN] = ACTIONS(1939),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1931),
  },
  [449] = {
    [sym__expression] = STATE(1048),
    [sym_binary_expression] = STATE(1048),
    [sym_unary_expression] = STATE(1048),
    [sym_postfix_expression] = STATE(1048),
    [sym_parenthesized_expression] = STATE(1048),
    [sym_concatenation] = STATE(1048),
    [sym_string] = STATE(280),
    [sym_simple_expansion] = STATE(280),
    [sym_string_expansion] = STATE(280),
    [sym_expansion] = STATE(280),
    [sym_command_substitution] = STATE(280),
    [sym_process_substitution] = STATE(280),
    [aux_sym__literal_repeat1] = STATE(286),
    [anon_sym_SEMI] = ACTIONS(1941),
    [anon_sym_SEMI_SEMI] = ACTIONS(1943),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(475),
    [anon_sym_DOLLAR] = ACTIONS(477),
    [sym__special_character] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(481),
    [sym_raw_string] = ACTIONS(483),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(485),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(487),
    [anon_sym_BQUOTE] = ACTIONS(489),
    [anon_sym_LT_LPAREN] = ACTIONS(491),
    [anon_sym_GT_LPAREN] = ACTIONS(491),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(493),
    [sym_test_operator] = ACTIONS(495),
    [anon_sym_LF] = ACTIONS(1943),
    [anon_sym_AMP] = ACTIONS(1943),
  },
  [450] = {
    [anon_sym_in] = ACTIONS(1945),
    [anon_sym_SEMI] = ACTIONS(1947),
    [anon_sym_SEMI_SEMI] = ACTIONS(1949),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1949),
    [anon_sym_AMP] = ACTIONS(1949),
  },
  [451] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1951),
    [anon_sym_AMP_AMP] = ACTIONS(557),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(559),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_PLUS_EQ] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DASH_EQ] = ACTIONS(557),
    [anon_sym_LT_EQ] = ACTIONS(557),
    [anon_sym_GT_EQ] = ACTIONS(557),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(557),
  },
  [452] = {
    [sym_do_group] = STATE(1053),
    [anon_sym_do] = ACTIONS(1953),
    [sym_comment] = ACTIONS(57),
  },
  [453] = {
    [anon_sym_then] = ACTIONS(1955),
    [sym_comment] = ACTIONS(57),
  },
  [454] = {
    [aux_sym_concatenation_repeat1] = STATE(401),
    [sym__concat] = ACTIONS(695),
    [anon_sym_in] = ACTIONS(1957),
    [anon_sym_SEMI] = ACTIONS(1959),
    [anon_sym_SEMI_SEMI] = ACTIONS(1961),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1961),
    [anon_sym_AMP] = ACTIONS(1961),
  },
  [455] = {
    [anon_sym_in] = ACTIONS(1957),
    [anon_sym_SEMI] = ACTIONS(1959),
    [anon_sym_SEMI_SEMI] = ACTIONS(1961),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1961),
    [anon_sym_AMP] = ACTIONS(1961),
  },
  [456] = {
    [aux_sym__literal_repeat1] = STATE(418),
    [anon_sym_in] = ACTIONS(1963),
    [anon_sym_SEMI] = ACTIONS(1965),
    [anon_sym_SEMI_SEMI] = ACTIONS(1967),
    [sym__special_character] = ACTIONS(723),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1967),
    [anon_sym_AMP] = ACTIONS(1967),
  },
  [457] = {
    [sym_compound_statement] = STATE(1060),
    [anon_sym_LPAREN] = ACTIONS(1969),
    [anon_sym_LBRACE] = ACTIONS(191),
    [sym_comment] = ACTIONS(57),
  },
  [458] = {
    [anon_sym_RPAREN] = ACTIONS(1971),
    [sym_comment] = ACTIONS(57),
  },
  [459] = {
    [sym__simple_heredoc_body] = ACTIONS(783),
    [sym__heredoc_body_beginning] = ACTIONS(783),
    [sym_file_descriptor] = ACTIONS(783),
    [anon_sym_SEMI] = ACTIONS(785),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_SEMI_SEMI] = ACTIONS(783),
    [anon_sym_RBRACE] = ACTIONS(783),
    [anon_sym_PIPE_AMP] = ACTIONS(783),
    [anon_sym_AMP_AMP] = ACTIONS(783),
    [anon_sym_PIPE_PIPE] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(785),
    [anon_sym_GT] = ACTIONS(785),
    [anon_sym_GT_GT] = ACTIONS(783),
    [anon_sym_AMP_GT] = ACTIONS(785),
    [anon_sym_AMP_GT_GT] = ACTIONS(783),
    [anon_sym_LT_AMP] = ACTIONS(783),
    [anon_sym_GT_AMP] = ACTIONS(783),
    [anon_sym_LT_LT] = ACTIONS(785),
    [anon_sym_LT_LT_DASH] = ACTIONS(783),
    [anon_sym_LT_LT_LT] = ACTIONS(783),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(783),
    [anon_sym_AMP] = ACTIONS(785),
  },
  [460] = {
    [anon_sym_RBRACE] = ACTIONS(1973),
    [sym_comment] = ACTIONS(57),
  },
  [461] = {
    [sym__simple_heredoc_body] = ACTIONS(895),
    [sym__heredoc_body_beginning] = ACTIONS(895),
    [sym_file_descriptor] = ACTIONS(895),
    [anon_sym_SEMI] = ACTIONS(897),
    [anon_sym_PIPE] = ACTIONS(897),
    [anon_sym_SEMI_SEMI] = ACTIONS(895),
    [anon_sym_RBRACE] = ACTIONS(895),
    [anon_sym_PIPE_AMP] = ACTIONS(895),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(895),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(895),
    [anon_sym_LT_AMP] = ACTIONS(895),
    [anon_sym_GT_AMP] = ACTIONS(895),
    [anon_sym_LT_LT] = ACTIONS(897),
    [anon_sym_LT_LT_DASH] = ACTIONS(895),
    [anon_sym_LT_LT_LT] = ACTIONS(895),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(895),
    [anon_sym_AMP] = ACTIONS(897),
  },
  [462] = {
    [anon_sym_AMP_AMP] = ACTIONS(923),
    [anon_sym_PIPE_PIPE] = ACTIONS(923),
    [anon_sym_RBRACK] = ACTIONS(1951),
    [anon_sym_EQ_TILDE] = ACTIONS(925),
    [anon_sym_EQ_EQ] = ACTIONS(925),
    [anon_sym_EQ] = ACTIONS(927),
    [anon_sym_PLUS_EQ] = ACTIONS(923),
    [anon_sym_LT] = ACTIONS(927),
    [anon_sym_GT] = ACTIONS(927),
    [anon_sym_BANG_EQ] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(927),
    [anon_sym_DASH_EQ] = ACTIONS(923),
    [anon_sym_LT_EQ] = ACTIONS(923),
    [anon_sym_GT_EQ] = ACTIONS(923),
    [anon_sym_PLUS_PLUS] = ACTIONS(929),
    [anon_sym_DASH_DASH] = ACTIONS(929),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(923),
  },
  [463] = {
    [anon_sym_AMP_AMP] = ACTIONS(933),
    [anon_sym_PIPE_PIPE] = ACTIONS(933),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1951),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(935),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_PLUS_EQ] = ACTIONS(933),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(933),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_DASH] = ACTIONS(937),
    [anon_sym_DASH_EQ] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(933),
    [anon_sym_GT_EQ] = ACTIONS(933),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(933),
  },
  [464] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(1975),
    [anon_sym_PLUS_EQ] = ACTIONS(1975),
    [sym_comment] = ACTIONS(57),
  },
  [465] = {
    [sym_string] = STATE(1065),
    [anon_sym_DASH] = ACTIONS(1977),
    [anon_sym_DOLLAR] = ACTIONS(1977),
    [anon_sym_DQUOTE] = ACTIONS(793),
    [sym_raw_string] = ACTIONS(1979),
    [anon_sym_POUND] = ACTIONS(1977),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1981),
    [anon_sym_STAR] = ACTIONS(1983),
    [anon_sym_AT] = ACTIONS(1983),
    [anon_sym_QMARK] = ACTIONS(1983),
    [anon_sym_0] = ACTIONS(1981),
    [anon_sym__] = ACTIONS(1981),
  },
  [466] = {
    [aux_sym_concatenation_repeat1] = STATE(1068),
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(1985),
    [sym_variable_name] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_RBRACE] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(339),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [467] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(1071),
    [anon_sym_DOLLAR] = ACTIONS(1987),
    [anon_sym_DQUOTE] = ACTIONS(1989),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [468] = {
    [aux_sym_concatenation_repeat1] = STATE(1068),
    [sym__simple_heredoc_body] = ACTIONS(957),
    [sym__heredoc_body_beginning] = ACTIONS(957),
    [sym_file_descriptor] = ACTIONS(957),
    [sym__concat] = ACTIONS(1985),
    [sym_variable_name] = ACTIONS(957),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_SEMI_SEMI] = ACTIONS(957),
    [anon_sym_RBRACE] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_LT] = ACTIONS(959),
    [anon_sym_GT] = ACTIONS(959),
    [anon_sym_GT_GT] = ACTIONS(957),
    [anon_sym_AMP_GT] = ACTIONS(959),
    [anon_sym_AMP_GT_GT] = ACTIONS(957),
    [anon_sym_LT_AMP] = ACTIONS(957),
    [anon_sym_GT_AMP] = ACTIONS(957),
    [anon_sym_LT_LT] = ACTIONS(959),
    [anon_sym_LT_LT_DASH] = ACTIONS(957),
    [anon_sym_LT_LT_LT] = ACTIONS(957),
    [anon_sym_DOLLAR] = ACTIONS(959),
    [sym__special_character] = ACTIONS(959),
    [anon_sym_DQUOTE] = ACTIONS(957),
    [sym_raw_string] = ACTIONS(957),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(957),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(957),
    [anon_sym_BQUOTE] = ACTIONS(957),
    [anon_sym_LT_LPAREN] = ACTIONS(957),
    [anon_sym_GT_LPAREN] = ACTIONS(957),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(959),
    [sym_word] = ACTIONS(959),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
  },
  [469] = {
    [sym_subscript] = STATE(1075),
    [sym_variable_name] = ACTIONS(1991),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_DOLLAR] = ACTIONS(1995),
    [anon_sym_POUND] = ACTIONS(1993),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1999),
    [anon_sym_AT] = ACTIONS(1999),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_0] = ACTIONS(1997),
    [anon_sym__] = ACTIONS(1997),
  },
  [470] = {
    [sym__statements] = STATE(1076),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(1077),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [471] = {
    [sym__statements] = STATE(1078),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [472] = {
    [sym__statements] = STATE(1079),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [473] = {
    [anon_sym_EQ] = ACTIONS(1975),
    [anon_sym_PLUS_EQ] = ACTIONS(1975),
    [sym_comment] = ACTIONS(57),
  },
  [474] = {
    [sym_variable_assignment] = STATE(1080),
    [sym_subscript] = STATE(473),
    [sym_concatenation] = STATE(1080),
    [sym_string] = STATE(468),
    [sym_simple_expansion] = STATE(468),
    [sym_string_expansion] = STATE(468),
    [sym_expansion] = STATE(468),
    [sym_command_substitution] = STATE(468),
    [sym_process_substitution] = STATE(468),
    [aux_sym_declaration_command_repeat1] = STATE(1080),
    [aux_sym__literal_repeat1] = STATE(475),
    [sym__simple_heredoc_body] = ACTIONS(971),
    [sym__heredoc_body_beginning] = ACTIONS(971),
    [sym_file_descriptor] = ACTIONS(971),
    [sym_variable_name] = ACTIONS(787),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_SEMI_SEMI] = ACTIONS(971),
    [anon_sym_RBRACE] = ACTIONS(971),
    [anon_sym_PIPE_AMP] = ACTIONS(971),
    [anon_sym_AMP_AMP] = ACTIONS(971),
    [anon_sym_PIPE_PIPE] = ACTIONS(971),
    [anon_sym_LT] = ACTIONS(973),
    [anon_sym_GT] = ACTIONS(973),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_AMP_GT] = ACTIONS(973),
    [anon_sym_AMP_GT_GT] = ACTIONS(971),
    [anon_sym_LT_AMP] = ACTIONS(971),
    [anon_sym_GT_AMP] = ACTIONS(971),
    [anon_sym_LT_LT] = ACTIONS(973),
    [anon_sym_LT_LT_DASH] = ACTIONS(971),
    [anon_sym_LT_LT_LT] = ACTIONS(971),
    [anon_sym_DOLLAR] = ACTIONS(789),
    [sym__special_character] = ACTIONS(791),
    [anon_sym_DQUOTE] = ACTIONS(793),
    [sym_raw_string] = ACTIONS(795),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(797),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(799),
    [anon_sym_BQUOTE] = ACTIONS(801),
    [anon_sym_LT_LPAREN] = ACTIONS(803),
    [anon_sym_GT_LPAREN] = ACTIONS(803),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2001),
    [sym_word] = ACTIONS(807),
    [anon_sym_LF] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(973),
  },
  [475] = {
    [aux_sym__literal_repeat1] = STATE(1082),
    [sym__simple_heredoc_body] = ACTIONS(977),
    [sym__heredoc_body_beginning] = ACTIONS(977),
    [sym_file_descriptor] = ACTIONS(977),
    [sym_variable_name] = ACTIONS(977),
    [anon_sym_SEMI] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(979),
    [anon_sym_SEMI_SEMI] = ACTIONS(977),
    [anon_sym_RBRACE] = ACTIONS(977),
    [anon_sym_PIPE_AMP] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(977),
    [anon_sym_AMP_GT] = ACTIONS(979),
    [anon_sym_AMP_GT_GT] = ACTIONS(977),
    [anon_sym_LT_AMP] = ACTIONS(977),
    [anon_sym_GT_AMP] = ACTIONS(977),
    [anon_sym_LT_LT] = ACTIONS(979),
    [anon_sym_LT_LT_DASH] = ACTIONS(977),
    [anon_sym_LT_LT_LT] = ACTIONS(977),
    [anon_sym_DOLLAR] = ACTIONS(979),
    [sym__special_character] = ACTIONS(2003),
    [anon_sym_DQUOTE] = ACTIONS(977),
    [sym_raw_string] = ACTIONS(977),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(977),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(977),
    [anon_sym_BQUOTE] = ACTIONS(977),
    [anon_sym_LT_LPAREN] = ACTIONS(977),
    [anon_sym_GT_LPAREN] = ACTIONS(977),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(979),
    [sym_word] = ACTIONS(979),
    [anon_sym_LF] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
  },
  [476] = {
    [sym_string] = STATE(1084),
    [anon_sym_DASH] = ACTIONS(2005),
    [anon_sym_DOLLAR] = ACTIONS(2005),
    [anon_sym_DQUOTE] = ACTIONS(813),
    [sym_raw_string] = ACTIONS(2007),
    [anon_sym_POUND] = ACTIONS(2005),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2009),
    [anon_sym_STAR] = ACTIONS(2011),
    [anon_sym_AT] = ACTIONS(2011),
    [anon_sym_QMARK] = ACTIONS(2011),
    [anon_sym_0] = ACTIONS(2009),
    [anon_sym__] = ACTIONS(2009),
  },
  [477] = {
    [aux_sym_concatenation_repeat1] = STATE(1087),
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(2013),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_RBRACE] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(339),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [478] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(1090),
    [anon_sym_DOLLAR] = ACTIONS(2015),
    [anon_sym_DQUOTE] = ACTIONS(2017),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [479] = {
    [aux_sym_concatenation_repeat1] = STATE(1087),
    [sym__simple_heredoc_body] = ACTIONS(997),
    [sym__heredoc_body_beginning] = ACTIONS(997),
    [sym_file_descriptor] = ACTIONS(997),
    [sym__concat] = ACTIONS(2013),
    [anon_sym_SEMI] = ACTIONS(999),
    [anon_sym_PIPE] = ACTIONS(999),
    [anon_sym_SEMI_SEMI] = ACTIONS(997),
    [anon_sym_RBRACE] = ACTIONS(997),
    [anon_sym_PIPE_AMP] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_LT] = ACTIONS(999),
    [anon_sym_GT] = ACTIONS(999),
    [anon_sym_GT_GT] = ACTIONS(997),
    [anon_sym_AMP_GT] = ACTIONS(999),
    [anon_sym_AMP_GT_GT] = ACTIONS(997),
    [anon_sym_LT_AMP] = ACTIONS(997),
    [anon_sym_GT_AMP] = ACTIONS(997),
    [anon_sym_LT_LT] = ACTIONS(999),
    [anon_sym_LT_LT_DASH] = ACTIONS(997),
    [anon_sym_LT_LT_LT] = ACTIONS(997),
    [anon_sym_DOLLAR] = ACTIONS(999),
    [sym__special_character] = ACTIONS(999),
    [anon_sym_DQUOTE] = ACTIONS(997),
    [sym_raw_string] = ACTIONS(997),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(997),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(997),
    [anon_sym_BQUOTE] = ACTIONS(997),
    [anon_sym_LT_LPAREN] = ACTIONS(997),
    [anon_sym_GT_LPAREN] = ACTIONS(997),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(999),
    [sym_word] = ACTIONS(999),
    [anon_sym_LF] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(999),
  },
  [480] = {
    [sym_subscript] = STATE(1094),
    [sym_variable_name] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2021),
    [anon_sym_DASH] = ACTIONS(2023),
    [anon_sym_DOLLAR] = ACTIONS(2023),
    [anon_sym_POUND] = ACTIONS(2021),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2025),
    [anon_sym_STAR] = ACTIONS(2027),
    [anon_sym_AT] = ACTIONS(2027),
    [anon_sym_QMARK] = ACTIONS(2027),
    [anon_sym_0] = ACTIONS(2025),
    [anon_sym__] = ACTIONS(2025),
  },
  [481] = {
    [sym__statements] = STATE(1095),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(1096),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [482] = {
    [sym__statements] = STATE(1097),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [483] = {
    [sym__statements] = STATE(1098),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [484] = {
    [sym_concatenation] = STATE(1099),
    [sym_string] = STATE(479),
    [sym_simple_expansion] = STATE(479),
    [sym_string_expansion] = STATE(479),
    [sym_expansion] = STATE(479),
    [sym_command_substitution] = STATE(479),
    [sym_process_substitution] = STATE(479),
    [aux_sym_unset_command_repeat1] = STATE(1099),
    [aux_sym__literal_repeat1] = STATE(485),
    [sym__simple_heredoc_body] = ACTIONS(1011),
    [sym__heredoc_body_beginning] = ACTIONS(1011),
    [sym_file_descriptor] = ACTIONS(1011),
    [anon_sym_SEMI] = ACTIONS(1013),
    [anon_sym_PIPE] = ACTIONS(1013),
    [anon_sym_SEMI_SEMI] = ACTIONS(1011),
    [anon_sym_RBRACE] = ACTIONS(1011),
    [anon_sym_PIPE_AMP] = ACTIONS(1011),
    [anon_sym_AMP_AMP] = ACTIONS(1011),
    [anon_sym_PIPE_PIPE] = ACTIONS(1011),
    [anon_sym_LT] = ACTIONS(1013),
    [anon_sym_GT] = ACTIONS(1013),
    [anon_sym_GT_GT] = ACTIONS(1011),
    [anon_sym_AMP_GT] = ACTIONS(1013),
    [anon_sym_AMP_GT_GT] = ACTIONS(1011),
    [anon_sym_LT_AMP] = ACTIONS(1011),
    [anon_sym_GT_AMP] = ACTIONS(1011),
    [anon_sym_LT_LT] = ACTIONS(1013),
    [anon_sym_LT_LT_DASH] = ACTIONS(1011),
    [anon_sym_LT_LT_LT] = ACTIONS(1011),
    [anon_sym_DOLLAR] = ACTIONS(809),
    [sym__special_character] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(813),
    [sym_raw_string] = ACTIONS(815),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(817),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(819),
    [anon_sym_BQUOTE] = ACTIONS(821),
    [anon_sym_LT_LPAREN] = ACTIONS(823),
    [anon_sym_GT_LPAREN] = ACTIONS(823),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2029),
    [sym_word] = ACTIONS(827),
    [anon_sym_LF] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(1013),
  },
  [485] = {
    [aux_sym__literal_repeat1] = STATE(1101),
    [sym__simple_heredoc_body] = ACTIONS(1017),
    [sym__heredoc_body_beginning] = ACTIONS(1017),
    [sym_file_descriptor] = ACTIONS(1017),
    [anon_sym_SEMI] = ACTIONS(1019),
    [anon_sym_PIPE] = ACTIONS(1019),
    [anon_sym_SEMI_SEMI] = ACTIONS(1017),
    [anon_sym_RBRACE] = ACTIONS(1017),
    [anon_sym_PIPE_AMP] = ACTIONS(1017),
    [anon_sym_AMP_AMP] = ACTIONS(1017),
    [anon_sym_PIPE_PIPE] = ACTIONS(1017),
    [anon_sym_LT] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(1019),
    [anon_sym_GT_GT] = ACTIONS(1017),
    [anon_sym_AMP_GT] = ACTIONS(1019),
    [anon_sym_AMP_GT_GT] = ACTIONS(1017),
    [anon_sym_LT_AMP] = ACTIONS(1017),
    [anon_sym_GT_AMP] = ACTIONS(1017),
    [anon_sym_LT_LT] = ACTIONS(1019),
    [anon_sym_LT_LT_DASH] = ACTIONS(1017),
    [anon_sym_LT_LT_LT] = ACTIONS(1017),
    [anon_sym_DOLLAR] = ACTIONS(1019),
    [sym__special_character] = ACTIONS(2031),
    [anon_sym_DQUOTE] = ACTIONS(1017),
    [sym_raw_string] = ACTIONS(1017),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1017),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1017),
    [anon_sym_BQUOTE] = ACTIONS(1017),
    [anon_sym_LT_LPAREN] = ACTIONS(1017),
    [anon_sym_GT_LPAREN] = ACTIONS(1017),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1019),
    [sym_word] = ACTIONS(1019),
    [anon_sym_LF] = ACTIONS(1017),
    [anon_sym_AMP] = ACTIONS(1019),
  },
  [486] = {
    [sym__simple_heredoc_body] = ACTIONS(1057),
    [sym__heredoc_body_beginning] = ACTIONS(1057),
    [sym_file_descriptor] = ACTIONS(1057),
    [sym__concat] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(1057),
    [anon_sym_PIPE_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_EQ_TILDE] = ACTIONS(1059),
    [anon_sym_EQ_EQ] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_AMP] = ACTIONS(1057),
    [anon_sym_GT_AMP] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_LT] = ACTIONS(1057),
    [anon_sym_DOLLAR] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [sym_raw_string] = ACTIONS(1057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1057),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1057),
    [anon_sym_BQUOTE] = ACTIONS(1057),
    [anon_sym_LT_LPAREN] = ACTIONS(1057),
    [anon_sym_GT_LPAREN] = ACTIONS(1057),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [487] = {
    [sym__simple_heredoc_body] = ACTIONS(1061),
    [sym__heredoc_body_beginning] = ACTIONS(1061),
    [sym_file_descriptor] = ACTIONS(1061),
    [sym__concat] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(1063),
    [anon_sym_PIPE] = ACTIONS(1063),
    [anon_sym_SEMI_SEMI] = ACTIONS(1061),
    [anon_sym_RBRACE] = ACTIONS(1061),
    [anon_sym_PIPE_AMP] = ACTIONS(1061),
    [anon_sym_AMP_AMP] = ACTIONS(1061),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_EQ_TILDE] = ACTIONS(1063),
    [anon_sym_EQ_EQ] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1063),
    [anon_sym_GT_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT_GT] = ACTIONS(1061),
    [anon_sym_LT_AMP] = ACTIONS(1061),
    [anon_sym_GT_AMP] = ACTIONS(1061),
    [anon_sym_LT_LT] = ACTIONS(1063),
    [anon_sym_LT_LT_DASH] = ACTIONS(1061),
    [anon_sym_LT_LT_LT] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1061),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1061),
    [anon_sym_LT_LPAREN] = ACTIONS(1061),
    [anon_sym_GT_LPAREN] = ACTIONS(1061),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1063),
    [anon_sym_LF] = ACTIONS(1061),
    [anon_sym_AMP] = ACTIONS(1063),
  },
  [488] = {
    [sym__simple_heredoc_body] = ACTIONS(1065),
    [sym__heredoc_body_beginning] = ACTIONS(1065),
    [sym_file_descriptor] = ACTIONS(1065),
    [sym__concat] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1067),
    [anon_sym_SEMI_SEMI] = ACTIONS(1065),
    [anon_sym_RBRACE] = ACTIONS(1065),
    [anon_sym_PIPE_AMP] = ACTIONS(1065),
    [anon_sym_AMP_AMP] = ACTIONS(1065),
    [anon_sym_PIPE_PIPE] = ACTIONS(1065),
    [anon_sym_EQ_TILDE] = ACTIONS(1067),
    [anon_sym_EQ_EQ] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_GT] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT] = ACTIONS(1067),
    [anon_sym_AMP_GT_GT] = ACTIONS(1065),
    [anon_sym_LT_AMP] = ACTIONS(1065),
    [anon_sym_GT_AMP] = ACTIONS(1065),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_LT_LT_DASH] = ACTIONS(1065),
    [anon_sym_LT_LT_LT] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1067),
    [sym__special_character] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LT_LPAREN] = ACTIONS(1065),
    [anon_sym_GT_LPAREN] = ACTIONS(1065),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1067),
    [anon_sym_LF] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1067),
  },
  [489] = {
    [sym_string] = STATE(1102),
    [sym_simple_expansion] = STATE(1102),
    [sym_string_expansion] = STATE(1102),
    [sym_expansion] = STATE(1102),
    [sym_command_substitution] = STATE(1102),
    [sym_process_substitution] = STATE(1102),
    [anon_sym_DOLLAR] = ACTIONS(205),
    [sym__special_character] = ACTIONS(2033),
    [anon_sym_DQUOTE] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(2033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2033),
  },
  [490] = {
    [aux_sym_concatenation_repeat1] = STATE(1104),
    [sym__simple_heredoc_body] = ACTIONS(1071),
    [sym__heredoc_body_beginning] = ACTIONS(1071),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(2035),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_EQ_TILDE] = ACTIONS(1075),
    [anon_sym_EQ_EQ] = ACTIONS(1075),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [sym__special_character] = ACTIONS(1075),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1075),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1075),
  },
  [491] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(2037),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [492] = {
    [sym__simple_heredoc_body] = ACTIONS(1089),
    [sym__heredoc_body_beginning] = ACTIONS(1089),
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(1089),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_PIPE_AMP] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_AMP] = ACTIONS(1089),
    [anon_sym_GT_AMP] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1089),
    [anon_sym_LT_LT_LT] = ACTIONS(1089),
    [anon_sym_DOLLAR] = ACTIONS(1091),
    [sym__special_character] = ACTIONS(1091),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1089),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1089),
    [anon_sym_GT_LPAREN] = ACTIONS(1089),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [493] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(627),
    [anon_sym_DOLLAR] = ACTIONS(2039),
    [anon_sym_DQUOTE] = ACTIONS(2037),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [494] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(2041),
    [sym_comment] = ACTIONS(57),
  },
  [495] = {
    [sym_subscript] = STATE(1110),
    [sym_variable_name] = ACTIONS(2043),
    [anon_sym_DASH] = ACTIONS(2045),
    [anon_sym_DOLLAR] = ACTIONS(2045),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2047),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_AT] = ACTIONS(2049),
    [anon_sym_QMARK] = ACTIONS(2049),
    [anon_sym_0] = ACTIONS(2047),
    [anon_sym__] = ACTIONS(2047),
  },
  [496] = {
    [sym_concatenation] = STATE(1113),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1113),
    [anon_sym_RBRACE] = ACTIONS(2051),
    [anon_sym_EQ] = ACTIONS(2053),
    [anon_sym_DASH] = ACTIONS(2053),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2055),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(2057),
    [anon_sym_COLON] = ACTIONS(2053),
    [anon_sym_COLON_QMARK] = ACTIONS(2053),
    [anon_sym_COLON_DASH] = ACTIONS(2053),
    [anon_sym_PERCENT] = ACTIONS(2053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [497] = {
    [sym_concatenation] = STATE(1116),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1116),
    [anon_sym_RBRACE] = ACTIONS(2059),
    [anon_sym_EQ] = ACTIONS(2061),
    [anon_sym_DASH] = ACTIONS(2061),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2063),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(2065),
    [anon_sym_COLON] = ACTIONS(2061),
    [anon_sym_COLON_QMARK] = ACTIONS(2061),
    [anon_sym_COLON_DASH] = ACTIONS(2061),
    [anon_sym_PERCENT] = ACTIONS(2061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [498] = {
    [anon_sym_RPAREN] = ACTIONS(2067),
    [sym_comment] = ACTIONS(57),
  },
  [499] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(2067),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [500] = {
    [anon_sym_BQUOTE] = ACTIONS(2067),
    [sym_comment] = ACTIONS(57),
  },
  [501] = {
    [anon_sym_RPAREN] = ACTIONS(2069),
    [sym_comment] = ACTIONS(57),
  },
  [502] = {
    [anon_sym_RPAREN] = ACTIONS(2071),
    [sym_comment] = ACTIONS(57),
  },
  [503] = {
    [sym__simple_heredoc_body] = ACTIONS(2073),
    [sym__heredoc_body_beginning] = ACTIONS(2073),
    [sym_file_descriptor] = ACTIONS(2073),
    [ts_builtin_sym_end] = ACTIONS(2073),
    [anon_sym_SEMI] = ACTIONS(2075),
    [anon_sym_done] = ACTIONS(2073),
    [anon_sym_fi] = ACTIONS(2073),
    [anon_sym_elif] = ACTIONS(2073),
    [anon_sym_else] = ACTIONS(2073),
    [anon_sym_esac] = ACTIONS(2073),
    [anon_sym_PIPE] = ACTIONS(2075),
    [anon_sym_RPAREN] = ACTIONS(2073),
    [anon_sym_SEMI_SEMI] = ACTIONS(2073),
    [anon_sym_PIPE_AMP] = ACTIONS(2073),
    [anon_sym_AMP_AMP] = ACTIONS(2073),
    [anon_sym_PIPE_PIPE] = ACTIONS(2073),
    [anon_sym_LT] = ACTIONS(2075),
    [anon_sym_GT] = ACTIONS(2075),
    [anon_sym_GT_GT] = ACTIONS(2073),
    [anon_sym_AMP_GT] = ACTIONS(2075),
    [anon_sym_AMP_GT_GT] = ACTIONS(2073),
    [anon_sym_LT_AMP] = ACTIONS(2073),
    [anon_sym_GT_AMP] = ACTIONS(2073),
    [anon_sym_LT_LT] = ACTIONS(2075),
    [anon_sym_LT_LT_DASH] = ACTIONS(2073),
    [anon_sym_LT_LT_LT] = ACTIONS(2073),
    [anon_sym_BQUOTE] = ACTIONS(2073),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2075),
  },
  [504] = {
    [anon_sym_SEMI] = ACTIONS(1219),
    [anon_sym_SEMI_SEMI] = ACTIONS(1217),
    [anon_sym_RBRACE] = ACTIONS(1217),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1217),
    [anon_sym_AMP] = ACTIONS(1217),
  },
  [505] = {
    [sym_simple_expansion] = STATE(1121),
    [sym_expansion] = STATE(1121),
    [sym_command_substitution] = STATE(1121),
    [aux_sym_heredoc_body_repeat1] = STATE(1121),
    [sym__heredoc_body_middle] = ACTIONS(2077),
    [sym__heredoc_body_end] = ACTIONS(2079),
    [anon_sym_DOLLAR] = ACTIONS(1225),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1227),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1229),
    [anon_sym_BQUOTE] = ACTIONS(1231),
    [sym_comment] = ACTIONS(57),
  },
  [506] = {
    [anon_sym_LT] = ACTIONS(2081),
    [anon_sym_GT] = ACTIONS(2081),
    [anon_sym_GT_GT] = ACTIONS(2083),
    [anon_sym_AMP_GT] = ACTIONS(2081),
    [anon_sym_AMP_GT_GT] = ACTIONS(2083),
    [anon_sym_LT_AMP] = ACTIONS(2083),
    [anon_sym_GT_AMP] = ACTIONS(2083),
    [sym_comment] = ACTIONS(57),
  },
  [507] = {
    [sym_file_descriptor] = ACTIONS(1237),
    [sym_variable_name] = ACTIONS(1237),
    [anon_sym_for] = ACTIONS(1241),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1237),
    [anon_sym_while] = ACTIONS(1241),
    [anon_sym_if] = ACTIONS(1241),
    [anon_sym_case] = ACTIONS(1241),
    [anon_sym_function] = ACTIONS(1241),
    [anon_sym_LPAREN] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1237),
    [anon_sym_RBRACE] = ACTIONS(1239),
    [anon_sym_BANG] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(1241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1237),
    [anon_sym_declare] = ACTIONS(1241),
    [anon_sym_typeset] = ACTIONS(1241),
    [anon_sym_export] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_local] = ACTIONS(1241),
    [anon_sym_unset] = ACTIONS(1241),
    [anon_sym_unsetenv] = ACTIONS(1241),
    [anon_sym_LT] = ACTIONS(1241),
    [anon_sym_GT] = ACTIONS(1241),
    [anon_sym_GT_GT] = ACTIONS(1237),
    [anon_sym_AMP_GT] = ACTIONS(1241),
    [anon_sym_AMP_GT_GT] = ACTIONS(1237),
    [anon_sym_LT_AMP] = ACTIONS(1237),
    [anon_sym_GT_AMP] = ACTIONS(1237),
    [anon_sym_DOLLAR] = ACTIONS(1241),
    [sym__special_character] = ACTIONS(1241),
    [anon_sym_DQUOTE] = ACTIONS(1237),
    [sym_raw_string] = ACTIONS(1237),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1237),
    [anon_sym_BQUOTE] = ACTIONS(1237),
    [anon_sym_LT_LPAREN] = ACTIONS(1237),
    [anon_sym_GT_LPAREN] = ACTIONS(1237),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1241),
  },
  [508] = {
    [sym_redirected_statement] = STATE(1123),
    [sym_for_statement] = STATE(1123),
    [sym_c_style_for_statement] = STATE(1123),
    [sym_while_statement] = STATE(1123),
    [sym_if_statement] = STATE(1123),
    [sym_case_statement] = STATE(1123),
    [sym_function_definition] = STATE(1123),
    [sym_compound_statement] = STATE(1123),
    [sym_subshell] = STATE(1123),
    [sym_pipeline] = STATE(1123),
    [sym_list] = STATE(1123),
    [sym_negated_command] = STATE(1123),
    [sym_test_command] = STATE(1123),
    [sym_declaration_command] = STATE(1123),
    [sym_unset_command] = STATE(1123),
    [sym_command] = STATE(1123),
    [sym_command_name] = STATE(138),
    [sym_variable_assignment] = STATE(1124),
    [sym_subscript] = STATE(140),
    [sym_file_redirect] = STATE(143),
    [sym_concatenation] = STATE(141),
    [sym_string] = STATE(130),
    [sym_simple_expansion] = STATE(130),
    [sym_string_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [sym_process_substitution] = STATE(130),
    [aux_sym_command_repeat1] = STATE(143),
    [aux_sym__literal_repeat1] = STATE(144),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(179),
    [anon_sym_while] = ACTIONS(181),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_case] = ACTIONS(185),
    [anon_sym_function] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_LBRACE] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(199),
    [anon_sym_declare] = ACTIONS(201),
    [anon_sym_typeset] = ACTIONS(201),
    [anon_sym_export] = ACTIONS(201),
    [anon_sym_readonly] = ACTIONS(201),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_unset] = ACTIONS(203),
    [anon_sym_unsetenv] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(205),
    [sym__special_character] = ACTIONS(207),
    [anon_sym_DQUOTE] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(221),
  },
  [509] = {
    [sym_redirected_statement] = STATE(1125),
    [sym_for_statement] = STATE(1125),
    [sym_c_style_for_statement] = STATE(1125),
    [sym_while_statement] = STATE(1125),
    [sym_if_statement] = STATE(1125),
    [sym_case_statement] = STATE(1125),
    [sym_function_definition] = STATE(1125),
    [sym_compound_statement] = STATE(1125),
    [sym_subshell] = STATE(1125),
    [sym_pipeline] = STATE(1125),
    [sym_list] = STATE(1125),
    [sym_negated_command] = STATE(1125),
    [sym_test_command] = STATE(1125),
    [sym_declaration_command] = STATE(1125),
    [sym_unset_command] = STATE(1125),
    [sym_command] = STATE(1125),
    [sym_command_name] = STATE(138),
    [sym_variable_assignment] = STATE(1126),
    [sym_subscript] = STATE(140),
    [sym_file_redirect] = STATE(143),
    [sym_concatenation] = STATE(141),
    [sym_string] = STATE(130),
    [sym_simple_expansion] = STATE(130),
    [sym_string_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [sym_process_substitution] = STATE(130),
    [aux_sym_command_repeat1] = STATE(143),
    [aux_sym__literal_repeat1] = STATE(144),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(179),
    [anon_sym_while] = ACTIONS(181),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_case] = ACTIONS(185),
    [anon_sym_function] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_LBRACE] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(199),
    [anon_sym_declare] = ACTIONS(201),
    [anon_sym_typeset] = ACTIONS(201),
    [anon_sym_export] = ACTIONS(201),
    [anon_sym_readonly] = ACTIONS(201),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_unset] = ACTIONS(203),
    [anon_sym_unsetenv] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(205),
    [sym__special_character] = ACTIONS(207),
    [anon_sym_DQUOTE] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(221),
  },
  [510] = {
    [sym_concatenation] = STATE(1129),
    [sym_string] = STATE(1128),
    [sym_simple_expansion] = STATE(1128),
    [sym_string_expansion] = STATE(1128),
    [sym_expansion] = STATE(1128),
    [sym_command_substitution] = STATE(1128),
    [sym_process_substitution] = STATE(1128),
    [aux_sym__literal_repeat1] = STATE(1130),
    [anon_sym_DOLLAR] = ACTIONS(205),
    [sym__special_character] = ACTIONS(2085),
    [anon_sym_DQUOTE] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(2087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2087),
  },
  [511] = {
    [sym_heredoc_start] = ACTIONS(2089),
    [sym_comment] = ACTIONS(57),
  },
  [512] = {
    [sym_concatenation] = STATE(1133),
    [sym_string] = STATE(1132),
    [sym_simple_expansion] = STATE(1132),
    [sym_string_expansion] = STATE(1132),
    [sym_expansion] = STATE(1132),
    [sym_command_substitution] = STATE(1132),
    [sym_process_substitution] = STATE(1132),
    [aux_sym__literal_repeat1] = STATE(1134),
    [anon_sym_DOLLAR] = ACTIONS(205),
    [sym__special_character] = ACTIONS(2085),
    [anon_sym_DQUOTE] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(2091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2091),
  },
  [513] = {
    [anon_sym_SEMI] = ACTIONS(2093),
    [anon_sym_SEMI_SEMI] = ACTIONS(2095),
    [anon_sym_RBRACE] = ACTIONS(1239),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2095),
    [anon_sym_AMP] = ACTIONS(2095),
  },
  [514] = {
    [sym_file_redirect] = STATE(1136),
    [sym_heredoc_redirect] = STATE(1136),
    [sym_herestring_redirect] = STATE(1136),
    [aux_sym_redirected_statement_repeat1] = STATE(1136),
    [sym__simple_heredoc_body] = ACTIONS(1255),
    [sym__heredoc_body_beginning] = ACTIONS(1255),
    [sym_file_descriptor] = ACTIONS(861),
    [anon_sym_SEMI] = ACTIONS(1257),
    [anon_sym_PIPE] = ACTIONS(1257),
    [anon_sym_SEMI_SEMI] = ACTIONS(1255),
    [anon_sym_RBRACE] = ACTIONS(1255),
    [anon_sym_PIPE_AMP] = ACTIONS(1255),
    [anon_sym_AMP_AMP] = ACTIONS(1255),
    [anon_sym_PIPE_PIPE] = ACTIONS(1255),
    [anon_sym_LT] = ACTIONS(873),
    [anon_sym_GT] = ACTIONS(873),
    [anon_sym_GT_GT] = ACTIONS(875),
    [anon_sym_AMP_GT] = ACTIONS(873),
    [anon_sym_AMP_GT_GT] = ACTIONS(875),
    [anon_sym_LT_AMP] = ACTIONS(875),
    [anon_sym_GT_AMP] = ACTIONS(875),
    [anon_sym_LT_LT] = ACTIONS(877),
    [anon_sym_LT_LT_DASH] = ACTIONS(879),
    [anon_sym_LT_LT_LT] = ACTIONS(881),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1257),
  },
  [515] = {
    [sym_concatenation] = STATE(1137),
    [sym_string] = STATE(1138),
    [sym_simple_expansion] = STATE(1138),
    [sym_string_expansion] = STATE(1138),
    [sym_expansion] = STATE(1138),
    [sym_command_substitution] = STATE(1138),
    [sym_process_substitution] = STATE(1138),
    [aux_sym__literal_repeat1] = STATE(1139),
    [sym_regex] = ACTIONS(2097),
    [anon_sym_DOLLAR] = ACTIONS(205),
    [sym__special_character] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(2099),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2099),
  },
  [516] = {
    [aux_sym_concatenation_repeat1] = STATE(490),
    [sym__simple_heredoc_body] = ACTIONS(1263),
    [sym__heredoc_body_beginning] = ACTIONS(1263),
    [sym_file_descriptor] = ACTIONS(1263),
    [sym__concat] = ACTIONS(837),
    [anon_sym_SEMI] = ACTIONS(1265),
    [anon_sym_PIPE] = ACTIONS(1265),
    [anon_sym_SEMI_SEMI] = ACTIONS(1263),
    [anon_sym_RBRACE] = ACTIONS(1263),
    [anon_sym_PIPE_AMP] = ACTIONS(1263),
    [anon_sym_AMP_AMP] = ACTIONS(1263),
    [anon_sym_PIPE_PIPE] = ACTIONS(1263),
    [anon_sym_EQ_TILDE] = ACTIONS(1265),
    [anon_sym_EQ_EQ] = ACTIONS(1265),
    [anon_sym_LT] = ACTIONS(1265),
    [anon_sym_GT] = ACTIONS(1265),
    [anon_sym_GT_GT] = ACTIONS(1263),
    [anon_sym_AMP_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT_GT] = ACTIONS(1263),
    [anon_sym_LT_AMP] = ACTIONS(1263),
    [anon_sym_GT_AMP] = ACTIONS(1263),
    [anon_sym_LT_LT] = ACTIONS(1265),
    [anon_sym_LT_LT_DASH] = ACTIONS(1263),
    [anon_sym_LT_LT_LT] = ACTIONS(1263),
    [anon_sym_DOLLAR] = ACTIONS(1265),
    [sym__special_character] = ACTIONS(1265),
    [anon_sym_DQUOTE] = ACTIONS(1263),
    [sym_raw_string] = ACTIONS(1263),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1263),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1263),
    [anon_sym_BQUOTE] = ACTIONS(1263),
    [anon_sym_LT_LPAREN] = ACTIONS(1263),
    [anon_sym_GT_LPAREN] = ACTIONS(1263),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1265),
    [anon_sym_LF] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1265),
  },
  [517] = {
    [sym_concatenation] = STATE(1140),
    [sym_string] = STATE(516),
    [sym_simple_expansion] = STATE(516),
    [sym_string_expansion] = STATE(516),
    [sym_expansion] = STATE(516),
    [sym_command_substitution] = STATE(516),
    [sym_process_substitution] = STATE(516),
    [aux_sym_command_repeat2] = STATE(1140),
    [aux_sym__literal_repeat1] = STATE(518),
    [sym__simple_heredoc_body] = ACTIONS(1267),
    [sym__heredoc_body_beginning] = ACTIONS(1267),
    [sym_file_descriptor] = ACTIONS(1267),
    [anon_sym_SEMI] = ACTIONS(1269),
    [anon_sym_PIPE] = ACTIONS(1269),
    [anon_sym_SEMI_SEMI] = ACTIONS(1267),
    [anon_sym_RBRACE] = ACTIONS(1267),
    [anon_sym_PIPE_AMP] = ACTIONS(1267),
    [anon_sym_AMP_AMP] = ACTIONS(1267),
    [anon_sym_PIPE_PIPE] = ACTIONS(1267),
    [anon_sym_EQ_TILDE] = ACTIONS(883),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1269),
    [anon_sym_GT_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT_GT] = ACTIONS(1267),
    [anon_sym_LT_AMP] = ACTIONS(1267),
    [anon_sym_GT_AMP] = ACTIONS(1267),
    [anon_sym_LT_LT] = ACTIONS(1269),
    [anon_sym_LT_LT_DASH] = ACTIONS(1267),
    [anon_sym_LT_LT_LT] = ACTIONS(1267),
    [anon_sym_DOLLAR] = ACTIONS(205),
    [sym__special_character] = ACTIONS(207),
    [anon_sym_DQUOTE] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(885),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(887),
    [anon_sym_LF] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(1269),
  },
  [518] = {
    [aux_sym__literal_repeat1] = STATE(523),
    [sym__simple_heredoc_body] = ACTIONS(1271),
    [sym__heredoc_body_beginning] = ACTIONS(1271),
    [sym_file_descriptor] = ACTIONS(1271),
    [anon_sym_SEMI] = ACTIONS(1273),
    [anon_sym_PIPE] = ACTIONS(1273),
    [anon_sym_SEMI_SEMI] = ACTIONS(1271),
    [anon_sym_RBRACE] = ACTIONS(1271),
    [anon_sym_PIPE_AMP] = ACTIONS(1271),
    [anon_sym_AMP_AMP] = ACTIONS(1271),
    [anon_sym_PIPE_PIPE] = ACTIONS(1271),
    [anon_sym_EQ_TILDE] = ACTIONS(1273),
    [anon_sym_EQ_EQ] = ACTIONS(1273),
    [anon_sym_LT] = ACTIONS(1273),
    [anon_sym_GT] = ACTIONS(1273),
    [anon_sym_GT_GT] = ACTIONS(1271),
    [anon_sym_AMP_GT] = ACTIONS(1273),
    [anon_sym_AMP_GT_GT] = ACTIONS(1271),
    [anon_sym_LT_AMP] = ACTIONS(1271),
    [anon_sym_GT_AMP] = ACTIONS(1271),
    [anon_sym_LT_LT] = ACTIONS(1273),
    [anon_sym_LT_LT_DASH] = ACTIONS(1271),
    [anon_sym_LT_LT_LT] = ACTIONS(1271),
    [anon_sym_DOLLAR] = ACTIONS(1273),
    [sym__special_character] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [sym_raw_string] = ACTIONS(1271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1271),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1271),
    [anon_sym_BQUOTE] = ACTIONS(1271),
    [anon_sym_LT_LPAREN] = ACTIONS(1271),
    [anon_sym_GT_LPAREN] = ACTIONS(1271),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1273),
    [anon_sym_LF] = ACTIONS(1271),
    [anon_sym_AMP] = ACTIONS(1273),
  },
  [519] = {
    [sym_file_redirect] = STATE(514),
    [sym_heredoc_redirect] = STATE(514),
    [sym_heredoc_body] = STATE(1142),
    [sym_herestring_redirect] = STATE(514),
    [aux_sym_redirected_statement_repeat1] = STATE(514),
    [sym__simple_heredoc_body] = ACTIONS(857),
    [sym__heredoc_body_beginning] = ACTIONS(859),
    [sym_file_descriptor] = ACTIONS(861),
    [anon_sym_SEMI] = ACTIONS(2101),
    [anon_sym_PIPE] = ACTIONS(865),
    [anon_sym_SEMI_SEMI] = ACTIONS(2103),
    [anon_sym_RBRACE] = ACTIONS(1239),
    [anon_sym_PIPE_AMP] = ACTIONS(869),
    [anon_sym_AMP_AMP] = ACTIONS(871),
    [anon_sym_PIPE_PIPE] = ACTIONS(871),
    [anon_sym_LT] = ACTIONS(873),
    [anon_sym_GT] = ACTIONS(873),
    [anon_sym_GT_GT] = ACTIONS(875),
    [anon_sym_AMP_GT] = ACTIONS(873),
    [anon_sym_AMP_GT_GT] = ACTIONS(875),
    [anon_sym_LT_AMP] = ACTIONS(875),
    [anon_sym_GT_AMP] = ACTIONS(875),
    [anon_sym_LT_LT] = ACTIONS(877),
    [anon_sym_LT_LT_DASH] = ACTIONS(879),
    [anon_sym_LT_LT_LT] = ACTIONS(881),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2103),
    [anon_sym_AMP] = ACTIONS(2101),
  },
  [520] = {
    [sym_file_redirect] = STATE(514),
    [sym_heredoc_redirect] = STATE(514),
    [sym_heredoc_body] = STATE(1142),
    [sym_herestring_redirect] = STATE(514),
    [aux_sym_redirected_statement_repeat1] = STATE(514),
    [sym__simple_heredoc_body] = ACTIONS(857),
    [sym__heredoc_body_beginning] = ACTIONS(859),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2101),
    [anon_sym_PIPE] = ACTIONS(865),
    [anon_sym_SEMI_SEMI] = ACTIONS(2103),
    [anon_sym_RBRACE] = ACTIONS(1239),
    [anon_sym_PIPE_AMP] = ACTIONS(869),
    [anon_sym_AMP_AMP] = ACTIONS(871),
    [anon_sym_PIPE_PIPE] = ACTIONS(871),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(877),
    [anon_sym_LT_LT_DASH] = ACTIONS(879),
    [anon_sym_LT_LT_LT] = ACTIONS(881),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(435),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2103),
    [anon_sym_AMP] = ACTIONS(2101),
  },
  [521] = {
    [sym_concatenation] = STATE(1143),
    [sym_string] = STATE(516),
    [sym_simple_expansion] = STATE(516),
    [sym_string_expansion] = STATE(516),
    [sym_expansion] = STATE(516),
    [sym_command_substitution] = STATE(516),
    [sym_process_substitution] = STATE(516),
    [aux_sym_command_repeat2] = STATE(1143),
    [aux_sym__literal_repeat1] = STATE(518),
    [sym__simple_heredoc_body] = ACTIONS(1267),
    [sym__heredoc_body_beginning] = ACTIONS(1267),
    [sym_file_descriptor] = ACTIONS(1267),
    [anon_sym_SEMI] = ACTIONS(1269),
    [anon_sym_PIPE] = ACTIONS(1269),
    [anon_sym_SEMI_SEMI] = ACTIONS(1267),
    [anon_sym_RBRACE] = ACTIONS(1267),
    [anon_sym_PIPE_AMP] = ACTIONS(1267),
    [anon_sym_AMP_AMP] = ACTIONS(1267),
    [anon_sym_PIPE_PIPE] = ACTIONS(1267),
    [anon_sym_EQ_TILDE] = ACTIONS(883),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1269),
    [anon_sym_GT_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT_GT] = ACTIONS(1267),
    [anon_sym_LT_AMP] = ACTIONS(1267),
    [anon_sym_GT_AMP] = ACTIONS(1267),
    [anon_sym_LT_LT] = ACTIONS(1269),
    [anon_sym_LT_LT_DASH] = ACTIONS(1267),
    [anon_sym_LT_LT_LT] = ACTIONS(1267),
    [anon_sym_DOLLAR] = ACTIONS(205),
    [sym__special_character] = ACTIONS(207),
    [anon_sym_DQUOTE] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(885),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(887),
    [anon_sym_LF] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(1269),
  },
  [522] = {
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_RBRACE] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_EQ_TILDE] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [523] = {
    [aux_sym__literal_repeat1] = STATE(523),
    [sym__simple_heredoc_body] = ACTIONS(1373),
    [sym__heredoc_body_beginning] = ACTIONS(1373),
    [sym_file_descriptor] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_RBRACE] = ACTIONS(1373),
    [anon_sym_PIPE_AMP] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_EQ_TILDE] = ACTIONS(1375),
    [anon_sym_EQ_EQ] = ACTIONS(1375),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_LT_LT_DASH] = ACTIONS(1373),
    [anon_sym_LT_LT_LT] = ACTIONS(1373),
    [anon_sym_DOLLAR] = ACTIONS(1375),
    [sym__special_character] = ACTIONS(2105),
    [anon_sym_DQUOTE] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1373),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [anon_sym_LT_LPAREN] = ACTIONS(1373),
    [anon_sym_GT_LPAREN] = ACTIONS(1373),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1375),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
  },
  [524] = {
    [sym_concatenation] = STATE(1144),
    [sym_string] = STATE(1146),
    [sym_array] = STATE(1144),
    [sym_simple_expansion] = STATE(1146),
    [sym_string_expansion] = STATE(1146),
    [sym_expansion] = STATE(1146),
    [sym_command_substitution] = STATE(1146),
    [sym_process_substitution] = STATE(1146),
    [aux_sym__literal_repeat1] = STATE(1147),
    [sym__empty_value] = ACTIONS(2108),
    [anon_sym_LPAREN] = ACTIONS(2110),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [sym__special_character] = ACTIONS(311),
    [anon_sym_DQUOTE] = ACTIONS(313),
    [sym_raw_string] = ACTIONS(2112),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(317),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(319),
    [anon_sym_BQUOTE] = ACTIONS(321),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2112),
  },
  [525] = {
    [anon_sym_RPAREN] = ACTIONS(2114),
    [anon_sym_AMP_AMP] = ACTIONS(1536),
    [anon_sym_PIPE_PIPE] = ACTIONS(1536),
    [anon_sym_EQ_TILDE] = ACTIONS(1538),
    [anon_sym_EQ_EQ] = ACTIONS(1538),
    [anon_sym_EQ] = ACTIONS(1540),
    [anon_sym_PLUS_EQ] = ACTIONS(1536),
    [anon_sym_LT] = ACTIONS(1540),
    [anon_sym_GT] = ACTIONS(1540),
    [anon_sym_BANG_EQ] = ACTIONS(1536),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_DASH_EQ] = ACTIONS(1536),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_PLUS_PLUS] = ACTIONS(1542),
    [anon_sym_DASH_DASH] = ACTIONS(1542),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1536),
  },
  [526] = {
    [anon_sym_AMP_AMP] = ACTIONS(923),
    [anon_sym_PIPE_PIPE] = ACTIONS(923),
    [anon_sym_RBRACK] = ACTIONS(1546),
    [anon_sym_EQ_TILDE] = ACTIONS(925),
    [anon_sym_EQ_EQ] = ACTIONS(925),
    [anon_sym_EQ] = ACTIONS(927),
    [anon_sym_PLUS_EQ] = ACTIONS(923),
    [anon_sym_LT] = ACTIONS(927),
    [anon_sym_GT] = ACTIONS(927),
    [anon_sym_BANG_EQ] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(927),
    [anon_sym_DASH_EQ] = ACTIONS(923),
    [anon_sym_LT_EQ] = ACTIONS(923),
    [anon_sym_GT_EQ] = ACTIONS(923),
    [anon_sym_PLUS_PLUS] = ACTIONS(929),
    [anon_sym_DASH_DASH] = ACTIONS(929),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(923),
  },
  [527] = {
    [sym__concat] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_RBRACK] = ACTIONS(1057),
    [anon_sym_EQ_TILDE] = ACTIONS(1057),
    [anon_sym_EQ_EQ] = ACTIONS(1057),
    [anon_sym_EQ] = ACTIONS(1059),
    [anon_sym_PLUS_EQ] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_BANG_EQ] = ACTIONS(1057),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_DASH_EQ] = ACTIONS(1057),
    [anon_sym_LT_EQ] = ACTIONS(1057),
    [anon_sym_GT_EQ] = ACTIONS(1057),
    [anon_sym_PLUS_PLUS] = ACTIONS(1057),
    [anon_sym_DASH_DASH] = ACTIONS(1057),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1057),
  },
  [528] = {
    [sym__concat] = ACTIONS(1061),
    [anon_sym_AMP_AMP] = ACTIONS(1061),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_RBRACK] = ACTIONS(1061),
    [anon_sym_EQ_TILDE] = ACTIONS(1061),
    [anon_sym_EQ_EQ] = ACTIONS(1061),
    [anon_sym_EQ] = ACTIONS(1063),
    [anon_sym_PLUS_EQ] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1063),
    [anon_sym_BANG_EQ] = ACTIONS(1061),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_DASH] = ACTIONS(1063),
    [anon_sym_DASH_EQ] = ACTIONS(1061),
    [anon_sym_LT_EQ] = ACTIONS(1061),
    [anon_sym_GT_EQ] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1061),
  },
  [529] = {
    [sym__concat] = ACTIONS(1065),
    [anon_sym_AMP_AMP] = ACTIONS(1065),
    [anon_sym_PIPE_PIPE] = ACTIONS(1065),
    [anon_sym_RBRACK] = ACTIONS(1065),
    [anon_sym_EQ_TILDE] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(1067),
    [anon_sym_PLUS_EQ] = ACTIONS(1065),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_GT] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DASH_EQ] = ACTIONS(1065),
    [anon_sym_LT_EQ] = ACTIONS(1065),
    [anon_sym_GT_EQ] = ACTIONS(1065),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1065),
  },
  [530] = {
    [sym_string] = STATE(1149),
    [sym_simple_expansion] = STATE(1149),
    [sym_string_expansion] = STATE(1149),
    [sym_expansion] = STATE(1149),
    [sym_command_substitution] = STATE(1149),
    [sym_process_substitution] = STATE(1149),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__special_character] = ACTIONS(2116),
    [anon_sym_DQUOTE] = ACTIONS(233),
    [sym_raw_string] = ACTIONS(2116),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [anon_sym_LT_LPAREN] = ACTIONS(243),
    [anon_sym_GT_LPAREN] = ACTIONS(243),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2116),
  },
  [531] = {
    [aux_sym_concatenation_repeat1] = STATE(1151),
    [sym__concat] = ACTIONS(2118),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_RBRACK] = ACTIONS(1071),
    [anon_sym_EQ_TILDE] = ACTIONS(1071),
    [anon_sym_EQ_EQ] = ACTIONS(1071),
    [anon_sym_EQ] = ACTIONS(1075),
    [anon_sym_PLUS_EQ] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_BANG_EQ] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(1075),
    [anon_sym_DASH] = ACTIONS(1075),
    [anon_sym_DASH_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_PLUS_PLUS] = ACTIONS(1071),
    [anon_sym_DASH_DASH] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1071),
  },
  [532] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(2120),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [533] = {
    [sym__concat] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_RBRACK] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_EQ_EQ] = ACTIONS(1089),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_DASH] = ACTIONS(1091),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1089),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_PLUS_PLUS] = ACTIONS(1089),
    [anon_sym_DASH_DASH] = ACTIONS(1089),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1089),
  },
  [534] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(627),
    [anon_sym_DOLLAR] = ACTIONS(2122),
    [anon_sym_DQUOTE] = ACTIONS(2120),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [535] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(2124),
    [sym_comment] = ACTIONS(57),
  },
  [536] = {
    [sym_subscript] = STATE(1157),
    [sym_variable_name] = ACTIONS(2126),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_DOLLAR] = ACTIONS(2128),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2130),
    [anon_sym_STAR] = ACTIONS(2132),
    [anon_sym_AT] = ACTIONS(2132),
    [anon_sym_QMARK] = ACTIONS(2132),
    [anon_sym_0] = ACTIONS(2130),
    [anon_sym__] = ACTIONS(2130),
  },
  [537] = {
    [sym_concatenation] = STATE(1160),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1160),
    [anon_sym_RBRACE] = ACTIONS(2134),
    [anon_sym_EQ] = ACTIONS(2136),
    [anon_sym_DASH] = ACTIONS(2136),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2138),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(2140),
    [anon_sym_COLON] = ACTIONS(2136),
    [anon_sym_COLON_QMARK] = ACTIONS(2136),
    [anon_sym_COLON_DASH] = ACTIONS(2136),
    [anon_sym_PERCENT] = ACTIONS(2136),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [538] = {
    [sym_concatenation] = STATE(1163),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1163),
    [anon_sym_RBRACE] = ACTIONS(2142),
    [anon_sym_EQ] = ACTIONS(2144),
    [anon_sym_DASH] = ACTIONS(2144),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2146),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(2148),
    [anon_sym_COLON] = ACTIONS(2144),
    [anon_sym_COLON_QMARK] = ACTIONS(2144),
    [anon_sym_COLON_DASH] = ACTIONS(2144),
    [anon_sym_PERCENT] = ACTIONS(2144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [539] = {
    [anon_sym_RPAREN] = ACTIONS(2150),
    [sym_comment] = ACTIONS(57),
  },
  [540] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(2150),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [541] = {
    [anon_sym_BQUOTE] = ACTIONS(2150),
    [sym_comment] = ACTIONS(57),
  },
  [542] = {
    [anon_sym_RPAREN] = ACTIONS(2152),
    [sym_comment] = ACTIONS(57),
  },
  [543] = {
    [sym__expression] = STATE(1166),
    [sym_binary_expression] = STATE(1166),
    [sym_unary_expression] = STATE(1166),
    [sym_postfix_expression] = STATE(1166),
    [sym_parenthesized_expression] = STATE(1166),
    [sym_concatenation] = STATE(1166),
    [sym_string] = STATE(153),
    [sym_simple_expansion] = STATE(153),
    [sym_string_expansion] = STATE(153),
    [sym_expansion] = STATE(153),
    [sym_command_substitution] = STATE(153),
    [sym_process_substitution] = STATE(153),
    [aux_sym__literal_repeat1] = STATE(159),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_BANG] = ACTIONS(227),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__special_character] = ACTIONS(231),
    [anon_sym_DQUOTE] = ACTIONS(233),
    [sym_raw_string] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [anon_sym_LT_LPAREN] = ACTIONS(243),
    [anon_sym_GT_LPAREN] = ACTIONS(243),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(245),
    [sym_test_operator] = ACTIONS(247),
  },
  [544] = {
    [sym__expression] = STATE(1166),
    [sym_binary_expression] = STATE(1166),
    [sym_unary_expression] = STATE(1166),
    [sym_postfix_expression] = STATE(1166),
    [sym_parenthesized_expression] = STATE(1166),
    [sym_concatenation] = STATE(1166),
    [sym_string] = STATE(153),
    [sym_simple_expansion] = STATE(153),
    [sym_string_expansion] = STATE(153),
    [sym_expansion] = STATE(153),
    [sym_command_substitution] = STATE(153),
    [sym_process_substitution] = STATE(153),
    [aux_sym__literal_repeat1] = STATE(159),
    [sym_regex] = ACTIONS(2154),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_BANG] = ACTIONS(227),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__special_character] = ACTIONS(231),
    [anon_sym_DQUOTE] = ACTIONS(233),
    [sym_raw_string] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [anon_sym_LT_LPAREN] = ACTIONS(243),
    [anon_sym_GT_LPAREN] = ACTIONS(243),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(245),
    [sym_test_operator] = ACTIONS(247),
  },
  [545] = {
    [anon_sym_AMP_AMP] = ACTIONS(1592),
    [anon_sym_PIPE_PIPE] = ACTIONS(1592),
    [anon_sym_RBRACK] = ACTIONS(1592),
    [anon_sym_EQ_TILDE] = ACTIONS(1592),
    [anon_sym_EQ_EQ] = ACTIONS(1592),
    [anon_sym_EQ] = ACTIONS(1594),
    [anon_sym_PLUS_EQ] = ACTIONS(1592),
    [anon_sym_LT] = ACTIONS(1594),
    [anon_sym_GT] = ACTIONS(1594),
    [anon_sym_BANG_EQ] = ACTIONS(1592),
    [anon_sym_PLUS] = ACTIONS(1594),
    [anon_sym_DASH] = ACTIONS(1594),
    [anon_sym_DASH_EQ] = ACTIONS(1592),
    [anon_sym_LT_EQ] = ACTIONS(1592),
    [anon_sym_GT_EQ] = ACTIONS(1592),
    [anon_sym_PLUS_PLUS] = ACTIONS(1592),
    [anon_sym_DASH_DASH] = ACTIONS(1592),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1592),
  },
  [546] = {
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_RBRACK] = ACTIONS(335),
    [anon_sym_EQ_TILDE] = ACTIONS(335),
    [anon_sym_EQ_EQ] = ACTIONS(335),
    [anon_sym_EQ] = ACTIONS(339),
    [anon_sym_PLUS_EQ] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(335),
    [anon_sym_PLUS] = ACTIONS(339),
    [anon_sym_DASH] = ACTIONS(339),
    [anon_sym_DASH_EQ] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(335),
    [anon_sym_GT_EQ] = ACTIONS(335),
    [anon_sym_PLUS_PLUS] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(335),
    [sym__special_character] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(335),
  },
  [547] = {
    [aux_sym__literal_repeat1] = STATE(547),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_RBRACK] = ACTIONS(1373),
    [anon_sym_EQ_TILDE] = ACTIONS(1373),
    [anon_sym_EQ_EQ] = ACTIONS(1373),
    [anon_sym_EQ] = ACTIONS(1375),
    [anon_sym_PLUS_EQ] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_BANG_EQ] = ACTIONS(1373),
    [anon_sym_PLUS] = ACTIONS(1375),
    [anon_sym_DASH] = ACTIONS(1375),
    [anon_sym_DASH_EQ] = ACTIONS(1373),
    [anon_sym_LT_EQ] = ACTIONS(1373),
    [anon_sym_GT_EQ] = ACTIONS(1373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1373),
    [anon_sym_DASH_DASH] = ACTIONS(1373),
    [sym__special_character] = ACTIONS(2156),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1373),
  },
  [548] = {
    [anon_sym_AMP_AMP] = ACTIONS(933),
    [anon_sym_PIPE_PIPE] = ACTIONS(933),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1546),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(935),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_PLUS_EQ] = ACTIONS(933),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(933),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_DASH] = ACTIONS(937),
    [anon_sym_DASH_EQ] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(933),
    [anon_sym_GT_EQ] = ACTIONS(933),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(933),
  },
  [549] = {
    [aux_sym_concatenation_repeat1] = STATE(1168),
    [sym__concat] = ACTIONS(1550),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1071),
    [anon_sym_EQ_TILDE] = ACTIONS(1071),
    [anon_sym_EQ_EQ] = ACTIONS(1071),
    [anon_sym_EQ] = ACTIONS(1075),
    [anon_sym_PLUS_EQ] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_BANG_EQ] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(1075),
    [anon_sym_DASH] = ACTIONS(1075),
    [anon_sym_DASH_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_PLUS_PLUS] = ACTIONS(1071),
    [anon_sym_DASH_DASH] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1071),
  },
  [550] = {
    [sym__expression] = STATE(833),
    [sym_binary_expression] = STATE(833),
    [sym_unary_expression] = STATE(833),
    [sym_postfix_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_concatenation] = STATE(833),
    [sym_string] = STATE(162),
    [sym_simple_expansion] = STATE(162),
    [sym_string_expansion] = STATE(162),
    [sym_expansion] = STATE(162),
    [sym_command_substitution] = STATE(162),
    [sym_process_substitution] = STATE(162),
    [aux_sym__literal_repeat1] = STATE(164),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(249),
    [anon_sym_DOLLAR] = ACTIONS(77),
    [sym__special_character] = ACTIONS(251),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(255),
    [sym_test_operator] = ACTIONS(257),
  },
  [551] = {
    [sym__expression] = STATE(833),
    [sym_binary_expression] = STATE(833),
    [sym_unary_expression] = STATE(833),
    [sym_postfix_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_concatenation] = STATE(833),
    [sym_string] = STATE(162),
    [sym_simple_expansion] = STATE(162),
    [sym_string_expansion] = STATE(162),
    [sym_expansion] = STATE(162),
    [sym_command_substitution] = STATE(162),
    [sym_process_substitution] = STATE(162),
    [aux_sym__literal_repeat1] = STATE(164),
    [sym_regex] = ACTIONS(1590),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(249),
    [anon_sym_DOLLAR] = ACTIONS(77),
    [sym__special_character] = ACTIONS(251),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(255),
    [sym_test_operator] = ACTIONS(257),
  },
  [552] = {
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(335),
    [anon_sym_EQ_TILDE] = ACTIONS(335),
    [anon_sym_EQ_EQ] = ACTIONS(335),
    [anon_sym_EQ] = ACTIONS(339),
    [anon_sym_PLUS_EQ] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(335),
    [anon_sym_PLUS] = ACTIONS(339),
    [anon_sym_DASH] = ACTIONS(339),
    [anon_sym_DASH_EQ] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(335),
    [anon_sym_GT_EQ] = ACTIONS(335),
    [anon_sym_PLUS_PLUS] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(335),
    [sym__special_character] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(335),
  },
  [553] = {
    [aux_sym__literal_repeat1] = STATE(553),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1373),
    [anon_sym_EQ_TILDE] = ACTIONS(1373),
    [anon_sym_EQ_EQ] = ACTIONS(1373),
    [anon_sym_EQ] = ACTIONS(1375),
    [anon_sym_PLUS_EQ] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_BANG_EQ] = ACTIONS(1373),
    [anon_sym_PLUS] = ACTIONS(1375),
    [anon_sym_DASH] = ACTIONS(1375),
    [anon_sym_DASH_EQ] = ACTIONS(1373),
    [anon_sym_LT_EQ] = ACTIONS(1373),
    [anon_sym_GT_EQ] = ACTIONS(1373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1373),
    [anon_sym_DASH_DASH] = ACTIONS(1373),
    [sym__special_character] = ACTIONS(2159),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1373),
  },
  [554] = {
    [sym_concatenation] = STATE(1169),
    [sym_string] = STATE(1171),
    [sym_array] = STATE(1169),
    [sym_simple_expansion] = STATE(1171),
    [sym_string_expansion] = STATE(1171),
    [sym_expansion] = STATE(1171),
    [sym_command_substitution] = STATE(1171),
    [sym_process_substitution] = STATE(1171),
    [aux_sym__literal_repeat1] = STATE(1172),
    [sym__empty_value] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(2164),
    [anon_sym_DOLLAR] = ACTIONS(265),
    [sym__special_character] = ACTIONS(267),
    [anon_sym_DQUOTE] = ACTIONS(269),
    [sym_raw_string] = ACTIONS(2166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(277),
    [anon_sym_LT_LPAREN] = ACTIONS(279),
    [anon_sym_GT_LPAREN] = ACTIONS(279),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2166),
  },
  [555] = {
    [sym__simple_heredoc_body] = ACTIONS(1057),
    [sym__heredoc_body_beginning] = ACTIONS(1057),
    [sym_file_descriptor] = ACTIONS(1057),
    [sym__concat] = ACTIONS(1057),
    [sym_variable_name] = ACTIONS(1057),
    [ts_builtin_sym_end] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_RPAREN] = ACTIONS(1057),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_PIPE_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_AMP] = ACTIONS(1057),
    [anon_sym_GT_AMP] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_LT] = ACTIONS(1057),
    [anon_sym_DOLLAR] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [sym_raw_string] = ACTIONS(1057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1057),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1057),
    [anon_sym_BQUOTE] = ACTIONS(1057),
    [anon_sym_LT_LPAREN] = ACTIONS(1057),
    [anon_sym_GT_LPAREN] = ACTIONS(1057),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1059),
    [sym_word] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [556] = {
    [sym__simple_heredoc_body] = ACTIONS(1061),
    [sym__heredoc_body_beginning] = ACTIONS(1061),
    [sym_file_descriptor] = ACTIONS(1061),
    [sym__concat] = ACTIONS(1061),
    [sym_variable_name] = ACTIONS(1061),
    [ts_builtin_sym_end] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(1063),
    [anon_sym_PIPE] = ACTIONS(1063),
    [anon_sym_RPAREN] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE_AMP] = ACTIONS(1061),
    [anon_sym_AMP_AMP] = ACTIONS(1061),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1063),
    [anon_sym_GT_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT_GT] = ACTIONS(1061),
    [anon_sym_LT_AMP] = ACTIONS(1061),
    [anon_sym_GT_AMP] = ACTIONS(1061),
    [anon_sym_LT_LT] = ACTIONS(1063),
    [anon_sym_LT_LT_DASH] = ACTIONS(1061),
    [anon_sym_LT_LT_LT] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1061),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1061),
    [anon_sym_LT_LPAREN] = ACTIONS(1061),
    [anon_sym_GT_LPAREN] = ACTIONS(1061),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1063),
    [sym_word] = ACTIONS(1063),
    [anon_sym_LF] = ACTIONS(1061),
    [anon_sym_AMP] = ACTIONS(1063),
  },
  [557] = {
    [sym__simple_heredoc_body] = ACTIONS(1065),
    [sym__heredoc_body_beginning] = ACTIONS(1065),
    [sym_file_descriptor] = ACTIONS(1065),
    [sym__concat] = ACTIONS(1065),
    [sym_variable_name] = ACTIONS(1065),
    [ts_builtin_sym_end] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1067),
    [anon_sym_RPAREN] = ACTIONS(1065),
    [anon_sym_SEMI_SEMI] = ACTIONS(1065),
    [anon_sym_PIPE_AMP] = ACTIONS(1065),
    [anon_sym_AMP_AMP] = ACTIONS(1065),
    [anon_sym_PIPE_PIPE] = ACTIONS(1065),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_GT] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT] = ACTIONS(1067),
    [anon_sym_AMP_GT_GT] = ACTIONS(1065),
    [anon_sym_LT_AMP] = ACTIONS(1065),
    [anon_sym_GT_AMP] = ACTIONS(1065),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_LT_LT_DASH] = ACTIONS(1065),
    [anon_sym_LT_LT_LT] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1067),
    [sym__special_character] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LT_LPAREN] = ACTIONS(1065),
    [anon_sym_GT_LPAREN] = ACTIONS(1065),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1067),
    [sym_word] = ACTIONS(1067),
    [anon_sym_LF] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1067),
  },
  [558] = {
    [sym_string] = STATE(1173),
    [sym_simple_expansion] = STATE(1173),
    [sym_string_expansion] = STATE(1173),
    [sym_expansion] = STATE(1173),
    [sym_command_substitution] = STATE(1173),
    [sym_process_substitution] = STATE(1173),
    [anon_sym_DOLLAR] = ACTIONS(265),
    [sym__special_character] = ACTIONS(2168),
    [anon_sym_DQUOTE] = ACTIONS(269),
    [sym_raw_string] = ACTIONS(2168),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(277),
    [anon_sym_LT_LPAREN] = ACTIONS(279),
    [anon_sym_GT_LPAREN] = ACTIONS(279),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2168),
  },
  [559] = {
    [aux_sym_concatenation_repeat1] = STATE(1175),
    [sym__simple_heredoc_body] = ACTIONS(1071),
    [sym__heredoc_body_beginning] = ACTIONS(1071),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(2170),
    [sym_variable_name] = ACTIONS(1071),
    [ts_builtin_sym_end] = ACTIONS(1071),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [sym__special_character] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [sym_word] = ACTIONS(1075),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1075),
  },
  [560] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(2172),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [561] = {
    [sym__simple_heredoc_body] = ACTIONS(1089),
    [sym__heredoc_body_beginning] = ACTIONS(1089),
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(1089),
    [sym_variable_name] = ACTIONS(1089),
    [ts_builtin_sym_end] = ACTIONS(1089),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_SEMI_SEMI] = ACTIONS(1089),
    [anon_sym_PIPE_AMP] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_AMP] = ACTIONS(1089),
    [anon_sym_GT_AMP] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1089),
    [anon_sym_LT_LT_LT] = ACTIONS(1089),
    [anon_sym_DOLLAR] = ACTIONS(1091),
    [sym__special_character] = ACTIONS(1089),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1089),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1089),
    [anon_sym_GT_LPAREN] = ACTIONS(1089),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1091),
    [sym_word] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [562] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(627),
    [anon_sym_DOLLAR] = ACTIONS(2174),
    [anon_sym_DQUOTE] = ACTIONS(2172),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [563] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(2176),
    [sym_comment] = ACTIONS(57),
  },
  [564] = {
    [sym_subscript] = STATE(1181),
    [sym_variable_name] = ACTIONS(2178),
    [anon_sym_DASH] = ACTIONS(2180),
    [anon_sym_DOLLAR] = ACTIONS(2180),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(2184),
    [anon_sym_AT] = ACTIONS(2184),
    [anon_sym_QMARK] = ACTIONS(2184),
    [anon_sym_0] = ACTIONS(2182),
    [anon_sym__] = ACTIONS(2182),
  },
  [565] = {
    [sym_concatenation] = STATE(1184),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1184),
    [anon_sym_RBRACE] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2188),
    [anon_sym_DASH] = ACTIONS(2188),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2190),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(2192),
    [anon_sym_COLON] = ACTIONS(2188),
    [anon_sym_COLON_QMARK] = ACTIONS(2188),
    [anon_sym_COLON_DASH] = ACTIONS(2188),
    [anon_sym_PERCENT] = ACTIONS(2188),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [566] = {
    [sym_concatenation] = STATE(1187),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1187),
    [anon_sym_RBRACE] = ACTIONS(2194),
    [anon_sym_EQ] = ACTIONS(2196),
    [anon_sym_DASH] = ACTIONS(2196),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2198),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(2200),
    [anon_sym_COLON] = ACTIONS(2196),
    [anon_sym_COLON_QMARK] = ACTIONS(2196),
    [anon_sym_COLON_DASH] = ACTIONS(2196),
    [anon_sym_PERCENT] = ACTIONS(2196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [567] = {
    [anon_sym_RPAREN] = ACTIONS(2202),
    [sym_comment] = ACTIONS(57),
  },
  [568] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(2202),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [569] = {
    [anon_sym_BQUOTE] = ACTIONS(2202),
    [sym_comment] = ACTIONS(57),
  },
  [570] = {
    [anon_sym_RPAREN] = ACTIONS(2204),
    [sym_comment] = ACTIONS(57),
  },
  [571] = {
    [sym_variable_assignment] = STATE(571),
    [sym_subscript] = STATE(174),
    [sym_concatenation] = STATE(571),
    [sym_string] = STATE(169),
    [sym_simple_expansion] = STATE(169),
    [sym_string_expansion] = STATE(169),
    [sym_expansion] = STATE(169),
    [sym_command_substitution] = STATE(169),
    [sym_process_substitution] = STATE(169),
    [aux_sym_declaration_command_repeat1] = STATE(571),
    [aux_sym__literal_repeat1] = STATE(176),
    [sym__simple_heredoc_body] = ACTIONS(2206),
    [sym__heredoc_body_beginning] = ACTIONS(2206),
    [sym_file_descriptor] = ACTIONS(2206),
    [sym_variable_name] = ACTIONS(2208),
    [ts_builtin_sym_end] = ACTIONS(2206),
    [anon_sym_SEMI] = ACTIONS(2211),
    [anon_sym_PIPE] = ACTIONS(2211),
    [anon_sym_SEMI_SEMI] = ACTIONS(2206),
    [anon_sym_PIPE_AMP] = ACTIONS(2206),
    [anon_sym_AMP_AMP] = ACTIONS(2206),
    [anon_sym_PIPE_PIPE] = ACTIONS(2206),
    [anon_sym_LT] = ACTIONS(2211),
    [anon_sym_GT] = ACTIONS(2211),
    [anon_sym_GT_GT] = ACTIONS(2206),
    [anon_sym_AMP_GT] = ACTIONS(2211),
    [anon_sym_AMP_GT_GT] = ACTIONS(2206),
    [anon_sym_LT_AMP] = ACTIONS(2206),
    [anon_sym_GT_AMP] = ACTIONS(2206),
    [anon_sym_LT_LT] = ACTIONS(2211),
    [anon_sym_LT_LT_DASH] = ACTIONS(2206),
    [anon_sym_LT_LT_LT] = ACTIONS(2206),
    [anon_sym_DOLLAR] = ACTIONS(2213),
    [sym__special_character] = ACTIONS(2216),
    [anon_sym_DQUOTE] = ACTIONS(2219),
    [sym_raw_string] = ACTIONS(2222),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2225),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2228),
    [anon_sym_BQUOTE] = ACTIONS(2231),
    [anon_sym_LT_LPAREN] = ACTIONS(2234),
    [anon_sym_GT_LPAREN] = ACTIONS(2234),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2237),
    [sym_word] = ACTIONS(2240),
    [anon_sym_LF] = ACTIONS(2206),
    [anon_sym_AMP] = ACTIONS(2211),
  },
  [572] = {
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym_variable_name] = ACTIONS(335),
    [ts_builtin_sym_end] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_RPAREN] = ACTIONS(335),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(339),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [573] = {
    [aux_sym__literal_repeat1] = STATE(573),
    [sym__simple_heredoc_body] = ACTIONS(1373),
    [sym__heredoc_body_beginning] = ACTIONS(1373),
    [sym_file_descriptor] = ACTIONS(1373),
    [sym_variable_name] = ACTIONS(1373),
    [ts_builtin_sym_end] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE_AMP] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_LT_LT_DASH] = ACTIONS(1373),
    [anon_sym_LT_LT_LT] = ACTIONS(1373),
    [anon_sym_DOLLAR] = ACTIONS(1375),
    [sym__special_character] = ACTIONS(2243),
    [anon_sym_DQUOTE] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1373),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [anon_sym_LT_LPAREN] = ACTIONS(1373),
    [anon_sym_GT_LPAREN] = ACTIONS(1373),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1375),
    [sym_word] = ACTIONS(1375),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
  },
  [574] = {
    [sym__simple_heredoc_body] = ACTIONS(1057),
    [sym__heredoc_body_beginning] = ACTIONS(1057),
    [sym_file_descriptor] = ACTIONS(1057),
    [sym__concat] = ACTIONS(1057),
    [ts_builtin_sym_end] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_RPAREN] = ACTIONS(1057),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_PIPE_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_AMP] = ACTIONS(1057),
    [anon_sym_GT_AMP] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_LT] = ACTIONS(1057),
    [anon_sym_DOLLAR] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [sym_raw_string] = ACTIONS(1057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1057),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1057),
    [anon_sym_BQUOTE] = ACTIONS(1057),
    [anon_sym_LT_LPAREN] = ACTIONS(1057),
    [anon_sym_GT_LPAREN] = ACTIONS(1057),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1059),
    [sym_word] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [575] = {
    [sym__simple_heredoc_body] = ACTIONS(1061),
    [sym__heredoc_body_beginning] = ACTIONS(1061),
    [sym_file_descriptor] = ACTIONS(1061),
    [sym__concat] = ACTIONS(1061),
    [ts_builtin_sym_end] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(1063),
    [anon_sym_PIPE] = ACTIONS(1063),
    [anon_sym_RPAREN] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE_AMP] = ACTIONS(1061),
    [anon_sym_AMP_AMP] = ACTIONS(1061),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1063),
    [anon_sym_GT_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT_GT] = ACTIONS(1061),
    [anon_sym_LT_AMP] = ACTIONS(1061),
    [anon_sym_GT_AMP] = ACTIONS(1061),
    [anon_sym_LT_LT] = ACTIONS(1063),
    [anon_sym_LT_LT_DASH] = ACTIONS(1061),
    [anon_sym_LT_LT_LT] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1061),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1061),
    [anon_sym_LT_LPAREN] = ACTIONS(1061),
    [anon_sym_GT_LPAREN] = ACTIONS(1061),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1063),
    [sym_word] = ACTIONS(1063),
    [anon_sym_LF] = ACTIONS(1061),
    [anon_sym_AMP] = ACTIONS(1063),
  },
  [576] = {
    [sym__simple_heredoc_body] = ACTIONS(1065),
    [sym__heredoc_body_beginning] = ACTIONS(1065),
    [sym_file_descriptor] = ACTIONS(1065),
    [sym__concat] = ACTIONS(1065),
    [ts_builtin_sym_end] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1067),
    [anon_sym_RPAREN] = ACTIONS(1065),
    [anon_sym_SEMI_SEMI] = ACTIONS(1065),
    [anon_sym_PIPE_AMP] = ACTIONS(1065),
    [anon_sym_AMP_AMP] = ACTIONS(1065),
    [anon_sym_PIPE_PIPE] = ACTIONS(1065),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_GT] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT] = ACTIONS(1067),
    [anon_sym_AMP_GT_GT] = ACTIONS(1065),
    [anon_sym_LT_AMP] = ACTIONS(1065),
    [anon_sym_GT_AMP] = ACTIONS(1065),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_LT_LT_DASH] = ACTIONS(1065),
    [anon_sym_LT_LT_LT] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1067),
    [sym__special_character] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LT_LPAREN] = ACTIONS(1065),
    [anon_sym_GT_LPAREN] = ACTIONS(1065),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1067),
    [sym_word] = ACTIONS(1067),
    [anon_sym_LF] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1067),
  },
  [577] = {
    [sym_string] = STATE(1190),
    [sym_simple_expansion] = STATE(1190),
    [sym_string_expansion] = STATE(1190),
    [sym_expansion] = STATE(1190),
    [sym_command_substitution] = STATE(1190),
    [sym_process_substitution] = STATE(1190),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym__special_character] = ACTIONS(2246),
    [anon_sym_DQUOTE] = ACTIONS(293),
    [sym_raw_string] = ACTIONS(2246),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(297),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(301),
    [anon_sym_LT_LPAREN] = ACTIONS(303),
    [anon_sym_GT_LPAREN] = ACTIONS(303),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2246),
  },
  [578] = {
    [aux_sym_concatenation_repeat1] = STATE(1192),
    [sym__simple_heredoc_body] = ACTIONS(1071),
    [sym__heredoc_body_beginning] = ACTIONS(1071),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(2248),
    [ts_builtin_sym_end] = ACTIONS(1071),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [sym__special_character] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [sym_word] = ACTIONS(1075),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1075),
  },
  [579] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [580] = {
    [sym__simple_heredoc_body] = ACTIONS(1089),
    [sym__heredoc_body_beginning] = ACTIONS(1089),
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(1089),
    [ts_builtin_sym_end] = ACTIONS(1089),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_SEMI_SEMI] = ACTIONS(1089),
    [anon_sym_PIPE_AMP] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_AMP] = ACTIONS(1089),
    [anon_sym_GT_AMP] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1089),
    [anon_sym_LT_LT_LT] = ACTIONS(1089),
    [anon_sym_DOLLAR] = ACTIONS(1091),
    [sym__special_character] = ACTIONS(1089),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1089),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1089),
    [anon_sym_GT_LPAREN] = ACTIONS(1089),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1091),
    [sym_word] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [581] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(627),
    [anon_sym_DOLLAR] = ACTIONS(2252),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [582] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(2254),
    [sym_comment] = ACTIONS(57),
  },
  [583] = {
    [sym_subscript] = STATE(1198),
    [sym_variable_name] = ACTIONS(2256),
    [anon_sym_DASH] = ACTIONS(2258),
    [anon_sym_DOLLAR] = ACTIONS(2258),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2260),
    [anon_sym_STAR] = ACTIONS(2262),
    [anon_sym_AT] = ACTIONS(2262),
    [anon_sym_QMARK] = ACTIONS(2262),
    [anon_sym_0] = ACTIONS(2260),
    [anon_sym__] = ACTIONS(2260),
  },
  [584] = {
    [sym_concatenation] = STATE(1201),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1201),
    [anon_sym_RBRACE] = ACTIONS(2264),
    [anon_sym_EQ] = ACTIONS(2266),
    [anon_sym_DASH] = ACTIONS(2266),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(2270),
    [anon_sym_COLON] = ACTIONS(2266),
    [anon_sym_COLON_QMARK] = ACTIONS(2266),
    [anon_sym_COLON_DASH] = ACTIONS(2266),
    [anon_sym_PERCENT] = ACTIONS(2266),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [585] = {
    [sym_concatenation] = STATE(1204),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1204),
    [anon_sym_RBRACE] = ACTIONS(2272),
    [anon_sym_EQ] = ACTIONS(2274),
    [anon_sym_DASH] = ACTIONS(2274),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2276),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(2278),
    [anon_sym_COLON] = ACTIONS(2274),
    [anon_sym_COLON_QMARK] = ACTIONS(2274),
    [anon_sym_COLON_DASH] = ACTIONS(2274),
    [anon_sym_PERCENT] = ACTIONS(2274),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [586] = {
    [anon_sym_RPAREN] = ACTIONS(2280),
    [sym_comment] = ACTIONS(57),
  },
  [587] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(2280),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [588] = {
    [anon_sym_BQUOTE] = ACTIONS(2280),
    [sym_comment] = ACTIONS(57),
  },
  [589] = {
    [anon_sym_RPAREN] = ACTIONS(2282),
    [sym_comment] = ACTIONS(57),
  },
  [590] = {
    [sym_concatenation] = STATE(590),
    [sym_string] = STATE(180),
    [sym_simple_expansion] = STATE(180),
    [sym_string_expansion] = STATE(180),
    [sym_expansion] = STATE(180),
    [sym_command_substitution] = STATE(180),
    [sym_process_substitution] = STATE(180),
    [aux_sym_unset_command_repeat1] = STATE(590),
    [aux_sym__literal_repeat1] = STATE(186),
    [sym__simple_heredoc_body] = ACTIONS(2284),
    [sym__heredoc_body_beginning] = ACTIONS(2284),
    [sym_file_descriptor] = ACTIONS(2284),
    [ts_builtin_sym_end] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym_PIPE] = ACTIONS(2286),
    [anon_sym_SEMI_SEMI] = ACTIONS(2284),
    [anon_sym_PIPE_AMP] = ACTIONS(2284),
    [anon_sym_AMP_AMP] = ACTIONS(2284),
    [anon_sym_PIPE_PIPE] = ACTIONS(2284),
    [anon_sym_LT] = ACTIONS(2286),
    [anon_sym_GT] = ACTIONS(2286),
    [anon_sym_GT_GT] = ACTIONS(2284),
    [anon_sym_AMP_GT] = ACTIONS(2286),
    [anon_sym_AMP_GT_GT] = ACTIONS(2284),
    [anon_sym_LT_AMP] = ACTIONS(2284),
    [anon_sym_GT_AMP] = ACTIONS(2284),
    [anon_sym_LT_LT] = ACTIONS(2286),
    [anon_sym_LT_LT_DASH] = ACTIONS(2284),
    [anon_sym_LT_LT_LT] = ACTIONS(2284),
    [anon_sym_DOLLAR] = ACTIONS(2288),
    [sym__special_character] = ACTIONS(2291),
    [anon_sym_DQUOTE] = ACTIONS(2294),
    [sym_raw_string] = ACTIONS(2297),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2300),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2303),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2309),
    [anon_sym_GT_LPAREN] = ACTIONS(2309),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2312),
    [sym_word] = ACTIONS(2315),
    [anon_sym_LF] = ACTIONS(2284),
    [anon_sym_AMP] = ACTIONS(2286),
  },
  [591] = {
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [ts_builtin_sym_end] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_RPAREN] = ACTIONS(335),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(339),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [592] = {
    [aux_sym__literal_repeat1] = STATE(592),
    [sym__simple_heredoc_body] = ACTIONS(1373),
    [sym__heredoc_body_beginning] = ACTIONS(1373),
    [sym_file_descriptor] = ACTIONS(1373),
    [ts_builtin_sym_end] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE_AMP] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_LT_LT_DASH] = ACTIONS(1373),
    [anon_sym_LT_LT_LT] = ACTIONS(1373),
    [anon_sym_DOLLAR] = ACTIONS(1375),
    [sym__special_character] = ACTIONS(2318),
    [anon_sym_DQUOTE] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1373),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [anon_sym_LT_LPAREN] = ACTIONS(1373),
    [anon_sym_GT_LPAREN] = ACTIONS(1373),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1375),
    [sym_word] = ACTIONS(1375),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
  },
  [593] = {
    [sym_file_descriptor] = ACTIONS(1057),
    [sym__concat] = ACTIONS(1057),
    [sym_variable_name] = ACTIONS(1057),
    [anon_sym_RPAREN] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_AMP] = ACTIONS(1057),
    [anon_sym_GT_AMP] = ACTIONS(1057),
    [anon_sym_DOLLAR] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [sym_raw_string] = ACTIONS(1057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1057),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1057),
    [anon_sym_BQUOTE] = ACTIONS(1057),
    [anon_sym_LT_LPAREN] = ACTIONS(1057),
    [anon_sym_GT_LPAREN] = ACTIONS(1057),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1057),
  },
  [594] = {
    [sym_file_descriptor] = ACTIONS(1061),
    [sym__concat] = ACTIONS(1061),
    [sym_variable_name] = ACTIONS(1061),
    [anon_sym_RPAREN] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1063),
    [anon_sym_GT_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT_GT] = ACTIONS(1061),
    [anon_sym_LT_AMP] = ACTIONS(1061),
    [anon_sym_GT_AMP] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1061),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1061),
    [anon_sym_LT_LPAREN] = ACTIONS(1061),
    [anon_sym_GT_LPAREN] = ACTIONS(1061),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1061),
  },
  [595] = {
    [sym_file_descriptor] = ACTIONS(1065),
    [sym__concat] = ACTIONS(1065),
    [sym_variable_name] = ACTIONS(1065),
    [anon_sym_RPAREN] = ACTIONS(1065),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_GT] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT] = ACTIONS(1067),
    [anon_sym_AMP_GT_GT] = ACTIONS(1065),
    [anon_sym_LT_AMP] = ACTIONS(1065),
    [anon_sym_GT_AMP] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1067),
    [sym__special_character] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LT_LPAREN] = ACTIONS(1065),
    [anon_sym_GT_LPAREN] = ACTIONS(1065),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1065),
  },
  [596] = {
    [sym_string] = STATE(1207),
    [sym_simple_expansion] = STATE(1207),
    [sym_string_expansion] = STATE(1207),
    [sym_expansion] = STATE(1207),
    [sym_command_substitution] = STATE(1207),
    [sym_process_substitution] = STATE(1207),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [sym__special_character] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(313),
    [sym_raw_string] = ACTIONS(2321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(317),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(319),
    [anon_sym_BQUOTE] = ACTIONS(321),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2321),
  },
  [597] = {
    [aux_sym_concatenation_repeat1] = STATE(1209),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(2323),
    [sym_variable_name] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [sym__special_character] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1071),
  },
  [598] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(2325),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [599] = {
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(1089),
    [sym_variable_name] = ACTIONS(1089),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_AMP] = ACTIONS(1089),
    [anon_sym_GT_AMP] = ACTIONS(1089),
    [anon_sym_DOLLAR] = ACTIONS(1091),
    [sym__special_character] = ACTIONS(1089),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1089),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1089),
    [anon_sym_GT_LPAREN] = ACTIONS(1089),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1089),
  },
  [600] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(627),
    [anon_sym_DOLLAR] = ACTIONS(2327),
    [anon_sym_DQUOTE] = ACTIONS(2325),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [601] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(2329),
    [sym_comment] = ACTIONS(57),
  },
  [602] = {
    [sym_subscript] = STATE(1215),
    [sym_variable_name] = ACTIONS(2331),
    [anon_sym_DASH] = ACTIONS(2333),
    [anon_sym_DOLLAR] = ACTIONS(2333),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2335),
    [anon_sym_STAR] = ACTIONS(2337),
    [anon_sym_AT] = ACTIONS(2337),
    [anon_sym_QMARK] = ACTIONS(2337),
    [anon_sym_0] = ACTIONS(2335),
    [anon_sym__] = ACTIONS(2335),
  },
  [603] = {
    [sym_concatenation] = STATE(1218),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1218),
    [anon_sym_RBRACE] = ACTIONS(2339),
    [anon_sym_EQ] = ACTIONS(2341),
    [anon_sym_DASH] = ACTIONS(2341),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2343),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(2345),
    [anon_sym_COLON] = ACTIONS(2341),
    [anon_sym_COLON_QMARK] = ACTIONS(2341),
    [anon_sym_COLON_DASH] = ACTIONS(2341),
    [anon_sym_PERCENT] = ACTIONS(2341),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [604] = {
    [sym_concatenation] = STATE(1221),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1221),
    [anon_sym_RBRACE] = ACTIONS(2347),
    [anon_sym_EQ] = ACTIONS(2349),
    [anon_sym_DASH] = ACTIONS(2349),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2351),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(2353),
    [anon_sym_COLON] = ACTIONS(2349),
    [anon_sym_COLON_QMARK] = ACTIONS(2349),
    [anon_sym_COLON_DASH] = ACTIONS(2349),
    [anon_sym_PERCENT] = ACTIONS(2349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [605] = {
    [anon_sym_RPAREN] = ACTIONS(2355),
    [sym_comment] = ACTIONS(57),
  },
  [606] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(2355),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [607] = {
    [anon_sym_BQUOTE] = ACTIONS(2355),
    [sym_comment] = ACTIONS(57),
  },
  [608] = {
    [anon_sym_RPAREN] = ACTIONS(2357),
    [sym_comment] = ACTIONS(57),
  },
  [609] = {
    [sym_file_descriptor] = ACTIONS(335),
    [sym_variable_name] = ACTIONS(335),
    [anon_sym_RPAREN] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(335),
  },
  [610] = {
    [aux_sym__literal_repeat1] = STATE(610),
    [sym_file_descriptor] = ACTIONS(1373),
    [sym_variable_name] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_DOLLAR] = ACTIONS(1375),
    [sym__special_character] = ACTIONS(2359),
    [anon_sym_DQUOTE] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1373),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [anon_sym_LT_LPAREN] = ACTIONS(1373),
    [anon_sym_GT_LPAREN] = ACTIONS(1373),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1373),
  },
  [611] = {
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(2362),
    [ts_builtin_sym_end] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_RPAREN] = ACTIONS(2362),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_EQ_TILDE] = ACTIONS(2364),
    [anon_sym_EQ_EQ] = ACTIONS(2364),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [612] = {
    [sym_string] = STATE(611),
    [sym_simple_expansion] = STATE(611),
    [sym_string_expansion] = STATE(611),
    [sym_expansion] = STATE(611),
    [sym_command_substitution] = STATE(611),
    [sym_process_substitution] = STATE(611),
    [anon_sym_DOLLAR] = ACTIONS(2366),
    [sym__special_character] = ACTIONS(1069),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1069),
  },
  [613] = {
    [aux_sym_concatenation_repeat1] = STATE(613),
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(2368),
    [ts_builtin_sym_end] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_EQ_TILDE] = ACTIONS(2364),
    [anon_sym_EQ_EQ] = ACTIONS(2364),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [614] = {
    [sym__concat] = ACTIONS(1057),
    [anon_sym_DOLLAR] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [sym__string_content] = ACTIONS(1057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1059),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [sym_comment] = ACTIONS(329),
  },
  [615] = {
    [sym__simple_heredoc_body] = ACTIONS(2371),
    [sym__heredoc_body_beginning] = ACTIONS(2371),
    [sym_file_descriptor] = ACTIONS(2371),
    [sym__concat] = ACTIONS(2371),
    [ts_builtin_sym_end] = ACTIONS(2371),
    [anon_sym_SEMI] = ACTIONS(2373),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_RPAREN] = ACTIONS(2371),
    [anon_sym_SEMI_SEMI] = ACTIONS(2371),
    [anon_sym_PIPE_AMP] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_EQ_TILDE] = ACTIONS(2373),
    [anon_sym_EQ_EQ] = ACTIONS(2373),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_GT_GT] = ACTIONS(2371),
    [anon_sym_AMP_GT] = ACTIONS(2373),
    [anon_sym_AMP_GT_GT] = ACTIONS(2371),
    [anon_sym_LT_AMP] = ACTIONS(2371),
    [anon_sym_GT_AMP] = ACTIONS(2371),
    [anon_sym_LT_LT] = ACTIONS(2373),
    [anon_sym_LT_LT_DASH] = ACTIONS(2371),
    [anon_sym_LT_LT_LT] = ACTIONS(2371),
    [anon_sym_DOLLAR] = ACTIONS(2373),
    [sym__special_character] = ACTIONS(2371),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [sym_raw_string] = ACTIONS(2371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2371),
    [anon_sym_BQUOTE] = ACTIONS(2371),
    [anon_sym_LT_LPAREN] = ACTIONS(2371),
    [anon_sym_GT_LPAREN] = ACTIONS(2371),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2373),
    [anon_sym_LF] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
  },
  [616] = {
    [sym__concat] = ACTIONS(2375),
    [anon_sym_DOLLAR] = ACTIONS(2377),
    [anon_sym_DQUOTE] = ACTIONS(2377),
    [sym__string_content] = ACTIONS(2379),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2377),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2377),
    [anon_sym_BQUOTE] = ACTIONS(2377),
    [sym_comment] = ACTIONS(329),
  },
  [617] = {
    [sym__concat] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(1067),
    [sym__string_content] = ACTIONS(1065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1067),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1067),
    [anon_sym_BQUOTE] = ACTIONS(1067),
    [sym_comment] = ACTIONS(329),
  },
  [618] = {
    [anon_sym_DOLLAR] = ACTIONS(2377),
    [anon_sym_DQUOTE] = ACTIONS(2377),
    [sym__string_content] = ACTIONS(2379),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2377),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2377),
    [anon_sym_BQUOTE] = ACTIONS(2377),
    [sym_comment] = ACTIONS(329),
  },
  [619] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(2381),
    [sym_comment] = ACTIONS(57),
  },
  [620] = {
    [sym_subscript] = STATE(1229),
    [sym_variable_name] = ACTIONS(2383),
    [anon_sym_DASH] = ACTIONS(2385),
    [anon_sym_DOLLAR] = ACTIONS(2385),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2387),
    [anon_sym_STAR] = ACTIONS(2389),
    [anon_sym_AT] = ACTIONS(2389),
    [anon_sym_QMARK] = ACTIONS(2389),
    [anon_sym_0] = ACTIONS(2387),
    [anon_sym__] = ACTIONS(2387),
  },
  [621] = {
    [sym_concatenation] = STATE(1232),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1232),
    [anon_sym_RBRACE] = ACTIONS(2391),
    [anon_sym_EQ] = ACTIONS(2393),
    [anon_sym_DASH] = ACTIONS(2393),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2395),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(2397),
    [anon_sym_COLON] = ACTIONS(2393),
    [anon_sym_COLON_QMARK] = ACTIONS(2393),
    [anon_sym_COLON_DASH] = ACTIONS(2393),
    [anon_sym_PERCENT] = ACTIONS(2393),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [622] = {
    [sym_concatenation] = STATE(1235),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1235),
    [anon_sym_RBRACE] = ACTIONS(2399),
    [anon_sym_EQ] = ACTIONS(2401),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2403),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(2405),
    [anon_sym_COLON] = ACTIONS(2401),
    [anon_sym_COLON_QMARK] = ACTIONS(2401),
    [anon_sym_COLON_DASH] = ACTIONS(2401),
    [anon_sym_PERCENT] = ACTIONS(2401),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [623] = {
    [anon_sym_RPAREN] = ACTIONS(2407),
    [sym_comment] = ACTIONS(57),
  },
  [624] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(2407),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [625] = {
    [anon_sym_BQUOTE] = ACTIONS(2407),
    [sym_comment] = ACTIONS(57),
  },
  [626] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(2409),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [627] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(627),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2377),
    [sym__string_content] = ACTIONS(2414),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2417),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2423),
    [sym_comment] = ACTIONS(329),
  },
  [628] = {
    [sym_concatenation] = STATE(1240),
    [sym_string] = STATE(1239),
    [sym_simple_expansion] = STATE(1239),
    [sym_string_expansion] = STATE(1239),
    [sym_expansion] = STATE(1239),
    [sym_command_substitution] = STATE(1239),
    [sym_process_substitution] = STATE(1239),
    [aux_sym__literal_repeat1] = STATE(1241),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__special_character] = ACTIONS(445),
    [anon_sym_DQUOTE] = ACTIONS(233),
    [sym_raw_string] = ACTIONS(2426),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [anon_sym_LT_LPAREN] = ACTIONS(243),
    [anon_sym_GT_LPAREN] = ACTIONS(243),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2426),
  },
  [629] = {
    [sym_concatenation] = STATE(1251),
    [sym_string] = STATE(1246),
    [sym_simple_expansion] = STATE(1246),
    [sym_string_expansion] = STATE(1246),
    [sym_expansion] = STATE(1246),
    [sym_command_substitution] = STATE(1246),
    [sym_process_substitution] = STATE(1246),
    [aux_sym__literal_repeat1] = STATE(1252),
    [anon_sym_RBRACE] = ACTIONS(2428),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(2436),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2436),
  },
  [630] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(2446),
    [sym_comment] = ACTIONS(57),
  },
  [631] = {
    [sym_concatenation] = STATE(1256),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1256),
    [anon_sym_RBRACE] = ACTIONS(2448),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(2454),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_COLON_QMARK] = ACTIONS(2450),
    [anon_sym_COLON_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [632] = {
    [sym_concatenation] = STATE(1258),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1258),
    [anon_sym_RBRACE] = ACTIONS(2428),
    [anon_sym_EQ] = ACTIONS(2456),
    [anon_sym_DASH] = ACTIONS(2456),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2458),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(2460),
    [anon_sym_COLON] = ACTIONS(2456),
    [anon_sym_COLON_QMARK] = ACTIONS(2456),
    [anon_sym_COLON_DASH] = ACTIONS(2456),
    [anon_sym_PERCENT] = ACTIONS(2456),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [633] = {
    [sym__simple_heredoc_body] = ACTIONS(2462),
    [sym__heredoc_body_beginning] = ACTIONS(2462),
    [sym_file_descriptor] = ACTIONS(2462),
    [sym__concat] = ACTIONS(2462),
    [ts_builtin_sym_end] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_RPAREN] = ACTIONS(2462),
    [anon_sym_SEMI_SEMI] = ACTIONS(2462),
    [anon_sym_PIPE_AMP] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_EQ_TILDE] = ACTIONS(2464),
    [anon_sym_EQ_EQ] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_GT_GT] = ACTIONS(2462),
    [anon_sym_AMP_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT_GT] = ACTIONS(2462),
    [anon_sym_LT_AMP] = ACTIONS(2462),
    [anon_sym_GT_AMP] = ACTIONS(2462),
    [anon_sym_LT_LT] = ACTIONS(2464),
    [anon_sym_LT_LT_DASH] = ACTIONS(2462),
    [anon_sym_LT_LT_LT] = ACTIONS(2462),
    [anon_sym_DOLLAR] = ACTIONS(2464),
    [sym__special_character] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [sym_raw_string] = ACTIONS(2462),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2462),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2462),
    [anon_sym_BQUOTE] = ACTIONS(2462),
    [anon_sym_LT_LPAREN] = ACTIONS(2462),
    [anon_sym_GT_LPAREN] = ACTIONS(2462),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2464),
    [anon_sym_LF] = ACTIONS(2462),
    [anon_sym_AMP] = ACTIONS(2464),
  },
  [634] = {
    [sym_string] = STATE(1260),
    [anon_sym_DASH] = ACTIONS(2466),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(2468),
    [anon_sym_POUND] = ACTIONS(2466),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2470),
    [anon_sym_STAR] = ACTIONS(2472),
    [anon_sym_AT] = ACTIONS(2472),
    [anon_sym_QMARK] = ACTIONS(2472),
    [anon_sym_0] = ACTIONS(2470),
    [anon_sym__] = ACTIONS(2470),
  },
  [635] = {
    [aux_sym_concatenation_repeat1] = STATE(1263),
    [sym__concat] = ACTIONS(2474),
    [anon_sym_RBRACE] = ACTIONS(335),
    [anon_sym_EQ] = ACTIONS(339),
    [anon_sym_DASH] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_POUND] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_COLON] = ACTIONS(339),
    [anon_sym_COLON_QMARK] = ACTIONS(339),
    [anon_sym_COLON_DASH] = ACTIONS(339),
    [anon_sym_PERCENT] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(339),
  },
  [636] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(1266),
    [anon_sym_DOLLAR] = ACTIONS(2476),
    [anon_sym_DQUOTE] = ACTIONS(2478),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [637] = {
    [aux_sym_concatenation_repeat1] = STATE(1263),
    [sym__concat] = ACTIONS(2474),
    [anon_sym_RBRACE] = ACTIONS(2480),
    [anon_sym_EQ] = ACTIONS(2482),
    [anon_sym_DASH] = ACTIONS(2482),
    [anon_sym_DOLLAR] = ACTIONS(2482),
    [sym__special_character] = ACTIONS(2482),
    [anon_sym_DQUOTE] = ACTIONS(2480),
    [sym_raw_string] = ACTIONS(2480),
    [anon_sym_POUND] = ACTIONS(2480),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2480),
    [anon_sym_COLON] = ACTIONS(2482),
    [anon_sym_COLON_QMARK] = ACTIONS(2482),
    [anon_sym_COLON_DASH] = ACTIONS(2482),
    [anon_sym_PERCENT] = ACTIONS(2482),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2480),
    [anon_sym_BQUOTE] = ACTIONS(2480),
    [anon_sym_LT_LPAREN] = ACTIONS(2480),
    [anon_sym_GT_LPAREN] = ACTIONS(2480),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(2482),
  },
  [638] = {
    [sym_subscript] = STATE(1270),
    [sym_variable_name] = ACTIONS(2484),
    [anon_sym_BANG] = ACTIONS(2486),
    [anon_sym_DASH] = ACTIONS(2488),
    [anon_sym_DOLLAR] = ACTIONS(2488),
    [anon_sym_POUND] = ACTIONS(2486),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2490),
    [anon_sym_STAR] = ACTIONS(2492),
    [anon_sym_AT] = ACTIONS(2492),
    [anon_sym_QMARK] = ACTIONS(2492),
    [anon_sym_0] = ACTIONS(2490),
    [anon_sym__] = ACTIONS(2490),
  },
  [639] = {
    [sym_concatenation] = STATE(1273),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1273),
    [sym_regex] = ACTIONS(2494),
    [anon_sym_RBRACE] = ACTIONS(2496),
    [anon_sym_EQ] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(2498),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2498),
    [anon_sym_COLON_QMARK] = ACTIONS(2498),
    [anon_sym_COLON_DASH] = ACTIONS(2498),
    [anon_sym_PERCENT] = ACTIONS(2498),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [640] = {
    [sym__statements] = STATE(1274),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(1275),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [641] = {
    [sym__statements] = STATE(1276),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [642] = {
    [sym__statements] = STATE(1277),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [643] = {
    [aux_sym__literal_repeat1] = STATE(1279),
    [anon_sym_RBRACE] = ACTIONS(2502),
    [anon_sym_EQ] = ACTIONS(2504),
    [anon_sym_DASH] = ACTIONS(2504),
    [anon_sym_DOLLAR] = ACTIONS(2504),
    [sym__special_character] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [sym_raw_string] = ACTIONS(2502),
    [anon_sym_POUND] = ACTIONS(2502),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2502),
    [anon_sym_COLON] = ACTIONS(2504),
    [anon_sym_COLON_QMARK] = ACTIONS(2504),
    [anon_sym_COLON_DASH] = ACTIONS(2504),
    [anon_sym_PERCENT] = ACTIONS(2504),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2502),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_LT_LPAREN] = ACTIONS(2502),
    [anon_sym_GT_LPAREN] = ACTIONS(2502),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(2504),
  },
  [644] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(2496),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [645] = {
    [sym__simple_heredoc_body] = ACTIONS(2512),
    [sym__heredoc_body_beginning] = ACTIONS(2512),
    [sym_file_descriptor] = ACTIONS(2512),
    [sym__concat] = ACTIONS(2512),
    [ts_builtin_sym_end] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2514),
    [anon_sym_PIPE] = ACTIONS(2514),
    [anon_sym_RPAREN] = ACTIONS(2512),
    [anon_sym_SEMI_SEMI] = ACTIONS(2512),
    [anon_sym_PIPE_AMP] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE_PIPE] = ACTIONS(2512),
    [anon_sym_EQ_TILDE] = ACTIONS(2514),
    [anon_sym_EQ_EQ] = ACTIONS(2514),
    [anon_sym_LT] = ACTIONS(2514),
    [anon_sym_GT] = ACTIONS(2514),
    [anon_sym_GT_GT] = ACTIONS(2512),
    [anon_sym_AMP_GT] = ACTIONS(2514),
    [anon_sym_AMP_GT_GT] = ACTIONS(2512),
    [anon_sym_LT_AMP] = ACTIONS(2512),
    [anon_sym_GT_AMP] = ACTIONS(2512),
    [anon_sym_LT_LT] = ACTIONS(2514),
    [anon_sym_LT_LT_DASH] = ACTIONS(2512),
    [anon_sym_LT_LT_LT] = ACTIONS(2512),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [sym__special_character] = ACTIONS(2512),
    [anon_sym_DQUOTE] = ACTIONS(2512),
    [sym_raw_string] = ACTIONS(2512),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2512),
    [anon_sym_BQUOTE] = ACTIONS(2512),
    [anon_sym_LT_LPAREN] = ACTIONS(2512),
    [anon_sym_GT_LPAREN] = ACTIONS(2512),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2514),
    [anon_sym_LF] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2514),
  },
  [646] = {
    [sym_concatenation] = STATE(1258),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1258),
    [sym_regex] = ACTIONS(2516),
    [anon_sym_RBRACE] = ACTIONS(2428),
    [anon_sym_EQ] = ACTIONS(2456),
    [anon_sym_DASH] = ACTIONS(2456),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2458),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2456),
    [anon_sym_COLON_QMARK] = ACTIONS(2456),
    [anon_sym_COLON_DASH] = ACTIONS(2456),
    [anon_sym_PERCENT] = ACTIONS(2456),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [647] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(2428),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [648] = {
    [sym_concatenation] = STATE(257),
    [sym_string] = STATE(1282),
    [sym_simple_expansion] = STATE(1282),
    [sym_string_expansion] = STATE(1282),
    [sym_expansion] = STATE(1282),
    [sym_command_substitution] = STATE(1282),
    [sym_process_substitution] = STATE(1282),
    [aux_sym__literal_repeat1] = STATE(1283),
    [anon_sym_DOLLAR] = ACTIONS(309),
    [sym__special_character] = ACTIONS(1161),
    [anon_sym_DQUOTE] = ACTIONS(313),
    [sym_raw_string] = ACTIONS(2518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(317),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(319),
    [anon_sym_BQUOTE] = ACTIONS(321),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2518),
  },
  [649] = {
    [aux_sym_concatenation_repeat1] = STATE(1284),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(1031),
    [sym_variable_name] = ACTIONS(335),
    [anon_sym_RPAREN] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(335),
  },
  [650] = {
    [aux_sym_concatenation_repeat1] = STATE(1284),
    [sym_file_descriptor] = ACTIONS(1037),
    [sym__concat] = ACTIONS(1031),
    [sym_variable_name] = ACTIONS(1037),
    [anon_sym_RPAREN] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1039),
    [anon_sym_GT] = ACTIONS(1039),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_AMP_GT] = ACTIONS(1039),
    [anon_sym_AMP_GT_GT] = ACTIONS(1037),
    [anon_sym_LT_AMP] = ACTIONS(1037),
    [anon_sym_GT_AMP] = ACTIONS(1037),
    [anon_sym_DOLLAR] = ACTIONS(1039),
    [sym__special_character] = ACTIONS(1037),
    [anon_sym_DQUOTE] = ACTIONS(1037),
    [sym_raw_string] = ACTIONS(1037),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1037),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1037),
    [anon_sym_BQUOTE] = ACTIONS(1037),
    [anon_sym_LT_LPAREN] = ACTIONS(1037),
    [anon_sym_GT_LPAREN] = ACTIONS(1037),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1037),
  },
  [651] = {
    [aux_sym__literal_repeat1] = STATE(1285),
    [sym_file_descriptor] = ACTIONS(1051),
    [sym_variable_name] = ACTIONS(1051),
    [anon_sym_RPAREN] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT_GT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1051),
    [anon_sym_GT_AMP] = ACTIONS(1051),
    [anon_sym_DOLLAR] = ACTIONS(1053),
    [sym__special_character] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1051),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1051),
    [anon_sym_BQUOTE] = ACTIONS(1051),
    [anon_sym_LT_LPAREN] = ACTIONS(1051),
    [anon_sym_GT_LPAREN] = ACTIONS(1051),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1051),
  },
  [652] = {
    [sym__simple_heredoc_body] = ACTIONS(2520),
    [sym__heredoc_body_beginning] = ACTIONS(2520),
    [sym_file_descriptor] = ACTIONS(2520),
    [sym__concat] = ACTIONS(2520),
    [ts_builtin_sym_end] = ACTIONS(2520),
    [anon_sym_SEMI] = ACTIONS(2522),
    [anon_sym_PIPE] = ACTIONS(2522),
    [anon_sym_RPAREN] = ACTIONS(2520),
    [anon_sym_SEMI_SEMI] = ACTIONS(2520),
    [anon_sym_PIPE_AMP] = ACTIONS(2520),
    [anon_sym_AMP_AMP] = ACTIONS(2520),
    [anon_sym_PIPE_PIPE] = ACTIONS(2520),
    [anon_sym_EQ_TILDE] = ACTIONS(2522),
    [anon_sym_EQ_EQ] = ACTIONS(2522),
    [anon_sym_LT] = ACTIONS(2522),
    [anon_sym_GT] = ACTIONS(2522),
    [anon_sym_GT_GT] = ACTIONS(2520),
    [anon_sym_AMP_GT] = ACTIONS(2522),
    [anon_sym_AMP_GT_GT] = ACTIONS(2520),
    [anon_sym_LT_AMP] = ACTIONS(2520),
    [anon_sym_GT_AMP] = ACTIONS(2520),
    [anon_sym_LT_LT] = ACTIONS(2522),
    [anon_sym_LT_LT_DASH] = ACTIONS(2520),
    [anon_sym_LT_LT_LT] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(2522),
    [sym__special_character] = ACTIONS(2520),
    [anon_sym_DQUOTE] = ACTIONS(2520),
    [sym_raw_string] = ACTIONS(2520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2520),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2520),
    [anon_sym_BQUOTE] = ACTIONS(2520),
    [anon_sym_LT_LPAREN] = ACTIONS(2520),
    [anon_sym_GT_LPAREN] = ACTIONS(2520),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2522),
    [anon_sym_LF] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2522),
  },
  [653] = {
    [sym_concatenation] = STATE(263),
    [sym_string] = STATE(1287),
    [sym_array] = STATE(263),
    [sym_simple_expansion] = STATE(1287),
    [sym_string_expansion] = STATE(1287),
    [sym_expansion] = STATE(1287),
    [sym_command_substitution] = STATE(1287),
    [sym_process_substitution] = STATE(1287),
    [aux_sym__literal_repeat1] = STATE(1288),
    [sym__empty_value] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_DOLLAR] = ACTIONS(453),
    [sym__special_character] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(457),
    [sym_raw_string] = ACTIONS(2526),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(461),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(463),
    [anon_sym_BQUOTE] = ACTIONS(465),
    [anon_sym_LT_LPAREN] = ACTIONS(467),
    [anon_sym_GT_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2526),
  },
  [654] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(2528),
    [anon_sym_PLUS_EQ] = ACTIONS(2528),
    [sym_comment] = ACTIONS(57),
  },
  [655] = {
    [aux_sym_concatenation_repeat1] = STATE(1290),
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(339),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [656] = {
    [aux_sym_concatenation_repeat1] = STATE(1290),
    [sym__simple_heredoc_body] = ACTIONS(957),
    [sym__heredoc_body_beginning] = ACTIONS(957),
    [sym_file_descriptor] = ACTIONS(957),
    [sym__concat] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(957),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_SEMI_SEMI] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_LT] = ACTIONS(959),
    [anon_sym_GT] = ACTIONS(959),
    [anon_sym_GT_GT] = ACTIONS(957),
    [anon_sym_AMP_GT] = ACTIONS(959),
    [anon_sym_AMP_GT_GT] = ACTIONS(957),
    [anon_sym_LT_AMP] = ACTIONS(957),
    [anon_sym_GT_AMP] = ACTIONS(957),
    [anon_sym_LT_LT] = ACTIONS(959),
    [anon_sym_LT_LT_DASH] = ACTIONS(957),
    [anon_sym_LT_LT_LT] = ACTIONS(957),
    [anon_sym_DOLLAR] = ACTIONS(959),
    [sym__special_character] = ACTIONS(957),
    [anon_sym_DQUOTE] = ACTIONS(957),
    [sym_raw_string] = ACTIONS(957),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(957),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(957),
    [anon_sym_BQUOTE] = ACTIONS(957),
    [anon_sym_LT_LPAREN] = ACTIONS(957),
    [anon_sym_GT_LPAREN] = ACTIONS(957),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(959),
    [sym_word] = ACTIONS(959),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
  },
  [657] = {
    [anon_sym_EQ] = ACTIONS(2528),
    [anon_sym_PLUS_EQ] = ACTIONS(2528),
    [sym_comment] = ACTIONS(57),
  },
  [658] = {
    [sym_variable_assignment] = STATE(1291),
    [sym_subscript] = STATE(657),
    [sym_concatenation] = STATE(1291),
    [sym_string] = STATE(656),
    [sym_simple_expansion] = STATE(656),
    [sym_string_expansion] = STATE(656),
    [sym_expansion] = STATE(656),
    [sym_command_substitution] = STATE(656),
    [sym_process_substitution] = STATE(656),
    [aux_sym_declaration_command_repeat1] = STATE(1291),
    [aux_sym__literal_repeat1] = STATE(659),
    [sym__simple_heredoc_body] = ACTIONS(971),
    [sym__heredoc_body_beginning] = ACTIONS(971),
    [sym_file_descriptor] = ACTIONS(971),
    [sym_variable_name] = ACTIONS(1169),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_SEMI_SEMI] = ACTIONS(971),
    [anon_sym_PIPE_AMP] = ACTIONS(971),
    [anon_sym_AMP_AMP] = ACTIONS(971),
    [anon_sym_PIPE_PIPE] = ACTIONS(971),
    [anon_sym_LT] = ACTIONS(973),
    [anon_sym_GT] = ACTIONS(973),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_AMP_GT] = ACTIONS(973),
    [anon_sym_AMP_GT_GT] = ACTIONS(971),
    [anon_sym_LT_AMP] = ACTIONS(971),
    [anon_sym_GT_AMP] = ACTIONS(971),
    [anon_sym_LT_LT] = ACTIONS(973),
    [anon_sym_LT_LT_DASH] = ACTIONS(971),
    [anon_sym_LT_LT_LT] = ACTIONS(971),
    [anon_sym_DOLLAR] = ACTIONS(265),
    [sym__special_character] = ACTIONS(1171),
    [anon_sym_DQUOTE] = ACTIONS(269),
    [sym_raw_string] = ACTIONS(1173),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(971),
    [anon_sym_LT_LPAREN] = ACTIONS(279),
    [anon_sym_GT_LPAREN] = ACTIONS(279),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2530),
    [sym_word] = ACTIONS(1177),
    [anon_sym_LF] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(973),
  },
  [659] = {
    [aux_sym__literal_repeat1] = STATE(1292),
    [sym__simple_heredoc_body] = ACTIONS(977),
    [sym__heredoc_body_beginning] = ACTIONS(977),
    [sym_file_descriptor] = ACTIONS(977),
    [sym_variable_name] = ACTIONS(977),
    [anon_sym_SEMI] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(979),
    [anon_sym_SEMI_SEMI] = ACTIONS(977),
    [anon_sym_PIPE_AMP] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(977),
    [anon_sym_AMP_GT] = ACTIONS(979),
    [anon_sym_AMP_GT_GT] = ACTIONS(977),
    [anon_sym_LT_AMP] = ACTIONS(977),
    [anon_sym_GT_AMP] = ACTIONS(977),
    [anon_sym_LT_LT] = ACTIONS(979),
    [anon_sym_LT_LT_DASH] = ACTIONS(977),
    [anon_sym_LT_LT_LT] = ACTIONS(977),
    [anon_sym_DOLLAR] = ACTIONS(979),
    [sym__special_character] = ACTIONS(981),
    [anon_sym_DQUOTE] = ACTIONS(977),
    [sym_raw_string] = ACTIONS(977),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(977),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(977),
    [anon_sym_BQUOTE] = ACTIONS(977),
    [anon_sym_LT_LPAREN] = ACTIONS(977),
    [anon_sym_GT_LPAREN] = ACTIONS(977),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(979),
    [sym_word] = ACTIONS(979),
    [anon_sym_LF] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
  },
  [660] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(991),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(339),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [661] = {
    [aux_sym_concatenation_repeat1] = STATE(1293),
    [sym__simple_heredoc_body] = ACTIONS(997),
    [sym__heredoc_body_beginning] = ACTIONS(997),
    [sym_file_descriptor] = ACTIONS(997),
    [sym__concat] = ACTIONS(991),
    [anon_sym_SEMI] = ACTIONS(999),
    [anon_sym_PIPE] = ACTIONS(999),
    [anon_sym_SEMI_SEMI] = ACTIONS(997),
    [anon_sym_PIPE_AMP] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_LT] = ACTIONS(999),
    [anon_sym_GT] = ACTIONS(999),
    [anon_sym_GT_GT] = ACTIONS(997),
    [anon_sym_AMP_GT] = ACTIONS(999),
    [anon_sym_AMP_GT_GT] = ACTIONS(997),
    [anon_sym_LT_AMP] = ACTIONS(997),
    [anon_sym_GT_AMP] = ACTIONS(997),
    [anon_sym_LT_LT] = ACTIONS(999),
    [anon_sym_LT_LT_DASH] = ACTIONS(997),
    [anon_sym_LT_LT_LT] = ACTIONS(997),
    [anon_sym_DOLLAR] = ACTIONS(999),
    [sym__special_character] = ACTIONS(997),
    [anon_sym_DQUOTE] = ACTIONS(997),
    [sym_raw_string] = ACTIONS(997),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(997),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(997),
    [anon_sym_BQUOTE] = ACTIONS(997),
    [anon_sym_LT_LPAREN] = ACTIONS(997),
    [anon_sym_GT_LPAREN] = ACTIONS(997),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(999),
    [sym_word] = ACTIONS(999),
    [anon_sym_LF] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(999),
  },
  [662] = {
    [sym_concatenation] = STATE(1294),
    [sym_string] = STATE(661),
    [sym_simple_expansion] = STATE(661),
    [sym_string_expansion] = STATE(661),
    [sym_expansion] = STATE(661),
    [sym_command_substitution] = STATE(661),
    [sym_process_substitution] = STATE(661),
    [aux_sym_unset_command_repeat1] = STATE(1294),
    [aux_sym__literal_repeat1] = STATE(663),
    [sym__simple_heredoc_body] = ACTIONS(1011),
    [sym__heredoc_body_beginning] = ACTIONS(1011),
    [sym_file_descriptor] = ACTIONS(1011),
    [anon_sym_SEMI] = ACTIONS(1013),
    [anon_sym_PIPE] = ACTIONS(1013),
    [anon_sym_SEMI_SEMI] = ACTIONS(1011),
    [anon_sym_PIPE_AMP] = ACTIONS(1011),
    [anon_sym_AMP_AMP] = ACTIONS(1011),
    [anon_sym_PIPE_PIPE] = ACTIONS(1011),
    [anon_sym_LT] = ACTIONS(1013),
    [anon_sym_GT] = ACTIONS(1013),
    [anon_sym_GT_GT] = ACTIONS(1011),
    [anon_sym_AMP_GT] = ACTIONS(1013),
    [anon_sym_AMP_GT_GT] = ACTIONS(1011),
    [anon_sym_LT_AMP] = ACTIONS(1011),
    [anon_sym_GT_AMP] = ACTIONS(1011),
    [anon_sym_LT_LT] = ACTIONS(1013),
    [anon_sym_LT_LT_DASH] = ACTIONS(1011),
    [anon_sym_LT_LT_LT] = ACTIONS(1011),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym__special_character] = ACTIONS(1179),
    [anon_sym_DQUOTE] = ACTIONS(293),
    [sym_raw_string] = ACTIONS(1181),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(297),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(1011),
    [anon_sym_LT_LPAREN] = ACTIONS(303),
    [anon_sym_GT_LPAREN] = ACTIONS(303),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2532),
    [sym_word] = ACTIONS(1185),
    [anon_sym_LF] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(1013),
  },
  [663] = {
    [aux_sym__literal_repeat1] = STATE(1295),
    [sym__simple_heredoc_body] = ACTIONS(1017),
    [sym__heredoc_body_beginning] = ACTIONS(1017),
    [sym_file_descriptor] = ACTIONS(1017),
    [anon_sym_SEMI] = ACTIONS(1019),
    [anon_sym_PIPE] = ACTIONS(1019),
    [anon_sym_SEMI_SEMI] = ACTIONS(1017),
    [anon_sym_PIPE_AMP] = ACTIONS(1017),
    [anon_sym_AMP_AMP] = ACTIONS(1017),
    [anon_sym_PIPE_PIPE] = ACTIONS(1017),
    [anon_sym_LT] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(1019),
    [anon_sym_GT_GT] = ACTIONS(1017),
    [anon_sym_AMP_GT] = ACTIONS(1019),
    [anon_sym_AMP_GT_GT] = ACTIONS(1017),
    [anon_sym_LT_AMP] = ACTIONS(1017),
    [anon_sym_GT_AMP] = ACTIONS(1017),
    [anon_sym_LT_LT] = ACTIONS(1019),
    [anon_sym_LT_LT_DASH] = ACTIONS(1017),
    [anon_sym_LT_LT_LT] = ACTIONS(1017),
    [anon_sym_DOLLAR] = ACTIONS(1019),
    [sym__special_character] = ACTIONS(1021),
    [anon_sym_DQUOTE] = ACTIONS(1017),
    [sym_raw_string] = ACTIONS(1017),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1017),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1017),
    [anon_sym_BQUOTE] = ACTIONS(1017),
    [anon_sym_LT_LPAREN] = ACTIONS(1017),
    [anon_sym_GT_LPAREN] = ACTIONS(1017),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1019),
    [sym_word] = ACTIONS(1019),
    [anon_sym_LF] = ACTIONS(1017),
    [anon_sym_AMP] = ACTIONS(1019),
  },
  [664] = {
    [aux_sym_concatenation_repeat1] = STATE(1296),
    [sym__simple_heredoc_body] = ACTIONS(1071),
    [sym__heredoc_body_beginning] = ACTIONS(1071),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(1073),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_EQ_TILDE] = ACTIONS(1075),
    [anon_sym_EQ_EQ] = ACTIONS(1075),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [sym__special_character] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1075),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1075),
  },
  [665] = {
    [anon_sym_LT] = ACTIONS(2534),
    [anon_sym_GT] = ACTIONS(2534),
    [anon_sym_GT_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT_GT] = ACTIONS(2536),
    [anon_sym_LT_AMP] = ACTIONS(2536),
    [anon_sym_GT_AMP] = ACTIONS(2536),
    [sym_comment] = ACTIONS(57),
  },
  [666] = {
    [sym_file_descriptor] = ACTIONS(1237),
    [sym_variable_name] = ACTIONS(1237),
    [anon_sym_for] = ACTIONS(1241),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1237),
    [anon_sym_while] = ACTIONS(1241),
    [anon_sym_if] = ACTIONS(1241),
    [anon_sym_case] = ACTIONS(1241),
    [anon_sym_function] = ACTIONS(1241),
    [anon_sym_LPAREN] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1237),
    [anon_sym_BANG] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(1241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1237),
    [anon_sym_declare] = ACTIONS(1241),
    [anon_sym_typeset] = ACTIONS(1241),
    [anon_sym_export] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_local] = ACTIONS(1241),
    [anon_sym_unset] = ACTIONS(1241),
    [anon_sym_unsetenv] = ACTIONS(1241),
    [anon_sym_LT] = ACTIONS(1241),
    [anon_sym_GT] = ACTIONS(1241),
    [anon_sym_GT_GT] = ACTIONS(1237),
    [anon_sym_AMP_GT] = ACTIONS(1241),
    [anon_sym_AMP_GT_GT] = ACTIONS(1237),
    [anon_sym_LT_AMP] = ACTIONS(1237),
    [anon_sym_GT_AMP] = ACTIONS(1237),
    [anon_sym_DOLLAR] = ACTIONS(1241),
    [sym__special_character] = ACTIONS(1241),
    [anon_sym_DQUOTE] = ACTIONS(1237),
    [sym_raw_string] = ACTIONS(1237),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1237),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [anon_sym_LT_LPAREN] = ACTIONS(1237),
    [anon_sym_GT_LPAREN] = ACTIONS(1237),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1241),
  },
  [667] = {
    [sym_redirected_statement] = STATE(1298),
    [sym_for_statement] = STATE(1298),
    [sym_c_style_for_statement] = STATE(1298),
    [sym_while_statement] = STATE(1298),
    [sym_if_statement] = STATE(1298),
    [sym_case_statement] = STATE(1298),
    [sym_function_definition] = STATE(1298),
    [sym_compound_statement] = STATE(1298),
    [sym_subshell] = STATE(1298),
    [sym_pipeline] = STATE(1298),
    [sym_list] = STATE(1298),
    [sym_negated_command] = STATE(1298),
    [sym_test_command] = STATE(1298),
    [sym_declaration_command] = STATE(1298),
    [sym_unset_command] = STATE(1298),
    [sym_command] = STATE(1298),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(1299),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [668] = {
    [sym_redirected_statement] = STATE(1300),
    [sym_for_statement] = STATE(1300),
    [sym_c_style_for_statement] = STATE(1300),
    [sym_while_statement] = STATE(1300),
    [sym_if_statement] = STATE(1300),
    [sym_case_statement] = STATE(1300),
    [sym_function_definition] = STATE(1300),
    [sym_compound_statement] = STATE(1300),
    [sym_subshell] = STATE(1300),
    [sym_pipeline] = STATE(1300),
    [sym_list] = STATE(1300),
    [sym_negated_command] = STATE(1300),
    [sym_test_command] = STATE(1300),
    [sym_declaration_command] = STATE(1300),
    [sym_unset_command] = STATE(1300),
    [sym_command] = STATE(1300),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(1301),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [669] = {
    [sym_concatenation] = STATE(696),
    [sym_string] = STATE(1303),
    [sym_simple_expansion] = STATE(1303),
    [sym_string_expansion] = STATE(1303),
    [sym_expansion] = STATE(1303),
    [sym_command_substitution] = STATE(1303),
    [sym_process_substitution] = STATE(1303),
    [aux_sym__literal_repeat1] = STATE(1304),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(2538),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(2540),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2540),
  },
  [670] = {
    [sym_concatenation] = STATE(700),
    [sym_string] = STATE(1305),
    [sym_simple_expansion] = STATE(1305),
    [sym_string_expansion] = STATE(1305),
    [sym_expansion] = STATE(1305),
    [sym_command_substitution] = STATE(1305),
    [sym_process_substitution] = STATE(1305),
    [aux_sym__literal_repeat1] = STATE(1306),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(2538),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(2542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2542),
  },
  [671] = {
    [anon_sym_SEMI] = ACTIONS(2544),
    [anon_sym_SEMI_SEMI] = ACTIONS(2546),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2546),
    [anon_sym_AMP] = ACTIONS(2546),
  },
  [672] = {
    [sym_file_redirect] = STATE(1308),
    [sym_heredoc_redirect] = STATE(1308),
    [sym_herestring_redirect] = STATE(1308),
    [aux_sym_redirected_statement_repeat1] = STATE(1308),
    [sym__simple_heredoc_body] = ACTIONS(1255),
    [sym__heredoc_body_beginning] = ACTIONS(1255),
    [sym_file_descriptor] = ACTIONS(1187),
    [anon_sym_SEMI] = ACTIONS(1257),
    [anon_sym_PIPE] = ACTIONS(1257),
    [anon_sym_SEMI_SEMI] = ACTIONS(1255),
    [anon_sym_PIPE_AMP] = ACTIONS(1255),
    [anon_sym_AMP_AMP] = ACTIONS(1255),
    [anon_sym_PIPE_PIPE] = ACTIONS(1255),
    [anon_sym_LT] = ACTIONS(1199),
    [anon_sym_GT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_AMP_GT] = ACTIONS(1199),
    [anon_sym_AMP_GT_GT] = ACTIONS(1201),
    [anon_sym_LT_AMP] = ACTIONS(1201),
    [anon_sym_GT_AMP] = ACTIONS(1201),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(1203),
    [anon_sym_BQUOTE] = ACTIONS(1255),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1257),
  },
  [673] = {
    [sym_concatenation] = STATE(704),
    [sym_string] = STATE(1309),
    [sym_simple_expansion] = STATE(1309),
    [sym_string_expansion] = STATE(1309),
    [sym_expansion] = STATE(1309),
    [sym_command_substitution] = STATE(1309),
    [sym_process_substitution] = STATE(1309),
    [aux_sym__literal_repeat1] = STATE(1310),
    [sym_regex] = ACTIONS(1259),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(1207),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(2548),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2548),
  },
  [674] = {
    [aux_sym_concatenation_repeat1] = STATE(664),
    [sym__simple_heredoc_body] = ACTIONS(1263),
    [sym__heredoc_body_beginning] = ACTIONS(1263),
    [sym_file_descriptor] = ACTIONS(1263),
    [sym__concat] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(1265),
    [anon_sym_PIPE] = ACTIONS(1265),
    [anon_sym_SEMI_SEMI] = ACTIONS(1263),
    [anon_sym_PIPE_AMP] = ACTIONS(1263),
    [anon_sym_AMP_AMP] = ACTIONS(1263),
    [anon_sym_PIPE_PIPE] = ACTIONS(1263),
    [anon_sym_EQ_TILDE] = ACTIONS(1265),
    [anon_sym_EQ_EQ] = ACTIONS(1265),
    [anon_sym_LT] = ACTIONS(1265),
    [anon_sym_GT] = ACTIONS(1265),
    [anon_sym_GT_GT] = ACTIONS(1263),
    [anon_sym_AMP_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT_GT] = ACTIONS(1263),
    [anon_sym_LT_AMP] = ACTIONS(1263),
    [anon_sym_GT_AMP] = ACTIONS(1263),
    [anon_sym_LT_LT] = ACTIONS(1265),
    [anon_sym_LT_LT_DASH] = ACTIONS(1263),
    [anon_sym_LT_LT_LT] = ACTIONS(1263),
    [anon_sym_DOLLAR] = ACTIONS(1265),
    [sym__special_character] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(1263),
    [sym_raw_string] = ACTIONS(1263),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1263),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1263),
    [anon_sym_BQUOTE] = ACTIONS(1263),
    [anon_sym_LT_LPAREN] = ACTIONS(1263),
    [anon_sym_GT_LPAREN] = ACTIONS(1263),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1265),
    [anon_sym_LF] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1265),
  },
  [675] = {
    [sym_concatenation] = STATE(1311),
    [sym_string] = STATE(674),
    [sym_simple_expansion] = STATE(674),
    [sym_string_expansion] = STATE(674),
    [sym_expansion] = STATE(674),
    [sym_command_substitution] = STATE(674),
    [sym_process_substitution] = STATE(674),
    [aux_sym_command_repeat2] = STATE(1311),
    [aux_sym__literal_repeat1] = STATE(676),
    [sym__simple_heredoc_body] = ACTIONS(1267),
    [sym__heredoc_body_beginning] = ACTIONS(1267),
    [sym_file_descriptor] = ACTIONS(1267),
    [anon_sym_SEMI] = ACTIONS(1269),
    [anon_sym_PIPE] = ACTIONS(1269),
    [anon_sym_SEMI_SEMI] = ACTIONS(1267),
    [anon_sym_PIPE_AMP] = ACTIONS(1267),
    [anon_sym_AMP_AMP] = ACTIONS(1267),
    [anon_sym_PIPE_PIPE] = ACTIONS(1267),
    [anon_sym_EQ_TILDE] = ACTIONS(1205),
    [anon_sym_EQ_EQ] = ACTIONS(1205),
    [anon_sym_LT] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1269),
    [anon_sym_GT_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT_GT] = ACTIONS(1267),
    [anon_sym_LT_AMP] = ACTIONS(1267),
    [anon_sym_GT_AMP] = ACTIONS(1267),
    [anon_sym_LT_LT] = ACTIONS(1269),
    [anon_sym_LT_LT_DASH] = ACTIONS(1267),
    [anon_sym_LT_LT_LT] = ACTIONS(1267),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(1207),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1209),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(1267),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1211),
    [anon_sym_LF] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(1269),
  },
  [676] = {
    [aux_sym__literal_repeat1] = STATE(680),
    [sym__simple_heredoc_body] = ACTIONS(1271),
    [sym__heredoc_body_beginning] = ACTIONS(1271),
    [sym_file_descriptor] = ACTIONS(1271),
    [anon_sym_SEMI] = ACTIONS(1273),
    [anon_sym_PIPE] = ACTIONS(1273),
    [anon_sym_SEMI_SEMI] = ACTIONS(1271),
    [anon_sym_PIPE_AMP] = ACTIONS(1271),
    [anon_sym_AMP_AMP] = ACTIONS(1271),
    [anon_sym_PIPE_PIPE] = ACTIONS(1271),
    [anon_sym_EQ_TILDE] = ACTIONS(1273),
    [anon_sym_EQ_EQ] = ACTIONS(1273),
    [anon_sym_LT] = ACTIONS(1273),
    [anon_sym_GT] = ACTIONS(1273),
    [anon_sym_GT_GT] = ACTIONS(1271),
    [anon_sym_AMP_GT] = ACTIONS(1273),
    [anon_sym_AMP_GT_GT] = ACTIONS(1271),
    [anon_sym_LT_AMP] = ACTIONS(1271),
    [anon_sym_GT_AMP] = ACTIONS(1271),
    [anon_sym_LT_LT] = ACTIONS(1273),
    [anon_sym_LT_LT_DASH] = ACTIONS(1271),
    [anon_sym_LT_LT_LT] = ACTIONS(1271),
    [anon_sym_DOLLAR] = ACTIONS(1273),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [sym_raw_string] = ACTIONS(1271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1271),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1271),
    [anon_sym_BQUOTE] = ACTIONS(1271),
    [anon_sym_LT_LPAREN] = ACTIONS(1271),
    [anon_sym_GT_LPAREN] = ACTIONS(1271),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1273),
    [anon_sym_LF] = ACTIONS(1271),
    [anon_sym_AMP] = ACTIONS(1273),
  },
  [677] = {
    [sym_file_redirect] = STATE(672),
    [sym_heredoc_redirect] = STATE(672),
    [sym_heredoc_body] = STATE(1313),
    [sym_herestring_redirect] = STATE(672),
    [aux_sym_redirected_statement_repeat1] = STATE(672),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(1187),
    [anon_sym_SEMI] = ACTIONS(2550),
    [anon_sym_PIPE] = ACTIONS(1191),
    [anon_sym_SEMI_SEMI] = ACTIONS(2552),
    [anon_sym_PIPE_AMP] = ACTIONS(1195),
    [anon_sym_AMP_AMP] = ACTIONS(1197),
    [anon_sym_PIPE_PIPE] = ACTIONS(1197),
    [anon_sym_LT] = ACTIONS(1199),
    [anon_sym_GT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_AMP_GT] = ACTIONS(1199),
    [anon_sym_AMP_GT_GT] = ACTIONS(1201),
    [anon_sym_LT_AMP] = ACTIONS(1201),
    [anon_sym_GT_AMP] = ACTIONS(1201),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(1203),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2552),
    [anon_sym_AMP] = ACTIONS(2550),
  },
  [678] = {
    [sym_file_redirect] = STATE(672),
    [sym_heredoc_redirect] = STATE(672),
    [sym_heredoc_body] = STATE(1313),
    [sym_herestring_redirect] = STATE(672),
    [aux_sym_redirected_statement_repeat1] = STATE(672),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2550),
    [anon_sym_PIPE] = ACTIONS(1191),
    [anon_sym_SEMI_SEMI] = ACTIONS(2552),
    [anon_sym_PIPE_AMP] = ACTIONS(1195),
    [anon_sym_AMP_AMP] = ACTIONS(1197),
    [anon_sym_PIPE_PIPE] = ACTIONS(1197),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(1203),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2552),
    [anon_sym_AMP] = ACTIONS(2550),
  },
  [679] = {
    [sym_concatenation] = STATE(1314),
    [sym_string] = STATE(674),
    [sym_simple_expansion] = STATE(674),
    [sym_string_expansion] = STATE(674),
    [sym_expansion] = STATE(674),
    [sym_command_substitution] = STATE(674),
    [sym_process_substitution] = STATE(674),
    [aux_sym_command_repeat2] = STATE(1314),
    [aux_sym__literal_repeat1] = STATE(676),
    [sym__simple_heredoc_body] = ACTIONS(1267),
    [sym__heredoc_body_beginning] = ACTIONS(1267),
    [sym_file_descriptor] = ACTIONS(1267),
    [anon_sym_SEMI] = ACTIONS(1269),
    [anon_sym_PIPE] = ACTIONS(1269),
    [anon_sym_SEMI_SEMI] = ACTIONS(1267),
    [anon_sym_PIPE_AMP] = ACTIONS(1267),
    [anon_sym_AMP_AMP] = ACTIONS(1267),
    [anon_sym_PIPE_PIPE] = ACTIONS(1267),
    [anon_sym_EQ_TILDE] = ACTIONS(1205),
    [anon_sym_EQ_EQ] = ACTIONS(1205),
    [anon_sym_LT] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1269),
    [anon_sym_GT_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT_GT] = ACTIONS(1267),
    [anon_sym_LT_AMP] = ACTIONS(1267),
    [anon_sym_GT_AMP] = ACTIONS(1267),
    [anon_sym_LT_LT] = ACTIONS(1269),
    [anon_sym_LT_LT_DASH] = ACTIONS(1267),
    [anon_sym_LT_LT_LT] = ACTIONS(1267),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(1207),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1209),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(1267),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1211),
    [anon_sym_LF] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(1269),
  },
  [680] = {
    [aux_sym__literal_repeat1] = STATE(680),
    [sym__simple_heredoc_body] = ACTIONS(1373),
    [sym__heredoc_body_beginning] = ACTIONS(1373),
    [sym_file_descriptor] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE_AMP] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_EQ_TILDE] = ACTIONS(1375),
    [anon_sym_EQ_EQ] = ACTIONS(1375),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_LT_LT_DASH] = ACTIONS(1373),
    [anon_sym_LT_LT_LT] = ACTIONS(1373),
    [anon_sym_DOLLAR] = ACTIONS(1375),
    [sym__special_character] = ACTIONS(1377),
    [anon_sym_DQUOTE] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1373),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [anon_sym_LT_LPAREN] = ACTIONS(1373),
    [anon_sym_GT_LPAREN] = ACTIONS(1373),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1375),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
  },
  [681] = {
    [sym__simple_heredoc_body] = ACTIONS(2554),
    [sym__heredoc_body_beginning] = ACTIONS(2554),
    [sym_file_descriptor] = ACTIONS(2554),
    [sym__concat] = ACTIONS(2554),
    [ts_builtin_sym_end] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(2556),
    [anon_sym_PIPE] = ACTIONS(2556),
    [anon_sym_RPAREN] = ACTIONS(2554),
    [anon_sym_SEMI_SEMI] = ACTIONS(2554),
    [anon_sym_PIPE_AMP] = ACTIONS(2554),
    [anon_sym_AMP_AMP] = ACTIONS(2554),
    [anon_sym_PIPE_PIPE] = ACTIONS(2554),
    [anon_sym_EQ_TILDE] = ACTIONS(2556),
    [anon_sym_EQ_EQ] = ACTIONS(2556),
    [anon_sym_LT] = ACTIONS(2556),
    [anon_sym_GT] = ACTIONS(2556),
    [anon_sym_GT_GT] = ACTIONS(2554),
    [anon_sym_AMP_GT] = ACTIONS(2556),
    [anon_sym_AMP_GT_GT] = ACTIONS(2554),
    [anon_sym_LT_AMP] = ACTIONS(2554),
    [anon_sym_GT_AMP] = ACTIONS(2554),
    [anon_sym_LT_LT] = ACTIONS(2556),
    [anon_sym_LT_LT_DASH] = ACTIONS(2554),
    [anon_sym_LT_LT_LT] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2556),
    [sym__special_character] = ACTIONS(2554),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2554),
    [anon_sym_BQUOTE] = ACTIONS(2554),
    [anon_sym_LT_LPAREN] = ACTIONS(2554),
    [anon_sym_GT_LPAREN] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2556),
    [anon_sym_LF] = ACTIONS(2554),
    [anon_sym_AMP] = ACTIONS(2556),
  },
  [682] = {
    [sym_compound_statement] = STATE(1315),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(57),
  },
  [683] = {
    [ts_builtin_sym_end] = ACTIONS(2558),
    [anon_sym_SEMI] = ACTIONS(2560),
    [anon_sym_done] = ACTIONS(2558),
    [anon_sym_fi] = ACTIONS(2558),
    [anon_sym_elif] = ACTIONS(2558),
    [anon_sym_else] = ACTIONS(2558),
    [anon_sym_esac] = ACTIONS(2558),
    [anon_sym_RPAREN] = ACTIONS(2558),
    [anon_sym_SEMI_SEMI] = ACTIONS(2558),
    [anon_sym_BQUOTE] = ACTIONS(2558),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2558),
    [anon_sym_AMP] = ACTIONS(2558),
  },
  [684] = {
    [anon_sym_DASH] = ACTIONS(2562),
    [anon_sym_DOLLAR] = ACTIONS(2562),
    [anon_sym_POUND] = ACTIONS(2562),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2564),
    [anon_sym_STAR] = ACTIONS(2566),
    [anon_sym_AT] = ACTIONS(2566),
    [anon_sym_QMARK] = ACTIONS(2566),
    [anon_sym_0] = ACTIONS(2564),
    [anon_sym__] = ACTIONS(2564),
  },
  [685] = {
    [sym_subscript] = STATE(1321),
    [sym_variable_name] = ACTIONS(2568),
    [anon_sym_BANG] = ACTIONS(2570),
    [anon_sym_DASH] = ACTIONS(2572),
    [anon_sym_DOLLAR] = ACTIONS(2572),
    [anon_sym_POUND] = ACTIONS(2570),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2574),
    [anon_sym_STAR] = ACTIONS(2576),
    [anon_sym_AT] = ACTIONS(2576),
    [anon_sym_QMARK] = ACTIONS(2576),
    [anon_sym_0] = ACTIONS(2574),
    [anon_sym__] = ACTIONS(2574),
  },
  [686] = {
    [sym__statements] = STATE(1322),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(1323),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [687] = {
    [sym__statements] = STATE(1324),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [688] = {
    [sym_simple_expansion] = STATE(1326),
    [sym_expansion] = STATE(1326),
    [sym_command_substitution] = STATE(1326),
    [aux_sym_heredoc_body_repeat1] = STATE(1326),
    [sym__heredoc_body_middle] = ACTIONS(2578),
    [sym__heredoc_body_end] = ACTIONS(2580),
    [anon_sym_DOLLAR] = ACTIONS(1225),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1227),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1229),
    [anon_sym_BQUOTE] = ACTIONS(1231),
    [sym_comment] = ACTIONS(57),
  },
  [689] = {
    [sym_concatenation] = STATE(1328),
    [sym_string] = STATE(1327),
    [sym_simple_expansion] = STATE(1327),
    [sym_string_expansion] = STATE(1327),
    [sym_expansion] = STATE(1327),
    [sym_command_substitution] = STATE(1327),
    [sym_process_substitution] = STATE(1327),
    [aux_sym__literal_repeat1] = STATE(1329),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(1243),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(2582),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2582),
  },
  [690] = {
    [sym_file_redirect] = STATE(244),
    [sym_heredoc_redirect] = STATE(244),
    [sym_herestring_redirect] = STATE(244),
    [aux_sym_redirected_statement_repeat1] = STATE(244),
    [sym__simple_heredoc_body] = ACTIONS(2584),
    [sym__heredoc_body_beginning] = ACTIONS(2584),
    [sym_file_descriptor] = ACTIONS(2584),
    [ts_builtin_sym_end] = ACTIONS(2584),
    [anon_sym_SEMI] = ACTIONS(2586),
    [anon_sym_PIPE] = ACTIONS(2586),
    [anon_sym_SEMI_SEMI] = ACTIONS(2584),
    [anon_sym_PIPE_AMP] = ACTIONS(2584),
    [anon_sym_AMP_AMP] = ACTIONS(2584),
    [anon_sym_PIPE_PIPE] = ACTIONS(2584),
    [anon_sym_LT] = ACTIONS(2586),
    [anon_sym_GT] = ACTIONS(2586),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT] = ACTIONS(2586),
    [anon_sym_AMP_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_AMP] = ACTIONS(2584),
    [anon_sym_GT_AMP] = ACTIONS(2584),
    [anon_sym_LT_LT] = ACTIONS(2586),
    [anon_sym_LT_LT_DASH] = ACTIONS(2584),
    [anon_sym_LT_LT_LT] = ACTIONS(2584),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2584),
    [anon_sym_AMP] = ACTIONS(2586),
  },
  [691] = {
    [sym_file_redirect] = STATE(244),
    [sym_heredoc_redirect] = STATE(244),
    [sym_herestring_redirect] = STATE(244),
    [aux_sym_redirected_statement_repeat1] = STATE(244),
    [sym__simple_heredoc_body] = ACTIONS(2584),
    [sym__heredoc_body_beginning] = ACTIONS(2584),
    [sym_file_descriptor] = ACTIONS(2584),
    [sym_variable_name] = ACTIONS(433),
    [ts_builtin_sym_end] = ACTIONS(2584),
    [anon_sym_SEMI] = ACTIONS(2586),
    [anon_sym_PIPE] = ACTIONS(2586),
    [anon_sym_SEMI_SEMI] = ACTIONS(2584),
    [anon_sym_PIPE_AMP] = ACTIONS(2584),
    [anon_sym_AMP_AMP] = ACTIONS(2584),
    [anon_sym_PIPE_PIPE] = ACTIONS(2584),
    [anon_sym_LT] = ACTIONS(2586),
    [anon_sym_GT] = ACTIONS(2586),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT] = ACTIONS(2586),
    [anon_sym_AMP_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_AMP] = ACTIONS(2584),
    [anon_sym_GT_AMP] = ACTIONS(2584),
    [anon_sym_LT_LT] = ACTIONS(2586),
    [anon_sym_LT_LT_DASH] = ACTIONS(2584),
    [anon_sym_LT_LT_LT] = ACTIONS(2584),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2584),
    [anon_sym_AMP] = ACTIONS(2586),
  },
  [692] = {
    [sym_file_redirect] = STATE(244),
    [sym_heredoc_redirect] = STATE(244),
    [sym_herestring_redirect] = STATE(244),
    [aux_sym_redirected_statement_repeat1] = STATE(244),
    [sym__simple_heredoc_body] = ACTIONS(2588),
    [sym__heredoc_body_beginning] = ACTIONS(2588),
    [sym_file_descriptor] = ACTIONS(2588),
    [ts_builtin_sym_end] = ACTIONS(2588),
    [anon_sym_SEMI] = ACTIONS(2590),
    [anon_sym_PIPE] = ACTIONS(403),
    [anon_sym_SEMI_SEMI] = ACTIONS(2588),
    [anon_sym_PIPE_AMP] = ACTIONS(407),
    [anon_sym_AMP_AMP] = ACTIONS(2588),
    [anon_sym_PIPE_PIPE] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(2590),
    [anon_sym_GT] = ACTIONS(2590),
    [anon_sym_GT_GT] = ACTIONS(2588),
    [anon_sym_AMP_GT] = ACTIONS(2590),
    [anon_sym_AMP_GT_GT] = ACTIONS(2588),
    [anon_sym_LT_AMP] = ACTIONS(2588),
    [anon_sym_GT_AMP] = ACTIONS(2588),
    [anon_sym_LT_LT] = ACTIONS(2590),
    [anon_sym_LT_LT_DASH] = ACTIONS(2588),
    [anon_sym_LT_LT_LT] = ACTIONS(2588),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2588),
    [anon_sym_AMP] = ACTIONS(2590),
  },
  [693] = {
    [sym_file_redirect] = STATE(244),
    [sym_heredoc_redirect] = STATE(244),
    [sym_herestring_redirect] = STATE(244),
    [aux_sym_redirected_statement_repeat1] = STATE(244),
    [sym__simple_heredoc_body] = ACTIONS(2588),
    [sym__heredoc_body_beginning] = ACTIONS(2588),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [ts_builtin_sym_end] = ACTIONS(2588),
    [anon_sym_SEMI] = ACTIONS(2590),
    [anon_sym_PIPE] = ACTIONS(403),
    [anon_sym_SEMI_SEMI] = ACTIONS(2588),
    [anon_sym_PIPE_AMP] = ACTIONS(407),
    [anon_sym_AMP_AMP] = ACTIONS(2588),
    [anon_sym_PIPE_PIPE] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(2590),
    [anon_sym_LT_LT_DASH] = ACTIONS(2588),
    [anon_sym_LT_LT_LT] = ACTIONS(2588),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2588),
    [anon_sym_AMP] = ACTIONS(2590),
  },
  [694] = {
    [aux_sym_concatenation_repeat1] = STATE(1330),
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(337),
    [ts_builtin_sym_end] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [sym__special_character] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [695] = {
    [aux_sym_concatenation_repeat1] = STATE(1330),
    [sym__simple_heredoc_body] = ACTIONS(1037),
    [sym__heredoc_body_beginning] = ACTIONS(1037),
    [sym_file_descriptor] = ACTIONS(1037),
    [sym__concat] = ACTIONS(337),
    [ts_builtin_sym_end] = ACTIONS(1037),
    [anon_sym_SEMI] = ACTIONS(1039),
    [anon_sym_PIPE] = ACTIONS(1039),
    [anon_sym_SEMI_SEMI] = ACTIONS(1037),
    [anon_sym_PIPE_AMP] = ACTIONS(1037),
    [anon_sym_AMP_AMP] = ACTIONS(1037),
    [anon_sym_PIPE_PIPE] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1039),
    [anon_sym_GT] = ACTIONS(1039),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_AMP_GT] = ACTIONS(1039),
    [anon_sym_AMP_GT_GT] = ACTIONS(1037),
    [anon_sym_LT_AMP] = ACTIONS(1037),
    [anon_sym_GT_AMP] = ACTIONS(1037),
    [anon_sym_LT_LT] = ACTIONS(1039),
    [anon_sym_LT_LT_DASH] = ACTIONS(1037),
    [anon_sym_LT_LT_LT] = ACTIONS(1037),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1037),
    [anon_sym_AMP] = ACTIONS(1039),
  },
  [696] = {
    [sym__simple_heredoc_body] = ACTIONS(1037),
    [sym__heredoc_body_beginning] = ACTIONS(1037),
    [sym_file_descriptor] = ACTIONS(1037),
    [ts_builtin_sym_end] = ACTIONS(1037),
    [anon_sym_SEMI] = ACTIONS(1039),
    [anon_sym_done] = ACTIONS(1037),
    [anon_sym_fi] = ACTIONS(1037),
    [anon_sym_elif] = ACTIONS(1037),
    [anon_sym_else] = ACTIONS(1037),
    [anon_sym_esac] = ACTIONS(1037),
    [anon_sym_PIPE] = ACTIONS(1039),
    [anon_sym_RPAREN] = ACTIONS(1037),
    [anon_sym_SEMI_SEMI] = ACTIONS(1037),
    [anon_sym_PIPE_AMP] = ACTIONS(1037),
    [anon_sym_AMP_AMP] = ACTIONS(1037),
    [anon_sym_PIPE_PIPE] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1039),
    [anon_sym_GT] = ACTIONS(1039),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_AMP_GT] = ACTIONS(1039),
    [anon_sym_AMP_GT_GT] = ACTIONS(1037),
    [anon_sym_LT_AMP] = ACTIONS(1037),
    [anon_sym_GT_AMP] = ACTIONS(1037),
    [anon_sym_LT_LT] = ACTIONS(1039),
    [anon_sym_LT_LT_DASH] = ACTIONS(1037),
    [anon_sym_LT_LT_LT] = ACTIONS(1037),
    [anon_sym_BQUOTE] = ACTIONS(1037),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1037),
    [anon_sym_AMP] = ACTIONS(1039),
  },
  [697] = {
    [aux_sym__literal_repeat1] = STATE(1331),
    [sym__simple_heredoc_body] = ACTIONS(1051),
    [sym__heredoc_body_beginning] = ACTIONS(1051),
    [sym_file_descriptor] = ACTIONS(1051),
    [ts_builtin_sym_end] = ACTIONS(1051),
    [anon_sym_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE] = ACTIONS(1053),
    [anon_sym_SEMI_SEMI] = ACTIONS(1051),
    [anon_sym_PIPE_AMP] = ACTIONS(1051),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_PIPE_PIPE] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT_GT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1051),
    [anon_sym_GT_AMP] = ACTIONS(1051),
    [anon_sym_LT_LT] = ACTIONS(1053),
    [anon_sym_LT_LT_DASH] = ACTIONS(1051),
    [anon_sym_LT_LT_LT] = ACTIONS(1051),
    [sym__special_character] = ACTIONS(441),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1051),
    [anon_sym_AMP] = ACTIONS(1053),
  },
  [698] = {
    [sym__simple_heredoc_body] = ACTIONS(2592),
    [sym__heredoc_body_beginning] = ACTIONS(2592),
    [sym_file_descriptor] = ACTIONS(2592),
    [ts_builtin_sym_end] = ACTIONS(2592),
    [anon_sym_SEMI] = ACTIONS(2594),
    [anon_sym_done] = ACTIONS(2592),
    [anon_sym_fi] = ACTIONS(2592),
    [anon_sym_elif] = ACTIONS(2592),
    [anon_sym_else] = ACTIONS(2592),
    [anon_sym_esac] = ACTIONS(2592),
    [anon_sym_PIPE] = ACTIONS(2594),
    [anon_sym_RPAREN] = ACTIONS(2592),
    [anon_sym_SEMI_SEMI] = ACTIONS(2592),
    [anon_sym_PIPE_AMP] = ACTIONS(2592),
    [anon_sym_AMP_AMP] = ACTIONS(2592),
    [anon_sym_PIPE_PIPE] = ACTIONS(2592),
    [anon_sym_LT] = ACTIONS(2594),
    [anon_sym_GT] = ACTIONS(2594),
    [anon_sym_GT_GT] = ACTIONS(2592),
    [anon_sym_AMP_GT] = ACTIONS(2594),
    [anon_sym_AMP_GT_GT] = ACTIONS(2592),
    [anon_sym_LT_AMP] = ACTIONS(2592),
    [anon_sym_GT_AMP] = ACTIONS(2592),
    [anon_sym_LT_LT] = ACTIONS(2594),
    [anon_sym_LT_LT_DASH] = ACTIONS(2592),
    [anon_sym_LT_LT_LT] = ACTIONS(2592),
    [anon_sym_BQUOTE] = ACTIONS(2592),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2592),
    [anon_sym_AMP] = ACTIONS(2594),
  },
  [699] = {
    [aux_sym_concatenation_repeat1] = STATE(1330),
    [sym__simple_heredoc_body] = ACTIONS(2596),
    [sym__heredoc_body_beginning] = ACTIONS(2596),
    [sym_file_descriptor] = ACTIONS(2596),
    [sym__concat] = ACTIONS(337),
    [ts_builtin_sym_end] = ACTIONS(2596),
    [anon_sym_SEMI] = ACTIONS(2598),
    [anon_sym_PIPE] = ACTIONS(2598),
    [anon_sym_SEMI_SEMI] = ACTIONS(2596),
    [anon_sym_PIPE_AMP] = ACTIONS(2596),
    [anon_sym_AMP_AMP] = ACTIONS(2596),
    [anon_sym_PIPE_PIPE] = ACTIONS(2596),
    [anon_sym_LT] = ACTIONS(2598),
    [anon_sym_GT] = ACTIONS(2598),
    [anon_sym_GT_GT] = ACTIONS(2596),
    [anon_sym_AMP_GT] = ACTIONS(2598),
    [anon_sym_AMP_GT_GT] = ACTIONS(2596),
    [anon_sym_LT_AMP] = ACTIONS(2596),
    [anon_sym_GT_AMP] = ACTIONS(2596),
    [anon_sym_LT_LT] = ACTIONS(2598),
    [anon_sym_LT_LT_DASH] = ACTIONS(2596),
    [anon_sym_LT_LT_LT] = ACTIONS(2596),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2596),
    [anon_sym_AMP] = ACTIONS(2598),
  },
  [700] = {
    [sym__simple_heredoc_body] = ACTIONS(2596),
    [sym__heredoc_body_beginning] = ACTIONS(2596),
    [sym_file_descriptor] = ACTIONS(2596),
    [ts_builtin_sym_end] = ACTIONS(2596),
    [anon_sym_SEMI] = ACTIONS(2598),
    [anon_sym_done] = ACTIONS(2596),
    [anon_sym_fi] = ACTIONS(2596),
    [anon_sym_elif] = ACTIONS(2596),
    [anon_sym_else] = ACTIONS(2596),
    [anon_sym_esac] = ACTIONS(2596),
    [anon_sym_PIPE] = ACTIONS(2598),
    [anon_sym_RPAREN] = ACTIONS(2596),
    [anon_sym_SEMI_SEMI] = ACTIONS(2596),
    [anon_sym_PIPE_AMP] = ACTIONS(2596),
    [anon_sym_AMP_AMP] = ACTIONS(2596),
    [anon_sym_PIPE_PIPE] = ACTIONS(2596),
    [anon_sym_LT] = ACTIONS(2598),
    [anon_sym_GT] = ACTIONS(2598),
    [anon_sym_GT_GT] = ACTIONS(2596),
    [anon_sym_AMP_GT] = ACTIONS(2598),
    [anon_sym_AMP_GT_GT] = ACTIONS(2596),
    [anon_sym_LT_AMP] = ACTIONS(2596),
    [anon_sym_GT_AMP] = ACTIONS(2596),
    [anon_sym_LT_LT] = ACTIONS(2598),
    [anon_sym_LT_LT_DASH] = ACTIONS(2596),
    [anon_sym_LT_LT_LT] = ACTIONS(2596),
    [anon_sym_BQUOTE] = ACTIONS(2596),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2596),
    [anon_sym_AMP] = ACTIONS(2598),
  },
  [701] = {
    [aux_sym__literal_repeat1] = STATE(1331),
    [sym__simple_heredoc_body] = ACTIONS(2600),
    [sym__heredoc_body_beginning] = ACTIONS(2600),
    [sym_file_descriptor] = ACTIONS(2600),
    [ts_builtin_sym_end] = ACTIONS(2600),
    [anon_sym_SEMI] = ACTIONS(2602),
    [anon_sym_PIPE] = ACTIONS(2602),
    [anon_sym_SEMI_SEMI] = ACTIONS(2600),
    [anon_sym_PIPE_AMP] = ACTIONS(2600),
    [anon_sym_AMP_AMP] = ACTIONS(2600),
    [anon_sym_PIPE_PIPE] = ACTIONS(2600),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_GT_GT] = ACTIONS(2600),
    [anon_sym_AMP_GT] = ACTIONS(2602),
    [anon_sym_AMP_GT_GT] = ACTIONS(2600),
    [anon_sym_LT_AMP] = ACTIONS(2600),
    [anon_sym_GT_AMP] = ACTIONS(2600),
    [anon_sym_LT_LT] = ACTIONS(2602),
    [anon_sym_LT_LT_DASH] = ACTIONS(2600),
    [anon_sym_LT_LT_LT] = ACTIONS(2600),
    [sym__special_character] = ACTIONS(441),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2600),
    [anon_sym_AMP] = ACTIONS(2602),
  },
  [702] = {
    [sym_file_descriptor] = ACTIONS(2604),
    [sym_variable_name] = ACTIONS(2604),
    [ts_builtin_sym_end] = ACTIONS(2606),
    [anon_sym_for] = ACTIONS(2608),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2608),
    [anon_sym_if] = ACTIONS(2608),
    [anon_sym_case] = ACTIONS(2608),
    [anon_sym_RPAREN] = ACTIONS(2606),
    [anon_sym_SEMI_SEMI] = ACTIONS(2606),
    [anon_sym_function] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(2608),
    [anon_sym_LBRACE] = ACTIONS(2604),
    [anon_sym_BANG] = ACTIONS(2608),
    [anon_sym_LBRACK] = ACTIONS(2608),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2604),
    [anon_sym_declare] = ACTIONS(2608),
    [anon_sym_typeset] = ACTIONS(2608),
    [anon_sym_export] = ACTIONS(2608),
    [anon_sym_readonly] = ACTIONS(2608),
    [anon_sym_local] = ACTIONS(2608),
    [anon_sym_unset] = ACTIONS(2608),
    [anon_sym_unsetenv] = ACTIONS(2608),
    [anon_sym_LT] = ACTIONS(2608),
    [anon_sym_GT] = ACTIONS(2608),
    [anon_sym_GT_GT] = ACTIONS(2604),
    [anon_sym_AMP_GT] = ACTIONS(2608),
    [anon_sym_AMP_GT_GT] = ACTIONS(2604),
    [anon_sym_LT_AMP] = ACTIONS(2604),
    [anon_sym_GT_AMP] = ACTIONS(2604),
    [anon_sym_DOLLAR] = ACTIONS(2608),
    [sym__special_character] = ACTIONS(2608),
    [anon_sym_DQUOTE] = ACTIONS(2604),
    [sym_raw_string] = ACTIONS(2604),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2604),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2604),
    [anon_sym_BQUOTE] = ACTIONS(2604),
    [anon_sym_LT_LPAREN] = ACTIONS(2604),
    [anon_sym_GT_LPAREN] = ACTIONS(2604),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2608),
  },
  [703] = {
    [sym_file_redirect] = STATE(703),
    [sym_heredoc_redirect] = STATE(703),
    [sym_herestring_redirect] = STATE(703),
    [aux_sym_redirected_statement_repeat1] = STATE(703),
    [sym__simple_heredoc_body] = ACTIONS(2610),
    [sym__heredoc_body_beginning] = ACTIONS(2610),
    [sym_file_descriptor] = ACTIONS(2612),
    [ts_builtin_sym_end] = ACTIONS(2610),
    [anon_sym_SEMI] = ACTIONS(2615),
    [anon_sym_PIPE] = ACTIONS(2615),
    [anon_sym_SEMI_SEMI] = ACTIONS(2610),
    [anon_sym_PIPE_AMP] = ACTIONS(2610),
    [anon_sym_AMP_AMP] = ACTIONS(2610),
    [anon_sym_PIPE_PIPE] = ACTIONS(2610),
    [anon_sym_LT] = ACTIONS(2617),
    [anon_sym_GT] = ACTIONS(2617),
    [anon_sym_GT_GT] = ACTIONS(2620),
    [anon_sym_AMP_GT] = ACTIONS(2617),
    [anon_sym_AMP_GT_GT] = ACTIONS(2620),
    [anon_sym_LT_AMP] = ACTIONS(2620),
    [anon_sym_GT_AMP] = ACTIONS(2620),
    [anon_sym_LT_LT] = ACTIONS(2623),
    [anon_sym_LT_LT_DASH] = ACTIONS(2626),
    [anon_sym_LT_LT_LT] = ACTIONS(2629),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2610),
    [anon_sym_AMP] = ACTIONS(2615),
  },
  [704] = {
    [sym__simple_heredoc_body] = ACTIONS(2632),
    [sym__heredoc_body_beginning] = ACTIONS(2632),
    [sym_file_descriptor] = ACTIONS(2632),
    [ts_builtin_sym_end] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2634),
    [anon_sym_RPAREN] = ACTIONS(2632),
    [anon_sym_SEMI_SEMI] = ACTIONS(2632),
    [anon_sym_PIPE_AMP] = ACTIONS(2632),
    [anon_sym_AMP_AMP] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2632),
    [anon_sym_EQ_TILDE] = ACTIONS(2634),
    [anon_sym_EQ_EQ] = ACTIONS(2634),
    [anon_sym_LT] = ACTIONS(2634),
    [anon_sym_GT] = ACTIONS(2634),
    [anon_sym_GT_GT] = ACTIONS(2632),
    [anon_sym_AMP_GT] = ACTIONS(2634),
    [anon_sym_AMP_GT_GT] = ACTIONS(2632),
    [anon_sym_LT_AMP] = ACTIONS(2632),
    [anon_sym_GT_AMP] = ACTIONS(2632),
    [anon_sym_LT_LT] = ACTIONS(2634),
    [anon_sym_LT_LT_DASH] = ACTIONS(2632),
    [anon_sym_LT_LT_LT] = ACTIONS(2632),
    [anon_sym_DOLLAR] = ACTIONS(2634),
    [sym__special_character] = ACTIONS(2632),
    [anon_sym_DQUOTE] = ACTIONS(2632),
    [sym_raw_string] = ACTIONS(2632),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2632),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2632),
    [anon_sym_BQUOTE] = ACTIONS(2632),
    [anon_sym_LT_LPAREN] = ACTIONS(2632),
    [anon_sym_GT_LPAREN] = ACTIONS(2632),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2634),
    [anon_sym_LF] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2634),
  },
  [705] = {
    [aux_sym_concatenation_repeat1] = STATE(201),
    [sym__simple_heredoc_body] = ACTIONS(2632),
    [sym__heredoc_body_beginning] = ACTIONS(2632),
    [sym_file_descriptor] = ACTIONS(2632),
    [sym__concat] = ACTIONS(337),
    [ts_builtin_sym_end] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2634),
    [anon_sym_SEMI_SEMI] = ACTIONS(2632),
    [anon_sym_PIPE_AMP] = ACTIONS(2632),
    [anon_sym_AMP_AMP] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2632),
    [anon_sym_EQ_TILDE] = ACTIONS(2634),
    [anon_sym_EQ_EQ] = ACTIONS(2634),
    [anon_sym_LT] = ACTIONS(2634),
    [anon_sym_GT] = ACTIONS(2634),
    [anon_sym_GT_GT] = ACTIONS(2632),
    [anon_sym_AMP_GT] = ACTIONS(2634),
    [anon_sym_AMP_GT_GT] = ACTIONS(2632),
    [anon_sym_LT_AMP] = ACTIONS(2632),
    [anon_sym_GT_AMP] = ACTIONS(2632),
    [anon_sym_LT_LT] = ACTIONS(2634),
    [anon_sym_LT_LT_DASH] = ACTIONS(2632),
    [anon_sym_LT_LT_LT] = ACTIONS(2632),
    [anon_sym_DOLLAR] = ACTIONS(2634),
    [sym__special_character] = ACTIONS(2632),
    [anon_sym_DQUOTE] = ACTIONS(2632),
    [sym_raw_string] = ACTIONS(2632),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2632),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2632),
    [anon_sym_BQUOTE] = ACTIONS(2632),
    [anon_sym_LT_LPAREN] = ACTIONS(2632),
    [anon_sym_GT_LPAREN] = ACTIONS(2632),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2634),
    [anon_sym_LF] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2634),
  },
  [706] = {
    [aux_sym__literal_repeat1] = STATE(255),
    [sym__simple_heredoc_body] = ACTIONS(2636),
    [sym__heredoc_body_beginning] = ACTIONS(2636),
    [sym_file_descriptor] = ACTIONS(2636),
    [ts_builtin_sym_end] = ACTIONS(2636),
    [anon_sym_SEMI] = ACTIONS(2638),
    [anon_sym_PIPE] = ACTIONS(2638),
    [anon_sym_SEMI_SEMI] = ACTIONS(2636),
    [anon_sym_PIPE_AMP] = ACTIONS(2636),
    [anon_sym_AMP_AMP] = ACTIONS(2636),
    [anon_sym_PIPE_PIPE] = ACTIONS(2636),
    [anon_sym_EQ_TILDE] = ACTIONS(2638),
    [anon_sym_EQ_EQ] = ACTIONS(2638),
    [anon_sym_LT] = ACTIONS(2638),
    [anon_sym_GT] = ACTIONS(2638),
    [anon_sym_GT_GT] = ACTIONS(2636),
    [anon_sym_AMP_GT] = ACTIONS(2638),
    [anon_sym_AMP_GT_GT] = ACTIONS(2636),
    [anon_sym_LT_AMP] = ACTIONS(2636),
    [anon_sym_GT_AMP] = ACTIONS(2636),
    [anon_sym_LT_LT] = ACTIONS(2638),
    [anon_sym_LT_LT_DASH] = ACTIONS(2636),
    [anon_sym_LT_LT_LT] = ACTIONS(2636),
    [anon_sym_DOLLAR] = ACTIONS(2638),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(2636),
    [sym_raw_string] = ACTIONS(2636),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2636),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2636),
    [anon_sym_BQUOTE] = ACTIONS(2636),
    [anon_sym_LT_LPAREN] = ACTIONS(2636),
    [anon_sym_GT_LPAREN] = ACTIONS(2636),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2638),
    [anon_sym_LF] = ACTIONS(2636),
    [anon_sym_AMP] = ACTIONS(2638),
  },
  [707] = {
    [sym_concatenation] = STATE(707),
    [sym_string] = STATE(246),
    [sym_simple_expansion] = STATE(246),
    [sym_string_expansion] = STATE(246),
    [sym_expansion] = STATE(246),
    [sym_command_substitution] = STATE(246),
    [sym_process_substitution] = STATE(246),
    [aux_sym_command_repeat2] = STATE(707),
    [aux_sym__literal_repeat1] = STATE(248),
    [sym__simple_heredoc_body] = ACTIONS(2632),
    [sym__heredoc_body_beginning] = ACTIONS(2632),
    [sym_file_descriptor] = ACTIONS(2632),
    [ts_builtin_sym_end] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2634),
    [anon_sym_SEMI_SEMI] = ACTIONS(2632),
    [anon_sym_PIPE_AMP] = ACTIONS(2632),
    [anon_sym_AMP_AMP] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2632),
    [anon_sym_EQ_TILDE] = ACTIONS(2640),
    [anon_sym_EQ_EQ] = ACTIONS(2640),
    [anon_sym_LT] = ACTIONS(2634),
    [anon_sym_GT] = ACTIONS(2634),
    [anon_sym_GT_GT] = ACTIONS(2632),
    [anon_sym_AMP_GT] = ACTIONS(2634),
    [anon_sym_AMP_GT_GT] = ACTIONS(2632),
    [anon_sym_LT_AMP] = ACTIONS(2632),
    [anon_sym_GT_AMP] = ACTIONS(2632),
    [anon_sym_LT_LT] = ACTIONS(2634),
    [anon_sym_LT_LT_DASH] = ACTIONS(2632),
    [anon_sym_LT_LT_LT] = ACTIONS(2632),
    [anon_sym_DOLLAR] = ACTIONS(2643),
    [sym__special_character] = ACTIONS(2646),
    [anon_sym_DQUOTE] = ACTIONS(2649),
    [sym_raw_string] = ACTIONS(2652),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2655),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2661),
    [anon_sym_LT_LPAREN] = ACTIONS(2664),
    [anon_sym_GT_LPAREN] = ACTIONS(2664),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2667),
    [anon_sym_LF] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2634),
  },
  [708] = {
    [sym_file_descriptor] = ACTIONS(1237),
    [sym_variable_name] = ACTIONS(1237),
    [ts_builtin_sym_end] = ACTIONS(2606),
    [anon_sym_for] = ACTIONS(1241),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1237),
    [anon_sym_while] = ACTIONS(1241),
    [anon_sym_if] = ACTIONS(1241),
    [anon_sym_case] = ACTIONS(1241),
    [anon_sym_RPAREN] = ACTIONS(2606),
    [anon_sym_SEMI_SEMI] = ACTIONS(2606),
    [anon_sym_function] = ACTIONS(1241),
    [anon_sym_LPAREN] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1237),
    [anon_sym_BANG] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(1241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1237),
    [anon_sym_declare] = ACTIONS(1241),
    [anon_sym_typeset] = ACTIONS(1241),
    [anon_sym_export] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_local] = ACTIONS(1241),
    [anon_sym_unset] = ACTIONS(1241),
    [anon_sym_unsetenv] = ACTIONS(1241),
    [anon_sym_LT] = ACTIONS(1241),
    [anon_sym_GT] = ACTIONS(1241),
    [anon_sym_GT_GT] = ACTIONS(1237),
    [anon_sym_AMP_GT] = ACTIONS(1241),
    [anon_sym_AMP_GT_GT] = ACTIONS(1237),
    [anon_sym_LT_AMP] = ACTIONS(1237),
    [anon_sym_GT_AMP] = ACTIONS(1237),
    [anon_sym_DOLLAR] = ACTIONS(1241),
    [sym__special_character] = ACTIONS(1241),
    [anon_sym_DQUOTE] = ACTIONS(1237),
    [sym_raw_string] = ACTIONS(1237),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1237),
    [anon_sym_BQUOTE] = ACTIONS(1237),
    [anon_sym_LT_LPAREN] = ACTIONS(1237),
    [anon_sym_GT_LPAREN] = ACTIONS(1237),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1241),
  },
  [709] = {
    [ts_builtin_sym_end] = ACTIONS(2606),
    [anon_sym_SEMI] = ACTIONS(2670),
    [anon_sym_RPAREN] = ACTIONS(2606),
    [anon_sym_SEMI_SEMI] = ACTIONS(2672),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2672),
    [anon_sym_AMP] = ACTIONS(2672),
  },
  [710] = {
    [sym_subshell] = STATE(146),
    [sym_test_command] = STATE(146),
    [sym_command] = STATE(146),
    [sym_command_name] = STATE(714),
    [sym_variable_assignment] = STATE(716),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(716),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym_command_repeat1] = STATE(716),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(383),
  },
  [711] = {
    [sym_variable_assignment] = STATE(1333),
    [sym_subscript] = STATE(657),
    [sym_concatenation] = STATE(1333),
    [sym_string] = STATE(656),
    [sym_simple_expansion] = STATE(656),
    [sym_string_expansion] = STATE(656),
    [sym_expansion] = STATE(656),
    [sym_command_substitution] = STATE(656),
    [sym_process_substitution] = STATE(656),
    [aux_sym_declaration_command_repeat1] = STATE(1333),
    [aux_sym__literal_repeat1] = STATE(659),
    [sym__simple_heredoc_body] = ACTIONS(259),
    [sym__heredoc_body_beginning] = ACTIONS(259),
    [sym_file_descriptor] = ACTIONS(259),
    [sym_variable_name] = ACTIONS(1169),
    [anon_sym_SEMI] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_SEMI_SEMI] = ACTIONS(259),
    [anon_sym_PIPE_AMP] = ACTIONS(259),
    [anon_sym_AMP_AMP] = ACTIONS(259),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_LT] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_GT_GT] = ACTIONS(259),
    [anon_sym_AMP_GT] = ACTIONS(263),
    [anon_sym_AMP_GT_GT] = ACTIONS(259),
    [anon_sym_LT_AMP] = ACTIONS(259),
    [anon_sym_GT_AMP] = ACTIONS(259),
    [anon_sym_LT_LT] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(259),
    [anon_sym_LT_LT_LT] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(265),
    [sym__special_character] = ACTIONS(1171),
    [anon_sym_DQUOTE] = ACTIONS(269),
    [sym_raw_string] = ACTIONS(1173),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(277),
    [anon_sym_LT_LPAREN] = ACTIONS(279),
    [anon_sym_GT_LPAREN] = ACTIONS(279),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2674),
    [sym_word] = ACTIONS(1177),
    [anon_sym_LF] = ACTIONS(259),
    [anon_sym_AMP] = ACTIONS(263),
  },
  [712] = {
    [sym_concatenation] = STATE(1334),
    [sym_string] = STATE(661),
    [sym_simple_expansion] = STATE(661),
    [sym_string_expansion] = STATE(661),
    [sym_expansion] = STATE(661),
    [sym_command_substitution] = STATE(661),
    [sym_process_substitution] = STATE(661),
    [aux_sym_unset_command_repeat1] = STATE(1334),
    [aux_sym__literal_repeat1] = STATE(663),
    [sym__simple_heredoc_body] = ACTIONS(285),
    [sym__heredoc_body_beginning] = ACTIONS(285),
    [sym_file_descriptor] = ACTIONS(285),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(285),
    [anon_sym_PIPE_AMP] = ACTIONS(285),
    [anon_sym_AMP_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(287),
    [anon_sym_GT] = ACTIONS(287),
    [anon_sym_GT_GT] = ACTIONS(285),
    [anon_sym_AMP_GT] = ACTIONS(287),
    [anon_sym_AMP_GT_GT] = ACTIONS(285),
    [anon_sym_LT_AMP] = ACTIONS(285),
    [anon_sym_GT_AMP] = ACTIONS(285),
    [anon_sym_LT_LT] = ACTIONS(287),
    [anon_sym_LT_LT_DASH] = ACTIONS(285),
    [anon_sym_LT_LT_LT] = ACTIONS(285),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym__special_character] = ACTIONS(1179),
    [anon_sym_DQUOTE] = ACTIONS(293),
    [sym_raw_string] = ACTIONS(1181),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(297),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(301),
    [anon_sym_LT_LPAREN] = ACTIONS(303),
    [anon_sym_GT_LPAREN] = ACTIONS(303),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2676),
    [sym_word] = ACTIONS(1185),
    [anon_sym_LF] = ACTIONS(285),
    [anon_sym_AMP] = ACTIONS(287),
  },
  [713] = {
    [sym_file_redirect] = STATE(1342),
    [sym_heredoc_redirect] = STATE(1342),
    [sym_heredoc_body] = STATE(1341),
    [sym_herestring_redirect] = STATE(1342),
    [aux_sym_redirected_statement_repeat1] = STATE(1342),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(2678),
    [anon_sym_SEMI] = ACTIONS(2680),
    [anon_sym_PIPE] = ACTIONS(2682),
    [anon_sym_SEMI_SEMI] = ACTIONS(2684),
    [anon_sym_PIPE_AMP] = ACTIONS(2686),
    [anon_sym_AMP_AMP] = ACTIONS(2688),
    [anon_sym_PIPE_PIPE] = ACTIONS(2688),
    [anon_sym_LT] = ACTIONS(2690),
    [anon_sym_GT] = ACTIONS(2690),
    [anon_sym_GT_GT] = ACTIONS(2692),
    [anon_sym_AMP_GT] = ACTIONS(2690),
    [anon_sym_AMP_GT_GT] = ACTIONS(2692),
    [anon_sym_LT_AMP] = ACTIONS(2692),
    [anon_sym_GT_AMP] = ACTIONS(2692),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(2694),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2684),
    [anon_sym_AMP] = ACTIONS(2680),
  },
  [714] = {
    [sym_concatenation] = STATE(1343),
    [sym_string] = STATE(674),
    [sym_simple_expansion] = STATE(674),
    [sym_string_expansion] = STATE(674),
    [sym_expansion] = STATE(674),
    [sym_command_substitution] = STATE(674),
    [sym_process_substitution] = STATE(674),
    [aux_sym_command_repeat2] = STATE(1343),
    [aux_sym__literal_repeat1] = STATE(676),
    [sym__simple_heredoc_body] = ACTIONS(421),
    [sym__heredoc_body_beginning] = ACTIONS(421),
    [sym_file_descriptor] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI_SEMI] = ACTIONS(421),
    [anon_sym_PIPE_AMP] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(1205),
    [anon_sym_EQ_EQ] = ACTIONS(1205),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_AMP_GT] = ACTIONS(423),
    [anon_sym_AMP_GT_GT] = ACTIONS(421),
    [anon_sym_LT_AMP] = ACTIONS(421),
    [anon_sym_GT_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_LT_LT_DASH] = ACTIONS(421),
    [anon_sym_LT_LT_LT] = ACTIONS(421),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(1207),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1209),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1211),
    [anon_sym_LF] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
  },
  [715] = {
    [sym_file_redirect] = STATE(1342),
    [sym_heredoc_redirect] = STATE(1342),
    [sym_heredoc_body] = STATE(1341),
    [sym_herestring_redirect] = STATE(1342),
    [aux_sym_redirected_statement_repeat1] = STATE(1342),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2680),
    [anon_sym_PIPE] = ACTIONS(2682),
    [anon_sym_SEMI_SEMI] = ACTIONS(2684),
    [anon_sym_PIPE_AMP] = ACTIONS(2686),
    [anon_sym_AMP_AMP] = ACTIONS(2688),
    [anon_sym_PIPE_PIPE] = ACTIONS(2688),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(2694),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2684),
    [anon_sym_AMP] = ACTIONS(2680),
  },
  [716] = {
    [sym_command_name] = STATE(1344),
    [sym_variable_assignment] = STATE(253),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(253),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym_command_repeat1] = STATE(253),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(1207),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(383),
  },
  [717] = {
    [sym_concatenation] = STATE(707),
    [sym_string] = STATE(246),
    [sym_simple_expansion] = STATE(246),
    [sym_string_expansion] = STATE(246),
    [sym_expansion] = STATE(246),
    [sym_command_substitution] = STATE(246),
    [sym_process_substitution] = STATE(246),
    [aux_sym_command_repeat2] = STATE(707),
    [aux_sym__literal_repeat1] = STATE(248),
    [sym__simple_heredoc_body] = ACTIONS(2696),
    [sym__heredoc_body_beginning] = ACTIONS(2696),
    [sym_file_descriptor] = ACTIONS(2696),
    [ts_builtin_sym_end] = ACTIONS(2696),
    [anon_sym_SEMI] = ACTIONS(2698),
    [anon_sym_PIPE] = ACTIONS(2698),
    [anon_sym_SEMI_SEMI] = ACTIONS(2696),
    [anon_sym_PIPE_AMP] = ACTIONS(2696),
    [anon_sym_AMP_AMP] = ACTIONS(2696),
    [anon_sym_PIPE_PIPE] = ACTIONS(2696),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT] = ACTIONS(2698),
    [anon_sym_GT] = ACTIONS(2698),
    [anon_sym_GT_GT] = ACTIONS(2696),
    [anon_sym_AMP_GT] = ACTIONS(2698),
    [anon_sym_AMP_GT_GT] = ACTIONS(2696),
    [anon_sym_LT_AMP] = ACTIONS(2696),
    [anon_sym_GT_AMP] = ACTIONS(2696),
    [anon_sym_LT_LT] = ACTIONS(2698),
    [anon_sym_LT_LT_DASH] = ACTIONS(2696),
    [anon_sym_LT_LT_LT] = ACTIONS(2696),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(427),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(429),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(431),
    [anon_sym_LF] = ACTIONS(2696),
    [anon_sym_AMP] = ACTIONS(2698),
  },
  [718] = {
    [aux_sym_concatenation_repeat1] = STATE(1346),
    [sym__concat] = ACTIONS(2700),
    [anon_sym_RBRACK] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
  },
  [719] = {
    [sym_string] = STATE(1149),
    [sym_simple_expansion] = STATE(1149),
    [sym_string_expansion] = STATE(1149),
    [sym_expansion] = STATE(1149),
    [sym_command_substitution] = STATE(1149),
    [sym_process_substitution] = STATE(1149),
    [anon_sym_RBRACK] = ACTIONS(2702),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__special_character] = ACTIONS(2704),
    [anon_sym_DQUOTE] = ACTIONS(233),
    [sym_raw_string] = ACTIONS(2116),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [anon_sym_LT_LPAREN] = ACTIONS(243),
    [anon_sym_GT_LPAREN] = ACTIONS(243),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2116),
  },
  [720] = {
    [sym__concat] = ACTIONS(2706),
    [anon_sym_EQ] = ACTIONS(2708),
    [anon_sym_PLUS_EQ] = ACTIONS(2708),
    [sym_comment] = ACTIONS(57),
  },
  [721] = {
    [anon_sym_RBRACK] = ACTIONS(2702),
    [sym_comment] = ACTIONS(57),
  },
  [722] = {
    [anon_sym_RBRACK] = ACTIONS(2710),
    [sym_comment] = ACTIONS(57),
  },
  [723] = {
    [sym__concat] = ACTIONS(2712),
    [anon_sym_EQ] = ACTIONS(2714),
    [anon_sym_PLUS_EQ] = ACTIONS(2714),
    [sym_comment] = ACTIONS(57),
  },
  [724] = {
    [sym__concat] = ACTIONS(335),
    [anon_sym_RBRACK] = ACTIONS(335),
    [sym__special_character] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
  },
  [725] = {
    [aux_sym__literal_repeat1] = STATE(725),
    [sym__concat] = ACTIONS(1373),
    [anon_sym_RBRACK] = ACTIONS(1373),
    [sym__special_character] = ACTIONS(2716),
    [sym_comment] = ACTIONS(57),
  },
  [726] = {
    [sym__simple_heredoc_body] = ACTIONS(2719),
    [sym__heredoc_body_beginning] = ACTIONS(2719),
    [sym_file_descriptor] = ACTIONS(2719),
    [sym_variable_name] = ACTIONS(2719),
    [ts_builtin_sym_end] = ACTIONS(2719),
    [anon_sym_SEMI] = ACTIONS(2721),
    [anon_sym_PIPE] = ACTIONS(2721),
    [anon_sym_RPAREN] = ACTIONS(2719),
    [anon_sym_SEMI_SEMI] = ACTIONS(2719),
    [anon_sym_PIPE_AMP] = ACTIONS(2719),
    [anon_sym_AMP_AMP] = ACTIONS(2719),
    [anon_sym_PIPE_PIPE] = ACTIONS(2719),
    [anon_sym_LT] = ACTIONS(2721),
    [anon_sym_GT] = ACTIONS(2721),
    [anon_sym_GT_GT] = ACTIONS(2719),
    [anon_sym_AMP_GT] = ACTIONS(2721),
    [anon_sym_AMP_GT_GT] = ACTIONS(2719),
    [anon_sym_LT_AMP] = ACTIONS(2719),
    [anon_sym_GT_AMP] = ACTIONS(2719),
    [anon_sym_LT_LT] = ACTIONS(2721),
    [anon_sym_LT_LT_DASH] = ACTIONS(2719),
    [anon_sym_LT_LT_LT] = ACTIONS(2719),
    [anon_sym_DOLLAR] = ACTIONS(2721),
    [sym__special_character] = ACTIONS(2719),
    [anon_sym_DQUOTE] = ACTIONS(2719),
    [sym_raw_string] = ACTIONS(2719),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2719),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2719),
    [anon_sym_BQUOTE] = ACTIONS(2719),
    [anon_sym_LT_LPAREN] = ACTIONS(2719),
    [anon_sym_GT_LPAREN] = ACTIONS(2719),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2721),
    [anon_sym_LF] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2721),
  },
  [727] = {
    [sym_string] = STATE(1352),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_DOLLAR] = ACTIONS(2723),
    [anon_sym_DQUOTE] = ACTIONS(1410),
    [sym_raw_string] = ACTIONS(2725),
    [anon_sym_POUND] = ACTIONS(2723),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2727),
    [anon_sym_STAR] = ACTIONS(2729),
    [anon_sym_AT] = ACTIONS(2729),
    [anon_sym_QMARK] = ACTIONS(2729),
    [anon_sym_0] = ACTIONS(2727),
    [anon_sym__] = ACTIONS(2727),
  },
  [728] = {
    [aux_sym_concatenation_repeat1] = STATE(1355),
    [sym__concat] = ACTIONS(2731),
    [anon_sym_RPAREN] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(335),
  },
  [729] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(1358),
    [anon_sym_DOLLAR] = ACTIONS(2733),
    [anon_sym_DQUOTE] = ACTIONS(2735),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [730] = {
    [aux_sym_concatenation_repeat1] = STATE(1355),
    [sym__concat] = ACTIONS(2731),
    [anon_sym_RPAREN] = ACTIONS(2737),
    [anon_sym_DOLLAR] = ACTIONS(2739),
    [sym__special_character] = ACTIONS(2737),
    [anon_sym_DQUOTE] = ACTIONS(2737),
    [sym_raw_string] = ACTIONS(2737),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2737),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2737),
    [anon_sym_BQUOTE] = ACTIONS(2737),
    [anon_sym_LT_LPAREN] = ACTIONS(2737),
    [anon_sym_GT_LPAREN] = ACTIONS(2737),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2737),
  },
  [731] = {
    [sym_subscript] = STATE(1362),
    [sym_variable_name] = ACTIONS(2741),
    [anon_sym_BANG] = ACTIONS(2743),
    [anon_sym_DASH] = ACTIONS(2745),
    [anon_sym_DOLLAR] = ACTIONS(2745),
    [anon_sym_POUND] = ACTIONS(2743),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2747),
    [anon_sym_STAR] = ACTIONS(2749),
    [anon_sym_AT] = ACTIONS(2749),
    [anon_sym_QMARK] = ACTIONS(2749),
    [anon_sym_0] = ACTIONS(2747),
    [anon_sym__] = ACTIONS(2747),
  },
  [732] = {
    [sym__statements] = STATE(1363),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(1364),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [733] = {
    [sym__statements] = STATE(1365),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [734] = {
    [sym__statements] = STATE(1366),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [735] = {
    [sym_concatenation] = STATE(1368),
    [sym_string] = STATE(730),
    [sym_simple_expansion] = STATE(730),
    [sym_string_expansion] = STATE(730),
    [sym_expansion] = STATE(730),
    [sym_command_substitution] = STATE(730),
    [sym_process_substitution] = STATE(730),
    [aux_sym_for_statement_repeat1] = STATE(1368),
    [aux_sym__literal_repeat1] = STATE(736),
    [anon_sym_RPAREN] = ACTIONS(2751),
    [anon_sym_DOLLAR] = ACTIONS(1406),
    [sym__special_character] = ACTIONS(1408),
    [anon_sym_DQUOTE] = ACTIONS(1410),
    [sym_raw_string] = ACTIONS(1412),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1414),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1416),
    [anon_sym_BQUOTE] = ACTIONS(1418),
    [anon_sym_LT_LPAREN] = ACTIONS(1420),
    [anon_sym_GT_LPAREN] = ACTIONS(1420),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1412),
  },
  [736] = {
    [aux_sym__literal_repeat1] = STATE(1370),
    [anon_sym_RPAREN] = ACTIONS(2753),
    [anon_sym_DOLLAR] = ACTIONS(2755),
    [sym__special_character] = ACTIONS(2757),
    [anon_sym_DQUOTE] = ACTIONS(2753),
    [sym_raw_string] = ACTIONS(2753),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2753),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2753),
    [anon_sym_BQUOTE] = ACTIONS(2753),
    [anon_sym_LT_LPAREN] = ACTIONS(2753),
    [anon_sym_GT_LPAREN] = ACTIONS(2753),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2753),
  },
  [737] = {
    [sym__simple_heredoc_body] = ACTIONS(1057),
    [sym__heredoc_body_beginning] = ACTIONS(1057),
    [sym_file_descriptor] = ACTIONS(1057),
    [sym__concat] = ACTIONS(1057),
    [sym_variable_name] = ACTIONS(1057),
    [ts_builtin_sym_end] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_RPAREN] = ACTIONS(1057),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_PIPE_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_AMP] = ACTIONS(1057),
    [anon_sym_GT_AMP] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_LT] = ACTIONS(1057),
    [anon_sym_DOLLAR] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [sym_raw_string] = ACTIONS(1057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1057),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1057),
    [anon_sym_BQUOTE] = ACTIONS(1057),
    [anon_sym_LT_LPAREN] = ACTIONS(1057),
    [anon_sym_GT_LPAREN] = ACTIONS(1057),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [738] = {
    [sym__simple_heredoc_body] = ACTIONS(1061),
    [sym__heredoc_body_beginning] = ACTIONS(1061),
    [sym_file_descriptor] = ACTIONS(1061),
    [sym__concat] = ACTIONS(1061),
    [sym_variable_name] = ACTIONS(1061),
    [ts_builtin_sym_end] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(1063),
    [anon_sym_PIPE] = ACTIONS(1063),
    [anon_sym_RPAREN] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE_AMP] = ACTIONS(1061),
    [anon_sym_AMP_AMP] = ACTIONS(1061),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1063),
    [anon_sym_GT_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT_GT] = ACTIONS(1061),
    [anon_sym_LT_AMP] = ACTIONS(1061),
    [anon_sym_GT_AMP] = ACTIONS(1061),
    [anon_sym_LT_LT] = ACTIONS(1063),
    [anon_sym_LT_LT_DASH] = ACTIONS(1061),
    [anon_sym_LT_LT_LT] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1061),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1061),
    [anon_sym_LT_LPAREN] = ACTIONS(1061),
    [anon_sym_GT_LPAREN] = ACTIONS(1061),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1063),
    [anon_sym_LF] = ACTIONS(1061),
    [anon_sym_AMP] = ACTIONS(1063),
  },
  [739] = {
    [sym__simple_heredoc_body] = ACTIONS(1065),
    [sym__heredoc_body_beginning] = ACTIONS(1065),
    [sym_file_descriptor] = ACTIONS(1065),
    [sym__concat] = ACTIONS(1065),
    [sym_variable_name] = ACTIONS(1065),
    [ts_builtin_sym_end] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1067),
    [anon_sym_RPAREN] = ACTIONS(1065),
    [anon_sym_SEMI_SEMI] = ACTIONS(1065),
    [anon_sym_PIPE_AMP] = ACTIONS(1065),
    [anon_sym_AMP_AMP] = ACTIONS(1065),
    [anon_sym_PIPE_PIPE] = ACTIONS(1065),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_GT] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT] = ACTIONS(1067),
    [anon_sym_AMP_GT_GT] = ACTIONS(1065),
    [anon_sym_LT_AMP] = ACTIONS(1065),
    [anon_sym_GT_AMP] = ACTIONS(1065),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_LT_LT_DASH] = ACTIONS(1065),
    [anon_sym_LT_LT_LT] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1067),
    [sym__special_character] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LT_LPAREN] = ACTIONS(1065),
    [anon_sym_GT_LPAREN] = ACTIONS(1065),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1067),
    [anon_sym_LF] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1067),
  },
  [740] = {
    [sym_string] = STATE(1371),
    [sym_simple_expansion] = STATE(1371),
    [sym_string_expansion] = STATE(1371),
    [sym_expansion] = STATE(1371),
    [sym_command_substitution] = STATE(1371),
    [sym_process_substitution] = STATE(1371),
    [anon_sym_DOLLAR] = ACTIONS(453),
    [sym__special_character] = ACTIONS(2759),
    [anon_sym_DQUOTE] = ACTIONS(457),
    [sym_raw_string] = ACTIONS(2759),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(461),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(463),
    [anon_sym_BQUOTE] = ACTIONS(465),
    [anon_sym_LT_LPAREN] = ACTIONS(467),
    [anon_sym_GT_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2759),
  },
  [741] = {
    [aux_sym_concatenation_repeat1] = STATE(1373),
    [sym__simple_heredoc_body] = ACTIONS(1071),
    [sym__heredoc_body_beginning] = ACTIONS(1071),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(2761),
    [sym_variable_name] = ACTIONS(1071),
    [ts_builtin_sym_end] = ACTIONS(1071),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [sym__special_character] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1075),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1075),
  },
  [742] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(2763),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [743] = {
    [sym__simple_heredoc_body] = ACTIONS(1089),
    [sym__heredoc_body_beginning] = ACTIONS(1089),
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(1089),
    [sym_variable_name] = ACTIONS(1089),
    [ts_builtin_sym_end] = ACTIONS(1089),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_SEMI_SEMI] = ACTIONS(1089),
    [anon_sym_PIPE_AMP] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_AMP] = ACTIONS(1089),
    [anon_sym_GT_AMP] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1089),
    [anon_sym_LT_LT_LT] = ACTIONS(1089),
    [anon_sym_DOLLAR] = ACTIONS(1091),
    [sym__special_character] = ACTIONS(1089),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1089),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1089),
    [anon_sym_GT_LPAREN] = ACTIONS(1089),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [744] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(627),
    [anon_sym_DOLLAR] = ACTIONS(2765),
    [anon_sym_DQUOTE] = ACTIONS(2763),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [745] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(2767),
    [sym_comment] = ACTIONS(57),
  },
  [746] = {
    [sym_subscript] = STATE(1379),
    [sym_variable_name] = ACTIONS(2769),
    [anon_sym_DASH] = ACTIONS(2771),
    [anon_sym_DOLLAR] = ACTIONS(2771),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2773),
    [anon_sym_STAR] = ACTIONS(2775),
    [anon_sym_AT] = ACTIONS(2775),
    [anon_sym_QMARK] = ACTIONS(2775),
    [anon_sym_0] = ACTIONS(2773),
    [anon_sym__] = ACTIONS(2773),
  },
  [747] = {
    [sym_concatenation] = STATE(1382),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1382),
    [anon_sym_RBRACE] = ACTIONS(2777),
    [anon_sym_EQ] = ACTIONS(2779),
    [anon_sym_DASH] = ACTIONS(2779),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2781),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(2783),
    [anon_sym_COLON] = ACTIONS(2779),
    [anon_sym_COLON_QMARK] = ACTIONS(2779),
    [anon_sym_COLON_DASH] = ACTIONS(2779),
    [anon_sym_PERCENT] = ACTIONS(2779),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [748] = {
    [sym_concatenation] = STATE(1385),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1385),
    [anon_sym_RBRACE] = ACTIONS(2785),
    [anon_sym_EQ] = ACTIONS(2787),
    [anon_sym_DASH] = ACTIONS(2787),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2789),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(2791),
    [anon_sym_COLON] = ACTIONS(2787),
    [anon_sym_COLON_QMARK] = ACTIONS(2787),
    [anon_sym_COLON_DASH] = ACTIONS(2787),
    [anon_sym_PERCENT] = ACTIONS(2787),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [749] = {
    [anon_sym_RPAREN] = ACTIONS(2793),
    [sym_comment] = ACTIONS(57),
  },
  [750] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(2793),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [751] = {
    [anon_sym_BQUOTE] = ACTIONS(2793),
    [sym_comment] = ACTIONS(57),
  },
  [752] = {
    [anon_sym_RPAREN] = ACTIONS(2795),
    [sym_comment] = ACTIONS(57),
  },
  [753] = {
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym_variable_name] = ACTIONS(335),
    [ts_builtin_sym_end] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_RPAREN] = ACTIONS(335),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [754] = {
    [aux_sym__literal_repeat1] = STATE(754),
    [sym__simple_heredoc_body] = ACTIONS(1373),
    [sym__heredoc_body_beginning] = ACTIONS(1373),
    [sym_file_descriptor] = ACTIONS(1373),
    [sym_variable_name] = ACTIONS(1373),
    [ts_builtin_sym_end] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE_AMP] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_LT_LT_DASH] = ACTIONS(1373),
    [anon_sym_LT_LT_LT] = ACTIONS(1373),
    [anon_sym_DOLLAR] = ACTIONS(1375),
    [sym__special_character] = ACTIONS(2797),
    [anon_sym_DQUOTE] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1373),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [anon_sym_LT_LPAREN] = ACTIONS(1373),
    [anon_sym_GT_LPAREN] = ACTIONS(1373),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1375),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
  },
  [755] = {
    [sym__expression] = STATE(1389),
    [sym_binary_expression] = STATE(1389),
    [sym_unary_expression] = STATE(1389),
    [sym_postfix_expression] = STATE(1389),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_concatenation] = STATE(1389),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__literal_repeat1] = STATE(53),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2800),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_DOLLAR] = ACTIONS(77),
    [sym__special_character] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [756] = {
    [anon_sym_SEMI] = ACTIONS(2802),
    [anon_sym_SEMI_SEMI] = ACTIONS(2804),
    [anon_sym_AMP_AMP] = ACTIONS(1484),
    [anon_sym_PIPE_PIPE] = ACTIONS(1484),
    [anon_sym_EQ_TILDE] = ACTIONS(1486),
    [anon_sym_EQ_EQ] = ACTIONS(1486),
    [anon_sym_EQ] = ACTIONS(1488),
    [anon_sym_PLUS_EQ] = ACTIONS(1484),
    [anon_sym_LT] = ACTIONS(1488),
    [anon_sym_GT] = ACTIONS(1488),
    [anon_sym_BANG_EQ] = ACTIONS(1484),
    [anon_sym_PLUS] = ACTIONS(1488),
    [anon_sym_DASH] = ACTIONS(1488),
    [anon_sym_DASH_EQ] = ACTIONS(1484),
    [anon_sym_LT_EQ] = ACTIONS(1484),
    [anon_sym_GT_EQ] = ACTIONS(1484),
    [anon_sym_PLUS_PLUS] = ACTIONS(1490),
    [anon_sym_DASH_DASH] = ACTIONS(1490),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1484),
    [anon_sym_LF] = ACTIONS(2804),
    [anon_sym_AMP] = ACTIONS(2802),
  },
  [757] = {
    [anon_sym_RPAREN] = ACTIONS(2806),
    [anon_sym_AMP_AMP] = ACTIONS(1536),
    [anon_sym_PIPE_PIPE] = ACTIONS(1536),
    [anon_sym_EQ_TILDE] = ACTIONS(1538),
    [anon_sym_EQ_EQ] = ACTIONS(1538),
    [anon_sym_EQ] = ACTIONS(1540),
    [anon_sym_PLUS_EQ] = ACTIONS(1536),
    [anon_sym_LT] = ACTIONS(1540),
    [anon_sym_GT] = ACTIONS(1540),
    [anon_sym_BANG_EQ] = ACTIONS(1536),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_DASH_EQ] = ACTIONS(1536),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_PLUS_PLUS] = ACTIONS(1542),
    [anon_sym_DASH_DASH] = ACTIONS(1542),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1536),
  },
  [758] = {
    [anon_sym_SEMI] = ACTIONS(2808),
    [anon_sym_SEMI_SEMI] = ACTIONS(1546),
    [anon_sym_AMP_AMP] = ACTIONS(1484),
    [anon_sym_PIPE_PIPE] = ACTIONS(1484),
    [anon_sym_EQ_TILDE] = ACTIONS(1486),
    [anon_sym_EQ_EQ] = ACTIONS(1486),
    [anon_sym_EQ] = ACTIONS(1488),
    [anon_sym_PLUS_EQ] = ACTIONS(1484),
    [anon_sym_LT] = ACTIONS(1488),
    [anon_sym_GT] = ACTIONS(1488),
    [anon_sym_BANG_EQ] = ACTIONS(1484),
    [anon_sym_PLUS] = ACTIONS(1488),
    [anon_sym_DASH] = ACTIONS(1488),
    [anon_sym_DASH_EQ] = ACTIONS(1484),
    [anon_sym_LT_EQ] = ACTIONS(1484),
    [anon_sym_GT_EQ] = ACTIONS(1484),
    [anon_sym_PLUS_PLUS] = ACTIONS(1490),
    [anon_sym_DASH_DASH] = ACTIONS(1490),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1484),
    [anon_sym_LF] = ACTIONS(1546),
    [anon_sym_AMP] = ACTIONS(2808),
  },
  [759] = {
    [sym__concat] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_EQ_TILDE] = ACTIONS(1057),
    [anon_sym_EQ_EQ] = ACTIONS(1057),
    [anon_sym_EQ] = ACTIONS(1059),
    [anon_sym_PLUS_EQ] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_BANG_EQ] = ACTIONS(1057),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_DASH_EQ] = ACTIONS(1057),
    [anon_sym_LT_EQ] = ACTIONS(1057),
    [anon_sym_GT_EQ] = ACTIONS(1057),
    [anon_sym_PLUS_PLUS] = ACTIONS(1057),
    [anon_sym_DASH_DASH] = ACTIONS(1057),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1057),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [760] = {
    [sym__concat] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(1063),
    [anon_sym_SEMI_SEMI] = ACTIONS(1061),
    [anon_sym_AMP_AMP] = ACTIONS(1061),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_EQ_TILDE] = ACTIONS(1061),
    [anon_sym_EQ_EQ] = ACTIONS(1061),
    [anon_sym_EQ] = ACTIONS(1063),
    [anon_sym_PLUS_EQ] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1063),
    [anon_sym_BANG_EQ] = ACTIONS(1061),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_DASH] = ACTIONS(1063),
    [anon_sym_DASH_EQ] = ACTIONS(1061),
    [anon_sym_LT_EQ] = ACTIONS(1061),
    [anon_sym_GT_EQ] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1061),
    [anon_sym_LF] = ACTIONS(1061),
    [anon_sym_AMP] = ACTIONS(1063),
  },
  [761] = {
    [sym__concat] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_SEMI_SEMI] = ACTIONS(1065),
    [anon_sym_AMP_AMP] = ACTIONS(1065),
    [anon_sym_PIPE_PIPE] = ACTIONS(1065),
    [anon_sym_EQ_TILDE] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(1067),
    [anon_sym_PLUS_EQ] = ACTIONS(1065),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_GT] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DASH_EQ] = ACTIONS(1065),
    [anon_sym_LT_EQ] = ACTIONS(1065),
    [anon_sym_GT_EQ] = ACTIONS(1065),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1065),
    [anon_sym_LF] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1067),
  },
  [762] = {
    [sym_string] = STATE(1392),
    [sym_simple_expansion] = STATE(1392),
    [sym_string_expansion] = STATE(1392),
    [sym_expansion] = STATE(1392),
    [sym_command_substitution] = STATE(1392),
    [sym_process_substitution] = STATE(1392),
    [anon_sym_DOLLAR] = ACTIONS(477),
    [sym__special_character] = ACTIONS(2810),
    [anon_sym_DQUOTE] = ACTIONS(481),
    [sym_raw_string] = ACTIONS(2810),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(485),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(487),
    [anon_sym_BQUOTE] = ACTIONS(489),
    [anon_sym_LT_LPAREN] = ACTIONS(491),
    [anon_sym_GT_LPAREN] = ACTIONS(491),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2810),
  },
  [763] = {
    [aux_sym_concatenation_repeat1] = STATE(1394),
    [sym__concat] = ACTIONS(2812),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_EQ_TILDE] = ACTIONS(1071),
    [anon_sym_EQ_EQ] = ACTIONS(1071),
    [anon_sym_EQ] = ACTIONS(1075),
    [anon_sym_PLUS_EQ] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_BANG_EQ] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(1075),
    [anon_sym_DASH] = ACTIONS(1075),
    [anon_sym_DASH_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_PLUS_PLUS] = ACTIONS(1071),
    [anon_sym_DASH_DASH] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1071),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1075),
  },
  [764] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(2814),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [765] = {
    [sym__concat] = ACTIONS(1089),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_EQ_EQ] = ACTIONS(1089),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_DASH] = ACTIONS(1091),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1089),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_PLUS_PLUS] = ACTIONS(1089),
    [anon_sym_DASH_DASH] = ACTIONS(1089),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1089),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [766] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(627),
    [anon_sym_DOLLAR] = ACTIONS(2816),
    [anon_sym_DQUOTE] = ACTIONS(2814),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [767] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(2818),
    [sym_comment] = ACTIONS(57),
  },
  [768] = {
    [sym_subscript] = STATE(1400),
    [sym_variable_name] = ACTIONS(2820),
    [anon_sym_DASH] = ACTIONS(2822),
    [anon_sym_DOLLAR] = ACTIONS(2822),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2824),
    [anon_sym_STAR] = ACTIONS(2826),
    [anon_sym_AT] = ACTIONS(2826),
    [anon_sym_QMARK] = ACTIONS(2826),
    [anon_sym_0] = ACTIONS(2824),
    [anon_sym__] = ACTIONS(2824),
  },
  [769] = {
    [sym_concatenation] = STATE(1403),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1403),
    [anon_sym_RBRACE] = ACTIONS(2828),
    [anon_sym_EQ] = ACTIONS(2830),
    [anon_sym_DASH] = ACTIONS(2830),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2832),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(2834),
    [anon_sym_COLON] = ACTIONS(2830),
    [anon_sym_COLON_QMARK] = ACTIONS(2830),
    [anon_sym_COLON_DASH] = ACTIONS(2830),
    [anon_sym_PERCENT] = ACTIONS(2830),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [770] = {
    [sym_concatenation] = STATE(1406),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1406),
    [anon_sym_RBRACE] = ACTIONS(2836),
    [anon_sym_EQ] = ACTIONS(2838),
    [anon_sym_DASH] = ACTIONS(2838),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2840),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(2842),
    [anon_sym_COLON] = ACTIONS(2838),
    [anon_sym_COLON_QMARK] = ACTIONS(2838),
    [anon_sym_COLON_DASH] = ACTIONS(2838),
    [anon_sym_PERCENT] = ACTIONS(2838),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [771] = {
    [anon_sym_RPAREN] = ACTIONS(2844),
    [sym_comment] = ACTIONS(57),
  },
  [772] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(2844),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [773] = {
    [anon_sym_BQUOTE] = ACTIONS(2844),
    [sym_comment] = ACTIONS(57),
  },
  [774] = {
    [anon_sym_RPAREN] = ACTIONS(2846),
    [sym_comment] = ACTIONS(57),
  },
  [775] = {
    [sym__expression] = STATE(1409),
    [sym_binary_expression] = STATE(1409),
    [sym_unary_expression] = STATE(1409),
    [sym_postfix_expression] = STATE(1409),
    [sym_parenthesized_expression] = STATE(1409),
    [sym_concatenation] = STATE(1409),
    [sym_string] = STATE(280),
    [sym_simple_expansion] = STATE(280),
    [sym_string_expansion] = STATE(280),
    [sym_expansion] = STATE(280),
    [sym_command_substitution] = STATE(280),
    [sym_process_substitution] = STATE(280),
    [aux_sym__literal_repeat1] = STATE(286),
    [anon_sym_SEMI] = ACTIONS(2802),
    [anon_sym_SEMI_SEMI] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(475),
    [anon_sym_DOLLAR] = ACTIONS(477),
    [sym__special_character] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(481),
    [sym_raw_string] = ACTIONS(483),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(485),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(487),
    [anon_sym_BQUOTE] = ACTIONS(489),
    [anon_sym_LT_LPAREN] = ACTIONS(491),
    [anon_sym_GT_LPAREN] = ACTIONS(491),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(493),
    [sym_test_operator] = ACTIONS(495),
    [anon_sym_LF] = ACTIONS(2804),
    [anon_sym_AMP] = ACTIONS(2804),
  },
  [776] = {
    [sym__expression] = STATE(1410),
    [sym_binary_expression] = STATE(1410),
    [sym_unary_expression] = STATE(1410),
    [sym_postfix_expression] = STATE(1410),
    [sym_parenthesized_expression] = STATE(1410),
    [sym_concatenation] = STATE(1410),
    [sym_string] = STATE(280),
    [sym_simple_expansion] = STATE(280),
    [sym_string_expansion] = STATE(280),
    [sym_expansion] = STATE(280),
    [sym_command_substitution] = STATE(280),
    [sym_process_substitution] = STATE(280),
    [aux_sym__literal_repeat1] = STATE(286),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(475),
    [anon_sym_DOLLAR] = ACTIONS(477),
    [sym__special_character] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(481),
    [sym_raw_string] = ACTIONS(483),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(485),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(487),
    [anon_sym_BQUOTE] = ACTIONS(489),
    [anon_sym_LT_LPAREN] = ACTIONS(491),
    [anon_sym_GT_LPAREN] = ACTIONS(491),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(493),
    [sym_test_operator] = ACTIONS(495),
  },
  [777] = {
    [sym__expression] = STATE(1410),
    [sym_binary_expression] = STATE(1410),
    [sym_unary_expression] = STATE(1410),
    [sym_postfix_expression] = STATE(1410),
    [sym_parenthesized_expression] = STATE(1410),
    [sym_concatenation] = STATE(1410),
    [sym_string] = STATE(280),
    [sym_simple_expansion] = STATE(280),
    [sym_string_expansion] = STATE(280),
    [sym_expansion] = STATE(280),
    [sym_command_substitution] = STATE(280),
    [sym_process_substitution] = STATE(280),
    [aux_sym__literal_repeat1] = STATE(286),
    [sym_regex] = ACTIONS(2848),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(475),
    [anon_sym_DOLLAR] = ACTIONS(477),
    [sym__special_character] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(481),
    [sym_raw_string] = ACTIONS(483),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(485),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(487),
    [anon_sym_BQUOTE] = ACTIONS(489),
    [anon_sym_LT_LPAREN] = ACTIONS(491),
    [anon_sym_GT_LPAREN] = ACTIONS(491),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(493),
    [sym_test_operator] = ACTIONS(495),
  },
  [778] = {
    [anon_sym_SEMI] = ACTIONS(1594),
    [anon_sym_SEMI_SEMI] = ACTIONS(1592),
    [anon_sym_AMP_AMP] = ACTIONS(1592),
    [anon_sym_PIPE_PIPE] = ACTIONS(1592),
    [anon_sym_EQ_TILDE] = ACTIONS(1592),
    [anon_sym_EQ_EQ] = ACTIONS(1592),
    [anon_sym_EQ] = ACTIONS(1594),
    [anon_sym_PLUS_EQ] = ACTIONS(1592),
    [anon_sym_LT] = ACTIONS(1594),
    [anon_sym_GT] = ACTIONS(1594),
    [anon_sym_BANG_EQ] = ACTIONS(1592),
    [anon_sym_PLUS] = ACTIONS(1594),
    [anon_sym_DASH] = ACTIONS(1594),
    [anon_sym_DASH_EQ] = ACTIONS(1592),
    [anon_sym_LT_EQ] = ACTIONS(1592),
    [anon_sym_GT_EQ] = ACTIONS(1592),
    [anon_sym_PLUS_PLUS] = ACTIONS(1592),
    [anon_sym_DASH_DASH] = ACTIONS(1592),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1592),
    [anon_sym_LF] = ACTIONS(1592),
    [anon_sym_AMP] = ACTIONS(1594),
  },
  [779] = {
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_EQ_TILDE] = ACTIONS(335),
    [anon_sym_EQ_EQ] = ACTIONS(335),
    [anon_sym_EQ] = ACTIONS(339),
    [anon_sym_PLUS_EQ] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(335),
    [anon_sym_PLUS] = ACTIONS(339),
    [anon_sym_DASH] = ACTIONS(339),
    [anon_sym_DASH_EQ] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(335),
    [anon_sym_GT_EQ] = ACTIONS(335),
    [anon_sym_PLUS_PLUS] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(335),
    [sym__special_character] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(335),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [780] = {
    [aux_sym__literal_repeat1] = STATE(780),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_EQ_TILDE] = ACTIONS(1373),
    [anon_sym_EQ_EQ] = ACTIONS(1373),
    [anon_sym_EQ] = ACTIONS(1375),
    [anon_sym_PLUS_EQ] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_BANG_EQ] = ACTIONS(1373),
    [anon_sym_PLUS] = ACTIONS(1375),
    [anon_sym_DASH] = ACTIONS(1375),
    [anon_sym_DASH_EQ] = ACTIONS(1373),
    [anon_sym_LT_EQ] = ACTIONS(1373),
    [anon_sym_GT_EQ] = ACTIONS(1373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1373),
    [anon_sym_DASH_DASH] = ACTIONS(1373),
    [sym__special_character] = ACTIONS(2850),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1373),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
  },
  [781] = {
    [sym_string] = STATE(1413),
    [anon_sym_DASH] = ACTIONS(2853),
    [anon_sym_DOLLAR] = ACTIONS(2853),
    [anon_sym_DQUOTE] = ACTIONS(1498),
    [sym_raw_string] = ACTIONS(2855),
    [anon_sym_POUND] = ACTIONS(2853),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2857),
    [anon_sym_STAR] = ACTIONS(2859),
    [anon_sym_AT] = ACTIONS(2859),
    [anon_sym_QMARK] = ACTIONS(2859),
    [anon_sym_0] = ACTIONS(2857),
    [anon_sym__] = ACTIONS(2857),
  },
  [782] = {
    [aux_sym_concatenation_repeat1] = STATE(1416),
    [sym__concat] = ACTIONS(2861),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(335),
  },
  [783] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(1419),
    [anon_sym_DOLLAR] = ACTIONS(2863),
    [anon_sym_DQUOTE] = ACTIONS(2865),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [784] = {
    [aux_sym_concatenation_repeat1] = STATE(1416),
    [sym__concat] = ACTIONS(2861),
    [anon_sym_SEMI] = ACTIONS(2739),
    [anon_sym_SEMI_SEMI] = ACTIONS(2737),
    [anon_sym_DOLLAR] = ACTIONS(2739),
    [sym__special_character] = ACTIONS(2737),
    [anon_sym_DQUOTE] = ACTIONS(2737),
    [sym_raw_string] = ACTIONS(2737),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2737),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2737),
    [anon_sym_BQUOTE] = ACTIONS(2737),
    [anon_sym_LT_LPAREN] = ACTIONS(2737),
    [anon_sym_GT_LPAREN] = ACTIONS(2737),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2739),
    [anon_sym_LF] = ACTIONS(2737),
    [anon_sym_AMP] = ACTIONS(2737),
  },
  [785] = {
    [sym_subscript] = STATE(1423),
    [sym_variable_name] = ACTIONS(2867),
    [anon_sym_BANG] = ACTIONS(2869),
    [anon_sym_DASH] = ACTIONS(2871),
    [anon_sym_DOLLAR] = ACTIONS(2871),
    [anon_sym_POUND] = ACTIONS(2869),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2873),
    [anon_sym_STAR] = ACTIONS(2875),
    [anon_sym_AT] = ACTIONS(2875),
    [anon_sym_QMARK] = ACTIONS(2875),
    [anon_sym_0] = ACTIONS(2873),
    [anon_sym__] = ACTIONS(2873),
  },
  [786] = {
    [sym__statements] = STATE(1424),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(1425),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [787] = {
    [sym__statements] = STATE(1426),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [788] = {
    [sym__statements] = STATE(1427),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [789] = {
    [sym_concatenation] = STATE(1429),
    [sym_string] = STATE(784),
    [sym_simple_expansion] = STATE(784),
    [sym_string_expansion] = STATE(784),
    [sym_expansion] = STATE(784),
    [sym_command_substitution] = STATE(784),
    [sym_process_substitution] = STATE(784),
    [aux_sym_for_statement_repeat1] = STATE(1429),
    [aux_sym__literal_repeat1] = STATE(790),
    [anon_sym_SEMI] = ACTIONS(2877),
    [anon_sym_SEMI_SEMI] = ACTIONS(2879),
    [anon_sym_DOLLAR] = ACTIONS(1494),
    [sym__special_character] = ACTIONS(1496),
    [anon_sym_DQUOTE] = ACTIONS(1498),
    [sym_raw_string] = ACTIONS(1500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1502),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1504),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_LT_LPAREN] = ACTIONS(1508),
    [anon_sym_GT_LPAREN] = ACTIONS(1508),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2881),
    [anon_sym_LF] = ACTIONS(2879),
    [anon_sym_AMP] = ACTIONS(2879),
  },
  [790] = {
    [aux_sym__literal_repeat1] = STATE(1431),
    [anon_sym_SEMI] = ACTIONS(2755),
    [anon_sym_SEMI_SEMI] = ACTIONS(2753),
    [anon_sym_DOLLAR] = ACTIONS(2755),
    [sym__special_character] = ACTIONS(2883),
    [anon_sym_DQUOTE] = ACTIONS(2753),
    [sym_raw_string] = ACTIONS(2753),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2753),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2753),
    [anon_sym_BQUOTE] = ACTIONS(2753),
    [anon_sym_LT_LPAREN] = ACTIONS(2753),
    [anon_sym_GT_LPAREN] = ACTIONS(2753),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2755),
    [anon_sym_LF] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2753),
  },
  [791] = {
    [sym__simple_heredoc_body] = ACTIONS(2885),
    [sym__heredoc_body_beginning] = ACTIONS(2885),
    [sym_file_descriptor] = ACTIONS(2885),
    [ts_builtin_sym_end] = ACTIONS(2885),
    [anon_sym_SEMI] = ACTIONS(2887),
    [anon_sym_done] = ACTIONS(2885),
    [anon_sym_fi] = ACTIONS(2885),
    [anon_sym_elif] = ACTIONS(2885),
    [anon_sym_else] = ACTIONS(2885),
    [anon_sym_esac] = ACTIONS(2885),
    [anon_sym_PIPE] = ACTIONS(2887),
    [anon_sym_RPAREN] = ACTIONS(2885),
    [anon_sym_SEMI_SEMI] = ACTIONS(2885),
    [anon_sym_PIPE_AMP] = ACTIONS(2885),
    [anon_sym_AMP_AMP] = ACTIONS(2885),
    [anon_sym_PIPE_PIPE] = ACTIONS(2885),
    [anon_sym_LT] = ACTIONS(2887),
    [anon_sym_GT] = ACTIONS(2887),
    [anon_sym_GT_GT] = ACTIONS(2885),
    [anon_sym_AMP_GT] = ACTIONS(2887),
    [anon_sym_AMP_GT_GT] = ACTIONS(2885),
    [anon_sym_LT_AMP] = ACTIONS(2885),
    [anon_sym_GT_AMP] = ACTIONS(2885),
    [anon_sym_LT_LT] = ACTIONS(2887),
    [anon_sym_LT_LT_DASH] = ACTIONS(2885),
    [anon_sym_LT_LT_LT] = ACTIONS(2885),
    [anon_sym_BQUOTE] = ACTIONS(2885),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2885),
    [anon_sym_AMP] = ACTIONS(2887),
  },
  [792] = {
    [anon_sym_RPAREN] = ACTIONS(2889),
    [anon_sym_AMP_AMP] = ACTIONS(1536),
    [anon_sym_PIPE_PIPE] = ACTIONS(1536),
    [anon_sym_EQ_TILDE] = ACTIONS(1538),
    [anon_sym_EQ_EQ] = ACTIONS(1538),
    [anon_sym_EQ] = ACTIONS(1540),
    [anon_sym_PLUS_EQ] = ACTIONS(1536),
    [anon_sym_LT] = ACTIONS(1540),
    [anon_sym_GT] = ACTIONS(1540),
    [anon_sym_BANG_EQ] = ACTIONS(1536),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_DASH_EQ] = ACTIONS(1536),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_PLUS_PLUS] = ACTIONS(1542),
    [anon_sym_DASH_DASH] = ACTIONS(1542),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1536),
  },
  [793] = {
    [anon_sym_RPAREN] = ACTIONS(1546),
    [anon_sym_AMP_AMP] = ACTIONS(1536),
    [anon_sym_PIPE_PIPE] = ACTIONS(1536),
    [anon_sym_EQ_TILDE] = ACTIONS(1538),
    [anon_sym_EQ_EQ] = ACTIONS(1538),
    [anon_sym_EQ] = ACTIONS(1540),
    [anon_sym_PLUS_EQ] = ACTIONS(1536),
    [anon_sym_LT] = ACTIONS(1540),
    [anon_sym_GT] = ACTIONS(1540),
    [anon_sym_BANG_EQ] = ACTIONS(1536),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_DASH_EQ] = ACTIONS(1536),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_PLUS_PLUS] = ACTIONS(1542),
    [anon_sym_DASH_DASH] = ACTIONS(1542),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1536),
  },
  [794] = {
    [sym__concat] = ACTIONS(1057),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_RPAREN] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_EQ_TILDE] = ACTIONS(1057),
    [anon_sym_EQ_EQ] = ACTIONS(1057),
    [anon_sym_EQ] = ACTIONS(1059),
    [anon_sym_PLUS_EQ] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_BANG_EQ] = ACTIONS(1057),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_DASH_EQ] = ACTIONS(1057),
    [anon_sym_LT_EQ] = ACTIONS(1057),
    [anon_sym_GT_EQ] = ACTIONS(1057),
    [anon_sym_PLUS_PLUS] = ACTIONS(1057),
    [anon_sym_DASH_DASH] = ACTIONS(1057),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1057),
  },
  [795] = {
    [sym__concat] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1063),
    [anon_sym_RPAREN] = ACTIONS(1061),
    [anon_sym_AMP_AMP] = ACTIONS(1061),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_EQ_TILDE] = ACTIONS(1061),
    [anon_sym_EQ_EQ] = ACTIONS(1061),
    [anon_sym_EQ] = ACTIONS(1063),
    [anon_sym_PLUS_EQ] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1063),
    [anon_sym_BANG_EQ] = ACTIONS(1061),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_DASH] = ACTIONS(1063),
    [anon_sym_DASH_EQ] = ACTIONS(1061),
    [anon_sym_LT_EQ] = ACTIONS(1061),
    [anon_sym_GT_EQ] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1061),
  },
  [796] = {
    [sym__concat] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1067),
    [anon_sym_RPAREN] = ACTIONS(1065),
    [anon_sym_AMP_AMP] = ACTIONS(1065),
    [anon_sym_PIPE_PIPE] = ACTIONS(1065),
    [anon_sym_EQ_TILDE] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(1067),
    [anon_sym_PLUS_EQ] = ACTIONS(1065),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_GT] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DASH_EQ] = ACTIONS(1065),
    [anon_sym_LT_EQ] = ACTIONS(1065),
    [anon_sym_GT_EQ] = ACTIONS(1065),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1065),
  },
  [797] = {
    [sym_string] = STATE(1433),
    [sym_simple_expansion] = STATE(1433),
    [sym_string_expansion] = STATE(1433),
    [sym_expansion] = STATE(1433),
    [sym_command_substitution] = STATE(1433),
    [sym_process_substitution] = STATE(1433),
    [anon_sym_DOLLAR] = ACTIONS(507),
    [sym__special_character] = ACTIONS(2891),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(2891),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2891),
  },
  [798] = {
    [aux_sym_concatenation_repeat1] = STATE(1435),
    [sym__concat] = ACTIONS(2893),
    [anon_sym_RPAREN] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_EQ_TILDE] = ACTIONS(1071),
    [anon_sym_EQ_EQ] = ACTIONS(1071),
    [anon_sym_EQ] = ACTIONS(1075),
    [anon_sym_PLUS_EQ] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_BANG_EQ] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(1075),
    [anon_sym_DASH] = ACTIONS(1075),
    [anon_sym_DASH_EQ] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1071),
    [anon_sym_GT_EQ] = ACTIONS(1071),
    [anon_sym_PLUS_PLUS] = ACTIONS(1071),
    [anon_sym_DASH_DASH] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1071),
  },
  [799] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(2895),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [800] = {
    [sym__concat] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_EQ_EQ] = ACTIONS(1089),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_DASH] = ACTIONS(1091),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1089),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_PLUS_PLUS] = ACTIONS(1089),
    [anon_sym_DASH_DASH] = ACTIONS(1089),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1089),
  },
  [801] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(627),
    [anon_sym_DOLLAR] = ACTIONS(2897),
    [anon_sym_DQUOTE] = ACTIONS(2895),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [802] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(2899),
    [sym_comment] = ACTIONS(57),
  },
  [803] = {
    [sym_subscript] = STATE(1441),
    [sym_variable_name] = ACTIONS(2901),
    [anon_sym_DASH] = ACTIONS(2903),
    [anon_sym_DOLLAR] = ACTIONS(2903),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2905),
    [anon_sym_STAR] = ACTIONS(2907),
    [anon_sym_AT] = ACTIONS(2907),
    [anon_sym_QMARK] = ACTIONS(2907),
    [anon_sym_0] = ACTIONS(2905),
    [anon_sym__] = ACTIONS(2905),
  },
  [804] = {
    [sym_concatenation] = STATE(1444),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1444),
    [anon_sym_RBRACE] = ACTIONS(2909),
    [anon_sym_EQ] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(2911),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2913),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(2915),
    [anon_sym_COLON] = ACTIONS(2911),
    [anon_sym_COLON_QMARK] = ACTIONS(2911),
    [anon_sym_COLON_DASH] = ACTIONS(2911),
    [anon_sym_PERCENT] = ACTIONS(2911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [805] = {
    [sym_concatenation] = STATE(1447),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1447),
    [anon_sym_RBRACE] = ACTIONS(2917),
    [anon_sym_EQ] = ACTIONS(2919),
    [anon_sym_DASH] = ACTIONS(2919),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2921),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(2923),
    [anon_sym_COLON] = ACTIONS(2919),
    [anon_sym_COLON_QMARK] = ACTIONS(2919),
    [anon_sym_COLON_DASH] = ACTIONS(2919),
    [anon_sym_PERCENT] = ACTIONS(2919),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [806] = {
    [anon_sym_RPAREN] = ACTIONS(2925),
    [sym_comment] = ACTIONS(57),
  },
  [807] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(2925),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [808] = {
    [anon_sym_BQUOTE] = ACTIONS(2925),
    [sym_comment] = ACTIONS(57),
  },
  [809] = {
    [anon_sym_RPAREN] = ACTIONS(2927),
    [sym_comment] = ACTIONS(57),
  },
  [810] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2929),
    [anon_sym_AMP_AMP] = ACTIONS(2929),
    [anon_sym_PIPE_PIPE] = ACTIONS(2929),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2929),
    [anon_sym_EQ_TILDE] = ACTIONS(2929),
    [anon_sym_EQ_EQ] = ACTIONS(2929),
    [anon_sym_EQ] = ACTIONS(2931),
    [anon_sym_PLUS_EQ] = ACTIONS(2929),
    [anon_sym_LT] = ACTIONS(2931),
    [anon_sym_GT] = ACTIONS(2931),
    [anon_sym_BANG_EQ] = ACTIONS(2929),
    [anon_sym_PLUS] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(2931),
    [anon_sym_DASH_EQ] = ACTIONS(2929),
    [anon_sym_LT_EQ] = ACTIONS(2929),
    [anon_sym_GT_EQ] = ACTIONS(2929),
    [anon_sym_PLUS_PLUS] = ACTIONS(2929),
    [anon_sym_DASH_DASH] = ACTIONS(2929),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2929),
  },
  [811] = {
    [sym__expression] = STATE(1450),
    [sym_binary_expression] = STATE(1450),
    [sym_unary_expression] = STATE(1450),
    [sym_postfix_expression] = STATE(1450),
    [sym_parenthesized_expression] = STATE(1450),
    [sym_concatenation] = STATE(1450),
    [sym_string] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [sym_expansion] = STATE(294),
    [sym_command_substitution] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(300),
    [anon_sym_LPAREN] = ACTIONS(503),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_DOLLAR] = ACTIONS(507),
    [sym__special_character] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(513),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(523),
    [sym_test_operator] = ACTIONS(525),
  },
  [812] = {
    [sym__expression] = STATE(1450),
    [sym_binary_expression] = STATE(1450),
    [sym_unary_expression] = STATE(1450),
    [sym_postfix_expression] = STATE(1450),
    [sym_parenthesized_expression] = STATE(1450),
    [sym_concatenation] = STATE(1450),
    [sym_string] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [sym_expansion] = STATE(294),
    [sym_command_substitution] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(300),
    [sym_regex] = ACTIONS(2933),
    [anon_sym_LPAREN] = ACTIONS(503),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_DOLLAR] = ACTIONS(507),
    [sym__special_character] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(513),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(523),
    [sym_test_operator] = ACTIONS(525),
  },
  [813] = {
    [anon_sym_RPAREN] = ACTIONS(1592),
    [anon_sym_AMP_AMP] = ACTIONS(1592),
    [anon_sym_PIPE_PIPE] = ACTIONS(1592),
    [anon_sym_EQ_TILDE] = ACTIONS(1592),
    [anon_sym_EQ_EQ] = ACTIONS(1592),
    [anon_sym_EQ] = ACTIONS(1594),
    [anon_sym_PLUS_EQ] = ACTIONS(1592),
    [anon_sym_LT] = ACTIONS(1594),
    [anon_sym_GT] = ACTIONS(1594),
    [anon_sym_BANG_EQ] = ACTIONS(1592),
    [anon_sym_PLUS] = ACTIONS(1594),
    [anon_sym_DASH] = ACTIONS(1594),
    [anon_sym_DASH_EQ] = ACTIONS(1592),
    [anon_sym_LT_EQ] = ACTIONS(1592),
    [anon_sym_GT_EQ] = ACTIONS(1592),
    [anon_sym_PLUS_PLUS] = ACTIONS(1592),
    [anon_sym_DASH_DASH] = ACTIONS(1592),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1592),
  },
  [814] = {
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_RPAREN] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_EQ_TILDE] = ACTIONS(335),
    [anon_sym_EQ_EQ] = ACTIONS(335),
    [anon_sym_EQ] = ACTIONS(339),
    [anon_sym_PLUS_EQ] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_BANG_EQ] = ACTIONS(335),
    [anon_sym_PLUS] = ACTIONS(339),
    [anon_sym_DASH] = ACTIONS(339),
    [anon_sym_DASH_EQ] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(335),
    [anon_sym_GT_EQ] = ACTIONS(335),
    [anon_sym_PLUS_PLUS] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(335),
    [sym__special_character] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(335),
  },
  [815] = {
    [aux_sym__literal_repeat1] = STATE(815),
    [anon_sym_RPAREN] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_EQ_TILDE] = ACTIONS(1373),
    [anon_sym_EQ_EQ] = ACTIONS(1373),
    [anon_sym_EQ] = ACTIONS(1375),
    [anon_sym_PLUS_EQ] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_BANG_EQ] = ACTIONS(1373),
    [anon_sym_PLUS] = ACTIONS(1375),
    [anon_sym_DASH] = ACTIONS(1375),
    [anon_sym_DASH_EQ] = ACTIONS(1373),
    [anon_sym_LT_EQ] = ACTIONS(1373),
    [anon_sym_GT_EQ] = ACTIONS(1373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1373),
    [anon_sym_DASH_DASH] = ACTIONS(1373),
    [sym__special_character] = ACTIONS(2935),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1373),
  },
  [816] = {
    [sym__concat] = ACTIONS(2362),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2362),
    [anon_sym_EQ_TILDE] = ACTIONS(2362),
    [anon_sym_EQ_EQ] = ACTIONS(2362),
    [anon_sym_EQ] = ACTIONS(2364),
    [anon_sym_PLUS_EQ] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_BANG_EQ] = ACTIONS(2362),
    [anon_sym_PLUS] = ACTIONS(2364),
    [anon_sym_DASH] = ACTIONS(2364),
    [anon_sym_DASH_EQ] = ACTIONS(2362),
    [anon_sym_LT_EQ] = ACTIONS(2362),
    [anon_sym_GT_EQ] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2362),
  },
  [817] = {
    [sym_string] = STATE(816),
    [sym_simple_expansion] = STATE(816),
    [sym_string_expansion] = STATE(816),
    [sym_expansion] = STATE(816),
    [sym_command_substitution] = STATE(816),
    [sym_process_substitution] = STATE(816),
    [anon_sym_DOLLAR] = ACTIONS(2938),
    [sym__special_character] = ACTIONS(1548),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(1548),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1548),
  },
  [818] = {
    [aux_sym_concatenation_repeat1] = STATE(818),
    [sym__concat] = ACTIONS(2940),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_EQ_TILDE] = ACTIONS(2362),
    [anon_sym_EQ_EQ] = ACTIONS(2362),
    [anon_sym_EQ] = ACTIONS(2364),
    [anon_sym_PLUS_EQ] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_BANG_EQ] = ACTIONS(2362),
    [anon_sym_PLUS] = ACTIONS(2364),
    [anon_sym_DASH] = ACTIONS(2364),
    [anon_sym_DASH_EQ] = ACTIONS(2362),
    [anon_sym_LT_EQ] = ACTIONS(2362),
    [anon_sym_GT_EQ] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2362),
  },
  [819] = {
    [sym__concat] = ACTIONS(2371),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2371),
    [anon_sym_EQ_TILDE] = ACTIONS(2371),
    [anon_sym_EQ_EQ] = ACTIONS(2371),
    [anon_sym_EQ] = ACTIONS(2373),
    [anon_sym_PLUS_EQ] = ACTIONS(2371),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2371),
    [anon_sym_PLUS] = ACTIONS(2373),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_DASH_EQ] = ACTIONS(2371),
    [anon_sym_LT_EQ] = ACTIONS(2371),
    [anon_sym_GT_EQ] = ACTIONS(2371),
    [anon_sym_PLUS_PLUS] = ACTIONS(2371),
    [anon_sym_DASH_DASH] = ACTIONS(2371),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2371),
  },
  [820] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(2943),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [821] = {
    [sym_concatenation] = STATE(1456),
    [sym_string] = STATE(1455),
    [sym_simple_expansion] = STATE(1455),
    [sym_string_expansion] = STATE(1455),
    [sym_expansion] = STATE(1455),
    [sym_command_substitution] = STATE(1455),
    [sym_process_substitution] = STATE(1455),
    [aux_sym__literal_repeat1] = STATE(1457),
    [anon_sym_RBRACE] = ACTIONS(2945),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(2947),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2947),
  },
  [822] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(2949),
    [sym_comment] = ACTIONS(57),
  },
  [823] = {
    [sym_concatenation] = STATE(1461),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1461),
    [anon_sym_RBRACE] = ACTIONS(2951),
    [anon_sym_EQ] = ACTIONS(2953),
    [anon_sym_DASH] = ACTIONS(2953),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2955),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(2957),
    [anon_sym_COLON] = ACTIONS(2953),
    [anon_sym_COLON_QMARK] = ACTIONS(2953),
    [anon_sym_COLON_DASH] = ACTIONS(2953),
    [anon_sym_PERCENT] = ACTIONS(2953),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [824] = {
    [sym_concatenation] = STATE(1463),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1463),
    [anon_sym_RBRACE] = ACTIONS(2945),
    [anon_sym_EQ] = ACTIONS(2959),
    [anon_sym_DASH] = ACTIONS(2959),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2961),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(2963),
    [anon_sym_COLON] = ACTIONS(2959),
    [anon_sym_COLON_QMARK] = ACTIONS(2959),
    [anon_sym_COLON_DASH] = ACTIONS(2959),
    [anon_sym_PERCENT] = ACTIONS(2959),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [825] = {
    [sym__concat] = ACTIONS(2462),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2462),
    [anon_sym_EQ_TILDE] = ACTIONS(2462),
    [anon_sym_EQ_EQ] = ACTIONS(2462),
    [anon_sym_EQ] = ACTIONS(2464),
    [anon_sym_PLUS_EQ] = ACTIONS(2462),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_BANG_EQ] = ACTIONS(2462),
    [anon_sym_PLUS] = ACTIONS(2464),
    [anon_sym_DASH] = ACTIONS(2464),
    [anon_sym_DASH_EQ] = ACTIONS(2462),
    [anon_sym_LT_EQ] = ACTIONS(2462),
    [anon_sym_GT_EQ] = ACTIONS(2462),
    [anon_sym_PLUS_PLUS] = ACTIONS(2462),
    [anon_sym_DASH_DASH] = ACTIONS(2462),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2462),
  },
  [826] = {
    [sym_concatenation] = STATE(1466),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1466),
    [sym_regex] = ACTIONS(2965),
    [anon_sym_RBRACE] = ACTIONS(2967),
    [anon_sym_EQ] = ACTIONS(2969),
    [anon_sym_DASH] = ACTIONS(2969),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2971),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_COLON_QMARK] = ACTIONS(2969),
    [anon_sym_COLON_DASH] = ACTIONS(2969),
    [anon_sym_PERCENT] = ACTIONS(2969),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [827] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(2967),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [828] = {
    [sym__concat] = ACTIONS(2512),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE_PIPE] = ACTIONS(2512),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2512),
    [anon_sym_EQ_TILDE] = ACTIONS(2512),
    [anon_sym_EQ_EQ] = ACTIONS(2512),
    [anon_sym_EQ] = ACTIONS(2514),
    [anon_sym_PLUS_EQ] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2514),
    [anon_sym_GT] = ACTIONS(2514),
    [anon_sym_BANG_EQ] = ACTIONS(2512),
    [anon_sym_PLUS] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2514),
    [anon_sym_DASH_EQ] = ACTIONS(2512),
    [anon_sym_LT_EQ] = ACTIONS(2512),
    [anon_sym_GT_EQ] = ACTIONS(2512),
    [anon_sym_PLUS_PLUS] = ACTIONS(2512),
    [anon_sym_DASH_DASH] = ACTIONS(2512),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2512),
  },
  [829] = {
    [sym_concatenation] = STATE(1463),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1463),
    [sym_regex] = ACTIONS(2973),
    [anon_sym_RBRACE] = ACTIONS(2945),
    [anon_sym_EQ] = ACTIONS(2959),
    [anon_sym_DASH] = ACTIONS(2959),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2961),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2959),
    [anon_sym_COLON_QMARK] = ACTIONS(2959),
    [anon_sym_COLON_DASH] = ACTIONS(2959),
    [anon_sym_PERCENT] = ACTIONS(2959),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [830] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(2945),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [831] = {
    [sym__concat] = ACTIONS(2520),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2520),
    [anon_sym_AMP_AMP] = ACTIONS(2520),
    [anon_sym_PIPE_PIPE] = ACTIONS(2520),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2520),
    [anon_sym_EQ_TILDE] = ACTIONS(2520),
    [anon_sym_EQ_EQ] = ACTIONS(2520),
    [anon_sym_EQ] = ACTIONS(2522),
    [anon_sym_PLUS_EQ] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(2522),
    [anon_sym_GT] = ACTIONS(2522),
    [anon_sym_BANG_EQ] = ACTIONS(2520),
    [anon_sym_PLUS] = ACTIONS(2522),
    [anon_sym_DASH] = ACTIONS(2522),
    [anon_sym_DASH_EQ] = ACTIONS(2520),
    [anon_sym_LT_EQ] = ACTIONS(2520),
    [anon_sym_GT_EQ] = ACTIONS(2520),
    [anon_sym_PLUS_PLUS] = ACTIONS(2520),
    [anon_sym_DASH_DASH] = ACTIONS(2520),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2520),
  },
  [832] = {
    [sym__concat] = ACTIONS(2554),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2554),
    [anon_sym_AMP_AMP] = ACTIONS(2554),
    [anon_sym_PIPE_PIPE] = ACTIONS(2554),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2554),
    [anon_sym_EQ_TILDE] = ACTIONS(2554),
    [anon_sym_EQ_EQ] = ACTIONS(2554),
    [anon_sym_EQ] = ACTIONS(2556),
    [anon_sym_PLUS_EQ] = ACTIONS(2554),
    [anon_sym_LT] = ACTIONS(2556),
    [anon_sym_GT] = ACTIONS(2556),
    [anon_sym_BANG_EQ] = ACTIONS(2554),
    [anon_sym_PLUS] = ACTIONS(2556),
    [anon_sym_DASH] = ACTIONS(2556),
    [anon_sym_DASH_EQ] = ACTIONS(2554),
    [anon_sym_LT_EQ] = ACTIONS(2554),
    [anon_sym_GT_EQ] = ACTIONS(2554),
    [anon_sym_PLUS_PLUS] = ACTIONS(2554),
    [anon_sym_DASH_DASH] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2554),
  },
  [833] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2975),
    [anon_sym_AMP_AMP] = ACTIONS(2975),
    [anon_sym_PIPE_PIPE] = ACTIONS(2975),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2975),
    [anon_sym_EQ_TILDE] = ACTIONS(2975),
    [anon_sym_EQ_EQ] = ACTIONS(2975),
    [anon_sym_EQ] = ACTIONS(2977),
    [anon_sym_PLUS_EQ] = ACTIONS(2975),
    [anon_sym_LT] = ACTIONS(2977),
    [anon_sym_GT] = ACTIONS(2977),
    [anon_sym_BANG_EQ] = ACTIONS(2975),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_DASH_EQ] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(2975),
    [anon_sym_GT_EQ] = ACTIONS(2975),
    [anon_sym_PLUS_PLUS] = ACTIONS(2975),
    [anon_sym_DASH_DASH] = ACTIONS(2975),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2975),
  },
  [834] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2975),
    [anon_sym_AMP_AMP] = ACTIONS(2975),
    [anon_sym_PIPE_PIPE] = ACTIONS(2975),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2975),
    [anon_sym_EQ_TILDE] = ACTIONS(2975),
    [anon_sym_EQ_EQ] = ACTIONS(2975),
    [anon_sym_EQ] = ACTIONS(2977),
    [anon_sym_PLUS_EQ] = ACTIONS(2975),
    [anon_sym_LT] = ACTIONS(2977),
    [anon_sym_GT] = ACTIONS(2977),
    [anon_sym_BANG_EQ] = ACTIONS(2975),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_DASH_EQ] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(2975),
    [anon_sym_GT_EQ] = ACTIONS(2975),
    [anon_sym_PLUS_PLUS] = ACTIONS(2975),
    [anon_sym_DASH_DASH] = ACTIONS(2975),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2975),
  },
  [835] = {
    [sym_file_descriptor] = ACTIONS(1400),
    [sym_variable_name] = ACTIONS(1400),
    [anon_sym_SEMI] = ACTIONS(1402),
    [anon_sym_PIPE] = ACTIONS(1402),
    [anon_sym_SEMI_SEMI] = ACTIONS(1400),
    [anon_sym_PIPE_AMP] = ACTIONS(1400),
    [anon_sym_AMP_AMP] = ACTIONS(1400),
    [anon_sym_PIPE_PIPE] = ACTIONS(1400),
    [anon_sym_LT] = ACTIONS(1402),
    [anon_sym_GT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT] = ACTIONS(1402),
    [anon_sym_AMP_GT_GT] = ACTIONS(1400),
    [anon_sym_LT_AMP] = ACTIONS(1400),
    [anon_sym_GT_AMP] = ACTIONS(1400),
    [anon_sym_LT_LT] = ACTIONS(1402),
    [anon_sym_LT_LT_DASH] = ACTIONS(1400),
    [anon_sym_LT_LT_LT] = ACTIONS(1400),
    [anon_sym_DOLLAR] = ACTIONS(1402),
    [sym__special_character] = ACTIONS(1400),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1400),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1400),
    [anon_sym_BQUOTE] = ACTIONS(1400),
    [anon_sym_LT_LPAREN] = ACTIONS(1400),
    [anon_sym_GT_LPAREN] = ACTIONS(1400),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1402),
    [anon_sym_LF] = ACTIONS(1400),
    [anon_sym_AMP] = ACTIONS(1402),
  },
  [836] = {
    [sym_concatenation] = STATE(1469),
    [sym_string] = STATE(730),
    [sym_simple_expansion] = STATE(730),
    [sym_string_expansion] = STATE(730),
    [sym_expansion] = STATE(730),
    [sym_command_substitution] = STATE(730),
    [sym_process_substitution] = STATE(730),
    [aux_sym_for_statement_repeat1] = STATE(1469),
    [aux_sym__literal_repeat1] = STATE(736),
    [anon_sym_RPAREN] = ACTIONS(2979),
    [anon_sym_DOLLAR] = ACTIONS(1406),
    [sym__special_character] = ACTIONS(1408),
    [anon_sym_DQUOTE] = ACTIONS(1410),
    [sym_raw_string] = ACTIONS(1412),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1414),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1416),
    [anon_sym_BQUOTE] = ACTIONS(1418),
    [anon_sym_LT_LPAREN] = ACTIONS(1420),
    [anon_sym_GT_LPAREN] = ACTIONS(1420),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1412),
  },
  [837] = {
    [sym_string] = STATE(1471),
    [anon_sym_DASH] = ACTIONS(2981),
    [anon_sym_DOLLAR] = ACTIONS(2981),
    [anon_sym_DQUOTE] = ACTIONS(1607),
    [sym_raw_string] = ACTIONS(2983),
    [anon_sym_POUND] = ACTIONS(2981),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2985),
    [anon_sym_STAR] = ACTIONS(2987),
    [anon_sym_AT] = ACTIONS(2987),
    [anon_sym_QMARK] = ACTIONS(2987),
    [anon_sym_0] = ACTIONS(2985),
    [anon_sym__] = ACTIONS(2985),
  },
  [838] = {
    [aux_sym_concatenation_repeat1] = STATE(1474),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(2989),
    [sym_variable_name] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [839] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(1477),
    [anon_sym_DOLLAR] = ACTIONS(2991),
    [anon_sym_DQUOTE] = ACTIONS(2993),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [840] = {
    [aux_sym_concatenation_repeat1] = STATE(1474),
    [sym_file_descriptor] = ACTIONS(1400),
    [sym__concat] = ACTIONS(2989),
    [sym_variable_name] = ACTIONS(1400),
    [anon_sym_SEMI] = ACTIONS(1402),
    [anon_sym_PIPE] = ACTIONS(1402),
    [anon_sym_SEMI_SEMI] = ACTIONS(1400),
    [anon_sym_PIPE_AMP] = ACTIONS(1400),
    [anon_sym_AMP_AMP] = ACTIONS(1400),
    [anon_sym_PIPE_PIPE] = ACTIONS(1400),
    [anon_sym_LT] = ACTIONS(1402),
    [anon_sym_GT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT] = ACTIONS(1402),
    [anon_sym_AMP_GT_GT] = ACTIONS(1400),
    [anon_sym_LT_AMP] = ACTIONS(1400),
    [anon_sym_GT_AMP] = ACTIONS(1400),
    [anon_sym_LT_LT] = ACTIONS(1402),
    [anon_sym_LT_LT_DASH] = ACTIONS(1400),
    [anon_sym_LT_LT_LT] = ACTIONS(1400),
    [anon_sym_DOLLAR] = ACTIONS(1402),
    [sym__special_character] = ACTIONS(1400),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1400),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1400),
    [anon_sym_BQUOTE] = ACTIONS(1400),
    [anon_sym_LT_LPAREN] = ACTIONS(1400),
    [anon_sym_GT_LPAREN] = ACTIONS(1400),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1402),
    [anon_sym_LF] = ACTIONS(1400),
    [anon_sym_AMP] = ACTIONS(1402),
  },
  [841] = {
    [sym_subscript] = STATE(1481),
    [sym_variable_name] = ACTIONS(2995),
    [anon_sym_BANG] = ACTIONS(2997),
    [anon_sym_DASH] = ACTIONS(2999),
    [anon_sym_DOLLAR] = ACTIONS(2999),
    [anon_sym_POUND] = ACTIONS(2997),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3001),
    [anon_sym_STAR] = ACTIONS(3003),
    [anon_sym_AT] = ACTIONS(3003),
    [anon_sym_QMARK] = ACTIONS(3003),
    [anon_sym_0] = ACTIONS(3001),
    [anon_sym__] = ACTIONS(3001),
  },
  [842] = {
    [sym__statements] = STATE(1482),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(1483),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [843] = {
    [sym__statements] = STATE(1484),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [844] = {
    [sym__statements] = STATE(1485),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [845] = {
    [aux_sym__literal_repeat1] = STATE(1487),
    [sym_file_descriptor] = ACTIONS(1446),
    [sym_variable_name] = ACTIONS(1446),
    [anon_sym_SEMI] = ACTIONS(1448),
    [anon_sym_PIPE] = ACTIONS(1448),
    [anon_sym_SEMI_SEMI] = ACTIONS(1446),
    [anon_sym_PIPE_AMP] = ACTIONS(1446),
    [anon_sym_AMP_AMP] = ACTIONS(1446),
    [anon_sym_PIPE_PIPE] = ACTIONS(1446),
    [anon_sym_LT] = ACTIONS(1448),
    [anon_sym_GT] = ACTIONS(1448),
    [anon_sym_GT_GT] = ACTIONS(1446),
    [anon_sym_AMP_GT] = ACTIONS(1448),
    [anon_sym_AMP_GT_GT] = ACTIONS(1446),
    [anon_sym_LT_AMP] = ACTIONS(1446),
    [anon_sym_GT_AMP] = ACTIONS(1446),
    [anon_sym_LT_LT] = ACTIONS(1448),
    [anon_sym_LT_LT_DASH] = ACTIONS(1446),
    [anon_sym_LT_LT_LT] = ACTIONS(1446),
    [anon_sym_DOLLAR] = ACTIONS(1448),
    [sym__special_character] = ACTIONS(3005),
    [anon_sym_DQUOTE] = ACTIONS(1446),
    [sym_raw_string] = ACTIONS(1446),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1446),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1446),
    [anon_sym_BQUOTE] = ACTIONS(1446),
    [anon_sym_LT_LPAREN] = ACTIONS(1446),
    [anon_sym_GT_LPAREN] = ACTIONS(1446),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1448),
    [anon_sym_LF] = ACTIONS(1446),
    [anon_sym_AMP] = ACTIONS(1448),
  },
  [846] = {
    [sym__expression] = STATE(1489),
    [sym_binary_expression] = STATE(1489),
    [sym_unary_expression] = STATE(1489),
    [sym_postfix_expression] = STATE(1489),
    [sym_parenthesized_expression] = STATE(1489),
    [sym_concatenation] = STATE(1489),
    [sym_string] = STATE(280),
    [sym_simple_expansion] = STATE(280),
    [sym_string_expansion] = STATE(280),
    [sym_expansion] = STATE(280),
    [sym_command_substitution] = STATE(280),
    [sym_process_substitution] = STATE(280),
    [aux_sym__literal_repeat1] = STATE(286),
    [anon_sym_SEMI] = ACTIONS(3007),
    [anon_sym_SEMI_SEMI] = ACTIONS(3009),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(475),
    [anon_sym_DOLLAR] = ACTIONS(477),
    [sym__special_character] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(481),
    [sym_raw_string] = ACTIONS(483),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(485),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(487),
    [anon_sym_BQUOTE] = ACTIONS(489),
    [anon_sym_LT_LPAREN] = ACTIONS(491),
    [anon_sym_GT_LPAREN] = ACTIONS(491),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(493),
    [sym_test_operator] = ACTIONS(495),
    [anon_sym_LF] = ACTIONS(3009),
    [anon_sym_AMP] = ACTIONS(3009),
  },
  [847] = {
    [anon_sym_SEMI] = ACTIONS(3011),
    [anon_sym_SEMI_SEMI] = ACTIONS(3013),
    [anon_sym_AMP_AMP] = ACTIONS(1484),
    [anon_sym_PIPE_PIPE] = ACTIONS(1484),
    [anon_sym_EQ_TILDE] = ACTIONS(1486),
    [anon_sym_EQ_EQ] = ACTIONS(1486),
    [anon_sym_EQ] = ACTIONS(1488),
    [anon_sym_PLUS_EQ] = ACTIONS(1484),
    [anon_sym_LT] = ACTIONS(1488),
    [anon_sym_GT] = ACTIONS(1488),
    [anon_sym_BANG_EQ] = ACTIONS(1484),
    [anon_sym_PLUS] = ACTIONS(1488),
    [anon_sym_DASH] = ACTIONS(1488),
    [anon_sym_DASH_EQ] = ACTIONS(1484),
    [anon_sym_LT_EQ] = ACTIONS(1484),
    [anon_sym_GT_EQ] = ACTIONS(1484),
    [anon_sym_PLUS_PLUS] = ACTIONS(1490),
    [anon_sym_DASH_DASH] = ACTIONS(1490),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1484),
    [anon_sym_LF] = ACTIONS(3013),
    [anon_sym_AMP] = ACTIONS(3011),
  },
  [848] = {
    [sym_concatenation] = STATE(1491),
    [sym_string] = STATE(784),
    [sym_simple_expansion] = STATE(784),
    [sym_string_expansion] = STATE(784),
    [sym_expansion] = STATE(784),
    [sym_command_substitution] = STATE(784),
    [sym_process_substitution] = STATE(784),
    [aux_sym_for_statement_repeat1] = STATE(1491),
    [aux_sym__literal_repeat1] = STATE(790),
    [anon_sym_DOLLAR] = ACTIONS(1494),
    [sym__special_character] = ACTIONS(1496),
    [anon_sym_DQUOTE] = ACTIONS(1498),
    [sym_raw_string] = ACTIONS(1500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1502),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1504),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_LT_LPAREN] = ACTIONS(1508),
    [anon_sym_GT_LPAREN] = ACTIONS(1508),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1500),
  },
  [849] = {
    [sym_do_group] = STATE(1492),
    [anon_sym_do] = ACTIONS(1631),
    [sym_comment] = ACTIONS(57),
  },
  [850] = {
    [sym_file_descriptor] = ACTIONS(1586),
    [anon_sym_SEMI] = ACTIONS(1588),
    [anon_sym_PIPE] = ACTIONS(1588),
    [anon_sym_SEMI_SEMI] = ACTIONS(1586),
    [anon_sym_PIPE_AMP] = ACTIONS(1586),
    [anon_sym_AMP_AMP] = ACTIONS(1586),
    [anon_sym_PIPE_PIPE] = ACTIONS(1586),
    [anon_sym_LT] = ACTIONS(1588),
    [anon_sym_GT] = ACTIONS(1588),
    [anon_sym_GT_GT] = ACTIONS(1586),
    [anon_sym_AMP_GT] = ACTIONS(1588),
    [anon_sym_AMP_GT_GT] = ACTIONS(1586),
    [anon_sym_LT_AMP] = ACTIONS(1586),
    [anon_sym_GT_AMP] = ACTIONS(1586),
    [anon_sym_LT_LT] = ACTIONS(1588),
    [anon_sym_LT_LT_DASH] = ACTIONS(1586),
    [anon_sym_LT_LT_LT] = ACTIONS(1586),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1586),
    [anon_sym_AMP] = ACTIONS(1588),
  },
  [851] = {
    [sym__statements] = STATE(1494),
    [sym_redirected_statement] = STATE(934),
    [sym_for_statement] = STATE(934),
    [sym_c_style_for_statement] = STATE(934),
    [sym_while_statement] = STATE(934),
    [sym_if_statement] = STATE(934),
    [sym_case_statement] = STATE(934),
    [sym_function_definition] = STATE(934),
    [sym_compound_statement] = STATE(934),
    [sym_subshell] = STATE(934),
    [sym_pipeline] = STATE(934),
    [sym_list] = STATE(934),
    [sym_negated_command] = STATE(934),
    [sym_test_command] = STATE(934),
    [sym_declaration_command] = STATE(934),
    [sym_unset_command] = STATE(934),
    [sym_command] = STATE(934),
    [sym_command_name] = STATE(935),
    [sym_variable_assignment] = STATE(936),
    [sym_subscript] = STATE(937),
    [sym_file_redirect] = STATE(940),
    [sym_concatenation] = STATE(938),
    [sym_string] = STATE(927),
    [sym_simple_expansion] = STATE(927),
    [sym_string_expansion] = STATE(927),
    [sym_expansion] = STATE(927),
    [sym_command_substitution] = STATE(927),
    [sym_process_substitution] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(939),
    [aux_sym_command_repeat1] = STATE(940),
    [aux_sym__literal_repeat1] = STATE(941),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(1751),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_done] = ACTIONS(3015),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1755),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(1757),
    [anon_sym_typeset] = ACTIONS(1757),
    [anon_sym_export] = ACTIONS(1757),
    [anon_sym_readonly] = ACTIONS(1757),
    [anon_sym_local] = ACTIONS(1757),
    [anon_sym_unset] = ACTIONS(1759),
    [anon_sym_unsetenv] = ACTIONS(1759),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(1761),
    [sym__special_character] = ACTIONS(1763),
    [anon_sym_DQUOTE] = ACTIONS(1765),
    [sym_raw_string] = ACTIONS(1767),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1769),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1771),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [anon_sym_LT_LPAREN] = ACTIONS(1775),
    [anon_sym_GT_LPAREN] = ACTIONS(1775),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1777),
  },
  [852] = {
    [sym_file_descriptor] = ACTIONS(1779),
    [anon_sym_SEMI] = ACTIONS(1781),
    [anon_sym_PIPE] = ACTIONS(1781),
    [anon_sym_SEMI_SEMI] = ACTIONS(1779),
    [anon_sym_PIPE_AMP] = ACTIONS(1779),
    [anon_sym_AMP_AMP] = ACTIONS(1779),
    [anon_sym_PIPE_PIPE] = ACTIONS(1779),
    [anon_sym_LT] = ACTIONS(1781),
    [anon_sym_GT] = ACTIONS(1781),
    [anon_sym_GT_GT] = ACTIONS(1779),
    [anon_sym_AMP_GT] = ACTIONS(1781),
    [anon_sym_AMP_GT_GT] = ACTIONS(1779),
    [anon_sym_LT_AMP] = ACTIONS(1779),
    [anon_sym_GT_AMP] = ACTIONS(1779),
    [anon_sym_LT_LT] = ACTIONS(1781),
    [anon_sym_LT_LT_DASH] = ACTIONS(1779),
    [anon_sym_LT_LT_LT] = ACTIONS(1779),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1779),
    [anon_sym_AMP] = ACTIONS(1781),
  },
  [853] = {
    [sym__statements] = STATE(1496),
    [sym_redirected_statement] = STATE(978),
    [sym_for_statement] = STATE(978),
    [sym_c_style_for_statement] = STATE(978),
    [sym_while_statement] = STATE(978),
    [sym_if_statement] = STATE(978),
    [sym_elif_clause] = STATE(1498),
    [sym_else_clause] = STATE(1497),
    [sym_case_statement] = STATE(978),
    [sym_function_definition] = STATE(978),
    [sym_compound_statement] = STATE(978),
    [sym_subshell] = STATE(978),
    [sym_pipeline] = STATE(978),
    [sym_list] = STATE(978),
    [sym_negated_command] = STATE(978),
    [sym_test_command] = STATE(978),
    [sym_declaration_command] = STATE(978),
    [sym_unset_command] = STATE(978),
    [sym_command] = STATE(978),
    [sym_command_name] = STATE(980),
    [sym_variable_assignment] = STATE(981),
    [sym_subscript] = STATE(982),
    [sym_file_redirect] = STATE(986),
    [sym_concatenation] = STATE(983),
    [sym_string] = STATE(971),
    [sym_simple_expansion] = STATE(971),
    [sym_string_expansion] = STATE(971),
    [sym_expansion] = STATE(971),
    [sym_command_substitution] = STATE(971),
    [sym_process_substitution] = STATE(971),
    [aux_sym__statements_repeat1] = STATE(984),
    [aux_sym_if_statement_repeat1] = STATE(1498),
    [aux_sym_command_repeat1] = STATE(986),
    [aux_sym__literal_repeat1] = STATE(987),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(1804),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_fi] = ACTIONS(3017),
    [anon_sym_elif] = ACTIONS(1808),
    [anon_sym_else] = ACTIONS(1810),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1812),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(1814),
    [anon_sym_typeset] = ACTIONS(1814),
    [anon_sym_export] = ACTIONS(1814),
    [anon_sym_readonly] = ACTIONS(1814),
    [anon_sym_local] = ACTIONS(1814),
    [anon_sym_unset] = ACTIONS(1816),
    [anon_sym_unsetenv] = ACTIONS(1816),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(1818),
    [sym__special_character] = ACTIONS(1820),
    [anon_sym_DQUOTE] = ACTIONS(1822),
    [sym_raw_string] = ACTIONS(1824),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1826),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1828),
    [anon_sym_BQUOTE] = ACTIONS(1830),
    [anon_sym_LT_LPAREN] = ACTIONS(1832),
    [anon_sym_GT_LPAREN] = ACTIONS(1832),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1834),
  },
  [854] = {
    [anon_sym_SEMI] = ACTIONS(3019),
    [anon_sym_SEMI_SEMI] = ACTIONS(3021),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3021),
    [anon_sym_AMP] = ACTIONS(3021),
  },
  [855] = {
    [anon_sym_in] = ACTIONS(3023),
    [sym_comment] = ACTIONS(57),
  },
  [856] = {
    [anon_sym_SEMI] = ACTIONS(3025),
    [anon_sym_SEMI_SEMI] = ACTIONS(3027),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3027),
    [anon_sym_AMP] = ACTIONS(3027),
  },
  [857] = {
    [anon_sym_in] = ACTIONS(3029),
    [sym_comment] = ACTIONS(57),
  },
  [858] = {
    [anon_sym_RPAREN] = ACTIONS(3031),
    [sym_comment] = ACTIONS(57),
  },
  [859] = {
    [sym_file_descriptor] = ACTIONS(1891),
    [anon_sym_SEMI] = ACTIONS(1893),
    [anon_sym_PIPE] = ACTIONS(1893),
    [anon_sym_SEMI_SEMI] = ACTIONS(1891),
    [anon_sym_PIPE_AMP] = ACTIONS(1891),
    [anon_sym_AMP_AMP] = ACTIONS(1891),
    [anon_sym_PIPE_PIPE] = ACTIONS(1891),
    [anon_sym_LT] = ACTIONS(1893),
    [anon_sym_GT] = ACTIONS(1893),
    [anon_sym_GT_GT] = ACTIONS(1891),
    [anon_sym_AMP_GT] = ACTIONS(1893),
    [anon_sym_AMP_GT_GT] = ACTIONS(1891),
    [anon_sym_LT_AMP] = ACTIONS(1891),
    [anon_sym_GT_AMP] = ACTIONS(1891),
    [anon_sym_LT_LT] = ACTIONS(1893),
    [anon_sym_LT_LT_DASH] = ACTIONS(1891),
    [anon_sym_LT_LT_LT] = ACTIONS(1891),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1891),
    [anon_sym_AMP] = ACTIONS(1893),
  },
  [860] = {
    [sym_file_descriptor] = ACTIONS(1905),
    [anon_sym_SEMI] = ACTIONS(1907),
    [anon_sym_PIPE] = ACTIONS(1907),
    [anon_sym_SEMI_SEMI] = ACTIONS(1905),
    [anon_sym_PIPE_AMP] = ACTIONS(1905),
    [anon_sym_AMP_AMP] = ACTIONS(1905),
    [anon_sym_PIPE_PIPE] = ACTIONS(1905),
    [anon_sym_LT] = ACTIONS(1907),
    [anon_sym_GT] = ACTIONS(1907),
    [anon_sym_GT_GT] = ACTIONS(1905),
    [anon_sym_AMP_GT] = ACTIONS(1907),
    [anon_sym_AMP_GT_GT] = ACTIONS(1905),
    [anon_sym_LT_AMP] = ACTIONS(1905),
    [anon_sym_GT_AMP] = ACTIONS(1905),
    [anon_sym_LT_LT] = ACTIONS(1907),
    [anon_sym_LT_LT_DASH] = ACTIONS(1905),
    [anon_sym_LT_LT_LT] = ACTIONS(1905),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1905),
    [anon_sym_AMP] = ACTIONS(1907),
  },
  [861] = {
    [sym_file_descriptor] = ACTIONS(2073),
    [anon_sym_SEMI] = ACTIONS(2075),
    [anon_sym_PIPE] = ACTIONS(2075),
    [anon_sym_SEMI_SEMI] = ACTIONS(2073),
    [anon_sym_PIPE_AMP] = ACTIONS(2073),
    [anon_sym_AMP_AMP] = ACTIONS(2073),
    [anon_sym_PIPE_PIPE] = ACTIONS(2073),
    [anon_sym_LT] = ACTIONS(2075),
    [anon_sym_GT] = ACTIONS(2075),
    [anon_sym_GT_GT] = ACTIONS(2073),
    [anon_sym_AMP_GT] = ACTIONS(2075),
    [anon_sym_AMP_GT_GT] = ACTIONS(2073),
    [anon_sym_LT_AMP] = ACTIONS(2073),
    [anon_sym_GT_AMP] = ACTIONS(2073),
    [anon_sym_LT_LT] = ACTIONS(2075),
    [anon_sym_LT_LT_DASH] = ACTIONS(2073),
    [anon_sym_LT_LT_LT] = ACTIONS(2073),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2075),
  },
  [862] = {
    [sym_concatenation] = STATE(1504),
    [sym_string] = STATE(1506),
    [sym_array] = STATE(1504),
    [sym_simple_expansion] = STATE(1506),
    [sym_string_expansion] = STATE(1506),
    [sym_expansion] = STATE(1506),
    [sym_command_substitution] = STATE(1506),
    [sym_process_substitution] = STATE(1506),
    [aux_sym__literal_repeat1] = STATE(1507),
    [sym__empty_value] = ACTIONS(3033),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_DOLLAR] = ACTIONS(585),
    [sym__special_character] = ACTIONS(587),
    [anon_sym_DQUOTE] = ACTIONS(589),
    [sym_raw_string] = ACTIONS(3037),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(593),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(595),
    [anon_sym_BQUOTE] = ACTIONS(597),
    [anon_sym_LT_LPAREN] = ACTIONS(599),
    [anon_sym_GT_LPAREN] = ACTIONS(599),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3037),
  },
  [863] = {
    [sym_file_descriptor] = ACTIONS(1057),
    [sym__concat] = ACTIONS(1057),
    [sym_variable_name] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_PIPE_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_AMP] = ACTIONS(1057),
    [anon_sym_GT_AMP] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_LT] = ACTIONS(1057),
    [anon_sym_DOLLAR] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [sym_raw_string] = ACTIONS(1057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1057),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1057),
    [anon_sym_BQUOTE] = ACTIONS(1057),
    [anon_sym_LT_LPAREN] = ACTIONS(1057),
    [anon_sym_GT_LPAREN] = ACTIONS(1057),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1059),
    [sym_word] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [864] = {
    [sym_file_descriptor] = ACTIONS(1061),
    [sym__concat] = ACTIONS(1061),
    [sym_variable_name] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(1063),
    [anon_sym_PIPE] = ACTIONS(1063),
    [anon_sym_SEMI_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE_AMP] = ACTIONS(1061),
    [anon_sym_AMP_AMP] = ACTIONS(1061),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1063),
    [anon_sym_GT_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT_GT] = ACTIONS(1061),
    [anon_sym_LT_AMP] = ACTIONS(1061),
    [anon_sym_GT_AMP] = ACTIONS(1061),
    [anon_sym_LT_LT] = ACTIONS(1063),
    [anon_sym_LT_LT_DASH] = ACTIONS(1061),
    [anon_sym_LT_LT_LT] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1061),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1061),
    [anon_sym_LT_LPAREN] = ACTIONS(1061),
    [anon_sym_GT_LPAREN] = ACTIONS(1061),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1063),
    [sym_word] = ACTIONS(1063),
    [anon_sym_LF] = ACTIONS(1061),
    [anon_sym_AMP] = ACTIONS(1063),
  },
  [865] = {
    [sym_file_descriptor] = ACTIONS(1065),
    [sym__concat] = ACTIONS(1065),
    [sym_variable_name] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1067),
    [anon_sym_SEMI_SEMI] = ACTIONS(1065),
    [anon_sym_PIPE_AMP] = ACTIONS(1065),
    [anon_sym_AMP_AMP] = ACTIONS(1065),
    [anon_sym_PIPE_PIPE] = ACTIONS(1065),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_GT] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT] = ACTIONS(1067),
    [anon_sym_AMP_GT_GT] = ACTIONS(1065),
    [anon_sym_LT_AMP] = ACTIONS(1065),
    [anon_sym_GT_AMP] = ACTIONS(1065),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_LT_LT_DASH] = ACTIONS(1065),
    [anon_sym_LT_LT_LT] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1067),
    [sym__special_character] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LT_LPAREN] = ACTIONS(1065),
    [anon_sym_GT_LPAREN] = ACTIONS(1065),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1067),
    [sym_word] = ACTIONS(1067),
    [anon_sym_LF] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1067),
  },
  [866] = {
    [sym_string] = STATE(1508),
    [sym_simple_expansion] = STATE(1508),
    [sym_string_expansion] = STATE(1508),
    [sym_expansion] = STATE(1508),
    [sym_command_substitution] = STATE(1508),
    [sym_process_substitution] = STATE(1508),
    [anon_sym_DOLLAR] = ACTIONS(585),
    [sym__special_character] = ACTIONS(3039),
    [anon_sym_DQUOTE] = ACTIONS(589),
    [sym_raw_string] = ACTIONS(3039),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(593),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(595),
    [anon_sym_BQUOTE] = ACTIONS(597),
    [anon_sym_LT_LPAREN] = ACTIONS(599),
    [anon_sym_GT_LPAREN] = ACTIONS(599),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3039),
  },
  [867] = {
    [aux_sym_concatenation_repeat1] = STATE(1510),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(3041),
    [sym_variable_name] = ACTIONS(1071),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [sym__special_character] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [sym_word] = ACTIONS(1075),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1075),
  },
  [868] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(3043),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [869] = {
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(1089),
    [sym_variable_name] = ACTIONS(1089),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1089),
    [anon_sym_PIPE_AMP] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_AMP] = ACTIONS(1089),
    [anon_sym_GT_AMP] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1089),
    [anon_sym_LT_LT_LT] = ACTIONS(1089),
    [anon_sym_DOLLAR] = ACTIONS(1091),
    [sym__special_character] = ACTIONS(1089),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1089),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1089),
    [anon_sym_GT_LPAREN] = ACTIONS(1089),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1091),
    [sym_word] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [870] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(627),
    [anon_sym_DOLLAR] = ACTIONS(3045),
    [anon_sym_DQUOTE] = ACTIONS(3043),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [871] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(3047),
    [sym_comment] = ACTIONS(57),
  },
  [872] = {
    [sym_subscript] = STATE(1516),
    [sym_variable_name] = ACTIONS(3049),
    [anon_sym_DASH] = ACTIONS(3051),
    [anon_sym_DOLLAR] = ACTIONS(3051),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3053),
    [anon_sym_STAR] = ACTIONS(3055),
    [anon_sym_AT] = ACTIONS(3055),
    [anon_sym_QMARK] = ACTIONS(3055),
    [anon_sym_0] = ACTIONS(3053),
    [anon_sym__] = ACTIONS(3053),
  },
  [873] = {
    [sym_concatenation] = STATE(1519),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1519),
    [anon_sym_RBRACE] = ACTIONS(3057),
    [anon_sym_EQ] = ACTIONS(3059),
    [anon_sym_DASH] = ACTIONS(3059),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(3061),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(3063),
    [anon_sym_COLON] = ACTIONS(3059),
    [anon_sym_COLON_QMARK] = ACTIONS(3059),
    [anon_sym_COLON_DASH] = ACTIONS(3059),
    [anon_sym_PERCENT] = ACTIONS(3059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [874] = {
    [sym_concatenation] = STATE(1522),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1522),
    [anon_sym_RBRACE] = ACTIONS(3065),
    [anon_sym_EQ] = ACTIONS(3067),
    [anon_sym_DASH] = ACTIONS(3067),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(3069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3067),
    [anon_sym_COLON_QMARK] = ACTIONS(3067),
    [anon_sym_COLON_DASH] = ACTIONS(3067),
    [anon_sym_PERCENT] = ACTIONS(3067),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [875] = {
    [anon_sym_RPAREN] = ACTIONS(3073),
    [sym_comment] = ACTIONS(57),
  },
  [876] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(3073),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [877] = {
    [anon_sym_BQUOTE] = ACTIONS(3073),
    [sym_comment] = ACTIONS(57),
  },
  [878] = {
    [anon_sym_RPAREN] = ACTIONS(3075),
    [sym_comment] = ACTIONS(57),
  },
  [879] = {
    [sym_variable_assignment] = STATE(879),
    [sym_subscript] = STATE(349),
    [sym_concatenation] = STATE(879),
    [sym_string] = STATE(344),
    [sym_simple_expansion] = STATE(344),
    [sym_string_expansion] = STATE(344),
    [sym_expansion] = STATE(344),
    [sym_command_substitution] = STATE(344),
    [sym_process_substitution] = STATE(344),
    [aux_sym_declaration_command_repeat1] = STATE(879),
    [aux_sym__literal_repeat1] = STATE(351),
    [sym_file_descriptor] = ACTIONS(2206),
    [sym_variable_name] = ACTIONS(3077),
    [anon_sym_SEMI] = ACTIONS(2211),
    [anon_sym_PIPE] = ACTIONS(2211),
    [anon_sym_SEMI_SEMI] = ACTIONS(2206),
    [anon_sym_PIPE_AMP] = ACTIONS(2206),
    [anon_sym_AMP_AMP] = ACTIONS(2206),
    [anon_sym_PIPE_PIPE] = ACTIONS(2206),
    [anon_sym_LT] = ACTIONS(2211),
    [anon_sym_GT] = ACTIONS(2211),
    [anon_sym_GT_GT] = ACTIONS(2206),
    [anon_sym_AMP_GT] = ACTIONS(2211),
    [anon_sym_AMP_GT_GT] = ACTIONS(2206),
    [anon_sym_LT_AMP] = ACTIONS(2206),
    [anon_sym_GT_AMP] = ACTIONS(2206),
    [anon_sym_LT_LT] = ACTIONS(2211),
    [anon_sym_LT_LT_DASH] = ACTIONS(2206),
    [anon_sym_LT_LT_LT] = ACTIONS(2206),
    [anon_sym_DOLLAR] = ACTIONS(3080),
    [sym__special_character] = ACTIONS(3083),
    [anon_sym_DQUOTE] = ACTIONS(3086),
    [sym_raw_string] = ACTIONS(3089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3092),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3095),
    [anon_sym_BQUOTE] = ACTIONS(3098),
    [anon_sym_LT_LPAREN] = ACTIONS(3101),
    [anon_sym_GT_LPAREN] = ACTIONS(3101),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3104),
    [sym_word] = ACTIONS(3107),
    [anon_sym_LF] = ACTIONS(2206),
    [anon_sym_AMP] = ACTIONS(2211),
  },
  [880] = {
    [sym_file_descriptor] = ACTIONS(335),
    [sym_variable_name] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(339),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [881] = {
    [aux_sym__literal_repeat1] = STATE(881),
    [sym_file_descriptor] = ACTIONS(1373),
    [sym_variable_name] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE_AMP] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_LT_LT_DASH] = ACTIONS(1373),
    [anon_sym_LT_LT_LT] = ACTIONS(1373),
    [anon_sym_DOLLAR] = ACTIONS(1375),
    [sym__special_character] = ACTIONS(3110),
    [anon_sym_DQUOTE] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1373),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [anon_sym_LT_LPAREN] = ACTIONS(1373),
    [anon_sym_GT_LPAREN] = ACTIONS(1373),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1375),
    [sym_word] = ACTIONS(1375),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
  },
  [882] = {
    [sym_file_descriptor] = ACTIONS(1057),
    [sym__concat] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_PIPE_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_AMP] = ACTIONS(1057),
    [anon_sym_GT_AMP] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_LT] = ACTIONS(1057),
    [anon_sym_DOLLAR] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [sym_raw_string] = ACTIONS(1057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1057),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1057),
    [anon_sym_BQUOTE] = ACTIONS(1057),
    [anon_sym_LT_LPAREN] = ACTIONS(1057),
    [anon_sym_GT_LPAREN] = ACTIONS(1057),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1059),
    [sym_word] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [883] = {
    [sym_file_descriptor] = ACTIONS(1061),
    [sym__concat] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(1063),
    [anon_sym_PIPE] = ACTIONS(1063),
    [anon_sym_SEMI_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE_AMP] = ACTIONS(1061),
    [anon_sym_AMP_AMP] = ACTIONS(1061),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1063),
    [anon_sym_GT_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT_GT] = ACTIONS(1061),
    [anon_sym_LT_AMP] = ACTIONS(1061),
    [anon_sym_GT_AMP] = ACTIONS(1061),
    [anon_sym_LT_LT] = ACTIONS(1063),
    [anon_sym_LT_LT_DASH] = ACTIONS(1061),
    [anon_sym_LT_LT_LT] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1061),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1061),
    [anon_sym_LT_LPAREN] = ACTIONS(1061),
    [anon_sym_GT_LPAREN] = ACTIONS(1061),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1063),
    [sym_word] = ACTIONS(1063),
    [anon_sym_LF] = ACTIONS(1061),
    [anon_sym_AMP] = ACTIONS(1063),
  },
  [884] = {
    [sym_file_descriptor] = ACTIONS(1065),
    [sym__concat] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1067),
    [anon_sym_SEMI_SEMI] = ACTIONS(1065),
    [anon_sym_PIPE_AMP] = ACTIONS(1065),
    [anon_sym_AMP_AMP] = ACTIONS(1065),
    [anon_sym_PIPE_PIPE] = ACTIONS(1065),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_GT] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT] = ACTIONS(1067),
    [anon_sym_AMP_GT_GT] = ACTIONS(1065),
    [anon_sym_LT_AMP] = ACTIONS(1065),
    [anon_sym_GT_AMP] = ACTIONS(1065),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_LT_LT_DASH] = ACTIONS(1065),
    [anon_sym_LT_LT_LT] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1067),
    [sym__special_character] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LT_LPAREN] = ACTIONS(1065),
    [anon_sym_GT_LPAREN] = ACTIONS(1065),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1067),
    [sym_word] = ACTIONS(1067),
    [anon_sym_LF] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1067),
  },
  [885] = {
    [sym_string] = STATE(1525),
    [sym_simple_expansion] = STATE(1525),
    [sym_string_expansion] = STATE(1525),
    [sym_expansion] = STATE(1525),
    [sym_command_substitution] = STATE(1525),
    [sym_process_substitution] = STATE(1525),
    [anon_sym_DOLLAR] = ACTIONS(605),
    [sym__special_character] = ACTIONS(3113),
    [anon_sym_DQUOTE] = ACTIONS(609),
    [sym_raw_string] = ACTIONS(3113),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(613),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(615),
    [anon_sym_BQUOTE] = ACTIONS(617),
    [anon_sym_LT_LPAREN] = ACTIONS(619),
    [anon_sym_GT_LPAREN] = ACTIONS(619),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3113),
  },
  [886] = {
    [aux_sym_concatenation_repeat1] = STATE(1527),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(3115),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [sym__special_character] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [sym_word] = ACTIONS(1075),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1075),
  },
  [887] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(3117),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [888] = {
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(1089),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1089),
    [anon_sym_PIPE_AMP] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_AMP] = ACTIONS(1089),
    [anon_sym_GT_AMP] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1089),
    [anon_sym_LT_LT_LT] = ACTIONS(1089),
    [anon_sym_DOLLAR] = ACTIONS(1091),
    [sym__special_character] = ACTIONS(1089),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1089),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1089),
    [anon_sym_GT_LPAREN] = ACTIONS(1089),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1091),
    [sym_word] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [889] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(627),
    [anon_sym_DOLLAR] = ACTIONS(3119),
    [anon_sym_DQUOTE] = ACTIONS(3117),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [890] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(3121),
    [sym_comment] = ACTIONS(57),
  },
  [891] = {
    [sym_subscript] = STATE(1533),
    [sym_variable_name] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3125),
    [anon_sym_DOLLAR] = ACTIONS(3125),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3127),
    [anon_sym_STAR] = ACTIONS(3129),
    [anon_sym_AT] = ACTIONS(3129),
    [anon_sym_QMARK] = ACTIONS(3129),
    [anon_sym_0] = ACTIONS(3127),
    [anon_sym__] = ACTIONS(3127),
  },
  [892] = {
    [sym_concatenation] = STATE(1536),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1536),
    [anon_sym_RBRACE] = ACTIONS(3131),
    [anon_sym_EQ] = ACTIONS(3133),
    [anon_sym_DASH] = ACTIONS(3133),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(3135),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(3137),
    [anon_sym_COLON] = ACTIONS(3133),
    [anon_sym_COLON_QMARK] = ACTIONS(3133),
    [anon_sym_COLON_DASH] = ACTIONS(3133),
    [anon_sym_PERCENT] = ACTIONS(3133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [893] = {
    [sym_concatenation] = STATE(1539),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1539),
    [anon_sym_RBRACE] = ACTIONS(3139),
    [anon_sym_EQ] = ACTIONS(3141),
    [anon_sym_DASH] = ACTIONS(3141),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(3143),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(3145),
    [anon_sym_COLON] = ACTIONS(3141),
    [anon_sym_COLON_QMARK] = ACTIONS(3141),
    [anon_sym_COLON_DASH] = ACTIONS(3141),
    [anon_sym_PERCENT] = ACTIONS(3141),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [894] = {
    [anon_sym_RPAREN] = ACTIONS(3147),
    [sym_comment] = ACTIONS(57),
  },
  [895] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(3147),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [896] = {
    [anon_sym_BQUOTE] = ACTIONS(3147),
    [sym_comment] = ACTIONS(57),
  },
  [897] = {
    [anon_sym_RPAREN] = ACTIONS(3149),
    [sym_comment] = ACTIONS(57),
  },
  [898] = {
    [sym_concatenation] = STATE(898),
    [sym_string] = STATE(355),
    [sym_simple_expansion] = STATE(355),
    [sym_string_expansion] = STATE(355),
    [sym_expansion] = STATE(355),
    [sym_command_substitution] = STATE(355),
    [sym_process_substitution] = STATE(355),
    [aux_sym_unset_command_repeat1] = STATE(898),
    [aux_sym__literal_repeat1] = STATE(361),
    [sym_file_descriptor] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym_PIPE] = ACTIONS(2286),
    [anon_sym_SEMI_SEMI] = ACTIONS(2284),
    [anon_sym_PIPE_AMP] = ACTIONS(2284),
    [anon_sym_AMP_AMP] = ACTIONS(2284),
    [anon_sym_PIPE_PIPE] = ACTIONS(2284),
    [anon_sym_LT] = ACTIONS(2286),
    [anon_sym_GT] = ACTIONS(2286),
    [anon_sym_GT_GT] = ACTIONS(2284),
    [anon_sym_AMP_GT] = ACTIONS(2286),
    [anon_sym_AMP_GT_GT] = ACTIONS(2284),
    [anon_sym_LT_AMP] = ACTIONS(2284),
    [anon_sym_GT_AMP] = ACTIONS(2284),
    [anon_sym_LT_LT] = ACTIONS(2286),
    [anon_sym_LT_LT_DASH] = ACTIONS(2284),
    [anon_sym_LT_LT_LT] = ACTIONS(2284),
    [anon_sym_DOLLAR] = ACTIONS(3151),
    [sym__special_character] = ACTIONS(3154),
    [anon_sym_DQUOTE] = ACTIONS(3157),
    [sym_raw_string] = ACTIONS(3160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3163),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3166),
    [anon_sym_BQUOTE] = ACTIONS(3169),
    [anon_sym_LT_LPAREN] = ACTIONS(3172),
    [anon_sym_GT_LPAREN] = ACTIONS(3172),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3175),
    [sym_word] = ACTIONS(3178),
    [anon_sym_LF] = ACTIONS(2284),
    [anon_sym_AMP] = ACTIONS(2286),
  },
  [899] = {
    [sym_file_descriptor] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(339),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [900] = {
    [aux_sym__literal_repeat1] = STATE(900),
    [sym_file_descriptor] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE_AMP] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_LT_LT_DASH] = ACTIONS(1373),
    [anon_sym_LT_LT_LT] = ACTIONS(1373),
    [anon_sym_DOLLAR] = ACTIONS(1375),
    [sym__special_character] = ACTIONS(3181),
    [anon_sym_DQUOTE] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1373),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [anon_sym_LT_LPAREN] = ACTIONS(1373),
    [anon_sym_GT_LPAREN] = ACTIONS(1373),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1375),
    [sym_word] = ACTIONS(1375),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
  },
  [901] = {
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_EQ_TILDE] = ACTIONS(2364),
    [anon_sym_EQ_EQ] = ACTIONS(2364),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [902] = {
    [sym_string] = STATE(901),
    [sym_simple_expansion] = STATE(901),
    [sym_string_expansion] = STATE(901),
    [sym_expansion] = STATE(901),
    [sym_command_substitution] = STATE(901),
    [sym_process_substitution] = STATE(901),
    [anon_sym_DOLLAR] = ACTIONS(3184),
    [sym__special_character] = ACTIONS(1711),
    [anon_sym_DQUOTE] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(1711),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1711),
  },
  [903] = {
    [aux_sym_concatenation_repeat1] = STATE(903),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(3186),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_EQ_TILDE] = ACTIONS(2364),
    [anon_sym_EQ_EQ] = ACTIONS(2364),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [904] = {
    [sym_file_descriptor] = ACTIONS(2371),
    [sym__concat] = ACTIONS(2371),
    [anon_sym_SEMI] = ACTIONS(2373),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_SEMI_SEMI] = ACTIONS(2371),
    [anon_sym_PIPE_AMP] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_EQ_TILDE] = ACTIONS(2373),
    [anon_sym_EQ_EQ] = ACTIONS(2373),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_GT_GT] = ACTIONS(2371),
    [anon_sym_AMP_GT] = ACTIONS(2373),
    [anon_sym_AMP_GT_GT] = ACTIONS(2371),
    [anon_sym_LT_AMP] = ACTIONS(2371),
    [anon_sym_GT_AMP] = ACTIONS(2371),
    [anon_sym_LT_LT] = ACTIONS(2373),
    [anon_sym_LT_LT_DASH] = ACTIONS(2371),
    [anon_sym_LT_LT_LT] = ACTIONS(2371),
    [anon_sym_DOLLAR] = ACTIONS(2373),
    [sym__special_character] = ACTIONS(2371),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [sym_raw_string] = ACTIONS(2371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2371),
    [anon_sym_BQUOTE] = ACTIONS(2371),
    [anon_sym_LT_LPAREN] = ACTIONS(2371),
    [anon_sym_GT_LPAREN] = ACTIONS(2371),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2373),
    [anon_sym_LF] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
  },
  [905] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(3189),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [906] = {
    [sym_concatenation] = STATE(1546),
    [sym_string] = STATE(1545),
    [sym_simple_expansion] = STATE(1545),
    [sym_string_expansion] = STATE(1545),
    [sym_expansion] = STATE(1545),
    [sym_command_substitution] = STATE(1545),
    [sym_process_substitution] = STATE(1545),
    [aux_sym__literal_repeat1] = STATE(1547),
    [anon_sym_RBRACE] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(3193),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3193),
  },
  [907] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(3195),
    [sym_comment] = ACTIONS(57),
  },
  [908] = {
    [sym_concatenation] = STATE(1551),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1551),
    [anon_sym_RBRACE] = ACTIONS(3197),
    [anon_sym_EQ] = ACTIONS(3199),
    [anon_sym_DASH] = ACTIONS(3199),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(3201),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(3203),
    [anon_sym_COLON] = ACTIONS(3199),
    [anon_sym_COLON_QMARK] = ACTIONS(3199),
    [anon_sym_COLON_DASH] = ACTIONS(3199),
    [anon_sym_PERCENT] = ACTIONS(3199),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [909] = {
    [sym_concatenation] = STATE(1553),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1553),
    [anon_sym_RBRACE] = ACTIONS(3191),
    [anon_sym_EQ] = ACTIONS(3205),
    [anon_sym_DASH] = ACTIONS(3205),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(3207),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(3209),
    [anon_sym_COLON] = ACTIONS(3205),
    [anon_sym_COLON_QMARK] = ACTIONS(3205),
    [anon_sym_COLON_DASH] = ACTIONS(3205),
    [anon_sym_PERCENT] = ACTIONS(3205),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [910] = {
    [sym_file_descriptor] = ACTIONS(2462),
    [sym__concat] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_SEMI_SEMI] = ACTIONS(2462),
    [anon_sym_PIPE_AMP] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_EQ_TILDE] = ACTIONS(2464),
    [anon_sym_EQ_EQ] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_GT_GT] = ACTIONS(2462),
    [anon_sym_AMP_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT_GT] = ACTIONS(2462),
    [anon_sym_LT_AMP] = ACTIONS(2462),
    [anon_sym_GT_AMP] = ACTIONS(2462),
    [anon_sym_LT_LT] = ACTIONS(2464),
    [anon_sym_LT_LT_DASH] = ACTIONS(2462),
    [anon_sym_LT_LT_LT] = ACTIONS(2462),
    [anon_sym_DOLLAR] = ACTIONS(2464),
    [sym__special_character] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [sym_raw_string] = ACTIONS(2462),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2462),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2462),
    [anon_sym_BQUOTE] = ACTIONS(2462),
    [anon_sym_LT_LPAREN] = ACTIONS(2462),
    [anon_sym_GT_LPAREN] = ACTIONS(2462),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2464),
    [anon_sym_LF] = ACTIONS(2462),
    [anon_sym_AMP] = ACTIONS(2464),
  },
  [911] = {
    [sym_concatenation] = STATE(1556),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1556),
    [sym_regex] = ACTIONS(3211),
    [anon_sym_RBRACE] = ACTIONS(3213),
    [anon_sym_EQ] = ACTIONS(3215),
    [anon_sym_DASH] = ACTIONS(3215),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(3217),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(3215),
    [anon_sym_COLON_QMARK] = ACTIONS(3215),
    [anon_sym_COLON_DASH] = ACTIONS(3215),
    [anon_sym_PERCENT] = ACTIONS(3215),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [912] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(3213),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [913] = {
    [sym_file_descriptor] = ACTIONS(2512),
    [sym__concat] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2514),
    [anon_sym_PIPE] = ACTIONS(2514),
    [anon_sym_SEMI_SEMI] = ACTIONS(2512),
    [anon_sym_PIPE_AMP] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE_PIPE] = ACTIONS(2512),
    [anon_sym_EQ_TILDE] = ACTIONS(2514),
    [anon_sym_EQ_EQ] = ACTIONS(2514),
    [anon_sym_LT] = ACTIONS(2514),
    [anon_sym_GT] = ACTIONS(2514),
    [anon_sym_GT_GT] = ACTIONS(2512),
    [anon_sym_AMP_GT] = ACTIONS(2514),
    [anon_sym_AMP_GT_GT] = ACTIONS(2512),
    [anon_sym_LT_AMP] = ACTIONS(2512),
    [anon_sym_GT_AMP] = ACTIONS(2512),
    [anon_sym_LT_LT] = ACTIONS(2514),
    [anon_sym_LT_LT_DASH] = ACTIONS(2512),
    [anon_sym_LT_LT_LT] = ACTIONS(2512),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [sym__special_character] = ACTIONS(2512),
    [anon_sym_DQUOTE] = ACTIONS(2512),
    [sym_raw_string] = ACTIONS(2512),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2512),
    [anon_sym_BQUOTE] = ACTIONS(2512),
    [anon_sym_LT_LPAREN] = ACTIONS(2512),
    [anon_sym_GT_LPAREN] = ACTIONS(2512),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2514),
    [anon_sym_LF] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2514),
  },
  [914] = {
    [sym_concatenation] = STATE(1553),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1553),
    [sym_regex] = ACTIONS(3219),
    [anon_sym_RBRACE] = ACTIONS(3191),
    [anon_sym_EQ] = ACTIONS(3205),
    [anon_sym_DASH] = ACTIONS(3205),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(3207),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(3205),
    [anon_sym_COLON_QMARK] = ACTIONS(3205),
    [anon_sym_COLON_DASH] = ACTIONS(3205),
    [anon_sym_PERCENT] = ACTIONS(3205),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [915] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(3191),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [916] = {
    [sym_file_descriptor] = ACTIONS(2520),
    [sym__concat] = ACTIONS(2520),
    [anon_sym_SEMI] = ACTIONS(2522),
    [anon_sym_PIPE] = ACTIONS(2522),
    [anon_sym_SEMI_SEMI] = ACTIONS(2520),
    [anon_sym_PIPE_AMP] = ACTIONS(2520),
    [anon_sym_AMP_AMP] = ACTIONS(2520),
    [anon_sym_PIPE_PIPE] = ACTIONS(2520),
    [anon_sym_EQ_TILDE] = ACTIONS(2522),
    [anon_sym_EQ_EQ] = ACTIONS(2522),
    [anon_sym_LT] = ACTIONS(2522),
    [anon_sym_GT] = ACTIONS(2522),
    [anon_sym_GT_GT] = ACTIONS(2520),
    [anon_sym_AMP_GT] = ACTIONS(2522),
    [anon_sym_AMP_GT_GT] = ACTIONS(2520),
    [anon_sym_LT_AMP] = ACTIONS(2520),
    [anon_sym_GT_AMP] = ACTIONS(2520),
    [anon_sym_LT_LT] = ACTIONS(2522),
    [anon_sym_LT_LT_DASH] = ACTIONS(2520),
    [anon_sym_LT_LT_LT] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(2522),
    [sym__special_character] = ACTIONS(2520),
    [anon_sym_DQUOTE] = ACTIONS(2520),
    [sym_raw_string] = ACTIONS(2520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2520),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2520),
    [anon_sym_BQUOTE] = ACTIONS(2520),
    [anon_sym_LT_LPAREN] = ACTIONS(2520),
    [anon_sym_GT_LPAREN] = ACTIONS(2520),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2522),
    [anon_sym_LF] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2522),
  },
  [917] = {
    [sym_file_descriptor] = ACTIONS(2554),
    [sym__concat] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(2556),
    [anon_sym_PIPE] = ACTIONS(2556),
    [anon_sym_SEMI_SEMI] = ACTIONS(2554),
    [anon_sym_PIPE_AMP] = ACTIONS(2554),
    [anon_sym_AMP_AMP] = ACTIONS(2554),
    [anon_sym_PIPE_PIPE] = ACTIONS(2554),
    [anon_sym_EQ_TILDE] = ACTIONS(2556),
    [anon_sym_EQ_EQ] = ACTIONS(2556),
    [anon_sym_LT] = ACTIONS(2556),
    [anon_sym_GT] = ACTIONS(2556),
    [anon_sym_GT_GT] = ACTIONS(2554),
    [anon_sym_AMP_GT] = ACTIONS(2556),
    [anon_sym_AMP_GT_GT] = ACTIONS(2554),
    [anon_sym_LT_AMP] = ACTIONS(2554),
    [anon_sym_GT_AMP] = ACTIONS(2554),
    [anon_sym_LT_LT] = ACTIONS(2556),
    [anon_sym_LT_LT_DASH] = ACTIONS(2554),
    [anon_sym_LT_LT_LT] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2556),
    [sym__special_character] = ACTIONS(2554),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2554),
    [anon_sym_BQUOTE] = ACTIONS(2554),
    [anon_sym_LT_LPAREN] = ACTIONS(2554),
    [anon_sym_GT_LPAREN] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2556),
    [anon_sym_LF] = ACTIONS(2554),
    [anon_sym_AMP] = ACTIONS(2556),
  },
  [918] = {
    [sym_compound_statement] = STATE(1558),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_comment] = ACTIONS(57),
  },
  [919] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(3221),
    [anon_sym_PLUS_EQ] = ACTIONS(3221),
    [sym_comment] = ACTIONS(57),
  },
  [920] = {
    [sym__simple_heredoc_body] = ACTIONS(3223),
    [sym__heredoc_body_beginning] = ACTIONS(3223),
    [sym_file_descriptor] = ACTIONS(3223),
    [ts_builtin_sym_end] = ACTIONS(3223),
    [anon_sym_SEMI] = ACTIONS(3225),
    [anon_sym_done] = ACTIONS(3223),
    [anon_sym_fi] = ACTIONS(3223),
    [anon_sym_elif] = ACTIONS(3223),
    [anon_sym_else] = ACTIONS(3223),
    [anon_sym_esac] = ACTIONS(3223),
    [anon_sym_PIPE] = ACTIONS(3225),
    [anon_sym_RPAREN] = ACTIONS(3223),
    [anon_sym_SEMI_SEMI] = ACTIONS(3223),
    [anon_sym_PIPE_AMP] = ACTIONS(3223),
    [anon_sym_AMP_AMP] = ACTIONS(3223),
    [anon_sym_PIPE_PIPE] = ACTIONS(3223),
    [anon_sym_LT] = ACTIONS(3225),
    [anon_sym_GT] = ACTIONS(3225),
    [anon_sym_GT_GT] = ACTIONS(3223),
    [anon_sym_AMP_GT] = ACTIONS(3225),
    [anon_sym_AMP_GT_GT] = ACTIONS(3223),
    [anon_sym_LT_AMP] = ACTIONS(3223),
    [anon_sym_GT_AMP] = ACTIONS(3223),
    [anon_sym_LT_LT] = ACTIONS(3225),
    [anon_sym_LT_LT_DASH] = ACTIONS(3223),
    [anon_sym_LT_LT_LT] = ACTIONS(3223),
    [anon_sym_BQUOTE] = ACTIONS(3223),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3223),
    [anon_sym_AMP] = ACTIONS(3225),
  },
  [921] = {
    [sym_subshell] = STATE(146),
    [sym_test_command] = STATE(146),
    [sym_command] = STATE(146),
    [sym_command_name] = STATE(935),
    [sym_variable_assignment] = STATE(940),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(940),
    [sym_concatenation] = STATE(938),
    [sym_string] = STATE(927),
    [sym_simple_expansion] = STATE(927),
    [sym_string_expansion] = STATE(927),
    [sym_expansion] = STATE(927),
    [sym_command_substitution] = STATE(927),
    [sym_process_substitution] = STATE(927),
    [aux_sym_command_repeat1] = STATE(940),
    [aux_sym__literal_repeat1] = STATE(941),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(1761),
    [sym__special_character] = ACTIONS(1763),
    [anon_sym_DQUOTE] = ACTIONS(1765),
    [sym_raw_string] = ACTIONS(1767),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1769),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1771),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [anon_sym_LT_LPAREN] = ACTIONS(1775),
    [anon_sym_GT_LPAREN] = ACTIONS(1775),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1767),
  },
  [922] = {
    [sym_variable_assignment] = STATE(1570),
    [sym_subscript] = STATE(1569),
    [sym_concatenation] = STATE(1570),
    [sym_string] = STATE(1564),
    [sym_simple_expansion] = STATE(1564),
    [sym_string_expansion] = STATE(1564),
    [sym_expansion] = STATE(1564),
    [sym_command_substitution] = STATE(1564),
    [sym_process_substitution] = STATE(1564),
    [aux_sym_declaration_command_repeat1] = STATE(1570),
    [aux_sym__literal_repeat1] = STATE(1571),
    [sym__simple_heredoc_body] = ACTIONS(259),
    [sym__heredoc_body_beginning] = ACTIONS(259),
    [sym_file_descriptor] = ACTIONS(259),
    [sym_variable_name] = ACTIONS(3227),
    [anon_sym_SEMI] = ACTIONS(263),
    [anon_sym_done] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_SEMI_SEMI] = ACTIONS(259),
    [anon_sym_PIPE_AMP] = ACTIONS(259),
    [anon_sym_AMP_AMP] = ACTIONS(259),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_LT] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_GT_GT] = ACTIONS(259),
    [anon_sym_AMP_GT] = ACTIONS(263),
    [anon_sym_AMP_GT_GT] = ACTIONS(259),
    [anon_sym_LT_AMP] = ACTIONS(259),
    [anon_sym_GT_AMP] = ACTIONS(259),
    [anon_sym_LT_LT] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(259),
    [anon_sym_LT_LT_LT] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(3229),
    [sym__special_character] = ACTIONS(3231),
    [anon_sym_DQUOTE] = ACTIONS(3233),
    [sym_raw_string] = ACTIONS(3235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3239),
    [anon_sym_BQUOTE] = ACTIONS(3241),
    [anon_sym_LT_LPAREN] = ACTIONS(3243),
    [anon_sym_GT_LPAREN] = ACTIONS(3243),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3245),
    [sym_word] = ACTIONS(3247),
    [anon_sym_LF] = ACTIONS(259),
    [anon_sym_AMP] = ACTIONS(263),
  },
  [923] = {
    [sym_concatenation] = STATE(1580),
    [sym_string] = STATE(1575),
    [sym_simple_expansion] = STATE(1575),
    [sym_string_expansion] = STATE(1575),
    [sym_expansion] = STATE(1575),
    [sym_command_substitution] = STATE(1575),
    [sym_process_substitution] = STATE(1575),
    [aux_sym_unset_command_repeat1] = STATE(1580),
    [aux_sym__literal_repeat1] = STATE(1581),
    [sym__simple_heredoc_body] = ACTIONS(285),
    [sym__heredoc_body_beginning] = ACTIONS(285),
    [sym_file_descriptor] = ACTIONS(285),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym_done] = ACTIONS(287),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(285),
    [anon_sym_PIPE_AMP] = ACTIONS(285),
    [anon_sym_AMP_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(287),
    [anon_sym_GT] = ACTIONS(287),
    [anon_sym_GT_GT] = ACTIONS(285),
    [anon_sym_AMP_GT] = ACTIONS(287),
    [anon_sym_AMP_GT_GT] = ACTIONS(285),
    [anon_sym_LT_AMP] = ACTIONS(285),
    [anon_sym_GT_AMP] = ACTIONS(285),
    [anon_sym_LT_LT] = ACTIONS(287),
    [anon_sym_LT_LT_DASH] = ACTIONS(285),
    [anon_sym_LT_LT_LT] = ACTIONS(285),
    [anon_sym_DOLLAR] = ACTIONS(3249),
    [sym__special_character] = ACTIONS(3251),
    [anon_sym_DQUOTE] = ACTIONS(3253),
    [sym_raw_string] = ACTIONS(3255),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3257),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3259),
    [anon_sym_BQUOTE] = ACTIONS(3261),
    [anon_sym_LT_LPAREN] = ACTIONS(3263),
    [anon_sym_GT_LPAREN] = ACTIONS(3263),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3265),
    [sym_word] = ACTIONS(3267),
    [anon_sym_LF] = ACTIONS(285),
    [anon_sym_AMP] = ACTIONS(287),
  },
  [924] = {
    [sym_string] = STATE(1583),
    [anon_sym_DASH] = ACTIONS(3269),
    [anon_sym_DOLLAR] = ACTIONS(3269),
    [anon_sym_DQUOTE] = ACTIONS(1765),
    [sym_raw_string] = ACTIONS(3271),
    [anon_sym_POUND] = ACTIONS(3269),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3273),
    [anon_sym_STAR] = ACTIONS(3275),
    [anon_sym_AT] = ACTIONS(3275),
    [anon_sym_QMARK] = ACTIONS(3275),
    [anon_sym_0] = ACTIONS(3273),
    [anon_sym__] = ACTIONS(3273),
  },
  [925] = {
    [aux_sym_concatenation_repeat1] = STATE(1586),
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(3277),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_done] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_EQ_TILDE] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [926] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(1589),
    [anon_sym_DOLLAR] = ACTIONS(3279),
    [anon_sym_DQUOTE] = ACTIONS(3281),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [927] = {
    [aux_sym_concatenation_repeat1] = STATE(1586),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(3277),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_done] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [928] = {
    [sym_subscript] = STATE(1593),
    [sym_variable_name] = ACTIONS(3283),
    [anon_sym_BANG] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3287),
    [anon_sym_DOLLAR] = ACTIONS(3287),
    [anon_sym_POUND] = ACTIONS(3285),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3289),
    [anon_sym_STAR] = ACTIONS(3291),
    [anon_sym_AT] = ACTIONS(3291),
    [anon_sym_QMARK] = ACTIONS(3291),
    [anon_sym_0] = ACTIONS(3289),
    [anon_sym__] = ACTIONS(3289),
  },
  [929] = {
    [sym__statements] = STATE(1594),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(1595),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [930] = {
    [sym__statements] = STATE(1596),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [931] = {
    [sym__statements] = STATE(1597),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [932] = {
    [aux_sym_concatenation_repeat1] = STATE(1586),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(3277),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_done] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_LPAREN] = ACTIONS(387),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [933] = {
    [anon_sym_done] = ACTIONS(3293),
    [sym_comment] = ACTIONS(57),
  },
  [934] = {
    [sym_file_redirect] = STATE(1606),
    [sym_heredoc_redirect] = STATE(1606),
    [sym_heredoc_body] = STATE(1605),
    [sym_herestring_redirect] = STATE(1606),
    [aux_sym_redirected_statement_repeat1] = STATE(1606),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(3295),
    [anon_sym_SEMI] = ACTIONS(3297),
    [anon_sym_done] = ACTIONS(399),
    [anon_sym_PIPE] = ACTIONS(3299),
    [anon_sym_SEMI_SEMI] = ACTIONS(3301),
    [anon_sym_PIPE_AMP] = ACTIONS(3303),
    [anon_sym_AMP_AMP] = ACTIONS(3305),
    [anon_sym_PIPE_PIPE] = ACTIONS(3305),
    [anon_sym_LT] = ACTIONS(3307),
    [anon_sym_GT] = ACTIONS(3307),
    [anon_sym_GT_GT] = ACTIONS(3309),
    [anon_sym_AMP_GT] = ACTIONS(3307),
    [anon_sym_AMP_GT_GT] = ACTIONS(3309),
    [anon_sym_LT_AMP] = ACTIONS(3309),
    [anon_sym_GT_AMP] = ACTIONS(3309),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(3311),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3301),
    [anon_sym_AMP] = ACTIONS(3297),
  },
  [935] = {
    [sym_concatenation] = STATE(1609),
    [sym_string] = STATE(1608),
    [sym_simple_expansion] = STATE(1608),
    [sym_string_expansion] = STATE(1608),
    [sym_expansion] = STATE(1608),
    [sym_command_substitution] = STATE(1608),
    [sym_process_substitution] = STATE(1608),
    [aux_sym_command_repeat2] = STATE(1609),
    [aux_sym__literal_repeat1] = STATE(1610),
    [sym__simple_heredoc_body] = ACTIONS(421),
    [sym__heredoc_body_beginning] = ACTIONS(421),
    [sym_file_descriptor] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_done] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI_SEMI] = ACTIONS(421),
    [anon_sym_PIPE_AMP] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(3313),
    [anon_sym_EQ_EQ] = ACTIONS(3313),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_AMP_GT] = ACTIONS(423),
    [anon_sym_AMP_GT_GT] = ACTIONS(421),
    [anon_sym_LT_AMP] = ACTIONS(421),
    [anon_sym_GT_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_LT_LT_DASH] = ACTIONS(421),
    [anon_sym_LT_LT_LT] = ACTIONS(421),
    [anon_sym_DOLLAR] = ACTIONS(1761),
    [sym__special_character] = ACTIONS(3315),
    [anon_sym_DQUOTE] = ACTIONS(1765),
    [sym_raw_string] = ACTIONS(3317),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1769),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1771),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [anon_sym_LT_LPAREN] = ACTIONS(1775),
    [anon_sym_GT_LPAREN] = ACTIONS(1775),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3319),
    [anon_sym_LF] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
  },
  [936] = {
    [sym_file_redirect] = STATE(1606),
    [sym_heredoc_redirect] = STATE(1606),
    [sym_heredoc_body] = STATE(1605),
    [sym_herestring_redirect] = STATE(1606),
    [aux_sym_redirected_statement_repeat1] = STATE(1606),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(3297),
    [anon_sym_done] = ACTIONS(3321),
    [anon_sym_PIPE] = ACTIONS(3299),
    [anon_sym_SEMI_SEMI] = ACTIONS(3301),
    [anon_sym_PIPE_AMP] = ACTIONS(3303),
    [anon_sym_AMP_AMP] = ACTIONS(3305),
    [anon_sym_PIPE_PIPE] = ACTIONS(3305),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(3311),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(3301),
    [anon_sym_AMP] = ACTIONS(3297),
  },
  [937] = {
    [anon_sym_EQ] = ACTIONS(3221),
    [anon_sym_PLUS_EQ] = ACTIONS(3221),
    [sym_comment] = ACTIONS(57),
  },
  [938] = {
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_done] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [939] = {
    [sym_redirected_statement] = STATE(1611),
    [sym_for_statement] = STATE(1611),
    [sym_c_style_for_statement] = STATE(1611),
    [sym_while_statement] = STATE(1611),
    [sym_if_statement] = STATE(1611),
    [sym_case_statement] = STATE(1611),
    [sym_function_definition] = STATE(1611),
    [sym_compound_statement] = STATE(1611),
    [sym_subshell] = STATE(1611),
    [sym_pipeline] = STATE(1611),
    [sym_list] = STATE(1611),
    [sym_negated_command] = STATE(1611),
    [sym_test_command] = STATE(1611),
    [sym_declaration_command] = STATE(1611),
    [sym_unset_command] = STATE(1611),
    [sym_command] = STATE(1611),
    [sym_command_name] = STATE(935),
    [sym_variable_assignment] = STATE(1612),
    [sym_subscript] = STATE(937),
    [sym_file_redirect] = STATE(940),
    [sym_concatenation] = STATE(938),
    [sym_string] = STATE(927),
    [sym_simple_expansion] = STATE(927),
    [sym_string_expansion] = STATE(927),
    [sym_expansion] = STATE(927),
    [sym_command_substitution] = STATE(927),
    [sym_process_substitution] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(251),
    [aux_sym_command_repeat1] = STATE(940),
    [aux_sym__literal_repeat1] = STATE(941),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(1751),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1755),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(1757),
    [anon_sym_typeset] = ACTIONS(1757),
    [anon_sym_export] = ACTIONS(1757),
    [anon_sym_readonly] = ACTIONS(1757),
    [anon_sym_local] = ACTIONS(1757),
    [anon_sym_unset] = ACTIONS(1759),
    [anon_sym_unsetenv] = ACTIONS(1759),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(1761),
    [sym__special_character] = ACTIONS(1763),
    [anon_sym_DQUOTE] = ACTIONS(1765),
    [sym_raw_string] = ACTIONS(1767),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1769),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1771),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [anon_sym_LT_LPAREN] = ACTIONS(1775),
    [anon_sym_GT_LPAREN] = ACTIONS(1775),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1777),
  },
  [940] = {
    [sym_command_name] = STATE(1613),
    [sym_variable_assignment] = STATE(253),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(253),
    [sym_concatenation] = STATE(938),
    [sym_string] = STATE(927),
    [sym_simple_expansion] = STATE(927),
    [sym_string_expansion] = STATE(927),
    [sym_expansion] = STATE(927),
    [sym_command_substitution] = STATE(927),
    [sym_process_substitution] = STATE(927),
    [aux_sym_command_repeat1] = STATE(253),
    [aux_sym__literal_repeat1] = STATE(941),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(1761),
    [sym__special_character] = ACTIONS(3315),
    [anon_sym_DQUOTE] = ACTIONS(1765),
    [sym_raw_string] = ACTIONS(1767),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1769),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1771),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [anon_sym_LT_LPAREN] = ACTIONS(1775),
    [anon_sym_GT_LPAREN] = ACTIONS(1775),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1767),
  },
  [941] = {
    [aux_sym__literal_repeat1] = STATE(1615),
    [sym__simple_heredoc_body] = ACTIONS(437),
    [sym__heredoc_body_beginning] = ACTIONS(437),
    [sym_file_descriptor] = ACTIONS(437),
    [anon_sym_SEMI] = ACTIONS(439),
    [anon_sym_done] = ACTIONS(439),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI_SEMI] = ACTIONS(437),
    [anon_sym_PIPE_AMP] = ACTIONS(437),
    [anon_sym_AMP_AMP] = ACTIONS(437),
    [anon_sym_PIPE_PIPE] = ACTIONS(437),
    [anon_sym_EQ_TILDE] = ACTIONS(439),
    [anon_sym_EQ_EQ] = ACTIONS(439),
    [anon_sym_LT] = ACTIONS(439),
    [anon_sym_GT] = ACTIONS(439),
    [anon_sym_GT_GT] = ACTIONS(437),
    [anon_sym_AMP_GT] = ACTIONS(439),
    [anon_sym_AMP_GT_GT] = ACTIONS(437),
    [anon_sym_LT_AMP] = ACTIONS(437),
    [anon_sym_GT_AMP] = ACTIONS(437),
    [anon_sym_LT_LT] = ACTIONS(439),
    [anon_sym_LT_LT_DASH] = ACTIONS(437),
    [anon_sym_LT_LT_LT] = ACTIONS(437),
    [anon_sym_DOLLAR] = ACTIONS(439),
    [sym__special_character] = ACTIONS(3323),
    [anon_sym_DQUOTE] = ACTIONS(437),
    [sym_raw_string] = ACTIONS(437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(437),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(437),
    [anon_sym_BQUOTE] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(437),
    [anon_sym_GT_LPAREN] = ACTIONS(437),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(439),
    [anon_sym_LF] = ACTIONS(437),
    [anon_sym_AMP] = ACTIONS(439),
  },
  [942] = {
    [sym_concatenation] = STATE(1617),
    [sym_string] = STATE(1616),
    [sym_simple_expansion] = STATE(1616),
    [sym_string_expansion] = STATE(1616),
    [sym_expansion] = STATE(1616),
    [sym_command_substitution] = STATE(1616),
    [sym_process_substitution] = STATE(1616),
    [aux_sym__literal_repeat1] = STATE(1618),
    [anon_sym_DOLLAR] = ACTIONS(125),
    [sym__special_character] = ACTIONS(1789),
    [anon_sym_DQUOTE] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(3325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3325),
  },
  [943] = {
    [sym_file_redirect] = STATE(388),
    [sym_heredoc_redirect] = STATE(388),
    [sym_herestring_redirect] = STATE(388),
    [aux_sym_redirected_statement_repeat1] = STATE(388),
    [sym_file_descriptor] = ACTIONS(2584),
    [anon_sym_SEMI] = ACTIONS(2586),
    [anon_sym_PIPE] = ACTIONS(2586),
    [anon_sym_SEMI_SEMI] = ACTIONS(2584),
    [anon_sym_PIPE_AMP] = ACTIONS(2584),
    [anon_sym_AMP_AMP] = ACTIONS(2584),
    [anon_sym_PIPE_PIPE] = ACTIONS(2584),
    [anon_sym_LT] = ACTIONS(2586),
    [anon_sym_GT] = ACTIONS(2586),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT] = ACTIONS(2586),
    [anon_sym_AMP_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_AMP] = ACTIONS(2584),
    [anon_sym_GT_AMP] = ACTIONS(2584),
    [anon_sym_LT_LT] = ACTIONS(2586),
    [anon_sym_LT_LT_DASH] = ACTIONS(2584),
    [anon_sym_LT_LT_LT] = ACTIONS(2584),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2584),
    [anon_sym_AMP] = ACTIONS(2586),
  },
  [944] = {
    [sym_file_redirect] = STATE(388),
    [sym_heredoc_redirect] = STATE(388),
    [sym_herestring_redirect] = STATE(388),
    [aux_sym_redirected_statement_repeat1] = STATE(388),
    [sym_file_descriptor] = ACTIONS(2584),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2586),
    [anon_sym_PIPE] = ACTIONS(2586),
    [anon_sym_SEMI_SEMI] = ACTIONS(2584),
    [anon_sym_PIPE_AMP] = ACTIONS(2584),
    [anon_sym_AMP_AMP] = ACTIONS(2584),
    [anon_sym_PIPE_PIPE] = ACTIONS(2584),
    [anon_sym_LT] = ACTIONS(2586),
    [anon_sym_GT] = ACTIONS(2586),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT] = ACTIONS(2586),
    [anon_sym_AMP_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_AMP] = ACTIONS(2584),
    [anon_sym_GT_AMP] = ACTIONS(2584),
    [anon_sym_LT_LT] = ACTIONS(2586),
    [anon_sym_LT_LT_DASH] = ACTIONS(2584),
    [anon_sym_LT_LT_LT] = ACTIONS(2584),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2584),
    [anon_sym_AMP] = ACTIONS(2586),
  },
  [945] = {
    [sym_file_redirect] = STATE(388),
    [sym_heredoc_redirect] = STATE(388),
    [sym_herestring_redirect] = STATE(388),
    [aux_sym_redirected_statement_repeat1] = STATE(388),
    [sym_file_descriptor] = ACTIONS(2588),
    [anon_sym_SEMI] = ACTIONS(2590),
    [anon_sym_PIPE] = ACTIONS(657),
    [anon_sym_SEMI_SEMI] = ACTIONS(2588),
    [anon_sym_PIPE_AMP] = ACTIONS(661),
    [anon_sym_AMP_AMP] = ACTIONS(2588),
    [anon_sym_PIPE_PIPE] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(2590),
    [anon_sym_GT] = ACTIONS(2590),
    [anon_sym_GT_GT] = ACTIONS(2588),
    [anon_sym_AMP_GT] = ACTIONS(2590),
    [anon_sym_AMP_GT_GT] = ACTIONS(2588),
    [anon_sym_LT_AMP] = ACTIONS(2588),
    [anon_sym_GT_AMP] = ACTIONS(2588),
    [anon_sym_LT_LT] = ACTIONS(2590),
    [anon_sym_LT_LT_DASH] = ACTIONS(2588),
    [anon_sym_LT_LT_LT] = ACTIONS(2588),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2588),
    [anon_sym_AMP] = ACTIONS(2590),
  },
  [946] = {
    [sym_file_redirect] = STATE(388),
    [sym_heredoc_redirect] = STATE(388),
    [sym_herestring_redirect] = STATE(388),
    [aux_sym_redirected_statement_repeat1] = STATE(388),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2590),
    [anon_sym_PIPE] = ACTIONS(657),
    [anon_sym_SEMI_SEMI] = ACTIONS(2588),
    [anon_sym_PIPE_AMP] = ACTIONS(661),
    [anon_sym_AMP_AMP] = ACTIONS(2588),
    [anon_sym_PIPE_PIPE] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(2590),
    [anon_sym_LT_LT_DASH] = ACTIONS(2588),
    [anon_sym_LT_LT_LT] = ACTIONS(2588),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2588),
    [anon_sym_AMP] = ACTIONS(2590),
  },
  [947] = {
    [aux_sym_concatenation_repeat1] = STATE(1619),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(633),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [sym__special_character] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [948] = {
    [aux_sym_concatenation_repeat1] = STATE(1619),
    [sym_file_descriptor] = ACTIONS(1037),
    [sym__concat] = ACTIONS(633),
    [anon_sym_SEMI] = ACTIONS(1039),
    [anon_sym_PIPE] = ACTIONS(1039),
    [anon_sym_SEMI_SEMI] = ACTIONS(1037),
    [anon_sym_PIPE_AMP] = ACTIONS(1037),
    [anon_sym_AMP_AMP] = ACTIONS(1037),
    [anon_sym_PIPE_PIPE] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1039),
    [anon_sym_GT] = ACTIONS(1039),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_AMP_GT] = ACTIONS(1039),
    [anon_sym_AMP_GT_GT] = ACTIONS(1037),
    [anon_sym_LT_AMP] = ACTIONS(1037),
    [anon_sym_GT_AMP] = ACTIONS(1037),
    [anon_sym_LT_LT] = ACTIONS(1039),
    [anon_sym_LT_LT_DASH] = ACTIONS(1037),
    [anon_sym_LT_LT_LT] = ACTIONS(1037),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1037),
    [anon_sym_AMP] = ACTIONS(1039),
  },
  [949] = {
    [sym_file_descriptor] = ACTIONS(1037),
    [anon_sym_SEMI] = ACTIONS(1039),
    [anon_sym_PIPE] = ACTIONS(1039),
    [anon_sym_SEMI_SEMI] = ACTIONS(1037),
    [anon_sym_PIPE_AMP] = ACTIONS(1037),
    [anon_sym_AMP_AMP] = ACTIONS(1037),
    [anon_sym_PIPE_PIPE] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1039),
    [anon_sym_GT] = ACTIONS(1039),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_AMP_GT] = ACTIONS(1039),
    [anon_sym_AMP_GT_GT] = ACTIONS(1037),
    [anon_sym_LT_AMP] = ACTIONS(1037),
    [anon_sym_GT_AMP] = ACTIONS(1037),
    [anon_sym_LT_LT] = ACTIONS(1039),
    [anon_sym_LT_LT_DASH] = ACTIONS(1037),
    [anon_sym_LT_LT_LT] = ACTIONS(1037),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1037),
    [anon_sym_AMP] = ACTIONS(1039),
  },
  [950] = {
    [aux_sym__literal_repeat1] = STATE(1620),
    [sym_file_descriptor] = ACTIONS(1051),
    [anon_sym_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE] = ACTIONS(1053),
    [anon_sym_SEMI_SEMI] = ACTIONS(1051),
    [anon_sym_PIPE_AMP] = ACTIONS(1051),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_PIPE_PIPE] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT_GT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1051),
    [anon_sym_GT_AMP] = ACTIONS(1051),
    [anon_sym_LT_LT] = ACTIONS(1053),
    [anon_sym_LT_LT_DASH] = ACTIONS(1051),
    [anon_sym_LT_LT_LT] = ACTIONS(1051),
    [sym__special_character] = ACTIONS(683),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1051),
    [anon_sym_AMP] = ACTIONS(1053),
  },
  [951] = {
    [sym_file_descriptor] = ACTIONS(2592),
    [anon_sym_SEMI] = ACTIONS(2594),
    [anon_sym_PIPE] = ACTIONS(2594),
    [anon_sym_SEMI_SEMI] = ACTIONS(2592),
    [anon_sym_PIPE_AMP] = ACTIONS(2592),
    [anon_sym_AMP_AMP] = ACTIONS(2592),
    [anon_sym_PIPE_PIPE] = ACTIONS(2592),
    [anon_sym_LT] = ACTIONS(2594),
    [anon_sym_GT] = ACTIONS(2594),
    [anon_sym_GT_GT] = ACTIONS(2592),
    [anon_sym_AMP_GT] = ACTIONS(2594),
    [anon_sym_AMP_GT_GT] = ACTIONS(2592),
    [anon_sym_LT_AMP] = ACTIONS(2592),
    [anon_sym_GT_AMP] = ACTIONS(2592),
    [anon_sym_LT_LT] = ACTIONS(2594),
    [anon_sym_LT_LT_DASH] = ACTIONS(2592),
    [anon_sym_LT_LT_LT] = ACTIONS(2592),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2592),
    [anon_sym_AMP] = ACTIONS(2594),
  },
  [952] = {
    [aux_sym_concatenation_repeat1] = STATE(1619),
    [sym_file_descriptor] = ACTIONS(2596),
    [sym__concat] = ACTIONS(633),
    [anon_sym_SEMI] = ACTIONS(2598),
    [anon_sym_PIPE] = ACTIONS(2598),
    [anon_sym_SEMI_SEMI] = ACTIONS(2596),
    [anon_sym_PIPE_AMP] = ACTIONS(2596),
    [anon_sym_AMP_AMP] = ACTIONS(2596),
    [anon_sym_PIPE_PIPE] = ACTIONS(2596),
    [anon_sym_LT] = ACTIONS(2598),
    [anon_sym_GT] = ACTIONS(2598),
    [anon_sym_GT_GT] = ACTIONS(2596),
    [anon_sym_AMP_GT] = ACTIONS(2598),
    [anon_sym_AMP_GT_GT] = ACTIONS(2596),
    [anon_sym_LT_AMP] = ACTIONS(2596),
    [anon_sym_GT_AMP] = ACTIONS(2596),
    [anon_sym_LT_LT] = ACTIONS(2598),
    [anon_sym_LT_LT_DASH] = ACTIONS(2596),
    [anon_sym_LT_LT_LT] = ACTIONS(2596),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2596),
    [anon_sym_AMP] = ACTIONS(2598),
  },
  [953] = {
    [sym_file_descriptor] = ACTIONS(2596),
    [anon_sym_SEMI] = ACTIONS(2598),
    [anon_sym_PIPE] = ACTIONS(2598),
    [anon_sym_SEMI_SEMI] = ACTIONS(2596),
    [anon_sym_PIPE_AMP] = ACTIONS(2596),
    [anon_sym_AMP_AMP] = ACTIONS(2596),
    [anon_sym_PIPE_PIPE] = ACTIONS(2596),
    [anon_sym_LT] = ACTIONS(2598),
    [anon_sym_GT] = ACTIONS(2598),
    [anon_sym_GT_GT] = ACTIONS(2596),
    [anon_sym_AMP_GT] = ACTIONS(2598),
    [anon_sym_AMP_GT_GT] = ACTIONS(2596),
    [anon_sym_LT_AMP] = ACTIONS(2596),
    [anon_sym_GT_AMP] = ACTIONS(2596),
    [anon_sym_LT_LT] = ACTIONS(2598),
    [anon_sym_LT_LT_DASH] = ACTIONS(2596),
    [anon_sym_LT_LT_LT] = ACTIONS(2596),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2596),
    [anon_sym_AMP] = ACTIONS(2598),
  },
  [954] = {
    [aux_sym__literal_repeat1] = STATE(1620),
    [sym_file_descriptor] = ACTIONS(2600),
    [anon_sym_SEMI] = ACTIONS(2602),
    [anon_sym_PIPE] = ACTIONS(2602),
    [anon_sym_SEMI_SEMI] = ACTIONS(2600),
    [anon_sym_PIPE_AMP] = ACTIONS(2600),
    [anon_sym_AMP_AMP] = ACTIONS(2600),
    [anon_sym_PIPE_PIPE] = ACTIONS(2600),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_GT_GT] = ACTIONS(2600),
    [anon_sym_AMP_GT] = ACTIONS(2602),
    [anon_sym_AMP_GT_GT] = ACTIONS(2600),
    [anon_sym_LT_AMP] = ACTIONS(2600),
    [anon_sym_GT_AMP] = ACTIONS(2600),
    [anon_sym_LT_LT] = ACTIONS(2602),
    [anon_sym_LT_LT_DASH] = ACTIONS(2600),
    [anon_sym_LT_LT_LT] = ACTIONS(2600),
    [sym__special_character] = ACTIONS(683),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2600),
    [anon_sym_AMP] = ACTIONS(2602),
  },
  [955] = {
    [sym_file_redirect] = STATE(955),
    [sym_heredoc_redirect] = STATE(955),
    [sym_herestring_redirect] = STATE(955),
    [aux_sym_redirected_statement_repeat1] = STATE(955),
    [sym_file_descriptor] = ACTIONS(3327),
    [anon_sym_SEMI] = ACTIONS(2615),
    [anon_sym_PIPE] = ACTIONS(2615),
    [anon_sym_SEMI_SEMI] = ACTIONS(2610),
    [anon_sym_PIPE_AMP] = ACTIONS(2610),
    [anon_sym_AMP_AMP] = ACTIONS(2610),
    [anon_sym_PIPE_PIPE] = ACTIONS(2610),
    [anon_sym_LT] = ACTIONS(3330),
    [anon_sym_GT] = ACTIONS(3330),
    [anon_sym_GT_GT] = ACTIONS(3333),
    [anon_sym_AMP_GT] = ACTIONS(3330),
    [anon_sym_AMP_GT_GT] = ACTIONS(3333),
    [anon_sym_LT_AMP] = ACTIONS(3333),
    [anon_sym_GT_AMP] = ACTIONS(3333),
    [anon_sym_LT_LT] = ACTIONS(3336),
    [anon_sym_LT_LT_DASH] = ACTIONS(3339),
    [anon_sym_LT_LT_LT] = ACTIONS(3342),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2610),
    [anon_sym_AMP] = ACTIONS(2615),
  },
  [956] = {
    [sym_file_descriptor] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2634),
    [anon_sym_SEMI_SEMI] = ACTIONS(2632),
    [anon_sym_PIPE_AMP] = ACTIONS(2632),
    [anon_sym_AMP_AMP] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2632),
    [anon_sym_EQ_TILDE] = ACTIONS(2634),
    [anon_sym_EQ_EQ] = ACTIONS(2634),
    [anon_sym_LT] = ACTIONS(2634),
    [anon_sym_GT] = ACTIONS(2634),
    [anon_sym_GT_GT] = ACTIONS(2632),
    [anon_sym_AMP_GT] = ACTIONS(2634),
    [anon_sym_AMP_GT_GT] = ACTIONS(2632),
    [anon_sym_LT_AMP] = ACTIONS(2632),
    [anon_sym_GT_AMP] = ACTIONS(2632),
    [anon_sym_LT_LT] = ACTIONS(2634),
    [anon_sym_LT_LT_DASH] = ACTIONS(2632),
    [anon_sym_LT_LT_LT] = ACTIONS(2632),
    [anon_sym_DOLLAR] = ACTIONS(2634),
    [sym__special_character] = ACTIONS(2632),
    [anon_sym_DQUOTE] = ACTIONS(2632),
    [sym_raw_string] = ACTIONS(2632),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2632),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2632),
    [anon_sym_BQUOTE] = ACTIONS(2632),
    [anon_sym_LT_LPAREN] = ACTIONS(2632),
    [anon_sym_GT_LPAREN] = ACTIONS(2632),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2634),
    [anon_sym_LF] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2634),
  },
  [957] = {
    [aux_sym_concatenation_repeat1] = STATE(366),
    [sym_file_descriptor] = ACTIONS(2632),
    [sym__concat] = ACTIONS(633),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2634),
    [anon_sym_SEMI_SEMI] = ACTIONS(2632),
    [anon_sym_PIPE_AMP] = ACTIONS(2632),
    [anon_sym_AMP_AMP] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2632),
    [anon_sym_EQ_TILDE] = ACTIONS(2634),
    [anon_sym_EQ_EQ] = ACTIONS(2634),
    [anon_sym_LT] = ACTIONS(2634),
    [anon_sym_GT] = ACTIONS(2634),
    [anon_sym_GT_GT] = ACTIONS(2632),
    [anon_sym_AMP_GT] = ACTIONS(2634),
    [anon_sym_AMP_GT_GT] = ACTIONS(2632),
    [anon_sym_LT_AMP] = ACTIONS(2632),
    [anon_sym_GT_AMP] = ACTIONS(2632),
    [anon_sym_LT_LT] = ACTIONS(2634),
    [anon_sym_LT_LT_DASH] = ACTIONS(2632),
    [anon_sym_LT_LT_LT] = ACTIONS(2632),
    [anon_sym_DOLLAR] = ACTIONS(2634),
    [sym__special_character] = ACTIONS(2632),
    [anon_sym_DQUOTE] = ACTIONS(2632),
    [sym_raw_string] = ACTIONS(2632),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2632),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2632),
    [anon_sym_BQUOTE] = ACTIONS(2632),
    [anon_sym_LT_LPAREN] = ACTIONS(2632),
    [anon_sym_GT_LPAREN] = ACTIONS(2632),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2634),
    [anon_sym_LF] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2634),
  },
  [958] = {
    [aux_sym__literal_repeat1] = STATE(395),
    [sym_file_descriptor] = ACTIONS(2636),
    [anon_sym_SEMI] = ACTIONS(2638),
    [anon_sym_PIPE] = ACTIONS(2638),
    [anon_sym_SEMI_SEMI] = ACTIONS(2636),
    [anon_sym_PIPE_AMP] = ACTIONS(2636),
    [anon_sym_AMP_AMP] = ACTIONS(2636),
    [anon_sym_PIPE_PIPE] = ACTIONS(2636),
    [anon_sym_EQ_TILDE] = ACTIONS(2638),
    [anon_sym_EQ_EQ] = ACTIONS(2638),
    [anon_sym_LT] = ACTIONS(2638),
    [anon_sym_GT] = ACTIONS(2638),
    [anon_sym_GT_GT] = ACTIONS(2636),
    [anon_sym_AMP_GT] = ACTIONS(2638),
    [anon_sym_AMP_GT_GT] = ACTIONS(2636),
    [anon_sym_LT_AMP] = ACTIONS(2636),
    [anon_sym_GT_AMP] = ACTIONS(2636),
    [anon_sym_LT_LT] = ACTIONS(2638),
    [anon_sym_LT_LT_DASH] = ACTIONS(2636),
    [anon_sym_LT_LT_LT] = ACTIONS(2636),
    [anon_sym_DOLLAR] = ACTIONS(2638),
    [sym__special_character] = ACTIONS(683),
    [anon_sym_DQUOTE] = ACTIONS(2636),
    [sym_raw_string] = ACTIONS(2636),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2636),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2636),
    [anon_sym_BQUOTE] = ACTIONS(2636),
    [anon_sym_LT_LPAREN] = ACTIONS(2636),
    [anon_sym_GT_LPAREN] = ACTIONS(2636),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2638),
    [anon_sym_LF] = ACTIONS(2636),
    [anon_sym_AMP] = ACTIONS(2638),
  },
  [959] = {
    [sym_concatenation] = STATE(959),
    [sym_string] = STATE(390),
    [sym_simple_expansion] = STATE(390),
    [sym_string_expansion] = STATE(390),
    [sym_expansion] = STATE(390),
    [sym_command_substitution] = STATE(390),
    [sym_process_substitution] = STATE(390),
    [aux_sym_command_repeat2] = STATE(959),
    [aux_sym__literal_repeat1] = STATE(392),
    [sym_file_descriptor] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2634),
    [anon_sym_SEMI_SEMI] = ACTIONS(2632),
    [anon_sym_PIPE_AMP] = ACTIONS(2632),
    [anon_sym_AMP_AMP] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2632),
    [anon_sym_EQ_TILDE] = ACTIONS(3345),
    [anon_sym_EQ_EQ] = ACTIONS(3345),
    [anon_sym_LT] = ACTIONS(2634),
    [anon_sym_GT] = ACTIONS(2634),
    [anon_sym_GT_GT] = ACTIONS(2632),
    [anon_sym_AMP_GT] = ACTIONS(2634),
    [anon_sym_AMP_GT_GT] = ACTIONS(2632),
    [anon_sym_LT_AMP] = ACTIONS(2632),
    [anon_sym_GT_AMP] = ACTIONS(2632),
    [anon_sym_LT_LT] = ACTIONS(2634),
    [anon_sym_LT_LT_DASH] = ACTIONS(2632),
    [anon_sym_LT_LT_LT] = ACTIONS(2632),
    [anon_sym_DOLLAR] = ACTIONS(3348),
    [sym__special_character] = ACTIONS(3351),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [sym_raw_string] = ACTIONS(3357),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3363),
    [anon_sym_BQUOTE] = ACTIONS(3366),
    [anon_sym_LT_LPAREN] = ACTIONS(3369),
    [anon_sym_GT_LPAREN] = ACTIONS(3369),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3372),
    [anon_sym_LF] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2634),
  },
  [960] = {
    [sym_concatenation] = STATE(959),
    [sym_string] = STATE(390),
    [sym_simple_expansion] = STATE(390),
    [sym_string_expansion] = STATE(390),
    [sym_expansion] = STATE(390),
    [sym_command_substitution] = STATE(390),
    [sym_process_substitution] = STATE(390),
    [aux_sym_command_repeat2] = STATE(959),
    [aux_sym__literal_repeat1] = STATE(392),
    [sym_file_descriptor] = ACTIONS(2696),
    [anon_sym_SEMI] = ACTIONS(2698),
    [anon_sym_PIPE] = ACTIONS(2698),
    [anon_sym_SEMI_SEMI] = ACTIONS(2696),
    [anon_sym_PIPE_AMP] = ACTIONS(2696),
    [anon_sym_AMP_AMP] = ACTIONS(2696),
    [anon_sym_PIPE_PIPE] = ACTIONS(2696),
    [anon_sym_EQ_TILDE] = ACTIONS(675),
    [anon_sym_EQ_EQ] = ACTIONS(675),
    [anon_sym_LT] = ACTIONS(2698),
    [anon_sym_GT] = ACTIONS(2698),
    [anon_sym_GT_GT] = ACTIONS(2696),
    [anon_sym_AMP_GT] = ACTIONS(2698),
    [anon_sym_AMP_GT_GT] = ACTIONS(2696),
    [anon_sym_LT_AMP] = ACTIONS(2696),
    [anon_sym_GT_AMP] = ACTIONS(2696),
    [anon_sym_LT_LT] = ACTIONS(2698),
    [anon_sym_LT_LT_DASH] = ACTIONS(2696),
    [anon_sym_LT_LT_LT] = ACTIONS(2696),
    [anon_sym_DOLLAR] = ACTIONS(125),
    [sym__special_character] = ACTIONS(677),
    [anon_sym_DQUOTE] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(679),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(681),
    [anon_sym_LF] = ACTIONS(2696),
    [anon_sym_AMP] = ACTIONS(2698),
  },
  [961] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(3375),
    [anon_sym_PLUS_EQ] = ACTIONS(3375),
    [sym_comment] = ACTIONS(57),
  },
  [962] = {
    [sym__simple_heredoc_body] = ACTIONS(3377),
    [sym__heredoc_body_beginning] = ACTIONS(3377),
    [sym_file_descriptor] = ACTIONS(3377),
    [ts_builtin_sym_end] = ACTIONS(3377),
    [anon_sym_SEMI] = ACTIONS(3379),
    [anon_sym_done] = ACTIONS(3377),
    [anon_sym_fi] = ACTIONS(3377),
    [anon_sym_elif] = ACTIONS(3377),
    [anon_sym_else] = ACTIONS(3377),
    [anon_sym_esac] = ACTIONS(3377),
    [anon_sym_PIPE] = ACTIONS(3379),
    [anon_sym_RPAREN] = ACTIONS(3377),
    [anon_sym_SEMI_SEMI] = ACTIONS(3377),
    [anon_sym_PIPE_AMP] = ACTIONS(3377),
    [anon_sym_AMP_AMP] = ACTIONS(3377),
    [anon_sym_PIPE_PIPE] = ACTIONS(3377),
    [anon_sym_LT] = ACTIONS(3379),
    [anon_sym_GT] = ACTIONS(3379),
    [anon_sym_GT_GT] = ACTIONS(3377),
    [anon_sym_AMP_GT] = ACTIONS(3379),
    [anon_sym_AMP_GT_GT] = ACTIONS(3377),
    [anon_sym_LT_AMP] = ACTIONS(3377),
    [anon_sym_GT_AMP] = ACTIONS(3377),
    [anon_sym_LT_LT] = ACTIONS(3379),
    [anon_sym_LT_LT_DASH] = ACTIONS(3377),
    [anon_sym_LT_LT_LT] = ACTIONS(3377),
    [anon_sym_BQUOTE] = ACTIONS(3377),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3377),
    [anon_sym_AMP] = ACTIONS(3379),
  },
  [963] = {
    [sym__terminated_statement] = STATE(1622),
    [sym_redirected_statement] = STATE(78),
    [sym_for_statement] = STATE(78),
    [sym_c_style_for_statement] = STATE(78),
    [sym_while_statement] = STATE(78),
    [sym_if_statement] = STATE(78),
    [sym_case_statement] = STATE(78),
    [sym_function_definition] = STATE(78),
    [sym_compound_statement] = STATE(78),
    [sym_subshell] = STATE(78),
    [sym_pipeline] = STATE(78),
    [sym_list] = STATE(78),
    [sym_negated_command] = STATE(78),
    [sym_test_command] = STATE(78),
    [sym_declaration_command] = STATE(78),
    [sym_unset_command] = STATE(78),
    [sym_command] = STATE(78),
    [sym_command_name] = STATE(79),
    [sym_variable_assignment] = STATE(80),
    [sym_subscript] = STATE(81),
    [sym_file_redirect] = STATE(83),
    [sym_concatenation] = STATE(82),
    [sym_string] = STATE(71),
    [sym_simple_expansion] = STATE(71),
    [sym_string_expansion] = STATE(71),
    [sym_expansion] = STATE(71),
    [sym_command_substitution] = STATE(71),
    [sym_process_substitution] = STATE(71),
    [aux_sym_command_repeat1] = STATE(83),
    [aux_sym__literal_repeat1] = STATE(84),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_case] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(125),
    [sym__special_character] = ACTIONS(127),
    [anon_sym_DQUOTE] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(131),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [964] = {
    [sym__statements] = STATE(1636),
    [sym_redirected_statement] = STATE(1637),
    [sym_for_statement] = STATE(1637),
    [sym_c_style_for_statement] = STATE(1637),
    [sym_while_statement] = STATE(1637),
    [sym_if_statement] = STATE(1637),
    [sym_case_statement] = STATE(1637),
    [sym_function_definition] = STATE(1637),
    [sym_compound_statement] = STATE(1637),
    [sym_subshell] = STATE(1637),
    [sym_pipeline] = STATE(1637),
    [sym_list] = STATE(1637),
    [sym_negated_command] = STATE(1637),
    [sym_test_command] = STATE(1637),
    [sym_declaration_command] = STATE(1637),
    [sym_unset_command] = STATE(1637),
    [sym_command] = STATE(1637),
    [sym_command_name] = STATE(1638),
    [sym_variable_assignment] = STATE(1639),
    [sym_subscript] = STATE(1640),
    [sym_file_redirect] = STATE(1643),
    [sym_concatenation] = STATE(1641),
    [sym_string] = STATE(1630),
    [sym_simple_expansion] = STATE(1630),
    [sym_string_expansion] = STATE(1630),
    [sym_expansion] = STATE(1630),
    [sym_command_substitution] = STATE(1630),
    [sym_process_substitution] = STATE(1630),
    [aux_sym__statements_repeat1] = STATE(1642),
    [aux_sym_command_repeat1] = STATE(1643),
    [aux_sym__literal_repeat1] = STATE(1644),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(3381),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_fi] = ACTIONS(3383),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(3385),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(3387),
    [anon_sym_typeset] = ACTIONS(3387),
    [anon_sym_export] = ACTIONS(3387),
    [anon_sym_readonly] = ACTIONS(3387),
    [anon_sym_local] = ACTIONS(3387),
    [anon_sym_unset] = ACTIONS(3389),
    [anon_sym_unsetenv] = ACTIONS(3389),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(3391),
    [sym__special_character] = ACTIONS(3393),
    [anon_sym_DQUOTE] = ACTIONS(3395),
    [sym_raw_string] = ACTIONS(3397),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3401),
    [anon_sym_BQUOTE] = ACTIONS(3403),
    [anon_sym_LT_LPAREN] = ACTIONS(3405),
    [anon_sym_GT_LPAREN] = ACTIONS(3405),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3407),
  },
  [965] = {
    [sym_subshell] = STATE(146),
    [sym_test_command] = STATE(146),
    [sym_command] = STATE(146),
    [sym_command_name] = STATE(980),
    [sym_variable_assignment] = STATE(986),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(986),
    [sym_concatenation] = STATE(983),
    [sym_string] = STATE(971),
    [sym_simple_expansion] = STATE(971),
    [sym_string_expansion] = STATE(971),
    [sym_expansion] = STATE(971),
    [sym_command_substitution] = STATE(971),
    [sym_process_substitution] = STATE(971),
    [aux_sym_command_repeat1] = STATE(986),
    [aux_sym__literal_repeat1] = STATE(987),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(1818),
    [sym__special_character] = ACTIONS(1820),
    [anon_sym_DQUOTE] = ACTIONS(1822),
    [sym_raw_string] = ACTIONS(1824),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1826),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1828),
    [anon_sym_BQUOTE] = ACTIONS(1830),
    [anon_sym_LT_LPAREN] = ACTIONS(1832),
    [anon_sym_GT_LPAREN] = ACTIONS(1832),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1824),
  },
  [966] = {
    [sym_variable_assignment] = STATE(1655),
    [sym_subscript] = STATE(1654),
    [sym_concatenation] = STATE(1655),
    [sym_string] = STATE(1649),
    [sym_simple_expansion] = STATE(1649),
    [sym_string_expansion] = STATE(1649),
    [sym_expansion] = STATE(1649),
    [sym_command_substitution] = STATE(1649),
    [sym_process_substitution] = STATE(1649),
    [aux_sym_declaration_command_repeat1] = STATE(1655),
    [aux_sym__literal_repeat1] = STATE(1656),
    [sym__simple_heredoc_body] = ACTIONS(259),
    [sym__heredoc_body_beginning] = ACTIONS(259),
    [sym_file_descriptor] = ACTIONS(259),
    [sym_variable_name] = ACTIONS(3409),
    [anon_sym_SEMI] = ACTIONS(263),
    [anon_sym_fi] = ACTIONS(263),
    [anon_sym_elif] = ACTIONS(263),
    [anon_sym_else] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_SEMI_SEMI] = ACTIONS(259),
    [anon_sym_PIPE_AMP] = ACTIONS(259),
    [anon_sym_AMP_AMP] = ACTIONS(259),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_LT] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_GT_GT] = ACTIONS(259),
    [anon_sym_AMP_GT] = ACTIONS(263),
    [anon_sym_AMP_GT_GT] = ACTIONS(259),
    [anon_sym_LT_AMP] = ACTIONS(259),
    [anon_sym_GT_AMP] = ACTIONS(259),
    [anon_sym_LT_LT] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(259),
    [anon_sym_LT_LT_LT] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(3411),
    [sym__special_character] = ACTIONS(3413),
    [anon_sym_DQUOTE] = ACTIONS(3415),
    [sym_raw_string] = ACTIONS(3417),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3419),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3421),
    [anon_sym_BQUOTE] = ACTIONS(3423),
    [anon_sym_LT_LPAREN] = ACTIONS(3425),
    [anon_sym_GT_LPAREN] = ACTIONS(3425),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3427),
    [sym_word] = ACTIONS(3429),
    [anon_sym_LF] = ACTIONS(259),
    [anon_sym_AMP] = ACTIONS(263),
  },
  [967] = {
    [sym_concatenation] = STATE(1665),
    [sym_string] = STATE(1660),
    [sym_simple_expansion] = STATE(1660),
    [sym_string_expansion] = STATE(1660),
    [sym_expansion] = STATE(1660),
    [sym_command_substitution] = STATE(1660),
    [sym_process_substitution] = STATE(1660),
    [aux_sym_unset_command_repeat1] = STATE(1665),
    [aux_sym__literal_repeat1] = STATE(1666),
    [sym__simple_heredoc_body] = ACTIONS(285),
    [sym__heredoc_body_beginning] = ACTIONS(285),
    [sym_file_descriptor] = ACTIONS(285),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym_fi] = ACTIONS(287),
    [anon_sym_elif] = ACTIONS(287),
    [anon_sym_else] = ACTIONS(287),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(285),
    [anon_sym_PIPE_AMP] = ACTIONS(285),
    [anon_sym_AMP_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(287),
    [anon_sym_GT] = ACTIONS(287),
    [anon_sym_GT_GT] = ACTIONS(285),
    [anon_sym_AMP_GT] = ACTIONS(287),
    [anon_sym_AMP_GT_GT] = ACTIONS(285),
    [anon_sym_LT_AMP] = ACTIONS(285),
    [anon_sym_GT_AMP] = ACTIONS(285),
    [anon_sym_LT_LT] = ACTIONS(287),
    [anon_sym_LT_LT_DASH] = ACTIONS(285),
    [anon_sym_LT_LT_LT] = ACTIONS(285),
    [anon_sym_DOLLAR] = ACTIONS(3431),
    [sym__special_character] = ACTIONS(3433),
    [anon_sym_DQUOTE] = ACTIONS(3435),
    [sym_raw_string] = ACTIONS(3437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3439),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3441),
    [anon_sym_BQUOTE] = ACTIONS(3443),
    [anon_sym_LT_LPAREN] = ACTIONS(3445),
    [anon_sym_GT_LPAREN] = ACTIONS(3445),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3447),
    [sym_word] = ACTIONS(3449),
    [anon_sym_LF] = ACTIONS(285),
    [anon_sym_AMP] = ACTIONS(287),
  },
  [968] = {
    [sym_string] = STATE(1668),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(1822),
    [sym_raw_string] = ACTIONS(3453),
    [anon_sym_POUND] = ACTIONS(3451),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3455),
    [anon_sym_STAR] = ACTIONS(3457),
    [anon_sym_AT] = ACTIONS(3457),
    [anon_sym_QMARK] = ACTIONS(3457),
    [anon_sym_0] = ACTIONS(3455),
    [anon_sym__] = ACTIONS(3455),
  },
  [969] = {
    [aux_sym_concatenation_repeat1] = STATE(1671),
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(3459),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_fi] = ACTIONS(339),
    [anon_sym_elif] = ACTIONS(339),
    [anon_sym_else] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_EQ_TILDE] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [970] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(1674),
    [anon_sym_DOLLAR] = ACTIONS(3461),
    [anon_sym_DQUOTE] = ACTIONS(3463),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [971] = {
    [aux_sym_concatenation_repeat1] = STATE(1671),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(3459),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_fi] = ACTIONS(355),
    [anon_sym_elif] = ACTIONS(355),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [972] = {
    [sym_subscript] = STATE(1678),
    [sym_variable_name] = ACTIONS(3465),
    [anon_sym_BANG] = ACTIONS(3467),
    [anon_sym_DASH] = ACTIONS(3469),
    [anon_sym_DOLLAR] = ACTIONS(3469),
    [anon_sym_POUND] = ACTIONS(3467),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3471),
    [anon_sym_STAR] = ACTIONS(3473),
    [anon_sym_AT] = ACTIONS(3473),
    [anon_sym_QMARK] = ACTIONS(3473),
    [anon_sym_0] = ACTIONS(3471),
    [anon_sym__] = ACTIONS(3471),
  },
  [973] = {
    [sym__statements] = STATE(1679),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(1680),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [974] = {
    [sym__statements] = STATE(1681),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [975] = {
    [sym__statements] = STATE(1682),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [976] = {
    [aux_sym_concatenation_repeat1] = STATE(1671),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(3459),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_fi] = ACTIONS(355),
    [anon_sym_elif] = ACTIONS(355),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_LPAREN] = ACTIONS(387),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [977] = {
    [sym_elif_clause] = STATE(1685),
    [sym_else_clause] = STATE(1684),
    [aux_sym_if_statement_repeat1] = STATE(1685),
    [anon_sym_fi] = ACTIONS(3475),
    [anon_sym_elif] = ACTIONS(3477),
    [anon_sym_else] = ACTIONS(3479),
    [sym_comment] = ACTIONS(57),
  },
  [978] = {
    [sym_file_redirect] = STATE(1693),
    [sym_heredoc_redirect] = STATE(1693),
    [sym_heredoc_body] = STATE(1692),
    [sym_herestring_redirect] = STATE(1693),
    [aux_sym_redirected_statement_repeat1] = STATE(1693),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(3481),
    [anon_sym_SEMI] = ACTIONS(3483),
    [anon_sym_fi] = ACTIONS(399),
    [anon_sym_elif] = ACTIONS(399),
    [anon_sym_else] = ACTIONS(399),
    [anon_sym_PIPE] = ACTIONS(3485),
    [anon_sym_SEMI_SEMI] = ACTIONS(3487),
    [anon_sym_PIPE_AMP] = ACTIONS(3489),
    [anon_sym_AMP_AMP] = ACTIONS(3491),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [anon_sym_GT] = ACTIONS(3493),
    [anon_sym_GT_GT] = ACTIONS(3495),
    [anon_sym_AMP_GT] = ACTIONS(3493),
    [anon_sym_AMP_GT_GT] = ACTIONS(3495),
    [anon_sym_LT_AMP] = ACTIONS(3495),
    [anon_sym_GT_AMP] = ACTIONS(3495),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(3497),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3487),
    [anon_sym_AMP] = ACTIONS(3483),
  },
  [979] = {
    [anon_sym_fi] = ACTIONS(3475),
    [sym_comment] = ACTIONS(57),
  },
  [980] = {
    [sym_concatenation] = STATE(1696),
    [sym_string] = STATE(1695),
    [sym_simple_expansion] = STATE(1695),
    [sym_string_expansion] = STATE(1695),
    [sym_expansion] = STATE(1695),
    [sym_command_substitution] = STATE(1695),
    [sym_process_substitution] = STATE(1695),
    [aux_sym_command_repeat2] = STATE(1696),
    [aux_sym__literal_repeat1] = STATE(1697),
    [sym__simple_heredoc_body] = ACTIONS(421),
    [sym__heredoc_body_beginning] = ACTIONS(421),
    [sym_file_descriptor] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_fi] = ACTIONS(423),
    [anon_sym_elif] = ACTIONS(423),
    [anon_sym_else] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI_SEMI] = ACTIONS(421),
    [anon_sym_PIPE_AMP] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(3499),
    [anon_sym_EQ_EQ] = ACTIONS(3499),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_AMP_GT] = ACTIONS(423),
    [anon_sym_AMP_GT_GT] = ACTIONS(421),
    [anon_sym_LT_AMP] = ACTIONS(421),
    [anon_sym_GT_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_LT_LT_DASH] = ACTIONS(421),
    [anon_sym_LT_LT_LT] = ACTIONS(421),
    [anon_sym_DOLLAR] = ACTIONS(1818),
    [sym__special_character] = ACTIONS(3501),
    [anon_sym_DQUOTE] = ACTIONS(1822),
    [sym_raw_string] = ACTIONS(3503),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1826),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1828),
    [anon_sym_BQUOTE] = ACTIONS(1830),
    [anon_sym_LT_LPAREN] = ACTIONS(1832),
    [anon_sym_GT_LPAREN] = ACTIONS(1832),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3505),
    [anon_sym_LF] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
  },
  [981] = {
    [sym_file_redirect] = STATE(1693),
    [sym_heredoc_redirect] = STATE(1693),
    [sym_heredoc_body] = STATE(1692),
    [sym_herestring_redirect] = STATE(1693),
    [aux_sym_redirected_statement_repeat1] = STATE(1693),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(3483),
    [anon_sym_fi] = ACTIONS(3321),
    [anon_sym_elif] = ACTIONS(3321),
    [anon_sym_else] = ACTIONS(3321),
    [anon_sym_PIPE] = ACTIONS(3485),
    [anon_sym_SEMI_SEMI] = ACTIONS(3487),
    [anon_sym_PIPE_AMP] = ACTIONS(3489),
    [anon_sym_AMP_AMP] = ACTIONS(3491),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(3497),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(3487),
    [anon_sym_AMP] = ACTIONS(3483),
  },
  [982] = {
    [anon_sym_EQ] = ACTIONS(3375),
    [anon_sym_PLUS_EQ] = ACTIONS(3375),
    [sym_comment] = ACTIONS(57),
  },
  [983] = {
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_fi] = ACTIONS(355),
    [anon_sym_elif] = ACTIONS(355),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [984] = {
    [sym_redirected_statement] = STATE(1698),
    [sym_for_statement] = STATE(1698),
    [sym_c_style_for_statement] = STATE(1698),
    [sym_while_statement] = STATE(1698),
    [sym_if_statement] = STATE(1698),
    [sym_case_statement] = STATE(1698),
    [sym_function_definition] = STATE(1698),
    [sym_compound_statement] = STATE(1698),
    [sym_subshell] = STATE(1698),
    [sym_pipeline] = STATE(1698),
    [sym_list] = STATE(1698),
    [sym_negated_command] = STATE(1698),
    [sym_test_command] = STATE(1698),
    [sym_declaration_command] = STATE(1698),
    [sym_unset_command] = STATE(1698),
    [sym_command] = STATE(1698),
    [sym_command_name] = STATE(980),
    [sym_variable_assignment] = STATE(1699),
    [sym_subscript] = STATE(982),
    [sym_file_redirect] = STATE(986),
    [sym_concatenation] = STATE(983),
    [sym_string] = STATE(971),
    [sym_simple_expansion] = STATE(971),
    [sym_string_expansion] = STATE(971),
    [sym_expansion] = STATE(971),
    [sym_command_substitution] = STATE(971),
    [sym_process_substitution] = STATE(971),
    [aux_sym__statements_repeat1] = STATE(251),
    [aux_sym_command_repeat1] = STATE(986),
    [aux_sym__literal_repeat1] = STATE(987),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(1804),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1812),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(1814),
    [anon_sym_typeset] = ACTIONS(1814),
    [anon_sym_export] = ACTIONS(1814),
    [anon_sym_readonly] = ACTIONS(1814),
    [anon_sym_local] = ACTIONS(1814),
    [anon_sym_unset] = ACTIONS(1816),
    [anon_sym_unsetenv] = ACTIONS(1816),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(1818),
    [sym__special_character] = ACTIONS(1820),
    [anon_sym_DQUOTE] = ACTIONS(1822),
    [sym_raw_string] = ACTIONS(1824),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1826),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1828),
    [anon_sym_BQUOTE] = ACTIONS(1830),
    [anon_sym_LT_LPAREN] = ACTIONS(1832),
    [anon_sym_GT_LPAREN] = ACTIONS(1832),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1834),
  },
  [985] = {
    [sym_elif_clause] = STATE(1700),
    [sym_else_clause] = STATE(1684),
    [aux_sym_if_statement_repeat1] = STATE(1700),
    [anon_sym_fi] = ACTIONS(3475),
    [anon_sym_elif] = ACTIONS(3477),
    [anon_sym_else] = ACTIONS(3479),
    [sym_comment] = ACTIONS(57),
  },
  [986] = {
    [sym_command_name] = STATE(1701),
    [sym_variable_assignment] = STATE(253),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(253),
    [sym_concatenation] = STATE(983),
    [sym_string] = STATE(971),
    [sym_simple_expansion] = STATE(971),
    [sym_string_expansion] = STATE(971),
    [sym_expansion] = STATE(971),
    [sym_command_substitution] = STATE(971),
    [sym_process_substitution] = STATE(971),
    [aux_sym_command_repeat1] = STATE(253),
    [aux_sym__literal_repeat1] = STATE(987),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(1818),
    [sym__special_character] = ACTIONS(3501),
    [anon_sym_DQUOTE] = ACTIONS(1822),
    [sym_raw_string] = ACTIONS(1824),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1826),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1828),
    [anon_sym_BQUOTE] = ACTIONS(1830),
    [anon_sym_LT_LPAREN] = ACTIONS(1832),
    [anon_sym_GT_LPAREN] = ACTIONS(1832),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1824),
  },
  [987] = {
    [aux_sym__literal_repeat1] = STATE(1703),
    [sym__simple_heredoc_body] = ACTIONS(437),
    [sym__heredoc_body_beginning] = ACTIONS(437),
    [sym_file_descriptor] = ACTIONS(437),
    [anon_sym_SEMI] = ACTIONS(439),
    [anon_sym_fi] = ACTIONS(439),
    [anon_sym_elif] = ACTIONS(439),
    [anon_sym_else] = ACTIONS(439),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI_SEMI] = ACTIONS(437),
    [anon_sym_PIPE_AMP] = ACTIONS(437),
    [anon_sym_AMP_AMP] = ACTIONS(437),
    [anon_sym_PIPE_PIPE] = ACTIONS(437),
    [anon_sym_EQ_TILDE] = ACTIONS(439),
    [anon_sym_EQ_EQ] = ACTIONS(439),
    [anon_sym_LT] = ACTIONS(439),
    [anon_sym_GT] = ACTIONS(439),
    [anon_sym_GT_GT] = ACTIONS(437),
    [anon_sym_AMP_GT] = ACTIONS(439),
    [anon_sym_AMP_GT_GT] = ACTIONS(437),
    [anon_sym_LT_AMP] = ACTIONS(437),
    [anon_sym_GT_AMP] = ACTIONS(437),
    [anon_sym_LT_LT] = ACTIONS(439),
    [anon_sym_LT_LT_DASH] = ACTIONS(437),
    [anon_sym_LT_LT_LT] = ACTIONS(437),
    [anon_sym_DOLLAR] = ACTIONS(439),
    [sym__special_character] = ACTIONS(3507),
    [anon_sym_DQUOTE] = ACTIONS(437),
    [sym_raw_string] = ACTIONS(437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(437),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(437),
    [anon_sym_BQUOTE] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(437),
    [anon_sym_GT_LPAREN] = ACTIONS(437),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(439),
    [anon_sym_LF] = ACTIONS(437),
    [anon_sym_AMP] = ACTIONS(439),
  },
  [988] = {
    [sym__concat] = ACTIONS(2362),
    [anon_sym_in] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2362),
  },
  [989] = {
    [sym_string] = STATE(988),
    [sym_simple_expansion] = STATE(988),
    [sym_string_expansion] = STATE(988),
    [sym_expansion] = STATE(988),
    [sym_command_substitution] = STATE(988),
    [sym_process_substitution] = STATE(988),
    [anon_sym_DOLLAR] = ACTIONS(3509),
    [sym__special_character] = ACTIONS(1836),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [sym_raw_string] = ACTIONS(1836),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [anon_sym_LT_LPAREN] = ACTIONS(157),
    [anon_sym_GT_LPAREN] = ACTIONS(157),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1836),
  },
  [990] = {
    [aux_sym_concatenation_repeat1] = STATE(990),
    [sym__concat] = ACTIONS(3511),
    [anon_sym_in] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2362),
  },
  [991] = {
    [sym__concat] = ACTIONS(2371),
    [anon_sym_in] = ACTIONS(2371),
    [anon_sym_SEMI] = ACTIONS(2373),
    [anon_sym_SEMI_SEMI] = ACTIONS(2371),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2371),
  },
  [992] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(3514),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [993] = {
    [sym_case_item] = STATE(1711),
    [sym_last_case_item] = STATE(1709),
    [sym_concatenation] = STATE(1710),
    [sym_string] = STATE(1708),
    [sym_simple_expansion] = STATE(1708),
    [sym_string_expansion] = STATE(1708),
    [sym_expansion] = STATE(1708),
    [sym_command_substitution] = STATE(1708),
    [sym_process_substitution] = STATE(1708),
    [aux_sym_case_statement_repeat1] = STATE(1711),
    [aux_sym__literal_repeat1] = STATE(1712),
    [anon_sym_esac] = ACTIONS(3516),
    [anon_sym_DOLLAR] = ACTIONS(507),
    [sym__special_character] = ACTIONS(3518),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3522),
  },
  [994] = {
    [anon_sym_SEMI] = ACTIONS(3524),
    [anon_sym_SEMI_SEMI] = ACTIONS(3526),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3526),
    [anon_sym_AMP] = ACTIONS(3526),
  },
  [995] = {
    [sym_concatenation] = STATE(1716),
    [sym_string] = STATE(1715),
    [sym_simple_expansion] = STATE(1715),
    [sym_string_expansion] = STATE(1715),
    [sym_expansion] = STATE(1715),
    [sym_command_substitution] = STATE(1715),
    [sym_process_substitution] = STATE(1715),
    [aux_sym__literal_repeat1] = STATE(1717),
    [anon_sym_RBRACE] = ACTIONS(3528),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(3530),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3530),
  },
  [996] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(3532),
    [sym_comment] = ACTIONS(57),
  },
  [997] = {
    [sym_concatenation] = STATE(1721),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1721),
    [anon_sym_RBRACE] = ACTIONS(3534),
    [anon_sym_EQ] = ACTIONS(3536),
    [anon_sym_DASH] = ACTIONS(3536),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(3538),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(3540),
    [anon_sym_COLON] = ACTIONS(3536),
    [anon_sym_COLON_QMARK] = ACTIONS(3536),
    [anon_sym_COLON_DASH] = ACTIONS(3536),
    [anon_sym_PERCENT] = ACTIONS(3536),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [998] = {
    [sym_concatenation] = STATE(1723),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1723),
    [anon_sym_RBRACE] = ACTIONS(3528),
    [anon_sym_EQ] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3542),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(3544),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(3546),
    [anon_sym_COLON] = ACTIONS(3542),
    [anon_sym_COLON_QMARK] = ACTIONS(3542),
    [anon_sym_COLON_DASH] = ACTIONS(3542),
    [anon_sym_PERCENT] = ACTIONS(3542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [999] = {
    [sym__concat] = ACTIONS(2462),
    [anon_sym_in] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_SEMI_SEMI] = ACTIONS(2462),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2462),
    [anon_sym_AMP] = ACTIONS(2462),
  },
  [1000] = {
    [sym_concatenation] = STATE(1726),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1726),
    [sym_regex] = ACTIONS(3548),
    [anon_sym_RBRACE] = ACTIONS(3550),
    [anon_sym_EQ] = ACTIONS(3552),
    [anon_sym_DASH] = ACTIONS(3552),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(3554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(3552),
    [anon_sym_COLON_QMARK] = ACTIONS(3552),
    [anon_sym_COLON_DASH] = ACTIONS(3552),
    [anon_sym_PERCENT] = ACTIONS(3552),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1001] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(3550),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1002] = {
    [sym__concat] = ACTIONS(2512),
    [anon_sym_in] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2514),
    [anon_sym_SEMI_SEMI] = ACTIONS(2512),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2512),
  },
  [1003] = {
    [sym_concatenation] = STATE(1723),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1723),
    [sym_regex] = ACTIONS(3556),
    [anon_sym_RBRACE] = ACTIONS(3528),
    [anon_sym_EQ] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3542),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(3544),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(3542),
    [anon_sym_COLON_QMARK] = ACTIONS(3542),
    [anon_sym_COLON_DASH] = ACTIONS(3542),
    [anon_sym_PERCENT] = ACTIONS(3542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1004] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(3528),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1005] = {
    [sym__concat] = ACTIONS(2520),
    [anon_sym_in] = ACTIONS(2520),
    [anon_sym_SEMI] = ACTIONS(2522),
    [anon_sym_SEMI_SEMI] = ACTIONS(2520),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2520),
  },
  [1006] = {
    [sym__concat] = ACTIONS(2554),
    [anon_sym_in] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(2556),
    [anon_sym_SEMI_SEMI] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2554),
    [anon_sym_AMP] = ACTIONS(2554),
  },
  [1007] = {
    [sym_case_item] = STATE(1730),
    [sym_last_case_item] = STATE(1729),
    [sym_concatenation] = STATE(1710),
    [sym_string] = STATE(1708),
    [sym_simple_expansion] = STATE(1708),
    [sym_string_expansion] = STATE(1708),
    [sym_expansion] = STATE(1708),
    [sym_command_substitution] = STATE(1708),
    [sym_process_substitution] = STATE(1708),
    [aux_sym_case_statement_repeat1] = STATE(1730),
    [aux_sym__literal_repeat1] = STATE(1712),
    [anon_sym_esac] = ACTIONS(3558),
    [anon_sym_DOLLAR] = ACTIONS(507),
    [sym__special_character] = ACTIONS(3518),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3522),
  },
  [1008] = {
    [anon_sym_SEMI] = ACTIONS(3560),
    [anon_sym_SEMI_SEMI] = ACTIONS(3562),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3562),
    [anon_sym_AMP] = ACTIONS(3562),
  },
  [1009] = {
    [sym_compound_statement] = STATE(1732),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(57),
  },
  [1010] = {
    [aux_sym_concatenation_repeat1] = STATE(1733),
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(1430),
    [sym_variable_name] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_RPAREN] = ACTIONS(335),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [1011] = {
    [aux_sym_concatenation_repeat1] = STATE(1733),
    [sym__simple_heredoc_body] = ACTIONS(1400),
    [sym__heredoc_body_beginning] = ACTIONS(1400),
    [sym_file_descriptor] = ACTIONS(1400),
    [sym__concat] = ACTIONS(1430),
    [sym_variable_name] = ACTIONS(1400),
    [anon_sym_SEMI] = ACTIONS(1402),
    [anon_sym_PIPE] = ACTIONS(1402),
    [anon_sym_RPAREN] = ACTIONS(1400),
    [anon_sym_SEMI_SEMI] = ACTIONS(1400),
    [anon_sym_PIPE_AMP] = ACTIONS(1400),
    [anon_sym_AMP_AMP] = ACTIONS(1400),
    [anon_sym_PIPE_PIPE] = ACTIONS(1400),
    [anon_sym_LT] = ACTIONS(1402),
    [anon_sym_GT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT] = ACTIONS(1402),
    [anon_sym_AMP_GT_GT] = ACTIONS(1400),
    [anon_sym_LT_AMP] = ACTIONS(1400),
    [anon_sym_GT_AMP] = ACTIONS(1400),
    [anon_sym_LT_LT] = ACTIONS(1402),
    [anon_sym_LT_LT_DASH] = ACTIONS(1400),
    [anon_sym_LT_LT_LT] = ACTIONS(1400),
    [anon_sym_DOLLAR] = ACTIONS(1402),
    [sym__special_character] = ACTIONS(1400),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1400),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1400),
    [anon_sym_BQUOTE] = ACTIONS(1400),
    [anon_sym_LT_LPAREN] = ACTIONS(1400),
    [anon_sym_GT_LPAREN] = ACTIONS(1400),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1402),
    [anon_sym_LF] = ACTIONS(1400),
    [anon_sym_AMP] = ACTIONS(1402),
  },
  [1012] = {
    [aux_sym__literal_repeat1] = STATE(1734),
    [sym__simple_heredoc_body] = ACTIONS(1446),
    [sym__heredoc_body_beginning] = ACTIONS(1446),
    [sym_file_descriptor] = ACTIONS(1446),
    [sym_variable_name] = ACTIONS(1446),
    [anon_sym_SEMI] = ACTIONS(1448),
    [anon_sym_PIPE] = ACTIONS(1448),
    [anon_sym_RPAREN] = ACTIONS(1446),
    [anon_sym_SEMI_SEMI] = ACTIONS(1446),
    [anon_sym_PIPE_AMP] = ACTIONS(1446),
    [anon_sym_AMP_AMP] = ACTIONS(1446),
    [anon_sym_PIPE_PIPE] = ACTIONS(1446),
    [anon_sym_LT] = ACTIONS(1448),
    [anon_sym_GT] = ACTIONS(1448),
    [anon_sym_GT_GT] = ACTIONS(1446),
    [anon_sym_AMP_GT] = ACTIONS(1448),
    [anon_sym_AMP_GT_GT] = ACTIONS(1446),
    [anon_sym_LT_AMP] = ACTIONS(1446),
    [anon_sym_GT_AMP] = ACTIONS(1446),
    [anon_sym_LT_LT] = ACTIONS(1448),
    [anon_sym_LT_LT_DASH] = ACTIONS(1446),
    [anon_sym_LT_LT_LT] = ACTIONS(1446),
    [anon_sym_DOLLAR] = ACTIONS(1448),
    [sym__special_character] = ACTIONS(1450),
    [anon_sym_DQUOTE] = ACTIONS(1446),
    [sym_raw_string] = ACTIONS(1446),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1446),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1446),
    [anon_sym_BQUOTE] = ACTIONS(1446),
    [anon_sym_LT_LPAREN] = ACTIONS(1446),
    [anon_sym_GT_LPAREN] = ACTIONS(1446),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1448),
    [anon_sym_LF] = ACTIONS(1446),
    [anon_sym_AMP] = ACTIONS(1448),
  },
  [1013] = {
    [sym_concatenation] = STATE(1169),
    [sym_string] = STATE(1735),
    [sym_array] = STATE(1169),
    [sym_simple_expansion] = STATE(1735),
    [sym_string_expansion] = STATE(1735),
    [sym_expansion] = STATE(1735),
    [sym_command_substitution] = STATE(1735),
    [sym_process_substitution] = STATE(1735),
    [aux_sym__literal_repeat1] = STATE(1736),
    [sym__empty_value] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(2164),
    [anon_sym_DOLLAR] = ACTIONS(265),
    [sym__special_character] = ACTIONS(731),
    [anon_sym_DQUOTE] = ACTIONS(269),
    [sym_raw_string] = ACTIONS(3564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(277),
    [anon_sym_LT_LPAREN] = ACTIONS(279),
    [anon_sym_GT_LPAREN] = ACTIONS(279),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3564),
  },
  [1014] = {
    [aux_sym_concatenation_repeat1] = STATE(1737),
    [sym__simple_heredoc_body] = ACTIONS(1071),
    [sym__heredoc_body_beginning] = ACTIONS(1071),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(2170),
    [sym_variable_name] = ACTIONS(1071),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_RPAREN] = ACTIONS(1071),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [sym__special_character] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [sym_word] = ACTIONS(1075),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1075),
  },
  [1015] = {
    [sym_variable_assignment] = STATE(1015),
    [sym_subscript] = STATE(425),
    [sym_concatenation] = STATE(1015),
    [sym_string] = STATE(424),
    [sym_simple_expansion] = STATE(424),
    [sym_string_expansion] = STATE(424),
    [sym_expansion] = STATE(424),
    [sym_command_substitution] = STATE(424),
    [sym_process_substitution] = STATE(424),
    [aux_sym_declaration_command_repeat1] = STATE(1015),
    [aux_sym__literal_repeat1] = STATE(427),
    [sym__simple_heredoc_body] = ACTIONS(2206),
    [sym__heredoc_body_beginning] = ACTIONS(2206),
    [sym_file_descriptor] = ACTIONS(2206),
    [sym_variable_name] = ACTIONS(3566),
    [anon_sym_SEMI] = ACTIONS(2211),
    [anon_sym_PIPE] = ACTIONS(2211),
    [anon_sym_RPAREN] = ACTIONS(2206),
    [anon_sym_SEMI_SEMI] = ACTIONS(2206),
    [anon_sym_PIPE_AMP] = ACTIONS(2206),
    [anon_sym_AMP_AMP] = ACTIONS(2206),
    [anon_sym_PIPE_PIPE] = ACTIONS(2206),
    [anon_sym_LT] = ACTIONS(2211),
    [anon_sym_GT] = ACTIONS(2211),
    [anon_sym_GT_GT] = ACTIONS(2206),
    [anon_sym_AMP_GT] = ACTIONS(2211),
    [anon_sym_AMP_GT_GT] = ACTIONS(2206),
    [anon_sym_LT_AMP] = ACTIONS(2206),
    [anon_sym_GT_AMP] = ACTIONS(2206),
    [anon_sym_LT_LT] = ACTIONS(2211),
    [anon_sym_LT_LT_DASH] = ACTIONS(2206),
    [anon_sym_LT_LT_LT] = ACTIONS(2206),
    [anon_sym_DOLLAR] = ACTIONS(2213),
    [sym__special_character] = ACTIONS(3569),
    [anon_sym_DQUOTE] = ACTIONS(2219),
    [sym_raw_string] = ACTIONS(3572),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2225),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2228),
    [anon_sym_BQUOTE] = ACTIONS(2231),
    [anon_sym_LT_LPAREN] = ACTIONS(2234),
    [anon_sym_GT_LPAREN] = ACTIONS(2234),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3575),
    [sym_word] = ACTIONS(3578),
    [anon_sym_LF] = ACTIONS(2206),
    [anon_sym_AMP] = ACTIONS(2211),
  },
  [1016] = {
    [aux_sym__literal_repeat1] = STATE(1016),
    [sym__simple_heredoc_body] = ACTIONS(1373),
    [sym__heredoc_body_beginning] = ACTIONS(1373),
    [sym_file_descriptor] = ACTIONS(1373),
    [sym_variable_name] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_RPAREN] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE_AMP] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_LT_LT_DASH] = ACTIONS(1373),
    [anon_sym_LT_LT_LT] = ACTIONS(1373),
    [anon_sym_DOLLAR] = ACTIONS(1375),
    [sym__special_character] = ACTIONS(2243),
    [anon_sym_DQUOTE] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1373),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [anon_sym_LT_LPAREN] = ACTIONS(1373),
    [anon_sym_GT_LPAREN] = ACTIONS(1373),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1375),
    [sym_word] = ACTIONS(1375),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
  },
  [1017] = {
    [aux_sym_concatenation_repeat1] = STATE(1738),
    [sym__simple_heredoc_body] = ACTIONS(1071),
    [sym__heredoc_body_beginning] = ACTIONS(1071),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(2248),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_RPAREN] = ACTIONS(1071),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [sym__special_character] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [sym_word] = ACTIONS(1075),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1075),
  },
  [1018] = {
    [sym_concatenation] = STATE(1018),
    [sym_string] = STATE(429),
    [sym_simple_expansion] = STATE(429),
    [sym_string_expansion] = STATE(429),
    [sym_expansion] = STATE(429),
    [sym_command_substitution] = STATE(429),
    [sym_process_substitution] = STATE(429),
    [aux_sym_unset_command_repeat1] = STATE(1018),
    [aux_sym__literal_repeat1] = STATE(431),
    [sym__simple_heredoc_body] = ACTIONS(2284),
    [sym__heredoc_body_beginning] = ACTIONS(2284),
    [sym_file_descriptor] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym_PIPE] = ACTIONS(2286),
    [anon_sym_RPAREN] = ACTIONS(2284),
    [anon_sym_SEMI_SEMI] = ACTIONS(2284),
    [anon_sym_PIPE_AMP] = ACTIONS(2284),
    [anon_sym_AMP_AMP] = ACTIONS(2284),
    [anon_sym_PIPE_PIPE] = ACTIONS(2284),
    [anon_sym_LT] = ACTIONS(2286),
    [anon_sym_GT] = ACTIONS(2286),
    [anon_sym_GT_GT] = ACTIONS(2284),
    [anon_sym_AMP_GT] = ACTIONS(2286),
    [anon_sym_AMP_GT_GT] = ACTIONS(2284),
    [anon_sym_LT_AMP] = ACTIONS(2284),
    [anon_sym_GT_AMP] = ACTIONS(2284),
    [anon_sym_LT_LT] = ACTIONS(2286),
    [anon_sym_LT_LT_DASH] = ACTIONS(2284),
    [anon_sym_LT_LT_LT] = ACTIONS(2284),
    [anon_sym_DOLLAR] = ACTIONS(2288),
    [sym__special_character] = ACTIONS(3581),
    [anon_sym_DQUOTE] = ACTIONS(2294),
    [sym_raw_string] = ACTIONS(3584),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2300),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2303),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2309),
    [anon_sym_GT_LPAREN] = ACTIONS(2309),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3587),
    [sym_word] = ACTIONS(3590),
    [anon_sym_LF] = ACTIONS(2284),
    [anon_sym_AMP] = ACTIONS(2286),
  },
  [1019] = {
    [aux_sym__literal_repeat1] = STATE(1019),
    [sym__simple_heredoc_body] = ACTIONS(1373),
    [sym__heredoc_body_beginning] = ACTIONS(1373),
    [sym_file_descriptor] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_RPAREN] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE_AMP] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_LT_LT_DASH] = ACTIONS(1373),
    [anon_sym_LT_LT_LT] = ACTIONS(1373),
    [anon_sym_DOLLAR] = ACTIONS(1375),
    [sym__special_character] = ACTIONS(2318),
    [anon_sym_DQUOTE] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1373),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [anon_sym_LT_LPAREN] = ACTIONS(1373),
    [anon_sym_GT_LPAREN] = ACTIONS(1373),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1375),
    [sym_word] = ACTIONS(1375),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
  },
  [1020] = {
    [aux_sym_concatenation_repeat1] = STATE(1020),
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(2368),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_RPAREN] = ACTIONS(2362),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_EQ_TILDE] = ACTIONS(2364),
    [anon_sym_EQ_EQ] = ACTIONS(2364),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [1021] = {
    [sym_concatenation] = STATE(1328),
    [sym_string] = STATE(1739),
    [sym_simple_expansion] = STATE(1739),
    [sym_string_expansion] = STATE(1739),
    [sym_expansion] = STATE(1739),
    [sym_command_substitution] = STATE(1739),
    [sym_process_substitution] = STATE(1739),
    [aux_sym__literal_repeat1] = STATE(1740),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(1913),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(3593),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3593),
  },
  [1022] = {
    [sym_file_redirect] = STATE(439),
    [sym_heredoc_redirect] = STATE(439),
    [sym_herestring_redirect] = STATE(439),
    [aux_sym_redirected_statement_repeat1] = STATE(439),
    [sym__simple_heredoc_body] = ACTIONS(2584),
    [sym__heredoc_body_beginning] = ACTIONS(2584),
    [sym_file_descriptor] = ACTIONS(2584),
    [anon_sym_SEMI] = ACTIONS(2586),
    [anon_sym_PIPE] = ACTIONS(2586),
    [anon_sym_RPAREN] = ACTIONS(2584),
    [anon_sym_SEMI_SEMI] = ACTIONS(2584),
    [anon_sym_PIPE_AMP] = ACTIONS(2584),
    [anon_sym_AMP_AMP] = ACTIONS(2584),
    [anon_sym_PIPE_PIPE] = ACTIONS(2584),
    [anon_sym_LT] = ACTIONS(2586),
    [anon_sym_GT] = ACTIONS(2586),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT] = ACTIONS(2586),
    [anon_sym_AMP_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_AMP] = ACTIONS(2584),
    [anon_sym_GT_AMP] = ACTIONS(2584),
    [anon_sym_LT_LT] = ACTIONS(2586),
    [anon_sym_LT_LT_DASH] = ACTIONS(2584),
    [anon_sym_LT_LT_LT] = ACTIONS(2584),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2584),
    [anon_sym_AMP] = ACTIONS(2586),
  },
  [1023] = {
    [sym_file_redirect] = STATE(439),
    [sym_heredoc_redirect] = STATE(439),
    [sym_herestring_redirect] = STATE(439),
    [aux_sym_redirected_statement_repeat1] = STATE(439),
    [sym__simple_heredoc_body] = ACTIONS(2584),
    [sym__heredoc_body_beginning] = ACTIONS(2584),
    [sym_file_descriptor] = ACTIONS(2584),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2586),
    [anon_sym_PIPE] = ACTIONS(2586),
    [anon_sym_RPAREN] = ACTIONS(2584),
    [anon_sym_SEMI_SEMI] = ACTIONS(2584),
    [anon_sym_PIPE_AMP] = ACTIONS(2584),
    [anon_sym_AMP_AMP] = ACTIONS(2584),
    [anon_sym_PIPE_PIPE] = ACTIONS(2584),
    [anon_sym_LT] = ACTIONS(2586),
    [anon_sym_GT] = ACTIONS(2586),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT] = ACTIONS(2586),
    [anon_sym_AMP_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_AMP] = ACTIONS(2584),
    [anon_sym_GT_AMP] = ACTIONS(2584),
    [anon_sym_LT_LT] = ACTIONS(2586),
    [anon_sym_LT_LT_DASH] = ACTIONS(2584),
    [anon_sym_LT_LT_LT] = ACTIONS(2584),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2584),
    [anon_sym_AMP] = ACTIONS(2586),
  },
  [1024] = {
    [sym_file_redirect] = STATE(439),
    [sym_heredoc_redirect] = STATE(439),
    [sym_herestring_redirect] = STATE(439),
    [aux_sym_redirected_statement_repeat1] = STATE(439),
    [sym__simple_heredoc_body] = ACTIONS(2588),
    [sym__heredoc_body_beginning] = ACTIONS(2588),
    [sym_file_descriptor] = ACTIONS(2588),
    [anon_sym_SEMI] = ACTIONS(2590),
    [anon_sym_PIPE] = ACTIONS(751),
    [anon_sym_RPAREN] = ACTIONS(2588),
    [anon_sym_SEMI_SEMI] = ACTIONS(2588),
    [anon_sym_PIPE_AMP] = ACTIONS(753),
    [anon_sym_AMP_AMP] = ACTIONS(2588),
    [anon_sym_PIPE_PIPE] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(2590),
    [anon_sym_GT] = ACTIONS(2590),
    [anon_sym_GT_GT] = ACTIONS(2588),
    [anon_sym_AMP_GT] = ACTIONS(2590),
    [anon_sym_AMP_GT_GT] = ACTIONS(2588),
    [anon_sym_LT_AMP] = ACTIONS(2588),
    [anon_sym_GT_AMP] = ACTIONS(2588),
    [anon_sym_LT_LT] = ACTIONS(2590),
    [anon_sym_LT_LT_DASH] = ACTIONS(2588),
    [anon_sym_LT_LT_LT] = ACTIONS(2588),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2588),
    [anon_sym_AMP] = ACTIONS(2590),
  },
  [1025] = {
    [sym_file_redirect] = STATE(439),
    [sym_heredoc_redirect] = STATE(439),
    [sym_herestring_redirect] = STATE(439),
    [aux_sym_redirected_statement_repeat1] = STATE(439),
    [sym__simple_heredoc_body] = ACTIONS(2588),
    [sym__heredoc_body_beginning] = ACTIONS(2588),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2590),
    [anon_sym_PIPE] = ACTIONS(751),
    [anon_sym_RPAREN] = ACTIONS(2588),
    [anon_sym_SEMI_SEMI] = ACTIONS(2588),
    [anon_sym_PIPE_AMP] = ACTIONS(753),
    [anon_sym_AMP_AMP] = ACTIONS(2588),
    [anon_sym_PIPE_PIPE] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(2590),
    [anon_sym_LT_LT_DASH] = ACTIONS(2588),
    [anon_sym_LT_LT_LT] = ACTIONS(2588),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2588),
    [anon_sym_AMP] = ACTIONS(2590),
  },
  [1026] = {
    [aux_sym_concatenation_repeat1] = STATE(1741),
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_RPAREN] = ACTIONS(335),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [sym__special_character] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [1027] = {
    [aux_sym_concatenation_repeat1] = STATE(1741),
    [sym__simple_heredoc_body] = ACTIONS(1037),
    [sym__heredoc_body_beginning] = ACTIONS(1037),
    [sym_file_descriptor] = ACTIONS(1037),
    [sym__concat] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(1039),
    [anon_sym_PIPE] = ACTIONS(1039),
    [anon_sym_RPAREN] = ACTIONS(1037),
    [anon_sym_SEMI_SEMI] = ACTIONS(1037),
    [anon_sym_PIPE_AMP] = ACTIONS(1037),
    [anon_sym_AMP_AMP] = ACTIONS(1037),
    [anon_sym_PIPE_PIPE] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1039),
    [anon_sym_GT] = ACTIONS(1039),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_AMP_GT] = ACTIONS(1039),
    [anon_sym_AMP_GT_GT] = ACTIONS(1037),
    [anon_sym_LT_AMP] = ACTIONS(1037),
    [anon_sym_GT_AMP] = ACTIONS(1037),
    [anon_sym_LT_LT] = ACTIONS(1039),
    [anon_sym_LT_LT_DASH] = ACTIONS(1037),
    [anon_sym_LT_LT_LT] = ACTIONS(1037),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1037),
    [anon_sym_AMP] = ACTIONS(1039),
  },
  [1028] = {
    [aux_sym__literal_repeat1] = STATE(1742),
    [sym__simple_heredoc_body] = ACTIONS(1051),
    [sym__heredoc_body_beginning] = ACTIONS(1051),
    [sym_file_descriptor] = ACTIONS(1051),
    [anon_sym_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(1051),
    [anon_sym_SEMI_SEMI] = ACTIONS(1051),
    [anon_sym_PIPE_AMP] = ACTIONS(1051),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_PIPE_PIPE] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT_GT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1051),
    [anon_sym_GT_AMP] = ACTIONS(1051),
    [anon_sym_LT_LT] = ACTIONS(1053),
    [anon_sym_LT_LT_DASH] = ACTIONS(1051),
    [anon_sym_LT_LT_LT] = ACTIONS(1051),
    [sym__special_character] = ACTIONS(441),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1051),
    [anon_sym_AMP] = ACTIONS(1053),
  },
  [1029] = {
    [aux_sym_concatenation_repeat1] = STATE(1741),
    [sym__simple_heredoc_body] = ACTIONS(2596),
    [sym__heredoc_body_beginning] = ACTIONS(2596),
    [sym_file_descriptor] = ACTIONS(2596),
    [sym__concat] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(2598),
    [anon_sym_PIPE] = ACTIONS(2598),
    [anon_sym_RPAREN] = ACTIONS(2596),
    [anon_sym_SEMI_SEMI] = ACTIONS(2596),
    [anon_sym_PIPE_AMP] = ACTIONS(2596),
    [anon_sym_AMP_AMP] = ACTIONS(2596),
    [anon_sym_PIPE_PIPE] = ACTIONS(2596),
    [anon_sym_LT] = ACTIONS(2598),
    [anon_sym_GT] = ACTIONS(2598),
    [anon_sym_GT_GT] = ACTIONS(2596),
    [anon_sym_AMP_GT] = ACTIONS(2598),
    [anon_sym_AMP_GT_GT] = ACTIONS(2596),
    [anon_sym_LT_AMP] = ACTIONS(2596),
    [anon_sym_GT_AMP] = ACTIONS(2596),
    [anon_sym_LT_LT] = ACTIONS(2598),
    [anon_sym_LT_LT_DASH] = ACTIONS(2596),
    [anon_sym_LT_LT_LT] = ACTIONS(2596),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2596),
    [anon_sym_AMP] = ACTIONS(2598),
  },
  [1030] = {
    [aux_sym__literal_repeat1] = STATE(1742),
    [sym__simple_heredoc_body] = ACTIONS(2600),
    [sym__heredoc_body_beginning] = ACTIONS(2600),
    [sym_file_descriptor] = ACTIONS(2600),
    [anon_sym_SEMI] = ACTIONS(2602),
    [anon_sym_PIPE] = ACTIONS(2602),
    [anon_sym_RPAREN] = ACTIONS(2600),
    [anon_sym_SEMI_SEMI] = ACTIONS(2600),
    [anon_sym_PIPE_AMP] = ACTIONS(2600),
    [anon_sym_AMP_AMP] = ACTIONS(2600),
    [anon_sym_PIPE_PIPE] = ACTIONS(2600),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_GT_GT] = ACTIONS(2600),
    [anon_sym_AMP_GT] = ACTIONS(2602),
    [anon_sym_AMP_GT_GT] = ACTIONS(2600),
    [anon_sym_LT_AMP] = ACTIONS(2600),
    [anon_sym_GT_AMP] = ACTIONS(2600),
    [anon_sym_LT_LT] = ACTIONS(2602),
    [anon_sym_LT_LT_DASH] = ACTIONS(2600),
    [anon_sym_LT_LT_LT] = ACTIONS(2600),
    [sym__special_character] = ACTIONS(441),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2600),
    [anon_sym_AMP] = ACTIONS(2602),
  },
  [1031] = {
    [sym_file_redirect] = STATE(1031),
    [sym_heredoc_redirect] = STATE(1031),
    [sym_herestring_redirect] = STATE(1031),
    [aux_sym_redirected_statement_repeat1] = STATE(1031),
    [sym__simple_heredoc_body] = ACTIONS(2610),
    [sym__heredoc_body_beginning] = ACTIONS(2610),
    [sym_file_descriptor] = ACTIONS(3595),
    [anon_sym_SEMI] = ACTIONS(2615),
    [anon_sym_PIPE] = ACTIONS(2615),
    [anon_sym_RPAREN] = ACTIONS(2610),
    [anon_sym_SEMI_SEMI] = ACTIONS(2610),
    [anon_sym_PIPE_AMP] = ACTIONS(2610),
    [anon_sym_AMP_AMP] = ACTIONS(2610),
    [anon_sym_PIPE_PIPE] = ACTIONS(2610),
    [anon_sym_LT] = ACTIONS(3598),
    [anon_sym_GT] = ACTIONS(3598),
    [anon_sym_GT_GT] = ACTIONS(3601),
    [anon_sym_AMP_GT] = ACTIONS(3598),
    [anon_sym_AMP_GT_GT] = ACTIONS(3601),
    [anon_sym_LT_AMP] = ACTIONS(3601),
    [anon_sym_GT_AMP] = ACTIONS(3601),
    [anon_sym_LT_LT] = ACTIONS(2623),
    [anon_sym_LT_LT_DASH] = ACTIONS(2626),
    [anon_sym_LT_LT_LT] = ACTIONS(3604),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2610),
    [anon_sym_AMP] = ACTIONS(2615),
  },
  [1032] = {
    [aux_sym_concatenation_repeat1] = STATE(432),
    [sym__simple_heredoc_body] = ACTIONS(2632),
    [sym__heredoc_body_beginning] = ACTIONS(2632),
    [sym_file_descriptor] = ACTIONS(2632),
    [sym__concat] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2634),
    [anon_sym_RPAREN] = ACTIONS(2632),
    [anon_sym_SEMI_SEMI] = ACTIONS(2632),
    [anon_sym_PIPE_AMP] = ACTIONS(2632),
    [anon_sym_AMP_AMP] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2632),
    [anon_sym_EQ_TILDE] = ACTIONS(2634),
    [anon_sym_EQ_EQ] = ACTIONS(2634),
    [anon_sym_LT] = ACTIONS(2634),
    [anon_sym_GT] = ACTIONS(2634),
    [anon_sym_GT_GT] = ACTIONS(2632),
    [anon_sym_AMP_GT] = ACTIONS(2634),
    [anon_sym_AMP_GT_GT] = ACTIONS(2632),
    [anon_sym_LT_AMP] = ACTIONS(2632),
    [anon_sym_GT_AMP] = ACTIONS(2632),
    [anon_sym_LT_LT] = ACTIONS(2634),
    [anon_sym_LT_LT_DASH] = ACTIONS(2632),
    [anon_sym_LT_LT_LT] = ACTIONS(2632),
    [anon_sym_DOLLAR] = ACTIONS(2634),
    [sym__special_character] = ACTIONS(2632),
    [anon_sym_DQUOTE] = ACTIONS(2632),
    [sym_raw_string] = ACTIONS(2632),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2632),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2632),
    [anon_sym_BQUOTE] = ACTIONS(2632),
    [anon_sym_LT_LPAREN] = ACTIONS(2632),
    [anon_sym_GT_LPAREN] = ACTIONS(2632),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2634),
    [anon_sym_LF] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2634),
  },
  [1033] = {
    [aux_sym__literal_repeat1] = STATE(447),
    [sym__simple_heredoc_body] = ACTIONS(2636),
    [sym__heredoc_body_beginning] = ACTIONS(2636),
    [sym_file_descriptor] = ACTIONS(2636),
    [anon_sym_SEMI] = ACTIONS(2638),
    [anon_sym_PIPE] = ACTIONS(2638),
    [anon_sym_RPAREN] = ACTIONS(2636),
    [anon_sym_SEMI_SEMI] = ACTIONS(2636),
    [anon_sym_PIPE_AMP] = ACTIONS(2636),
    [anon_sym_AMP_AMP] = ACTIONS(2636),
    [anon_sym_PIPE_PIPE] = ACTIONS(2636),
    [anon_sym_EQ_TILDE] = ACTIONS(2638),
    [anon_sym_EQ_EQ] = ACTIONS(2638),
    [anon_sym_LT] = ACTIONS(2638),
    [anon_sym_GT] = ACTIONS(2638),
    [anon_sym_GT_GT] = ACTIONS(2636),
    [anon_sym_AMP_GT] = ACTIONS(2638),
    [anon_sym_AMP_GT_GT] = ACTIONS(2636),
    [anon_sym_LT_AMP] = ACTIONS(2636),
    [anon_sym_GT_AMP] = ACTIONS(2636),
    [anon_sym_LT_LT] = ACTIONS(2638),
    [anon_sym_LT_LT_DASH] = ACTIONS(2636),
    [anon_sym_LT_LT_LT] = ACTIONS(2636),
    [anon_sym_DOLLAR] = ACTIONS(2638),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(2636),
    [sym_raw_string] = ACTIONS(2636),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2636),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2636),
    [anon_sym_BQUOTE] = ACTIONS(2636),
    [anon_sym_LT_LPAREN] = ACTIONS(2636),
    [anon_sym_GT_LPAREN] = ACTIONS(2636),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2638),
    [anon_sym_LF] = ACTIONS(2636),
    [anon_sym_AMP] = ACTIONS(2638),
  },
  [1034] = {
    [sym_concatenation] = STATE(1034),
    [sym_string] = STATE(441),
    [sym_simple_expansion] = STATE(441),
    [sym_string_expansion] = STATE(441),
    [sym_expansion] = STATE(441),
    [sym_command_substitution] = STATE(441),
    [sym_process_substitution] = STATE(441),
    [aux_sym_command_repeat2] = STATE(1034),
    [aux_sym__literal_repeat1] = STATE(443),
    [sym__simple_heredoc_body] = ACTIONS(2632),
    [sym__heredoc_body_beginning] = ACTIONS(2632),
    [sym_file_descriptor] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2634),
    [anon_sym_RPAREN] = ACTIONS(2632),
    [anon_sym_SEMI_SEMI] = ACTIONS(2632),
    [anon_sym_PIPE_AMP] = ACTIONS(2632),
    [anon_sym_AMP_AMP] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2632),
    [anon_sym_EQ_TILDE] = ACTIONS(3607),
    [anon_sym_EQ_EQ] = ACTIONS(3607),
    [anon_sym_LT] = ACTIONS(2634),
    [anon_sym_GT] = ACTIONS(2634),
    [anon_sym_GT_GT] = ACTIONS(2632),
    [anon_sym_AMP_GT] = ACTIONS(2634),
    [anon_sym_AMP_GT_GT] = ACTIONS(2632),
    [anon_sym_LT_AMP] = ACTIONS(2632),
    [anon_sym_GT_AMP] = ACTIONS(2632),
    [anon_sym_LT_LT] = ACTIONS(2634),
    [anon_sym_LT_LT_DASH] = ACTIONS(2632),
    [anon_sym_LT_LT_LT] = ACTIONS(2632),
    [anon_sym_DOLLAR] = ACTIONS(2643),
    [sym__special_character] = ACTIONS(3610),
    [anon_sym_DQUOTE] = ACTIONS(2649),
    [sym_raw_string] = ACTIONS(3613),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2655),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2661),
    [anon_sym_LT_LPAREN] = ACTIONS(2664),
    [anon_sym_GT_LPAREN] = ACTIONS(2664),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3616),
    [anon_sym_LF] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2634),
  },
  [1035] = {
    [sym_concatenation] = STATE(1034),
    [sym_string] = STATE(441),
    [sym_simple_expansion] = STATE(441),
    [sym_string_expansion] = STATE(441),
    [sym_expansion] = STATE(441),
    [sym_command_substitution] = STATE(441),
    [sym_process_substitution] = STATE(441),
    [aux_sym_command_repeat2] = STATE(1034),
    [aux_sym__literal_repeat1] = STATE(443),
    [sym__simple_heredoc_body] = ACTIONS(2696),
    [sym__heredoc_body_beginning] = ACTIONS(2696),
    [sym_file_descriptor] = ACTIONS(2696),
    [anon_sym_SEMI] = ACTIONS(2698),
    [anon_sym_PIPE] = ACTIONS(2698),
    [anon_sym_RPAREN] = ACTIONS(2696),
    [anon_sym_SEMI_SEMI] = ACTIONS(2696),
    [anon_sym_PIPE_AMP] = ACTIONS(2696),
    [anon_sym_AMP_AMP] = ACTIONS(2696),
    [anon_sym_PIPE_PIPE] = ACTIONS(2696),
    [anon_sym_EQ_TILDE] = ACTIONS(763),
    [anon_sym_EQ_EQ] = ACTIONS(763),
    [anon_sym_LT] = ACTIONS(2698),
    [anon_sym_GT] = ACTIONS(2698),
    [anon_sym_GT_GT] = ACTIONS(2696),
    [anon_sym_AMP_GT] = ACTIONS(2698),
    [anon_sym_AMP_GT_GT] = ACTIONS(2696),
    [anon_sym_LT_AMP] = ACTIONS(2696),
    [anon_sym_GT_AMP] = ACTIONS(2696),
    [anon_sym_LT_LT] = ACTIONS(2698),
    [anon_sym_LT_LT_DASH] = ACTIONS(2696),
    [anon_sym_LT_LT_LT] = ACTIONS(2696),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(767),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(769),
    [anon_sym_LF] = ACTIONS(2696),
    [anon_sym_AMP] = ACTIONS(2698),
  },
  [1036] = {
    [sym__simple_heredoc_body] = ACTIONS(1400),
    [sym__heredoc_body_beginning] = ACTIONS(1400),
    [sym_file_descriptor] = ACTIONS(1400),
    [sym_variable_name] = ACTIONS(1400),
    [anon_sym_SEMI] = ACTIONS(1402),
    [anon_sym_PIPE] = ACTIONS(1402),
    [anon_sym_SEMI_SEMI] = ACTIONS(1400),
    [anon_sym_RBRACE] = ACTIONS(1400),
    [anon_sym_PIPE_AMP] = ACTIONS(1400),
    [anon_sym_AMP_AMP] = ACTIONS(1400),
    [anon_sym_PIPE_PIPE] = ACTIONS(1400),
    [anon_sym_LT] = ACTIONS(1402),
    [anon_sym_GT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT] = ACTIONS(1402),
    [anon_sym_AMP_GT_GT] = ACTIONS(1400),
    [anon_sym_LT_AMP] = ACTIONS(1400),
    [anon_sym_GT_AMP] = ACTIONS(1400),
    [anon_sym_LT_LT] = ACTIONS(1402),
    [anon_sym_LT_LT_DASH] = ACTIONS(1400),
    [anon_sym_LT_LT_LT] = ACTIONS(1400),
    [anon_sym_DOLLAR] = ACTIONS(1402),
    [sym__special_character] = ACTIONS(1402),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1400),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1400),
    [anon_sym_BQUOTE] = ACTIONS(1400),
    [anon_sym_LT_LPAREN] = ACTIONS(1400),
    [anon_sym_GT_LPAREN] = ACTIONS(1400),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1402),
    [anon_sym_LF] = ACTIONS(1400),
    [anon_sym_AMP] = ACTIONS(1402),
  },
  [1037] = {
    [sym_concatenation] = STATE(1744),
    [sym_string] = STATE(730),
    [sym_simple_expansion] = STATE(730),
    [sym_string_expansion] = STATE(730),
    [sym_expansion] = STATE(730),
    [sym_command_substitution] = STATE(730),
    [sym_process_substitution] = STATE(730),
    [aux_sym_for_statement_repeat1] = STATE(1744),
    [aux_sym__literal_repeat1] = STATE(736),
    [anon_sym_RPAREN] = ACTIONS(3619),
    [anon_sym_DOLLAR] = ACTIONS(1406),
    [sym__special_character] = ACTIONS(1408),
    [anon_sym_DQUOTE] = ACTIONS(1410),
    [sym_raw_string] = ACTIONS(1412),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1414),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1416),
    [anon_sym_BQUOTE] = ACTIONS(1418),
    [anon_sym_LT_LPAREN] = ACTIONS(1420),
    [anon_sym_GT_LPAREN] = ACTIONS(1420),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1412),
  },
  [1038] = {
    [sym_string] = STATE(1746),
    [anon_sym_DASH] = ACTIONS(3621),
    [anon_sym_DOLLAR] = ACTIONS(3621),
    [anon_sym_DQUOTE] = ACTIONS(1929),
    [sym_raw_string] = ACTIONS(3623),
    [anon_sym_POUND] = ACTIONS(3621),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3625),
    [anon_sym_STAR] = ACTIONS(3627),
    [anon_sym_AT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(3627),
    [anon_sym_0] = ACTIONS(3625),
    [anon_sym__] = ACTIONS(3625),
  },
  [1039] = {
    [aux_sym_concatenation_repeat1] = STATE(1749),
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(3629),
    [sym_variable_name] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_RBRACE] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [1040] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(1752),
    [anon_sym_DOLLAR] = ACTIONS(3631),
    [anon_sym_DQUOTE] = ACTIONS(3633),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [1041] = {
    [aux_sym_concatenation_repeat1] = STATE(1749),
    [sym__simple_heredoc_body] = ACTIONS(1400),
    [sym__heredoc_body_beginning] = ACTIONS(1400),
    [sym_file_descriptor] = ACTIONS(1400),
    [sym__concat] = ACTIONS(3629),
    [sym_variable_name] = ACTIONS(1400),
    [anon_sym_SEMI] = ACTIONS(1402),
    [anon_sym_PIPE] = ACTIONS(1402),
    [anon_sym_SEMI_SEMI] = ACTIONS(1400),
    [anon_sym_RBRACE] = ACTIONS(1400),
    [anon_sym_PIPE_AMP] = ACTIONS(1400),
    [anon_sym_AMP_AMP] = ACTIONS(1400),
    [anon_sym_PIPE_PIPE] = ACTIONS(1400),
    [anon_sym_LT] = ACTIONS(1402),
    [anon_sym_GT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT] = ACTIONS(1402),
    [anon_sym_AMP_GT_GT] = ACTIONS(1400),
    [anon_sym_LT_AMP] = ACTIONS(1400),
    [anon_sym_GT_AMP] = ACTIONS(1400),
    [anon_sym_LT_LT] = ACTIONS(1402),
    [anon_sym_LT_LT_DASH] = ACTIONS(1400),
    [anon_sym_LT_LT_LT] = ACTIONS(1400),
    [anon_sym_DOLLAR] = ACTIONS(1402),
    [sym__special_character] = ACTIONS(1402),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1400),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1400),
    [anon_sym_BQUOTE] = ACTIONS(1400),
    [anon_sym_LT_LPAREN] = ACTIONS(1400),
    [anon_sym_GT_LPAREN] = ACTIONS(1400),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1402),
    [anon_sym_LF] = ACTIONS(1400),
    [anon_sym_AMP] = ACTIONS(1402),
  },
  [1042] = {
    [sym_subscript] = STATE(1756),
    [sym_variable_name] = ACTIONS(3635),
    [anon_sym_BANG] = ACTIONS(3637),
    [anon_sym_DASH] = ACTIONS(3639),
    [anon_sym_DOLLAR] = ACTIONS(3639),
    [anon_sym_POUND] = ACTIONS(3637),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3641),
    [anon_sym_STAR] = ACTIONS(3643),
    [anon_sym_AT] = ACTIONS(3643),
    [anon_sym_QMARK] = ACTIONS(3643),
    [anon_sym_0] = ACTIONS(3641),
    [anon_sym__] = ACTIONS(3641),
  },
  [1043] = {
    [sym__statements] = STATE(1757),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(1758),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [1044] = {
    [sym__statements] = STATE(1759),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [1045] = {
    [sym__statements] = STATE(1760),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [1046] = {
    [aux_sym__literal_repeat1] = STATE(1762),
    [sym__simple_heredoc_body] = ACTIONS(1446),
    [sym__heredoc_body_beginning] = ACTIONS(1446),
    [sym_file_descriptor] = ACTIONS(1446),
    [sym_variable_name] = ACTIONS(1446),
    [anon_sym_SEMI] = ACTIONS(1448),
    [anon_sym_PIPE] = ACTIONS(1448),
    [anon_sym_SEMI_SEMI] = ACTIONS(1446),
    [anon_sym_RBRACE] = ACTIONS(1446),
    [anon_sym_PIPE_AMP] = ACTIONS(1446),
    [anon_sym_AMP_AMP] = ACTIONS(1446),
    [anon_sym_PIPE_PIPE] = ACTIONS(1446),
    [anon_sym_LT] = ACTIONS(1448),
    [anon_sym_GT] = ACTIONS(1448),
    [anon_sym_GT_GT] = ACTIONS(1446),
    [anon_sym_AMP_GT] = ACTIONS(1448),
    [anon_sym_AMP_GT_GT] = ACTIONS(1446),
    [anon_sym_LT_AMP] = ACTIONS(1446),
    [anon_sym_GT_AMP] = ACTIONS(1446),
    [anon_sym_LT_LT] = ACTIONS(1448),
    [anon_sym_LT_LT_DASH] = ACTIONS(1446),
    [anon_sym_LT_LT_LT] = ACTIONS(1446),
    [anon_sym_DOLLAR] = ACTIONS(1448),
    [sym__special_character] = ACTIONS(3645),
    [anon_sym_DQUOTE] = ACTIONS(1446),
    [sym_raw_string] = ACTIONS(1446),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1446),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1446),
    [anon_sym_BQUOTE] = ACTIONS(1446),
    [anon_sym_LT_LPAREN] = ACTIONS(1446),
    [anon_sym_GT_LPAREN] = ACTIONS(1446),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1448),
    [anon_sym_LF] = ACTIONS(1446),
    [anon_sym_AMP] = ACTIONS(1448),
  },
  [1047] = {
    [sym__expression] = STATE(1764),
    [sym_binary_expression] = STATE(1764),
    [sym_unary_expression] = STATE(1764),
    [sym_postfix_expression] = STATE(1764),
    [sym_parenthesized_expression] = STATE(1764),
    [sym_concatenation] = STATE(1764),
    [sym_string] = STATE(280),
    [sym_simple_expansion] = STATE(280),
    [sym_string_expansion] = STATE(280),
    [sym_expansion] = STATE(280),
    [sym_command_substitution] = STATE(280),
    [sym_process_substitution] = STATE(280),
    [aux_sym__literal_repeat1] = STATE(286),
    [anon_sym_SEMI] = ACTIONS(3647),
    [anon_sym_SEMI_SEMI] = ACTIONS(3649),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(475),
    [anon_sym_DOLLAR] = ACTIONS(477),
    [sym__special_character] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(481),
    [sym_raw_string] = ACTIONS(483),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(485),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(487),
    [anon_sym_BQUOTE] = ACTIONS(489),
    [anon_sym_LT_LPAREN] = ACTIONS(491),
    [anon_sym_GT_LPAREN] = ACTIONS(491),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(493),
    [sym_test_operator] = ACTIONS(495),
    [anon_sym_LF] = ACTIONS(3649),
    [anon_sym_AMP] = ACTIONS(3649),
  },
  [1048] = {
    [anon_sym_SEMI] = ACTIONS(3651),
    [anon_sym_SEMI_SEMI] = ACTIONS(3653),
    [anon_sym_AMP_AMP] = ACTIONS(1484),
    [anon_sym_PIPE_PIPE] = ACTIONS(1484),
    [anon_sym_EQ_TILDE] = ACTIONS(1486),
    [anon_sym_EQ_EQ] = ACTIONS(1486),
    [anon_sym_EQ] = ACTIONS(1488),
    [anon_sym_PLUS_EQ] = ACTIONS(1484),
    [anon_sym_LT] = ACTIONS(1488),
    [anon_sym_GT] = ACTIONS(1488),
    [anon_sym_BANG_EQ] = ACTIONS(1484),
    [anon_sym_PLUS] = ACTIONS(1488),
    [anon_sym_DASH] = ACTIONS(1488),
    [anon_sym_DASH_EQ] = ACTIONS(1484),
    [anon_sym_LT_EQ] = ACTIONS(1484),
    [anon_sym_GT_EQ] = ACTIONS(1484),
    [anon_sym_PLUS_PLUS] = ACTIONS(1490),
    [anon_sym_DASH_DASH] = ACTIONS(1490),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1484),
    [anon_sym_LF] = ACTIONS(3653),
    [anon_sym_AMP] = ACTIONS(3651),
  },
  [1049] = {
    [sym_concatenation] = STATE(1766),
    [sym_string] = STATE(784),
    [sym_simple_expansion] = STATE(784),
    [sym_string_expansion] = STATE(784),
    [sym_expansion] = STATE(784),
    [sym_command_substitution] = STATE(784),
    [sym_process_substitution] = STATE(784),
    [aux_sym_for_statement_repeat1] = STATE(1766),
    [aux_sym__literal_repeat1] = STATE(790),
    [anon_sym_DOLLAR] = ACTIONS(1494),
    [sym__special_character] = ACTIONS(1496),
    [anon_sym_DQUOTE] = ACTIONS(1498),
    [sym_raw_string] = ACTIONS(1500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1502),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1504),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_LT_LPAREN] = ACTIONS(1508),
    [anon_sym_GT_LPAREN] = ACTIONS(1508),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1500),
  },
  [1050] = {
    [sym_do_group] = STATE(1767),
    [anon_sym_do] = ACTIONS(1953),
    [sym_comment] = ACTIONS(57),
  },
  [1051] = {
    [sym__simple_heredoc_body] = ACTIONS(1586),
    [sym__heredoc_body_beginning] = ACTIONS(1586),
    [sym_file_descriptor] = ACTIONS(1586),
    [anon_sym_SEMI] = ACTIONS(1588),
    [anon_sym_PIPE] = ACTIONS(1588),
    [anon_sym_SEMI_SEMI] = ACTIONS(1586),
    [anon_sym_RBRACE] = ACTIONS(1586),
    [anon_sym_PIPE_AMP] = ACTIONS(1586),
    [anon_sym_AMP_AMP] = ACTIONS(1586),
    [anon_sym_PIPE_PIPE] = ACTIONS(1586),
    [anon_sym_LT] = ACTIONS(1588),
    [anon_sym_GT] = ACTIONS(1588),
    [anon_sym_GT_GT] = ACTIONS(1586),
    [anon_sym_AMP_GT] = ACTIONS(1588),
    [anon_sym_AMP_GT_GT] = ACTIONS(1586),
    [anon_sym_LT_AMP] = ACTIONS(1586),
    [anon_sym_GT_AMP] = ACTIONS(1586),
    [anon_sym_LT_LT] = ACTIONS(1588),
    [anon_sym_LT_LT_DASH] = ACTIONS(1586),
    [anon_sym_LT_LT_LT] = ACTIONS(1586),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1586),
    [anon_sym_AMP] = ACTIONS(1588),
  },
  [1052] = {
    [sym__statements] = STATE(1769),
    [sym_redirected_statement] = STATE(934),
    [sym_for_statement] = STATE(934),
    [sym_c_style_for_statement] = STATE(934),
    [sym_while_statement] = STATE(934),
    [sym_if_statement] = STATE(934),
    [sym_case_statement] = STATE(934),
    [sym_function_definition] = STATE(934),
    [sym_compound_statement] = STATE(934),
    [sym_subshell] = STATE(934),
    [sym_pipeline] = STATE(934),
    [sym_list] = STATE(934),
    [sym_negated_command] = STATE(934),
    [sym_test_command] = STATE(934),
    [sym_declaration_command] = STATE(934),
    [sym_unset_command] = STATE(934),
    [sym_command] = STATE(934),
    [sym_command_name] = STATE(935),
    [sym_variable_assignment] = STATE(936),
    [sym_subscript] = STATE(937),
    [sym_file_redirect] = STATE(940),
    [sym_concatenation] = STATE(938),
    [sym_string] = STATE(927),
    [sym_simple_expansion] = STATE(927),
    [sym_string_expansion] = STATE(927),
    [sym_expansion] = STATE(927),
    [sym_command_substitution] = STATE(927),
    [sym_process_substitution] = STATE(927),
    [aux_sym__statements_repeat1] = STATE(939),
    [aux_sym_command_repeat1] = STATE(940),
    [aux_sym__literal_repeat1] = STATE(941),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(1751),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_done] = ACTIONS(3655),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1755),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(1757),
    [anon_sym_typeset] = ACTIONS(1757),
    [anon_sym_export] = ACTIONS(1757),
    [anon_sym_readonly] = ACTIONS(1757),
    [anon_sym_local] = ACTIONS(1757),
    [anon_sym_unset] = ACTIONS(1759),
    [anon_sym_unsetenv] = ACTIONS(1759),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(1761),
    [sym__special_character] = ACTIONS(1763),
    [anon_sym_DQUOTE] = ACTIONS(1765),
    [sym_raw_string] = ACTIONS(1767),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1769),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1771),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [anon_sym_LT_LPAREN] = ACTIONS(1775),
    [anon_sym_GT_LPAREN] = ACTIONS(1775),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1777),
  },
  [1053] = {
    [sym__simple_heredoc_body] = ACTIONS(1779),
    [sym__heredoc_body_beginning] = ACTIONS(1779),
    [sym_file_descriptor] = ACTIONS(1779),
    [anon_sym_SEMI] = ACTIONS(1781),
    [anon_sym_PIPE] = ACTIONS(1781),
    [anon_sym_SEMI_SEMI] = ACTIONS(1779),
    [anon_sym_RBRACE] = ACTIONS(1779),
    [anon_sym_PIPE_AMP] = ACTIONS(1779),
    [anon_sym_AMP_AMP] = ACTIONS(1779),
    [anon_sym_PIPE_PIPE] = ACTIONS(1779),
    [anon_sym_LT] = ACTIONS(1781),
    [anon_sym_GT] = ACTIONS(1781),
    [anon_sym_GT_GT] = ACTIONS(1779),
    [anon_sym_AMP_GT] = ACTIONS(1781),
    [anon_sym_AMP_GT_GT] = ACTIONS(1779),
    [anon_sym_LT_AMP] = ACTIONS(1779),
    [anon_sym_GT_AMP] = ACTIONS(1779),
    [anon_sym_LT_LT] = ACTIONS(1781),
    [anon_sym_LT_LT_DASH] = ACTIONS(1779),
    [anon_sym_LT_LT_LT] = ACTIONS(1779),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1779),
    [anon_sym_AMP] = ACTIONS(1781),
  },
  [1054] = {
    [sym__statements] = STATE(1771),
    [sym_redirected_statement] = STATE(978),
    [sym_for_statement] = STATE(978),
    [sym_c_style_for_statement] = STATE(978),
    [sym_while_statement] = STATE(978),
    [sym_if_statement] = STATE(978),
    [sym_elif_clause] = STATE(1773),
    [sym_else_clause] = STATE(1772),
    [sym_case_statement] = STATE(978),
    [sym_function_definition] = STATE(978),
    [sym_compound_statement] = STATE(978),
    [sym_subshell] = STATE(978),
    [sym_pipeline] = STATE(978),
    [sym_list] = STATE(978),
    [sym_negated_command] = STATE(978),
    [sym_test_command] = STATE(978),
    [sym_declaration_command] = STATE(978),
    [sym_unset_command] = STATE(978),
    [sym_command] = STATE(978),
    [sym_command_name] = STATE(980),
    [sym_variable_assignment] = STATE(981),
    [sym_subscript] = STATE(982),
    [sym_file_redirect] = STATE(986),
    [sym_concatenation] = STATE(983),
    [sym_string] = STATE(971),
    [sym_simple_expansion] = STATE(971),
    [sym_string_expansion] = STATE(971),
    [sym_expansion] = STATE(971),
    [sym_command_substitution] = STATE(971),
    [sym_process_substitution] = STATE(971),
    [aux_sym__statements_repeat1] = STATE(984),
    [aux_sym_if_statement_repeat1] = STATE(1773),
    [aux_sym_command_repeat1] = STATE(986),
    [aux_sym__literal_repeat1] = STATE(987),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(1804),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_fi] = ACTIONS(3657),
    [anon_sym_elif] = ACTIONS(1808),
    [anon_sym_else] = ACTIONS(1810),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1812),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(1814),
    [anon_sym_typeset] = ACTIONS(1814),
    [anon_sym_export] = ACTIONS(1814),
    [anon_sym_readonly] = ACTIONS(1814),
    [anon_sym_local] = ACTIONS(1814),
    [anon_sym_unset] = ACTIONS(1816),
    [anon_sym_unsetenv] = ACTIONS(1816),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(1818),
    [sym__special_character] = ACTIONS(1820),
    [anon_sym_DQUOTE] = ACTIONS(1822),
    [sym_raw_string] = ACTIONS(1824),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1826),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1828),
    [anon_sym_BQUOTE] = ACTIONS(1830),
    [anon_sym_LT_LPAREN] = ACTIONS(1832),
    [anon_sym_GT_LPAREN] = ACTIONS(1832),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1834),
  },
  [1055] = {
    [anon_sym_SEMI] = ACTIONS(3659),
    [anon_sym_SEMI_SEMI] = ACTIONS(3661),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3661),
    [anon_sym_AMP] = ACTIONS(3661),
  },
  [1056] = {
    [anon_sym_in] = ACTIONS(3663),
    [sym_comment] = ACTIONS(57),
  },
  [1057] = {
    [anon_sym_SEMI] = ACTIONS(3665),
    [anon_sym_SEMI_SEMI] = ACTIONS(3667),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3667),
    [anon_sym_AMP] = ACTIONS(3667),
  },
  [1058] = {
    [anon_sym_in] = ACTIONS(3669),
    [sym_comment] = ACTIONS(57),
  },
  [1059] = {
    [anon_sym_RPAREN] = ACTIONS(3671),
    [sym_comment] = ACTIONS(57),
  },
  [1060] = {
    [sym__simple_heredoc_body] = ACTIONS(1891),
    [sym__heredoc_body_beginning] = ACTIONS(1891),
    [sym_file_descriptor] = ACTIONS(1891),
    [anon_sym_SEMI] = ACTIONS(1893),
    [anon_sym_PIPE] = ACTIONS(1893),
    [anon_sym_SEMI_SEMI] = ACTIONS(1891),
    [anon_sym_RBRACE] = ACTIONS(1891),
    [anon_sym_PIPE_AMP] = ACTIONS(1891),
    [anon_sym_AMP_AMP] = ACTIONS(1891),
    [anon_sym_PIPE_PIPE] = ACTIONS(1891),
    [anon_sym_LT] = ACTIONS(1893),
    [anon_sym_GT] = ACTIONS(1893),
    [anon_sym_GT_GT] = ACTIONS(1891),
    [anon_sym_AMP_GT] = ACTIONS(1893),
    [anon_sym_AMP_GT_GT] = ACTIONS(1891),
    [anon_sym_LT_AMP] = ACTIONS(1891),
    [anon_sym_GT_AMP] = ACTIONS(1891),
    [anon_sym_LT_LT] = ACTIONS(1893),
    [anon_sym_LT_LT_DASH] = ACTIONS(1891),
    [anon_sym_LT_LT_LT] = ACTIONS(1891),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1891),
    [anon_sym_AMP] = ACTIONS(1893),
  },
  [1061] = {
    [sym__simple_heredoc_body] = ACTIONS(1905),
    [sym__heredoc_body_beginning] = ACTIONS(1905),
    [sym_file_descriptor] = ACTIONS(1905),
    [anon_sym_SEMI] = ACTIONS(1907),
    [anon_sym_PIPE] = ACTIONS(1907),
    [anon_sym_SEMI_SEMI] = ACTIONS(1905),
    [anon_sym_RBRACE] = ACTIONS(1905),
    [anon_sym_PIPE_AMP] = ACTIONS(1905),
    [anon_sym_AMP_AMP] = ACTIONS(1905),
    [anon_sym_PIPE_PIPE] = ACTIONS(1905),
    [anon_sym_LT] = ACTIONS(1907),
    [anon_sym_GT] = ACTIONS(1907),
    [anon_sym_GT_GT] = ACTIONS(1905),
    [anon_sym_AMP_GT] = ACTIONS(1907),
    [anon_sym_AMP_GT_GT] = ACTIONS(1905),
    [anon_sym_LT_AMP] = ACTIONS(1905),
    [anon_sym_GT_AMP] = ACTIONS(1905),
    [anon_sym_LT_LT] = ACTIONS(1907),
    [anon_sym_LT_LT_DASH] = ACTIONS(1905),
    [anon_sym_LT_LT_LT] = ACTIONS(1905),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1905),
    [anon_sym_AMP] = ACTIONS(1907),
  },
  [1062] = {
    [sym__simple_heredoc_body] = ACTIONS(2073),
    [sym__heredoc_body_beginning] = ACTIONS(2073),
    [sym_file_descriptor] = ACTIONS(2073),
    [anon_sym_SEMI] = ACTIONS(2075),
    [anon_sym_PIPE] = ACTIONS(2075),
    [anon_sym_SEMI_SEMI] = ACTIONS(2073),
    [anon_sym_RBRACE] = ACTIONS(2073),
    [anon_sym_PIPE_AMP] = ACTIONS(2073),
    [anon_sym_AMP_AMP] = ACTIONS(2073),
    [anon_sym_PIPE_PIPE] = ACTIONS(2073),
    [anon_sym_LT] = ACTIONS(2075),
    [anon_sym_GT] = ACTIONS(2075),
    [anon_sym_GT_GT] = ACTIONS(2073),
    [anon_sym_AMP_GT] = ACTIONS(2075),
    [anon_sym_AMP_GT_GT] = ACTIONS(2073),
    [anon_sym_LT_AMP] = ACTIONS(2073),
    [anon_sym_GT_AMP] = ACTIONS(2073),
    [anon_sym_LT_LT] = ACTIONS(2075),
    [anon_sym_LT_LT_DASH] = ACTIONS(2073),
    [anon_sym_LT_LT_LT] = ACTIONS(2073),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2075),
  },
  [1063] = {
    [sym_concatenation] = STATE(1779),
    [sym_string] = STATE(1781),
    [sym_array] = STATE(1779),
    [sym_simple_expansion] = STATE(1781),
    [sym_string_expansion] = STATE(1781),
    [sym_expansion] = STATE(1781),
    [sym_command_substitution] = STATE(1781),
    [sym_process_substitution] = STATE(1781),
    [aux_sym__literal_repeat1] = STATE(1782),
    [sym__empty_value] = ACTIONS(3673),
    [anon_sym_LPAREN] = ACTIONS(3675),
    [anon_sym_DOLLAR] = ACTIONS(789),
    [sym__special_character] = ACTIONS(3677),
    [anon_sym_DQUOTE] = ACTIONS(793),
    [sym_raw_string] = ACTIONS(3679),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(797),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(799),
    [anon_sym_BQUOTE] = ACTIONS(801),
    [anon_sym_LT_LPAREN] = ACTIONS(803),
    [anon_sym_GT_LPAREN] = ACTIONS(803),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3679),
  },
  [1064] = {
    [sym__simple_heredoc_body] = ACTIONS(1057),
    [sym__heredoc_body_beginning] = ACTIONS(1057),
    [sym_file_descriptor] = ACTIONS(1057),
    [sym__concat] = ACTIONS(1057),
    [sym_variable_name] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(1057),
    [anon_sym_PIPE_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_AMP] = ACTIONS(1057),
    [anon_sym_GT_AMP] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_LT] = ACTIONS(1057),
    [anon_sym_DOLLAR] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [sym_raw_string] = ACTIONS(1057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1057),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1057),
    [anon_sym_BQUOTE] = ACTIONS(1057),
    [anon_sym_LT_LPAREN] = ACTIONS(1057),
    [anon_sym_GT_LPAREN] = ACTIONS(1057),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1059),
    [sym_word] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [1065] = {
    [sym__simple_heredoc_body] = ACTIONS(1061),
    [sym__heredoc_body_beginning] = ACTIONS(1061),
    [sym_file_descriptor] = ACTIONS(1061),
    [sym__concat] = ACTIONS(1061),
    [sym_variable_name] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(1063),
    [anon_sym_PIPE] = ACTIONS(1063),
    [anon_sym_SEMI_SEMI] = ACTIONS(1061),
    [anon_sym_RBRACE] = ACTIONS(1061),
    [anon_sym_PIPE_AMP] = ACTIONS(1061),
    [anon_sym_AMP_AMP] = ACTIONS(1061),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1063),
    [anon_sym_GT_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT_GT] = ACTIONS(1061),
    [anon_sym_LT_AMP] = ACTIONS(1061),
    [anon_sym_GT_AMP] = ACTIONS(1061),
    [anon_sym_LT_LT] = ACTIONS(1063),
    [anon_sym_LT_LT_DASH] = ACTIONS(1061),
    [anon_sym_LT_LT_LT] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1061),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1061),
    [anon_sym_LT_LPAREN] = ACTIONS(1061),
    [anon_sym_GT_LPAREN] = ACTIONS(1061),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1063),
    [sym_word] = ACTIONS(1063),
    [anon_sym_LF] = ACTIONS(1061),
    [anon_sym_AMP] = ACTIONS(1063),
  },
  [1066] = {
    [sym__simple_heredoc_body] = ACTIONS(1065),
    [sym__heredoc_body_beginning] = ACTIONS(1065),
    [sym_file_descriptor] = ACTIONS(1065),
    [sym__concat] = ACTIONS(1065),
    [sym_variable_name] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1067),
    [anon_sym_SEMI_SEMI] = ACTIONS(1065),
    [anon_sym_RBRACE] = ACTIONS(1065),
    [anon_sym_PIPE_AMP] = ACTIONS(1065),
    [anon_sym_AMP_AMP] = ACTIONS(1065),
    [anon_sym_PIPE_PIPE] = ACTIONS(1065),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_GT] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT] = ACTIONS(1067),
    [anon_sym_AMP_GT_GT] = ACTIONS(1065),
    [anon_sym_LT_AMP] = ACTIONS(1065),
    [anon_sym_GT_AMP] = ACTIONS(1065),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_LT_LT_DASH] = ACTIONS(1065),
    [anon_sym_LT_LT_LT] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1067),
    [sym__special_character] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LT_LPAREN] = ACTIONS(1065),
    [anon_sym_GT_LPAREN] = ACTIONS(1065),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1067),
    [sym_word] = ACTIONS(1067),
    [anon_sym_LF] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1067),
  },
  [1067] = {
    [sym_string] = STATE(1783),
    [sym_simple_expansion] = STATE(1783),
    [sym_string_expansion] = STATE(1783),
    [sym_expansion] = STATE(1783),
    [sym_command_substitution] = STATE(1783),
    [sym_process_substitution] = STATE(1783),
    [anon_sym_DOLLAR] = ACTIONS(789),
    [sym__special_character] = ACTIONS(3681),
    [anon_sym_DQUOTE] = ACTIONS(793),
    [sym_raw_string] = ACTIONS(3681),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(797),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(799),
    [anon_sym_BQUOTE] = ACTIONS(801),
    [anon_sym_LT_LPAREN] = ACTIONS(803),
    [anon_sym_GT_LPAREN] = ACTIONS(803),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3681),
  },
  [1068] = {
    [aux_sym_concatenation_repeat1] = STATE(1785),
    [sym__simple_heredoc_body] = ACTIONS(1071),
    [sym__heredoc_body_beginning] = ACTIONS(1071),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(3683),
    [sym_variable_name] = ACTIONS(1071),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [sym__special_character] = ACTIONS(1075),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [sym_word] = ACTIONS(1075),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1075),
  },
  [1069] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(3685),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [1070] = {
    [sym__simple_heredoc_body] = ACTIONS(1089),
    [sym__heredoc_body_beginning] = ACTIONS(1089),
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(1089),
    [sym_variable_name] = ACTIONS(1089),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_PIPE_AMP] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_AMP] = ACTIONS(1089),
    [anon_sym_GT_AMP] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1089),
    [anon_sym_LT_LT_LT] = ACTIONS(1089),
    [anon_sym_DOLLAR] = ACTIONS(1091),
    [sym__special_character] = ACTIONS(1091),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1089),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1089),
    [anon_sym_GT_LPAREN] = ACTIONS(1089),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1091),
    [sym_word] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [1071] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(627),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_DQUOTE] = ACTIONS(3685),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [1072] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(3689),
    [sym_comment] = ACTIONS(57),
  },
  [1073] = {
    [sym_subscript] = STATE(1791),
    [sym_variable_name] = ACTIONS(3691),
    [anon_sym_DASH] = ACTIONS(3693),
    [anon_sym_DOLLAR] = ACTIONS(3693),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3695),
    [anon_sym_STAR] = ACTIONS(3697),
    [anon_sym_AT] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3697),
    [anon_sym_0] = ACTIONS(3695),
    [anon_sym__] = ACTIONS(3695),
  },
  [1074] = {
    [sym_concatenation] = STATE(1794),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1794),
    [anon_sym_RBRACE] = ACTIONS(3699),
    [anon_sym_EQ] = ACTIONS(3701),
    [anon_sym_DASH] = ACTIONS(3701),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(3703),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(3705),
    [anon_sym_COLON] = ACTIONS(3701),
    [anon_sym_COLON_QMARK] = ACTIONS(3701),
    [anon_sym_COLON_DASH] = ACTIONS(3701),
    [anon_sym_PERCENT] = ACTIONS(3701),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1075] = {
    [sym_concatenation] = STATE(1797),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1797),
    [anon_sym_RBRACE] = ACTIONS(3707),
    [anon_sym_EQ] = ACTIONS(3709),
    [anon_sym_DASH] = ACTIONS(3709),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(3711),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(3713),
    [anon_sym_COLON] = ACTIONS(3709),
    [anon_sym_COLON_QMARK] = ACTIONS(3709),
    [anon_sym_COLON_DASH] = ACTIONS(3709),
    [anon_sym_PERCENT] = ACTIONS(3709),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1076] = {
    [anon_sym_RPAREN] = ACTIONS(3715),
    [sym_comment] = ACTIONS(57),
  },
  [1077] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(3715),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [1078] = {
    [anon_sym_BQUOTE] = ACTIONS(3715),
    [sym_comment] = ACTIONS(57),
  },
  [1079] = {
    [anon_sym_RPAREN] = ACTIONS(3717),
    [sym_comment] = ACTIONS(57),
  },
  [1080] = {
    [sym_variable_assignment] = STATE(1080),
    [sym_subscript] = STATE(473),
    [sym_concatenation] = STATE(1080),
    [sym_string] = STATE(468),
    [sym_simple_expansion] = STATE(468),
    [sym_string_expansion] = STATE(468),
    [sym_expansion] = STATE(468),
    [sym_command_substitution] = STATE(468),
    [sym_process_substitution] = STATE(468),
    [aux_sym_declaration_command_repeat1] = STATE(1080),
    [aux_sym__literal_repeat1] = STATE(475),
    [sym__simple_heredoc_body] = ACTIONS(2206),
    [sym__heredoc_body_beginning] = ACTIONS(2206),
    [sym_file_descriptor] = ACTIONS(2206),
    [sym_variable_name] = ACTIONS(3719),
    [anon_sym_SEMI] = ACTIONS(2211),
    [anon_sym_PIPE] = ACTIONS(2211),
    [anon_sym_SEMI_SEMI] = ACTIONS(2206),
    [anon_sym_RBRACE] = ACTIONS(2206),
    [anon_sym_PIPE_AMP] = ACTIONS(2206),
    [anon_sym_AMP_AMP] = ACTIONS(2206),
    [anon_sym_PIPE_PIPE] = ACTIONS(2206),
    [anon_sym_LT] = ACTIONS(2211),
    [anon_sym_GT] = ACTIONS(2211),
    [anon_sym_GT_GT] = ACTIONS(2206),
    [anon_sym_AMP_GT] = ACTIONS(2211),
    [anon_sym_AMP_GT_GT] = ACTIONS(2206),
    [anon_sym_LT_AMP] = ACTIONS(2206),
    [anon_sym_GT_AMP] = ACTIONS(2206),
    [anon_sym_LT_LT] = ACTIONS(2211),
    [anon_sym_LT_LT_DASH] = ACTIONS(2206),
    [anon_sym_LT_LT_LT] = ACTIONS(2206),
    [anon_sym_DOLLAR] = ACTIONS(3722),
    [sym__special_character] = ACTIONS(3725),
    [anon_sym_DQUOTE] = ACTIONS(3728),
    [sym_raw_string] = ACTIONS(3731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3734),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3737),
    [anon_sym_BQUOTE] = ACTIONS(3740),
    [anon_sym_LT_LPAREN] = ACTIONS(3743),
    [anon_sym_GT_LPAREN] = ACTIONS(3743),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3746),
    [sym_word] = ACTIONS(3749),
    [anon_sym_LF] = ACTIONS(2206),
    [anon_sym_AMP] = ACTIONS(2211),
  },
  [1081] = {
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym_variable_name] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_RBRACE] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(339),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [1082] = {
    [aux_sym__literal_repeat1] = STATE(1082),
    [sym__simple_heredoc_body] = ACTIONS(1373),
    [sym__heredoc_body_beginning] = ACTIONS(1373),
    [sym_file_descriptor] = ACTIONS(1373),
    [sym_variable_name] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_RBRACE] = ACTIONS(1373),
    [anon_sym_PIPE_AMP] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_LT_LT_DASH] = ACTIONS(1373),
    [anon_sym_LT_LT_LT] = ACTIONS(1373),
    [anon_sym_DOLLAR] = ACTIONS(1375),
    [sym__special_character] = ACTIONS(3752),
    [anon_sym_DQUOTE] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1373),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [anon_sym_LT_LPAREN] = ACTIONS(1373),
    [anon_sym_GT_LPAREN] = ACTIONS(1373),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1375),
    [sym_word] = ACTIONS(1375),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
  },
  [1083] = {
    [sym__simple_heredoc_body] = ACTIONS(1057),
    [sym__heredoc_body_beginning] = ACTIONS(1057),
    [sym_file_descriptor] = ACTIONS(1057),
    [sym__concat] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(1057),
    [anon_sym_PIPE_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_AMP] = ACTIONS(1057),
    [anon_sym_GT_AMP] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_LT] = ACTIONS(1057),
    [anon_sym_DOLLAR] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [sym_raw_string] = ACTIONS(1057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1057),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1057),
    [anon_sym_BQUOTE] = ACTIONS(1057),
    [anon_sym_LT_LPAREN] = ACTIONS(1057),
    [anon_sym_GT_LPAREN] = ACTIONS(1057),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1059),
    [sym_word] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [1084] = {
    [sym__simple_heredoc_body] = ACTIONS(1061),
    [sym__heredoc_body_beginning] = ACTIONS(1061),
    [sym_file_descriptor] = ACTIONS(1061),
    [sym__concat] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(1063),
    [anon_sym_PIPE] = ACTIONS(1063),
    [anon_sym_SEMI_SEMI] = ACTIONS(1061),
    [anon_sym_RBRACE] = ACTIONS(1061),
    [anon_sym_PIPE_AMP] = ACTIONS(1061),
    [anon_sym_AMP_AMP] = ACTIONS(1061),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1063),
    [anon_sym_GT_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT_GT] = ACTIONS(1061),
    [anon_sym_LT_AMP] = ACTIONS(1061),
    [anon_sym_GT_AMP] = ACTIONS(1061),
    [anon_sym_LT_LT] = ACTIONS(1063),
    [anon_sym_LT_LT_DASH] = ACTIONS(1061),
    [anon_sym_LT_LT_LT] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1061),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1061),
    [anon_sym_LT_LPAREN] = ACTIONS(1061),
    [anon_sym_GT_LPAREN] = ACTIONS(1061),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1063),
    [sym_word] = ACTIONS(1063),
    [anon_sym_LF] = ACTIONS(1061),
    [anon_sym_AMP] = ACTIONS(1063),
  },
  [1085] = {
    [sym__simple_heredoc_body] = ACTIONS(1065),
    [sym__heredoc_body_beginning] = ACTIONS(1065),
    [sym_file_descriptor] = ACTIONS(1065),
    [sym__concat] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1067),
    [anon_sym_SEMI_SEMI] = ACTIONS(1065),
    [anon_sym_RBRACE] = ACTIONS(1065),
    [anon_sym_PIPE_AMP] = ACTIONS(1065),
    [anon_sym_AMP_AMP] = ACTIONS(1065),
    [anon_sym_PIPE_PIPE] = ACTIONS(1065),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_GT] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT] = ACTIONS(1067),
    [anon_sym_AMP_GT_GT] = ACTIONS(1065),
    [anon_sym_LT_AMP] = ACTIONS(1065),
    [anon_sym_GT_AMP] = ACTIONS(1065),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_LT_LT_DASH] = ACTIONS(1065),
    [anon_sym_LT_LT_LT] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1067),
    [sym__special_character] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LT_LPAREN] = ACTIONS(1065),
    [anon_sym_GT_LPAREN] = ACTIONS(1065),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1067),
    [sym_word] = ACTIONS(1067),
    [anon_sym_LF] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1067),
  },
  [1086] = {
    [sym_string] = STATE(1800),
    [sym_simple_expansion] = STATE(1800),
    [sym_string_expansion] = STATE(1800),
    [sym_expansion] = STATE(1800),
    [sym_command_substitution] = STATE(1800),
    [sym_process_substitution] = STATE(1800),
    [anon_sym_DOLLAR] = ACTIONS(809),
    [sym__special_character] = ACTIONS(3755),
    [anon_sym_DQUOTE] = ACTIONS(813),
    [sym_raw_string] = ACTIONS(3755),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(817),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(819),
    [anon_sym_BQUOTE] = ACTIONS(821),
    [anon_sym_LT_LPAREN] = ACTIONS(823),
    [anon_sym_GT_LPAREN] = ACTIONS(823),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3755),
  },
  [1087] = {
    [aux_sym_concatenation_repeat1] = STATE(1802),
    [sym__simple_heredoc_body] = ACTIONS(1071),
    [sym__heredoc_body_beginning] = ACTIONS(1071),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(3757),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [sym__special_character] = ACTIONS(1075),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [sym_word] = ACTIONS(1075),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1075),
  },
  [1088] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(3759),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [1089] = {
    [sym__simple_heredoc_body] = ACTIONS(1089),
    [sym__heredoc_body_beginning] = ACTIONS(1089),
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(1089),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_PIPE_AMP] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_AMP] = ACTIONS(1089),
    [anon_sym_GT_AMP] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1089),
    [anon_sym_LT_LT_LT] = ACTIONS(1089),
    [anon_sym_DOLLAR] = ACTIONS(1091),
    [sym__special_character] = ACTIONS(1091),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1089),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1089),
    [anon_sym_GT_LPAREN] = ACTIONS(1089),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1091),
    [sym_word] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [1090] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(627),
    [anon_sym_DOLLAR] = ACTIONS(3761),
    [anon_sym_DQUOTE] = ACTIONS(3759),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [1091] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(3763),
    [sym_comment] = ACTIONS(57),
  },
  [1092] = {
    [sym_subscript] = STATE(1808),
    [sym_variable_name] = ACTIONS(3765),
    [anon_sym_DASH] = ACTIONS(3767),
    [anon_sym_DOLLAR] = ACTIONS(3767),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3771),
    [anon_sym_AT] = ACTIONS(3771),
    [anon_sym_QMARK] = ACTIONS(3771),
    [anon_sym_0] = ACTIONS(3769),
    [anon_sym__] = ACTIONS(3769),
  },
  [1093] = {
    [sym_concatenation] = STATE(1811),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1811),
    [anon_sym_RBRACE] = ACTIONS(3773),
    [anon_sym_EQ] = ACTIONS(3775),
    [anon_sym_DASH] = ACTIONS(3775),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(3777),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(3779),
    [anon_sym_COLON] = ACTIONS(3775),
    [anon_sym_COLON_QMARK] = ACTIONS(3775),
    [anon_sym_COLON_DASH] = ACTIONS(3775),
    [anon_sym_PERCENT] = ACTIONS(3775),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1094] = {
    [sym_concatenation] = STATE(1814),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1814),
    [anon_sym_RBRACE] = ACTIONS(3781),
    [anon_sym_EQ] = ACTIONS(3783),
    [anon_sym_DASH] = ACTIONS(3783),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(3785),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(3787),
    [anon_sym_COLON] = ACTIONS(3783),
    [anon_sym_COLON_QMARK] = ACTIONS(3783),
    [anon_sym_COLON_DASH] = ACTIONS(3783),
    [anon_sym_PERCENT] = ACTIONS(3783),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1095] = {
    [anon_sym_RPAREN] = ACTIONS(3789),
    [sym_comment] = ACTIONS(57),
  },
  [1096] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(3789),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [1097] = {
    [anon_sym_BQUOTE] = ACTIONS(3789),
    [sym_comment] = ACTIONS(57),
  },
  [1098] = {
    [anon_sym_RPAREN] = ACTIONS(3791),
    [sym_comment] = ACTIONS(57),
  },
  [1099] = {
    [sym_concatenation] = STATE(1099),
    [sym_string] = STATE(479),
    [sym_simple_expansion] = STATE(479),
    [sym_string_expansion] = STATE(479),
    [sym_expansion] = STATE(479),
    [sym_command_substitution] = STATE(479),
    [sym_process_substitution] = STATE(479),
    [aux_sym_unset_command_repeat1] = STATE(1099),
    [aux_sym__literal_repeat1] = STATE(485),
    [sym__simple_heredoc_body] = ACTIONS(2284),
    [sym__heredoc_body_beginning] = ACTIONS(2284),
    [sym_file_descriptor] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym_PIPE] = ACTIONS(2286),
    [anon_sym_SEMI_SEMI] = ACTIONS(2284),
    [anon_sym_RBRACE] = ACTIONS(2284),
    [anon_sym_PIPE_AMP] = ACTIONS(2284),
    [anon_sym_AMP_AMP] = ACTIONS(2284),
    [anon_sym_PIPE_PIPE] = ACTIONS(2284),
    [anon_sym_LT] = ACTIONS(2286),
    [anon_sym_GT] = ACTIONS(2286),
    [anon_sym_GT_GT] = ACTIONS(2284),
    [anon_sym_AMP_GT] = ACTIONS(2286),
    [anon_sym_AMP_GT_GT] = ACTIONS(2284),
    [anon_sym_LT_AMP] = ACTIONS(2284),
    [anon_sym_GT_AMP] = ACTIONS(2284),
    [anon_sym_LT_LT] = ACTIONS(2286),
    [anon_sym_LT_LT_DASH] = ACTIONS(2284),
    [anon_sym_LT_LT_LT] = ACTIONS(2284),
    [anon_sym_DOLLAR] = ACTIONS(3793),
    [sym__special_character] = ACTIONS(3796),
    [anon_sym_DQUOTE] = ACTIONS(3799),
    [sym_raw_string] = ACTIONS(3802),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3805),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3808),
    [anon_sym_BQUOTE] = ACTIONS(3811),
    [anon_sym_LT_LPAREN] = ACTIONS(3814),
    [anon_sym_GT_LPAREN] = ACTIONS(3814),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3817),
    [sym_word] = ACTIONS(3820),
    [anon_sym_LF] = ACTIONS(2284),
    [anon_sym_AMP] = ACTIONS(2286),
  },
  [1100] = {
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_RBRACE] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(339),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [1101] = {
    [aux_sym__literal_repeat1] = STATE(1101),
    [sym__simple_heredoc_body] = ACTIONS(1373),
    [sym__heredoc_body_beginning] = ACTIONS(1373),
    [sym_file_descriptor] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_RBRACE] = ACTIONS(1373),
    [anon_sym_PIPE_AMP] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_LT_LT_DASH] = ACTIONS(1373),
    [anon_sym_LT_LT_LT] = ACTIONS(1373),
    [anon_sym_DOLLAR] = ACTIONS(1375),
    [sym__special_character] = ACTIONS(3823),
    [anon_sym_DQUOTE] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1373),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [anon_sym_LT_LPAREN] = ACTIONS(1373),
    [anon_sym_GT_LPAREN] = ACTIONS(1373),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1375),
    [sym_word] = ACTIONS(1375),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
  },
  [1102] = {
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_RBRACE] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_EQ_TILDE] = ACTIONS(2364),
    [anon_sym_EQ_EQ] = ACTIONS(2364),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2364),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [1103] = {
    [sym_string] = STATE(1102),
    [sym_simple_expansion] = STATE(1102),
    [sym_string_expansion] = STATE(1102),
    [sym_expansion] = STATE(1102),
    [sym_command_substitution] = STATE(1102),
    [sym_process_substitution] = STATE(1102),
    [anon_sym_DOLLAR] = ACTIONS(3826),
    [sym__special_character] = ACTIONS(2033),
    [anon_sym_DQUOTE] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(2033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2033),
  },
  [1104] = {
    [aux_sym_concatenation_repeat1] = STATE(1104),
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(3828),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_RBRACE] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_EQ_TILDE] = ACTIONS(2364),
    [anon_sym_EQ_EQ] = ACTIONS(2364),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2364),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [1105] = {
    [sym__simple_heredoc_body] = ACTIONS(2371),
    [sym__heredoc_body_beginning] = ACTIONS(2371),
    [sym_file_descriptor] = ACTIONS(2371),
    [sym__concat] = ACTIONS(2371),
    [anon_sym_SEMI] = ACTIONS(2373),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_SEMI_SEMI] = ACTIONS(2371),
    [anon_sym_RBRACE] = ACTIONS(2371),
    [anon_sym_PIPE_AMP] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_EQ_TILDE] = ACTIONS(2373),
    [anon_sym_EQ_EQ] = ACTIONS(2373),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_GT_GT] = ACTIONS(2371),
    [anon_sym_AMP_GT] = ACTIONS(2373),
    [anon_sym_AMP_GT_GT] = ACTIONS(2371),
    [anon_sym_LT_AMP] = ACTIONS(2371),
    [anon_sym_GT_AMP] = ACTIONS(2371),
    [anon_sym_LT_LT] = ACTIONS(2373),
    [anon_sym_LT_LT_DASH] = ACTIONS(2371),
    [anon_sym_LT_LT_LT] = ACTIONS(2371),
    [anon_sym_DOLLAR] = ACTIONS(2373),
    [sym__special_character] = ACTIONS(2373),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [sym_raw_string] = ACTIONS(2371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2371),
    [anon_sym_BQUOTE] = ACTIONS(2371),
    [anon_sym_LT_LPAREN] = ACTIONS(2371),
    [anon_sym_GT_LPAREN] = ACTIONS(2371),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2373),
    [anon_sym_LF] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
  },
  [1106] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(3831),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [1107] = {
    [sym_concatenation] = STATE(1821),
    [sym_string] = STATE(1820),
    [sym_simple_expansion] = STATE(1820),
    [sym_string_expansion] = STATE(1820),
    [sym_expansion] = STATE(1820),
    [sym_command_substitution] = STATE(1820),
    [sym_process_substitution] = STATE(1820),
    [aux_sym__literal_repeat1] = STATE(1822),
    [anon_sym_RBRACE] = ACTIONS(3833),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(3835),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3835),
  },
  [1108] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(3837),
    [sym_comment] = ACTIONS(57),
  },
  [1109] = {
    [sym_concatenation] = STATE(1826),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1826),
    [anon_sym_RBRACE] = ACTIONS(3839),
    [anon_sym_EQ] = ACTIONS(3841),
    [anon_sym_DASH] = ACTIONS(3841),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(3843),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(3845),
    [anon_sym_COLON] = ACTIONS(3841),
    [anon_sym_COLON_QMARK] = ACTIONS(3841),
    [anon_sym_COLON_DASH] = ACTIONS(3841),
    [anon_sym_PERCENT] = ACTIONS(3841),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1110] = {
    [sym_concatenation] = STATE(1828),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1828),
    [anon_sym_RBRACE] = ACTIONS(3833),
    [anon_sym_EQ] = ACTIONS(3847),
    [anon_sym_DASH] = ACTIONS(3847),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(3849),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(3851),
    [anon_sym_COLON] = ACTIONS(3847),
    [anon_sym_COLON_QMARK] = ACTIONS(3847),
    [anon_sym_COLON_DASH] = ACTIONS(3847),
    [anon_sym_PERCENT] = ACTIONS(3847),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1111] = {
    [sym__simple_heredoc_body] = ACTIONS(2462),
    [sym__heredoc_body_beginning] = ACTIONS(2462),
    [sym_file_descriptor] = ACTIONS(2462),
    [sym__concat] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_SEMI_SEMI] = ACTIONS(2462),
    [anon_sym_RBRACE] = ACTIONS(2462),
    [anon_sym_PIPE_AMP] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_EQ_TILDE] = ACTIONS(2464),
    [anon_sym_EQ_EQ] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_GT_GT] = ACTIONS(2462),
    [anon_sym_AMP_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT_GT] = ACTIONS(2462),
    [anon_sym_LT_AMP] = ACTIONS(2462),
    [anon_sym_GT_AMP] = ACTIONS(2462),
    [anon_sym_LT_LT] = ACTIONS(2464),
    [anon_sym_LT_LT_DASH] = ACTIONS(2462),
    [anon_sym_LT_LT_LT] = ACTIONS(2462),
    [anon_sym_DOLLAR] = ACTIONS(2464),
    [sym__special_character] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [sym_raw_string] = ACTIONS(2462),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2462),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2462),
    [anon_sym_BQUOTE] = ACTIONS(2462),
    [anon_sym_LT_LPAREN] = ACTIONS(2462),
    [anon_sym_GT_LPAREN] = ACTIONS(2462),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2464),
    [anon_sym_LF] = ACTIONS(2462),
    [anon_sym_AMP] = ACTIONS(2464),
  },
  [1112] = {
    [sym_concatenation] = STATE(1831),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1831),
    [sym_regex] = ACTIONS(3853),
    [anon_sym_RBRACE] = ACTIONS(3855),
    [anon_sym_EQ] = ACTIONS(3857),
    [anon_sym_DASH] = ACTIONS(3857),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(3859),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(3857),
    [anon_sym_COLON_QMARK] = ACTIONS(3857),
    [anon_sym_COLON_DASH] = ACTIONS(3857),
    [anon_sym_PERCENT] = ACTIONS(3857),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1113] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(3855),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1114] = {
    [sym__simple_heredoc_body] = ACTIONS(2512),
    [sym__heredoc_body_beginning] = ACTIONS(2512),
    [sym_file_descriptor] = ACTIONS(2512),
    [sym__concat] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2514),
    [anon_sym_PIPE] = ACTIONS(2514),
    [anon_sym_SEMI_SEMI] = ACTIONS(2512),
    [anon_sym_RBRACE] = ACTIONS(2512),
    [anon_sym_PIPE_AMP] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE_PIPE] = ACTIONS(2512),
    [anon_sym_EQ_TILDE] = ACTIONS(2514),
    [anon_sym_EQ_EQ] = ACTIONS(2514),
    [anon_sym_LT] = ACTIONS(2514),
    [anon_sym_GT] = ACTIONS(2514),
    [anon_sym_GT_GT] = ACTIONS(2512),
    [anon_sym_AMP_GT] = ACTIONS(2514),
    [anon_sym_AMP_GT_GT] = ACTIONS(2512),
    [anon_sym_LT_AMP] = ACTIONS(2512),
    [anon_sym_GT_AMP] = ACTIONS(2512),
    [anon_sym_LT_LT] = ACTIONS(2514),
    [anon_sym_LT_LT_DASH] = ACTIONS(2512),
    [anon_sym_LT_LT_LT] = ACTIONS(2512),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [sym__special_character] = ACTIONS(2514),
    [anon_sym_DQUOTE] = ACTIONS(2512),
    [sym_raw_string] = ACTIONS(2512),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2512),
    [anon_sym_BQUOTE] = ACTIONS(2512),
    [anon_sym_LT_LPAREN] = ACTIONS(2512),
    [anon_sym_GT_LPAREN] = ACTIONS(2512),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2514),
    [anon_sym_LF] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2514),
  },
  [1115] = {
    [sym_concatenation] = STATE(1828),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1828),
    [sym_regex] = ACTIONS(3861),
    [anon_sym_RBRACE] = ACTIONS(3833),
    [anon_sym_EQ] = ACTIONS(3847),
    [anon_sym_DASH] = ACTIONS(3847),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(3849),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(3847),
    [anon_sym_COLON_QMARK] = ACTIONS(3847),
    [anon_sym_COLON_DASH] = ACTIONS(3847),
    [anon_sym_PERCENT] = ACTIONS(3847),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1116] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(3833),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1117] = {
    [sym__simple_heredoc_body] = ACTIONS(2520),
    [sym__heredoc_body_beginning] = ACTIONS(2520),
    [sym_file_descriptor] = ACTIONS(2520),
    [sym__concat] = ACTIONS(2520),
    [anon_sym_SEMI] = ACTIONS(2522),
    [anon_sym_PIPE] = ACTIONS(2522),
    [anon_sym_SEMI_SEMI] = ACTIONS(2520),
    [anon_sym_RBRACE] = ACTIONS(2520),
    [anon_sym_PIPE_AMP] = ACTIONS(2520),
    [anon_sym_AMP_AMP] = ACTIONS(2520),
    [anon_sym_PIPE_PIPE] = ACTIONS(2520),
    [anon_sym_EQ_TILDE] = ACTIONS(2522),
    [anon_sym_EQ_EQ] = ACTIONS(2522),
    [anon_sym_LT] = ACTIONS(2522),
    [anon_sym_GT] = ACTIONS(2522),
    [anon_sym_GT_GT] = ACTIONS(2520),
    [anon_sym_AMP_GT] = ACTIONS(2522),
    [anon_sym_AMP_GT_GT] = ACTIONS(2520),
    [anon_sym_LT_AMP] = ACTIONS(2520),
    [anon_sym_GT_AMP] = ACTIONS(2520),
    [anon_sym_LT_LT] = ACTIONS(2522),
    [anon_sym_LT_LT_DASH] = ACTIONS(2520),
    [anon_sym_LT_LT_LT] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(2522),
    [sym__special_character] = ACTIONS(2522),
    [anon_sym_DQUOTE] = ACTIONS(2520),
    [sym_raw_string] = ACTIONS(2520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2520),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2520),
    [anon_sym_BQUOTE] = ACTIONS(2520),
    [anon_sym_LT_LPAREN] = ACTIONS(2520),
    [anon_sym_GT_LPAREN] = ACTIONS(2520),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2522),
    [anon_sym_LF] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2522),
  },
  [1118] = {
    [sym__simple_heredoc_body] = ACTIONS(2554),
    [sym__heredoc_body_beginning] = ACTIONS(2554),
    [sym_file_descriptor] = ACTIONS(2554),
    [sym__concat] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(2556),
    [anon_sym_PIPE] = ACTIONS(2556),
    [anon_sym_SEMI_SEMI] = ACTIONS(2554),
    [anon_sym_RBRACE] = ACTIONS(2554),
    [anon_sym_PIPE_AMP] = ACTIONS(2554),
    [anon_sym_AMP_AMP] = ACTIONS(2554),
    [anon_sym_PIPE_PIPE] = ACTIONS(2554),
    [anon_sym_EQ_TILDE] = ACTIONS(2556),
    [anon_sym_EQ_EQ] = ACTIONS(2556),
    [anon_sym_LT] = ACTIONS(2556),
    [anon_sym_GT] = ACTIONS(2556),
    [anon_sym_GT_GT] = ACTIONS(2554),
    [anon_sym_AMP_GT] = ACTIONS(2556),
    [anon_sym_AMP_GT_GT] = ACTIONS(2554),
    [anon_sym_LT_AMP] = ACTIONS(2554),
    [anon_sym_GT_AMP] = ACTIONS(2554),
    [anon_sym_LT_LT] = ACTIONS(2556),
    [anon_sym_LT_LT_DASH] = ACTIONS(2554),
    [anon_sym_LT_LT_LT] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2556),
    [sym__special_character] = ACTIONS(2556),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2554),
    [anon_sym_BQUOTE] = ACTIONS(2554),
    [anon_sym_LT_LPAREN] = ACTIONS(2554),
    [anon_sym_GT_LPAREN] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2556),
    [anon_sym_LF] = ACTIONS(2554),
    [anon_sym_AMP] = ACTIONS(2556),
  },
  [1119] = {
    [sym_compound_statement] = STATE(1833),
    [anon_sym_LBRACE] = ACTIONS(191),
    [sym_comment] = ACTIONS(57),
  },
  [1120] = {
    [anon_sym_SEMI] = ACTIONS(2560),
    [anon_sym_SEMI_SEMI] = ACTIONS(2558),
    [anon_sym_RBRACE] = ACTIONS(2558),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2558),
    [anon_sym_AMP] = ACTIONS(2558),
  },
  [1121] = {
    [sym_simple_expansion] = STATE(1326),
    [sym_expansion] = STATE(1326),
    [sym_command_substitution] = STATE(1326),
    [aux_sym_heredoc_body_repeat1] = STATE(1326),
    [sym__heredoc_body_middle] = ACTIONS(2578),
    [sym__heredoc_body_end] = ACTIONS(3863),
    [anon_sym_DOLLAR] = ACTIONS(1225),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1227),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1229),
    [anon_sym_BQUOTE] = ACTIONS(1231),
    [sym_comment] = ACTIONS(57),
  },
  [1122] = {
    [sym_concatenation] = STATE(1836),
    [sym_string] = STATE(1835),
    [sym_simple_expansion] = STATE(1835),
    [sym_string_expansion] = STATE(1835),
    [sym_expansion] = STATE(1835),
    [sym_command_substitution] = STATE(1835),
    [sym_process_substitution] = STATE(1835),
    [aux_sym__literal_repeat1] = STATE(1837),
    [anon_sym_DOLLAR] = ACTIONS(205),
    [sym__special_character] = ACTIONS(2085),
    [anon_sym_DQUOTE] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(3865),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3865),
  },
  [1123] = {
    [sym_file_redirect] = STATE(514),
    [sym_heredoc_redirect] = STATE(514),
    [sym_herestring_redirect] = STATE(514),
    [aux_sym_redirected_statement_repeat1] = STATE(514),
    [sym__simple_heredoc_body] = ACTIONS(2584),
    [sym__heredoc_body_beginning] = ACTIONS(2584),
    [sym_file_descriptor] = ACTIONS(2584),
    [anon_sym_SEMI] = ACTIONS(2586),
    [anon_sym_PIPE] = ACTIONS(2586),
    [anon_sym_SEMI_SEMI] = ACTIONS(2584),
    [anon_sym_RBRACE] = ACTIONS(2584),
    [anon_sym_PIPE_AMP] = ACTIONS(2584),
    [anon_sym_AMP_AMP] = ACTIONS(2584),
    [anon_sym_PIPE_PIPE] = ACTIONS(2584),
    [anon_sym_LT] = ACTIONS(2586),
    [anon_sym_GT] = ACTIONS(2586),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT] = ACTIONS(2586),
    [anon_sym_AMP_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_AMP] = ACTIONS(2584),
    [anon_sym_GT_AMP] = ACTIONS(2584),
    [anon_sym_LT_LT] = ACTIONS(2586),
    [anon_sym_LT_LT_DASH] = ACTIONS(2584),
    [anon_sym_LT_LT_LT] = ACTIONS(2584),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2584),
    [anon_sym_AMP] = ACTIONS(2586),
  },
  [1124] = {
    [sym_file_redirect] = STATE(514),
    [sym_heredoc_redirect] = STATE(514),
    [sym_herestring_redirect] = STATE(514),
    [aux_sym_redirected_statement_repeat1] = STATE(514),
    [sym__simple_heredoc_body] = ACTIONS(2584),
    [sym__heredoc_body_beginning] = ACTIONS(2584),
    [sym_file_descriptor] = ACTIONS(2584),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2586),
    [anon_sym_PIPE] = ACTIONS(2586),
    [anon_sym_SEMI_SEMI] = ACTIONS(2584),
    [anon_sym_RBRACE] = ACTIONS(2584),
    [anon_sym_PIPE_AMP] = ACTIONS(2584),
    [anon_sym_AMP_AMP] = ACTIONS(2584),
    [anon_sym_PIPE_PIPE] = ACTIONS(2584),
    [anon_sym_LT] = ACTIONS(2586),
    [anon_sym_GT] = ACTIONS(2586),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT] = ACTIONS(2586),
    [anon_sym_AMP_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_AMP] = ACTIONS(2584),
    [anon_sym_GT_AMP] = ACTIONS(2584),
    [anon_sym_LT_LT] = ACTIONS(2586),
    [anon_sym_LT_LT_DASH] = ACTIONS(2584),
    [anon_sym_LT_LT_LT] = ACTIONS(2584),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(435),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2584),
    [anon_sym_AMP] = ACTIONS(2586),
  },
  [1125] = {
    [sym_file_redirect] = STATE(514),
    [sym_heredoc_redirect] = STATE(514),
    [sym_herestring_redirect] = STATE(514),
    [aux_sym_redirected_statement_repeat1] = STATE(514),
    [sym__simple_heredoc_body] = ACTIONS(2588),
    [sym__heredoc_body_beginning] = ACTIONS(2588),
    [sym_file_descriptor] = ACTIONS(2588),
    [anon_sym_SEMI] = ACTIONS(2590),
    [anon_sym_PIPE] = ACTIONS(865),
    [anon_sym_SEMI_SEMI] = ACTIONS(2588),
    [anon_sym_RBRACE] = ACTIONS(2588),
    [anon_sym_PIPE_AMP] = ACTIONS(869),
    [anon_sym_AMP_AMP] = ACTIONS(2588),
    [anon_sym_PIPE_PIPE] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(2590),
    [anon_sym_GT] = ACTIONS(2590),
    [anon_sym_GT_GT] = ACTIONS(2588),
    [anon_sym_AMP_GT] = ACTIONS(2590),
    [anon_sym_AMP_GT_GT] = ACTIONS(2588),
    [anon_sym_LT_AMP] = ACTIONS(2588),
    [anon_sym_GT_AMP] = ACTIONS(2588),
    [anon_sym_LT_LT] = ACTIONS(2590),
    [anon_sym_LT_LT_DASH] = ACTIONS(2588),
    [anon_sym_LT_LT_LT] = ACTIONS(2588),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2588),
    [anon_sym_AMP] = ACTIONS(2590),
  },
  [1126] = {
    [sym_file_redirect] = STATE(514),
    [sym_heredoc_redirect] = STATE(514),
    [sym_herestring_redirect] = STATE(514),
    [aux_sym_redirected_statement_repeat1] = STATE(514),
    [sym__simple_heredoc_body] = ACTIONS(2588),
    [sym__heredoc_body_beginning] = ACTIONS(2588),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2590),
    [anon_sym_PIPE] = ACTIONS(865),
    [anon_sym_SEMI_SEMI] = ACTIONS(2588),
    [anon_sym_RBRACE] = ACTIONS(2588),
    [anon_sym_PIPE_AMP] = ACTIONS(869),
    [anon_sym_AMP_AMP] = ACTIONS(2588),
    [anon_sym_PIPE_PIPE] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(2590),
    [anon_sym_LT_LT_DASH] = ACTIONS(2588),
    [anon_sym_LT_LT_LT] = ACTIONS(2588),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(435),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2588),
    [anon_sym_AMP] = ACTIONS(2590),
  },
  [1127] = {
    [aux_sym_concatenation_repeat1] = STATE(1838),
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(837),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_RBRACE] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [sym__special_character] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [1128] = {
    [aux_sym_concatenation_repeat1] = STATE(1838),
    [sym__simple_heredoc_body] = ACTIONS(1037),
    [sym__heredoc_body_beginning] = ACTIONS(1037),
    [sym_file_descriptor] = ACTIONS(1037),
    [sym__concat] = ACTIONS(837),
    [anon_sym_SEMI] = ACTIONS(1039),
    [anon_sym_PIPE] = ACTIONS(1039),
    [anon_sym_SEMI_SEMI] = ACTIONS(1037),
    [anon_sym_RBRACE] = ACTIONS(1037),
    [anon_sym_PIPE_AMP] = ACTIONS(1037),
    [anon_sym_AMP_AMP] = ACTIONS(1037),
    [anon_sym_PIPE_PIPE] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1039),
    [anon_sym_GT] = ACTIONS(1039),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_AMP_GT] = ACTIONS(1039),
    [anon_sym_AMP_GT_GT] = ACTIONS(1037),
    [anon_sym_LT_AMP] = ACTIONS(1037),
    [anon_sym_GT_AMP] = ACTIONS(1037),
    [anon_sym_LT_LT] = ACTIONS(1039),
    [anon_sym_LT_LT_DASH] = ACTIONS(1037),
    [anon_sym_LT_LT_LT] = ACTIONS(1037),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1037),
    [anon_sym_AMP] = ACTIONS(1039),
  },
  [1129] = {
    [sym__simple_heredoc_body] = ACTIONS(1037),
    [sym__heredoc_body_beginning] = ACTIONS(1037),
    [sym_file_descriptor] = ACTIONS(1037),
    [anon_sym_SEMI] = ACTIONS(1039),
    [anon_sym_PIPE] = ACTIONS(1039),
    [anon_sym_SEMI_SEMI] = ACTIONS(1037),
    [anon_sym_RBRACE] = ACTIONS(1037),
    [anon_sym_PIPE_AMP] = ACTIONS(1037),
    [anon_sym_AMP_AMP] = ACTIONS(1037),
    [anon_sym_PIPE_PIPE] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1039),
    [anon_sym_GT] = ACTIONS(1039),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_AMP_GT] = ACTIONS(1039),
    [anon_sym_AMP_GT_GT] = ACTIONS(1037),
    [anon_sym_LT_AMP] = ACTIONS(1037),
    [anon_sym_GT_AMP] = ACTIONS(1037),
    [anon_sym_LT_LT] = ACTIONS(1039),
    [anon_sym_LT_LT_DASH] = ACTIONS(1037),
    [anon_sym_LT_LT_LT] = ACTIONS(1037),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1037),
    [anon_sym_AMP] = ACTIONS(1039),
  },
  [1130] = {
    [aux_sym__literal_repeat1] = STATE(1839),
    [sym__simple_heredoc_body] = ACTIONS(1051),
    [sym__heredoc_body_beginning] = ACTIONS(1051),
    [sym_file_descriptor] = ACTIONS(1051),
    [anon_sym_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE] = ACTIONS(1053),
    [anon_sym_SEMI_SEMI] = ACTIONS(1051),
    [anon_sym_RBRACE] = ACTIONS(1051),
    [anon_sym_PIPE_AMP] = ACTIONS(1051),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_PIPE_PIPE] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT_GT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1051),
    [anon_sym_GT_AMP] = ACTIONS(1051),
    [anon_sym_LT_LT] = ACTIONS(1053),
    [anon_sym_LT_LT_DASH] = ACTIONS(1051),
    [anon_sym_LT_LT_LT] = ACTIONS(1051),
    [sym__special_character] = ACTIONS(891),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1051),
    [anon_sym_AMP] = ACTIONS(1053),
  },
  [1131] = {
    [sym__simple_heredoc_body] = ACTIONS(2592),
    [sym__heredoc_body_beginning] = ACTIONS(2592),
    [sym_file_descriptor] = ACTIONS(2592),
    [anon_sym_SEMI] = ACTIONS(2594),
    [anon_sym_PIPE] = ACTIONS(2594),
    [anon_sym_SEMI_SEMI] = ACTIONS(2592),
    [anon_sym_RBRACE] = ACTIONS(2592),
    [anon_sym_PIPE_AMP] = ACTIONS(2592),
    [anon_sym_AMP_AMP] = ACTIONS(2592),
    [anon_sym_PIPE_PIPE] = ACTIONS(2592),
    [anon_sym_LT] = ACTIONS(2594),
    [anon_sym_GT] = ACTIONS(2594),
    [anon_sym_GT_GT] = ACTIONS(2592),
    [anon_sym_AMP_GT] = ACTIONS(2594),
    [anon_sym_AMP_GT_GT] = ACTIONS(2592),
    [anon_sym_LT_AMP] = ACTIONS(2592),
    [anon_sym_GT_AMP] = ACTIONS(2592),
    [anon_sym_LT_LT] = ACTIONS(2594),
    [anon_sym_LT_LT_DASH] = ACTIONS(2592),
    [anon_sym_LT_LT_LT] = ACTIONS(2592),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2592),
    [anon_sym_AMP] = ACTIONS(2594),
  },
  [1132] = {
    [aux_sym_concatenation_repeat1] = STATE(1838),
    [sym__simple_heredoc_body] = ACTIONS(2596),
    [sym__heredoc_body_beginning] = ACTIONS(2596),
    [sym_file_descriptor] = ACTIONS(2596),
    [sym__concat] = ACTIONS(837),
    [anon_sym_SEMI] = ACTIONS(2598),
    [anon_sym_PIPE] = ACTIONS(2598),
    [anon_sym_SEMI_SEMI] = ACTIONS(2596),
    [anon_sym_RBRACE] = ACTIONS(2596),
    [anon_sym_PIPE_AMP] = ACTIONS(2596),
    [anon_sym_AMP_AMP] = ACTIONS(2596),
    [anon_sym_PIPE_PIPE] = ACTIONS(2596),
    [anon_sym_LT] = ACTIONS(2598),
    [anon_sym_GT] = ACTIONS(2598),
    [anon_sym_GT_GT] = ACTIONS(2596),
    [anon_sym_AMP_GT] = ACTIONS(2598),
    [anon_sym_AMP_GT_GT] = ACTIONS(2596),
    [anon_sym_LT_AMP] = ACTIONS(2596),
    [anon_sym_GT_AMP] = ACTIONS(2596),
    [anon_sym_LT_LT] = ACTIONS(2598),
    [anon_sym_LT_LT_DASH] = ACTIONS(2596),
    [anon_sym_LT_LT_LT] = ACTIONS(2596),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2596),
    [anon_sym_AMP] = ACTIONS(2598),
  },
  [1133] = {
    [sym__simple_heredoc_body] = ACTIONS(2596),
    [sym__heredoc_body_beginning] = ACTIONS(2596),
    [sym_file_descriptor] = ACTIONS(2596),
    [anon_sym_SEMI] = ACTIONS(2598),
    [anon_sym_PIPE] = ACTIONS(2598),
    [anon_sym_SEMI_SEMI] = ACTIONS(2596),
    [anon_sym_RBRACE] = ACTIONS(2596),
    [anon_sym_PIPE_AMP] = ACTIONS(2596),
    [anon_sym_AMP_AMP] = ACTIONS(2596),
    [anon_sym_PIPE_PIPE] = ACTIONS(2596),
    [anon_sym_LT] = ACTIONS(2598),
    [anon_sym_GT] = ACTIONS(2598),
    [anon_sym_GT_GT] = ACTIONS(2596),
    [anon_sym_AMP_GT] = ACTIONS(2598),
    [anon_sym_AMP_GT_GT] = ACTIONS(2596),
    [anon_sym_LT_AMP] = ACTIONS(2596),
    [anon_sym_GT_AMP] = ACTIONS(2596),
    [anon_sym_LT_LT] = ACTIONS(2598),
    [anon_sym_LT_LT_DASH] = ACTIONS(2596),
    [anon_sym_LT_LT_LT] = ACTIONS(2596),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2596),
    [anon_sym_AMP] = ACTIONS(2598),
  },
  [1134] = {
    [aux_sym__literal_repeat1] = STATE(1839),
    [sym__simple_heredoc_body] = ACTIONS(2600),
    [sym__heredoc_body_beginning] = ACTIONS(2600),
    [sym_file_descriptor] = ACTIONS(2600),
    [anon_sym_SEMI] = ACTIONS(2602),
    [anon_sym_PIPE] = ACTIONS(2602),
    [anon_sym_SEMI_SEMI] = ACTIONS(2600),
    [anon_sym_RBRACE] = ACTIONS(2600),
    [anon_sym_PIPE_AMP] = ACTIONS(2600),
    [anon_sym_AMP_AMP] = ACTIONS(2600),
    [anon_sym_PIPE_PIPE] = ACTIONS(2600),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_GT_GT] = ACTIONS(2600),
    [anon_sym_AMP_GT] = ACTIONS(2602),
    [anon_sym_AMP_GT_GT] = ACTIONS(2600),
    [anon_sym_LT_AMP] = ACTIONS(2600),
    [anon_sym_GT_AMP] = ACTIONS(2600),
    [anon_sym_LT_LT] = ACTIONS(2602),
    [anon_sym_LT_LT_DASH] = ACTIONS(2600),
    [anon_sym_LT_LT_LT] = ACTIONS(2600),
    [sym__special_character] = ACTIONS(891),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2600),
    [anon_sym_AMP] = ACTIONS(2602),
  },
  [1135] = {
    [sym_file_descriptor] = ACTIONS(2604),
    [sym_variable_name] = ACTIONS(2604),
    [anon_sym_for] = ACTIONS(2608),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2608),
    [anon_sym_if] = ACTIONS(2608),
    [anon_sym_case] = ACTIONS(2608),
    [anon_sym_function] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(2608),
    [anon_sym_LBRACE] = ACTIONS(2604),
    [anon_sym_RBRACE] = ACTIONS(2606),
    [anon_sym_BANG] = ACTIONS(2608),
    [anon_sym_LBRACK] = ACTIONS(2608),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2604),
    [anon_sym_declare] = ACTIONS(2608),
    [anon_sym_typeset] = ACTIONS(2608),
    [anon_sym_export] = ACTIONS(2608),
    [anon_sym_readonly] = ACTIONS(2608),
    [anon_sym_local] = ACTIONS(2608),
    [anon_sym_unset] = ACTIONS(2608),
    [anon_sym_unsetenv] = ACTIONS(2608),
    [anon_sym_LT] = ACTIONS(2608),
    [anon_sym_GT] = ACTIONS(2608),
    [anon_sym_GT_GT] = ACTIONS(2604),
    [anon_sym_AMP_GT] = ACTIONS(2608),
    [anon_sym_AMP_GT_GT] = ACTIONS(2604),
    [anon_sym_LT_AMP] = ACTIONS(2604),
    [anon_sym_GT_AMP] = ACTIONS(2604),
    [anon_sym_DOLLAR] = ACTIONS(2608),
    [sym__special_character] = ACTIONS(2608),
    [anon_sym_DQUOTE] = ACTIONS(2604),
    [sym_raw_string] = ACTIONS(2604),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2604),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2604),
    [anon_sym_BQUOTE] = ACTIONS(2604),
    [anon_sym_LT_LPAREN] = ACTIONS(2604),
    [anon_sym_GT_LPAREN] = ACTIONS(2604),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2608),
  },
  [1136] = {
    [sym_file_redirect] = STATE(1136),
    [sym_heredoc_redirect] = STATE(1136),
    [sym_herestring_redirect] = STATE(1136),
    [aux_sym_redirected_statement_repeat1] = STATE(1136),
    [sym__simple_heredoc_body] = ACTIONS(2610),
    [sym__heredoc_body_beginning] = ACTIONS(2610),
    [sym_file_descriptor] = ACTIONS(3867),
    [anon_sym_SEMI] = ACTIONS(2615),
    [anon_sym_PIPE] = ACTIONS(2615),
    [anon_sym_SEMI_SEMI] = ACTIONS(2610),
    [anon_sym_RBRACE] = ACTIONS(2610),
    [anon_sym_PIPE_AMP] = ACTIONS(2610),
    [anon_sym_AMP_AMP] = ACTIONS(2610),
    [anon_sym_PIPE_PIPE] = ACTIONS(2610),
    [anon_sym_LT] = ACTIONS(3870),
    [anon_sym_GT] = ACTIONS(3870),
    [anon_sym_GT_GT] = ACTIONS(3873),
    [anon_sym_AMP_GT] = ACTIONS(3870),
    [anon_sym_AMP_GT_GT] = ACTIONS(3873),
    [anon_sym_LT_AMP] = ACTIONS(3873),
    [anon_sym_GT_AMP] = ACTIONS(3873),
    [anon_sym_LT_LT] = ACTIONS(3876),
    [anon_sym_LT_LT_DASH] = ACTIONS(3879),
    [anon_sym_LT_LT_LT] = ACTIONS(3882),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2610),
    [anon_sym_AMP] = ACTIONS(2615),
  },
  [1137] = {
    [sym__simple_heredoc_body] = ACTIONS(2632),
    [sym__heredoc_body_beginning] = ACTIONS(2632),
    [sym_file_descriptor] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2634),
    [anon_sym_SEMI_SEMI] = ACTIONS(2632),
    [anon_sym_RBRACE] = ACTIONS(2632),
    [anon_sym_PIPE_AMP] = ACTIONS(2632),
    [anon_sym_AMP_AMP] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2632),
    [anon_sym_EQ_TILDE] = ACTIONS(2634),
    [anon_sym_EQ_EQ] = ACTIONS(2634),
    [anon_sym_LT] = ACTIONS(2634),
    [anon_sym_GT] = ACTIONS(2634),
    [anon_sym_GT_GT] = ACTIONS(2632),
    [anon_sym_AMP_GT] = ACTIONS(2634),
    [anon_sym_AMP_GT_GT] = ACTIONS(2632),
    [anon_sym_LT_AMP] = ACTIONS(2632),
    [anon_sym_GT_AMP] = ACTIONS(2632),
    [anon_sym_LT_LT] = ACTIONS(2634),
    [anon_sym_LT_LT_DASH] = ACTIONS(2632),
    [anon_sym_LT_LT_LT] = ACTIONS(2632),
    [anon_sym_DOLLAR] = ACTIONS(2634),
    [sym__special_character] = ACTIONS(2634),
    [anon_sym_DQUOTE] = ACTIONS(2632),
    [sym_raw_string] = ACTIONS(2632),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2632),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2632),
    [anon_sym_BQUOTE] = ACTIONS(2632),
    [anon_sym_LT_LPAREN] = ACTIONS(2632),
    [anon_sym_GT_LPAREN] = ACTIONS(2632),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2634),
    [anon_sym_LF] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2634),
  },
  [1138] = {
    [aux_sym_concatenation_repeat1] = STATE(490),
    [sym__simple_heredoc_body] = ACTIONS(2632),
    [sym__heredoc_body_beginning] = ACTIONS(2632),
    [sym_file_descriptor] = ACTIONS(2632),
    [sym__concat] = ACTIONS(837),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2634),
    [anon_sym_SEMI_SEMI] = ACTIONS(2632),
    [anon_sym_RBRACE] = ACTIONS(2632),
    [anon_sym_PIPE_AMP] = ACTIONS(2632),
    [anon_sym_AMP_AMP] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2632),
    [anon_sym_EQ_TILDE] = ACTIONS(2634),
    [anon_sym_EQ_EQ] = ACTIONS(2634),
    [anon_sym_LT] = ACTIONS(2634),
    [anon_sym_GT] = ACTIONS(2634),
    [anon_sym_GT_GT] = ACTIONS(2632),
    [anon_sym_AMP_GT] = ACTIONS(2634),
    [anon_sym_AMP_GT_GT] = ACTIONS(2632),
    [anon_sym_LT_AMP] = ACTIONS(2632),
    [anon_sym_GT_AMP] = ACTIONS(2632),
    [anon_sym_LT_LT] = ACTIONS(2634),
    [anon_sym_LT_LT_DASH] = ACTIONS(2632),
    [anon_sym_LT_LT_LT] = ACTIONS(2632),
    [anon_sym_DOLLAR] = ACTIONS(2634),
    [sym__special_character] = ACTIONS(2634),
    [anon_sym_DQUOTE] = ACTIONS(2632),
    [sym_raw_string] = ACTIONS(2632),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2632),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2632),
    [anon_sym_BQUOTE] = ACTIONS(2632),
    [anon_sym_LT_LPAREN] = ACTIONS(2632),
    [anon_sym_GT_LPAREN] = ACTIONS(2632),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2634),
    [anon_sym_LF] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2634),
  },
  [1139] = {
    [aux_sym__literal_repeat1] = STATE(523),
    [sym__simple_heredoc_body] = ACTIONS(2636),
    [sym__heredoc_body_beginning] = ACTIONS(2636),
    [sym_file_descriptor] = ACTIONS(2636),
    [anon_sym_SEMI] = ACTIONS(2638),
    [anon_sym_PIPE] = ACTIONS(2638),
    [anon_sym_SEMI_SEMI] = ACTIONS(2636),
    [anon_sym_RBRACE] = ACTIONS(2636),
    [anon_sym_PIPE_AMP] = ACTIONS(2636),
    [anon_sym_AMP_AMP] = ACTIONS(2636),
    [anon_sym_PIPE_PIPE] = ACTIONS(2636),
    [anon_sym_EQ_TILDE] = ACTIONS(2638),
    [anon_sym_EQ_EQ] = ACTIONS(2638),
    [anon_sym_LT] = ACTIONS(2638),
    [anon_sym_GT] = ACTIONS(2638),
    [anon_sym_GT_GT] = ACTIONS(2636),
    [anon_sym_AMP_GT] = ACTIONS(2638),
    [anon_sym_AMP_GT_GT] = ACTIONS(2636),
    [anon_sym_LT_AMP] = ACTIONS(2636),
    [anon_sym_GT_AMP] = ACTIONS(2636),
    [anon_sym_LT_LT] = ACTIONS(2638),
    [anon_sym_LT_LT_DASH] = ACTIONS(2636),
    [anon_sym_LT_LT_LT] = ACTIONS(2636),
    [anon_sym_DOLLAR] = ACTIONS(2638),
    [sym__special_character] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(2636),
    [sym_raw_string] = ACTIONS(2636),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2636),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2636),
    [anon_sym_BQUOTE] = ACTIONS(2636),
    [anon_sym_LT_LPAREN] = ACTIONS(2636),
    [anon_sym_GT_LPAREN] = ACTIONS(2636),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2638),
    [anon_sym_LF] = ACTIONS(2636),
    [anon_sym_AMP] = ACTIONS(2638),
  },
  [1140] = {
    [sym_concatenation] = STATE(1140),
    [sym_string] = STATE(516),
    [sym_simple_expansion] = STATE(516),
    [sym_string_expansion] = STATE(516),
    [sym_expansion] = STATE(516),
    [sym_command_substitution] = STATE(516),
    [sym_process_substitution] = STATE(516),
    [aux_sym_command_repeat2] = STATE(1140),
    [aux_sym__literal_repeat1] = STATE(518),
    [sym__simple_heredoc_body] = ACTIONS(2632),
    [sym__heredoc_body_beginning] = ACTIONS(2632),
    [sym_file_descriptor] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2634),
    [anon_sym_SEMI_SEMI] = ACTIONS(2632),
    [anon_sym_RBRACE] = ACTIONS(2632),
    [anon_sym_PIPE_AMP] = ACTIONS(2632),
    [anon_sym_AMP_AMP] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2632),
    [anon_sym_EQ_TILDE] = ACTIONS(3885),
    [anon_sym_EQ_EQ] = ACTIONS(3885),
    [anon_sym_LT] = ACTIONS(2634),
    [anon_sym_GT] = ACTIONS(2634),
    [anon_sym_GT_GT] = ACTIONS(2632),
    [anon_sym_AMP_GT] = ACTIONS(2634),
    [anon_sym_AMP_GT_GT] = ACTIONS(2632),
    [anon_sym_LT_AMP] = ACTIONS(2632),
    [anon_sym_GT_AMP] = ACTIONS(2632),
    [anon_sym_LT_LT] = ACTIONS(2634),
    [anon_sym_LT_LT_DASH] = ACTIONS(2632),
    [anon_sym_LT_LT_LT] = ACTIONS(2632),
    [anon_sym_DOLLAR] = ACTIONS(3888),
    [sym__special_character] = ACTIONS(3891),
    [anon_sym_DQUOTE] = ACTIONS(3894),
    [sym_raw_string] = ACTIONS(3897),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3900),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3903),
    [anon_sym_BQUOTE] = ACTIONS(3906),
    [anon_sym_LT_LPAREN] = ACTIONS(3909),
    [anon_sym_GT_LPAREN] = ACTIONS(3909),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3912),
    [anon_sym_LF] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2634),
  },
  [1141] = {
    [sym_file_descriptor] = ACTIONS(1237),
    [sym_variable_name] = ACTIONS(1237),
    [anon_sym_for] = ACTIONS(1241),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1237),
    [anon_sym_while] = ACTIONS(1241),
    [anon_sym_if] = ACTIONS(1241),
    [anon_sym_case] = ACTIONS(1241),
    [anon_sym_function] = ACTIONS(1241),
    [anon_sym_LPAREN] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1237),
    [anon_sym_RBRACE] = ACTIONS(2606),
    [anon_sym_BANG] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(1241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1237),
    [anon_sym_declare] = ACTIONS(1241),
    [anon_sym_typeset] = ACTIONS(1241),
    [anon_sym_export] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_local] = ACTIONS(1241),
    [anon_sym_unset] = ACTIONS(1241),
    [anon_sym_unsetenv] = ACTIONS(1241),
    [anon_sym_LT] = ACTIONS(1241),
    [anon_sym_GT] = ACTIONS(1241),
    [anon_sym_GT_GT] = ACTIONS(1237),
    [anon_sym_AMP_GT] = ACTIONS(1241),
    [anon_sym_AMP_GT_GT] = ACTIONS(1237),
    [anon_sym_LT_AMP] = ACTIONS(1237),
    [anon_sym_GT_AMP] = ACTIONS(1237),
    [anon_sym_DOLLAR] = ACTIONS(1241),
    [sym__special_character] = ACTIONS(1241),
    [anon_sym_DQUOTE] = ACTIONS(1237),
    [sym_raw_string] = ACTIONS(1237),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1237),
    [anon_sym_BQUOTE] = ACTIONS(1237),
    [anon_sym_LT_LPAREN] = ACTIONS(1237),
    [anon_sym_GT_LPAREN] = ACTIONS(1237),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1241),
  },
  [1142] = {
    [anon_sym_SEMI] = ACTIONS(3915),
    [anon_sym_SEMI_SEMI] = ACTIONS(3917),
    [anon_sym_RBRACE] = ACTIONS(2606),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3917),
    [anon_sym_AMP] = ACTIONS(3917),
  },
  [1143] = {
    [sym_concatenation] = STATE(1140),
    [sym_string] = STATE(516),
    [sym_simple_expansion] = STATE(516),
    [sym_string_expansion] = STATE(516),
    [sym_expansion] = STATE(516),
    [sym_command_substitution] = STATE(516),
    [sym_process_substitution] = STATE(516),
    [aux_sym_command_repeat2] = STATE(1140),
    [aux_sym__literal_repeat1] = STATE(518),
    [sym__simple_heredoc_body] = ACTIONS(2696),
    [sym__heredoc_body_beginning] = ACTIONS(2696),
    [sym_file_descriptor] = ACTIONS(2696),
    [anon_sym_SEMI] = ACTIONS(2698),
    [anon_sym_PIPE] = ACTIONS(2698),
    [anon_sym_SEMI_SEMI] = ACTIONS(2696),
    [anon_sym_RBRACE] = ACTIONS(2696),
    [anon_sym_PIPE_AMP] = ACTIONS(2696),
    [anon_sym_AMP_AMP] = ACTIONS(2696),
    [anon_sym_PIPE_PIPE] = ACTIONS(2696),
    [anon_sym_EQ_TILDE] = ACTIONS(883),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(2698),
    [anon_sym_GT] = ACTIONS(2698),
    [anon_sym_GT_GT] = ACTIONS(2696),
    [anon_sym_AMP_GT] = ACTIONS(2698),
    [anon_sym_AMP_GT_GT] = ACTIONS(2696),
    [anon_sym_LT_AMP] = ACTIONS(2696),
    [anon_sym_GT_AMP] = ACTIONS(2696),
    [anon_sym_LT_LT] = ACTIONS(2698),
    [anon_sym_LT_LT_DASH] = ACTIONS(2696),
    [anon_sym_LT_LT_LT] = ACTIONS(2696),
    [anon_sym_DOLLAR] = ACTIONS(205),
    [sym__special_character] = ACTIONS(207),
    [anon_sym_DQUOTE] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(885),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(887),
    [anon_sym_LF] = ACTIONS(2696),
    [anon_sym_AMP] = ACTIONS(2698),
  },
  [1144] = {
    [sym_file_descriptor] = ACTIONS(1400),
    [sym_variable_name] = ACTIONS(1400),
    [anon_sym_LT] = ACTIONS(1402),
    [anon_sym_GT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT] = ACTIONS(1402),
    [anon_sym_AMP_GT_GT] = ACTIONS(1400),
    [anon_sym_LT_AMP] = ACTIONS(1400),
    [anon_sym_GT_AMP] = ACTIONS(1400),
    [anon_sym_DOLLAR] = ACTIONS(1402),
    [sym__special_character] = ACTIONS(1400),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1400),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1400),
    [anon_sym_BQUOTE] = ACTIONS(1400),
    [anon_sym_LT_LPAREN] = ACTIONS(1400),
    [anon_sym_GT_LPAREN] = ACTIONS(1400),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1400),
  },
  [1145] = {
    [sym_concatenation] = STATE(1842),
    [sym_string] = STATE(730),
    [sym_simple_expansion] = STATE(730),
    [sym_string_expansion] = STATE(730),
    [sym_expansion] = STATE(730),
    [sym_command_substitution] = STATE(730),
    [sym_process_substitution] = STATE(730),
    [aux_sym_for_statement_repeat1] = STATE(1842),
    [aux_sym__literal_repeat1] = STATE(736),
    [anon_sym_RPAREN] = ACTIONS(3919),
    [anon_sym_DOLLAR] = ACTIONS(1406),
    [sym__special_character] = ACTIONS(1408),
    [anon_sym_DQUOTE] = ACTIONS(1410),
    [sym_raw_string] = ACTIONS(1412),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1414),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1416),
    [anon_sym_BQUOTE] = ACTIONS(1418),
    [anon_sym_LT_LPAREN] = ACTIONS(1420),
    [anon_sym_GT_LPAREN] = ACTIONS(1420),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1412),
  },
  [1146] = {
    [aux_sym_concatenation_repeat1] = STATE(597),
    [sym_file_descriptor] = ACTIONS(1400),
    [sym__concat] = ACTIONS(1031),
    [sym_variable_name] = ACTIONS(1400),
    [anon_sym_LT] = ACTIONS(1402),
    [anon_sym_GT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT] = ACTIONS(1402),
    [anon_sym_AMP_GT_GT] = ACTIONS(1400),
    [anon_sym_LT_AMP] = ACTIONS(1400),
    [anon_sym_GT_AMP] = ACTIONS(1400),
    [anon_sym_DOLLAR] = ACTIONS(1402),
    [sym__special_character] = ACTIONS(1400),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1400),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1400),
    [anon_sym_BQUOTE] = ACTIONS(1400),
    [anon_sym_LT_LPAREN] = ACTIONS(1400),
    [anon_sym_GT_LPAREN] = ACTIONS(1400),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1400),
  },
  [1147] = {
    [aux_sym__literal_repeat1] = STATE(610),
    [sym_file_descriptor] = ACTIONS(1446),
    [sym_variable_name] = ACTIONS(1446),
    [anon_sym_LT] = ACTIONS(1448),
    [anon_sym_GT] = ACTIONS(1448),
    [anon_sym_GT_GT] = ACTIONS(1446),
    [anon_sym_AMP_GT] = ACTIONS(1448),
    [anon_sym_AMP_GT_GT] = ACTIONS(1446),
    [anon_sym_LT_AMP] = ACTIONS(1446),
    [anon_sym_GT_AMP] = ACTIONS(1446),
    [anon_sym_DOLLAR] = ACTIONS(1448),
    [sym__special_character] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1446),
    [sym_raw_string] = ACTIONS(1446),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1446),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1446),
    [anon_sym_BQUOTE] = ACTIONS(1446),
    [anon_sym_LT_LPAREN] = ACTIONS(1446),
    [anon_sym_GT_LPAREN] = ACTIONS(1446),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1446),
  },
  [1148] = {
    [anon_sym_AMP_AMP] = ACTIONS(2929),
    [anon_sym_PIPE_PIPE] = ACTIONS(2929),
    [anon_sym_RBRACK] = ACTIONS(2929),
    [anon_sym_EQ_TILDE] = ACTIONS(2929),
    [anon_sym_EQ_EQ] = ACTIONS(2929),
    [anon_sym_EQ] = ACTIONS(2931),
    [anon_sym_PLUS_EQ] = ACTIONS(2929),
    [anon_sym_LT] = ACTIONS(2931),
    [anon_sym_GT] = ACTIONS(2931),
    [anon_sym_BANG_EQ] = ACTIONS(2929),
    [anon_sym_PLUS] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(2931),
    [anon_sym_DASH_EQ] = ACTIONS(2929),
    [anon_sym_LT_EQ] = ACTIONS(2929),
    [anon_sym_GT_EQ] = ACTIONS(2929),
    [anon_sym_PLUS_PLUS] = ACTIONS(2929),
    [anon_sym_DASH_DASH] = ACTIONS(2929),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2929),
  },
  [1149] = {
    [sym__concat] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_RBRACK] = ACTIONS(2362),
    [anon_sym_EQ_TILDE] = ACTIONS(2362),
    [anon_sym_EQ_EQ] = ACTIONS(2362),
    [anon_sym_EQ] = ACTIONS(2364),
    [anon_sym_PLUS_EQ] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_BANG_EQ] = ACTIONS(2362),
    [anon_sym_PLUS] = ACTIONS(2364),
    [anon_sym_DASH] = ACTIONS(2364),
    [anon_sym_DASH_EQ] = ACTIONS(2362),
    [anon_sym_LT_EQ] = ACTIONS(2362),
    [anon_sym_GT_EQ] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2362),
  },
  [1150] = {
    [sym_string] = STATE(1149),
    [sym_simple_expansion] = STATE(1149),
    [sym_string_expansion] = STATE(1149),
    [sym_expansion] = STATE(1149),
    [sym_command_substitution] = STATE(1149),
    [sym_process_substitution] = STATE(1149),
    [anon_sym_DOLLAR] = ACTIONS(3921),
    [sym__special_character] = ACTIONS(2116),
    [anon_sym_DQUOTE] = ACTIONS(233),
    [sym_raw_string] = ACTIONS(2116),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [anon_sym_LT_LPAREN] = ACTIONS(243),
    [anon_sym_GT_LPAREN] = ACTIONS(243),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2116),
  },
  [1151] = {
    [aux_sym_concatenation_repeat1] = STATE(1151),
    [sym__concat] = ACTIONS(3923),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_RBRACK] = ACTIONS(2362),
    [anon_sym_EQ_TILDE] = ACTIONS(2362),
    [anon_sym_EQ_EQ] = ACTIONS(2362),
    [anon_sym_EQ] = ACTIONS(2364),
    [anon_sym_PLUS_EQ] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_BANG_EQ] = ACTIONS(2362),
    [anon_sym_PLUS] = ACTIONS(2364),
    [anon_sym_DASH] = ACTIONS(2364),
    [anon_sym_DASH_EQ] = ACTIONS(2362),
    [anon_sym_LT_EQ] = ACTIONS(2362),
    [anon_sym_GT_EQ] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2362),
  },
  [1152] = {
    [sym__concat] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_RBRACK] = ACTIONS(2371),
    [anon_sym_EQ_TILDE] = ACTIONS(2371),
    [anon_sym_EQ_EQ] = ACTIONS(2371),
    [anon_sym_EQ] = ACTIONS(2373),
    [anon_sym_PLUS_EQ] = ACTIONS(2371),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2371),
    [anon_sym_PLUS] = ACTIONS(2373),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_DASH_EQ] = ACTIONS(2371),
    [anon_sym_LT_EQ] = ACTIONS(2371),
    [anon_sym_GT_EQ] = ACTIONS(2371),
    [anon_sym_PLUS_PLUS] = ACTIONS(2371),
    [anon_sym_DASH_DASH] = ACTIONS(2371),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2371),
  },
  [1153] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(3926),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [1154] = {
    [sym_concatenation] = STATE(1847),
    [sym_string] = STATE(1846),
    [sym_simple_expansion] = STATE(1846),
    [sym_string_expansion] = STATE(1846),
    [sym_expansion] = STATE(1846),
    [sym_command_substitution] = STATE(1846),
    [sym_process_substitution] = STATE(1846),
    [aux_sym__literal_repeat1] = STATE(1848),
    [anon_sym_RBRACE] = ACTIONS(3928),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(3930),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3930),
  },
  [1155] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(3932),
    [sym_comment] = ACTIONS(57),
  },
  [1156] = {
    [sym_concatenation] = STATE(1852),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1852),
    [anon_sym_RBRACE] = ACTIONS(3934),
    [anon_sym_EQ] = ACTIONS(3936),
    [anon_sym_DASH] = ACTIONS(3936),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(3938),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(3940),
    [anon_sym_COLON] = ACTIONS(3936),
    [anon_sym_COLON_QMARK] = ACTIONS(3936),
    [anon_sym_COLON_DASH] = ACTIONS(3936),
    [anon_sym_PERCENT] = ACTIONS(3936),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1157] = {
    [sym_concatenation] = STATE(1854),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1854),
    [anon_sym_RBRACE] = ACTIONS(3928),
    [anon_sym_EQ] = ACTIONS(3942),
    [anon_sym_DASH] = ACTIONS(3942),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(3944),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(3946),
    [anon_sym_COLON] = ACTIONS(3942),
    [anon_sym_COLON_QMARK] = ACTIONS(3942),
    [anon_sym_COLON_DASH] = ACTIONS(3942),
    [anon_sym_PERCENT] = ACTIONS(3942),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1158] = {
    [sym__concat] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_RBRACK] = ACTIONS(2462),
    [anon_sym_EQ_TILDE] = ACTIONS(2462),
    [anon_sym_EQ_EQ] = ACTIONS(2462),
    [anon_sym_EQ] = ACTIONS(2464),
    [anon_sym_PLUS_EQ] = ACTIONS(2462),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_BANG_EQ] = ACTIONS(2462),
    [anon_sym_PLUS] = ACTIONS(2464),
    [anon_sym_DASH] = ACTIONS(2464),
    [anon_sym_DASH_EQ] = ACTIONS(2462),
    [anon_sym_LT_EQ] = ACTIONS(2462),
    [anon_sym_GT_EQ] = ACTIONS(2462),
    [anon_sym_PLUS_PLUS] = ACTIONS(2462),
    [anon_sym_DASH_DASH] = ACTIONS(2462),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2462),
  },
  [1159] = {
    [sym_concatenation] = STATE(1857),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1857),
    [sym_regex] = ACTIONS(3948),
    [anon_sym_RBRACE] = ACTIONS(3950),
    [anon_sym_EQ] = ACTIONS(3952),
    [anon_sym_DASH] = ACTIONS(3952),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(3954),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(3952),
    [anon_sym_COLON_QMARK] = ACTIONS(3952),
    [anon_sym_COLON_DASH] = ACTIONS(3952),
    [anon_sym_PERCENT] = ACTIONS(3952),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1160] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(3950),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1161] = {
    [sym__concat] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE_PIPE] = ACTIONS(2512),
    [anon_sym_RBRACK] = ACTIONS(2512),
    [anon_sym_EQ_TILDE] = ACTIONS(2512),
    [anon_sym_EQ_EQ] = ACTIONS(2512),
    [anon_sym_EQ] = ACTIONS(2514),
    [anon_sym_PLUS_EQ] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2514),
    [anon_sym_GT] = ACTIONS(2514),
    [anon_sym_BANG_EQ] = ACTIONS(2512),
    [anon_sym_PLUS] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2514),
    [anon_sym_DASH_EQ] = ACTIONS(2512),
    [anon_sym_LT_EQ] = ACTIONS(2512),
    [anon_sym_GT_EQ] = ACTIONS(2512),
    [anon_sym_PLUS_PLUS] = ACTIONS(2512),
    [anon_sym_DASH_DASH] = ACTIONS(2512),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2512),
  },
  [1162] = {
    [sym_concatenation] = STATE(1854),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1854),
    [sym_regex] = ACTIONS(3956),
    [anon_sym_RBRACE] = ACTIONS(3928),
    [anon_sym_EQ] = ACTIONS(3942),
    [anon_sym_DASH] = ACTIONS(3942),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(3944),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(3942),
    [anon_sym_COLON_QMARK] = ACTIONS(3942),
    [anon_sym_COLON_DASH] = ACTIONS(3942),
    [anon_sym_PERCENT] = ACTIONS(3942),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1163] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(3928),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1164] = {
    [sym__concat] = ACTIONS(2520),
    [anon_sym_AMP_AMP] = ACTIONS(2520),
    [anon_sym_PIPE_PIPE] = ACTIONS(2520),
    [anon_sym_RBRACK] = ACTIONS(2520),
    [anon_sym_EQ_TILDE] = ACTIONS(2520),
    [anon_sym_EQ_EQ] = ACTIONS(2520),
    [anon_sym_EQ] = ACTIONS(2522),
    [anon_sym_PLUS_EQ] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(2522),
    [anon_sym_GT] = ACTIONS(2522),
    [anon_sym_BANG_EQ] = ACTIONS(2520),
    [anon_sym_PLUS] = ACTIONS(2522),
    [anon_sym_DASH] = ACTIONS(2522),
    [anon_sym_DASH_EQ] = ACTIONS(2520),
    [anon_sym_LT_EQ] = ACTIONS(2520),
    [anon_sym_GT_EQ] = ACTIONS(2520),
    [anon_sym_PLUS_PLUS] = ACTIONS(2520),
    [anon_sym_DASH_DASH] = ACTIONS(2520),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2520),
  },
  [1165] = {
    [sym__concat] = ACTIONS(2554),
    [anon_sym_AMP_AMP] = ACTIONS(2554),
    [anon_sym_PIPE_PIPE] = ACTIONS(2554),
    [anon_sym_RBRACK] = ACTIONS(2554),
    [anon_sym_EQ_TILDE] = ACTIONS(2554),
    [anon_sym_EQ_EQ] = ACTIONS(2554),
    [anon_sym_EQ] = ACTIONS(2556),
    [anon_sym_PLUS_EQ] = ACTIONS(2554),
    [anon_sym_LT] = ACTIONS(2556),
    [anon_sym_GT] = ACTIONS(2556),
    [anon_sym_BANG_EQ] = ACTIONS(2554),
    [anon_sym_PLUS] = ACTIONS(2556),
    [anon_sym_DASH] = ACTIONS(2556),
    [anon_sym_DASH_EQ] = ACTIONS(2554),
    [anon_sym_LT_EQ] = ACTIONS(2554),
    [anon_sym_GT_EQ] = ACTIONS(2554),
    [anon_sym_PLUS_PLUS] = ACTIONS(2554),
    [anon_sym_DASH_DASH] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2554),
  },
  [1166] = {
    [anon_sym_AMP_AMP] = ACTIONS(2975),
    [anon_sym_PIPE_PIPE] = ACTIONS(2975),
    [anon_sym_RBRACK] = ACTIONS(2975),
    [anon_sym_EQ_TILDE] = ACTIONS(2975),
    [anon_sym_EQ_EQ] = ACTIONS(2975),
    [anon_sym_EQ] = ACTIONS(2977),
    [anon_sym_PLUS_EQ] = ACTIONS(2975),
    [anon_sym_LT] = ACTIONS(2977),
    [anon_sym_GT] = ACTIONS(2977),
    [anon_sym_BANG_EQ] = ACTIONS(2975),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_DASH_EQ] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(2975),
    [anon_sym_GT_EQ] = ACTIONS(2975),
    [anon_sym_PLUS_PLUS] = ACTIONS(2975),
    [anon_sym_DASH_DASH] = ACTIONS(2975),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2975),
  },
  [1167] = {
    [anon_sym_AMP_AMP] = ACTIONS(2975),
    [anon_sym_PIPE_PIPE] = ACTIONS(2975),
    [anon_sym_RBRACK] = ACTIONS(2975),
    [anon_sym_EQ_TILDE] = ACTIONS(2975),
    [anon_sym_EQ_EQ] = ACTIONS(2975),
    [anon_sym_EQ] = ACTIONS(2977),
    [anon_sym_PLUS_EQ] = ACTIONS(2975),
    [anon_sym_LT] = ACTIONS(2977),
    [anon_sym_GT] = ACTIONS(2977),
    [anon_sym_BANG_EQ] = ACTIONS(2975),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_DASH_EQ] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(2975),
    [anon_sym_GT_EQ] = ACTIONS(2975),
    [anon_sym_PLUS_PLUS] = ACTIONS(2975),
    [anon_sym_DASH_DASH] = ACTIONS(2975),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2975),
  },
  [1168] = {
    [aux_sym_concatenation_repeat1] = STATE(1168),
    [sym__concat] = ACTIONS(2940),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2362),
    [anon_sym_EQ_TILDE] = ACTIONS(2362),
    [anon_sym_EQ_EQ] = ACTIONS(2362),
    [anon_sym_EQ] = ACTIONS(2364),
    [anon_sym_PLUS_EQ] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_BANG_EQ] = ACTIONS(2362),
    [anon_sym_PLUS] = ACTIONS(2364),
    [anon_sym_DASH] = ACTIONS(2364),
    [anon_sym_DASH_EQ] = ACTIONS(2362),
    [anon_sym_LT_EQ] = ACTIONS(2362),
    [anon_sym_GT_EQ] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2362),
  },
  [1169] = {
    [sym__simple_heredoc_body] = ACTIONS(1400),
    [sym__heredoc_body_beginning] = ACTIONS(1400),
    [sym_file_descriptor] = ACTIONS(1400),
    [sym_variable_name] = ACTIONS(1400),
    [ts_builtin_sym_end] = ACTIONS(1400),
    [anon_sym_SEMI] = ACTIONS(1402),
    [anon_sym_PIPE] = ACTIONS(1402),
    [anon_sym_RPAREN] = ACTIONS(1400),
    [anon_sym_SEMI_SEMI] = ACTIONS(1400),
    [anon_sym_PIPE_AMP] = ACTIONS(1400),
    [anon_sym_AMP_AMP] = ACTIONS(1400),
    [anon_sym_PIPE_PIPE] = ACTIONS(1400),
    [anon_sym_LT] = ACTIONS(1402),
    [anon_sym_GT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT] = ACTIONS(1402),
    [anon_sym_AMP_GT_GT] = ACTIONS(1400),
    [anon_sym_LT_AMP] = ACTIONS(1400),
    [anon_sym_GT_AMP] = ACTIONS(1400),
    [anon_sym_LT_LT] = ACTIONS(1402),
    [anon_sym_LT_LT_DASH] = ACTIONS(1400),
    [anon_sym_LT_LT_LT] = ACTIONS(1400),
    [anon_sym_DOLLAR] = ACTIONS(1402),
    [sym__special_character] = ACTIONS(1400),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1400),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1400),
    [anon_sym_BQUOTE] = ACTIONS(1400),
    [anon_sym_LT_LPAREN] = ACTIONS(1400),
    [anon_sym_GT_LPAREN] = ACTIONS(1400),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1402),
    [sym_word] = ACTIONS(1402),
    [anon_sym_LF] = ACTIONS(1400),
    [anon_sym_AMP] = ACTIONS(1402),
  },
  [1170] = {
    [sym_concatenation] = STATE(1860),
    [sym_string] = STATE(730),
    [sym_simple_expansion] = STATE(730),
    [sym_string_expansion] = STATE(730),
    [sym_expansion] = STATE(730),
    [sym_command_substitution] = STATE(730),
    [sym_process_substitution] = STATE(730),
    [aux_sym_for_statement_repeat1] = STATE(1860),
    [aux_sym__literal_repeat1] = STATE(736),
    [anon_sym_RPAREN] = ACTIONS(3958),
    [anon_sym_DOLLAR] = ACTIONS(1406),
    [sym__special_character] = ACTIONS(1408),
    [anon_sym_DQUOTE] = ACTIONS(1410),
    [sym_raw_string] = ACTIONS(1412),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1414),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1416),
    [anon_sym_BQUOTE] = ACTIONS(1418),
    [anon_sym_LT_LPAREN] = ACTIONS(1420),
    [anon_sym_GT_LPAREN] = ACTIONS(1420),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1412),
  },
  [1171] = {
    [aux_sym_concatenation_repeat1] = STATE(559),
    [sym__simple_heredoc_body] = ACTIONS(1400),
    [sym__heredoc_body_beginning] = ACTIONS(1400),
    [sym_file_descriptor] = ACTIONS(1400),
    [sym__concat] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(1400),
    [ts_builtin_sym_end] = ACTIONS(1400),
    [anon_sym_SEMI] = ACTIONS(1402),
    [anon_sym_PIPE] = ACTIONS(1402),
    [anon_sym_SEMI_SEMI] = ACTIONS(1400),
    [anon_sym_PIPE_AMP] = ACTIONS(1400),
    [anon_sym_AMP_AMP] = ACTIONS(1400),
    [anon_sym_PIPE_PIPE] = ACTIONS(1400),
    [anon_sym_LT] = ACTIONS(1402),
    [anon_sym_GT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT] = ACTIONS(1402),
    [anon_sym_AMP_GT_GT] = ACTIONS(1400),
    [anon_sym_LT_AMP] = ACTIONS(1400),
    [anon_sym_GT_AMP] = ACTIONS(1400),
    [anon_sym_LT_LT] = ACTIONS(1402),
    [anon_sym_LT_LT_DASH] = ACTIONS(1400),
    [anon_sym_LT_LT_LT] = ACTIONS(1400),
    [anon_sym_DOLLAR] = ACTIONS(1402),
    [sym__special_character] = ACTIONS(1400),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1400),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1400),
    [anon_sym_BQUOTE] = ACTIONS(1400),
    [anon_sym_LT_LPAREN] = ACTIONS(1400),
    [anon_sym_GT_LPAREN] = ACTIONS(1400),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1402),
    [sym_word] = ACTIONS(1402),
    [anon_sym_LF] = ACTIONS(1400),
    [anon_sym_AMP] = ACTIONS(1402),
  },
  [1172] = {
    [aux_sym__literal_repeat1] = STATE(573),
    [sym__simple_heredoc_body] = ACTIONS(1446),
    [sym__heredoc_body_beginning] = ACTIONS(1446),
    [sym_file_descriptor] = ACTIONS(1446),
    [sym_variable_name] = ACTIONS(1446),
    [ts_builtin_sym_end] = ACTIONS(1446),
    [anon_sym_SEMI] = ACTIONS(1448),
    [anon_sym_PIPE] = ACTIONS(1448),
    [anon_sym_SEMI_SEMI] = ACTIONS(1446),
    [anon_sym_PIPE_AMP] = ACTIONS(1446),
    [anon_sym_AMP_AMP] = ACTIONS(1446),
    [anon_sym_PIPE_PIPE] = ACTIONS(1446),
    [anon_sym_LT] = ACTIONS(1448),
    [anon_sym_GT] = ACTIONS(1448),
    [anon_sym_GT_GT] = ACTIONS(1446),
    [anon_sym_AMP_GT] = ACTIONS(1448),
    [anon_sym_AMP_GT_GT] = ACTIONS(1446),
    [anon_sym_LT_AMP] = ACTIONS(1446),
    [anon_sym_GT_AMP] = ACTIONS(1446),
    [anon_sym_LT_LT] = ACTIONS(1448),
    [anon_sym_LT_LT_DASH] = ACTIONS(1446),
    [anon_sym_LT_LT_LT] = ACTIONS(1446),
    [anon_sym_DOLLAR] = ACTIONS(1448),
    [sym__special_character] = ACTIONS(981),
    [anon_sym_DQUOTE] = ACTIONS(1446),
    [sym_raw_string] = ACTIONS(1446),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1446),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1446),
    [anon_sym_BQUOTE] = ACTIONS(1446),
    [anon_sym_LT_LPAREN] = ACTIONS(1446),
    [anon_sym_GT_LPAREN] = ACTIONS(1446),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1448),
    [sym_word] = ACTIONS(1448),
    [anon_sym_LF] = ACTIONS(1446),
    [anon_sym_AMP] = ACTIONS(1448),
  },
  [1173] = {
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(2362),
    [sym_variable_name] = ACTIONS(2362),
    [ts_builtin_sym_end] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_RPAREN] = ACTIONS(2362),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2364),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [1174] = {
    [sym_string] = STATE(1173),
    [sym_simple_expansion] = STATE(1173),
    [sym_string_expansion] = STATE(1173),
    [sym_expansion] = STATE(1173),
    [sym_command_substitution] = STATE(1173),
    [sym_process_substitution] = STATE(1173),
    [anon_sym_DOLLAR] = ACTIONS(3960),
    [sym__special_character] = ACTIONS(2168),
    [anon_sym_DQUOTE] = ACTIONS(269),
    [sym_raw_string] = ACTIONS(2168),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(277),
    [anon_sym_LT_LPAREN] = ACTIONS(279),
    [anon_sym_GT_LPAREN] = ACTIONS(279),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2168),
  },
  [1175] = {
    [aux_sym_concatenation_repeat1] = STATE(1175),
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(3962),
    [sym_variable_name] = ACTIONS(2362),
    [ts_builtin_sym_end] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2364),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [1176] = {
    [sym__simple_heredoc_body] = ACTIONS(2371),
    [sym__heredoc_body_beginning] = ACTIONS(2371),
    [sym_file_descriptor] = ACTIONS(2371),
    [sym__concat] = ACTIONS(2371),
    [sym_variable_name] = ACTIONS(2371),
    [ts_builtin_sym_end] = ACTIONS(2371),
    [anon_sym_SEMI] = ACTIONS(2373),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_RPAREN] = ACTIONS(2371),
    [anon_sym_SEMI_SEMI] = ACTIONS(2371),
    [anon_sym_PIPE_AMP] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_GT_GT] = ACTIONS(2371),
    [anon_sym_AMP_GT] = ACTIONS(2373),
    [anon_sym_AMP_GT_GT] = ACTIONS(2371),
    [anon_sym_LT_AMP] = ACTIONS(2371),
    [anon_sym_GT_AMP] = ACTIONS(2371),
    [anon_sym_LT_LT] = ACTIONS(2373),
    [anon_sym_LT_LT_DASH] = ACTIONS(2371),
    [anon_sym_LT_LT_LT] = ACTIONS(2371),
    [anon_sym_DOLLAR] = ACTIONS(2373),
    [sym__special_character] = ACTIONS(2371),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [sym_raw_string] = ACTIONS(2371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2371),
    [anon_sym_BQUOTE] = ACTIONS(2371),
    [anon_sym_LT_LPAREN] = ACTIONS(2371),
    [anon_sym_GT_LPAREN] = ACTIONS(2371),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2373),
    [sym_word] = ACTIONS(2373),
    [anon_sym_LF] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
  },
  [1177] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(3965),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [1178] = {
    [sym_concatenation] = STATE(1865),
    [sym_string] = STATE(1864),
    [sym_simple_expansion] = STATE(1864),
    [sym_string_expansion] = STATE(1864),
    [sym_expansion] = STATE(1864),
    [sym_command_substitution] = STATE(1864),
    [sym_process_substitution] = STATE(1864),
    [aux_sym__literal_repeat1] = STATE(1866),
    [anon_sym_RBRACE] = ACTIONS(3967),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(3969),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3969),
  },
  [1179] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(3971),
    [sym_comment] = ACTIONS(57),
  },
  [1180] = {
    [sym_concatenation] = STATE(1870),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1870),
    [anon_sym_RBRACE] = ACTIONS(3973),
    [anon_sym_EQ] = ACTIONS(3975),
    [anon_sym_DASH] = ACTIONS(3975),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(3977),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(3979),
    [anon_sym_COLON] = ACTIONS(3975),
    [anon_sym_COLON_QMARK] = ACTIONS(3975),
    [anon_sym_COLON_DASH] = ACTIONS(3975),
    [anon_sym_PERCENT] = ACTIONS(3975),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1181] = {
    [sym_concatenation] = STATE(1872),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1872),
    [anon_sym_RBRACE] = ACTIONS(3967),
    [anon_sym_EQ] = ACTIONS(3981),
    [anon_sym_DASH] = ACTIONS(3981),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(3983),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(3985),
    [anon_sym_COLON] = ACTIONS(3981),
    [anon_sym_COLON_QMARK] = ACTIONS(3981),
    [anon_sym_COLON_DASH] = ACTIONS(3981),
    [anon_sym_PERCENT] = ACTIONS(3981),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1182] = {
    [sym__simple_heredoc_body] = ACTIONS(2462),
    [sym__heredoc_body_beginning] = ACTIONS(2462),
    [sym_file_descriptor] = ACTIONS(2462),
    [sym__concat] = ACTIONS(2462),
    [sym_variable_name] = ACTIONS(2462),
    [ts_builtin_sym_end] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_RPAREN] = ACTIONS(2462),
    [anon_sym_SEMI_SEMI] = ACTIONS(2462),
    [anon_sym_PIPE_AMP] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_GT_GT] = ACTIONS(2462),
    [anon_sym_AMP_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT_GT] = ACTIONS(2462),
    [anon_sym_LT_AMP] = ACTIONS(2462),
    [anon_sym_GT_AMP] = ACTIONS(2462),
    [anon_sym_LT_LT] = ACTIONS(2464),
    [anon_sym_LT_LT_DASH] = ACTIONS(2462),
    [anon_sym_LT_LT_LT] = ACTIONS(2462),
    [anon_sym_DOLLAR] = ACTIONS(2464),
    [sym__special_character] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [sym_raw_string] = ACTIONS(2462),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2462),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2462),
    [anon_sym_BQUOTE] = ACTIONS(2462),
    [anon_sym_LT_LPAREN] = ACTIONS(2462),
    [anon_sym_GT_LPAREN] = ACTIONS(2462),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2464),
    [sym_word] = ACTIONS(2464),
    [anon_sym_LF] = ACTIONS(2462),
    [anon_sym_AMP] = ACTIONS(2464),
  },
  [1183] = {
    [sym_concatenation] = STATE(1875),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1875),
    [sym_regex] = ACTIONS(3987),
    [anon_sym_RBRACE] = ACTIONS(3989),
    [anon_sym_EQ] = ACTIONS(3991),
    [anon_sym_DASH] = ACTIONS(3991),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(3993),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(3991),
    [anon_sym_COLON_QMARK] = ACTIONS(3991),
    [anon_sym_COLON_DASH] = ACTIONS(3991),
    [anon_sym_PERCENT] = ACTIONS(3991),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1184] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(3989),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1185] = {
    [sym__simple_heredoc_body] = ACTIONS(2512),
    [sym__heredoc_body_beginning] = ACTIONS(2512),
    [sym_file_descriptor] = ACTIONS(2512),
    [sym__concat] = ACTIONS(2512),
    [sym_variable_name] = ACTIONS(2512),
    [ts_builtin_sym_end] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2514),
    [anon_sym_PIPE] = ACTIONS(2514),
    [anon_sym_RPAREN] = ACTIONS(2512),
    [anon_sym_SEMI_SEMI] = ACTIONS(2512),
    [anon_sym_PIPE_AMP] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE_PIPE] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2514),
    [anon_sym_GT] = ACTIONS(2514),
    [anon_sym_GT_GT] = ACTIONS(2512),
    [anon_sym_AMP_GT] = ACTIONS(2514),
    [anon_sym_AMP_GT_GT] = ACTIONS(2512),
    [anon_sym_LT_AMP] = ACTIONS(2512),
    [anon_sym_GT_AMP] = ACTIONS(2512),
    [anon_sym_LT_LT] = ACTIONS(2514),
    [anon_sym_LT_LT_DASH] = ACTIONS(2512),
    [anon_sym_LT_LT_LT] = ACTIONS(2512),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [sym__special_character] = ACTIONS(2512),
    [anon_sym_DQUOTE] = ACTIONS(2512),
    [sym_raw_string] = ACTIONS(2512),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2512),
    [anon_sym_BQUOTE] = ACTIONS(2512),
    [anon_sym_LT_LPAREN] = ACTIONS(2512),
    [anon_sym_GT_LPAREN] = ACTIONS(2512),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2514),
    [sym_word] = ACTIONS(2514),
    [anon_sym_LF] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2514),
  },
  [1186] = {
    [sym_concatenation] = STATE(1872),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1872),
    [sym_regex] = ACTIONS(3995),
    [anon_sym_RBRACE] = ACTIONS(3967),
    [anon_sym_EQ] = ACTIONS(3981),
    [anon_sym_DASH] = ACTIONS(3981),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(3983),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(3981),
    [anon_sym_COLON_QMARK] = ACTIONS(3981),
    [anon_sym_COLON_DASH] = ACTIONS(3981),
    [anon_sym_PERCENT] = ACTIONS(3981),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1187] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(3967),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1188] = {
    [sym__simple_heredoc_body] = ACTIONS(2520),
    [sym__heredoc_body_beginning] = ACTIONS(2520),
    [sym_file_descriptor] = ACTIONS(2520),
    [sym__concat] = ACTIONS(2520),
    [sym_variable_name] = ACTIONS(2520),
    [ts_builtin_sym_end] = ACTIONS(2520),
    [anon_sym_SEMI] = ACTIONS(2522),
    [anon_sym_PIPE] = ACTIONS(2522),
    [anon_sym_RPAREN] = ACTIONS(2520),
    [anon_sym_SEMI_SEMI] = ACTIONS(2520),
    [anon_sym_PIPE_AMP] = ACTIONS(2520),
    [anon_sym_AMP_AMP] = ACTIONS(2520),
    [anon_sym_PIPE_PIPE] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(2522),
    [anon_sym_GT] = ACTIONS(2522),
    [anon_sym_GT_GT] = ACTIONS(2520),
    [anon_sym_AMP_GT] = ACTIONS(2522),
    [anon_sym_AMP_GT_GT] = ACTIONS(2520),
    [anon_sym_LT_AMP] = ACTIONS(2520),
    [anon_sym_GT_AMP] = ACTIONS(2520),
    [anon_sym_LT_LT] = ACTIONS(2522),
    [anon_sym_LT_LT_DASH] = ACTIONS(2520),
    [anon_sym_LT_LT_LT] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(2522),
    [sym__special_character] = ACTIONS(2520),
    [anon_sym_DQUOTE] = ACTIONS(2520),
    [sym_raw_string] = ACTIONS(2520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2520),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2520),
    [anon_sym_BQUOTE] = ACTIONS(2520),
    [anon_sym_LT_LPAREN] = ACTIONS(2520),
    [anon_sym_GT_LPAREN] = ACTIONS(2520),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2522),
    [sym_word] = ACTIONS(2522),
    [anon_sym_LF] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2522),
  },
  [1189] = {
    [sym__simple_heredoc_body] = ACTIONS(2554),
    [sym__heredoc_body_beginning] = ACTIONS(2554),
    [sym_file_descriptor] = ACTIONS(2554),
    [sym__concat] = ACTIONS(2554),
    [sym_variable_name] = ACTIONS(2554),
    [ts_builtin_sym_end] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(2556),
    [anon_sym_PIPE] = ACTIONS(2556),
    [anon_sym_RPAREN] = ACTIONS(2554),
    [anon_sym_SEMI_SEMI] = ACTIONS(2554),
    [anon_sym_PIPE_AMP] = ACTIONS(2554),
    [anon_sym_AMP_AMP] = ACTIONS(2554),
    [anon_sym_PIPE_PIPE] = ACTIONS(2554),
    [anon_sym_LT] = ACTIONS(2556),
    [anon_sym_GT] = ACTIONS(2556),
    [anon_sym_GT_GT] = ACTIONS(2554),
    [anon_sym_AMP_GT] = ACTIONS(2556),
    [anon_sym_AMP_GT_GT] = ACTIONS(2554),
    [anon_sym_LT_AMP] = ACTIONS(2554),
    [anon_sym_GT_AMP] = ACTIONS(2554),
    [anon_sym_LT_LT] = ACTIONS(2556),
    [anon_sym_LT_LT_DASH] = ACTIONS(2554),
    [anon_sym_LT_LT_LT] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2556),
    [sym__special_character] = ACTIONS(2554),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2554),
    [anon_sym_BQUOTE] = ACTIONS(2554),
    [anon_sym_LT_LPAREN] = ACTIONS(2554),
    [anon_sym_GT_LPAREN] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2556),
    [sym_word] = ACTIONS(2556),
    [anon_sym_LF] = ACTIONS(2554),
    [anon_sym_AMP] = ACTIONS(2556),
  },
  [1190] = {
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(2362),
    [ts_builtin_sym_end] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_RPAREN] = ACTIONS(2362),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2364),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [1191] = {
    [sym_string] = STATE(1190),
    [sym_simple_expansion] = STATE(1190),
    [sym_string_expansion] = STATE(1190),
    [sym_expansion] = STATE(1190),
    [sym_command_substitution] = STATE(1190),
    [sym_process_substitution] = STATE(1190),
    [anon_sym_DOLLAR] = ACTIONS(3997),
    [sym__special_character] = ACTIONS(2246),
    [anon_sym_DQUOTE] = ACTIONS(293),
    [sym_raw_string] = ACTIONS(2246),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(297),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(301),
    [anon_sym_LT_LPAREN] = ACTIONS(303),
    [anon_sym_GT_LPAREN] = ACTIONS(303),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2246),
  },
  [1192] = {
    [aux_sym_concatenation_repeat1] = STATE(1192),
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(3999),
    [ts_builtin_sym_end] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2364),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [1193] = {
    [sym__simple_heredoc_body] = ACTIONS(2371),
    [sym__heredoc_body_beginning] = ACTIONS(2371),
    [sym_file_descriptor] = ACTIONS(2371),
    [sym__concat] = ACTIONS(2371),
    [ts_builtin_sym_end] = ACTIONS(2371),
    [anon_sym_SEMI] = ACTIONS(2373),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_RPAREN] = ACTIONS(2371),
    [anon_sym_SEMI_SEMI] = ACTIONS(2371),
    [anon_sym_PIPE_AMP] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_GT_GT] = ACTIONS(2371),
    [anon_sym_AMP_GT] = ACTIONS(2373),
    [anon_sym_AMP_GT_GT] = ACTIONS(2371),
    [anon_sym_LT_AMP] = ACTIONS(2371),
    [anon_sym_GT_AMP] = ACTIONS(2371),
    [anon_sym_LT_LT] = ACTIONS(2373),
    [anon_sym_LT_LT_DASH] = ACTIONS(2371),
    [anon_sym_LT_LT_LT] = ACTIONS(2371),
    [anon_sym_DOLLAR] = ACTIONS(2373),
    [sym__special_character] = ACTIONS(2371),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [sym_raw_string] = ACTIONS(2371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2371),
    [anon_sym_BQUOTE] = ACTIONS(2371),
    [anon_sym_LT_LPAREN] = ACTIONS(2371),
    [anon_sym_GT_LPAREN] = ACTIONS(2371),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2373),
    [sym_word] = ACTIONS(2373),
    [anon_sym_LF] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
  },
  [1194] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(4002),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [1195] = {
    [sym_concatenation] = STATE(1881),
    [sym_string] = STATE(1880),
    [sym_simple_expansion] = STATE(1880),
    [sym_string_expansion] = STATE(1880),
    [sym_expansion] = STATE(1880),
    [sym_command_substitution] = STATE(1880),
    [sym_process_substitution] = STATE(1880),
    [aux_sym__literal_repeat1] = STATE(1882),
    [anon_sym_RBRACE] = ACTIONS(4004),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(4006),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4006),
  },
  [1196] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(4008),
    [sym_comment] = ACTIONS(57),
  },
  [1197] = {
    [sym_concatenation] = STATE(1886),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1886),
    [anon_sym_RBRACE] = ACTIONS(4010),
    [anon_sym_EQ] = ACTIONS(4012),
    [anon_sym_DASH] = ACTIONS(4012),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4014),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(4016),
    [anon_sym_COLON] = ACTIONS(4012),
    [anon_sym_COLON_QMARK] = ACTIONS(4012),
    [anon_sym_COLON_DASH] = ACTIONS(4012),
    [anon_sym_PERCENT] = ACTIONS(4012),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1198] = {
    [sym_concatenation] = STATE(1888),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1888),
    [anon_sym_RBRACE] = ACTIONS(4004),
    [anon_sym_EQ] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4018),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4020),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(4022),
    [anon_sym_COLON] = ACTIONS(4018),
    [anon_sym_COLON_QMARK] = ACTIONS(4018),
    [anon_sym_COLON_DASH] = ACTIONS(4018),
    [anon_sym_PERCENT] = ACTIONS(4018),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1199] = {
    [sym__simple_heredoc_body] = ACTIONS(2462),
    [sym__heredoc_body_beginning] = ACTIONS(2462),
    [sym_file_descriptor] = ACTIONS(2462),
    [sym__concat] = ACTIONS(2462),
    [ts_builtin_sym_end] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_RPAREN] = ACTIONS(2462),
    [anon_sym_SEMI_SEMI] = ACTIONS(2462),
    [anon_sym_PIPE_AMP] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_GT_GT] = ACTIONS(2462),
    [anon_sym_AMP_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT_GT] = ACTIONS(2462),
    [anon_sym_LT_AMP] = ACTIONS(2462),
    [anon_sym_GT_AMP] = ACTIONS(2462),
    [anon_sym_LT_LT] = ACTIONS(2464),
    [anon_sym_LT_LT_DASH] = ACTIONS(2462),
    [anon_sym_LT_LT_LT] = ACTIONS(2462),
    [anon_sym_DOLLAR] = ACTIONS(2464),
    [sym__special_character] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [sym_raw_string] = ACTIONS(2462),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2462),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2462),
    [anon_sym_BQUOTE] = ACTIONS(2462),
    [anon_sym_LT_LPAREN] = ACTIONS(2462),
    [anon_sym_GT_LPAREN] = ACTIONS(2462),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2464),
    [sym_word] = ACTIONS(2464),
    [anon_sym_LF] = ACTIONS(2462),
    [anon_sym_AMP] = ACTIONS(2464),
  },
  [1200] = {
    [sym_concatenation] = STATE(1891),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1891),
    [sym_regex] = ACTIONS(4024),
    [anon_sym_RBRACE] = ACTIONS(4026),
    [anon_sym_EQ] = ACTIONS(4028),
    [anon_sym_DASH] = ACTIONS(4028),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4030),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(4028),
    [anon_sym_COLON_QMARK] = ACTIONS(4028),
    [anon_sym_COLON_DASH] = ACTIONS(4028),
    [anon_sym_PERCENT] = ACTIONS(4028),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1201] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(4026),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1202] = {
    [sym__simple_heredoc_body] = ACTIONS(2512),
    [sym__heredoc_body_beginning] = ACTIONS(2512),
    [sym_file_descriptor] = ACTIONS(2512),
    [sym__concat] = ACTIONS(2512),
    [ts_builtin_sym_end] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2514),
    [anon_sym_PIPE] = ACTIONS(2514),
    [anon_sym_RPAREN] = ACTIONS(2512),
    [anon_sym_SEMI_SEMI] = ACTIONS(2512),
    [anon_sym_PIPE_AMP] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE_PIPE] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2514),
    [anon_sym_GT] = ACTIONS(2514),
    [anon_sym_GT_GT] = ACTIONS(2512),
    [anon_sym_AMP_GT] = ACTIONS(2514),
    [anon_sym_AMP_GT_GT] = ACTIONS(2512),
    [anon_sym_LT_AMP] = ACTIONS(2512),
    [anon_sym_GT_AMP] = ACTIONS(2512),
    [anon_sym_LT_LT] = ACTIONS(2514),
    [anon_sym_LT_LT_DASH] = ACTIONS(2512),
    [anon_sym_LT_LT_LT] = ACTIONS(2512),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [sym__special_character] = ACTIONS(2512),
    [anon_sym_DQUOTE] = ACTIONS(2512),
    [sym_raw_string] = ACTIONS(2512),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2512),
    [anon_sym_BQUOTE] = ACTIONS(2512),
    [anon_sym_LT_LPAREN] = ACTIONS(2512),
    [anon_sym_GT_LPAREN] = ACTIONS(2512),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2514),
    [sym_word] = ACTIONS(2514),
    [anon_sym_LF] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2514),
  },
  [1203] = {
    [sym_concatenation] = STATE(1888),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1888),
    [sym_regex] = ACTIONS(4032),
    [anon_sym_RBRACE] = ACTIONS(4004),
    [anon_sym_EQ] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4018),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4020),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(4018),
    [anon_sym_COLON_QMARK] = ACTIONS(4018),
    [anon_sym_COLON_DASH] = ACTIONS(4018),
    [anon_sym_PERCENT] = ACTIONS(4018),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1204] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(4004),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1205] = {
    [sym__simple_heredoc_body] = ACTIONS(2520),
    [sym__heredoc_body_beginning] = ACTIONS(2520),
    [sym_file_descriptor] = ACTIONS(2520),
    [sym__concat] = ACTIONS(2520),
    [ts_builtin_sym_end] = ACTIONS(2520),
    [anon_sym_SEMI] = ACTIONS(2522),
    [anon_sym_PIPE] = ACTIONS(2522),
    [anon_sym_RPAREN] = ACTIONS(2520),
    [anon_sym_SEMI_SEMI] = ACTIONS(2520),
    [anon_sym_PIPE_AMP] = ACTIONS(2520),
    [anon_sym_AMP_AMP] = ACTIONS(2520),
    [anon_sym_PIPE_PIPE] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(2522),
    [anon_sym_GT] = ACTIONS(2522),
    [anon_sym_GT_GT] = ACTIONS(2520),
    [anon_sym_AMP_GT] = ACTIONS(2522),
    [anon_sym_AMP_GT_GT] = ACTIONS(2520),
    [anon_sym_LT_AMP] = ACTIONS(2520),
    [anon_sym_GT_AMP] = ACTIONS(2520),
    [anon_sym_LT_LT] = ACTIONS(2522),
    [anon_sym_LT_LT_DASH] = ACTIONS(2520),
    [anon_sym_LT_LT_LT] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(2522),
    [sym__special_character] = ACTIONS(2520),
    [anon_sym_DQUOTE] = ACTIONS(2520),
    [sym_raw_string] = ACTIONS(2520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2520),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2520),
    [anon_sym_BQUOTE] = ACTIONS(2520),
    [anon_sym_LT_LPAREN] = ACTIONS(2520),
    [anon_sym_GT_LPAREN] = ACTIONS(2520),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2522),
    [sym_word] = ACTIONS(2522),
    [anon_sym_LF] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2522),
  },
  [1206] = {
    [sym__simple_heredoc_body] = ACTIONS(2554),
    [sym__heredoc_body_beginning] = ACTIONS(2554),
    [sym_file_descriptor] = ACTIONS(2554),
    [sym__concat] = ACTIONS(2554),
    [ts_builtin_sym_end] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(2556),
    [anon_sym_PIPE] = ACTIONS(2556),
    [anon_sym_RPAREN] = ACTIONS(2554),
    [anon_sym_SEMI_SEMI] = ACTIONS(2554),
    [anon_sym_PIPE_AMP] = ACTIONS(2554),
    [anon_sym_AMP_AMP] = ACTIONS(2554),
    [anon_sym_PIPE_PIPE] = ACTIONS(2554),
    [anon_sym_LT] = ACTIONS(2556),
    [anon_sym_GT] = ACTIONS(2556),
    [anon_sym_GT_GT] = ACTIONS(2554),
    [anon_sym_AMP_GT] = ACTIONS(2556),
    [anon_sym_AMP_GT_GT] = ACTIONS(2554),
    [anon_sym_LT_AMP] = ACTIONS(2554),
    [anon_sym_GT_AMP] = ACTIONS(2554),
    [anon_sym_LT_LT] = ACTIONS(2556),
    [anon_sym_LT_LT_DASH] = ACTIONS(2554),
    [anon_sym_LT_LT_LT] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2556),
    [sym__special_character] = ACTIONS(2554),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2554),
    [anon_sym_BQUOTE] = ACTIONS(2554),
    [anon_sym_LT_LPAREN] = ACTIONS(2554),
    [anon_sym_GT_LPAREN] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2556),
    [sym_word] = ACTIONS(2556),
    [anon_sym_LF] = ACTIONS(2554),
    [anon_sym_AMP] = ACTIONS(2556),
  },
  [1207] = {
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(2362),
    [sym_variable_name] = ACTIONS(2362),
    [anon_sym_RPAREN] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2362),
  },
  [1208] = {
    [sym_string] = STATE(1207),
    [sym_simple_expansion] = STATE(1207),
    [sym_string_expansion] = STATE(1207),
    [sym_expansion] = STATE(1207),
    [sym_command_substitution] = STATE(1207),
    [sym_process_substitution] = STATE(1207),
    [anon_sym_DOLLAR] = ACTIONS(4034),
    [sym__special_character] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(313),
    [sym_raw_string] = ACTIONS(2321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(317),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(319),
    [anon_sym_BQUOTE] = ACTIONS(321),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2321),
  },
  [1209] = {
    [aux_sym_concatenation_repeat1] = STATE(1209),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(4036),
    [sym_variable_name] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2362),
  },
  [1210] = {
    [sym_file_descriptor] = ACTIONS(2371),
    [sym__concat] = ACTIONS(2371),
    [sym_variable_name] = ACTIONS(2371),
    [anon_sym_RPAREN] = ACTIONS(2371),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_GT_GT] = ACTIONS(2371),
    [anon_sym_AMP_GT] = ACTIONS(2373),
    [anon_sym_AMP_GT_GT] = ACTIONS(2371),
    [anon_sym_LT_AMP] = ACTIONS(2371),
    [anon_sym_GT_AMP] = ACTIONS(2371),
    [anon_sym_DOLLAR] = ACTIONS(2373),
    [sym__special_character] = ACTIONS(2371),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [sym_raw_string] = ACTIONS(2371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2371),
    [anon_sym_BQUOTE] = ACTIONS(2371),
    [anon_sym_LT_LPAREN] = ACTIONS(2371),
    [anon_sym_GT_LPAREN] = ACTIONS(2371),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2371),
  },
  [1211] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(4039),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [1212] = {
    [sym_concatenation] = STATE(1897),
    [sym_string] = STATE(1896),
    [sym_simple_expansion] = STATE(1896),
    [sym_string_expansion] = STATE(1896),
    [sym_expansion] = STATE(1896),
    [sym_command_substitution] = STATE(1896),
    [sym_process_substitution] = STATE(1896),
    [aux_sym__literal_repeat1] = STATE(1898),
    [anon_sym_RBRACE] = ACTIONS(4041),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(4043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4043),
  },
  [1213] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(4045),
    [sym_comment] = ACTIONS(57),
  },
  [1214] = {
    [sym_concatenation] = STATE(1902),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1902),
    [anon_sym_RBRACE] = ACTIONS(4047),
    [anon_sym_EQ] = ACTIONS(4049),
    [anon_sym_DASH] = ACTIONS(4049),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4051),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(4053),
    [anon_sym_COLON] = ACTIONS(4049),
    [anon_sym_COLON_QMARK] = ACTIONS(4049),
    [anon_sym_COLON_DASH] = ACTIONS(4049),
    [anon_sym_PERCENT] = ACTIONS(4049),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1215] = {
    [sym_concatenation] = STATE(1904),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1904),
    [anon_sym_RBRACE] = ACTIONS(4041),
    [anon_sym_EQ] = ACTIONS(4055),
    [anon_sym_DASH] = ACTIONS(4055),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(4059),
    [anon_sym_COLON] = ACTIONS(4055),
    [anon_sym_COLON_QMARK] = ACTIONS(4055),
    [anon_sym_COLON_DASH] = ACTIONS(4055),
    [anon_sym_PERCENT] = ACTIONS(4055),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1216] = {
    [sym_file_descriptor] = ACTIONS(2462),
    [sym__concat] = ACTIONS(2462),
    [sym_variable_name] = ACTIONS(2462),
    [anon_sym_RPAREN] = ACTIONS(2462),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_GT_GT] = ACTIONS(2462),
    [anon_sym_AMP_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT_GT] = ACTIONS(2462),
    [anon_sym_LT_AMP] = ACTIONS(2462),
    [anon_sym_GT_AMP] = ACTIONS(2462),
    [anon_sym_DOLLAR] = ACTIONS(2464),
    [sym__special_character] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [sym_raw_string] = ACTIONS(2462),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2462),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2462),
    [anon_sym_BQUOTE] = ACTIONS(2462),
    [anon_sym_LT_LPAREN] = ACTIONS(2462),
    [anon_sym_GT_LPAREN] = ACTIONS(2462),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2462),
  },
  [1217] = {
    [sym_concatenation] = STATE(1907),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1907),
    [sym_regex] = ACTIONS(4061),
    [anon_sym_RBRACE] = ACTIONS(4063),
    [anon_sym_EQ] = ACTIONS(4065),
    [anon_sym_DASH] = ACTIONS(4065),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4067),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(4065),
    [anon_sym_COLON_QMARK] = ACTIONS(4065),
    [anon_sym_COLON_DASH] = ACTIONS(4065),
    [anon_sym_PERCENT] = ACTIONS(4065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1218] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(4063),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1219] = {
    [sym_file_descriptor] = ACTIONS(2512),
    [sym__concat] = ACTIONS(2512),
    [sym_variable_name] = ACTIONS(2512),
    [anon_sym_RPAREN] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2514),
    [anon_sym_GT] = ACTIONS(2514),
    [anon_sym_GT_GT] = ACTIONS(2512),
    [anon_sym_AMP_GT] = ACTIONS(2514),
    [anon_sym_AMP_GT_GT] = ACTIONS(2512),
    [anon_sym_LT_AMP] = ACTIONS(2512),
    [anon_sym_GT_AMP] = ACTIONS(2512),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [sym__special_character] = ACTIONS(2512),
    [anon_sym_DQUOTE] = ACTIONS(2512),
    [sym_raw_string] = ACTIONS(2512),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2512),
    [anon_sym_BQUOTE] = ACTIONS(2512),
    [anon_sym_LT_LPAREN] = ACTIONS(2512),
    [anon_sym_GT_LPAREN] = ACTIONS(2512),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2512),
  },
  [1220] = {
    [sym_concatenation] = STATE(1904),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1904),
    [sym_regex] = ACTIONS(4069),
    [anon_sym_RBRACE] = ACTIONS(4041),
    [anon_sym_EQ] = ACTIONS(4055),
    [anon_sym_DASH] = ACTIONS(4055),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(4055),
    [anon_sym_COLON_QMARK] = ACTIONS(4055),
    [anon_sym_COLON_DASH] = ACTIONS(4055),
    [anon_sym_PERCENT] = ACTIONS(4055),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1221] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(4041),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1222] = {
    [sym_file_descriptor] = ACTIONS(2520),
    [sym__concat] = ACTIONS(2520),
    [sym_variable_name] = ACTIONS(2520),
    [anon_sym_RPAREN] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(2522),
    [anon_sym_GT] = ACTIONS(2522),
    [anon_sym_GT_GT] = ACTIONS(2520),
    [anon_sym_AMP_GT] = ACTIONS(2522),
    [anon_sym_AMP_GT_GT] = ACTIONS(2520),
    [anon_sym_LT_AMP] = ACTIONS(2520),
    [anon_sym_GT_AMP] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(2522),
    [sym__special_character] = ACTIONS(2520),
    [anon_sym_DQUOTE] = ACTIONS(2520),
    [sym_raw_string] = ACTIONS(2520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2520),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2520),
    [anon_sym_BQUOTE] = ACTIONS(2520),
    [anon_sym_LT_LPAREN] = ACTIONS(2520),
    [anon_sym_GT_LPAREN] = ACTIONS(2520),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2520),
  },
  [1223] = {
    [sym_file_descriptor] = ACTIONS(2554),
    [sym__concat] = ACTIONS(2554),
    [sym_variable_name] = ACTIONS(2554),
    [anon_sym_RPAREN] = ACTIONS(2554),
    [anon_sym_LT] = ACTIONS(2556),
    [anon_sym_GT] = ACTIONS(2556),
    [anon_sym_GT_GT] = ACTIONS(2554),
    [anon_sym_AMP_GT] = ACTIONS(2556),
    [anon_sym_AMP_GT_GT] = ACTIONS(2554),
    [anon_sym_LT_AMP] = ACTIONS(2554),
    [anon_sym_GT_AMP] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2556),
    [sym__special_character] = ACTIONS(2554),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2554),
    [anon_sym_BQUOTE] = ACTIONS(2554),
    [anon_sym_LT_LPAREN] = ACTIONS(2554),
    [anon_sym_GT_LPAREN] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2554),
  },
  [1224] = {
    [sym_string] = STATE(198),
    [sym__simple_heredoc_body] = ACTIONS(4071),
    [sym__heredoc_body_beginning] = ACTIONS(4071),
    [sym_file_descriptor] = ACTIONS(4071),
    [ts_builtin_sym_end] = ACTIONS(4071),
    [anon_sym_SEMI] = ACTIONS(4073),
    [anon_sym_PIPE] = ACTIONS(4073),
    [anon_sym_RPAREN] = ACTIONS(4071),
    [anon_sym_SEMI_SEMI] = ACTIONS(4071),
    [anon_sym_PIPE_AMP] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_PIPE_PIPE] = ACTIONS(4071),
    [anon_sym_EQ_TILDE] = ACTIONS(4073),
    [anon_sym_EQ_EQ] = ACTIONS(4073),
    [anon_sym_LT] = ACTIONS(4073),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_GT_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT] = ACTIONS(4073),
    [anon_sym_AMP_GT_GT] = ACTIONS(4071),
    [anon_sym_LT_AMP] = ACTIONS(4071),
    [anon_sym_GT_AMP] = ACTIONS(4071),
    [anon_sym_LT_LT] = ACTIONS(4073),
    [anon_sym_LT_LT_DASH] = ACTIONS(4071),
    [anon_sym_LT_LT_LT] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(4075),
    [anon_sym_DOLLAR] = ACTIONS(4075),
    [sym__special_character] = ACTIONS(4071),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(327),
    [anon_sym_POUND] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4071),
    [anon_sym_BQUOTE] = ACTIONS(4071),
    [anon_sym_LT_LPAREN] = ACTIONS(4071),
    [anon_sym_GT_LPAREN] = ACTIONS(4071),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(331),
    [anon_sym_STAR] = ACTIONS(331),
    [anon_sym_AT] = ACTIONS(331),
    [anon_sym_QMARK] = ACTIONS(331),
    [anon_sym_0] = ACTIONS(331),
    [anon_sym__] = ACTIONS(331),
    [sym_word] = ACTIONS(4073),
    [anon_sym_LF] = ACTIONS(4071),
    [anon_sym_AMP] = ACTIONS(4073),
  },
  [1225] = {
    [anon_sym_DOLLAR] = ACTIONS(4077),
    [anon_sym_DQUOTE] = ACTIONS(4077),
    [sym__string_content] = ACTIONS(4079),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4077),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4077),
    [anon_sym_BQUOTE] = ACTIONS(4077),
    [sym_comment] = ACTIONS(329),
  },
  [1226] = {
    [sym_concatenation] = STATE(1911),
    [sym_string] = STATE(1910),
    [sym_simple_expansion] = STATE(1910),
    [sym_string_expansion] = STATE(1910),
    [sym_expansion] = STATE(1910),
    [sym_command_substitution] = STATE(1910),
    [sym_process_substitution] = STATE(1910),
    [aux_sym__literal_repeat1] = STATE(1912),
    [anon_sym_RBRACE] = ACTIONS(4081),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(4083),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4083),
  },
  [1227] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(4085),
    [sym_comment] = ACTIONS(57),
  },
  [1228] = {
    [sym_concatenation] = STATE(1916),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1916),
    [anon_sym_RBRACE] = ACTIONS(4087),
    [anon_sym_EQ] = ACTIONS(4089),
    [anon_sym_DASH] = ACTIONS(4089),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(4093),
    [anon_sym_COLON] = ACTIONS(4089),
    [anon_sym_COLON_QMARK] = ACTIONS(4089),
    [anon_sym_COLON_DASH] = ACTIONS(4089),
    [anon_sym_PERCENT] = ACTIONS(4089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1229] = {
    [sym_concatenation] = STATE(1918),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1918),
    [anon_sym_RBRACE] = ACTIONS(4081),
    [anon_sym_EQ] = ACTIONS(4095),
    [anon_sym_DASH] = ACTIONS(4095),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(4099),
    [anon_sym_COLON] = ACTIONS(4095),
    [anon_sym_COLON_QMARK] = ACTIONS(4095),
    [anon_sym_COLON_DASH] = ACTIONS(4095),
    [anon_sym_PERCENT] = ACTIONS(4095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1230] = {
    [sym__concat] = ACTIONS(2462),
    [anon_sym_DOLLAR] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [sym__string_content] = ACTIONS(2462),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2464),
    [anon_sym_BQUOTE] = ACTIONS(2464),
    [sym_comment] = ACTIONS(329),
  },
  [1231] = {
    [sym_concatenation] = STATE(1921),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1921),
    [sym_regex] = ACTIONS(4101),
    [anon_sym_RBRACE] = ACTIONS(4103),
    [anon_sym_EQ] = ACTIONS(4105),
    [anon_sym_DASH] = ACTIONS(4105),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(4105),
    [anon_sym_COLON_QMARK] = ACTIONS(4105),
    [anon_sym_COLON_DASH] = ACTIONS(4105),
    [anon_sym_PERCENT] = ACTIONS(4105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1232] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(4103),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1233] = {
    [sym__concat] = ACTIONS(2512),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [anon_sym_DQUOTE] = ACTIONS(2514),
    [sym__string_content] = ACTIONS(2512),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2514),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2514),
    [anon_sym_BQUOTE] = ACTIONS(2514),
    [sym_comment] = ACTIONS(329),
  },
  [1234] = {
    [sym_concatenation] = STATE(1918),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1918),
    [sym_regex] = ACTIONS(4109),
    [anon_sym_RBRACE] = ACTIONS(4081),
    [anon_sym_EQ] = ACTIONS(4095),
    [anon_sym_DASH] = ACTIONS(4095),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(4095),
    [anon_sym_COLON_QMARK] = ACTIONS(4095),
    [anon_sym_COLON_DASH] = ACTIONS(4095),
    [anon_sym_PERCENT] = ACTIONS(4095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1235] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(4081),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1236] = {
    [sym__concat] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(2522),
    [anon_sym_DQUOTE] = ACTIONS(2522),
    [sym__string_content] = ACTIONS(2520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2522),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2522),
    [anon_sym_BQUOTE] = ACTIONS(2522),
    [sym_comment] = ACTIONS(329),
  },
  [1237] = {
    [sym__simple_heredoc_body] = ACTIONS(4111),
    [sym__heredoc_body_beginning] = ACTIONS(4111),
    [sym_file_descriptor] = ACTIONS(4111),
    [sym__concat] = ACTIONS(4111),
    [ts_builtin_sym_end] = ACTIONS(4111),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_PIPE] = ACTIONS(4113),
    [anon_sym_RPAREN] = ACTIONS(4111),
    [anon_sym_SEMI_SEMI] = ACTIONS(4111),
    [anon_sym_PIPE_AMP] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_EQ_TILDE] = ACTIONS(4113),
    [anon_sym_EQ_EQ] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4113),
    [anon_sym_GT_GT] = ACTIONS(4111),
    [anon_sym_AMP_GT] = ACTIONS(4113),
    [anon_sym_AMP_GT_GT] = ACTIONS(4111),
    [anon_sym_LT_AMP] = ACTIONS(4111),
    [anon_sym_GT_AMP] = ACTIONS(4111),
    [anon_sym_LT_LT] = ACTIONS(4113),
    [anon_sym_LT_LT_DASH] = ACTIONS(4111),
    [anon_sym_LT_LT_LT] = ACTIONS(4111),
    [anon_sym_DOLLAR] = ACTIONS(4113),
    [sym__special_character] = ACTIONS(4111),
    [anon_sym_DQUOTE] = ACTIONS(4111),
    [sym_raw_string] = ACTIONS(4111),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4111),
    [anon_sym_BQUOTE] = ACTIONS(4111),
    [anon_sym_LT_LPAREN] = ACTIONS(4111),
    [anon_sym_GT_LPAREN] = ACTIONS(4111),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4113),
    [anon_sym_LF] = ACTIONS(4111),
    [anon_sym_AMP] = ACTIONS(4113),
  },
  [1238] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [1239] = {
    [aux_sym_concatenation_repeat1] = STATE(718),
    [sym__concat] = ACTIONS(4115),
    [anon_sym_RBRACK] = ACTIONS(4117),
    [sym_comment] = ACTIONS(57),
  },
  [1240] = {
    [sym__concat] = ACTIONS(4119),
    [anon_sym_RBRACK] = ACTIONS(4117),
    [sym_comment] = ACTIONS(57),
  },
  [1241] = {
    [aux_sym__literal_repeat1] = STATE(725),
    [sym__concat] = ACTIONS(4121),
    [anon_sym_RBRACK] = ACTIONS(4123),
    [sym__special_character] = ACTIONS(1398),
    [sym_comment] = ACTIONS(57),
  },
  [1242] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [ts_builtin_sym_end] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_RPAREN] = ACTIONS(4125),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_EQ_TILDE] = ACTIONS(4127),
    [anon_sym_EQ_EQ] = ACTIONS(4127),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym__special_character] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [1243] = {
    [sym_string] = STATE(1929),
    [anon_sym_DASH] = ACTIONS(4129),
    [anon_sym_DOLLAR] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(4131),
    [anon_sym_POUND] = ACTIONS(4129),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4133),
    [anon_sym_STAR] = ACTIONS(4135),
    [anon_sym_AT] = ACTIONS(4135),
    [anon_sym_QMARK] = ACTIONS(4135),
    [anon_sym_0] = ACTIONS(4133),
    [anon_sym__] = ACTIONS(4133),
  },
  [1244] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(335),
    [sym__special_character] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
  },
  [1245] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(1935),
    [anon_sym_DOLLAR] = ACTIONS(4139),
    [anon_sym_DQUOTE] = ACTIONS(4141),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [1246] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(4143),
    [sym_comment] = ACTIONS(57),
  },
  [1247] = {
    [sym_subscript] = STATE(1940),
    [sym_variable_name] = ACTIONS(4145),
    [anon_sym_BANG] = ACTIONS(4147),
    [anon_sym_DASH] = ACTIONS(4149),
    [anon_sym_DOLLAR] = ACTIONS(4149),
    [anon_sym_POUND] = ACTIONS(4147),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4151),
    [anon_sym_STAR] = ACTIONS(4153),
    [anon_sym_AT] = ACTIONS(4153),
    [anon_sym_QMARK] = ACTIONS(4153),
    [anon_sym_0] = ACTIONS(4151),
    [anon_sym__] = ACTIONS(4151),
  },
  [1248] = {
    [sym__statements] = STATE(1941),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(1942),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [1249] = {
    [sym__statements] = STATE(1943),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [1250] = {
    [sym__statements] = STATE(1944),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [1251] = {
    [anon_sym_RBRACE] = ACTIONS(4143),
    [sym_comment] = ACTIONS(57),
  },
  [1252] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(4155),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [1253] = {
    [sym_concatenation] = STATE(1949),
    [sym_string] = STATE(1948),
    [sym_simple_expansion] = STATE(1948),
    [sym_string_expansion] = STATE(1948),
    [sym_expansion] = STATE(1948),
    [sym_command_substitution] = STATE(1948),
    [sym_process_substitution] = STATE(1948),
    [aux_sym__literal_repeat1] = STATE(1950),
    [anon_sym_RBRACE] = ACTIONS(4143),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(4159),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4159),
  },
  [1254] = {
    [sym__simple_heredoc_body] = ACTIONS(4161),
    [sym__heredoc_body_beginning] = ACTIONS(4161),
    [sym_file_descriptor] = ACTIONS(4161),
    [sym__concat] = ACTIONS(4161),
    [ts_builtin_sym_end] = ACTIONS(4161),
    [anon_sym_SEMI] = ACTIONS(4163),
    [anon_sym_PIPE] = ACTIONS(4163),
    [anon_sym_RPAREN] = ACTIONS(4161),
    [anon_sym_SEMI_SEMI] = ACTIONS(4161),
    [anon_sym_PIPE_AMP] = ACTIONS(4161),
    [anon_sym_AMP_AMP] = ACTIONS(4161),
    [anon_sym_PIPE_PIPE] = ACTIONS(4161),
    [anon_sym_EQ_TILDE] = ACTIONS(4163),
    [anon_sym_EQ_EQ] = ACTIONS(4163),
    [anon_sym_LT] = ACTIONS(4163),
    [anon_sym_GT] = ACTIONS(4163),
    [anon_sym_GT_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT] = ACTIONS(4163),
    [anon_sym_AMP_GT_GT] = ACTIONS(4161),
    [anon_sym_LT_AMP] = ACTIONS(4161),
    [anon_sym_GT_AMP] = ACTIONS(4161),
    [anon_sym_LT_LT] = ACTIONS(4163),
    [anon_sym_LT_LT_DASH] = ACTIONS(4161),
    [anon_sym_LT_LT_LT] = ACTIONS(4161),
    [anon_sym_DOLLAR] = ACTIONS(4163),
    [sym__special_character] = ACTIONS(4161),
    [anon_sym_DQUOTE] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4161),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4161),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4161),
    [anon_sym_BQUOTE] = ACTIONS(4161),
    [anon_sym_LT_LPAREN] = ACTIONS(4161),
    [anon_sym_GT_LPAREN] = ACTIONS(4161),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4163),
    [anon_sym_LF] = ACTIONS(4161),
    [anon_sym_AMP] = ACTIONS(4163),
  },
  [1255] = {
    [sym_concatenation] = STATE(1953),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1953),
    [sym_regex] = ACTIONS(4165),
    [anon_sym_RBRACE] = ACTIONS(4167),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_DASH] = ACTIONS(4169),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(4169),
    [anon_sym_COLON_QMARK] = ACTIONS(4169),
    [anon_sym_COLON_DASH] = ACTIONS(4169),
    [anon_sym_PERCENT] = ACTIONS(4169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1256] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(4167),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1257] = {
    [sym_concatenation] = STATE(1955),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1955),
    [sym_regex] = ACTIONS(4173),
    [anon_sym_RBRACE] = ACTIONS(4143),
    [anon_sym_EQ] = ACTIONS(4175),
    [anon_sym_DASH] = ACTIONS(4175),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4177),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(4175),
    [anon_sym_COLON_QMARK] = ACTIONS(4175),
    [anon_sym_COLON_DASH] = ACTIONS(4175),
    [anon_sym_PERCENT] = ACTIONS(4175),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1258] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(4143),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1259] = {
    [sym__concat] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(1057),
    [anon_sym_EQ] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [sym_raw_string] = ACTIONS(1057),
    [anon_sym_POUND] = ACTIONS(1057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1057),
    [anon_sym_COLON] = ACTIONS(1059),
    [anon_sym_COLON_QMARK] = ACTIONS(1059),
    [anon_sym_COLON_DASH] = ACTIONS(1059),
    [anon_sym_PERCENT] = ACTIONS(1059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1057),
    [anon_sym_BQUOTE] = ACTIONS(1057),
    [anon_sym_LT_LPAREN] = ACTIONS(1057),
    [anon_sym_GT_LPAREN] = ACTIONS(1057),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1059),
  },
  [1260] = {
    [sym__concat] = ACTIONS(1061),
    [anon_sym_RBRACE] = ACTIONS(1061),
    [anon_sym_EQ] = ACTIONS(1063),
    [anon_sym_DASH] = ACTIONS(1063),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1061),
    [anon_sym_POUND] = ACTIONS(1061),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1061),
    [anon_sym_COLON] = ACTIONS(1063),
    [anon_sym_COLON_QMARK] = ACTIONS(1063),
    [anon_sym_COLON_DASH] = ACTIONS(1063),
    [anon_sym_PERCENT] = ACTIONS(1063),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1061),
    [anon_sym_LT_LPAREN] = ACTIONS(1061),
    [anon_sym_GT_LPAREN] = ACTIONS(1061),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1063),
  },
  [1261] = {
    [sym__concat] = ACTIONS(1065),
    [anon_sym_RBRACE] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(1067),
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DOLLAR] = ACTIONS(1067),
    [sym__special_character] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1065),
    [anon_sym_POUND] = ACTIONS(1065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1065),
    [anon_sym_COLON] = ACTIONS(1067),
    [anon_sym_COLON_QMARK] = ACTIONS(1067),
    [anon_sym_COLON_DASH] = ACTIONS(1067),
    [anon_sym_PERCENT] = ACTIONS(1067),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LT_LPAREN] = ACTIONS(1065),
    [anon_sym_GT_LPAREN] = ACTIONS(1065),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1067),
  },
  [1262] = {
    [sym_string] = STATE(1956),
    [sym_simple_expansion] = STATE(1956),
    [sym_string_expansion] = STATE(1956),
    [sym_expansion] = STATE(1956),
    [sym_command_substitution] = STATE(1956),
    [sym_process_substitution] = STATE(1956),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(4179),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(4179),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4179),
  },
  [1263] = {
    [aux_sym_concatenation_repeat1] = STATE(1958),
    [sym__concat] = ACTIONS(4181),
    [anon_sym_RBRACE] = ACTIONS(1071),
    [anon_sym_EQ] = ACTIONS(1075),
    [anon_sym_DASH] = ACTIONS(1075),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [sym__special_character] = ACTIONS(1075),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_POUND] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_COLON] = ACTIONS(1075),
    [anon_sym_COLON_QMARK] = ACTIONS(1075),
    [anon_sym_COLON_DASH] = ACTIONS(1075),
    [anon_sym_PERCENT] = ACTIONS(1075),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1075),
  },
  [1264] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(4183),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [1265] = {
    [sym__concat] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_DASH] = ACTIONS(1091),
    [anon_sym_DOLLAR] = ACTIONS(1091),
    [sym__special_character] = ACTIONS(1091),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1089),
    [anon_sym_POUND] = ACTIONS(1089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1089),
    [anon_sym_COLON] = ACTIONS(1091),
    [anon_sym_COLON_QMARK] = ACTIONS(1091),
    [anon_sym_COLON_DASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1089),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1089),
    [anon_sym_GT_LPAREN] = ACTIONS(1089),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1091),
  },
  [1266] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(627),
    [anon_sym_DOLLAR] = ACTIONS(4185),
    [anon_sym_DQUOTE] = ACTIONS(4183),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [1267] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(4187),
    [sym_comment] = ACTIONS(57),
  },
  [1268] = {
    [sym_subscript] = STATE(1964),
    [sym_variable_name] = ACTIONS(4189),
    [anon_sym_DASH] = ACTIONS(4191),
    [anon_sym_DOLLAR] = ACTIONS(4191),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4193),
    [anon_sym_STAR] = ACTIONS(4195),
    [anon_sym_AT] = ACTIONS(4195),
    [anon_sym_QMARK] = ACTIONS(4195),
    [anon_sym_0] = ACTIONS(4193),
    [anon_sym__] = ACTIONS(4193),
  },
  [1269] = {
    [sym_concatenation] = STATE(1967),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1967),
    [anon_sym_RBRACE] = ACTIONS(4197),
    [anon_sym_EQ] = ACTIONS(4199),
    [anon_sym_DASH] = ACTIONS(4199),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4201),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(4203),
    [anon_sym_COLON] = ACTIONS(4199),
    [anon_sym_COLON_QMARK] = ACTIONS(4199),
    [anon_sym_COLON_DASH] = ACTIONS(4199),
    [anon_sym_PERCENT] = ACTIONS(4199),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1270] = {
    [sym_concatenation] = STATE(1970),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1970),
    [anon_sym_RBRACE] = ACTIONS(4205),
    [anon_sym_EQ] = ACTIONS(4207),
    [anon_sym_DASH] = ACTIONS(4207),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4209),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(4211),
    [anon_sym_COLON] = ACTIONS(4207),
    [anon_sym_COLON_QMARK] = ACTIONS(4207),
    [anon_sym_COLON_DASH] = ACTIONS(4207),
    [anon_sym_PERCENT] = ACTIONS(4207),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1271] = {
    [sym_concatenation] = STATE(1972),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1972),
    [anon_sym_RBRACE] = ACTIONS(4213),
    [anon_sym_EQ] = ACTIONS(4215),
    [anon_sym_DASH] = ACTIONS(4215),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4217),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(4215),
    [anon_sym_COLON_QMARK] = ACTIONS(4215),
    [anon_sym_COLON_DASH] = ACTIONS(4215),
    [anon_sym_PERCENT] = ACTIONS(4215),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1272] = {
    [sym__simple_heredoc_body] = ACTIONS(4219),
    [sym__heredoc_body_beginning] = ACTIONS(4219),
    [sym_file_descriptor] = ACTIONS(4219),
    [sym__concat] = ACTIONS(4219),
    [ts_builtin_sym_end] = ACTIONS(4219),
    [anon_sym_SEMI] = ACTIONS(4221),
    [anon_sym_PIPE] = ACTIONS(4221),
    [anon_sym_RPAREN] = ACTIONS(4219),
    [anon_sym_SEMI_SEMI] = ACTIONS(4219),
    [anon_sym_PIPE_AMP] = ACTIONS(4219),
    [anon_sym_AMP_AMP] = ACTIONS(4219),
    [anon_sym_PIPE_PIPE] = ACTIONS(4219),
    [anon_sym_EQ_TILDE] = ACTIONS(4221),
    [anon_sym_EQ_EQ] = ACTIONS(4221),
    [anon_sym_LT] = ACTIONS(4221),
    [anon_sym_GT] = ACTIONS(4221),
    [anon_sym_GT_GT] = ACTIONS(4219),
    [anon_sym_AMP_GT] = ACTIONS(4221),
    [anon_sym_AMP_GT_GT] = ACTIONS(4219),
    [anon_sym_LT_AMP] = ACTIONS(4219),
    [anon_sym_GT_AMP] = ACTIONS(4219),
    [anon_sym_LT_LT] = ACTIONS(4221),
    [anon_sym_LT_LT_DASH] = ACTIONS(4219),
    [anon_sym_LT_LT_LT] = ACTIONS(4219),
    [anon_sym_DOLLAR] = ACTIONS(4221),
    [sym__special_character] = ACTIONS(4219),
    [anon_sym_DQUOTE] = ACTIONS(4219),
    [sym_raw_string] = ACTIONS(4219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4219),
    [anon_sym_BQUOTE] = ACTIONS(4219),
    [anon_sym_LT_LPAREN] = ACTIONS(4219),
    [anon_sym_GT_LPAREN] = ACTIONS(4219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4221),
    [anon_sym_LF] = ACTIONS(4219),
    [anon_sym_AMP] = ACTIONS(4221),
  },
  [1273] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(4213),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1274] = {
    [anon_sym_RPAREN] = ACTIONS(4223),
    [sym_comment] = ACTIONS(57),
  },
  [1275] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(4223),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [1276] = {
    [anon_sym_BQUOTE] = ACTIONS(4223),
    [sym_comment] = ACTIONS(57),
  },
  [1277] = {
    [anon_sym_RPAREN] = ACTIONS(4225),
    [sym_comment] = ACTIONS(57),
  },
  [1278] = {
    [anon_sym_RBRACE] = ACTIONS(335),
    [anon_sym_EQ] = ACTIONS(339),
    [anon_sym_DASH] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_POUND] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_COLON] = ACTIONS(339),
    [anon_sym_COLON_QMARK] = ACTIONS(339),
    [anon_sym_COLON_DASH] = ACTIONS(339),
    [anon_sym_PERCENT] = ACTIONS(339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(339),
  },
  [1279] = {
    [aux_sym__literal_repeat1] = STATE(1279),
    [anon_sym_RBRACE] = ACTIONS(1373),
    [anon_sym_EQ] = ACTIONS(1375),
    [anon_sym_DASH] = ACTIONS(1375),
    [anon_sym_DOLLAR] = ACTIONS(1375),
    [sym__special_character] = ACTIONS(4227),
    [anon_sym_DQUOTE] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1373),
    [anon_sym_POUND] = ACTIONS(1373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1373),
    [anon_sym_COLON] = ACTIONS(1375),
    [anon_sym_COLON_QMARK] = ACTIONS(1375),
    [anon_sym_COLON_DASH] = ACTIONS(1375),
    [anon_sym_PERCENT] = ACTIONS(1375),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1373),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [anon_sym_LT_LPAREN] = ACTIONS(1373),
    [anon_sym_GT_LPAREN] = ACTIONS(1373),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1375),
  },
  [1280] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(4230),
    [anon_sym_EQ] = ACTIONS(4232),
    [anon_sym_DASH] = ACTIONS(4232),
    [anon_sym_DOLLAR] = ACTIONS(4235),
    [sym__special_character] = ACTIONS(4238),
    [anon_sym_DQUOTE] = ACTIONS(4241),
    [sym_raw_string] = ACTIONS(4244),
    [anon_sym_POUND] = ACTIONS(4247),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4250),
    [anon_sym_COLON] = ACTIONS(4232),
    [anon_sym_COLON_QMARK] = ACTIONS(4232),
    [anon_sym_COLON_DASH] = ACTIONS(4232),
    [anon_sym_PERCENT] = ACTIONS(4232),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4253),
    [anon_sym_BQUOTE] = ACTIONS(4256),
    [anon_sym_LT_LPAREN] = ACTIONS(4259),
    [anon_sym_GT_LPAREN] = ACTIONS(4259),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(4262),
  },
  [1281] = {
    [sym_concatenation] = STATE(1955),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1955),
    [anon_sym_RBRACE] = ACTIONS(4143),
    [anon_sym_EQ] = ACTIONS(4175),
    [anon_sym_DASH] = ACTIONS(4175),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4177),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(4175),
    [anon_sym_COLON_QMARK] = ACTIONS(4175),
    [anon_sym_COLON_DASH] = ACTIONS(4175),
    [anon_sym_PERCENT] = ACTIONS(4175),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1282] = {
    [aux_sym_concatenation_repeat1] = STATE(1284),
    [sym_file_descriptor] = ACTIONS(1380),
    [sym__concat] = ACTIONS(1031),
    [sym_variable_name] = ACTIONS(1380),
    [anon_sym_RPAREN] = ACTIONS(1380),
    [anon_sym_LT] = ACTIONS(1382),
    [anon_sym_GT] = ACTIONS(1382),
    [anon_sym_GT_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT] = ACTIONS(1382),
    [anon_sym_AMP_GT_GT] = ACTIONS(1380),
    [anon_sym_LT_AMP] = ACTIONS(1380),
    [anon_sym_GT_AMP] = ACTIONS(1380),
    [anon_sym_DOLLAR] = ACTIONS(1382),
    [sym__special_character] = ACTIONS(1380),
    [anon_sym_DQUOTE] = ACTIONS(1380),
    [sym_raw_string] = ACTIONS(1380),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1380),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1380),
    [anon_sym_BQUOTE] = ACTIONS(1380),
    [anon_sym_LT_LPAREN] = ACTIONS(1380),
    [anon_sym_GT_LPAREN] = ACTIONS(1380),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1380),
  },
  [1283] = {
    [aux_sym__literal_repeat1] = STATE(1285),
    [sym_file_descriptor] = ACTIONS(1384),
    [sym_variable_name] = ACTIONS(1384),
    [anon_sym_RPAREN] = ACTIONS(1384),
    [anon_sym_LT] = ACTIONS(1386),
    [anon_sym_GT] = ACTIONS(1386),
    [anon_sym_GT_GT] = ACTIONS(1384),
    [anon_sym_AMP_GT] = ACTIONS(1386),
    [anon_sym_AMP_GT_GT] = ACTIONS(1384),
    [anon_sym_LT_AMP] = ACTIONS(1384),
    [anon_sym_GT_AMP] = ACTIONS(1384),
    [anon_sym_DOLLAR] = ACTIONS(1386),
    [sym__special_character] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1384),
    [sym_raw_string] = ACTIONS(1384),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1384),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1384),
    [anon_sym_BQUOTE] = ACTIONS(1384),
    [anon_sym_LT_LPAREN] = ACTIONS(1384),
    [anon_sym_GT_LPAREN] = ACTIONS(1384),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1384),
  },
  [1284] = {
    [aux_sym_concatenation_repeat1] = STATE(1975),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(2323),
    [sym_variable_name] = ACTIONS(1071),
    [anon_sym_RPAREN] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [sym__special_character] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1071),
  },
  [1285] = {
    [aux_sym__literal_repeat1] = STATE(1285),
    [sym_file_descriptor] = ACTIONS(1373),
    [sym_variable_name] = ACTIONS(1373),
    [anon_sym_RPAREN] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_DOLLAR] = ACTIONS(1375),
    [sym__special_character] = ACTIONS(2359),
    [anon_sym_DQUOTE] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1373),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [anon_sym_LT_LPAREN] = ACTIONS(1373),
    [anon_sym_GT_LPAREN] = ACTIONS(1373),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1373),
  },
  [1286] = {
    [aux_sym_concatenation_repeat1] = STATE(1976),
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(1430),
    [sym_variable_name] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [1287] = {
    [aux_sym_concatenation_repeat1] = STATE(1976),
    [sym__simple_heredoc_body] = ACTIONS(1400),
    [sym__heredoc_body_beginning] = ACTIONS(1400),
    [sym_file_descriptor] = ACTIONS(1400),
    [sym__concat] = ACTIONS(1430),
    [sym_variable_name] = ACTIONS(1400),
    [anon_sym_SEMI] = ACTIONS(1402),
    [anon_sym_PIPE] = ACTIONS(1402),
    [anon_sym_SEMI_SEMI] = ACTIONS(1400),
    [anon_sym_PIPE_AMP] = ACTIONS(1400),
    [anon_sym_AMP_AMP] = ACTIONS(1400),
    [anon_sym_PIPE_PIPE] = ACTIONS(1400),
    [anon_sym_LT] = ACTIONS(1402),
    [anon_sym_GT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT] = ACTIONS(1402),
    [anon_sym_AMP_GT_GT] = ACTIONS(1400),
    [anon_sym_LT_AMP] = ACTIONS(1400),
    [anon_sym_GT_AMP] = ACTIONS(1400),
    [anon_sym_LT_LT] = ACTIONS(1402),
    [anon_sym_LT_LT_DASH] = ACTIONS(1400),
    [anon_sym_LT_LT_LT] = ACTIONS(1400),
    [anon_sym_DOLLAR] = ACTIONS(1402),
    [sym__special_character] = ACTIONS(1400),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1400),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1400),
    [anon_sym_BQUOTE] = ACTIONS(1400),
    [anon_sym_LT_LPAREN] = ACTIONS(1400),
    [anon_sym_GT_LPAREN] = ACTIONS(1400),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1402),
    [anon_sym_LF] = ACTIONS(1400),
    [anon_sym_AMP] = ACTIONS(1402),
  },
  [1288] = {
    [aux_sym__literal_repeat1] = STATE(1977),
    [sym__simple_heredoc_body] = ACTIONS(1446),
    [sym__heredoc_body_beginning] = ACTIONS(1446),
    [sym_file_descriptor] = ACTIONS(1446),
    [sym_variable_name] = ACTIONS(1446),
    [anon_sym_SEMI] = ACTIONS(1448),
    [anon_sym_PIPE] = ACTIONS(1448),
    [anon_sym_SEMI_SEMI] = ACTIONS(1446),
    [anon_sym_PIPE_AMP] = ACTIONS(1446),
    [anon_sym_AMP_AMP] = ACTIONS(1446),
    [anon_sym_PIPE_PIPE] = ACTIONS(1446),
    [anon_sym_LT] = ACTIONS(1448),
    [anon_sym_GT] = ACTIONS(1448),
    [anon_sym_GT_GT] = ACTIONS(1446),
    [anon_sym_AMP_GT] = ACTIONS(1448),
    [anon_sym_AMP_GT_GT] = ACTIONS(1446),
    [anon_sym_LT_AMP] = ACTIONS(1446),
    [anon_sym_GT_AMP] = ACTIONS(1446),
    [anon_sym_LT_LT] = ACTIONS(1448),
    [anon_sym_LT_LT_DASH] = ACTIONS(1446),
    [anon_sym_LT_LT_LT] = ACTIONS(1446),
    [anon_sym_DOLLAR] = ACTIONS(1448),
    [sym__special_character] = ACTIONS(1450),
    [anon_sym_DQUOTE] = ACTIONS(1446),
    [sym_raw_string] = ACTIONS(1446),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1446),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1446),
    [anon_sym_BQUOTE] = ACTIONS(1446),
    [anon_sym_LT_LPAREN] = ACTIONS(1446),
    [anon_sym_GT_LPAREN] = ACTIONS(1446),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1448),
    [anon_sym_LF] = ACTIONS(1446),
    [anon_sym_AMP] = ACTIONS(1448),
  },
  [1289] = {
    [sym_concatenation] = STATE(1169),
    [sym_string] = STATE(1978),
    [sym_array] = STATE(1169),
    [sym_simple_expansion] = STATE(1978),
    [sym_string_expansion] = STATE(1978),
    [sym_expansion] = STATE(1978),
    [sym_command_substitution] = STATE(1978),
    [sym_process_substitution] = STATE(1978),
    [aux_sym__literal_repeat1] = STATE(1979),
    [sym__empty_value] = ACTIONS(2162),
    [anon_sym_LPAREN] = ACTIONS(2164),
    [anon_sym_DOLLAR] = ACTIONS(265),
    [sym__special_character] = ACTIONS(1171),
    [anon_sym_DQUOTE] = ACTIONS(269),
    [sym_raw_string] = ACTIONS(4265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(277),
    [anon_sym_LT_LPAREN] = ACTIONS(279),
    [anon_sym_GT_LPAREN] = ACTIONS(279),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4265),
  },
  [1290] = {
    [aux_sym_concatenation_repeat1] = STATE(1980),
    [sym__simple_heredoc_body] = ACTIONS(1071),
    [sym__heredoc_body_beginning] = ACTIONS(1071),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(2170),
    [sym_variable_name] = ACTIONS(1071),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [sym__special_character] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [sym_word] = ACTIONS(1075),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1075),
  },
  [1291] = {
    [sym_variable_assignment] = STATE(1291),
    [sym_subscript] = STATE(657),
    [sym_concatenation] = STATE(1291),
    [sym_string] = STATE(656),
    [sym_simple_expansion] = STATE(656),
    [sym_string_expansion] = STATE(656),
    [sym_expansion] = STATE(656),
    [sym_command_substitution] = STATE(656),
    [sym_process_substitution] = STATE(656),
    [aux_sym_declaration_command_repeat1] = STATE(1291),
    [aux_sym__literal_repeat1] = STATE(659),
    [sym__simple_heredoc_body] = ACTIONS(2206),
    [sym__heredoc_body_beginning] = ACTIONS(2206),
    [sym_file_descriptor] = ACTIONS(2206),
    [sym_variable_name] = ACTIONS(4267),
    [anon_sym_SEMI] = ACTIONS(2211),
    [anon_sym_PIPE] = ACTIONS(2211),
    [anon_sym_SEMI_SEMI] = ACTIONS(2206),
    [anon_sym_PIPE_AMP] = ACTIONS(2206),
    [anon_sym_AMP_AMP] = ACTIONS(2206),
    [anon_sym_PIPE_PIPE] = ACTIONS(2206),
    [anon_sym_LT] = ACTIONS(2211),
    [anon_sym_GT] = ACTIONS(2211),
    [anon_sym_GT_GT] = ACTIONS(2206),
    [anon_sym_AMP_GT] = ACTIONS(2211),
    [anon_sym_AMP_GT_GT] = ACTIONS(2206),
    [anon_sym_LT_AMP] = ACTIONS(2206),
    [anon_sym_GT_AMP] = ACTIONS(2206),
    [anon_sym_LT_LT] = ACTIONS(2211),
    [anon_sym_LT_LT_DASH] = ACTIONS(2206),
    [anon_sym_LT_LT_LT] = ACTIONS(2206),
    [anon_sym_DOLLAR] = ACTIONS(2213),
    [sym__special_character] = ACTIONS(4270),
    [anon_sym_DQUOTE] = ACTIONS(2219),
    [sym_raw_string] = ACTIONS(4273),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2225),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2228),
    [anon_sym_BQUOTE] = ACTIONS(2231),
    [anon_sym_LT_LPAREN] = ACTIONS(2234),
    [anon_sym_GT_LPAREN] = ACTIONS(2234),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4276),
    [sym_word] = ACTIONS(4279),
    [anon_sym_LF] = ACTIONS(2206),
    [anon_sym_AMP] = ACTIONS(2211),
  },
  [1292] = {
    [aux_sym__literal_repeat1] = STATE(1292),
    [sym__simple_heredoc_body] = ACTIONS(1373),
    [sym__heredoc_body_beginning] = ACTIONS(1373),
    [sym_file_descriptor] = ACTIONS(1373),
    [sym_variable_name] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE_AMP] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_LT_LT_DASH] = ACTIONS(1373),
    [anon_sym_LT_LT_LT] = ACTIONS(1373),
    [anon_sym_DOLLAR] = ACTIONS(1375),
    [sym__special_character] = ACTIONS(2243),
    [anon_sym_DQUOTE] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1373),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [anon_sym_LT_LPAREN] = ACTIONS(1373),
    [anon_sym_GT_LPAREN] = ACTIONS(1373),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1375),
    [sym_word] = ACTIONS(1375),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
  },
  [1293] = {
    [aux_sym_concatenation_repeat1] = STATE(1981),
    [sym__simple_heredoc_body] = ACTIONS(1071),
    [sym__heredoc_body_beginning] = ACTIONS(1071),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(2248),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [sym__special_character] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [sym_word] = ACTIONS(1075),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1075),
  },
  [1294] = {
    [sym_concatenation] = STATE(1294),
    [sym_string] = STATE(661),
    [sym_simple_expansion] = STATE(661),
    [sym_string_expansion] = STATE(661),
    [sym_expansion] = STATE(661),
    [sym_command_substitution] = STATE(661),
    [sym_process_substitution] = STATE(661),
    [aux_sym_unset_command_repeat1] = STATE(1294),
    [aux_sym__literal_repeat1] = STATE(663),
    [sym__simple_heredoc_body] = ACTIONS(2284),
    [sym__heredoc_body_beginning] = ACTIONS(2284),
    [sym_file_descriptor] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym_PIPE] = ACTIONS(2286),
    [anon_sym_SEMI_SEMI] = ACTIONS(2284),
    [anon_sym_PIPE_AMP] = ACTIONS(2284),
    [anon_sym_AMP_AMP] = ACTIONS(2284),
    [anon_sym_PIPE_PIPE] = ACTIONS(2284),
    [anon_sym_LT] = ACTIONS(2286),
    [anon_sym_GT] = ACTIONS(2286),
    [anon_sym_GT_GT] = ACTIONS(2284),
    [anon_sym_AMP_GT] = ACTIONS(2286),
    [anon_sym_AMP_GT_GT] = ACTIONS(2284),
    [anon_sym_LT_AMP] = ACTIONS(2284),
    [anon_sym_GT_AMP] = ACTIONS(2284),
    [anon_sym_LT_LT] = ACTIONS(2286),
    [anon_sym_LT_LT_DASH] = ACTIONS(2284),
    [anon_sym_LT_LT_LT] = ACTIONS(2284),
    [anon_sym_DOLLAR] = ACTIONS(2288),
    [sym__special_character] = ACTIONS(4282),
    [anon_sym_DQUOTE] = ACTIONS(2294),
    [sym_raw_string] = ACTIONS(4285),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2300),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2303),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [anon_sym_LT_LPAREN] = ACTIONS(2309),
    [anon_sym_GT_LPAREN] = ACTIONS(2309),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4288),
    [sym_word] = ACTIONS(4291),
    [anon_sym_LF] = ACTIONS(2284),
    [anon_sym_AMP] = ACTIONS(2286),
  },
  [1295] = {
    [aux_sym__literal_repeat1] = STATE(1295),
    [sym__simple_heredoc_body] = ACTIONS(1373),
    [sym__heredoc_body_beginning] = ACTIONS(1373),
    [sym_file_descriptor] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE_AMP] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_LT_LT_DASH] = ACTIONS(1373),
    [anon_sym_LT_LT_LT] = ACTIONS(1373),
    [anon_sym_DOLLAR] = ACTIONS(1375),
    [sym__special_character] = ACTIONS(2318),
    [anon_sym_DQUOTE] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1373),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [anon_sym_LT_LPAREN] = ACTIONS(1373),
    [anon_sym_GT_LPAREN] = ACTIONS(1373),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1375),
    [sym_word] = ACTIONS(1375),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
  },
  [1296] = {
    [aux_sym_concatenation_repeat1] = STATE(1296),
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(2368),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_EQ_TILDE] = ACTIONS(2364),
    [anon_sym_EQ_EQ] = ACTIONS(2364),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [1297] = {
    [sym_concatenation] = STATE(1328),
    [sym_string] = STATE(1982),
    [sym_simple_expansion] = STATE(1982),
    [sym_string_expansion] = STATE(1982),
    [sym_expansion] = STATE(1982),
    [sym_command_substitution] = STATE(1982),
    [sym_process_substitution] = STATE(1982),
    [aux_sym__literal_repeat1] = STATE(1983),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(2538),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(4294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4294),
  },
  [1298] = {
    [sym_file_redirect] = STATE(672),
    [sym_heredoc_redirect] = STATE(672),
    [sym_herestring_redirect] = STATE(672),
    [aux_sym_redirected_statement_repeat1] = STATE(672),
    [sym__simple_heredoc_body] = ACTIONS(2584),
    [sym__heredoc_body_beginning] = ACTIONS(2584),
    [sym_file_descriptor] = ACTIONS(2584),
    [anon_sym_SEMI] = ACTIONS(2586),
    [anon_sym_PIPE] = ACTIONS(2586),
    [anon_sym_SEMI_SEMI] = ACTIONS(2584),
    [anon_sym_PIPE_AMP] = ACTIONS(2584),
    [anon_sym_AMP_AMP] = ACTIONS(2584),
    [anon_sym_PIPE_PIPE] = ACTIONS(2584),
    [anon_sym_LT] = ACTIONS(2586),
    [anon_sym_GT] = ACTIONS(2586),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT] = ACTIONS(2586),
    [anon_sym_AMP_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_AMP] = ACTIONS(2584),
    [anon_sym_GT_AMP] = ACTIONS(2584),
    [anon_sym_LT_LT] = ACTIONS(2586),
    [anon_sym_LT_LT_DASH] = ACTIONS(2584),
    [anon_sym_LT_LT_LT] = ACTIONS(2584),
    [anon_sym_BQUOTE] = ACTIONS(2584),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2584),
    [anon_sym_AMP] = ACTIONS(2586),
  },
  [1299] = {
    [sym_file_redirect] = STATE(672),
    [sym_heredoc_redirect] = STATE(672),
    [sym_herestring_redirect] = STATE(672),
    [aux_sym_redirected_statement_repeat1] = STATE(672),
    [sym__simple_heredoc_body] = ACTIONS(2584),
    [sym__heredoc_body_beginning] = ACTIONS(2584),
    [sym_file_descriptor] = ACTIONS(2584),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2586),
    [anon_sym_PIPE] = ACTIONS(2586),
    [anon_sym_SEMI_SEMI] = ACTIONS(2584),
    [anon_sym_PIPE_AMP] = ACTIONS(2584),
    [anon_sym_AMP_AMP] = ACTIONS(2584),
    [anon_sym_PIPE_PIPE] = ACTIONS(2584),
    [anon_sym_LT] = ACTIONS(2586),
    [anon_sym_GT] = ACTIONS(2586),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT] = ACTIONS(2586),
    [anon_sym_AMP_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_AMP] = ACTIONS(2584),
    [anon_sym_GT_AMP] = ACTIONS(2584),
    [anon_sym_LT_LT] = ACTIONS(2586),
    [anon_sym_LT_LT_DASH] = ACTIONS(2584),
    [anon_sym_LT_LT_LT] = ACTIONS(2584),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(2584),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2584),
    [anon_sym_AMP] = ACTIONS(2586),
  },
  [1300] = {
    [sym_file_redirect] = STATE(672),
    [sym_heredoc_redirect] = STATE(672),
    [sym_herestring_redirect] = STATE(672),
    [aux_sym_redirected_statement_repeat1] = STATE(672),
    [sym__simple_heredoc_body] = ACTIONS(2588),
    [sym__heredoc_body_beginning] = ACTIONS(2588),
    [sym_file_descriptor] = ACTIONS(2588),
    [anon_sym_SEMI] = ACTIONS(2590),
    [anon_sym_PIPE] = ACTIONS(1191),
    [anon_sym_SEMI_SEMI] = ACTIONS(2588),
    [anon_sym_PIPE_AMP] = ACTIONS(1195),
    [anon_sym_AMP_AMP] = ACTIONS(2588),
    [anon_sym_PIPE_PIPE] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(2590),
    [anon_sym_GT] = ACTIONS(2590),
    [anon_sym_GT_GT] = ACTIONS(2588),
    [anon_sym_AMP_GT] = ACTIONS(2590),
    [anon_sym_AMP_GT_GT] = ACTIONS(2588),
    [anon_sym_LT_AMP] = ACTIONS(2588),
    [anon_sym_GT_AMP] = ACTIONS(2588),
    [anon_sym_LT_LT] = ACTIONS(2590),
    [anon_sym_LT_LT_DASH] = ACTIONS(2588),
    [anon_sym_LT_LT_LT] = ACTIONS(2588),
    [anon_sym_BQUOTE] = ACTIONS(2588),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2588),
    [anon_sym_AMP] = ACTIONS(2590),
  },
  [1301] = {
    [sym_file_redirect] = STATE(672),
    [sym_heredoc_redirect] = STATE(672),
    [sym_herestring_redirect] = STATE(672),
    [aux_sym_redirected_statement_repeat1] = STATE(672),
    [sym__simple_heredoc_body] = ACTIONS(2588),
    [sym__heredoc_body_beginning] = ACTIONS(2588),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2590),
    [anon_sym_PIPE] = ACTIONS(1191),
    [anon_sym_SEMI_SEMI] = ACTIONS(2588),
    [anon_sym_PIPE_AMP] = ACTIONS(1195),
    [anon_sym_AMP_AMP] = ACTIONS(2588),
    [anon_sym_PIPE_PIPE] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(2590),
    [anon_sym_LT_LT_DASH] = ACTIONS(2588),
    [anon_sym_LT_LT_LT] = ACTIONS(2588),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2588),
    [anon_sym_AMP] = ACTIONS(2590),
  },
  [1302] = {
    [aux_sym_concatenation_repeat1] = STATE(1984),
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [1303] = {
    [aux_sym_concatenation_repeat1] = STATE(1984),
    [sym__simple_heredoc_body] = ACTIONS(1037),
    [sym__heredoc_body_beginning] = ACTIONS(1037),
    [sym_file_descriptor] = ACTIONS(1037),
    [sym__concat] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(1039),
    [anon_sym_PIPE] = ACTIONS(1039),
    [anon_sym_SEMI_SEMI] = ACTIONS(1037),
    [anon_sym_PIPE_AMP] = ACTIONS(1037),
    [anon_sym_AMP_AMP] = ACTIONS(1037),
    [anon_sym_PIPE_PIPE] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1039),
    [anon_sym_GT] = ACTIONS(1039),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_AMP_GT] = ACTIONS(1039),
    [anon_sym_AMP_GT_GT] = ACTIONS(1037),
    [anon_sym_LT_AMP] = ACTIONS(1037),
    [anon_sym_GT_AMP] = ACTIONS(1037),
    [anon_sym_LT_LT] = ACTIONS(1039),
    [anon_sym_LT_LT_DASH] = ACTIONS(1037),
    [anon_sym_LT_LT_LT] = ACTIONS(1037),
    [anon_sym_BQUOTE] = ACTIONS(1037),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1037),
    [anon_sym_AMP] = ACTIONS(1039),
  },
  [1304] = {
    [aux_sym__literal_repeat1] = STATE(1985),
    [sym__simple_heredoc_body] = ACTIONS(1051),
    [sym__heredoc_body_beginning] = ACTIONS(1051),
    [sym_file_descriptor] = ACTIONS(1051),
    [anon_sym_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE] = ACTIONS(1053),
    [anon_sym_SEMI_SEMI] = ACTIONS(1051),
    [anon_sym_PIPE_AMP] = ACTIONS(1051),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_PIPE_PIPE] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT_GT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1051),
    [anon_sym_GT_AMP] = ACTIONS(1051),
    [anon_sym_LT_LT] = ACTIONS(1053),
    [anon_sym_LT_LT_DASH] = ACTIONS(1051),
    [anon_sym_LT_LT_LT] = ACTIONS(1051),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(1051),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1051),
    [anon_sym_AMP] = ACTIONS(1053),
  },
  [1305] = {
    [aux_sym_concatenation_repeat1] = STATE(1984),
    [sym__simple_heredoc_body] = ACTIONS(2596),
    [sym__heredoc_body_beginning] = ACTIONS(2596),
    [sym_file_descriptor] = ACTIONS(2596),
    [sym__concat] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(2598),
    [anon_sym_PIPE] = ACTIONS(2598),
    [anon_sym_SEMI_SEMI] = ACTIONS(2596),
    [anon_sym_PIPE_AMP] = ACTIONS(2596),
    [anon_sym_AMP_AMP] = ACTIONS(2596),
    [anon_sym_PIPE_PIPE] = ACTIONS(2596),
    [anon_sym_LT] = ACTIONS(2598),
    [anon_sym_GT] = ACTIONS(2598),
    [anon_sym_GT_GT] = ACTIONS(2596),
    [anon_sym_AMP_GT] = ACTIONS(2598),
    [anon_sym_AMP_GT_GT] = ACTIONS(2596),
    [anon_sym_LT_AMP] = ACTIONS(2596),
    [anon_sym_GT_AMP] = ACTIONS(2596),
    [anon_sym_LT_LT] = ACTIONS(2598),
    [anon_sym_LT_LT_DASH] = ACTIONS(2596),
    [anon_sym_LT_LT_LT] = ACTIONS(2596),
    [anon_sym_BQUOTE] = ACTIONS(2596),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2596),
    [anon_sym_AMP] = ACTIONS(2598),
  },
  [1306] = {
    [aux_sym__literal_repeat1] = STATE(1985),
    [sym__simple_heredoc_body] = ACTIONS(2600),
    [sym__heredoc_body_beginning] = ACTIONS(2600),
    [sym_file_descriptor] = ACTIONS(2600),
    [anon_sym_SEMI] = ACTIONS(2602),
    [anon_sym_PIPE] = ACTIONS(2602),
    [anon_sym_SEMI_SEMI] = ACTIONS(2600),
    [anon_sym_PIPE_AMP] = ACTIONS(2600),
    [anon_sym_AMP_AMP] = ACTIONS(2600),
    [anon_sym_PIPE_PIPE] = ACTIONS(2600),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_GT_GT] = ACTIONS(2600),
    [anon_sym_AMP_GT] = ACTIONS(2602),
    [anon_sym_AMP_GT_GT] = ACTIONS(2600),
    [anon_sym_LT_AMP] = ACTIONS(2600),
    [anon_sym_GT_AMP] = ACTIONS(2600),
    [anon_sym_LT_LT] = ACTIONS(2602),
    [anon_sym_LT_LT_DASH] = ACTIONS(2600),
    [anon_sym_LT_LT_LT] = ACTIONS(2600),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(2600),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2600),
    [anon_sym_AMP] = ACTIONS(2602),
  },
  [1307] = {
    [sym_file_descriptor] = ACTIONS(2604),
    [sym_variable_name] = ACTIONS(2604),
    [anon_sym_for] = ACTIONS(2608),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2608),
    [anon_sym_if] = ACTIONS(2608),
    [anon_sym_case] = ACTIONS(2608),
    [anon_sym_function] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(2608),
    [anon_sym_LBRACE] = ACTIONS(2604),
    [anon_sym_BANG] = ACTIONS(2608),
    [anon_sym_LBRACK] = ACTIONS(2608),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2604),
    [anon_sym_declare] = ACTIONS(2608),
    [anon_sym_typeset] = ACTIONS(2608),
    [anon_sym_export] = ACTIONS(2608),
    [anon_sym_readonly] = ACTIONS(2608),
    [anon_sym_local] = ACTIONS(2608),
    [anon_sym_unset] = ACTIONS(2608),
    [anon_sym_unsetenv] = ACTIONS(2608),
    [anon_sym_LT] = ACTIONS(2608),
    [anon_sym_GT] = ACTIONS(2608),
    [anon_sym_GT_GT] = ACTIONS(2604),
    [anon_sym_AMP_GT] = ACTIONS(2608),
    [anon_sym_AMP_GT_GT] = ACTIONS(2604),
    [anon_sym_LT_AMP] = ACTIONS(2604),
    [anon_sym_GT_AMP] = ACTIONS(2604),
    [anon_sym_DOLLAR] = ACTIONS(2608),
    [sym__special_character] = ACTIONS(2608),
    [anon_sym_DQUOTE] = ACTIONS(2604),
    [sym_raw_string] = ACTIONS(2604),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2604),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2604),
    [anon_sym_BQUOTE] = ACTIONS(2606),
    [anon_sym_LT_LPAREN] = ACTIONS(2604),
    [anon_sym_GT_LPAREN] = ACTIONS(2604),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2608),
  },
  [1308] = {
    [sym_file_redirect] = STATE(1308),
    [sym_heredoc_redirect] = STATE(1308),
    [sym_herestring_redirect] = STATE(1308),
    [aux_sym_redirected_statement_repeat1] = STATE(1308),
    [sym__simple_heredoc_body] = ACTIONS(2610),
    [sym__heredoc_body_beginning] = ACTIONS(2610),
    [sym_file_descriptor] = ACTIONS(4296),
    [anon_sym_SEMI] = ACTIONS(2615),
    [anon_sym_PIPE] = ACTIONS(2615),
    [anon_sym_SEMI_SEMI] = ACTIONS(2610),
    [anon_sym_PIPE_AMP] = ACTIONS(2610),
    [anon_sym_AMP_AMP] = ACTIONS(2610),
    [anon_sym_PIPE_PIPE] = ACTIONS(2610),
    [anon_sym_LT] = ACTIONS(4299),
    [anon_sym_GT] = ACTIONS(4299),
    [anon_sym_GT_GT] = ACTIONS(4302),
    [anon_sym_AMP_GT] = ACTIONS(4299),
    [anon_sym_AMP_GT_GT] = ACTIONS(4302),
    [anon_sym_LT_AMP] = ACTIONS(4302),
    [anon_sym_GT_AMP] = ACTIONS(4302),
    [anon_sym_LT_LT] = ACTIONS(2623),
    [anon_sym_LT_LT_DASH] = ACTIONS(2626),
    [anon_sym_LT_LT_LT] = ACTIONS(4305),
    [anon_sym_BQUOTE] = ACTIONS(2610),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2610),
    [anon_sym_AMP] = ACTIONS(2615),
  },
  [1309] = {
    [aux_sym_concatenation_repeat1] = STATE(664),
    [sym__simple_heredoc_body] = ACTIONS(2632),
    [sym__heredoc_body_beginning] = ACTIONS(2632),
    [sym_file_descriptor] = ACTIONS(2632),
    [sym__concat] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2634),
    [anon_sym_SEMI_SEMI] = ACTIONS(2632),
    [anon_sym_PIPE_AMP] = ACTIONS(2632),
    [anon_sym_AMP_AMP] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2632),
    [anon_sym_EQ_TILDE] = ACTIONS(2634),
    [anon_sym_EQ_EQ] = ACTIONS(2634),
    [anon_sym_LT] = ACTIONS(2634),
    [anon_sym_GT] = ACTIONS(2634),
    [anon_sym_GT_GT] = ACTIONS(2632),
    [anon_sym_AMP_GT] = ACTIONS(2634),
    [anon_sym_AMP_GT_GT] = ACTIONS(2632),
    [anon_sym_LT_AMP] = ACTIONS(2632),
    [anon_sym_GT_AMP] = ACTIONS(2632),
    [anon_sym_LT_LT] = ACTIONS(2634),
    [anon_sym_LT_LT_DASH] = ACTIONS(2632),
    [anon_sym_LT_LT_LT] = ACTIONS(2632),
    [anon_sym_DOLLAR] = ACTIONS(2634),
    [sym__special_character] = ACTIONS(2632),
    [anon_sym_DQUOTE] = ACTIONS(2632),
    [sym_raw_string] = ACTIONS(2632),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2632),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2632),
    [anon_sym_BQUOTE] = ACTIONS(2632),
    [anon_sym_LT_LPAREN] = ACTIONS(2632),
    [anon_sym_GT_LPAREN] = ACTIONS(2632),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2634),
    [anon_sym_LF] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2634),
  },
  [1310] = {
    [aux_sym__literal_repeat1] = STATE(680),
    [sym__simple_heredoc_body] = ACTIONS(2636),
    [sym__heredoc_body_beginning] = ACTIONS(2636),
    [sym_file_descriptor] = ACTIONS(2636),
    [anon_sym_SEMI] = ACTIONS(2638),
    [anon_sym_PIPE] = ACTIONS(2638),
    [anon_sym_SEMI_SEMI] = ACTIONS(2636),
    [anon_sym_PIPE_AMP] = ACTIONS(2636),
    [anon_sym_AMP_AMP] = ACTIONS(2636),
    [anon_sym_PIPE_PIPE] = ACTIONS(2636),
    [anon_sym_EQ_TILDE] = ACTIONS(2638),
    [anon_sym_EQ_EQ] = ACTIONS(2638),
    [anon_sym_LT] = ACTIONS(2638),
    [anon_sym_GT] = ACTIONS(2638),
    [anon_sym_GT_GT] = ACTIONS(2636),
    [anon_sym_AMP_GT] = ACTIONS(2638),
    [anon_sym_AMP_GT_GT] = ACTIONS(2636),
    [anon_sym_LT_AMP] = ACTIONS(2636),
    [anon_sym_GT_AMP] = ACTIONS(2636),
    [anon_sym_LT_LT] = ACTIONS(2638),
    [anon_sym_LT_LT_DASH] = ACTIONS(2636),
    [anon_sym_LT_LT_LT] = ACTIONS(2636),
    [anon_sym_DOLLAR] = ACTIONS(2638),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(2636),
    [sym_raw_string] = ACTIONS(2636),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2636),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2636),
    [anon_sym_BQUOTE] = ACTIONS(2636),
    [anon_sym_LT_LPAREN] = ACTIONS(2636),
    [anon_sym_GT_LPAREN] = ACTIONS(2636),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2638),
    [anon_sym_LF] = ACTIONS(2636),
    [anon_sym_AMP] = ACTIONS(2638),
  },
  [1311] = {
    [sym_concatenation] = STATE(1311),
    [sym_string] = STATE(674),
    [sym_simple_expansion] = STATE(674),
    [sym_string_expansion] = STATE(674),
    [sym_expansion] = STATE(674),
    [sym_command_substitution] = STATE(674),
    [sym_process_substitution] = STATE(674),
    [aux_sym_command_repeat2] = STATE(1311),
    [aux_sym__literal_repeat1] = STATE(676),
    [sym__simple_heredoc_body] = ACTIONS(2632),
    [sym__heredoc_body_beginning] = ACTIONS(2632),
    [sym_file_descriptor] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2634),
    [anon_sym_SEMI_SEMI] = ACTIONS(2632),
    [anon_sym_PIPE_AMP] = ACTIONS(2632),
    [anon_sym_AMP_AMP] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2632),
    [anon_sym_EQ_TILDE] = ACTIONS(4308),
    [anon_sym_EQ_EQ] = ACTIONS(4308),
    [anon_sym_LT] = ACTIONS(2634),
    [anon_sym_GT] = ACTIONS(2634),
    [anon_sym_GT_GT] = ACTIONS(2632),
    [anon_sym_AMP_GT] = ACTIONS(2634),
    [anon_sym_AMP_GT_GT] = ACTIONS(2632),
    [anon_sym_LT_AMP] = ACTIONS(2632),
    [anon_sym_GT_AMP] = ACTIONS(2632),
    [anon_sym_LT_LT] = ACTIONS(2634),
    [anon_sym_LT_LT_DASH] = ACTIONS(2632),
    [anon_sym_LT_LT_LT] = ACTIONS(2632),
    [anon_sym_DOLLAR] = ACTIONS(2643),
    [sym__special_character] = ACTIONS(4311),
    [anon_sym_DQUOTE] = ACTIONS(2649),
    [sym_raw_string] = ACTIONS(4314),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2655),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2661),
    [anon_sym_LT_LPAREN] = ACTIONS(2664),
    [anon_sym_GT_LPAREN] = ACTIONS(2664),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4317),
    [anon_sym_LF] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2634),
  },
  [1312] = {
    [sym_file_descriptor] = ACTIONS(1237),
    [sym_variable_name] = ACTIONS(1237),
    [anon_sym_for] = ACTIONS(1241),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1237),
    [anon_sym_while] = ACTIONS(1241),
    [anon_sym_if] = ACTIONS(1241),
    [anon_sym_case] = ACTIONS(1241),
    [anon_sym_function] = ACTIONS(1241),
    [anon_sym_LPAREN] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1237),
    [anon_sym_BANG] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(1241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1237),
    [anon_sym_declare] = ACTIONS(1241),
    [anon_sym_typeset] = ACTIONS(1241),
    [anon_sym_export] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_local] = ACTIONS(1241),
    [anon_sym_unset] = ACTIONS(1241),
    [anon_sym_unsetenv] = ACTIONS(1241),
    [anon_sym_LT] = ACTIONS(1241),
    [anon_sym_GT] = ACTIONS(1241),
    [anon_sym_GT_GT] = ACTIONS(1237),
    [anon_sym_AMP_GT] = ACTIONS(1241),
    [anon_sym_AMP_GT_GT] = ACTIONS(1237),
    [anon_sym_LT_AMP] = ACTIONS(1237),
    [anon_sym_GT_AMP] = ACTIONS(1237),
    [anon_sym_DOLLAR] = ACTIONS(1241),
    [sym__special_character] = ACTIONS(1241),
    [anon_sym_DQUOTE] = ACTIONS(1237),
    [sym_raw_string] = ACTIONS(1237),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1237),
    [anon_sym_BQUOTE] = ACTIONS(2606),
    [anon_sym_LT_LPAREN] = ACTIONS(1237),
    [anon_sym_GT_LPAREN] = ACTIONS(1237),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1241),
  },
  [1313] = {
    [anon_sym_SEMI] = ACTIONS(4320),
    [anon_sym_SEMI_SEMI] = ACTIONS(4322),
    [anon_sym_BQUOTE] = ACTIONS(2606),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4322),
    [anon_sym_AMP] = ACTIONS(4322),
  },
  [1314] = {
    [sym_concatenation] = STATE(1311),
    [sym_string] = STATE(674),
    [sym_simple_expansion] = STATE(674),
    [sym_string_expansion] = STATE(674),
    [sym_expansion] = STATE(674),
    [sym_command_substitution] = STATE(674),
    [sym_process_substitution] = STATE(674),
    [aux_sym_command_repeat2] = STATE(1311),
    [aux_sym__literal_repeat1] = STATE(676),
    [sym__simple_heredoc_body] = ACTIONS(2696),
    [sym__heredoc_body_beginning] = ACTIONS(2696),
    [sym_file_descriptor] = ACTIONS(2696),
    [anon_sym_SEMI] = ACTIONS(2698),
    [anon_sym_PIPE] = ACTIONS(2698),
    [anon_sym_SEMI_SEMI] = ACTIONS(2696),
    [anon_sym_PIPE_AMP] = ACTIONS(2696),
    [anon_sym_AMP_AMP] = ACTIONS(2696),
    [anon_sym_PIPE_PIPE] = ACTIONS(2696),
    [anon_sym_EQ_TILDE] = ACTIONS(1205),
    [anon_sym_EQ_EQ] = ACTIONS(1205),
    [anon_sym_LT] = ACTIONS(2698),
    [anon_sym_GT] = ACTIONS(2698),
    [anon_sym_GT_GT] = ACTIONS(2696),
    [anon_sym_AMP_GT] = ACTIONS(2698),
    [anon_sym_AMP_GT_GT] = ACTIONS(2696),
    [anon_sym_LT_AMP] = ACTIONS(2696),
    [anon_sym_GT_AMP] = ACTIONS(2696),
    [anon_sym_LT_LT] = ACTIONS(2698),
    [anon_sym_LT_LT_DASH] = ACTIONS(2696),
    [anon_sym_LT_LT_LT] = ACTIONS(2696),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(1207),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1209),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(2696),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1211),
    [anon_sym_LF] = ACTIONS(2696),
    [anon_sym_AMP] = ACTIONS(2698),
  },
  [1315] = {
    [sym__simple_heredoc_body] = ACTIONS(4324),
    [sym__heredoc_body_beginning] = ACTIONS(4324),
    [sym_file_descriptor] = ACTIONS(4324),
    [ts_builtin_sym_end] = ACTIONS(4324),
    [anon_sym_SEMI] = ACTIONS(4326),
    [anon_sym_done] = ACTIONS(4324),
    [anon_sym_fi] = ACTIONS(4324),
    [anon_sym_elif] = ACTIONS(4324),
    [anon_sym_else] = ACTIONS(4324),
    [anon_sym_esac] = ACTIONS(4324),
    [anon_sym_PIPE] = ACTIONS(4326),
    [anon_sym_RPAREN] = ACTIONS(4324),
    [anon_sym_SEMI_SEMI] = ACTIONS(4324),
    [anon_sym_PIPE_AMP] = ACTIONS(4324),
    [anon_sym_AMP_AMP] = ACTIONS(4324),
    [anon_sym_PIPE_PIPE] = ACTIONS(4324),
    [anon_sym_LT] = ACTIONS(4326),
    [anon_sym_GT] = ACTIONS(4326),
    [anon_sym_GT_GT] = ACTIONS(4324),
    [anon_sym_AMP_GT] = ACTIONS(4326),
    [anon_sym_AMP_GT_GT] = ACTIONS(4324),
    [anon_sym_LT_AMP] = ACTIONS(4324),
    [anon_sym_GT_AMP] = ACTIONS(4324),
    [anon_sym_LT_LT] = ACTIONS(4326),
    [anon_sym_LT_LT_DASH] = ACTIONS(4324),
    [anon_sym_LT_LT_LT] = ACTIONS(4324),
    [anon_sym_BQUOTE] = ACTIONS(4324),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4324),
    [anon_sym_AMP] = ACTIONS(4326),
  },
  [1316] = {
    [sym__heredoc_body_middle] = ACTIONS(1057),
    [sym__heredoc_body_end] = ACTIONS(1057),
    [anon_sym_DOLLAR] = ACTIONS(1059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1057),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1057),
    [anon_sym_BQUOTE] = ACTIONS(1057),
    [sym_comment] = ACTIONS(57),
  },
  [1317] = {
    [sym__heredoc_body_middle] = ACTIONS(1065),
    [sym__heredoc_body_end] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1067),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [sym_comment] = ACTIONS(57),
  },
  [1318] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(4328),
    [sym_comment] = ACTIONS(57),
  },
  [1319] = {
    [sym_subscript] = STATE(1990),
    [sym_variable_name] = ACTIONS(4330),
    [anon_sym_DASH] = ACTIONS(4332),
    [anon_sym_DOLLAR] = ACTIONS(4332),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4334),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_AT] = ACTIONS(4336),
    [anon_sym_QMARK] = ACTIONS(4336),
    [anon_sym_0] = ACTIONS(4334),
    [anon_sym__] = ACTIONS(4334),
  },
  [1320] = {
    [sym_concatenation] = STATE(1993),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1993),
    [anon_sym_RBRACE] = ACTIONS(4338),
    [anon_sym_EQ] = ACTIONS(4340),
    [anon_sym_DASH] = ACTIONS(4340),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4342),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(4344),
    [anon_sym_COLON] = ACTIONS(4340),
    [anon_sym_COLON_QMARK] = ACTIONS(4340),
    [anon_sym_COLON_DASH] = ACTIONS(4340),
    [anon_sym_PERCENT] = ACTIONS(4340),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1321] = {
    [sym_concatenation] = STATE(1996),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1996),
    [anon_sym_RBRACE] = ACTIONS(4346),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_DASH] = ACTIONS(4348),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4350),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(4352),
    [anon_sym_COLON] = ACTIONS(4348),
    [anon_sym_COLON_QMARK] = ACTIONS(4348),
    [anon_sym_COLON_DASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1322] = {
    [anon_sym_RPAREN] = ACTIONS(4354),
    [sym_comment] = ACTIONS(57),
  },
  [1323] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(4354),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [1324] = {
    [anon_sym_BQUOTE] = ACTIONS(4354),
    [sym_comment] = ACTIONS(57),
  },
  [1325] = {
    [ts_builtin_sym_end] = ACTIONS(4356),
    [anon_sym_SEMI] = ACTIONS(4358),
    [anon_sym_done] = ACTIONS(4356),
    [anon_sym_fi] = ACTIONS(4356),
    [anon_sym_elif] = ACTIONS(4356),
    [anon_sym_else] = ACTIONS(4356),
    [anon_sym_esac] = ACTIONS(4356),
    [anon_sym_RPAREN] = ACTIONS(4356),
    [anon_sym_SEMI_SEMI] = ACTIONS(4356),
    [anon_sym_BQUOTE] = ACTIONS(4356),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4356),
    [anon_sym_AMP] = ACTIONS(4356),
  },
  [1326] = {
    [sym_simple_expansion] = STATE(1326),
    [sym_expansion] = STATE(1326),
    [sym_command_substitution] = STATE(1326),
    [aux_sym_heredoc_body_repeat1] = STATE(1326),
    [sym__heredoc_body_middle] = ACTIONS(4360),
    [sym__heredoc_body_end] = ACTIONS(4363),
    [anon_sym_DOLLAR] = ACTIONS(4365),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4368),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4371),
    [anon_sym_BQUOTE] = ACTIONS(4374),
    [sym_comment] = ACTIONS(57),
  },
  [1327] = {
    [aux_sym_concatenation_repeat1] = STATE(1330),
    [sym__simple_heredoc_body] = ACTIONS(1380),
    [sym__heredoc_body_beginning] = ACTIONS(1380),
    [sym_file_descriptor] = ACTIONS(1380),
    [sym__concat] = ACTIONS(337),
    [ts_builtin_sym_end] = ACTIONS(1380),
    [anon_sym_SEMI] = ACTIONS(1382),
    [anon_sym_PIPE] = ACTIONS(1382),
    [anon_sym_SEMI_SEMI] = ACTIONS(1380),
    [anon_sym_PIPE_AMP] = ACTIONS(1380),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_PIPE_PIPE] = ACTIONS(1380),
    [anon_sym_LT] = ACTIONS(1382),
    [anon_sym_GT] = ACTIONS(1382),
    [anon_sym_GT_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT] = ACTIONS(1382),
    [anon_sym_AMP_GT_GT] = ACTIONS(1380),
    [anon_sym_LT_AMP] = ACTIONS(1380),
    [anon_sym_GT_AMP] = ACTIONS(1380),
    [anon_sym_LT_LT] = ACTIONS(1382),
    [anon_sym_LT_LT_DASH] = ACTIONS(1380),
    [anon_sym_LT_LT_LT] = ACTIONS(1380),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1380),
    [anon_sym_AMP] = ACTIONS(1382),
  },
  [1328] = {
    [sym__simple_heredoc_body] = ACTIONS(1380),
    [sym__heredoc_body_beginning] = ACTIONS(1380),
    [sym_file_descriptor] = ACTIONS(1380),
    [ts_builtin_sym_end] = ACTIONS(1380),
    [anon_sym_SEMI] = ACTIONS(1382),
    [anon_sym_done] = ACTIONS(1380),
    [anon_sym_fi] = ACTIONS(1380),
    [anon_sym_elif] = ACTIONS(1380),
    [anon_sym_else] = ACTIONS(1380),
    [anon_sym_esac] = ACTIONS(1380),
    [anon_sym_PIPE] = ACTIONS(1382),
    [anon_sym_RPAREN] = ACTIONS(1380),
    [anon_sym_SEMI_SEMI] = ACTIONS(1380),
    [anon_sym_PIPE_AMP] = ACTIONS(1380),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_PIPE_PIPE] = ACTIONS(1380),
    [anon_sym_LT] = ACTIONS(1382),
    [anon_sym_GT] = ACTIONS(1382),
    [anon_sym_GT_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT] = ACTIONS(1382),
    [anon_sym_AMP_GT_GT] = ACTIONS(1380),
    [anon_sym_LT_AMP] = ACTIONS(1380),
    [anon_sym_GT_AMP] = ACTIONS(1380),
    [anon_sym_LT_LT] = ACTIONS(1382),
    [anon_sym_LT_LT_DASH] = ACTIONS(1380),
    [anon_sym_LT_LT_LT] = ACTIONS(1380),
    [anon_sym_BQUOTE] = ACTIONS(1380),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1380),
    [anon_sym_AMP] = ACTIONS(1382),
  },
  [1329] = {
    [aux_sym__literal_repeat1] = STATE(1331),
    [sym__simple_heredoc_body] = ACTIONS(1384),
    [sym__heredoc_body_beginning] = ACTIONS(1384),
    [sym_file_descriptor] = ACTIONS(1384),
    [ts_builtin_sym_end] = ACTIONS(1384),
    [anon_sym_SEMI] = ACTIONS(1386),
    [anon_sym_PIPE] = ACTIONS(1386),
    [anon_sym_SEMI_SEMI] = ACTIONS(1384),
    [anon_sym_PIPE_AMP] = ACTIONS(1384),
    [anon_sym_AMP_AMP] = ACTIONS(1384),
    [anon_sym_PIPE_PIPE] = ACTIONS(1384),
    [anon_sym_LT] = ACTIONS(1386),
    [anon_sym_GT] = ACTIONS(1386),
    [anon_sym_GT_GT] = ACTIONS(1384),
    [anon_sym_AMP_GT] = ACTIONS(1386),
    [anon_sym_AMP_GT_GT] = ACTIONS(1384),
    [anon_sym_LT_AMP] = ACTIONS(1384),
    [anon_sym_GT_AMP] = ACTIONS(1384),
    [anon_sym_LT_LT] = ACTIONS(1386),
    [anon_sym_LT_LT_DASH] = ACTIONS(1384),
    [anon_sym_LT_LT_LT] = ACTIONS(1384),
    [sym__special_character] = ACTIONS(441),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1384),
    [anon_sym_AMP] = ACTIONS(1386),
  },
  [1330] = {
    [aux_sym_concatenation_repeat1] = STATE(1999),
    [sym__simple_heredoc_body] = ACTIONS(1071),
    [sym__heredoc_body_beginning] = ACTIONS(1071),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(4377),
    [ts_builtin_sym_end] = ACTIONS(1071),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1075),
  },
  [1331] = {
    [aux_sym__literal_repeat1] = STATE(1331),
    [sym__simple_heredoc_body] = ACTIONS(1373),
    [sym__heredoc_body_beginning] = ACTIONS(1373),
    [sym_file_descriptor] = ACTIONS(1373),
    [ts_builtin_sym_end] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE_AMP] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_LT_LT_DASH] = ACTIONS(1373),
    [anon_sym_LT_LT_LT] = ACTIONS(1373),
    [sym__special_character] = ACTIONS(1377),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
  },
  [1332] = {
    [sym_file_descriptor] = ACTIONS(2604),
    [sym_variable_name] = ACTIONS(2604),
    [ts_builtin_sym_end] = ACTIONS(4379),
    [anon_sym_for] = ACTIONS(2608),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2608),
    [anon_sym_if] = ACTIONS(2608),
    [anon_sym_case] = ACTIONS(2608),
    [anon_sym_RPAREN] = ACTIONS(4379),
    [anon_sym_SEMI_SEMI] = ACTIONS(4379),
    [anon_sym_function] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(2608),
    [anon_sym_LBRACE] = ACTIONS(2604),
    [anon_sym_BANG] = ACTIONS(2608),
    [anon_sym_LBRACK] = ACTIONS(2608),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2604),
    [anon_sym_declare] = ACTIONS(2608),
    [anon_sym_typeset] = ACTIONS(2608),
    [anon_sym_export] = ACTIONS(2608),
    [anon_sym_readonly] = ACTIONS(2608),
    [anon_sym_local] = ACTIONS(2608),
    [anon_sym_unset] = ACTIONS(2608),
    [anon_sym_unsetenv] = ACTIONS(2608),
    [anon_sym_LT] = ACTIONS(2608),
    [anon_sym_GT] = ACTIONS(2608),
    [anon_sym_GT_GT] = ACTIONS(2604),
    [anon_sym_AMP_GT] = ACTIONS(2608),
    [anon_sym_AMP_GT_GT] = ACTIONS(2604),
    [anon_sym_LT_AMP] = ACTIONS(2604),
    [anon_sym_GT_AMP] = ACTIONS(2604),
    [anon_sym_DOLLAR] = ACTIONS(2608),
    [sym__special_character] = ACTIONS(2608),
    [anon_sym_DQUOTE] = ACTIONS(2604),
    [sym_raw_string] = ACTIONS(2604),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2604),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2604),
    [anon_sym_BQUOTE] = ACTIONS(2604),
    [anon_sym_LT_LPAREN] = ACTIONS(2604),
    [anon_sym_GT_LPAREN] = ACTIONS(2604),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2608),
  },
  [1333] = {
    [sym_variable_assignment] = STATE(1291),
    [sym_subscript] = STATE(657),
    [sym_concatenation] = STATE(1291),
    [sym_string] = STATE(656),
    [sym_simple_expansion] = STATE(656),
    [sym_string_expansion] = STATE(656),
    [sym_expansion] = STATE(656),
    [sym_command_substitution] = STATE(656),
    [sym_process_substitution] = STATE(656),
    [aux_sym_declaration_command_repeat1] = STATE(1291),
    [aux_sym__literal_repeat1] = STATE(659),
    [sym__simple_heredoc_body] = ACTIONS(971),
    [sym__heredoc_body_beginning] = ACTIONS(971),
    [sym_file_descriptor] = ACTIONS(971),
    [sym_variable_name] = ACTIONS(1169),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_SEMI_SEMI] = ACTIONS(971),
    [anon_sym_PIPE_AMP] = ACTIONS(971),
    [anon_sym_AMP_AMP] = ACTIONS(971),
    [anon_sym_PIPE_PIPE] = ACTIONS(971),
    [anon_sym_LT] = ACTIONS(973),
    [anon_sym_GT] = ACTIONS(973),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_AMP_GT] = ACTIONS(973),
    [anon_sym_AMP_GT_GT] = ACTIONS(971),
    [anon_sym_LT_AMP] = ACTIONS(971),
    [anon_sym_GT_AMP] = ACTIONS(971),
    [anon_sym_LT_LT] = ACTIONS(973),
    [anon_sym_LT_LT_DASH] = ACTIONS(971),
    [anon_sym_LT_LT_LT] = ACTIONS(971),
    [anon_sym_DOLLAR] = ACTIONS(265),
    [sym__special_character] = ACTIONS(1171),
    [anon_sym_DQUOTE] = ACTIONS(269),
    [sym_raw_string] = ACTIONS(1173),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(277),
    [anon_sym_LT_LPAREN] = ACTIONS(279),
    [anon_sym_GT_LPAREN] = ACTIONS(279),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2530),
    [sym_word] = ACTIONS(1177),
    [anon_sym_LF] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(973),
  },
  [1334] = {
    [sym_concatenation] = STATE(1294),
    [sym_string] = STATE(661),
    [sym_simple_expansion] = STATE(661),
    [sym_string_expansion] = STATE(661),
    [sym_expansion] = STATE(661),
    [sym_command_substitution] = STATE(661),
    [sym_process_substitution] = STATE(661),
    [aux_sym_unset_command_repeat1] = STATE(1294),
    [aux_sym__literal_repeat1] = STATE(663),
    [sym__simple_heredoc_body] = ACTIONS(1011),
    [sym__heredoc_body_beginning] = ACTIONS(1011),
    [sym_file_descriptor] = ACTIONS(1011),
    [anon_sym_SEMI] = ACTIONS(1013),
    [anon_sym_PIPE] = ACTIONS(1013),
    [anon_sym_SEMI_SEMI] = ACTIONS(1011),
    [anon_sym_PIPE_AMP] = ACTIONS(1011),
    [anon_sym_AMP_AMP] = ACTIONS(1011),
    [anon_sym_PIPE_PIPE] = ACTIONS(1011),
    [anon_sym_LT] = ACTIONS(1013),
    [anon_sym_GT] = ACTIONS(1013),
    [anon_sym_GT_GT] = ACTIONS(1011),
    [anon_sym_AMP_GT] = ACTIONS(1013),
    [anon_sym_AMP_GT_GT] = ACTIONS(1011),
    [anon_sym_LT_AMP] = ACTIONS(1011),
    [anon_sym_GT_AMP] = ACTIONS(1011),
    [anon_sym_LT_LT] = ACTIONS(1013),
    [anon_sym_LT_LT_DASH] = ACTIONS(1011),
    [anon_sym_LT_LT_LT] = ACTIONS(1011),
    [anon_sym_DOLLAR] = ACTIONS(289),
    [sym__special_character] = ACTIONS(1179),
    [anon_sym_DQUOTE] = ACTIONS(293),
    [sym_raw_string] = ACTIONS(1181),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(297),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(301),
    [anon_sym_LT_LPAREN] = ACTIONS(303),
    [anon_sym_GT_LPAREN] = ACTIONS(303),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2532),
    [sym_word] = ACTIONS(1185),
    [anon_sym_LF] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(1013),
  },
  [1335] = {
    [anon_sym_LT] = ACTIONS(4381),
    [anon_sym_GT] = ACTIONS(4381),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_AMP_GT] = ACTIONS(4381),
    [anon_sym_AMP_GT_GT] = ACTIONS(4383),
    [anon_sym_LT_AMP] = ACTIONS(4383),
    [anon_sym_GT_AMP] = ACTIONS(4383),
    [sym_comment] = ACTIONS(57),
  },
  [1336] = {
    [sym_file_descriptor] = ACTIONS(1237),
    [sym_variable_name] = ACTIONS(1237),
    [anon_sym_for] = ACTIONS(1241),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1237),
    [anon_sym_while] = ACTIONS(1241),
    [anon_sym_if] = ACTIONS(1241),
    [anon_sym_case] = ACTIONS(1241),
    [anon_sym_function] = ACTIONS(1241),
    [anon_sym_LPAREN] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1237),
    [anon_sym_BANG] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(1241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1237),
    [anon_sym_declare] = ACTIONS(1241),
    [anon_sym_typeset] = ACTIONS(1241),
    [anon_sym_export] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_local] = ACTIONS(1241),
    [anon_sym_unset] = ACTIONS(1241),
    [anon_sym_unsetenv] = ACTIONS(1241),
    [anon_sym_LT] = ACTIONS(1241),
    [anon_sym_GT] = ACTIONS(1241),
    [anon_sym_GT_GT] = ACTIONS(1237),
    [anon_sym_AMP_GT] = ACTIONS(1241),
    [anon_sym_AMP_GT_GT] = ACTIONS(1237),
    [anon_sym_LT_AMP] = ACTIONS(1237),
    [anon_sym_GT_AMP] = ACTIONS(1237),
    [anon_sym_DOLLAR] = ACTIONS(1241),
    [sym__special_character] = ACTIONS(1241),
    [anon_sym_DQUOTE] = ACTIONS(1237),
    [sym_raw_string] = ACTIONS(1237),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1237),
    [anon_sym_BQUOTE] = ACTIONS(1237),
    [anon_sym_LT_LPAREN] = ACTIONS(1237),
    [anon_sym_GT_LPAREN] = ACTIONS(1237),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1241),
  },
  [1337] = {
    [sym_redirected_statement] = STATE(2001),
    [sym_for_statement] = STATE(2001),
    [sym_c_style_for_statement] = STATE(2001),
    [sym_while_statement] = STATE(2001),
    [sym_if_statement] = STATE(2001),
    [sym_case_statement] = STATE(2001),
    [sym_function_definition] = STATE(2001),
    [sym_compound_statement] = STATE(2001),
    [sym_subshell] = STATE(2001),
    [sym_pipeline] = STATE(2001),
    [sym_list] = STATE(2001),
    [sym_negated_command] = STATE(2001),
    [sym_test_command] = STATE(2001),
    [sym_declaration_command] = STATE(2001),
    [sym_unset_command] = STATE(2001),
    [sym_command] = STATE(2001),
    [sym_command_name] = STATE(714),
    [sym_variable_assignment] = STATE(2002),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(716),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym_command_repeat1] = STATE(716),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(4385),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(4387),
    [anon_sym_typeset] = ACTIONS(4387),
    [anon_sym_export] = ACTIONS(4387),
    [anon_sym_readonly] = ACTIONS(4387),
    [anon_sym_local] = ACTIONS(4387),
    [anon_sym_unset] = ACTIONS(4389),
    [anon_sym_unsetenv] = ACTIONS(4389),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [1338] = {
    [sym_redirected_statement] = STATE(2003),
    [sym_for_statement] = STATE(2003),
    [sym_c_style_for_statement] = STATE(2003),
    [sym_while_statement] = STATE(2003),
    [sym_if_statement] = STATE(2003),
    [sym_case_statement] = STATE(2003),
    [sym_function_definition] = STATE(2003),
    [sym_compound_statement] = STATE(2003),
    [sym_subshell] = STATE(2003),
    [sym_pipeline] = STATE(2003),
    [sym_list] = STATE(2003),
    [sym_negated_command] = STATE(2003),
    [sym_test_command] = STATE(2003),
    [sym_declaration_command] = STATE(2003),
    [sym_unset_command] = STATE(2003),
    [sym_command] = STATE(2003),
    [sym_command_name] = STATE(714),
    [sym_variable_assignment] = STATE(2004),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(716),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym_command_repeat1] = STATE(716),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(4385),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(4387),
    [anon_sym_typeset] = ACTIONS(4387),
    [anon_sym_export] = ACTIONS(4387),
    [anon_sym_readonly] = ACTIONS(4387),
    [anon_sym_local] = ACTIONS(4387),
    [anon_sym_unset] = ACTIONS(4389),
    [anon_sym_unsetenv] = ACTIONS(4389),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [1339] = {
    [sym_concatenation] = STATE(696),
    [sym_string] = STATE(2006),
    [sym_simple_expansion] = STATE(2006),
    [sym_string_expansion] = STATE(2006),
    [sym_expansion] = STATE(2006),
    [sym_command_substitution] = STATE(2006),
    [sym_process_substitution] = STATE(2006),
    [aux_sym__literal_repeat1] = STATE(2007),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(4391),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(4393),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4393),
  },
  [1340] = {
    [sym_concatenation] = STATE(700),
    [sym_string] = STATE(2008),
    [sym_simple_expansion] = STATE(2008),
    [sym_string_expansion] = STATE(2008),
    [sym_expansion] = STATE(2008),
    [sym_command_substitution] = STATE(2008),
    [sym_process_substitution] = STATE(2008),
    [aux_sym__literal_repeat1] = STATE(2009),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(4391),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(4395),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4395),
  },
  [1341] = {
    [anon_sym_SEMI] = ACTIONS(4397),
    [anon_sym_SEMI_SEMI] = ACTIONS(4399),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4399),
    [anon_sym_AMP] = ACTIONS(4399),
  },
  [1342] = {
    [sym_file_redirect] = STATE(2011),
    [sym_heredoc_redirect] = STATE(2011),
    [sym_herestring_redirect] = STATE(2011),
    [aux_sym_redirected_statement_repeat1] = STATE(2011),
    [sym__simple_heredoc_body] = ACTIONS(1255),
    [sym__heredoc_body_beginning] = ACTIONS(1255),
    [sym_file_descriptor] = ACTIONS(2678),
    [anon_sym_SEMI] = ACTIONS(1257),
    [anon_sym_PIPE] = ACTIONS(1257),
    [anon_sym_SEMI_SEMI] = ACTIONS(1255),
    [anon_sym_PIPE_AMP] = ACTIONS(1255),
    [anon_sym_AMP_AMP] = ACTIONS(1255),
    [anon_sym_PIPE_PIPE] = ACTIONS(1255),
    [anon_sym_LT] = ACTIONS(2690),
    [anon_sym_GT] = ACTIONS(2690),
    [anon_sym_GT_GT] = ACTIONS(2692),
    [anon_sym_AMP_GT] = ACTIONS(2690),
    [anon_sym_AMP_GT_GT] = ACTIONS(2692),
    [anon_sym_LT_AMP] = ACTIONS(2692),
    [anon_sym_GT_AMP] = ACTIONS(2692),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(2694),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1257),
  },
  [1343] = {
    [sym_concatenation] = STATE(1311),
    [sym_string] = STATE(674),
    [sym_simple_expansion] = STATE(674),
    [sym_string_expansion] = STATE(674),
    [sym_expansion] = STATE(674),
    [sym_command_substitution] = STATE(674),
    [sym_process_substitution] = STATE(674),
    [aux_sym_command_repeat2] = STATE(1311),
    [aux_sym__literal_repeat1] = STATE(676),
    [sym__simple_heredoc_body] = ACTIONS(1267),
    [sym__heredoc_body_beginning] = ACTIONS(1267),
    [sym_file_descriptor] = ACTIONS(1267),
    [anon_sym_SEMI] = ACTIONS(1269),
    [anon_sym_PIPE] = ACTIONS(1269),
    [anon_sym_SEMI_SEMI] = ACTIONS(1267),
    [anon_sym_PIPE_AMP] = ACTIONS(1267),
    [anon_sym_AMP_AMP] = ACTIONS(1267),
    [anon_sym_PIPE_PIPE] = ACTIONS(1267),
    [anon_sym_EQ_TILDE] = ACTIONS(1205),
    [anon_sym_EQ_EQ] = ACTIONS(1205),
    [anon_sym_LT] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1269),
    [anon_sym_GT_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT_GT] = ACTIONS(1267),
    [anon_sym_LT_AMP] = ACTIONS(1267),
    [anon_sym_GT_AMP] = ACTIONS(1267),
    [anon_sym_LT_LT] = ACTIONS(1269),
    [anon_sym_LT_LT_DASH] = ACTIONS(1267),
    [anon_sym_LT_LT_LT] = ACTIONS(1267),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(1207),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1209),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1211),
    [anon_sym_LF] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(1269),
  },
  [1344] = {
    [sym_concatenation] = STATE(2012),
    [sym_string] = STATE(674),
    [sym_simple_expansion] = STATE(674),
    [sym_string_expansion] = STATE(674),
    [sym_expansion] = STATE(674),
    [sym_command_substitution] = STATE(674),
    [sym_process_substitution] = STATE(674),
    [aux_sym_command_repeat2] = STATE(2012),
    [aux_sym__literal_repeat1] = STATE(676),
    [sym__simple_heredoc_body] = ACTIONS(1267),
    [sym__heredoc_body_beginning] = ACTIONS(1267),
    [sym_file_descriptor] = ACTIONS(1267),
    [anon_sym_SEMI] = ACTIONS(1269),
    [anon_sym_PIPE] = ACTIONS(1269),
    [anon_sym_SEMI_SEMI] = ACTIONS(1267),
    [anon_sym_PIPE_AMP] = ACTIONS(1267),
    [anon_sym_AMP_AMP] = ACTIONS(1267),
    [anon_sym_PIPE_PIPE] = ACTIONS(1267),
    [anon_sym_EQ_TILDE] = ACTIONS(1205),
    [anon_sym_EQ_EQ] = ACTIONS(1205),
    [anon_sym_LT] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1269),
    [anon_sym_GT_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT_GT] = ACTIONS(1267),
    [anon_sym_LT_AMP] = ACTIONS(1267),
    [anon_sym_GT_AMP] = ACTIONS(1267),
    [anon_sym_LT_LT] = ACTIONS(1269),
    [anon_sym_LT_LT_DASH] = ACTIONS(1267),
    [anon_sym_LT_LT_LT] = ACTIONS(1267),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(1207),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1209),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1211),
    [anon_sym_LF] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(1269),
  },
  [1345] = {
    [sym_string] = STATE(1149),
    [sym_simple_expansion] = STATE(1149),
    [sym_string_expansion] = STATE(1149),
    [sym_expansion] = STATE(1149),
    [sym_command_substitution] = STATE(1149),
    [sym_process_substitution] = STATE(1149),
    [anon_sym_DOLLAR] = ACTIONS(4401),
    [sym__special_character] = ACTIONS(2116),
    [anon_sym_DQUOTE] = ACTIONS(233),
    [sym_raw_string] = ACTIONS(2116),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [anon_sym_LT_LPAREN] = ACTIONS(243),
    [anon_sym_GT_LPAREN] = ACTIONS(243),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2116),
  },
  [1346] = {
    [aux_sym_concatenation_repeat1] = STATE(1346),
    [sym__concat] = ACTIONS(3923),
    [anon_sym_RBRACK] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
  },
  [1347] = {
    [sym__concat] = ACTIONS(4403),
    [anon_sym_EQ] = ACTIONS(4405),
    [anon_sym_PLUS_EQ] = ACTIONS(4405),
    [sym_comment] = ACTIONS(57),
  },
  [1348] = {
    [anon_sym_EQ] = ACTIONS(4405),
    [anon_sym_PLUS_EQ] = ACTIONS(4405),
    [sym_comment] = ACTIONS(57),
  },
  [1349] = {
    [sym__concat] = ACTIONS(4407),
    [anon_sym_EQ] = ACTIONS(4409),
    [anon_sym_PLUS_EQ] = ACTIONS(4409),
    [sym_comment] = ACTIONS(57),
  },
  [1350] = {
    [anon_sym_EQ] = ACTIONS(4409),
    [anon_sym_PLUS_EQ] = ACTIONS(4409),
    [sym_comment] = ACTIONS(57),
  },
  [1351] = {
    [sym__concat] = ACTIONS(1057),
    [anon_sym_RPAREN] = ACTIONS(1057),
    [anon_sym_DOLLAR] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [sym_raw_string] = ACTIONS(1057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1057),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1057),
    [anon_sym_BQUOTE] = ACTIONS(1057),
    [anon_sym_LT_LPAREN] = ACTIONS(1057),
    [anon_sym_GT_LPAREN] = ACTIONS(1057),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1057),
  },
  [1352] = {
    [sym__concat] = ACTIONS(1061),
    [anon_sym_RPAREN] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1061),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1061),
    [anon_sym_LT_LPAREN] = ACTIONS(1061),
    [anon_sym_GT_LPAREN] = ACTIONS(1061),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1061),
  },
  [1353] = {
    [sym__concat] = ACTIONS(1065),
    [anon_sym_RPAREN] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1067),
    [sym__special_character] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LT_LPAREN] = ACTIONS(1065),
    [anon_sym_GT_LPAREN] = ACTIONS(1065),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1065),
  },
  [1354] = {
    [sym_string] = STATE(2016),
    [sym_simple_expansion] = STATE(2016),
    [sym_string_expansion] = STATE(2016),
    [sym_expansion] = STATE(2016),
    [sym_command_substitution] = STATE(2016),
    [sym_process_substitution] = STATE(2016),
    [anon_sym_DOLLAR] = ACTIONS(1406),
    [sym__special_character] = ACTIONS(4411),
    [anon_sym_DQUOTE] = ACTIONS(1410),
    [sym_raw_string] = ACTIONS(4411),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1414),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1416),
    [anon_sym_BQUOTE] = ACTIONS(1418),
    [anon_sym_LT_LPAREN] = ACTIONS(1420),
    [anon_sym_GT_LPAREN] = ACTIONS(1420),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4411),
  },
  [1355] = {
    [aux_sym_concatenation_repeat1] = STATE(2018),
    [sym__concat] = ACTIONS(4413),
    [anon_sym_RPAREN] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [sym__special_character] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1071),
  },
  [1356] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(4415),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [1357] = {
    [sym__concat] = ACTIONS(1089),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_DOLLAR] = ACTIONS(1091),
    [sym__special_character] = ACTIONS(1089),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1089),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1089),
    [anon_sym_GT_LPAREN] = ACTIONS(1089),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1089),
  },
  [1358] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(627),
    [anon_sym_DOLLAR] = ACTIONS(4417),
    [anon_sym_DQUOTE] = ACTIONS(4415),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [1359] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(4419),
    [sym_comment] = ACTIONS(57),
  },
  [1360] = {
    [sym_subscript] = STATE(2024),
    [sym_variable_name] = ACTIONS(4421),
    [anon_sym_DASH] = ACTIONS(4423),
    [anon_sym_DOLLAR] = ACTIONS(4423),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4425),
    [anon_sym_STAR] = ACTIONS(4427),
    [anon_sym_AT] = ACTIONS(4427),
    [anon_sym_QMARK] = ACTIONS(4427),
    [anon_sym_0] = ACTIONS(4425),
    [anon_sym__] = ACTIONS(4425),
  },
  [1361] = {
    [sym_concatenation] = STATE(2027),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2027),
    [anon_sym_RBRACE] = ACTIONS(4429),
    [anon_sym_EQ] = ACTIONS(4431),
    [anon_sym_DASH] = ACTIONS(4431),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(4435),
    [anon_sym_COLON] = ACTIONS(4431),
    [anon_sym_COLON_QMARK] = ACTIONS(4431),
    [anon_sym_COLON_DASH] = ACTIONS(4431),
    [anon_sym_PERCENT] = ACTIONS(4431),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1362] = {
    [sym_concatenation] = STATE(2030),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2030),
    [anon_sym_RBRACE] = ACTIONS(4437),
    [anon_sym_EQ] = ACTIONS(4439),
    [anon_sym_DASH] = ACTIONS(4439),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4441),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(4443),
    [anon_sym_COLON] = ACTIONS(4439),
    [anon_sym_COLON_QMARK] = ACTIONS(4439),
    [anon_sym_COLON_DASH] = ACTIONS(4439),
    [anon_sym_PERCENT] = ACTIONS(4439),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1363] = {
    [anon_sym_RPAREN] = ACTIONS(4445),
    [sym_comment] = ACTIONS(57),
  },
  [1364] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(4445),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [1365] = {
    [anon_sym_BQUOTE] = ACTIONS(4445),
    [sym_comment] = ACTIONS(57),
  },
  [1366] = {
    [anon_sym_RPAREN] = ACTIONS(4447),
    [sym_comment] = ACTIONS(57),
  },
  [1367] = {
    [sym__simple_heredoc_body] = ACTIONS(4449),
    [sym__heredoc_body_beginning] = ACTIONS(4449),
    [sym_file_descriptor] = ACTIONS(4449),
    [sym_variable_name] = ACTIONS(4449),
    [ts_builtin_sym_end] = ACTIONS(4449),
    [anon_sym_SEMI] = ACTIONS(4451),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_RPAREN] = ACTIONS(4449),
    [anon_sym_SEMI_SEMI] = ACTIONS(4449),
    [anon_sym_PIPE_AMP] = ACTIONS(4449),
    [anon_sym_AMP_AMP] = ACTIONS(4449),
    [anon_sym_PIPE_PIPE] = ACTIONS(4449),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_GT_GT] = ACTIONS(4449),
    [anon_sym_AMP_GT] = ACTIONS(4451),
    [anon_sym_AMP_GT_GT] = ACTIONS(4449),
    [anon_sym_LT_AMP] = ACTIONS(4449),
    [anon_sym_GT_AMP] = ACTIONS(4449),
    [anon_sym_LT_LT] = ACTIONS(4451),
    [anon_sym_LT_LT_DASH] = ACTIONS(4449),
    [anon_sym_LT_LT_LT] = ACTIONS(4449),
    [anon_sym_DOLLAR] = ACTIONS(4451),
    [sym__special_character] = ACTIONS(4449),
    [anon_sym_DQUOTE] = ACTIONS(4449),
    [sym_raw_string] = ACTIONS(4449),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4449),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4449),
    [anon_sym_BQUOTE] = ACTIONS(4449),
    [anon_sym_LT_LPAREN] = ACTIONS(4449),
    [anon_sym_GT_LPAREN] = ACTIONS(4449),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4451),
    [anon_sym_LF] = ACTIONS(4449),
    [anon_sym_AMP] = ACTIONS(4451),
  },
  [1368] = {
    [sym_concatenation] = STATE(1368),
    [sym_string] = STATE(730),
    [sym_simple_expansion] = STATE(730),
    [sym_string_expansion] = STATE(730),
    [sym_expansion] = STATE(730),
    [sym_command_substitution] = STATE(730),
    [sym_process_substitution] = STATE(730),
    [aux_sym_for_statement_repeat1] = STATE(1368),
    [aux_sym__literal_repeat1] = STATE(736),
    [anon_sym_RPAREN] = ACTIONS(4453),
    [anon_sym_DOLLAR] = ACTIONS(4455),
    [sym__special_character] = ACTIONS(4458),
    [anon_sym_DQUOTE] = ACTIONS(4461),
    [sym_raw_string] = ACTIONS(4464),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4467),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4470),
    [anon_sym_BQUOTE] = ACTIONS(4473),
    [anon_sym_LT_LPAREN] = ACTIONS(4476),
    [anon_sym_GT_LPAREN] = ACTIONS(4476),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4464),
  },
  [1369] = {
    [anon_sym_RPAREN] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(335),
  },
  [1370] = {
    [aux_sym__literal_repeat1] = STATE(1370),
    [anon_sym_RPAREN] = ACTIONS(1373),
    [anon_sym_DOLLAR] = ACTIONS(1375),
    [sym__special_character] = ACTIONS(4479),
    [anon_sym_DQUOTE] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1373),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [anon_sym_LT_LPAREN] = ACTIONS(1373),
    [anon_sym_GT_LPAREN] = ACTIONS(1373),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1373),
  },
  [1371] = {
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(2362),
    [sym_variable_name] = ACTIONS(2362),
    [ts_builtin_sym_end] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_RPAREN] = ACTIONS(2362),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [1372] = {
    [sym_string] = STATE(1371),
    [sym_simple_expansion] = STATE(1371),
    [sym_string_expansion] = STATE(1371),
    [sym_expansion] = STATE(1371),
    [sym_command_substitution] = STATE(1371),
    [sym_process_substitution] = STATE(1371),
    [anon_sym_DOLLAR] = ACTIONS(4482),
    [sym__special_character] = ACTIONS(2759),
    [anon_sym_DQUOTE] = ACTIONS(457),
    [sym_raw_string] = ACTIONS(2759),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(461),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(463),
    [anon_sym_BQUOTE] = ACTIONS(465),
    [anon_sym_LT_LPAREN] = ACTIONS(467),
    [anon_sym_GT_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2759),
  },
  [1373] = {
    [aux_sym_concatenation_repeat1] = STATE(1373),
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(4484),
    [sym_variable_name] = ACTIONS(2362),
    [ts_builtin_sym_end] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [1374] = {
    [sym__simple_heredoc_body] = ACTIONS(2371),
    [sym__heredoc_body_beginning] = ACTIONS(2371),
    [sym_file_descriptor] = ACTIONS(2371),
    [sym__concat] = ACTIONS(2371),
    [sym_variable_name] = ACTIONS(2371),
    [ts_builtin_sym_end] = ACTIONS(2371),
    [anon_sym_SEMI] = ACTIONS(2373),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_RPAREN] = ACTIONS(2371),
    [anon_sym_SEMI_SEMI] = ACTIONS(2371),
    [anon_sym_PIPE_AMP] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_GT_GT] = ACTIONS(2371),
    [anon_sym_AMP_GT] = ACTIONS(2373),
    [anon_sym_AMP_GT_GT] = ACTIONS(2371),
    [anon_sym_LT_AMP] = ACTIONS(2371),
    [anon_sym_GT_AMP] = ACTIONS(2371),
    [anon_sym_LT_LT] = ACTIONS(2373),
    [anon_sym_LT_LT_DASH] = ACTIONS(2371),
    [anon_sym_LT_LT_LT] = ACTIONS(2371),
    [anon_sym_DOLLAR] = ACTIONS(2373),
    [sym__special_character] = ACTIONS(2371),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [sym_raw_string] = ACTIONS(2371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2371),
    [anon_sym_BQUOTE] = ACTIONS(2371),
    [anon_sym_LT_LPAREN] = ACTIONS(2371),
    [anon_sym_GT_LPAREN] = ACTIONS(2371),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2373),
    [anon_sym_LF] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
  },
  [1375] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(4487),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [1376] = {
    [sym_concatenation] = STATE(2037),
    [sym_string] = STATE(2036),
    [sym_simple_expansion] = STATE(2036),
    [sym_string_expansion] = STATE(2036),
    [sym_expansion] = STATE(2036),
    [sym_command_substitution] = STATE(2036),
    [sym_process_substitution] = STATE(2036),
    [aux_sym__literal_repeat1] = STATE(2038),
    [anon_sym_RBRACE] = ACTIONS(4489),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(4491),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4491),
  },
  [1377] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(4493),
    [sym_comment] = ACTIONS(57),
  },
  [1378] = {
    [sym_concatenation] = STATE(2042),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2042),
    [anon_sym_RBRACE] = ACTIONS(4495),
    [anon_sym_EQ] = ACTIONS(4497),
    [anon_sym_DASH] = ACTIONS(4497),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4499),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(4501),
    [anon_sym_COLON] = ACTIONS(4497),
    [anon_sym_COLON_QMARK] = ACTIONS(4497),
    [anon_sym_COLON_DASH] = ACTIONS(4497),
    [anon_sym_PERCENT] = ACTIONS(4497),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1379] = {
    [sym_concatenation] = STATE(2044),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2044),
    [anon_sym_RBRACE] = ACTIONS(4489),
    [anon_sym_EQ] = ACTIONS(4503),
    [anon_sym_DASH] = ACTIONS(4503),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4505),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(4507),
    [anon_sym_COLON] = ACTIONS(4503),
    [anon_sym_COLON_QMARK] = ACTIONS(4503),
    [anon_sym_COLON_DASH] = ACTIONS(4503),
    [anon_sym_PERCENT] = ACTIONS(4503),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1380] = {
    [sym__simple_heredoc_body] = ACTIONS(2462),
    [sym__heredoc_body_beginning] = ACTIONS(2462),
    [sym_file_descriptor] = ACTIONS(2462),
    [sym__concat] = ACTIONS(2462),
    [sym_variable_name] = ACTIONS(2462),
    [ts_builtin_sym_end] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_RPAREN] = ACTIONS(2462),
    [anon_sym_SEMI_SEMI] = ACTIONS(2462),
    [anon_sym_PIPE_AMP] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_GT_GT] = ACTIONS(2462),
    [anon_sym_AMP_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT_GT] = ACTIONS(2462),
    [anon_sym_LT_AMP] = ACTIONS(2462),
    [anon_sym_GT_AMP] = ACTIONS(2462),
    [anon_sym_LT_LT] = ACTIONS(2464),
    [anon_sym_LT_LT_DASH] = ACTIONS(2462),
    [anon_sym_LT_LT_LT] = ACTIONS(2462),
    [anon_sym_DOLLAR] = ACTIONS(2464),
    [sym__special_character] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [sym_raw_string] = ACTIONS(2462),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2462),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2462),
    [anon_sym_BQUOTE] = ACTIONS(2462),
    [anon_sym_LT_LPAREN] = ACTIONS(2462),
    [anon_sym_GT_LPAREN] = ACTIONS(2462),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2464),
    [anon_sym_LF] = ACTIONS(2462),
    [anon_sym_AMP] = ACTIONS(2464),
  },
  [1381] = {
    [sym_concatenation] = STATE(2047),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2047),
    [sym_regex] = ACTIONS(4509),
    [anon_sym_RBRACE] = ACTIONS(4511),
    [anon_sym_EQ] = ACTIONS(4513),
    [anon_sym_DASH] = ACTIONS(4513),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4515),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(4513),
    [anon_sym_COLON_QMARK] = ACTIONS(4513),
    [anon_sym_COLON_DASH] = ACTIONS(4513),
    [anon_sym_PERCENT] = ACTIONS(4513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1382] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(4511),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1383] = {
    [sym__simple_heredoc_body] = ACTIONS(2512),
    [sym__heredoc_body_beginning] = ACTIONS(2512),
    [sym_file_descriptor] = ACTIONS(2512),
    [sym__concat] = ACTIONS(2512),
    [sym_variable_name] = ACTIONS(2512),
    [ts_builtin_sym_end] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2514),
    [anon_sym_PIPE] = ACTIONS(2514),
    [anon_sym_RPAREN] = ACTIONS(2512),
    [anon_sym_SEMI_SEMI] = ACTIONS(2512),
    [anon_sym_PIPE_AMP] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE_PIPE] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2514),
    [anon_sym_GT] = ACTIONS(2514),
    [anon_sym_GT_GT] = ACTIONS(2512),
    [anon_sym_AMP_GT] = ACTIONS(2514),
    [anon_sym_AMP_GT_GT] = ACTIONS(2512),
    [anon_sym_LT_AMP] = ACTIONS(2512),
    [anon_sym_GT_AMP] = ACTIONS(2512),
    [anon_sym_LT_LT] = ACTIONS(2514),
    [anon_sym_LT_LT_DASH] = ACTIONS(2512),
    [anon_sym_LT_LT_LT] = ACTIONS(2512),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [sym__special_character] = ACTIONS(2512),
    [anon_sym_DQUOTE] = ACTIONS(2512),
    [sym_raw_string] = ACTIONS(2512),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2512),
    [anon_sym_BQUOTE] = ACTIONS(2512),
    [anon_sym_LT_LPAREN] = ACTIONS(2512),
    [anon_sym_GT_LPAREN] = ACTIONS(2512),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2514),
    [anon_sym_LF] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2514),
  },
  [1384] = {
    [sym_concatenation] = STATE(2044),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2044),
    [sym_regex] = ACTIONS(4517),
    [anon_sym_RBRACE] = ACTIONS(4489),
    [anon_sym_EQ] = ACTIONS(4503),
    [anon_sym_DASH] = ACTIONS(4503),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4505),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(4503),
    [anon_sym_COLON_QMARK] = ACTIONS(4503),
    [anon_sym_COLON_DASH] = ACTIONS(4503),
    [anon_sym_PERCENT] = ACTIONS(4503),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1385] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(4489),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1386] = {
    [sym__simple_heredoc_body] = ACTIONS(2520),
    [sym__heredoc_body_beginning] = ACTIONS(2520),
    [sym_file_descriptor] = ACTIONS(2520),
    [sym__concat] = ACTIONS(2520),
    [sym_variable_name] = ACTIONS(2520),
    [ts_builtin_sym_end] = ACTIONS(2520),
    [anon_sym_SEMI] = ACTIONS(2522),
    [anon_sym_PIPE] = ACTIONS(2522),
    [anon_sym_RPAREN] = ACTIONS(2520),
    [anon_sym_SEMI_SEMI] = ACTIONS(2520),
    [anon_sym_PIPE_AMP] = ACTIONS(2520),
    [anon_sym_AMP_AMP] = ACTIONS(2520),
    [anon_sym_PIPE_PIPE] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(2522),
    [anon_sym_GT] = ACTIONS(2522),
    [anon_sym_GT_GT] = ACTIONS(2520),
    [anon_sym_AMP_GT] = ACTIONS(2522),
    [anon_sym_AMP_GT_GT] = ACTIONS(2520),
    [anon_sym_LT_AMP] = ACTIONS(2520),
    [anon_sym_GT_AMP] = ACTIONS(2520),
    [anon_sym_LT_LT] = ACTIONS(2522),
    [anon_sym_LT_LT_DASH] = ACTIONS(2520),
    [anon_sym_LT_LT_LT] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(2522),
    [sym__special_character] = ACTIONS(2520),
    [anon_sym_DQUOTE] = ACTIONS(2520),
    [sym_raw_string] = ACTIONS(2520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2520),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2520),
    [anon_sym_BQUOTE] = ACTIONS(2520),
    [anon_sym_LT_LPAREN] = ACTIONS(2520),
    [anon_sym_GT_LPAREN] = ACTIONS(2520),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2522),
    [anon_sym_LF] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2522),
  },
  [1387] = {
    [sym__simple_heredoc_body] = ACTIONS(2554),
    [sym__heredoc_body_beginning] = ACTIONS(2554),
    [sym_file_descriptor] = ACTIONS(2554),
    [sym__concat] = ACTIONS(2554),
    [sym_variable_name] = ACTIONS(2554),
    [ts_builtin_sym_end] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(2556),
    [anon_sym_PIPE] = ACTIONS(2556),
    [anon_sym_RPAREN] = ACTIONS(2554),
    [anon_sym_SEMI_SEMI] = ACTIONS(2554),
    [anon_sym_PIPE_AMP] = ACTIONS(2554),
    [anon_sym_AMP_AMP] = ACTIONS(2554),
    [anon_sym_PIPE_PIPE] = ACTIONS(2554),
    [anon_sym_LT] = ACTIONS(2556),
    [anon_sym_GT] = ACTIONS(2556),
    [anon_sym_GT_GT] = ACTIONS(2554),
    [anon_sym_AMP_GT] = ACTIONS(2556),
    [anon_sym_AMP_GT_GT] = ACTIONS(2554),
    [anon_sym_LT_AMP] = ACTIONS(2554),
    [anon_sym_GT_AMP] = ACTIONS(2554),
    [anon_sym_LT_LT] = ACTIONS(2556),
    [anon_sym_LT_LT_DASH] = ACTIONS(2554),
    [anon_sym_LT_LT_LT] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2556),
    [sym__special_character] = ACTIONS(2554),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2554),
    [anon_sym_BQUOTE] = ACTIONS(2554),
    [anon_sym_LT_LPAREN] = ACTIONS(2554),
    [anon_sym_GT_LPAREN] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2556),
    [anon_sym_LF] = ACTIONS(2554),
    [anon_sym_AMP] = ACTIONS(2556),
  },
  [1388] = {
    [sym_do_group] = STATE(2050),
    [sym_compound_statement] = STATE(2050),
    [anon_sym_SEMI] = ACTIONS(4519),
    [anon_sym_do] = ACTIONS(651),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(57),
  },
  [1389] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4521),
    [anon_sym_AMP_AMP] = ACTIONS(557),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(559),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_PLUS_EQ] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DASH_EQ] = ACTIONS(557),
    [anon_sym_LT_EQ] = ACTIONS(557),
    [anon_sym_GT_EQ] = ACTIONS(557),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(557),
  },
  [1390] = {
    [sym__expression] = STATE(2052),
    [sym_binary_expression] = STATE(2052),
    [sym_unary_expression] = STATE(2052),
    [sym_postfix_expression] = STATE(2052),
    [sym_parenthesized_expression] = STATE(2052),
    [sym_concatenation] = STATE(2052),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__literal_repeat1] = STATE(53),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4521),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_DOLLAR] = ACTIONS(77),
    [sym__special_character] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [1391] = {
    [anon_sym_SEMI] = ACTIONS(2931),
    [anon_sym_SEMI_SEMI] = ACTIONS(2929),
    [anon_sym_AMP_AMP] = ACTIONS(2929),
    [anon_sym_PIPE_PIPE] = ACTIONS(2929),
    [anon_sym_EQ_TILDE] = ACTIONS(2929),
    [anon_sym_EQ_EQ] = ACTIONS(2929),
    [anon_sym_EQ] = ACTIONS(2931),
    [anon_sym_PLUS_EQ] = ACTIONS(2929),
    [anon_sym_LT] = ACTIONS(2931),
    [anon_sym_GT] = ACTIONS(2931),
    [anon_sym_BANG_EQ] = ACTIONS(2929),
    [anon_sym_PLUS] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(2931),
    [anon_sym_DASH_EQ] = ACTIONS(2929),
    [anon_sym_LT_EQ] = ACTIONS(2929),
    [anon_sym_GT_EQ] = ACTIONS(2929),
    [anon_sym_PLUS_PLUS] = ACTIONS(2929),
    [anon_sym_DASH_DASH] = ACTIONS(2929),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2929),
    [anon_sym_LF] = ACTIONS(2929),
    [anon_sym_AMP] = ACTIONS(2931),
  },
  [1392] = {
    [sym__concat] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_EQ_TILDE] = ACTIONS(2362),
    [anon_sym_EQ_EQ] = ACTIONS(2362),
    [anon_sym_EQ] = ACTIONS(2364),
    [anon_sym_PLUS_EQ] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_BANG_EQ] = ACTIONS(2362),
    [anon_sym_PLUS] = ACTIONS(2364),
    [anon_sym_DASH] = ACTIONS(2364),
    [anon_sym_DASH_EQ] = ACTIONS(2362),
    [anon_sym_LT_EQ] = ACTIONS(2362),
    [anon_sym_GT_EQ] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2362),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [1393] = {
    [sym_string] = STATE(1392),
    [sym_simple_expansion] = STATE(1392),
    [sym_string_expansion] = STATE(1392),
    [sym_expansion] = STATE(1392),
    [sym_command_substitution] = STATE(1392),
    [sym_process_substitution] = STATE(1392),
    [anon_sym_DOLLAR] = ACTIONS(4523),
    [sym__special_character] = ACTIONS(2810),
    [anon_sym_DQUOTE] = ACTIONS(481),
    [sym_raw_string] = ACTIONS(2810),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(485),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(487),
    [anon_sym_BQUOTE] = ACTIONS(489),
    [anon_sym_LT_LPAREN] = ACTIONS(491),
    [anon_sym_GT_LPAREN] = ACTIONS(491),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2810),
  },
  [1394] = {
    [aux_sym_concatenation_repeat1] = STATE(1394),
    [sym__concat] = ACTIONS(4525),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_EQ_TILDE] = ACTIONS(2362),
    [anon_sym_EQ_EQ] = ACTIONS(2362),
    [anon_sym_EQ] = ACTIONS(2364),
    [anon_sym_PLUS_EQ] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_BANG_EQ] = ACTIONS(2362),
    [anon_sym_PLUS] = ACTIONS(2364),
    [anon_sym_DASH] = ACTIONS(2364),
    [anon_sym_DASH_EQ] = ACTIONS(2362),
    [anon_sym_LT_EQ] = ACTIONS(2362),
    [anon_sym_GT_EQ] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2362),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [1395] = {
    [sym__concat] = ACTIONS(2371),
    [anon_sym_SEMI] = ACTIONS(2373),
    [anon_sym_SEMI_SEMI] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_EQ_TILDE] = ACTIONS(2371),
    [anon_sym_EQ_EQ] = ACTIONS(2371),
    [anon_sym_EQ] = ACTIONS(2373),
    [anon_sym_PLUS_EQ] = ACTIONS(2371),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2371),
    [anon_sym_PLUS] = ACTIONS(2373),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_DASH_EQ] = ACTIONS(2371),
    [anon_sym_LT_EQ] = ACTIONS(2371),
    [anon_sym_GT_EQ] = ACTIONS(2371),
    [anon_sym_PLUS_PLUS] = ACTIONS(2371),
    [anon_sym_DASH_DASH] = ACTIONS(2371),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2371),
    [anon_sym_LF] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
  },
  [1396] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(4528),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [1397] = {
    [sym_concatenation] = STATE(2057),
    [sym_string] = STATE(2056),
    [sym_simple_expansion] = STATE(2056),
    [sym_string_expansion] = STATE(2056),
    [sym_expansion] = STATE(2056),
    [sym_command_substitution] = STATE(2056),
    [sym_process_substitution] = STATE(2056),
    [aux_sym__literal_repeat1] = STATE(2058),
    [anon_sym_RBRACE] = ACTIONS(4530),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(4532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4532),
  },
  [1398] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(4534),
    [sym_comment] = ACTIONS(57),
  },
  [1399] = {
    [sym_concatenation] = STATE(2062),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2062),
    [anon_sym_RBRACE] = ACTIONS(4536),
    [anon_sym_EQ] = ACTIONS(4538),
    [anon_sym_DASH] = ACTIONS(4538),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4540),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(4542),
    [anon_sym_COLON] = ACTIONS(4538),
    [anon_sym_COLON_QMARK] = ACTIONS(4538),
    [anon_sym_COLON_DASH] = ACTIONS(4538),
    [anon_sym_PERCENT] = ACTIONS(4538),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1400] = {
    [sym_concatenation] = STATE(2064),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2064),
    [anon_sym_RBRACE] = ACTIONS(4530),
    [anon_sym_EQ] = ACTIONS(4544),
    [anon_sym_DASH] = ACTIONS(4544),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4546),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(4548),
    [anon_sym_COLON] = ACTIONS(4544),
    [anon_sym_COLON_QMARK] = ACTIONS(4544),
    [anon_sym_COLON_DASH] = ACTIONS(4544),
    [anon_sym_PERCENT] = ACTIONS(4544),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1401] = {
    [sym__concat] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_SEMI_SEMI] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_EQ_TILDE] = ACTIONS(2462),
    [anon_sym_EQ_EQ] = ACTIONS(2462),
    [anon_sym_EQ] = ACTIONS(2464),
    [anon_sym_PLUS_EQ] = ACTIONS(2462),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_BANG_EQ] = ACTIONS(2462),
    [anon_sym_PLUS] = ACTIONS(2464),
    [anon_sym_DASH] = ACTIONS(2464),
    [anon_sym_DASH_EQ] = ACTIONS(2462),
    [anon_sym_LT_EQ] = ACTIONS(2462),
    [anon_sym_GT_EQ] = ACTIONS(2462),
    [anon_sym_PLUS_PLUS] = ACTIONS(2462),
    [anon_sym_DASH_DASH] = ACTIONS(2462),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2462),
    [anon_sym_LF] = ACTIONS(2462),
    [anon_sym_AMP] = ACTIONS(2464),
  },
  [1402] = {
    [sym_concatenation] = STATE(2067),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2067),
    [sym_regex] = ACTIONS(4550),
    [anon_sym_RBRACE] = ACTIONS(4552),
    [anon_sym_EQ] = ACTIONS(4554),
    [anon_sym_DASH] = ACTIONS(4554),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4556),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(4554),
    [anon_sym_COLON_QMARK] = ACTIONS(4554),
    [anon_sym_COLON_DASH] = ACTIONS(4554),
    [anon_sym_PERCENT] = ACTIONS(4554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1403] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(4552),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1404] = {
    [sym__concat] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2514),
    [anon_sym_SEMI_SEMI] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE_PIPE] = ACTIONS(2512),
    [anon_sym_EQ_TILDE] = ACTIONS(2512),
    [anon_sym_EQ_EQ] = ACTIONS(2512),
    [anon_sym_EQ] = ACTIONS(2514),
    [anon_sym_PLUS_EQ] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2514),
    [anon_sym_GT] = ACTIONS(2514),
    [anon_sym_BANG_EQ] = ACTIONS(2512),
    [anon_sym_PLUS] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2514),
    [anon_sym_DASH_EQ] = ACTIONS(2512),
    [anon_sym_LT_EQ] = ACTIONS(2512),
    [anon_sym_GT_EQ] = ACTIONS(2512),
    [anon_sym_PLUS_PLUS] = ACTIONS(2512),
    [anon_sym_DASH_DASH] = ACTIONS(2512),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2512),
    [anon_sym_LF] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2514),
  },
  [1405] = {
    [sym_concatenation] = STATE(2064),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2064),
    [sym_regex] = ACTIONS(4558),
    [anon_sym_RBRACE] = ACTIONS(4530),
    [anon_sym_EQ] = ACTIONS(4544),
    [anon_sym_DASH] = ACTIONS(4544),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4546),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(4544),
    [anon_sym_COLON_QMARK] = ACTIONS(4544),
    [anon_sym_COLON_DASH] = ACTIONS(4544),
    [anon_sym_PERCENT] = ACTIONS(4544),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1406] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(4530),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1407] = {
    [sym__concat] = ACTIONS(2520),
    [anon_sym_SEMI] = ACTIONS(2522),
    [anon_sym_SEMI_SEMI] = ACTIONS(2520),
    [anon_sym_AMP_AMP] = ACTIONS(2520),
    [anon_sym_PIPE_PIPE] = ACTIONS(2520),
    [anon_sym_EQ_TILDE] = ACTIONS(2520),
    [anon_sym_EQ_EQ] = ACTIONS(2520),
    [anon_sym_EQ] = ACTIONS(2522),
    [anon_sym_PLUS_EQ] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(2522),
    [anon_sym_GT] = ACTIONS(2522),
    [anon_sym_BANG_EQ] = ACTIONS(2520),
    [anon_sym_PLUS] = ACTIONS(2522),
    [anon_sym_DASH] = ACTIONS(2522),
    [anon_sym_DASH_EQ] = ACTIONS(2520),
    [anon_sym_LT_EQ] = ACTIONS(2520),
    [anon_sym_GT_EQ] = ACTIONS(2520),
    [anon_sym_PLUS_PLUS] = ACTIONS(2520),
    [anon_sym_DASH_DASH] = ACTIONS(2520),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2520),
    [anon_sym_LF] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2522),
  },
  [1408] = {
    [sym__concat] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(2556),
    [anon_sym_SEMI_SEMI] = ACTIONS(2554),
    [anon_sym_AMP_AMP] = ACTIONS(2554),
    [anon_sym_PIPE_PIPE] = ACTIONS(2554),
    [anon_sym_EQ_TILDE] = ACTIONS(2554),
    [anon_sym_EQ_EQ] = ACTIONS(2554),
    [anon_sym_EQ] = ACTIONS(2556),
    [anon_sym_PLUS_EQ] = ACTIONS(2554),
    [anon_sym_LT] = ACTIONS(2556),
    [anon_sym_GT] = ACTIONS(2556),
    [anon_sym_BANG_EQ] = ACTIONS(2554),
    [anon_sym_PLUS] = ACTIONS(2556),
    [anon_sym_DASH] = ACTIONS(2556),
    [anon_sym_DASH_EQ] = ACTIONS(2554),
    [anon_sym_LT_EQ] = ACTIONS(2554),
    [anon_sym_GT_EQ] = ACTIONS(2554),
    [anon_sym_PLUS_PLUS] = ACTIONS(2554),
    [anon_sym_DASH_DASH] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2554),
    [anon_sym_LF] = ACTIONS(2554),
    [anon_sym_AMP] = ACTIONS(2556),
  },
  [1409] = {
    [anon_sym_SEMI] = ACTIONS(4560),
    [anon_sym_SEMI_SEMI] = ACTIONS(4562),
    [anon_sym_AMP_AMP] = ACTIONS(1484),
    [anon_sym_PIPE_PIPE] = ACTIONS(1484),
    [anon_sym_EQ_TILDE] = ACTIONS(1486),
    [anon_sym_EQ_EQ] = ACTIONS(1486),
    [anon_sym_EQ] = ACTIONS(1488),
    [anon_sym_PLUS_EQ] = ACTIONS(1484),
    [anon_sym_LT] = ACTIONS(1488),
    [anon_sym_GT] = ACTIONS(1488),
    [anon_sym_BANG_EQ] = ACTIONS(1484),
    [anon_sym_PLUS] = ACTIONS(1488),
    [anon_sym_DASH] = ACTIONS(1488),
    [anon_sym_DASH_EQ] = ACTIONS(1484),
    [anon_sym_LT_EQ] = ACTIONS(1484),
    [anon_sym_GT_EQ] = ACTIONS(1484),
    [anon_sym_PLUS_PLUS] = ACTIONS(1490),
    [anon_sym_DASH_DASH] = ACTIONS(1490),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1484),
    [anon_sym_LF] = ACTIONS(4562),
    [anon_sym_AMP] = ACTIONS(4560),
  },
  [1410] = {
    [anon_sym_SEMI] = ACTIONS(2977),
    [anon_sym_SEMI_SEMI] = ACTIONS(2975),
    [anon_sym_AMP_AMP] = ACTIONS(2975),
    [anon_sym_PIPE_PIPE] = ACTIONS(2975),
    [anon_sym_EQ_TILDE] = ACTIONS(2975),
    [anon_sym_EQ_EQ] = ACTIONS(2975),
    [anon_sym_EQ] = ACTIONS(2977),
    [anon_sym_PLUS_EQ] = ACTIONS(2975),
    [anon_sym_LT] = ACTIONS(2977),
    [anon_sym_GT] = ACTIONS(2977),
    [anon_sym_BANG_EQ] = ACTIONS(2975),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_DASH_EQ] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(2975),
    [anon_sym_GT_EQ] = ACTIONS(2975),
    [anon_sym_PLUS_PLUS] = ACTIONS(2975),
    [anon_sym_DASH_DASH] = ACTIONS(2975),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2975),
    [anon_sym_LF] = ACTIONS(2975),
    [anon_sym_AMP] = ACTIONS(2977),
  },
  [1411] = {
    [anon_sym_SEMI] = ACTIONS(2977),
    [anon_sym_SEMI_SEMI] = ACTIONS(2975),
    [anon_sym_AMP_AMP] = ACTIONS(2975),
    [anon_sym_PIPE_PIPE] = ACTIONS(2975),
    [anon_sym_EQ_TILDE] = ACTIONS(2975),
    [anon_sym_EQ_EQ] = ACTIONS(2975),
    [anon_sym_EQ] = ACTIONS(2977),
    [anon_sym_PLUS_EQ] = ACTIONS(2975),
    [anon_sym_LT] = ACTIONS(2977),
    [anon_sym_GT] = ACTIONS(2977),
    [anon_sym_BANG_EQ] = ACTIONS(2975),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_DASH_EQ] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(2975),
    [anon_sym_GT_EQ] = ACTIONS(2975),
    [anon_sym_PLUS_PLUS] = ACTIONS(2975),
    [anon_sym_DASH_DASH] = ACTIONS(2975),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2975),
    [anon_sym_LF] = ACTIONS(2975),
    [anon_sym_AMP] = ACTIONS(2977),
  },
  [1412] = {
    [sym__concat] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_DOLLAR] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [sym_raw_string] = ACTIONS(1057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1057),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1057),
    [anon_sym_BQUOTE] = ACTIONS(1057),
    [anon_sym_LT_LPAREN] = ACTIONS(1057),
    [anon_sym_GT_LPAREN] = ACTIONS(1057),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1057),
  },
  [1413] = {
    [sym__concat] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(1063),
    [anon_sym_SEMI_SEMI] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1061),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1061),
    [anon_sym_LT_LPAREN] = ACTIONS(1061),
    [anon_sym_GT_LPAREN] = ACTIONS(1061),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1063),
    [anon_sym_LF] = ACTIONS(1061),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [1414] = {
    [sym__concat] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_SEMI_SEMI] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1067),
    [sym__special_character] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LT_LPAREN] = ACTIONS(1065),
    [anon_sym_GT_LPAREN] = ACTIONS(1065),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1067),
    [anon_sym_LF] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1065),
  },
  [1415] = {
    [sym_string] = STATE(2070),
    [sym_simple_expansion] = STATE(2070),
    [sym_string_expansion] = STATE(2070),
    [sym_expansion] = STATE(2070),
    [sym_command_substitution] = STATE(2070),
    [sym_process_substitution] = STATE(2070),
    [anon_sym_DOLLAR] = ACTIONS(1494),
    [sym__special_character] = ACTIONS(4564),
    [anon_sym_DQUOTE] = ACTIONS(1498),
    [sym_raw_string] = ACTIONS(4564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1502),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1504),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_LT_LPAREN] = ACTIONS(1508),
    [anon_sym_GT_LPAREN] = ACTIONS(1508),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4564),
  },
  [1416] = {
    [aux_sym_concatenation_repeat1] = STATE(2072),
    [sym__concat] = ACTIONS(4566),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [sym__special_character] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1075),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1071),
  },
  [1417] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(4568),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [1418] = {
    [sym__concat] = ACTIONS(1089),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1089),
    [anon_sym_DOLLAR] = ACTIONS(1091),
    [sym__special_character] = ACTIONS(1089),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1089),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1089),
    [anon_sym_GT_LPAREN] = ACTIONS(1089),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1089),
  },
  [1419] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(627),
    [anon_sym_DOLLAR] = ACTIONS(4570),
    [anon_sym_DQUOTE] = ACTIONS(4568),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [1420] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(4572),
    [sym_comment] = ACTIONS(57),
  },
  [1421] = {
    [sym_subscript] = STATE(2078),
    [sym_variable_name] = ACTIONS(4574),
    [anon_sym_DASH] = ACTIONS(4576),
    [anon_sym_DOLLAR] = ACTIONS(4576),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4578),
    [anon_sym_STAR] = ACTIONS(4580),
    [anon_sym_AT] = ACTIONS(4580),
    [anon_sym_QMARK] = ACTIONS(4580),
    [anon_sym_0] = ACTIONS(4578),
    [anon_sym__] = ACTIONS(4578),
  },
  [1422] = {
    [sym_concatenation] = STATE(2081),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2081),
    [anon_sym_RBRACE] = ACTIONS(4582),
    [anon_sym_EQ] = ACTIONS(4584),
    [anon_sym_DASH] = ACTIONS(4584),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(4588),
    [anon_sym_COLON] = ACTIONS(4584),
    [anon_sym_COLON_QMARK] = ACTIONS(4584),
    [anon_sym_COLON_DASH] = ACTIONS(4584),
    [anon_sym_PERCENT] = ACTIONS(4584),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1423] = {
    [sym_concatenation] = STATE(2084),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2084),
    [anon_sym_RBRACE] = ACTIONS(4590),
    [anon_sym_EQ] = ACTIONS(4592),
    [anon_sym_DASH] = ACTIONS(4592),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4594),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(4596),
    [anon_sym_COLON] = ACTIONS(4592),
    [anon_sym_COLON_QMARK] = ACTIONS(4592),
    [anon_sym_COLON_DASH] = ACTIONS(4592),
    [anon_sym_PERCENT] = ACTIONS(4592),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1424] = {
    [anon_sym_RPAREN] = ACTIONS(4598),
    [sym_comment] = ACTIONS(57),
  },
  [1425] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(4598),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [1426] = {
    [anon_sym_BQUOTE] = ACTIONS(4598),
    [sym_comment] = ACTIONS(57),
  },
  [1427] = {
    [anon_sym_RPAREN] = ACTIONS(4600),
    [sym_comment] = ACTIONS(57),
  },
  [1428] = {
    [sym_do_group] = STATE(2087),
    [anon_sym_do] = ACTIONS(651),
    [sym_comment] = ACTIONS(57),
  },
  [1429] = {
    [sym_concatenation] = STATE(1429),
    [sym_string] = STATE(784),
    [sym_simple_expansion] = STATE(784),
    [sym_string_expansion] = STATE(784),
    [sym_expansion] = STATE(784),
    [sym_command_substitution] = STATE(784),
    [sym_process_substitution] = STATE(784),
    [aux_sym_for_statement_repeat1] = STATE(1429),
    [aux_sym__literal_repeat1] = STATE(790),
    [anon_sym_SEMI] = ACTIONS(4602),
    [anon_sym_SEMI_SEMI] = ACTIONS(4453),
    [anon_sym_DOLLAR] = ACTIONS(4604),
    [sym__special_character] = ACTIONS(4607),
    [anon_sym_DQUOTE] = ACTIONS(4610),
    [sym_raw_string] = ACTIONS(4613),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4616),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4619),
    [anon_sym_BQUOTE] = ACTIONS(4622),
    [anon_sym_LT_LPAREN] = ACTIONS(4625),
    [anon_sym_GT_LPAREN] = ACTIONS(4625),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4628),
    [anon_sym_LF] = ACTIONS(4453),
    [anon_sym_AMP] = ACTIONS(4453),
  },
  [1430] = {
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(335),
  },
  [1431] = {
    [aux_sym__literal_repeat1] = STATE(1431),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_DOLLAR] = ACTIONS(1375),
    [sym__special_character] = ACTIONS(4631),
    [anon_sym_DQUOTE] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1373),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [anon_sym_LT_LPAREN] = ACTIONS(1373),
    [anon_sym_GT_LPAREN] = ACTIONS(1373),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1375),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [1432] = {
    [anon_sym_RPAREN] = ACTIONS(2929),
    [anon_sym_AMP_AMP] = ACTIONS(2929),
    [anon_sym_PIPE_PIPE] = ACTIONS(2929),
    [anon_sym_EQ_TILDE] = ACTIONS(2929),
    [anon_sym_EQ_EQ] = ACTIONS(2929),
    [anon_sym_EQ] = ACTIONS(2931),
    [anon_sym_PLUS_EQ] = ACTIONS(2929),
    [anon_sym_LT] = ACTIONS(2931),
    [anon_sym_GT] = ACTIONS(2931),
    [anon_sym_BANG_EQ] = ACTIONS(2929),
    [anon_sym_PLUS] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(2931),
    [anon_sym_DASH_EQ] = ACTIONS(2929),
    [anon_sym_LT_EQ] = ACTIONS(2929),
    [anon_sym_GT_EQ] = ACTIONS(2929),
    [anon_sym_PLUS_PLUS] = ACTIONS(2929),
    [anon_sym_DASH_DASH] = ACTIONS(2929),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2929),
  },
  [1433] = {
    [sym__concat] = ACTIONS(2362),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_RPAREN] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_EQ_TILDE] = ACTIONS(2362),
    [anon_sym_EQ_EQ] = ACTIONS(2362),
    [anon_sym_EQ] = ACTIONS(2364),
    [anon_sym_PLUS_EQ] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_BANG_EQ] = ACTIONS(2362),
    [anon_sym_PLUS] = ACTIONS(2364),
    [anon_sym_DASH] = ACTIONS(2364),
    [anon_sym_DASH_EQ] = ACTIONS(2362),
    [anon_sym_LT_EQ] = ACTIONS(2362),
    [anon_sym_GT_EQ] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2362),
  },
  [1434] = {
    [sym_string] = STATE(1433),
    [sym_simple_expansion] = STATE(1433),
    [sym_string_expansion] = STATE(1433),
    [sym_expansion] = STATE(1433),
    [sym_command_substitution] = STATE(1433),
    [sym_process_substitution] = STATE(1433),
    [anon_sym_DOLLAR] = ACTIONS(4634),
    [sym__special_character] = ACTIONS(2891),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(2891),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2891),
  },
  [1435] = {
    [aux_sym_concatenation_repeat1] = STATE(1435),
    [sym__concat] = ACTIONS(4636),
    [anon_sym_RPAREN] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_EQ_TILDE] = ACTIONS(2362),
    [anon_sym_EQ_EQ] = ACTIONS(2362),
    [anon_sym_EQ] = ACTIONS(2364),
    [anon_sym_PLUS_EQ] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_BANG_EQ] = ACTIONS(2362),
    [anon_sym_PLUS] = ACTIONS(2364),
    [anon_sym_DASH] = ACTIONS(2364),
    [anon_sym_DASH_EQ] = ACTIONS(2362),
    [anon_sym_LT_EQ] = ACTIONS(2362),
    [anon_sym_GT_EQ] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2362),
  },
  [1436] = {
    [sym__concat] = ACTIONS(2371),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_RPAREN] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_EQ_TILDE] = ACTIONS(2371),
    [anon_sym_EQ_EQ] = ACTIONS(2371),
    [anon_sym_EQ] = ACTIONS(2373),
    [anon_sym_PLUS_EQ] = ACTIONS(2371),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2371),
    [anon_sym_PLUS] = ACTIONS(2373),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_DASH_EQ] = ACTIONS(2371),
    [anon_sym_LT_EQ] = ACTIONS(2371),
    [anon_sym_GT_EQ] = ACTIONS(2371),
    [anon_sym_PLUS_PLUS] = ACTIONS(2371),
    [anon_sym_DASH_DASH] = ACTIONS(2371),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2371),
  },
  [1437] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(4639),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [1438] = {
    [sym_concatenation] = STATE(2092),
    [sym_string] = STATE(2091),
    [sym_simple_expansion] = STATE(2091),
    [sym_string_expansion] = STATE(2091),
    [sym_expansion] = STATE(2091),
    [sym_command_substitution] = STATE(2091),
    [sym_process_substitution] = STATE(2091),
    [aux_sym__literal_repeat1] = STATE(2093),
    [anon_sym_RBRACE] = ACTIONS(4641),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(4643),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4643),
  },
  [1439] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(4645),
    [sym_comment] = ACTIONS(57),
  },
  [1440] = {
    [sym_concatenation] = STATE(2097),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2097),
    [anon_sym_RBRACE] = ACTIONS(4647),
    [anon_sym_EQ] = ACTIONS(4649),
    [anon_sym_DASH] = ACTIONS(4649),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4651),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(4653),
    [anon_sym_COLON] = ACTIONS(4649),
    [anon_sym_COLON_QMARK] = ACTIONS(4649),
    [anon_sym_COLON_DASH] = ACTIONS(4649),
    [anon_sym_PERCENT] = ACTIONS(4649),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1441] = {
    [sym_concatenation] = STATE(2099),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2099),
    [anon_sym_RBRACE] = ACTIONS(4641),
    [anon_sym_EQ] = ACTIONS(4655),
    [anon_sym_DASH] = ACTIONS(4655),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4657),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(4659),
    [anon_sym_COLON] = ACTIONS(4655),
    [anon_sym_COLON_QMARK] = ACTIONS(4655),
    [anon_sym_COLON_DASH] = ACTIONS(4655),
    [anon_sym_PERCENT] = ACTIONS(4655),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1442] = {
    [sym__concat] = ACTIONS(2462),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_RPAREN] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_EQ_TILDE] = ACTIONS(2462),
    [anon_sym_EQ_EQ] = ACTIONS(2462),
    [anon_sym_EQ] = ACTIONS(2464),
    [anon_sym_PLUS_EQ] = ACTIONS(2462),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_BANG_EQ] = ACTIONS(2462),
    [anon_sym_PLUS] = ACTIONS(2464),
    [anon_sym_DASH] = ACTIONS(2464),
    [anon_sym_DASH_EQ] = ACTIONS(2462),
    [anon_sym_LT_EQ] = ACTIONS(2462),
    [anon_sym_GT_EQ] = ACTIONS(2462),
    [anon_sym_PLUS_PLUS] = ACTIONS(2462),
    [anon_sym_DASH_DASH] = ACTIONS(2462),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2462),
  },
  [1443] = {
    [sym_concatenation] = STATE(2102),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2102),
    [sym_regex] = ACTIONS(4661),
    [anon_sym_RBRACE] = ACTIONS(4663),
    [anon_sym_EQ] = ACTIONS(4665),
    [anon_sym_DASH] = ACTIONS(4665),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4667),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(4665),
    [anon_sym_COLON_QMARK] = ACTIONS(4665),
    [anon_sym_COLON_DASH] = ACTIONS(4665),
    [anon_sym_PERCENT] = ACTIONS(4665),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1444] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(4663),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1445] = {
    [sym__concat] = ACTIONS(2512),
    [anon_sym_PIPE] = ACTIONS(2514),
    [anon_sym_RPAREN] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE_PIPE] = ACTIONS(2512),
    [anon_sym_EQ_TILDE] = ACTIONS(2512),
    [anon_sym_EQ_EQ] = ACTIONS(2512),
    [anon_sym_EQ] = ACTIONS(2514),
    [anon_sym_PLUS_EQ] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2514),
    [anon_sym_GT] = ACTIONS(2514),
    [anon_sym_BANG_EQ] = ACTIONS(2512),
    [anon_sym_PLUS] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2514),
    [anon_sym_DASH_EQ] = ACTIONS(2512),
    [anon_sym_LT_EQ] = ACTIONS(2512),
    [anon_sym_GT_EQ] = ACTIONS(2512),
    [anon_sym_PLUS_PLUS] = ACTIONS(2512),
    [anon_sym_DASH_DASH] = ACTIONS(2512),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2512),
  },
  [1446] = {
    [sym_concatenation] = STATE(2099),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2099),
    [sym_regex] = ACTIONS(4669),
    [anon_sym_RBRACE] = ACTIONS(4641),
    [anon_sym_EQ] = ACTIONS(4655),
    [anon_sym_DASH] = ACTIONS(4655),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4657),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(4655),
    [anon_sym_COLON_QMARK] = ACTIONS(4655),
    [anon_sym_COLON_DASH] = ACTIONS(4655),
    [anon_sym_PERCENT] = ACTIONS(4655),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1447] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(4641),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1448] = {
    [sym__concat] = ACTIONS(2520),
    [anon_sym_PIPE] = ACTIONS(2522),
    [anon_sym_RPAREN] = ACTIONS(2520),
    [anon_sym_AMP_AMP] = ACTIONS(2520),
    [anon_sym_PIPE_PIPE] = ACTIONS(2520),
    [anon_sym_EQ_TILDE] = ACTIONS(2520),
    [anon_sym_EQ_EQ] = ACTIONS(2520),
    [anon_sym_EQ] = ACTIONS(2522),
    [anon_sym_PLUS_EQ] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(2522),
    [anon_sym_GT] = ACTIONS(2522),
    [anon_sym_BANG_EQ] = ACTIONS(2520),
    [anon_sym_PLUS] = ACTIONS(2522),
    [anon_sym_DASH] = ACTIONS(2522),
    [anon_sym_DASH_EQ] = ACTIONS(2520),
    [anon_sym_LT_EQ] = ACTIONS(2520),
    [anon_sym_GT_EQ] = ACTIONS(2520),
    [anon_sym_PLUS_PLUS] = ACTIONS(2520),
    [anon_sym_DASH_DASH] = ACTIONS(2520),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2520),
  },
  [1449] = {
    [sym__concat] = ACTIONS(2554),
    [anon_sym_PIPE] = ACTIONS(2556),
    [anon_sym_RPAREN] = ACTIONS(2554),
    [anon_sym_AMP_AMP] = ACTIONS(2554),
    [anon_sym_PIPE_PIPE] = ACTIONS(2554),
    [anon_sym_EQ_TILDE] = ACTIONS(2554),
    [anon_sym_EQ_EQ] = ACTIONS(2554),
    [anon_sym_EQ] = ACTIONS(2556),
    [anon_sym_PLUS_EQ] = ACTIONS(2554),
    [anon_sym_LT] = ACTIONS(2556),
    [anon_sym_GT] = ACTIONS(2556),
    [anon_sym_BANG_EQ] = ACTIONS(2554),
    [anon_sym_PLUS] = ACTIONS(2556),
    [anon_sym_DASH] = ACTIONS(2556),
    [anon_sym_DASH_EQ] = ACTIONS(2554),
    [anon_sym_LT_EQ] = ACTIONS(2554),
    [anon_sym_GT_EQ] = ACTIONS(2554),
    [anon_sym_PLUS_PLUS] = ACTIONS(2554),
    [anon_sym_DASH_DASH] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2554),
  },
  [1450] = {
    [anon_sym_RPAREN] = ACTIONS(2975),
    [anon_sym_AMP_AMP] = ACTIONS(2975),
    [anon_sym_PIPE_PIPE] = ACTIONS(2975),
    [anon_sym_EQ_TILDE] = ACTIONS(2975),
    [anon_sym_EQ_EQ] = ACTIONS(2975),
    [anon_sym_EQ] = ACTIONS(2977),
    [anon_sym_PLUS_EQ] = ACTIONS(2975),
    [anon_sym_LT] = ACTIONS(2977),
    [anon_sym_GT] = ACTIONS(2977),
    [anon_sym_BANG_EQ] = ACTIONS(2975),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_DASH_EQ] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(2975),
    [anon_sym_GT_EQ] = ACTIONS(2975),
    [anon_sym_PLUS_PLUS] = ACTIONS(2975),
    [anon_sym_DASH_DASH] = ACTIONS(2975),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2975),
  },
  [1451] = {
    [anon_sym_RPAREN] = ACTIONS(2975),
    [anon_sym_AMP_AMP] = ACTIONS(2975),
    [anon_sym_PIPE_PIPE] = ACTIONS(2975),
    [anon_sym_EQ_TILDE] = ACTIONS(2975),
    [anon_sym_EQ_EQ] = ACTIONS(2975),
    [anon_sym_EQ] = ACTIONS(2977),
    [anon_sym_PLUS_EQ] = ACTIONS(2975),
    [anon_sym_LT] = ACTIONS(2977),
    [anon_sym_GT] = ACTIONS(2977),
    [anon_sym_BANG_EQ] = ACTIONS(2975),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_DASH_EQ] = ACTIONS(2975),
    [anon_sym_LT_EQ] = ACTIONS(2975),
    [anon_sym_GT_EQ] = ACTIONS(2975),
    [anon_sym_PLUS_PLUS] = ACTIONS(2975),
    [anon_sym_DASH_DASH] = ACTIONS(2975),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2975),
  },
  [1452] = {
    [sym_string] = STATE(303),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_PIPE_PIPE] = ACTIONS(4071),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4071),
    [anon_sym_EQ_TILDE] = ACTIONS(4071),
    [anon_sym_EQ_EQ] = ACTIONS(4071),
    [anon_sym_EQ] = ACTIONS(4073),
    [anon_sym_PLUS_EQ] = ACTIONS(4071),
    [anon_sym_LT] = ACTIONS(4073),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_BANG_EQ] = ACTIONS(4071),
    [anon_sym_PLUS] = ACTIONS(4073),
    [anon_sym_DASH] = ACTIONS(4671),
    [anon_sym_DASH_EQ] = ACTIONS(4071),
    [anon_sym_LT_EQ] = ACTIONS(4071),
    [anon_sym_GT_EQ] = ACTIONS(4071),
    [anon_sym_PLUS_PLUS] = ACTIONS(4071),
    [anon_sym_DASH_DASH] = ACTIONS(4071),
    [anon_sym_DOLLAR] = ACTIONS(527),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(529),
    [anon_sym_POUND] = ACTIONS(527),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(533),
    [anon_sym_QMARK] = ACTIONS(533),
    [anon_sym_0] = ACTIONS(531),
    [anon_sym__] = ACTIONS(531),
    [sym_test_operator] = ACTIONS(4071),
  },
  [1453] = {
    [sym__concat] = ACTIONS(4111),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4111),
    [anon_sym_EQ_TILDE] = ACTIONS(4111),
    [anon_sym_EQ_EQ] = ACTIONS(4111),
    [anon_sym_EQ] = ACTIONS(4113),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_LT] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4113),
    [anon_sym_BANG_EQ] = ACTIONS(4111),
    [anon_sym_PLUS] = ACTIONS(4113),
    [anon_sym_DASH] = ACTIONS(4113),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_PLUS_PLUS] = ACTIONS(4111),
    [anon_sym_DASH_DASH] = ACTIONS(4111),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4111),
  },
  [1454] = {
    [sym__concat] = ACTIONS(4125),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4125),
    [anon_sym_EQ_TILDE] = ACTIONS(4125),
    [anon_sym_EQ_EQ] = ACTIONS(4125),
    [anon_sym_EQ] = ACTIONS(4127),
    [anon_sym_PLUS_EQ] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_BANG_EQ] = ACTIONS(4125),
    [anon_sym_PLUS] = ACTIONS(4127),
    [anon_sym_DASH] = ACTIONS(4127),
    [anon_sym_DASH_EQ] = ACTIONS(4125),
    [anon_sym_LT_EQ] = ACTIONS(4125),
    [anon_sym_GT_EQ] = ACTIONS(4125),
    [anon_sym_PLUS_PLUS] = ACTIONS(4125),
    [anon_sym_DASH_DASH] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4125),
  },
  [1455] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(4673),
    [sym_comment] = ACTIONS(57),
  },
  [1456] = {
    [anon_sym_RBRACE] = ACTIONS(4673),
    [sym_comment] = ACTIONS(57),
  },
  [1457] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(4675),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [1458] = {
    [sym_concatenation] = STATE(2107),
    [sym_string] = STATE(2106),
    [sym_simple_expansion] = STATE(2106),
    [sym_string_expansion] = STATE(2106),
    [sym_expansion] = STATE(2106),
    [sym_command_substitution] = STATE(2106),
    [sym_process_substitution] = STATE(2106),
    [aux_sym__literal_repeat1] = STATE(2108),
    [anon_sym_RBRACE] = ACTIONS(4673),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(4677),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4677),
  },
  [1459] = {
    [sym__concat] = ACTIONS(4161),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4161),
    [anon_sym_AMP_AMP] = ACTIONS(4161),
    [anon_sym_PIPE_PIPE] = ACTIONS(4161),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4161),
    [anon_sym_EQ_TILDE] = ACTIONS(4161),
    [anon_sym_EQ_EQ] = ACTIONS(4161),
    [anon_sym_EQ] = ACTIONS(4163),
    [anon_sym_PLUS_EQ] = ACTIONS(4161),
    [anon_sym_LT] = ACTIONS(4163),
    [anon_sym_GT] = ACTIONS(4163),
    [anon_sym_BANG_EQ] = ACTIONS(4161),
    [anon_sym_PLUS] = ACTIONS(4163),
    [anon_sym_DASH] = ACTIONS(4163),
    [anon_sym_DASH_EQ] = ACTIONS(4161),
    [anon_sym_LT_EQ] = ACTIONS(4161),
    [anon_sym_GT_EQ] = ACTIONS(4161),
    [anon_sym_PLUS_PLUS] = ACTIONS(4161),
    [anon_sym_DASH_DASH] = ACTIONS(4161),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4161),
  },
  [1460] = {
    [sym_concatenation] = STATE(2111),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2111),
    [sym_regex] = ACTIONS(4679),
    [anon_sym_RBRACE] = ACTIONS(4681),
    [anon_sym_EQ] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4685),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(4683),
    [anon_sym_COLON_QMARK] = ACTIONS(4683),
    [anon_sym_COLON_DASH] = ACTIONS(4683),
    [anon_sym_PERCENT] = ACTIONS(4683),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1461] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(4681),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1462] = {
    [sym_concatenation] = STATE(2113),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2113),
    [sym_regex] = ACTIONS(4687),
    [anon_sym_RBRACE] = ACTIONS(4673),
    [anon_sym_EQ] = ACTIONS(4689),
    [anon_sym_DASH] = ACTIONS(4689),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4691),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(4689),
    [anon_sym_COLON_QMARK] = ACTIONS(4689),
    [anon_sym_COLON_DASH] = ACTIONS(4689),
    [anon_sym_PERCENT] = ACTIONS(4689),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1463] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(4673),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1464] = {
    [sym_concatenation] = STATE(2115),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2115),
    [anon_sym_RBRACE] = ACTIONS(4693),
    [anon_sym_EQ] = ACTIONS(4695),
    [anon_sym_DASH] = ACTIONS(4695),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4697),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(4695),
    [anon_sym_COLON_QMARK] = ACTIONS(4695),
    [anon_sym_COLON_DASH] = ACTIONS(4695),
    [anon_sym_PERCENT] = ACTIONS(4695),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1465] = {
    [sym__concat] = ACTIONS(4219),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4219),
    [anon_sym_AMP_AMP] = ACTIONS(4219),
    [anon_sym_PIPE_PIPE] = ACTIONS(4219),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4219),
    [anon_sym_EQ_TILDE] = ACTIONS(4219),
    [anon_sym_EQ_EQ] = ACTIONS(4219),
    [anon_sym_EQ] = ACTIONS(4221),
    [anon_sym_PLUS_EQ] = ACTIONS(4219),
    [anon_sym_LT] = ACTIONS(4221),
    [anon_sym_GT] = ACTIONS(4221),
    [anon_sym_BANG_EQ] = ACTIONS(4219),
    [anon_sym_PLUS] = ACTIONS(4221),
    [anon_sym_DASH] = ACTIONS(4221),
    [anon_sym_DASH_EQ] = ACTIONS(4219),
    [anon_sym_LT_EQ] = ACTIONS(4219),
    [anon_sym_GT_EQ] = ACTIONS(4219),
    [anon_sym_PLUS_PLUS] = ACTIONS(4219),
    [anon_sym_DASH_DASH] = ACTIONS(4219),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4219),
  },
  [1466] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(4693),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1467] = {
    [sym_concatenation] = STATE(2113),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2113),
    [anon_sym_RBRACE] = ACTIONS(4673),
    [anon_sym_EQ] = ACTIONS(4689),
    [anon_sym_DASH] = ACTIONS(4689),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4691),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(4689),
    [anon_sym_COLON_QMARK] = ACTIONS(4689),
    [anon_sym_COLON_DASH] = ACTIONS(4689),
    [anon_sym_PERCENT] = ACTIONS(4689),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1468] = {
    [sym_file_descriptor] = ACTIONS(2719),
    [sym_variable_name] = ACTIONS(2719),
    [anon_sym_SEMI] = ACTIONS(2721),
    [anon_sym_PIPE] = ACTIONS(2721),
    [anon_sym_SEMI_SEMI] = ACTIONS(2719),
    [anon_sym_PIPE_AMP] = ACTIONS(2719),
    [anon_sym_AMP_AMP] = ACTIONS(2719),
    [anon_sym_PIPE_PIPE] = ACTIONS(2719),
    [anon_sym_LT] = ACTIONS(2721),
    [anon_sym_GT] = ACTIONS(2721),
    [anon_sym_GT_GT] = ACTIONS(2719),
    [anon_sym_AMP_GT] = ACTIONS(2721),
    [anon_sym_AMP_GT_GT] = ACTIONS(2719),
    [anon_sym_LT_AMP] = ACTIONS(2719),
    [anon_sym_GT_AMP] = ACTIONS(2719),
    [anon_sym_LT_LT] = ACTIONS(2721),
    [anon_sym_LT_LT_DASH] = ACTIONS(2719),
    [anon_sym_LT_LT_LT] = ACTIONS(2719),
    [anon_sym_DOLLAR] = ACTIONS(2721),
    [sym__special_character] = ACTIONS(2719),
    [anon_sym_DQUOTE] = ACTIONS(2719),
    [sym_raw_string] = ACTIONS(2719),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2719),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2719),
    [anon_sym_BQUOTE] = ACTIONS(2719),
    [anon_sym_LT_LPAREN] = ACTIONS(2719),
    [anon_sym_GT_LPAREN] = ACTIONS(2719),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2721),
    [anon_sym_LF] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2721),
  },
  [1469] = {
    [sym_concatenation] = STATE(1368),
    [sym_string] = STATE(730),
    [sym_simple_expansion] = STATE(730),
    [sym_string_expansion] = STATE(730),
    [sym_expansion] = STATE(730),
    [sym_command_substitution] = STATE(730),
    [sym_process_substitution] = STATE(730),
    [aux_sym_for_statement_repeat1] = STATE(1368),
    [aux_sym__literal_repeat1] = STATE(736),
    [anon_sym_RPAREN] = ACTIONS(4699),
    [anon_sym_DOLLAR] = ACTIONS(1406),
    [sym__special_character] = ACTIONS(1408),
    [anon_sym_DQUOTE] = ACTIONS(1410),
    [sym_raw_string] = ACTIONS(1412),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1414),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1416),
    [anon_sym_BQUOTE] = ACTIONS(1418),
    [anon_sym_LT_LPAREN] = ACTIONS(1420),
    [anon_sym_GT_LPAREN] = ACTIONS(1420),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1412),
  },
  [1470] = {
    [sym_file_descriptor] = ACTIONS(1057),
    [sym__concat] = ACTIONS(1057),
    [sym_variable_name] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_PIPE_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_AMP] = ACTIONS(1057),
    [anon_sym_GT_AMP] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_LT] = ACTIONS(1057),
    [anon_sym_DOLLAR] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [sym_raw_string] = ACTIONS(1057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1057),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1057),
    [anon_sym_BQUOTE] = ACTIONS(1057),
    [anon_sym_LT_LPAREN] = ACTIONS(1057),
    [anon_sym_GT_LPAREN] = ACTIONS(1057),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [1471] = {
    [sym_file_descriptor] = ACTIONS(1061),
    [sym__concat] = ACTIONS(1061),
    [sym_variable_name] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(1063),
    [anon_sym_PIPE] = ACTIONS(1063),
    [anon_sym_SEMI_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE_AMP] = ACTIONS(1061),
    [anon_sym_AMP_AMP] = ACTIONS(1061),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1063),
    [anon_sym_GT_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT_GT] = ACTIONS(1061),
    [anon_sym_LT_AMP] = ACTIONS(1061),
    [anon_sym_GT_AMP] = ACTIONS(1061),
    [anon_sym_LT_LT] = ACTIONS(1063),
    [anon_sym_LT_LT_DASH] = ACTIONS(1061),
    [anon_sym_LT_LT_LT] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1061),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1061),
    [anon_sym_LT_LPAREN] = ACTIONS(1061),
    [anon_sym_GT_LPAREN] = ACTIONS(1061),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1063),
    [anon_sym_LF] = ACTIONS(1061),
    [anon_sym_AMP] = ACTIONS(1063),
  },
  [1472] = {
    [sym_file_descriptor] = ACTIONS(1065),
    [sym__concat] = ACTIONS(1065),
    [sym_variable_name] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1067),
    [anon_sym_SEMI_SEMI] = ACTIONS(1065),
    [anon_sym_PIPE_AMP] = ACTIONS(1065),
    [anon_sym_AMP_AMP] = ACTIONS(1065),
    [anon_sym_PIPE_PIPE] = ACTIONS(1065),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_GT] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT] = ACTIONS(1067),
    [anon_sym_AMP_GT_GT] = ACTIONS(1065),
    [anon_sym_LT_AMP] = ACTIONS(1065),
    [anon_sym_GT_AMP] = ACTIONS(1065),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_LT_LT_DASH] = ACTIONS(1065),
    [anon_sym_LT_LT_LT] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1067),
    [sym__special_character] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LT_LPAREN] = ACTIONS(1065),
    [anon_sym_GT_LPAREN] = ACTIONS(1065),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1067),
    [anon_sym_LF] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1067),
  },
  [1473] = {
    [sym_string] = STATE(2117),
    [sym_simple_expansion] = STATE(2117),
    [sym_string_expansion] = STATE(2117),
    [sym_expansion] = STATE(2117),
    [sym_command_substitution] = STATE(2117),
    [sym_process_substitution] = STATE(2117),
    [anon_sym_DOLLAR] = ACTIONS(1603),
    [sym__special_character] = ACTIONS(4701),
    [anon_sym_DQUOTE] = ACTIONS(1607),
    [sym_raw_string] = ACTIONS(4701),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1611),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1613),
    [anon_sym_BQUOTE] = ACTIONS(1615),
    [anon_sym_LT_LPAREN] = ACTIONS(1617),
    [anon_sym_GT_LPAREN] = ACTIONS(1617),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4701),
  },
  [1474] = {
    [aux_sym_concatenation_repeat1] = STATE(2119),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(4703),
    [sym_variable_name] = ACTIONS(1071),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [sym__special_character] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1075),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1075),
  },
  [1475] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(4705),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [1476] = {
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(1089),
    [sym_variable_name] = ACTIONS(1089),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1089),
    [anon_sym_PIPE_AMP] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_AMP] = ACTIONS(1089),
    [anon_sym_GT_AMP] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1089),
    [anon_sym_LT_LT_LT] = ACTIONS(1089),
    [anon_sym_DOLLAR] = ACTIONS(1091),
    [sym__special_character] = ACTIONS(1089),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1089),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1089),
    [anon_sym_GT_LPAREN] = ACTIONS(1089),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [1477] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(627),
    [anon_sym_DOLLAR] = ACTIONS(4707),
    [anon_sym_DQUOTE] = ACTIONS(4705),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [1478] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(4709),
    [sym_comment] = ACTIONS(57),
  },
  [1479] = {
    [sym_subscript] = STATE(2125),
    [sym_variable_name] = ACTIONS(4711),
    [anon_sym_DASH] = ACTIONS(4713),
    [anon_sym_DOLLAR] = ACTIONS(4713),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4715),
    [anon_sym_STAR] = ACTIONS(4717),
    [anon_sym_AT] = ACTIONS(4717),
    [anon_sym_QMARK] = ACTIONS(4717),
    [anon_sym_0] = ACTIONS(4715),
    [anon_sym__] = ACTIONS(4715),
  },
  [1480] = {
    [sym_concatenation] = STATE(2128),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2128),
    [anon_sym_RBRACE] = ACTIONS(4719),
    [anon_sym_EQ] = ACTIONS(4721),
    [anon_sym_DASH] = ACTIONS(4721),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4723),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(4725),
    [anon_sym_COLON] = ACTIONS(4721),
    [anon_sym_COLON_QMARK] = ACTIONS(4721),
    [anon_sym_COLON_DASH] = ACTIONS(4721),
    [anon_sym_PERCENT] = ACTIONS(4721),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1481] = {
    [sym_concatenation] = STATE(2131),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2131),
    [anon_sym_RBRACE] = ACTIONS(4727),
    [anon_sym_EQ] = ACTIONS(4729),
    [anon_sym_DASH] = ACTIONS(4729),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(4733),
    [anon_sym_COLON] = ACTIONS(4729),
    [anon_sym_COLON_QMARK] = ACTIONS(4729),
    [anon_sym_COLON_DASH] = ACTIONS(4729),
    [anon_sym_PERCENT] = ACTIONS(4729),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1482] = {
    [anon_sym_RPAREN] = ACTIONS(4735),
    [sym_comment] = ACTIONS(57),
  },
  [1483] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(4735),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [1484] = {
    [anon_sym_BQUOTE] = ACTIONS(4735),
    [sym_comment] = ACTIONS(57),
  },
  [1485] = {
    [anon_sym_RPAREN] = ACTIONS(4737),
    [sym_comment] = ACTIONS(57),
  },
  [1486] = {
    [sym_file_descriptor] = ACTIONS(335),
    [sym_variable_name] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [1487] = {
    [aux_sym__literal_repeat1] = STATE(1487),
    [sym_file_descriptor] = ACTIONS(1373),
    [sym_variable_name] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE_AMP] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_LT_LT_DASH] = ACTIONS(1373),
    [anon_sym_LT_LT_LT] = ACTIONS(1373),
    [anon_sym_DOLLAR] = ACTIONS(1375),
    [sym__special_character] = ACTIONS(4739),
    [anon_sym_DQUOTE] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1373),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [anon_sym_LT_LPAREN] = ACTIONS(1373),
    [anon_sym_GT_LPAREN] = ACTIONS(1373),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1375),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
  },
  [1488] = {
    [sym__expression] = STATE(2135),
    [sym_binary_expression] = STATE(2135),
    [sym_unary_expression] = STATE(2135),
    [sym_postfix_expression] = STATE(2135),
    [sym_parenthesized_expression] = STATE(2135),
    [sym_concatenation] = STATE(2135),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__literal_repeat1] = STATE(53),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4742),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_DOLLAR] = ACTIONS(77),
    [sym__special_character] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [1489] = {
    [anon_sym_SEMI] = ACTIONS(4744),
    [anon_sym_SEMI_SEMI] = ACTIONS(4746),
    [anon_sym_AMP_AMP] = ACTIONS(1484),
    [anon_sym_PIPE_PIPE] = ACTIONS(1484),
    [anon_sym_EQ_TILDE] = ACTIONS(1486),
    [anon_sym_EQ_EQ] = ACTIONS(1486),
    [anon_sym_EQ] = ACTIONS(1488),
    [anon_sym_PLUS_EQ] = ACTIONS(1484),
    [anon_sym_LT] = ACTIONS(1488),
    [anon_sym_GT] = ACTIONS(1488),
    [anon_sym_BANG_EQ] = ACTIONS(1484),
    [anon_sym_PLUS] = ACTIONS(1488),
    [anon_sym_DASH] = ACTIONS(1488),
    [anon_sym_DASH_EQ] = ACTIONS(1484),
    [anon_sym_LT_EQ] = ACTIONS(1484),
    [anon_sym_GT_EQ] = ACTIONS(1484),
    [anon_sym_PLUS_PLUS] = ACTIONS(1490),
    [anon_sym_DASH_DASH] = ACTIONS(1490),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1484),
    [anon_sym_LF] = ACTIONS(4746),
    [anon_sym_AMP] = ACTIONS(4744),
  },
  [1490] = {
    [sym__expression] = STATE(2137),
    [sym_binary_expression] = STATE(2137),
    [sym_unary_expression] = STATE(2137),
    [sym_postfix_expression] = STATE(2137),
    [sym_parenthesized_expression] = STATE(2137),
    [sym_concatenation] = STATE(2137),
    [sym_string] = STATE(280),
    [sym_simple_expansion] = STATE(280),
    [sym_string_expansion] = STATE(280),
    [sym_expansion] = STATE(280),
    [sym_command_substitution] = STATE(280),
    [sym_process_substitution] = STATE(280),
    [aux_sym__literal_repeat1] = STATE(286),
    [anon_sym_SEMI] = ACTIONS(4744),
    [anon_sym_SEMI_SEMI] = ACTIONS(4746),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(475),
    [anon_sym_DOLLAR] = ACTIONS(477),
    [sym__special_character] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(481),
    [sym_raw_string] = ACTIONS(483),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(485),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(487),
    [anon_sym_BQUOTE] = ACTIONS(489),
    [anon_sym_LT_LPAREN] = ACTIONS(491),
    [anon_sym_GT_LPAREN] = ACTIONS(491),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(493),
    [sym_test_operator] = ACTIONS(495),
    [anon_sym_LF] = ACTIONS(4746),
    [anon_sym_AMP] = ACTIONS(4746),
  },
  [1491] = {
    [sym_concatenation] = STATE(1429),
    [sym_string] = STATE(784),
    [sym_simple_expansion] = STATE(784),
    [sym_string_expansion] = STATE(784),
    [sym_expansion] = STATE(784),
    [sym_command_substitution] = STATE(784),
    [sym_process_substitution] = STATE(784),
    [aux_sym_for_statement_repeat1] = STATE(1429),
    [aux_sym__literal_repeat1] = STATE(790),
    [anon_sym_SEMI] = ACTIONS(4748),
    [anon_sym_SEMI_SEMI] = ACTIONS(4750),
    [anon_sym_DOLLAR] = ACTIONS(1494),
    [sym__special_character] = ACTIONS(1496),
    [anon_sym_DQUOTE] = ACTIONS(1498),
    [sym_raw_string] = ACTIONS(1500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1502),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1504),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_LT_LPAREN] = ACTIONS(1508),
    [anon_sym_GT_LPAREN] = ACTIONS(1508),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2881),
    [anon_sym_LF] = ACTIONS(4750),
    [anon_sym_AMP] = ACTIONS(4750),
  },
  [1492] = {
    [sym_file_descriptor] = ACTIONS(2885),
    [anon_sym_SEMI] = ACTIONS(2887),
    [anon_sym_PIPE] = ACTIONS(2887),
    [anon_sym_SEMI_SEMI] = ACTIONS(2885),
    [anon_sym_PIPE_AMP] = ACTIONS(2885),
    [anon_sym_AMP_AMP] = ACTIONS(2885),
    [anon_sym_PIPE_PIPE] = ACTIONS(2885),
    [anon_sym_LT] = ACTIONS(2887),
    [anon_sym_GT] = ACTIONS(2887),
    [anon_sym_GT_GT] = ACTIONS(2885),
    [anon_sym_AMP_GT] = ACTIONS(2887),
    [anon_sym_AMP_GT_GT] = ACTIONS(2885),
    [anon_sym_LT_AMP] = ACTIONS(2885),
    [anon_sym_GT_AMP] = ACTIONS(2885),
    [anon_sym_LT_LT] = ACTIONS(2887),
    [anon_sym_LT_LT_DASH] = ACTIONS(2885),
    [anon_sym_LT_LT_LT] = ACTIONS(2885),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2885),
    [anon_sym_AMP] = ACTIONS(2887),
  },
  [1493] = {
    [sym_file_descriptor] = ACTIONS(3223),
    [anon_sym_SEMI] = ACTIONS(3225),
    [anon_sym_PIPE] = ACTIONS(3225),
    [anon_sym_SEMI_SEMI] = ACTIONS(3223),
    [anon_sym_PIPE_AMP] = ACTIONS(3223),
    [anon_sym_AMP_AMP] = ACTIONS(3223),
    [anon_sym_PIPE_PIPE] = ACTIONS(3223),
    [anon_sym_LT] = ACTIONS(3225),
    [anon_sym_GT] = ACTIONS(3225),
    [anon_sym_GT_GT] = ACTIONS(3223),
    [anon_sym_AMP_GT] = ACTIONS(3225),
    [anon_sym_AMP_GT_GT] = ACTIONS(3223),
    [anon_sym_LT_AMP] = ACTIONS(3223),
    [anon_sym_GT_AMP] = ACTIONS(3223),
    [anon_sym_LT_LT] = ACTIONS(3225),
    [anon_sym_LT_LT_DASH] = ACTIONS(3223),
    [anon_sym_LT_LT_LT] = ACTIONS(3223),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3223),
    [anon_sym_AMP] = ACTIONS(3225),
  },
  [1494] = {
    [anon_sym_done] = ACTIONS(4752),
    [sym_comment] = ACTIONS(57),
  },
  [1495] = {
    [sym_file_descriptor] = ACTIONS(3377),
    [anon_sym_SEMI] = ACTIONS(3379),
    [anon_sym_PIPE] = ACTIONS(3379),
    [anon_sym_SEMI_SEMI] = ACTIONS(3377),
    [anon_sym_PIPE_AMP] = ACTIONS(3377),
    [anon_sym_AMP_AMP] = ACTIONS(3377),
    [anon_sym_PIPE_PIPE] = ACTIONS(3377),
    [anon_sym_LT] = ACTIONS(3379),
    [anon_sym_GT] = ACTIONS(3379),
    [anon_sym_GT_GT] = ACTIONS(3377),
    [anon_sym_AMP_GT] = ACTIONS(3379),
    [anon_sym_AMP_GT_GT] = ACTIONS(3377),
    [anon_sym_LT_AMP] = ACTIONS(3377),
    [anon_sym_GT_AMP] = ACTIONS(3377),
    [anon_sym_LT_LT] = ACTIONS(3379),
    [anon_sym_LT_LT_DASH] = ACTIONS(3377),
    [anon_sym_LT_LT_LT] = ACTIONS(3377),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3377),
    [anon_sym_AMP] = ACTIONS(3379),
  },
  [1496] = {
    [sym_elif_clause] = STATE(2142),
    [sym_else_clause] = STATE(2141),
    [aux_sym_if_statement_repeat1] = STATE(2142),
    [anon_sym_fi] = ACTIONS(4754),
    [anon_sym_elif] = ACTIONS(3477),
    [anon_sym_else] = ACTIONS(3479),
    [sym_comment] = ACTIONS(57),
  },
  [1497] = {
    [anon_sym_fi] = ACTIONS(4754),
    [sym_comment] = ACTIONS(57),
  },
  [1498] = {
    [sym_elif_clause] = STATE(1700),
    [sym_else_clause] = STATE(2141),
    [aux_sym_if_statement_repeat1] = STATE(1700),
    [anon_sym_fi] = ACTIONS(4754),
    [anon_sym_elif] = ACTIONS(3477),
    [anon_sym_else] = ACTIONS(3479),
    [sym_comment] = ACTIONS(57),
  },
  [1499] = {
    [sym_case_item] = STATE(2145),
    [sym_last_case_item] = STATE(2144),
    [sym_concatenation] = STATE(1710),
    [sym_string] = STATE(1708),
    [sym_simple_expansion] = STATE(1708),
    [sym_string_expansion] = STATE(1708),
    [sym_expansion] = STATE(1708),
    [sym_command_substitution] = STATE(1708),
    [sym_process_substitution] = STATE(1708),
    [aux_sym_case_statement_repeat1] = STATE(2145),
    [aux_sym__literal_repeat1] = STATE(1712),
    [anon_sym_esac] = ACTIONS(4756),
    [anon_sym_DOLLAR] = ACTIONS(507),
    [sym__special_character] = ACTIONS(3518),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3522),
  },
  [1500] = {
    [anon_sym_SEMI] = ACTIONS(4758),
    [anon_sym_SEMI_SEMI] = ACTIONS(4760),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4760),
    [anon_sym_AMP] = ACTIONS(4760),
  },
  [1501] = {
    [sym_case_item] = STATE(2149),
    [sym_last_case_item] = STATE(2148),
    [sym_concatenation] = STATE(1710),
    [sym_string] = STATE(1708),
    [sym_simple_expansion] = STATE(1708),
    [sym_string_expansion] = STATE(1708),
    [sym_expansion] = STATE(1708),
    [sym_command_substitution] = STATE(1708),
    [sym_process_substitution] = STATE(1708),
    [aux_sym_case_statement_repeat1] = STATE(2149),
    [aux_sym__literal_repeat1] = STATE(1712),
    [anon_sym_esac] = ACTIONS(4762),
    [anon_sym_DOLLAR] = ACTIONS(507),
    [sym__special_character] = ACTIONS(3518),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3522),
  },
  [1502] = {
    [anon_sym_SEMI] = ACTIONS(4764),
    [anon_sym_SEMI_SEMI] = ACTIONS(4766),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4766),
    [anon_sym_AMP] = ACTIONS(4766),
  },
  [1503] = {
    [sym_compound_statement] = STATE(2151),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_comment] = ACTIONS(57),
  },
  [1504] = {
    [sym_file_descriptor] = ACTIONS(1400),
    [sym_variable_name] = ACTIONS(1400),
    [anon_sym_SEMI] = ACTIONS(1402),
    [anon_sym_PIPE] = ACTIONS(1402),
    [anon_sym_SEMI_SEMI] = ACTIONS(1400),
    [anon_sym_PIPE_AMP] = ACTIONS(1400),
    [anon_sym_AMP_AMP] = ACTIONS(1400),
    [anon_sym_PIPE_PIPE] = ACTIONS(1400),
    [anon_sym_LT] = ACTIONS(1402),
    [anon_sym_GT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT] = ACTIONS(1402),
    [anon_sym_AMP_GT_GT] = ACTIONS(1400),
    [anon_sym_LT_AMP] = ACTIONS(1400),
    [anon_sym_GT_AMP] = ACTIONS(1400),
    [anon_sym_LT_LT] = ACTIONS(1402),
    [anon_sym_LT_LT_DASH] = ACTIONS(1400),
    [anon_sym_LT_LT_LT] = ACTIONS(1400),
    [anon_sym_DOLLAR] = ACTIONS(1402),
    [sym__special_character] = ACTIONS(1400),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1400),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1400),
    [anon_sym_BQUOTE] = ACTIONS(1400),
    [anon_sym_LT_LPAREN] = ACTIONS(1400),
    [anon_sym_GT_LPAREN] = ACTIONS(1400),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1402),
    [sym_word] = ACTIONS(1402),
    [anon_sym_LF] = ACTIONS(1400),
    [anon_sym_AMP] = ACTIONS(1402),
  },
  [1505] = {
    [sym_concatenation] = STATE(2153),
    [sym_string] = STATE(730),
    [sym_simple_expansion] = STATE(730),
    [sym_string_expansion] = STATE(730),
    [sym_expansion] = STATE(730),
    [sym_command_substitution] = STATE(730),
    [sym_process_substitution] = STATE(730),
    [aux_sym_for_statement_repeat1] = STATE(2153),
    [aux_sym__literal_repeat1] = STATE(736),
    [anon_sym_RPAREN] = ACTIONS(4768),
    [anon_sym_DOLLAR] = ACTIONS(1406),
    [sym__special_character] = ACTIONS(1408),
    [anon_sym_DQUOTE] = ACTIONS(1410),
    [sym_raw_string] = ACTIONS(1412),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1414),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1416),
    [anon_sym_BQUOTE] = ACTIONS(1418),
    [anon_sym_LT_LPAREN] = ACTIONS(1420),
    [anon_sym_GT_LPAREN] = ACTIONS(1420),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1412),
  },
  [1506] = {
    [aux_sym_concatenation_repeat1] = STATE(867),
    [sym_file_descriptor] = ACTIONS(1400),
    [sym__concat] = ACTIONS(1663),
    [sym_variable_name] = ACTIONS(1400),
    [anon_sym_SEMI] = ACTIONS(1402),
    [anon_sym_PIPE] = ACTIONS(1402),
    [anon_sym_SEMI_SEMI] = ACTIONS(1400),
    [anon_sym_PIPE_AMP] = ACTIONS(1400),
    [anon_sym_AMP_AMP] = ACTIONS(1400),
    [anon_sym_PIPE_PIPE] = ACTIONS(1400),
    [anon_sym_LT] = ACTIONS(1402),
    [anon_sym_GT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT] = ACTIONS(1402),
    [anon_sym_AMP_GT_GT] = ACTIONS(1400),
    [anon_sym_LT_AMP] = ACTIONS(1400),
    [anon_sym_GT_AMP] = ACTIONS(1400),
    [anon_sym_LT_LT] = ACTIONS(1402),
    [anon_sym_LT_LT_DASH] = ACTIONS(1400),
    [anon_sym_LT_LT_LT] = ACTIONS(1400),
    [anon_sym_DOLLAR] = ACTIONS(1402),
    [sym__special_character] = ACTIONS(1400),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1400),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1400),
    [anon_sym_BQUOTE] = ACTIONS(1400),
    [anon_sym_LT_LPAREN] = ACTIONS(1400),
    [anon_sym_GT_LPAREN] = ACTIONS(1400),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1402),
    [sym_word] = ACTIONS(1402),
    [anon_sym_LF] = ACTIONS(1400),
    [anon_sym_AMP] = ACTIONS(1402),
  },
  [1507] = {
    [aux_sym__literal_repeat1] = STATE(881),
    [sym_file_descriptor] = ACTIONS(1446),
    [sym_variable_name] = ACTIONS(1446),
    [anon_sym_SEMI] = ACTIONS(1448),
    [anon_sym_PIPE] = ACTIONS(1448),
    [anon_sym_SEMI_SEMI] = ACTIONS(1446),
    [anon_sym_PIPE_AMP] = ACTIONS(1446),
    [anon_sym_AMP_AMP] = ACTIONS(1446),
    [anon_sym_PIPE_PIPE] = ACTIONS(1446),
    [anon_sym_LT] = ACTIONS(1448),
    [anon_sym_GT] = ACTIONS(1448),
    [anon_sym_GT_GT] = ACTIONS(1446),
    [anon_sym_AMP_GT] = ACTIONS(1448),
    [anon_sym_AMP_GT_GT] = ACTIONS(1446),
    [anon_sym_LT_AMP] = ACTIONS(1446),
    [anon_sym_GT_AMP] = ACTIONS(1446),
    [anon_sym_LT_LT] = ACTIONS(1448),
    [anon_sym_LT_LT_DASH] = ACTIONS(1446),
    [anon_sym_LT_LT_LT] = ACTIONS(1446),
    [anon_sym_DOLLAR] = ACTIONS(1448),
    [sym__special_character] = ACTIONS(1681),
    [anon_sym_DQUOTE] = ACTIONS(1446),
    [sym_raw_string] = ACTIONS(1446),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1446),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1446),
    [anon_sym_BQUOTE] = ACTIONS(1446),
    [anon_sym_LT_LPAREN] = ACTIONS(1446),
    [anon_sym_GT_LPAREN] = ACTIONS(1446),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1448),
    [sym_word] = ACTIONS(1448),
    [anon_sym_LF] = ACTIONS(1446),
    [anon_sym_AMP] = ACTIONS(1448),
  },
  [1508] = {
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(2362),
    [sym_variable_name] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2364),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [1509] = {
    [sym_string] = STATE(1508),
    [sym_simple_expansion] = STATE(1508),
    [sym_string_expansion] = STATE(1508),
    [sym_expansion] = STATE(1508),
    [sym_command_substitution] = STATE(1508),
    [sym_process_substitution] = STATE(1508),
    [anon_sym_DOLLAR] = ACTIONS(4770),
    [sym__special_character] = ACTIONS(3039),
    [anon_sym_DQUOTE] = ACTIONS(589),
    [sym_raw_string] = ACTIONS(3039),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(593),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(595),
    [anon_sym_BQUOTE] = ACTIONS(597),
    [anon_sym_LT_LPAREN] = ACTIONS(599),
    [anon_sym_GT_LPAREN] = ACTIONS(599),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3039),
  },
  [1510] = {
    [aux_sym_concatenation_repeat1] = STATE(1510),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(4772),
    [sym_variable_name] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2364),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [1511] = {
    [sym_file_descriptor] = ACTIONS(2371),
    [sym__concat] = ACTIONS(2371),
    [sym_variable_name] = ACTIONS(2371),
    [anon_sym_SEMI] = ACTIONS(2373),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_SEMI_SEMI] = ACTIONS(2371),
    [anon_sym_PIPE_AMP] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_GT_GT] = ACTIONS(2371),
    [anon_sym_AMP_GT] = ACTIONS(2373),
    [anon_sym_AMP_GT_GT] = ACTIONS(2371),
    [anon_sym_LT_AMP] = ACTIONS(2371),
    [anon_sym_GT_AMP] = ACTIONS(2371),
    [anon_sym_LT_LT] = ACTIONS(2373),
    [anon_sym_LT_LT_DASH] = ACTIONS(2371),
    [anon_sym_LT_LT_LT] = ACTIONS(2371),
    [anon_sym_DOLLAR] = ACTIONS(2373),
    [sym__special_character] = ACTIONS(2371),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [sym_raw_string] = ACTIONS(2371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2371),
    [anon_sym_BQUOTE] = ACTIONS(2371),
    [anon_sym_LT_LPAREN] = ACTIONS(2371),
    [anon_sym_GT_LPAREN] = ACTIONS(2371),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2373),
    [sym_word] = ACTIONS(2373),
    [anon_sym_LF] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
  },
  [1512] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(4775),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [1513] = {
    [sym_concatenation] = STATE(2158),
    [sym_string] = STATE(2157),
    [sym_simple_expansion] = STATE(2157),
    [sym_string_expansion] = STATE(2157),
    [sym_expansion] = STATE(2157),
    [sym_command_substitution] = STATE(2157),
    [sym_process_substitution] = STATE(2157),
    [aux_sym__literal_repeat1] = STATE(2159),
    [anon_sym_RBRACE] = ACTIONS(4777),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(4779),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4779),
  },
  [1514] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(4781),
    [sym_comment] = ACTIONS(57),
  },
  [1515] = {
    [sym_concatenation] = STATE(2163),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2163),
    [anon_sym_RBRACE] = ACTIONS(4783),
    [anon_sym_EQ] = ACTIONS(4785),
    [anon_sym_DASH] = ACTIONS(4785),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4787),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(4789),
    [anon_sym_COLON] = ACTIONS(4785),
    [anon_sym_COLON_QMARK] = ACTIONS(4785),
    [anon_sym_COLON_DASH] = ACTIONS(4785),
    [anon_sym_PERCENT] = ACTIONS(4785),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1516] = {
    [sym_concatenation] = STATE(2165),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2165),
    [anon_sym_RBRACE] = ACTIONS(4777),
    [anon_sym_EQ] = ACTIONS(4791),
    [anon_sym_DASH] = ACTIONS(4791),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4793),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(4795),
    [anon_sym_COLON] = ACTIONS(4791),
    [anon_sym_COLON_QMARK] = ACTIONS(4791),
    [anon_sym_COLON_DASH] = ACTIONS(4791),
    [anon_sym_PERCENT] = ACTIONS(4791),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1517] = {
    [sym_file_descriptor] = ACTIONS(2462),
    [sym__concat] = ACTIONS(2462),
    [sym_variable_name] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_SEMI_SEMI] = ACTIONS(2462),
    [anon_sym_PIPE_AMP] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_GT_GT] = ACTIONS(2462),
    [anon_sym_AMP_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT_GT] = ACTIONS(2462),
    [anon_sym_LT_AMP] = ACTIONS(2462),
    [anon_sym_GT_AMP] = ACTIONS(2462),
    [anon_sym_LT_LT] = ACTIONS(2464),
    [anon_sym_LT_LT_DASH] = ACTIONS(2462),
    [anon_sym_LT_LT_LT] = ACTIONS(2462),
    [anon_sym_DOLLAR] = ACTIONS(2464),
    [sym__special_character] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [sym_raw_string] = ACTIONS(2462),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2462),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2462),
    [anon_sym_BQUOTE] = ACTIONS(2462),
    [anon_sym_LT_LPAREN] = ACTIONS(2462),
    [anon_sym_GT_LPAREN] = ACTIONS(2462),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2464),
    [sym_word] = ACTIONS(2464),
    [anon_sym_LF] = ACTIONS(2462),
    [anon_sym_AMP] = ACTIONS(2464),
  },
  [1518] = {
    [sym_concatenation] = STATE(2168),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2168),
    [sym_regex] = ACTIONS(4797),
    [anon_sym_RBRACE] = ACTIONS(4799),
    [anon_sym_EQ] = ACTIONS(4801),
    [anon_sym_DASH] = ACTIONS(4801),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4803),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(4801),
    [anon_sym_COLON_QMARK] = ACTIONS(4801),
    [anon_sym_COLON_DASH] = ACTIONS(4801),
    [anon_sym_PERCENT] = ACTIONS(4801),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1519] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(4799),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1520] = {
    [sym_file_descriptor] = ACTIONS(2512),
    [sym__concat] = ACTIONS(2512),
    [sym_variable_name] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2514),
    [anon_sym_PIPE] = ACTIONS(2514),
    [anon_sym_SEMI_SEMI] = ACTIONS(2512),
    [anon_sym_PIPE_AMP] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE_PIPE] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2514),
    [anon_sym_GT] = ACTIONS(2514),
    [anon_sym_GT_GT] = ACTIONS(2512),
    [anon_sym_AMP_GT] = ACTIONS(2514),
    [anon_sym_AMP_GT_GT] = ACTIONS(2512),
    [anon_sym_LT_AMP] = ACTIONS(2512),
    [anon_sym_GT_AMP] = ACTIONS(2512),
    [anon_sym_LT_LT] = ACTIONS(2514),
    [anon_sym_LT_LT_DASH] = ACTIONS(2512),
    [anon_sym_LT_LT_LT] = ACTIONS(2512),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [sym__special_character] = ACTIONS(2512),
    [anon_sym_DQUOTE] = ACTIONS(2512),
    [sym_raw_string] = ACTIONS(2512),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2512),
    [anon_sym_BQUOTE] = ACTIONS(2512),
    [anon_sym_LT_LPAREN] = ACTIONS(2512),
    [anon_sym_GT_LPAREN] = ACTIONS(2512),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2514),
    [sym_word] = ACTIONS(2514),
    [anon_sym_LF] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2514),
  },
  [1521] = {
    [sym_concatenation] = STATE(2165),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2165),
    [sym_regex] = ACTIONS(4805),
    [anon_sym_RBRACE] = ACTIONS(4777),
    [anon_sym_EQ] = ACTIONS(4791),
    [anon_sym_DASH] = ACTIONS(4791),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4793),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(4791),
    [anon_sym_COLON_QMARK] = ACTIONS(4791),
    [anon_sym_COLON_DASH] = ACTIONS(4791),
    [anon_sym_PERCENT] = ACTIONS(4791),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1522] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(4777),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1523] = {
    [sym_file_descriptor] = ACTIONS(2520),
    [sym__concat] = ACTIONS(2520),
    [sym_variable_name] = ACTIONS(2520),
    [anon_sym_SEMI] = ACTIONS(2522),
    [anon_sym_PIPE] = ACTIONS(2522),
    [anon_sym_SEMI_SEMI] = ACTIONS(2520),
    [anon_sym_PIPE_AMP] = ACTIONS(2520),
    [anon_sym_AMP_AMP] = ACTIONS(2520),
    [anon_sym_PIPE_PIPE] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(2522),
    [anon_sym_GT] = ACTIONS(2522),
    [anon_sym_GT_GT] = ACTIONS(2520),
    [anon_sym_AMP_GT] = ACTIONS(2522),
    [anon_sym_AMP_GT_GT] = ACTIONS(2520),
    [anon_sym_LT_AMP] = ACTIONS(2520),
    [anon_sym_GT_AMP] = ACTIONS(2520),
    [anon_sym_LT_LT] = ACTIONS(2522),
    [anon_sym_LT_LT_DASH] = ACTIONS(2520),
    [anon_sym_LT_LT_LT] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(2522),
    [sym__special_character] = ACTIONS(2520),
    [anon_sym_DQUOTE] = ACTIONS(2520),
    [sym_raw_string] = ACTIONS(2520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2520),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2520),
    [anon_sym_BQUOTE] = ACTIONS(2520),
    [anon_sym_LT_LPAREN] = ACTIONS(2520),
    [anon_sym_GT_LPAREN] = ACTIONS(2520),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2522),
    [sym_word] = ACTIONS(2522),
    [anon_sym_LF] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2522),
  },
  [1524] = {
    [sym_file_descriptor] = ACTIONS(2554),
    [sym__concat] = ACTIONS(2554),
    [sym_variable_name] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(2556),
    [anon_sym_PIPE] = ACTIONS(2556),
    [anon_sym_SEMI_SEMI] = ACTIONS(2554),
    [anon_sym_PIPE_AMP] = ACTIONS(2554),
    [anon_sym_AMP_AMP] = ACTIONS(2554),
    [anon_sym_PIPE_PIPE] = ACTIONS(2554),
    [anon_sym_LT] = ACTIONS(2556),
    [anon_sym_GT] = ACTIONS(2556),
    [anon_sym_GT_GT] = ACTIONS(2554),
    [anon_sym_AMP_GT] = ACTIONS(2556),
    [anon_sym_AMP_GT_GT] = ACTIONS(2554),
    [anon_sym_LT_AMP] = ACTIONS(2554),
    [anon_sym_GT_AMP] = ACTIONS(2554),
    [anon_sym_LT_LT] = ACTIONS(2556),
    [anon_sym_LT_LT_DASH] = ACTIONS(2554),
    [anon_sym_LT_LT_LT] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2556),
    [sym__special_character] = ACTIONS(2554),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2554),
    [anon_sym_BQUOTE] = ACTIONS(2554),
    [anon_sym_LT_LPAREN] = ACTIONS(2554),
    [anon_sym_GT_LPAREN] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2556),
    [sym_word] = ACTIONS(2556),
    [anon_sym_LF] = ACTIONS(2554),
    [anon_sym_AMP] = ACTIONS(2556),
  },
  [1525] = {
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2364),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [1526] = {
    [sym_string] = STATE(1525),
    [sym_simple_expansion] = STATE(1525),
    [sym_string_expansion] = STATE(1525),
    [sym_expansion] = STATE(1525),
    [sym_command_substitution] = STATE(1525),
    [sym_process_substitution] = STATE(1525),
    [anon_sym_DOLLAR] = ACTIONS(4807),
    [sym__special_character] = ACTIONS(3113),
    [anon_sym_DQUOTE] = ACTIONS(609),
    [sym_raw_string] = ACTIONS(3113),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(613),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(615),
    [anon_sym_BQUOTE] = ACTIONS(617),
    [anon_sym_LT_LPAREN] = ACTIONS(619),
    [anon_sym_GT_LPAREN] = ACTIONS(619),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3113),
  },
  [1527] = {
    [aux_sym_concatenation_repeat1] = STATE(1527),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(4809),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2364),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [1528] = {
    [sym_file_descriptor] = ACTIONS(2371),
    [sym__concat] = ACTIONS(2371),
    [anon_sym_SEMI] = ACTIONS(2373),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_SEMI_SEMI] = ACTIONS(2371),
    [anon_sym_PIPE_AMP] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_GT_GT] = ACTIONS(2371),
    [anon_sym_AMP_GT] = ACTIONS(2373),
    [anon_sym_AMP_GT_GT] = ACTIONS(2371),
    [anon_sym_LT_AMP] = ACTIONS(2371),
    [anon_sym_GT_AMP] = ACTIONS(2371),
    [anon_sym_LT_LT] = ACTIONS(2373),
    [anon_sym_LT_LT_DASH] = ACTIONS(2371),
    [anon_sym_LT_LT_LT] = ACTIONS(2371),
    [anon_sym_DOLLAR] = ACTIONS(2373),
    [sym__special_character] = ACTIONS(2371),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [sym_raw_string] = ACTIONS(2371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2371),
    [anon_sym_BQUOTE] = ACTIONS(2371),
    [anon_sym_LT_LPAREN] = ACTIONS(2371),
    [anon_sym_GT_LPAREN] = ACTIONS(2371),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2373),
    [sym_word] = ACTIONS(2373),
    [anon_sym_LF] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
  },
  [1529] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(4812),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [1530] = {
    [sym_concatenation] = STATE(2174),
    [sym_string] = STATE(2173),
    [sym_simple_expansion] = STATE(2173),
    [sym_string_expansion] = STATE(2173),
    [sym_expansion] = STATE(2173),
    [sym_command_substitution] = STATE(2173),
    [sym_process_substitution] = STATE(2173),
    [aux_sym__literal_repeat1] = STATE(2175),
    [anon_sym_RBRACE] = ACTIONS(4814),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(4816),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4816),
  },
  [1531] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(4818),
    [sym_comment] = ACTIONS(57),
  },
  [1532] = {
    [sym_concatenation] = STATE(2179),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2179),
    [anon_sym_RBRACE] = ACTIONS(4820),
    [anon_sym_EQ] = ACTIONS(4822),
    [anon_sym_DASH] = ACTIONS(4822),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4824),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(4826),
    [anon_sym_COLON] = ACTIONS(4822),
    [anon_sym_COLON_QMARK] = ACTIONS(4822),
    [anon_sym_COLON_DASH] = ACTIONS(4822),
    [anon_sym_PERCENT] = ACTIONS(4822),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1533] = {
    [sym_concatenation] = STATE(2181),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2181),
    [anon_sym_RBRACE] = ACTIONS(4814),
    [anon_sym_EQ] = ACTIONS(4828),
    [anon_sym_DASH] = ACTIONS(4828),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(4832),
    [anon_sym_COLON] = ACTIONS(4828),
    [anon_sym_COLON_QMARK] = ACTIONS(4828),
    [anon_sym_COLON_DASH] = ACTIONS(4828),
    [anon_sym_PERCENT] = ACTIONS(4828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1534] = {
    [sym_file_descriptor] = ACTIONS(2462),
    [sym__concat] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_SEMI_SEMI] = ACTIONS(2462),
    [anon_sym_PIPE_AMP] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_GT_GT] = ACTIONS(2462),
    [anon_sym_AMP_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT_GT] = ACTIONS(2462),
    [anon_sym_LT_AMP] = ACTIONS(2462),
    [anon_sym_GT_AMP] = ACTIONS(2462),
    [anon_sym_LT_LT] = ACTIONS(2464),
    [anon_sym_LT_LT_DASH] = ACTIONS(2462),
    [anon_sym_LT_LT_LT] = ACTIONS(2462),
    [anon_sym_DOLLAR] = ACTIONS(2464),
    [sym__special_character] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [sym_raw_string] = ACTIONS(2462),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2462),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2462),
    [anon_sym_BQUOTE] = ACTIONS(2462),
    [anon_sym_LT_LPAREN] = ACTIONS(2462),
    [anon_sym_GT_LPAREN] = ACTIONS(2462),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2464),
    [sym_word] = ACTIONS(2464),
    [anon_sym_LF] = ACTIONS(2462),
    [anon_sym_AMP] = ACTIONS(2464),
  },
  [1535] = {
    [sym_concatenation] = STATE(2184),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2184),
    [sym_regex] = ACTIONS(4834),
    [anon_sym_RBRACE] = ACTIONS(4836),
    [anon_sym_EQ] = ACTIONS(4838),
    [anon_sym_DASH] = ACTIONS(4838),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4840),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(4838),
    [anon_sym_COLON_QMARK] = ACTIONS(4838),
    [anon_sym_COLON_DASH] = ACTIONS(4838),
    [anon_sym_PERCENT] = ACTIONS(4838),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1536] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(4836),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1537] = {
    [sym_file_descriptor] = ACTIONS(2512),
    [sym__concat] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2514),
    [anon_sym_PIPE] = ACTIONS(2514),
    [anon_sym_SEMI_SEMI] = ACTIONS(2512),
    [anon_sym_PIPE_AMP] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE_PIPE] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2514),
    [anon_sym_GT] = ACTIONS(2514),
    [anon_sym_GT_GT] = ACTIONS(2512),
    [anon_sym_AMP_GT] = ACTIONS(2514),
    [anon_sym_AMP_GT_GT] = ACTIONS(2512),
    [anon_sym_LT_AMP] = ACTIONS(2512),
    [anon_sym_GT_AMP] = ACTIONS(2512),
    [anon_sym_LT_LT] = ACTIONS(2514),
    [anon_sym_LT_LT_DASH] = ACTIONS(2512),
    [anon_sym_LT_LT_LT] = ACTIONS(2512),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [sym__special_character] = ACTIONS(2512),
    [anon_sym_DQUOTE] = ACTIONS(2512),
    [sym_raw_string] = ACTIONS(2512),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2512),
    [anon_sym_BQUOTE] = ACTIONS(2512),
    [anon_sym_LT_LPAREN] = ACTIONS(2512),
    [anon_sym_GT_LPAREN] = ACTIONS(2512),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2514),
    [sym_word] = ACTIONS(2514),
    [anon_sym_LF] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2514),
  },
  [1538] = {
    [sym_concatenation] = STATE(2181),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2181),
    [sym_regex] = ACTIONS(4842),
    [anon_sym_RBRACE] = ACTIONS(4814),
    [anon_sym_EQ] = ACTIONS(4828),
    [anon_sym_DASH] = ACTIONS(4828),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(4828),
    [anon_sym_COLON_QMARK] = ACTIONS(4828),
    [anon_sym_COLON_DASH] = ACTIONS(4828),
    [anon_sym_PERCENT] = ACTIONS(4828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1539] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(4814),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1540] = {
    [sym_file_descriptor] = ACTIONS(2520),
    [sym__concat] = ACTIONS(2520),
    [anon_sym_SEMI] = ACTIONS(2522),
    [anon_sym_PIPE] = ACTIONS(2522),
    [anon_sym_SEMI_SEMI] = ACTIONS(2520),
    [anon_sym_PIPE_AMP] = ACTIONS(2520),
    [anon_sym_AMP_AMP] = ACTIONS(2520),
    [anon_sym_PIPE_PIPE] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(2522),
    [anon_sym_GT] = ACTIONS(2522),
    [anon_sym_GT_GT] = ACTIONS(2520),
    [anon_sym_AMP_GT] = ACTIONS(2522),
    [anon_sym_AMP_GT_GT] = ACTIONS(2520),
    [anon_sym_LT_AMP] = ACTIONS(2520),
    [anon_sym_GT_AMP] = ACTIONS(2520),
    [anon_sym_LT_LT] = ACTIONS(2522),
    [anon_sym_LT_LT_DASH] = ACTIONS(2520),
    [anon_sym_LT_LT_LT] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(2522),
    [sym__special_character] = ACTIONS(2520),
    [anon_sym_DQUOTE] = ACTIONS(2520),
    [sym_raw_string] = ACTIONS(2520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2520),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2520),
    [anon_sym_BQUOTE] = ACTIONS(2520),
    [anon_sym_LT_LPAREN] = ACTIONS(2520),
    [anon_sym_GT_LPAREN] = ACTIONS(2520),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2522),
    [sym_word] = ACTIONS(2522),
    [anon_sym_LF] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2522),
  },
  [1541] = {
    [sym_file_descriptor] = ACTIONS(2554),
    [sym__concat] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(2556),
    [anon_sym_PIPE] = ACTIONS(2556),
    [anon_sym_SEMI_SEMI] = ACTIONS(2554),
    [anon_sym_PIPE_AMP] = ACTIONS(2554),
    [anon_sym_AMP_AMP] = ACTIONS(2554),
    [anon_sym_PIPE_PIPE] = ACTIONS(2554),
    [anon_sym_LT] = ACTIONS(2556),
    [anon_sym_GT] = ACTIONS(2556),
    [anon_sym_GT_GT] = ACTIONS(2554),
    [anon_sym_AMP_GT] = ACTIONS(2556),
    [anon_sym_AMP_GT_GT] = ACTIONS(2554),
    [anon_sym_LT_AMP] = ACTIONS(2554),
    [anon_sym_GT_AMP] = ACTIONS(2554),
    [anon_sym_LT_LT] = ACTIONS(2556),
    [anon_sym_LT_LT_DASH] = ACTIONS(2554),
    [anon_sym_LT_LT_LT] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2556),
    [sym__special_character] = ACTIONS(2554),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2554),
    [anon_sym_BQUOTE] = ACTIONS(2554),
    [anon_sym_LT_LPAREN] = ACTIONS(2554),
    [anon_sym_GT_LPAREN] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2556),
    [sym_word] = ACTIONS(2556),
    [anon_sym_LF] = ACTIONS(2554),
    [anon_sym_AMP] = ACTIONS(2556),
  },
  [1542] = {
    [sym_string] = STATE(363),
    [sym_file_descriptor] = ACTIONS(4071),
    [anon_sym_SEMI] = ACTIONS(4073),
    [anon_sym_PIPE] = ACTIONS(4073),
    [anon_sym_SEMI_SEMI] = ACTIONS(4071),
    [anon_sym_PIPE_AMP] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_PIPE_PIPE] = ACTIONS(4071),
    [anon_sym_EQ_TILDE] = ACTIONS(4073),
    [anon_sym_EQ_EQ] = ACTIONS(4073),
    [anon_sym_LT] = ACTIONS(4073),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_GT_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT] = ACTIONS(4073),
    [anon_sym_AMP_GT_GT] = ACTIONS(4071),
    [anon_sym_LT_AMP] = ACTIONS(4071),
    [anon_sym_GT_AMP] = ACTIONS(4071),
    [anon_sym_LT_LT] = ACTIONS(4073),
    [anon_sym_LT_LT_DASH] = ACTIONS(4071),
    [anon_sym_LT_LT_LT] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(4844),
    [anon_sym_DOLLAR] = ACTIONS(4844),
    [sym__special_character] = ACTIONS(4071),
    [anon_sym_DQUOTE] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(627),
    [anon_sym_POUND] = ACTIONS(625),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4071),
    [anon_sym_BQUOTE] = ACTIONS(4071),
    [anon_sym_LT_LPAREN] = ACTIONS(4071),
    [anon_sym_GT_LPAREN] = ACTIONS(4071),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(629),
    [anon_sym_STAR] = ACTIONS(629),
    [anon_sym_AT] = ACTIONS(629),
    [anon_sym_QMARK] = ACTIONS(629),
    [anon_sym_0] = ACTIONS(629),
    [anon_sym__] = ACTIONS(629),
    [sym_word] = ACTIONS(4073),
    [anon_sym_LF] = ACTIONS(4071),
    [anon_sym_AMP] = ACTIONS(4073),
  },
  [1543] = {
    [sym_file_descriptor] = ACTIONS(4111),
    [sym__concat] = ACTIONS(4111),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_PIPE] = ACTIONS(4113),
    [anon_sym_SEMI_SEMI] = ACTIONS(4111),
    [anon_sym_PIPE_AMP] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_EQ_TILDE] = ACTIONS(4113),
    [anon_sym_EQ_EQ] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4113),
    [anon_sym_GT_GT] = ACTIONS(4111),
    [anon_sym_AMP_GT] = ACTIONS(4113),
    [anon_sym_AMP_GT_GT] = ACTIONS(4111),
    [anon_sym_LT_AMP] = ACTIONS(4111),
    [anon_sym_GT_AMP] = ACTIONS(4111),
    [anon_sym_LT_LT] = ACTIONS(4113),
    [anon_sym_LT_LT_DASH] = ACTIONS(4111),
    [anon_sym_LT_LT_LT] = ACTIONS(4111),
    [anon_sym_DOLLAR] = ACTIONS(4113),
    [sym__special_character] = ACTIONS(4111),
    [anon_sym_DQUOTE] = ACTIONS(4111),
    [sym_raw_string] = ACTIONS(4111),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4111),
    [anon_sym_BQUOTE] = ACTIONS(4111),
    [anon_sym_LT_LPAREN] = ACTIONS(4111),
    [anon_sym_GT_LPAREN] = ACTIONS(4111),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4113),
    [anon_sym_LF] = ACTIONS(4111),
    [anon_sym_AMP] = ACTIONS(4113),
  },
  [1544] = {
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_EQ_TILDE] = ACTIONS(4127),
    [anon_sym_EQ_EQ] = ACTIONS(4127),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym__special_character] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [1545] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(4846),
    [sym_comment] = ACTIONS(57),
  },
  [1546] = {
    [anon_sym_RBRACE] = ACTIONS(4846),
    [sym_comment] = ACTIONS(57),
  },
  [1547] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(4848),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [1548] = {
    [sym_concatenation] = STATE(2189),
    [sym_string] = STATE(2188),
    [sym_simple_expansion] = STATE(2188),
    [sym_string_expansion] = STATE(2188),
    [sym_expansion] = STATE(2188),
    [sym_command_substitution] = STATE(2188),
    [sym_process_substitution] = STATE(2188),
    [aux_sym__literal_repeat1] = STATE(2190),
    [anon_sym_RBRACE] = ACTIONS(4846),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(4850),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4850),
  },
  [1549] = {
    [sym_file_descriptor] = ACTIONS(4161),
    [sym__concat] = ACTIONS(4161),
    [anon_sym_SEMI] = ACTIONS(4163),
    [anon_sym_PIPE] = ACTIONS(4163),
    [anon_sym_SEMI_SEMI] = ACTIONS(4161),
    [anon_sym_PIPE_AMP] = ACTIONS(4161),
    [anon_sym_AMP_AMP] = ACTIONS(4161),
    [anon_sym_PIPE_PIPE] = ACTIONS(4161),
    [anon_sym_EQ_TILDE] = ACTIONS(4163),
    [anon_sym_EQ_EQ] = ACTIONS(4163),
    [anon_sym_LT] = ACTIONS(4163),
    [anon_sym_GT] = ACTIONS(4163),
    [anon_sym_GT_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT] = ACTIONS(4163),
    [anon_sym_AMP_GT_GT] = ACTIONS(4161),
    [anon_sym_LT_AMP] = ACTIONS(4161),
    [anon_sym_GT_AMP] = ACTIONS(4161),
    [anon_sym_LT_LT] = ACTIONS(4163),
    [anon_sym_LT_LT_DASH] = ACTIONS(4161),
    [anon_sym_LT_LT_LT] = ACTIONS(4161),
    [anon_sym_DOLLAR] = ACTIONS(4163),
    [sym__special_character] = ACTIONS(4161),
    [anon_sym_DQUOTE] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4161),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4161),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4161),
    [anon_sym_BQUOTE] = ACTIONS(4161),
    [anon_sym_LT_LPAREN] = ACTIONS(4161),
    [anon_sym_GT_LPAREN] = ACTIONS(4161),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4163),
    [anon_sym_LF] = ACTIONS(4161),
    [anon_sym_AMP] = ACTIONS(4163),
  },
  [1550] = {
    [sym_concatenation] = STATE(2193),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2193),
    [sym_regex] = ACTIONS(4852),
    [anon_sym_RBRACE] = ACTIONS(4854),
    [anon_sym_EQ] = ACTIONS(4856),
    [anon_sym_DASH] = ACTIONS(4856),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4858),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(4856),
    [anon_sym_COLON_QMARK] = ACTIONS(4856),
    [anon_sym_COLON_DASH] = ACTIONS(4856),
    [anon_sym_PERCENT] = ACTIONS(4856),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1551] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(4854),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1552] = {
    [sym_concatenation] = STATE(2195),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2195),
    [sym_regex] = ACTIONS(4860),
    [anon_sym_RBRACE] = ACTIONS(4846),
    [anon_sym_EQ] = ACTIONS(4862),
    [anon_sym_DASH] = ACTIONS(4862),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4864),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(4862),
    [anon_sym_COLON_QMARK] = ACTIONS(4862),
    [anon_sym_COLON_DASH] = ACTIONS(4862),
    [anon_sym_PERCENT] = ACTIONS(4862),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1553] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(4846),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1554] = {
    [sym_concatenation] = STATE(2197),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2197),
    [anon_sym_RBRACE] = ACTIONS(4866),
    [anon_sym_EQ] = ACTIONS(4868),
    [anon_sym_DASH] = ACTIONS(4868),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4870),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(4868),
    [anon_sym_COLON_QMARK] = ACTIONS(4868),
    [anon_sym_COLON_DASH] = ACTIONS(4868),
    [anon_sym_PERCENT] = ACTIONS(4868),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1555] = {
    [sym_file_descriptor] = ACTIONS(4219),
    [sym__concat] = ACTIONS(4219),
    [anon_sym_SEMI] = ACTIONS(4221),
    [anon_sym_PIPE] = ACTIONS(4221),
    [anon_sym_SEMI_SEMI] = ACTIONS(4219),
    [anon_sym_PIPE_AMP] = ACTIONS(4219),
    [anon_sym_AMP_AMP] = ACTIONS(4219),
    [anon_sym_PIPE_PIPE] = ACTIONS(4219),
    [anon_sym_EQ_TILDE] = ACTIONS(4221),
    [anon_sym_EQ_EQ] = ACTIONS(4221),
    [anon_sym_LT] = ACTIONS(4221),
    [anon_sym_GT] = ACTIONS(4221),
    [anon_sym_GT_GT] = ACTIONS(4219),
    [anon_sym_AMP_GT] = ACTIONS(4221),
    [anon_sym_AMP_GT_GT] = ACTIONS(4219),
    [anon_sym_LT_AMP] = ACTIONS(4219),
    [anon_sym_GT_AMP] = ACTIONS(4219),
    [anon_sym_LT_LT] = ACTIONS(4221),
    [anon_sym_LT_LT_DASH] = ACTIONS(4219),
    [anon_sym_LT_LT_LT] = ACTIONS(4219),
    [anon_sym_DOLLAR] = ACTIONS(4221),
    [sym__special_character] = ACTIONS(4219),
    [anon_sym_DQUOTE] = ACTIONS(4219),
    [sym_raw_string] = ACTIONS(4219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4219),
    [anon_sym_BQUOTE] = ACTIONS(4219),
    [anon_sym_LT_LPAREN] = ACTIONS(4219),
    [anon_sym_GT_LPAREN] = ACTIONS(4219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4221),
    [anon_sym_LF] = ACTIONS(4219),
    [anon_sym_AMP] = ACTIONS(4221),
  },
  [1556] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(4866),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1557] = {
    [sym_concatenation] = STATE(2195),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2195),
    [anon_sym_RBRACE] = ACTIONS(4846),
    [anon_sym_EQ] = ACTIONS(4862),
    [anon_sym_DASH] = ACTIONS(4862),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4864),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(4862),
    [anon_sym_COLON_QMARK] = ACTIONS(4862),
    [anon_sym_COLON_DASH] = ACTIONS(4862),
    [anon_sym_PERCENT] = ACTIONS(4862),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1558] = {
    [sym_file_descriptor] = ACTIONS(4324),
    [anon_sym_SEMI] = ACTIONS(4326),
    [anon_sym_PIPE] = ACTIONS(4326),
    [anon_sym_SEMI_SEMI] = ACTIONS(4324),
    [anon_sym_PIPE_AMP] = ACTIONS(4324),
    [anon_sym_AMP_AMP] = ACTIONS(4324),
    [anon_sym_PIPE_PIPE] = ACTIONS(4324),
    [anon_sym_LT] = ACTIONS(4326),
    [anon_sym_GT] = ACTIONS(4326),
    [anon_sym_GT_GT] = ACTIONS(4324),
    [anon_sym_AMP_GT] = ACTIONS(4326),
    [anon_sym_AMP_GT_GT] = ACTIONS(4324),
    [anon_sym_LT_AMP] = ACTIONS(4324),
    [anon_sym_GT_AMP] = ACTIONS(4324),
    [anon_sym_LT_LT] = ACTIONS(4326),
    [anon_sym_LT_LT_DASH] = ACTIONS(4324),
    [anon_sym_LT_LT_LT] = ACTIONS(4324),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4324),
    [anon_sym_AMP] = ACTIONS(4326),
  },
  [1559] = {
    [sym_concatenation] = STATE(2198),
    [sym_string] = STATE(2203),
    [sym_array] = STATE(2198),
    [sym_simple_expansion] = STATE(2203),
    [sym_string_expansion] = STATE(2203),
    [sym_expansion] = STATE(2203),
    [sym_command_substitution] = STATE(2203),
    [sym_process_substitution] = STATE(2203),
    [aux_sym__literal_repeat1] = STATE(2208),
    [sym__empty_value] = ACTIONS(4872),
    [anon_sym_LPAREN] = ACTIONS(4874),
    [anon_sym_DOLLAR] = ACTIONS(4876),
    [sym__special_character] = ACTIONS(4878),
    [anon_sym_DQUOTE] = ACTIONS(4880),
    [sym_raw_string] = ACTIONS(4882),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4884),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4886),
    [anon_sym_BQUOTE] = ACTIONS(4888),
    [anon_sym_LT_LPAREN] = ACTIONS(4890),
    [anon_sym_GT_LPAREN] = ACTIONS(4890),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4882),
  },
  [1560] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(4892),
    [anon_sym_PLUS_EQ] = ACTIONS(4892),
    [sym_comment] = ACTIONS(57),
  },
  [1561] = {
    [sym_string] = STATE(2211),
    [anon_sym_DASH] = ACTIONS(4894),
    [anon_sym_DOLLAR] = ACTIONS(4894),
    [anon_sym_DQUOTE] = ACTIONS(3233),
    [sym_raw_string] = ACTIONS(4896),
    [anon_sym_POUND] = ACTIONS(4894),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4898),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_AT] = ACTIONS(4900),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_0] = ACTIONS(4898),
    [anon_sym__] = ACTIONS(4898),
  },
  [1562] = {
    [aux_sym_concatenation_repeat1] = STATE(2214),
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(4902),
    [sym_variable_name] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_done] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(339),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [1563] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(2217),
    [anon_sym_DOLLAR] = ACTIONS(4904),
    [anon_sym_DQUOTE] = ACTIONS(4906),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [1564] = {
    [aux_sym_concatenation_repeat1] = STATE(2214),
    [sym__simple_heredoc_body] = ACTIONS(957),
    [sym__heredoc_body_beginning] = ACTIONS(957),
    [sym_file_descriptor] = ACTIONS(957),
    [sym__concat] = ACTIONS(4902),
    [sym_variable_name] = ACTIONS(957),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_done] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_SEMI_SEMI] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_LT] = ACTIONS(959),
    [anon_sym_GT] = ACTIONS(959),
    [anon_sym_GT_GT] = ACTIONS(957),
    [anon_sym_AMP_GT] = ACTIONS(959),
    [anon_sym_AMP_GT_GT] = ACTIONS(957),
    [anon_sym_LT_AMP] = ACTIONS(957),
    [anon_sym_GT_AMP] = ACTIONS(957),
    [anon_sym_LT_LT] = ACTIONS(959),
    [anon_sym_LT_LT_DASH] = ACTIONS(957),
    [anon_sym_LT_LT_LT] = ACTIONS(957),
    [anon_sym_DOLLAR] = ACTIONS(959),
    [sym__special_character] = ACTIONS(957),
    [anon_sym_DQUOTE] = ACTIONS(957),
    [sym_raw_string] = ACTIONS(957),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(957),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(957),
    [anon_sym_BQUOTE] = ACTIONS(957),
    [anon_sym_LT_LPAREN] = ACTIONS(957),
    [anon_sym_GT_LPAREN] = ACTIONS(957),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(959),
    [sym_word] = ACTIONS(959),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
  },
  [1565] = {
    [sym_subscript] = STATE(2221),
    [sym_variable_name] = ACTIONS(4908),
    [anon_sym_BANG] = ACTIONS(4910),
    [anon_sym_DASH] = ACTIONS(4912),
    [anon_sym_DOLLAR] = ACTIONS(4912),
    [anon_sym_POUND] = ACTIONS(4910),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4914),
    [anon_sym_STAR] = ACTIONS(4916),
    [anon_sym_AT] = ACTIONS(4916),
    [anon_sym_QMARK] = ACTIONS(4916),
    [anon_sym_0] = ACTIONS(4914),
    [anon_sym__] = ACTIONS(4914),
  },
  [1566] = {
    [sym__statements] = STATE(2222),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(2223),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [1567] = {
    [sym__statements] = STATE(2224),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [1568] = {
    [sym__statements] = STATE(2225),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [1569] = {
    [anon_sym_EQ] = ACTIONS(4892),
    [anon_sym_PLUS_EQ] = ACTIONS(4892),
    [sym_comment] = ACTIONS(57),
  },
  [1570] = {
    [sym_variable_assignment] = STATE(2226),
    [sym_subscript] = STATE(1569),
    [sym_concatenation] = STATE(2226),
    [sym_string] = STATE(1564),
    [sym_simple_expansion] = STATE(1564),
    [sym_string_expansion] = STATE(1564),
    [sym_expansion] = STATE(1564),
    [sym_command_substitution] = STATE(1564),
    [sym_process_substitution] = STATE(1564),
    [aux_sym_declaration_command_repeat1] = STATE(2226),
    [aux_sym__literal_repeat1] = STATE(1571),
    [sym__simple_heredoc_body] = ACTIONS(971),
    [sym__heredoc_body_beginning] = ACTIONS(971),
    [sym_file_descriptor] = ACTIONS(971),
    [sym_variable_name] = ACTIONS(3227),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_done] = ACTIONS(973),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_SEMI_SEMI] = ACTIONS(971),
    [anon_sym_PIPE_AMP] = ACTIONS(971),
    [anon_sym_AMP_AMP] = ACTIONS(971),
    [anon_sym_PIPE_PIPE] = ACTIONS(971),
    [anon_sym_LT] = ACTIONS(973),
    [anon_sym_GT] = ACTIONS(973),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_AMP_GT] = ACTIONS(973),
    [anon_sym_AMP_GT_GT] = ACTIONS(971),
    [anon_sym_LT_AMP] = ACTIONS(971),
    [anon_sym_GT_AMP] = ACTIONS(971),
    [anon_sym_LT_LT] = ACTIONS(973),
    [anon_sym_LT_LT_DASH] = ACTIONS(971),
    [anon_sym_LT_LT_LT] = ACTIONS(971),
    [anon_sym_DOLLAR] = ACTIONS(3229),
    [sym__special_character] = ACTIONS(3231),
    [anon_sym_DQUOTE] = ACTIONS(3233),
    [sym_raw_string] = ACTIONS(3235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3239),
    [anon_sym_BQUOTE] = ACTIONS(3241),
    [anon_sym_LT_LPAREN] = ACTIONS(3243),
    [anon_sym_GT_LPAREN] = ACTIONS(3243),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4918),
    [sym_word] = ACTIONS(3247),
    [anon_sym_LF] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(973),
  },
  [1571] = {
    [aux_sym__literal_repeat1] = STATE(2228),
    [sym__simple_heredoc_body] = ACTIONS(977),
    [sym__heredoc_body_beginning] = ACTIONS(977),
    [sym_file_descriptor] = ACTIONS(977),
    [sym_variable_name] = ACTIONS(977),
    [anon_sym_SEMI] = ACTIONS(979),
    [anon_sym_done] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(979),
    [anon_sym_SEMI_SEMI] = ACTIONS(977),
    [anon_sym_PIPE_AMP] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(977),
    [anon_sym_AMP_GT] = ACTIONS(979),
    [anon_sym_AMP_GT_GT] = ACTIONS(977),
    [anon_sym_LT_AMP] = ACTIONS(977),
    [anon_sym_GT_AMP] = ACTIONS(977),
    [anon_sym_LT_LT] = ACTIONS(979),
    [anon_sym_LT_LT_DASH] = ACTIONS(977),
    [anon_sym_LT_LT_LT] = ACTIONS(977),
    [anon_sym_DOLLAR] = ACTIONS(979),
    [sym__special_character] = ACTIONS(4920),
    [anon_sym_DQUOTE] = ACTIONS(977),
    [sym_raw_string] = ACTIONS(977),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(977),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(977),
    [anon_sym_BQUOTE] = ACTIONS(977),
    [anon_sym_LT_LPAREN] = ACTIONS(977),
    [anon_sym_GT_LPAREN] = ACTIONS(977),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(979),
    [sym_word] = ACTIONS(979),
    [anon_sym_LF] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
  },
  [1572] = {
    [sym_string] = STATE(2230),
    [anon_sym_DASH] = ACTIONS(4922),
    [anon_sym_DOLLAR] = ACTIONS(4922),
    [anon_sym_DQUOTE] = ACTIONS(3253),
    [sym_raw_string] = ACTIONS(4924),
    [anon_sym_POUND] = ACTIONS(4922),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4926),
    [anon_sym_STAR] = ACTIONS(4928),
    [anon_sym_AT] = ACTIONS(4928),
    [anon_sym_QMARK] = ACTIONS(4928),
    [anon_sym_0] = ACTIONS(4926),
    [anon_sym__] = ACTIONS(4926),
  },
  [1573] = {
    [aux_sym_concatenation_repeat1] = STATE(2233),
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(4930),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_done] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(339),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [1574] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(2236),
    [anon_sym_DOLLAR] = ACTIONS(4932),
    [anon_sym_DQUOTE] = ACTIONS(4934),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [1575] = {
    [aux_sym_concatenation_repeat1] = STATE(2233),
    [sym__simple_heredoc_body] = ACTIONS(997),
    [sym__heredoc_body_beginning] = ACTIONS(997),
    [sym_file_descriptor] = ACTIONS(997),
    [sym__concat] = ACTIONS(4930),
    [anon_sym_SEMI] = ACTIONS(999),
    [anon_sym_done] = ACTIONS(999),
    [anon_sym_PIPE] = ACTIONS(999),
    [anon_sym_SEMI_SEMI] = ACTIONS(997),
    [anon_sym_PIPE_AMP] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_LT] = ACTIONS(999),
    [anon_sym_GT] = ACTIONS(999),
    [anon_sym_GT_GT] = ACTIONS(997),
    [anon_sym_AMP_GT] = ACTIONS(999),
    [anon_sym_AMP_GT_GT] = ACTIONS(997),
    [anon_sym_LT_AMP] = ACTIONS(997),
    [anon_sym_GT_AMP] = ACTIONS(997),
    [anon_sym_LT_LT] = ACTIONS(999),
    [anon_sym_LT_LT_DASH] = ACTIONS(997),
    [anon_sym_LT_LT_LT] = ACTIONS(997),
    [anon_sym_DOLLAR] = ACTIONS(999),
    [sym__special_character] = ACTIONS(997),
    [anon_sym_DQUOTE] = ACTIONS(997),
    [sym_raw_string] = ACTIONS(997),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(997),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(997),
    [anon_sym_BQUOTE] = ACTIONS(997),
    [anon_sym_LT_LPAREN] = ACTIONS(997),
    [anon_sym_GT_LPAREN] = ACTIONS(997),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(999),
    [sym_word] = ACTIONS(999),
    [anon_sym_LF] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(999),
  },
  [1576] = {
    [sym_subscript] = STATE(2240),
    [sym_variable_name] = ACTIONS(4936),
    [anon_sym_BANG] = ACTIONS(4938),
    [anon_sym_DASH] = ACTIONS(4940),
    [anon_sym_DOLLAR] = ACTIONS(4940),
    [anon_sym_POUND] = ACTIONS(4938),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4942),
    [anon_sym_STAR] = ACTIONS(4944),
    [anon_sym_AT] = ACTIONS(4944),
    [anon_sym_QMARK] = ACTIONS(4944),
    [anon_sym_0] = ACTIONS(4942),
    [anon_sym__] = ACTIONS(4942),
  },
  [1577] = {
    [sym__statements] = STATE(2241),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(2242),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [1578] = {
    [sym__statements] = STATE(2243),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [1579] = {
    [sym__statements] = STATE(2244),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [1580] = {
    [sym_concatenation] = STATE(2245),
    [sym_string] = STATE(1575),
    [sym_simple_expansion] = STATE(1575),
    [sym_string_expansion] = STATE(1575),
    [sym_expansion] = STATE(1575),
    [sym_command_substitution] = STATE(1575),
    [sym_process_substitution] = STATE(1575),
    [aux_sym_unset_command_repeat1] = STATE(2245),
    [aux_sym__literal_repeat1] = STATE(1581),
    [sym__simple_heredoc_body] = ACTIONS(1011),
    [sym__heredoc_body_beginning] = ACTIONS(1011),
    [sym_file_descriptor] = ACTIONS(1011),
    [anon_sym_SEMI] = ACTIONS(1013),
    [anon_sym_done] = ACTIONS(1013),
    [anon_sym_PIPE] = ACTIONS(1013),
    [anon_sym_SEMI_SEMI] = ACTIONS(1011),
    [anon_sym_PIPE_AMP] = ACTIONS(1011),
    [anon_sym_AMP_AMP] = ACTIONS(1011),
    [anon_sym_PIPE_PIPE] = ACTIONS(1011),
    [anon_sym_LT] = ACTIONS(1013),
    [anon_sym_GT] = ACTIONS(1013),
    [anon_sym_GT_GT] = ACTIONS(1011),
    [anon_sym_AMP_GT] = ACTIONS(1013),
    [anon_sym_AMP_GT_GT] = ACTIONS(1011),
    [anon_sym_LT_AMP] = ACTIONS(1011),
    [anon_sym_GT_AMP] = ACTIONS(1011),
    [anon_sym_LT_LT] = ACTIONS(1013),
    [anon_sym_LT_LT_DASH] = ACTIONS(1011),
    [anon_sym_LT_LT_LT] = ACTIONS(1011),
    [anon_sym_DOLLAR] = ACTIONS(3249),
    [sym__special_character] = ACTIONS(3251),
    [anon_sym_DQUOTE] = ACTIONS(3253),
    [sym_raw_string] = ACTIONS(3255),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3257),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3259),
    [anon_sym_BQUOTE] = ACTIONS(3261),
    [anon_sym_LT_LPAREN] = ACTIONS(3263),
    [anon_sym_GT_LPAREN] = ACTIONS(3263),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4946),
    [sym_word] = ACTIONS(3267),
    [anon_sym_LF] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(1013),
  },
  [1581] = {
    [aux_sym__literal_repeat1] = STATE(2247),
    [sym__simple_heredoc_body] = ACTIONS(1017),
    [sym__heredoc_body_beginning] = ACTIONS(1017),
    [sym_file_descriptor] = ACTIONS(1017),
    [anon_sym_SEMI] = ACTIONS(1019),
    [anon_sym_done] = ACTIONS(1019),
    [anon_sym_PIPE] = ACTIONS(1019),
    [anon_sym_SEMI_SEMI] = ACTIONS(1017),
    [anon_sym_PIPE_AMP] = ACTIONS(1017),
    [anon_sym_AMP_AMP] = ACTIONS(1017),
    [anon_sym_PIPE_PIPE] = ACTIONS(1017),
    [anon_sym_LT] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(1019),
    [anon_sym_GT_GT] = ACTIONS(1017),
    [anon_sym_AMP_GT] = ACTIONS(1019),
    [anon_sym_AMP_GT_GT] = ACTIONS(1017),
    [anon_sym_LT_AMP] = ACTIONS(1017),
    [anon_sym_GT_AMP] = ACTIONS(1017),
    [anon_sym_LT_LT] = ACTIONS(1019),
    [anon_sym_LT_LT_DASH] = ACTIONS(1017),
    [anon_sym_LT_LT_LT] = ACTIONS(1017),
    [anon_sym_DOLLAR] = ACTIONS(1019),
    [sym__special_character] = ACTIONS(4948),
    [anon_sym_DQUOTE] = ACTIONS(1017),
    [sym_raw_string] = ACTIONS(1017),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1017),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1017),
    [anon_sym_BQUOTE] = ACTIONS(1017),
    [anon_sym_LT_LPAREN] = ACTIONS(1017),
    [anon_sym_GT_LPAREN] = ACTIONS(1017),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1019),
    [sym_word] = ACTIONS(1019),
    [anon_sym_LF] = ACTIONS(1017),
    [anon_sym_AMP] = ACTIONS(1019),
  },
  [1582] = {
    [sym__simple_heredoc_body] = ACTIONS(1057),
    [sym__heredoc_body_beginning] = ACTIONS(1057),
    [sym_file_descriptor] = ACTIONS(1057),
    [sym__concat] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_done] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_PIPE_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_EQ_TILDE] = ACTIONS(1059),
    [anon_sym_EQ_EQ] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_AMP] = ACTIONS(1057),
    [anon_sym_GT_AMP] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_LT] = ACTIONS(1057),
    [anon_sym_DOLLAR] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [sym_raw_string] = ACTIONS(1057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1057),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1057),
    [anon_sym_BQUOTE] = ACTIONS(1057),
    [anon_sym_LT_LPAREN] = ACTIONS(1057),
    [anon_sym_GT_LPAREN] = ACTIONS(1057),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [1583] = {
    [sym__simple_heredoc_body] = ACTIONS(1061),
    [sym__heredoc_body_beginning] = ACTIONS(1061),
    [sym_file_descriptor] = ACTIONS(1061),
    [sym__concat] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(1063),
    [anon_sym_done] = ACTIONS(1063),
    [anon_sym_PIPE] = ACTIONS(1063),
    [anon_sym_SEMI_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE_AMP] = ACTIONS(1061),
    [anon_sym_AMP_AMP] = ACTIONS(1061),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_EQ_TILDE] = ACTIONS(1063),
    [anon_sym_EQ_EQ] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1063),
    [anon_sym_GT_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT_GT] = ACTIONS(1061),
    [anon_sym_LT_AMP] = ACTIONS(1061),
    [anon_sym_GT_AMP] = ACTIONS(1061),
    [anon_sym_LT_LT] = ACTIONS(1063),
    [anon_sym_LT_LT_DASH] = ACTIONS(1061),
    [anon_sym_LT_LT_LT] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1061),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1061),
    [anon_sym_LT_LPAREN] = ACTIONS(1061),
    [anon_sym_GT_LPAREN] = ACTIONS(1061),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1063),
    [anon_sym_LF] = ACTIONS(1061),
    [anon_sym_AMP] = ACTIONS(1063),
  },
  [1584] = {
    [sym__simple_heredoc_body] = ACTIONS(1065),
    [sym__heredoc_body_beginning] = ACTIONS(1065),
    [sym_file_descriptor] = ACTIONS(1065),
    [sym__concat] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_done] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1067),
    [anon_sym_SEMI_SEMI] = ACTIONS(1065),
    [anon_sym_PIPE_AMP] = ACTIONS(1065),
    [anon_sym_AMP_AMP] = ACTIONS(1065),
    [anon_sym_PIPE_PIPE] = ACTIONS(1065),
    [anon_sym_EQ_TILDE] = ACTIONS(1067),
    [anon_sym_EQ_EQ] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_GT] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT] = ACTIONS(1067),
    [anon_sym_AMP_GT_GT] = ACTIONS(1065),
    [anon_sym_LT_AMP] = ACTIONS(1065),
    [anon_sym_GT_AMP] = ACTIONS(1065),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_LT_LT_DASH] = ACTIONS(1065),
    [anon_sym_LT_LT_LT] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1067),
    [sym__special_character] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LT_LPAREN] = ACTIONS(1065),
    [anon_sym_GT_LPAREN] = ACTIONS(1065),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1067),
    [anon_sym_LF] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1067),
  },
  [1585] = {
    [sym_string] = STATE(2248),
    [sym_simple_expansion] = STATE(2248),
    [sym_string_expansion] = STATE(2248),
    [sym_expansion] = STATE(2248),
    [sym_command_substitution] = STATE(2248),
    [sym_process_substitution] = STATE(2248),
    [anon_sym_DOLLAR] = ACTIONS(1761),
    [sym__special_character] = ACTIONS(4950),
    [anon_sym_DQUOTE] = ACTIONS(1765),
    [sym_raw_string] = ACTIONS(4950),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1769),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1771),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [anon_sym_LT_LPAREN] = ACTIONS(1775),
    [anon_sym_GT_LPAREN] = ACTIONS(1775),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4950),
  },
  [1586] = {
    [aux_sym_concatenation_repeat1] = STATE(2250),
    [sym__simple_heredoc_body] = ACTIONS(1071),
    [sym__heredoc_body_beginning] = ACTIONS(1071),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(4952),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_done] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_EQ_TILDE] = ACTIONS(1075),
    [anon_sym_EQ_EQ] = ACTIONS(1075),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [sym__special_character] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1075),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1075),
  },
  [1587] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(4954),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [1588] = {
    [sym__simple_heredoc_body] = ACTIONS(1089),
    [sym__heredoc_body_beginning] = ACTIONS(1089),
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(1089),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_done] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1089),
    [anon_sym_PIPE_AMP] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_AMP] = ACTIONS(1089),
    [anon_sym_GT_AMP] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1089),
    [anon_sym_LT_LT_LT] = ACTIONS(1089),
    [anon_sym_DOLLAR] = ACTIONS(1091),
    [sym__special_character] = ACTIONS(1089),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1089),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1089),
    [anon_sym_GT_LPAREN] = ACTIONS(1089),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [1589] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(627),
    [anon_sym_DOLLAR] = ACTIONS(4956),
    [anon_sym_DQUOTE] = ACTIONS(4954),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [1590] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(4958),
    [sym_comment] = ACTIONS(57),
  },
  [1591] = {
    [sym_subscript] = STATE(2256),
    [sym_variable_name] = ACTIONS(4960),
    [anon_sym_DASH] = ACTIONS(4962),
    [anon_sym_DOLLAR] = ACTIONS(4962),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4964),
    [anon_sym_STAR] = ACTIONS(4966),
    [anon_sym_AT] = ACTIONS(4966),
    [anon_sym_QMARK] = ACTIONS(4966),
    [anon_sym_0] = ACTIONS(4964),
    [anon_sym__] = ACTIONS(4964),
  },
  [1592] = {
    [sym_concatenation] = STATE(2259),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2259),
    [anon_sym_RBRACE] = ACTIONS(4968),
    [anon_sym_EQ] = ACTIONS(4970),
    [anon_sym_DASH] = ACTIONS(4970),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4972),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(4974),
    [anon_sym_COLON] = ACTIONS(4970),
    [anon_sym_COLON_QMARK] = ACTIONS(4970),
    [anon_sym_COLON_DASH] = ACTIONS(4970),
    [anon_sym_PERCENT] = ACTIONS(4970),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1593] = {
    [sym_concatenation] = STATE(2262),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2262),
    [anon_sym_RBRACE] = ACTIONS(4976),
    [anon_sym_EQ] = ACTIONS(4978),
    [anon_sym_DASH] = ACTIONS(4978),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(4980),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(4982),
    [anon_sym_COLON] = ACTIONS(4978),
    [anon_sym_COLON_QMARK] = ACTIONS(4978),
    [anon_sym_COLON_DASH] = ACTIONS(4978),
    [anon_sym_PERCENT] = ACTIONS(4978),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1594] = {
    [anon_sym_RPAREN] = ACTIONS(4984),
    [sym_comment] = ACTIONS(57),
  },
  [1595] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(4984),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [1596] = {
    [anon_sym_BQUOTE] = ACTIONS(4984),
    [sym_comment] = ACTIONS(57),
  },
  [1597] = {
    [anon_sym_RPAREN] = ACTIONS(4986),
    [sym_comment] = ACTIONS(57),
  },
  [1598] = {
    [sym__simple_heredoc_body] = ACTIONS(4988),
    [sym__heredoc_body_beginning] = ACTIONS(4988),
    [sym_file_descriptor] = ACTIONS(4988),
    [ts_builtin_sym_end] = ACTIONS(4988),
    [anon_sym_SEMI] = ACTIONS(4990),
    [anon_sym_done] = ACTIONS(4988),
    [anon_sym_fi] = ACTIONS(4988),
    [anon_sym_elif] = ACTIONS(4988),
    [anon_sym_else] = ACTIONS(4988),
    [anon_sym_esac] = ACTIONS(4988),
    [anon_sym_PIPE] = ACTIONS(4990),
    [anon_sym_RPAREN] = ACTIONS(4988),
    [anon_sym_SEMI_SEMI] = ACTIONS(4988),
    [anon_sym_PIPE_AMP] = ACTIONS(4988),
    [anon_sym_AMP_AMP] = ACTIONS(4988),
    [anon_sym_PIPE_PIPE] = ACTIONS(4988),
    [anon_sym_LT] = ACTIONS(4990),
    [anon_sym_GT] = ACTIONS(4990),
    [anon_sym_GT_GT] = ACTIONS(4988),
    [anon_sym_AMP_GT] = ACTIONS(4990),
    [anon_sym_AMP_GT_GT] = ACTIONS(4988),
    [anon_sym_LT_AMP] = ACTIONS(4988),
    [anon_sym_GT_AMP] = ACTIONS(4988),
    [anon_sym_LT_LT] = ACTIONS(4990),
    [anon_sym_LT_LT_DASH] = ACTIONS(4988),
    [anon_sym_LT_LT_LT] = ACTIONS(4988),
    [anon_sym_BQUOTE] = ACTIONS(4988),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4988),
    [anon_sym_AMP] = ACTIONS(4990),
  },
  [1599] = {
    [anon_sym_LT] = ACTIONS(4992),
    [anon_sym_GT] = ACTIONS(4992),
    [anon_sym_GT_GT] = ACTIONS(4994),
    [anon_sym_AMP_GT] = ACTIONS(4992),
    [anon_sym_AMP_GT_GT] = ACTIONS(4994),
    [anon_sym_LT_AMP] = ACTIONS(4994),
    [anon_sym_GT_AMP] = ACTIONS(4994),
    [sym_comment] = ACTIONS(57),
  },
  [1600] = {
    [sym_file_descriptor] = ACTIONS(1237),
    [sym_variable_name] = ACTIONS(1237),
    [anon_sym_for] = ACTIONS(1241),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1237),
    [anon_sym_while] = ACTIONS(1241),
    [anon_sym_done] = ACTIONS(4996),
    [anon_sym_if] = ACTIONS(1241),
    [anon_sym_case] = ACTIONS(1241),
    [anon_sym_function] = ACTIONS(1241),
    [anon_sym_LPAREN] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1237),
    [anon_sym_BANG] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(1241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1237),
    [anon_sym_declare] = ACTIONS(1241),
    [anon_sym_typeset] = ACTIONS(1241),
    [anon_sym_export] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_local] = ACTIONS(1241),
    [anon_sym_unset] = ACTIONS(1241),
    [anon_sym_unsetenv] = ACTIONS(1241),
    [anon_sym_LT] = ACTIONS(1241),
    [anon_sym_GT] = ACTIONS(1241),
    [anon_sym_GT_GT] = ACTIONS(1237),
    [anon_sym_AMP_GT] = ACTIONS(1241),
    [anon_sym_AMP_GT_GT] = ACTIONS(1237),
    [anon_sym_LT_AMP] = ACTIONS(1237),
    [anon_sym_GT_AMP] = ACTIONS(1237),
    [anon_sym_DOLLAR] = ACTIONS(1241),
    [sym__special_character] = ACTIONS(1241),
    [anon_sym_DQUOTE] = ACTIONS(1237),
    [sym_raw_string] = ACTIONS(1237),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1237),
    [anon_sym_BQUOTE] = ACTIONS(1237),
    [anon_sym_LT_LPAREN] = ACTIONS(1237),
    [anon_sym_GT_LPAREN] = ACTIONS(1237),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1241),
  },
  [1601] = {
    [sym_redirected_statement] = STATE(2266),
    [sym_for_statement] = STATE(2266),
    [sym_c_style_for_statement] = STATE(2266),
    [sym_while_statement] = STATE(2266),
    [sym_if_statement] = STATE(2266),
    [sym_case_statement] = STATE(2266),
    [sym_function_definition] = STATE(2266),
    [sym_compound_statement] = STATE(2266),
    [sym_subshell] = STATE(2266),
    [sym_pipeline] = STATE(2266),
    [sym_list] = STATE(2266),
    [sym_negated_command] = STATE(2266),
    [sym_test_command] = STATE(2266),
    [sym_declaration_command] = STATE(2266),
    [sym_unset_command] = STATE(2266),
    [sym_command] = STATE(2266),
    [sym_command_name] = STATE(935),
    [sym_variable_assignment] = STATE(2267),
    [sym_subscript] = STATE(937),
    [sym_file_redirect] = STATE(940),
    [sym_concatenation] = STATE(938),
    [sym_string] = STATE(927),
    [sym_simple_expansion] = STATE(927),
    [sym_string_expansion] = STATE(927),
    [sym_expansion] = STATE(927),
    [sym_command_substitution] = STATE(927),
    [sym_process_substitution] = STATE(927),
    [aux_sym_command_repeat1] = STATE(940),
    [aux_sym__literal_repeat1] = STATE(941),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(1751),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1755),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(1757),
    [anon_sym_typeset] = ACTIONS(1757),
    [anon_sym_export] = ACTIONS(1757),
    [anon_sym_readonly] = ACTIONS(1757),
    [anon_sym_local] = ACTIONS(1757),
    [anon_sym_unset] = ACTIONS(1759),
    [anon_sym_unsetenv] = ACTIONS(1759),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(1761),
    [sym__special_character] = ACTIONS(1763),
    [anon_sym_DQUOTE] = ACTIONS(1765),
    [sym_raw_string] = ACTIONS(1767),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1769),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1771),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [anon_sym_LT_LPAREN] = ACTIONS(1775),
    [anon_sym_GT_LPAREN] = ACTIONS(1775),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1777),
  },
  [1602] = {
    [sym_redirected_statement] = STATE(2268),
    [sym_for_statement] = STATE(2268),
    [sym_c_style_for_statement] = STATE(2268),
    [sym_while_statement] = STATE(2268),
    [sym_if_statement] = STATE(2268),
    [sym_case_statement] = STATE(2268),
    [sym_function_definition] = STATE(2268),
    [sym_compound_statement] = STATE(2268),
    [sym_subshell] = STATE(2268),
    [sym_pipeline] = STATE(2268),
    [sym_list] = STATE(2268),
    [sym_negated_command] = STATE(2268),
    [sym_test_command] = STATE(2268),
    [sym_declaration_command] = STATE(2268),
    [sym_unset_command] = STATE(2268),
    [sym_command] = STATE(2268),
    [sym_command_name] = STATE(935),
    [sym_variable_assignment] = STATE(2269),
    [sym_subscript] = STATE(937),
    [sym_file_redirect] = STATE(940),
    [sym_concatenation] = STATE(938),
    [sym_string] = STATE(927),
    [sym_simple_expansion] = STATE(927),
    [sym_string_expansion] = STATE(927),
    [sym_expansion] = STATE(927),
    [sym_command_substitution] = STATE(927),
    [sym_process_substitution] = STATE(927),
    [aux_sym_command_repeat1] = STATE(940),
    [aux_sym__literal_repeat1] = STATE(941),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(1751),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1755),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(1757),
    [anon_sym_typeset] = ACTIONS(1757),
    [anon_sym_export] = ACTIONS(1757),
    [anon_sym_readonly] = ACTIONS(1757),
    [anon_sym_local] = ACTIONS(1757),
    [anon_sym_unset] = ACTIONS(1759),
    [anon_sym_unsetenv] = ACTIONS(1759),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(1761),
    [sym__special_character] = ACTIONS(1763),
    [anon_sym_DQUOTE] = ACTIONS(1765),
    [sym_raw_string] = ACTIONS(1767),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1769),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1771),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [anon_sym_LT_LPAREN] = ACTIONS(1775),
    [anon_sym_GT_LPAREN] = ACTIONS(1775),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1777),
  },
  [1603] = {
    [sym_concatenation] = STATE(696),
    [sym_string] = STATE(2273),
    [sym_simple_expansion] = STATE(2273),
    [sym_string_expansion] = STATE(2273),
    [sym_expansion] = STATE(2273),
    [sym_command_substitution] = STATE(2273),
    [sym_process_substitution] = STATE(2273),
    [aux_sym__literal_repeat1] = STATE(2278),
    [anon_sym_DOLLAR] = ACTIONS(4998),
    [sym__special_character] = ACTIONS(5000),
    [anon_sym_DQUOTE] = ACTIONS(5002),
    [sym_raw_string] = ACTIONS(5004),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5006),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5008),
    [anon_sym_BQUOTE] = ACTIONS(5010),
    [anon_sym_LT_LPAREN] = ACTIONS(5012),
    [anon_sym_GT_LPAREN] = ACTIONS(5012),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5004),
  },
  [1604] = {
    [sym_concatenation] = STATE(700),
    [sym_string] = STATE(2279),
    [sym_simple_expansion] = STATE(2279),
    [sym_string_expansion] = STATE(2279),
    [sym_expansion] = STATE(2279),
    [sym_command_substitution] = STATE(2279),
    [sym_process_substitution] = STATE(2279),
    [aux_sym__literal_repeat1] = STATE(2280),
    [anon_sym_DOLLAR] = ACTIONS(4998),
    [sym__special_character] = ACTIONS(5000),
    [anon_sym_DQUOTE] = ACTIONS(5002),
    [sym_raw_string] = ACTIONS(5014),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5006),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5008),
    [anon_sym_BQUOTE] = ACTIONS(5010),
    [anon_sym_LT_LPAREN] = ACTIONS(5012),
    [anon_sym_GT_LPAREN] = ACTIONS(5012),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5014),
  },
  [1605] = {
    [anon_sym_SEMI] = ACTIONS(5016),
    [anon_sym_done] = ACTIONS(1239),
    [anon_sym_SEMI_SEMI] = ACTIONS(5018),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5018),
    [anon_sym_AMP] = ACTIONS(5018),
  },
  [1606] = {
    [sym_file_redirect] = STATE(2282),
    [sym_heredoc_redirect] = STATE(2282),
    [sym_herestring_redirect] = STATE(2282),
    [aux_sym_redirected_statement_repeat1] = STATE(2282),
    [sym__simple_heredoc_body] = ACTIONS(1255),
    [sym__heredoc_body_beginning] = ACTIONS(1255),
    [sym_file_descriptor] = ACTIONS(3295),
    [anon_sym_SEMI] = ACTIONS(1257),
    [anon_sym_done] = ACTIONS(1255),
    [anon_sym_PIPE] = ACTIONS(1257),
    [anon_sym_SEMI_SEMI] = ACTIONS(1255),
    [anon_sym_PIPE_AMP] = ACTIONS(1255),
    [anon_sym_AMP_AMP] = ACTIONS(1255),
    [anon_sym_PIPE_PIPE] = ACTIONS(1255),
    [anon_sym_LT] = ACTIONS(3307),
    [anon_sym_GT] = ACTIONS(3307),
    [anon_sym_GT_GT] = ACTIONS(3309),
    [anon_sym_AMP_GT] = ACTIONS(3307),
    [anon_sym_AMP_GT_GT] = ACTIONS(3309),
    [anon_sym_LT_AMP] = ACTIONS(3309),
    [anon_sym_GT_AMP] = ACTIONS(3309),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(3311),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1257),
  },
  [1607] = {
    [sym_concatenation] = STATE(2283),
    [sym_string] = STATE(2284),
    [sym_simple_expansion] = STATE(2284),
    [sym_string_expansion] = STATE(2284),
    [sym_expansion] = STATE(2284),
    [sym_command_substitution] = STATE(2284),
    [sym_process_substitution] = STATE(2284),
    [aux_sym__literal_repeat1] = STATE(2285),
    [sym_regex] = ACTIONS(5020),
    [anon_sym_DOLLAR] = ACTIONS(1761),
    [sym__special_character] = ACTIONS(3315),
    [anon_sym_DQUOTE] = ACTIONS(1765),
    [sym_raw_string] = ACTIONS(5022),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1769),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1771),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [anon_sym_LT_LPAREN] = ACTIONS(1775),
    [anon_sym_GT_LPAREN] = ACTIONS(1775),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5022),
  },
  [1608] = {
    [aux_sym_concatenation_repeat1] = STATE(1586),
    [sym__simple_heredoc_body] = ACTIONS(1263),
    [sym__heredoc_body_beginning] = ACTIONS(1263),
    [sym_file_descriptor] = ACTIONS(1263),
    [sym__concat] = ACTIONS(3277),
    [anon_sym_SEMI] = ACTIONS(1265),
    [anon_sym_done] = ACTIONS(1265),
    [anon_sym_PIPE] = ACTIONS(1265),
    [anon_sym_SEMI_SEMI] = ACTIONS(1263),
    [anon_sym_PIPE_AMP] = ACTIONS(1263),
    [anon_sym_AMP_AMP] = ACTIONS(1263),
    [anon_sym_PIPE_PIPE] = ACTIONS(1263),
    [anon_sym_EQ_TILDE] = ACTIONS(1265),
    [anon_sym_EQ_EQ] = ACTIONS(1265),
    [anon_sym_LT] = ACTIONS(1265),
    [anon_sym_GT] = ACTIONS(1265),
    [anon_sym_GT_GT] = ACTIONS(1263),
    [anon_sym_AMP_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT_GT] = ACTIONS(1263),
    [anon_sym_LT_AMP] = ACTIONS(1263),
    [anon_sym_GT_AMP] = ACTIONS(1263),
    [anon_sym_LT_LT] = ACTIONS(1265),
    [anon_sym_LT_LT_DASH] = ACTIONS(1263),
    [anon_sym_LT_LT_LT] = ACTIONS(1263),
    [anon_sym_DOLLAR] = ACTIONS(1265),
    [sym__special_character] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(1263),
    [sym_raw_string] = ACTIONS(1263),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1263),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1263),
    [anon_sym_BQUOTE] = ACTIONS(1263),
    [anon_sym_LT_LPAREN] = ACTIONS(1263),
    [anon_sym_GT_LPAREN] = ACTIONS(1263),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1265),
    [anon_sym_LF] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1265),
  },
  [1609] = {
    [sym_concatenation] = STATE(2286),
    [sym_string] = STATE(1608),
    [sym_simple_expansion] = STATE(1608),
    [sym_string_expansion] = STATE(1608),
    [sym_expansion] = STATE(1608),
    [sym_command_substitution] = STATE(1608),
    [sym_process_substitution] = STATE(1608),
    [aux_sym_command_repeat2] = STATE(2286),
    [aux_sym__literal_repeat1] = STATE(1610),
    [sym__simple_heredoc_body] = ACTIONS(1267),
    [sym__heredoc_body_beginning] = ACTIONS(1267),
    [sym_file_descriptor] = ACTIONS(1267),
    [anon_sym_SEMI] = ACTIONS(1269),
    [anon_sym_done] = ACTIONS(1269),
    [anon_sym_PIPE] = ACTIONS(1269),
    [anon_sym_SEMI_SEMI] = ACTIONS(1267),
    [anon_sym_PIPE_AMP] = ACTIONS(1267),
    [anon_sym_AMP_AMP] = ACTIONS(1267),
    [anon_sym_PIPE_PIPE] = ACTIONS(1267),
    [anon_sym_EQ_TILDE] = ACTIONS(3313),
    [anon_sym_EQ_EQ] = ACTIONS(3313),
    [anon_sym_LT] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1269),
    [anon_sym_GT_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT_GT] = ACTIONS(1267),
    [anon_sym_LT_AMP] = ACTIONS(1267),
    [anon_sym_GT_AMP] = ACTIONS(1267),
    [anon_sym_LT_LT] = ACTIONS(1269),
    [anon_sym_LT_LT_DASH] = ACTIONS(1267),
    [anon_sym_LT_LT_LT] = ACTIONS(1267),
    [anon_sym_DOLLAR] = ACTIONS(1761),
    [sym__special_character] = ACTIONS(3315),
    [anon_sym_DQUOTE] = ACTIONS(1765),
    [sym_raw_string] = ACTIONS(3317),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1769),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1771),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [anon_sym_LT_LPAREN] = ACTIONS(1775),
    [anon_sym_GT_LPAREN] = ACTIONS(1775),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3319),
    [anon_sym_LF] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(1269),
  },
  [1610] = {
    [aux_sym__literal_repeat1] = STATE(1615),
    [sym__simple_heredoc_body] = ACTIONS(1271),
    [sym__heredoc_body_beginning] = ACTIONS(1271),
    [sym_file_descriptor] = ACTIONS(1271),
    [anon_sym_SEMI] = ACTIONS(1273),
    [anon_sym_done] = ACTIONS(1273),
    [anon_sym_PIPE] = ACTIONS(1273),
    [anon_sym_SEMI_SEMI] = ACTIONS(1271),
    [anon_sym_PIPE_AMP] = ACTIONS(1271),
    [anon_sym_AMP_AMP] = ACTIONS(1271),
    [anon_sym_PIPE_PIPE] = ACTIONS(1271),
    [anon_sym_EQ_TILDE] = ACTIONS(1273),
    [anon_sym_EQ_EQ] = ACTIONS(1273),
    [anon_sym_LT] = ACTIONS(1273),
    [anon_sym_GT] = ACTIONS(1273),
    [anon_sym_GT_GT] = ACTIONS(1271),
    [anon_sym_AMP_GT] = ACTIONS(1273),
    [anon_sym_AMP_GT_GT] = ACTIONS(1271),
    [anon_sym_LT_AMP] = ACTIONS(1271),
    [anon_sym_GT_AMP] = ACTIONS(1271),
    [anon_sym_LT_LT] = ACTIONS(1273),
    [anon_sym_LT_LT_DASH] = ACTIONS(1271),
    [anon_sym_LT_LT_LT] = ACTIONS(1271),
    [anon_sym_DOLLAR] = ACTIONS(1273),
    [sym__special_character] = ACTIONS(3323),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [sym_raw_string] = ACTIONS(1271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1271),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1271),
    [anon_sym_BQUOTE] = ACTIONS(1271),
    [anon_sym_LT_LPAREN] = ACTIONS(1271),
    [anon_sym_GT_LPAREN] = ACTIONS(1271),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1273),
    [anon_sym_LF] = ACTIONS(1271),
    [anon_sym_AMP] = ACTIONS(1273),
  },
  [1611] = {
    [sym_file_redirect] = STATE(1606),
    [sym_heredoc_redirect] = STATE(1606),
    [sym_heredoc_body] = STATE(2288),
    [sym_herestring_redirect] = STATE(1606),
    [aux_sym_redirected_statement_repeat1] = STATE(1606),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(3295),
    [anon_sym_SEMI] = ACTIONS(5024),
    [anon_sym_done] = ACTIONS(1239),
    [anon_sym_PIPE] = ACTIONS(3299),
    [anon_sym_SEMI_SEMI] = ACTIONS(5026),
    [anon_sym_PIPE_AMP] = ACTIONS(3303),
    [anon_sym_AMP_AMP] = ACTIONS(3305),
    [anon_sym_PIPE_PIPE] = ACTIONS(3305),
    [anon_sym_LT] = ACTIONS(3307),
    [anon_sym_GT] = ACTIONS(3307),
    [anon_sym_GT_GT] = ACTIONS(3309),
    [anon_sym_AMP_GT] = ACTIONS(3307),
    [anon_sym_AMP_GT_GT] = ACTIONS(3309),
    [anon_sym_LT_AMP] = ACTIONS(3309),
    [anon_sym_GT_AMP] = ACTIONS(3309),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(3311),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5026),
    [anon_sym_AMP] = ACTIONS(5024),
  },
  [1612] = {
    [sym_file_redirect] = STATE(1606),
    [sym_heredoc_redirect] = STATE(1606),
    [sym_heredoc_body] = STATE(2288),
    [sym_herestring_redirect] = STATE(1606),
    [aux_sym_redirected_statement_repeat1] = STATE(1606),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(5024),
    [anon_sym_done] = ACTIONS(4996),
    [anon_sym_PIPE] = ACTIONS(3299),
    [anon_sym_SEMI_SEMI] = ACTIONS(5026),
    [anon_sym_PIPE_AMP] = ACTIONS(3303),
    [anon_sym_AMP_AMP] = ACTIONS(3305),
    [anon_sym_PIPE_PIPE] = ACTIONS(3305),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(3311),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(5026),
    [anon_sym_AMP] = ACTIONS(5024),
  },
  [1613] = {
    [sym_concatenation] = STATE(2289),
    [sym_string] = STATE(1608),
    [sym_simple_expansion] = STATE(1608),
    [sym_string_expansion] = STATE(1608),
    [sym_expansion] = STATE(1608),
    [sym_command_substitution] = STATE(1608),
    [sym_process_substitution] = STATE(1608),
    [aux_sym_command_repeat2] = STATE(2289),
    [aux_sym__literal_repeat1] = STATE(1610),
    [sym__simple_heredoc_body] = ACTIONS(1267),
    [sym__heredoc_body_beginning] = ACTIONS(1267),
    [sym_file_descriptor] = ACTIONS(1267),
    [anon_sym_SEMI] = ACTIONS(1269),
    [anon_sym_done] = ACTIONS(1269),
    [anon_sym_PIPE] = ACTIONS(1269),
    [anon_sym_SEMI_SEMI] = ACTIONS(1267),
    [anon_sym_PIPE_AMP] = ACTIONS(1267),
    [anon_sym_AMP_AMP] = ACTIONS(1267),
    [anon_sym_PIPE_PIPE] = ACTIONS(1267),
    [anon_sym_EQ_TILDE] = ACTIONS(3313),
    [anon_sym_EQ_EQ] = ACTIONS(3313),
    [anon_sym_LT] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1269),
    [anon_sym_GT_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT_GT] = ACTIONS(1267),
    [anon_sym_LT_AMP] = ACTIONS(1267),
    [anon_sym_GT_AMP] = ACTIONS(1267),
    [anon_sym_LT_LT] = ACTIONS(1269),
    [anon_sym_LT_LT_DASH] = ACTIONS(1267),
    [anon_sym_LT_LT_LT] = ACTIONS(1267),
    [anon_sym_DOLLAR] = ACTIONS(1761),
    [sym__special_character] = ACTIONS(3315),
    [anon_sym_DQUOTE] = ACTIONS(1765),
    [sym_raw_string] = ACTIONS(3317),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1769),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1771),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [anon_sym_LT_LPAREN] = ACTIONS(1775),
    [anon_sym_GT_LPAREN] = ACTIONS(1775),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3319),
    [anon_sym_LF] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(1269),
  },
  [1614] = {
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_done] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_EQ_TILDE] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [1615] = {
    [aux_sym__literal_repeat1] = STATE(1615),
    [sym__simple_heredoc_body] = ACTIONS(1373),
    [sym__heredoc_body_beginning] = ACTIONS(1373),
    [sym_file_descriptor] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_done] = ACTIONS(1375),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE_AMP] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_EQ_TILDE] = ACTIONS(1375),
    [anon_sym_EQ_EQ] = ACTIONS(1375),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_LT_LT_DASH] = ACTIONS(1373),
    [anon_sym_LT_LT_LT] = ACTIONS(1373),
    [anon_sym_DOLLAR] = ACTIONS(1375),
    [sym__special_character] = ACTIONS(5028),
    [anon_sym_DQUOTE] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1373),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [anon_sym_LT_LPAREN] = ACTIONS(1373),
    [anon_sym_GT_LPAREN] = ACTIONS(1373),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1375),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
  },
  [1616] = {
    [aux_sym_concatenation_repeat1] = STATE(1619),
    [sym_file_descriptor] = ACTIONS(1380),
    [sym__concat] = ACTIONS(633),
    [anon_sym_SEMI] = ACTIONS(1382),
    [anon_sym_PIPE] = ACTIONS(1382),
    [anon_sym_SEMI_SEMI] = ACTIONS(1380),
    [anon_sym_PIPE_AMP] = ACTIONS(1380),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_PIPE_PIPE] = ACTIONS(1380),
    [anon_sym_LT] = ACTIONS(1382),
    [anon_sym_GT] = ACTIONS(1382),
    [anon_sym_GT_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT] = ACTIONS(1382),
    [anon_sym_AMP_GT_GT] = ACTIONS(1380),
    [anon_sym_LT_AMP] = ACTIONS(1380),
    [anon_sym_GT_AMP] = ACTIONS(1380),
    [anon_sym_LT_LT] = ACTIONS(1382),
    [anon_sym_LT_LT_DASH] = ACTIONS(1380),
    [anon_sym_LT_LT_LT] = ACTIONS(1380),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1380),
    [anon_sym_AMP] = ACTIONS(1382),
  },
  [1617] = {
    [sym_file_descriptor] = ACTIONS(1380),
    [anon_sym_SEMI] = ACTIONS(1382),
    [anon_sym_PIPE] = ACTIONS(1382),
    [anon_sym_SEMI_SEMI] = ACTIONS(1380),
    [anon_sym_PIPE_AMP] = ACTIONS(1380),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_PIPE_PIPE] = ACTIONS(1380),
    [anon_sym_LT] = ACTIONS(1382),
    [anon_sym_GT] = ACTIONS(1382),
    [anon_sym_GT_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT] = ACTIONS(1382),
    [anon_sym_AMP_GT_GT] = ACTIONS(1380),
    [anon_sym_LT_AMP] = ACTIONS(1380),
    [anon_sym_GT_AMP] = ACTIONS(1380),
    [anon_sym_LT_LT] = ACTIONS(1382),
    [anon_sym_LT_LT_DASH] = ACTIONS(1380),
    [anon_sym_LT_LT_LT] = ACTIONS(1380),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1380),
    [anon_sym_AMP] = ACTIONS(1382),
  },
  [1618] = {
    [aux_sym__literal_repeat1] = STATE(1620),
    [sym_file_descriptor] = ACTIONS(1384),
    [anon_sym_SEMI] = ACTIONS(1386),
    [anon_sym_PIPE] = ACTIONS(1386),
    [anon_sym_SEMI_SEMI] = ACTIONS(1384),
    [anon_sym_PIPE_AMP] = ACTIONS(1384),
    [anon_sym_AMP_AMP] = ACTIONS(1384),
    [anon_sym_PIPE_PIPE] = ACTIONS(1384),
    [anon_sym_LT] = ACTIONS(1386),
    [anon_sym_GT] = ACTIONS(1386),
    [anon_sym_GT_GT] = ACTIONS(1384),
    [anon_sym_AMP_GT] = ACTIONS(1386),
    [anon_sym_AMP_GT_GT] = ACTIONS(1384),
    [anon_sym_LT_AMP] = ACTIONS(1384),
    [anon_sym_GT_AMP] = ACTIONS(1384),
    [anon_sym_LT_LT] = ACTIONS(1386),
    [anon_sym_LT_LT_DASH] = ACTIONS(1384),
    [anon_sym_LT_LT_LT] = ACTIONS(1384),
    [sym__special_character] = ACTIONS(683),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1384),
    [anon_sym_AMP] = ACTIONS(1386),
  },
  [1619] = {
    [aux_sym_concatenation_repeat1] = STATE(2291),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(5031),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1075),
  },
  [1620] = {
    [aux_sym__literal_repeat1] = STATE(1620),
    [sym_file_descriptor] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE_AMP] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_LT_LT_DASH] = ACTIONS(1373),
    [anon_sym_LT_LT_LT] = ACTIONS(1373),
    [sym__special_character] = ACTIONS(1801),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
  },
  [1621] = {
    [sym_concatenation] = STATE(2292),
    [sym_string] = STATE(2297),
    [sym_array] = STATE(2292),
    [sym_simple_expansion] = STATE(2297),
    [sym_string_expansion] = STATE(2297),
    [sym_expansion] = STATE(2297),
    [sym_command_substitution] = STATE(2297),
    [sym_process_substitution] = STATE(2297),
    [aux_sym__literal_repeat1] = STATE(2302),
    [sym__empty_value] = ACTIONS(5033),
    [anon_sym_LPAREN] = ACTIONS(5035),
    [anon_sym_DOLLAR] = ACTIONS(5037),
    [sym__special_character] = ACTIONS(5039),
    [anon_sym_DQUOTE] = ACTIONS(5041),
    [sym_raw_string] = ACTIONS(5043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5045),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5047),
    [anon_sym_BQUOTE] = ACTIONS(5049),
    [anon_sym_LT_LPAREN] = ACTIONS(5051),
    [anon_sym_GT_LPAREN] = ACTIONS(5051),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5043),
  },
  [1622] = {
    [anon_sym_then] = ACTIONS(5053),
    [sym_comment] = ACTIONS(57),
  },
  [1623] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(5055),
    [anon_sym_PLUS_EQ] = ACTIONS(5055),
    [sym_comment] = ACTIONS(57),
  },
  [1624] = {
    [sym_subshell] = STATE(146),
    [sym_test_command] = STATE(146),
    [sym_command] = STATE(146),
    [sym_command_name] = STATE(1638),
    [sym_variable_assignment] = STATE(1643),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(1643),
    [sym_concatenation] = STATE(1641),
    [sym_string] = STATE(1630),
    [sym_simple_expansion] = STATE(1630),
    [sym_string_expansion] = STATE(1630),
    [sym_expansion] = STATE(1630),
    [sym_command_substitution] = STATE(1630),
    [sym_process_substitution] = STATE(1630),
    [aux_sym_command_repeat1] = STATE(1643),
    [aux_sym__literal_repeat1] = STATE(1644),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(3391),
    [sym__special_character] = ACTIONS(3393),
    [anon_sym_DQUOTE] = ACTIONS(3395),
    [sym_raw_string] = ACTIONS(3397),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3401),
    [anon_sym_BQUOTE] = ACTIONS(3403),
    [anon_sym_LT_LPAREN] = ACTIONS(3405),
    [anon_sym_GT_LPAREN] = ACTIONS(3405),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3397),
  },
  [1625] = {
    [sym_variable_assignment] = STATE(2315),
    [sym_subscript] = STATE(2314),
    [sym_concatenation] = STATE(2315),
    [sym_string] = STATE(2309),
    [sym_simple_expansion] = STATE(2309),
    [sym_string_expansion] = STATE(2309),
    [sym_expansion] = STATE(2309),
    [sym_command_substitution] = STATE(2309),
    [sym_process_substitution] = STATE(2309),
    [aux_sym_declaration_command_repeat1] = STATE(2315),
    [aux_sym__literal_repeat1] = STATE(2316),
    [sym__simple_heredoc_body] = ACTIONS(259),
    [sym__heredoc_body_beginning] = ACTIONS(259),
    [sym_file_descriptor] = ACTIONS(259),
    [sym_variable_name] = ACTIONS(5057),
    [anon_sym_SEMI] = ACTIONS(263),
    [anon_sym_fi] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_SEMI_SEMI] = ACTIONS(259),
    [anon_sym_PIPE_AMP] = ACTIONS(259),
    [anon_sym_AMP_AMP] = ACTIONS(259),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_LT] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_GT_GT] = ACTIONS(259),
    [anon_sym_AMP_GT] = ACTIONS(263),
    [anon_sym_AMP_GT_GT] = ACTIONS(259),
    [anon_sym_LT_AMP] = ACTIONS(259),
    [anon_sym_GT_AMP] = ACTIONS(259),
    [anon_sym_LT_LT] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(259),
    [anon_sym_LT_LT_LT] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(5059),
    [sym__special_character] = ACTIONS(5061),
    [anon_sym_DQUOTE] = ACTIONS(5063),
    [sym_raw_string] = ACTIONS(5065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5067),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5069),
    [anon_sym_BQUOTE] = ACTIONS(5071),
    [anon_sym_LT_LPAREN] = ACTIONS(5073),
    [anon_sym_GT_LPAREN] = ACTIONS(5073),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5075),
    [sym_word] = ACTIONS(5077),
    [anon_sym_LF] = ACTIONS(259),
    [anon_sym_AMP] = ACTIONS(263),
  },
  [1626] = {
    [sym_concatenation] = STATE(2325),
    [sym_string] = STATE(2320),
    [sym_simple_expansion] = STATE(2320),
    [sym_string_expansion] = STATE(2320),
    [sym_expansion] = STATE(2320),
    [sym_command_substitution] = STATE(2320),
    [sym_process_substitution] = STATE(2320),
    [aux_sym_unset_command_repeat1] = STATE(2325),
    [aux_sym__literal_repeat1] = STATE(2326),
    [sym__simple_heredoc_body] = ACTIONS(285),
    [sym__heredoc_body_beginning] = ACTIONS(285),
    [sym_file_descriptor] = ACTIONS(285),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym_fi] = ACTIONS(287),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(285),
    [anon_sym_PIPE_AMP] = ACTIONS(285),
    [anon_sym_AMP_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(287),
    [anon_sym_GT] = ACTIONS(287),
    [anon_sym_GT_GT] = ACTIONS(285),
    [anon_sym_AMP_GT] = ACTIONS(287),
    [anon_sym_AMP_GT_GT] = ACTIONS(285),
    [anon_sym_LT_AMP] = ACTIONS(285),
    [anon_sym_GT_AMP] = ACTIONS(285),
    [anon_sym_LT_LT] = ACTIONS(287),
    [anon_sym_LT_LT_DASH] = ACTIONS(285),
    [anon_sym_LT_LT_LT] = ACTIONS(285),
    [anon_sym_DOLLAR] = ACTIONS(5079),
    [sym__special_character] = ACTIONS(5081),
    [anon_sym_DQUOTE] = ACTIONS(5083),
    [sym_raw_string] = ACTIONS(5085),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5089),
    [anon_sym_BQUOTE] = ACTIONS(5091),
    [anon_sym_LT_LPAREN] = ACTIONS(5093),
    [anon_sym_GT_LPAREN] = ACTIONS(5093),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5095),
    [sym_word] = ACTIONS(5097),
    [anon_sym_LF] = ACTIONS(285),
    [anon_sym_AMP] = ACTIONS(287),
  },
  [1627] = {
    [sym_string] = STATE(2328),
    [anon_sym_DASH] = ACTIONS(5099),
    [anon_sym_DOLLAR] = ACTIONS(5099),
    [anon_sym_DQUOTE] = ACTIONS(3395),
    [sym_raw_string] = ACTIONS(5101),
    [anon_sym_POUND] = ACTIONS(5099),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5103),
    [anon_sym_STAR] = ACTIONS(5105),
    [anon_sym_AT] = ACTIONS(5105),
    [anon_sym_QMARK] = ACTIONS(5105),
    [anon_sym_0] = ACTIONS(5103),
    [anon_sym__] = ACTIONS(5103),
  },
  [1628] = {
    [aux_sym_concatenation_repeat1] = STATE(2331),
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(5107),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_fi] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_EQ_TILDE] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [1629] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(2334),
    [anon_sym_DOLLAR] = ACTIONS(5109),
    [anon_sym_DQUOTE] = ACTIONS(5111),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [1630] = {
    [aux_sym_concatenation_repeat1] = STATE(2331),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(5107),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_fi] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [1631] = {
    [sym_subscript] = STATE(2338),
    [sym_variable_name] = ACTIONS(5113),
    [anon_sym_BANG] = ACTIONS(5115),
    [anon_sym_DASH] = ACTIONS(5117),
    [anon_sym_DOLLAR] = ACTIONS(5117),
    [anon_sym_POUND] = ACTIONS(5115),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5119),
    [anon_sym_STAR] = ACTIONS(5121),
    [anon_sym_AT] = ACTIONS(5121),
    [anon_sym_QMARK] = ACTIONS(5121),
    [anon_sym_0] = ACTIONS(5119),
    [anon_sym__] = ACTIONS(5119),
  },
  [1632] = {
    [sym__statements] = STATE(2339),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(2340),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [1633] = {
    [sym__statements] = STATE(2341),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [1634] = {
    [sym__statements] = STATE(2342),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [1635] = {
    [aux_sym_concatenation_repeat1] = STATE(2331),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(5107),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_fi] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_LPAREN] = ACTIONS(387),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [1636] = {
    [anon_sym_fi] = ACTIONS(5123),
    [sym_comment] = ACTIONS(57),
  },
  [1637] = {
    [sym_file_redirect] = STATE(2350),
    [sym_heredoc_redirect] = STATE(2350),
    [sym_heredoc_body] = STATE(2349),
    [sym_herestring_redirect] = STATE(2350),
    [aux_sym_redirected_statement_repeat1] = STATE(2350),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(5125),
    [anon_sym_SEMI] = ACTIONS(5127),
    [anon_sym_fi] = ACTIONS(399),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_SEMI_SEMI] = ACTIONS(5131),
    [anon_sym_PIPE_AMP] = ACTIONS(5133),
    [anon_sym_AMP_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5135),
    [anon_sym_LT] = ACTIONS(5137),
    [anon_sym_GT] = ACTIONS(5137),
    [anon_sym_GT_GT] = ACTIONS(5139),
    [anon_sym_AMP_GT] = ACTIONS(5137),
    [anon_sym_AMP_GT_GT] = ACTIONS(5139),
    [anon_sym_LT_AMP] = ACTIONS(5139),
    [anon_sym_GT_AMP] = ACTIONS(5139),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(5141),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5131),
    [anon_sym_AMP] = ACTIONS(5127),
  },
  [1638] = {
    [sym_concatenation] = STATE(2353),
    [sym_string] = STATE(2352),
    [sym_simple_expansion] = STATE(2352),
    [sym_string_expansion] = STATE(2352),
    [sym_expansion] = STATE(2352),
    [sym_command_substitution] = STATE(2352),
    [sym_process_substitution] = STATE(2352),
    [aux_sym_command_repeat2] = STATE(2353),
    [aux_sym__literal_repeat1] = STATE(2354),
    [sym__simple_heredoc_body] = ACTIONS(421),
    [sym__heredoc_body_beginning] = ACTIONS(421),
    [sym_file_descriptor] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_fi] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI_SEMI] = ACTIONS(421),
    [anon_sym_PIPE_AMP] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_AMP_GT] = ACTIONS(423),
    [anon_sym_AMP_GT_GT] = ACTIONS(421),
    [anon_sym_LT_AMP] = ACTIONS(421),
    [anon_sym_GT_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_LT_LT_DASH] = ACTIONS(421),
    [anon_sym_LT_LT_LT] = ACTIONS(421),
    [anon_sym_DOLLAR] = ACTIONS(3391),
    [sym__special_character] = ACTIONS(5145),
    [anon_sym_DQUOTE] = ACTIONS(3395),
    [sym_raw_string] = ACTIONS(5147),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3401),
    [anon_sym_BQUOTE] = ACTIONS(3403),
    [anon_sym_LT_LPAREN] = ACTIONS(3405),
    [anon_sym_GT_LPAREN] = ACTIONS(3405),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5149),
    [anon_sym_LF] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
  },
  [1639] = {
    [sym_file_redirect] = STATE(2350),
    [sym_heredoc_redirect] = STATE(2350),
    [sym_heredoc_body] = STATE(2349),
    [sym_herestring_redirect] = STATE(2350),
    [aux_sym_redirected_statement_repeat1] = STATE(2350),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(5127),
    [anon_sym_fi] = ACTIONS(3321),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_SEMI_SEMI] = ACTIONS(5131),
    [anon_sym_PIPE_AMP] = ACTIONS(5133),
    [anon_sym_AMP_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5135),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(5141),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(5131),
    [anon_sym_AMP] = ACTIONS(5127),
  },
  [1640] = {
    [anon_sym_EQ] = ACTIONS(5055),
    [anon_sym_PLUS_EQ] = ACTIONS(5055),
    [sym_comment] = ACTIONS(57),
  },
  [1641] = {
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_fi] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [1642] = {
    [sym_redirected_statement] = STATE(2355),
    [sym_for_statement] = STATE(2355),
    [sym_c_style_for_statement] = STATE(2355),
    [sym_while_statement] = STATE(2355),
    [sym_if_statement] = STATE(2355),
    [sym_case_statement] = STATE(2355),
    [sym_function_definition] = STATE(2355),
    [sym_compound_statement] = STATE(2355),
    [sym_subshell] = STATE(2355),
    [sym_pipeline] = STATE(2355),
    [sym_list] = STATE(2355),
    [sym_negated_command] = STATE(2355),
    [sym_test_command] = STATE(2355),
    [sym_declaration_command] = STATE(2355),
    [sym_unset_command] = STATE(2355),
    [sym_command] = STATE(2355),
    [sym_command_name] = STATE(1638),
    [sym_variable_assignment] = STATE(2356),
    [sym_subscript] = STATE(1640),
    [sym_file_redirect] = STATE(1643),
    [sym_concatenation] = STATE(1641),
    [sym_string] = STATE(1630),
    [sym_simple_expansion] = STATE(1630),
    [sym_string_expansion] = STATE(1630),
    [sym_expansion] = STATE(1630),
    [sym_command_substitution] = STATE(1630),
    [sym_process_substitution] = STATE(1630),
    [aux_sym__statements_repeat1] = STATE(251),
    [aux_sym_command_repeat1] = STATE(1643),
    [aux_sym__literal_repeat1] = STATE(1644),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(3381),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(3385),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(3387),
    [anon_sym_typeset] = ACTIONS(3387),
    [anon_sym_export] = ACTIONS(3387),
    [anon_sym_readonly] = ACTIONS(3387),
    [anon_sym_local] = ACTIONS(3387),
    [anon_sym_unset] = ACTIONS(3389),
    [anon_sym_unsetenv] = ACTIONS(3389),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(3391),
    [sym__special_character] = ACTIONS(3393),
    [anon_sym_DQUOTE] = ACTIONS(3395),
    [sym_raw_string] = ACTIONS(3397),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3401),
    [anon_sym_BQUOTE] = ACTIONS(3403),
    [anon_sym_LT_LPAREN] = ACTIONS(3405),
    [anon_sym_GT_LPAREN] = ACTIONS(3405),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3407),
  },
  [1643] = {
    [sym_command_name] = STATE(2357),
    [sym_variable_assignment] = STATE(253),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(253),
    [sym_concatenation] = STATE(1641),
    [sym_string] = STATE(1630),
    [sym_simple_expansion] = STATE(1630),
    [sym_string_expansion] = STATE(1630),
    [sym_expansion] = STATE(1630),
    [sym_command_substitution] = STATE(1630),
    [sym_process_substitution] = STATE(1630),
    [aux_sym_command_repeat1] = STATE(253),
    [aux_sym__literal_repeat1] = STATE(1644),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(3391),
    [sym__special_character] = ACTIONS(5145),
    [anon_sym_DQUOTE] = ACTIONS(3395),
    [sym_raw_string] = ACTIONS(3397),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3401),
    [anon_sym_BQUOTE] = ACTIONS(3403),
    [anon_sym_LT_LPAREN] = ACTIONS(3405),
    [anon_sym_GT_LPAREN] = ACTIONS(3405),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3397),
  },
  [1644] = {
    [aux_sym__literal_repeat1] = STATE(2359),
    [sym__simple_heredoc_body] = ACTIONS(437),
    [sym__heredoc_body_beginning] = ACTIONS(437),
    [sym_file_descriptor] = ACTIONS(437),
    [anon_sym_SEMI] = ACTIONS(439),
    [anon_sym_fi] = ACTIONS(439),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI_SEMI] = ACTIONS(437),
    [anon_sym_PIPE_AMP] = ACTIONS(437),
    [anon_sym_AMP_AMP] = ACTIONS(437),
    [anon_sym_PIPE_PIPE] = ACTIONS(437),
    [anon_sym_EQ_TILDE] = ACTIONS(439),
    [anon_sym_EQ_EQ] = ACTIONS(439),
    [anon_sym_LT] = ACTIONS(439),
    [anon_sym_GT] = ACTIONS(439),
    [anon_sym_GT_GT] = ACTIONS(437),
    [anon_sym_AMP_GT] = ACTIONS(439),
    [anon_sym_AMP_GT_GT] = ACTIONS(437),
    [anon_sym_LT_AMP] = ACTIONS(437),
    [anon_sym_GT_AMP] = ACTIONS(437),
    [anon_sym_LT_LT] = ACTIONS(439),
    [anon_sym_LT_LT_DASH] = ACTIONS(437),
    [anon_sym_LT_LT_LT] = ACTIONS(437),
    [anon_sym_DOLLAR] = ACTIONS(439),
    [sym__special_character] = ACTIONS(5151),
    [anon_sym_DQUOTE] = ACTIONS(437),
    [sym_raw_string] = ACTIONS(437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(437),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(437),
    [anon_sym_BQUOTE] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(437),
    [anon_sym_GT_LPAREN] = ACTIONS(437),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(439),
    [anon_sym_LF] = ACTIONS(437),
    [anon_sym_AMP] = ACTIONS(439),
  },
  [1645] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(5153),
    [anon_sym_PLUS_EQ] = ACTIONS(5153),
    [sym_comment] = ACTIONS(57),
  },
  [1646] = {
    [sym_string] = STATE(2362),
    [anon_sym_DASH] = ACTIONS(5155),
    [anon_sym_DOLLAR] = ACTIONS(5155),
    [anon_sym_DQUOTE] = ACTIONS(3415),
    [sym_raw_string] = ACTIONS(5157),
    [anon_sym_POUND] = ACTIONS(5155),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5159),
    [anon_sym_STAR] = ACTIONS(5161),
    [anon_sym_AT] = ACTIONS(5161),
    [anon_sym_QMARK] = ACTIONS(5161),
    [anon_sym_0] = ACTIONS(5159),
    [anon_sym__] = ACTIONS(5159),
  },
  [1647] = {
    [aux_sym_concatenation_repeat1] = STATE(2365),
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(5163),
    [sym_variable_name] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_fi] = ACTIONS(339),
    [anon_sym_elif] = ACTIONS(339),
    [anon_sym_else] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(339),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [1648] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(2368),
    [anon_sym_DOLLAR] = ACTIONS(5165),
    [anon_sym_DQUOTE] = ACTIONS(5167),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [1649] = {
    [aux_sym_concatenation_repeat1] = STATE(2365),
    [sym__simple_heredoc_body] = ACTIONS(957),
    [sym__heredoc_body_beginning] = ACTIONS(957),
    [sym_file_descriptor] = ACTIONS(957),
    [sym__concat] = ACTIONS(5163),
    [sym_variable_name] = ACTIONS(957),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_fi] = ACTIONS(959),
    [anon_sym_elif] = ACTIONS(959),
    [anon_sym_else] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_SEMI_SEMI] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_LT] = ACTIONS(959),
    [anon_sym_GT] = ACTIONS(959),
    [anon_sym_GT_GT] = ACTIONS(957),
    [anon_sym_AMP_GT] = ACTIONS(959),
    [anon_sym_AMP_GT_GT] = ACTIONS(957),
    [anon_sym_LT_AMP] = ACTIONS(957),
    [anon_sym_GT_AMP] = ACTIONS(957),
    [anon_sym_LT_LT] = ACTIONS(959),
    [anon_sym_LT_LT_DASH] = ACTIONS(957),
    [anon_sym_LT_LT_LT] = ACTIONS(957),
    [anon_sym_DOLLAR] = ACTIONS(959),
    [sym__special_character] = ACTIONS(957),
    [anon_sym_DQUOTE] = ACTIONS(957),
    [sym_raw_string] = ACTIONS(957),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(957),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(957),
    [anon_sym_BQUOTE] = ACTIONS(957),
    [anon_sym_LT_LPAREN] = ACTIONS(957),
    [anon_sym_GT_LPAREN] = ACTIONS(957),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(959),
    [sym_word] = ACTIONS(959),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
  },
  [1650] = {
    [sym_subscript] = STATE(2372),
    [sym_variable_name] = ACTIONS(5169),
    [anon_sym_BANG] = ACTIONS(5171),
    [anon_sym_DASH] = ACTIONS(5173),
    [anon_sym_DOLLAR] = ACTIONS(5173),
    [anon_sym_POUND] = ACTIONS(5171),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5175),
    [anon_sym_STAR] = ACTIONS(5177),
    [anon_sym_AT] = ACTIONS(5177),
    [anon_sym_QMARK] = ACTIONS(5177),
    [anon_sym_0] = ACTIONS(5175),
    [anon_sym__] = ACTIONS(5175),
  },
  [1651] = {
    [sym__statements] = STATE(2373),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(2374),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [1652] = {
    [sym__statements] = STATE(2375),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [1653] = {
    [sym__statements] = STATE(2376),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [1654] = {
    [anon_sym_EQ] = ACTIONS(5153),
    [anon_sym_PLUS_EQ] = ACTIONS(5153),
    [sym_comment] = ACTIONS(57),
  },
  [1655] = {
    [sym_variable_assignment] = STATE(2377),
    [sym_subscript] = STATE(1654),
    [sym_concatenation] = STATE(2377),
    [sym_string] = STATE(1649),
    [sym_simple_expansion] = STATE(1649),
    [sym_string_expansion] = STATE(1649),
    [sym_expansion] = STATE(1649),
    [sym_command_substitution] = STATE(1649),
    [sym_process_substitution] = STATE(1649),
    [aux_sym_declaration_command_repeat1] = STATE(2377),
    [aux_sym__literal_repeat1] = STATE(1656),
    [sym__simple_heredoc_body] = ACTIONS(971),
    [sym__heredoc_body_beginning] = ACTIONS(971),
    [sym_file_descriptor] = ACTIONS(971),
    [sym_variable_name] = ACTIONS(3409),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_fi] = ACTIONS(973),
    [anon_sym_elif] = ACTIONS(973),
    [anon_sym_else] = ACTIONS(973),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_SEMI_SEMI] = ACTIONS(971),
    [anon_sym_PIPE_AMP] = ACTIONS(971),
    [anon_sym_AMP_AMP] = ACTIONS(971),
    [anon_sym_PIPE_PIPE] = ACTIONS(971),
    [anon_sym_LT] = ACTIONS(973),
    [anon_sym_GT] = ACTIONS(973),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_AMP_GT] = ACTIONS(973),
    [anon_sym_AMP_GT_GT] = ACTIONS(971),
    [anon_sym_LT_AMP] = ACTIONS(971),
    [anon_sym_GT_AMP] = ACTIONS(971),
    [anon_sym_LT_LT] = ACTIONS(973),
    [anon_sym_LT_LT_DASH] = ACTIONS(971),
    [anon_sym_LT_LT_LT] = ACTIONS(971),
    [anon_sym_DOLLAR] = ACTIONS(3411),
    [sym__special_character] = ACTIONS(3413),
    [anon_sym_DQUOTE] = ACTIONS(3415),
    [sym_raw_string] = ACTIONS(3417),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3419),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3421),
    [anon_sym_BQUOTE] = ACTIONS(3423),
    [anon_sym_LT_LPAREN] = ACTIONS(3425),
    [anon_sym_GT_LPAREN] = ACTIONS(3425),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5179),
    [sym_word] = ACTIONS(3429),
    [anon_sym_LF] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(973),
  },
  [1656] = {
    [aux_sym__literal_repeat1] = STATE(2379),
    [sym__simple_heredoc_body] = ACTIONS(977),
    [sym__heredoc_body_beginning] = ACTIONS(977),
    [sym_file_descriptor] = ACTIONS(977),
    [sym_variable_name] = ACTIONS(977),
    [anon_sym_SEMI] = ACTIONS(979),
    [anon_sym_fi] = ACTIONS(979),
    [anon_sym_elif] = ACTIONS(979),
    [anon_sym_else] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(979),
    [anon_sym_SEMI_SEMI] = ACTIONS(977),
    [anon_sym_PIPE_AMP] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(977),
    [anon_sym_AMP_GT] = ACTIONS(979),
    [anon_sym_AMP_GT_GT] = ACTIONS(977),
    [anon_sym_LT_AMP] = ACTIONS(977),
    [anon_sym_GT_AMP] = ACTIONS(977),
    [anon_sym_LT_LT] = ACTIONS(979),
    [anon_sym_LT_LT_DASH] = ACTIONS(977),
    [anon_sym_LT_LT_LT] = ACTIONS(977),
    [anon_sym_DOLLAR] = ACTIONS(979),
    [sym__special_character] = ACTIONS(5181),
    [anon_sym_DQUOTE] = ACTIONS(977),
    [sym_raw_string] = ACTIONS(977),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(977),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(977),
    [anon_sym_BQUOTE] = ACTIONS(977),
    [anon_sym_LT_LPAREN] = ACTIONS(977),
    [anon_sym_GT_LPAREN] = ACTIONS(977),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(979),
    [sym_word] = ACTIONS(979),
    [anon_sym_LF] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
  },
  [1657] = {
    [sym_string] = STATE(2381),
    [anon_sym_DASH] = ACTIONS(5183),
    [anon_sym_DOLLAR] = ACTIONS(5183),
    [anon_sym_DQUOTE] = ACTIONS(3435),
    [sym_raw_string] = ACTIONS(5185),
    [anon_sym_POUND] = ACTIONS(5183),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5187),
    [anon_sym_STAR] = ACTIONS(5189),
    [anon_sym_AT] = ACTIONS(5189),
    [anon_sym_QMARK] = ACTIONS(5189),
    [anon_sym_0] = ACTIONS(5187),
    [anon_sym__] = ACTIONS(5187),
  },
  [1658] = {
    [aux_sym_concatenation_repeat1] = STATE(2384),
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(5191),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_fi] = ACTIONS(339),
    [anon_sym_elif] = ACTIONS(339),
    [anon_sym_else] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(339),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [1659] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(2387),
    [anon_sym_DOLLAR] = ACTIONS(5193),
    [anon_sym_DQUOTE] = ACTIONS(5195),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [1660] = {
    [aux_sym_concatenation_repeat1] = STATE(2384),
    [sym__simple_heredoc_body] = ACTIONS(997),
    [sym__heredoc_body_beginning] = ACTIONS(997),
    [sym_file_descriptor] = ACTIONS(997),
    [sym__concat] = ACTIONS(5191),
    [anon_sym_SEMI] = ACTIONS(999),
    [anon_sym_fi] = ACTIONS(999),
    [anon_sym_elif] = ACTIONS(999),
    [anon_sym_else] = ACTIONS(999),
    [anon_sym_PIPE] = ACTIONS(999),
    [anon_sym_SEMI_SEMI] = ACTIONS(997),
    [anon_sym_PIPE_AMP] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_LT] = ACTIONS(999),
    [anon_sym_GT] = ACTIONS(999),
    [anon_sym_GT_GT] = ACTIONS(997),
    [anon_sym_AMP_GT] = ACTIONS(999),
    [anon_sym_AMP_GT_GT] = ACTIONS(997),
    [anon_sym_LT_AMP] = ACTIONS(997),
    [anon_sym_GT_AMP] = ACTIONS(997),
    [anon_sym_LT_LT] = ACTIONS(999),
    [anon_sym_LT_LT_DASH] = ACTIONS(997),
    [anon_sym_LT_LT_LT] = ACTIONS(997),
    [anon_sym_DOLLAR] = ACTIONS(999),
    [sym__special_character] = ACTIONS(997),
    [anon_sym_DQUOTE] = ACTIONS(997),
    [sym_raw_string] = ACTIONS(997),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(997),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(997),
    [anon_sym_BQUOTE] = ACTIONS(997),
    [anon_sym_LT_LPAREN] = ACTIONS(997),
    [anon_sym_GT_LPAREN] = ACTIONS(997),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(999),
    [sym_word] = ACTIONS(999),
    [anon_sym_LF] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(999),
  },
  [1661] = {
    [sym_subscript] = STATE(2391),
    [sym_variable_name] = ACTIONS(5197),
    [anon_sym_BANG] = ACTIONS(5199),
    [anon_sym_DASH] = ACTIONS(5201),
    [anon_sym_DOLLAR] = ACTIONS(5201),
    [anon_sym_POUND] = ACTIONS(5199),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5203),
    [anon_sym_STAR] = ACTIONS(5205),
    [anon_sym_AT] = ACTIONS(5205),
    [anon_sym_QMARK] = ACTIONS(5205),
    [anon_sym_0] = ACTIONS(5203),
    [anon_sym__] = ACTIONS(5203),
  },
  [1662] = {
    [sym__statements] = STATE(2392),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(2393),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [1663] = {
    [sym__statements] = STATE(2394),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [1664] = {
    [sym__statements] = STATE(2395),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [1665] = {
    [sym_concatenation] = STATE(2396),
    [sym_string] = STATE(1660),
    [sym_simple_expansion] = STATE(1660),
    [sym_string_expansion] = STATE(1660),
    [sym_expansion] = STATE(1660),
    [sym_command_substitution] = STATE(1660),
    [sym_process_substitution] = STATE(1660),
    [aux_sym_unset_command_repeat1] = STATE(2396),
    [aux_sym__literal_repeat1] = STATE(1666),
    [sym__simple_heredoc_body] = ACTIONS(1011),
    [sym__heredoc_body_beginning] = ACTIONS(1011),
    [sym_file_descriptor] = ACTIONS(1011),
    [anon_sym_SEMI] = ACTIONS(1013),
    [anon_sym_fi] = ACTIONS(1013),
    [anon_sym_elif] = ACTIONS(1013),
    [anon_sym_else] = ACTIONS(1013),
    [anon_sym_PIPE] = ACTIONS(1013),
    [anon_sym_SEMI_SEMI] = ACTIONS(1011),
    [anon_sym_PIPE_AMP] = ACTIONS(1011),
    [anon_sym_AMP_AMP] = ACTIONS(1011),
    [anon_sym_PIPE_PIPE] = ACTIONS(1011),
    [anon_sym_LT] = ACTIONS(1013),
    [anon_sym_GT] = ACTIONS(1013),
    [anon_sym_GT_GT] = ACTIONS(1011),
    [anon_sym_AMP_GT] = ACTIONS(1013),
    [anon_sym_AMP_GT_GT] = ACTIONS(1011),
    [anon_sym_LT_AMP] = ACTIONS(1011),
    [anon_sym_GT_AMP] = ACTIONS(1011),
    [anon_sym_LT_LT] = ACTIONS(1013),
    [anon_sym_LT_LT_DASH] = ACTIONS(1011),
    [anon_sym_LT_LT_LT] = ACTIONS(1011),
    [anon_sym_DOLLAR] = ACTIONS(3431),
    [sym__special_character] = ACTIONS(3433),
    [anon_sym_DQUOTE] = ACTIONS(3435),
    [sym_raw_string] = ACTIONS(3437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3439),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3441),
    [anon_sym_BQUOTE] = ACTIONS(3443),
    [anon_sym_LT_LPAREN] = ACTIONS(3445),
    [anon_sym_GT_LPAREN] = ACTIONS(3445),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5207),
    [sym_word] = ACTIONS(3449),
    [anon_sym_LF] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(1013),
  },
  [1666] = {
    [aux_sym__literal_repeat1] = STATE(2398),
    [sym__simple_heredoc_body] = ACTIONS(1017),
    [sym__heredoc_body_beginning] = ACTIONS(1017),
    [sym_file_descriptor] = ACTIONS(1017),
    [anon_sym_SEMI] = ACTIONS(1019),
    [anon_sym_fi] = ACTIONS(1019),
    [anon_sym_elif] = ACTIONS(1019),
    [anon_sym_else] = ACTIONS(1019),
    [anon_sym_PIPE] = ACTIONS(1019),
    [anon_sym_SEMI_SEMI] = ACTIONS(1017),
    [anon_sym_PIPE_AMP] = ACTIONS(1017),
    [anon_sym_AMP_AMP] = ACTIONS(1017),
    [anon_sym_PIPE_PIPE] = ACTIONS(1017),
    [anon_sym_LT] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(1019),
    [anon_sym_GT_GT] = ACTIONS(1017),
    [anon_sym_AMP_GT] = ACTIONS(1019),
    [anon_sym_AMP_GT_GT] = ACTIONS(1017),
    [anon_sym_LT_AMP] = ACTIONS(1017),
    [anon_sym_GT_AMP] = ACTIONS(1017),
    [anon_sym_LT_LT] = ACTIONS(1019),
    [anon_sym_LT_LT_DASH] = ACTIONS(1017),
    [anon_sym_LT_LT_LT] = ACTIONS(1017),
    [anon_sym_DOLLAR] = ACTIONS(1019),
    [sym__special_character] = ACTIONS(5209),
    [anon_sym_DQUOTE] = ACTIONS(1017),
    [sym_raw_string] = ACTIONS(1017),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1017),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1017),
    [anon_sym_BQUOTE] = ACTIONS(1017),
    [anon_sym_LT_LPAREN] = ACTIONS(1017),
    [anon_sym_GT_LPAREN] = ACTIONS(1017),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1019),
    [sym_word] = ACTIONS(1019),
    [anon_sym_LF] = ACTIONS(1017),
    [anon_sym_AMP] = ACTIONS(1019),
  },
  [1667] = {
    [sym__simple_heredoc_body] = ACTIONS(1057),
    [sym__heredoc_body_beginning] = ACTIONS(1057),
    [sym_file_descriptor] = ACTIONS(1057),
    [sym__concat] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_fi] = ACTIONS(1059),
    [anon_sym_elif] = ACTIONS(1059),
    [anon_sym_else] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_PIPE_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_EQ_TILDE] = ACTIONS(1059),
    [anon_sym_EQ_EQ] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_AMP] = ACTIONS(1057),
    [anon_sym_GT_AMP] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_LT] = ACTIONS(1057),
    [anon_sym_DOLLAR] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [sym_raw_string] = ACTIONS(1057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1057),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1057),
    [anon_sym_BQUOTE] = ACTIONS(1057),
    [anon_sym_LT_LPAREN] = ACTIONS(1057),
    [anon_sym_GT_LPAREN] = ACTIONS(1057),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [1668] = {
    [sym__simple_heredoc_body] = ACTIONS(1061),
    [sym__heredoc_body_beginning] = ACTIONS(1061),
    [sym_file_descriptor] = ACTIONS(1061),
    [sym__concat] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(1063),
    [anon_sym_fi] = ACTIONS(1063),
    [anon_sym_elif] = ACTIONS(1063),
    [anon_sym_else] = ACTIONS(1063),
    [anon_sym_PIPE] = ACTIONS(1063),
    [anon_sym_SEMI_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE_AMP] = ACTIONS(1061),
    [anon_sym_AMP_AMP] = ACTIONS(1061),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_EQ_TILDE] = ACTIONS(1063),
    [anon_sym_EQ_EQ] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1063),
    [anon_sym_GT_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT_GT] = ACTIONS(1061),
    [anon_sym_LT_AMP] = ACTIONS(1061),
    [anon_sym_GT_AMP] = ACTIONS(1061),
    [anon_sym_LT_LT] = ACTIONS(1063),
    [anon_sym_LT_LT_DASH] = ACTIONS(1061),
    [anon_sym_LT_LT_LT] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1061),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1061),
    [anon_sym_LT_LPAREN] = ACTIONS(1061),
    [anon_sym_GT_LPAREN] = ACTIONS(1061),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1063),
    [anon_sym_LF] = ACTIONS(1061),
    [anon_sym_AMP] = ACTIONS(1063),
  },
  [1669] = {
    [sym__simple_heredoc_body] = ACTIONS(1065),
    [sym__heredoc_body_beginning] = ACTIONS(1065),
    [sym_file_descriptor] = ACTIONS(1065),
    [sym__concat] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_fi] = ACTIONS(1067),
    [anon_sym_elif] = ACTIONS(1067),
    [anon_sym_else] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1067),
    [anon_sym_SEMI_SEMI] = ACTIONS(1065),
    [anon_sym_PIPE_AMP] = ACTIONS(1065),
    [anon_sym_AMP_AMP] = ACTIONS(1065),
    [anon_sym_PIPE_PIPE] = ACTIONS(1065),
    [anon_sym_EQ_TILDE] = ACTIONS(1067),
    [anon_sym_EQ_EQ] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_GT] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT] = ACTIONS(1067),
    [anon_sym_AMP_GT_GT] = ACTIONS(1065),
    [anon_sym_LT_AMP] = ACTIONS(1065),
    [anon_sym_GT_AMP] = ACTIONS(1065),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_LT_LT_DASH] = ACTIONS(1065),
    [anon_sym_LT_LT_LT] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1067),
    [sym__special_character] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LT_LPAREN] = ACTIONS(1065),
    [anon_sym_GT_LPAREN] = ACTIONS(1065),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1067),
    [anon_sym_LF] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1067),
  },
  [1670] = {
    [sym_string] = STATE(2399),
    [sym_simple_expansion] = STATE(2399),
    [sym_string_expansion] = STATE(2399),
    [sym_expansion] = STATE(2399),
    [sym_command_substitution] = STATE(2399),
    [sym_process_substitution] = STATE(2399),
    [anon_sym_DOLLAR] = ACTIONS(1818),
    [sym__special_character] = ACTIONS(5211),
    [anon_sym_DQUOTE] = ACTIONS(1822),
    [sym_raw_string] = ACTIONS(5211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1826),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1828),
    [anon_sym_BQUOTE] = ACTIONS(1830),
    [anon_sym_LT_LPAREN] = ACTIONS(1832),
    [anon_sym_GT_LPAREN] = ACTIONS(1832),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5211),
  },
  [1671] = {
    [aux_sym_concatenation_repeat1] = STATE(2401),
    [sym__simple_heredoc_body] = ACTIONS(1071),
    [sym__heredoc_body_beginning] = ACTIONS(1071),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(5213),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_fi] = ACTIONS(1075),
    [anon_sym_elif] = ACTIONS(1075),
    [anon_sym_else] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_EQ_TILDE] = ACTIONS(1075),
    [anon_sym_EQ_EQ] = ACTIONS(1075),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [sym__special_character] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1075),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1075),
  },
  [1672] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(5215),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [1673] = {
    [sym__simple_heredoc_body] = ACTIONS(1089),
    [sym__heredoc_body_beginning] = ACTIONS(1089),
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(1089),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_fi] = ACTIONS(1091),
    [anon_sym_elif] = ACTIONS(1091),
    [anon_sym_else] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1089),
    [anon_sym_PIPE_AMP] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_AMP] = ACTIONS(1089),
    [anon_sym_GT_AMP] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1089),
    [anon_sym_LT_LT_LT] = ACTIONS(1089),
    [anon_sym_DOLLAR] = ACTIONS(1091),
    [sym__special_character] = ACTIONS(1089),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1089),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1089),
    [anon_sym_GT_LPAREN] = ACTIONS(1089),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [1674] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(627),
    [anon_sym_DOLLAR] = ACTIONS(5217),
    [anon_sym_DQUOTE] = ACTIONS(5215),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [1675] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(5219),
    [sym_comment] = ACTIONS(57),
  },
  [1676] = {
    [sym_subscript] = STATE(2407),
    [sym_variable_name] = ACTIONS(5221),
    [anon_sym_DASH] = ACTIONS(5223),
    [anon_sym_DOLLAR] = ACTIONS(5223),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5225),
    [anon_sym_STAR] = ACTIONS(5227),
    [anon_sym_AT] = ACTIONS(5227),
    [anon_sym_QMARK] = ACTIONS(5227),
    [anon_sym_0] = ACTIONS(5225),
    [anon_sym__] = ACTIONS(5225),
  },
  [1677] = {
    [sym_concatenation] = STATE(2410),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2410),
    [anon_sym_RBRACE] = ACTIONS(5229),
    [anon_sym_EQ] = ACTIONS(5231),
    [anon_sym_DASH] = ACTIONS(5231),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5233),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(5235),
    [anon_sym_COLON] = ACTIONS(5231),
    [anon_sym_COLON_QMARK] = ACTIONS(5231),
    [anon_sym_COLON_DASH] = ACTIONS(5231),
    [anon_sym_PERCENT] = ACTIONS(5231),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1678] = {
    [sym_concatenation] = STATE(2413),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2413),
    [anon_sym_RBRACE] = ACTIONS(5237),
    [anon_sym_EQ] = ACTIONS(5239),
    [anon_sym_DASH] = ACTIONS(5239),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5241),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(5243),
    [anon_sym_COLON] = ACTIONS(5239),
    [anon_sym_COLON_QMARK] = ACTIONS(5239),
    [anon_sym_COLON_DASH] = ACTIONS(5239),
    [anon_sym_PERCENT] = ACTIONS(5239),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1679] = {
    [anon_sym_RPAREN] = ACTIONS(5245),
    [sym_comment] = ACTIONS(57),
  },
  [1680] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(5245),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [1681] = {
    [anon_sym_BQUOTE] = ACTIONS(5245),
    [sym_comment] = ACTIONS(57),
  },
  [1682] = {
    [anon_sym_RPAREN] = ACTIONS(5247),
    [sym_comment] = ACTIONS(57),
  },
  [1683] = {
    [sym__simple_heredoc_body] = ACTIONS(5249),
    [sym__heredoc_body_beginning] = ACTIONS(5249),
    [sym_file_descriptor] = ACTIONS(5249),
    [ts_builtin_sym_end] = ACTIONS(5249),
    [anon_sym_SEMI] = ACTIONS(5251),
    [anon_sym_done] = ACTIONS(5249),
    [anon_sym_fi] = ACTIONS(5249),
    [anon_sym_elif] = ACTIONS(5249),
    [anon_sym_else] = ACTIONS(5249),
    [anon_sym_esac] = ACTIONS(5249),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_RPAREN] = ACTIONS(5249),
    [anon_sym_SEMI_SEMI] = ACTIONS(5249),
    [anon_sym_PIPE_AMP] = ACTIONS(5249),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5249),
    [anon_sym_AMP_GT] = ACTIONS(5251),
    [anon_sym_AMP_GT_GT] = ACTIONS(5249),
    [anon_sym_LT_AMP] = ACTIONS(5249),
    [anon_sym_GT_AMP] = ACTIONS(5249),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_LT_LT_DASH] = ACTIONS(5249),
    [anon_sym_LT_LT_LT] = ACTIONS(5249),
    [anon_sym_BQUOTE] = ACTIONS(5249),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5249),
    [anon_sym_AMP] = ACTIONS(5251),
  },
  [1684] = {
    [anon_sym_fi] = ACTIONS(5253),
    [sym_comment] = ACTIONS(57),
  },
  [1685] = {
    [sym_elif_clause] = STATE(1700),
    [sym_else_clause] = STATE(2417),
    [aux_sym_if_statement_repeat1] = STATE(1700),
    [anon_sym_fi] = ACTIONS(5253),
    [anon_sym_elif] = ACTIONS(3477),
    [anon_sym_else] = ACTIONS(3479),
    [sym_comment] = ACTIONS(57),
  },
  [1686] = {
    [anon_sym_LT] = ACTIONS(5255),
    [anon_sym_GT] = ACTIONS(5255),
    [anon_sym_GT_GT] = ACTIONS(5257),
    [anon_sym_AMP_GT] = ACTIONS(5255),
    [anon_sym_AMP_GT_GT] = ACTIONS(5257),
    [anon_sym_LT_AMP] = ACTIONS(5257),
    [anon_sym_GT_AMP] = ACTIONS(5257),
    [sym_comment] = ACTIONS(57),
  },
  [1687] = {
    [sym_file_descriptor] = ACTIONS(1237),
    [sym_variable_name] = ACTIONS(1237),
    [anon_sym_for] = ACTIONS(1241),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1237),
    [anon_sym_while] = ACTIONS(1241),
    [anon_sym_if] = ACTIONS(1241),
    [anon_sym_fi] = ACTIONS(4996),
    [anon_sym_elif] = ACTIONS(4996),
    [anon_sym_else] = ACTIONS(4996),
    [anon_sym_case] = ACTIONS(1241),
    [anon_sym_function] = ACTIONS(1241),
    [anon_sym_LPAREN] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1237),
    [anon_sym_BANG] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(1241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1237),
    [anon_sym_declare] = ACTIONS(1241),
    [anon_sym_typeset] = ACTIONS(1241),
    [anon_sym_export] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_local] = ACTIONS(1241),
    [anon_sym_unset] = ACTIONS(1241),
    [anon_sym_unsetenv] = ACTIONS(1241),
    [anon_sym_LT] = ACTIONS(1241),
    [anon_sym_GT] = ACTIONS(1241),
    [anon_sym_GT_GT] = ACTIONS(1237),
    [anon_sym_AMP_GT] = ACTIONS(1241),
    [anon_sym_AMP_GT_GT] = ACTIONS(1237),
    [anon_sym_LT_AMP] = ACTIONS(1237),
    [anon_sym_GT_AMP] = ACTIONS(1237),
    [anon_sym_DOLLAR] = ACTIONS(1241),
    [sym__special_character] = ACTIONS(1241),
    [anon_sym_DQUOTE] = ACTIONS(1237),
    [sym_raw_string] = ACTIONS(1237),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1237),
    [anon_sym_BQUOTE] = ACTIONS(1237),
    [anon_sym_LT_LPAREN] = ACTIONS(1237),
    [anon_sym_GT_LPAREN] = ACTIONS(1237),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1241),
  },
  [1688] = {
    [sym_redirected_statement] = STATE(2419),
    [sym_for_statement] = STATE(2419),
    [sym_c_style_for_statement] = STATE(2419),
    [sym_while_statement] = STATE(2419),
    [sym_if_statement] = STATE(2419),
    [sym_case_statement] = STATE(2419),
    [sym_function_definition] = STATE(2419),
    [sym_compound_statement] = STATE(2419),
    [sym_subshell] = STATE(2419),
    [sym_pipeline] = STATE(2419),
    [sym_list] = STATE(2419),
    [sym_negated_command] = STATE(2419),
    [sym_test_command] = STATE(2419),
    [sym_declaration_command] = STATE(2419),
    [sym_unset_command] = STATE(2419),
    [sym_command] = STATE(2419),
    [sym_command_name] = STATE(980),
    [sym_variable_assignment] = STATE(2420),
    [sym_subscript] = STATE(982),
    [sym_file_redirect] = STATE(986),
    [sym_concatenation] = STATE(983),
    [sym_string] = STATE(971),
    [sym_simple_expansion] = STATE(971),
    [sym_string_expansion] = STATE(971),
    [sym_expansion] = STATE(971),
    [sym_command_substitution] = STATE(971),
    [sym_process_substitution] = STATE(971),
    [aux_sym_command_repeat1] = STATE(986),
    [aux_sym__literal_repeat1] = STATE(987),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(1804),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1812),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(1814),
    [anon_sym_typeset] = ACTIONS(1814),
    [anon_sym_export] = ACTIONS(1814),
    [anon_sym_readonly] = ACTIONS(1814),
    [anon_sym_local] = ACTIONS(1814),
    [anon_sym_unset] = ACTIONS(1816),
    [anon_sym_unsetenv] = ACTIONS(1816),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(1818),
    [sym__special_character] = ACTIONS(1820),
    [anon_sym_DQUOTE] = ACTIONS(1822),
    [sym_raw_string] = ACTIONS(1824),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1826),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1828),
    [anon_sym_BQUOTE] = ACTIONS(1830),
    [anon_sym_LT_LPAREN] = ACTIONS(1832),
    [anon_sym_GT_LPAREN] = ACTIONS(1832),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1834),
  },
  [1689] = {
    [sym_redirected_statement] = STATE(2421),
    [sym_for_statement] = STATE(2421),
    [sym_c_style_for_statement] = STATE(2421),
    [sym_while_statement] = STATE(2421),
    [sym_if_statement] = STATE(2421),
    [sym_case_statement] = STATE(2421),
    [sym_function_definition] = STATE(2421),
    [sym_compound_statement] = STATE(2421),
    [sym_subshell] = STATE(2421),
    [sym_pipeline] = STATE(2421),
    [sym_list] = STATE(2421),
    [sym_negated_command] = STATE(2421),
    [sym_test_command] = STATE(2421),
    [sym_declaration_command] = STATE(2421),
    [sym_unset_command] = STATE(2421),
    [sym_command] = STATE(2421),
    [sym_command_name] = STATE(980),
    [sym_variable_assignment] = STATE(2422),
    [sym_subscript] = STATE(982),
    [sym_file_redirect] = STATE(986),
    [sym_concatenation] = STATE(983),
    [sym_string] = STATE(971),
    [sym_simple_expansion] = STATE(971),
    [sym_string_expansion] = STATE(971),
    [sym_expansion] = STATE(971),
    [sym_command_substitution] = STATE(971),
    [sym_process_substitution] = STATE(971),
    [aux_sym_command_repeat1] = STATE(986),
    [aux_sym__literal_repeat1] = STATE(987),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(1804),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1812),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(1814),
    [anon_sym_typeset] = ACTIONS(1814),
    [anon_sym_export] = ACTIONS(1814),
    [anon_sym_readonly] = ACTIONS(1814),
    [anon_sym_local] = ACTIONS(1814),
    [anon_sym_unset] = ACTIONS(1816),
    [anon_sym_unsetenv] = ACTIONS(1816),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(1818),
    [sym__special_character] = ACTIONS(1820),
    [anon_sym_DQUOTE] = ACTIONS(1822),
    [sym_raw_string] = ACTIONS(1824),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1826),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1828),
    [anon_sym_BQUOTE] = ACTIONS(1830),
    [anon_sym_LT_LPAREN] = ACTIONS(1832),
    [anon_sym_GT_LPAREN] = ACTIONS(1832),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1834),
  },
  [1690] = {
    [sym_concatenation] = STATE(696),
    [sym_string] = STATE(2424),
    [sym_simple_expansion] = STATE(2424),
    [sym_string_expansion] = STATE(2424),
    [sym_expansion] = STATE(2424),
    [sym_command_substitution] = STATE(2424),
    [sym_process_substitution] = STATE(2424),
    [aux_sym__literal_repeat1] = STATE(2425),
    [anon_sym_DOLLAR] = ACTIONS(4998),
    [sym__special_character] = ACTIONS(5259),
    [anon_sym_DQUOTE] = ACTIONS(5002),
    [sym_raw_string] = ACTIONS(5261),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5006),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5008),
    [anon_sym_BQUOTE] = ACTIONS(5010),
    [anon_sym_LT_LPAREN] = ACTIONS(5012),
    [anon_sym_GT_LPAREN] = ACTIONS(5012),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5261),
  },
  [1691] = {
    [sym_concatenation] = STATE(700),
    [sym_string] = STATE(2426),
    [sym_simple_expansion] = STATE(2426),
    [sym_string_expansion] = STATE(2426),
    [sym_expansion] = STATE(2426),
    [sym_command_substitution] = STATE(2426),
    [sym_process_substitution] = STATE(2426),
    [aux_sym__literal_repeat1] = STATE(2427),
    [anon_sym_DOLLAR] = ACTIONS(4998),
    [sym__special_character] = ACTIONS(5259),
    [anon_sym_DQUOTE] = ACTIONS(5002),
    [sym_raw_string] = ACTIONS(5263),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5006),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5008),
    [anon_sym_BQUOTE] = ACTIONS(5010),
    [anon_sym_LT_LPAREN] = ACTIONS(5012),
    [anon_sym_GT_LPAREN] = ACTIONS(5012),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5263),
  },
  [1692] = {
    [anon_sym_SEMI] = ACTIONS(5265),
    [anon_sym_fi] = ACTIONS(1239),
    [anon_sym_elif] = ACTIONS(1239),
    [anon_sym_else] = ACTIONS(1239),
    [anon_sym_SEMI_SEMI] = ACTIONS(5267),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5267),
    [anon_sym_AMP] = ACTIONS(5267),
  },
  [1693] = {
    [sym_file_redirect] = STATE(2429),
    [sym_heredoc_redirect] = STATE(2429),
    [sym_herestring_redirect] = STATE(2429),
    [aux_sym_redirected_statement_repeat1] = STATE(2429),
    [sym__simple_heredoc_body] = ACTIONS(1255),
    [sym__heredoc_body_beginning] = ACTIONS(1255),
    [sym_file_descriptor] = ACTIONS(3481),
    [anon_sym_SEMI] = ACTIONS(1257),
    [anon_sym_fi] = ACTIONS(1255),
    [anon_sym_elif] = ACTIONS(1255),
    [anon_sym_else] = ACTIONS(1255),
    [anon_sym_PIPE] = ACTIONS(1257),
    [anon_sym_SEMI_SEMI] = ACTIONS(1255),
    [anon_sym_PIPE_AMP] = ACTIONS(1255),
    [anon_sym_AMP_AMP] = ACTIONS(1255),
    [anon_sym_PIPE_PIPE] = ACTIONS(1255),
    [anon_sym_LT] = ACTIONS(3493),
    [anon_sym_GT] = ACTIONS(3493),
    [anon_sym_GT_GT] = ACTIONS(3495),
    [anon_sym_AMP_GT] = ACTIONS(3493),
    [anon_sym_AMP_GT_GT] = ACTIONS(3495),
    [anon_sym_LT_AMP] = ACTIONS(3495),
    [anon_sym_GT_AMP] = ACTIONS(3495),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(3497),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1257),
  },
  [1694] = {
    [sym_concatenation] = STATE(2430),
    [sym_string] = STATE(2431),
    [sym_simple_expansion] = STATE(2431),
    [sym_string_expansion] = STATE(2431),
    [sym_expansion] = STATE(2431),
    [sym_command_substitution] = STATE(2431),
    [sym_process_substitution] = STATE(2431),
    [aux_sym__literal_repeat1] = STATE(2432),
    [sym_regex] = ACTIONS(5269),
    [anon_sym_DOLLAR] = ACTIONS(1818),
    [sym__special_character] = ACTIONS(3501),
    [anon_sym_DQUOTE] = ACTIONS(1822),
    [sym_raw_string] = ACTIONS(5271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1826),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1828),
    [anon_sym_BQUOTE] = ACTIONS(1830),
    [anon_sym_LT_LPAREN] = ACTIONS(1832),
    [anon_sym_GT_LPAREN] = ACTIONS(1832),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5271),
  },
  [1695] = {
    [aux_sym_concatenation_repeat1] = STATE(1671),
    [sym__simple_heredoc_body] = ACTIONS(1263),
    [sym__heredoc_body_beginning] = ACTIONS(1263),
    [sym_file_descriptor] = ACTIONS(1263),
    [sym__concat] = ACTIONS(3459),
    [anon_sym_SEMI] = ACTIONS(1265),
    [anon_sym_fi] = ACTIONS(1265),
    [anon_sym_elif] = ACTIONS(1265),
    [anon_sym_else] = ACTIONS(1265),
    [anon_sym_PIPE] = ACTIONS(1265),
    [anon_sym_SEMI_SEMI] = ACTIONS(1263),
    [anon_sym_PIPE_AMP] = ACTIONS(1263),
    [anon_sym_AMP_AMP] = ACTIONS(1263),
    [anon_sym_PIPE_PIPE] = ACTIONS(1263),
    [anon_sym_EQ_TILDE] = ACTIONS(1265),
    [anon_sym_EQ_EQ] = ACTIONS(1265),
    [anon_sym_LT] = ACTIONS(1265),
    [anon_sym_GT] = ACTIONS(1265),
    [anon_sym_GT_GT] = ACTIONS(1263),
    [anon_sym_AMP_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT_GT] = ACTIONS(1263),
    [anon_sym_LT_AMP] = ACTIONS(1263),
    [anon_sym_GT_AMP] = ACTIONS(1263),
    [anon_sym_LT_LT] = ACTIONS(1265),
    [anon_sym_LT_LT_DASH] = ACTIONS(1263),
    [anon_sym_LT_LT_LT] = ACTIONS(1263),
    [anon_sym_DOLLAR] = ACTIONS(1265),
    [sym__special_character] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(1263),
    [sym_raw_string] = ACTIONS(1263),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1263),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1263),
    [anon_sym_BQUOTE] = ACTIONS(1263),
    [anon_sym_LT_LPAREN] = ACTIONS(1263),
    [anon_sym_GT_LPAREN] = ACTIONS(1263),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1265),
    [anon_sym_LF] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1265),
  },
  [1696] = {
    [sym_concatenation] = STATE(2433),
    [sym_string] = STATE(1695),
    [sym_simple_expansion] = STATE(1695),
    [sym_string_expansion] = STATE(1695),
    [sym_expansion] = STATE(1695),
    [sym_command_substitution] = STATE(1695),
    [sym_process_substitution] = STATE(1695),
    [aux_sym_command_repeat2] = STATE(2433),
    [aux_sym__literal_repeat1] = STATE(1697),
    [sym__simple_heredoc_body] = ACTIONS(1267),
    [sym__heredoc_body_beginning] = ACTIONS(1267),
    [sym_file_descriptor] = ACTIONS(1267),
    [anon_sym_SEMI] = ACTIONS(1269),
    [anon_sym_fi] = ACTIONS(1269),
    [anon_sym_elif] = ACTIONS(1269),
    [anon_sym_else] = ACTIONS(1269),
    [anon_sym_PIPE] = ACTIONS(1269),
    [anon_sym_SEMI_SEMI] = ACTIONS(1267),
    [anon_sym_PIPE_AMP] = ACTIONS(1267),
    [anon_sym_AMP_AMP] = ACTIONS(1267),
    [anon_sym_PIPE_PIPE] = ACTIONS(1267),
    [anon_sym_EQ_TILDE] = ACTIONS(3499),
    [anon_sym_EQ_EQ] = ACTIONS(3499),
    [anon_sym_LT] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1269),
    [anon_sym_GT_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT_GT] = ACTIONS(1267),
    [anon_sym_LT_AMP] = ACTIONS(1267),
    [anon_sym_GT_AMP] = ACTIONS(1267),
    [anon_sym_LT_LT] = ACTIONS(1269),
    [anon_sym_LT_LT_DASH] = ACTIONS(1267),
    [anon_sym_LT_LT_LT] = ACTIONS(1267),
    [anon_sym_DOLLAR] = ACTIONS(1818),
    [sym__special_character] = ACTIONS(3501),
    [anon_sym_DQUOTE] = ACTIONS(1822),
    [sym_raw_string] = ACTIONS(3503),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1826),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1828),
    [anon_sym_BQUOTE] = ACTIONS(1830),
    [anon_sym_LT_LPAREN] = ACTIONS(1832),
    [anon_sym_GT_LPAREN] = ACTIONS(1832),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3505),
    [anon_sym_LF] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(1269),
  },
  [1697] = {
    [aux_sym__literal_repeat1] = STATE(1703),
    [sym__simple_heredoc_body] = ACTIONS(1271),
    [sym__heredoc_body_beginning] = ACTIONS(1271),
    [sym_file_descriptor] = ACTIONS(1271),
    [anon_sym_SEMI] = ACTIONS(1273),
    [anon_sym_fi] = ACTIONS(1273),
    [anon_sym_elif] = ACTIONS(1273),
    [anon_sym_else] = ACTIONS(1273),
    [anon_sym_PIPE] = ACTIONS(1273),
    [anon_sym_SEMI_SEMI] = ACTIONS(1271),
    [anon_sym_PIPE_AMP] = ACTIONS(1271),
    [anon_sym_AMP_AMP] = ACTIONS(1271),
    [anon_sym_PIPE_PIPE] = ACTIONS(1271),
    [anon_sym_EQ_TILDE] = ACTIONS(1273),
    [anon_sym_EQ_EQ] = ACTIONS(1273),
    [anon_sym_LT] = ACTIONS(1273),
    [anon_sym_GT] = ACTIONS(1273),
    [anon_sym_GT_GT] = ACTIONS(1271),
    [anon_sym_AMP_GT] = ACTIONS(1273),
    [anon_sym_AMP_GT_GT] = ACTIONS(1271),
    [anon_sym_LT_AMP] = ACTIONS(1271),
    [anon_sym_GT_AMP] = ACTIONS(1271),
    [anon_sym_LT_LT] = ACTIONS(1273),
    [anon_sym_LT_LT_DASH] = ACTIONS(1271),
    [anon_sym_LT_LT_LT] = ACTIONS(1271),
    [anon_sym_DOLLAR] = ACTIONS(1273),
    [sym__special_character] = ACTIONS(3507),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [sym_raw_string] = ACTIONS(1271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1271),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1271),
    [anon_sym_BQUOTE] = ACTIONS(1271),
    [anon_sym_LT_LPAREN] = ACTIONS(1271),
    [anon_sym_GT_LPAREN] = ACTIONS(1271),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1273),
    [anon_sym_LF] = ACTIONS(1271),
    [anon_sym_AMP] = ACTIONS(1273),
  },
  [1698] = {
    [sym_file_redirect] = STATE(1693),
    [sym_heredoc_redirect] = STATE(1693),
    [sym_heredoc_body] = STATE(2435),
    [sym_herestring_redirect] = STATE(1693),
    [aux_sym_redirected_statement_repeat1] = STATE(1693),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(3481),
    [anon_sym_SEMI] = ACTIONS(5273),
    [anon_sym_fi] = ACTIONS(1239),
    [anon_sym_elif] = ACTIONS(1239),
    [anon_sym_else] = ACTIONS(1239),
    [anon_sym_PIPE] = ACTIONS(3485),
    [anon_sym_SEMI_SEMI] = ACTIONS(5275),
    [anon_sym_PIPE_AMP] = ACTIONS(3489),
    [anon_sym_AMP_AMP] = ACTIONS(3491),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3493),
    [anon_sym_GT] = ACTIONS(3493),
    [anon_sym_GT_GT] = ACTIONS(3495),
    [anon_sym_AMP_GT] = ACTIONS(3493),
    [anon_sym_AMP_GT_GT] = ACTIONS(3495),
    [anon_sym_LT_AMP] = ACTIONS(3495),
    [anon_sym_GT_AMP] = ACTIONS(3495),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(3497),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5275),
    [anon_sym_AMP] = ACTIONS(5273),
  },
  [1699] = {
    [sym_file_redirect] = STATE(1693),
    [sym_heredoc_redirect] = STATE(1693),
    [sym_heredoc_body] = STATE(2435),
    [sym_herestring_redirect] = STATE(1693),
    [aux_sym_redirected_statement_repeat1] = STATE(1693),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(5273),
    [anon_sym_fi] = ACTIONS(4996),
    [anon_sym_elif] = ACTIONS(4996),
    [anon_sym_else] = ACTIONS(4996),
    [anon_sym_PIPE] = ACTIONS(3485),
    [anon_sym_SEMI_SEMI] = ACTIONS(5275),
    [anon_sym_PIPE_AMP] = ACTIONS(3489),
    [anon_sym_AMP_AMP] = ACTIONS(3491),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(3497),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(5275),
    [anon_sym_AMP] = ACTIONS(5273),
  },
  [1700] = {
    [sym_elif_clause] = STATE(1700),
    [aux_sym_if_statement_repeat1] = STATE(1700),
    [anon_sym_fi] = ACTIONS(5277),
    [anon_sym_elif] = ACTIONS(5279),
    [anon_sym_else] = ACTIONS(5277),
    [sym_comment] = ACTIONS(57),
  },
  [1701] = {
    [sym_concatenation] = STATE(2436),
    [sym_string] = STATE(1695),
    [sym_simple_expansion] = STATE(1695),
    [sym_string_expansion] = STATE(1695),
    [sym_expansion] = STATE(1695),
    [sym_command_substitution] = STATE(1695),
    [sym_process_substitution] = STATE(1695),
    [aux_sym_command_repeat2] = STATE(2436),
    [aux_sym__literal_repeat1] = STATE(1697),
    [sym__simple_heredoc_body] = ACTIONS(1267),
    [sym__heredoc_body_beginning] = ACTIONS(1267),
    [sym_file_descriptor] = ACTIONS(1267),
    [anon_sym_SEMI] = ACTIONS(1269),
    [anon_sym_fi] = ACTIONS(1269),
    [anon_sym_elif] = ACTIONS(1269),
    [anon_sym_else] = ACTIONS(1269),
    [anon_sym_PIPE] = ACTIONS(1269),
    [anon_sym_SEMI_SEMI] = ACTIONS(1267),
    [anon_sym_PIPE_AMP] = ACTIONS(1267),
    [anon_sym_AMP_AMP] = ACTIONS(1267),
    [anon_sym_PIPE_PIPE] = ACTIONS(1267),
    [anon_sym_EQ_TILDE] = ACTIONS(3499),
    [anon_sym_EQ_EQ] = ACTIONS(3499),
    [anon_sym_LT] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1269),
    [anon_sym_GT_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT_GT] = ACTIONS(1267),
    [anon_sym_LT_AMP] = ACTIONS(1267),
    [anon_sym_GT_AMP] = ACTIONS(1267),
    [anon_sym_LT_LT] = ACTIONS(1269),
    [anon_sym_LT_LT_DASH] = ACTIONS(1267),
    [anon_sym_LT_LT_LT] = ACTIONS(1267),
    [anon_sym_DOLLAR] = ACTIONS(1818),
    [sym__special_character] = ACTIONS(3501),
    [anon_sym_DQUOTE] = ACTIONS(1822),
    [sym_raw_string] = ACTIONS(3503),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1826),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1828),
    [anon_sym_BQUOTE] = ACTIONS(1830),
    [anon_sym_LT_LPAREN] = ACTIONS(1832),
    [anon_sym_GT_LPAREN] = ACTIONS(1832),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3505),
    [anon_sym_LF] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(1269),
  },
  [1702] = {
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_fi] = ACTIONS(339),
    [anon_sym_elif] = ACTIONS(339),
    [anon_sym_else] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_EQ_TILDE] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [1703] = {
    [aux_sym__literal_repeat1] = STATE(1703),
    [sym__simple_heredoc_body] = ACTIONS(1373),
    [sym__heredoc_body_beginning] = ACTIONS(1373),
    [sym_file_descriptor] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_fi] = ACTIONS(1375),
    [anon_sym_elif] = ACTIONS(1375),
    [anon_sym_else] = ACTIONS(1375),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE_AMP] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_EQ_TILDE] = ACTIONS(1375),
    [anon_sym_EQ_EQ] = ACTIONS(1375),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_LT_LT_DASH] = ACTIONS(1373),
    [anon_sym_LT_LT_LT] = ACTIONS(1373),
    [anon_sym_DOLLAR] = ACTIONS(1375),
    [sym__special_character] = ACTIONS(5282),
    [anon_sym_DQUOTE] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1373),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [anon_sym_LT_LPAREN] = ACTIONS(1373),
    [anon_sym_GT_LPAREN] = ACTIONS(1373),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1375),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
  },
  [1704] = {
    [sym_string] = STATE(398),
    [anon_sym_in] = ACTIONS(4073),
    [anon_sym_SEMI] = ACTIONS(4073),
    [anon_sym_SEMI_SEMI] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(687),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [sym_raw_string] = ACTIONS(689),
    [anon_sym_POUND] = ACTIONS(687),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(691),
    [anon_sym_STAR] = ACTIONS(693),
    [anon_sym_AT] = ACTIONS(693),
    [anon_sym_QMARK] = ACTIONS(693),
    [anon_sym_0] = ACTIONS(691),
    [anon_sym__] = ACTIONS(691),
    [anon_sym_LF] = ACTIONS(4071),
    [anon_sym_AMP] = ACTIONS(4071),
  },
  [1705] = {
    [sym__concat] = ACTIONS(4111),
    [anon_sym_in] = ACTIONS(4111),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_SEMI_SEMI] = ACTIONS(4111),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4111),
    [anon_sym_AMP] = ACTIONS(4111),
  },
  [1706] = {
    [sym__simple_heredoc_body] = ACTIONS(5285),
    [sym__heredoc_body_beginning] = ACTIONS(5285),
    [sym_file_descriptor] = ACTIONS(5285),
    [ts_builtin_sym_end] = ACTIONS(5285),
    [anon_sym_SEMI] = ACTIONS(5287),
    [anon_sym_done] = ACTIONS(5285),
    [anon_sym_fi] = ACTIONS(5285),
    [anon_sym_elif] = ACTIONS(5285),
    [anon_sym_else] = ACTIONS(5285),
    [anon_sym_esac] = ACTIONS(5285),
    [anon_sym_PIPE] = ACTIONS(5287),
    [anon_sym_RPAREN] = ACTIONS(5285),
    [anon_sym_SEMI_SEMI] = ACTIONS(5285),
    [anon_sym_PIPE_AMP] = ACTIONS(5285),
    [anon_sym_AMP_AMP] = ACTIONS(5285),
    [anon_sym_PIPE_PIPE] = ACTIONS(5285),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_GT] = ACTIONS(5285),
    [anon_sym_AMP_GT] = ACTIONS(5287),
    [anon_sym_AMP_GT_GT] = ACTIONS(5285),
    [anon_sym_LT_AMP] = ACTIONS(5285),
    [anon_sym_GT_AMP] = ACTIONS(5285),
    [anon_sym_LT_LT] = ACTIONS(5287),
    [anon_sym_LT_LT_DASH] = ACTIONS(5285),
    [anon_sym_LT_LT_LT] = ACTIONS(5285),
    [anon_sym_BQUOTE] = ACTIONS(5285),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5285),
    [anon_sym_AMP] = ACTIONS(5287),
  },
  [1707] = {
    [aux_sym_concatenation_repeat1] = STATE(2437),
    [sym__concat] = ACTIONS(1518),
    [anon_sym_PIPE] = ACTIONS(335),
    [anon_sym_RPAREN] = ACTIONS(335),
    [sym__special_character] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
  },
  [1708] = {
    [aux_sym_case_item_repeat1] = STATE(2440),
    [aux_sym_concatenation_repeat1] = STATE(2437),
    [sym__concat] = ACTIONS(1518),
    [anon_sym_PIPE] = ACTIONS(5289),
    [anon_sym_RPAREN] = ACTIONS(5291),
    [sym_comment] = ACTIONS(57),
  },
  [1709] = {
    [anon_sym_esac] = ACTIONS(5293),
    [sym_comment] = ACTIONS(57),
  },
  [1710] = {
    [aux_sym_case_item_repeat1] = STATE(2440),
    [anon_sym_PIPE] = ACTIONS(5289),
    [anon_sym_RPAREN] = ACTIONS(5291),
    [sym_comment] = ACTIONS(57),
  },
  [1711] = {
    [sym_case_item] = STATE(2443),
    [sym_last_case_item] = STATE(2442),
    [sym_concatenation] = STATE(1710),
    [sym_string] = STATE(1708),
    [sym_simple_expansion] = STATE(1708),
    [sym_string_expansion] = STATE(1708),
    [sym_expansion] = STATE(1708),
    [sym_command_substitution] = STATE(1708),
    [sym_process_substitution] = STATE(1708),
    [aux_sym_case_statement_repeat1] = STATE(2443),
    [aux_sym__literal_repeat1] = STATE(1712),
    [anon_sym_DOLLAR] = ACTIONS(507),
    [sym__special_character] = ACTIONS(3518),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3520),
  },
  [1712] = {
    [aux_sym_case_item_repeat1] = STATE(2445),
    [aux_sym__literal_repeat1] = STATE(2446),
    [anon_sym_PIPE] = ACTIONS(5289),
    [anon_sym_RPAREN] = ACTIONS(5295),
    [sym__special_character] = ACTIONS(1544),
    [sym_comment] = ACTIONS(57),
  },
  [1713] = {
    [sym_case_item] = STATE(2447),
    [sym_last_case_item] = STATE(2442),
    [sym_concatenation] = STATE(1710),
    [sym_string] = STATE(1708),
    [sym_simple_expansion] = STATE(1708),
    [sym_string_expansion] = STATE(1708),
    [sym_expansion] = STATE(1708),
    [sym_command_substitution] = STATE(1708),
    [sym_process_substitution] = STATE(1708),
    [aux_sym_case_statement_repeat1] = STATE(2447),
    [aux_sym__literal_repeat1] = STATE(1712),
    [anon_sym_esac] = ACTIONS(5297),
    [anon_sym_DOLLAR] = ACTIONS(507),
    [sym__special_character] = ACTIONS(3518),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3522),
  },
  [1714] = {
    [sym__concat] = ACTIONS(4125),
    [anon_sym_in] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4125),
  },
  [1715] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(5299),
    [sym_comment] = ACTIONS(57),
  },
  [1716] = {
    [anon_sym_RBRACE] = ACTIONS(5299),
    [sym_comment] = ACTIONS(57),
  },
  [1717] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(5301),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [1718] = {
    [sym_concatenation] = STATE(2451),
    [sym_string] = STATE(2450),
    [sym_simple_expansion] = STATE(2450),
    [sym_string_expansion] = STATE(2450),
    [sym_expansion] = STATE(2450),
    [sym_command_substitution] = STATE(2450),
    [sym_process_substitution] = STATE(2450),
    [aux_sym__literal_repeat1] = STATE(2452),
    [anon_sym_RBRACE] = ACTIONS(5299),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(5303),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5303),
  },
  [1719] = {
    [sym__concat] = ACTIONS(4161),
    [anon_sym_in] = ACTIONS(4161),
    [anon_sym_SEMI] = ACTIONS(4163),
    [anon_sym_SEMI_SEMI] = ACTIONS(4161),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4161),
    [anon_sym_AMP] = ACTIONS(4161),
  },
  [1720] = {
    [sym_concatenation] = STATE(2455),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2455),
    [sym_regex] = ACTIONS(5305),
    [anon_sym_RBRACE] = ACTIONS(5307),
    [anon_sym_EQ] = ACTIONS(5309),
    [anon_sym_DASH] = ACTIONS(5309),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5311),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5309),
    [anon_sym_COLON_QMARK] = ACTIONS(5309),
    [anon_sym_COLON_DASH] = ACTIONS(5309),
    [anon_sym_PERCENT] = ACTIONS(5309),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1721] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(5307),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1722] = {
    [sym_concatenation] = STATE(2457),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2457),
    [sym_regex] = ACTIONS(5313),
    [anon_sym_RBRACE] = ACTIONS(5299),
    [anon_sym_EQ] = ACTIONS(5315),
    [anon_sym_DASH] = ACTIONS(5315),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5317),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5315),
    [anon_sym_COLON_QMARK] = ACTIONS(5315),
    [anon_sym_COLON_DASH] = ACTIONS(5315),
    [anon_sym_PERCENT] = ACTIONS(5315),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1723] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(5299),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1724] = {
    [sym_concatenation] = STATE(2459),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2459),
    [anon_sym_RBRACE] = ACTIONS(5319),
    [anon_sym_EQ] = ACTIONS(5321),
    [anon_sym_DASH] = ACTIONS(5321),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5321),
    [anon_sym_COLON_QMARK] = ACTIONS(5321),
    [anon_sym_COLON_DASH] = ACTIONS(5321),
    [anon_sym_PERCENT] = ACTIONS(5321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1725] = {
    [sym__concat] = ACTIONS(4219),
    [anon_sym_in] = ACTIONS(4219),
    [anon_sym_SEMI] = ACTIONS(4221),
    [anon_sym_SEMI_SEMI] = ACTIONS(4219),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4219),
    [anon_sym_AMP] = ACTIONS(4219),
  },
  [1726] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(5319),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1727] = {
    [sym_concatenation] = STATE(2457),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2457),
    [anon_sym_RBRACE] = ACTIONS(5299),
    [anon_sym_EQ] = ACTIONS(5315),
    [anon_sym_DASH] = ACTIONS(5315),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5317),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5315),
    [anon_sym_COLON_QMARK] = ACTIONS(5315),
    [anon_sym_COLON_DASH] = ACTIONS(5315),
    [anon_sym_PERCENT] = ACTIONS(5315),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1728] = {
    [sym__simple_heredoc_body] = ACTIONS(5325),
    [sym__heredoc_body_beginning] = ACTIONS(5325),
    [sym_file_descriptor] = ACTIONS(5325),
    [ts_builtin_sym_end] = ACTIONS(5325),
    [anon_sym_SEMI] = ACTIONS(5327),
    [anon_sym_done] = ACTIONS(5325),
    [anon_sym_fi] = ACTIONS(5325),
    [anon_sym_elif] = ACTIONS(5325),
    [anon_sym_else] = ACTIONS(5325),
    [anon_sym_esac] = ACTIONS(5325),
    [anon_sym_PIPE] = ACTIONS(5327),
    [anon_sym_RPAREN] = ACTIONS(5325),
    [anon_sym_SEMI_SEMI] = ACTIONS(5325),
    [anon_sym_PIPE_AMP] = ACTIONS(5325),
    [anon_sym_AMP_AMP] = ACTIONS(5325),
    [anon_sym_PIPE_PIPE] = ACTIONS(5325),
    [anon_sym_LT] = ACTIONS(5327),
    [anon_sym_GT] = ACTIONS(5327),
    [anon_sym_GT_GT] = ACTIONS(5325),
    [anon_sym_AMP_GT] = ACTIONS(5327),
    [anon_sym_AMP_GT_GT] = ACTIONS(5325),
    [anon_sym_LT_AMP] = ACTIONS(5325),
    [anon_sym_GT_AMP] = ACTIONS(5325),
    [anon_sym_LT_LT] = ACTIONS(5327),
    [anon_sym_LT_LT_DASH] = ACTIONS(5325),
    [anon_sym_LT_LT_LT] = ACTIONS(5325),
    [anon_sym_BQUOTE] = ACTIONS(5325),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5325),
    [anon_sym_AMP] = ACTIONS(5327),
  },
  [1729] = {
    [anon_sym_esac] = ACTIONS(5329),
    [sym_comment] = ACTIONS(57),
  },
  [1730] = {
    [sym_case_item] = STATE(2443),
    [sym_last_case_item] = STATE(2461),
    [sym_concatenation] = STATE(1710),
    [sym_string] = STATE(1708),
    [sym_simple_expansion] = STATE(1708),
    [sym_string_expansion] = STATE(1708),
    [sym_expansion] = STATE(1708),
    [sym_command_substitution] = STATE(1708),
    [sym_process_substitution] = STATE(1708),
    [aux_sym_case_statement_repeat1] = STATE(2443),
    [aux_sym__literal_repeat1] = STATE(1712),
    [anon_sym_DOLLAR] = ACTIONS(507),
    [sym__special_character] = ACTIONS(3518),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3520),
  },
  [1731] = {
    [sym_case_item] = STATE(2462),
    [sym_last_case_item] = STATE(2461),
    [sym_concatenation] = STATE(1710),
    [sym_string] = STATE(1708),
    [sym_simple_expansion] = STATE(1708),
    [sym_string_expansion] = STATE(1708),
    [sym_expansion] = STATE(1708),
    [sym_command_substitution] = STATE(1708),
    [sym_process_substitution] = STATE(1708),
    [aux_sym_case_statement_repeat1] = STATE(2462),
    [aux_sym__literal_repeat1] = STATE(1712),
    [anon_sym_esac] = ACTIONS(5331),
    [anon_sym_DOLLAR] = ACTIONS(507),
    [sym__special_character] = ACTIONS(3518),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3522),
  },
  [1732] = {
    [sym__simple_heredoc_body] = ACTIONS(5333),
    [sym__heredoc_body_beginning] = ACTIONS(5333),
    [sym_file_descriptor] = ACTIONS(5333),
    [ts_builtin_sym_end] = ACTIONS(5333),
    [anon_sym_SEMI] = ACTIONS(5335),
    [anon_sym_done] = ACTIONS(5333),
    [anon_sym_fi] = ACTIONS(5333),
    [anon_sym_elif] = ACTIONS(5333),
    [anon_sym_else] = ACTIONS(5333),
    [anon_sym_esac] = ACTIONS(5333),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_RPAREN] = ACTIONS(5333),
    [anon_sym_SEMI_SEMI] = ACTIONS(5333),
    [anon_sym_PIPE_AMP] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5335),
    [anon_sym_GT] = ACTIONS(5335),
    [anon_sym_GT_GT] = ACTIONS(5333),
    [anon_sym_AMP_GT] = ACTIONS(5335),
    [anon_sym_AMP_GT_GT] = ACTIONS(5333),
    [anon_sym_LT_AMP] = ACTIONS(5333),
    [anon_sym_GT_AMP] = ACTIONS(5333),
    [anon_sym_LT_LT] = ACTIONS(5335),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_LT] = ACTIONS(5333),
    [anon_sym_BQUOTE] = ACTIONS(5333),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5333),
    [anon_sym_AMP] = ACTIONS(5335),
  },
  [1733] = {
    [aux_sym_concatenation_repeat1] = STATE(2463),
    [sym__simple_heredoc_body] = ACTIONS(1071),
    [sym__heredoc_body_beginning] = ACTIONS(1071),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(2761),
    [sym_variable_name] = ACTIONS(1071),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_RPAREN] = ACTIONS(1071),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [sym__special_character] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1075),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1075),
  },
  [1734] = {
    [aux_sym__literal_repeat1] = STATE(1734),
    [sym__simple_heredoc_body] = ACTIONS(1373),
    [sym__heredoc_body_beginning] = ACTIONS(1373),
    [sym_file_descriptor] = ACTIONS(1373),
    [sym_variable_name] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_RPAREN] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE_AMP] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_LT_LT_DASH] = ACTIONS(1373),
    [anon_sym_LT_LT_LT] = ACTIONS(1373),
    [anon_sym_DOLLAR] = ACTIONS(1375),
    [sym__special_character] = ACTIONS(2797),
    [anon_sym_DQUOTE] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1373),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [anon_sym_LT_LPAREN] = ACTIONS(1373),
    [anon_sym_GT_LPAREN] = ACTIONS(1373),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1375),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
  },
  [1735] = {
    [aux_sym_concatenation_repeat1] = STATE(1014),
    [sym__simple_heredoc_body] = ACTIONS(1400),
    [sym__heredoc_body_beginning] = ACTIONS(1400),
    [sym_file_descriptor] = ACTIONS(1400),
    [sym__concat] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(1400),
    [anon_sym_SEMI] = ACTIONS(1402),
    [anon_sym_PIPE] = ACTIONS(1402),
    [anon_sym_RPAREN] = ACTIONS(1400),
    [anon_sym_SEMI_SEMI] = ACTIONS(1400),
    [anon_sym_PIPE_AMP] = ACTIONS(1400),
    [anon_sym_AMP_AMP] = ACTIONS(1400),
    [anon_sym_PIPE_PIPE] = ACTIONS(1400),
    [anon_sym_LT] = ACTIONS(1402),
    [anon_sym_GT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT] = ACTIONS(1402),
    [anon_sym_AMP_GT_GT] = ACTIONS(1400),
    [anon_sym_LT_AMP] = ACTIONS(1400),
    [anon_sym_GT_AMP] = ACTIONS(1400),
    [anon_sym_LT_LT] = ACTIONS(1402),
    [anon_sym_LT_LT_DASH] = ACTIONS(1400),
    [anon_sym_LT_LT_LT] = ACTIONS(1400),
    [anon_sym_DOLLAR] = ACTIONS(1402),
    [sym__special_character] = ACTIONS(1400),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1400),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1400),
    [anon_sym_BQUOTE] = ACTIONS(1400),
    [anon_sym_LT_LPAREN] = ACTIONS(1400),
    [anon_sym_GT_LPAREN] = ACTIONS(1400),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1402),
    [sym_word] = ACTIONS(1402),
    [anon_sym_LF] = ACTIONS(1400),
    [anon_sym_AMP] = ACTIONS(1402),
  },
  [1736] = {
    [aux_sym__literal_repeat1] = STATE(1016),
    [sym__simple_heredoc_body] = ACTIONS(1446),
    [sym__heredoc_body_beginning] = ACTIONS(1446),
    [sym_file_descriptor] = ACTIONS(1446),
    [sym_variable_name] = ACTIONS(1446),
    [anon_sym_SEMI] = ACTIONS(1448),
    [anon_sym_PIPE] = ACTIONS(1448),
    [anon_sym_RPAREN] = ACTIONS(1446),
    [anon_sym_SEMI_SEMI] = ACTIONS(1446),
    [anon_sym_PIPE_AMP] = ACTIONS(1446),
    [anon_sym_AMP_AMP] = ACTIONS(1446),
    [anon_sym_PIPE_PIPE] = ACTIONS(1446),
    [anon_sym_LT] = ACTIONS(1448),
    [anon_sym_GT] = ACTIONS(1448),
    [anon_sym_GT_GT] = ACTIONS(1446),
    [anon_sym_AMP_GT] = ACTIONS(1448),
    [anon_sym_AMP_GT_GT] = ACTIONS(1446),
    [anon_sym_LT_AMP] = ACTIONS(1446),
    [anon_sym_GT_AMP] = ACTIONS(1446),
    [anon_sym_LT_LT] = ACTIONS(1448),
    [anon_sym_LT_LT_DASH] = ACTIONS(1446),
    [anon_sym_LT_LT_LT] = ACTIONS(1446),
    [anon_sym_DOLLAR] = ACTIONS(1448),
    [sym__special_character] = ACTIONS(981),
    [anon_sym_DQUOTE] = ACTIONS(1446),
    [sym_raw_string] = ACTIONS(1446),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1446),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1446),
    [anon_sym_BQUOTE] = ACTIONS(1446),
    [anon_sym_LT_LPAREN] = ACTIONS(1446),
    [anon_sym_GT_LPAREN] = ACTIONS(1446),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1448),
    [sym_word] = ACTIONS(1448),
    [anon_sym_LF] = ACTIONS(1446),
    [anon_sym_AMP] = ACTIONS(1448),
  },
  [1737] = {
    [aux_sym_concatenation_repeat1] = STATE(1737),
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(3962),
    [sym_variable_name] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_RPAREN] = ACTIONS(2362),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2364),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [1738] = {
    [aux_sym_concatenation_repeat1] = STATE(1738),
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(3999),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_RPAREN] = ACTIONS(2362),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2364),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [1739] = {
    [aux_sym_concatenation_repeat1] = STATE(1741),
    [sym__simple_heredoc_body] = ACTIONS(1380),
    [sym__heredoc_body_beginning] = ACTIONS(1380),
    [sym_file_descriptor] = ACTIONS(1380),
    [sym__concat] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(1382),
    [anon_sym_PIPE] = ACTIONS(1382),
    [anon_sym_RPAREN] = ACTIONS(1380),
    [anon_sym_SEMI_SEMI] = ACTIONS(1380),
    [anon_sym_PIPE_AMP] = ACTIONS(1380),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_PIPE_PIPE] = ACTIONS(1380),
    [anon_sym_LT] = ACTIONS(1382),
    [anon_sym_GT] = ACTIONS(1382),
    [anon_sym_GT_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT] = ACTIONS(1382),
    [anon_sym_AMP_GT_GT] = ACTIONS(1380),
    [anon_sym_LT_AMP] = ACTIONS(1380),
    [anon_sym_GT_AMP] = ACTIONS(1380),
    [anon_sym_LT_LT] = ACTIONS(1382),
    [anon_sym_LT_LT_DASH] = ACTIONS(1380),
    [anon_sym_LT_LT_LT] = ACTIONS(1380),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1380),
    [anon_sym_AMP] = ACTIONS(1382),
  },
  [1740] = {
    [aux_sym__literal_repeat1] = STATE(1742),
    [sym__simple_heredoc_body] = ACTIONS(1384),
    [sym__heredoc_body_beginning] = ACTIONS(1384),
    [sym_file_descriptor] = ACTIONS(1384),
    [anon_sym_SEMI] = ACTIONS(1386),
    [anon_sym_PIPE] = ACTIONS(1386),
    [anon_sym_RPAREN] = ACTIONS(1384),
    [anon_sym_SEMI_SEMI] = ACTIONS(1384),
    [anon_sym_PIPE_AMP] = ACTIONS(1384),
    [anon_sym_AMP_AMP] = ACTIONS(1384),
    [anon_sym_PIPE_PIPE] = ACTIONS(1384),
    [anon_sym_LT] = ACTIONS(1386),
    [anon_sym_GT] = ACTIONS(1386),
    [anon_sym_GT_GT] = ACTIONS(1384),
    [anon_sym_AMP_GT] = ACTIONS(1386),
    [anon_sym_AMP_GT_GT] = ACTIONS(1384),
    [anon_sym_LT_AMP] = ACTIONS(1384),
    [anon_sym_GT_AMP] = ACTIONS(1384),
    [anon_sym_LT_LT] = ACTIONS(1386),
    [anon_sym_LT_LT_DASH] = ACTIONS(1384),
    [anon_sym_LT_LT_LT] = ACTIONS(1384),
    [sym__special_character] = ACTIONS(441),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1384),
    [anon_sym_AMP] = ACTIONS(1386),
  },
  [1741] = {
    [aux_sym_concatenation_repeat1] = STATE(2464),
    [sym__simple_heredoc_body] = ACTIONS(1071),
    [sym__heredoc_body_beginning] = ACTIONS(1071),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(4377),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_RPAREN] = ACTIONS(1071),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1075),
  },
  [1742] = {
    [aux_sym__literal_repeat1] = STATE(1742),
    [sym__simple_heredoc_body] = ACTIONS(1373),
    [sym__heredoc_body_beginning] = ACTIONS(1373),
    [sym_file_descriptor] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_RPAREN] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE_AMP] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_LT_LT_DASH] = ACTIONS(1373),
    [anon_sym_LT_LT_LT] = ACTIONS(1373),
    [sym__special_character] = ACTIONS(1377),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
  },
  [1743] = {
    [sym__simple_heredoc_body] = ACTIONS(2719),
    [sym__heredoc_body_beginning] = ACTIONS(2719),
    [sym_file_descriptor] = ACTIONS(2719),
    [sym_variable_name] = ACTIONS(2719),
    [anon_sym_SEMI] = ACTIONS(2721),
    [anon_sym_PIPE] = ACTIONS(2721),
    [anon_sym_SEMI_SEMI] = ACTIONS(2719),
    [anon_sym_RBRACE] = ACTIONS(2719),
    [anon_sym_PIPE_AMP] = ACTIONS(2719),
    [anon_sym_AMP_AMP] = ACTIONS(2719),
    [anon_sym_PIPE_PIPE] = ACTIONS(2719),
    [anon_sym_LT] = ACTIONS(2721),
    [anon_sym_GT] = ACTIONS(2721),
    [anon_sym_GT_GT] = ACTIONS(2719),
    [anon_sym_AMP_GT] = ACTIONS(2721),
    [anon_sym_AMP_GT_GT] = ACTIONS(2719),
    [anon_sym_LT_AMP] = ACTIONS(2719),
    [anon_sym_GT_AMP] = ACTIONS(2719),
    [anon_sym_LT_LT] = ACTIONS(2721),
    [anon_sym_LT_LT_DASH] = ACTIONS(2719),
    [anon_sym_LT_LT_LT] = ACTIONS(2719),
    [anon_sym_DOLLAR] = ACTIONS(2721),
    [sym__special_character] = ACTIONS(2721),
    [anon_sym_DQUOTE] = ACTIONS(2719),
    [sym_raw_string] = ACTIONS(2719),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2719),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2719),
    [anon_sym_BQUOTE] = ACTIONS(2719),
    [anon_sym_LT_LPAREN] = ACTIONS(2719),
    [anon_sym_GT_LPAREN] = ACTIONS(2719),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2721),
    [anon_sym_LF] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2721),
  },
  [1744] = {
    [sym_concatenation] = STATE(1368),
    [sym_string] = STATE(730),
    [sym_simple_expansion] = STATE(730),
    [sym_string_expansion] = STATE(730),
    [sym_expansion] = STATE(730),
    [sym_command_substitution] = STATE(730),
    [sym_process_substitution] = STATE(730),
    [aux_sym_for_statement_repeat1] = STATE(1368),
    [aux_sym__literal_repeat1] = STATE(736),
    [anon_sym_RPAREN] = ACTIONS(5337),
    [anon_sym_DOLLAR] = ACTIONS(1406),
    [sym__special_character] = ACTIONS(1408),
    [anon_sym_DQUOTE] = ACTIONS(1410),
    [sym_raw_string] = ACTIONS(1412),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1414),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1416),
    [anon_sym_BQUOTE] = ACTIONS(1418),
    [anon_sym_LT_LPAREN] = ACTIONS(1420),
    [anon_sym_GT_LPAREN] = ACTIONS(1420),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1412),
  },
  [1745] = {
    [sym__simple_heredoc_body] = ACTIONS(1057),
    [sym__heredoc_body_beginning] = ACTIONS(1057),
    [sym_file_descriptor] = ACTIONS(1057),
    [sym__concat] = ACTIONS(1057),
    [sym_variable_name] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(1057),
    [anon_sym_PIPE_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_AMP] = ACTIONS(1057),
    [anon_sym_GT_AMP] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_LT] = ACTIONS(1057),
    [anon_sym_DOLLAR] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [sym_raw_string] = ACTIONS(1057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1057),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1057),
    [anon_sym_BQUOTE] = ACTIONS(1057),
    [anon_sym_LT_LPAREN] = ACTIONS(1057),
    [anon_sym_GT_LPAREN] = ACTIONS(1057),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [1746] = {
    [sym__simple_heredoc_body] = ACTIONS(1061),
    [sym__heredoc_body_beginning] = ACTIONS(1061),
    [sym_file_descriptor] = ACTIONS(1061),
    [sym__concat] = ACTIONS(1061),
    [sym_variable_name] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(1063),
    [anon_sym_PIPE] = ACTIONS(1063),
    [anon_sym_SEMI_SEMI] = ACTIONS(1061),
    [anon_sym_RBRACE] = ACTIONS(1061),
    [anon_sym_PIPE_AMP] = ACTIONS(1061),
    [anon_sym_AMP_AMP] = ACTIONS(1061),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1063),
    [anon_sym_GT_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT_GT] = ACTIONS(1061),
    [anon_sym_LT_AMP] = ACTIONS(1061),
    [anon_sym_GT_AMP] = ACTIONS(1061),
    [anon_sym_LT_LT] = ACTIONS(1063),
    [anon_sym_LT_LT_DASH] = ACTIONS(1061),
    [anon_sym_LT_LT_LT] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1061),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1061),
    [anon_sym_LT_LPAREN] = ACTIONS(1061),
    [anon_sym_GT_LPAREN] = ACTIONS(1061),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1063),
    [anon_sym_LF] = ACTIONS(1061),
    [anon_sym_AMP] = ACTIONS(1063),
  },
  [1747] = {
    [sym__simple_heredoc_body] = ACTIONS(1065),
    [sym__heredoc_body_beginning] = ACTIONS(1065),
    [sym_file_descriptor] = ACTIONS(1065),
    [sym__concat] = ACTIONS(1065),
    [sym_variable_name] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1067),
    [anon_sym_SEMI_SEMI] = ACTIONS(1065),
    [anon_sym_RBRACE] = ACTIONS(1065),
    [anon_sym_PIPE_AMP] = ACTIONS(1065),
    [anon_sym_AMP_AMP] = ACTIONS(1065),
    [anon_sym_PIPE_PIPE] = ACTIONS(1065),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_GT] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT] = ACTIONS(1067),
    [anon_sym_AMP_GT_GT] = ACTIONS(1065),
    [anon_sym_LT_AMP] = ACTIONS(1065),
    [anon_sym_GT_AMP] = ACTIONS(1065),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_LT_LT_DASH] = ACTIONS(1065),
    [anon_sym_LT_LT_LT] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1067),
    [sym__special_character] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LT_LPAREN] = ACTIONS(1065),
    [anon_sym_GT_LPAREN] = ACTIONS(1065),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1067),
    [anon_sym_LF] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1067),
  },
  [1748] = {
    [sym_string] = STATE(2466),
    [sym_simple_expansion] = STATE(2466),
    [sym_string_expansion] = STATE(2466),
    [sym_expansion] = STATE(2466),
    [sym_command_substitution] = STATE(2466),
    [sym_process_substitution] = STATE(2466),
    [anon_sym_DOLLAR] = ACTIONS(1925),
    [sym__special_character] = ACTIONS(5339),
    [anon_sym_DQUOTE] = ACTIONS(1929),
    [sym_raw_string] = ACTIONS(5339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1933),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1935),
    [anon_sym_BQUOTE] = ACTIONS(1937),
    [anon_sym_LT_LPAREN] = ACTIONS(1939),
    [anon_sym_GT_LPAREN] = ACTIONS(1939),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5339),
  },
  [1749] = {
    [aux_sym_concatenation_repeat1] = STATE(2468),
    [sym__simple_heredoc_body] = ACTIONS(1071),
    [sym__heredoc_body_beginning] = ACTIONS(1071),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(5341),
    [sym_variable_name] = ACTIONS(1071),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [sym__special_character] = ACTIONS(1075),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1075),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1075),
  },
  [1750] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(5343),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [1751] = {
    [sym__simple_heredoc_body] = ACTIONS(1089),
    [sym__heredoc_body_beginning] = ACTIONS(1089),
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(1089),
    [sym_variable_name] = ACTIONS(1089),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_PIPE_AMP] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_AMP] = ACTIONS(1089),
    [anon_sym_GT_AMP] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1089),
    [anon_sym_LT_LT_LT] = ACTIONS(1089),
    [anon_sym_DOLLAR] = ACTIONS(1091),
    [sym__special_character] = ACTIONS(1091),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1089),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1089),
    [anon_sym_GT_LPAREN] = ACTIONS(1089),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [1752] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(627),
    [anon_sym_DOLLAR] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(5343),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [1753] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(5347),
    [sym_comment] = ACTIONS(57),
  },
  [1754] = {
    [sym_subscript] = STATE(2474),
    [sym_variable_name] = ACTIONS(5349),
    [anon_sym_DASH] = ACTIONS(5351),
    [anon_sym_DOLLAR] = ACTIONS(5351),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5353),
    [anon_sym_STAR] = ACTIONS(5355),
    [anon_sym_AT] = ACTIONS(5355),
    [anon_sym_QMARK] = ACTIONS(5355),
    [anon_sym_0] = ACTIONS(5353),
    [anon_sym__] = ACTIONS(5353),
  },
  [1755] = {
    [sym_concatenation] = STATE(2477),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2477),
    [anon_sym_RBRACE] = ACTIONS(5357),
    [anon_sym_EQ] = ACTIONS(5359),
    [anon_sym_DASH] = ACTIONS(5359),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5361),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(5363),
    [anon_sym_COLON] = ACTIONS(5359),
    [anon_sym_COLON_QMARK] = ACTIONS(5359),
    [anon_sym_COLON_DASH] = ACTIONS(5359),
    [anon_sym_PERCENT] = ACTIONS(5359),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1756] = {
    [sym_concatenation] = STATE(2480),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2480),
    [anon_sym_RBRACE] = ACTIONS(5365),
    [anon_sym_EQ] = ACTIONS(5367),
    [anon_sym_DASH] = ACTIONS(5367),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(5371),
    [anon_sym_COLON] = ACTIONS(5367),
    [anon_sym_COLON_QMARK] = ACTIONS(5367),
    [anon_sym_COLON_DASH] = ACTIONS(5367),
    [anon_sym_PERCENT] = ACTIONS(5367),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1757] = {
    [anon_sym_RPAREN] = ACTIONS(5373),
    [sym_comment] = ACTIONS(57),
  },
  [1758] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(5373),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [1759] = {
    [anon_sym_BQUOTE] = ACTIONS(5373),
    [sym_comment] = ACTIONS(57),
  },
  [1760] = {
    [anon_sym_RPAREN] = ACTIONS(5375),
    [sym_comment] = ACTIONS(57),
  },
  [1761] = {
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym_variable_name] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_RBRACE] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(339),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [1762] = {
    [aux_sym__literal_repeat1] = STATE(1762),
    [sym__simple_heredoc_body] = ACTIONS(1373),
    [sym__heredoc_body_beginning] = ACTIONS(1373),
    [sym_file_descriptor] = ACTIONS(1373),
    [sym_variable_name] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_RBRACE] = ACTIONS(1373),
    [anon_sym_PIPE_AMP] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_LT_LT_DASH] = ACTIONS(1373),
    [anon_sym_LT_LT_LT] = ACTIONS(1373),
    [anon_sym_DOLLAR] = ACTIONS(1375),
    [sym__special_character] = ACTIONS(5377),
    [anon_sym_DQUOTE] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1373),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [anon_sym_LT_LPAREN] = ACTIONS(1373),
    [anon_sym_GT_LPAREN] = ACTIONS(1373),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1375),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
  },
  [1763] = {
    [sym__expression] = STATE(2484),
    [sym_binary_expression] = STATE(2484),
    [sym_unary_expression] = STATE(2484),
    [sym_postfix_expression] = STATE(2484),
    [sym_parenthesized_expression] = STATE(2484),
    [sym_concatenation] = STATE(2484),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__literal_repeat1] = STATE(53),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(5380),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_DOLLAR] = ACTIONS(77),
    [sym__special_character] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [1764] = {
    [anon_sym_SEMI] = ACTIONS(5382),
    [anon_sym_SEMI_SEMI] = ACTIONS(5384),
    [anon_sym_AMP_AMP] = ACTIONS(1484),
    [anon_sym_PIPE_PIPE] = ACTIONS(1484),
    [anon_sym_EQ_TILDE] = ACTIONS(1486),
    [anon_sym_EQ_EQ] = ACTIONS(1486),
    [anon_sym_EQ] = ACTIONS(1488),
    [anon_sym_PLUS_EQ] = ACTIONS(1484),
    [anon_sym_LT] = ACTIONS(1488),
    [anon_sym_GT] = ACTIONS(1488),
    [anon_sym_BANG_EQ] = ACTIONS(1484),
    [anon_sym_PLUS] = ACTIONS(1488),
    [anon_sym_DASH] = ACTIONS(1488),
    [anon_sym_DASH_EQ] = ACTIONS(1484),
    [anon_sym_LT_EQ] = ACTIONS(1484),
    [anon_sym_GT_EQ] = ACTIONS(1484),
    [anon_sym_PLUS_PLUS] = ACTIONS(1490),
    [anon_sym_DASH_DASH] = ACTIONS(1490),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1484),
    [anon_sym_LF] = ACTIONS(5384),
    [anon_sym_AMP] = ACTIONS(5382),
  },
  [1765] = {
    [sym__expression] = STATE(2486),
    [sym_binary_expression] = STATE(2486),
    [sym_unary_expression] = STATE(2486),
    [sym_postfix_expression] = STATE(2486),
    [sym_parenthesized_expression] = STATE(2486),
    [sym_concatenation] = STATE(2486),
    [sym_string] = STATE(280),
    [sym_simple_expansion] = STATE(280),
    [sym_string_expansion] = STATE(280),
    [sym_expansion] = STATE(280),
    [sym_command_substitution] = STATE(280),
    [sym_process_substitution] = STATE(280),
    [aux_sym__literal_repeat1] = STATE(286),
    [anon_sym_SEMI] = ACTIONS(5382),
    [anon_sym_SEMI_SEMI] = ACTIONS(5384),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(475),
    [anon_sym_DOLLAR] = ACTIONS(477),
    [sym__special_character] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(481),
    [sym_raw_string] = ACTIONS(483),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(485),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(487),
    [anon_sym_BQUOTE] = ACTIONS(489),
    [anon_sym_LT_LPAREN] = ACTIONS(491),
    [anon_sym_GT_LPAREN] = ACTIONS(491),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(493),
    [sym_test_operator] = ACTIONS(495),
    [anon_sym_LF] = ACTIONS(5384),
    [anon_sym_AMP] = ACTIONS(5384),
  },
  [1766] = {
    [sym_concatenation] = STATE(1429),
    [sym_string] = STATE(784),
    [sym_simple_expansion] = STATE(784),
    [sym_string_expansion] = STATE(784),
    [sym_expansion] = STATE(784),
    [sym_command_substitution] = STATE(784),
    [sym_process_substitution] = STATE(784),
    [aux_sym_for_statement_repeat1] = STATE(1429),
    [aux_sym__literal_repeat1] = STATE(790),
    [anon_sym_SEMI] = ACTIONS(5386),
    [anon_sym_SEMI_SEMI] = ACTIONS(5388),
    [anon_sym_DOLLAR] = ACTIONS(1494),
    [sym__special_character] = ACTIONS(1496),
    [anon_sym_DQUOTE] = ACTIONS(1498),
    [sym_raw_string] = ACTIONS(1500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1502),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1504),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_LT_LPAREN] = ACTIONS(1508),
    [anon_sym_GT_LPAREN] = ACTIONS(1508),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2881),
    [anon_sym_LF] = ACTIONS(5388),
    [anon_sym_AMP] = ACTIONS(5388),
  },
  [1767] = {
    [sym__simple_heredoc_body] = ACTIONS(2885),
    [sym__heredoc_body_beginning] = ACTIONS(2885),
    [sym_file_descriptor] = ACTIONS(2885),
    [anon_sym_SEMI] = ACTIONS(2887),
    [anon_sym_PIPE] = ACTIONS(2887),
    [anon_sym_SEMI_SEMI] = ACTIONS(2885),
    [anon_sym_RBRACE] = ACTIONS(2885),
    [anon_sym_PIPE_AMP] = ACTIONS(2885),
    [anon_sym_AMP_AMP] = ACTIONS(2885),
    [anon_sym_PIPE_PIPE] = ACTIONS(2885),
    [anon_sym_LT] = ACTIONS(2887),
    [anon_sym_GT] = ACTIONS(2887),
    [anon_sym_GT_GT] = ACTIONS(2885),
    [anon_sym_AMP_GT] = ACTIONS(2887),
    [anon_sym_AMP_GT_GT] = ACTIONS(2885),
    [anon_sym_LT_AMP] = ACTIONS(2885),
    [anon_sym_GT_AMP] = ACTIONS(2885),
    [anon_sym_LT_LT] = ACTIONS(2887),
    [anon_sym_LT_LT_DASH] = ACTIONS(2885),
    [anon_sym_LT_LT_LT] = ACTIONS(2885),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2885),
    [anon_sym_AMP] = ACTIONS(2887),
  },
  [1768] = {
    [sym__simple_heredoc_body] = ACTIONS(3223),
    [sym__heredoc_body_beginning] = ACTIONS(3223),
    [sym_file_descriptor] = ACTIONS(3223),
    [anon_sym_SEMI] = ACTIONS(3225),
    [anon_sym_PIPE] = ACTIONS(3225),
    [anon_sym_SEMI_SEMI] = ACTIONS(3223),
    [anon_sym_RBRACE] = ACTIONS(3223),
    [anon_sym_PIPE_AMP] = ACTIONS(3223),
    [anon_sym_AMP_AMP] = ACTIONS(3223),
    [anon_sym_PIPE_PIPE] = ACTIONS(3223),
    [anon_sym_LT] = ACTIONS(3225),
    [anon_sym_GT] = ACTIONS(3225),
    [anon_sym_GT_GT] = ACTIONS(3223),
    [anon_sym_AMP_GT] = ACTIONS(3225),
    [anon_sym_AMP_GT_GT] = ACTIONS(3223),
    [anon_sym_LT_AMP] = ACTIONS(3223),
    [anon_sym_GT_AMP] = ACTIONS(3223),
    [anon_sym_LT_LT] = ACTIONS(3225),
    [anon_sym_LT_LT_DASH] = ACTIONS(3223),
    [anon_sym_LT_LT_LT] = ACTIONS(3223),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3223),
    [anon_sym_AMP] = ACTIONS(3225),
  },
  [1769] = {
    [anon_sym_done] = ACTIONS(5390),
    [sym_comment] = ACTIONS(57),
  },
  [1770] = {
    [sym__simple_heredoc_body] = ACTIONS(3377),
    [sym__heredoc_body_beginning] = ACTIONS(3377),
    [sym_file_descriptor] = ACTIONS(3377),
    [anon_sym_SEMI] = ACTIONS(3379),
    [anon_sym_PIPE] = ACTIONS(3379),
    [anon_sym_SEMI_SEMI] = ACTIONS(3377),
    [anon_sym_RBRACE] = ACTIONS(3377),
    [anon_sym_PIPE_AMP] = ACTIONS(3377),
    [anon_sym_AMP_AMP] = ACTIONS(3377),
    [anon_sym_PIPE_PIPE] = ACTIONS(3377),
    [anon_sym_LT] = ACTIONS(3379),
    [anon_sym_GT] = ACTIONS(3379),
    [anon_sym_GT_GT] = ACTIONS(3377),
    [anon_sym_AMP_GT] = ACTIONS(3379),
    [anon_sym_AMP_GT_GT] = ACTIONS(3377),
    [anon_sym_LT_AMP] = ACTIONS(3377),
    [anon_sym_GT_AMP] = ACTIONS(3377),
    [anon_sym_LT_LT] = ACTIONS(3379),
    [anon_sym_LT_LT_DASH] = ACTIONS(3377),
    [anon_sym_LT_LT_LT] = ACTIONS(3377),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3377),
    [anon_sym_AMP] = ACTIONS(3379),
  },
  [1771] = {
    [sym_elif_clause] = STATE(2491),
    [sym_else_clause] = STATE(2490),
    [aux_sym_if_statement_repeat1] = STATE(2491),
    [anon_sym_fi] = ACTIONS(5392),
    [anon_sym_elif] = ACTIONS(3477),
    [anon_sym_else] = ACTIONS(3479),
    [sym_comment] = ACTIONS(57),
  },
  [1772] = {
    [anon_sym_fi] = ACTIONS(5392),
    [sym_comment] = ACTIONS(57),
  },
  [1773] = {
    [sym_elif_clause] = STATE(1700),
    [sym_else_clause] = STATE(2490),
    [aux_sym_if_statement_repeat1] = STATE(1700),
    [anon_sym_fi] = ACTIONS(5392),
    [anon_sym_elif] = ACTIONS(3477),
    [anon_sym_else] = ACTIONS(3479),
    [sym_comment] = ACTIONS(57),
  },
  [1774] = {
    [sym_case_item] = STATE(2494),
    [sym_last_case_item] = STATE(2493),
    [sym_concatenation] = STATE(1710),
    [sym_string] = STATE(1708),
    [sym_simple_expansion] = STATE(1708),
    [sym_string_expansion] = STATE(1708),
    [sym_expansion] = STATE(1708),
    [sym_command_substitution] = STATE(1708),
    [sym_process_substitution] = STATE(1708),
    [aux_sym_case_statement_repeat1] = STATE(2494),
    [aux_sym__literal_repeat1] = STATE(1712),
    [anon_sym_esac] = ACTIONS(5394),
    [anon_sym_DOLLAR] = ACTIONS(507),
    [sym__special_character] = ACTIONS(3518),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3522),
  },
  [1775] = {
    [anon_sym_SEMI] = ACTIONS(5396),
    [anon_sym_SEMI_SEMI] = ACTIONS(5398),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5398),
    [anon_sym_AMP] = ACTIONS(5398),
  },
  [1776] = {
    [sym_case_item] = STATE(2498),
    [sym_last_case_item] = STATE(2497),
    [sym_concatenation] = STATE(1710),
    [sym_string] = STATE(1708),
    [sym_simple_expansion] = STATE(1708),
    [sym_string_expansion] = STATE(1708),
    [sym_expansion] = STATE(1708),
    [sym_command_substitution] = STATE(1708),
    [sym_process_substitution] = STATE(1708),
    [aux_sym_case_statement_repeat1] = STATE(2498),
    [aux_sym__literal_repeat1] = STATE(1712),
    [anon_sym_esac] = ACTIONS(5400),
    [anon_sym_DOLLAR] = ACTIONS(507),
    [sym__special_character] = ACTIONS(3518),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3522),
  },
  [1777] = {
    [anon_sym_SEMI] = ACTIONS(5402),
    [anon_sym_SEMI_SEMI] = ACTIONS(5404),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5404),
    [anon_sym_AMP] = ACTIONS(5404),
  },
  [1778] = {
    [sym_compound_statement] = STATE(2500),
    [anon_sym_LBRACE] = ACTIONS(191),
    [sym_comment] = ACTIONS(57),
  },
  [1779] = {
    [sym__simple_heredoc_body] = ACTIONS(1400),
    [sym__heredoc_body_beginning] = ACTIONS(1400),
    [sym_file_descriptor] = ACTIONS(1400),
    [sym_variable_name] = ACTIONS(1400),
    [anon_sym_SEMI] = ACTIONS(1402),
    [anon_sym_PIPE] = ACTIONS(1402),
    [anon_sym_SEMI_SEMI] = ACTIONS(1400),
    [anon_sym_RBRACE] = ACTIONS(1400),
    [anon_sym_PIPE_AMP] = ACTIONS(1400),
    [anon_sym_AMP_AMP] = ACTIONS(1400),
    [anon_sym_PIPE_PIPE] = ACTIONS(1400),
    [anon_sym_LT] = ACTIONS(1402),
    [anon_sym_GT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT] = ACTIONS(1402),
    [anon_sym_AMP_GT_GT] = ACTIONS(1400),
    [anon_sym_LT_AMP] = ACTIONS(1400),
    [anon_sym_GT_AMP] = ACTIONS(1400),
    [anon_sym_LT_LT] = ACTIONS(1402),
    [anon_sym_LT_LT_DASH] = ACTIONS(1400),
    [anon_sym_LT_LT_LT] = ACTIONS(1400),
    [anon_sym_DOLLAR] = ACTIONS(1402),
    [sym__special_character] = ACTIONS(1402),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1400),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1400),
    [anon_sym_BQUOTE] = ACTIONS(1400),
    [anon_sym_LT_LPAREN] = ACTIONS(1400),
    [anon_sym_GT_LPAREN] = ACTIONS(1400),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1402),
    [sym_word] = ACTIONS(1402),
    [anon_sym_LF] = ACTIONS(1400),
    [anon_sym_AMP] = ACTIONS(1402),
  },
  [1780] = {
    [sym_concatenation] = STATE(2502),
    [sym_string] = STATE(730),
    [sym_simple_expansion] = STATE(730),
    [sym_string_expansion] = STATE(730),
    [sym_expansion] = STATE(730),
    [sym_command_substitution] = STATE(730),
    [sym_process_substitution] = STATE(730),
    [aux_sym_for_statement_repeat1] = STATE(2502),
    [aux_sym__literal_repeat1] = STATE(736),
    [anon_sym_RPAREN] = ACTIONS(5406),
    [anon_sym_DOLLAR] = ACTIONS(1406),
    [sym__special_character] = ACTIONS(1408),
    [anon_sym_DQUOTE] = ACTIONS(1410),
    [sym_raw_string] = ACTIONS(1412),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1414),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1416),
    [anon_sym_BQUOTE] = ACTIONS(1418),
    [anon_sym_LT_LPAREN] = ACTIONS(1420),
    [anon_sym_GT_LPAREN] = ACTIONS(1420),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1412),
  },
  [1781] = {
    [aux_sym_concatenation_repeat1] = STATE(1068),
    [sym__simple_heredoc_body] = ACTIONS(1400),
    [sym__heredoc_body_beginning] = ACTIONS(1400),
    [sym_file_descriptor] = ACTIONS(1400),
    [sym__concat] = ACTIONS(1985),
    [sym_variable_name] = ACTIONS(1400),
    [anon_sym_SEMI] = ACTIONS(1402),
    [anon_sym_PIPE] = ACTIONS(1402),
    [anon_sym_SEMI_SEMI] = ACTIONS(1400),
    [anon_sym_RBRACE] = ACTIONS(1400),
    [anon_sym_PIPE_AMP] = ACTIONS(1400),
    [anon_sym_AMP_AMP] = ACTIONS(1400),
    [anon_sym_PIPE_PIPE] = ACTIONS(1400),
    [anon_sym_LT] = ACTIONS(1402),
    [anon_sym_GT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT] = ACTIONS(1402),
    [anon_sym_AMP_GT_GT] = ACTIONS(1400),
    [anon_sym_LT_AMP] = ACTIONS(1400),
    [anon_sym_GT_AMP] = ACTIONS(1400),
    [anon_sym_LT_LT] = ACTIONS(1402),
    [anon_sym_LT_LT_DASH] = ACTIONS(1400),
    [anon_sym_LT_LT_LT] = ACTIONS(1400),
    [anon_sym_DOLLAR] = ACTIONS(1402),
    [sym__special_character] = ACTIONS(1402),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1400),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1400),
    [anon_sym_BQUOTE] = ACTIONS(1400),
    [anon_sym_LT_LPAREN] = ACTIONS(1400),
    [anon_sym_GT_LPAREN] = ACTIONS(1400),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1402),
    [sym_word] = ACTIONS(1402),
    [anon_sym_LF] = ACTIONS(1400),
    [anon_sym_AMP] = ACTIONS(1402),
  },
  [1782] = {
    [aux_sym__literal_repeat1] = STATE(1082),
    [sym__simple_heredoc_body] = ACTIONS(1446),
    [sym__heredoc_body_beginning] = ACTIONS(1446),
    [sym_file_descriptor] = ACTIONS(1446),
    [sym_variable_name] = ACTIONS(1446),
    [anon_sym_SEMI] = ACTIONS(1448),
    [anon_sym_PIPE] = ACTIONS(1448),
    [anon_sym_SEMI_SEMI] = ACTIONS(1446),
    [anon_sym_RBRACE] = ACTIONS(1446),
    [anon_sym_PIPE_AMP] = ACTIONS(1446),
    [anon_sym_AMP_AMP] = ACTIONS(1446),
    [anon_sym_PIPE_PIPE] = ACTIONS(1446),
    [anon_sym_LT] = ACTIONS(1448),
    [anon_sym_GT] = ACTIONS(1448),
    [anon_sym_GT_GT] = ACTIONS(1446),
    [anon_sym_AMP_GT] = ACTIONS(1448),
    [anon_sym_AMP_GT_GT] = ACTIONS(1446),
    [anon_sym_LT_AMP] = ACTIONS(1446),
    [anon_sym_GT_AMP] = ACTIONS(1446),
    [anon_sym_LT_LT] = ACTIONS(1448),
    [anon_sym_LT_LT_DASH] = ACTIONS(1446),
    [anon_sym_LT_LT_LT] = ACTIONS(1446),
    [anon_sym_DOLLAR] = ACTIONS(1448),
    [sym__special_character] = ACTIONS(2003),
    [anon_sym_DQUOTE] = ACTIONS(1446),
    [sym_raw_string] = ACTIONS(1446),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1446),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1446),
    [anon_sym_BQUOTE] = ACTIONS(1446),
    [anon_sym_LT_LPAREN] = ACTIONS(1446),
    [anon_sym_GT_LPAREN] = ACTIONS(1446),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1448),
    [sym_word] = ACTIONS(1448),
    [anon_sym_LF] = ACTIONS(1446),
    [anon_sym_AMP] = ACTIONS(1448),
  },
  [1783] = {
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(2362),
    [sym_variable_name] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_RBRACE] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2364),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2364),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [1784] = {
    [sym_string] = STATE(1783),
    [sym_simple_expansion] = STATE(1783),
    [sym_string_expansion] = STATE(1783),
    [sym_expansion] = STATE(1783),
    [sym_command_substitution] = STATE(1783),
    [sym_process_substitution] = STATE(1783),
    [anon_sym_DOLLAR] = ACTIONS(5408),
    [sym__special_character] = ACTIONS(3681),
    [anon_sym_DQUOTE] = ACTIONS(793),
    [sym_raw_string] = ACTIONS(3681),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(797),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(799),
    [anon_sym_BQUOTE] = ACTIONS(801),
    [anon_sym_LT_LPAREN] = ACTIONS(803),
    [anon_sym_GT_LPAREN] = ACTIONS(803),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3681),
  },
  [1785] = {
    [aux_sym_concatenation_repeat1] = STATE(1785),
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(5410),
    [sym_variable_name] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_RBRACE] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2364),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2364),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [1786] = {
    [sym__simple_heredoc_body] = ACTIONS(2371),
    [sym__heredoc_body_beginning] = ACTIONS(2371),
    [sym_file_descriptor] = ACTIONS(2371),
    [sym__concat] = ACTIONS(2371),
    [sym_variable_name] = ACTIONS(2371),
    [anon_sym_SEMI] = ACTIONS(2373),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_SEMI_SEMI] = ACTIONS(2371),
    [anon_sym_RBRACE] = ACTIONS(2371),
    [anon_sym_PIPE_AMP] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_GT_GT] = ACTIONS(2371),
    [anon_sym_AMP_GT] = ACTIONS(2373),
    [anon_sym_AMP_GT_GT] = ACTIONS(2371),
    [anon_sym_LT_AMP] = ACTIONS(2371),
    [anon_sym_GT_AMP] = ACTIONS(2371),
    [anon_sym_LT_LT] = ACTIONS(2373),
    [anon_sym_LT_LT_DASH] = ACTIONS(2371),
    [anon_sym_LT_LT_LT] = ACTIONS(2371),
    [anon_sym_DOLLAR] = ACTIONS(2373),
    [sym__special_character] = ACTIONS(2373),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [sym_raw_string] = ACTIONS(2371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2371),
    [anon_sym_BQUOTE] = ACTIONS(2371),
    [anon_sym_LT_LPAREN] = ACTIONS(2371),
    [anon_sym_GT_LPAREN] = ACTIONS(2371),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2373),
    [sym_word] = ACTIONS(2373),
    [anon_sym_LF] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
  },
  [1787] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(5413),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [1788] = {
    [sym_concatenation] = STATE(2507),
    [sym_string] = STATE(2506),
    [sym_simple_expansion] = STATE(2506),
    [sym_string_expansion] = STATE(2506),
    [sym_expansion] = STATE(2506),
    [sym_command_substitution] = STATE(2506),
    [sym_process_substitution] = STATE(2506),
    [aux_sym__literal_repeat1] = STATE(2508),
    [anon_sym_RBRACE] = ACTIONS(5415),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(5417),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5417),
  },
  [1789] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(5419),
    [sym_comment] = ACTIONS(57),
  },
  [1790] = {
    [sym_concatenation] = STATE(2512),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2512),
    [anon_sym_RBRACE] = ACTIONS(5421),
    [anon_sym_EQ] = ACTIONS(5423),
    [anon_sym_DASH] = ACTIONS(5423),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5425),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(5427),
    [anon_sym_COLON] = ACTIONS(5423),
    [anon_sym_COLON_QMARK] = ACTIONS(5423),
    [anon_sym_COLON_DASH] = ACTIONS(5423),
    [anon_sym_PERCENT] = ACTIONS(5423),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1791] = {
    [sym_concatenation] = STATE(2514),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2514),
    [anon_sym_RBRACE] = ACTIONS(5415),
    [anon_sym_EQ] = ACTIONS(5429),
    [anon_sym_DASH] = ACTIONS(5429),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(5433),
    [anon_sym_COLON] = ACTIONS(5429),
    [anon_sym_COLON_QMARK] = ACTIONS(5429),
    [anon_sym_COLON_DASH] = ACTIONS(5429),
    [anon_sym_PERCENT] = ACTIONS(5429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1792] = {
    [sym__simple_heredoc_body] = ACTIONS(2462),
    [sym__heredoc_body_beginning] = ACTIONS(2462),
    [sym_file_descriptor] = ACTIONS(2462),
    [sym__concat] = ACTIONS(2462),
    [sym_variable_name] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_SEMI_SEMI] = ACTIONS(2462),
    [anon_sym_RBRACE] = ACTIONS(2462),
    [anon_sym_PIPE_AMP] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_GT_GT] = ACTIONS(2462),
    [anon_sym_AMP_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT_GT] = ACTIONS(2462),
    [anon_sym_LT_AMP] = ACTIONS(2462),
    [anon_sym_GT_AMP] = ACTIONS(2462),
    [anon_sym_LT_LT] = ACTIONS(2464),
    [anon_sym_LT_LT_DASH] = ACTIONS(2462),
    [anon_sym_LT_LT_LT] = ACTIONS(2462),
    [anon_sym_DOLLAR] = ACTIONS(2464),
    [sym__special_character] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [sym_raw_string] = ACTIONS(2462),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2462),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2462),
    [anon_sym_BQUOTE] = ACTIONS(2462),
    [anon_sym_LT_LPAREN] = ACTIONS(2462),
    [anon_sym_GT_LPAREN] = ACTIONS(2462),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2464),
    [sym_word] = ACTIONS(2464),
    [anon_sym_LF] = ACTIONS(2462),
    [anon_sym_AMP] = ACTIONS(2464),
  },
  [1793] = {
    [sym_concatenation] = STATE(2517),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2517),
    [sym_regex] = ACTIONS(5435),
    [anon_sym_RBRACE] = ACTIONS(5437),
    [anon_sym_EQ] = ACTIONS(5439),
    [anon_sym_DASH] = ACTIONS(5439),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5441),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5439),
    [anon_sym_COLON_QMARK] = ACTIONS(5439),
    [anon_sym_COLON_DASH] = ACTIONS(5439),
    [anon_sym_PERCENT] = ACTIONS(5439),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1794] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(5437),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1795] = {
    [sym__simple_heredoc_body] = ACTIONS(2512),
    [sym__heredoc_body_beginning] = ACTIONS(2512),
    [sym_file_descriptor] = ACTIONS(2512),
    [sym__concat] = ACTIONS(2512),
    [sym_variable_name] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2514),
    [anon_sym_PIPE] = ACTIONS(2514),
    [anon_sym_SEMI_SEMI] = ACTIONS(2512),
    [anon_sym_RBRACE] = ACTIONS(2512),
    [anon_sym_PIPE_AMP] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE_PIPE] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2514),
    [anon_sym_GT] = ACTIONS(2514),
    [anon_sym_GT_GT] = ACTIONS(2512),
    [anon_sym_AMP_GT] = ACTIONS(2514),
    [anon_sym_AMP_GT_GT] = ACTIONS(2512),
    [anon_sym_LT_AMP] = ACTIONS(2512),
    [anon_sym_GT_AMP] = ACTIONS(2512),
    [anon_sym_LT_LT] = ACTIONS(2514),
    [anon_sym_LT_LT_DASH] = ACTIONS(2512),
    [anon_sym_LT_LT_LT] = ACTIONS(2512),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [sym__special_character] = ACTIONS(2514),
    [anon_sym_DQUOTE] = ACTIONS(2512),
    [sym_raw_string] = ACTIONS(2512),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2512),
    [anon_sym_BQUOTE] = ACTIONS(2512),
    [anon_sym_LT_LPAREN] = ACTIONS(2512),
    [anon_sym_GT_LPAREN] = ACTIONS(2512),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2514),
    [sym_word] = ACTIONS(2514),
    [anon_sym_LF] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2514),
  },
  [1796] = {
    [sym_concatenation] = STATE(2514),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2514),
    [sym_regex] = ACTIONS(5443),
    [anon_sym_RBRACE] = ACTIONS(5415),
    [anon_sym_EQ] = ACTIONS(5429),
    [anon_sym_DASH] = ACTIONS(5429),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5429),
    [anon_sym_COLON_QMARK] = ACTIONS(5429),
    [anon_sym_COLON_DASH] = ACTIONS(5429),
    [anon_sym_PERCENT] = ACTIONS(5429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1797] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(5415),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1798] = {
    [sym__simple_heredoc_body] = ACTIONS(2520),
    [sym__heredoc_body_beginning] = ACTIONS(2520),
    [sym_file_descriptor] = ACTIONS(2520),
    [sym__concat] = ACTIONS(2520),
    [sym_variable_name] = ACTIONS(2520),
    [anon_sym_SEMI] = ACTIONS(2522),
    [anon_sym_PIPE] = ACTIONS(2522),
    [anon_sym_SEMI_SEMI] = ACTIONS(2520),
    [anon_sym_RBRACE] = ACTIONS(2520),
    [anon_sym_PIPE_AMP] = ACTIONS(2520),
    [anon_sym_AMP_AMP] = ACTIONS(2520),
    [anon_sym_PIPE_PIPE] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(2522),
    [anon_sym_GT] = ACTIONS(2522),
    [anon_sym_GT_GT] = ACTIONS(2520),
    [anon_sym_AMP_GT] = ACTIONS(2522),
    [anon_sym_AMP_GT_GT] = ACTIONS(2520),
    [anon_sym_LT_AMP] = ACTIONS(2520),
    [anon_sym_GT_AMP] = ACTIONS(2520),
    [anon_sym_LT_LT] = ACTIONS(2522),
    [anon_sym_LT_LT_DASH] = ACTIONS(2520),
    [anon_sym_LT_LT_LT] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(2522),
    [sym__special_character] = ACTIONS(2522),
    [anon_sym_DQUOTE] = ACTIONS(2520),
    [sym_raw_string] = ACTIONS(2520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2520),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2520),
    [anon_sym_BQUOTE] = ACTIONS(2520),
    [anon_sym_LT_LPAREN] = ACTIONS(2520),
    [anon_sym_GT_LPAREN] = ACTIONS(2520),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2522),
    [sym_word] = ACTIONS(2522),
    [anon_sym_LF] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2522),
  },
  [1799] = {
    [sym__simple_heredoc_body] = ACTIONS(2554),
    [sym__heredoc_body_beginning] = ACTIONS(2554),
    [sym_file_descriptor] = ACTIONS(2554),
    [sym__concat] = ACTIONS(2554),
    [sym_variable_name] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(2556),
    [anon_sym_PIPE] = ACTIONS(2556),
    [anon_sym_SEMI_SEMI] = ACTIONS(2554),
    [anon_sym_RBRACE] = ACTIONS(2554),
    [anon_sym_PIPE_AMP] = ACTIONS(2554),
    [anon_sym_AMP_AMP] = ACTIONS(2554),
    [anon_sym_PIPE_PIPE] = ACTIONS(2554),
    [anon_sym_LT] = ACTIONS(2556),
    [anon_sym_GT] = ACTIONS(2556),
    [anon_sym_GT_GT] = ACTIONS(2554),
    [anon_sym_AMP_GT] = ACTIONS(2556),
    [anon_sym_AMP_GT_GT] = ACTIONS(2554),
    [anon_sym_LT_AMP] = ACTIONS(2554),
    [anon_sym_GT_AMP] = ACTIONS(2554),
    [anon_sym_LT_LT] = ACTIONS(2556),
    [anon_sym_LT_LT_DASH] = ACTIONS(2554),
    [anon_sym_LT_LT_LT] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2556),
    [sym__special_character] = ACTIONS(2556),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2554),
    [anon_sym_BQUOTE] = ACTIONS(2554),
    [anon_sym_LT_LPAREN] = ACTIONS(2554),
    [anon_sym_GT_LPAREN] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2556),
    [sym_word] = ACTIONS(2556),
    [anon_sym_LF] = ACTIONS(2554),
    [anon_sym_AMP] = ACTIONS(2556),
  },
  [1800] = {
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_RBRACE] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2364),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2364),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [1801] = {
    [sym_string] = STATE(1800),
    [sym_simple_expansion] = STATE(1800),
    [sym_string_expansion] = STATE(1800),
    [sym_expansion] = STATE(1800),
    [sym_command_substitution] = STATE(1800),
    [sym_process_substitution] = STATE(1800),
    [anon_sym_DOLLAR] = ACTIONS(5445),
    [sym__special_character] = ACTIONS(3755),
    [anon_sym_DQUOTE] = ACTIONS(813),
    [sym_raw_string] = ACTIONS(3755),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(817),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(819),
    [anon_sym_BQUOTE] = ACTIONS(821),
    [anon_sym_LT_LPAREN] = ACTIONS(823),
    [anon_sym_GT_LPAREN] = ACTIONS(823),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3755),
  },
  [1802] = {
    [aux_sym_concatenation_repeat1] = STATE(1802),
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(5447),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_RBRACE] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2364),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2364),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [1803] = {
    [sym__simple_heredoc_body] = ACTIONS(2371),
    [sym__heredoc_body_beginning] = ACTIONS(2371),
    [sym_file_descriptor] = ACTIONS(2371),
    [sym__concat] = ACTIONS(2371),
    [anon_sym_SEMI] = ACTIONS(2373),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_SEMI_SEMI] = ACTIONS(2371),
    [anon_sym_RBRACE] = ACTIONS(2371),
    [anon_sym_PIPE_AMP] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_GT_GT] = ACTIONS(2371),
    [anon_sym_AMP_GT] = ACTIONS(2373),
    [anon_sym_AMP_GT_GT] = ACTIONS(2371),
    [anon_sym_LT_AMP] = ACTIONS(2371),
    [anon_sym_GT_AMP] = ACTIONS(2371),
    [anon_sym_LT_LT] = ACTIONS(2373),
    [anon_sym_LT_LT_DASH] = ACTIONS(2371),
    [anon_sym_LT_LT_LT] = ACTIONS(2371),
    [anon_sym_DOLLAR] = ACTIONS(2373),
    [sym__special_character] = ACTIONS(2373),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [sym_raw_string] = ACTIONS(2371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2371),
    [anon_sym_BQUOTE] = ACTIONS(2371),
    [anon_sym_LT_LPAREN] = ACTIONS(2371),
    [anon_sym_GT_LPAREN] = ACTIONS(2371),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2373),
    [sym_word] = ACTIONS(2373),
    [anon_sym_LF] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
  },
  [1804] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(5450),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [1805] = {
    [sym_concatenation] = STATE(2523),
    [sym_string] = STATE(2522),
    [sym_simple_expansion] = STATE(2522),
    [sym_string_expansion] = STATE(2522),
    [sym_expansion] = STATE(2522),
    [sym_command_substitution] = STATE(2522),
    [sym_process_substitution] = STATE(2522),
    [aux_sym__literal_repeat1] = STATE(2524),
    [anon_sym_RBRACE] = ACTIONS(5452),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(5454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5454),
  },
  [1806] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(5456),
    [sym_comment] = ACTIONS(57),
  },
  [1807] = {
    [sym_concatenation] = STATE(2528),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2528),
    [anon_sym_RBRACE] = ACTIONS(5458),
    [anon_sym_EQ] = ACTIONS(5460),
    [anon_sym_DASH] = ACTIONS(5460),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5462),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(5464),
    [anon_sym_COLON] = ACTIONS(5460),
    [anon_sym_COLON_QMARK] = ACTIONS(5460),
    [anon_sym_COLON_DASH] = ACTIONS(5460),
    [anon_sym_PERCENT] = ACTIONS(5460),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1808] = {
    [sym_concatenation] = STATE(2530),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2530),
    [anon_sym_RBRACE] = ACTIONS(5452),
    [anon_sym_EQ] = ACTIONS(5466),
    [anon_sym_DASH] = ACTIONS(5466),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5468),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(5470),
    [anon_sym_COLON] = ACTIONS(5466),
    [anon_sym_COLON_QMARK] = ACTIONS(5466),
    [anon_sym_COLON_DASH] = ACTIONS(5466),
    [anon_sym_PERCENT] = ACTIONS(5466),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1809] = {
    [sym__simple_heredoc_body] = ACTIONS(2462),
    [sym__heredoc_body_beginning] = ACTIONS(2462),
    [sym_file_descriptor] = ACTIONS(2462),
    [sym__concat] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_SEMI_SEMI] = ACTIONS(2462),
    [anon_sym_RBRACE] = ACTIONS(2462),
    [anon_sym_PIPE_AMP] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_GT_GT] = ACTIONS(2462),
    [anon_sym_AMP_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT_GT] = ACTIONS(2462),
    [anon_sym_LT_AMP] = ACTIONS(2462),
    [anon_sym_GT_AMP] = ACTIONS(2462),
    [anon_sym_LT_LT] = ACTIONS(2464),
    [anon_sym_LT_LT_DASH] = ACTIONS(2462),
    [anon_sym_LT_LT_LT] = ACTIONS(2462),
    [anon_sym_DOLLAR] = ACTIONS(2464),
    [sym__special_character] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [sym_raw_string] = ACTIONS(2462),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2462),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2462),
    [anon_sym_BQUOTE] = ACTIONS(2462),
    [anon_sym_LT_LPAREN] = ACTIONS(2462),
    [anon_sym_GT_LPAREN] = ACTIONS(2462),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2464),
    [sym_word] = ACTIONS(2464),
    [anon_sym_LF] = ACTIONS(2462),
    [anon_sym_AMP] = ACTIONS(2464),
  },
  [1810] = {
    [sym_concatenation] = STATE(2533),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2533),
    [sym_regex] = ACTIONS(5472),
    [anon_sym_RBRACE] = ACTIONS(5474),
    [anon_sym_EQ] = ACTIONS(5476),
    [anon_sym_DASH] = ACTIONS(5476),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5478),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5476),
    [anon_sym_COLON_QMARK] = ACTIONS(5476),
    [anon_sym_COLON_DASH] = ACTIONS(5476),
    [anon_sym_PERCENT] = ACTIONS(5476),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1811] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(5474),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1812] = {
    [sym__simple_heredoc_body] = ACTIONS(2512),
    [sym__heredoc_body_beginning] = ACTIONS(2512),
    [sym_file_descriptor] = ACTIONS(2512),
    [sym__concat] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2514),
    [anon_sym_PIPE] = ACTIONS(2514),
    [anon_sym_SEMI_SEMI] = ACTIONS(2512),
    [anon_sym_RBRACE] = ACTIONS(2512),
    [anon_sym_PIPE_AMP] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE_PIPE] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2514),
    [anon_sym_GT] = ACTIONS(2514),
    [anon_sym_GT_GT] = ACTIONS(2512),
    [anon_sym_AMP_GT] = ACTIONS(2514),
    [anon_sym_AMP_GT_GT] = ACTIONS(2512),
    [anon_sym_LT_AMP] = ACTIONS(2512),
    [anon_sym_GT_AMP] = ACTIONS(2512),
    [anon_sym_LT_LT] = ACTIONS(2514),
    [anon_sym_LT_LT_DASH] = ACTIONS(2512),
    [anon_sym_LT_LT_LT] = ACTIONS(2512),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [sym__special_character] = ACTIONS(2514),
    [anon_sym_DQUOTE] = ACTIONS(2512),
    [sym_raw_string] = ACTIONS(2512),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2512),
    [anon_sym_BQUOTE] = ACTIONS(2512),
    [anon_sym_LT_LPAREN] = ACTIONS(2512),
    [anon_sym_GT_LPAREN] = ACTIONS(2512),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2514),
    [sym_word] = ACTIONS(2514),
    [anon_sym_LF] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2514),
  },
  [1813] = {
    [sym_concatenation] = STATE(2530),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2530),
    [sym_regex] = ACTIONS(5480),
    [anon_sym_RBRACE] = ACTIONS(5452),
    [anon_sym_EQ] = ACTIONS(5466),
    [anon_sym_DASH] = ACTIONS(5466),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5468),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5466),
    [anon_sym_COLON_QMARK] = ACTIONS(5466),
    [anon_sym_COLON_DASH] = ACTIONS(5466),
    [anon_sym_PERCENT] = ACTIONS(5466),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1814] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(5452),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1815] = {
    [sym__simple_heredoc_body] = ACTIONS(2520),
    [sym__heredoc_body_beginning] = ACTIONS(2520),
    [sym_file_descriptor] = ACTIONS(2520),
    [sym__concat] = ACTIONS(2520),
    [anon_sym_SEMI] = ACTIONS(2522),
    [anon_sym_PIPE] = ACTIONS(2522),
    [anon_sym_SEMI_SEMI] = ACTIONS(2520),
    [anon_sym_RBRACE] = ACTIONS(2520),
    [anon_sym_PIPE_AMP] = ACTIONS(2520),
    [anon_sym_AMP_AMP] = ACTIONS(2520),
    [anon_sym_PIPE_PIPE] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(2522),
    [anon_sym_GT] = ACTIONS(2522),
    [anon_sym_GT_GT] = ACTIONS(2520),
    [anon_sym_AMP_GT] = ACTIONS(2522),
    [anon_sym_AMP_GT_GT] = ACTIONS(2520),
    [anon_sym_LT_AMP] = ACTIONS(2520),
    [anon_sym_GT_AMP] = ACTIONS(2520),
    [anon_sym_LT_LT] = ACTIONS(2522),
    [anon_sym_LT_LT_DASH] = ACTIONS(2520),
    [anon_sym_LT_LT_LT] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(2522),
    [sym__special_character] = ACTIONS(2522),
    [anon_sym_DQUOTE] = ACTIONS(2520),
    [sym_raw_string] = ACTIONS(2520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2520),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2520),
    [anon_sym_BQUOTE] = ACTIONS(2520),
    [anon_sym_LT_LPAREN] = ACTIONS(2520),
    [anon_sym_GT_LPAREN] = ACTIONS(2520),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2522),
    [sym_word] = ACTIONS(2522),
    [anon_sym_LF] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2522),
  },
  [1816] = {
    [sym__simple_heredoc_body] = ACTIONS(2554),
    [sym__heredoc_body_beginning] = ACTIONS(2554),
    [sym_file_descriptor] = ACTIONS(2554),
    [sym__concat] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(2556),
    [anon_sym_PIPE] = ACTIONS(2556),
    [anon_sym_SEMI_SEMI] = ACTIONS(2554),
    [anon_sym_RBRACE] = ACTIONS(2554),
    [anon_sym_PIPE_AMP] = ACTIONS(2554),
    [anon_sym_AMP_AMP] = ACTIONS(2554),
    [anon_sym_PIPE_PIPE] = ACTIONS(2554),
    [anon_sym_LT] = ACTIONS(2556),
    [anon_sym_GT] = ACTIONS(2556),
    [anon_sym_GT_GT] = ACTIONS(2554),
    [anon_sym_AMP_GT] = ACTIONS(2556),
    [anon_sym_AMP_GT_GT] = ACTIONS(2554),
    [anon_sym_LT_AMP] = ACTIONS(2554),
    [anon_sym_GT_AMP] = ACTIONS(2554),
    [anon_sym_LT_LT] = ACTIONS(2556),
    [anon_sym_LT_LT_DASH] = ACTIONS(2554),
    [anon_sym_LT_LT_LT] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2556),
    [sym__special_character] = ACTIONS(2556),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2554),
    [anon_sym_BQUOTE] = ACTIONS(2554),
    [anon_sym_LT_LPAREN] = ACTIONS(2554),
    [anon_sym_GT_LPAREN] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2556),
    [sym_word] = ACTIONS(2556),
    [anon_sym_LF] = ACTIONS(2554),
    [anon_sym_AMP] = ACTIONS(2556),
  },
  [1817] = {
    [sym_string] = STATE(487),
    [sym__simple_heredoc_body] = ACTIONS(4071),
    [sym__heredoc_body_beginning] = ACTIONS(4071),
    [sym_file_descriptor] = ACTIONS(4071),
    [anon_sym_SEMI] = ACTIONS(4073),
    [anon_sym_PIPE] = ACTIONS(4073),
    [anon_sym_SEMI_SEMI] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(4071),
    [anon_sym_PIPE_AMP] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_PIPE_PIPE] = ACTIONS(4071),
    [anon_sym_EQ_TILDE] = ACTIONS(4073),
    [anon_sym_EQ_EQ] = ACTIONS(4073),
    [anon_sym_LT] = ACTIONS(4073),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_GT_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT] = ACTIONS(4073),
    [anon_sym_AMP_GT_GT] = ACTIONS(4071),
    [anon_sym_LT_AMP] = ACTIONS(4071),
    [anon_sym_GT_AMP] = ACTIONS(4071),
    [anon_sym_LT_LT] = ACTIONS(4073),
    [anon_sym_LT_LT_DASH] = ACTIONS(4071),
    [anon_sym_LT_LT_LT] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(5482),
    [anon_sym_DOLLAR] = ACTIONS(5482),
    [sym__special_character] = ACTIONS(4073),
    [anon_sym_DQUOTE] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(831),
    [anon_sym_POUND] = ACTIONS(829),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4071),
    [anon_sym_BQUOTE] = ACTIONS(4071),
    [anon_sym_LT_LPAREN] = ACTIONS(4071),
    [anon_sym_GT_LPAREN] = ACTIONS(4071),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(833),
    [anon_sym_STAR] = ACTIONS(833),
    [anon_sym_AT] = ACTIONS(833),
    [anon_sym_QMARK] = ACTIONS(833),
    [anon_sym_0] = ACTIONS(833),
    [anon_sym__] = ACTIONS(833),
    [sym_word] = ACTIONS(4073),
    [anon_sym_LF] = ACTIONS(4071),
    [anon_sym_AMP] = ACTIONS(4073),
  },
  [1818] = {
    [sym__simple_heredoc_body] = ACTIONS(4111),
    [sym__heredoc_body_beginning] = ACTIONS(4111),
    [sym_file_descriptor] = ACTIONS(4111),
    [sym__concat] = ACTIONS(4111),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_PIPE] = ACTIONS(4113),
    [anon_sym_SEMI_SEMI] = ACTIONS(4111),
    [anon_sym_RBRACE] = ACTIONS(4111),
    [anon_sym_PIPE_AMP] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_EQ_TILDE] = ACTIONS(4113),
    [anon_sym_EQ_EQ] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4113),
    [anon_sym_GT_GT] = ACTIONS(4111),
    [anon_sym_AMP_GT] = ACTIONS(4113),
    [anon_sym_AMP_GT_GT] = ACTIONS(4111),
    [anon_sym_LT_AMP] = ACTIONS(4111),
    [anon_sym_GT_AMP] = ACTIONS(4111),
    [anon_sym_LT_LT] = ACTIONS(4113),
    [anon_sym_LT_LT_DASH] = ACTIONS(4111),
    [anon_sym_LT_LT_LT] = ACTIONS(4111),
    [anon_sym_DOLLAR] = ACTIONS(4113),
    [sym__special_character] = ACTIONS(4113),
    [anon_sym_DQUOTE] = ACTIONS(4111),
    [sym_raw_string] = ACTIONS(4111),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4111),
    [anon_sym_BQUOTE] = ACTIONS(4111),
    [anon_sym_LT_LPAREN] = ACTIONS(4111),
    [anon_sym_GT_LPAREN] = ACTIONS(4111),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4113),
    [anon_sym_LF] = ACTIONS(4111),
    [anon_sym_AMP] = ACTIONS(4113),
  },
  [1819] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_RBRACE] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_EQ_TILDE] = ACTIONS(4127),
    [anon_sym_EQ_EQ] = ACTIONS(4127),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym__special_character] = ACTIONS(4127),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [1820] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(5484),
    [sym_comment] = ACTIONS(57),
  },
  [1821] = {
    [anon_sym_RBRACE] = ACTIONS(5484),
    [sym_comment] = ACTIONS(57),
  },
  [1822] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(5486),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [1823] = {
    [sym_concatenation] = STATE(2538),
    [sym_string] = STATE(2537),
    [sym_simple_expansion] = STATE(2537),
    [sym_string_expansion] = STATE(2537),
    [sym_expansion] = STATE(2537),
    [sym_command_substitution] = STATE(2537),
    [sym_process_substitution] = STATE(2537),
    [aux_sym__literal_repeat1] = STATE(2539),
    [anon_sym_RBRACE] = ACTIONS(5484),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(5488),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5488),
  },
  [1824] = {
    [sym__simple_heredoc_body] = ACTIONS(4161),
    [sym__heredoc_body_beginning] = ACTIONS(4161),
    [sym_file_descriptor] = ACTIONS(4161),
    [sym__concat] = ACTIONS(4161),
    [anon_sym_SEMI] = ACTIONS(4163),
    [anon_sym_PIPE] = ACTIONS(4163),
    [anon_sym_SEMI_SEMI] = ACTIONS(4161),
    [anon_sym_RBRACE] = ACTIONS(4161),
    [anon_sym_PIPE_AMP] = ACTIONS(4161),
    [anon_sym_AMP_AMP] = ACTIONS(4161),
    [anon_sym_PIPE_PIPE] = ACTIONS(4161),
    [anon_sym_EQ_TILDE] = ACTIONS(4163),
    [anon_sym_EQ_EQ] = ACTIONS(4163),
    [anon_sym_LT] = ACTIONS(4163),
    [anon_sym_GT] = ACTIONS(4163),
    [anon_sym_GT_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT] = ACTIONS(4163),
    [anon_sym_AMP_GT_GT] = ACTIONS(4161),
    [anon_sym_LT_AMP] = ACTIONS(4161),
    [anon_sym_GT_AMP] = ACTIONS(4161),
    [anon_sym_LT_LT] = ACTIONS(4163),
    [anon_sym_LT_LT_DASH] = ACTIONS(4161),
    [anon_sym_LT_LT_LT] = ACTIONS(4161),
    [anon_sym_DOLLAR] = ACTIONS(4163),
    [sym__special_character] = ACTIONS(4163),
    [anon_sym_DQUOTE] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4161),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4161),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4161),
    [anon_sym_BQUOTE] = ACTIONS(4161),
    [anon_sym_LT_LPAREN] = ACTIONS(4161),
    [anon_sym_GT_LPAREN] = ACTIONS(4161),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4163),
    [anon_sym_LF] = ACTIONS(4161),
    [anon_sym_AMP] = ACTIONS(4163),
  },
  [1825] = {
    [sym_concatenation] = STATE(2542),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2542),
    [sym_regex] = ACTIONS(5490),
    [anon_sym_RBRACE] = ACTIONS(5492),
    [anon_sym_EQ] = ACTIONS(5494),
    [anon_sym_DASH] = ACTIONS(5494),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5496),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5494),
    [anon_sym_COLON_QMARK] = ACTIONS(5494),
    [anon_sym_COLON_DASH] = ACTIONS(5494),
    [anon_sym_PERCENT] = ACTIONS(5494),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1826] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(5492),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1827] = {
    [sym_concatenation] = STATE(2544),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2544),
    [sym_regex] = ACTIONS(5498),
    [anon_sym_RBRACE] = ACTIONS(5484),
    [anon_sym_EQ] = ACTIONS(5500),
    [anon_sym_DASH] = ACTIONS(5500),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5502),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5500),
    [anon_sym_COLON_QMARK] = ACTIONS(5500),
    [anon_sym_COLON_DASH] = ACTIONS(5500),
    [anon_sym_PERCENT] = ACTIONS(5500),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1828] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(5484),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1829] = {
    [sym_concatenation] = STATE(2546),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2546),
    [anon_sym_RBRACE] = ACTIONS(5504),
    [anon_sym_EQ] = ACTIONS(5506),
    [anon_sym_DASH] = ACTIONS(5506),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5508),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5506),
    [anon_sym_COLON_QMARK] = ACTIONS(5506),
    [anon_sym_COLON_DASH] = ACTIONS(5506),
    [anon_sym_PERCENT] = ACTIONS(5506),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1830] = {
    [sym__simple_heredoc_body] = ACTIONS(4219),
    [sym__heredoc_body_beginning] = ACTIONS(4219),
    [sym_file_descriptor] = ACTIONS(4219),
    [sym__concat] = ACTIONS(4219),
    [anon_sym_SEMI] = ACTIONS(4221),
    [anon_sym_PIPE] = ACTIONS(4221),
    [anon_sym_SEMI_SEMI] = ACTIONS(4219),
    [anon_sym_RBRACE] = ACTIONS(4219),
    [anon_sym_PIPE_AMP] = ACTIONS(4219),
    [anon_sym_AMP_AMP] = ACTIONS(4219),
    [anon_sym_PIPE_PIPE] = ACTIONS(4219),
    [anon_sym_EQ_TILDE] = ACTIONS(4221),
    [anon_sym_EQ_EQ] = ACTIONS(4221),
    [anon_sym_LT] = ACTIONS(4221),
    [anon_sym_GT] = ACTIONS(4221),
    [anon_sym_GT_GT] = ACTIONS(4219),
    [anon_sym_AMP_GT] = ACTIONS(4221),
    [anon_sym_AMP_GT_GT] = ACTIONS(4219),
    [anon_sym_LT_AMP] = ACTIONS(4219),
    [anon_sym_GT_AMP] = ACTIONS(4219),
    [anon_sym_LT_LT] = ACTIONS(4221),
    [anon_sym_LT_LT_DASH] = ACTIONS(4219),
    [anon_sym_LT_LT_LT] = ACTIONS(4219),
    [anon_sym_DOLLAR] = ACTIONS(4221),
    [sym__special_character] = ACTIONS(4221),
    [anon_sym_DQUOTE] = ACTIONS(4219),
    [sym_raw_string] = ACTIONS(4219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4219),
    [anon_sym_BQUOTE] = ACTIONS(4219),
    [anon_sym_LT_LPAREN] = ACTIONS(4219),
    [anon_sym_GT_LPAREN] = ACTIONS(4219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4221),
    [anon_sym_LF] = ACTIONS(4219),
    [anon_sym_AMP] = ACTIONS(4221),
  },
  [1831] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(5504),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1832] = {
    [sym_concatenation] = STATE(2544),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2544),
    [anon_sym_RBRACE] = ACTIONS(5484),
    [anon_sym_EQ] = ACTIONS(5500),
    [anon_sym_DASH] = ACTIONS(5500),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5502),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5500),
    [anon_sym_COLON_QMARK] = ACTIONS(5500),
    [anon_sym_COLON_DASH] = ACTIONS(5500),
    [anon_sym_PERCENT] = ACTIONS(5500),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1833] = {
    [sym__simple_heredoc_body] = ACTIONS(4324),
    [sym__heredoc_body_beginning] = ACTIONS(4324),
    [sym_file_descriptor] = ACTIONS(4324),
    [anon_sym_SEMI] = ACTIONS(4326),
    [anon_sym_PIPE] = ACTIONS(4326),
    [anon_sym_SEMI_SEMI] = ACTIONS(4324),
    [anon_sym_RBRACE] = ACTIONS(4324),
    [anon_sym_PIPE_AMP] = ACTIONS(4324),
    [anon_sym_AMP_AMP] = ACTIONS(4324),
    [anon_sym_PIPE_PIPE] = ACTIONS(4324),
    [anon_sym_LT] = ACTIONS(4326),
    [anon_sym_GT] = ACTIONS(4326),
    [anon_sym_GT_GT] = ACTIONS(4324),
    [anon_sym_AMP_GT] = ACTIONS(4326),
    [anon_sym_AMP_GT_GT] = ACTIONS(4324),
    [anon_sym_LT_AMP] = ACTIONS(4324),
    [anon_sym_GT_AMP] = ACTIONS(4324),
    [anon_sym_LT_LT] = ACTIONS(4326),
    [anon_sym_LT_LT_DASH] = ACTIONS(4324),
    [anon_sym_LT_LT_LT] = ACTIONS(4324),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4324),
    [anon_sym_AMP] = ACTIONS(4326),
  },
  [1834] = {
    [anon_sym_SEMI] = ACTIONS(4358),
    [anon_sym_SEMI_SEMI] = ACTIONS(4356),
    [anon_sym_RBRACE] = ACTIONS(4356),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4356),
    [anon_sym_AMP] = ACTIONS(4356),
  },
  [1835] = {
    [aux_sym_concatenation_repeat1] = STATE(1838),
    [sym__simple_heredoc_body] = ACTIONS(1380),
    [sym__heredoc_body_beginning] = ACTIONS(1380),
    [sym_file_descriptor] = ACTIONS(1380),
    [sym__concat] = ACTIONS(837),
    [anon_sym_SEMI] = ACTIONS(1382),
    [anon_sym_PIPE] = ACTIONS(1382),
    [anon_sym_SEMI_SEMI] = ACTIONS(1380),
    [anon_sym_RBRACE] = ACTIONS(1380),
    [anon_sym_PIPE_AMP] = ACTIONS(1380),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_PIPE_PIPE] = ACTIONS(1380),
    [anon_sym_LT] = ACTIONS(1382),
    [anon_sym_GT] = ACTIONS(1382),
    [anon_sym_GT_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT] = ACTIONS(1382),
    [anon_sym_AMP_GT_GT] = ACTIONS(1380),
    [anon_sym_LT_AMP] = ACTIONS(1380),
    [anon_sym_GT_AMP] = ACTIONS(1380),
    [anon_sym_LT_LT] = ACTIONS(1382),
    [anon_sym_LT_LT_DASH] = ACTIONS(1380),
    [anon_sym_LT_LT_LT] = ACTIONS(1380),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1380),
    [anon_sym_AMP] = ACTIONS(1382),
  },
  [1836] = {
    [sym__simple_heredoc_body] = ACTIONS(1380),
    [sym__heredoc_body_beginning] = ACTIONS(1380),
    [sym_file_descriptor] = ACTIONS(1380),
    [anon_sym_SEMI] = ACTIONS(1382),
    [anon_sym_PIPE] = ACTIONS(1382),
    [anon_sym_SEMI_SEMI] = ACTIONS(1380),
    [anon_sym_RBRACE] = ACTIONS(1380),
    [anon_sym_PIPE_AMP] = ACTIONS(1380),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_PIPE_PIPE] = ACTIONS(1380),
    [anon_sym_LT] = ACTIONS(1382),
    [anon_sym_GT] = ACTIONS(1382),
    [anon_sym_GT_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT] = ACTIONS(1382),
    [anon_sym_AMP_GT_GT] = ACTIONS(1380),
    [anon_sym_LT_AMP] = ACTIONS(1380),
    [anon_sym_GT_AMP] = ACTIONS(1380),
    [anon_sym_LT_LT] = ACTIONS(1382),
    [anon_sym_LT_LT_DASH] = ACTIONS(1380),
    [anon_sym_LT_LT_LT] = ACTIONS(1380),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1380),
    [anon_sym_AMP] = ACTIONS(1382),
  },
  [1837] = {
    [aux_sym__literal_repeat1] = STATE(1839),
    [sym__simple_heredoc_body] = ACTIONS(1384),
    [sym__heredoc_body_beginning] = ACTIONS(1384),
    [sym_file_descriptor] = ACTIONS(1384),
    [anon_sym_SEMI] = ACTIONS(1386),
    [anon_sym_PIPE] = ACTIONS(1386),
    [anon_sym_SEMI_SEMI] = ACTIONS(1384),
    [anon_sym_RBRACE] = ACTIONS(1384),
    [anon_sym_PIPE_AMP] = ACTIONS(1384),
    [anon_sym_AMP_AMP] = ACTIONS(1384),
    [anon_sym_PIPE_PIPE] = ACTIONS(1384),
    [anon_sym_LT] = ACTIONS(1386),
    [anon_sym_GT] = ACTIONS(1386),
    [anon_sym_GT_GT] = ACTIONS(1384),
    [anon_sym_AMP_GT] = ACTIONS(1386),
    [anon_sym_AMP_GT_GT] = ACTIONS(1384),
    [anon_sym_LT_AMP] = ACTIONS(1384),
    [anon_sym_GT_AMP] = ACTIONS(1384),
    [anon_sym_LT_LT] = ACTIONS(1386),
    [anon_sym_LT_LT_DASH] = ACTIONS(1384),
    [anon_sym_LT_LT_LT] = ACTIONS(1384),
    [sym__special_character] = ACTIONS(891),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1384),
    [anon_sym_AMP] = ACTIONS(1386),
  },
  [1838] = {
    [aux_sym_concatenation_repeat1] = STATE(2548),
    [sym__simple_heredoc_body] = ACTIONS(1071),
    [sym__heredoc_body_beginning] = ACTIONS(1071),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(5510),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1075),
  },
  [1839] = {
    [aux_sym__literal_repeat1] = STATE(1839),
    [sym__simple_heredoc_body] = ACTIONS(1373),
    [sym__heredoc_body_beginning] = ACTIONS(1373),
    [sym_file_descriptor] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_RBRACE] = ACTIONS(1373),
    [anon_sym_PIPE_AMP] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_LT_LT_DASH] = ACTIONS(1373),
    [anon_sym_LT_LT_LT] = ACTIONS(1373),
    [sym__special_character] = ACTIONS(2105),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
  },
  [1840] = {
    [sym_file_descriptor] = ACTIONS(2604),
    [sym_variable_name] = ACTIONS(2604),
    [anon_sym_for] = ACTIONS(2608),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2608),
    [anon_sym_if] = ACTIONS(2608),
    [anon_sym_case] = ACTIONS(2608),
    [anon_sym_function] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(2608),
    [anon_sym_LBRACE] = ACTIONS(2604),
    [anon_sym_RBRACE] = ACTIONS(4379),
    [anon_sym_BANG] = ACTIONS(2608),
    [anon_sym_LBRACK] = ACTIONS(2608),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2604),
    [anon_sym_declare] = ACTIONS(2608),
    [anon_sym_typeset] = ACTIONS(2608),
    [anon_sym_export] = ACTIONS(2608),
    [anon_sym_readonly] = ACTIONS(2608),
    [anon_sym_local] = ACTIONS(2608),
    [anon_sym_unset] = ACTIONS(2608),
    [anon_sym_unsetenv] = ACTIONS(2608),
    [anon_sym_LT] = ACTIONS(2608),
    [anon_sym_GT] = ACTIONS(2608),
    [anon_sym_GT_GT] = ACTIONS(2604),
    [anon_sym_AMP_GT] = ACTIONS(2608),
    [anon_sym_AMP_GT_GT] = ACTIONS(2604),
    [anon_sym_LT_AMP] = ACTIONS(2604),
    [anon_sym_GT_AMP] = ACTIONS(2604),
    [anon_sym_DOLLAR] = ACTIONS(2608),
    [sym__special_character] = ACTIONS(2608),
    [anon_sym_DQUOTE] = ACTIONS(2604),
    [sym_raw_string] = ACTIONS(2604),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2604),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2604),
    [anon_sym_BQUOTE] = ACTIONS(2604),
    [anon_sym_LT_LPAREN] = ACTIONS(2604),
    [anon_sym_GT_LPAREN] = ACTIONS(2604),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2608),
  },
  [1841] = {
    [sym_file_descriptor] = ACTIONS(2719),
    [sym_variable_name] = ACTIONS(2719),
    [anon_sym_LT] = ACTIONS(2721),
    [anon_sym_GT] = ACTIONS(2721),
    [anon_sym_GT_GT] = ACTIONS(2719),
    [anon_sym_AMP_GT] = ACTIONS(2721),
    [anon_sym_AMP_GT_GT] = ACTIONS(2719),
    [anon_sym_LT_AMP] = ACTIONS(2719),
    [anon_sym_GT_AMP] = ACTIONS(2719),
    [anon_sym_DOLLAR] = ACTIONS(2721),
    [sym__special_character] = ACTIONS(2719),
    [anon_sym_DQUOTE] = ACTIONS(2719),
    [sym_raw_string] = ACTIONS(2719),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2719),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2719),
    [anon_sym_BQUOTE] = ACTIONS(2719),
    [anon_sym_LT_LPAREN] = ACTIONS(2719),
    [anon_sym_GT_LPAREN] = ACTIONS(2719),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2719),
  },
  [1842] = {
    [sym_concatenation] = STATE(1368),
    [sym_string] = STATE(730),
    [sym_simple_expansion] = STATE(730),
    [sym_string_expansion] = STATE(730),
    [sym_expansion] = STATE(730),
    [sym_command_substitution] = STATE(730),
    [sym_process_substitution] = STATE(730),
    [aux_sym_for_statement_repeat1] = STATE(1368),
    [aux_sym__literal_repeat1] = STATE(736),
    [anon_sym_RPAREN] = ACTIONS(5512),
    [anon_sym_DOLLAR] = ACTIONS(1406),
    [sym__special_character] = ACTIONS(1408),
    [anon_sym_DQUOTE] = ACTIONS(1410),
    [sym_raw_string] = ACTIONS(1412),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1414),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1416),
    [anon_sym_BQUOTE] = ACTIONS(1418),
    [anon_sym_LT_LPAREN] = ACTIONS(1420),
    [anon_sym_GT_LPAREN] = ACTIONS(1420),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1412),
  },
  [1843] = {
    [sym_string] = STATE(528),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_PIPE_PIPE] = ACTIONS(4071),
    [anon_sym_RBRACK] = ACTIONS(4071),
    [anon_sym_EQ_TILDE] = ACTIONS(4071),
    [anon_sym_EQ_EQ] = ACTIONS(4071),
    [anon_sym_EQ] = ACTIONS(4073),
    [anon_sym_PLUS_EQ] = ACTIONS(4071),
    [anon_sym_LT] = ACTIONS(4073),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_BANG_EQ] = ACTIONS(4071),
    [anon_sym_PLUS] = ACTIONS(4073),
    [anon_sym_DASH] = ACTIONS(5514),
    [anon_sym_DASH_EQ] = ACTIONS(4071),
    [anon_sym_LT_EQ] = ACTIONS(4071),
    [anon_sym_GT_EQ] = ACTIONS(4071),
    [anon_sym_PLUS_PLUS] = ACTIONS(4071),
    [anon_sym_DASH_DASH] = ACTIONS(4071),
    [anon_sym_DOLLAR] = ACTIONS(899),
    [anon_sym_DQUOTE] = ACTIONS(233),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_POUND] = ACTIONS(899),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(903),
    [anon_sym_STAR] = ACTIONS(905),
    [anon_sym_AT] = ACTIONS(905),
    [anon_sym_QMARK] = ACTIONS(905),
    [anon_sym_0] = ACTIONS(903),
    [anon_sym__] = ACTIONS(903),
    [sym_test_operator] = ACTIONS(4071),
  },
  [1844] = {
    [sym__concat] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_RBRACK] = ACTIONS(4111),
    [anon_sym_EQ_TILDE] = ACTIONS(4111),
    [anon_sym_EQ_EQ] = ACTIONS(4111),
    [anon_sym_EQ] = ACTIONS(4113),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_LT] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4113),
    [anon_sym_BANG_EQ] = ACTIONS(4111),
    [anon_sym_PLUS] = ACTIONS(4113),
    [anon_sym_DASH] = ACTIONS(4113),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_PLUS_PLUS] = ACTIONS(4111),
    [anon_sym_DASH_DASH] = ACTIONS(4111),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4111),
  },
  [1845] = {
    [sym__concat] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_RBRACK] = ACTIONS(4125),
    [anon_sym_EQ_TILDE] = ACTIONS(4125),
    [anon_sym_EQ_EQ] = ACTIONS(4125),
    [anon_sym_EQ] = ACTIONS(4127),
    [anon_sym_PLUS_EQ] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_BANG_EQ] = ACTIONS(4125),
    [anon_sym_PLUS] = ACTIONS(4127),
    [anon_sym_DASH] = ACTIONS(4127),
    [anon_sym_DASH_EQ] = ACTIONS(4125),
    [anon_sym_LT_EQ] = ACTIONS(4125),
    [anon_sym_GT_EQ] = ACTIONS(4125),
    [anon_sym_PLUS_PLUS] = ACTIONS(4125),
    [anon_sym_DASH_DASH] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4125),
  },
  [1846] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(5516),
    [sym_comment] = ACTIONS(57),
  },
  [1847] = {
    [anon_sym_RBRACE] = ACTIONS(5516),
    [sym_comment] = ACTIONS(57),
  },
  [1848] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(5518),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [1849] = {
    [sym_concatenation] = STATE(2553),
    [sym_string] = STATE(2552),
    [sym_simple_expansion] = STATE(2552),
    [sym_string_expansion] = STATE(2552),
    [sym_expansion] = STATE(2552),
    [sym_command_substitution] = STATE(2552),
    [sym_process_substitution] = STATE(2552),
    [aux_sym__literal_repeat1] = STATE(2554),
    [anon_sym_RBRACE] = ACTIONS(5516),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(5520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5520),
  },
  [1850] = {
    [sym__concat] = ACTIONS(4161),
    [anon_sym_AMP_AMP] = ACTIONS(4161),
    [anon_sym_PIPE_PIPE] = ACTIONS(4161),
    [anon_sym_RBRACK] = ACTIONS(4161),
    [anon_sym_EQ_TILDE] = ACTIONS(4161),
    [anon_sym_EQ_EQ] = ACTIONS(4161),
    [anon_sym_EQ] = ACTIONS(4163),
    [anon_sym_PLUS_EQ] = ACTIONS(4161),
    [anon_sym_LT] = ACTIONS(4163),
    [anon_sym_GT] = ACTIONS(4163),
    [anon_sym_BANG_EQ] = ACTIONS(4161),
    [anon_sym_PLUS] = ACTIONS(4163),
    [anon_sym_DASH] = ACTIONS(4163),
    [anon_sym_DASH_EQ] = ACTIONS(4161),
    [anon_sym_LT_EQ] = ACTIONS(4161),
    [anon_sym_GT_EQ] = ACTIONS(4161),
    [anon_sym_PLUS_PLUS] = ACTIONS(4161),
    [anon_sym_DASH_DASH] = ACTIONS(4161),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4161),
  },
  [1851] = {
    [sym_concatenation] = STATE(2557),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2557),
    [sym_regex] = ACTIONS(5522),
    [anon_sym_RBRACE] = ACTIONS(5524),
    [anon_sym_EQ] = ACTIONS(5526),
    [anon_sym_DASH] = ACTIONS(5526),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5528),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5526),
    [anon_sym_COLON_QMARK] = ACTIONS(5526),
    [anon_sym_COLON_DASH] = ACTIONS(5526),
    [anon_sym_PERCENT] = ACTIONS(5526),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1852] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(5524),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1853] = {
    [sym_concatenation] = STATE(2559),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2559),
    [sym_regex] = ACTIONS(5530),
    [anon_sym_RBRACE] = ACTIONS(5516),
    [anon_sym_EQ] = ACTIONS(5532),
    [anon_sym_DASH] = ACTIONS(5532),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5532),
    [anon_sym_COLON_QMARK] = ACTIONS(5532),
    [anon_sym_COLON_DASH] = ACTIONS(5532),
    [anon_sym_PERCENT] = ACTIONS(5532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1854] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(5516),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1855] = {
    [sym_concatenation] = STATE(2561),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2561),
    [anon_sym_RBRACE] = ACTIONS(5536),
    [anon_sym_EQ] = ACTIONS(5538),
    [anon_sym_DASH] = ACTIONS(5538),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5540),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5538),
    [anon_sym_COLON_QMARK] = ACTIONS(5538),
    [anon_sym_COLON_DASH] = ACTIONS(5538),
    [anon_sym_PERCENT] = ACTIONS(5538),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1856] = {
    [sym__concat] = ACTIONS(4219),
    [anon_sym_AMP_AMP] = ACTIONS(4219),
    [anon_sym_PIPE_PIPE] = ACTIONS(4219),
    [anon_sym_RBRACK] = ACTIONS(4219),
    [anon_sym_EQ_TILDE] = ACTIONS(4219),
    [anon_sym_EQ_EQ] = ACTIONS(4219),
    [anon_sym_EQ] = ACTIONS(4221),
    [anon_sym_PLUS_EQ] = ACTIONS(4219),
    [anon_sym_LT] = ACTIONS(4221),
    [anon_sym_GT] = ACTIONS(4221),
    [anon_sym_BANG_EQ] = ACTIONS(4219),
    [anon_sym_PLUS] = ACTIONS(4221),
    [anon_sym_DASH] = ACTIONS(4221),
    [anon_sym_DASH_EQ] = ACTIONS(4219),
    [anon_sym_LT_EQ] = ACTIONS(4219),
    [anon_sym_GT_EQ] = ACTIONS(4219),
    [anon_sym_PLUS_PLUS] = ACTIONS(4219),
    [anon_sym_DASH_DASH] = ACTIONS(4219),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4219),
  },
  [1857] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(5536),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1858] = {
    [sym_concatenation] = STATE(2559),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2559),
    [anon_sym_RBRACE] = ACTIONS(5516),
    [anon_sym_EQ] = ACTIONS(5532),
    [anon_sym_DASH] = ACTIONS(5532),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5532),
    [anon_sym_COLON_QMARK] = ACTIONS(5532),
    [anon_sym_COLON_DASH] = ACTIONS(5532),
    [anon_sym_PERCENT] = ACTIONS(5532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1859] = {
    [sym__simple_heredoc_body] = ACTIONS(2719),
    [sym__heredoc_body_beginning] = ACTIONS(2719),
    [sym_file_descriptor] = ACTIONS(2719),
    [sym_variable_name] = ACTIONS(2719),
    [ts_builtin_sym_end] = ACTIONS(2719),
    [anon_sym_SEMI] = ACTIONS(2721),
    [anon_sym_PIPE] = ACTIONS(2721),
    [anon_sym_RPAREN] = ACTIONS(2719),
    [anon_sym_SEMI_SEMI] = ACTIONS(2719),
    [anon_sym_PIPE_AMP] = ACTIONS(2719),
    [anon_sym_AMP_AMP] = ACTIONS(2719),
    [anon_sym_PIPE_PIPE] = ACTIONS(2719),
    [anon_sym_LT] = ACTIONS(2721),
    [anon_sym_GT] = ACTIONS(2721),
    [anon_sym_GT_GT] = ACTIONS(2719),
    [anon_sym_AMP_GT] = ACTIONS(2721),
    [anon_sym_AMP_GT_GT] = ACTIONS(2719),
    [anon_sym_LT_AMP] = ACTIONS(2719),
    [anon_sym_GT_AMP] = ACTIONS(2719),
    [anon_sym_LT_LT] = ACTIONS(2721),
    [anon_sym_LT_LT_DASH] = ACTIONS(2719),
    [anon_sym_LT_LT_LT] = ACTIONS(2719),
    [anon_sym_DOLLAR] = ACTIONS(2721),
    [sym__special_character] = ACTIONS(2719),
    [anon_sym_DQUOTE] = ACTIONS(2719),
    [sym_raw_string] = ACTIONS(2719),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2719),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2719),
    [anon_sym_BQUOTE] = ACTIONS(2719),
    [anon_sym_LT_LPAREN] = ACTIONS(2719),
    [anon_sym_GT_LPAREN] = ACTIONS(2719),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2721),
    [sym_word] = ACTIONS(2721),
    [anon_sym_LF] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2721),
  },
  [1860] = {
    [sym_concatenation] = STATE(1368),
    [sym_string] = STATE(730),
    [sym_simple_expansion] = STATE(730),
    [sym_string_expansion] = STATE(730),
    [sym_expansion] = STATE(730),
    [sym_command_substitution] = STATE(730),
    [sym_process_substitution] = STATE(730),
    [aux_sym_for_statement_repeat1] = STATE(1368),
    [aux_sym__literal_repeat1] = STATE(736),
    [anon_sym_RPAREN] = ACTIONS(5542),
    [anon_sym_DOLLAR] = ACTIONS(1406),
    [sym__special_character] = ACTIONS(1408),
    [anon_sym_DQUOTE] = ACTIONS(1410),
    [sym_raw_string] = ACTIONS(1412),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1414),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1416),
    [anon_sym_BQUOTE] = ACTIONS(1418),
    [anon_sym_LT_LPAREN] = ACTIONS(1420),
    [anon_sym_GT_LPAREN] = ACTIONS(1420),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1412),
  },
  [1861] = {
    [sym_string] = STATE(556),
    [sym__simple_heredoc_body] = ACTIONS(4071),
    [sym__heredoc_body_beginning] = ACTIONS(4071),
    [sym_file_descriptor] = ACTIONS(4071),
    [sym_variable_name] = ACTIONS(4071),
    [ts_builtin_sym_end] = ACTIONS(4071),
    [anon_sym_SEMI] = ACTIONS(4073),
    [anon_sym_PIPE] = ACTIONS(4073),
    [anon_sym_RPAREN] = ACTIONS(4071),
    [anon_sym_SEMI_SEMI] = ACTIONS(4071),
    [anon_sym_PIPE_AMP] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_PIPE_PIPE] = ACTIONS(4071),
    [anon_sym_LT] = ACTIONS(4073),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_GT_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT] = ACTIONS(4073),
    [anon_sym_AMP_GT_GT] = ACTIONS(4071),
    [anon_sym_LT_AMP] = ACTIONS(4071),
    [anon_sym_GT_AMP] = ACTIONS(4071),
    [anon_sym_LT_LT] = ACTIONS(4073),
    [anon_sym_LT_LT_DASH] = ACTIONS(4071),
    [anon_sym_LT_LT_LT] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(5544),
    [anon_sym_DOLLAR] = ACTIONS(5544),
    [sym__special_character] = ACTIONS(4071),
    [anon_sym_DQUOTE] = ACTIONS(269),
    [sym_raw_string] = ACTIONS(945),
    [anon_sym_POUND] = ACTIONS(943),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4071),
    [anon_sym_BQUOTE] = ACTIONS(4071),
    [anon_sym_LT_LPAREN] = ACTIONS(4071),
    [anon_sym_GT_LPAREN] = ACTIONS(4071),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(947),
    [anon_sym_STAR] = ACTIONS(947),
    [anon_sym_AT] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(947),
    [anon_sym_0] = ACTIONS(947),
    [anon_sym__] = ACTIONS(947),
    [sym_word] = ACTIONS(4073),
    [anon_sym_LF] = ACTIONS(4071),
    [anon_sym_AMP] = ACTIONS(4073),
  },
  [1862] = {
    [sym__simple_heredoc_body] = ACTIONS(4111),
    [sym__heredoc_body_beginning] = ACTIONS(4111),
    [sym_file_descriptor] = ACTIONS(4111),
    [sym__concat] = ACTIONS(4111),
    [sym_variable_name] = ACTIONS(4111),
    [ts_builtin_sym_end] = ACTIONS(4111),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_PIPE] = ACTIONS(4113),
    [anon_sym_RPAREN] = ACTIONS(4111),
    [anon_sym_SEMI_SEMI] = ACTIONS(4111),
    [anon_sym_PIPE_AMP] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_LT] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4113),
    [anon_sym_GT_GT] = ACTIONS(4111),
    [anon_sym_AMP_GT] = ACTIONS(4113),
    [anon_sym_AMP_GT_GT] = ACTIONS(4111),
    [anon_sym_LT_AMP] = ACTIONS(4111),
    [anon_sym_GT_AMP] = ACTIONS(4111),
    [anon_sym_LT_LT] = ACTIONS(4113),
    [anon_sym_LT_LT_DASH] = ACTIONS(4111),
    [anon_sym_LT_LT_LT] = ACTIONS(4111),
    [anon_sym_DOLLAR] = ACTIONS(4113),
    [sym__special_character] = ACTIONS(4111),
    [anon_sym_DQUOTE] = ACTIONS(4111),
    [sym_raw_string] = ACTIONS(4111),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4111),
    [anon_sym_BQUOTE] = ACTIONS(4111),
    [anon_sym_LT_LPAREN] = ACTIONS(4111),
    [anon_sym_GT_LPAREN] = ACTIONS(4111),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4113),
    [sym_word] = ACTIONS(4113),
    [anon_sym_LF] = ACTIONS(4111),
    [anon_sym_AMP] = ACTIONS(4113),
  },
  [1863] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [sym_variable_name] = ACTIONS(4125),
    [ts_builtin_sym_end] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_RPAREN] = ACTIONS(4125),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym__special_character] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4127),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [1864] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(5546),
    [sym_comment] = ACTIONS(57),
  },
  [1865] = {
    [anon_sym_RBRACE] = ACTIONS(5546),
    [sym_comment] = ACTIONS(57),
  },
  [1866] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(5548),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [1867] = {
    [sym_concatenation] = STATE(2566),
    [sym_string] = STATE(2565),
    [sym_simple_expansion] = STATE(2565),
    [sym_string_expansion] = STATE(2565),
    [sym_expansion] = STATE(2565),
    [sym_command_substitution] = STATE(2565),
    [sym_process_substitution] = STATE(2565),
    [aux_sym__literal_repeat1] = STATE(2567),
    [anon_sym_RBRACE] = ACTIONS(5546),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(5550),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5550),
  },
  [1868] = {
    [sym__simple_heredoc_body] = ACTIONS(4161),
    [sym__heredoc_body_beginning] = ACTIONS(4161),
    [sym_file_descriptor] = ACTIONS(4161),
    [sym__concat] = ACTIONS(4161),
    [sym_variable_name] = ACTIONS(4161),
    [ts_builtin_sym_end] = ACTIONS(4161),
    [anon_sym_SEMI] = ACTIONS(4163),
    [anon_sym_PIPE] = ACTIONS(4163),
    [anon_sym_RPAREN] = ACTIONS(4161),
    [anon_sym_SEMI_SEMI] = ACTIONS(4161),
    [anon_sym_PIPE_AMP] = ACTIONS(4161),
    [anon_sym_AMP_AMP] = ACTIONS(4161),
    [anon_sym_PIPE_PIPE] = ACTIONS(4161),
    [anon_sym_LT] = ACTIONS(4163),
    [anon_sym_GT] = ACTIONS(4163),
    [anon_sym_GT_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT] = ACTIONS(4163),
    [anon_sym_AMP_GT_GT] = ACTIONS(4161),
    [anon_sym_LT_AMP] = ACTIONS(4161),
    [anon_sym_GT_AMP] = ACTIONS(4161),
    [anon_sym_LT_LT] = ACTIONS(4163),
    [anon_sym_LT_LT_DASH] = ACTIONS(4161),
    [anon_sym_LT_LT_LT] = ACTIONS(4161),
    [anon_sym_DOLLAR] = ACTIONS(4163),
    [sym__special_character] = ACTIONS(4161),
    [anon_sym_DQUOTE] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4161),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4161),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4161),
    [anon_sym_BQUOTE] = ACTIONS(4161),
    [anon_sym_LT_LPAREN] = ACTIONS(4161),
    [anon_sym_GT_LPAREN] = ACTIONS(4161),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4163),
    [sym_word] = ACTIONS(4163),
    [anon_sym_LF] = ACTIONS(4161),
    [anon_sym_AMP] = ACTIONS(4163),
  },
  [1869] = {
    [sym_concatenation] = STATE(2570),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2570),
    [sym_regex] = ACTIONS(5552),
    [anon_sym_RBRACE] = ACTIONS(5554),
    [anon_sym_EQ] = ACTIONS(5556),
    [anon_sym_DASH] = ACTIONS(5556),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5558),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5556),
    [anon_sym_COLON_QMARK] = ACTIONS(5556),
    [anon_sym_COLON_DASH] = ACTIONS(5556),
    [anon_sym_PERCENT] = ACTIONS(5556),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1870] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(5554),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1871] = {
    [sym_concatenation] = STATE(2572),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2572),
    [sym_regex] = ACTIONS(5560),
    [anon_sym_RBRACE] = ACTIONS(5546),
    [anon_sym_EQ] = ACTIONS(5562),
    [anon_sym_DASH] = ACTIONS(5562),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5562),
    [anon_sym_COLON_QMARK] = ACTIONS(5562),
    [anon_sym_COLON_DASH] = ACTIONS(5562),
    [anon_sym_PERCENT] = ACTIONS(5562),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1872] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(5546),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1873] = {
    [sym_concatenation] = STATE(2574),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2574),
    [anon_sym_RBRACE] = ACTIONS(5566),
    [anon_sym_EQ] = ACTIONS(5568),
    [anon_sym_DASH] = ACTIONS(5568),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5570),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5568),
    [anon_sym_COLON_QMARK] = ACTIONS(5568),
    [anon_sym_COLON_DASH] = ACTIONS(5568),
    [anon_sym_PERCENT] = ACTIONS(5568),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1874] = {
    [sym__simple_heredoc_body] = ACTIONS(4219),
    [sym__heredoc_body_beginning] = ACTIONS(4219),
    [sym_file_descriptor] = ACTIONS(4219),
    [sym__concat] = ACTIONS(4219),
    [sym_variable_name] = ACTIONS(4219),
    [ts_builtin_sym_end] = ACTIONS(4219),
    [anon_sym_SEMI] = ACTIONS(4221),
    [anon_sym_PIPE] = ACTIONS(4221),
    [anon_sym_RPAREN] = ACTIONS(4219),
    [anon_sym_SEMI_SEMI] = ACTIONS(4219),
    [anon_sym_PIPE_AMP] = ACTIONS(4219),
    [anon_sym_AMP_AMP] = ACTIONS(4219),
    [anon_sym_PIPE_PIPE] = ACTIONS(4219),
    [anon_sym_LT] = ACTIONS(4221),
    [anon_sym_GT] = ACTIONS(4221),
    [anon_sym_GT_GT] = ACTIONS(4219),
    [anon_sym_AMP_GT] = ACTIONS(4221),
    [anon_sym_AMP_GT_GT] = ACTIONS(4219),
    [anon_sym_LT_AMP] = ACTIONS(4219),
    [anon_sym_GT_AMP] = ACTIONS(4219),
    [anon_sym_LT_LT] = ACTIONS(4221),
    [anon_sym_LT_LT_DASH] = ACTIONS(4219),
    [anon_sym_LT_LT_LT] = ACTIONS(4219),
    [anon_sym_DOLLAR] = ACTIONS(4221),
    [sym__special_character] = ACTIONS(4219),
    [anon_sym_DQUOTE] = ACTIONS(4219),
    [sym_raw_string] = ACTIONS(4219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4219),
    [anon_sym_BQUOTE] = ACTIONS(4219),
    [anon_sym_LT_LPAREN] = ACTIONS(4219),
    [anon_sym_GT_LPAREN] = ACTIONS(4219),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4221),
    [sym_word] = ACTIONS(4221),
    [anon_sym_LF] = ACTIONS(4219),
    [anon_sym_AMP] = ACTIONS(4221),
  },
  [1875] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(5566),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1876] = {
    [sym_concatenation] = STATE(2572),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2572),
    [anon_sym_RBRACE] = ACTIONS(5546),
    [anon_sym_EQ] = ACTIONS(5562),
    [anon_sym_DASH] = ACTIONS(5562),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5562),
    [anon_sym_COLON_QMARK] = ACTIONS(5562),
    [anon_sym_COLON_DASH] = ACTIONS(5562),
    [anon_sym_PERCENT] = ACTIONS(5562),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1877] = {
    [sym_string] = STATE(575),
    [sym__simple_heredoc_body] = ACTIONS(4071),
    [sym__heredoc_body_beginning] = ACTIONS(4071),
    [sym_file_descriptor] = ACTIONS(4071),
    [ts_builtin_sym_end] = ACTIONS(4071),
    [anon_sym_SEMI] = ACTIONS(4073),
    [anon_sym_PIPE] = ACTIONS(4073),
    [anon_sym_RPAREN] = ACTIONS(4071),
    [anon_sym_SEMI_SEMI] = ACTIONS(4071),
    [anon_sym_PIPE_AMP] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_PIPE_PIPE] = ACTIONS(4071),
    [anon_sym_LT] = ACTIONS(4073),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_GT_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT] = ACTIONS(4073),
    [anon_sym_AMP_GT_GT] = ACTIONS(4071),
    [anon_sym_LT_AMP] = ACTIONS(4071),
    [anon_sym_GT_AMP] = ACTIONS(4071),
    [anon_sym_LT_LT] = ACTIONS(4073),
    [anon_sym_LT_LT_DASH] = ACTIONS(4071),
    [anon_sym_LT_LT_LT] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(5572),
    [anon_sym_DOLLAR] = ACTIONS(5572),
    [sym__special_character] = ACTIONS(4071),
    [anon_sym_DQUOTE] = ACTIONS(293),
    [sym_raw_string] = ACTIONS(985),
    [anon_sym_POUND] = ACTIONS(983),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4071),
    [anon_sym_BQUOTE] = ACTIONS(4071),
    [anon_sym_LT_LPAREN] = ACTIONS(4071),
    [anon_sym_GT_LPAREN] = ACTIONS(4071),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(987),
    [anon_sym_STAR] = ACTIONS(987),
    [anon_sym_AT] = ACTIONS(987),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_0] = ACTIONS(987),
    [anon_sym__] = ACTIONS(987),
    [sym_word] = ACTIONS(4073),
    [anon_sym_LF] = ACTIONS(4071),
    [anon_sym_AMP] = ACTIONS(4073),
  },
  [1878] = {
    [sym__simple_heredoc_body] = ACTIONS(4111),
    [sym__heredoc_body_beginning] = ACTIONS(4111),
    [sym_file_descriptor] = ACTIONS(4111),
    [sym__concat] = ACTIONS(4111),
    [ts_builtin_sym_end] = ACTIONS(4111),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_PIPE] = ACTIONS(4113),
    [anon_sym_RPAREN] = ACTIONS(4111),
    [anon_sym_SEMI_SEMI] = ACTIONS(4111),
    [anon_sym_PIPE_AMP] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_LT] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4113),
    [anon_sym_GT_GT] = ACTIONS(4111),
    [anon_sym_AMP_GT] = ACTIONS(4113),
    [anon_sym_AMP_GT_GT] = ACTIONS(4111),
    [anon_sym_LT_AMP] = ACTIONS(4111),
    [anon_sym_GT_AMP] = ACTIONS(4111),
    [anon_sym_LT_LT] = ACTIONS(4113),
    [anon_sym_LT_LT_DASH] = ACTIONS(4111),
    [anon_sym_LT_LT_LT] = ACTIONS(4111),
    [anon_sym_DOLLAR] = ACTIONS(4113),
    [sym__special_character] = ACTIONS(4111),
    [anon_sym_DQUOTE] = ACTIONS(4111),
    [sym_raw_string] = ACTIONS(4111),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4111),
    [anon_sym_BQUOTE] = ACTIONS(4111),
    [anon_sym_LT_LPAREN] = ACTIONS(4111),
    [anon_sym_GT_LPAREN] = ACTIONS(4111),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4113),
    [sym_word] = ACTIONS(4113),
    [anon_sym_LF] = ACTIONS(4111),
    [anon_sym_AMP] = ACTIONS(4113),
  },
  [1879] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [ts_builtin_sym_end] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_RPAREN] = ACTIONS(4125),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym__special_character] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4127),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [1880] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(5574),
    [sym_comment] = ACTIONS(57),
  },
  [1881] = {
    [anon_sym_RBRACE] = ACTIONS(5574),
    [sym_comment] = ACTIONS(57),
  },
  [1882] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(5576),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [1883] = {
    [sym_concatenation] = STATE(2578),
    [sym_string] = STATE(2577),
    [sym_simple_expansion] = STATE(2577),
    [sym_string_expansion] = STATE(2577),
    [sym_expansion] = STATE(2577),
    [sym_command_substitution] = STATE(2577),
    [sym_process_substitution] = STATE(2577),
    [aux_sym__literal_repeat1] = STATE(2579),
    [anon_sym_RBRACE] = ACTIONS(5574),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(5578),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5578),
  },
  [1884] = {
    [sym__simple_heredoc_body] = ACTIONS(4161),
    [sym__heredoc_body_beginning] = ACTIONS(4161),
    [sym_file_descriptor] = ACTIONS(4161),
    [sym__concat] = ACTIONS(4161),
    [ts_builtin_sym_end] = ACTIONS(4161),
    [anon_sym_SEMI] = ACTIONS(4163),
    [anon_sym_PIPE] = ACTIONS(4163),
    [anon_sym_RPAREN] = ACTIONS(4161),
    [anon_sym_SEMI_SEMI] = ACTIONS(4161),
    [anon_sym_PIPE_AMP] = ACTIONS(4161),
    [anon_sym_AMP_AMP] = ACTIONS(4161),
    [anon_sym_PIPE_PIPE] = ACTIONS(4161),
    [anon_sym_LT] = ACTIONS(4163),
    [anon_sym_GT] = ACTIONS(4163),
    [anon_sym_GT_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT] = ACTIONS(4163),
    [anon_sym_AMP_GT_GT] = ACTIONS(4161),
    [anon_sym_LT_AMP] = ACTIONS(4161),
    [anon_sym_GT_AMP] = ACTIONS(4161),
    [anon_sym_LT_LT] = ACTIONS(4163),
    [anon_sym_LT_LT_DASH] = ACTIONS(4161),
    [anon_sym_LT_LT_LT] = ACTIONS(4161),
    [anon_sym_DOLLAR] = ACTIONS(4163),
    [sym__special_character] = ACTIONS(4161),
    [anon_sym_DQUOTE] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4161),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4161),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4161),
    [anon_sym_BQUOTE] = ACTIONS(4161),
    [anon_sym_LT_LPAREN] = ACTIONS(4161),
    [anon_sym_GT_LPAREN] = ACTIONS(4161),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4163),
    [sym_word] = ACTIONS(4163),
    [anon_sym_LF] = ACTIONS(4161),
    [anon_sym_AMP] = ACTIONS(4163),
  },
  [1885] = {
    [sym_concatenation] = STATE(2582),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2582),
    [sym_regex] = ACTIONS(5580),
    [anon_sym_RBRACE] = ACTIONS(5582),
    [anon_sym_EQ] = ACTIONS(5584),
    [anon_sym_DASH] = ACTIONS(5584),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5584),
    [anon_sym_COLON_QMARK] = ACTIONS(5584),
    [anon_sym_COLON_DASH] = ACTIONS(5584),
    [anon_sym_PERCENT] = ACTIONS(5584),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1886] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(5582),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1887] = {
    [sym_concatenation] = STATE(2584),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2584),
    [sym_regex] = ACTIONS(5588),
    [anon_sym_RBRACE] = ACTIONS(5574),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_DASH] = ACTIONS(5590),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5592),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5590),
    [anon_sym_COLON_QMARK] = ACTIONS(5590),
    [anon_sym_COLON_DASH] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1888] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(5574),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1889] = {
    [sym_concatenation] = STATE(2586),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2586),
    [anon_sym_RBRACE] = ACTIONS(5594),
    [anon_sym_EQ] = ACTIONS(5596),
    [anon_sym_DASH] = ACTIONS(5596),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5598),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5596),
    [anon_sym_COLON_QMARK] = ACTIONS(5596),
    [anon_sym_COLON_DASH] = ACTIONS(5596),
    [anon_sym_PERCENT] = ACTIONS(5596),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1890] = {
    [sym__simple_heredoc_body] = ACTIONS(4219),
    [sym__heredoc_body_beginning] = ACTIONS(4219),
    [sym_file_descriptor] = ACTIONS(4219),
    [sym__concat] = ACTIONS(4219),
    [ts_builtin_sym_end] = ACTIONS(4219),
    [anon_sym_SEMI] = ACTIONS(4221),
    [anon_sym_PIPE] = ACTIONS(4221),
    [anon_sym_RPAREN] = ACTIONS(4219),
    [anon_sym_SEMI_SEMI] = ACTIONS(4219),
    [anon_sym_PIPE_AMP] = ACTIONS(4219),
    [anon_sym_AMP_AMP] = ACTIONS(4219),
    [anon_sym_PIPE_PIPE] = ACTIONS(4219),
    [anon_sym_LT] = ACTIONS(4221),
    [anon_sym_GT] = ACTIONS(4221),
    [anon_sym_GT_GT] = ACTIONS(4219),
    [anon_sym_AMP_GT] = ACTIONS(4221),
    [anon_sym_AMP_GT_GT] = ACTIONS(4219),
    [anon_sym_LT_AMP] = ACTIONS(4219),
    [anon_sym_GT_AMP] = ACTIONS(4219),
    [anon_sym_LT_LT] = ACTIONS(4221),
    [anon_sym_LT_LT_DASH] = ACTIONS(4219),
    [anon_sym_LT_LT_LT] = ACTIONS(4219),
    [anon_sym_DOLLAR] = ACTIONS(4221),
    [sym__special_character] = ACTIONS(4219),
    [anon_sym_DQUOTE] = ACTIONS(4219),
    [sym_raw_string] = ACTIONS(4219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4219),
    [anon_sym_BQUOTE] = ACTIONS(4219),
    [anon_sym_LT_LPAREN] = ACTIONS(4219),
    [anon_sym_GT_LPAREN] = ACTIONS(4219),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4221),
    [sym_word] = ACTIONS(4221),
    [anon_sym_LF] = ACTIONS(4219),
    [anon_sym_AMP] = ACTIONS(4221),
  },
  [1891] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(5594),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1892] = {
    [sym_concatenation] = STATE(2584),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2584),
    [anon_sym_RBRACE] = ACTIONS(5574),
    [anon_sym_EQ] = ACTIONS(5590),
    [anon_sym_DASH] = ACTIONS(5590),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5592),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5590),
    [anon_sym_COLON_QMARK] = ACTIONS(5590),
    [anon_sym_COLON_DASH] = ACTIONS(5590),
    [anon_sym_PERCENT] = ACTIONS(5590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1893] = {
    [sym_string] = STATE(594),
    [sym_file_descriptor] = ACTIONS(4071),
    [sym_variable_name] = ACTIONS(4071),
    [anon_sym_RPAREN] = ACTIONS(4071),
    [anon_sym_LT] = ACTIONS(4073),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_GT_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT] = ACTIONS(4073),
    [anon_sym_AMP_GT_GT] = ACTIONS(4071),
    [anon_sym_LT_AMP] = ACTIONS(4071),
    [anon_sym_GT_AMP] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(5600),
    [anon_sym_DOLLAR] = ACTIONS(5600),
    [sym__special_character] = ACTIONS(4071),
    [anon_sym_DQUOTE] = ACTIONS(313),
    [sym_raw_string] = ACTIONS(1025),
    [anon_sym_POUND] = ACTIONS(1023),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4071),
    [anon_sym_BQUOTE] = ACTIONS(4071),
    [anon_sym_LT_LPAREN] = ACTIONS(4071),
    [anon_sym_GT_LPAREN] = ACTIONS(4071),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1027),
    [anon_sym_STAR] = ACTIONS(1027),
    [anon_sym_AT] = ACTIONS(1027),
    [anon_sym_QMARK] = ACTIONS(1027),
    [anon_sym_0] = ACTIONS(1027),
    [anon_sym__] = ACTIONS(1027),
    [sym_word] = ACTIONS(4073),
  },
  [1894] = {
    [sym_file_descriptor] = ACTIONS(4111),
    [sym__concat] = ACTIONS(4111),
    [sym_variable_name] = ACTIONS(4111),
    [anon_sym_RPAREN] = ACTIONS(4111),
    [anon_sym_LT] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4113),
    [anon_sym_GT_GT] = ACTIONS(4111),
    [anon_sym_AMP_GT] = ACTIONS(4113),
    [anon_sym_AMP_GT_GT] = ACTIONS(4111),
    [anon_sym_LT_AMP] = ACTIONS(4111),
    [anon_sym_GT_AMP] = ACTIONS(4111),
    [anon_sym_DOLLAR] = ACTIONS(4113),
    [sym__special_character] = ACTIONS(4111),
    [anon_sym_DQUOTE] = ACTIONS(4111),
    [sym_raw_string] = ACTIONS(4111),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4111),
    [anon_sym_BQUOTE] = ACTIONS(4111),
    [anon_sym_LT_LPAREN] = ACTIONS(4111),
    [anon_sym_GT_LPAREN] = ACTIONS(4111),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4111),
  },
  [1895] = {
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [sym_variable_name] = ACTIONS(4125),
    [anon_sym_RPAREN] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym__special_character] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4125),
  },
  [1896] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(5602),
    [sym_comment] = ACTIONS(57),
  },
  [1897] = {
    [anon_sym_RBRACE] = ACTIONS(5602),
    [sym_comment] = ACTIONS(57),
  },
  [1898] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(5604),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [1899] = {
    [sym_concatenation] = STATE(2590),
    [sym_string] = STATE(2589),
    [sym_simple_expansion] = STATE(2589),
    [sym_string_expansion] = STATE(2589),
    [sym_expansion] = STATE(2589),
    [sym_command_substitution] = STATE(2589),
    [sym_process_substitution] = STATE(2589),
    [aux_sym__literal_repeat1] = STATE(2591),
    [anon_sym_RBRACE] = ACTIONS(5602),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(5606),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5606),
  },
  [1900] = {
    [sym_file_descriptor] = ACTIONS(4161),
    [sym__concat] = ACTIONS(4161),
    [sym_variable_name] = ACTIONS(4161),
    [anon_sym_RPAREN] = ACTIONS(4161),
    [anon_sym_LT] = ACTIONS(4163),
    [anon_sym_GT] = ACTIONS(4163),
    [anon_sym_GT_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT] = ACTIONS(4163),
    [anon_sym_AMP_GT_GT] = ACTIONS(4161),
    [anon_sym_LT_AMP] = ACTIONS(4161),
    [anon_sym_GT_AMP] = ACTIONS(4161),
    [anon_sym_DOLLAR] = ACTIONS(4163),
    [sym__special_character] = ACTIONS(4161),
    [anon_sym_DQUOTE] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4161),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4161),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4161),
    [anon_sym_BQUOTE] = ACTIONS(4161),
    [anon_sym_LT_LPAREN] = ACTIONS(4161),
    [anon_sym_GT_LPAREN] = ACTIONS(4161),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4161),
  },
  [1901] = {
    [sym_concatenation] = STATE(2594),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2594),
    [sym_regex] = ACTIONS(5608),
    [anon_sym_RBRACE] = ACTIONS(5610),
    [anon_sym_EQ] = ACTIONS(5612),
    [anon_sym_DASH] = ACTIONS(5612),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5614),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5612),
    [anon_sym_COLON_QMARK] = ACTIONS(5612),
    [anon_sym_COLON_DASH] = ACTIONS(5612),
    [anon_sym_PERCENT] = ACTIONS(5612),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1902] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(5610),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1903] = {
    [sym_concatenation] = STATE(2596),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2596),
    [sym_regex] = ACTIONS(5616),
    [anon_sym_RBRACE] = ACTIONS(5602),
    [anon_sym_EQ] = ACTIONS(5618),
    [anon_sym_DASH] = ACTIONS(5618),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5620),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5618),
    [anon_sym_COLON_QMARK] = ACTIONS(5618),
    [anon_sym_COLON_DASH] = ACTIONS(5618),
    [anon_sym_PERCENT] = ACTIONS(5618),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1904] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(5602),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1905] = {
    [sym_concatenation] = STATE(2598),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2598),
    [anon_sym_RBRACE] = ACTIONS(5622),
    [anon_sym_EQ] = ACTIONS(5624),
    [anon_sym_DASH] = ACTIONS(5624),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5626),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5624),
    [anon_sym_COLON_QMARK] = ACTIONS(5624),
    [anon_sym_COLON_DASH] = ACTIONS(5624),
    [anon_sym_PERCENT] = ACTIONS(5624),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1906] = {
    [sym_file_descriptor] = ACTIONS(4219),
    [sym__concat] = ACTIONS(4219),
    [sym_variable_name] = ACTIONS(4219),
    [anon_sym_RPAREN] = ACTIONS(4219),
    [anon_sym_LT] = ACTIONS(4221),
    [anon_sym_GT] = ACTIONS(4221),
    [anon_sym_GT_GT] = ACTIONS(4219),
    [anon_sym_AMP_GT] = ACTIONS(4221),
    [anon_sym_AMP_GT_GT] = ACTIONS(4219),
    [anon_sym_LT_AMP] = ACTIONS(4219),
    [anon_sym_GT_AMP] = ACTIONS(4219),
    [anon_sym_DOLLAR] = ACTIONS(4221),
    [sym__special_character] = ACTIONS(4219),
    [anon_sym_DQUOTE] = ACTIONS(4219),
    [sym_raw_string] = ACTIONS(4219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4219),
    [anon_sym_BQUOTE] = ACTIONS(4219),
    [anon_sym_LT_LPAREN] = ACTIONS(4219),
    [anon_sym_GT_LPAREN] = ACTIONS(4219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4219),
  },
  [1907] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(5622),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1908] = {
    [sym_concatenation] = STATE(2596),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2596),
    [anon_sym_RBRACE] = ACTIONS(5602),
    [anon_sym_EQ] = ACTIONS(5618),
    [anon_sym_DASH] = ACTIONS(5618),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5620),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5618),
    [anon_sym_COLON_QMARK] = ACTIONS(5618),
    [anon_sym_COLON_DASH] = ACTIONS(5618),
    [anon_sym_PERCENT] = ACTIONS(5618),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1909] = {
    [sym__concat] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [anon_sym_DQUOTE] = ACTIONS(4127),
    [sym__string_content] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4127),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4127),
    [anon_sym_BQUOTE] = ACTIONS(4127),
    [sym_comment] = ACTIONS(329),
  },
  [1910] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(5628),
    [sym_comment] = ACTIONS(57),
  },
  [1911] = {
    [anon_sym_RBRACE] = ACTIONS(5628),
    [sym_comment] = ACTIONS(57),
  },
  [1912] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(5630),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [1913] = {
    [sym_concatenation] = STATE(2602),
    [sym_string] = STATE(2601),
    [sym_simple_expansion] = STATE(2601),
    [sym_string_expansion] = STATE(2601),
    [sym_expansion] = STATE(2601),
    [sym_command_substitution] = STATE(2601),
    [sym_process_substitution] = STATE(2601),
    [aux_sym__literal_repeat1] = STATE(2603),
    [anon_sym_RBRACE] = ACTIONS(5628),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(5632),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5632),
  },
  [1914] = {
    [sym__concat] = ACTIONS(4161),
    [anon_sym_DOLLAR] = ACTIONS(4163),
    [anon_sym_DQUOTE] = ACTIONS(4163),
    [sym__string_content] = ACTIONS(4161),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4163),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4163),
    [anon_sym_BQUOTE] = ACTIONS(4163),
    [sym_comment] = ACTIONS(329),
  },
  [1915] = {
    [sym_concatenation] = STATE(2606),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2606),
    [sym_regex] = ACTIONS(5634),
    [anon_sym_RBRACE] = ACTIONS(5636),
    [anon_sym_EQ] = ACTIONS(5638),
    [anon_sym_DASH] = ACTIONS(5638),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5638),
    [anon_sym_COLON_QMARK] = ACTIONS(5638),
    [anon_sym_COLON_DASH] = ACTIONS(5638),
    [anon_sym_PERCENT] = ACTIONS(5638),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1916] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(5636),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1917] = {
    [sym_concatenation] = STATE(2608),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2608),
    [sym_regex] = ACTIONS(5642),
    [anon_sym_RBRACE] = ACTIONS(5628),
    [anon_sym_EQ] = ACTIONS(5644),
    [anon_sym_DASH] = ACTIONS(5644),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5646),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5644),
    [anon_sym_COLON_QMARK] = ACTIONS(5644),
    [anon_sym_COLON_DASH] = ACTIONS(5644),
    [anon_sym_PERCENT] = ACTIONS(5644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1918] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(5628),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1919] = {
    [sym_concatenation] = STATE(2610),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2610),
    [anon_sym_RBRACE] = ACTIONS(5648),
    [anon_sym_EQ] = ACTIONS(5650),
    [anon_sym_DASH] = ACTIONS(5650),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5652),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5650),
    [anon_sym_COLON_QMARK] = ACTIONS(5650),
    [anon_sym_COLON_DASH] = ACTIONS(5650),
    [anon_sym_PERCENT] = ACTIONS(5650),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1920] = {
    [sym__concat] = ACTIONS(4219),
    [anon_sym_DOLLAR] = ACTIONS(4221),
    [anon_sym_DQUOTE] = ACTIONS(4221),
    [sym__string_content] = ACTIONS(4219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4221),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4221),
    [anon_sym_BQUOTE] = ACTIONS(4221),
    [sym_comment] = ACTIONS(329),
  },
  [1921] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(5648),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1922] = {
    [sym_concatenation] = STATE(2608),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2608),
    [anon_sym_RBRACE] = ACTIONS(5628),
    [anon_sym_EQ] = ACTIONS(5644),
    [anon_sym_DASH] = ACTIONS(5644),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5646),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5644),
    [anon_sym_COLON_QMARK] = ACTIONS(5644),
    [anon_sym_COLON_DASH] = ACTIONS(5644),
    [anon_sym_PERCENT] = ACTIONS(5644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1923] = {
    [sym_string] = STATE(1149),
    [sym_simple_expansion] = STATE(1149),
    [sym_string_expansion] = STATE(1149),
    [sym_expansion] = STATE(1149),
    [sym_command_substitution] = STATE(1149),
    [sym_process_substitution] = STATE(1149),
    [anon_sym_RBRACK] = ACTIONS(5654),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [sym__special_character] = ACTIONS(2704),
    [anon_sym_DQUOTE] = ACTIONS(233),
    [sym_raw_string] = ACTIONS(2116),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [anon_sym_LT_LPAREN] = ACTIONS(243),
    [anon_sym_GT_LPAREN] = ACTIONS(243),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2116),
  },
  [1924] = {
    [sym__concat] = ACTIONS(5656),
    [anon_sym_RBRACE] = ACTIONS(2708),
    [anon_sym_EQ] = ACTIONS(5658),
    [anon_sym_DASH] = ACTIONS(5658),
    [anon_sym_DOLLAR] = ACTIONS(5658),
    [sym__special_character] = ACTIONS(5658),
    [anon_sym_DQUOTE] = ACTIONS(2708),
    [sym_raw_string] = ACTIONS(2708),
    [anon_sym_POUND] = ACTIONS(2708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2708),
    [anon_sym_SLASH] = ACTIONS(2708),
    [anon_sym_COLON] = ACTIONS(5658),
    [anon_sym_COLON_QMARK] = ACTIONS(5658),
    [anon_sym_COLON_DASH] = ACTIONS(5658),
    [anon_sym_PERCENT] = ACTIONS(5658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2708),
    [anon_sym_BQUOTE] = ACTIONS(2708),
    [anon_sym_LT_LPAREN] = ACTIONS(2708),
    [anon_sym_GT_LPAREN] = ACTIONS(2708),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(5658),
  },
  [1925] = {
    [anon_sym_RBRACK] = ACTIONS(5654),
    [sym_comment] = ACTIONS(57),
  },
  [1926] = {
    [anon_sym_RBRACK] = ACTIONS(5660),
    [sym_comment] = ACTIONS(57),
  },
  [1927] = {
    [sym__concat] = ACTIONS(5662),
    [anon_sym_RBRACE] = ACTIONS(2714),
    [anon_sym_EQ] = ACTIONS(5664),
    [anon_sym_DASH] = ACTIONS(5664),
    [anon_sym_DOLLAR] = ACTIONS(5664),
    [sym__special_character] = ACTIONS(5664),
    [anon_sym_DQUOTE] = ACTIONS(2714),
    [sym_raw_string] = ACTIONS(2714),
    [anon_sym_POUND] = ACTIONS(2714),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2714),
    [anon_sym_SLASH] = ACTIONS(2714),
    [anon_sym_COLON] = ACTIONS(5664),
    [anon_sym_COLON_QMARK] = ACTIONS(5664),
    [anon_sym_COLON_DASH] = ACTIONS(5664),
    [anon_sym_PERCENT] = ACTIONS(5664),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2714),
    [anon_sym_BQUOTE] = ACTIONS(2714),
    [anon_sym_LT_LPAREN] = ACTIONS(2714),
    [anon_sym_GT_LPAREN] = ACTIONS(2714),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(5664),
  },
  [1928] = {
    [sym__concat] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(1057),
    [sym_comment] = ACTIONS(57),
  },
  [1929] = {
    [sym__concat] = ACTIONS(1061),
    [anon_sym_RBRACE] = ACTIONS(1061),
    [sym_comment] = ACTIONS(57),
  },
  [1930] = {
    [sym__concat] = ACTIONS(1065),
    [anon_sym_RBRACE] = ACTIONS(1065),
    [sym_comment] = ACTIONS(57),
  },
  [1931] = {
    [sym_string] = STATE(2615),
    [sym_simple_expansion] = STATE(2615),
    [sym_string_expansion] = STATE(2615),
    [sym_expansion] = STATE(2615),
    [sym_command_substitution] = STATE(2615),
    [sym_process_substitution] = STATE(2615),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(5666),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(5666),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5666),
  },
  [1932] = {
    [aux_sym_concatenation_repeat1] = STATE(2617),
    [sym__concat] = ACTIONS(5668),
    [anon_sym_RBRACE] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
  },
  [1933] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(5670),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [1934] = {
    [sym__concat] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [sym_comment] = ACTIONS(57),
  },
  [1935] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(627),
    [anon_sym_DOLLAR] = ACTIONS(5672),
    [anon_sym_DQUOTE] = ACTIONS(5670),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [1936] = {
    [sym__simple_heredoc_body] = ACTIONS(5674),
    [sym__heredoc_body_beginning] = ACTIONS(5674),
    [sym_file_descriptor] = ACTIONS(5674),
    [sym__concat] = ACTIONS(5674),
    [ts_builtin_sym_end] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(5676),
    [anon_sym_PIPE] = ACTIONS(5676),
    [anon_sym_RPAREN] = ACTIONS(5674),
    [anon_sym_SEMI_SEMI] = ACTIONS(5674),
    [anon_sym_PIPE_AMP] = ACTIONS(5674),
    [anon_sym_AMP_AMP] = ACTIONS(5674),
    [anon_sym_PIPE_PIPE] = ACTIONS(5674),
    [anon_sym_EQ_TILDE] = ACTIONS(5676),
    [anon_sym_EQ_EQ] = ACTIONS(5676),
    [anon_sym_LT] = ACTIONS(5676),
    [anon_sym_GT] = ACTIONS(5676),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_AMP_GT] = ACTIONS(5676),
    [anon_sym_AMP_GT_GT] = ACTIONS(5674),
    [anon_sym_LT_AMP] = ACTIONS(5674),
    [anon_sym_GT_AMP] = ACTIONS(5674),
    [anon_sym_LT_LT] = ACTIONS(5676),
    [anon_sym_LT_LT_DASH] = ACTIONS(5674),
    [anon_sym_LT_LT_LT] = ACTIONS(5674),
    [anon_sym_DOLLAR] = ACTIONS(5676),
    [sym__special_character] = ACTIONS(5674),
    [anon_sym_DQUOTE] = ACTIONS(5674),
    [sym_raw_string] = ACTIONS(5674),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5674),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5674),
    [anon_sym_BQUOTE] = ACTIONS(5674),
    [anon_sym_LT_LPAREN] = ACTIONS(5674),
    [anon_sym_GT_LPAREN] = ACTIONS(5674),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5676),
    [anon_sym_LF] = ACTIONS(5674),
    [anon_sym_AMP] = ACTIONS(5676),
  },
  [1937] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(5678),
    [sym_comment] = ACTIONS(57),
  },
  [1938] = {
    [sym_subscript] = STATE(2623),
    [sym_variable_name] = ACTIONS(5680),
    [anon_sym_DASH] = ACTIONS(5682),
    [anon_sym_DOLLAR] = ACTIONS(5682),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5684),
    [anon_sym_STAR] = ACTIONS(5686),
    [anon_sym_AT] = ACTIONS(5686),
    [anon_sym_QMARK] = ACTIONS(5686),
    [anon_sym_0] = ACTIONS(5684),
    [anon_sym__] = ACTIONS(5684),
  },
  [1939] = {
    [sym_concatenation] = STATE(2626),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2626),
    [anon_sym_RBRACE] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5690),
    [anon_sym_DASH] = ACTIONS(5690),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5692),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(5694),
    [anon_sym_COLON] = ACTIONS(5690),
    [anon_sym_COLON_QMARK] = ACTIONS(5690),
    [anon_sym_COLON_DASH] = ACTIONS(5690),
    [anon_sym_PERCENT] = ACTIONS(5690),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1940] = {
    [sym_concatenation] = STATE(2629),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2629),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_DASH] = ACTIONS(5698),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5700),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(5702),
    [anon_sym_COLON] = ACTIONS(5698),
    [anon_sym_COLON_QMARK] = ACTIONS(5698),
    [anon_sym_COLON_DASH] = ACTIONS(5698),
    [anon_sym_PERCENT] = ACTIONS(5698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1941] = {
    [anon_sym_RPAREN] = ACTIONS(5704),
    [sym_comment] = ACTIONS(57),
  },
  [1942] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(5704),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [1943] = {
    [anon_sym_BQUOTE] = ACTIONS(5704),
    [sym_comment] = ACTIONS(57),
  },
  [1944] = {
    [anon_sym_RPAREN] = ACTIONS(5706),
    [sym_comment] = ACTIONS(57),
  },
  [1945] = {
    [sym__simple_heredoc_body] = ACTIONS(5708),
    [sym__heredoc_body_beginning] = ACTIONS(5708),
    [sym_file_descriptor] = ACTIONS(5708),
    [sym__concat] = ACTIONS(5708),
    [ts_builtin_sym_end] = ACTIONS(5708),
    [anon_sym_SEMI] = ACTIONS(5710),
    [anon_sym_PIPE] = ACTIONS(5710),
    [anon_sym_RPAREN] = ACTIONS(5708),
    [anon_sym_SEMI_SEMI] = ACTIONS(5708),
    [anon_sym_PIPE_AMP] = ACTIONS(5708),
    [anon_sym_AMP_AMP] = ACTIONS(5708),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_EQ_TILDE] = ACTIONS(5710),
    [anon_sym_EQ_EQ] = ACTIONS(5710),
    [anon_sym_LT] = ACTIONS(5710),
    [anon_sym_GT] = ACTIONS(5710),
    [anon_sym_GT_GT] = ACTIONS(5708),
    [anon_sym_AMP_GT] = ACTIONS(5710),
    [anon_sym_AMP_GT_GT] = ACTIONS(5708),
    [anon_sym_LT_AMP] = ACTIONS(5708),
    [anon_sym_GT_AMP] = ACTIONS(5708),
    [anon_sym_LT_LT] = ACTIONS(5710),
    [anon_sym_LT_LT_DASH] = ACTIONS(5708),
    [anon_sym_LT_LT_LT] = ACTIONS(5708),
    [anon_sym_DOLLAR] = ACTIONS(5710),
    [sym__special_character] = ACTIONS(5708),
    [anon_sym_DQUOTE] = ACTIONS(5708),
    [sym_raw_string] = ACTIONS(5708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5708),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5708),
    [anon_sym_BQUOTE] = ACTIONS(5708),
    [anon_sym_LT_LPAREN] = ACTIONS(5708),
    [anon_sym_GT_LPAREN] = ACTIONS(5708),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5710),
    [anon_sym_LF] = ACTIONS(5708),
    [anon_sym_AMP] = ACTIONS(5710),
  },
  [1946] = {
    [anon_sym_RBRACE] = ACTIONS(335),
    [sym__special_character] = ACTIONS(339),
    [sym_comment] = ACTIONS(57),
  },
  [1947] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(1373),
    [sym__special_character] = ACTIONS(5712),
    [sym_comment] = ACTIONS(57),
  },
  [1948] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(5715),
    [sym_comment] = ACTIONS(57),
  },
  [1949] = {
    [anon_sym_RBRACE] = ACTIONS(5715),
    [sym_comment] = ACTIONS(57),
  },
  [1950] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(5717),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [1951] = {
    [sym_concatenation] = STATE(2635),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2635),
    [anon_sym_RBRACE] = ACTIONS(5719),
    [anon_sym_EQ] = ACTIONS(5721),
    [anon_sym_DASH] = ACTIONS(5721),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5723),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5721),
    [anon_sym_COLON_QMARK] = ACTIONS(5721),
    [anon_sym_COLON_DASH] = ACTIONS(5721),
    [anon_sym_PERCENT] = ACTIONS(5721),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1952] = {
    [sym__simple_heredoc_body] = ACTIONS(5725),
    [sym__heredoc_body_beginning] = ACTIONS(5725),
    [sym_file_descriptor] = ACTIONS(5725),
    [sym__concat] = ACTIONS(5725),
    [ts_builtin_sym_end] = ACTIONS(5725),
    [anon_sym_SEMI] = ACTIONS(5727),
    [anon_sym_PIPE] = ACTIONS(5727),
    [anon_sym_RPAREN] = ACTIONS(5725),
    [anon_sym_SEMI_SEMI] = ACTIONS(5725),
    [anon_sym_PIPE_AMP] = ACTIONS(5725),
    [anon_sym_AMP_AMP] = ACTIONS(5725),
    [anon_sym_PIPE_PIPE] = ACTIONS(5725),
    [anon_sym_EQ_TILDE] = ACTIONS(5727),
    [anon_sym_EQ_EQ] = ACTIONS(5727),
    [anon_sym_LT] = ACTIONS(5727),
    [anon_sym_GT] = ACTIONS(5727),
    [anon_sym_GT_GT] = ACTIONS(5725),
    [anon_sym_AMP_GT] = ACTIONS(5727),
    [anon_sym_AMP_GT_GT] = ACTIONS(5725),
    [anon_sym_LT_AMP] = ACTIONS(5725),
    [anon_sym_GT_AMP] = ACTIONS(5725),
    [anon_sym_LT_LT] = ACTIONS(5727),
    [anon_sym_LT_LT_DASH] = ACTIONS(5725),
    [anon_sym_LT_LT_LT] = ACTIONS(5725),
    [anon_sym_DOLLAR] = ACTIONS(5727),
    [sym__special_character] = ACTIONS(5725),
    [anon_sym_DQUOTE] = ACTIONS(5725),
    [sym_raw_string] = ACTIONS(5725),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5725),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5725),
    [anon_sym_BQUOTE] = ACTIONS(5725),
    [anon_sym_LT_LPAREN] = ACTIONS(5725),
    [anon_sym_GT_LPAREN] = ACTIONS(5725),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5727),
    [anon_sym_LF] = ACTIONS(5725),
    [anon_sym_AMP] = ACTIONS(5727),
  },
  [1953] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(5719),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1954] = {
    [sym_concatenation] = STATE(2636),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2636),
    [anon_sym_RBRACE] = ACTIONS(5715),
    [anon_sym_EQ] = ACTIONS(5729),
    [anon_sym_DASH] = ACTIONS(5729),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5729),
    [anon_sym_COLON_QMARK] = ACTIONS(5729),
    [anon_sym_COLON_DASH] = ACTIONS(5729),
    [anon_sym_PERCENT] = ACTIONS(5729),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1955] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(5715),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1956] = {
    [sym__concat] = ACTIONS(2362),
    [anon_sym_RBRACE] = ACTIONS(2362),
    [anon_sym_EQ] = ACTIONS(2364),
    [anon_sym_DASH] = ACTIONS(2364),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2364),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_POUND] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_COLON] = ACTIONS(2364),
    [anon_sym_COLON_QMARK] = ACTIONS(2364),
    [anon_sym_COLON_DASH] = ACTIONS(2364),
    [anon_sym_PERCENT] = ACTIONS(2364),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(2364),
  },
  [1957] = {
    [sym_string] = STATE(1956),
    [sym_simple_expansion] = STATE(1956),
    [sym_string_expansion] = STATE(1956),
    [sym_expansion] = STATE(1956),
    [sym_command_substitution] = STATE(1956),
    [sym_process_substitution] = STATE(1956),
    [anon_sym_DOLLAR] = ACTIONS(5733),
    [sym__special_character] = ACTIONS(4179),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(4179),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4179),
  },
  [1958] = {
    [aux_sym_concatenation_repeat1] = STATE(1958),
    [sym__concat] = ACTIONS(5735),
    [anon_sym_RBRACE] = ACTIONS(2362),
    [anon_sym_EQ] = ACTIONS(2364),
    [anon_sym_DASH] = ACTIONS(2364),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2364),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_POUND] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_COLON] = ACTIONS(2364),
    [anon_sym_COLON_QMARK] = ACTIONS(2364),
    [anon_sym_COLON_DASH] = ACTIONS(2364),
    [anon_sym_PERCENT] = ACTIONS(2364),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(2364),
  },
  [1959] = {
    [sym__concat] = ACTIONS(2371),
    [anon_sym_RBRACE] = ACTIONS(2371),
    [anon_sym_EQ] = ACTIONS(2373),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_DOLLAR] = ACTIONS(2373),
    [sym__special_character] = ACTIONS(2373),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [sym_raw_string] = ACTIONS(2371),
    [anon_sym_POUND] = ACTIONS(2371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2371),
    [anon_sym_COLON] = ACTIONS(2373),
    [anon_sym_COLON_QMARK] = ACTIONS(2373),
    [anon_sym_COLON_DASH] = ACTIONS(2373),
    [anon_sym_PERCENT] = ACTIONS(2373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2371),
    [anon_sym_BQUOTE] = ACTIONS(2371),
    [anon_sym_LT_LPAREN] = ACTIONS(2371),
    [anon_sym_GT_LPAREN] = ACTIONS(2371),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(2373),
  },
  [1960] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(5738),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [1961] = {
    [sym_concatenation] = STATE(2641),
    [sym_string] = STATE(2640),
    [sym_simple_expansion] = STATE(2640),
    [sym_string_expansion] = STATE(2640),
    [sym_expansion] = STATE(2640),
    [sym_command_substitution] = STATE(2640),
    [sym_process_substitution] = STATE(2640),
    [aux_sym__literal_repeat1] = STATE(2642),
    [anon_sym_RBRACE] = ACTIONS(5740),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(5742),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5742),
  },
  [1962] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(5744),
    [sym_comment] = ACTIONS(57),
  },
  [1963] = {
    [sym_concatenation] = STATE(2646),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2646),
    [anon_sym_RBRACE] = ACTIONS(5746),
    [anon_sym_EQ] = ACTIONS(5748),
    [anon_sym_DASH] = ACTIONS(5748),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5750),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(5752),
    [anon_sym_COLON] = ACTIONS(5748),
    [anon_sym_COLON_QMARK] = ACTIONS(5748),
    [anon_sym_COLON_DASH] = ACTIONS(5748),
    [anon_sym_PERCENT] = ACTIONS(5748),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1964] = {
    [sym_concatenation] = STATE(2648),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2648),
    [anon_sym_RBRACE] = ACTIONS(5740),
    [anon_sym_EQ] = ACTIONS(5754),
    [anon_sym_DASH] = ACTIONS(5754),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5756),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(5758),
    [anon_sym_COLON] = ACTIONS(5754),
    [anon_sym_COLON_QMARK] = ACTIONS(5754),
    [anon_sym_COLON_DASH] = ACTIONS(5754),
    [anon_sym_PERCENT] = ACTIONS(5754),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1965] = {
    [sym__concat] = ACTIONS(2462),
    [anon_sym_RBRACE] = ACTIONS(2462),
    [anon_sym_EQ] = ACTIONS(2464),
    [anon_sym_DASH] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2464),
    [sym__special_character] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [sym_raw_string] = ACTIONS(2462),
    [anon_sym_POUND] = ACTIONS(2462),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2462),
    [anon_sym_COLON] = ACTIONS(2464),
    [anon_sym_COLON_QMARK] = ACTIONS(2464),
    [anon_sym_COLON_DASH] = ACTIONS(2464),
    [anon_sym_PERCENT] = ACTIONS(2464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2462),
    [anon_sym_BQUOTE] = ACTIONS(2462),
    [anon_sym_LT_LPAREN] = ACTIONS(2462),
    [anon_sym_GT_LPAREN] = ACTIONS(2462),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(2464),
  },
  [1966] = {
    [sym_concatenation] = STATE(2651),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2651),
    [sym_regex] = ACTIONS(5760),
    [anon_sym_RBRACE] = ACTIONS(5762),
    [anon_sym_EQ] = ACTIONS(5764),
    [anon_sym_DASH] = ACTIONS(5764),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5766),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5764),
    [anon_sym_COLON_QMARK] = ACTIONS(5764),
    [anon_sym_COLON_DASH] = ACTIONS(5764),
    [anon_sym_PERCENT] = ACTIONS(5764),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1967] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(5762),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1968] = {
    [sym__concat] = ACTIONS(2512),
    [anon_sym_RBRACE] = ACTIONS(2512),
    [anon_sym_EQ] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2514),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [sym__special_character] = ACTIONS(2514),
    [anon_sym_DQUOTE] = ACTIONS(2512),
    [sym_raw_string] = ACTIONS(2512),
    [anon_sym_POUND] = ACTIONS(2512),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2512),
    [anon_sym_COLON] = ACTIONS(2514),
    [anon_sym_COLON_QMARK] = ACTIONS(2514),
    [anon_sym_COLON_DASH] = ACTIONS(2514),
    [anon_sym_PERCENT] = ACTIONS(2514),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2512),
    [anon_sym_BQUOTE] = ACTIONS(2512),
    [anon_sym_LT_LPAREN] = ACTIONS(2512),
    [anon_sym_GT_LPAREN] = ACTIONS(2512),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(2514),
  },
  [1969] = {
    [sym_concatenation] = STATE(2648),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2648),
    [sym_regex] = ACTIONS(5768),
    [anon_sym_RBRACE] = ACTIONS(5740),
    [anon_sym_EQ] = ACTIONS(5754),
    [anon_sym_DASH] = ACTIONS(5754),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5756),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5754),
    [anon_sym_COLON_QMARK] = ACTIONS(5754),
    [anon_sym_COLON_DASH] = ACTIONS(5754),
    [anon_sym_PERCENT] = ACTIONS(5754),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1970] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(5740),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1971] = {
    [sym__simple_heredoc_body] = ACTIONS(5770),
    [sym__heredoc_body_beginning] = ACTIONS(5770),
    [sym_file_descriptor] = ACTIONS(5770),
    [sym__concat] = ACTIONS(5770),
    [ts_builtin_sym_end] = ACTIONS(5770),
    [anon_sym_SEMI] = ACTIONS(5772),
    [anon_sym_PIPE] = ACTIONS(5772),
    [anon_sym_RPAREN] = ACTIONS(5770),
    [anon_sym_SEMI_SEMI] = ACTIONS(5770),
    [anon_sym_PIPE_AMP] = ACTIONS(5770),
    [anon_sym_AMP_AMP] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5770),
    [anon_sym_EQ_TILDE] = ACTIONS(5772),
    [anon_sym_EQ_EQ] = ACTIONS(5772),
    [anon_sym_LT] = ACTIONS(5772),
    [anon_sym_GT] = ACTIONS(5772),
    [anon_sym_GT_GT] = ACTIONS(5770),
    [anon_sym_AMP_GT] = ACTIONS(5772),
    [anon_sym_AMP_GT_GT] = ACTIONS(5770),
    [anon_sym_LT_AMP] = ACTIONS(5770),
    [anon_sym_GT_AMP] = ACTIONS(5770),
    [anon_sym_LT_LT] = ACTIONS(5772),
    [anon_sym_LT_LT_DASH] = ACTIONS(5770),
    [anon_sym_LT_LT_LT] = ACTIONS(5770),
    [anon_sym_DOLLAR] = ACTIONS(5772),
    [sym__special_character] = ACTIONS(5770),
    [anon_sym_DQUOTE] = ACTIONS(5770),
    [sym_raw_string] = ACTIONS(5770),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5770),
    [anon_sym_BQUOTE] = ACTIONS(5770),
    [anon_sym_LT_LPAREN] = ACTIONS(5770),
    [anon_sym_GT_LPAREN] = ACTIONS(5770),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5772),
    [anon_sym_LF] = ACTIONS(5770),
    [anon_sym_AMP] = ACTIONS(5772),
  },
  [1972] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(5774),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1973] = {
    [sym__concat] = ACTIONS(2520),
    [anon_sym_RBRACE] = ACTIONS(2520),
    [anon_sym_EQ] = ACTIONS(2522),
    [anon_sym_DASH] = ACTIONS(2522),
    [anon_sym_DOLLAR] = ACTIONS(2522),
    [sym__special_character] = ACTIONS(2522),
    [anon_sym_DQUOTE] = ACTIONS(2520),
    [sym_raw_string] = ACTIONS(2520),
    [anon_sym_POUND] = ACTIONS(2520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2520),
    [anon_sym_COLON] = ACTIONS(2522),
    [anon_sym_COLON_QMARK] = ACTIONS(2522),
    [anon_sym_COLON_DASH] = ACTIONS(2522),
    [anon_sym_PERCENT] = ACTIONS(2522),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2520),
    [anon_sym_BQUOTE] = ACTIONS(2520),
    [anon_sym_LT_LPAREN] = ACTIONS(2520),
    [anon_sym_GT_LPAREN] = ACTIONS(2520),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(2522),
  },
  [1974] = {
    [sym__concat] = ACTIONS(2554),
    [anon_sym_RBRACE] = ACTIONS(2554),
    [anon_sym_EQ] = ACTIONS(2556),
    [anon_sym_DASH] = ACTIONS(2556),
    [anon_sym_DOLLAR] = ACTIONS(2556),
    [sym__special_character] = ACTIONS(2556),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_POUND] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2554),
    [anon_sym_COLON] = ACTIONS(2556),
    [anon_sym_COLON_QMARK] = ACTIONS(2556),
    [anon_sym_COLON_DASH] = ACTIONS(2556),
    [anon_sym_PERCENT] = ACTIONS(2556),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2554),
    [anon_sym_BQUOTE] = ACTIONS(2554),
    [anon_sym_LT_LPAREN] = ACTIONS(2554),
    [anon_sym_GT_LPAREN] = ACTIONS(2554),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(2556),
  },
  [1975] = {
    [aux_sym_concatenation_repeat1] = STATE(1975),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(4036),
    [sym_variable_name] = ACTIONS(2362),
    [anon_sym_RPAREN] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2362),
  },
  [1976] = {
    [aux_sym_concatenation_repeat1] = STATE(2654),
    [sym__simple_heredoc_body] = ACTIONS(1071),
    [sym__heredoc_body_beginning] = ACTIONS(1071),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(2761),
    [sym_variable_name] = ACTIONS(1071),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [sym__special_character] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1075),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1075),
  },
  [1977] = {
    [aux_sym__literal_repeat1] = STATE(1977),
    [sym__simple_heredoc_body] = ACTIONS(1373),
    [sym__heredoc_body_beginning] = ACTIONS(1373),
    [sym_file_descriptor] = ACTIONS(1373),
    [sym_variable_name] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE_AMP] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_LT_LT_DASH] = ACTIONS(1373),
    [anon_sym_LT_LT_LT] = ACTIONS(1373),
    [anon_sym_DOLLAR] = ACTIONS(1375),
    [sym__special_character] = ACTIONS(2797),
    [anon_sym_DQUOTE] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1373),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [anon_sym_LT_LPAREN] = ACTIONS(1373),
    [anon_sym_GT_LPAREN] = ACTIONS(1373),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1375),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
  },
  [1978] = {
    [aux_sym_concatenation_repeat1] = STATE(1290),
    [sym__simple_heredoc_body] = ACTIONS(1400),
    [sym__heredoc_body_beginning] = ACTIONS(1400),
    [sym_file_descriptor] = ACTIONS(1400),
    [sym__concat] = ACTIONS(951),
    [sym_variable_name] = ACTIONS(1400),
    [anon_sym_SEMI] = ACTIONS(1402),
    [anon_sym_PIPE] = ACTIONS(1402),
    [anon_sym_SEMI_SEMI] = ACTIONS(1400),
    [anon_sym_PIPE_AMP] = ACTIONS(1400),
    [anon_sym_AMP_AMP] = ACTIONS(1400),
    [anon_sym_PIPE_PIPE] = ACTIONS(1400),
    [anon_sym_LT] = ACTIONS(1402),
    [anon_sym_GT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT] = ACTIONS(1402),
    [anon_sym_AMP_GT_GT] = ACTIONS(1400),
    [anon_sym_LT_AMP] = ACTIONS(1400),
    [anon_sym_GT_AMP] = ACTIONS(1400),
    [anon_sym_LT_LT] = ACTIONS(1402),
    [anon_sym_LT_LT_DASH] = ACTIONS(1400),
    [anon_sym_LT_LT_LT] = ACTIONS(1400),
    [anon_sym_DOLLAR] = ACTIONS(1402),
    [sym__special_character] = ACTIONS(1400),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1400),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1400),
    [anon_sym_BQUOTE] = ACTIONS(1400),
    [anon_sym_LT_LPAREN] = ACTIONS(1400),
    [anon_sym_GT_LPAREN] = ACTIONS(1400),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1402),
    [sym_word] = ACTIONS(1402),
    [anon_sym_LF] = ACTIONS(1400),
    [anon_sym_AMP] = ACTIONS(1402),
  },
  [1979] = {
    [aux_sym__literal_repeat1] = STATE(1292),
    [sym__simple_heredoc_body] = ACTIONS(1446),
    [sym__heredoc_body_beginning] = ACTIONS(1446),
    [sym_file_descriptor] = ACTIONS(1446),
    [sym_variable_name] = ACTIONS(1446),
    [anon_sym_SEMI] = ACTIONS(1448),
    [anon_sym_PIPE] = ACTIONS(1448),
    [anon_sym_SEMI_SEMI] = ACTIONS(1446),
    [anon_sym_PIPE_AMP] = ACTIONS(1446),
    [anon_sym_AMP_AMP] = ACTIONS(1446),
    [anon_sym_PIPE_PIPE] = ACTIONS(1446),
    [anon_sym_LT] = ACTIONS(1448),
    [anon_sym_GT] = ACTIONS(1448),
    [anon_sym_GT_GT] = ACTIONS(1446),
    [anon_sym_AMP_GT] = ACTIONS(1448),
    [anon_sym_AMP_GT_GT] = ACTIONS(1446),
    [anon_sym_LT_AMP] = ACTIONS(1446),
    [anon_sym_GT_AMP] = ACTIONS(1446),
    [anon_sym_LT_LT] = ACTIONS(1448),
    [anon_sym_LT_LT_DASH] = ACTIONS(1446),
    [anon_sym_LT_LT_LT] = ACTIONS(1446),
    [anon_sym_DOLLAR] = ACTIONS(1448),
    [sym__special_character] = ACTIONS(981),
    [anon_sym_DQUOTE] = ACTIONS(1446),
    [sym_raw_string] = ACTIONS(1446),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1446),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1446),
    [anon_sym_BQUOTE] = ACTIONS(1446),
    [anon_sym_LT_LPAREN] = ACTIONS(1446),
    [anon_sym_GT_LPAREN] = ACTIONS(1446),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1448),
    [sym_word] = ACTIONS(1448),
    [anon_sym_LF] = ACTIONS(1446),
    [anon_sym_AMP] = ACTIONS(1448),
  },
  [1980] = {
    [aux_sym_concatenation_repeat1] = STATE(1980),
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(3962),
    [sym_variable_name] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2364),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [1981] = {
    [aux_sym_concatenation_repeat1] = STATE(1981),
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(3999),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2364),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [1982] = {
    [aux_sym_concatenation_repeat1] = STATE(1984),
    [sym__simple_heredoc_body] = ACTIONS(1380),
    [sym__heredoc_body_beginning] = ACTIONS(1380),
    [sym_file_descriptor] = ACTIONS(1380),
    [sym__concat] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(1382),
    [anon_sym_PIPE] = ACTIONS(1382),
    [anon_sym_SEMI_SEMI] = ACTIONS(1380),
    [anon_sym_PIPE_AMP] = ACTIONS(1380),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_PIPE_PIPE] = ACTIONS(1380),
    [anon_sym_LT] = ACTIONS(1382),
    [anon_sym_GT] = ACTIONS(1382),
    [anon_sym_GT_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT] = ACTIONS(1382),
    [anon_sym_AMP_GT_GT] = ACTIONS(1380),
    [anon_sym_LT_AMP] = ACTIONS(1380),
    [anon_sym_GT_AMP] = ACTIONS(1380),
    [anon_sym_LT_LT] = ACTIONS(1382),
    [anon_sym_LT_LT_DASH] = ACTIONS(1380),
    [anon_sym_LT_LT_LT] = ACTIONS(1380),
    [anon_sym_BQUOTE] = ACTIONS(1380),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1380),
    [anon_sym_AMP] = ACTIONS(1382),
  },
  [1983] = {
    [aux_sym__literal_repeat1] = STATE(1985),
    [sym__simple_heredoc_body] = ACTIONS(1384),
    [sym__heredoc_body_beginning] = ACTIONS(1384),
    [sym_file_descriptor] = ACTIONS(1384),
    [anon_sym_SEMI] = ACTIONS(1386),
    [anon_sym_PIPE] = ACTIONS(1386),
    [anon_sym_SEMI_SEMI] = ACTIONS(1384),
    [anon_sym_PIPE_AMP] = ACTIONS(1384),
    [anon_sym_AMP_AMP] = ACTIONS(1384),
    [anon_sym_PIPE_PIPE] = ACTIONS(1384),
    [anon_sym_LT] = ACTIONS(1386),
    [anon_sym_GT] = ACTIONS(1386),
    [anon_sym_GT_GT] = ACTIONS(1384),
    [anon_sym_AMP_GT] = ACTIONS(1386),
    [anon_sym_AMP_GT_GT] = ACTIONS(1384),
    [anon_sym_LT_AMP] = ACTIONS(1384),
    [anon_sym_GT_AMP] = ACTIONS(1384),
    [anon_sym_LT_LT] = ACTIONS(1386),
    [anon_sym_LT_LT_DASH] = ACTIONS(1384),
    [anon_sym_LT_LT_LT] = ACTIONS(1384),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(1384),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1384),
    [anon_sym_AMP] = ACTIONS(1386),
  },
  [1984] = {
    [aux_sym_concatenation_repeat1] = STATE(2655),
    [sym__simple_heredoc_body] = ACTIONS(1071),
    [sym__heredoc_body_beginning] = ACTIONS(1071),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(4377),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1075),
  },
  [1985] = {
    [aux_sym__literal_repeat1] = STATE(1985),
    [sym__simple_heredoc_body] = ACTIONS(1373),
    [sym__heredoc_body_beginning] = ACTIONS(1373),
    [sym_file_descriptor] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE_AMP] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_LT_LT_DASH] = ACTIONS(1373),
    [anon_sym_LT_LT_LT] = ACTIONS(1373),
    [sym__special_character] = ACTIONS(1377),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
  },
  [1986] = {
    [sym_file_descriptor] = ACTIONS(2604),
    [sym_variable_name] = ACTIONS(2604),
    [anon_sym_for] = ACTIONS(2608),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2608),
    [anon_sym_if] = ACTIONS(2608),
    [anon_sym_case] = ACTIONS(2608),
    [anon_sym_function] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(2608),
    [anon_sym_LBRACE] = ACTIONS(2604),
    [anon_sym_BANG] = ACTIONS(2608),
    [anon_sym_LBRACK] = ACTIONS(2608),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2604),
    [anon_sym_declare] = ACTIONS(2608),
    [anon_sym_typeset] = ACTIONS(2608),
    [anon_sym_export] = ACTIONS(2608),
    [anon_sym_readonly] = ACTIONS(2608),
    [anon_sym_local] = ACTIONS(2608),
    [anon_sym_unset] = ACTIONS(2608),
    [anon_sym_unsetenv] = ACTIONS(2608),
    [anon_sym_LT] = ACTIONS(2608),
    [anon_sym_GT] = ACTIONS(2608),
    [anon_sym_GT_GT] = ACTIONS(2604),
    [anon_sym_AMP_GT] = ACTIONS(2608),
    [anon_sym_AMP_GT_GT] = ACTIONS(2604),
    [anon_sym_LT_AMP] = ACTIONS(2604),
    [anon_sym_GT_AMP] = ACTIONS(2604),
    [anon_sym_DOLLAR] = ACTIONS(2608),
    [sym__special_character] = ACTIONS(2608),
    [anon_sym_DQUOTE] = ACTIONS(2604),
    [sym_raw_string] = ACTIONS(2604),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2604),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2604),
    [anon_sym_BQUOTE] = ACTIONS(4379),
    [anon_sym_LT_LPAREN] = ACTIONS(2604),
    [anon_sym_GT_LPAREN] = ACTIONS(2604),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2608),
  },
  [1987] = {
    [sym_concatenation] = STATE(2658),
    [sym_string] = STATE(2657),
    [sym_simple_expansion] = STATE(2657),
    [sym_string_expansion] = STATE(2657),
    [sym_expansion] = STATE(2657),
    [sym_command_substitution] = STATE(2657),
    [sym_process_substitution] = STATE(2657),
    [aux_sym__literal_repeat1] = STATE(2659),
    [anon_sym_RBRACE] = ACTIONS(5776),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(5778),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5778),
  },
  [1988] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(5780),
    [sym_comment] = ACTIONS(57),
  },
  [1989] = {
    [sym_concatenation] = STATE(2663),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2663),
    [anon_sym_RBRACE] = ACTIONS(5782),
    [anon_sym_EQ] = ACTIONS(5784),
    [anon_sym_DASH] = ACTIONS(5784),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5786),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(5788),
    [anon_sym_COLON] = ACTIONS(5784),
    [anon_sym_COLON_QMARK] = ACTIONS(5784),
    [anon_sym_COLON_DASH] = ACTIONS(5784),
    [anon_sym_PERCENT] = ACTIONS(5784),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1990] = {
    [sym_concatenation] = STATE(2665),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2665),
    [anon_sym_RBRACE] = ACTIONS(5776),
    [anon_sym_EQ] = ACTIONS(5790),
    [anon_sym_DASH] = ACTIONS(5790),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5792),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(5794),
    [anon_sym_COLON] = ACTIONS(5790),
    [anon_sym_COLON_QMARK] = ACTIONS(5790),
    [anon_sym_COLON_DASH] = ACTIONS(5790),
    [anon_sym_PERCENT] = ACTIONS(5790),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1991] = {
    [sym__heredoc_body_middle] = ACTIONS(2462),
    [sym__heredoc_body_end] = ACTIONS(2462),
    [anon_sym_DOLLAR] = ACTIONS(2464),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2462),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2462),
    [anon_sym_BQUOTE] = ACTIONS(2462),
    [sym_comment] = ACTIONS(57),
  },
  [1992] = {
    [sym_concatenation] = STATE(2668),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2668),
    [sym_regex] = ACTIONS(5796),
    [anon_sym_RBRACE] = ACTIONS(5798),
    [anon_sym_EQ] = ACTIONS(5800),
    [anon_sym_DASH] = ACTIONS(5800),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5802),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5800),
    [anon_sym_COLON_QMARK] = ACTIONS(5800),
    [anon_sym_COLON_DASH] = ACTIONS(5800),
    [anon_sym_PERCENT] = ACTIONS(5800),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1993] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(5798),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1994] = {
    [sym__heredoc_body_middle] = ACTIONS(2512),
    [sym__heredoc_body_end] = ACTIONS(2512),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2512),
    [anon_sym_BQUOTE] = ACTIONS(2512),
    [sym_comment] = ACTIONS(57),
  },
  [1995] = {
    [sym_concatenation] = STATE(2665),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2665),
    [sym_regex] = ACTIONS(5804),
    [anon_sym_RBRACE] = ACTIONS(5776),
    [anon_sym_EQ] = ACTIONS(5790),
    [anon_sym_DASH] = ACTIONS(5790),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5792),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5790),
    [anon_sym_COLON_QMARK] = ACTIONS(5790),
    [anon_sym_COLON_DASH] = ACTIONS(5790),
    [anon_sym_PERCENT] = ACTIONS(5790),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1996] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(5776),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [1997] = {
    [sym__heredoc_body_middle] = ACTIONS(2520),
    [sym__heredoc_body_end] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(2522),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2520),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2520),
    [anon_sym_BQUOTE] = ACTIONS(2520),
    [sym_comment] = ACTIONS(57),
  },
  [1998] = {
    [sym_string] = STATE(611),
    [sym_simple_expansion] = STATE(611),
    [sym_string_expansion] = STATE(611),
    [sym_expansion] = STATE(611),
    [sym_command_substitution] = STATE(611),
    [sym_process_substitution] = STATE(611),
    [anon_sym_DOLLAR] = ACTIONS(5806),
    [sym__special_character] = ACTIONS(1069),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1069),
  },
  [1999] = {
    [aux_sym_concatenation_repeat1] = STATE(1999),
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(2368),
    [ts_builtin_sym_end] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [2000] = {
    [sym_concatenation] = STATE(1328),
    [sym_string] = STATE(2671),
    [sym_simple_expansion] = STATE(2671),
    [sym_string_expansion] = STATE(2671),
    [sym_expansion] = STATE(2671),
    [sym_command_substitution] = STATE(2671),
    [sym_process_substitution] = STATE(2671),
    [aux_sym__literal_repeat1] = STATE(2672),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(4391),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(5808),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5808),
  },
  [2001] = {
    [sym_file_redirect] = STATE(1342),
    [sym_heredoc_redirect] = STATE(1342),
    [sym_herestring_redirect] = STATE(1342),
    [aux_sym_redirected_statement_repeat1] = STATE(1342),
    [sym__simple_heredoc_body] = ACTIONS(2584),
    [sym__heredoc_body_beginning] = ACTIONS(2584),
    [sym_file_descriptor] = ACTIONS(2584),
    [anon_sym_SEMI] = ACTIONS(2586),
    [anon_sym_PIPE] = ACTIONS(2586),
    [anon_sym_SEMI_SEMI] = ACTIONS(2584),
    [anon_sym_PIPE_AMP] = ACTIONS(2584),
    [anon_sym_AMP_AMP] = ACTIONS(2584),
    [anon_sym_PIPE_PIPE] = ACTIONS(2584),
    [anon_sym_LT] = ACTIONS(2586),
    [anon_sym_GT] = ACTIONS(2586),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT] = ACTIONS(2586),
    [anon_sym_AMP_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_AMP] = ACTIONS(2584),
    [anon_sym_GT_AMP] = ACTIONS(2584),
    [anon_sym_LT_LT] = ACTIONS(2586),
    [anon_sym_LT_LT_DASH] = ACTIONS(2584),
    [anon_sym_LT_LT_LT] = ACTIONS(2584),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2584),
    [anon_sym_AMP] = ACTIONS(2586),
  },
  [2002] = {
    [sym_file_redirect] = STATE(1342),
    [sym_heredoc_redirect] = STATE(1342),
    [sym_herestring_redirect] = STATE(1342),
    [aux_sym_redirected_statement_repeat1] = STATE(1342),
    [sym__simple_heredoc_body] = ACTIONS(2584),
    [sym__heredoc_body_beginning] = ACTIONS(2584),
    [sym_file_descriptor] = ACTIONS(2584),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2586),
    [anon_sym_PIPE] = ACTIONS(2586),
    [anon_sym_SEMI_SEMI] = ACTIONS(2584),
    [anon_sym_PIPE_AMP] = ACTIONS(2584),
    [anon_sym_AMP_AMP] = ACTIONS(2584),
    [anon_sym_PIPE_PIPE] = ACTIONS(2584),
    [anon_sym_LT] = ACTIONS(2586),
    [anon_sym_GT] = ACTIONS(2586),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT] = ACTIONS(2586),
    [anon_sym_AMP_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_AMP] = ACTIONS(2584),
    [anon_sym_GT_AMP] = ACTIONS(2584),
    [anon_sym_LT_LT] = ACTIONS(2586),
    [anon_sym_LT_LT_DASH] = ACTIONS(2584),
    [anon_sym_LT_LT_LT] = ACTIONS(2584),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2584),
    [anon_sym_AMP] = ACTIONS(2586),
  },
  [2003] = {
    [sym_file_redirect] = STATE(1342),
    [sym_heredoc_redirect] = STATE(1342),
    [sym_herestring_redirect] = STATE(1342),
    [aux_sym_redirected_statement_repeat1] = STATE(1342),
    [sym__simple_heredoc_body] = ACTIONS(2588),
    [sym__heredoc_body_beginning] = ACTIONS(2588),
    [sym_file_descriptor] = ACTIONS(2588),
    [anon_sym_SEMI] = ACTIONS(2590),
    [anon_sym_PIPE] = ACTIONS(2682),
    [anon_sym_SEMI_SEMI] = ACTIONS(2588),
    [anon_sym_PIPE_AMP] = ACTIONS(2686),
    [anon_sym_AMP_AMP] = ACTIONS(2588),
    [anon_sym_PIPE_PIPE] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(2590),
    [anon_sym_GT] = ACTIONS(2590),
    [anon_sym_GT_GT] = ACTIONS(2588),
    [anon_sym_AMP_GT] = ACTIONS(2590),
    [anon_sym_AMP_GT_GT] = ACTIONS(2588),
    [anon_sym_LT_AMP] = ACTIONS(2588),
    [anon_sym_GT_AMP] = ACTIONS(2588),
    [anon_sym_LT_LT] = ACTIONS(2590),
    [anon_sym_LT_LT_DASH] = ACTIONS(2588),
    [anon_sym_LT_LT_LT] = ACTIONS(2588),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2588),
    [anon_sym_AMP] = ACTIONS(2590),
  },
  [2004] = {
    [sym_file_redirect] = STATE(1342),
    [sym_heredoc_redirect] = STATE(1342),
    [sym_herestring_redirect] = STATE(1342),
    [aux_sym_redirected_statement_repeat1] = STATE(1342),
    [sym__simple_heredoc_body] = ACTIONS(2588),
    [sym__heredoc_body_beginning] = ACTIONS(2588),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2590),
    [anon_sym_PIPE] = ACTIONS(2682),
    [anon_sym_SEMI_SEMI] = ACTIONS(2588),
    [anon_sym_PIPE_AMP] = ACTIONS(2686),
    [anon_sym_AMP_AMP] = ACTIONS(2588),
    [anon_sym_PIPE_PIPE] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(2590),
    [anon_sym_LT_LT_DASH] = ACTIONS(2588),
    [anon_sym_LT_LT_LT] = ACTIONS(2588),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2588),
    [anon_sym_AMP] = ACTIONS(2590),
  },
  [2005] = {
    [aux_sym_concatenation_repeat1] = STATE(2673),
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [sym__special_character] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [2006] = {
    [aux_sym_concatenation_repeat1] = STATE(2673),
    [sym__simple_heredoc_body] = ACTIONS(1037),
    [sym__heredoc_body_beginning] = ACTIONS(1037),
    [sym_file_descriptor] = ACTIONS(1037),
    [sym__concat] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(1039),
    [anon_sym_PIPE] = ACTIONS(1039),
    [anon_sym_SEMI_SEMI] = ACTIONS(1037),
    [anon_sym_PIPE_AMP] = ACTIONS(1037),
    [anon_sym_AMP_AMP] = ACTIONS(1037),
    [anon_sym_PIPE_PIPE] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1039),
    [anon_sym_GT] = ACTIONS(1039),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_AMP_GT] = ACTIONS(1039),
    [anon_sym_AMP_GT_GT] = ACTIONS(1037),
    [anon_sym_LT_AMP] = ACTIONS(1037),
    [anon_sym_GT_AMP] = ACTIONS(1037),
    [anon_sym_LT_LT] = ACTIONS(1039),
    [anon_sym_LT_LT_DASH] = ACTIONS(1037),
    [anon_sym_LT_LT_LT] = ACTIONS(1037),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1037),
    [anon_sym_AMP] = ACTIONS(1039),
  },
  [2007] = {
    [aux_sym__literal_repeat1] = STATE(2674),
    [sym__simple_heredoc_body] = ACTIONS(1051),
    [sym__heredoc_body_beginning] = ACTIONS(1051),
    [sym_file_descriptor] = ACTIONS(1051),
    [anon_sym_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE] = ACTIONS(1053),
    [anon_sym_SEMI_SEMI] = ACTIONS(1051),
    [anon_sym_PIPE_AMP] = ACTIONS(1051),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_PIPE_PIPE] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT_GT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1051),
    [anon_sym_GT_AMP] = ACTIONS(1051),
    [anon_sym_LT_LT] = ACTIONS(1053),
    [anon_sym_LT_LT_DASH] = ACTIONS(1051),
    [anon_sym_LT_LT_LT] = ACTIONS(1051),
    [sym__special_character] = ACTIONS(441),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1051),
    [anon_sym_AMP] = ACTIONS(1053),
  },
  [2008] = {
    [aux_sym_concatenation_repeat1] = STATE(2673),
    [sym__simple_heredoc_body] = ACTIONS(2596),
    [sym__heredoc_body_beginning] = ACTIONS(2596),
    [sym_file_descriptor] = ACTIONS(2596),
    [sym__concat] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(2598),
    [anon_sym_PIPE] = ACTIONS(2598),
    [anon_sym_SEMI_SEMI] = ACTIONS(2596),
    [anon_sym_PIPE_AMP] = ACTIONS(2596),
    [anon_sym_AMP_AMP] = ACTIONS(2596),
    [anon_sym_PIPE_PIPE] = ACTIONS(2596),
    [anon_sym_LT] = ACTIONS(2598),
    [anon_sym_GT] = ACTIONS(2598),
    [anon_sym_GT_GT] = ACTIONS(2596),
    [anon_sym_AMP_GT] = ACTIONS(2598),
    [anon_sym_AMP_GT_GT] = ACTIONS(2596),
    [anon_sym_LT_AMP] = ACTIONS(2596),
    [anon_sym_GT_AMP] = ACTIONS(2596),
    [anon_sym_LT_LT] = ACTIONS(2598),
    [anon_sym_LT_LT_DASH] = ACTIONS(2596),
    [anon_sym_LT_LT_LT] = ACTIONS(2596),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2596),
    [anon_sym_AMP] = ACTIONS(2598),
  },
  [2009] = {
    [aux_sym__literal_repeat1] = STATE(2674),
    [sym__simple_heredoc_body] = ACTIONS(2600),
    [sym__heredoc_body_beginning] = ACTIONS(2600),
    [sym_file_descriptor] = ACTIONS(2600),
    [anon_sym_SEMI] = ACTIONS(2602),
    [anon_sym_PIPE] = ACTIONS(2602),
    [anon_sym_SEMI_SEMI] = ACTIONS(2600),
    [anon_sym_PIPE_AMP] = ACTIONS(2600),
    [anon_sym_AMP_AMP] = ACTIONS(2600),
    [anon_sym_PIPE_PIPE] = ACTIONS(2600),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_GT_GT] = ACTIONS(2600),
    [anon_sym_AMP_GT] = ACTIONS(2602),
    [anon_sym_AMP_GT_GT] = ACTIONS(2600),
    [anon_sym_LT_AMP] = ACTIONS(2600),
    [anon_sym_GT_AMP] = ACTIONS(2600),
    [anon_sym_LT_LT] = ACTIONS(2602),
    [anon_sym_LT_LT_DASH] = ACTIONS(2600),
    [anon_sym_LT_LT_LT] = ACTIONS(2600),
    [sym__special_character] = ACTIONS(441),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2600),
    [anon_sym_AMP] = ACTIONS(2602),
  },
  [2010] = {
    [sym_file_descriptor] = ACTIONS(2604),
    [sym_variable_name] = ACTIONS(2604),
    [anon_sym_for] = ACTIONS(2608),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2608),
    [anon_sym_if] = ACTIONS(2608),
    [anon_sym_case] = ACTIONS(2608),
    [anon_sym_function] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(2608),
    [anon_sym_LBRACE] = ACTIONS(2604),
    [anon_sym_BANG] = ACTIONS(2608),
    [anon_sym_LBRACK] = ACTIONS(2608),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2604),
    [anon_sym_declare] = ACTIONS(2608),
    [anon_sym_typeset] = ACTIONS(2608),
    [anon_sym_export] = ACTIONS(2608),
    [anon_sym_readonly] = ACTIONS(2608),
    [anon_sym_local] = ACTIONS(2608),
    [anon_sym_unset] = ACTIONS(2608),
    [anon_sym_unsetenv] = ACTIONS(2608),
    [anon_sym_LT] = ACTIONS(2608),
    [anon_sym_GT] = ACTIONS(2608),
    [anon_sym_GT_GT] = ACTIONS(2604),
    [anon_sym_AMP_GT] = ACTIONS(2608),
    [anon_sym_AMP_GT_GT] = ACTIONS(2604),
    [anon_sym_LT_AMP] = ACTIONS(2604),
    [anon_sym_GT_AMP] = ACTIONS(2604),
    [anon_sym_DOLLAR] = ACTIONS(2608),
    [sym__special_character] = ACTIONS(2608),
    [anon_sym_DQUOTE] = ACTIONS(2604),
    [sym_raw_string] = ACTIONS(2604),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2604),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2604),
    [anon_sym_BQUOTE] = ACTIONS(2604),
    [anon_sym_LT_LPAREN] = ACTIONS(2604),
    [anon_sym_GT_LPAREN] = ACTIONS(2604),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2608),
  },
  [2011] = {
    [sym_file_redirect] = STATE(2011),
    [sym_heredoc_redirect] = STATE(2011),
    [sym_herestring_redirect] = STATE(2011),
    [aux_sym_redirected_statement_repeat1] = STATE(2011),
    [sym__simple_heredoc_body] = ACTIONS(2610),
    [sym__heredoc_body_beginning] = ACTIONS(2610),
    [sym_file_descriptor] = ACTIONS(5810),
    [anon_sym_SEMI] = ACTIONS(2615),
    [anon_sym_PIPE] = ACTIONS(2615),
    [anon_sym_SEMI_SEMI] = ACTIONS(2610),
    [anon_sym_PIPE_AMP] = ACTIONS(2610),
    [anon_sym_AMP_AMP] = ACTIONS(2610),
    [anon_sym_PIPE_PIPE] = ACTIONS(2610),
    [anon_sym_LT] = ACTIONS(5813),
    [anon_sym_GT] = ACTIONS(5813),
    [anon_sym_GT_GT] = ACTIONS(5816),
    [anon_sym_AMP_GT] = ACTIONS(5813),
    [anon_sym_AMP_GT_GT] = ACTIONS(5816),
    [anon_sym_LT_AMP] = ACTIONS(5816),
    [anon_sym_GT_AMP] = ACTIONS(5816),
    [anon_sym_LT_LT] = ACTIONS(2623),
    [anon_sym_LT_LT_DASH] = ACTIONS(2626),
    [anon_sym_LT_LT_LT] = ACTIONS(5819),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2610),
    [anon_sym_AMP] = ACTIONS(2615),
  },
  [2012] = {
    [sym_concatenation] = STATE(1311),
    [sym_string] = STATE(674),
    [sym_simple_expansion] = STATE(674),
    [sym_string_expansion] = STATE(674),
    [sym_expansion] = STATE(674),
    [sym_command_substitution] = STATE(674),
    [sym_process_substitution] = STATE(674),
    [aux_sym_command_repeat2] = STATE(1311),
    [aux_sym__literal_repeat1] = STATE(676),
    [sym__simple_heredoc_body] = ACTIONS(2696),
    [sym__heredoc_body_beginning] = ACTIONS(2696),
    [sym_file_descriptor] = ACTIONS(2696),
    [anon_sym_SEMI] = ACTIONS(2698),
    [anon_sym_PIPE] = ACTIONS(2698),
    [anon_sym_SEMI_SEMI] = ACTIONS(2696),
    [anon_sym_PIPE_AMP] = ACTIONS(2696),
    [anon_sym_AMP_AMP] = ACTIONS(2696),
    [anon_sym_PIPE_PIPE] = ACTIONS(2696),
    [anon_sym_EQ_TILDE] = ACTIONS(1205),
    [anon_sym_EQ_EQ] = ACTIONS(1205),
    [anon_sym_LT] = ACTIONS(2698),
    [anon_sym_GT] = ACTIONS(2698),
    [anon_sym_GT_GT] = ACTIONS(2696),
    [anon_sym_AMP_GT] = ACTIONS(2698),
    [anon_sym_AMP_GT_GT] = ACTIONS(2696),
    [anon_sym_LT_AMP] = ACTIONS(2696),
    [anon_sym_GT_AMP] = ACTIONS(2696),
    [anon_sym_LT_LT] = ACTIONS(2698),
    [anon_sym_LT_LT_DASH] = ACTIONS(2696),
    [anon_sym_LT_LT_LT] = ACTIONS(2696),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(1207),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1209),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1211),
    [anon_sym_LF] = ACTIONS(2696),
    [anon_sym_AMP] = ACTIONS(2698),
  },
  [2013] = {
    [sym_string] = STATE(528),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACK] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(899),
    [anon_sym_DOLLAR] = ACTIONS(899),
    [anon_sym_DQUOTE] = ACTIONS(233),
    [sym_raw_string] = ACTIONS(901),
    [anon_sym_POUND] = ACTIONS(899),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(903),
    [anon_sym_STAR] = ACTIONS(905),
    [anon_sym_AT] = ACTIONS(905),
    [anon_sym_QMARK] = ACTIONS(905),
    [anon_sym_0] = ACTIONS(903),
    [anon_sym__] = ACTIONS(903),
  },
  [2014] = {
    [anon_sym_EQ] = ACTIONS(5822),
    [anon_sym_PLUS_EQ] = ACTIONS(5822),
    [sym_comment] = ACTIONS(57),
  },
  [2015] = {
    [anon_sym_EQ] = ACTIONS(5824),
    [anon_sym_PLUS_EQ] = ACTIONS(5824),
    [sym_comment] = ACTIONS(57),
  },
  [2016] = {
    [sym__concat] = ACTIONS(2362),
    [anon_sym_RPAREN] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2362),
  },
  [2017] = {
    [sym_string] = STATE(2016),
    [sym_simple_expansion] = STATE(2016),
    [sym_string_expansion] = STATE(2016),
    [sym_expansion] = STATE(2016),
    [sym_command_substitution] = STATE(2016),
    [sym_process_substitution] = STATE(2016),
    [anon_sym_DOLLAR] = ACTIONS(5826),
    [sym__special_character] = ACTIONS(4411),
    [anon_sym_DQUOTE] = ACTIONS(1410),
    [sym_raw_string] = ACTIONS(4411),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1414),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1416),
    [anon_sym_BQUOTE] = ACTIONS(1418),
    [anon_sym_LT_LPAREN] = ACTIONS(1420),
    [anon_sym_GT_LPAREN] = ACTIONS(1420),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4411),
  },
  [2018] = {
    [aux_sym_concatenation_repeat1] = STATE(2018),
    [sym__concat] = ACTIONS(5828),
    [anon_sym_RPAREN] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2362),
  },
  [2019] = {
    [sym__concat] = ACTIONS(2371),
    [anon_sym_RPAREN] = ACTIONS(2371),
    [anon_sym_DOLLAR] = ACTIONS(2373),
    [sym__special_character] = ACTIONS(2371),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [sym_raw_string] = ACTIONS(2371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2371),
    [anon_sym_BQUOTE] = ACTIONS(2371),
    [anon_sym_LT_LPAREN] = ACTIONS(2371),
    [anon_sym_GT_LPAREN] = ACTIONS(2371),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2371),
  },
  [2020] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(5831),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [2021] = {
    [sym_concatenation] = STATE(2679),
    [sym_string] = STATE(2678),
    [sym_simple_expansion] = STATE(2678),
    [sym_string_expansion] = STATE(2678),
    [sym_expansion] = STATE(2678),
    [sym_command_substitution] = STATE(2678),
    [sym_process_substitution] = STATE(2678),
    [aux_sym__literal_repeat1] = STATE(2680),
    [anon_sym_RBRACE] = ACTIONS(5833),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(5835),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5835),
  },
  [2022] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(5837),
    [sym_comment] = ACTIONS(57),
  },
  [2023] = {
    [sym_concatenation] = STATE(2684),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2684),
    [anon_sym_RBRACE] = ACTIONS(5839),
    [anon_sym_EQ] = ACTIONS(5841),
    [anon_sym_DASH] = ACTIONS(5841),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5843),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(5845),
    [anon_sym_COLON] = ACTIONS(5841),
    [anon_sym_COLON_QMARK] = ACTIONS(5841),
    [anon_sym_COLON_DASH] = ACTIONS(5841),
    [anon_sym_PERCENT] = ACTIONS(5841),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2024] = {
    [sym_concatenation] = STATE(2686),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2686),
    [anon_sym_RBRACE] = ACTIONS(5833),
    [anon_sym_EQ] = ACTIONS(5847),
    [anon_sym_DASH] = ACTIONS(5847),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5849),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(5851),
    [anon_sym_COLON] = ACTIONS(5847),
    [anon_sym_COLON_QMARK] = ACTIONS(5847),
    [anon_sym_COLON_DASH] = ACTIONS(5847),
    [anon_sym_PERCENT] = ACTIONS(5847),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2025] = {
    [sym__concat] = ACTIONS(2462),
    [anon_sym_RPAREN] = ACTIONS(2462),
    [anon_sym_DOLLAR] = ACTIONS(2464),
    [sym__special_character] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [sym_raw_string] = ACTIONS(2462),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2462),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2462),
    [anon_sym_BQUOTE] = ACTIONS(2462),
    [anon_sym_LT_LPAREN] = ACTIONS(2462),
    [anon_sym_GT_LPAREN] = ACTIONS(2462),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2462),
  },
  [2026] = {
    [sym_concatenation] = STATE(2689),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2689),
    [sym_regex] = ACTIONS(5853),
    [anon_sym_RBRACE] = ACTIONS(5855),
    [anon_sym_EQ] = ACTIONS(5857),
    [anon_sym_DASH] = ACTIONS(5857),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5859),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5857),
    [anon_sym_COLON_QMARK] = ACTIONS(5857),
    [anon_sym_COLON_DASH] = ACTIONS(5857),
    [anon_sym_PERCENT] = ACTIONS(5857),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2027] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(5855),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2028] = {
    [sym__concat] = ACTIONS(2512),
    [anon_sym_RPAREN] = ACTIONS(2512),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [sym__special_character] = ACTIONS(2512),
    [anon_sym_DQUOTE] = ACTIONS(2512),
    [sym_raw_string] = ACTIONS(2512),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2512),
    [anon_sym_BQUOTE] = ACTIONS(2512),
    [anon_sym_LT_LPAREN] = ACTIONS(2512),
    [anon_sym_GT_LPAREN] = ACTIONS(2512),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2512),
  },
  [2029] = {
    [sym_concatenation] = STATE(2686),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2686),
    [sym_regex] = ACTIONS(5861),
    [anon_sym_RBRACE] = ACTIONS(5833),
    [anon_sym_EQ] = ACTIONS(5847),
    [anon_sym_DASH] = ACTIONS(5847),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5849),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5847),
    [anon_sym_COLON_QMARK] = ACTIONS(5847),
    [anon_sym_COLON_DASH] = ACTIONS(5847),
    [anon_sym_PERCENT] = ACTIONS(5847),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2030] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(5833),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2031] = {
    [sym__concat] = ACTIONS(2520),
    [anon_sym_RPAREN] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(2522),
    [sym__special_character] = ACTIONS(2520),
    [anon_sym_DQUOTE] = ACTIONS(2520),
    [sym_raw_string] = ACTIONS(2520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2520),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2520),
    [anon_sym_BQUOTE] = ACTIONS(2520),
    [anon_sym_LT_LPAREN] = ACTIONS(2520),
    [anon_sym_GT_LPAREN] = ACTIONS(2520),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2520),
  },
  [2032] = {
    [sym__concat] = ACTIONS(2554),
    [anon_sym_RPAREN] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2556),
    [sym__special_character] = ACTIONS(2554),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2554),
    [anon_sym_BQUOTE] = ACTIONS(2554),
    [anon_sym_LT_LPAREN] = ACTIONS(2554),
    [anon_sym_GT_LPAREN] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2554),
  },
  [2033] = {
    [sym_string] = STATE(738),
    [sym__simple_heredoc_body] = ACTIONS(4071),
    [sym__heredoc_body_beginning] = ACTIONS(4071),
    [sym_file_descriptor] = ACTIONS(4071),
    [sym_variable_name] = ACTIONS(4071),
    [ts_builtin_sym_end] = ACTIONS(4071),
    [anon_sym_SEMI] = ACTIONS(4073),
    [anon_sym_PIPE] = ACTIONS(4073),
    [anon_sym_RPAREN] = ACTIONS(4071),
    [anon_sym_SEMI_SEMI] = ACTIONS(4071),
    [anon_sym_PIPE_AMP] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_PIPE_PIPE] = ACTIONS(4071),
    [anon_sym_LT] = ACTIONS(4073),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_GT_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT] = ACTIONS(4073),
    [anon_sym_AMP_GT_GT] = ACTIONS(4071),
    [anon_sym_LT_AMP] = ACTIONS(4071),
    [anon_sym_GT_AMP] = ACTIONS(4071),
    [anon_sym_LT_LT] = ACTIONS(4073),
    [anon_sym_LT_LT_DASH] = ACTIONS(4071),
    [anon_sym_LT_LT_LT] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(5863),
    [anon_sym_DOLLAR] = ACTIONS(5863),
    [sym__special_character] = ACTIONS(4071),
    [anon_sym_DQUOTE] = ACTIONS(457),
    [sym_raw_string] = ACTIONS(1424),
    [anon_sym_POUND] = ACTIONS(1422),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4071),
    [anon_sym_BQUOTE] = ACTIONS(4071),
    [anon_sym_LT_LPAREN] = ACTIONS(4071),
    [anon_sym_GT_LPAREN] = ACTIONS(4071),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1426),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_AT] = ACTIONS(1426),
    [anon_sym_QMARK] = ACTIONS(1426),
    [anon_sym_0] = ACTIONS(1426),
    [anon_sym__] = ACTIONS(1426),
    [sym_word] = ACTIONS(4073),
    [anon_sym_LF] = ACTIONS(4071),
    [anon_sym_AMP] = ACTIONS(4073),
  },
  [2034] = {
    [sym__simple_heredoc_body] = ACTIONS(4111),
    [sym__heredoc_body_beginning] = ACTIONS(4111),
    [sym_file_descriptor] = ACTIONS(4111),
    [sym__concat] = ACTIONS(4111),
    [sym_variable_name] = ACTIONS(4111),
    [ts_builtin_sym_end] = ACTIONS(4111),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_PIPE] = ACTIONS(4113),
    [anon_sym_RPAREN] = ACTIONS(4111),
    [anon_sym_SEMI_SEMI] = ACTIONS(4111),
    [anon_sym_PIPE_AMP] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_LT] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4113),
    [anon_sym_GT_GT] = ACTIONS(4111),
    [anon_sym_AMP_GT] = ACTIONS(4113),
    [anon_sym_AMP_GT_GT] = ACTIONS(4111),
    [anon_sym_LT_AMP] = ACTIONS(4111),
    [anon_sym_GT_AMP] = ACTIONS(4111),
    [anon_sym_LT_LT] = ACTIONS(4113),
    [anon_sym_LT_LT_DASH] = ACTIONS(4111),
    [anon_sym_LT_LT_LT] = ACTIONS(4111),
    [anon_sym_DOLLAR] = ACTIONS(4113),
    [sym__special_character] = ACTIONS(4111),
    [anon_sym_DQUOTE] = ACTIONS(4111),
    [sym_raw_string] = ACTIONS(4111),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4111),
    [anon_sym_BQUOTE] = ACTIONS(4111),
    [anon_sym_LT_LPAREN] = ACTIONS(4111),
    [anon_sym_GT_LPAREN] = ACTIONS(4111),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4113),
    [anon_sym_LF] = ACTIONS(4111),
    [anon_sym_AMP] = ACTIONS(4113),
  },
  [2035] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [sym_variable_name] = ACTIONS(4125),
    [ts_builtin_sym_end] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_RPAREN] = ACTIONS(4125),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym__special_character] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [2036] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(5865),
    [sym_comment] = ACTIONS(57),
  },
  [2037] = {
    [anon_sym_RBRACE] = ACTIONS(5865),
    [sym_comment] = ACTIONS(57),
  },
  [2038] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(5867),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [2039] = {
    [sym_concatenation] = STATE(2694),
    [sym_string] = STATE(2693),
    [sym_simple_expansion] = STATE(2693),
    [sym_string_expansion] = STATE(2693),
    [sym_expansion] = STATE(2693),
    [sym_command_substitution] = STATE(2693),
    [sym_process_substitution] = STATE(2693),
    [aux_sym__literal_repeat1] = STATE(2695),
    [anon_sym_RBRACE] = ACTIONS(5865),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(5869),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5869),
  },
  [2040] = {
    [sym__simple_heredoc_body] = ACTIONS(4161),
    [sym__heredoc_body_beginning] = ACTIONS(4161),
    [sym_file_descriptor] = ACTIONS(4161),
    [sym__concat] = ACTIONS(4161),
    [sym_variable_name] = ACTIONS(4161),
    [ts_builtin_sym_end] = ACTIONS(4161),
    [anon_sym_SEMI] = ACTIONS(4163),
    [anon_sym_PIPE] = ACTIONS(4163),
    [anon_sym_RPAREN] = ACTIONS(4161),
    [anon_sym_SEMI_SEMI] = ACTIONS(4161),
    [anon_sym_PIPE_AMP] = ACTIONS(4161),
    [anon_sym_AMP_AMP] = ACTIONS(4161),
    [anon_sym_PIPE_PIPE] = ACTIONS(4161),
    [anon_sym_LT] = ACTIONS(4163),
    [anon_sym_GT] = ACTIONS(4163),
    [anon_sym_GT_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT] = ACTIONS(4163),
    [anon_sym_AMP_GT_GT] = ACTIONS(4161),
    [anon_sym_LT_AMP] = ACTIONS(4161),
    [anon_sym_GT_AMP] = ACTIONS(4161),
    [anon_sym_LT_LT] = ACTIONS(4163),
    [anon_sym_LT_LT_DASH] = ACTIONS(4161),
    [anon_sym_LT_LT_LT] = ACTIONS(4161),
    [anon_sym_DOLLAR] = ACTIONS(4163),
    [sym__special_character] = ACTIONS(4161),
    [anon_sym_DQUOTE] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4161),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4161),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4161),
    [anon_sym_BQUOTE] = ACTIONS(4161),
    [anon_sym_LT_LPAREN] = ACTIONS(4161),
    [anon_sym_GT_LPAREN] = ACTIONS(4161),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4163),
    [anon_sym_LF] = ACTIONS(4161),
    [anon_sym_AMP] = ACTIONS(4163),
  },
  [2041] = {
    [sym_concatenation] = STATE(2698),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2698),
    [sym_regex] = ACTIONS(5871),
    [anon_sym_RBRACE] = ACTIONS(5873),
    [anon_sym_EQ] = ACTIONS(5875),
    [anon_sym_DASH] = ACTIONS(5875),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5877),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5875),
    [anon_sym_COLON_QMARK] = ACTIONS(5875),
    [anon_sym_COLON_DASH] = ACTIONS(5875),
    [anon_sym_PERCENT] = ACTIONS(5875),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2042] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(5873),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2043] = {
    [sym_concatenation] = STATE(2700),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2700),
    [sym_regex] = ACTIONS(5879),
    [anon_sym_RBRACE] = ACTIONS(5865),
    [anon_sym_EQ] = ACTIONS(5881),
    [anon_sym_DASH] = ACTIONS(5881),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5883),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5881),
    [anon_sym_COLON_QMARK] = ACTIONS(5881),
    [anon_sym_COLON_DASH] = ACTIONS(5881),
    [anon_sym_PERCENT] = ACTIONS(5881),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2044] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(5865),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2045] = {
    [sym_concatenation] = STATE(2702),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2702),
    [anon_sym_RBRACE] = ACTIONS(5885),
    [anon_sym_EQ] = ACTIONS(5887),
    [anon_sym_DASH] = ACTIONS(5887),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5887),
    [anon_sym_COLON_QMARK] = ACTIONS(5887),
    [anon_sym_COLON_DASH] = ACTIONS(5887),
    [anon_sym_PERCENT] = ACTIONS(5887),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2046] = {
    [sym__simple_heredoc_body] = ACTIONS(4219),
    [sym__heredoc_body_beginning] = ACTIONS(4219),
    [sym_file_descriptor] = ACTIONS(4219),
    [sym__concat] = ACTIONS(4219),
    [sym_variable_name] = ACTIONS(4219),
    [ts_builtin_sym_end] = ACTIONS(4219),
    [anon_sym_SEMI] = ACTIONS(4221),
    [anon_sym_PIPE] = ACTIONS(4221),
    [anon_sym_RPAREN] = ACTIONS(4219),
    [anon_sym_SEMI_SEMI] = ACTIONS(4219),
    [anon_sym_PIPE_AMP] = ACTIONS(4219),
    [anon_sym_AMP_AMP] = ACTIONS(4219),
    [anon_sym_PIPE_PIPE] = ACTIONS(4219),
    [anon_sym_LT] = ACTIONS(4221),
    [anon_sym_GT] = ACTIONS(4221),
    [anon_sym_GT_GT] = ACTIONS(4219),
    [anon_sym_AMP_GT] = ACTIONS(4221),
    [anon_sym_AMP_GT_GT] = ACTIONS(4219),
    [anon_sym_LT_AMP] = ACTIONS(4219),
    [anon_sym_GT_AMP] = ACTIONS(4219),
    [anon_sym_LT_LT] = ACTIONS(4221),
    [anon_sym_LT_LT_DASH] = ACTIONS(4219),
    [anon_sym_LT_LT_LT] = ACTIONS(4219),
    [anon_sym_DOLLAR] = ACTIONS(4221),
    [sym__special_character] = ACTIONS(4219),
    [anon_sym_DQUOTE] = ACTIONS(4219),
    [sym_raw_string] = ACTIONS(4219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4219),
    [anon_sym_BQUOTE] = ACTIONS(4219),
    [anon_sym_LT_LPAREN] = ACTIONS(4219),
    [anon_sym_GT_LPAREN] = ACTIONS(4219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4221),
    [anon_sym_LF] = ACTIONS(4219),
    [anon_sym_AMP] = ACTIONS(4221),
  },
  [2047] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(5885),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2048] = {
    [sym_concatenation] = STATE(2700),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2700),
    [anon_sym_RBRACE] = ACTIONS(5865),
    [anon_sym_EQ] = ACTIONS(5881),
    [anon_sym_DASH] = ACTIONS(5881),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5883),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5881),
    [anon_sym_COLON_QMARK] = ACTIONS(5881),
    [anon_sym_COLON_DASH] = ACTIONS(5881),
    [anon_sym_PERCENT] = ACTIONS(5881),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2049] = {
    [sym_do_group] = STATE(2703),
    [sym_compound_statement] = STATE(2703),
    [anon_sym_do] = ACTIONS(651),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(57),
  },
  [2050] = {
    [sym__simple_heredoc_body] = ACTIONS(5891),
    [sym__heredoc_body_beginning] = ACTIONS(5891),
    [sym_file_descriptor] = ACTIONS(5891),
    [ts_builtin_sym_end] = ACTIONS(5891),
    [anon_sym_SEMI] = ACTIONS(5893),
    [anon_sym_done] = ACTIONS(5891),
    [anon_sym_fi] = ACTIONS(5891),
    [anon_sym_elif] = ACTIONS(5891),
    [anon_sym_else] = ACTIONS(5891),
    [anon_sym_esac] = ACTIONS(5891),
    [anon_sym_PIPE] = ACTIONS(5893),
    [anon_sym_RPAREN] = ACTIONS(5891),
    [anon_sym_SEMI_SEMI] = ACTIONS(5891),
    [anon_sym_PIPE_AMP] = ACTIONS(5891),
    [anon_sym_AMP_AMP] = ACTIONS(5891),
    [anon_sym_PIPE_PIPE] = ACTIONS(5891),
    [anon_sym_LT] = ACTIONS(5893),
    [anon_sym_GT] = ACTIONS(5893),
    [anon_sym_GT_GT] = ACTIONS(5891),
    [anon_sym_AMP_GT] = ACTIONS(5893),
    [anon_sym_AMP_GT_GT] = ACTIONS(5891),
    [anon_sym_LT_AMP] = ACTIONS(5891),
    [anon_sym_GT_AMP] = ACTIONS(5891),
    [anon_sym_LT_LT] = ACTIONS(5893),
    [anon_sym_LT_LT_DASH] = ACTIONS(5891),
    [anon_sym_LT_LT_LT] = ACTIONS(5891),
    [anon_sym_BQUOTE] = ACTIONS(5891),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5891),
    [anon_sym_AMP] = ACTIONS(5893),
  },
  [2051] = {
    [sym_do_group] = STATE(2703),
    [sym_compound_statement] = STATE(2703),
    [anon_sym_SEMI] = ACTIONS(5895),
    [anon_sym_do] = ACTIONS(651),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(57),
  },
  [2052] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(5897),
    [anon_sym_AMP_AMP] = ACTIONS(557),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(559),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_PLUS_EQ] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DASH_EQ] = ACTIONS(557),
    [anon_sym_LT_EQ] = ACTIONS(557),
    [anon_sym_GT_EQ] = ACTIONS(557),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(557),
  },
  [2053] = {
    [sym_string] = STATE(760),
    [anon_sym_SEMI] = ACTIONS(4073),
    [anon_sym_SEMI_SEMI] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_PIPE_PIPE] = ACTIONS(4071),
    [anon_sym_EQ_TILDE] = ACTIONS(4071),
    [anon_sym_EQ_EQ] = ACTIONS(4071),
    [anon_sym_EQ] = ACTIONS(4073),
    [anon_sym_PLUS_EQ] = ACTIONS(4071),
    [anon_sym_LT] = ACTIONS(4073),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_BANG_EQ] = ACTIONS(4071),
    [anon_sym_PLUS] = ACTIONS(4073),
    [anon_sym_DASH] = ACTIONS(5899),
    [anon_sym_DASH_EQ] = ACTIONS(4071),
    [anon_sym_LT_EQ] = ACTIONS(4071),
    [anon_sym_GT_EQ] = ACTIONS(4071),
    [anon_sym_PLUS_PLUS] = ACTIONS(4071),
    [anon_sym_DASH_DASH] = ACTIONS(4071),
    [anon_sym_DOLLAR] = ACTIONS(1456),
    [anon_sym_DQUOTE] = ACTIONS(481),
    [sym_raw_string] = ACTIONS(1458),
    [anon_sym_POUND] = ACTIONS(1456),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1460),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_AT] = ACTIONS(1462),
    [anon_sym_QMARK] = ACTIONS(1462),
    [anon_sym_0] = ACTIONS(1460),
    [anon_sym__] = ACTIONS(1460),
    [sym_test_operator] = ACTIONS(4071),
    [anon_sym_LF] = ACTIONS(4071),
    [anon_sym_AMP] = ACTIONS(4073),
  },
  [2054] = {
    [sym__concat] = ACTIONS(4111),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_SEMI_SEMI] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_EQ_TILDE] = ACTIONS(4111),
    [anon_sym_EQ_EQ] = ACTIONS(4111),
    [anon_sym_EQ] = ACTIONS(4113),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_LT] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4113),
    [anon_sym_BANG_EQ] = ACTIONS(4111),
    [anon_sym_PLUS] = ACTIONS(4113),
    [anon_sym_DASH] = ACTIONS(4113),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_PLUS_PLUS] = ACTIONS(4111),
    [anon_sym_DASH_DASH] = ACTIONS(4111),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4111),
    [anon_sym_LF] = ACTIONS(4111),
    [anon_sym_AMP] = ACTIONS(4113),
  },
  [2055] = {
    [sym__concat] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_EQ_TILDE] = ACTIONS(4125),
    [anon_sym_EQ_EQ] = ACTIONS(4125),
    [anon_sym_EQ] = ACTIONS(4127),
    [anon_sym_PLUS_EQ] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_BANG_EQ] = ACTIONS(4125),
    [anon_sym_PLUS] = ACTIONS(4127),
    [anon_sym_DASH] = ACTIONS(4127),
    [anon_sym_DASH_EQ] = ACTIONS(4125),
    [anon_sym_LT_EQ] = ACTIONS(4125),
    [anon_sym_GT_EQ] = ACTIONS(4125),
    [anon_sym_PLUS_PLUS] = ACTIONS(4125),
    [anon_sym_DASH_DASH] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4125),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [2056] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(5901),
    [sym_comment] = ACTIONS(57),
  },
  [2057] = {
    [anon_sym_RBRACE] = ACTIONS(5901),
    [sym_comment] = ACTIONS(57),
  },
  [2058] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(5903),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [2059] = {
    [sym_concatenation] = STATE(2709),
    [sym_string] = STATE(2708),
    [sym_simple_expansion] = STATE(2708),
    [sym_string_expansion] = STATE(2708),
    [sym_expansion] = STATE(2708),
    [sym_command_substitution] = STATE(2708),
    [sym_process_substitution] = STATE(2708),
    [aux_sym__literal_repeat1] = STATE(2710),
    [anon_sym_RBRACE] = ACTIONS(5901),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(5905),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5905),
  },
  [2060] = {
    [sym__concat] = ACTIONS(4161),
    [anon_sym_SEMI] = ACTIONS(4163),
    [anon_sym_SEMI_SEMI] = ACTIONS(4161),
    [anon_sym_AMP_AMP] = ACTIONS(4161),
    [anon_sym_PIPE_PIPE] = ACTIONS(4161),
    [anon_sym_EQ_TILDE] = ACTIONS(4161),
    [anon_sym_EQ_EQ] = ACTIONS(4161),
    [anon_sym_EQ] = ACTIONS(4163),
    [anon_sym_PLUS_EQ] = ACTIONS(4161),
    [anon_sym_LT] = ACTIONS(4163),
    [anon_sym_GT] = ACTIONS(4163),
    [anon_sym_BANG_EQ] = ACTIONS(4161),
    [anon_sym_PLUS] = ACTIONS(4163),
    [anon_sym_DASH] = ACTIONS(4163),
    [anon_sym_DASH_EQ] = ACTIONS(4161),
    [anon_sym_LT_EQ] = ACTIONS(4161),
    [anon_sym_GT_EQ] = ACTIONS(4161),
    [anon_sym_PLUS_PLUS] = ACTIONS(4161),
    [anon_sym_DASH_DASH] = ACTIONS(4161),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4161),
    [anon_sym_LF] = ACTIONS(4161),
    [anon_sym_AMP] = ACTIONS(4163),
  },
  [2061] = {
    [sym_concatenation] = STATE(2713),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2713),
    [sym_regex] = ACTIONS(5907),
    [anon_sym_RBRACE] = ACTIONS(5909),
    [anon_sym_EQ] = ACTIONS(5911),
    [anon_sym_DASH] = ACTIONS(5911),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5913),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5911),
    [anon_sym_COLON_QMARK] = ACTIONS(5911),
    [anon_sym_COLON_DASH] = ACTIONS(5911),
    [anon_sym_PERCENT] = ACTIONS(5911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2062] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(5909),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2063] = {
    [sym_concatenation] = STATE(2715),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2715),
    [sym_regex] = ACTIONS(5915),
    [anon_sym_RBRACE] = ACTIONS(5901),
    [anon_sym_EQ] = ACTIONS(5917),
    [anon_sym_DASH] = ACTIONS(5917),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5919),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5917),
    [anon_sym_COLON_QMARK] = ACTIONS(5917),
    [anon_sym_COLON_DASH] = ACTIONS(5917),
    [anon_sym_PERCENT] = ACTIONS(5917),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2064] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(5901),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2065] = {
    [sym_concatenation] = STATE(2717),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2717),
    [anon_sym_RBRACE] = ACTIONS(5921),
    [anon_sym_EQ] = ACTIONS(5923),
    [anon_sym_DASH] = ACTIONS(5923),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5925),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5923),
    [anon_sym_COLON_QMARK] = ACTIONS(5923),
    [anon_sym_COLON_DASH] = ACTIONS(5923),
    [anon_sym_PERCENT] = ACTIONS(5923),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2066] = {
    [sym__concat] = ACTIONS(4219),
    [anon_sym_SEMI] = ACTIONS(4221),
    [anon_sym_SEMI_SEMI] = ACTIONS(4219),
    [anon_sym_AMP_AMP] = ACTIONS(4219),
    [anon_sym_PIPE_PIPE] = ACTIONS(4219),
    [anon_sym_EQ_TILDE] = ACTIONS(4219),
    [anon_sym_EQ_EQ] = ACTIONS(4219),
    [anon_sym_EQ] = ACTIONS(4221),
    [anon_sym_PLUS_EQ] = ACTIONS(4219),
    [anon_sym_LT] = ACTIONS(4221),
    [anon_sym_GT] = ACTIONS(4221),
    [anon_sym_BANG_EQ] = ACTIONS(4219),
    [anon_sym_PLUS] = ACTIONS(4221),
    [anon_sym_DASH] = ACTIONS(4221),
    [anon_sym_DASH_EQ] = ACTIONS(4219),
    [anon_sym_LT_EQ] = ACTIONS(4219),
    [anon_sym_GT_EQ] = ACTIONS(4219),
    [anon_sym_PLUS_PLUS] = ACTIONS(4219),
    [anon_sym_DASH_DASH] = ACTIONS(4219),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4219),
    [anon_sym_LF] = ACTIONS(4219),
    [anon_sym_AMP] = ACTIONS(4221),
  },
  [2067] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(5921),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2068] = {
    [sym_concatenation] = STATE(2715),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2715),
    [anon_sym_RBRACE] = ACTIONS(5901),
    [anon_sym_EQ] = ACTIONS(5917),
    [anon_sym_DASH] = ACTIONS(5917),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5919),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5917),
    [anon_sym_COLON_QMARK] = ACTIONS(5917),
    [anon_sym_COLON_DASH] = ACTIONS(5917),
    [anon_sym_PERCENT] = ACTIONS(5917),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2069] = {
    [sym__expression] = STATE(2718),
    [sym_binary_expression] = STATE(2718),
    [sym_unary_expression] = STATE(2718),
    [sym_postfix_expression] = STATE(2718),
    [sym_parenthesized_expression] = STATE(2718),
    [sym_concatenation] = STATE(2718),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__literal_repeat1] = STATE(53),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(5897),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_DOLLAR] = ACTIONS(77),
    [sym__special_character] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [2070] = {
    [sym__concat] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2362),
  },
  [2071] = {
    [sym_string] = STATE(2070),
    [sym_simple_expansion] = STATE(2070),
    [sym_string_expansion] = STATE(2070),
    [sym_expansion] = STATE(2070),
    [sym_command_substitution] = STATE(2070),
    [sym_process_substitution] = STATE(2070),
    [anon_sym_DOLLAR] = ACTIONS(5927),
    [sym__special_character] = ACTIONS(4564),
    [anon_sym_DQUOTE] = ACTIONS(1498),
    [sym_raw_string] = ACTIONS(4564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1502),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1504),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_LT_LPAREN] = ACTIONS(1508),
    [anon_sym_GT_LPAREN] = ACTIONS(1508),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4564),
  },
  [2072] = {
    [aux_sym_concatenation_repeat1] = STATE(2072),
    [sym__concat] = ACTIONS(5929),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2362),
  },
  [2073] = {
    [sym__concat] = ACTIONS(2371),
    [anon_sym_SEMI] = ACTIONS(2373),
    [anon_sym_SEMI_SEMI] = ACTIONS(2371),
    [anon_sym_DOLLAR] = ACTIONS(2373),
    [sym__special_character] = ACTIONS(2371),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [sym_raw_string] = ACTIONS(2371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2371),
    [anon_sym_BQUOTE] = ACTIONS(2371),
    [anon_sym_LT_LPAREN] = ACTIONS(2371),
    [anon_sym_GT_LPAREN] = ACTIONS(2371),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2373),
    [anon_sym_LF] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2371),
  },
  [2074] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(5932),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [2075] = {
    [sym_concatenation] = STATE(2723),
    [sym_string] = STATE(2722),
    [sym_simple_expansion] = STATE(2722),
    [sym_string_expansion] = STATE(2722),
    [sym_expansion] = STATE(2722),
    [sym_command_substitution] = STATE(2722),
    [sym_process_substitution] = STATE(2722),
    [aux_sym__literal_repeat1] = STATE(2724),
    [anon_sym_RBRACE] = ACTIONS(5934),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(5936),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5936),
  },
  [2076] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(5938),
    [sym_comment] = ACTIONS(57),
  },
  [2077] = {
    [sym_concatenation] = STATE(2728),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2728),
    [anon_sym_RBRACE] = ACTIONS(5940),
    [anon_sym_EQ] = ACTIONS(5942),
    [anon_sym_DASH] = ACTIONS(5942),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5944),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(5946),
    [anon_sym_COLON] = ACTIONS(5942),
    [anon_sym_COLON_QMARK] = ACTIONS(5942),
    [anon_sym_COLON_DASH] = ACTIONS(5942),
    [anon_sym_PERCENT] = ACTIONS(5942),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2078] = {
    [sym_concatenation] = STATE(2730),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2730),
    [anon_sym_RBRACE] = ACTIONS(5934),
    [anon_sym_EQ] = ACTIONS(5948),
    [anon_sym_DASH] = ACTIONS(5948),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5950),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(5952),
    [anon_sym_COLON] = ACTIONS(5948),
    [anon_sym_COLON_QMARK] = ACTIONS(5948),
    [anon_sym_COLON_DASH] = ACTIONS(5948),
    [anon_sym_PERCENT] = ACTIONS(5948),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2079] = {
    [sym__concat] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_SEMI_SEMI] = ACTIONS(2462),
    [anon_sym_DOLLAR] = ACTIONS(2464),
    [sym__special_character] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [sym_raw_string] = ACTIONS(2462),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2462),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2462),
    [anon_sym_BQUOTE] = ACTIONS(2462),
    [anon_sym_LT_LPAREN] = ACTIONS(2462),
    [anon_sym_GT_LPAREN] = ACTIONS(2462),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2464),
    [anon_sym_LF] = ACTIONS(2462),
    [anon_sym_AMP] = ACTIONS(2462),
  },
  [2080] = {
    [sym_concatenation] = STATE(2733),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2733),
    [sym_regex] = ACTIONS(5954),
    [anon_sym_RBRACE] = ACTIONS(5956),
    [anon_sym_EQ] = ACTIONS(5958),
    [anon_sym_DASH] = ACTIONS(5958),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5958),
    [anon_sym_COLON_QMARK] = ACTIONS(5958),
    [anon_sym_COLON_DASH] = ACTIONS(5958),
    [anon_sym_PERCENT] = ACTIONS(5958),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2081] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(5956),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2082] = {
    [sym__concat] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2514),
    [anon_sym_SEMI_SEMI] = ACTIONS(2512),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [sym__special_character] = ACTIONS(2512),
    [anon_sym_DQUOTE] = ACTIONS(2512),
    [sym_raw_string] = ACTIONS(2512),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2512),
    [anon_sym_BQUOTE] = ACTIONS(2512),
    [anon_sym_LT_LPAREN] = ACTIONS(2512),
    [anon_sym_GT_LPAREN] = ACTIONS(2512),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2514),
    [anon_sym_LF] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2512),
  },
  [2083] = {
    [sym_concatenation] = STATE(2730),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2730),
    [sym_regex] = ACTIONS(5962),
    [anon_sym_RBRACE] = ACTIONS(5934),
    [anon_sym_EQ] = ACTIONS(5948),
    [anon_sym_DASH] = ACTIONS(5948),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5950),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5948),
    [anon_sym_COLON_QMARK] = ACTIONS(5948),
    [anon_sym_COLON_DASH] = ACTIONS(5948),
    [anon_sym_PERCENT] = ACTIONS(5948),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2084] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(5934),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2085] = {
    [sym__concat] = ACTIONS(2520),
    [anon_sym_SEMI] = ACTIONS(2522),
    [anon_sym_SEMI_SEMI] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(2522),
    [sym__special_character] = ACTIONS(2520),
    [anon_sym_DQUOTE] = ACTIONS(2520),
    [sym_raw_string] = ACTIONS(2520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2520),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2520),
    [anon_sym_BQUOTE] = ACTIONS(2520),
    [anon_sym_LT_LPAREN] = ACTIONS(2520),
    [anon_sym_GT_LPAREN] = ACTIONS(2520),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2522),
    [anon_sym_LF] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2520),
  },
  [2086] = {
    [sym__concat] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(2556),
    [anon_sym_SEMI_SEMI] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2556),
    [sym__special_character] = ACTIONS(2554),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2554),
    [anon_sym_BQUOTE] = ACTIONS(2554),
    [anon_sym_LT_LPAREN] = ACTIONS(2554),
    [anon_sym_GT_LPAREN] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2556),
    [anon_sym_LF] = ACTIONS(2554),
    [anon_sym_AMP] = ACTIONS(2554),
  },
  [2087] = {
    [sym__simple_heredoc_body] = ACTIONS(5964),
    [sym__heredoc_body_beginning] = ACTIONS(5964),
    [sym_file_descriptor] = ACTIONS(5964),
    [ts_builtin_sym_end] = ACTIONS(5964),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_done] = ACTIONS(5964),
    [anon_sym_fi] = ACTIONS(5964),
    [anon_sym_elif] = ACTIONS(5964),
    [anon_sym_else] = ACTIONS(5964),
    [anon_sym_esac] = ACTIONS(5964),
    [anon_sym_PIPE] = ACTIONS(5966),
    [anon_sym_RPAREN] = ACTIONS(5964),
    [anon_sym_SEMI_SEMI] = ACTIONS(5964),
    [anon_sym_PIPE_AMP] = ACTIONS(5964),
    [anon_sym_AMP_AMP] = ACTIONS(5964),
    [anon_sym_PIPE_PIPE] = ACTIONS(5964),
    [anon_sym_LT] = ACTIONS(5966),
    [anon_sym_GT] = ACTIONS(5966),
    [anon_sym_GT_GT] = ACTIONS(5964),
    [anon_sym_AMP_GT] = ACTIONS(5966),
    [anon_sym_AMP_GT_GT] = ACTIONS(5964),
    [anon_sym_LT_AMP] = ACTIONS(5964),
    [anon_sym_GT_AMP] = ACTIONS(5964),
    [anon_sym_LT_LT] = ACTIONS(5966),
    [anon_sym_LT_LT_DASH] = ACTIONS(5964),
    [anon_sym_LT_LT_LT] = ACTIONS(5964),
    [anon_sym_BQUOTE] = ACTIONS(5964),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5964),
    [anon_sym_AMP] = ACTIONS(5966),
  },
  [2088] = {
    [sym_string] = STATE(795),
    [anon_sym_RPAREN] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_PIPE_PIPE] = ACTIONS(4071),
    [anon_sym_EQ_TILDE] = ACTIONS(4071),
    [anon_sym_EQ_EQ] = ACTIONS(4071),
    [anon_sym_EQ] = ACTIONS(4073),
    [anon_sym_PLUS_EQ] = ACTIONS(4071),
    [anon_sym_LT] = ACTIONS(4073),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_BANG_EQ] = ACTIONS(4071),
    [anon_sym_PLUS] = ACTIONS(4073),
    [anon_sym_DASH] = ACTIONS(5968),
    [anon_sym_DASH_EQ] = ACTIONS(4071),
    [anon_sym_LT_EQ] = ACTIONS(4071),
    [anon_sym_GT_EQ] = ACTIONS(4071),
    [anon_sym_PLUS_PLUS] = ACTIONS(4071),
    [anon_sym_DASH_DASH] = ACTIONS(4071),
    [anon_sym_DOLLAR] = ACTIONS(1510),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(1512),
    [anon_sym_POUND] = ACTIONS(1510),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1514),
    [anon_sym_STAR] = ACTIONS(1516),
    [anon_sym_AT] = ACTIONS(1516),
    [anon_sym_QMARK] = ACTIONS(1516),
    [anon_sym_0] = ACTIONS(1514),
    [anon_sym__] = ACTIONS(1514),
    [sym_test_operator] = ACTIONS(4071),
  },
  [2089] = {
    [sym__concat] = ACTIONS(4111),
    [anon_sym_PIPE] = ACTIONS(4113),
    [anon_sym_RPAREN] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_EQ_TILDE] = ACTIONS(4111),
    [anon_sym_EQ_EQ] = ACTIONS(4111),
    [anon_sym_EQ] = ACTIONS(4113),
    [anon_sym_PLUS_EQ] = ACTIONS(4111),
    [anon_sym_LT] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4113),
    [anon_sym_BANG_EQ] = ACTIONS(4111),
    [anon_sym_PLUS] = ACTIONS(4113),
    [anon_sym_DASH] = ACTIONS(4113),
    [anon_sym_DASH_EQ] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4111),
    [anon_sym_GT_EQ] = ACTIONS(4111),
    [anon_sym_PLUS_PLUS] = ACTIONS(4111),
    [anon_sym_DASH_DASH] = ACTIONS(4111),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4111),
  },
  [2090] = {
    [sym__concat] = ACTIONS(4125),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_RPAREN] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_EQ_TILDE] = ACTIONS(4125),
    [anon_sym_EQ_EQ] = ACTIONS(4125),
    [anon_sym_EQ] = ACTIONS(4127),
    [anon_sym_PLUS_EQ] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_BANG_EQ] = ACTIONS(4125),
    [anon_sym_PLUS] = ACTIONS(4127),
    [anon_sym_DASH] = ACTIONS(4127),
    [anon_sym_DASH_EQ] = ACTIONS(4125),
    [anon_sym_LT_EQ] = ACTIONS(4125),
    [anon_sym_GT_EQ] = ACTIONS(4125),
    [anon_sym_PLUS_PLUS] = ACTIONS(4125),
    [anon_sym_DASH_DASH] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4125),
  },
  [2091] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(5970),
    [sym_comment] = ACTIONS(57),
  },
  [2092] = {
    [anon_sym_RBRACE] = ACTIONS(5970),
    [sym_comment] = ACTIONS(57),
  },
  [2093] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(5972),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [2094] = {
    [sym_concatenation] = STATE(2738),
    [sym_string] = STATE(2737),
    [sym_simple_expansion] = STATE(2737),
    [sym_string_expansion] = STATE(2737),
    [sym_expansion] = STATE(2737),
    [sym_command_substitution] = STATE(2737),
    [sym_process_substitution] = STATE(2737),
    [aux_sym__literal_repeat1] = STATE(2739),
    [anon_sym_RBRACE] = ACTIONS(5970),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(5974),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5974),
  },
  [2095] = {
    [sym__concat] = ACTIONS(4161),
    [anon_sym_PIPE] = ACTIONS(4163),
    [anon_sym_RPAREN] = ACTIONS(4161),
    [anon_sym_AMP_AMP] = ACTIONS(4161),
    [anon_sym_PIPE_PIPE] = ACTIONS(4161),
    [anon_sym_EQ_TILDE] = ACTIONS(4161),
    [anon_sym_EQ_EQ] = ACTIONS(4161),
    [anon_sym_EQ] = ACTIONS(4163),
    [anon_sym_PLUS_EQ] = ACTIONS(4161),
    [anon_sym_LT] = ACTIONS(4163),
    [anon_sym_GT] = ACTIONS(4163),
    [anon_sym_BANG_EQ] = ACTIONS(4161),
    [anon_sym_PLUS] = ACTIONS(4163),
    [anon_sym_DASH] = ACTIONS(4163),
    [anon_sym_DASH_EQ] = ACTIONS(4161),
    [anon_sym_LT_EQ] = ACTIONS(4161),
    [anon_sym_GT_EQ] = ACTIONS(4161),
    [anon_sym_PLUS_PLUS] = ACTIONS(4161),
    [anon_sym_DASH_DASH] = ACTIONS(4161),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4161),
  },
  [2096] = {
    [sym_concatenation] = STATE(2742),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2742),
    [sym_regex] = ACTIONS(5976),
    [anon_sym_RBRACE] = ACTIONS(5978),
    [anon_sym_EQ] = ACTIONS(5980),
    [anon_sym_DASH] = ACTIONS(5980),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5982),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5980),
    [anon_sym_COLON_QMARK] = ACTIONS(5980),
    [anon_sym_COLON_DASH] = ACTIONS(5980),
    [anon_sym_PERCENT] = ACTIONS(5980),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2097] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(5978),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2098] = {
    [sym_concatenation] = STATE(2744),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2744),
    [sym_regex] = ACTIONS(5984),
    [anon_sym_RBRACE] = ACTIONS(5970),
    [anon_sym_EQ] = ACTIONS(5986),
    [anon_sym_DASH] = ACTIONS(5986),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5988),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5986),
    [anon_sym_COLON_QMARK] = ACTIONS(5986),
    [anon_sym_COLON_DASH] = ACTIONS(5986),
    [anon_sym_PERCENT] = ACTIONS(5986),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2099] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(5970),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2100] = {
    [sym_concatenation] = STATE(2746),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2746),
    [anon_sym_RBRACE] = ACTIONS(5990),
    [anon_sym_EQ] = ACTIONS(5992),
    [anon_sym_DASH] = ACTIONS(5992),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5994),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5992),
    [anon_sym_COLON_QMARK] = ACTIONS(5992),
    [anon_sym_COLON_DASH] = ACTIONS(5992),
    [anon_sym_PERCENT] = ACTIONS(5992),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2101] = {
    [sym__concat] = ACTIONS(4219),
    [anon_sym_PIPE] = ACTIONS(4221),
    [anon_sym_RPAREN] = ACTIONS(4219),
    [anon_sym_AMP_AMP] = ACTIONS(4219),
    [anon_sym_PIPE_PIPE] = ACTIONS(4219),
    [anon_sym_EQ_TILDE] = ACTIONS(4219),
    [anon_sym_EQ_EQ] = ACTIONS(4219),
    [anon_sym_EQ] = ACTIONS(4221),
    [anon_sym_PLUS_EQ] = ACTIONS(4219),
    [anon_sym_LT] = ACTIONS(4221),
    [anon_sym_GT] = ACTIONS(4221),
    [anon_sym_BANG_EQ] = ACTIONS(4219),
    [anon_sym_PLUS] = ACTIONS(4221),
    [anon_sym_DASH] = ACTIONS(4221),
    [anon_sym_DASH_EQ] = ACTIONS(4219),
    [anon_sym_LT_EQ] = ACTIONS(4219),
    [anon_sym_GT_EQ] = ACTIONS(4219),
    [anon_sym_PLUS_PLUS] = ACTIONS(4219),
    [anon_sym_DASH_DASH] = ACTIONS(4219),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4219),
  },
  [2102] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(5990),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2103] = {
    [sym_concatenation] = STATE(2744),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2744),
    [anon_sym_RBRACE] = ACTIONS(5970),
    [anon_sym_EQ] = ACTIONS(5986),
    [anon_sym_DASH] = ACTIONS(5986),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(5988),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(5986),
    [anon_sym_COLON_QMARK] = ACTIONS(5986),
    [anon_sym_COLON_DASH] = ACTIONS(5986),
    [anon_sym_PERCENT] = ACTIONS(5986),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2104] = {
    [sym__concat] = ACTIONS(5674),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(5674),
    [anon_sym_AMP_AMP] = ACTIONS(5674),
    [anon_sym_PIPE_PIPE] = ACTIONS(5674),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(5674),
    [anon_sym_EQ_TILDE] = ACTIONS(5674),
    [anon_sym_EQ_EQ] = ACTIONS(5674),
    [anon_sym_EQ] = ACTIONS(5676),
    [anon_sym_PLUS_EQ] = ACTIONS(5674),
    [anon_sym_LT] = ACTIONS(5676),
    [anon_sym_GT] = ACTIONS(5676),
    [anon_sym_BANG_EQ] = ACTIONS(5674),
    [anon_sym_PLUS] = ACTIONS(5676),
    [anon_sym_DASH] = ACTIONS(5676),
    [anon_sym_DASH_EQ] = ACTIONS(5674),
    [anon_sym_LT_EQ] = ACTIONS(5674),
    [anon_sym_GT_EQ] = ACTIONS(5674),
    [anon_sym_PLUS_PLUS] = ACTIONS(5674),
    [anon_sym_DASH_DASH] = ACTIONS(5674),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5674),
  },
  [2105] = {
    [sym__concat] = ACTIONS(5708),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(5708),
    [anon_sym_AMP_AMP] = ACTIONS(5708),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(5708),
    [anon_sym_EQ_TILDE] = ACTIONS(5708),
    [anon_sym_EQ_EQ] = ACTIONS(5708),
    [anon_sym_EQ] = ACTIONS(5710),
    [anon_sym_PLUS_EQ] = ACTIONS(5708),
    [anon_sym_LT] = ACTIONS(5710),
    [anon_sym_GT] = ACTIONS(5710),
    [anon_sym_BANG_EQ] = ACTIONS(5708),
    [anon_sym_PLUS] = ACTIONS(5710),
    [anon_sym_DASH] = ACTIONS(5710),
    [anon_sym_DASH_EQ] = ACTIONS(5708),
    [anon_sym_LT_EQ] = ACTIONS(5708),
    [anon_sym_GT_EQ] = ACTIONS(5708),
    [anon_sym_PLUS_PLUS] = ACTIONS(5708),
    [anon_sym_DASH_DASH] = ACTIONS(5708),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5708),
  },
  [2106] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(5996),
    [sym_comment] = ACTIONS(57),
  },
  [2107] = {
    [anon_sym_RBRACE] = ACTIONS(5996),
    [sym_comment] = ACTIONS(57),
  },
  [2108] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(5998),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [2109] = {
    [sym_concatenation] = STATE(2750),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2750),
    [anon_sym_RBRACE] = ACTIONS(6000),
    [anon_sym_EQ] = ACTIONS(6002),
    [anon_sym_DASH] = ACTIONS(6002),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(6004),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(6002),
    [anon_sym_COLON_QMARK] = ACTIONS(6002),
    [anon_sym_COLON_DASH] = ACTIONS(6002),
    [anon_sym_PERCENT] = ACTIONS(6002),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2110] = {
    [sym__concat] = ACTIONS(5725),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(5725),
    [anon_sym_AMP_AMP] = ACTIONS(5725),
    [anon_sym_PIPE_PIPE] = ACTIONS(5725),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(5725),
    [anon_sym_EQ_TILDE] = ACTIONS(5725),
    [anon_sym_EQ_EQ] = ACTIONS(5725),
    [anon_sym_EQ] = ACTIONS(5727),
    [anon_sym_PLUS_EQ] = ACTIONS(5725),
    [anon_sym_LT] = ACTIONS(5727),
    [anon_sym_GT] = ACTIONS(5727),
    [anon_sym_BANG_EQ] = ACTIONS(5725),
    [anon_sym_PLUS] = ACTIONS(5727),
    [anon_sym_DASH] = ACTIONS(5727),
    [anon_sym_DASH_EQ] = ACTIONS(5725),
    [anon_sym_LT_EQ] = ACTIONS(5725),
    [anon_sym_GT_EQ] = ACTIONS(5725),
    [anon_sym_PLUS_PLUS] = ACTIONS(5725),
    [anon_sym_DASH_DASH] = ACTIONS(5725),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5725),
  },
  [2111] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(6000),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2112] = {
    [sym_concatenation] = STATE(2751),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2751),
    [anon_sym_RBRACE] = ACTIONS(5996),
    [anon_sym_EQ] = ACTIONS(6006),
    [anon_sym_DASH] = ACTIONS(6006),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(6008),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(6006),
    [anon_sym_COLON_QMARK] = ACTIONS(6006),
    [anon_sym_COLON_DASH] = ACTIONS(6006),
    [anon_sym_PERCENT] = ACTIONS(6006),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2113] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(5996),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2114] = {
    [sym__concat] = ACTIONS(5770),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(5770),
    [anon_sym_AMP_AMP] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5770),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(5770),
    [anon_sym_EQ_TILDE] = ACTIONS(5770),
    [anon_sym_EQ_EQ] = ACTIONS(5770),
    [anon_sym_EQ] = ACTIONS(5772),
    [anon_sym_PLUS_EQ] = ACTIONS(5770),
    [anon_sym_LT] = ACTIONS(5772),
    [anon_sym_GT] = ACTIONS(5772),
    [anon_sym_BANG_EQ] = ACTIONS(5770),
    [anon_sym_PLUS] = ACTIONS(5772),
    [anon_sym_DASH] = ACTIONS(5772),
    [anon_sym_DASH_EQ] = ACTIONS(5770),
    [anon_sym_LT_EQ] = ACTIONS(5770),
    [anon_sym_GT_EQ] = ACTIONS(5770),
    [anon_sym_PLUS_PLUS] = ACTIONS(5770),
    [anon_sym_DASH_DASH] = ACTIONS(5770),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5770),
  },
  [2115] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(6010),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2116] = {
    [sym_file_descriptor] = ACTIONS(4449),
    [sym_variable_name] = ACTIONS(4449),
    [anon_sym_SEMI] = ACTIONS(4451),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_SEMI_SEMI] = ACTIONS(4449),
    [anon_sym_PIPE_AMP] = ACTIONS(4449),
    [anon_sym_AMP_AMP] = ACTIONS(4449),
    [anon_sym_PIPE_PIPE] = ACTIONS(4449),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_GT_GT] = ACTIONS(4449),
    [anon_sym_AMP_GT] = ACTIONS(4451),
    [anon_sym_AMP_GT_GT] = ACTIONS(4449),
    [anon_sym_LT_AMP] = ACTIONS(4449),
    [anon_sym_GT_AMP] = ACTIONS(4449),
    [anon_sym_LT_LT] = ACTIONS(4451),
    [anon_sym_LT_LT_DASH] = ACTIONS(4449),
    [anon_sym_LT_LT_LT] = ACTIONS(4449),
    [anon_sym_DOLLAR] = ACTIONS(4451),
    [sym__special_character] = ACTIONS(4449),
    [anon_sym_DQUOTE] = ACTIONS(4449),
    [sym_raw_string] = ACTIONS(4449),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4449),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4449),
    [anon_sym_BQUOTE] = ACTIONS(4449),
    [anon_sym_LT_LPAREN] = ACTIONS(4449),
    [anon_sym_GT_LPAREN] = ACTIONS(4449),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4451),
    [anon_sym_LF] = ACTIONS(4449),
    [anon_sym_AMP] = ACTIONS(4451),
  },
  [2117] = {
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(2362),
    [sym_variable_name] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [2118] = {
    [sym_string] = STATE(2117),
    [sym_simple_expansion] = STATE(2117),
    [sym_string_expansion] = STATE(2117),
    [sym_expansion] = STATE(2117),
    [sym_command_substitution] = STATE(2117),
    [sym_process_substitution] = STATE(2117),
    [anon_sym_DOLLAR] = ACTIONS(6012),
    [sym__special_character] = ACTIONS(4701),
    [anon_sym_DQUOTE] = ACTIONS(1607),
    [sym_raw_string] = ACTIONS(4701),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1611),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1613),
    [anon_sym_BQUOTE] = ACTIONS(1615),
    [anon_sym_LT_LPAREN] = ACTIONS(1617),
    [anon_sym_GT_LPAREN] = ACTIONS(1617),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4701),
  },
  [2119] = {
    [aux_sym_concatenation_repeat1] = STATE(2119),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(6014),
    [sym_variable_name] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [2120] = {
    [sym_file_descriptor] = ACTIONS(2371),
    [sym__concat] = ACTIONS(2371),
    [sym_variable_name] = ACTIONS(2371),
    [anon_sym_SEMI] = ACTIONS(2373),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_SEMI_SEMI] = ACTIONS(2371),
    [anon_sym_PIPE_AMP] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_GT_GT] = ACTIONS(2371),
    [anon_sym_AMP_GT] = ACTIONS(2373),
    [anon_sym_AMP_GT_GT] = ACTIONS(2371),
    [anon_sym_LT_AMP] = ACTIONS(2371),
    [anon_sym_GT_AMP] = ACTIONS(2371),
    [anon_sym_LT_LT] = ACTIONS(2373),
    [anon_sym_LT_LT_DASH] = ACTIONS(2371),
    [anon_sym_LT_LT_LT] = ACTIONS(2371),
    [anon_sym_DOLLAR] = ACTIONS(2373),
    [sym__special_character] = ACTIONS(2371),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [sym_raw_string] = ACTIONS(2371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2371),
    [anon_sym_BQUOTE] = ACTIONS(2371),
    [anon_sym_LT_LPAREN] = ACTIONS(2371),
    [anon_sym_GT_LPAREN] = ACTIONS(2371),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2373),
    [anon_sym_LF] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
  },
  [2121] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(6017),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [2122] = {
    [sym_concatenation] = STATE(2757),
    [sym_string] = STATE(2756),
    [sym_simple_expansion] = STATE(2756),
    [sym_string_expansion] = STATE(2756),
    [sym_expansion] = STATE(2756),
    [sym_command_substitution] = STATE(2756),
    [sym_process_substitution] = STATE(2756),
    [aux_sym__literal_repeat1] = STATE(2758),
    [anon_sym_RBRACE] = ACTIONS(6019),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(6021),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6021),
  },
  [2123] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(6023),
    [sym_comment] = ACTIONS(57),
  },
  [2124] = {
    [sym_concatenation] = STATE(2762),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2762),
    [anon_sym_RBRACE] = ACTIONS(6025),
    [anon_sym_EQ] = ACTIONS(6027),
    [anon_sym_DASH] = ACTIONS(6027),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(6029),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(6031),
    [anon_sym_COLON] = ACTIONS(6027),
    [anon_sym_COLON_QMARK] = ACTIONS(6027),
    [anon_sym_COLON_DASH] = ACTIONS(6027),
    [anon_sym_PERCENT] = ACTIONS(6027),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2125] = {
    [sym_concatenation] = STATE(2764),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2764),
    [anon_sym_RBRACE] = ACTIONS(6019),
    [anon_sym_EQ] = ACTIONS(6033),
    [anon_sym_DASH] = ACTIONS(6033),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(6035),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(6037),
    [anon_sym_COLON] = ACTIONS(6033),
    [anon_sym_COLON_QMARK] = ACTIONS(6033),
    [anon_sym_COLON_DASH] = ACTIONS(6033),
    [anon_sym_PERCENT] = ACTIONS(6033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2126] = {
    [sym_file_descriptor] = ACTIONS(2462),
    [sym__concat] = ACTIONS(2462),
    [sym_variable_name] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_SEMI_SEMI] = ACTIONS(2462),
    [anon_sym_PIPE_AMP] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_GT_GT] = ACTIONS(2462),
    [anon_sym_AMP_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT_GT] = ACTIONS(2462),
    [anon_sym_LT_AMP] = ACTIONS(2462),
    [anon_sym_GT_AMP] = ACTIONS(2462),
    [anon_sym_LT_LT] = ACTIONS(2464),
    [anon_sym_LT_LT_DASH] = ACTIONS(2462),
    [anon_sym_LT_LT_LT] = ACTIONS(2462),
    [anon_sym_DOLLAR] = ACTIONS(2464),
    [sym__special_character] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [sym_raw_string] = ACTIONS(2462),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2462),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2462),
    [anon_sym_BQUOTE] = ACTIONS(2462),
    [anon_sym_LT_LPAREN] = ACTIONS(2462),
    [anon_sym_GT_LPAREN] = ACTIONS(2462),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2464),
    [anon_sym_LF] = ACTIONS(2462),
    [anon_sym_AMP] = ACTIONS(2464),
  },
  [2127] = {
    [sym_concatenation] = STATE(2767),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2767),
    [sym_regex] = ACTIONS(6039),
    [anon_sym_RBRACE] = ACTIONS(6041),
    [anon_sym_EQ] = ACTIONS(6043),
    [anon_sym_DASH] = ACTIONS(6043),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(6045),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(6043),
    [anon_sym_COLON_QMARK] = ACTIONS(6043),
    [anon_sym_COLON_DASH] = ACTIONS(6043),
    [anon_sym_PERCENT] = ACTIONS(6043),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2128] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(6041),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2129] = {
    [sym_file_descriptor] = ACTIONS(2512),
    [sym__concat] = ACTIONS(2512),
    [sym_variable_name] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2514),
    [anon_sym_PIPE] = ACTIONS(2514),
    [anon_sym_SEMI_SEMI] = ACTIONS(2512),
    [anon_sym_PIPE_AMP] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE_PIPE] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2514),
    [anon_sym_GT] = ACTIONS(2514),
    [anon_sym_GT_GT] = ACTIONS(2512),
    [anon_sym_AMP_GT] = ACTIONS(2514),
    [anon_sym_AMP_GT_GT] = ACTIONS(2512),
    [anon_sym_LT_AMP] = ACTIONS(2512),
    [anon_sym_GT_AMP] = ACTIONS(2512),
    [anon_sym_LT_LT] = ACTIONS(2514),
    [anon_sym_LT_LT_DASH] = ACTIONS(2512),
    [anon_sym_LT_LT_LT] = ACTIONS(2512),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [sym__special_character] = ACTIONS(2512),
    [anon_sym_DQUOTE] = ACTIONS(2512),
    [sym_raw_string] = ACTIONS(2512),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2512),
    [anon_sym_BQUOTE] = ACTIONS(2512),
    [anon_sym_LT_LPAREN] = ACTIONS(2512),
    [anon_sym_GT_LPAREN] = ACTIONS(2512),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2514),
    [anon_sym_LF] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2514),
  },
  [2130] = {
    [sym_concatenation] = STATE(2764),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2764),
    [sym_regex] = ACTIONS(6047),
    [anon_sym_RBRACE] = ACTIONS(6019),
    [anon_sym_EQ] = ACTIONS(6033),
    [anon_sym_DASH] = ACTIONS(6033),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(6035),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(6033),
    [anon_sym_COLON_QMARK] = ACTIONS(6033),
    [anon_sym_COLON_DASH] = ACTIONS(6033),
    [anon_sym_PERCENT] = ACTIONS(6033),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2131] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(6019),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2132] = {
    [sym_file_descriptor] = ACTIONS(2520),
    [sym__concat] = ACTIONS(2520),
    [sym_variable_name] = ACTIONS(2520),
    [anon_sym_SEMI] = ACTIONS(2522),
    [anon_sym_PIPE] = ACTIONS(2522),
    [anon_sym_SEMI_SEMI] = ACTIONS(2520),
    [anon_sym_PIPE_AMP] = ACTIONS(2520),
    [anon_sym_AMP_AMP] = ACTIONS(2520),
    [anon_sym_PIPE_PIPE] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(2522),
    [anon_sym_GT] = ACTIONS(2522),
    [anon_sym_GT_GT] = ACTIONS(2520),
    [anon_sym_AMP_GT] = ACTIONS(2522),
    [anon_sym_AMP_GT_GT] = ACTIONS(2520),
    [anon_sym_LT_AMP] = ACTIONS(2520),
    [anon_sym_GT_AMP] = ACTIONS(2520),
    [anon_sym_LT_LT] = ACTIONS(2522),
    [anon_sym_LT_LT_DASH] = ACTIONS(2520),
    [anon_sym_LT_LT_LT] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(2522),
    [sym__special_character] = ACTIONS(2520),
    [anon_sym_DQUOTE] = ACTIONS(2520),
    [sym_raw_string] = ACTIONS(2520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2520),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2520),
    [anon_sym_BQUOTE] = ACTIONS(2520),
    [anon_sym_LT_LPAREN] = ACTIONS(2520),
    [anon_sym_GT_LPAREN] = ACTIONS(2520),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2522),
    [anon_sym_LF] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2522),
  },
  [2133] = {
    [sym_file_descriptor] = ACTIONS(2554),
    [sym__concat] = ACTIONS(2554),
    [sym_variable_name] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(2556),
    [anon_sym_PIPE] = ACTIONS(2556),
    [anon_sym_SEMI_SEMI] = ACTIONS(2554),
    [anon_sym_PIPE_AMP] = ACTIONS(2554),
    [anon_sym_AMP_AMP] = ACTIONS(2554),
    [anon_sym_PIPE_PIPE] = ACTIONS(2554),
    [anon_sym_LT] = ACTIONS(2556),
    [anon_sym_GT] = ACTIONS(2556),
    [anon_sym_GT_GT] = ACTIONS(2554),
    [anon_sym_AMP_GT] = ACTIONS(2556),
    [anon_sym_AMP_GT_GT] = ACTIONS(2554),
    [anon_sym_LT_AMP] = ACTIONS(2554),
    [anon_sym_GT_AMP] = ACTIONS(2554),
    [anon_sym_LT_LT] = ACTIONS(2556),
    [anon_sym_LT_LT_DASH] = ACTIONS(2554),
    [anon_sym_LT_LT_LT] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2556),
    [sym__special_character] = ACTIONS(2554),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2554),
    [anon_sym_BQUOTE] = ACTIONS(2554),
    [anon_sym_LT_LPAREN] = ACTIONS(2554),
    [anon_sym_GT_LPAREN] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2556),
    [anon_sym_LF] = ACTIONS(2554),
    [anon_sym_AMP] = ACTIONS(2556),
  },
  [2134] = {
    [sym_do_group] = STATE(2770),
    [sym_compound_statement] = STATE(2770),
    [anon_sym_SEMI] = ACTIONS(6049),
    [anon_sym_do] = ACTIONS(1631),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_comment] = ACTIONS(57),
  },
  [2135] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(6051),
    [anon_sym_AMP_AMP] = ACTIONS(557),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(559),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_PLUS_EQ] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DASH_EQ] = ACTIONS(557),
    [anon_sym_LT_EQ] = ACTIONS(557),
    [anon_sym_GT_EQ] = ACTIONS(557),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(557),
  },
  [2136] = {
    [sym__expression] = STATE(2772),
    [sym_binary_expression] = STATE(2772),
    [sym_unary_expression] = STATE(2772),
    [sym_postfix_expression] = STATE(2772),
    [sym_parenthesized_expression] = STATE(2772),
    [sym_concatenation] = STATE(2772),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__literal_repeat1] = STATE(53),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(6051),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_DOLLAR] = ACTIONS(77),
    [sym__special_character] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [2137] = {
    [anon_sym_SEMI] = ACTIONS(6053),
    [anon_sym_SEMI_SEMI] = ACTIONS(6055),
    [anon_sym_AMP_AMP] = ACTIONS(1484),
    [anon_sym_PIPE_PIPE] = ACTIONS(1484),
    [anon_sym_EQ_TILDE] = ACTIONS(1486),
    [anon_sym_EQ_EQ] = ACTIONS(1486),
    [anon_sym_EQ] = ACTIONS(1488),
    [anon_sym_PLUS_EQ] = ACTIONS(1484),
    [anon_sym_LT] = ACTIONS(1488),
    [anon_sym_GT] = ACTIONS(1488),
    [anon_sym_BANG_EQ] = ACTIONS(1484),
    [anon_sym_PLUS] = ACTIONS(1488),
    [anon_sym_DASH] = ACTIONS(1488),
    [anon_sym_DASH_EQ] = ACTIONS(1484),
    [anon_sym_LT_EQ] = ACTIONS(1484),
    [anon_sym_GT_EQ] = ACTIONS(1484),
    [anon_sym_PLUS_PLUS] = ACTIONS(1490),
    [anon_sym_DASH_DASH] = ACTIONS(1490),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1484),
    [anon_sym_LF] = ACTIONS(6055),
    [anon_sym_AMP] = ACTIONS(6053),
  },
  [2138] = {
    [sym_do_group] = STATE(2774),
    [anon_sym_do] = ACTIONS(1631),
    [sym_comment] = ACTIONS(57),
  },
  [2139] = {
    [sym_file_descriptor] = ACTIONS(4988),
    [anon_sym_SEMI] = ACTIONS(4990),
    [anon_sym_PIPE] = ACTIONS(4990),
    [anon_sym_SEMI_SEMI] = ACTIONS(4988),
    [anon_sym_PIPE_AMP] = ACTIONS(4988),
    [anon_sym_AMP_AMP] = ACTIONS(4988),
    [anon_sym_PIPE_PIPE] = ACTIONS(4988),
    [anon_sym_LT] = ACTIONS(4990),
    [anon_sym_GT] = ACTIONS(4990),
    [anon_sym_GT_GT] = ACTIONS(4988),
    [anon_sym_AMP_GT] = ACTIONS(4990),
    [anon_sym_AMP_GT_GT] = ACTIONS(4988),
    [anon_sym_LT_AMP] = ACTIONS(4988),
    [anon_sym_GT_AMP] = ACTIONS(4988),
    [anon_sym_LT_LT] = ACTIONS(4990),
    [anon_sym_LT_LT_DASH] = ACTIONS(4988),
    [anon_sym_LT_LT_LT] = ACTIONS(4988),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4988),
    [anon_sym_AMP] = ACTIONS(4990),
  },
  [2140] = {
    [sym_file_descriptor] = ACTIONS(5249),
    [anon_sym_SEMI] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_SEMI_SEMI] = ACTIONS(5249),
    [anon_sym_PIPE_AMP] = ACTIONS(5249),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5249),
    [anon_sym_AMP_GT] = ACTIONS(5251),
    [anon_sym_AMP_GT_GT] = ACTIONS(5249),
    [anon_sym_LT_AMP] = ACTIONS(5249),
    [anon_sym_GT_AMP] = ACTIONS(5249),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_LT_LT_DASH] = ACTIONS(5249),
    [anon_sym_LT_LT_LT] = ACTIONS(5249),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5249),
    [anon_sym_AMP] = ACTIONS(5251),
  },
  [2141] = {
    [anon_sym_fi] = ACTIONS(6057),
    [sym_comment] = ACTIONS(57),
  },
  [2142] = {
    [sym_elif_clause] = STATE(1700),
    [sym_else_clause] = STATE(2776),
    [aux_sym_if_statement_repeat1] = STATE(1700),
    [anon_sym_fi] = ACTIONS(6057),
    [anon_sym_elif] = ACTIONS(3477),
    [anon_sym_else] = ACTIONS(3479),
    [sym_comment] = ACTIONS(57),
  },
  [2143] = {
    [sym_file_descriptor] = ACTIONS(5285),
    [anon_sym_SEMI] = ACTIONS(5287),
    [anon_sym_PIPE] = ACTIONS(5287),
    [anon_sym_SEMI_SEMI] = ACTIONS(5285),
    [anon_sym_PIPE_AMP] = ACTIONS(5285),
    [anon_sym_AMP_AMP] = ACTIONS(5285),
    [anon_sym_PIPE_PIPE] = ACTIONS(5285),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_GT] = ACTIONS(5285),
    [anon_sym_AMP_GT] = ACTIONS(5287),
    [anon_sym_AMP_GT_GT] = ACTIONS(5285),
    [anon_sym_LT_AMP] = ACTIONS(5285),
    [anon_sym_GT_AMP] = ACTIONS(5285),
    [anon_sym_LT_LT] = ACTIONS(5287),
    [anon_sym_LT_LT_DASH] = ACTIONS(5285),
    [anon_sym_LT_LT_LT] = ACTIONS(5285),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5285),
    [anon_sym_AMP] = ACTIONS(5287),
  },
  [2144] = {
    [anon_sym_esac] = ACTIONS(6059),
    [sym_comment] = ACTIONS(57),
  },
  [2145] = {
    [sym_case_item] = STATE(2443),
    [sym_last_case_item] = STATE(2778),
    [sym_concatenation] = STATE(1710),
    [sym_string] = STATE(1708),
    [sym_simple_expansion] = STATE(1708),
    [sym_string_expansion] = STATE(1708),
    [sym_expansion] = STATE(1708),
    [sym_command_substitution] = STATE(1708),
    [sym_process_substitution] = STATE(1708),
    [aux_sym_case_statement_repeat1] = STATE(2443),
    [aux_sym__literal_repeat1] = STATE(1712),
    [anon_sym_DOLLAR] = ACTIONS(507),
    [sym__special_character] = ACTIONS(3518),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3520),
  },
  [2146] = {
    [sym_case_item] = STATE(2779),
    [sym_last_case_item] = STATE(2778),
    [sym_concatenation] = STATE(1710),
    [sym_string] = STATE(1708),
    [sym_simple_expansion] = STATE(1708),
    [sym_string_expansion] = STATE(1708),
    [sym_expansion] = STATE(1708),
    [sym_command_substitution] = STATE(1708),
    [sym_process_substitution] = STATE(1708),
    [aux_sym_case_statement_repeat1] = STATE(2779),
    [aux_sym__literal_repeat1] = STATE(1712),
    [anon_sym_esac] = ACTIONS(6061),
    [anon_sym_DOLLAR] = ACTIONS(507),
    [sym__special_character] = ACTIONS(3518),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3522),
  },
  [2147] = {
    [sym_file_descriptor] = ACTIONS(5325),
    [anon_sym_SEMI] = ACTIONS(5327),
    [anon_sym_PIPE] = ACTIONS(5327),
    [anon_sym_SEMI_SEMI] = ACTIONS(5325),
    [anon_sym_PIPE_AMP] = ACTIONS(5325),
    [anon_sym_AMP_AMP] = ACTIONS(5325),
    [anon_sym_PIPE_PIPE] = ACTIONS(5325),
    [anon_sym_LT] = ACTIONS(5327),
    [anon_sym_GT] = ACTIONS(5327),
    [anon_sym_GT_GT] = ACTIONS(5325),
    [anon_sym_AMP_GT] = ACTIONS(5327),
    [anon_sym_AMP_GT_GT] = ACTIONS(5325),
    [anon_sym_LT_AMP] = ACTIONS(5325),
    [anon_sym_GT_AMP] = ACTIONS(5325),
    [anon_sym_LT_LT] = ACTIONS(5327),
    [anon_sym_LT_LT_DASH] = ACTIONS(5325),
    [anon_sym_LT_LT_LT] = ACTIONS(5325),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5325),
    [anon_sym_AMP] = ACTIONS(5327),
  },
  [2148] = {
    [anon_sym_esac] = ACTIONS(6063),
    [sym_comment] = ACTIONS(57),
  },
  [2149] = {
    [sym_case_item] = STATE(2443),
    [sym_last_case_item] = STATE(2781),
    [sym_concatenation] = STATE(1710),
    [sym_string] = STATE(1708),
    [sym_simple_expansion] = STATE(1708),
    [sym_string_expansion] = STATE(1708),
    [sym_expansion] = STATE(1708),
    [sym_command_substitution] = STATE(1708),
    [sym_process_substitution] = STATE(1708),
    [aux_sym_case_statement_repeat1] = STATE(2443),
    [aux_sym__literal_repeat1] = STATE(1712),
    [anon_sym_DOLLAR] = ACTIONS(507),
    [sym__special_character] = ACTIONS(3518),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3520),
  },
  [2150] = {
    [sym_case_item] = STATE(2782),
    [sym_last_case_item] = STATE(2781),
    [sym_concatenation] = STATE(1710),
    [sym_string] = STATE(1708),
    [sym_simple_expansion] = STATE(1708),
    [sym_string_expansion] = STATE(1708),
    [sym_expansion] = STATE(1708),
    [sym_command_substitution] = STATE(1708),
    [sym_process_substitution] = STATE(1708),
    [aux_sym_case_statement_repeat1] = STATE(2782),
    [aux_sym__literal_repeat1] = STATE(1712),
    [anon_sym_esac] = ACTIONS(6065),
    [anon_sym_DOLLAR] = ACTIONS(507),
    [sym__special_character] = ACTIONS(3518),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3522),
  },
  [2151] = {
    [sym_file_descriptor] = ACTIONS(5333),
    [anon_sym_SEMI] = ACTIONS(5335),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_SEMI_SEMI] = ACTIONS(5333),
    [anon_sym_PIPE_AMP] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5335),
    [anon_sym_GT] = ACTIONS(5335),
    [anon_sym_GT_GT] = ACTIONS(5333),
    [anon_sym_AMP_GT] = ACTIONS(5335),
    [anon_sym_AMP_GT_GT] = ACTIONS(5333),
    [anon_sym_LT_AMP] = ACTIONS(5333),
    [anon_sym_GT_AMP] = ACTIONS(5333),
    [anon_sym_LT_LT] = ACTIONS(5335),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_LT] = ACTIONS(5333),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5333),
    [anon_sym_AMP] = ACTIONS(5335),
  },
  [2152] = {
    [sym_file_descriptor] = ACTIONS(2719),
    [sym_variable_name] = ACTIONS(2719),
    [anon_sym_SEMI] = ACTIONS(2721),
    [anon_sym_PIPE] = ACTIONS(2721),
    [anon_sym_SEMI_SEMI] = ACTIONS(2719),
    [anon_sym_PIPE_AMP] = ACTIONS(2719),
    [anon_sym_AMP_AMP] = ACTIONS(2719),
    [anon_sym_PIPE_PIPE] = ACTIONS(2719),
    [anon_sym_LT] = ACTIONS(2721),
    [anon_sym_GT] = ACTIONS(2721),
    [anon_sym_GT_GT] = ACTIONS(2719),
    [anon_sym_AMP_GT] = ACTIONS(2721),
    [anon_sym_AMP_GT_GT] = ACTIONS(2719),
    [anon_sym_LT_AMP] = ACTIONS(2719),
    [anon_sym_GT_AMP] = ACTIONS(2719),
    [anon_sym_LT_LT] = ACTIONS(2721),
    [anon_sym_LT_LT_DASH] = ACTIONS(2719),
    [anon_sym_LT_LT_LT] = ACTIONS(2719),
    [anon_sym_DOLLAR] = ACTIONS(2721),
    [sym__special_character] = ACTIONS(2719),
    [anon_sym_DQUOTE] = ACTIONS(2719),
    [sym_raw_string] = ACTIONS(2719),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2719),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2719),
    [anon_sym_BQUOTE] = ACTIONS(2719),
    [anon_sym_LT_LPAREN] = ACTIONS(2719),
    [anon_sym_GT_LPAREN] = ACTIONS(2719),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2721),
    [sym_word] = ACTIONS(2721),
    [anon_sym_LF] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2721),
  },
  [2153] = {
    [sym_concatenation] = STATE(1368),
    [sym_string] = STATE(730),
    [sym_simple_expansion] = STATE(730),
    [sym_string_expansion] = STATE(730),
    [sym_expansion] = STATE(730),
    [sym_command_substitution] = STATE(730),
    [sym_process_substitution] = STATE(730),
    [aux_sym_for_statement_repeat1] = STATE(1368),
    [aux_sym__literal_repeat1] = STATE(736),
    [anon_sym_RPAREN] = ACTIONS(6067),
    [anon_sym_DOLLAR] = ACTIONS(1406),
    [sym__special_character] = ACTIONS(1408),
    [anon_sym_DQUOTE] = ACTIONS(1410),
    [sym_raw_string] = ACTIONS(1412),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1414),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1416),
    [anon_sym_BQUOTE] = ACTIONS(1418),
    [anon_sym_LT_LPAREN] = ACTIONS(1420),
    [anon_sym_GT_LPAREN] = ACTIONS(1420),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1412),
  },
  [2154] = {
    [sym_string] = STATE(864),
    [sym_file_descriptor] = ACTIONS(4071),
    [sym_variable_name] = ACTIONS(4071),
    [anon_sym_SEMI] = ACTIONS(4073),
    [anon_sym_PIPE] = ACTIONS(4073),
    [anon_sym_SEMI_SEMI] = ACTIONS(4071),
    [anon_sym_PIPE_AMP] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_PIPE_PIPE] = ACTIONS(4071),
    [anon_sym_LT] = ACTIONS(4073),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_GT_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT] = ACTIONS(4073),
    [anon_sym_AMP_GT_GT] = ACTIONS(4071),
    [anon_sym_LT_AMP] = ACTIONS(4071),
    [anon_sym_GT_AMP] = ACTIONS(4071),
    [anon_sym_LT_LT] = ACTIONS(4073),
    [anon_sym_LT_LT_DASH] = ACTIONS(4071),
    [anon_sym_LT_LT_LT] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(6069),
    [anon_sym_DOLLAR] = ACTIONS(6069),
    [sym__special_character] = ACTIONS(4071),
    [anon_sym_DQUOTE] = ACTIONS(589),
    [sym_raw_string] = ACTIONS(1657),
    [anon_sym_POUND] = ACTIONS(1655),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4071),
    [anon_sym_BQUOTE] = ACTIONS(4071),
    [anon_sym_LT_LPAREN] = ACTIONS(4071),
    [anon_sym_GT_LPAREN] = ACTIONS(4071),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1659),
    [anon_sym_STAR] = ACTIONS(1659),
    [anon_sym_AT] = ACTIONS(1659),
    [anon_sym_QMARK] = ACTIONS(1659),
    [anon_sym_0] = ACTIONS(1659),
    [anon_sym__] = ACTIONS(1659),
    [sym_word] = ACTIONS(4073),
    [anon_sym_LF] = ACTIONS(4071),
    [anon_sym_AMP] = ACTIONS(4073),
  },
  [2155] = {
    [sym_file_descriptor] = ACTIONS(4111),
    [sym__concat] = ACTIONS(4111),
    [sym_variable_name] = ACTIONS(4111),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_PIPE] = ACTIONS(4113),
    [anon_sym_SEMI_SEMI] = ACTIONS(4111),
    [anon_sym_PIPE_AMP] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_LT] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4113),
    [anon_sym_GT_GT] = ACTIONS(4111),
    [anon_sym_AMP_GT] = ACTIONS(4113),
    [anon_sym_AMP_GT_GT] = ACTIONS(4111),
    [anon_sym_LT_AMP] = ACTIONS(4111),
    [anon_sym_GT_AMP] = ACTIONS(4111),
    [anon_sym_LT_LT] = ACTIONS(4113),
    [anon_sym_LT_LT_DASH] = ACTIONS(4111),
    [anon_sym_LT_LT_LT] = ACTIONS(4111),
    [anon_sym_DOLLAR] = ACTIONS(4113),
    [sym__special_character] = ACTIONS(4111),
    [anon_sym_DQUOTE] = ACTIONS(4111),
    [sym_raw_string] = ACTIONS(4111),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4111),
    [anon_sym_BQUOTE] = ACTIONS(4111),
    [anon_sym_LT_LPAREN] = ACTIONS(4111),
    [anon_sym_GT_LPAREN] = ACTIONS(4111),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4113),
    [sym_word] = ACTIONS(4113),
    [anon_sym_LF] = ACTIONS(4111),
    [anon_sym_AMP] = ACTIONS(4113),
  },
  [2156] = {
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [sym_variable_name] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym__special_character] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4127),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [2157] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(6071),
    [sym_comment] = ACTIONS(57),
  },
  [2158] = {
    [anon_sym_RBRACE] = ACTIONS(6071),
    [sym_comment] = ACTIONS(57),
  },
  [2159] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(6073),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [2160] = {
    [sym_concatenation] = STATE(2787),
    [sym_string] = STATE(2786),
    [sym_simple_expansion] = STATE(2786),
    [sym_string_expansion] = STATE(2786),
    [sym_expansion] = STATE(2786),
    [sym_command_substitution] = STATE(2786),
    [sym_process_substitution] = STATE(2786),
    [aux_sym__literal_repeat1] = STATE(2788),
    [anon_sym_RBRACE] = ACTIONS(6071),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(6075),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6075),
  },
  [2161] = {
    [sym_file_descriptor] = ACTIONS(4161),
    [sym__concat] = ACTIONS(4161),
    [sym_variable_name] = ACTIONS(4161),
    [anon_sym_SEMI] = ACTIONS(4163),
    [anon_sym_PIPE] = ACTIONS(4163),
    [anon_sym_SEMI_SEMI] = ACTIONS(4161),
    [anon_sym_PIPE_AMP] = ACTIONS(4161),
    [anon_sym_AMP_AMP] = ACTIONS(4161),
    [anon_sym_PIPE_PIPE] = ACTIONS(4161),
    [anon_sym_LT] = ACTIONS(4163),
    [anon_sym_GT] = ACTIONS(4163),
    [anon_sym_GT_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT] = ACTIONS(4163),
    [anon_sym_AMP_GT_GT] = ACTIONS(4161),
    [anon_sym_LT_AMP] = ACTIONS(4161),
    [anon_sym_GT_AMP] = ACTIONS(4161),
    [anon_sym_LT_LT] = ACTIONS(4163),
    [anon_sym_LT_LT_DASH] = ACTIONS(4161),
    [anon_sym_LT_LT_LT] = ACTIONS(4161),
    [anon_sym_DOLLAR] = ACTIONS(4163),
    [sym__special_character] = ACTIONS(4161),
    [anon_sym_DQUOTE] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4161),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4161),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4161),
    [anon_sym_BQUOTE] = ACTIONS(4161),
    [anon_sym_LT_LPAREN] = ACTIONS(4161),
    [anon_sym_GT_LPAREN] = ACTIONS(4161),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4163),
    [sym_word] = ACTIONS(4163),
    [anon_sym_LF] = ACTIONS(4161),
    [anon_sym_AMP] = ACTIONS(4163),
  },
  [2162] = {
    [sym_concatenation] = STATE(2791),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2791),
    [sym_regex] = ACTIONS(6077),
    [anon_sym_RBRACE] = ACTIONS(6079),
    [anon_sym_EQ] = ACTIONS(6081),
    [anon_sym_DASH] = ACTIONS(6081),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(6083),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(6081),
    [anon_sym_COLON_QMARK] = ACTIONS(6081),
    [anon_sym_COLON_DASH] = ACTIONS(6081),
    [anon_sym_PERCENT] = ACTIONS(6081),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2163] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(6079),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2164] = {
    [sym_concatenation] = STATE(2793),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2793),
    [sym_regex] = ACTIONS(6085),
    [anon_sym_RBRACE] = ACTIONS(6071),
    [anon_sym_EQ] = ACTIONS(6087),
    [anon_sym_DASH] = ACTIONS(6087),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(6089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(6087),
    [anon_sym_COLON_QMARK] = ACTIONS(6087),
    [anon_sym_COLON_DASH] = ACTIONS(6087),
    [anon_sym_PERCENT] = ACTIONS(6087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2165] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(6071),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2166] = {
    [sym_concatenation] = STATE(2795),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2795),
    [anon_sym_RBRACE] = ACTIONS(6091),
    [anon_sym_EQ] = ACTIONS(6093),
    [anon_sym_DASH] = ACTIONS(6093),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(6095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(6093),
    [anon_sym_COLON_QMARK] = ACTIONS(6093),
    [anon_sym_COLON_DASH] = ACTIONS(6093),
    [anon_sym_PERCENT] = ACTIONS(6093),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2167] = {
    [sym_file_descriptor] = ACTIONS(4219),
    [sym__concat] = ACTIONS(4219),
    [sym_variable_name] = ACTIONS(4219),
    [anon_sym_SEMI] = ACTIONS(4221),
    [anon_sym_PIPE] = ACTIONS(4221),
    [anon_sym_SEMI_SEMI] = ACTIONS(4219),
    [anon_sym_PIPE_AMP] = ACTIONS(4219),
    [anon_sym_AMP_AMP] = ACTIONS(4219),
    [anon_sym_PIPE_PIPE] = ACTIONS(4219),
    [anon_sym_LT] = ACTIONS(4221),
    [anon_sym_GT] = ACTIONS(4221),
    [anon_sym_GT_GT] = ACTIONS(4219),
    [anon_sym_AMP_GT] = ACTIONS(4221),
    [anon_sym_AMP_GT_GT] = ACTIONS(4219),
    [anon_sym_LT_AMP] = ACTIONS(4219),
    [anon_sym_GT_AMP] = ACTIONS(4219),
    [anon_sym_LT_LT] = ACTIONS(4221),
    [anon_sym_LT_LT_DASH] = ACTIONS(4219),
    [anon_sym_LT_LT_LT] = ACTIONS(4219),
    [anon_sym_DOLLAR] = ACTIONS(4221),
    [sym__special_character] = ACTIONS(4219),
    [anon_sym_DQUOTE] = ACTIONS(4219),
    [sym_raw_string] = ACTIONS(4219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4219),
    [anon_sym_BQUOTE] = ACTIONS(4219),
    [anon_sym_LT_LPAREN] = ACTIONS(4219),
    [anon_sym_GT_LPAREN] = ACTIONS(4219),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4221),
    [sym_word] = ACTIONS(4221),
    [anon_sym_LF] = ACTIONS(4219),
    [anon_sym_AMP] = ACTIONS(4221),
  },
  [2168] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(6091),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2169] = {
    [sym_concatenation] = STATE(2793),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2793),
    [anon_sym_RBRACE] = ACTIONS(6071),
    [anon_sym_EQ] = ACTIONS(6087),
    [anon_sym_DASH] = ACTIONS(6087),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(6089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(6087),
    [anon_sym_COLON_QMARK] = ACTIONS(6087),
    [anon_sym_COLON_DASH] = ACTIONS(6087),
    [anon_sym_PERCENT] = ACTIONS(6087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2170] = {
    [sym_string] = STATE(883),
    [sym_file_descriptor] = ACTIONS(4071),
    [anon_sym_SEMI] = ACTIONS(4073),
    [anon_sym_PIPE] = ACTIONS(4073),
    [anon_sym_SEMI_SEMI] = ACTIONS(4071),
    [anon_sym_PIPE_AMP] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_PIPE_PIPE] = ACTIONS(4071),
    [anon_sym_LT] = ACTIONS(4073),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_GT_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT] = ACTIONS(4073),
    [anon_sym_AMP_GT_GT] = ACTIONS(4071),
    [anon_sym_LT_AMP] = ACTIONS(4071),
    [anon_sym_GT_AMP] = ACTIONS(4071),
    [anon_sym_LT_LT] = ACTIONS(4073),
    [anon_sym_LT_LT_DASH] = ACTIONS(4071),
    [anon_sym_LT_LT_LT] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(6097),
    [anon_sym_DOLLAR] = ACTIONS(6097),
    [sym__special_character] = ACTIONS(4071),
    [anon_sym_DQUOTE] = ACTIONS(609),
    [sym_raw_string] = ACTIONS(1685),
    [anon_sym_POUND] = ACTIONS(1683),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4071),
    [anon_sym_BQUOTE] = ACTIONS(4071),
    [anon_sym_LT_LPAREN] = ACTIONS(4071),
    [anon_sym_GT_LPAREN] = ACTIONS(4071),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1687),
    [anon_sym_STAR] = ACTIONS(1687),
    [anon_sym_AT] = ACTIONS(1687),
    [anon_sym_QMARK] = ACTIONS(1687),
    [anon_sym_0] = ACTIONS(1687),
    [anon_sym__] = ACTIONS(1687),
    [sym_word] = ACTIONS(4073),
    [anon_sym_LF] = ACTIONS(4071),
    [anon_sym_AMP] = ACTIONS(4073),
  },
  [2171] = {
    [sym_file_descriptor] = ACTIONS(4111),
    [sym__concat] = ACTIONS(4111),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_PIPE] = ACTIONS(4113),
    [anon_sym_SEMI_SEMI] = ACTIONS(4111),
    [anon_sym_PIPE_AMP] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_LT] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4113),
    [anon_sym_GT_GT] = ACTIONS(4111),
    [anon_sym_AMP_GT] = ACTIONS(4113),
    [anon_sym_AMP_GT_GT] = ACTIONS(4111),
    [anon_sym_LT_AMP] = ACTIONS(4111),
    [anon_sym_GT_AMP] = ACTIONS(4111),
    [anon_sym_LT_LT] = ACTIONS(4113),
    [anon_sym_LT_LT_DASH] = ACTIONS(4111),
    [anon_sym_LT_LT_LT] = ACTIONS(4111),
    [anon_sym_DOLLAR] = ACTIONS(4113),
    [sym__special_character] = ACTIONS(4111),
    [anon_sym_DQUOTE] = ACTIONS(4111),
    [sym_raw_string] = ACTIONS(4111),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4111),
    [anon_sym_BQUOTE] = ACTIONS(4111),
    [anon_sym_LT_LPAREN] = ACTIONS(4111),
    [anon_sym_GT_LPAREN] = ACTIONS(4111),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4113),
    [sym_word] = ACTIONS(4113),
    [anon_sym_LF] = ACTIONS(4111),
    [anon_sym_AMP] = ACTIONS(4113),
  },
  [2172] = {
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym__special_character] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4127),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [2173] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(6099),
    [sym_comment] = ACTIONS(57),
  },
  [2174] = {
    [anon_sym_RBRACE] = ACTIONS(6099),
    [sym_comment] = ACTIONS(57),
  },
  [2175] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(6101),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [2176] = {
    [sym_concatenation] = STATE(2799),
    [sym_string] = STATE(2798),
    [sym_simple_expansion] = STATE(2798),
    [sym_string_expansion] = STATE(2798),
    [sym_expansion] = STATE(2798),
    [sym_command_substitution] = STATE(2798),
    [sym_process_substitution] = STATE(2798),
    [aux_sym__literal_repeat1] = STATE(2800),
    [anon_sym_RBRACE] = ACTIONS(6099),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(6103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6103),
  },
  [2177] = {
    [sym_file_descriptor] = ACTIONS(4161),
    [sym__concat] = ACTIONS(4161),
    [anon_sym_SEMI] = ACTIONS(4163),
    [anon_sym_PIPE] = ACTIONS(4163),
    [anon_sym_SEMI_SEMI] = ACTIONS(4161),
    [anon_sym_PIPE_AMP] = ACTIONS(4161),
    [anon_sym_AMP_AMP] = ACTIONS(4161),
    [anon_sym_PIPE_PIPE] = ACTIONS(4161),
    [anon_sym_LT] = ACTIONS(4163),
    [anon_sym_GT] = ACTIONS(4163),
    [anon_sym_GT_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT] = ACTIONS(4163),
    [anon_sym_AMP_GT_GT] = ACTIONS(4161),
    [anon_sym_LT_AMP] = ACTIONS(4161),
    [anon_sym_GT_AMP] = ACTIONS(4161),
    [anon_sym_LT_LT] = ACTIONS(4163),
    [anon_sym_LT_LT_DASH] = ACTIONS(4161),
    [anon_sym_LT_LT_LT] = ACTIONS(4161),
    [anon_sym_DOLLAR] = ACTIONS(4163),
    [sym__special_character] = ACTIONS(4161),
    [anon_sym_DQUOTE] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4161),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4161),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4161),
    [anon_sym_BQUOTE] = ACTIONS(4161),
    [anon_sym_LT_LPAREN] = ACTIONS(4161),
    [anon_sym_GT_LPAREN] = ACTIONS(4161),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4163),
    [sym_word] = ACTIONS(4163),
    [anon_sym_LF] = ACTIONS(4161),
    [anon_sym_AMP] = ACTIONS(4163),
  },
  [2178] = {
    [sym_concatenation] = STATE(2803),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2803),
    [sym_regex] = ACTIONS(6105),
    [anon_sym_RBRACE] = ACTIONS(6107),
    [anon_sym_EQ] = ACTIONS(6109),
    [anon_sym_DASH] = ACTIONS(6109),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(6111),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(6109),
    [anon_sym_COLON_QMARK] = ACTIONS(6109),
    [anon_sym_COLON_DASH] = ACTIONS(6109),
    [anon_sym_PERCENT] = ACTIONS(6109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2179] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(6107),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2180] = {
    [sym_concatenation] = STATE(2805),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2805),
    [sym_regex] = ACTIONS(6113),
    [anon_sym_RBRACE] = ACTIONS(6099),
    [anon_sym_EQ] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6115),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(6117),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(6115),
    [anon_sym_COLON_QMARK] = ACTIONS(6115),
    [anon_sym_COLON_DASH] = ACTIONS(6115),
    [anon_sym_PERCENT] = ACTIONS(6115),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2181] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(6099),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2182] = {
    [sym_concatenation] = STATE(2807),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2807),
    [anon_sym_RBRACE] = ACTIONS(6119),
    [anon_sym_EQ] = ACTIONS(6121),
    [anon_sym_DASH] = ACTIONS(6121),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(6123),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(6121),
    [anon_sym_COLON_QMARK] = ACTIONS(6121),
    [anon_sym_COLON_DASH] = ACTIONS(6121),
    [anon_sym_PERCENT] = ACTIONS(6121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2183] = {
    [sym_file_descriptor] = ACTIONS(4219),
    [sym__concat] = ACTIONS(4219),
    [anon_sym_SEMI] = ACTIONS(4221),
    [anon_sym_PIPE] = ACTIONS(4221),
    [anon_sym_SEMI_SEMI] = ACTIONS(4219),
    [anon_sym_PIPE_AMP] = ACTIONS(4219),
    [anon_sym_AMP_AMP] = ACTIONS(4219),
    [anon_sym_PIPE_PIPE] = ACTIONS(4219),
    [anon_sym_LT] = ACTIONS(4221),
    [anon_sym_GT] = ACTIONS(4221),
    [anon_sym_GT_GT] = ACTIONS(4219),
    [anon_sym_AMP_GT] = ACTIONS(4221),
    [anon_sym_AMP_GT_GT] = ACTIONS(4219),
    [anon_sym_LT_AMP] = ACTIONS(4219),
    [anon_sym_GT_AMP] = ACTIONS(4219),
    [anon_sym_LT_LT] = ACTIONS(4221),
    [anon_sym_LT_LT_DASH] = ACTIONS(4219),
    [anon_sym_LT_LT_LT] = ACTIONS(4219),
    [anon_sym_DOLLAR] = ACTIONS(4221),
    [sym__special_character] = ACTIONS(4219),
    [anon_sym_DQUOTE] = ACTIONS(4219),
    [sym_raw_string] = ACTIONS(4219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4219),
    [anon_sym_BQUOTE] = ACTIONS(4219),
    [anon_sym_LT_LPAREN] = ACTIONS(4219),
    [anon_sym_GT_LPAREN] = ACTIONS(4219),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4221),
    [sym_word] = ACTIONS(4221),
    [anon_sym_LF] = ACTIONS(4219),
    [anon_sym_AMP] = ACTIONS(4221),
  },
  [2184] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(6119),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2185] = {
    [sym_concatenation] = STATE(2805),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2805),
    [anon_sym_RBRACE] = ACTIONS(6099),
    [anon_sym_EQ] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6115),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(6117),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(6115),
    [anon_sym_COLON_QMARK] = ACTIONS(6115),
    [anon_sym_COLON_DASH] = ACTIONS(6115),
    [anon_sym_PERCENT] = ACTIONS(6115),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2186] = {
    [sym_file_descriptor] = ACTIONS(5674),
    [sym__concat] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(5676),
    [anon_sym_PIPE] = ACTIONS(5676),
    [anon_sym_SEMI_SEMI] = ACTIONS(5674),
    [anon_sym_PIPE_AMP] = ACTIONS(5674),
    [anon_sym_AMP_AMP] = ACTIONS(5674),
    [anon_sym_PIPE_PIPE] = ACTIONS(5674),
    [anon_sym_EQ_TILDE] = ACTIONS(5676),
    [anon_sym_EQ_EQ] = ACTIONS(5676),
    [anon_sym_LT] = ACTIONS(5676),
    [anon_sym_GT] = ACTIONS(5676),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_AMP_GT] = ACTIONS(5676),
    [anon_sym_AMP_GT_GT] = ACTIONS(5674),
    [anon_sym_LT_AMP] = ACTIONS(5674),
    [anon_sym_GT_AMP] = ACTIONS(5674),
    [anon_sym_LT_LT] = ACTIONS(5676),
    [anon_sym_LT_LT_DASH] = ACTIONS(5674),
    [anon_sym_LT_LT_LT] = ACTIONS(5674),
    [anon_sym_DOLLAR] = ACTIONS(5676),
    [sym__special_character] = ACTIONS(5674),
    [anon_sym_DQUOTE] = ACTIONS(5674),
    [sym_raw_string] = ACTIONS(5674),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5674),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5674),
    [anon_sym_BQUOTE] = ACTIONS(5674),
    [anon_sym_LT_LPAREN] = ACTIONS(5674),
    [anon_sym_GT_LPAREN] = ACTIONS(5674),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5676),
    [anon_sym_LF] = ACTIONS(5674),
    [anon_sym_AMP] = ACTIONS(5676),
  },
  [2187] = {
    [sym_file_descriptor] = ACTIONS(5708),
    [sym__concat] = ACTIONS(5708),
    [anon_sym_SEMI] = ACTIONS(5710),
    [anon_sym_PIPE] = ACTIONS(5710),
    [anon_sym_SEMI_SEMI] = ACTIONS(5708),
    [anon_sym_PIPE_AMP] = ACTIONS(5708),
    [anon_sym_AMP_AMP] = ACTIONS(5708),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_EQ_TILDE] = ACTIONS(5710),
    [anon_sym_EQ_EQ] = ACTIONS(5710),
    [anon_sym_LT] = ACTIONS(5710),
    [anon_sym_GT] = ACTIONS(5710),
    [anon_sym_GT_GT] = ACTIONS(5708),
    [anon_sym_AMP_GT] = ACTIONS(5710),
    [anon_sym_AMP_GT_GT] = ACTIONS(5708),
    [anon_sym_LT_AMP] = ACTIONS(5708),
    [anon_sym_GT_AMP] = ACTIONS(5708),
    [anon_sym_LT_LT] = ACTIONS(5710),
    [anon_sym_LT_LT_DASH] = ACTIONS(5708),
    [anon_sym_LT_LT_LT] = ACTIONS(5708),
    [anon_sym_DOLLAR] = ACTIONS(5710),
    [sym__special_character] = ACTIONS(5708),
    [anon_sym_DQUOTE] = ACTIONS(5708),
    [sym_raw_string] = ACTIONS(5708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5708),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5708),
    [anon_sym_BQUOTE] = ACTIONS(5708),
    [anon_sym_LT_LPAREN] = ACTIONS(5708),
    [anon_sym_GT_LPAREN] = ACTIONS(5708),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5710),
    [anon_sym_LF] = ACTIONS(5708),
    [anon_sym_AMP] = ACTIONS(5710),
  },
  [2188] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(6125),
    [sym_comment] = ACTIONS(57),
  },
  [2189] = {
    [anon_sym_RBRACE] = ACTIONS(6125),
    [sym_comment] = ACTIONS(57),
  },
  [2190] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(6127),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [2191] = {
    [sym_concatenation] = STATE(2811),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2811),
    [anon_sym_RBRACE] = ACTIONS(6129),
    [anon_sym_EQ] = ACTIONS(6131),
    [anon_sym_DASH] = ACTIONS(6131),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(6133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(6131),
    [anon_sym_COLON_QMARK] = ACTIONS(6131),
    [anon_sym_COLON_DASH] = ACTIONS(6131),
    [anon_sym_PERCENT] = ACTIONS(6131),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2192] = {
    [sym_file_descriptor] = ACTIONS(5725),
    [sym__concat] = ACTIONS(5725),
    [anon_sym_SEMI] = ACTIONS(5727),
    [anon_sym_PIPE] = ACTIONS(5727),
    [anon_sym_SEMI_SEMI] = ACTIONS(5725),
    [anon_sym_PIPE_AMP] = ACTIONS(5725),
    [anon_sym_AMP_AMP] = ACTIONS(5725),
    [anon_sym_PIPE_PIPE] = ACTIONS(5725),
    [anon_sym_EQ_TILDE] = ACTIONS(5727),
    [anon_sym_EQ_EQ] = ACTIONS(5727),
    [anon_sym_LT] = ACTIONS(5727),
    [anon_sym_GT] = ACTIONS(5727),
    [anon_sym_GT_GT] = ACTIONS(5725),
    [anon_sym_AMP_GT] = ACTIONS(5727),
    [anon_sym_AMP_GT_GT] = ACTIONS(5725),
    [anon_sym_LT_AMP] = ACTIONS(5725),
    [anon_sym_GT_AMP] = ACTIONS(5725),
    [anon_sym_LT_LT] = ACTIONS(5727),
    [anon_sym_LT_LT_DASH] = ACTIONS(5725),
    [anon_sym_LT_LT_LT] = ACTIONS(5725),
    [anon_sym_DOLLAR] = ACTIONS(5727),
    [sym__special_character] = ACTIONS(5725),
    [anon_sym_DQUOTE] = ACTIONS(5725),
    [sym_raw_string] = ACTIONS(5725),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5725),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5725),
    [anon_sym_BQUOTE] = ACTIONS(5725),
    [anon_sym_LT_LPAREN] = ACTIONS(5725),
    [anon_sym_GT_LPAREN] = ACTIONS(5725),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5727),
    [anon_sym_LF] = ACTIONS(5725),
    [anon_sym_AMP] = ACTIONS(5727),
  },
  [2193] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(6129),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2194] = {
    [sym_concatenation] = STATE(2812),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2812),
    [anon_sym_RBRACE] = ACTIONS(6125),
    [anon_sym_EQ] = ACTIONS(6135),
    [anon_sym_DASH] = ACTIONS(6135),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(6137),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(6135),
    [anon_sym_COLON_QMARK] = ACTIONS(6135),
    [anon_sym_COLON_DASH] = ACTIONS(6135),
    [anon_sym_PERCENT] = ACTIONS(6135),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2195] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(6125),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2196] = {
    [sym_file_descriptor] = ACTIONS(5770),
    [sym__concat] = ACTIONS(5770),
    [anon_sym_SEMI] = ACTIONS(5772),
    [anon_sym_PIPE] = ACTIONS(5772),
    [anon_sym_SEMI_SEMI] = ACTIONS(5770),
    [anon_sym_PIPE_AMP] = ACTIONS(5770),
    [anon_sym_AMP_AMP] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5770),
    [anon_sym_EQ_TILDE] = ACTIONS(5772),
    [anon_sym_EQ_EQ] = ACTIONS(5772),
    [anon_sym_LT] = ACTIONS(5772),
    [anon_sym_GT] = ACTIONS(5772),
    [anon_sym_GT_GT] = ACTIONS(5770),
    [anon_sym_AMP_GT] = ACTIONS(5772),
    [anon_sym_AMP_GT_GT] = ACTIONS(5770),
    [anon_sym_LT_AMP] = ACTIONS(5770),
    [anon_sym_GT_AMP] = ACTIONS(5770),
    [anon_sym_LT_LT] = ACTIONS(5772),
    [anon_sym_LT_LT_DASH] = ACTIONS(5770),
    [anon_sym_LT_LT_LT] = ACTIONS(5770),
    [anon_sym_DOLLAR] = ACTIONS(5772),
    [sym__special_character] = ACTIONS(5770),
    [anon_sym_DQUOTE] = ACTIONS(5770),
    [sym_raw_string] = ACTIONS(5770),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5770),
    [anon_sym_BQUOTE] = ACTIONS(5770),
    [anon_sym_LT_LPAREN] = ACTIONS(5770),
    [anon_sym_GT_LPAREN] = ACTIONS(5770),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5772),
    [anon_sym_LF] = ACTIONS(5770),
    [anon_sym_AMP] = ACTIONS(5772),
  },
  [2197] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(6139),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2198] = {
    [sym__simple_heredoc_body] = ACTIONS(1400),
    [sym__heredoc_body_beginning] = ACTIONS(1400),
    [sym_file_descriptor] = ACTIONS(1400),
    [sym_variable_name] = ACTIONS(1400),
    [anon_sym_SEMI] = ACTIONS(1402),
    [anon_sym_done] = ACTIONS(1402),
    [anon_sym_PIPE] = ACTIONS(1402),
    [anon_sym_SEMI_SEMI] = ACTIONS(1400),
    [anon_sym_PIPE_AMP] = ACTIONS(1400),
    [anon_sym_AMP_AMP] = ACTIONS(1400),
    [anon_sym_PIPE_PIPE] = ACTIONS(1400),
    [anon_sym_LT] = ACTIONS(1402),
    [anon_sym_GT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT] = ACTIONS(1402),
    [anon_sym_AMP_GT_GT] = ACTIONS(1400),
    [anon_sym_LT_AMP] = ACTIONS(1400),
    [anon_sym_GT_AMP] = ACTIONS(1400),
    [anon_sym_LT_LT] = ACTIONS(1402),
    [anon_sym_LT_LT_DASH] = ACTIONS(1400),
    [anon_sym_LT_LT_LT] = ACTIONS(1400),
    [anon_sym_DOLLAR] = ACTIONS(1402),
    [sym__special_character] = ACTIONS(1400),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1400),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1400),
    [anon_sym_BQUOTE] = ACTIONS(1400),
    [anon_sym_LT_LPAREN] = ACTIONS(1400),
    [anon_sym_GT_LPAREN] = ACTIONS(1400),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1402),
    [anon_sym_LF] = ACTIONS(1400),
    [anon_sym_AMP] = ACTIONS(1402),
  },
  [2199] = {
    [sym_concatenation] = STATE(2815),
    [sym_string] = STATE(730),
    [sym_simple_expansion] = STATE(730),
    [sym_string_expansion] = STATE(730),
    [sym_expansion] = STATE(730),
    [sym_command_substitution] = STATE(730),
    [sym_process_substitution] = STATE(730),
    [aux_sym_for_statement_repeat1] = STATE(2815),
    [aux_sym__literal_repeat1] = STATE(736),
    [anon_sym_RPAREN] = ACTIONS(6141),
    [anon_sym_DOLLAR] = ACTIONS(1406),
    [sym__special_character] = ACTIONS(1408),
    [anon_sym_DQUOTE] = ACTIONS(1410),
    [sym_raw_string] = ACTIONS(1412),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1414),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1416),
    [anon_sym_BQUOTE] = ACTIONS(1418),
    [anon_sym_LT_LPAREN] = ACTIONS(1420),
    [anon_sym_GT_LPAREN] = ACTIONS(1420),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1412),
  },
  [2200] = {
    [sym_string] = STATE(2817),
    [anon_sym_DASH] = ACTIONS(6143),
    [anon_sym_DOLLAR] = ACTIONS(6143),
    [anon_sym_DQUOTE] = ACTIONS(4880),
    [sym_raw_string] = ACTIONS(6145),
    [anon_sym_POUND] = ACTIONS(6143),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6147),
    [anon_sym_STAR] = ACTIONS(6149),
    [anon_sym_AT] = ACTIONS(6149),
    [anon_sym_QMARK] = ACTIONS(6149),
    [anon_sym_0] = ACTIONS(6147),
    [anon_sym__] = ACTIONS(6147),
  },
  [2201] = {
    [aux_sym_concatenation_repeat1] = STATE(2820),
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(6151),
    [sym_variable_name] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_done] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [2202] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(2823),
    [anon_sym_DOLLAR] = ACTIONS(6153),
    [anon_sym_DQUOTE] = ACTIONS(6155),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [2203] = {
    [aux_sym_concatenation_repeat1] = STATE(2820),
    [sym__simple_heredoc_body] = ACTIONS(1400),
    [sym__heredoc_body_beginning] = ACTIONS(1400),
    [sym_file_descriptor] = ACTIONS(1400),
    [sym__concat] = ACTIONS(6151),
    [sym_variable_name] = ACTIONS(1400),
    [anon_sym_SEMI] = ACTIONS(1402),
    [anon_sym_done] = ACTIONS(1402),
    [anon_sym_PIPE] = ACTIONS(1402),
    [anon_sym_SEMI_SEMI] = ACTIONS(1400),
    [anon_sym_PIPE_AMP] = ACTIONS(1400),
    [anon_sym_AMP_AMP] = ACTIONS(1400),
    [anon_sym_PIPE_PIPE] = ACTIONS(1400),
    [anon_sym_LT] = ACTIONS(1402),
    [anon_sym_GT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT] = ACTIONS(1402),
    [anon_sym_AMP_GT_GT] = ACTIONS(1400),
    [anon_sym_LT_AMP] = ACTIONS(1400),
    [anon_sym_GT_AMP] = ACTIONS(1400),
    [anon_sym_LT_LT] = ACTIONS(1402),
    [anon_sym_LT_LT_DASH] = ACTIONS(1400),
    [anon_sym_LT_LT_LT] = ACTIONS(1400),
    [anon_sym_DOLLAR] = ACTIONS(1402),
    [sym__special_character] = ACTIONS(1400),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1400),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1400),
    [anon_sym_BQUOTE] = ACTIONS(1400),
    [anon_sym_LT_LPAREN] = ACTIONS(1400),
    [anon_sym_GT_LPAREN] = ACTIONS(1400),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1402),
    [anon_sym_LF] = ACTIONS(1400),
    [anon_sym_AMP] = ACTIONS(1402),
  },
  [2204] = {
    [sym_subscript] = STATE(2827),
    [sym_variable_name] = ACTIONS(6157),
    [anon_sym_BANG] = ACTIONS(6159),
    [anon_sym_DASH] = ACTIONS(6161),
    [anon_sym_DOLLAR] = ACTIONS(6161),
    [anon_sym_POUND] = ACTIONS(6159),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6163),
    [anon_sym_STAR] = ACTIONS(6165),
    [anon_sym_AT] = ACTIONS(6165),
    [anon_sym_QMARK] = ACTIONS(6165),
    [anon_sym_0] = ACTIONS(6163),
    [anon_sym__] = ACTIONS(6163),
  },
  [2205] = {
    [sym__statements] = STATE(2828),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(2829),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [2206] = {
    [sym__statements] = STATE(2830),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [2207] = {
    [sym__statements] = STATE(2831),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [2208] = {
    [aux_sym__literal_repeat1] = STATE(2833),
    [sym__simple_heredoc_body] = ACTIONS(1446),
    [sym__heredoc_body_beginning] = ACTIONS(1446),
    [sym_file_descriptor] = ACTIONS(1446),
    [sym_variable_name] = ACTIONS(1446),
    [anon_sym_SEMI] = ACTIONS(1448),
    [anon_sym_done] = ACTIONS(1448),
    [anon_sym_PIPE] = ACTIONS(1448),
    [anon_sym_SEMI_SEMI] = ACTIONS(1446),
    [anon_sym_PIPE_AMP] = ACTIONS(1446),
    [anon_sym_AMP_AMP] = ACTIONS(1446),
    [anon_sym_PIPE_PIPE] = ACTIONS(1446),
    [anon_sym_LT] = ACTIONS(1448),
    [anon_sym_GT] = ACTIONS(1448),
    [anon_sym_GT_GT] = ACTIONS(1446),
    [anon_sym_AMP_GT] = ACTIONS(1448),
    [anon_sym_AMP_GT_GT] = ACTIONS(1446),
    [anon_sym_LT_AMP] = ACTIONS(1446),
    [anon_sym_GT_AMP] = ACTIONS(1446),
    [anon_sym_LT_LT] = ACTIONS(1448),
    [anon_sym_LT_LT_DASH] = ACTIONS(1446),
    [anon_sym_LT_LT_LT] = ACTIONS(1446),
    [anon_sym_DOLLAR] = ACTIONS(1448),
    [sym__special_character] = ACTIONS(6167),
    [anon_sym_DQUOTE] = ACTIONS(1446),
    [sym_raw_string] = ACTIONS(1446),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1446),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1446),
    [anon_sym_BQUOTE] = ACTIONS(1446),
    [anon_sym_LT_LPAREN] = ACTIONS(1446),
    [anon_sym_GT_LPAREN] = ACTIONS(1446),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1448),
    [anon_sym_LF] = ACTIONS(1446),
    [anon_sym_AMP] = ACTIONS(1448),
  },
  [2209] = {
    [sym_concatenation] = STATE(2834),
    [sym_string] = STATE(2836),
    [sym_array] = STATE(2834),
    [sym_simple_expansion] = STATE(2836),
    [sym_string_expansion] = STATE(2836),
    [sym_expansion] = STATE(2836),
    [sym_command_substitution] = STATE(2836),
    [sym_process_substitution] = STATE(2836),
    [aux_sym__literal_repeat1] = STATE(2837),
    [sym__empty_value] = ACTIONS(6169),
    [anon_sym_LPAREN] = ACTIONS(6171),
    [anon_sym_DOLLAR] = ACTIONS(3229),
    [sym__special_character] = ACTIONS(3231),
    [anon_sym_DQUOTE] = ACTIONS(3233),
    [sym_raw_string] = ACTIONS(6173),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3239),
    [anon_sym_BQUOTE] = ACTIONS(3241),
    [anon_sym_LT_LPAREN] = ACTIONS(3243),
    [anon_sym_GT_LPAREN] = ACTIONS(3243),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6173),
  },
  [2210] = {
    [sym__simple_heredoc_body] = ACTIONS(1057),
    [sym__heredoc_body_beginning] = ACTIONS(1057),
    [sym_file_descriptor] = ACTIONS(1057),
    [sym__concat] = ACTIONS(1057),
    [sym_variable_name] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_done] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_PIPE_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_AMP] = ACTIONS(1057),
    [anon_sym_GT_AMP] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_LT] = ACTIONS(1057),
    [anon_sym_DOLLAR] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [sym_raw_string] = ACTIONS(1057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1057),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1057),
    [anon_sym_BQUOTE] = ACTIONS(1057),
    [anon_sym_LT_LPAREN] = ACTIONS(1057),
    [anon_sym_GT_LPAREN] = ACTIONS(1057),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1059),
    [sym_word] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [2211] = {
    [sym__simple_heredoc_body] = ACTIONS(1061),
    [sym__heredoc_body_beginning] = ACTIONS(1061),
    [sym_file_descriptor] = ACTIONS(1061),
    [sym__concat] = ACTIONS(1061),
    [sym_variable_name] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(1063),
    [anon_sym_done] = ACTIONS(1063),
    [anon_sym_PIPE] = ACTIONS(1063),
    [anon_sym_SEMI_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE_AMP] = ACTIONS(1061),
    [anon_sym_AMP_AMP] = ACTIONS(1061),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1063),
    [anon_sym_GT_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT_GT] = ACTIONS(1061),
    [anon_sym_LT_AMP] = ACTIONS(1061),
    [anon_sym_GT_AMP] = ACTIONS(1061),
    [anon_sym_LT_LT] = ACTIONS(1063),
    [anon_sym_LT_LT_DASH] = ACTIONS(1061),
    [anon_sym_LT_LT_LT] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1061),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1061),
    [anon_sym_LT_LPAREN] = ACTIONS(1061),
    [anon_sym_GT_LPAREN] = ACTIONS(1061),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1063),
    [sym_word] = ACTIONS(1063),
    [anon_sym_LF] = ACTIONS(1061),
    [anon_sym_AMP] = ACTIONS(1063),
  },
  [2212] = {
    [sym__simple_heredoc_body] = ACTIONS(1065),
    [sym__heredoc_body_beginning] = ACTIONS(1065),
    [sym_file_descriptor] = ACTIONS(1065),
    [sym__concat] = ACTIONS(1065),
    [sym_variable_name] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_done] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1067),
    [anon_sym_SEMI_SEMI] = ACTIONS(1065),
    [anon_sym_PIPE_AMP] = ACTIONS(1065),
    [anon_sym_AMP_AMP] = ACTIONS(1065),
    [anon_sym_PIPE_PIPE] = ACTIONS(1065),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_GT] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT] = ACTIONS(1067),
    [anon_sym_AMP_GT_GT] = ACTIONS(1065),
    [anon_sym_LT_AMP] = ACTIONS(1065),
    [anon_sym_GT_AMP] = ACTIONS(1065),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_LT_LT_DASH] = ACTIONS(1065),
    [anon_sym_LT_LT_LT] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1067),
    [sym__special_character] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LT_LPAREN] = ACTIONS(1065),
    [anon_sym_GT_LPAREN] = ACTIONS(1065),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1067),
    [sym_word] = ACTIONS(1067),
    [anon_sym_LF] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1067),
  },
  [2213] = {
    [sym_string] = STATE(2838),
    [sym_simple_expansion] = STATE(2838),
    [sym_string_expansion] = STATE(2838),
    [sym_expansion] = STATE(2838),
    [sym_command_substitution] = STATE(2838),
    [sym_process_substitution] = STATE(2838),
    [anon_sym_DOLLAR] = ACTIONS(3229),
    [sym__special_character] = ACTIONS(6175),
    [anon_sym_DQUOTE] = ACTIONS(3233),
    [sym_raw_string] = ACTIONS(6175),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3239),
    [anon_sym_BQUOTE] = ACTIONS(3241),
    [anon_sym_LT_LPAREN] = ACTIONS(3243),
    [anon_sym_GT_LPAREN] = ACTIONS(3243),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6175),
  },
  [2214] = {
    [aux_sym_concatenation_repeat1] = STATE(2840),
    [sym__simple_heredoc_body] = ACTIONS(1071),
    [sym__heredoc_body_beginning] = ACTIONS(1071),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(6177),
    [sym_variable_name] = ACTIONS(1071),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_done] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [sym__special_character] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [sym_word] = ACTIONS(1075),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1075),
  },
  [2215] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(6179),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [2216] = {
    [sym__simple_heredoc_body] = ACTIONS(1089),
    [sym__heredoc_body_beginning] = ACTIONS(1089),
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(1089),
    [sym_variable_name] = ACTIONS(1089),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_done] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1089),
    [anon_sym_PIPE_AMP] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_AMP] = ACTIONS(1089),
    [anon_sym_GT_AMP] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1089),
    [anon_sym_LT_LT_LT] = ACTIONS(1089),
    [anon_sym_DOLLAR] = ACTIONS(1091),
    [sym__special_character] = ACTIONS(1089),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1089),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1089),
    [anon_sym_GT_LPAREN] = ACTIONS(1089),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1091),
    [sym_word] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [2217] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(627),
    [anon_sym_DOLLAR] = ACTIONS(6181),
    [anon_sym_DQUOTE] = ACTIONS(6179),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [2218] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(6183),
    [sym_comment] = ACTIONS(57),
  },
  [2219] = {
    [sym_subscript] = STATE(2846),
    [sym_variable_name] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_DOLLAR] = ACTIONS(6187),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6189),
    [anon_sym_STAR] = ACTIONS(6191),
    [anon_sym_AT] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6191),
    [anon_sym_0] = ACTIONS(6189),
    [anon_sym__] = ACTIONS(6189),
  },
  [2220] = {
    [sym_concatenation] = STATE(2849),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2849),
    [anon_sym_RBRACE] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6195),
    [anon_sym_DASH] = ACTIONS(6195),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(6197),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(6199),
    [anon_sym_COLON] = ACTIONS(6195),
    [anon_sym_COLON_QMARK] = ACTIONS(6195),
    [anon_sym_COLON_DASH] = ACTIONS(6195),
    [anon_sym_PERCENT] = ACTIONS(6195),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2221] = {
    [sym_concatenation] = STATE(2852),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2852),
    [anon_sym_RBRACE] = ACTIONS(6201),
    [anon_sym_EQ] = ACTIONS(6203),
    [anon_sym_DASH] = ACTIONS(6203),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(6205),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(6207),
    [anon_sym_COLON] = ACTIONS(6203),
    [anon_sym_COLON_QMARK] = ACTIONS(6203),
    [anon_sym_COLON_DASH] = ACTIONS(6203),
    [anon_sym_PERCENT] = ACTIONS(6203),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2222] = {
    [anon_sym_RPAREN] = ACTIONS(6209),
    [sym_comment] = ACTIONS(57),
  },
  [2223] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(6209),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [2224] = {
    [anon_sym_BQUOTE] = ACTIONS(6209),
    [sym_comment] = ACTIONS(57),
  },
  [2225] = {
    [anon_sym_RPAREN] = ACTIONS(6211),
    [sym_comment] = ACTIONS(57),
  },
  [2226] = {
    [sym_variable_assignment] = STATE(2226),
    [sym_subscript] = STATE(1569),
    [sym_concatenation] = STATE(2226),
    [sym_string] = STATE(1564),
    [sym_simple_expansion] = STATE(1564),
    [sym_string_expansion] = STATE(1564),
    [sym_expansion] = STATE(1564),
    [sym_command_substitution] = STATE(1564),
    [sym_process_substitution] = STATE(1564),
    [aux_sym_declaration_command_repeat1] = STATE(2226),
    [aux_sym__literal_repeat1] = STATE(1571),
    [sym__simple_heredoc_body] = ACTIONS(2206),
    [sym__heredoc_body_beginning] = ACTIONS(2206),
    [sym_file_descriptor] = ACTIONS(2206),
    [sym_variable_name] = ACTIONS(6213),
    [anon_sym_SEMI] = ACTIONS(2211),
    [anon_sym_done] = ACTIONS(2211),
    [anon_sym_PIPE] = ACTIONS(2211),
    [anon_sym_SEMI_SEMI] = ACTIONS(2206),
    [anon_sym_PIPE_AMP] = ACTIONS(2206),
    [anon_sym_AMP_AMP] = ACTIONS(2206),
    [anon_sym_PIPE_PIPE] = ACTIONS(2206),
    [anon_sym_LT] = ACTIONS(2211),
    [anon_sym_GT] = ACTIONS(2211),
    [anon_sym_GT_GT] = ACTIONS(2206),
    [anon_sym_AMP_GT] = ACTIONS(2211),
    [anon_sym_AMP_GT_GT] = ACTIONS(2206),
    [anon_sym_LT_AMP] = ACTIONS(2206),
    [anon_sym_GT_AMP] = ACTIONS(2206),
    [anon_sym_LT_LT] = ACTIONS(2211),
    [anon_sym_LT_LT_DASH] = ACTIONS(2206),
    [anon_sym_LT_LT_LT] = ACTIONS(2206),
    [anon_sym_DOLLAR] = ACTIONS(6216),
    [sym__special_character] = ACTIONS(6219),
    [anon_sym_DQUOTE] = ACTIONS(6222),
    [sym_raw_string] = ACTIONS(6225),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6228),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6231),
    [anon_sym_BQUOTE] = ACTIONS(6234),
    [anon_sym_LT_LPAREN] = ACTIONS(6237),
    [anon_sym_GT_LPAREN] = ACTIONS(6237),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6240),
    [sym_word] = ACTIONS(6243),
    [anon_sym_LF] = ACTIONS(2206),
    [anon_sym_AMP] = ACTIONS(2211),
  },
  [2227] = {
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym_variable_name] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_done] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(339),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [2228] = {
    [aux_sym__literal_repeat1] = STATE(2228),
    [sym__simple_heredoc_body] = ACTIONS(1373),
    [sym__heredoc_body_beginning] = ACTIONS(1373),
    [sym_file_descriptor] = ACTIONS(1373),
    [sym_variable_name] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_done] = ACTIONS(1375),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE_AMP] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_LT_LT_DASH] = ACTIONS(1373),
    [anon_sym_LT_LT_LT] = ACTIONS(1373),
    [anon_sym_DOLLAR] = ACTIONS(1375),
    [sym__special_character] = ACTIONS(6246),
    [anon_sym_DQUOTE] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1373),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [anon_sym_LT_LPAREN] = ACTIONS(1373),
    [anon_sym_GT_LPAREN] = ACTIONS(1373),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1375),
    [sym_word] = ACTIONS(1375),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
  },
  [2229] = {
    [sym__simple_heredoc_body] = ACTIONS(1057),
    [sym__heredoc_body_beginning] = ACTIONS(1057),
    [sym_file_descriptor] = ACTIONS(1057),
    [sym__concat] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_done] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_PIPE_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_AMP] = ACTIONS(1057),
    [anon_sym_GT_AMP] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_LT] = ACTIONS(1057),
    [anon_sym_DOLLAR] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [sym_raw_string] = ACTIONS(1057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1057),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1057),
    [anon_sym_BQUOTE] = ACTIONS(1057),
    [anon_sym_LT_LPAREN] = ACTIONS(1057),
    [anon_sym_GT_LPAREN] = ACTIONS(1057),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1059),
    [sym_word] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [2230] = {
    [sym__simple_heredoc_body] = ACTIONS(1061),
    [sym__heredoc_body_beginning] = ACTIONS(1061),
    [sym_file_descriptor] = ACTIONS(1061),
    [sym__concat] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(1063),
    [anon_sym_done] = ACTIONS(1063),
    [anon_sym_PIPE] = ACTIONS(1063),
    [anon_sym_SEMI_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE_AMP] = ACTIONS(1061),
    [anon_sym_AMP_AMP] = ACTIONS(1061),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1063),
    [anon_sym_GT_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT_GT] = ACTIONS(1061),
    [anon_sym_LT_AMP] = ACTIONS(1061),
    [anon_sym_GT_AMP] = ACTIONS(1061),
    [anon_sym_LT_LT] = ACTIONS(1063),
    [anon_sym_LT_LT_DASH] = ACTIONS(1061),
    [anon_sym_LT_LT_LT] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1061),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1061),
    [anon_sym_LT_LPAREN] = ACTIONS(1061),
    [anon_sym_GT_LPAREN] = ACTIONS(1061),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1063),
    [sym_word] = ACTIONS(1063),
    [anon_sym_LF] = ACTIONS(1061),
    [anon_sym_AMP] = ACTIONS(1063),
  },
  [2231] = {
    [sym__simple_heredoc_body] = ACTIONS(1065),
    [sym__heredoc_body_beginning] = ACTIONS(1065),
    [sym_file_descriptor] = ACTIONS(1065),
    [sym__concat] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_done] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1067),
    [anon_sym_SEMI_SEMI] = ACTIONS(1065),
    [anon_sym_PIPE_AMP] = ACTIONS(1065),
    [anon_sym_AMP_AMP] = ACTIONS(1065),
    [anon_sym_PIPE_PIPE] = ACTIONS(1065),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_GT] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT] = ACTIONS(1067),
    [anon_sym_AMP_GT_GT] = ACTIONS(1065),
    [anon_sym_LT_AMP] = ACTIONS(1065),
    [anon_sym_GT_AMP] = ACTIONS(1065),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_LT_LT_DASH] = ACTIONS(1065),
    [anon_sym_LT_LT_LT] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1067),
    [sym__special_character] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LT_LPAREN] = ACTIONS(1065),
    [anon_sym_GT_LPAREN] = ACTIONS(1065),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1067),
    [sym_word] = ACTIONS(1067),
    [anon_sym_LF] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1067),
  },
  [2232] = {
    [sym_string] = STATE(2855),
    [sym_simple_expansion] = STATE(2855),
    [sym_string_expansion] = STATE(2855),
    [sym_expansion] = STATE(2855),
    [sym_command_substitution] = STATE(2855),
    [sym_process_substitution] = STATE(2855),
    [anon_sym_DOLLAR] = ACTIONS(3249),
    [sym__special_character] = ACTIONS(6249),
    [anon_sym_DQUOTE] = ACTIONS(3253),
    [sym_raw_string] = ACTIONS(6249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3257),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3259),
    [anon_sym_BQUOTE] = ACTIONS(3261),
    [anon_sym_LT_LPAREN] = ACTIONS(3263),
    [anon_sym_GT_LPAREN] = ACTIONS(3263),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6249),
  },
  [2233] = {
    [aux_sym_concatenation_repeat1] = STATE(2857),
    [sym__simple_heredoc_body] = ACTIONS(1071),
    [sym__heredoc_body_beginning] = ACTIONS(1071),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(6251),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_done] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [sym__special_character] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [sym_word] = ACTIONS(1075),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1075),
  },
  [2234] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(6253),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [2235] = {
    [sym__simple_heredoc_body] = ACTIONS(1089),
    [sym__heredoc_body_beginning] = ACTIONS(1089),
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(1089),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_done] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1089),
    [anon_sym_PIPE_AMP] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_AMP] = ACTIONS(1089),
    [anon_sym_GT_AMP] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1089),
    [anon_sym_LT_LT_LT] = ACTIONS(1089),
    [anon_sym_DOLLAR] = ACTIONS(1091),
    [sym__special_character] = ACTIONS(1089),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1089),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1089),
    [anon_sym_GT_LPAREN] = ACTIONS(1089),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1091),
    [sym_word] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [2236] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(627),
    [anon_sym_DOLLAR] = ACTIONS(6255),
    [anon_sym_DQUOTE] = ACTIONS(6253),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [2237] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(6257),
    [sym_comment] = ACTIONS(57),
  },
  [2238] = {
    [sym_subscript] = STATE(2863),
    [sym_variable_name] = ACTIONS(6259),
    [anon_sym_DASH] = ACTIONS(6261),
    [anon_sym_DOLLAR] = ACTIONS(6261),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6263),
    [anon_sym_STAR] = ACTIONS(6265),
    [anon_sym_AT] = ACTIONS(6265),
    [anon_sym_QMARK] = ACTIONS(6265),
    [anon_sym_0] = ACTIONS(6263),
    [anon_sym__] = ACTIONS(6263),
  },
  [2239] = {
    [sym_concatenation] = STATE(2866),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2866),
    [anon_sym_RBRACE] = ACTIONS(6267),
    [anon_sym_EQ] = ACTIONS(6269),
    [anon_sym_DASH] = ACTIONS(6269),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(6271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(6273),
    [anon_sym_COLON] = ACTIONS(6269),
    [anon_sym_COLON_QMARK] = ACTIONS(6269),
    [anon_sym_COLON_DASH] = ACTIONS(6269),
    [anon_sym_PERCENT] = ACTIONS(6269),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2240] = {
    [sym_concatenation] = STATE(2869),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2869),
    [anon_sym_RBRACE] = ACTIONS(6275),
    [anon_sym_EQ] = ACTIONS(6277),
    [anon_sym_DASH] = ACTIONS(6277),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(6279),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(6281),
    [anon_sym_COLON] = ACTIONS(6277),
    [anon_sym_COLON_QMARK] = ACTIONS(6277),
    [anon_sym_COLON_DASH] = ACTIONS(6277),
    [anon_sym_PERCENT] = ACTIONS(6277),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2241] = {
    [anon_sym_RPAREN] = ACTIONS(6283),
    [sym_comment] = ACTIONS(57),
  },
  [2242] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(6283),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [2243] = {
    [anon_sym_BQUOTE] = ACTIONS(6283),
    [sym_comment] = ACTIONS(57),
  },
  [2244] = {
    [anon_sym_RPAREN] = ACTIONS(6285),
    [sym_comment] = ACTIONS(57),
  },
  [2245] = {
    [sym_concatenation] = STATE(2245),
    [sym_string] = STATE(1575),
    [sym_simple_expansion] = STATE(1575),
    [sym_string_expansion] = STATE(1575),
    [sym_expansion] = STATE(1575),
    [sym_command_substitution] = STATE(1575),
    [sym_process_substitution] = STATE(1575),
    [aux_sym_unset_command_repeat1] = STATE(2245),
    [aux_sym__literal_repeat1] = STATE(1581),
    [sym__simple_heredoc_body] = ACTIONS(2284),
    [sym__heredoc_body_beginning] = ACTIONS(2284),
    [sym_file_descriptor] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym_done] = ACTIONS(2286),
    [anon_sym_PIPE] = ACTIONS(2286),
    [anon_sym_SEMI_SEMI] = ACTIONS(2284),
    [anon_sym_PIPE_AMP] = ACTIONS(2284),
    [anon_sym_AMP_AMP] = ACTIONS(2284),
    [anon_sym_PIPE_PIPE] = ACTIONS(2284),
    [anon_sym_LT] = ACTIONS(2286),
    [anon_sym_GT] = ACTIONS(2286),
    [anon_sym_GT_GT] = ACTIONS(2284),
    [anon_sym_AMP_GT] = ACTIONS(2286),
    [anon_sym_AMP_GT_GT] = ACTIONS(2284),
    [anon_sym_LT_AMP] = ACTIONS(2284),
    [anon_sym_GT_AMP] = ACTIONS(2284),
    [anon_sym_LT_LT] = ACTIONS(2286),
    [anon_sym_LT_LT_DASH] = ACTIONS(2284),
    [anon_sym_LT_LT_LT] = ACTIONS(2284),
    [anon_sym_DOLLAR] = ACTIONS(6287),
    [sym__special_character] = ACTIONS(6290),
    [anon_sym_DQUOTE] = ACTIONS(6293),
    [sym_raw_string] = ACTIONS(6296),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6302),
    [anon_sym_BQUOTE] = ACTIONS(6305),
    [anon_sym_LT_LPAREN] = ACTIONS(6308),
    [anon_sym_GT_LPAREN] = ACTIONS(6308),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6311),
    [sym_word] = ACTIONS(6314),
    [anon_sym_LF] = ACTIONS(2284),
    [anon_sym_AMP] = ACTIONS(2286),
  },
  [2246] = {
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_done] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(339),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [2247] = {
    [aux_sym__literal_repeat1] = STATE(2247),
    [sym__simple_heredoc_body] = ACTIONS(1373),
    [sym__heredoc_body_beginning] = ACTIONS(1373),
    [sym_file_descriptor] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_done] = ACTIONS(1375),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE_AMP] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_LT_LT_DASH] = ACTIONS(1373),
    [anon_sym_LT_LT_LT] = ACTIONS(1373),
    [anon_sym_DOLLAR] = ACTIONS(1375),
    [sym__special_character] = ACTIONS(6317),
    [anon_sym_DQUOTE] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1373),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [anon_sym_LT_LPAREN] = ACTIONS(1373),
    [anon_sym_GT_LPAREN] = ACTIONS(1373),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1375),
    [sym_word] = ACTIONS(1375),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
  },
  [2248] = {
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_done] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_EQ_TILDE] = ACTIONS(2364),
    [anon_sym_EQ_EQ] = ACTIONS(2364),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [2249] = {
    [sym_string] = STATE(2248),
    [sym_simple_expansion] = STATE(2248),
    [sym_string_expansion] = STATE(2248),
    [sym_expansion] = STATE(2248),
    [sym_command_substitution] = STATE(2248),
    [sym_process_substitution] = STATE(2248),
    [anon_sym_DOLLAR] = ACTIONS(6320),
    [sym__special_character] = ACTIONS(4950),
    [anon_sym_DQUOTE] = ACTIONS(1765),
    [sym_raw_string] = ACTIONS(4950),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1769),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1771),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [anon_sym_LT_LPAREN] = ACTIONS(1775),
    [anon_sym_GT_LPAREN] = ACTIONS(1775),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4950),
  },
  [2250] = {
    [aux_sym_concatenation_repeat1] = STATE(2250),
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(6322),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_done] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_EQ_TILDE] = ACTIONS(2364),
    [anon_sym_EQ_EQ] = ACTIONS(2364),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [2251] = {
    [sym__simple_heredoc_body] = ACTIONS(2371),
    [sym__heredoc_body_beginning] = ACTIONS(2371),
    [sym_file_descriptor] = ACTIONS(2371),
    [sym__concat] = ACTIONS(2371),
    [anon_sym_SEMI] = ACTIONS(2373),
    [anon_sym_done] = ACTIONS(2373),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_SEMI_SEMI] = ACTIONS(2371),
    [anon_sym_PIPE_AMP] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_EQ_TILDE] = ACTIONS(2373),
    [anon_sym_EQ_EQ] = ACTIONS(2373),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_GT_GT] = ACTIONS(2371),
    [anon_sym_AMP_GT] = ACTIONS(2373),
    [anon_sym_AMP_GT_GT] = ACTIONS(2371),
    [anon_sym_LT_AMP] = ACTIONS(2371),
    [anon_sym_GT_AMP] = ACTIONS(2371),
    [anon_sym_LT_LT] = ACTIONS(2373),
    [anon_sym_LT_LT_DASH] = ACTIONS(2371),
    [anon_sym_LT_LT_LT] = ACTIONS(2371),
    [anon_sym_DOLLAR] = ACTIONS(2373),
    [sym__special_character] = ACTIONS(2371),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [sym_raw_string] = ACTIONS(2371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2371),
    [anon_sym_BQUOTE] = ACTIONS(2371),
    [anon_sym_LT_LPAREN] = ACTIONS(2371),
    [anon_sym_GT_LPAREN] = ACTIONS(2371),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2373),
    [anon_sym_LF] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
  },
  [2252] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(6325),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [2253] = {
    [sym_concatenation] = STATE(2876),
    [sym_string] = STATE(2875),
    [sym_simple_expansion] = STATE(2875),
    [sym_string_expansion] = STATE(2875),
    [sym_expansion] = STATE(2875),
    [sym_command_substitution] = STATE(2875),
    [sym_process_substitution] = STATE(2875),
    [aux_sym__literal_repeat1] = STATE(2877),
    [anon_sym_RBRACE] = ACTIONS(6327),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(6329),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6329),
  },
  [2254] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(6331),
    [sym_comment] = ACTIONS(57),
  },
  [2255] = {
    [sym_concatenation] = STATE(2881),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2881),
    [anon_sym_RBRACE] = ACTIONS(6333),
    [anon_sym_EQ] = ACTIONS(6335),
    [anon_sym_DASH] = ACTIONS(6335),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(6337),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(6339),
    [anon_sym_COLON] = ACTIONS(6335),
    [anon_sym_COLON_QMARK] = ACTIONS(6335),
    [anon_sym_COLON_DASH] = ACTIONS(6335),
    [anon_sym_PERCENT] = ACTIONS(6335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2256] = {
    [sym_concatenation] = STATE(2883),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2883),
    [anon_sym_RBRACE] = ACTIONS(6327),
    [anon_sym_EQ] = ACTIONS(6341),
    [anon_sym_DASH] = ACTIONS(6341),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(6343),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(6345),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_COLON_QMARK] = ACTIONS(6341),
    [anon_sym_COLON_DASH] = ACTIONS(6341),
    [anon_sym_PERCENT] = ACTIONS(6341),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2257] = {
    [sym__simple_heredoc_body] = ACTIONS(2462),
    [sym__heredoc_body_beginning] = ACTIONS(2462),
    [sym_file_descriptor] = ACTIONS(2462),
    [sym__concat] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_done] = ACTIONS(2464),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_SEMI_SEMI] = ACTIONS(2462),
    [anon_sym_PIPE_AMP] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_EQ_TILDE] = ACTIONS(2464),
    [anon_sym_EQ_EQ] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_GT_GT] = ACTIONS(2462),
    [anon_sym_AMP_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT_GT] = ACTIONS(2462),
    [anon_sym_LT_AMP] = ACTIONS(2462),
    [anon_sym_GT_AMP] = ACTIONS(2462),
    [anon_sym_LT_LT] = ACTIONS(2464),
    [anon_sym_LT_LT_DASH] = ACTIONS(2462),
    [anon_sym_LT_LT_LT] = ACTIONS(2462),
    [anon_sym_DOLLAR] = ACTIONS(2464),
    [sym__special_character] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [sym_raw_string] = ACTIONS(2462),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2462),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2462),
    [anon_sym_BQUOTE] = ACTIONS(2462),
    [anon_sym_LT_LPAREN] = ACTIONS(2462),
    [anon_sym_GT_LPAREN] = ACTIONS(2462),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2464),
    [anon_sym_LF] = ACTIONS(2462),
    [anon_sym_AMP] = ACTIONS(2464),
  },
  [2258] = {
    [sym_concatenation] = STATE(2886),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2886),
    [sym_regex] = ACTIONS(6347),
    [anon_sym_RBRACE] = ACTIONS(6349),
    [anon_sym_EQ] = ACTIONS(6351),
    [anon_sym_DASH] = ACTIONS(6351),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(6353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(6351),
    [anon_sym_COLON_QMARK] = ACTIONS(6351),
    [anon_sym_COLON_DASH] = ACTIONS(6351),
    [anon_sym_PERCENT] = ACTIONS(6351),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2259] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(6349),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2260] = {
    [sym__simple_heredoc_body] = ACTIONS(2512),
    [sym__heredoc_body_beginning] = ACTIONS(2512),
    [sym_file_descriptor] = ACTIONS(2512),
    [sym__concat] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2514),
    [anon_sym_done] = ACTIONS(2514),
    [anon_sym_PIPE] = ACTIONS(2514),
    [anon_sym_SEMI_SEMI] = ACTIONS(2512),
    [anon_sym_PIPE_AMP] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE_PIPE] = ACTIONS(2512),
    [anon_sym_EQ_TILDE] = ACTIONS(2514),
    [anon_sym_EQ_EQ] = ACTIONS(2514),
    [anon_sym_LT] = ACTIONS(2514),
    [anon_sym_GT] = ACTIONS(2514),
    [anon_sym_GT_GT] = ACTIONS(2512),
    [anon_sym_AMP_GT] = ACTIONS(2514),
    [anon_sym_AMP_GT_GT] = ACTIONS(2512),
    [anon_sym_LT_AMP] = ACTIONS(2512),
    [anon_sym_GT_AMP] = ACTIONS(2512),
    [anon_sym_LT_LT] = ACTIONS(2514),
    [anon_sym_LT_LT_DASH] = ACTIONS(2512),
    [anon_sym_LT_LT_LT] = ACTIONS(2512),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [sym__special_character] = ACTIONS(2512),
    [anon_sym_DQUOTE] = ACTIONS(2512),
    [sym_raw_string] = ACTIONS(2512),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2512),
    [anon_sym_BQUOTE] = ACTIONS(2512),
    [anon_sym_LT_LPAREN] = ACTIONS(2512),
    [anon_sym_GT_LPAREN] = ACTIONS(2512),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2514),
    [anon_sym_LF] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2514),
  },
  [2261] = {
    [sym_concatenation] = STATE(2883),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2883),
    [sym_regex] = ACTIONS(6355),
    [anon_sym_RBRACE] = ACTIONS(6327),
    [anon_sym_EQ] = ACTIONS(6341),
    [anon_sym_DASH] = ACTIONS(6341),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(6343),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(6341),
    [anon_sym_COLON_QMARK] = ACTIONS(6341),
    [anon_sym_COLON_DASH] = ACTIONS(6341),
    [anon_sym_PERCENT] = ACTIONS(6341),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2262] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(6327),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2263] = {
    [sym__simple_heredoc_body] = ACTIONS(2520),
    [sym__heredoc_body_beginning] = ACTIONS(2520),
    [sym_file_descriptor] = ACTIONS(2520),
    [sym__concat] = ACTIONS(2520),
    [anon_sym_SEMI] = ACTIONS(2522),
    [anon_sym_done] = ACTIONS(2522),
    [anon_sym_PIPE] = ACTIONS(2522),
    [anon_sym_SEMI_SEMI] = ACTIONS(2520),
    [anon_sym_PIPE_AMP] = ACTIONS(2520),
    [anon_sym_AMP_AMP] = ACTIONS(2520),
    [anon_sym_PIPE_PIPE] = ACTIONS(2520),
    [anon_sym_EQ_TILDE] = ACTIONS(2522),
    [anon_sym_EQ_EQ] = ACTIONS(2522),
    [anon_sym_LT] = ACTIONS(2522),
    [anon_sym_GT] = ACTIONS(2522),
    [anon_sym_GT_GT] = ACTIONS(2520),
    [anon_sym_AMP_GT] = ACTIONS(2522),
    [anon_sym_AMP_GT_GT] = ACTIONS(2520),
    [anon_sym_LT_AMP] = ACTIONS(2520),
    [anon_sym_GT_AMP] = ACTIONS(2520),
    [anon_sym_LT_LT] = ACTIONS(2522),
    [anon_sym_LT_LT_DASH] = ACTIONS(2520),
    [anon_sym_LT_LT_LT] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(2522),
    [sym__special_character] = ACTIONS(2520),
    [anon_sym_DQUOTE] = ACTIONS(2520),
    [sym_raw_string] = ACTIONS(2520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2520),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2520),
    [anon_sym_BQUOTE] = ACTIONS(2520),
    [anon_sym_LT_LPAREN] = ACTIONS(2520),
    [anon_sym_GT_LPAREN] = ACTIONS(2520),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2522),
    [anon_sym_LF] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2522),
  },
  [2264] = {
    [sym__simple_heredoc_body] = ACTIONS(2554),
    [sym__heredoc_body_beginning] = ACTIONS(2554),
    [sym_file_descriptor] = ACTIONS(2554),
    [sym__concat] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(2556),
    [anon_sym_done] = ACTIONS(2556),
    [anon_sym_PIPE] = ACTIONS(2556),
    [anon_sym_SEMI_SEMI] = ACTIONS(2554),
    [anon_sym_PIPE_AMP] = ACTIONS(2554),
    [anon_sym_AMP_AMP] = ACTIONS(2554),
    [anon_sym_PIPE_PIPE] = ACTIONS(2554),
    [anon_sym_EQ_TILDE] = ACTIONS(2556),
    [anon_sym_EQ_EQ] = ACTIONS(2556),
    [anon_sym_LT] = ACTIONS(2556),
    [anon_sym_GT] = ACTIONS(2556),
    [anon_sym_GT_GT] = ACTIONS(2554),
    [anon_sym_AMP_GT] = ACTIONS(2556),
    [anon_sym_AMP_GT_GT] = ACTIONS(2554),
    [anon_sym_LT_AMP] = ACTIONS(2554),
    [anon_sym_GT_AMP] = ACTIONS(2554),
    [anon_sym_LT_LT] = ACTIONS(2556),
    [anon_sym_LT_LT_DASH] = ACTIONS(2554),
    [anon_sym_LT_LT_LT] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2556),
    [sym__special_character] = ACTIONS(2554),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2554),
    [anon_sym_BQUOTE] = ACTIONS(2554),
    [anon_sym_LT_LPAREN] = ACTIONS(2554),
    [anon_sym_GT_LPAREN] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2556),
    [anon_sym_LF] = ACTIONS(2554),
    [anon_sym_AMP] = ACTIONS(2556),
  },
  [2265] = {
    [sym_concatenation] = STATE(1328),
    [sym_string] = STATE(2888),
    [sym_simple_expansion] = STATE(2888),
    [sym_string_expansion] = STATE(2888),
    [sym_expansion] = STATE(2888),
    [sym_command_substitution] = STATE(2888),
    [sym_process_substitution] = STATE(2888),
    [aux_sym__literal_repeat1] = STATE(2889),
    [anon_sym_DOLLAR] = ACTIONS(4998),
    [sym__special_character] = ACTIONS(5000),
    [anon_sym_DQUOTE] = ACTIONS(5002),
    [sym_raw_string] = ACTIONS(6357),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5006),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5008),
    [anon_sym_BQUOTE] = ACTIONS(5010),
    [anon_sym_LT_LPAREN] = ACTIONS(5012),
    [anon_sym_GT_LPAREN] = ACTIONS(5012),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6357),
  },
  [2266] = {
    [sym_file_redirect] = STATE(1606),
    [sym_heredoc_redirect] = STATE(1606),
    [sym_herestring_redirect] = STATE(1606),
    [aux_sym_redirected_statement_repeat1] = STATE(1606),
    [sym__simple_heredoc_body] = ACTIONS(2584),
    [sym__heredoc_body_beginning] = ACTIONS(2584),
    [sym_file_descriptor] = ACTIONS(2584),
    [anon_sym_SEMI] = ACTIONS(2586),
    [anon_sym_done] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2586),
    [anon_sym_SEMI_SEMI] = ACTIONS(2584),
    [anon_sym_PIPE_AMP] = ACTIONS(2584),
    [anon_sym_AMP_AMP] = ACTIONS(2584),
    [anon_sym_PIPE_PIPE] = ACTIONS(2584),
    [anon_sym_LT] = ACTIONS(2586),
    [anon_sym_GT] = ACTIONS(2586),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT] = ACTIONS(2586),
    [anon_sym_AMP_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_AMP] = ACTIONS(2584),
    [anon_sym_GT_AMP] = ACTIONS(2584),
    [anon_sym_LT_LT] = ACTIONS(2586),
    [anon_sym_LT_LT_DASH] = ACTIONS(2584),
    [anon_sym_LT_LT_LT] = ACTIONS(2584),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2584),
    [anon_sym_AMP] = ACTIONS(2586),
  },
  [2267] = {
    [sym_file_redirect] = STATE(1606),
    [sym_heredoc_redirect] = STATE(1606),
    [sym_herestring_redirect] = STATE(1606),
    [aux_sym_redirected_statement_repeat1] = STATE(1606),
    [sym__simple_heredoc_body] = ACTIONS(2584),
    [sym__heredoc_body_beginning] = ACTIONS(2584),
    [sym_file_descriptor] = ACTIONS(2584),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2586),
    [anon_sym_done] = ACTIONS(2586),
    [anon_sym_PIPE] = ACTIONS(2586),
    [anon_sym_SEMI_SEMI] = ACTIONS(2584),
    [anon_sym_PIPE_AMP] = ACTIONS(2584),
    [anon_sym_AMP_AMP] = ACTIONS(2584),
    [anon_sym_PIPE_PIPE] = ACTIONS(2584),
    [anon_sym_LT] = ACTIONS(2586),
    [anon_sym_GT] = ACTIONS(2586),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT] = ACTIONS(2586),
    [anon_sym_AMP_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_AMP] = ACTIONS(2584),
    [anon_sym_GT_AMP] = ACTIONS(2584),
    [anon_sym_LT_LT] = ACTIONS(2586),
    [anon_sym_LT_LT_DASH] = ACTIONS(2584),
    [anon_sym_LT_LT_LT] = ACTIONS(2584),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2584),
    [anon_sym_AMP] = ACTIONS(2586),
  },
  [2268] = {
    [sym_file_redirect] = STATE(1606),
    [sym_heredoc_redirect] = STATE(1606),
    [sym_herestring_redirect] = STATE(1606),
    [aux_sym_redirected_statement_repeat1] = STATE(1606),
    [sym__simple_heredoc_body] = ACTIONS(2588),
    [sym__heredoc_body_beginning] = ACTIONS(2588),
    [sym_file_descriptor] = ACTIONS(2588),
    [anon_sym_SEMI] = ACTIONS(2590),
    [anon_sym_done] = ACTIONS(2588),
    [anon_sym_PIPE] = ACTIONS(3299),
    [anon_sym_SEMI_SEMI] = ACTIONS(2588),
    [anon_sym_PIPE_AMP] = ACTIONS(3303),
    [anon_sym_AMP_AMP] = ACTIONS(2588),
    [anon_sym_PIPE_PIPE] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(2590),
    [anon_sym_GT] = ACTIONS(2590),
    [anon_sym_GT_GT] = ACTIONS(2588),
    [anon_sym_AMP_GT] = ACTIONS(2590),
    [anon_sym_AMP_GT_GT] = ACTIONS(2588),
    [anon_sym_LT_AMP] = ACTIONS(2588),
    [anon_sym_GT_AMP] = ACTIONS(2588),
    [anon_sym_LT_LT] = ACTIONS(2590),
    [anon_sym_LT_LT_DASH] = ACTIONS(2588),
    [anon_sym_LT_LT_LT] = ACTIONS(2588),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2588),
    [anon_sym_AMP] = ACTIONS(2590),
  },
  [2269] = {
    [sym_file_redirect] = STATE(1606),
    [sym_heredoc_redirect] = STATE(1606),
    [sym_herestring_redirect] = STATE(1606),
    [aux_sym_redirected_statement_repeat1] = STATE(1606),
    [sym__simple_heredoc_body] = ACTIONS(2588),
    [sym__heredoc_body_beginning] = ACTIONS(2588),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2590),
    [anon_sym_done] = ACTIONS(2590),
    [anon_sym_PIPE] = ACTIONS(3299),
    [anon_sym_SEMI_SEMI] = ACTIONS(2588),
    [anon_sym_PIPE_AMP] = ACTIONS(3303),
    [anon_sym_AMP_AMP] = ACTIONS(2588),
    [anon_sym_PIPE_PIPE] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(2590),
    [anon_sym_LT_LT_DASH] = ACTIONS(2588),
    [anon_sym_LT_LT_LT] = ACTIONS(2588),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2588),
    [anon_sym_AMP] = ACTIONS(2590),
  },
  [2270] = {
    [sym_string] = STATE(2891),
    [anon_sym_DASH] = ACTIONS(6359),
    [anon_sym_DOLLAR] = ACTIONS(6359),
    [anon_sym_DQUOTE] = ACTIONS(5002),
    [sym_raw_string] = ACTIONS(6361),
    [anon_sym_POUND] = ACTIONS(6359),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6363),
    [anon_sym_STAR] = ACTIONS(6365),
    [anon_sym_AT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6365),
    [anon_sym_0] = ACTIONS(6363),
    [anon_sym__] = ACTIONS(6363),
  },
  [2271] = {
    [aux_sym_concatenation_repeat1] = STATE(2894),
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(6367),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_done] = ACTIONS(335),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [sym__special_character] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [2272] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(2897),
    [anon_sym_DOLLAR] = ACTIONS(6369),
    [anon_sym_DQUOTE] = ACTIONS(6371),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [2273] = {
    [aux_sym_concatenation_repeat1] = STATE(2894),
    [sym__simple_heredoc_body] = ACTIONS(1037),
    [sym__heredoc_body_beginning] = ACTIONS(1037),
    [sym_file_descriptor] = ACTIONS(1037),
    [sym__concat] = ACTIONS(6367),
    [anon_sym_SEMI] = ACTIONS(1039),
    [anon_sym_done] = ACTIONS(1037),
    [anon_sym_PIPE] = ACTIONS(1039),
    [anon_sym_SEMI_SEMI] = ACTIONS(1037),
    [anon_sym_PIPE_AMP] = ACTIONS(1037),
    [anon_sym_AMP_AMP] = ACTIONS(1037),
    [anon_sym_PIPE_PIPE] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1039),
    [anon_sym_GT] = ACTIONS(1039),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_AMP_GT] = ACTIONS(1039),
    [anon_sym_AMP_GT_GT] = ACTIONS(1037),
    [anon_sym_LT_AMP] = ACTIONS(1037),
    [anon_sym_GT_AMP] = ACTIONS(1037),
    [anon_sym_LT_LT] = ACTIONS(1039),
    [anon_sym_LT_LT_DASH] = ACTIONS(1037),
    [anon_sym_LT_LT_LT] = ACTIONS(1037),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1037),
    [anon_sym_AMP] = ACTIONS(1039),
  },
  [2274] = {
    [sym_subscript] = STATE(2901),
    [sym_variable_name] = ACTIONS(6373),
    [anon_sym_BANG] = ACTIONS(6375),
    [anon_sym_DASH] = ACTIONS(6377),
    [anon_sym_DOLLAR] = ACTIONS(6377),
    [anon_sym_POUND] = ACTIONS(6375),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6379),
    [anon_sym_STAR] = ACTIONS(6381),
    [anon_sym_AT] = ACTIONS(6381),
    [anon_sym_QMARK] = ACTIONS(6381),
    [anon_sym_0] = ACTIONS(6379),
    [anon_sym__] = ACTIONS(6379),
  },
  [2275] = {
    [sym__statements] = STATE(2902),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(2903),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [2276] = {
    [sym__statements] = STATE(2904),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [2277] = {
    [sym__statements] = STATE(2905),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [2278] = {
    [aux_sym__literal_repeat1] = STATE(2907),
    [sym__simple_heredoc_body] = ACTIONS(1051),
    [sym__heredoc_body_beginning] = ACTIONS(1051),
    [sym_file_descriptor] = ACTIONS(1051),
    [anon_sym_SEMI] = ACTIONS(1053),
    [anon_sym_done] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1053),
    [anon_sym_SEMI_SEMI] = ACTIONS(1051),
    [anon_sym_PIPE_AMP] = ACTIONS(1051),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_PIPE_PIPE] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT_GT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1051),
    [anon_sym_GT_AMP] = ACTIONS(1051),
    [anon_sym_LT_LT] = ACTIONS(1053),
    [anon_sym_LT_LT_DASH] = ACTIONS(1051),
    [anon_sym_LT_LT_LT] = ACTIONS(1051),
    [sym__special_character] = ACTIONS(6383),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1051),
    [anon_sym_AMP] = ACTIONS(1053),
  },
  [2279] = {
    [aux_sym_concatenation_repeat1] = STATE(2894),
    [sym__simple_heredoc_body] = ACTIONS(2596),
    [sym__heredoc_body_beginning] = ACTIONS(2596),
    [sym_file_descriptor] = ACTIONS(2596),
    [sym__concat] = ACTIONS(6367),
    [anon_sym_SEMI] = ACTIONS(2598),
    [anon_sym_done] = ACTIONS(2596),
    [anon_sym_PIPE] = ACTIONS(2598),
    [anon_sym_SEMI_SEMI] = ACTIONS(2596),
    [anon_sym_PIPE_AMP] = ACTIONS(2596),
    [anon_sym_AMP_AMP] = ACTIONS(2596),
    [anon_sym_PIPE_PIPE] = ACTIONS(2596),
    [anon_sym_LT] = ACTIONS(2598),
    [anon_sym_GT] = ACTIONS(2598),
    [anon_sym_GT_GT] = ACTIONS(2596),
    [anon_sym_AMP_GT] = ACTIONS(2598),
    [anon_sym_AMP_GT_GT] = ACTIONS(2596),
    [anon_sym_LT_AMP] = ACTIONS(2596),
    [anon_sym_GT_AMP] = ACTIONS(2596),
    [anon_sym_LT_LT] = ACTIONS(2598),
    [anon_sym_LT_LT_DASH] = ACTIONS(2596),
    [anon_sym_LT_LT_LT] = ACTIONS(2596),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2596),
    [anon_sym_AMP] = ACTIONS(2598),
  },
  [2280] = {
    [aux_sym__literal_repeat1] = STATE(2907),
    [sym__simple_heredoc_body] = ACTIONS(2600),
    [sym__heredoc_body_beginning] = ACTIONS(2600),
    [sym_file_descriptor] = ACTIONS(2600),
    [anon_sym_SEMI] = ACTIONS(2602),
    [anon_sym_done] = ACTIONS(2600),
    [anon_sym_PIPE] = ACTIONS(2602),
    [anon_sym_SEMI_SEMI] = ACTIONS(2600),
    [anon_sym_PIPE_AMP] = ACTIONS(2600),
    [anon_sym_AMP_AMP] = ACTIONS(2600),
    [anon_sym_PIPE_PIPE] = ACTIONS(2600),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_GT_GT] = ACTIONS(2600),
    [anon_sym_AMP_GT] = ACTIONS(2602),
    [anon_sym_AMP_GT_GT] = ACTIONS(2600),
    [anon_sym_LT_AMP] = ACTIONS(2600),
    [anon_sym_GT_AMP] = ACTIONS(2600),
    [anon_sym_LT_LT] = ACTIONS(2602),
    [anon_sym_LT_LT_DASH] = ACTIONS(2600),
    [anon_sym_LT_LT_LT] = ACTIONS(2600),
    [sym__special_character] = ACTIONS(6383),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2600),
    [anon_sym_AMP] = ACTIONS(2602),
  },
  [2281] = {
    [sym_file_descriptor] = ACTIONS(2604),
    [sym_variable_name] = ACTIONS(2604),
    [anon_sym_for] = ACTIONS(2608),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2608),
    [anon_sym_done] = ACTIONS(6385),
    [anon_sym_if] = ACTIONS(2608),
    [anon_sym_case] = ACTIONS(2608),
    [anon_sym_function] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(2608),
    [anon_sym_LBRACE] = ACTIONS(2604),
    [anon_sym_BANG] = ACTIONS(2608),
    [anon_sym_LBRACK] = ACTIONS(2608),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2604),
    [anon_sym_declare] = ACTIONS(2608),
    [anon_sym_typeset] = ACTIONS(2608),
    [anon_sym_export] = ACTIONS(2608),
    [anon_sym_readonly] = ACTIONS(2608),
    [anon_sym_local] = ACTIONS(2608),
    [anon_sym_unset] = ACTIONS(2608),
    [anon_sym_unsetenv] = ACTIONS(2608),
    [anon_sym_LT] = ACTIONS(2608),
    [anon_sym_GT] = ACTIONS(2608),
    [anon_sym_GT_GT] = ACTIONS(2604),
    [anon_sym_AMP_GT] = ACTIONS(2608),
    [anon_sym_AMP_GT_GT] = ACTIONS(2604),
    [anon_sym_LT_AMP] = ACTIONS(2604),
    [anon_sym_GT_AMP] = ACTIONS(2604),
    [anon_sym_DOLLAR] = ACTIONS(2608),
    [sym__special_character] = ACTIONS(2608),
    [anon_sym_DQUOTE] = ACTIONS(2604),
    [sym_raw_string] = ACTIONS(2604),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2604),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2604),
    [anon_sym_BQUOTE] = ACTIONS(2604),
    [anon_sym_LT_LPAREN] = ACTIONS(2604),
    [anon_sym_GT_LPAREN] = ACTIONS(2604),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2608),
  },
  [2282] = {
    [sym_file_redirect] = STATE(2282),
    [sym_heredoc_redirect] = STATE(2282),
    [sym_herestring_redirect] = STATE(2282),
    [aux_sym_redirected_statement_repeat1] = STATE(2282),
    [sym__simple_heredoc_body] = ACTIONS(2610),
    [sym__heredoc_body_beginning] = ACTIONS(2610),
    [sym_file_descriptor] = ACTIONS(6387),
    [anon_sym_SEMI] = ACTIONS(2615),
    [anon_sym_done] = ACTIONS(2610),
    [anon_sym_PIPE] = ACTIONS(2615),
    [anon_sym_SEMI_SEMI] = ACTIONS(2610),
    [anon_sym_PIPE_AMP] = ACTIONS(2610),
    [anon_sym_AMP_AMP] = ACTIONS(2610),
    [anon_sym_PIPE_PIPE] = ACTIONS(2610),
    [anon_sym_LT] = ACTIONS(6390),
    [anon_sym_GT] = ACTIONS(6390),
    [anon_sym_GT_GT] = ACTIONS(6393),
    [anon_sym_AMP_GT] = ACTIONS(6390),
    [anon_sym_AMP_GT_GT] = ACTIONS(6393),
    [anon_sym_LT_AMP] = ACTIONS(6393),
    [anon_sym_GT_AMP] = ACTIONS(6393),
    [anon_sym_LT_LT] = ACTIONS(2623),
    [anon_sym_LT_LT_DASH] = ACTIONS(2626),
    [anon_sym_LT_LT_LT] = ACTIONS(6396),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2610),
    [anon_sym_AMP] = ACTIONS(2615),
  },
  [2283] = {
    [sym__simple_heredoc_body] = ACTIONS(2632),
    [sym__heredoc_body_beginning] = ACTIONS(2632),
    [sym_file_descriptor] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_done] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2634),
    [anon_sym_SEMI_SEMI] = ACTIONS(2632),
    [anon_sym_PIPE_AMP] = ACTIONS(2632),
    [anon_sym_AMP_AMP] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2632),
    [anon_sym_EQ_TILDE] = ACTIONS(2634),
    [anon_sym_EQ_EQ] = ACTIONS(2634),
    [anon_sym_LT] = ACTIONS(2634),
    [anon_sym_GT] = ACTIONS(2634),
    [anon_sym_GT_GT] = ACTIONS(2632),
    [anon_sym_AMP_GT] = ACTIONS(2634),
    [anon_sym_AMP_GT_GT] = ACTIONS(2632),
    [anon_sym_LT_AMP] = ACTIONS(2632),
    [anon_sym_GT_AMP] = ACTIONS(2632),
    [anon_sym_LT_LT] = ACTIONS(2634),
    [anon_sym_LT_LT_DASH] = ACTIONS(2632),
    [anon_sym_LT_LT_LT] = ACTIONS(2632),
    [anon_sym_DOLLAR] = ACTIONS(2634),
    [sym__special_character] = ACTIONS(2632),
    [anon_sym_DQUOTE] = ACTIONS(2632),
    [sym_raw_string] = ACTIONS(2632),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2632),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2632),
    [anon_sym_BQUOTE] = ACTIONS(2632),
    [anon_sym_LT_LPAREN] = ACTIONS(2632),
    [anon_sym_GT_LPAREN] = ACTIONS(2632),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2634),
    [anon_sym_LF] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2634),
  },
  [2284] = {
    [aux_sym_concatenation_repeat1] = STATE(1586),
    [sym__simple_heredoc_body] = ACTIONS(2632),
    [sym__heredoc_body_beginning] = ACTIONS(2632),
    [sym_file_descriptor] = ACTIONS(2632),
    [sym__concat] = ACTIONS(3277),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_done] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2634),
    [anon_sym_SEMI_SEMI] = ACTIONS(2632),
    [anon_sym_PIPE_AMP] = ACTIONS(2632),
    [anon_sym_AMP_AMP] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2632),
    [anon_sym_EQ_TILDE] = ACTIONS(2634),
    [anon_sym_EQ_EQ] = ACTIONS(2634),
    [anon_sym_LT] = ACTIONS(2634),
    [anon_sym_GT] = ACTIONS(2634),
    [anon_sym_GT_GT] = ACTIONS(2632),
    [anon_sym_AMP_GT] = ACTIONS(2634),
    [anon_sym_AMP_GT_GT] = ACTIONS(2632),
    [anon_sym_LT_AMP] = ACTIONS(2632),
    [anon_sym_GT_AMP] = ACTIONS(2632),
    [anon_sym_LT_LT] = ACTIONS(2634),
    [anon_sym_LT_LT_DASH] = ACTIONS(2632),
    [anon_sym_LT_LT_LT] = ACTIONS(2632),
    [anon_sym_DOLLAR] = ACTIONS(2634),
    [sym__special_character] = ACTIONS(2632),
    [anon_sym_DQUOTE] = ACTIONS(2632),
    [sym_raw_string] = ACTIONS(2632),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2632),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2632),
    [anon_sym_BQUOTE] = ACTIONS(2632),
    [anon_sym_LT_LPAREN] = ACTIONS(2632),
    [anon_sym_GT_LPAREN] = ACTIONS(2632),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2634),
    [anon_sym_LF] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2634),
  },
  [2285] = {
    [aux_sym__literal_repeat1] = STATE(1615),
    [sym__simple_heredoc_body] = ACTIONS(2636),
    [sym__heredoc_body_beginning] = ACTIONS(2636),
    [sym_file_descriptor] = ACTIONS(2636),
    [anon_sym_SEMI] = ACTIONS(2638),
    [anon_sym_done] = ACTIONS(2638),
    [anon_sym_PIPE] = ACTIONS(2638),
    [anon_sym_SEMI_SEMI] = ACTIONS(2636),
    [anon_sym_PIPE_AMP] = ACTIONS(2636),
    [anon_sym_AMP_AMP] = ACTIONS(2636),
    [anon_sym_PIPE_PIPE] = ACTIONS(2636),
    [anon_sym_EQ_TILDE] = ACTIONS(2638),
    [anon_sym_EQ_EQ] = ACTIONS(2638),
    [anon_sym_LT] = ACTIONS(2638),
    [anon_sym_GT] = ACTIONS(2638),
    [anon_sym_GT_GT] = ACTIONS(2636),
    [anon_sym_AMP_GT] = ACTIONS(2638),
    [anon_sym_AMP_GT_GT] = ACTIONS(2636),
    [anon_sym_LT_AMP] = ACTIONS(2636),
    [anon_sym_GT_AMP] = ACTIONS(2636),
    [anon_sym_LT_LT] = ACTIONS(2638),
    [anon_sym_LT_LT_DASH] = ACTIONS(2636),
    [anon_sym_LT_LT_LT] = ACTIONS(2636),
    [anon_sym_DOLLAR] = ACTIONS(2638),
    [sym__special_character] = ACTIONS(3323),
    [anon_sym_DQUOTE] = ACTIONS(2636),
    [sym_raw_string] = ACTIONS(2636),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2636),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2636),
    [anon_sym_BQUOTE] = ACTIONS(2636),
    [anon_sym_LT_LPAREN] = ACTIONS(2636),
    [anon_sym_GT_LPAREN] = ACTIONS(2636),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2638),
    [anon_sym_LF] = ACTIONS(2636),
    [anon_sym_AMP] = ACTIONS(2638),
  },
  [2286] = {
    [sym_concatenation] = STATE(2286),
    [sym_string] = STATE(1608),
    [sym_simple_expansion] = STATE(1608),
    [sym_string_expansion] = STATE(1608),
    [sym_expansion] = STATE(1608),
    [sym_command_substitution] = STATE(1608),
    [sym_process_substitution] = STATE(1608),
    [aux_sym_command_repeat2] = STATE(2286),
    [aux_sym__literal_repeat1] = STATE(1610),
    [sym__simple_heredoc_body] = ACTIONS(2632),
    [sym__heredoc_body_beginning] = ACTIONS(2632),
    [sym_file_descriptor] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_done] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2634),
    [anon_sym_SEMI_SEMI] = ACTIONS(2632),
    [anon_sym_PIPE_AMP] = ACTIONS(2632),
    [anon_sym_AMP_AMP] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2632),
    [anon_sym_EQ_TILDE] = ACTIONS(6399),
    [anon_sym_EQ_EQ] = ACTIONS(6399),
    [anon_sym_LT] = ACTIONS(2634),
    [anon_sym_GT] = ACTIONS(2634),
    [anon_sym_GT_GT] = ACTIONS(2632),
    [anon_sym_AMP_GT] = ACTIONS(2634),
    [anon_sym_AMP_GT_GT] = ACTIONS(2632),
    [anon_sym_LT_AMP] = ACTIONS(2632),
    [anon_sym_GT_AMP] = ACTIONS(2632),
    [anon_sym_LT_LT] = ACTIONS(2634),
    [anon_sym_LT_LT_DASH] = ACTIONS(2632),
    [anon_sym_LT_LT_LT] = ACTIONS(2632),
    [anon_sym_DOLLAR] = ACTIONS(6402),
    [sym__special_character] = ACTIONS(6405),
    [anon_sym_DQUOTE] = ACTIONS(6408),
    [sym_raw_string] = ACTIONS(6411),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6414),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6417),
    [anon_sym_BQUOTE] = ACTIONS(6420),
    [anon_sym_LT_LPAREN] = ACTIONS(6423),
    [anon_sym_GT_LPAREN] = ACTIONS(6423),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6426),
    [anon_sym_LF] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2634),
  },
  [2287] = {
    [sym_file_descriptor] = ACTIONS(1237),
    [sym_variable_name] = ACTIONS(1237),
    [anon_sym_for] = ACTIONS(1241),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1237),
    [anon_sym_while] = ACTIONS(1241),
    [anon_sym_done] = ACTIONS(6385),
    [anon_sym_if] = ACTIONS(1241),
    [anon_sym_case] = ACTIONS(1241),
    [anon_sym_function] = ACTIONS(1241),
    [anon_sym_LPAREN] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1237),
    [anon_sym_BANG] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(1241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1237),
    [anon_sym_declare] = ACTIONS(1241),
    [anon_sym_typeset] = ACTIONS(1241),
    [anon_sym_export] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_local] = ACTIONS(1241),
    [anon_sym_unset] = ACTIONS(1241),
    [anon_sym_unsetenv] = ACTIONS(1241),
    [anon_sym_LT] = ACTIONS(1241),
    [anon_sym_GT] = ACTIONS(1241),
    [anon_sym_GT_GT] = ACTIONS(1237),
    [anon_sym_AMP_GT] = ACTIONS(1241),
    [anon_sym_AMP_GT_GT] = ACTIONS(1237),
    [anon_sym_LT_AMP] = ACTIONS(1237),
    [anon_sym_GT_AMP] = ACTIONS(1237),
    [anon_sym_DOLLAR] = ACTIONS(1241),
    [sym__special_character] = ACTIONS(1241),
    [anon_sym_DQUOTE] = ACTIONS(1237),
    [sym_raw_string] = ACTIONS(1237),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1237),
    [anon_sym_BQUOTE] = ACTIONS(1237),
    [anon_sym_LT_LPAREN] = ACTIONS(1237),
    [anon_sym_GT_LPAREN] = ACTIONS(1237),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1241),
  },
  [2288] = {
    [anon_sym_SEMI] = ACTIONS(6429),
    [anon_sym_done] = ACTIONS(2606),
    [anon_sym_SEMI_SEMI] = ACTIONS(6431),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6431),
    [anon_sym_AMP] = ACTIONS(6431),
  },
  [2289] = {
    [sym_concatenation] = STATE(2286),
    [sym_string] = STATE(1608),
    [sym_simple_expansion] = STATE(1608),
    [sym_string_expansion] = STATE(1608),
    [sym_expansion] = STATE(1608),
    [sym_command_substitution] = STATE(1608),
    [sym_process_substitution] = STATE(1608),
    [aux_sym_command_repeat2] = STATE(2286),
    [aux_sym__literal_repeat1] = STATE(1610),
    [sym__simple_heredoc_body] = ACTIONS(2696),
    [sym__heredoc_body_beginning] = ACTIONS(2696),
    [sym_file_descriptor] = ACTIONS(2696),
    [anon_sym_SEMI] = ACTIONS(2698),
    [anon_sym_done] = ACTIONS(2698),
    [anon_sym_PIPE] = ACTIONS(2698),
    [anon_sym_SEMI_SEMI] = ACTIONS(2696),
    [anon_sym_PIPE_AMP] = ACTIONS(2696),
    [anon_sym_AMP_AMP] = ACTIONS(2696),
    [anon_sym_PIPE_PIPE] = ACTIONS(2696),
    [anon_sym_EQ_TILDE] = ACTIONS(3313),
    [anon_sym_EQ_EQ] = ACTIONS(3313),
    [anon_sym_LT] = ACTIONS(2698),
    [anon_sym_GT] = ACTIONS(2698),
    [anon_sym_GT_GT] = ACTIONS(2696),
    [anon_sym_AMP_GT] = ACTIONS(2698),
    [anon_sym_AMP_GT_GT] = ACTIONS(2696),
    [anon_sym_LT_AMP] = ACTIONS(2696),
    [anon_sym_GT_AMP] = ACTIONS(2696),
    [anon_sym_LT_LT] = ACTIONS(2698),
    [anon_sym_LT_LT_DASH] = ACTIONS(2696),
    [anon_sym_LT_LT_LT] = ACTIONS(2696),
    [anon_sym_DOLLAR] = ACTIONS(1761),
    [sym__special_character] = ACTIONS(3315),
    [anon_sym_DQUOTE] = ACTIONS(1765),
    [sym_raw_string] = ACTIONS(3317),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1769),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1771),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [anon_sym_LT_LPAREN] = ACTIONS(1775),
    [anon_sym_GT_LPAREN] = ACTIONS(1775),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3319),
    [anon_sym_LF] = ACTIONS(2696),
    [anon_sym_AMP] = ACTIONS(2698),
  },
  [2290] = {
    [sym_string] = STATE(901),
    [sym_simple_expansion] = STATE(901),
    [sym_string_expansion] = STATE(901),
    [sym_expansion] = STATE(901),
    [sym_command_substitution] = STATE(901),
    [sym_process_substitution] = STATE(901),
    [anon_sym_DOLLAR] = ACTIONS(6433),
    [sym__special_character] = ACTIONS(1711),
    [anon_sym_DQUOTE] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(1711),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1711),
  },
  [2291] = {
    [aux_sym_concatenation_repeat1] = STATE(2291),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(3186),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [2292] = {
    [sym__simple_heredoc_body] = ACTIONS(1400),
    [sym__heredoc_body_beginning] = ACTIONS(1400),
    [sym_file_descriptor] = ACTIONS(1400),
    [sym_variable_name] = ACTIONS(1400),
    [anon_sym_SEMI] = ACTIONS(1402),
    [anon_sym_fi] = ACTIONS(1402),
    [anon_sym_elif] = ACTIONS(1402),
    [anon_sym_else] = ACTIONS(1402),
    [anon_sym_PIPE] = ACTIONS(1402),
    [anon_sym_SEMI_SEMI] = ACTIONS(1400),
    [anon_sym_PIPE_AMP] = ACTIONS(1400),
    [anon_sym_AMP_AMP] = ACTIONS(1400),
    [anon_sym_PIPE_PIPE] = ACTIONS(1400),
    [anon_sym_LT] = ACTIONS(1402),
    [anon_sym_GT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT] = ACTIONS(1402),
    [anon_sym_AMP_GT_GT] = ACTIONS(1400),
    [anon_sym_LT_AMP] = ACTIONS(1400),
    [anon_sym_GT_AMP] = ACTIONS(1400),
    [anon_sym_LT_LT] = ACTIONS(1402),
    [anon_sym_LT_LT_DASH] = ACTIONS(1400),
    [anon_sym_LT_LT_LT] = ACTIONS(1400),
    [anon_sym_DOLLAR] = ACTIONS(1402),
    [sym__special_character] = ACTIONS(1400),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1400),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1400),
    [anon_sym_BQUOTE] = ACTIONS(1400),
    [anon_sym_LT_LPAREN] = ACTIONS(1400),
    [anon_sym_GT_LPAREN] = ACTIONS(1400),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1402),
    [anon_sym_LF] = ACTIONS(1400),
    [anon_sym_AMP] = ACTIONS(1402),
  },
  [2293] = {
    [sym_concatenation] = STATE(2911),
    [sym_string] = STATE(730),
    [sym_simple_expansion] = STATE(730),
    [sym_string_expansion] = STATE(730),
    [sym_expansion] = STATE(730),
    [sym_command_substitution] = STATE(730),
    [sym_process_substitution] = STATE(730),
    [aux_sym_for_statement_repeat1] = STATE(2911),
    [aux_sym__literal_repeat1] = STATE(736),
    [anon_sym_RPAREN] = ACTIONS(6435),
    [anon_sym_DOLLAR] = ACTIONS(1406),
    [sym__special_character] = ACTIONS(1408),
    [anon_sym_DQUOTE] = ACTIONS(1410),
    [sym_raw_string] = ACTIONS(1412),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1414),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1416),
    [anon_sym_BQUOTE] = ACTIONS(1418),
    [anon_sym_LT_LPAREN] = ACTIONS(1420),
    [anon_sym_GT_LPAREN] = ACTIONS(1420),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1412),
  },
  [2294] = {
    [sym_string] = STATE(2913),
    [anon_sym_DASH] = ACTIONS(6437),
    [anon_sym_DOLLAR] = ACTIONS(6437),
    [anon_sym_DQUOTE] = ACTIONS(5041),
    [sym_raw_string] = ACTIONS(6439),
    [anon_sym_POUND] = ACTIONS(6437),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6441),
    [anon_sym_STAR] = ACTIONS(6443),
    [anon_sym_AT] = ACTIONS(6443),
    [anon_sym_QMARK] = ACTIONS(6443),
    [anon_sym_0] = ACTIONS(6441),
    [anon_sym__] = ACTIONS(6441),
  },
  [2295] = {
    [aux_sym_concatenation_repeat1] = STATE(2916),
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(6445),
    [sym_variable_name] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_fi] = ACTIONS(339),
    [anon_sym_elif] = ACTIONS(339),
    [anon_sym_else] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [2296] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(2919),
    [anon_sym_DOLLAR] = ACTIONS(6447),
    [anon_sym_DQUOTE] = ACTIONS(6449),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [2297] = {
    [aux_sym_concatenation_repeat1] = STATE(2916),
    [sym__simple_heredoc_body] = ACTIONS(1400),
    [sym__heredoc_body_beginning] = ACTIONS(1400),
    [sym_file_descriptor] = ACTIONS(1400),
    [sym__concat] = ACTIONS(6445),
    [sym_variable_name] = ACTIONS(1400),
    [anon_sym_SEMI] = ACTIONS(1402),
    [anon_sym_fi] = ACTIONS(1402),
    [anon_sym_elif] = ACTIONS(1402),
    [anon_sym_else] = ACTIONS(1402),
    [anon_sym_PIPE] = ACTIONS(1402),
    [anon_sym_SEMI_SEMI] = ACTIONS(1400),
    [anon_sym_PIPE_AMP] = ACTIONS(1400),
    [anon_sym_AMP_AMP] = ACTIONS(1400),
    [anon_sym_PIPE_PIPE] = ACTIONS(1400),
    [anon_sym_LT] = ACTIONS(1402),
    [anon_sym_GT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT] = ACTIONS(1402),
    [anon_sym_AMP_GT_GT] = ACTIONS(1400),
    [anon_sym_LT_AMP] = ACTIONS(1400),
    [anon_sym_GT_AMP] = ACTIONS(1400),
    [anon_sym_LT_LT] = ACTIONS(1402),
    [anon_sym_LT_LT_DASH] = ACTIONS(1400),
    [anon_sym_LT_LT_LT] = ACTIONS(1400),
    [anon_sym_DOLLAR] = ACTIONS(1402),
    [sym__special_character] = ACTIONS(1400),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1400),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1400),
    [anon_sym_BQUOTE] = ACTIONS(1400),
    [anon_sym_LT_LPAREN] = ACTIONS(1400),
    [anon_sym_GT_LPAREN] = ACTIONS(1400),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1402),
    [anon_sym_LF] = ACTIONS(1400),
    [anon_sym_AMP] = ACTIONS(1402),
  },
  [2298] = {
    [sym_subscript] = STATE(2923),
    [sym_variable_name] = ACTIONS(6451),
    [anon_sym_BANG] = ACTIONS(6453),
    [anon_sym_DASH] = ACTIONS(6455),
    [anon_sym_DOLLAR] = ACTIONS(6455),
    [anon_sym_POUND] = ACTIONS(6453),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6457),
    [anon_sym_STAR] = ACTIONS(6459),
    [anon_sym_AT] = ACTIONS(6459),
    [anon_sym_QMARK] = ACTIONS(6459),
    [anon_sym_0] = ACTIONS(6457),
    [anon_sym__] = ACTIONS(6457),
  },
  [2299] = {
    [sym__statements] = STATE(2924),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(2925),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [2300] = {
    [sym__statements] = STATE(2926),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [2301] = {
    [sym__statements] = STATE(2927),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [2302] = {
    [aux_sym__literal_repeat1] = STATE(2929),
    [sym__simple_heredoc_body] = ACTIONS(1446),
    [sym__heredoc_body_beginning] = ACTIONS(1446),
    [sym_file_descriptor] = ACTIONS(1446),
    [sym_variable_name] = ACTIONS(1446),
    [anon_sym_SEMI] = ACTIONS(1448),
    [anon_sym_fi] = ACTIONS(1448),
    [anon_sym_elif] = ACTIONS(1448),
    [anon_sym_else] = ACTIONS(1448),
    [anon_sym_PIPE] = ACTIONS(1448),
    [anon_sym_SEMI_SEMI] = ACTIONS(1446),
    [anon_sym_PIPE_AMP] = ACTIONS(1446),
    [anon_sym_AMP_AMP] = ACTIONS(1446),
    [anon_sym_PIPE_PIPE] = ACTIONS(1446),
    [anon_sym_LT] = ACTIONS(1448),
    [anon_sym_GT] = ACTIONS(1448),
    [anon_sym_GT_GT] = ACTIONS(1446),
    [anon_sym_AMP_GT] = ACTIONS(1448),
    [anon_sym_AMP_GT_GT] = ACTIONS(1446),
    [anon_sym_LT_AMP] = ACTIONS(1446),
    [anon_sym_GT_AMP] = ACTIONS(1446),
    [anon_sym_LT_LT] = ACTIONS(1448),
    [anon_sym_LT_LT_DASH] = ACTIONS(1446),
    [anon_sym_LT_LT_LT] = ACTIONS(1446),
    [anon_sym_DOLLAR] = ACTIONS(1448),
    [sym__special_character] = ACTIONS(6461),
    [anon_sym_DQUOTE] = ACTIONS(1446),
    [sym_raw_string] = ACTIONS(1446),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1446),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1446),
    [anon_sym_BQUOTE] = ACTIONS(1446),
    [anon_sym_LT_LPAREN] = ACTIONS(1446),
    [anon_sym_GT_LPAREN] = ACTIONS(1446),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1448),
    [anon_sym_LF] = ACTIONS(1446),
    [anon_sym_AMP] = ACTIONS(1448),
  },
  [2303] = {
    [sym__statements] = STATE(2930),
    [sym_redirected_statement] = STATE(978),
    [sym_for_statement] = STATE(978),
    [sym_c_style_for_statement] = STATE(978),
    [sym_while_statement] = STATE(978),
    [sym_if_statement] = STATE(978),
    [sym_case_statement] = STATE(978),
    [sym_function_definition] = STATE(978),
    [sym_compound_statement] = STATE(978),
    [sym_subshell] = STATE(978),
    [sym_pipeline] = STATE(978),
    [sym_list] = STATE(978),
    [sym_negated_command] = STATE(978),
    [sym_test_command] = STATE(978),
    [sym_declaration_command] = STATE(978),
    [sym_unset_command] = STATE(978),
    [sym_command] = STATE(978),
    [sym_command_name] = STATE(980),
    [sym_variable_assignment] = STATE(981),
    [sym_subscript] = STATE(982),
    [sym_file_redirect] = STATE(986),
    [sym_concatenation] = STATE(983),
    [sym_string] = STATE(971),
    [sym_simple_expansion] = STATE(971),
    [sym_string_expansion] = STATE(971),
    [sym_expansion] = STATE(971),
    [sym_command_substitution] = STATE(971),
    [sym_process_substitution] = STATE(971),
    [aux_sym__statements_repeat1] = STATE(984),
    [aux_sym_command_repeat1] = STATE(986),
    [aux_sym__literal_repeat1] = STATE(987),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(1804),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_fi] = ACTIONS(6463),
    [anon_sym_elif] = ACTIONS(6463),
    [anon_sym_else] = ACTIONS(6463),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1812),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(1814),
    [anon_sym_typeset] = ACTIONS(1814),
    [anon_sym_export] = ACTIONS(1814),
    [anon_sym_readonly] = ACTIONS(1814),
    [anon_sym_local] = ACTIONS(1814),
    [anon_sym_unset] = ACTIONS(1816),
    [anon_sym_unsetenv] = ACTIONS(1816),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(1818),
    [sym__special_character] = ACTIONS(1820),
    [anon_sym_DQUOTE] = ACTIONS(1822),
    [sym_raw_string] = ACTIONS(1824),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1826),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1828),
    [anon_sym_BQUOTE] = ACTIONS(1830),
    [anon_sym_LT_LPAREN] = ACTIONS(1832),
    [anon_sym_GT_LPAREN] = ACTIONS(1832),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1834),
  },
  [2304] = {
    [sym_concatenation] = STATE(2931),
    [sym_string] = STATE(2936),
    [sym_array] = STATE(2931),
    [sym_simple_expansion] = STATE(2936),
    [sym_string_expansion] = STATE(2936),
    [sym_expansion] = STATE(2936),
    [sym_command_substitution] = STATE(2936),
    [sym_process_substitution] = STATE(2936),
    [aux_sym__literal_repeat1] = STATE(2941),
    [sym__empty_value] = ACTIONS(6465),
    [anon_sym_LPAREN] = ACTIONS(6467),
    [anon_sym_DOLLAR] = ACTIONS(6469),
    [sym__special_character] = ACTIONS(6471),
    [anon_sym_DQUOTE] = ACTIONS(6473),
    [sym_raw_string] = ACTIONS(6475),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6477),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6479),
    [anon_sym_BQUOTE] = ACTIONS(6481),
    [anon_sym_LT_LPAREN] = ACTIONS(6483),
    [anon_sym_GT_LPAREN] = ACTIONS(6483),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6475),
  },
  [2305] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(6485),
    [anon_sym_PLUS_EQ] = ACTIONS(6485),
    [sym_comment] = ACTIONS(57),
  },
  [2306] = {
    [sym_string] = STATE(2944),
    [anon_sym_DASH] = ACTIONS(6487),
    [anon_sym_DOLLAR] = ACTIONS(6487),
    [anon_sym_DQUOTE] = ACTIONS(5063),
    [sym_raw_string] = ACTIONS(6489),
    [anon_sym_POUND] = ACTIONS(6487),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6491),
    [anon_sym_STAR] = ACTIONS(6493),
    [anon_sym_AT] = ACTIONS(6493),
    [anon_sym_QMARK] = ACTIONS(6493),
    [anon_sym_0] = ACTIONS(6491),
    [anon_sym__] = ACTIONS(6491),
  },
  [2307] = {
    [aux_sym_concatenation_repeat1] = STATE(2947),
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(6495),
    [sym_variable_name] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_fi] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(339),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [2308] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(2950),
    [anon_sym_DOLLAR] = ACTIONS(6497),
    [anon_sym_DQUOTE] = ACTIONS(6499),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [2309] = {
    [aux_sym_concatenation_repeat1] = STATE(2947),
    [sym__simple_heredoc_body] = ACTIONS(957),
    [sym__heredoc_body_beginning] = ACTIONS(957),
    [sym_file_descriptor] = ACTIONS(957),
    [sym__concat] = ACTIONS(6495),
    [sym_variable_name] = ACTIONS(957),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_fi] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_SEMI_SEMI] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_LT] = ACTIONS(959),
    [anon_sym_GT] = ACTIONS(959),
    [anon_sym_GT_GT] = ACTIONS(957),
    [anon_sym_AMP_GT] = ACTIONS(959),
    [anon_sym_AMP_GT_GT] = ACTIONS(957),
    [anon_sym_LT_AMP] = ACTIONS(957),
    [anon_sym_GT_AMP] = ACTIONS(957),
    [anon_sym_LT_LT] = ACTIONS(959),
    [anon_sym_LT_LT_DASH] = ACTIONS(957),
    [anon_sym_LT_LT_LT] = ACTIONS(957),
    [anon_sym_DOLLAR] = ACTIONS(959),
    [sym__special_character] = ACTIONS(957),
    [anon_sym_DQUOTE] = ACTIONS(957),
    [sym_raw_string] = ACTIONS(957),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(957),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(957),
    [anon_sym_BQUOTE] = ACTIONS(957),
    [anon_sym_LT_LPAREN] = ACTIONS(957),
    [anon_sym_GT_LPAREN] = ACTIONS(957),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(959),
    [sym_word] = ACTIONS(959),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
  },
  [2310] = {
    [sym_subscript] = STATE(2954),
    [sym_variable_name] = ACTIONS(6501),
    [anon_sym_BANG] = ACTIONS(6503),
    [anon_sym_DASH] = ACTIONS(6505),
    [anon_sym_DOLLAR] = ACTIONS(6505),
    [anon_sym_POUND] = ACTIONS(6503),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6507),
    [anon_sym_STAR] = ACTIONS(6509),
    [anon_sym_AT] = ACTIONS(6509),
    [anon_sym_QMARK] = ACTIONS(6509),
    [anon_sym_0] = ACTIONS(6507),
    [anon_sym__] = ACTIONS(6507),
  },
  [2311] = {
    [sym__statements] = STATE(2955),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(2956),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [2312] = {
    [sym__statements] = STATE(2957),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [2313] = {
    [sym__statements] = STATE(2958),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [2314] = {
    [anon_sym_EQ] = ACTIONS(6485),
    [anon_sym_PLUS_EQ] = ACTIONS(6485),
    [sym_comment] = ACTIONS(57),
  },
  [2315] = {
    [sym_variable_assignment] = STATE(2959),
    [sym_subscript] = STATE(2314),
    [sym_concatenation] = STATE(2959),
    [sym_string] = STATE(2309),
    [sym_simple_expansion] = STATE(2309),
    [sym_string_expansion] = STATE(2309),
    [sym_expansion] = STATE(2309),
    [sym_command_substitution] = STATE(2309),
    [sym_process_substitution] = STATE(2309),
    [aux_sym_declaration_command_repeat1] = STATE(2959),
    [aux_sym__literal_repeat1] = STATE(2316),
    [sym__simple_heredoc_body] = ACTIONS(971),
    [sym__heredoc_body_beginning] = ACTIONS(971),
    [sym_file_descriptor] = ACTIONS(971),
    [sym_variable_name] = ACTIONS(5057),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_fi] = ACTIONS(973),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_SEMI_SEMI] = ACTIONS(971),
    [anon_sym_PIPE_AMP] = ACTIONS(971),
    [anon_sym_AMP_AMP] = ACTIONS(971),
    [anon_sym_PIPE_PIPE] = ACTIONS(971),
    [anon_sym_LT] = ACTIONS(973),
    [anon_sym_GT] = ACTIONS(973),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_AMP_GT] = ACTIONS(973),
    [anon_sym_AMP_GT_GT] = ACTIONS(971),
    [anon_sym_LT_AMP] = ACTIONS(971),
    [anon_sym_GT_AMP] = ACTIONS(971),
    [anon_sym_LT_LT] = ACTIONS(973),
    [anon_sym_LT_LT_DASH] = ACTIONS(971),
    [anon_sym_LT_LT_LT] = ACTIONS(971),
    [anon_sym_DOLLAR] = ACTIONS(5059),
    [sym__special_character] = ACTIONS(5061),
    [anon_sym_DQUOTE] = ACTIONS(5063),
    [sym_raw_string] = ACTIONS(5065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5067),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5069),
    [anon_sym_BQUOTE] = ACTIONS(5071),
    [anon_sym_LT_LPAREN] = ACTIONS(5073),
    [anon_sym_GT_LPAREN] = ACTIONS(5073),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6511),
    [sym_word] = ACTIONS(5077),
    [anon_sym_LF] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(973),
  },
  [2316] = {
    [aux_sym__literal_repeat1] = STATE(2961),
    [sym__simple_heredoc_body] = ACTIONS(977),
    [sym__heredoc_body_beginning] = ACTIONS(977),
    [sym_file_descriptor] = ACTIONS(977),
    [sym_variable_name] = ACTIONS(977),
    [anon_sym_SEMI] = ACTIONS(979),
    [anon_sym_fi] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(979),
    [anon_sym_SEMI_SEMI] = ACTIONS(977),
    [anon_sym_PIPE_AMP] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(977),
    [anon_sym_AMP_GT] = ACTIONS(979),
    [anon_sym_AMP_GT_GT] = ACTIONS(977),
    [anon_sym_LT_AMP] = ACTIONS(977),
    [anon_sym_GT_AMP] = ACTIONS(977),
    [anon_sym_LT_LT] = ACTIONS(979),
    [anon_sym_LT_LT_DASH] = ACTIONS(977),
    [anon_sym_LT_LT_LT] = ACTIONS(977),
    [anon_sym_DOLLAR] = ACTIONS(979),
    [sym__special_character] = ACTIONS(6513),
    [anon_sym_DQUOTE] = ACTIONS(977),
    [sym_raw_string] = ACTIONS(977),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(977),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(977),
    [anon_sym_BQUOTE] = ACTIONS(977),
    [anon_sym_LT_LPAREN] = ACTIONS(977),
    [anon_sym_GT_LPAREN] = ACTIONS(977),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(979),
    [sym_word] = ACTIONS(979),
    [anon_sym_LF] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
  },
  [2317] = {
    [sym_string] = STATE(2963),
    [anon_sym_DASH] = ACTIONS(6515),
    [anon_sym_DOLLAR] = ACTIONS(6515),
    [anon_sym_DQUOTE] = ACTIONS(5083),
    [sym_raw_string] = ACTIONS(6517),
    [anon_sym_POUND] = ACTIONS(6515),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6519),
    [anon_sym_STAR] = ACTIONS(6521),
    [anon_sym_AT] = ACTIONS(6521),
    [anon_sym_QMARK] = ACTIONS(6521),
    [anon_sym_0] = ACTIONS(6519),
    [anon_sym__] = ACTIONS(6519),
  },
  [2318] = {
    [aux_sym_concatenation_repeat1] = STATE(2966),
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(6523),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_fi] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(339),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [2319] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(2969),
    [anon_sym_DOLLAR] = ACTIONS(6525),
    [anon_sym_DQUOTE] = ACTIONS(6527),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [2320] = {
    [aux_sym_concatenation_repeat1] = STATE(2966),
    [sym__simple_heredoc_body] = ACTIONS(997),
    [sym__heredoc_body_beginning] = ACTIONS(997),
    [sym_file_descriptor] = ACTIONS(997),
    [sym__concat] = ACTIONS(6523),
    [anon_sym_SEMI] = ACTIONS(999),
    [anon_sym_fi] = ACTIONS(999),
    [anon_sym_PIPE] = ACTIONS(999),
    [anon_sym_SEMI_SEMI] = ACTIONS(997),
    [anon_sym_PIPE_AMP] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_LT] = ACTIONS(999),
    [anon_sym_GT] = ACTIONS(999),
    [anon_sym_GT_GT] = ACTIONS(997),
    [anon_sym_AMP_GT] = ACTIONS(999),
    [anon_sym_AMP_GT_GT] = ACTIONS(997),
    [anon_sym_LT_AMP] = ACTIONS(997),
    [anon_sym_GT_AMP] = ACTIONS(997),
    [anon_sym_LT_LT] = ACTIONS(999),
    [anon_sym_LT_LT_DASH] = ACTIONS(997),
    [anon_sym_LT_LT_LT] = ACTIONS(997),
    [anon_sym_DOLLAR] = ACTIONS(999),
    [sym__special_character] = ACTIONS(997),
    [anon_sym_DQUOTE] = ACTIONS(997),
    [sym_raw_string] = ACTIONS(997),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(997),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(997),
    [anon_sym_BQUOTE] = ACTIONS(997),
    [anon_sym_LT_LPAREN] = ACTIONS(997),
    [anon_sym_GT_LPAREN] = ACTIONS(997),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(999),
    [sym_word] = ACTIONS(999),
    [anon_sym_LF] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(999),
  },
  [2321] = {
    [sym_subscript] = STATE(2973),
    [sym_variable_name] = ACTIONS(6529),
    [anon_sym_BANG] = ACTIONS(6531),
    [anon_sym_DASH] = ACTIONS(6533),
    [anon_sym_DOLLAR] = ACTIONS(6533),
    [anon_sym_POUND] = ACTIONS(6531),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6535),
    [anon_sym_STAR] = ACTIONS(6537),
    [anon_sym_AT] = ACTIONS(6537),
    [anon_sym_QMARK] = ACTIONS(6537),
    [anon_sym_0] = ACTIONS(6535),
    [anon_sym__] = ACTIONS(6535),
  },
  [2322] = {
    [sym__statements] = STATE(2974),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(2975),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [2323] = {
    [sym__statements] = STATE(2976),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [2324] = {
    [sym__statements] = STATE(2977),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [2325] = {
    [sym_concatenation] = STATE(2978),
    [sym_string] = STATE(2320),
    [sym_simple_expansion] = STATE(2320),
    [sym_string_expansion] = STATE(2320),
    [sym_expansion] = STATE(2320),
    [sym_command_substitution] = STATE(2320),
    [sym_process_substitution] = STATE(2320),
    [aux_sym_unset_command_repeat1] = STATE(2978),
    [aux_sym__literal_repeat1] = STATE(2326),
    [sym__simple_heredoc_body] = ACTIONS(1011),
    [sym__heredoc_body_beginning] = ACTIONS(1011),
    [sym_file_descriptor] = ACTIONS(1011),
    [anon_sym_SEMI] = ACTIONS(1013),
    [anon_sym_fi] = ACTIONS(1013),
    [anon_sym_PIPE] = ACTIONS(1013),
    [anon_sym_SEMI_SEMI] = ACTIONS(1011),
    [anon_sym_PIPE_AMP] = ACTIONS(1011),
    [anon_sym_AMP_AMP] = ACTIONS(1011),
    [anon_sym_PIPE_PIPE] = ACTIONS(1011),
    [anon_sym_LT] = ACTIONS(1013),
    [anon_sym_GT] = ACTIONS(1013),
    [anon_sym_GT_GT] = ACTIONS(1011),
    [anon_sym_AMP_GT] = ACTIONS(1013),
    [anon_sym_AMP_GT_GT] = ACTIONS(1011),
    [anon_sym_LT_AMP] = ACTIONS(1011),
    [anon_sym_GT_AMP] = ACTIONS(1011),
    [anon_sym_LT_LT] = ACTIONS(1013),
    [anon_sym_LT_LT_DASH] = ACTIONS(1011),
    [anon_sym_LT_LT_LT] = ACTIONS(1011),
    [anon_sym_DOLLAR] = ACTIONS(5079),
    [sym__special_character] = ACTIONS(5081),
    [anon_sym_DQUOTE] = ACTIONS(5083),
    [sym_raw_string] = ACTIONS(5085),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5089),
    [anon_sym_BQUOTE] = ACTIONS(5091),
    [anon_sym_LT_LPAREN] = ACTIONS(5093),
    [anon_sym_GT_LPAREN] = ACTIONS(5093),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6539),
    [sym_word] = ACTIONS(5097),
    [anon_sym_LF] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(1013),
  },
  [2326] = {
    [aux_sym__literal_repeat1] = STATE(2980),
    [sym__simple_heredoc_body] = ACTIONS(1017),
    [sym__heredoc_body_beginning] = ACTIONS(1017),
    [sym_file_descriptor] = ACTIONS(1017),
    [anon_sym_SEMI] = ACTIONS(1019),
    [anon_sym_fi] = ACTIONS(1019),
    [anon_sym_PIPE] = ACTIONS(1019),
    [anon_sym_SEMI_SEMI] = ACTIONS(1017),
    [anon_sym_PIPE_AMP] = ACTIONS(1017),
    [anon_sym_AMP_AMP] = ACTIONS(1017),
    [anon_sym_PIPE_PIPE] = ACTIONS(1017),
    [anon_sym_LT] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(1019),
    [anon_sym_GT_GT] = ACTIONS(1017),
    [anon_sym_AMP_GT] = ACTIONS(1019),
    [anon_sym_AMP_GT_GT] = ACTIONS(1017),
    [anon_sym_LT_AMP] = ACTIONS(1017),
    [anon_sym_GT_AMP] = ACTIONS(1017),
    [anon_sym_LT_LT] = ACTIONS(1019),
    [anon_sym_LT_LT_DASH] = ACTIONS(1017),
    [anon_sym_LT_LT_LT] = ACTIONS(1017),
    [anon_sym_DOLLAR] = ACTIONS(1019),
    [sym__special_character] = ACTIONS(6541),
    [anon_sym_DQUOTE] = ACTIONS(1017),
    [sym_raw_string] = ACTIONS(1017),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1017),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1017),
    [anon_sym_BQUOTE] = ACTIONS(1017),
    [anon_sym_LT_LPAREN] = ACTIONS(1017),
    [anon_sym_GT_LPAREN] = ACTIONS(1017),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1019),
    [sym_word] = ACTIONS(1019),
    [anon_sym_LF] = ACTIONS(1017),
    [anon_sym_AMP] = ACTIONS(1019),
  },
  [2327] = {
    [sym__simple_heredoc_body] = ACTIONS(1057),
    [sym__heredoc_body_beginning] = ACTIONS(1057),
    [sym_file_descriptor] = ACTIONS(1057),
    [sym__concat] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_fi] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_PIPE_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_EQ_TILDE] = ACTIONS(1059),
    [anon_sym_EQ_EQ] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_AMP] = ACTIONS(1057),
    [anon_sym_GT_AMP] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_LT] = ACTIONS(1057),
    [anon_sym_DOLLAR] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [sym_raw_string] = ACTIONS(1057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1057),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1057),
    [anon_sym_BQUOTE] = ACTIONS(1057),
    [anon_sym_LT_LPAREN] = ACTIONS(1057),
    [anon_sym_GT_LPAREN] = ACTIONS(1057),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [2328] = {
    [sym__simple_heredoc_body] = ACTIONS(1061),
    [sym__heredoc_body_beginning] = ACTIONS(1061),
    [sym_file_descriptor] = ACTIONS(1061),
    [sym__concat] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(1063),
    [anon_sym_fi] = ACTIONS(1063),
    [anon_sym_PIPE] = ACTIONS(1063),
    [anon_sym_SEMI_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE_AMP] = ACTIONS(1061),
    [anon_sym_AMP_AMP] = ACTIONS(1061),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_EQ_TILDE] = ACTIONS(1063),
    [anon_sym_EQ_EQ] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1063),
    [anon_sym_GT_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT_GT] = ACTIONS(1061),
    [anon_sym_LT_AMP] = ACTIONS(1061),
    [anon_sym_GT_AMP] = ACTIONS(1061),
    [anon_sym_LT_LT] = ACTIONS(1063),
    [anon_sym_LT_LT_DASH] = ACTIONS(1061),
    [anon_sym_LT_LT_LT] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1061),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1061),
    [anon_sym_LT_LPAREN] = ACTIONS(1061),
    [anon_sym_GT_LPAREN] = ACTIONS(1061),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1063),
    [anon_sym_LF] = ACTIONS(1061),
    [anon_sym_AMP] = ACTIONS(1063),
  },
  [2329] = {
    [sym__simple_heredoc_body] = ACTIONS(1065),
    [sym__heredoc_body_beginning] = ACTIONS(1065),
    [sym_file_descriptor] = ACTIONS(1065),
    [sym__concat] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_fi] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1067),
    [anon_sym_SEMI_SEMI] = ACTIONS(1065),
    [anon_sym_PIPE_AMP] = ACTIONS(1065),
    [anon_sym_AMP_AMP] = ACTIONS(1065),
    [anon_sym_PIPE_PIPE] = ACTIONS(1065),
    [anon_sym_EQ_TILDE] = ACTIONS(1067),
    [anon_sym_EQ_EQ] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_GT] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT] = ACTIONS(1067),
    [anon_sym_AMP_GT_GT] = ACTIONS(1065),
    [anon_sym_LT_AMP] = ACTIONS(1065),
    [anon_sym_GT_AMP] = ACTIONS(1065),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_LT_LT_DASH] = ACTIONS(1065),
    [anon_sym_LT_LT_LT] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1067),
    [sym__special_character] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LT_LPAREN] = ACTIONS(1065),
    [anon_sym_GT_LPAREN] = ACTIONS(1065),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1067),
    [anon_sym_LF] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1067),
  },
  [2330] = {
    [sym_string] = STATE(2981),
    [sym_simple_expansion] = STATE(2981),
    [sym_string_expansion] = STATE(2981),
    [sym_expansion] = STATE(2981),
    [sym_command_substitution] = STATE(2981),
    [sym_process_substitution] = STATE(2981),
    [anon_sym_DOLLAR] = ACTIONS(3391),
    [sym__special_character] = ACTIONS(6543),
    [anon_sym_DQUOTE] = ACTIONS(3395),
    [sym_raw_string] = ACTIONS(6543),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3401),
    [anon_sym_BQUOTE] = ACTIONS(3403),
    [anon_sym_LT_LPAREN] = ACTIONS(3405),
    [anon_sym_GT_LPAREN] = ACTIONS(3405),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6543),
  },
  [2331] = {
    [aux_sym_concatenation_repeat1] = STATE(2983),
    [sym__simple_heredoc_body] = ACTIONS(1071),
    [sym__heredoc_body_beginning] = ACTIONS(1071),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(6545),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_fi] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_EQ_TILDE] = ACTIONS(1075),
    [anon_sym_EQ_EQ] = ACTIONS(1075),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [sym__special_character] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1075),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1075),
  },
  [2332] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(6547),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [2333] = {
    [sym__simple_heredoc_body] = ACTIONS(1089),
    [sym__heredoc_body_beginning] = ACTIONS(1089),
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(1089),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_fi] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1089),
    [anon_sym_PIPE_AMP] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_AMP] = ACTIONS(1089),
    [anon_sym_GT_AMP] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1089),
    [anon_sym_LT_LT_LT] = ACTIONS(1089),
    [anon_sym_DOLLAR] = ACTIONS(1091),
    [sym__special_character] = ACTIONS(1089),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1089),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1089),
    [anon_sym_GT_LPAREN] = ACTIONS(1089),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [2334] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(627),
    [anon_sym_DOLLAR] = ACTIONS(6549),
    [anon_sym_DQUOTE] = ACTIONS(6547),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [2335] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(6551),
    [sym_comment] = ACTIONS(57),
  },
  [2336] = {
    [sym_subscript] = STATE(2989),
    [sym_variable_name] = ACTIONS(6553),
    [anon_sym_DASH] = ACTIONS(6555),
    [anon_sym_DOLLAR] = ACTIONS(6555),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6557),
    [anon_sym_STAR] = ACTIONS(6559),
    [anon_sym_AT] = ACTIONS(6559),
    [anon_sym_QMARK] = ACTIONS(6559),
    [anon_sym_0] = ACTIONS(6557),
    [anon_sym__] = ACTIONS(6557),
  },
  [2337] = {
    [sym_concatenation] = STATE(2992),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2992),
    [anon_sym_RBRACE] = ACTIONS(6561),
    [anon_sym_EQ] = ACTIONS(6563),
    [anon_sym_DASH] = ACTIONS(6563),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(6565),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(6567),
    [anon_sym_COLON] = ACTIONS(6563),
    [anon_sym_COLON_QMARK] = ACTIONS(6563),
    [anon_sym_COLON_DASH] = ACTIONS(6563),
    [anon_sym_PERCENT] = ACTIONS(6563),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2338] = {
    [sym_concatenation] = STATE(2995),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(2995),
    [anon_sym_RBRACE] = ACTIONS(6569),
    [anon_sym_EQ] = ACTIONS(6571),
    [anon_sym_DASH] = ACTIONS(6571),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(6573),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(6575),
    [anon_sym_COLON] = ACTIONS(6571),
    [anon_sym_COLON_QMARK] = ACTIONS(6571),
    [anon_sym_COLON_DASH] = ACTIONS(6571),
    [anon_sym_PERCENT] = ACTIONS(6571),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2339] = {
    [anon_sym_RPAREN] = ACTIONS(6577),
    [sym_comment] = ACTIONS(57),
  },
  [2340] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(6577),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [2341] = {
    [anon_sym_BQUOTE] = ACTIONS(6577),
    [sym_comment] = ACTIONS(57),
  },
  [2342] = {
    [anon_sym_RPAREN] = ACTIONS(6579),
    [sym_comment] = ACTIONS(57),
  },
  [2343] = {
    [anon_sym_LT] = ACTIONS(6581),
    [anon_sym_GT] = ACTIONS(6581),
    [anon_sym_GT_GT] = ACTIONS(6583),
    [anon_sym_AMP_GT] = ACTIONS(6581),
    [anon_sym_AMP_GT_GT] = ACTIONS(6583),
    [anon_sym_LT_AMP] = ACTIONS(6583),
    [anon_sym_GT_AMP] = ACTIONS(6583),
    [sym_comment] = ACTIONS(57),
  },
  [2344] = {
    [sym_file_descriptor] = ACTIONS(1237),
    [sym_variable_name] = ACTIONS(1237),
    [anon_sym_for] = ACTIONS(1241),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1237),
    [anon_sym_while] = ACTIONS(1241),
    [anon_sym_if] = ACTIONS(1241),
    [anon_sym_fi] = ACTIONS(4996),
    [anon_sym_case] = ACTIONS(1241),
    [anon_sym_function] = ACTIONS(1241),
    [anon_sym_LPAREN] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1237),
    [anon_sym_BANG] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(1241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1237),
    [anon_sym_declare] = ACTIONS(1241),
    [anon_sym_typeset] = ACTIONS(1241),
    [anon_sym_export] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_local] = ACTIONS(1241),
    [anon_sym_unset] = ACTIONS(1241),
    [anon_sym_unsetenv] = ACTIONS(1241),
    [anon_sym_LT] = ACTIONS(1241),
    [anon_sym_GT] = ACTIONS(1241),
    [anon_sym_GT_GT] = ACTIONS(1237),
    [anon_sym_AMP_GT] = ACTIONS(1241),
    [anon_sym_AMP_GT_GT] = ACTIONS(1237),
    [anon_sym_LT_AMP] = ACTIONS(1237),
    [anon_sym_GT_AMP] = ACTIONS(1237),
    [anon_sym_DOLLAR] = ACTIONS(1241),
    [sym__special_character] = ACTIONS(1241),
    [anon_sym_DQUOTE] = ACTIONS(1237),
    [sym_raw_string] = ACTIONS(1237),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1237),
    [anon_sym_BQUOTE] = ACTIONS(1237),
    [anon_sym_LT_LPAREN] = ACTIONS(1237),
    [anon_sym_GT_LPAREN] = ACTIONS(1237),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1241),
  },
  [2345] = {
    [sym_redirected_statement] = STATE(2999),
    [sym_for_statement] = STATE(2999),
    [sym_c_style_for_statement] = STATE(2999),
    [sym_while_statement] = STATE(2999),
    [sym_if_statement] = STATE(2999),
    [sym_case_statement] = STATE(2999),
    [sym_function_definition] = STATE(2999),
    [sym_compound_statement] = STATE(2999),
    [sym_subshell] = STATE(2999),
    [sym_pipeline] = STATE(2999),
    [sym_list] = STATE(2999),
    [sym_negated_command] = STATE(2999),
    [sym_test_command] = STATE(2999),
    [sym_declaration_command] = STATE(2999),
    [sym_unset_command] = STATE(2999),
    [sym_command] = STATE(2999),
    [sym_command_name] = STATE(1638),
    [sym_variable_assignment] = STATE(3000),
    [sym_subscript] = STATE(1640),
    [sym_file_redirect] = STATE(1643),
    [sym_concatenation] = STATE(1641),
    [sym_string] = STATE(1630),
    [sym_simple_expansion] = STATE(1630),
    [sym_string_expansion] = STATE(1630),
    [sym_expansion] = STATE(1630),
    [sym_command_substitution] = STATE(1630),
    [sym_process_substitution] = STATE(1630),
    [aux_sym_command_repeat1] = STATE(1643),
    [aux_sym__literal_repeat1] = STATE(1644),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(3381),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(3385),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(3387),
    [anon_sym_typeset] = ACTIONS(3387),
    [anon_sym_export] = ACTIONS(3387),
    [anon_sym_readonly] = ACTIONS(3387),
    [anon_sym_local] = ACTIONS(3387),
    [anon_sym_unset] = ACTIONS(3389),
    [anon_sym_unsetenv] = ACTIONS(3389),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(3391),
    [sym__special_character] = ACTIONS(3393),
    [anon_sym_DQUOTE] = ACTIONS(3395),
    [sym_raw_string] = ACTIONS(3397),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3401),
    [anon_sym_BQUOTE] = ACTIONS(3403),
    [anon_sym_LT_LPAREN] = ACTIONS(3405),
    [anon_sym_GT_LPAREN] = ACTIONS(3405),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3407),
  },
  [2346] = {
    [sym_redirected_statement] = STATE(3001),
    [sym_for_statement] = STATE(3001),
    [sym_c_style_for_statement] = STATE(3001),
    [sym_while_statement] = STATE(3001),
    [sym_if_statement] = STATE(3001),
    [sym_case_statement] = STATE(3001),
    [sym_function_definition] = STATE(3001),
    [sym_compound_statement] = STATE(3001),
    [sym_subshell] = STATE(3001),
    [sym_pipeline] = STATE(3001),
    [sym_list] = STATE(3001),
    [sym_negated_command] = STATE(3001),
    [sym_test_command] = STATE(3001),
    [sym_declaration_command] = STATE(3001),
    [sym_unset_command] = STATE(3001),
    [sym_command] = STATE(3001),
    [sym_command_name] = STATE(1638),
    [sym_variable_assignment] = STATE(3002),
    [sym_subscript] = STATE(1640),
    [sym_file_redirect] = STATE(1643),
    [sym_concatenation] = STATE(1641),
    [sym_string] = STATE(1630),
    [sym_simple_expansion] = STATE(1630),
    [sym_string_expansion] = STATE(1630),
    [sym_expansion] = STATE(1630),
    [sym_command_substitution] = STATE(1630),
    [sym_process_substitution] = STATE(1630),
    [aux_sym_command_repeat1] = STATE(1643),
    [aux_sym__literal_repeat1] = STATE(1644),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(3381),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(3385),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(3387),
    [anon_sym_typeset] = ACTIONS(3387),
    [anon_sym_export] = ACTIONS(3387),
    [anon_sym_readonly] = ACTIONS(3387),
    [anon_sym_local] = ACTIONS(3387),
    [anon_sym_unset] = ACTIONS(3389),
    [anon_sym_unsetenv] = ACTIONS(3389),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(3391),
    [sym__special_character] = ACTIONS(3393),
    [anon_sym_DQUOTE] = ACTIONS(3395),
    [sym_raw_string] = ACTIONS(3397),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3401),
    [anon_sym_BQUOTE] = ACTIONS(3403),
    [anon_sym_LT_LPAREN] = ACTIONS(3405),
    [anon_sym_GT_LPAREN] = ACTIONS(3405),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3407),
  },
  [2347] = {
    [sym_concatenation] = STATE(696),
    [sym_string] = STATE(3004),
    [sym_simple_expansion] = STATE(3004),
    [sym_string_expansion] = STATE(3004),
    [sym_expansion] = STATE(3004),
    [sym_command_substitution] = STATE(3004),
    [sym_process_substitution] = STATE(3004),
    [aux_sym__literal_repeat1] = STATE(3005),
    [anon_sym_DOLLAR] = ACTIONS(4998),
    [sym__special_character] = ACTIONS(6585),
    [anon_sym_DQUOTE] = ACTIONS(5002),
    [sym_raw_string] = ACTIONS(6587),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5006),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5008),
    [anon_sym_BQUOTE] = ACTIONS(5010),
    [anon_sym_LT_LPAREN] = ACTIONS(5012),
    [anon_sym_GT_LPAREN] = ACTIONS(5012),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6587),
  },
  [2348] = {
    [sym_concatenation] = STATE(700),
    [sym_string] = STATE(3006),
    [sym_simple_expansion] = STATE(3006),
    [sym_string_expansion] = STATE(3006),
    [sym_expansion] = STATE(3006),
    [sym_command_substitution] = STATE(3006),
    [sym_process_substitution] = STATE(3006),
    [aux_sym__literal_repeat1] = STATE(3007),
    [anon_sym_DOLLAR] = ACTIONS(4998),
    [sym__special_character] = ACTIONS(6585),
    [anon_sym_DQUOTE] = ACTIONS(5002),
    [sym_raw_string] = ACTIONS(6589),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5006),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5008),
    [anon_sym_BQUOTE] = ACTIONS(5010),
    [anon_sym_LT_LPAREN] = ACTIONS(5012),
    [anon_sym_GT_LPAREN] = ACTIONS(5012),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6589),
  },
  [2349] = {
    [anon_sym_SEMI] = ACTIONS(6591),
    [anon_sym_fi] = ACTIONS(1239),
    [anon_sym_SEMI_SEMI] = ACTIONS(6593),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6593),
    [anon_sym_AMP] = ACTIONS(6593),
  },
  [2350] = {
    [sym_file_redirect] = STATE(3009),
    [sym_heredoc_redirect] = STATE(3009),
    [sym_herestring_redirect] = STATE(3009),
    [aux_sym_redirected_statement_repeat1] = STATE(3009),
    [sym__simple_heredoc_body] = ACTIONS(1255),
    [sym__heredoc_body_beginning] = ACTIONS(1255),
    [sym_file_descriptor] = ACTIONS(5125),
    [anon_sym_SEMI] = ACTIONS(1257),
    [anon_sym_fi] = ACTIONS(1255),
    [anon_sym_PIPE] = ACTIONS(1257),
    [anon_sym_SEMI_SEMI] = ACTIONS(1255),
    [anon_sym_PIPE_AMP] = ACTIONS(1255),
    [anon_sym_AMP_AMP] = ACTIONS(1255),
    [anon_sym_PIPE_PIPE] = ACTIONS(1255),
    [anon_sym_LT] = ACTIONS(5137),
    [anon_sym_GT] = ACTIONS(5137),
    [anon_sym_GT_GT] = ACTIONS(5139),
    [anon_sym_AMP_GT] = ACTIONS(5137),
    [anon_sym_AMP_GT_GT] = ACTIONS(5139),
    [anon_sym_LT_AMP] = ACTIONS(5139),
    [anon_sym_GT_AMP] = ACTIONS(5139),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(5141),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1257),
  },
  [2351] = {
    [sym_concatenation] = STATE(3010),
    [sym_string] = STATE(3011),
    [sym_simple_expansion] = STATE(3011),
    [sym_string_expansion] = STATE(3011),
    [sym_expansion] = STATE(3011),
    [sym_command_substitution] = STATE(3011),
    [sym_process_substitution] = STATE(3011),
    [aux_sym__literal_repeat1] = STATE(3012),
    [sym_regex] = ACTIONS(6595),
    [anon_sym_DOLLAR] = ACTIONS(3391),
    [sym__special_character] = ACTIONS(5145),
    [anon_sym_DQUOTE] = ACTIONS(3395),
    [sym_raw_string] = ACTIONS(6597),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3401),
    [anon_sym_BQUOTE] = ACTIONS(3403),
    [anon_sym_LT_LPAREN] = ACTIONS(3405),
    [anon_sym_GT_LPAREN] = ACTIONS(3405),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6597),
  },
  [2352] = {
    [aux_sym_concatenation_repeat1] = STATE(2331),
    [sym__simple_heredoc_body] = ACTIONS(1263),
    [sym__heredoc_body_beginning] = ACTIONS(1263),
    [sym_file_descriptor] = ACTIONS(1263),
    [sym__concat] = ACTIONS(5107),
    [anon_sym_SEMI] = ACTIONS(1265),
    [anon_sym_fi] = ACTIONS(1265),
    [anon_sym_PIPE] = ACTIONS(1265),
    [anon_sym_SEMI_SEMI] = ACTIONS(1263),
    [anon_sym_PIPE_AMP] = ACTIONS(1263),
    [anon_sym_AMP_AMP] = ACTIONS(1263),
    [anon_sym_PIPE_PIPE] = ACTIONS(1263),
    [anon_sym_EQ_TILDE] = ACTIONS(1265),
    [anon_sym_EQ_EQ] = ACTIONS(1265),
    [anon_sym_LT] = ACTIONS(1265),
    [anon_sym_GT] = ACTIONS(1265),
    [anon_sym_GT_GT] = ACTIONS(1263),
    [anon_sym_AMP_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT_GT] = ACTIONS(1263),
    [anon_sym_LT_AMP] = ACTIONS(1263),
    [anon_sym_GT_AMP] = ACTIONS(1263),
    [anon_sym_LT_LT] = ACTIONS(1265),
    [anon_sym_LT_LT_DASH] = ACTIONS(1263),
    [anon_sym_LT_LT_LT] = ACTIONS(1263),
    [anon_sym_DOLLAR] = ACTIONS(1265),
    [sym__special_character] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(1263),
    [sym_raw_string] = ACTIONS(1263),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1263),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1263),
    [anon_sym_BQUOTE] = ACTIONS(1263),
    [anon_sym_LT_LPAREN] = ACTIONS(1263),
    [anon_sym_GT_LPAREN] = ACTIONS(1263),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1265),
    [anon_sym_LF] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1265),
  },
  [2353] = {
    [sym_concatenation] = STATE(3013),
    [sym_string] = STATE(2352),
    [sym_simple_expansion] = STATE(2352),
    [sym_string_expansion] = STATE(2352),
    [sym_expansion] = STATE(2352),
    [sym_command_substitution] = STATE(2352),
    [sym_process_substitution] = STATE(2352),
    [aux_sym_command_repeat2] = STATE(3013),
    [aux_sym__literal_repeat1] = STATE(2354),
    [sym__simple_heredoc_body] = ACTIONS(1267),
    [sym__heredoc_body_beginning] = ACTIONS(1267),
    [sym_file_descriptor] = ACTIONS(1267),
    [anon_sym_SEMI] = ACTIONS(1269),
    [anon_sym_fi] = ACTIONS(1269),
    [anon_sym_PIPE] = ACTIONS(1269),
    [anon_sym_SEMI_SEMI] = ACTIONS(1267),
    [anon_sym_PIPE_AMP] = ACTIONS(1267),
    [anon_sym_AMP_AMP] = ACTIONS(1267),
    [anon_sym_PIPE_PIPE] = ACTIONS(1267),
    [anon_sym_EQ_TILDE] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_LT] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1269),
    [anon_sym_GT_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT_GT] = ACTIONS(1267),
    [anon_sym_LT_AMP] = ACTIONS(1267),
    [anon_sym_GT_AMP] = ACTIONS(1267),
    [anon_sym_LT_LT] = ACTIONS(1269),
    [anon_sym_LT_LT_DASH] = ACTIONS(1267),
    [anon_sym_LT_LT_LT] = ACTIONS(1267),
    [anon_sym_DOLLAR] = ACTIONS(3391),
    [sym__special_character] = ACTIONS(5145),
    [anon_sym_DQUOTE] = ACTIONS(3395),
    [sym_raw_string] = ACTIONS(5147),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3401),
    [anon_sym_BQUOTE] = ACTIONS(3403),
    [anon_sym_LT_LPAREN] = ACTIONS(3405),
    [anon_sym_GT_LPAREN] = ACTIONS(3405),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5149),
    [anon_sym_LF] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(1269),
  },
  [2354] = {
    [aux_sym__literal_repeat1] = STATE(2359),
    [sym__simple_heredoc_body] = ACTIONS(1271),
    [sym__heredoc_body_beginning] = ACTIONS(1271),
    [sym_file_descriptor] = ACTIONS(1271),
    [anon_sym_SEMI] = ACTIONS(1273),
    [anon_sym_fi] = ACTIONS(1273),
    [anon_sym_PIPE] = ACTIONS(1273),
    [anon_sym_SEMI_SEMI] = ACTIONS(1271),
    [anon_sym_PIPE_AMP] = ACTIONS(1271),
    [anon_sym_AMP_AMP] = ACTIONS(1271),
    [anon_sym_PIPE_PIPE] = ACTIONS(1271),
    [anon_sym_EQ_TILDE] = ACTIONS(1273),
    [anon_sym_EQ_EQ] = ACTIONS(1273),
    [anon_sym_LT] = ACTIONS(1273),
    [anon_sym_GT] = ACTIONS(1273),
    [anon_sym_GT_GT] = ACTIONS(1271),
    [anon_sym_AMP_GT] = ACTIONS(1273),
    [anon_sym_AMP_GT_GT] = ACTIONS(1271),
    [anon_sym_LT_AMP] = ACTIONS(1271),
    [anon_sym_GT_AMP] = ACTIONS(1271),
    [anon_sym_LT_LT] = ACTIONS(1273),
    [anon_sym_LT_LT_DASH] = ACTIONS(1271),
    [anon_sym_LT_LT_LT] = ACTIONS(1271),
    [anon_sym_DOLLAR] = ACTIONS(1273),
    [sym__special_character] = ACTIONS(5151),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [sym_raw_string] = ACTIONS(1271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1271),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1271),
    [anon_sym_BQUOTE] = ACTIONS(1271),
    [anon_sym_LT_LPAREN] = ACTIONS(1271),
    [anon_sym_GT_LPAREN] = ACTIONS(1271),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1273),
    [anon_sym_LF] = ACTIONS(1271),
    [anon_sym_AMP] = ACTIONS(1273),
  },
  [2355] = {
    [sym_file_redirect] = STATE(2350),
    [sym_heredoc_redirect] = STATE(2350),
    [sym_heredoc_body] = STATE(3015),
    [sym_herestring_redirect] = STATE(2350),
    [aux_sym_redirected_statement_repeat1] = STATE(2350),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(5125),
    [anon_sym_SEMI] = ACTIONS(6599),
    [anon_sym_fi] = ACTIONS(1239),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_SEMI_SEMI] = ACTIONS(6601),
    [anon_sym_PIPE_AMP] = ACTIONS(5133),
    [anon_sym_AMP_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5135),
    [anon_sym_LT] = ACTIONS(5137),
    [anon_sym_GT] = ACTIONS(5137),
    [anon_sym_GT_GT] = ACTIONS(5139),
    [anon_sym_AMP_GT] = ACTIONS(5137),
    [anon_sym_AMP_GT_GT] = ACTIONS(5139),
    [anon_sym_LT_AMP] = ACTIONS(5139),
    [anon_sym_GT_AMP] = ACTIONS(5139),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(5141),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6601),
    [anon_sym_AMP] = ACTIONS(6599),
  },
  [2356] = {
    [sym_file_redirect] = STATE(2350),
    [sym_heredoc_redirect] = STATE(2350),
    [sym_heredoc_body] = STATE(3015),
    [sym_herestring_redirect] = STATE(2350),
    [aux_sym_redirected_statement_repeat1] = STATE(2350),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(6599),
    [anon_sym_fi] = ACTIONS(4996),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_SEMI_SEMI] = ACTIONS(6601),
    [anon_sym_PIPE_AMP] = ACTIONS(5133),
    [anon_sym_AMP_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5135),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(5141),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(6601),
    [anon_sym_AMP] = ACTIONS(6599),
  },
  [2357] = {
    [sym_concatenation] = STATE(3016),
    [sym_string] = STATE(2352),
    [sym_simple_expansion] = STATE(2352),
    [sym_string_expansion] = STATE(2352),
    [sym_expansion] = STATE(2352),
    [sym_command_substitution] = STATE(2352),
    [sym_process_substitution] = STATE(2352),
    [aux_sym_command_repeat2] = STATE(3016),
    [aux_sym__literal_repeat1] = STATE(2354),
    [sym__simple_heredoc_body] = ACTIONS(1267),
    [sym__heredoc_body_beginning] = ACTIONS(1267),
    [sym_file_descriptor] = ACTIONS(1267),
    [anon_sym_SEMI] = ACTIONS(1269),
    [anon_sym_fi] = ACTIONS(1269),
    [anon_sym_PIPE] = ACTIONS(1269),
    [anon_sym_SEMI_SEMI] = ACTIONS(1267),
    [anon_sym_PIPE_AMP] = ACTIONS(1267),
    [anon_sym_AMP_AMP] = ACTIONS(1267),
    [anon_sym_PIPE_PIPE] = ACTIONS(1267),
    [anon_sym_EQ_TILDE] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_LT] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1269),
    [anon_sym_GT_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT_GT] = ACTIONS(1267),
    [anon_sym_LT_AMP] = ACTIONS(1267),
    [anon_sym_GT_AMP] = ACTIONS(1267),
    [anon_sym_LT_LT] = ACTIONS(1269),
    [anon_sym_LT_LT_DASH] = ACTIONS(1267),
    [anon_sym_LT_LT_LT] = ACTIONS(1267),
    [anon_sym_DOLLAR] = ACTIONS(3391),
    [sym__special_character] = ACTIONS(5145),
    [anon_sym_DQUOTE] = ACTIONS(3395),
    [sym_raw_string] = ACTIONS(5147),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3401),
    [anon_sym_BQUOTE] = ACTIONS(3403),
    [anon_sym_LT_LPAREN] = ACTIONS(3405),
    [anon_sym_GT_LPAREN] = ACTIONS(3405),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5149),
    [anon_sym_LF] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(1269),
  },
  [2358] = {
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_fi] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_EQ_TILDE] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [2359] = {
    [aux_sym__literal_repeat1] = STATE(2359),
    [sym__simple_heredoc_body] = ACTIONS(1373),
    [sym__heredoc_body_beginning] = ACTIONS(1373),
    [sym_file_descriptor] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_fi] = ACTIONS(1375),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE_AMP] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_EQ_TILDE] = ACTIONS(1375),
    [anon_sym_EQ_EQ] = ACTIONS(1375),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_LT_LT_DASH] = ACTIONS(1373),
    [anon_sym_LT_LT_LT] = ACTIONS(1373),
    [anon_sym_DOLLAR] = ACTIONS(1375),
    [sym__special_character] = ACTIONS(6603),
    [anon_sym_DQUOTE] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1373),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [anon_sym_LT_LPAREN] = ACTIONS(1373),
    [anon_sym_GT_LPAREN] = ACTIONS(1373),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1375),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
  },
  [2360] = {
    [sym_concatenation] = STATE(3017),
    [sym_string] = STATE(3019),
    [sym_array] = STATE(3017),
    [sym_simple_expansion] = STATE(3019),
    [sym_string_expansion] = STATE(3019),
    [sym_expansion] = STATE(3019),
    [sym_command_substitution] = STATE(3019),
    [sym_process_substitution] = STATE(3019),
    [aux_sym__literal_repeat1] = STATE(3020),
    [sym__empty_value] = ACTIONS(6606),
    [anon_sym_LPAREN] = ACTIONS(6608),
    [anon_sym_DOLLAR] = ACTIONS(3411),
    [sym__special_character] = ACTIONS(3413),
    [anon_sym_DQUOTE] = ACTIONS(3415),
    [sym_raw_string] = ACTIONS(6610),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3419),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3421),
    [anon_sym_BQUOTE] = ACTIONS(3423),
    [anon_sym_LT_LPAREN] = ACTIONS(3425),
    [anon_sym_GT_LPAREN] = ACTIONS(3425),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6610),
  },
  [2361] = {
    [sym__simple_heredoc_body] = ACTIONS(1057),
    [sym__heredoc_body_beginning] = ACTIONS(1057),
    [sym_file_descriptor] = ACTIONS(1057),
    [sym__concat] = ACTIONS(1057),
    [sym_variable_name] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_fi] = ACTIONS(1059),
    [anon_sym_elif] = ACTIONS(1059),
    [anon_sym_else] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_PIPE_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_AMP] = ACTIONS(1057),
    [anon_sym_GT_AMP] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_LT] = ACTIONS(1057),
    [anon_sym_DOLLAR] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [sym_raw_string] = ACTIONS(1057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1057),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1057),
    [anon_sym_BQUOTE] = ACTIONS(1057),
    [anon_sym_LT_LPAREN] = ACTIONS(1057),
    [anon_sym_GT_LPAREN] = ACTIONS(1057),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1059),
    [sym_word] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [2362] = {
    [sym__simple_heredoc_body] = ACTIONS(1061),
    [sym__heredoc_body_beginning] = ACTIONS(1061),
    [sym_file_descriptor] = ACTIONS(1061),
    [sym__concat] = ACTIONS(1061),
    [sym_variable_name] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(1063),
    [anon_sym_fi] = ACTIONS(1063),
    [anon_sym_elif] = ACTIONS(1063),
    [anon_sym_else] = ACTIONS(1063),
    [anon_sym_PIPE] = ACTIONS(1063),
    [anon_sym_SEMI_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE_AMP] = ACTIONS(1061),
    [anon_sym_AMP_AMP] = ACTIONS(1061),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1063),
    [anon_sym_GT_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT_GT] = ACTIONS(1061),
    [anon_sym_LT_AMP] = ACTIONS(1061),
    [anon_sym_GT_AMP] = ACTIONS(1061),
    [anon_sym_LT_LT] = ACTIONS(1063),
    [anon_sym_LT_LT_DASH] = ACTIONS(1061),
    [anon_sym_LT_LT_LT] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1061),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1061),
    [anon_sym_LT_LPAREN] = ACTIONS(1061),
    [anon_sym_GT_LPAREN] = ACTIONS(1061),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1063),
    [sym_word] = ACTIONS(1063),
    [anon_sym_LF] = ACTIONS(1061),
    [anon_sym_AMP] = ACTIONS(1063),
  },
  [2363] = {
    [sym__simple_heredoc_body] = ACTIONS(1065),
    [sym__heredoc_body_beginning] = ACTIONS(1065),
    [sym_file_descriptor] = ACTIONS(1065),
    [sym__concat] = ACTIONS(1065),
    [sym_variable_name] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_fi] = ACTIONS(1067),
    [anon_sym_elif] = ACTIONS(1067),
    [anon_sym_else] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1067),
    [anon_sym_SEMI_SEMI] = ACTIONS(1065),
    [anon_sym_PIPE_AMP] = ACTIONS(1065),
    [anon_sym_AMP_AMP] = ACTIONS(1065),
    [anon_sym_PIPE_PIPE] = ACTIONS(1065),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_GT] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT] = ACTIONS(1067),
    [anon_sym_AMP_GT_GT] = ACTIONS(1065),
    [anon_sym_LT_AMP] = ACTIONS(1065),
    [anon_sym_GT_AMP] = ACTIONS(1065),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_LT_LT_DASH] = ACTIONS(1065),
    [anon_sym_LT_LT_LT] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1067),
    [sym__special_character] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LT_LPAREN] = ACTIONS(1065),
    [anon_sym_GT_LPAREN] = ACTIONS(1065),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1067),
    [sym_word] = ACTIONS(1067),
    [anon_sym_LF] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1067),
  },
  [2364] = {
    [sym_string] = STATE(3021),
    [sym_simple_expansion] = STATE(3021),
    [sym_string_expansion] = STATE(3021),
    [sym_expansion] = STATE(3021),
    [sym_command_substitution] = STATE(3021),
    [sym_process_substitution] = STATE(3021),
    [anon_sym_DOLLAR] = ACTIONS(3411),
    [sym__special_character] = ACTIONS(6612),
    [anon_sym_DQUOTE] = ACTIONS(3415),
    [sym_raw_string] = ACTIONS(6612),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3419),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3421),
    [anon_sym_BQUOTE] = ACTIONS(3423),
    [anon_sym_LT_LPAREN] = ACTIONS(3425),
    [anon_sym_GT_LPAREN] = ACTIONS(3425),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6612),
  },
  [2365] = {
    [aux_sym_concatenation_repeat1] = STATE(3023),
    [sym__simple_heredoc_body] = ACTIONS(1071),
    [sym__heredoc_body_beginning] = ACTIONS(1071),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(6614),
    [sym_variable_name] = ACTIONS(1071),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_fi] = ACTIONS(1075),
    [anon_sym_elif] = ACTIONS(1075),
    [anon_sym_else] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [sym__special_character] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [sym_word] = ACTIONS(1075),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1075),
  },
  [2366] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(6616),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [2367] = {
    [sym__simple_heredoc_body] = ACTIONS(1089),
    [sym__heredoc_body_beginning] = ACTIONS(1089),
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(1089),
    [sym_variable_name] = ACTIONS(1089),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_fi] = ACTIONS(1091),
    [anon_sym_elif] = ACTIONS(1091),
    [anon_sym_else] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1089),
    [anon_sym_PIPE_AMP] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_AMP] = ACTIONS(1089),
    [anon_sym_GT_AMP] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1089),
    [anon_sym_LT_LT_LT] = ACTIONS(1089),
    [anon_sym_DOLLAR] = ACTIONS(1091),
    [sym__special_character] = ACTIONS(1089),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1089),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1089),
    [anon_sym_GT_LPAREN] = ACTIONS(1089),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1091),
    [sym_word] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [2368] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(627),
    [anon_sym_DOLLAR] = ACTIONS(6618),
    [anon_sym_DQUOTE] = ACTIONS(6616),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [2369] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(6620),
    [sym_comment] = ACTIONS(57),
  },
  [2370] = {
    [sym_subscript] = STATE(3029),
    [sym_variable_name] = ACTIONS(6622),
    [anon_sym_DASH] = ACTIONS(6624),
    [anon_sym_DOLLAR] = ACTIONS(6624),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6626),
    [anon_sym_STAR] = ACTIONS(6628),
    [anon_sym_AT] = ACTIONS(6628),
    [anon_sym_QMARK] = ACTIONS(6628),
    [anon_sym_0] = ACTIONS(6626),
    [anon_sym__] = ACTIONS(6626),
  },
  [2371] = {
    [sym_concatenation] = STATE(3032),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3032),
    [anon_sym_RBRACE] = ACTIONS(6630),
    [anon_sym_EQ] = ACTIONS(6632),
    [anon_sym_DASH] = ACTIONS(6632),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(6634),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(6636),
    [anon_sym_COLON] = ACTIONS(6632),
    [anon_sym_COLON_QMARK] = ACTIONS(6632),
    [anon_sym_COLON_DASH] = ACTIONS(6632),
    [anon_sym_PERCENT] = ACTIONS(6632),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2372] = {
    [sym_concatenation] = STATE(3035),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3035),
    [anon_sym_RBRACE] = ACTIONS(6638),
    [anon_sym_EQ] = ACTIONS(6640),
    [anon_sym_DASH] = ACTIONS(6640),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(6642),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(6644),
    [anon_sym_COLON] = ACTIONS(6640),
    [anon_sym_COLON_QMARK] = ACTIONS(6640),
    [anon_sym_COLON_DASH] = ACTIONS(6640),
    [anon_sym_PERCENT] = ACTIONS(6640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2373] = {
    [anon_sym_RPAREN] = ACTIONS(6646),
    [sym_comment] = ACTIONS(57),
  },
  [2374] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(6646),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [2375] = {
    [anon_sym_BQUOTE] = ACTIONS(6646),
    [sym_comment] = ACTIONS(57),
  },
  [2376] = {
    [anon_sym_RPAREN] = ACTIONS(6648),
    [sym_comment] = ACTIONS(57),
  },
  [2377] = {
    [sym_variable_assignment] = STATE(2377),
    [sym_subscript] = STATE(1654),
    [sym_concatenation] = STATE(2377),
    [sym_string] = STATE(1649),
    [sym_simple_expansion] = STATE(1649),
    [sym_string_expansion] = STATE(1649),
    [sym_expansion] = STATE(1649),
    [sym_command_substitution] = STATE(1649),
    [sym_process_substitution] = STATE(1649),
    [aux_sym_declaration_command_repeat1] = STATE(2377),
    [aux_sym__literal_repeat1] = STATE(1656),
    [sym__simple_heredoc_body] = ACTIONS(2206),
    [sym__heredoc_body_beginning] = ACTIONS(2206),
    [sym_file_descriptor] = ACTIONS(2206),
    [sym_variable_name] = ACTIONS(6650),
    [anon_sym_SEMI] = ACTIONS(2211),
    [anon_sym_fi] = ACTIONS(2211),
    [anon_sym_elif] = ACTIONS(2211),
    [anon_sym_else] = ACTIONS(2211),
    [anon_sym_PIPE] = ACTIONS(2211),
    [anon_sym_SEMI_SEMI] = ACTIONS(2206),
    [anon_sym_PIPE_AMP] = ACTIONS(2206),
    [anon_sym_AMP_AMP] = ACTIONS(2206),
    [anon_sym_PIPE_PIPE] = ACTIONS(2206),
    [anon_sym_LT] = ACTIONS(2211),
    [anon_sym_GT] = ACTIONS(2211),
    [anon_sym_GT_GT] = ACTIONS(2206),
    [anon_sym_AMP_GT] = ACTIONS(2211),
    [anon_sym_AMP_GT_GT] = ACTIONS(2206),
    [anon_sym_LT_AMP] = ACTIONS(2206),
    [anon_sym_GT_AMP] = ACTIONS(2206),
    [anon_sym_LT_LT] = ACTIONS(2211),
    [anon_sym_LT_LT_DASH] = ACTIONS(2206),
    [anon_sym_LT_LT_LT] = ACTIONS(2206),
    [anon_sym_DOLLAR] = ACTIONS(6653),
    [sym__special_character] = ACTIONS(6656),
    [anon_sym_DQUOTE] = ACTIONS(6659),
    [sym_raw_string] = ACTIONS(6662),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6665),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6668),
    [anon_sym_BQUOTE] = ACTIONS(6671),
    [anon_sym_LT_LPAREN] = ACTIONS(6674),
    [anon_sym_GT_LPAREN] = ACTIONS(6674),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6677),
    [sym_word] = ACTIONS(6680),
    [anon_sym_LF] = ACTIONS(2206),
    [anon_sym_AMP] = ACTIONS(2211),
  },
  [2378] = {
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym_variable_name] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_fi] = ACTIONS(339),
    [anon_sym_elif] = ACTIONS(339),
    [anon_sym_else] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(339),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [2379] = {
    [aux_sym__literal_repeat1] = STATE(2379),
    [sym__simple_heredoc_body] = ACTIONS(1373),
    [sym__heredoc_body_beginning] = ACTIONS(1373),
    [sym_file_descriptor] = ACTIONS(1373),
    [sym_variable_name] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_fi] = ACTIONS(1375),
    [anon_sym_elif] = ACTIONS(1375),
    [anon_sym_else] = ACTIONS(1375),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE_AMP] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_LT_LT_DASH] = ACTIONS(1373),
    [anon_sym_LT_LT_LT] = ACTIONS(1373),
    [anon_sym_DOLLAR] = ACTIONS(1375),
    [sym__special_character] = ACTIONS(6683),
    [anon_sym_DQUOTE] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1373),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [anon_sym_LT_LPAREN] = ACTIONS(1373),
    [anon_sym_GT_LPAREN] = ACTIONS(1373),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1375),
    [sym_word] = ACTIONS(1375),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
  },
  [2380] = {
    [sym__simple_heredoc_body] = ACTIONS(1057),
    [sym__heredoc_body_beginning] = ACTIONS(1057),
    [sym_file_descriptor] = ACTIONS(1057),
    [sym__concat] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_fi] = ACTIONS(1059),
    [anon_sym_elif] = ACTIONS(1059),
    [anon_sym_else] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_PIPE_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_AMP] = ACTIONS(1057),
    [anon_sym_GT_AMP] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_LT] = ACTIONS(1057),
    [anon_sym_DOLLAR] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [sym_raw_string] = ACTIONS(1057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1057),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1057),
    [anon_sym_BQUOTE] = ACTIONS(1057),
    [anon_sym_LT_LPAREN] = ACTIONS(1057),
    [anon_sym_GT_LPAREN] = ACTIONS(1057),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1059),
    [sym_word] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [2381] = {
    [sym__simple_heredoc_body] = ACTIONS(1061),
    [sym__heredoc_body_beginning] = ACTIONS(1061),
    [sym_file_descriptor] = ACTIONS(1061),
    [sym__concat] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(1063),
    [anon_sym_fi] = ACTIONS(1063),
    [anon_sym_elif] = ACTIONS(1063),
    [anon_sym_else] = ACTIONS(1063),
    [anon_sym_PIPE] = ACTIONS(1063),
    [anon_sym_SEMI_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE_AMP] = ACTIONS(1061),
    [anon_sym_AMP_AMP] = ACTIONS(1061),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1063),
    [anon_sym_GT_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT_GT] = ACTIONS(1061),
    [anon_sym_LT_AMP] = ACTIONS(1061),
    [anon_sym_GT_AMP] = ACTIONS(1061),
    [anon_sym_LT_LT] = ACTIONS(1063),
    [anon_sym_LT_LT_DASH] = ACTIONS(1061),
    [anon_sym_LT_LT_LT] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1061),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1061),
    [anon_sym_LT_LPAREN] = ACTIONS(1061),
    [anon_sym_GT_LPAREN] = ACTIONS(1061),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1063),
    [sym_word] = ACTIONS(1063),
    [anon_sym_LF] = ACTIONS(1061),
    [anon_sym_AMP] = ACTIONS(1063),
  },
  [2382] = {
    [sym__simple_heredoc_body] = ACTIONS(1065),
    [sym__heredoc_body_beginning] = ACTIONS(1065),
    [sym_file_descriptor] = ACTIONS(1065),
    [sym__concat] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_fi] = ACTIONS(1067),
    [anon_sym_elif] = ACTIONS(1067),
    [anon_sym_else] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1067),
    [anon_sym_SEMI_SEMI] = ACTIONS(1065),
    [anon_sym_PIPE_AMP] = ACTIONS(1065),
    [anon_sym_AMP_AMP] = ACTIONS(1065),
    [anon_sym_PIPE_PIPE] = ACTIONS(1065),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_GT] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT] = ACTIONS(1067),
    [anon_sym_AMP_GT_GT] = ACTIONS(1065),
    [anon_sym_LT_AMP] = ACTIONS(1065),
    [anon_sym_GT_AMP] = ACTIONS(1065),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_LT_LT_DASH] = ACTIONS(1065),
    [anon_sym_LT_LT_LT] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1067),
    [sym__special_character] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LT_LPAREN] = ACTIONS(1065),
    [anon_sym_GT_LPAREN] = ACTIONS(1065),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1067),
    [sym_word] = ACTIONS(1067),
    [anon_sym_LF] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1067),
  },
  [2383] = {
    [sym_string] = STATE(3038),
    [sym_simple_expansion] = STATE(3038),
    [sym_string_expansion] = STATE(3038),
    [sym_expansion] = STATE(3038),
    [sym_command_substitution] = STATE(3038),
    [sym_process_substitution] = STATE(3038),
    [anon_sym_DOLLAR] = ACTIONS(3431),
    [sym__special_character] = ACTIONS(6686),
    [anon_sym_DQUOTE] = ACTIONS(3435),
    [sym_raw_string] = ACTIONS(6686),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3439),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3441),
    [anon_sym_BQUOTE] = ACTIONS(3443),
    [anon_sym_LT_LPAREN] = ACTIONS(3445),
    [anon_sym_GT_LPAREN] = ACTIONS(3445),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6686),
  },
  [2384] = {
    [aux_sym_concatenation_repeat1] = STATE(3040),
    [sym__simple_heredoc_body] = ACTIONS(1071),
    [sym__heredoc_body_beginning] = ACTIONS(1071),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(6688),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_fi] = ACTIONS(1075),
    [anon_sym_elif] = ACTIONS(1075),
    [anon_sym_else] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [sym__special_character] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [sym_word] = ACTIONS(1075),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1075),
  },
  [2385] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(6690),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [2386] = {
    [sym__simple_heredoc_body] = ACTIONS(1089),
    [sym__heredoc_body_beginning] = ACTIONS(1089),
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(1089),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_fi] = ACTIONS(1091),
    [anon_sym_elif] = ACTIONS(1091),
    [anon_sym_else] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1089),
    [anon_sym_PIPE_AMP] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_AMP] = ACTIONS(1089),
    [anon_sym_GT_AMP] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1089),
    [anon_sym_LT_LT_LT] = ACTIONS(1089),
    [anon_sym_DOLLAR] = ACTIONS(1091),
    [sym__special_character] = ACTIONS(1089),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1089),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1089),
    [anon_sym_GT_LPAREN] = ACTIONS(1089),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1091),
    [sym_word] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [2387] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(627),
    [anon_sym_DOLLAR] = ACTIONS(6692),
    [anon_sym_DQUOTE] = ACTIONS(6690),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [2388] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(6694),
    [sym_comment] = ACTIONS(57),
  },
  [2389] = {
    [sym_subscript] = STATE(3046),
    [sym_variable_name] = ACTIONS(6696),
    [anon_sym_DASH] = ACTIONS(6698),
    [anon_sym_DOLLAR] = ACTIONS(6698),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6700),
    [anon_sym_STAR] = ACTIONS(6702),
    [anon_sym_AT] = ACTIONS(6702),
    [anon_sym_QMARK] = ACTIONS(6702),
    [anon_sym_0] = ACTIONS(6700),
    [anon_sym__] = ACTIONS(6700),
  },
  [2390] = {
    [sym_concatenation] = STATE(3049),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3049),
    [anon_sym_RBRACE] = ACTIONS(6704),
    [anon_sym_EQ] = ACTIONS(6706),
    [anon_sym_DASH] = ACTIONS(6706),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(6708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(6710),
    [anon_sym_COLON] = ACTIONS(6706),
    [anon_sym_COLON_QMARK] = ACTIONS(6706),
    [anon_sym_COLON_DASH] = ACTIONS(6706),
    [anon_sym_PERCENT] = ACTIONS(6706),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2391] = {
    [sym_concatenation] = STATE(3052),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3052),
    [anon_sym_RBRACE] = ACTIONS(6712),
    [anon_sym_EQ] = ACTIONS(6714),
    [anon_sym_DASH] = ACTIONS(6714),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(6716),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(6718),
    [anon_sym_COLON] = ACTIONS(6714),
    [anon_sym_COLON_QMARK] = ACTIONS(6714),
    [anon_sym_COLON_DASH] = ACTIONS(6714),
    [anon_sym_PERCENT] = ACTIONS(6714),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2392] = {
    [anon_sym_RPAREN] = ACTIONS(6720),
    [sym_comment] = ACTIONS(57),
  },
  [2393] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(6720),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [2394] = {
    [anon_sym_BQUOTE] = ACTIONS(6720),
    [sym_comment] = ACTIONS(57),
  },
  [2395] = {
    [anon_sym_RPAREN] = ACTIONS(6722),
    [sym_comment] = ACTIONS(57),
  },
  [2396] = {
    [sym_concatenation] = STATE(2396),
    [sym_string] = STATE(1660),
    [sym_simple_expansion] = STATE(1660),
    [sym_string_expansion] = STATE(1660),
    [sym_expansion] = STATE(1660),
    [sym_command_substitution] = STATE(1660),
    [sym_process_substitution] = STATE(1660),
    [aux_sym_unset_command_repeat1] = STATE(2396),
    [aux_sym__literal_repeat1] = STATE(1666),
    [sym__simple_heredoc_body] = ACTIONS(2284),
    [sym__heredoc_body_beginning] = ACTIONS(2284),
    [sym_file_descriptor] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym_fi] = ACTIONS(2286),
    [anon_sym_elif] = ACTIONS(2286),
    [anon_sym_else] = ACTIONS(2286),
    [anon_sym_PIPE] = ACTIONS(2286),
    [anon_sym_SEMI_SEMI] = ACTIONS(2284),
    [anon_sym_PIPE_AMP] = ACTIONS(2284),
    [anon_sym_AMP_AMP] = ACTIONS(2284),
    [anon_sym_PIPE_PIPE] = ACTIONS(2284),
    [anon_sym_LT] = ACTIONS(2286),
    [anon_sym_GT] = ACTIONS(2286),
    [anon_sym_GT_GT] = ACTIONS(2284),
    [anon_sym_AMP_GT] = ACTIONS(2286),
    [anon_sym_AMP_GT_GT] = ACTIONS(2284),
    [anon_sym_LT_AMP] = ACTIONS(2284),
    [anon_sym_GT_AMP] = ACTIONS(2284),
    [anon_sym_LT_LT] = ACTIONS(2286),
    [anon_sym_LT_LT_DASH] = ACTIONS(2284),
    [anon_sym_LT_LT_LT] = ACTIONS(2284),
    [anon_sym_DOLLAR] = ACTIONS(6724),
    [sym__special_character] = ACTIONS(6727),
    [anon_sym_DQUOTE] = ACTIONS(6730),
    [sym_raw_string] = ACTIONS(6733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6736),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6739),
    [anon_sym_BQUOTE] = ACTIONS(6742),
    [anon_sym_LT_LPAREN] = ACTIONS(6745),
    [anon_sym_GT_LPAREN] = ACTIONS(6745),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6748),
    [sym_word] = ACTIONS(6751),
    [anon_sym_LF] = ACTIONS(2284),
    [anon_sym_AMP] = ACTIONS(2286),
  },
  [2397] = {
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_fi] = ACTIONS(339),
    [anon_sym_elif] = ACTIONS(339),
    [anon_sym_else] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(339),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [2398] = {
    [aux_sym__literal_repeat1] = STATE(2398),
    [sym__simple_heredoc_body] = ACTIONS(1373),
    [sym__heredoc_body_beginning] = ACTIONS(1373),
    [sym_file_descriptor] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_fi] = ACTIONS(1375),
    [anon_sym_elif] = ACTIONS(1375),
    [anon_sym_else] = ACTIONS(1375),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE_AMP] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_LT_LT_DASH] = ACTIONS(1373),
    [anon_sym_LT_LT_LT] = ACTIONS(1373),
    [anon_sym_DOLLAR] = ACTIONS(1375),
    [sym__special_character] = ACTIONS(6754),
    [anon_sym_DQUOTE] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1373),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [anon_sym_LT_LPAREN] = ACTIONS(1373),
    [anon_sym_GT_LPAREN] = ACTIONS(1373),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1375),
    [sym_word] = ACTIONS(1375),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
  },
  [2399] = {
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_fi] = ACTIONS(2364),
    [anon_sym_elif] = ACTIONS(2364),
    [anon_sym_else] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_EQ_TILDE] = ACTIONS(2364),
    [anon_sym_EQ_EQ] = ACTIONS(2364),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [2400] = {
    [sym_string] = STATE(2399),
    [sym_simple_expansion] = STATE(2399),
    [sym_string_expansion] = STATE(2399),
    [sym_expansion] = STATE(2399),
    [sym_command_substitution] = STATE(2399),
    [sym_process_substitution] = STATE(2399),
    [anon_sym_DOLLAR] = ACTIONS(6757),
    [sym__special_character] = ACTIONS(5211),
    [anon_sym_DQUOTE] = ACTIONS(1822),
    [sym_raw_string] = ACTIONS(5211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1826),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1828),
    [anon_sym_BQUOTE] = ACTIONS(1830),
    [anon_sym_LT_LPAREN] = ACTIONS(1832),
    [anon_sym_GT_LPAREN] = ACTIONS(1832),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5211),
  },
  [2401] = {
    [aux_sym_concatenation_repeat1] = STATE(2401),
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(6759),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_fi] = ACTIONS(2364),
    [anon_sym_elif] = ACTIONS(2364),
    [anon_sym_else] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_EQ_TILDE] = ACTIONS(2364),
    [anon_sym_EQ_EQ] = ACTIONS(2364),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [2402] = {
    [sym__simple_heredoc_body] = ACTIONS(2371),
    [sym__heredoc_body_beginning] = ACTIONS(2371),
    [sym_file_descriptor] = ACTIONS(2371),
    [sym__concat] = ACTIONS(2371),
    [anon_sym_SEMI] = ACTIONS(2373),
    [anon_sym_fi] = ACTIONS(2373),
    [anon_sym_elif] = ACTIONS(2373),
    [anon_sym_else] = ACTIONS(2373),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_SEMI_SEMI] = ACTIONS(2371),
    [anon_sym_PIPE_AMP] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_EQ_TILDE] = ACTIONS(2373),
    [anon_sym_EQ_EQ] = ACTIONS(2373),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_GT_GT] = ACTIONS(2371),
    [anon_sym_AMP_GT] = ACTIONS(2373),
    [anon_sym_AMP_GT_GT] = ACTIONS(2371),
    [anon_sym_LT_AMP] = ACTIONS(2371),
    [anon_sym_GT_AMP] = ACTIONS(2371),
    [anon_sym_LT_LT] = ACTIONS(2373),
    [anon_sym_LT_LT_DASH] = ACTIONS(2371),
    [anon_sym_LT_LT_LT] = ACTIONS(2371),
    [anon_sym_DOLLAR] = ACTIONS(2373),
    [sym__special_character] = ACTIONS(2371),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [sym_raw_string] = ACTIONS(2371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2371),
    [anon_sym_BQUOTE] = ACTIONS(2371),
    [anon_sym_LT_LPAREN] = ACTIONS(2371),
    [anon_sym_GT_LPAREN] = ACTIONS(2371),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2373),
    [anon_sym_LF] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
  },
  [2403] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(6762),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [2404] = {
    [sym_concatenation] = STATE(3059),
    [sym_string] = STATE(3058),
    [sym_simple_expansion] = STATE(3058),
    [sym_string_expansion] = STATE(3058),
    [sym_expansion] = STATE(3058),
    [sym_command_substitution] = STATE(3058),
    [sym_process_substitution] = STATE(3058),
    [aux_sym__literal_repeat1] = STATE(3060),
    [anon_sym_RBRACE] = ACTIONS(6764),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(6766),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6766),
  },
  [2405] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(6768),
    [sym_comment] = ACTIONS(57),
  },
  [2406] = {
    [sym_concatenation] = STATE(3064),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3064),
    [anon_sym_RBRACE] = ACTIONS(6770),
    [anon_sym_EQ] = ACTIONS(6772),
    [anon_sym_DASH] = ACTIONS(6772),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(6774),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(6776),
    [anon_sym_COLON] = ACTIONS(6772),
    [anon_sym_COLON_QMARK] = ACTIONS(6772),
    [anon_sym_COLON_DASH] = ACTIONS(6772),
    [anon_sym_PERCENT] = ACTIONS(6772),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2407] = {
    [sym_concatenation] = STATE(3066),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3066),
    [anon_sym_RBRACE] = ACTIONS(6764),
    [anon_sym_EQ] = ACTIONS(6778),
    [anon_sym_DASH] = ACTIONS(6778),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(6780),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(6782),
    [anon_sym_COLON] = ACTIONS(6778),
    [anon_sym_COLON_QMARK] = ACTIONS(6778),
    [anon_sym_COLON_DASH] = ACTIONS(6778),
    [anon_sym_PERCENT] = ACTIONS(6778),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2408] = {
    [sym__simple_heredoc_body] = ACTIONS(2462),
    [sym__heredoc_body_beginning] = ACTIONS(2462),
    [sym_file_descriptor] = ACTIONS(2462),
    [sym__concat] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_fi] = ACTIONS(2464),
    [anon_sym_elif] = ACTIONS(2464),
    [anon_sym_else] = ACTIONS(2464),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_SEMI_SEMI] = ACTIONS(2462),
    [anon_sym_PIPE_AMP] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_EQ_TILDE] = ACTIONS(2464),
    [anon_sym_EQ_EQ] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_GT_GT] = ACTIONS(2462),
    [anon_sym_AMP_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT_GT] = ACTIONS(2462),
    [anon_sym_LT_AMP] = ACTIONS(2462),
    [anon_sym_GT_AMP] = ACTIONS(2462),
    [anon_sym_LT_LT] = ACTIONS(2464),
    [anon_sym_LT_LT_DASH] = ACTIONS(2462),
    [anon_sym_LT_LT_LT] = ACTIONS(2462),
    [anon_sym_DOLLAR] = ACTIONS(2464),
    [sym__special_character] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [sym_raw_string] = ACTIONS(2462),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2462),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2462),
    [anon_sym_BQUOTE] = ACTIONS(2462),
    [anon_sym_LT_LPAREN] = ACTIONS(2462),
    [anon_sym_GT_LPAREN] = ACTIONS(2462),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2464),
    [anon_sym_LF] = ACTIONS(2462),
    [anon_sym_AMP] = ACTIONS(2464),
  },
  [2409] = {
    [sym_concatenation] = STATE(3069),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3069),
    [sym_regex] = ACTIONS(6784),
    [anon_sym_RBRACE] = ACTIONS(6786),
    [anon_sym_EQ] = ACTIONS(6788),
    [anon_sym_DASH] = ACTIONS(6788),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(6790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(6788),
    [anon_sym_COLON_QMARK] = ACTIONS(6788),
    [anon_sym_COLON_DASH] = ACTIONS(6788),
    [anon_sym_PERCENT] = ACTIONS(6788),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2410] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(6786),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2411] = {
    [sym__simple_heredoc_body] = ACTIONS(2512),
    [sym__heredoc_body_beginning] = ACTIONS(2512),
    [sym_file_descriptor] = ACTIONS(2512),
    [sym__concat] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2514),
    [anon_sym_fi] = ACTIONS(2514),
    [anon_sym_elif] = ACTIONS(2514),
    [anon_sym_else] = ACTIONS(2514),
    [anon_sym_PIPE] = ACTIONS(2514),
    [anon_sym_SEMI_SEMI] = ACTIONS(2512),
    [anon_sym_PIPE_AMP] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE_PIPE] = ACTIONS(2512),
    [anon_sym_EQ_TILDE] = ACTIONS(2514),
    [anon_sym_EQ_EQ] = ACTIONS(2514),
    [anon_sym_LT] = ACTIONS(2514),
    [anon_sym_GT] = ACTIONS(2514),
    [anon_sym_GT_GT] = ACTIONS(2512),
    [anon_sym_AMP_GT] = ACTIONS(2514),
    [anon_sym_AMP_GT_GT] = ACTIONS(2512),
    [anon_sym_LT_AMP] = ACTIONS(2512),
    [anon_sym_GT_AMP] = ACTIONS(2512),
    [anon_sym_LT_LT] = ACTIONS(2514),
    [anon_sym_LT_LT_DASH] = ACTIONS(2512),
    [anon_sym_LT_LT_LT] = ACTIONS(2512),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [sym__special_character] = ACTIONS(2512),
    [anon_sym_DQUOTE] = ACTIONS(2512),
    [sym_raw_string] = ACTIONS(2512),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2512),
    [anon_sym_BQUOTE] = ACTIONS(2512),
    [anon_sym_LT_LPAREN] = ACTIONS(2512),
    [anon_sym_GT_LPAREN] = ACTIONS(2512),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2514),
    [anon_sym_LF] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2514),
  },
  [2412] = {
    [sym_concatenation] = STATE(3066),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3066),
    [sym_regex] = ACTIONS(6792),
    [anon_sym_RBRACE] = ACTIONS(6764),
    [anon_sym_EQ] = ACTIONS(6778),
    [anon_sym_DASH] = ACTIONS(6778),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(6780),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(6778),
    [anon_sym_COLON_QMARK] = ACTIONS(6778),
    [anon_sym_COLON_DASH] = ACTIONS(6778),
    [anon_sym_PERCENT] = ACTIONS(6778),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2413] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(6764),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2414] = {
    [sym__simple_heredoc_body] = ACTIONS(2520),
    [sym__heredoc_body_beginning] = ACTIONS(2520),
    [sym_file_descriptor] = ACTIONS(2520),
    [sym__concat] = ACTIONS(2520),
    [anon_sym_SEMI] = ACTIONS(2522),
    [anon_sym_fi] = ACTIONS(2522),
    [anon_sym_elif] = ACTIONS(2522),
    [anon_sym_else] = ACTIONS(2522),
    [anon_sym_PIPE] = ACTIONS(2522),
    [anon_sym_SEMI_SEMI] = ACTIONS(2520),
    [anon_sym_PIPE_AMP] = ACTIONS(2520),
    [anon_sym_AMP_AMP] = ACTIONS(2520),
    [anon_sym_PIPE_PIPE] = ACTIONS(2520),
    [anon_sym_EQ_TILDE] = ACTIONS(2522),
    [anon_sym_EQ_EQ] = ACTIONS(2522),
    [anon_sym_LT] = ACTIONS(2522),
    [anon_sym_GT] = ACTIONS(2522),
    [anon_sym_GT_GT] = ACTIONS(2520),
    [anon_sym_AMP_GT] = ACTIONS(2522),
    [anon_sym_AMP_GT_GT] = ACTIONS(2520),
    [anon_sym_LT_AMP] = ACTIONS(2520),
    [anon_sym_GT_AMP] = ACTIONS(2520),
    [anon_sym_LT_LT] = ACTIONS(2522),
    [anon_sym_LT_LT_DASH] = ACTIONS(2520),
    [anon_sym_LT_LT_LT] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(2522),
    [sym__special_character] = ACTIONS(2520),
    [anon_sym_DQUOTE] = ACTIONS(2520),
    [sym_raw_string] = ACTIONS(2520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2520),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2520),
    [anon_sym_BQUOTE] = ACTIONS(2520),
    [anon_sym_LT_LPAREN] = ACTIONS(2520),
    [anon_sym_GT_LPAREN] = ACTIONS(2520),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2522),
    [anon_sym_LF] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2522),
  },
  [2415] = {
    [sym__simple_heredoc_body] = ACTIONS(2554),
    [sym__heredoc_body_beginning] = ACTIONS(2554),
    [sym_file_descriptor] = ACTIONS(2554),
    [sym__concat] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(2556),
    [anon_sym_fi] = ACTIONS(2556),
    [anon_sym_elif] = ACTIONS(2556),
    [anon_sym_else] = ACTIONS(2556),
    [anon_sym_PIPE] = ACTIONS(2556),
    [anon_sym_SEMI_SEMI] = ACTIONS(2554),
    [anon_sym_PIPE_AMP] = ACTIONS(2554),
    [anon_sym_AMP_AMP] = ACTIONS(2554),
    [anon_sym_PIPE_PIPE] = ACTIONS(2554),
    [anon_sym_EQ_TILDE] = ACTIONS(2556),
    [anon_sym_EQ_EQ] = ACTIONS(2556),
    [anon_sym_LT] = ACTIONS(2556),
    [anon_sym_GT] = ACTIONS(2556),
    [anon_sym_GT_GT] = ACTIONS(2554),
    [anon_sym_AMP_GT] = ACTIONS(2556),
    [anon_sym_AMP_GT_GT] = ACTIONS(2554),
    [anon_sym_LT_AMP] = ACTIONS(2554),
    [anon_sym_GT_AMP] = ACTIONS(2554),
    [anon_sym_LT_LT] = ACTIONS(2556),
    [anon_sym_LT_LT_DASH] = ACTIONS(2554),
    [anon_sym_LT_LT_LT] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2556),
    [sym__special_character] = ACTIONS(2554),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2554),
    [anon_sym_BQUOTE] = ACTIONS(2554),
    [anon_sym_LT_LPAREN] = ACTIONS(2554),
    [anon_sym_GT_LPAREN] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2556),
    [anon_sym_LF] = ACTIONS(2554),
    [anon_sym_AMP] = ACTIONS(2556),
  },
  [2416] = {
    [sym__simple_heredoc_body] = ACTIONS(6794),
    [sym__heredoc_body_beginning] = ACTIONS(6794),
    [sym_file_descriptor] = ACTIONS(6794),
    [ts_builtin_sym_end] = ACTIONS(6794),
    [anon_sym_SEMI] = ACTIONS(6796),
    [anon_sym_done] = ACTIONS(6794),
    [anon_sym_fi] = ACTIONS(6794),
    [anon_sym_elif] = ACTIONS(6794),
    [anon_sym_else] = ACTIONS(6794),
    [anon_sym_esac] = ACTIONS(6794),
    [anon_sym_PIPE] = ACTIONS(6796),
    [anon_sym_RPAREN] = ACTIONS(6794),
    [anon_sym_SEMI_SEMI] = ACTIONS(6794),
    [anon_sym_PIPE_AMP] = ACTIONS(6794),
    [anon_sym_AMP_AMP] = ACTIONS(6794),
    [anon_sym_PIPE_PIPE] = ACTIONS(6794),
    [anon_sym_LT] = ACTIONS(6796),
    [anon_sym_GT] = ACTIONS(6796),
    [anon_sym_GT_GT] = ACTIONS(6794),
    [anon_sym_AMP_GT] = ACTIONS(6796),
    [anon_sym_AMP_GT_GT] = ACTIONS(6794),
    [anon_sym_LT_AMP] = ACTIONS(6794),
    [anon_sym_GT_AMP] = ACTIONS(6794),
    [anon_sym_LT_LT] = ACTIONS(6796),
    [anon_sym_LT_LT_DASH] = ACTIONS(6794),
    [anon_sym_LT_LT_LT] = ACTIONS(6794),
    [anon_sym_BQUOTE] = ACTIONS(6794),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6794),
    [anon_sym_AMP] = ACTIONS(6796),
  },
  [2417] = {
    [anon_sym_fi] = ACTIONS(6798),
    [sym_comment] = ACTIONS(57),
  },
  [2418] = {
    [sym_concatenation] = STATE(1328),
    [sym_string] = STATE(3072),
    [sym_simple_expansion] = STATE(3072),
    [sym_string_expansion] = STATE(3072),
    [sym_expansion] = STATE(3072),
    [sym_command_substitution] = STATE(3072),
    [sym_process_substitution] = STATE(3072),
    [aux_sym__literal_repeat1] = STATE(3073),
    [anon_sym_DOLLAR] = ACTIONS(4998),
    [sym__special_character] = ACTIONS(5259),
    [anon_sym_DQUOTE] = ACTIONS(5002),
    [sym_raw_string] = ACTIONS(6800),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5006),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5008),
    [anon_sym_BQUOTE] = ACTIONS(5010),
    [anon_sym_LT_LPAREN] = ACTIONS(5012),
    [anon_sym_GT_LPAREN] = ACTIONS(5012),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6800),
  },
  [2419] = {
    [sym_file_redirect] = STATE(1693),
    [sym_heredoc_redirect] = STATE(1693),
    [sym_herestring_redirect] = STATE(1693),
    [aux_sym_redirected_statement_repeat1] = STATE(1693),
    [sym__simple_heredoc_body] = ACTIONS(2584),
    [sym__heredoc_body_beginning] = ACTIONS(2584),
    [sym_file_descriptor] = ACTIONS(2584),
    [anon_sym_SEMI] = ACTIONS(2586),
    [anon_sym_fi] = ACTIONS(2584),
    [anon_sym_elif] = ACTIONS(2584),
    [anon_sym_else] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2586),
    [anon_sym_SEMI_SEMI] = ACTIONS(2584),
    [anon_sym_PIPE_AMP] = ACTIONS(2584),
    [anon_sym_AMP_AMP] = ACTIONS(2584),
    [anon_sym_PIPE_PIPE] = ACTIONS(2584),
    [anon_sym_LT] = ACTIONS(2586),
    [anon_sym_GT] = ACTIONS(2586),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT] = ACTIONS(2586),
    [anon_sym_AMP_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_AMP] = ACTIONS(2584),
    [anon_sym_GT_AMP] = ACTIONS(2584),
    [anon_sym_LT_LT] = ACTIONS(2586),
    [anon_sym_LT_LT_DASH] = ACTIONS(2584),
    [anon_sym_LT_LT_LT] = ACTIONS(2584),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2584),
    [anon_sym_AMP] = ACTIONS(2586),
  },
  [2420] = {
    [sym_file_redirect] = STATE(1693),
    [sym_heredoc_redirect] = STATE(1693),
    [sym_herestring_redirect] = STATE(1693),
    [aux_sym_redirected_statement_repeat1] = STATE(1693),
    [sym__simple_heredoc_body] = ACTIONS(2584),
    [sym__heredoc_body_beginning] = ACTIONS(2584),
    [sym_file_descriptor] = ACTIONS(2584),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2586),
    [anon_sym_fi] = ACTIONS(2586),
    [anon_sym_elif] = ACTIONS(2586),
    [anon_sym_else] = ACTIONS(2586),
    [anon_sym_PIPE] = ACTIONS(2586),
    [anon_sym_SEMI_SEMI] = ACTIONS(2584),
    [anon_sym_PIPE_AMP] = ACTIONS(2584),
    [anon_sym_AMP_AMP] = ACTIONS(2584),
    [anon_sym_PIPE_PIPE] = ACTIONS(2584),
    [anon_sym_LT] = ACTIONS(2586),
    [anon_sym_GT] = ACTIONS(2586),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT] = ACTIONS(2586),
    [anon_sym_AMP_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_AMP] = ACTIONS(2584),
    [anon_sym_GT_AMP] = ACTIONS(2584),
    [anon_sym_LT_LT] = ACTIONS(2586),
    [anon_sym_LT_LT_DASH] = ACTIONS(2584),
    [anon_sym_LT_LT_LT] = ACTIONS(2584),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2584),
    [anon_sym_AMP] = ACTIONS(2586),
  },
  [2421] = {
    [sym_file_redirect] = STATE(1693),
    [sym_heredoc_redirect] = STATE(1693),
    [sym_herestring_redirect] = STATE(1693),
    [aux_sym_redirected_statement_repeat1] = STATE(1693),
    [sym__simple_heredoc_body] = ACTIONS(2588),
    [sym__heredoc_body_beginning] = ACTIONS(2588),
    [sym_file_descriptor] = ACTIONS(2588),
    [anon_sym_SEMI] = ACTIONS(2590),
    [anon_sym_fi] = ACTIONS(2588),
    [anon_sym_elif] = ACTIONS(2588),
    [anon_sym_else] = ACTIONS(2588),
    [anon_sym_PIPE] = ACTIONS(3485),
    [anon_sym_SEMI_SEMI] = ACTIONS(2588),
    [anon_sym_PIPE_AMP] = ACTIONS(3489),
    [anon_sym_AMP_AMP] = ACTIONS(2588),
    [anon_sym_PIPE_PIPE] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(2590),
    [anon_sym_GT] = ACTIONS(2590),
    [anon_sym_GT_GT] = ACTIONS(2588),
    [anon_sym_AMP_GT] = ACTIONS(2590),
    [anon_sym_AMP_GT_GT] = ACTIONS(2588),
    [anon_sym_LT_AMP] = ACTIONS(2588),
    [anon_sym_GT_AMP] = ACTIONS(2588),
    [anon_sym_LT_LT] = ACTIONS(2590),
    [anon_sym_LT_LT_DASH] = ACTIONS(2588),
    [anon_sym_LT_LT_LT] = ACTIONS(2588),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2588),
    [anon_sym_AMP] = ACTIONS(2590),
  },
  [2422] = {
    [sym_file_redirect] = STATE(1693),
    [sym_heredoc_redirect] = STATE(1693),
    [sym_herestring_redirect] = STATE(1693),
    [aux_sym_redirected_statement_repeat1] = STATE(1693),
    [sym__simple_heredoc_body] = ACTIONS(2588),
    [sym__heredoc_body_beginning] = ACTIONS(2588),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2590),
    [anon_sym_fi] = ACTIONS(2590),
    [anon_sym_elif] = ACTIONS(2590),
    [anon_sym_else] = ACTIONS(2590),
    [anon_sym_PIPE] = ACTIONS(3485),
    [anon_sym_SEMI_SEMI] = ACTIONS(2588),
    [anon_sym_PIPE_AMP] = ACTIONS(3489),
    [anon_sym_AMP_AMP] = ACTIONS(2588),
    [anon_sym_PIPE_PIPE] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(2590),
    [anon_sym_LT_LT_DASH] = ACTIONS(2588),
    [anon_sym_LT_LT_LT] = ACTIONS(2588),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2588),
    [anon_sym_AMP] = ACTIONS(2590),
  },
  [2423] = {
    [aux_sym_concatenation_repeat1] = STATE(3074),
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(6367),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_fi] = ACTIONS(335),
    [anon_sym_elif] = ACTIONS(335),
    [anon_sym_else] = ACTIONS(335),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [sym__special_character] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [2424] = {
    [aux_sym_concatenation_repeat1] = STATE(3074),
    [sym__simple_heredoc_body] = ACTIONS(1037),
    [sym__heredoc_body_beginning] = ACTIONS(1037),
    [sym_file_descriptor] = ACTIONS(1037),
    [sym__concat] = ACTIONS(6367),
    [anon_sym_SEMI] = ACTIONS(1039),
    [anon_sym_fi] = ACTIONS(1037),
    [anon_sym_elif] = ACTIONS(1037),
    [anon_sym_else] = ACTIONS(1037),
    [anon_sym_PIPE] = ACTIONS(1039),
    [anon_sym_SEMI_SEMI] = ACTIONS(1037),
    [anon_sym_PIPE_AMP] = ACTIONS(1037),
    [anon_sym_AMP_AMP] = ACTIONS(1037),
    [anon_sym_PIPE_PIPE] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1039),
    [anon_sym_GT] = ACTIONS(1039),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_AMP_GT] = ACTIONS(1039),
    [anon_sym_AMP_GT_GT] = ACTIONS(1037),
    [anon_sym_LT_AMP] = ACTIONS(1037),
    [anon_sym_GT_AMP] = ACTIONS(1037),
    [anon_sym_LT_LT] = ACTIONS(1039),
    [anon_sym_LT_LT_DASH] = ACTIONS(1037),
    [anon_sym_LT_LT_LT] = ACTIONS(1037),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1037),
    [anon_sym_AMP] = ACTIONS(1039),
  },
  [2425] = {
    [aux_sym__literal_repeat1] = STATE(3075),
    [sym__simple_heredoc_body] = ACTIONS(1051),
    [sym__heredoc_body_beginning] = ACTIONS(1051),
    [sym_file_descriptor] = ACTIONS(1051),
    [anon_sym_SEMI] = ACTIONS(1053),
    [anon_sym_fi] = ACTIONS(1051),
    [anon_sym_elif] = ACTIONS(1051),
    [anon_sym_else] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1053),
    [anon_sym_SEMI_SEMI] = ACTIONS(1051),
    [anon_sym_PIPE_AMP] = ACTIONS(1051),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_PIPE_PIPE] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT_GT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1051),
    [anon_sym_GT_AMP] = ACTIONS(1051),
    [anon_sym_LT_LT] = ACTIONS(1053),
    [anon_sym_LT_LT_DASH] = ACTIONS(1051),
    [anon_sym_LT_LT_LT] = ACTIONS(1051),
    [sym__special_character] = ACTIONS(6383),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1051),
    [anon_sym_AMP] = ACTIONS(1053),
  },
  [2426] = {
    [aux_sym_concatenation_repeat1] = STATE(3074),
    [sym__simple_heredoc_body] = ACTIONS(2596),
    [sym__heredoc_body_beginning] = ACTIONS(2596),
    [sym_file_descriptor] = ACTIONS(2596),
    [sym__concat] = ACTIONS(6367),
    [anon_sym_SEMI] = ACTIONS(2598),
    [anon_sym_fi] = ACTIONS(2596),
    [anon_sym_elif] = ACTIONS(2596),
    [anon_sym_else] = ACTIONS(2596),
    [anon_sym_PIPE] = ACTIONS(2598),
    [anon_sym_SEMI_SEMI] = ACTIONS(2596),
    [anon_sym_PIPE_AMP] = ACTIONS(2596),
    [anon_sym_AMP_AMP] = ACTIONS(2596),
    [anon_sym_PIPE_PIPE] = ACTIONS(2596),
    [anon_sym_LT] = ACTIONS(2598),
    [anon_sym_GT] = ACTIONS(2598),
    [anon_sym_GT_GT] = ACTIONS(2596),
    [anon_sym_AMP_GT] = ACTIONS(2598),
    [anon_sym_AMP_GT_GT] = ACTIONS(2596),
    [anon_sym_LT_AMP] = ACTIONS(2596),
    [anon_sym_GT_AMP] = ACTIONS(2596),
    [anon_sym_LT_LT] = ACTIONS(2598),
    [anon_sym_LT_LT_DASH] = ACTIONS(2596),
    [anon_sym_LT_LT_LT] = ACTIONS(2596),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2596),
    [anon_sym_AMP] = ACTIONS(2598),
  },
  [2427] = {
    [aux_sym__literal_repeat1] = STATE(3075),
    [sym__simple_heredoc_body] = ACTIONS(2600),
    [sym__heredoc_body_beginning] = ACTIONS(2600),
    [sym_file_descriptor] = ACTIONS(2600),
    [anon_sym_SEMI] = ACTIONS(2602),
    [anon_sym_fi] = ACTIONS(2600),
    [anon_sym_elif] = ACTIONS(2600),
    [anon_sym_else] = ACTIONS(2600),
    [anon_sym_PIPE] = ACTIONS(2602),
    [anon_sym_SEMI_SEMI] = ACTIONS(2600),
    [anon_sym_PIPE_AMP] = ACTIONS(2600),
    [anon_sym_AMP_AMP] = ACTIONS(2600),
    [anon_sym_PIPE_PIPE] = ACTIONS(2600),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_GT_GT] = ACTIONS(2600),
    [anon_sym_AMP_GT] = ACTIONS(2602),
    [anon_sym_AMP_GT_GT] = ACTIONS(2600),
    [anon_sym_LT_AMP] = ACTIONS(2600),
    [anon_sym_GT_AMP] = ACTIONS(2600),
    [anon_sym_LT_LT] = ACTIONS(2602),
    [anon_sym_LT_LT_DASH] = ACTIONS(2600),
    [anon_sym_LT_LT_LT] = ACTIONS(2600),
    [sym__special_character] = ACTIONS(6383),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2600),
    [anon_sym_AMP] = ACTIONS(2602),
  },
  [2428] = {
    [sym_file_descriptor] = ACTIONS(2604),
    [sym_variable_name] = ACTIONS(2604),
    [anon_sym_for] = ACTIONS(2608),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2608),
    [anon_sym_if] = ACTIONS(2608),
    [anon_sym_fi] = ACTIONS(6385),
    [anon_sym_elif] = ACTIONS(6385),
    [anon_sym_else] = ACTIONS(6385),
    [anon_sym_case] = ACTIONS(2608),
    [anon_sym_function] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(2608),
    [anon_sym_LBRACE] = ACTIONS(2604),
    [anon_sym_BANG] = ACTIONS(2608),
    [anon_sym_LBRACK] = ACTIONS(2608),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2604),
    [anon_sym_declare] = ACTIONS(2608),
    [anon_sym_typeset] = ACTIONS(2608),
    [anon_sym_export] = ACTIONS(2608),
    [anon_sym_readonly] = ACTIONS(2608),
    [anon_sym_local] = ACTIONS(2608),
    [anon_sym_unset] = ACTIONS(2608),
    [anon_sym_unsetenv] = ACTIONS(2608),
    [anon_sym_LT] = ACTIONS(2608),
    [anon_sym_GT] = ACTIONS(2608),
    [anon_sym_GT_GT] = ACTIONS(2604),
    [anon_sym_AMP_GT] = ACTIONS(2608),
    [anon_sym_AMP_GT_GT] = ACTIONS(2604),
    [anon_sym_LT_AMP] = ACTIONS(2604),
    [anon_sym_GT_AMP] = ACTIONS(2604),
    [anon_sym_DOLLAR] = ACTIONS(2608),
    [sym__special_character] = ACTIONS(2608),
    [anon_sym_DQUOTE] = ACTIONS(2604),
    [sym_raw_string] = ACTIONS(2604),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2604),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2604),
    [anon_sym_BQUOTE] = ACTIONS(2604),
    [anon_sym_LT_LPAREN] = ACTIONS(2604),
    [anon_sym_GT_LPAREN] = ACTIONS(2604),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2608),
  },
  [2429] = {
    [sym_file_redirect] = STATE(2429),
    [sym_heredoc_redirect] = STATE(2429),
    [sym_herestring_redirect] = STATE(2429),
    [aux_sym_redirected_statement_repeat1] = STATE(2429),
    [sym__simple_heredoc_body] = ACTIONS(2610),
    [sym__heredoc_body_beginning] = ACTIONS(2610),
    [sym_file_descriptor] = ACTIONS(6802),
    [anon_sym_SEMI] = ACTIONS(2615),
    [anon_sym_fi] = ACTIONS(2610),
    [anon_sym_elif] = ACTIONS(2610),
    [anon_sym_else] = ACTIONS(2610),
    [anon_sym_PIPE] = ACTIONS(2615),
    [anon_sym_SEMI_SEMI] = ACTIONS(2610),
    [anon_sym_PIPE_AMP] = ACTIONS(2610),
    [anon_sym_AMP_AMP] = ACTIONS(2610),
    [anon_sym_PIPE_PIPE] = ACTIONS(2610),
    [anon_sym_LT] = ACTIONS(6805),
    [anon_sym_GT] = ACTIONS(6805),
    [anon_sym_GT_GT] = ACTIONS(6808),
    [anon_sym_AMP_GT] = ACTIONS(6805),
    [anon_sym_AMP_GT_GT] = ACTIONS(6808),
    [anon_sym_LT_AMP] = ACTIONS(6808),
    [anon_sym_GT_AMP] = ACTIONS(6808),
    [anon_sym_LT_LT] = ACTIONS(2623),
    [anon_sym_LT_LT_DASH] = ACTIONS(2626),
    [anon_sym_LT_LT_LT] = ACTIONS(6811),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2610),
    [anon_sym_AMP] = ACTIONS(2615),
  },
  [2430] = {
    [sym__simple_heredoc_body] = ACTIONS(2632),
    [sym__heredoc_body_beginning] = ACTIONS(2632),
    [sym_file_descriptor] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_fi] = ACTIONS(2634),
    [anon_sym_elif] = ACTIONS(2634),
    [anon_sym_else] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2634),
    [anon_sym_SEMI_SEMI] = ACTIONS(2632),
    [anon_sym_PIPE_AMP] = ACTIONS(2632),
    [anon_sym_AMP_AMP] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2632),
    [anon_sym_EQ_TILDE] = ACTIONS(2634),
    [anon_sym_EQ_EQ] = ACTIONS(2634),
    [anon_sym_LT] = ACTIONS(2634),
    [anon_sym_GT] = ACTIONS(2634),
    [anon_sym_GT_GT] = ACTIONS(2632),
    [anon_sym_AMP_GT] = ACTIONS(2634),
    [anon_sym_AMP_GT_GT] = ACTIONS(2632),
    [anon_sym_LT_AMP] = ACTIONS(2632),
    [anon_sym_GT_AMP] = ACTIONS(2632),
    [anon_sym_LT_LT] = ACTIONS(2634),
    [anon_sym_LT_LT_DASH] = ACTIONS(2632),
    [anon_sym_LT_LT_LT] = ACTIONS(2632),
    [anon_sym_DOLLAR] = ACTIONS(2634),
    [sym__special_character] = ACTIONS(2632),
    [anon_sym_DQUOTE] = ACTIONS(2632),
    [sym_raw_string] = ACTIONS(2632),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2632),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2632),
    [anon_sym_BQUOTE] = ACTIONS(2632),
    [anon_sym_LT_LPAREN] = ACTIONS(2632),
    [anon_sym_GT_LPAREN] = ACTIONS(2632),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2634),
    [anon_sym_LF] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2634),
  },
  [2431] = {
    [aux_sym_concatenation_repeat1] = STATE(1671),
    [sym__simple_heredoc_body] = ACTIONS(2632),
    [sym__heredoc_body_beginning] = ACTIONS(2632),
    [sym_file_descriptor] = ACTIONS(2632),
    [sym__concat] = ACTIONS(3459),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_fi] = ACTIONS(2634),
    [anon_sym_elif] = ACTIONS(2634),
    [anon_sym_else] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2634),
    [anon_sym_SEMI_SEMI] = ACTIONS(2632),
    [anon_sym_PIPE_AMP] = ACTIONS(2632),
    [anon_sym_AMP_AMP] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2632),
    [anon_sym_EQ_TILDE] = ACTIONS(2634),
    [anon_sym_EQ_EQ] = ACTIONS(2634),
    [anon_sym_LT] = ACTIONS(2634),
    [anon_sym_GT] = ACTIONS(2634),
    [anon_sym_GT_GT] = ACTIONS(2632),
    [anon_sym_AMP_GT] = ACTIONS(2634),
    [anon_sym_AMP_GT_GT] = ACTIONS(2632),
    [anon_sym_LT_AMP] = ACTIONS(2632),
    [anon_sym_GT_AMP] = ACTIONS(2632),
    [anon_sym_LT_LT] = ACTIONS(2634),
    [anon_sym_LT_LT_DASH] = ACTIONS(2632),
    [anon_sym_LT_LT_LT] = ACTIONS(2632),
    [anon_sym_DOLLAR] = ACTIONS(2634),
    [sym__special_character] = ACTIONS(2632),
    [anon_sym_DQUOTE] = ACTIONS(2632),
    [sym_raw_string] = ACTIONS(2632),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2632),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2632),
    [anon_sym_BQUOTE] = ACTIONS(2632),
    [anon_sym_LT_LPAREN] = ACTIONS(2632),
    [anon_sym_GT_LPAREN] = ACTIONS(2632),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2634),
    [anon_sym_LF] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2634),
  },
  [2432] = {
    [aux_sym__literal_repeat1] = STATE(1703),
    [sym__simple_heredoc_body] = ACTIONS(2636),
    [sym__heredoc_body_beginning] = ACTIONS(2636),
    [sym_file_descriptor] = ACTIONS(2636),
    [anon_sym_SEMI] = ACTIONS(2638),
    [anon_sym_fi] = ACTIONS(2638),
    [anon_sym_elif] = ACTIONS(2638),
    [anon_sym_else] = ACTIONS(2638),
    [anon_sym_PIPE] = ACTIONS(2638),
    [anon_sym_SEMI_SEMI] = ACTIONS(2636),
    [anon_sym_PIPE_AMP] = ACTIONS(2636),
    [anon_sym_AMP_AMP] = ACTIONS(2636),
    [anon_sym_PIPE_PIPE] = ACTIONS(2636),
    [anon_sym_EQ_TILDE] = ACTIONS(2638),
    [anon_sym_EQ_EQ] = ACTIONS(2638),
    [anon_sym_LT] = ACTIONS(2638),
    [anon_sym_GT] = ACTIONS(2638),
    [anon_sym_GT_GT] = ACTIONS(2636),
    [anon_sym_AMP_GT] = ACTIONS(2638),
    [anon_sym_AMP_GT_GT] = ACTIONS(2636),
    [anon_sym_LT_AMP] = ACTIONS(2636),
    [anon_sym_GT_AMP] = ACTIONS(2636),
    [anon_sym_LT_LT] = ACTIONS(2638),
    [anon_sym_LT_LT_DASH] = ACTIONS(2636),
    [anon_sym_LT_LT_LT] = ACTIONS(2636),
    [anon_sym_DOLLAR] = ACTIONS(2638),
    [sym__special_character] = ACTIONS(3507),
    [anon_sym_DQUOTE] = ACTIONS(2636),
    [sym_raw_string] = ACTIONS(2636),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2636),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2636),
    [anon_sym_BQUOTE] = ACTIONS(2636),
    [anon_sym_LT_LPAREN] = ACTIONS(2636),
    [anon_sym_GT_LPAREN] = ACTIONS(2636),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2638),
    [anon_sym_LF] = ACTIONS(2636),
    [anon_sym_AMP] = ACTIONS(2638),
  },
  [2433] = {
    [sym_concatenation] = STATE(2433),
    [sym_string] = STATE(1695),
    [sym_simple_expansion] = STATE(1695),
    [sym_string_expansion] = STATE(1695),
    [sym_expansion] = STATE(1695),
    [sym_command_substitution] = STATE(1695),
    [sym_process_substitution] = STATE(1695),
    [aux_sym_command_repeat2] = STATE(2433),
    [aux_sym__literal_repeat1] = STATE(1697),
    [sym__simple_heredoc_body] = ACTIONS(2632),
    [sym__heredoc_body_beginning] = ACTIONS(2632),
    [sym_file_descriptor] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_fi] = ACTIONS(2634),
    [anon_sym_elif] = ACTIONS(2634),
    [anon_sym_else] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2634),
    [anon_sym_SEMI_SEMI] = ACTIONS(2632),
    [anon_sym_PIPE_AMP] = ACTIONS(2632),
    [anon_sym_AMP_AMP] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2632),
    [anon_sym_EQ_TILDE] = ACTIONS(6814),
    [anon_sym_EQ_EQ] = ACTIONS(6814),
    [anon_sym_LT] = ACTIONS(2634),
    [anon_sym_GT] = ACTIONS(2634),
    [anon_sym_GT_GT] = ACTIONS(2632),
    [anon_sym_AMP_GT] = ACTIONS(2634),
    [anon_sym_AMP_GT_GT] = ACTIONS(2632),
    [anon_sym_LT_AMP] = ACTIONS(2632),
    [anon_sym_GT_AMP] = ACTIONS(2632),
    [anon_sym_LT_LT] = ACTIONS(2634),
    [anon_sym_LT_LT_DASH] = ACTIONS(2632),
    [anon_sym_LT_LT_LT] = ACTIONS(2632),
    [anon_sym_DOLLAR] = ACTIONS(6817),
    [sym__special_character] = ACTIONS(6820),
    [anon_sym_DQUOTE] = ACTIONS(6823),
    [sym_raw_string] = ACTIONS(6826),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6829),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6832),
    [anon_sym_BQUOTE] = ACTIONS(6835),
    [anon_sym_LT_LPAREN] = ACTIONS(6838),
    [anon_sym_GT_LPAREN] = ACTIONS(6838),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6841),
    [anon_sym_LF] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2634),
  },
  [2434] = {
    [sym_file_descriptor] = ACTIONS(1237),
    [sym_variable_name] = ACTIONS(1237),
    [anon_sym_for] = ACTIONS(1241),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1237),
    [anon_sym_while] = ACTIONS(1241),
    [anon_sym_if] = ACTIONS(1241),
    [anon_sym_fi] = ACTIONS(6385),
    [anon_sym_elif] = ACTIONS(6385),
    [anon_sym_else] = ACTIONS(6385),
    [anon_sym_case] = ACTIONS(1241),
    [anon_sym_function] = ACTIONS(1241),
    [anon_sym_LPAREN] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1237),
    [anon_sym_BANG] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(1241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1237),
    [anon_sym_declare] = ACTIONS(1241),
    [anon_sym_typeset] = ACTIONS(1241),
    [anon_sym_export] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_local] = ACTIONS(1241),
    [anon_sym_unset] = ACTIONS(1241),
    [anon_sym_unsetenv] = ACTIONS(1241),
    [anon_sym_LT] = ACTIONS(1241),
    [anon_sym_GT] = ACTIONS(1241),
    [anon_sym_GT_GT] = ACTIONS(1237),
    [anon_sym_AMP_GT] = ACTIONS(1241),
    [anon_sym_AMP_GT_GT] = ACTIONS(1237),
    [anon_sym_LT_AMP] = ACTIONS(1237),
    [anon_sym_GT_AMP] = ACTIONS(1237),
    [anon_sym_DOLLAR] = ACTIONS(1241),
    [sym__special_character] = ACTIONS(1241),
    [anon_sym_DQUOTE] = ACTIONS(1237),
    [sym_raw_string] = ACTIONS(1237),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1237),
    [anon_sym_BQUOTE] = ACTIONS(1237),
    [anon_sym_LT_LPAREN] = ACTIONS(1237),
    [anon_sym_GT_LPAREN] = ACTIONS(1237),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1241),
  },
  [2435] = {
    [anon_sym_SEMI] = ACTIONS(6844),
    [anon_sym_fi] = ACTIONS(2606),
    [anon_sym_elif] = ACTIONS(2606),
    [anon_sym_else] = ACTIONS(2606),
    [anon_sym_SEMI_SEMI] = ACTIONS(6846),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6846),
    [anon_sym_AMP] = ACTIONS(6846),
  },
  [2436] = {
    [sym_concatenation] = STATE(2433),
    [sym_string] = STATE(1695),
    [sym_simple_expansion] = STATE(1695),
    [sym_string_expansion] = STATE(1695),
    [sym_expansion] = STATE(1695),
    [sym_command_substitution] = STATE(1695),
    [sym_process_substitution] = STATE(1695),
    [aux_sym_command_repeat2] = STATE(2433),
    [aux_sym__literal_repeat1] = STATE(1697),
    [sym__simple_heredoc_body] = ACTIONS(2696),
    [sym__heredoc_body_beginning] = ACTIONS(2696),
    [sym_file_descriptor] = ACTIONS(2696),
    [anon_sym_SEMI] = ACTIONS(2698),
    [anon_sym_fi] = ACTIONS(2698),
    [anon_sym_elif] = ACTIONS(2698),
    [anon_sym_else] = ACTIONS(2698),
    [anon_sym_PIPE] = ACTIONS(2698),
    [anon_sym_SEMI_SEMI] = ACTIONS(2696),
    [anon_sym_PIPE_AMP] = ACTIONS(2696),
    [anon_sym_AMP_AMP] = ACTIONS(2696),
    [anon_sym_PIPE_PIPE] = ACTIONS(2696),
    [anon_sym_EQ_TILDE] = ACTIONS(3499),
    [anon_sym_EQ_EQ] = ACTIONS(3499),
    [anon_sym_LT] = ACTIONS(2698),
    [anon_sym_GT] = ACTIONS(2698),
    [anon_sym_GT_GT] = ACTIONS(2696),
    [anon_sym_AMP_GT] = ACTIONS(2698),
    [anon_sym_AMP_GT_GT] = ACTIONS(2696),
    [anon_sym_LT_AMP] = ACTIONS(2696),
    [anon_sym_GT_AMP] = ACTIONS(2696),
    [anon_sym_LT_LT] = ACTIONS(2698),
    [anon_sym_LT_LT_DASH] = ACTIONS(2696),
    [anon_sym_LT_LT_LT] = ACTIONS(2696),
    [anon_sym_DOLLAR] = ACTIONS(1818),
    [sym__special_character] = ACTIONS(3501),
    [anon_sym_DQUOTE] = ACTIONS(1822),
    [sym_raw_string] = ACTIONS(3503),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1826),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1828),
    [anon_sym_BQUOTE] = ACTIONS(1830),
    [anon_sym_LT_LPAREN] = ACTIONS(1832),
    [anon_sym_GT_LPAREN] = ACTIONS(1832),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3505),
    [anon_sym_LF] = ACTIONS(2696),
    [anon_sym_AMP] = ACTIONS(2698),
  },
  [2437] = {
    [aux_sym_concatenation_repeat1] = STATE(3078),
    [sym__concat] = ACTIONS(6848),
    [anon_sym_PIPE] = ACTIONS(1071),
    [anon_sym_RPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
  },
  [2438] = {
    [sym_concatenation] = STATE(3080),
    [sym_string] = STATE(3079),
    [sym_simple_expansion] = STATE(3079),
    [sym_string_expansion] = STATE(3079),
    [sym_expansion] = STATE(3079),
    [sym_command_substitution] = STATE(3079),
    [sym_process_substitution] = STATE(3079),
    [aux_sym__literal_repeat1] = STATE(3081),
    [anon_sym_DOLLAR] = ACTIONS(507),
    [sym__special_character] = ACTIONS(3518),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(6850),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6850),
  },
  [2439] = {
    [sym__statements] = STATE(3096),
    [sym_redirected_statement] = STATE(3097),
    [sym_for_statement] = STATE(3097),
    [sym_c_style_for_statement] = STATE(3097),
    [sym_while_statement] = STATE(3097),
    [sym_if_statement] = STATE(3097),
    [sym_case_statement] = STATE(3097),
    [sym_function_definition] = STATE(3097),
    [sym_compound_statement] = STATE(3097),
    [sym_subshell] = STATE(3097),
    [sym_pipeline] = STATE(3097),
    [sym_list] = STATE(3097),
    [sym_negated_command] = STATE(3097),
    [sym_test_command] = STATE(3097),
    [sym_declaration_command] = STATE(3097),
    [sym_unset_command] = STATE(3097),
    [sym_command] = STATE(3097),
    [sym_command_name] = STATE(3098),
    [sym_variable_assignment] = STATE(3099),
    [sym_subscript] = STATE(3100),
    [sym_file_redirect] = STATE(3103),
    [sym_concatenation] = STATE(3101),
    [sym_string] = STATE(3090),
    [sym_simple_expansion] = STATE(3090),
    [sym_string_expansion] = STATE(3090),
    [sym_expansion] = STATE(3090),
    [sym_command_substitution] = STATE(3090),
    [sym_process_substitution] = STATE(3090),
    [aux_sym__statements_repeat1] = STATE(3102),
    [aux_sym_command_repeat1] = STATE(3103),
    [aux_sym__literal_repeat1] = STATE(3104),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(6852),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_esac] = ACTIONS(6854),
    [anon_sym_SEMI_SEMI] = ACTIONS(6856),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(6858),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(6860),
    [anon_sym_typeset] = ACTIONS(6860),
    [anon_sym_export] = ACTIONS(6860),
    [anon_sym_readonly] = ACTIONS(6860),
    [anon_sym_local] = ACTIONS(6860),
    [anon_sym_unset] = ACTIONS(6862),
    [anon_sym_unsetenv] = ACTIONS(6862),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(6864),
    [sym__special_character] = ACTIONS(6866),
    [anon_sym_DQUOTE] = ACTIONS(6868),
    [sym_raw_string] = ACTIONS(6870),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6874),
    [anon_sym_BQUOTE] = ACTIONS(6876),
    [anon_sym_LT_LPAREN] = ACTIONS(6878),
    [anon_sym_GT_LPAREN] = ACTIONS(6878),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6880),
  },
  [2440] = {
    [aux_sym_case_item_repeat1] = STATE(3106),
    [anon_sym_PIPE] = ACTIONS(5289),
    [anon_sym_RPAREN] = ACTIONS(6882),
    [sym_comment] = ACTIONS(57),
  },
  [2441] = {
    [sym__simple_heredoc_body] = ACTIONS(6884),
    [sym__heredoc_body_beginning] = ACTIONS(6884),
    [sym_file_descriptor] = ACTIONS(6884),
    [ts_builtin_sym_end] = ACTIONS(6884),
    [anon_sym_SEMI] = ACTIONS(6886),
    [anon_sym_done] = ACTIONS(6884),
    [anon_sym_fi] = ACTIONS(6884),
    [anon_sym_elif] = ACTIONS(6884),
    [anon_sym_else] = ACTIONS(6884),
    [anon_sym_esac] = ACTIONS(6884),
    [anon_sym_PIPE] = ACTIONS(6886),
    [anon_sym_RPAREN] = ACTIONS(6884),
    [anon_sym_SEMI_SEMI] = ACTIONS(6884),
    [anon_sym_PIPE_AMP] = ACTIONS(6884),
    [anon_sym_AMP_AMP] = ACTIONS(6884),
    [anon_sym_PIPE_PIPE] = ACTIONS(6884),
    [anon_sym_LT] = ACTIONS(6886),
    [anon_sym_GT] = ACTIONS(6886),
    [anon_sym_GT_GT] = ACTIONS(6884),
    [anon_sym_AMP_GT] = ACTIONS(6886),
    [anon_sym_AMP_GT_GT] = ACTIONS(6884),
    [anon_sym_LT_AMP] = ACTIONS(6884),
    [anon_sym_GT_AMP] = ACTIONS(6884),
    [anon_sym_LT_LT] = ACTIONS(6886),
    [anon_sym_LT_LT_DASH] = ACTIONS(6884),
    [anon_sym_LT_LT_LT] = ACTIONS(6884),
    [anon_sym_BQUOTE] = ACTIONS(6884),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6884),
    [anon_sym_AMP] = ACTIONS(6886),
  },
  [2442] = {
    [anon_sym_esac] = ACTIONS(6888),
    [sym_comment] = ACTIONS(57),
  },
  [2443] = {
    [sym_case_item] = STATE(2443),
    [sym_concatenation] = STATE(3109),
    [sym_string] = STATE(3108),
    [sym_simple_expansion] = STATE(3108),
    [sym_string_expansion] = STATE(3108),
    [sym_expansion] = STATE(3108),
    [sym_command_substitution] = STATE(3108),
    [sym_process_substitution] = STATE(3108),
    [aux_sym_case_statement_repeat1] = STATE(2443),
    [aux_sym__literal_repeat1] = STATE(3110),
    [anon_sym_DOLLAR] = ACTIONS(6890),
    [sym__special_character] = ACTIONS(6893),
    [anon_sym_DQUOTE] = ACTIONS(6896),
    [sym_raw_string] = ACTIONS(6899),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6902),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6905),
    [anon_sym_BQUOTE] = ACTIONS(6908),
    [anon_sym_LT_LPAREN] = ACTIONS(6911),
    [anon_sym_GT_LPAREN] = ACTIONS(6911),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6899),
  },
  [2444] = {
    [sym__statements] = STATE(3112),
    [sym_redirected_statement] = STATE(3097),
    [sym_for_statement] = STATE(3097),
    [sym_c_style_for_statement] = STATE(3097),
    [sym_while_statement] = STATE(3097),
    [sym_if_statement] = STATE(3097),
    [sym_case_statement] = STATE(3097),
    [sym_function_definition] = STATE(3097),
    [sym_compound_statement] = STATE(3097),
    [sym_subshell] = STATE(3097),
    [sym_pipeline] = STATE(3097),
    [sym_list] = STATE(3097),
    [sym_negated_command] = STATE(3097),
    [sym_test_command] = STATE(3097),
    [sym_declaration_command] = STATE(3097),
    [sym_unset_command] = STATE(3097),
    [sym_command] = STATE(3097),
    [sym_command_name] = STATE(3098),
    [sym_variable_assignment] = STATE(3099),
    [sym_subscript] = STATE(3100),
    [sym_file_redirect] = STATE(3103),
    [sym_concatenation] = STATE(3101),
    [sym_string] = STATE(3090),
    [sym_simple_expansion] = STATE(3090),
    [sym_string_expansion] = STATE(3090),
    [sym_expansion] = STATE(3090),
    [sym_command_substitution] = STATE(3090),
    [sym_process_substitution] = STATE(3090),
    [aux_sym__statements_repeat1] = STATE(3102),
    [aux_sym_command_repeat1] = STATE(3103),
    [aux_sym__literal_repeat1] = STATE(3104),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(6852),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_esac] = ACTIONS(6914),
    [anon_sym_SEMI_SEMI] = ACTIONS(6916),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(6858),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(6860),
    [anon_sym_typeset] = ACTIONS(6860),
    [anon_sym_export] = ACTIONS(6860),
    [anon_sym_readonly] = ACTIONS(6860),
    [anon_sym_local] = ACTIONS(6860),
    [anon_sym_unset] = ACTIONS(6862),
    [anon_sym_unsetenv] = ACTIONS(6862),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(6864),
    [sym__special_character] = ACTIONS(6866),
    [anon_sym_DQUOTE] = ACTIONS(6868),
    [sym_raw_string] = ACTIONS(6870),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6874),
    [anon_sym_BQUOTE] = ACTIONS(6876),
    [anon_sym_LT_LPAREN] = ACTIONS(6878),
    [anon_sym_GT_LPAREN] = ACTIONS(6878),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6880),
  },
  [2445] = {
    [aux_sym_case_item_repeat1] = STATE(3106),
    [anon_sym_PIPE] = ACTIONS(5289),
    [anon_sym_RPAREN] = ACTIONS(6918),
    [sym_comment] = ACTIONS(57),
  },
  [2446] = {
    [aux_sym__literal_repeat1] = STATE(2446),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_RPAREN] = ACTIONS(1373),
    [sym__special_character] = ACTIONS(2935),
    [sym_comment] = ACTIONS(57),
  },
  [2447] = {
    [sym_case_item] = STATE(2443),
    [sym_last_case_item] = STATE(3114),
    [sym_concatenation] = STATE(1710),
    [sym_string] = STATE(1708),
    [sym_simple_expansion] = STATE(1708),
    [sym_string_expansion] = STATE(1708),
    [sym_expansion] = STATE(1708),
    [sym_command_substitution] = STATE(1708),
    [sym_process_substitution] = STATE(1708),
    [aux_sym_case_statement_repeat1] = STATE(2443),
    [aux_sym__literal_repeat1] = STATE(1712),
    [anon_sym_DOLLAR] = ACTIONS(507),
    [sym__special_character] = ACTIONS(3518),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3520),
  },
  [2448] = {
    [sym__concat] = ACTIONS(5674),
    [anon_sym_in] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(5676),
    [anon_sym_SEMI_SEMI] = ACTIONS(5674),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5674),
    [anon_sym_AMP] = ACTIONS(5674),
  },
  [2449] = {
    [sym__concat] = ACTIONS(5708),
    [anon_sym_in] = ACTIONS(5708),
    [anon_sym_SEMI] = ACTIONS(5710),
    [anon_sym_SEMI_SEMI] = ACTIONS(5708),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5708),
    [anon_sym_AMP] = ACTIONS(5708),
  },
  [2450] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(6920),
    [sym_comment] = ACTIONS(57),
  },
  [2451] = {
    [anon_sym_RBRACE] = ACTIONS(6920),
    [sym_comment] = ACTIONS(57),
  },
  [2452] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(6922),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [2453] = {
    [sym_concatenation] = STATE(3118),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3118),
    [anon_sym_RBRACE] = ACTIONS(6924),
    [anon_sym_EQ] = ACTIONS(6926),
    [anon_sym_DASH] = ACTIONS(6926),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(6928),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(6926),
    [anon_sym_COLON_QMARK] = ACTIONS(6926),
    [anon_sym_COLON_DASH] = ACTIONS(6926),
    [anon_sym_PERCENT] = ACTIONS(6926),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2454] = {
    [sym__concat] = ACTIONS(5725),
    [anon_sym_in] = ACTIONS(5725),
    [anon_sym_SEMI] = ACTIONS(5727),
    [anon_sym_SEMI_SEMI] = ACTIONS(5725),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5725),
    [anon_sym_AMP] = ACTIONS(5725),
  },
  [2455] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(6924),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2456] = {
    [sym_concatenation] = STATE(3119),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3119),
    [anon_sym_RBRACE] = ACTIONS(6920),
    [anon_sym_EQ] = ACTIONS(6930),
    [anon_sym_DASH] = ACTIONS(6930),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(6932),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(6930),
    [anon_sym_COLON_QMARK] = ACTIONS(6930),
    [anon_sym_COLON_DASH] = ACTIONS(6930),
    [anon_sym_PERCENT] = ACTIONS(6930),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2457] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(6920),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2458] = {
    [sym__concat] = ACTIONS(5770),
    [anon_sym_in] = ACTIONS(5770),
    [anon_sym_SEMI] = ACTIONS(5772),
    [anon_sym_SEMI_SEMI] = ACTIONS(5770),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5770),
    [anon_sym_AMP] = ACTIONS(5770),
  },
  [2459] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(6934),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2460] = {
    [sym__simple_heredoc_body] = ACTIONS(6936),
    [sym__heredoc_body_beginning] = ACTIONS(6936),
    [sym_file_descriptor] = ACTIONS(6936),
    [ts_builtin_sym_end] = ACTIONS(6936),
    [anon_sym_SEMI] = ACTIONS(6938),
    [anon_sym_done] = ACTIONS(6936),
    [anon_sym_fi] = ACTIONS(6936),
    [anon_sym_elif] = ACTIONS(6936),
    [anon_sym_else] = ACTIONS(6936),
    [anon_sym_esac] = ACTIONS(6936),
    [anon_sym_PIPE] = ACTIONS(6938),
    [anon_sym_RPAREN] = ACTIONS(6936),
    [anon_sym_SEMI_SEMI] = ACTIONS(6936),
    [anon_sym_PIPE_AMP] = ACTIONS(6936),
    [anon_sym_AMP_AMP] = ACTIONS(6936),
    [anon_sym_PIPE_PIPE] = ACTIONS(6936),
    [anon_sym_LT] = ACTIONS(6938),
    [anon_sym_GT] = ACTIONS(6938),
    [anon_sym_GT_GT] = ACTIONS(6936),
    [anon_sym_AMP_GT] = ACTIONS(6938),
    [anon_sym_AMP_GT_GT] = ACTIONS(6936),
    [anon_sym_LT_AMP] = ACTIONS(6936),
    [anon_sym_GT_AMP] = ACTIONS(6936),
    [anon_sym_LT_LT] = ACTIONS(6938),
    [anon_sym_LT_LT_DASH] = ACTIONS(6936),
    [anon_sym_LT_LT_LT] = ACTIONS(6936),
    [anon_sym_BQUOTE] = ACTIONS(6936),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6936),
    [anon_sym_AMP] = ACTIONS(6938),
  },
  [2461] = {
    [anon_sym_esac] = ACTIONS(6940),
    [sym_comment] = ACTIONS(57),
  },
  [2462] = {
    [sym_case_item] = STATE(2443),
    [sym_last_case_item] = STATE(3122),
    [sym_concatenation] = STATE(1710),
    [sym_string] = STATE(1708),
    [sym_simple_expansion] = STATE(1708),
    [sym_string_expansion] = STATE(1708),
    [sym_expansion] = STATE(1708),
    [sym_command_substitution] = STATE(1708),
    [sym_process_substitution] = STATE(1708),
    [aux_sym_case_statement_repeat1] = STATE(2443),
    [aux_sym__literal_repeat1] = STATE(1712),
    [anon_sym_DOLLAR] = ACTIONS(507),
    [sym__special_character] = ACTIONS(3518),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3520),
  },
  [2463] = {
    [aux_sym_concatenation_repeat1] = STATE(2463),
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(4484),
    [sym_variable_name] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_RPAREN] = ACTIONS(2362),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [2464] = {
    [aux_sym_concatenation_repeat1] = STATE(2464),
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(2368),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_RPAREN] = ACTIONS(2362),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [2465] = {
    [sym__simple_heredoc_body] = ACTIONS(4449),
    [sym__heredoc_body_beginning] = ACTIONS(4449),
    [sym_file_descriptor] = ACTIONS(4449),
    [sym_variable_name] = ACTIONS(4449),
    [anon_sym_SEMI] = ACTIONS(4451),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_SEMI_SEMI] = ACTIONS(4449),
    [anon_sym_RBRACE] = ACTIONS(4449),
    [anon_sym_PIPE_AMP] = ACTIONS(4449),
    [anon_sym_AMP_AMP] = ACTIONS(4449),
    [anon_sym_PIPE_PIPE] = ACTIONS(4449),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_GT_GT] = ACTIONS(4449),
    [anon_sym_AMP_GT] = ACTIONS(4451),
    [anon_sym_AMP_GT_GT] = ACTIONS(4449),
    [anon_sym_LT_AMP] = ACTIONS(4449),
    [anon_sym_GT_AMP] = ACTIONS(4449),
    [anon_sym_LT_LT] = ACTIONS(4451),
    [anon_sym_LT_LT_DASH] = ACTIONS(4449),
    [anon_sym_LT_LT_LT] = ACTIONS(4449),
    [anon_sym_DOLLAR] = ACTIONS(4451),
    [sym__special_character] = ACTIONS(4451),
    [anon_sym_DQUOTE] = ACTIONS(4449),
    [sym_raw_string] = ACTIONS(4449),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4449),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4449),
    [anon_sym_BQUOTE] = ACTIONS(4449),
    [anon_sym_LT_LPAREN] = ACTIONS(4449),
    [anon_sym_GT_LPAREN] = ACTIONS(4449),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4451),
    [anon_sym_LF] = ACTIONS(4449),
    [anon_sym_AMP] = ACTIONS(4451),
  },
  [2466] = {
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(2362),
    [sym_variable_name] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_RBRACE] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2364),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [2467] = {
    [sym_string] = STATE(2466),
    [sym_simple_expansion] = STATE(2466),
    [sym_string_expansion] = STATE(2466),
    [sym_expansion] = STATE(2466),
    [sym_command_substitution] = STATE(2466),
    [sym_process_substitution] = STATE(2466),
    [anon_sym_DOLLAR] = ACTIONS(6942),
    [sym__special_character] = ACTIONS(5339),
    [anon_sym_DQUOTE] = ACTIONS(1929),
    [sym_raw_string] = ACTIONS(5339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1933),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1935),
    [anon_sym_BQUOTE] = ACTIONS(1937),
    [anon_sym_LT_LPAREN] = ACTIONS(1939),
    [anon_sym_GT_LPAREN] = ACTIONS(1939),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5339),
  },
  [2468] = {
    [aux_sym_concatenation_repeat1] = STATE(2468),
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(6944),
    [sym_variable_name] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_RBRACE] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2364),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [2469] = {
    [sym__simple_heredoc_body] = ACTIONS(2371),
    [sym__heredoc_body_beginning] = ACTIONS(2371),
    [sym_file_descriptor] = ACTIONS(2371),
    [sym__concat] = ACTIONS(2371),
    [sym_variable_name] = ACTIONS(2371),
    [anon_sym_SEMI] = ACTIONS(2373),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_SEMI_SEMI] = ACTIONS(2371),
    [anon_sym_RBRACE] = ACTIONS(2371),
    [anon_sym_PIPE_AMP] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_GT_GT] = ACTIONS(2371),
    [anon_sym_AMP_GT] = ACTIONS(2373),
    [anon_sym_AMP_GT_GT] = ACTIONS(2371),
    [anon_sym_LT_AMP] = ACTIONS(2371),
    [anon_sym_GT_AMP] = ACTIONS(2371),
    [anon_sym_LT_LT] = ACTIONS(2373),
    [anon_sym_LT_LT_DASH] = ACTIONS(2371),
    [anon_sym_LT_LT_LT] = ACTIONS(2371),
    [anon_sym_DOLLAR] = ACTIONS(2373),
    [sym__special_character] = ACTIONS(2373),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [sym_raw_string] = ACTIONS(2371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2371),
    [anon_sym_BQUOTE] = ACTIONS(2371),
    [anon_sym_LT_LPAREN] = ACTIONS(2371),
    [anon_sym_GT_LPAREN] = ACTIONS(2371),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2373),
    [anon_sym_LF] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
  },
  [2470] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(6947),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [2471] = {
    [sym_concatenation] = STATE(3127),
    [sym_string] = STATE(3126),
    [sym_simple_expansion] = STATE(3126),
    [sym_string_expansion] = STATE(3126),
    [sym_expansion] = STATE(3126),
    [sym_command_substitution] = STATE(3126),
    [sym_process_substitution] = STATE(3126),
    [aux_sym__literal_repeat1] = STATE(3128),
    [anon_sym_RBRACE] = ACTIONS(6949),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(6951),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6951),
  },
  [2472] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(6953),
    [sym_comment] = ACTIONS(57),
  },
  [2473] = {
    [sym_concatenation] = STATE(3132),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3132),
    [anon_sym_RBRACE] = ACTIONS(6955),
    [anon_sym_EQ] = ACTIONS(6957),
    [anon_sym_DASH] = ACTIONS(6957),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(6959),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(6961),
    [anon_sym_COLON] = ACTIONS(6957),
    [anon_sym_COLON_QMARK] = ACTIONS(6957),
    [anon_sym_COLON_DASH] = ACTIONS(6957),
    [anon_sym_PERCENT] = ACTIONS(6957),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2474] = {
    [sym_concatenation] = STATE(3134),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3134),
    [anon_sym_RBRACE] = ACTIONS(6949),
    [anon_sym_EQ] = ACTIONS(6963),
    [anon_sym_DASH] = ACTIONS(6963),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(6965),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(6967),
    [anon_sym_COLON] = ACTIONS(6963),
    [anon_sym_COLON_QMARK] = ACTIONS(6963),
    [anon_sym_COLON_DASH] = ACTIONS(6963),
    [anon_sym_PERCENT] = ACTIONS(6963),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2475] = {
    [sym__simple_heredoc_body] = ACTIONS(2462),
    [sym__heredoc_body_beginning] = ACTIONS(2462),
    [sym_file_descriptor] = ACTIONS(2462),
    [sym__concat] = ACTIONS(2462),
    [sym_variable_name] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_SEMI_SEMI] = ACTIONS(2462),
    [anon_sym_RBRACE] = ACTIONS(2462),
    [anon_sym_PIPE_AMP] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_GT_GT] = ACTIONS(2462),
    [anon_sym_AMP_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT_GT] = ACTIONS(2462),
    [anon_sym_LT_AMP] = ACTIONS(2462),
    [anon_sym_GT_AMP] = ACTIONS(2462),
    [anon_sym_LT_LT] = ACTIONS(2464),
    [anon_sym_LT_LT_DASH] = ACTIONS(2462),
    [anon_sym_LT_LT_LT] = ACTIONS(2462),
    [anon_sym_DOLLAR] = ACTIONS(2464),
    [sym__special_character] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [sym_raw_string] = ACTIONS(2462),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2462),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2462),
    [anon_sym_BQUOTE] = ACTIONS(2462),
    [anon_sym_LT_LPAREN] = ACTIONS(2462),
    [anon_sym_GT_LPAREN] = ACTIONS(2462),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2464),
    [anon_sym_LF] = ACTIONS(2462),
    [anon_sym_AMP] = ACTIONS(2464),
  },
  [2476] = {
    [sym_concatenation] = STATE(3137),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3137),
    [sym_regex] = ACTIONS(6969),
    [anon_sym_RBRACE] = ACTIONS(6971),
    [anon_sym_EQ] = ACTIONS(6973),
    [anon_sym_DASH] = ACTIONS(6973),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(6975),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(6973),
    [anon_sym_COLON_QMARK] = ACTIONS(6973),
    [anon_sym_COLON_DASH] = ACTIONS(6973),
    [anon_sym_PERCENT] = ACTIONS(6973),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2477] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(6971),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2478] = {
    [sym__simple_heredoc_body] = ACTIONS(2512),
    [sym__heredoc_body_beginning] = ACTIONS(2512),
    [sym_file_descriptor] = ACTIONS(2512),
    [sym__concat] = ACTIONS(2512),
    [sym_variable_name] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2514),
    [anon_sym_PIPE] = ACTIONS(2514),
    [anon_sym_SEMI_SEMI] = ACTIONS(2512),
    [anon_sym_RBRACE] = ACTIONS(2512),
    [anon_sym_PIPE_AMP] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE_PIPE] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2514),
    [anon_sym_GT] = ACTIONS(2514),
    [anon_sym_GT_GT] = ACTIONS(2512),
    [anon_sym_AMP_GT] = ACTIONS(2514),
    [anon_sym_AMP_GT_GT] = ACTIONS(2512),
    [anon_sym_LT_AMP] = ACTIONS(2512),
    [anon_sym_GT_AMP] = ACTIONS(2512),
    [anon_sym_LT_LT] = ACTIONS(2514),
    [anon_sym_LT_LT_DASH] = ACTIONS(2512),
    [anon_sym_LT_LT_LT] = ACTIONS(2512),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [sym__special_character] = ACTIONS(2514),
    [anon_sym_DQUOTE] = ACTIONS(2512),
    [sym_raw_string] = ACTIONS(2512),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2512),
    [anon_sym_BQUOTE] = ACTIONS(2512),
    [anon_sym_LT_LPAREN] = ACTIONS(2512),
    [anon_sym_GT_LPAREN] = ACTIONS(2512),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2514),
    [anon_sym_LF] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2514),
  },
  [2479] = {
    [sym_concatenation] = STATE(3134),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3134),
    [sym_regex] = ACTIONS(6977),
    [anon_sym_RBRACE] = ACTIONS(6949),
    [anon_sym_EQ] = ACTIONS(6963),
    [anon_sym_DASH] = ACTIONS(6963),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(6965),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(6963),
    [anon_sym_COLON_QMARK] = ACTIONS(6963),
    [anon_sym_COLON_DASH] = ACTIONS(6963),
    [anon_sym_PERCENT] = ACTIONS(6963),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2480] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(6949),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2481] = {
    [sym__simple_heredoc_body] = ACTIONS(2520),
    [sym__heredoc_body_beginning] = ACTIONS(2520),
    [sym_file_descriptor] = ACTIONS(2520),
    [sym__concat] = ACTIONS(2520),
    [sym_variable_name] = ACTIONS(2520),
    [anon_sym_SEMI] = ACTIONS(2522),
    [anon_sym_PIPE] = ACTIONS(2522),
    [anon_sym_SEMI_SEMI] = ACTIONS(2520),
    [anon_sym_RBRACE] = ACTIONS(2520),
    [anon_sym_PIPE_AMP] = ACTIONS(2520),
    [anon_sym_AMP_AMP] = ACTIONS(2520),
    [anon_sym_PIPE_PIPE] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(2522),
    [anon_sym_GT] = ACTIONS(2522),
    [anon_sym_GT_GT] = ACTIONS(2520),
    [anon_sym_AMP_GT] = ACTIONS(2522),
    [anon_sym_AMP_GT_GT] = ACTIONS(2520),
    [anon_sym_LT_AMP] = ACTIONS(2520),
    [anon_sym_GT_AMP] = ACTIONS(2520),
    [anon_sym_LT_LT] = ACTIONS(2522),
    [anon_sym_LT_LT_DASH] = ACTIONS(2520),
    [anon_sym_LT_LT_LT] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(2522),
    [sym__special_character] = ACTIONS(2522),
    [anon_sym_DQUOTE] = ACTIONS(2520),
    [sym_raw_string] = ACTIONS(2520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2520),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2520),
    [anon_sym_BQUOTE] = ACTIONS(2520),
    [anon_sym_LT_LPAREN] = ACTIONS(2520),
    [anon_sym_GT_LPAREN] = ACTIONS(2520),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2522),
    [anon_sym_LF] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2522),
  },
  [2482] = {
    [sym__simple_heredoc_body] = ACTIONS(2554),
    [sym__heredoc_body_beginning] = ACTIONS(2554),
    [sym_file_descriptor] = ACTIONS(2554),
    [sym__concat] = ACTIONS(2554),
    [sym_variable_name] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(2556),
    [anon_sym_PIPE] = ACTIONS(2556),
    [anon_sym_SEMI_SEMI] = ACTIONS(2554),
    [anon_sym_RBRACE] = ACTIONS(2554),
    [anon_sym_PIPE_AMP] = ACTIONS(2554),
    [anon_sym_AMP_AMP] = ACTIONS(2554),
    [anon_sym_PIPE_PIPE] = ACTIONS(2554),
    [anon_sym_LT] = ACTIONS(2556),
    [anon_sym_GT] = ACTIONS(2556),
    [anon_sym_GT_GT] = ACTIONS(2554),
    [anon_sym_AMP_GT] = ACTIONS(2556),
    [anon_sym_AMP_GT_GT] = ACTIONS(2554),
    [anon_sym_LT_AMP] = ACTIONS(2554),
    [anon_sym_GT_AMP] = ACTIONS(2554),
    [anon_sym_LT_LT] = ACTIONS(2556),
    [anon_sym_LT_LT_DASH] = ACTIONS(2554),
    [anon_sym_LT_LT_LT] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2556),
    [sym__special_character] = ACTIONS(2556),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2554),
    [anon_sym_BQUOTE] = ACTIONS(2554),
    [anon_sym_LT_LPAREN] = ACTIONS(2554),
    [anon_sym_GT_LPAREN] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2556),
    [anon_sym_LF] = ACTIONS(2554),
    [anon_sym_AMP] = ACTIONS(2556),
  },
  [2483] = {
    [sym_do_group] = STATE(3140),
    [sym_compound_statement] = STATE(3140),
    [anon_sym_SEMI] = ACTIONS(6979),
    [anon_sym_do] = ACTIONS(1953),
    [anon_sym_LBRACE] = ACTIONS(191),
    [sym_comment] = ACTIONS(57),
  },
  [2484] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(6981),
    [anon_sym_AMP_AMP] = ACTIONS(557),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(559),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_PLUS_EQ] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DASH_EQ] = ACTIONS(557),
    [anon_sym_LT_EQ] = ACTIONS(557),
    [anon_sym_GT_EQ] = ACTIONS(557),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(557),
  },
  [2485] = {
    [sym__expression] = STATE(3142),
    [sym_binary_expression] = STATE(3142),
    [sym_unary_expression] = STATE(3142),
    [sym_postfix_expression] = STATE(3142),
    [sym_parenthesized_expression] = STATE(3142),
    [sym_concatenation] = STATE(3142),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__literal_repeat1] = STATE(53),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(6981),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_DOLLAR] = ACTIONS(77),
    [sym__special_character] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [2486] = {
    [anon_sym_SEMI] = ACTIONS(6983),
    [anon_sym_SEMI_SEMI] = ACTIONS(6985),
    [anon_sym_AMP_AMP] = ACTIONS(1484),
    [anon_sym_PIPE_PIPE] = ACTIONS(1484),
    [anon_sym_EQ_TILDE] = ACTIONS(1486),
    [anon_sym_EQ_EQ] = ACTIONS(1486),
    [anon_sym_EQ] = ACTIONS(1488),
    [anon_sym_PLUS_EQ] = ACTIONS(1484),
    [anon_sym_LT] = ACTIONS(1488),
    [anon_sym_GT] = ACTIONS(1488),
    [anon_sym_BANG_EQ] = ACTIONS(1484),
    [anon_sym_PLUS] = ACTIONS(1488),
    [anon_sym_DASH] = ACTIONS(1488),
    [anon_sym_DASH_EQ] = ACTIONS(1484),
    [anon_sym_LT_EQ] = ACTIONS(1484),
    [anon_sym_GT_EQ] = ACTIONS(1484),
    [anon_sym_PLUS_PLUS] = ACTIONS(1490),
    [anon_sym_DASH_DASH] = ACTIONS(1490),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1484),
    [anon_sym_LF] = ACTIONS(6985),
    [anon_sym_AMP] = ACTIONS(6983),
  },
  [2487] = {
    [sym_do_group] = STATE(3144),
    [anon_sym_do] = ACTIONS(1953),
    [sym_comment] = ACTIONS(57),
  },
  [2488] = {
    [sym__simple_heredoc_body] = ACTIONS(4988),
    [sym__heredoc_body_beginning] = ACTIONS(4988),
    [sym_file_descriptor] = ACTIONS(4988),
    [anon_sym_SEMI] = ACTIONS(4990),
    [anon_sym_PIPE] = ACTIONS(4990),
    [anon_sym_SEMI_SEMI] = ACTIONS(4988),
    [anon_sym_RBRACE] = ACTIONS(4988),
    [anon_sym_PIPE_AMP] = ACTIONS(4988),
    [anon_sym_AMP_AMP] = ACTIONS(4988),
    [anon_sym_PIPE_PIPE] = ACTIONS(4988),
    [anon_sym_LT] = ACTIONS(4990),
    [anon_sym_GT] = ACTIONS(4990),
    [anon_sym_GT_GT] = ACTIONS(4988),
    [anon_sym_AMP_GT] = ACTIONS(4990),
    [anon_sym_AMP_GT_GT] = ACTIONS(4988),
    [anon_sym_LT_AMP] = ACTIONS(4988),
    [anon_sym_GT_AMP] = ACTIONS(4988),
    [anon_sym_LT_LT] = ACTIONS(4990),
    [anon_sym_LT_LT_DASH] = ACTIONS(4988),
    [anon_sym_LT_LT_LT] = ACTIONS(4988),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4988),
    [anon_sym_AMP] = ACTIONS(4990),
  },
  [2489] = {
    [sym__simple_heredoc_body] = ACTIONS(5249),
    [sym__heredoc_body_beginning] = ACTIONS(5249),
    [sym_file_descriptor] = ACTIONS(5249),
    [anon_sym_SEMI] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5251),
    [anon_sym_SEMI_SEMI] = ACTIONS(5249),
    [anon_sym_RBRACE] = ACTIONS(5249),
    [anon_sym_PIPE_AMP] = ACTIONS(5249),
    [anon_sym_AMP_AMP] = ACTIONS(5249),
    [anon_sym_PIPE_PIPE] = ACTIONS(5249),
    [anon_sym_LT] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5251),
    [anon_sym_GT_GT] = ACTIONS(5249),
    [anon_sym_AMP_GT] = ACTIONS(5251),
    [anon_sym_AMP_GT_GT] = ACTIONS(5249),
    [anon_sym_LT_AMP] = ACTIONS(5249),
    [anon_sym_GT_AMP] = ACTIONS(5249),
    [anon_sym_LT_LT] = ACTIONS(5251),
    [anon_sym_LT_LT_DASH] = ACTIONS(5249),
    [anon_sym_LT_LT_LT] = ACTIONS(5249),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5249),
    [anon_sym_AMP] = ACTIONS(5251),
  },
  [2490] = {
    [anon_sym_fi] = ACTIONS(6987),
    [sym_comment] = ACTIONS(57),
  },
  [2491] = {
    [sym_elif_clause] = STATE(1700),
    [sym_else_clause] = STATE(3146),
    [aux_sym_if_statement_repeat1] = STATE(1700),
    [anon_sym_fi] = ACTIONS(6987),
    [anon_sym_elif] = ACTIONS(3477),
    [anon_sym_else] = ACTIONS(3479),
    [sym_comment] = ACTIONS(57),
  },
  [2492] = {
    [sym__simple_heredoc_body] = ACTIONS(5285),
    [sym__heredoc_body_beginning] = ACTIONS(5285),
    [sym_file_descriptor] = ACTIONS(5285),
    [anon_sym_SEMI] = ACTIONS(5287),
    [anon_sym_PIPE] = ACTIONS(5287),
    [anon_sym_SEMI_SEMI] = ACTIONS(5285),
    [anon_sym_RBRACE] = ACTIONS(5285),
    [anon_sym_PIPE_AMP] = ACTIONS(5285),
    [anon_sym_AMP_AMP] = ACTIONS(5285),
    [anon_sym_PIPE_PIPE] = ACTIONS(5285),
    [anon_sym_LT] = ACTIONS(5287),
    [anon_sym_GT] = ACTIONS(5287),
    [anon_sym_GT_GT] = ACTIONS(5285),
    [anon_sym_AMP_GT] = ACTIONS(5287),
    [anon_sym_AMP_GT_GT] = ACTIONS(5285),
    [anon_sym_LT_AMP] = ACTIONS(5285),
    [anon_sym_GT_AMP] = ACTIONS(5285),
    [anon_sym_LT_LT] = ACTIONS(5287),
    [anon_sym_LT_LT_DASH] = ACTIONS(5285),
    [anon_sym_LT_LT_LT] = ACTIONS(5285),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5285),
    [anon_sym_AMP] = ACTIONS(5287),
  },
  [2493] = {
    [anon_sym_esac] = ACTIONS(6989),
    [sym_comment] = ACTIONS(57),
  },
  [2494] = {
    [sym_case_item] = STATE(2443),
    [sym_last_case_item] = STATE(3148),
    [sym_concatenation] = STATE(1710),
    [sym_string] = STATE(1708),
    [sym_simple_expansion] = STATE(1708),
    [sym_string_expansion] = STATE(1708),
    [sym_expansion] = STATE(1708),
    [sym_command_substitution] = STATE(1708),
    [sym_process_substitution] = STATE(1708),
    [aux_sym_case_statement_repeat1] = STATE(2443),
    [aux_sym__literal_repeat1] = STATE(1712),
    [anon_sym_DOLLAR] = ACTIONS(507),
    [sym__special_character] = ACTIONS(3518),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3520),
  },
  [2495] = {
    [sym_case_item] = STATE(3149),
    [sym_last_case_item] = STATE(3148),
    [sym_concatenation] = STATE(1710),
    [sym_string] = STATE(1708),
    [sym_simple_expansion] = STATE(1708),
    [sym_string_expansion] = STATE(1708),
    [sym_expansion] = STATE(1708),
    [sym_command_substitution] = STATE(1708),
    [sym_process_substitution] = STATE(1708),
    [aux_sym_case_statement_repeat1] = STATE(3149),
    [aux_sym__literal_repeat1] = STATE(1712),
    [anon_sym_esac] = ACTIONS(6991),
    [anon_sym_DOLLAR] = ACTIONS(507),
    [sym__special_character] = ACTIONS(3518),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3522),
  },
  [2496] = {
    [sym__simple_heredoc_body] = ACTIONS(5325),
    [sym__heredoc_body_beginning] = ACTIONS(5325),
    [sym_file_descriptor] = ACTIONS(5325),
    [anon_sym_SEMI] = ACTIONS(5327),
    [anon_sym_PIPE] = ACTIONS(5327),
    [anon_sym_SEMI_SEMI] = ACTIONS(5325),
    [anon_sym_RBRACE] = ACTIONS(5325),
    [anon_sym_PIPE_AMP] = ACTIONS(5325),
    [anon_sym_AMP_AMP] = ACTIONS(5325),
    [anon_sym_PIPE_PIPE] = ACTIONS(5325),
    [anon_sym_LT] = ACTIONS(5327),
    [anon_sym_GT] = ACTIONS(5327),
    [anon_sym_GT_GT] = ACTIONS(5325),
    [anon_sym_AMP_GT] = ACTIONS(5327),
    [anon_sym_AMP_GT_GT] = ACTIONS(5325),
    [anon_sym_LT_AMP] = ACTIONS(5325),
    [anon_sym_GT_AMP] = ACTIONS(5325),
    [anon_sym_LT_LT] = ACTIONS(5327),
    [anon_sym_LT_LT_DASH] = ACTIONS(5325),
    [anon_sym_LT_LT_LT] = ACTIONS(5325),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5325),
    [anon_sym_AMP] = ACTIONS(5327),
  },
  [2497] = {
    [anon_sym_esac] = ACTIONS(6993),
    [sym_comment] = ACTIONS(57),
  },
  [2498] = {
    [sym_case_item] = STATE(2443),
    [sym_last_case_item] = STATE(3151),
    [sym_concatenation] = STATE(1710),
    [sym_string] = STATE(1708),
    [sym_simple_expansion] = STATE(1708),
    [sym_string_expansion] = STATE(1708),
    [sym_expansion] = STATE(1708),
    [sym_command_substitution] = STATE(1708),
    [sym_process_substitution] = STATE(1708),
    [aux_sym_case_statement_repeat1] = STATE(2443),
    [aux_sym__literal_repeat1] = STATE(1712),
    [anon_sym_DOLLAR] = ACTIONS(507),
    [sym__special_character] = ACTIONS(3518),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3520),
  },
  [2499] = {
    [sym_case_item] = STATE(3152),
    [sym_last_case_item] = STATE(3151),
    [sym_concatenation] = STATE(1710),
    [sym_string] = STATE(1708),
    [sym_simple_expansion] = STATE(1708),
    [sym_string_expansion] = STATE(1708),
    [sym_expansion] = STATE(1708),
    [sym_command_substitution] = STATE(1708),
    [sym_process_substitution] = STATE(1708),
    [aux_sym_case_statement_repeat1] = STATE(3152),
    [aux_sym__literal_repeat1] = STATE(1712),
    [anon_sym_esac] = ACTIONS(6995),
    [anon_sym_DOLLAR] = ACTIONS(507),
    [sym__special_character] = ACTIONS(3518),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3522),
  },
  [2500] = {
    [sym__simple_heredoc_body] = ACTIONS(5333),
    [sym__heredoc_body_beginning] = ACTIONS(5333),
    [sym_file_descriptor] = ACTIONS(5333),
    [anon_sym_SEMI] = ACTIONS(5335),
    [anon_sym_PIPE] = ACTIONS(5335),
    [anon_sym_SEMI_SEMI] = ACTIONS(5333),
    [anon_sym_RBRACE] = ACTIONS(5333),
    [anon_sym_PIPE_AMP] = ACTIONS(5333),
    [anon_sym_AMP_AMP] = ACTIONS(5333),
    [anon_sym_PIPE_PIPE] = ACTIONS(5333),
    [anon_sym_LT] = ACTIONS(5335),
    [anon_sym_GT] = ACTIONS(5335),
    [anon_sym_GT_GT] = ACTIONS(5333),
    [anon_sym_AMP_GT] = ACTIONS(5335),
    [anon_sym_AMP_GT_GT] = ACTIONS(5333),
    [anon_sym_LT_AMP] = ACTIONS(5333),
    [anon_sym_GT_AMP] = ACTIONS(5333),
    [anon_sym_LT_LT] = ACTIONS(5335),
    [anon_sym_LT_LT_DASH] = ACTIONS(5333),
    [anon_sym_LT_LT_LT] = ACTIONS(5333),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5333),
    [anon_sym_AMP] = ACTIONS(5335),
  },
  [2501] = {
    [sym__simple_heredoc_body] = ACTIONS(2719),
    [sym__heredoc_body_beginning] = ACTIONS(2719),
    [sym_file_descriptor] = ACTIONS(2719),
    [sym_variable_name] = ACTIONS(2719),
    [anon_sym_SEMI] = ACTIONS(2721),
    [anon_sym_PIPE] = ACTIONS(2721),
    [anon_sym_SEMI_SEMI] = ACTIONS(2719),
    [anon_sym_RBRACE] = ACTIONS(2719),
    [anon_sym_PIPE_AMP] = ACTIONS(2719),
    [anon_sym_AMP_AMP] = ACTIONS(2719),
    [anon_sym_PIPE_PIPE] = ACTIONS(2719),
    [anon_sym_LT] = ACTIONS(2721),
    [anon_sym_GT] = ACTIONS(2721),
    [anon_sym_GT_GT] = ACTIONS(2719),
    [anon_sym_AMP_GT] = ACTIONS(2721),
    [anon_sym_AMP_GT_GT] = ACTIONS(2719),
    [anon_sym_LT_AMP] = ACTIONS(2719),
    [anon_sym_GT_AMP] = ACTIONS(2719),
    [anon_sym_LT_LT] = ACTIONS(2721),
    [anon_sym_LT_LT_DASH] = ACTIONS(2719),
    [anon_sym_LT_LT_LT] = ACTIONS(2719),
    [anon_sym_DOLLAR] = ACTIONS(2721),
    [sym__special_character] = ACTIONS(2721),
    [anon_sym_DQUOTE] = ACTIONS(2719),
    [sym_raw_string] = ACTIONS(2719),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2719),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2719),
    [anon_sym_BQUOTE] = ACTIONS(2719),
    [anon_sym_LT_LPAREN] = ACTIONS(2719),
    [anon_sym_GT_LPAREN] = ACTIONS(2719),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2721),
    [sym_word] = ACTIONS(2721),
    [anon_sym_LF] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2721),
  },
  [2502] = {
    [sym_concatenation] = STATE(1368),
    [sym_string] = STATE(730),
    [sym_simple_expansion] = STATE(730),
    [sym_string_expansion] = STATE(730),
    [sym_expansion] = STATE(730),
    [sym_command_substitution] = STATE(730),
    [sym_process_substitution] = STATE(730),
    [aux_sym_for_statement_repeat1] = STATE(1368),
    [aux_sym__literal_repeat1] = STATE(736),
    [anon_sym_RPAREN] = ACTIONS(6997),
    [anon_sym_DOLLAR] = ACTIONS(1406),
    [sym__special_character] = ACTIONS(1408),
    [anon_sym_DQUOTE] = ACTIONS(1410),
    [sym_raw_string] = ACTIONS(1412),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1414),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1416),
    [anon_sym_BQUOTE] = ACTIONS(1418),
    [anon_sym_LT_LPAREN] = ACTIONS(1420),
    [anon_sym_GT_LPAREN] = ACTIONS(1420),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1412),
  },
  [2503] = {
    [sym_string] = STATE(1065),
    [sym__simple_heredoc_body] = ACTIONS(4071),
    [sym__heredoc_body_beginning] = ACTIONS(4071),
    [sym_file_descriptor] = ACTIONS(4071),
    [sym_variable_name] = ACTIONS(4071),
    [anon_sym_SEMI] = ACTIONS(4073),
    [anon_sym_PIPE] = ACTIONS(4073),
    [anon_sym_SEMI_SEMI] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(4071),
    [anon_sym_PIPE_AMP] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_PIPE_PIPE] = ACTIONS(4071),
    [anon_sym_LT] = ACTIONS(4073),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_GT_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT] = ACTIONS(4073),
    [anon_sym_AMP_GT_GT] = ACTIONS(4071),
    [anon_sym_LT_AMP] = ACTIONS(4071),
    [anon_sym_GT_AMP] = ACTIONS(4071),
    [anon_sym_LT_LT] = ACTIONS(4073),
    [anon_sym_LT_LT_DASH] = ACTIONS(4071),
    [anon_sym_LT_LT_LT] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(6999),
    [anon_sym_DOLLAR] = ACTIONS(6999),
    [sym__special_character] = ACTIONS(4073),
    [anon_sym_DQUOTE] = ACTIONS(793),
    [sym_raw_string] = ACTIONS(1979),
    [anon_sym_POUND] = ACTIONS(1977),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4071),
    [anon_sym_BQUOTE] = ACTIONS(4071),
    [anon_sym_LT_LPAREN] = ACTIONS(4071),
    [anon_sym_GT_LPAREN] = ACTIONS(4071),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1981),
    [anon_sym_STAR] = ACTIONS(1981),
    [anon_sym_AT] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(1981),
    [anon_sym_0] = ACTIONS(1981),
    [anon_sym__] = ACTIONS(1981),
    [sym_word] = ACTIONS(4073),
    [anon_sym_LF] = ACTIONS(4071),
    [anon_sym_AMP] = ACTIONS(4073),
  },
  [2504] = {
    [sym__simple_heredoc_body] = ACTIONS(4111),
    [sym__heredoc_body_beginning] = ACTIONS(4111),
    [sym_file_descriptor] = ACTIONS(4111),
    [sym__concat] = ACTIONS(4111),
    [sym_variable_name] = ACTIONS(4111),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_PIPE] = ACTIONS(4113),
    [anon_sym_SEMI_SEMI] = ACTIONS(4111),
    [anon_sym_RBRACE] = ACTIONS(4111),
    [anon_sym_PIPE_AMP] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_LT] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4113),
    [anon_sym_GT_GT] = ACTIONS(4111),
    [anon_sym_AMP_GT] = ACTIONS(4113),
    [anon_sym_AMP_GT_GT] = ACTIONS(4111),
    [anon_sym_LT_AMP] = ACTIONS(4111),
    [anon_sym_GT_AMP] = ACTIONS(4111),
    [anon_sym_LT_LT] = ACTIONS(4113),
    [anon_sym_LT_LT_DASH] = ACTIONS(4111),
    [anon_sym_LT_LT_LT] = ACTIONS(4111),
    [anon_sym_DOLLAR] = ACTIONS(4113),
    [sym__special_character] = ACTIONS(4113),
    [anon_sym_DQUOTE] = ACTIONS(4111),
    [sym_raw_string] = ACTIONS(4111),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4111),
    [anon_sym_BQUOTE] = ACTIONS(4111),
    [anon_sym_LT_LPAREN] = ACTIONS(4111),
    [anon_sym_GT_LPAREN] = ACTIONS(4111),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4113),
    [sym_word] = ACTIONS(4113),
    [anon_sym_LF] = ACTIONS(4111),
    [anon_sym_AMP] = ACTIONS(4113),
  },
  [2505] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [sym_variable_name] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_RBRACE] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym__special_character] = ACTIONS(4127),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4127),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [2506] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(7001),
    [sym_comment] = ACTIONS(57),
  },
  [2507] = {
    [anon_sym_RBRACE] = ACTIONS(7001),
    [sym_comment] = ACTIONS(57),
  },
  [2508] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [2509] = {
    [sym_concatenation] = STATE(3157),
    [sym_string] = STATE(3156),
    [sym_simple_expansion] = STATE(3156),
    [sym_string_expansion] = STATE(3156),
    [sym_expansion] = STATE(3156),
    [sym_command_substitution] = STATE(3156),
    [sym_process_substitution] = STATE(3156),
    [aux_sym__literal_repeat1] = STATE(3158),
    [anon_sym_RBRACE] = ACTIONS(7001),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(7005),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7005),
  },
  [2510] = {
    [sym__simple_heredoc_body] = ACTIONS(4161),
    [sym__heredoc_body_beginning] = ACTIONS(4161),
    [sym_file_descriptor] = ACTIONS(4161),
    [sym__concat] = ACTIONS(4161),
    [sym_variable_name] = ACTIONS(4161),
    [anon_sym_SEMI] = ACTIONS(4163),
    [anon_sym_PIPE] = ACTIONS(4163),
    [anon_sym_SEMI_SEMI] = ACTIONS(4161),
    [anon_sym_RBRACE] = ACTIONS(4161),
    [anon_sym_PIPE_AMP] = ACTIONS(4161),
    [anon_sym_AMP_AMP] = ACTIONS(4161),
    [anon_sym_PIPE_PIPE] = ACTIONS(4161),
    [anon_sym_LT] = ACTIONS(4163),
    [anon_sym_GT] = ACTIONS(4163),
    [anon_sym_GT_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT] = ACTIONS(4163),
    [anon_sym_AMP_GT_GT] = ACTIONS(4161),
    [anon_sym_LT_AMP] = ACTIONS(4161),
    [anon_sym_GT_AMP] = ACTIONS(4161),
    [anon_sym_LT_LT] = ACTIONS(4163),
    [anon_sym_LT_LT_DASH] = ACTIONS(4161),
    [anon_sym_LT_LT_LT] = ACTIONS(4161),
    [anon_sym_DOLLAR] = ACTIONS(4163),
    [sym__special_character] = ACTIONS(4163),
    [anon_sym_DQUOTE] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4161),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4161),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4161),
    [anon_sym_BQUOTE] = ACTIONS(4161),
    [anon_sym_LT_LPAREN] = ACTIONS(4161),
    [anon_sym_GT_LPAREN] = ACTIONS(4161),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4163),
    [sym_word] = ACTIONS(4163),
    [anon_sym_LF] = ACTIONS(4161),
    [anon_sym_AMP] = ACTIONS(4163),
  },
  [2511] = {
    [sym_concatenation] = STATE(3161),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3161),
    [sym_regex] = ACTIONS(7007),
    [anon_sym_RBRACE] = ACTIONS(7009),
    [anon_sym_EQ] = ACTIONS(7011),
    [anon_sym_DASH] = ACTIONS(7011),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7013),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7011),
    [anon_sym_COLON_QMARK] = ACTIONS(7011),
    [anon_sym_COLON_DASH] = ACTIONS(7011),
    [anon_sym_PERCENT] = ACTIONS(7011),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2512] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7009),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2513] = {
    [sym_concatenation] = STATE(3163),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3163),
    [sym_regex] = ACTIONS(7015),
    [anon_sym_RBRACE] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7017),
    [anon_sym_DASH] = ACTIONS(7017),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7019),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7017),
    [anon_sym_COLON_QMARK] = ACTIONS(7017),
    [anon_sym_COLON_DASH] = ACTIONS(7017),
    [anon_sym_PERCENT] = ACTIONS(7017),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2514] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2515] = {
    [sym_concatenation] = STATE(3165),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3165),
    [anon_sym_RBRACE] = ACTIONS(7021),
    [anon_sym_EQ] = ACTIONS(7023),
    [anon_sym_DASH] = ACTIONS(7023),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7025),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7023),
    [anon_sym_COLON_QMARK] = ACTIONS(7023),
    [anon_sym_COLON_DASH] = ACTIONS(7023),
    [anon_sym_PERCENT] = ACTIONS(7023),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2516] = {
    [sym__simple_heredoc_body] = ACTIONS(4219),
    [sym__heredoc_body_beginning] = ACTIONS(4219),
    [sym_file_descriptor] = ACTIONS(4219),
    [sym__concat] = ACTIONS(4219),
    [sym_variable_name] = ACTIONS(4219),
    [anon_sym_SEMI] = ACTIONS(4221),
    [anon_sym_PIPE] = ACTIONS(4221),
    [anon_sym_SEMI_SEMI] = ACTIONS(4219),
    [anon_sym_RBRACE] = ACTIONS(4219),
    [anon_sym_PIPE_AMP] = ACTIONS(4219),
    [anon_sym_AMP_AMP] = ACTIONS(4219),
    [anon_sym_PIPE_PIPE] = ACTIONS(4219),
    [anon_sym_LT] = ACTIONS(4221),
    [anon_sym_GT] = ACTIONS(4221),
    [anon_sym_GT_GT] = ACTIONS(4219),
    [anon_sym_AMP_GT] = ACTIONS(4221),
    [anon_sym_AMP_GT_GT] = ACTIONS(4219),
    [anon_sym_LT_AMP] = ACTIONS(4219),
    [anon_sym_GT_AMP] = ACTIONS(4219),
    [anon_sym_LT_LT] = ACTIONS(4221),
    [anon_sym_LT_LT_DASH] = ACTIONS(4219),
    [anon_sym_LT_LT_LT] = ACTIONS(4219),
    [anon_sym_DOLLAR] = ACTIONS(4221),
    [sym__special_character] = ACTIONS(4221),
    [anon_sym_DQUOTE] = ACTIONS(4219),
    [sym_raw_string] = ACTIONS(4219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4219),
    [anon_sym_BQUOTE] = ACTIONS(4219),
    [anon_sym_LT_LPAREN] = ACTIONS(4219),
    [anon_sym_GT_LPAREN] = ACTIONS(4219),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4221),
    [sym_word] = ACTIONS(4221),
    [anon_sym_LF] = ACTIONS(4219),
    [anon_sym_AMP] = ACTIONS(4221),
  },
  [2517] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7021),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2518] = {
    [sym_concatenation] = STATE(3163),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3163),
    [anon_sym_RBRACE] = ACTIONS(7001),
    [anon_sym_EQ] = ACTIONS(7017),
    [anon_sym_DASH] = ACTIONS(7017),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7019),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7017),
    [anon_sym_COLON_QMARK] = ACTIONS(7017),
    [anon_sym_COLON_DASH] = ACTIONS(7017),
    [anon_sym_PERCENT] = ACTIONS(7017),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2519] = {
    [sym_string] = STATE(1084),
    [sym__simple_heredoc_body] = ACTIONS(4071),
    [sym__heredoc_body_beginning] = ACTIONS(4071),
    [sym_file_descriptor] = ACTIONS(4071),
    [anon_sym_SEMI] = ACTIONS(4073),
    [anon_sym_PIPE] = ACTIONS(4073),
    [anon_sym_SEMI_SEMI] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(4071),
    [anon_sym_PIPE_AMP] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_PIPE_PIPE] = ACTIONS(4071),
    [anon_sym_LT] = ACTIONS(4073),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_GT_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT] = ACTIONS(4073),
    [anon_sym_AMP_GT_GT] = ACTIONS(4071),
    [anon_sym_LT_AMP] = ACTIONS(4071),
    [anon_sym_GT_AMP] = ACTIONS(4071),
    [anon_sym_LT_LT] = ACTIONS(4073),
    [anon_sym_LT_LT_DASH] = ACTIONS(4071),
    [anon_sym_LT_LT_LT] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(7027),
    [anon_sym_DOLLAR] = ACTIONS(7027),
    [sym__special_character] = ACTIONS(4073),
    [anon_sym_DQUOTE] = ACTIONS(813),
    [sym_raw_string] = ACTIONS(2007),
    [anon_sym_POUND] = ACTIONS(2005),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4071),
    [anon_sym_BQUOTE] = ACTIONS(4071),
    [anon_sym_LT_LPAREN] = ACTIONS(4071),
    [anon_sym_GT_LPAREN] = ACTIONS(4071),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2009),
    [anon_sym_STAR] = ACTIONS(2009),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_QMARK] = ACTIONS(2009),
    [anon_sym_0] = ACTIONS(2009),
    [anon_sym__] = ACTIONS(2009),
    [sym_word] = ACTIONS(4073),
    [anon_sym_LF] = ACTIONS(4071),
    [anon_sym_AMP] = ACTIONS(4073),
  },
  [2520] = {
    [sym__simple_heredoc_body] = ACTIONS(4111),
    [sym__heredoc_body_beginning] = ACTIONS(4111),
    [sym_file_descriptor] = ACTIONS(4111),
    [sym__concat] = ACTIONS(4111),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_PIPE] = ACTIONS(4113),
    [anon_sym_SEMI_SEMI] = ACTIONS(4111),
    [anon_sym_RBRACE] = ACTIONS(4111),
    [anon_sym_PIPE_AMP] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_LT] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4113),
    [anon_sym_GT_GT] = ACTIONS(4111),
    [anon_sym_AMP_GT] = ACTIONS(4113),
    [anon_sym_AMP_GT_GT] = ACTIONS(4111),
    [anon_sym_LT_AMP] = ACTIONS(4111),
    [anon_sym_GT_AMP] = ACTIONS(4111),
    [anon_sym_LT_LT] = ACTIONS(4113),
    [anon_sym_LT_LT_DASH] = ACTIONS(4111),
    [anon_sym_LT_LT_LT] = ACTIONS(4111),
    [anon_sym_DOLLAR] = ACTIONS(4113),
    [sym__special_character] = ACTIONS(4113),
    [anon_sym_DQUOTE] = ACTIONS(4111),
    [sym_raw_string] = ACTIONS(4111),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4111),
    [anon_sym_BQUOTE] = ACTIONS(4111),
    [anon_sym_LT_LPAREN] = ACTIONS(4111),
    [anon_sym_GT_LPAREN] = ACTIONS(4111),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4113),
    [sym_word] = ACTIONS(4113),
    [anon_sym_LF] = ACTIONS(4111),
    [anon_sym_AMP] = ACTIONS(4113),
  },
  [2521] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_RBRACE] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym__special_character] = ACTIONS(4127),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4127),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [2522] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(7029),
    [sym_comment] = ACTIONS(57),
  },
  [2523] = {
    [anon_sym_RBRACE] = ACTIONS(7029),
    [sym_comment] = ACTIONS(57),
  },
  [2524] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(7031),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [2525] = {
    [sym_concatenation] = STATE(3169),
    [sym_string] = STATE(3168),
    [sym_simple_expansion] = STATE(3168),
    [sym_string_expansion] = STATE(3168),
    [sym_expansion] = STATE(3168),
    [sym_command_substitution] = STATE(3168),
    [sym_process_substitution] = STATE(3168),
    [aux_sym__literal_repeat1] = STATE(3170),
    [anon_sym_RBRACE] = ACTIONS(7029),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(7033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7033),
  },
  [2526] = {
    [sym__simple_heredoc_body] = ACTIONS(4161),
    [sym__heredoc_body_beginning] = ACTIONS(4161),
    [sym_file_descriptor] = ACTIONS(4161),
    [sym__concat] = ACTIONS(4161),
    [anon_sym_SEMI] = ACTIONS(4163),
    [anon_sym_PIPE] = ACTIONS(4163),
    [anon_sym_SEMI_SEMI] = ACTIONS(4161),
    [anon_sym_RBRACE] = ACTIONS(4161),
    [anon_sym_PIPE_AMP] = ACTIONS(4161),
    [anon_sym_AMP_AMP] = ACTIONS(4161),
    [anon_sym_PIPE_PIPE] = ACTIONS(4161),
    [anon_sym_LT] = ACTIONS(4163),
    [anon_sym_GT] = ACTIONS(4163),
    [anon_sym_GT_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT] = ACTIONS(4163),
    [anon_sym_AMP_GT_GT] = ACTIONS(4161),
    [anon_sym_LT_AMP] = ACTIONS(4161),
    [anon_sym_GT_AMP] = ACTIONS(4161),
    [anon_sym_LT_LT] = ACTIONS(4163),
    [anon_sym_LT_LT_DASH] = ACTIONS(4161),
    [anon_sym_LT_LT_LT] = ACTIONS(4161),
    [anon_sym_DOLLAR] = ACTIONS(4163),
    [sym__special_character] = ACTIONS(4163),
    [anon_sym_DQUOTE] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4161),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4161),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4161),
    [anon_sym_BQUOTE] = ACTIONS(4161),
    [anon_sym_LT_LPAREN] = ACTIONS(4161),
    [anon_sym_GT_LPAREN] = ACTIONS(4161),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4163),
    [sym_word] = ACTIONS(4163),
    [anon_sym_LF] = ACTIONS(4161),
    [anon_sym_AMP] = ACTIONS(4163),
  },
  [2527] = {
    [sym_concatenation] = STATE(3173),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3173),
    [sym_regex] = ACTIONS(7035),
    [anon_sym_RBRACE] = ACTIONS(7037),
    [anon_sym_EQ] = ACTIONS(7039),
    [anon_sym_DASH] = ACTIONS(7039),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7041),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7039),
    [anon_sym_COLON_QMARK] = ACTIONS(7039),
    [anon_sym_COLON_DASH] = ACTIONS(7039),
    [anon_sym_PERCENT] = ACTIONS(7039),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2528] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7037),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2529] = {
    [sym_concatenation] = STATE(3175),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3175),
    [sym_regex] = ACTIONS(7043),
    [anon_sym_RBRACE] = ACTIONS(7029),
    [anon_sym_EQ] = ACTIONS(7045),
    [anon_sym_DASH] = ACTIONS(7045),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7045),
    [anon_sym_COLON_QMARK] = ACTIONS(7045),
    [anon_sym_COLON_DASH] = ACTIONS(7045),
    [anon_sym_PERCENT] = ACTIONS(7045),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2530] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7029),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2531] = {
    [sym_concatenation] = STATE(3177),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3177),
    [anon_sym_RBRACE] = ACTIONS(7049),
    [anon_sym_EQ] = ACTIONS(7051),
    [anon_sym_DASH] = ACTIONS(7051),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7051),
    [anon_sym_COLON_QMARK] = ACTIONS(7051),
    [anon_sym_COLON_DASH] = ACTIONS(7051),
    [anon_sym_PERCENT] = ACTIONS(7051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2532] = {
    [sym__simple_heredoc_body] = ACTIONS(4219),
    [sym__heredoc_body_beginning] = ACTIONS(4219),
    [sym_file_descriptor] = ACTIONS(4219),
    [sym__concat] = ACTIONS(4219),
    [anon_sym_SEMI] = ACTIONS(4221),
    [anon_sym_PIPE] = ACTIONS(4221),
    [anon_sym_SEMI_SEMI] = ACTIONS(4219),
    [anon_sym_RBRACE] = ACTIONS(4219),
    [anon_sym_PIPE_AMP] = ACTIONS(4219),
    [anon_sym_AMP_AMP] = ACTIONS(4219),
    [anon_sym_PIPE_PIPE] = ACTIONS(4219),
    [anon_sym_LT] = ACTIONS(4221),
    [anon_sym_GT] = ACTIONS(4221),
    [anon_sym_GT_GT] = ACTIONS(4219),
    [anon_sym_AMP_GT] = ACTIONS(4221),
    [anon_sym_AMP_GT_GT] = ACTIONS(4219),
    [anon_sym_LT_AMP] = ACTIONS(4219),
    [anon_sym_GT_AMP] = ACTIONS(4219),
    [anon_sym_LT_LT] = ACTIONS(4221),
    [anon_sym_LT_LT_DASH] = ACTIONS(4219),
    [anon_sym_LT_LT_LT] = ACTIONS(4219),
    [anon_sym_DOLLAR] = ACTIONS(4221),
    [sym__special_character] = ACTIONS(4221),
    [anon_sym_DQUOTE] = ACTIONS(4219),
    [sym_raw_string] = ACTIONS(4219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4219),
    [anon_sym_BQUOTE] = ACTIONS(4219),
    [anon_sym_LT_LPAREN] = ACTIONS(4219),
    [anon_sym_GT_LPAREN] = ACTIONS(4219),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4221),
    [sym_word] = ACTIONS(4221),
    [anon_sym_LF] = ACTIONS(4219),
    [anon_sym_AMP] = ACTIONS(4221),
  },
  [2533] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7049),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2534] = {
    [sym_concatenation] = STATE(3175),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3175),
    [anon_sym_RBRACE] = ACTIONS(7029),
    [anon_sym_EQ] = ACTIONS(7045),
    [anon_sym_DASH] = ACTIONS(7045),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7045),
    [anon_sym_COLON_QMARK] = ACTIONS(7045),
    [anon_sym_COLON_DASH] = ACTIONS(7045),
    [anon_sym_PERCENT] = ACTIONS(7045),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2535] = {
    [sym__simple_heredoc_body] = ACTIONS(5674),
    [sym__heredoc_body_beginning] = ACTIONS(5674),
    [sym_file_descriptor] = ACTIONS(5674),
    [sym__concat] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(5676),
    [anon_sym_PIPE] = ACTIONS(5676),
    [anon_sym_SEMI_SEMI] = ACTIONS(5674),
    [anon_sym_RBRACE] = ACTIONS(5674),
    [anon_sym_PIPE_AMP] = ACTIONS(5674),
    [anon_sym_AMP_AMP] = ACTIONS(5674),
    [anon_sym_PIPE_PIPE] = ACTIONS(5674),
    [anon_sym_EQ_TILDE] = ACTIONS(5676),
    [anon_sym_EQ_EQ] = ACTIONS(5676),
    [anon_sym_LT] = ACTIONS(5676),
    [anon_sym_GT] = ACTIONS(5676),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_AMP_GT] = ACTIONS(5676),
    [anon_sym_AMP_GT_GT] = ACTIONS(5674),
    [anon_sym_LT_AMP] = ACTIONS(5674),
    [anon_sym_GT_AMP] = ACTIONS(5674),
    [anon_sym_LT_LT] = ACTIONS(5676),
    [anon_sym_LT_LT_DASH] = ACTIONS(5674),
    [anon_sym_LT_LT_LT] = ACTIONS(5674),
    [anon_sym_DOLLAR] = ACTIONS(5676),
    [sym__special_character] = ACTIONS(5676),
    [anon_sym_DQUOTE] = ACTIONS(5674),
    [sym_raw_string] = ACTIONS(5674),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5674),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5674),
    [anon_sym_BQUOTE] = ACTIONS(5674),
    [anon_sym_LT_LPAREN] = ACTIONS(5674),
    [anon_sym_GT_LPAREN] = ACTIONS(5674),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5676),
    [anon_sym_LF] = ACTIONS(5674),
    [anon_sym_AMP] = ACTIONS(5676),
  },
  [2536] = {
    [sym__simple_heredoc_body] = ACTIONS(5708),
    [sym__heredoc_body_beginning] = ACTIONS(5708),
    [sym_file_descriptor] = ACTIONS(5708),
    [sym__concat] = ACTIONS(5708),
    [anon_sym_SEMI] = ACTIONS(5710),
    [anon_sym_PIPE] = ACTIONS(5710),
    [anon_sym_SEMI_SEMI] = ACTIONS(5708),
    [anon_sym_RBRACE] = ACTIONS(5708),
    [anon_sym_PIPE_AMP] = ACTIONS(5708),
    [anon_sym_AMP_AMP] = ACTIONS(5708),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_EQ_TILDE] = ACTIONS(5710),
    [anon_sym_EQ_EQ] = ACTIONS(5710),
    [anon_sym_LT] = ACTIONS(5710),
    [anon_sym_GT] = ACTIONS(5710),
    [anon_sym_GT_GT] = ACTIONS(5708),
    [anon_sym_AMP_GT] = ACTIONS(5710),
    [anon_sym_AMP_GT_GT] = ACTIONS(5708),
    [anon_sym_LT_AMP] = ACTIONS(5708),
    [anon_sym_GT_AMP] = ACTIONS(5708),
    [anon_sym_LT_LT] = ACTIONS(5710),
    [anon_sym_LT_LT_DASH] = ACTIONS(5708),
    [anon_sym_LT_LT_LT] = ACTIONS(5708),
    [anon_sym_DOLLAR] = ACTIONS(5710),
    [sym__special_character] = ACTIONS(5710),
    [anon_sym_DQUOTE] = ACTIONS(5708),
    [sym_raw_string] = ACTIONS(5708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5708),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5708),
    [anon_sym_BQUOTE] = ACTIONS(5708),
    [anon_sym_LT_LPAREN] = ACTIONS(5708),
    [anon_sym_GT_LPAREN] = ACTIONS(5708),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5710),
    [anon_sym_LF] = ACTIONS(5708),
    [anon_sym_AMP] = ACTIONS(5710),
  },
  [2537] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(7055),
    [sym_comment] = ACTIONS(57),
  },
  [2538] = {
    [anon_sym_RBRACE] = ACTIONS(7055),
    [sym_comment] = ACTIONS(57),
  },
  [2539] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(7057),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [2540] = {
    [sym_concatenation] = STATE(3181),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3181),
    [anon_sym_RBRACE] = ACTIONS(7059),
    [anon_sym_EQ] = ACTIONS(7061),
    [anon_sym_DASH] = ACTIONS(7061),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7063),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7061),
    [anon_sym_COLON_QMARK] = ACTIONS(7061),
    [anon_sym_COLON_DASH] = ACTIONS(7061),
    [anon_sym_PERCENT] = ACTIONS(7061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2541] = {
    [sym__simple_heredoc_body] = ACTIONS(5725),
    [sym__heredoc_body_beginning] = ACTIONS(5725),
    [sym_file_descriptor] = ACTIONS(5725),
    [sym__concat] = ACTIONS(5725),
    [anon_sym_SEMI] = ACTIONS(5727),
    [anon_sym_PIPE] = ACTIONS(5727),
    [anon_sym_SEMI_SEMI] = ACTIONS(5725),
    [anon_sym_RBRACE] = ACTIONS(5725),
    [anon_sym_PIPE_AMP] = ACTIONS(5725),
    [anon_sym_AMP_AMP] = ACTIONS(5725),
    [anon_sym_PIPE_PIPE] = ACTIONS(5725),
    [anon_sym_EQ_TILDE] = ACTIONS(5727),
    [anon_sym_EQ_EQ] = ACTIONS(5727),
    [anon_sym_LT] = ACTIONS(5727),
    [anon_sym_GT] = ACTIONS(5727),
    [anon_sym_GT_GT] = ACTIONS(5725),
    [anon_sym_AMP_GT] = ACTIONS(5727),
    [anon_sym_AMP_GT_GT] = ACTIONS(5725),
    [anon_sym_LT_AMP] = ACTIONS(5725),
    [anon_sym_GT_AMP] = ACTIONS(5725),
    [anon_sym_LT_LT] = ACTIONS(5727),
    [anon_sym_LT_LT_DASH] = ACTIONS(5725),
    [anon_sym_LT_LT_LT] = ACTIONS(5725),
    [anon_sym_DOLLAR] = ACTIONS(5727),
    [sym__special_character] = ACTIONS(5727),
    [anon_sym_DQUOTE] = ACTIONS(5725),
    [sym_raw_string] = ACTIONS(5725),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5725),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5725),
    [anon_sym_BQUOTE] = ACTIONS(5725),
    [anon_sym_LT_LPAREN] = ACTIONS(5725),
    [anon_sym_GT_LPAREN] = ACTIONS(5725),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5727),
    [anon_sym_LF] = ACTIONS(5725),
    [anon_sym_AMP] = ACTIONS(5727),
  },
  [2542] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7059),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2543] = {
    [sym_concatenation] = STATE(3182),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3182),
    [anon_sym_RBRACE] = ACTIONS(7055),
    [anon_sym_EQ] = ACTIONS(7065),
    [anon_sym_DASH] = ACTIONS(7065),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7067),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7065),
    [anon_sym_COLON_QMARK] = ACTIONS(7065),
    [anon_sym_COLON_DASH] = ACTIONS(7065),
    [anon_sym_PERCENT] = ACTIONS(7065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2544] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7055),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2545] = {
    [sym__simple_heredoc_body] = ACTIONS(5770),
    [sym__heredoc_body_beginning] = ACTIONS(5770),
    [sym_file_descriptor] = ACTIONS(5770),
    [sym__concat] = ACTIONS(5770),
    [anon_sym_SEMI] = ACTIONS(5772),
    [anon_sym_PIPE] = ACTIONS(5772),
    [anon_sym_SEMI_SEMI] = ACTIONS(5770),
    [anon_sym_RBRACE] = ACTIONS(5770),
    [anon_sym_PIPE_AMP] = ACTIONS(5770),
    [anon_sym_AMP_AMP] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5770),
    [anon_sym_EQ_TILDE] = ACTIONS(5772),
    [anon_sym_EQ_EQ] = ACTIONS(5772),
    [anon_sym_LT] = ACTIONS(5772),
    [anon_sym_GT] = ACTIONS(5772),
    [anon_sym_GT_GT] = ACTIONS(5770),
    [anon_sym_AMP_GT] = ACTIONS(5772),
    [anon_sym_AMP_GT_GT] = ACTIONS(5770),
    [anon_sym_LT_AMP] = ACTIONS(5770),
    [anon_sym_GT_AMP] = ACTIONS(5770),
    [anon_sym_LT_LT] = ACTIONS(5772),
    [anon_sym_LT_LT_DASH] = ACTIONS(5770),
    [anon_sym_LT_LT_LT] = ACTIONS(5770),
    [anon_sym_DOLLAR] = ACTIONS(5772),
    [sym__special_character] = ACTIONS(5772),
    [anon_sym_DQUOTE] = ACTIONS(5770),
    [sym_raw_string] = ACTIONS(5770),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5770),
    [anon_sym_BQUOTE] = ACTIONS(5770),
    [anon_sym_LT_LPAREN] = ACTIONS(5770),
    [anon_sym_GT_LPAREN] = ACTIONS(5770),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5772),
    [anon_sym_LF] = ACTIONS(5770),
    [anon_sym_AMP] = ACTIONS(5772),
  },
  [2546] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7069),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2547] = {
    [sym_string] = STATE(1102),
    [sym_simple_expansion] = STATE(1102),
    [sym_string_expansion] = STATE(1102),
    [sym_expansion] = STATE(1102),
    [sym_command_substitution] = STATE(1102),
    [sym_process_substitution] = STATE(1102),
    [anon_sym_DOLLAR] = ACTIONS(7071),
    [sym__special_character] = ACTIONS(2033),
    [anon_sym_DQUOTE] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(2033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2033),
  },
  [2548] = {
    [aux_sym_concatenation_repeat1] = STATE(2548),
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(3828),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_RBRACE] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [2549] = {
    [sym_file_descriptor] = ACTIONS(4449),
    [sym_variable_name] = ACTIONS(4449),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_GT_GT] = ACTIONS(4449),
    [anon_sym_AMP_GT] = ACTIONS(4451),
    [anon_sym_AMP_GT_GT] = ACTIONS(4449),
    [anon_sym_LT_AMP] = ACTIONS(4449),
    [anon_sym_GT_AMP] = ACTIONS(4449),
    [anon_sym_DOLLAR] = ACTIONS(4451),
    [sym__special_character] = ACTIONS(4449),
    [anon_sym_DQUOTE] = ACTIONS(4449),
    [sym_raw_string] = ACTIONS(4449),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4449),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4449),
    [anon_sym_BQUOTE] = ACTIONS(4449),
    [anon_sym_LT_LPAREN] = ACTIONS(4449),
    [anon_sym_GT_LPAREN] = ACTIONS(4449),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4449),
  },
  [2550] = {
    [sym__concat] = ACTIONS(5674),
    [anon_sym_AMP_AMP] = ACTIONS(5674),
    [anon_sym_PIPE_PIPE] = ACTIONS(5674),
    [anon_sym_RBRACK] = ACTIONS(5674),
    [anon_sym_EQ_TILDE] = ACTIONS(5674),
    [anon_sym_EQ_EQ] = ACTIONS(5674),
    [anon_sym_EQ] = ACTIONS(5676),
    [anon_sym_PLUS_EQ] = ACTIONS(5674),
    [anon_sym_LT] = ACTIONS(5676),
    [anon_sym_GT] = ACTIONS(5676),
    [anon_sym_BANG_EQ] = ACTIONS(5674),
    [anon_sym_PLUS] = ACTIONS(5676),
    [anon_sym_DASH] = ACTIONS(5676),
    [anon_sym_DASH_EQ] = ACTIONS(5674),
    [anon_sym_LT_EQ] = ACTIONS(5674),
    [anon_sym_GT_EQ] = ACTIONS(5674),
    [anon_sym_PLUS_PLUS] = ACTIONS(5674),
    [anon_sym_DASH_DASH] = ACTIONS(5674),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5674),
  },
  [2551] = {
    [sym__concat] = ACTIONS(5708),
    [anon_sym_AMP_AMP] = ACTIONS(5708),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_RBRACK] = ACTIONS(5708),
    [anon_sym_EQ_TILDE] = ACTIONS(5708),
    [anon_sym_EQ_EQ] = ACTIONS(5708),
    [anon_sym_EQ] = ACTIONS(5710),
    [anon_sym_PLUS_EQ] = ACTIONS(5708),
    [anon_sym_LT] = ACTIONS(5710),
    [anon_sym_GT] = ACTIONS(5710),
    [anon_sym_BANG_EQ] = ACTIONS(5708),
    [anon_sym_PLUS] = ACTIONS(5710),
    [anon_sym_DASH] = ACTIONS(5710),
    [anon_sym_DASH_EQ] = ACTIONS(5708),
    [anon_sym_LT_EQ] = ACTIONS(5708),
    [anon_sym_GT_EQ] = ACTIONS(5708),
    [anon_sym_PLUS_PLUS] = ACTIONS(5708),
    [anon_sym_DASH_DASH] = ACTIONS(5708),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5708),
  },
  [2552] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(7073),
    [sym_comment] = ACTIONS(57),
  },
  [2553] = {
    [anon_sym_RBRACE] = ACTIONS(7073),
    [sym_comment] = ACTIONS(57),
  },
  [2554] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(7075),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [2555] = {
    [sym_concatenation] = STATE(3188),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3188),
    [anon_sym_RBRACE] = ACTIONS(7077),
    [anon_sym_EQ] = ACTIONS(7079),
    [anon_sym_DASH] = ACTIONS(7079),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7081),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7079),
    [anon_sym_COLON_QMARK] = ACTIONS(7079),
    [anon_sym_COLON_DASH] = ACTIONS(7079),
    [anon_sym_PERCENT] = ACTIONS(7079),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2556] = {
    [sym__concat] = ACTIONS(5725),
    [anon_sym_AMP_AMP] = ACTIONS(5725),
    [anon_sym_PIPE_PIPE] = ACTIONS(5725),
    [anon_sym_RBRACK] = ACTIONS(5725),
    [anon_sym_EQ_TILDE] = ACTIONS(5725),
    [anon_sym_EQ_EQ] = ACTIONS(5725),
    [anon_sym_EQ] = ACTIONS(5727),
    [anon_sym_PLUS_EQ] = ACTIONS(5725),
    [anon_sym_LT] = ACTIONS(5727),
    [anon_sym_GT] = ACTIONS(5727),
    [anon_sym_BANG_EQ] = ACTIONS(5725),
    [anon_sym_PLUS] = ACTIONS(5727),
    [anon_sym_DASH] = ACTIONS(5727),
    [anon_sym_DASH_EQ] = ACTIONS(5725),
    [anon_sym_LT_EQ] = ACTIONS(5725),
    [anon_sym_GT_EQ] = ACTIONS(5725),
    [anon_sym_PLUS_PLUS] = ACTIONS(5725),
    [anon_sym_DASH_DASH] = ACTIONS(5725),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5725),
  },
  [2557] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7077),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2558] = {
    [sym_concatenation] = STATE(3189),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3189),
    [anon_sym_RBRACE] = ACTIONS(7073),
    [anon_sym_EQ] = ACTIONS(7083),
    [anon_sym_DASH] = ACTIONS(7083),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7085),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7083),
    [anon_sym_COLON_QMARK] = ACTIONS(7083),
    [anon_sym_COLON_DASH] = ACTIONS(7083),
    [anon_sym_PERCENT] = ACTIONS(7083),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2559] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7073),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2560] = {
    [sym__concat] = ACTIONS(5770),
    [anon_sym_AMP_AMP] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5770),
    [anon_sym_RBRACK] = ACTIONS(5770),
    [anon_sym_EQ_TILDE] = ACTIONS(5770),
    [anon_sym_EQ_EQ] = ACTIONS(5770),
    [anon_sym_EQ] = ACTIONS(5772),
    [anon_sym_PLUS_EQ] = ACTIONS(5770),
    [anon_sym_LT] = ACTIONS(5772),
    [anon_sym_GT] = ACTIONS(5772),
    [anon_sym_BANG_EQ] = ACTIONS(5770),
    [anon_sym_PLUS] = ACTIONS(5772),
    [anon_sym_DASH] = ACTIONS(5772),
    [anon_sym_DASH_EQ] = ACTIONS(5770),
    [anon_sym_LT_EQ] = ACTIONS(5770),
    [anon_sym_GT_EQ] = ACTIONS(5770),
    [anon_sym_PLUS_PLUS] = ACTIONS(5770),
    [anon_sym_DASH_DASH] = ACTIONS(5770),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5770),
  },
  [2561] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7087),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2562] = {
    [sym__simple_heredoc_body] = ACTIONS(4449),
    [sym__heredoc_body_beginning] = ACTIONS(4449),
    [sym_file_descriptor] = ACTIONS(4449),
    [sym_variable_name] = ACTIONS(4449),
    [ts_builtin_sym_end] = ACTIONS(4449),
    [anon_sym_SEMI] = ACTIONS(4451),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_RPAREN] = ACTIONS(4449),
    [anon_sym_SEMI_SEMI] = ACTIONS(4449),
    [anon_sym_PIPE_AMP] = ACTIONS(4449),
    [anon_sym_AMP_AMP] = ACTIONS(4449),
    [anon_sym_PIPE_PIPE] = ACTIONS(4449),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_GT_GT] = ACTIONS(4449),
    [anon_sym_AMP_GT] = ACTIONS(4451),
    [anon_sym_AMP_GT_GT] = ACTIONS(4449),
    [anon_sym_LT_AMP] = ACTIONS(4449),
    [anon_sym_GT_AMP] = ACTIONS(4449),
    [anon_sym_LT_LT] = ACTIONS(4451),
    [anon_sym_LT_LT_DASH] = ACTIONS(4449),
    [anon_sym_LT_LT_LT] = ACTIONS(4449),
    [anon_sym_DOLLAR] = ACTIONS(4451),
    [sym__special_character] = ACTIONS(4449),
    [anon_sym_DQUOTE] = ACTIONS(4449),
    [sym_raw_string] = ACTIONS(4449),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4449),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4449),
    [anon_sym_BQUOTE] = ACTIONS(4449),
    [anon_sym_LT_LPAREN] = ACTIONS(4449),
    [anon_sym_GT_LPAREN] = ACTIONS(4449),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4451),
    [sym_word] = ACTIONS(4451),
    [anon_sym_LF] = ACTIONS(4449),
    [anon_sym_AMP] = ACTIONS(4451),
  },
  [2563] = {
    [sym__simple_heredoc_body] = ACTIONS(5674),
    [sym__heredoc_body_beginning] = ACTIONS(5674),
    [sym_file_descriptor] = ACTIONS(5674),
    [sym__concat] = ACTIONS(5674),
    [sym_variable_name] = ACTIONS(5674),
    [ts_builtin_sym_end] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(5676),
    [anon_sym_PIPE] = ACTIONS(5676),
    [anon_sym_RPAREN] = ACTIONS(5674),
    [anon_sym_SEMI_SEMI] = ACTIONS(5674),
    [anon_sym_PIPE_AMP] = ACTIONS(5674),
    [anon_sym_AMP_AMP] = ACTIONS(5674),
    [anon_sym_PIPE_PIPE] = ACTIONS(5674),
    [anon_sym_LT] = ACTIONS(5676),
    [anon_sym_GT] = ACTIONS(5676),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_AMP_GT] = ACTIONS(5676),
    [anon_sym_AMP_GT_GT] = ACTIONS(5674),
    [anon_sym_LT_AMP] = ACTIONS(5674),
    [anon_sym_GT_AMP] = ACTIONS(5674),
    [anon_sym_LT_LT] = ACTIONS(5676),
    [anon_sym_LT_LT_DASH] = ACTIONS(5674),
    [anon_sym_LT_LT_LT] = ACTIONS(5674),
    [anon_sym_DOLLAR] = ACTIONS(5676),
    [sym__special_character] = ACTIONS(5674),
    [anon_sym_DQUOTE] = ACTIONS(5674),
    [sym_raw_string] = ACTIONS(5674),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5674),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5674),
    [anon_sym_BQUOTE] = ACTIONS(5674),
    [anon_sym_LT_LPAREN] = ACTIONS(5674),
    [anon_sym_GT_LPAREN] = ACTIONS(5674),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5676),
    [sym_word] = ACTIONS(5676),
    [anon_sym_LF] = ACTIONS(5674),
    [anon_sym_AMP] = ACTIONS(5676),
  },
  [2564] = {
    [sym__simple_heredoc_body] = ACTIONS(5708),
    [sym__heredoc_body_beginning] = ACTIONS(5708),
    [sym_file_descriptor] = ACTIONS(5708),
    [sym__concat] = ACTIONS(5708),
    [sym_variable_name] = ACTIONS(5708),
    [ts_builtin_sym_end] = ACTIONS(5708),
    [anon_sym_SEMI] = ACTIONS(5710),
    [anon_sym_PIPE] = ACTIONS(5710),
    [anon_sym_RPAREN] = ACTIONS(5708),
    [anon_sym_SEMI_SEMI] = ACTIONS(5708),
    [anon_sym_PIPE_AMP] = ACTIONS(5708),
    [anon_sym_AMP_AMP] = ACTIONS(5708),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_LT] = ACTIONS(5710),
    [anon_sym_GT] = ACTIONS(5710),
    [anon_sym_GT_GT] = ACTIONS(5708),
    [anon_sym_AMP_GT] = ACTIONS(5710),
    [anon_sym_AMP_GT_GT] = ACTIONS(5708),
    [anon_sym_LT_AMP] = ACTIONS(5708),
    [anon_sym_GT_AMP] = ACTIONS(5708),
    [anon_sym_LT_LT] = ACTIONS(5710),
    [anon_sym_LT_LT_DASH] = ACTIONS(5708),
    [anon_sym_LT_LT_LT] = ACTIONS(5708),
    [anon_sym_DOLLAR] = ACTIONS(5710),
    [sym__special_character] = ACTIONS(5708),
    [anon_sym_DQUOTE] = ACTIONS(5708),
    [sym_raw_string] = ACTIONS(5708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5708),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5708),
    [anon_sym_BQUOTE] = ACTIONS(5708),
    [anon_sym_LT_LPAREN] = ACTIONS(5708),
    [anon_sym_GT_LPAREN] = ACTIONS(5708),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5710),
    [sym_word] = ACTIONS(5710),
    [anon_sym_LF] = ACTIONS(5708),
    [anon_sym_AMP] = ACTIONS(5710),
  },
  [2565] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(7089),
    [sym_comment] = ACTIONS(57),
  },
  [2566] = {
    [anon_sym_RBRACE] = ACTIONS(7089),
    [sym_comment] = ACTIONS(57),
  },
  [2567] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(7091),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [2568] = {
    [sym_concatenation] = STATE(3194),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3194),
    [anon_sym_RBRACE] = ACTIONS(7093),
    [anon_sym_EQ] = ACTIONS(7095),
    [anon_sym_DASH] = ACTIONS(7095),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7095),
    [anon_sym_COLON_QMARK] = ACTIONS(7095),
    [anon_sym_COLON_DASH] = ACTIONS(7095),
    [anon_sym_PERCENT] = ACTIONS(7095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2569] = {
    [sym__simple_heredoc_body] = ACTIONS(5725),
    [sym__heredoc_body_beginning] = ACTIONS(5725),
    [sym_file_descriptor] = ACTIONS(5725),
    [sym__concat] = ACTIONS(5725),
    [sym_variable_name] = ACTIONS(5725),
    [ts_builtin_sym_end] = ACTIONS(5725),
    [anon_sym_SEMI] = ACTIONS(5727),
    [anon_sym_PIPE] = ACTIONS(5727),
    [anon_sym_RPAREN] = ACTIONS(5725),
    [anon_sym_SEMI_SEMI] = ACTIONS(5725),
    [anon_sym_PIPE_AMP] = ACTIONS(5725),
    [anon_sym_AMP_AMP] = ACTIONS(5725),
    [anon_sym_PIPE_PIPE] = ACTIONS(5725),
    [anon_sym_LT] = ACTIONS(5727),
    [anon_sym_GT] = ACTIONS(5727),
    [anon_sym_GT_GT] = ACTIONS(5725),
    [anon_sym_AMP_GT] = ACTIONS(5727),
    [anon_sym_AMP_GT_GT] = ACTIONS(5725),
    [anon_sym_LT_AMP] = ACTIONS(5725),
    [anon_sym_GT_AMP] = ACTIONS(5725),
    [anon_sym_LT_LT] = ACTIONS(5727),
    [anon_sym_LT_LT_DASH] = ACTIONS(5725),
    [anon_sym_LT_LT_LT] = ACTIONS(5725),
    [anon_sym_DOLLAR] = ACTIONS(5727),
    [sym__special_character] = ACTIONS(5725),
    [anon_sym_DQUOTE] = ACTIONS(5725),
    [sym_raw_string] = ACTIONS(5725),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5725),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5725),
    [anon_sym_BQUOTE] = ACTIONS(5725),
    [anon_sym_LT_LPAREN] = ACTIONS(5725),
    [anon_sym_GT_LPAREN] = ACTIONS(5725),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5727),
    [sym_word] = ACTIONS(5727),
    [anon_sym_LF] = ACTIONS(5725),
    [anon_sym_AMP] = ACTIONS(5727),
  },
  [2570] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7093),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2571] = {
    [sym_concatenation] = STATE(3195),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3195),
    [anon_sym_RBRACE] = ACTIONS(7089),
    [anon_sym_EQ] = ACTIONS(7099),
    [anon_sym_DASH] = ACTIONS(7099),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7099),
    [anon_sym_COLON_QMARK] = ACTIONS(7099),
    [anon_sym_COLON_DASH] = ACTIONS(7099),
    [anon_sym_PERCENT] = ACTIONS(7099),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2572] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7089),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2573] = {
    [sym__simple_heredoc_body] = ACTIONS(5770),
    [sym__heredoc_body_beginning] = ACTIONS(5770),
    [sym_file_descriptor] = ACTIONS(5770),
    [sym__concat] = ACTIONS(5770),
    [sym_variable_name] = ACTIONS(5770),
    [ts_builtin_sym_end] = ACTIONS(5770),
    [anon_sym_SEMI] = ACTIONS(5772),
    [anon_sym_PIPE] = ACTIONS(5772),
    [anon_sym_RPAREN] = ACTIONS(5770),
    [anon_sym_SEMI_SEMI] = ACTIONS(5770),
    [anon_sym_PIPE_AMP] = ACTIONS(5770),
    [anon_sym_AMP_AMP] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5770),
    [anon_sym_LT] = ACTIONS(5772),
    [anon_sym_GT] = ACTIONS(5772),
    [anon_sym_GT_GT] = ACTIONS(5770),
    [anon_sym_AMP_GT] = ACTIONS(5772),
    [anon_sym_AMP_GT_GT] = ACTIONS(5770),
    [anon_sym_LT_AMP] = ACTIONS(5770),
    [anon_sym_GT_AMP] = ACTIONS(5770),
    [anon_sym_LT_LT] = ACTIONS(5772),
    [anon_sym_LT_LT_DASH] = ACTIONS(5770),
    [anon_sym_LT_LT_LT] = ACTIONS(5770),
    [anon_sym_DOLLAR] = ACTIONS(5772),
    [sym__special_character] = ACTIONS(5770),
    [anon_sym_DQUOTE] = ACTIONS(5770),
    [sym_raw_string] = ACTIONS(5770),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5770),
    [anon_sym_BQUOTE] = ACTIONS(5770),
    [anon_sym_LT_LPAREN] = ACTIONS(5770),
    [anon_sym_GT_LPAREN] = ACTIONS(5770),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5772),
    [sym_word] = ACTIONS(5772),
    [anon_sym_LF] = ACTIONS(5770),
    [anon_sym_AMP] = ACTIONS(5772),
  },
  [2574] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7103),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2575] = {
    [sym__simple_heredoc_body] = ACTIONS(5674),
    [sym__heredoc_body_beginning] = ACTIONS(5674),
    [sym_file_descriptor] = ACTIONS(5674),
    [sym__concat] = ACTIONS(5674),
    [ts_builtin_sym_end] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(5676),
    [anon_sym_PIPE] = ACTIONS(5676),
    [anon_sym_RPAREN] = ACTIONS(5674),
    [anon_sym_SEMI_SEMI] = ACTIONS(5674),
    [anon_sym_PIPE_AMP] = ACTIONS(5674),
    [anon_sym_AMP_AMP] = ACTIONS(5674),
    [anon_sym_PIPE_PIPE] = ACTIONS(5674),
    [anon_sym_LT] = ACTIONS(5676),
    [anon_sym_GT] = ACTIONS(5676),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_AMP_GT] = ACTIONS(5676),
    [anon_sym_AMP_GT_GT] = ACTIONS(5674),
    [anon_sym_LT_AMP] = ACTIONS(5674),
    [anon_sym_GT_AMP] = ACTIONS(5674),
    [anon_sym_LT_LT] = ACTIONS(5676),
    [anon_sym_LT_LT_DASH] = ACTIONS(5674),
    [anon_sym_LT_LT_LT] = ACTIONS(5674),
    [anon_sym_DOLLAR] = ACTIONS(5676),
    [sym__special_character] = ACTIONS(5674),
    [anon_sym_DQUOTE] = ACTIONS(5674),
    [sym_raw_string] = ACTIONS(5674),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5674),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5674),
    [anon_sym_BQUOTE] = ACTIONS(5674),
    [anon_sym_LT_LPAREN] = ACTIONS(5674),
    [anon_sym_GT_LPAREN] = ACTIONS(5674),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5676),
    [sym_word] = ACTIONS(5676),
    [anon_sym_LF] = ACTIONS(5674),
    [anon_sym_AMP] = ACTIONS(5676),
  },
  [2576] = {
    [sym__simple_heredoc_body] = ACTIONS(5708),
    [sym__heredoc_body_beginning] = ACTIONS(5708),
    [sym_file_descriptor] = ACTIONS(5708),
    [sym__concat] = ACTIONS(5708),
    [ts_builtin_sym_end] = ACTIONS(5708),
    [anon_sym_SEMI] = ACTIONS(5710),
    [anon_sym_PIPE] = ACTIONS(5710),
    [anon_sym_RPAREN] = ACTIONS(5708),
    [anon_sym_SEMI_SEMI] = ACTIONS(5708),
    [anon_sym_PIPE_AMP] = ACTIONS(5708),
    [anon_sym_AMP_AMP] = ACTIONS(5708),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_LT] = ACTIONS(5710),
    [anon_sym_GT] = ACTIONS(5710),
    [anon_sym_GT_GT] = ACTIONS(5708),
    [anon_sym_AMP_GT] = ACTIONS(5710),
    [anon_sym_AMP_GT_GT] = ACTIONS(5708),
    [anon_sym_LT_AMP] = ACTIONS(5708),
    [anon_sym_GT_AMP] = ACTIONS(5708),
    [anon_sym_LT_LT] = ACTIONS(5710),
    [anon_sym_LT_LT_DASH] = ACTIONS(5708),
    [anon_sym_LT_LT_LT] = ACTIONS(5708),
    [anon_sym_DOLLAR] = ACTIONS(5710),
    [sym__special_character] = ACTIONS(5708),
    [anon_sym_DQUOTE] = ACTIONS(5708),
    [sym_raw_string] = ACTIONS(5708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5708),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5708),
    [anon_sym_BQUOTE] = ACTIONS(5708),
    [anon_sym_LT_LPAREN] = ACTIONS(5708),
    [anon_sym_GT_LPAREN] = ACTIONS(5708),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5710),
    [sym_word] = ACTIONS(5710),
    [anon_sym_LF] = ACTIONS(5708),
    [anon_sym_AMP] = ACTIONS(5710),
  },
  [2577] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(7105),
    [sym_comment] = ACTIONS(57),
  },
  [2578] = {
    [anon_sym_RBRACE] = ACTIONS(7105),
    [sym_comment] = ACTIONS(57),
  },
  [2579] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(7107),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [2580] = {
    [sym_concatenation] = STATE(3200),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3200),
    [anon_sym_RBRACE] = ACTIONS(7109),
    [anon_sym_EQ] = ACTIONS(7111),
    [anon_sym_DASH] = ACTIONS(7111),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7113),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7111),
    [anon_sym_COLON_QMARK] = ACTIONS(7111),
    [anon_sym_COLON_DASH] = ACTIONS(7111),
    [anon_sym_PERCENT] = ACTIONS(7111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2581] = {
    [sym__simple_heredoc_body] = ACTIONS(5725),
    [sym__heredoc_body_beginning] = ACTIONS(5725),
    [sym_file_descriptor] = ACTIONS(5725),
    [sym__concat] = ACTIONS(5725),
    [ts_builtin_sym_end] = ACTIONS(5725),
    [anon_sym_SEMI] = ACTIONS(5727),
    [anon_sym_PIPE] = ACTIONS(5727),
    [anon_sym_RPAREN] = ACTIONS(5725),
    [anon_sym_SEMI_SEMI] = ACTIONS(5725),
    [anon_sym_PIPE_AMP] = ACTIONS(5725),
    [anon_sym_AMP_AMP] = ACTIONS(5725),
    [anon_sym_PIPE_PIPE] = ACTIONS(5725),
    [anon_sym_LT] = ACTIONS(5727),
    [anon_sym_GT] = ACTIONS(5727),
    [anon_sym_GT_GT] = ACTIONS(5725),
    [anon_sym_AMP_GT] = ACTIONS(5727),
    [anon_sym_AMP_GT_GT] = ACTIONS(5725),
    [anon_sym_LT_AMP] = ACTIONS(5725),
    [anon_sym_GT_AMP] = ACTIONS(5725),
    [anon_sym_LT_LT] = ACTIONS(5727),
    [anon_sym_LT_LT_DASH] = ACTIONS(5725),
    [anon_sym_LT_LT_LT] = ACTIONS(5725),
    [anon_sym_DOLLAR] = ACTIONS(5727),
    [sym__special_character] = ACTIONS(5725),
    [anon_sym_DQUOTE] = ACTIONS(5725),
    [sym_raw_string] = ACTIONS(5725),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5725),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5725),
    [anon_sym_BQUOTE] = ACTIONS(5725),
    [anon_sym_LT_LPAREN] = ACTIONS(5725),
    [anon_sym_GT_LPAREN] = ACTIONS(5725),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5727),
    [sym_word] = ACTIONS(5727),
    [anon_sym_LF] = ACTIONS(5725),
    [anon_sym_AMP] = ACTIONS(5727),
  },
  [2582] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7109),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2583] = {
    [sym_concatenation] = STATE(3201),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3201),
    [anon_sym_RBRACE] = ACTIONS(7105),
    [anon_sym_EQ] = ACTIONS(7115),
    [anon_sym_DASH] = ACTIONS(7115),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7117),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7115),
    [anon_sym_COLON_QMARK] = ACTIONS(7115),
    [anon_sym_COLON_DASH] = ACTIONS(7115),
    [anon_sym_PERCENT] = ACTIONS(7115),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2584] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7105),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2585] = {
    [sym__simple_heredoc_body] = ACTIONS(5770),
    [sym__heredoc_body_beginning] = ACTIONS(5770),
    [sym_file_descriptor] = ACTIONS(5770),
    [sym__concat] = ACTIONS(5770),
    [ts_builtin_sym_end] = ACTIONS(5770),
    [anon_sym_SEMI] = ACTIONS(5772),
    [anon_sym_PIPE] = ACTIONS(5772),
    [anon_sym_RPAREN] = ACTIONS(5770),
    [anon_sym_SEMI_SEMI] = ACTIONS(5770),
    [anon_sym_PIPE_AMP] = ACTIONS(5770),
    [anon_sym_AMP_AMP] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5770),
    [anon_sym_LT] = ACTIONS(5772),
    [anon_sym_GT] = ACTIONS(5772),
    [anon_sym_GT_GT] = ACTIONS(5770),
    [anon_sym_AMP_GT] = ACTIONS(5772),
    [anon_sym_AMP_GT_GT] = ACTIONS(5770),
    [anon_sym_LT_AMP] = ACTIONS(5770),
    [anon_sym_GT_AMP] = ACTIONS(5770),
    [anon_sym_LT_LT] = ACTIONS(5772),
    [anon_sym_LT_LT_DASH] = ACTIONS(5770),
    [anon_sym_LT_LT_LT] = ACTIONS(5770),
    [anon_sym_DOLLAR] = ACTIONS(5772),
    [sym__special_character] = ACTIONS(5770),
    [anon_sym_DQUOTE] = ACTIONS(5770),
    [sym_raw_string] = ACTIONS(5770),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5770),
    [anon_sym_BQUOTE] = ACTIONS(5770),
    [anon_sym_LT_LPAREN] = ACTIONS(5770),
    [anon_sym_GT_LPAREN] = ACTIONS(5770),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5772),
    [sym_word] = ACTIONS(5772),
    [anon_sym_LF] = ACTIONS(5770),
    [anon_sym_AMP] = ACTIONS(5772),
  },
  [2586] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7119),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2587] = {
    [sym_file_descriptor] = ACTIONS(5674),
    [sym__concat] = ACTIONS(5674),
    [sym_variable_name] = ACTIONS(5674),
    [anon_sym_RPAREN] = ACTIONS(5674),
    [anon_sym_LT] = ACTIONS(5676),
    [anon_sym_GT] = ACTIONS(5676),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_AMP_GT] = ACTIONS(5676),
    [anon_sym_AMP_GT_GT] = ACTIONS(5674),
    [anon_sym_LT_AMP] = ACTIONS(5674),
    [anon_sym_GT_AMP] = ACTIONS(5674),
    [anon_sym_DOLLAR] = ACTIONS(5676),
    [sym__special_character] = ACTIONS(5674),
    [anon_sym_DQUOTE] = ACTIONS(5674),
    [sym_raw_string] = ACTIONS(5674),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5674),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5674),
    [anon_sym_BQUOTE] = ACTIONS(5674),
    [anon_sym_LT_LPAREN] = ACTIONS(5674),
    [anon_sym_GT_LPAREN] = ACTIONS(5674),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5674),
  },
  [2588] = {
    [sym_file_descriptor] = ACTIONS(5708),
    [sym__concat] = ACTIONS(5708),
    [sym_variable_name] = ACTIONS(5708),
    [anon_sym_RPAREN] = ACTIONS(5708),
    [anon_sym_LT] = ACTIONS(5710),
    [anon_sym_GT] = ACTIONS(5710),
    [anon_sym_GT_GT] = ACTIONS(5708),
    [anon_sym_AMP_GT] = ACTIONS(5710),
    [anon_sym_AMP_GT_GT] = ACTIONS(5708),
    [anon_sym_LT_AMP] = ACTIONS(5708),
    [anon_sym_GT_AMP] = ACTIONS(5708),
    [anon_sym_DOLLAR] = ACTIONS(5710),
    [sym__special_character] = ACTIONS(5708),
    [anon_sym_DQUOTE] = ACTIONS(5708),
    [sym_raw_string] = ACTIONS(5708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5708),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5708),
    [anon_sym_BQUOTE] = ACTIONS(5708),
    [anon_sym_LT_LPAREN] = ACTIONS(5708),
    [anon_sym_GT_LPAREN] = ACTIONS(5708),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5708),
  },
  [2589] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(7121),
    [sym_comment] = ACTIONS(57),
  },
  [2590] = {
    [anon_sym_RBRACE] = ACTIONS(7121),
    [sym_comment] = ACTIONS(57),
  },
  [2591] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(7123),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [2592] = {
    [sym_concatenation] = STATE(3206),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3206),
    [anon_sym_RBRACE] = ACTIONS(7125),
    [anon_sym_EQ] = ACTIONS(7127),
    [anon_sym_DASH] = ACTIONS(7127),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7127),
    [anon_sym_COLON_QMARK] = ACTIONS(7127),
    [anon_sym_COLON_DASH] = ACTIONS(7127),
    [anon_sym_PERCENT] = ACTIONS(7127),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2593] = {
    [sym_file_descriptor] = ACTIONS(5725),
    [sym__concat] = ACTIONS(5725),
    [sym_variable_name] = ACTIONS(5725),
    [anon_sym_RPAREN] = ACTIONS(5725),
    [anon_sym_LT] = ACTIONS(5727),
    [anon_sym_GT] = ACTIONS(5727),
    [anon_sym_GT_GT] = ACTIONS(5725),
    [anon_sym_AMP_GT] = ACTIONS(5727),
    [anon_sym_AMP_GT_GT] = ACTIONS(5725),
    [anon_sym_LT_AMP] = ACTIONS(5725),
    [anon_sym_GT_AMP] = ACTIONS(5725),
    [anon_sym_DOLLAR] = ACTIONS(5727),
    [sym__special_character] = ACTIONS(5725),
    [anon_sym_DQUOTE] = ACTIONS(5725),
    [sym_raw_string] = ACTIONS(5725),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5725),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5725),
    [anon_sym_BQUOTE] = ACTIONS(5725),
    [anon_sym_LT_LPAREN] = ACTIONS(5725),
    [anon_sym_GT_LPAREN] = ACTIONS(5725),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5725),
  },
  [2594] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7125),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2595] = {
    [sym_concatenation] = STATE(3207),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3207),
    [anon_sym_RBRACE] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(7131),
    [anon_sym_DASH] = ACTIONS(7131),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7131),
    [anon_sym_COLON_QMARK] = ACTIONS(7131),
    [anon_sym_COLON_DASH] = ACTIONS(7131),
    [anon_sym_PERCENT] = ACTIONS(7131),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2596] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7121),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2597] = {
    [sym_file_descriptor] = ACTIONS(5770),
    [sym__concat] = ACTIONS(5770),
    [sym_variable_name] = ACTIONS(5770),
    [anon_sym_RPAREN] = ACTIONS(5770),
    [anon_sym_LT] = ACTIONS(5772),
    [anon_sym_GT] = ACTIONS(5772),
    [anon_sym_GT_GT] = ACTIONS(5770),
    [anon_sym_AMP_GT] = ACTIONS(5772),
    [anon_sym_AMP_GT_GT] = ACTIONS(5770),
    [anon_sym_LT_AMP] = ACTIONS(5770),
    [anon_sym_GT_AMP] = ACTIONS(5770),
    [anon_sym_DOLLAR] = ACTIONS(5772),
    [sym__special_character] = ACTIONS(5770),
    [anon_sym_DQUOTE] = ACTIONS(5770),
    [sym_raw_string] = ACTIONS(5770),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5770),
    [anon_sym_BQUOTE] = ACTIONS(5770),
    [anon_sym_LT_LPAREN] = ACTIONS(5770),
    [anon_sym_GT_LPAREN] = ACTIONS(5770),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5770),
  },
  [2598] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7135),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2599] = {
    [sym__concat] = ACTIONS(5674),
    [anon_sym_DOLLAR] = ACTIONS(5676),
    [anon_sym_DQUOTE] = ACTIONS(5676),
    [sym__string_content] = ACTIONS(5674),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5676),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5676),
    [anon_sym_BQUOTE] = ACTIONS(5676),
    [sym_comment] = ACTIONS(329),
  },
  [2600] = {
    [sym__concat] = ACTIONS(5708),
    [anon_sym_DOLLAR] = ACTIONS(5710),
    [anon_sym_DQUOTE] = ACTIONS(5710),
    [sym__string_content] = ACTIONS(5708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5710),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5710),
    [anon_sym_BQUOTE] = ACTIONS(5710),
    [sym_comment] = ACTIONS(329),
  },
  [2601] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(7137),
    [sym_comment] = ACTIONS(57),
  },
  [2602] = {
    [anon_sym_RBRACE] = ACTIONS(7137),
    [sym_comment] = ACTIONS(57),
  },
  [2603] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(7139),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [2604] = {
    [sym_concatenation] = STATE(3212),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3212),
    [anon_sym_RBRACE] = ACTIONS(7141),
    [anon_sym_EQ] = ACTIONS(7143),
    [anon_sym_DASH] = ACTIONS(7143),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7145),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7143),
    [anon_sym_COLON_QMARK] = ACTIONS(7143),
    [anon_sym_COLON_DASH] = ACTIONS(7143),
    [anon_sym_PERCENT] = ACTIONS(7143),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2605] = {
    [sym__concat] = ACTIONS(5725),
    [anon_sym_DOLLAR] = ACTIONS(5727),
    [anon_sym_DQUOTE] = ACTIONS(5727),
    [sym__string_content] = ACTIONS(5725),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5727),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5727),
    [anon_sym_BQUOTE] = ACTIONS(5727),
    [sym_comment] = ACTIONS(329),
  },
  [2606] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7141),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2607] = {
    [sym_concatenation] = STATE(3213),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3213),
    [anon_sym_RBRACE] = ACTIONS(7137),
    [anon_sym_EQ] = ACTIONS(7147),
    [anon_sym_DASH] = ACTIONS(7147),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7149),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7147),
    [anon_sym_COLON_QMARK] = ACTIONS(7147),
    [anon_sym_COLON_DASH] = ACTIONS(7147),
    [anon_sym_PERCENT] = ACTIONS(7147),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2608] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7137),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2609] = {
    [sym__concat] = ACTIONS(5770),
    [anon_sym_DOLLAR] = ACTIONS(5772),
    [anon_sym_DQUOTE] = ACTIONS(5772),
    [sym__string_content] = ACTIONS(5770),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5772),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5772),
    [anon_sym_BQUOTE] = ACTIONS(5772),
    [sym_comment] = ACTIONS(329),
  },
  [2610] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7151),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2611] = {
    [sym__concat] = ACTIONS(7153),
    [anon_sym_RBRACE] = ACTIONS(4405),
    [anon_sym_EQ] = ACTIONS(7155),
    [anon_sym_DASH] = ACTIONS(7155),
    [anon_sym_DOLLAR] = ACTIONS(7155),
    [sym__special_character] = ACTIONS(7155),
    [anon_sym_DQUOTE] = ACTIONS(4405),
    [sym_raw_string] = ACTIONS(4405),
    [anon_sym_POUND] = ACTIONS(4405),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4405),
    [anon_sym_SLASH] = ACTIONS(4405),
    [anon_sym_COLON] = ACTIONS(7155),
    [anon_sym_COLON_QMARK] = ACTIONS(7155),
    [anon_sym_COLON_DASH] = ACTIONS(7155),
    [anon_sym_PERCENT] = ACTIONS(7155),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4405),
    [anon_sym_BQUOTE] = ACTIONS(4405),
    [anon_sym_LT_LPAREN] = ACTIONS(4405),
    [anon_sym_GT_LPAREN] = ACTIONS(4405),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(7155),
  },
  [2612] = {
    [anon_sym_RBRACE] = ACTIONS(4405),
    [anon_sym_EQ] = ACTIONS(7155),
    [anon_sym_DASH] = ACTIONS(7155),
    [anon_sym_DOLLAR] = ACTIONS(7155),
    [sym__special_character] = ACTIONS(7155),
    [anon_sym_DQUOTE] = ACTIONS(4405),
    [sym_raw_string] = ACTIONS(4405),
    [anon_sym_POUND] = ACTIONS(4405),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4405),
    [anon_sym_SLASH] = ACTIONS(4405),
    [anon_sym_COLON] = ACTIONS(7155),
    [anon_sym_COLON_QMARK] = ACTIONS(7155),
    [anon_sym_COLON_DASH] = ACTIONS(7155),
    [anon_sym_PERCENT] = ACTIONS(7155),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4405),
    [anon_sym_BQUOTE] = ACTIONS(4405),
    [anon_sym_LT_LPAREN] = ACTIONS(4405),
    [anon_sym_GT_LPAREN] = ACTIONS(4405),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(7155),
  },
  [2613] = {
    [sym__concat] = ACTIONS(7157),
    [anon_sym_RBRACE] = ACTIONS(4409),
    [anon_sym_EQ] = ACTIONS(7159),
    [anon_sym_DASH] = ACTIONS(7159),
    [anon_sym_DOLLAR] = ACTIONS(7159),
    [sym__special_character] = ACTIONS(7159),
    [anon_sym_DQUOTE] = ACTIONS(4409),
    [sym_raw_string] = ACTIONS(4409),
    [anon_sym_POUND] = ACTIONS(4409),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4409),
    [anon_sym_SLASH] = ACTIONS(4409),
    [anon_sym_COLON] = ACTIONS(7159),
    [anon_sym_COLON_QMARK] = ACTIONS(7159),
    [anon_sym_COLON_DASH] = ACTIONS(7159),
    [anon_sym_PERCENT] = ACTIONS(7159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4409),
    [anon_sym_BQUOTE] = ACTIONS(4409),
    [anon_sym_LT_LPAREN] = ACTIONS(4409),
    [anon_sym_GT_LPAREN] = ACTIONS(4409),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(7159),
  },
  [2614] = {
    [anon_sym_RBRACE] = ACTIONS(4409),
    [anon_sym_EQ] = ACTIONS(7159),
    [anon_sym_DASH] = ACTIONS(7159),
    [anon_sym_DOLLAR] = ACTIONS(7159),
    [sym__special_character] = ACTIONS(7159),
    [anon_sym_DQUOTE] = ACTIONS(4409),
    [sym_raw_string] = ACTIONS(4409),
    [anon_sym_POUND] = ACTIONS(4409),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4409),
    [anon_sym_SLASH] = ACTIONS(4409),
    [anon_sym_COLON] = ACTIONS(7159),
    [anon_sym_COLON_QMARK] = ACTIONS(7159),
    [anon_sym_COLON_DASH] = ACTIONS(7159),
    [anon_sym_PERCENT] = ACTIONS(7159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4409),
    [anon_sym_BQUOTE] = ACTIONS(4409),
    [anon_sym_LT_LPAREN] = ACTIONS(4409),
    [anon_sym_GT_LPAREN] = ACTIONS(4409),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(7159),
  },
  [2615] = {
    [sym__concat] = ACTIONS(2362),
    [anon_sym_RBRACE] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
  },
  [2616] = {
    [sym_string] = STATE(2615),
    [sym_simple_expansion] = STATE(2615),
    [sym_string_expansion] = STATE(2615),
    [sym_expansion] = STATE(2615),
    [sym_command_substitution] = STATE(2615),
    [sym_process_substitution] = STATE(2615),
    [anon_sym_DOLLAR] = ACTIONS(7161),
    [sym__special_character] = ACTIONS(5666),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(5666),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5666),
  },
  [2617] = {
    [aux_sym_concatenation_repeat1] = STATE(2617),
    [sym__concat] = ACTIONS(7163),
    [anon_sym_RBRACE] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
  },
  [2618] = {
    [sym__concat] = ACTIONS(2371),
    [anon_sym_RBRACE] = ACTIONS(2371),
    [sym_comment] = ACTIONS(57),
  },
  [2619] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(7166),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [2620] = {
    [sym_concatenation] = STATE(3221),
    [sym_string] = STATE(3220),
    [sym_simple_expansion] = STATE(3220),
    [sym_string_expansion] = STATE(3220),
    [sym_expansion] = STATE(3220),
    [sym_command_substitution] = STATE(3220),
    [sym_process_substitution] = STATE(3220),
    [aux_sym__literal_repeat1] = STATE(3222),
    [anon_sym_RBRACE] = ACTIONS(7168),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(7170),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7170),
  },
  [2621] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(7172),
    [sym_comment] = ACTIONS(57),
  },
  [2622] = {
    [sym_concatenation] = STATE(3226),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3226),
    [anon_sym_RBRACE] = ACTIONS(7174),
    [anon_sym_EQ] = ACTIONS(7176),
    [anon_sym_DASH] = ACTIONS(7176),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7178),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(7180),
    [anon_sym_COLON] = ACTIONS(7176),
    [anon_sym_COLON_QMARK] = ACTIONS(7176),
    [anon_sym_COLON_DASH] = ACTIONS(7176),
    [anon_sym_PERCENT] = ACTIONS(7176),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2623] = {
    [sym_concatenation] = STATE(3228),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3228),
    [anon_sym_RBRACE] = ACTIONS(7168),
    [anon_sym_EQ] = ACTIONS(7182),
    [anon_sym_DASH] = ACTIONS(7182),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7184),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(7186),
    [anon_sym_COLON] = ACTIONS(7182),
    [anon_sym_COLON_QMARK] = ACTIONS(7182),
    [anon_sym_COLON_DASH] = ACTIONS(7182),
    [anon_sym_PERCENT] = ACTIONS(7182),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2624] = {
    [sym__concat] = ACTIONS(2462),
    [anon_sym_RBRACE] = ACTIONS(2462),
    [sym_comment] = ACTIONS(57),
  },
  [2625] = {
    [sym_concatenation] = STATE(3231),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3231),
    [sym_regex] = ACTIONS(7188),
    [anon_sym_RBRACE] = ACTIONS(7190),
    [anon_sym_EQ] = ACTIONS(7192),
    [anon_sym_DASH] = ACTIONS(7192),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7192),
    [anon_sym_COLON_QMARK] = ACTIONS(7192),
    [anon_sym_COLON_DASH] = ACTIONS(7192),
    [anon_sym_PERCENT] = ACTIONS(7192),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2626] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7190),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2627] = {
    [sym__concat] = ACTIONS(2512),
    [anon_sym_RBRACE] = ACTIONS(2512),
    [sym_comment] = ACTIONS(57),
  },
  [2628] = {
    [sym_concatenation] = STATE(3228),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3228),
    [sym_regex] = ACTIONS(7196),
    [anon_sym_RBRACE] = ACTIONS(7168),
    [anon_sym_EQ] = ACTIONS(7182),
    [anon_sym_DASH] = ACTIONS(7182),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7184),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7182),
    [anon_sym_COLON_QMARK] = ACTIONS(7182),
    [anon_sym_COLON_DASH] = ACTIONS(7182),
    [anon_sym_PERCENT] = ACTIONS(7182),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2629] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7168),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2630] = {
    [sym__concat] = ACTIONS(2520),
    [anon_sym_RBRACE] = ACTIONS(2520),
    [sym_comment] = ACTIONS(57),
  },
  [2631] = {
    [sym__concat] = ACTIONS(2554),
    [anon_sym_RBRACE] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
  },
  [2632] = {
    [sym__simple_heredoc_body] = ACTIONS(7198),
    [sym__heredoc_body_beginning] = ACTIONS(7198),
    [sym_file_descriptor] = ACTIONS(7198),
    [sym__concat] = ACTIONS(7198),
    [ts_builtin_sym_end] = ACTIONS(7198),
    [anon_sym_SEMI] = ACTIONS(7200),
    [anon_sym_PIPE] = ACTIONS(7200),
    [anon_sym_RPAREN] = ACTIONS(7198),
    [anon_sym_SEMI_SEMI] = ACTIONS(7198),
    [anon_sym_PIPE_AMP] = ACTIONS(7198),
    [anon_sym_AMP_AMP] = ACTIONS(7198),
    [anon_sym_PIPE_PIPE] = ACTIONS(7198),
    [anon_sym_EQ_TILDE] = ACTIONS(7200),
    [anon_sym_EQ_EQ] = ACTIONS(7200),
    [anon_sym_LT] = ACTIONS(7200),
    [anon_sym_GT] = ACTIONS(7200),
    [anon_sym_GT_GT] = ACTIONS(7198),
    [anon_sym_AMP_GT] = ACTIONS(7200),
    [anon_sym_AMP_GT_GT] = ACTIONS(7198),
    [anon_sym_LT_AMP] = ACTIONS(7198),
    [anon_sym_GT_AMP] = ACTIONS(7198),
    [anon_sym_LT_LT] = ACTIONS(7200),
    [anon_sym_LT_LT_DASH] = ACTIONS(7198),
    [anon_sym_LT_LT_LT] = ACTIONS(7198),
    [anon_sym_DOLLAR] = ACTIONS(7200),
    [sym__special_character] = ACTIONS(7198),
    [anon_sym_DQUOTE] = ACTIONS(7198),
    [sym_raw_string] = ACTIONS(7198),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7198),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7198),
    [anon_sym_BQUOTE] = ACTIONS(7198),
    [anon_sym_LT_LPAREN] = ACTIONS(7198),
    [anon_sym_GT_LPAREN] = ACTIONS(7198),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7200),
    [anon_sym_LF] = ACTIONS(7198),
    [anon_sym_AMP] = ACTIONS(7200),
  },
  [2633] = {
    [sym__simple_heredoc_body] = ACTIONS(7202),
    [sym__heredoc_body_beginning] = ACTIONS(7202),
    [sym_file_descriptor] = ACTIONS(7202),
    [sym__concat] = ACTIONS(7202),
    [ts_builtin_sym_end] = ACTIONS(7202),
    [anon_sym_SEMI] = ACTIONS(7204),
    [anon_sym_PIPE] = ACTIONS(7204),
    [anon_sym_RPAREN] = ACTIONS(7202),
    [anon_sym_SEMI_SEMI] = ACTIONS(7202),
    [anon_sym_PIPE_AMP] = ACTIONS(7202),
    [anon_sym_AMP_AMP] = ACTIONS(7202),
    [anon_sym_PIPE_PIPE] = ACTIONS(7202),
    [anon_sym_EQ_TILDE] = ACTIONS(7204),
    [anon_sym_EQ_EQ] = ACTIONS(7204),
    [anon_sym_LT] = ACTIONS(7204),
    [anon_sym_GT] = ACTIONS(7204),
    [anon_sym_GT_GT] = ACTIONS(7202),
    [anon_sym_AMP_GT] = ACTIONS(7204),
    [anon_sym_AMP_GT_GT] = ACTIONS(7202),
    [anon_sym_LT_AMP] = ACTIONS(7202),
    [anon_sym_GT_AMP] = ACTIONS(7202),
    [anon_sym_LT_LT] = ACTIONS(7204),
    [anon_sym_LT_LT_DASH] = ACTIONS(7202),
    [anon_sym_LT_LT_LT] = ACTIONS(7202),
    [anon_sym_DOLLAR] = ACTIONS(7204),
    [sym__special_character] = ACTIONS(7202),
    [anon_sym_DQUOTE] = ACTIONS(7202),
    [sym_raw_string] = ACTIONS(7202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7202),
    [anon_sym_BQUOTE] = ACTIONS(7202),
    [anon_sym_LT_LPAREN] = ACTIONS(7202),
    [anon_sym_GT_LPAREN] = ACTIONS(7202),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7204),
    [anon_sym_LF] = ACTIONS(7202),
    [anon_sym_AMP] = ACTIONS(7204),
  },
  [2634] = {
    [sym__simple_heredoc_body] = ACTIONS(7206),
    [sym__heredoc_body_beginning] = ACTIONS(7206),
    [sym_file_descriptor] = ACTIONS(7206),
    [sym__concat] = ACTIONS(7206),
    [ts_builtin_sym_end] = ACTIONS(7206),
    [anon_sym_SEMI] = ACTIONS(7208),
    [anon_sym_PIPE] = ACTIONS(7208),
    [anon_sym_RPAREN] = ACTIONS(7206),
    [anon_sym_SEMI_SEMI] = ACTIONS(7206),
    [anon_sym_PIPE_AMP] = ACTIONS(7206),
    [anon_sym_AMP_AMP] = ACTIONS(7206),
    [anon_sym_PIPE_PIPE] = ACTIONS(7206),
    [anon_sym_EQ_TILDE] = ACTIONS(7208),
    [anon_sym_EQ_EQ] = ACTIONS(7208),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7206),
    [anon_sym_AMP_GT] = ACTIONS(7208),
    [anon_sym_AMP_GT_GT] = ACTIONS(7206),
    [anon_sym_LT_AMP] = ACTIONS(7206),
    [anon_sym_GT_AMP] = ACTIONS(7206),
    [anon_sym_LT_LT] = ACTIONS(7208),
    [anon_sym_LT_LT_DASH] = ACTIONS(7206),
    [anon_sym_LT_LT_LT] = ACTIONS(7206),
    [anon_sym_DOLLAR] = ACTIONS(7208),
    [sym__special_character] = ACTIONS(7206),
    [anon_sym_DQUOTE] = ACTIONS(7206),
    [sym_raw_string] = ACTIONS(7206),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7206),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7206),
    [anon_sym_BQUOTE] = ACTIONS(7206),
    [anon_sym_LT_LPAREN] = ACTIONS(7206),
    [anon_sym_GT_LPAREN] = ACTIONS(7206),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7208),
    [anon_sym_LF] = ACTIONS(7206),
    [anon_sym_AMP] = ACTIONS(7208),
  },
  [2635] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7210),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2636] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7212),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2637] = {
    [sym_string] = STATE(1260),
    [anon_sym_RBRACE] = ACTIONS(4071),
    [anon_sym_EQ] = ACTIONS(4073),
    [anon_sym_DASH] = ACTIONS(7214),
    [anon_sym_DOLLAR] = ACTIONS(7214),
    [sym__special_character] = ACTIONS(4073),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(2468),
    [anon_sym_POUND] = ACTIONS(2466),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4071),
    [anon_sym_COLON] = ACTIONS(4073),
    [anon_sym_COLON_QMARK] = ACTIONS(4073),
    [anon_sym_COLON_DASH] = ACTIONS(4073),
    [anon_sym_PERCENT] = ACTIONS(4073),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4071),
    [anon_sym_BQUOTE] = ACTIONS(4071),
    [anon_sym_LT_LPAREN] = ACTIONS(4071),
    [anon_sym_GT_LPAREN] = ACTIONS(4071),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2470),
    [anon_sym_STAR] = ACTIONS(2470),
    [anon_sym_AT] = ACTIONS(2470),
    [anon_sym_QMARK] = ACTIONS(2470),
    [anon_sym_0] = ACTIONS(2470),
    [anon_sym__] = ACTIONS(2470),
    [sym_word] = ACTIONS(4073),
  },
  [2638] = {
    [sym__concat] = ACTIONS(4111),
    [anon_sym_RBRACE] = ACTIONS(4111),
    [anon_sym_EQ] = ACTIONS(4113),
    [anon_sym_DASH] = ACTIONS(4113),
    [anon_sym_DOLLAR] = ACTIONS(4113),
    [sym__special_character] = ACTIONS(4113),
    [anon_sym_DQUOTE] = ACTIONS(4111),
    [sym_raw_string] = ACTIONS(4111),
    [anon_sym_POUND] = ACTIONS(4111),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4111),
    [anon_sym_COLON] = ACTIONS(4113),
    [anon_sym_COLON_QMARK] = ACTIONS(4113),
    [anon_sym_COLON_DASH] = ACTIONS(4113),
    [anon_sym_PERCENT] = ACTIONS(4113),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4111),
    [anon_sym_BQUOTE] = ACTIONS(4111),
    [anon_sym_LT_LPAREN] = ACTIONS(4111),
    [anon_sym_GT_LPAREN] = ACTIONS(4111),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(4113),
  },
  [2639] = {
    [sym__concat] = ACTIONS(4125),
    [anon_sym_RBRACE] = ACTIONS(4125),
    [anon_sym_EQ] = ACTIONS(4127),
    [anon_sym_DASH] = ACTIONS(4127),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym__special_character] = ACTIONS(4127),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_POUND] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_COLON] = ACTIONS(4127),
    [anon_sym_COLON_QMARK] = ACTIONS(4127),
    [anon_sym_COLON_DASH] = ACTIONS(4127),
    [anon_sym_PERCENT] = ACTIONS(4127),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(4127),
  },
  [2640] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(7216),
    [sym_comment] = ACTIONS(57),
  },
  [2641] = {
    [anon_sym_RBRACE] = ACTIONS(7216),
    [sym_comment] = ACTIONS(57),
  },
  [2642] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(7218),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [2643] = {
    [sym_concatenation] = STATE(3238),
    [sym_string] = STATE(3237),
    [sym_simple_expansion] = STATE(3237),
    [sym_string_expansion] = STATE(3237),
    [sym_expansion] = STATE(3237),
    [sym_command_substitution] = STATE(3237),
    [sym_process_substitution] = STATE(3237),
    [aux_sym__literal_repeat1] = STATE(3239),
    [anon_sym_RBRACE] = ACTIONS(7216),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(7220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7220),
  },
  [2644] = {
    [sym__concat] = ACTIONS(4161),
    [anon_sym_RBRACE] = ACTIONS(4161),
    [anon_sym_EQ] = ACTIONS(4163),
    [anon_sym_DASH] = ACTIONS(4163),
    [anon_sym_DOLLAR] = ACTIONS(4163),
    [sym__special_character] = ACTIONS(4163),
    [anon_sym_DQUOTE] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4161),
    [anon_sym_POUND] = ACTIONS(4161),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4161),
    [anon_sym_COLON] = ACTIONS(4163),
    [anon_sym_COLON_QMARK] = ACTIONS(4163),
    [anon_sym_COLON_DASH] = ACTIONS(4163),
    [anon_sym_PERCENT] = ACTIONS(4163),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4161),
    [anon_sym_BQUOTE] = ACTIONS(4161),
    [anon_sym_LT_LPAREN] = ACTIONS(4161),
    [anon_sym_GT_LPAREN] = ACTIONS(4161),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(4163),
  },
  [2645] = {
    [sym_concatenation] = STATE(3242),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3242),
    [sym_regex] = ACTIONS(7222),
    [anon_sym_RBRACE] = ACTIONS(7224),
    [anon_sym_EQ] = ACTIONS(7226),
    [anon_sym_DASH] = ACTIONS(7226),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7228),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7226),
    [anon_sym_COLON_QMARK] = ACTIONS(7226),
    [anon_sym_COLON_DASH] = ACTIONS(7226),
    [anon_sym_PERCENT] = ACTIONS(7226),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2646] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7224),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2647] = {
    [sym_concatenation] = STATE(3244),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3244),
    [sym_regex] = ACTIONS(7230),
    [anon_sym_RBRACE] = ACTIONS(7216),
    [anon_sym_EQ] = ACTIONS(7232),
    [anon_sym_DASH] = ACTIONS(7232),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7234),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7232),
    [anon_sym_COLON_QMARK] = ACTIONS(7232),
    [anon_sym_COLON_DASH] = ACTIONS(7232),
    [anon_sym_PERCENT] = ACTIONS(7232),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2648] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7216),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2649] = {
    [sym_concatenation] = STATE(3246),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3246),
    [anon_sym_RBRACE] = ACTIONS(7236),
    [anon_sym_EQ] = ACTIONS(7238),
    [anon_sym_DASH] = ACTIONS(7238),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7240),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7238),
    [anon_sym_COLON_QMARK] = ACTIONS(7238),
    [anon_sym_COLON_DASH] = ACTIONS(7238),
    [anon_sym_PERCENT] = ACTIONS(7238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2650] = {
    [sym__concat] = ACTIONS(4219),
    [anon_sym_RBRACE] = ACTIONS(4219),
    [anon_sym_EQ] = ACTIONS(4221),
    [anon_sym_DASH] = ACTIONS(4221),
    [anon_sym_DOLLAR] = ACTIONS(4221),
    [sym__special_character] = ACTIONS(4221),
    [anon_sym_DQUOTE] = ACTIONS(4219),
    [sym_raw_string] = ACTIONS(4219),
    [anon_sym_POUND] = ACTIONS(4219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4219),
    [anon_sym_COLON] = ACTIONS(4221),
    [anon_sym_COLON_QMARK] = ACTIONS(4221),
    [anon_sym_COLON_DASH] = ACTIONS(4221),
    [anon_sym_PERCENT] = ACTIONS(4221),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4219),
    [anon_sym_BQUOTE] = ACTIONS(4219),
    [anon_sym_LT_LPAREN] = ACTIONS(4219),
    [anon_sym_GT_LPAREN] = ACTIONS(4219),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(4221),
  },
  [2651] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7236),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2652] = {
    [sym_concatenation] = STATE(3244),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3244),
    [anon_sym_RBRACE] = ACTIONS(7216),
    [anon_sym_EQ] = ACTIONS(7232),
    [anon_sym_DASH] = ACTIONS(7232),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7234),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7232),
    [anon_sym_COLON_QMARK] = ACTIONS(7232),
    [anon_sym_COLON_DASH] = ACTIONS(7232),
    [anon_sym_PERCENT] = ACTIONS(7232),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2653] = {
    [sym__simple_heredoc_body] = ACTIONS(7242),
    [sym__heredoc_body_beginning] = ACTIONS(7242),
    [sym_file_descriptor] = ACTIONS(7242),
    [sym__concat] = ACTIONS(7242),
    [ts_builtin_sym_end] = ACTIONS(7242),
    [anon_sym_SEMI] = ACTIONS(7244),
    [anon_sym_PIPE] = ACTIONS(7244),
    [anon_sym_RPAREN] = ACTIONS(7242),
    [anon_sym_SEMI_SEMI] = ACTIONS(7242),
    [anon_sym_PIPE_AMP] = ACTIONS(7242),
    [anon_sym_AMP_AMP] = ACTIONS(7242),
    [anon_sym_PIPE_PIPE] = ACTIONS(7242),
    [anon_sym_EQ_TILDE] = ACTIONS(7244),
    [anon_sym_EQ_EQ] = ACTIONS(7244),
    [anon_sym_LT] = ACTIONS(7244),
    [anon_sym_GT] = ACTIONS(7244),
    [anon_sym_GT_GT] = ACTIONS(7242),
    [anon_sym_AMP_GT] = ACTIONS(7244),
    [anon_sym_AMP_GT_GT] = ACTIONS(7242),
    [anon_sym_LT_AMP] = ACTIONS(7242),
    [anon_sym_GT_AMP] = ACTIONS(7242),
    [anon_sym_LT_LT] = ACTIONS(7244),
    [anon_sym_LT_LT_DASH] = ACTIONS(7242),
    [anon_sym_LT_LT_LT] = ACTIONS(7242),
    [anon_sym_DOLLAR] = ACTIONS(7244),
    [sym__special_character] = ACTIONS(7242),
    [anon_sym_DQUOTE] = ACTIONS(7242),
    [sym_raw_string] = ACTIONS(7242),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7242),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7242),
    [anon_sym_BQUOTE] = ACTIONS(7242),
    [anon_sym_LT_LPAREN] = ACTIONS(7242),
    [anon_sym_GT_LPAREN] = ACTIONS(7242),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7244),
    [anon_sym_LF] = ACTIONS(7242),
    [anon_sym_AMP] = ACTIONS(7244),
  },
  [2654] = {
    [aux_sym_concatenation_repeat1] = STATE(2654),
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(4484),
    [sym_variable_name] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [2655] = {
    [aux_sym_concatenation_repeat1] = STATE(2655),
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(2368),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [2656] = {
    [sym__heredoc_body_middle] = ACTIONS(4125),
    [sym__heredoc_body_end] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
  },
  [2657] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(7246),
    [sym_comment] = ACTIONS(57),
  },
  [2658] = {
    [anon_sym_RBRACE] = ACTIONS(7246),
    [sym_comment] = ACTIONS(57),
  },
  [2659] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(7248),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [2660] = {
    [sym_concatenation] = STATE(3250),
    [sym_string] = STATE(3249),
    [sym_simple_expansion] = STATE(3249),
    [sym_string_expansion] = STATE(3249),
    [sym_expansion] = STATE(3249),
    [sym_command_substitution] = STATE(3249),
    [sym_process_substitution] = STATE(3249),
    [aux_sym__literal_repeat1] = STATE(3251),
    [anon_sym_RBRACE] = ACTIONS(7246),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(7250),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7250),
  },
  [2661] = {
    [sym__heredoc_body_middle] = ACTIONS(4161),
    [sym__heredoc_body_end] = ACTIONS(4161),
    [anon_sym_DOLLAR] = ACTIONS(4163),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4161),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4161),
    [anon_sym_BQUOTE] = ACTIONS(4161),
    [sym_comment] = ACTIONS(57),
  },
  [2662] = {
    [sym_concatenation] = STATE(3254),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3254),
    [sym_regex] = ACTIONS(7252),
    [anon_sym_RBRACE] = ACTIONS(7254),
    [anon_sym_EQ] = ACTIONS(7256),
    [anon_sym_DASH] = ACTIONS(7256),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7256),
    [anon_sym_COLON_QMARK] = ACTIONS(7256),
    [anon_sym_COLON_DASH] = ACTIONS(7256),
    [anon_sym_PERCENT] = ACTIONS(7256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2663] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7254),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2664] = {
    [sym_concatenation] = STATE(3256),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3256),
    [sym_regex] = ACTIONS(7260),
    [anon_sym_RBRACE] = ACTIONS(7246),
    [anon_sym_EQ] = ACTIONS(7262),
    [anon_sym_DASH] = ACTIONS(7262),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7264),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7262),
    [anon_sym_COLON_QMARK] = ACTIONS(7262),
    [anon_sym_COLON_DASH] = ACTIONS(7262),
    [anon_sym_PERCENT] = ACTIONS(7262),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2665] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7246),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2666] = {
    [sym_concatenation] = STATE(3258),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3258),
    [anon_sym_RBRACE] = ACTIONS(7266),
    [anon_sym_EQ] = ACTIONS(7268),
    [anon_sym_DASH] = ACTIONS(7268),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7270),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7268),
    [anon_sym_COLON_QMARK] = ACTIONS(7268),
    [anon_sym_COLON_DASH] = ACTIONS(7268),
    [anon_sym_PERCENT] = ACTIONS(7268),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2667] = {
    [sym__heredoc_body_middle] = ACTIONS(4219),
    [sym__heredoc_body_end] = ACTIONS(4219),
    [anon_sym_DOLLAR] = ACTIONS(4221),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4219),
    [anon_sym_BQUOTE] = ACTIONS(4219),
    [sym_comment] = ACTIONS(57),
  },
  [2668] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7266),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2669] = {
    [sym_concatenation] = STATE(3256),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3256),
    [anon_sym_RBRACE] = ACTIONS(7246),
    [anon_sym_EQ] = ACTIONS(7262),
    [anon_sym_DASH] = ACTIONS(7262),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7264),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7262),
    [anon_sym_COLON_QMARK] = ACTIONS(7262),
    [anon_sym_COLON_DASH] = ACTIONS(7262),
    [anon_sym_PERCENT] = ACTIONS(7262),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2670] = {
    [sym_string] = STATE(198),
    [sym__simple_heredoc_body] = ACTIONS(4071),
    [sym__heredoc_body_beginning] = ACTIONS(4071),
    [sym_file_descriptor] = ACTIONS(4071),
    [ts_builtin_sym_end] = ACTIONS(4071),
    [anon_sym_SEMI] = ACTIONS(4073),
    [anon_sym_PIPE] = ACTIONS(4073),
    [anon_sym_RPAREN] = ACTIONS(4071),
    [anon_sym_SEMI_SEMI] = ACTIONS(4071),
    [anon_sym_PIPE_AMP] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_PIPE_PIPE] = ACTIONS(4071),
    [anon_sym_LT] = ACTIONS(4073),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_GT_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT] = ACTIONS(4073),
    [anon_sym_AMP_GT_GT] = ACTIONS(4071),
    [anon_sym_LT_AMP] = ACTIONS(4071),
    [anon_sym_GT_AMP] = ACTIONS(4071),
    [anon_sym_LT_LT] = ACTIONS(4073),
    [anon_sym_LT_LT_DASH] = ACTIONS(4071),
    [anon_sym_LT_LT_LT] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(327),
    [anon_sym_POUND] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(4071),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(331),
    [anon_sym_STAR] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_QMARK] = ACTIONS(333),
    [anon_sym_0] = ACTIONS(331),
    [anon_sym__] = ACTIONS(331),
    [anon_sym_LF] = ACTIONS(4071),
    [anon_sym_AMP] = ACTIONS(4073),
  },
  [2671] = {
    [aux_sym_concatenation_repeat1] = STATE(2673),
    [sym__simple_heredoc_body] = ACTIONS(1380),
    [sym__heredoc_body_beginning] = ACTIONS(1380),
    [sym_file_descriptor] = ACTIONS(1380),
    [sym__concat] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(1382),
    [anon_sym_PIPE] = ACTIONS(1382),
    [anon_sym_SEMI_SEMI] = ACTIONS(1380),
    [anon_sym_PIPE_AMP] = ACTIONS(1380),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_PIPE_PIPE] = ACTIONS(1380),
    [anon_sym_LT] = ACTIONS(1382),
    [anon_sym_GT] = ACTIONS(1382),
    [anon_sym_GT_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT] = ACTIONS(1382),
    [anon_sym_AMP_GT_GT] = ACTIONS(1380),
    [anon_sym_LT_AMP] = ACTIONS(1380),
    [anon_sym_GT_AMP] = ACTIONS(1380),
    [anon_sym_LT_LT] = ACTIONS(1382),
    [anon_sym_LT_LT_DASH] = ACTIONS(1380),
    [anon_sym_LT_LT_LT] = ACTIONS(1380),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1380),
    [anon_sym_AMP] = ACTIONS(1382),
  },
  [2672] = {
    [aux_sym__literal_repeat1] = STATE(2674),
    [sym__simple_heredoc_body] = ACTIONS(1384),
    [sym__heredoc_body_beginning] = ACTIONS(1384),
    [sym_file_descriptor] = ACTIONS(1384),
    [anon_sym_SEMI] = ACTIONS(1386),
    [anon_sym_PIPE] = ACTIONS(1386),
    [anon_sym_SEMI_SEMI] = ACTIONS(1384),
    [anon_sym_PIPE_AMP] = ACTIONS(1384),
    [anon_sym_AMP_AMP] = ACTIONS(1384),
    [anon_sym_PIPE_PIPE] = ACTIONS(1384),
    [anon_sym_LT] = ACTIONS(1386),
    [anon_sym_GT] = ACTIONS(1386),
    [anon_sym_GT_GT] = ACTIONS(1384),
    [anon_sym_AMP_GT] = ACTIONS(1386),
    [anon_sym_AMP_GT_GT] = ACTIONS(1384),
    [anon_sym_LT_AMP] = ACTIONS(1384),
    [anon_sym_GT_AMP] = ACTIONS(1384),
    [anon_sym_LT_LT] = ACTIONS(1386),
    [anon_sym_LT_LT_DASH] = ACTIONS(1384),
    [anon_sym_LT_LT_LT] = ACTIONS(1384),
    [sym__special_character] = ACTIONS(441),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1384),
    [anon_sym_AMP] = ACTIONS(1386),
  },
  [2673] = {
    [aux_sym_concatenation_repeat1] = STATE(3259),
    [sym__simple_heredoc_body] = ACTIONS(1071),
    [sym__heredoc_body_beginning] = ACTIONS(1071),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(4377),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1075),
  },
  [2674] = {
    [aux_sym__literal_repeat1] = STATE(2674),
    [sym__simple_heredoc_body] = ACTIONS(1373),
    [sym__heredoc_body_beginning] = ACTIONS(1373),
    [sym_file_descriptor] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE_AMP] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_LT_LT_DASH] = ACTIONS(1373),
    [anon_sym_LT_LT_LT] = ACTIONS(1373),
    [sym__special_character] = ACTIONS(1377),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
  },
  [2675] = {
    [sym_string] = STATE(1352),
    [anon_sym_RPAREN] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(7272),
    [anon_sym_DOLLAR] = ACTIONS(7272),
    [sym__special_character] = ACTIONS(4071),
    [anon_sym_DQUOTE] = ACTIONS(1410),
    [sym_raw_string] = ACTIONS(2725),
    [anon_sym_POUND] = ACTIONS(2723),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4071),
    [anon_sym_BQUOTE] = ACTIONS(4071),
    [anon_sym_LT_LPAREN] = ACTIONS(4071),
    [anon_sym_GT_LPAREN] = ACTIONS(4071),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2727),
    [anon_sym_STAR] = ACTIONS(2727),
    [anon_sym_AT] = ACTIONS(2727),
    [anon_sym_QMARK] = ACTIONS(2727),
    [anon_sym_0] = ACTIONS(2727),
    [anon_sym__] = ACTIONS(2727),
    [sym_word] = ACTIONS(4073),
  },
  [2676] = {
    [sym__concat] = ACTIONS(4111),
    [anon_sym_RPAREN] = ACTIONS(4111),
    [anon_sym_DOLLAR] = ACTIONS(4113),
    [sym__special_character] = ACTIONS(4111),
    [anon_sym_DQUOTE] = ACTIONS(4111),
    [sym_raw_string] = ACTIONS(4111),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4111),
    [anon_sym_BQUOTE] = ACTIONS(4111),
    [anon_sym_LT_LPAREN] = ACTIONS(4111),
    [anon_sym_GT_LPAREN] = ACTIONS(4111),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4111),
  },
  [2677] = {
    [sym__concat] = ACTIONS(4125),
    [anon_sym_RPAREN] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym__special_character] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4125),
  },
  [2678] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(7274),
    [sym_comment] = ACTIONS(57),
  },
  [2679] = {
    [anon_sym_RBRACE] = ACTIONS(7274),
    [sym_comment] = ACTIONS(57),
  },
  [2680] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(7276),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [2681] = {
    [sym_concatenation] = STATE(3263),
    [sym_string] = STATE(3262),
    [sym_simple_expansion] = STATE(3262),
    [sym_string_expansion] = STATE(3262),
    [sym_expansion] = STATE(3262),
    [sym_command_substitution] = STATE(3262),
    [sym_process_substitution] = STATE(3262),
    [aux_sym__literal_repeat1] = STATE(3264),
    [anon_sym_RBRACE] = ACTIONS(7274),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(7278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7278),
  },
  [2682] = {
    [sym__concat] = ACTIONS(4161),
    [anon_sym_RPAREN] = ACTIONS(4161),
    [anon_sym_DOLLAR] = ACTIONS(4163),
    [sym__special_character] = ACTIONS(4161),
    [anon_sym_DQUOTE] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4161),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4161),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4161),
    [anon_sym_BQUOTE] = ACTIONS(4161),
    [anon_sym_LT_LPAREN] = ACTIONS(4161),
    [anon_sym_GT_LPAREN] = ACTIONS(4161),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4161),
  },
  [2683] = {
    [sym_concatenation] = STATE(3267),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3267),
    [sym_regex] = ACTIONS(7280),
    [anon_sym_RBRACE] = ACTIONS(7282),
    [anon_sym_EQ] = ACTIONS(7284),
    [anon_sym_DASH] = ACTIONS(7284),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7286),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7284),
    [anon_sym_COLON_QMARK] = ACTIONS(7284),
    [anon_sym_COLON_DASH] = ACTIONS(7284),
    [anon_sym_PERCENT] = ACTIONS(7284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2684] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7282),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2685] = {
    [sym_concatenation] = STATE(3269),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3269),
    [sym_regex] = ACTIONS(7288),
    [anon_sym_RBRACE] = ACTIONS(7274),
    [anon_sym_EQ] = ACTIONS(7290),
    [anon_sym_DASH] = ACTIONS(7290),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7292),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7290),
    [anon_sym_COLON_QMARK] = ACTIONS(7290),
    [anon_sym_COLON_DASH] = ACTIONS(7290),
    [anon_sym_PERCENT] = ACTIONS(7290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2686] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7274),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2687] = {
    [sym_concatenation] = STATE(3271),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3271),
    [anon_sym_RBRACE] = ACTIONS(7294),
    [anon_sym_EQ] = ACTIONS(7296),
    [anon_sym_DASH] = ACTIONS(7296),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7298),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7296),
    [anon_sym_COLON_QMARK] = ACTIONS(7296),
    [anon_sym_COLON_DASH] = ACTIONS(7296),
    [anon_sym_PERCENT] = ACTIONS(7296),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2688] = {
    [sym__concat] = ACTIONS(4219),
    [anon_sym_RPAREN] = ACTIONS(4219),
    [anon_sym_DOLLAR] = ACTIONS(4221),
    [sym__special_character] = ACTIONS(4219),
    [anon_sym_DQUOTE] = ACTIONS(4219),
    [sym_raw_string] = ACTIONS(4219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4219),
    [anon_sym_BQUOTE] = ACTIONS(4219),
    [anon_sym_LT_LPAREN] = ACTIONS(4219),
    [anon_sym_GT_LPAREN] = ACTIONS(4219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4219),
  },
  [2689] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7294),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2690] = {
    [sym_concatenation] = STATE(3269),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3269),
    [anon_sym_RBRACE] = ACTIONS(7274),
    [anon_sym_EQ] = ACTIONS(7290),
    [anon_sym_DASH] = ACTIONS(7290),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7292),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7290),
    [anon_sym_COLON_QMARK] = ACTIONS(7290),
    [anon_sym_COLON_DASH] = ACTIONS(7290),
    [anon_sym_PERCENT] = ACTIONS(7290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2691] = {
    [sym__simple_heredoc_body] = ACTIONS(5674),
    [sym__heredoc_body_beginning] = ACTIONS(5674),
    [sym_file_descriptor] = ACTIONS(5674),
    [sym__concat] = ACTIONS(5674),
    [sym_variable_name] = ACTIONS(5674),
    [ts_builtin_sym_end] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(5676),
    [anon_sym_PIPE] = ACTIONS(5676),
    [anon_sym_RPAREN] = ACTIONS(5674),
    [anon_sym_SEMI_SEMI] = ACTIONS(5674),
    [anon_sym_PIPE_AMP] = ACTIONS(5674),
    [anon_sym_AMP_AMP] = ACTIONS(5674),
    [anon_sym_PIPE_PIPE] = ACTIONS(5674),
    [anon_sym_LT] = ACTIONS(5676),
    [anon_sym_GT] = ACTIONS(5676),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_AMP_GT] = ACTIONS(5676),
    [anon_sym_AMP_GT_GT] = ACTIONS(5674),
    [anon_sym_LT_AMP] = ACTIONS(5674),
    [anon_sym_GT_AMP] = ACTIONS(5674),
    [anon_sym_LT_LT] = ACTIONS(5676),
    [anon_sym_LT_LT_DASH] = ACTIONS(5674),
    [anon_sym_LT_LT_LT] = ACTIONS(5674),
    [anon_sym_DOLLAR] = ACTIONS(5676),
    [sym__special_character] = ACTIONS(5674),
    [anon_sym_DQUOTE] = ACTIONS(5674),
    [sym_raw_string] = ACTIONS(5674),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5674),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5674),
    [anon_sym_BQUOTE] = ACTIONS(5674),
    [anon_sym_LT_LPAREN] = ACTIONS(5674),
    [anon_sym_GT_LPAREN] = ACTIONS(5674),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5676),
    [anon_sym_LF] = ACTIONS(5674),
    [anon_sym_AMP] = ACTIONS(5676),
  },
  [2692] = {
    [sym__simple_heredoc_body] = ACTIONS(5708),
    [sym__heredoc_body_beginning] = ACTIONS(5708),
    [sym_file_descriptor] = ACTIONS(5708),
    [sym__concat] = ACTIONS(5708),
    [sym_variable_name] = ACTIONS(5708),
    [ts_builtin_sym_end] = ACTIONS(5708),
    [anon_sym_SEMI] = ACTIONS(5710),
    [anon_sym_PIPE] = ACTIONS(5710),
    [anon_sym_RPAREN] = ACTIONS(5708),
    [anon_sym_SEMI_SEMI] = ACTIONS(5708),
    [anon_sym_PIPE_AMP] = ACTIONS(5708),
    [anon_sym_AMP_AMP] = ACTIONS(5708),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_LT] = ACTIONS(5710),
    [anon_sym_GT] = ACTIONS(5710),
    [anon_sym_GT_GT] = ACTIONS(5708),
    [anon_sym_AMP_GT] = ACTIONS(5710),
    [anon_sym_AMP_GT_GT] = ACTIONS(5708),
    [anon_sym_LT_AMP] = ACTIONS(5708),
    [anon_sym_GT_AMP] = ACTIONS(5708),
    [anon_sym_LT_LT] = ACTIONS(5710),
    [anon_sym_LT_LT_DASH] = ACTIONS(5708),
    [anon_sym_LT_LT_LT] = ACTIONS(5708),
    [anon_sym_DOLLAR] = ACTIONS(5710),
    [sym__special_character] = ACTIONS(5708),
    [anon_sym_DQUOTE] = ACTIONS(5708),
    [sym_raw_string] = ACTIONS(5708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5708),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5708),
    [anon_sym_BQUOTE] = ACTIONS(5708),
    [anon_sym_LT_LPAREN] = ACTIONS(5708),
    [anon_sym_GT_LPAREN] = ACTIONS(5708),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5710),
    [anon_sym_LF] = ACTIONS(5708),
    [anon_sym_AMP] = ACTIONS(5710),
  },
  [2693] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(7300),
    [sym_comment] = ACTIONS(57),
  },
  [2694] = {
    [anon_sym_RBRACE] = ACTIONS(7300),
    [sym_comment] = ACTIONS(57),
  },
  [2695] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(7302),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [2696] = {
    [sym_concatenation] = STATE(3275),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3275),
    [anon_sym_RBRACE] = ACTIONS(7304),
    [anon_sym_EQ] = ACTIONS(7306),
    [anon_sym_DASH] = ACTIONS(7306),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7308),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7306),
    [anon_sym_COLON_QMARK] = ACTIONS(7306),
    [anon_sym_COLON_DASH] = ACTIONS(7306),
    [anon_sym_PERCENT] = ACTIONS(7306),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2697] = {
    [sym__simple_heredoc_body] = ACTIONS(5725),
    [sym__heredoc_body_beginning] = ACTIONS(5725),
    [sym_file_descriptor] = ACTIONS(5725),
    [sym__concat] = ACTIONS(5725),
    [sym_variable_name] = ACTIONS(5725),
    [ts_builtin_sym_end] = ACTIONS(5725),
    [anon_sym_SEMI] = ACTIONS(5727),
    [anon_sym_PIPE] = ACTIONS(5727),
    [anon_sym_RPAREN] = ACTIONS(5725),
    [anon_sym_SEMI_SEMI] = ACTIONS(5725),
    [anon_sym_PIPE_AMP] = ACTIONS(5725),
    [anon_sym_AMP_AMP] = ACTIONS(5725),
    [anon_sym_PIPE_PIPE] = ACTIONS(5725),
    [anon_sym_LT] = ACTIONS(5727),
    [anon_sym_GT] = ACTIONS(5727),
    [anon_sym_GT_GT] = ACTIONS(5725),
    [anon_sym_AMP_GT] = ACTIONS(5727),
    [anon_sym_AMP_GT_GT] = ACTIONS(5725),
    [anon_sym_LT_AMP] = ACTIONS(5725),
    [anon_sym_GT_AMP] = ACTIONS(5725),
    [anon_sym_LT_LT] = ACTIONS(5727),
    [anon_sym_LT_LT_DASH] = ACTIONS(5725),
    [anon_sym_LT_LT_LT] = ACTIONS(5725),
    [anon_sym_DOLLAR] = ACTIONS(5727),
    [sym__special_character] = ACTIONS(5725),
    [anon_sym_DQUOTE] = ACTIONS(5725),
    [sym_raw_string] = ACTIONS(5725),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5725),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5725),
    [anon_sym_BQUOTE] = ACTIONS(5725),
    [anon_sym_LT_LPAREN] = ACTIONS(5725),
    [anon_sym_GT_LPAREN] = ACTIONS(5725),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5727),
    [anon_sym_LF] = ACTIONS(5725),
    [anon_sym_AMP] = ACTIONS(5727),
  },
  [2698] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7304),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2699] = {
    [sym_concatenation] = STATE(3276),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3276),
    [anon_sym_RBRACE] = ACTIONS(7300),
    [anon_sym_EQ] = ACTIONS(7310),
    [anon_sym_DASH] = ACTIONS(7310),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7312),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7310),
    [anon_sym_COLON_QMARK] = ACTIONS(7310),
    [anon_sym_COLON_DASH] = ACTIONS(7310),
    [anon_sym_PERCENT] = ACTIONS(7310),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2700] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7300),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2701] = {
    [sym__simple_heredoc_body] = ACTIONS(5770),
    [sym__heredoc_body_beginning] = ACTIONS(5770),
    [sym_file_descriptor] = ACTIONS(5770),
    [sym__concat] = ACTIONS(5770),
    [sym_variable_name] = ACTIONS(5770),
    [ts_builtin_sym_end] = ACTIONS(5770),
    [anon_sym_SEMI] = ACTIONS(5772),
    [anon_sym_PIPE] = ACTIONS(5772),
    [anon_sym_RPAREN] = ACTIONS(5770),
    [anon_sym_SEMI_SEMI] = ACTIONS(5770),
    [anon_sym_PIPE_AMP] = ACTIONS(5770),
    [anon_sym_AMP_AMP] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5770),
    [anon_sym_LT] = ACTIONS(5772),
    [anon_sym_GT] = ACTIONS(5772),
    [anon_sym_GT_GT] = ACTIONS(5770),
    [anon_sym_AMP_GT] = ACTIONS(5772),
    [anon_sym_AMP_GT_GT] = ACTIONS(5770),
    [anon_sym_LT_AMP] = ACTIONS(5770),
    [anon_sym_GT_AMP] = ACTIONS(5770),
    [anon_sym_LT_LT] = ACTIONS(5772),
    [anon_sym_LT_LT_DASH] = ACTIONS(5770),
    [anon_sym_LT_LT_LT] = ACTIONS(5770),
    [anon_sym_DOLLAR] = ACTIONS(5772),
    [sym__special_character] = ACTIONS(5770),
    [anon_sym_DQUOTE] = ACTIONS(5770),
    [sym_raw_string] = ACTIONS(5770),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5770),
    [anon_sym_BQUOTE] = ACTIONS(5770),
    [anon_sym_LT_LPAREN] = ACTIONS(5770),
    [anon_sym_GT_LPAREN] = ACTIONS(5770),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5772),
    [anon_sym_LF] = ACTIONS(5770),
    [anon_sym_AMP] = ACTIONS(5772),
  },
  [2702] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7314),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2703] = {
    [sym__simple_heredoc_body] = ACTIONS(7316),
    [sym__heredoc_body_beginning] = ACTIONS(7316),
    [sym_file_descriptor] = ACTIONS(7316),
    [ts_builtin_sym_end] = ACTIONS(7316),
    [anon_sym_SEMI] = ACTIONS(7318),
    [anon_sym_done] = ACTIONS(7316),
    [anon_sym_fi] = ACTIONS(7316),
    [anon_sym_elif] = ACTIONS(7316),
    [anon_sym_else] = ACTIONS(7316),
    [anon_sym_esac] = ACTIONS(7316),
    [anon_sym_PIPE] = ACTIONS(7318),
    [anon_sym_RPAREN] = ACTIONS(7316),
    [anon_sym_SEMI_SEMI] = ACTIONS(7316),
    [anon_sym_PIPE_AMP] = ACTIONS(7316),
    [anon_sym_AMP_AMP] = ACTIONS(7316),
    [anon_sym_PIPE_PIPE] = ACTIONS(7316),
    [anon_sym_LT] = ACTIONS(7318),
    [anon_sym_GT] = ACTIONS(7318),
    [anon_sym_GT_GT] = ACTIONS(7316),
    [anon_sym_AMP_GT] = ACTIONS(7318),
    [anon_sym_AMP_GT_GT] = ACTIONS(7316),
    [anon_sym_LT_AMP] = ACTIONS(7316),
    [anon_sym_GT_AMP] = ACTIONS(7316),
    [anon_sym_LT_LT] = ACTIONS(7318),
    [anon_sym_LT_LT_DASH] = ACTIONS(7316),
    [anon_sym_LT_LT_LT] = ACTIONS(7316),
    [anon_sym_BQUOTE] = ACTIONS(7316),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(7316),
    [anon_sym_AMP] = ACTIONS(7318),
  },
  [2704] = {
    [sym_do_group] = STATE(3278),
    [sym_compound_statement] = STATE(3278),
    [anon_sym_do] = ACTIONS(651),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(57),
  },
  [2705] = {
    [sym_do_group] = STATE(3278),
    [sym_compound_statement] = STATE(3278),
    [anon_sym_SEMI] = ACTIONS(7320),
    [anon_sym_do] = ACTIONS(651),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(57),
  },
  [2706] = {
    [sym__concat] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(5676),
    [anon_sym_SEMI_SEMI] = ACTIONS(5674),
    [anon_sym_AMP_AMP] = ACTIONS(5674),
    [anon_sym_PIPE_PIPE] = ACTIONS(5674),
    [anon_sym_EQ_TILDE] = ACTIONS(5674),
    [anon_sym_EQ_EQ] = ACTIONS(5674),
    [anon_sym_EQ] = ACTIONS(5676),
    [anon_sym_PLUS_EQ] = ACTIONS(5674),
    [anon_sym_LT] = ACTIONS(5676),
    [anon_sym_GT] = ACTIONS(5676),
    [anon_sym_BANG_EQ] = ACTIONS(5674),
    [anon_sym_PLUS] = ACTIONS(5676),
    [anon_sym_DASH] = ACTIONS(5676),
    [anon_sym_DASH_EQ] = ACTIONS(5674),
    [anon_sym_LT_EQ] = ACTIONS(5674),
    [anon_sym_GT_EQ] = ACTIONS(5674),
    [anon_sym_PLUS_PLUS] = ACTIONS(5674),
    [anon_sym_DASH_DASH] = ACTIONS(5674),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5674),
    [anon_sym_LF] = ACTIONS(5674),
    [anon_sym_AMP] = ACTIONS(5676),
  },
  [2707] = {
    [sym__concat] = ACTIONS(5708),
    [anon_sym_SEMI] = ACTIONS(5710),
    [anon_sym_SEMI_SEMI] = ACTIONS(5708),
    [anon_sym_AMP_AMP] = ACTIONS(5708),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_EQ_TILDE] = ACTIONS(5708),
    [anon_sym_EQ_EQ] = ACTIONS(5708),
    [anon_sym_EQ] = ACTIONS(5710),
    [anon_sym_PLUS_EQ] = ACTIONS(5708),
    [anon_sym_LT] = ACTIONS(5710),
    [anon_sym_GT] = ACTIONS(5710),
    [anon_sym_BANG_EQ] = ACTIONS(5708),
    [anon_sym_PLUS] = ACTIONS(5710),
    [anon_sym_DASH] = ACTIONS(5710),
    [anon_sym_DASH_EQ] = ACTIONS(5708),
    [anon_sym_LT_EQ] = ACTIONS(5708),
    [anon_sym_GT_EQ] = ACTIONS(5708),
    [anon_sym_PLUS_PLUS] = ACTIONS(5708),
    [anon_sym_DASH_DASH] = ACTIONS(5708),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5708),
    [anon_sym_LF] = ACTIONS(5708),
    [anon_sym_AMP] = ACTIONS(5710),
  },
  [2708] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(7322),
    [sym_comment] = ACTIONS(57),
  },
  [2709] = {
    [anon_sym_RBRACE] = ACTIONS(7322),
    [sym_comment] = ACTIONS(57),
  },
  [2710] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(7324),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [2711] = {
    [sym_concatenation] = STATE(3283),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3283),
    [anon_sym_RBRACE] = ACTIONS(7326),
    [anon_sym_EQ] = ACTIONS(7328),
    [anon_sym_DASH] = ACTIONS(7328),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7330),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7328),
    [anon_sym_COLON_QMARK] = ACTIONS(7328),
    [anon_sym_COLON_DASH] = ACTIONS(7328),
    [anon_sym_PERCENT] = ACTIONS(7328),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2712] = {
    [sym__concat] = ACTIONS(5725),
    [anon_sym_SEMI] = ACTIONS(5727),
    [anon_sym_SEMI_SEMI] = ACTIONS(5725),
    [anon_sym_AMP_AMP] = ACTIONS(5725),
    [anon_sym_PIPE_PIPE] = ACTIONS(5725),
    [anon_sym_EQ_TILDE] = ACTIONS(5725),
    [anon_sym_EQ_EQ] = ACTIONS(5725),
    [anon_sym_EQ] = ACTIONS(5727),
    [anon_sym_PLUS_EQ] = ACTIONS(5725),
    [anon_sym_LT] = ACTIONS(5727),
    [anon_sym_GT] = ACTIONS(5727),
    [anon_sym_BANG_EQ] = ACTIONS(5725),
    [anon_sym_PLUS] = ACTIONS(5727),
    [anon_sym_DASH] = ACTIONS(5727),
    [anon_sym_DASH_EQ] = ACTIONS(5725),
    [anon_sym_LT_EQ] = ACTIONS(5725),
    [anon_sym_GT_EQ] = ACTIONS(5725),
    [anon_sym_PLUS_PLUS] = ACTIONS(5725),
    [anon_sym_DASH_DASH] = ACTIONS(5725),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5725),
    [anon_sym_LF] = ACTIONS(5725),
    [anon_sym_AMP] = ACTIONS(5727),
  },
  [2713] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7326),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2714] = {
    [sym_concatenation] = STATE(3284),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3284),
    [anon_sym_RBRACE] = ACTIONS(7322),
    [anon_sym_EQ] = ACTIONS(7332),
    [anon_sym_DASH] = ACTIONS(7332),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7334),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7332),
    [anon_sym_COLON_QMARK] = ACTIONS(7332),
    [anon_sym_COLON_DASH] = ACTIONS(7332),
    [anon_sym_PERCENT] = ACTIONS(7332),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2715] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7322),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2716] = {
    [sym__concat] = ACTIONS(5770),
    [anon_sym_SEMI] = ACTIONS(5772),
    [anon_sym_SEMI_SEMI] = ACTIONS(5770),
    [anon_sym_AMP_AMP] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5770),
    [anon_sym_EQ_TILDE] = ACTIONS(5770),
    [anon_sym_EQ_EQ] = ACTIONS(5770),
    [anon_sym_EQ] = ACTIONS(5772),
    [anon_sym_PLUS_EQ] = ACTIONS(5770),
    [anon_sym_LT] = ACTIONS(5772),
    [anon_sym_GT] = ACTIONS(5772),
    [anon_sym_BANG_EQ] = ACTIONS(5770),
    [anon_sym_PLUS] = ACTIONS(5772),
    [anon_sym_DASH] = ACTIONS(5772),
    [anon_sym_DASH_EQ] = ACTIONS(5770),
    [anon_sym_LT_EQ] = ACTIONS(5770),
    [anon_sym_GT_EQ] = ACTIONS(5770),
    [anon_sym_PLUS_PLUS] = ACTIONS(5770),
    [anon_sym_DASH_DASH] = ACTIONS(5770),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5770),
    [anon_sym_LF] = ACTIONS(5770),
    [anon_sym_AMP] = ACTIONS(5772),
  },
  [2717] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7336),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2718] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(7338),
    [anon_sym_AMP_AMP] = ACTIONS(557),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(559),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_PLUS_EQ] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DASH_EQ] = ACTIONS(557),
    [anon_sym_LT_EQ] = ACTIONS(557),
    [anon_sym_GT_EQ] = ACTIONS(557),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(557),
  },
  [2719] = {
    [sym_string] = STATE(1413),
    [anon_sym_SEMI] = ACTIONS(4073),
    [anon_sym_SEMI_SEMI] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(7340),
    [anon_sym_DOLLAR] = ACTIONS(7340),
    [sym__special_character] = ACTIONS(4071),
    [anon_sym_DQUOTE] = ACTIONS(1498),
    [sym_raw_string] = ACTIONS(2855),
    [anon_sym_POUND] = ACTIONS(2853),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4071),
    [anon_sym_BQUOTE] = ACTIONS(4071),
    [anon_sym_LT_LPAREN] = ACTIONS(4071),
    [anon_sym_GT_LPAREN] = ACTIONS(4071),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2857),
    [anon_sym_STAR] = ACTIONS(2857),
    [anon_sym_AT] = ACTIONS(2857),
    [anon_sym_QMARK] = ACTIONS(2857),
    [anon_sym_0] = ACTIONS(2857),
    [anon_sym__] = ACTIONS(2857),
    [sym_word] = ACTIONS(4073),
    [anon_sym_LF] = ACTIONS(4071),
    [anon_sym_AMP] = ACTIONS(4071),
  },
  [2720] = {
    [sym__concat] = ACTIONS(4111),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_SEMI_SEMI] = ACTIONS(4111),
    [anon_sym_DOLLAR] = ACTIONS(4113),
    [sym__special_character] = ACTIONS(4111),
    [anon_sym_DQUOTE] = ACTIONS(4111),
    [sym_raw_string] = ACTIONS(4111),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4111),
    [anon_sym_BQUOTE] = ACTIONS(4111),
    [anon_sym_LT_LPAREN] = ACTIONS(4111),
    [anon_sym_GT_LPAREN] = ACTIONS(4111),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4113),
    [anon_sym_LF] = ACTIONS(4111),
    [anon_sym_AMP] = ACTIONS(4111),
  },
  [2721] = {
    [sym__concat] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym__special_character] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4125),
  },
  [2722] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(7342),
    [sym_comment] = ACTIONS(57),
  },
  [2723] = {
    [anon_sym_RBRACE] = ACTIONS(7342),
    [sym_comment] = ACTIONS(57),
  },
  [2724] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(7344),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [2725] = {
    [sym_concatenation] = STATE(3290),
    [sym_string] = STATE(3289),
    [sym_simple_expansion] = STATE(3289),
    [sym_string_expansion] = STATE(3289),
    [sym_expansion] = STATE(3289),
    [sym_command_substitution] = STATE(3289),
    [sym_process_substitution] = STATE(3289),
    [aux_sym__literal_repeat1] = STATE(3291),
    [anon_sym_RBRACE] = ACTIONS(7342),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(7346),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7346),
  },
  [2726] = {
    [sym__concat] = ACTIONS(4161),
    [anon_sym_SEMI] = ACTIONS(4163),
    [anon_sym_SEMI_SEMI] = ACTIONS(4161),
    [anon_sym_DOLLAR] = ACTIONS(4163),
    [sym__special_character] = ACTIONS(4161),
    [anon_sym_DQUOTE] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4161),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4161),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4161),
    [anon_sym_BQUOTE] = ACTIONS(4161),
    [anon_sym_LT_LPAREN] = ACTIONS(4161),
    [anon_sym_GT_LPAREN] = ACTIONS(4161),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4163),
    [anon_sym_LF] = ACTIONS(4161),
    [anon_sym_AMP] = ACTIONS(4161),
  },
  [2727] = {
    [sym_concatenation] = STATE(3294),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3294),
    [sym_regex] = ACTIONS(7348),
    [anon_sym_RBRACE] = ACTIONS(7350),
    [anon_sym_EQ] = ACTIONS(7352),
    [anon_sym_DASH] = ACTIONS(7352),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7352),
    [anon_sym_COLON_QMARK] = ACTIONS(7352),
    [anon_sym_COLON_DASH] = ACTIONS(7352),
    [anon_sym_PERCENT] = ACTIONS(7352),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2728] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7350),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2729] = {
    [sym_concatenation] = STATE(3296),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3296),
    [sym_regex] = ACTIONS(7356),
    [anon_sym_RBRACE] = ACTIONS(7342),
    [anon_sym_EQ] = ACTIONS(7358),
    [anon_sym_DASH] = ACTIONS(7358),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7358),
    [anon_sym_COLON_QMARK] = ACTIONS(7358),
    [anon_sym_COLON_DASH] = ACTIONS(7358),
    [anon_sym_PERCENT] = ACTIONS(7358),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2730] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7342),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2731] = {
    [sym_concatenation] = STATE(3298),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3298),
    [anon_sym_RBRACE] = ACTIONS(7362),
    [anon_sym_EQ] = ACTIONS(7364),
    [anon_sym_DASH] = ACTIONS(7364),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7364),
    [anon_sym_COLON_QMARK] = ACTIONS(7364),
    [anon_sym_COLON_DASH] = ACTIONS(7364),
    [anon_sym_PERCENT] = ACTIONS(7364),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2732] = {
    [sym__concat] = ACTIONS(4219),
    [anon_sym_SEMI] = ACTIONS(4221),
    [anon_sym_SEMI_SEMI] = ACTIONS(4219),
    [anon_sym_DOLLAR] = ACTIONS(4221),
    [sym__special_character] = ACTIONS(4219),
    [anon_sym_DQUOTE] = ACTIONS(4219),
    [sym_raw_string] = ACTIONS(4219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4219),
    [anon_sym_BQUOTE] = ACTIONS(4219),
    [anon_sym_LT_LPAREN] = ACTIONS(4219),
    [anon_sym_GT_LPAREN] = ACTIONS(4219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4221),
    [anon_sym_LF] = ACTIONS(4219),
    [anon_sym_AMP] = ACTIONS(4219),
  },
  [2733] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7362),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2734] = {
    [sym_concatenation] = STATE(3296),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3296),
    [anon_sym_RBRACE] = ACTIONS(7342),
    [anon_sym_EQ] = ACTIONS(7358),
    [anon_sym_DASH] = ACTIONS(7358),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7358),
    [anon_sym_COLON_QMARK] = ACTIONS(7358),
    [anon_sym_COLON_DASH] = ACTIONS(7358),
    [anon_sym_PERCENT] = ACTIONS(7358),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2735] = {
    [sym__concat] = ACTIONS(5674),
    [anon_sym_PIPE] = ACTIONS(5676),
    [anon_sym_RPAREN] = ACTIONS(5674),
    [anon_sym_AMP_AMP] = ACTIONS(5674),
    [anon_sym_PIPE_PIPE] = ACTIONS(5674),
    [anon_sym_EQ_TILDE] = ACTIONS(5674),
    [anon_sym_EQ_EQ] = ACTIONS(5674),
    [anon_sym_EQ] = ACTIONS(5676),
    [anon_sym_PLUS_EQ] = ACTIONS(5674),
    [anon_sym_LT] = ACTIONS(5676),
    [anon_sym_GT] = ACTIONS(5676),
    [anon_sym_BANG_EQ] = ACTIONS(5674),
    [anon_sym_PLUS] = ACTIONS(5676),
    [anon_sym_DASH] = ACTIONS(5676),
    [anon_sym_DASH_EQ] = ACTIONS(5674),
    [anon_sym_LT_EQ] = ACTIONS(5674),
    [anon_sym_GT_EQ] = ACTIONS(5674),
    [anon_sym_PLUS_PLUS] = ACTIONS(5674),
    [anon_sym_DASH_DASH] = ACTIONS(5674),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5674),
  },
  [2736] = {
    [sym__concat] = ACTIONS(5708),
    [anon_sym_PIPE] = ACTIONS(5710),
    [anon_sym_RPAREN] = ACTIONS(5708),
    [anon_sym_AMP_AMP] = ACTIONS(5708),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_EQ_TILDE] = ACTIONS(5708),
    [anon_sym_EQ_EQ] = ACTIONS(5708),
    [anon_sym_EQ] = ACTIONS(5710),
    [anon_sym_PLUS_EQ] = ACTIONS(5708),
    [anon_sym_LT] = ACTIONS(5710),
    [anon_sym_GT] = ACTIONS(5710),
    [anon_sym_BANG_EQ] = ACTIONS(5708),
    [anon_sym_PLUS] = ACTIONS(5710),
    [anon_sym_DASH] = ACTIONS(5710),
    [anon_sym_DASH_EQ] = ACTIONS(5708),
    [anon_sym_LT_EQ] = ACTIONS(5708),
    [anon_sym_GT_EQ] = ACTIONS(5708),
    [anon_sym_PLUS_PLUS] = ACTIONS(5708),
    [anon_sym_DASH_DASH] = ACTIONS(5708),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5708),
  },
  [2737] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(7368),
    [sym_comment] = ACTIONS(57),
  },
  [2738] = {
    [anon_sym_RBRACE] = ACTIONS(7368),
    [sym_comment] = ACTIONS(57),
  },
  [2739] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(7370),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [2740] = {
    [sym_concatenation] = STATE(3302),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3302),
    [anon_sym_RBRACE] = ACTIONS(7372),
    [anon_sym_EQ] = ACTIONS(7374),
    [anon_sym_DASH] = ACTIONS(7374),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7376),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7374),
    [anon_sym_COLON_QMARK] = ACTIONS(7374),
    [anon_sym_COLON_DASH] = ACTIONS(7374),
    [anon_sym_PERCENT] = ACTIONS(7374),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2741] = {
    [sym__concat] = ACTIONS(5725),
    [anon_sym_PIPE] = ACTIONS(5727),
    [anon_sym_RPAREN] = ACTIONS(5725),
    [anon_sym_AMP_AMP] = ACTIONS(5725),
    [anon_sym_PIPE_PIPE] = ACTIONS(5725),
    [anon_sym_EQ_TILDE] = ACTIONS(5725),
    [anon_sym_EQ_EQ] = ACTIONS(5725),
    [anon_sym_EQ] = ACTIONS(5727),
    [anon_sym_PLUS_EQ] = ACTIONS(5725),
    [anon_sym_LT] = ACTIONS(5727),
    [anon_sym_GT] = ACTIONS(5727),
    [anon_sym_BANG_EQ] = ACTIONS(5725),
    [anon_sym_PLUS] = ACTIONS(5727),
    [anon_sym_DASH] = ACTIONS(5727),
    [anon_sym_DASH_EQ] = ACTIONS(5725),
    [anon_sym_LT_EQ] = ACTIONS(5725),
    [anon_sym_GT_EQ] = ACTIONS(5725),
    [anon_sym_PLUS_PLUS] = ACTIONS(5725),
    [anon_sym_DASH_DASH] = ACTIONS(5725),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5725),
  },
  [2742] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7372),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2743] = {
    [sym_concatenation] = STATE(3303),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3303),
    [anon_sym_RBRACE] = ACTIONS(7368),
    [anon_sym_EQ] = ACTIONS(7378),
    [anon_sym_DASH] = ACTIONS(7378),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7380),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7378),
    [anon_sym_COLON_QMARK] = ACTIONS(7378),
    [anon_sym_COLON_DASH] = ACTIONS(7378),
    [anon_sym_PERCENT] = ACTIONS(7378),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2744] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7368),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2745] = {
    [sym__concat] = ACTIONS(5770),
    [anon_sym_PIPE] = ACTIONS(5772),
    [anon_sym_RPAREN] = ACTIONS(5770),
    [anon_sym_AMP_AMP] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5770),
    [anon_sym_EQ_TILDE] = ACTIONS(5770),
    [anon_sym_EQ_EQ] = ACTIONS(5770),
    [anon_sym_EQ] = ACTIONS(5772),
    [anon_sym_PLUS_EQ] = ACTIONS(5770),
    [anon_sym_LT] = ACTIONS(5772),
    [anon_sym_GT] = ACTIONS(5772),
    [anon_sym_BANG_EQ] = ACTIONS(5770),
    [anon_sym_PLUS] = ACTIONS(5772),
    [anon_sym_DASH] = ACTIONS(5772),
    [anon_sym_DASH_EQ] = ACTIONS(5770),
    [anon_sym_LT_EQ] = ACTIONS(5770),
    [anon_sym_GT_EQ] = ACTIONS(5770),
    [anon_sym_PLUS_PLUS] = ACTIONS(5770),
    [anon_sym_DASH_DASH] = ACTIONS(5770),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5770),
  },
  [2746] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7382),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2747] = {
    [sym__concat] = ACTIONS(7198),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(7198),
    [anon_sym_AMP_AMP] = ACTIONS(7198),
    [anon_sym_PIPE_PIPE] = ACTIONS(7198),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(7198),
    [anon_sym_EQ_TILDE] = ACTIONS(7198),
    [anon_sym_EQ_EQ] = ACTIONS(7198),
    [anon_sym_EQ] = ACTIONS(7200),
    [anon_sym_PLUS_EQ] = ACTIONS(7198),
    [anon_sym_LT] = ACTIONS(7200),
    [anon_sym_GT] = ACTIONS(7200),
    [anon_sym_BANG_EQ] = ACTIONS(7198),
    [anon_sym_PLUS] = ACTIONS(7200),
    [anon_sym_DASH] = ACTIONS(7200),
    [anon_sym_DASH_EQ] = ACTIONS(7198),
    [anon_sym_LT_EQ] = ACTIONS(7198),
    [anon_sym_GT_EQ] = ACTIONS(7198),
    [anon_sym_PLUS_PLUS] = ACTIONS(7198),
    [anon_sym_DASH_DASH] = ACTIONS(7198),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7198),
  },
  [2748] = {
    [sym__concat] = ACTIONS(7202),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(7202),
    [anon_sym_AMP_AMP] = ACTIONS(7202),
    [anon_sym_PIPE_PIPE] = ACTIONS(7202),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(7202),
    [anon_sym_EQ_TILDE] = ACTIONS(7202),
    [anon_sym_EQ_EQ] = ACTIONS(7202),
    [anon_sym_EQ] = ACTIONS(7204),
    [anon_sym_PLUS_EQ] = ACTIONS(7202),
    [anon_sym_LT] = ACTIONS(7204),
    [anon_sym_GT] = ACTIONS(7204),
    [anon_sym_BANG_EQ] = ACTIONS(7202),
    [anon_sym_PLUS] = ACTIONS(7204),
    [anon_sym_DASH] = ACTIONS(7204),
    [anon_sym_DASH_EQ] = ACTIONS(7202),
    [anon_sym_LT_EQ] = ACTIONS(7202),
    [anon_sym_GT_EQ] = ACTIONS(7202),
    [anon_sym_PLUS_PLUS] = ACTIONS(7202),
    [anon_sym_DASH_DASH] = ACTIONS(7202),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7202),
  },
  [2749] = {
    [sym__concat] = ACTIONS(7206),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(7206),
    [anon_sym_AMP_AMP] = ACTIONS(7206),
    [anon_sym_PIPE_PIPE] = ACTIONS(7206),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(7206),
    [anon_sym_EQ_TILDE] = ACTIONS(7206),
    [anon_sym_EQ_EQ] = ACTIONS(7206),
    [anon_sym_EQ] = ACTIONS(7208),
    [anon_sym_PLUS_EQ] = ACTIONS(7206),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_BANG_EQ] = ACTIONS(7206),
    [anon_sym_PLUS] = ACTIONS(7208),
    [anon_sym_DASH] = ACTIONS(7208),
    [anon_sym_DASH_EQ] = ACTIONS(7206),
    [anon_sym_LT_EQ] = ACTIONS(7206),
    [anon_sym_GT_EQ] = ACTIONS(7206),
    [anon_sym_PLUS_PLUS] = ACTIONS(7206),
    [anon_sym_DASH_DASH] = ACTIONS(7206),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7206),
  },
  [2750] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7384),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2751] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7386),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2752] = {
    [sym__concat] = ACTIONS(7242),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(7242),
    [anon_sym_AMP_AMP] = ACTIONS(7242),
    [anon_sym_PIPE_PIPE] = ACTIONS(7242),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(7242),
    [anon_sym_EQ_TILDE] = ACTIONS(7242),
    [anon_sym_EQ_EQ] = ACTIONS(7242),
    [anon_sym_EQ] = ACTIONS(7244),
    [anon_sym_PLUS_EQ] = ACTIONS(7242),
    [anon_sym_LT] = ACTIONS(7244),
    [anon_sym_GT] = ACTIONS(7244),
    [anon_sym_BANG_EQ] = ACTIONS(7242),
    [anon_sym_PLUS] = ACTIONS(7244),
    [anon_sym_DASH] = ACTIONS(7244),
    [anon_sym_DASH_EQ] = ACTIONS(7242),
    [anon_sym_LT_EQ] = ACTIONS(7242),
    [anon_sym_GT_EQ] = ACTIONS(7242),
    [anon_sym_PLUS_PLUS] = ACTIONS(7242),
    [anon_sym_DASH_DASH] = ACTIONS(7242),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7242),
  },
  [2753] = {
    [sym_string] = STATE(1471),
    [sym_file_descriptor] = ACTIONS(4071),
    [sym_variable_name] = ACTIONS(4071),
    [anon_sym_SEMI] = ACTIONS(4073),
    [anon_sym_PIPE] = ACTIONS(4073),
    [anon_sym_SEMI_SEMI] = ACTIONS(4071),
    [anon_sym_PIPE_AMP] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_PIPE_PIPE] = ACTIONS(4071),
    [anon_sym_LT] = ACTIONS(4073),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_GT_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT] = ACTIONS(4073),
    [anon_sym_AMP_GT_GT] = ACTIONS(4071),
    [anon_sym_LT_AMP] = ACTIONS(4071),
    [anon_sym_GT_AMP] = ACTIONS(4071),
    [anon_sym_LT_LT] = ACTIONS(4073),
    [anon_sym_LT_LT_DASH] = ACTIONS(4071),
    [anon_sym_LT_LT_LT] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(7388),
    [anon_sym_DOLLAR] = ACTIONS(7388),
    [sym__special_character] = ACTIONS(4071),
    [anon_sym_DQUOTE] = ACTIONS(1607),
    [sym_raw_string] = ACTIONS(2983),
    [anon_sym_POUND] = ACTIONS(2981),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4071),
    [anon_sym_BQUOTE] = ACTIONS(4071),
    [anon_sym_LT_LPAREN] = ACTIONS(4071),
    [anon_sym_GT_LPAREN] = ACTIONS(4071),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2985),
    [anon_sym_STAR] = ACTIONS(2985),
    [anon_sym_AT] = ACTIONS(2985),
    [anon_sym_QMARK] = ACTIONS(2985),
    [anon_sym_0] = ACTIONS(2985),
    [anon_sym__] = ACTIONS(2985),
    [sym_word] = ACTIONS(4073),
    [anon_sym_LF] = ACTIONS(4071),
    [anon_sym_AMP] = ACTIONS(4073),
  },
  [2754] = {
    [sym_file_descriptor] = ACTIONS(4111),
    [sym__concat] = ACTIONS(4111),
    [sym_variable_name] = ACTIONS(4111),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_PIPE] = ACTIONS(4113),
    [anon_sym_SEMI_SEMI] = ACTIONS(4111),
    [anon_sym_PIPE_AMP] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_LT] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4113),
    [anon_sym_GT_GT] = ACTIONS(4111),
    [anon_sym_AMP_GT] = ACTIONS(4113),
    [anon_sym_AMP_GT_GT] = ACTIONS(4111),
    [anon_sym_LT_AMP] = ACTIONS(4111),
    [anon_sym_GT_AMP] = ACTIONS(4111),
    [anon_sym_LT_LT] = ACTIONS(4113),
    [anon_sym_LT_LT_DASH] = ACTIONS(4111),
    [anon_sym_LT_LT_LT] = ACTIONS(4111),
    [anon_sym_DOLLAR] = ACTIONS(4113),
    [sym__special_character] = ACTIONS(4111),
    [anon_sym_DQUOTE] = ACTIONS(4111),
    [sym_raw_string] = ACTIONS(4111),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4111),
    [anon_sym_BQUOTE] = ACTIONS(4111),
    [anon_sym_LT_LPAREN] = ACTIONS(4111),
    [anon_sym_GT_LPAREN] = ACTIONS(4111),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4113),
    [anon_sym_LF] = ACTIONS(4111),
    [anon_sym_AMP] = ACTIONS(4113),
  },
  [2755] = {
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [sym_variable_name] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym__special_character] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [2756] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(7390),
    [sym_comment] = ACTIONS(57),
  },
  [2757] = {
    [anon_sym_RBRACE] = ACTIONS(7390),
    [sym_comment] = ACTIONS(57),
  },
  [2758] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(7392),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [2759] = {
    [sym_concatenation] = STATE(3310),
    [sym_string] = STATE(3309),
    [sym_simple_expansion] = STATE(3309),
    [sym_string_expansion] = STATE(3309),
    [sym_expansion] = STATE(3309),
    [sym_command_substitution] = STATE(3309),
    [sym_process_substitution] = STATE(3309),
    [aux_sym__literal_repeat1] = STATE(3311),
    [anon_sym_RBRACE] = ACTIONS(7390),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(7394),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7394),
  },
  [2760] = {
    [sym_file_descriptor] = ACTIONS(4161),
    [sym__concat] = ACTIONS(4161),
    [sym_variable_name] = ACTIONS(4161),
    [anon_sym_SEMI] = ACTIONS(4163),
    [anon_sym_PIPE] = ACTIONS(4163),
    [anon_sym_SEMI_SEMI] = ACTIONS(4161),
    [anon_sym_PIPE_AMP] = ACTIONS(4161),
    [anon_sym_AMP_AMP] = ACTIONS(4161),
    [anon_sym_PIPE_PIPE] = ACTIONS(4161),
    [anon_sym_LT] = ACTIONS(4163),
    [anon_sym_GT] = ACTIONS(4163),
    [anon_sym_GT_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT] = ACTIONS(4163),
    [anon_sym_AMP_GT_GT] = ACTIONS(4161),
    [anon_sym_LT_AMP] = ACTIONS(4161),
    [anon_sym_GT_AMP] = ACTIONS(4161),
    [anon_sym_LT_LT] = ACTIONS(4163),
    [anon_sym_LT_LT_DASH] = ACTIONS(4161),
    [anon_sym_LT_LT_LT] = ACTIONS(4161),
    [anon_sym_DOLLAR] = ACTIONS(4163),
    [sym__special_character] = ACTIONS(4161),
    [anon_sym_DQUOTE] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4161),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4161),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4161),
    [anon_sym_BQUOTE] = ACTIONS(4161),
    [anon_sym_LT_LPAREN] = ACTIONS(4161),
    [anon_sym_GT_LPAREN] = ACTIONS(4161),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4163),
    [anon_sym_LF] = ACTIONS(4161),
    [anon_sym_AMP] = ACTIONS(4163),
  },
  [2761] = {
    [sym_concatenation] = STATE(3314),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3314),
    [sym_regex] = ACTIONS(7396),
    [anon_sym_RBRACE] = ACTIONS(7398),
    [anon_sym_EQ] = ACTIONS(7400),
    [anon_sym_DASH] = ACTIONS(7400),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7402),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7400),
    [anon_sym_COLON_QMARK] = ACTIONS(7400),
    [anon_sym_COLON_DASH] = ACTIONS(7400),
    [anon_sym_PERCENT] = ACTIONS(7400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2762] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7398),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2763] = {
    [sym_concatenation] = STATE(3316),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3316),
    [sym_regex] = ACTIONS(7404),
    [anon_sym_RBRACE] = ACTIONS(7390),
    [anon_sym_EQ] = ACTIONS(7406),
    [anon_sym_DASH] = ACTIONS(7406),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7408),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7406),
    [anon_sym_COLON_QMARK] = ACTIONS(7406),
    [anon_sym_COLON_DASH] = ACTIONS(7406),
    [anon_sym_PERCENT] = ACTIONS(7406),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2764] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7390),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2765] = {
    [sym_concatenation] = STATE(3318),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3318),
    [anon_sym_RBRACE] = ACTIONS(7410),
    [anon_sym_EQ] = ACTIONS(7412),
    [anon_sym_DASH] = ACTIONS(7412),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7414),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7412),
    [anon_sym_COLON_QMARK] = ACTIONS(7412),
    [anon_sym_COLON_DASH] = ACTIONS(7412),
    [anon_sym_PERCENT] = ACTIONS(7412),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2766] = {
    [sym_file_descriptor] = ACTIONS(4219),
    [sym__concat] = ACTIONS(4219),
    [sym_variable_name] = ACTIONS(4219),
    [anon_sym_SEMI] = ACTIONS(4221),
    [anon_sym_PIPE] = ACTIONS(4221),
    [anon_sym_SEMI_SEMI] = ACTIONS(4219),
    [anon_sym_PIPE_AMP] = ACTIONS(4219),
    [anon_sym_AMP_AMP] = ACTIONS(4219),
    [anon_sym_PIPE_PIPE] = ACTIONS(4219),
    [anon_sym_LT] = ACTIONS(4221),
    [anon_sym_GT] = ACTIONS(4221),
    [anon_sym_GT_GT] = ACTIONS(4219),
    [anon_sym_AMP_GT] = ACTIONS(4221),
    [anon_sym_AMP_GT_GT] = ACTIONS(4219),
    [anon_sym_LT_AMP] = ACTIONS(4219),
    [anon_sym_GT_AMP] = ACTIONS(4219),
    [anon_sym_LT_LT] = ACTIONS(4221),
    [anon_sym_LT_LT_DASH] = ACTIONS(4219),
    [anon_sym_LT_LT_LT] = ACTIONS(4219),
    [anon_sym_DOLLAR] = ACTIONS(4221),
    [sym__special_character] = ACTIONS(4219),
    [anon_sym_DQUOTE] = ACTIONS(4219),
    [sym_raw_string] = ACTIONS(4219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4219),
    [anon_sym_BQUOTE] = ACTIONS(4219),
    [anon_sym_LT_LPAREN] = ACTIONS(4219),
    [anon_sym_GT_LPAREN] = ACTIONS(4219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4221),
    [anon_sym_LF] = ACTIONS(4219),
    [anon_sym_AMP] = ACTIONS(4221),
  },
  [2767] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7410),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2768] = {
    [sym_concatenation] = STATE(3316),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3316),
    [anon_sym_RBRACE] = ACTIONS(7390),
    [anon_sym_EQ] = ACTIONS(7406),
    [anon_sym_DASH] = ACTIONS(7406),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7408),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7406),
    [anon_sym_COLON_QMARK] = ACTIONS(7406),
    [anon_sym_COLON_DASH] = ACTIONS(7406),
    [anon_sym_PERCENT] = ACTIONS(7406),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2769] = {
    [sym_do_group] = STATE(3319),
    [sym_compound_statement] = STATE(3319),
    [anon_sym_do] = ACTIONS(1631),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_comment] = ACTIONS(57),
  },
  [2770] = {
    [sym_file_descriptor] = ACTIONS(5891),
    [anon_sym_SEMI] = ACTIONS(5893),
    [anon_sym_PIPE] = ACTIONS(5893),
    [anon_sym_SEMI_SEMI] = ACTIONS(5891),
    [anon_sym_PIPE_AMP] = ACTIONS(5891),
    [anon_sym_AMP_AMP] = ACTIONS(5891),
    [anon_sym_PIPE_PIPE] = ACTIONS(5891),
    [anon_sym_LT] = ACTIONS(5893),
    [anon_sym_GT] = ACTIONS(5893),
    [anon_sym_GT_GT] = ACTIONS(5891),
    [anon_sym_AMP_GT] = ACTIONS(5893),
    [anon_sym_AMP_GT_GT] = ACTIONS(5891),
    [anon_sym_LT_AMP] = ACTIONS(5891),
    [anon_sym_GT_AMP] = ACTIONS(5891),
    [anon_sym_LT_LT] = ACTIONS(5893),
    [anon_sym_LT_LT_DASH] = ACTIONS(5891),
    [anon_sym_LT_LT_LT] = ACTIONS(5891),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5891),
    [anon_sym_AMP] = ACTIONS(5893),
  },
  [2771] = {
    [sym_do_group] = STATE(3319),
    [sym_compound_statement] = STATE(3319),
    [anon_sym_SEMI] = ACTIONS(7416),
    [anon_sym_do] = ACTIONS(1631),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_comment] = ACTIONS(57),
  },
  [2772] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(7418),
    [anon_sym_AMP_AMP] = ACTIONS(557),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(559),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_PLUS_EQ] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DASH_EQ] = ACTIONS(557),
    [anon_sym_LT_EQ] = ACTIONS(557),
    [anon_sym_GT_EQ] = ACTIONS(557),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(557),
  },
  [2773] = {
    [sym__expression] = STATE(3322),
    [sym_binary_expression] = STATE(3322),
    [sym_unary_expression] = STATE(3322),
    [sym_postfix_expression] = STATE(3322),
    [sym_parenthesized_expression] = STATE(3322),
    [sym_concatenation] = STATE(3322),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__literal_repeat1] = STATE(53),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(7418),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_DOLLAR] = ACTIONS(77),
    [sym__special_character] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [2774] = {
    [sym_file_descriptor] = ACTIONS(5964),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(5966),
    [anon_sym_SEMI_SEMI] = ACTIONS(5964),
    [anon_sym_PIPE_AMP] = ACTIONS(5964),
    [anon_sym_AMP_AMP] = ACTIONS(5964),
    [anon_sym_PIPE_PIPE] = ACTIONS(5964),
    [anon_sym_LT] = ACTIONS(5966),
    [anon_sym_GT] = ACTIONS(5966),
    [anon_sym_GT_GT] = ACTIONS(5964),
    [anon_sym_AMP_GT] = ACTIONS(5966),
    [anon_sym_AMP_GT_GT] = ACTIONS(5964),
    [anon_sym_LT_AMP] = ACTIONS(5964),
    [anon_sym_GT_AMP] = ACTIONS(5964),
    [anon_sym_LT_LT] = ACTIONS(5966),
    [anon_sym_LT_LT_DASH] = ACTIONS(5964),
    [anon_sym_LT_LT_LT] = ACTIONS(5964),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5964),
    [anon_sym_AMP] = ACTIONS(5966),
  },
  [2775] = {
    [sym_file_descriptor] = ACTIONS(6794),
    [anon_sym_SEMI] = ACTIONS(6796),
    [anon_sym_PIPE] = ACTIONS(6796),
    [anon_sym_SEMI_SEMI] = ACTIONS(6794),
    [anon_sym_PIPE_AMP] = ACTIONS(6794),
    [anon_sym_AMP_AMP] = ACTIONS(6794),
    [anon_sym_PIPE_PIPE] = ACTIONS(6794),
    [anon_sym_LT] = ACTIONS(6796),
    [anon_sym_GT] = ACTIONS(6796),
    [anon_sym_GT_GT] = ACTIONS(6794),
    [anon_sym_AMP_GT] = ACTIONS(6796),
    [anon_sym_AMP_GT_GT] = ACTIONS(6794),
    [anon_sym_LT_AMP] = ACTIONS(6794),
    [anon_sym_GT_AMP] = ACTIONS(6794),
    [anon_sym_LT_LT] = ACTIONS(6796),
    [anon_sym_LT_LT_DASH] = ACTIONS(6794),
    [anon_sym_LT_LT_LT] = ACTIONS(6794),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6794),
    [anon_sym_AMP] = ACTIONS(6796),
  },
  [2776] = {
    [anon_sym_fi] = ACTIONS(7420),
    [sym_comment] = ACTIONS(57),
  },
  [2777] = {
    [sym_file_descriptor] = ACTIONS(6884),
    [anon_sym_SEMI] = ACTIONS(6886),
    [anon_sym_PIPE] = ACTIONS(6886),
    [anon_sym_SEMI_SEMI] = ACTIONS(6884),
    [anon_sym_PIPE_AMP] = ACTIONS(6884),
    [anon_sym_AMP_AMP] = ACTIONS(6884),
    [anon_sym_PIPE_PIPE] = ACTIONS(6884),
    [anon_sym_LT] = ACTIONS(6886),
    [anon_sym_GT] = ACTIONS(6886),
    [anon_sym_GT_GT] = ACTIONS(6884),
    [anon_sym_AMP_GT] = ACTIONS(6886),
    [anon_sym_AMP_GT_GT] = ACTIONS(6884),
    [anon_sym_LT_AMP] = ACTIONS(6884),
    [anon_sym_GT_AMP] = ACTIONS(6884),
    [anon_sym_LT_LT] = ACTIONS(6886),
    [anon_sym_LT_LT_DASH] = ACTIONS(6884),
    [anon_sym_LT_LT_LT] = ACTIONS(6884),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6884),
    [anon_sym_AMP] = ACTIONS(6886),
  },
  [2778] = {
    [anon_sym_esac] = ACTIONS(7422),
    [sym_comment] = ACTIONS(57),
  },
  [2779] = {
    [sym_case_item] = STATE(2443),
    [sym_last_case_item] = STATE(3325),
    [sym_concatenation] = STATE(1710),
    [sym_string] = STATE(1708),
    [sym_simple_expansion] = STATE(1708),
    [sym_string_expansion] = STATE(1708),
    [sym_expansion] = STATE(1708),
    [sym_command_substitution] = STATE(1708),
    [sym_process_substitution] = STATE(1708),
    [aux_sym_case_statement_repeat1] = STATE(2443),
    [aux_sym__literal_repeat1] = STATE(1712),
    [anon_sym_DOLLAR] = ACTIONS(507),
    [sym__special_character] = ACTIONS(3518),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3520),
  },
  [2780] = {
    [sym_file_descriptor] = ACTIONS(6936),
    [anon_sym_SEMI] = ACTIONS(6938),
    [anon_sym_PIPE] = ACTIONS(6938),
    [anon_sym_SEMI_SEMI] = ACTIONS(6936),
    [anon_sym_PIPE_AMP] = ACTIONS(6936),
    [anon_sym_AMP_AMP] = ACTIONS(6936),
    [anon_sym_PIPE_PIPE] = ACTIONS(6936),
    [anon_sym_LT] = ACTIONS(6938),
    [anon_sym_GT] = ACTIONS(6938),
    [anon_sym_GT_GT] = ACTIONS(6936),
    [anon_sym_AMP_GT] = ACTIONS(6938),
    [anon_sym_AMP_GT_GT] = ACTIONS(6936),
    [anon_sym_LT_AMP] = ACTIONS(6936),
    [anon_sym_GT_AMP] = ACTIONS(6936),
    [anon_sym_LT_LT] = ACTIONS(6938),
    [anon_sym_LT_LT_DASH] = ACTIONS(6936),
    [anon_sym_LT_LT_LT] = ACTIONS(6936),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6936),
    [anon_sym_AMP] = ACTIONS(6938),
  },
  [2781] = {
    [anon_sym_esac] = ACTIONS(7424),
    [sym_comment] = ACTIONS(57),
  },
  [2782] = {
    [sym_case_item] = STATE(2443),
    [sym_last_case_item] = STATE(3327),
    [sym_concatenation] = STATE(1710),
    [sym_string] = STATE(1708),
    [sym_simple_expansion] = STATE(1708),
    [sym_string_expansion] = STATE(1708),
    [sym_expansion] = STATE(1708),
    [sym_command_substitution] = STATE(1708),
    [sym_process_substitution] = STATE(1708),
    [aux_sym_case_statement_repeat1] = STATE(2443),
    [aux_sym__literal_repeat1] = STATE(1712),
    [anon_sym_DOLLAR] = ACTIONS(507),
    [sym__special_character] = ACTIONS(3518),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3520),
  },
  [2783] = {
    [sym_file_descriptor] = ACTIONS(4449),
    [sym_variable_name] = ACTIONS(4449),
    [anon_sym_SEMI] = ACTIONS(4451),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_SEMI_SEMI] = ACTIONS(4449),
    [anon_sym_PIPE_AMP] = ACTIONS(4449),
    [anon_sym_AMP_AMP] = ACTIONS(4449),
    [anon_sym_PIPE_PIPE] = ACTIONS(4449),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_GT_GT] = ACTIONS(4449),
    [anon_sym_AMP_GT] = ACTIONS(4451),
    [anon_sym_AMP_GT_GT] = ACTIONS(4449),
    [anon_sym_LT_AMP] = ACTIONS(4449),
    [anon_sym_GT_AMP] = ACTIONS(4449),
    [anon_sym_LT_LT] = ACTIONS(4451),
    [anon_sym_LT_LT_DASH] = ACTIONS(4449),
    [anon_sym_LT_LT_LT] = ACTIONS(4449),
    [anon_sym_DOLLAR] = ACTIONS(4451),
    [sym__special_character] = ACTIONS(4449),
    [anon_sym_DQUOTE] = ACTIONS(4449),
    [sym_raw_string] = ACTIONS(4449),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4449),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4449),
    [anon_sym_BQUOTE] = ACTIONS(4449),
    [anon_sym_LT_LPAREN] = ACTIONS(4449),
    [anon_sym_GT_LPAREN] = ACTIONS(4449),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4451),
    [sym_word] = ACTIONS(4451),
    [anon_sym_LF] = ACTIONS(4449),
    [anon_sym_AMP] = ACTIONS(4451),
  },
  [2784] = {
    [sym_file_descriptor] = ACTIONS(5674),
    [sym__concat] = ACTIONS(5674),
    [sym_variable_name] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(5676),
    [anon_sym_PIPE] = ACTIONS(5676),
    [anon_sym_SEMI_SEMI] = ACTIONS(5674),
    [anon_sym_PIPE_AMP] = ACTIONS(5674),
    [anon_sym_AMP_AMP] = ACTIONS(5674),
    [anon_sym_PIPE_PIPE] = ACTIONS(5674),
    [anon_sym_LT] = ACTIONS(5676),
    [anon_sym_GT] = ACTIONS(5676),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_AMP_GT] = ACTIONS(5676),
    [anon_sym_AMP_GT_GT] = ACTIONS(5674),
    [anon_sym_LT_AMP] = ACTIONS(5674),
    [anon_sym_GT_AMP] = ACTIONS(5674),
    [anon_sym_LT_LT] = ACTIONS(5676),
    [anon_sym_LT_LT_DASH] = ACTIONS(5674),
    [anon_sym_LT_LT_LT] = ACTIONS(5674),
    [anon_sym_DOLLAR] = ACTIONS(5676),
    [sym__special_character] = ACTIONS(5674),
    [anon_sym_DQUOTE] = ACTIONS(5674),
    [sym_raw_string] = ACTIONS(5674),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5674),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5674),
    [anon_sym_BQUOTE] = ACTIONS(5674),
    [anon_sym_LT_LPAREN] = ACTIONS(5674),
    [anon_sym_GT_LPAREN] = ACTIONS(5674),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5676),
    [sym_word] = ACTIONS(5676),
    [anon_sym_LF] = ACTIONS(5674),
    [anon_sym_AMP] = ACTIONS(5676),
  },
  [2785] = {
    [sym_file_descriptor] = ACTIONS(5708),
    [sym__concat] = ACTIONS(5708),
    [sym_variable_name] = ACTIONS(5708),
    [anon_sym_SEMI] = ACTIONS(5710),
    [anon_sym_PIPE] = ACTIONS(5710),
    [anon_sym_SEMI_SEMI] = ACTIONS(5708),
    [anon_sym_PIPE_AMP] = ACTIONS(5708),
    [anon_sym_AMP_AMP] = ACTIONS(5708),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_LT] = ACTIONS(5710),
    [anon_sym_GT] = ACTIONS(5710),
    [anon_sym_GT_GT] = ACTIONS(5708),
    [anon_sym_AMP_GT] = ACTIONS(5710),
    [anon_sym_AMP_GT_GT] = ACTIONS(5708),
    [anon_sym_LT_AMP] = ACTIONS(5708),
    [anon_sym_GT_AMP] = ACTIONS(5708),
    [anon_sym_LT_LT] = ACTIONS(5710),
    [anon_sym_LT_LT_DASH] = ACTIONS(5708),
    [anon_sym_LT_LT_LT] = ACTIONS(5708),
    [anon_sym_DOLLAR] = ACTIONS(5710),
    [sym__special_character] = ACTIONS(5708),
    [anon_sym_DQUOTE] = ACTIONS(5708),
    [sym_raw_string] = ACTIONS(5708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5708),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5708),
    [anon_sym_BQUOTE] = ACTIONS(5708),
    [anon_sym_LT_LPAREN] = ACTIONS(5708),
    [anon_sym_GT_LPAREN] = ACTIONS(5708),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5710),
    [sym_word] = ACTIONS(5710),
    [anon_sym_LF] = ACTIONS(5708),
    [anon_sym_AMP] = ACTIONS(5710),
  },
  [2786] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(7426),
    [sym_comment] = ACTIONS(57),
  },
  [2787] = {
    [anon_sym_RBRACE] = ACTIONS(7426),
    [sym_comment] = ACTIONS(57),
  },
  [2788] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(7428),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [2789] = {
    [sym_concatenation] = STATE(3331),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3331),
    [anon_sym_RBRACE] = ACTIONS(7430),
    [anon_sym_EQ] = ACTIONS(7432),
    [anon_sym_DASH] = ACTIONS(7432),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7434),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7432),
    [anon_sym_COLON_QMARK] = ACTIONS(7432),
    [anon_sym_COLON_DASH] = ACTIONS(7432),
    [anon_sym_PERCENT] = ACTIONS(7432),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2790] = {
    [sym_file_descriptor] = ACTIONS(5725),
    [sym__concat] = ACTIONS(5725),
    [sym_variable_name] = ACTIONS(5725),
    [anon_sym_SEMI] = ACTIONS(5727),
    [anon_sym_PIPE] = ACTIONS(5727),
    [anon_sym_SEMI_SEMI] = ACTIONS(5725),
    [anon_sym_PIPE_AMP] = ACTIONS(5725),
    [anon_sym_AMP_AMP] = ACTIONS(5725),
    [anon_sym_PIPE_PIPE] = ACTIONS(5725),
    [anon_sym_LT] = ACTIONS(5727),
    [anon_sym_GT] = ACTIONS(5727),
    [anon_sym_GT_GT] = ACTIONS(5725),
    [anon_sym_AMP_GT] = ACTIONS(5727),
    [anon_sym_AMP_GT_GT] = ACTIONS(5725),
    [anon_sym_LT_AMP] = ACTIONS(5725),
    [anon_sym_GT_AMP] = ACTIONS(5725),
    [anon_sym_LT_LT] = ACTIONS(5727),
    [anon_sym_LT_LT_DASH] = ACTIONS(5725),
    [anon_sym_LT_LT_LT] = ACTIONS(5725),
    [anon_sym_DOLLAR] = ACTIONS(5727),
    [sym__special_character] = ACTIONS(5725),
    [anon_sym_DQUOTE] = ACTIONS(5725),
    [sym_raw_string] = ACTIONS(5725),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5725),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5725),
    [anon_sym_BQUOTE] = ACTIONS(5725),
    [anon_sym_LT_LPAREN] = ACTIONS(5725),
    [anon_sym_GT_LPAREN] = ACTIONS(5725),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5727),
    [sym_word] = ACTIONS(5727),
    [anon_sym_LF] = ACTIONS(5725),
    [anon_sym_AMP] = ACTIONS(5727),
  },
  [2791] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7430),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2792] = {
    [sym_concatenation] = STATE(3332),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3332),
    [anon_sym_RBRACE] = ACTIONS(7426),
    [anon_sym_EQ] = ACTIONS(7436),
    [anon_sym_DASH] = ACTIONS(7436),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7438),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7436),
    [anon_sym_COLON_QMARK] = ACTIONS(7436),
    [anon_sym_COLON_DASH] = ACTIONS(7436),
    [anon_sym_PERCENT] = ACTIONS(7436),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2793] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7426),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2794] = {
    [sym_file_descriptor] = ACTIONS(5770),
    [sym__concat] = ACTIONS(5770),
    [sym_variable_name] = ACTIONS(5770),
    [anon_sym_SEMI] = ACTIONS(5772),
    [anon_sym_PIPE] = ACTIONS(5772),
    [anon_sym_SEMI_SEMI] = ACTIONS(5770),
    [anon_sym_PIPE_AMP] = ACTIONS(5770),
    [anon_sym_AMP_AMP] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5770),
    [anon_sym_LT] = ACTIONS(5772),
    [anon_sym_GT] = ACTIONS(5772),
    [anon_sym_GT_GT] = ACTIONS(5770),
    [anon_sym_AMP_GT] = ACTIONS(5772),
    [anon_sym_AMP_GT_GT] = ACTIONS(5770),
    [anon_sym_LT_AMP] = ACTIONS(5770),
    [anon_sym_GT_AMP] = ACTIONS(5770),
    [anon_sym_LT_LT] = ACTIONS(5772),
    [anon_sym_LT_LT_DASH] = ACTIONS(5770),
    [anon_sym_LT_LT_LT] = ACTIONS(5770),
    [anon_sym_DOLLAR] = ACTIONS(5772),
    [sym__special_character] = ACTIONS(5770),
    [anon_sym_DQUOTE] = ACTIONS(5770),
    [sym_raw_string] = ACTIONS(5770),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5770),
    [anon_sym_BQUOTE] = ACTIONS(5770),
    [anon_sym_LT_LPAREN] = ACTIONS(5770),
    [anon_sym_GT_LPAREN] = ACTIONS(5770),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5772),
    [sym_word] = ACTIONS(5772),
    [anon_sym_LF] = ACTIONS(5770),
    [anon_sym_AMP] = ACTIONS(5772),
  },
  [2795] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7440),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2796] = {
    [sym_file_descriptor] = ACTIONS(5674),
    [sym__concat] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(5676),
    [anon_sym_PIPE] = ACTIONS(5676),
    [anon_sym_SEMI_SEMI] = ACTIONS(5674),
    [anon_sym_PIPE_AMP] = ACTIONS(5674),
    [anon_sym_AMP_AMP] = ACTIONS(5674),
    [anon_sym_PIPE_PIPE] = ACTIONS(5674),
    [anon_sym_LT] = ACTIONS(5676),
    [anon_sym_GT] = ACTIONS(5676),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_AMP_GT] = ACTIONS(5676),
    [anon_sym_AMP_GT_GT] = ACTIONS(5674),
    [anon_sym_LT_AMP] = ACTIONS(5674),
    [anon_sym_GT_AMP] = ACTIONS(5674),
    [anon_sym_LT_LT] = ACTIONS(5676),
    [anon_sym_LT_LT_DASH] = ACTIONS(5674),
    [anon_sym_LT_LT_LT] = ACTIONS(5674),
    [anon_sym_DOLLAR] = ACTIONS(5676),
    [sym__special_character] = ACTIONS(5674),
    [anon_sym_DQUOTE] = ACTIONS(5674),
    [sym_raw_string] = ACTIONS(5674),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5674),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5674),
    [anon_sym_BQUOTE] = ACTIONS(5674),
    [anon_sym_LT_LPAREN] = ACTIONS(5674),
    [anon_sym_GT_LPAREN] = ACTIONS(5674),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5676),
    [sym_word] = ACTIONS(5676),
    [anon_sym_LF] = ACTIONS(5674),
    [anon_sym_AMP] = ACTIONS(5676),
  },
  [2797] = {
    [sym_file_descriptor] = ACTIONS(5708),
    [sym__concat] = ACTIONS(5708),
    [anon_sym_SEMI] = ACTIONS(5710),
    [anon_sym_PIPE] = ACTIONS(5710),
    [anon_sym_SEMI_SEMI] = ACTIONS(5708),
    [anon_sym_PIPE_AMP] = ACTIONS(5708),
    [anon_sym_AMP_AMP] = ACTIONS(5708),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_LT] = ACTIONS(5710),
    [anon_sym_GT] = ACTIONS(5710),
    [anon_sym_GT_GT] = ACTIONS(5708),
    [anon_sym_AMP_GT] = ACTIONS(5710),
    [anon_sym_AMP_GT_GT] = ACTIONS(5708),
    [anon_sym_LT_AMP] = ACTIONS(5708),
    [anon_sym_GT_AMP] = ACTIONS(5708),
    [anon_sym_LT_LT] = ACTIONS(5710),
    [anon_sym_LT_LT_DASH] = ACTIONS(5708),
    [anon_sym_LT_LT_LT] = ACTIONS(5708),
    [anon_sym_DOLLAR] = ACTIONS(5710),
    [sym__special_character] = ACTIONS(5708),
    [anon_sym_DQUOTE] = ACTIONS(5708),
    [sym_raw_string] = ACTIONS(5708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5708),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5708),
    [anon_sym_BQUOTE] = ACTIONS(5708),
    [anon_sym_LT_LPAREN] = ACTIONS(5708),
    [anon_sym_GT_LPAREN] = ACTIONS(5708),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5710),
    [sym_word] = ACTIONS(5710),
    [anon_sym_LF] = ACTIONS(5708),
    [anon_sym_AMP] = ACTIONS(5710),
  },
  [2798] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(7442),
    [sym_comment] = ACTIONS(57),
  },
  [2799] = {
    [anon_sym_RBRACE] = ACTIONS(7442),
    [sym_comment] = ACTIONS(57),
  },
  [2800] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(7444),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [2801] = {
    [sym_concatenation] = STATE(3337),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3337),
    [anon_sym_RBRACE] = ACTIONS(7446),
    [anon_sym_EQ] = ACTIONS(7448),
    [anon_sym_DASH] = ACTIONS(7448),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7450),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7448),
    [anon_sym_COLON_QMARK] = ACTIONS(7448),
    [anon_sym_COLON_DASH] = ACTIONS(7448),
    [anon_sym_PERCENT] = ACTIONS(7448),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2802] = {
    [sym_file_descriptor] = ACTIONS(5725),
    [sym__concat] = ACTIONS(5725),
    [anon_sym_SEMI] = ACTIONS(5727),
    [anon_sym_PIPE] = ACTIONS(5727),
    [anon_sym_SEMI_SEMI] = ACTIONS(5725),
    [anon_sym_PIPE_AMP] = ACTIONS(5725),
    [anon_sym_AMP_AMP] = ACTIONS(5725),
    [anon_sym_PIPE_PIPE] = ACTIONS(5725),
    [anon_sym_LT] = ACTIONS(5727),
    [anon_sym_GT] = ACTIONS(5727),
    [anon_sym_GT_GT] = ACTIONS(5725),
    [anon_sym_AMP_GT] = ACTIONS(5727),
    [anon_sym_AMP_GT_GT] = ACTIONS(5725),
    [anon_sym_LT_AMP] = ACTIONS(5725),
    [anon_sym_GT_AMP] = ACTIONS(5725),
    [anon_sym_LT_LT] = ACTIONS(5727),
    [anon_sym_LT_LT_DASH] = ACTIONS(5725),
    [anon_sym_LT_LT_LT] = ACTIONS(5725),
    [anon_sym_DOLLAR] = ACTIONS(5727),
    [sym__special_character] = ACTIONS(5725),
    [anon_sym_DQUOTE] = ACTIONS(5725),
    [sym_raw_string] = ACTIONS(5725),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5725),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5725),
    [anon_sym_BQUOTE] = ACTIONS(5725),
    [anon_sym_LT_LPAREN] = ACTIONS(5725),
    [anon_sym_GT_LPAREN] = ACTIONS(5725),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5727),
    [sym_word] = ACTIONS(5727),
    [anon_sym_LF] = ACTIONS(5725),
    [anon_sym_AMP] = ACTIONS(5727),
  },
  [2803] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7446),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2804] = {
    [sym_concatenation] = STATE(3338),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3338),
    [anon_sym_RBRACE] = ACTIONS(7442),
    [anon_sym_EQ] = ACTIONS(7452),
    [anon_sym_DASH] = ACTIONS(7452),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7452),
    [anon_sym_COLON_QMARK] = ACTIONS(7452),
    [anon_sym_COLON_DASH] = ACTIONS(7452),
    [anon_sym_PERCENT] = ACTIONS(7452),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2805] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7442),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2806] = {
    [sym_file_descriptor] = ACTIONS(5770),
    [sym__concat] = ACTIONS(5770),
    [anon_sym_SEMI] = ACTIONS(5772),
    [anon_sym_PIPE] = ACTIONS(5772),
    [anon_sym_SEMI_SEMI] = ACTIONS(5770),
    [anon_sym_PIPE_AMP] = ACTIONS(5770),
    [anon_sym_AMP_AMP] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5770),
    [anon_sym_LT] = ACTIONS(5772),
    [anon_sym_GT] = ACTIONS(5772),
    [anon_sym_GT_GT] = ACTIONS(5770),
    [anon_sym_AMP_GT] = ACTIONS(5772),
    [anon_sym_AMP_GT_GT] = ACTIONS(5770),
    [anon_sym_LT_AMP] = ACTIONS(5770),
    [anon_sym_GT_AMP] = ACTIONS(5770),
    [anon_sym_LT_LT] = ACTIONS(5772),
    [anon_sym_LT_LT_DASH] = ACTIONS(5770),
    [anon_sym_LT_LT_LT] = ACTIONS(5770),
    [anon_sym_DOLLAR] = ACTIONS(5772),
    [sym__special_character] = ACTIONS(5770),
    [anon_sym_DQUOTE] = ACTIONS(5770),
    [sym_raw_string] = ACTIONS(5770),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5770),
    [anon_sym_BQUOTE] = ACTIONS(5770),
    [anon_sym_LT_LPAREN] = ACTIONS(5770),
    [anon_sym_GT_LPAREN] = ACTIONS(5770),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5772),
    [sym_word] = ACTIONS(5772),
    [anon_sym_LF] = ACTIONS(5770),
    [anon_sym_AMP] = ACTIONS(5772),
  },
  [2807] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7456),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2808] = {
    [sym_file_descriptor] = ACTIONS(7198),
    [sym__concat] = ACTIONS(7198),
    [anon_sym_SEMI] = ACTIONS(7200),
    [anon_sym_PIPE] = ACTIONS(7200),
    [anon_sym_SEMI_SEMI] = ACTIONS(7198),
    [anon_sym_PIPE_AMP] = ACTIONS(7198),
    [anon_sym_AMP_AMP] = ACTIONS(7198),
    [anon_sym_PIPE_PIPE] = ACTIONS(7198),
    [anon_sym_EQ_TILDE] = ACTIONS(7200),
    [anon_sym_EQ_EQ] = ACTIONS(7200),
    [anon_sym_LT] = ACTIONS(7200),
    [anon_sym_GT] = ACTIONS(7200),
    [anon_sym_GT_GT] = ACTIONS(7198),
    [anon_sym_AMP_GT] = ACTIONS(7200),
    [anon_sym_AMP_GT_GT] = ACTIONS(7198),
    [anon_sym_LT_AMP] = ACTIONS(7198),
    [anon_sym_GT_AMP] = ACTIONS(7198),
    [anon_sym_LT_LT] = ACTIONS(7200),
    [anon_sym_LT_LT_DASH] = ACTIONS(7198),
    [anon_sym_LT_LT_LT] = ACTIONS(7198),
    [anon_sym_DOLLAR] = ACTIONS(7200),
    [sym__special_character] = ACTIONS(7198),
    [anon_sym_DQUOTE] = ACTIONS(7198),
    [sym_raw_string] = ACTIONS(7198),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7198),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7198),
    [anon_sym_BQUOTE] = ACTIONS(7198),
    [anon_sym_LT_LPAREN] = ACTIONS(7198),
    [anon_sym_GT_LPAREN] = ACTIONS(7198),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7200),
    [anon_sym_LF] = ACTIONS(7198),
    [anon_sym_AMP] = ACTIONS(7200),
  },
  [2809] = {
    [sym_file_descriptor] = ACTIONS(7202),
    [sym__concat] = ACTIONS(7202),
    [anon_sym_SEMI] = ACTIONS(7204),
    [anon_sym_PIPE] = ACTIONS(7204),
    [anon_sym_SEMI_SEMI] = ACTIONS(7202),
    [anon_sym_PIPE_AMP] = ACTIONS(7202),
    [anon_sym_AMP_AMP] = ACTIONS(7202),
    [anon_sym_PIPE_PIPE] = ACTIONS(7202),
    [anon_sym_EQ_TILDE] = ACTIONS(7204),
    [anon_sym_EQ_EQ] = ACTIONS(7204),
    [anon_sym_LT] = ACTIONS(7204),
    [anon_sym_GT] = ACTIONS(7204),
    [anon_sym_GT_GT] = ACTIONS(7202),
    [anon_sym_AMP_GT] = ACTIONS(7204),
    [anon_sym_AMP_GT_GT] = ACTIONS(7202),
    [anon_sym_LT_AMP] = ACTIONS(7202),
    [anon_sym_GT_AMP] = ACTIONS(7202),
    [anon_sym_LT_LT] = ACTIONS(7204),
    [anon_sym_LT_LT_DASH] = ACTIONS(7202),
    [anon_sym_LT_LT_LT] = ACTIONS(7202),
    [anon_sym_DOLLAR] = ACTIONS(7204),
    [sym__special_character] = ACTIONS(7202),
    [anon_sym_DQUOTE] = ACTIONS(7202),
    [sym_raw_string] = ACTIONS(7202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7202),
    [anon_sym_BQUOTE] = ACTIONS(7202),
    [anon_sym_LT_LPAREN] = ACTIONS(7202),
    [anon_sym_GT_LPAREN] = ACTIONS(7202),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7204),
    [anon_sym_LF] = ACTIONS(7202),
    [anon_sym_AMP] = ACTIONS(7204),
  },
  [2810] = {
    [sym_file_descriptor] = ACTIONS(7206),
    [sym__concat] = ACTIONS(7206),
    [anon_sym_SEMI] = ACTIONS(7208),
    [anon_sym_PIPE] = ACTIONS(7208),
    [anon_sym_SEMI_SEMI] = ACTIONS(7206),
    [anon_sym_PIPE_AMP] = ACTIONS(7206),
    [anon_sym_AMP_AMP] = ACTIONS(7206),
    [anon_sym_PIPE_PIPE] = ACTIONS(7206),
    [anon_sym_EQ_TILDE] = ACTIONS(7208),
    [anon_sym_EQ_EQ] = ACTIONS(7208),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7206),
    [anon_sym_AMP_GT] = ACTIONS(7208),
    [anon_sym_AMP_GT_GT] = ACTIONS(7206),
    [anon_sym_LT_AMP] = ACTIONS(7206),
    [anon_sym_GT_AMP] = ACTIONS(7206),
    [anon_sym_LT_LT] = ACTIONS(7208),
    [anon_sym_LT_LT_DASH] = ACTIONS(7206),
    [anon_sym_LT_LT_LT] = ACTIONS(7206),
    [anon_sym_DOLLAR] = ACTIONS(7208),
    [sym__special_character] = ACTIONS(7206),
    [anon_sym_DQUOTE] = ACTIONS(7206),
    [sym_raw_string] = ACTIONS(7206),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7206),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7206),
    [anon_sym_BQUOTE] = ACTIONS(7206),
    [anon_sym_LT_LPAREN] = ACTIONS(7206),
    [anon_sym_GT_LPAREN] = ACTIONS(7206),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7208),
    [anon_sym_LF] = ACTIONS(7206),
    [anon_sym_AMP] = ACTIONS(7208),
  },
  [2811] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7458),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2812] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7460),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2813] = {
    [sym_file_descriptor] = ACTIONS(7242),
    [sym__concat] = ACTIONS(7242),
    [anon_sym_SEMI] = ACTIONS(7244),
    [anon_sym_PIPE] = ACTIONS(7244),
    [anon_sym_SEMI_SEMI] = ACTIONS(7242),
    [anon_sym_PIPE_AMP] = ACTIONS(7242),
    [anon_sym_AMP_AMP] = ACTIONS(7242),
    [anon_sym_PIPE_PIPE] = ACTIONS(7242),
    [anon_sym_EQ_TILDE] = ACTIONS(7244),
    [anon_sym_EQ_EQ] = ACTIONS(7244),
    [anon_sym_LT] = ACTIONS(7244),
    [anon_sym_GT] = ACTIONS(7244),
    [anon_sym_GT_GT] = ACTIONS(7242),
    [anon_sym_AMP_GT] = ACTIONS(7244),
    [anon_sym_AMP_GT_GT] = ACTIONS(7242),
    [anon_sym_LT_AMP] = ACTIONS(7242),
    [anon_sym_GT_AMP] = ACTIONS(7242),
    [anon_sym_LT_LT] = ACTIONS(7244),
    [anon_sym_LT_LT_DASH] = ACTIONS(7242),
    [anon_sym_LT_LT_LT] = ACTIONS(7242),
    [anon_sym_DOLLAR] = ACTIONS(7244),
    [sym__special_character] = ACTIONS(7242),
    [anon_sym_DQUOTE] = ACTIONS(7242),
    [sym_raw_string] = ACTIONS(7242),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7242),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7242),
    [anon_sym_BQUOTE] = ACTIONS(7242),
    [anon_sym_LT_LPAREN] = ACTIONS(7242),
    [anon_sym_GT_LPAREN] = ACTIONS(7242),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7244),
    [anon_sym_LF] = ACTIONS(7242),
    [anon_sym_AMP] = ACTIONS(7244),
  },
  [2814] = {
    [sym__simple_heredoc_body] = ACTIONS(2719),
    [sym__heredoc_body_beginning] = ACTIONS(2719),
    [sym_file_descriptor] = ACTIONS(2719),
    [sym_variable_name] = ACTIONS(2719),
    [anon_sym_SEMI] = ACTIONS(2721),
    [anon_sym_done] = ACTIONS(2721),
    [anon_sym_PIPE] = ACTIONS(2721),
    [anon_sym_SEMI_SEMI] = ACTIONS(2719),
    [anon_sym_PIPE_AMP] = ACTIONS(2719),
    [anon_sym_AMP_AMP] = ACTIONS(2719),
    [anon_sym_PIPE_PIPE] = ACTIONS(2719),
    [anon_sym_LT] = ACTIONS(2721),
    [anon_sym_GT] = ACTIONS(2721),
    [anon_sym_GT_GT] = ACTIONS(2719),
    [anon_sym_AMP_GT] = ACTIONS(2721),
    [anon_sym_AMP_GT_GT] = ACTIONS(2719),
    [anon_sym_LT_AMP] = ACTIONS(2719),
    [anon_sym_GT_AMP] = ACTIONS(2719),
    [anon_sym_LT_LT] = ACTIONS(2721),
    [anon_sym_LT_LT_DASH] = ACTIONS(2719),
    [anon_sym_LT_LT_LT] = ACTIONS(2719),
    [anon_sym_DOLLAR] = ACTIONS(2721),
    [sym__special_character] = ACTIONS(2719),
    [anon_sym_DQUOTE] = ACTIONS(2719),
    [sym_raw_string] = ACTIONS(2719),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2719),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2719),
    [anon_sym_BQUOTE] = ACTIONS(2719),
    [anon_sym_LT_LPAREN] = ACTIONS(2719),
    [anon_sym_GT_LPAREN] = ACTIONS(2719),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2721),
    [anon_sym_LF] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2721),
  },
  [2815] = {
    [sym_concatenation] = STATE(1368),
    [sym_string] = STATE(730),
    [sym_simple_expansion] = STATE(730),
    [sym_string_expansion] = STATE(730),
    [sym_expansion] = STATE(730),
    [sym_command_substitution] = STATE(730),
    [sym_process_substitution] = STATE(730),
    [aux_sym_for_statement_repeat1] = STATE(1368),
    [aux_sym__literal_repeat1] = STATE(736),
    [anon_sym_RPAREN] = ACTIONS(7462),
    [anon_sym_DOLLAR] = ACTIONS(1406),
    [sym__special_character] = ACTIONS(1408),
    [anon_sym_DQUOTE] = ACTIONS(1410),
    [sym_raw_string] = ACTIONS(1412),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1414),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1416),
    [anon_sym_BQUOTE] = ACTIONS(1418),
    [anon_sym_LT_LPAREN] = ACTIONS(1420),
    [anon_sym_GT_LPAREN] = ACTIONS(1420),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1412),
  },
  [2816] = {
    [sym__simple_heredoc_body] = ACTIONS(1057),
    [sym__heredoc_body_beginning] = ACTIONS(1057),
    [sym_file_descriptor] = ACTIONS(1057),
    [sym__concat] = ACTIONS(1057),
    [sym_variable_name] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_done] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_PIPE_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_AMP] = ACTIONS(1057),
    [anon_sym_GT_AMP] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_LT] = ACTIONS(1057),
    [anon_sym_DOLLAR] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [sym_raw_string] = ACTIONS(1057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1057),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1057),
    [anon_sym_BQUOTE] = ACTIONS(1057),
    [anon_sym_LT_LPAREN] = ACTIONS(1057),
    [anon_sym_GT_LPAREN] = ACTIONS(1057),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [2817] = {
    [sym__simple_heredoc_body] = ACTIONS(1061),
    [sym__heredoc_body_beginning] = ACTIONS(1061),
    [sym_file_descriptor] = ACTIONS(1061),
    [sym__concat] = ACTIONS(1061),
    [sym_variable_name] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(1063),
    [anon_sym_done] = ACTIONS(1063),
    [anon_sym_PIPE] = ACTIONS(1063),
    [anon_sym_SEMI_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE_AMP] = ACTIONS(1061),
    [anon_sym_AMP_AMP] = ACTIONS(1061),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1063),
    [anon_sym_GT_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT_GT] = ACTIONS(1061),
    [anon_sym_LT_AMP] = ACTIONS(1061),
    [anon_sym_GT_AMP] = ACTIONS(1061),
    [anon_sym_LT_LT] = ACTIONS(1063),
    [anon_sym_LT_LT_DASH] = ACTIONS(1061),
    [anon_sym_LT_LT_LT] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1061),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1061),
    [anon_sym_LT_LPAREN] = ACTIONS(1061),
    [anon_sym_GT_LPAREN] = ACTIONS(1061),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1063),
    [anon_sym_LF] = ACTIONS(1061),
    [anon_sym_AMP] = ACTIONS(1063),
  },
  [2818] = {
    [sym__simple_heredoc_body] = ACTIONS(1065),
    [sym__heredoc_body_beginning] = ACTIONS(1065),
    [sym_file_descriptor] = ACTIONS(1065),
    [sym__concat] = ACTIONS(1065),
    [sym_variable_name] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_done] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1067),
    [anon_sym_SEMI_SEMI] = ACTIONS(1065),
    [anon_sym_PIPE_AMP] = ACTIONS(1065),
    [anon_sym_AMP_AMP] = ACTIONS(1065),
    [anon_sym_PIPE_PIPE] = ACTIONS(1065),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_GT] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT] = ACTIONS(1067),
    [anon_sym_AMP_GT_GT] = ACTIONS(1065),
    [anon_sym_LT_AMP] = ACTIONS(1065),
    [anon_sym_GT_AMP] = ACTIONS(1065),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_LT_LT_DASH] = ACTIONS(1065),
    [anon_sym_LT_LT_LT] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1067),
    [sym__special_character] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LT_LPAREN] = ACTIONS(1065),
    [anon_sym_GT_LPAREN] = ACTIONS(1065),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1067),
    [anon_sym_LF] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1067),
  },
  [2819] = {
    [sym_string] = STATE(3343),
    [sym_simple_expansion] = STATE(3343),
    [sym_string_expansion] = STATE(3343),
    [sym_expansion] = STATE(3343),
    [sym_command_substitution] = STATE(3343),
    [sym_process_substitution] = STATE(3343),
    [anon_sym_DOLLAR] = ACTIONS(4876),
    [sym__special_character] = ACTIONS(7464),
    [anon_sym_DQUOTE] = ACTIONS(4880),
    [sym_raw_string] = ACTIONS(7464),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4884),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4886),
    [anon_sym_BQUOTE] = ACTIONS(4888),
    [anon_sym_LT_LPAREN] = ACTIONS(4890),
    [anon_sym_GT_LPAREN] = ACTIONS(4890),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7464),
  },
  [2820] = {
    [aux_sym_concatenation_repeat1] = STATE(3345),
    [sym__simple_heredoc_body] = ACTIONS(1071),
    [sym__heredoc_body_beginning] = ACTIONS(1071),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(7466),
    [sym_variable_name] = ACTIONS(1071),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_done] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [sym__special_character] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1075),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1075),
  },
  [2821] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(7468),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [2822] = {
    [sym__simple_heredoc_body] = ACTIONS(1089),
    [sym__heredoc_body_beginning] = ACTIONS(1089),
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(1089),
    [sym_variable_name] = ACTIONS(1089),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_done] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1089),
    [anon_sym_PIPE_AMP] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_AMP] = ACTIONS(1089),
    [anon_sym_GT_AMP] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1089),
    [anon_sym_LT_LT_LT] = ACTIONS(1089),
    [anon_sym_DOLLAR] = ACTIONS(1091),
    [sym__special_character] = ACTIONS(1089),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1089),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1089),
    [anon_sym_GT_LPAREN] = ACTIONS(1089),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [2823] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(627),
    [anon_sym_DOLLAR] = ACTIONS(7470),
    [anon_sym_DQUOTE] = ACTIONS(7468),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [2824] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(7472),
    [sym_comment] = ACTIONS(57),
  },
  [2825] = {
    [sym_subscript] = STATE(3351),
    [sym_variable_name] = ACTIONS(7474),
    [anon_sym_DASH] = ACTIONS(7476),
    [anon_sym_DOLLAR] = ACTIONS(7476),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7478),
    [anon_sym_STAR] = ACTIONS(7480),
    [anon_sym_AT] = ACTIONS(7480),
    [anon_sym_QMARK] = ACTIONS(7480),
    [anon_sym_0] = ACTIONS(7478),
    [anon_sym__] = ACTIONS(7478),
  },
  [2826] = {
    [sym_concatenation] = STATE(3354),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3354),
    [anon_sym_RBRACE] = ACTIONS(7482),
    [anon_sym_EQ] = ACTIONS(7484),
    [anon_sym_DASH] = ACTIONS(7484),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7486),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(7488),
    [anon_sym_COLON] = ACTIONS(7484),
    [anon_sym_COLON_QMARK] = ACTIONS(7484),
    [anon_sym_COLON_DASH] = ACTIONS(7484),
    [anon_sym_PERCENT] = ACTIONS(7484),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2827] = {
    [sym_concatenation] = STATE(3357),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3357),
    [anon_sym_RBRACE] = ACTIONS(7490),
    [anon_sym_EQ] = ACTIONS(7492),
    [anon_sym_DASH] = ACTIONS(7492),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7494),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(7496),
    [anon_sym_COLON] = ACTIONS(7492),
    [anon_sym_COLON_QMARK] = ACTIONS(7492),
    [anon_sym_COLON_DASH] = ACTIONS(7492),
    [anon_sym_PERCENT] = ACTIONS(7492),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2828] = {
    [anon_sym_RPAREN] = ACTIONS(7498),
    [sym_comment] = ACTIONS(57),
  },
  [2829] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(7498),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [2830] = {
    [anon_sym_BQUOTE] = ACTIONS(7498),
    [sym_comment] = ACTIONS(57),
  },
  [2831] = {
    [anon_sym_RPAREN] = ACTIONS(7500),
    [sym_comment] = ACTIONS(57),
  },
  [2832] = {
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym_variable_name] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_done] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [2833] = {
    [aux_sym__literal_repeat1] = STATE(2833),
    [sym__simple_heredoc_body] = ACTIONS(1373),
    [sym__heredoc_body_beginning] = ACTIONS(1373),
    [sym_file_descriptor] = ACTIONS(1373),
    [sym_variable_name] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_done] = ACTIONS(1375),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE_AMP] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_LT_LT_DASH] = ACTIONS(1373),
    [anon_sym_LT_LT_LT] = ACTIONS(1373),
    [anon_sym_DOLLAR] = ACTIONS(1375),
    [sym__special_character] = ACTIONS(7502),
    [anon_sym_DQUOTE] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1373),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [anon_sym_LT_LPAREN] = ACTIONS(1373),
    [anon_sym_GT_LPAREN] = ACTIONS(1373),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1375),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
  },
  [2834] = {
    [sym__simple_heredoc_body] = ACTIONS(1400),
    [sym__heredoc_body_beginning] = ACTIONS(1400),
    [sym_file_descriptor] = ACTIONS(1400),
    [sym_variable_name] = ACTIONS(1400),
    [anon_sym_SEMI] = ACTIONS(1402),
    [anon_sym_done] = ACTIONS(1402),
    [anon_sym_PIPE] = ACTIONS(1402),
    [anon_sym_SEMI_SEMI] = ACTIONS(1400),
    [anon_sym_PIPE_AMP] = ACTIONS(1400),
    [anon_sym_AMP_AMP] = ACTIONS(1400),
    [anon_sym_PIPE_PIPE] = ACTIONS(1400),
    [anon_sym_LT] = ACTIONS(1402),
    [anon_sym_GT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT] = ACTIONS(1402),
    [anon_sym_AMP_GT_GT] = ACTIONS(1400),
    [anon_sym_LT_AMP] = ACTIONS(1400),
    [anon_sym_GT_AMP] = ACTIONS(1400),
    [anon_sym_LT_LT] = ACTIONS(1402),
    [anon_sym_LT_LT_DASH] = ACTIONS(1400),
    [anon_sym_LT_LT_LT] = ACTIONS(1400),
    [anon_sym_DOLLAR] = ACTIONS(1402),
    [sym__special_character] = ACTIONS(1400),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1400),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1400),
    [anon_sym_BQUOTE] = ACTIONS(1400),
    [anon_sym_LT_LPAREN] = ACTIONS(1400),
    [anon_sym_GT_LPAREN] = ACTIONS(1400),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1402),
    [sym_word] = ACTIONS(1402),
    [anon_sym_LF] = ACTIONS(1400),
    [anon_sym_AMP] = ACTIONS(1402),
  },
  [2835] = {
    [sym_concatenation] = STATE(3361),
    [sym_string] = STATE(730),
    [sym_simple_expansion] = STATE(730),
    [sym_string_expansion] = STATE(730),
    [sym_expansion] = STATE(730),
    [sym_command_substitution] = STATE(730),
    [sym_process_substitution] = STATE(730),
    [aux_sym_for_statement_repeat1] = STATE(3361),
    [aux_sym__literal_repeat1] = STATE(736),
    [anon_sym_RPAREN] = ACTIONS(7505),
    [anon_sym_DOLLAR] = ACTIONS(1406),
    [sym__special_character] = ACTIONS(1408),
    [anon_sym_DQUOTE] = ACTIONS(1410),
    [sym_raw_string] = ACTIONS(1412),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1414),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1416),
    [anon_sym_BQUOTE] = ACTIONS(1418),
    [anon_sym_LT_LPAREN] = ACTIONS(1420),
    [anon_sym_GT_LPAREN] = ACTIONS(1420),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1412),
  },
  [2836] = {
    [aux_sym_concatenation_repeat1] = STATE(2214),
    [sym__simple_heredoc_body] = ACTIONS(1400),
    [sym__heredoc_body_beginning] = ACTIONS(1400),
    [sym_file_descriptor] = ACTIONS(1400),
    [sym__concat] = ACTIONS(4902),
    [sym_variable_name] = ACTIONS(1400),
    [anon_sym_SEMI] = ACTIONS(1402),
    [anon_sym_done] = ACTIONS(1402),
    [anon_sym_PIPE] = ACTIONS(1402),
    [anon_sym_SEMI_SEMI] = ACTIONS(1400),
    [anon_sym_PIPE_AMP] = ACTIONS(1400),
    [anon_sym_AMP_AMP] = ACTIONS(1400),
    [anon_sym_PIPE_PIPE] = ACTIONS(1400),
    [anon_sym_LT] = ACTIONS(1402),
    [anon_sym_GT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT] = ACTIONS(1402),
    [anon_sym_AMP_GT_GT] = ACTIONS(1400),
    [anon_sym_LT_AMP] = ACTIONS(1400),
    [anon_sym_GT_AMP] = ACTIONS(1400),
    [anon_sym_LT_LT] = ACTIONS(1402),
    [anon_sym_LT_LT_DASH] = ACTIONS(1400),
    [anon_sym_LT_LT_LT] = ACTIONS(1400),
    [anon_sym_DOLLAR] = ACTIONS(1402),
    [sym__special_character] = ACTIONS(1400),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1400),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1400),
    [anon_sym_BQUOTE] = ACTIONS(1400),
    [anon_sym_LT_LPAREN] = ACTIONS(1400),
    [anon_sym_GT_LPAREN] = ACTIONS(1400),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1402),
    [sym_word] = ACTIONS(1402),
    [anon_sym_LF] = ACTIONS(1400),
    [anon_sym_AMP] = ACTIONS(1402),
  },
  [2837] = {
    [aux_sym__literal_repeat1] = STATE(2228),
    [sym__simple_heredoc_body] = ACTIONS(1446),
    [sym__heredoc_body_beginning] = ACTIONS(1446),
    [sym_file_descriptor] = ACTIONS(1446),
    [sym_variable_name] = ACTIONS(1446),
    [anon_sym_SEMI] = ACTIONS(1448),
    [anon_sym_done] = ACTIONS(1448),
    [anon_sym_PIPE] = ACTIONS(1448),
    [anon_sym_SEMI_SEMI] = ACTIONS(1446),
    [anon_sym_PIPE_AMP] = ACTIONS(1446),
    [anon_sym_AMP_AMP] = ACTIONS(1446),
    [anon_sym_PIPE_PIPE] = ACTIONS(1446),
    [anon_sym_LT] = ACTIONS(1448),
    [anon_sym_GT] = ACTIONS(1448),
    [anon_sym_GT_GT] = ACTIONS(1446),
    [anon_sym_AMP_GT] = ACTIONS(1448),
    [anon_sym_AMP_GT_GT] = ACTIONS(1446),
    [anon_sym_LT_AMP] = ACTIONS(1446),
    [anon_sym_GT_AMP] = ACTIONS(1446),
    [anon_sym_LT_LT] = ACTIONS(1448),
    [anon_sym_LT_LT_DASH] = ACTIONS(1446),
    [anon_sym_LT_LT_LT] = ACTIONS(1446),
    [anon_sym_DOLLAR] = ACTIONS(1448),
    [sym__special_character] = ACTIONS(4920),
    [anon_sym_DQUOTE] = ACTIONS(1446),
    [sym_raw_string] = ACTIONS(1446),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1446),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1446),
    [anon_sym_BQUOTE] = ACTIONS(1446),
    [anon_sym_LT_LPAREN] = ACTIONS(1446),
    [anon_sym_GT_LPAREN] = ACTIONS(1446),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1448),
    [sym_word] = ACTIONS(1448),
    [anon_sym_LF] = ACTIONS(1446),
    [anon_sym_AMP] = ACTIONS(1448),
  },
  [2838] = {
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(2362),
    [sym_variable_name] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_done] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2364),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [2839] = {
    [sym_string] = STATE(2838),
    [sym_simple_expansion] = STATE(2838),
    [sym_string_expansion] = STATE(2838),
    [sym_expansion] = STATE(2838),
    [sym_command_substitution] = STATE(2838),
    [sym_process_substitution] = STATE(2838),
    [anon_sym_DOLLAR] = ACTIONS(7507),
    [sym__special_character] = ACTIONS(6175),
    [anon_sym_DQUOTE] = ACTIONS(3233),
    [sym_raw_string] = ACTIONS(6175),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3239),
    [anon_sym_BQUOTE] = ACTIONS(3241),
    [anon_sym_LT_LPAREN] = ACTIONS(3243),
    [anon_sym_GT_LPAREN] = ACTIONS(3243),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6175),
  },
  [2840] = {
    [aux_sym_concatenation_repeat1] = STATE(2840),
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(7509),
    [sym_variable_name] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_done] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2364),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [2841] = {
    [sym__simple_heredoc_body] = ACTIONS(2371),
    [sym__heredoc_body_beginning] = ACTIONS(2371),
    [sym_file_descriptor] = ACTIONS(2371),
    [sym__concat] = ACTIONS(2371),
    [sym_variable_name] = ACTIONS(2371),
    [anon_sym_SEMI] = ACTIONS(2373),
    [anon_sym_done] = ACTIONS(2373),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_SEMI_SEMI] = ACTIONS(2371),
    [anon_sym_PIPE_AMP] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_GT_GT] = ACTIONS(2371),
    [anon_sym_AMP_GT] = ACTIONS(2373),
    [anon_sym_AMP_GT_GT] = ACTIONS(2371),
    [anon_sym_LT_AMP] = ACTIONS(2371),
    [anon_sym_GT_AMP] = ACTIONS(2371),
    [anon_sym_LT_LT] = ACTIONS(2373),
    [anon_sym_LT_LT_DASH] = ACTIONS(2371),
    [anon_sym_LT_LT_LT] = ACTIONS(2371),
    [anon_sym_DOLLAR] = ACTIONS(2373),
    [sym__special_character] = ACTIONS(2371),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [sym_raw_string] = ACTIONS(2371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2371),
    [anon_sym_BQUOTE] = ACTIONS(2371),
    [anon_sym_LT_LPAREN] = ACTIONS(2371),
    [anon_sym_GT_LPAREN] = ACTIONS(2371),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2373),
    [sym_word] = ACTIONS(2373),
    [anon_sym_LF] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
  },
  [2842] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(7512),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [2843] = {
    [sym_concatenation] = STATE(3366),
    [sym_string] = STATE(3365),
    [sym_simple_expansion] = STATE(3365),
    [sym_string_expansion] = STATE(3365),
    [sym_expansion] = STATE(3365),
    [sym_command_substitution] = STATE(3365),
    [sym_process_substitution] = STATE(3365),
    [aux_sym__literal_repeat1] = STATE(3367),
    [anon_sym_RBRACE] = ACTIONS(7514),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(7516),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7516),
  },
  [2844] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(7518),
    [sym_comment] = ACTIONS(57),
  },
  [2845] = {
    [sym_concatenation] = STATE(3371),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3371),
    [anon_sym_RBRACE] = ACTIONS(7520),
    [anon_sym_EQ] = ACTIONS(7522),
    [anon_sym_DASH] = ACTIONS(7522),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7524),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(7526),
    [anon_sym_COLON] = ACTIONS(7522),
    [anon_sym_COLON_QMARK] = ACTIONS(7522),
    [anon_sym_COLON_DASH] = ACTIONS(7522),
    [anon_sym_PERCENT] = ACTIONS(7522),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2846] = {
    [sym_concatenation] = STATE(3373),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3373),
    [anon_sym_RBRACE] = ACTIONS(7514),
    [anon_sym_EQ] = ACTIONS(7528),
    [anon_sym_DASH] = ACTIONS(7528),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7530),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(7532),
    [anon_sym_COLON] = ACTIONS(7528),
    [anon_sym_COLON_QMARK] = ACTIONS(7528),
    [anon_sym_COLON_DASH] = ACTIONS(7528),
    [anon_sym_PERCENT] = ACTIONS(7528),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2847] = {
    [sym__simple_heredoc_body] = ACTIONS(2462),
    [sym__heredoc_body_beginning] = ACTIONS(2462),
    [sym_file_descriptor] = ACTIONS(2462),
    [sym__concat] = ACTIONS(2462),
    [sym_variable_name] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_done] = ACTIONS(2464),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_SEMI_SEMI] = ACTIONS(2462),
    [anon_sym_PIPE_AMP] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_GT_GT] = ACTIONS(2462),
    [anon_sym_AMP_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT_GT] = ACTIONS(2462),
    [anon_sym_LT_AMP] = ACTIONS(2462),
    [anon_sym_GT_AMP] = ACTIONS(2462),
    [anon_sym_LT_LT] = ACTIONS(2464),
    [anon_sym_LT_LT_DASH] = ACTIONS(2462),
    [anon_sym_LT_LT_LT] = ACTIONS(2462),
    [anon_sym_DOLLAR] = ACTIONS(2464),
    [sym__special_character] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [sym_raw_string] = ACTIONS(2462),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2462),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2462),
    [anon_sym_BQUOTE] = ACTIONS(2462),
    [anon_sym_LT_LPAREN] = ACTIONS(2462),
    [anon_sym_GT_LPAREN] = ACTIONS(2462),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2464),
    [sym_word] = ACTIONS(2464),
    [anon_sym_LF] = ACTIONS(2462),
    [anon_sym_AMP] = ACTIONS(2464),
  },
  [2848] = {
    [sym_concatenation] = STATE(3376),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3376),
    [sym_regex] = ACTIONS(7534),
    [anon_sym_RBRACE] = ACTIONS(7536),
    [anon_sym_EQ] = ACTIONS(7538),
    [anon_sym_DASH] = ACTIONS(7538),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7540),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7538),
    [anon_sym_COLON_QMARK] = ACTIONS(7538),
    [anon_sym_COLON_DASH] = ACTIONS(7538),
    [anon_sym_PERCENT] = ACTIONS(7538),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2849] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7536),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2850] = {
    [sym__simple_heredoc_body] = ACTIONS(2512),
    [sym__heredoc_body_beginning] = ACTIONS(2512),
    [sym_file_descriptor] = ACTIONS(2512),
    [sym__concat] = ACTIONS(2512),
    [sym_variable_name] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2514),
    [anon_sym_done] = ACTIONS(2514),
    [anon_sym_PIPE] = ACTIONS(2514),
    [anon_sym_SEMI_SEMI] = ACTIONS(2512),
    [anon_sym_PIPE_AMP] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE_PIPE] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2514),
    [anon_sym_GT] = ACTIONS(2514),
    [anon_sym_GT_GT] = ACTIONS(2512),
    [anon_sym_AMP_GT] = ACTIONS(2514),
    [anon_sym_AMP_GT_GT] = ACTIONS(2512),
    [anon_sym_LT_AMP] = ACTIONS(2512),
    [anon_sym_GT_AMP] = ACTIONS(2512),
    [anon_sym_LT_LT] = ACTIONS(2514),
    [anon_sym_LT_LT_DASH] = ACTIONS(2512),
    [anon_sym_LT_LT_LT] = ACTIONS(2512),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [sym__special_character] = ACTIONS(2512),
    [anon_sym_DQUOTE] = ACTIONS(2512),
    [sym_raw_string] = ACTIONS(2512),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2512),
    [anon_sym_BQUOTE] = ACTIONS(2512),
    [anon_sym_LT_LPAREN] = ACTIONS(2512),
    [anon_sym_GT_LPAREN] = ACTIONS(2512),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2514),
    [sym_word] = ACTIONS(2514),
    [anon_sym_LF] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2514),
  },
  [2851] = {
    [sym_concatenation] = STATE(3373),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3373),
    [sym_regex] = ACTIONS(7542),
    [anon_sym_RBRACE] = ACTIONS(7514),
    [anon_sym_EQ] = ACTIONS(7528),
    [anon_sym_DASH] = ACTIONS(7528),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7530),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7528),
    [anon_sym_COLON_QMARK] = ACTIONS(7528),
    [anon_sym_COLON_DASH] = ACTIONS(7528),
    [anon_sym_PERCENT] = ACTIONS(7528),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2852] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7514),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2853] = {
    [sym__simple_heredoc_body] = ACTIONS(2520),
    [sym__heredoc_body_beginning] = ACTIONS(2520),
    [sym_file_descriptor] = ACTIONS(2520),
    [sym__concat] = ACTIONS(2520),
    [sym_variable_name] = ACTIONS(2520),
    [anon_sym_SEMI] = ACTIONS(2522),
    [anon_sym_done] = ACTIONS(2522),
    [anon_sym_PIPE] = ACTIONS(2522),
    [anon_sym_SEMI_SEMI] = ACTIONS(2520),
    [anon_sym_PIPE_AMP] = ACTIONS(2520),
    [anon_sym_AMP_AMP] = ACTIONS(2520),
    [anon_sym_PIPE_PIPE] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(2522),
    [anon_sym_GT] = ACTIONS(2522),
    [anon_sym_GT_GT] = ACTIONS(2520),
    [anon_sym_AMP_GT] = ACTIONS(2522),
    [anon_sym_AMP_GT_GT] = ACTIONS(2520),
    [anon_sym_LT_AMP] = ACTIONS(2520),
    [anon_sym_GT_AMP] = ACTIONS(2520),
    [anon_sym_LT_LT] = ACTIONS(2522),
    [anon_sym_LT_LT_DASH] = ACTIONS(2520),
    [anon_sym_LT_LT_LT] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(2522),
    [sym__special_character] = ACTIONS(2520),
    [anon_sym_DQUOTE] = ACTIONS(2520),
    [sym_raw_string] = ACTIONS(2520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2520),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2520),
    [anon_sym_BQUOTE] = ACTIONS(2520),
    [anon_sym_LT_LPAREN] = ACTIONS(2520),
    [anon_sym_GT_LPAREN] = ACTIONS(2520),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2522),
    [sym_word] = ACTIONS(2522),
    [anon_sym_LF] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2522),
  },
  [2854] = {
    [sym__simple_heredoc_body] = ACTIONS(2554),
    [sym__heredoc_body_beginning] = ACTIONS(2554),
    [sym_file_descriptor] = ACTIONS(2554),
    [sym__concat] = ACTIONS(2554),
    [sym_variable_name] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(2556),
    [anon_sym_done] = ACTIONS(2556),
    [anon_sym_PIPE] = ACTIONS(2556),
    [anon_sym_SEMI_SEMI] = ACTIONS(2554),
    [anon_sym_PIPE_AMP] = ACTIONS(2554),
    [anon_sym_AMP_AMP] = ACTIONS(2554),
    [anon_sym_PIPE_PIPE] = ACTIONS(2554),
    [anon_sym_LT] = ACTIONS(2556),
    [anon_sym_GT] = ACTIONS(2556),
    [anon_sym_GT_GT] = ACTIONS(2554),
    [anon_sym_AMP_GT] = ACTIONS(2556),
    [anon_sym_AMP_GT_GT] = ACTIONS(2554),
    [anon_sym_LT_AMP] = ACTIONS(2554),
    [anon_sym_GT_AMP] = ACTIONS(2554),
    [anon_sym_LT_LT] = ACTIONS(2556),
    [anon_sym_LT_LT_DASH] = ACTIONS(2554),
    [anon_sym_LT_LT_LT] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2556),
    [sym__special_character] = ACTIONS(2554),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2554),
    [anon_sym_BQUOTE] = ACTIONS(2554),
    [anon_sym_LT_LPAREN] = ACTIONS(2554),
    [anon_sym_GT_LPAREN] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2556),
    [sym_word] = ACTIONS(2556),
    [anon_sym_LF] = ACTIONS(2554),
    [anon_sym_AMP] = ACTIONS(2556),
  },
  [2855] = {
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_done] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2364),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [2856] = {
    [sym_string] = STATE(2855),
    [sym_simple_expansion] = STATE(2855),
    [sym_string_expansion] = STATE(2855),
    [sym_expansion] = STATE(2855),
    [sym_command_substitution] = STATE(2855),
    [sym_process_substitution] = STATE(2855),
    [anon_sym_DOLLAR] = ACTIONS(7544),
    [sym__special_character] = ACTIONS(6249),
    [anon_sym_DQUOTE] = ACTIONS(3253),
    [sym_raw_string] = ACTIONS(6249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3257),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3259),
    [anon_sym_BQUOTE] = ACTIONS(3261),
    [anon_sym_LT_LPAREN] = ACTIONS(3263),
    [anon_sym_GT_LPAREN] = ACTIONS(3263),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6249),
  },
  [2857] = {
    [aux_sym_concatenation_repeat1] = STATE(2857),
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(7546),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_done] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2364),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [2858] = {
    [sym__simple_heredoc_body] = ACTIONS(2371),
    [sym__heredoc_body_beginning] = ACTIONS(2371),
    [sym_file_descriptor] = ACTIONS(2371),
    [sym__concat] = ACTIONS(2371),
    [anon_sym_SEMI] = ACTIONS(2373),
    [anon_sym_done] = ACTIONS(2373),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_SEMI_SEMI] = ACTIONS(2371),
    [anon_sym_PIPE_AMP] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_GT_GT] = ACTIONS(2371),
    [anon_sym_AMP_GT] = ACTIONS(2373),
    [anon_sym_AMP_GT_GT] = ACTIONS(2371),
    [anon_sym_LT_AMP] = ACTIONS(2371),
    [anon_sym_GT_AMP] = ACTIONS(2371),
    [anon_sym_LT_LT] = ACTIONS(2373),
    [anon_sym_LT_LT_DASH] = ACTIONS(2371),
    [anon_sym_LT_LT_LT] = ACTIONS(2371),
    [anon_sym_DOLLAR] = ACTIONS(2373),
    [sym__special_character] = ACTIONS(2371),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [sym_raw_string] = ACTIONS(2371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2371),
    [anon_sym_BQUOTE] = ACTIONS(2371),
    [anon_sym_LT_LPAREN] = ACTIONS(2371),
    [anon_sym_GT_LPAREN] = ACTIONS(2371),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2373),
    [sym_word] = ACTIONS(2373),
    [anon_sym_LF] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
  },
  [2859] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(7549),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [2860] = {
    [sym_concatenation] = STATE(3382),
    [sym_string] = STATE(3381),
    [sym_simple_expansion] = STATE(3381),
    [sym_string_expansion] = STATE(3381),
    [sym_expansion] = STATE(3381),
    [sym_command_substitution] = STATE(3381),
    [sym_process_substitution] = STATE(3381),
    [aux_sym__literal_repeat1] = STATE(3383),
    [anon_sym_RBRACE] = ACTIONS(7551),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(7553),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7553),
  },
  [2861] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(7555),
    [sym_comment] = ACTIONS(57),
  },
  [2862] = {
    [sym_concatenation] = STATE(3387),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3387),
    [anon_sym_RBRACE] = ACTIONS(7557),
    [anon_sym_EQ] = ACTIONS(7559),
    [anon_sym_DASH] = ACTIONS(7559),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7561),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(7563),
    [anon_sym_COLON] = ACTIONS(7559),
    [anon_sym_COLON_QMARK] = ACTIONS(7559),
    [anon_sym_COLON_DASH] = ACTIONS(7559),
    [anon_sym_PERCENT] = ACTIONS(7559),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2863] = {
    [sym_concatenation] = STATE(3389),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3389),
    [anon_sym_RBRACE] = ACTIONS(7551),
    [anon_sym_EQ] = ACTIONS(7565),
    [anon_sym_DASH] = ACTIONS(7565),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7567),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(7569),
    [anon_sym_COLON] = ACTIONS(7565),
    [anon_sym_COLON_QMARK] = ACTIONS(7565),
    [anon_sym_COLON_DASH] = ACTIONS(7565),
    [anon_sym_PERCENT] = ACTIONS(7565),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2864] = {
    [sym__simple_heredoc_body] = ACTIONS(2462),
    [sym__heredoc_body_beginning] = ACTIONS(2462),
    [sym_file_descriptor] = ACTIONS(2462),
    [sym__concat] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_done] = ACTIONS(2464),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_SEMI_SEMI] = ACTIONS(2462),
    [anon_sym_PIPE_AMP] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_GT_GT] = ACTIONS(2462),
    [anon_sym_AMP_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT_GT] = ACTIONS(2462),
    [anon_sym_LT_AMP] = ACTIONS(2462),
    [anon_sym_GT_AMP] = ACTIONS(2462),
    [anon_sym_LT_LT] = ACTIONS(2464),
    [anon_sym_LT_LT_DASH] = ACTIONS(2462),
    [anon_sym_LT_LT_LT] = ACTIONS(2462),
    [anon_sym_DOLLAR] = ACTIONS(2464),
    [sym__special_character] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [sym_raw_string] = ACTIONS(2462),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2462),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2462),
    [anon_sym_BQUOTE] = ACTIONS(2462),
    [anon_sym_LT_LPAREN] = ACTIONS(2462),
    [anon_sym_GT_LPAREN] = ACTIONS(2462),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2464),
    [sym_word] = ACTIONS(2464),
    [anon_sym_LF] = ACTIONS(2462),
    [anon_sym_AMP] = ACTIONS(2464),
  },
  [2865] = {
    [sym_concatenation] = STATE(3392),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3392),
    [sym_regex] = ACTIONS(7571),
    [anon_sym_RBRACE] = ACTIONS(7573),
    [anon_sym_EQ] = ACTIONS(7575),
    [anon_sym_DASH] = ACTIONS(7575),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7577),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7575),
    [anon_sym_COLON_QMARK] = ACTIONS(7575),
    [anon_sym_COLON_DASH] = ACTIONS(7575),
    [anon_sym_PERCENT] = ACTIONS(7575),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2866] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7573),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2867] = {
    [sym__simple_heredoc_body] = ACTIONS(2512),
    [sym__heredoc_body_beginning] = ACTIONS(2512),
    [sym_file_descriptor] = ACTIONS(2512),
    [sym__concat] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2514),
    [anon_sym_done] = ACTIONS(2514),
    [anon_sym_PIPE] = ACTIONS(2514),
    [anon_sym_SEMI_SEMI] = ACTIONS(2512),
    [anon_sym_PIPE_AMP] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE_PIPE] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2514),
    [anon_sym_GT] = ACTIONS(2514),
    [anon_sym_GT_GT] = ACTIONS(2512),
    [anon_sym_AMP_GT] = ACTIONS(2514),
    [anon_sym_AMP_GT_GT] = ACTIONS(2512),
    [anon_sym_LT_AMP] = ACTIONS(2512),
    [anon_sym_GT_AMP] = ACTIONS(2512),
    [anon_sym_LT_LT] = ACTIONS(2514),
    [anon_sym_LT_LT_DASH] = ACTIONS(2512),
    [anon_sym_LT_LT_LT] = ACTIONS(2512),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [sym__special_character] = ACTIONS(2512),
    [anon_sym_DQUOTE] = ACTIONS(2512),
    [sym_raw_string] = ACTIONS(2512),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2512),
    [anon_sym_BQUOTE] = ACTIONS(2512),
    [anon_sym_LT_LPAREN] = ACTIONS(2512),
    [anon_sym_GT_LPAREN] = ACTIONS(2512),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2514),
    [sym_word] = ACTIONS(2514),
    [anon_sym_LF] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2514),
  },
  [2868] = {
    [sym_concatenation] = STATE(3389),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3389),
    [sym_regex] = ACTIONS(7579),
    [anon_sym_RBRACE] = ACTIONS(7551),
    [anon_sym_EQ] = ACTIONS(7565),
    [anon_sym_DASH] = ACTIONS(7565),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7567),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7565),
    [anon_sym_COLON_QMARK] = ACTIONS(7565),
    [anon_sym_COLON_DASH] = ACTIONS(7565),
    [anon_sym_PERCENT] = ACTIONS(7565),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2869] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7551),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2870] = {
    [sym__simple_heredoc_body] = ACTIONS(2520),
    [sym__heredoc_body_beginning] = ACTIONS(2520),
    [sym_file_descriptor] = ACTIONS(2520),
    [sym__concat] = ACTIONS(2520),
    [anon_sym_SEMI] = ACTIONS(2522),
    [anon_sym_done] = ACTIONS(2522),
    [anon_sym_PIPE] = ACTIONS(2522),
    [anon_sym_SEMI_SEMI] = ACTIONS(2520),
    [anon_sym_PIPE_AMP] = ACTIONS(2520),
    [anon_sym_AMP_AMP] = ACTIONS(2520),
    [anon_sym_PIPE_PIPE] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(2522),
    [anon_sym_GT] = ACTIONS(2522),
    [anon_sym_GT_GT] = ACTIONS(2520),
    [anon_sym_AMP_GT] = ACTIONS(2522),
    [anon_sym_AMP_GT_GT] = ACTIONS(2520),
    [anon_sym_LT_AMP] = ACTIONS(2520),
    [anon_sym_GT_AMP] = ACTIONS(2520),
    [anon_sym_LT_LT] = ACTIONS(2522),
    [anon_sym_LT_LT_DASH] = ACTIONS(2520),
    [anon_sym_LT_LT_LT] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(2522),
    [sym__special_character] = ACTIONS(2520),
    [anon_sym_DQUOTE] = ACTIONS(2520),
    [sym_raw_string] = ACTIONS(2520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2520),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2520),
    [anon_sym_BQUOTE] = ACTIONS(2520),
    [anon_sym_LT_LPAREN] = ACTIONS(2520),
    [anon_sym_GT_LPAREN] = ACTIONS(2520),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2522),
    [sym_word] = ACTIONS(2522),
    [anon_sym_LF] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2522),
  },
  [2871] = {
    [sym__simple_heredoc_body] = ACTIONS(2554),
    [sym__heredoc_body_beginning] = ACTIONS(2554),
    [sym_file_descriptor] = ACTIONS(2554),
    [sym__concat] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(2556),
    [anon_sym_done] = ACTIONS(2556),
    [anon_sym_PIPE] = ACTIONS(2556),
    [anon_sym_SEMI_SEMI] = ACTIONS(2554),
    [anon_sym_PIPE_AMP] = ACTIONS(2554),
    [anon_sym_AMP_AMP] = ACTIONS(2554),
    [anon_sym_PIPE_PIPE] = ACTIONS(2554),
    [anon_sym_LT] = ACTIONS(2556),
    [anon_sym_GT] = ACTIONS(2556),
    [anon_sym_GT_GT] = ACTIONS(2554),
    [anon_sym_AMP_GT] = ACTIONS(2556),
    [anon_sym_AMP_GT_GT] = ACTIONS(2554),
    [anon_sym_LT_AMP] = ACTIONS(2554),
    [anon_sym_GT_AMP] = ACTIONS(2554),
    [anon_sym_LT_LT] = ACTIONS(2556),
    [anon_sym_LT_LT_DASH] = ACTIONS(2554),
    [anon_sym_LT_LT_LT] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2556),
    [sym__special_character] = ACTIONS(2554),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2554),
    [anon_sym_BQUOTE] = ACTIONS(2554),
    [anon_sym_LT_LPAREN] = ACTIONS(2554),
    [anon_sym_GT_LPAREN] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2556),
    [sym_word] = ACTIONS(2556),
    [anon_sym_LF] = ACTIONS(2554),
    [anon_sym_AMP] = ACTIONS(2556),
  },
  [2872] = {
    [sym_string] = STATE(1583),
    [sym__simple_heredoc_body] = ACTIONS(4071),
    [sym__heredoc_body_beginning] = ACTIONS(4071),
    [sym_file_descriptor] = ACTIONS(4071),
    [anon_sym_SEMI] = ACTIONS(4073),
    [anon_sym_done] = ACTIONS(4073),
    [anon_sym_PIPE] = ACTIONS(4073),
    [anon_sym_SEMI_SEMI] = ACTIONS(4071),
    [anon_sym_PIPE_AMP] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_PIPE_PIPE] = ACTIONS(4071),
    [anon_sym_EQ_TILDE] = ACTIONS(4073),
    [anon_sym_EQ_EQ] = ACTIONS(4073),
    [anon_sym_LT] = ACTIONS(4073),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_GT_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT] = ACTIONS(4073),
    [anon_sym_AMP_GT_GT] = ACTIONS(4071),
    [anon_sym_LT_AMP] = ACTIONS(4071),
    [anon_sym_GT_AMP] = ACTIONS(4071),
    [anon_sym_LT_LT] = ACTIONS(4073),
    [anon_sym_LT_LT_DASH] = ACTIONS(4071),
    [anon_sym_LT_LT_LT] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(7581),
    [anon_sym_DOLLAR] = ACTIONS(7581),
    [sym__special_character] = ACTIONS(4071),
    [anon_sym_DQUOTE] = ACTIONS(1765),
    [sym_raw_string] = ACTIONS(3271),
    [anon_sym_POUND] = ACTIONS(3269),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4071),
    [anon_sym_BQUOTE] = ACTIONS(4071),
    [anon_sym_LT_LPAREN] = ACTIONS(4071),
    [anon_sym_GT_LPAREN] = ACTIONS(4071),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3273),
    [anon_sym_STAR] = ACTIONS(3273),
    [anon_sym_AT] = ACTIONS(3273),
    [anon_sym_QMARK] = ACTIONS(3273),
    [anon_sym_0] = ACTIONS(3273),
    [anon_sym__] = ACTIONS(3273),
    [sym_word] = ACTIONS(4073),
    [anon_sym_LF] = ACTIONS(4071),
    [anon_sym_AMP] = ACTIONS(4073),
  },
  [2873] = {
    [sym__simple_heredoc_body] = ACTIONS(4111),
    [sym__heredoc_body_beginning] = ACTIONS(4111),
    [sym_file_descriptor] = ACTIONS(4111),
    [sym__concat] = ACTIONS(4111),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_done] = ACTIONS(4113),
    [anon_sym_PIPE] = ACTIONS(4113),
    [anon_sym_SEMI_SEMI] = ACTIONS(4111),
    [anon_sym_PIPE_AMP] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_EQ_TILDE] = ACTIONS(4113),
    [anon_sym_EQ_EQ] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4113),
    [anon_sym_GT_GT] = ACTIONS(4111),
    [anon_sym_AMP_GT] = ACTIONS(4113),
    [anon_sym_AMP_GT_GT] = ACTIONS(4111),
    [anon_sym_LT_AMP] = ACTIONS(4111),
    [anon_sym_GT_AMP] = ACTIONS(4111),
    [anon_sym_LT_LT] = ACTIONS(4113),
    [anon_sym_LT_LT_DASH] = ACTIONS(4111),
    [anon_sym_LT_LT_LT] = ACTIONS(4111),
    [anon_sym_DOLLAR] = ACTIONS(4113),
    [sym__special_character] = ACTIONS(4111),
    [anon_sym_DQUOTE] = ACTIONS(4111),
    [sym_raw_string] = ACTIONS(4111),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4111),
    [anon_sym_BQUOTE] = ACTIONS(4111),
    [anon_sym_LT_LPAREN] = ACTIONS(4111),
    [anon_sym_GT_LPAREN] = ACTIONS(4111),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4113),
    [anon_sym_LF] = ACTIONS(4111),
    [anon_sym_AMP] = ACTIONS(4113),
  },
  [2874] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_done] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_EQ_TILDE] = ACTIONS(4127),
    [anon_sym_EQ_EQ] = ACTIONS(4127),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym__special_character] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [2875] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(7583),
    [sym_comment] = ACTIONS(57),
  },
  [2876] = {
    [anon_sym_RBRACE] = ACTIONS(7583),
    [sym_comment] = ACTIONS(57),
  },
  [2877] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(7585),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [2878] = {
    [sym_concatenation] = STATE(3397),
    [sym_string] = STATE(3396),
    [sym_simple_expansion] = STATE(3396),
    [sym_string_expansion] = STATE(3396),
    [sym_expansion] = STATE(3396),
    [sym_command_substitution] = STATE(3396),
    [sym_process_substitution] = STATE(3396),
    [aux_sym__literal_repeat1] = STATE(3398),
    [anon_sym_RBRACE] = ACTIONS(7583),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(7587),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7587),
  },
  [2879] = {
    [sym__simple_heredoc_body] = ACTIONS(4161),
    [sym__heredoc_body_beginning] = ACTIONS(4161),
    [sym_file_descriptor] = ACTIONS(4161),
    [sym__concat] = ACTIONS(4161),
    [anon_sym_SEMI] = ACTIONS(4163),
    [anon_sym_done] = ACTIONS(4163),
    [anon_sym_PIPE] = ACTIONS(4163),
    [anon_sym_SEMI_SEMI] = ACTIONS(4161),
    [anon_sym_PIPE_AMP] = ACTIONS(4161),
    [anon_sym_AMP_AMP] = ACTIONS(4161),
    [anon_sym_PIPE_PIPE] = ACTIONS(4161),
    [anon_sym_EQ_TILDE] = ACTIONS(4163),
    [anon_sym_EQ_EQ] = ACTIONS(4163),
    [anon_sym_LT] = ACTIONS(4163),
    [anon_sym_GT] = ACTIONS(4163),
    [anon_sym_GT_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT] = ACTIONS(4163),
    [anon_sym_AMP_GT_GT] = ACTIONS(4161),
    [anon_sym_LT_AMP] = ACTIONS(4161),
    [anon_sym_GT_AMP] = ACTIONS(4161),
    [anon_sym_LT_LT] = ACTIONS(4163),
    [anon_sym_LT_LT_DASH] = ACTIONS(4161),
    [anon_sym_LT_LT_LT] = ACTIONS(4161),
    [anon_sym_DOLLAR] = ACTIONS(4163),
    [sym__special_character] = ACTIONS(4161),
    [anon_sym_DQUOTE] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4161),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4161),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4161),
    [anon_sym_BQUOTE] = ACTIONS(4161),
    [anon_sym_LT_LPAREN] = ACTIONS(4161),
    [anon_sym_GT_LPAREN] = ACTIONS(4161),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4163),
    [anon_sym_LF] = ACTIONS(4161),
    [anon_sym_AMP] = ACTIONS(4163),
  },
  [2880] = {
    [sym_concatenation] = STATE(3401),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3401),
    [sym_regex] = ACTIONS(7589),
    [anon_sym_RBRACE] = ACTIONS(7591),
    [anon_sym_EQ] = ACTIONS(7593),
    [anon_sym_DASH] = ACTIONS(7593),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7595),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7593),
    [anon_sym_COLON_QMARK] = ACTIONS(7593),
    [anon_sym_COLON_DASH] = ACTIONS(7593),
    [anon_sym_PERCENT] = ACTIONS(7593),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2881] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7591),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2882] = {
    [sym_concatenation] = STATE(3403),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3403),
    [sym_regex] = ACTIONS(7597),
    [anon_sym_RBRACE] = ACTIONS(7583),
    [anon_sym_EQ] = ACTIONS(7599),
    [anon_sym_DASH] = ACTIONS(7599),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7601),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7599),
    [anon_sym_COLON_QMARK] = ACTIONS(7599),
    [anon_sym_COLON_DASH] = ACTIONS(7599),
    [anon_sym_PERCENT] = ACTIONS(7599),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2883] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7583),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2884] = {
    [sym_concatenation] = STATE(3405),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3405),
    [anon_sym_RBRACE] = ACTIONS(7603),
    [anon_sym_EQ] = ACTIONS(7605),
    [anon_sym_DASH] = ACTIONS(7605),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7607),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7605),
    [anon_sym_COLON_QMARK] = ACTIONS(7605),
    [anon_sym_COLON_DASH] = ACTIONS(7605),
    [anon_sym_PERCENT] = ACTIONS(7605),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2885] = {
    [sym__simple_heredoc_body] = ACTIONS(4219),
    [sym__heredoc_body_beginning] = ACTIONS(4219),
    [sym_file_descriptor] = ACTIONS(4219),
    [sym__concat] = ACTIONS(4219),
    [anon_sym_SEMI] = ACTIONS(4221),
    [anon_sym_done] = ACTIONS(4221),
    [anon_sym_PIPE] = ACTIONS(4221),
    [anon_sym_SEMI_SEMI] = ACTIONS(4219),
    [anon_sym_PIPE_AMP] = ACTIONS(4219),
    [anon_sym_AMP_AMP] = ACTIONS(4219),
    [anon_sym_PIPE_PIPE] = ACTIONS(4219),
    [anon_sym_EQ_TILDE] = ACTIONS(4221),
    [anon_sym_EQ_EQ] = ACTIONS(4221),
    [anon_sym_LT] = ACTIONS(4221),
    [anon_sym_GT] = ACTIONS(4221),
    [anon_sym_GT_GT] = ACTIONS(4219),
    [anon_sym_AMP_GT] = ACTIONS(4221),
    [anon_sym_AMP_GT_GT] = ACTIONS(4219),
    [anon_sym_LT_AMP] = ACTIONS(4219),
    [anon_sym_GT_AMP] = ACTIONS(4219),
    [anon_sym_LT_LT] = ACTIONS(4221),
    [anon_sym_LT_LT_DASH] = ACTIONS(4219),
    [anon_sym_LT_LT_LT] = ACTIONS(4219),
    [anon_sym_DOLLAR] = ACTIONS(4221),
    [sym__special_character] = ACTIONS(4219),
    [anon_sym_DQUOTE] = ACTIONS(4219),
    [sym_raw_string] = ACTIONS(4219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4219),
    [anon_sym_BQUOTE] = ACTIONS(4219),
    [anon_sym_LT_LPAREN] = ACTIONS(4219),
    [anon_sym_GT_LPAREN] = ACTIONS(4219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4221),
    [anon_sym_LF] = ACTIONS(4219),
    [anon_sym_AMP] = ACTIONS(4221),
  },
  [2886] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7603),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2887] = {
    [sym_concatenation] = STATE(3403),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3403),
    [anon_sym_RBRACE] = ACTIONS(7583),
    [anon_sym_EQ] = ACTIONS(7599),
    [anon_sym_DASH] = ACTIONS(7599),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7601),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7599),
    [anon_sym_COLON_QMARK] = ACTIONS(7599),
    [anon_sym_COLON_DASH] = ACTIONS(7599),
    [anon_sym_PERCENT] = ACTIONS(7599),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2888] = {
    [aux_sym_concatenation_repeat1] = STATE(2894),
    [sym__simple_heredoc_body] = ACTIONS(1380),
    [sym__heredoc_body_beginning] = ACTIONS(1380),
    [sym_file_descriptor] = ACTIONS(1380),
    [sym__concat] = ACTIONS(6367),
    [anon_sym_SEMI] = ACTIONS(1382),
    [anon_sym_done] = ACTIONS(1380),
    [anon_sym_PIPE] = ACTIONS(1382),
    [anon_sym_SEMI_SEMI] = ACTIONS(1380),
    [anon_sym_PIPE_AMP] = ACTIONS(1380),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_PIPE_PIPE] = ACTIONS(1380),
    [anon_sym_LT] = ACTIONS(1382),
    [anon_sym_GT] = ACTIONS(1382),
    [anon_sym_GT_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT] = ACTIONS(1382),
    [anon_sym_AMP_GT_GT] = ACTIONS(1380),
    [anon_sym_LT_AMP] = ACTIONS(1380),
    [anon_sym_GT_AMP] = ACTIONS(1380),
    [anon_sym_LT_LT] = ACTIONS(1382),
    [anon_sym_LT_LT_DASH] = ACTIONS(1380),
    [anon_sym_LT_LT_LT] = ACTIONS(1380),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1380),
    [anon_sym_AMP] = ACTIONS(1382),
  },
  [2889] = {
    [aux_sym__literal_repeat1] = STATE(2907),
    [sym__simple_heredoc_body] = ACTIONS(1384),
    [sym__heredoc_body_beginning] = ACTIONS(1384),
    [sym_file_descriptor] = ACTIONS(1384),
    [anon_sym_SEMI] = ACTIONS(1386),
    [anon_sym_done] = ACTIONS(1384),
    [anon_sym_PIPE] = ACTIONS(1386),
    [anon_sym_SEMI_SEMI] = ACTIONS(1384),
    [anon_sym_PIPE_AMP] = ACTIONS(1384),
    [anon_sym_AMP_AMP] = ACTIONS(1384),
    [anon_sym_PIPE_PIPE] = ACTIONS(1384),
    [anon_sym_LT] = ACTIONS(1386),
    [anon_sym_GT] = ACTIONS(1386),
    [anon_sym_GT_GT] = ACTIONS(1384),
    [anon_sym_AMP_GT] = ACTIONS(1386),
    [anon_sym_AMP_GT_GT] = ACTIONS(1384),
    [anon_sym_LT_AMP] = ACTIONS(1384),
    [anon_sym_GT_AMP] = ACTIONS(1384),
    [anon_sym_LT_LT] = ACTIONS(1386),
    [anon_sym_LT_LT_DASH] = ACTIONS(1384),
    [anon_sym_LT_LT_LT] = ACTIONS(1384),
    [sym__special_character] = ACTIONS(6383),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1384),
    [anon_sym_AMP] = ACTIONS(1386),
  },
  [2890] = {
    [sym__simple_heredoc_body] = ACTIONS(1057),
    [sym__heredoc_body_beginning] = ACTIONS(1057),
    [sym_file_descriptor] = ACTIONS(1057),
    [sym__concat] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_done] = ACTIONS(1057),
    [anon_sym_fi] = ACTIONS(1057),
    [anon_sym_elif] = ACTIONS(1057),
    [anon_sym_else] = ACTIONS(1057),
    [anon_sym_esac] = ACTIONS(1057),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_PIPE_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_AMP] = ACTIONS(1057),
    [anon_sym_GT_AMP] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_LT] = ACTIONS(1057),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [2891] = {
    [sym__simple_heredoc_body] = ACTIONS(1061),
    [sym__heredoc_body_beginning] = ACTIONS(1061),
    [sym_file_descriptor] = ACTIONS(1061),
    [sym__concat] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(1063),
    [anon_sym_done] = ACTIONS(1061),
    [anon_sym_fi] = ACTIONS(1061),
    [anon_sym_elif] = ACTIONS(1061),
    [anon_sym_else] = ACTIONS(1061),
    [anon_sym_esac] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1063),
    [anon_sym_SEMI_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE_AMP] = ACTIONS(1061),
    [anon_sym_AMP_AMP] = ACTIONS(1061),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1063),
    [anon_sym_GT_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT_GT] = ACTIONS(1061),
    [anon_sym_LT_AMP] = ACTIONS(1061),
    [anon_sym_GT_AMP] = ACTIONS(1061),
    [anon_sym_LT_LT] = ACTIONS(1063),
    [anon_sym_LT_LT_DASH] = ACTIONS(1061),
    [anon_sym_LT_LT_LT] = ACTIONS(1061),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1061),
    [anon_sym_AMP] = ACTIONS(1063),
  },
  [2892] = {
    [sym__simple_heredoc_body] = ACTIONS(1065),
    [sym__heredoc_body_beginning] = ACTIONS(1065),
    [sym_file_descriptor] = ACTIONS(1065),
    [sym__concat] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_done] = ACTIONS(1065),
    [anon_sym_fi] = ACTIONS(1065),
    [anon_sym_elif] = ACTIONS(1065),
    [anon_sym_else] = ACTIONS(1065),
    [anon_sym_esac] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1067),
    [anon_sym_SEMI_SEMI] = ACTIONS(1065),
    [anon_sym_PIPE_AMP] = ACTIONS(1065),
    [anon_sym_AMP_AMP] = ACTIONS(1065),
    [anon_sym_PIPE_PIPE] = ACTIONS(1065),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_GT] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT] = ACTIONS(1067),
    [anon_sym_AMP_GT_GT] = ACTIONS(1065),
    [anon_sym_LT_AMP] = ACTIONS(1065),
    [anon_sym_GT_AMP] = ACTIONS(1065),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_LT_LT_DASH] = ACTIONS(1065),
    [anon_sym_LT_LT_LT] = ACTIONS(1065),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1067),
  },
  [2893] = {
    [sym_string] = STATE(3406),
    [sym_simple_expansion] = STATE(3406),
    [sym_string_expansion] = STATE(3406),
    [sym_expansion] = STATE(3406),
    [sym_command_substitution] = STATE(3406),
    [sym_process_substitution] = STATE(3406),
    [anon_sym_DOLLAR] = ACTIONS(4998),
    [sym__special_character] = ACTIONS(7609),
    [anon_sym_DQUOTE] = ACTIONS(5002),
    [sym_raw_string] = ACTIONS(7609),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5006),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5008),
    [anon_sym_BQUOTE] = ACTIONS(5010),
    [anon_sym_LT_LPAREN] = ACTIONS(5012),
    [anon_sym_GT_LPAREN] = ACTIONS(5012),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7609),
  },
  [2894] = {
    [aux_sym_concatenation_repeat1] = STATE(3408),
    [sym__simple_heredoc_body] = ACTIONS(1071),
    [sym__heredoc_body_beginning] = ACTIONS(1071),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(7611),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_done] = ACTIONS(1071),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1075),
  },
  [2895] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(7613),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [2896] = {
    [sym__simple_heredoc_body] = ACTIONS(1089),
    [sym__heredoc_body_beginning] = ACTIONS(1089),
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(1089),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_done] = ACTIONS(1089),
    [anon_sym_fi] = ACTIONS(1089),
    [anon_sym_elif] = ACTIONS(1089),
    [anon_sym_else] = ACTIONS(1089),
    [anon_sym_esac] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1089),
    [anon_sym_PIPE_AMP] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_AMP] = ACTIONS(1089),
    [anon_sym_GT_AMP] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1089),
    [anon_sym_LT_LT_LT] = ACTIONS(1089),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [2897] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(627),
    [anon_sym_DOLLAR] = ACTIONS(7615),
    [anon_sym_DQUOTE] = ACTIONS(7613),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [2898] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(7617),
    [sym_comment] = ACTIONS(57),
  },
  [2899] = {
    [sym_subscript] = STATE(3414),
    [sym_variable_name] = ACTIONS(7619),
    [anon_sym_DASH] = ACTIONS(7621),
    [anon_sym_DOLLAR] = ACTIONS(7621),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7623),
    [anon_sym_STAR] = ACTIONS(7625),
    [anon_sym_AT] = ACTIONS(7625),
    [anon_sym_QMARK] = ACTIONS(7625),
    [anon_sym_0] = ACTIONS(7623),
    [anon_sym__] = ACTIONS(7623),
  },
  [2900] = {
    [sym_concatenation] = STATE(3417),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3417),
    [anon_sym_RBRACE] = ACTIONS(7627),
    [anon_sym_EQ] = ACTIONS(7629),
    [anon_sym_DASH] = ACTIONS(7629),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7631),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(7633),
    [anon_sym_COLON] = ACTIONS(7629),
    [anon_sym_COLON_QMARK] = ACTIONS(7629),
    [anon_sym_COLON_DASH] = ACTIONS(7629),
    [anon_sym_PERCENT] = ACTIONS(7629),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2901] = {
    [sym_concatenation] = STATE(3420),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3420),
    [anon_sym_RBRACE] = ACTIONS(7635),
    [anon_sym_EQ] = ACTIONS(7637),
    [anon_sym_DASH] = ACTIONS(7637),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7639),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(7641),
    [anon_sym_COLON] = ACTIONS(7637),
    [anon_sym_COLON_QMARK] = ACTIONS(7637),
    [anon_sym_COLON_DASH] = ACTIONS(7637),
    [anon_sym_PERCENT] = ACTIONS(7637),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2902] = {
    [anon_sym_RPAREN] = ACTIONS(7643),
    [sym_comment] = ACTIONS(57),
  },
  [2903] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(7643),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [2904] = {
    [anon_sym_BQUOTE] = ACTIONS(7643),
    [sym_comment] = ACTIONS(57),
  },
  [2905] = {
    [anon_sym_RPAREN] = ACTIONS(7645),
    [sym_comment] = ACTIONS(57),
  },
  [2906] = {
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_done] = ACTIONS(335),
    [anon_sym_fi] = ACTIONS(335),
    [anon_sym_elif] = ACTIONS(335),
    [anon_sym_else] = ACTIONS(335),
    [anon_sym_esac] = ACTIONS(335),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [sym__special_character] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [2907] = {
    [aux_sym__literal_repeat1] = STATE(2907),
    [sym__simple_heredoc_body] = ACTIONS(1373),
    [sym__heredoc_body_beginning] = ACTIONS(1373),
    [sym_file_descriptor] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_done] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE_AMP] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_LT_LT_DASH] = ACTIONS(1373),
    [anon_sym_LT_LT_LT] = ACTIONS(1373),
    [sym__special_character] = ACTIONS(7647),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
  },
  [2908] = {
    [sym_file_descriptor] = ACTIONS(2604),
    [sym_variable_name] = ACTIONS(2604),
    [anon_sym_for] = ACTIONS(2608),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2608),
    [anon_sym_done] = ACTIONS(7650),
    [anon_sym_if] = ACTIONS(2608),
    [anon_sym_case] = ACTIONS(2608),
    [anon_sym_function] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(2608),
    [anon_sym_LBRACE] = ACTIONS(2604),
    [anon_sym_BANG] = ACTIONS(2608),
    [anon_sym_LBRACK] = ACTIONS(2608),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2604),
    [anon_sym_declare] = ACTIONS(2608),
    [anon_sym_typeset] = ACTIONS(2608),
    [anon_sym_export] = ACTIONS(2608),
    [anon_sym_readonly] = ACTIONS(2608),
    [anon_sym_local] = ACTIONS(2608),
    [anon_sym_unset] = ACTIONS(2608),
    [anon_sym_unsetenv] = ACTIONS(2608),
    [anon_sym_LT] = ACTIONS(2608),
    [anon_sym_GT] = ACTIONS(2608),
    [anon_sym_GT_GT] = ACTIONS(2604),
    [anon_sym_AMP_GT] = ACTIONS(2608),
    [anon_sym_AMP_GT_GT] = ACTIONS(2604),
    [anon_sym_LT_AMP] = ACTIONS(2604),
    [anon_sym_GT_AMP] = ACTIONS(2604),
    [anon_sym_DOLLAR] = ACTIONS(2608),
    [sym__special_character] = ACTIONS(2608),
    [anon_sym_DQUOTE] = ACTIONS(2604),
    [sym_raw_string] = ACTIONS(2604),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2604),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2604),
    [anon_sym_BQUOTE] = ACTIONS(2604),
    [anon_sym_LT_LPAREN] = ACTIONS(2604),
    [anon_sym_GT_LPAREN] = ACTIONS(2604),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2608),
  },
  [2909] = {
    [sym_string] = STATE(363),
    [sym_file_descriptor] = ACTIONS(4071),
    [anon_sym_SEMI] = ACTIONS(4073),
    [anon_sym_PIPE] = ACTIONS(4073),
    [anon_sym_SEMI_SEMI] = ACTIONS(4071),
    [anon_sym_PIPE_AMP] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_PIPE_PIPE] = ACTIONS(4071),
    [anon_sym_LT] = ACTIONS(4073),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_GT_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT] = ACTIONS(4073),
    [anon_sym_AMP_GT_GT] = ACTIONS(4071),
    [anon_sym_LT_AMP] = ACTIONS(4071),
    [anon_sym_GT_AMP] = ACTIONS(4071),
    [anon_sym_LT_LT] = ACTIONS(4073),
    [anon_sym_LT_LT_DASH] = ACTIONS(4071),
    [anon_sym_LT_LT_LT] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(625),
    [anon_sym_DQUOTE] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(627),
    [anon_sym_POUND] = ACTIONS(625),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(629),
    [anon_sym_STAR] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(631),
    [anon_sym_QMARK] = ACTIONS(631),
    [anon_sym_0] = ACTIONS(629),
    [anon_sym__] = ACTIONS(629),
    [anon_sym_LF] = ACTIONS(4071),
    [anon_sym_AMP] = ACTIONS(4073),
  },
  [2910] = {
    [sym__simple_heredoc_body] = ACTIONS(2719),
    [sym__heredoc_body_beginning] = ACTIONS(2719),
    [sym_file_descriptor] = ACTIONS(2719),
    [sym_variable_name] = ACTIONS(2719),
    [anon_sym_SEMI] = ACTIONS(2721),
    [anon_sym_fi] = ACTIONS(2721),
    [anon_sym_elif] = ACTIONS(2721),
    [anon_sym_else] = ACTIONS(2721),
    [anon_sym_PIPE] = ACTIONS(2721),
    [anon_sym_SEMI_SEMI] = ACTIONS(2719),
    [anon_sym_PIPE_AMP] = ACTIONS(2719),
    [anon_sym_AMP_AMP] = ACTIONS(2719),
    [anon_sym_PIPE_PIPE] = ACTIONS(2719),
    [anon_sym_LT] = ACTIONS(2721),
    [anon_sym_GT] = ACTIONS(2721),
    [anon_sym_GT_GT] = ACTIONS(2719),
    [anon_sym_AMP_GT] = ACTIONS(2721),
    [anon_sym_AMP_GT_GT] = ACTIONS(2719),
    [anon_sym_LT_AMP] = ACTIONS(2719),
    [anon_sym_GT_AMP] = ACTIONS(2719),
    [anon_sym_LT_LT] = ACTIONS(2721),
    [anon_sym_LT_LT_DASH] = ACTIONS(2719),
    [anon_sym_LT_LT_LT] = ACTIONS(2719),
    [anon_sym_DOLLAR] = ACTIONS(2721),
    [sym__special_character] = ACTIONS(2719),
    [anon_sym_DQUOTE] = ACTIONS(2719),
    [sym_raw_string] = ACTIONS(2719),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2719),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2719),
    [anon_sym_BQUOTE] = ACTIONS(2719),
    [anon_sym_LT_LPAREN] = ACTIONS(2719),
    [anon_sym_GT_LPAREN] = ACTIONS(2719),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2721),
    [anon_sym_LF] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2721),
  },
  [2911] = {
    [sym_concatenation] = STATE(1368),
    [sym_string] = STATE(730),
    [sym_simple_expansion] = STATE(730),
    [sym_string_expansion] = STATE(730),
    [sym_expansion] = STATE(730),
    [sym_command_substitution] = STATE(730),
    [sym_process_substitution] = STATE(730),
    [aux_sym_for_statement_repeat1] = STATE(1368),
    [aux_sym__literal_repeat1] = STATE(736),
    [anon_sym_RPAREN] = ACTIONS(7652),
    [anon_sym_DOLLAR] = ACTIONS(1406),
    [sym__special_character] = ACTIONS(1408),
    [anon_sym_DQUOTE] = ACTIONS(1410),
    [sym_raw_string] = ACTIONS(1412),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1414),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1416),
    [anon_sym_BQUOTE] = ACTIONS(1418),
    [anon_sym_LT_LPAREN] = ACTIONS(1420),
    [anon_sym_GT_LPAREN] = ACTIONS(1420),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1412),
  },
  [2912] = {
    [sym__simple_heredoc_body] = ACTIONS(1057),
    [sym__heredoc_body_beginning] = ACTIONS(1057),
    [sym_file_descriptor] = ACTIONS(1057),
    [sym__concat] = ACTIONS(1057),
    [sym_variable_name] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_fi] = ACTIONS(1059),
    [anon_sym_elif] = ACTIONS(1059),
    [anon_sym_else] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_PIPE_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_AMP] = ACTIONS(1057),
    [anon_sym_GT_AMP] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_LT] = ACTIONS(1057),
    [anon_sym_DOLLAR] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [sym_raw_string] = ACTIONS(1057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1057),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1057),
    [anon_sym_BQUOTE] = ACTIONS(1057),
    [anon_sym_LT_LPAREN] = ACTIONS(1057),
    [anon_sym_GT_LPAREN] = ACTIONS(1057),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [2913] = {
    [sym__simple_heredoc_body] = ACTIONS(1061),
    [sym__heredoc_body_beginning] = ACTIONS(1061),
    [sym_file_descriptor] = ACTIONS(1061),
    [sym__concat] = ACTIONS(1061),
    [sym_variable_name] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(1063),
    [anon_sym_fi] = ACTIONS(1063),
    [anon_sym_elif] = ACTIONS(1063),
    [anon_sym_else] = ACTIONS(1063),
    [anon_sym_PIPE] = ACTIONS(1063),
    [anon_sym_SEMI_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE_AMP] = ACTIONS(1061),
    [anon_sym_AMP_AMP] = ACTIONS(1061),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1063),
    [anon_sym_GT_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT_GT] = ACTIONS(1061),
    [anon_sym_LT_AMP] = ACTIONS(1061),
    [anon_sym_GT_AMP] = ACTIONS(1061),
    [anon_sym_LT_LT] = ACTIONS(1063),
    [anon_sym_LT_LT_DASH] = ACTIONS(1061),
    [anon_sym_LT_LT_LT] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1061),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1061),
    [anon_sym_LT_LPAREN] = ACTIONS(1061),
    [anon_sym_GT_LPAREN] = ACTIONS(1061),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1063),
    [anon_sym_LF] = ACTIONS(1061),
    [anon_sym_AMP] = ACTIONS(1063),
  },
  [2914] = {
    [sym__simple_heredoc_body] = ACTIONS(1065),
    [sym__heredoc_body_beginning] = ACTIONS(1065),
    [sym_file_descriptor] = ACTIONS(1065),
    [sym__concat] = ACTIONS(1065),
    [sym_variable_name] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_fi] = ACTIONS(1067),
    [anon_sym_elif] = ACTIONS(1067),
    [anon_sym_else] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1067),
    [anon_sym_SEMI_SEMI] = ACTIONS(1065),
    [anon_sym_PIPE_AMP] = ACTIONS(1065),
    [anon_sym_AMP_AMP] = ACTIONS(1065),
    [anon_sym_PIPE_PIPE] = ACTIONS(1065),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_GT] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT] = ACTIONS(1067),
    [anon_sym_AMP_GT_GT] = ACTIONS(1065),
    [anon_sym_LT_AMP] = ACTIONS(1065),
    [anon_sym_GT_AMP] = ACTIONS(1065),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_LT_LT_DASH] = ACTIONS(1065),
    [anon_sym_LT_LT_LT] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1067),
    [sym__special_character] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LT_LPAREN] = ACTIONS(1065),
    [anon_sym_GT_LPAREN] = ACTIONS(1065),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1067),
    [anon_sym_LF] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1067),
  },
  [2915] = {
    [sym_string] = STATE(3424),
    [sym_simple_expansion] = STATE(3424),
    [sym_string_expansion] = STATE(3424),
    [sym_expansion] = STATE(3424),
    [sym_command_substitution] = STATE(3424),
    [sym_process_substitution] = STATE(3424),
    [anon_sym_DOLLAR] = ACTIONS(5037),
    [sym__special_character] = ACTIONS(7654),
    [anon_sym_DQUOTE] = ACTIONS(5041),
    [sym_raw_string] = ACTIONS(7654),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5045),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5047),
    [anon_sym_BQUOTE] = ACTIONS(5049),
    [anon_sym_LT_LPAREN] = ACTIONS(5051),
    [anon_sym_GT_LPAREN] = ACTIONS(5051),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7654),
  },
  [2916] = {
    [aux_sym_concatenation_repeat1] = STATE(3426),
    [sym__simple_heredoc_body] = ACTIONS(1071),
    [sym__heredoc_body_beginning] = ACTIONS(1071),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(7656),
    [sym_variable_name] = ACTIONS(1071),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_fi] = ACTIONS(1075),
    [anon_sym_elif] = ACTIONS(1075),
    [anon_sym_else] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [sym__special_character] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1075),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1075),
  },
  [2917] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(7658),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [2918] = {
    [sym__simple_heredoc_body] = ACTIONS(1089),
    [sym__heredoc_body_beginning] = ACTIONS(1089),
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(1089),
    [sym_variable_name] = ACTIONS(1089),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_fi] = ACTIONS(1091),
    [anon_sym_elif] = ACTIONS(1091),
    [anon_sym_else] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1089),
    [anon_sym_PIPE_AMP] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_AMP] = ACTIONS(1089),
    [anon_sym_GT_AMP] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1089),
    [anon_sym_LT_LT_LT] = ACTIONS(1089),
    [anon_sym_DOLLAR] = ACTIONS(1091),
    [sym__special_character] = ACTIONS(1089),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1089),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1089),
    [anon_sym_GT_LPAREN] = ACTIONS(1089),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [2919] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(627),
    [anon_sym_DOLLAR] = ACTIONS(7660),
    [anon_sym_DQUOTE] = ACTIONS(7658),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [2920] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(7662),
    [sym_comment] = ACTIONS(57),
  },
  [2921] = {
    [sym_subscript] = STATE(3432),
    [sym_variable_name] = ACTIONS(7664),
    [anon_sym_DASH] = ACTIONS(7666),
    [anon_sym_DOLLAR] = ACTIONS(7666),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7668),
    [anon_sym_STAR] = ACTIONS(7670),
    [anon_sym_AT] = ACTIONS(7670),
    [anon_sym_QMARK] = ACTIONS(7670),
    [anon_sym_0] = ACTIONS(7668),
    [anon_sym__] = ACTIONS(7668),
  },
  [2922] = {
    [sym_concatenation] = STATE(3435),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3435),
    [anon_sym_RBRACE] = ACTIONS(7672),
    [anon_sym_EQ] = ACTIONS(7674),
    [anon_sym_DASH] = ACTIONS(7674),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7676),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(7678),
    [anon_sym_COLON] = ACTIONS(7674),
    [anon_sym_COLON_QMARK] = ACTIONS(7674),
    [anon_sym_COLON_DASH] = ACTIONS(7674),
    [anon_sym_PERCENT] = ACTIONS(7674),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2923] = {
    [sym_concatenation] = STATE(3438),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3438),
    [anon_sym_RBRACE] = ACTIONS(7680),
    [anon_sym_EQ] = ACTIONS(7682),
    [anon_sym_DASH] = ACTIONS(7682),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7684),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(7686),
    [anon_sym_COLON] = ACTIONS(7682),
    [anon_sym_COLON_QMARK] = ACTIONS(7682),
    [anon_sym_COLON_DASH] = ACTIONS(7682),
    [anon_sym_PERCENT] = ACTIONS(7682),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2924] = {
    [anon_sym_RPAREN] = ACTIONS(7688),
    [sym_comment] = ACTIONS(57),
  },
  [2925] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(7688),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [2926] = {
    [anon_sym_BQUOTE] = ACTIONS(7688),
    [sym_comment] = ACTIONS(57),
  },
  [2927] = {
    [anon_sym_RPAREN] = ACTIONS(7690),
    [sym_comment] = ACTIONS(57),
  },
  [2928] = {
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym_variable_name] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_fi] = ACTIONS(339),
    [anon_sym_elif] = ACTIONS(339),
    [anon_sym_else] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [2929] = {
    [aux_sym__literal_repeat1] = STATE(2929),
    [sym__simple_heredoc_body] = ACTIONS(1373),
    [sym__heredoc_body_beginning] = ACTIONS(1373),
    [sym_file_descriptor] = ACTIONS(1373),
    [sym_variable_name] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_fi] = ACTIONS(1375),
    [anon_sym_elif] = ACTIONS(1375),
    [anon_sym_else] = ACTIONS(1375),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE_AMP] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_LT_LT_DASH] = ACTIONS(1373),
    [anon_sym_LT_LT_LT] = ACTIONS(1373),
    [anon_sym_DOLLAR] = ACTIONS(1375),
    [sym__special_character] = ACTIONS(7692),
    [anon_sym_DQUOTE] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1373),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [anon_sym_LT_LPAREN] = ACTIONS(1373),
    [anon_sym_GT_LPAREN] = ACTIONS(1373),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1375),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
  },
  [2930] = {
    [anon_sym_fi] = ACTIONS(7695),
    [anon_sym_elif] = ACTIONS(7695),
    [anon_sym_else] = ACTIONS(7695),
    [sym_comment] = ACTIONS(57),
  },
  [2931] = {
    [sym__simple_heredoc_body] = ACTIONS(1400),
    [sym__heredoc_body_beginning] = ACTIONS(1400),
    [sym_file_descriptor] = ACTIONS(1400),
    [sym_variable_name] = ACTIONS(1400),
    [anon_sym_SEMI] = ACTIONS(1402),
    [anon_sym_fi] = ACTIONS(1402),
    [anon_sym_PIPE] = ACTIONS(1402),
    [anon_sym_SEMI_SEMI] = ACTIONS(1400),
    [anon_sym_PIPE_AMP] = ACTIONS(1400),
    [anon_sym_AMP_AMP] = ACTIONS(1400),
    [anon_sym_PIPE_PIPE] = ACTIONS(1400),
    [anon_sym_LT] = ACTIONS(1402),
    [anon_sym_GT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT] = ACTIONS(1402),
    [anon_sym_AMP_GT_GT] = ACTIONS(1400),
    [anon_sym_LT_AMP] = ACTIONS(1400),
    [anon_sym_GT_AMP] = ACTIONS(1400),
    [anon_sym_LT_LT] = ACTIONS(1402),
    [anon_sym_LT_LT_DASH] = ACTIONS(1400),
    [anon_sym_LT_LT_LT] = ACTIONS(1400),
    [anon_sym_DOLLAR] = ACTIONS(1402),
    [sym__special_character] = ACTIONS(1400),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1400),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1400),
    [anon_sym_BQUOTE] = ACTIONS(1400),
    [anon_sym_LT_LPAREN] = ACTIONS(1400),
    [anon_sym_GT_LPAREN] = ACTIONS(1400),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1402),
    [anon_sym_LF] = ACTIONS(1400),
    [anon_sym_AMP] = ACTIONS(1402),
  },
  [2932] = {
    [sym_concatenation] = STATE(3442),
    [sym_string] = STATE(730),
    [sym_simple_expansion] = STATE(730),
    [sym_string_expansion] = STATE(730),
    [sym_expansion] = STATE(730),
    [sym_command_substitution] = STATE(730),
    [sym_process_substitution] = STATE(730),
    [aux_sym_for_statement_repeat1] = STATE(3442),
    [aux_sym__literal_repeat1] = STATE(736),
    [anon_sym_RPAREN] = ACTIONS(7697),
    [anon_sym_DOLLAR] = ACTIONS(1406),
    [sym__special_character] = ACTIONS(1408),
    [anon_sym_DQUOTE] = ACTIONS(1410),
    [sym_raw_string] = ACTIONS(1412),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1414),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1416),
    [anon_sym_BQUOTE] = ACTIONS(1418),
    [anon_sym_LT_LPAREN] = ACTIONS(1420),
    [anon_sym_GT_LPAREN] = ACTIONS(1420),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1412),
  },
  [2933] = {
    [sym_string] = STATE(3444),
    [anon_sym_DASH] = ACTIONS(7699),
    [anon_sym_DOLLAR] = ACTIONS(7699),
    [anon_sym_DQUOTE] = ACTIONS(6473),
    [sym_raw_string] = ACTIONS(7701),
    [anon_sym_POUND] = ACTIONS(7699),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7703),
    [anon_sym_STAR] = ACTIONS(7705),
    [anon_sym_AT] = ACTIONS(7705),
    [anon_sym_QMARK] = ACTIONS(7705),
    [anon_sym_0] = ACTIONS(7703),
    [anon_sym__] = ACTIONS(7703),
  },
  [2934] = {
    [aux_sym_concatenation_repeat1] = STATE(3447),
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(7707),
    [sym_variable_name] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_fi] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [2935] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(3450),
    [anon_sym_DOLLAR] = ACTIONS(7709),
    [anon_sym_DQUOTE] = ACTIONS(7711),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [2936] = {
    [aux_sym_concatenation_repeat1] = STATE(3447),
    [sym__simple_heredoc_body] = ACTIONS(1400),
    [sym__heredoc_body_beginning] = ACTIONS(1400),
    [sym_file_descriptor] = ACTIONS(1400),
    [sym__concat] = ACTIONS(7707),
    [sym_variable_name] = ACTIONS(1400),
    [anon_sym_SEMI] = ACTIONS(1402),
    [anon_sym_fi] = ACTIONS(1402),
    [anon_sym_PIPE] = ACTIONS(1402),
    [anon_sym_SEMI_SEMI] = ACTIONS(1400),
    [anon_sym_PIPE_AMP] = ACTIONS(1400),
    [anon_sym_AMP_AMP] = ACTIONS(1400),
    [anon_sym_PIPE_PIPE] = ACTIONS(1400),
    [anon_sym_LT] = ACTIONS(1402),
    [anon_sym_GT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT] = ACTIONS(1402),
    [anon_sym_AMP_GT_GT] = ACTIONS(1400),
    [anon_sym_LT_AMP] = ACTIONS(1400),
    [anon_sym_GT_AMP] = ACTIONS(1400),
    [anon_sym_LT_LT] = ACTIONS(1402),
    [anon_sym_LT_LT_DASH] = ACTIONS(1400),
    [anon_sym_LT_LT_LT] = ACTIONS(1400),
    [anon_sym_DOLLAR] = ACTIONS(1402),
    [sym__special_character] = ACTIONS(1400),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1400),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1400),
    [anon_sym_BQUOTE] = ACTIONS(1400),
    [anon_sym_LT_LPAREN] = ACTIONS(1400),
    [anon_sym_GT_LPAREN] = ACTIONS(1400),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1402),
    [anon_sym_LF] = ACTIONS(1400),
    [anon_sym_AMP] = ACTIONS(1402),
  },
  [2937] = {
    [sym_subscript] = STATE(3454),
    [sym_variable_name] = ACTIONS(7713),
    [anon_sym_BANG] = ACTIONS(7715),
    [anon_sym_DASH] = ACTIONS(7717),
    [anon_sym_DOLLAR] = ACTIONS(7717),
    [anon_sym_POUND] = ACTIONS(7715),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7719),
    [anon_sym_STAR] = ACTIONS(7721),
    [anon_sym_AT] = ACTIONS(7721),
    [anon_sym_QMARK] = ACTIONS(7721),
    [anon_sym_0] = ACTIONS(7719),
    [anon_sym__] = ACTIONS(7719),
  },
  [2938] = {
    [sym__statements] = STATE(3455),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(3456),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [2939] = {
    [sym__statements] = STATE(3457),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [2940] = {
    [sym__statements] = STATE(3458),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [2941] = {
    [aux_sym__literal_repeat1] = STATE(3460),
    [sym__simple_heredoc_body] = ACTIONS(1446),
    [sym__heredoc_body_beginning] = ACTIONS(1446),
    [sym_file_descriptor] = ACTIONS(1446),
    [sym_variable_name] = ACTIONS(1446),
    [anon_sym_SEMI] = ACTIONS(1448),
    [anon_sym_fi] = ACTIONS(1448),
    [anon_sym_PIPE] = ACTIONS(1448),
    [anon_sym_SEMI_SEMI] = ACTIONS(1446),
    [anon_sym_PIPE_AMP] = ACTIONS(1446),
    [anon_sym_AMP_AMP] = ACTIONS(1446),
    [anon_sym_PIPE_PIPE] = ACTIONS(1446),
    [anon_sym_LT] = ACTIONS(1448),
    [anon_sym_GT] = ACTIONS(1448),
    [anon_sym_GT_GT] = ACTIONS(1446),
    [anon_sym_AMP_GT] = ACTIONS(1448),
    [anon_sym_AMP_GT_GT] = ACTIONS(1446),
    [anon_sym_LT_AMP] = ACTIONS(1446),
    [anon_sym_GT_AMP] = ACTIONS(1446),
    [anon_sym_LT_LT] = ACTIONS(1448),
    [anon_sym_LT_LT_DASH] = ACTIONS(1446),
    [anon_sym_LT_LT_LT] = ACTIONS(1446),
    [anon_sym_DOLLAR] = ACTIONS(1448),
    [sym__special_character] = ACTIONS(7723),
    [anon_sym_DQUOTE] = ACTIONS(1446),
    [sym_raw_string] = ACTIONS(1446),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1446),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1446),
    [anon_sym_BQUOTE] = ACTIONS(1446),
    [anon_sym_LT_LPAREN] = ACTIONS(1446),
    [anon_sym_GT_LPAREN] = ACTIONS(1446),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1448),
    [anon_sym_LF] = ACTIONS(1446),
    [anon_sym_AMP] = ACTIONS(1448),
  },
  [2942] = {
    [sym_concatenation] = STATE(3461),
    [sym_string] = STATE(3463),
    [sym_array] = STATE(3461),
    [sym_simple_expansion] = STATE(3463),
    [sym_string_expansion] = STATE(3463),
    [sym_expansion] = STATE(3463),
    [sym_command_substitution] = STATE(3463),
    [sym_process_substitution] = STATE(3463),
    [aux_sym__literal_repeat1] = STATE(3464),
    [sym__empty_value] = ACTIONS(7725),
    [anon_sym_LPAREN] = ACTIONS(7727),
    [anon_sym_DOLLAR] = ACTIONS(5059),
    [sym__special_character] = ACTIONS(5061),
    [anon_sym_DQUOTE] = ACTIONS(5063),
    [sym_raw_string] = ACTIONS(7729),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5067),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5069),
    [anon_sym_BQUOTE] = ACTIONS(5071),
    [anon_sym_LT_LPAREN] = ACTIONS(5073),
    [anon_sym_GT_LPAREN] = ACTIONS(5073),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7729),
  },
  [2943] = {
    [sym__simple_heredoc_body] = ACTIONS(1057),
    [sym__heredoc_body_beginning] = ACTIONS(1057),
    [sym_file_descriptor] = ACTIONS(1057),
    [sym__concat] = ACTIONS(1057),
    [sym_variable_name] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_fi] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_PIPE_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_AMP] = ACTIONS(1057),
    [anon_sym_GT_AMP] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_LT] = ACTIONS(1057),
    [anon_sym_DOLLAR] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [sym_raw_string] = ACTIONS(1057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1057),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1057),
    [anon_sym_BQUOTE] = ACTIONS(1057),
    [anon_sym_LT_LPAREN] = ACTIONS(1057),
    [anon_sym_GT_LPAREN] = ACTIONS(1057),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1059),
    [sym_word] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [2944] = {
    [sym__simple_heredoc_body] = ACTIONS(1061),
    [sym__heredoc_body_beginning] = ACTIONS(1061),
    [sym_file_descriptor] = ACTIONS(1061),
    [sym__concat] = ACTIONS(1061),
    [sym_variable_name] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(1063),
    [anon_sym_fi] = ACTIONS(1063),
    [anon_sym_PIPE] = ACTIONS(1063),
    [anon_sym_SEMI_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE_AMP] = ACTIONS(1061),
    [anon_sym_AMP_AMP] = ACTIONS(1061),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1063),
    [anon_sym_GT_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT_GT] = ACTIONS(1061),
    [anon_sym_LT_AMP] = ACTIONS(1061),
    [anon_sym_GT_AMP] = ACTIONS(1061),
    [anon_sym_LT_LT] = ACTIONS(1063),
    [anon_sym_LT_LT_DASH] = ACTIONS(1061),
    [anon_sym_LT_LT_LT] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1061),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1061),
    [anon_sym_LT_LPAREN] = ACTIONS(1061),
    [anon_sym_GT_LPAREN] = ACTIONS(1061),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1063),
    [sym_word] = ACTIONS(1063),
    [anon_sym_LF] = ACTIONS(1061),
    [anon_sym_AMP] = ACTIONS(1063),
  },
  [2945] = {
    [sym__simple_heredoc_body] = ACTIONS(1065),
    [sym__heredoc_body_beginning] = ACTIONS(1065),
    [sym_file_descriptor] = ACTIONS(1065),
    [sym__concat] = ACTIONS(1065),
    [sym_variable_name] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_fi] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1067),
    [anon_sym_SEMI_SEMI] = ACTIONS(1065),
    [anon_sym_PIPE_AMP] = ACTIONS(1065),
    [anon_sym_AMP_AMP] = ACTIONS(1065),
    [anon_sym_PIPE_PIPE] = ACTIONS(1065),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_GT] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT] = ACTIONS(1067),
    [anon_sym_AMP_GT_GT] = ACTIONS(1065),
    [anon_sym_LT_AMP] = ACTIONS(1065),
    [anon_sym_GT_AMP] = ACTIONS(1065),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_LT_LT_DASH] = ACTIONS(1065),
    [anon_sym_LT_LT_LT] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1067),
    [sym__special_character] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LT_LPAREN] = ACTIONS(1065),
    [anon_sym_GT_LPAREN] = ACTIONS(1065),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1067),
    [sym_word] = ACTIONS(1067),
    [anon_sym_LF] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1067),
  },
  [2946] = {
    [sym_string] = STATE(3465),
    [sym_simple_expansion] = STATE(3465),
    [sym_string_expansion] = STATE(3465),
    [sym_expansion] = STATE(3465),
    [sym_command_substitution] = STATE(3465),
    [sym_process_substitution] = STATE(3465),
    [anon_sym_DOLLAR] = ACTIONS(5059),
    [sym__special_character] = ACTIONS(7731),
    [anon_sym_DQUOTE] = ACTIONS(5063),
    [sym_raw_string] = ACTIONS(7731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5067),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5069),
    [anon_sym_BQUOTE] = ACTIONS(5071),
    [anon_sym_LT_LPAREN] = ACTIONS(5073),
    [anon_sym_GT_LPAREN] = ACTIONS(5073),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7731),
  },
  [2947] = {
    [aux_sym_concatenation_repeat1] = STATE(3467),
    [sym__simple_heredoc_body] = ACTIONS(1071),
    [sym__heredoc_body_beginning] = ACTIONS(1071),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(7733),
    [sym_variable_name] = ACTIONS(1071),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_fi] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [sym__special_character] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [sym_word] = ACTIONS(1075),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1075),
  },
  [2948] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(7735),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [2949] = {
    [sym__simple_heredoc_body] = ACTIONS(1089),
    [sym__heredoc_body_beginning] = ACTIONS(1089),
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(1089),
    [sym_variable_name] = ACTIONS(1089),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_fi] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1089),
    [anon_sym_PIPE_AMP] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_AMP] = ACTIONS(1089),
    [anon_sym_GT_AMP] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1089),
    [anon_sym_LT_LT_LT] = ACTIONS(1089),
    [anon_sym_DOLLAR] = ACTIONS(1091),
    [sym__special_character] = ACTIONS(1089),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1089),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1089),
    [anon_sym_GT_LPAREN] = ACTIONS(1089),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1091),
    [sym_word] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [2950] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(627),
    [anon_sym_DOLLAR] = ACTIONS(7737),
    [anon_sym_DQUOTE] = ACTIONS(7735),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [2951] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(7739),
    [sym_comment] = ACTIONS(57),
  },
  [2952] = {
    [sym_subscript] = STATE(3473),
    [sym_variable_name] = ACTIONS(7741),
    [anon_sym_DASH] = ACTIONS(7743),
    [anon_sym_DOLLAR] = ACTIONS(7743),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7745),
    [anon_sym_STAR] = ACTIONS(7747),
    [anon_sym_AT] = ACTIONS(7747),
    [anon_sym_QMARK] = ACTIONS(7747),
    [anon_sym_0] = ACTIONS(7745),
    [anon_sym__] = ACTIONS(7745),
  },
  [2953] = {
    [sym_concatenation] = STATE(3476),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3476),
    [anon_sym_RBRACE] = ACTIONS(7749),
    [anon_sym_EQ] = ACTIONS(7751),
    [anon_sym_DASH] = ACTIONS(7751),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7753),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(7755),
    [anon_sym_COLON] = ACTIONS(7751),
    [anon_sym_COLON_QMARK] = ACTIONS(7751),
    [anon_sym_COLON_DASH] = ACTIONS(7751),
    [anon_sym_PERCENT] = ACTIONS(7751),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2954] = {
    [sym_concatenation] = STATE(3479),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3479),
    [anon_sym_RBRACE] = ACTIONS(7757),
    [anon_sym_EQ] = ACTIONS(7759),
    [anon_sym_DASH] = ACTIONS(7759),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7761),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(7763),
    [anon_sym_COLON] = ACTIONS(7759),
    [anon_sym_COLON_QMARK] = ACTIONS(7759),
    [anon_sym_COLON_DASH] = ACTIONS(7759),
    [anon_sym_PERCENT] = ACTIONS(7759),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2955] = {
    [anon_sym_RPAREN] = ACTIONS(7765),
    [sym_comment] = ACTIONS(57),
  },
  [2956] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(7765),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [2957] = {
    [anon_sym_BQUOTE] = ACTIONS(7765),
    [sym_comment] = ACTIONS(57),
  },
  [2958] = {
    [anon_sym_RPAREN] = ACTIONS(7767),
    [sym_comment] = ACTIONS(57),
  },
  [2959] = {
    [sym_variable_assignment] = STATE(2959),
    [sym_subscript] = STATE(2314),
    [sym_concatenation] = STATE(2959),
    [sym_string] = STATE(2309),
    [sym_simple_expansion] = STATE(2309),
    [sym_string_expansion] = STATE(2309),
    [sym_expansion] = STATE(2309),
    [sym_command_substitution] = STATE(2309),
    [sym_process_substitution] = STATE(2309),
    [aux_sym_declaration_command_repeat1] = STATE(2959),
    [aux_sym__literal_repeat1] = STATE(2316),
    [sym__simple_heredoc_body] = ACTIONS(2206),
    [sym__heredoc_body_beginning] = ACTIONS(2206),
    [sym_file_descriptor] = ACTIONS(2206),
    [sym_variable_name] = ACTIONS(7769),
    [anon_sym_SEMI] = ACTIONS(2211),
    [anon_sym_fi] = ACTIONS(2211),
    [anon_sym_PIPE] = ACTIONS(2211),
    [anon_sym_SEMI_SEMI] = ACTIONS(2206),
    [anon_sym_PIPE_AMP] = ACTIONS(2206),
    [anon_sym_AMP_AMP] = ACTIONS(2206),
    [anon_sym_PIPE_PIPE] = ACTIONS(2206),
    [anon_sym_LT] = ACTIONS(2211),
    [anon_sym_GT] = ACTIONS(2211),
    [anon_sym_GT_GT] = ACTIONS(2206),
    [anon_sym_AMP_GT] = ACTIONS(2211),
    [anon_sym_AMP_GT_GT] = ACTIONS(2206),
    [anon_sym_LT_AMP] = ACTIONS(2206),
    [anon_sym_GT_AMP] = ACTIONS(2206),
    [anon_sym_LT_LT] = ACTIONS(2211),
    [anon_sym_LT_LT_DASH] = ACTIONS(2206),
    [anon_sym_LT_LT_LT] = ACTIONS(2206),
    [anon_sym_DOLLAR] = ACTIONS(7772),
    [sym__special_character] = ACTIONS(7775),
    [anon_sym_DQUOTE] = ACTIONS(7778),
    [sym_raw_string] = ACTIONS(7781),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7784),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7787),
    [anon_sym_BQUOTE] = ACTIONS(7790),
    [anon_sym_LT_LPAREN] = ACTIONS(7793),
    [anon_sym_GT_LPAREN] = ACTIONS(7793),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7796),
    [sym_word] = ACTIONS(7799),
    [anon_sym_LF] = ACTIONS(2206),
    [anon_sym_AMP] = ACTIONS(2211),
  },
  [2960] = {
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym_variable_name] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_fi] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(339),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [2961] = {
    [aux_sym__literal_repeat1] = STATE(2961),
    [sym__simple_heredoc_body] = ACTIONS(1373),
    [sym__heredoc_body_beginning] = ACTIONS(1373),
    [sym_file_descriptor] = ACTIONS(1373),
    [sym_variable_name] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_fi] = ACTIONS(1375),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE_AMP] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_LT_LT_DASH] = ACTIONS(1373),
    [anon_sym_LT_LT_LT] = ACTIONS(1373),
    [anon_sym_DOLLAR] = ACTIONS(1375),
    [sym__special_character] = ACTIONS(7802),
    [anon_sym_DQUOTE] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1373),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [anon_sym_LT_LPAREN] = ACTIONS(1373),
    [anon_sym_GT_LPAREN] = ACTIONS(1373),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1375),
    [sym_word] = ACTIONS(1375),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
  },
  [2962] = {
    [sym__simple_heredoc_body] = ACTIONS(1057),
    [sym__heredoc_body_beginning] = ACTIONS(1057),
    [sym_file_descriptor] = ACTIONS(1057),
    [sym__concat] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_fi] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_PIPE_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_AMP] = ACTIONS(1057),
    [anon_sym_GT_AMP] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_LT] = ACTIONS(1057),
    [anon_sym_DOLLAR] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [sym_raw_string] = ACTIONS(1057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1057),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1057),
    [anon_sym_BQUOTE] = ACTIONS(1057),
    [anon_sym_LT_LPAREN] = ACTIONS(1057),
    [anon_sym_GT_LPAREN] = ACTIONS(1057),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1059),
    [sym_word] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [2963] = {
    [sym__simple_heredoc_body] = ACTIONS(1061),
    [sym__heredoc_body_beginning] = ACTIONS(1061),
    [sym_file_descriptor] = ACTIONS(1061),
    [sym__concat] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(1063),
    [anon_sym_fi] = ACTIONS(1063),
    [anon_sym_PIPE] = ACTIONS(1063),
    [anon_sym_SEMI_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE_AMP] = ACTIONS(1061),
    [anon_sym_AMP_AMP] = ACTIONS(1061),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1063),
    [anon_sym_GT_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT_GT] = ACTIONS(1061),
    [anon_sym_LT_AMP] = ACTIONS(1061),
    [anon_sym_GT_AMP] = ACTIONS(1061),
    [anon_sym_LT_LT] = ACTIONS(1063),
    [anon_sym_LT_LT_DASH] = ACTIONS(1061),
    [anon_sym_LT_LT_LT] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1061),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1061),
    [anon_sym_LT_LPAREN] = ACTIONS(1061),
    [anon_sym_GT_LPAREN] = ACTIONS(1061),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1063),
    [sym_word] = ACTIONS(1063),
    [anon_sym_LF] = ACTIONS(1061),
    [anon_sym_AMP] = ACTIONS(1063),
  },
  [2964] = {
    [sym__simple_heredoc_body] = ACTIONS(1065),
    [sym__heredoc_body_beginning] = ACTIONS(1065),
    [sym_file_descriptor] = ACTIONS(1065),
    [sym__concat] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_fi] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1067),
    [anon_sym_SEMI_SEMI] = ACTIONS(1065),
    [anon_sym_PIPE_AMP] = ACTIONS(1065),
    [anon_sym_AMP_AMP] = ACTIONS(1065),
    [anon_sym_PIPE_PIPE] = ACTIONS(1065),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_GT] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT] = ACTIONS(1067),
    [anon_sym_AMP_GT_GT] = ACTIONS(1065),
    [anon_sym_LT_AMP] = ACTIONS(1065),
    [anon_sym_GT_AMP] = ACTIONS(1065),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_LT_LT_DASH] = ACTIONS(1065),
    [anon_sym_LT_LT_LT] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1067),
    [sym__special_character] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LT_LPAREN] = ACTIONS(1065),
    [anon_sym_GT_LPAREN] = ACTIONS(1065),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1067),
    [sym_word] = ACTIONS(1067),
    [anon_sym_LF] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1067),
  },
  [2965] = {
    [sym_string] = STATE(3482),
    [sym_simple_expansion] = STATE(3482),
    [sym_string_expansion] = STATE(3482),
    [sym_expansion] = STATE(3482),
    [sym_command_substitution] = STATE(3482),
    [sym_process_substitution] = STATE(3482),
    [anon_sym_DOLLAR] = ACTIONS(5079),
    [sym__special_character] = ACTIONS(7805),
    [anon_sym_DQUOTE] = ACTIONS(5083),
    [sym_raw_string] = ACTIONS(7805),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5089),
    [anon_sym_BQUOTE] = ACTIONS(5091),
    [anon_sym_LT_LPAREN] = ACTIONS(5093),
    [anon_sym_GT_LPAREN] = ACTIONS(5093),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7805),
  },
  [2966] = {
    [aux_sym_concatenation_repeat1] = STATE(3484),
    [sym__simple_heredoc_body] = ACTIONS(1071),
    [sym__heredoc_body_beginning] = ACTIONS(1071),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(7807),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_fi] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [sym__special_character] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [sym_word] = ACTIONS(1075),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1075),
  },
  [2967] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(7809),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [2968] = {
    [sym__simple_heredoc_body] = ACTIONS(1089),
    [sym__heredoc_body_beginning] = ACTIONS(1089),
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(1089),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_fi] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1089),
    [anon_sym_PIPE_AMP] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_AMP] = ACTIONS(1089),
    [anon_sym_GT_AMP] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1089),
    [anon_sym_LT_LT_LT] = ACTIONS(1089),
    [anon_sym_DOLLAR] = ACTIONS(1091),
    [sym__special_character] = ACTIONS(1089),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1089),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1089),
    [anon_sym_GT_LPAREN] = ACTIONS(1089),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1091),
    [sym_word] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [2969] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(627),
    [anon_sym_DOLLAR] = ACTIONS(7811),
    [anon_sym_DQUOTE] = ACTIONS(7809),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [2970] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(7813),
    [sym_comment] = ACTIONS(57),
  },
  [2971] = {
    [sym_subscript] = STATE(3490),
    [sym_variable_name] = ACTIONS(7815),
    [anon_sym_DASH] = ACTIONS(7817),
    [anon_sym_DOLLAR] = ACTIONS(7817),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7819),
    [anon_sym_STAR] = ACTIONS(7821),
    [anon_sym_AT] = ACTIONS(7821),
    [anon_sym_QMARK] = ACTIONS(7821),
    [anon_sym_0] = ACTIONS(7819),
    [anon_sym__] = ACTIONS(7819),
  },
  [2972] = {
    [sym_concatenation] = STATE(3493),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3493),
    [anon_sym_RBRACE] = ACTIONS(7823),
    [anon_sym_EQ] = ACTIONS(7825),
    [anon_sym_DASH] = ACTIONS(7825),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7827),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(7829),
    [anon_sym_COLON] = ACTIONS(7825),
    [anon_sym_COLON_QMARK] = ACTIONS(7825),
    [anon_sym_COLON_DASH] = ACTIONS(7825),
    [anon_sym_PERCENT] = ACTIONS(7825),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2973] = {
    [sym_concatenation] = STATE(3496),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3496),
    [anon_sym_RBRACE] = ACTIONS(7831),
    [anon_sym_EQ] = ACTIONS(7833),
    [anon_sym_DASH] = ACTIONS(7833),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7835),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(7837),
    [anon_sym_COLON] = ACTIONS(7833),
    [anon_sym_COLON_QMARK] = ACTIONS(7833),
    [anon_sym_COLON_DASH] = ACTIONS(7833),
    [anon_sym_PERCENT] = ACTIONS(7833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2974] = {
    [anon_sym_RPAREN] = ACTIONS(7839),
    [sym_comment] = ACTIONS(57),
  },
  [2975] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(7839),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [2976] = {
    [anon_sym_BQUOTE] = ACTIONS(7839),
    [sym_comment] = ACTIONS(57),
  },
  [2977] = {
    [anon_sym_RPAREN] = ACTIONS(7841),
    [sym_comment] = ACTIONS(57),
  },
  [2978] = {
    [sym_concatenation] = STATE(2978),
    [sym_string] = STATE(2320),
    [sym_simple_expansion] = STATE(2320),
    [sym_string_expansion] = STATE(2320),
    [sym_expansion] = STATE(2320),
    [sym_command_substitution] = STATE(2320),
    [sym_process_substitution] = STATE(2320),
    [aux_sym_unset_command_repeat1] = STATE(2978),
    [aux_sym__literal_repeat1] = STATE(2326),
    [sym__simple_heredoc_body] = ACTIONS(2284),
    [sym__heredoc_body_beginning] = ACTIONS(2284),
    [sym_file_descriptor] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym_fi] = ACTIONS(2286),
    [anon_sym_PIPE] = ACTIONS(2286),
    [anon_sym_SEMI_SEMI] = ACTIONS(2284),
    [anon_sym_PIPE_AMP] = ACTIONS(2284),
    [anon_sym_AMP_AMP] = ACTIONS(2284),
    [anon_sym_PIPE_PIPE] = ACTIONS(2284),
    [anon_sym_LT] = ACTIONS(2286),
    [anon_sym_GT] = ACTIONS(2286),
    [anon_sym_GT_GT] = ACTIONS(2284),
    [anon_sym_AMP_GT] = ACTIONS(2286),
    [anon_sym_AMP_GT_GT] = ACTIONS(2284),
    [anon_sym_LT_AMP] = ACTIONS(2284),
    [anon_sym_GT_AMP] = ACTIONS(2284),
    [anon_sym_LT_LT] = ACTIONS(2286),
    [anon_sym_LT_LT_DASH] = ACTIONS(2284),
    [anon_sym_LT_LT_LT] = ACTIONS(2284),
    [anon_sym_DOLLAR] = ACTIONS(7843),
    [sym__special_character] = ACTIONS(7846),
    [anon_sym_DQUOTE] = ACTIONS(7849),
    [sym_raw_string] = ACTIONS(7852),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7855),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7858),
    [anon_sym_BQUOTE] = ACTIONS(7861),
    [anon_sym_LT_LPAREN] = ACTIONS(7864),
    [anon_sym_GT_LPAREN] = ACTIONS(7864),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7867),
    [sym_word] = ACTIONS(7870),
    [anon_sym_LF] = ACTIONS(2284),
    [anon_sym_AMP] = ACTIONS(2286),
  },
  [2979] = {
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_fi] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(339),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [2980] = {
    [aux_sym__literal_repeat1] = STATE(2980),
    [sym__simple_heredoc_body] = ACTIONS(1373),
    [sym__heredoc_body_beginning] = ACTIONS(1373),
    [sym_file_descriptor] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_fi] = ACTIONS(1375),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE_AMP] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_LT_LT_DASH] = ACTIONS(1373),
    [anon_sym_LT_LT_LT] = ACTIONS(1373),
    [anon_sym_DOLLAR] = ACTIONS(1375),
    [sym__special_character] = ACTIONS(7873),
    [anon_sym_DQUOTE] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1373),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [anon_sym_LT_LPAREN] = ACTIONS(1373),
    [anon_sym_GT_LPAREN] = ACTIONS(1373),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1375),
    [sym_word] = ACTIONS(1375),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
  },
  [2981] = {
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_fi] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_EQ_TILDE] = ACTIONS(2364),
    [anon_sym_EQ_EQ] = ACTIONS(2364),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [2982] = {
    [sym_string] = STATE(2981),
    [sym_simple_expansion] = STATE(2981),
    [sym_string_expansion] = STATE(2981),
    [sym_expansion] = STATE(2981),
    [sym_command_substitution] = STATE(2981),
    [sym_process_substitution] = STATE(2981),
    [anon_sym_DOLLAR] = ACTIONS(7876),
    [sym__special_character] = ACTIONS(6543),
    [anon_sym_DQUOTE] = ACTIONS(3395),
    [sym_raw_string] = ACTIONS(6543),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3401),
    [anon_sym_BQUOTE] = ACTIONS(3403),
    [anon_sym_LT_LPAREN] = ACTIONS(3405),
    [anon_sym_GT_LPAREN] = ACTIONS(3405),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6543),
  },
  [2983] = {
    [aux_sym_concatenation_repeat1] = STATE(2983),
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(7878),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_fi] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_EQ_TILDE] = ACTIONS(2364),
    [anon_sym_EQ_EQ] = ACTIONS(2364),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [2984] = {
    [sym__simple_heredoc_body] = ACTIONS(2371),
    [sym__heredoc_body_beginning] = ACTIONS(2371),
    [sym_file_descriptor] = ACTIONS(2371),
    [sym__concat] = ACTIONS(2371),
    [anon_sym_SEMI] = ACTIONS(2373),
    [anon_sym_fi] = ACTIONS(2373),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_SEMI_SEMI] = ACTIONS(2371),
    [anon_sym_PIPE_AMP] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_EQ_TILDE] = ACTIONS(2373),
    [anon_sym_EQ_EQ] = ACTIONS(2373),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_GT_GT] = ACTIONS(2371),
    [anon_sym_AMP_GT] = ACTIONS(2373),
    [anon_sym_AMP_GT_GT] = ACTIONS(2371),
    [anon_sym_LT_AMP] = ACTIONS(2371),
    [anon_sym_GT_AMP] = ACTIONS(2371),
    [anon_sym_LT_LT] = ACTIONS(2373),
    [anon_sym_LT_LT_DASH] = ACTIONS(2371),
    [anon_sym_LT_LT_LT] = ACTIONS(2371),
    [anon_sym_DOLLAR] = ACTIONS(2373),
    [sym__special_character] = ACTIONS(2371),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [sym_raw_string] = ACTIONS(2371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2371),
    [anon_sym_BQUOTE] = ACTIONS(2371),
    [anon_sym_LT_LPAREN] = ACTIONS(2371),
    [anon_sym_GT_LPAREN] = ACTIONS(2371),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2373),
    [anon_sym_LF] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
  },
  [2985] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(7881),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [2986] = {
    [sym_concatenation] = STATE(3503),
    [sym_string] = STATE(3502),
    [sym_simple_expansion] = STATE(3502),
    [sym_string_expansion] = STATE(3502),
    [sym_expansion] = STATE(3502),
    [sym_command_substitution] = STATE(3502),
    [sym_process_substitution] = STATE(3502),
    [aux_sym__literal_repeat1] = STATE(3504),
    [anon_sym_RBRACE] = ACTIONS(7883),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(7885),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7885),
  },
  [2987] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(7887),
    [sym_comment] = ACTIONS(57),
  },
  [2988] = {
    [sym_concatenation] = STATE(3508),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3508),
    [anon_sym_RBRACE] = ACTIONS(7889),
    [anon_sym_EQ] = ACTIONS(7891),
    [anon_sym_DASH] = ACTIONS(7891),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7893),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(7895),
    [anon_sym_COLON] = ACTIONS(7891),
    [anon_sym_COLON_QMARK] = ACTIONS(7891),
    [anon_sym_COLON_DASH] = ACTIONS(7891),
    [anon_sym_PERCENT] = ACTIONS(7891),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2989] = {
    [sym_concatenation] = STATE(3510),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3510),
    [anon_sym_RBRACE] = ACTIONS(7883),
    [anon_sym_EQ] = ACTIONS(7897),
    [anon_sym_DASH] = ACTIONS(7897),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7899),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(7901),
    [anon_sym_COLON] = ACTIONS(7897),
    [anon_sym_COLON_QMARK] = ACTIONS(7897),
    [anon_sym_COLON_DASH] = ACTIONS(7897),
    [anon_sym_PERCENT] = ACTIONS(7897),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2990] = {
    [sym__simple_heredoc_body] = ACTIONS(2462),
    [sym__heredoc_body_beginning] = ACTIONS(2462),
    [sym_file_descriptor] = ACTIONS(2462),
    [sym__concat] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_fi] = ACTIONS(2464),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_SEMI_SEMI] = ACTIONS(2462),
    [anon_sym_PIPE_AMP] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_EQ_TILDE] = ACTIONS(2464),
    [anon_sym_EQ_EQ] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_GT_GT] = ACTIONS(2462),
    [anon_sym_AMP_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT_GT] = ACTIONS(2462),
    [anon_sym_LT_AMP] = ACTIONS(2462),
    [anon_sym_GT_AMP] = ACTIONS(2462),
    [anon_sym_LT_LT] = ACTIONS(2464),
    [anon_sym_LT_LT_DASH] = ACTIONS(2462),
    [anon_sym_LT_LT_LT] = ACTIONS(2462),
    [anon_sym_DOLLAR] = ACTIONS(2464),
    [sym__special_character] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [sym_raw_string] = ACTIONS(2462),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2462),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2462),
    [anon_sym_BQUOTE] = ACTIONS(2462),
    [anon_sym_LT_LPAREN] = ACTIONS(2462),
    [anon_sym_GT_LPAREN] = ACTIONS(2462),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2464),
    [anon_sym_LF] = ACTIONS(2462),
    [anon_sym_AMP] = ACTIONS(2464),
  },
  [2991] = {
    [sym_concatenation] = STATE(3513),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3513),
    [sym_regex] = ACTIONS(7903),
    [anon_sym_RBRACE] = ACTIONS(7905),
    [anon_sym_EQ] = ACTIONS(7907),
    [anon_sym_DASH] = ACTIONS(7907),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7909),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7907),
    [anon_sym_COLON_QMARK] = ACTIONS(7907),
    [anon_sym_COLON_DASH] = ACTIONS(7907),
    [anon_sym_PERCENT] = ACTIONS(7907),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2992] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7905),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2993] = {
    [sym__simple_heredoc_body] = ACTIONS(2512),
    [sym__heredoc_body_beginning] = ACTIONS(2512),
    [sym_file_descriptor] = ACTIONS(2512),
    [sym__concat] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2514),
    [anon_sym_fi] = ACTIONS(2514),
    [anon_sym_PIPE] = ACTIONS(2514),
    [anon_sym_SEMI_SEMI] = ACTIONS(2512),
    [anon_sym_PIPE_AMP] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE_PIPE] = ACTIONS(2512),
    [anon_sym_EQ_TILDE] = ACTIONS(2514),
    [anon_sym_EQ_EQ] = ACTIONS(2514),
    [anon_sym_LT] = ACTIONS(2514),
    [anon_sym_GT] = ACTIONS(2514),
    [anon_sym_GT_GT] = ACTIONS(2512),
    [anon_sym_AMP_GT] = ACTIONS(2514),
    [anon_sym_AMP_GT_GT] = ACTIONS(2512),
    [anon_sym_LT_AMP] = ACTIONS(2512),
    [anon_sym_GT_AMP] = ACTIONS(2512),
    [anon_sym_LT_LT] = ACTIONS(2514),
    [anon_sym_LT_LT_DASH] = ACTIONS(2512),
    [anon_sym_LT_LT_LT] = ACTIONS(2512),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [sym__special_character] = ACTIONS(2512),
    [anon_sym_DQUOTE] = ACTIONS(2512),
    [sym_raw_string] = ACTIONS(2512),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2512),
    [anon_sym_BQUOTE] = ACTIONS(2512),
    [anon_sym_LT_LPAREN] = ACTIONS(2512),
    [anon_sym_GT_LPAREN] = ACTIONS(2512),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2514),
    [anon_sym_LF] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2514),
  },
  [2994] = {
    [sym_concatenation] = STATE(3510),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3510),
    [sym_regex] = ACTIONS(7911),
    [anon_sym_RBRACE] = ACTIONS(7883),
    [anon_sym_EQ] = ACTIONS(7897),
    [anon_sym_DASH] = ACTIONS(7897),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7899),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7897),
    [anon_sym_COLON_QMARK] = ACTIONS(7897),
    [anon_sym_COLON_DASH] = ACTIONS(7897),
    [anon_sym_PERCENT] = ACTIONS(7897),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2995] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7883),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [2996] = {
    [sym__simple_heredoc_body] = ACTIONS(2520),
    [sym__heredoc_body_beginning] = ACTIONS(2520),
    [sym_file_descriptor] = ACTIONS(2520),
    [sym__concat] = ACTIONS(2520),
    [anon_sym_SEMI] = ACTIONS(2522),
    [anon_sym_fi] = ACTIONS(2522),
    [anon_sym_PIPE] = ACTIONS(2522),
    [anon_sym_SEMI_SEMI] = ACTIONS(2520),
    [anon_sym_PIPE_AMP] = ACTIONS(2520),
    [anon_sym_AMP_AMP] = ACTIONS(2520),
    [anon_sym_PIPE_PIPE] = ACTIONS(2520),
    [anon_sym_EQ_TILDE] = ACTIONS(2522),
    [anon_sym_EQ_EQ] = ACTIONS(2522),
    [anon_sym_LT] = ACTIONS(2522),
    [anon_sym_GT] = ACTIONS(2522),
    [anon_sym_GT_GT] = ACTIONS(2520),
    [anon_sym_AMP_GT] = ACTIONS(2522),
    [anon_sym_AMP_GT_GT] = ACTIONS(2520),
    [anon_sym_LT_AMP] = ACTIONS(2520),
    [anon_sym_GT_AMP] = ACTIONS(2520),
    [anon_sym_LT_LT] = ACTIONS(2522),
    [anon_sym_LT_LT_DASH] = ACTIONS(2520),
    [anon_sym_LT_LT_LT] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(2522),
    [sym__special_character] = ACTIONS(2520),
    [anon_sym_DQUOTE] = ACTIONS(2520),
    [sym_raw_string] = ACTIONS(2520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2520),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2520),
    [anon_sym_BQUOTE] = ACTIONS(2520),
    [anon_sym_LT_LPAREN] = ACTIONS(2520),
    [anon_sym_GT_LPAREN] = ACTIONS(2520),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2522),
    [anon_sym_LF] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2522),
  },
  [2997] = {
    [sym__simple_heredoc_body] = ACTIONS(2554),
    [sym__heredoc_body_beginning] = ACTIONS(2554),
    [sym_file_descriptor] = ACTIONS(2554),
    [sym__concat] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(2556),
    [anon_sym_fi] = ACTIONS(2556),
    [anon_sym_PIPE] = ACTIONS(2556),
    [anon_sym_SEMI_SEMI] = ACTIONS(2554),
    [anon_sym_PIPE_AMP] = ACTIONS(2554),
    [anon_sym_AMP_AMP] = ACTIONS(2554),
    [anon_sym_PIPE_PIPE] = ACTIONS(2554),
    [anon_sym_EQ_TILDE] = ACTIONS(2556),
    [anon_sym_EQ_EQ] = ACTIONS(2556),
    [anon_sym_LT] = ACTIONS(2556),
    [anon_sym_GT] = ACTIONS(2556),
    [anon_sym_GT_GT] = ACTIONS(2554),
    [anon_sym_AMP_GT] = ACTIONS(2556),
    [anon_sym_AMP_GT_GT] = ACTIONS(2554),
    [anon_sym_LT_AMP] = ACTIONS(2554),
    [anon_sym_GT_AMP] = ACTIONS(2554),
    [anon_sym_LT_LT] = ACTIONS(2556),
    [anon_sym_LT_LT_DASH] = ACTIONS(2554),
    [anon_sym_LT_LT_LT] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2556),
    [sym__special_character] = ACTIONS(2554),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2554),
    [anon_sym_BQUOTE] = ACTIONS(2554),
    [anon_sym_LT_LPAREN] = ACTIONS(2554),
    [anon_sym_GT_LPAREN] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2556),
    [anon_sym_LF] = ACTIONS(2554),
    [anon_sym_AMP] = ACTIONS(2556),
  },
  [2998] = {
    [sym_concatenation] = STATE(1328),
    [sym_string] = STATE(3515),
    [sym_simple_expansion] = STATE(3515),
    [sym_string_expansion] = STATE(3515),
    [sym_expansion] = STATE(3515),
    [sym_command_substitution] = STATE(3515),
    [sym_process_substitution] = STATE(3515),
    [aux_sym__literal_repeat1] = STATE(3516),
    [anon_sym_DOLLAR] = ACTIONS(4998),
    [sym__special_character] = ACTIONS(6585),
    [anon_sym_DQUOTE] = ACTIONS(5002),
    [sym_raw_string] = ACTIONS(7913),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5006),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5008),
    [anon_sym_BQUOTE] = ACTIONS(5010),
    [anon_sym_LT_LPAREN] = ACTIONS(5012),
    [anon_sym_GT_LPAREN] = ACTIONS(5012),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7913),
  },
  [2999] = {
    [sym_file_redirect] = STATE(2350),
    [sym_heredoc_redirect] = STATE(2350),
    [sym_herestring_redirect] = STATE(2350),
    [aux_sym_redirected_statement_repeat1] = STATE(2350),
    [sym__simple_heredoc_body] = ACTIONS(2584),
    [sym__heredoc_body_beginning] = ACTIONS(2584),
    [sym_file_descriptor] = ACTIONS(2584),
    [anon_sym_SEMI] = ACTIONS(2586),
    [anon_sym_fi] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2586),
    [anon_sym_SEMI_SEMI] = ACTIONS(2584),
    [anon_sym_PIPE_AMP] = ACTIONS(2584),
    [anon_sym_AMP_AMP] = ACTIONS(2584),
    [anon_sym_PIPE_PIPE] = ACTIONS(2584),
    [anon_sym_LT] = ACTIONS(2586),
    [anon_sym_GT] = ACTIONS(2586),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT] = ACTIONS(2586),
    [anon_sym_AMP_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_AMP] = ACTIONS(2584),
    [anon_sym_GT_AMP] = ACTIONS(2584),
    [anon_sym_LT_LT] = ACTIONS(2586),
    [anon_sym_LT_LT_DASH] = ACTIONS(2584),
    [anon_sym_LT_LT_LT] = ACTIONS(2584),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2584),
    [anon_sym_AMP] = ACTIONS(2586),
  },
  [3000] = {
    [sym_file_redirect] = STATE(2350),
    [sym_heredoc_redirect] = STATE(2350),
    [sym_herestring_redirect] = STATE(2350),
    [aux_sym_redirected_statement_repeat1] = STATE(2350),
    [sym__simple_heredoc_body] = ACTIONS(2584),
    [sym__heredoc_body_beginning] = ACTIONS(2584),
    [sym_file_descriptor] = ACTIONS(2584),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2586),
    [anon_sym_fi] = ACTIONS(2586),
    [anon_sym_PIPE] = ACTIONS(2586),
    [anon_sym_SEMI_SEMI] = ACTIONS(2584),
    [anon_sym_PIPE_AMP] = ACTIONS(2584),
    [anon_sym_AMP_AMP] = ACTIONS(2584),
    [anon_sym_PIPE_PIPE] = ACTIONS(2584),
    [anon_sym_LT] = ACTIONS(2586),
    [anon_sym_GT] = ACTIONS(2586),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT] = ACTIONS(2586),
    [anon_sym_AMP_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_AMP] = ACTIONS(2584),
    [anon_sym_GT_AMP] = ACTIONS(2584),
    [anon_sym_LT_LT] = ACTIONS(2586),
    [anon_sym_LT_LT_DASH] = ACTIONS(2584),
    [anon_sym_LT_LT_LT] = ACTIONS(2584),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2584),
    [anon_sym_AMP] = ACTIONS(2586),
  },
  [3001] = {
    [sym_file_redirect] = STATE(2350),
    [sym_heredoc_redirect] = STATE(2350),
    [sym_herestring_redirect] = STATE(2350),
    [aux_sym_redirected_statement_repeat1] = STATE(2350),
    [sym__simple_heredoc_body] = ACTIONS(2588),
    [sym__heredoc_body_beginning] = ACTIONS(2588),
    [sym_file_descriptor] = ACTIONS(2588),
    [anon_sym_SEMI] = ACTIONS(2590),
    [anon_sym_fi] = ACTIONS(2588),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_SEMI_SEMI] = ACTIONS(2588),
    [anon_sym_PIPE_AMP] = ACTIONS(5133),
    [anon_sym_AMP_AMP] = ACTIONS(2588),
    [anon_sym_PIPE_PIPE] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(2590),
    [anon_sym_GT] = ACTIONS(2590),
    [anon_sym_GT_GT] = ACTIONS(2588),
    [anon_sym_AMP_GT] = ACTIONS(2590),
    [anon_sym_AMP_GT_GT] = ACTIONS(2588),
    [anon_sym_LT_AMP] = ACTIONS(2588),
    [anon_sym_GT_AMP] = ACTIONS(2588),
    [anon_sym_LT_LT] = ACTIONS(2590),
    [anon_sym_LT_LT_DASH] = ACTIONS(2588),
    [anon_sym_LT_LT_LT] = ACTIONS(2588),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2588),
    [anon_sym_AMP] = ACTIONS(2590),
  },
  [3002] = {
    [sym_file_redirect] = STATE(2350),
    [sym_heredoc_redirect] = STATE(2350),
    [sym_herestring_redirect] = STATE(2350),
    [aux_sym_redirected_statement_repeat1] = STATE(2350),
    [sym__simple_heredoc_body] = ACTIONS(2588),
    [sym__heredoc_body_beginning] = ACTIONS(2588),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2590),
    [anon_sym_fi] = ACTIONS(2590),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_SEMI_SEMI] = ACTIONS(2588),
    [anon_sym_PIPE_AMP] = ACTIONS(5133),
    [anon_sym_AMP_AMP] = ACTIONS(2588),
    [anon_sym_PIPE_PIPE] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(2590),
    [anon_sym_LT_LT_DASH] = ACTIONS(2588),
    [anon_sym_LT_LT_LT] = ACTIONS(2588),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2588),
    [anon_sym_AMP] = ACTIONS(2590),
  },
  [3003] = {
    [aux_sym_concatenation_repeat1] = STATE(3517),
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(6367),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_fi] = ACTIONS(335),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [sym__special_character] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [3004] = {
    [aux_sym_concatenation_repeat1] = STATE(3517),
    [sym__simple_heredoc_body] = ACTIONS(1037),
    [sym__heredoc_body_beginning] = ACTIONS(1037),
    [sym_file_descriptor] = ACTIONS(1037),
    [sym__concat] = ACTIONS(6367),
    [anon_sym_SEMI] = ACTIONS(1039),
    [anon_sym_fi] = ACTIONS(1037),
    [anon_sym_PIPE] = ACTIONS(1039),
    [anon_sym_SEMI_SEMI] = ACTIONS(1037),
    [anon_sym_PIPE_AMP] = ACTIONS(1037),
    [anon_sym_AMP_AMP] = ACTIONS(1037),
    [anon_sym_PIPE_PIPE] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1039),
    [anon_sym_GT] = ACTIONS(1039),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_AMP_GT] = ACTIONS(1039),
    [anon_sym_AMP_GT_GT] = ACTIONS(1037),
    [anon_sym_LT_AMP] = ACTIONS(1037),
    [anon_sym_GT_AMP] = ACTIONS(1037),
    [anon_sym_LT_LT] = ACTIONS(1039),
    [anon_sym_LT_LT_DASH] = ACTIONS(1037),
    [anon_sym_LT_LT_LT] = ACTIONS(1037),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1037),
    [anon_sym_AMP] = ACTIONS(1039),
  },
  [3005] = {
    [aux_sym__literal_repeat1] = STATE(3518),
    [sym__simple_heredoc_body] = ACTIONS(1051),
    [sym__heredoc_body_beginning] = ACTIONS(1051),
    [sym_file_descriptor] = ACTIONS(1051),
    [anon_sym_SEMI] = ACTIONS(1053),
    [anon_sym_fi] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1053),
    [anon_sym_SEMI_SEMI] = ACTIONS(1051),
    [anon_sym_PIPE_AMP] = ACTIONS(1051),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_PIPE_PIPE] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT_GT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1051),
    [anon_sym_GT_AMP] = ACTIONS(1051),
    [anon_sym_LT_LT] = ACTIONS(1053),
    [anon_sym_LT_LT_DASH] = ACTIONS(1051),
    [anon_sym_LT_LT_LT] = ACTIONS(1051),
    [sym__special_character] = ACTIONS(6383),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1051),
    [anon_sym_AMP] = ACTIONS(1053),
  },
  [3006] = {
    [aux_sym_concatenation_repeat1] = STATE(3517),
    [sym__simple_heredoc_body] = ACTIONS(2596),
    [sym__heredoc_body_beginning] = ACTIONS(2596),
    [sym_file_descriptor] = ACTIONS(2596),
    [sym__concat] = ACTIONS(6367),
    [anon_sym_SEMI] = ACTIONS(2598),
    [anon_sym_fi] = ACTIONS(2596),
    [anon_sym_PIPE] = ACTIONS(2598),
    [anon_sym_SEMI_SEMI] = ACTIONS(2596),
    [anon_sym_PIPE_AMP] = ACTIONS(2596),
    [anon_sym_AMP_AMP] = ACTIONS(2596),
    [anon_sym_PIPE_PIPE] = ACTIONS(2596),
    [anon_sym_LT] = ACTIONS(2598),
    [anon_sym_GT] = ACTIONS(2598),
    [anon_sym_GT_GT] = ACTIONS(2596),
    [anon_sym_AMP_GT] = ACTIONS(2598),
    [anon_sym_AMP_GT_GT] = ACTIONS(2596),
    [anon_sym_LT_AMP] = ACTIONS(2596),
    [anon_sym_GT_AMP] = ACTIONS(2596),
    [anon_sym_LT_LT] = ACTIONS(2598),
    [anon_sym_LT_LT_DASH] = ACTIONS(2596),
    [anon_sym_LT_LT_LT] = ACTIONS(2596),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2596),
    [anon_sym_AMP] = ACTIONS(2598),
  },
  [3007] = {
    [aux_sym__literal_repeat1] = STATE(3518),
    [sym__simple_heredoc_body] = ACTIONS(2600),
    [sym__heredoc_body_beginning] = ACTIONS(2600),
    [sym_file_descriptor] = ACTIONS(2600),
    [anon_sym_SEMI] = ACTIONS(2602),
    [anon_sym_fi] = ACTIONS(2600),
    [anon_sym_PIPE] = ACTIONS(2602),
    [anon_sym_SEMI_SEMI] = ACTIONS(2600),
    [anon_sym_PIPE_AMP] = ACTIONS(2600),
    [anon_sym_AMP_AMP] = ACTIONS(2600),
    [anon_sym_PIPE_PIPE] = ACTIONS(2600),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_GT_GT] = ACTIONS(2600),
    [anon_sym_AMP_GT] = ACTIONS(2602),
    [anon_sym_AMP_GT_GT] = ACTIONS(2600),
    [anon_sym_LT_AMP] = ACTIONS(2600),
    [anon_sym_GT_AMP] = ACTIONS(2600),
    [anon_sym_LT_LT] = ACTIONS(2602),
    [anon_sym_LT_LT_DASH] = ACTIONS(2600),
    [anon_sym_LT_LT_LT] = ACTIONS(2600),
    [sym__special_character] = ACTIONS(6383),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2600),
    [anon_sym_AMP] = ACTIONS(2602),
  },
  [3008] = {
    [sym_file_descriptor] = ACTIONS(2604),
    [sym_variable_name] = ACTIONS(2604),
    [anon_sym_for] = ACTIONS(2608),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2608),
    [anon_sym_if] = ACTIONS(2608),
    [anon_sym_fi] = ACTIONS(6385),
    [anon_sym_case] = ACTIONS(2608),
    [anon_sym_function] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(2608),
    [anon_sym_LBRACE] = ACTIONS(2604),
    [anon_sym_BANG] = ACTIONS(2608),
    [anon_sym_LBRACK] = ACTIONS(2608),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2604),
    [anon_sym_declare] = ACTIONS(2608),
    [anon_sym_typeset] = ACTIONS(2608),
    [anon_sym_export] = ACTIONS(2608),
    [anon_sym_readonly] = ACTIONS(2608),
    [anon_sym_local] = ACTIONS(2608),
    [anon_sym_unset] = ACTIONS(2608),
    [anon_sym_unsetenv] = ACTIONS(2608),
    [anon_sym_LT] = ACTIONS(2608),
    [anon_sym_GT] = ACTIONS(2608),
    [anon_sym_GT_GT] = ACTIONS(2604),
    [anon_sym_AMP_GT] = ACTIONS(2608),
    [anon_sym_AMP_GT_GT] = ACTIONS(2604),
    [anon_sym_LT_AMP] = ACTIONS(2604),
    [anon_sym_GT_AMP] = ACTIONS(2604),
    [anon_sym_DOLLAR] = ACTIONS(2608),
    [sym__special_character] = ACTIONS(2608),
    [anon_sym_DQUOTE] = ACTIONS(2604),
    [sym_raw_string] = ACTIONS(2604),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2604),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2604),
    [anon_sym_BQUOTE] = ACTIONS(2604),
    [anon_sym_LT_LPAREN] = ACTIONS(2604),
    [anon_sym_GT_LPAREN] = ACTIONS(2604),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2608),
  },
  [3009] = {
    [sym_file_redirect] = STATE(3009),
    [sym_heredoc_redirect] = STATE(3009),
    [sym_herestring_redirect] = STATE(3009),
    [aux_sym_redirected_statement_repeat1] = STATE(3009),
    [sym__simple_heredoc_body] = ACTIONS(2610),
    [sym__heredoc_body_beginning] = ACTIONS(2610),
    [sym_file_descriptor] = ACTIONS(7915),
    [anon_sym_SEMI] = ACTIONS(2615),
    [anon_sym_fi] = ACTIONS(2610),
    [anon_sym_PIPE] = ACTIONS(2615),
    [anon_sym_SEMI_SEMI] = ACTIONS(2610),
    [anon_sym_PIPE_AMP] = ACTIONS(2610),
    [anon_sym_AMP_AMP] = ACTIONS(2610),
    [anon_sym_PIPE_PIPE] = ACTIONS(2610),
    [anon_sym_LT] = ACTIONS(7918),
    [anon_sym_GT] = ACTIONS(7918),
    [anon_sym_GT_GT] = ACTIONS(7921),
    [anon_sym_AMP_GT] = ACTIONS(7918),
    [anon_sym_AMP_GT_GT] = ACTIONS(7921),
    [anon_sym_LT_AMP] = ACTIONS(7921),
    [anon_sym_GT_AMP] = ACTIONS(7921),
    [anon_sym_LT_LT] = ACTIONS(2623),
    [anon_sym_LT_LT_DASH] = ACTIONS(2626),
    [anon_sym_LT_LT_LT] = ACTIONS(7924),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2610),
    [anon_sym_AMP] = ACTIONS(2615),
  },
  [3010] = {
    [sym__simple_heredoc_body] = ACTIONS(2632),
    [sym__heredoc_body_beginning] = ACTIONS(2632),
    [sym_file_descriptor] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_fi] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2634),
    [anon_sym_SEMI_SEMI] = ACTIONS(2632),
    [anon_sym_PIPE_AMP] = ACTIONS(2632),
    [anon_sym_AMP_AMP] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2632),
    [anon_sym_EQ_TILDE] = ACTIONS(2634),
    [anon_sym_EQ_EQ] = ACTIONS(2634),
    [anon_sym_LT] = ACTIONS(2634),
    [anon_sym_GT] = ACTIONS(2634),
    [anon_sym_GT_GT] = ACTIONS(2632),
    [anon_sym_AMP_GT] = ACTIONS(2634),
    [anon_sym_AMP_GT_GT] = ACTIONS(2632),
    [anon_sym_LT_AMP] = ACTIONS(2632),
    [anon_sym_GT_AMP] = ACTIONS(2632),
    [anon_sym_LT_LT] = ACTIONS(2634),
    [anon_sym_LT_LT_DASH] = ACTIONS(2632),
    [anon_sym_LT_LT_LT] = ACTIONS(2632),
    [anon_sym_DOLLAR] = ACTIONS(2634),
    [sym__special_character] = ACTIONS(2632),
    [anon_sym_DQUOTE] = ACTIONS(2632),
    [sym_raw_string] = ACTIONS(2632),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2632),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2632),
    [anon_sym_BQUOTE] = ACTIONS(2632),
    [anon_sym_LT_LPAREN] = ACTIONS(2632),
    [anon_sym_GT_LPAREN] = ACTIONS(2632),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2634),
    [anon_sym_LF] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2634),
  },
  [3011] = {
    [aux_sym_concatenation_repeat1] = STATE(2331),
    [sym__simple_heredoc_body] = ACTIONS(2632),
    [sym__heredoc_body_beginning] = ACTIONS(2632),
    [sym_file_descriptor] = ACTIONS(2632),
    [sym__concat] = ACTIONS(5107),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_fi] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2634),
    [anon_sym_SEMI_SEMI] = ACTIONS(2632),
    [anon_sym_PIPE_AMP] = ACTIONS(2632),
    [anon_sym_AMP_AMP] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2632),
    [anon_sym_EQ_TILDE] = ACTIONS(2634),
    [anon_sym_EQ_EQ] = ACTIONS(2634),
    [anon_sym_LT] = ACTIONS(2634),
    [anon_sym_GT] = ACTIONS(2634),
    [anon_sym_GT_GT] = ACTIONS(2632),
    [anon_sym_AMP_GT] = ACTIONS(2634),
    [anon_sym_AMP_GT_GT] = ACTIONS(2632),
    [anon_sym_LT_AMP] = ACTIONS(2632),
    [anon_sym_GT_AMP] = ACTIONS(2632),
    [anon_sym_LT_LT] = ACTIONS(2634),
    [anon_sym_LT_LT_DASH] = ACTIONS(2632),
    [anon_sym_LT_LT_LT] = ACTIONS(2632),
    [anon_sym_DOLLAR] = ACTIONS(2634),
    [sym__special_character] = ACTIONS(2632),
    [anon_sym_DQUOTE] = ACTIONS(2632),
    [sym_raw_string] = ACTIONS(2632),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2632),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2632),
    [anon_sym_BQUOTE] = ACTIONS(2632),
    [anon_sym_LT_LPAREN] = ACTIONS(2632),
    [anon_sym_GT_LPAREN] = ACTIONS(2632),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2634),
    [anon_sym_LF] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2634),
  },
  [3012] = {
    [aux_sym__literal_repeat1] = STATE(2359),
    [sym__simple_heredoc_body] = ACTIONS(2636),
    [sym__heredoc_body_beginning] = ACTIONS(2636),
    [sym_file_descriptor] = ACTIONS(2636),
    [anon_sym_SEMI] = ACTIONS(2638),
    [anon_sym_fi] = ACTIONS(2638),
    [anon_sym_PIPE] = ACTIONS(2638),
    [anon_sym_SEMI_SEMI] = ACTIONS(2636),
    [anon_sym_PIPE_AMP] = ACTIONS(2636),
    [anon_sym_AMP_AMP] = ACTIONS(2636),
    [anon_sym_PIPE_PIPE] = ACTIONS(2636),
    [anon_sym_EQ_TILDE] = ACTIONS(2638),
    [anon_sym_EQ_EQ] = ACTIONS(2638),
    [anon_sym_LT] = ACTIONS(2638),
    [anon_sym_GT] = ACTIONS(2638),
    [anon_sym_GT_GT] = ACTIONS(2636),
    [anon_sym_AMP_GT] = ACTIONS(2638),
    [anon_sym_AMP_GT_GT] = ACTIONS(2636),
    [anon_sym_LT_AMP] = ACTIONS(2636),
    [anon_sym_GT_AMP] = ACTIONS(2636),
    [anon_sym_LT_LT] = ACTIONS(2638),
    [anon_sym_LT_LT_DASH] = ACTIONS(2636),
    [anon_sym_LT_LT_LT] = ACTIONS(2636),
    [anon_sym_DOLLAR] = ACTIONS(2638),
    [sym__special_character] = ACTIONS(5151),
    [anon_sym_DQUOTE] = ACTIONS(2636),
    [sym_raw_string] = ACTIONS(2636),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2636),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2636),
    [anon_sym_BQUOTE] = ACTIONS(2636),
    [anon_sym_LT_LPAREN] = ACTIONS(2636),
    [anon_sym_GT_LPAREN] = ACTIONS(2636),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2638),
    [anon_sym_LF] = ACTIONS(2636),
    [anon_sym_AMP] = ACTIONS(2638),
  },
  [3013] = {
    [sym_concatenation] = STATE(3013),
    [sym_string] = STATE(2352),
    [sym_simple_expansion] = STATE(2352),
    [sym_string_expansion] = STATE(2352),
    [sym_expansion] = STATE(2352),
    [sym_command_substitution] = STATE(2352),
    [sym_process_substitution] = STATE(2352),
    [aux_sym_command_repeat2] = STATE(3013),
    [aux_sym__literal_repeat1] = STATE(2354),
    [sym__simple_heredoc_body] = ACTIONS(2632),
    [sym__heredoc_body_beginning] = ACTIONS(2632),
    [sym_file_descriptor] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_fi] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2634),
    [anon_sym_SEMI_SEMI] = ACTIONS(2632),
    [anon_sym_PIPE_AMP] = ACTIONS(2632),
    [anon_sym_AMP_AMP] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2632),
    [anon_sym_EQ_TILDE] = ACTIONS(7927),
    [anon_sym_EQ_EQ] = ACTIONS(7927),
    [anon_sym_LT] = ACTIONS(2634),
    [anon_sym_GT] = ACTIONS(2634),
    [anon_sym_GT_GT] = ACTIONS(2632),
    [anon_sym_AMP_GT] = ACTIONS(2634),
    [anon_sym_AMP_GT_GT] = ACTIONS(2632),
    [anon_sym_LT_AMP] = ACTIONS(2632),
    [anon_sym_GT_AMP] = ACTIONS(2632),
    [anon_sym_LT_LT] = ACTIONS(2634),
    [anon_sym_LT_LT_DASH] = ACTIONS(2632),
    [anon_sym_LT_LT_LT] = ACTIONS(2632),
    [anon_sym_DOLLAR] = ACTIONS(7930),
    [sym__special_character] = ACTIONS(7933),
    [anon_sym_DQUOTE] = ACTIONS(7936),
    [sym_raw_string] = ACTIONS(7939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7942),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7945),
    [anon_sym_BQUOTE] = ACTIONS(7948),
    [anon_sym_LT_LPAREN] = ACTIONS(7951),
    [anon_sym_GT_LPAREN] = ACTIONS(7951),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7954),
    [anon_sym_LF] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2634),
  },
  [3014] = {
    [sym_file_descriptor] = ACTIONS(1237),
    [sym_variable_name] = ACTIONS(1237),
    [anon_sym_for] = ACTIONS(1241),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1237),
    [anon_sym_while] = ACTIONS(1241),
    [anon_sym_if] = ACTIONS(1241),
    [anon_sym_fi] = ACTIONS(6385),
    [anon_sym_case] = ACTIONS(1241),
    [anon_sym_function] = ACTIONS(1241),
    [anon_sym_LPAREN] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1237),
    [anon_sym_BANG] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(1241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1237),
    [anon_sym_declare] = ACTIONS(1241),
    [anon_sym_typeset] = ACTIONS(1241),
    [anon_sym_export] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_local] = ACTIONS(1241),
    [anon_sym_unset] = ACTIONS(1241),
    [anon_sym_unsetenv] = ACTIONS(1241),
    [anon_sym_LT] = ACTIONS(1241),
    [anon_sym_GT] = ACTIONS(1241),
    [anon_sym_GT_GT] = ACTIONS(1237),
    [anon_sym_AMP_GT] = ACTIONS(1241),
    [anon_sym_AMP_GT_GT] = ACTIONS(1237),
    [anon_sym_LT_AMP] = ACTIONS(1237),
    [anon_sym_GT_AMP] = ACTIONS(1237),
    [anon_sym_DOLLAR] = ACTIONS(1241),
    [sym__special_character] = ACTIONS(1241),
    [anon_sym_DQUOTE] = ACTIONS(1237),
    [sym_raw_string] = ACTIONS(1237),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1237),
    [anon_sym_BQUOTE] = ACTIONS(1237),
    [anon_sym_LT_LPAREN] = ACTIONS(1237),
    [anon_sym_GT_LPAREN] = ACTIONS(1237),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1241),
  },
  [3015] = {
    [anon_sym_SEMI] = ACTIONS(7957),
    [anon_sym_fi] = ACTIONS(2606),
    [anon_sym_SEMI_SEMI] = ACTIONS(7959),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(7959),
    [anon_sym_AMP] = ACTIONS(7959),
  },
  [3016] = {
    [sym_concatenation] = STATE(3013),
    [sym_string] = STATE(2352),
    [sym_simple_expansion] = STATE(2352),
    [sym_string_expansion] = STATE(2352),
    [sym_expansion] = STATE(2352),
    [sym_command_substitution] = STATE(2352),
    [sym_process_substitution] = STATE(2352),
    [aux_sym_command_repeat2] = STATE(3013),
    [aux_sym__literal_repeat1] = STATE(2354),
    [sym__simple_heredoc_body] = ACTIONS(2696),
    [sym__heredoc_body_beginning] = ACTIONS(2696),
    [sym_file_descriptor] = ACTIONS(2696),
    [anon_sym_SEMI] = ACTIONS(2698),
    [anon_sym_fi] = ACTIONS(2698),
    [anon_sym_PIPE] = ACTIONS(2698),
    [anon_sym_SEMI_SEMI] = ACTIONS(2696),
    [anon_sym_PIPE_AMP] = ACTIONS(2696),
    [anon_sym_AMP_AMP] = ACTIONS(2696),
    [anon_sym_PIPE_PIPE] = ACTIONS(2696),
    [anon_sym_EQ_TILDE] = ACTIONS(5143),
    [anon_sym_EQ_EQ] = ACTIONS(5143),
    [anon_sym_LT] = ACTIONS(2698),
    [anon_sym_GT] = ACTIONS(2698),
    [anon_sym_GT_GT] = ACTIONS(2696),
    [anon_sym_AMP_GT] = ACTIONS(2698),
    [anon_sym_AMP_GT_GT] = ACTIONS(2696),
    [anon_sym_LT_AMP] = ACTIONS(2696),
    [anon_sym_GT_AMP] = ACTIONS(2696),
    [anon_sym_LT_LT] = ACTIONS(2698),
    [anon_sym_LT_LT_DASH] = ACTIONS(2696),
    [anon_sym_LT_LT_LT] = ACTIONS(2696),
    [anon_sym_DOLLAR] = ACTIONS(3391),
    [sym__special_character] = ACTIONS(5145),
    [anon_sym_DQUOTE] = ACTIONS(3395),
    [sym_raw_string] = ACTIONS(5147),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3401),
    [anon_sym_BQUOTE] = ACTIONS(3403),
    [anon_sym_LT_LPAREN] = ACTIONS(3405),
    [anon_sym_GT_LPAREN] = ACTIONS(3405),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5149),
    [anon_sym_LF] = ACTIONS(2696),
    [anon_sym_AMP] = ACTIONS(2698),
  },
  [3017] = {
    [sym__simple_heredoc_body] = ACTIONS(1400),
    [sym__heredoc_body_beginning] = ACTIONS(1400),
    [sym_file_descriptor] = ACTIONS(1400),
    [sym_variable_name] = ACTIONS(1400),
    [anon_sym_SEMI] = ACTIONS(1402),
    [anon_sym_fi] = ACTIONS(1402),
    [anon_sym_elif] = ACTIONS(1402),
    [anon_sym_else] = ACTIONS(1402),
    [anon_sym_PIPE] = ACTIONS(1402),
    [anon_sym_SEMI_SEMI] = ACTIONS(1400),
    [anon_sym_PIPE_AMP] = ACTIONS(1400),
    [anon_sym_AMP_AMP] = ACTIONS(1400),
    [anon_sym_PIPE_PIPE] = ACTIONS(1400),
    [anon_sym_LT] = ACTIONS(1402),
    [anon_sym_GT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT] = ACTIONS(1402),
    [anon_sym_AMP_GT_GT] = ACTIONS(1400),
    [anon_sym_LT_AMP] = ACTIONS(1400),
    [anon_sym_GT_AMP] = ACTIONS(1400),
    [anon_sym_LT_LT] = ACTIONS(1402),
    [anon_sym_LT_LT_DASH] = ACTIONS(1400),
    [anon_sym_LT_LT_LT] = ACTIONS(1400),
    [anon_sym_DOLLAR] = ACTIONS(1402),
    [sym__special_character] = ACTIONS(1400),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1400),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1400),
    [anon_sym_BQUOTE] = ACTIONS(1400),
    [anon_sym_LT_LPAREN] = ACTIONS(1400),
    [anon_sym_GT_LPAREN] = ACTIONS(1400),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1402),
    [sym_word] = ACTIONS(1402),
    [anon_sym_LF] = ACTIONS(1400),
    [anon_sym_AMP] = ACTIONS(1402),
  },
  [3018] = {
    [sym_concatenation] = STATE(3521),
    [sym_string] = STATE(730),
    [sym_simple_expansion] = STATE(730),
    [sym_string_expansion] = STATE(730),
    [sym_expansion] = STATE(730),
    [sym_command_substitution] = STATE(730),
    [sym_process_substitution] = STATE(730),
    [aux_sym_for_statement_repeat1] = STATE(3521),
    [aux_sym__literal_repeat1] = STATE(736),
    [anon_sym_RPAREN] = ACTIONS(7961),
    [anon_sym_DOLLAR] = ACTIONS(1406),
    [sym__special_character] = ACTIONS(1408),
    [anon_sym_DQUOTE] = ACTIONS(1410),
    [sym_raw_string] = ACTIONS(1412),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1414),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1416),
    [anon_sym_BQUOTE] = ACTIONS(1418),
    [anon_sym_LT_LPAREN] = ACTIONS(1420),
    [anon_sym_GT_LPAREN] = ACTIONS(1420),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1412),
  },
  [3019] = {
    [aux_sym_concatenation_repeat1] = STATE(2365),
    [sym__simple_heredoc_body] = ACTIONS(1400),
    [sym__heredoc_body_beginning] = ACTIONS(1400),
    [sym_file_descriptor] = ACTIONS(1400),
    [sym__concat] = ACTIONS(5163),
    [sym_variable_name] = ACTIONS(1400),
    [anon_sym_SEMI] = ACTIONS(1402),
    [anon_sym_fi] = ACTIONS(1402),
    [anon_sym_elif] = ACTIONS(1402),
    [anon_sym_else] = ACTIONS(1402),
    [anon_sym_PIPE] = ACTIONS(1402),
    [anon_sym_SEMI_SEMI] = ACTIONS(1400),
    [anon_sym_PIPE_AMP] = ACTIONS(1400),
    [anon_sym_AMP_AMP] = ACTIONS(1400),
    [anon_sym_PIPE_PIPE] = ACTIONS(1400),
    [anon_sym_LT] = ACTIONS(1402),
    [anon_sym_GT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT] = ACTIONS(1402),
    [anon_sym_AMP_GT_GT] = ACTIONS(1400),
    [anon_sym_LT_AMP] = ACTIONS(1400),
    [anon_sym_GT_AMP] = ACTIONS(1400),
    [anon_sym_LT_LT] = ACTIONS(1402),
    [anon_sym_LT_LT_DASH] = ACTIONS(1400),
    [anon_sym_LT_LT_LT] = ACTIONS(1400),
    [anon_sym_DOLLAR] = ACTIONS(1402),
    [sym__special_character] = ACTIONS(1400),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1400),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1400),
    [anon_sym_BQUOTE] = ACTIONS(1400),
    [anon_sym_LT_LPAREN] = ACTIONS(1400),
    [anon_sym_GT_LPAREN] = ACTIONS(1400),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1402),
    [sym_word] = ACTIONS(1402),
    [anon_sym_LF] = ACTIONS(1400),
    [anon_sym_AMP] = ACTIONS(1402),
  },
  [3020] = {
    [aux_sym__literal_repeat1] = STATE(2379),
    [sym__simple_heredoc_body] = ACTIONS(1446),
    [sym__heredoc_body_beginning] = ACTIONS(1446),
    [sym_file_descriptor] = ACTIONS(1446),
    [sym_variable_name] = ACTIONS(1446),
    [anon_sym_SEMI] = ACTIONS(1448),
    [anon_sym_fi] = ACTIONS(1448),
    [anon_sym_elif] = ACTIONS(1448),
    [anon_sym_else] = ACTIONS(1448),
    [anon_sym_PIPE] = ACTIONS(1448),
    [anon_sym_SEMI_SEMI] = ACTIONS(1446),
    [anon_sym_PIPE_AMP] = ACTIONS(1446),
    [anon_sym_AMP_AMP] = ACTIONS(1446),
    [anon_sym_PIPE_PIPE] = ACTIONS(1446),
    [anon_sym_LT] = ACTIONS(1448),
    [anon_sym_GT] = ACTIONS(1448),
    [anon_sym_GT_GT] = ACTIONS(1446),
    [anon_sym_AMP_GT] = ACTIONS(1448),
    [anon_sym_AMP_GT_GT] = ACTIONS(1446),
    [anon_sym_LT_AMP] = ACTIONS(1446),
    [anon_sym_GT_AMP] = ACTIONS(1446),
    [anon_sym_LT_LT] = ACTIONS(1448),
    [anon_sym_LT_LT_DASH] = ACTIONS(1446),
    [anon_sym_LT_LT_LT] = ACTIONS(1446),
    [anon_sym_DOLLAR] = ACTIONS(1448),
    [sym__special_character] = ACTIONS(5181),
    [anon_sym_DQUOTE] = ACTIONS(1446),
    [sym_raw_string] = ACTIONS(1446),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1446),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1446),
    [anon_sym_BQUOTE] = ACTIONS(1446),
    [anon_sym_LT_LPAREN] = ACTIONS(1446),
    [anon_sym_GT_LPAREN] = ACTIONS(1446),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1448),
    [sym_word] = ACTIONS(1448),
    [anon_sym_LF] = ACTIONS(1446),
    [anon_sym_AMP] = ACTIONS(1448),
  },
  [3021] = {
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(2362),
    [sym_variable_name] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_fi] = ACTIONS(2364),
    [anon_sym_elif] = ACTIONS(2364),
    [anon_sym_else] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2364),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [3022] = {
    [sym_string] = STATE(3021),
    [sym_simple_expansion] = STATE(3021),
    [sym_string_expansion] = STATE(3021),
    [sym_expansion] = STATE(3021),
    [sym_command_substitution] = STATE(3021),
    [sym_process_substitution] = STATE(3021),
    [anon_sym_DOLLAR] = ACTIONS(7963),
    [sym__special_character] = ACTIONS(6612),
    [anon_sym_DQUOTE] = ACTIONS(3415),
    [sym_raw_string] = ACTIONS(6612),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3419),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3421),
    [anon_sym_BQUOTE] = ACTIONS(3423),
    [anon_sym_LT_LPAREN] = ACTIONS(3425),
    [anon_sym_GT_LPAREN] = ACTIONS(3425),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6612),
  },
  [3023] = {
    [aux_sym_concatenation_repeat1] = STATE(3023),
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(7965),
    [sym_variable_name] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_fi] = ACTIONS(2364),
    [anon_sym_elif] = ACTIONS(2364),
    [anon_sym_else] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2364),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [3024] = {
    [sym__simple_heredoc_body] = ACTIONS(2371),
    [sym__heredoc_body_beginning] = ACTIONS(2371),
    [sym_file_descriptor] = ACTIONS(2371),
    [sym__concat] = ACTIONS(2371),
    [sym_variable_name] = ACTIONS(2371),
    [anon_sym_SEMI] = ACTIONS(2373),
    [anon_sym_fi] = ACTIONS(2373),
    [anon_sym_elif] = ACTIONS(2373),
    [anon_sym_else] = ACTIONS(2373),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_SEMI_SEMI] = ACTIONS(2371),
    [anon_sym_PIPE_AMP] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_GT_GT] = ACTIONS(2371),
    [anon_sym_AMP_GT] = ACTIONS(2373),
    [anon_sym_AMP_GT_GT] = ACTIONS(2371),
    [anon_sym_LT_AMP] = ACTIONS(2371),
    [anon_sym_GT_AMP] = ACTIONS(2371),
    [anon_sym_LT_LT] = ACTIONS(2373),
    [anon_sym_LT_LT_DASH] = ACTIONS(2371),
    [anon_sym_LT_LT_LT] = ACTIONS(2371),
    [anon_sym_DOLLAR] = ACTIONS(2373),
    [sym__special_character] = ACTIONS(2371),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [sym_raw_string] = ACTIONS(2371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2371),
    [anon_sym_BQUOTE] = ACTIONS(2371),
    [anon_sym_LT_LPAREN] = ACTIONS(2371),
    [anon_sym_GT_LPAREN] = ACTIONS(2371),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2373),
    [sym_word] = ACTIONS(2373),
    [anon_sym_LF] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
  },
  [3025] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(7968),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [3026] = {
    [sym_concatenation] = STATE(3526),
    [sym_string] = STATE(3525),
    [sym_simple_expansion] = STATE(3525),
    [sym_string_expansion] = STATE(3525),
    [sym_expansion] = STATE(3525),
    [sym_command_substitution] = STATE(3525),
    [sym_process_substitution] = STATE(3525),
    [aux_sym__literal_repeat1] = STATE(3527),
    [anon_sym_RBRACE] = ACTIONS(7970),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(7972),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7972),
  },
  [3027] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(7974),
    [sym_comment] = ACTIONS(57),
  },
  [3028] = {
    [sym_concatenation] = STATE(3531),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3531),
    [anon_sym_RBRACE] = ACTIONS(7976),
    [anon_sym_EQ] = ACTIONS(7978),
    [anon_sym_DASH] = ACTIONS(7978),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7980),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(7982),
    [anon_sym_COLON] = ACTIONS(7978),
    [anon_sym_COLON_QMARK] = ACTIONS(7978),
    [anon_sym_COLON_DASH] = ACTIONS(7978),
    [anon_sym_PERCENT] = ACTIONS(7978),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3029] = {
    [sym_concatenation] = STATE(3533),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3533),
    [anon_sym_RBRACE] = ACTIONS(7970),
    [anon_sym_EQ] = ACTIONS(7984),
    [anon_sym_DASH] = ACTIONS(7984),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7986),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(7988),
    [anon_sym_COLON] = ACTIONS(7984),
    [anon_sym_COLON_QMARK] = ACTIONS(7984),
    [anon_sym_COLON_DASH] = ACTIONS(7984),
    [anon_sym_PERCENT] = ACTIONS(7984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3030] = {
    [sym__simple_heredoc_body] = ACTIONS(2462),
    [sym__heredoc_body_beginning] = ACTIONS(2462),
    [sym_file_descriptor] = ACTIONS(2462),
    [sym__concat] = ACTIONS(2462),
    [sym_variable_name] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_fi] = ACTIONS(2464),
    [anon_sym_elif] = ACTIONS(2464),
    [anon_sym_else] = ACTIONS(2464),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_SEMI_SEMI] = ACTIONS(2462),
    [anon_sym_PIPE_AMP] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_GT_GT] = ACTIONS(2462),
    [anon_sym_AMP_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT_GT] = ACTIONS(2462),
    [anon_sym_LT_AMP] = ACTIONS(2462),
    [anon_sym_GT_AMP] = ACTIONS(2462),
    [anon_sym_LT_LT] = ACTIONS(2464),
    [anon_sym_LT_LT_DASH] = ACTIONS(2462),
    [anon_sym_LT_LT_LT] = ACTIONS(2462),
    [anon_sym_DOLLAR] = ACTIONS(2464),
    [sym__special_character] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [sym_raw_string] = ACTIONS(2462),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2462),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2462),
    [anon_sym_BQUOTE] = ACTIONS(2462),
    [anon_sym_LT_LPAREN] = ACTIONS(2462),
    [anon_sym_GT_LPAREN] = ACTIONS(2462),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2464),
    [sym_word] = ACTIONS(2464),
    [anon_sym_LF] = ACTIONS(2462),
    [anon_sym_AMP] = ACTIONS(2464),
  },
  [3031] = {
    [sym_concatenation] = STATE(3536),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3536),
    [sym_regex] = ACTIONS(7990),
    [anon_sym_RBRACE] = ACTIONS(7992),
    [anon_sym_EQ] = ACTIONS(7994),
    [anon_sym_DASH] = ACTIONS(7994),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7996),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7994),
    [anon_sym_COLON_QMARK] = ACTIONS(7994),
    [anon_sym_COLON_DASH] = ACTIONS(7994),
    [anon_sym_PERCENT] = ACTIONS(7994),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3032] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7992),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3033] = {
    [sym__simple_heredoc_body] = ACTIONS(2512),
    [sym__heredoc_body_beginning] = ACTIONS(2512),
    [sym_file_descriptor] = ACTIONS(2512),
    [sym__concat] = ACTIONS(2512),
    [sym_variable_name] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2514),
    [anon_sym_fi] = ACTIONS(2514),
    [anon_sym_elif] = ACTIONS(2514),
    [anon_sym_else] = ACTIONS(2514),
    [anon_sym_PIPE] = ACTIONS(2514),
    [anon_sym_SEMI_SEMI] = ACTIONS(2512),
    [anon_sym_PIPE_AMP] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE_PIPE] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2514),
    [anon_sym_GT] = ACTIONS(2514),
    [anon_sym_GT_GT] = ACTIONS(2512),
    [anon_sym_AMP_GT] = ACTIONS(2514),
    [anon_sym_AMP_GT_GT] = ACTIONS(2512),
    [anon_sym_LT_AMP] = ACTIONS(2512),
    [anon_sym_GT_AMP] = ACTIONS(2512),
    [anon_sym_LT_LT] = ACTIONS(2514),
    [anon_sym_LT_LT_DASH] = ACTIONS(2512),
    [anon_sym_LT_LT_LT] = ACTIONS(2512),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [sym__special_character] = ACTIONS(2512),
    [anon_sym_DQUOTE] = ACTIONS(2512),
    [sym_raw_string] = ACTIONS(2512),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2512),
    [anon_sym_BQUOTE] = ACTIONS(2512),
    [anon_sym_LT_LPAREN] = ACTIONS(2512),
    [anon_sym_GT_LPAREN] = ACTIONS(2512),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2514),
    [sym_word] = ACTIONS(2514),
    [anon_sym_LF] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2514),
  },
  [3034] = {
    [sym_concatenation] = STATE(3533),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3533),
    [sym_regex] = ACTIONS(7998),
    [anon_sym_RBRACE] = ACTIONS(7970),
    [anon_sym_EQ] = ACTIONS(7984),
    [anon_sym_DASH] = ACTIONS(7984),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(7986),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(7984),
    [anon_sym_COLON_QMARK] = ACTIONS(7984),
    [anon_sym_COLON_DASH] = ACTIONS(7984),
    [anon_sym_PERCENT] = ACTIONS(7984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3035] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(7970),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3036] = {
    [sym__simple_heredoc_body] = ACTIONS(2520),
    [sym__heredoc_body_beginning] = ACTIONS(2520),
    [sym_file_descriptor] = ACTIONS(2520),
    [sym__concat] = ACTIONS(2520),
    [sym_variable_name] = ACTIONS(2520),
    [anon_sym_SEMI] = ACTIONS(2522),
    [anon_sym_fi] = ACTIONS(2522),
    [anon_sym_elif] = ACTIONS(2522),
    [anon_sym_else] = ACTIONS(2522),
    [anon_sym_PIPE] = ACTIONS(2522),
    [anon_sym_SEMI_SEMI] = ACTIONS(2520),
    [anon_sym_PIPE_AMP] = ACTIONS(2520),
    [anon_sym_AMP_AMP] = ACTIONS(2520),
    [anon_sym_PIPE_PIPE] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(2522),
    [anon_sym_GT] = ACTIONS(2522),
    [anon_sym_GT_GT] = ACTIONS(2520),
    [anon_sym_AMP_GT] = ACTIONS(2522),
    [anon_sym_AMP_GT_GT] = ACTIONS(2520),
    [anon_sym_LT_AMP] = ACTIONS(2520),
    [anon_sym_GT_AMP] = ACTIONS(2520),
    [anon_sym_LT_LT] = ACTIONS(2522),
    [anon_sym_LT_LT_DASH] = ACTIONS(2520),
    [anon_sym_LT_LT_LT] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(2522),
    [sym__special_character] = ACTIONS(2520),
    [anon_sym_DQUOTE] = ACTIONS(2520),
    [sym_raw_string] = ACTIONS(2520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2520),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2520),
    [anon_sym_BQUOTE] = ACTIONS(2520),
    [anon_sym_LT_LPAREN] = ACTIONS(2520),
    [anon_sym_GT_LPAREN] = ACTIONS(2520),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2522),
    [sym_word] = ACTIONS(2522),
    [anon_sym_LF] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2522),
  },
  [3037] = {
    [sym__simple_heredoc_body] = ACTIONS(2554),
    [sym__heredoc_body_beginning] = ACTIONS(2554),
    [sym_file_descriptor] = ACTIONS(2554),
    [sym__concat] = ACTIONS(2554),
    [sym_variable_name] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(2556),
    [anon_sym_fi] = ACTIONS(2556),
    [anon_sym_elif] = ACTIONS(2556),
    [anon_sym_else] = ACTIONS(2556),
    [anon_sym_PIPE] = ACTIONS(2556),
    [anon_sym_SEMI_SEMI] = ACTIONS(2554),
    [anon_sym_PIPE_AMP] = ACTIONS(2554),
    [anon_sym_AMP_AMP] = ACTIONS(2554),
    [anon_sym_PIPE_PIPE] = ACTIONS(2554),
    [anon_sym_LT] = ACTIONS(2556),
    [anon_sym_GT] = ACTIONS(2556),
    [anon_sym_GT_GT] = ACTIONS(2554),
    [anon_sym_AMP_GT] = ACTIONS(2556),
    [anon_sym_AMP_GT_GT] = ACTIONS(2554),
    [anon_sym_LT_AMP] = ACTIONS(2554),
    [anon_sym_GT_AMP] = ACTIONS(2554),
    [anon_sym_LT_LT] = ACTIONS(2556),
    [anon_sym_LT_LT_DASH] = ACTIONS(2554),
    [anon_sym_LT_LT_LT] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2556),
    [sym__special_character] = ACTIONS(2554),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2554),
    [anon_sym_BQUOTE] = ACTIONS(2554),
    [anon_sym_LT_LPAREN] = ACTIONS(2554),
    [anon_sym_GT_LPAREN] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2556),
    [sym_word] = ACTIONS(2556),
    [anon_sym_LF] = ACTIONS(2554),
    [anon_sym_AMP] = ACTIONS(2556),
  },
  [3038] = {
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_fi] = ACTIONS(2364),
    [anon_sym_elif] = ACTIONS(2364),
    [anon_sym_else] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2364),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [3039] = {
    [sym_string] = STATE(3038),
    [sym_simple_expansion] = STATE(3038),
    [sym_string_expansion] = STATE(3038),
    [sym_expansion] = STATE(3038),
    [sym_command_substitution] = STATE(3038),
    [sym_process_substitution] = STATE(3038),
    [anon_sym_DOLLAR] = ACTIONS(8000),
    [sym__special_character] = ACTIONS(6686),
    [anon_sym_DQUOTE] = ACTIONS(3435),
    [sym_raw_string] = ACTIONS(6686),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3439),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3441),
    [anon_sym_BQUOTE] = ACTIONS(3443),
    [anon_sym_LT_LPAREN] = ACTIONS(3445),
    [anon_sym_GT_LPAREN] = ACTIONS(3445),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6686),
  },
  [3040] = {
    [aux_sym_concatenation_repeat1] = STATE(3040),
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(8002),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_fi] = ACTIONS(2364),
    [anon_sym_elif] = ACTIONS(2364),
    [anon_sym_else] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2364),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [3041] = {
    [sym__simple_heredoc_body] = ACTIONS(2371),
    [sym__heredoc_body_beginning] = ACTIONS(2371),
    [sym_file_descriptor] = ACTIONS(2371),
    [sym__concat] = ACTIONS(2371),
    [anon_sym_SEMI] = ACTIONS(2373),
    [anon_sym_fi] = ACTIONS(2373),
    [anon_sym_elif] = ACTIONS(2373),
    [anon_sym_else] = ACTIONS(2373),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_SEMI_SEMI] = ACTIONS(2371),
    [anon_sym_PIPE_AMP] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_GT_GT] = ACTIONS(2371),
    [anon_sym_AMP_GT] = ACTIONS(2373),
    [anon_sym_AMP_GT_GT] = ACTIONS(2371),
    [anon_sym_LT_AMP] = ACTIONS(2371),
    [anon_sym_GT_AMP] = ACTIONS(2371),
    [anon_sym_LT_LT] = ACTIONS(2373),
    [anon_sym_LT_LT_DASH] = ACTIONS(2371),
    [anon_sym_LT_LT_LT] = ACTIONS(2371),
    [anon_sym_DOLLAR] = ACTIONS(2373),
    [sym__special_character] = ACTIONS(2371),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [sym_raw_string] = ACTIONS(2371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2371),
    [anon_sym_BQUOTE] = ACTIONS(2371),
    [anon_sym_LT_LPAREN] = ACTIONS(2371),
    [anon_sym_GT_LPAREN] = ACTIONS(2371),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2373),
    [sym_word] = ACTIONS(2373),
    [anon_sym_LF] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
  },
  [3042] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(8005),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [3043] = {
    [sym_concatenation] = STATE(3542),
    [sym_string] = STATE(3541),
    [sym_simple_expansion] = STATE(3541),
    [sym_string_expansion] = STATE(3541),
    [sym_expansion] = STATE(3541),
    [sym_command_substitution] = STATE(3541),
    [sym_process_substitution] = STATE(3541),
    [aux_sym__literal_repeat1] = STATE(3543),
    [anon_sym_RBRACE] = ACTIONS(8007),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(8009),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8009),
  },
  [3044] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(8011),
    [sym_comment] = ACTIONS(57),
  },
  [3045] = {
    [sym_concatenation] = STATE(3547),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3547),
    [anon_sym_RBRACE] = ACTIONS(8013),
    [anon_sym_EQ] = ACTIONS(8015),
    [anon_sym_DASH] = ACTIONS(8015),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8017),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(8019),
    [anon_sym_COLON] = ACTIONS(8015),
    [anon_sym_COLON_QMARK] = ACTIONS(8015),
    [anon_sym_COLON_DASH] = ACTIONS(8015),
    [anon_sym_PERCENT] = ACTIONS(8015),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3046] = {
    [sym_concatenation] = STATE(3549),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3549),
    [anon_sym_RBRACE] = ACTIONS(8007),
    [anon_sym_EQ] = ACTIONS(8021),
    [anon_sym_DASH] = ACTIONS(8021),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8023),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(8025),
    [anon_sym_COLON] = ACTIONS(8021),
    [anon_sym_COLON_QMARK] = ACTIONS(8021),
    [anon_sym_COLON_DASH] = ACTIONS(8021),
    [anon_sym_PERCENT] = ACTIONS(8021),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3047] = {
    [sym__simple_heredoc_body] = ACTIONS(2462),
    [sym__heredoc_body_beginning] = ACTIONS(2462),
    [sym_file_descriptor] = ACTIONS(2462),
    [sym__concat] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_fi] = ACTIONS(2464),
    [anon_sym_elif] = ACTIONS(2464),
    [anon_sym_else] = ACTIONS(2464),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_SEMI_SEMI] = ACTIONS(2462),
    [anon_sym_PIPE_AMP] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_GT_GT] = ACTIONS(2462),
    [anon_sym_AMP_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT_GT] = ACTIONS(2462),
    [anon_sym_LT_AMP] = ACTIONS(2462),
    [anon_sym_GT_AMP] = ACTIONS(2462),
    [anon_sym_LT_LT] = ACTIONS(2464),
    [anon_sym_LT_LT_DASH] = ACTIONS(2462),
    [anon_sym_LT_LT_LT] = ACTIONS(2462),
    [anon_sym_DOLLAR] = ACTIONS(2464),
    [sym__special_character] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [sym_raw_string] = ACTIONS(2462),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2462),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2462),
    [anon_sym_BQUOTE] = ACTIONS(2462),
    [anon_sym_LT_LPAREN] = ACTIONS(2462),
    [anon_sym_GT_LPAREN] = ACTIONS(2462),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2464),
    [sym_word] = ACTIONS(2464),
    [anon_sym_LF] = ACTIONS(2462),
    [anon_sym_AMP] = ACTIONS(2464),
  },
  [3048] = {
    [sym_concatenation] = STATE(3552),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3552),
    [sym_regex] = ACTIONS(8027),
    [anon_sym_RBRACE] = ACTIONS(8029),
    [anon_sym_EQ] = ACTIONS(8031),
    [anon_sym_DASH] = ACTIONS(8031),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8031),
    [anon_sym_COLON_QMARK] = ACTIONS(8031),
    [anon_sym_COLON_DASH] = ACTIONS(8031),
    [anon_sym_PERCENT] = ACTIONS(8031),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3049] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8029),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3050] = {
    [sym__simple_heredoc_body] = ACTIONS(2512),
    [sym__heredoc_body_beginning] = ACTIONS(2512),
    [sym_file_descriptor] = ACTIONS(2512),
    [sym__concat] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2514),
    [anon_sym_fi] = ACTIONS(2514),
    [anon_sym_elif] = ACTIONS(2514),
    [anon_sym_else] = ACTIONS(2514),
    [anon_sym_PIPE] = ACTIONS(2514),
    [anon_sym_SEMI_SEMI] = ACTIONS(2512),
    [anon_sym_PIPE_AMP] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE_PIPE] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2514),
    [anon_sym_GT] = ACTIONS(2514),
    [anon_sym_GT_GT] = ACTIONS(2512),
    [anon_sym_AMP_GT] = ACTIONS(2514),
    [anon_sym_AMP_GT_GT] = ACTIONS(2512),
    [anon_sym_LT_AMP] = ACTIONS(2512),
    [anon_sym_GT_AMP] = ACTIONS(2512),
    [anon_sym_LT_LT] = ACTIONS(2514),
    [anon_sym_LT_LT_DASH] = ACTIONS(2512),
    [anon_sym_LT_LT_LT] = ACTIONS(2512),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [sym__special_character] = ACTIONS(2512),
    [anon_sym_DQUOTE] = ACTIONS(2512),
    [sym_raw_string] = ACTIONS(2512),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2512),
    [anon_sym_BQUOTE] = ACTIONS(2512),
    [anon_sym_LT_LPAREN] = ACTIONS(2512),
    [anon_sym_GT_LPAREN] = ACTIONS(2512),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2514),
    [sym_word] = ACTIONS(2514),
    [anon_sym_LF] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2514),
  },
  [3051] = {
    [sym_concatenation] = STATE(3549),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3549),
    [sym_regex] = ACTIONS(8035),
    [anon_sym_RBRACE] = ACTIONS(8007),
    [anon_sym_EQ] = ACTIONS(8021),
    [anon_sym_DASH] = ACTIONS(8021),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8023),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8021),
    [anon_sym_COLON_QMARK] = ACTIONS(8021),
    [anon_sym_COLON_DASH] = ACTIONS(8021),
    [anon_sym_PERCENT] = ACTIONS(8021),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3052] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8007),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3053] = {
    [sym__simple_heredoc_body] = ACTIONS(2520),
    [sym__heredoc_body_beginning] = ACTIONS(2520),
    [sym_file_descriptor] = ACTIONS(2520),
    [sym__concat] = ACTIONS(2520),
    [anon_sym_SEMI] = ACTIONS(2522),
    [anon_sym_fi] = ACTIONS(2522),
    [anon_sym_elif] = ACTIONS(2522),
    [anon_sym_else] = ACTIONS(2522),
    [anon_sym_PIPE] = ACTIONS(2522),
    [anon_sym_SEMI_SEMI] = ACTIONS(2520),
    [anon_sym_PIPE_AMP] = ACTIONS(2520),
    [anon_sym_AMP_AMP] = ACTIONS(2520),
    [anon_sym_PIPE_PIPE] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(2522),
    [anon_sym_GT] = ACTIONS(2522),
    [anon_sym_GT_GT] = ACTIONS(2520),
    [anon_sym_AMP_GT] = ACTIONS(2522),
    [anon_sym_AMP_GT_GT] = ACTIONS(2520),
    [anon_sym_LT_AMP] = ACTIONS(2520),
    [anon_sym_GT_AMP] = ACTIONS(2520),
    [anon_sym_LT_LT] = ACTIONS(2522),
    [anon_sym_LT_LT_DASH] = ACTIONS(2520),
    [anon_sym_LT_LT_LT] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(2522),
    [sym__special_character] = ACTIONS(2520),
    [anon_sym_DQUOTE] = ACTIONS(2520),
    [sym_raw_string] = ACTIONS(2520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2520),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2520),
    [anon_sym_BQUOTE] = ACTIONS(2520),
    [anon_sym_LT_LPAREN] = ACTIONS(2520),
    [anon_sym_GT_LPAREN] = ACTIONS(2520),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2522),
    [sym_word] = ACTIONS(2522),
    [anon_sym_LF] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2522),
  },
  [3054] = {
    [sym__simple_heredoc_body] = ACTIONS(2554),
    [sym__heredoc_body_beginning] = ACTIONS(2554),
    [sym_file_descriptor] = ACTIONS(2554),
    [sym__concat] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(2556),
    [anon_sym_fi] = ACTIONS(2556),
    [anon_sym_elif] = ACTIONS(2556),
    [anon_sym_else] = ACTIONS(2556),
    [anon_sym_PIPE] = ACTIONS(2556),
    [anon_sym_SEMI_SEMI] = ACTIONS(2554),
    [anon_sym_PIPE_AMP] = ACTIONS(2554),
    [anon_sym_AMP_AMP] = ACTIONS(2554),
    [anon_sym_PIPE_PIPE] = ACTIONS(2554),
    [anon_sym_LT] = ACTIONS(2556),
    [anon_sym_GT] = ACTIONS(2556),
    [anon_sym_GT_GT] = ACTIONS(2554),
    [anon_sym_AMP_GT] = ACTIONS(2556),
    [anon_sym_AMP_GT_GT] = ACTIONS(2554),
    [anon_sym_LT_AMP] = ACTIONS(2554),
    [anon_sym_GT_AMP] = ACTIONS(2554),
    [anon_sym_LT_LT] = ACTIONS(2556),
    [anon_sym_LT_LT_DASH] = ACTIONS(2554),
    [anon_sym_LT_LT_LT] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2556),
    [sym__special_character] = ACTIONS(2554),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2554),
    [anon_sym_BQUOTE] = ACTIONS(2554),
    [anon_sym_LT_LPAREN] = ACTIONS(2554),
    [anon_sym_GT_LPAREN] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2556),
    [sym_word] = ACTIONS(2556),
    [anon_sym_LF] = ACTIONS(2554),
    [anon_sym_AMP] = ACTIONS(2556),
  },
  [3055] = {
    [sym_string] = STATE(1668),
    [sym__simple_heredoc_body] = ACTIONS(4071),
    [sym__heredoc_body_beginning] = ACTIONS(4071),
    [sym_file_descriptor] = ACTIONS(4071),
    [anon_sym_SEMI] = ACTIONS(4073),
    [anon_sym_fi] = ACTIONS(4073),
    [anon_sym_elif] = ACTIONS(4073),
    [anon_sym_else] = ACTIONS(4073),
    [anon_sym_PIPE] = ACTIONS(4073),
    [anon_sym_SEMI_SEMI] = ACTIONS(4071),
    [anon_sym_PIPE_AMP] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_PIPE_PIPE] = ACTIONS(4071),
    [anon_sym_EQ_TILDE] = ACTIONS(4073),
    [anon_sym_EQ_EQ] = ACTIONS(4073),
    [anon_sym_LT] = ACTIONS(4073),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_GT_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT] = ACTIONS(4073),
    [anon_sym_AMP_GT_GT] = ACTIONS(4071),
    [anon_sym_LT_AMP] = ACTIONS(4071),
    [anon_sym_GT_AMP] = ACTIONS(4071),
    [anon_sym_LT_LT] = ACTIONS(4073),
    [anon_sym_LT_LT_DASH] = ACTIONS(4071),
    [anon_sym_LT_LT_LT] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(8037),
    [anon_sym_DOLLAR] = ACTIONS(8037),
    [sym__special_character] = ACTIONS(4071),
    [anon_sym_DQUOTE] = ACTIONS(1822),
    [sym_raw_string] = ACTIONS(3453),
    [anon_sym_POUND] = ACTIONS(3451),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4071),
    [anon_sym_BQUOTE] = ACTIONS(4071),
    [anon_sym_LT_LPAREN] = ACTIONS(4071),
    [anon_sym_GT_LPAREN] = ACTIONS(4071),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3455),
    [anon_sym_STAR] = ACTIONS(3455),
    [anon_sym_AT] = ACTIONS(3455),
    [anon_sym_QMARK] = ACTIONS(3455),
    [anon_sym_0] = ACTIONS(3455),
    [anon_sym__] = ACTIONS(3455),
    [sym_word] = ACTIONS(4073),
    [anon_sym_LF] = ACTIONS(4071),
    [anon_sym_AMP] = ACTIONS(4073),
  },
  [3056] = {
    [sym__simple_heredoc_body] = ACTIONS(4111),
    [sym__heredoc_body_beginning] = ACTIONS(4111),
    [sym_file_descriptor] = ACTIONS(4111),
    [sym__concat] = ACTIONS(4111),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_fi] = ACTIONS(4113),
    [anon_sym_elif] = ACTIONS(4113),
    [anon_sym_else] = ACTIONS(4113),
    [anon_sym_PIPE] = ACTIONS(4113),
    [anon_sym_SEMI_SEMI] = ACTIONS(4111),
    [anon_sym_PIPE_AMP] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_EQ_TILDE] = ACTIONS(4113),
    [anon_sym_EQ_EQ] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4113),
    [anon_sym_GT_GT] = ACTIONS(4111),
    [anon_sym_AMP_GT] = ACTIONS(4113),
    [anon_sym_AMP_GT_GT] = ACTIONS(4111),
    [anon_sym_LT_AMP] = ACTIONS(4111),
    [anon_sym_GT_AMP] = ACTIONS(4111),
    [anon_sym_LT_LT] = ACTIONS(4113),
    [anon_sym_LT_LT_DASH] = ACTIONS(4111),
    [anon_sym_LT_LT_LT] = ACTIONS(4111),
    [anon_sym_DOLLAR] = ACTIONS(4113),
    [sym__special_character] = ACTIONS(4111),
    [anon_sym_DQUOTE] = ACTIONS(4111),
    [sym_raw_string] = ACTIONS(4111),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4111),
    [anon_sym_BQUOTE] = ACTIONS(4111),
    [anon_sym_LT_LPAREN] = ACTIONS(4111),
    [anon_sym_GT_LPAREN] = ACTIONS(4111),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4113),
    [anon_sym_LF] = ACTIONS(4111),
    [anon_sym_AMP] = ACTIONS(4113),
  },
  [3057] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_fi] = ACTIONS(4127),
    [anon_sym_elif] = ACTIONS(4127),
    [anon_sym_else] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_EQ_TILDE] = ACTIONS(4127),
    [anon_sym_EQ_EQ] = ACTIONS(4127),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym__special_character] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [3058] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(8039),
    [sym_comment] = ACTIONS(57),
  },
  [3059] = {
    [anon_sym_RBRACE] = ACTIONS(8039),
    [sym_comment] = ACTIONS(57),
  },
  [3060] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(8041),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [3061] = {
    [sym_concatenation] = STATE(3557),
    [sym_string] = STATE(3556),
    [sym_simple_expansion] = STATE(3556),
    [sym_string_expansion] = STATE(3556),
    [sym_expansion] = STATE(3556),
    [sym_command_substitution] = STATE(3556),
    [sym_process_substitution] = STATE(3556),
    [aux_sym__literal_repeat1] = STATE(3558),
    [anon_sym_RBRACE] = ACTIONS(8039),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(8043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8043),
  },
  [3062] = {
    [sym__simple_heredoc_body] = ACTIONS(4161),
    [sym__heredoc_body_beginning] = ACTIONS(4161),
    [sym_file_descriptor] = ACTIONS(4161),
    [sym__concat] = ACTIONS(4161),
    [anon_sym_SEMI] = ACTIONS(4163),
    [anon_sym_fi] = ACTIONS(4163),
    [anon_sym_elif] = ACTIONS(4163),
    [anon_sym_else] = ACTIONS(4163),
    [anon_sym_PIPE] = ACTIONS(4163),
    [anon_sym_SEMI_SEMI] = ACTIONS(4161),
    [anon_sym_PIPE_AMP] = ACTIONS(4161),
    [anon_sym_AMP_AMP] = ACTIONS(4161),
    [anon_sym_PIPE_PIPE] = ACTIONS(4161),
    [anon_sym_EQ_TILDE] = ACTIONS(4163),
    [anon_sym_EQ_EQ] = ACTIONS(4163),
    [anon_sym_LT] = ACTIONS(4163),
    [anon_sym_GT] = ACTIONS(4163),
    [anon_sym_GT_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT] = ACTIONS(4163),
    [anon_sym_AMP_GT_GT] = ACTIONS(4161),
    [anon_sym_LT_AMP] = ACTIONS(4161),
    [anon_sym_GT_AMP] = ACTIONS(4161),
    [anon_sym_LT_LT] = ACTIONS(4163),
    [anon_sym_LT_LT_DASH] = ACTIONS(4161),
    [anon_sym_LT_LT_LT] = ACTIONS(4161),
    [anon_sym_DOLLAR] = ACTIONS(4163),
    [sym__special_character] = ACTIONS(4161),
    [anon_sym_DQUOTE] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4161),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4161),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4161),
    [anon_sym_BQUOTE] = ACTIONS(4161),
    [anon_sym_LT_LPAREN] = ACTIONS(4161),
    [anon_sym_GT_LPAREN] = ACTIONS(4161),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4163),
    [anon_sym_LF] = ACTIONS(4161),
    [anon_sym_AMP] = ACTIONS(4163),
  },
  [3063] = {
    [sym_concatenation] = STATE(3561),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3561),
    [sym_regex] = ACTIONS(8045),
    [anon_sym_RBRACE] = ACTIONS(8047),
    [anon_sym_EQ] = ACTIONS(8049),
    [anon_sym_DASH] = ACTIONS(8049),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8051),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8049),
    [anon_sym_COLON_QMARK] = ACTIONS(8049),
    [anon_sym_COLON_DASH] = ACTIONS(8049),
    [anon_sym_PERCENT] = ACTIONS(8049),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3064] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8047),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3065] = {
    [sym_concatenation] = STATE(3563),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3563),
    [sym_regex] = ACTIONS(8053),
    [anon_sym_RBRACE] = ACTIONS(8039),
    [anon_sym_EQ] = ACTIONS(8055),
    [anon_sym_DASH] = ACTIONS(8055),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8055),
    [anon_sym_COLON_QMARK] = ACTIONS(8055),
    [anon_sym_COLON_DASH] = ACTIONS(8055),
    [anon_sym_PERCENT] = ACTIONS(8055),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3066] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8039),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3067] = {
    [sym_concatenation] = STATE(3565),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3565),
    [anon_sym_RBRACE] = ACTIONS(8059),
    [anon_sym_EQ] = ACTIONS(8061),
    [anon_sym_DASH] = ACTIONS(8061),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8063),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8061),
    [anon_sym_COLON_QMARK] = ACTIONS(8061),
    [anon_sym_COLON_DASH] = ACTIONS(8061),
    [anon_sym_PERCENT] = ACTIONS(8061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3068] = {
    [sym__simple_heredoc_body] = ACTIONS(4219),
    [sym__heredoc_body_beginning] = ACTIONS(4219),
    [sym_file_descriptor] = ACTIONS(4219),
    [sym__concat] = ACTIONS(4219),
    [anon_sym_SEMI] = ACTIONS(4221),
    [anon_sym_fi] = ACTIONS(4221),
    [anon_sym_elif] = ACTIONS(4221),
    [anon_sym_else] = ACTIONS(4221),
    [anon_sym_PIPE] = ACTIONS(4221),
    [anon_sym_SEMI_SEMI] = ACTIONS(4219),
    [anon_sym_PIPE_AMP] = ACTIONS(4219),
    [anon_sym_AMP_AMP] = ACTIONS(4219),
    [anon_sym_PIPE_PIPE] = ACTIONS(4219),
    [anon_sym_EQ_TILDE] = ACTIONS(4221),
    [anon_sym_EQ_EQ] = ACTIONS(4221),
    [anon_sym_LT] = ACTIONS(4221),
    [anon_sym_GT] = ACTIONS(4221),
    [anon_sym_GT_GT] = ACTIONS(4219),
    [anon_sym_AMP_GT] = ACTIONS(4221),
    [anon_sym_AMP_GT_GT] = ACTIONS(4219),
    [anon_sym_LT_AMP] = ACTIONS(4219),
    [anon_sym_GT_AMP] = ACTIONS(4219),
    [anon_sym_LT_LT] = ACTIONS(4221),
    [anon_sym_LT_LT_DASH] = ACTIONS(4219),
    [anon_sym_LT_LT_LT] = ACTIONS(4219),
    [anon_sym_DOLLAR] = ACTIONS(4221),
    [sym__special_character] = ACTIONS(4219),
    [anon_sym_DQUOTE] = ACTIONS(4219),
    [sym_raw_string] = ACTIONS(4219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4219),
    [anon_sym_BQUOTE] = ACTIONS(4219),
    [anon_sym_LT_LPAREN] = ACTIONS(4219),
    [anon_sym_GT_LPAREN] = ACTIONS(4219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4221),
    [anon_sym_LF] = ACTIONS(4219),
    [anon_sym_AMP] = ACTIONS(4221),
  },
  [3069] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8059),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3070] = {
    [sym_concatenation] = STATE(3563),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3563),
    [anon_sym_RBRACE] = ACTIONS(8039),
    [anon_sym_EQ] = ACTIONS(8055),
    [anon_sym_DASH] = ACTIONS(8055),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8055),
    [anon_sym_COLON_QMARK] = ACTIONS(8055),
    [anon_sym_COLON_DASH] = ACTIONS(8055),
    [anon_sym_PERCENT] = ACTIONS(8055),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3071] = {
    [sym__simple_heredoc_body] = ACTIONS(8065),
    [sym__heredoc_body_beginning] = ACTIONS(8065),
    [sym_file_descriptor] = ACTIONS(8065),
    [ts_builtin_sym_end] = ACTIONS(8065),
    [anon_sym_SEMI] = ACTIONS(8067),
    [anon_sym_done] = ACTIONS(8065),
    [anon_sym_fi] = ACTIONS(8065),
    [anon_sym_elif] = ACTIONS(8065),
    [anon_sym_else] = ACTIONS(8065),
    [anon_sym_esac] = ACTIONS(8065),
    [anon_sym_PIPE] = ACTIONS(8067),
    [anon_sym_RPAREN] = ACTIONS(8065),
    [anon_sym_SEMI_SEMI] = ACTIONS(8065),
    [anon_sym_PIPE_AMP] = ACTIONS(8065),
    [anon_sym_AMP_AMP] = ACTIONS(8065),
    [anon_sym_PIPE_PIPE] = ACTIONS(8065),
    [anon_sym_LT] = ACTIONS(8067),
    [anon_sym_GT] = ACTIONS(8067),
    [anon_sym_GT_GT] = ACTIONS(8065),
    [anon_sym_AMP_GT] = ACTIONS(8067),
    [anon_sym_AMP_GT_GT] = ACTIONS(8065),
    [anon_sym_LT_AMP] = ACTIONS(8065),
    [anon_sym_GT_AMP] = ACTIONS(8065),
    [anon_sym_LT_LT] = ACTIONS(8067),
    [anon_sym_LT_LT_DASH] = ACTIONS(8065),
    [anon_sym_LT_LT_LT] = ACTIONS(8065),
    [anon_sym_BQUOTE] = ACTIONS(8065),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8065),
    [anon_sym_AMP] = ACTIONS(8067),
  },
  [3072] = {
    [aux_sym_concatenation_repeat1] = STATE(3074),
    [sym__simple_heredoc_body] = ACTIONS(1380),
    [sym__heredoc_body_beginning] = ACTIONS(1380),
    [sym_file_descriptor] = ACTIONS(1380),
    [sym__concat] = ACTIONS(6367),
    [anon_sym_SEMI] = ACTIONS(1382),
    [anon_sym_fi] = ACTIONS(1380),
    [anon_sym_elif] = ACTIONS(1380),
    [anon_sym_else] = ACTIONS(1380),
    [anon_sym_PIPE] = ACTIONS(1382),
    [anon_sym_SEMI_SEMI] = ACTIONS(1380),
    [anon_sym_PIPE_AMP] = ACTIONS(1380),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_PIPE_PIPE] = ACTIONS(1380),
    [anon_sym_LT] = ACTIONS(1382),
    [anon_sym_GT] = ACTIONS(1382),
    [anon_sym_GT_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT] = ACTIONS(1382),
    [anon_sym_AMP_GT_GT] = ACTIONS(1380),
    [anon_sym_LT_AMP] = ACTIONS(1380),
    [anon_sym_GT_AMP] = ACTIONS(1380),
    [anon_sym_LT_LT] = ACTIONS(1382),
    [anon_sym_LT_LT_DASH] = ACTIONS(1380),
    [anon_sym_LT_LT_LT] = ACTIONS(1380),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1380),
    [anon_sym_AMP] = ACTIONS(1382),
  },
  [3073] = {
    [aux_sym__literal_repeat1] = STATE(3075),
    [sym__simple_heredoc_body] = ACTIONS(1384),
    [sym__heredoc_body_beginning] = ACTIONS(1384),
    [sym_file_descriptor] = ACTIONS(1384),
    [anon_sym_SEMI] = ACTIONS(1386),
    [anon_sym_fi] = ACTIONS(1384),
    [anon_sym_elif] = ACTIONS(1384),
    [anon_sym_else] = ACTIONS(1384),
    [anon_sym_PIPE] = ACTIONS(1386),
    [anon_sym_SEMI_SEMI] = ACTIONS(1384),
    [anon_sym_PIPE_AMP] = ACTIONS(1384),
    [anon_sym_AMP_AMP] = ACTIONS(1384),
    [anon_sym_PIPE_PIPE] = ACTIONS(1384),
    [anon_sym_LT] = ACTIONS(1386),
    [anon_sym_GT] = ACTIONS(1386),
    [anon_sym_GT_GT] = ACTIONS(1384),
    [anon_sym_AMP_GT] = ACTIONS(1386),
    [anon_sym_AMP_GT_GT] = ACTIONS(1384),
    [anon_sym_LT_AMP] = ACTIONS(1384),
    [anon_sym_GT_AMP] = ACTIONS(1384),
    [anon_sym_LT_LT] = ACTIONS(1386),
    [anon_sym_LT_LT_DASH] = ACTIONS(1384),
    [anon_sym_LT_LT_LT] = ACTIONS(1384),
    [sym__special_character] = ACTIONS(6383),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1384),
    [anon_sym_AMP] = ACTIONS(1386),
  },
  [3074] = {
    [aux_sym_concatenation_repeat1] = STATE(3567),
    [sym__simple_heredoc_body] = ACTIONS(1071),
    [sym__heredoc_body_beginning] = ACTIONS(1071),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(8069),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_fi] = ACTIONS(1071),
    [anon_sym_elif] = ACTIONS(1071),
    [anon_sym_else] = ACTIONS(1071),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1075),
  },
  [3075] = {
    [aux_sym__literal_repeat1] = STATE(3075),
    [sym__simple_heredoc_body] = ACTIONS(1373),
    [sym__heredoc_body_beginning] = ACTIONS(1373),
    [sym_file_descriptor] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_fi] = ACTIONS(1373),
    [anon_sym_elif] = ACTIONS(1373),
    [anon_sym_else] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE_AMP] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_LT_LT_DASH] = ACTIONS(1373),
    [anon_sym_LT_LT_LT] = ACTIONS(1373),
    [sym__special_character] = ACTIONS(7647),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
  },
  [3076] = {
    [sym_file_descriptor] = ACTIONS(2604),
    [sym_variable_name] = ACTIONS(2604),
    [anon_sym_for] = ACTIONS(2608),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2608),
    [anon_sym_if] = ACTIONS(2608),
    [anon_sym_fi] = ACTIONS(7650),
    [anon_sym_elif] = ACTIONS(7650),
    [anon_sym_else] = ACTIONS(7650),
    [anon_sym_case] = ACTIONS(2608),
    [anon_sym_function] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(2608),
    [anon_sym_LBRACE] = ACTIONS(2604),
    [anon_sym_BANG] = ACTIONS(2608),
    [anon_sym_LBRACK] = ACTIONS(2608),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2604),
    [anon_sym_declare] = ACTIONS(2608),
    [anon_sym_typeset] = ACTIONS(2608),
    [anon_sym_export] = ACTIONS(2608),
    [anon_sym_readonly] = ACTIONS(2608),
    [anon_sym_local] = ACTIONS(2608),
    [anon_sym_unset] = ACTIONS(2608),
    [anon_sym_unsetenv] = ACTIONS(2608),
    [anon_sym_LT] = ACTIONS(2608),
    [anon_sym_GT] = ACTIONS(2608),
    [anon_sym_GT_GT] = ACTIONS(2604),
    [anon_sym_AMP_GT] = ACTIONS(2608),
    [anon_sym_AMP_GT_GT] = ACTIONS(2604),
    [anon_sym_LT_AMP] = ACTIONS(2604),
    [anon_sym_GT_AMP] = ACTIONS(2604),
    [anon_sym_DOLLAR] = ACTIONS(2608),
    [sym__special_character] = ACTIONS(2608),
    [anon_sym_DQUOTE] = ACTIONS(2604),
    [sym_raw_string] = ACTIONS(2604),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2604),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2604),
    [anon_sym_BQUOTE] = ACTIONS(2604),
    [anon_sym_LT_LPAREN] = ACTIONS(2604),
    [anon_sym_GT_LPAREN] = ACTIONS(2604),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2608),
  },
  [3077] = {
    [sym_string] = STATE(1433),
    [sym_simple_expansion] = STATE(1433),
    [sym_string_expansion] = STATE(1433),
    [sym_expansion] = STATE(1433),
    [sym_command_substitution] = STATE(1433),
    [sym_process_substitution] = STATE(1433),
    [anon_sym_DOLLAR] = ACTIONS(8071),
    [sym__special_character] = ACTIONS(2891),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(2891),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2891),
  },
  [3078] = {
    [aux_sym_concatenation_repeat1] = STATE(3078),
    [sym__concat] = ACTIONS(4636),
    [anon_sym_PIPE] = ACTIONS(2362),
    [anon_sym_RPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
  },
  [3079] = {
    [aux_sym_concatenation_repeat1] = STATE(2437),
    [sym__concat] = ACTIONS(1518),
    [anon_sym_PIPE] = ACTIONS(8073),
    [anon_sym_RPAREN] = ACTIONS(8073),
    [sym_comment] = ACTIONS(57),
  },
  [3080] = {
    [anon_sym_PIPE] = ACTIONS(8073),
    [anon_sym_RPAREN] = ACTIONS(8073),
    [sym_comment] = ACTIONS(57),
  },
  [3081] = {
    [aux_sym__literal_repeat1] = STATE(2446),
    [anon_sym_PIPE] = ACTIONS(8075),
    [anon_sym_RPAREN] = ACTIONS(8075),
    [sym__special_character] = ACTIONS(1544),
    [sym_comment] = ACTIONS(57),
  },
  [3082] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(8077),
    [anon_sym_PLUS_EQ] = ACTIONS(8077),
    [sym_comment] = ACTIONS(57),
  },
  [3083] = {
    [anon_sym_esac] = ACTIONS(8079),
    [anon_sym_DOLLAR] = ACTIONS(8081),
    [sym__special_character] = ACTIONS(8083),
    [anon_sym_DQUOTE] = ACTIONS(8083),
    [sym_raw_string] = ACTIONS(8083),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8083),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8083),
    [anon_sym_BQUOTE] = ACTIONS(8083),
    [anon_sym_LT_LPAREN] = ACTIONS(8083),
    [anon_sym_GT_LPAREN] = ACTIONS(8083),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8081),
  },
  [3084] = {
    [sym_subshell] = STATE(146),
    [sym_test_command] = STATE(146),
    [sym_command] = STATE(146),
    [sym_command_name] = STATE(3098),
    [sym_variable_assignment] = STATE(3103),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(3103),
    [sym_concatenation] = STATE(3101),
    [sym_string] = STATE(3090),
    [sym_simple_expansion] = STATE(3090),
    [sym_string_expansion] = STATE(3090),
    [sym_expansion] = STATE(3090),
    [sym_command_substitution] = STATE(3090),
    [sym_process_substitution] = STATE(3090),
    [aux_sym_command_repeat1] = STATE(3103),
    [aux_sym__literal_repeat1] = STATE(3104),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(6864),
    [sym__special_character] = ACTIONS(6866),
    [anon_sym_DQUOTE] = ACTIONS(6868),
    [sym_raw_string] = ACTIONS(6870),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6874),
    [anon_sym_BQUOTE] = ACTIONS(6876),
    [anon_sym_LT_LPAREN] = ACTIONS(6878),
    [anon_sym_GT_LPAREN] = ACTIONS(6878),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6870),
  },
  [3085] = {
    [sym_variable_assignment] = STATE(3580),
    [sym_subscript] = STATE(3579),
    [sym_concatenation] = STATE(3580),
    [sym_string] = STATE(3574),
    [sym_simple_expansion] = STATE(3574),
    [sym_string_expansion] = STATE(3574),
    [sym_expansion] = STATE(3574),
    [sym_command_substitution] = STATE(3574),
    [sym_process_substitution] = STATE(3574),
    [aux_sym_declaration_command_repeat1] = STATE(3580),
    [aux_sym__literal_repeat1] = STATE(3581),
    [sym__simple_heredoc_body] = ACTIONS(259),
    [sym__heredoc_body_beginning] = ACTIONS(259),
    [sym_file_descriptor] = ACTIONS(259),
    [sym_variable_name] = ACTIONS(8085),
    [anon_sym_SEMI] = ACTIONS(263),
    [anon_sym_esac] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_SEMI_SEMI] = ACTIONS(259),
    [anon_sym_PIPE_AMP] = ACTIONS(259),
    [anon_sym_AMP_AMP] = ACTIONS(259),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_LT] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_GT_GT] = ACTIONS(259),
    [anon_sym_AMP_GT] = ACTIONS(263),
    [anon_sym_AMP_GT_GT] = ACTIONS(259),
    [anon_sym_LT_AMP] = ACTIONS(259),
    [anon_sym_GT_AMP] = ACTIONS(259),
    [anon_sym_LT_LT] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(259),
    [anon_sym_LT_LT_LT] = ACTIONS(259),
    [anon_sym_DOLLAR] = ACTIONS(8087),
    [sym__special_character] = ACTIONS(8089),
    [anon_sym_DQUOTE] = ACTIONS(8091),
    [sym_raw_string] = ACTIONS(8093),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8097),
    [anon_sym_BQUOTE] = ACTIONS(8099),
    [anon_sym_LT_LPAREN] = ACTIONS(8101),
    [anon_sym_GT_LPAREN] = ACTIONS(8101),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8103),
    [sym_word] = ACTIONS(8105),
    [anon_sym_LF] = ACTIONS(259),
    [anon_sym_AMP] = ACTIONS(263),
  },
  [3086] = {
    [sym_concatenation] = STATE(3590),
    [sym_string] = STATE(3585),
    [sym_simple_expansion] = STATE(3585),
    [sym_string_expansion] = STATE(3585),
    [sym_expansion] = STATE(3585),
    [sym_command_substitution] = STATE(3585),
    [sym_process_substitution] = STATE(3585),
    [aux_sym_unset_command_repeat1] = STATE(3590),
    [aux_sym__literal_repeat1] = STATE(3591),
    [sym__simple_heredoc_body] = ACTIONS(285),
    [sym__heredoc_body_beginning] = ACTIONS(285),
    [sym_file_descriptor] = ACTIONS(285),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym_esac] = ACTIONS(287),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(285),
    [anon_sym_PIPE_AMP] = ACTIONS(285),
    [anon_sym_AMP_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(287),
    [anon_sym_GT] = ACTIONS(287),
    [anon_sym_GT_GT] = ACTIONS(285),
    [anon_sym_AMP_GT] = ACTIONS(287),
    [anon_sym_AMP_GT_GT] = ACTIONS(285),
    [anon_sym_LT_AMP] = ACTIONS(285),
    [anon_sym_GT_AMP] = ACTIONS(285),
    [anon_sym_LT_LT] = ACTIONS(287),
    [anon_sym_LT_LT_DASH] = ACTIONS(285),
    [anon_sym_LT_LT_LT] = ACTIONS(285),
    [anon_sym_DOLLAR] = ACTIONS(8107),
    [sym__special_character] = ACTIONS(8109),
    [anon_sym_DQUOTE] = ACTIONS(8111),
    [sym_raw_string] = ACTIONS(8113),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8115),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8117),
    [anon_sym_BQUOTE] = ACTIONS(8119),
    [anon_sym_LT_LPAREN] = ACTIONS(8121),
    [anon_sym_GT_LPAREN] = ACTIONS(8121),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8123),
    [sym_word] = ACTIONS(8125),
    [anon_sym_LF] = ACTIONS(285),
    [anon_sym_AMP] = ACTIONS(287),
  },
  [3087] = {
    [sym_string] = STATE(3593),
    [anon_sym_DASH] = ACTIONS(8127),
    [anon_sym_DOLLAR] = ACTIONS(8127),
    [anon_sym_DQUOTE] = ACTIONS(6868),
    [sym_raw_string] = ACTIONS(8129),
    [anon_sym_POUND] = ACTIONS(8127),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8131),
    [anon_sym_STAR] = ACTIONS(8133),
    [anon_sym_AT] = ACTIONS(8133),
    [anon_sym_QMARK] = ACTIONS(8133),
    [anon_sym_0] = ACTIONS(8131),
    [anon_sym__] = ACTIONS(8131),
  },
  [3088] = {
    [aux_sym_concatenation_repeat1] = STATE(3596),
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(8135),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_esac] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_EQ_TILDE] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [3089] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(3599),
    [anon_sym_DOLLAR] = ACTIONS(8137),
    [anon_sym_DQUOTE] = ACTIONS(8139),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [3090] = {
    [aux_sym_concatenation_repeat1] = STATE(3596),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(8135),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_esac] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [3091] = {
    [sym_subscript] = STATE(3603),
    [sym_variable_name] = ACTIONS(8141),
    [anon_sym_BANG] = ACTIONS(8143),
    [anon_sym_DASH] = ACTIONS(8145),
    [anon_sym_DOLLAR] = ACTIONS(8145),
    [anon_sym_POUND] = ACTIONS(8143),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8147),
    [anon_sym_STAR] = ACTIONS(8149),
    [anon_sym_AT] = ACTIONS(8149),
    [anon_sym_QMARK] = ACTIONS(8149),
    [anon_sym_0] = ACTIONS(8147),
    [anon_sym__] = ACTIONS(8147),
  },
  [3092] = {
    [sym__statements] = STATE(3604),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(3605),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [3093] = {
    [sym__statements] = STATE(3606),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [3094] = {
    [sym__statements] = STATE(3607),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [3095] = {
    [aux_sym_concatenation_repeat1] = STATE(3596),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(8135),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_esac] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_LPAREN] = ACTIONS(387),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [3096] = {
    [anon_sym_esac] = ACTIONS(8151),
    [anon_sym_SEMI_SEMI] = ACTIONS(8153),
    [sym_comment] = ACTIONS(57),
  },
  [3097] = {
    [sym_file_redirect] = STATE(3616),
    [sym_heredoc_redirect] = STATE(3616),
    [sym_heredoc_body] = STATE(3615),
    [sym_herestring_redirect] = STATE(3616),
    [aux_sym_redirected_statement_repeat1] = STATE(3616),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(8155),
    [anon_sym_SEMI] = ACTIONS(8157),
    [anon_sym_esac] = ACTIONS(399),
    [anon_sym_PIPE] = ACTIONS(8159),
    [anon_sym_SEMI_SEMI] = ACTIONS(399),
    [anon_sym_PIPE_AMP] = ACTIONS(8161),
    [anon_sym_AMP_AMP] = ACTIONS(8163),
    [anon_sym_PIPE_PIPE] = ACTIONS(8163),
    [anon_sym_LT] = ACTIONS(8165),
    [anon_sym_GT] = ACTIONS(8165),
    [anon_sym_GT_GT] = ACTIONS(8167),
    [anon_sym_AMP_GT] = ACTIONS(8165),
    [anon_sym_AMP_GT_GT] = ACTIONS(8167),
    [anon_sym_LT_AMP] = ACTIONS(8167),
    [anon_sym_GT_AMP] = ACTIONS(8167),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(8169),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8171),
    [anon_sym_AMP] = ACTIONS(8157),
  },
  [3098] = {
    [sym_concatenation] = STATE(3619),
    [sym_string] = STATE(3618),
    [sym_simple_expansion] = STATE(3618),
    [sym_string_expansion] = STATE(3618),
    [sym_expansion] = STATE(3618),
    [sym_command_substitution] = STATE(3618),
    [sym_process_substitution] = STATE(3618),
    [aux_sym_command_repeat2] = STATE(3619),
    [aux_sym__literal_repeat1] = STATE(3620),
    [sym__simple_heredoc_body] = ACTIONS(421),
    [sym__heredoc_body_beginning] = ACTIONS(421),
    [sym_file_descriptor] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_esac] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI_SEMI] = ACTIONS(421),
    [anon_sym_PIPE_AMP] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(8173),
    [anon_sym_EQ_EQ] = ACTIONS(8173),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_AMP_GT] = ACTIONS(423),
    [anon_sym_AMP_GT_GT] = ACTIONS(421),
    [anon_sym_LT_AMP] = ACTIONS(421),
    [anon_sym_GT_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_LT_LT_DASH] = ACTIONS(421),
    [anon_sym_LT_LT_LT] = ACTIONS(421),
    [anon_sym_DOLLAR] = ACTIONS(6864),
    [sym__special_character] = ACTIONS(8175),
    [anon_sym_DQUOTE] = ACTIONS(6868),
    [sym_raw_string] = ACTIONS(8177),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6874),
    [anon_sym_BQUOTE] = ACTIONS(6876),
    [anon_sym_LT_LPAREN] = ACTIONS(6878),
    [anon_sym_GT_LPAREN] = ACTIONS(6878),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8179),
    [anon_sym_LF] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
  },
  [3099] = {
    [sym_file_redirect] = STATE(3616),
    [sym_heredoc_redirect] = STATE(3616),
    [sym_heredoc_body] = STATE(3615),
    [sym_herestring_redirect] = STATE(3616),
    [aux_sym_redirected_statement_repeat1] = STATE(3616),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(8157),
    [anon_sym_esac] = ACTIONS(3321),
    [anon_sym_PIPE] = ACTIONS(8159),
    [anon_sym_SEMI_SEMI] = ACTIONS(399),
    [anon_sym_PIPE_AMP] = ACTIONS(8161),
    [anon_sym_AMP_AMP] = ACTIONS(8163),
    [anon_sym_PIPE_PIPE] = ACTIONS(8163),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(8169),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(8171),
    [anon_sym_AMP] = ACTIONS(8157),
  },
  [3100] = {
    [anon_sym_EQ] = ACTIONS(8077),
    [anon_sym_PLUS_EQ] = ACTIONS(8077),
    [sym_comment] = ACTIONS(57),
  },
  [3101] = {
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_esac] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [3102] = {
    [sym_redirected_statement] = STATE(3621),
    [sym_for_statement] = STATE(3621),
    [sym_c_style_for_statement] = STATE(3621),
    [sym_while_statement] = STATE(3621),
    [sym_if_statement] = STATE(3621),
    [sym_case_statement] = STATE(3621),
    [sym_function_definition] = STATE(3621),
    [sym_compound_statement] = STATE(3621),
    [sym_subshell] = STATE(3621),
    [sym_pipeline] = STATE(3621),
    [sym_list] = STATE(3621),
    [sym_negated_command] = STATE(3621),
    [sym_test_command] = STATE(3621),
    [sym_declaration_command] = STATE(3621),
    [sym_unset_command] = STATE(3621),
    [sym_command] = STATE(3621),
    [sym_command_name] = STATE(3098),
    [sym_variable_assignment] = STATE(3622),
    [sym_subscript] = STATE(3100),
    [sym_file_redirect] = STATE(3103),
    [sym_concatenation] = STATE(3101),
    [sym_string] = STATE(3090),
    [sym_simple_expansion] = STATE(3090),
    [sym_string_expansion] = STATE(3090),
    [sym_expansion] = STATE(3090),
    [sym_command_substitution] = STATE(3090),
    [sym_process_substitution] = STATE(3090),
    [aux_sym__statements_repeat1] = STATE(251),
    [aux_sym_command_repeat1] = STATE(3103),
    [aux_sym__literal_repeat1] = STATE(3104),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(6852),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(6858),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(6860),
    [anon_sym_typeset] = ACTIONS(6860),
    [anon_sym_export] = ACTIONS(6860),
    [anon_sym_readonly] = ACTIONS(6860),
    [anon_sym_local] = ACTIONS(6860),
    [anon_sym_unset] = ACTIONS(6862),
    [anon_sym_unsetenv] = ACTIONS(6862),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(6864),
    [sym__special_character] = ACTIONS(6866),
    [anon_sym_DQUOTE] = ACTIONS(6868),
    [sym_raw_string] = ACTIONS(6870),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6874),
    [anon_sym_BQUOTE] = ACTIONS(6876),
    [anon_sym_LT_LPAREN] = ACTIONS(6878),
    [anon_sym_GT_LPAREN] = ACTIONS(6878),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6880),
  },
  [3103] = {
    [sym_command_name] = STATE(3623),
    [sym_variable_assignment] = STATE(253),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(253),
    [sym_concatenation] = STATE(3101),
    [sym_string] = STATE(3090),
    [sym_simple_expansion] = STATE(3090),
    [sym_string_expansion] = STATE(3090),
    [sym_expansion] = STATE(3090),
    [sym_command_substitution] = STATE(3090),
    [sym_process_substitution] = STATE(3090),
    [aux_sym_command_repeat1] = STATE(253),
    [aux_sym__literal_repeat1] = STATE(3104),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(6864),
    [sym__special_character] = ACTIONS(8175),
    [anon_sym_DQUOTE] = ACTIONS(6868),
    [sym_raw_string] = ACTIONS(6870),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6874),
    [anon_sym_BQUOTE] = ACTIONS(6876),
    [anon_sym_LT_LPAREN] = ACTIONS(6878),
    [anon_sym_GT_LPAREN] = ACTIONS(6878),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6870),
  },
  [3104] = {
    [aux_sym__literal_repeat1] = STATE(3625),
    [sym__simple_heredoc_body] = ACTIONS(437),
    [sym__heredoc_body_beginning] = ACTIONS(437),
    [sym_file_descriptor] = ACTIONS(437),
    [anon_sym_SEMI] = ACTIONS(439),
    [anon_sym_esac] = ACTIONS(439),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI_SEMI] = ACTIONS(437),
    [anon_sym_PIPE_AMP] = ACTIONS(437),
    [anon_sym_AMP_AMP] = ACTIONS(437),
    [anon_sym_PIPE_PIPE] = ACTIONS(437),
    [anon_sym_EQ_TILDE] = ACTIONS(439),
    [anon_sym_EQ_EQ] = ACTIONS(439),
    [anon_sym_LT] = ACTIONS(439),
    [anon_sym_GT] = ACTIONS(439),
    [anon_sym_GT_GT] = ACTIONS(437),
    [anon_sym_AMP_GT] = ACTIONS(439),
    [anon_sym_AMP_GT_GT] = ACTIONS(437),
    [anon_sym_LT_AMP] = ACTIONS(437),
    [anon_sym_GT_AMP] = ACTIONS(437),
    [anon_sym_LT_LT] = ACTIONS(439),
    [anon_sym_LT_LT_DASH] = ACTIONS(437),
    [anon_sym_LT_LT_LT] = ACTIONS(437),
    [anon_sym_DOLLAR] = ACTIONS(439),
    [sym__special_character] = ACTIONS(8181),
    [anon_sym_DQUOTE] = ACTIONS(437),
    [sym_raw_string] = ACTIONS(437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(437),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(437),
    [anon_sym_BQUOTE] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(437),
    [anon_sym_GT_LPAREN] = ACTIONS(437),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(439),
    [anon_sym_LF] = ACTIONS(437),
    [anon_sym_AMP] = ACTIONS(439),
  },
  [3105] = {
    [sym__statements] = STATE(3626),
    [sym_redirected_statement] = STATE(3097),
    [sym_for_statement] = STATE(3097),
    [sym_c_style_for_statement] = STATE(3097),
    [sym_while_statement] = STATE(3097),
    [sym_if_statement] = STATE(3097),
    [sym_case_statement] = STATE(3097),
    [sym_function_definition] = STATE(3097),
    [sym_compound_statement] = STATE(3097),
    [sym_subshell] = STATE(3097),
    [sym_pipeline] = STATE(3097),
    [sym_list] = STATE(3097),
    [sym_negated_command] = STATE(3097),
    [sym_test_command] = STATE(3097),
    [sym_declaration_command] = STATE(3097),
    [sym_unset_command] = STATE(3097),
    [sym_command] = STATE(3097),
    [sym_command_name] = STATE(3098),
    [sym_variable_assignment] = STATE(3099),
    [sym_subscript] = STATE(3100),
    [sym_file_redirect] = STATE(3103),
    [sym_concatenation] = STATE(3101),
    [sym_string] = STATE(3090),
    [sym_simple_expansion] = STATE(3090),
    [sym_string_expansion] = STATE(3090),
    [sym_expansion] = STATE(3090),
    [sym_command_substitution] = STATE(3090),
    [sym_process_substitution] = STATE(3090),
    [aux_sym__statements_repeat1] = STATE(3102),
    [aux_sym_command_repeat1] = STATE(3103),
    [aux_sym__literal_repeat1] = STATE(3104),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(6852),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_esac] = ACTIONS(8079),
    [anon_sym_SEMI_SEMI] = ACTIONS(8153),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(6858),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(6860),
    [anon_sym_typeset] = ACTIONS(6860),
    [anon_sym_export] = ACTIONS(6860),
    [anon_sym_readonly] = ACTIONS(6860),
    [anon_sym_local] = ACTIONS(6860),
    [anon_sym_unset] = ACTIONS(6862),
    [anon_sym_unsetenv] = ACTIONS(6862),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(6864),
    [sym__special_character] = ACTIONS(6866),
    [anon_sym_DQUOTE] = ACTIONS(6868),
    [sym_raw_string] = ACTIONS(6870),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6874),
    [anon_sym_BQUOTE] = ACTIONS(6876),
    [anon_sym_LT_LPAREN] = ACTIONS(6878),
    [anon_sym_GT_LPAREN] = ACTIONS(6878),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6880),
  },
  [3106] = {
    [aux_sym_case_item_repeat1] = STATE(3106),
    [anon_sym_PIPE] = ACTIONS(8183),
    [anon_sym_RPAREN] = ACTIONS(8073),
    [sym_comment] = ACTIONS(57),
  },
  [3107] = {
    [sym__simple_heredoc_body] = ACTIONS(8186),
    [sym__heredoc_body_beginning] = ACTIONS(8186),
    [sym_file_descriptor] = ACTIONS(8186),
    [ts_builtin_sym_end] = ACTIONS(8186),
    [anon_sym_SEMI] = ACTIONS(8188),
    [anon_sym_done] = ACTIONS(8186),
    [anon_sym_fi] = ACTIONS(8186),
    [anon_sym_elif] = ACTIONS(8186),
    [anon_sym_else] = ACTIONS(8186),
    [anon_sym_esac] = ACTIONS(8186),
    [anon_sym_PIPE] = ACTIONS(8188),
    [anon_sym_RPAREN] = ACTIONS(8186),
    [anon_sym_SEMI_SEMI] = ACTIONS(8186),
    [anon_sym_PIPE_AMP] = ACTIONS(8186),
    [anon_sym_AMP_AMP] = ACTIONS(8186),
    [anon_sym_PIPE_PIPE] = ACTIONS(8186),
    [anon_sym_LT] = ACTIONS(8188),
    [anon_sym_GT] = ACTIONS(8188),
    [anon_sym_GT_GT] = ACTIONS(8186),
    [anon_sym_AMP_GT] = ACTIONS(8188),
    [anon_sym_AMP_GT_GT] = ACTIONS(8186),
    [anon_sym_LT_AMP] = ACTIONS(8186),
    [anon_sym_GT_AMP] = ACTIONS(8186),
    [anon_sym_LT_LT] = ACTIONS(8188),
    [anon_sym_LT_LT_DASH] = ACTIONS(8186),
    [anon_sym_LT_LT_LT] = ACTIONS(8186),
    [anon_sym_BQUOTE] = ACTIONS(8186),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8186),
    [anon_sym_AMP] = ACTIONS(8188),
  },
  [3108] = {
    [aux_sym_case_item_repeat1] = STATE(3628),
    [aux_sym_concatenation_repeat1] = STATE(2437),
    [sym__concat] = ACTIONS(1518),
    [anon_sym_PIPE] = ACTIONS(5289),
    [anon_sym_RPAREN] = ACTIONS(8190),
    [sym_comment] = ACTIONS(57),
  },
  [3109] = {
    [aux_sym_case_item_repeat1] = STATE(3628),
    [anon_sym_PIPE] = ACTIONS(5289),
    [anon_sym_RPAREN] = ACTIONS(8190),
    [sym_comment] = ACTIONS(57),
  },
  [3110] = {
    [aux_sym_case_item_repeat1] = STATE(3630),
    [aux_sym__literal_repeat1] = STATE(2446),
    [anon_sym_PIPE] = ACTIONS(5289),
    [anon_sym_RPAREN] = ACTIONS(8192),
    [sym__special_character] = ACTIONS(1544),
    [sym_comment] = ACTIONS(57),
  },
  [3111] = {
    [anon_sym_esac] = ACTIONS(8194),
    [anon_sym_DOLLAR] = ACTIONS(8196),
    [sym__special_character] = ACTIONS(8198),
    [anon_sym_DQUOTE] = ACTIONS(8198),
    [sym_raw_string] = ACTIONS(8198),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8198),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8198),
    [anon_sym_BQUOTE] = ACTIONS(8198),
    [anon_sym_LT_LPAREN] = ACTIONS(8198),
    [anon_sym_GT_LPAREN] = ACTIONS(8198),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8196),
  },
  [3112] = {
    [anon_sym_esac] = ACTIONS(8200),
    [anon_sym_SEMI_SEMI] = ACTIONS(8202),
    [sym_comment] = ACTIONS(57),
  },
  [3113] = {
    [sym__statements] = STATE(3632),
    [sym_redirected_statement] = STATE(3097),
    [sym_for_statement] = STATE(3097),
    [sym_c_style_for_statement] = STATE(3097),
    [sym_while_statement] = STATE(3097),
    [sym_if_statement] = STATE(3097),
    [sym_case_statement] = STATE(3097),
    [sym_function_definition] = STATE(3097),
    [sym_compound_statement] = STATE(3097),
    [sym_subshell] = STATE(3097),
    [sym_pipeline] = STATE(3097),
    [sym_list] = STATE(3097),
    [sym_negated_command] = STATE(3097),
    [sym_test_command] = STATE(3097),
    [sym_declaration_command] = STATE(3097),
    [sym_unset_command] = STATE(3097),
    [sym_command] = STATE(3097),
    [sym_command_name] = STATE(3098),
    [sym_variable_assignment] = STATE(3099),
    [sym_subscript] = STATE(3100),
    [sym_file_redirect] = STATE(3103),
    [sym_concatenation] = STATE(3101),
    [sym_string] = STATE(3090),
    [sym_simple_expansion] = STATE(3090),
    [sym_string_expansion] = STATE(3090),
    [sym_expansion] = STATE(3090),
    [sym_command_substitution] = STATE(3090),
    [sym_process_substitution] = STATE(3090),
    [aux_sym__statements_repeat1] = STATE(3102),
    [aux_sym_command_repeat1] = STATE(3103),
    [aux_sym__literal_repeat1] = STATE(3104),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(6852),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_esac] = ACTIONS(8194),
    [anon_sym_SEMI_SEMI] = ACTIONS(8202),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(6858),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(6860),
    [anon_sym_typeset] = ACTIONS(6860),
    [anon_sym_export] = ACTIONS(6860),
    [anon_sym_readonly] = ACTIONS(6860),
    [anon_sym_local] = ACTIONS(6860),
    [anon_sym_unset] = ACTIONS(6862),
    [anon_sym_unsetenv] = ACTIONS(6862),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(6864),
    [sym__special_character] = ACTIONS(6866),
    [anon_sym_DQUOTE] = ACTIONS(6868),
    [sym_raw_string] = ACTIONS(6870),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6874),
    [anon_sym_BQUOTE] = ACTIONS(6876),
    [anon_sym_LT_LPAREN] = ACTIONS(6878),
    [anon_sym_GT_LPAREN] = ACTIONS(6878),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6880),
  },
  [3114] = {
    [anon_sym_esac] = ACTIONS(8204),
    [sym_comment] = ACTIONS(57),
  },
  [3115] = {
    [sym__concat] = ACTIONS(7198),
    [anon_sym_in] = ACTIONS(7198),
    [anon_sym_SEMI] = ACTIONS(7200),
    [anon_sym_SEMI_SEMI] = ACTIONS(7198),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(7198),
    [anon_sym_AMP] = ACTIONS(7198),
  },
  [3116] = {
    [sym__concat] = ACTIONS(7202),
    [anon_sym_in] = ACTIONS(7202),
    [anon_sym_SEMI] = ACTIONS(7204),
    [anon_sym_SEMI_SEMI] = ACTIONS(7202),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(7202),
    [anon_sym_AMP] = ACTIONS(7202),
  },
  [3117] = {
    [sym__concat] = ACTIONS(7206),
    [anon_sym_in] = ACTIONS(7206),
    [anon_sym_SEMI] = ACTIONS(7208),
    [anon_sym_SEMI_SEMI] = ACTIONS(7206),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(7206),
    [anon_sym_AMP] = ACTIONS(7206),
  },
  [3118] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8206),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3119] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8208),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3120] = {
    [sym__concat] = ACTIONS(7242),
    [anon_sym_in] = ACTIONS(7242),
    [anon_sym_SEMI] = ACTIONS(7244),
    [anon_sym_SEMI_SEMI] = ACTIONS(7242),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(7242),
    [anon_sym_AMP] = ACTIONS(7242),
  },
  [3121] = {
    [sym__simple_heredoc_body] = ACTIONS(8210),
    [sym__heredoc_body_beginning] = ACTIONS(8210),
    [sym_file_descriptor] = ACTIONS(8210),
    [ts_builtin_sym_end] = ACTIONS(8210),
    [anon_sym_SEMI] = ACTIONS(8212),
    [anon_sym_done] = ACTIONS(8210),
    [anon_sym_fi] = ACTIONS(8210),
    [anon_sym_elif] = ACTIONS(8210),
    [anon_sym_else] = ACTIONS(8210),
    [anon_sym_esac] = ACTIONS(8210),
    [anon_sym_PIPE] = ACTIONS(8212),
    [anon_sym_RPAREN] = ACTIONS(8210),
    [anon_sym_SEMI_SEMI] = ACTIONS(8210),
    [anon_sym_PIPE_AMP] = ACTIONS(8210),
    [anon_sym_AMP_AMP] = ACTIONS(8210),
    [anon_sym_PIPE_PIPE] = ACTIONS(8210),
    [anon_sym_LT] = ACTIONS(8212),
    [anon_sym_GT] = ACTIONS(8212),
    [anon_sym_GT_GT] = ACTIONS(8210),
    [anon_sym_AMP_GT] = ACTIONS(8212),
    [anon_sym_AMP_GT_GT] = ACTIONS(8210),
    [anon_sym_LT_AMP] = ACTIONS(8210),
    [anon_sym_GT_AMP] = ACTIONS(8210),
    [anon_sym_LT_LT] = ACTIONS(8212),
    [anon_sym_LT_LT_DASH] = ACTIONS(8210),
    [anon_sym_LT_LT_LT] = ACTIONS(8210),
    [anon_sym_BQUOTE] = ACTIONS(8210),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8210),
    [anon_sym_AMP] = ACTIONS(8212),
  },
  [3122] = {
    [anon_sym_esac] = ACTIONS(8214),
    [sym_comment] = ACTIONS(57),
  },
  [3123] = {
    [sym_string] = STATE(1746),
    [sym__simple_heredoc_body] = ACTIONS(4071),
    [sym__heredoc_body_beginning] = ACTIONS(4071),
    [sym_file_descriptor] = ACTIONS(4071),
    [sym_variable_name] = ACTIONS(4071),
    [anon_sym_SEMI] = ACTIONS(4073),
    [anon_sym_PIPE] = ACTIONS(4073),
    [anon_sym_SEMI_SEMI] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(4071),
    [anon_sym_PIPE_AMP] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_PIPE_PIPE] = ACTIONS(4071),
    [anon_sym_LT] = ACTIONS(4073),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_GT_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT] = ACTIONS(4073),
    [anon_sym_AMP_GT_GT] = ACTIONS(4071),
    [anon_sym_LT_AMP] = ACTIONS(4071),
    [anon_sym_GT_AMP] = ACTIONS(4071),
    [anon_sym_LT_LT] = ACTIONS(4073),
    [anon_sym_LT_LT_DASH] = ACTIONS(4071),
    [anon_sym_LT_LT_LT] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(8216),
    [anon_sym_DOLLAR] = ACTIONS(8216),
    [sym__special_character] = ACTIONS(4073),
    [anon_sym_DQUOTE] = ACTIONS(1929),
    [sym_raw_string] = ACTIONS(3623),
    [anon_sym_POUND] = ACTIONS(3621),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4071),
    [anon_sym_BQUOTE] = ACTIONS(4071),
    [anon_sym_LT_LPAREN] = ACTIONS(4071),
    [anon_sym_GT_LPAREN] = ACTIONS(4071),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3625),
    [anon_sym_STAR] = ACTIONS(3625),
    [anon_sym_AT] = ACTIONS(3625),
    [anon_sym_QMARK] = ACTIONS(3625),
    [anon_sym_0] = ACTIONS(3625),
    [anon_sym__] = ACTIONS(3625),
    [sym_word] = ACTIONS(4073),
    [anon_sym_LF] = ACTIONS(4071),
    [anon_sym_AMP] = ACTIONS(4073),
  },
  [3124] = {
    [sym__simple_heredoc_body] = ACTIONS(4111),
    [sym__heredoc_body_beginning] = ACTIONS(4111),
    [sym_file_descriptor] = ACTIONS(4111),
    [sym__concat] = ACTIONS(4111),
    [sym_variable_name] = ACTIONS(4111),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_PIPE] = ACTIONS(4113),
    [anon_sym_SEMI_SEMI] = ACTIONS(4111),
    [anon_sym_RBRACE] = ACTIONS(4111),
    [anon_sym_PIPE_AMP] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_LT] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4113),
    [anon_sym_GT_GT] = ACTIONS(4111),
    [anon_sym_AMP_GT] = ACTIONS(4113),
    [anon_sym_AMP_GT_GT] = ACTIONS(4111),
    [anon_sym_LT_AMP] = ACTIONS(4111),
    [anon_sym_GT_AMP] = ACTIONS(4111),
    [anon_sym_LT_LT] = ACTIONS(4113),
    [anon_sym_LT_LT_DASH] = ACTIONS(4111),
    [anon_sym_LT_LT_LT] = ACTIONS(4111),
    [anon_sym_DOLLAR] = ACTIONS(4113),
    [sym__special_character] = ACTIONS(4113),
    [anon_sym_DQUOTE] = ACTIONS(4111),
    [sym_raw_string] = ACTIONS(4111),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4111),
    [anon_sym_BQUOTE] = ACTIONS(4111),
    [anon_sym_LT_LPAREN] = ACTIONS(4111),
    [anon_sym_GT_LPAREN] = ACTIONS(4111),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4113),
    [anon_sym_LF] = ACTIONS(4111),
    [anon_sym_AMP] = ACTIONS(4113),
  },
  [3125] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [sym_variable_name] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_RBRACE] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym__special_character] = ACTIONS(4127),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [3126] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(8218),
    [sym_comment] = ACTIONS(57),
  },
  [3127] = {
    [anon_sym_RBRACE] = ACTIONS(8218),
    [sym_comment] = ACTIONS(57),
  },
  [3128] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(8220),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [3129] = {
    [sym_concatenation] = STATE(3640),
    [sym_string] = STATE(3639),
    [sym_simple_expansion] = STATE(3639),
    [sym_string_expansion] = STATE(3639),
    [sym_expansion] = STATE(3639),
    [sym_command_substitution] = STATE(3639),
    [sym_process_substitution] = STATE(3639),
    [aux_sym__literal_repeat1] = STATE(3641),
    [anon_sym_RBRACE] = ACTIONS(8218),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(8222),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8222),
  },
  [3130] = {
    [sym__simple_heredoc_body] = ACTIONS(4161),
    [sym__heredoc_body_beginning] = ACTIONS(4161),
    [sym_file_descriptor] = ACTIONS(4161),
    [sym__concat] = ACTIONS(4161),
    [sym_variable_name] = ACTIONS(4161),
    [anon_sym_SEMI] = ACTIONS(4163),
    [anon_sym_PIPE] = ACTIONS(4163),
    [anon_sym_SEMI_SEMI] = ACTIONS(4161),
    [anon_sym_RBRACE] = ACTIONS(4161),
    [anon_sym_PIPE_AMP] = ACTIONS(4161),
    [anon_sym_AMP_AMP] = ACTIONS(4161),
    [anon_sym_PIPE_PIPE] = ACTIONS(4161),
    [anon_sym_LT] = ACTIONS(4163),
    [anon_sym_GT] = ACTIONS(4163),
    [anon_sym_GT_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT] = ACTIONS(4163),
    [anon_sym_AMP_GT_GT] = ACTIONS(4161),
    [anon_sym_LT_AMP] = ACTIONS(4161),
    [anon_sym_GT_AMP] = ACTIONS(4161),
    [anon_sym_LT_LT] = ACTIONS(4163),
    [anon_sym_LT_LT_DASH] = ACTIONS(4161),
    [anon_sym_LT_LT_LT] = ACTIONS(4161),
    [anon_sym_DOLLAR] = ACTIONS(4163),
    [sym__special_character] = ACTIONS(4163),
    [anon_sym_DQUOTE] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4161),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4161),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4161),
    [anon_sym_BQUOTE] = ACTIONS(4161),
    [anon_sym_LT_LPAREN] = ACTIONS(4161),
    [anon_sym_GT_LPAREN] = ACTIONS(4161),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4163),
    [anon_sym_LF] = ACTIONS(4161),
    [anon_sym_AMP] = ACTIONS(4163),
  },
  [3131] = {
    [sym_concatenation] = STATE(3644),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3644),
    [sym_regex] = ACTIONS(8224),
    [anon_sym_RBRACE] = ACTIONS(8226),
    [anon_sym_EQ] = ACTIONS(8228),
    [anon_sym_DASH] = ACTIONS(8228),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8230),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_COLON_QMARK] = ACTIONS(8228),
    [anon_sym_COLON_DASH] = ACTIONS(8228),
    [anon_sym_PERCENT] = ACTIONS(8228),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3132] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8226),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3133] = {
    [sym_concatenation] = STATE(3646),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3646),
    [sym_regex] = ACTIONS(8232),
    [anon_sym_RBRACE] = ACTIONS(8218),
    [anon_sym_EQ] = ACTIONS(8234),
    [anon_sym_DASH] = ACTIONS(8234),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8234),
    [anon_sym_COLON_QMARK] = ACTIONS(8234),
    [anon_sym_COLON_DASH] = ACTIONS(8234),
    [anon_sym_PERCENT] = ACTIONS(8234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3134] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8218),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3135] = {
    [sym_concatenation] = STATE(3648),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3648),
    [anon_sym_RBRACE] = ACTIONS(8238),
    [anon_sym_EQ] = ACTIONS(8240),
    [anon_sym_DASH] = ACTIONS(8240),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8242),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8240),
    [anon_sym_COLON_QMARK] = ACTIONS(8240),
    [anon_sym_COLON_DASH] = ACTIONS(8240),
    [anon_sym_PERCENT] = ACTIONS(8240),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3136] = {
    [sym__simple_heredoc_body] = ACTIONS(4219),
    [sym__heredoc_body_beginning] = ACTIONS(4219),
    [sym_file_descriptor] = ACTIONS(4219),
    [sym__concat] = ACTIONS(4219),
    [sym_variable_name] = ACTIONS(4219),
    [anon_sym_SEMI] = ACTIONS(4221),
    [anon_sym_PIPE] = ACTIONS(4221),
    [anon_sym_SEMI_SEMI] = ACTIONS(4219),
    [anon_sym_RBRACE] = ACTIONS(4219),
    [anon_sym_PIPE_AMP] = ACTIONS(4219),
    [anon_sym_AMP_AMP] = ACTIONS(4219),
    [anon_sym_PIPE_PIPE] = ACTIONS(4219),
    [anon_sym_LT] = ACTIONS(4221),
    [anon_sym_GT] = ACTIONS(4221),
    [anon_sym_GT_GT] = ACTIONS(4219),
    [anon_sym_AMP_GT] = ACTIONS(4221),
    [anon_sym_AMP_GT_GT] = ACTIONS(4219),
    [anon_sym_LT_AMP] = ACTIONS(4219),
    [anon_sym_GT_AMP] = ACTIONS(4219),
    [anon_sym_LT_LT] = ACTIONS(4221),
    [anon_sym_LT_LT_DASH] = ACTIONS(4219),
    [anon_sym_LT_LT_LT] = ACTIONS(4219),
    [anon_sym_DOLLAR] = ACTIONS(4221),
    [sym__special_character] = ACTIONS(4221),
    [anon_sym_DQUOTE] = ACTIONS(4219),
    [sym_raw_string] = ACTIONS(4219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4219),
    [anon_sym_BQUOTE] = ACTIONS(4219),
    [anon_sym_LT_LPAREN] = ACTIONS(4219),
    [anon_sym_GT_LPAREN] = ACTIONS(4219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4221),
    [anon_sym_LF] = ACTIONS(4219),
    [anon_sym_AMP] = ACTIONS(4221),
  },
  [3137] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8238),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3138] = {
    [sym_concatenation] = STATE(3646),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3646),
    [anon_sym_RBRACE] = ACTIONS(8218),
    [anon_sym_EQ] = ACTIONS(8234),
    [anon_sym_DASH] = ACTIONS(8234),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8234),
    [anon_sym_COLON_QMARK] = ACTIONS(8234),
    [anon_sym_COLON_DASH] = ACTIONS(8234),
    [anon_sym_PERCENT] = ACTIONS(8234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3139] = {
    [sym_do_group] = STATE(3649),
    [sym_compound_statement] = STATE(3649),
    [anon_sym_do] = ACTIONS(1953),
    [anon_sym_LBRACE] = ACTIONS(191),
    [sym_comment] = ACTIONS(57),
  },
  [3140] = {
    [sym__simple_heredoc_body] = ACTIONS(5891),
    [sym__heredoc_body_beginning] = ACTIONS(5891),
    [sym_file_descriptor] = ACTIONS(5891),
    [anon_sym_SEMI] = ACTIONS(5893),
    [anon_sym_PIPE] = ACTIONS(5893),
    [anon_sym_SEMI_SEMI] = ACTIONS(5891),
    [anon_sym_RBRACE] = ACTIONS(5891),
    [anon_sym_PIPE_AMP] = ACTIONS(5891),
    [anon_sym_AMP_AMP] = ACTIONS(5891),
    [anon_sym_PIPE_PIPE] = ACTIONS(5891),
    [anon_sym_LT] = ACTIONS(5893),
    [anon_sym_GT] = ACTIONS(5893),
    [anon_sym_GT_GT] = ACTIONS(5891),
    [anon_sym_AMP_GT] = ACTIONS(5893),
    [anon_sym_AMP_GT_GT] = ACTIONS(5891),
    [anon_sym_LT_AMP] = ACTIONS(5891),
    [anon_sym_GT_AMP] = ACTIONS(5891),
    [anon_sym_LT_LT] = ACTIONS(5893),
    [anon_sym_LT_LT_DASH] = ACTIONS(5891),
    [anon_sym_LT_LT_LT] = ACTIONS(5891),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5891),
    [anon_sym_AMP] = ACTIONS(5893),
  },
  [3141] = {
    [sym_do_group] = STATE(3649),
    [sym_compound_statement] = STATE(3649),
    [anon_sym_SEMI] = ACTIONS(8244),
    [anon_sym_do] = ACTIONS(1953),
    [anon_sym_LBRACE] = ACTIONS(191),
    [sym_comment] = ACTIONS(57),
  },
  [3142] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(8246),
    [anon_sym_AMP_AMP] = ACTIONS(557),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(559),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_PLUS_EQ] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DASH_EQ] = ACTIONS(557),
    [anon_sym_LT_EQ] = ACTIONS(557),
    [anon_sym_GT_EQ] = ACTIONS(557),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(557),
  },
  [3143] = {
    [sym__expression] = STATE(3652),
    [sym_binary_expression] = STATE(3652),
    [sym_unary_expression] = STATE(3652),
    [sym_postfix_expression] = STATE(3652),
    [sym_parenthesized_expression] = STATE(3652),
    [sym_concatenation] = STATE(3652),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__literal_repeat1] = STATE(53),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(8246),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_DOLLAR] = ACTIONS(77),
    [sym__special_character] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [3144] = {
    [sym__simple_heredoc_body] = ACTIONS(5964),
    [sym__heredoc_body_beginning] = ACTIONS(5964),
    [sym_file_descriptor] = ACTIONS(5964),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(5966),
    [anon_sym_SEMI_SEMI] = ACTIONS(5964),
    [anon_sym_RBRACE] = ACTIONS(5964),
    [anon_sym_PIPE_AMP] = ACTIONS(5964),
    [anon_sym_AMP_AMP] = ACTIONS(5964),
    [anon_sym_PIPE_PIPE] = ACTIONS(5964),
    [anon_sym_LT] = ACTIONS(5966),
    [anon_sym_GT] = ACTIONS(5966),
    [anon_sym_GT_GT] = ACTIONS(5964),
    [anon_sym_AMP_GT] = ACTIONS(5966),
    [anon_sym_AMP_GT_GT] = ACTIONS(5964),
    [anon_sym_LT_AMP] = ACTIONS(5964),
    [anon_sym_GT_AMP] = ACTIONS(5964),
    [anon_sym_LT_LT] = ACTIONS(5966),
    [anon_sym_LT_LT_DASH] = ACTIONS(5964),
    [anon_sym_LT_LT_LT] = ACTIONS(5964),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5964),
    [anon_sym_AMP] = ACTIONS(5966),
  },
  [3145] = {
    [sym__simple_heredoc_body] = ACTIONS(6794),
    [sym__heredoc_body_beginning] = ACTIONS(6794),
    [sym_file_descriptor] = ACTIONS(6794),
    [anon_sym_SEMI] = ACTIONS(6796),
    [anon_sym_PIPE] = ACTIONS(6796),
    [anon_sym_SEMI_SEMI] = ACTIONS(6794),
    [anon_sym_RBRACE] = ACTIONS(6794),
    [anon_sym_PIPE_AMP] = ACTIONS(6794),
    [anon_sym_AMP_AMP] = ACTIONS(6794),
    [anon_sym_PIPE_PIPE] = ACTIONS(6794),
    [anon_sym_LT] = ACTIONS(6796),
    [anon_sym_GT] = ACTIONS(6796),
    [anon_sym_GT_GT] = ACTIONS(6794),
    [anon_sym_AMP_GT] = ACTIONS(6796),
    [anon_sym_AMP_GT_GT] = ACTIONS(6794),
    [anon_sym_LT_AMP] = ACTIONS(6794),
    [anon_sym_GT_AMP] = ACTIONS(6794),
    [anon_sym_LT_LT] = ACTIONS(6796),
    [anon_sym_LT_LT_DASH] = ACTIONS(6794),
    [anon_sym_LT_LT_LT] = ACTIONS(6794),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6794),
    [anon_sym_AMP] = ACTIONS(6796),
  },
  [3146] = {
    [anon_sym_fi] = ACTIONS(8248),
    [sym_comment] = ACTIONS(57),
  },
  [3147] = {
    [sym__simple_heredoc_body] = ACTIONS(6884),
    [sym__heredoc_body_beginning] = ACTIONS(6884),
    [sym_file_descriptor] = ACTIONS(6884),
    [anon_sym_SEMI] = ACTIONS(6886),
    [anon_sym_PIPE] = ACTIONS(6886),
    [anon_sym_SEMI_SEMI] = ACTIONS(6884),
    [anon_sym_RBRACE] = ACTIONS(6884),
    [anon_sym_PIPE_AMP] = ACTIONS(6884),
    [anon_sym_AMP_AMP] = ACTIONS(6884),
    [anon_sym_PIPE_PIPE] = ACTIONS(6884),
    [anon_sym_LT] = ACTIONS(6886),
    [anon_sym_GT] = ACTIONS(6886),
    [anon_sym_GT_GT] = ACTIONS(6884),
    [anon_sym_AMP_GT] = ACTIONS(6886),
    [anon_sym_AMP_GT_GT] = ACTIONS(6884),
    [anon_sym_LT_AMP] = ACTIONS(6884),
    [anon_sym_GT_AMP] = ACTIONS(6884),
    [anon_sym_LT_LT] = ACTIONS(6886),
    [anon_sym_LT_LT_DASH] = ACTIONS(6884),
    [anon_sym_LT_LT_LT] = ACTIONS(6884),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6884),
    [anon_sym_AMP] = ACTIONS(6886),
  },
  [3148] = {
    [anon_sym_esac] = ACTIONS(8250),
    [sym_comment] = ACTIONS(57),
  },
  [3149] = {
    [sym_case_item] = STATE(2443),
    [sym_last_case_item] = STATE(3655),
    [sym_concatenation] = STATE(1710),
    [sym_string] = STATE(1708),
    [sym_simple_expansion] = STATE(1708),
    [sym_string_expansion] = STATE(1708),
    [sym_expansion] = STATE(1708),
    [sym_command_substitution] = STATE(1708),
    [sym_process_substitution] = STATE(1708),
    [aux_sym_case_statement_repeat1] = STATE(2443),
    [aux_sym__literal_repeat1] = STATE(1712),
    [anon_sym_DOLLAR] = ACTIONS(507),
    [sym__special_character] = ACTIONS(3518),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3520),
  },
  [3150] = {
    [sym__simple_heredoc_body] = ACTIONS(6936),
    [sym__heredoc_body_beginning] = ACTIONS(6936),
    [sym_file_descriptor] = ACTIONS(6936),
    [anon_sym_SEMI] = ACTIONS(6938),
    [anon_sym_PIPE] = ACTIONS(6938),
    [anon_sym_SEMI_SEMI] = ACTIONS(6936),
    [anon_sym_RBRACE] = ACTIONS(6936),
    [anon_sym_PIPE_AMP] = ACTIONS(6936),
    [anon_sym_AMP_AMP] = ACTIONS(6936),
    [anon_sym_PIPE_PIPE] = ACTIONS(6936),
    [anon_sym_LT] = ACTIONS(6938),
    [anon_sym_GT] = ACTIONS(6938),
    [anon_sym_GT_GT] = ACTIONS(6936),
    [anon_sym_AMP_GT] = ACTIONS(6938),
    [anon_sym_AMP_GT_GT] = ACTIONS(6936),
    [anon_sym_LT_AMP] = ACTIONS(6936),
    [anon_sym_GT_AMP] = ACTIONS(6936),
    [anon_sym_LT_LT] = ACTIONS(6938),
    [anon_sym_LT_LT_DASH] = ACTIONS(6936),
    [anon_sym_LT_LT_LT] = ACTIONS(6936),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6936),
    [anon_sym_AMP] = ACTIONS(6938),
  },
  [3151] = {
    [anon_sym_esac] = ACTIONS(8252),
    [sym_comment] = ACTIONS(57),
  },
  [3152] = {
    [sym_case_item] = STATE(2443),
    [sym_last_case_item] = STATE(3657),
    [sym_concatenation] = STATE(1710),
    [sym_string] = STATE(1708),
    [sym_simple_expansion] = STATE(1708),
    [sym_string_expansion] = STATE(1708),
    [sym_expansion] = STATE(1708),
    [sym_command_substitution] = STATE(1708),
    [sym_process_substitution] = STATE(1708),
    [aux_sym_case_statement_repeat1] = STATE(2443),
    [aux_sym__literal_repeat1] = STATE(1712),
    [anon_sym_DOLLAR] = ACTIONS(507),
    [sym__special_character] = ACTIONS(3518),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3520),
  },
  [3153] = {
    [sym__simple_heredoc_body] = ACTIONS(4449),
    [sym__heredoc_body_beginning] = ACTIONS(4449),
    [sym_file_descriptor] = ACTIONS(4449),
    [sym_variable_name] = ACTIONS(4449),
    [anon_sym_SEMI] = ACTIONS(4451),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_SEMI_SEMI] = ACTIONS(4449),
    [anon_sym_RBRACE] = ACTIONS(4449),
    [anon_sym_PIPE_AMP] = ACTIONS(4449),
    [anon_sym_AMP_AMP] = ACTIONS(4449),
    [anon_sym_PIPE_PIPE] = ACTIONS(4449),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_GT_GT] = ACTIONS(4449),
    [anon_sym_AMP_GT] = ACTIONS(4451),
    [anon_sym_AMP_GT_GT] = ACTIONS(4449),
    [anon_sym_LT_AMP] = ACTIONS(4449),
    [anon_sym_GT_AMP] = ACTIONS(4449),
    [anon_sym_LT_LT] = ACTIONS(4451),
    [anon_sym_LT_LT_DASH] = ACTIONS(4449),
    [anon_sym_LT_LT_LT] = ACTIONS(4449),
    [anon_sym_DOLLAR] = ACTIONS(4451),
    [sym__special_character] = ACTIONS(4451),
    [anon_sym_DQUOTE] = ACTIONS(4449),
    [sym_raw_string] = ACTIONS(4449),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4449),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4449),
    [anon_sym_BQUOTE] = ACTIONS(4449),
    [anon_sym_LT_LPAREN] = ACTIONS(4449),
    [anon_sym_GT_LPAREN] = ACTIONS(4449),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4451),
    [sym_word] = ACTIONS(4451),
    [anon_sym_LF] = ACTIONS(4449),
    [anon_sym_AMP] = ACTIONS(4451),
  },
  [3154] = {
    [sym__simple_heredoc_body] = ACTIONS(5674),
    [sym__heredoc_body_beginning] = ACTIONS(5674),
    [sym_file_descriptor] = ACTIONS(5674),
    [sym__concat] = ACTIONS(5674),
    [sym_variable_name] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(5676),
    [anon_sym_PIPE] = ACTIONS(5676),
    [anon_sym_SEMI_SEMI] = ACTIONS(5674),
    [anon_sym_RBRACE] = ACTIONS(5674),
    [anon_sym_PIPE_AMP] = ACTIONS(5674),
    [anon_sym_AMP_AMP] = ACTIONS(5674),
    [anon_sym_PIPE_PIPE] = ACTIONS(5674),
    [anon_sym_LT] = ACTIONS(5676),
    [anon_sym_GT] = ACTIONS(5676),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_AMP_GT] = ACTIONS(5676),
    [anon_sym_AMP_GT_GT] = ACTIONS(5674),
    [anon_sym_LT_AMP] = ACTIONS(5674),
    [anon_sym_GT_AMP] = ACTIONS(5674),
    [anon_sym_LT_LT] = ACTIONS(5676),
    [anon_sym_LT_LT_DASH] = ACTIONS(5674),
    [anon_sym_LT_LT_LT] = ACTIONS(5674),
    [anon_sym_DOLLAR] = ACTIONS(5676),
    [sym__special_character] = ACTIONS(5676),
    [anon_sym_DQUOTE] = ACTIONS(5674),
    [sym_raw_string] = ACTIONS(5674),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5674),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5674),
    [anon_sym_BQUOTE] = ACTIONS(5674),
    [anon_sym_LT_LPAREN] = ACTIONS(5674),
    [anon_sym_GT_LPAREN] = ACTIONS(5674),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5676),
    [sym_word] = ACTIONS(5676),
    [anon_sym_LF] = ACTIONS(5674),
    [anon_sym_AMP] = ACTIONS(5676),
  },
  [3155] = {
    [sym__simple_heredoc_body] = ACTIONS(5708),
    [sym__heredoc_body_beginning] = ACTIONS(5708),
    [sym_file_descriptor] = ACTIONS(5708),
    [sym__concat] = ACTIONS(5708),
    [sym_variable_name] = ACTIONS(5708),
    [anon_sym_SEMI] = ACTIONS(5710),
    [anon_sym_PIPE] = ACTIONS(5710),
    [anon_sym_SEMI_SEMI] = ACTIONS(5708),
    [anon_sym_RBRACE] = ACTIONS(5708),
    [anon_sym_PIPE_AMP] = ACTIONS(5708),
    [anon_sym_AMP_AMP] = ACTIONS(5708),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_LT] = ACTIONS(5710),
    [anon_sym_GT] = ACTIONS(5710),
    [anon_sym_GT_GT] = ACTIONS(5708),
    [anon_sym_AMP_GT] = ACTIONS(5710),
    [anon_sym_AMP_GT_GT] = ACTIONS(5708),
    [anon_sym_LT_AMP] = ACTIONS(5708),
    [anon_sym_GT_AMP] = ACTIONS(5708),
    [anon_sym_LT_LT] = ACTIONS(5710),
    [anon_sym_LT_LT_DASH] = ACTIONS(5708),
    [anon_sym_LT_LT_LT] = ACTIONS(5708),
    [anon_sym_DOLLAR] = ACTIONS(5710),
    [sym__special_character] = ACTIONS(5710),
    [anon_sym_DQUOTE] = ACTIONS(5708),
    [sym_raw_string] = ACTIONS(5708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5708),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5708),
    [anon_sym_BQUOTE] = ACTIONS(5708),
    [anon_sym_LT_LPAREN] = ACTIONS(5708),
    [anon_sym_GT_LPAREN] = ACTIONS(5708),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5710),
    [sym_word] = ACTIONS(5710),
    [anon_sym_LF] = ACTIONS(5708),
    [anon_sym_AMP] = ACTIONS(5710),
  },
  [3156] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(8254),
    [sym_comment] = ACTIONS(57),
  },
  [3157] = {
    [anon_sym_RBRACE] = ACTIONS(8254),
    [sym_comment] = ACTIONS(57),
  },
  [3158] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(8256),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [3159] = {
    [sym_concatenation] = STATE(3661),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3661),
    [anon_sym_RBRACE] = ACTIONS(8258),
    [anon_sym_EQ] = ACTIONS(8260),
    [anon_sym_DASH] = ACTIONS(8260),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8262),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8260),
    [anon_sym_COLON_QMARK] = ACTIONS(8260),
    [anon_sym_COLON_DASH] = ACTIONS(8260),
    [anon_sym_PERCENT] = ACTIONS(8260),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3160] = {
    [sym__simple_heredoc_body] = ACTIONS(5725),
    [sym__heredoc_body_beginning] = ACTIONS(5725),
    [sym_file_descriptor] = ACTIONS(5725),
    [sym__concat] = ACTIONS(5725),
    [sym_variable_name] = ACTIONS(5725),
    [anon_sym_SEMI] = ACTIONS(5727),
    [anon_sym_PIPE] = ACTIONS(5727),
    [anon_sym_SEMI_SEMI] = ACTIONS(5725),
    [anon_sym_RBRACE] = ACTIONS(5725),
    [anon_sym_PIPE_AMP] = ACTIONS(5725),
    [anon_sym_AMP_AMP] = ACTIONS(5725),
    [anon_sym_PIPE_PIPE] = ACTIONS(5725),
    [anon_sym_LT] = ACTIONS(5727),
    [anon_sym_GT] = ACTIONS(5727),
    [anon_sym_GT_GT] = ACTIONS(5725),
    [anon_sym_AMP_GT] = ACTIONS(5727),
    [anon_sym_AMP_GT_GT] = ACTIONS(5725),
    [anon_sym_LT_AMP] = ACTIONS(5725),
    [anon_sym_GT_AMP] = ACTIONS(5725),
    [anon_sym_LT_LT] = ACTIONS(5727),
    [anon_sym_LT_LT_DASH] = ACTIONS(5725),
    [anon_sym_LT_LT_LT] = ACTIONS(5725),
    [anon_sym_DOLLAR] = ACTIONS(5727),
    [sym__special_character] = ACTIONS(5727),
    [anon_sym_DQUOTE] = ACTIONS(5725),
    [sym_raw_string] = ACTIONS(5725),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5725),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5725),
    [anon_sym_BQUOTE] = ACTIONS(5725),
    [anon_sym_LT_LPAREN] = ACTIONS(5725),
    [anon_sym_GT_LPAREN] = ACTIONS(5725),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5727),
    [sym_word] = ACTIONS(5727),
    [anon_sym_LF] = ACTIONS(5725),
    [anon_sym_AMP] = ACTIONS(5727),
  },
  [3161] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8258),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3162] = {
    [sym_concatenation] = STATE(3662),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3662),
    [anon_sym_RBRACE] = ACTIONS(8254),
    [anon_sym_EQ] = ACTIONS(8264),
    [anon_sym_DASH] = ACTIONS(8264),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8266),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8264),
    [anon_sym_COLON_QMARK] = ACTIONS(8264),
    [anon_sym_COLON_DASH] = ACTIONS(8264),
    [anon_sym_PERCENT] = ACTIONS(8264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3163] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8254),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3164] = {
    [sym__simple_heredoc_body] = ACTIONS(5770),
    [sym__heredoc_body_beginning] = ACTIONS(5770),
    [sym_file_descriptor] = ACTIONS(5770),
    [sym__concat] = ACTIONS(5770),
    [sym_variable_name] = ACTIONS(5770),
    [anon_sym_SEMI] = ACTIONS(5772),
    [anon_sym_PIPE] = ACTIONS(5772),
    [anon_sym_SEMI_SEMI] = ACTIONS(5770),
    [anon_sym_RBRACE] = ACTIONS(5770),
    [anon_sym_PIPE_AMP] = ACTIONS(5770),
    [anon_sym_AMP_AMP] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5770),
    [anon_sym_LT] = ACTIONS(5772),
    [anon_sym_GT] = ACTIONS(5772),
    [anon_sym_GT_GT] = ACTIONS(5770),
    [anon_sym_AMP_GT] = ACTIONS(5772),
    [anon_sym_AMP_GT_GT] = ACTIONS(5770),
    [anon_sym_LT_AMP] = ACTIONS(5770),
    [anon_sym_GT_AMP] = ACTIONS(5770),
    [anon_sym_LT_LT] = ACTIONS(5772),
    [anon_sym_LT_LT_DASH] = ACTIONS(5770),
    [anon_sym_LT_LT_LT] = ACTIONS(5770),
    [anon_sym_DOLLAR] = ACTIONS(5772),
    [sym__special_character] = ACTIONS(5772),
    [anon_sym_DQUOTE] = ACTIONS(5770),
    [sym_raw_string] = ACTIONS(5770),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5770),
    [anon_sym_BQUOTE] = ACTIONS(5770),
    [anon_sym_LT_LPAREN] = ACTIONS(5770),
    [anon_sym_GT_LPAREN] = ACTIONS(5770),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5772),
    [sym_word] = ACTIONS(5772),
    [anon_sym_LF] = ACTIONS(5770),
    [anon_sym_AMP] = ACTIONS(5772),
  },
  [3165] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8268),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3166] = {
    [sym__simple_heredoc_body] = ACTIONS(5674),
    [sym__heredoc_body_beginning] = ACTIONS(5674),
    [sym_file_descriptor] = ACTIONS(5674),
    [sym__concat] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(5676),
    [anon_sym_PIPE] = ACTIONS(5676),
    [anon_sym_SEMI_SEMI] = ACTIONS(5674),
    [anon_sym_RBRACE] = ACTIONS(5674),
    [anon_sym_PIPE_AMP] = ACTIONS(5674),
    [anon_sym_AMP_AMP] = ACTIONS(5674),
    [anon_sym_PIPE_PIPE] = ACTIONS(5674),
    [anon_sym_LT] = ACTIONS(5676),
    [anon_sym_GT] = ACTIONS(5676),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_AMP_GT] = ACTIONS(5676),
    [anon_sym_AMP_GT_GT] = ACTIONS(5674),
    [anon_sym_LT_AMP] = ACTIONS(5674),
    [anon_sym_GT_AMP] = ACTIONS(5674),
    [anon_sym_LT_LT] = ACTIONS(5676),
    [anon_sym_LT_LT_DASH] = ACTIONS(5674),
    [anon_sym_LT_LT_LT] = ACTIONS(5674),
    [anon_sym_DOLLAR] = ACTIONS(5676),
    [sym__special_character] = ACTIONS(5676),
    [anon_sym_DQUOTE] = ACTIONS(5674),
    [sym_raw_string] = ACTIONS(5674),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5674),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5674),
    [anon_sym_BQUOTE] = ACTIONS(5674),
    [anon_sym_LT_LPAREN] = ACTIONS(5674),
    [anon_sym_GT_LPAREN] = ACTIONS(5674),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5676),
    [sym_word] = ACTIONS(5676),
    [anon_sym_LF] = ACTIONS(5674),
    [anon_sym_AMP] = ACTIONS(5676),
  },
  [3167] = {
    [sym__simple_heredoc_body] = ACTIONS(5708),
    [sym__heredoc_body_beginning] = ACTIONS(5708),
    [sym_file_descriptor] = ACTIONS(5708),
    [sym__concat] = ACTIONS(5708),
    [anon_sym_SEMI] = ACTIONS(5710),
    [anon_sym_PIPE] = ACTIONS(5710),
    [anon_sym_SEMI_SEMI] = ACTIONS(5708),
    [anon_sym_RBRACE] = ACTIONS(5708),
    [anon_sym_PIPE_AMP] = ACTIONS(5708),
    [anon_sym_AMP_AMP] = ACTIONS(5708),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_LT] = ACTIONS(5710),
    [anon_sym_GT] = ACTIONS(5710),
    [anon_sym_GT_GT] = ACTIONS(5708),
    [anon_sym_AMP_GT] = ACTIONS(5710),
    [anon_sym_AMP_GT_GT] = ACTIONS(5708),
    [anon_sym_LT_AMP] = ACTIONS(5708),
    [anon_sym_GT_AMP] = ACTIONS(5708),
    [anon_sym_LT_LT] = ACTIONS(5710),
    [anon_sym_LT_LT_DASH] = ACTIONS(5708),
    [anon_sym_LT_LT_LT] = ACTIONS(5708),
    [anon_sym_DOLLAR] = ACTIONS(5710),
    [sym__special_character] = ACTIONS(5710),
    [anon_sym_DQUOTE] = ACTIONS(5708),
    [sym_raw_string] = ACTIONS(5708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5708),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5708),
    [anon_sym_BQUOTE] = ACTIONS(5708),
    [anon_sym_LT_LPAREN] = ACTIONS(5708),
    [anon_sym_GT_LPAREN] = ACTIONS(5708),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5710),
    [sym_word] = ACTIONS(5710),
    [anon_sym_LF] = ACTIONS(5708),
    [anon_sym_AMP] = ACTIONS(5710),
  },
  [3168] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(8270),
    [sym_comment] = ACTIONS(57),
  },
  [3169] = {
    [anon_sym_RBRACE] = ACTIONS(8270),
    [sym_comment] = ACTIONS(57),
  },
  [3170] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(8272),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [3171] = {
    [sym_concatenation] = STATE(3667),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3667),
    [anon_sym_RBRACE] = ACTIONS(8274),
    [anon_sym_EQ] = ACTIONS(8276),
    [anon_sym_DASH] = ACTIONS(8276),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8276),
    [anon_sym_COLON_QMARK] = ACTIONS(8276),
    [anon_sym_COLON_DASH] = ACTIONS(8276),
    [anon_sym_PERCENT] = ACTIONS(8276),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3172] = {
    [sym__simple_heredoc_body] = ACTIONS(5725),
    [sym__heredoc_body_beginning] = ACTIONS(5725),
    [sym_file_descriptor] = ACTIONS(5725),
    [sym__concat] = ACTIONS(5725),
    [anon_sym_SEMI] = ACTIONS(5727),
    [anon_sym_PIPE] = ACTIONS(5727),
    [anon_sym_SEMI_SEMI] = ACTIONS(5725),
    [anon_sym_RBRACE] = ACTIONS(5725),
    [anon_sym_PIPE_AMP] = ACTIONS(5725),
    [anon_sym_AMP_AMP] = ACTIONS(5725),
    [anon_sym_PIPE_PIPE] = ACTIONS(5725),
    [anon_sym_LT] = ACTIONS(5727),
    [anon_sym_GT] = ACTIONS(5727),
    [anon_sym_GT_GT] = ACTIONS(5725),
    [anon_sym_AMP_GT] = ACTIONS(5727),
    [anon_sym_AMP_GT_GT] = ACTIONS(5725),
    [anon_sym_LT_AMP] = ACTIONS(5725),
    [anon_sym_GT_AMP] = ACTIONS(5725),
    [anon_sym_LT_LT] = ACTIONS(5727),
    [anon_sym_LT_LT_DASH] = ACTIONS(5725),
    [anon_sym_LT_LT_LT] = ACTIONS(5725),
    [anon_sym_DOLLAR] = ACTIONS(5727),
    [sym__special_character] = ACTIONS(5727),
    [anon_sym_DQUOTE] = ACTIONS(5725),
    [sym_raw_string] = ACTIONS(5725),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5725),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5725),
    [anon_sym_BQUOTE] = ACTIONS(5725),
    [anon_sym_LT_LPAREN] = ACTIONS(5725),
    [anon_sym_GT_LPAREN] = ACTIONS(5725),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5727),
    [sym_word] = ACTIONS(5727),
    [anon_sym_LF] = ACTIONS(5725),
    [anon_sym_AMP] = ACTIONS(5727),
  },
  [3173] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8274),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3174] = {
    [sym_concatenation] = STATE(3668),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3668),
    [anon_sym_RBRACE] = ACTIONS(8270),
    [anon_sym_EQ] = ACTIONS(8280),
    [anon_sym_DASH] = ACTIONS(8280),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8280),
    [anon_sym_COLON_QMARK] = ACTIONS(8280),
    [anon_sym_COLON_DASH] = ACTIONS(8280),
    [anon_sym_PERCENT] = ACTIONS(8280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3175] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8270),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3176] = {
    [sym__simple_heredoc_body] = ACTIONS(5770),
    [sym__heredoc_body_beginning] = ACTIONS(5770),
    [sym_file_descriptor] = ACTIONS(5770),
    [sym__concat] = ACTIONS(5770),
    [anon_sym_SEMI] = ACTIONS(5772),
    [anon_sym_PIPE] = ACTIONS(5772),
    [anon_sym_SEMI_SEMI] = ACTIONS(5770),
    [anon_sym_RBRACE] = ACTIONS(5770),
    [anon_sym_PIPE_AMP] = ACTIONS(5770),
    [anon_sym_AMP_AMP] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5770),
    [anon_sym_LT] = ACTIONS(5772),
    [anon_sym_GT] = ACTIONS(5772),
    [anon_sym_GT_GT] = ACTIONS(5770),
    [anon_sym_AMP_GT] = ACTIONS(5772),
    [anon_sym_AMP_GT_GT] = ACTIONS(5770),
    [anon_sym_LT_AMP] = ACTIONS(5770),
    [anon_sym_GT_AMP] = ACTIONS(5770),
    [anon_sym_LT_LT] = ACTIONS(5772),
    [anon_sym_LT_LT_DASH] = ACTIONS(5770),
    [anon_sym_LT_LT_LT] = ACTIONS(5770),
    [anon_sym_DOLLAR] = ACTIONS(5772),
    [sym__special_character] = ACTIONS(5772),
    [anon_sym_DQUOTE] = ACTIONS(5770),
    [sym_raw_string] = ACTIONS(5770),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5770),
    [anon_sym_BQUOTE] = ACTIONS(5770),
    [anon_sym_LT_LPAREN] = ACTIONS(5770),
    [anon_sym_GT_LPAREN] = ACTIONS(5770),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5772),
    [sym_word] = ACTIONS(5772),
    [anon_sym_LF] = ACTIONS(5770),
    [anon_sym_AMP] = ACTIONS(5772),
  },
  [3177] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8284),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3178] = {
    [sym__simple_heredoc_body] = ACTIONS(7198),
    [sym__heredoc_body_beginning] = ACTIONS(7198),
    [sym_file_descriptor] = ACTIONS(7198),
    [sym__concat] = ACTIONS(7198),
    [anon_sym_SEMI] = ACTIONS(7200),
    [anon_sym_PIPE] = ACTIONS(7200),
    [anon_sym_SEMI_SEMI] = ACTIONS(7198),
    [anon_sym_RBRACE] = ACTIONS(7198),
    [anon_sym_PIPE_AMP] = ACTIONS(7198),
    [anon_sym_AMP_AMP] = ACTIONS(7198),
    [anon_sym_PIPE_PIPE] = ACTIONS(7198),
    [anon_sym_EQ_TILDE] = ACTIONS(7200),
    [anon_sym_EQ_EQ] = ACTIONS(7200),
    [anon_sym_LT] = ACTIONS(7200),
    [anon_sym_GT] = ACTIONS(7200),
    [anon_sym_GT_GT] = ACTIONS(7198),
    [anon_sym_AMP_GT] = ACTIONS(7200),
    [anon_sym_AMP_GT_GT] = ACTIONS(7198),
    [anon_sym_LT_AMP] = ACTIONS(7198),
    [anon_sym_GT_AMP] = ACTIONS(7198),
    [anon_sym_LT_LT] = ACTIONS(7200),
    [anon_sym_LT_LT_DASH] = ACTIONS(7198),
    [anon_sym_LT_LT_LT] = ACTIONS(7198),
    [anon_sym_DOLLAR] = ACTIONS(7200),
    [sym__special_character] = ACTIONS(7200),
    [anon_sym_DQUOTE] = ACTIONS(7198),
    [sym_raw_string] = ACTIONS(7198),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7198),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7198),
    [anon_sym_BQUOTE] = ACTIONS(7198),
    [anon_sym_LT_LPAREN] = ACTIONS(7198),
    [anon_sym_GT_LPAREN] = ACTIONS(7198),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7200),
    [anon_sym_LF] = ACTIONS(7198),
    [anon_sym_AMP] = ACTIONS(7200),
  },
  [3179] = {
    [sym__simple_heredoc_body] = ACTIONS(7202),
    [sym__heredoc_body_beginning] = ACTIONS(7202),
    [sym_file_descriptor] = ACTIONS(7202),
    [sym__concat] = ACTIONS(7202),
    [anon_sym_SEMI] = ACTIONS(7204),
    [anon_sym_PIPE] = ACTIONS(7204),
    [anon_sym_SEMI_SEMI] = ACTIONS(7202),
    [anon_sym_RBRACE] = ACTIONS(7202),
    [anon_sym_PIPE_AMP] = ACTIONS(7202),
    [anon_sym_AMP_AMP] = ACTIONS(7202),
    [anon_sym_PIPE_PIPE] = ACTIONS(7202),
    [anon_sym_EQ_TILDE] = ACTIONS(7204),
    [anon_sym_EQ_EQ] = ACTIONS(7204),
    [anon_sym_LT] = ACTIONS(7204),
    [anon_sym_GT] = ACTIONS(7204),
    [anon_sym_GT_GT] = ACTIONS(7202),
    [anon_sym_AMP_GT] = ACTIONS(7204),
    [anon_sym_AMP_GT_GT] = ACTIONS(7202),
    [anon_sym_LT_AMP] = ACTIONS(7202),
    [anon_sym_GT_AMP] = ACTIONS(7202),
    [anon_sym_LT_LT] = ACTIONS(7204),
    [anon_sym_LT_LT_DASH] = ACTIONS(7202),
    [anon_sym_LT_LT_LT] = ACTIONS(7202),
    [anon_sym_DOLLAR] = ACTIONS(7204),
    [sym__special_character] = ACTIONS(7204),
    [anon_sym_DQUOTE] = ACTIONS(7202),
    [sym_raw_string] = ACTIONS(7202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7202),
    [anon_sym_BQUOTE] = ACTIONS(7202),
    [anon_sym_LT_LPAREN] = ACTIONS(7202),
    [anon_sym_GT_LPAREN] = ACTIONS(7202),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7204),
    [anon_sym_LF] = ACTIONS(7202),
    [anon_sym_AMP] = ACTIONS(7204),
  },
  [3180] = {
    [sym__simple_heredoc_body] = ACTIONS(7206),
    [sym__heredoc_body_beginning] = ACTIONS(7206),
    [sym_file_descriptor] = ACTIONS(7206),
    [sym__concat] = ACTIONS(7206),
    [anon_sym_SEMI] = ACTIONS(7208),
    [anon_sym_PIPE] = ACTIONS(7208),
    [anon_sym_SEMI_SEMI] = ACTIONS(7206),
    [anon_sym_RBRACE] = ACTIONS(7206),
    [anon_sym_PIPE_AMP] = ACTIONS(7206),
    [anon_sym_AMP_AMP] = ACTIONS(7206),
    [anon_sym_PIPE_PIPE] = ACTIONS(7206),
    [anon_sym_EQ_TILDE] = ACTIONS(7208),
    [anon_sym_EQ_EQ] = ACTIONS(7208),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7206),
    [anon_sym_AMP_GT] = ACTIONS(7208),
    [anon_sym_AMP_GT_GT] = ACTIONS(7206),
    [anon_sym_LT_AMP] = ACTIONS(7206),
    [anon_sym_GT_AMP] = ACTIONS(7206),
    [anon_sym_LT_LT] = ACTIONS(7208),
    [anon_sym_LT_LT_DASH] = ACTIONS(7206),
    [anon_sym_LT_LT_LT] = ACTIONS(7206),
    [anon_sym_DOLLAR] = ACTIONS(7208),
    [sym__special_character] = ACTIONS(7208),
    [anon_sym_DQUOTE] = ACTIONS(7206),
    [sym_raw_string] = ACTIONS(7206),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7206),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7206),
    [anon_sym_BQUOTE] = ACTIONS(7206),
    [anon_sym_LT_LPAREN] = ACTIONS(7206),
    [anon_sym_GT_LPAREN] = ACTIONS(7206),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7208),
    [anon_sym_LF] = ACTIONS(7206),
    [anon_sym_AMP] = ACTIONS(7208),
  },
  [3181] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8286),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3182] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8288),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3183] = {
    [sym__simple_heredoc_body] = ACTIONS(7242),
    [sym__heredoc_body_beginning] = ACTIONS(7242),
    [sym_file_descriptor] = ACTIONS(7242),
    [sym__concat] = ACTIONS(7242),
    [anon_sym_SEMI] = ACTIONS(7244),
    [anon_sym_PIPE] = ACTIONS(7244),
    [anon_sym_SEMI_SEMI] = ACTIONS(7242),
    [anon_sym_RBRACE] = ACTIONS(7242),
    [anon_sym_PIPE_AMP] = ACTIONS(7242),
    [anon_sym_AMP_AMP] = ACTIONS(7242),
    [anon_sym_PIPE_PIPE] = ACTIONS(7242),
    [anon_sym_EQ_TILDE] = ACTIONS(7244),
    [anon_sym_EQ_EQ] = ACTIONS(7244),
    [anon_sym_LT] = ACTIONS(7244),
    [anon_sym_GT] = ACTIONS(7244),
    [anon_sym_GT_GT] = ACTIONS(7242),
    [anon_sym_AMP_GT] = ACTIONS(7244),
    [anon_sym_AMP_GT_GT] = ACTIONS(7242),
    [anon_sym_LT_AMP] = ACTIONS(7242),
    [anon_sym_GT_AMP] = ACTIONS(7242),
    [anon_sym_LT_LT] = ACTIONS(7244),
    [anon_sym_LT_LT_DASH] = ACTIONS(7242),
    [anon_sym_LT_LT_LT] = ACTIONS(7242),
    [anon_sym_DOLLAR] = ACTIONS(7244),
    [sym__special_character] = ACTIONS(7244),
    [anon_sym_DQUOTE] = ACTIONS(7242),
    [sym_raw_string] = ACTIONS(7242),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7242),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7242),
    [anon_sym_BQUOTE] = ACTIONS(7242),
    [anon_sym_LT_LPAREN] = ACTIONS(7242),
    [anon_sym_GT_LPAREN] = ACTIONS(7242),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7244),
    [anon_sym_LF] = ACTIONS(7242),
    [anon_sym_AMP] = ACTIONS(7244),
  },
  [3184] = {
    [sym_string] = STATE(487),
    [sym__simple_heredoc_body] = ACTIONS(4071),
    [sym__heredoc_body_beginning] = ACTIONS(4071),
    [sym_file_descriptor] = ACTIONS(4071),
    [anon_sym_SEMI] = ACTIONS(4073),
    [anon_sym_PIPE] = ACTIONS(4073),
    [anon_sym_SEMI_SEMI] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(4071),
    [anon_sym_PIPE_AMP] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_PIPE_PIPE] = ACTIONS(4071),
    [anon_sym_LT] = ACTIONS(4073),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_GT_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT] = ACTIONS(4073),
    [anon_sym_AMP_GT_GT] = ACTIONS(4071),
    [anon_sym_LT_AMP] = ACTIONS(4071),
    [anon_sym_GT_AMP] = ACTIONS(4071),
    [anon_sym_LT_LT] = ACTIONS(4073),
    [anon_sym_LT_LT_DASH] = ACTIONS(4071),
    [anon_sym_LT_LT_LT] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(829),
    [anon_sym_DOLLAR] = ACTIONS(829),
    [anon_sym_DQUOTE] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(831),
    [anon_sym_POUND] = ACTIONS(829),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(833),
    [anon_sym_STAR] = ACTIONS(835),
    [anon_sym_AT] = ACTIONS(835),
    [anon_sym_QMARK] = ACTIONS(835),
    [anon_sym_0] = ACTIONS(833),
    [anon_sym__] = ACTIONS(833),
    [anon_sym_LF] = ACTIONS(4071),
    [anon_sym_AMP] = ACTIONS(4073),
  },
  [3185] = {
    [sym__concat] = ACTIONS(7198),
    [anon_sym_AMP_AMP] = ACTIONS(7198),
    [anon_sym_PIPE_PIPE] = ACTIONS(7198),
    [anon_sym_RBRACK] = ACTIONS(7198),
    [anon_sym_EQ_TILDE] = ACTIONS(7198),
    [anon_sym_EQ_EQ] = ACTIONS(7198),
    [anon_sym_EQ] = ACTIONS(7200),
    [anon_sym_PLUS_EQ] = ACTIONS(7198),
    [anon_sym_LT] = ACTIONS(7200),
    [anon_sym_GT] = ACTIONS(7200),
    [anon_sym_BANG_EQ] = ACTIONS(7198),
    [anon_sym_PLUS] = ACTIONS(7200),
    [anon_sym_DASH] = ACTIONS(7200),
    [anon_sym_DASH_EQ] = ACTIONS(7198),
    [anon_sym_LT_EQ] = ACTIONS(7198),
    [anon_sym_GT_EQ] = ACTIONS(7198),
    [anon_sym_PLUS_PLUS] = ACTIONS(7198),
    [anon_sym_DASH_DASH] = ACTIONS(7198),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7198),
  },
  [3186] = {
    [sym__concat] = ACTIONS(7202),
    [anon_sym_AMP_AMP] = ACTIONS(7202),
    [anon_sym_PIPE_PIPE] = ACTIONS(7202),
    [anon_sym_RBRACK] = ACTIONS(7202),
    [anon_sym_EQ_TILDE] = ACTIONS(7202),
    [anon_sym_EQ_EQ] = ACTIONS(7202),
    [anon_sym_EQ] = ACTIONS(7204),
    [anon_sym_PLUS_EQ] = ACTIONS(7202),
    [anon_sym_LT] = ACTIONS(7204),
    [anon_sym_GT] = ACTIONS(7204),
    [anon_sym_BANG_EQ] = ACTIONS(7202),
    [anon_sym_PLUS] = ACTIONS(7204),
    [anon_sym_DASH] = ACTIONS(7204),
    [anon_sym_DASH_EQ] = ACTIONS(7202),
    [anon_sym_LT_EQ] = ACTIONS(7202),
    [anon_sym_GT_EQ] = ACTIONS(7202),
    [anon_sym_PLUS_PLUS] = ACTIONS(7202),
    [anon_sym_DASH_DASH] = ACTIONS(7202),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7202),
  },
  [3187] = {
    [sym__concat] = ACTIONS(7206),
    [anon_sym_AMP_AMP] = ACTIONS(7206),
    [anon_sym_PIPE_PIPE] = ACTIONS(7206),
    [anon_sym_RBRACK] = ACTIONS(7206),
    [anon_sym_EQ_TILDE] = ACTIONS(7206),
    [anon_sym_EQ_EQ] = ACTIONS(7206),
    [anon_sym_EQ] = ACTIONS(7208),
    [anon_sym_PLUS_EQ] = ACTIONS(7206),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_BANG_EQ] = ACTIONS(7206),
    [anon_sym_PLUS] = ACTIONS(7208),
    [anon_sym_DASH] = ACTIONS(7208),
    [anon_sym_DASH_EQ] = ACTIONS(7206),
    [anon_sym_LT_EQ] = ACTIONS(7206),
    [anon_sym_GT_EQ] = ACTIONS(7206),
    [anon_sym_PLUS_PLUS] = ACTIONS(7206),
    [anon_sym_DASH_DASH] = ACTIONS(7206),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7206),
  },
  [3188] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8290),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3189] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8292),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3190] = {
    [sym__concat] = ACTIONS(7242),
    [anon_sym_AMP_AMP] = ACTIONS(7242),
    [anon_sym_PIPE_PIPE] = ACTIONS(7242),
    [anon_sym_RBRACK] = ACTIONS(7242),
    [anon_sym_EQ_TILDE] = ACTIONS(7242),
    [anon_sym_EQ_EQ] = ACTIONS(7242),
    [anon_sym_EQ] = ACTIONS(7244),
    [anon_sym_PLUS_EQ] = ACTIONS(7242),
    [anon_sym_LT] = ACTIONS(7244),
    [anon_sym_GT] = ACTIONS(7244),
    [anon_sym_BANG_EQ] = ACTIONS(7242),
    [anon_sym_PLUS] = ACTIONS(7244),
    [anon_sym_DASH] = ACTIONS(7244),
    [anon_sym_DASH_EQ] = ACTIONS(7242),
    [anon_sym_LT_EQ] = ACTIONS(7242),
    [anon_sym_GT_EQ] = ACTIONS(7242),
    [anon_sym_PLUS_PLUS] = ACTIONS(7242),
    [anon_sym_DASH_DASH] = ACTIONS(7242),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7242),
  },
  [3191] = {
    [sym__simple_heredoc_body] = ACTIONS(7198),
    [sym__heredoc_body_beginning] = ACTIONS(7198),
    [sym_file_descriptor] = ACTIONS(7198),
    [sym__concat] = ACTIONS(7198),
    [sym_variable_name] = ACTIONS(7198),
    [ts_builtin_sym_end] = ACTIONS(7198),
    [anon_sym_SEMI] = ACTIONS(7200),
    [anon_sym_PIPE] = ACTIONS(7200),
    [anon_sym_RPAREN] = ACTIONS(7198),
    [anon_sym_SEMI_SEMI] = ACTIONS(7198),
    [anon_sym_PIPE_AMP] = ACTIONS(7198),
    [anon_sym_AMP_AMP] = ACTIONS(7198),
    [anon_sym_PIPE_PIPE] = ACTIONS(7198),
    [anon_sym_LT] = ACTIONS(7200),
    [anon_sym_GT] = ACTIONS(7200),
    [anon_sym_GT_GT] = ACTIONS(7198),
    [anon_sym_AMP_GT] = ACTIONS(7200),
    [anon_sym_AMP_GT_GT] = ACTIONS(7198),
    [anon_sym_LT_AMP] = ACTIONS(7198),
    [anon_sym_GT_AMP] = ACTIONS(7198),
    [anon_sym_LT_LT] = ACTIONS(7200),
    [anon_sym_LT_LT_DASH] = ACTIONS(7198),
    [anon_sym_LT_LT_LT] = ACTIONS(7198),
    [anon_sym_DOLLAR] = ACTIONS(7200),
    [sym__special_character] = ACTIONS(7198),
    [anon_sym_DQUOTE] = ACTIONS(7198),
    [sym_raw_string] = ACTIONS(7198),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7198),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7198),
    [anon_sym_BQUOTE] = ACTIONS(7198),
    [anon_sym_LT_LPAREN] = ACTIONS(7198),
    [anon_sym_GT_LPAREN] = ACTIONS(7198),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7200),
    [sym_word] = ACTIONS(7200),
    [anon_sym_LF] = ACTIONS(7198),
    [anon_sym_AMP] = ACTIONS(7200),
  },
  [3192] = {
    [sym__simple_heredoc_body] = ACTIONS(7202),
    [sym__heredoc_body_beginning] = ACTIONS(7202),
    [sym_file_descriptor] = ACTIONS(7202),
    [sym__concat] = ACTIONS(7202),
    [sym_variable_name] = ACTIONS(7202),
    [ts_builtin_sym_end] = ACTIONS(7202),
    [anon_sym_SEMI] = ACTIONS(7204),
    [anon_sym_PIPE] = ACTIONS(7204),
    [anon_sym_RPAREN] = ACTIONS(7202),
    [anon_sym_SEMI_SEMI] = ACTIONS(7202),
    [anon_sym_PIPE_AMP] = ACTIONS(7202),
    [anon_sym_AMP_AMP] = ACTIONS(7202),
    [anon_sym_PIPE_PIPE] = ACTIONS(7202),
    [anon_sym_LT] = ACTIONS(7204),
    [anon_sym_GT] = ACTIONS(7204),
    [anon_sym_GT_GT] = ACTIONS(7202),
    [anon_sym_AMP_GT] = ACTIONS(7204),
    [anon_sym_AMP_GT_GT] = ACTIONS(7202),
    [anon_sym_LT_AMP] = ACTIONS(7202),
    [anon_sym_GT_AMP] = ACTIONS(7202),
    [anon_sym_LT_LT] = ACTIONS(7204),
    [anon_sym_LT_LT_DASH] = ACTIONS(7202),
    [anon_sym_LT_LT_LT] = ACTIONS(7202),
    [anon_sym_DOLLAR] = ACTIONS(7204),
    [sym__special_character] = ACTIONS(7202),
    [anon_sym_DQUOTE] = ACTIONS(7202),
    [sym_raw_string] = ACTIONS(7202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7202),
    [anon_sym_BQUOTE] = ACTIONS(7202),
    [anon_sym_LT_LPAREN] = ACTIONS(7202),
    [anon_sym_GT_LPAREN] = ACTIONS(7202),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7204),
    [sym_word] = ACTIONS(7204),
    [anon_sym_LF] = ACTIONS(7202),
    [anon_sym_AMP] = ACTIONS(7204),
  },
  [3193] = {
    [sym__simple_heredoc_body] = ACTIONS(7206),
    [sym__heredoc_body_beginning] = ACTIONS(7206),
    [sym_file_descriptor] = ACTIONS(7206),
    [sym__concat] = ACTIONS(7206),
    [sym_variable_name] = ACTIONS(7206),
    [ts_builtin_sym_end] = ACTIONS(7206),
    [anon_sym_SEMI] = ACTIONS(7208),
    [anon_sym_PIPE] = ACTIONS(7208),
    [anon_sym_RPAREN] = ACTIONS(7206),
    [anon_sym_SEMI_SEMI] = ACTIONS(7206),
    [anon_sym_PIPE_AMP] = ACTIONS(7206),
    [anon_sym_AMP_AMP] = ACTIONS(7206),
    [anon_sym_PIPE_PIPE] = ACTIONS(7206),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7206),
    [anon_sym_AMP_GT] = ACTIONS(7208),
    [anon_sym_AMP_GT_GT] = ACTIONS(7206),
    [anon_sym_LT_AMP] = ACTIONS(7206),
    [anon_sym_GT_AMP] = ACTIONS(7206),
    [anon_sym_LT_LT] = ACTIONS(7208),
    [anon_sym_LT_LT_DASH] = ACTIONS(7206),
    [anon_sym_LT_LT_LT] = ACTIONS(7206),
    [anon_sym_DOLLAR] = ACTIONS(7208),
    [sym__special_character] = ACTIONS(7206),
    [anon_sym_DQUOTE] = ACTIONS(7206),
    [sym_raw_string] = ACTIONS(7206),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7206),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7206),
    [anon_sym_BQUOTE] = ACTIONS(7206),
    [anon_sym_LT_LPAREN] = ACTIONS(7206),
    [anon_sym_GT_LPAREN] = ACTIONS(7206),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7208),
    [sym_word] = ACTIONS(7208),
    [anon_sym_LF] = ACTIONS(7206),
    [anon_sym_AMP] = ACTIONS(7208),
  },
  [3194] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8294),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3195] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8296),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3196] = {
    [sym__simple_heredoc_body] = ACTIONS(7242),
    [sym__heredoc_body_beginning] = ACTIONS(7242),
    [sym_file_descriptor] = ACTIONS(7242),
    [sym__concat] = ACTIONS(7242),
    [sym_variable_name] = ACTIONS(7242),
    [ts_builtin_sym_end] = ACTIONS(7242),
    [anon_sym_SEMI] = ACTIONS(7244),
    [anon_sym_PIPE] = ACTIONS(7244),
    [anon_sym_RPAREN] = ACTIONS(7242),
    [anon_sym_SEMI_SEMI] = ACTIONS(7242),
    [anon_sym_PIPE_AMP] = ACTIONS(7242),
    [anon_sym_AMP_AMP] = ACTIONS(7242),
    [anon_sym_PIPE_PIPE] = ACTIONS(7242),
    [anon_sym_LT] = ACTIONS(7244),
    [anon_sym_GT] = ACTIONS(7244),
    [anon_sym_GT_GT] = ACTIONS(7242),
    [anon_sym_AMP_GT] = ACTIONS(7244),
    [anon_sym_AMP_GT_GT] = ACTIONS(7242),
    [anon_sym_LT_AMP] = ACTIONS(7242),
    [anon_sym_GT_AMP] = ACTIONS(7242),
    [anon_sym_LT_LT] = ACTIONS(7244),
    [anon_sym_LT_LT_DASH] = ACTIONS(7242),
    [anon_sym_LT_LT_LT] = ACTIONS(7242),
    [anon_sym_DOLLAR] = ACTIONS(7244),
    [sym__special_character] = ACTIONS(7242),
    [anon_sym_DQUOTE] = ACTIONS(7242),
    [sym_raw_string] = ACTIONS(7242),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7242),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7242),
    [anon_sym_BQUOTE] = ACTIONS(7242),
    [anon_sym_LT_LPAREN] = ACTIONS(7242),
    [anon_sym_GT_LPAREN] = ACTIONS(7242),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7244),
    [sym_word] = ACTIONS(7244),
    [anon_sym_LF] = ACTIONS(7242),
    [anon_sym_AMP] = ACTIONS(7244),
  },
  [3197] = {
    [sym__simple_heredoc_body] = ACTIONS(7198),
    [sym__heredoc_body_beginning] = ACTIONS(7198),
    [sym_file_descriptor] = ACTIONS(7198),
    [sym__concat] = ACTIONS(7198),
    [ts_builtin_sym_end] = ACTIONS(7198),
    [anon_sym_SEMI] = ACTIONS(7200),
    [anon_sym_PIPE] = ACTIONS(7200),
    [anon_sym_RPAREN] = ACTIONS(7198),
    [anon_sym_SEMI_SEMI] = ACTIONS(7198),
    [anon_sym_PIPE_AMP] = ACTIONS(7198),
    [anon_sym_AMP_AMP] = ACTIONS(7198),
    [anon_sym_PIPE_PIPE] = ACTIONS(7198),
    [anon_sym_LT] = ACTIONS(7200),
    [anon_sym_GT] = ACTIONS(7200),
    [anon_sym_GT_GT] = ACTIONS(7198),
    [anon_sym_AMP_GT] = ACTIONS(7200),
    [anon_sym_AMP_GT_GT] = ACTIONS(7198),
    [anon_sym_LT_AMP] = ACTIONS(7198),
    [anon_sym_GT_AMP] = ACTIONS(7198),
    [anon_sym_LT_LT] = ACTIONS(7200),
    [anon_sym_LT_LT_DASH] = ACTIONS(7198),
    [anon_sym_LT_LT_LT] = ACTIONS(7198),
    [anon_sym_DOLLAR] = ACTIONS(7200),
    [sym__special_character] = ACTIONS(7198),
    [anon_sym_DQUOTE] = ACTIONS(7198),
    [sym_raw_string] = ACTIONS(7198),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7198),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7198),
    [anon_sym_BQUOTE] = ACTIONS(7198),
    [anon_sym_LT_LPAREN] = ACTIONS(7198),
    [anon_sym_GT_LPAREN] = ACTIONS(7198),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7200),
    [sym_word] = ACTIONS(7200),
    [anon_sym_LF] = ACTIONS(7198),
    [anon_sym_AMP] = ACTIONS(7200),
  },
  [3198] = {
    [sym__simple_heredoc_body] = ACTIONS(7202),
    [sym__heredoc_body_beginning] = ACTIONS(7202),
    [sym_file_descriptor] = ACTIONS(7202),
    [sym__concat] = ACTIONS(7202),
    [ts_builtin_sym_end] = ACTIONS(7202),
    [anon_sym_SEMI] = ACTIONS(7204),
    [anon_sym_PIPE] = ACTIONS(7204),
    [anon_sym_RPAREN] = ACTIONS(7202),
    [anon_sym_SEMI_SEMI] = ACTIONS(7202),
    [anon_sym_PIPE_AMP] = ACTIONS(7202),
    [anon_sym_AMP_AMP] = ACTIONS(7202),
    [anon_sym_PIPE_PIPE] = ACTIONS(7202),
    [anon_sym_LT] = ACTIONS(7204),
    [anon_sym_GT] = ACTIONS(7204),
    [anon_sym_GT_GT] = ACTIONS(7202),
    [anon_sym_AMP_GT] = ACTIONS(7204),
    [anon_sym_AMP_GT_GT] = ACTIONS(7202),
    [anon_sym_LT_AMP] = ACTIONS(7202),
    [anon_sym_GT_AMP] = ACTIONS(7202),
    [anon_sym_LT_LT] = ACTIONS(7204),
    [anon_sym_LT_LT_DASH] = ACTIONS(7202),
    [anon_sym_LT_LT_LT] = ACTIONS(7202),
    [anon_sym_DOLLAR] = ACTIONS(7204),
    [sym__special_character] = ACTIONS(7202),
    [anon_sym_DQUOTE] = ACTIONS(7202),
    [sym_raw_string] = ACTIONS(7202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7202),
    [anon_sym_BQUOTE] = ACTIONS(7202),
    [anon_sym_LT_LPAREN] = ACTIONS(7202),
    [anon_sym_GT_LPAREN] = ACTIONS(7202),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7204),
    [sym_word] = ACTIONS(7204),
    [anon_sym_LF] = ACTIONS(7202),
    [anon_sym_AMP] = ACTIONS(7204),
  },
  [3199] = {
    [sym__simple_heredoc_body] = ACTIONS(7206),
    [sym__heredoc_body_beginning] = ACTIONS(7206),
    [sym_file_descriptor] = ACTIONS(7206),
    [sym__concat] = ACTIONS(7206),
    [ts_builtin_sym_end] = ACTIONS(7206),
    [anon_sym_SEMI] = ACTIONS(7208),
    [anon_sym_PIPE] = ACTIONS(7208),
    [anon_sym_RPAREN] = ACTIONS(7206),
    [anon_sym_SEMI_SEMI] = ACTIONS(7206),
    [anon_sym_PIPE_AMP] = ACTIONS(7206),
    [anon_sym_AMP_AMP] = ACTIONS(7206),
    [anon_sym_PIPE_PIPE] = ACTIONS(7206),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7206),
    [anon_sym_AMP_GT] = ACTIONS(7208),
    [anon_sym_AMP_GT_GT] = ACTIONS(7206),
    [anon_sym_LT_AMP] = ACTIONS(7206),
    [anon_sym_GT_AMP] = ACTIONS(7206),
    [anon_sym_LT_LT] = ACTIONS(7208),
    [anon_sym_LT_LT_DASH] = ACTIONS(7206),
    [anon_sym_LT_LT_LT] = ACTIONS(7206),
    [anon_sym_DOLLAR] = ACTIONS(7208),
    [sym__special_character] = ACTIONS(7206),
    [anon_sym_DQUOTE] = ACTIONS(7206),
    [sym_raw_string] = ACTIONS(7206),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7206),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7206),
    [anon_sym_BQUOTE] = ACTIONS(7206),
    [anon_sym_LT_LPAREN] = ACTIONS(7206),
    [anon_sym_GT_LPAREN] = ACTIONS(7206),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7208),
    [sym_word] = ACTIONS(7208),
    [anon_sym_LF] = ACTIONS(7206),
    [anon_sym_AMP] = ACTIONS(7208),
  },
  [3200] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8298),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3201] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8300),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3202] = {
    [sym__simple_heredoc_body] = ACTIONS(7242),
    [sym__heredoc_body_beginning] = ACTIONS(7242),
    [sym_file_descriptor] = ACTIONS(7242),
    [sym__concat] = ACTIONS(7242),
    [ts_builtin_sym_end] = ACTIONS(7242),
    [anon_sym_SEMI] = ACTIONS(7244),
    [anon_sym_PIPE] = ACTIONS(7244),
    [anon_sym_RPAREN] = ACTIONS(7242),
    [anon_sym_SEMI_SEMI] = ACTIONS(7242),
    [anon_sym_PIPE_AMP] = ACTIONS(7242),
    [anon_sym_AMP_AMP] = ACTIONS(7242),
    [anon_sym_PIPE_PIPE] = ACTIONS(7242),
    [anon_sym_LT] = ACTIONS(7244),
    [anon_sym_GT] = ACTIONS(7244),
    [anon_sym_GT_GT] = ACTIONS(7242),
    [anon_sym_AMP_GT] = ACTIONS(7244),
    [anon_sym_AMP_GT_GT] = ACTIONS(7242),
    [anon_sym_LT_AMP] = ACTIONS(7242),
    [anon_sym_GT_AMP] = ACTIONS(7242),
    [anon_sym_LT_LT] = ACTIONS(7244),
    [anon_sym_LT_LT_DASH] = ACTIONS(7242),
    [anon_sym_LT_LT_LT] = ACTIONS(7242),
    [anon_sym_DOLLAR] = ACTIONS(7244),
    [sym__special_character] = ACTIONS(7242),
    [anon_sym_DQUOTE] = ACTIONS(7242),
    [sym_raw_string] = ACTIONS(7242),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7242),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7242),
    [anon_sym_BQUOTE] = ACTIONS(7242),
    [anon_sym_LT_LPAREN] = ACTIONS(7242),
    [anon_sym_GT_LPAREN] = ACTIONS(7242),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7244),
    [sym_word] = ACTIONS(7244),
    [anon_sym_LF] = ACTIONS(7242),
    [anon_sym_AMP] = ACTIONS(7244),
  },
  [3203] = {
    [sym_file_descriptor] = ACTIONS(7198),
    [sym__concat] = ACTIONS(7198),
    [sym_variable_name] = ACTIONS(7198),
    [anon_sym_RPAREN] = ACTIONS(7198),
    [anon_sym_LT] = ACTIONS(7200),
    [anon_sym_GT] = ACTIONS(7200),
    [anon_sym_GT_GT] = ACTIONS(7198),
    [anon_sym_AMP_GT] = ACTIONS(7200),
    [anon_sym_AMP_GT_GT] = ACTIONS(7198),
    [anon_sym_LT_AMP] = ACTIONS(7198),
    [anon_sym_GT_AMP] = ACTIONS(7198),
    [anon_sym_DOLLAR] = ACTIONS(7200),
    [sym__special_character] = ACTIONS(7198),
    [anon_sym_DQUOTE] = ACTIONS(7198),
    [sym_raw_string] = ACTIONS(7198),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7198),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7198),
    [anon_sym_BQUOTE] = ACTIONS(7198),
    [anon_sym_LT_LPAREN] = ACTIONS(7198),
    [anon_sym_GT_LPAREN] = ACTIONS(7198),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7198),
  },
  [3204] = {
    [sym_file_descriptor] = ACTIONS(7202),
    [sym__concat] = ACTIONS(7202),
    [sym_variable_name] = ACTIONS(7202),
    [anon_sym_RPAREN] = ACTIONS(7202),
    [anon_sym_LT] = ACTIONS(7204),
    [anon_sym_GT] = ACTIONS(7204),
    [anon_sym_GT_GT] = ACTIONS(7202),
    [anon_sym_AMP_GT] = ACTIONS(7204),
    [anon_sym_AMP_GT_GT] = ACTIONS(7202),
    [anon_sym_LT_AMP] = ACTIONS(7202),
    [anon_sym_GT_AMP] = ACTIONS(7202),
    [anon_sym_DOLLAR] = ACTIONS(7204),
    [sym__special_character] = ACTIONS(7202),
    [anon_sym_DQUOTE] = ACTIONS(7202),
    [sym_raw_string] = ACTIONS(7202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7202),
    [anon_sym_BQUOTE] = ACTIONS(7202),
    [anon_sym_LT_LPAREN] = ACTIONS(7202),
    [anon_sym_GT_LPAREN] = ACTIONS(7202),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7202),
  },
  [3205] = {
    [sym_file_descriptor] = ACTIONS(7206),
    [sym__concat] = ACTIONS(7206),
    [sym_variable_name] = ACTIONS(7206),
    [anon_sym_RPAREN] = ACTIONS(7206),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7206),
    [anon_sym_AMP_GT] = ACTIONS(7208),
    [anon_sym_AMP_GT_GT] = ACTIONS(7206),
    [anon_sym_LT_AMP] = ACTIONS(7206),
    [anon_sym_GT_AMP] = ACTIONS(7206),
    [anon_sym_DOLLAR] = ACTIONS(7208),
    [sym__special_character] = ACTIONS(7206),
    [anon_sym_DQUOTE] = ACTIONS(7206),
    [sym_raw_string] = ACTIONS(7206),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7206),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7206),
    [anon_sym_BQUOTE] = ACTIONS(7206),
    [anon_sym_LT_LPAREN] = ACTIONS(7206),
    [anon_sym_GT_LPAREN] = ACTIONS(7206),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7206),
  },
  [3206] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8302),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3207] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8304),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3208] = {
    [sym_file_descriptor] = ACTIONS(7242),
    [sym__concat] = ACTIONS(7242),
    [sym_variable_name] = ACTIONS(7242),
    [anon_sym_RPAREN] = ACTIONS(7242),
    [anon_sym_LT] = ACTIONS(7244),
    [anon_sym_GT] = ACTIONS(7244),
    [anon_sym_GT_GT] = ACTIONS(7242),
    [anon_sym_AMP_GT] = ACTIONS(7244),
    [anon_sym_AMP_GT_GT] = ACTIONS(7242),
    [anon_sym_LT_AMP] = ACTIONS(7242),
    [anon_sym_GT_AMP] = ACTIONS(7242),
    [anon_sym_DOLLAR] = ACTIONS(7244),
    [sym__special_character] = ACTIONS(7242),
    [anon_sym_DQUOTE] = ACTIONS(7242),
    [sym_raw_string] = ACTIONS(7242),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7242),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7242),
    [anon_sym_BQUOTE] = ACTIONS(7242),
    [anon_sym_LT_LPAREN] = ACTIONS(7242),
    [anon_sym_GT_LPAREN] = ACTIONS(7242),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7242),
  },
  [3209] = {
    [sym__concat] = ACTIONS(7198),
    [anon_sym_DOLLAR] = ACTIONS(7200),
    [anon_sym_DQUOTE] = ACTIONS(7200),
    [sym__string_content] = ACTIONS(7198),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7200),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7200),
    [anon_sym_BQUOTE] = ACTIONS(7200),
    [sym_comment] = ACTIONS(329),
  },
  [3210] = {
    [sym__concat] = ACTIONS(7202),
    [anon_sym_DOLLAR] = ACTIONS(7204),
    [anon_sym_DQUOTE] = ACTIONS(7204),
    [sym__string_content] = ACTIONS(7202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7204),
    [anon_sym_BQUOTE] = ACTIONS(7204),
    [sym_comment] = ACTIONS(329),
  },
  [3211] = {
    [sym__concat] = ACTIONS(7206),
    [anon_sym_DOLLAR] = ACTIONS(7208),
    [anon_sym_DQUOTE] = ACTIONS(7208),
    [sym__string_content] = ACTIONS(7206),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7208),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7208),
    [anon_sym_BQUOTE] = ACTIONS(7208),
    [sym_comment] = ACTIONS(329),
  },
  [3212] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8306),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3213] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8308),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3214] = {
    [sym__concat] = ACTIONS(7242),
    [anon_sym_DOLLAR] = ACTIONS(7244),
    [anon_sym_DQUOTE] = ACTIONS(7244),
    [sym__string_content] = ACTIONS(7242),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7244),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7244),
    [anon_sym_BQUOTE] = ACTIONS(7244),
    [sym_comment] = ACTIONS(329),
  },
  [3215] = {
    [anon_sym_RBRACE] = ACTIONS(5822),
    [anon_sym_EQ] = ACTIONS(8310),
    [anon_sym_DASH] = ACTIONS(8310),
    [anon_sym_DOLLAR] = ACTIONS(8310),
    [sym__special_character] = ACTIONS(8310),
    [anon_sym_DQUOTE] = ACTIONS(5822),
    [sym_raw_string] = ACTIONS(5822),
    [anon_sym_POUND] = ACTIONS(5822),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5822),
    [anon_sym_SLASH] = ACTIONS(5822),
    [anon_sym_COLON] = ACTIONS(8310),
    [anon_sym_COLON_QMARK] = ACTIONS(8310),
    [anon_sym_COLON_DASH] = ACTIONS(8310),
    [anon_sym_PERCENT] = ACTIONS(8310),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5822),
    [anon_sym_BQUOTE] = ACTIONS(5822),
    [anon_sym_LT_LPAREN] = ACTIONS(5822),
    [anon_sym_GT_LPAREN] = ACTIONS(5822),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(8310),
  },
  [3216] = {
    [anon_sym_RBRACE] = ACTIONS(5824),
    [anon_sym_EQ] = ACTIONS(8312),
    [anon_sym_DASH] = ACTIONS(8312),
    [anon_sym_DOLLAR] = ACTIONS(8312),
    [sym__special_character] = ACTIONS(8312),
    [anon_sym_DQUOTE] = ACTIONS(5824),
    [sym_raw_string] = ACTIONS(5824),
    [anon_sym_POUND] = ACTIONS(5824),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5824),
    [anon_sym_SLASH] = ACTIONS(5824),
    [anon_sym_COLON] = ACTIONS(8312),
    [anon_sym_COLON_QMARK] = ACTIONS(8312),
    [anon_sym_COLON_DASH] = ACTIONS(8312),
    [anon_sym_PERCENT] = ACTIONS(8312),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5824),
    [anon_sym_BQUOTE] = ACTIONS(5824),
    [anon_sym_LT_LPAREN] = ACTIONS(5824),
    [anon_sym_GT_LPAREN] = ACTIONS(5824),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(8312),
  },
  [3217] = {
    [sym_string] = STATE(1929),
    [anon_sym_RBRACE] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(4129),
    [anon_sym_DOLLAR] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(4131),
    [anon_sym_POUND] = ACTIONS(4129),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4133),
    [anon_sym_STAR] = ACTIONS(4135),
    [anon_sym_AT] = ACTIONS(4135),
    [anon_sym_QMARK] = ACTIONS(4135),
    [anon_sym_0] = ACTIONS(4133),
    [anon_sym__] = ACTIONS(4133),
  },
  [3218] = {
    [sym__concat] = ACTIONS(4111),
    [anon_sym_RBRACE] = ACTIONS(4111),
    [sym_comment] = ACTIONS(57),
  },
  [3219] = {
    [sym__concat] = ACTIONS(4125),
    [anon_sym_RBRACE] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
  },
  [3220] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(8314),
    [sym_comment] = ACTIONS(57),
  },
  [3221] = {
    [anon_sym_RBRACE] = ACTIONS(8314),
    [sym_comment] = ACTIONS(57),
  },
  [3222] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(8316),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [3223] = {
    [sym_concatenation] = STATE(3685),
    [sym_string] = STATE(3684),
    [sym_simple_expansion] = STATE(3684),
    [sym_string_expansion] = STATE(3684),
    [sym_expansion] = STATE(3684),
    [sym_command_substitution] = STATE(3684),
    [sym_process_substitution] = STATE(3684),
    [aux_sym__literal_repeat1] = STATE(3686),
    [anon_sym_RBRACE] = ACTIONS(8314),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(8318),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8318),
  },
  [3224] = {
    [sym__concat] = ACTIONS(4161),
    [anon_sym_RBRACE] = ACTIONS(4161),
    [sym_comment] = ACTIONS(57),
  },
  [3225] = {
    [sym_concatenation] = STATE(3689),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3689),
    [sym_regex] = ACTIONS(8320),
    [anon_sym_RBRACE] = ACTIONS(8322),
    [anon_sym_EQ] = ACTIONS(8324),
    [anon_sym_DASH] = ACTIONS(8324),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8326),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8324),
    [anon_sym_COLON_QMARK] = ACTIONS(8324),
    [anon_sym_COLON_DASH] = ACTIONS(8324),
    [anon_sym_PERCENT] = ACTIONS(8324),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3226] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8322),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3227] = {
    [sym_concatenation] = STATE(3691),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3691),
    [sym_regex] = ACTIONS(8328),
    [anon_sym_RBRACE] = ACTIONS(8314),
    [anon_sym_EQ] = ACTIONS(8330),
    [anon_sym_DASH] = ACTIONS(8330),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8332),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8330),
    [anon_sym_COLON_QMARK] = ACTIONS(8330),
    [anon_sym_COLON_DASH] = ACTIONS(8330),
    [anon_sym_PERCENT] = ACTIONS(8330),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3228] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8314),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3229] = {
    [sym_concatenation] = STATE(3693),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3693),
    [anon_sym_RBRACE] = ACTIONS(8334),
    [anon_sym_EQ] = ACTIONS(8336),
    [anon_sym_DASH] = ACTIONS(8336),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8336),
    [anon_sym_COLON_QMARK] = ACTIONS(8336),
    [anon_sym_COLON_DASH] = ACTIONS(8336),
    [anon_sym_PERCENT] = ACTIONS(8336),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3230] = {
    [sym__concat] = ACTIONS(4219),
    [anon_sym_RBRACE] = ACTIONS(4219),
    [sym_comment] = ACTIONS(57),
  },
  [3231] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8334),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3232] = {
    [sym_concatenation] = STATE(3691),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3691),
    [anon_sym_RBRACE] = ACTIONS(8314),
    [anon_sym_EQ] = ACTIONS(8330),
    [anon_sym_DASH] = ACTIONS(8330),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8332),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8330),
    [anon_sym_COLON_QMARK] = ACTIONS(8330),
    [anon_sym_COLON_DASH] = ACTIONS(8330),
    [anon_sym_PERCENT] = ACTIONS(8330),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3233] = {
    [sym__simple_heredoc_body] = ACTIONS(8340),
    [sym__heredoc_body_beginning] = ACTIONS(8340),
    [sym_file_descriptor] = ACTIONS(8340),
    [sym__concat] = ACTIONS(8340),
    [ts_builtin_sym_end] = ACTIONS(8340),
    [anon_sym_SEMI] = ACTIONS(8342),
    [anon_sym_PIPE] = ACTIONS(8342),
    [anon_sym_RPAREN] = ACTIONS(8340),
    [anon_sym_SEMI_SEMI] = ACTIONS(8340),
    [anon_sym_PIPE_AMP] = ACTIONS(8340),
    [anon_sym_AMP_AMP] = ACTIONS(8340),
    [anon_sym_PIPE_PIPE] = ACTIONS(8340),
    [anon_sym_EQ_TILDE] = ACTIONS(8342),
    [anon_sym_EQ_EQ] = ACTIONS(8342),
    [anon_sym_LT] = ACTIONS(8342),
    [anon_sym_GT] = ACTIONS(8342),
    [anon_sym_GT_GT] = ACTIONS(8340),
    [anon_sym_AMP_GT] = ACTIONS(8342),
    [anon_sym_AMP_GT_GT] = ACTIONS(8340),
    [anon_sym_LT_AMP] = ACTIONS(8340),
    [anon_sym_GT_AMP] = ACTIONS(8340),
    [anon_sym_LT_LT] = ACTIONS(8342),
    [anon_sym_LT_LT_DASH] = ACTIONS(8340),
    [anon_sym_LT_LT_LT] = ACTIONS(8340),
    [anon_sym_DOLLAR] = ACTIONS(8342),
    [sym__special_character] = ACTIONS(8340),
    [anon_sym_DQUOTE] = ACTIONS(8340),
    [sym_raw_string] = ACTIONS(8340),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8340),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [anon_sym_LT_LPAREN] = ACTIONS(8340),
    [anon_sym_GT_LPAREN] = ACTIONS(8340),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8342),
    [anon_sym_LF] = ACTIONS(8340),
    [anon_sym_AMP] = ACTIONS(8342),
  },
  [3234] = {
    [sym__simple_heredoc_body] = ACTIONS(8344),
    [sym__heredoc_body_beginning] = ACTIONS(8344),
    [sym_file_descriptor] = ACTIONS(8344),
    [sym__concat] = ACTIONS(8344),
    [ts_builtin_sym_end] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [anon_sym_PIPE] = ACTIONS(8346),
    [anon_sym_RPAREN] = ACTIONS(8344),
    [anon_sym_SEMI_SEMI] = ACTIONS(8344),
    [anon_sym_PIPE_AMP] = ACTIONS(8344),
    [anon_sym_AMP_AMP] = ACTIONS(8344),
    [anon_sym_PIPE_PIPE] = ACTIONS(8344),
    [anon_sym_EQ_TILDE] = ACTIONS(8346),
    [anon_sym_EQ_EQ] = ACTIONS(8346),
    [anon_sym_LT] = ACTIONS(8346),
    [anon_sym_GT] = ACTIONS(8346),
    [anon_sym_GT_GT] = ACTIONS(8344),
    [anon_sym_AMP_GT] = ACTIONS(8346),
    [anon_sym_AMP_GT_GT] = ACTIONS(8344),
    [anon_sym_LT_AMP] = ACTIONS(8344),
    [anon_sym_GT_AMP] = ACTIONS(8344),
    [anon_sym_LT_LT] = ACTIONS(8346),
    [anon_sym_LT_LT_DASH] = ACTIONS(8344),
    [anon_sym_LT_LT_LT] = ACTIONS(8344),
    [anon_sym_DOLLAR] = ACTIONS(8346),
    [sym__special_character] = ACTIONS(8344),
    [anon_sym_DQUOTE] = ACTIONS(8344),
    [sym_raw_string] = ACTIONS(8344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8344),
    [anon_sym_BQUOTE] = ACTIONS(8344),
    [anon_sym_LT_LPAREN] = ACTIONS(8344),
    [anon_sym_GT_LPAREN] = ACTIONS(8344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8346),
    [anon_sym_LF] = ACTIONS(8344),
    [anon_sym_AMP] = ACTIONS(8346),
  },
  [3235] = {
    [sym__concat] = ACTIONS(5674),
    [anon_sym_RBRACE] = ACTIONS(5674),
    [anon_sym_EQ] = ACTIONS(5676),
    [anon_sym_DASH] = ACTIONS(5676),
    [anon_sym_DOLLAR] = ACTIONS(5676),
    [sym__special_character] = ACTIONS(5676),
    [anon_sym_DQUOTE] = ACTIONS(5674),
    [sym_raw_string] = ACTIONS(5674),
    [anon_sym_POUND] = ACTIONS(5674),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5674),
    [anon_sym_COLON] = ACTIONS(5676),
    [anon_sym_COLON_QMARK] = ACTIONS(5676),
    [anon_sym_COLON_DASH] = ACTIONS(5676),
    [anon_sym_PERCENT] = ACTIONS(5676),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5674),
    [anon_sym_BQUOTE] = ACTIONS(5674),
    [anon_sym_LT_LPAREN] = ACTIONS(5674),
    [anon_sym_GT_LPAREN] = ACTIONS(5674),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(5676),
  },
  [3236] = {
    [sym__concat] = ACTIONS(5708),
    [anon_sym_RBRACE] = ACTIONS(5708),
    [anon_sym_EQ] = ACTIONS(5710),
    [anon_sym_DASH] = ACTIONS(5710),
    [anon_sym_DOLLAR] = ACTIONS(5710),
    [sym__special_character] = ACTIONS(5710),
    [anon_sym_DQUOTE] = ACTIONS(5708),
    [sym_raw_string] = ACTIONS(5708),
    [anon_sym_POUND] = ACTIONS(5708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5708),
    [anon_sym_COLON] = ACTIONS(5710),
    [anon_sym_COLON_QMARK] = ACTIONS(5710),
    [anon_sym_COLON_DASH] = ACTIONS(5710),
    [anon_sym_PERCENT] = ACTIONS(5710),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5708),
    [anon_sym_BQUOTE] = ACTIONS(5708),
    [anon_sym_LT_LPAREN] = ACTIONS(5708),
    [anon_sym_GT_LPAREN] = ACTIONS(5708),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(5710),
  },
  [3237] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(8348),
    [sym_comment] = ACTIONS(57),
  },
  [3238] = {
    [anon_sym_RBRACE] = ACTIONS(8348),
    [sym_comment] = ACTIONS(57),
  },
  [3239] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(8350),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [3240] = {
    [sym_concatenation] = STATE(3697),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3697),
    [anon_sym_RBRACE] = ACTIONS(8352),
    [anon_sym_EQ] = ACTIONS(8354),
    [anon_sym_DASH] = ACTIONS(8354),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8356),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8354),
    [anon_sym_COLON_QMARK] = ACTIONS(8354),
    [anon_sym_COLON_DASH] = ACTIONS(8354),
    [anon_sym_PERCENT] = ACTIONS(8354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3241] = {
    [sym__concat] = ACTIONS(5725),
    [anon_sym_RBRACE] = ACTIONS(5725),
    [anon_sym_EQ] = ACTIONS(5727),
    [anon_sym_DASH] = ACTIONS(5727),
    [anon_sym_DOLLAR] = ACTIONS(5727),
    [sym__special_character] = ACTIONS(5727),
    [anon_sym_DQUOTE] = ACTIONS(5725),
    [sym_raw_string] = ACTIONS(5725),
    [anon_sym_POUND] = ACTIONS(5725),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5725),
    [anon_sym_COLON] = ACTIONS(5727),
    [anon_sym_COLON_QMARK] = ACTIONS(5727),
    [anon_sym_COLON_DASH] = ACTIONS(5727),
    [anon_sym_PERCENT] = ACTIONS(5727),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5725),
    [anon_sym_BQUOTE] = ACTIONS(5725),
    [anon_sym_LT_LPAREN] = ACTIONS(5725),
    [anon_sym_GT_LPAREN] = ACTIONS(5725),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(5727),
  },
  [3242] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8352),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3243] = {
    [sym_concatenation] = STATE(3698),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3698),
    [anon_sym_RBRACE] = ACTIONS(8348),
    [anon_sym_EQ] = ACTIONS(8358),
    [anon_sym_DASH] = ACTIONS(8358),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8358),
    [anon_sym_COLON_QMARK] = ACTIONS(8358),
    [anon_sym_COLON_DASH] = ACTIONS(8358),
    [anon_sym_PERCENT] = ACTIONS(8358),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3244] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8348),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3245] = {
    [sym__concat] = ACTIONS(5770),
    [anon_sym_RBRACE] = ACTIONS(5770),
    [anon_sym_EQ] = ACTIONS(5772),
    [anon_sym_DASH] = ACTIONS(5772),
    [anon_sym_DOLLAR] = ACTIONS(5772),
    [sym__special_character] = ACTIONS(5772),
    [anon_sym_DQUOTE] = ACTIONS(5770),
    [sym_raw_string] = ACTIONS(5770),
    [anon_sym_POUND] = ACTIONS(5770),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5770),
    [anon_sym_COLON] = ACTIONS(5772),
    [anon_sym_COLON_QMARK] = ACTIONS(5772),
    [anon_sym_COLON_DASH] = ACTIONS(5772),
    [anon_sym_PERCENT] = ACTIONS(5772),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5770),
    [anon_sym_BQUOTE] = ACTIONS(5770),
    [anon_sym_LT_LPAREN] = ACTIONS(5770),
    [anon_sym_GT_LPAREN] = ACTIONS(5770),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(5772),
  },
  [3246] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8362),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3247] = {
    [sym__heredoc_body_middle] = ACTIONS(5674),
    [sym__heredoc_body_end] = ACTIONS(5674),
    [anon_sym_DOLLAR] = ACTIONS(5676),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5674),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5674),
    [anon_sym_BQUOTE] = ACTIONS(5674),
    [sym_comment] = ACTIONS(57),
  },
  [3248] = {
    [sym__heredoc_body_middle] = ACTIONS(5708),
    [sym__heredoc_body_end] = ACTIONS(5708),
    [anon_sym_DOLLAR] = ACTIONS(5710),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5708),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5708),
    [anon_sym_BQUOTE] = ACTIONS(5708),
    [sym_comment] = ACTIONS(57),
  },
  [3249] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(8364),
    [sym_comment] = ACTIONS(57),
  },
  [3250] = {
    [anon_sym_RBRACE] = ACTIONS(8364),
    [sym_comment] = ACTIONS(57),
  },
  [3251] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(8366),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [3252] = {
    [sym_concatenation] = STATE(3703),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3703),
    [anon_sym_RBRACE] = ACTIONS(8368),
    [anon_sym_EQ] = ACTIONS(8370),
    [anon_sym_DASH] = ACTIONS(8370),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8372),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8370),
    [anon_sym_COLON_QMARK] = ACTIONS(8370),
    [anon_sym_COLON_DASH] = ACTIONS(8370),
    [anon_sym_PERCENT] = ACTIONS(8370),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3253] = {
    [sym__heredoc_body_middle] = ACTIONS(5725),
    [sym__heredoc_body_end] = ACTIONS(5725),
    [anon_sym_DOLLAR] = ACTIONS(5727),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5725),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5725),
    [anon_sym_BQUOTE] = ACTIONS(5725),
    [sym_comment] = ACTIONS(57),
  },
  [3254] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8368),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3255] = {
    [sym_concatenation] = STATE(3704),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3704),
    [anon_sym_RBRACE] = ACTIONS(8364),
    [anon_sym_EQ] = ACTIONS(8374),
    [anon_sym_DASH] = ACTIONS(8374),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8376),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8374),
    [anon_sym_COLON_QMARK] = ACTIONS(8374),
    [anon_sym_COLON_DASH] = ACTIONS(8374),
    [anon_sym_PERCENT] = ACTIONS(8374),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3256] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8364),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3257] = {
    [sym__heredoc_body_middle] = ACTIONS(5770),
    [sym__heredoc_body_end] = ACTIONS(5770),
    [anon_sym_DOLLAR] = ACTIONS(5772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5770),
    [anon_sym_BQUOTE] = ACTIONS(5770),
    [sym_comment] = ACTIONS(57),
  },
  [3258] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8378),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3259] = {
    [aux_sym_concatenation_repeat1] = STATE(3259),
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(2368),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [3260] = {
    [sym__concat] = ACTIONS(5674),
    [anon_sym_RPAREN] = ACTIONS(5674),
    [anon_sym_DOLLAR] = ACTIONS(5676),
    [sym__special_character] = ACTIONS(5674),
    [anon_sym_DQUOTE] = ACTIONS(5674),
    [sym_raw_string] = ACTIONS(5674),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5674),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5674),
    [anon_sym_BQUOTE] = ACTIONS(5674),
    [anon_sym_LT_LPAREN] = ACTIONS(5674),
    [anon_sym_GT_LPAREN] = ACTIONS(5674),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5674),
  },
  [3261] = {
    [sym__concat] = ACTIONS(5708),
    [anon_sym_RPAREN] = ACTIONS(5708),
    [anon_sym_DOLLAR] = ACTIONS(5710),
    [sym__special_character] = ACTIONS(5708),
    [anon_sym_DQUOTE] = ACTIONS(5708),
    [sym_raw_string] = ACTIONS(5708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5708),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5708),
    [anon_sym_BQUOTE] = ACTIONS(5708),
    [anon_sym_LT_LPAREN] = ACTIONS(5708),
    [anon_sym_GT_LPAREN] = ACTIONS(5708),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5708),
  },
  [3262] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(8380),
    [sym_comment] = ACTIONS(57),
  },
  [3263] = {
    [anon_sym_RBRACE] = ACTIONS(8380),
    [sym_comment] = ACTIONS(57),
  },
  [3264] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(8382),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [3265] = {
    [sym_concatenation] = STATE(3709),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3709),
    [anon_sym_RBRACE] = ACTIONS(8384),
    [anon_sym_EQ] = ACTIONS(8386),
    [anon_sym_DASH] = ACTIONS(8386),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8388),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8386),
    [anon_sym_COLON_QMARK] = ACTIONS(8386),
    [anon_sym_COLON_DASH] = ACTIONS(8386),
    [anon_sym_PERCENT] = ACTIONS(8386),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3266] = {
    [sym__concat] = ACTIONS(5725),
    [anon_sym_RPAREN] = ACTIONS(5725),
    [anon_sym_DOLLAR] = ACTIONS(5727),
    [sym__special_character] = ACTIONS(5725),
    [anon_sym_DQUOTE] = ACTIONS(5725),
    [sym_raw_string] = ACTIONS(5725),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5725),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5725),
    [anon_sym_BQUOTE] = ACTIONS(5725),
    [anon_sym_LT_LPAREN] = ACTIONS(5725),
    [anon_sym_GT_LPAREN] = ACTIONS(5725),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5725),
  },
  [3267] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8384),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3268] = {
    [sym_concatenation] = STATE(3710),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3710),
    [anon_sym_RBRACE] = ACTIONS(8380),
    [anon_sym_EQ] = ACTIONS(8390),
    [anon_sym_DASH] = ACTIONS(8390),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8392),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8390),
    [anon_sym_COLON_QMARK] = ACTIONS(8390),
    [anon_sym_COLON_DASH] = ACTIONS(8390),
    [anon_sym_PERCENT] = ACTIONS(8390),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3269] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8380),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3270] = {
    [sym__concat] = ACTIONS(5770),
    [anon_sym_RPAREN] = ACTIONS(5770),
    [anon_sym_DOLLAR] = ACTIONS(5772),
    [sym__special_character] = ACTIONS(5770),
    [anon_sym_DQUOTE] = ACTIONS(5770),
    [sym_raw_string] = ACTIONS(5770),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5770),
    [anon_sym_BQUOTE] = ACTIONS(5770),
    [anon_sym_LT_LPAREN] = ACTIONS(5770),
    [anon_sym_GT_LPAREN] = ACTIONS(5770),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5770),
  },
  [3271] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8394),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3272] = {
    [sym__simple_heredoc_body] = ACTIONS(7198),
    [sym__heredoc_body_beginning] = ACTIONS(7198),
    [sym_file_descriptor] = ACTIONS(7198),
    [sym__concat] = ACTIONS(7198),
    [sym_variable_name] = ACTIONS(7198),
    [ts_builtin_sym_end] = ACTIONS(7198),
    [anon_sym_SEMI] = ACTIONS(7200),
    [anon_sym_PIPE] = ACTIONS(7200),
    [anon_sym_RPAREN] = ACTIONS(7198),
    [anon_sym_SEMI_SEMI] = ACTIONS(7198),
    [anon_sym_PIPE_AMP] = ACTIONS(7198),
    [anon_sym_AMP_AMP] = ACTIONS(7198),
    [anon_sym_PIPE_PIPE] = ACTIONS(7198),
    [anon_sym_LT] = ACTIONS(7200),
    [anon_sym_GT] = ACTIONS(7200),
    [anon_sym_GT_GT] = ACTIONS(7198),
    [anon_sym_AMP_GT] = ACTIONS(7200),
    [anon_sym_AMP_GT_GT] = ACTIONS(7198),
    [anon_sym_LT_AMP] = ACTIONS(7198),
    [anon_sym_GT_AMP] = ACTIONS(7198),
    [anon_sym_LT_LT] = ACTIONS(7200),
    [anon_sym_LT_LT_DASH] = ACTIONS(7198),
    [anon_sym_LT_LT_LT] = ACTIONS(7198),
    [anon_sym_DOLLAR] = ACTIONS(7200),
    [sym__special_character] = ACTIONS(7198),
    [anon_sym_DQUOTE] = ACTIONS(7198),
    [sym_raw_string] = ACTIONS(7198),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7198),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7198),
    [anon_sym_BQUOTE] = ACTIONS(7198),
    [anon_sym_LT_LPAREN] = ACTIONS(7198),
    [anon_sym_GT_LPAREN] = ACTIONS(7198),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7200),
    [anon_sym_LF] = ACTIONS(7198),
    [anon_sym_AMP] = ACTIONS(7200),
  },
  [3273] = {
    [sym__simple_heredoc_body] = ACTIONS(7202),
    [sym__heredoc_body_beginning] = ACTIONS(7202),
    [sym_file_descriptor] = ACTIONS(7202),
    [sym__concat] = ACTIONS(7202),
    [sym_variable_name] = ACTIONS(7202),
    [ts_builtin_sym_end] = ACTIONS(7202),
    [anon_sym_SEMI] = ACTIONS(7204),
    [anon_sym_PIPE] = ACTIONS(7204),
    [anon_sym_RPAREN] = ACTIONS(7202),
    [anon_sym_SEMI_SEMI] = ACTIONS(7202),
    [anon_sym_PIPE_AMP] = ACTIONS(7202),
    [anon_sym_AMP_AMP] = ACTIONS(7202),
    [anon_sym_PIPE_PIPE] = ACTIONS(7202),
    [anon_sym_LT] = ACTIONS(7204),
    [anon_sym_GT] = ACTIONS(7204),
    [anon_sym_GT_GT] = ACTIONS(7202),
    [anon_sym_AMP_GT] = ACTIONS(7204),
    [anon_sym_AMP_GT_GT] = ACTIONS(7202),
    [anon_sym_LT_AMP] = ACTIONS(7202),
    [anon_sym_GT_AMP] = ACTIONS(7202),
    [anon_sym_LT_LT] = ACTIONS(7204),
    [anon_sym_LT_LT_DASH] = ACTIONS(7202),
    [anon_sym_LT_LT_LT] = ACTIONS(7202),
    [anon_sym_DOLLAR] = ACTIONS(7204),
    [sym__special_character] = ACTIONS(7202),
    [anon_sym_DQUOTE] = ACTIONS(7202),
    [sym_raw_string] = ACTIONS(7202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7202),
    [anon_sym_BQUOTE] = ACTIONS(7202),
    [anon_sym_LT_LPAREN] = ACTIONS(7202),
    [anon_sym_GT_LPAREN] = ACTIONS(7202),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7204),
    [anon_sym_LF] = ACTIONS(7202),
    [anon_sym_AMP] = ACTIONS(7204),
  },
  [3274] = {
    [sym__simple_heredoc_body] = ACTIONS(7206),
    [sym__heredoc_body_beginning] = ACTIONS(7206),
    [sym_file_descriptor] = ACTIONS(7206),
    [sym__concat] = ACTIONS(7206),
    [sym_variable_name] = ACTIONS(7206),
    [ts_builtin_sym_end] = ACTIONS(7206),
    [anon_sym_SEMI] = ACTIONS(7208),
    [anon_sym_PIPE] = ACTIONS(7208),
    [anon_sym_RPAREN] = ACTIONS(7206),
    [anon_sym_SEMI_SEMI] = ACTIONS(7206),
    [anon_sym_PIPE_AMP] = ACTIONS(7206),
    [anon_sym_AMP_AMP] = ACTIONS(7206),
    [anon_sym_PIPE_PIPE] = ACTIONS(7206),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7206),
    [anon_sym_AMP_GT] = ACTIONS(7208),
    [anon_sym_AMP_GT_GT] = ACTIONS(7206),
    [anon_sym_LT_AMP] = ACTIONS(7206),
    [anon_sym_GT_AMP] = ACTIONS(7206),
    [anon_sym_LT_LT] = ACTIONS(7208),
    [anon_sym_LT_LT_DASH] = ACTIONS(7206),
    [anon_sym_LT_LT_LT] = ACTIONS(7206),
    [anon_sym_DOLLAR] = ACTIONS(7208),
    [sym__special_character] = ACTIONS(7206),
    [anon_sym_DQUOTE] = ACTIONS(7206),
    [sym_raw_string] = ACTIONS(7206),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7206),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7206),
    [anon_sym_BQUOTE] = ACTIONS(7206),
    [anon_sym_LT_LPAREN] = ACTIONS(7206),
    [anon_sym_GT_LPAREN] = ACTIONS(7206),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7208),
    [anon_sym_LF] = ACTIONS(7206),
    [anon_sym_AMP] = ACTIONS(7208),
  },
  [3275] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8396),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3276] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8398),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3277] = {
    [sym__simple_heredoc_body] = ACTIONS(7242),
    [sym__heredoc_body_beginning] = ACTIONS(7242),
    [sym_file_descriptor] = ACTIONS(7242),
    [sym__concat] = ACTIONS(7242),
    [sym_variable_name] = ACTIONS(7242),
    [ts_builtin_sym_end] = ACTIONS(7242),
    [anon_sym_SEMI] = ACTIONS(7244),
    [anon_sym_PIPE] = ACTIONS(7244),
    [anon_sym_RPAREN] = ACTIONS(7242),
    [anon_sym_SEMI_SEMI] = ACTIONS(7242),
    [anon_sym_PIPE_AMP] = ACTIONS(7242),
    [anon_sym_AMP_AMP] = ACTIONS(7242),
    [anon_sym_PIPE_PIPE] = ACTIONS(7242),
    [anon_sym_LT] = ACTIONS(7244),
    [anon_sym_GT] = ACTIONS(7244),
    [anon_sym_GT_GT] = ACTIONS(7242),
    [anon_sym_AMP_GT] = ACTIONS(7244),
    [anon_sym_AMP_GT_GT] = ACTIONS(7242),
    [anon_sym_LT_AMP] = ACTIONS(7242),
    [anon_sym_GT_AMP] = ACTIONS(7242),
    [anon_sym_LT_LT] = ACTIONS(7244),
    [anon_sym_LT_LT_DASH] = ACTIONS(7242),
    [anon_sym_LT_LT_LT] = ACTIONS(7242),
    [anon_sym_DOLLAR] = ACTIONS(7244),
    [sym__special_character] = ACTIONS(7242),
    [anon_sym_DQUOTE] = ACTIONS(7242),
    [sym_raw_string] = ACTIONS(7242),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7242),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7242),
    [anon_sym_BQUOTE] = ACTIONS(7242),
    [anon_sym_LT_LPAREN] = ACTIONS(7242),
    [anon_sym_GT_LPAREN] = ACTIONS(7242),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7244),
    [anon_sym_LF] = ACTIONS(7242),
    [anon_sym_AMP] = ACTIONS(7244),
  },
  [3278] = {
    [sym__simple_heredoc_body] = ACTIONS(8400),
    [sym__heredoc_body_beginning] = ACTIONS(8400),
    [sym_file_descriptor] = ACTIONS(8400),
    [ts_builtin_sym_end] = ACTIONS(8400),
    [anon_sym_SEMI] = ACTIONS(8402),
    [anon_sym_done] = ACTIONS(8400),
    [anon_sym_fi] = ACTIONS(8400),
    [anon_sym_elif] = ACTIONS(8400),
    [anon_sym_else] = ACTIONS(8400),
    [anon_sym_esac] = ACTIONS(8400),
    [anon_sym_PIPE] = ACTIONS(8402),
    [anon_sym_RPAREN] = ACTIONS(8400),
    [anon_sym_SEMI_SEMI] = ACTIONS(8400),
    [anon_sym_PIPE_AMP] = ACTIONS(8400),
    [anon_sym_AMP_AMP] = ACTIONS(8400),
    [anon_sym_PIPE_PIPE] = ACTIONS(8400),
    [anon_sym_LT] = ACTIONS(8402),
    [anon_sym_GT] = ACTIONS(8402),
    [anon_sym_GT_GT] = ACTIONS(8400),
    [anon_sym_AMP_GT] = ACTIONS(8402),
    [anon_sym_AMP_GT_GT] = ACTIONS(8400),
    [anon_sym_LT_AMP] = ACTIONS(8400),
    [anon_sym_GT_AMP] = ACTIONS(8400),
    [anon_sym_LT_LT] = ACTIONS(8402),
    [anon_sym_LT_LT_DASH] = ACTIONS(8400),
    [anon_sym_LT_LT_LT] = ACTIONS(8400),
    [anon_sym_BQUOTE] = ACTIONS(8400),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8400),
    [anon_sym_AMP] = ACTIONS(8402),
  },
  [3279] = {
    [sym_do_group] = STATE(3714),
    [sym_compound_statement] = STATE(3714),
    [anon_sym_do] = ACTIONS(651),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(57),
  },
  [3280] = {
    [sym__concat] = ACTIONS(7198),
    [anon_sym_SEMI] = ACTIONS(7200),
    [anon_sym_SEMI_SEMI] = ACTIONS(7198),
    [anon_sym_AMP_AMP] = ACTIONS(7198),
    [anon_sym_PIPE_PIPE] = ACTIONS(7198),
    [anon_sym_EQ_TILDE] = ACTIONS(7198),
    [anon_sym_EQ_EQ] = ACTIONS(7198),
    [anon_sym_EQ] = ACTIONS(7200),
    [anon_sym_PLUS_EQ] = ACTIONS(7198),
    [anon_sym_LT] = ACTIONS(7200),
    [anon_sym_GT] = ACTIONS(7200),
    [anon_sym_BANG_EQ] = ACTIONS(7198),
    [anon_sym_PLUS] = ACTIONS(7200),
    [anon_sym_DASH] = ACTIONS(7200),
    [anon_sym_DASH_EQ] = ACTIONS(7198),
    [anon_sym_LT_EQ] = ACTIONS(7198),
    [anon_sym_GT_EQ] = ACTIONS(7198),
    [anon_sym_PLUS_PLUS] = ACTIONS(7198),
    [anon_sym_DASH_DASH] = ACTIONS(7198),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7198),
    [anon_sym_LF] = ACTIONS(7198),
    [anon_sym_AMP] = ACTIONS(7200),
  },
  [3281] = {
    [sym__concat] = ACTIONS(7202),
    [anon_sym_SEMI] = ACTIONS(7204),
    [anon_sym_SEMI_SEMI] = ACTIONS(7202),
    [anon_sym_AMP_AMP] = ACTIONS(7202),
    [anon_sym_PIPE_PIPE] = ACTIONS(7202),
    [anon_sym_EQ_TILDE] = ACTIONS(7202),
    [anon_sym_EQ_EQ] = ACTIONS(7202),
    [anon_sym_EQ] = ACTIONS(7204),
    [anon_sym_PLUS_EQ] = ACTIONS(7202),
    [anon_sym_LT] = ACTIONS(7204),
    [anon_sym_GT] = ACTIONS(7204),
    [anon_sym_BANG_EQ] = ACTIONS(7202),
    [anon_sym_PLUS] = ACTIONS(7204),
    [anon_sym_DASH] = ACTIONS(7204),
    [anon_sym_DASH_EQ] = ACTIONS(7202),
    [anon_sym_LT_EQ] = ACTIONS(7202),
    [anon_sym_GT_EQ] = ACTIONS(7202),
    [anon_sym_PLUS_PLUS] = ACTIONS(7202),
    [anon_sym_DASH_DASH] = ACTIONS(7202),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7202),
    [anon_sym_LF] = ACTIONS(7202),
    [anon_sym_AMP] = ACTIONS(7204),
  },
  [3282] = {
    [sym__concat] = ACTIONS(7206),
    [anon_sym_SEMI] = ACTIONS(7208),
    [anon_sym_SEMI_SEMI] = ACTIONS(7206),
    [anon_sym_AMP_AMP] = ACTIONS(7206),
    [anon_sym_PIPE_PIPE] = ACTIONS(7206),
    [anon_sym_EQ_TILDE] = ACTIONS(7206),
    [anon_sym_EQ_EQ] = ACTIONS(7206),
    [anon_sym_EQ] = ACTIONS(7208),
    [anon_sym_PLUS_EQ] = ACTIONS(7206),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_BANG_EQ] = ACTIONS(7206),
    [anon_sym_PLUS] = ACTIONS(7208),
    [anon_sym_DASH] = ACTIONS(7208),
    [anon_sym_DASH_EQ] = ACTIONS(7206),
    [anon_sym_LT_EQ] = ACTIONS(7206),
    [anon_sym_GT_EQ] = ACTIONS(7206),
    [anon_sym_PLUS_PLUS] = ACTIONS(7206),
    [anon_sym_DASH_DASH] = ACTIONS(7206),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7206),
    [anon_sym_LF] = ACTIONS(7206),
    [anon_sym_AMP] = ACTIONS(7208),
  },
  [3283] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8404),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3284] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8406),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3285] = {
    [sym__concat] = ACTIONS(7242),
    [anon_sym_SEMI] = ACTIONS(7244),
    [anon_sym_SEMI_SEMI] = ACTIONS(7242),
    [anon_sym_AMP_AMP] = ACTIONS(7242),
    [anon_sym_PIPE_PIPE] = ACTIONS(7242),
    [anon_sym_EQ_TILDE] = ACTIONS(7242),
    [anon_sym_EQ_EQ] = ACTIONS(7242),
    [anon_sym_EQ] = ACTIONS(7244),
    [anon_sym_PLUS_EQ] = ACTIONS(7242),
    [anon_sym_LT] = ACTIONS(7244),
    [anon_sym_GT] = ACTIONS(7244),
    [anon_sym_BANG_EQ] = ACTIONS(7242),
    [anon_sym_PLUS] = ACTIONS(7244),
    [anon_sym_DASH] = ACTIONS(7244),
    [anon_sym_DASH_EQ] = ACTIONS(7242),
    [anon_sym_LT_EQ] = ACTIONS(7242),
    [anon_sym_GT_EQ] = ACTIONS(7242),
    [anon_sym_PLUS_PLUS] = ACTIONS(7242),
    [anon_sym_DASH_DASH] = ACTIONS(7242),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7242),
    [anon_sym_LF] = ACTIONS(7242),
    [anon_sym_AMP] = ACTIONS(7244),
  },
  [3286] = {
    [sym_do_group] = STATE(3714),
    [sym_compound_statement] = STATE(3714),
    [anon_sym_SEMI] = ACTIONS(8408),
    [anon_sym_do] = ACTIONS(651),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(57),
  },
  [3287] = {
    [sym__concat] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(5676),
    [anon_sym_SEMI_SEMI] = ACTIONS(5674),
    [anon_sym_DOLLAR] = ACTIONS(5676),
    [sym__special_character] = ACTIONS(5674),
    [anon_sym_DQUOTE] = ACTIONS(5674),
    [sym_raw_string] = ACTIONS(5674),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5674),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5674),
    [anon_sym_BQUOTE] = ACTIONS(5674),
    [anon_sym_LT_LPAREN] = ACTIONS(5674),
    [anon_sym_GT_LPAREN] = ACTIONS(5674),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5676),
    [anon_sym_LF] = ACTIONS(5674),
    [anon_sym_AMP] = ACTIONS(5674),
  },
  [3288] = {
    [sym__concat] = ACTIONS(5708),
    [anon_sym_SEMI] = ACTIONS(5710),
    [anon_sym_SEMI_SEMI] = ACTIONS(5708),
    [anon_sym_DOLLAR] = ACTIONS(5710),
    [sym__special_character] = ACTIONS(5708),
    [anon_sym_DQUOTE] = ACTIONS(5708),
    [sym_raw_string] = ACTIONS(5708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5708),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5708),
    [anon_sym_BQUOTE] = ACTIONS(5708),
    [anon_sym_LT_LPAREN] = ACTIONS(5708),
    [anon_sym_GT_LPAREN] = ACTIONS(5708),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5710),
    [anon_sym_LF] = ACTIONS(5708),
    [anon_sym_AMP] = ACTIONS(5708),
  },
  [3289] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(8410),
    [sym_comment] = ACTIONS(57),
  },
  [3290] = {
    [anon_sym_RBRACE] = ACTIONS(8410),
    [sym_comment] = ACTIONS(57),
  },
  [3291] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(8412),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [3292] = {
    [sym_concatenation] = STATE(3721),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3721),
    [anon_sym_RBRACE] = ACTIONS(8414),
    [anon_sym_EQ] = ACTIONS(8416),
    [anon_sym_DASH] = ACTIONS(8416),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8418),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8416),
    [anon_sym_COLON_QMARK] = ACTIONS(8416),
    [anon_sym_COLON_DASH] = ACTIONS(8416),
    [anon_sym_PERCENT] = ACTIONS(8416),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3293] = {
    [sym__concat] = ACTIONS(5725),
    [anon_sym_SEMI] = ACTIONS(5727),
    [anon_sym_SEMI_SEMI] = ACTIONS(5725),
    [anon_sym_DOLLAR] = ACTIONS(5727),
    [sym__special_character] = ACTIONS(5725),
    [anon_sym_DQUOTE] = ACTIONS(5725),
    [sym_raw_string] = ACTIONS(5725),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5725),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5725),
    [anon_sym_BQUOTE] = ACTIONS(5725),
    [anon_sym_LT_LPAREN] = ACTIONS(5725),
    [anon_sym_GT_LPAREN] = ACTIONS(5725),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5727),
    [anon_sym_LF] = ACTIONS(5725),
    [anon_sym_AMP] = ACTIONS(5725),
  },
  [3294] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8414),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3295] = {
    [sym_concatenation] = STATE(3722),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3722),
    [anon_sym_RBRACE] = ACTIONS(8410),
    [anon_sym_EQ] = ACTIONS(8420),
    [anon_sym_DASH] = ACTIONS(8420),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8422),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8420),
    [anon_sym_COLON_QMARK] = ACTIONS(8420),
    [anon_sym_COLON_DASH] = ACTIONS(8420),
    [anon_sym_PERCENT] = ACTIONS(8420),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3296] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8410),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3297] = {
    [sym__concat] = ACTIONS(5770),
    [anon_sym_SEMI] = ACTIONS(5772),
    [anon_sym_SEMI_SEMI] = ACTIONS(5770),
    [anon_sym_DOLLAR] = ACTIONS(5772),
    [sym__special_character] = ACTIONS(5770),
    [anon_sym_DQUOTE] = ACTIONS(5770),
    [sym_raw_string] = ACTIONS(5770),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5770),
    [anon_sym_BQUOTE] = ACTIONS(5770),
    [anon_sym_LT_LPAREN] = ACTIONS(5770),
    [anon_sym_GT_LPAREN] = ACTIONS(5770),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5772),
    [anon_sym_LF] = ACTIONS(5770),
    [anon_sym_AMP] = ACTIONS(5770),
  },
  [3298] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8424),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3299] = {
    [sym__concat] = ACTIONS(7198),
    [anon_sym_PIPE] = ACTIONS(7200),
    [anon_sym_RPAREN] = ACTIONS(7198),
    [anon_sym_AMP_AMP] = ACTIONS(7198),
    [anon_sym_PIPE_PIPE] = ACTIONS(7198),
    [anon_sym_EQ_TILDE] = ACTIONS(7198),
    [anon_sym_EQ_EQ] = ACTIONS(7198),
    [anon_sym_EQ] = ACTIONS(7200),
    [anon_sym_PLUS_EQ] = ACTIONS(7198),
    [anon_sym_LT] = ACTIONS(7200),
    [anon_sym_GT] = ACTIONS(7200),
    [anon_sym_BANG_EQ] = ACTIONS(7198),
    [anon_sym_PLUS] = ACTIONS(7200),
    [anon_sym_DASH] = ACTIONS(7200),
    [anon_sym_DASH_EQ] = ACTIONS(7198),
    [anon_sym_LT_EQ] = ACTIONS(7198),
    [anon_sym_GT_EQ] = ACTIONS(7198),
    [anon_sym_PLUS_PLUS] = ACTIONS(7198),
    [anon_sym_DASH_DASH] = ACTIONS(7198),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7198),
  },
  [3300] = {
    [sym__concat] = ACTIONS(7202),
    [anon_sym_PIPE] = ACTIONS(7204),
    [anon_sym_RPAREN] = ACTIONS(7202),
    [anon_sym_AMP_AMP] = ACTIONS(7202),
    [anon_sym_PIPE_PIPE] = ACTIONS(7202),
    [anon_sym_EQ_TILDE] = ACTIONS(7202),
    [anon_sym_EQ_EQ] = ACTIONS(7202),
    [anon_sym_EQ] = ACTIONS(7204),
    [anon_sym_PLUS_EQ] = ACTIONS(7202),
    [anon_sym_LT] = ACTIONS(7204),
    [anon_sym_GT] = ACTIONS(7204),
    [anon_sym_BANG_EQ] = ACTIONS(7202),
    [anon_sym_PLUS] = ACTIONS(7204),
    [anon_sym_DASH] = ACTIONS(7204),
    [anon_sym_DASH_EQ] = ACTIONS(7202),
    [anon_sym_LT_EQ] = ACTIONS(7202),
    [anon_sym_GT_EQ] = ACTIONS(7202),
    [anon_sym_PLUS_PLUS] = ACTIONS(7202),
    [anon_sym_DASH_DASH] = ACTIONS(7202),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7202),
  },
  [3301] = {
    [sym__concat] = ACTIONS(7206),
    [anon_sym_PIPE] = ACTIONS(7208),
    [anon_sym_RPAREN] = ACTIONS(7206),
    [anon_sym_AMP_AMP] = ACTIONS(7206),
    [anon_sym_PIPE_PIPE] = ACTIONS(7206),
    [anon_sym_EQ_TILDE] = ACTIONS(7206),
    [anon_sym_EQ_EQ] = ACTIONS(7206),
    [anon_sym_EQ] = ACTIONS(7208),
    [anon_sym_PLUS_EQ] = ACTIONS(7206),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_BANG_EQ] = ACTIONS(7206),
    [anon_sym_PLUS] = ACTIONS(7208),
    [anon_sym_DASH] = ACTIONS(7208),
    [anon_sym_DASH_EQ] = ACTIONS(7206),
    [anon_sym_LT_EQ] = ACTIONS(7206),
    [anon_sym_GT_EQ] = ACTIONS(7206),
    [anon_sym_PLUS_PLUS] = ACTIONS(7206),
    [anon_sym_DASH_DASH] = ACTIONS(7206),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7206),
  },
  [3302] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8426),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3303] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8428),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3304] = {
    [sym__concat] = ACTIONS(7242),
    [anon_sym_PIPE] = ACTIONS(7244),
    [anon_sym_RPAREN] = ACTIONS(7242),
    [anon_sym_AMP_AMP] = ACTIONS(7242),
    [anon_sym_PIPE_PIPE] = ACTIONS(7242),
    [anon_sym_EQ_TILDE] = ACTIONS(7242),
    [anon_sym_EQ_EQ] = ACTIONS(7242),
    [anon_sym_EQ] = ACTIONS(7244),
    [anon_sym_PLUS_EQ] = ACTIONS(7242),
    [anon_sym_LT] = ACTIONS(7244),
    [anon_sym_GT] = ACTIONS(7244),
    [anon_sym_BANG_EQ] = ACTIONS(7242),
    [anon_sym_PLUS] = ACTIONS(7244),
    [anon_sym_DASH] = ACTIONS(7244),
    [anon_sym_DASH_EQ] = ACTIONS(7242),
    [anon_sym_LT_EQ] = ACTIONS(7242),
    [anon_sym_GT_EQ] = ACTIONS(7242),
    [anon_sym_PLUS_PLUS] = ACTIONS(7242),
    [anon_sym_DASH_DASH] = ACTIONS(7242),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7242),
  },
  [3305] = {
    [sym__concat] = ACTIONS(8340),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(8340),
    [anon_sym_AMP_AMP] = ACTIONS(8340),
    [anon_sym_PIPE_PIPE] = ACTIONS(8340),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(8340),
    [anon_sym_EQ_TILDE] = ACTIONS(8340),
    [anon_sym_EQ_EQ] = ACTIONS(8340),
    [anon_sym_EQ] = ACTIONS(8342),
    [anon_sym_PLUS_EQ] = ACTIONS(8340),
    [anon_sym_LT] = ACTIONS(8342),
    [anon_sym_GT] = ACTIONS(8342),
    [anon_sym_BANG_EQ] = ACTIONS(8340),
    [anon_sym_PLUS] = ACTIONS(8342),
    [anon_sym_DASH] = ACTIONS(8342),
    [anon_sym_DASH_EQ] = ACTIONS(8340),
    [anon_sym_LT_EQ] = ACTIONS(8340),
    [anon_sym_GT_EQ] = ACTIONS(8340),
    [anon_sym_PLUS_PLUS] = ACTIONS(8340),
    [anon_sym_DASH_DASH] = ACTIONS(8340),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(8340),
  },
  [3306] = {
    [sym__concat] = ACTIONS(8344),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(8344),
    [anon_sym_AMP_AMP] = ACTIONS(8344),
    [anon_sym_PIPE_PIPE] = ACTIONS(8344),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(8344),
    [anon_sym_EQ_TILDE] = ACTIONS(8344),
    [anon_sym_EQ_EQ] = ACTIONS(8344),
    [anon_sym_EQ] = ACTIONS(8346),
    [anon_sym_PLUS_EQ] = ACTIONS(8344),
    [anon_sym_LT] = ACTIONS(8346),
    [anon_sym_GT] = ACTIONS(8346),
    [anon_sym_BANG_EQ] = ACTIONS(8344),
    [anon_sym_PLUS] = ACTIONS(8346),
    [anon_sym_DASH] = ACTIONS(8346),
    [anon_sym_DASH_EQ] = ACTIONS(8344),
    [anon_sym_LT_EQ] = ACTIONS(8344),
    [anon_sym_GT_EQ] = ACTIONS(8344),
    [anon_sym_PLUS_PLUS] = ACTIONS(8344),
    [anon_sym_DASH_DASH] = ACTIONS(8344),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(8344),
  },
  [3307] = {
    [sym_file_descriptor] = ACTIONS(5674),
    [sym__concat] = ACTIONS(5674),
    [sym_variable_name] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(5676),
    [anon_sym_PIPE] = ACTIONS(5676),
    [anon_sym_SEMI_SEMI] = ACTIONS(5674),
    [anon_sym_PIPE_AMP] = ACTIONS(5674),
    [anon_sym_AMP_AMP] = ACTIONS(5674),
    [anon_sym_PIPE_PIPE] = ACTIONS(5674),
    [anon_sym_LT] = ACTIONS(5676),
    [anon_sym_GT] = ACTIONS(5676),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_AMP_GT] = ACTIONS(5676),
    [anon_sym_AMP_GT_GT] = ACTIONS(5674),
    [anon_sym_LT_AMP] = ACTIONS(5674),
    [anon_sym_GT_AMP] = ACTIONS(5674),
    [anon_sym_LT_LT] = ACTIONS(5676),
    [anon_sym_LT_LT_DASH] = ACTIONS(5674),
    [anon_sym_LT_LT_LT] = ACTIONS(5674),
    [anon_sym_DOLLAR] = ACTIONS(5676),
    [sym__special_character] = ACTIONS(5674),
    [anon_sym_DQUOTE] = ACTIONS(5674),
    [sym_raw_string] = ACTIONS(5674),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5674),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5674),
    [anon_sym_BQUOTE] = ACTIONS(5674),
    [anon_sym_LT_LPAREN] = ACTIONS(5674),
    [anon_sym_GT_LPAREN] = ACTIONS(5674),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5676),
    [anon_sym_LF] = ACTIONS(5674),
    [anon_sym_AMP] = ACTIONS(5676),
  },
  [3308] = {
    [sym_file_descriptor] = ACTIONS(5708),
    [sym__concat] = ACTIONS(5708),
    [sym_variable_name] = ACTIONS(5708),
    [anon_sym_SEMI] = ACTIONS(5710),
    [anon_sym_PIPE] = ACTIONS(5710),
    [anon_sym_SEMI_SEMI] = ACTIONS(5708),
    [anon_sym_PIPE_AMP] = ACTIONS(5708),
    [anon_sym_AMP_AMP] = ACTIONS(5708),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_LT] = ACTIONS(5710),
    [anon_sym_GT] = ACTIONS(5710),
    [anon_sym_GT_GT] = ACTIONS(5708),
    [anon_sym_AMP_GT] = ACTIONS(5710),
    [anon_sym_AMP_GT_GT] = ACTIONS(5708),
    [anon_sym_LT_AMP] = ACTIONS(5708),
    [anon_sym_GT_AMP] = ACTIONS(5708),
    [anon_sym_LT_LT] = ACTIONS(5710),
    [anon_sym_LT_LT_DASH] = ACTIONS(5708),
    [anon_sym_LT_LT_LT] = ACTIONS(5708),
    [anon_sym_DOLLAR] = ACTIONS(5710),
    [sym__special_character] = ACTIONS(5708),
    [anon_sym_DQUOTE] = ACTIONS(5708),
    [sym_raw_string] = ACTIONS(5708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5708),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5708),
    [anon_sym_BQUOTE] = ACTIONS(5708),
    [anon_sym_LT_LPAREN] = ACTIONS(5708),
    [anon_sym_GT_LPAREN] = ACTIONS(5708),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5710),
    [anon_sym_LF] = ACTIONS(5708),
    [anon_sym_AMP] = ACTIONS(5710),
  },
  [3309] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(8430),
    [sym_comment] = ACTIONS(57),
  },
  [3310] = {
    [anon_sym_RBRACE] = ACTIONS(8430),
    [sym_comment] = ACTIONS(57),
  },
  [3311] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(8432),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [3312] = {
    [sym_concatenation] = STATE(3729),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3729),
    [anon_sym_RBRACE] = ACTIONS(8434),
    [anon_sym_EQ] = ACTIONS(8436),
    [anon_sym_DASH] = ACTIONS(8436),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8438),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8436),
    [anon_sym_COLON_QMARK] = ACTIONS(8436),
    [anon_sym_COLON_DASH] = ACTIONS(8436),
    [anon_sym_PERCENT] = ACTIONS(8436),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3313] = {
    [sym_file_descriptor] = ACTIONS(5725),
    [sym__concat] = ACTIONS(5725),
    [sym_variable_name] = ACTIONS(5725),
    [anon_sym_SEMI] = ACTIONS(5727),
    [anon_sym_PIPE] = ACTIONS(5727),
    [anon_sym_SEMI_SEMI] = ACTIONS(5725),
    [anon_sym_PIPE_AMP] = ACTIONS(5725),
    [anon_sym_AMP_AMP] = ACTIONS(5725),
    [anon_sym_PIPE_PIPE] = ACTIONS(5725),
    [anon_sym_LT] = ACTIONS(5727),
    [anon_sym_GT] = ACTIONS(5727),
    [anon_sym_GT_GT] = ACTIONS(5725),
    [anon_sym_AMP_GT] = ACTIONS(5727),
    [anon_sym_AMP_GT_GT] = ACTIONS(5725),
    [anon_sym_LT_AMP] = ACTIONS(5725),
    [anon_sym_GT_AMP] = ACTIONS(5725),
    [anon_sym_LT_LT] = ACTIONS(5727),
    [anon_sym_LT_LT_DASH] = ACTIONS(5725),
    [anon_sym_LT_LT_LT] = ACTIONS(5725),
    [anon_sym_DOLLAR] = ACTIONS(5727),
    [sym__special_character] = ACTIONS(5725),
    [anon_sym_DQUOTE] = ACTIONS(5725),
    [sym_raw_string] = ACTIONS(5725),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5725),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5725),
    [anon_sym_BQUOTE] = ACTIONS(5725),
    [anon_sym_LT_LPAREN] = ACTIONS(5725),
    [anon_sym_GT_LPAREN] = ACTIONS(5725),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5727),
    [anon_sym_LF] = ACTIONS(5725),
    [anon_sym_AMP] = ACTIONS(5727),
  },
  [3314] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8434),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3315] = {
    [sym_concatenation] = STATE(3730),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3730),
    [anon_sym_RBRACE] = ACTIONS(8430),
    [anon_sym_EQ] = ACTIONS(8440),
    [anon_sym_DASH] = ACTIONS(8440),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8440),
    [anon_sym_COLON_QMARK] = ACTIONS(8440),
    [anon_sym_COLON_DASH] = ACTIONS(8440),
    [anon_sym_PERCENT] = ACTIONS(8440),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3316] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8430),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3317] = {
    [sym_file_descriptor] = ACTIONS(5770),
    [sym__concat] = ACTIONS(5770),
    [sym_variable_name] = ACTIONS(5770),
    [anon_sym_SEMI] = ACTIONS(5772),
    [anon_sym_PIPE] = ACTIONS(5772),
    [anon_sym_SEMI_SEMI] = ACTIONS(5770),
    [anon_sym_PIPE_AMP] = ACTIONS(5770),
    [anon_sym_AMP_AMP] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5770),
    [anon_sym_LT] = ACTIONS(5772),
    [anon_sym_GT] = ACTIONS(5772),
    [anon_sym_GT_GT] = ACTIONS(5770),
    [anon_sym_AMP_GT] = ACTIONS(5772),
    [anon_sym_AMP_GT_GT] = ACTIONS(5770),
    [anon_sym_LT_AMP] = ACTIONS(5770),
    [anon_sym_GT_AMP] = ACTIONS(5770),
    [anon_sym_LT_LT] = ACTIONS(5772),
    [anon_sym_LT_LT_DASH] = ACTIONS(5770),
    [anon_sym_LT_LT_LT] = ACTIONS(5770),
    [anon_sym_DOLLAR] = ACTIONS(5772),
    [sym__special_character] = ACTIONS(5770),
    [anon_sym_DQUOTE] = ACTIONS(5770),
    [sym_raw_string] = ACTIONS(5770),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5770),
    [anon_sym_BQUOTE] = ACTIONS(5770),
    [anon_sym_LT_LPAREN] = ACTIONS(5770),
    [anon_sym_GT_LPAREN] = ACTIONS(5770),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5772),
    [anon_sym_LF] = ACTIONS(5770),
    [anon_sym_AMP] = ACTIONS(5772),
  },
  [3318] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8444),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3319] = {
    [sym_file_descriptor] = ACTIONS(7316),
    [anon_sym_SEMI] = ACTIONS(7318),
    [anon_sym_PIPE] = ACTIONS(7318),
    [anon_sym_SEMI_SEMI] = ACTIONS(7316),
    [anon_sym_PIPE_AMP] = ACTIONS(7316),
    [anon_sym_AMP_AMP] = ACTIONS(7316),
    [anon_sym_PIPE_PIPE] = ACTIONS(7316),
    [anon_sym_LT] = ACTIONS(7318),
    [anon_sym_GT] = ACTIONS(7318),
    [anon_sym_GT_GT] = ACTIONS(7316),
    [anon_sym_AMP_GT] = ACTIONS(7318),
    [anon_sym_AMP_GT_GT] = ACTIONS(7316),
    [anon_sym_LT_AMP] = ACTIONS(7316),
    [anon_sym_GT_AMP] = ACTIONS(7316),
    [anon_sym_LT_LT] = ACTIONS(7318),
    [anon_sym_LT_LT_DASH] = ACTIONS(7316),
    [anon_sym_LT_LT_LT] = ACTIONS(7316),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(7316),
    [anon_sym_AMP] = ACTIONS(7318),
  },
  [3320] = {
    [sym_do_group] = STATE(3732),
    [sym_compound_statement] = STATE(3732),
    [anon_sym_do] = ACTIONS(1631),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_comment] = ACTIONS(57),
  },
  [3321] = {
    [sym_do_group] = STATE(3732),
    [sym_compound_statement] = STATE(3732),
    [anon_sym_SEMI] = ACTIONS(8446),
    [anon_sym_do] = ACTIONS(1631),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_comment] = ACTIONS(57),
  },
  [3322] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(8448),
    [anon_sym_AMP_AMP] = ACTIONS(557),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(559),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_PLUS_EQ] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DASH_EQ] = ACTIONS(557),
    [anon_sym_LT_EQ] = ACTIONS(557),
    [anon_sym_GT_EQ] = ACTIONS(557),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(557),
  },
  [3323] = {
    [sym_file_descriptor] = ACTIONS(8065),
    [anon_sym_SEMI] = ACTIONS(8067),
    [anon_sym_PIPE] = ACTIONS(8067),
    [anon_sym_SEMI_SEMI] = ACTIONS(8065),
    [anon_sym_PIPE_AMP] = ACTIONS(8065),
    [anon_sym_AMP_AMP] = ACTIONS(8065),
    [anon_sym_PIPE_PIPE] = ACTIONS(8065),
    [anon_sym_LT] = ACTIONS(8067),
    [anon_sym_GT] = ACTIONS(8067),
    [anon_sym_GT_GT] = ACTIONS(8065),
    [anon_sym_AMP_GT] = ACTIONS(8067),
    [anon_sym_AMP_GT_GT] = ACTIONS(8065),
    [anon_sym_LT_AMP] = ACTIONS(8065),
    [anon_sym_GT_AMP] = ACTIONS(8065),
    [anon_sym_LT_LT] = ACTIONS(8067),
    [anon_sym_LT_LT_DASH] = ACTIONS(8065),
    [anon_sym_LT_LT_LT] = ACTIONS(8065),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8065),
    [anon_sym_AMP] = ACTIONS(8067),
  },
  [3324] = {
    [sym_file_descriptor] = ACTIONS(8186),
    [anon_sym_SEMI] = ACTIONS(8188),
    [anon_sym_PIPE] = ACTIONS(8188),
    [anon_sym_SEMI_SEMI] = ACTIONS(8186),
    [anon_sym_PIPE_AMP] = ACTIONS(8186),
    [anon_sym_AMP_AMP] = ACTIONS(8186),
    [anon_sym_PIPE_PIPE] = ACTIONS(8186),
    [anon_sym_LT] = ACTIONS(8188),
    [anon_sym_GT] = ACTIONS(8188),
    [anon_sym_GT_GT] = ACTIONS(8186),
    [anon_sym_AMP_GT] = ACTIONS(8188),
    [anon_sym_AMP_GT_GT] = ACTIONS(8186),
    [anon_sym_LT_AMP] = ACTIONS(8186),
    [anon_sym_GT_AMP] = ACTIONS(8186),
    [anon_sym_LT_LT] = ACTIONS(8188),
    [anon_sym_LT_LT_DASH] = ACTIONS(8186),
    [anon_sym_LT_LT_LT] = ACTIONS(8186),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8186),
    [anon_sym_AMP] = ACTIONS(8188),
  },
  [3325] = {
    [anon_sym_esac] = ACTIONS(8450),
    [sym_comment] = ACTIONS(57),
  },
  [3326] = {
    [sym_file_descriptor] = ACTIONS(8210),
    [anon_sym_SEMI] = ACTIONS(8212),
    [anon_sym_PIPE] = ACTIONS(8212),
    [anon_sym_SEMI_SEMI] = ACTIONS(8210),
    [anon_sym_PIPE_AMP] = ACTIONS(8210),
    [anon_sym_AMP_AMP] = ACTIONS(8210),
    [anon_sym_PIPE_PIPE] = ACTIONS(8210),
    [anon_sym_LT] = ACTIONS(8212),
    [anon_sym_GT] = ACTIONS(8212),
    [anon_sym_GT_GT] = ACTIONS(8210),
    [anon_sym_AMP_GT] = ACTIONS(8212),
    [anon_sym_AMP_GT_GT] = ACTIONS(8210),
    [anon_sym_LT_AMP] = ACTIONS(8210),
    [anon_sym_GT_AMP] = ACTIONS(8210),
    [anon_sym_LT_LT] = ACTIONS(8212),
    [anon_sym_LT_LT_DASH] = ACTIONS(8210),
    [anon_sym_LT_LT_LT] = ACTIONS(8210),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8210),
    [anon_sym_AMP] = ACTIONS(8212),
  },
  [3327] = {
    [anon_sym_esac] = ACTIONS(8452),
    [sym_comment] = ACTIONS(57),
  },
  [3328] = {
    [sym_file_descriptor] = ACTIONS(7198),
    [sym__concat] = ACTIONS(7198),
    [sym_variable_name] = ACTIONS(7198),
    [anon_sym_SEMI] = ACTIONS(7200),
    [anon_sym_PIPE] = ACTIONS(7200),
    [anon_sym_SEMI_SEMI] = ACTIONS(7198),
    [anon_sym_PIPE_AMP] = ACTIONS(7198),
    [anon_sym_AMP_AMP] = ACTIONS(7198),
    [anon_sym_PIPE_PIPE] = ACTIONS(7198),
    [anon_sym_LT] = ACTIONS(7200),
    [anon_sym_GT] = ACTIONS(7200),
    [anon_sym_GT_GT] = ACTIONS(7198),
    [anon_sym_AMP_GT] = ACTIONS(7200),
    [anon_sym_AMP_GT_GT] = ACTIONS(7198),
    [anon_sym_LT_AMP] = ACTIONS(7198),
    [anon_sym_GT_AMP] = ACTIONS(7198),
    [anon_sym_LT_LT] = ACTIONS(7200),
    [anon_sym_LT_LT_DASH] = ACTIONS(7198),
    [anon_sym_LT_LT_LT] = ACTIONS(7198),
    [anon_sym_DOLLAR] = ACTIONS(7200),
    [sym__special_character] = ACTIONS(7198),
    [anon_sym_DQUOTE] = ACTIONS(7198),
    [sym_raw_string] = ACTIONS(7198),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7198),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7198),
    [anon_sym_BQUOTE] = ACTIONS(7198),
    [anon_sym_LT_LPAREN] = ACTIONS(7198),
    [anon_sym_GT_LPAREN] = ACTIONS(7198),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7200),
    [sym_word] = ACTIONS(7200),
    [anon_sym_LF] = ACTIONS(7198),
    [anon_sym_AMP] = ACTIONS(7200),
  },
  [3329] = {
    [sym_file_descriptor] = ACTIONS(7202),
    [sym__concat] = ACTIONS(7202),
    [sym_variable_name] = ACTIONS(7202),
    [anon_sym_SEMI] = ACTIONS(7204),
    [anon_sym_PIPE] = ACTIONS(7204),
    [anon_sym_SEMI_SEMI] = ACTIONS(7202),
    [anon_sym_PIPE_AMP] = ACTIONS(7202),
    [anon_sym_AMP_AMP] = ACTIONS(7202),
    [anon_sym_PIPE_PIPE] = ACTIONS(7202),
    [anon_sym_LT] = ACTIONS(7204),
    [anon_sym_GT] = ACTIONS(7204),
    [anon_sym_GT_GT] = ACTIONS(7202),
    [anon_sym_AMP_GT] = ACTIONS(7204),
    [anon_sym_AMP_GT_GT] = ACTIONS(7202),
    [anon_sym_LT_AMP] = ACTIONS(7202),
    [anon_sym_GT_AMP] = ACTIONS(7202),
    [anon_sym_LT_LT] = ACTIONS(7204),
    [anon_sym_LT_LT_DASH] = ACTIONS(7202),
    [anon_sym_LT_LT_LT] = ACTIONS(7202),
    [anon_sym_DOLLAR] = ACTIONS(7204),
    [sym__special_character] = ACTIONS(7202),
    [anon_sym_DQUOTE] = ACTIONS(7202),
    [sym_raw_string] = ACTIONS(7202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7202),
    [anon_sym_BQUOTE] = ACTIONS(7202),
    [anon_sym_LT_LPAREN] = ACTIONS(7202),
    [anon_sym_GT_LPAREN] = ACTIONS(7202),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7204),
    [sym_word] = ACTIONS(7204),
    [anon_sym_LF] = ACTIONS(7202),
    [anon_sym_AMP] = ACTIONS(7204),
  },
  [3330] = {
    [sym_file_descriptor] = ACTIONS(7206),
    [sym__concat] = ACTIONS(7206),
    [sym_variable_name] = ACTIONS(7206),
    [anon_sym_SEMI] = ACTIONS(7208),
    [anon_sym_PIPE] = ACTIONS(7208),
    [anon_sym_SEMI_SEMI] = ACTIONS(7206),
    [anon_sym_PIPE_AMP] = ACTIONS(7206),
    [anon_sym_AMP_AMP] = ACTIONS(7206),
    [anon_sym_PIPE_PIPE] = ACTIONS(7206),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7206),
    [anon_sym_AMP_GT] = ACTIONS(7208),
    [anon_sym_AMP_GT_GT] = ACTIONS(7206),
    [anon_sym_LT_AMP] = ACTIONS(7206),
    [anon_sym_GT_AMP] = ACTIONS(7206),
    [anon_sym_LT_LT] = ACTIONS(7208),
    [anon_sym_LT_LT_DASH] = ACTIONS(7206),
    [anon_sym_LT_LT_LT] = ACTIONS(7206),
    [anon_sym_DOLLAR] = ACTIONS(7208),
    [sym__special_character] = ACTIONS(7206),
    [anon_sym_DQUOTE] = ACTIONS(7206),
    [sym_raw_string] = ACTIONS(7206),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7206),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7206),
    [anon_sym_BQUOTE] = ACTIONS(7206),
    [anon_sym_LT_LPAREN] = ACTIONS(7206),
    [anon_sym_GT_LPAREN] = ACTIONS(7206),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7208),
    [sym_word] = ACTIONS(7208),
    [anon_sym_LF] = ACTIONS(7206),
    [anon_sym_AMP] = ACTIONS(7208),
  },
  [3331] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8454),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3332] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8456),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3333] = {
    [sym_file_descriptor] = ACTIONS(7242),
    [sym__concat] = ACTIONS(7242),
    [sym_variable_name] = ACTIONS(7242),
    [anon_sym_SEMI] = ACTIONS(7244),
    [anon_sym_PIPE] = ACTIONS(7244),
    [anon_sym_SEMI_SEMI] = ACTIONS(7242),
    [anon_sym_PIPE_AMP] = ACTIONS(7242),
    [anon_sym_AMP_AMP] = ACTIONS(7242),
    [anon_sym_PIPE_PIPE] = ACTIONS(7242),
    [anon_sym_LT] = ACTIONS(7244),
    [anon_sym_GT] = ACTIONS(7244),
    [anon_sym_GT_GT] = ACTIONS(7242),
    [anon_sym_AMP_GT] = ACTIONS(7244),
    [anon_sym_AMP_GT_GT] = ACTIONS(7242),
    [anon_sym_LT_AMP] = ACTIONS(7242),
    [anon_sym_GT_AMP] = ACTIONS(7242),
    [anon_sym_LT_LT] = ACTIONS(7244),
    [anon_sym_LT_LT_DASH] = ACTIONS(7242),
    [anon_sym_LT_LT_LT] = ACTIONS(7242),
    [anon_sym_DOLLAR] = ACTIONS(7244),
    [sym__special_character] = ACTIONS(7242),
    [anon_sym_DQUOTE] = ACTIONS(7242),
    [sym_raw_string] = ACTIONS(7242),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7242),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7242),
    [anon_sym_BQUOTE] = ACTIONS(7242),
    [anon_sym_LT_LPAREN] = ACTIONS(7242),
    [anon_sym_GT_LPAREN] = ACTIONS(7242),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7244),
    [sym_word] = ACTIONS(7244),
    [anon_sym_LF] = ACTIONS(7242),
    [anon_sym_AMP] = ACTIONS(7244),
  },
  [3334] = {
    [sym_file_descriptor] = ACTIONS(7198),
    [sym__concat] = ACTIONS(7198),
    [anon_sym_SEMI] = ACTIONS(7200),
    [anon_sym_PIPE] = ACTIONS(7200),
    [anon_sym_SEMI_SEMI] = ACTIONS(7198),
    [anon_sym_PIPE_AMP] = ACTIONS(7198),
    [anon_sym_AMP_AMP] = ACTIONS(7198),
    [anon_sym_PIPE_PIPE] = ACTIONS(7198),
    [anon_sym_LT] = ACTIONS(7200),
    [anon_sym_GT] = ACTIONS(7200),
    [anon_sym_GT_GT] = ACTIONS(7198),
    [anon_sym_AMP_GT] = ACTIONS(7200),
    [anon_sym_AMP_GT_GT] = ACTIONS(7198),
    [anon_sym_LT_AMP] = ACTIONS(7198),
    [anon_sym_GT_AMP] = ACTIONS(7198),
    [anon_sym_LT_LT] = ACTIONS(7200),
    [anon_sym_LT_LT_DASH] = ACTIONS(7198),
    [anon_sym_LT_LT_LT] = ACTIONS(7198),
    [anon_sym_DOLLAR] = ACTIONS(7200),
    [sym__special_character] = ACTIONS(7198),
    [anon_sym_DQUOTE] = ACTIONS(7198),
    [sym_raw_string] = ACTIONS(7198),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7198),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7198),
    [anon_sym_BQUOTE] = ACTIONS(7198),
    [anon_sym_LT_LPAREN] = ACTIONS(7198),
    [anon_sym_GT_LPAREN] = ACTIONS(7198),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7200),
    [sym_word] = ACTIONS(7200),
    [anon_sym_LF] = ACTIONS(7198),
    [anon_sym_AMP] = ACTIONS(7200),
  },
  [3335] = {
    [sym_file_descriptor] = ACTIONS(7202),
    [sym__concat] = ACTIONS(7202),
    [anon_sym_SEMI] = ACTIONS(7204),
    [anon_sym_PIPE] = ACTIONS(7204),
    [anon_sym_SEMI_SEMI] = ACTIONS(7202),
    [anon_sym_PIPE_AMP] = ACTIONS(7202),
    [anon_sym_AMP_AMP] = ACTIONS(7202),
    [anon_sym_PIPE_PIPE] = ACTIONS(7202),
    [anon_sym_LT] = ACTIONS(7204),
    [anon_sym_GT] = ACTIONS(7204),
    [anon_sym_GT_GT] = ACTIONS(7202),
    [anon_sym_AMP_GT] = ACTIONS(7204),
    [anon_sym_AMP_GT_GT] = ACTIONS(7202),
    [anon_sym_LT_AMP] = ACTIONS(7202),
    [anon_sym_GT_AMP] = ACTIONS(7202),
    [anon_sym_LT_LT] = ACTIONS(7204),
    [anon_sym_LT_LT_DASH] = ACTIONS(7202),
    [anon_sym_LT_LT_LT] = ACTIONS(7202),
    [anon_sym_DOLLAR] = ACTIONS(7204),
    [sym__special_character] = ACTIONS(7202),
    [anon_sym_DQUOTE] = ACTIONS(7202),
    [sym_raw_string] = ACTIONS(7202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7202),
    [anon_sym_BQUOTE] = ACTIONS(7202),
    [anon_sym_LT_LPAREN] = ACTIONS(7202),
    [anon_sym_GT_LPAREN] = ACTIONS(7202),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7204),
    [sym_word] = ACTIONS(7204),
    [anon_sym_LF] = ACTIONS(7202),
    [anon_sym_AMP] = ACTIONS(7204),
  },
  [3336] = {
    [sym_file_descriptor] = ACTIONS(7206),
    [sym__concat] = ACTIONS(7206),
    [anon_sym_SEMI] = ACTIONS(7208),
    [anon_sym_PIPE] = ACTIONS(7208),
    [anon_sym_SEMI_SEMI] = ACTIONS(7206),
    [anon_sym_PIPE_AMP] = ACTIONS(7206),
    [anon_sym_AMP_AMP] = ACTIONS(7206),
    [anon_sym_PIPE_PIPE] = ACTIONS(7206),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7206),
    [anon_sym_AMP_GT] = ACTIONS(7208),
    [anon_sym_AMP_GT_GT] = ACTIONS(7206),
    [anon_sym_LT_AMP] = ACTIONS(7206),
    [anon_sym_GT_AMP] = ACTIONS(7206),
    [anon_sym_LT_LT] = ACTIONS(7208),
    [anon_sym_LT_LT_DASH] = ACTIONS(7206),
    [anon_sym_LT_LT_LT] = ACTIONS(7206),
    [anon_sym_DOLLAR] = ACTIONS(7208),
    [sym__special_character] = ACTIONS(7206),
    [anon_sym_DQUOTE] = ACTIONS(7206),
    [sym_raw_string] = ACTIONS(7206),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7206),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7206),
    [anon_sym_BQUOTE] = ACTIONS(7206),
    [anon_sym_LT_LPAREN] = ACTIONS(7206),
    [anon_sym_GT_LPAREN] = ACTIONS(7206),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7208),
    [sym_word] = ACTIONS(7208),
    [anon_sym_LF] = ACTIONS(7206),
    [anon_sym_AMP] = ACTIONS(7208),
  },
  [3337] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8458),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3338] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8460),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3339] = {
    [sym_file_descriptor] = ACTIONS(7242),
    [sym__concat] = ACTIONS(7242),
    [anon_sym_SEMI] = ACTIONS(7244),
    [anon_sym_PIPE] = ACTIONS(7244),
    [anon_sym_SEMI_SEMI] = ACTIONS(7242),
    [anon_sym_PIPE_AMP] = ACTIONS(7242),
    [anon_sym_AMP_AMP] = ACTIONS(7242),
    [anon_sym_PIPE_PIPE] = ACTIONS(7242),
    [anon_sym_LT] = ACTIONS(7244),
    [anon_sym_GT] = ACTIONS(7244),
    [anon_sym_GT_GT] = ACTIONS(7242),
    [anon_sym_AMP_GT] = ACTIONS(7244),
    [anon_sym_AMP_GT_GT] = ACTIONS(7242),
    [anon_sym_LT_AMP] = ACTIONS(7242),
    [anon_sym_GT_AMP] = ACTIONS(7242),
    [anon_sym_LT_LT] = ACTIONS(7244),
    [anon_sym_LT_LT_DASH] = ACTIONS(7242),
    [anon_sym_LT_LT_LT] = ACTIONS(7242),
    [anon_sym_DOLLAR] = ACTIONS(7244),
    [sym__special_character] = ACTIONS(7242),
    [anon_sym_DQUOTE] = ACTIONS(7242),
    [sym_raw_string] = ACTIONS(7242),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7242),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7242),
    [anon_sym_BQUOTE] = ACTIONS(7242),
    [anon_sym_LT_LPAREN] = ACTIONS(7242),
    [anon_sym_GT_LPAREN] = ACTIONS(7242),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7244),
    [sym_word] = ACTIONS(7244),
    [anon_sym_LF] = ACTIONS(7242),
    [anon_sym_AMP] = ACTIONS(7244),
  },
  [3340] = {
    [sym_file_descriptor] = ACTIONS(8340),
    [sym__concat] = ACTIONS(8340),
    [anon_sym_SEMI] = ACTIONS(8342),
    [anon_sym_PIPE] = ACTIONS(8342),
    [anon_sym_SEMI_SEMI] = ACTIONS(8340),
    [anon_sym_PIPE_AMP] = ACTIONS(8340),
    [anon_sym_AMP_AMP] = ACTIONS(8340),
    [anon_sym_PIPE_PIPE] = ACTIONS(8340),
    [anon_sym_EQ_TILDE] = ACTIONS(8342),
    [anon_sym_EQ_EQ] = ACTIONS(8342),
    [anon_sym_LT] = ACTIONS(8342),
    [anon_sym_GT] = ACTIONS(8342),
    [anon_sym_GT_GT] = ACTIONS(8340),
    [anon_sym_AMP_GT] = ACTIONS(8342),
    [anon_sym_AMP_GT_GT] = ACTIONS(8340),
    [anon_sym_LT_AMP] = ACTIONS(8340),
    [anon_sym_GT_AMP] = ACTIONS(8340),
    [anon_sym_LT_LT] = ACTIONS(8342),
    [anon_sym_LT_LT_DASH] = ACTIONS(8340),
    [anon_sym_LT_LT_LT] = ACTIONS(8340),
    [anon_sym_DOLLAR] = ACTIONS(8342),
    [sym__special_character] = ACTIONS(8340),
    [anon_sym_DQUOTE] = ACTIONS(8340),
    [sym_raw_string] = ACTIONS(8340),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8340),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [anon_sym_LT_LPAREN] = ACTIONS(8340),
    [anon_sym_GT_LPAREN] = ACTIONS(8340),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8342),
    [anon_sym_LF] = ACTIONS(8340),
    [anon_sym_AMP] = ACTIONS(8342),
  },
  [3341] = {
    [sym_file_descriptor] = ACTIONS(8344),
    [sym__concat] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [anon_sym_PIPE] = ACTIONS(8346),
    [anon_sym_SEMI_SEMI] = ACTIONS(8344),
    [anon_sym_PIPE_AMP] = ACTIONS(8344),
    [anon_sym_AMP_AMP] = ACTIONS(8344),
    [anon_sym_PIPE_PIPE] = ACTIONS(8344),
    [anon_sym_EQ_TILDE] = ACTIONS(8346),
    [anon_sym_EQ_EQ] = ACTIONS(8346),
    [anon_sym_LT] = ACTIONS(8346),
    [anon_sym_GT] = ACTIONS(8346),
    [anon_sym_GT_GT] = ACTIONS(8344),
    [anon_sym_AMP_GT] = ACTIONS(8346),
    [anon_sym_AMP_GT_GT] = ACTIONS(8344),
    [anon_sym_LT_AMP] = ACTIONS(8344),
    [anon_sym_GT_AMP] = ACTIONS(8344),
    [anon_sym_LT_LT] = ACTIONS(8346),
    [anon_sym_LT_LT_DASH] = ACTIONS(8344),
    [anon_sym_LT_LT_LT] = ACTIONS(8344),
    [anon_sym_DOLLAR] = ACTIONS(8346),
    [sym__special_character] = ACTIONS(8344),
    [anon_sym_DQUOTE] = ACTIONS(8344),
    [sym_raw_string] = ACTIONS(8344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8344),
    [anon_sym_BQUOTE] = ACTIONS(8344),
    [anon_sym_LT_LPAREN] = ACTIONS(8344),
    [anon_sym_GT_LPAREN] = ACTIONS(8344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8346),
    [anon_sym_LF] = ACTIONS(8344),
    [anon_sym_AMP] = ACTIONS(8346),
  },
  [3342] = {
    [sym__simple_heredoc_body] = ACTIONS(4449),
    [sym__heredoc_body_beginning] = ACTIONS(4449),
    [sym_file_descriptor] = ACTIONS(4449),
    [sym_variable_name] = ACTIONS(4449),
    [anon_sym_SEMI] = ACTIONS(4451),
    [anon_sym_done] = ACTIONS(4451),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_SEMI_SEMI] = ACTIONS(4449),
    [anon_sym_PIPE_AMP] = ACTIONS(4449),
    [anon_sym_AMP_AMP] = ACTIONS(4449),
    [anon_sym_PIPE_PIPE] = ACTIONS(4449),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_GT_GT] = ACTIONS(4449),
    [anon_sym_AMP_GT] = ACTIONS(4451),
    [anon_sym_AMP_GT_GT] = ACTIONS(4449),
    [anon_sym_LT_AMP] = ACTIONS(4449),
    [anon_sym_GT_AMP] = ACTIONS(4449),
    [anon_sym_LT_LT] = ACTIONS(4451),
    [anon_sym_LT_LT_DASH] = ACTIONS(4449),
    [anon_sym_LT_LT_LT] = ACTIONS(4449),
    [anon_sym_DOLLAR] = ACTIONS(4451),
    [sym__special_character] = ACTIONS(4449),
    [anon_sym_DQUOTE] = ACTIONS(4449),
    [sym_raw_string] = ACTIONS(4449),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4449),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4449),
    [anon_sym_BQUOTE] = ACTIONS(4449),
    [anon_sym_LT_LPAREN] = ACTIONS(4449),
    [anon_sym_GT_LPAREN] = ACTIONS(4449),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4451),
    [anon_sym_LF] = ACTIONS(4449),
    [anon_sym_AMP] = ACTIONS(4451),
  },
  [3343] = {
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(2362),
    [sym_variable_name] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_done] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [3344] = {
    [sym_string] = STATE(3343),
    [sym_simple_expansion] = STATE(3343),
    [sym_string_expansion] = STATE(3343),
    [sym_expansion] = STATE(3343),
    [sym_command_substitution] = STATE(3343),
    [sym_process_substitution] = STATE(3343),
    [anon_sym_DOLLAR] = ACTIONS(8462),
    [sym__special_character] = ACTIONS(7464),
    [anon_sym_DQUOTE] = ACTIONS(4880),
    [sym_raw_string] = ACTIONS(7464),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4884),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4886),
    [anon_sym_BQUOTE] = ACTIONS(4888),
    [anon_sym_LT_LPAREN] = ACTIONS(4890),
    [anon_sym_GT_LPAREN] = ACTIONS(4890),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7464),
  },
  [3345] = {
    [aux_sym_concatenation_repeat1] = STATE(3345),
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(8464),
    [sym_variable_name] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_done] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [3346] = {
    [sym__simple_heredoc_body] = ACTIONS(2371),
    [sym__heredoc_body_beginning] = ACTIONS(2371),
    [sym_file_descriptor] = ACTIONS(2371),
    [sym__concat] = ACTIONS(2371),
    [sym_variable_name] = ACTIONS(2371),
    [anon_sym_SEMI] = ACTIONS(2373),
    [anon_sym_done] = ACTIONS(2373),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_SEMI_SEMI] = ACTIONS(2371),
    [anon_sym_PIPE_AMP] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_GT_GT] = ACTIONS(2371),
    [anon_sym_AMP_GT] = ACTIONS(2373),
    [anon_sym_AMP_GT_GT] = ACTIONS(2371),
    [anon_sym_LT_AMP] = ACTIONS(2371),
    [anon_sym_GT_AMP] = ACTIONS(2371),
    [anon_sym_LT_LT] = ACTIONS(2373),
    [anon_sym_LT_LT_DASH] = ACTIONS(2371),
    [anon_sym_LT_LT_LT] = ACTIONS(2371),
    [anon_sym_DOLLAR] = ACTIONS(2373),
    [sym__special_character] = ACTIONS(2371),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [sym_raw_string] = ACTIONS(2371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2371),
    [anon_sym_BQUOTE] = ACTIONS(2371),
    [anon_sym_LT_LPAREN] = ACTIONS(2371),
    [anon_sym_GT_LPAREN] = ACTIONS(2371),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2373),
    [anon_sym_LF] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
  },
  [3347] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(8467),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [3348] = {
    [sym_concatenation] = STATE(3745),
    [sym_string] = STATE(3744),
    [sym_simple_expansion] = STATE(3744),
    [sym_string_expansion] = STATE(3744),
    [sym_expansion] = STATE(3744),
    [sym_command_substitution] = STATE(3744),
    [sym_process_substitution] = STATE(3744),
    [aux_sym__literal_repeat1] = STATE(3746),
    [anon_sym_RBRACE] = ACTIONS(8469),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(8471),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8471),
  },
  [3349] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(8473),
    [sym_comment] = ACTIONS(57),
  },
  [3350] = {
    [sym_concatenation] = STATE(3750),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3750),
    [anon_sym_RBRACE] = ACTIONS(8475),
    [anon_sym_EQ] = ACTIONS(8477),
    [anon_sym_DASH] = ACTIONS(8477),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8479),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(8481),
    [anon_sym_COLON] = ACTIONS(8477),
    [anon_sym_COLON_QMARK] = ACTIONS(8477),
    [anon_sym_COLON_DASH] = ACTIONS(8477),
    [anon_sym_PERCENT] = ACTIONS(8477),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3351] = {
    [sym_concatenation] = STATE(3752),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3752),
    [anon_sym_RBRACE] = ACTIONS(8469),
    [anon_sym_EQ] = ACTIONS(8483),
    [anon_sym_DASH] = ACTIONS(8483),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8485),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(8487),
    [anon_sym_COLON] = ACTIONS(8483),
    [anon_sym_COLON_QMARK] = ACTIONS(8483),
    [anon_sym_COLON_DASH] = ACTIONS(8483),
    [anon_sym_PERCENT] = ACTIONS(8483),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3352] = {
    [sym__simple_heredoc_body] = ACTIONS(2462),
    [sym__heredoc_body_beginning] = ACTIONS(2462),
    [sym_file_descriptor] = ACTIONS(2462),
    [sym__concat] = ACTIONS(2462),
    [sym_variable_name] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_done] = ACTIONS(2464),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_SEMI_SEMI] = ACTIONS(2462),
    [anon_sym_PIPE_AMP] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_GT_GT] = ACTIONS(2462),
    [anon_sym_AMP_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT_GT] = ACTIONS(2462),
    [anon_sym_LT_AMP] = ACTIONS(2462),
    [anon_sym_GT_AMP] = ACTIONS(2462),
    [anon_sym_LT_LT] = ACTIONS(2464),
    [anon_sym_LT_LT_DASH] = ACTIONS(2462),
    [anon_sym_LT_LT_LT] = ACTIONS(2462),
    [anon_sym_DOLLAR] = ACTIONS(2464),
    [sym__special_character] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [sym_raw_string] = ACTIONS(2462),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2462),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2462),
    [anon_sym_BQUOTE] = ACTIONS(2462),
    [anon_sym_LT_LPAREN] = ACTIONS(2462),
    [anon_sym_GT_LPAREN] = ACTIONS(2462),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2464),
    [anon_sym_LF] = ACTIONS(2462),
    [anon_sym_AMP] = ACTIONS(2464),
  },
  [3353] = {
    [sym_concatenation] = STATE(3755),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3755),
    [sym_regex] = ACTIONS(8489),
    [anon_sym_RBRACE] = ACTIONS(8491),
    [anon_sym_EQ] = ACTIONS(8493),
    [anon_sym_DASH] = ACTIONS(8493),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8495),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8493),
    [anon_sym_COLON_QMARK] = ACTIONS(8493),
    [anon_sym_COLON_DASH] = ACTIONS(8493),
    [anon_sym_PERCENT] = ACTIONS(8493),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3354] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8491),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3355] = {
    [sym__simple_heredoc_body] = ACTIONS(2512),
    [sym__heredoc_body_beginning] = ACTIONS(2512),
    [sym_file_descriptor] = ACTIONS(2512),
    [sym__concat] = ACTIONS(2512),
    [sym_variable_name] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2514),
    [anon_sym_done] = ACTIONS(2514),
    [anon_sym_PIPE] = ACTIONS(2514),
    [anon_sym_SEMI_SEMI] = ACTIONS(2512),
    [anon_sym_PIPE_AMP] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE_PIPE] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2514),
    [anon_sym_GT] = ACTIONS(2514),
    [anon_sym_GT_GT] = ACTIONS(2512),
    [anon_sym_AMP_GT] = ACTIONS(2514),
    [anon_sym_AMP_GT_GT] = ACTIONS(2512),
    [anon_sym_LT_AMP] = ACTIONS(2512),
    [anon_sym_GT_AMP] = ACTIONS(2512),
    [anon_sym_LT_LT] = ACTIONS(2514),
    [anon_sym_LT_LT_DASH] = ACTIONS(2512),
    [anon_sym_LT_LT_LT] = ACTIONS(2512),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [sym__special_character] = ACTIONS(2512),
    [anon_sym_DQUOTE] = ACTIONS(2512),
    [sym_raw_string] = ACTIONS(2512),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2512),
    [anon_sym_BQUOTE] = ACTIONS(2512),
    [anon_sym_LT_LPAREN] = ACTIONS(2512),
    [anon_sym_GT_LPAREN] = ACTIONS(2512),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2514),
    [anon_sym_LF] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2514),
  },
  [3356] = {
    [sym_concatenation] = STATE(3752),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3752),
    [sym_regex] = ACTIONS(8497),
    [anon_sym_RBRACE] = ACTIONS(8469),
    [anon_sym_EQ] = ACTIONS(8483),
    [anon_sym_DASH] = ACTIONS(8483),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8485),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8483),
    [anon_sym_COLON_QMARK] = ACTIONS(8483),
    [anon_sym_COLON_DASH] = ACTIONS(8483),
    [anon_sym_PERCENT] = ACTIONS(8483),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3357] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8469),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3358] = {
    [sym__simple_heredoc_body] = ACTIONS(2520),
    [sym__heredoc_body_beginning] = ACTIONS(2520),
    [sym_file_descriptor] = ACTIONS(2520),
    [sym__concat] = ACTIONS(2520),
    [sym_variable_name] = ACTIONS(2520),
    [anon_sym_SEMI] = ACTIONS(2522),
    [anon_sym_done] = ACTIONS(2522),
    [anon_sym_PIPE] = ACTIONS(2522),
    [anon_sym_SEMI_SEMI] = ACTIONS(2520),
    [anon_sym_PIPE_AMP] = ACTIONS(2520),
    [anon_sym_AMP_AMP] = ACTIONS(2520),
    [anon_sym_PIPE_PIPE] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(2522),
    [anon_sym_GT] = ACTIONS(2522),
    [anon_sym_GT_GT] = ACTIONS(2520),
    [anon_sym_AMP_GT] = ACTIONS(2522),
    [anon_sym_AMP_GT_GT] = ACTIONS(2520),
    [anon_sym_LT_AMP] = ACTIONS(2520),
    [anon_sym_GT_AMP] = ACTIONS(2520),
    [anon_sym_LT_LT] = ACTIONS(2522),
    [anon_sym_LT_LT_DASH] = ACTIONS(2520),
    [anon_sym_LT_LT_LT] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(2522),
    [sym__special_character] = ACTIONS(2520),
    [anon_sym_DQUOTE] = ACTIONS(2520),
    [sym_raw_string] = ACTIONS(2520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2520),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2520),
    [anon_sym_BQUOTE] = ACTIONS(2520),
    [anon_sym_LT_LPAREN] = ACTIONS(2520),
    [anon_sym_GT_LPAREN] = ACTIONS(2520),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2522),
    [anon_sym_LF] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2522),
  },
  [3359] = {
    [sym__simple_heredoc_body] = ACTIONS(2554),
    [sym__heredoc_body_beginning] = ACTIONS(2554),
    [sym_file_descriptor] = ACTIONS(2554),
    [sym__concat] = ACTIONS(2554),
    [sym_variable_name] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(2556),
    [anon_sym_done] = ACTIONS(2556),
    [anon_sym_PIPE] = ACTIONS(2556),
    [anon_sym_SEMI_SEMI] = ACTIONS(2554),
    [anon_sym_PIPE_AMP] = ACTIONS(2554),
    [anon_sym_AMP_AMP] = ACTIONS(2554),
    [anon_sym_PIPE_PIPE] = ACTIONS(2554),
    [anon_sym_LT] = ACTIONS(2556),
    [anon_sym_GT] = ACTIONS(2556),
    [anon_sym_GT_GT] = ACTIONS(2554),
    [anon_sym_AMP_GT] = ACTIONS(2556),
    [anon_sym_AMP_GT_GT] = ACTIONS(2554),
    [anon_sym_LT_AMP] = ACTIONS(2554),
    [anon_sym_GT_AMP] = ACTIONS(2554),
    [anon_sym_LT_LT] = ACTIONS(2556),
    [anon_sym_LT_LT_DASH] = ACTIONS(2554),
    [anon_sym_LT_LT_LT] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2556),
    [sym__special_character] = ACTIONS(2554),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2554),
    [anon_sym_BQUOTE] = ACTIONS(2554),
    [anon_sym_LT_LPAREN] = ACTIONS(2554),
    [anon_sym_GT_LPAREN] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2556),
    [anon_sym_LF] = ACTIONS(2554),
    [anon_sym_AMP] = ACTIONS(2556),
  },
  [3360] = {
    [sym__simple_heredoc_body] = ACTIONS(2719),
    [sym__heredoc_body_beginning] = ACTIONS(2719),
    [sym_file_descriptor] = ACTIONS(2719),
    [sym_variable_name] = ACTIONS(2719),
    [anon_sym_SEMI] = ACTIONS(2721),
    [anon_sym_done] = ACTIONS(2721),
    [anon_sym_PIPE] = ACTIONS(2721),
    [anon_sym_SEMI_SEMI] = ACTIONS(2719),
    [anon_sym_PIPE_AMP] = ACTIONS(2719),
    [anon_sym_AMP_AMP] = ACTIONS(2719),
    [anon_sym_PIPE_PIPE] = ACTIONS(2719),
    [anon_sym_LT] = ACTIONS(2721),
    [anon_sym_GT] = ACTIONS(2721),
    [anon_sym_GT_GT] = ACTIONS(2719),
    [anon_sym_AMP_GT] = ACTIONS(2721),
    [anon_sym_AMP_GT_GT] = ACTIONS(2719),
    [anon_sym_LT_AMP] = ACTIONS(2719),
    [anon_sym_GT_AMP] = ACTIONS(2719),
    [anon_sym_LT_LT] = ACTIONS(2721),
    [anon_sym_LT_LT_DASH] = ACTIONS(2719),
    [anon_sym_LT_LT_LT] = ACTIONS(2719),
    [anon_sym_DOLLAR] = ACTIONS(2721),
    [sym__special_character] = ACTIONS(2719),
    [anon_sym_DQUOTE] = ACTIONS(2719),
    [sym_raw_string] = ACTIONS(2719),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2719),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2719),
    [anon_sym_BQUOTE] = ACTIONS(2719),
    [anon_sym_LT_LPAREN] = ACTIONS(2719),
    [anon_sym_GT_LPAREN] = ACTIONS(2719),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2721),
    [sym_word] = ACTIONS(2721),
    [anon_sym_LF] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2721),
  },
  [3361] = {
    [sym_concatenation] = STATE(1368),
    [sym_string] = STATE(730),
    [sym_simple_expansion] = STATE(730),
    [sym_string_expansion] = STATE(730),
    [sym_expansion] = STATE(730),
    [sym_command_substitution] = STATE(730),
    [sym_process_substitution] = STATE(730),
    [aux_sym_for_statement_repeat1] = STATE(1368),
    [aux_sym__literal_repeat1] = STATE(736),
    [anon_sym_RPAREN] = ACTIONS(8499),
    [anon_sym_DOLLAR] = ACTIONS(1406),
    [sym__special_character] = ACTIONS(1408),
    [anon_sym_DQUOTE] = ACTIONS(1410),
    [sym_raw_string] = ACTIONS(1412),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1414),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1416),
    [anon_sym_BQUOTE] = ACTIONS(1418),
    [anon_sym_LT_LPAREN] = ACTIONS(1420),
    [anon_sym_GT_LPAREN] = ACTIONS(1420),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1412),
  },
  [3362] = {
    [sym_string] = STATE(2211),
    [sym__simple_heredoc_body] = ACTIONS(4071),
    [sym__heredoc_body_beginning] = ACTIONS(4071),
    [sym_file_descriptor] = ACTIONS(4071),
    [sym_variable_name] = ACTIONS(4071),
    [anon_sym_SEMI] = ACTIONS(4073),
    [anon_sym_done] = ACTIONS(4073),
    [anon_sym_PIPE] = ACTIONS(4073),
    [anon_sym_SEMI_SEMI] = ACTIONS(4071),
    [anon_sym_PIPE_AMP] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_PIPE_PIPE] = ACTIONS(4071),
    [anon_sym_LT] = ACTIONS(4073),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_GT_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT] = ACTIONS(4073),
    [anon_sym_AMP_GT_GT] = ACTIONS(4071),
    [anon_sym_LT_AMP] = ACTIONS(4071),
    [anon_sym_GT_AMP] = ACTIONS(4071),
    [anon_sym_LT_LT] = ACTIONS(4073),
    [anon_sym_LT_LT_DASH] = ACTIONS(4071),
    [anon_sym_LT_LT_LT] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(8501),
    [anon_sym_DOLLAR] = ACTIONS(8501),
    [sym__special_character] = ACTIONS(4071),
    [anon_sym_DQUOTE] = ACTIONS(3233),
    [sym_raw_string] = ACTIONS(4896),
    [anon_sym_POUND] = ACTIONS(4894),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4071),
    [anon_sym_BQUOTE] = ACTIONS(4071),
    [anon_sym_LT_LPAREN] = ACTIONS(4071),
    [anon_sym_GT_LPAREN] = ACTIONS(4071),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4898),
    [anon_sym_STAR] = ACTIONS(4898),
    [anon_sym_AT] = ACTIONS(4898),
    [anon_sym_QMARK] = ACTIONS(4898),
    [anon_sym_0] = ACTIONS(4898),
    [anon_sym__] = ACTIONS(4898),
    [sym_word] = ACTIONS(4073),
    [anon_sym_LF] = ACTIONS(4071),
    [anon_sym_AMP] = ACTIONS(4073),
  },
  [3363] = {
    [sym__simple_heredoc_body] = ACTIONS(4111),
    [sym__heredoc_body_beginning] = ACTIONS(4111),
    [sym_file_descriptor] = ACTIONS(4111),
    [sym__concat] = ACTIONS(4111),
    [sym_variable_name] = ACTIONS(4111),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_done] = ACTIONS(4113),
    [anon_sym_PIPE] = ACTIONS(4113),
    [anon_sym_SEMI_SEMI] = ACTIONS(4111),
    [anon_sym_PIPE_AMP] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_LT] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4113),
    [anon_sym_GT_GT] = ACTIONS(4111),
    [anon_sym_AMP_GT] = ACTIONS(4113),
    [anon_sym_AMP_GT_GT] = ACTIONS(4111),
    [anon_sym_LT_AMP] = ACTIONS(4111),
    [anon_sym_GT_AMP] = ACTIONS(4111),
    [anon_sym_LT_LT] = ACTIONS(4113),
    [anon_sym_LT_LT_DASH] = ACTIONS(4111),
    [anon_sym_LT_LT_LT] = ACTIONS(4111),
    [anon_sym_DOLLAR] = ACTIONS(4113),
    [sym__special_character] = ACTIONS(4111),
    [anon_sym_DQUOTE] = ACTIONS(4111),
    [sym_raw_string] = ACTIONS(4111),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4111),
    [anon_sym_BQUOTE] = ACTIONS(4111),
    [anon_sym_LT_LPAREN] = ACTIONS(4111),
    [anon_sym_GT_LPAREN] = ACTIONS(4111),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4113),
    [sym_word] = ACTIONS(4113),
    [anon_sym_LF] = ACTIONS(4111),
    [anon_sym_AMP] = ACTIONS(4113),
  },
  [3364] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [sym_variable_name] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_done] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym__special_character] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4127),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [3365] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(8503),
    [sym_comment] = ACTIONS(57),
  },
  [3366] = {
    [anon_sym_RBRACE] = ACTIONS(8503),
    [sym_comment] = ACTIONS(57),
  },
  [3367] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(8505),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [3368] = {
    [sym_concatenation] = STATE(3761),
    [sym_string] = STATE(3760),
    [sym_simple_expansion] = STATE(3760),
    [sym_string_expansion] = STATE(3760),
    [sym_expansion] = STATE(3760),
    [sym_command_substitution] = STATE(3760),
    [sym_process_substitution] = STATE(3760),
    [aux_sym__literal_repeat1] = STATE(3762),
    [anon_sym_RBRACE] = ACTIONS(8503),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(8507),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8507),
  },
  [3369] = {
    [sym__simple_heredoc_body] = ACTIONS(4161),
    [sym__heredoc_body_beginning] = ACTIONS(4161),
    [sym_file_descriptor] = ACTIONS(4161),
    [sym__concat] = ACTIONS(4161),
    [sym_variable_name] = ACTIONS(4161),
    [anon_sym_SEMI] = ACTIONS(4163),
    [anon_sym_done] = ACTIONS(4163),
    [anon_sym_PIPE] = ACTIONS(4163),
    [anon_sym_SEMI_SEMI] = ACTIONS(4161),
    [anon_sym_PIPE_AMP] = ACTIONS(4161),
    [anon_sym_AMP_AMP] = ACTIONS(4161),
    [anon_sym_PIPE_PIPE] = ACTIONS(4161),
    [anon_sym_LT] = ACTIONS(4163),
    [anon_sym_GT] = ACTIONS(4163),
    [anon_sym_GT_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT] = ACTIONS(4163),
    [anon_sym_AMP_GT_GT] = ACTIONS(4161),
    [anon_sym_LT_AMP] = ACTIONS(4161),
    [anon_sym_GT_AMP] = ACTIONS(4161),
    [anon_sym_LT_LT] = ACTIONS(4163),
    [anon_sym_LT_LT_DASH] = ACTIONS(4161),
    [anon_sym_LT_LT_LT] = ACTIONS(4161),
    [anon_sym_DOLLAR] = ACTIONS(4163),
    [sym__special_character] = ACTIONS(4161),
    [anon_sym_DQUOTE] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4161),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4161),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4161),
    [anon_sym_BQUOTE] = ACTIONS(4161),
    [anon_sym_LT_LPAREN] = ACTIONS(4161),
    [anon_sym_GT_LPAREN] = ACTIONS(4161),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4163),
    [sym_word] = ACTIONS(4163),
    [anon_sym_LF] = ACTIONS(4161),
    [anon_sym_AMP] = ACTIONS(4163),
  },
  [3370] = {
    [sym_concatenation] = STATE(3765),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3765),
    [sym_regex] = ACTIONS(8509),
    [anon_sym_RBRACE] = ACTIONS(8511),
    [anon_sym_EQ] = ACTIONS(8513),
    [anon_sym_DASH] = ACTIONS(8513),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8515),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8513),
    [anon_sym_COLON_QMARK] = ACTIONS(8513),
    [anon_sym_COLON_DASH] = ACTIONS(8513),
    [anon_sym_PERCENT] = ACTIONS(8513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3371] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8511),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3372] = {
    [sym_concatenation] = STATE(3767),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3767),
    [sym_regex] = ACTIONS(8517),
    [anon_sym_RBRACE] = ACTIONS(8503),
    [anon_sym_EQ] = ACTIONS(8519),
    [anon_sym_DASH] = ACTIONS(8519),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8521),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8519),
    [anon_sym_COLON_QMARK] = ACTIONS(8519),
    [anon_sym_COLON_DASH] = ACTIONS(8519),
    [anon_sym_PERCENT] = ACTIONS(8519),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3373] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8503),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3374] = {
    [sym_concatenation] = STATE(3769),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3769),
    [anon_sym_RBRACE] = ACTIONS(8523),
    [anon_sym_EQ] = ACTIONS(8525),
    [anon_sym_DASH] = ACTIONS(8525),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8527),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8525),
    [anon_sym_COLON_QMARK] = ACTIONS(8525),
    [anon_sym_COLON_DASH] = ACTIONS(8525),
    [anon_sym_PERCENT] = ACTIONS(8525),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3375] = {
    [sym__simple_heredoc_body] = ACTIONS(4219),
    [sym__heredoc_body_beginning] = ACTIONS(4219),
    [sym_file_descriptor] = ACTIONS(4219),
    [sym__concat] = ACTIONS(4219),
    [sym_variable_name] = ACTIONS(4219),
    [anon_sym_SEMI] = ACTIONS(4221),
    [anon_sym_done] = ACTIONS(4221),
    [anon_sym_PIPE] = ACTIONS(4221),
    [anon_sym_SEMI_SEMI] = ACTIONS(4219),
    [anon_sym_PIPE_AMP] = ACTIONS(4219),
    [anon_sym_AMP_AMP] = ACTIONS(4219),
    [anon_sym_PIPE_PIPE] = ACTIONS(4219),
    [anon_sym_LT] = ACTIONS(4221),
    [anon_sym_GT] = ACTIONS(4221),
    [anon_sym_GT_GT] = ACTIONS(4219),
    [anon_sym_AMP_GT] = ACTIONS(4221),
    [anon_sym_AMP_GT_GT] = ACTIONS(4219),
    [anon_sym_LT_AMP] = ACTIONS(4219),
    [anon_sym_GT_AMP] = ACTIONS(4219),
    [anon_sym_LT_LT] = ACTIONS(4221),
    [anon_sym_LT_LT_DASH] = ACTIONS(4219),
    [anon_sym_LT_LT_LT] = ACTIONS(4219),
    [anon_sym_DOLLAR] = ACTIONS(4221),
    [sym__special_character] = ACTIONS(4219),
    [anon_sym_DQUOTE] = ACTIONS(4219),
    [sym_raw_string] = ACTIONS(4219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4219),
    [anon_sym_BQUOTE] = ACTIONS(4219),
    [anon_sym_LT_LPAREN] = ACTIONS(4219),
    [anon_sym_GT_LPAREN] = ACTIONS(4219),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4221),
    [sym_word] = ACTIONS(4221),
    [anon_sym_LF] = ACTIONS(4219),
    [anon_sym_AMP] = ACTIONS(4221),
  },
  [3376] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8523),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3377] = {
    [sym_concatenation] = STATE(3767),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3767),
    [anon_sym_RBRACE] = ACTIONS(8503),
    [anon_sym_EQ] = ACTIONS(8519),
    [anon_sym_DASH] = ACTIONS(8519),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8521),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8519),
    [anon_sym_COLON_QMARK] = ACTIONS(8519),
    [anon_sym_COLON_DASH] = ACTIONS(8519),
    [anon_sym_PERCENT] = ACTIONS(8519),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3378] = {
    [sym_string] = STATE(2230),
    [sym__simple_heredoc_body] = ACTIONS(4071),
    [sym__heredoc_body_beginning] = ACTIONS(4071),
    [sym_file_descriptor] = ACTIONS(4071),
    [anon_sym_SEMI] = ACTIONS(4073),
    [anon_sym_done] = ACTIONS(4073),
    [anon_sym_PIPE] = ACTIONS(4073),
    [anon_sym_SEMI_SEMI] = ACTIONS(4071),
    [anon_sym_PIPE_AMP] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_PIPE_PIPE] = ACTIONS(4071),
    [anon_sym_LT] = ACTIONS(4073),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_GT_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT] = ACTIONS(4073),
    [anon_sym_AMP_GT_GT] = ACTIONS(4071),
    [anon_sym_LT_AMP] = ACTIONS(4071),
    [anon_sym_GT_AMP] = ACTIONS(4071),
    [anon_sym_LT_LT] = ACTIONS(4073),
    [anon_sym_LT_LT_DASH] = ACTIONS(4071),
    [anon_sym_LT_LT_LT] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(8529),
    [anon_sym_DOLLAR] = ACTIONS(8529),
    [sym__special_character] = ACTIONS(4071),
    [anon_sym_DQUOTE] = ACTIONS(3253),
    [sym_raw_string] = ACTIONS(4924),
    [anon_sym_POUND] = ACTIONS(4922),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4071),
    [anon_sym_BQUOTE] = ACTIONS(4071),
    [anon_sym_LT_LPAREN] = ACTIONS(4071),
    [anon_sym_GT_LPAREN] = ACTIONS(4071),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4926),
    [anon_sym_STAR] = ACTIONS(4926),
    [anon_sym_AT] = ACTIONS(4926),
    [anon_sym_QMARK] = ACTIONS(4926),
    [anon_sym_0] = ACTIONS(4926),
    [anon_sym__] = ACTIONS(4926),
    [sym_word] = ACTIONS(4073),
    [anon_sym_LF] = ACTIONS(4071),
    [anon_sym_AMP] = ACTIONS(4073),
  },
  [3379] = {
    [sym__simple_heredoc_body] = ACTIONS(4111),
    [sym__heredoc_body_beginning] = ACTIONS(4111),
    [sym_file_descriptor] = ACTIONS(4111),
    [sym__concat] = ACTIONS(4111),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_done] = ACTIONS(4113),
    [anon_sym_PIPE] = ACTIONS(4113),
    [anon_sym_SEMI_SEMI] = ACTIONS(4111),
    [anon_sym_PIPE_AMP] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_LT] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4113),
    [anon_sym_GT_GT] = ACTIONS(4111),
    [anon_sym_AMP_GT] = ACTIONS(4113),
    [anon_sym_AMP_GT_GT] = ACTIONS(4111),
    [anon_sym_LT_AMP] = ACTIONS(4111),
    [anon_sym_GT_AMP] = ACTIONS(4111),
    [anon_sym_LT_LT] = ACTIONS(4113),
    [anon_sym_LT_LT_DASH] = ACTIONS(4111),
    [anon_sym_LT_LT_LT] = ACTIONS(4111),
    [anon_sym_DOLLAR] = ACTIONS(4113),
    [sym__special_character] = ACTIONS(4111),
    [anon_sym_DQUOTE] = ACTIONS(4111),
    [sym_raw_string] = ACTIONS(4111),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4111),
    [anon_sym_BQUOTE] = ACTIONS(4111),
    [anon_sym_LT_LPAREN] = ACTIONS(4111),
    [anon_sym_GT_LPAREN] = ACTIONS(4111),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4113),
    [sym_word] = ACTIONS(4113),
    [anon_sym_LF] = ACTIONS(4111),
    [anon_sym_AMP] = ACTIONS(4113),
  },
  [3380] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_done] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym__special_character] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4127),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [3381] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(8531),
    [sym_comment] = ACTIONS(57),
  },
  [3382] = {
    [anon_sym_RBRACE] = ACTIONS(8531),
    [sym_comment] = ACTIONS(57),
  },
  [3383] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(8533),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [3384] = {
    [sym_concatenation] = STATE(3773),
    [sym_string] = STATE(3772),
    [sym_simple_expansion] = STATE(3772),
    [sym_string_expansion] = STATE(3772),
    [sym_expansion] = STATE(3772),
    [sym_command_substitution] = STATE(3772),
    [sym_process_substitution] = STATE(3772),
    [aux_sym__literal_repeat1] = STATE(3774),
    [anon_sym_RBRACE] = ACTIONS(8531),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(8535),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8535),
  },
  [3385] = {
    [sym__simple_heredoc_body] = ACTIONS(4161),
    [sym__heredoc_body_beginning] = ACTIONS(4161),
    [sym_file_descriptor] = ACTIONS(4161),
    [sym__concat] = ACTIONS(4161),
    [anon_sym_SEMI] = ACTIONS(4163),
    [anon_sym_done] = ACTIONS(4163),
    [anon_sym_PIPE] = ACTIONS(4163),
    [anon_sym_SEMI_SEMI] = ACTIONS(4161),
    [anon_sym_PIPE_AMP] = ACTIONS(4161),
    [anon_sym_AMP_AMP] = ACTIONS(4161),
    [anon_sym_PIPE_PIPE] = ACTIONS(4161),
    [anon_sym_LT] = ACTIONS(4163),
    [anon_sym_GT] = ACTIONS(4163),
    [anon_sym_GT_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT] = ACTIONS(4163),
    [anon_sym_AMP_GT_GT] = ACTIONS(4161),
    [anon_sym_LT_AMP] = ACTIONS(4161),
    [anon_sym_GT_AMP] = ACTIONS(4161),
    [anon_sym_LT_LT] = ACTIONS(4163),
    [anon_sym_LT_LT_DASH] = ACTIONS(4161),
    [anon_sym_LT_LT_LT] = ACTIONS(4161),
    [anon_sym_DOLLAR] = ACTIONS(4163),
    [sym__special_character] = ACTIONS(4161),
    [anon_sym_DQUOTE] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4161),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4161),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4161),
    [anon_sym_BQUOTE] = ACTIONS(4161),
    [anon_sym_LT_LPAREN] = ACTIONS(4161),
    [anon_sym_GT_LPAREN] = ACTIONS(4161),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4163),
    [sym_word] = ACTIONS(4163),
    [anon_sym_LF] = ACTIONS(4161),
    [anon_sym_AMP] = ACTIONS(4163),
  },
  [3386] = {
    [sym_concatenation] = STATE(3777),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3777),
    [sym_regex] = ACTIONS(8537),
    [anon_sym_RBRACE] = ACTIONS(8539),
    [anon_sym_EQ] = ACTIONS(8541),
    [anon_sym_DASH] = ACTIONS(8541),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8543),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8541),
    [anon_sym_COLON_QMARK] = ACTIONS(8541),
    [anon_sym_COLON_DASH] = ACTIONS(8541),
    [anon_sym_PERCENT] = ACTIONS(8541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3387] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8539),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3388] = {
    [sym_concatenation] = STATE(3779),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3779),
    [sym_regex] = ACTIONS(8545),
    [anon_sym_RBRACE] = ACTIONS(8531),
    [anon_sym_EQ] = ACTIONS(8547),
    [anon_sym_DASH] = ACTIONS(8547),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8549),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8547),
    [anon_sym_COLON_QMARK] = ACTIONS(8547),
    [anon_sym_COLON_DASH] = ACTIONS(8547),
    [anon_sym_PERCENT] = ACTIONS(8547),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3389] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8531),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3390] = {
    [sym_concatenation] = STATE(3781),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3781),
    [anon_sym_RBRACE] = ACTIONS(8551),
    [anon_sym_EQ] = ACTIONS(8553),
    [anon_sym_DASH] = ACTIONS(8553),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8555),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8553),
    [anon_sym_COLON_QMARK] = ACTIONS(8553),
    [anon_sym_COLON_DASH] = ACTIONS(8553),
    [anon_sym_PERCENT] = ACTIONS(8553),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3391] = {
    [sym__simple_heredoc_body] = ACTIONS(4219),
    [sym__heredoc_body_beginning] = ACTIONS(4219),
    [sym_file_descriptor] = ACTIONS(4219),
    [sym__concat] = ACTIONS(4219),
    [anon_sym_SEMI] = ACTIONS(4221),
    [anon_sym_done] = ACTIONS(4221),
    [anon_sym_PIPE] = ACTIONS(4221),
    [anon_sym_SEMI_SEMI] = ACTIONS(4219),
    [anon_sym_PIPE_AMP] = ACTIONS(4219),
    [anon_sym_AMP_AMP] = ACTIONS(4219),
    [anon_sym_PIPE_PIPE] = ACTIONS(4219),
    [anon_sym_LT] = ACTIONS(4221),
    [anon_sym_GT] = ACTIONS(4221),
    [anon_sym_GT_GT] = ACTIONS(4219),
    [anon_sym_AMP_GT] = ACTIONS(4221),
    [anon_sym_AMP_GT_GT] = ACTIONS(4219),
    [anon_sym_LT_AMP] = ACTIONS(4219),
    [anon_sym_GT_AMP] = ACTIONS(4219),
    [anon_sym_LT_LT] = ACTIONS(4221),
    [anon_sym_LT_LT_DASH] = ACTIONS(4219),
    [anon_sym_LT_LT_LT] = ACTIONS(4219),
    [anon_sym_DOLLAR] = ACTIONS(4221),
    [sym__special_character] = ACTIONS(4219),
    [anon_sym_DQUOTE] = ACTIONS(4219),
    [sym_raw_string] = ACTIONS(4219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4219),
    [anon_sym_BQUOTE] = ACTIONS(4219),
    [anon_sym_LT_LPAREN] = ACTIONS(4219),
    [anon_sym_GT_LPAREN] = ACTIONS(4219),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4221),
    [sym_word] = ACTIONS(4221),
    [anon_sym_LF] = ACTIONS(4219),
    [anon_sym_AMP] = ACTIONS(4221),
  },
  [3392] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8551),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3393] = {
    [sym_concatenation] = STATE(3779),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3779),
    [anon_sym_RBRACE] = ACTIONS(8531),
    [anon_sym_EQ] = ACTIONS(8547),
    [anon_sym_DASH] = ACTIONS(8547),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8549),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8547),
    [anon_sym_COLON_QMARK] = ACTIONS(8547),
    [anon_sym_COLON_DASH] = ACTIONS(8547),
    [anon_sym_PERCENT] = ACTIONS(8547),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3394] = {
    [sym__simple_heredoc_body] = ACTIONS(5674),
    [sym__heredoc_body_beginning] = ACTIONS(5674),
    [sym_file_descriptor] = ACTIONS(5674),
    [sym__concat] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(5676),
    [anon_sym_done] = ACTIONS(5676),
    [anon_sym_PIPE] = ACTIONS(5676),
    [anon_sym_SEMI_SEMI] = ACTIONS(5674),
    [anon_sym_PIPE_AMP] = ACTIONS(5674),
    [anon_sym_AMP_AMP] = ACTIONS(5674),
    [anon_sym_PIPE_PIPE] = ACTIONS(5674),
    [anon_sym_EQ_TILDE] = ACTIONS(5676),
    [anon_sym_EQ_EQ] = ACTIONS(5676),
    [anon_sym_LT] = ACTIONS(5676),
    [anon_sym_GT] = ACTIONS(5676),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_AMP_GT] = ACTIONS(5676),
    [anon_sym_AMP_GT_GT] = ACTIONS(5674),
    [anon_sym_LT_AMP] = ACTIONS(5674),
    [anon_sym_GT_AMP] = ACTIONS(5674),
    [anon_sym_LT_LT] = ACTIONS(5676),
    [anon_sym_LT_LT_DASH] = ACTIONS(5674),
    [anon_sym_LT_LT_LT] = ACTIONS(5674),
    [anon_sym_DOLLAR] = ACTIONS(5676),
    [sym__special_character] = ACTIONS(5674),
    [anon_sym_DQUOTE] = ACTIONS(5674),
    [sym_raw_string] = ACTIONS(5674),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5674),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5674),
    [anon_sym_BQUOTE] = ACTIONS(5674),
    [anon_sym_LT_LPAREN] = ACTIONS(5674),
    [anon_sym_GT_LPAREN] = ACTIONS(5674),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5676),
    [anon_sym_LF] = ACTIONS(5674),
    [anon_sym_AMP] = ACTIONS(5676),
  },
  [3395] = {
    [sym__simple_heredoc_body] = ACTIONS(5708),
    [sym__heredoc_body_beginning] = ACTIONS(5708),
    [sym_file_descriptor] = ACTIONS(5708),
    [sym__concat] = ACTIONS(5708),
    [anon_sym_SEMI] = ACTIONS(5710),
    [anon_sym_done] = ACTIONS(5710),
    [anon_sym_PIPE] = ACTIONS(5710),
    [anon_sym_SEMI_SEMI] = ACTIONS(5708),
    [anon_sym_PIPE_AMP] = ACTIONS(5708),
    [anon_sym_AMP_AMP] = ACTIONS(5708),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_EQ_TILDE] = ACTIONS(5710),
    [anon_sym_EQ_EQ] = ACTIONS(5710),
    [anon_sym_LT] = ACTIONS(5710),
    [anon_sym_GT] = ACTIONS(5710),
    [anon_sym_GT_GT] = ACTIONS(5708),
    [anon_sym_AMP_GT] = ACTIONS(5710),
    [anon_sym_AMP_GT_GT] = ACTIONS(5708),
    [anon_sym_LT_AMP] = ACTIONS(5708),
    [anon_sym_GT_AMP] = ACTIONS(5708),
    [anon_sym_LT_LT] = ACTIONS(5710),
    [anon_sym_LT_LT_DASH] = ACTIONS(5708),
    [anon_sym_LT_LT_LT] = ACTIONS(5708),
    [anon_sym_DOLLAR] = ACTIONS(5710),
    [sym__special_character] = ACTIONS(5708),
    [anon_sym_DQUOTE] = ACTIONS(5708),
    [sym_raw_string] = ACTIONS(5708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5708),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5708),
    [anon_sym_BQUOTE] = ACTIONS(5708),
    [anon_sym_LT_LPAREN] = ACTIONS(5708),
    [anon_sym_GT_LPAREN] = ACTIONS(5708),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5710),
    [anon_sym_LF] = ACTIONS(5708),
    [anon_sym_AMP] = ACTIONS(5710),
  },
  [3396] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(8557),
    [sym_comment] = ACTIONS(57),
  },
  [3397] = {
    [anon_sym_RBRACE] = ACTIONS(8557),
    [sym_comment] = ACTIONS(57),
  },
  [3398] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(8559),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [3399] = {
    [sym_concatenation] = STATE(3785),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3785),
    [anon_sym_RBRACE] = ACTIONS(8561),
    [anon_sym_EQ] = ACTIONS(8563),
    [anon_sym_DASH] = ACTIONS(8563),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8565),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8563),
    [anon_sym_COLON_QMARK] = ACTIONS(8563),
    [anon_sym_COLON_DASH] = ACTIONS(8563),
    [anon_sym_PERCENT] = ACTIONS(8563),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3400] = {
    [sym__simple_heredoc_body] = ACTIONS(5725),
    [sym__heredoc_body_beginning] = ACTIONS(5725),
    [sym_file_descriptor] = ACTIONS(5725),
    [sym__concat] = ACTIONS(5725),
    [anon_sym_SEMI] = ACTIONS(5727),
    [anon_sym_done] = ACTIONS(5727),
    [anon_sym_PIPE] = ACTIONS(5727),
    [anon_sym_SEMI_SEMI] = ACTIONS(5725),
    [anon_sym_PIPE_AMP] = ACTIONS(5725),
    [anon_sym_AMP_AMP] = ACTIONS(5725),
    [anon_sym_PIPE_PIPE] = ACTIONS(5725),
    [anon_sym_EQ_TILDE] = ACTIONS(5727),
    [anon_sym_EQ_EQ] = ACTIONS(5727),
    [anon_sym_LT] = ACTIONS(5727),
    [anon_sym_GT] = ACTIONS(5727),
    [anon_sym_GT_GT] = ACTIONS(5725),
    [anon_sym_AMP_GT] = ACTIONS(5727),
    [anon_sym_AMP_GT_GT] = ACTIONS(5725),
    [anon_sym_LT_AMP] = ACTIONS(5725),
    [anon_sym_GT_AMP] = ACTIONS(5725),
    [anon_sym_LT_LT] = ACTIONS(5727),
    [anon_sym_LT_LT_DASH] = ACTIONS(5725),
    [anon_sym_LT_LT_LT] = ACTIONS(5725),
    [anon_sym_DOLLAR] = ACTIONS(5727),
    [sym__special_character] = ACTIONS(5725),
    [anon_sym_DQUOTE] = ACTIONS(5725),
    [sym_raw_string] = ACTIONS(5725),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5725),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5725),
    [anon_sym_BQUOTE] = ACTIONS(5725),
    [anon_sym_LT_LPAREN] = ACTIONS(5725),
    [anon_sym_GT_LPAREN] = ACTIONS(5725),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5727),
    [anon_sym_LF] = ACTIONS(5725),
    [anon_sym_AMP] = ACTIONS(5727),
  },
  [3401] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8561),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3402] = {
    [sym_concatenation] = STATE(3786),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3786),
    [anon_sym_RBRACE] = ACTIONS(8557),
    [anon_sym_EQ] = ACTIONS(8567),
    [anon_sym_DASH] = ACTIONS(8567),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8569),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8567),
    [anon_sym_COLON_QMARK] = ACTIONS(8567),
    [anon_sym_COLON_DASH] = ACTIONS(8567),
    [anon_sym_PERCENT] = ACTIONS(8567),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3403] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8557),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3404] = {
    [sym__simple_heredoc_body] = ACTIONS(5770),
    [sym__heredoc_body_beginning] = ACTIONS(5770),
    [sym_file_descriptor] = ACTIONS(5770),
    [sym__concat] = ACTIONS(5770),
    [anon_sym_SEMI] = ACTIONS(5772),
    [anon_sym_done] = ACTIONS(5772),
    [anon_sym_PIPE] = ACTIONS(5772),
    [anon_sym_SEMI_SEMI] = ACTIONS(5770),
    [anon_sym_PIPE_AMP] = ACTIONS(5770),
    [anon_sym_AMP_AMP] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5770),
    [anon_sym_EQ_TILDE] = ACTIONS(5772),
    [anon_sym_EQ_EQ] = ACTIONS(5772),
    [anon_sym_LT] = ACTIONS(5772),
    [anon_sym_GT] = ACTIONS(5772),
    [anon_sym_GT_GT] = ACTIONS(5770),
    [anon_sym_AMP_GT] = ACTIONS(5772),
    [anon_sym_AMP_GT_GT] = ACTIONS(5770),
    [anon_sym_LT_AMP] = ACTIONS(5770),
    [anon_sym_GT_AMP] = ACTIONS(5770),
    [anon_sym_LT_LT] = ACTIONS(5772),
    [anon_sym_LT_LT_DASH] = ACTIONS(5770),
    [anon_sym_LT_LT_LT] = ACTIONS(5770),
    [anon_sym_DOLLAR] = ACTIONS(5772),
    [sym__special_character] = ACTIONS(5770),
    [anon_sym_DQUOTE] = ACTIONS(5770),
    [sym_raw_string] = ACTIONS(5770),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5770),
    [anon_sym_BQUOTE] = ACTIONS(5770),
    [anon_sym_LT_LPAREN] = ACTIONS(5770),
    [anon_sym_GT_LPAREN] = ACTIONS(5770),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5772),
    [anon_sym_LF] = ACTIONS(5770),
    [anon_sym_AMP] = ACTIONS(5772),
  },
  [3405] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8571),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3406] = {
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_done] = ACTIONS(2362),
    [anon_sym_fi] = ACTIONS(2362),
    [anon_sym_elif] = ACTIONS(2362),
    [anon_sym_else] = ACTIONS(2362),
    [anon_sym_esac] = ACTIONS(2362),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [3407] = {
    [sym_string] = STATE(3406),
    [sym_simple_expansion] = STATE(3406),
    [sym_string_expansion] = STATE(3406),
    [sym_expansion] = STATE(3406),
    [sym_command_substitution] = STATE(3406),
    [sym_process_substitution] = STATE(3406),
    [anon_sym_DOLLAR] = ACTIONS(8573),
    [sym__special_character] = ACTIONS(7609),
    [anon_sym_DQUOTE] = ACTIONS(5002),
    [sym_raw_string] = ACTIONS(7609),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5006),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5008),
    [anon_sym_BQUOTE] = ACTIONS(5010),
    [anon_sym_LT_LPAREN] = ACTIONS(5012),
    [anon_sym_GT_LPAREN] = ACTIONS(5012),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7609),
  },
  [3408] = {
    [aux_sym_concatenation_repeat1] = STATE(3408),
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(8575),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_done] = ACTIONS(2362),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [3409] = {
    [sym__simple_heredoc_body] = ACTIONS(2371),
    [sym__heredoc_body_beginning] = ACTIONS(2371),
    [sym_file_descriptor] = ACTIONS(2371),
    [sym__concat] = ACTIONS(2371),
    [anon_sym_SEMI] = ACTIONS(2373),
    [anon_sym_done] = ACTIONS(2371),
    [anon_sym_fi] = ACTIONS(2371),
    [anon_sym_elif] = ACTIONS(2371),
    [anon_sym_else] = ACTIONS(2371),
    [anon_sym_esac] = ACTIONS(2371),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_SEMI_SEMI] = ACTIONS(2371),
    [anon_sym_PIPE_AMP] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_GT_GT] = ACTIONS(2371),
    [anon_sym_AMP_GT] = ACTIONS(2373),
    [anon_sym_AMP_GT_GT] = ACTIONS(2371),
    [anon_sym_LT_AMP] = ACTIONS(2371),
    [anon_sym_GT_AMP] = ACTIONS(2371),
    [anon_sym_LT_LT] = ACTIONS(2373),
    [anon_sym_LT_LT_DASH] = ACTIONS(2371),
    [anon_sym_LT_LT_LT] = ACTIONS(2371),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
  },
  [3410] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(8578),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [3411] = {
    [sym_concatenation] = STATE(3792),
    [sym_string] = STATE(3791),
    [sym_simple_expansion] = STATE(3791),
    [sym_string_expansion] = STATE(3791),
    [sym_expansion] = STATE(3791),
    [sym_command_substitution] = STATE(3791),
    [sym_process_substitution] = STATE(3791),
    [aux_sym__literal_repeat1] = STATE(3793),
    [anon_sym_RBRACE] = ACTIONS(8580),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(8582),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8582),
  },
  [3412] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(8584),
    [sym_comment] = ACTIONS(57),
  },
  [3413] = {
    [sym_concatenation] = STATE(3797),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3797),
    [anon_sym_RBRACE] = ACTIONS(8586),
    [anon_sym_EQ] = ACTIONS(8588),
    [anon_sym_DASH] = ACTIONS(8588),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8590),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(8592),
    [anon_sym_COLON] = ACTIONS(8588),
    [anon_sym_COLON_QMARK] = ACTIONS(8588),
    [anon_sym_COLON_DASH] = ACTIONS(8588),
    [anon_sym_PERCENT] = ACTIONS(8588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3414] = {
    [sym_concatenation] = STATE(3799),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3799),
    [anon_sym_RBRACE] = ACTIONS(8580),
    [anon_sym_EQ] = ACTIONS(8594),
    [anon_sym_DASH] = ACTIONS(8594),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8596),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(8598),
    [anon_sym_COLON] = ACTIONS(8594),
    [anon_sym_COLON_QMARK] = ACTIONS(8594),
    [anon_sym_COLON_DASH] = ACTIONS(8594),
    [anon_sym_PERCENT] = ACTIONS(8594),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3415] = {
    [sym__simple_heredoc_body] = ACTIONS(2462),
    [sym__heredoc_body_beginning] = ACTIONS(2462),
    [sym_file_descriptor] = ACTIONS(2462),
    [sym__concat] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_done] = ACTIONS(2462),
    [anon_sym_fi] = ACTIONS(2462),
    [anon_sym_elif] = ACTIONS(2462),
    [anon_sym_else] = ACTIONS(2462),
    [anon_sym_esac] = ACTIONS(2462),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_SEMI_SEMI] = ACTIONS(2462),
    [anon_sym_PIPE_AMP] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_GT_GT] = ACTIONS(2462),
    [anon_sym_AMP_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT_GT] = ACTIONS(2462),
    [anon_sym_LT_AMP] = ACTIONS(2462),
    [anon_sym_GT_AMP] = ACTIONS(2462),
    [anon_sym_LT_LT] = ACTIONS(2464),
    [anon_sym_LT_LT_DASH] = ACTIONS(2462),
    [anon_sym_LT_LT_LT] = ACTIONS(2462),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2462),
    [anon_sym_AMP] = ACTIONS(2464),
  },
  [3416] = {
    [sym_concatenation] = STATE(3802),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3802),
    [sym_regex] = ACTIONS(8600),
    [anon_sym_RBRACE] = ACTIONS(8602),
    [anon_sym_EQ] = ACTIONS(8604),
    [anon_sym_DASH] = ACTIONS(8604),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8606),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8604),
    [anon_sym_COLON_QMARK] = ACTIONS(8604),
    [anon_sym_COLON_DASH] = ACTIONS(8604),
    [anon_sym_PERCENT] = ACTIONS(8604),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3417] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8602),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3418] = {
    [sym__simple_heredoc_body] = ACTIONS(2512),
    [sym__heredoc_body_beginning] = ACTIONS(2512),
    [sym_file_descriptor] = ACTIONS(2512),
    [sym__concat] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2514),
    [anon_sym_done] = ACTIONS(2512),
    [anon_sym_fi] = ACTIONS(2512),
    [anon_sym_elif] = ACTIONS(2512),
    [anon_sym_else] = ACTIONS(2512),
    [anon_sym_esac] = ACTIONS(2512),
    [anon_sym_PIPE] = ACTIONS(2514),
    [anon_sym_SEMI_SEMI] = ACTIONS(2512),
    [anon_sym_PIPE_AMP] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE_PIPE] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2514),
    [anon_sym_GT] = ACTIONS(2514),
    [anon_sym_GT_GT] = ACTIONS(2512),
    [anon_sym_AMP_GT] = ACTIONS(2514),
    [anon_sym_AMP_GT_GT] = ACTIONS(2512),
    [anon_sym_LT_AMP] = ACTIONS(2512),
    [anon_sym_GT_AMP] = ACTIONS(2512),
    [anon_sym_LT_LT] = ACTIONS(2514),
    [anon_sym_LT_LT_DASH] = ACTIONS(2512),
    [anon_sym_LT_LT_LT] = ACTIONS(2512),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2514),
  },
  [3419] = {
    [sym_concatenation] = STATE(3799),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3799),
    [sym_regex] = ACTIONS(8608),
    [anon_sym_RBRACE] = ACTIONS(8580),
    [anon_sym_EQ] = ACTIONS(8594),
    [anon_sym_DASH] = ACTIONS(8594),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8596),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8594),
    [anon_sym_COLON_QMARK] = ACTIONS(8594),
    [anon_sym_COLON_DASH] = ACTIONS(8594),
    [anon_sym_PERCENT] = ACTIONS(8594),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3420] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8580),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3421] = {
    [sym__simple_heredoc_body] = ACTIONS(2520),
    [sym__heredoc_body_beginning] = ACTIONS(2520),
    [sym_file_descriptor] = ACTIONS(2520),
    [sym__concat] = ACTIONS(2520),
    [anon_sym_SEMI] = ACTIONS(2522),
    [anon_sym_done] = ACTIONS(2520),
    [anon_sym_fi] = ACTIONS(2520),
    [anon_sym_elif] = ACTIONS(2520),
    [anon_sym_else] = ACTIONS(2520),
    [anon_sym_esac] = ACTIONS(2520),
    [anon_sym_PIPE] = ACTIONS(2522),
    [anon_sym_SEMI_SEMI] = ACTIONS(2520),
    [anon_sym_PIPE_AMP] = ACTIONS(2520),
    [anon_sym_AMP_AMP] = ACTIONS(2520),
    [anon_sym_PIPE_PIPE] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(2522),
    [anon_sym_GT] = ACTIONS(2522),
    [anon_sym_GT_GT] = ACTIONS(2520),
    [anon_sym_AMP_GT] = ACTIONS(2522),
    [anon_sym_AMP_GT_GT] = ACTIONS(2520),
    [anon_sym_LT_AMP] = ACTIONS(2520),
    [anon_sym_GT_AMP] = ACTIONS(2520),
    [anon_sym_LT_LT] = ACTIONS(2522),
    [anon_sym_LT_LT_DASH] = ACTIONS(2520),
    [anon_sym_LT_LT_LT] = ACTIONS(2520),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2522),
  },
  [3422] = {
    [sym__simple_heredoc_body] = ACTIONS(2554),
    [sym__heredoc_body_beginning] = ACTIONS(2554),
    [sym_file_descriptor] = ACTIONS(2554),
    [sym__concat] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(2556),
    [anon_sym_done] = ACTIONS(2554),
    [anon_sym_fi] = ACTIONS(2554),
    [anon_sym_elif] = ACTIONS(2554),
    [anon_sym_else] = ACTIONS(2554),
    [anon_sym_esac] = ACTIONS(2554),
    [anon_sym_PIPE] = ACTIONS(2556),
    [anon_sym_SEMI_SEMI] = ACTIONS(2554),
    [anon_sym_PIPE_AMP] = ACTIONS(2554),
    [anon_sym_AMP_AMP] = ACTIONS(2554),
    [anon_sym_PIPE_PIPE] = ACTIONS(2554),
    [anon_sym_LT] = ACTIONS(2556),
    [anon_sym_GT] = ACTIONS(2556),
    [anon_sym_GT_GT] = ACTIONS(2554),
    [anon_sym_AMP_GT] = ACTIONS(2556),
    [anon_sym_AMP_GT_GT] = ACTIONS(2554),
    [anon_sym_LT_AMP] = ACTIONS(2554),
    [anon_sym_GT_AMP] = ACTIONS(2554),
    [anon_sym_LT_LT] = ACTIONS(2556),
    [anon_sym_LT_LT_DASH] = ACTIONS(2554),
    [anon_sym_LT_LT_LT] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2554),
    [anon_sym_AMP] = ACTIONS(2556),
  },
  [3423] = {
    [sym__simple_heredoc_body] = ACTIONS(4449),
    [sym__heredoc_body_beginning] = ACTIONS(4449),
    [sym_file_descriptor] = ACTIONS(4449),
    [sym_variable_name] = ACTIONS(4449),
    [anon_sym_SEMI] = ACTIONS(4451),
    [anon_sym_fi] = ACTIONS(4451),
    [anon_sym_elif] = ACTIONS(4451),
    [anon_sym_else] = ACTIONS(4451),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_SEMI_SEMI] = ACTIONS(4449),
    [anon_sym_PIPE_AMP] = ACTIONS(4449),
    [anon_sym_AMP_AMP] = ACTIONS(4449),
    [anon_sym_PIPE_PIPE] = ACTIONS(4449),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_GT_GT] = ACTIONS(4449),
    [anon_sym_AMP_GT] = ACTIONS(4451),
    [anon_sym_AMP_GT_GT] = ACTIONS(4449),
    [anon_sym_LT_AMP] = ACTIONS(4449),
    [anon_sym_GT_AMP] = ACTIONS(4449),
    [anon_sym_LT_LT] = ACTIONS(4451),
    [anon_sym_LT_LT_DASH] = ACTIONS(4449),
    [anon_sym_LT_LT_LT] = ACTIONS(4449),
    [anon_sym_DOLLAR] = ACTIONS(4451),
    [sym__special_character] = ACTIONS(4449),
    [anon_sym_DQUOTE] = ACTIONS(4449),
    [sym_raw_string] = ACTIONS(4449),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4449),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4449),
    [anon_sym_BQUOTE] = ACTIONS(4449),
    [anon_sym_LT_LPAREN] = ACTIONS(4449),
    [anon_sym_GT_LPAREN] = ACTIONS(4449),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4451),
    [anon_sym_LF] = ACTIONS(4449),
    [anon_sym_AMP] = ACTIONS(4451),
  },
  [3424] = {
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(2362),
    [sym_variable_name] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_fi] = ACTIONS(2364),
    [anon_sym_elif] = ACTIONS(2364),
    [anon_sym_else] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [3425] = {
    [sym_string] = STATE(3424),
    [sym_simple_expansion] = STATE(3424),
    [sym_string_expansion] = STATE(3424),
    [sym_expansion] = STATE(3424),
    [sym_command_substitution] = STATE(3424),
    [sym_process_substitution] = STATE(3424),
    [anon_sym_DOLLAR] = ACTIONS(8610),
    [sym__special_character] = ACTIONS(7654),
    [anon_sym_DQUOTE] = ACTIONS(5041),
    [sym_raw_string] = ACTIONS(7654),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5045),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5047),
    [anon_sym_BQUOTE] = ACTIONS(5049),
    [anon_sym_LT_LPAREN] = ACTIONS(5051),
    [anon_sym_GT_LPAREN] = ACTIONS(5051),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7654),
  },
  [3426] = {
    [aux_sym_concatenation_repeat1] = STATE(3426),
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(8612),
    [sym_variable_name] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_fi] = ACTIONS(2364),
    [anon_sym_elif] = ACTIONS(2364),
    [anon_sym_else] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [3427] = {
    [sym__simple_heredoc_body] = ACTIONS(2371),
    [sym__heredoc_body_beginning] = ACTIONS(2371),
    [sym_file_descriptor] = ACTIONS(2371),
    [sym__concat] = ACTIONS(2371),
    [sym_variable_name] = ACTIONS(2371),
    [anon_sym_SEMI] = ACTIONS(2373),
    [anon_sym_fi] = ACTIONS(2373),
    [anon_sym_elif] = ACTIONS(2373),
    [anon_sym_else] = ACTIONS(2373),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_SEMI_SEMI] = ACTIONS(2371),
    [anon_sym_PIPE_AMP] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_GT_GT] = ACTIONS(2371),
    [anon_sym_AMP_GT] = ACTIONS(2373),
    [anon_sym_AMP_GT_GT] = ACTIONS(2371),
    [anon_sym_LT_AMP] = ACTIONS(2371),
    [anon_sym_GT_AMP] = ACTIONS(2371),
    [anon_sym_LT_LT] = ACTIONS(2373),
    [anon_sym_LT_LT_DASH] = ACTIONS(2371),
    [anon_sym_LT_LT_LT] = ACTIONS(2371),
    [anon_sym_DOLLAR] = ACTIONS(2373),
    [sym__special_character] = ACTIONS(2371),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [sym_raw_string] = ACTIONS(2371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2371),
    [anon_sym_BQUOTE] = ACTIONS(2371),
    [anon_sym_LT_LPAREN] = ACTIONS(2371),
    [anon_sym_GT_LPAREN] = ACTIONS(2371),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2373),
    [anon_sym_LF] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
  },
  [3428] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(8615),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [3429] = {
    [sym_concatenation] = STATE(3808),
    [sym_string] = STATE(3807),
    [sym_simple_expansion] = STATE(3807),
    [sym_string_expansion] = STATE(3807),
    [sym_expansion] = STATE(3807),
    [sym_command_substitution] = STATE(3807),
    [sym_process_substitution] = STATE(3807),
    [aux_sym__literal_repeat1] = STATE(3809),
    [anon_sym_RBRACE] = ACTIONS(8617),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(8619),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8619),
  },
  [3430] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(8621),
    [sym_comment] = ACTIONS(57),
  },
  [3431] = {
    [sym_concatenation] = STATE(3813),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3813),
    [anon_sym_RBRACE] = ACTIONS(8623),
    [anon_sym_EQ] = ACTIONS(8625),
    [anon_sym_DASH] = ACTIONS(8625),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8627),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(8629),
    [anon_sym_COLON] = ACTIONS(8625),
    [anon_sym_COLON_QMARK] = ACTIONS(8625),
    [anon_sym_COLON_DASH] = ACTIONS(8625),
    [anon_sym_PERCENT] = ACTIONS(8625),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3432] = {
    [sym_concatenation] = STATE(3815),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3815),
    [anon_sym_RBRACE] = ACTIONS(8617),
    [anon_sym_EQ] = ACTIONS(8631),
    [anon_sym_DASH] = ACTIONS(8631),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8633),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(8635),
    [anon_sym_COLON] = ACTIONS(8631),
    [anon_sym_COLON_QMARK] = ACTIONS(8631),
    [anon_sym_COLON_DASH] = ACTIONS(8631),
    [anon_sym_PERCENT] = ACTIONS(8631),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3433] = {
    [sym__simple_heredoc_body] = ACTIONS(2462),
    [sym__heredoc_body_beginning] = ACTIONS(2462),
    [sym_file_descriptor] = ACTIONS(2462),
    [sym__concat] = ACTIONS(2462),
    [sym_variable_name] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_fi] = ACTIONS(2464),
    [anon_sym_elif] = ACTIONS(2464),
    [anon_sym_else] = ACTIONS(2464),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_SEMI_SEMI] = ACTIONS(2462),
    [anon_sym_PIPE_AMP] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_GT_GT] = ACTIONS(2462),
    [anon_sym_AMP_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT_GT] = ACTIONS(2462),
    [anon_sym_LT_AMP] = ACTIONS(2462),
    [anon_sym_GT_AMP] = ACTIONS(2462),
    [anon_sym_LT_LT] = ACTIONS(2464),
    [anon_sym_LT_LT_DASH] = ACTIONS(2462),
    [anon_sym_LT_LT_LT] = ACTIONS(2462),
    [anon_sym_DOLLAR] = ACTIONS(2464),
    [sym__special_character] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [sym_raw_string] = ACTIONS(2462),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2462),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2462),
    [anon_sym_BQUOTE] = ACTIONS(2462),
    [anon_sym_LT_LPAREN] = ACTIONS(2462),
    [anon_sym_GT_LPAREN] = ACTIONS(2462),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2464),
    [anon_sym_LF] = ACTIONS(2462),
    [anon_sym_AMP] = ACTIONS(2464),
  },
  [3434] = {
    [sym_concatenation] = STATE(3818),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3818),
    [sym_regex] = ACTIONS(8637),
    [anon_sym_RBRACE] = ACTIONS(8639),
    [anon_sym_EQ] = ACTIONS(8641),
    [anon_sym_DASH] = ACTIONS(8641),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8643),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8641),
    [anon_sym_COLON_QMARK] = ACTIONS(8641),
    [anon_sym_COLON_DASH] = ACTIONS(8641),
    [anon_sym_PERCENT] = ACTIONS(8641),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3435] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8639),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3436] = {
    [sym__simple_heredoc_body] = ACTIONS(2512),
    [sym__heredoc_body_beginning] = ACTIONS(2512),
    [sym_file_descriptor] = ACTIONS(2512),
    [sym__concat] = ACTIONS(2512),
    [sym_variable_name] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2514),
    [anon_sym_fi] = ACTIONS(2514),
    [anon_sym_elif] = ACTIONS(2514),
    [anon_sym_else] = ACTIONS(2514),
    [anon_sym_PIPE] = ACTIONS(2514),
    [anon_sym_SEMI_SEMI] = ACTIONS(2512),
    [anon_sym_PIPE_AMP] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE_PIPE] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2514),
    [anon_sym_GT] = ACTIONS(2514),
    [anon_sym_GT_GT] = ACTIONS(2512),
    [anon_sym_AMP_GT] = ACTIONS(2514),
    [anon_sym_AMP_GT_GT] = ACTIONS(2512),
    [anon_sym_LT_AMP] = ACTIONS(2512),
    [anon_sym_GT_AMP] = ACTIONS(2512),
    [anon_sym_LT_LT] = ACTIONS(2514),
    [anon_sym_LT_LT_DASH] = ACTIONS(2512),
    [anon_sym_LT_LT_LT] = ACTIONS(2512),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [sym__special_character] = ACTIONS(2512),
    [anon_sym_DQUOTE] = ACTIONS(2512),
    [sym_raw_string] = ACTIONS(2512),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2512),
    [anon_sym_BQUOTE] = ACTIONS(2512),
    [anon_sym_LT_LPAREN] = ACTIONS(2512),
    [anon_sym_GT_LPAREN] = ACTIONS(2512),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2514),
    [anon_sym_LF] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2514),
  },
  [3437] = {
    [sym_concatenation] = STATE(3815),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3815),
    [sym_regex] = ACTIONS(8645),
    [anon_sym_RBRACE] = ACTIONS(8617),
    [anon_sym_EQ] = ACTIONS(8631),
    [anon_sym_DASH] = ACTIONS(8631),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8633),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8631),
    [anon_sym_COLON_QMARK] = ACTIONS(8631),
    [anon_sym_COLON_DASH] = ACTIONS(8631),
    [anon_sym_PERCENT] = ACTIONS(8631),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3438] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8617),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3439] = {
    [sym__simple_heredoc_body] = ACTIONS(2520),
    [sym__heredoc_body_beginning] = ACTIONS(2520),
    [sym_file_descriptor] = ACTIONS(2520),
    [sym__concat] = ACTIONS(2520),
    [sym_variable_name] = ACTIONS(2520),
    [anon_sym_SEMI] = ACTIONS(2522),
    [anon_sym_fi] = ACTIONS(2522),
    [anon_sym_elif] = ACTIONS(2522),
    [anon_sym_else] = ACTIONS(2522),
    [anon_sym_PIPE] = ACTIONS(2522),
    [anon_sym_SEMI_SEMI] = ACTIONS(2520),
    [anon_sym_PIPE_AMP] = ACTIONS(2520),
    [anon_sym_AMP_AMP] = ACTIONS(2520),
    [anon_sym_PIPE_PIPE] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(2522),
    [anon_sym_GT] = ACTIONS(2522),
    [anon_sym_GT_GT] = ACTIONS(2520),
    [anon_sym_AMP_GT] = ACTIONS(2522),
    [anon_sym_AMP_GT_GT] = ACTIONS(2520),
    [anon_sym_LT_AMP] = ACTIONS(2520),
    [anon_sym_GT_AMP] = ACTIONS(2520),
    [anon_sym_LT_LT] = ACTIONS(2522),
    [anon_sym_LT_LT_DASH] = ACTIONS(2520),
    [anon_sym_LT_LT_LT] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(2522),
    [sym__special_character] = ACTIONS(2520),
    [anon_sym_DQUOTE] = ACTIONS(2520),
    [sym_raw_string] = ACTIONS(2520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2520),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2520),
    [anon_sym_BQUOTE] = ACTIONS(2520),
    [anon_sym_LT_LPAREN] = ACTIONS(2520),
    [anon_sym_GT_LPAREN] = ACTIONS(2520),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2522),
    [anon_sym_LF] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2522),
  },
  [3440] = {
    [sym__simple_heredoc_body] = ACTIONS(2554),
    [sym__heredoc_body_beginning] = ACTIONS(2554),
    [sym_file_descriptor] = ACTIONS(2554),
    [sym__concat] = ACTIONS(2554),
    [sym_variable_name] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(2556),
    [anon_sym_fi] = ACTIONS(2556),
    [anon_sym_elif] = ACTIONS(2556),
    [anon_sym_else] = ACTIONS(2556),
    [anon_sym_PIPE] = ACTIONS(2556),
    [anon_sym_SEMI_SEMI] = ACTIONS(2554),
    [anon_sym_PIPE_AMP] = ACTIONS(2554),
    [anon_sym_AMP_AMP] = ACTIONS(2554),
    [anon_sym_PIPE_PIPE] = ACTIONS(2554),
    [anon_sym_LT] = ACTIONS(2556),
    [anon_sym_GT] = ACTIONS(2556),
    [anon_sym_GT_GT] = ACTIONS(2554),
    [anon_sym_AMP_GT] = ACTIONS(2556),
    [anon_sym_AMP_GT_GT] = ACTIONS(2554),
    [anon_sym_LT_AMP] = ACTIONS(2554),
    [anon_sym_GT_AMP] = ACTIONS(2554),
    [anon_sym_LT_LT] = ACTIONS(2556),
    [anon_sym_LT_LT_DASH] = ACTIONS(2554),
    [anon_sym_LT_LT_LT] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2556),
    [sym__special_character] = ACTIONS(2554),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2554),
    [anon_sym_BQUOTE] = ACTIONS(2554),
    [anon_sym_LT_LPAREN] = ACTIONS(2554),
    [anon_sym_GT_LPAREN] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2556),
    [anon_sym_LF] = ACTIONS(2554),
    [anon_sym_AMP] = ACTIONS(2556),
  },
  [3441] = {
    [sym__simple_heredoc_body] = ACTIONS(2719),
    [sym__heredoc_body_beginning] = ACTIONS(2719),
    [sym_file_descriptor] = ACTIONS(2719),
    [sym_variable_name] = ACTIONS(2719),
    [anon_sym_SEMI] = ACTIONS(2721),
    [anon_sym_fi] = ACTIONS(2721),
    [anon_sym_PIPE] = ACTIONS(2721),
    [anon_sym_SEMI_SEMI] = ACTIONS(2719),
    [anon_sym_PIPE_AMP] = ACTIONS(2719),
    [anon_sym_AMP_AMP] = ACTIONS(2719),
    [anon_sym_PIPE_PIPE] = ACTIONS(2719),
    [anon_sym_LT] = ACTIONS(2721),
    [anon_sym_GT] = ACTIONS(2721),
    [anon_sym_GT_GT] = ACTIONS(2719),
    [anon_sym_AMP_GT] = ACTIONS(2721),
    [anon_sym_AMP_GT_GT] = ACTIONS(2719),
    [anon_sym_LT_AMP] = ACTIONS(2719),
    [anon_sym_GT_AMP] = ACTIONS(2719),
    [anon_sym_LT_LT] = ACTIONS(2721),
    [anon_sym_LT_LT_DASH] = ACTIONS(2719),
    [anon_sym_LT_LT_LT] = ACTIONS(2719),
    [anon_sym_DOLLAR] = ACTIONS(2721),
    [sym__special_character] = ACTIONS(2719),
    [anon_sym_DQUOTE] = ACTIONS(2719),
    [sym_raw_string] = ACTIONS(2719),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2719),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2719),
    [anon_sym_BQUOTE] = ACTIONS(2719),
    [anon_sym_LT_LPAREN] = ACTIONS(2719),
    [anon_sym_GT_LPAREN] = ACTIONS(2719),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2721),
    [anon_sym_LF] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2721),
  },
  [3442] = {
    [sym_concatenation] = STATE(1368),
    [sym_string] = STATE(730),
    [sym_simple_expansion] = STATE(730),
    [sym_string_expansion] = STATE(730),
    [sym_expansion] = STATE(730),
    [sym_command_substitution] = STATE(730),
    [sym_process_substitution] = STATE(730),
    [aux_sym_for_statement_repeat1] = STATE(1368),
    [aux_sym__literal_repeat1] = STATE(736),
    [anon_sym_RPAREN] = ACTIONS(8647),
    [anon_sym_DOLLAR] = ACTIONS(1406),
    [sym__special_character] = ACTIONS(1408),
    [anon_sym_DQUOTE] = ACTIONS(1410),
    [sym_raw_string] = ACTIONS(1412),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1414),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1416),
    [anon_sym_BQUOTE] = ACTIONS(1418),
    [anon_sym_LT_LPAREN] = ACTIONS(1420),
    [anon_sym_GT_LPAREN] = ACTIONS(1420),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1412),
  },
  [3443] = {
    [sym__simple_heredoc_body] = ACTIONS(1057),
    [sym__heredoc_body_beginning] = ACTIONS(1057),
    [sym_file_descriptor] = ACTIONS(1057),
    [sym__concat] = ACTIONS(1057),
    [sym_variable_name] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_fi] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_PIPE_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_AMP] = ACTIONS(1057),
    [anon_sym_GT_AMP] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_LT] = ACTIONS(1057),
    [anon_sym_DOLLAR] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [sym_raw_string] = ACTIONS(1057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1057),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1057),
    [anon_sym_BQUOTE] = ACTIONS(1057),
    [anon_sym_LT_LPAREN] = ACTIONS(1057),
    [anon_sym_GT_LPAREN] = ACTIONS(1057),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [3444] = {
    [sym__simple_heredoc_body] = ACTIONS(1061),
    [sym__heredoc_body_beginning] = ACTIONS(1061),
    [sym_file_descriptor] = ACTIONS(1061),
    [sym__concat] = ACTIONS(1061),
    [sym_variable_name] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(1063),
    [anon_sym_fi] = ACTIONS(1063),
    [anon_sym_PIPE] = ACTIONS(1063),
    [anon_sym_SEMI_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE_AMP] = ACTIONS(1061),
    [anon_sym_AMP_AMP] = ACTIONS(1061),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1063),
    [anon_sym_GT_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT_GT] = ACTIONS(1061),
    [anon_sym_LT_AMP] = ACTIONS(1061),
    [anon_sym_GT_AMP] = ACTIONS(1061),
    [anon_sym_LT_LT] = ACTIONS(1063),
    [anon_sym_LT_LT_DASH] = ACTIONS(1061),
    [anon_sym_LT_LT_LT] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1061),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1061),
    [anon_sym_LT_LPAREN] = ACTIONS(1061),
    [anon_sym_GT_LPAREN] = ACTIONS(1061),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1063),
    [anon_sym_LF] = ACTIONS(1061),
    [anon_sym_AMP] = ACTIONS(1063),
  },
  [3445] = {
    [sym__simple_heredoc_body] = ACTIONS(1065),
    [sym__heredoc_body_beginning] = ACTIONS(1065),
    [sym_file_descriptor] = ACTIONS(1065),
    [sym__concat] = ACTIONS(1065),
    [sym_variable_name] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_fi] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1067),
    [anon_sym_SEMI_SEMI] = ACTIONS(1065),
    [anon_sym_PIPE_AMP] = ACTIONS(1065),
    [anon_sym_AMP_AMP] = ACTIONS(1065),
    [anon_sym_PIPE_PIPE] = ACTIONS(1065),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_GT] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT] = ACTIONS(1067),
    [anon_sym_AMP_GT_GT] = ACTIONS(1065),
    [anon_sym_LT_AMP] = ACTIONS(1065),
    [anon_sym_GT_AMP] = ACTIONS(1065),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_LT_LT_DASH] = ACTIONS(1065),
    [anon_sym_LT_LT_LT] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1067),
    [sym__special_character] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LT_LPAREN] = ACTIONS(1065),
    [anon_sym_GT_LPAREN] = ACTIONS(1065),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1067),
    [anon_sym_LF] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1067),
  },
  [3446] = {
    [sym_string] = STATE(3821),
    [sym_simple_expansion] = STATE(3821),
    [sym_string_expansion] = STATE(3821),
    [sym_expansion] = STATE(3821),
    [sym_command_substitution] = STATE(3821),
    [sym_process_substitution] = STATE(3821),
    [anon_sym_DOLLAR] = ACTIONS(6469),
    [sym__special_character] = ACTIONS(8649),
    [anon_sym_DQUOTE] = ACTIONS(6473),
    [sym_raw_string] = ACTIONS(8649),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6477),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6479),
    [anon_sym_BQUOTE] = ACTIONS(6481),
    [anon_sym_LT_LPAREN] = ACTIONS(6483),
    [anon_sym_GT_LPAREN] = ACTIONS(6483),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8649),
  },
  [3447] = {
    [aux_sym_concatenation_repeat1] = STATE(3823),
    [sym__simple_heredoc_body] = ACTIONS(1071),
    [sym__heredoc_body_beginning] = ACTIONS(1071),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(8651),
    [sym_variable_name] = ACTIONS(1071),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_fi] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [sym__special_character] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1075),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1075),
  },
  [3448] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(8653),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [3449] = {
    [sym__simple_heredoc_body] = ACTIONS(1089),
    [sym__heredoc_body_beginning] = ACTIONS(1089),
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(1089),
    [sym_variable_name] = ACTIONS(1089),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_fi] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1089),
    [anon_sym_PIPE_AMP] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_AMP] = ACTIONS(1089),
    [anon_sym_GT_AMP] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1089),
    [anon_sym_LT_LT_LT] = ACTIONS(1089),
    [anon_sym_DOLLAR] = ACTIONS(1091),
    [sym__special_character] = ACTIONS(1089),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1089),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1089),
    [anon_sym_GT_LPAREN] = ACTIONS(1089),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [3450] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(627),
    [anon_sym_DOLLAR] = ACTIONS(8655),
    [anon_sym_DQUOTE] = ACTIONS(8653),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [3451] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(8657),
    [sym_comment] = ACTIONS(57),
  },
  [3452] = {
    [sym_subscript] = STATE(3829),
    [sym_variable_name] = ACTIONS(8659),
    [anon_sym_DASH] = ACTIONS(8661),
    [anon_sym_DOLLAR] = ACTIONS(8661),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8663),
    [anon_sym_STAR] = ACTIONS(8665),
    [anon_sym_AT] = ACTIONS(8665),
    [anon_sym_QMARK] = ACTIONS(8665),
    [anon_sym_0] = ACTIONS(8663),
    [anon_sym__] = ACTIONS(8663),
  },
  [3453] = {
    [sym_concatenation] = STATE(3832),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3832),
    [anon_sym_RBRACE] = ACTIONS(8667),
    [anon_sym_EQ] = ACTIONS(8669),
    [anon_sym_DASH] = ACTIONS(8669),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8671),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(8673),
    [anon_sym_COLON] = ACTIONS(8669),
    [anon_sym_COLON_QMARK] = ACTIONS(8669),
    [anon_sym_COLON_DASH] = ACTIONS(8669),
    [anon_sym_PERCENT] = ACTIONS(8669),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3454] = {
    [sym_concatenation] = STATE(3835),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3835),
    [anon_sym_RBRACE] = ACTIONS(8675),
    [anon_sym_EQ] = ACTIONS(8677),
    [anon_sym_DASH] = ACTIONS(8677),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8679),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(8681),
    [anon_sym_COLON] = ACTIONS(8677),
    [anon_sym_COLON_QMARK] = ACTIONS(8677),
    [anon_sym_COLON_DASH] = ACTIONS(8677),
    [anon_sym_PERCENT] = ACTIONS(8677),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3455] = {
    [anon_sym_RPAREN] = ACTIONS(8683),
    [sym_comment] = ACTIONS(57),
  },
  [3456] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(8683),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [3457] = {
    [anon_sym_BQUOTE] = ACTIONS(8683),
    [sym_comment] = ACTIONS(57),
  },
  [3458] = {
    [anon_sym_RPAREN] = ACTIONS(8685),
    [sym_comment] = ACTIONS(57),
  },
  [3459] = {
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym_variable_name] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_fi] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [3460] = {
    [aux_sym__literal_repeat1] = STATE(3460),
    [sym__simple_heredoc_body] = ACTIONS(1373),
    [sym__heredoc_body_beginning] = ACTIONS(1373),
    [sym_file_descriptor] = ACTIONS(1373),
    [sym_variable_name] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_fi] = ACTIONS(1375),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE_AMP] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_LT_LT_DASH] = ACTIONS(1373),
    [anon_sym_LT_LT_LT] = ACTIONS(1373),
    [anon_sym_DOLLAR] = ACTIONS(1375),
    [sym__special_character] = ACTIONS(8687),
    [anon_sym_DQUOTE] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1373),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [anon_sym_LT_LPAREN] = ACTIONS(1373),
    [anon_sym_GT_LPAREN] = ACTIONS(1373),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1375),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
  },
  [3461] = {
    [sym__simple_heredoc_body] = ACTIONS(1400),
    [sym__heredoc_body_beginning] = ACTIONS(1400),
    [sym_file_descriptor] = ACTIONS(1400),
    [sym_variable_name] = ACTIONS(1400),
    [anon_sym_SEMI] = ACTIONS(1402),
    [anon_sym_fi] = ACTIONS(1402),
    [anon_sym_PIPE] = ACTIONS(1402),
    [anon_sym_SEMI_SEMI] = ACTIONS(1400),
    [anon_sym_PIPE_AMP] = ACTIONS(1400),
    [anon_sym_AMP_AMP] = ACTIONS(1400),
    [anon_sym_PIPE_PIPE] = ACTIONS(1400),
    [anon_sym_LT] = ACTIONS(1402),
    [anon_sym_GT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT] = ACTIONS(1402),
    [anon_sym_AMP_GT_GT] = ACTIONS(1400),
    [anon_sym_LT_AMP] = ACTIONS(1400),
    [anon_sym_GT_AMP] = ACTIONS(1400),
    [anon_sym_LT_LT] = ACTIONS(1402),
    [anon_sym_LT_LT_DASH] = ACTIONS(1400),
    [anon_sym_LT_LT_LT] = ACTIONS(1400),
    [anon_sym_DOLLAR] = ACTIONS(1402),
    [sym__special_character] = ACTIONS(1400),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1400),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1400),
    [anon_sym_BQUOTE] = ACTIONS(1400),
    [anon_sym_LT_LPAREN] = ACTIONS(1400),
    [anon_sym_GT_LPAREN] = ACTIONS(1400),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1402),
    [sym_word] = ACTIONS(1402),
    [anon_sym_LF] = ACTIONS(1400),
    [anon_sym_AMP] = ACTIONS(1402),
  },
  [3462] = {
    [sym_concatenation] = STATE(3839),
    [sym_string] = STATE(730),
    [sym_simple_expansion] = STATE(730),
    [sym_string_expansion] = STATE(730),
    [sym_expansion] = STATE(730),
    [sym_command_substitution] = STATE(730),
    [sym_process_substitution] = STATE(730),
    [aux_sym_for_statement_repeat1] = STATE(3839),
    [aux_sym__literal_repeat1] = STATE(736),
    [anon_sym_RPAREN] = ACTIONS(8690),
    [anon_sym_DOLLAR] = ACTIONS(1406),
    [sym__special_character] = ACTIONS(1408),
    [anon_sym_DQUOTE] = ACTIONS(1410),
    [sym_raw_string] = ACTIONS(1412),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1414),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1416),
    [anon_sym_BQUOTE] = ACTIONS(1418),
    [anon_sym_LT_LPAREN] = ACTIONS(1420),
    [anon_sym_GT_LPAREN] = ACTIONS(1420),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1412),
  },
  [3463] = {
    [aux_sym_concatenation_repeat1] = STATE(2947),
    [sym__simple_heredoc_body] = ACTIONS(1400),
    [sym__heredoc_body_beginning] = ACTIONS(1400),
    [sym_file_descriptor] = ACTIONS(1400),
    [sym__concat] = ACTIONS(6495),
    [sym_variable_name] = ACTIONS(1400),
    [anon_sym_SEMI] = ACTIONS(1402),
    [anon_sym_fi] = ACTIONS(1402),
    [anon_sym_PIPE] = ACTIONS(1402),
    [anon_sym_SEMI_SEMI] = ACTIONS(1400),
    [anon_sym_PIPE_AMP] = ACTIONS(1400),
    [anon_sym_AMP_AMP] = ACTIONS(1400),
    [anon_sym_PIPE_PIPE] = ACTIONS(1400),
    [anon_sym_LT] = ACTIONS(1402),
    [anon_sym_GT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT] = ACTIONS(1402),
    [anon_sym_AMP_GT_GT] = ACTIONS(1400),
    [anon_sym_LT_AMP] = ACTIONS(1400),
    [anon_sym_GT_AMP] = ACTIONS(1400),
    [anon_sym_LT_LT] = ACTIONS(1402),
    [anon_sym_LT_LT_DASH] = ACTIONS(1400),
    [anon_sym_LT_LT_LT] = ACTIONS(1400),
    [anon_sym_DOLLAR] = ACTIONS(1402),
    [sym__special_character] = ACTIONS(1400),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1400),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1400),
    [anon_sym_BQUOTE] = ACTIONS(1400),
    [anon_sym_LT_LPAREN] = ACTIONS(1400),
    [anon_sym_GT_LPAREN] = ACTIONS(1400),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1402),
    [sym_word] = ACTIONS(1402),
    [anon_sym_LF] = ACTIONS(1400),
    [anon_sym_AMP] = ACTIONS(1402),
  },
  [3464] = {
    [aux_sym__literal_repeat1] = STATE(2961),
    [sym__simple_heredoc_body] = ACTIONS(1446),
    [sym__heredoc_body_beginning] = ACTIONS(1446),
    [sym_file_descriptor] = ACTIONS(1446),
    [sym_variable_name] = ACTIONS(1446),
    [anon_sym_SEMI] = ACTIONS(1448),
    [anon_sym_fi] = ACTIONS(1448),
    [anon_sym_PIPE] = ACTIONS(1448),
    [anon_sym_SEMI_SEMI] = ACTIONS(1446),
    [anon_sym_PIPE_AMP] = ACTIONS(1446),
    [anon_sym_AMP_AMP] = ACTIONS(1446),
    [anon_sym_PIPE_PIPE] = ACTIONS(1446),
    [anon_sym_LT] = ACTIONS(1448),
    [anon_sym_GT] = ACTIONS(1448),
    [anon_sym_GT_GT] = ACTIONS(1446),
    [anon_sym_AMP_GT] = ACTIONS(1448),
    [anon_sym_AMP_GT_GT] = ACTIONS(1446),
    [anon_sym_LT_AMP] = ACTIONS(1446),
    [anon_sym_GT_AMP] = ACTIONS(1446),
    [anon_sym_LT_LT] = ACTIONS(1448),
    [anon_sym_LT_LT_DASH] = ACTIONS(1446),
    [anon_sym_LT_LT_LT] = ACTIONS(1446),
    [anon_sym_DOLLAR] = ACTIONS(1448),
    [sym__special_character] = ACTIONS(6513),
    [anon_sym_DQUOTE] = ACTIONS(1446),
    [sym_raw_string] = ACTIONS(1446),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1446),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1446),
    [anon_sym_BQUOTE] = ACTIONS(1446),
    [anon_sym_LT_LPAREN] = ACTIONS(1446),
    [anon_sym_GT_LPAREN] = ACTIONS(1446),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1448),
    [sym_word] = ACTIONS(1448),
    [anon_sym_LF] = ACTIONS(1446),
    [anon_sym_AMP] = ACTIONS(1448),
  },
  [3465] = {
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(2362),
    [sym_variable_name] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_fi] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2364),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [3466] = {
    [sym_string] = STATE(3465),
    [sym_simple_expansion] = STATE(3465),
    [sym_string_expansion] = STATE(3465),
    [sym_expansion] = STATE(3465),
    [sym_command_substitution] = STATE(3465),
    [sym_process_substitution] = STATE(3465),
    [anon_sym_DOLLAR] = ACTIONS(8692),
    [sym__special_character] = ACTIONS(7731),
    [anon_sym_DQUOTE] = ACTIONS(5063),
    [sym_raw_string] = ACTIONS(7731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5067),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5069),
    [anon_sym_BQUOTE] = ACTIONS(5071),
    [anon_sym_LT_LPAREN] = ACTIONS(5073),
    [anon_sym_GT_LPAREN] = ACTIONS(5073),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7731),
  },
  [3467] = {
    [aux_sym_concatenation_repeat1] = STATE(3467),
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(8694),
    [sym_variable_name] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_fi] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2364),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [3468] = {
    [sym__simple_heredoc_body] = ACTIONS(2371),
    [sym__heredoc_body_beginning] = ACTIONS(2371),
    [sym_file_descriptor] = ACTIONS(2371),
    [sym__concat] = ACTIONS(2371),
    [sym_variable_name] = ACTIONS(2371),
    [anon_sym_SEMI] = ACTIONS(2373),
    [anon_sym_fi] = ACTIONS(2373),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_SEMI_SEMI] = ACTIONS(2371),
    [anon_sym_PIPE_AMP] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_GT_GT] = ACTIONS(2371),
    [anon_sym_AMP_GT] = ACTIONS(2373),
    [anon_sym_AMP_GT_GT] = ACTIONS(2371),
    [anon_sym_LT_AMP] = ACTIONS(2371),
    [anon_sym_GT_AMP] = ACTIONS(2371),
    [anon_sym_LT_LT] = ACTIONS(2373),
    [anon_sym_LT_LT_DASH] = ACTIONS(2371),
    [anon_sym_LT_LT_LT] = ACTIONS(2371),
    [anon_sym_DOLLAR] = ACTIONS(2373),
    [sym__special_character] = ACTIONS(2371),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [sym_raw_string] = ACTIONS(2371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2371),
    [anon_sym_BQUOTE] = ACTIONS(2371),
    [anon_sym_LT_LPAREN] = ACTIONS(2371),
    [anon_sym_GT_LPAREN] = ACTIONS(2371),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2373),
    [sym_word] = ACTIONS(2373),
    [anon_sym_LF] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
  },
  [3469] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(8697),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [3470] = {
    [sym_concatenation] = STATE(3844),
    [sym_string] = STATE(3843),
    [sym_simple_expansion] = STATE(3843),
    [sym_string_expansion] = STATE(3843),
    [sym_expansion] = STATE(3843),
    [sym_command_substitution] = STATE(3843),
    [sym_process_substitution] = STATE(3843),
    [aux_sym__literal_repeat1] = STATE(3845),
    [anon_sym_RBRACE] = ACTIONS(8699),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(8701),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8701),
  },
  [3471] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(8703),
    [sym_comment] = ACTIONS(57),
  },
  [3472] = {
    [sym_concatenation] = STATE(3849),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3849),
    [anon_sym_RBRACE] = ACTIONS(8705),
    [anon_sym_EQ] = ACTIONS(8707),
    [anon_sym_DASH] = ACTIONS(8707),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8709),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(8711),
    [anon_sym_COLON] = ACTIONS(8707),
    [anon_sym_COLON_QMARK] = ACTIONS(8707),
    [anon_sym_COLON_DASH] = ACTIONS(8707),
    [anon_sym_PERCENT] = ACTIONS(8707),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3473] = {
    [sym_concatenation] = STATE(3851),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3851),
    [anon_sym_RBRACE] = ACTIONS(8699),
    [anon_sym_EQ] = ACTIONS(8713),
    [anon_sym_DASH] = ACTIONS(8713),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8715),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(8717),
    [anon_sym_COLON] = ACTIONS(8713),
    [anon_sym_COLON_QMARK] = ACTIONS(8713),
    [anon_sym_COLON_DASH] = ACTIONS(8713),
    [anon_sym_PERCENT] = ACTIONS(8713),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3474] = {
    [sym__simple_heredoc_body] = ACTIONS(2462),
    [sym__heredoc_body_beginning] = ACTIONS(2462),
    [sym_file_descriptor] = ACTIONS(2462),
    [sym__concat] = ACTIONS(2462),
    [sym_variable_name] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_fi] = ACTIONS(2464),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_SEMI_SEMI] = ACTIONS(2462),
    [anon_sym_PIPE_AMP] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_GT_GT] = ACTIONS(2462),
    [anon_sym_AMP_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT_GT] = ACTIONS(2462),
    [anon_sym_LT_AMP] = ACTIONS(2462),
    [anon_sym_GT_AMP] = ACTIONS(2462),
    [anon_sym_LT_LT] = ACTIONS(2464),
    [anon_sym_LT_LT_DASH] = ACTIONS(2462),
    [anon_sym_LT_LT_LT] = ACTIONS(2462),
    [anon_sym_DOLLAR] = ACTIONS(2464),
    [sym__special_character] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [sym_raw_string] = ACTIONS(2462),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2462),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2462),
    [anon_sym_BQUOTE] = ACTIONS(2462),
    [anon_sym_LT_LPAREN] = ACTIONS(2462),
    [anon_sym_GT_LPAREN] = ACTIONS(2462),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2464),
    [sym_word] = ACTIONS(2464),
    [anon_sym_LF] = ACTIONS(2462),
    [anon_sym_AMP] = ACTIONS(2464),
  },
  [3475] = {
    [sym_concatenation] = STATE(3854),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3854),
    [sym_regex] = ACTIONS(8719),
    [anon_sym_RBRACE] = ACTIONS(8721),
    [anon_sym_EQ] = ACTIONS(8723),
    [anon_sym_DASH] = ACTIONS(8723),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8725),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8723),
    [anon_sym_COLON_QMARK] = ACTIONS(8723),
    [anon_sym_COLON_DASH] = ACTIONS(8723),
    [anon_sym_PERCENT] = ACTIONS(8723),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3476] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8721),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3477] = {
    [sym__simple_heredoc_body] = ACTIONS(2512),
    [sym__heredoc_body_beginning] = ACTIONS(2512),
    [sym_file_descriptor] = ACTIONS(2512),
    [sym__concat] = ACTIONS(2512),
    [sym_variable_name] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2514),
    [anon_sym_fi] = ACTIONS(2514),
    [anon_sym_PIPE] = ACTIONS(2514),
    [anon_sym_SEMI_SEMI] = ACTIONS(2512),
    [anon_sym_PIPE_AMP] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE_PIPE] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2514),
    [anon_sym_GT] = ACTIONS(2514),
    [anon_sym_GT_GT] = ACTIONS(2512),
    [anon_sym_AMP_GT] = ACTIONS(2514),
    [anon_sym_AMP_GT_GT] = ACTIONS(2512),
    [anon_sym_LT_AMP] = ACTIONS(2512),
    [anon_sym_GT_AMP] = ACTIONS(2512),
    [anon_sym_LT_LT] = ACTIONS(2514),
    [anon_sym_LT_LT_DASH] = ACTIONS(2512),
    [anon_sym_LT_LT_LT] = ACTIONS(2512),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [sym__special_character] = ACTIONS(2512),
    [anon_sym_DQUOTE] = ACTIONS(2512),
    [sym_raw_string] = ACTIONS(2512),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2512),
    [anon_sym_BQUOTE] = ACTIONS(2512),
    [anon_sym_LT_LPAREN] = ACTIONS(2512),
    [anon_sym_GT_LPAREN] = ACTIONS(2512),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2514),
    [sym_word] = ACTIONS(2514),
    [anon_sym_LF] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2514),
  },
  [3478] = {
    [sym_concatenation] = STATE(3851),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3851),
    [sym_regex] = ACTIONS(8727),
    [anon_sym_RBRACE] = ACTIONS(8699),
    [anon_sym_EQ] = ACTIONS(8713),
    [anon_sym_DASH] = ACTIONS(8713),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8715),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8713),
    [anon_sym_COLON_QMARK] = ACTIONS(8713),
    [anon_sym_COLON_DASH] = ACTIONS(8713),
    [anon_sym_PERCENT] = ACTIONS(8713),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3479] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8699),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3480] = {
    [sym__simple_heredoc_body] = ACTIONS(2520),
    [sym__heredoc_body_beginning] = ACTIONS(2520),
    [sym_file_descriptor] = ACTIONS(2520),
    [sym__concat] = ACTIONS(2520),
    [sym_variable_name] = ACTIONS(2520),
    [anon_sym_SEMI] = ACTIONS(2522),
    [anon_sym_fi] = ACTIONS(2522),
    [anon_sym_PIPE] = ACTIONS(2522),
    [anon_sym_SEMI_SEMI] = ACTIONS(2520),
    [anon_sym_PIPE_AMP] = ACTIONS(2520),
    [anon_sym_AMP_AMP] = ACTIONS(2520),
    [anon_sym_PIPE_PIPE] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(2522),
    [anon_sym_GT] = ACTIONS(2522),
    [anon_sym_GT_GT] = ACTIONS(2520),
    [anon_sym_AMP_GT] = ACTIONS(2522),
    [anon_sym_AMP_GT_GT] = ACTIONS(2520),
    [anon_sym_LT_AMP] = ACTIONS(2520),
    [anon_sym_GT_AMP] = ACTIONS(2520),
    [anon_sym_LT_LT] = ACTIONS(2522),
    [anon_sym_LT_LT_DASH] = ACTIONS(2520),
    [anon_sym_LT_LT_LT] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(2522),
    [sym__special_character] = ACTIONS(2520),
    [anon_sym_DQUOTE] = ACTIONS(2520),
    [sym_raw_string] = ACTIONS(2520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2520),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2520),
    [anon_sym_BQUOTE] = ACTIONS(2520),
    [anon_sym_LT_LPAREN] = ACTIONS(2520),
    [anon_sym_GT_LPAREN] = ACTIONS(2520),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2522),
    [sym_word] = ACTIONS(2522),
    [anon_sym_LF] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2522),
  },
  [3481] = {
    [sym__simple_heredoc_body] = ACTIONS(2554),
    [sym__heredoc_body_beginning] = ACTIONS(2554),
    [sym_file_descriptor] = ACTIONS(2554),
    [sym__concat] = ACTIONS(2554),
    [sym_variable_name] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(2556),
    [anon_sym_fi] = ACTIONS(2556),
    [anon_sym_PIPE] = ACTIONS(2556),
    [anon_sym_SEMI_SEMI] = ACTIONS(2554),
    [anon_sym_PIPE_AMP] = ACTIONS(2554),
    [anon_sym_AMP_AMP] = ACTIONS(2554),
    [anon_sym_PIPE_PIPE] = ACTIONS(2554),
    [anon_sym_LT] = ACTIONS(2556),
    [anon_sym_GT] = ACTIONS(2556),
    [anon_sym_GT_GT] = ACTIONS(2554),
    [anon_sym_AMP_GT] = ACTIONS(2556),
    [anon_sym_AMP_GT_GT] = ACTIONS(2554),
    [anon_sym_LT_AMP] = ACTIONS(2554),
    [anon_sym_GT_AMP] = ACTIONS(2554),
    [anon_sym_LT_LT] = ACTIONS(2556),
    [anon_sym_LT_LT_DASH] = ACTIONS(2554),
    [anon_sym_LT_LT_LT] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2556),
    [sym__special_character] = ACTIONS(2554),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2554),
    [anon_sym_BQUOTE] = ACTIONS(2554),
    [anon_sym_LT_LPAREN] = ACTIONS(2554),
    [anon_sym_GT_LPAREN] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2556),
    [sym_word] = ACTIONS(2556),
    [anon_sym_LF] = ACTIONS(2554),
    [anon_sym_AMP] = ACTIONS(2556),
  },
  [3482] = {
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_fi] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2364),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [3483] = {
    [sym_string] = STATE(3482),
    [sym_simple_expansion] = STATE(3482),
    [sym_string_expansion] = STATE(3482),
    [sym_expansion] = STATE(3482),
    [sym_command_substitution] = STATE(3482),
    [sym_process_substitution] = STATE(3482),
    [anon_sym_DOLLAR] = ACTIONS(8729),
    [sym__special_character] = ACTIONS(7805),
    [anon_sym_DQUOTE] = ACTIONS(5083),
    [sym_raw_string] = ACTIONS(7805),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5089),
    [anon_sym_BQUOTE] = ACTIONS(5091),
    [anon_sym_LT_LPAREN] = ACTIONS(5093),
    [anon_sym_GT_LPAREN] = ACTIONS(5093),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7805),
  },
  [3484] = {
    [aux_sym_concatenation_repeat1] = STATE(3484),
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(8731),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_fi] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2364),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [3485] = {
    [sym__simple_heredoc_body] = ACTIONS(2371),
    [sym__heredoc_body_beginning] = ACTIONS(2371),
    [sym_file_descriptor] = ACTIONS(2371),
    [sym__concat] = ACTIONS(2371),
    [anon_sym_SEMI] = ACTIONS(2373),
    [anon_sym_fi] = ACTIONS(2373),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_SEMI_SEMI] = ACTIONS(2371),
    [anon_sym_PIPE_AMP] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_GT_GT] = ACTIONS(2371),
    [anon_sym_AMP_GT] = ACTIONS(2373),
    [anon_sym_AMP_GT_GT] = ACTIONS(2371),
    [anon_sym_LT_AMP] = ACTIONS(2371),
    [anon_sym_GT_AMP] = ACTIONS(2371),
    [anon_sym_LT_LT] = ACTIONS(2373),
    [anon_sym_LT_LT_DASH] = ACTIONS(2371),
    [anon_sym_LT_LT_LT] = ACTIONS(2371),
    [anon_sym_DOLLAR] = ACTIONS(2373),
    [sym__special_character] = ACTIONS(2371),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [sym_raw_string] = ACTIONS(2371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2371),
    [anon_sym_BQUOTE] = ACTIONS(2371),
    [anon_sym_LT_LPAREN] = ACTIONS(2371),
    [anon_sym_GT_LPAREN] = ACTIONS(2371),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2373),
    [sym_word] = ACTIONS(2373),
    [anon_sym_LF] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
  },
  [3486] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(8734),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [3487] = {
    [sym_concatenation] = STATE(3860),
    [sym_string] = STATE(3859),
    [sym_simple_expansion] = STATE(3859),
    [sym_string_expansion] = STATE(3859),
    [sym_expansion] = STATE(3859),
    [sym_command_substitution] = STATE(3859),
    [sym_process_substitution] = STATE(3859),
    [aux_sym__literal_repeat1] = STATE(3861),
    [anon_sym_RBRACE] = ACTIONS(8736),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(8738),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8738),
  },
  [3488] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(8740),
    [sym_comment] = ACTIONS(57),
  },
  [3489] = {
    [sym_concatenation] = STATE(3865),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3865),
    [anon_sym_RBRACE] = ACTIONS(8742),
    [anon_sym_EQ] = ACTIONS(8744),
    [anon_sym_DASH] = ACTIONS(8744),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8746),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(8748),
    [anon_sym_COLON] = ACTIONS(8744),
    [anon_sym_COLON_QMARK] = ACTIONS(8744),
    [anon_sym_COLON_DASH] = ACTIONS(8744),
    [anon_sym_PERCENT] = ACTIONS(8744),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3490] = {
    [sym_concatenation] = STATE(3867),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3867),
    [anon_sym_RBRACE] = ACTIONS(8736),
    [anon_sym_EQ] = ACTIONS(8750),
    [anon_sym_DASH] = ACTIONS(8750),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8752),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(8754),
    [anon_sym_COLON] = ACTIONS(8750),
    [anon_sym_COLON_QMARK] = ACTIONS(8750),
    [anon_sym_COLON_DASH] = ACTIONS(8750),
    [anon_sym_PERCENT] = ACTIONS(8750),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3491] = {
    [sym__simple_heredoc_body] = ACTIONS(2462),
    [sym__heredoc_body_beginning] = ACTIONS(2462),
    [sym_file_descriptor] = ACTIONS(2462),
    [sym__concat] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_fi] = ACTIONS(2464),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_SEMI_SEMI] = ACTIONS(2462),
    [anon_sym_PIPE_AMP] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_GT_GT] = ACTIONS(2462),
    [anon_sym_AMP_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT_GT] = ACTIONS(2462),
    [anon_sym_LT_AMP] = ACTIONS(2462),
    [anon_sym_GT_AMP] = ACTIONS(2462),
    [anon_sym_LT_LT] = ACTIONS(2464),
    [anon_sym_LT_LT_DASH] = ACTIONS(2462),
    [anon_sym_LT_LT_LT] = ACTIONS(2462),
    [anon_sym_DOLLAR] = ACTIONS(2464),
    [sym__special_character] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [sym_raw_string] = ACTIONS(2462),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2462),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2462),
    [anon_sym_BQUOTE] = ACTIONS(2462),
    [anon_sym_LT_LPAREN] = ACTIONS(2462),
    [anon_sym_GT_LPAREN] = ACTIONS(2462),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2464),
    [sym_word] = ACTIONS(2464),
    [anon_sym_LF] = ACTIONS(2462),
    [anon_sym_AMP] = ACTIONS(2464),
  },
  [3492] = {
    [sym_concatenation] = STATE(3870),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3870),
    [sym_regex] = ACTIONS(8756),
    [anon_sym_RBRACE] = ACTIONS(8758),
    [anon_sym_EQ] = ACTIONS(8760),
    [anon_sym_DASH] = ACTIONS(8760),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8762),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8760),
    [anon_sym_COLON_QMARK] = ACTIONS(8760),
    [anon_sym_COLON_DASH] = ACTIONS(8760),
    [anon_sym_PERCENT] = ACTIONS(8760),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3493] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8758),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3494] = {
    [sym__simple_heredoc_body] = ACTIONS(2512),
    [sym__heredoc_body_beginning] = ACTIONS(2512),
    [sym_file_descriptor] = ACTIONS(2512),
    [sym__concat] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2514),
    [anon_sym_fi] = ACTIONS(2514),
    [anon_sym_PIPE] = ACTIONS(2514),
    [anon_sym_SEMI_SEMI] = ACTIONS(2512),
    [anon_sym_PIPE_AMP] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE_PIPE] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2514),
    [anon_sym_GT] = ACTIONS(2514),
    [anon_sym_GT_GT] = ACTIONS(2512),
    [anon_sym_AMP_GT] = ACTIONS(2514),
    [anon_sym_AMP_GT_GT] = ACTIONS(2512),
    [anon_sym_LT_AMP] = ACTIONS(2512),
    [anon_sym_GT_AMP] = ACTIONS(2512),
    [anon_sym_LT_LT] = ACTIONS(2514),
    [anon_sym_LT_LT_DASH] = ACTIONS(2512),
    [anon_sym_LT_LT_LT] = ACTIONS(2512),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [sym__special_character] = ACTIONS(2512),
    [anon_sym_DQUOTE] = ACTIONS(2512),
    [sym_raw_string] = ACTIONS(2512),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2512),
    [anon_sym_BQUOTE] = ACTIONS(2512),
    [anon_sym_LT_LPAREN] = ACTIONS(2512),
    [anon_sym_GT_LPAREN] = ACTIONS(2512),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2514),
    [sym_word] = ACTIONS(2514),
    [anon_sym_LF] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2514),
  },
  [3495] = {
    [sym_concatenation] = STATE(3867),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3867),
    [sym_regex] = ACTIONS(8764),
    [anon_sym_RBRACE] = ACTIONS(8736),
    [anon_sym_EQ] = ACTIONS(8750),
    [anon_sym_DASH] = ACTIONS(8750),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8752),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8750),
    [anon_sym_COLON_QMARK] = ACTIONS(8750),
    [anon_sym_COLON_DASH] = ACTIONS(8750),
    [anon_sym_PERCENT] = ACTIONS(8750),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3496] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8736),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3497] = {
    [sym__simple_heredoc_body] = ACTIONS(2520),
    [sym__heredoc_body_beginning] = ACTIONS(2520),
    [sym_file_descriptor] = ACTIONS(2520),
    [sym__concat] = ACTIONS(2520),
    [anon_sym_SEMI] = ACTIONS(2522),
    [anon_sym_fi] = ACTIONS(2522),
    [anon_sym_PIPE] = ACTIONS(2522),
    [anon_sym_SEMI_SEMI] = ACTIONS(2520),
    [anon_sym_PIPE_AMP] = ACTIONS(2520),
    [anon_sym_AMP_AMP] = ACTIONS(2520),
    [anon_sym_PIPE_PIPE] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(2522),
    [anon_sym_GT] = ACTIONS(2522),
    [anon_sym_GT_GT] = ACTIONS(2520),
    [anon_sym_AMP_GT] = ACTIONS(2522),
    [anon_sym_AMP_GT_GT] = ACTIONS(2520),
    [anon_sym_LT_AMP] = ACTIONS(2520),
    [anon_sym_GT_AMP] = ACTIONS(2520),
    [anon_sym_LT_LT] = ACTIONS(2522),
    [anon_sym_LT_LT_DASH] = ACTIONS(2520),
    [anon_sym_LT_LT_LT] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(2522),
    [sym__special_character] = ACTIONS(2520),
    [anon_sym_DQUOTE] = ACTIONS(2520),
    [sym_raw_string] = ACTIONS(2520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2520),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2520),
    [anon_sym_BQUOTE] = ACTIONS(2520),
    [anon_sym_LT_LPAREN] = ACTIONS(2520),
    [anon_sym_GT_LPAREN] = ACTIONS(2520),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2522),
    [sym_word] = ACTIONS(2522),
    [anon_sym_LF] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2522),
  },
  [3498] = {
    [sym__simple_heredoc_body] = ACTIONS(2554),
    [sym__heredoc_body_beginning] = ACTIONS(2554),
    [sym_file_descriptor] = ACTIONS(2554),
    [sym__concat] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(2556),
    [anon_sym_fi] = ACTIONS(2556),
    [anon_sym_PIPE] = ACTIONS(2556),
    [anon_sym_SEMI_SEMI] = ACTIONS(2554),
    [anon_sym_PIPE_AMP] = ACTIONS(2554),
    [anon_sym_AMP_AMP] = ACTIONS(2554),
    [anon_sym_PIPE_PIPE] = ACTIONS(2554),
    [anon_sym_LT] = ACTIONS(2556),
    [anon_sym_GT] = ACTIONS(2556),
    [anon_sym_GT_GT] = ACTIONS(2554),
    [anon_sym_AMP_GT] = ACTIONS(2556),
    [anon_sym_AMP_GT_GT] = ACTIONS(2554),
    [anon_sym_LT_AMP] = ACTIONS(2554),
    [anon_sym_GT_AMP] = ACTIONS(2554),
    [anon_sym_LT_LT] = ACTIONS(2556),
    [anon_sym_LT_LT_DASH] = ACTIONS(2554),
    [anon_sym_LT_LT_LT] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2556),
    [sym__special_character] = ACTIONS(2554),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2554),
    [anon_sym_BQUOTE] = ACTIONS(2554),
    [anon_sym_LT_LPAREN] = ACTIONS(2554),
    [anon_sym_GT_LPAREN] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2556),
    [sym_word] = ACTIONS(2556),
    [anon_sym_LF] = ACTIONS(2554),
    [anon_sym_AMP] = ACTIONS(2556),
  },
  [3499] = {
    [sym_string] = STATE(2328),
    [sym__simple_heredoc_body] = ACTIONS(4071),
    [sym__heredoc_body_beginning] = ACTIONS(4071),
    [sym_file_descriptor] = ACTIONS(4071),
    [anon_sym_SEMI] = ACTIONS(4073),
    [anon_sym_fi] = ACTIONS(4073),
    [anon_sym_PIPE] = ACTIONS(4073),
    [anon_sym_SEMI_SEMI] = ACTIONS(4071),
    [anon_sym_PIPE_AMP] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_PIPE_PIPE] = ACTIONS(4071),
    [anon_sym_EQ_TILDE] = ACTIONS(4073),
    [anon_sym_EQ_EQ] = ACTIONS(4073),
    [anon_sym_LT] = ACTIONS(4073),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_GT_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT] = ACTIONS(4073),
    [anon_sym_AMP_GT_GT] = ACTIONS(4071),
    [anon_sym_LT_AMP] = ACTIONS(4071),
    [anon_sym_GT_AMP] = ACTIONS(4071),
    [anon_sym_LT_LT] = ACTIONS(4073),
    [anon_sym_LT_LT_DASH] = ACTIONS(4071),
    [anon_sym_LT_LT_LT] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(8766),
    [anon_sym_DOLLAR] = ACTIONS(8766),
    [sym__special_character] = ACTIONS(4071),
    [anon_sym_DQUOTE] = ACTIONS(3395),
    [sym_raw_string] = ACTIONS(5101),
    [anon_sym_POUND] = ACTIONS(5099),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4071),
    [anon_sym_BQUOTE] = ACTIONS(4071),
    [anon_sym_LT_LPAREN] = ACTIONS(4071),
    [anon_sym_GT_LPAREN] = ACTIONS(4071),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5103),
    [anon_sym_STAR] = ACTIONS(5103),
    [anon_sym_AT] = ACTIONS(5103),
    [anon_sym_QMARK] = ACTIONS(5103),
    [anon_sym_0] = ACTIONS(5103),
    [anon_sym__] = ACTIONS(5103),
    [sym_word] = ACTIONS(4073),
    [anon_sym_LF] = ACTIONS(4071),
    [anon_sym_AMP] = ACTIONS(4073),
  },
  [3500] = {
    [sym__simple_heredoc_body] = ACTIONS(4111),
    [sym__heredoc_body_beginning] = ACTIONS(4111),
    [sym_file_descriptor] = ACTIONS(4111),
    [sym__concat] = ACTIONS(4111),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_fi] = ACTIONS(4113),
    [anon_sym_PIPE] = ACTIONS(4113),
    [anon_sym_SEMI_SEMI] = ACTIONS(4111),
    [anon_sym_PIPE_AMP] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_EQ_TILDE] = ACTIONS(4113),
    [anon_sym_EQ_EQ] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4113),
    [anon_sym_GT_GT] = ACTIONS(4111),
    [anon_sym_AMP_GT] = ACTIONS(4113),
    [anon_sym_AMP_GT_GT] = ACTIONS(4111),
    [anon_sym_LT_AMP] = ACTIONS(4111),
    [anon_sym_GT_AMP] = ACTIONS(4111),
    [anon_sym_LT_LT] = ACTIONS(4113),
    [anon_sym_LT_LT_DASH] = ACTIONS(4111),
    [anon_sym_LT_LT_LT] = ACTIONS(4111),
    [anon_sym_DOLLAR] = ACTIONS(4113),
    [sym__special_character] = ACTIONS(4111),
    [anon_sym_DQUOTE] = ACTIONS(4111),
    [sym_raw_string] = ACTIONS(4111),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4111),
    [anon_sym_BQUOTE] = ACTIONS(4111),
    [anon_sym_LT_LPAREN] = ACTIONS(4111),
    [anon_sym_GT_LPAREN] = ACTIONS(4111),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4113),
    [anon_sym_LF] = ACTIONS(4111),
    [anon_sym_AMP] = ACTIONS(4113),
  },
  [3501] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_fi] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_EQ_TILDE] = ACTIONS(4127),
    [anon_sym_EQ_EQ] = ACTIONS(4127),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym__special_character] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [3502] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(8768),
    [sym_comment] = ACTIONS(57),
  },
  [3503] = {
    [anon_sym_RBRACE] = ACTIONS(8768),
    [sym_comment] = ACTIONS(57),
  },
  [3504] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(8770),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [3505] = {
    [sym_concatenation] = STATE(3875),
    [sym_string] = STATE(3874),
    [sym_simple_expansion] = STATE(3874),
    [sym_string_expansion] = STATE(3874),
    [sym_expansion] = STATE(3874),
    [sym_command_substitution] = STATE(3874),
    [sym_process_substitution] = STATE(3874),
    [aux_sym__literal_repeat1] = STATE(3876),
    [anon_sym_RBRACE] = ACTIONS(8768),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(8772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8772),
  },
  [3506] = {
    [sym__simple_heredoc_body] = ACTIONS(4161),
    [sym__heredoc_body_beginning] = ACTIONS(4161),
    [sym_file_descriptor] = ACTIONS(4161),
    [sym__concat] = ACTIONS(4161),
    [anon_sym_SEMI] = ACTIONS(4163),
    [anon_sym_fi] = ACTIONS(4163),
    [anon_sym_PIPE] = ACTIONS(4163),
    [anon_sym_SEMI_SEMI] = ACTIONS(4161),
    [anon_sym_PIPE_AMP] = ACTIONS(4161),
    [anon_sym_AMP_AMP] = ACTIONS(4161),
    [anon_sym_PIPE_PIPE] = ACTIONS(4161),
    [anon_sym_EQ_TILDE] = ACTIONS(4163),
    [anon_sym_EQ_EQ] = ACTIONS(4163),
    [anon_sym_LT] = ACTIONS(4163),
    [anon_sym_GT] = ACTIONS(4163),
    [anon_sym_GT_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT] = ACTIONS(4163),
    [anon_sym_AMP_GT_GT] = ACTIONS(4161),
    [anon_sym_LT_AMP] = ACTIONS(4161),
    [anon_sym_GT_AMP] = ACTIONS(4161),
    [anon_sym_LT_LT] = ACTIONS(4163),
    [anon_sym_LT_LT_DASH] = ACTIONS(4161),
    [anon_sym_LT_LT_LT] = ACTIONS(4161),
    [anon_sym_DOLLAR] = ACTIONS(4163),
    [sym__special_character] = ACTIONS(4161),
    [anon_sym_DQUOTE] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4161),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4161),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4161),
    [anon_sym_BQUOTE] = ACTIONS(4161),
    [anon_sym_LT_LPAREN] = ACTIONS(4161),
    [anon_sym_GT_LPAREN] = ACTIONS(4161),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4163),
    [anon_sym_LF] = ACTIONS(4161),
    [anon_sym_AMP] = ACTIONS(4163),
  },
  [3507] = {
    [sym_concatenation] = STATE(3879),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3879),
    [sym_regex] = ACTIONS(8774),
    [anon_sym_RBRACE] = ACTIONS(8776),
    [anon_sym_EQ] = ACTIONS(8778),
    [anon_sym_DASH] = ACTIONS(8778),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8780),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8778),
    [anon_sym_COLON_QMARK] = ACTIONS(8778),
    [anon_sym_COLON_DASH] = ACTIONS(8778),
    [anon_sym_PERCENT] = ACTIONS(8778),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3508] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8776),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3509] = {
    [sym_concatenation] = STATE(3881),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3881),
    [sym_regex] = ACTIONS(8782),
    [anon_sym_RBRACE] = ACTIONS(8768),
    [anon_sym_EQ] = ACTIONS(8784),
    [anon_sym_DASH] = ACTIONS(8784),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8786),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8784),
    [anon_sym_COLON_QMARK] = ACTIONS(8784),
    [anon_sym_COLON_DASH] = ACTIONS(8784),
    [anon_sym_PERCENT] = ACTIONS(8784),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3510] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8768),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3511] = {
    [sym_concatenation] = STATE(3883),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3883),
    [anon_sym_RBRACE] = ACTIONS(8788),
    [anon_sym_EQ] = ACTIONS(8790),
    [anon_sym_DASH] = ACTIONS(8790),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8792),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8790),
    [anon_sym_COLON_QMARK] = ACTIONS(8790),
    [anon_sym_COLON_DASH] = ACTIONS(8790),
    [anon_sym_PERCENT] = ACTIONS(8790),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3512] = {
    [sym__simple_heredoc_body] = ACTIONS(4219),
    [sym__heredoc_body_beginning] = ACTIONS(4219),
    [sym_file_descriptor] = ACTIONS(4219),
    [sym__concat] = ACTIONS(4219),
    [anon_sym_SEMI] = ACTIONS(4221),
    [anon_sym_fi] = ACTIONS(4221),
    [anon_sym_PIPE] = ACTIONS(4221),
    [anon_sym_SEMI_SEMI] = ACTIONS(4219),
    [anon_sym_PIPE_AMP] = ACTIONS(4219),
    [anon_sym_AMP_AMP] = ACTIONS(4219),
    [anon_sym_PIPE_PIPE] = ACTIONS(4219),
    [anon_sym_EQ_TILDE] = ACTIONS(4221),
    [anon_sym_EQ_EQ] = ACTIONS(4221),
    [anon_sym_LT] = ACTIONS(4221),
    [anon_sym_GT] = ACTIONS(4221),
    [anon_sym_GT_GT] = ACTIONS(4219),
    [anon_sym_AMP_GT] = ACTIONS(4221),
    [anon_sym_AMP_GT_GT] = ACTIONS(4219),
    [anon_sym_LT_AMP] = ACTIONS(4219),
    [anon_sym_GT_AMP] = ACTIONS(4219),
    [anon_sym_LT_LT] = ACTIONS(4221),
    [anon_sym_LT_LT_DASH] = ACTIONS(4219),
    [anon_sym_LT_LT_LT] = ACTIONS(4219),
    [anon_sym_DOLLAR] = ACTIONS(4221),
    [sym__special_character] = ACTIONS(4219),
    [anon_sym_DQUOTE] = ACTIONS(4219),
    [sym_raw_string] = ACTIONS(4219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4219),
    [anon_sym_BQUOTE] = ACTIONS(4219),
    [anon_sym_LT_LPAREN] = ACTIONS(4219),
    [anon_sym_GT_LPAREN] = ACTIONS(4219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4221),
    [anon_sym_LF] = ACTIONS(4219),
    [anon_sym_AMP] = ACTIONS(4221),
  },
  [3513] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8788),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3514] = {
    [sym_concatenation] = STATE(3881),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3881),
    [anon_sym_RBRACE] = ACTIONS(8768),
    [anon_sym_EQ] = ACTIONS(8784),
    [anon_sym_DASH] = ACTIONS(8784),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8786),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8784),
    [anon_sym_COLON_QMARK] = ACTIONS(8784),
    [anon_sym_COLON_DASH] = ACTIONS(8784),
    [anon_sym_PERCENT] = ACTIONS(8784),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3515] = {
    [aux_sym_concatenation_repeat1] = STATE(3517),
    [sym__simple_heredoc_body] = ACTIONS(1380),
    [sym__heredoc_body_beginning] = ACTIONS(1380),
    [sym_file_descriptor] = ACTIONS(1380),
    [sym__concat] = ACTIONS(6367),
    [anon_sym_SEMI] = ACTIONS(1382),
    [anon_sym_fi] = ACTIONS(1380),
    [anon_sym_PIPE] = ACTIONS(1382),
    [anon_sym_SEMI_SEMI] = ACTIONS(1380),
    [anon_sym_PIPE_AMP] = ACTIONS(1380),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_PIPE_PIPE] = ACTIONS(1380),
    [anon_sym_LT] = ACTIONS(1382),
    [anon_sym_GT] = ACTIONS(1382),
    [anon_sym_GT_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT] = ACTIONS(1382),
    [anon_sym_AMP_GT_GT] = ACTIONS(1380),
    [anon_sym_LT_AMP] = ACTIONS(1380),
    [anon_sym_GT_AMP] = ACTIONS(1380),
    [anon_sym_LT_LT] = ACTIONS(1382),
    [anon_sym_LT_LT_DASH] = ACTIONS(1380),
    [anon_sym_LT_LT_LT] = ACTIONS(1380),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1380),
    [anon_sym_AMP] = ACTIONS(1382),
  },
  [3516] = {
    [aux_sym__literal_repeat1] = STATE(3518),
    [sym__simple_heredoc_body] = ACTIONS(1384),
    [sym__heredoc_body_beginning] = ACTIONS(1384),
    [sym_file_descriptor] = ACTIONS(1384),
    [anon_sym_SEMI] = ACTIONS(1386),
    [anon_sym_fi] = ACTIONS(1384),
    [anon_sym_PIPE] = ACTIONS(1386),
    [anon_sym_SEMI_SEMI] = ACTIONS(1384),
    [anon_sym_PIPE_AMP] = ACTIONS(1384),
    [anon_sym_AMP_AMP] = ACTIONS(1384),
    [anon_sym_PIPE_PIPE] = ACTIONS(1384),
    [anon_sym_LT] = ACTIONS(1386),
    [anon_sym_GT] = ACTIONS(1386),
    [anon_sym_GT_GT] = ACTIONS(1384),
    [anon_sym_AMP_GT] = ACTIONS(1386),
    [anon_sym_AMP_GT_GT] = ACTIONS(1384),
    [anon_sym_LT_AMP] = ACTIONS(1384),
    [anon_sym_GT_AMP] = ACTIONS(1384),
    [anon_sym_LT_LT] = ACTIONS(1386),
    [anon_sym_LT_LT_DASH] = ACTIONS(1384),
    [anon_sym_LT_LT_LT] = ACTIONS(1384),
    [sym__special_character] = ACTIONS(6383),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1384),
    [anon_sym_AMP] = ACTIONS(1386),
  },
  [3517] = {
    [aux_sym_concatenation_repeat1] = STATE(3885),
    [sym__simple_heredoc_body] = ACTIONS(1071),
    [sym__heredoc_body_beginning] = ACTIONS(1071),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(8794),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_fi] = ACTIONS(1071),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1075),
  },
  [3518] = {
    [aux_sym__literal_repeat1] = STATE(3518),
    [sym__simple_heredoc_body] = ACTIONS(1373),
    [sym__heredoc_body_beginning] = ACTIONS(1373),
    [sym_file_descriptor] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_fi] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE_AMP] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_LT_LT_DASH] = ACTIONS(1373),
    [anon_sym_LT_LT_LT] = ACTIONS(1373),
    [sym__special_character] = ACTIONS(7647),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
  },
  [3519] = {
    [sym_file_descriptor] = ACTIONS(2604),
    [sym_variable_name] = ACTIONS(2604),
    [anon_sym_for] = ACTIONS(2608),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2608),
    [anon_sym_if] = ACTIONS(2608),
    [anon_sym_fi] = ACTIONS(7650),
    [anon_sym_case] = ACTIONS(2608),
    [anon_sym_function] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(2608),
    [anon_sym_LBRACE] = ACTIONS(2604),
    [anon_sym_BANG] = ACTIONS(2608),
    [anon_sym_LBRACK] = ACTIONS(2608),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2604),
    [anon_sym_declare] = ACTIONS(2608),
    [anon_sym_typeset] = ACTIONS(2608),
    [anon_sym_export] = ACTIONS(2608),
    [anon_sym_readonly] = ACTIONS(2608),
    [anon_sym_local] = ACTIONS(2608),
    [anon_sym_unset] = ACTIONS(2608),
    [anon_sym_unsetenv] = ACTIONS(2608),
    [anon_sym_LT] = ACTIONS(2608),
    [anon_sym_GT] = ACTIONS(2608),
    [anon_sym_GT_GT] = ACTIONS(2604),
    [anon_sym_AMP_GT] = ACTIONS(2608),
    [anon_sym_AMP_GT_GT] = ACTIONS(2604),
    [anon_sym_LT_AMP] = ACTIONS(2604),
    [anon_sym_GT_AMP] = ACTIONS(2604),
    [anon_sym_DOLLAR] = ACTIONS(2608),
    [sym__special_character] = ACTIONS(2608),
    [anon_sym_DQUOTE] = ACTIONS(2604),
    [sym_raw_string] = ACTIONS(2604),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2604),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2604),
    [anon_sym_BQUOTE] = ACTIONS(2604),
    [anon_sym_LT_LPAREN] = ACTIONS(2604),
    [anon_sym_GT_LPAREN] = ACTIONS(2604),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2608),
  },
  [3520] = {
    [sym__simple_heredoc_body] = ACTIONS(2719),
    [sym__heredoc_body_beginning] = ACTIONS(2719),
    [sym_file_descriptor] = ACTIONS(2719),
    [sym_variable_name] = ACTIONS(2719),
    [anon_sym_SEMI] = ACTIONS(2721),
    [anon_sym_fi] = ACTIONS(2721),
    [anon_sym_elif] = ACTIONS(2721),
    [anon_sym_else] = ACTIONS(2721),
    [anon_sym_PIPE] = ACTIONS(2721),
    [anon_sym_SEMI_SEMI] = ACTIONS(2719),
    [anon_sym_PIPE_AMP] = ACTIONS(2719),
    [anon_sym_AMP_AMP] = ACTIONS(2719),
    [anon_sym_PIPE_PIPE] = ACTIONS(2719),
    [anon_sym_LT] = ACTIONS(2721),
    [anon_sym_GT] = ACTIONS(2721),
    [anon_sym_GT_GT] = ACTIONS(2719),
    [anon_sym_AMP_GT] = ACTIONS(2721),
    [anon_sym_AMP_GT_GT] = ACTIONS(2719),
    [anon_sym_LT_AMP] = ACTIONS(2719),
    [anon_sym_GT_AMP] = ACTIONS(2719),
    [anon_sym_LT_LT] = ACTIONS(2721),
    [anon_sym_LT_LT_DASH] = ACTIONS(2719),
    [anon_sym_LT_LT_LT] = ACTIONS(2719),
    [anon_sym_DOLLAR] = ACTIONS(2721),
    [sym__special_character] = ACTIONS(2719),
    [anon_sym_DQUOTE] = ACTIONS(2719),
    [sym_raw_string] = ACTIONS(2719),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2719),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2719),
    [anon_sym_BQUOTE] = ACTIONS(2719),
    [anon_sym_LT_LPAREN] = ACTIONS(2719),
    [anon_sym_GT_LPAREN] = ACTIONS(2719),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2721),
    [sym_word] = ACTIONS(2721),
    [anon_sym_LF] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2721),
  },
  [3521] = {
    [sym_concatenation] = STATE(1368),
    [sym_string] = STATE(730),
    [sym_simple_expansion] = STATE(730),
    [sym_string_expansion] = STATE(730),
    [sym_expansion] = STATE(730),
    [sym_command_substitution] = STATE(730),
    [sym_process_substitution] = STATE(730),
    [aux_sym_for_statement_repeat1] = STATE(1368),
    [aux_sym__literal_repeat1] = STATE(736),
    [anon_sym_RPAREN] = ACTIONS(8796),
    [anon_sym_DOLLAR] = ACTIONS(1406),
    [sym__special_character] = ACTIONS(1408),
    [anon_sym_DQUOTE] = ACTIONS(1410),
    [sym_raw_string] = ACTIONS(1412),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1414),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1416),
    [anon_sym_BQUOTE] = ACTIONS(1418),
    [anon_sym_LT_LPAREN] = ACTIONS(1420),
    [anon_sym_GT_LPAREN] = ACTIONS(1420),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1412),
  },
  [3522] = {
    [sym_string] = STATE(2362),
    [sym__simple_heredoc_body] = ACTIONS(4071),
    [sym__heredoc_body_beginning] = ACTIONS(4071),
    [sym_file_descriptor] = ACTIONS(4071),
    [sym_variable_name] = ACTIONS(4071),
    [anon_sym_SEMI] = ACTIONS(4073),
    [anon_sym_fi] = ACTIONS(4073),
    [anon_sym_elif] = ACTIONS(4073),
    [anon_sym_else] = ACTIONS(4073),
    [anon_sym_PIPE] = ACTIONS(4073),
    [anon_sym_SEMI_SEMI] = ACTIONS(4071),
    [anon_sym_PIPE_AMP] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_PIPE_PIPE] = ACTIONS(4071),
    [anon_sym_LT] = ACTIONS(4073),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_GT_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT] = ACTIONS(4073),
    [anon_sym_AMP_GT_GT] = ACTIONS(4071),
    [anon_sym_LT_AMP] = ACTIONS(4071),
    [anon_sym_GT_AMP] = ACTIONS(4071),
    [anon_sym_LT_LT] = ACTIONS(4073),
    [anon_sym_LT_LT_DASH] = ACTIONS(4071),
    [anon_sym_LT_LT_LT] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(8798),
    [anon_sym_DOLLAR] = ACTIONS(8798),
    [sym__special_character] = ACTIONS(4071),
    [anon_sym_DQUOTE] = ACTIONS(3415),
    [sym_raw_string] = ACTIONS(5157),
    [anon_sym_POUND] = ACTIONS(5155),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4071),
    [anon_sym_BQUOTE] = ACTIONS(4071),
    [anon_sym_LT_LPAREN] = ACTIONS(4071),
    [anon_sym_GT_LPAREN] = ACTIONS(4071),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5159),
    [anon_sym_STAR] = ACTIONS(5159),
    [anon_sym_AT] = ACTIONS(5159),
    [anon_sym_QMARK] = ACTIONS(5159),
    [anon_sym_0] = ACTIONS(5159),
    [anon_sym__] = ACTIONS(5159),
    [sym_word] = ACTIONS(4073),
    [anon_sym_LF] = ACTIONS(4071),
    [anon_sym_AMP] = ACTIONS(4073),
  },
  [3523] = {
    [sym__simple_heredoc_body] = ACTIONS(4111),
    [sym__heredoc_body_beginning] = ACTIONS(4111),
    [sym_file_descriptor] = ACTIONS(4111),
    [sym__concat] = ACTIONS(4111),
    [sym_variable_name] = ACTIONS(4111),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_fi] = ACTIONS(4113),
    [anon_sym_elif] = ACTIONS(4113),
    [anon_sym_else] = ACTIONS(4113),
    [anon_sym_PIPE] = ACTIONS(4113),
    [anon_sym_SEMI_SEMI] = ACTIONS(4111),
    [anon_sym_PIPE_AMP] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_LT] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4113),
    [anon_sym_GT_GT] = ACTIONS(4111),
    [anon_sym_AMP_GT] = ACTIONS(4113),
    [anon_sym_AMP_GT_GT] = ACTIONS(4111),
    [anon_sym_LT_AMP] = ACTIONS(4111),
    [anon_sym_GT_AMP] = ACTIONS(4111),
    [anon_sym_LT_LT] = ACTIONS(4113),
    [anon_sym_LT_LT_DASH] = ACTIONS(4111),
    [anon_sym_LT_LT_LT] = ACTIONS(4111),
    [anon_sym_DOLLAR] = ACTIONS(4113),
    [sym__special_character] = ACTIONS(4111),
    [anon_sym_DQUOTE] = ACTIONS(4111),
    [sym_raw_string] = ACTIONS(4111),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4111),
    [anon_sym_BQUOTE] = ACTIONS(4111),
    [anon_sym_LT_LPAREN] = ACTIONS(4111),
    [anon_sym_GT_LPAREN] = ACTIONS(4111),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4113),
    [sym_word] = ACTIONS(4113),
    [anon_sym_LF] = ACTIONS(4111),
    [anon_sym_AMP] = ACTIONS(4113),
  },
  [3524] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [sym_variable_name] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_fi] = ACTIONS(4127),
    [anon_sym_elif] = ACTIONS(4127),
    [anon_sym_else] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym__special_character] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4127),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [3525] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(8800),
    [sym_comment] = ACTIONS(57),
  },
  [3526] = {
    [anon_sym_RBRACE] = ACTIONS(8800),
    [sym_comment] = ACTIONS(57),
  },
  [3527] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(8802),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [3528] = {
    [sym_concatenation] = STATE(3890),
    [sym_string] = STATE(3889),
    [sym_simple_expansion] = STATE(3889),
    [sym_string_expansion] = STATE(3889),
    [sym_expansion] = STATE(3889),
    [sym_command_substitution] = STATE(3889),
    [sym_process_substitution] = STATE(3889),
    [aux_sym__literal_repeat1] = STATE(3891),
    [anon_sym_RBRACE] = ACTIONS(8800),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(8804),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8804),
  },
  [3529] = {
    [sym__simple_heredoc_body] = ACTIONS(4161),
    [sym__heredoc_body_beginning] = ACTIONS(4161),
    [sym_file_descriptor] = ACTIONS(4161),
    [sym__concat] = ACTIONS(4161),
    [sym_variable_name] = ACTIONS(4161),
    [anon_sym_SEMI] = ACTIONS(4163),
    [anon_sym_fi] = ACTIONS(4163),
    [anon_sym_elif] = ACTIONS(4163),
    [anon_sym_else] = ACTIONS(4163),
    [anon_sym_PIPE] = ACTIONS(4163),
    [anon_sym_SEMI_SEMI] = ACTIONS(4161),
    [anon_sym_PIPE_AMP] = ACTIONS(4161),
    [anon_sym_AMP_AMP] = ACTIONS(4161),
    [anon_sym_PIPE_PIPE] = ACTIONS(4161),
    [anon_sym_LT] = ACTIONS(4163),
    [anon_sym_GT] = ACTIONS(4163),
    [anon_sym_GT_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT] = ACTIONS(4163),
    [anon_sym_AMP_GT_GT] = ACTIONS(4161),
    [anon_sym_LT_AMP] = ACTIONS(4161),
    [anon_sym_GT_AMP] = ACTIONS(4161),
    [anon_sym_LT_LT] = ACTIONS(4163),
    [anon_sym_LT_LT_DASH] = ACTIONS(4161),
    [anon_sym_LT_LT_LT] = ACTIONS(4161),
    [anon_sym_DOLLAR] = ACTIONS(4163),
    [sym__special_character] = ACTIONS(4161),
    [anon_sym_DQUOTE] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4161),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4161),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4161),
    [anon_sym_BQUOTE] = ACTIONS(4161),
    [anon_sym_LT_LPAREN] = ACTIONS(4161),
    [anon_sym_GT_LPAREN] = ACTIONS(4161),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4163),
    [sym_word] = ACTIONS(4163),
    [anon_sym_LF] = ACTIONS(4161),
    [anon_sym_AMP] = ACTIONS(4163),
  },
  [3530] = {
    [sym_concatenation] = STATE(3894),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3894),
    [sym_regex] = ACTIONS(8806),
    [anon_sym_RBRACE] = ACTIONS(8808),
    [anon_sym_EQ] = ACTIONS(8810),
    [anon_sym_DASH] = ACTIONS(8810),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8812),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8810),
    [anon_sym_COLON_QMARK] = ACTIONS(8810),
    [anon_sym_COLON_DASH] = ACTIONS(8810),
    [anon_sym_PERCENT] = ACTIONS(8810),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3531] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8808),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3532] = {
    [sym_concatenation] = STATE(3896),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3896),
    [sym_regex] = ACTIONS(8814),
    [anon_sym_RBRACE] = ACTIONS(8800),
    [anon_sym_EQ] = ACTIONS(8816),
    [anon_sym_DASH] = ACTIONS(8816),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8818),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8816),
    [anon_sym_COLON_QMARK] = ACTIONS(8816),
    [anon_sym_COLON_DASH] = ACTIONS(8816),
    [anon_sym_PERCENT] = ACTIONS(8816),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3533] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8800),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3534] = {
    [sym_concatenation] = STATE(3898),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3898),
    [anon_sym_RBRACE] = ACTIONS(8820),
    [anon_sym_EQ] = ACTIONS(8822),
    [anon_sym_DASH] = ACTIONS(8822),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8824),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8822),
    [anon_sym_COLON_QMARK] = ACTIONS(8822),
    [anon_sym_COLON_DASH] = ACTIONS(8822),
    [anon_sym_PERCENT] = ACTIONS(8822),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3535] = {
    [sym__simple_heredoc_body] = ACTIONS(4219),
    [sym__heredoc_body_beginning] = ACTIONS(4219),
    [sym_file_descriptor] = ACTIONS(4219),
    [sym__concat] = ACTIONS(4219),
    [sym_variable_name] = ACTIONS(4219),
    [anon_sym_SEMI] = ACTIONS(4221),
    [anon_sym_fi] = ACTIONS(4221),
    [anon_sym_elif] = ACTIONS(4221),
    [anon_sym_else] = ACTIONS(4221),
    [anon_sym_PIPE] = ACTIONS(4221),
    [anon_sym_SEMI_SEMI] = ACTIONS(4219),
    [anon_sym_PIPE_AMP] = ACTIONS(4219),
    [anon_sym_AMP_AMP] = ACTIONS(4219),
    [anon_sym_PIPE_PIPE] = ACTIONS(4219),
    [anon_sym_LT] = ACTIONS(4221),
    [anon_sym_GT] = ACTIONS(4221),
    [anon_sym_GT_GT] = ACTIONS(4219),
    [anon_sym_AMP_GT] = ACTIONS(4221),
    [anon_sym_AMP_GT_GT] = ACTIONS(4219),
    [anon_sym_LT_AMP] = ACTIONS(4219),
    [anon_sym_GT_AMP] = ACTIONS(4219),
    [anon_sym_LT_LT] = ACTIONS(4221),
    [anon_sym_LT_LT_DASH] = ACTIONS(4219),
    [anon_sym_LT_LT_LT] = ACTIONS(4219),
    [anon_sym_DOLLAR] = ACTIONS(4221),
    [sym__special_character] = ACTIONS(4219),
    [anon_sym_DQUOTE] = ACTIONS(4219),
    [sym_raw_string] = ACTIONS(4219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4219),
    [anon_sym_BQUOTE] = ACTIONS(4219),
    [anon_sym_LT_LPAREN] = ACTIONS(4219),
    [anon_sym_GT_LPAREN] = ACTIONS(4219),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4221),
    [sym_word] = ACTIONS(4221),
    [anon_sym_LF] = ACTIONS(4219),
    [anon_sym_AMP] = ACTIONS(4221),
  },
  [3536] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8820),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3537] = {
    [sym_concatenation] = STATE(3896),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3896),
    [anon_sym_RBRACE] = ACTIONS(8800),
    [anon_sym_EQ] = ACTIONS(8816),
    [anon_sym_DASH] = ACTIONS(8816),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8818),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8816),
    [anon_sym_COLON_QMARK] = ACTIONS(8816),
    [anon_sym_COLON_DASH] = ACTIONS(8816),
    [anon_sym_PERCENT] = ACTIONS(8816),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3538] = {
    [sym_string] = STATE(2381),
    [sym__simple_heredoc_body] = ACTIONS(4071),
    [sym__heredoc_body_beginning] = ACTIONS(4071),
    [sym_file_descriptor] = ACTIONS(4071),
    [anon_sym_SEMI] = ACTIONS(4073),
    [anon_sym_fi] = ACTIONS(4073),
    [anon_sym_elif] = ACTIONS(4073),
    [anon_sym_else] = ACTIONS(4073),
    [anon_sym_PIPE] = ACTIONS(4073),
    [anon_sym_SEMI_SEMI] = ACTIONS(4071),
    [anon_sym_PIPE_AMP] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_PIPE_PIPE] = ACTIONS(4071),
    [anon_sym_LT] = ACTIONS(4073),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_GT_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT] = ACTIONS(4073),
    [anon_sym_AMP_GT_GT] = ACTIONS(4071),
    [anon_sym_LT_AMP] = ACTIONS(4071),
    [anon_sym_GT_AMP] = ACTIONS(4071),
    [anon_sym_LT_LT] = ACTIONS(4073),
    [anon_sym_LT_LT_DASH] = ACTIONS(4071),
    [anon_sym_LT_LT_LT] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(8826),
    [anon_sym_DOLLAR] = ACTIONS(8826),
    [sym__special_character] = ACTIONS(4071),
    [anon_sym_DQUOTE] = ACTIONS(3435),
    [sym_raw_string] = ACTIONS(5185),
    [anon_sym_POUND] = ACTIONS(5183),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4071),
    [anon_sym_BQUOTE] = ACTIONS(4071),
    [anon_sym_LT_LPAREN] = ACTIONS(4071),
    [anon_sym_GT_LPAREN] = ACTIONS(4071),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5187),
    [anon_sym_STAR] = ACTIONS(5187),
    [anon_sym_AT] = ACTIONS(5187),
    [anon_sym_QMARK] = ACTIONS(5187),
    [anon_sym_0] = ACTIONS(5187),
    [anon_sym__] = ACTIONS(5187),
    [sym_word] = ACTIONS(4073),
    [anon_sym_LF] = ACTIONS(4071),
    [anon_sym_AMP] = ACTIONS(4073),
  },
  [3539] = {
    [sym__simple_heredoc_body] = ACTIONS(4111),
    [sym__heredoc_body_beginning] = ACTIONS(4111),
    [sym_file_descriptor] = ACTIONS(4111),
    [sym__concat] = ACTIONS(4111),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_fi] = ACTIONS(4113),
    [anon_sym_elif] = ACTIONS(4113),
    [anon_sym_else] = ACTIONS(4113),
    [anon_sym_PIPE] = ACTIONS(4113),
    [anon_sym_SEMI_SEMI] = ACTIONS(4111),
    [anon_sym_PIPE_AMP] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_LT] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4113),
    [anon_sym_GT_GT] = ACTIONS(4111),
    [anon_sym_AMP_GT] = ACTIONS(4113),
    [anon_sym_AMP_GT_GT] = ACTIONS(4111),
    [anon_sym_LT_AMP] = ACTIONS(4111),
    [anon_sym_GT_AMP] = ACTIONS(4111),
    [anon_sym_LT_LT] = ACTIONS(4113),
    [anon_sym_LT_LT_DASH] = ACTIONS(4111),
    [anon_sym_LT_LT_LT] = ACTIONS(4111),
    [anon_sym_DOLLAR] = ACTIONS(4113),
    [sym__special_character] = ACTIONS(4111),
    [anon_sym_DQUOTE] = ACTIONS(4111),
    [sym_raw_string] = ACTIONS(4111),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4111),
    [anon_sym_BQUOTE] = ACTIONS(4111),
    [anon_sym_LT_LPAREN] = ACTIONS(4111),
    [anon_sym_GT_LPAREN] = ACTIONS(4111),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4113),
    [sym_word] = ACTIONS(4113),
    [anon_sym_LF] = ACTIONS(4111),
    [anon_sym_AMP] = ACTIONS(4113),
  },
  [3540] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_fi] = ACTIONS(4127),
    [anon_sym_elif] = ACTIONS(4127),
    [anon_sym_else] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym__special_character] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4127),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [3541] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(8828),
    [sym_comment] = ACTIONS(57),
  },
  [3542] = {
    [anon_sym_RBRACE] = ACTIONS(8828),
    [sym_comment] = ACTIONS(57),
  },
  [3543] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(8830),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [3544] = {
    [sym_concatenation] = STATE(3902),
    [sym_string] = STATE(3901),
    [sym_simple_expansion] = STATE(3901),
    [sym_string_expansion] = STATE(3901),
    [sym_expansion] = STATE(3901),
    [sym_command_substitution] = STATE(3901),
    [sym_process_substitution] = STATE(3901),
    [aux_sym__literal_repeat1] = STATE(3903),
    [anon_sym_RBRACE] = ACTIONS(8828),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(8832),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8832),
  },
  [3545] = {
    [sym__simple_heredoc_body] = ACTIONS(4161),
    [sym__heredoc_body_beginning] = ACTIONS(4161),
    [sym_file_descriptor] = ACTIONS(4161),
    [sym__concat] = ACTIONS(4161),
    [anon_sym_SEMI] = ACTIONS(4163),
    [anon_sym_fi] = ACTIONS(4163),
    [anon_sym_elif] = ACTIONS(4163),
    [anon_sym_else] = ACTIONS(4163),
    [anon_sym_PIPE] = ACTIONS(4163),
    [anon_sym_SEMI_SEMI] = ACTIONS(4161),
    [anon_sym_PIPE_AMP] = ACTIONS(4161),
    [anon_sym_AMP_AMP] = ACTIONS(4161),
    [anon_sym_PIPE_PIPE] = ACTIONS(4161),
    [anon_sym_LT] = ACTIONS(4163),
    [anon_sym_GT] = ACTIONS(4163),
    [anon_sym_GT_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT] = ACTIONS(4163),
    [anon_sym_AMP_GT_GT] = ACTIONS(4161),
    [anon_sym_LT_AMP] = ACTIONS(4161),
    [anon_sym_GT_AMP] = ACTIONS(4161),
    [anon_sym_LT_LT] = ACTIONS(4163),
    [anon_sym_LT_LT_DASH] = ACTIONS(4161),
    [anon_sym_LT_LT_LT] = ACTIONS(4161),
    [anon_sym_DOLLAR] = ACTIONS(4163),
    [sym__special_character] = ACTIONS(4161),
    [anon_sym_DQUOTE] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4161),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4161),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4161),
    [anon_sym_BQUOTE] = ACTIONS(4161),
    [anon_sym_LT_LPAREN] = ACTIONS(4161),
    [anon_sym_GT_LPAREN] = ACTIONS(4161),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4163),
    [sym_word] = ACTIONS(4163),
    [anon_sym_LF] = ACTIONS(4161),
    [anon_sym_AMP] = ACTIONS(4163),
  },
  [3546] = {
    [sym_concatenation] = STATE(3906),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3906),
    [sym_regex] = ACTIONS(8834),
    [anon_sym_RBRACE] = ACTIONS(8836),
    [anon_sym_EQ] = ACTIONS(8838),
    [anon_sym_DASH] = ACTIONS(8838),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8840),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8838),
    [anon_sym_COLON_QMARK] = ACTIONS(8838),
    [anon_sym_COLON_DASH] = ACTIONS(8838),
    [anon_sym_PERCENT] = ACTIONS(8838),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3547] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8836),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3548] = {
    [sym_concatenation] = STATE(3908),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3908),
    [sym_regex] = ACTIONS(8842),
    [anon_sym_RBRACE] = ACTIONS(8828),
    [anon_sym_EQ] = ACTIONS(8844),
    [anon_sym_DASH] = ACTIONS(8844),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8846),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8844),
    [anon_sym_COLON_QMARK] = ACTIONS(8844),
    [anon_sym_COLON_DASH] = ACTIONS(8844),
    [anon_sym_PERCENT] = ACTIONS(8844),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3549] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8828),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3550] = {
    [sym_concatenation] = STATE(3910),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3910),
    [anon_sym_RBRACE] = ACTIONS(8848),
    [anon_sym_EQ] = ACTIONS(8850),
    [anon_sym_DASH] = ACTIONS(8850),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8852),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8850),
    [anon_sym_COLON_QMARK] = ACTIONS(8850),
    [anon_sym_COLON_DASH] = ACTIONS(8850),
    [anon_sym_PERCENT] = ACTIONS(8850),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3551] = {
    [sym__simple_heredoc_body] = ACTIONS(4219),
    [sym__heredoc_body_beginning] = ACTIONS(4219),
    [sym_file_descriptor] = ACTIONS(4219),
    [sym__concat] = ACTIONS(4219),
    [anon_sym_SEMI] = ACTIONS(4221),
    [anon_sym_fi] = ACTIONS(4221),
    [anon_sym_elif] = ACTIONS(4221),
    [anon_sym_else] = ACTIONS(4221),
    [anon_sym_PIPE] = ACTIONS(4221),
    [anon_sym_SEMI_SEMI] = ACTIONS(4219),
    [anon_sym_PIPE_AMP] = ACTIONS(4219),
    [anon_sym_AMP_AMP] = ACTIONS(4219),
    [anon_sym_PIPE_PIPE] = ACTIONS(4219),
    [anon_sym_LT] = ACTIONS(4221),
    [anon_sym_GT] = ACTIONS(4221),
    [anon_sym_GT_GT] = ACTIONS(4219),
    [anon_sym_AMP_GT] = ACTIONS(4221),
    [anon_sym_AMP_GT_GT] = ACTIONS(4219),
    [anon_sym_LT_AMP] = ACTIONS(4219),
    [anon_sym_GT_AMP] = ACTIONS(4219),
    [anon_sym_LT_LT] = ACTIONS(4221),
    [anon_sym_LT_LT_DASH] = ACTIONS(4219),
    [anon_sym_LT_LT_LT] = ACTIONS(4219),
    [anon_sym_DOLLAR] = ACTIONS(4221),
    [sym__special_character] = ACTIONS(4219),
    [anon_sym_DQUOTE] = ACTIONS(4219),
    [sym_raw_string] = ACTIONS(4219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4219),
    [anon_sym_BQUOTE] = ACTIONS(4219),
    [anon_sym_LT_LPAREN] = ACTIONS(4219),
    [anon_sym_GT_LPAREN] = ACTIONS(4219),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4221),
    [sym_word] = ACTIONS(4221),
    [anon_sym_LF] = ACTIONS(4219),
    [anon_sym_AMP] = ACTIONS(4221),
  },
  [3552] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8848),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3553] = {
    [sym_concatenation] = STATE(3908),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3908),
    [anon_sym_RBRACE] = ACTIONS(8828),
    [anon_sym_EQ] = ACTIONS(8844),
    [anon_sym_DASH] = ACTIONS(8844),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8846),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8844),
    [anon_sym_COLON_QMARK] = ACTIONS(8844),
    [anon_sym_COLON_DASH] = ACTIONS(8844),
    [anon_sym_PERCENT] = ACTIONS(8844),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3554] = {
    [sym__simple_heredoc_body] = ACTIONS(5674),
    [sym__heredoc_body_beginning] = ACTIONS(5674),
    [sym_file_descriptor] = ACTIONS(5674),
    [sym__concat] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(5676),
    [anon_sym_fi] = ACTIONS(5676),
    [anon_sym_elif] = ACTIONS(5676),
    [anon_sym_else] = ACTIONS(5676),
    [anon_sym_PIPE] = ACTIONS(5676),
    [anon_sym_SEMI_SEMI] = ACTIONS(5674),
    [anon_sym_PIPE_AMP] = ACTIONS(5674),
    [anon_sym_AMP_AMP] = ACTIONS(5674),
    [anon_sym_PIPE_PIPE] = ACTIONS(5674),
    [anon_sym_EQ_TILDE] = ACTIONS(5676),
    [anon_sym_EQ_EQ] = ACTIONS(5676),
    [anon_sym_LT] = ACTIONS(5676),
    [anon_sym_GT] = ACTIONS(5676),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_AMP_GT] = ACTIONS(5676),
    [anon_sym_AMP_GT_GT] = ACTIONS(5674),
    [anon_sym_LT_AMP] = ACTIONS(5674),
    [anon_sym_GT_AMP] = ACTIONS(5674),
    [anon_sym_LT_LT] = ACTIONS(5676),
    [anon_sym_LT_LT_DASH] = ACTIONS(5674),
    [anon_sym_LT_LT_LT] = ACTIONS(5674),
    [anon_sym_DOLLAR] = ACTIONS(5676),
    [sym__special_character] = ACTIONS(5674),
    [anon_sym_DQUOTE] = ACTIONS(5674),
    [sym_raw_string] = ACTIONS(5674),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5674),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5674),
    [anon_sym_BQUOTE] = ACTIONS(5674),
    [anon_sym_LT_LPAREN] = ACTIONS(5674),
    [anon_sym_GT_LPAREN] = ACTIONS(5674),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5676),
    [anon_sym_LF] = ACTIONS(5674),
    [anon_sym_AMP] = ACTIONS(5676),
  },
  [3555] = {
    [sym__simple_heredoc_body] = ACTIONS(5708),
    [sym__heredoc_body_beginning] = ACTIONS(5708),
    [sym_file_descriptor] = ACTIONS(5708),
    [sym__concat] = ACTIONS(5708),
    [anon_sym_SEMI] = ACTIONS(5710),
    [anon_sym_fi] = ACTIONS(5710),
    [anon_sym_elif] = ACTIONS(5710),
    [anon_sym_else] = ACTIONS(5710),
    [anon_sym_PIPE] = ACTIONS(5710),
    [anon_sym_SEMI_SEMI] = ACTIONS(5708),
    [anon_sym_PIPE_AMP] = ACTIONS(5708),
    [anon_sym_AMP_AMP] = ACTIONS(5708),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_EQ_TILDE] = ACTIONS(5710),
    [anon_sym_EQ_EQ] = ACTIONS(5710),
    [anon_sym_LT] = ACTIONS(5710),
    [anon_sym_GT] = ACTIONS(5710),
    [anon_sym_GT_GT] = ACTIONS(5708),
    [anon_sym_AMP_GT] = ACTIONS(5710),
    [anon_sym_AMP_GT_GT] = ACTIONS(5708),
    [anon_sym_LT_AMP] = ACTIONS(5708),
    [anon_sym_GT_AMP] = ACTIONS(5708),
    [anon_sym_LT_LT] = ACTIONS(5710),
    [anon_sym_LT_LT_DASH] = ACTIONS(5708),
    [anon_sym_LT_LT_LT] = ACTIONS(5708),
    [anon_sym_DOLLAR] = ACTIONS(5710),
    [sym__special_character] = ACTIONS(5708),
    [anon_sym_DQUOTE] = ACTIONS(5708),
    [sym_raw_string] = ACTIONS(5708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5708),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5708),
    [anon_sym_BQUOTE] = ACTIONS(5708),
    [anon_sym_LT_LPAREN] = ACTIONS(5708),
    [anon_sym_GT_LPAREN] = ACTIONS(5708),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5710),
    [anon_sym_LF] = ACTIONS(5708),
    [anon_sym_AMP] = ACTIONS(5710),
  },
  [3556] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(8854),
    [sym_comment] = ACTIONS(57),
  },
  [3557] = {
    [anon_sym_RBRACE] = ACTIONS(8854),
    [sym_comment] = ACTIONS(57),
  },
  [3558] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(8856),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [3559] = {
    [sym_concatenation] = STATE(3914),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3914),
    [anon_sym_RBRACE] = ACTIONS(8858),
    [anon_sym_EQ] = ACTIONS(8860),
    [anon_sym_DASH] = ACTIONS(8860),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8862),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8860),
    [anon_sym_COLON_QMARK] = ACTIONS(8860),
    [anon_sym_COLON_DASH] = ACTIONS(8860),
    [anon_sym_PERCENT] = ACTIONS(8860),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3560] = {
    [sym__simple_heredoc_body] = ACTIONS(5725),
    [sym__heredoc_body_beginning] = ACTIONS(5725),
    [sym_file_descriptor] = ACTIONS(5725),
    [sym__concat] = ACTIONS(5725),
    [anon_sym_SEMI] = ACTIONS(5727),
    [anon_sym_fi] = ACTIONS(5727),
    [anon_sym_elif] = ACTIONS(5727),
    [anon_sym_else] = ACTIONS(5727),
    [anon_sym_PIPE] = ACTIONS(5727),
    [anon_sym_SEMI_SEMI] = ACTIONS(5725),
    [anon_sym_PIPE_AMP] = ACTIONS(5725),
    [anon_sym_AMP_AMP] = ACTIONS(5725),
    [anon_sym_PIPE_PIPE] = ACTIONS(5725),
    [anon_sym_EQ_TILDE] = ACTIONS(5727),
    [anon_sym_EQ_EQ] = ACTIONS(5727),
    [anon_sym_LT] = ACTIONS(5727),
    [anon_sym_GT] = ACTIONS(5727),
    [anon_sym_GT_GT] = ACTIONS(5725),
    [anon_sym_AMP_GT] = ACTIONS(5727),
    [anon_sym_AMP_GT_GT] = ACTIONS(5725),
    [anon_sym_LT_AMP] = ACTIONS(5725),
    [anon_sym_GT_AMP] = ACTIONS(5725),
    [anon_sym_LT_LT] = ACTIONS(5727),
    [anon_sym_LT_LT_DASH] = ACTIONS(5725),
    [anon_sym_LT_LT_LT] = ACTIONS(5725),
    [anon_sym_DOLLAR] = ACTIONS(5727),
    [sym__special_character] = ACTIONS(5725),
    [anon_sym_DQUOTE] = ACTIONS(5725),
    [sym_raw_string] = ACTIONS(5725),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5725),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5725),
    [anon_sym_BQUOTE] = ACTIONS(5725),
    [anon_sym_LT_LPAREN] = ACTIONS(5725),
    [anon_sym_GT_LPAREN] = ACTIONS(5725),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5727),
    [anon_sym_LF] = ACTIONS(5725),
    [anon_sym_AMP] = ACTIONS(5727),
  },
  [3561] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8858),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3562] = {
    [sym_concatenation] = STATE(3915),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3915),
    [anon_sym_RBRACE] = ACTIONS(8854),
    [anon_sym_EQ] = ACTIONS(8864),
    [anon_sym_DASH] = ACTIONS(8864),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8866),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(8864),
    [anon_sym_COLON_QMARK] = ACTIONS(8864),
    [anon_sym_COLON_DASH] = ACTIONS(8864),
    [anon_sym_PERCENT] = ACTIONS(8864),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3563] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8854),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3564] = {
    [sym__simple_heredoc_body] = ACTIONS(5770),
    [sym__heredoc_body_beginning] = ACTIONS(5770),
    [sym_file_descriptor] = ACTIONS(5770),
    [sym__concat] = ACTIONS(5770),
    [anon_sym_SEMI] = ACTIONS(5772),
    [anon_sym_fi] = ACTIONS(5772),
    [anon_sym_elif] = ACTIONS(5772),
    [anon_sym_else] = ACTIONS(5772),
    [anon_sym_PIPE] = ACTIONS(5772),
    [anon_sym_SEMI_SEMI] = ACTIONS(5770),
    [anon_sym_PIPE_AMP] = ACTIONS(5770),
    [anon_sym_AMP_AMP] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5770),
    [anon_sym_EQ_TILDE] = ACTIONS(5772),
    [anon_sym_EQ_EQ] = ACTIONS(5772),
    [anon_sym_LT] = ACTIONS(5772),
    [anon_sym_GT] = ACTIONS(5772),
    [anon_sym_GT_GT] = ACTIONS(5770),
    [anon_sym_AMP_GT] = ACTIONS(5772),
    [anon_sym_AMP_GT_GT] = ACTIONS(5770),
    [anon_sym_LT_AMP] = ACTIONS(5770),
    [anon_sym_GT_AMP] = ACTIONS(5770),
    [anon_sym_LT_LT] = ACTIONS(5772),
    [anon_sym_LT_LT_DASH] = ACTIONS(5770),
    [anon_sym_LT_LT_LT] = ACTIONS(5770),
    [anon_sym_DOLLAR] = ACTIONS(5772),
    [sym__special_character] = ACTIONS(5770),
    [anon_sym_DQUOTE] = ACTIONS(5770),
    [sym_raw_string] = ACTIONS(5770),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5770),
    [anon_sym_BQUOTE] = ACTIONS(5770),
    [anon_sym_LT_LPAREN] = ACTIONS(5770),
    [anon_sym_GT_LPAREN] = ACTIONS(5770),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5772),
    [anon_sym_LF] = ACTIONS(5770),
    [anon_sym_AMP] = ACTIONS(5772),
  },
  [3565] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(8868),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3566] = {
    [sym_string] = STATE(3406),
    [sym_simple_expansion] = STATE(3406),
    [sym_string_expansion] = STATE(3406),
    [sym_expansion] = STATE(3406),
    [sym_command_substitution] = STATE(3406),
    [sym_process_substitution] = STATE(3406),
    [anon_sym_DOLLAR] = ACTIONS(8870),
    [sym__special_character] = ACTIONS(7609),
    [anon_sym_DQUOTE] = ACTIONS(5002),
    [sym_raw_string] = ACTIONS(7609),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5006),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5008),
    [anon_sym_BQUOTE] = ACTIONS(5010),
    [anon_sym_LT_LPAREN] = ACTIONS(5012),
    [anon_sym_GT_LPAREN] = ACTIONS(5012),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7609),
  },
  [3567] = {
    [aux_sym_concatenation_repeat1] = STATE(3567),
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(8575),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_fi] = ACTIONS(2362),
    [anon_sym_elif] = ACTIONS(2362),
    [anon_sym_else] = ACTIONS(2362),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [3568] = {
    [sym_string] = STATE(795),
    [anon_sym_PIPE] = ACTIONS(4071),
    [anon_sym_RPAREN] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(1510),
    [anon_sym_DOLLAR] = ACTIONS(1510),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(1512),
    [anon_sym_POUND] = ACTIONS(1510),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1514),
    [anon_sym_STAR] = ACTIONS(1516),
    [anon_sym_AT] = ACTIONS(1516),
    [anon_sym_QMARK] = ACTIONS(1516),
    [anon_sym_0] = ACTIONS(1514),
    [anon_sym__] = ACTIONS(1514),
  },
  [3569] = {
    [sym_concatenation] = STATE(3918),
    [sym_string] = STATE(3923),
    [sym_array] = STATE(3918),
    [sym_simple_expansion] = STATE(3923),
    [sym_string_expansion] = STATE(3923),
    [sym_expansion] = STATE(3923),
    [sym_command_substitution] = STATE(3923),
    [sym_process_substitution] = STATE(3923),
    [aux_sym__literal_repeat1] = STATE(3928),
    [sym__empty_value] = ACTIONS(8872),
    [anon_sym_LPAREN] = ACTIONS(8874),
    [anon_sym_DOLLAR] = ACTIONS(8876),
    [sym__special_character] = ACTIONS(8878),
    [anon_sym_DQUOTE] = ACTIONS(8880),
    [sym_raw_string] = ACTIONS(8882),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8884),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8886),
    [anon_sym_BQUOTE] = ACTIONS(8888),
    [anon_sym_LT_LPAREN] = ACTIONS(8890),
    [anon_sym_GT_LPAREN] = ACTIONS(8890),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8882),
  },
  [3570] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(8892),
    [anon_sym_PLUS_EQ] = ACTIONS(8892),
    [sym_comment] = ACTIONS(57),
  },
  [3571] = {
    [sym_string] = STATE(3931),
    [anon_sym_DASH] = ACTIONS(8894),
    [anon_sym_DOLLAR] = ACTIONS(8894),
    [anon_sym_DQUOTE] = ACTIONS(8091),
    [sym_raw_string] = ACTIONS(8896),
    [anon_sym_POUND] = ACTIONS(8894),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8898),
    [anon_sym_STAR] = ACTIONS(8900),
    [anon_sym_AT] = ACTIONS(8900),
    [anon_sym_QMARK] = ACTIONS(8900),
    [anon_sym_0] = ACTIONS(8898),
    [anon_sym__] = ACTIONS(8898),
  },
  [3572] = {
    [aux_sym_concatenation_repeat1] = STATE(3934),
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(8902),
    [sym_variable_name] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_esac] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(339),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [3573] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(3937),
    [anon_sym_DOLLAR] = ACTIONS(8904),
    [anon_sym_DQUOTE] = ACTIONS(8906),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [3574] = {
    [aux_sym_concatenation_repeat1] = STATE(3934),
    [sym__simple_heredoc_body] = ACTIONS(957),
    [sym__heredoc_body_beginning] = ACTIONS(957),
    [sym_file_descriptor] = ACTIONS(957),
    [sym__concat] = ACTIONS(8902),
    [sym_variable_name] = ACTIONS(957),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_esac] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_SEMI_SEMI] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_LT] = ACTIONS(959),
    [anon_sym_GT] = ACTIONS(959),
    [anon_sym_GT_GT] = ACTIONS(957),
    [anon_sym_AMP_GT] = ACTIONS(959),
    [anon_sym_AMP_GT_GT] = ACTIONS(957),
    [anon_sym_LT_AMP] = ACTIONS(957),
    [anon_sym_GT_AMP] = ACTIONS(957),
    [anon_sym_LT_LT] = ACTIONS(959),
    [anon_sym_LT_LT_DASH] = ACTIONS(957),
    [anon_sym_LT_LT_LT] = ACTIONS(957),
    [anon_sym_DOLLAR] = ACTIONS(959),
    [sym__special_character] = ACTIONS(957),
    [anon_sym_DQUOTE] = ACTIONS(957),
    [sym_raw_string] = ACTIONS(957),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(957),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(957),
    [anon_sym_BQUOTE] = ACTIONS(957),
    [anon_sym_LT_LPAREN] = ACTIONS(957),
    [anon_sym_GT_LPAREN] = ACTIONS(957),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(959),
    [sym_word] = ACTIONS(959),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
  },
  [3575] = {
    [sym_subscript] = STATE(3941),
    [sym_variable_name] = ACTIONS(8908),
    [anon_sym_BANG] = ACTIONS(8910),
    [anon_sym_DASH] = ACTIONS(8912),
    [anon_sym_DOLLAR] = ACTIONS(8912),
    [anon_sym_POUND] = ACTIONS(8910),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8914),
    [anon_sym_STAR] = ACTIONS(8916),
    [anon_sym_AT] = ACTIONS(8916),
    [anon_sym_QMARK] = ACTIONS(8916),
    [anon_sym_0] = ACTIONS(8914),
    [anon_sym__] = ACTIONS(8914),
  },
  [3576] = {
    [sym__statements] = STATE(3942),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(3943),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [3577] = {
    [sym__statements] = STATE(3944),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [3578] = {
    [sym__statements] = STATE(3945),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [3579] = {
    [anon_sym_EQ] = ACTIONS(8892),
    [anon_sym_PLUS_EQ] = ACTIONS(8892),
    [sym_comment] = ACTIONS(57),
  },
  [3580] = {
    [sym_variable_assignment] = STATE(3946),
    [sym_subscript] = STATE(3579),
    [sym_concatenation] = STATE(3946),
    [sym_string] = STATE(3574),
    [sym_simple_expansion] = STATE(3574),
    [sym_string_expansion] = STATE(3574),
    [sym_expansion] = STATE(3574),
    [sym_command_substitution] = STATE(3574),
    [sym_process_substitution] = STATE(3574),
    [aux_sym_declaration_command_repeat1] = STATE(3946),
    [aux_sym__literal_repeat1] = STATE(3581),
    [sym__simple_heredoc_body] = ACTIONS(971),
    [sym__heredoc_body_beginning] = ACTIONS(971),
    [sym_file_descriptor] = ACTIONS(971),
    [sym_variable_name] = ACTIONS(8085),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_esac] = ACTIONS(973),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_SEMI_SEMI] = ACTIONS(971),
    [anon_sym_PIPE_AMP] = ACTIONS(971),
    [anon_sym_AMP_AMP] = ACTIONS(971),
    [anon_sym_PIPE_PIPE] = ACTIONS(971),
    [anon_sym_LT] = ACTIONS(973),
    [anon_sym_GT] = ACTIONS(973),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_AMP_GT] = ACTIONS(973),
    [anon_sym_AMP_GT_GT] = ACTIONS(971),
    [anon_sym_LT_AMP] = ACTIONS(971),
    [anon_sym_GT_AMP] = ACTIONS(971),
    [anon_sym_LT_LT] = ACTIONS(973),
    [anon_sym_LT_LT_DASH] = ACTIONS(971),
    [anon_sym_LT_LT_LT] = ACTIONS(971),
    [anon_sym_DOLLAR] = ACTIONS(8087),
    [sym__special_character] = ACTIONS(8089),
    [anon_sym_DQUOTE] = ACTIONS(8091),
    [sym_raw_string] = ACTIONS(8093),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8097),
    [anon_sym_BQUOTE] = ACTIONS(8099),
    [anon_sym_LT_LPAREN] = ACTIONS(8101),
    [anon_sym_GT_LPAREN] = ACTIONS(8101),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8918),
    [sym_word] = ACTIONS(8105),
    [anon_sym_LF] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(973),
  },
  [3581] = {
    [aux_sym__literal_repeat1] = STATE(3948),
    [sym__simple_heredoc_body] = ACTIONS(977),
    [sym__heredoc_body_beginning] = ACTIONS(977),
    [sym_file_descriptor] = ACTIONS(977),
    [sym_variable_name] = ACTIONS(977),
    [anon_sym_SEMI] = ACTIONS(979),
    [anon_sym_esac] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(979),
    [anon_sym_SEMI_SEMI] = ACTIONS(977),
    [anon_sym_PIPE_AMP] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(977),
    [anon_sym_AMP_GT] = ACTIONS(979),
    [anon_sym_AMP_GT_GT] = ACTIONS(977),
    [anon_sym_LT_AMP] = ACTIONS(977),
    [anon_sym_GT_AMP] = ACTIONS(977),
    [anon_sym_LT_LT] = ACTIONS(979),
    [anon_sym_LT_LT_DASH] = ACTIONS(977),
    [anon_sym_LT_LT_LT] = ACTIONS(977),
    [anon_sym_DOLLAR] = ACTIONS(979),
    [sym__special_character] = ACTIONS(8920),
    [anon_sym_DQUOTE] = ACTIONS(977),
    [sym_raw_string] = ACTIONS(977),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(977),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(977),
    [anon_sym_BQUOTE] = ACTIONS(977),
    [anon_sym_LT_LPAREN] = ACTIONS(977),
    [anon_sym_GT_LPAREN] = ACTIONS(977),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(979),
    [sym_word] = ACTIONS(979),
    [anon_sym_LF] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
  },
  [3582] = {
    [sym_string] = STATE(3950),
    [anon_sym_DASH] = ACTIONS(8922),
    [anon_sym_DOLLAR] = ACTIONS(8922),
    [anon_sym_DQUOTE] = ACTIONS(8111),
    [sym_raw_string] = ACTIONS(8924),
    [anon_sym_POUND] = ACTIONS(8922),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8926),
    [anon_sym_STAR] = ACTIONS(8928),
    [anon_sym_AT] = ACTIONS(8928),
    [anon_sym_QMARK] = ACTIONS(8928),
    [anon_sym_0] = ACTIONS(8926),
    [anon_sym__] = ACTIONS(8926),
  },
  [3583] = {
    [aux_sym_concatenation_repeat1] = STATE(3953),
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(8930),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_esac] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(339),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [3584] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(3956),
    [anon_sym_DOLLAR] = ACTIONS(8932),
    [anon_sym_DQUOTE] = ACTIONS(8934),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [3585] = {
    [aux_sym_concatenation_repeat1] = STATE(3953),
    [sym__simple_heredoc_body] = ACTIONS(997),
    [sym__heredoc_body_beginning] = ACTIONS(997),
    [sym_file_descriptor] = ACTIONS(997),
    [sym__concat] = ACTIONS(8930),
    [anon_sym_SEMI] = ACTIONS(999),
    [anon_sym_esac] = ACTIONS(999),
    [anon_sym_PIPE] = ACTIONS(999),
    [anon_sym_SEMI_SEMI] = ACTIONS(997),
    [anon_sym_PIPE_AMP] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_LT] = ACTIONS(999),
    [anon_sym_GT] = ACTIONS(999),
    [anon_sym_GT_GT] = ACTIONS(997),
    [anon_sym_AMP_GT] = ACTIONS(999),
    [anon_sym_AMP_GT_GT] = ACTIONS(997),
    [anon_sym_LT_AMP] = ACTIONS(997),
    [anon_sym_GT_AMP] = ACTIONS(997),
    [anon_sym_LT_LT] = ACTIONS(999),
    [anon_sym_LT_LT_DASH] = ACTIONS(997),
    [anon_sym_LT_LT_LT] = ACTIONS(997),
    [anon_sym_DOLLAR] = ACTIONS(999),
    [sym__special_character] = ACTIONS(997),
    [anon_sym_DQUOTE] = ACTIONS(997),
    [sym_raw_string] = ACTIONS(997),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(997),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(997),
    [anon_sym_BQUOTE] = ACTIONS(997),
    [anon_sym_LT_LPAREN] = ACTIONS(997),
    [anon_sym_GT_LPAREN] = ACTIONS(997),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(999),
    [sym_word] = ACTIONS(999),
    [anon_sym_LF] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(999),
  },
  [3586] = {
    [sym_subscript] = STATE(3960),
    [sym_variable_name] = ACTIONS(8936),
    [anon_sym_BANG] = ACTIONS(8938),
    [anon_sym_DASH] = ACTIONS(8940),
    [anon_sym_DOLLAR] = ACTIONS(8940),
    [anon_sym_POUND] = ACTIONS(8938),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8942),
    [anon_sym_STAR] = ACTIONS(8944),
    [anon_sym_AT] = ACTIONS(8944),
    [anon_sym_QMARK] = ACTIONS(8944),
    [anon_sym_0] = ACTIONS(8942),
    [anon_sym__] = ACTIONS(8942),
  },
  [3587] = {
    [sym__statements] = STATE(3961),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(3962),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [3588] = {
    [sym__statements] = STATE(3963),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [3589] = {
    [sym__statements] = STATE(3964),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [3590] = {
    [sym_concatenation] = STATE(3965),
    [sym_string] = STATE(3585),
    [sym_simple_expansion] = STATE(3585),
    [sym_string_expansion] = STATE(3585),
    [sym_expansion] = STATE(3585),
    [sym_command_substitution] = STATE(3585),
    [sym_process_substitution] = STATE(3585),
    [aux_sym_unset_command_repeat1] = STATE(3965),
    [aux_sym__literal_repeat1] = STATE(3591),
    [sym__simple_heredoc_body] = ACTIONS(1011),
    [sym__heredoc_body_beginning] = ACTIONS(1011),
    [sym_file_descriptor] = ACTIONS(1011),
    [anon_sym_SEMI] = ACTIONS(1013),
    [anon_sym_esac] = ACTIONS(1013),
    [anon_sym_PIPE] = ACTIONS(1013),
    [anon_sym_SEMI_SEMI] = ACTIONS(1011),
    [anon_sym_PIPE_AMP] = ACTIONS(1011),
    [anon_sym_AMP_AMP] = ACTIONS(1011),
    [anon_sym_PIPE_PIPE] = ACTIONS(1011),
    [anon_sym_LT] = ACTIONS(1013),
    [anon_sym_GT] = ACTIONS(1013),
    [anon_sym_GT_GT] = ACTIONS(1011),
    [anon_sym_AMP_GT] = ACTIONS(1013),
    [anon_sym_AMP_GT_GT] = ACTIONS(1011),
    [anon_sym_LT_AMP] = ACTIONS(1011),
    [anon_sym_GT_AMP] = ACTIONS(1011),
    [anon_sym_LT_LT] = ACTIONS(1013),
    [anon_sym_LT_LT_DASH] = ACTIONS(1011),
    [anon_sym_LT_LT_LT] = ACTIONS(1011),
    [anon_sym_DOLLAR] = ACTIONS(8107),
    [sym__special_character] = ACTIONS(8109),
    [anon_sym_DQUOTE] = ACTIONS(8111),
    [sym_raw_string] = ACTIONS(8113),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8115),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8117),
    [anon_sym_BQUOTE] = ACTIONS(8119),
    [anon_sym_LT_LPAREN] = ACTIONS(8121),
    [anon_sym_GT_LPAREN] = ACTIONS(8121),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8946),
    [sym_word] = ACTIONS(8125),
    [anon_sym_LF] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(1013),
  },
  [3591] = {
    [aux_sym__literal_repeat1] = STATE(3967),
    [sym__simple_heredoc_body] = ACTIONS(1017),
    [sym__heredoc_body_beginning] = ACTIONS(1017),
    [sym_file_descriptor] = ACTIONS(1017),
    [anon_sym_SEMI] = ACTIONS(1019),
    [anon_sym_esac] = ACTIONS(1019),
    [anon_sym_PIPE] = ACTIONS(1019),
    [anon_sym_SEMI_SEMI] = ACTIONS(1017),
    [anon_sym_PIPE_AMP] = ACTIONS(1017),
    [anon_sym_AMP_AMP] = ACTIONS(1017),
    [anon_sym_PIPE_PIPE] = ACTIONS(1017),
    [anon_sym_LT] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(1019),
    [anon_sym_GT_GT] = ACTIONS(1017),
    [anon_sym_AMP_GT] = ACTIONS(1019),
    [anon_sym_AMP_GT_GT] = ACTIONS(1017),
    [anon_sym_LT_AMP] = ACTIONS(1017),
    [anon_sym_GT_AMP] = ACTIONS(1017),
    [anon_sym_LT_LT] = ACTIONS(1019),
    [anon_sym_LT_LT_DASH] = ACTIONS(1017),
    [anon_sym_LT_LT_LT] = ACTIONS(1017),
    [anon_sym_DOLLAR] = ACTIONS(1019),
    [sym__special_character] = ACTIONS(8948),
    [anon_sym_DQUOTE] = ACTIONS(1017),
    [sym_raw_string] = ACTIONS(1017),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1017),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1017),
    [anon_sym_BQUOTE] = ACTIONS(1017),
    [anon_sym_LT_LPAREN] = ACTIONS(1017),
    [anon_sym_GT_LPAREN] = ACTIONS(1017),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1019),
    [sym_word] = ACTIONS(1019),
    [anon_sym_LF] = ACTIONS(1017),
    [anon_sym_AMP] = ACTIONS(1019),
  },
  [3592] = {
    [sym__simple_heredoc_body] = ACTIONS(1057),
    [sym__heredoc_body_beginning] = ACTIONS(1057),
    [sym_file_descriptor] = ACTIONS(1057),
    [sym__concat] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_esac] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_PIPE_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_EQ_TILDE] = ACTIONS(1059),
    [anon_sym_EQ_EQ] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_AMP] = ACTIONS(1057),
    [anon_sym_GT_AMP] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_LT] = ACTIONS(1057),
    [anon_sym_DOLLAR] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [sym_raw_string] = ACTIONS(1057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1057),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1057),
    [anon_sym_BQUOTE] = ACTIONS(1057),
    [anon_sym_LT_LPAREN] = ACTIONS(1057),
    [anon_sym_GT_LPAREN] = ACTIONS(1057),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [3593] = {
    [sym__simple_heredoc_body] = ACTIONS(1061),
    [sym__heredoc_body_beginning] = ACTIONS(1061),
    [sym_file_descriptor] = ACTIONS(1061),
    [sym__concat] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(1063),
    [anon_sym_esac] = ACTIONS(1063),
    [anon_sym_PIPE] = ACTIONS(1063),
    [anon_sym_SEMI_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE_AMP] = ACTIONS(1061),
    [anon_sym_AMP_AMP] = ACTIONS(1061),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_EQ_TILDE] = ACTIONS(1063),
    [anon_sym_EQ_EQ] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1063),
    [anon_sym_GT_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT_GT] = ACTIONS(1061),
    [anon_sym_LT_AMP] = ACTIONS(1061),
    [anon_sym_GT_AMP] = ACTIONS(1061),
    [anon_sym_LT_LT] = ACTIONS(1063),
    [anon_sym_LT_LT_DASH] = ACTIONS(1061),
    [anon_sym_LT_LT_LT] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1061),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1061),
    [anon_sym_LT_LPAREN] = ACTIONS(1061),
    [anon_sym_GT_LPAREN] = ACTIONS(1061),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1063),
    [anon_sym_LF] = ACTIONS(1061),
    [anon_sym_AMP] = ACTIONS(1063),
  },
  [3594] = {
    [sym__simple_heredoc_body] = ACTIONS(1065),
    [sym__heredoc_body_beginning] = ACTIONS(1065),
    [sym_file_descriptor] = ACTIONS(1065),
    [sym__concat] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_esac] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1067),
    [anon_sym_SEMI_SEMI] = ACTIONS(1065),
    [anon_sym_PIPE_AMP] = ACTIONS(1065),
    [anon_sym_AMP_AMP] = ACTIONS(1065),
    [anon_sym_PIPE_PIPE] = ACTIONS(1065),
    [anon_sym_EQ_TILDE] = ACTIONS(1067),
    [anon_sym_EQ_EQ] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_GT] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT] = ACTIONS(1067),
    [anon_sym_AMP_GT_GT] = ACTIONS(1065),
    [anon_sym_LT_AMP] = ACTIONS(1065),
    [anon_sym_GT_AMP] = ACTIONS(1065),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_LT_LT_DASH] = ACTIONS(1065),
    [anon_sym_LT_LT_LT] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1067),
    [sym__special_character] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LT_LPAREN] = ACTIONS(1065),
    [anon_sym_GT_LPAREN] = ACTIONS(1065),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1067),
    [anon_sym_LF] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1067),
  },
  [3595] = {
    [sym_string] = STATE(3968),
    [sym_simple_expansion] = STATE(3968),
    [sym_string_expansion] = STATE(3968),
    [sym_expansion] = STATE(3968),
    [sym_command_substitution] = STATE(3968),
    [sym_process_substitution] = STATE(3968),
    [anon_sym_DOLLAR] = ACTIONS(6864),
    [sym__special_character] = ACTIONS(8950),
    [anon_sym_DQUOTE] = ACTIONS(6868),
    [sym_raw_string] = ACTIONS(8950),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6874),
    [anon_sym_BQUOTE] = ACTIONS(6876),
    [anon_sym_LT_LPAREN] = ACTIONS(6878),
    [anon_sym_GT_LPAREN] = ACTIONS(6878),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8950),
  },
  [3596] = {
    [aux_sym_concatenation_repeat1] = STATE(3970),
    [sym__simple_heredoc_body] = ACTIONS(1071),
    [sym__heredoc_body_beginning] = ACTIONS(1071),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(8952),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_esac] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_EQ_TILDE] = ACTIONS(1075),
    [anon_sym_EQ_EQ] = ACTIONS(1075),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [sym__special_character] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1075),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1075),
  },
  [3597] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(8954),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [3598] = {
    [sym__simple_heredoc_body] = ACTIONS(1089),
    [sym__heredoc_body_beginning] = ACTIONS(1089),
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(1089),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_esac] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1089),
    [anon_sym_PIPE_AMP] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_AMP] = ACTIONS(1089),
    [anon_sym_GT_AMP] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1089),
    [anon_sym_LT_LT_LT] = ACTIONS(1089),
    [anon_sym_DOLLAR] = ACTIONS(1091),
    [sym__special_character] = ACTIONS(1089),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1089),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1089),
    [anon_sym_GT_LPAREN] = ACTIONS(1089),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [3599] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(627),
    [anon_sym_DOLLAR] = ACTIONS(8956),
    [anon_sym_DQUOTE] = ACTIONS(8954),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [3600] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(8958),
    [sym_comment] = ACTIONS(57),
  },
  [3601] = {
    [sym_subscript] = STATE(3976),
    [sym_variable_name] = ACTIONS(8960),
    [anon_sym_DASH] = ACTIONS(8962),
    [anon_sym_DOLLAR] = ACTIONS(8962),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8964),
    [anon_sym_STAR] = ACTIONS(8966),
    [anon_sym_AT] = ACTIONS(8966),
    [anon_sym_QMARK] = ACTIONS(8966),
    [anon_sym_0] = ACTIONS(8964),
    [anon_sym__] = ACTIONS(8964),
  },
  [3602] = {
    [sym_concatenation] = STATE(3979),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3979),
    [anon_sym_RBRACE] = ACTIONS(8968),
    [anon_sym_EQ] = ACTIONS(8970),
    [anon_sym_DASH] = ACTIONS(8970),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8972),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(8974),
    [anon_sym_COLON] = ACTIONS(8970),
    [anon_sym_COLON_QMARK] = ACTIONS(8970),
    [anon_sym_COLON_DASH] = ACTIONS(8970),
    [anon_sym_PERCENT] = ACTIONS(8970),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3603] = {
    [sym_concatenation] = STATE(3982),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(3982),
    [anon_sym_RBRACE] = ACTIONS(8976),
    [anon_sym_EQ] = ACTIONS(8978),
    [anon_sym_DASH] = ACTIONS(8978),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(8980),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(8982),
    [anon_sym_COLON] = ACTIONS(8978),
    [anon_sym_COLON_QMARK] = ACTIONS(8978),
    [anon_sym_COLON_DASH] = ACTIONS(8978),
    [anon_sym_PERCENT] = ACTIONS(8978),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3604] = {
    [anon_sym_RPAREN] = ACTIONS(8984),
    [sym_comment] = ACTIONS(57),
  },
  [3605] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(8984),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [3606] = {
    [anon_sym_BQUOTE] = ACTIONS(8984),
    [sym_comment] = ACTIONS(57),
  },
  [3607] = {
    [anon_sym_RPAREN] = ACTIONS(8986),
    [sym_comment] = ACTIONS(57),
  },
  [3608] = {
    [anon_sym_esac] = ACTIONS(8988),
    [anon_sym_DOLLAR] = ACTIONS(8990),
    [sym__special_character] = ACTIONS(8992),
    [anon_sym_DQUOTE] = ACTIONS(8992),
    [sym_raw_string] = ACTIONS(8992),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8992),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8992),
    [anon_sym_BQUOTE] = ACTIONS(8992),
    [anon_sym_LT_LPAREN] = ACTIONS(8992),
    [anon_sym_GT_LPAREN] = ACTIONS(8992),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8990),
  },
  [3609] = {
    [anon_sym_LT] = ACTIONS(8994),
    [anon_sym_GT] = ACTIONS(8994),
    [anon_sym_GT_GT] = ACTIONS(8996),
    [anon_sym_AMP_GT] = ACTIONS(8994),
    [anon_sym_AMP_GT_GT] = ACTIONS(8996),
    [anon_sym_LT_AMP] = ACTIONS(8996),
    [anon_sym_GT_AMP] = ACTIONS(8996),
    [sym_comment] = ACTIONS(57),
  },
  [3610] = {
    [sym_file_descriptor] = ACTIONS(1237),
    [sym_variable_name] = ACTIONS(1237),
    [anon_sym_for] = ACTIONS(1241),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1237),
    [anon_sym_while] = ACTIONS(1241),
    [anon_sym_if] = ACTIONS(1241),
    [anon_sym_case] = ACTIONS(1241),
    [anon_sym_esac] = ACTIONS(4996),
    [anon_sym_SEMI_SEMI] = ACTIONS(1239),
    [anon_sym_function] = ACTIONS(1241),
    [anon_sym_LPAREN] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1237),
    [anon_sym_BANG] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(1241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1237),
    [anon_sym_declare] = ACTIONS(1241),
    [anon_sym_typeset] = ACTIONS(1241),
    [anon_sym_export] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_local] = ACTIONS(1241),
    [anon_sym_unset] = ACTIONS(1241),
    [anon_sym_unsetenv] = ACTIONS(1241),
    [anon_sym_LT] = ACTIONS(1241),
    [anon_sym_GT] = ACTIONS(1241),
    [anon_sym_GT_GT] = ACTIONS(1237),
    [anon_sym_AMP_GT] = ACTIONS(1241),
    [anon_sym_AMP_GT_GT] = ACTIONS(1237),
    [anon_sym_LT_AMP] = ACTIONS(1237),
    [anon_sym_GT_AMP] = ACTIONS(1237),
    [anon_sym_DOLLAR] = ACTIONS(1241),
    [sym__special_character] = ACTIONS(1241),
    [anon_sym_DQUOTE] = ACTIONS(1237),
    [sym_raw_string] = ACTIONS(1237),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1237),
    [anon_sym_BQUOTE] = ACTIONS(1237),
    [anon_sym_LT_LPAREN] = ACTIONS(1237),
    [anon_sym_GT_LPAREN] = ACTIONS(1237),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1241),
  },
  [3611] = {
    [sym_redirected_statement] = STATE(3986),
    [sym_for_statement] = STATE(3986),
    [sym_c_style_for_statement] = STATE(3986),
    [sym_while_statement] = STATE(3986),
    [sym_if_statement] = STATE(3986),
    [sym_case_statement] = STATE(3986),
    [sym_function_definition] = STATE(3986),
    [sym_compound_statement] = STATE(3986),
    [sym_subshell] = STATE(3986),
    [sym_pipeline] = STATE(3986),
    [sym_list] = STATE(3986),
    [sym_negated_command] = STATE(3986),
    [sym_test_command] = STATE(3986),
    [sym_declaration_command] = STATE(3986),
    [sym_unset_command] = STATE(3986),
    [sym_command] = STATE(3986),
    [sym_command_name] = STATE(3098),
    [sym_variable_assignment] = STATE(3987),
    [sym_subscript] = STATE(3100),
    [sym_file_redirect] = STATE(3103),
    [sym_concatenation] = STATE(3101),
    [sym_string] = STATE(3090),
    [sym_simple_expansion] = STATE(3090),
    [sym_string_expansion] = STATE(3090),
    [sym_expansion] = STATE(3090),
    [sym_command_substitution] = STATE(3090),
    [sym_process_substitution] = STATE(3090),
    [aux_sym_command_repeat1] = STATE(3103),
    [aux_sym__literal_repeat1] = STATE(3104),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(6852),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(6858),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(6860),
    [anon_sym_typeset] = ACTIONS(6860),
    [anon_sym_export] = ACTIONS(6860),
    [anon_sym_readonly] = ACTIONS(6860),
    [anon_sym_local] = ACTIONS(6860),
    [anon_sym_unset] = ACTIONS(6862),
    [anon_sym_unsetenv] = ACTIONS(6862),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(6864),
    [sym__special_character] = ACTIONS(6866),
    [anon_sym_DQUOTE] = ACTIONS(6868),
    [sym_raw_string] = ACTIONS(6870),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6874),
    [anon_sym_BQUOTE] = ACTIONS(6876),
    [anon_sym_LT_LPAREN] = ACTIONS(6878),
    [anon_sym_GT_LPAREN] = ACTIONS(6878),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6880),
  },
  [3612] = {
    [sym_redirected_statement] = STATE(3988),
    [sym_for_statement] = STATE(3988),
    [sym_c_style_for_statement] = STATE(3988),
    [sym_while_statement] = STATE(3988),
    [sym_if_statement] = STATE(3988),
    [sym_case_statement] = STATE(3988),
    [sym_function_definition] = STATE(3988),
    [sym_compound_statement] = STATE(3988),
    [sym_subshell] = STATE(3988),
    [sym_pipeline] = STATE(3988),
    [sym_list] = STATE(3988),
    [sym_negated_command] = STATE(3988),
    [sym_test_command] = STATE(3988),
    [sym_declaration_command] = STATE(3988),
    [sym_unset_command] = STATE(3988),
    [sym_command] = STATE(3988),
    [sym_command_name] = STATE(3098),
    [sym_variable_assignment] = STATE(3989),
    [sym_subscript] = STATE(3100),
    [sym_file_redirect] = STATE(3103),
    [sym_concatenation] = STATE(3101),
    [sym_string] = STATE(3090),
    [sym_simple_expansion] = STATE(3090),
    [sym_string_expansion] = STATE(3090),
    [sym_expansion] = STATE(3090),
    [sym_command_substitution] = STATE(3090),
    [sym_process_substitution] = STATE(3090),
    [aux_sym_command_repeat1] = STATE(3103),
    [aux_sym__literal_repeat1] = STATE(3104),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(6852),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(6858),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(6860),
    [anon_sym_typeset] = ACTIONS(6860),
    [anon_sym_export] = ACTIONS(6860),
    [anon_sym_readonly] = ACTIONS(6860),
    [anon_sym_local] = ACTIONS(6860),
    [anon_sym_unset] = ACTIONS(6862),
    [anon_sym_unsetenv] = ACTIONS(6862),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(6864),
    [sym__special_character] = ACTIONS(6866),
    [anon_sym_DQUOTE] = ACTIONS(6868),
    [sym_raw_string] = ACTIONS(6870),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6874),
    [anon_sym_BQUOTE] = ACTIONS(6876),
    [anon_sym_LT_LPAREN] = ACTIONS(6878),
    [anon_sym_GT_LPAREN] = ACTIONS(6878),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6880),
  },
  [3613] = {
    [sym_concatenation] = STATE(696),
    [sym_string] = STATE(3991),
    [sym_simple_expansion] = STATE(3991),
    [sym_string_expansion] = STATE(3991),
    [sym_expansion] = STATE(3991),
    [sym_command_substitution] = STATE(3991),
    [sym_process_substitution] = STATE(3991),
    [aux_sym__literal_repeat1] = STATE(3992),
    [anon_sym_DOLLAR] = ACTIONS(4998),
    [sym__special_character] = ACTIONS(8998),
    [anon_sym_DQUOTE] = ACTIONS(5002),
    [sym_raw_string] = ACTIONS(9000),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5006),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5008),
    [anon_sym_BQUOTE] = ACTIONS(5010),
    [anon_sym_LT_LPAREN] = ACTIONS(5012),
    [anon_sym_GT_LPAREN] = ACTIONS(5012),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9000),
  },
  [3614] = {
    [sym_concatenation] = STATE(700),
    [sym_string] = STATE(3993),
    [sym_simple_expansion] = STATE(3993),
    [sym_string_expansion] = STATE(3993),
    [sym_expansion] = STATE(3993),
    [sym_command_substitution] = STATE(3993),
    [sym_process_substitution] = STATE(3993),
    [aux_sym__literal_repeat1] = STATE(3994),
    [anon_sym_DOLLAR] = ACTIONS(4998),
    [sym__special_character] = ACTIONS(8998),
    [anon_sym_DQUOTE] = ACTIONS(5002),
    [sym_raw_string] = ACTIONS(9002),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5006),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5008),
    [anon_sym_BQUOTE] = ACTIONS(5010),
    [anon_sym_LT_LPAREN] = ACTIONS(5012),
    [anon_sym_GT_LPAREN] = ACTIONS(5012),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9002),
  },
  [3615] = {
    [anon_sym_SEMI] = ACTIONS(9004),
    [anon_sym_esac] = ACTIONS(1239),
    [anon_sym_SEMI_SEMI] = ACTIONS(1239),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(9006),
    [anon_sym_AMP] = ACTIONS(9006),
  },
  [3616] = {
    [sym_file_redirect] = STATE(3996),
    [sym_heredoc_redirect] = STATE(3996),
    [sym_herestring_redirect] = STATE(3996),
    [aux_sym_redirected_statement_repeat1] = STATE(3996),
    [sym__simple_heredoc_body] = ACTIONS(1255),
    [sym__heredoc_body_beginning] = ACTIONS(1255),
    [sym_file_descriptor] = ACTIONS(8155),
    [anon_sym_SEMI] = ACTIONS(1257),
    [anon_sym_esac] = ACTIONS(1255),
    [anon_sym_PIPE] = ACTIONS(1257),
    [anon_sym_SEMI_SEMI] = ACTIONS(1255),
    [anon_sym_PIPE_AMP] = ACTIONS(1255),
    [anon_sym_AMP_AMP] = ACTIONS(1255),
    [anon_sym_PIPE_PIPE] = ACTIONS(1255),
    [anon_sym_LT] = ACTIONS(8165),
    [anon_sym_GT] = ACTIONS(8165),
    [anon_sym_GT_GT] = ACTIONS(8167),
    [anon_sym_AMP_GT] = ACTIONS(8165),
    [anon_sym_AMP_GT_GT] = ACTIONS(8167),
    [anon_sym_LT_AMP] = ACTIONS(8167),
    [anon_sym_GT_AMP] = ACTIONS(8167),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(8169),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1257),
  },
  [3617] = {
    [sym_concatenation] = STATE(3997),
    [sym_string] = STATE(3998),
    [sym_simple_expansion] = STATE(3998),
    [sym_string_expansion] = STATE(3998),
    [sym_expansion] = STATE(3998),
    [sym_command_substitution] = STATE(3998),
    [sym_process_substitution] = STATE(3998),
    [aux_sym__literal_repeat1] = STATE(3999),
    [sym_regex] = ACTIONS(9008),
    [anon_sym_DOLLAR] = ACTIONS(6864),
    [sym__special_character] = ACTIONS(8175),
    [anon_sym_DQUOTE] = ACTIONS(6868),
    [sym_raw_string] = ACTIONS(9010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6874),
    [anon_sym_BQUOTE] = ACTIONS(6876),
    [anon_sym_LT_LPAREN] = ACTIONS(6878),
    [anon_sym_GT_LPAREN] = ACTIONS(6878),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9010),
  },
  [3618] = {
    [aux_sym_concatenation_repeat1] = STATE(3596),
    [sym__simple_heredoc_body] = ACTIONS(1263),
    [sym__heredoc_body_beginning] = ACTIONS(1263),
    [sym_file_descriptor] = ACTIONS(1263),
    [sym__concat] = ACTIONS(8135),
    [anon_sym_SEMI] = ACTIONS(1265),
    [anon_sym_esac] = ACTIONS(1265),
    [anon_sym_PIPE] = ACTIONS(1265),
    [anon_sym_SEMI_SEMI] = ACTIONS(1263),
    [anon_sym_PIPE_AMP] = ACTIONS(1263),
    [anon_sym_AMP_AMP] = ACTIONS(1263),
    [anon_sym_PIPE_PIPE] = ACTIONS(1263),
    [anon_sym_EQ_TILDE] = ACTIONS(1265),
    [anon_sym_EQ_EQ] = ACTIONS(1265),
    [anon_sym_LT] = ACTIONS(1265),
    [anon_sym_GT] = ACTIONS(1265),
    [anon_sym_GT_GT] = ACTIONS(1263),
    [anon_sym_AMP_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT_GT] = ACTIONS(1263),
    [anon_sym_LT_AMP] = ACTIONS(1263),
    [anon_sym_GT_AMP] = ACTIONS(1263),
    [anon_sym_LT_LT] = ACTIONS(1265),
    [anon_sym_LT_LT_DASH] = ACTIONS(1263),
    [anon_sym_LT_LT_LT] = ACTIONS(1263),
    [anon_sym_DOLLAR] = ACTIONS(1265),
    [sym__special_character] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(1263),
    [sym_raw_string] = ACTIONS(1263),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1263),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1263),
    [anon_sym_BQUOTE] = ACTIONS(1263),
    [anon_sym_LT_LPAREN] = ACTIONS(1263),
    [anon_sym_GT_LPAREN] = ACTIONS(1263),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1265),
    [anon_sym_LF] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1265),
  },
  [3619] = {
    [sym_concatenation] = STATE(4000),
    [sym_string] = STATE(3618),
    [sym_simple_expansion] = STATE(3618),
    [sym_string_expansion] = STATE(3618),
    [sym_expansion] = STATE(3618),
    [sym_command_substitution] = STATE(3618),
    [sym_process_substitution] = STATE(3618),
    [aux_sym_command_repeat2] = STATE(4000),
    [aux_sym__literal_repeat1] = STATE(3620),
    [sym__simple_heredoc_body] = ACTIONS(1267),
    [sym__heredoc_body_beginning] = ACTIONS(1267),
    [sym_file_descriptor] = ACTIONS(1267),
    [anon_sym_SEMI] = ACTIONS(1269),
    [anon_sym_esac] = ACTIONS(1269),
    [anon_sym_PIPE] = ACTIONS(1269),
    [anon_sym_SEMI_SEMI] = ACTIONS(1267),
    [anon_sym_PIPE_AMP] = ACTIONS(1267),
    [anon_sym_AMP_AMP] = ACTIONS(1267),
    [anon_sym_PIPE_PIPE] = ACTIONS(1267),
    [anon_sym_EQ_TILDE] = ACTIONS(8173),
    [anon_sym_EQ_EQ] = ACTIONS(8173),
    [anon_sym_LT] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1269),
    [anon_sym_GT_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT_GT] = ACTIONS(1267),
    [anon_sym_LT_AMP] = ACTIONS(1267),
    [anon_sym_GT_AMP] = ACTIONS(1267),
    [anon_sym_LT_LT] = ACTIONS(1269),
    [anon_sym_LT_LT_DASH] = ACTIONS(1267),
    [anon_sym_LT_LT_LT] = ACTIONS(1267),
    [anon_sym_DOLLAR] = ACTIONS(6864),
    [sym__special_character] = ACTIONS(8175),
    [anon_sym_DQUOTE] = ACTIONS(6868),
    [sym_raw_string] = ACTIONS(8177),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6874),
    [anon_sym_BQUOTE] = ACTIONS(6876),
    [anon_sym_LT_LPAREN] = ACTIONS(6878),
    [anon_sym_GT_LPAREN] = ACTIONS(6878),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8179),
    [anon_sym_LF] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(1269),
  },
  [3620] = {
    [aux_sym__literal_repeat1] = STATE(3625),
    [sym__simple_heredoc_body] = ACTIONS(1271),
    [sym__heredoc_body_beginning] = ACTIONS(1271),
    [sym_file_descriptor] = ACTIONS(1271),
    [anon_sym_SEMI] = ACTIONS(1273),
    [anon_sym_esac] = ACTIONS(1273),
    [anon_sym_PIPE] = ACTIONS(1273),
    [anon_sym_SEMI_SEMI] = ACTIONS(1271),
    [anon_sym_PIPE_AMP] = ACTIONS(1271),
    [anon_sym_AMP_AMP] = ACTIONS(1271),
    [anon_sym_PIPE_PIPE] = ACTIONS(1271),
    [anon_sym_EQ_TILDE] = ACTIONS(1273),
    [anon_sym_EQ_EQ] = ACTIONS(1273),
    [anon_sym_LT] = ACTIONS(1273),
    [anon_sym_GT] = ACTIONS(1273),
    [anon_sym_GT_GT] = ACTIONS(1271),
    [anon_sym_AMP_GT] = ACTIONS(1273),
    [anon_sym_AMP_GT_GT] = ACTIONS(1271),
    [anon_sym_LT_AMP] = ACTIONS(1271),
    [anon_sym_GT_AMP] = ACTIONS(1271),
    [anon_sym_LT_LT] = ACTIONS(1273),
    [anon_sym_LT_LT_DASH] = ACTIONS(1271),
    [anon_sym_LT_LT_LT] = ACTIONS(1271),
    [anon_sym_DOLLAR] = ACTIONS(1273),
    [sym__special_character] = ACTIONS(8181),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [sym_raw_string] = ACTIONS(1271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1271),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1271),
    [anon_sym_BQUOTE] = ACTIONS(1271),
    [anon_sym_LT_LPAREN] = ACTIONS(1271),
    [anon_sym_GT_LPAREN] = ACTIONS(1271),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1273),
    [anon_sym_LF] = ACTIONS(1271),
    [anon_sym_AMP] = ACTIONS(1273),
  },
  [3621] = {
    [sym_file_redirect] = STATE(3616),
    [sym_heredoc_redirect] = STATE(3616),
    [sym_heredoc_body] = STATE(4002),
    [sym_herestring_redirect] = STATE(3616),
    [aux_sym_redirected_statement_repeat1] = STATE(3616),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(8155),
    [anon_sym_SEMI] = ACTIONS(9012),
    [anon_sym_esac] = ACTIONS(1239),
    [anon_sym_PIPE] = ACTIONS(8159),
    [anon_sym_SEMI_SEMI] = ACTIONS(1239),
    [anon_sym_PIPE_AMP] = ACTIONS(8161),
    [anon_sym_AMP_AMP] = ACTIONS(8163),
    [anon_sym_PIPE_PIPE] = ACTIONS(8163),
    [anon_sym_LT] = ACTIONS(8165),
    [anon_sym_GT] = ACTIONS(8165),
    [anon_sym_GT_GT] = ACTIONS(8167),
    [anon_sym_AMP_GT] = ACTIONS(8165),
    [anon_sym_AMP_GT_GT] = ACTIONS(8167),
    [anon_sym_LT_AMP] = ACTIONS(8167),
    [anon_sym_GT_AMP] = ACTIONS(8167),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(8169),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(9014),
    [anon_sym_AMP] = ACTIONS(9012),
  },
  [3622] = {
    [sym_file_redirect] = STATE(3616),
    [sym_heredoc_redirect] = STATE(3616),
    [sym_heredoc_body] = STATE(4002),
    [sym_herestring_redirect] = STATE(3616),
    [aux_sym_redirected_statement_repeat1] = STATE(3616),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(9012),
    [anon_sym_esac] = ACTIONS(4996),
    [anon_sym_PIPE] = ACTIONS(8159),
    [anon_sym_SEMI_SEMI] = ACTIONS(1239),
    [anon_sym_PIPE_AMP] = ACTIONS(8161),
    [anon_sym_AMP_AMP] = ACTIONS(8163),
    [anon_sym_PIPE_PIPE] = ACTIONS(8163),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(8169),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(9014),
    [anon_sym_AMP] = ACTIONS(9012),
  },
  [3623] = {
    [sym_concatenation] = STATE(4003),
    [sym_string] = STATE(3618),
    [sym_simple_expansion] = STATE(3618),
    [sym_string_expansion] = STATE(3618),
    [sym_expansion] = STATE(3618),
    [sym_command_substitution] = STATE(3618),
    [sym_process_substitution] = STATE(3618),
    [aux_sym_command_repeat2] = STATE(4003),
    [aux_sym__literal_repeat1] = STATE(3620),
    [sym__simple_heredoc_body] = ACTIONS(1267),
    [sym__heredoc_body_beginning] = ACTIONS(1267),
    [sym_file_descriptor] = ACTIONS(1267),
    [anon_sym_SEMI] = ACTIONS(1269),
    [anon_sym_esac] = ACTIONS(1269),
    [anon_sym_PIPE] = ACTIONS(1269),
    [anon_sym_SEMI_SEMI] = ACTIONS(1267),
    [anon_sym_PIPE_AMP] = ACTIONS(1267),
    [anon_sym_AMP_AMP] = ACTIONS(1267),
    [anon_sym_PIPE_PIPE] = ACTIONS(1267),
    [anon_sym_EQ_TILDE] = ACTIONS(8173),
    [anon_sym_EQ_EQ] = ACTIONS(8173),
    [anon_sym_LT] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1269),
    [anon_sym_GT_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT_GT] = ACTIONS(1267),
    [anon_sym_LT_AMP] = ACTIONS(1267),
    [anon_sym_GT_AMP] = ACTIONS(1267),
    [anon_sym_LT_LT] = ACTIONS(1269),
    [anon_sym_LT_LT_DASH] = ACTIONS(1267),
    [anon_sym_LT_LT_LT] = ACTIONS(1267),
    [anon_sym_DOLLAR] = ACTIONS(6864),
    [sym__special_character] = ACTIONS(8175),
    [anon_sym_DQUOTE] = ACTIONS(6868),
    [sym_raw_string] = ACTIONS(8177),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6874),
    [anon_sym_BQUOTE] = ACTIONS(6876),
    [anon_sym_LT_LPAREN] = ACTIONS(6878),
    [anon_sym_GT_LPAREN] = ACTIONS(6878),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8179),
    [anon_sym_LF] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(1269),
  },
  [3624] = {
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_esac] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_EQ_TILDE] = ACTIONS(339),
    [anon_sym_EQ_EQ] = ACTIONS(339),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [3625] = {
    [aux_sym__literal_repeat1] = STATE(3625),
    [sym__simple_heredoc_body] = ACTIONS(1373),
    [sym__heredoc_body_beginning] = ACTIONS(1373),
    [sym_file_descriptor] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_esac] = ACTIONS(1375),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE_AMP] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_EQ_TILDE] = ACTIONS(1375),
    [anon_sym_EQ_EQ] = ACTIONS(1375),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_LT_LT_DASH] = ACTIONS(1373),
    [anon_sym_LT_LT_LT] = ACTIONS(1373),
    [anon_sym_DOLLAR] = ACTIONS(1375),
    [sym__special_character] = ACTIONS(9016),
    [anon_sym_DQUOTE] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1373),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [anon_sym_LT_LPAREN] = ACTIONS(1373),
    [anon_sym_GT_LPAREN] = ACTIONS(1373),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1375),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
  },
  [3626] = {
    [anon_sym_esac] = ACTIONS(9019),
    [anon_sym_SEMI_SEMI] = ACTIONS(9021),
    [sym_comment] = ACTIONS(57),
  },
  [3627] = {
    [sym__statements] = STATE(4006),
    [sym_redirected_statement] = STATE(4007),
    [sym_for_statement] = STATE(4007),
    [sym_c_style_for_statement] = STATE(4007),
    [sym_while_statement] = STATE(4007),
    [sym_if_statement] = STATE(4007),
    [sym_case_statement] = STATE(4007),
    [sym_function_definition] = STATE(4007),
    [sym_compound_statement] = STATE(4007),
    [sym_subshell] = STATE(4007),
    [sym_pipeline] = STATE(4007),
    [sym_list] = STATE(4007),
    [sym_negated_command] = STATE(4007),
    [sym_test_command] = STATE(4007),
    [sym_declaration_command] = STATE(4007),
    [sym_unset_command] = STATE(4007),
    [sym_command] = STATE(4007),
    [sym_command_name] = STATE(714),
    [sym_variable_assignment] = STATE(4008),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(716),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(4009),
    [aux_sym_command_repeat1] = STATE(716),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_SEMI_SEMI] = ACTIONS(9023),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(4385),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(4387),
    [anon_sym_typeset] = ACTIONS(4387),
    [anon_sym_export] = ACTIONS(4387),
    [anon_sym_readonly] = ACTIONS(4387),
    [anon_sym_local] = ACTIONS(4387),
    [anon_sym_unset] = ACTIONS(4389),
    [anon_sym_unsetenv] = ACTIONS(4389),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [3628] = {
    [aux_sym_case_item_repeat1] = STATE(3106),
    [anon_sym_PIPE] = ACTIONS(5289),
    [anon_sym_RPAREN] = ACTIONS(9025),
    [sym_comment] = ACTIONS(57),
  },
  [3629] = {
    [sym__statements] = STATE(4012),
    [sym_redirected_statement] = STATE(4007),
    [sym_for_statement] = STATE(4007),
    [sym_c_style_for_statement] = STATE(4007),
    [sym_while_statement] = STATE(4007),
    [sym_if_statement] = STATE(4007),
    [sym_case_statement] = STATE(4007),
    [sym_function_definition] = STATE(4007),
    [sym_compound_statement] = STATE(4007),
    [sym_subshell] = STATE(4007),
    [sym_pipeline] = STATE(4007),
    [sym_list] = STATE(4007),
    [sym_negated_command] = STATE(4007),
    [sym_test_command] = STATE(4007),
    [sym_declaration_command] = STATE(4007),
    [sym_unset_command] = STATE(4007),
    [sym_command] = STATE(4007),
    [sym_command_name] = STATE(714),
    [sym_variable_assignment] = STATE(4008),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(716),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(4009),
    [aux_sym_command_repeat1] = STATE(716),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_SEMI_SEMI] = ACTIONS(9027),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(4385),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(4387),
    [anon_sym_typeset] = ACTIONS(4387),
    [anon_sym_export] = ACTIONS(4387),
    [anon_sym_readonly] = ACTIONS(4387),
    [anon_sym_local] = ACTIONS(4387),
    [anon_sym_unset] = ACTIONS(4389),
    [anon_sym_unsetenv] = ACTIONS(4389),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [3630] = {
    [aux_sym_case_item_repeat1] = STATE(3106),
    [anon_sym_PIPE] = ACTIONS(5289),
    [anon_sym_RPAREN] = ACTIONS(9029),
    [sym_comment] = ACTIONS(57),
  },
  [3631] = {
    [anon_sym_esac] = ACTIONS(9031),
    [anon_sym_DOLLAR] = ACTIONS(9033),
    [sym__special_character] = ACTIONS(9035),
    [anon_sym_DQUOTE] = ACTIONS(9035),
    [sym_raw_string] = ACTIONS(9035),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(9035),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(9035),
    [anon_sym_BQUOTE] = ACTIONS(9035),
    [anon_sym_LT_LPAREN] = ACTIONS(9035),
    [anon_sym_GT_LPAREN] = ACTIONS(9035),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9033),
  },
  [3632] = {
    [anon_sym_esac] = ACTIONS(9037),
    [anon_sym_SEMI_SEMI] = ACTIONS(9039),
    [sym_comment] = ACTIONS(57),
  },
  [3633] = {
    [sym__simple_heredoc_body] = ACTIONS(9041),
    [sym__heredoc_body_beginning] = ACTIONS(9041),
    [sym_file_descriptor] = ACTIONS(9041),
    [ts_builtin_sym_end] = ACTIONS(9041),
    [anon_sym_SEMI] = ACTIONS(9043),
    [anon_sym_done] = ACTIONS(9041),
    [anon_sym_fi] = ACTIONS(9041),
    [anon_sym_elif] = ACTIONS(9041),
    [anon_sym_else] = ACTIONS(9041),
    [anon_sym_esac] = ACTIONS(9041),
    [anon_sym_PIPE] = ACTIONS(9043),
    [anon_sym_RPAREN] = ACTIONS(9041),
    [anon_sym_SEMI_SEMI] = ACTIONS(9041),
    [anon_sym_PIPE_AMP] = ACTIONS(9041),
    [anon_sym_AMP_AMP] = ACTIONS(9041),
    [anon_sym_PIPE_PIPE] = ACTIONS(9041),
    [anon_sym_LT] = ACTIONS(9043),
    [anon_sym_GT] = ACTIONS(9043),
    [anon_sym_GT_GT] = ACTIONS(9041),
    [anon_sym_AMP_GT] = ACTIONS(9043),
    [anon_sym_AMP_GT_GT] = ACTIONS(9041),
    [anon_sym_LT_AMP] = ACTIONS(9041),
    [anon_sym_GT_AMP] = ACTIONS(9041),
    [anon_sym_LT_LT] = ACTIONS(9043),
    [anon_sym_LT_LT_DASH] = ACTIONS(9041),
    [anon_sym_LT_LT_LT] = ACTIONS(9041),
    [anon_sym_BQUOTE] = ACTIONS(9041),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(9041),
    [anon_sym_AMP] = ACTIONS(9043),
  },
  [3634] = {
    [sym__concat] = ACTIONS(8340),
    [anon_sym_in] = ACTIONS(8340),
    [anon_sym_SEMI] = ACTIONS(8342),
    [anon_sym_SEMI_SEMI] = ACTIONS(8340),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8340),
    [anon_sym_AMP] = ACTIONS(8340),
  },
  [3635] = {
    [sym__concat] = ACTIONS(8344),
    [anon_sym_in] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [anon_sym_SEMI_SEMI] = ACTIONS(8344),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8344),
    [anon_sym_AMP] = ACTIONS(8344),
  },
  [3636] = {
    [sym__simple_heredoc_body] = ACTIONS(9045),
    [sym__heredoc_body_beginning] = ACTIONS(9045),
    [sym_file_descriptor] = ACTIONS(9045),
    [ts_builtin_sym_end] = ACTIONS(9045),
    [anon_sym_SEMI] = ACTIONS(9047),
    [anon_sym_done] = ACTIONS(9045),
    [anon_sym_fi] = ACTIONS(9045),
    [anon_sym_elif] = ACTIONS(9045),
    [anon_sym_else] = ACTIONS(9045),
    [anon_sym_esac] = ACTIONS(9045),
    [anon_sym_PIPE] = ACTIONS(9047),
    [anon_sym_RPAREN] = ACTIONS(9045),
    [anon_sym_SEMI_SEMI] = ACTIONS(9045),
    [anon_sym_PIPE_AMP] = ACTIONS(9045),
    [anon_sym_AMP_AMP] = ACTIONS(9045),
    [anon_sym_PIPE_PIPE] = ACTIONS(9045),
    [anon_sym_LT] = ACTIONS(9047),
    [anon_sym_GT] = ACTIONS(9047),
    [anon_sym_GT_GT] = ACTIONS(9045),
    [anon_sym_AMP_GT] = ACTIONS(9047),
    [anon_sym_AMP_GT_GT] = ACTIONS(9045),
    [anon_sym_LT_AMP] = ACTIONS(9045),
    [anon_sym_GT_AMP] = ACTIONS(9045),
    [anon_sym_LT_LT] = ACTIONS(9047),
    [anon_sym_LT_LT_DASH] = ACTIONS(9045),
    [anon_sym_LT_LT_LT] = ACTIONS(9045),
    [anon_sym_BQUOTE] = ACTIONS(9045),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(9045),
    [anon_sym_AMP] = ACTIONS(9047),
  },
  [3637] = {
    [sym__simple_heredoc_body] = ACTIONS(5674),
    [sym__heredoc_body_beginning] = ACTIONS(5674),
    [sym_file_descriptor] = ACTIONS(5674),
    [sym__concat] = ACTIONS(5674),
    [sym_variable_name] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(5676),
    [anon_sym_PIPE] = ACTIONS(5676),
    [anon_sym_SEMI_SEMI] = ACTIONS(5674),
    [anon_sym_RBRACE] = ACTIONS(5674),
    [anon_sym_PIPE_AMP] = ACTIONS(5674),
    [anon_sym_AMP_AMP] = ACTIONS(5674),
    [anon_sym_PIPE_PIPE] = ACTIONS(5674),
    [anon_sym_LT] = ACTIONS(5676),
    [anon_sym_GT] = ACTIONS(5676),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_AMP_GT] = ACTIONS(5676),
    [anon_sym_AMP_GT_GT] = ACTIONS(5674),
    [anon_sym_LT_AMP] = ACTIONS(5674),
    [anon_sym_GT_AMP] = ACTIONS(5674),
    [anon_sym_LT_LT] = ACTIONS(5676),
    [anon_sym_LT_LT_DASH] = ACTIONS(5674),
    [anon_sym_LT_LT_LT] = ACTIONS(5674),
    [anon_sym_DOLLAR] = ACTIONS(5676),
    [sym__special_character] = ACTIONS(5676),
    [anon_sym_DQUOTE] = ACTIONS(5674),
    [sym_raw_string] = ACTIONS(5674),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5674),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5674),
    [anon_sym_BQUOTE] = ACTIONS(5674),
    [anon_sym_LT_LPAREN] = ACTIONS(5674),
    [anon_sym_GT_LPAREN] = ACTIONS(5674),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5676),
    [anon_sym_LF] = ACTIONS(5674),
    [anon_sym_AMP] = ACTIONS(5676),
  },
  [3638] = {
    [sym__simple_heredoc_body] = ACTIONS(5708),
    [sym__heredoc_body_beginning] = ACTIONS(5708),
    [sym_file_descriptor] = ACTIONS(5708),
    [sym__concat] = ACTIONS(5708),
    [sym_variable_name] = ACTIONS(5708),
    [anon_sym_SEMI] = ACTIONS(5710),
    [anon_sym_PIPE] = ACTIONS(5710),
    [anon_sym_SEMI_SEMI] = ACTIONS(5708),
    [anon_sym_RBRACE] = ACTIONS(5708),
    [anon_sym_PIPE_AMP] = ACTIONS(5708),
    [anon_sym_AMP_AMP] = ACTIONS(5708),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_LT] = ACTIONS(5710),
    [anon_sym_GT] = ACTIONS(5710),
    [anon_sym_GT_GT] = ACTIONS(5708),
    [anon_sym_AMP_GT] = ACTIONS(5710),
    [anon_sym_AMP_GT_GT] = ACTIONS(5708),
    [anon_sym_LT_AMP] = ACTIONS(5708),
    [anon_sym_GT_AMP] = ACTIONS(5708),
    [anon_sym_LT_LT] = ACTIONS(5710),
    [anon_sym_LT_LT_DASH] = ACTIONS(5708),
    [anon_sym_LT_LT_LT] = ACTIONS(5708),
    [anon_sym_DOLLAR] = ACTIONS(5710),
    [sym__special_character] = ACTIONS(5710),
    [anon_sym_DQUOTE] = ACTIONS(5708),
    [sym_raw_string] = ACTIONS(5708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5708),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5708),
    [anon_sym_BQUOTE] = ACTIONS(5708),
    [anon_sym_LT_LPAREN] = ACTIONS(5708),
    [anon_sym_GT_LPAREN] = ACTIONS(5708),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5710),
    [anon_sym_LF] = ACTIONS(5708),
    [anon_sym_AMP] = ACTIONS(5710),
  },
  [3639] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(9049),
    [sym_comment] = ACTIONS(57),
  },
  [3640] = {
    [anon_sym_RBRACE] = ACTIONS(9049),
    [sym_comment] = ACTIONS(57),
  },
  [3641] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(9051),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [3642] = {
    [sym_concatenation] = STATE(4018),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4018),
    [anon_sym_RBRACE] = ACTIONS(9053),
    [anon_sym_EQ] = ACTIONS(9055),
    [anon_sym_DASH] = ACTIONS(9055),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9055),
    [anon_sym_COLON_QMARK] = ACTIONS(9055),
    [anon_sym_COLON_DASH] = ACTIONS(9055),
    [anon_sym_PERCENT] = ACTIONS(9055),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3643] = {
    [sym__simple_heredoc_body] = ACTIONS(5725),
    [sym__heredoc_body_beginning] = ACTIONS(5725),
    [sym_file_descriptor] = ACTIONS(5725),
    [sym__concat] = ACTIONS(5725),
    [sym_variable_name] = ACTIONS(5725),
    [anon_sym_SEMI] = ACTIONS(5727),
    [anon_sym_PIPE] = ACTIONS(5727),
    [anon_sym_SEMI_SEMI] = ACTIONS(5725),
    [anon_sym_RBRACE] = ACTIONS(5725),
    [anon_sym_PIPE_AMP] = ACTIONS(5725),
    [anon_sym_AMP_AMP] = ACTIONS(5725),
    [anon_sym_PIPE_PIPE] = ACTIONS(5725),
    [anon_sym_LT] = ACTIONS(5727),
    [anon_sym_GT] = ACTIONS(5727),
    [anon_sym_GT_GT] = ACTIONS(5725),
    [anon_sym_AMP_GT] = ACTIONS(5727),
    [anon_sym_AMP_GT_GT] = ACTIONS(5725),
    [anon_sym_LT_AMP] = ACTIONS(5725),
    [anon_sym_GT_AMP] = ACTIONS(5725),
    [anon_sym_LT_LT] = ACTIONS(5727),
    [anon_sym_LT_LT_DASH] = ACTIONS(5725),
    [anon_sym_LT_LT_LT] = ACTIONS(5725),
    [anon_sym_DOLLAR] = ACTIONS(5727),
    [sym__special_character] = ACTIONS(5727),
    [anon_sym_DQUOTE] = ACTIONS(5725),
    [sym_raw_string] = ACTIONS(5725),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5725),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5725),
    [anon_sym_BQUOTE] = ACTIONS(5725),
    [anon_sym_LT_LPAREN] = ACTIONS(5725),
    [anon_sym_GT_LPAREN] = ACTIONS(5725),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5727),
    [anon_sym_LF] = ACTIONS(5725),
    [anon_sym_AMP] = ACTIONS(5727),
  },
  [3644] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9053),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3645] = {
    [sym_concatenation] = STATE(4019),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4019),
    [anon_sym_RBRACE] = ACTIONS(9049),
    [anon_sym_EQ] = ACTIONS(9059),
    [anon_sym_DASH] = ACTIONS(9059),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9061),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9059),
    [anon_sym_COLON_QMARK] = ACTIONS(9059),
    [anon_sym_COLON_DASH] = ACTIONS(9059),
    [anon_sym_PERCENT] = ACTIONS(9059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3646] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9049),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3647] = {
    [sym__simple_heredoc_body] = ACTIONS(5770),
    [sym__heredoc_body_beginning] = ACTIONS(5770),
    [sym_file_descriptor] = ACTIONS(5770),
    [sym__concat] = ACTIONS(5770),
    [sym_variable_name] = ACTIONS(5770),
    [anon_sym_SEMI] = ACTIONS(5772),
    [anon_sym_PIPE] = ACTIONS(5772),
    [anon_sym_SEMI_SEMI] = ACTIONS(5770),
    [anon_sym_RBRACE] = ACTIONS(5770),
    [anon_sym_PIPE_AMP] = ACTIONS(5770),
    [anon_sym_AMP_AMP] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5770),
    [anon_sym_LT] = ACTIONS(5772),
    [anon_sym_GT] = ACTIONS(5772),
    [anon_sym_GT_GT] = ACTIONS(5770),
    [anon_sym_AMP_GT] = ACTIONS(5772),
    [anon_sym_AMP_GT_GT] = ACTIONS(5770),
    [anon_sym_LT_AMP] = ACTIONS(5770),
    [anon_sym_GT_AMP] = ACTIONS(5770),
    [anon_sym_LT_LT] = ACTIONS(5772),
    [anon_sym_LT_LT_DASH] = ACTIONS(5770),
    [anon_sym_LT_LT_LT] = ACTIONS(5770),
    [anon_sym_DOLLAR] = ACTIONS(5772),
    [sym__special_character] = ACTIONS(5772),
    [anon_sym_DQUOTE] = ACTIONS(5770),
    [sym_raw_string] = ACTIONS(5770),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5770),
    [anon_sym_BQUOTE] = ACTIONS(5770),
    [anon_sym_LT_LPAREN] = ACTIONS(5770),
    [anon_sym_GT_LPAREN] = ACTIONS(5770),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5772),
    [anon_sym_LF] = ACTIONS(5770),
    [anon_sym_AMP] = ACTIONS(5772),
  },
  [3648] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9063),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3649] = {
    [sym__simple_heredoc_body] = ACTIONS(7316),
    [sym__heredoc_body_beginning] = ACTIONS(7316),
    [sym_file_descriptor] = ACTIONS(7316),
    [anon_sym_SEMI] = ACTIONS(7318),
    [anon_sym_PIPE] = ACTIONS(7318),
    [anon_sym_SEMI_SEMI] = ACTIONS(7316),
    [anon_sym_RBRACE] = ACTIONS(7316),
    [anon_sym_PIPE_AMP] = ACTIONS(7316),
    [anon_sym_AMP_AMP] = ACTIONS(7316),
    [anon_sym_PIPE_PIPE] = ACTIONS(7316),
    [anon_sym_LT] = ACTIONS(7318),
    [anon_sym_GT] = ACTIONS(7318),
    [anon_sym_GT_GT] = ACTIONS(7316),
    [anon_sym_AMP_GT] = ACTIONS(7318),
    [anon_sym_AMP_GT_GT] = ACTIONS(7316),
    [anon_sym_LT_AMP] = ACTIONS(7316),
    [anon_sym_GT_AMP] = ACTIONS(7316),
    [anon_sym_LT_LT] = ACTIONS(7318),
    [anon_sym_LT_LT_DASH] = ACTIONS(7316),
    [anon_sym_LT_LT_LT] = ACTIONS(7316),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(7316),
    [anon_sym_AMP] = ACTIONS(7318),
  },
  [3650] = {
    [sym_do_group] = STATE(4021),
    [sym_compound_statement] = STATE(4021),
    [anon_sym_do] = ACTIONS(1953),
    [anon_sym_LBRACE] = ACTIONS(191),
    [sym_comment] = ACTIONS(57),
  },
  [3651] = {
    [sym_do_group] = STATE(4021),
    [sym_compound_statement] = STATE(4021),
    [anon_sym_SEMI] = ACTIONS(9065),
    [anon_sym_do] = ACTIONS(1953),
    [anon_sym_LBRACE] = ACTIONS(191),
    [sym_comment] = ACTIONS(57),
  },
  [3652] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(9067),
    [anon_sym_AMP_AMP] = ACTIONS(557),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(559),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_PLUS_EQ] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DASH_EQ] = ACTIONS(557),
    [anon_sym_LT_EQ] = ACTIONS(557),
    [anon_sym_GT_EQ] = ACTIONS(557),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(557),
  },
  [3653] = {
    [sym__simple_heredoc_body] = ACTIONS(8065),
    [sym__heredoc_body_beginning] = ACTIONS(8065),
    [sym_file_descriptor] = ACTIONS(8065),
    [anon_sym_SEMI] = ACTIONS(8067),
    [anon_sym_PIPE] = ACTIONS(8067),
    [anon_sym_SEMI_SEMI] = ACTIONS(8065),
    [anon_sym_RBRACE] = ACTIONS(8065),
    [anon_sym_PIPE_AMP] = ACTIONS(8065),
    [anon_sym_AMP_AMP] = ACTIONS(8065),
    [anon_sym_PIPE_PIPE] = ACTIONS(8065),
    [anon_sym_LT] = ACTIONS(8067),
    [anon_sym_GT] = ACTIONS(8067),
    [anon_sym_GT_GT] = ACTIONS(8065),
    [anon_sym_AMP_GT] = ACTIONS(8067),
    [anon_sym_AMP_GT_GT] = ACTIONS(8065),
    [anon_sym_LT_AMP] = ACTIONS(8065),
    [anon_sym_GT_AMP] = ACTIONS(8065),
    [anon_sym_LT_LT] = ACTIONS(8067),
    [anon_sym_LT_LT_DASH] = ACTIONS(8065),
    [anon_sym_LT_LT_LT] = ACTIONS(8065),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8065),
    [anon_sym_AMP] = ACTIONS(8067),
  },
  [3654] = {
    [sym__simple_heredoc_body] = ACTIONS(8186),
    [sym__heredoc_body_beginning] = ACTIONS(8186),
    [sym_file_descriptor] = ACTIONS(8186),
    [anon_sym_SEMI] = ACTIONS(8188),
    [anon_sym_PIPE] = ACTIONS(8188),
    [anon_sym_SEMI_SEMI] = ACTIONS(8186),
    [anon_sym_RBRACE] = ACTIONS(8186),
    [anon_sym_PIPE_AMP] = ACTIONS(8186),
    [anon_sym_AMP_AMP] = ACTIONS(8186),
    [anon_sym_PIPE_PIPE] = ACTIONS(8186),
    [anon_sym_LT] = ACTIONS(8188),
    [anon_sym_GT] = ACTIONS(8188),
    [anon_sym_GT_GT] = ACTIONS(8186),
    [anon_sym_AMP_GT] = ACTIONS(8188),
    [anon_sym_AMP_GT_GT] = ACTIONS(8186),
    [anon_sym_LT_AMP] = ACTIONS(8186),
    [anon_sym_GT_AMP] = ACTIONS(8186),
    [anon_sym_LT_LT] = ACTIONS(8188),
    [anon_sym_LT_LT_DASH] = ACTIONS(8186),
    [anon_sym_LT_LT_LT] = ACTIONS(8186),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8186),
    [anon_sym_AMP] = ACTIONS(8188),
  },
  [3655] = {
    [anon_sym_esac] = ACTIONS(9069),
    [sym_comment] = ACTIONS(57),
  },
  [3656] = {
    [sym__simple_heredoc_body] = ACTIONS(8210),
    [sym__heredoc_body_beginning] = ACTIONS(8210),
    [sym_file_descriptor] = ACTIONS(8210),
    [anon_sym_SEMI] = ACTIONS(8212),
    [anon_sym_PIPE] = ACTIONS(8212),
    [anon_sym_SEMI_SEMI] = ACTIONS(8210),
    [anon_sym_RBRACE] = ACTIONS(8210),
    [anon_sym_PIPE_AMP] = ACTIONS(8210),
    [anon_sym_AMP_AMP] = ACTIONS(8210),
    [anon_sym_PIPE_PIPE] = ACTIONS(8210),
    [anon_sym_LT] = ACTIONS(8212),
    [anon_sym_GT] = ACTIONS(8212),
    [anon_sym_GT_GT] = ACTIONS(8210),
    [anon_sym_AMP_GT] = ACTIONS(8212),
    [anon_sym_AMP_GT_GT] = ACTIONS(8210),
    [anon_sym_LT_AMP] = ACTIONS(8210),
    [anon_sym_GT_AMP] = ACTIONS(8210),
    [anon_sym_LT_LT] = ACTIONS(8212),
    [anon_sym_LT_LT_DASH] = ACTIONS(8210),
    [anon_sym_LT_LT_LT] = ACTIONS(8210),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8210),
    [anon_sym_AMP] = ACTIONS(8212),
  },
  [3657] = {
    [anon_sym_esac] = ACTIONS(9071),
    [sym_comment] = ACTIONS(57),
  },
  [3658] = {
    [sym__simple_heredoc_body] = ACTIONS(7198),
    [sym__heredoc_body_beginning] = ACTIONS(7198),
    [sym_file_descriptor] = ACTIONS(7198),
    [sym__concat] = ACTIONS(7198),
    [sym_variable_name] = ACTIONS(7198),
    [anon_sym_SEMI] = ACTIONS(7200),
    [anon_sym_PIPE] = ACTIONS(7200),
    [anon_sym_SEMI_SEMI] = ACTIONS(7198),
    [anon_sym_RBRACE] = ACTIONS(7198),
    [anon_sym_PIPE_AMP] = ACTIONS(7198),
    [anon_sym_AMP_AMP] = ACTIONS(7198),
    [anon_sym_PIPE_PIPE] = ACTIONS(7198),
    [anon_sym_LT] = ACTIONS(7200),
    [anon_sym_GT] = ACTIONS(7200),
    [anon_sym_GT_GT] = ACTIONS(7198),
    [anon_sym_AMP_GT] = ACTIONS(7200),
    [anon_sym_AMP_GT_GT] = ACTIONS(7198),
    [anon_sym_LT_AMP] = ACTIONS(7198),
    [anon_sym_GT_AMP] = ACTIONS(7198),
    [anon_sym_LT_LT] = ACTIONS(7200),
    [anon_sym_LT_LT_DASH] = ACTIONS(7198),
    [anon_sym_LT_LT_LT] = ACTIONS(7198),
    [anon_sym_DOLLAR] = ACTIONS(7200),
    [sym__special_character] = ACTIONS(7200),
    [anon_sym_DQUOTE] = ACTIONS(7198),
    [sym_raw_string] = ACTIONS(7198),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7198),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7198),
    [anon_sym_BQUOTE] = ACTIONS(7198),
    [anon_sym_LT_LPAREN] = ACTIONS(7198),
    [anon_sym_GT_LPAREN] = ACTIONS(7198),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7200),
    [sym_word] = ACTIONS(7200),
    [anon_sym_LF] = ACTIONS(7198),
    [anon_sym_AMP] = ACTIONS(7200),
  },
  [3659] = {
    [sym__simple_heredoc_body] = ACTIONS(7202),
    [sym__heredoc_body_beginning] = ACTIONS(7202),
    [sym_file_descriptor] = ACTIONS(7202),
    [sym__concat] = ACTIONS(7202),
    [sym_variable_name] = ACTIONS(7202),
    [anon_sym_SEMI] = ACTIONS(7204),
    [anon_sym_PIPE] = ACTIONS(7204),
    [anon_sym_SEMI_SEMI] = ACTIONS(7202),
    [anon_sym_RBRACE] = ACTIONS(7202),
    [anon_sym_PIPE_AMP] = ACTIONS(7202),
    [anon_sym_AMP_AMP] = ACTIONS(7202),
    [anon_sym_PIPE_PIPE] = ACTIONS(7202),
    [anon_sym_LT] = ACTIONS(7204),
    [anon_sym_GT] = ACTIONS(7204),
    [anon_sym_GT_GT] = ACTIONS(7202),
    [anon_sym_AMP_GT] = ACTIONS(7204),
    [anon_sym_AMP_GT_GT] = ACTIONS(7202),
    [anon_sym_LT_AMP] = ACTIONS(7202),
    [anon_sym_GT_AMP] = ACTIONS(7202),
    [anon_sym_LT_LT] = ACTIONS(7204),
    [anon_sym_LT_LT_DASH] = ACTIONS(7202),
    [anon_sym_LT_LT_LT] = ACTIONS(7202),
    [anon_sym_DOLLAR] = ACTIONS(7204),
    [sym__special_character] = ACTIONS(7204),
    [anon_sym_DQUOTE] = ACTIONS(7202),
    [sym_raw_string] = ACTIONS(7202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7202),
    [anon_sym_BQUOTE] = ACTIONS(7202),
    [anon_sym_LT_LPAREN] = ACTIONS(7202),
    [anon_sym_GT_LPAREN] = ACTIONS(7202),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7204),
    [sym_word] = ACTIONS(7204),
    [anon_sym_LF] = ACTIONS(7202),
    [anon_sym_AMP] = ACTIONS(7204),
  },
  [3660] = {
    [sym__simple_heredoc_body] = ACTIONS(7206),
    [sym__heredoc_body_beginning] = ACTIONS(7206),
    [sym_file_descriptor] = ACTIONS(7206),
    [sym__concat] = ACTIONS(7206),
    [sym_variable_name] = ACTIONS(7206),
    [anon_sym_SEMI] = ACTIONS(7208),
    [anon_sym_PIPE] = ACTIONS(7208),
    [anon_sym_SEMI_SEMI] = ACTIONS(7206),
    [anon_sym_RBRACE] = ACTIONS(7206),
    [anon_sym_PIPE_AMP] = ACTIONS(7206),
    [anon_sym_AMP_AMP] = ACTIONS(7206),
    [anon_sym_PIPE_PIPE] = ACTIONS(7206),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7206),
    [anon_sym_AMP_GT] = ACTIONS(7208),
    [anon_sym_AMP_GT_GT] = ACTIONS(7206),
    [anon_sym_LT_AMP] = ACTIONS(7206),
    [anon_sym_GT_AMP] = ACTIONS(7206),
    [anon_sym_LT_LT] = ACTIONS(7208),
    [anon_sym_LT_LT_DASH] = ACTIONS(7206),
    [anon_sym_LT_LT_LT] = ACTIONS(7206),
    [anon_sym_DOLLAR] = ACTIONS(7208),
    [sym__special_character] = ACTIONS(7208),
    [anon_sym_DQUOTE] = ACTIONS(7206),
    [sym_raw_string] = ACTIONS(7206),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7206),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7206),
    [anon_sym_BQUOTE] = ACTIONS(7206),
    [anon_sym_LT_LPAREN] = ACTIONS(7206),
    [anon_sym_GT_LPAREN] = ACTIONS(7206),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7208),
    [sym_word] = ACTIONS(7208),
    [anon_sym_LF] = ACTIONS(7206),
    [anon_sym_AMP] = ACTIONS(7208),
  },
  [3661] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9073),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3662] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9075),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3663] = {
    [sym__simple_heredoc_body] = ACTIONS(7242),
    [sym__heredoc_body_beginning] = ACTIONS(7242),
    [sym_file_descriptor] = ACTIONS(7242),
    [sym__concat] = ACTIONS(7242),
    [sym_variable_name] = ACTIONS(7242),
    [anon_sym_SEMI] = ACTIONS(7244),
    [anon_sym_PIPE] = ACTIONS(7244),
    [anon_sym_SEMI_SEMI] = ACTIONS(7242),
    [anon_sym_RBRACE] = ACTIONS(7242),
    [anon_sym_PIPE_AMP] = ACTIONS(7242),
    [anon_sym_AMP_AMP] = ACTIONS(7242),
    [anon_sym_PIPE_PIPE] = ACTIONS(7242),
    [anon_sym_LT] = ACTIONS(7244),
    [anon_sym_GT] = ACTIONS(7244),
    [anon_sym_GT_GT] = ACTIONS(7242),
    [anon_sym_AMP_GT] = ACTIONS(7244),
    [anon_sym_AMP_GT_GT] = ACTIONS(7242),
    [anon_sym_LT_AMP] = ACTIONS(7242),
    [anon_sym_GT_AMP] = ACTIONS(7242),
    [anon_sym_LT_LT] = ACTIONS(7244),
    [anon_sym_LT_LT_DASH] = ACTIONS(7242),
    [anon_sym_LT_LT_LT] = ACTIONS(7242),
    [anon_sym_DOLLAR] = ACTIONS(7244),
    [sym__special_character] = ACTIONS(7244),
    [anon_sym_DQUOTE] = ACTIONS(7242),
    [sym_raw_string] = ACTIONS(7242),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7242),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7242),
    [anon_sym_BQUOTE] = ACTIONS(7242),
    [anon_sym_LT_LPAREN] = ACTIONS(7242),
    [anon_sym_GT_LPAREN] = ACTIONS(7242),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7244),
    [sym_word] = ACTIONS(7244),
    [anon_sym_LF] = ACTIONS(7242),
    [anon_sym_AMP] = ACTIONS(7244),
  },
  [3664] = {
    [sym__simple_heredoc_body] = ACTIONS(7198),
    [sym__heredoc_body_beginning] = ACTIONS(7198),
    [sym_file_descriptor] = ACTIONS(7198),
    [sym__concat] = ACTIONS(7198),
    [anon_sym_SEMI] = ACTIONS(7200),
    [anon_sym_PIPE] = ACTIONS(7200),
    [anon_sym_SEMI_SEMI] = ACTIONS(7198),
    [anon_sym_RBRACE] = ACTIONS(7198),
    [anon_sym_PIPE_AMP] = ACTIONS(7198),
    [anon_sym_AMP_AMP] = ACTIONS(7198),
    [anon_sym_PIPE_PIPE] = ACTIONS(7198),
    [anon_sym_LT] = ACTIONS(7200),
    [anon_sym_GT] = ACTIONS(7200),
    [anon_sym_GT_GT] = ACTIONS(7198),
    [anon_sym_AMP_GT] = ACTIONS(7200),
    [anon_sym_AMP_GT_GT] = ACTIONS(7198),
    [anon_sym_LT_AMP] = ACTIONS(7198),
    [anon_sym_GT_AMP] = ACTIONS(7198),
    [anon_sym_LT_LT] = ACTIONS(7200),
    [anon_sym_LT_LT_DASH] = ACTIONS(7198),
    [anon_sym_LT_LT_LT] = ACTIONS(7198),
    [anon_sym_DOLLAR] = ACTIONS(7200),
    [sym__special_character] = ACTIONS(7200),
    [anon_sym_DQUOTE] = ACTIONS(7198),
    [sym_raw_string] = ACTIONS(7198),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7198),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7198),
    [anon_sym_BQUOTE] = ACTIONS(7198),
    [anon_sym_LT_LPAREN] = ACTIONS(7198),
    [anon_sym_GT_LPAREN] = ACTIONS(7198),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7200),
    [sym_word] = ACTIONS(7200),
    [anon_sym_LF] = ACTIONS(7198),
    [anon_sym_AMP] = ACTIONS(7200),
  },
  [3665] = {
    [sym__simple_heredoc_body] = ACTIONS(7202),
    [sym__heredoc_body_beginning] = ACTIONS(7202),
    [sym_file_descriptor] = ACTIONS(7202),
    [sym__concat] = ACTIONS(7202),
    [anon_sym_SEMI] = ACTIONS(7204),
    [anon_sym_PIPE] = ACTIONS(7204),
    [anon_sym_SEMI_SEMI] = ACTIONS(7202),
    [anon_sym_RBRACE] = ACTIONS(7202),
    [anon_sym_PIPE_AMP] = ACTIONS(7202),
    [anon_sym_AMP_AMP] = ACTIONS(7202),
    [anon_sym_PIPE_PIPE] = ACTIONS(7202),
    [anon_sym_LT] = ACTIONS(7204),
    [anon_sym_GT] = ACTIONS(7204),
    [anon_sym_GT_GT] = ACTIONS(7202),
    [anon_sym_AMP_GT] = ACTIONS(7204),
    [anon_sym_AMP_GT_GT] = ACTIONS(7202),
    [anon_sym_LT_AMP] = ACTIONS(7202),
    [anon_sym_GT_AMP] = ACTIONS(7202),
    [anon_sym_LT_LT] = ACTIONS(7204),
    [anon_sym_LT_LT_DASH] = ACTIONS(7202),
    [anon_sym_LT_LT_LT] = ACTIONS(7202),
    [anon_sym_DOLLAR] = ACTIONS(7204),
    [sym__special_character] = ACTIONS(7204),
    [anon_sym_DQUOTE] = ACTIONS(7202),
    [sym_raw_string] = ACTIONS(7202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7202),
    [anon_sym_BQUOTE] = ACTIONS(7202),
    [anon_sym_LT_LPAREN] = ACTIONS(7202),
    [anon_sym_GT_LPAREN] = ACTIONS(7202),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7204),
    [sym_word] = ACTIONS(7204),
    [anon_sym_LF] = ACTIONS(7202),
    [anon_sym_AMP] = ACTIONS(7204),
  },
  [3666] = {
    [sym__simple_heredoc_body] = ACTIONS(7206),
    [sym__heredoc_body_beginning] = ACTIONS(7206),
    [sym_file_descriptor] = ACTIONS(7206),
    [sym__concat] = ACTIONS(7206),
    [anon_sym_SEMI] = ACTIONS(7208),
    [anon_sym_PIPE] = ACTIONS(7208),
    [anon_sym_SEMI_SEMI] = ACTIONS(7206),
    [anon_sym_RBRACE] = ACTIONS(7206),
    [anon_sym_PIPE_AMP] = ACTIONS(7206),
    [anon_sym_AMP_AMP] = ACTIONS(7206),
    [anon_sym_PIPE_PIPE] = ACTIONS(7206),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7206),
    [anon_sym_AMP_GT] = ACTIONS(7208),
    [anon_sym_AMP_GT_GT] = ACTIONS(7206),
    [anon_sym_LT_AMP] = ACTIONS(7206),
    [anon_sym_GT_AMP] = ACTIONS(7206),
    [anon_sym_LT_LT] = ACTIONS(7208),
    [anon_sym_LT_LT_DASH] = ACTIONS(7206),
    [anon_sym_LT_LT_LT] = ACTIONS(7206),
    [anon_sym_DOLLAR] = ACTIONS(7208),
    [sym__special_character] = ACTIONS(7208),
    [anon_sym_DQUOTE] = ACTIONS(7206),
    [sym_raw_string] = ACTIONS(7206),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7206),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7206),
    [anon_sym_BQUOTE] = ACTIONS(7206),
    [anon_sym_LT_LPAREN] = ACTIONS(7206),
    [anon_sym_GT_LPAREN] = ACTIONS(7206),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7208),
    [sym_word] = ACTIONS(7208),
    [anon_sym_LF] = ACTIONS(7206),
    [anon_sym_AMP] = ACTIONS(7208),
  },
  [3667] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9077),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3668] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9079),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3669] = {
    [sym__simple_heredoc_body] = ACTIONS(7242),
    [sym__heredoc_body_beginning] = ACTIONS(7242),
    [sym_file_descriptor] = ACTIONS(7242),
    [sym__concat] = ACTIONS(7242),
    [anon_sym_SEMI] = ACTIONS(7244),
    [anon_sym_PIPE] = ACTIONS(7244),
    [anon_sym_SEMI_SEMI] = ACTIONS(7242),
    [anon_sym_RBRACE] = ACTIONS(7242),
    [anon_sym_PIPE_AMP] = ACTIONS(7242),
    [anon_sym_AMP_AMP] = ACTIONS(7242),
    [anon_sym_PIPE_PIPE] = ACTIONS(7242),
    [anon_sym_LT] = ACTIONS(7244),
    [anon_sym_GT] = ACTIONS(7244),
    [anon_sym_GT_GT] = ACTIONS(7242),
    [anon_sym_AMP_GT] = ACTIONS(7244),
    [anon_sym_AMP_GT_GT] = ACTIONS(7242),
    [anon_sym_LT_AMP] = ACTIONS(7242),
    [anon_sym_GT_AMP] = ACTIONS(7242),
    [anon_sym_LT_LT] = ACTIONS(7244),
    [anon_sym_LT_LT_DASH] = ACTIONS(7242),
    [anon_sym_LT_LT_LT] = ACTIONS(7242),
    [anon_sym_DOLLAR] = ACTIONS(7244),
    [sym__special_character] = ACTIONS(7244),
    [anon_sym_DQUOTE] = ACTIONS(7242),
    [sym_raw_string] = ACTIONS(7242),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7242),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7242),
    [anon_sym_BQUOTE] = ACTIONS(7242),
    [anon_sym_LT_LPAREN] = ACTIONS(7242),
    [anon_sym_GT_LPAREN] = ACTIONS(7242),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7244),
    [sym_word] = ACTIONS(7244),
    [anon_sym_LF] = ACTIONS(7242),
    [anon_sym_AMP] = ACTIONS(7244),
  },
  [3670] = {
    [sym__simple_heredoc_body] = ACTIONS(8340),
    [sym__heredoc_body_beginning] = ACTIONS(8340),
    [sym_file_descriptor] = ACTIONS(8340),
    [sym__concat] = ACTIONS(8340),
    [anon_sym_SEMI] = ACTIONS(8342),
    [anon_sym_PIPE] = ACTIONS(8342),
    [anon_sym_SEMI_SEMI] = ACTIONS(8340),
    [anon_sym_RBRACE] = ACTIONS(8340),
    [anon_sym_PIPE_AMP] = ACTIONS(8340),
    [anon_sym_AMP_AMP] = ACTIONS(8340),
    [anon_sym_PIPE_PIPE] = ACTIONS(8340),
    [anon_sym_EQ_TILDE] = ACTIONS(8342),
    [anon_sym_EQ_EQ] = ACTIONS(8342),
    [anon_sym_LT] = ACTIONS(8342),
    [anon_sym_GT] = ACTIONS(8342),
    [anon_sym_GT_GT] = ACTIONS(8340),
    [anon_sym_AMP_GT] = ACTIONS(8342),
    [anon_sym_AMP_GT_GT] = ACTIONS(8340),
    [anon_sym_LT_AMP] = ACTIONS(8340),
    [anon_sym_GT_AMP] = ACTIONS(8340),
    [anon_sym_LT_LT] = ACTIONS(8342),
    [anon_sym_LT_LT_DASH] = ACTIONS(8340),
    [anon_sym_LT_LT_LT] = ACTIONS(8340),
    [anon_sym_DOLLAR] = ACTIONS(8342),
    [sym__special_character] = ACTIONS(8342),
    [anon_sym_DQUOTE] = ACTIONS(8340),
    [sym_raw_string] = ACTIONS(8340),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8340),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [anon_sym_LT_LPAREN] = ACTIONS(8340),
    [anon_sym_GT_LPAREN] = ACTIONS(8340),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8342),
    [anon_sym_LF] = ACTIONS(8340),
    [anon_sym_AMP] = ACTIONS(8342),
  },
  [3671] = {
    [sym__simple_heredoc_body] = ACTIONS(8344),
    [sym__heredoc_body_beginning] = ACTIONS(8344),
    [sym_file_descriptor] = ACTIONS(8344),
    [sym__concat] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [anon_sym_PIPE] = ACTIONS(8346),
    [anon_sym_SEMI_SEMI] = ACTIONS(8344),
    [anon_sym_RBRACE] = ACTIONS(8344),
    [anon_sym_PIPE_AMP] = ACTIONS(8344),
    [anon_sym_AMP_AMP] = ACTIONS(8344),
    [anon_sym_PIPE_PIPE] = ACTIONS(8344),
    [anon_sym_EQ_TILDE] = ACTIONS(8346),
    [anon_sym_EQ_EQ] = ACTIONS(8346),
    [anon_sym_LT] = ACTIONS(8346),
    [anon_sym_GT] = ACTIONS(8346),
    [anon_sym_GT_GT] = ACTIONS(8344),
    [anon_sym_AMP_GT] = ACTIONS(8346),
    [anon_sym_AMP_GT_GT] = ACTIONS(8344),
    [anon_sym_LT_AMP] = ACTIONS(8344),
    [anon_sym_GT_AMP] = ACTIONS(8344),
    [anon_sym_LT_LT] = ACTIONS(8346),
    [anon_sym_LT_LT_DASH] = ACTIONS(8344),
    [anon_sym_LT_LT_LT] = ACTIONS(8344),
    [anon_sym_DOLLAR] = ACTIONS(8346),
    [sym__special_character] = ACTIONS(8346),
    [anon_sym_DQUOTE] = ACTIONS(8344),
    [sym_raw_string] = ACTIONS(8344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8344),
    [anon_sym_BQUOTE] = ACTIONS(8344),
    [anon_sym_LT_LPAREN] = ACTIONS(8344),
    [anon_sym_GT_LPAREN] = ACTIONS(8344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8346),
    [anon_sym_LF] = ACTIONS(8344),
    [anon_sym_AMP] = ACTIONS(8346),
  },
  [3672] = {
    [sym__concat] = ACTIONS(8340),
    [anon_sym_AMP_AMP] = ACTIONS(8340),
    [anon_sym_PIPE_PIPE] = ACTIONS(8340),
    [anon_sym_RBRACK] = ACTIONS(8340),
    [anon_sym_EQ_TILDE] = ACTIONS(8340),
    [anon_sym_EQ_EQ] = ACTIONS(8340),
    [anon_sym_EQ] = ACTIONS(8342),
    [anon_sym_PLUS_EQ] = ACTIONS(8340),
    [anon_sym_LT] = ACTIONS(8342),
    [anon_sym_GT] = ACTIONS(8342),
    [anon_sym_BANG_EQ] = ACTIONS(8340),
    [anon_sym_PLUS] = ACTIONS(8342),
    [anon_sym_DASH] = ACTIONS(8342),
    [anon_sym_DASH_EQ] = ACTIONS(8340),
    [anon_sym_LT_EQ] = ACTIONS(8340),
    [anon_sym_GT_EQ] = ACTIONS(8340),
    [anon_sym_PLUS_PLUS] = ACTIONS(8340),
    [anon_sym_DASH_DASH] = ACTIONS(8340),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(8340),
  },
  [3673] = {
    [sym__concat] = ACTIONS(8344),
    [anon_sym_AMP_AMP] = ACTIONS(8344),
    [anon_sym_PIPE_PIPE] = ACTIONS(8344),
    [anon_sym_RBRACK] = ACTIONS(8344),
    [anon_sym_EQ_TILDE] = ACTIONS(8344),
    [anon_sym_EQ_EQ] = ACTIONS(8344),
    [anon_sym_EQ] = ACTIONS(8346),
    [anon_sym_PLUS_EQ] = ACTIONS(8344),
    [anon_sym_LT] = ACTIONS(8346),
    [anon_sym_GT] = ACTIONS(8346),
    [anon_sym_BANG_EQ] = ACTIONS(8344),
    [anon_sym_PLUS] = ACTIONS(8346),
    [anon_sym_DASH] = ACTIONS(8346),
    [anon_sym_DASH_EQ] = ACTIONS(8344),
    [anon_sym_LT_EQ] = ACTIONS(8344),
    [anon_sym_GT_EQ] = ACTIONS(8344),
    [anon_sym_PLUS_PLUS] = ACTIONS(8344),
    [anon_sym_DASH_DASH] = ACTIONS(8344),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(8344),
  },
  [3674] = {
    [sym__simple_heredoc_body] = ACTIONS(8340),
    [sym__heredoc_body_beginning] = ACTIONS(8340),
    [sym_file_descriptor] = ACTIONS(8340),
    [sym__concat] = ACTIONS(8340),
    [sym_variable_name] = ACTIONS(8340),
    [ts_builtin_sym_end] = ACTIONS(8340),
    [anon_sym_SEMI] = ACTIONS(8342),
    [anon_sym_PIPE] = ACTIONS(8342),
    [anon_sym_RPAREN] = ACTIONS(8340),
    [anon_sym_SEMI_SEMI] = ACTIONS(8340),
    [anon_sym_PIPE_AMP] = ACTIONS(8340),
    [anon_sym_AMP_AMP] = ACTIONS(8340),
    [anon_sym_PIPE_PIPE] = ACTIONS(8340),
    [anon_sym_LT] = ACTIONS(8342),
    [anon_sym_GT] = ACTIONS(8342),
    [anon_sym_GT_GT] = ACTIONS(8340),
    [anon_sym_AMP_GT] = ACTIONS(8342),
    [anon_sym_AMP_GT_GT] = ACTIONS(8340),
    [anon_sym_LT_AMP] = ACTIONS(8340),
    [anon_sym_GT_AMP] = ACTIONS(8340),
    [anon_sym_LT_LT] = ACTIONS(8342),
    [anon_sym_LT_LT_DASH] = ACTIONS(8340),
    [anon_sym_LT_LT_LT] = ACTIONS(8340),
    [anon_sym_DOLLAR] = ACTIONS(8342),
    [sym__special_character] = ACTIONS(8340),
    [anon_sym_DQUOTE] = ACTIONS(8340),
    [sym_raw_string] = ACTIONS(8340),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8340),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [anon_sym_LT_LPAREN] = ACTIONS(8340),
    [anon_sym_GT_LPAREN] = ACTIONS(8340),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8342),
    [sym_word] = ACTIONS(8342),
    [anon_sym_LF] = ACTIONS(8340),
    [anon_sym_AMP] = ACTIONS(8342),
  },
  [3675] = {
    [sym__simple_heredoc_body] = ACTIONS(8344),
    [sym__heredoc_body_beginning] = ACTIONS(8344),
    [sym_file_descriptor] = ACTIONS(8344),
    [sym__concat] = ACTIONS(8344),
    [sym_variable_name] = ACTIONS(8344),
    [ts_builtin_sym_end] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [anon_sym_PIPE] = ACTIONS(8346),
    [anon_sym_RPAREN] = ACTIONS(8344),
    [anon_sym_SEMI_SEMI] = ACTIONS(8344),
    [anon_sym_PIPE_AMP] = ACTIONS(8344),
    [anon_sym_AMP_AMP] = ACTIONS(8344),
    [anon_sym_PIPE_PIPE] = ACTIONS(8344),
    [anon_sym_LT] = ACTIONS(8346),
    [anon_sym_GT] = ACTIONS(8346),
    [anon_sym_GT_GT] = ACTIONS(8344),
    [anon_sym_AMP_GT] = ACTIONS(8346),
    [anon_sym_AMP_GT_GT] = ACTIONS(8344),
    [anon_sym_LT_AMP] = ACTIONS(8344),
    [anon_sym_GT_AMP] = ACTIONS(8344),
    [anon_sym_LT_LT] = ACTIONS(8346),
    [anon_sym_LT_LT_DASH] = ACTIONS(8344),
    [anon_sym_LT_LT_LT] = ACTIONS(8344),
    [anon_sym_DOLLAR] = ACTIONS(8346),
    [sym__special_character] = ACTIONS(8344),
    [anon_sym_DQUOTE] = ACTIONS(8344),
    [sym_raw_string] = ACTIONS(8344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8344),
    [anon_sym_BQUOTE] = ACTIONS(8344),
    [anon_sym_LT_LPAREN] = ACTIONS(8344),
    [anon_sym_GT_LPAREN] = ACTIONS(8344),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8346),
    [sym_word] = ACTIONS(8346),
    [anon_sym_LF] = ACTIONS(8344),
    [anon_sym_AMP] = ACTIONS(8346),
  },
  [3676] = {
    [sym__simple_heredoc_body] = ACTIONS(8340),
    [sym__heredoc_body_beginning] = ACTIONS(8340),
    [sym_file_descriptor] = ACTIONS(8340),
    [sym__concat] = ACTIONS(8340),
    [ts_builtin_sym_end] = ACTIONS(8340),
    [anon_sym_SEMI] = ACTIONS(8342),
    [anon_sym_PIPE] = ACTIONS(8342),
    [anon_sym_RPAREN] = ACTIONS(8340),
    [anon_sym_SEMI_SEMI] = ACTIONS(8340),
    [anon_sym_PIPE_AMP] = ACTIONS(8340),
    [anon_sym_AMP_AMP] = ACTIONS(8340),
    [anon_sym_PIPE_PIPE] = ACTIONS(8340),
    [anon_sym_LT] = ACTIONS(8342),
    [anon_sym_GT] = ACTIONS(8342),
    [anon_sym_GT_GT] = ACTIONS(8340),
    [anon_sym_AMP_GT] = ACTIONS(8342),
    [anon_sym_AMP_GT_GT] = ACTIONS(8340),
    [anon_sym_LT_AMP] = ACTIONS(8340),
    [anon_sym_GT_AMP] = ACTIONS(8340),
    [anon_sym_LT_LT] = ACTIONS(8342),
    [anon_sym_LT_LT_DASH] = ACTIONS(8340),
    [anon_sym_LT_LT_LT] = ACTIONS(8340),
    [anon_sym_DOLLAR] = ACTIONS(8342),
    [sym__special_character] = ACTIONS(8340),
    [anon_sym_DQUOTE] = ACTIONS(8340),
    [sym_raw_string] = ACTIONS(8340),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8340),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [anon_sym_LT_LPAREN] = ACTIONS(8340),
    [anon_sym_GT_LPAREN] = ACTIONS(8340),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8342),
    [sym_word] = ACTIONS(8342),
    [anon_sym_LF] = ACTIONS(8340),
    [anon_sym_AMP] = ACTIONS(8342),
  },
  [3677] = {
    [sym__simple_heredoc_body] = ACTIONS(8344),
    [sym__heredoc_body_beginning] = ACTIONS(8344),
    [sym_file_descriptor] = ACTIONS(8344),
    [sym__concat] = ACTIONS(8344),
    [ts_builtin_sym_end] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [anon_sym_PIPE] = ACTIONS(8346),
    [anon_sym_RPAREN] = ACTIONS(8344),
    [anon_sym_SEMI_SEMI] = ACTIONS(8344),
    [anon_sym_PIPE_AMP] = ACTIONS(8344),
    [anon_sym_AMP_AMP] = ACTIONS(8344),
    [anon_sym_PIPE_PIPE] = ACTIONS(8344),
    [anon_sym_LT] = ACTIONS(8346),
    [anon_sym_GT] = ACTIONS(8346),
    [anon_sym_GT_GT] = ACTIONS(8344),
    [anon_sym_AMP_GT] = ACTIONS(8346),
    [anon_sym_AMP_GT_GT] = ACTIONS(8344),
    [anon_sym_LT_AMP] = ACTIONS(8344),
    [anon_sym_GT_AMP] = ACTIONS(8344),
    [anon_sym_LT_LT] = ACTIONS(8346),
    [anon_sym_LT_LT_DASH] = ACTIONS(8344),
    [anon_sym_LT_LT_LT] = ACTIONS(8344),
    [anon_sym_DOLLAR] = ACTIONS(8346),
    [sym__special_character] = ACTIONS(8344),
    [anon_sym_DQUOTE] = ACTIONS(8344),
    [sym_raw_string] = ACTIONS(8344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8344),
    [anon_sym_BQUOTE] = ACTIONS(8344),
    [anon_sym_LT_LPAREN] = ACTIONS(8344),
    [anon_sym_GT_LPAREN] = ACTIONS(8344),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8346),
    [sym_word] = ACTIONS(8346),
    [anon_sym_LF] = ACTIONS(8344),
    [anon_sym_AMP] = ACTIONS(8346),
  },
  [3678] = {
    [sym_file_descriptor] = ACTIONS(8340),
    [sym__concat] = ACTIONS(8340),
    [sym_variable_name] = ACTIONS(8340),
    [anon_sym_RPAREN] = ACTIONS(8340),
    [anon_sym_LT] = ACTIONS(8342),
    [anon_sym_GT] = ACTIONS(8342),
    [anon_sym_GT_GT] = ACTIONS(8340),
    [anon_sym_AMP_GT] = ACTIONS(8342),
    [anon_sym_AMP_GT_GT] = ACTIONS(8340),
    [anon_sym_LT_AMP] = ACTIONS(8340),
    [anon_sym_GT_AMP] = ACTIONS(8340),
    [anon_sym_DOLLAR] = ACTIONS(8342),
    [sym__special_character] = ACTIONS(8340),
    [anon_sym_DQUOTE] = ACTIONS(8340),
    [sym_raw_string] = ACTIONS(8340),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8340),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [anon_sym_LT_LPAREN] = ACTIONS(8340),
    [anon_sym_GT_LPAREN] = ACTIONS(8340),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8340),
  },
  [3679] = {
    [sym_file_descriptor] = ACTIONS(8344),
    [sym__concat] = ACTIONS(8344),
    [sym_variable_name] = ACTIONS(8344),
    [anon_sym_RPAREN] = ACTIONS(8344),
    [anon_sym_LT] = ACTIONS(8346),
    [anon_sym_GT] = ACTIONS(8346),
    [anon_sym_GT_GT] = ACTIONS(8344),
    [anon_sym_AMP_GT] = ACTIONS(8346),
    [anon_sym_AMP_GT_GT] = ACTIONS(8344),
    [anon_sym_LT_AMP] = ACTIONS(8344),
    [anon_sym_GT_AMP] = ACTIONS(8344),
    [anon_sym_DOLLAR] = ACTIONS(8346),
    [sym__special_character] = ACTIONS(8344),
    [anon_sym_DQUOTE] = ACTIONS(8344),
    [sym_raw_string] = ACTIONS(8344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8344),
    [anon_sym_BQUOTE] = ACTIONS(8344),
    [anon_sym_LT_LPAREN] = ACTIONS(8344),
    [anon_sym_GT_LPAREN] = ACTIONS(8344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8344),
  },
  [3680] = {
    [sym__concat] = ACTIONS(8340),
    [anon_sym_DOLLAR] = ACTIONS(8342),
    [anon_sym_DQUOTE] = ACTIONS(8342),
    [sym__string_content] = ACTIONS(8340),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8342),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8342),
    [anon_sym_BQUOTE] = ACTIONS(8342),
    [sym_comment] = ACTIONS(329),
  },
  [3681] = {
    [sym__concat] = ACTIONS(8344),
    [anon_sym_DOLLAR] = ACTIONS(8346),
    [anon_sym_DQUOTE] = ACTIONS(8346),
    [sym__string_content] = ACTIONS(8344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8346),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8346),
    [anon_sym_BQUOTE] = ACTIONS(8346),
    [sym_comment] = ACTIONS(329),
  },
  [3682] = {
    [sym__concat] = ACTIONS(5674),
    [anon_sym_RBRACE] = ACTIONS(5674),
    [sym_comment] = ACTIONS(57),
  },
  [3683] = {
    [sym__concat] = ACTIONS(5708),
    [anon_sym_RBRACE] = ACTIONS(5708),
    [sym_comment] = ACTIONS(57),
  },
  [3684] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(9081),
    [sym_comment] = ACTIONS(57),
  },
  [3685] = {
    [anon_sym_RBRACE] = ACTIONS(9081),
    [sym_comment] = ACTIONS(57),
  },
  [3686] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(9083),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [3687] = {
    [sym_concatenation] = STATE(4033),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4033),
    [anon_sym_RBRACE] = ACTIONS(9085),
    [anon_sym_EQ] = ACTIONS(9087),
    [anon_sym_DASH] = ACTIONS(9087),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9087),
    [anon_sym_COLON_QMARK] = ACTIONS(9087),
    [anon_sym_COLON_DASH] = ACTIONS(9087),
    [anon_sym_PERCENT] = ACTIONS(9087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3688] = {
    [sym__concat] = ACTIONS(5725),
    [anon_sym_RBRACE] = ACTIONS(5725),
    [sym_comment] = ACTIONS(57),
  },
  [3689] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9085),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3690] = {
    [sym_concatenation] = STATE(4034),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4034),
    [anon_sym_RBRACE] = ACTIONS(9081),
    [anon_sym_EQ] = ACTIONS(9091),
    [anon_sym_DASH] = ACTIONS(9091),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9093),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9091),
    [anon_sym_COLON_QMARK] = ACTIONS(9091),
    [anon_sym_COLON_DASH] = ACTIONS(9091),
    [anon_sym_PERCENT] = ACTIONS(9091),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3691] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9081),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3692] = {
    [sym__concat] = ACTIONS(5770),
    [anon_sym_RBRACE] = ACTIONS(5770),
    [sym_comment] = ACTIONS(57),
  },
  [3693] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9095),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3694] = {
    [sym__concat] = ACTIONS(7198),
    [anon_sym_RBRACE] = ACTIONS(7198),
    [anon_sym_EQ] = ACTIONS(7200),
    [anon_sym_DASH] = ACTIONS(7200),
    [anon_sym_DOLLAR] = ACTIONS(7200),
    [sym__special_character] = ACTIONS(7200),
    [anon_sym_DQUOTE] = ACTIONS(7198),
    [sym_raw_string] = ACTIONS(7198),
    [anon_sym_POUND] = ACTIONS(7198),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7198),
    [anon_sym_COLON] = ACTIONS(7200),
    [anon_sym_COLON_QMARK] = ACTIONS(7200),
    [anon_sym_COLON_DASH] = ACTIONS(7200),
    [anon_sym_PERCENT] = ACTIONS(7200),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7198),
    [anon_sym_BQUOTE] = ACTIONS(7198),
    [anon_sym_LT_LPAREN] = ACTIONS(7198),
    [anon_sym_GT_LPAREN] = ACTIONS(7198),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(7200),
  },
  [3695] = {
    [sym__concat] = ACTIONS(7202),
    [anon_sym_RBRACE] = ACTIONS(7202),
    [anon_sym_EQ] = ACTIONS(7204),
    [anon_sym_DASH] = ACTIONS(7204),
    [anon_sym_DOLLAR] = ACTIONS(7204),
    [sym__special_character] = ACTIONS(7204),
    [anon_sym_DQUOTE] = ACTIONS(7202),
    [sym_raw_string] = ACTIONS(7202),
    [anon_sym_POUND] = ACTIONS(7202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7202),
    [anon_sym_COLON] = ACTIONS(7204),
    [anon_sym_COLON_QMARK] = ACTIONS(7204),
    [anon_sym_COLON_DASH] = ACTIONS(7204),
    [anon_sym_PERCENT] = ACTIONS(7204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7202),
    [anon_sym_BQUOTE] = ACTIONS(7202),
    [anon_sym_LT_LPAREN] = ACTIONS(7202),
    [anon_sym_GT_LPAREN] = ACTIONS(7202),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(7204),
  },
  [3696] = {
    [sym__concat] = ACTIONS(7206),
    [anon_sym_RBRACE] = ACTIONS(7206),
    [anon_sym_EQ] = ACTIONS(7208),
    [anon_sym_DASH] = ACTIONS(7208),
    [anon_sym_DOLLAR] = ACTIONS(7208),
    [sym__special_character] = ACTIONS(7208),
    [anon_sym_DQUOTE] = ACTIONS(7206),
    [sym_raw_string] = ACTIONS(7206),
    [anon_sym_POUND] = ACTIONS(7206),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7206),
    [anon_sym_COLON] = ACTIONS(7208),
    [anon_sym_COLON_QMARK] = ACTIONS(7208),
    [anon_sym_COLON_DASH] = ACTIONS(7208),
    [anon_sym_PERCENT] = ACTIONS(7208),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7206),
    [anon_sym_BQUOTE] = ACTIONS(7206),
    [anon_sym_LT_LPAREN] = ACTIONS(7206),
    [anon_sym_GT_LPAREN] = ACTIONS(7206),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(7208),
  },
  [3697] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9097),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3698] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9099),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3699] = {
    [sym__concat] = ACTIONS(7242),
    [anon_sym_RBRACE] = ACTIONS(7242),
    [anon_sym_EQ] = ACTIONS(7244),
    [anon_sym_DASH] = ACTIONS(7244),
    [anon_sym_DOLLAR] = ACTIONS(7244),
    [sym__special_character] = ACTIONS(7244),
    [anon_sym_DQUOTE] = ACTIONS(7242),
    [sym_raw_string] = ACTIONS(7242),
    [anon_sym_POUND] = ACTIONS(7242),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7242),
    [anon_sym_COLON] = ACTIONS(7244),
    [anon_sym_COLON_QMARK] = ACTIONS(7244),
    [anon_sym_COLON_DASH] = ACTIONS(7244),
    [anon_sym_PERCENT] = ACTIONS(7244),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7242),
    [anon_sym_BQUOTE] = ACTIONS(7242),
    [anon_sym_LT_LPAREN] = ACTIONS(7242),
    [anon_sym_GT_LPAREN] = ACTIONS(7242),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(7244),
  },
  [3700] = {
    [sym__heredoc_body_middle] = ACTIONS(7198),
    [sym__heredoc_body_end] = ACTIONS(7198),
    [anon_sym_DOLLAR] = ACTIONS(7200),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7198),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7198),
    [anon_sym_BQUOTE] = ACTIONS(7198),
    [sym_comment] = ACTIONS(57),
  },
  [3701] = {
    [sym__heredoc_body_middle] = ACTIONS(7202),
    [sym__heredoc_body_end] = ACTIONS(7202),
    [anon_sym_DOLLAR] = ACTIONS(7204),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7202),
    [anon_sym_BQUOTE] = ACTIONS(7202),
    [sym_comment] = ACTIONS(57),
  },
  [3702] = {
    [sym__heredoc_body_middle] = ACTIONS(7206),
    [sym__heredoc_body_end] = ACTIONS(7206),
    [anon_sym_DOLLAR] = ACTIONS(7208),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7206),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7206),
    [anon_sym_BQUOTE] = ACTIONS(7206),
    [sym_comment] = ACTIONS(57),
  },
  [3703] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9101),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3704] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9103),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3705] = {
    [sym__heredoc_body_middle] = ACTIONS(7242),
    [sym__heredoc_body_end] = ACTIONS(7242),
    [anon_sym_DOLLAR] = ACTIONS(7244),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7242),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7242),
    [anon_sym_BQUOTE] = ACTIONS(7242),
    [sym_comment] = ACTIONS(57),
  },
  [3706] = {
    [sym__concat] = ACTIONS(7198),
    [anon_sym_RPAREN] = ACTIONS(7198),
    [anon_sym_DOLLAR] = ACTIONS(7200),
    [sym__special_character] = ACTIONS(7198),
    [anon_sym_DQUOTE] = ACTIONS(7198),
    [sym_raw_string] = ACTIONS(7198),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7198),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7198),
    [anon_sym_BQUOTE] = ACTIONS(7198),
    [anon_sym_LT_LPAREN] = ACTIONS(7198),
    [anon_sym_GT_LPAREN] = ACTIONS(7198),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7198),
  },
  [3707] = {
    [sym__concat] = ACTIONS(7202),
    [anon_sym_RPAREN] = ACTIONS(7202),
    [anon_sym_DOLLAR] = ACTIONS(7204),
    [sym__special_character] = ACTIONS(7202),
    [anon_sym_DQUOTE] = ACTIONS(7202),
    [sym_raw_string] = ACTIONS(7202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7202),
    [anon_sym_BQUOTE] = ACTIONS(7202),
    [anon_sym_LT_LPAREN] = ACTIONS(7202),
    [anon_sym_GT_LPAREN] = ACTIONS(7202),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7202),
  },
  [3708] = {
    [sym__concat] = ACTIONS(7206),
    [anon_sym_RPAREN] = ACTIONS(7206),
    [anon_sym_DOLLAR] = ACTIONS(7208),
    [sym__special_character] = ACTIONS(7206),
    [anon_sym_DQUOTE] = ACTIONS(7206),
    [sym_raw_string] = ACTIONS(7206),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7206),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7206),
    [anon_sym_BQUOTE] = ACTIONS(7206),
    [anon_sym_LT_LPAREN] = ACTIONS(7206),
    [anon_sym_GT_LPAREN] = ACTIONS(7206),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7206),
  },
  [3709] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9105),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3710] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9107),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3711] = {
    [sym__concat] = ACTIONS(7242),
    [anon_sym_RPAREN] = ACTIONS(7242),
    [anon_sym_DOLLAR] = ACTIONS(7244),
    [sym__special_character] = ACTIONS(7242),
    [anon_sym_DQUOTE] = ACTIONS(7242),
    [sym_raw_string] = ACTIONS(7242),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7242),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7242),
    [anon_sym_BQUOTE] = ACTIONS(7242),
    [anon_sym_LT_LPAREN] = ACTIONS(7242),
    [anon_sym_GT_LPAREN] = ACTIONS(7242),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7242),
  },
  [3712] = {
    [sym__simple_heredoc_body] = ACTIONS(8340),
    [sym__heredoc_body_beginning] = ACTIONS(8340),
    [sym_file_descriptor] = ACTIONS(8340),
    [sym__concat] = ACTIONS(8340),
    [sym_variable_name] = ACTIONS(8340),
    [ts_builtin_sym_end] = ACTIONS(8340),
    [anon_sym_SEMI] = ACTIONS(8342),
    [anon_sym_PIPE] = ACTIONS(8342),
    [anon_sym_RPAREN] = ACTIONS(8340),
    [anon_sym_SEMI_SEMI] = ACTIONS(8340),
    [anon_sym_PIPE_AMP] = ACTIONS(8340),
    [anon_sym_AMP_AMP] = ACTIONS(8340),
    [anon_sym_PIPE_PIPE] = ACTIONS(8340),
    [anon_sym_LT] = ACTIONS(8342),
    [anon_sym_GT] = ACTIONS(8342),
    [anon_sym_GT_GT] = ACTIONS(8340),
    [anon_sym_AMP_GT] = ACTIONS(8342),
    [anon_sym_AMP_GT_GT] = ACTIONS(8340),
    [anon_sym_LT_AMP] = ACTIONS(8340),
    [anon_sym_GT_AMP] = ACTIONS(8340),
    [anon_sym_LT_LT] = ACTIONS(8342),
    [anon_sym_LT_LT_DASH] = ACTIONS(8340),
    [anon_sym_LT_LT_LT] = ACTIONS(8340),
    [anon_sym_DOLLAR] = ACTIONS(8342),
    [sym__special_character] = ACTIONS(8340),
    [anon_sym_DQUOTE] = ACTIONS(8340),
    [sym_raw_string] = ACTIONS(8340),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8340),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [anon_sym_LT_LPAREN] = ACTIONS(8340),
    [anon_sym_GT_LPAREN] = ACTIONS(8340),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8342),
    [anon_sym_LF] = ACTIONS(8340),
    [anon_sym_AMP] = ACTIONS(8342),
  },
  [3713] = {
    [sym__simple_heredoc_body] = ACTIONS(8344),
    [sym__heredoc_body_beginning] = ACTIONS(8344),
    [sym_file_descriptor] = ACTIONS(8344),
    [sym__concat] = ACTIONS(8344),
    [sym_variable_name] = ACTIONS(8344),
    [ts_builtin_sym_end] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [anon_sym_PIPE] = ACTIONS(8346),
    [anon_sym_RPAREN] = ACTIONS(8344),
    [anon_sym_SEMI_SEMI] = ACTIONS(8344),
    [anon_sym_PIPE_AMP] = ACTIONS(8344),
    [anon_sym_AMP_AMP] = ACTIONS(8344),
    [anon_sym_PIPE_PIPE] = ACTIONS(8344),
    [anon_sym_LT] = ACTIONS(8346),
    [anon_sym_GT] = ACTIONS(8346),
    [anon_sym_GT_GT] = ACTIONS(8344),
    [anon_sym_AMP_GT] = ACTIONS(8346),
    [anon_sym_AMP_GT_GT] = ACTIONS(8344),
    [anon_sym_LT_AMP] = ACTIONS(8344),
    [anon_sym_GT_AMP] = ACTIONS(8344),
    [anon_sym_LT_LT] = ACTIONS(8346),
    [anon_sym_LT_LT_DASH] = ACTIONS(8344),
    [anon_sym_LT_LT_LT] = ACTIONS(8344),
    [anon_sym_DOLLAR] = ACTIONS(8346),
    [sym__special_character] = ACTIONS(8344),
    [anon_sym_DQUOTE] = ACTIONS(8344),
    [sym_raw_string] = ACTIONS(8344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8344),
    [anon_sym_BQUOTE] = ACTIONS(8344),
    [anon_sym_LT_LPAREN] = ACTIONS(8344),
    [anon_sym_GT_LPAREN] = ACTIONS(8344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8346),
    [anon_sym_LF] = ACTIONS(8344),
    [anon_sym_AMP] = ACTIONS(8346),
  },
  [3714] = {
    [sym__simple_heredoc_body] = ACTIONS(9109),
    [sym__heredoc_body_beginning] = ACTIONS(9109),
    [sym_file_descriptor] = ACTIONS(9109),
    [ts_builtin_sym_end] = ACTIONS(9109),
    [anon_sym_SEMI] = ACTIONS(9111),
    [anon_sym_done] = ACTIONS(9109),
    [anon_sym_fi] = ACTIONS(9109),
    [anon_sym_elif] = ACTIONS(9109),
    [anon_sym_else] = ACTIONS(9109),
    [anon_sym_esac] = ACTIONS(9109),
    [anon_sym_PIPE] = ACTIONS(9111),
    [anon_sym_RPAREN] = ACTIONS(9109),
    [anon_sym_SEMI_SEMI] = ACTIONS(9109),
    [anon_sym_PIPE_AMP] = ACTIONS(9109),
    [anon_sym_AMP_AMP] = ACTIONS(9109),
    [anon_sym_PIPE_PIPE] = ACTIONS(9109),
    [anon_sym_LT] = ACTIONS(9111),
    [anon_sym_GT] = ACTIONS(9111),
    [anon_sym_GT_GT] = ACTIONS(9109),
    [anon_sym_AMP_GT] = ACTIONS(9111),
    [anon_sym_AMP_GT_GT] = ACTIONS(9109),
    [anon_sym_LT_AMP] = ACTIONS(9109),
    [anon_sym_GT_AMP] = ACTIONS(9109),
    [anon_sym_LT_LT] = ACTIONS(9111),
    [anon_sym_LT_LT_DASH] = ACTIONS(9109),
    [anon_sym_LT_LT_LT] = ACTIONS(9109),
    [anon_sym_BQUOTE] = ACTIONS(9109),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(9109),
    [anon_sym_AMP] = ACTIONS(9111),
  },
  [3715] = {
    [sym__concat] = ACTIONS(8340),
    [anon_sym_SEMI] = ACTIONS(8342),
    [anon_sym_SEMI_SEMI] = ACTIONS(8340),
    [anon_sym_AMP_AMP] = ACTIONS(8340),
    [anon_sym_PIPE_PIPE] = ACTIONS(8340),
    [anon_sym_EQ_TILDE] = ACTIONS(8340),
    [anon_sym_EQ_EQ] = ACTIONS(8340),
    [anon_sym_EQ] = ACTIONS(8342),
    [anon_sym_PLUS_EQ] = ACTIONS(8340),
    [anon_sym_LT] = ACTIONS(8342),
    [anon_sym_GT] = ACTIONS(8342),
    [anon_sym_BANG_EQ] = ACTIONS(8340),
    [anon_sym_PLUS] = ACTIONS(8342),
    [anon_sym_DASH] = ACTIONS(8342),
    [anon_sym_DASH_EQ] = ACTIONS(8340),
    [anon_sym_LT_EQ] = ACTIONS(8340),
    [anon_sym_GT_EQ] = ACTIONS(8340),
    [anon_sym_PLUS_PLUS] = ACTIONS(8340),
    [anon_sym_DASH_DASH] = ACTIONS(8340),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(8340),
    [anon_sym_LF] = ACTIONS(8340),
    [anon_sym_AMP] = ACTIONS(8342),
  },
  [3716] = {
    [sym__concat] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [anon_sym_SEMI_SEMI] = ACTIONS(8344),
    [anon_sym_AMP_AMP] = ACTIONS(8344),
    [anon_sym_PIPE_PIPE] = ACTIONS(8344),
    [anon_sym_EQ_TILDE] = ACTIONS(8344),
    [anon_sym_EQ_EQ] = ACTIONS(8344),
    [anon_sym_EQ] = ACTIONS(8346),
    [anon_sym_PLUS_EQ] = ACTIONS(8344),
    [anon_sym_LT] = ACTIONS(8346),
    [anon_sym_GT] = ACTIONS(8346),
    [anon_sym_BANG_EQ] = ACTIONS(8344),
    [anon_sym_PLUS] = ACTIONS(8346),
    [anon_sym_DASH] = ACTIONS(8346),
    [anon_sym_DASH_EQ] = ACTIONS(8344),
    [anon_sym_LT_EQ] = ACTIONS(8344),
    [anon_sym_GT_EQ] = ACTIONS(8344),
    [anon_sym_PLUS_PLUS] = ACTIONS(8344),
    [anon_sym_DASH_DASH] = ACTIONS(8344),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(8344),
    [anon_sym_LF] = ACTIONS(8344),
    [anon_sym_AMP] = ACTIONS(8346),
  },
  [3717] = {
    [sym_do_group] = STATE(4042),
    [sym_compound_statement] = STATE(4042),
    [anon_sym_do] = ACTIONS(651),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(57),
  },
  [3718] = {
    [sym__concat] = ACTIONS(7198),
    [anon_sym_SEMI] = ACTIONS(7200),
    [anon_sym_SEMI_SEMI] = ACTIONS(7198),
    [anon_sym_DOLLAR] = ACTIONS(7200),
    [sym__special_character] = ACTIONS(7198),
    [anon_sym_DQUOTE] = ACTIONS(7198),
    [sym_raw_string] = ACTIONS(7198),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7198),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7198),
    [anon_sym_BQUOTE] = ACTIONS(7198),
    [anon_sym_LT_LPAREN] = ACTIONS(7198),
    [anon_sym_GT_LPAREN] = ACTIONS(7198),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7200),
    [anon_sym_LF] = ACTIONS(7198),
    [anon_sym_AMP] = ACTIONS(7198),
  },
  [3719] = {
    [sym__concat] = ACTIONS(7202),
    [anon_sym_SEMI] = ACTIONS(7204),
    [anon_sym_SEMI_SEMI] = ACTIONS(7202),
    [anon_sym_DOLLAR] = ACTIONS(7204),
    [sym__special_character] = ACTIONS(7202),
    [anon_sym_DQUOTE] = ACTIONS(7202),
    [sym_raw_string] = ACTIONS(7202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7202),
    [anon_sym_BQUOTE] = ACTIONS(7202),
    [anon_sym_LT_LPAREN] = ACTIONS(7202),
    [anon_sym_GT_LPAREN] = ACTIONS(7202),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7204),
    [anon_sym_LF] = ACTIONS(7202),
    [anon_sym_AMP] = ACTIONS(7202),
  },
  [3720] = {
    [sym__concat] = ACTIONS(7206),
    [anon_sym_SEMI] = ACTIONS(7208),
    [anon_sym_SEMI_SEMI] = ACTIONS(7206),
    [anon_sym_DOLLAR] = ACTIONS(7208),
    [sym__special_character] = ACTIONS(7206),
    [anon_sym_DQUOTE] = ACTIONS(7206),
    [sym_raw_string] = ACTIONS(7206),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7206),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7206),
    [anon_sym_BQUOTE] = ACTIONS(7206),
    [anon_sym_LT_LPAREN] = ACTIONS(7206),
    [anon_sym_GT_LPAREN] = ACTIONS(7206),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7208),
    [anon_sym_LF] = ACTIONS(7206),
    [anon_sym_AMP] = ACTIONS(7206),
  },
  [3721] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9113),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3722] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9115),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3723] = {
    [sym__concat] = ACTIONS(7242),
    [anon_sym_SEMI] = ACTIONS(7244),
    [anon_sym_SEMI_SEMI] = ACTIONS(7242),
    [anon_sym_DOLLAR] = ACTIONS(7244),
    [sym__special_character] = ACTIONS(7242),
    [anon_sym_DQUOTE] = ACTIONS(7242),
    [sym_raw_string] = ACTIONS(7242),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7242),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7242),
    [anon_sym_BQUOTE] = ACTIONS(7242),
    [anon_sym_LT_LPAREN] = ACTIONS(7242),
    [anon_sym_GT_LPAREN] = ACTIONS(7242),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7244),
    [anon_sym_LF] = ACTIONS(7242),
    [anon_sym_AMP] = ACTIONS(7242),
  },
  [3724] = {
    [sym__concat] = ACTIONS(8340),
    [anon_sym_PIPE] = ACTIONS(8342),
    [anon_sym_RPAREN] = ACTIONS(8340),
    [anon_sym_AMP_AMP] = ACTIONS(8340),
    [anon_sym_PIPE_PIPE] = ACTIONS(8340),
    [anon_sym_EQ_TILDE] = ACTIONS(8340),
    [anon_sym_EQ_EQ] = ACTIONS(8340),
    [anon_sym_EQ] = ACTIONS(8342),
    [anon_sym_PLUS_EQ] = ACTIONS(8340),
    [anon_sym_LT] = ACTIONS(8342),
    [anon_sym_GT] = ACTIONS(8342),
    [anon_sym_BANG_EQ] = ACTIONS(8340),
    [anon_sym_PLUS] = ACTIONS(8342),
    [anon_sym_DASH] = ACTIONS(8342),
    [anon_sym_DASH_EQ] = ACTIONS(8340),
    [anon_sym_LT_EQ] = ACTIONS(8340),
    [anon_sym_GT_EQ] = ACTIONS(8340),
    [anon_sym_PLUS_PLUS] = ACTIONS(8340),
    [anon_sym_DASH_DASH] = ACTIONS(8340),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(8340),
  },
  [3725] = {
    [sym__concat] = ACTIONS(8344),
    [anon_sym_PIPE] = ACTIONS(8346),
    [anon_sym_RPAREN] = ACTIONS(8344),
    [anon_sym_AMP_AMP] = ACTIONS(8344),
    [anon_sym_PIPE_PIPE] = ACTIONS(8344),
    [anon_sym_EQ_TILDE] = ACTIONS(8344),
    [anon_sym_EQ_EQ] = ACTIONS(8344),
    [anon_sym_EQ] = ACTIONS(8346),
    [anon_sym_PLUS_EQ] = ACTIONS(8344),
    [anon_sym_LT] = ACTIONS(8346),
    [anon_sym_GT] = ACTIONS(8346),
    [anon_sym_BANG_EQ] = ACTIONS(8344),
    [anon_sym_PLUS] = ACTIONS(8346),
    [anon_sym_DASH] = ACTIONS(8346),
    [anon_sym_DASH_EQ] = ACTIONS(8344),
    [anon_sym_LT_EQ] = ACTIONS(8344),
    [anon_sym_GT_EQ] = ACTIONS(8344),
    [anon_sym_PLUS_PLUS] = ACTIONS(8344),
    [anon_sym_DASH_DASH] = ACTIONS(8344),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(8344),
  },
  [3726] = {
    [sym_file_descriptor] = ACTIONS(7198),
    [sym__concat] = ACTIONS(7198),
    [sym_variable_name] = ACTIONS(7198),
    [anon_sym_SEMI] = ACTIONS(7200),
    [anon_sym_PIPE] = ACTIONS(7200),
    [anon_sym_SEMI_SEMI] = ACTIONS(7198),
    [anon_sym_PIPE_AMP] = ACTIONS(7198),
    [anon_sym_AMP_AMP] = ACTIONS(7198),
    [anon_sym_PIPE_PIPE] = ACTIONS(7198),
    [anon_sym_LT] = ACTIONS(7200),
    [anon_sym_GT] = ACTIONS(7200),
    [anon_sym_GT_GT] = ACTIONS(7198),
    [anon_sym_AMP_GT] = ACTIONS(7200),
    [anon_sym_AMP_GT_GT] = ACTIONS(7198),
    [anon_sym_LT_AMP] = ACTIONS(7198),
    [anon_sym_GT_AMP] = ACTIONS(7198),
    [anon_sym_LT_LT] = ACTIONS(7200),
    [anon_sym_LT_LT_DASH] = ACTIONS(7198),
    [anon_sym_LT_LT_LT] = ACTIONS(7198),
    [anon_sym_DOLLAR] = ACTIONS(7200),
    [sym__special_character] = ACTIONS(7198),
    [anon_sym_DQUOTE] = ACTIONS(7198),
    [sym_raw_string] = ACTIONS(7198),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7198),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7198),
    [anon_sym_BQUOTE] = ACTIONS(7198),
    [anon_sym_LT_LPAREN] = ACTIONS(7198),
    [anon_sym_GT_LPAREN] = ACTIONS(7198),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7200),
    [anon_sym_LF] = ACTIONS(7198),
    [anon_sym_AMP] = ACTIONS(7200),
  },
  [3727] = {
    [sym_file_descriptor] = ACTIONS(7202),
    [sym__concat] = ACTIONS(7202),
    [sym_variable_name] = ACTIONS(7202),
    [anon_sym_SEMI] = ACTIONS(7204),
    [anon_sym_PIPE] = ACTIONS(7204),
    [anon_sym_SEMI_SEMI] = ACTIONS(7202),
    [anon_sym_PIPE_AMP] = ACTIONS(7202),
    [anon_sym_AMP_AMP] = ACTIONS(7202),
    [anon_sym_PIPE_PIPE] = ACTIONS(7202),
    [anon_sym_LT] = ACTIONS(7204),
    [anon_sym_GT] = ACTIONS(7204),
    [anon_sym_GT_GT] = ACTIONS(7202),
    [anon_sym_AMP_GT] = ACTIONS(7204),
    [anon_sym_AMP_GT_GT] = ACTIONS(7202),
    [anon_sym_LT_AMP] = ACTIONS(7202),
    [anon_sym_GT_AMP] = ACTIONS(7202),
    [anon_sym_LT_LT] = ACTIONS(7204),
    [anon_sym_LT_LT_DASH] = ACTIONS(7202),
    [anon_sym_LT_LT_LT] = ACTIONS(7202),
    [anon_sym_DOLLAR] = ACTIONS(7204),
    [sym__special_character] = ACTIONS(7202),
    [anon_sym_DQUOTE] = ACTIONS(7202),
    [sym_raw_string] = ACTIONS(7202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7202),
    [anon_sym_BQUOTE] = ACTIONS(7202),
    [anon_sym_LT_LPAREN] = ACTIONS(7202),
    [anon_sym_GT_LPAREN] = ACTIONS(7202),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7204),
    [anon_sym_LF] = ACTIONS(7202),
    [anon_sym_AMP] = ACTIONS(7204),
  },
  [3728] = {
    [sym_file_descriptor] = ACTIONS(7206),
    [sym__concat] = ACTIONS(7206),
    [sym_variable_name] = ACTIONS(7206),
    [anon_sym_SEMI] = ACTIONS(7208),
    [anon_sym_PIPE] = ACTIONS(7208),
    [anon_sym_SEMI_SEMI] = ACTIONS(7206),
    [anon_sym_PIPE_AMP] = ACTIONS(7206),
    [anon_sym_AMP_AMP] = ACTIONS(7206),
    [anon_sym_PIPE_PIPE] = ACTIONS(7206),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7206),
    [anon_sym_AMP_GT] = ACTIONS(7208),
    [anon_sym_AMP_GT_GT] = ACTIONS(7206),
    [anon_sym_LT_AMP] = ACTIONS(7206),
    [anon_sym_GT_AMP] = ACTIONS(7206),
    [anon_sym_LT_LT] = ACTIONS(7208),
    [anon_sym_LT_LT_DASH] = ACTIONS(7206),
    [anon_sym_LT_LT_LT] = ACTIONS(7206),
    [anon_sym_DOLLAR] = ACTIONS(7208),
    [sym__special_character] = ACTIONS(7206),
    [anon_sym_DQUOTE] = ACTIONS(7206),
    [sym_raw_string] = ACTIONS(7206),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7206),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7206),
    [anon_sym_BQUOTE] = ACTIONS(7206),
    [anon_sym_LT_LPAREN] = ACTIONS(7206),
    [anon_sym_GT_LPAREN] = ACTIONS(7206),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7208),
    [anon_sym_LF] = ACTIONS(7206),
    [anon_sym_AMP] = ACTIONS(7208),
  },
  [3729] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9117),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3730] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9119),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3731] = {
    [sym_file_descriptor] = ACTIONS(7242),
    [sym__concat] = ACTIONS(7242),
    [sym_variable_name] = ACTIONS(7242),
    [anon_sym_SEMI] = ACTIONS(7244),
    [anon_sym_PIPE] = ACTIONS(7244),
    [anon_sym_SEMI_SEMI] = ACTIONS(7242),
    [anon_sym_PIPE_AMP] = ACTIONS(7242),
    [anon_sym_AMP_AMP] = ACTIONS(7242),
    [anon_sym_PIPE_PIPE] = ACTIONS(7242),
    [anon_sym_LT] = ACTIONS(7244),
    [anon_sym_GT] = ACTIONS(7244),
    [anon_sym_GT_GT] = ACTIONS(7242),
    [anon_sym_AMP_GT] = ACTIONS(7244),
    [anon_sym_AMP_GT_GT] = ACTIONS(7242),
    [anon_sym_LT_AMP] = ACTIONS(7242),
    [anon_sym_GT_AMP] = ACTIONS(7242),
    [anon_sym_LT_LT] = ACTIONS(7244),
    [anon_sym_LT_LT_DASH] = ACTIONS(7242),
    [anon_sym_LT_LT_LT] = ACTIONS(7242),
    [anon_sym_DOLLAR] = ACTIONS(7244),
    [sym__special_character] = ACTIONS(7242),
    [anon_sym_DQUOTE] = ACTIONS(7242),
    [sym_raw_string] = ACTIONS(7242),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7242),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7242),
    [anon_sym_BQUOTE] = ACTIONS(7242),
    [anon_sym_LT_LPAREN] = ACTIONS(7242),
    [anon_sym_GT_LPAREN] = ACTIONS(7242),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7244),
    [anon_sym_LF] = ACTIONS(7242),
    [anon_sym_AMP] = ACTIONS(7244),
  },
  [3732] = {
    [sym_file_descriptor] = ACTIONS(8400),
    [anon_sym_SEMI] = ACTIONS(8402),
    [anon_sym_PIPE] = ACTIONS(8402),
    [anon_sym_SEMI_SEMI] = ACTIONS(8400),
    [anon_sym_PIPE_AMP] = ACTIONS(8400),
    [anon_sym_AMP_AMP] = ACTIONS(8400),
    [anon_sym_PIPE_PIPE] = ACTIONS(8400),
    [anon_sym_LT] = ACTIONS(8402),
    [anon_sym_GT] = ACTIONS(8402),
    [anon_sym_GT_GT] = ACTIONS(8400),
    [anon_sym_AMP_GT] = ACTIONS(8402),
    [anon_sym_AMP_GT_GT] = ACTIONS(8400),
    [anon_sym_LT_AMP] = ACTIONS(8400),
    [anon_sym_GT_AMP] = ACTIONS(8400),
    [anon_sym_LT_LT] = ACTIONS(8402),
    [anon_sym_LT_LT_DASH] = ACTIONS(8400),
    [anon_sym_LT_LT_LT] = ACTIONS(8400),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8400),
    [anon_sym_AMP] = ACTIONS(8402),
  },
  [3733] = {
    [sym_do_group] = STATE(4047),
    [sym_compound_statement] = STATE(4047),
    [anon_sym_do] = ACTIONS(1631),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_comment] = ACTIONS(57),
  },
  [3734] = {
    [sym_do_group] = STATE(4047),
    [sym_compound_statement] = STATE(4047),
    [anon_sym_SEMI] = ACTIONS(9121),
    [anon_sym_do] = ACTIONS(1631),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_comment] = ACTIONS(57),
  },
  [3735] = {
    [sym_file_descriptor] = ACTIONS(9041),
    [anon_sym_SEMI] = ACTIONS(9043),
    [anon_sym_PIPE] = ACTIONS(9043),
    [anon_sym_SEMI_SEMI] = ACTIONS(9041),
    [anon_sym_PIPE_AMP] = ACTIONS(9041),
    [anon_sym_AMP_AMP] = ACTIONS(9041),
    [anon_sym_PIPE_PIPE] = ACTIONS(9041),
    [anon_sym_LT] = ACTIONS(9043),
    [anon_sym_GT] = ACTIONS(9043),
    [anon_sym_GT_GT] = ACTIONS(9041),
    [anon_sym_AMP_GT] = ACTIONS(9043),
    [anon_sym_AMP_GT_GT] = ACTIONS(9041),
    [anon_sym_LT_AMP] = ACTIONS(9041),
    [anon_sym_GT_AMP] = ACTIONS(9041),
    [anon_sym_LT_LT] = ACTIONS(9043),
    [anon_sym_LT_LT_DASH] = ACTIONS(9041),
    [anon_sym_LT_LT_LT] = ACTIONS(9041),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(9041),
    [anon_sym_AMP] = ACTIONS(9043),
  },
  [3736] = {
    [sym_file_descriptor] = ACTIONS(9045),
    [anon_sym_SEMI] = ACTIONS(9047),
    [anon_sym_PIPE] = ACTIONS(9047),
    [anon_sym_SEMI_SEMI] = ACTIONS(9045),
    [anon_sym_PIPE_AMP] = ACTIONS(9045),
    [anon_sym_AMP_AMP] = ACTIONS(9045),
    [anon_sym_PIPE_PIPE] = ACTIONS(9045),
    [anon_sym_LT] = ACTIONS(9047),
    [anon_sym_GT] = ACTIONS(9047),
    [anon_sym_GT_GT] = ACTIONS(9045),
    [anon_sym_AMP_GT] = ACTIONS(9047),
    [anon_sym_AMP_GT_GT] = ACTIONS(9045),
    [anon_sym_LT_AMP] = ACTIONS(9045),
    [anon_sym_GT_AMP] = ACTIONS(9045),
    [anon_sym_LT_LT] = ACTIONS(9047),
    [anon_sym_LT_LT_DASH] = ACTIONS(9045),
    [anon_sym_LT_LT_LT] = ACTIONS(9045),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(9045),
    [anon_sym_AMP] = ACTIONS(9047),
  },
  [3737] = {
    [sym_file_descriptor] = ACTIONS(8340),
    [sym__concat] = ACTIONS(8340),
    [sym_variable_name] = ACTIONS(8340),
    [anon_sym_SEMI] = ACTIONS(8342),
    [anon_sym_PIPE] = ACTIONS(8342),
    [anon_sym_SEMI_SEMI] = ACTIONS(8340),
    [anon_sym_PIPE_AMP] = ACTIONS(8340),
    [anon_sym_AMP_AMP] = ACTIONS(8340),
    [anon_sym_PIPE_PIPE] = ACTIONS(8340),
    [anon_sym_LT] = ACTIONS(8342),
    [anon_sym_GT] = ACTIONS(8342),
    [anon_sym_GT_GT] = ACTIONS(8340),
    [anon_sym_AMP_GT] = ACTIONS(8342),
    [anon_sym_AMP_GT_GT] = ACTIONS(8340),
    [anon_sym_LT_AMP] = ACTIONS(8340),
    [anon_sym_GT_AMP] = ACTIONS(8340),
    [anon_sym_LT_LT] = ACTIONS(8342),
    [anon_sym_LT_LT_DASH] = ACTIONS(8340),
    [anon_sym_LT_LT_LT] = ACTIONS(8340),
    [anon_sym_DOLLAR] = ACTIONS(8342),
    [sym__special_character] = ACTIONS(8340),
    [anon_sym_DQUOTE] = ACTIONS(8340),
    [sym_raw_string] = ACTIONS(8340),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8340),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [anon_sym_LT_LPAREN] = ACTIONS(8340),
    [anon_sym_GT_LPAREN] = ACTIONS(8340),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8342),
    [sym_word] = ACTIONS(8342),
    [anon_sym_LF] = ACTIONS(8340),
    [anon_sym_AMP] = ACTIONS(8342),
  },
  [3738] = {
    [sym_file_descriptor] = ACTIONS(8344),
    [sym__concat] = ACTIONS(8344),
    [sym_variable_name] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [anon_sym_PIPE] = ACTIONS(8346),
    [anon_sym_SEMI_SEMI] = ACTIONS(8344),
    [anon_sym_PIPE_AMP] = ACTIONS(8344),
    [anon_sym_AMP_AMP] = ACTIONS(8344),
    [anon_sym_PIPE_PIPE] = ACTIONS(8344),
    [anon_sym_LT] = ACTIONS(8346),
    [anon_sym_GT] = ACTIONS(8346),
    [anon_sym_GT_GT] = ACTIONS(8344),
    [anon_sym_AMP_GT] = ACTIONS(8346),
    [anon_sym_AMP_GT_GT] = ACTIONS(8344),
    [anon_sym_LT_AMP] = ACTIONS(8344),
    [anon_sym_GT_AMP] = ACTIONS(8344),
    [anon_sym_LT_LT] = ACTIONS(8346),
    [anon_sym_LT_LT_DASH] = ACTIONS(8344),
    [anon_sym_LT_LT_LT] = ACTIONS(8344),
    [anon_sym_DOLLAR] = ACTIONS(8346),
    [sym__special_character] = ACTIONS(8344),
    [anon_sym_DQUOTE] = ACTIONS(8344),
    [sym_raw_string] = ACTIONS(8344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8344),
    [anon_sym_BQUOTE] = ACTIONS(8344),
    [anon_sym_LT_LPAREN] = ACTIONS(8344),
    [anon_sym_GT_LPAREN] = ACTIONS(8344),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8346),
    [sym_word] = ACTIONS(8346),
    [anon_sym_LF] = ACTIONS(8344),
    [anon_sym_AMP] = ACTIONS(8346),
  },
  [3739] = {
    [sym_file_descriptor] = ACTIONS(8340),
    [sym__concat] = ACTIONS(8340),
    [anon_sym_SEMI] = ACTIONS(8342),
    [anon_sym_PIPE] = ACTIONS(8342),
    [anon_sym_SEMI_SEMI] = ACTIONS(8340),
    [anon_sym_PIPE_AMP] = ACTIONS(8340),
    [anon_sym_AMP_AMP] = ACTIONS(8340),
    [anon_sym_PIPE_PIPE] = ACTIONS(8340),
    [anon_sym_LT] = ACTIONS(8342),
    [anon_sym_GT] = ACTIONS(8342),
    [anon_sym_GT_GT] = ACTIONS(8340),
    [anon_sym_AMP_GT] = ACTIONS(8342),
    [anon_sym_AMP_GT_GT] = ACTIONS(8340),
    [anon_sym_LT_AMP] = ACTIONS(8340),
    [anon_sym_GT_AMP] = ACTIONS(8340),
    [anon_sym_LT_LT] = ACTIONS(8342),
    [anon_sym_LT_LT_DASH] = ACTIONS(8340),
    [anon_sym_LT_LT_LT] = ACTIONS(8340),
    [anon_sym_DOLLAR] = ACTIONS(8342),
    [sym__special_character] = ACTIONS(8340),
    [anon_sym_DQUOTE] = ACTIONS(8340),
    [sym_raw_string] = ACTIONS(8340),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8340),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [anon_sym_LT_LPAREN] = ACTIONS(8340),
    [anon_sym_GT_LPAREN] = ACTIONS(8340),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8342),
    [sym_word] = ACTIONS(8342),
    [anon_sym_LF] = ACTIONS(8340),
    [anon_sym_AMP] = ACTIONS(8342),
  },
  [3740] = {
    [sym_file_descriptor] = ACTIONS(8344),
    [sym__concat] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [anon_sym_PIPE] = ACTIONS(8346),
    [anon_sym_SEMI_SEMI] = ACTIONS(8344),
    [anon_sym_PIPE_AMP] = ACTIONS(8344),
    [anon_sym_AMP_AMP] = ACTIONS(8344),
    [anon_sym_PIPE_PIPE] = ACTIONS(8344),
    [anon_sym_LT] = ACTIONS(8346),
    [anon_sym_GT] = ACTIONS(8346),
    [anon_sym_GT_GT] = ACTIONS(8344),
    [anon_sym_AMP_GT] = ACTIONS(8346),
    [anon_sym_AMP_GT_GT] = ACTIONS(8344),
    [anon_sym_LT_AMP] = ACTIONS(8344),
    [anon_sym_GT_AMP] = ACTIONS(8344),
    [anon_sym_LT_LT] = ACTIONS(8346),
    [anon_sym_LT_LT_DASH] = ACTIONS(8344),
    [anon_sym_LT_LT_LT] = ACTIONS(8344),
    [anon_sym_DOLLAR] = ACTIONS(8346),
    [sym__special_character] = ACTIONS(8344),
    [anon_sym_DQUOTE] = ACTIONS(8344),
    [sym_raw_string] = ACTIONS(8344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8344),
    [anon_sym_BQUOTE] = ACTIONS(8344),
    [anon_sym_LT_LPAREN] = ACTIONS(8344),
    [anon_sym_GT_LPAREN] = ACTIONS(8344),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8346),
    [sym_word] = ACTIONS(8346),
    [anon_sym_LF] = ACTIONS(8344),
    [anon_sym_AMP] = ACTIONS(8346),
  },
  [3741] = {
    [sym_string] = STATE(2817),
    [sym__simple_heredoc_body] = ACTIONS(4071),
    [sym__heredoc_body_beginning] = ACTIONS(4071),
    [sym_file_descriptor] = ACTIONS(4071),
    [sym_variable_name] = ACTIONS(4071),
    [anon_sym_SEMI] = ACTIONS(4073),
    [anon_sym_done] = ACTIONS(4073),
    [anon_sym_PIPE] = ACTIONS(4073),
    [anon_sym_SEMI_SEMI] = ACTIONS(4071),
    [anon_sym_PIPE_AMP] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_PIPE_PIPE] = ACTIONS(4071),
    [anon_sym_LT] = ACTIONS(4073),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_GT_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT] = ACTIONS(4073),
    [anon_sym_AMP_GT_GT] = ACTIONS(4071),
    [anon_sym_LT_AMP] = ACTIONS(4071),
    [anon_sym_GT_AMP] = ACTIONS(4071),
    [anon_sym_LT_LT] = ACTIONS(4073),
    [anon_sym_LT_LT_DASH] = ACTIONS(4071),
    [anon_sym_LT_LT_LT] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(9123),
    [anon_sym_DOLLAR] = ACTIONS(9123),
    [sym__special_character] = ACTIONS(4071),
    [anon_sym_DQUOTE] = ACTIONS(4880),
    [sym_raw_string] = ACTIONS(6145),
    [anon_sym_POUND] = ACTIONS(6143),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4071),
    [anon_sym_BQUOTE] = ACTIONS(4071),
    [anon_sym_LT_LPAREN] = ACTIONS(4071),
    [anon_sym_GT_LPAREN] = ACTIONS(4071),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6147),
    [anon_sym_STAR] = ACTIONS(6147),
    [anon_sym_AT] = ACTIONS(6147),
    [anon_sym_QMARK] = ACTIONS(6147),
    [anon_sym_0] = ACTIONS(6147),
    [anon_sym__] = ACTIONS(6147),
    [sym_word] = ACTIONS(4073),
    [anon_sym_LF] = ACTIONS(4071),
    [anon_sym_AMP] = ACTIONS(4073),
  },
  [3742] = {
    [sym__simple_heredoc_body] = ACTIONS(4111),
    [sym__heredoc_body_beginning] = ACTIONS(4111),
    [sym_file_descriptor] = ACTIONS(4111),
    [sym__concat] = ACTIONS(4111),
    [sym_variable_name] = ACTIONS(4111),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_done] = ACTIONS(4113),
    [anon_sym_PIPE] = ACTIONS(4113),
    [anon_sym_SEMI_SEMI] = ACTIONS(4111),
    [anon_sym_PIPE_AMP] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_LT] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4113),
    [anon_sym_GT_GT] = ACTIONS(4111),
    [anon_sym_AMP_GT] = ACTIONS(4113),
    [anon_sym_AMP_GT_GT] = ACTIONS(4111),
    [anon_sym_LT_AMP] = ACTIONS(4111),
    [anon_sym_GT_AMP] = ACTIONS(4111),
    [anon_sym_LT_LT] = ACTIONS(4113),
    [anon_sym_LT_LT_DASH] = ACTIONS(4111),
    [anon_sym_LT_LT_LT] = ACTIONS(4111),
    [anon_sym_DOLLAR] = ACTIONS(4113),
    [sym__special_character] = ACTIONS(4111),
    [anon_sym_DQUOTE] = ACTIONS(4111),
    [sym_raw_string] = ACTIONS(4111),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4111),
    [anon_sym_BQUOTE] = ACTIONS(4111),
    [anon_sym_LT_LPAREN] = ACTIONS(4111),
    [anon_sym_GT_LPAREN] = ACTIONS(4111),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4113),
    [anon_sym_LF] = ACTIONS(4111),
    [anon_sym_AMP] = ACTIONS(4113),
  },
  [3743] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [sym_variable_name] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_done] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym__special_character] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [3744] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(9125),
    [sym_comment] = ACTIONS(57),
  },
  [3745] = {
    [anon_sym_RBRACE] = ACTIONS(9125),
    [sym_comment] = ACTIONS(57),
  },
  [3746] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(9127),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [3747] = {
    [sym_concatenation] = STATE(4052),
    [sym_string] = STATE(4051),
    [sym_simple_expansion] = STATE(4051),
    [sym_string_expansion] = STATE(4051),
    [sym_expansion] = STATE(4051),
    [sym_command_substitution] = STATE(4051),
    [sym_process_substitution] = STATE(4051),
    [aux_sym__literal_repeat1] = STATE(4053),
    [anon_sym_RBRACE] = ACTIONS(9125),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(9129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9129),
  },
  [3748] = {
    [sym__simple_heredoc_body] = ACTIONS(4161),
    [sym__heredoc_body_beginning] = ACTIONS(4161),
    [sym_file_descriptor] = ACTIONS(4161),
    [sym__concat] = ACTIONS(4161),
    [sym_variable_name] = ACTIONS(4161),
    [anon_sym_SEMI] = ACTIONS(4163),
    [anon_sym_done] = ACTIONS(4163),
    [anon_sym_PIPE] = ACTIONS(4163),
    [anon_sym_SEMI_SEMI] = ACTIONS(4161),
    [anon_sym_PIPE_AMP] = ACTIONS(4161),
    [anon_sym_AMP_AMP] = ACTIONS(4161),
    [anon_sym_PIPE_PIPE] = ACTIONS(4161),
    [anon_sym_LT] = ACTIONS(4163),
    [anon_sym_GT] = ACTIONS(4163),
    [anon_sym_GT_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT] = ACTIONS(4163),
    [anon_sym_AMP_GT_GT] = ACTIONS(4161),
    [anon_sym_LT_AMP] = ACTIONS(4161),
    [anon_sym_GT_AMP] = ACTIONS(4161),
    [anon_sym_LT_LT] = ACTIONS(4163),
    [anon_sym_LT_LT_DASH] = ACTIONS(4161),
    [anon_sym_LT_LT_LT] = ACTIONS(4161),
    [anon_sym_DOLLAR] = ACTIONS(4163),
    [sym__special_character] = ACTIONS(4161),
    [anon_sym_DQUOTE] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4161),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4161),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4161),
    [anon_sym_BQUOTE] = ACTIONS(4161),
    [anon_sym_LT_LPAREN] = ACTIONS(4161),
    [anon_sym_GT_LPAREN] = ACTIONS(4161),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4163),
    [anon_sym_LF] = ACTIONS(4161),
    [anon_sym_AMP] = ACTIONS(4163),
  },
  [3749] = {
    [sym_concatenation] = STATE(4056),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4056),
    [sym_regex] = ACTIONS(9131),
    [anon_sym_RBRACE] = ACTIONS(9133),
    [anon_sym_EQ] = ACTIONS(9135),
    [anon_sym_DASH] = ACTIONS(9135),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9137),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9135),
    [anon_sym_COLON_QMARK] = ACTIONS(9135),
    [anon_sym_COLON_DASH] = ACTIONS(9135),
    [anon_sym_PERCENT] = ACTIONS(9135),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3750] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9133),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3751] = {
    [sym_concatenation] = STATE(4058),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4058),
    [sym_regex] = ACTIONS(9139),
    [anon_sym_RBRACE] = ACTIONS(9125),
    [anon_sym_EQ] = ACTIONS(9141),
    [anon_sym_DASH] = ACTIONS(9141),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9143),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9141),
    [anon_sym_COLON_QMARK] = ACTIONS(9141),
    [anon_sym_COLON_DASH] = ACTIONS(9141),
    [anon_sym_PERCENT] = ACTIONS(9141),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3752] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9125),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3753] = {
    [sym_concatenation] = STATE(4060),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4060),
    [anon_sym_RBRACE] = ACTIONS(9145),
    [anon_sym_EQ] = ACTIONS(9147),
    [anon_sym_DASH] = ACTIONS(9147),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9149),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9147),
    [anon_sym_COLON_QMARK] = ACTIONS(9147),
    [anon_sym_COLON_DASH] = ACTIONS(9147),
    [anon_sym_PERCENT] = ACTIONS(9147),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3754] = {
    [sym__simple_heredoc_body] = ACTIONS(4219),
    [sym__heredoc_body_beginning] = ACTIONS(4219),
    [sym_file_descriptor] = ACTIONS(4219),
    [sym__concat] = ACTIONS(4219),
    [sym_variable_name] = ACTIONS(4219),
    [anon_sym_SEMI] = ACTIONS(4221),
    [anon_sym_done] = ACTIONS(4221),
    [anon_sym_PIPE] = ACTIONS(4221),
    [anon_sym_SEMI_SEMI] = ACTIONS(4219),
    [anon_sym_PIPE_AMP] = ACTIONS(4219),
    [anon_sym_AMP_AMP] = ACTIONS(4219),
    [anon_sym_PIPE_PIPE] = ACTIONS(4219),
    [anon_sym_LT] = ACTIONS(4221),
    [anon_sym_GT] = ACTIONS(4221),
    [anon_sym_GT_GT] = ACTIONS(4219),
    [anon_sym_AMP_GT] = ACTIONS(4221),
    [anon_sym_AMP_GT_GT] = ACTIONS(4219),
    [anon_sym_LT_AMP] = ACTIONS(4219),
    [anon_sym_GT_AMP] = ACTIONS(4219),
    [anon_sym_LT_LT] = ACTIONS(4221),
    [anon_sym_LT_LT_DASH] = ACTIONS(4219),
    [anon_sym_LT_LT_LT] = ACTIONS(4219),
    [anon_sym_DOLLAR] = ACTIONS(4221),
    [sym__special_character] = ACTIONS(4219),
    [anon_sym_DQUOTE] = ACTIONS(4219),
    [sym_raw_string] = ACTIONS(4219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4219),
    [anon_sym_BQUOTE] = ACTIONS(4219),
    [anon_sym_LT_LPAREN] = ACTIONS(4219),
    [anon_sym_GT_LPAREN] = ACTIONS(4219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4221),
    [anon_sym_LF] = ACTIONS(4219),
    [anon_sym_AMP] = ACTIONS(4221),
  },
  [3755] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9145),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3756] = {
    [sym_concatenation] = STATE(4058),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4058),
    [anon_sym_RBRACE] = ACTIONS(9125),
    [anon_sym_EQ] = ACTIONS(9141),
    [anon_sym_DASH] = ACTIONS(9141),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9143),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9141),
    [anon_sym_COLON_QMARK] = ACTIONS(9141),
    [anon_sym_COLON_DASH] = ACTIONS(9141),
    [anon_sym_PERCENT] = ACTIONS(9141),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3757] = {
    [sym__simple_heredoc_body] = ACTIONS(4449),
    [sym__heredoc_body_beginning] = ACTIONS(4449),
    [sym_file_descriptor] = ACTIONS(4449),
    [sym_variable_name] = ACTIONS(4449),
    [anon_sym_SEMI] = ACTIONS(4451),
    [anon_sym_done] = ACTIONS(4451),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_SEMI_SEMI] = ACTIONS(4449),
    [anon_sym_PIPE_AMP] = ACTIONS(4449),
    [anon_sym_AMP_AMP] = ACTIONS(4449),
    [anon_sym_PIPE_PIPE] = ACTIONS(4449),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_GT_GT] = ACTIONS(4449),
    [anon_sym_AMP_GT] = ACTIONS(4451),
    [anon_sym_AMP_GT_GT] = ACTIONS(4449),
    [anon_sym_LT_AMP] = ACTIONS(4449),
    [anon_sym_GT_AMP] = ACTIONS(4449),
    [anon_sym_LT_LT] = ACTIONS(4451),
    [anon_sym_LT_LT_DASH] = ACTIONS(4449),
    [anon_sym_LT_LT_LT] = ACTIONS(4449),
    [anon_sym_DOLLAR] = ACTIONS(4451),
    [sym__special_character] = ACTIONS(4449),
    [anon_sym_DQUOTE] = ACTIONS(4449),
    [sym_raw_string] = ACTIONS(4449),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4449),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4449),
    [anon_sym_BQUOTE] = ACTIONS(4449),
    [anon_sym_LT_LPAREN] = ACTIONS(4449),
    [anon_sym_GT_LPAREN] = ACTIONS(4449),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4451),
    [sym_word] = ACTIONS(4451),
    [anon_sym_LF] = ACTIONS(4449),
    [anon_sym_AMP] = ACTIONS(4451),
  },
  [3758] = {
    [sym__simple_heredoc_body] = ACTIONS(5674),
    [sym__heredoc_body_beginning] = ACTIONS(5674),
    [sym_file_descriptor] = ACTIONS(5674),
    [sym__concat] = ACTIONS(5674),
    [sym_variable_name] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(5676),
    [anon_sym_done] = ACTIONS(5676),
    [anon_sym_PIPE] = ACTIONS(5676),
    [anon_sym_SEMI_SEMI] = ACTIONS(5674),
    [anon_sym_PIPE_AMP] = ACTIONS(5674),
    [anon_sym_AMP_AMP] = ACTIONS(5674),
    [anon_sym_PIPE_PIPE] = ACTIONS(5674),
    [anon_sym_LT] = ACTIONS(5676),
    [anon_sym_GT] = ACTIONS(5676),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_AMP_GT] = ACTIONS(5676),
    [anon_sym_AMP_GT_GT] = ACTIONS(5674),
    [anon_sym_LT_AMP] = ACTIONS(5674),
    [anon_sym_GT_AMP] = ACTIONS(5674),
    [anon_sym_LT_LT] = ACTIONS(5676),
    [anon_sym_LT_LT_DASH] = ACTIONS(5674),
    [anon_sym_LT_LT_LT] = ACTIONS(5674),
    [anon_sym_DOLLAR] = ACTIONS(5676),
    [sym__special_character] = ACTIONS(5674),
    [anon_sym_DQUOTE] = ACTIONS(5674),
    [sym_raw_string] = ACTIONS(5674),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5674),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5674),
    [anon_sym_BQUOTE] = ACTIONS(5674),
    [anon_sym_LT_LPAREN] = ACTIONS(5674),
    [anon_sym_GT_LPAREN] = ACTIONS(5674),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5676),
    [sym_word] = ACTIONS(5676),
    [anon_sym_LF] = ACTIONS(5674),
    [anon_sym_AMP] = ACTIONS(5676),
  },
  [3759] = {
    [sym__simple_heredoc_body] = ACTIONS(5708),
    [sym__heredoc_body_beginning] = ACTIONS(5708),
    [sym_file_descriptor] = ACTIONS(5708),
    [sym__concat] = ACTIONS(5708),
    [sym_variable_name] = ACTIONS(5708),
    [anon_sym_SEMI] = ACTIONS(5710),
    [anon_sym_done] = ACTIONS(5710),
    [anon_sym_PIPE] = ACTIONS(5710),
    [anon_sym_SEMI_SEMI] = ACTIONS(5708),
    [anon_sym_PIPE_AMP] = ACTIONS(5708),
    [anon_sym_AMP_AMP] = ACTIONS(5708),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_LT] = ACTIONS(5710),
    [anon_sym_GT] = ACTIONS(5710),
    [anon_sym_GT_GT] = ACTIONS(5708),
    [anon_sym_AMP_GT] = ACTIONS(5710),
    [anon_sym_AMP_GT_GT] = ACTIONS(5708),
    [anon_sym_LT_AMP] = ACTIONS(5708),
    [anon_sym_GT_AMP] = ACTIONS(5708),
    [anon_sym_LT_LT] = ACTIONS(5710),
    [anon_sym_LT_LT_DASH] = ACTIONS(5708),
    [anon_sym_LT_LT_LT] = ACTIONS(5708),
    [anon_sym_DOLLAR] = ACTIONS(5710),
    [sym__special_character] = ACTIONS(5708),
    [anon_sym_DQUOTE] = ACTIONS(5708),
    [sym_raw_string] = ACTIONS(5708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5708),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5708),
    [anon_sym_BQUOTE] = ACTIONS(5708),
    [anon_sym_LT_LPAREN] = ACTIONS(5708),
    [anon_sym_GT_LPAREN] = ACTIONS(5708),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5710),
    [sym_word] = ACTIONS(5710),
    [anon_sym_LF] = ACTIONS(5708),
    [anon_sym_AMP] = ACTIONS(5710),
  },
  [3760] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(9151),
    [sym_comment] = ACTIONS(57),
  },
  [3761] = {
    [anon_sym_RBRACE] = ACTIONS(9151),
    [sym_comment] = ACTIONS(57),
  },
  [3762] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(9153),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [3763] = {
    [sym_concatenation] = STATE(4064),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4064),
    [anon_sym_RBRACE] = ACTIONS(9155),
    [anon_sym_EQ] = ACTIONS(9157),
    [anon_sym_DASH] = ACTIONS(9157),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9159),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9157),
    [anon_sym_COLON_QMARK] = ACTIONS(9157),
    [anon_sym_COLON_DASH] = ACTIONS(9157),
    [anon_sym_PERCENT] = ACTIONS(9157),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3764] = {
    [sym__simple_heredoc_body] = ACTIONS(5725),
    [sym__heredoc_body_beginning] = ACTIONS(5725),
    [sym_file_descriptor] = ACTIONS(5725),
    [sym__concat] = ACTIONS(5725),
    [sym_variable_name] = ACTIONS(5725),
    [anon_sym_SEMI] = ACTIONS(5727),
    [anon_sym_done] = ACTIONS(5727),
    [anon_sym_PIPE] = ACTIONS(5727),
    [anon_sym_SEMI_SEMI] = ACTIONS(5725),
    [anon_sym_PIPE_AMP] = ACTIONS(5725),
    [anon_sym_AMP_AMP] = ACTIONS(5725),
    [anon_sym_PIPE_PIPE] = ACTIONS(5725),
    [anon_sym_LT] = ACTIONS(5727),
    [anon_sym_GT] = ACTIONS(5727),
    [anon_sym_GT_GT] = ACTIONS(5725),
    [anon_sym_AMP_GT] = ACTIONS(5727),
    [anon_sym_AMP_GT_GT] = ACTIONS(5725),
    [anon_sym_LT_AMP] = ACTIONS(5725),
    [anon_sym_GT_AMP] = ACTIONS(5725),
    [anon_sym_LT_LT] = ACTIONS(5727),
    [anon_sym_LT_LT_DASH] = ACTIONS(5725),
    [anon_sym_LT_LT_LT] = ACTIONS(5725),
    [anon_sym_DOLLAR] = ACTIONS(5727),
    [sym__special_character] = ACTIONS(5725),
    [anon_sym_DQUOTE] = ACTIONS(5725),
    [sym_raw_string] = ACTIONS(5725),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5725),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5725),
    [anon_sym_BQUOTE] = ACTIONS(5725),
    [anon_sym_LT_LPAREN] = ACTIONS(5725),
    [anon_sym_GT_LPAREN] = ACTIONS(5725),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5727),
    [sym_word] = ACTIONS(5727),
    [anon_sym_LF] = ACTIONS(5725),
    [anon_sym_AMP] = ACTIONS(5727),
  },
  [3765] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9155),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3766] = {
    [sym_concatenation] = STATE(4065),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4065),
    [anon_sym_RBRACE] = ACTIONS(9151),
    [anon_sym_EQ] = ACTIONS(9161),
    [anon_sym_DASH] = ACTIONS(9161),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9163),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9161),
    [anon_sym_COLON_QMARK] = ACTIONS(9161),
    [anon_sym_COLON_DASH] = ACTIONS(9161),
    [anon_sym_PERCENT] = ACTIONS(9161),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3767] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9151),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3768] = {
    [sym__simple_heredoc_body] = ACTIONS(5770),
    [sym__heredoc_body_beginning] = ACTIONS(5770),
    [sym_file_descriptor] = ACTIONS(5770),
    [sym__concat] = ACTIONS(5770),
    [sym_variable_name] = ACTIONS(5770),
    [anon_sym_SEMI] = ACTIONS(5772),
    [anon_sym_done] = ACTIONS(5772),
    [anon_sym_PIPE] = ACTIONS(5772),
    [anon_sym_SEMI_SEMI] = ACTIONS(5770),
    [anon_sym_PIPE_AMP] = ACTIONS(5770),
    [anon_sym_AMP_AMP] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5770),
    [anon_sym_LT] = ACTIONS(5772),
    [anon_sym_GT] = ACTIONS(5772),
    [anon_sym_GT_GT] = ACTIONS(5770),
    [anon_sym_AMP_GT] = ACTIONS(5772),
    [anon_sym_AMP_GT_GT] = ACTIONS(5770),
    [anon_sym_LT_AMP] = ACTIONS(5770),
    [anon_sym_GT_AMP] = ACTIONS(5770),
    [anon_sym_LT_LT] = ACTIONS(5772),
    [anon_sym_LT_LT_DASH] = ACTIONS(5770),
    [anon_sym_LT_LT_LT] = ACTIONS(5770),
    [anon_sym_DOLLAR] = ACTIONS(5772),
    [sym__special_character] = ACTIONS(5770),
    [anon_sym_DQUOTE] = ACTIONS(5770),
    [sym_raw_string] = ACTIONS(5770),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5770),
    [anon_sym_BQUOTE] = ACTIONS(5770),
    [anon_sym_LT_LPAREN] = ACTIONS(5770),
    [anon_sym_GT_LPAREN] = ACTIONS(5770),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5772),
    [sym_word] = ACTIONS(5772),
    [anon_sym_LF] = ACTIONS(5770),
    [anon_sym_AMP] = ACTIONS(5772),
  },
  [3769] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9165),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3770] = {
    [sym__simple_heredoc_body] = ACTIONS(5674),
    [sym__heredoc_body_beginning] = ACTIONS(5674),
    [sym_file_descriptor] = ACTIONS(5674),
    [sym__concat] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(5676),
    [anon_sym_done] = ACTIONS(5676),
    [anon_sym_PIPE] = ACTIONS(5676),
    [anon_sym_SEMI_SEMI] = ACTIONS(5674),
    [anon_sym_PIPE_AMP] = ACTIONS(5674),
    [anon_sym_AMP_AMP] = ACTIONS(5674),
    [anon_sym_PIPE_PIPE] = ACTIONS(5674),
    [anon_sym_LT] = ACTIONS(5676),
    [anon_sym_GT] = ACTIONS(5676),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_AMP_GT] = ACTIONS(5676),
    [anon_sym_AMP_GT_GT] = ACTIONS(5674),
    [anon_sym_LT_AMP] = ACTIONS(5674),
    [anon_sym_GT_AMP] = ACTIONS(5674),
    [anon_sym_LT_LT] = ACTIONS(5676),
    [anon_sym_LT_LT_DASH] = ACTIONS(5674),
    [anon_sym_LT_LT_LT] = ACTIONS(5674),
    [anon_sym_DOLLAR] = ACTIONS(5676),
    [sym__special_character] = ACTIONS(5674),
    [anon_sym_DQUOTE] = ACTIONS(5674),
    [sym_raw_string] = ACTIONS(5674),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5674),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5674),
    [anon_sym_BQUOTE] = ACTIONS(5674),
    [anon_sym_LT_LPAREN] = ACTIONS(5674),
    [anon_sym_GT_LPAREN] = ACTIONS(5674),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5676),
    [sym_word] = ACTIONS(5676),
    [anon_sym_LF] = ACTIONS(5674),
    [anon_sym_AMP] = ACTIONS(5676),
  },
  [3771] = {
    [sym__simple_heredoc_body] = ACTIONS(5708),
    [sym__heredoc_body_beginning] = ACTIONS(5708),
    [sym_file_descriptor] = ACTIONS(5708),
    [sym__concat] = ACTIONS(5708),
    [anon_sym_SEMI] = ACTIONS(5710),
    [anon_sym_done] = ACTIONS(5710),
    [anon_sym_PIPE] = ACTIONS(5710),
    [anon_sym_SEMI_SEMI] = ACTIONS(5708),
    [anon_sym_PIPE_AMP] = ACTIONS(5708),
    [anon_sym_AMP_AMP] = ACTIONS(5708),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_LT] = ACTIONS(5710),
    [anon_sym_GT] = ACTIONS(5710),
    [anon_sym_GT_GT] = ACTIONS(5708),
    [anon_sym_AMP_GT] = ACTIONS(5710),
    [anon_sym_AMP_GT_GT] = ACTIONS(5708),
    [anon_sym_LT_AMP] = ACTIONS(5708),
    [anon_sym_GT_AMP] = ACTIONS(5708),
    [anon_sym_LT_LT] = ACTIONS(5710),
    [anon_sym_LT_LT_DASH] = ACTIONS(5708),
    [anon_sym_LT_LT_LT] = ACTIONS(5708),
    [anon_sym_DOLLAR] = ACTIONS(5710),
    [sym__special_character] = ACTIONS(5708),
    [anon_sym_DQUOTE] = ACTIONS(5708),
    [sym_raw_string] = ACTIONS(5708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5708),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5708),
    [anon_sym_BQUOTE] = ACTIONS(5708),
    [anon_sym_LT_LPAREN] = ACTIONS(5708),
    [anon_sym_GT_LPAREN] = ACTIONS(5708),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5710),
    [sym_word] = ACTIONS(5710),
    [anon_sym_LF] = ACTIONS(5708),
    [anon_sym_AMP] = ACTIONS(5710),
  },
  [3772] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(9167),
    [sym_comment] = ACTIONS(57),
  },
  [3773] = {
    [anon_sym_RBRACE] = ACTIONS(9167),
    [sym_comment] = ACTIONS(57),
  },
  [3774] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(9169),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [3775] = {
    [sym_concatenation] = STATE(4070),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4070),
    [anon_sym_RBRACE] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9173),
    [anon_sym_DASH] = ACTIONS(9173),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9175),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9173),
    [anon_sym_COLON_QMARK] = ACTIONS(9173),
    [anon_sym_COLON_DASH] = ACTIONS(9173),
    [anon_sym_PERCENT] = ACTIONS(9173),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3776] = {
    [sym__simple_heredoc_body] = ACTIONS(5725),
    [sym__heredoc_body_beginning] = ACTIONS(5725),
    [sym_file_descriptor] = ACTIONS(5725),
    [sym__concat] = ACTIONS(5725),
    [anon_sym_SEMI] = ACTIONS(5727),
    [anon_sym_done] = ACTIONS(5727),
    [anon_sym_PIPE] = ACTIONS(5727),
    [anon_sym_SEMI_SEMI] = ACTIONS(5725),
    [anon_sym_PIPE_AMP] = ACTIONS(5725),
    [anon_sym_AMP_AMP] = ACTIONS(5725),
    [anon_sym_PIPE_PIPE] = ACTIONS(5725),
    [anon_sym_LT] = ACTIONS(5727),
    [anon_sym_GT] = ACTIONS(5727),
    [anon_sym_GT_GT] = ACTIONS(5725),
    [anon_sym_AMP_GT] = ACTIONS(5727),
    [anon_sym_AMP_GT_GT] = ACTIONS(5725),
    [anon_sym_LT_AMP] = ACTIONS(5725),
    [anon_sym_GT_AMP] = ACTIONS(5725),
    [anon_sym_LT_LT] = ACTIONS(5727),
    [anon_sym_LT_LT_DASH] = ACTIONS(5725),
    [anon_sym_LT_LT_LT] = ACTIONS(5725),
    [anon_sym_DOLLAR] = ACTIONS(5727),
    [sym__special_character] = ACTIONS(5725),
    [anon_sym_DQUOTE] = ACTIONS(5725),
    [sym_raw_string] = ACTIONS(5725),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5725),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5725),
    [anon_sym_BQUOTE] = ACTIONS(5725),
    [anon_sym_LT_LPAREN] = ACTIONS(5725),
    [anon_sym_GT_LPAREN] = ACTIONS(5725),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5727),
    [sym_word] = ACTIONS(5727),
    [anon_sym_LF] = ACTIONS(5725),
    [anon_sym_AMP] = ACTIONS(5727),
  },
  [3777] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3778] = {
    [sym_concatenation] = STATE(4071),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4071),
    [anon_sym_RBRACE] = ACTIONS(9167),
    [anon_sym_EQ] = ACTIONS(9177),
    [anon_sym_DASH] = ACTIONS(9177),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9179),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9177),
    [anon_sym_COLON_QMARK] = ACTIONS(9177),
    [anon_sym_COLON_DASH] = ACTIONS(9177),
    [anon_sym_PERCENT] = ACTIONS(9177),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3779] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9167),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3780] = {
    [sym__simple_heredoc_body] = ACTIONS(5770),
    [sym__heredoc_body_beginning] = ACTIONS(5770),
    [sym_file_descriptor] = ACTIONS(5770),
    [sym__concat] = ACTIONS(5770),
    [anon_sym_SEMI] = ACTIONS(5772),
    [anon_sym_done] = ACTIONS(5772),
    [anon_sym_PIPE] = ACTIONS(5772),
    [anon_sym_SEMI_SEMI] = ACTIONS(5770),
    [anon_sym_PIPE_AMP] = ACTIONS(5770),
    [anon_sym_AMP_AMP] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5770),
    [anon_sym_LT] = ACTIONS(5772),
    [anon_sym_GT] = ACTIONS(5772),
    [anon_sym_GT_GT] = ACTIONS(5770),
    [anon_sym_AMP_GT] = ACTIONS(5772),
    [anon_sym_AMP_GT_GT] = ACTIONS(5770),
    [anon_sym_LT_AMP] = ACTIONS(5770),
    [anon_sym_GT_AMP] = ACTIONS(5770),
    [anon_sym_LT_LT] = ACTIONS(5772),
    [anon_sym_LT_LT_DASH] = ACTIONS(5770),
    [anon_sym_LT_LT_LT] = ACTIONS(5770),
    [anon_sym_DOLLAR] = ACTIONS(5772),
    [sym__special_character] = ACTIONS(5770),
    [anon_sym_DQUOTE] = ACTIONS(5770),
    [sym_raw_string] = ACTIONS(5770),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5770),
    [anon_sym_BQUOTE] = ACTIONS(5770),
    [anon_sym_LT_LPAREN] = ACTIONS(5770),
    [anon_sym_GT_LPAREN] = ACTIONS(5770),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5772),
    [sym_word] = ACTIONS(5772),
    [anon_sym_LF] = ACTIONS(5770),
    [anon_sym_AMP] = ACTIONS(5772),
  },
  [3781] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9181),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3782] = {
    [sym__simple_heredoc_body] = ACTIONS(7198),
    [sym__heredoc_body_beginning] = ACTIONS(7198),
    [sym_file_descriptor] = ACTIONS(7198),
    [sym__concat] = ACTIONS(7198),
    [anon_sym_SEMI] = ACTIONS(7200),
    [anon_sym_done] = ACTIONS(7200),
    [anon_sym_PIPE] = ACTIONS(7200),
    [anon_sym_SEMI_SEMI] = ACTIONS(7198),
    [anon_sym_PIPE_AMP] = ACTIONS(7198),
    [anon_sym_AMP_AMP] = ACTIONS(7198),
    [anon_sym_PIPE_PIPE] = ACTIONS(7198),
    [anon_sym_EQ_TILDE] = ACTIONS(7200),
    [anon_sym_EQ_EQ] = ACTIONS(7200),
    [anon_sym_LT] = ACTIONS(7200),
    [anon_sym_GT] = ACTIONS(7200),
    [anon_sym_GT_GT] = ACTIONS(7198),
    [anon_sym_AMP_GT] = ACTIONS(7200),
    [anon_sym_AMP_GT_GT] = ACTIONS(7198),
    [anon_sym_LT_AMP] = ACTIONS(7198),
    [anon_sym_GT_AMP] = ACTIONS(7198),
    [anon_sym_LT_LT] = ACTIONS(7200),
    [anon_sym_LT_LT_DASH] = ACTIONS(7198),
    [anon_sym_LT_LT_LT] = ACTIONS(7198),
    [anon_sym_DOLLAR] = ACTIONS(7200),
    [sym__special_character] = ACTIONS(7198),
    [anon_sym_DQUOTE] = ACTIONS(7198),
    [sym_raw_string] = ACTIONS(7198),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7198),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7198),
    [anon_sym_BQUOTE] = ACTIONS(7198),
    [anon_sym_LT_LPAREN] = ACTIONS(7198),
    [anon_sym_GT_LPAREN] = ACTIONS(7198),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7200),
    [anon_sym_LF] = ACTIONS(7198),
    [anon_sym_AMP] = ACTIONS(7200),
  },
  [3783] = {
    [sym__simple_heredoc_body] = ACTIONS(7202),
    [sym__heredoc_body_beginning] = ACTIONS(7202),
    [sym_file_descriptor] = ACTIONS(7202),
    [sym__concat] = ACTIONS(7202),
    [anon_sym_SEMI] = ACTIONS(7204),
    [anon_sym_done] = ACTIONS(7204),
    [anon_sym_PIPE] = ACTIONS(7204),
    [anon_sym_SEMI_SEMI] = ACTIONS(7202),
    [anon_sym_PIPE_AMP] = ACTIONS(7202),
    [anon_sym_AMP_AMP] = ACTIONS(7202),
    [anon_sym_PIPE_PIPE] = ACTIONS(7202),
    [anon_sym_EQ_TILDE] = ACTIONS(7204),
    [anon_sym_EQ_EQ] = ACTIONS(7204),
    [anon_sym_LT] = ACTIONS(7204),
    [anon_sym_GT] = ACTIONS(7204),
    [anon_sym_GT_GT] = ACTIONS(7202),
    [anon_sym_AMP_GT] = ACTIONS(7204),
    [anon_sym_AMP_GT_GT] = ACTIONS(7202),
    [anon_sym_LT_AMP] = ACTIONS(7202),
    [anon_sym_GT_AMP] = ACTIONS(7202),
    [anon_sym_LT_LT] = ACTIONS(7204),
    [anon_sym_LT_LT_DASH] = ACTIONS(7202),
    [anon_sym_LT_LT_LT] = ACTIONS(7202),
    [anon_sym_DOLLAR] = ACTIONS(7204),
    [sym__special_character] = ACTIONS(7202),
    [anon_sym_DQUOTE] = ACTIONS(7202),
    [sym_raw_string] = ACTIONS(7202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7202),
    [anon_sym_BQUOTE] = ACTIONS(7202),
    [anon_sym_LT_LPAREN] = ACTIONS(7202),
    [anon_sym_GT_LPAREN] = ACTIONS(7202),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7204),
    [anon_sym_LF] = ACTIONS(7202),
    [anon_sym_AMP] = ACTIONS(7204),
  },
  [3784] = {
    [sym__simple_heredoc_body] = ACTIONS(7206),
    [sym__heredoc_body_beginning] = ACTIONS(7206),
    [sym_file_descriptor] = ACTIONS(7206),
    [sym__concat] = ACTIONS(7206),
    [anon_sym_SEMI] = ACTIONS(7208),
    [anon_sym_done] = ACTIONS(7208),
    [anon_sym_PIPE] = ACTIONS(7208),
    [anon_sym_SEMI_SEMI] = ACTIONS(7206),
    [anon_sym_PIPE_AMP] = ACTIONS(7206),
    [anon_sym_AMP_AMP] = ACTIONS(7206),
    [anon_sym_PIPE_PIPE] = ACTIONS(7206),
    [anon_sym_EQ_TILDE] = ACTIONS(7208),
    [anon_sym_EQ_EQ] = ACTIONS(7208),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7206),
    [anon_sym_AMP_GT] = ACTIONS(7208),
    [anon_sym_AMP_GT_GT] = ACTIONS(7206),
    [anon_sym_LT_AMP] = ACTIONS(7206),
    [anon_sym_GT_AMP] = ACTIONS(7206),
    [anon_sym_LT_LT] = ACTIONS(7208),
    [anon_sym_LT_LT_DASH] = ACTIONS(7206),
    [anon_sym_LT_LT_LT] = ACTIONS(7206),
    [anon_sym_DOLLAR] = ACTIONS(7208),
    [sym__special_character] = ACTIONS(7206),
    [anon_sym_DQUOTE] = ACTIONS(7206),
    [sym_raw_string] = ACTIONS(7206),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7206),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7206),
    [anon_sym_BQUOTE] = ACTIONS(7206),
    [anon_sym_LT_LPAREN] = ACTIONS(7206),
    [anon_sym_GT_LPAREN] = ACTIONS(7206),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7208),
    [anon_sym_LF] = ACTIONS(7206),
    [anon_sym_AMP] = ACTIONS(7208),
  },
  [3785] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9183),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3786] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9185),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3787] = {
    [sym__simple_heredoc_body] = ACTIONS(7242),
    [sym__heredoc_body_beginning] = ACTIONS(7242),
    [sym_file_descriptor] = ACTIONS(7242),
    [sym__concat] = ACTIONS(7242),
    [anon_sym_SEMI] = ACTIONS(7244),
    [anon_sym_done] = ACTIONS(7244),
    [anon_sym_PIPE] = ACTIONS(7244),
    [anon_sym_SEMI_SEMI] = ACTIONS(7242),
    [anon_sym_PIPE_AMP] = ACTIONS(7242),
    [anon_sym_AMP_AMP] = ACTIONS(7242),
    [anon_sym_PIPE_PIPE] = ACTIONS(7242),
    [anon_sym_EQ_TILDE] = ACTIONS(7244),
    [anon_sym_EQ_EQ] = ACTIONS(7244),
    [anon_sym_LT] = ACTIONS(7244),
    [anon_sym_GT] = ACTIONS(7244),
    [anon_sym_GT_GT] = ACTIONS(7242),
    [anon_sym_AMP_GT] = ACTIONS(7244),
    [anon_sym_AMP_GT_GT] = ACTIONS(7242),
    [anon_sym_LT_AMP] = ACTIONS(7242),
    [anon_sym_GT_AMP] = ACTIONS(7242),
    [anon_sym_LT_LT] = ACTIONS(7244),
    [anon_sym_LT_LT_DASH] = ACTIONS(7242),
    [anon_sym_LT_LT_LT] = ACTIONS(7242),
    [anon_sym_DOLLAR] = ACTIONS(7244),
    [sym__special_character] = ACTIONS(7242),
    [anon_sym_DQUOTE] = ACTIONS(7242),
    [sym_raw_string] = ACTIONS(7242),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7242),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7242),
    [anon_sym_BQUOTE] = ACTIONS(7242),
    [anon_sym_LT_LPAREN] = ACTIONS(7242),
    [anon_sym_GT_LPAREN] = ACTIONS(7242),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7244),
    [anon_sym_LF] = ACTIONS(7242),
    [anon_sym_AMP] = ACTIONS(7244),
  },
  [3788] = {
    [sym_string] = STATE(2891),
    [sym__simple_heredoc_body] = ACTIONS(4071),
    [sym__heredoc_body_beginning] = ACTIONS(4071),
    [sym_file_descriptor] = ACTIONS(4071),
    [anon_sym_SEMI] = ACTIONS(4073),
    [anon_sym_done] = ACTIONS(4073),
    [anon_sym_PIPE] = ACTIONS(4073),
    [anon_sym_SEMI_SEMI] = ACTIONS(4071),
    [anon_sym_PIPE_AMP] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_PIPE_PIPE] = ACTIONS(4071),
    [anon_sym_LT] = ACTIONS(4073),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_GT_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT] = ACTIONS(4073),
    [anon_sym_AMP_GT_GT] = ACTIONS(4071),
    [anon_sym_LT_AMP] = ACTIONS(4071),
    [anon_sym_GT_AMP] = ACTIONS(4071),
    [anon_sym_LT_LT] = ACTIONS(4073),
    [anon_sym_LT_LT_DASH] = ACTIONS(4071),
    [anon_sym_LT_LT_LT] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(6359),
    [anon_sym_DOLLAR] = ACTIONS(6359),
    [anon_sym_DQUOTE] = ACTIONS(5002),
    [sym_raw_string] = ACTIONS(6361),
    [anon_sym_POUND] = ACTIONS(6359),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6363),
    [anon_sym_STAR] = ACTIONS(6365),
    [anon_sym_AT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6365),
    [anon_sym_0] = ACTIONS(6363),
    [anon_sym__] = ACTIONS(6363),
    [anon_sym_LF] = ACTIONS(4071),
    [anon_sym_AMP] = ACTIONS(4073),
  },
  [3789] = {
    [sym__simple_heredoc_body] = ACTIONS(4111),
    [sym__heredoc_body_beginning] = ACTIONS(4111),
    [sym_file_descriptor] = ACTIONS(4111),
    [sym__concat] = ACTIONS(4111),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_done] = ACTIONS(4111),
    [anon_sym_fi] = ACTIONS(4111),
    [anon_sym_elif] = ACTIONS(4111),
    [anon_sym_else] = ACTIONS(4111),
    [anon_sym_esac] = ACTIONS(4111),
    [anon_sym_PIPE] = ACTIONS(4113),
    [anon_sym_SEMI_SEMI] = ACTIONS(4111),
    [anon_sym_PIPE_AMP] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_LT] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4113),
    [anon_sym_GT_GT] = ACTIONS(4111),
    [anon_sym_AMP_GT] = ACTIONS(4113),
    [anon_sym_AMP_GT_GT] = ACTIONS(4111),
    [anon_sym_LT_AMP] = ACTIONS(4111),
    [anon_sym_GT_AMP] = ACTIONS(4111),
    [anon_sym_LT_LT] = ACTIONS(4113),
    [anon_sym_LT_LT_DASH] = ACTIONS(4111),
    [anon_sym_LT_LT_LT] = ACTIONS(4111),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4111),
    [anon_sym_AMP] = ACTIONS(4113),
  },
  [3790] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_done] = ACTIONS(4125),
    [anon_sym_fi] = ACTIONS(4125),
    [anon_sym_elif] = ACTIONS(4125),
    [anon_sym_else] = ACTIONS(4125),
    [anon_sym_esac] = ACTIONS(4125),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [3791] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(9187),
    [sym_comment] = ACTIONS(57),
  },
  [3792] = {
    [anon_sym_RBRACE] = ACTIONS(9187),
    [sym_comment] = ACTIONS(57),
  },
  [3793] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(9189),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [3794] = {
    [sym_concatenation] = STATE(4078),
    [sym_string] = STATE(4077),
    [sym_simple_expansion] = STATE(4077),
    [sym_string_expansion] = STATE(4077),
    [sym_expansion] = STATE(4077),
    [sym_command_substitution] = STATE(4077),
    [sym_process_substitution] = STATE(4077),
    [aux_sym__literal_repeat1] = STATE(4079),
    [anon_sym_RBRACE] = ACTIONS(9187),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(9191),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9191),
  },
  [3795] = {
    [sym__simple_heredoc_body] = ACTIONS(4161),
    [sym__heredoc_body_beginning] = ACTIONS(4161),
    [sym_file_descriptor] = ACTIONS(4161),
    [sym__concat] = ACTIONS(4161),
    [anon_sym_SEMI] = ACTIONS(4163),
    [anon_sym_done] = ACTIONS(4161),
    [anon_sym_fi] = ACTIONS(4161),
    [anon_sym_elif] = ACTIONS(4161),
    [anon_sym_else] = ACTIONS(4161),
    [anon_sym_esac] = ACTIONS(4161),
    [anon_sym_PIPE] = ACTIONS(4163),
    [anon_sym_SEMI_SEMI] = ACTIONS(4161),
    [anon_sym_PIPE_AMP] = ACTIONS(4161),
    [anon_sym_AMP_AMP] = ACTIONS(4161),
    [anon_sym_PIPE_PIPE] = ACTIONS(4161),
    [anon_sym_LT] = ACTIONS(4163),
    [anon_sym_GT] = ACTIONS(4163),
    [anon_sym_GT_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT] = ACTIONS(4163),
    [anon_sym_AMP_GT_GT] = ACTIONS(4161),
    [anon_sym_LT_AMP] = ACTIONS(4161),
    [anon_sym_GT_AMP] = ACTIONS(4161),
    [anon_sym_LT_LT] = ACTIONS(4163),
    [anon_sym_LT_LT_DASH] = ACTIONS(4161),
    [anon_sym_LT_LT_LT] = ACTIONS(4161),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4161),
    [anon_sym_AMP] = ACTIONS(4163),
  },
  [3796] = {
    [sym_concatenation] = STATE(4082),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4082),
    [sym_regex] = ACTIONS(9193),
    [anon_sym_RBRACE] = ACTIONS(9195),
    [anon_sym_EQ] = ACTIONS(9197),
    [anon_sym_DASH] = ACTIONS(9197),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9197),
    [anon_sym_COLON_QMARK] = ACTIONS(9197),
    [anon_sym_COLON_DASH] = ACTIONS(9197),
    [anon_sym_PERCENT] = ACTIONS(9197),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3797] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9195),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3798] = {
    [sym_concatenation] = STATE(4084),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4084),
    [sym_regex] = ACTIONS(9201),
    [anon_sym_RBRACE] = ACTIONS(9187),
    [anon_sym_EQ] = ACTIONS(9203),
    [anon_sym_DASH] = ACTIONS(9203),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9205),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9203),
    [anon_sym_COLON_QMARK] = ACTIONS(9203),
    [anon_sym_COLON_DASH] = ACTIONS(9203),
    [anon_sym_PERCENT] = ACTIONS(9203),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3799] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9187),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3800] = {
    [sym_concatenation] = STATE(4086),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4086),
    [anon_sym_RBRACE] = ACTIONS(9207),
    [anon_sym_EQ] = ACTIONS(9209),
    [anon_sym_DASH] = ACTIONS(9209),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9209),
    [anon_sym_COLON_QMARK] = ACTIONS(9209),
    [anon_sym_COLON_DASH] = ACTIONS(9209),
    [anon_sym_PERCENT] = ACTIONS(9209),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3801] = {
    [sym__simple_heredoc_body] = ACTIONS(4219),
    [sym__heredoc_body_beginning] = ACTIONS(4219),
    [sym_file_descriptor] = ACTIONS(4219),
    [sym__concat] = ACTIONS(4219),
    [anon_sym_SEMI] = ACTIONS(4221),
    [anon_sym_done] = ACTIONS(4219),
    [anon_sym_fi] = ACTIONS(4219),
    [anon_sym_elif] = ACTIONS(4219),
    [anon_sym_else] = ACTIONS(4219),
    [anon_sym_esac] = ACTIONS(4219),
    [anon_sym_PIPE] = ACTIONS(4221),
    [anon_sym_SEMI_SEMI] = ACTIONS(4219),
    [anon_sym_PIPE_AMP] = ACTIONS(4219),
    [anon_sym_AMP_AMP] = ACTIONS(4219),
    [anon_sym_PIPE_PIPE] = ACTIONS(4219),
    [anon_sym_LT] = ACTIONS(4221),
    [anon_sym_GT] = ACTIONS(4221),
    [anon_sym_GT_GT] = ACTIONS(4219),
    [anon_sym_AMP_GT] = ACTIONS(4221),
    [anon_sym_AMP_GT_GT] = ACTIONS(4219),
    [anon_sym_LT_AMP] = ACTIONS(4219),
    [anon_sym_GT_AMP] = ACTIONS(4219),
    [anon_sym_LT_LT] = ACTIONS(4221),
    [anon_sym_LT_LT_DASH] = ACTIONS(4219),
    [anon_sym_LT_LT_LT] = ACTIONS(4219),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4219),
    [anon_sym_AMP] = ACTIONS(4221),
  },
  [3802] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9207),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3803] = {
    [sym_concatenation] = STATE(4084),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4084),
    [anon_sym_RBRACE] = ACTIONS(9187),
    [anon_sym_EQ] = ACTIONS(9203),
    [anon_sym_DASH] = ACTIONS(9203),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9205),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9203),
    [anon_sym_COLON_QMARK] = ACTIONS(9203),
    [anon_sym_COLON_DASH] = ACTIONS(9203),
    [anon_sym_PERCENT] = ACTIONS(9203),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3804] = {
    [sym_string] = STATE(2913),
    [sym__simple_heredoc_body] = ACTIONS(4071),
    [sym__heredoc_body_beginning] = ACTIONS(4071),
    [sym_file_descriptor] = ACTIONS(4071),
    [sym_variable_name] = ACTIONS(4071),
    [anon_sym_SEMI] = ACTIONS(4073),
    [anon_sym_fi] = ACTIONS(4073),
    [anon_sym_elif] = ACTIONS(4073),
    [anon_sym_else] = ACTIONS(4073),
    [anon_sym_PIPE] = ACTIONS(4073),
    [anon_sym_SEMI_SEMI] = ACTIONS(4071),
    [anon_sym_PIPE_AMP] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_PIPE_PIPE] = ACTIONS(4071),
    [anon_sym_LT] = ACTIONS(4073),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_GT_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT] = ACTIONS(4073),
    [anon_sym_AMP_GT_GT] = ACTIONS(4071),
    [anon_sym_LT_AMP] = ACTIONS(4071),
    [anon_sym_GT_AMP] = ACTIONS(4071),
    [anon_sym_LT_LT] = ACTIONS(4073),
    [anon_sym_LT_LT_DASH] = ACTIONS(4071),
    [anon_sym_LT_LT_LT] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(9213),
    [anon_sym_DOLLAR] = ACTIONS(9213),
    [sym__special_character] = ACTIONS(4071),
    [anon_sym_DQUOTE] = ACTIONS(5041),
    [sym_raw_string] = ACTIONS(6439),
    [anon_sym_POUND] = ACTIONS(6437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4071),
    [anon_sym_BQUOTE] = ACTIONS(4071),
    [anon_sym_LT_LPAREN] = ACTIONS(4071),
    [anon_sym_GT_LPAREN] = ACTIONS(4071),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6441),
    [anon_sym_STAR] = ACTIONS(6441),
    [anon_sym_AT] = ACTIONS(6441),
    [anon_sym_QMARK] = ACTIONS(6441),
    [anon_sym_0] = ACTIONS(6441),
    [anon_sym__] = ACTIONS(6441),
    [sym_word] = ACTIONS(4073),
    [anon_sym_LF] = ACTIONS(4071),
    [anon_sym_AMP] = ACTIONS(4073),
  },
  [3805] = {
    [sym__simple_heredoc_body] = ACTIONS(4111),
    [sym__heredoc_body_beginning] = ACTIONS(4111),
    [sym_file_descriptor] = ACTIONS(4111),
    [sym__concat] = ACTIONS(4111),
    [sym_variable_name] = ACTIONS(4111),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_fi] = ACTIONS(4113),
    [anon_sym_elif] = ACTIONS(4113),
    [anon_sym_else] = ACTIONS(4113),
    [anon_sym_PIPE] = ACTIONS(4113),
    [anon_sym_SEMI_SEMI] = ACTIONS(4111),
    [anon_sym_PIPE_AMP] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_LT] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4113),
    [anon_sym_GT_GT] = ACTIONS(4111),
    [anon_sym_AMP_GT] = ACTIONS(4113),
    [anon_sym_AMP_GT_GT] = ACTIONS(4111),
    [anon_sym_LT_AMP] = ACTIONS(4111),
    [anon_sym_GT_AMP] = ACTIONS(4111),
    [anon_sym_LT_LT] = ACTIONS(4113),
    [anon_sym_LT_LT_DASH] = ACTIONS(4111),
    [anon_sym_LT_LT_LT] = ACTIONS(4111),
    [anon_sym_DOLLAR] = ACTIONS(4113),
    [sym__special_character] = ACTIONS(4111),
    [anon_sym_DQUOTE] = ACTIONS(4111),
    [sym_raw_string] = ACTIONS(4111),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4111),
    [anon_sym_BQUOTE] = ACTIONS(4111),
    [anon_sym_LT_LPAREN] = ACTIONS(4111),
    [anon_sym_GT_LPAREN] = ACTIONS(4111),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4113),
    [anon_sym_LF] = ACTIONS(4111),
    [anon_sym_AMP] = ACTIONS(4113),
  },
  [3806] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [sym_variable_name] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_fi] = ACTIONS(4127),
    [anon_sym_elif] = ACTIONS(4127),
    [anon_sym_else] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym__special_character] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [3807] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(9215),
    [sym_comment] = ACTIONS(57),
  },
  [3808] = {
    [anon_sym_RBRACE] = ACTIONS(9215),
    [sym_comment] = ACTIONS(57),
  },
  [3809] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(9217),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [3810] = {
    [sym_concatenation] = STATE(4090),
    [sym_string] = STATE(4089),
    [sym_simple_expansion] = STATE(4089),
    [sym_string_expansion] = STATE(4089),
    [sym_expansion] = STATE(4089),
    [sym_command_substitution] = STATE(4089),
    [sym_process_substitution] = STATE(4089),
    [aux_sym__literal_repeat1] = STATE(4091),
    [anon_sym_RBRACE] = ACTIONS(9215),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(9219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9219),
  },
  [3811] = {
    [sym__simple_heredoc_body] = ACTIONS(4161),
    [sym__heredoc_body_beginning] = ACTIONS(4161),
    [sym_file_descriptor] = ACTIONS(4161),
    [sym__concat] = ACTIONS(4161),
    [sym_variable_name] = ACTIONS(4161),
    [anon_sym_SEMI] = ACTIONS(4163),
    [anon_sym_fi] = ACTIONS(4163),
    [anon_sym_elif] = ACTIONS(4163),
    [anon_sym_else] = ACTIONS(4163),
    [anon_sym_PIPE] = ACTIONS(4163),
    [anon_sym_SEMI_SEMI] = ACTIONS(4161),
    [anon_sym_PIPE_AMP] = ACTIONS(4161),
    [anon_sym_AMP_AMP] = ACTIONS(4161),
    [anon_sym_PIPE_PIPE] = ACTIONS(4161),
    [anon_sym_LT] = ACTIONS(4163),
    [anon_sym_GT] = ACTIONS(4163),
    [anon_sym_GT_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT] = ACTIONS(4163),
    [anon_sym_AMP_GT_GT] = ACTIONS(4161),
    [anon_sym_LT_AMP] = ACTIONS(4161),
    [anon_sym_GT_AMP] = ACTIONS(4161),
    [anon_sym_LT_LT] = ACTIONS(4163),
    [anon_sym_LT_LT_DASH] = ACTIONS(4161),
    [anon_sym_LT_LT_LT] = ACTIONS(4161),
    [anon_sym_DOLLAR] = ACTIONS(4163),
    [sym__special_character] = ACTIONS(4161),
    [anon_sym_DQUOTE] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4161),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4161),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4161),
    [anon_sym_BQUOTE] = ACTIONS(4161),
    [anon_sym_LT_LPAREN] = ACTIONS(4161),
    [anon_sym_GT_LPAREN] = ACTIONS(4161),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4163),
    [anon_sym_LF] = ACTIONS(4161),
    [anon_sym_AMP] = ACTIONS(4163),
  },
  [3812] = {
    [sym_concatenation] = STATE(4094),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4094),
    [sym_regex] = ACTIONS(9221),
    [anon_sym_RBRACE] = ACTIONS(9223),
    [anon_sym_EQ] = ACTIONS(9225),
    [anon_sym_DASH] = ACTIONS(9225),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9227),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9225),
    [anon_sym_COLON_QMARK] = ACTIONS(9225),
    [anon_sym_COLON_DASH] = ACTIONS(9225),
    [anon_sym_PERCENT] = ACTIONS(9225),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3813] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9223),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3814] = {
    [sym_concatenation] = STATE(4096),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4096),
    [sym_regex] = ACTIONS(9229),
    [anon_sym_RBRACE] = ACTIONS(9215),
    [anon_sym_EQ] = ACTIONS(9231),
    [anon_sym_DASH] = ACTIONS(9231),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9233),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9231),
    [anon_sym_COLON_QMARK] = ACTIONS(9231),
    [anon_sym_COLON_DASH] = ACTIONS(9231),
    [anon_sym_PERCENT] = ACTIONS(9231),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3815] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9215),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3816] = {
    [sym_concatenation] = STATE(4098),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4098),
    [anon_sym_RBRACE] = ACTIONS(9235),
    [anon_sym_EQ] = ACTIONS(9237),
    [anon_sym_DASH] = ACTIONS(9237),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9239),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9237),
    [anon_sym_COLON_QMARK] = ACTIONS(9237),
    [anon_sym_COLON_DASH] = ACTIONS(9237),
    [anon_sym_PERCENT] = ACTIONS(9237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3817] = {
    [sym__simple_heredoc_body] = ACTIONS(4219),
    [sym__heredoc_body_beginning] = ACTIONS(4219),
    [sym_file_descriptor] = ACTIONS(4219),
    [sym__concat] = ACTIONS(4219),
    [sym_variable_name] = ACTIONS(4219),
    [anon_sym_SEMI] = ACTIONS(4221),
    [anon_sym_fi] = ACTIONS(4221),
    [anon_sym_elif] = ACTIONS(4221),
    [anon_sym_else] = ACTIONS(4221),
    [anon_sym_PIPE] = ACTIONS(4221),
    [anon_sym_SEMI_SEMI] = ACTIONS(4219),
    [anon_sym_PIPE_AMP] = ACTIONS(4219),
    [anon_sym_AMP_AMP] = ACTIONS(4219),
    [anon_sym_PIPE_PIPE] = ACTIONS(4219),
    [anon_sym_LT] = ACTIONS(4221),
    [anon_sym_GT] = ACTIONS(4221),
    [anon_sym_GT_GT] = ACTIONS(4219),
    [anon_sym_AMP_GT] = ACTIONS(4221),
    [anon_sym_AMP_GT_GT] = ACTIONS(4219),
    [anon_sym_LT_AMP] = ACTIONS(4219),
    [anon_sym_GT_AMP] = ACTIONS(4219),
    [anon_sym_LT_LT] = ACTIONS(4221),
    [anon_sym_LT_LT_DASH] = ACTIONS(4219),
    [anon_sym_LT_LT_LT] = ACTIONS(4219),
    [anon_sym_DOLLAR] = ACTIONS(4221),
    [sym__special_character] = ACTIONS(4219),
    [anon_sym_DQUOTE] = ACTIONS(4219),
    [sym_raw_string] = ACTIONS(4219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4219),
    [anon_sym_BQUOTE] = ACTIONS(4219),
    [anon_sym_LT_LPAREN] = ACTIONS(4219),
    [anon_sym_GT_LPAREN] = ACTIONS(4219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4221),
    [anon_sym_LF] = ACTIONS(4219),
    [anon_sym_AMP] = ACTIONS(4221),
  },
  [3818] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9235),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3819] = {
    [sym_concatenation] = STATE(4096),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4096),
    [anon_sym_RBRACE] = ACTIONS(9215),
    [anon_sym_EQ] = ACTIONS(9231),
    [anon_sym_DASH] = ACTIONS(9231),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9233),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9231),
    [anon_sym_COLON_QMARK] = ACTIONS(9231),
    [anon_sym_COLON_DASH] = ACTIONS(9231),
    [anon_sym_PERCENT] = ACTIONS(9231),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3820] = {
    [sym__simple_heredoc_body] = ACTIONS(4449),
    [sym__heredoc_body_beginning] = ACTIONS(4449),
    [sym_file_descriptor] = ACTIONS(4449),
    [sym_variable_name] = ACTIONS(4449),
    [anon_sym_SEMI] = ACTIONS(4451),
    [anon_sym_fi] = ACTIONS(4451),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_SEMI_SEMI] = ACTIONS(4449),
    [anon_sym_PIPE_AMP] = ACTIONS(4449),
    [anon_sym_AMP_AMP] = ACTIONS(4449),
    [anon_sym_PIPE_PIPE] = ACTIONS(4449),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_GT_GT] = ACTIONS(4449),
    [anon_sym_AMP_GT] = ACTIONS(4451),
    [anon_sym_AMP_GT_GT] = ACTIONS(4449),
    [anon_sym_LT_AMP] = ACTIONS(4449),
    [anon_sym_GT_AMP] = ACTIONS(4449),
    [anon_sym_LT_LT] = ACTIONS(4451),
    [anon_sym_LT_LT_DASH] = ACTIONS(4449),
    [anon_sym_LT_LT_LT] = ACTIONS(4449),
    [anon_sym_DOLLAR] = ACTIONS(4451),
    [sym__special_character] = ACTIONS(4449),
    [anon_sym_DQUOTE] = ACTIONS(4449),
    [sym_raw_string] = ACTIONS(4449),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4449),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4449),
    [anon_sym_BQUOTE] = ACTIONS(4449),
    [anon_sym_LT_LPAREN] = ACTIONS(4449),
    [anon_sym_GT_LPAREN] = ACTIONS(4449),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4451),
    [anon_sym_LF] = ACTIONS(4449),
    [anon_sym_AMP] = ACTIONS(4451),
  },
  [3821] = {
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(2362),
    [sym_variable_name] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_fi] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [3822] = {
    [sym_string] = STATE(3821),
    [sym_simple_expansion] = STATE(3821),
    [sym_string_expansion] = STATE(3821),
    [sym_expansion] = STATE(3821),
    [sym_command_substitution] = STATE(3821),
    [sym_process_substitution] = STATE(3821),
    [anon_sym_DOLLAR] = ACTIONS(9241),
    [sym__special_character] = ACTIONS(8649),
    [anon_sym_DQUOTE] = ACTIONS(6473),
    [sym_raw_string] = ACTIONS(8649),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6477),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6479),
    [anon_sym_BQUOTE] = ACTIONS(6481),
    [anon_sym_LT_LPAREN] = ACTIONS(6483),
    [anon_sym_GT_LPAREN] = ACTIONS(6483),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8649),
  },
  [3823] = {
    [aux_sym_concatenation_repeat1] = STATE(3823),
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(9243),
    [sym_variable_name] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_fi] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [3824] = {
    [sym__simple_heredoc_body] = ACTIONS(2371),
    [sym__heredoc_body_beginning] = ACTIONS(2371),
    [sym_file_descriptor] = ACTIONS(2371),
    [sym__concat] = ACTIONS(2371),
    [sym_variable_name] = ACTIONS(2371),
    [anon_sym_SEMI] = ACTIONS(2373),
    [anon_sym_fi] = ACTIONS(2373),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_SEMI_SEMI] = ACTIONS(2371),
    [anon_sym_PIPE_AMP] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_GT_GT] = ACTIONS(2371),
    [anon_sym_AMP_GT] = ACTIONS(2373),
    [anon_sym_AMP_GT_GT] = ACTIONS(2371),
    [anon_sym_LT_AMP] = ACTIONS(2371),
    [anon_sym_GT_AMP] = ACTIONS(2371),
    [anon_sym_LT_LT] = ACTIONS(2373),
    [anon_sym_LT_LT_DASH] = ACTIONS(2371),
    [anon_sym_LT_LT_LT] = ACTIONS(2371),
    [anon_sym_DOLLAR] = ACTIONS(2373),
    [sym__special_character] = ACTIONS(2371),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [sym_raw_string] = ACTIONS(2371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2371),
    [anon_sym_BQUOTE] = ACTIONS(2371),
    [anon_sym_LT_LPAREN] = ACTIONS(2371),
    [anon_sym_GT_LPAREN] = ACTIONS(2371),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2373),
    [anon_sym_LF] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
  },
  [3825] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(9246),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [3826] = {
    [sym_concatenation] = STATE(4103),
    [sym_string] = STATE(4102),
    [sym_simple_expansion] = STATE(4102),
    [sym_string_expansion] = STATE(4102),
    [sym_expansion] = STATE(4102),
    [sym_command_substitution] = STATE(4102),
    [sym_process_substitution] = STATE(4102),
    [aux_sym__literal_repeat1] = STATE(4104),
    [anon_sym_RBRACE] = ACTIONS(9248),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(9250),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9250),
  },
  [3827] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(9252),
    [sym_comment] = ACTIONS(57),
  },
  [3828] = {
    [sym_concatenation] = STATE(4108),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4108),
    [anon_sym_RBRACE] = ACTIONS(9254),
    [anon_sym_EQ] = ACTIONS(9256),
    [anon_sym_DASH] = ACTIONS(9256),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(9260),
    [anon_sym_COLON] = ACTIONS(9256),
    [anon_sym_COLON_QMARK] = ACTIONS(9256),
    [anon_sym_COLON_DASH] = ACTIONS(9256),
    [anon_sym_PERCENT] = ACTIONS(9256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3829] = {
    [sym_concatenation] = STATE(4110),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4110),
    [anon_sym_RBRACE] = ACTIONS(9248),
    [anon_sym_EQ] = ACTIONS(9262),
    [anon_sym_DASH] = ACTIONS(9262),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9264),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(9266),
    [anon_sym_COLON] = ACTIONS(9262),
    [anon_sym_COLON_QMARK] = ACTIONS(9262),
    [anon_sym_COLON_DASH] = ACTIONS(9262),
    [anon_sym_PERCENT] = ACTIONS(9262),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3830] = {
    [sym__simple_heredoc_body] = ACTIONS(2462),
    [sym__heredoc_body_beginning] = ACTIONS(2462),
    [sym_file_descriptor] = ACTIONS(2462),
    [sym__concat] = ACTIONS(2462),
    [sym_variable_name] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_fi] = ACTIONS(2464),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_SEMI_SEMI] = ACTIONS(2462),
    [anon_sym_PIPE_AMP] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_GT_GT] = ACTIONS(2462),
    [anon_sym_AMP_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT_GT] = ACTIONS(2462),
    [anon_sym_LT_AMP] = ACTIONS(2462),
    [anon_sym_GT_AMP] = ACTIONS(2462),
    [anon_sym_LT_LT] = ACTIONS(2464),
    [anon_sym_LT_LT_DASH] = ACTIONS(2462),
    [anon_sym_LT_LT_LT] = ACTIONS(2462),
    [anon_sym_DOLLAR] = ACTIONS(2464),
    [sym__special_character] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [sym_raw_string] = ACTIONS(2462),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2462),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2462),
    [anon_sym_BQUOTE] = ACTIONS(2462),
    [anon_sym_LT_LPAREN] = ACTIONS(2462),
    [anon_sym_GT_LPAREN] = ACTIONS(2462),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2464),
    [anon_sym_LF] = ACTIONS(2462),
    [anon_sym_AMP] = ACTIONS(2464),
  },
  [3831] = {
    [sym_concatenation] = STATE(4113),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4113),
    [sym_regex] = ACTIONS(9268),
    [anon_sym_RBRACE] = ACTIONS(9270),
    [anon_sym_EQ] = ACTIONS(9272),
    [anon_sym_DASH] = ACTIONS(9272),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9274),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9272),
    [anon_sym_COLON_QMARK] = ACTIONS(9272),
    [anon_sym_COLON_DASH] = ACTIONS(9272),
    [anon_sym_PERCENT] = ACTIONS(9272),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3832] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9270),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3833] = {
    [sym__simple_heredoc_body] = ACTIONS(2512),
    [sym__heredoc_body_beginning] = ACTIONS(2512),
    [sym_file_descriptor] = ACTIONS(2512),
    [sym__concat] = ACTIONS(2512),
    [sym_variable_name] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2514),
    [anon_sym_fi] = ACTIONS(2514),
    [anon_sym_PIPE] = ACTIONS(2514),
    [anon_sym_SEMI_SEMI] = ACTIONS(2512),
    [anon_sym_PIPE_AMP] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE_PIPE] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2514),
    [anon_sym_GT] = ACTIONS(2514),
    [anon_sym_GT_GT] = ACTIONS(2512),
    [anon_sym_AMP_GT] = ACTIONS(2514),
    [anon_sym_AMP_GT_GT] = ACTIONS(2512),
    [anon_sym_LT_AMP] = ACTIONS(2512),
    [anon_sym_GT_AMP] = ACTIONS(2512),
    [anon_sym_LT_LT] = ACTIONS(2514),
    [anon_sym_LT_LT_DASH] = ACTIONS(2512),
    [anon_sym_LT_LT_LT] = ACTIONS(2512),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [sym__special_character] = ACTIONS(2512),
    [anon_sym_DQUOTE] = ACTIONS(2512),
    [sym_raw_string] = ACTIONS(2512),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2512),
    [anon_sym_BQUOTE] = ACTIONS(2512),
    [anon_sym_LT_LPAREN] = ACTIONS(2512),
    [anon_sym_GT_LPAREN] = ACTIONS(2512),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2514),
    [anon_sym_LF] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2514),
  },
  [3834] = {
    [sym_concatenation] = STATE(4110),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4110),
    [sym_regex] = ACTIONS(9276),
    [anon_sym_RBRACE] = ACTIONS(9248),
    [anon_sym_EQ] = ACTIONS(9262),
    [anon_sym_DASH] = ACTIONS(9262),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9264),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9262),
    [anon_sym_COLON_QMARK] = ACTIONS(9262),
    [anon_sym_COLON_DASH] = ACTIONS(9262),
    [anon_sym_PERCENT] = ACTIONS(9262),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3835] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9248),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3836] = {
    [sym__simple_heredoc_body] = ACTIONS(2520),
    [sym__heredoc_body_beginning] = ACTIONS(2520),
    [sym_file_descriptor] = ACTIONS(2520),
    [sym__concat] = ACTIONS(2520),
    [sym_variable_name] = ACTIONS(2520),
    [anon_sym_SEMI] = ACTIONS(2522),
    [anon_sym_fi] = ACTIONS(2522),
    [anon_sym_PIPE] = ACTIONS(2522),
    [anon_sym_SEMI_SEMI] = ACTIONS(2520),
    [anon_sym_PIPE_AMP] = ACTIONS(2520),
    [anon_sym_AMP_AMP] = ACTIONS(2520),
    [anon_sym_PIPE_PIPE] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(2522),
    [anon_sym_GT] = ACTIONS(2522),
    [anon_sym_GT_GT] = ACTIONS(2520),
    [anon_sym_AMP_GT] = ACTIONS(2522),
    [anon_sym_AMP_GT_GT] = ACTIONS(2520),
    [anon_sym_LT_AMP] = ACTIONS(2520),
    [anon_sym_GT_AMP] = ACTIONS(2520),
    [anon_sym_LT_LT] = ACTIONS(2522),
    [anon_sym_LT_LT_DASH] = ACTIONS(2520),
    [anon_sym_LT_LT_LT] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(2522),
    [sym__special_character] = ACTIONS(2520),
    [anon_sym_DQUOTE] = ACTIONS(2520),
    [sym_raw_string] = ACTIONS(2520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2520),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2520),
    [anon_sym_BQUOTE] = ACTIONS(2520),
    [anon_sym_LT_LPAREN] = ACTIONS(2520),
    [anon_sym_GT_LPAREN] = ACTIONS(2520),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2522),
    [anon_sym_LF] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2522),
  },
  [3837] = {
    [sym__simple_heredoc_body] = ACTIONS(2554),
    [sym__heredoc_body_beginning] = ACTIONS(2554),
    [sym_file_descriptor] = ACTIONS(2554),
    [sym__concat] = ACTIONS(2554),
    [sym_variable_name] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(2556),
    [anon_sym_fi] = ACTIONS(2556),
    [anon_sym_PIPE] = ACTIONS(2556),
    [anon_sym_SEMI_SEMI] = ACTIONS(2554),
    [anon_sym_PIPE_AMP] = ACTIONS(2554),
    [anon_sym_AMP_AMP] = ACTIONS(2554),
    [anon_sym_PIPE_PIPE] = ACTIONS(2554),
    [anon_sym_LT] = ACTIONS(2556),
    [anon_sym_GT] = ACTIONS(2556),
    [anon_sym_GT_GT] = ACTIONS(2554),
    [anon_sym_AMP_GT] = ACTIONS(2556),
    [anon_sym_AMP_GT_GT] = ACTIONS(2554),
    [anon_sym_LT_AMP] = ACTIONS(2554),
    [anon_sym_GT_AMP] = ACTIONS(2554),
    [anon_sym_LT_LT] = ACTIONS(2556),
    [anon_sym_LT_LT_DASH] = ACTIONS(2554),
    [anon_sym_LT_LT_LT] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2556),
    [sym__special_character] = ACTIONS(2554),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2554),
    [anon_sym_BQUOTE] = ACTIONS(2554),
    [anon_sym_LT_LPAREN] = ACTIONS(2554),
    [anon_sym_GT_LPAREN] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2556),
    [anon_sym_LF] = ACTIONS(2554),
    [anon_sym_AMP] = ACTIONS(2556),
  },
  [3838] = {
    [sym__simple_heredoc_body] = ACTIONS(2719),
    [sym__heredoc_body_beginning] = ACTIONS(2719),
    [sym_file_descriptor] = ACTIONS(2719),
    [sym_variable_name] = ACTIONS(2719),
    [anon_sym_SEMI] = ACTIONS(2721),
    [anon_sym_fi] = ACTIONS(2721),
    [anon_sym_PIPE] = ACTIONS(2721),
    [anon_sym_SEMI_SEMI] = ACTIONS(2719),
    [anon_sym_PIPE_AMP] = ACTIONS(2719),
    [anon_sym_AMP_AMP] = ACTIONS(2719),
    [anon_sym_PIPE_PIPE] = ACTIONS(2719),
    [anon_sym_LT] = ACTIONS(2721),
    [anon_sym_GT] = ACTIONS(2721),
    [anon_sym_GT_GT] = ACTIONS(2719),
    [anon_sym_AMP_GT] = ACTIONS(2721),
    [anon_sym_AMP_GT_GT] = ACTIONS(2719),
    [anon_sym_LT_AMP] = ACTIONS(2719),
    [anon_sym_GT_AMP] = ACTIONS(2719),
    [anon_sym_LT_LT] = ACTIONS(2721),
    [anon_sym_LT_LT_DASH] = ACTIONS(2719),
    [anon_sym_LT_LT_LT] = ACTIONS(2719),
    [anon_sym_DOLLAR] = ACTIONS(2721),
    [sym__special_character] = ACTIONS(2719),
    [anon_sym_DQUOTE] = ACTIONS(2719),
    [sym_raw_string] = ACTIONS(2719),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2719),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2719),
    [anon_sym_BQUOTE] = ACTIONS(2719),
    [anon_sym_LT_LPAREN] = ACTIONS(2719),
    [anon_sym_GT_LPAREN] = ACTIONS(2719),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2721),
    [sym_word] = ACTIONS(2721),
    [anon_sym_LF] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2721),
  },
  [3839] = {
    [sym_concatenation] = STATE(1368),
    [sym_string] = STATE(730),
    [sym_simple_expansion] = STATE(730),
    [sym_string_expansion] = STATE(730),
    [sym_expansion] = STATE(730),
    [sym_command_substitution] = STATE(730),
    [sym_process_substitution] = STATE(730),
    [aux_sym_for_statement_repeat1] = STATE(1368),
    [aux_sym__literal_repeat1] = STATE(736),
    [anon_sym_RPAREN] = ACTIONS(9278),
    [anon_sym_DOLLAR] = ACTIONS(1406),
    [sym__special_character] = ACTIONS(1408),
    [anon_sym_DQUOTE] = ACTIONS(1410),
    [sym_raw_string] = ACTIONS(1412),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1414),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1416),
    [anon_sym_BQUOTE] = ACTIONS(1418),
    [anon_sym_LT_LPAREN] = ACTIONS(1420),
    [anon_sym_GT_LPAREN] = ACTIONS(1420),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1412),
  },
  [3840] = {
    [sym_string] = STATE(2944),
    [sym__simple_heredoc_body] = ACTIONS(4071),
    [sym__heredoc_body_beginning] = ACTIONS(4071),
    [sym_file_descriptor] = ACTIONS(4071),
    [sym_variable_name] = ACTIONS(4071),
    [anon_sym_SEMI] = ACTIONS(4073),
    [anon_sym_fi] = ACTIONS(4073),
    [anon_sym_PIPE] = ACTIONS(4073),
    [anon_sym_SEMI_SEMI] = ACTIONS(4071),
    [anon_sym_PIPE_AMP] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_PIPE_PIPE] = ACTIONS(4071),
    [anon_sym_LT] = ACTIONS(4073),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_GT_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT] = ACTIONS(4073),
    [anon_sym_AMP_GT_GT] = ACTIONS(4071),
    [anon_sym_LT_AMP] = ACTIONS(4071),
    [anon_sym_GT_AMP] = ACTIONS(4071),
    [anon_sym_LT_LT] = ACTIONS(4073),
    [anon_sym_LT_LT_DASH] = ACTIONS(4071),
    [anon_sym_LT_LT_LT] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(9280),
    [anon_sym_DOLLAR] = ACTIONS(9280),
    [sym__special_character] = ACTIONS(4071),
    [anon_sym_DQUOTE] = ACTIONS(5063),
    [sym_raw_string] = ACTIONS(6489),
    [anon_sym_POUND] = ACTIONS(6487),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4071),
    [anon_sym_BQUOTE] = ACTIONS(4071),
    [anon_sym_LT_LPAREN] = ACTIONS(4071),
    [anon_sym_GT_LPAREN] = ACTIONS(4071),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6491),
    [anon_sym_STAR] = ACTIONS(6491),
    [anon_sym_AT] = ACTIONS(6491),
    [anon_sym_QMARK] = ACTIONS(6491),
    [anon_sym_0] = ACTIONS(6491),
    [anon_sym__] = ACTIONS(6491),
    [sym_word] = ACTIONS(4073),
    [anon_sym_LF] = ACTIONS(4071),
    [anon_sym_AMP] = ACTIONS(4073),
  },
  [3841] = {
    [sym__simple_heredoc_body] = ACTIONS(4111),
    [sym__heredoc_body_beginning] = ACTIONS(4111),
    [sym_file_descriptor] = ACTIONS(4111),
    [sym__concat] = ACTIONS(4111),
    [sym_variable_name] = ACTIONS(4111),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_fi] = ACTIONS(4113),
    [anon_sym_PIPE] = ACTIONS(4113),
    [anon_sym_SEMI_SEMI] = ACTIONS(4111),
    [anon_sym_PIPE_AMP] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_LT] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4113),
    [anon_sym_GT_GT] = ACTIONS(4111),
    [anon_sym_AMP_GT] = ACTIONS(4113),
    [anon_sym_AMP_GT_GT] = ACTIONS(4111),
    [anon_sym_LT_AMP] = ACTIONS(4111),
    [anon_sym_GT_AMP] = ACTIONS(4111),
    [anon_sym_LT_LT] = ACTIONS(4113),
    [anon_sym_LT_LT_DASH] = ACTIONS(4111),
    [anon_sym_LT_LT_LT] = ACTIONS(4111),
    [anon_sym_DOLLAR] = ACTIONS(4113),
    [sym__special_character] = ACTIONS(4111),
    [anon_sym_DQUOTE] = ACTIONS(4111),
    [sym_raw_string] = ACTIONS(4111),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4111),
    [anon_sym_BQUOTE] = ACTIONS(4111),
    [anon_sym_LT_LPAREN] = ACTIONS(4111),
    [anon_sym_GT_LPAREN] = ACTIONS(4111),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4113),
    [sym_word] = ACTIONS(4113),
    [anon_sym_LF] = ACTIONS(4111),
    [anon_sym_AMP] = ACTIONS(4113),
  },
  [3842] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [sym_variable_name] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_fi] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym__special_character] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4127),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [3843] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(9282),
    [sym_comment] = ACTIONS(57),
  },
  [3844] = {
    [anon_sym_RBRACE] = ACTIONS(9282),
    [sym_comment] = ACTIONS(57),
  },
  [3845] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(9284),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [3846] = {
    [sym_concatenation] = STATE(4119),
    [sym_string] = STATE(4118),
    [sym_simple_expansion] = STATE(4118),
    [sym_string_expansion] = STATE(4118),
    [sym_expansion] = STATE(4118),
    [sym_command_substitution] = STATE(4118),
    [sym_process_substitution] = STATE(4118),
    [aux_sym__literal_repeat1] = STATE(4120),
    [anon_sym_RBRACE] = ACTIONS(9282),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(9286),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9286),
  },
  [3847] = {
    [sym__simple_heredoc_body] = ACTIONS(4161),
    [sym__heredoc_body_beginning] = ACTIONS(4161),
    [sym_file_descriptor] = ACTIONS(4161),
    [sym__concat] = ACTIONS(4161),
    [sym_variable_name] = ACTIONS(4161),
    [anon_sym_SEMI] = ACTIONS(4163),
    [anon_sym_fi] = ACTIONS(4163),
    [anon_sym_PIPE] = ACTIONS(4163),
    [anon_sym_SEMI_SEMI] = ACTIONS(4161),
    [anon_sym_PIPE_AMP] = ACTIONS(4161),
    [anon_sym_AMP_AMP] = ACTIONS(4161),
    [anon_sym_PIPE_PIPE] = ACTIONS(4161),
    [anon_sym_LT] = ACTIONS(4163),
    [anon_sym_GT] = ACTIONS(4163),
    [anon_sym_GT_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT] = ACTIONS(4163),
    [anon_sym_AMP_GT_GT] = ACTIONS(4161),
    [anon_sym_LT_AMP] = ACTIONS(4161),
    [anon_sym_GT_AMP] = ACTIONS(4161),
    [anon_sym_LT_LT] = ACTIONS(4163),
    [anon_sym_LT_LT_DASH] = ACTIONS(4161),
    [anon_sym_LT_LT_LT] = ACTIONS(4161),
    [anon_sym_DOLLAR] = ACTIONS(4163),
    [sym__special_character] = ACTIONS(4161),
    [anon_sym_DQUOTE] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4161),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4161),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4161),
    [anon_sym_BQUOTE] = ACTIONS(4161),
    [anon_sym_LT_LPAREN] = ACTIONS(4161),
    [anon_sym_GT_LPAREN] = ACTIONS(4161),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4163),
    [sym_word] = ACTIONS(4163),
    [anon_sym_LF] = ACTIONS(4161),
    [anon_sym_AMP] = ACTIONS(4163),
  },
  [3848] = {
    [sym_concatenation] = STATE(4123),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4123),
    [sym_regex] = ACTIONS(9288),
    [anon_sym_RBRACE] = ACTIONS(9290),
    [anon_sym_EQ] = ACTIONS(9292),
    [anon_sym_DASH] = ACTIONS(9292),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9292),
    [anon_sym_COLON_QMARK] = ACTIONS(9292),
    [anon_sym_COLON_DASH] = ACTIONS(9292),
    [anon_sym_PERCENT] = ACTIONS(9292),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3849] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9290),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3850] = {
    [sym_concatenation] = STATE(4125),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4125),
    [sym_regex] = ACTIONS(9296),
    [anon_sym_RBRACE] = ACTIONS(9282),
    [anon_sym_EQ] = ACTIONS(9298),
    [anon_sym_DASH] = ACTIONS(9298),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9300),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9298),
    [anon_sym_COLON_QMARK] = ACTIONS(9298),
    [anon_sym_COLON_DASH] = ACTIONS(9298),
    [anon_sym_PERCENT] = ACTIONS(9298),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3851] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9282),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3852] = {
    [sym_concatenation] = STATE(4127),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4127),
    [anon_sym_RBRACE] = ACTIONS(9302),
    [anon_sym_EQ] = ACTIONS(9304),
    [anon_sym_DASH] = ACTIONS(9304),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9306),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9304),
    [anon_sym_COLON_QMARK] = ACTIONS(9304),
    [anon_sym_COLON_DASH] = ACTIONS(9304),
    [anon_sym_PERCENT] = ACTIONS(9304),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3853] = {
    [sym__simple_heredoc_body] = ACTIONS(4219),
    [sym__heredoc_body_beginning] = ACTIONS(4219),
    [sym_file_descriptor] = ACTIONS(4219),
    [sym__concat] = ACTIONS(4219),
    [sym_variable_name] = ACTIONS(4219),
    [anon_sym_SEMI] = ACTIONS(4221),
    [anon_sym_fi] = ACTIONS(4221),
    [anon_sym_PIPE] = ACTIONS(4221),
    [anon_sym_SEMI_SEMI] = ACTIONS(4219),
    [anon_sym_PIPE_AMP] = ACTIONS(4219),
    [anon_sym_AMP_AMP] = ACTIONS(4219),
    [anon_sym_PIPE_PIPE] = ACTIONS(4219),
    [anon_sym_LT] = ACTIONS(4221),
    [anon_sym_GT] = ACTIONS(4221),
    [anon_sym_GT_GT] = ACTIONS(4219),
    [anon_sym_AMP_GT] = ACTIONS(4221),
    [anon_sym_AMP_GT_GT] = ACTIONS(4219),
    [anon_sym_LT_AMP] = ACTIONS(4219),
    [anon_sym_GT_AMP] = ACTIONS(4219),
    [anon_sym_LT_LT] = ACTIONS(4221),
    [anon_sym_LT_LT_DASH] = ACTIONS(4219),
    [anon_sym_LT_LT_LT] = ACTIONS(4219),
    [anon_sym_DOLLAR] = ACTIONS(4221),
    [sym__special_character] = ACTIONS(4219),
    [anon_sym_DQUOTE] = ACTIONS(4219),
    [sym_raw_string] = ACTIONS(4219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4219),
    [anon_sym_BQUOTE] = ACTIONS(4219),
    [anon_sym_LT_LPAREN] = ACTIONS(4219),
    [anon_sym_GT_LPAREN] = ACTIONS(4219),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4221),
    [sym_word] = ACTIONS(4221),
    [anon_sym_LF] = ACTIONS(4219),
    [anon_sym_AMP] = ACTIONS(4221),
  },
  [3854] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9302),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3855] = {
    [sym_concatenation] = STATE(4125),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4125),
    [anon_sym_RBRACE] = ACTIONS(9282),
    [anon_sym_EQ] = ACTIONS(9298),
    [anon_sym_DASH] = ACTIONS(9298),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9300),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9298),
    [anon_sym_COLON_QMARK] = ACTIONS(9298),
    [anon_sym_COLON_DASH] = ACTIONS(9298),
    [anon_sym_PERCENT] = ACTIONS(9298),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3856] = {
    [sym_string] = STATE(2963),
    [sym__simple_heredoc_body] = ACTIONS(4071),
    [sym__heredoc_body_beginning] = ACTIONS(4071),
    [sym_file_descriptor] = ACTIONS(4071),
    [anon_sym_SEMI] = ACTIONS(4073),
    [anon_sym_fi] = ACTIONS(4073),
    [anon_sym_PIPE] = ACTIONS(4073),
    [anon_sym_SEMI_SEMI] = ACTIONS(4071),
    [anon_sym_PIPE_AMP] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_PIPE_PIPE] = ACTIONS(4071),
    [anon_sym_LT] = ACTIONS(4073),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_GT_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT] = ACTIONS(4073),
    [anon_sym_AMP_GT_GT] = ACTIONS(4071),
    [anon_sym_LT_AMP] = ACTIONS(4071),
    [anon_sym_GT_AMP] = ACTIONS(4071),
    [anon_sym_LT_LT] = ACTIONS(4073),
    [anon_sym_LT_LT_DASH] = ACTIONS(4071),
    [anon_sym_LT_LT_LT] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(9308),
    [anon_sym_DOLLAR] = ACTIONS(9308),
    [sym__special_character] = ACTIONS(4071),
    [anon_sym_DQUOTE] = ACTIONS(5083),
    [sym_raw_string] = ACTIONS(6517),
    [anon_sym_POUND] = ACTIONS(6515),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4071),
    [anon_sym_BQUOTE] = ACTIONS(4071),
    [anon_sym_LT_LPAREN] = ACTIONS(4071),
    [anon_sym_GT_LPAREN] = ACTIONS(4071),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6519),
    [anon_sym_STAR] = ACTIONS(6519),
    [anon_sym_AT] = ACTIONS(6519),
    [anon_sym_QMARK] = ACTIONS(6519),
    [anon_sym_0] = ACTIONS(6519),
    [anon_sym__] = ACTIONS(6519),
    [sym_word] = ACTIONS(4073),
    [anon_sym_LF] = ACTIONS(4071),
    [anon_sym_AMP] = ACTIONS(4073),
  },
  [3857] = {
    [sym__simple_heredoc_body] = ACTIONS(4111),
    [sym__heredoc_body_beginning] = ACTIONS(4111),
    [sym_file_descriptor] = ACTIONS(4111),
    [sym__concat] = ACTIONS(4111),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_fi] = ACTIONS(4113),
    [anon_sym_PIPE] = ACTIONS(4113),
    [anon_sym_SEMI_SEMI] = ACTIONS(4111),
    [anon_sym_PIPE_AMP] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_LT] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4113),
    [anon_sym_GT_GT] = ACTIONS(4111),
    [anon_sym_AMP_GT] = ACTIONS(4113),
    [anon_sym_AMP_GT_GT] = ACTIONS(4111),
    [anon_sym_LT_AMP] = ACTIONS(4111),
    [anon_sym_GT_AMP] = ACTIONS(4111),
    [anon_sym_LT_LT] = ACTIONS(4113),
    [anon_sym_LT_LT_DASH] = ACTIONS(4111),
    [anon_sym_LT_LT_LT] = ACTIONS(4111),
    [anon_sym_DOLLAR] = ACTIONS(4113),
    [sym__special_character] = ACTIONS(4111),
    [anon_sym_DQUOTE] = ACTIONS(4111),
    [sym_raw_string] = ACTIONS(4111),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4111),
    [anon_sym_BQUOTE] = ACTIONS(4111),
    [anon_sym_LT_LPAREN] = ACTIONS(4111),
    [anon_sym_GT_LPAREN] = ACTIONS(4111),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4113),
    [sym_word] = ACTIONS(4113),
    [anon_sym_LF] = ACTIONS(4111),
    [anon_sym_AMP] = ACTIONS(4113),
  },
  [3858] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_fi] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym__special_character] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4127),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [3859] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(9310),
    [sym_comment] = ACTIONS(57),
  },
  [3860] = {
    [anon_sym_RBRACE] = ACTIONS(9310),
    [sym_comment] = ACTIONS(57),
  },
  [3861] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(9312),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [3862] = {
    [sym_concatenation] = STATE(4131),
    [sym_string] = STATE(4130),
    [sym_simple_expansion] = STATE(4130),
    [sym_string_expansion] = STATE(4130),
    [sym_expansion] = STATE(4130),
    [sym_command_substitution] = STATE(4130),
    [sym_process_substitution] = STATE(4130),
    [aux_sym__literal_repeat1] = STATE(4132),
    [anon_sym_RBRACE] = ACTIONS(9310),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(9314),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9314),
  },
  [3863] = {
    [sym__simple_heredoc_body] = ACTIONS(4161),
    [sym__heredoc_body_beginning] = ACTIONS(4161),
    [sym_file_descriptor] = ACTIONS(4161),
    [sym__concat] = ACTIONS(4161),
    [anon_sym_SEMI] = ACTIONS(4163),
    [anon_sym_fi] = ACTIONS(4163),
    [anon_sym_PIPE] = ACTIONS(4163),
    [anon_sym_SEMI_SEMI] = ACTIONS(4161),
    [anon_sym_PIPE_AMP] = ACTIONS(4161),
    [anon_sym_AMP_AMP] = ACTIONS(4161),
    [anon_sym_PIPE_PIPE] = ACTIONS(4161),
    [anon_sym_LT] = ACTIONS(4163),
    [anon_sym_GT] = ACTIONS(4163),
    [anon_sym_GT_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT] = ACTIONS(4163),
    [anon_sym_AMP_GT_GT] = ACTIONS(4161),
    [anon_sym_LT_AMP] = ACTIONS(4161),
    [anon_sym_GT_AMP] = ACTIONS(4161),
    [anon_sym_LT_LT] = ACTIONS(4163),
    [anon_sym_LT_LT_DASH] = ACTIONS(4161),
    [anon_sym_LT_LT_LT] = ACTIONS(4161),
    [anon_sym_DOLLAR] = ACTIONS(4163),
    [sym__special_character] = ACTIONS(4161),
    [anon_sym_DQUOTE] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4161),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4161),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4161),
    [anon_sym_BQUOTE] = ACTIONS(4161),
    [anon_sym_LT_LPAREN] = ACTIONS(4161),
    [anon_sym_GT_LPAREN] = ACTIONS(4161),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4163),
    [sym_word] = ACTIONS(4163),
    [anon_sym_LF] = ACTIONS(4161),
    [anon_sym_AMP] = ACTIONS(4163),
  },
  [3864] = {
    [sym_concatenation] = STATE(4135),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4135),
    [sym_regex] = ACTIONS(9316),
    [anon_sym_RBRACE] = ACTIONS(9318),
    [anon_sym_EQ] = ACTIONS(9320),
    [anon_sym_DASH] = ACTIONS(9320),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9322),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9320),
    [anon_sym_COLON_QMARK] = ACTIONS(9320),
    [anon_sym_COLON_DASH] = ACTIONS(9320),
    [anon_sym_PERCENT] = ACTIONS(9320),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3865] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9318),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3866] = {
    [sym_concatenation] = STATE(4137),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4137),
    [sym_regex] = ACTIONS(9324),
    [anon_sym_RBRACE] = ACTIONS(9310),
    [anon_sym_EQ] = ACTIONS(9326),
    [anon_sym_DASH] = ACTIONS(9326),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9328),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9326),
    [anon_sym_COLON_QMARK] = ACTIONS(9326),
    [anon_sym_COLON_DASH] = ACTIONS(9326),
    [anon_sym_PERCENT] = ACTIONS(9326),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3867] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9310),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3868] = {
    [sym_concatenation] = STATE(4139),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4139),
    [anon_sym_RBRACE] = ACTIONS(9330),
    [anon_sym_EQ] = ACTIONS(9332),
    [anon_sym_DASH] = ACTIONS(9332),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9334),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9332),
    [anon_sym_COLON_QMARK] = ACTIONS(9332),
    [anon_sym_COLON_DASH] = ACTIONS(9332),
    [anon_sym_PERCENT] = ACTIONS(9332),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3869] = {
    [sym__simple_heredoc_body] = ACTIONS(4219),
    [sym__heredoc_body_beginning] = ACTIONS(4219),
    [sym_file_descriptor] = ACTIONS(4219),
    [sym__concat] = ACTIONS(4219),
    [anon_sym_SEMI] = ACTIONS(4221),
    [anon_sym_fi] = ACTIONS(4221),
    [anon_sym_PIPE] = ACTIONS(4221),
    [anon_sym_SEMI_SEMI] = ACTIONS(4219),
    [anon_sym_PIPE_AMP] = ACTIONS(4219),
    [anon_sym_AMP_AMP] = ACTIONS(4219),
    [anon_sym_PIPE_PIPE] = ACTIONS(4219),
    [anon_sym_LT] = ACTIONS(4221),
    [anon_sym_GT] = ACTIONS(4221),
    [anon_sym_GT_GT] = ACTIONS(4219),
    [anon_sym_AMP_GT] = ACTIONS(4221),
    [anon_sym_AMP_GT_GT] = ACTIONS(4219),
    [anon_sym_LT_AMP] = ACTIONS(4219),
    [anon_sym_GT_AMP] = ACTIONS(4219),
    [anon_sym_LT_LT] = ACTIONS(4221),
    [anon_sym_LT_LT_DASH] = ACTIONS(4219),
    [anon_sym_LT_LT_LT] = ACTIONS(4219),
    [anon_sym_DOLLAR] = ACTIONS(4221),
    [sym__special_character] = ACTIONS(4219),
    [anon_sym_DQUOTE] = ACTIONS(4219),
    [sym_raw_string] = ACTIONS(4219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4219),
    [anon_sym_BQUOTE] = ACTIONS(4219),
    [anon_sym_LT_LPAREN] = ACTIONS(4219),
    [anon_sym_GT_LPAREN] = ACTIONS(4219),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4221),
    [sym_word] = ACTIONS(4221),
    [anon_sym_LF] = ACTIONS(4219),
    [anon_sym_AMP] = ACTIONS(4221),
  },
  [3870] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9330),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3871] = {
    [sym_concatenation] = STATE(4137),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4137),
    [anon_sym_RBRACE] = ACTIONS(9310),
    [anon_sym_EQ] = ACTIONS(9326),
    [anon_sym_DASH] = ACTIONS(9326),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9328),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9326),
    [anon_sym_COLON_QMARK] = ACTIONS(9326),
    [anon_sym_COLON_DASH] = ACTIONS(9326),
    [anon_sym_PERCENT] = ACTIONS(9326),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3872] = {
    [sym__simple_heredoc_body] = ACTIONS(5674),
    [sym__heredoc_body_beginning] = ACTIONS(5674),
    [sym_file_descriptor] = ACTIONS(5674),
    [sym__concat] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(5676),
    [anon_sym_fi] = ACTIONS(5676),
    [anon_sym_PIPE] = ACTIONS(5676),
    [anon_sym_SEMI_SEMI] = ACTIONS(5674),
    [anon_sym_PIPE_AMP] = ACTIONS(5674),
    [anon_sym_AMP_AMP] = ACTIONS(5674),
    [anon_sym_PIPE_PIPE] = ACTIONS(5674),
    [anon_sym_EQ_TILDE] = ACTIONS(5676),
    [anon_sym_EQ_EQ] = ACTIONS(5676),
    [anon_sym_LT] = ACTIONS(5676),
    [anon_sym_GT] = ACTIONS(5676),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_AMP_GT] = ACTIONS(5676),
    [anon_sym_AMP_GT_GT] = ACTIONS(5674),
    [anon_sym_LT_AMP] = ACTIONS(5674),
    [anon_sym_GT_AMP] = ACTIONS(5674),
    [anon_sym_LT_LT] = ACTIONS(5676),
    [anon_sym_LT_LT_DASH] = ACTIONS(5674),
    [anon_sym_LT_LT_LT] = ACTIONS(5674),
    [anon_sym_DOLLAR] = ACTIONS(5676),
    [sym__special_character] = ACTIONS(5674),
    [anon_sym_DQUOTE] = ACTIONS(5674),
    [sym_raw_string] = ACTIONS(5674),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5674),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5674),
    [anon_sym_BQUOTE] = ACTIONS(5674),
    [anon_sym_LT_LPAREN] = ACTIONS(5674),
    [anon_sym_GT_LPAREN] = ACTIONS(5674),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5676),
    [anon_sym_LF] = ACTIONS(5674),
    [anon_sym_AMP] = ACTIONS(5676),
  },
  [3873] = {
    [sym__simple_heredoc_body] = ACTIONS(5708),
    [sym__heredoc_body_beginning] = ACTIONS(5708),
    [sym_file_descriptor] = ACTIONS(5708),
    [sym__concat] = ACTIONS(5708),
    [anon_sym_SEMI] = ACTIONS(5710),
    [anon_sym_fi] = ACTIONS(5710),
    [anon_sym_PIPE] = ACTIONS(5710),
    [anon_sym_SEMI_SEMI] = ACTIONS(5708),
    [anon_sym_PIPE_AMP] = ACTIONS(5708),
    [anon_sym_AMP_AMP] = ACTIONS(5708),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_EQ_TILDE] = ACTIONS(5710),
    [anon_sym_EQ_EQ] = ACTIONS(5710),
    [anon_sym_LT] = ACTIONS(5710),
    [anon_sym_GT] = ACTIONS(5710),
    [anon_sym_GT_GT] = ACTIONS(5708),
    [anon_sym_AMP_GT] = ACTIONS(5710),
    [anon_sym_AMP_GT_GT] = ACTIONS(5708),
    [anon_sym_LT_AMP] = ACTIONS(5708),
    [anon_sym_GT_AMP] = ACTIONS(5708),
    [anon_sym_LT_LT] = ACTIONS(5710),
    [anon_sym_LT_LT_DASH] = ACTIONS(5708),
    [anon_sym_LT_LT_LT] = ACTIONS(5708),
    [anon_sym_DOLLAR] = ACTIONS(5710),
    [sym__special_character] = ACTIONS(5708),
    [anon_sym_DQUOTE] = ACTIONS(5708),
    [sym_raw_string] = ACTIONS(5708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5708),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5708),
    [anon_sym_BQUOTE] = ACTIONS(5708),
    [anon_sym_LT_LPAREN] = ACTIONS(5708),
    [anon_sym_GT_LPAREN] = ACTIONS(5708),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5710),
    [anon_sym_LF] = ACTIONS(5708),
    [anon_sym_AMP] = ACTIONS(5710),
  },
  [3874] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(9336),
    [sym_comment] = ACTIONS(57),
  },
  [3875] = {
    [anon_sym_RBRACE] = ACTIONS(9336),
    [sym_comment] = ACTIONS(57),
  },
  [3876] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(9338),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [3877] = {
    [sym_concatenation] = STATE(4143),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4143),
    [anon_sym_RBRACE] = ACTIONS(9340),
    [anon_sym_EQ] = ACTIONS(9342),
    [anon_sym_DASH] = ACTIONS(9342),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9342),
    [anon_sym_COLON_QMARK] = ACTIONS(9342),
    [anon_sym_COLON_DASH] = ACTIONS(9342),
    [anon_sym_PERCENT] = ACTIONS(9342),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3878] = {
    [sym__simple_heredoc_body] = ACTIONS(5725),
    [sym__heredoc_body_beginning] = ACTIONS(5725),
    [sym_file_descriptor] = ACTIONS(5725),
    [sym__concat] = ACTIONS(5725),
    [anon_sym_SEMI] = ACTIONS(5727),
    [anon_sym_fi] = ACTIONS(5727),
    [anon_sym_PIPE] = ACTIONS(5727),
    [anon_sym_SEMI_SEMI] = ACTIONS(5725),
    [anon_sym_PIPE_AMP] = ACTIONS(5725),
    [anon_sym_AMP_AMP] = ACTIONS(5725),
    [anon_sym_PIPE_PIPE] = ACTIONS(5725),
    [anon_sym_EQ_TILDE] = ACTIONS(5727),
    [anon_sym_EQ_EQ] = ACTIONS(5727),
    [anon_sym_LT] = ACTIONS(5727),
    [anon_sym_GT] = ACTIONS(5727),
    [anon_sym_GT_GT] = ACTIONS(5725),
    [anon_sym_AMP_GT] = ACTIONS(5727),
    [anon_sym_AMP_GT_GT] = ACTIONS(5725),
    [anon_sym_LT_AMP] = ACTIONS(5725),
    [anon_sym_GT_AMP] = ACTIONS(5725),
    [anon_sym_LT_LT] = ACTIONS(5727),
    [anon_sym_LT_LT_DASH] = ACTIONS(5725),
    [anon_sym_LT_LT_LT] = ACTIONS(5725),
    [anon_sym_DOLLAR] = ACTIONS(5727),
    [sym__special_character] = ACTIONS(5725),
    [anon_sym_DQUOTE] = ACTIONS(5725),
    [sym_raw_string] = ACTIONS(5725),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5725),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5725),
    [anon_sym_BQUOTE] = ACTIONS(5725),
    [anon_sym_LT_LPAREN] = ACTIONS(5725),
    [anon_sym_GT_LPAREN] = ACTIONS(5725),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5727),
    [anon_sym_LF] = ACTIONS(5725),
    [anon_sym_AMP] = ACTIONS(5727),
  },
  [3879] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9340),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3880] = {
    [sym_concatenation] = STATE(4144),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4144),
    [anon_sym_RBRACE] = ACTIONS(9336),
    [anon_sym_EQ] = ACTIONS(9346),
    [anon_sym_DASH] = ACTIONS(9346),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9348),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9346),
    [anon_sym_COLON_QMARK] = ACTIONS(9346),
    [anon_sym_COLON_DASH] = ACTIONS(9346),
    [anon_sym_PERCENT] = ACTIONS(9346),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3881] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9336),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3882] = {
    [sym__simple_heredoc_body] = ACTIONS(5770),
    [sym__heredoc_body_beginning] = ACTIONS(5770),
    [sym_file_descriptor] = ACTIONS(5770),
    [sym__concat] = ACTIONS(5770),
    [anon_sym_SEMI] = ACTIONS(5772),
    [anon_sym_fi] = ACTIONS(5772),
    [anon_sym_PIPE] = ACTIONS(5772),
    [anon_sym_SEMI_SEMI] = ACTIONS(5770),
    [anon_sym_PIPE_AMP] = ACTIONS(5770),
    [anon_sym_AMP_AMP] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5770),
    [anon_sym_EQ_TILDE] = ACTIONS(5772),
    [anon_sym_EQ_EQ] = ACTIONS(5772),
    [anon_sym_LT] = ACTIONS(5772),
    [anon_sym_GT] = ACTIONS(5772),
    [anon_sym_GT_GT] = ACTIONS(5770),
    [anon_sym_AMP_GT] = ACTIONS(5772),
    [anon_sym_AMP_GT_GT] = ACTIONS(5770),
    [anon_sym_LT_AMP] = ACTIONS(5770),
    [anon_sym_GT_AMP] = ACTIONS(5770),
    [anon_sym_LT_LT] = ACTIONS(5772),
    [anon_sym_LT_LT_DASH] = ACTIONS(5770),
    [anon_sym_LT_LT_LT] = ACTIONS(5770),
    [anon_sym_DOLLAR] = ACTIONS(5772),
    [sym__special_character] = ACTIONS(5770),
    [anon_sym_DQUOTE] = ACTIONS(5770),
    [sym_raw_string] = ACTIONS(5770),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5770),
    [anon_sym_BQUOTE] = ACTIONS(5770),
    [anon_sym_LT_LPAREN] = ACTIONS(5770),
    [anon_sym_GT_LPAREN] = ACTIONS(5770),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5772),
    [anon_sym_LF] = ACTIONS(5770),
    [anon_sym_AMP] = ACTIONS(5772),
  },
  [3883] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9350),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3884] = {
    [sym_string] = STATE(3406),
    [sym_simple_expansion] = STATE(3406),
    [sym_string_expansion] = STATE(3406),
    [sym_expansion] = STATE(3406),
    [sym_command_substitution] = STATE(3406),
    [sym_process_substitution] = STATE(3406),
    [anon_sym_DOLLAR] = ACTIONS(9352),
    [sym__special_character] = ACTIONS(7609),
    [anon_sym_DQUOTE] = ACTIONS(5002),
    [sym_raw_string] = ACTIONS(7609),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5006),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5008),
    [anon_sym_BQUOTE] = ACTIONS(5010),
    [anon_sym_LT_LPAREN] = ACTIONS(5012),
    [anon_sym_GT_LPAREN] = ACTIONS(5012),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7609),
  },
  [3885] = {
    [aux_sym_concatenation_repeat1] = STATE(3885),
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(8575),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_fi] = ACTIONS(2362),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [3886] = {
    [sym__simple_heredoc_body] = ACTIONS(4449),
    [sym__heredoc_body_beginning] = ACTIONS(4449),
    [sym_file_descriptor] = ACTIONS(4449),
    [sym_variable_name] = ACTIONS(4449),
    [anon_sym_SEMI] = ACTIONS(4451),
    [anon_sym_fi] = ACTIONS(4451),
    [anon_sym_elif] = ACTIONS(4451),
    [anon_sym_else] = ACTIONS(4451),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_SEMI_SEMI] = ACTIONS(4449),
    [anon_sym_PIPE_AMP] = ACTIONS(4449),
    [anon_sym_AMP_AMP] = ACTIONS(4449),
    [anon_sym_PIPE_PIPE] = ACTIONS(4449),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_GT_GT] = ACTIONS(4449),
    [anon_sym_AMP_GT] = ACTIONS(4451),
    [anon_sym_AMP_GT_GT] = ACTIONS(4449),
    [anon_sym_LT_AMP] = ACTIONS(4449),
    [anon_sym_GT_AMP] = ACTIONS(4449),
    [anon_sym_LT_LT] = ACTIONS(4451),
    [anon_sym_LT_LT_DASH] = ACTIONS(4449),
    [anon_sym_LT_LT_LT] = ACTIONS(4449),
    [anon_sym_DOLLAR] = ACTIONS(4451),
    [sym__special_character] = ACTIONS(4449),
    [anon_sym_DQUOTE] = ACTIONS(4449),
    [sym_raw_string] = ACTIONS(4449),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4449),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4449),
    [anon_sym_BQUOTE] = ACTIONS(4449),
    [anon_sym_LT_LPAREN] = ACTIONS(4449),
    [anon_sym_GT_LPAREN] = ACTIONS(4449),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4451),
    [sym_word] = ACTIONS(4451),
    [anon_sym_LF] = ACTIONS(4449),
    [anon_sym_AMP] = ACTIONS(4451),
  },
  [3887] = {
    [sym__simple_heredoc_body] = ACTIONS(5674),
    [sym__heredoc_body_beginning] = ACTIONS(5674),
    [sym_file_descriptor] = ACTIONS(5674),
    [sym__concat] = ACTIONS(5674),
    [sym_variable_name] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(5676),
    [anon_sym_fi] = ACTIONS(5676),
    [anon_sym_elif] = ACTIONS(5676),
    [anon_sym_else] = ACTIONS(5676),
    [anon_sym_PIPE] = ACTIONS(5676),
    [anon_sym_SEMI_SEMI] = ACTIONS(5674),
    [anon_sym_PIPE_AMP] = ACTIONS(5674),
    [anon_sym_AMP_AMP] = ACTIONS(5674),
    [anon_sym_PIPE_PIPE] = ACTIONS(5674),
    [anon_sym_LT] = ACTIONS(5676),
    [anon_sym_GT] = ACTIONS(5676),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_AMP_GT] = ACTIONS(5676),
    [anon_sym_AMP_GT_GT] = ACTIONS(5674),
    [anon_sym_LT_AMP] = ACTIONS(5674),
    [anon_sym_GT_AMP] = ACTIONS(5674),
    [anon_sym_LT_LT] = ACTIONS(5676),
    [anon_sym_LT_LT_DASH] = ACTIONS(5674),
    [anon_sym_LT_LT_LT] = ACTIONS(5674),
    [anon_sym_DOLLAR] = ACTIONS(5676),
    [sym__special_character] = ACTIONS(5674),
    [anon_sym_DQUOTE] = ACTIONS(5674),
    [sym_raw_string] = ACTIONS(5674),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5674),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5674),
    [anon_sym_BQUOTE] = ACTIONS(5674),
    [anon_sym_LT_LPAREN] = ACTIONS(5674),
    [anon_sym_GT_LPAREN] = ACTIONS(5674),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5676),
    [sym_word] = ACTIONS(5676),
    [anon_sym_LF] = ACTIONS(5674),
    [anon_sym_AMP] = ACTIONS(5676),
  },
  [3888] = {
    [sym__simple_heredoc_body] = ACTIONS(5708),
    [sym__heredoc_body_beginning] = ACTIONS(5708),
    [sym_file_descriptor] = ACTIONS(5708),
    [sym__concat] = ACTIONS(5708),
    [sym_variable_name] = ACTIONS(5708),
    [anon_sym_SEMI] = ACTIONS(5710),
    [anon_sym_fi] = ACTIONS(5710),
    [anon_sym_elif] = ACTIONS(5710),
    [anon_sym_else] = ACTIONS(5710),
    [anon_sym_PIPE] = ACTIONS(5710),
    [anon_sym_SEMI_SEMI] = ACTIONS(5708),
    [anon_sym_PIPE_AMP] = ACTIONS(5708),
    [anon_sym_AMP_AMP] = ACTIONS(5708),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_LT] = ACTIONS(5710),
    [anon_sym_GT] = ACTIONS(5710),
    [anon_sym_GT_GT] = ACTIONS(5708),
    [anon_sym_AMP_GT] = ACTIONS(5710),
    [anon_sym_AMP_GT_GT] = ACTIONS(5708),
    [anon_sym_LT_AMP] = ACTIONS(5708),
    [anon_sym_GT_AMP] = ACTIONS(5708),
    [anon_sym_LT_LT] = ACTIONS(5710),
    [anon_sym_LT_LT_DASH] = ACTIONS(5708),
    [anon_sym_LT_LT_LT] = ACTIONS(5708),
    [anon_sym_DOLLAR] = ACTIONS(5710),
    [sym__special_character] = ACTIONS(5708),
    [anon_sym_DQUOTE] = ACTIONS(5708),
    [sym_raw_string] = ACTIONS(5708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5708),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5708),
    [anon_sym_BQUOTE] = ACTIONS(5708),
    [anon_sym_LT_LPAREN] = ACTIONS(5708),
    [anon_sym_GT_LPAREN] = ACTIONS(5708),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5710),
    [sym_word] = ACTIONS(5710),
    [anon_sym_LF] = ACTIONS(5708),
    [anon_sym_AMP] = ACTIONS(5710),
  },
  [3889] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(9354),
    [sym_comment] = ACTIONS(57),
  },
  [3890] = {
    [anon_sym_RBRACE] = ACTIONS(9354),
    [sym_comment] = ACTIONS(57),
  },
  [3891] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(9356),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [3892] = {
    [sym_concatenation] = STATE(4150),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4150),
    [anon_sym_RBRACE] = ACTIONS(9358),
    [anon_sym_EQ] = ACTIONS(9360),
    [anon_sym_DASH] = ACTIONS(9360),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9360),
    [anon_sym_COLON_QMARK] = ACTIONS(9360),
    [anon_sym_COLON_DASH] = ACTIONS(9360),
    [anon_sym_PERCENT] = ACTIONS(9360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3893] = {
    [sym__simple_heredoc_body] = ACTIONS(5725),
    [sym__heredoc_body_beginning] = ACTIONS(5725),
    [sym_file_descriptor] = ACTIONS(5725),
    [sym__concat] = ACTIONS(5725),
    [sym_variable_name] = ACTIONS(5725),
    [anon_sym_SEMI] = ACTIONS(5727),
    [anon_sym_fi] = ACTIONS(5727),
    [anon_sym_elif] = ACTIONS(5727),
    [anon_sym_else] = ACTIONS(5727),
    [anon_sym_PIPE] = ACTIONS(5727),
    [anon_sym_SEMI_SEMI] = ACTIONS(5725),
    [anon_sym_PIPE_AMP] = ACTIONS(5725),
    [anon_sym_AMP_AMP] = ACTIONS(5725),
    [anon_sym_PIPE_PIPE] = ACTIONS(5725),
    [anon_sym_LT] = ACTIONS(5727),
    [anon_sym_GT] = ACTIONS(5727),
    [anon_sym_GT_GT] = ACTIONS(5725),
    [anon_sym_AMP_GT] = ACTIONS(5727),
    [anon_sym_AMP_GT_GT] = ACTIONS(5725),
    [anon_sym_LT_AMP] = ACTIONS(5725),
    [anon_sym_GT_AMP] = ACTIONS(5725),
    [anon_sym_LT_LT] = ACTIONS(5727),
    [anon_sym_LT_LT_DASH] = ACTIONS(5725),
    [anon_sym_LT_LT_LT] = ACTIONS(5725),
    [anon_sym_DOLLAR] = ACTIONS(5727),
    [sym__special_character] = ACTIONS(5725),
    [anon_sym_DQUOTE] = ACTIONS(5725),
    [sym_raw_string] = ACTIONS(5725),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5725),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5725),
    [anon_sym_BQUOTE] = ACTIONS(5725),
    [anon_sym_LT_LPAREN] = ACTIONS(5725),
    [anon_sym_GT_LPAREN] = ACTIONS(5725),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5727),
    [sym_word] = ACTIONS(5727),
    [anon_sym_LF] = ACTIONS(5725),
    [anon_sym_AMP] = ACTIONS(5727),
  },
  [3894] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9358),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3895] = {
    [sym_concatenation] = STATE(4151),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4151),
    [anon_sym_RBRACE] = ACTIONS(9354),
    [anon_sym_EQ] = ACTIONS(9364),
    [anon_sym_DASH] = ACTIONS(9364),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9364),
    [anon_sym_COLON_QMARK] = ACTIONS(9364),
    [anon_sym_COLON_DASH] = ACTIONS(9364),
    [anon_sym_PERCENT] = ACTIONS(9364),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3896] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9354),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3897] = {
    [sym__simple_heredoc_body] = ACTIONS(5770),
    [sym__heredoc_body_beginning] = ACTIONS(5770),
    [sym_file_descriptor] = ACTIONS(5770),
    [sym__concat] = ACTIONS(5770),
    [sym_variable_name] = ACTIONS(5770),
    [anon_sym_SEMI] = ACTIONS(5772),
    [anon_sym_fi] = ACTIONS(5772),
    [anon_sym_elif] = ACTIONS(5772),
    [anon_sym_else] = ACTIONS(5772),
    [anon_sym_PIPE] = ACTIONS(5772),
    [anon_sym_SEMI_SEMI] = ACTIONS(5770),
    [anon_sym_PIPE_AMP] = ACTIONS(5770),
    [anon_sym_AMP_AMP] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5770),
    [anon_sym_LT] = ACTIONS(5772),
    [anon_sym_GT] = ACTIONS(5772),
    [anon_sym_GT_GT] = ACTIONS(5770),
    [anon_sym_AMP_GT] = ACTIONS(5772),
    [anon_sym_AMP_GT_GT] = ACTIONS(5770),
    [anon_sym_LT_AMP] = ACTIONS(5770),
    [anon_sym_GT_AMP] = ACTIONS(5770),
    [anon_sym_LT_LT] = ACTIONS(5772),
    [anon_sym_LT_LT_DASH] = ACTIONS(5770),
    [anon_sym_LT_LT_LT] = ACTIONS(5770),
    [anon_sym_DOLLAR] = ACTIONS(5772),
    [sym__special_character] = ACTIONS(5770),
    [anon_sym_DQUOTE] = ACTIONS(5770),
    [sym_raw_string] = ACTIONS(5770),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5770),
    [anon_sym_BQUOTE] = ACTIONS(5770),
    [anon_sym_LT_LPAREN] = ACTIONS(5770),
    [anon_sym_GT_LPAREN] = ACTIONS(5770),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5772),
    [sym_word] = ACTIONS(5772),
    [anon_sym_LF] = ACTIONS(5770),
    [anon_sym_AMP] = ACTIONS(5772),
  },
  [3898] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9368),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3899] = {
    [sym__simple_heredoc_body] = ACTIONS(5674),
    [sym__heredoc_body_beginning] = ACTIONS(5674),
    [sym_file_descriptor] = ACTIONS(5674),
    [sym__concat] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(5676),
    [anon_sym_fi] = ACTIONS(5676),
    [anon_sym_elif] = ACTIONS(5676),
    [anon_sym_else] = ACTIONS(5676),
    [anon_sym_PIPE] = ACTIONS(5676),
    [anon_sym_SEMI_SEMI] = ACTIONS(5674),
    [anon_sym_PIPE_AMP] = ACTIONS(5674),
    [anon_sym_AMP_AMP] = ACTIONS(5674),
    [anon_sym_PIPE_PIPE] = ACTIONS(5674),
    [anon_sym_LT] = ACTIONS(5676),
    [anon_sym_GT] = ACTIONS(5676),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_AMP_GT] = ACTIONS(5676),
    [anon_sym_AMP_GT_GT] = ACTIONS(5674),
    [anon_sym_LT_AMP] = ACTIONS(5674),
    [anon_sym_GT_AMP] = ACTIONS(5674),
    [anon_sym_LT_LT] = ACTIONS(5676),
    [anon_sym_LT_LT_DASH] = ACTIONS(5674),
    [anon_sym_LT_LT_LT] = ACTIONS(5674),
    [anon_sym_DOLLAR] = ACTIONS(5676),
    [sym__special_character] = ACTIONS(5674),
    [anon_sym_DQUOTE] = ACTIONS(5674),
    [sym_raw_string] = ACTIONS(5674),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5674),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5674),
    [anon_sym_BQUOTE] = ACTIONS(5674),
    [anon_sym_LT_LPAREN] = ACTIONS(5674),
    [anon_sym_GT_LPAREN] = ACTIONS(5674),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5676),
    [sym_word] = ACTIONS(5676),
    [anon_sym_LF] = ACTIONS(5674),
    [anon_sym_AMP] = ACTIONS(5676),
  },
  [3900] = {
    [sym__simple_heredoc_body] = ACTIONS(5708),
    [sym__heredoc_body_beginning] = ACTIONS(5708),
    [sym_file_descriptor] = ACTIONS(5708),
    [sym__concat] = ACTIONS(5708),
    [anon_sym_SEMI] = ACTIONS(5710),
    [anon_sym_fi] = ACTIONS(5710),
    [anon_sym_elif] = ACTIONS(5710),
    [anon_sym_else] = ACTIONS(5710),
    [anon_sym_PIPE] = ACTIONS(5710),
    [anon_sym_SEMI_SEMI] = ACTIONS(5708),
    [anon_sym_PIPE_AMP] = ACTIONS(5708),
    [anon_sym_AMP_AMP] = ACTIONS(5708),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_LT] = ACTIONS(5710),
    [anon_sym_GT] = ACTIONS(5710),
    [anon_sym_GT_GT] = ACTIONS(5708),
    [anon_sym_AMP_GT] = ACTIONS(5710),
    [anon_sym_AMP_GT_GT] = ACTIONS(5708),
    [anon_sym_LT_AMP] = ACTIONS(5708),
    [anon_sym_GT_AMP] = ACTIONS(5708),
    [anon_sym_LT_LT] = ACTIONS(5710),
    [anon_sym_LT_LT_DASH] = ACTIONS(5708),
    [anon_sym_LT_LT_LT] = ACTIONS(5708),
    [anon_sym_DOLLAR] = ACTIONS(5710),
    [sym__special_character] = ACTIONS(5708),
    [anon_sym_DQUOTE] = ACTIONS(5708),
    [sym_raw_string] = ACTIONS(5708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5708),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5708),
    [anon_sym_BQUOTE] = ACTIONS(5708),
    [anon_sym_LT_LPAREN] = ACTIONS(5708),
    [anon_sym_GT_LPAREN] = ACTIONS(5708),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5710),
    [sym_word] = ACTIONS(5710),
    [anon_sym_LF] = ACTIONS(5708),
    [anon_sym_AMP] = ACTIONS(5710),
  },
  [3901] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(9370),
    [sym_comment] = ACTIONS(57),
  },
  [3902] = {
    [anon_sym_RBRACE] = ACTIONS(9370),
    [sym_comment] = ACTIONS(57),
  },
  [3903] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(9372),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [3904] = {
    [sym_concatenation] = STATE(4156),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4156),
    [anon_sym_RBRACE] = ACTIONS(9374),
    [anon_sym_EQ] = ACTIONS(9376),
    [anon_sym_DASH] = ACTIONS(9376),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9378),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9376),
    [anon_sym_COLON_QMARK] = ACTIONS(9376),
    [anon_sym_COLON_DASH] = ACTIONS(9376),
    [anon_sym_PERCENT] = ACTIONS(9376),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3905] = {
    [sym__simple_heredoc_body] = ACTIONS(5725),
    [sym__heredoc_body_beginning] = ACTIONS(5725),
    [sym_file_descriptor] = ACTIONS(5725),
    [sym__concat] = ACTIONS(5725),
    [anon_sym_SEMI] = ACTIONS(5727),
    [anon_sym_fi] = ACTIONS(5727),
    [anon_sym_elif] = ACTIONS(5727),
    [anon_sym_else] = ACTIONS(5727),
    [anon_sym_PIPE] = ACTIONS(5727),
    [anon_sym_SEMI_SEMI] = ACTIONS(5725),
    [anon_sym_PIPE_AMP] = ACTIONS(5725),
    [anon_sym_AMP_AMP] = ACTIONS(5725),
    [anon_sym_PIPE_PIPE] = ACTIONS(5725),
    [anon_sym_LT] = ACTIONS(5727),
    [anon_sym_GT] = ACTIONS(5727),
    [anon_sym_GT_GT] = ACTIONS(5725),
    [anon_sym_AMP_GT] = ACTIONS(5727),
    [anon_sym_AMP_GT_GT] = ACTIONS(5725),
    [anon_sym_LT_AMP] = ACTIONS(5725),
    [anon_sym_GT_AMP] = ACTIONS(5725),
    [anon_sym_LT_LT] = ACTIONS(5727),
    [anon_sym_LT_LT_DASH] = ACTIONS(5725),
    [anon_sym_LT_LT_LT] = ACTIONS(5725),
    [anon_sym_DOLLAR] = ACTIONS(5727),
    [sym__special_character] = ACTIONS(5725),
    [anon_sym_DQUOTE] = ACTIONS(5725),
    [sym_raw_string] = ACTIONS(5725),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5725),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5725),
    [anon_sym_BQUOTE] = ACTIONS(5725),
    [anon_sym_LT_LPAREN] = ACTIONS(5725),
    [anon_sym_GT_LPAREN] = ACTIONS(5725),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5727),
    [sym_word] = ACTIONS(5727),
    [anon_sym_LF] = ACTIONS(5725),
    [anon_sym_AMP] = ACTIONS(5727),
  },
  [3906] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9374),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3907] = {
    [sym_concatenation] = STATE(4157),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4157),
    [anon_sym_RBRACE] = ACTIONS(9370),
    [anon_sym_EQ] = ACTIONS(9380),
    [anon_sym_DASH] = ACTIONS(9380),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9382),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9380),
    [anon_sym_COLON_QMARK] = ACTIONS(9380),
    [anon_sym_COLON_DASH] = ACTIONS(9380),
    [anon_sym_PERCENT] = ACTIONS(9380),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3908] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9370),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3909] = {
    [sym__simple_heredoc_body] = ACTIONS(5770),
    [sym__heredoc_body_beginning] = ACTIONS(5770),
    [sym_file_descriptor] = ACTIONS(5770),
    [sym__concat] = ACTIONS(5770),
    [anon_sym_SEMI] = ACTIONS(5772),
    [anon_sym_fi] = ACTIONS(5772),
    [anon_sym_elif] = ACTIONS(5772),
    [anon_sym_else] = ACTIONS(5772),
    [anon_sym_PIPE] = ACTIONS(5772),
    [anon_sym_SEMI_SEMI] = ACTIONS(5770),
    [anon_sym_PIPE_AMP] = ACTIONS(5770),
    [anon_sym_AMP_AMP] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5770),
    [anon_sym_LT] = ACTIONS(5772),
    [anon_sym_GT] = ACTIONS(5772),
    [anon_sym_GT_GT] = ACTIONS(5770),
    [anon_sym_AMP_GT] = ACTIONS(5772),
    [anon_sym_AMP_GT_GT] = ACTIONS(5770),
    [anon_sym_LT_AMP] = ACTIONS(5770),
    [anon_sym_GT_AMP] = ACTIONS(5770),
    [anon_sym_LT_LT] = ACTIONS(5772),
    [anon_sym_LT_LT_DASH] = ACTIONS(5770),
    [anon_sym_LT_LT_LT] = ACTIONS(5770),
    [anon_sym_DOLLAR] = ACTIONS(5772),
    [sym__special_character] = ACTIONS(5770),
    [anon_sym_DQUOTE] = ACTIONS(5770),
    [sym_raw_string] = ACTIONS(5770),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5770),
    [anon_sym_BQUOTE] = ACTIONS(5770),
    [anon_sym_LT_LPAREN] = ACTIONS(5770),
    [anon_sym_GT_LPAREN] = ACTIONS(5770),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5772),
    [sym_word] = ACTIONS(5772),
    [anon_sym_LF] = ACTIONS(5770),
    [anon_sym_AMP] = ACTIONS(5772),
  },
  [3910] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9384),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3911] = {
    [sym__simple_heredoc_body] = ACTIONS(7198),
    [sym__heredoc_body_beginning] = ACTIONS(7198),
    [sym_file_descriptor] = ACTIONS(7198),
    [sym__concat] = ACTIONS(7198),
    [anon_sym_SEMI] = ACTIONS(7200),
    [anon_sym_fi] = ACTIONS(7200),
    [anon_sym_elif] = ACTIONS(7200),
    [anon_sym_else] = ACTIONS(7200),
    [anon_sym_PIPE] = ACTIONS(7200),
    [anon_sym_SEMI_SEMI] = ACTIONS(7198),
    [anon_sym_PIPE_AMP] = ACTIONS(7198),
    [anon_sym_AMP_AMP] = ACTIONS(7198),
    [anon_sym_PIPE_PIPE] = ACTIONS(7198),
    [anon_sym_EQ_TILDE] = ACTIONS(7200),
    [anon_sym_EQ_EQ] = ACTIONS(7200),
    [anon_sym_LT] = ACTIONS(7200),
    [anon_sym_GT] = ACTIONS(7200),
    [anon_sym_GT_GT] = ACTIONS(7198),
    [anon_sym_AMP_GT] = ACTIONS(7200),
    [anon_sym_AMP_GT_GT] = ACTIONS(7198),
    [anon_sym_LT_AMP] = ACTIONS(7198),
    [anon_sym_GT_AMP] = ACTIONS(7198),
    [anon_sym_LT_LT] = ACTIONS(7200),
    [anon_sym_LT_LT_DASH] = ACTIONS(7198),
    [anon_sym_LT_LT_LT] = ACTIONS(7198),
    [anon_sym_DOLLAR] = ACTIONS(7200),
    [sym__special_character] = ACTIONS(7198),
    [anon_sym_DQUOTE] = ACTIONS(7198),
    [sym_raw_string] = ACTIONS(7198),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7198),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7198),
    [anon_sym_BQUOTE] = ACTIONS(7198),
    [anon_sym_LT_LPAREN] = ACTIONS(7198),
    [anon_sym_GT_LPAREN] = ACTIONS(7198),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7200),
    [anon_sym_LF] = ACTIONS(7198),
    [anon_sym_AMP] = ACTIONS(7200),
  },
  [3912] = {
    [sym__simple_heredoc_body] = ACTIONS(7202),
    [sym__heredoc_body_beginning] = ACTIONS(7202),
    [sym_file_descriptor] = ACTIONS(7202),
    [sym__concat] = ACTIONS(7202),
    [anon_sym_SEMI] = ACTIONS(7204),
    [anon_sym_fi] = ACTIONS(7204),
    [anon_sym_elif] = ACTIONS(7204),
    [anon_sym_else] = ACTIONS(7204),
    [anon_sym_PIPE] = ACTIONS(7204),
    [anon_sym_SEMI_SEMI] = ACTIONS(7202),
    [anon_sym_PIPE_AMP] = ACTIONS(7202),
    [anon_sym_AMP_AMP] = ACTIONS(7202),
    [anon_sym_PIPE_PIPE] = ACTIONS(7202),
    [anon_sym_EQ_TILDE] = ACTIONS(7204),
    [anon_sym_EQ_EQ] = ACTIONS(7204),
    [anon_sym_LT] = ACTIONS(7204),
    [anon_sym_GT] = ACTIONS(7204),
    [anon_sym_GT_GT] = ACTIONS(7202),
    [anon_sym_AMP_GT] = ACTIONS(7204),
    [anon_sym_AMP_GT_GT] = ACTIONS(7202),
    [anon_sym_LT_AMP] = ACTIONS(7202),
    [anon_sym_GT_AMP] = ACTIONS(7202),
    [anon_sym_LT_LT] = ACTIONS(7204),
    [anon_sym_LT_LT_DASH] = ACTIONS(7202),
    [anon_sym_LT_LT_LT] = ACTIONS(7202),
    [anon_sym_DOLLAR] = ACTIONS(7204),
    [sym__special_character] = ACTIONS(7202),
    [anon_sym_DQUOTE] = ACTIONS(7202),
    [sym_raw_string] = ACTIONS(7202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7202),
    [anon_sym_BQUOTE] = ACTIONS(7202),
    [anon_sym_LT_LPAREN] = ACTIONS(7202),
    [anon_sym_GT_LPAREN] = ACTIONS(7202),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7204),
    [anon_sym_LF] = ACTIONS(7202),
    [anon_sym_AMP] = ACTIONS(7204),
  },
  [3913] = {
    [sym__simple_heredoc_body] = ACTIONS(7206),
    [sym__heredoc_body_beginning] = ACTIONS(7206),
    [sym_file_descriptor] = ACTIONS(7206),
    [sym__concat] = ACTIONS(7206),
    [anon_sym_SEMI] = ACTIONS(7208),
    [anon_sym_fi] = ACTIONS(7208),
    [anon_sym_elif] = ACTIONS(7208),
    [anon_sym_else] = ACTIONS(7208),
    [anon_sym_PIPE] = ACTIONS(7208),
    [anon_sym_SEMI_SEMI] = ACTIONS(7206),
    [anon_sym_PIPE_AMP] = ACTIONS(7206),
    [anon_sym_AMP_AMP] = ACTIONS(7206),
    [anon_sym_PIPE_PIPE] = ACTIONS(7206),
    [anon_sym_EQ_TILDE] = ACTIONS(7208),
    [anon_sym_EQ_EQ] = ACTIONS(7208),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7206),
    [anon_sym_AMP_GT] = ACTIONS(7208),
    [anon_sym_AMP_GT_GT] = ACTIONS(7206),
    [anon_sym_LT_AMP] = ACTIONS(7206),
    [anon_sym_GT_AMP] = ACTIONS(7206),
    [anon_sym_LT_LT] = ACTIONS(7208),
    [anon_sym_LT_LT_DASH] = ACTIONS(7206),
    [anon_sym_LT_LT_LT] = ACTIONS(7206),
    [anon_sym_DOLLAR] = ACTIONS(7208),
    [sym__special_character] = ACTIONS(7206),
    [anon_sym_DQUOTE] = ACTIONS(7206),
    [sym_raw_string] = ACTIONS(7206),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7206),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7206),
    [anon_sym_BQUOTE] = ACTIONS(7206),
    [anon_sym_LT_LPAREN] = ACTIONS(7206),
    [anon_sym_GT_LPAREN] = ACTIONS(7206),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7208),
    [anon_sym_LF] = ACTIONS(7206),
    [anon_sym_AMP] = ACTIONS(7208),
  },
  [3914] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9386),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3915] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9388),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3916] = {
    [sym__simple_heredoc_body] = ACTIONS(7242),
    [sym__heredoc_body_beginning] = ACTIONS(7242),
    [sym_file_descriptor] = ACTIONS(7242),
    [sym__concat] = ACTIONS(7242),
    [anon_sym_SEMI] = ACTIONS(7244),
    [anon_sym_fi] = ACTIONS(7244),
    [anon_sym_elif] = ACTIONS(7244),
    [anon_sym_else] = ACTIONS(7244),
    [anon_sym_PIPE] = ACTIONS(7244),
    [anon_sym_SEMI_SEMI] = ACTIONS(7242),
    [anon_sym_PIPE_AMP] = ACTIONS(7242),
    [anon_sym_AMP_AMP] = ACTIONS(7242),
    [anon_sym_PIPE_PIPE] = ACTIONS(7242),
    [anon_sym_EQ_TILDE] = ACTIONS(7244),
    [anon_sym_EQ_EQ] = ACTIONS(7244),
    [anon_sym_LT] = ACTIONS(7244),
    [anon_sym_GT] = ACTIONS(7244),
    [anon_sym_GT_GT] = ACTIONS(7242),
    [anon_sym_AMP_GT] = ACTIONS(7244),
    [anon_sym_AMP_GT_GT] = ACTIONS(7242),
    [anon_sym_LT_AMP] = ACTIONS(7242),
    [anon_sym_GT_AMP] = ACTIONS(7242),
    [anon_sym_LT_LT] = ACTIONS(7244),
    [anon_sym_LT_LT_DASH] = ACTIONS(7242),
    [anon_sym_LT_LT_LT] = ACTIONS(7242),
    [anon_sym_DOLLAR] = ACTIONS(7244),
    [sym__special_character] = ACTIONS(7242),
    [anon_sym_DQUOTE] = ACTIONS(7242),
    [sym_raw_string] = ACTIONS(7242),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7242),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7242),
    [anon_sym_BQUOTE] = ACTIONS(7242),
    [anon_sym_LT_LPAREN] = ACTIONS(7242),
    [anon_sym_GT_LPAREN] = ACTIONS(7242),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7244),
    [anon_sym_LF] = ACTIONS(7242),
    [anon_sym_AMP] = ACTIONS(7244),
  },
  [3917] = {
    [sym_string] = STATE(2891),
    [sym__simple_heredoc_body] = ACTIONS(4071),
    [sym__heredoc_body_beginning] = ACTIONS(4071),
    [sym_file_descriptor] = ACTIONS(4071),
    [anon_sym_SEMI] = ACTIONS(4073),
    [anon_sym_fi] = ACTIONS(4073),
    [anon_sym_elif] = ACTIONS(4073),
    [anon_sym_else] = ACTIONS(4073),
    [anon_sym_PIPE] = ACTIONS(4073),
    [anon_sym_SEMI_SEMI] = ACTIONS(4071),
    [anon_sym_PIPE_AMP] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_PIPE_PIPE] = ACTIONS(4071),
    [anon_sym_LT] = ACTIONS(4073),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_GT_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT] = ACTIONS(4073),
    [anon_sym_AMP_GT_GT] = ACTIONS(4071),
    [anon_sym_LT_AMP] = ACTIONS(4071),
    [anon_sym_GT_AMP] = ACTIONS(4071),
    [anon_sym_LT_LT] = ACTIONS(4073),
    [anon_sym_LT_LT_DASH] = ACTIONS(4071),
    [anon_sym_LT_LT_LT] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(6359),
    [anon_sym_DOLLAR] = ACTIONS(6359),
    [anon_sym_DQUOTE] = ACTIONS(5002),
    [sym_raw_string] = ACTIONS(6361),
    [anon_sym_POUND] = ACTIONS(6359),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6363),
    [anon_sym_STAR] = ACTIONS(6365),
    [anon_sym_AT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6365),
    [anon_sym_0] = ACTIONS(6363),
    [anon_sym__] = ACTIONS(6363),
    [anon_sym_LF] = ACTIONS(4071),
    [anon_sym_AMP] = ACTIONS(4073),
  },
  [3918] = {
    [sym__simple_heredoc_body] = ACTIONS(1400),
    [sym__heredoc_body_beginning] = ACTIONS(1400),
    [sym_file_descriptor] = ACTIONS(1400),
    [sym_variable_name] = ACTIONS(1400),
    [anon_sym_SEMI] = ACTIONS(1402),
    [anon_sym_esac] = ACTIONS(1402),
    [anon_sym_PIPE] = ACTIONS(1402),
    [anon_sym_SEMI_SEMI] = ACTIONS(1400),
    [anon_sym_PIPE_AMP] = ACTIONS(1400),
    [anon_sym_AMP_AMP] = ACTIONS(1400),
    [anon_sym_PIPE_PIPE] = ACTIONS(1400),
    [anon_sym_LT] = ACTIONS(1402),
    [anon_sym_GT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT] = ACTIONS(1402),
    [anon_sym_AMP_GT_GT] = ACTIONS(1400),
    [anon_sym_LT_AMP] = ACTIONS(1400),
    [anon_sym_GT_AMP] = ACTIONS(1400),
    [anon_sym_LT_LT] = ACTIONS(1402),
    [anon_sym_LT_LT_DASH] = ACTIONS(1400),
    [anon_sym_LT_LT_LT] = ACTIONS(1400),
    [anon_sym_DOLLAR] = ACTIONS(1402),
    [sym__special_character] = ACTIONS(1400),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1400),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1400),
    [anon_sym_BQUOTE] = ACTIONS(1400),
    [anon_sym_LT_LPAREN] = ACTIONS(1400),
    [anon_sym_GT_LPAREN] = ACTIONS(1400),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1402),
    [anon_sym_LF] = ACTIONS(1400),
    [anon_sym_AMP] = ACTIONS(1402),
  },
  [3919] = {
    [sym_concatenation] = STATE(4162),
    [sym_string] = STATE(730),
    [sym_simple_expansion] = STATE(730),
    [sym_string_expansion] = STATE(730),
    [sym_expansion] = STATE(730),
    [sym_command_substitution] = STATE(730),
    [sym_process_substitution] = STATE(730),
    [aux_sym_for_statement_repeat1] = STATE(4162),
    [aux_sym__literal_repeat1] = STATE(736),
    [anon_sym_RPAREN] = ACTIONS(9390),
    [anon_sym_DOLLAR] = ACTIONS(1406),
    [sym__special_character] = ACTIONS(1408),
    [anon_sym_DQUOTE] = ACTIONS(1410),
    [sym_raw_string] = ACTIONS(1412),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1414),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1416),
    [anon_sym_BQUOTE] = ACTIONS(1418),
    [anon_sym_LT_LPAREN] = ACTIONS(1420),
    [anon_sym_GT_LPAREN] = ACTIONS(1420),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1412),
  },
  [3920] = {
    [sym_string] = STATE(4164),
    [anon_sym_DASH] = ACTIONS(9392),
    [anon_sym_DOLLAR] = ACTIONS(9392),
    [anon_sym_DQUOTE] = ACTIONS(8880),
    [sym_raw_string] = ACTIONS(9394),
    [anon_sym_POUND] = ACTIONS(9392),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(9396),
    [anon_sym_STAR] = ACTIONS(9398),
    [anon_sym_AT] = ACTIONS(9398),
    [anon_sym_QMARK] = ACTIONS(9398),
    [anon_sym_0] = ACTIONS(9396),
    [anon_sym__] = ACTIONS(9396),
  },
  [3921] = {
    [aux_sym_concatenation_repeat1] = STATE(4167),
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(9400),
    [sym_variable_name] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_esac] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [3922] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(4170),
    [anon_sym_DOLLAR] = ACTIONS(9402),
    [anon_sym_DQUOTE] = ACTIONS(9404),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [3923] = {
    [aux_sym_concatenation_repeat1] = STATE(4167),
    [sym__simple_heredoc_body] = ACTIONS(1400),
    [sym__heredoc_body_beginning] = ACTIONS(1400),
    [sym_file_descriptor] = ACTIONS(1400),
    [sym__concat] = ACTIONS(9400),
    [sym_variable_name] = ACTIONS(1400),
    [anon_sym_SEMI] = ACTIONS(1402),
    [anon_sym_esac] = ACTIONS(1402),
    [anon_sym_PIPE] = ACTIONS(1402),
    [anon_sym_SEMI_SEMI] = ACTIONS(1400),
    [anon_sym_PIPE_AMP] = ACTIONS(1400),
    [anon_sym_AMP_AMP] = ACTIONS(1400),
    [anon_sym_PIPE_PIPE] = ACTIONS(1400),
    [anon_sym_LT] = ACTIONS(1402),
    [anon_sym_GT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT] = ACTIONS(1402),
    [anon_sym_AMP_GT_GT] = ACTIONS(1400),
    [anon_sym_LT_AMP] = ACTIONS(1400),
    [anon_sym_GT_AMP] = ACTIONS(1400),
    [anon_sym_LT_LT] = ACTIONS(1402),
    [anon_sym_LT_LT_DASH] = ACTIONS(1400),
    [anon_sym_LT_LT_LT] = ACTIONS(1400),
    [anon_sym_DOLLAR] = ACTIONS(1402),
    [sym__special_character] = ACTIONS(1400),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1400),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1400),
    [anon_sym_BQUOTE] = ACTIONS(1400),
    [anon_sym_LT_LPAREN] = ACTIONS(1400),
    [anon_sym_GT_LPAREN] = ACTIONS(1400),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1402),
    [anon_sym_LF] = ACTIONS(1400),
    [anon_sym_AMP] = ACTIONS(1402),
  },
  [3924] = {
    [sym_subscript] = STATE(4174),
    [sym_variable_name] = ACTIONS(9406),
    [anon_sym_BANG] = ACTIONS(9408),
    [anon_sym_DASH] = ACTIONS(9410),
    [anon_sym_DOLLAR] = ACTIONS(9410),
    [anon_sym_POUND] = ACTIONS(9408),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(9412),
    [anon_sym_STAR] = ACTIONS(9414),
    [anon_sym_AT] = ACTIONS(9414),
    [anon_sym_QMARK] = ACTIONS(9414),
    [anon_sym_0] = ACTIONS(9412),
    [anon_sym__] = ACTIONS(9412),
  },
  [3925] = {
    [sym__statements] = STATE(4175),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(4176),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [3926] = {
    [sym__statements] = STATE(4177),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [3927] = {
    [sym__statements] = STATE(4178),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [3928] = {
    [aux_sym__literal_repeat1] = STATE(4180),
    [sym__simple_heredoc_body] = ACTIONS(1446),
    [sym__heredoc_body_beginning] = ACTIONS(1446),
    [sym_file_descriptor] = ACTIONS(1446),
    [sym_variable_name] = ACTIONS(1446),
    [anon_sym_SEMI] = ACTIONS(1448),
    [anon_sym_esac] = ACTIONS(1448),
    [anon_sym_PIPE] = ACTIONS(1448),
    [anon_sym_SEMI_SEMI] = ACTIONS(1446),
    [anon_sym_PIPE_AMP] = ACTIONS(1446),
    [anon_sym_AMP_AMP] = ACTIONS(1446),
    [anon_sym_PIPE_PIPE] = ACTIONS(1446),
    [anon_sym_LT] = ACTIONS(1448),
    [anon_sym_GT] = ACTIONS(1448),
    [anon_sym_GT_GT] = ACTIONS(1446),
    [anon_sym_AMP_GT] = ACTIONS(1448),
    [anon_sym_AMP_GT_GT] = ACTIONS(1446),
    [anon_sym_LT_AMP] = ACTIONS(1446),
    [anon_sym_GT_AMP] = ACTIONS(1446),
    [anon_sym_LT_LT] = ACTIONS(1448),
    [anon_sym_LT_LT_DASH] = ACTIONS(1446),
    [anon_sym_LT_LT_LT] = ACTIONS(1446),
    [anon_sym_DOLLAR] = ACTIONS(1448),
    [sym__special_character] = ACTIONS(9416),
    [anon_sym_DQUOTE] = ACTIONS(1446),
    [sym_raw_string] = ACTIONS(1446),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1446),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1446),
    [anon_sym_BQUOTE] = ACTIONS(1446),
    [anon_sym_LT_LPAREN] = ACTIONS(1446),
    [anon_sym_GT_LPAREN] = ACTIONS(1446),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1448),
    [anon_sym_LF] = ACTIONS(1446),
    [anon_sym_AMP] = ACTIONS(1448),
  },
  [3929] = {
    [sym_concatenation] = STATE(4181),
    [sym_string] = STATE(4183),
    [sym_array] = STATE(4181),
    [sym_simple_expansion] = STATE(4183),
    [sym_string_expansion] = STATE(4183),
    [sym_expansion] = STATE(4183),
    [sym_command_substitution] = STATE(4183),
    [sym_process_substitution] = STATE(4183),
    [aux_sym__literal_repeat1] = STATE(4184),
    [sym__empty_value] = ACTIONS(9418),
    [anon_sym_LPAREN] = ACTIONS(9420),
    [anon_sym_DOLLAR] = ACTIONS(8087),
    [sym__special_character] = ACTIONS(8089),
    [anon_sym_DQUOTE] = ACTIONS(8091),
    [sym_raw_string] = ACTIONS(9422),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8097),
    [anon_sym_BQUOTE] = ACTIONS(8099),
    [anon_sym_LT_LPAREN] = ACTIONS(8101),
    [anon_sym_GT_LPAREN] = ACTIONS(8101),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9422),
  },
  [3930] = {
    [sym__simple_heredoc_body] = ACTIONS(1057),
    [sym__heredoc_body_beginning] = ACTIONS(1057),
    [sym_file_descriptor] = ACTIONS(1057),
    [sym__concat] = ACTIONS(1057),
    [sym_variable_name] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_esac] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_PIPE_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_AMP] = ACTIONS(1057),
    [anon_sym_GT_AMP] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_LT] = ACTIONS(1057),
    [anon_sym_DOLLAR] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [sym_raw_string] = ACTIONS(1057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1057),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1057),
    [anon_sym_BQUOTE] = ACTIONS(1057),
    [anon_sym_LT_LPAREN] = ACTIONS(1057),
    [anon_sym_GT_LPAREN] = ACTIONS(1057),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1059),
    [sym_word] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [3931] = {
    [sym__simple_heredoc_body] = ACTIONS(1061),
    [sym__heredoc_body_beginning] = ACTIONS(1061),
    [sym_file_descriptor] = ACTIONS(1061),
    [sym__concat] = ACTIONS(1061),
    [sym_variable_name] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(1063),
    [anon_sym_esac] = ACTIONS(1063),
    [anon_sym_PIPE] = ACTIONS(1063),
    [anon_sym_SEMI_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE_AMP] = ACTIONS(1061),
    [anon_sym_AMP_AMP] = ACTIONS(1061),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1063),
    [anon_sym_GT_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT_GT] = ACTIONS(1061),
    [anon_sym_LT_AMP] = ACTIONS(1061),
    [anon_sym_GT_AMP] = ACTIONS(1061),
    [anon_sym_LT_LT] = ACTIONS(1063),
    [anon_sym_LT_LT_DASH] = ACTIONS(1061),
    [anon_sym_LT_LT_LT] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1061),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1061),
    [anon_sym_LT_LPAREN] = ACTIONS(1061),
    [anon_sym_GT_LPAREN] = ACTIONS(1061),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1063),
    [sym_word] = ACTIONS(1063),
    [anon_sym_LF] = ACTIONS(1061),
    [anon_sym_AMP] = ACTIONS(1063),
  },
  [3932] = {
    [sym__simple_heredoc_body] = ACTIONS(1065),
    [sym__heredoc_body_beginning] = ACTIONS(1065),
    [sym_file_descriptor] = ACTIONS(1065),
    [sym__concat] = ACTIONS(1065),
    [sym_variable_name] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_esac] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1067),
    [anon_sym_SEMI_SEMI] = ACTIONS(1065),
    [anon_sym_PIPE_AMP] = ACTIONS(1065),
    [anon_sym_AMP_AMP] = ACTIONS(1065),
    [anon_sym_PIPE_PIPE] = ACTIONS(1065),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_GT] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT] = ACTIONS(1067),
    [anon_sym_AMP_GT_GT] = ACTIONS(1065),
    [anon_sym_LT_AMP] = ACTIONS(1065),
    [anon_sym_GT_AMP] = ACTIONS(1065),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_LT_LT_DASH] = ACTIONS(1065),
    [anon_sym_LT_LT_LT] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1067),
    [sym__special_character] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LT_LPAREN] = ACTIONS(1065),
    [anon_sym_GT_LPAREN] = ACTIONS(1065),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1067),
    [sym_word] = ACTIONS(1067),
    [anon_sym_LF] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1067),
  },
  [3933] = {
    [sym_string] = STATE(4185),
    [sym_simple_expansion] = STATE(4185),
    [sym_string_expansion] = STATE(4185),
    [sym_expansion] = STATE(4185),
    [sym_command_substitution] = STATE(4185),
    [sym_process_substitution] = STATE(4185),
    [anon_sym_DOLLAR] = ACTIONS(8087),
    [sym__special_character] = ACTIONS(9424),
    [anon_sym_DQUOTE] = ACTIONS(8091),
    [sym_raw_string] = ACTIONS(9424),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8097),
    [anon_sym_BQUOTE] = ACTIONS(8099),
    [anon_sym_LT_LPAREN] = ACTIONS(8101),
    [anon_sym_GT_LPAREN] = ACTIONS(8101),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9424),
  },
  [3934] = {
    [aux_sym_concatenation_repeat1] = STATE(4187),
    [sym__simple_heredoc_body] = ACTIONS(1071),
    [sym__heredoc_body_beginning] = ACTIONS(1071),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(9426),
    [sym_variable_name] = ACTIONS(1071),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_esac] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [sym__special_character] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [sym_word] = ACTIONS(1075),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1075),
  },
  [3935] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(9428),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [3936] = {
    [sym__simple_heredoc_body] = ACTIONS(1089),
    [sym__heredoc_body_beginning] = ACTIONS(1089),
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(1089),
    [sym_variable_name] = ACTIONS(1089),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_esac] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1089),
    [anon_sym_PIPE_AMP] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_AMP] = ACTIONS(1089),
    [anon_sym_GT_AMP] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1089),
    [anon_sym_LT_LT_LT] = ACTIONS(1089),
    [anon_sym_DOLLAR] = ACTIONS(1091),
    [sym__special_character] = ACTIONS(1089),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1089),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1089),
    [anon_sym_GT_LPAREN] = ACTIONS(1089),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1091),
    [sym_word] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [3937] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(627),
    [anon_sym_DOLLAR] = ACTIONS(9430),
    [anon_sym_DQUOTE] = ACTIONS(9428),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [3938] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(9432),
    [sym_comment] = ACTIONS(57),
  },
  [3939] = {
    [sym_subscript] = STATE(4193),
    [sym_variable_name] = ACTIONS(9434),
    [anon_sym_DASH] = ACTIONS(9436),
    [anon_sym_DOLLAR] = ACTIONS(9436),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(9438),
    [anon_sym_STAR] = ACTIONS(9440),
    [anon_sym_AT] = ACTIONS(9440),
    [anon_sym_QMARK] = ACTIONS(9440),
    [anon_sym_0] = ACTIONS(9438),
    [anon_sym__] = ACTIONS(9438),
  },
  [3940] = {
    [sym_concatenation] = STATE(4196),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4196),
    [anon_sym_RBRACE] = ACTIONS(9442),
    [anon_sym_EQ] = ACTIONS(9444),
    [anon_sym_DASH] = ACTIONS(9444),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9446),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(9448),
    [anon_sym_COLON] = ACTIONS(9444),
    [anon_sym_COLON_QMARK] = ACTIONS(9444),
    [anon_sym_COLON_DASH] = ACTIONS(9444),
    [anon_sym_PERCENT] = ACTIONS(9444),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3941] = {
    [sym_concatenation] = STATE(4199),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4199),
    [anon_sym_RBRACE] = ACTIONS(9450),
    [anon_sym_EQ] = ACTIONS(9452),
    [anon_sym_DASH] = ACTIONS(9452),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(9456),
    [anon_sym_COLON] = ACTIONS(9452),
    [anon_sym_COLON_QMARK] = ACTIONS(9452),
    [anon_sym_COLON_DASH] = ACTIONS(9452),
    [anon_sym_PERCENT] = ACTIONS(9452),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3942] = {
    [anon_sym_RPAREN] = ACTIONS(9458),
    [sym_comment] = ACTIONS(57),
  },
  [3943] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(9458),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [3944] = {
    [anon_sym_BQUOTE] = ACTIONS(9458),
    [sym_comment] = ACTIONS(57),
  },
  [3945] = {
    [anon_sym_RPAREN] = ACTIONS(9460),
    [sym_comment] = ACTIONS(57),
  },
  [3946] = {
    [sym_variable_assignment] = STATE(3946),
    [sym_subscript] = STATE(3579),
    [sym_concatenation] = STATE(3946),
    [sym_string] = STATE(3574),
    [sym_simple_expansion] = STATE(3574),
    [sym_string_expansion] = STATE(3574),
    [sym_expansion] = STATE(3574),
    [sym_command_substitution] = STATE(3574),
    [sym_process_substitution] = STATE(3574),
    [aux_sym_declaration_command_repeat1] = STATE(3946),
    [aux_sym__literal_repeat1] = STATE(3581),
    [sym__simple_heredoc_body] = ACTIONS(2206),
    [sym__heredoc_body_beginning] = ACTIONS(2206),
    [sym_file_descriptor] = ACTIONS(2206),
    [sym_variable_name] = ACTIONS(9462),
    [anon_sym_SEMI] = ACTIONS(2211),
    [anon_sym_esac] = ACTIONS(2211),
    [anon_sym_PIPE] = ACTIONS(2211),
    [anon_sym_SEMI_SEMI] = ACTIONS(2206),
    [anon_sym_PIPE_AMP] = ACTIONS(2206),
    [anon_sym_AMP_AMP] = ACTIONS(2206),
    [anon_sym_PIPE_PIPE] = ACTIONS(2206),
    [anon_sym_LT] = ACTIONS(2211),
    [anon_sym_GT] = ACTIONS(2211),
    [anon_sym_GT_GT] = ACTIONS(2206),
    [anon_sym_AMP_GT] = ACTIONS(2211),
    [anon_sym_AMP_GT_GT] = ACTIONS(2206),
    [anon_sym_LT_AMP] = ACTIONS(2206),
    [anon_sym_GT_AMP] = ACTIONS(2206),
    [anon_sym_LT_LT] = ACTIONS(2211),
    [anon_sym_LT_LT_DASH] = ACTIONS(2206),
    [anon_sym_LT_LT_LT] = ACTIONS(2206),
    [anon_sym_DOLLAR] = ACTIONS(9465),
    [sym__special_character] = ACTIONS(9468),
    [anon_sym_DQUOTE] = ACTIONS(9471),
    [sym_raw_string] = ACTIONS(9474),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(9477),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(9480),
    [anon_sym_BQUOTE] = ACTIONS(9483),
    [anon_sym_LT_LPAREN] = ACTIONS(9486),
    [anon_sym_GT_LPAREN] = ACTIONS(9486),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(9489),
    [sym_word] = ACTIONS(9492),
    [anon_sym_LF] = ACTIONS(2206),
    [anon_sym_AMP] = ACTIONS(2211),
  },
  [3947] = {
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym_variable_name] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_esac] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(339),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [3948] = {
    [aux_sym__literal_repeat1] = STATE(3948),
    [sym__simple_heredoc_body] = ACTIONS(1373),
    [sym__heredoc_body_beginning] = ACTIONS(1373),
    [sym_file_descriptor] = ACTIONS(1373),
    [sym_variable_name] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_esac] = ACTIONS(1375),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE_AMP] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_LT_LT_DASH] = ACTIONS(1373),
    [anon_sym_LT_LT_LT] = ACTIONS(1373),
    [anon_sym_DOLLAR] = ACTIONS(1375),
    [sym__special_character] = ACTIONS(9495),
    [anon_sym_DQUOTE] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1373),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [anon_sym_LT_LPAREN] = ACTIONS(1373),
    [anon_sym_GT_LPAREN] = ACTIONS(1373),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1375),
    [sym_word] = ACTIONS(1375),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
  },
  [3949] = {
    [sym__simple_heredoc_body] = ACTIONS(1057),
    [sym__heredoc_body_beginning] = ACTIONS(1057),
    [sym_file_descriptor] = ACTIONS(1057),
    [sym__concat] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_esac] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_PIPE_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_AMP] = ACTIONS(1057),
    [anon_sym_GT_AMP] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_LT] = ACTIONS(1057),
    [anon_sym_DOLLAR] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [sym_raw_string] = ACTIONS(1057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1057),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1057),
    [anon_sym_BQUOTE] = ACTIONS(1057),
    [anon_sym_LT_LPAREN] = ACTIONS(1057),
    [anon_sym_GT_LPAREN] = ACTIONS(1057),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1059),
    [sym_word] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [3950] = {
    [sym__simple_heredoc_body] = ACTIONS(1061),
    [sym__heredoc_body_beginning] = ACTIONS(1061),
    [sym_file_descriptor] = ACTIONS(1061),
    [sym__concat] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(1063),
    [anon_sym_esac] = ACTIONS(1063),
    [anon_sym_PIPE] = ACTIONS(1063),
    [anon_sym_SEMI_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE_AMP] = ACTIONS(1061),
    [anon_sym_AMP_AMP] = ACTIONS(1061),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1063),
    [anon_sym_GT_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT_GT] = ACTIONS(1061),
    [anon_sym_LT_AMP] = ACTIONS(1061),
    [anon_sym_GT_AMP] = ACTIONS(1061),
    [anon_sym_LT_LT] = ACTIONS(1063),
    [anon_sym_LT_LT_DASH] = ACTIONS(1061),
    [anon_sym_LT_LT_LT] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1061),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1061),
    [anon_sym_LT_LPAREN] = ACTIONS(1061),
    [anon_sym_GT_LPAREN] = ACTIONS(1061),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1063),
    [sym_word] = ACTIONS(1063),
    [anon_sym_LF] = ACTIONS(1061),
    [anon_sym_AMP] = ACTIONS(1063),
  },
  [3951] = {
    [sym__simple_heredoc_body] = ACTIONS(1065),
    [sym__heredoc_body_beginning] = ACTIONS(1065),
    [sym_file_descriptor] = ACTIONS(1065),
    [sym__concat] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_esac] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1067),
    [anon_sym_SEMI_SEMI] = ACTIONS(1065),
    [anon_sym_PIPE_AMP] = ACTIONS(1065),
    [anon_sym_AMP_AMP] = ACTIONS(1065),
    [anon_sym_PIPE_PIPE] = ACTIONS(1065),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_GT] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT] = ACTIONS(1067),
    [anon_sym_AMP_GT_GT] = ACTIONS(1065),
    [anon_sym_LT_AMP] = ACTIONS(1065),
    [anon_sym_GT_AMP] = ACTIONS(1065),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_LT_LT_DASH] = ACTIONS(1065),
    [anon_sym_LT_LT_LT] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1067),
    [sym__special_character] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LT_LPAREN] = ACTIONS(1065),
    [anon_sym_GT_LPAREN] = ACTIONS(1065),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1067),
    [sym_word] = ACTIONS(1067),
    [anon_sym_LF] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1067),
  },
  [3952] = {
    [sym_string] = STATE(4202),
    [sym_simple_expansion] = STATE(4202),
    [sym_string_expansion] = STATE(4202),
    [sym_expansion] = STATE(4202),
    [sym_command_substitution] = STATE(4202),
    [sym_process_substitution] = STATE(4202),
    [anon_sym_DOLLAR] = ACTIONS(8107),
    [sym__special_character] = ACTIONS(9498),
    [anon_sym_DQUOTE] = ACTIONS(8111),
    [sym_raw_string] = ACTIONS(9498),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8115),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8117),
    [anon_sym_BQUOTE] = ACTIONS(8119),
    [anon_sym_LT_LPAREN] = ACTIONS(8121),
    [anon_sym_GT_LPAREN] = ACTIONS(8121),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9498),
  },
  [3953] = {
    [aux_sym_concatenation_repeat1] = STATE(4204),
    [sym__simple_heredoc_body] = ACTIONS(1071),
    [sym__heredoc_body_beginning] = ACTIONS(1071),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(9500),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_esac] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [sym__special_character] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [sym_word] = ACTIONS(1075),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1075),
  },
  [3954] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(9502),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [3955] = {
    [sym__simple_heredoc_body] = ACTIONS(1089),
    [sym__heredoc_body_beginning] = ACTIONS(1089),
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(1089),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_esac] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1089),
    [anon_sym_PIPE_AMP] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_AMP] = ACTIONS(1089),
    [anon_sym_GT_AMP] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1089),
    [anon_sym_LT_LT_LT] = ACTIONS(1089),
    [anon_sym_DOLLAR] = ACTIONS(1091),
    [sym__special_character] = ACTIONS(1089),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1089),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1089),
    [anon_sym_GT_LPAREN] = ACTIONS(1089),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1091),
    [sym_word] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [3956] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(627),
    [anon_sym_DOLLAR] = ACTIONS(9504),
    [anon_sym_DQUOTE] = ACTIONS(9502),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [3957] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(9506),
    [sym_comment] = ACTIONS(57),
  },
  [3958] = {
    [sym_subscript] = STATE(4210),
    [sym_variable_name] = ACTIONS(9508),
    [anon_sym_DASH] = ACTIONS(9510),
    [anon_sym_DOLLAR] = ACTIONS(9510),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(9512),
    [anon_sym_STAR] = ACTIONS(9514),
    [anon_sym_AT] = ACTIONS(9514),
    [anon_sym_QMARK] = ACTIONS(9514),
    [anon_sym_0] = ACTIONS(9512),
    [anon_sym__] = ACTIONS(9512),
  },
  [3959] = {
    [sym_concatenation] = STATE(4213),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4213),
    [anon_sym_RBRACE] = ACTIONS(9516),
    [anon_sym_EQ] = ACTIONS(9518),
    [anon_sym_DASH] = ACTIONS(9518),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(9522),
    [anon_sym_COLON] = ACTIONS(9518),
    [anon_sym_COLON_QMARK] = ACTIONS(9518),
    [anon_sym_COLON_DASH] = ACTIONS(9518),
    [anon_sym_PERCENT] = ACTIONS(9518),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3960] = {
    [sym_concatenation] = STATE(4216),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4216),
    [anon_sym_RBRACE] = ACTIONS(9524),
    [anon_sym_EQ] = ACTIONS(9526),
    [anon_sym_DASH] = ACTIONS(9526),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9528),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(9530),
    [anon_sym_COLON] = ACTIONS(9526),
    [anon_sym_COLON_QMARK] = ACTIONS(9526),
    [anon_sym_COLON_DASH] = ACTIONS(9526),
    [anon_sym_PERCENT] = ACTIONS(9526),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3961] = {
    [anon_sym_RPAREN] = ACTIONS(9532),
    [sym_comment] = ACTIONS(57),
  },
  [3962] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(9532),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [3963] = {
    [anon_sym_BQUOTE] = ACTIONS(9532),
    [sym_comment] = ACTIONS(57),
  },
  [3964] = {
    [anon_sym_RPAREN] = ACTIONS(9534),
    [sym_comment] = ACTIONS(57),
  },
  [3965] = {
    [sym_concatenation] = STATE(3965),
    [sym_string] = STATE(3585),
    [sym_simple_expansion] = STATE(3585),
    [sym_string_expansion] = STATE(3585),
    [sym_expansion] = STATE(3585),
    [sym_command_substitution] = STATE(3585),
    [sym_process_substitution] = STATE(3585),
    [aux_sym_unset_command_repeat1] = STATE(3965),
    [aux_sym__literal_repeat1] = STATE(3591),
    [sym__simple_heredoc_body] = ACTIONS(2284),
    [sym__heredoc_body_beginning] = ACTIONS(2284),
    [sym_file_descriptor] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym_esac] = ACTIONS(2286),
    [anon_sym_PIPE] = ACTIONS(2286),
    [anon_sym_SEMI_SEMI] = ACTIONS(2284),
    [anon_sym_PIPE_AMP] = ACTIONS(2284),
    [anon_sym_AMP_AMP] = ACTIONS(2284),
    [anon_sym_PIPE_PIPE] = ACTIONS(2284),
    [anon_sym_LT] = ACTIONS(2286),
    [anon_sym_GT] = ACTIONS(2286),
    [anon_sym_GT_GT] = ACTIONS(2284),
    [anon_sym_AMP_GT] = ACTIONS(2286),
    [anon_sym_AMP_GT_GT] = ACTIONS(2284),
    [anon_sym_LT_AMP] = ACTIONS(2284),
    [anon_sym_GT_AMP] = ACTIONS(2284),
    [anon_sym_LT_LT] = ACTIONS(2286),
    [anon_sym_LT_LT_DASH] = ACTIONS(2284),
    [anon_sym_LT_LT_LT] = ACTIONS(2284),
    [anon_sym_DOLLAR] = ACTIONS(9536),
    [sym__special_character] = ACTIONS(9539),
    [anon_sym_DQUOTE] = ACTIONS(9542),
    [sym_raw_string] = ACTIONS(9545),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(9548),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(9551),
    [anon_sym_BQUOTE] = ACTIONS(9554),
    [anon_sym_LT_LPAREN] = ACTIONS(9557),
    [anon_sym_GT_LPAREN] = ACTIONS(9557),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(9560),
    [sym_word] = ACTIONS(9563),
    [anon_sym_LF] = ACTIONS(2284),
    [anon_sym_AMP] = ACTIONS(2286),
  },
  [3966] = {
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_esac] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(339),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [3967] = {
    [aux_sym__literal_repeat1] = STATE(3967),
    [sym__simple_heredoc_body] = ACTIONS(1373),
    [sym__heredoc_body_beginning] = ACTIONS(1373),
    [sym_file_descriptor] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_esac] = ACTIONS(1375),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE_AMP] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_LT_LT_DASH] = ACTIONS(1373),
    [anon_sym_LT_LT_LT] = ACTIONS(1373),
    [anon_sym_DOLLAR] = ACTIONS(1375),
    [sym__special_character] = ACTIONS(9566),
    [anon_sym_DQUOTE] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1373),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [anon_sym_LT_LPAREN] = ACTIONS(1373),
    [anon_sym_GT_LPAREN] = ACTIONS(1373),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1375),
    [sym_word] = ACTIONS(1375),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
  },
  [3968] = {
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_esac] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_EQ_TILDE] = ACTIONS(2364),
    [anon_sym_EQ_EQ] = ACTIONS(2364),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [3969] = {
    [sym_string] = STATE(3968),
    [sym_simple_expansion] = STATE(3968),
    [sym_string_expansion] = STATE(3968),
    [sym_expansion] = STATE(3968),
    [sym_command_substitution] = STATE(3968),
    [sym_process_substitution] = STATE(3968),
    [anon_sym_DOLLAR] = ACTIONS(9569),
    [sym__special_character] = ACTIONS(8950),
    [anon_sym_DQUOTE] = ACTIONS(6868),
    [sym_raw_string] = ACTIONS(8950),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6874),
    [anon_sym_BQUOTE] = ACTIONS(6876),
    [anon_sym_LT_LPAREN] = ACTIONS(6878),
    [anon_sym_GT_LPAREN] = ACTIONS(6878),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8950),
  },
  [3970] = {
    [aux_sym_concatenation_repeat1] = STATE(3970),
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(9571),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_esac] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_EQ_TILDE] = ACTIONS(2364),
    [anon_sym_EQ_EQ] = ACTIONS(2364),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [3971] = {
    [sym__simple_heredoc_body] = ACTIONS(2371),
    [sym__heredoc_body_beginning] = ACTIONS(2371),
    [sym_file_descriptor] = ACTIONS(2371),
    [sym__concat] = ACTIONS(2371),
    [anon_sym_SEMI] = ACTIONS(2373),
    [anon_sym_esac] = ACTIONS(2373),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_SEMI_SEMI] = ACTIONS(2371),
    [anon_sym_PIPE_AMP] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_EQ_TILDE] = ACTIONS(2373),
    [anon_sym_EQ_EQ] = ACTIONS(2373),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_GT_GT] = ACTIONS(2371),
    [anon_sym_AMP_GT] = ACTIONS(2373),
    [anon_sym_AMP_GT_GT] = ACTIONS(2371),
    [anon_sym_LT_AMP] = ACTIONS(2371),
    [anon_sym_GT_AMP] = ACTIONS(2371),
    [anon_sym_LT_LT] = ACTIONS(2373),
    [anon_sym_LT_LT_DASH] = ACTIONS(2371),
    [anon_sym_LT_LT_LT] = ACTIONS(2371),
    [anon_sym_DOLLAR] = ACTIONS(2373),
    [sym__special_character] = ACTIONS(2371),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [sym_raw_string] = ACTIONS(2371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2371),
    [anon_sym_BQUOTE] = ACTIONS(2371),
    [anon_sym_LT_LPAREN] = ACTIONS(2371),
    [anon_sym_GT_LPAREN] = ACTIONS(2371),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2373),
    [anon_sym_LF] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
  },
  [3972] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(9574),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [3973] = {
    [sym_concatenation] = STATE(4223),
    [sym_string] = STATE(4222),
    [sym_simple_expansion] = STATE(4222),
    [sym_string_expansion] = STATE(4222),
    [sym_expansion] = STATE(4222),
    [sym_command_substitution] = STATE(4222),
    [sym_process_substitution] = STATE(4222),
    [aux_sym__literal_repeat1] = STATE(4224),
    [anon_sym_RBRACE] = ACTIONS(9576),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(9578),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9578),
  },
  [3974] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(9580),
    [sym_comment] = ACTIONS(57),
  },
  [3975] = {
    [sym_concatenation] = STATE(4228),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4228),
    [anon_sym_RBRACE] = ACTIONS(9582),
    [anon_sym_EQ] = ACTIONS(9584),
    [anon_sym_DASH] = ACTIONS(9584),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(9588),
    [anon_sym_COLON] = ACTIONS(9584),
    [anon_sym_COLON_QMARK] = ACTIONS(9584),
    [anon_sym_COLON_DASH] = ACTIONS(9584),
    [anon_sym_PERCENT] = ACTIONS(9584),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3976] = {
    [sym_concatenation] = STATE(4230),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4230),
    [anon_sym_RBRACE] = ACTIONS(9576),
    [anon_sym_EQ] = ACTIONS(9590),
    [anon_sym_DASH] = ACTIONS(9590),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9592),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(9594),
    [anon_sym_COLON] = ACTIONS(9590),
    [anon_sym_COLON_QMARK] = ACTIONS(9590),
    [anon_sym_COLON_DASH] = ACTIONS(9590),
    [anon_sym_PERCENT] = ACTIONS(9590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3977] = {
    [sym__simple_heredoc_body] = ACTIONS(2462),
    [sym__heredoc_body_beginning] = ACTIONS(2462),
    [sym_file_descriptor] = ACTIONS(2462),
    [sym__concat] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_esac] = ACTIONS(2464),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_SEMI_SEMI] = ACTIONS(2462),
    [anon_sym_PIPE_AMP] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_EQ_TILDE] = ACTIONS(2464),
    [anon_sym_EQ_EQ] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_GT_GT] = ACTIONS(2462),
    [anon_sym_AMP_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT_GT] = ACTIONS(2462),
    [anon_sym_LT_AMP] = ACTIONS(2462),
    [anon_sym_GT_AMP] = ACTIONS(2462),
    [anon_sym_LT_LT] = ACTIONS(2464),
    [anon_sym_LT_LT_DASH] = ACTIONS(2462),
    [anon_sym_LT_LT_LT] = ACTIONS(2462),
    [anon_sym_DOLLAR] = ACTIONS(2464),
    [sym__special_character] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [sym_raw_string] = ACTIONS(2462),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2462),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2462),
    [anon_sym_BQUOTE] = ACTIONS(2462),
    [anon_sym_LT_LPAREN] = ACTIONS(2462),
    [anon_sym_GT_LPAREN] = ACTIONS(2462),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2464),
    [anon_sym_LF] = ACTIONS(2462),
    [anon_sym_AMP] = ACTIONS(2464),
  },
  [3978] = {
    [sym_concatenation] = STATE(4233),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4233),
    [sym_regex] = ACTIONS(9596),
    [anon_sym_RBRACE] = ACTIONS(9598),
    [anon_sym_EQ] = ACTIONS(9600),
    [anon_sym_DASH] = ACTIONS(9600),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9602),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9600),
    [anon_sym_COLON_QMARK] = ACTIONS(9600),
    [anon_sym_COLON_DASH] = ACTIONS(9600),
    [anon_sym_PERCENT] = ACTIONS(9600),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3979] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9598),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3980] = {
    [sym__simple_heredoc_body] = ACTIONS(2512),
    [sym__heredoc_body_beginning] = ACTIONS(2512),
    [sym_file_descriptor] = ACTIONS(2512),
    [sym__concat] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2514),
    [anon_sym_esac] = ACTIONS(2514),
    [anon_sym_PIPE] = ACTIONS(2514),
    [anon_sym_SEMI_SEMI] = ACTIONS(2512),
    [anon_sym_PIPE_AMP] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE_PIPE] = ACTIONS(2512),
    [anon_sym_EQ_TILDE] = ACTIONS(2514),
    [anon_sym_EQ_EQ] = ACTIONS(2514),
    [anon_sym_LT] = ACTIONS(2514),
    [anon_sym_GT] = ACTIONS(2514),
    [anon_sym_GT_GT] = ACTIONS(2512),
    [anon_sym_AMP_GT] = ACTIONS(2514),
    [anon_sym_AMP_GT_GT] = ACTIONS(2512),
    [anon_sym_LT_AMP] = ACTIONS(2512),
    [anon_sym_GT_AMP] = ACTIONS(2512),
    [anon_sym_LT_LT] = ACTIONS(2514),
    [anon_sym_LT_LT_DASH] = ACTIONS(2512),
    [anon_sym_LT_LT_LT] = ACTIONS(2512),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [sym__special_character] = ACTIONS(2512),
    [anon_sym_DQUOTE] = ACTIONS(2512),
    [sym_raw_string] = ACTIONS(2512),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2512),
    [anon_sym_BQUOTE] = ACTIONS(2512),
    [anon_sym_LT_LPAREN] = ACTIONS(2512),
    [anon_sym_GT_LPAREN] = ACTIONS(2512),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2514),
    [anon_sym_LF] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2514),
  },
  [3981] = {
    [sym_concatenation] = STATE(4230),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4230),
    [sym_regex] = ACTIONS(9604),
    [anon_sym_RBRACE] = ACTIONS(9576),
    [anon_sym_EQ] = ACTIONS(9590),
    [anon_sym_DASH] = ACTIONS(9590),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9592),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9590),
    [anon_sym_COLON_QMARK] = ACTIONS(9590),
    [anon_sym_COLON_DASH] = ACTIONS(9590),
    [anon_sym_PERCENT] = ACTIONS(9590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3982] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9576),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [3983] = {
    [sym__simple_heredoc_body] = ACTIONS(2520),
    [sym__heredoc_body_beginning] = ACTIONS(2520),
    [sym_file_descriptor] = ACTIONS(2520),
    [sym__concat] = ACTIONS(2520),
    [anon_sym_SEMI] = ACTIONS(2522),
    [anon_sym_esac] = ACTIONS(2522),
    [anon_sym_PIPE] = ACTIONS(2522),
    [anon_sym_SEMI_SEMI] = ACTIONS(2520),
    [anon_sym_PIPE_AMP] = ACTIONS(2520),
    [anon_sym_AMP_AMP] = ACTIONS(2520),
    [anon_sym_PIPE_PIPE] = ACTIONS(2520),
    [anon_sym_EQ_TILDE] = ACTIONS(2522),
    [anon_sym_EQ_EQ] = ACTIONS(2522),
    [anon_sym_LT] = ACTIONS(2522),
    [anon_sym_GT] = ACTIONS(2522),
    [anon_sym_GT_GT] = ACTIONS(2520),
    [anon_sym_AMP_GT] = ACTIONS(2522),
    [anon_sym_AMP_GT_GT] = ACTIONS(2520),
    [anon_sym_LT_AMP] = ACTIONS(2520),
    [anon_sym_GT_AMP] = ACTIONS(2520),
    [anon_sym_LT_LT] = ACTIONS(2522),
    [anon_sym_LT_LT_DASH] = ACTIONS(2520),
    [anon_sym_LT_LT_LT] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(2522),
    [sym__special_character] = ACTIONS(2520),
    [anon_sym_DQUOTE] = ACTIONS(2520),
    [sym_raw_string] = ACTIONS(2520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2520),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2520),
    [anon_sym_BQUOTE] = ACTIONS(2520),
    [anon_sym_LT_LPAREN] = ACTIONS(2520),
    [anon_sym_GT_LPAREN] = ACTIONS(2520),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2522),
    [anon_sym_LF] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2522),
  },
  [3984] = {
    [sym__simple_heredoc_body] = ACTIONS(2554),
    [sym__heredoc_body_beginning] = ACTIONS(2554),
    [sym_file_descriptor] = ACTIONS(2554),
    [sym__concat] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(2556),
    [anon_sym_esac] = ACTIONS(2556),
    [anon_sym_PIPE] = ACTIONS(2556),
    [anon_sym_SEMI_SEMI] = ACTIONS(2554),
    [anon_sym_PIPE_AMP] = ACTIONS(2554),
    [anon_sym_AMP_AMP] = ACTIONS(2554),
    [anon_sym_PIPE_PIPE] = ACTIONS(2554),
    [anon_sym_EQ_TILDE] = ACTIONS(2556),
    [anon_sym_EQ_EQ] = ACTIONS(2556),
    [anon_sym_LT] = ACTIONS(2556),
    [anon_sym_GT] = ACTIONS(2556),
    [anon_sym_GT_GT] = ACTIONS(2554),
    [anon_sym_AMP_GT] = ACTIONS(2556),
    [anon_sym_AMP_GT_GT] = ACTIONS(2554),
    [anon_sym_LT_AMP] = ACTIONS(2554),
    [anon_sym_GT_AMP] = ACTIONS(2554),
    [anon_sym_LT_LT] = ACTIONS(2556),
    [anon_sym_LT_LT_DASH] = ACTIONS(2554),
    [anon_sym_LT_LT_LT] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2556),
    [sym__special_character] = ACTIONS(2554),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2554),
    [anon_sym_BQUOTE] = ACTIONS(2554),
    [anon_sym_LT_LPAREN] = ACTIONS(2554),
    [anon_sym_GT_LPAREN] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2556),
    [anon_sym_LF] = ACTIONS(2554),
    [anon_sym_AMP] = ACTIONS(2556),
  },
  [3985] = {
    [sym_concatenation] = STATE(1328),
    [sym_string] = STATE(4235),
    [sym_simple_expansion] = STATE(4235),
    [sym_string_expansion] = STATE(4235),
    [sym_expansion] = STATE(4235),
    [sym_command_substitution] = STATE(4235),
    [sym_process_substitution] = STATE(4235),
    [aux_sym__literal_repeat1] = STATE(4236),
    [anon_sym_DOLLAR] = ACTIONS(4998),
    [sym__special_character] = ACTIONS(8998),
    [anon_sym_DQUOTE] = ACTIONS(5002),
    [sym_raw_string] = ACTIONS(9606),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5006),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5008),
    [anon_sym_BQUOTE] = ACTIONS(5010),
    [anon_sym_LT_LPAREN] = ACTIONS(5012),
    [anon_sym_GT_LPAREN] = ACTIONS(5012),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9606),
  },
  [3986] = {
    [sym_file_redirect] = STATE(3616),
    [sym_heredoc_redirect] = STATE(3616),
    [sym_herestring_redirect] = STATE(3616),
    [aux_sym_redirected_statement_repeat1] = STATE(3616),
    [sym__simple_heredoc_body] = ACTIONS(2584),
    [sym__heredoc_body_beginning] = ACTIONS(2584),
    [sym_file_descriptor] = ACTIONS(2584),
    [anon_sym_SEMI] = ACTIONS(2586),
    [anon_sym_esac] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2586),
    [anon_sym_SEMI_SEMI] = ACTIONS(2584),
    [anon_sym_PIPE_AMP] = ACTIONS(2584),
    [anon_sym_AMP_AMP] = ACTIONS(2584),
    [anon_sym_PIPE_PIPE] = ACTIONS(2584),
    [anon_sym_LT] = ACTIONS(2586),
    [anon_sym_GT] = ACTIONS(2586),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT] = ACTIONS(2586),
    [anon_sym_AMP_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_AMP] = ACTIONS(2584),
    [anon_sym_GT_AMP] = ACTIONS(2584),
    [anon_sym_LT_LT] = ACTIONS(2586),
    [anon_sym_LT_LT_DASH] = ACTIONS(2584),
    [anon_sym_LT_LT_LT] = ACTIONS(2584),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2584),
    [anon_sym_AMP] = ACTIONS(2586),
  },
  [3987] = {
    [sym_file_redirect] = STATE(3616),
    [sym_heredoc_redirect] = STATE(3616),
    [sym_herestring_redirect] = STATE(3616),
    [aux_sym_redirected_statement_repeat1] = STATE(3616),
    [sym__simple_heredoc_body] = ACTIONS(2584),
    [sym__heredoc_body_beginning] = ACTIONS(2584),
    [sym_file_descriptor] = ACTIONS(2584),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2586),
    [anon_sym_esac] = ACTIONS(2586),
    [anon_sym_PIPE] = ACTIONS(2586),
    [anon_sym_SEMI_SEMI] = ACTIONS(2584),
    [anon_sym_PIPE_AMP] = ACTIONS(2584),
    [anon_sym_AMP_AMP] = ACTIONS(2584),
    [anon_sym_PIPE_PIPE] = ACTIONS(2584),
    [anon_sym_LT] = ACTIONS(2586),
    [anon_sym_GT] = ACTIONS(2586),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT] = ACTIONS(2586),
    [anon_sym_AMP_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_AMP] = ACTIONS(2584),
    [anon_sym_GT_AMP] = ACTIONS(2584),
    [anon_sym_LT_LT] = ACTIONS(2586),
    [anon_sym_LT_LT_DASH] = ACTIONS(2584),
    [anon_sym_LT_LT_LT] = ACTIONS(2584),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2584),
    [anon_sym_AMP] = ACTIONS(2586),
  },
  [3988] = {
    [sym_file_redirect] = STATE(3616),
    [sym_heredoc_redirect] = STATE(3616),
    [sym_herestring_redirect] = STATE(3616),
    [aux_sym_redirected_statement_repeat1] = STATE(3616),
    [sym__simple_heredoc_body] = ACTIONS(2588),
    [sym__heredoc_body_beginning] = ACTIONS(2588),
    [sym_file_descriptor] = ACTIONS(2588),
    [anon_sym_SEMI] = ACTIONS(2590),
    [anon_sym_esac] = ACTIONS(2588),
    [anon_sym_PIPE] = ACTIONS(8159),
    [anon_sym_SEMI_SEMI] = ACTIONS(2588),
    [anon_sym_PIPE_AMP] = ACTIONS(8161),
    [anon_sym_AMP_AMP] = ACTIONS(2588),
    [anon_sym_PIPE_PIPE] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(2590),
    [anon_sym_GT] = ACTIONS(2590),
    [anon_sym_GT_GT] = ACTIONS(2588),
    [anon_sym_AMP_GT] = ACTIONS(2590),
    [anon_sym_AMP_GT_GT] = ACTIONS(2588),
    [anon_sym_LT_AMP] = ACTIONS(2588),
    [anon_sym_GT_AMP] = ACTIONS(2588),
    [anon_sym_LT_LT] = ACTIONS(2590),
    [anon_sym_LT_LT_DASH] = ACTIONS(2588),
    [anon_sym_LT_LT_LT] = ACTIONS(2588),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2588),
    [anon_sym_AMP] = ACTIONS(2590),
  },
  [3989] = {
    [sym_file_redirect] = STATE(3616),
    [sym_heredoc_redirect] = STATE(3616),
    [sym_herestring_redirect] = STATE(3616),
    [aux_sym_redirected_statement_repeat1] = STATE(3616),
    [sym__simple_heredoc_body] = ACTIONS(2588),
    [sym__heredoc_body_beginning] = ACTIONS(2588),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2590),
    [anon_sym_esac] = ACTIONS(2590),
    [anon_sym_PIPE] = ACTIONS(8159),
    [anon_sym_SEMI_SEMI] = ACTIONS(2588),
    [anon_sym_PIPE_AMP] = ACTIONS(8161),
    [anon_sym_AMP_AMP] = ACTIONS(2588),
    [anon_sym_PIPE_PIPE] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(2590),
    [anon_sym_LT_LT_DASH] = ACTIONS(2588),
    [anon_sym_LT_LT_LT] = ACTIONS(2588),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2588),
    [anon_sym_AMP] = ACTIONS(2590),
  },
  [3990] = {
    [aux_sym_concatenation_repeat1] = STATE(4237),
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym__concat] = ACTIONS(6367),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_esac] = ACTIONS(335),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [sym__special_character] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [3991] = {
    [aux_sym_concatenation_repeat1] = STATE(4237),
    [sym__simple_heredoc_body] = ACTIONS(1037),
    [sym__heredoc_body_beginning] = ACTIONS(1037),
    [sym_file_descriptor] = ACTIONS(1037),
    [sym__concat] = ACTIONS(6367),
    [anon_sym_SEMI] = ACTIONS(1039),
    [anon_sym_esac] = ACTIONS(1037),
    [anon_sym_PIPE] = ACTIONS(1039),
    [anon_sym_SEMI_SEMI] = ACTIONS(1037),
    [anon_sym_PIPE_AMP] = ACTIONS(1037),
    [anon_sym_AMP_AMP] = ACTIONS(1037),
    [anon_sym_PIPE_PIPE] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1039),
    [anon_sym_GT] = ACTIONS(1039),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_AMP_GT] = ACTIONS(1039),
    [anon_sym_AMP_GT_GT] = ACTIONS(1037),
    [anon_sym_LT_AMP] = ACTIONS(1037),
    [anon_sym_GT_AMP] = ACTIONS(1037),
    [anon_sym_LT_LT] = ACTIONS(1039),
    [anon_sym_LT_LT_DASH] = ACTIONS(1037),
    [anon_sym_LT_LT_LT] = ACTIONS(1037),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1037),
    [anon_sym_AMP] = ACTIONS(1039),
  },
  [3992] = {
    [aux_sym__literal_repeat1] = STATE(4238),
    [sym__simple_heredoc_body] = ACTIONS(1051),
    [sym__heredoc_body_beginning] = ACTIONS(1051),
    [sym_file_descriptor] = ACTIONS(1051),
    [anon_sym_SEMI] = ACTIONS(1053),
    [anon_sym_esac] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1053),
    [anon_sym_SEMI_SEMI] = ACTIONS(1051),
    [anon_sym_PIPE_AMP] = ACTIONS(1051),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_PIPE_PIPE] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT_GT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1051),
    [anon_sym_GT_AMP] = ACTIONS(1051),
    [anon_sym_LT_LT] = ACTIONS(1053),
    [anon_sym_LT_LT_DASH] = ACTIONS(1051),
    [anon_sym_LT_LT_LT] = ACTIONS(1051),
    [sym__special_character] = ACTIONS(6383),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1051),
    [anon_sym_AMP] = ACTIONS(1053),
  },
  [3993] = {
    [aux_sym_concatenation_repeat1] = STATE(4237),
    [sym__simple_heredoc_body] = ACTIONS(2596),
    [sym__heredoc_body_beginning] = ACTIONS(2596),
    [sym_file_descriptor] = ACTIONS(2596),
    [sym__concat] = ACTIONS(6367),
    [anon_sym_SEMI] = ACTIONS(2598),
    [anon_sym_esac] = ACTIONS(2596),
    [anon_sym_PIPE] = ACTIONS(2598),
    [anon_sym_SEMI_SEMI] = ACTIONS(2596),
    [anon_sym_PIPE_AMP] = ACTIONS(2596),
    [anon_sym_AMP_AMP] = ACTIONS(2596),
    [anon_sym_PIPE_PIPE] = ACTIONS(2596),
    [anon_sym_LT] = ACTIONS(2598),
    [anon_sym_GT] = ACTIONS(2598),
    [anon_sym_GT_GT] = ACTIONS(2596),
    [anon_sym_AMP_GT] = ACTIONS(2598),
    [anon_sym_AMP_GT_GT] = ACTIONS(2596),
    [anon_sym_LT_AMP] = ACTIONS(2596),
    [anon_sym_GT_AMP] = ACTIONS(2596),
    [anon_sym_LT_LT] = ACTIONS(2598),
    [anon_sym_LT_LT_DASH] = ACTIONS(2596),
    [anon_sym_LT_LT_LT] = ACTIONS(2596),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2596),
    [anon_sym_AMP] = ACTIONS(2598),
  },
  [3994] = {
    [aux_sym__literal_repeat1] = STATE(4238),
    [sym__simple_heredoc_body] = ACTIONS(2600),
    [sym__heredoc_body_beginning] = ACTIONS(2600),
    [sym_file_descriptor] = ACTIONS(2600),
    [anon_sym_SEMI] = ACTIONS(2602),
    [anon_sym_esac] = ACTIONS(2600),
    [anon_sym_PIPE] = ACTIONS(2602),
    [anon_sym_SEMI_SEMI] = ACTIONS(2600),
    [anon_sym_PIPE_AMP] = ACTIONS(2600),
    [anon_sym_AMP_AMP] = ACTIONS(2600),
    [anon_sym_PIPE_PIPE] = ACTIONS(2600),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_GT_GT] = ACTIONS(2600),
    [anon_sym_AMP_GT] = ACTIONS(2602),
    [anon_sym_AMP_GT_GT] = ACTIONS(2600),
    [anon_sym_LT_AMP] = ACTIONS(2600),
    [anon_sym_GT_AMP] = ACTIONS(2600),
    [anon_sym_LT_LT] = ACTIONS(2602),
    [anon_sym_LT_LT_DASH] = ACTIONS(2600),
    [anon_sym_LT_LT_LT] = ACTIONS(2600),
    [sym__special_character] = ACTIONS(6383),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2600),
    [anon_sym_AMP] = ACTIONS(2602),
  },
  [3995] = {
    [sym_file_descriptor] = ACTIONS(2604),
    [sym_variable_name] = ACTIONS(2604),
    [anon_sym_for] = ACTIONS(2608),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2608),
    [anon_sym_if] = ACTIONS(2608),
    [anon_sym_case] = ACTIONS(2608),
    [anon_sym_esac] = ACTIONS(6385),
    [anon_sym_SEMI_SEMI] = ACTIONS(2606),
    [anon_sym_function] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(2608),
    [anon_sym_LBRACE] = ACTIONS(2604),
    [anon_sym_BANG] = ACTIONS(2608),
    [anon_sym_LBRACK] = ACTIONS(2608),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2604),
    [anon_sym_declare] = ACTIONS(2608),
    [anon_sym_typeset] = ACTIONS(2608),
    [anon_sym_export] = ACTIONS(2608),
    [anon_sym_readonly] = ACTIONS(2608),
    [anon_sym_local] = ACTIONS(2608),
    [anon_sym_unset] = ACTIONS(2608),
    [anon_sym_unsetenv] = ACTIONS(2608),
    [anon_sym_LT] = ACTIONS(2608),
    [anon_sym_GT] = ACTIONS(2608),
    [anon_sym_GT_GT] = ACTIONS(2604),
    [anon_sym_AMP_GT] = ACTIONS(2608),
    [anon_sym_AMP_GT_GT] = ACTIONS(2604),
    [anon_sym_LT_AMP] = ACTIONS(2604),
    [anon_sym_GT_AMP] = ACTIONS(2604),
    [anon_sym_DOLLAR] = ACTIONS(2608),
    [sym__special_character] = ACTIONS(2608),
    [anon_sym_DQUOTE] = ACTIONS(2604),
    [sym_raw_string] = ACTIONS(2604),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2604),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2604),
    [anon_sym_BQUOTE] = ACTIONS(2604),
    [anon_sym_LT_LPAREN] = ACTIONS(2604),
    [anon_sym_GT_LPAREN] = ACTIONS(2604),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2608),
  },
  [3996] = {
    [sym_file_redirect] = STATE(3996),
    [sym_heredoc_redirect] = STATE(3996),
    [sym_herestring_redirect] = STATE(3996),
    [aux_sym_redirected_statement_repeat1] = STATE(3996),
    [sym__simple_heredoc_body] = ACTIONS(2610),
    [sym__heredoc_body_beginning] = ACTIONS(2610),
    [sym_file_descriptor] = ACTIONS(9608),
    [anon_sym_SEMI] = ACTIONS(2615),
    [anon_sym_esac] = ACTIONS(2610),
    [anon_sym_PIPE] = ACTIONS(2615),
    [anon_sym_SEMI_SEMI] = ACTIONS(2610),
    [anon_sym_PIPE_AMP] = ACTIONS(2610),
    [anon_sym_AMP_AMP] = ACTIONS(2610),
    [anon_sym_PIPE_PIPE] = ACTIONS(2610),
    [anon_sym_LT] = ACTIONS(9611),
    [anon_sym_GT] = ACTIONS(9611),
    [anon_sym_GT_GT] = ACTIONS(9614),
    [anon_sym_AMP_GT] = ACTIONS(9611),
    [anon_sym_AMP_GT_GT] = ACTIONS(9614),
    [anon_sym_LT_AMP] = ACTIONS(9614),
    [anon_sym_GT_AMP] = ACTIONS(9614),
    [anon_sym_LT_LT] = ACTIONS(2623),
    [anon_sym_LT_LT_DASH] = ACTIONS(2626),
    [anon_sym_LT_LT_LT] = ACTIONS(9617),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2610),
    [anon_sym_AMP] = ACTIONS(2615),
  },
  [3997] = {
    [sym__simple_heredoc_body] = ACTIONS(2632),
    [sym__heredoc_body_beginning] = ACTIONS(2632),
    [sym_file_descriptor] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_esac] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2634),
    [anon_sym_SEMI_SEMI] = ACTIONS(2632),
    [anon_sym_PIPE_AMP] = ACTIONS(2632),
    [anon_sym_AMP_AMP] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2632),
    [anon_sym_EQ_TILDE] = ACTIONS(2634),
    [anon_sym_EQ_EQ] = ACTIONS(2634),
    [anon_sym_LT] = ACTIONS(2634),
    [anon_sym_GT] = ACTIONS(2634),
    [anon_sym_GT_GT] = ACTIONS(2632),
    [anon_sym_AMP_GT] = ACTIONS(2634),
    [anon_sym_AMP_GT_GT] = ACTIONS(2632),
    [anon_sym_LT_AMP] = ACTIONS(2632),
    [anon_sym_GT_AMP] = ACTIONS(2632),
    [anon_sym_LT_LT] = ACTIONS(2634),
    [anon_sym_LT_LT_DASH] = ACTIONS(2632),
    [anon_sym_LT_LT_LT] = ACTIONS(2632),
    [anon_sym_DOLLAR] = ACTIONS(2634),
    [sym__special_character] = ACTIONS(2632),
    [anon_sym_DQUOTE] = ACTIONS(2632),
    [sym_raw_string] = ACTIONS(2632),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2632),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2632),
    [anon_sym_BQUOTE] = ACTIONS(2632),
    [anon_sym_LT_LPAREN] = ACTIONS(2632),
    [anon_sym_GT_LPAREN] = ACTIONS(2632),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2634),
    [anon_sym_LF] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2634),
  },
  [3998] = {
    [aux_sym_concatenation_repeat1] = STATE(3596),
    [sym__simple_heredoc_body] = ACTIONS(2632),
    [sym__heredoc_body_beginning] = ACTIONS(2632),
    [sym_file_descriptor] = ACTIONS(2632),
    [sym__concat] = ACTIONS(8135),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_esac] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2634),
    [anon_sym_SEMI_SEMI] = ACTIONS(2632),
    [anon_sym_PIPE_AMP] = ACTIONS(2632),
    [anon_sym_AMP_AMP] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2632),
    [anon_sym_EQ_TILDE] = ACTIONS(2634),
    [anon_sym_EQ_EQ] = ACTIONS(2634),
    [anon_sym_LT] = ACTIONS(2634),
    [anon_sym_GT] = ACTIONS(2634),
    [anon_sym_GT_GT] = ACTIONS(2632),
    [anon_sym_AMP_GT] = ACTIONS(2634),
    [anon_sym_AMP_GT_GT] = ACTIONS(2632),
    [anon_sym_LT_AMP] = ACTIONS(2632),
    [anon_sym_GT_AMP] = ACTIONS(2632),
    [anon_sym_LT_LT] = ACTIONS(2634),
    [anon_sym_LT_LT_DASH] = ACTIONS(2632),
    [anon_sym_LT_LT_LT] = ACTIONS(2632),
    [anon_sym_DOLLAR] = ACTIONS(2634),
    [sym__special_character] = ACTIONS(2632),
    [anon_sym_DQUOTE] = ACTIONS(2632),
    [sym_raw_string] = ACTIONS(2632),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2632),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2632),
    [anon_sym_BQUOTE] = ACTIONS(2632),
    [anon_sym_LT_LPAREN] = ACTIONS(2632),
    [anon_sym_GT_LPAREN] = ACTIONS(2632),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2634),
    [anon_sym_LF] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2634),
  },
  [3999] = {
    [aux_sym__literal_repeat1] = STATE(3625),
    [sym__simple_heredoc_body] = ACTIONS(2636),
    [sym__heredoc_body_beginning] = ACTIONS(2636),
    [sym_file_descriptor] = ACTIONS(2636),
    [anon_sym_SEMI] = ACTIONS(2638),
    [anon_sym_esac] = ACTIONS(2638),
    [anon_sym_PIPE] = ACTIONS(2638),
    [anon_sym_SEMI_SEMI] = ACTIONS(2636),
    [anon_sym_PIPE_AMP] = ACTIONS(2636),
    [anon_sym_AMP_AMP] = ACTIONS(2636),
    [anon_sym_PIPE_PIPE] = ACTIONS(2636),
    [anon_sym_EQ_TILDE] = ACTIONS(2638),
    [anon_sym_EQ_EQ] = ACTIONS(2638),
    [anon_sym_LT] = ACTIONS(2638),
    [anon_sym_GT] = ACTIONS(2638),
    [anon_sym_GT_GT] = ACTIONS(2636),
    [anon_sym_AMP_GT] = ACTIONS(2638),
    [anon_sym_AMP_GT_GT] = ACTIONS(2636),
    [anon_sym_LT_AMP] = ACTIONS(2636),
    [anon_sym_GT_AMP] = ACTIONS(2636),
    [anon_sym_LT_LT] = ACTIONS(2638),
    [anon_sym_LT_LT_DASH] = ACTIONS(2636),
    [anon_sym_LT_LT_LT] = ACTIONS(2636),
    [anon_sym_DOLLAR] = ACTIONS(2638),
    [sym__special_character] = ACTIONS(8181),
    [anon_sym_DQUOTE] = ACTIONS(2636),
    [sym_raw_string] = ACTIONS(2636),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2636),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2636),
    [anon_sym_BQUOTE] = ACTIONS(2636),
    [anon_sym_LT_LPAREN] = ACTIONS(2636),
    [anon_sym_GT_LPAREN] = ACTIONS(2636),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2638),
    [anon_sym_LF] = ACTIONS(2636),
    [anon_sym_AMP] = ACTIONS(2638),
  },
  [4000] = {
    [sym_concatenation] = STATE(4000),
    [sym_string] = STATE(3618),
    [sym_simple_expansion] = STATE(3618),
    [sym_string_expansion] = STATE(3618),
    [sym_expansion] = STATE(3618),
    [sym_command_substitution] = STATE(3618),
    [sym_process_substitution] = STATE(3618),
    [aux_sym_command_repeat2] = STATE(4000),
    [aux_sym__literal_repeat1] = STATE(3620),
    [sym__simple_heredoc_body] = ACTIONS(2632),
    [sym__heredoc_body_beginning] = ACTIONS(2632),
    [sym_file_descriptor] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_esac] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2634),
    [anon_sym_SEMI_SEMI] = ACTIONS(2632),
    [anon_sym_PIPE_AMP] = ACTIONS(2632),
    [anon_sym_AMP_AMP] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2632),
    [anon_sym_EQ_TILDE] = ACTIONS(9620),
    [anon_sym_EQ_EQ] = ACTIONS(9620),
    [anon_sym_LT] = ACTIONS(2634),
    [anon_sym_GT] = ACTIONS(2634),
    [anon_sym_GT_GT] = ACTIONS(2632),
    [anon_sym_AMP_GT] = ACTIONS(2634),
    [anon_sym_AMP_GT_GT] = ACTIONS(2632),
    [anon_sym_LT_AMP] = ACTIONS(2632),
    [anon_sym_GT_AMP] = ACTIONS(2632),
    [anon_sym_LT_LT] = ACTIONS(2634),
    [anon_sym_LT_LT_DASH] = ACTIONS(2632),
    [anon_sym_LT_LT_LT] = ACTIONS(2632),
    [anon_sym_DOLLAR] = ACTIONS(9623),
    [sym__special_character] = ACTIONS(9626),
    [anon_sym_DQUOTE] = ACTIONS(9629),
    [sym_raw_string] = ACTIONS(9632),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(9635),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(9638),
    [anon_sym_BQUOTE] = ACTIONS(9641),
    [anon_sym_LT_LPAREN] = ACTIONS(9644),
    [anon_sym_GT_LPAREN] = ACTIONS(9644),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9647),
    [anon_sym_LF] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2634),
  },
  [4001] = {
    [sym_file_descriptor] = ACTIONS(1237),
    [sym_variable_name] = ACTIONS(1237),
    [anon_sym_for] = ACTIONS(1241),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1237),
    [anon_sym_while] = ACTIONS(1241),
    [anon_sym_if] = ACTIONS(1241),
    [anon_sym_case] = ACTIONS(1241),
    [anon_sym_esac] = ACTIONS(6385),
    [anon_sym_SEMI_SEMI] = ACTIONS(2606),
    [anon_sym_function] = ACTIONS(1241),
    [anon_sym_LPAREN] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1237),
    [anon_sym_BANG] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(1241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1237),
    [anon_sym_declare] = ACTIONS(1241),
    [anon_sym_typeset] = ACTIONS(1241),
    [anon_sym_export] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_local] = ACTIONS(1241),
    [anon_sym_unset] = ACTIONS(1241),
    [anon_sym_unsetenv] = ACTIONS(1241),
    [anon_sym_LT] = ACTIONS(1241),
    [anon_sym_GT] = ACTIONS(1241),
    [anon_sym_GT_GT] = ACTIONS(1237),
    [anon_sym_AMP_GT] = ACTIONS(1241),
    [anon_sym_AMP_GT_GT] = ACTIONS(1237),
    [anon_sym_LT_AMP] = ACTIONS(1237),
    [anon_sym_GT_AMP] = ACTIONS(1237),
    [anon_sym_DOLLAR] = ACTIONS(1241),
    [sym__special_character] = ACTIONS(1241),
    [anon_sym_DQUOTE] = ACTIONS(1237),
    [sym_raw_string] = ACTIONS(1237),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1237),
    [anon_sym_BQUOTE] = ACTIONS(1237),
    [anon_sym_LT_LPAREN] = ACTIONS(1237),
    [anon_sym_GT_LPAREN] = ACTIONS(1237),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1241),
  },
  [4002] = {
    [anon_sym_SEMI] = ACTIONS(9650),
    [anon_sym_esac] = ACTIONS(2606),
    [anon_sym_SEMI_SEMI] = ACTIONS(2606),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(9652),
    [anon_sym_AMP] = ACTIONS(9652),
  },
  [4003] = {
    [sym_concatenation] = STATE(4000),
    [sym_string] = STATE(3618),
    [sym_simple_expansion] = STATE(3618),
    [sym_string_expansion] = STATE(3618),
    [sym_expansion] = STATE(3618),
    [sym_command_substitution] = STATE(3618),
    [sym_process_substitution] = STATE(3618),
    [aux_sym_command_repeat2] = STATE(4000),
    [aux_sym__literal_repeat1] = STATE(3620),
    [sym__simple_heredoc_body] = ACTIONS(2696),
    [sym__heredoc_body_beginning] = ACTIONS(2696),
    [sym_file_descriptor] = ACTIONS(2696),
    [anon_sym_SEMI] = ACTIONS(2698),
    [anon_sym_esac] = ACTIONS(2698),
    [anon_sym_PIPE] = ACTIONS(2698),
    [anon_sym_SEMI_SEMI] = ACTIONS(2696),
    [anon_sym_PIPE_AMP] = ACTIONS(2696),
    [anon_sym_AMP_AMP] = ACTIONS(2696),
    [anon_sym_PIPE_PIPE] = ACTIONS(2696),
    [anon_sym_EQ_TILDE] = ACTIONS(8173),
    [anon_sym_EQ_EQ] = ACTIONS(8173),
    [anon_sym_LT] = ACTIONS(2698),
    [anon_sym_GT] = ACTIONS(2698),
    [anon_sym_GT_GT] = ACTIONS(2696),
    [anon_sym_AMP_GT] = ACTIONS(2698),
    [anon_sym_AMP_GT_GT] = ACTIONS(2696),
    [anon_sym_LT_AMP] = ACTIONS(2696),
    [anon_sym_GT_AMP] = ACTIONS(2696),
    [anon_sym_LT_LT] = ACTIONS(2698),
    [anon_sym_LT_LT_DASH] = ACTIONS(2696),
    [anon_sym_LT_LT_LT] = ACTIONS(2696),
    [anon_sym_DOLLAR] = ACTIONS(6864),
    [sym__special_character] = ACTIONS(8175),
    [anon_sym_DQUOTE] = ACTIONS(6868),
    [sym_raw_string] = ACTIONS(8177),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6874),
    [anon_sym_BQUOTE] = ACTIONS(6876),
    [anon_sym_LT_LPAREN] = ACTIONS(6878),
    [anon_sym_GT_LPAREN] = ACTIONS(6878),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8179),
    [anon_sym_LF] = ACTIONS(2696),
    [anon_sym_AMP] = ACTIONS(2698),
  },
  [4004] = {
    [anon_sym_esac] = ACTIONS(9654),
    [anon_sym_DOLLAR] = ACTIONS(9656),
    [sym__special_character] = ACTIONS(9658),
    [anon_sym_DQUOTE] = ACTIONS(9658),
    [sym_raw_string] = ACTIONS(9658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(9658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(9658),
    [anon_sym_BQUOTE] = ACTIONS(9658),
    [anon_sym_LT_LPAREN] = ACTIONS(9658),
    [anon_sym_GT_LPAREN] = ACTIONS(9658),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9656),
  },
  [4005] = {
    [anon_sym_DOLLAR] = ACTIONS(8081),
    [sym__special_character] = ACTIONS(8083),
    [anon_sym_DQUOTE] = ACTIONS(8083),
    [sym_raw_string] = ACTIONS(8083),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8083),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8083),
    [anon_sym_BQUOTE] = ACTIONS(8083),
    [anon_sym_LT_LPAREN] = ACTIONS(8083),
    [anon_sym_GT_LPAREN] = ACTIONS(8083),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8083),
  },
  [4006] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(9660),
    [sym_comment] = ACTIONS(57),
  },
  [4007] = {
    [sym_file_redirect] = STATE(1342),
    [sym_heredoc_redirect] = STATE(1342),
    [sym_heredoc_body] = STATE(4241),
    [sym_herestring_redirect] = STATE(1342),
    [aux_sym_redirected_statement_repeat1] = STATE(1342),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(2678),
    [anon_sym_SEMI] = ACTIONS(401),
    [anon_sym_PIPE] = ACTIONS(2682),
    [anon_sym_SEMI_SEMI] = ACTIONS(399),
    [anon_sym_PIPE_AMP] = ACTIONS(2686),
    [anon_sym_AMP_AMP] = ACTIONS(2688),
    [anon_sym_PIPE_PIPE] = ACTIONS(2688),
    [anon_sym_LT] = ACTIONS(2690),
    [anon_sym_GT] = ACTIONS(2690),
    [anon_sym_GT_GT] = ACTIONS(2692),
    [anon_sym_AMP_GT] = ACTIONS(2690),
    [anon_sym_AMP_GT_GT] = ACTIONS(2692),
    [anon_sym_LT_AMP] = ACTIONS(2692),
    [anon_sym_GT_AMP] = ACTIONS(2692),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(2694),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(405),
    [anon_sym_AMP] = ACTIONS(401),
  },
  [4008] = {
    [sym_file_redirect] = STATE(1342),
    [sym_heredoc_redirect] = STATE(1342),
    [sym_heredoc_body] = STATE(4241),
    [sym_herestring_redirect] = STATE(1342),
    [aux_sym_redirected_statement_repeat1] = STATE(1342),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(401),
    [anon_sym_PIPE] = ACTIONS(2682),
    [anon_sym_SEMI_SEMI] = ACTIONS(399),
    [anon_sym_PIPE_AMP] = ACTIONS(2686),
    [anon_sym_AMP_AMP] = ACTIONS(2688),
    [anon_sym_PIPE_PIPE] = ACTIONS(2688),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(2694),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(405),
    [anon_sym_AMP] = ACTIONS(401),
  },
  [4009] = {
    [sym_redirected_statement] = STATE(4242),
    [sym_for_statement] = STATE(4242),
    [sym_c_style_for_statement] = STATE(4242),
    [sym_while_statement] = STATE(4242),
    [sym_if_statement] = STATE(4242),
    [sym_case_statement] = STATE(4242),
    [sym_function_definition] = STATE(4242),
    [sym_compound_statement] = STATE(4242),
    [sym_subshell] = STATE(4242),
    [sym_pipeline] = STATE(4242),
    [sym_list] = STATE(4242),
    [sym_negated_command] = STATE(4242),
    [sym_test_command] = STATE(4242),
    [sym_declaration_command] = STATE(4242),
    [sym_unset_command] = STATE(4242),
    [sym_command] = STATE(4242),
    [sym_command_name] = STATE(714),
    [sym_variable_assignment] = STATE(4243),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(716),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(251),
    [aux_sym_command_repeat1] = STATE(716),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(4385),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(4387),
    [anon_sym_typeset] = ACTIONS(4387),
    [anon_sym_export] = ACTIONS(4387),
    [anon_sym_readonly] = ACTIONS(4387),
    [anon_sym_local] = ACTIONS(4387),
    [anon_sym_unset] = ACTIONS(4389),
    [anon_sym_unsetenv] = ACTIONS(4389),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [4010] = {
    [sym__statements] = STATE(4244),
    [sym_redirected_statement] = STATE(4007),
    [sym_for_statement] = STATE(4007),
    [sym_c_style_for_statement] = STATE(4007),
    [sym_while_statement] = STATE(4007),
    [sym_if_statement] = STATE(4007),
    [sym_case_statement] = STATE(4007),
    [sym_function_definition] = STATE(4007),
    [sym_compound_statement] = STATE(4007),
    [sym_subshell] = STATE(4007),
    [sym_pipeline] = STATE(4007),
    [sym_list] = STATE(4007),
    [sym_negated_command] = STATE(4007),
    [sym_test_command] = STATE(4007),
    [sym_declaration_command] = STATE(4007),
    [sym_unset_command] = STATE(4007),
    [sym_command] = STATE(4007),
    [sym_command_name] = STATE(714),
    [sym_variable_assignment] = STATE(4008),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(716),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(4009),
    [aux_sym_command_repeat1] = STATE(716),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_SEMI_SEMI] = ACTIONS(9660),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(4385),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(4387),
    [anon_sym_typeset] = ACTIONS(4387),
    [anon_sym_export] = ACTIONS(4387),
    [anon_sym_readonly] = ACTIONS(4387),
    [anon_sym_local] = ACTIONS(4387),
    [anon_sym_unset] = ACTIONS(4389),
    [anon_sym_unsetenv] = ACTIONS(4389),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [4011] = {
    [anon_sym_DOLLAR] = ACTIONS(8196),
    [sym__special_character] = ACTIONS(8198),
    [anon_sym_DQUOTE] = ACTIONS(8198),
    [sym_raw_string] = ACTIONS(8198),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8198),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8198),
    [anon_sym_BQUOTE] = ACTIONS(8198),
    [anon_sym_LT_LPAREN] = ACTIONS(8198),
    [anon_sym_GT_LPAREN] = ACTIONS(8198),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8198),
  },
  [4012] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(9662),
    [sym_comment] = ACTIONS(57),
  },
  [4013] = {
    [sym__statements] = STATE(4246),
    [sym_redirected_statement] = STATE(4007),
    [sym_for_statement] = STATE(4007),
    [sym_c_style_for_statement] = STATE(4007),
    [sym_while_statement] = STATE(4007),
    [sym_if_statement] = STATE(4007),
    [sym_case_statement] = STATE(4007),
    [sym_function_definition] = STATE(4007),
    [sym_compound_statement] = STATE(4007),
    [sym_subshell] = STATE(4007),
    [sym_pipeline] = STATE(4007),
    [sym_list] = STATE(4007),
    [sym_negated_command] = STATE(4007),
    [sym_test_command] = STATE(4007),
    [sym_declaration_command] = STATE(4007),
    [sym_unset_command] = STATE(4007),
    [sym_command] = STATE(4007),
    [sym_command_name] = STATE(714),
    [sym_variable_assignment] = STATE(4008),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(716),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(4009),
    [aux_sym_command_repeat1] = STATE(716),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_SEMI_SEMI] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(4385),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(4387),
    [anon_sym_typeset] = ACTIONS(4387),
    [anon_sym_export] = ACTIONS(4387),
    [anon_sym_readonly] = ACTIONS(4387),
    [anon_sym_local] = ACTIONS(4387),
    [anon_sym_unset] = ACTIONS(4389),
    [anon_sym_unsetenv] = ACTIONS(4389),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [anon_sym_DOLLAR] = ACTIONS(41),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [4014] = {
    [anon_sym_esac] = ACTIONS(9664),
    [anon_sym_DOLLAR] = ACTIONS(9666),
    [sym__special_character] = ACTIONS(9668),
    [anon_sym_DQUOTE] = ACTIONS(9668),
    [sym_raw_string] = ACTIONS(9668),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(9668),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(9668),
    [anon_sym_BQUOTE] = ACTIONS(9668),
    [anon_sym_LT_LPAREN] = ACTIONS(9668),
    [anon_sym_GT_LPAREN] = ACTIONS(9668),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9666),
  },
  [4015] = {
    [sym__simple_heredoc_body] = ACTIONS(7198),
    [sym__heredoc_body_beginning] = ACTIONS(7198),
    [sym_file_descriptor] = ACTIONS(7198),
    [sym__concat] = ACTIONS(7198),
    [sym_variable_name] = ACTIONS(7198),
    [anon_sym_SEMI] = ACTIONS(7200),
    [anon_sym_PIPE] = ACTIONS(7200),
    [anon_sym_SEMI_SEMI] = ACTIONS(7198),
    [anon_sym_RBRACE] = ACTIONS(7198),
    [anon_sym_PIPE_AMP] = ACTIONS(7198),
    [anon_sym_AMP_AMP] = ACTIONS(7198),
    [anon_sym_PIPE_PIPE] = ACTIONS(7198),
    [anon_sym_LT] = ACTIONS(7200),
    [anon_sym_GT] = ACTIONS(7200),
    [anon_sym_GT_GT] = ACTIONS(7198),
    [anon_sym_AMP_GT] = ACTIONS(7200),
    [anon_sym_AMP_GT_GT] = ACTIONS(7198),
    [anon_sym_LT_AMP] = ACTIONS(7198),
    [anon_sym_GT_AMP] = ACTIONS(7198),
    [anon_sym_LT_LT] = ACTIONS(7200),
    [anon_sym_LT_LT_DASH] = ACTIONS(7198),
    [anon_sym_LT_LT_LT] = ACTIONS(7198),
    [anon_sym_DOLLAR] = ACTIONS(7200),
    [sym__special_character] = ACTIONS(7200),
    [anon_sym_DQUOTE] = ACTIONS(7198),
    [sym_raw_string] = ACTIONS(7198),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7198),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7198),
    [anon_sym_BQUOTE] = ACTIONS(7198),
    [anon_sym_LT_LPAREN] = ACTIONS(7198),
    [anon_sym_GT_LPAREN] = ACTIONS(7198),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7200),
    [anon_sym_LF] = ACTIONS(7198),
    [anon_sym_AMP] = ACTIONS(7200),
  },
  [4016] = {
    [sym__simple_heredoc_body] = ACTIONS(7202),
    [sym__heredoc_body_beginning] = ACTIONS(7202),
    [sym_file_descriptor] = ACTIONS(7202),
    [sym__concat] = ACTIONS(7202),
    [sym_variable_name] = ACTIONS(7202),
    [anon_sym_SEMI] = ACTIONS(7204),
    [anon_sym_PIPE] = ACTIONS(7204),
    [anon_sym_SEMI_SEMI] = ACTIONS(7202),
    [anon_sym_RBRACE] = ACTIONS(7202),
    [anon_sym_PIPE_AMP] = ACTIONS(7202),
    [anon_sym_AMP_AMP] = ACTIONS(7202),
    [anon_sym_PIPE_PIPE] = ACTIONS(7202),
    [anon_sym_LT] = ACTIONS(7204),
    [anon_sym_GT] = ACTIONS(7204),
    [anon_sym_GT_GT] = ACTIONS(7202),
    [anon_sym_AMP_GT] = ACTIONS(7204),
    [anon_sym_AMP_GT_GT] = ACTIONS(7202),
    [anon_sym_LT_AMP] = ACTIONS(7202),
    [anon_sym_GT_AMP] = ACTIONS(7202),
    [anon_sym_LT_LT] = ACTIONS(7204),
    [anon_sym_LT_LT_DASH] = ACTIONS(7202),
    [anon_sym_LT_LT_LT] = ACTIONS(7202),
    [anon_sym_DOLLAR] = ACTIONS(7204),
    [sym__special_character] = ACTIONS(7204),
    [anon_sym_DQUOTE] = ACTIONS(7202),
    [sym_raw_string] = ACTIONS(7202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7202),
    [anon_sym_BQUOTE] = ACTIONS(7202),
    [anon_sym_LT_LPAREN] = ACTIONS(7202),
    [anon_sym_GT_LPAREN] = ACTIONS(7202),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7204),
    [anon_sym_LF] = ACTIONS(7202),
    [anon_sym_AMP] = ACTIONS(7204),
  },
  [4017] = {
    [sym__simple_heredoc_body] = ACTIONS(7206),
    [sym__heredoc_body_beginning] = ACTIONS(7206),
    [sym_file_descriptor] = ACTIONS(7206),
    [sym__concat] = ACTIONS(7206),
    [sym_variable_name] = ACTIONS(7206),
    [anon_sym_SEMI] = ACTIONS(7208),
    [anon_sym_PIPE] = ACTIONS(7208),
    [anon_sym_SEMI_SEMI] = ACTIONS(7206),
    [anon_sym_RBRACE] = ACTIONS(7206),
    [anon_sym_PIPE_AMP] = ACTIONS(7206),
    [anon_sym_AMP_AMP] = ACTIONS(7206),
    [anon_sym_PIPE_PIPE] = ACTIONS(7206),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7206),
    [anon_sym_AMP_GT] = ACTIONS(7208),
    [anon_sym_AMP_GT_GT] = ACTIONS(7206),
    [anon_sym_LT_AMP] = ACTIONS(7206),
    [anon_sym_GT_AMP] = ACTIONS(7206),
    [anon_sym_LT_LT] = ACTIONS(7208),
    [anon_sym_LT_LT_DASH] = ACTIONS(7206),
    [anon_sym_LT_LT_LT] = ACTIONS(7206),
    [anon_sym_DOLLAR] = ACTIONS(7208),
    [sym__special_character] = ACTIONS(7208),
    [anon_sym_DQUOTE] = ACTIONS(7206),
    [sym_raw_string] = ACTIONS(7206),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7206),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7206),
    [anon_sym_BQUOTE] = ACTIONS(7206),
    [anon_sym_LT_LPAREN] = ACTIONS(7206),
    [anon_sym_GT_LPAREN] = ACTIONS(7206),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7208),
    [anon_sym_LF] = ACTIONS(7206),
    [anon_sym_AMP] = ACTIONS(7208),
  },
  [4018] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9670),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4019] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9672),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4020] = {
    [sym__simple_heredoc_body] = ACTIONS(7242),
    [sym__heredoc_body_beginning] = ACTIONS(7242),
    [sym_file_descriptor] = ACTIONS(7242),
    [sym__concat] = ACTIONS(7242),
    [sym_variable_name] = ACTIONS(7242),
    [anon_sym_SEMI] = ACTIONS(7244),
    [anon_sym_PIPE] = ACTIONS(7244),
    [anon_sym_SEMI_SEMI] = ACTIONS(7242),
    [anon_sym_RBRACE] = ACTIONS(7242),
    [anon_sym_PIPE_AMP] = ACTIONS(7242),
    [anon_sym_AMP_AMP] = ACTIONS(7242),
    [anon_sym_PIPE_PIPE] = ACTIONS(7242),
    [anon_sym_LT] = ACTIONS(7244),
    [anon_sym_GT] = ACTIONS(7244),
    [anon_sym_GT_GT] = ACTIONS(7242),
    [anon_sym_AMP_GT] = ACTIONS(7244),
    [anon_sym_AMP_GT_GT] = ACTIONS(7242),
    [anon_sym_LT_AMP] = ACTIONS(7242),
    [anon_sym_GT_AMP] = ACTIONS(7242),
    [anon_sym_LT_LT] = ACTIONS(7244),
    [anon_sym_LT_LT_DASH] = ACTIONS(7242),
    [anon_sym_LT_LT_LT] = ACTIONS(7242),
    [anon_sym_DOLLAR] = ACTIONS(7244),
    [sym__special_character] = ACTIONS(7244),
    [anon_sym_DQUOTE] = ACTIONS(7242),
    [sym_raw_string] = ACTIONS(7242),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7242),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7242),
    [anon_sym_BQUOTE] = ACTIONS(7242),
    [anon_sym_LT_LPAREN] = ACTIONS(7242),
    [anon_sym_GT_LPAREN] = ACTIONS(7242),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7244),
    [anon_sym_LF] = ACTIONS(7242),
    [anon_sym_AMP] = ACTIONS(7244),
  },
  [4021] = {
    [sym__simple_heredoc_body] = ACTIONS(8400),
    [sym__heredoc_body_beginning] = ACTIONS(8400),
    [sym_file_descriptor] = ACTIONS(8400),
    [anon_sym_SEMI] = ACTIONS(8402),
    [anon_sym_PIPE] = ACTIONS(8402),
    [anon_sym_SEMI_SEMI] = ACTIONS(8400),
    [anon_sym_RBRACE] = ACTIONS(8400),
    [anon_sym_PIPE_AMP] = ACTIONS(8400),
    [anon_sym_AMP_AMP] = ACTIONS(8400),
    [anon_sym_PIPE_PIPE] = ACTIONS(8400),
    [anon_sym_LT] = ACTIONS(8402),
    [anon_sym_GT] = ACTIONS(8402),
    [anon_sym_GT_GT] = ACTIONS(8400),
    [anon_sym_AMP_GT] = ACTIONS(8402),
    [anon_sym_AMP_GT_GT] = ACTIONS(8400),
    [anon_sym_LT_AMP] = ACTIONS(8400),
    [anon_sym_GT_AMP] = ACTIONS(8400),
    [anon_sym_LT_LT] = ACTIONS(8402),
    [anon_sym_LT_LT_DASH] = ACTIONS(8400),
    [anon_sym_LT_LT_LT] = ACTIONS(8400),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8400),
    [anon_sym_AMP] = ACTIONS(8402),
  },
  [4022] = {
    [sym_do_group] = STATE(4249),
    [sym_compound_statement] = STATE(4249),
    [anon_sym_do] = ACTIONS(1953),
    [anon_sym_LBRACE] = ACTIONS(191),
    [sym_comment] = ACTIONS(57),
  },
  [4023] = {
    [sym_do_group] = STATE(4249),
    [sym_compound_statement] = STATE(4249),
    [anon_sym_SEMI] = ACTIONS(9674),
    [anon_sym_do] = ACTIONS(1953),
    [anon_sym_LBRACE] = ACTIONS(191),
    [sym_comment] = ACTIONS(57),
  },
  [4024] = {
    [sym__simple_heredoc_body] = ACTIONS(9041),
    [sym__heredoc_body_beginning] = ACTIONS(9041),
    [sym_file_descriptor] = ACTIONS(9041),
    [anon_sym_SEMI] = ACTIONS(9043),
    [anon_sym_PIPE] = ACTIONS(9043),
    [anon_sym_SEMI_SEMI] = ACTIONS(9041),
    [anon_sym_RBRACE] = ACTIONS(9041),
    [anon_sym_PIPE_AMP] = ACTIONS(9041),
    [anon_sym_AMP_AMP] = ACTIONS(9041),
    [anon_sym_PIPE_PIPE] = ACTIONS(9041),
    [anon_sym_LT] = ACTIONS(9043),
    [anon_sym_GT] = ACTIONS(9043),
    [anon_sym_GT_GT] = ACTIONS(9041),
    [anon_sym_AMP_GT] = ACTIONS(9043),
    [anon_sym_AMP_GT_GT] = ACTIONS(9041),
    [anon_sym_LT_AMP] = ACTIONS(9041),
    [anon_sym_GT_AMP] = ACTIONS(9041),
    [anon_sym_LT_LT] = ACTIONS(9043),
    [anon_sym_LT_LT_DASH] = ACTIONS(9041),
    [anon_sym_LT_LT_LT] = ACTIONS(9041),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(9041),
    [anon_sym_AMP] = ACTIONS(9043),
  },
  [4025] = {
    [sym__simple_heredoc_body] = ACTIONS(9045),
    [sym__heredoc_body_beginning] = ACTIONS(9045),
    [sym_file_descriptor] = ACTIONS(9045),
    [anon_sym_SEMI] = ACTIONS(9047),
    [anon_sym_PIPE] = ACTIONS(9047),
    [anon_sym_SEMI_SEMI] = ACTIONS(9045),
    [anon_sym_RBRACE] = ACTIONS(9045),
    [anon_sym_PIPE_AMP] = ACTIONS(9045),
    [anon_sym_AMP_AMP] = ACTIONS(9045),
    [anon_sym_PIPE_PIPE] = ACTIONS(9045),
    [anon_sym_LT] = ACTIONS(9047),
    [anon_sym_GT] = ACTIONS(9047),
    [anon_sym_GT_GT] = ACTIONS(9045),
    [anon_sym_AMP_GT] = ACTIONS(9047),
    [anon_sym_AMP_GT_GT] = ACTIONS(9045),
    [anon_sym_LT_AMP] = ACTIONS(9045),
    [anon_sym_GT_AMP] = ACTIONS(9045),
    [anon_sym_LT_LT] = ACTIONS(9047),
    [anon_sym_LT_LT_DASH] = ACTIONS(9045),
    [anon_sym_LT_LT_LT] = ACTIONS(9045),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(9045),
    [anon_sym_AMP] = ACTIONS(9047),
  },
  [4026] = {
    [sym__simple_heredoc_body] = ACTIONS(8340),
    [sym__heredoc_body_beginning] = ACTIONS(8340),
    [sym_file_descriptor] = ACTIONS(8340),
    [sym__concat] = ACTIONS(8340),
    [sym_variable_name] = ACTIONS(8340),
    [anon_sym_SEMI] = ACTIONS(8342),
    [anon_sym_PIPE] = ACTIONS(8342),
    [anon_sym_SEMI_SEMI] = ACTIONS(8340),
    [anon_sym_RBRACE] = ACTIONS(8340),
    [anon_sym_PIPE_AMP] = ACTIONS(8340),
    [anon_sym_AMP_AMP] = ACTIONS(8340),
    [anon_sym_PIPE_PIPE] = ACTIONS(8340),
    [anon_sym_LT] = ACTIONS(8342),
    [anon_sym_GT] = ACTIONS(8342),
    [anon_sym_GT_GT] = ACTIONS(8340),
    [anon_sym_AMP_GT] = ACTIONS(8342),
    [anon_sym_AMP_GT_GT] = ACTIONS(8340),
    [anon_sym_LT_AMP] = ACTIONS(8340),
    [anon_sym_GT_AMP] = ACTIONS(8340),
    [anon_sym_LT_LT] = ACTIONS(8342),
    [anon_sym_LT_LT_DASH] = ACTIONS(8340),
    [anon_sym_LT_LT_LT] = ACTIONS(8340),
    [anon_sym_DOLLAR] = ACTIONS(8342),
    [sym__special_character] = ACTIONS(8342),
    [anon_sym_DQUOTE] = ACTIONS(8340),
    [sym_raw_string] = ACTIONS(8340),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8340),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [anon_sym_LT_LPAREN] = ACTIONS(8340),
    [anon_sym_GT_LPAREN] = ACTIONS(8340),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8342),
    [sym_word] = ACTIONS(8342),
    [anon_sym_LF] = ACTIONS(8340),
    [anon_sym_AMP] = ACTIONS(8342),
  },
  [4027] = {
    [sym__simple_heredoc_body] = ACTIONS(8344),
    [sym__heredoc_body_beginning] = ACTIONS(8344),
    [sym_file_descriptor] = ACTIONS(8344),
    [sym__concat] = ACTIONS(8344),
    [sym_variable_name] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [anon_sym_PIPE] = ACTIONS(8346),
    [anon_sym_SEMI_SEMI] = ACTIONS(8344),
    [anon_sym_RBRACE] = ACTIONS(8344),
    [anon_sym_PIPE_AMP] = ACTIONS(8344),
    [anon_sym_AMP_AMP] = ACTIONS(8344),
    [anon_sym_PIPE_PIPE] = ACTIONS(8344),
    [anon_sym_LT] = ACTIONS(8346),
    [anon_sym_GT] = ACTIONS(8346),
    [anon_sym_GT_GT] = ACTIONS(8344),
    [anon_sym_AMP_GT] = ACTIONS(8346),
    [anon_sym_AMP_GT_GT] = ACTIONS(8344),
    [anon_sym_LT_AMP] = ACTIONS(8344),
    [anon_sym_GT_AMP] = ACTIONS(8344),
    [anon_sym_LT_LT] = ACTIONS(8346),
    [anon_sym_LT_LT_DASH] = ACTIONS(8344),
    [anon_sym_LT_LT_LT] = ACTIONS(8344),
    [anon_sym_DOLLAR] = ACTIONS(8346),
    [sym__special_character] = ACTIONS(8346),
    [anon_sym_DQUOTE] = ACTIONS(8344),
    [sym_raw_string] = ACTIONS(8344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8344),
    [anon_sym_BQUOTE] = ACTIONS(8344),
    [anon_sym_LT_LPAREN] = ACTIONS(8344),
    [anon_sym_GT_LPAREN] = ACTIONS(8344),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8346),
    [sym_word] = ACTIONS(8346),
    [anon_sym_LF] = ACTIONS(8344),
    [anon_sym_AMP] = ACTIONS(8346),
  },
  [4028] = {
    [sym__simple_heredoc_body] = ACTIONS(8340),
    [sym__heredoc_body_beginning] = ACTIONS(8340),
    [sym_file_descriptor] = ACTIONS(8340),
    [sym__concat] = ACTIONS(8340),
    [anon_sym_SEMI] = ACTIONS(8342),
    [anon_sym_PIPE] = ACTIONS(8342),
    [anon_sym_SEMI_SEMI] = ACTIONS(8340),
    [anon_sym_RBRACE] = ACTIONS(8340),
    [anon_sym_PIPE_AMP] = ACTIONS(8340),
    [anon_sym_AMP_AMP] = ACTIONS(8340),
    [anon_sym_PIPE_PIPE] = ACTIONS(8340),
    [anon_sym_LT] = ACTIONS(8342),
    [anon_sym_GT] = ACTIONS(8342),
    [anon_sym_GT_GT] = ACTIONS(8340),
    [anon_sym_AMP_GT] = ACTIONS(8342),
    [anon_sym_AMP_GT_GT] = ACTIONS(8340),
    [anon_sym_LT_AMP] = ACTIONS(8340),
    [anon_sym_GT_AMP] = ACTIONS(8340),
    [anon_sym_LT_LT] = ACTIONS(8342),
    [anon_sym_LT_LT_DASH] = ACTIONS(8340),
    [anon_sym_LT_LT_LT] = ACTIONS(8340),
    [anon_sym_DOLLAR] = ACTIONS(8342),
    [sym__special_character] = ACTIONS(8342),
    [anon_sym_DQUOTE] = ACTIONS(8340),
    [sym_raw_string] = ACTIONS(8340),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8340),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [anon_sym_LT_LPAREN] = ACTIONS(8340),
    [anon_sym_GT_LPAREN] = ACTIONS(8340),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8342),
    [sym_word] = ACTIONS(8342),
    [anon_sym_LF] = ACTIONS(8340),
    [anon_sym_AMP] = ACTIONS(8342),
  },
  [4029] = {
    [sym__simple_heredoc_body] = ACTIONS(8344),
    [sym__heredoc_body_beginning] = ACTIONS(8344),
    [sym_file_descriptor] = ACTIONS(8344),
    [sym__concat] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [anon_sym_PIPE] = ACTIONS(8346),
    [anon_sym_SEMI_SEMI] = ACTIONS(8344),
    [anon_sym_RBRACE] = ACTIONS(8344),
    [anon_sym_PIPE_AMP] = ACTIONS(8344),
    [anon_sym_AMP_AMP] = ACTIONS(8344),
    [anon_sym_PIPE_PIPE] = ACTIONS(8344),
    [anon_sym_LT] = ACTIONS(8346),
    [anon_sym_GT] = ACTIONS(8346),
    [anon_sym_GT_GT] = ACTIONS(8344),
    [anon_sym_AMP_GT] = ACTIONS(8346),
    [anon_sym_AMP_GT_GT] = ACTIONS(8344),
    [anon_sym_LT_AMP] = ACTIONS(8344),
    [anon_sym_GT_AMP] = ACTIONS(8344),
    [anon_sym_LT_LT] = ACTIONS(8346),
    [anon_sym_LT_LT_DASH] = ACTIONS(8344),
    [anon_sym_LT_LT_LT] = ACTIONS(8344),
    [anon_sym_DOLLAR] = ACTIONS(8346),
    [sym__special_character] = ACTIONS(8346),
    [anon_sym_DQUOTE] = ACTIONS(8344),
    [sym_raw_string] = ACTIONS(8344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8344),
    [anon_sym_BQUOTE] = ACTIONS(8344),
    [anon_sym_LT_LPAREN] = ACTIONS(8344),
    [anon_sym_GT_LPAREN] = ACTIONS(8344),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8346),
    [sym_word] = ACTIONS(8346),
    [anon_sym_LF] = ACTIONS(8344),
    [anon_sym_AMP] = ACTIONS(8346),
  },
  [4030] = {
    [sym__concat] = ACTIONS(7198),
    [anon_sym_RBRACE] = ACTIONS(7198),
    [sym_comment] = ACTIONS(57),
  },
  [4031] = {
    [sym__concat] = ACTIONS(7202),
    [anon_sym_RBRACE] = ACTIONS(7202),
    [sym_comment] = ACTIONS(57),
  },
  [4032] = {
    [sym__concat] = ACTIONS(7206),
    [anon_sym_RBRACE] = ACTIONS(7206),
    [sym_comment] = ACTIONS(57),
  },
  [4033] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9676),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4034] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9678),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4035] = {
    [sym__concat] = ACTIONS(7242),
    [anon_sym_RBRACE] = ACTIONS(7242),
    [sym_comment] = ACTIONS(57),
  },
  [4036] = {
    [sym__concat] = ACTIONS(8340),
    [anon_sym_RBRACE] = ACTIONS(8340),
    [anon_sym_EQ] = ACTIONS(8342),
    [anon_sym_DASH] = ACTIONS(8342),
    [anon_sym_DOLLAR] = ACTIONS(8342),
    [sym__special_character] = ACTIONS(8342),
    [anon_sym_DQUOTE] = ACTIONS(8340),
    [sym_raw_string] = ACTIONS(8340),
    [anon_sym_POUND] = ACTIONS(8340),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8340),
    [anon_sym_COLON] = ACTIONS(8342),
    [anon_sym_COLON_QMARK] = ACTIONS(8342),
    [anon_sym_COLON_DASH] = ACTIONS(8342),
    [anon_sym_PERCENT] = ACTIONS(8342),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [anon_sym_LT_LPAREN] = ACTIONS(8340),
    [anon_sym_GT_LPAREN] = ACTIONS(8340),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(8342),
  },
  [4037] = {
    [sym__concat] = ACTIONS(8344),
    [anon_sym_RBRACE] = ACTIONS(8344),
    [anon_sym_EQ] = ACTIONS(8346),
    [anon_sym_DASH] = ACTIONS(8346),
    [anon_sym_DOLLAR] = ACTIONS(8346),
    [sym__special_character] = ACTIONS(8346),
    [anon_sym_DQUOTE] = ACTIONS(8344),
    [sym_raw_string] = ACTIONS(8344),
    [anon_sym_POUND] = ACTIONS(8344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8344),
    [anon_sym_COLON] = ACTIONS(8346),
    [anon_sym_COLON_QMARK] = ACTIONS(8346),
    [anon_sym_COLON_DASH] = ACTIONS(8346),
    [anon_sym_PERCENT] = ACTIONS(8346),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8344),
    [anon_sym_BQUOTE] = ACTIONS(8344),
    [anon_sym_LT_LPAREN] = ACTIONS(8344),
    [anon_sym_GT_LPAREN] = ACTIONS(8344),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(8346),
  },
  [4038] = {
    [sym__heredoc_body_middle] = ACTIONS(8340),
    [sym__heredoc_body_end] = ACTIONS(8340),
    [anon_sym_DOLLAR] = ACTIONS(8342),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8340),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [sym_comment] = ACTIONS(57),
  },
  [4039] = {
    [sym__heredoc_body_middle] = ACTIONS(8344),
    [sym__heredoc_body_end] = ACTIONS(8344),
    [anon_sym_DOLLAR] = ACTIONS(8346),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8344),
    [anon_sym_BQUOTE] = ACTIONS(8344),
    [sym_comment] = ACTIONS(57),
  },
  [4040] = {
    [sym__concat] = ACTIONS(8340),
    [anon_sym_RPAREN] = ACTIONS(8340),
    [anon_sym_DOLLAR] = ACTIONS(8342),
    [sym__special_character] = ACTIONS(8340),
    [anon_sym_DQUOTE] = ACTIONS(8340),
    [sym_raw_string] = ACTIONS(8340),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8340),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [anon_sym_LT_LPAREN] = ACTIONS(8340),
    [anon_sym_GT_LPAREN] = ACTIONS(8340),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8340),
  },
  [4041] = {
    [sym__concat] = ACTIONS(8344),
    [anon_sym_RPAREN] = ACTIONS(8344),
    [anon_sym_DOLLAR] = ACTIONS(8346),
    [sym__special_character] = ACTIONS(8344),
    [anon_sym_DQUOTE] = ACTIONS(8344),
    [sym_raw_string] = ACTIONS(8344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8344),
    [anon_sym_BQUOTE] = ACTIONS(8344),
    [anon_sym_LT_LPAREN] = ACTIONS(8344),
    [anon_sym_GT_LPAREN] = ACTIONS(8344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8344),
  },
  [4042] = {
    [sym__simple_heredoc_body] = ACTIONS(9680),
    [sym__heredoc_body_beginning] = ACTIONS(9680),
    [sym_file_descriptor] = ACTIONS(9680),
    [ts_builtin_sym_end] = ACTIONS(9680),
    [anon_sym_SEMI] = ACTIONS(9682),
    [anon_sym_done] = ACTIONS(9680),
    [anon_sym_fi] = ACTIONS(9680),
    [anon_sym_elif] = ACTIONS(9680),
    [anon_sym_else] = ACTIONS(9680),
    [anon_sym_esac] = ACTIONS(9680),
    [anon_sym_PIPE] = ACTIONS(9682),
    [anon_sym_RPAREN] = ACTIONS(9680),
    [anon_sym_SEMI_SEMI] = ACTIONS(9680),
    [anon_sym_PIPE_AMP] = ACTIONS(9680),
    [anon_sym_AMP_AMP] = ACTIONS(9680),
    [anon_sym_PIPE_PIPE] = ACTIONS(9680),
    [anon_sym_LT] = ACTIONS(9682),
    [anon_sym_GT] = ACTIONS(9682),
    [anon_sym_GT_GT] = ACTIONS(9680),
    [anon_sym_AMP_GT] = ACTIONS(9682),
    [anon_sym_AMP_GT_GT] = ACTIONS(9680),
    [anon_sym_LT_AMP] = ACTIONS(9680),
    [anon_sym_GT_AMP] = ACTIONS(9680),
    [anon_sym_LT_LT] = ACTIONS(9682),
    [anon_sym_LT_LT_DASH] = ACTIONS(9680),
    [anon_sym_LT_LT_LT] = ACTIONS(9680),
    [anon_sym_BQUOTE] = ACTIONS(9680),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(9680),
    [anon_sym_AMP] = ACTIONS(9682),
  },
  [4043] = {
    [sym__concat] = ACTIONS(8340),
    [anon_sym_SEMI] = ACTIONS(8342),
    [anon_sym_SEMI_SEMI] = ACTIONS(8340),
    [anon_sym_DOLLAR] = ACTIONS(8342),
    [sym__special_character] = ACTIONS(8340),
    [anon_sym_DQUOTE] = ACTIONS(8340),
    [sym_raw_string] = ACTIONS(8340),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8340),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [anon_sym_LT_LPAREN] = ACTIONS(8340),
    [anon_sym_GT_LPAREN] = ACTIONS(8340),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8342),
    [anon_sym_LF] = ACTIONS(8340),
    [anon_sym_AMP] = ACTIONS(8340),
  },
  [4044] = {
    [sym__concat] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [anon_sym_SEMI_SEMI] = ACTIONS(8344),
    [anon_sym_DOLLAR] = ACTIONS(8346),
    [sym__special_character] = ACTIONS(8344),
    [anon_sym_DQUOTE] = ACTIONS(8344),
    [sym_raw_string] = ACTIONS(8344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8344),
    [anon_sym_BQUOTE] = ACTIONS(8344),
    [anon_sym_LT_LPAREN] = ACTIONS(8344),
    [anon_sym_GT_LPAREN] = ACTIONS(8344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8346),
    [anon_sym_LF] = ACTIONS(8344),
    [anon_sym_AMP] = ACTIONS(8344),
  },
  [4045] = {
    [sym_file_descriptor] = ACTIONS(8340),
    [sym__concat] = ACTIONS(8340),
    [sym_variable_name] = ACTIONS(8340),
    [anon_sym_SEMI] = ACTIONS(8342),
    [anon_sym_PIPE] = ACTIONS(8342),
    [anon_sym_SEMI_SEMI] = ACTIONS(8340),
    [anon_sym_PIPE_AMP] = ACTIONS(8340),
    [anon_sym_AMP_AMP] = ACTIONS(8340),
    [anon_sym_PIPE_PIPE] = ACTIONS(8340),
    [anon_sym_LT] = ACTIONS(8342),
    [anon_sym_GT] = ACTIONS(8342),
    [anon_sym_GT_GT] = ACTIONS(8340),
    [anon_sym_AMP_GT] = ACTIONS(8342),
    [anon_sym_AMP_GT_GT] = ACTIONS(8340),
    [anon_sym_LT_AMP] = ACTIONS(8340),
    [anon_sym_GT_AMP] = ACTIONS(8340),
    [anon_sym_LT_LT] = ACTIONS(8342),
    [anon_sym_LT_LT_DASH] = ACTIONS(8340),
    [anon_sym_LT_LT_LT] = ACTIONS(8340),
    [anon_sym_DOLLAR] = ACTIONS(8342),
    [sym__special_character] = ACTIONS(8340),
    [anon_sym_DQUOTE] = ACTIONS(8340),
    [sym_raw_string] = ACTIONS(8340),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8340),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [anon_sym_LT_LPAREN] = ACTIONS(8340),
    [anon_sym_GT_LPAREN] = ACTIONS(8340),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8342),
    [anon_sym_LF] = ACTIONS(8340),
    [anon_sym_AMP] = ACTIONS(8342),
  },
  [4046] = {
    [sym_file_descriptor] = ACTIONS(8344),
    [sym__concat] = ACTIONS(8344),
    [sym_variable_name] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [anon_sym_PIPE] = ACTIONS(8346),
    [anon_sym_SEMI_SEMI] = ACTIONS(8344),
    [anon_sym_PIPE_AMP] = ACTIONS(8344),
    [anon_sym_AMP_AMP] = ACTIONS(8344),
    [anon_sym_PIPE_PIPE] = ACTIONS(8344),
    [anon_sym_LT] = ACTIONS(8346),
    [anon_sym_GT] = ACTIONS(8346),
    [anon_sym_GT_GT] = ACTIONS(8344),
    [anon_sym_AMP_GT] = ACTIONS(8346),
    [anon_sym_AMP_GT_GT] = ACTIONS(8344),
    [anon_sym_LT_AMP] = ACTIONS(8344),
    [anon_sym_GT_AMP] = ACTIONS(8344),
    [anon_sym_LT_LT] = ACTIONS(8346),
    [anon_sym_LT_LT_DASH] = ACTIONS(8344),
    [anon_sym_LT_LT_LT] = ACTIONS(8344),
    [anon_sym_DOLLAR] = ACTIONS(8346),
    [sym__special_character] = ACTIONS(8344),
    [anon_sym_DQUOTE] = ACTIONS(8344),
    [sym_raw_string] = ACTIONS(8344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8344),
    [anon_sym_BQUOTE] = ACTIONS(8344),
    [anon_sym_LT_LPAREN] = ACTIONS(8344),
    [anon_sym_GT_LPAREN] = ACTIONS(8344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8346),
    [anon_sym_LF] = ACTIONS(8344),
    [anon_sym_AMP] = ACTIONS(8346),
  },
  [4047] = {
    [sym_file_descriptor] = ACTIONS(9109),
    [anon_sym_SEMI] = ACTIONS(9111),
    [anon_sym_PIPE] = ACTIONS(9111),
    [anon_sym_SEMI_SEMI] = ACTIONS(9109),
    [anon_sym_PIPE_AMP] = ACTIONS(9109),
    [anon_sym_AMP_AMP] = ACTIONS(9109),
    [anon_sym_PIPE_PIPE] = ACTIONS(9109),
    [anon_sym_LT] = ACTIONS(9111),
    [anon_sym_GT] = ACTIONS(9111),
    [anon_sym_GT_GT] = ACTIONS(9109),
    [anon_sym_AMP_GT] = ACTIONS(9111),
    [anon_sym_AMP_GT_GT] = ACTIONS(9109),
    [anon_sym_LT_AMP] = ACTIONS(9109),
    [anon_sym_GT_AMP] = ACTIONS(9109),
    [anon_sym_LT_LT] = ACTIONS(9111),
    [anon_sym_LT_LT_DASH] = ACTIONS(9109),
    [anon_sym_LT_LT_LT] = ACTIONS(9109),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(9109),
    [anon_sym_AMP] = ACTIONS(9111),
  },
  [4048] = {
    [sym_do_group] = STATE(4253),
    [sym_compound_statement] = STATE(4253),
    [anon_sym_do] = ACTIONS(1631),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_comment] = ACTIONS(57),
  },
  [4049] = {
    [sym__simple_heredoc_body] = ACTIONS(5674),
    [sym__heredoc_body_beginning] = ACTIONS(5674),
    [sym_file_descriptor] = ACTIONS(5674),
    [sym__concat] = ACTIONS(5674),
    [sym_variable_name] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(5676),
    [anon_sym_done] = ACTIONS(5676),
    [anon_sym_PIPE] = ACTIONS(5676),
    [anon_sym_SEMI_SEMI] = ACTIONS(5674),
    [anon_sym_PIPE_AMP] = ACTIONS(5674),
    [anon_sym_AMP_AMP] = ACTIONS(5674),
    [anon_sym_PIPE_PIPE] = ACTIONS(5674),
    [anon_sym_LT] = ACTIONS(5676),
    [anon_sym_GT] = ACTIONS(5676),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_AMP_GT] = ACTIONS(5676),
    [anon_sym_AMP_GT_GT] = ACTIONS(5674),
    [anon_sym_LT_AMP] = ACTIONS(5674),
    [anon_sym_GT_AMP] = ACTIONS(5674),
    [anon_sym_LT_LT] = ACTIONS(5676),
    [anon_sym_LT_LT_DASH] = ACTIONS(5674),
    [anon_sym_LT_LT_LT] = ACTIONS(5674),
    [anon_sym_DOLLAR] = ACTIONS(5676),
    [sym__special_character] = ACTIONS(5674),
    [anon_sym_DQUOTE] = ACTIONS(5674),
    [sym_raw_string] = ACTIONS(5674),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5674),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5674),
    [anon_sym_BQUOTE] = ACTIONS(5674),
    [anon_sym_LT_LPAREN] = ACTIONS(5674),
    [anon_sym_GT_LPAREN] = ACTIONS(5674),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5676),
    [anon_sym_LF] = ACTIONS(5674),
    [anon_sym_AMP] = ACTIONS(5676),
  },
  [4050] = {
    [sym__simple_heredoc_body] = ACTIONS(5708),
    [sym__heredoc_body_beginning] = ACTIONS(5708),
    [sym_file_descriptor] = ACTIONS(5708),
    [sym__concat] = ACTIONS(5708),
    [sym_variable_name] = ACTIONS(5708),
    [anon_sym_SEMI] = ACTIONS(5710),
    [anon_sym_done] = ACTIONS(5710),
    [anon_sym_PIPE] = ACTIONS(5710),
    [anon_sym_SEMI_SEMI] = ACTIONS(5708),
    [anon_sym_PIPE_AMP] = ACTIONS(5708),
    [anon_sym_AMP_AMP] = ACTIONS(5708),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_LT] = ACTIONS(5710),
    [anon_sym_GT] = ACTIONS(5710),
    [anon_sym_GT_GT] = ACTIONS(5708),
    [anon_sym_AMP_GT] = ACTIONS(5710),
    [anon_sym_AMP_GT_GT] = ACTIONS(5708),
    [anon_sym_LT_AMP] = ACTIONS(5708),
    [anon_sym_GT_AMP] = ACTIONS(5708),
    [anon_sym_LT_LT] = ACTIONS(5710),
    [anon_sym_LT_LT_DASH] = ACTIONS(5708),
    [anon_sym_LT_LT_LT] = ACTIONS(5708),
    [anon_sym_DOLLAR] = ACTIONS(5710),
    [sym__special_character] = ACTIONS(5708),
    [anon_sym_DQUOTE] = ACTIONS(5708),
    [sym_raw_string] = ACTIONS(5708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5708),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5708),
    [anon_sym_BQUOTE] = ACTIONS(5708),
    [anon_sym_LT_LPAREN] = ACTIONS(5708),
    [anon_sym_GT_LPAREN] = ACTIONS(5708),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5710),
    [anon_sym_LF] = ACTIONS(5708),
    [anon_sym_AMP] = ACTIONS(5710),
  },
  [4051] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(9684),
    [sym_comment] = ACTIONS(57),
  },
  [4052] = {
    [anon_sym_RBRACE] = ACTIONS(9684),
    [sym_comment] = ACTIONS(57),
  },
  [4053] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(9686),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [4054] = {
    [sym_concatenation] = STATE(4257),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4257),
    [anon_sym_RBRACE] = ACTIONS(9688),
    [anon_sym_EQ] = ACTIONS(9690),
    [anon_sym_DASH] = ACTIONS(9690),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9692),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9690),
    [anon_sym_COLON_QMARK] = ACTIONS(9690),
    [anon_sym_COLON_DASH] = ACTIONS(9690),
    [anon_sym_PERCENT] = ACTIONS(9690),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4055] = {
    [sym__simple_heredoc_body] = ACTIONS(5725),
    [sym__heredoc_body_beginning] = ACTIONS(5725),
    [sym_file_descriptor] = ACTIONS(5725),
    [sym__concat] = ACTIONS(5725),
    [sym_variable_name] = ACTIONS(5725),
    [anon_sym_SEMI] = ACTIONS(5727),
    [anon_sym_done] = ACTIONS(5727),
    [anon_sym_PIPE] = ACTIONS(5727),
    [anon_sym_SEMI_SEMI] = ACTIONS(5725),
    [anon_sym_PIPE_AMP] = ACTIONS(5725),
    [anon_sym_AMP_AMP] = ACTIONS(5725),
    [anon_sym_PIPE_PIPE] = ACTIONS(5725),
    [anon_sym_LT] = ACTIONS(5727),
    [anon_sym_GT] = ACTIONS(5727),
    [anon_sym_GT_GT] = ACTIONS(5725),
    [anon_sym_AMP_GT] = ACTIONS(5727),
    [anon_sym_AMP_GT_GT] = ACTIONS(5725),
    [anon_sym_LT_AMP] = ACTIONS(5725),
    [anon_sym_GT_AMP] = ACTIONS(5725),
    [anon_sym_LT_LT] = ACTIONS(5727),
    [anon_sym_LT_LT_DASH] = ACTIONS(5725),
    [anon_sym_LT_LT_LT] = ACTIONS(5725),
    [anon_sym_DOLLAR] = ACTIONS(5727),
    [sym__special_character] = ACTIONS(5725),
    [anon_sym_DQUOTE] = ACTIONS(5725),
    [sym_raw_string] = ACTIONS(5725),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5725),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5725),
    [anon_sym_BQUOTE] = ACTIONS(5725),
    [anon_sym_LT_LPAREN] = ACTIONS(5725),
    [anon_sym_GT_LPAREN] = ACTIONS(5725),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5727),
    [anon_sym_LF] = ACTIONS(5725),
    [anon_sym_AMP] = ACTIONS(5727),
  },
  [4056] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9688),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4057] = {
    [sym_concatenation] = STATE(4258),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4258),
    [anon_sym_RBRACE] = ACTIONS(9684),
    [anon_sym_EQ] = ACTIONS(9694),
    [anon_sym_DASH] = ACTIONS(9694),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9696),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9694),
    [anon_sym_COLON_QMARK] = ACTIONS(9694),
    [anon_sym_COLON_DASH] = ACTIONS(9694),
    [anon_sym_PERCENT] = ACTIONS(9694),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4058] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9684),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4059] = {
    [sym__simple_heredoc_body] = ACTIONS(5770),
    [sym__heredoc_body_beginning] = ACTIONS(5770),
    [sym_file_descriptor] = ACTIONS(5770),
    [sym__concat] = ACTIONS(5770),
    [sym_variable_name] = ACTIONS(5770),
    [anon_sym_SEMI] = ACTIONS(5772),
    [anon_sym_done] = ACTIONS(5772),
    [anon_sym_PIPE] = ACTIONS(5772),
    [anon_sym_SEMI_SEMI] = ACTIONS(5770),
    [anon_sym_PIPE_AMP] = ACTIONS(5770),
    [anon_sym_AMP_AMP] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5770),
    [anon_sym_LT] = ACTIONS(5772),
    [anon_sym_GT] = ACTIONS(5772),
    [anon_sym_GT_GT] = ACTIONS(5770),
    [anon_sym_AMP_GT] = ACTIONS(5772),
    [anon_sym_AMP_GT_GT] = ACTIONS(5770),
    [anon_sym_LT_AMP] = ACTIONS(5770),
    [anon_sym_GT_AMP] = ACTIONS(5770),
    [anon_sym_LT_LT] = ACTIONS(5772),
    [anon_sym_LT_LT_DASH] = ACTIONS(5770),
    [anon_sym_LT_LT_LT] = ACTIONS(5770),
    [anon_sym_DOLLAR] = ACTIONS(5772),
    [sym__special_character] = ACTIONS(5770),
    [anon_sym_DQUOTE] = ACTIONS(5770),
    [sym_raw_string] = ACTIONS(5770),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5770),
    [anon_sym_BQUOTE] = ACTIONS(5770),
    [anon_sym_LT_LPAREN] = ACTIONS(5770),
    [anon_sym_GT_LPAREN] = ACTIONS(5770),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5772),
    [anon_sym_LF] = ACTIONS(5770),
    [anon_sym_AMP] = ACTIONS(5772),
  },
  [4060] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9698),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4061] = {
    [sym__simple_heredoc_body] = ACTIONS(7198),
    [sym__heredoc_body_beginning] = ACTIONS(7198),
    [sym_file_descriptor] = ACTIONS(7198),
    [sym__concat] = ACTIONS(7198),
    [sym_variable_name] = ACTIONS(7198),
    [anon_sym_SEMI] = ACTIONS(7200),
    [anon_sym_done] = ACTIONS(7200),
    [anon_sym_PIPE] = ACTIONS(7200),
    [anon_sym_SEMI_SEMI] = ACTIONS(7198),
    [anon_sym_PIPE_AMP] = ACTIONS(7198),
    [anon_sym_AMP_AMP] = ACTIONS(7198),
    [anon_sym_PIPE_PIPE] = ACTIONS(7198),
    [anon_sym_LT] = ACTIONS(7200),
    [anon_sym_GT] = ACTIONS(7200),
    [anon_sym_GT_GT] = ACTIONS(7198),
    [anon_sym_AMP_GT] = ACTIONS(7200),
    [anon_sym_AMP_GT_GT] = ACTIONS(7198),
    [anon_sym_LT_AMP] = ACTIONS(7198),
    [anon_sym_GT_AMP] = ACTIONS(7198),
    [anon_sym_LT_LT] = ACTIONS(7200),
    [anon_sym_LT_LT_DASH] = ACTIONS(7198),
    [anon_sym_LT_LT_LT] = ACTIONS(7198),
    [anon_sym_DOLLAR] = ACTIONS(7200),
    [sym__special_character] = ACTIONS(7198),
    [anon_sym_DQUOTE] = ACTIONS(7198),
    [sym_raw_string] = ACTIONS(7198),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7198),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7198),
    [anon_sym_BQUOTE] = ACTIONS(7198),
    [anon_sym_LT_LPAREN] = ACTIONS(7198),
    [anon_sym_GT_LPAREN] = ACTIONS(7198),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7200),
    [sym_word] = ACTIONS(7200),
    [anon_sym_LF] = ACTIONS(7198),
    [anon_sym_AMP] = ACTIONS(7200),
  },
  [4062] = {
    [sym__simple_heredoc_body] = ACTIONS(7202),
    [sym__heredoc_body_beginning] = ACTIONS(7202),
    [sym_file_descriptor] = ACTIONS(7202),
    [sym__concat] = ACTIONS(7202),
    [sym_variable_name] = ACTIONS(7202),
    [anon_sym_SEMI] = ACTIONS(7204),
    [anon_sym_done] = ACTIONS(7204),
    [anon_sym_PIPE] = ACTIONS(7204),
    [anon_sym_SEMI_SEMI] = ACTIONS(7202),
    [anon_sym_PIPE_AMP] = ACTIONS(7202),
    [anon_sym_AMP_AMP] = ACTIONS(7202),
    [anon_sym_PIPE_PIPE] = ACTIONS(7202),
    [anon_sym_LT] = ACTIONS(7204),
    [anon_sym_GT] = ACTIONS(7204),
    [anon_sym_GT_GT] = ACTIONS(7202),
    [anon_sym_AMP_GT] = ACTIONS(7204),
    [anon_sym_AMP_GT_GT] = ACTIONS(7202),
    [anon_sym_LT_AMP] = ACTIONS(7202),
    [anon_sym_GT_AMP] = ACTIONS(7202),
    [anon_sym_LT_LT] = ACTIONS(7204),
    [anon_sym_LT_LT_DASH] = ACTIONS(7202),
    [anon_sym_LT_LT_LT] = ACTIONS(7202),
    [anon_sym_DOLLAR] = ACTIONS(7204),
    [sym__special_character] = ACTIONS(7202),
    [anon_sym_DQUOTE] = ACTIONS(7202),
    [sym_raw_string] = ACTIONS(7202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7202),
    [anon_sym_BQUOTE] = ACTIONS(7202),
    [anon_sym_LT_LPAREN] = ACTIONS(7202),
    [anon_sym_GT_LPAREN] = ACTIONS(7202),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7204),
    [sym_word] = ACTIONS(7204),
    [anon_sym_LF] = ACTIONS(7202),
    [anon_sym_AMP] = ACTIONS(7204),
  },
  [4063] = {
    [sym__simple_heredoc_body] = ACTIONS(7206),
    [sym__heredoc_body_beginning] = ACTIONS(7206),
    [sym_file_descriptor] = ACTIONS(7206),
    [sym__concat] = ACTIONS(7206),
    [sym_variable_name] = ACTIONS(7206),
    [anon_sym_SEMI] = ACTIONS(7208),
    [anon_sym_done] = ACTIONS(7208),
    [anon_sym_PIPE] = ACTIONS(7208),
    [anon_sym_SEMI_SEMI] = ACTIONS(7206),
    [anon_sym_PIPE_AMP] = ACTIONS(7206),
    [anon_sym_AMP_AMP] = ACTIONS(7206),
    [anon_sym_PIPE_PIPE] = ACTIONS(7206),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7206),
    [anon_sym_AMP_GT] = ACTIONS(7208),
    [anon_sym_AMP_GT_GT] = ACTIONS(7206),
    [anon_sym_LT_AMP] = ACTIONS(7206),
    [anon_sym_GT_AMP] = ACTIONS(7206),
    [anon_sym_LT_LT] = ACTIONS(7208),
    [anon_sym_LT_LT_DASH] = ACTIONS(7206),
    [anon_sym_LT_LT_LT] = ACTIONS(7206),
    [anon_sym_DOLLAR] = ACTIONS(7208),
    [sym__special_character] = ACTIONS(7206),
    [anon_sym_DQUOTE] = ACTIONS(7206),
    [sym_raw_string] = ACTIONS(7206),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7206),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7206),
    [anon_sym_BQUOTE] = ACTIONS(7206),
    [anon_sym_LT_LPAREN] = ACTIONS(7206),
    [anon_sym_GT_LPAREN] = ACTIONS(7206),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7208),
    [sym_word] = ACTIONS(7208),
    [anon_sym_LF] = ACTIONS(7206),
    [anon_sym_AMP] = ACTIONS(7208),
  },
  [4064] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9700),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4065] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9702),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4066] = {
    [sym__simple_heredoc_body] = ACTIONS(7242),
    [sym__heredoc_body_beginning] = ACTIONS(7242),
    [sym_file_descriptor] = ACTIONS(7242),
    [sym__concat] = ACTIONS(7242),
    [sym_variable_name] = ACTIONS(7242),
    [anon_sym_SEMI] = ACTIONS(7244),
    [anon_sym_done] = ACTIONS(7244),
    [anon_sym_PIPE] = ACTIONS(7244),
    [anon_sym_SEMI_SEMI] = ACTIONS(7242),
    [anon_sym_PIPE_AMP] = ACTIONS(7242),
    [anon_sym_AMP_AMP] = ACTIONS(7242),
    [anon_sym_PIPE_PIPE] = ACTIONS(7242),
    [anon_sym_LT] = ACTIONS(7244),
    [anon_sym_GT] = ACTIONS(7244),
    [anon_sym_GT_GT] = ACTIONS(7242),
    [anon_sym_AMP_GT] = ACTIONS(7244),
    [anon_sym_AMP_GT_GT] = ACTIONS(7242),
    [anon_sym_LT_AMP] = ACTIONS(7242),
    [anon_sym_GT_AMP] = ACTIONS(7242),
    [anon_sym_LT_LT] = ACTIONS(7244),
    [anon_sym_LT_LT_DASH] = ACTIONS(7242),
    [anon_sym_LT_LT_LT] = ACTIONS(7242),
    [anon_sym_DOLLAR] = ACTIONS(7244),
    [sym__special_character] = ACTIONS(7242),
    [anon_sym_DQUOTE] = ACTIONS(7242),
    [sym_raw_string] = ACTIONS(7242),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7242),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7242),
    [anon_sym_BQUOTE] = ACTIONS(7242),
    [anon_sym_LT_LPAREN] = ACTIONS(7242),
    [anon_sym_GT_LPAREN] = ACTIONS(7242),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7244),
    [sym_word] = ACTIONS(7244),
    [anon_sym_LF] = ACTIONS(7242),
    [anon_sym_AMP] = ACTIONS(7244),
  },
  [4067] = {
    [sym__simple_heredoc_body] = ACTIONS(7198),
    [sym__heredoc_body_beginning] = ACTIONS(7198),
    [sym_file_descriptor] = ACTIONS(7198),
    [sym__concat] = ACTIONS(7198),
    [anon_sym_SEMI] = ACTIONS(7200),
    [anon_sym_done] = ACTIONS(7200),
    [anon_sym_PIPE] = ACTIONS(7200),
    [anon_sym_SEMI_SEMI] = ACTIONS(7198),
    [anon_sym_PIPE_AMP] = ACTIONS(7198),
    [anon_sym_AMP_AMP] = ACTIONS(7198),
    [anon_sym_PIPE_PIPE] = ACTIONS(7198),
    [anon_sym_LT] = ACTIONS(7200),
    [anon_sym_GT] = ACTIONS(7200),
    [anon_sym_GT_GT] = ACTIONS(7198),
    [anon_sym_AMP_GT] = ACTIONS(7200),
    [anon_sym_AMP_GT_GT] = ACTIONS(7198),
    [anon_sym_LT_AMP] = ACTIONS(7198),
    [anon_sym_GT_AMP] = ACTIONS(7198),
    [anon_sym_LT_LT] = ACTIONS(7200),
    [anon_sym_LT_LT_DASH] = ACTIONS(7198),
    [anon_sym_LT_LT_LT] = ACTIONS(7198),
    [anon_sym_DOLLAR] = ACTIONS(7200),
    [sym__special_character] = ACTIONS(7198),
    [anon_sym_DQUOTE] = ACTIONS(7198),
    [sym_raw_string] = ACTIONS(7198),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7198),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7198),
    [anon_sym_BQUOTE] = ACTIONS(7198),
    [anon_sym_LT_LPAREN] = ACTIONS(7198),
    [anon_sym_GT_LPAREN] = ACTIONS(7198),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7200),
    [sym_word] = ACTIONS(7200),
    [anon_sym_LF] = ACTIONS(7198),
    [anon_sym_AMP] = ACTIONS(7200),
  },
  [4068] = {
    [sym__simple_heredoc_body] = ACTIONS(7202),
    [sym__heredoc_body_beginning] = ACTIONS(7202),
    [sym_file_descriptor] = ACTIONS(7202),
    [sym__concat] = ACTIONS(7202),
    [anon_sym_SEMI] = ACTIONS(7204),
    [anon_sym_done] = ACTIONS(7204),
    [anon_sym_PIPE] = ACTIONS(7204),
    [anon_sym_SEMI_SEMI] = ACTIONS(7202),
    [anon_sym_PIPE_AMP] = ACTIONS(7202),
    [anon_sym_AMP_AMP] = ACTIONS(7202),
    [anon_sym_PIPE_PIPE] = ACTIONS(7202),
    [anon_sym_LT] = ACTIONS(7204),
    [anon_sym_GT] = ACTIONS(7204),
    [anon_sym_GT_GT] = ACTIONS(7202),
    [anon_sym_AMP_GT] = ACTIONS(7204),
    [anon_sym_AMP_GT_GT] = ACTIONS(7202),
    [anon_sym_LT_AMP] = ACTIONS(7202),
    [anon_sym_GT_AMP] = ACTIONS(7202),
    [anon_sym_LT_LT] = ACTIONS(7204),
    [anon_sym_LT_LT_DASH] = ACTIONS(7202),
    [anon_sym_LT_LT_LT] = ACTIONS(7202),
    [anon_sym_DOLLAR] = ACTIONS(7204),
    [sym__special_character] = ACTIONS(7202),
    [anon_sym_DQUOTE] = ACTIONS(7202),
    [sym_raw_string] = ACTIONS(7202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7202),
    [anon_sym_BQUOTE] = ACTIONS(7202),
    [anon_sym_LT_LPAREN] = ACTIONS(7202),
    [anon_sym_GT_LPAREN] = ACTIONS(7202),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7204),
    [sym_word] = ACTIONS(7204),
    [anon_sym_LF] = ACTIONS(7202),
    [anon_sym_AMP] = ACTIONS(7204),
  },
  [4069] = {
    [sym__simple_heredoc_body] = ACTIONS(7206),
    [sym__heredoc_body_beginning] = ACTIONS(7206),
    [sym_file_descriptor] = ACTIONS(7206),
    [sym__concat] = ACTIONS(7206),
    [anon_sym_SEMI] = ACTIONS(7208),
    [anon_sym_done] = ACTIONS(7208),
    [anon_sym_PIPE] = ACTIONS(7208),
    [anon_sym_SEMI_SEMI] = ACTIONS(7206),
    [anon_sym_PIPE_AMP] = ACTIONS(7206),
    [anon_sym_AMP_AMP] = ACTIONS(7206),
    [anon_sym_PIPE_PIPE] = ACTIONS(7206),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7206),
    [anon_sym_AMP_GT] = ACTIONS(7208),
    [anon_sym_AMP_GT_GT] = ACTIONS(7206),
    [anon_sym_LT_AMP] = ACTIONS(7206),
    [anon_sym_GT_AMP] = ACTIONS(7206),
    [anon_sym_LT_LT] = ACTIONS(7208),
    [anon_sym_LT_LT_DASH] = ACTIONS(7206),
    [anon_sym_LT_LT_LT] = ACTIONS(7206),
    [anon_sym_DOLLAR] = ACTIONS(7208),
    [sym__special_character] = ACTIONS(7206),
    [anon_sym_DQUOTE] = ACTIONS(7206),
    [sym_raw_string] = ACTIONS(7206),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7206),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7206),
    [anon_sym_BQUOTE] = ACTIONS(7206),
    [anon_sym_LT_LPAREN] = ACTIONS(7206),
    [anon_sym_GT_LPAREN] = ACTIONS(7206),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7208),
    [sym_word] = ACTIONS(7208),
    [anon_sym_LF] = ACTIONS(7206),
    [anon_sym_AMP] = ACTIONS(7208),
  },
  [4070] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9704),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4071] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9706),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4072] = {
    [sym__simple_heredoc_body] = ACTIONS(7242),
    [sym__heredoc_body_beginning] = ACTIONS(7242),
    [sym_file_descriptor] = ACTIONS(7242),
    [sym__concat] = ACTIONS(7242),
    [anon_sym_SEMI] = ACTIONS(7244),
    [anon_sym_done] = ACTIONS(7244),
    [anon_sym_PIPE] = ACTIONS(7244),
    [anon_sym_SEMI_SEMI] = ACTIONS(7242),
    [anon_sym_PIPE_AMP] = ACTIONS(7242),
    [anon_sym_AMP_AMP] = ACTIONS(7242),
    [anon_sym_PIPE_PIPE] = ACTIONS(7242),
    [anon_sym_LT] = ACTIONS(7244),
    [anon_sym_GT] = ACTIONS(7244),
    [anon_sym_GT_GT] = ACTIONS(7242),
    [anon_sym_AMP_GT] = ACTIONS(7244),
    [anon_sym_AMP_GT_GT] = ACTIONS(7242),
    [anon_sym_LT_AMP] = ACTIONS(7242),
    [anon_sym_GT_AMP] = ACTIONS(7242),
    [anon_sym_LT_LT] = ACTIONS(7244),
    [anon_sym_LT_LT_DASH] = ACTIONS(7242),
    [anon_sym_LT_LT_LT] = ACTIONS(7242),
    [anon_sym_DOLLAR] = ACTIONS(7244),
    [sym__special_character] = ACTIONS(7242),
    [anon_sym_DQUOTE] = ACTIONS(7242),
    [sym_raw_string] = ACTIONS(7242),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7242),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7242),
    [anon_sym_BQUOTE] = ACTIONS(7242),
    [anon_sym_LT_LPAREN] = ACTIONS(7242),
    [anon_sym_GT_LPAREN] = ACTIONS(7242),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7244),
    [sym_word] = ACTIONS(7244),
    [anon_sym_LF] = ACTIONS(7242),
    [anon_sym_AMP] = ACTIONS(7244),
  },
  [4073] = {
    [sym__simple_heredoc_body] = ACTIONS(8340),
    [sym__heredoc_body_beginning] = ACTIONS(8340),
    [sym_file_descriptor] = ACTIONS(8340),
    [sym__concat] = ACTIONS(8340),
    [anon_sym_SEMI] = ACTIONS(8342),
    [anon_sym_done] = ACTIONS(8342),
    [anon_sym_PIPE] = ACTIONS(8342),
    [anon_sym_SEMI_SEMI] = ACTIONS(8340),
    [anon_sym_PIPE_AMP] = ACTIONS(8340),
    [anon_sym_AMP_AMP] = ACTIONS(8340),
    [anon_sym_PIPE_PIPE] = ACTIONS(8340),
    [anon_sym_EQ_TILDE] = ACTIONS(8342),
    [anon_sym_EQ_EQ] = ACTIONS(8342),
    [anon_sym_LT] = ACTIONS(8342),
    [anon_sym_GT] = ACTIONS(8342),
    [anon_sym_GT_GT] = ACTIONS(8340),
    [anon_sym_AMP_GT] = ACTIONS(8342),
    [anon_sym_AMP_GT_GT] = ACTIONS(8340),
    [anon_sym_LT_AMP] = ACTIONS(8340),
    [anon_sym_GT_AMP] = ACTIONS(8340),
    [anon_sym_LT_LT] = ACTIONS(8342),
    [anon_sym_LT_LT_DASH] = ACTIONS(8340),
    [anon_sym_LT_LT_LT] = ACTIONS(8340),
    [anon_sym_DOLLAR] = ACTIONS(8342),
    [sym__special_character] = ACTIONS(8340),
    [anon_sym_DQUOTE] = ACTIONS(8340),
    [sym_raw_string] = ACTIONS(8340),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8340),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [anon_sym_LT_LPAREN] = ACTIONS(8340),
    [anon_sym_GT_LPAREN] = ACTIONS(8340),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8342),
    [anon_sym_LF] = ACTIONS(8340),
    [anon_sym_AMP] = ACTIONS(8342),
  },
  [4074] = {
    [sym__simple_heredoc_body] = ACTIONS(8344),
    [sym__heredoc_body_beginning] = ACTIONS(8344),
    [sym_file_descriptor] = ACTIONS(8344),
    [sym__concat] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [anon_sym_done] = ACTIONS(8346),
    [anon_sym_PIPE] = ACTIONS(8346),
    [anon_sym_SEMI_SEMI] = ACTIONS(8344),
    [anon_sym_PIPE_AMP] = ACTIONS(8344),
    [anon_sym_AMP_AMP] = ACTIONS(8344),
    [anon_sym_PIPE_PIPE] = ACTIONS(8344),
    [anon_sym_EQ_TILDE] = ACTIONS(8346),
    [anon_sym_EQ_EQ] = ACTIONS(8346),
    [anon_sym_LT] = ACTIONS(8346),
    [anon_sym_GT] = ACTIONS(8346),
    [anon_sym_GT_GT] = ACTIONS(8344),
    [anon_sym_AMP_GT] = ACTIONS(8346),
    [anon_sym_AMP_GT_GT] = ACTIONS(8344),
    [anon_sym_LT_AMP] = ACTIONS(8344),
    [anon_sym_GT_AMP] = ACTIONS(8344),
    [anon_sym_LT_LT] = ACTIONS(8346),
    [anon_sym_LT_LT_DASH] = ACTIONS(8344),
    [anon_sym_LT_LT_LT] = ACTIONS(8344),
    [anon_sym_DOLLAR] = ACTIONS(8346),
    [sym__special_character] = ACTIONS(8344),
    [anon_sym_DQUOTE] = ACTIONS(8344),
    [sym_raw_string] = ACTIONS(8344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8344),
    [anon_sym_BQUOTE] = ACTIONS(8344),
    [anon_sym_LT_LPAREN] = ACTIONS(8344),
    [anon_sym_GT_LPAREN] = ACTIONS(8344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8346),
    [anon_sym_LF] = ACTIONS(8344),
    [anon_sym_AMP] = ACTIONS(8346),
  },
  [4075] = {
    [sym__simple_heredoc_body] = ACTIONS(5674),
    [sym__heredoc_body_beginning] = ACTIONS(5674),
    [sym_file_descriptor] = ACTIONS(5674),
    [sym__concat] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(5676),
    [anon_sym_done] = ACTIONS(5674),
    [anon_sym_fi] = ACTIONS(5674),
    [anon_sym_elif] = ACTIONS(5674),
    [anon_sym_else] = ACTIONS(5674),
    [anon_sym_esac] = ACTIONS(5674),
    [anon_sym_PIPE] = ACTIONS(5676),
    [anon_sym_SEMI_SEMI] = ACTIONS(5674),
    [anon_sym_PIPE_AMP] = ACTIONS(5674),
    [anon_sym_AMP_AMP] = ACTIONS(5674),
    [anon_sym_PIPE_PIPE] = ACTIONS(5674),
    [anon_sym_LT] = ACTIONS(5676),
    [anon_sym_GT] = ACTIONS(5676),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_AMP_GT] = ACTIONS(5676),
    [anon_sym_AMP_GT_GT] = ACTIONS(5674),
    [anon_sym_LT_AMP] = ACTIONS(5674),
    [anon_sym_GT_AMP] = ACTIONS(5674),
    [anon_sym_LT_LT] = ACTIONS(5676),
    [anon_sym_LT_LT_DASH] = ACTIONS(5674),
    [anon_sym_LT_LT_LT] = ACTIONS(5674),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5674),
    [anon_sym_AMP] = ACTIONS(5676),
  },
  [4076] = {
    [sym__simple_heredoc_body] = ACTIONS(5708),
    [sym__heredoc_body_beginning] = ACTIONS(5708),
    [sym_file_descriptor] = ACTIONS(5708),
    [sym__concat] = ACTIONS(5708),
    [anon_sym_SEMI] = ACTIONS(5710),
    [anon_sym_done] = ACTIONS(5708),
    [anon_sym_fi] = ACTIONS(5708),
    [anon_sym_elif] = ACTIONS(5708),
    [anon_sym_else] = ACTIONS(5708),
    [anon_sym_esac] = ACTIONS(5708),
    [anon_sym_PIPE] = ACTIONS(5710),
    [anon_sym_SEMI_SEMI] = ACTIONS(5708),
    [anon_sym_PIPE_AMP] = ACTIONS(5708),
    [anon_sym_AMP_AMP] = ACTIONS(5708),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_LT] = ACTIONS(5710),
    [anon_sym_GT] = ACTIONS(5710),
    [anon_sym_GT_GT] = ACTIONS(5708),
    [anon_sym_AMP_GT] = ACTIONS(5710),
    [anon_sym_AMP_GT_GT] = ACTIONS(5708),
    [anon_sym_LT_AMP] = ACTIONS(5708),
    [anon_sym_GT_AMP] = ACTIONS(5708),
    [anon_sym_LT_LT] = ACTIONS(5710),
    [anon_sym_LT_LT_DASH] = ACTIONS(5708),
    [anon_sym_LT_LT_LT] = ACTIONS(5708),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5708),
    [anon_sym_AMP] = ACTIONS(5710),
  },
  [4077] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(9708),
    [sym_comment] = ACTIONS(57),
  },
  [4078] = {
    [anon_sym_RBRACE] = ACTIONS(9708),
    [sym_comment] = ACTIONS(57),
  },
  [4079] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(9710),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [4080] = {
    [sym_concatenation] = STATE(4267),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4267),
    [anon_sym_RBRACE] = ACTIONS(9712),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_DASH] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9716),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_COLON_QMARK] = ACTIONS(9714),
    [anon_sym_COLON_DASH] = ACTIONS(9714),
    [anon_sym_PERCENT] = ACTIONS(9714),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4081] = {
    [sym__simple_heredoc_body] = ACTIONS(5725),
    [sym__heredoc_body_beginning] = ACTIONS(5725),
    [sym_file_descriptor] = ACTIONS(5725),
    [sym__concat] = ACTIONS(5725),
    [anon_sym_SEMI] = ACTIONS(5727),
    [anon_sym_done] = ACTIONS(5725),
    [anon_sym_fi] = ACTIONS(5725),
    [anon_sym_elif] = ACTIONS(5725),
    [anon_sym_else] = ACTIONS(5725),
    [anon_sym_esac] = ACTIONS(5725),
    [anon_sym_PIPE] = ACTIONS(5727),
    [anon_sym_SEMI_SEMI] = ACTIONS(5725),
    [anon_sym_PIPE_AMP] = ACTIONS(5725),
    [anon_sym_AMP_AMP] = ACTIONS(5725),
    [anon_sym_PIPE_PIPE] = ACTIONS(5725),
    [anon_sym_LT] = ACTIONS(5727),
    [anon_sym_GT] = ACTIONS(5727),
    [anon_sym_GT_GT] = ACTIONS(5725),
    [anon_sym_AMP_GT] = ACTIONS(5727),
    [anon_sym_AMP_GT_GT] = ACTIONS(5725),
    [anon_sym_LT_AMP] = ACTIONS(5725),
    [anon_sym_GT_AMP] = ACTIONS(5725),
    [anon_sym_LT_LT] = ACTIONS(5727),
    [anon_sym_LT_LT_DASH] = ACTIONS(5725),
    [anon_sym_LT_LT_LT] = ACTIONS(5725),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5725),
    [anon_sym_AMP] = ACTIONS(5727),
  },
  [4082] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9712),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4083] = {
    [sym_concatenation] = STATE(4268),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4268),
    [anon_sym_RBRACE] = ACTIONS(9708),
    [anon_sym_EQ] = ACTIONS(9718),
    [anon_sym_DASH] = ACTIONS(9718),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9720),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9718),
    [anon_sym_COLON_QMARK] = ACTIONS(9718),
    [anon_sym_COLON_DASH] = ACTIONS(9718),
    [anon_sym_PERCENT] = ACTIONS(9718),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4084] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9708),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4085] = {
    [sym__simple_heredoc_body] = ACTIONS(5770),
    [sym__heredoc_body_beginning] = ACTIONS(5770),
    [sym_file_descriptor] = ACTIONS(5770),
    [sym__concat] = ACTIONS(5770),
    [anon_sym_SEMI] = ACTIONS(5772),
    [anon_sym_done] = ACTIONS(5770),
    [anon_sym_fi] = ACTIONS(5770),
    [anon_sym_elif] = ACTIONS(5770),
    [anon_sym_else] = ACTIONS(5770),
    [anon_sym_esac] = ACTIONS(5770),
    [anon_sym_PIPE] = ACTIONS(5772),
    [anon_sym_SEMI_SEMI] = ACTIONS(5770),
    [anon_sym_PIPE_AMP] = ACTIONS(5770),
    [anon_sym_AMP_AMP] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5770),
    [anon_sym_LT] = ACTIONS(5772),
    [anon_sym_GT] = ACTIONS(5772),
    [anon_sym_GT_GT] = ACTIONS(5770),
    [anon_sym_AMP_GT] = ACTIONS(5772),
    [anon_sym_AMP_GT_GT] = ACTIONS(5770),
    [anon_sym_LT_AMP] = ACTIONS(5770),
    [anon_sym_GT_AMP] = ACTIONS(5770),
    [anon_sym_LT_LT] = ACTIONS(5772),
    [anon_sym_LT_LT_DASH] = ACTIONS(5770),
    [anon_sym_LT_LT_LT] = ACTIONS(5770),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5770),
    [anon_sym_AMP] = ACTIONS(5772),
  },
  [4086] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9722),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4087] = {
    [sym__simple_heredoc_body] = ACTIONS(5674),
    [sym__heredoc_body_beginning] = ACTIONS(5674),
    [sym_file_descriptor] = ACTIONS(5674),
    [sym__concat] = ACTIONS(5674),
    [sym_variable_name] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(5676),
    [anon_sym_fi] = ACTIONS(5676),
    [anon_sym_elif] = ACTIONS(5676),
    [anon_sym_else] = ACTIONS(5676),
    [anon_sym_PIPE] = ACTIONS(5676),
    [anon_sym_SEMI_SEMI] = ACTIONS(5674),
    [anon_sym_PIPE_AMP] = ACTIONS(5674),
    [anon_sym_AMP_AMP] = ACTIONS(5674),
    [anon_sym_PIPE_PIPE] = ACTIONS(5674),
    [anon_sym_LT] = ACTIONS(5676),
    [anon_sym_GT] = ACTIONS(5676),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_AMP_GT] = ACTIONS(5676),
    [anon_sym_AMP_GT_GT] = ACTIONS(5674),
    [anon_sym_LT_AMP] = ACTIONS(5674),
    [anon_sym_GT_AMP] = ACTIONS(5674),
    [anon_sym_LT_LT] = ACTIONS(5676),
    [anon_sym_LT_LT_DASH] = ACTIONS(5674),
    [anon_sym_LT_LT_LT] = ACTIONS(5674),
    [anon_sym_DOLLAR] = ACTIONS(5676),
    [sym__special_character] = ACTIONS(5674),
    [anon_sym_DQUOTE] = ACTIONS(5674),
    [sym_raw_string] = ACTIONS(5674),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5674),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5674),
    [anon_sym_BQUOTE] = ACTIONS(5674),
    [anon_sym_LT_LPAREN] = ACTIONS(5674),
    [anon_sym_GT_LPAREN] = ACTIONS(5674),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5676),
    [anon_sym_LF] = ACTIONS(5674),
    [anon_sym_AMP] = ACTIONS(5676),
  },
  [4088] = {
    [sym__simple_heredoc_body] = ACTIONS(5708),
    [sym__heredoc_body_beginning] = ACTIONS(5708),
    [sym_file_descriptor] = ACTIONS(5708),
    [sym__concat] = ACTIONS(5708),
    [sym_variable_name] = ACTIONS(5708),
    [anon_sym_SEMI] = ACTIONS(5710),
    [anon_sym_fi] = ACTIONS(5710),
    [anon_sym_elif] = ACTIONS(5710),
    [anon_sym_else] = ACTIONS(5710),
    [anon_sym_PIPE] = ACTIONS(5710),
    [anon_sym_SEMI_SEMI] = ACTIONS(5708),
    [anon_sym_PIPE_AMP] = ACTIONS(5708),
    [anon_sym_AMP_AMP] = ACTIONS(5708),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_LT] = ACTIONS(5710),
    [anon_sym_GT] = ACTIONS(5710),
    [anon_sym_GT_GT] = ACTIONS(5708),
    [anon_sym_AMP_GT] = ACTIONS(5710),
    [anon_sym_AMP_GT_GT] = ACTIONS(5708),
    [anon_sym_LT_AMP] = ACTIONS(5708),
    [anon_sym_GT_AMP] = ACTIONS(5708),
    [anon_sym_LT_LT] = ACTIONS(5710),
    [anon_sym_LT_LT_DASH] = ACTIONS(5708),
    [anon_sym_LT_LT_LT] = ACTIONS(5708),
    [anon_sym_DOLLAR] = ACTIONS(5710),
    [sym__special_character] = ACTIONS(5708),
    [anon_sym_DQUOTE] = ACTIONS(5708),
    [sym_raw_string] = ACTIONS(5708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5708),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5708),
    [anon_sym_BQUOTE] = ACTIONS(5708),
    [anon_sym_LT_LPAREN] = ACTIONS(5708),
    [anon_sym_GT_LPAREN] = ACTIONS(5708),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5710),
    [anon_sym_LF] = ACTIONS(5708),
    [anon_sym_AMP] = ACTIONS(5710),
  },
  [4089] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(9724),
    [sym_comment] = ACTIONS(57),
  },
  [4090] = {
    [anon_sym_RBRACE] = ACTIONS(9724),
    [sym_comment] = ACTIONS(57),
  },
  [4091] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(9726),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [4092] = {
    [sym_concatenation] = STATE(4273),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4273),
    [anon_sym_RBRACE] = ACTIONS(9728),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_DASH] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9732),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_COLON_QMARK] = ACTIONS(9730),
    [anon_sym_COLON_DASH] = ACTIONS(9730),
    [anon_sym_PERCENT] = ACTIONS(9730),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4093] = {
    [sym__simple_heredoc_body] = ACTIONS(5725),
    [sym__heredoc_body_beginning] = ACTIONS(5725),
    [sym_file_descriptor] = ACTIONS(5725),
    [sym__concat] = ACTIONS(5725),
    [sym_variable_name] = ACTIONS(5725),
    [anon_sym_SEMI] = ACTIONS(5727),
    [anon_sym_fi] = ACTIONS(5727),
    [anon_sym_elif] = ACTIONS(5727),
    [anon_sym_else] = ACTIONS(5727),
    [anon_sym_PIPE] = ACTIONS(5727),
    [anon_sym_SEMI_SEMI] = ACTIONS(5725),
    [anon_sym_PIPE_AMP] = ACTIONS(5725),
    [anon_sym_AMP_AMP] = ACTIONS(5725),
    [anon_sym_PIPE_PIPE] = ACTIONS(5725),
    [anon_sym_LT] = ACTIONS(5727),
    [anon_sym_GT] = ACTIONS(5727),
    [anon_sym_GT_GT] = ACTIONS(5725),
    [anon_sym_AMP_GT] = ACTIONS(5727),
    [anon_sym_AMP_GT_GT] = ACTIONS(5725),
    [anon_sym_LT_AMP] = ACTIONS(5725),
    [anon_sym_GT_AMP] = ACTIONS(5725),
    [anon_sym_LT_LT] = ACTIONS(5727),
    [anon_sym_LT_LT_DASH] = ACTIONS(5725),
    [anon_sym_LT_LT_LT] = ACTIONS(5725),
    [anon_sym_DOLLAR] = ACTIONS(5727),
    [sym__special_character] = ACTIONS(5725),
    [anon_sym_DQUOTE] = ACTIONS(5725),
    [sym_raw_string] = ACTIONS(5725),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5725),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5725),
    [anon_sym_BQUOTE] = ACTIONS(5725),
    [anon_sym_LT_LPAREN] = ACTIONS(5725),
    [anon_sym_GT_LPAREN] = ACTIONS(5725),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5727),
    [anon_sym_LF] = ACTIONS(5725),
    [anon_sym_AMP] = ACTIONS(5727),
  },
  [4094] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9728),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4095] = {
    [sym_concatenation] = STATE(4274),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4274),
    [anon_sym_RBRACE] = ACTIONS(9724),
    [anon_sym_EQ] = ACTIONS(9734),
    [anon_sym_DASH] = ACTIONS(9734),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9736),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9734),
    [anon_sym_COLON_QMARK] = ACTIONS(9734),
    [anon_sym_COLON_DASH] = ACTIONS(9734),
    [anon_sym_PERCENT] = ACTIONS(9734),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4096] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9724),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4097] = {
    [sym__simple_heredoc_body] = ACTIONS(5770),
    [sym__heredoc_body_beginning] = ACTIONS(5770),
    [sym_file_descriptor] = ACTIONS(5770),
    [sym__concat] = ACTIONS(5770),
    [sym_variable_name] = ACTIONS(5770),
    [anon_sym_SEMI] = ACTIONS(5772),
    [anon_sym_fi] = ACTIONS(5772),
    [anon_sym_elif] = ACTIONS(5772),
    [anon_sym_else] = ACTIONS(5772),
    [anon_sym_PIPE] = ACTIONS(5772),
    [anon_sym_SEMI_SEMI] = ACTIONS(5770),
    [anon_sym_PIPE_AMP] = ACTIONS(5770),
    [anon_sym_AMP_AMP] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5770),
    [anon_sym_LT] = ACTIONS(5772),
    [anon_sym_GT] = ACTIONS(5772),
    [anon_sym_GT_GT] = ACTIONS(5770),
    [anon_sym_AMP_GT] = ACTIONS(5772),
    [anon_sym_AMP_GT_GT] = ACTIONS(5770),
    [anon_sym_LT_AMP] = ACTIONS(5770),
    [anon_sym_GT_AMP] = ACTIONS(5770),
    [anon_sym_LT_LT] = ACTIONS(5772),
    [anon_sym_LT_LT_DASH] = ACTIONS(5770),
    [anon_sym_LT_LT_LT] = ACTIONS(5770),
    [anon_sym_DOLLAR] = ACTIONS(5772),
    [sym__special_character] = ACTIONS(5770),
    [anon_sym_DQUOTE] = ACTIONS(5770),
    [sym_raw_string] = ACTIONS(5770),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5770),
    [anon_sym_BQUOTE] = ACTIONS(5770),
    [anon_sym_LT_LPAREN] = ACTIONS(5770),
    [anon_sym_GT_LPAREN] = ACTIONS(5770),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5772),
    [anon_sym_LF] = ACTIONS(5770),
    [anon_sym_AMP] = ACTIONS(5772),
  },
  [4098] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4099] = {
    [sym_string] = STATE(3444),
    [sym__simple_heredoc_body] = ACTIONS(4071),
    [sym__heredoc_body_beginning] = ACTIONS(4071),
    [sym_file_descriptor] = ACTIONS(4071),
    [sym_variable_name] = ACTIONS(4071),
    [anon_sym_SEMI] = ACTIONS(4073),
    [anon_sym_fi] = ACTIONS(4073),
    [anon_sym_PIPE] = ACTIONS(4073),
    [anon_sym_SEMI_SEMI] = ACTIONS(4071),
    [anon_sym_PIPE_AMP] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_PIPE_PIPE] = ACTIONS(4071),
    [anon_sym_LT] = ACTIONS(4073),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_GT_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT] = ACTIONS(4073),
    [anon_sym_AMP_GT_GT] = ACTIONS(4071),
    [anon_sym_LT_AMP] = ACTIONS(4071),
    [anon_sym_GT_AMP] = ACTIONS(4071),
    [anon_sym_LT_LT] = ACTIONS(4073),
    [anon_sym_LT_LT_DASH] = ACTIONS(4071),
    [anon_sym_LT_LT_LT] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(9740),
    [anon_sym_DOLLAR] = ACTIONS(9740),
    [sym__special_character] = ACTIONS(4071),
    [anon_sym_DQUOTE] = ACTIONS(6473),
    [sym_raw_string] = ACTIONS(7701),
    [anon_sym_POUND] = ACTIONS(7699),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4071),
    [anon_sym_BQUOTE] = ACTIONS(4071),
    [anon_sym_LT_LPAREN] = ACTIONS(4071),
    [anon_sym_GT_LPAREN] = ACTIONS(4071),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7703),
    [anon_sym_STAR] = ACTIONS(7703),
    [anon_sym_AT] = ACTIONS(7703),
    [anon_sym_QMARK] = ACTIONS(7703),
    [anon_sym_0] = ACTIONS(7703),
    [anon_sym__] = ACTIONS(7703),
    [sym_word] = ACTIONS(4073),
    [anon_sym_LF] = ACTIONS(4071),
    [anon_sym_AMP] = ACTIONS(4073),
  },
  [4100] = {
    [sym__simple_heredoc_body] = ACTIONS(4111),
    [sym__heredoc_body_beginning] = ACTIONS(4111),
    [sym_file_descriptor] = ACTIONS(4111),
    [sym__concat] = ACTIONS(4111),
    [sym_variable_name] = ACTIONS(4111),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_fi] = ACTIONS(4113),
    [anon_sym_PIPE] = ACTIONS(4113),
    [anon_sym_SEMI_SEMI] = ACTIONS(4111),
    [anon_sym_PIPE_AMP] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_LT] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4113),
    [anon_sym_GT_GT] = ACTIONS(4111),
    [anon_sym_AMP_GT] = ACTIONS(4113),
    [anon_sym_AMP_GT_GT] = ACTIONS(4111),
    [anon_sym_LT_AMP] = ACTIONS(4111),
    [anon_sym_GT_AMP] = ACTIONS(4111),
    [anon_sym_LT_LT] = ACTIONS(4113),
    [anon_sym_LT_LT_DASH] = ACTIONS(4111),
    [anon_sym_LT_LT_LT] = ACTIONS(4111),
    [anon_sym_DOLLAR] = ACTIONS(4113),
    [sym__special_character] = ACTIONS(4111),
    [anon_sym_DQUOTE] = ACTIONS(4111),
    [sym_raw_string] = ACTIONS(4111),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4111),
    [anon_sym_BQUOTE] = ACTIONS(4111),
    [anon_sym_LT_LPAREN] = ACTIONS(4111),
    [anon_sym_GT_LPAREN] = ACTIONS(4111),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4113),
    [anon_sym_LF] = ACTIONS(4111),
    [anon_sym_AMP] = ACTIONS(4113),
  },
  [4101] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [sym_variable_name] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_fi] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym__special_character] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [4102] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(9742),
    [sym_comment] = ACTIONS(57),
  },
  [4103] = {
    [anon_sym_RBRACE] = ACTIONS(9742),
    [sym_comment] = ACTIONS(57),
  },
  [4104] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(9744),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [4105] = {
    [sym_concatenation] = STATE(4279),
    [sym_string] = STATE(4278),
    [sym_simple_expansion] = STATE(4278),
    [sym_string_expansion] = STATE(4278),
    [sym_expansion] = STATE(4278),
    [sym_command_substitution] = STATE(4278),
    [sym_process_substitution] = STATE(4278),
    [aux_sym__literal_repeat1] = STATE(4280),
    [anon_sym_RBRACE] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(9746),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9746),
  },
  [4106] = {
    [sym__simple_heredoc_body] = ACTIONS(4161),
    [sym__heredoc_body_beginning] = ACTIONS(4161),
    [sym_file_descriptor] = ACTIONS(4161),
    [sym__concat] = ACTIONS(4161),
    [sym_variable_name] = ACTIONS(4161),
    [anon_sym_SEMI] = ACTIONS(4163),
    [anon_sym_fi] = ACTIONS(4163),
    [anon_sym_PIPE] = ACTIONS(4163),
    [anon_sym_SEMI_SEMI] = ACTIONS(4161),
    [anon_sym_PIPE_AMP] = ACTIONS(4161),
    [anon_sym_AMP_AMP] = ACTIONS(4161),
    [anon_sym_PIPE_PIPE] = ACTIONS(4161),
    [anon_sym_LT] = ACTIONS(4163),
    [anon_sym_GT] = ACTIONS(4163),
    [anon_sym_GT_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT] = ACTIONS(4163),
    [anon_sym_AMP_GT_GT] = ACTIONS(4161),
    [anon_sym_LT_AMP] = ACTIONS(4161),
    [anon_sym_GT_AMP] = ACTIONS(4161),
    [anon_sym_LT_LT] = ACTIONS(4163),
    [anon_sym_LT_LT_DASH] = ACTIONS(4161),
    [anon_sym_LT_LT_LT] = ACTIONS(4161),
    [anon_sym_DOLLAR] = ACTIONS(4163),
    [sym__special_character] = ACTIONS(4161),
    [anon_sym_DQUOTE] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4161),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4161),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4161),
    [anon_sym_BQUOTE] = ACTIONS(4161),
    [anon_sym_LT_LPAREN] = ACTIONS(4161),
    [anon_sym_GT_LPAREN] = ACTIONS(4161),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4163),
    [anon_sym_LF] = ACTIONS(4161),
    [anon_sym_AMP] = ACTIONS(4163),
  },
  [4107] = {
    [sym_concatenation] = STATE(4283),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4283),
    [sym_regex] = ACTIONS(9748),
    [anon_sym_RBRACE] = ACTIONS(9750),
    [anon_sym_EQ] = ACTIONS(9752),
    [anon_sym_DASH] = ACTIONS(9752),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9754),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9752),
    [anon_sym_COLON_QMARK] = ACTIONS(9752),
    [anon_sym_COLON_DASH] = ACTIONS(9752),
    [anon_sym_PERCENT] = ACTIONS(9752),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4108] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9750),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4109] = {
    [sym_concatenation] = STATE(4285),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4285),
    [sym_regex] = ACTIONS(9756),
    [anon_sym_RBRACE] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9758),
    [anon_sym_DASH] = ACTIONS(9758),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9760),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9758),
    [anon_sym_COLON_QMARK] = ACTIONS(9758),
    [anon_sym_COLON_DASH] = ACTIONS(9758),
    [anon_sym_PERCENT] = ACTIONS(9758),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4110] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4111] = {
    [sym_concatenation] = STATE(4287),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4287),
    [anon_sym_RBRACE] = ACTIONS(9762),
    [anon_sym_EQ] = ACTIONS(9764),
    [anon_sym_DASH] = ACTIONS(9764),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9766),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9764),
    [anon_sym_COLON_QMARK] = ACTIONS(9764),
    [anon_sym_COLON_DASH] = ACTIONS(9764),
    [anon_sym_PERCENT] = ACTIONS(9764),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4112] = {
    [sym__simple_heredoc_body] = ACTIONS(4219),
    [sym__heredoc_body_beginning] = ACTIONS(4219),
    [sym_file_descriptor] = ACTIONS(4219),
    [sym__concat] = ACTIONS(4219),
    [sym_variable_name] = ACTIONS(4219),
    [anon_sym_SEMI] = ACTIONS(4221),
    [anon_sym_fi] = ACTIONS(4221),
    [anon_sym_PIPE] = ACTIONS(4221),
    [anon_sym_SEMI_SEMI] = ACTIONS(4219),
    [anon_sym_PIPE_AMP] = ACTIONS(4219),
    [anon_sym_AMP_AMP] = ACTIONS(4219),
    [anon_sym_PIPE_PIPE] = ACTIONS(4219),
    [anon_sym_LT] = ACTIONS(4221),
    [anon_sym_GT] = ACTIONS(4221),
    [anon_sym_GT_GT] = ACTIONS(4219),
    [anon_sym_AMP_GT] = ACTIONS(4221),
    [anon_sym_AMP_GT_GT] = ACTIONS(4219),
    [anon_sym_LT_AMP] = ACTIONS(4219),
    [anon_sym_GT_AMP] = ACTIONS(4219),
    [anon_sym_LT_LT] = ACTIONS(4221),
    [anon_sym_LT_LT_DASH] = ACTIONS(4219),
    [anon_sym_LT_LT_LT] = ACTIONS(4219),
    [anon_sym_DOLLAR] = ACTIONS(4221),
    [sym__special_character] = ACTIONS(4219),
    [anon_sym_DQUOTE] = ACTIONS(4219),
    [sym_raw_string] = ACTIONS(4219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4219),
    [anon_sym_BQUOTE] = ACTIONS(4219),
    [anon_sym_LT_LPAREN] = ACTIONS(4219),
    [anon_sym_GT_LPAREN] = ACTIONS(4219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4221),
    [anon_sym_LF] = ACTIONS(4219),
    [anon_sym_AMP] = ACTIONS(4221),
  },
  [4113] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9762),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4114] = {
    [sym_concatenation] = STATE(4285),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4285),
    [anon_sym_RBRACE] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9758),
    [anon_sym_DASH] = ACTIONS(9758),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9760),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9758),
    [anon_sym_COLON_QMARK] = ACTIONS(9758),
    [anon_sym_COLON_DASH] = ACTIONS(9758),
    [anon_sym_PERCENT] = ACTIONS(9758),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4115] = {
    [sym__simple_heredoc_body] = ACTIONS(4449),
    [sym__heredoc_body_beginning] = ACTIONS(4449),
    [sym_file_descriptor] = ACTIONS(4449),
    [sym_variable_name] = ACTIONS(4449),
    [anon_sym_SEMI] = ACTIONS(4451),
    [anon_sym_fi] = ACTIONS(4451),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_SEMI_SEMI] = ACTIONS(4449),
    [anon_sym_PIPE_AMP] = ACTIONS(4449),
    [anon_sym_AMP_AMP] = ACTIONS(4449),
    [anon_sym_PIPE_PIPE] = ACTIONS(4449),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_GT_GT] = ACTIONS(4449),
    [anon_sym_AMP_GT] = ACTIONS(4451),
    [anon_sym_AMP_GT_GT] = ACTIONS(4449),
    [anon_sym_LT_AMP] = ACTIONS(4449),
    [anon_sym_GT_AMP] = ACTIONS(4449),
    [anon_sym_LT_LT] = ACTIONS(4451),
    [anon_sym_LT_LT_DASH] = ACTIONS(4449),
    [anon_sym_LT_LT_LT] = ACTIONS(4449),
    [anon_sym_DOLLAR] = ACTIONS(4451),
    [sym__special_character] = ACTIONS(4449),
    [anon_sym_DQUOTE] = ACTIONS(4449),
    [sym_raw_string] = ACTIONS(4449),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4449),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4449),
    [anon_sym_BQUOTE] = ACTIONS(4449),
    [anon_sym_LT_LPAREN] = ACTIONS(4449),
    [anon_sym_GT_LPAREN] = ACTIONS(4449),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4451),
    [sym_word] = ACTIONS(4451),
    [anon_sym_LF] = ACTIONS(4449),
    [anon_sym_AMP] = ACTIONS(4451),
  },
  [4116] = {
    [sym__simple_heredoc_body] = ACTIONS(5674),
    [sym__heredoc_body_beginning] = ACTIONS(5674),
    [sym_file_descriptor] = ACTIONS(5674),
    [sym__concat] = ACTIONS(5674),
    [sym_variable_name] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(5676),
    [anon_sym_fi] = ACTIONS(5676),
    [anon_sym_PIPE] = ACTIONS(5676),
    [anon_sym_SEMI_SEMI] = ACTIONS(5674),
    [anon_sym_PIPE_AMP] = ACTIONS(5674),
    [anon_sym_AMP_AMP] = ACTIONS(5674),
    [anon_sym_PIPE_PIPE] = ACTIONS(5674),
    [anon_sym_LT] = ACTIONS(5676),
    [anon_sym_GT] = ACTIONS(5676),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_AMP_GT] = ACTIONS(5676),
    [anon_sym_AMP_GT_GT] = ACTIONS(5674),
    [anon_sym_LT_AMP] = ACTIONS(5674),
    [anon_sym_GT_AMP] = ACTIONS(5674),
    [anon_sym_LT_LT] = ACTIONS(5676),
    [anon_sym_LT_LT_DASH] = ACTIONS(5674),
    [anon_sym_LT_LT_LT] = ACTIONS(5674),
    [anon_sym_DOLLAR] = ACTIONS(5676),
    [sym__special_character] = ACTIONS(5674),
    [anon_sym_DQUOTE] = ACTIONS(5674),
    [sym_raw_string] = ACTIONS(5674),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5674),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5674),
    [anon_sym_BQUOTE] = ACTIONS(5674),
    [anon_sym_LT_LPAREN] = ACTIONS(5674),
    [anon_sym_GT_LPAREN] = ACTIONS(5674),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5676),
    [sym_word] = ACTIONS(5676),
    [anon_sym_LF] = ACTIONS(5674),
    [anon_sym_AMP] = ACTIONS(5676),
  },
  [4117] = {
    [sym__simple_heredoc_body] = ACTIONS(5708),
    [sym__heredoc_body_beginning] = ACTIONS(5708),
    [sym_file_descriptor] = ACTIONS(5708),
    [sym__concat] = ACTIONS(5708),
    [sym_variable_name] = ACTIONS(5708),
    [anon_sym_SEMI] = ACTIONS(5710),
    [anon_sym_fi] = ACTIONS(5710),
    [anon_sym_PIPE] = ACTIONS(5710),
    [anon_sym_SEMI_SEMI] = ACTIONS(5708),
    [anon_sym_PIPE_AMP] = ACTIONS(5708),
    [anon_sym_AMP_AMP] = ACTIONS(5708),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_LT] = ACTIONS(5710),
    [anon_sym_GT] = ACTIONS(5710),
    [anon_sym_GT_GT] = ACTIONS(5708),
    [anon_sym_AMP_GT] = ACTIONS(5710),
    [anon_sym_AMP_GT_GT] = ACTIONS(5708),
    [anon_sym_LT_AMP] = ACTIONS(5708),
    [anon_sym_GT_AMP] = ACTIONS(5708),
    [anon_sym_LT_LT] = ACTIONS(5710),
    [anon_sym_LT_LT_DASH] = ACTIONS(5708),
    [anon_sym_LT_LT_LT] = ACTIONS(5708),
    [anon_sym_DOLLAR] = ACTIONS(5710),
    [sym__special_character] = ACTIONS(5708),
    [anon_sym_DQUOTE] = ACTIONS(5708),
    [sym_raw_string] = ACTIONS(5708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5708),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5708),
    [anon_sym_BQUOTE] = ACTIONS(5708),
    [anon_sym_LT_LPAREN] = ACTIONS(5708),
    [anon_sym_GT_LPAREN] = ACTIONS(5708),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5710),
    [sym_word] = ACTIONS(5710),
    [anon_sym_LF] = ACTIONS(5708),
    [anon_sym_AMP] = ACTIONS(5710),
  },
  [4118] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(9768),
    [sym_comment] = ACTIONS(57),
  },
  [4119] = {
    [anon_sym_RBRACE] = ACTIONS(9768),
    [sym_comment] = ACTIONS(57),
  },
  [4120] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(9770),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [4121] = {
    [sym_concatenation] = STATE(4291),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4291),
    [anon_sym_RBRACE] = ACTIONS(9772),
    [anon_sym_EQ] = ACTIONS(9774),
    [anon_sym_DASH] = ACTIONS(9774),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9776),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9774),
    [anon_sym_COLON_QMARK] = ACTIONS(9774),
    [anon_sym_COLON_DASH] = ACTIONS(9774),
    [anon_sym_PERCENT] = ACTIONS(9774),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4122] = {
    [sym__simple_heredoc_body] = ACTIONS(5725),
    [sym__heredoc_body_beginning] = ACTIONS(5725),
    [sym_file_descriptor] = ACTIONS(5725),
    [sym__concat] = ACTIONS(5725),
    [sym_variable_name] = ACTIONS(5725),
    [anon_sym_SEMI] = ACTIONS(5727),
    [anon_sym_fi] = ACTIONS(5727),
    [anon_sym_PIPE] = ACTIONS(5727),
    [anon_sym_SEMI_SEMI] = ACTIONS(5725),
    [anon_sym_PIPE_AMP] = ACTIONS(5725),
    [anon_sym_AMP_AMP] = ACTIONS(5725),
    [anon_sym_PIPE_PIPE] = ACTIONS(5725),
    [anon_sym_LT] = ACTIONS(5727),
    [anon_sym_GT] = ACTIONS(5727),
    [anon_sym_GT_GT] = ACTIONS(5725),
    [anon_sym_AMP_GT] = ACTIONS(5727),
    [anon_sym_AMP_GT_GT] = ACTIONS(5725),
    [anon_sym_LT_AMP] = ACTIONS(5725),
    [anon_sym_GT_AMP] = ACTIONS(5725),
    [anon_sym_LT_LT] = ACTIONS(5727),
    [anon_sym_LT_LT_DASH] = ACTIONS(5725),
    [anon_sym_LT_LT_LT] = ACTIONS(5725),
    [anon_sym_DOLLAR] = ACTIONS(5727),
    [sym__special_character] = ACTIONS(5725),
    [anon_sym_DQUOTE] = ACTIONS(5725),
    [sym_raw_string] = ACTIONS(5725),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5725),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5725),
    [anon_sym_BQUOTE] = ACTIONS(5725),
    [anon_sym_LT_LPAREN] = ACTIONS(5725),
    [anon_sym_GT_LPAREN] = ACTIONS(5725),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5727),
    [sym_word] = ACTIONS(5727),
    [anon_sym_LF] = ACTIONS(5725),
    [anon_sym_AMP] = ACTIONS(5727),
  },
  [4123] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9772),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4124] = {
    [sym_concatenation] = STATE(4292),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4292),
    [anon_sym_RBRACE] = ACTIONS(9768),
    [anon_sym_EQ] = ACTIONS(9778),
    [anon_sym_DASH] = ACTIONS(9778),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9780),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9778),
    [anon_sym_COLON_QMARK] = ACTIONS(9778),
    [anon_sym_COLON_DASH] = ACTIONS(9778),
    [anon_sym_PERCENT] = ACTIONS(9778),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4125] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9768),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4126] = {
    [sym__simple_heredoc_body] = ACTIONS(5770),
    [sym__heredoc_body_beginning] = ACTIONS(5770),
    [sym_file_descriptor] = ACTIONS(5770),
    [sym__concat] = ACTIONS(5770),
    [sym_variable_name] = ACTIONS(5770),
    [anon_sym_SEMI] = ACTIONS(5772),
    [anon_sym_fi] = ACTIONS(5772),
    [anon_sym_PIPE] = ACTIONS(5772),
    [anon_sym_SEMI_SEMI] = ACTIONS(5770),
    [anon_sym_PIPE_AMP] = ACTIONS(5770),
    [anon_sym_AMP_AMP] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5770),
    [anon_sym_LT] = ACTIONS(5772),
    [anon_sym_GT] = ACTIONS(5772),
    [anon_sym_GT_GT] = ACTIONS(5770),
    [anon_sym_AMP_GT] = ACTIONS(5772),
    [anon_sym_AMP_GT_GT] = ACTIONS(5770),
    [anon_sym_LT_AMP] = ACTIONS(5770),
    [anon_sym_GT_AMP] = ACTIONS(5770),
    [anon_sym_LT_LT] = ACTIONS(5772),
    [anon_sym_LT_LT_DASH] = ACTIONS(5770),
    [anon_sym_LT_LT_LT] = ACTIONS(5770),
    [anon_sym_DOLLAR] = ACTIONS(5772),
    [sym__special_character] = ACTIONS(5770),
    [anon_sym_DQUOTE] = ACTIONS(5770),
    [sym_raw_string] = ACTIONS(5770),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5770),
    [anon_sym_BQUOTE] = ACTIONS(5770),
    [anon_sym_LT_LPAREN] = ACTIONS(5770),
    [anon_sym_GT_LPAREN] = ACTIONS(5770),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5772),
    [sym_word] = ACTIONS(5772),
    [anon_sym_LF] = ACTIONS(5770),
    [anon_sym_AMP] = ACTIONS(5772),
  },
  [4127] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9782),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4128] = {
    [sym__simple_heredoc_body] = ACTIONS(5674),
    [sym__heredoc_body_beginning] = ACTIONS(5674),
    [sym_file_descriptor] = ACTIONS(5674),
    [sym__concat] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(5676),
    [anon_sym_fi] = ACTIONS(5676),
    [anon_sym_PIPE] = ACTIONS(5676),
    [anon_sym_SEMI_SEMI] = ACTIONS(5674),
    [anon_sym_PIPE_AMP] = ACTIONS(5674),
    [anon_sym_AMP_AMP] = ACTIONS(5674),
    [anon_sym_PIPE_PIPE] = ACTIONS(5674),
    [anon_sym_LT] = ACTIONS(5676),
    [anon_sym_GT] = ACTIONS(5676),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_AMP_GT] = ACTIONS(5676),
    [anon_sym_AMP_GT_GT] = ACTIONS(5674),
    [anon_sym_LT_AMP] = ACTIONS(5674),
    [anon_sym_GT_AMP] = ACTIONS(5674),
    [anon_sym_LT_LT] = ACTIONS(5676),
    [anon_sym_LT_LT_DASH] = ACTIONS(5674),
    [anon_sym_LT_LT_LT] = ACTIONS(5674),
    [anon_sym_DOLLAR] = ACTIONS(5676),
    [sym__special_character] = ACTIONS(5674),
    [anon_sym_DQUOTE] = ACTIONS(5674),
    [sym_raw_string] = ACTIONS(5674),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5674),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5674),
    [anon_sym_BQUOTE] = ACTIONS(5674),
    [anon_sym_LT_LPAREN] = ACTIONS(5674),
    [anon_sym_GT_LPAREN] = ACTIONS(5674),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5676),
    [sym_word] = ACTIONS(5676),
    [anon_sym_LF] = ACTIONS(5674),
    [anon_sym_AMP] = ACTIONS(5676),
  },
  [4129] = {
    [sym__simple_heredoc_body] = ACTIONS(5708),
    [sym__heredoc_body_beginning] = ACTIONS(5708),
    [sym_file_descriptor] = ACTIONS(5708),
    [sym__concat] = ACTIONS(5708),
    [anon_sym_SEMI] = ACTIONS(5710),
    [anon_sym_fi] = ACTIONS(5710),
    [anon_sym_PIPE] = ACTIONS(5710),
    [anon_sym_SEMI_SEMI] = ACTIONS(5708),
    [anon_sym_PIPE_AMP] = ACTIONS(5708),
    [anon_sym_AMP_AMP] = ACTIONS(5708),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_LT] = ACTIONS(5710),
    [anon_sym_GT] = ACTIONS(5710),
    [anon_sym_GT_GT] = ACTIONS(5708),
    [anon_sym_AMP_GT] = ACTIONS(5710),
    [anon_sym_AMP_GT_GT] = ACTIONS(5708),
    [anon_sym_LT_AMP] = ACTIONS(5708),
    [anon_sym_GT_AMP] = ACTIONS(5708),
    [anon_sym_LT_LT] = ACTIONS(5710),
    [anon_sym_LT_LT_DASH] = ACTIONS(5708),
    [anon_sym_LT_LT_LT] = ACTIONS(5708),
    [anon_sym_DOLLAR] = ACTIONS(5710),
    [sym__special_character] = ACTIONS(5708),
    [anon_sym_DQUOTE] = ACTIONS(5708),
    [sym_raw_string] = ACTIONS(5708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5708),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5708),
    [anon_sym_BQUOTE] = ACTIONS(5708),
    [anon_sym_LT_LPAREN] = ACTIONS(5708),
    [anon_sym_GT_LPAREN] = ACTIONS(5708),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5710),
    [sym_word] = ACTIONS(5710),
    [anon_sym_LF] = ACTIONS(5708),
    [anon_sym_AMP] = ACTIONS(5710),
  },
  [4130] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(9784),
    [sym_comment] = ACTIONS(57),
  },
  [4131] = {
    [anon_sym_RBRACE] = ACTIONS(9784),
    [sym_comment] = ACTIONS(57),
  },
  [4132] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(9786),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [4133] = {
    [sym_concatenation] = STATE(4297),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4297),
    [anon_sym_RBRACE] = ACTIONS(9788),
    [anon_sym_EQ] = ACTIONS(9790),
    [anon_sym_DASH] = ACTIONS(9790),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9792),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9790),
    [anon_sym_COLON_QMARK] = ACTIONS(9790),
    [anon_sym_COLON_DASH] = ACTIONS(9790),
    [anon_sym_PERCENT] = ACTIONS(9790),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4134] = {
    [sym__simple_heredoc_body] = ACTIONS(5725),
    [sym__heredoc_body_beginning] = ACTIONS(5725),
    [sym_file_descriptor] = ACTIONS(5725),
    [sym__concat] = ACTIONS(5725),
    [anon_sym_SEMI] = ACTIONS(5727),
    [anon_sym_fi] = ACTIONS(5727),
    [anon_sym_PIPE] = ACTIONS(5727),
    [anon_sym_SEMI_SEMI] = ACTIONS(5725),
    [anon_sym_PIPE_AMP] = ACTIONS(5725),
    [anon_sym_AMP_AMP] = ACTIONS(5725),
    [anon_sym_PIPE_PIPE] = ACTIONS(5725),
    [anon_sym_LT] = ACTIONS(5727),
    [anon_sym_GT] = ACTIONS(5727),
    [anon_sym_GT_GT] = ACTIONS(5725),
    [anon_sym_AMP_GT] = ACTIONS(5727),
    [anon_sym_AMP_GT_GT] = ACTIONS(5725),
    [anon_sym_LT_AMP] = ACTIONS(5725),
    [anon_sym_GT_AMP] = ACTIONS(5725),
    [anon_sym_LT_LT] = ACTIONS(5727),
    [anon_sym_LT_LT_DASH] = ACTIONS(5725),
    [anon_sym_LT_LT_LT] = ACTIONS(5725),
    [anon_sym_DOLLAR] = ACTIONS(5727),
    [sym__special_character] = ACTIONS(5725),
    [anon_sym_DQUOTE] = ACTIONS(5725),
    [sym_raw_string] = ACTIONS(5725),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5725),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5725),
    [anon_sym_BQUOTE] = ACTIONS(5725),
    [anon_sym_LT_LPAREN] = ACTIONS(5725),
    [anon_sym_GT_LPAREN] = ACTIONS(5725),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5727),
    [sym_word] = ACTIONS(5727),
    [anon_sym_LF] = ACTIONS(5725),
    [anon_sym_AMP] = ACTIONS(5727),
  },
  [4135] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9788),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4136] = {
    [sym_concatenation] = STATE(4298),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4298),
    [anon_sym_RBRACE] = ACTIONS(9784),
    [anon_sym_EQ] = ACTIONS(9794),
    [anon_sym_DASH] = ACTIONS(9794),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9796),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9794),
    [anon_sym_COLON_QMARK] = ACTIONS(9794),
    [anon_sym_COLON_DASH] = ACTIONS(9794),
    [anon_sym_PERCENT] = ACTIONS(9794),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4137] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9784),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4138] = {
    [sym__simple_heredoc_body] = ACTIONS(5770),
    [sym__heredoc_body_beginning] = ACTIONS(5770),
    [sym_file_descriptor] = ACTIONS(5770),
    [sym__concat] = ACTIONS(5770),
    [anon_sym_SEMI] = ACTIONS(5772),
    [anon_sym_fi] = ACTIONS(5772),
    [anon_sym_PIPE] = ACTIONS(5772),
    [anon_sym_SEMI_SEMI] = ACTIONS(5770),
    [anon_sym_PIPE_AMP] = ACTIONS(5770),
    [anon_sym_AMP_AMP] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5770),
    [anon_sym_LT] = ACTIONS(5772),
    [anon_sym_GT] = ACTIONS(5772),
    [anon_sym_GT_GT] = ACTIONS(5770),
    [anon_sym_AMP_GT] = ACTIONS(5772),
    [anon_sym_AMP_GT_GT] = ACTIONS(5770),
    [anon_sym_LT_AMP] = ACTIONS(5770),
    [anon_sym_GT_AMP] = ACTIONS(5770),
    [anon_sym_LT_LT] = ACTIONS(5772),
    [anon_sym_LT_LT_DASH] = ACTIONS(5770),
    [anon_sym_LT_LT_LT] = ACTIONS(5770),
    [anon_sym_DOLLAR] = ACTIONS(5772),
    [sym__special_character] = ACTIONS(5770),
    [anon_sym_DQUOTE] = ACTIONS(5770),
    [sym_raw_string] = ACTIONS(5770),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5770),
    [anon_sym_BQUOTE] = ACTIONS(5770),
    [anon_sym_LT_LPAREN] = ACTIONS(5770),
    [anon_sym_GT_LPAREN] = ACTIONS(5770),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5772),
    [sym_word] = ACTIONS(5772),
    [anon_sym_LF] = ACTIONS(5770),
    [anon_sym_AMP] = ACTIONS(5772),
  },
  [4139] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9798),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4140] = {
    [sym__simple_heredoc_body] = ACTIONS(7198),
    [sym__heredoc_body_beginning] = ACTIONS(7198),
    [sym_file_descriptor] = ACTIONS(7198),
    [sym__concat] = ACTIONS(7198),
    [anon_sym_SEMI] = ACTIONS(7200),
    [anon_sym_fi] = ACTIONS(7200),
    [anon_sym_PIPE] = ACTIONS(7200),
    [anon_sym_SEMI_SEMI] = ACTIONS(7198),
    [anon_sym_PIPE_AMP] = ACTIONS(7198),
    [anon_sym_AMP_AMP] = ACTIONS(7198),
    [anon_sym_PIPE_PIPE] = ACTIONS(7198),
    [anon_sym_EQ_TILDE] = ACTIONS(7200),
    [anon_sym_EQ_EQ] = ACTIONS(7200),
    [anon_sym_LT] = ACTIONS(7200),
    [anon_sym_GT] = ACTIONS(7200),
    [anon_sym_GT_GT] = ACTIONS(7198),
    [anon_sym_AMP_GT] = ACTIONS(7200),
    [anon_sym_AMP_GT_GT] = ACTIONS(7198),
    [anon_sym_LT_AMP] = ACTIONS(7198),
    [anon_sym_GT_AMP] = ACTIONS(7198),
    [anon_sym_LT_LT] = ACTIONS(7200),
    [anon_sym_LT_LT_DASH] = ACTIONS(7198),
    [anon_sym_LT_LT_LT] = ACTIONS(7198),
    [anon_sym_DOLLAR] = ACTIONS(7200),
    [sym__special_character] = ACTIONS(7198),
    [anon_sym_DQUOTE] = ACTIONS(7198),
    [sym_raw_string] = ACTIONS(7198),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7198),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7198),
    [anon_sym_BQUOTE] = ACTIONS(7198),
    [anon_sym_LT_LPAREN] = ACTIONS(7198),
    [anon_sym_GT_LPAREN] = ACTIONS(7198),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7200),
    [anon_sym_LF] = ACTIONS(7198),
    [anon_sym_AMP] = ACTIONS(7200),
  },
  [4141] = {
    [sym__simple_heredoc_body] = ACTIONS(7202),
    [sym__heredoc_body_beginning] = ACTIONS(7202),
    [sym_file_descriptor] = ACTIONS(7202),
    [sym__concat] = ACTIONS(7202),
    [anon_sym_SEMI] = ACTIONS(7204),
    [anon_sym_fi] = ACTIONS(7204),
    [anon_sym_PIPE] = ACTIONS(7204),
    [anon_sym_SEMI_SEMI] = ACTIONS(7202),
    [anon_sym_PIPE_AMP] = ACTIONS(7202),
    [anon_sym_AMP_AMP] = ACTIONS(7202),
    [anon_sym_PIPE_PIPE] = ACTIONS(7202),
    [anon_sym_EQ_TILDE] = ACTIONS(7204),
    [anon_sym_EQ_EQ] = ACTIONS(7204),
    [anon_sym_LT] = ACTIONS(7204),
    [anon_sym_GT] = ACTIONS(7204),
    [anon_sym_GT_GT] = ACTIONS(7202),
    [anon_sym_AMP_GT] = ACTIONS(7204),
    [anon_sym_AMP_GT_GT] = ACTIONS(7202),
    [anon_sym_LT_AMP] = ACTIONS(7202),
    [anon_sym_GT_AMP] = ACTIONS(7202),
    [anon_sym_LT_LT] = ACTIONS(7204),
    [anon_sym_LT_LT_DASH] = ACTIONS(7202),
    [anon_sym_LT_LT_LT] = ACTIONS(7202),
    [anon_sym_DOLLAR] = ACTIONS(7204),
    [sym__special_character] = ACTIONS(7202),
    [anon_sym_DQUOTE] = ACTIONS(7202),
    [sym_raw_string] = ACTIONS(7202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7202),
    [anon_sym_BQUOTE] = ACTIONS(7202),
    [anon_sym_LT_LPAREN] = ACTIONS(7202),
    [anon_sym_GT_LPAREN] = ACTIONS(7202),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7204),
    [anon_sym_LF] = ACTIONS(7202),
    [anon_sym_AMP] = ACTIONS(7204),
  },
  [4142] = {
    [sym__simple_heredoc_body] = ACTIONS(7206),
    [sym__heredoc_body_beginning] = ACTIONS(7206),
    [sym_file_descriptor] = ACTIONS(7206),
    [sym__concat] = ACTIONS(7206),
    [anon_sym_SEMI] = ACTIONS(7208),
    [anon_sym_fi] = ACTIONS(7208),
    [anon_sym_PIPE] = ACTIONS(7208),
    [anon_sym_SEMI_SEMI] = ACTIONS(7206),
    [anon_sym_PIPE_AMP] = ACTIONS(7206),
    [anon_sym_AMP_AMP] = ACTIONS(7206),
    [anon_sym_PIPE_PIPE] = ACTIONS(7206),
    [anon_sym_EQ_TILDE] = ACTIONS(7208),
    [anon_sym_EQ_EQ] = ACTIONS(7208),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7206),
    [anon_sym_AMP_GT] = ACTIONS(7208),
    [anon_sym_AMP_GT_GT] = ACTIONS(7206),
    [anon_sym_LT_AMP] = ACTIONS(7206),
    [anon_sym_GT_AMP] = ACTIONS(7206),
    [anon_sym_LT_LT] = ACTIONS(7208),
    [anon_sym_LT_LT_DASH] = ACTIONS(7206),
    [anon_sym_LT_LT_LT] = ACTIONS(7206),
    [anon_sym_DOLLAR] = ACTIONS(7208),
    [sym__special_character] = ACTIONS(7206),
    [anon_sym_DQUOTE] = ACTIONS(7206),
    [sym_raw_string] = ACTIONS(7206),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7206),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7206),
    [anon_sym_BQUOTE] = ACTIONS(7206),
    [anon_sym_LT_LPAREN] = ACTIONS(7206),
    [anon_sym_GT_LPAREN] = ACTIONS(7206),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7208),
    [anon_sym_LF] = ACTIONS(7206),
    [anon_sym_AMP] = ACTIONS(7208),
  },
  [4143] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9800),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4144] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9802),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4145] = {
    [sym__simple_heredoc_body] = ACTIONS(7242),
    [sym__heredoc_body_beginning] = ACTIONS(7242),
    [sym_file_descriptor] = ACTIONS(7242),
    [sym__concat] = ACTIONS(7242),
    [anon_sym_SEMI] = ACTIONS(7244),
    [anon_sym_fi] = ACTIONS(7244),
    [anon_sym_PIPE] = ACTIONS(7244),
    [anon_sym_SEMI_SEMI] = ACTIONS(7242),
    [anon_sym_PIPE_AMP] = ACTIONS(7242),
    [anon_sym_AMP_AMP] = ACTIONS(7242),
    [anon_sym_PIPE_PIPE] = ACTIONS(7242),
    [anon_sym_EQ_TILDE] = ACTIONS(7244),
    [anon_sym_EQ_EQ] = ACTIONS(7244),
    [anon_sym_LT] = ACTIONS(7244),
    [anon_sym_GT] = ACTIONS(7244),
    [anon_sym_GT_GT] = ACTIONS(7242),
    [anon_sym_AMP_GT] = ACTIONS(7244),
    [anon_sym_AMP_GT_GT] = ACTIONS(7242),
    [anon_sym_LT_AMP] = ACTIONS(7242),
    [anon_sym_GT_AMP] = ACTIONS(7242),
    [anon_sym_LT_LT] = ACTIONS(7244),
    [anon_sym_LT_LT_DASH] = ACTIONS(7242),
    [anon_sym_LT_LT_LT] = ACTIONS(7242),
    [anon_sym_DOLLAR] = ACTIONS(7244),
    [sym__special_character] = ACTIONS(7242),
    [anon_sym_DQUOTE] = ACTIONS(7242),
    [sym_raw_string] = ACTIONS(7242),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7242),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7242),
    [anon_sym_BQUOTE] = ACTIONS(7242),
    [anon_sym_LT_LPAREN] = ACTIONS(7242),
    [anon_sym_GT_LPAREN] = ACTIONS(7242),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7244),
    [anon_sym_LF] = ACTIONS(7242),
    [anon_sym_AMP] = ACTIONS(7244),
  },
  [4146] = {
    [sym_string] = STATE(2891),
    [sym__simple_heredoc_body] = ACTIONS(4071),
    [sym__heredoc_body_beginning] = ACTIONS(4071),
    [sym_file_descriptor] = ACTIONS(4071),
    [anon_sym_SEMI] = ACTIONS(4073),
    [anon_sym_fi] = ACTIONS(4073),
    [anon_sym_PIPE] = ACTIONS(4073),
    [anon_sym_SEMI_SEMI] = ACTIONS(4071),
    [anon_sym_PIPE_AMP] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_PIPE_PIPE] = ACTIONS(4071),
    [anon_sym_LT] = ACTIONS(4073),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_GT_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT] = ACTIONS(4073),
    [anon_sym_AMP_GT_GT] = ACTIONS(4071),
    [anon_sym_LT_AMP] = ACTIONS(4071),
    [anon_sym_GT_AMP] = ACTIONS(4071),
    [anon_sym_LT_LT] = ACTIONS(4073),
    [anon_sym_LT_LT_DASH] = ACTIONS(4071),
    [anon_sym_LT_LT_LT] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(6359),
    [anon_sym_DOLLAR] = ACTIONS(6359),
    [anon_sym_DQUOTE] = ACTIONS(5002),
    [sym_raw_string] = ACTIONS(6361),
    [anon_sym_POUND] = ACTIONS(6359),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6363),
    [anon_sym_STAR] = ACTIONS(6365),
    [anon_sym_AT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6365),
    [anon_sym_0] = ACTIONS(6363),
    [anon_sym__] = ACTIONS(6363),
    [anon_sym_LF] = ACTIONS(4071),
    [anon_sym_AMP] = ACTIONS(4073),
  },
  [4147] = {
    [sym__simple_heredoc_body] = ACTIONS(7198),
    [sym__heredoc_body_beginning] = ACTIONS(7198),
    [sym_file_descriptor] = ACTIONS(7198),
    [sym__concat] = ACTIONS(7198),
    [sym_variable_name] = ACTIONS(7198),
    [anon_sym_SEMI] = ACTIONS(7200),
    [anon_sym_fi] = ACTIONS(7200),
    [anon_sym_elif] = ACTIONS(7200),
    [anon_sym_else] = ACTIONS(7200),
    [anon_sym_PIPE] = ACTIONS(7200),
    [anon_sym_SEMI_SEMI] = ACTIONS(7198),
    [anon_sym_PIPE_AMP] = ACTIONS(7198),
    [anon_sym_AMP_AMP] = ACTIONS(7198),
    [anon_sym_PIPE_PIPE] = ACTIONS(7198),
    [anon_sym_LT] = ACTIONS(7200),
    [anon_sym_GT] = ACTIONS(7200),
    [anon_sym_GT_GT] = ACTIONS(7198),
    [anon_sym_AMP_GT] = ACTIONS(7200),
    [anon_sym_AMP_GT_GT] = ACTIONS(7198),
    [anon_sym_LT_AMP] = ACTIONS(7198),
    [anon_sym_GT_AMP] = ACTIONS(7198),
    [anon_sym_LT_LT] = ACTIONS(7200),
    [anon_sym_LT_LT_DASH] = ACTIONS(7198),
    [anon_sym_LT_LT_LT] = ACTIONS(7198),
    [anon_sym_DOLLAR] = ACTIONS(7200),
    [sym__special_character] = ACTIONS(7198),
    [anon_sym_DQUOTE] = ACTIONS(7198),
    [sym_raw_string] = ACTIONS(7198),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7198),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7198),
    [anon_sym_BQUOTE] = ACTIONS(7198),
    [anon_sym_LT_LPAREN] = ACTIONS(7198),
    [anon_sym_GT_LPAREN] = ACTIONS(7198),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7200),
    [sym_word] = ACTIONS(7200),
    [anon_sym_LF] = ACTIONS(7198),
    [anon_sym_AMP] = ACTIONS(7200),
  },
  [4148] = {
    [sym__simple_heredoc_body] = ACTIONS(7202),
    [sym__heredoc_body_beginning] = ACTIONS(7202),
    [sym_file_descriptor] = ACTIONS(7202),
    [sym__concat] = ACTIONS(7202),
    [sym_variable_name] = ACTIONS(7202),
    [anon_sym_SEMI] = ACTIONS(7204),
    [anon_sym_fi] = ACTIONS(7204),
    [anon_sym_elif] = ACTIONS(7204),
    [anon_sym_else] = ACTIONS(7204),
    [anon_sym_PIPE] = ACTIONS(7204),
    [anon_sym_SEMI_SEMI] = ACTIONS(7202),
    [anon_sym_PIPE_AMP] = ACTIONS(7202),
    [anon_sym_AMP_AMP] = ACTIONS(7202),
    [anon_sym_PIPE_PIPE] = ACTIONS(7202),
    [anon_sym_LT] = ACTIONS(7204),
    [anon_sym_GT] = ACTIONS(7204),
    [anon_sym_GT_GT] = ACTIONS(7202),
    [anon_sym_AMP_GT] = ACTIONS(7204),
    [anon_sym_AMP_GT_GT] = ACTIONS(7202),
    [anon_sym_LT_AMP] = ACTIONS(7202),
    [anon_sym_GT_AMP] = ACTIONS(7202),
    [anon_sym_LT_LT] = ACTIONS(7204),
    [anon_sym_LT_LT_DASH] = ACTIONS(7202),
    [anon_sym_LT_LT_LT] = ACTIONS(7202),
    [anon_sym_DOLLAR] = ACTIONS(7204),
    [sym__special_character] = ACTIONS(7202),
    [anon_sym_DQUOTE] = ACTIONS(7202),
    [sym_raw_string] = ACTIONS(7202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7202),
    [anon_sym_BQUOTE] = ACTIONS(7202),
    [anon_sym_LT_LPAREN] = ACTIONS(7202),
    [anon_sym_GT_LPAREN] = ACTIONS(7202),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7204),
    [sym_word] = ACTIONS(7204),
    [anon_sym_LF] = ACTIONS(7202),
    [anon_sym_AMP] = ACTIONS(7204),
  },
  [4149] = {
    [sym__simple_heredoc_body] = ACTIONS(7206),
    [sym__heredoc_body_beginning] = ACTIONS(7206),
    [sym_file_descriptor] = ACTIONS(7206),
    [sym__concat] = ACTIONS(7206),
    [sym_variable_name] = ACTIONS(7206),
    [anon_sym_SEMI] = ACTIONS(7208),
    [anon_sym_fi] = ACTIONS(7208),
    [anon_sym_elif] = ACTIONS(7208),
    [anon_sym_else] = ACTIONS(7208),
    [anon_sym_PIPE] = ACTIONS(7208),
    [anon_sym_SEMI_SEMI] = ACTIONS(7206),
    [anon_sym_PIPE_AMP] = ACTIONS(7206),
    [anon_sym_AMP_AMP] = ACTIONS(7206),
    [anon_sym_PIPE_PIPE] = ACTIONS(7206),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7206),
    [anon_sym_AMP_GT] = ACTIONS(7208),
    [anon_sym_AMP_GT_GT] = ACTIONS(7206),
    [anon_sym_LT_AMP] = ACTIONS(7206),
    [anon_sym_GT_AMP] = ACTIONS(7206),
    [anon_sym_LT_LT] = ACTIONS(7208),
    [anon_sym_LT_LT_DASH] = ACTIONS(7206),
    [anon_sym_LT_LT_LT] = ACTIONS(7206),
    [anon_sym_DOLLAR] = ACTIONS(7208),
    [sym__special_character] = ACTIONS(7206),
    [anon_sym_DQUOTE] = ACTIONS(7206),
    [sym_raw_string] = ACTIONS(7206),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7206),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7206),
    [anon_sym_BQUOTE] = ACTIONS(7206),
    [anon_sym_LT_LPAREN] = ACTIONS(7206),
    [anon_sym_GT_LPAREN] = ACTIONS(7206),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7208),
    [sym_word] = ACTIONS(7208),
    [anon_sym_LF] = ACTIONS(7206),
    [anon_sym_AMP] = ACTIONS(7208),
  },
  [4150] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9804),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4151] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9806),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4152] = {
    [sym__simple_heredoc_body] = ACTIONS(7242),
    [sym__heredoc_body_beginning] = ACTIONS(7242),
    [sym_file_descriptor] = ACTIONS(7242),
    [sym__concat] = ACTIONS(7242),
    [sym_variable_name] = ACTIONS(7242),
    [anon_sym_SEMI] = ACTIONS(7244),
    [anon_sym_fi] = ACTIONS(7244),
    [anon_sym_elif] = ACTIONS(7244),
    [anon_sym_else] = ACTIONS(7244),
    [anon_sym_PIPE] = ACTIONS(7244),
    [anon_sym_SEMI_SEMI] = ACTIONS(7242),
    [anon_sym_PIPE_AMP] = ACTIONS(7242),
    [anon_sym_AMP_AMP] = ACTIONS(7242),
    [anon_sym_PIPE_PIPE] = ACTIONS(7242),
    [anon_sym_LT] = ACTIONS(7244),
    [anon_sym_GT] = ACTIONS(7244),
    [anon_sym_GT_GT] = ACTIONS(7242),
    [anon_sym_AMP_GT] = ACTIONS(7244),
    [anon_sym_AMP_GT_GT] = ACTIONS(7242),
    [anon_sym_LT_AMP] = ACTIONS(7242),
    [anon_sym_GT_AMP] = ACTIONS(7242),
    [anon_sym_LT_LT] = ACTIONS(7244),
    [anon_sym_LT_LT_DASH] = ACTIONS(7242),
    [anon_sym_LT_LT_LT] = ACTIONS(7242),
    [anon_sym_DOLLAR] = ACTIONS(7244),
    [sym__special_character] = ACTIONS(7242),
    [anon_sym_DQUOTE] = ACTIONS(7242),
    [sym_raw_string] = ACTIONS(7242),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7242),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7242),
    [anon_sym_BQUOTE] = ACTIONS(7242),
    [anon_sym_LT_LPAREN] = ACTIONS(7242),
    [anon_sym_GT_LPAREN] = ACTIONS(7242),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7244),
    [sym_word] = ACTIONS(7244),
    [anon_sym_LF] = ACTIONS(7242),
    [anon_sym_AMP] = ACTIONS(7244),
  },
  [4153] = {
    [sym__simple_heredoc_body] = ACTIONS(7198),
    [sym__heredoc_body_beginning] = ACTIONS(7198),
    [sym_file_descriptor] = ACTIONS(7198),
    [sym__concat] = ACTIONS(7198),
    [anon_sym_SEMI] = ACTIONS(7200),
    [anon_sym_fi] = ACTIONS(7200),
    [anon_sym_elif] = ACTIONS(7200),
    [anon_sym_else] = ACTIONS(7200),
    [anon_sym_PIPE] = ACTIONS(7200),
    [anon_sym_SEMI_SEMI] = ACTIONS(7198),
    [anon_sym_PIPE_AMP] = ACTIONS(7198),
    [anon_sym_AMP_AMP] = ACTIONS(7198),
    [anon_sym_PIPE_PIPE] = ACTIONS(7198),
    [anon_sym_LT] = ACTIONS(7200),
    [anon_sym_GT] = ACTIONS(7200),
    [anon_sym_GT_GT] = ACTIONS(7198),
    [anon_sym_AMP_GT] = ACTIONS(7200),
    [anon_sym_AMP_GT_GT] = ACTIONS(7198),
    [anon_sym_LT_AMP] = ACTIONS(7198),
    [anon_sym_GT_AMP] = ACTIONS(7198),
    [anon_sym_LT_LT] = ACTIONS(7200),
    [anon_sym_LT_LT_DASH] = ACTIONS(7198),
    [anon_sym_LT_LT_LT] = ACTIONS(7198),
    [anon_sym_DOLLAR] = ACTIONS(7200),
    [sym__special_character] = ACTIONS(7198),
    [anon_sym_DQUOTE] = ACTIONS(7198),
    [sym_raw_string] = ACTIONS(7198),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7198),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7198),
    [anon_sym_BQUOTE] = ACTIONS(7198),
    [anon_sym_LT_LPAREN] = ACTIONS(7198),
    [anon_sym_GT_LPAREN] = ACTIONS(7198),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7200),
    [sym_word] = ACTIONS(7200),
    [anon_sym_LF] = ACTIONS(7198),
    [anon_sym_AMP] = ACTIONS(7200),
  },
  [4154] = {
    [sym__simple_heredoc_body] = ACTIONS(7202),
    [sym__heredoc_body_beginning] = ACTIONS(7202),
    [sym_file_descriptor] = ACTIONS(7202),
    [sym__concat] = ACTIONS(7202),
    [anon_sym_SEMI] = ACTIONS(7204),
    [anon_sym_fi] = ACTIONS(7204),
    [anon_sym_elif] = ACTIONS(7204),
    [anon_sym_else] = ACTIONS(7204),
    [anon_sym_PIPE] = ACTIONS(7204),
    [anon_sym_SEMI_SEMI] = ACTIONS(7202),
    [anon_sym_PIPE_AMP] = ACTIONS(7202),
    [anon_sym_AMP_AMP] = ACTIONS(7202),
    [anon_sym_PIPE_PIPE] = ACTIONS(7202),
    [anon_sym_LT] = ACTIONS(7204),
    [anon_sym_GT] = ACTIONS(7204),
    [anon_sym_GT_GT] = ACTIONS(7202),
    [anon_sym_AMP_GT] = ACTIONS(7204),
    [anon_sym_AMP_GT_GT] = ACTIONS(7202),
    [anon_sym_LT_AMP] = ACTIONS(7202),
    [anon_sym_GT_AMP] = ACTIONS(7202),
    [anon_sym_LT_LT] = ACTIONS(7204),
    [anon_sym_LT_LT_DASH] = ACTIONS(7202),
    [anon_sym_LT_LT_LT] = ACTIONS(7202),
    [anon_sym_DOLLAR] = ACTIONS(7204),
    [sym__special_character] = ACTIONS(7202),
    [anon_sym_DQUOTE] = ACTIONS(7202),
    [sym_raw_string] = ACTIONS(7202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7202),
    [anon_sym_BQUOTE] = ACTIONS(7202),
    [anon_sym_LT_LPAREN] = ACTIONS(7202),
    [anon_sym_GT_LPAREN] = ACTIONS(7202),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7204),
    [sym_word] = ACTIONS(7204),
    [anon_sym_LF] = ACTIONS(7202),
    [anon_sym_AMP] = ACTIONS(7204),
  },
  [4155] = {
    [sym__simple_heredoc_body] = ACTIONS(7206),
    [sym__heredoc_body_beginning] = ACTIONS(7206),
    [sym_file_descriptor] = ACTIONS(7206),
    [sym__concat] = ACTIONS(7206),
    [anon_sym_SEMI] = ACTIONS(7208),
    [anon_sym_fi] = ACTIONS(7208),
    [anon_sym_elif] = ACTIONS(7208),
    [anon_sym_else] = ACTIONS(7208),
    [anon_sym_PIPE] = ACTIONS(7208),
    [anon_sym_SEMI_SEMI] = ACTIONS(7206),
    [anon_sym_PIPE_AMP] = ACTIONS(7206),
    [anon_sym_AMP_AMP] = ACTIONS(7206),
    [anon_sym_PIPE_PIPE] = ACTIONS(7206),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7206),
    [anon_sym_AMP_GT] = ACTIONS(7208),
    [anon_sym_AMP_GT_GT] = ACTIONS(7206),
    [anon_sym_LT_AMP] = ACTIONS(7206),
    [anon_sym_GT_AMP] = ACTIONS(7206),
    [anon_sym_LT_LT] = ACTIONS(7208),
    [anon_sym_LT_LT_DASH] = ACTIONS(7206),
    [anon_sym_LT_LT_LT] = ACTIONS(7206),
    [anon_sym_DOLLAR] = ACTIONS(7208),
    [sym__special_character] = ACTIONS(7206),
    [anon_sym_DQUOTE] = ACTIONS(7206),
    [sym_raw_string] = ACTIONS(7206),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7206),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7206),
    [anon_sym_BQUOTE] = ACTIONS(7206),
    [anon_sym_LT_LPAREN] = ACTIONS(7206),
    [anon_sym_GT_LPAREN] = ACTIONS(7206),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7208),
    [sym_word] = ACTIONS(7208),
    [anon_sym_LF] = ACTIONS(7206),
    [anon_sym_AMP] = ACTIONS(7208),
  },
  [4156] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9808),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4157] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9810),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4158] = {
    [sym__simple_heredoc_body] = ACTIONS(7242),
    [sym__heredoc_body_beginning] = ACTIONS(7242),
    [sym_file_descriptor] = ACTIONS(7242),
    [sym__concat] = ACTIONS(7242),
    [anon_sym_SEMI] = ACTIONS(7244),
    [anon_sym_fi] = ACTIONS(7244),
    [anon_sym_elif] = ACTIONS(7244),
    [anon_sym_else] = ACTIONS(7244),
    [anon_sym_PIPE] = ACTIONS(7244),
    [anon_sym_SEMI_SEMI] = ACTIONS(7242),
    [anon_sym_PIPE_AMP] = ACTIONS(7242),
    [anon_sym_AMP_AMP] = ACTIONS(7242),
    [anon_sym_PIPE_PIPE] = ACTIONS(7242),
    [anon_sym_LT] = ACTIONS(7244),
    [anon_sym_GT] = ACTIONS(7244),
    [anon_sym_GT_GT] = ACTIONS(7242),
    [anon_sym_AMP_GT] = ACTIONS(7244),
    [anon_sym_AMP_GT_GT] = ACTIONS(7242),
    [anon_sym_LT_AMP] = ACTIONS(7242),
    [anon_sym_GT_AMP] = ACTIONS(7242),
    [anon_sym_LT_LT] = ACTIONS(7244),
    [anon_sym_LT_LT_DASH] = ACTIONS(7242),
    [anon_sym_LT_LT_LT] = ACTIONS(7242),
    [anon_sym_DOLLAR] = ACTIONS(7244),
    [sym__special_character] = ACTIONS(7242),
    [anon_sym_DQUOTE] = ACTIONS(7242),
    [sym_raw_string] = ACTIONS(7242),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7242),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7242),
    [anon_sym_BQUOTE] = ACTIONS(7242),
    [anon_sym_LT_LPAREN] = ACTIONS(7242),
    [anon_sym_GT_LPAREN] = ACTIONS(7242),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7244),
    [sym_word] = ACTIONS(7244),
    [anon_sym_LF] = ACTIONS(7242),
    [anon_sym_AMP] = ACTIONS(7244),
  },
  [4159] = {
    [sym__simple_heredoc_body] = ACTIONS(8340),
    [sym__heredoc_body_beginning] = ACTIONS(8340),
    [sym_file_descriptor] = ACTIONS(8340),
    [sym__concat] = ACTIONS(8340),
    [anon_sym_SEMI] = ACTIONS(8342),
    [anon_sym_fi] = ACTIONS(8342),
    [anon_sym_elif] = ACTIONS(8342),
    [anon_sym_else] = ACTIONS(8342),
    [anon_sym_PIPE] = ACTIONS(8342),
    [anon_sym_SEMI_SEMI] = ACTIONS(8340),
    [anon_sym_PIPE_AMP] = ACTIONS(8340),
    [anon_sym_AMP_AMP] = ACTIONS(8340),
    [anon_sym_PIPE_PIPE] = ACTIONS(8340),
    [anon_sym_EQ_TILDE] = ACTIONS(8342),
    [anon_sym_EQ_EQ] = ACTIONS(8342),
    [anon_sym_LT] = ACTIONS(8342),
    [anon_sym_GT] = ACTIONS(8342),
    [anon_sym_GT_GT] = ACTIONS(8340),
    [anon_sym_AMP_GT] = ACTIONS(8342),
    [anon_sym_AMP_GT_GT] = ACTIONS(8340),
    [anon_sym_LT_AMP] = ACTIONS(8340),
    [anon_sym_GT_AMP] = ACTIONS(8340),
    [anon_sym_LT_LT] = ACTIONS(8342),
    [anon_sym_LT_LT_DASH] = ACTIONS(8340),
    [anon_sym_LT_LT_LT] = ACTIONS(8340),
    [anon_sym_DOLLAR] = ACTIONS(8342),
    [sym__special_character] = ACTIONS(8340),
    [anon_sym_DQUOTE] = ACTIONS(8340),
    [sym_raw_string] = ACTIONS(8340),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8340),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [anon_sym_LT_LPAREN] = ACTIONS(8340),
    [anon_sym_GT_LPAREN] = ACTIONS(8340),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8342),
    [anon_sym_LF] = ACTIONS(8340),
    [anon_sym_AMP] = ACTIONS(8342),
  },
  [4160] = {
    [sym__simple_heredoc_body] = ACTIONS(8344),
    [sym__heredoc_body_beginning] = ACTIONS(8344),
    [sym_file_descriptor] = ACTIONS(8344),
    [sym__concat] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [anon_sym_fi] = ACTIONS(8346),
    [anon_sym_elif] = ACTIONS(8346),
    [anon_sym_else] = ACTIONS(8346),
    [anon_sym_PIPE] = ACTIONS(8346),
    [anon_sym_SEMI_SEMI] = ACTIONS(8344),
    [anon_sym_PIPE_AMP] = ACTIONS(8344),
    [anon_sym_AMP_AMP] = ACTIONS(8344),
    [anon_sym_PIPE_PIPE] = ACTIONS(8344),
    [anon_sym_EQ_TILDE] = ACTIONS(8346),
    [anon_sym_EQ_EQ] = ACTIONS(8346),
    [anon_sym_LT] = ACTIONS(8346),
    [anon_sym_GT] = ACTIONS(8346),
    [anon_sym_GT_GT] = ACTIONS(8344),
    [anon_sym_AMP_GT] = ACTIONS(8346),
    [anon_sym_AMP_GT_GT] = ACTIONS(8344),
    [anon_sym_LT_AMP] = ACTIONS(8344),
    [anon_sym_GT_AMP] = ACTIONS(8344),
    [anon_sym_LT_LT] = ACTIONS(8346),
    [anon_sym_LT_LT_DASH] = ACTIONS(8344),
    [anon_sym_LT_LT_LT] = ACTIONS(8344),
    [anon_sym_DOLLAR] = ACTIONS(8346),
    [sym__special_character] = ACTIONS(8344),
    [anon_sym_DQUOTE] = ACTIONS(8344),
    [sym_raw_string] = ACTIONS(8344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8344),
    [anon_sym_BQUOTE] = ACTIONS(8344),
    [anon_sym_LT_LPAREN] = ACTIONS(8344),
    [anon_sym_GT_LPAREN] = ACTIONS(8344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8346),
    [anon_sym_LF] = ACTIONS(8344),
    [anon_sym_AMP] = ACTIONS(8346),
  },
  [4161] = {
    [sym__simple_heredoc_body] = ACTIONS(2719),
    [sym__heredoc_body_beginning] = ACTIONS(2719),
    [sym_file_descriptor] = ACTIONS(2719),
    [sym_variable_name] = ACTIONS(2719),
    [anon_sym_SEMI] = ACTIONS(2721),
    [anon_sym_esac] = ACTIONS(2721),
    [anon_sym_PIPE] = ACTIONS(2721),
    [anon_sym_SEMI_SEMI] = ACTIONS(2719),
    [anon_sym_PIPE_AMP] = ACTIONS(2719),
    [anon_sym_AMP_AMP] = ACTIONS(2719),
    [anon_sym_PIPE_PIPE] = ACTIONS(2719),
    [anon_sym_LT] = ACTIONS(2721),
    [anon_sym_GT] = ACTIONS(2721),
    [anon_sym_GT_GT] = ACTIONS(2719),
    [anon_sym_AMP_GT] = ACTIONS(2721),
    [anon_sym_AMP_GT_GT] = ACTIONS(2719),
    [anon_sym_LT_AMP] = ACTIONS(2719),
    [anon_sym_GT_AMP] = ACTIONS(2719),
    [anon_sym_LT_LT] = ACTIONS(2721),
    [anon_sym_LT_LT_DASH] = ACTIONS(2719),
    [anon_sym_LT_LT_LT] = ACTIONS(2719),
    [anon_sym_DOLLAR] = ACTIONS(2721),
    [sym__special_character] = ACTIONS(2719),
    [anon_sym_DQUOTE] = ACTIONS(2719),
    [sym_raw_string] = ACTIONS(2719),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2719),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2719),
    [anon_sym_BQUOTE] = ACTIONS(2719),
    [anon_sym_LT_LPAREN] = ACTIONS(2719),
    [anon_sym_GT_LPAREN] = ACTIONS(2719),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2721),
    [anon_sym_LF] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2721),
  },
  [4162] = {
    [sym_concatenation] = STATE(1368),
    [sym_string] = STATE(730),
    [sym_simple_expansion] = STATE(730),
    [sym_string_expansion] = STATE(730),
    [sym_expansion] = STATE(730),
    [sym_command_substitution] = STATE(730),
    [sym_process_substitution] = STATE(730),
    [aux_sym_for_statement_repeat1] = STATE(1368),
    [aux_sym__literal_repeat1] = STATE(736),
    [anon_sym_RPAREN] = ACTIONS(9812),
    [anon_sym_DOLLAR] = ACTIONS(1406),
    [sym__special_character] = ACTIONS(1408),
    [anon_sym_DQUOTE] = ACTIONS(1410),
    [sym_raw_string] = ACTIONS(1412),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1414),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1416),
    [anon_sym_BQUOTE] = ACTIONS(1418),
    [anon_sym_LT_LPAREN] = ACTIONS(1420),
    [anon_sym_GT_LPAREN] = ACTIONS(1420),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1412),
  },
  [4163] = {
    [sym__simple_heredoc_body] = ACTIONS(1057),
    [sym__heredoc_body_beginning] = ACTIONS(1057),
    [sym_file_descriptor] = ACTIONS(1057),
    [sym__concat] = ACTIONS(1057),
    [sym_variable_name] = ACTIONS(1057),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_esac] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_SEMI_SEMI] = ACTIONS(1057),
    [anon_sym_PIPE_AMP] = ACTIONS(1057),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1057),
    [anon_sym_AMP_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_AMP] = ACTIONS(1057),
    [anon_sym_GT_AMP] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_LT_LT_DASH] = ACTIONS(1057),
    [anon_sym_LT_LT_LT] = ACTIONS(1057),
    [anon_sym_DOLLAR] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [sym_raw_string] = ACTIONS(1057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1057),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1057),
    [anon_sym_BQUOTE] = ACTIONS(1057),
    [anon_sym_LT_LPAREN] = ACTIONS(1057),
    [anon_sym_GT_LPAREN] = ACTIONS(1057),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [4164] = {
    [sym__simple_heredoc_body] = ACTIONS(1061),
    [sym__heredoc_body_beginning] = ACTIONS(1061),
    [sym_file_descriptor] = ACTIONS(1061),
    [sym__concat] = ACTIONS(1061),
    [sym_variable_name] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(1063),
    [anon_sym_esac] = ACTIONS(1063),
    [anon_sym_PIPE] = ACTIONS(1063),
    [anon_sym_SEMI_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE_AMP] = ACTIONS(1061),
    [anon_sym_AMP_AMP] = ACTIONS(1061),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1063),
    [anon_sym_GT_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT_GT] = ACTIONS(1061),
    [anon_sym_LT_AMP] = ACTIONS(1061),
    [anon_sym_GT_AMP] = ACTIONS(1061),
    [anon_sym_LT_LT] = ACTIONS(1063),
    [anon_sym_LT_LT_DASH] = ACTIONS(1061),
    [anon_sym_LT_LT_LT] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1061),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1061),
    [anon_sym_BQUOTE] = ACTIONS(1061),
    [anon_sym_LT_LPAREN] = ACTIONS(1061),
    [anon_sym_GT_LPAREN] = ACTIONS(1061),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1063),
    [anon_sym_LF] = ACTIONS(1061),
    [anon_sym_AMP] = ACTIONS(1063),
  },
  [4165] = {
    [sym__simple_heredoc_body] = ACTIONS(1065),
    [sym__heredoc_body_beginning] = ACTIONS(1065),
    [sym_file_descriptor] = ACTIONS(1065),
    [sym__concat] = ACTIONS(1065),
    [sym_variable_name] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_esac] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1067),
    [anon_sym_SEMI_SEMI] = ACTIONS(1065),
    [anon_sym_PIPE_AMP] = ACTIONS(1065),
    [anon_sym_AMP_AMP] = ACTIONS(1065),
    [anon_sym_PIPE_PIPE] = ACTIONS(1065),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_GT] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT] = ACTIONS(1067),
    [anon_sym_AMP_GT_GT] = ACTIONS(1065),
    [anon_sym_LT_AMP] = ACTIONS(1065),
    [anon_sym_GT_AMP] = ACTIONS(1065),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_LT_LT_DASH] = ACTIONS(1065),
    [anon_sym_LT_LT_LT] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1067),
    [sym__special_character] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LT_LPAREN] = ACTIONS(1065),
    [anon_sym_GT_LPAREN] = ACTIONS(1065),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1067),
    [anon_sym_LF] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1067),
  },
  [4166] = {
    [sym_string] = STATE(4307),
    [sym_simple_expansion] = STATE(4307),
    [sym_string_expansion] = STATE(4307),
    [sym_expansion] = STATE(4307),
    [sym_command_substitution] = STATE(4307),
    [sym_process_substitution] = STATE(4307),
    [anon_sym_DOLLAR] = ACTIONS(8876),
    [sym__special_character] = ACTIONS(9814),
    [anon_sym_DQUOTE] = ACTIONS(8880),
    [sym_raw_string] = ACTIONS(9814),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8884),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8886),
    [anon_sym_BQUOTE] = ACTIONS(8888),
    [anon_sym_LT_LPAREN] = ACTIONS(8890),
    [anon_sym_GT_LPAREN] = ACTIONS(8890),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9814),
  },
  [4167] = {
    [aux_sym_concatenation_repeat1] = STATE(4309),
    [sym__simple_heredoc_body] = ACTIONS(1071),
    [sym__heredoc_body_beginning] = ACTIONS(1071),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(9816),
    [sym_variable_name] = ACTIONS(1071),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_esac] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [sym__special_character] = ACTIONS(1071),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [sym_raw_string] = ACTIONS(1071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_LT_LPAREN] = ACTIONS(1071),
    [anon_sym_GT_LPAREN] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1075),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1075),
  },
  [4168] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(9818),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [4169] = {
    [sym__simple_heredoc_body] = ACTIONS(1089),
    [sym__heredoc_body_beginning] = ACTIONS(1089),
    [sym_file_descriptor] = ACTIONS(1089),
    [sym__concat] = ACTIONS(1089),
    [sym_variable_name] = ACTIONS(1089),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_esac] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI_SEMI] = ACTIONS(1089),
    [anon_sym_PIPE_AMP] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1089),
    [anon_sym_AMP_GT] = ACTIONS(1091),
    [anon_sym_AMP_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_AMP] = ACTIONS(1089),
    [anon_sym_GT_AMP] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_LT_LT_DASH] = ACTIONS(1089),
    [anon_sym_LT_LT_LT] = ACTIONS(1089),
    [anon_sym_DOLLAR] = ACTIONS(1091),
    [sym__special_character] = ACTIONS(1089),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [sym_raw_string] = ACTIONS(1089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1089),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_LT_LPAREN] = ACTIONS(1089),
    [anon_sym_GT_LPAREN] = ACTIONS(1089),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1091),
    [anon_sym_LF] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
  },
  [4170] = {
    [sym_simple_expansion] = STATE(204),
    [sym_expansion] = STATE(204),
    [sym_command_substitution] = STATE(204),
    [aux_sym_string_repeat1] = STATE(627),
    [anon_sym_DOLLAR] = ACTIONS(9820),
    [anon_sym_DQUOTE] = ACTIONS(9818),
    [sym__string_content] = ACTIONS(345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(347),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(351),
    [sym_comment] = ACTIONS(329),
  },
  [4171] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(9822),
    [sym_comment] = ACTIONS(57),
  },
  [4172] = {
    [sym_subscript] = STATE(4315),
    [sym_variable_name] = ACTIONS(9824),
    [anon_sym_DASH] = ACTIONS(9826),
    [anon_sym_DOLLAR] = ACTIONS(9826),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(9828),
    [anon_sym_STAR] = ACTIONS(9830),
    [anon_sym_AT] = ACTIONS(9830),
    [anon_sym_QMARK] = ACTIONS(9830),
    [anon_sym_0] = ACTIONS(9828),
    [anon_sym__] = ACTIONS(9828),
  },
  [4173] = {
    [sym_concatenation] = STATE(4318),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4318),
    [anon_sym_RBRACE] = ACTIONS(9832),
    [anon_sym_EQ] = ACTIONS(9834),
    [anon_sym_DASH] = ACTIONS(9834),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9836),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(9838),
    [anon_sym_COLON] = ACTIONS(9834),
    [anon_sym_COLON_QMARK] = ACTIONS(9834),
    [anon_sym_COLON_DASH] = ACTIONS(9834),
    [anon_sym_PERCENT] = ACTIONS(9834),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4174] = {
    [sym_concatenation] = STATE(4321),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4321),
    [anon_sym_RBRACE] = ACTIONS(9840),
    [anon_sym_EQ] = ACTIONS(9842),
    [anon_sym_DASH] = ACTIONS(9842),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9844),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(9846),
    [anon_sym_COLON] = ACTIONS(9842),
    [anon_sym_COLON_QMARK] = ACTIONS(9842),
    [anon_sym_COLON_DASH] = ACTIONS(9842),
    [anon_sym_PERCENT] = ACTIONS(9842),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4175] = {
    [anon_sym_RPAREN] = ACTIONS(9848),
    [sym_comment] = ACTIONS(57),
  },
  [4176] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(9848),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [4177] = {
    [anon_sym_BQUOTE] = ACTIONS(9848),
    [sym_comment] = ACTIONS(57),
  },
  [4178] = {
    [anon_sym_RPAREN] = ACTIONS(9850),
    [sym_comment] = ACTIONS(57),
  },
  [4179] = {
    [sym__simple_heredoc_body] = ACTIONS(335),
    [sym__heredoc_body_beginning] = ACTIONS(335),
    [sym_file_descriptor] = ACTIONS(335),
    [sym_variable_name] = ACTIONS(335),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_esac] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_SEMI_SEMI] = ACTIONS(335),
    [anon_sym_PIPE_AMP] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(335),
    [anon_sym_PIPE_PIPE] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_AMP_GT] = ACTIONS(339),
    [anon_sym_AMP_GT_GT] = ACTIONS(335),
    [anon_sym_LT_AMP] = ACTIONS(335),
    [anon_sym_GT_AMP] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(339),
    [anon_sym_LT_LT_DASH] = ACTIONS(335),
    [anon_sym_LT_LT_LT] = ACTIONS(335),
    [anon_sym_DOLLAR] = ACTIONS(339),
    [sym__special_character] = ACTIONS(335),
    [anon_sym_DQUOTE] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_BQUOTE] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(339),
    [anon_sym_LF] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(339),
  },
  [4180] = {
    [aux_sym__literal_repeat1] = STATE(4180),
    [sym__simple_heredoc_body] = ACTIONS(1373),
    [sym__heredoc_body_beginning] = ACTIONS(1373),
    [sym_file_descriptor] = ACTIONS(1373),
    [sym_variable_name] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_esac] = ACTIONS(1375),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE_AMP] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_LT_LT_DASH] = ACTIONS(1373),
    [anon_sym_LT_LT_LT] = ACTIONS(1373),
    [anon_sym_DOLLAR] = ACTIONS(1375),
    [sym__special_character] = ACTIONS(9852),
    [anon_sym_DQUOTE] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1373),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [anon_sym_LT_LPAREN] = ACTIONS(1373),
    [anon_sym_GT_LPAREN] = ACTIONS(1373),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1375),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
  },
  [4181] = {
    [sym__simple_heredoc_body] = ACTIONS(1400),
    [sym__heredoc_body_beginning] = ACTIONS(1400),
    [sym_file_descriptor] = ACTIONS(1400),
    [sym_variable_name] = ACTIONS(1400),
    [anon_sym_SEMI] = ACTIONS(1402),
    [anon_sym_esac] = ACTIONS(1402),
    [anon_sym_PIPE] = ACTIONS(1402),
    [anon_sym_SEMI_SEMI] = ACTIONS(1400),
    [anon_sym_PIPE_AMP] = ACTIONS(1400),
    [anon_sym_AMP_AMP] = ACTIONS(1400),
    [anon_sym_PIPE_PIPE] = ACTIONS(1400),
    [anon_sym_LT] = ACTIONS(1402),
    [anon_sym_GT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT] = ACTIONS(1402),
    [anon_sym_AMP_GT_GT] = ACTIONS(1400),
    [anon_sym_LT_AMP] = ACTIONS(1400),
    [anon_sym_GT_AMP] = ACTIONS(1400),
    [anon_sym_LT_LT] = ACTIONS(1402),
    [anon_sym_LT_LT_DASH] = ACTIONS(1400),
    [anon_sym_LT_LT_LT] = ACTIONS(1400),
    [anon_sym_DOLLAR] = ACTIONS(1402),
    [sym__special_character] = ACTIONS(1400),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1400),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1400),
    [anon_sym_BQUOTE] = ACTIONS(1400),
    [anon_sym_LT_LPAREN] = ACTIONS(1400),
    [anon_sym_GT_LPAREN] = ACTIONS(1400),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1402),
    [sym_word] = ACTIONS(1402),
    [anon_sym_LF] = ACTIONS(1400),
    [anon_sym_AMP] = ACTIONS(1402),
  },
  [4182] = {
    [sym_concatenation] = STATE(4325),
    [sym_string] = STATE(730),
    [sym_simple_expansion] = STATE(730),
    [sym_string_expansion] = STATE(730),
    [sym_expansion] = STATE(730),
    [sym_command_substitution] = STATE(730),
    [sym_process_substitution] = STATE(730),
    [aux_sym_for_statement_repeat1] = STATE(4325),
    [aux_sym__literal_repeat1] = STATE(736),
    [anon_sym_RPAREN] = ACTIONS(9855),
    [anon_sym_DOLLAR] = ACTIONS(1406),
    [sym__special_character] = ACTIONS(1408),
    [anon_sym_DQUOTE] = ACTIONS(1410),
    [sym_raw_string] = ACTIONS(1412),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1414),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1416),
    [anon_sym_BQUOTE] = ACTIONS(1418),
    [anon_sym_LT_LPAREN] = ACTIONS(1420),
    [anon_sym_GT_LPAREN] = ACTIONS(1420),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1412),
  },
  [4183] = {
    [aux_sym_concatenation_repeat1] = STATE(3934),
    [sym__simple_heredoc_body] = ACTIONS(1400),
    [sym__heredoc_body_beginning] = ACTIONS(1400),
    [sym_file_descriptor] = ACTIONS(1400),
    [sym__concat] = ACTIONS(8902),
    [sym_variable_name] = ACTIONS(1400),
    [anon_sym_SEMI] = ACTIONS(1402),
    [anon_sym_esac] = ACTIONS(1402),
    [anon_sym_PIPE] = ACTIONS(1402),
    [anon_sym_SEMI_SEMI] = ACTIONS(1400),
    [anon_sym_PIPE_AMP] = ACTIONS(1400),
    [anon_sym_AMP_AMP] = ACTIONS(1400),
    [anon_sym_PIPE_PIPE] = ACTIONS(1400),
    [anon_sym_LT] = ACTIONS(1402),
    [anon_sym_GT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT] = ACTIONS(1402),
    [anon_sym_AMP_GT_GT] = ACTIONS(1400),
    [anon_sym_LT_AMP] = ACTIONS(1400),
    [anon_sym_GT_AMP] = ACTIONS(1400),
    [anon_sym_LT_LT] = ACTIONS(1402),
    [anon_sym_LT_LT_DASH] = ACTIONS(1400),
    [anon_sym_LT_LT_LT] = ACTIONS(1400),
    [anon_sym_DOLLAR] = ACTIONS(1402),
    [sym__special_character] = ACTIONS(1400),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1400),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1400),
    [anon_sym_BQUOTE] = ACTIONS(1400),
    [anon_sym_LT_LPAREN] = ACTIONS(1400),
    [anon_sym_GT_LPAREN] = ACTIONS(1400),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1402),
    [sym_word] = ACTIONS(1402),
    [anon_sym_LF] = ACTIONS(1400),
    [anon_sym_AMP] = ACTIONS(1402),
  },
  [4184] = {
    [aux_sym__literal_repeat1] = STATE(3948),
    [sym__simple_heredoc_body] = ACTIONS(1446),
    [sym__heredoc_body_beginning] = ACTIONS(1446),
    [sym_file_descriptor] = ACTIONS(1446),
    [sym_variable_name] = ACTIONS(1446),
    [anon_sym_SEMI] = ACTIONS(1448),
    [anon_sym_esac] = ACTIONS(1448),
    [anon_sym_PIPE] = ACTIONS(1448),
    [anon_sym_SEMI_SEMI] = ACTIONS(1446),
    [anon_sym_PIPE_AMP] = ACTIONS(1446),
    [anon_sym_AMP_AMP] = ACTIONS(1446),
    [anon_sym_PIPE_PIPE] = ACTIONS(1446),
    [anon_sym_LT] = ACTIONS(1448),
    [anon_sym_GT] = ACTIONS(1448),
    [anon_sym_GT_GT] = ACTIONS(1446),
    [anon_sym_AMP_GT] = ACTIONS(1448),
    [anon_sym_AMP_GT_GT] = ACTIONS(1446),
    [anon_sym_LT_AMP] = ACTIONS(1446),
    [anon_sym_GT_AMP] = ACTIONS(1446),
    [anon_sym_LT_LT] = ACTIONS(1448),
    [anon_sym_LT_LT_DASH] = ACTIONS(1446),
    [anon_sym_LT_LT_LT] = ACTIONS(1446),
    [anon_sym_DOLLAR] = ACTIONS(1448),
    [sym__special_character] = ACTIONS(8920),
    [anon_sym_DQUOTE] = ACTIONS(1446),
    [sym_raw_string] = ACTIONS(1446),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1446),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1446),
    [anon_sym_BQUOTE] = ACTIONS(1446),
    [anon_sym_LT_LPAREN] = ACTIONS(1446),
    [anon_sym_GT_LPAREN] = ACTIONS(1446),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1448),
    [sym_word] = ACTIONS(1448),
    [anon_sym_LF] = ACTIONS(1446),
    [anon_sym_AMP] = ACTIONS(1448),
  },
  [4185] = {
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(2362),
    [sym_variable_name] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_esac] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2364),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [4186] = {
    [sym_string] = STATE(4185),
    [sym_simple_expansion] = STATE(4185),
    [sym_string_expansion] = STATE(4185),
    [sym_expansion] = STATE(4185),
    [sym_command_substitution] = STATE(4185),
    [sym_process_substitution] = STATE(4185),
    [anon_sym_DOLLAR] = ACTIONS(9857),
    [sym__special_character] = ACTIONS(9424),
    [anon_sym_DQUOTE] = ACTIONS(8091),
    [sym_raw_string] = ACTIONS(9424),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8097),
    [anon_sym_BQUOTE] = ACTIONS(8099),
    [anon_sym_LT_LPAREN] = ACTIONS(8101),
    [anon_sym_GT_LPAREN] = ACTIONS(8101),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9424),
  },
  [4187] = {
    [aux_sym_concatenation_repeat1] = STATE(4187),
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(9859),
    [sym_variable_name] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_esac] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2364),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [4188] = {
    [sym__simple_heredoc_body] = ACTIONS(2371),
    [sym__heredoc_body_beginning] = ACTIONS(2371),
    [sym_file_descriptor] = ACTIONS(2371),
    [sym__concat] = ACTIONS(2371),
    [sym_variable_name] = ACTIONS(2371),
    [anon_sym_SEMI] = ACTIONS(2373),
    [anon_sym_esac] = ACTIONS(2373),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_SEMI_SEMI] = ACTIONS(2371),
    [anon_sym_PIPE_AMP] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_GT_GT] = ACTIONS(2371),
    [anon_sym_AMP_GT] = ACTIONS(2373),
    [anon_sym_AMP_GT_GT] = ACTIONS(2371),
    [anon_sym_LT_AMP] = ACTIONS(2371),
    [anon_sym_GT_AMP] = ACTIONS(2371),
    [anon_sym_LT_LT] = ACTIONS(2373),
    [anon_sym_LT_LT_DASH] = ACTIONS(2371),
    [anon_sym_LT_LT_LT] = ACTIONS(2371),
    [anon_sym_DOLLAR] = ACTIONS(2373),
    [sym__special_character] = ACTIONS(2371),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [sym_raw_string] = ACTIONS(2371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2371),
    [anon_sym_BQUOTE] = ACTIONS(2371),
    [anon_sym_LT_LPAREN] = ACTIONS(2371),
    [anon_sym_GT_LPAREN] = ACTIONS(2371),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2373),
    [sym_word] = ACTIONS(2373),
    [anon_sym_LF] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
  },
  [4189] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(9862),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [4190] = {
    [sym_concatenation] = STATE(4330),
    [sym_string] = STATE(4329),
    [sym_simple_expansion] = STATE(4329),
    [sym_string_expansion] = STATE(4329),
    [sym_expansion] = STATE(4329),
    [sym_command_substitution] = STATE(4329),
    [sym_process_substitution] = STATE(4329),
    [aux_sym__literal_repeat1] = STATE(4331),
    [anon_sym_RBRACE] = ACTIONS(9864),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(9866),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9866),
  },
  [4191] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(9868),
    [sym_comment] = ACTIONS(57),
  },
  [4192] = {
    [sym_concatenation] = STATE(4335),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4335),
    [anon_sym_RBRACE] = ACTIONS(9870),
    [anon_sym_EQ] = ACTIONS(9872),
    [anon_sym_DASH] = ACTIONS(9872),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(9876),
    [anon_sym_COLON] = ACTIONS(9872),
    [anon_sym_COLON_QMARK] = ACTIONS(9872),
    [anon_sym_COLON_DASH] = ACTIONS(9872),
    [anon_sym_PERCENT] = ACTIONS(9872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4193] = {
    [sym_concatenation] = STATE(4337),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4337),
    [anon_sym_RBRACE] = ACTIONS(9864),
    [anon_sym_EQ] = ACTIONS(9878),
    [anon_sym_DASH] = ACTIONS(9878),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(9882),
    [anon_sym_COLON] = ACTIONS(9878),
    [anon_sym_COLON_QMARK] = ACTIONS(9878),
    [anon_sym_COLON_DASH] = ACTIONS(9878),
    [anon_sym_PERCENT] = ACTIONS(9878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4194] = {
    [sym__simple_heredoc_body] = ACTIONS(2462),
    [sym__heredoc_body_beginning] = ACTIONS(2462),
    [sym_file_descriptor] = ACTIONS(2462),
    [sym__concat] = ACTIONS(2462),
    [sym_variable_name] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_esac] = ACTIONS(2464),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_SEMI_SEMI] = ACTIONS(2462),
    [anon_sym_PIPE_AMP] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_GT_GT] = ACTIONS(2462),
    [anon_sym_AMP_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT_GT] = ACTIONS(2462),
    [anon_sym_LT_AMP] = ACTIONS(2462),
    [anon_sym_GT_AMP] = ACTIONS(2462),
    [anon_sym_LT_LT] = ACTIONS(2464),
    [anon_sym_LT_LT_DASH] = ACTIONS(2462),
    [anon_sym_LT_LT_LT] = ACTIONS(2462),
    [anon_sym_DOLLAR] = ACTIONS(2464),
    [sym__special_character] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [sym_raw_string] = ACTIONS(2462),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2462),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2462),
    [anon_sym_BQUOTE] = ACTIONS(2462),
    [anon_sym_LT_LPAREN] = ACTIONS(2462),
    [anon_sym_GT_LPAREN] = ACTIONS(2462),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2464),
    [sym_word] = ACTIONS(2464),
    [anon_sym_LF] = ACTIONS(2462),
    [anon_sym_AMP] = ACTIONS(2464),
  },
  [4195] = {
    [sym_concatenation] = STATE(4340),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4340),
    [sym_regex] = ACTIONS(9884),
    [anon_sym_RBRACE] = ACTIONS(9886),
    [anon_sym_EQ] = ACTIONS(9888),
    [anon_sym_DASH] = ACTIONS(9888),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9888),
    [anon_sym_COLON_QMARK] = ACTIONS(9888),
    [anon_sym_COLON_DASH] = ACTIONS(9888),
    [anon_sym_PERCENT] = ACTIONS(9888),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4196] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9886),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4197] = {
    [sym__simple_heredoc_body] = ACTIONS(2512),
    [sym__heredoc_body_beginning] = ACTIONS(2512),
    [sym_file_descriptor] = ACTIONS(2512),
    [sym__concat] = ACTIONS(2512),
    [sym_variable_name] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2514),
    [anon_sym_esac] = ACTIONS(2514),
    [anon_sym_PIPE] = ACTIONS(2514),
    [anon_sym_SEMI_SEMI] = ACTIONS(2512),
    [anon_sym_PIPE_AMP] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE_PIPE] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2514),
    [anon_sym_GT] = ACTIONS(2514),
    [anon_sym_GT_GT] = ACTIONS(2512),
    [anon_sym_AMP_GT] = ACTIONS(2514),
    [anon_sym_AMP_GT_GT] = ACTIONS(2512),
    [anon_sym_LT_AMP] = ACTIONS(2512),
    [anon_sym_GT_AMP] = ACTIONS(2512),
    [anon_sym_LT_LT] = ACTIONS(2514),
    [anon_sym_LT_LT_DASH] = ACTIONS(2512),
    [anon_sym_LT_LT_LT] = ACTIONS(2512),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [sym__special_character] = ACTIONS(2512),
    [anon_sym_DQUOTE] = ACTIONS(2512),
    [sym_raw_string] = ACTIONS(2512),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2512),
    [anon_sym_BQUOTE] = ACTIONS(2512),
    [anon_sym_LT_LPAREN] = ACTIONS(2512),
    [anon_sym_GT_LPAREN] = ACTIONS(2512),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2514),
    [sym_word] = ACTIONS(2514),
    [anon_sym_LF] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2514),
  },
  [4198] = {
    [sym_concatenation] = STATE(4337),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4337),
    [sym_regex] = ACTIONS(9892),
    [anon_sym_RBRACE] = ACTIONS(9864),
    [anon_sym_EQ] = ACTIONS(9878),
    [anon_sym_DASH] = ACTIONS(9878),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9878),
    [anon_sym_COLON_QMARK] = ACTIONS(9878),
    [anon_sym_COLON_DASH] = ACTIONS(9878),
    [anon_sym_PERCENT] = ACTIONS(9878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4199] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9864),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4200] = {
    [sym__simple_heredoc_body] = ACTIONS(2520),
    [sym__heredoc_body_beginning] = ACTIONS(2520),
    [sym_file_descriptor] = ACTIONS(2520),
    [sym__concat] = ACTIONS(2520),
    [sym_variable_name] = ACTIONS(2520),
    [anon_sym_SEMI] = ACTIONS(2522),
    [anon_sym_esac] = ACTIONS(2522),
    [anon_sym_PIPE] = ACTIONS(2522),
    [anon_sym_SEMI_SEMI] = ACTIONS(2520),
    [anon_sym_PIPE_AMP] = ACTIONS(2520),
    [anon_sym_AMP_AMP] = ACTIONS(2520),
    [anon_sym_PIPE_PIPE] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(2522),
    [anon_sym_GT] = ACTIONS(2522),
    [anon_sym_GT_GT] = ACTIONS(2520),
    [anon_sym_AMP_GT] = ACTIONS(2522),
    [anon_sym_AMP_GT_GT] = ACTIONS(2520),
    [anon_sym_LT_AMP] = ACTIONS(2520),
    [anon_sym_GT_AMP] = ACTIONS(2520),
    [anon_sym_LT_LT] = ACTIONS(2522),
    [anon_sym_LT_LT_DASH] = ACTIONS(2520),
    [anon_sym_LT_LT_LT] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(2522),
    [sym__special_character] = ACTIONS(2520),
    [anon_sym_DQUOTE] = ACTIONS(2520),
    [sym_raw_string] = ACTIONS(2520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2520),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2520),
    [anon_sym_BQUOTE] = ACTIONS(2520),
    [anon_sym_LT_LPAREN] = ACTIONS(2520),
    [anon_sym_GT_LPAREN] = ACTIONS(2520),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2522),
    [sym_word] = ACTIONS(2522),
    [anon_sym_LF] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2522),
  },
  [4201] = {
    [sym__simple_heredoc_body] = ACTIONS(2554),
    [sym__heredoc_body_beginning] = ACTIONS(2554),
    [sym_file_descriptor] = ACTIONS(2554),
    [sym__concat] = ACTIONS(2554),
    [sym_variable_name] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(2556),
    [anon_sym_esac] = ACTIONS(2556),
    [anon_sym_PIPE] = ACTIONS(2556),
    [anon_sym_SEMI_SEMI] = ACTIONS(2554),
    [anon_sym_PIPE_AMP] = ACTIONS(2554),
    [anon_sym_AMP_AMP] = ACTIONS(2554),
    [anon_sym_PIPE_PIPE] = ACTIONS(2554),
    [anon_sym_LT] = ACTIONS(2556),
    [anon_sym_GT] = ACTIONS(2556),
    [anon_sym_GT_GT] = ACTIONS(2554),
    [anon_sym_AMP_GT] = ACTIONS(2556),
    [anon_sym_AMP_GT_GT] = ACTIONS(2554),
    [anon_sym_LT_AMP] = ACTIONS(2554),
    [anon_sym_GT_AMP] = ACTIONS(2554),
    [anon_sym_LT_LT] = ACTIONS(2556),
    [anon_sym_LT_LT_DASH] = ACTIONS(2554),
    [anon_sym_LT_LT_LT] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2556),
    [sym__special_character] = ACTIONS(2554),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2554),
    [anon_sym_BQUOTE] = ACTIONS(2554),
    [anon_sym_LT_LPAREN] = ACTIONS(2554),
    [anon_sym_GT_LPAREN] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2556),
    [sym_word] = ACTIONS(2556),
    [anon_sym_LF] = ACTIONS(2554),
    [anon_sym_AMP] = ACTIONS(2556),
  },
  [4202] = {
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_esac] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2364),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [4203] = {
    [sym_string] = STATE(4202),
    [sym_simple_expansion] = STATE(4202),
    [sym_string_expansion] = STATE(4202),
    [sym_expansion] = STATE(4202),
    [sym_command_substitution] = STATE(4202),
    [sym_process_substitution] = STATE(4202),
    [anon_sym_DOLLAR] = ACTIONS(9894),
    [sym__special_character] = ACTIONS(9498),
    [anon_sym_DQUOTE] = ACTIONS(8111),
    [sym_raw_string] = ACTIONS(9498),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8115),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8117),
    [anon_sym_BQUOTE] = ACTIONS(8119),
    [anon_sym_LT_LPAREN] = ACTIONS(8121),
    [anon_sym_GT_LPAREN] = ACTIONS(8121),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9498),
  },
  [4204] = {
    [aux_sym_concatenation_repeat1] = STATE(4204),
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(9896),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_esac] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2364),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [4205] = {
    [sym__simple_heredoc_body] = ACTIONS(2371),
    [sym__heredoc_body_beginning] = ACTIONS(2371),
    [sym_file_descriptor] = ACTIONS(2371),
    [sym__concat] = ACTIONS(2371),
    [anon_sym_SEMI] = ACTIONS(2373),
    [anon_sym_esac] = ACTIONS(2373),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_SEMI_SEMI] = ACTIONS(2371),
    [anon_sym_PIPE_AMP] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_GT_GT] = ACTIONS(2371),
    [anon_sym_AMP_GT] = ACTIONS(2373),
    [anon_sym_AMP_GT_GT] = ACTIONS(2371),
    [anon_sym_LT_AMP] = ACTIONS(2371),
    [anon_sym_GT_AMP] = ACTIONS(2371),
    [anon_sym_LT_LT] = ACTIONS(2373),
    [anon_sym_LT_LT_DASH] = ACTIONS(2371),
    [anon_sym_LT_LT_LT] = ACTIONS(2371),
    [anon_sym_DOLLAR] = ACTIONS(2373),
    [sym__special_character] = ACTIONS(2371),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [sym_raw_string] = ACTIONS(2371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2371),
    [anon_sym_BQUOTE] = ACTIONS(2371),
    [anon_sym_LT_LPAREN] = ACTIONS(2371),
    [anon_sym_GT_LPAREN] = ACTIONS(2371),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2373),
    [sym_word] = ACTIONS(2373),
    [anon_sym_LF] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
  },
  [4206] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(9899),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [4207] = {
    [sym_concatenation] = STATE(4346),
    [sym_string] = STATE(4345),
    [sym_simple_expansion] = STATE(4345),
    [sym_string_expansion] = STATE(4345),
    [sym_expansion] = STATE(4345),
    [sym_command_substitution] = STATE(4345),
    [sym_process_substitution] = STATE(4345),
    [aux_sym__literal_repeat1] = STATE(4347),
    [anon_sym_RBRACE] = ACTIONS(9901),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(9903),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9903),
  },
  [4208] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(9905),
    [sym_comment] = ACTIONS(57),
  },
  [4209] = {
    [sym_concatenation] = STATE(4351),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4351),
    [anon_sym_RBRACE] = ACTIONS(9907),
    [anon_sym_EQ] = ACTIONS(9909),
    [anon_sym_DASH] = ACTIONS(9909),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9911),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(9913),
    [anon_sym_COLON] = ACTIONS(9909),
    [anon_sym_COLON_QMARK] = ACTIONS(9909),
    [anon_sym_COLON_DASH] = ACTIONS(9909),
    [anon_sym_PERCENT] = ACTIONS(9909),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4210] = {
    [sym_concatenation] = STATE(4353),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4353),
    [anon_sym_RBRACE] = ACTIONS(9901),
    [anon_sym_EQ] = ACTIONS(9915),
    [anon_sym_DASH] = ACTIONS(9915),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(9919),
    [anon_sym_COLON] = ACTIONS(9915),
    [anon_sym_COLON_QMARK] = ACTIONS(9915),
    [anon_sym_COLON_DASH] = ACTIONS(9915),
    [anon_sym_PERCENT] = ACTIONS(9915),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4211] = {
    [sym__simple_heredoc_body] = ACTIONS(2462),
    [sym__heredoc_body_beginning] = ACTIONS(2462),
    [sym_file_descriptor] = ACTIONS(2462),
    [sym__concat] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_esac] = ACTIONS(2464),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_SEMI_SEMI] = ACTIONS(2462),
    [anon_sym_PIPE_AMP] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_GT_GT] = ACTIONS(2462),
    [anon_sym_AMP_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT_GT] = ACTIONS(2462),
    [anon_sym_LT_AMP] = ACTIONS(2462),
    [anon_sym_GT_AMP] = ACTIONS(2462),
    [anon_sym_LT_LT] = ACTIONS(2464),
    [anon_sym_LT_LT_DASH] = ACTIONS(2462),
    [anon_sym_LT_LT_LT] = ACTIONS(2462),
    [anon_sym_DOLLAR] = ACTIONS(2464),
    [sym__special_character] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [sym_raw_string] = ACTIONS(2462),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2462),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2462),
    [anon_sym_BQUOTE] = ACTIONS(2462),
    [anon_sym_LT_LPAREN] = ACTIONS(2462),
    [anon_sym_GT_LPAREN] = ACTIONS(2462),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2464),
    [sym_word] = ACTIONS(2464),
    [anon_sym_LF] = ACTIONS(2462),
    [anon_sym_AMP] = ACTIONS(2464),
  },
  [4212] = {
    [sym_concatenation] = STATE(4356),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4356),
    [sym_regex] = ACTIONS(9921),
    [anon_sym_RBRACE] = ACTIONS(9923),
    [anon_sym_EQ] = ACTIONS(9925),
    [anon_sym_DASH] = ACTIONS(9925),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9925),
    [anon_sym_COLON_QMARK] = ACTIONS(9925),
    [anon_sym_COLON_DASH] = ACTIONS(9925),
    [anon_sym_PERCENT] = ACTIONS(9925),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4213] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9923),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4214] = {
    [sym__simple_heredoc_body] = ACTIONS(2512),
    [sym__heredoc_body_beginning] = ACTIONS(2512),
    [sym_file_descriptor] = ACTIONS(2512),
    [sym__concat] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2514),
    [anon_sym_esac] = ACTIONS(2514),
    [anon_sym_PIPE] = ACTIONS(2514),
    [anon_sym_SEMI_SEMI] = ACTIONS(2512),
    [anon_sym_PIPE_AMP] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE_PIPE] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2514),
    [anon_sym_GT] = ACTIONS(2514),
    [anon_sym_GT_GT] = ACTIONS(2512),
    [anon_sym_AMP_GT] = ACTIONS(2514),
    [anon_sym_AMP_GT_GT] = ACTIONS(2512),
    [anon_sym_LT_AMP] = ACTIONS(2512),
    [anon_sym_GT_AMP] = ACTIONS(2512),
    [anon_sym_LT_LT] = ACTIONS(2514),
    [anon_sym_LT_LT_DASH] = ACTIONS(2512),
    [anon_sym_LT_LT_LT] = ACTIONS(2512),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [sym__special_character] = ACTIONS(2512),
    [anon_sym_DQUOTE] = ACTIONS(2512),
    [sym_raw_string] = ACTIONS(2512),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2512),
    [anon_sym_BQUOTE] = ACTIONS(2512),
    [anon_sym_LT_LPAREN] = ACTIONS(2512),
    [anon_sym_GT_LPAREN] = ACTIONS(2512),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2514),
    [sym_word] = ACTIONS(2514),
    [anon_sym_LF] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2514),
  },
  [4215] = {
    [sym_concatenation] = STATE(4353),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4353),
    [sym_regex] = ACTIONS(9929),
    [anon_sym_RBRACE] = ACTIONS(9901),
    [anon_sym_EQ] = ACTIONS(9915),
    [anon_sym_DASH] = ACTIONS(9915),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9915),
    [anon_sym_COLON_QMARK] = ACTIONS(9915),
    [anon_sym_COLON_DASH] = ACTIONS(9915),
    [anon_sym_PERCENT] = ACTIONS(9915),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4216] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9901),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4217] = {
    [sym__simple_heredoc_body] = ACTIONS(2520),
    [sym__heredoc_body_beginning] = ACTIONS(2520),
    [sym_file_descriptor] = ACTIONS(2520),
    [sym__concat] = ACTIONS(2520),
    [anon_sym_SEMI] = ACTIONS(2522),
    [anon_sym_esac] = ACTIONS(2522),
    [anon_sym_PIPE] = ACTIONS(2522),
    [anon_sym_SEMI_SEMI] = ACTIONS(2520),
    [anon_sym_PIPE_AMP] = ACTIONS(2520),
    [anon_sym_AMP_AMP] = ACTIONS(2520),
    [anon_sym_PIPE_PIPE] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(2522),
    [anon_sym_GT] = ACTIONS(2522),
    [anon_sym_GT_GT] = ACTIONS(2520),
    [anon_sym_AMP_GT] = ACTIONS(2522),
    [anon_sym_AMP_GT_GT] = ACTIONS(2520),
    [anon_sym_LT_AMP] = ACTIONS(2520),
    [anon_sym_GT_AMP] = ACTIONS(2520),
    [anon_sym_LT_LT] = ACTIONS(2522),
    [anon_sym_LT_LT_DASH] = ACTIONS(2520),
    [anon_sym_LT_LT_LT] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(2522),
    [sym__special_character] = ACTIONS(2520),
    [anon_sym_DQUOTE] = ACTIONS(2520),
    [sym_raw_string] = ACTIONS(2520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2520),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2520),
    [anon_sym_BQUOTE] = ACTIONS(2520),
    [anon_sym_LT_LPAREN] = ACTIONS(2520),
    [anon_sym_GT_LPAREN] = ACTIONS(2520),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2522),
    [sym_word] = ACTIONS(2522),
    [anon_sym_LF] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2522),
  },
  [4218] = {
    [sym__simple_heredoc_body] = ACTIONS(2554),
    [sym__heredoc_body_beginning] = ACTIONS(2554),
    [sym_file_descriptor] = ACTIONS(2554),
    [sym__concat] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(2556),
    [anon_sym_esac] = ACTIONS(2556),
    [anon_sym_PIPE] = ACTIONS(2556),
    [anon_sym_SEMI_SEMI] = ACTIONS(2554),
    [anon_sym_PIPE_AMP] = ACTIONS(2554),
    [anon_sym_AMP_AMP] = ACTIONS(2554),
    [anon_sym_PIPE_PIPE] = ACTIONS(2554),
    [anon_sym_LT] = ACTIONS(2556),
    [anon_sym_GT] = ACTIONS(2556),
    [anon_sym_GT_GT] = ACTIONS(2554),
    [anon_sym_AMP_GT] = ACTIONS(2556),
    [anon_sym_AMP_GT_GT] = ACTIONS(2554),
    [anon_sym_LT_AMP] = ACTIONS(2554),
    [anon_sym_GT_AMP] = ACTIONS(2554),
    [anon_sym_LT_LT] = ACTIONS(2556),
    [anon_sym_LT_LT_DASH] = ACTIONS(2554),
    [anon_sym_LT_LT_LT] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2556),
    [sym__special_character] = ACTIONS(2554),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2554),
    [anon_sym_BQUOTE] = ACTIONS(2554),
    [anon_sym_LT_LPAREN] = ACTIONS(2554),
    [anon_sym_GT_LPAREN] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2556),
    [sym_word] = ACTIONS(2556),
    [anon_sym_LF] = ACTIONS(2554),
    [anon_sym_AMP] = ACTIONS(2556),
  },
  [4219] = {
    [sym_string] = STATE(3593),
    [sym__simple_heredoc_body] = ACTIONS(4071),
    [sym__heredoc_body_beginning] = ACTIONS(4071),
    [sym_file_descriptor] = ACTIONS(4071),
    [anon_sym_SEMI] = ACTIONS(4073),
    [anon_sym_esac] = ACTIONS(4073),
    [anon_sym_PIPE] = ACTIONS(4073),
    [anon_sym_SEMI_SEMI] = ACTIONS(4071),
    [anon_sym_PIPE_AMP] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_PIPE_PIPE] = ACTIONS(4071),
    [anon_sym_EQ_TILDE] = ACTIONS(4073),
    [anon_sym_EQ_EQ] = ACTIONS(4073),
    [anon_sym_LT] = ACTIONS(4073),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_GT_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT] = ACTIONS(4073),
    [anon_sym_AMP_GT_GT] = ACTIONS(4071),
    [anon_sym_LT_AMP] = ACTIONS(4071),
    [anon_sym_GT_AMP] = ACTIONS(4071),
    [anon_sym_LT_LT] = ACTIONS(4073),
    [anon_sym_LT_LT_DASH] = ACTIONS(4071),
    [anon_sym_LT_LT_LT] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(9931),
    [anon_sym_DOLLAR] = ACTIONS(9931),
    [sym__special_character] = ACTIONS(4071),
    [anon_sym_DQUOTE] = ACTIONS(6868),
    [sym_raw_string] = ACTIONS(8129),
    [anon_sym_POUND] = ACTIONS(8127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4071),
    [anon_sym_BQUOTE] = ACTIONS(4071),
    [anon_sym_LT_LPAREN] = ACTIONS(4071),
    [anon_sym_GT_LPAREN] = ACTIONS(4071),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8131),
    [anon_sym_STAR] = ACTIONS(8131),
    [anon_sym_AT] = ACTIONS(8131),
    [anon_sym_QMARK] = ACTIONS(8131),
    [anon_sym_0] = ACTIONS(8131),
    [anon_sym__] = ACTIONS(8131),
    [sym_word] = ACTIONS(4073),
    [anon_sym_LF] = ACTIONS(4071),
    [anon_sym_AMP] = ACTIONS(4073),
  },
  [4220] = {
    [sym__simple_heredoc_body] = ACTIONS(4111),
    [sym__heredoc_body_beginning] = ACTIONS(4111),
    [sym_file_descriptor] = ACTIONS(4111),
    [sym__concat] = ACTIONS(4111),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_esac] = ACTIONS(4113),
    [anon_sym_PIPE] = ACTIONS(4113),
    [anon_sym_SEMI_SEMI] = ACTIONS(4111),
    [anon_sym_PIPE_AMP] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_EQ_TILDE] = ACTIONS(4113),
    [anon_sym_EQ_EQ] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4113),
    [anon_sym_GT_GT] = ACTIONS(4111),
    [anon_sym_AMP_GT] = ACTIONS(4113),
    [anon_sym_AMP_GT_GT] = ACTIONS(4111),
    [anon_sym_LT_AMP] = ACTIONS(4111),
    [anon_sym_GT_AMP] = ACTIONS(4111),
    [anon_sym_LT_LT] = ACTIONS(4113),
    [anon_sym_LT_LT_DASH] = ACTIONS(4111),
    [anon_sym_LT_LT_LT] = ACTIONS(4111),
    [anon_sym_DOLLAR] = ACTIONS(4113),
    [sym__special_character] = ACTIONS(4111),
    [anon_sym_DQUOTE] = ACTIONS(4111),
    [sym_raw_string] = ACTIONS(4111),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4111),
    [anon_sym_BQUOTE] = ACTIONS(4111),
    [anon_sym_LT_LPAREN] = ACTIONS(4111),
    [anon_sym_GT_LPAREN] = ACTIONS(4111),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4113),
    [anon_sym_LF] = ACTIONS(4111),
    [anon_sym_AMP] = ACTIONS(4113),
  },
  [4221] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_esac] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_EQ_TILDE] = ACTIONS(4127),
    [anon_sym_EQ_EQ] = ACTIONS(4127),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym__special_character] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [4222] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(9933),
    [sym_comment] = ACTIONS(57),
  },
  [4223] = {
    [anon_sym_RBRACE] = ACTIONS(9933),
    [sym_comment] = ACTIONS(57),
  },
  [4224] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(9935),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [4225] = {
    [sym_concatenation] = STATE(4361),
    [sym_string] = STATE(4360),
    [sym_simple_expansion] = STATE(4360),
    [sym_string_expansion] = STATE(4360),
    [sym_expansion] = STATE(4360),
    [sym_command_substitution] = STATE(4360),
    [sym_process_substitution] = STATE(4360),
    [aux_sym__literal_repeat1] = STATE(4362),
    [anon_sym_RBRACE] = ACTIONS(9933),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(9937),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9937),
  },
  [4226] = {
    [sym__simple_heredoc_body] = ACTIONS(4161),
    [sym__heredoc_body_beginning] = ACTIONS(4161),
    [sym_file_descriptor] = ACTIONS(4161),
    [sym__concat] = ACTIONS(4161),
    [anon_sym_SEMI] = ACTIONS(4163),
    [anon_sym_esac] = ACTIONS(4163),
    [anon_sym_PIPE] = ACTIONS(4163),
    [anon_sym_SEMI_SEMI] = ACTIONS(4161),
    [anon_sym_PIPE_AMP] = ACTIONS(4161),
    [anon_sym_AMP_AMP] = ACTIONS(4161),
    [anon_sym_PIPE_PIPE] = ACTIONS(4161),
    [anon_sym_EQ_TILDE] = ACTIONS(4163),
    [anon_sym_EQ_EQ] = ACTIONS(4163),
    [anon_sym_LT] = ACTIONS(4163),
    [anon_sym_GT] = ACTIONS(4163),
    [anon_sym_GT_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT] = ACTIONS(4163),
    [anon_sym_AMP_GT_GT] = ACTIONS(4161),
    [anon_sym_LT_AMP] = ACTIONS(4161),
    [anon_sym_GT_AMP] = ACTIONS(4161),
    [anon_sym_LT_LT] = ACTIONS(4163),
    [anon_sym_LT_LT_DASH] = ACTIONS(4161),
    [anon_sym_LT_LT_LT] = ACTIONS(4161),
    [anon_sym_DOLLAR] = ACTIONS(4163),
    [sym__special_character] = ACTIONS(4161),
    [anon_sym_DQUOTE] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4161),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4161),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4161),
    [anon_sym_BQUOTE] = ACTIONS(4161),
    [anon_sym_LT_LPAREN] = ACTIONS(4161),
    [anon_sym_GT_LPAREN] = ACTIONS(4161),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4163),
    [anon_sym_LF] = ACTIONS(4161),
    [anon_sym_AMP] = ACTIONS(4163),
  },
  [4227] = {
    [sym_concatenation] = STATE(4365),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4365),
    [sym_regex] = ACTIONS(9939),
    [anon_sym_RBRACE] = ACTIONS(9941),
    [anon_sym_EQ] = ACTIONS(9943),
    [anon_sym_DASH] = ACTIONS(9943),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9945),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9943),
    [anon_sym_COLON_QMARK] = ACTIONS(9943),
    [anon_sym_COLON_DASH] = ACTIONS(9943),
    [anon_sym_PERCENT] = ACTIONS(9943),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4228] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9941),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4229] = {
    [sym_concatenation] = STATE(4367),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4367),
    [sym_regex] = ACTIONS(9947),
    [anon_sym_RBRACE] = ACTIONS(9933),
    [anon_sym_EQ] = ACTIONS(9949),
    [anon_sym_DASH] = ACTIONS(9949),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9951),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9949),
    [anon_sym_COLON_QMARK] = ACTIONS(9949),
    [anon_sym_COLON_DASH] = ACTIONS(9949),
    [anon_sym_PERCENT] = ACTIONS(9949),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4230] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9933),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4231] = {
    [sym_concatenation] = STATE(4369),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4369),
    [anon_sym_RBRACE] = ACTIONS(9953),
    [anon_sym_EQ] = ACTIONS(9955),
    [anon_sym_DASH] = ACTIONS(9955),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9957),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9955),
    [anon_sym_COLON_QMARK] = ACTIONS(9955),
    [anon_sym_COLON_DASH] = ACTIONS(9955),
    [anon_sym_PERCENT] = ACTIONS(9955),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4232] = {
    [sym__simple_heredoc_body] = ACTIONS(4219),
    [sym__heredoc_body_beginning] = ACTIONS(4219),
    [sym_file_descriptor] = ACTIONS(4219),
    [sym__concat] = ACTIONS(4219),
    [anon_sym_SEMI] = ACTIONS(4221),
    [anon_sym_esac] = ACTIONS(4221),
    [anon_sym_PIPE] = ACTIONS(4221),
    [anon_sym_SEMI_SEMI] = ACTIONS(4219),
    [anon_sym_PIPE_AMP] = ACTIONS(4219),
    [anon_sym_AMP_AMP] = ACTIONS(4219),
    [anon_sym_PIPE_PIPE] = ACTIONS(4219),
    [anon_sym_EQ_TILDE] = ACTIONS(4221),
    [anon_sym_EQ_EQ] = ACTIONS(4221),
    [anon_sym_LT] = ACTIONS(4221),
    [anon_sym_GT] = ACTIONS(4221),
    [anon_sym_GT_GT] = ACTIONS(4219),
    [anon_sym_AMP_GT] = ACTIONS(4221),
    [anon_sym_AMP_GT_GT] = ACTIONS(4219),
    [anon_sym_LT_AMP] = ACTIONS(4219),
    [anon_sym_GT_AMP] = ACTIONS(4219),
    [anon_sym_LT_LT] = ACTIONS(4221),
    [anon_sym_LT_LT_DASH] = ACTIONS(4219),
    [anon_sym_LT_LT_LT] = ACTIONS(4219),
    [anon_sym_DOLLAR] = ACTIONS(4221),
    [sym__special_character] = ACTIONS(4219),
    [anon_sym_DQUOTE] = ACTIONS(4219),
    [sym_raw_string] = ACTIONS(4219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4219),
    [anon_sym_BQUOTE] = ACTIONS(4219),
    [anon_sym_LT_LPAREN] = ACTIONS(4219),
    [anon_sym_GT_LPAREN] = ACTIONS(4219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4221),
    [anon_sym_LF] = ACTIONS(4219),
    [anon_sym_AMP] = ACTIONS(4221),
  },
  [4233] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9953),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4234] = {
    [sym_concatenation] = STATE(4367),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4367),
    [anon_sym_RBRACE] = ACTIONS(9933),
    [anon_sym_EQ] = ACTIONS(9949),
    [anon_sym_DASH] = ACTIONS(9949),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9951),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9949),
    [anon_sym_COLON_QMARK] = ACTIONS(9949),
    [anon_sym_COLON_DASH] = ACTIONS(9949),
    [anon_sym_PERCENT] = ACTIONS(9949),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4235] = {
    [aux_sym_concatenation_repeat1] = STATE(4237),
    [sym__simple_heredoc_body] = ACTIONS(1380),
    [sym__heredoc_body_beginning] = ACTIONS(1380),
    [sym_file_descriptor] = ACTIONS(1380),
    [sym__concat] = ACTIONS(6367),
    [anon_sym_SEMI] = ACTIONS(1382),
    [anon_sym_esac] = ACTIONS(1380),
    [anon_sym_PIPE] = ACTIONS(1382),
    [anon_sym_SEMI_SEMI] = ACTIONS(1380),
    [anon_sym_PIPE_AMP] = ACTIONS(1380),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_PIPE_PIPE] = ACTIONS(1380),
    [anon_sym_LT] = ACTIONS(1382),
    [anon_sym_GT] = ACTIONS(1382),
    [anon_sym_GT_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT] = ACTIONS(1382),
    [anon_sym_AMP_GT_GT] = ACTIONS(1380),
    [anon_sym_LT_AMP] = ACTIONS(1380),
    [anon_sym_GT_AMP] = ACTIONS(1380),
    [anon_sym_LT_LT] = ACTIONS(1382),
    [anon_sym_LT_LT_DASH] = ACTIONS(1380),
    [anon_sym_LT_LT_LT] = ACTIONS(1380),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1380),
    [anon_sym_AMP] = ACTIONS(1382),
  },
  [4236] = {
    [aux_sym__literal_repeat1] = STATE(4238),
    [sym__simple_heredoc_body] = ACTIONS(1384),
    [sym__heredoc_body_beginning] = ACTIONS(1384),
    [sym_file_descriptor] = ACTIONS(1384),
    [anon_sym_SEMI] = ACTIONS(1386),
    [anon_sym_esac] = ACTIONS(1384),
    [anon_sym_PIPE] = ACTIONS(1386),
    [anon_sym_SEMI_SEMI] = ACTIONS(1384),
    [anon_sym_PIPE_AMP] = ACTIONS(1384),
    [anon_sym_AMP_AMP] = ACTIONS(1384),
    [anon_sym_PIPE_PIPE] = ACTIONS(1384),
    [anon_sym_LT] = ACTIONS(1386),
    [anon_sym_GT] = ACTIONS(1386),
    [anon_sym_GT_GT] = ACTIONS(1384),
    [anon_sym_AMP_GT] = ACTIONS(1386),
    [anon_sym_AMP_GT_GT] = ACTIONS(1384),
    [anon_sym_LT_AMP] = ACTIONS(1384),
    [anon_sym_GT_AMP] = ACTIONS(1384),
    [anon_sym_LT_LT] = ACTIONS(1386),
    [anon_sym_LT_LT_DASH] = ACTIONS(1384),
    [anon_sym_LT_LT_LT] = ACTIONS(1384),
    [sym__special_character] = ACTIONS(6383),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1384),
    [anon_sym_AMP] = ACTIONS(1386),
  },
  [4237] = {
    [aux_sym_concatenation_repeat1] = STATE(4371),
    [sym__simple_heredoc_body] = ACTIONS(1071),
    [sym__heredoc_body_beginning] = ACTIONS(1071),
    [sym_file_descriptor] = ACTIONS(1071),
    [sym__concat] = ACTIONS(9959),
    [anon_sym_SEMI] = ACTIONS(1075),
    [anon_sym_esac] = ACTIONS(1071),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(1075),
    [anon_sym_AMP_GT_GT] = ACTIONS(1071),
    [anon_sym_LT_AMP] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_LT_LT_DASH] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(1071),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1075),
  },
  [4238] = {
    [aux_sym__literal_repeat1] = STATE(4238),
    [sym__simple_heredoc_body] = ACTIONS(1373),
    [sym__heredoc_body_beginning] = ACTIONS(1373),
    [sym_file_descriptor] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_esac] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_SEMI_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE_AMP] = ACTIONS(1373),
    [anon_sym_AMP_AMP] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT] = ACTIONS(1375),
    [anon_sym_AMP_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_AMP] = ACTIONS(1373),
    [anon_sym_GT_AMP] = ACTIONS(1373),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_LT_LT_DASH] = ACTIONS(1373),
    [anon_sym_LT_LT_LT] = ACTIONS(1373),
    [sym__special_character] = ACTIONS(7647),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
  },
  [4239] = {
    [sym_file_descriptor] = ACTIONS(2604),
    [sym_variable_name] = ACTIONS(2604),
    [anon_sym_for] = ACTIONS(2608),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2608),
    [anon_sym_if] = ACTIONS(2608),
    [anon_sym_case] = ACTIONS(2608),
    [anon_sym_esac] = ACTIONS(7650),
    [anon_sym_SEMI_SEMI] = ACTIONS(4379),
    [anon_sym_function] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(2608),
    [anon_sym_LBRACE] = ACTIONS(2604),
    [anon_sym_BANG] = ACTIONS(2608),
    [anon_sym_LBRACK] = ACTIONS(2608),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2604),
    [anon_sym_declare] = ACTIONS(2608),
    [anon_sym_typeset] = ACTIONS(2608),
    [anon_sym_export] = ACTIONS(2608),
    [anon_sym_readonly] = ACTIONS(2608),
    [anon_sym_local] = ACTIONS(2608),
    [anon_sym_unset] = ACTIONS(2608),
    [anon_sym_unsetenv] = ACTIONS(2608),
    [anon_sym_LT] = ACTIONS(2608),
    [anon_sym_GT] = ACTIONS(2608),
    [anon_sym_GT_GT] = ACTIONS(2604),
    [anon_sym_AMP_GT] = ACTIONS(2608),
    [anon_sym_AMP_GT_GT] = ACTIONS(2604),
    [anon_sym_LT_AMP] = ACTIONS(2604),
    [anon_sym_GT_AMP] = ACTIONS(2604),
    [anon_sym_DOLLAR] = ACTIONS(2608),
    [sym__special_character] = ACTIONS(2608),
    [anon_sym_DQUOTE] = ACTIONS(2604),
    [sym_raw_string] = ACTIONS(2604),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2604),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2604),
    [anon_sym_BQUOTE] = ACTIONS(2604),
    [anon_sym_LT_LPAREN] = ACTIONS(2604),
    [anon_sym_GT_LPAREN] = ACTIONS(2604),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2608),
  },
  [4240] = {
    [anon_sym_DOLLAR] = ACTIONS(8990),
    [sym__special_character] = ACTIONS(8992),
    [anon_sym_DQUOTE] = ACTIONS(8992),
    [sym_raw_string] = ACTIONS(8992),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8992),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8992),
    [anon_sym_BQUOTE] = ACTIONS(8992),
    [anon_sym_LT_LPAREN] = ACTIONS(8992),
    [anon_sym_GT_LPAREN] = ACTIONS(8992),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8992),
  },
  [4241] = {
    [anon_sym_SEMI] = ACTIONS(1251),
    [anon_sym_SEMI_SEMI] = ACTIONS(1239),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1253),
  },
  [4242] = {
    [sym_file_redirect] = STATE(1342),
    [sym_heredoc_redirect] = STATE(1342),
    [sym_heredoc_body] = STATE(4372),
    [sym_herestring_redirect] = STATE(1342),
    [aux_sym_redirected_statement_repeat1] = STATE(1342),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(2678),
    [anon_sym_SEMI] = ACTIONS(1275),
    [anon_sym_PIPE] = ACTIONS(2682),
    [anon_sym_SEMI_SEMI] = ACTIONS(1239),
    [anon_sym_PIPE_AMP] = ACTIONS(2686),
    [anon_sym_AMP_AMP] = ACTIONS(2688),
    [anon_sym_PIPE_PIPE] = ACTIONS(2688),
    [anon_sym_LT] = ACTIONS(2690),
    [anon_sym_GT] = ACTIONS(2690),
    [anon_sym_GT_GT] = ACTIONS(2692),
    [anon_sym_AMP_GT] = ACTIONS(2690),
    [anon_sym_AMP_GT_GT] = ACTIONS(2692),
    [anon_sym_LT_AMP] = ACTIONS(2692),
    [anon_sym_GT_AMP] = ACTIONS(2692),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(2694),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1275),
  },
  [4243] = {
    [sym_file_redirect] = STATE(1342),
    [sym_heredoc_redirect] = STATE(1342),
    [sym_heredoc_body] = STATE(4372),
    [sym_herestring_redirect] = STATE(1342),
    [aux_sym_redirected_statement_repeat1] = STATE(1342),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(1275),
    [anon_sym_PIPE] = ACTIONS(2682),
    [anon_sym_SEMI_SEMI] = ACTIONS(1239),
    [anon_sym_PIPE_AMP] = ACTIONS(2686),
    [anon_sym_AMP_AMP] = ACTIONS(2688),
    [anon_sym_PIPE_PIPE] = ACTIONS(2688),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(2694),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1275),
  },
  [4244] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(9961),
    [sym_comment] = ACTIONS(57),
  },
  [4245] = {
    [anon_sym_DOLLAR] = ACTIONS(9033),
    [sym__special_character] = ACTIONS(9035),
    [anon_sym_DQUOTE] = ACTIONS(9035),
    [sym_raw_string] = ACTIONS(9035),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(9035),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(9035),
    [anon_sym_BQUOTE] = ACTIONS(9035),
    [anon_sym_LT_LPAREN] = ACTIONS(9035),
    [anon_sym_GT_LPAREN] = ACTIONS(9035),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9035),
  },
  [4246] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(9963),
    [sym_comment] = ACTIONS(57),
  },
  [4247] = {
    [sym__simple_heredoc_body] = ACTIONS(8340),
    [sym__heredoc_body_beginning] = ACTIONS(8340),
    [sym_file_descriptor] = ACTIONS(8340),
    [sym__concat] = ACTIONS(8340),
    [sym_variable_name] = ACTIONS(8340),
    [anon_sym_SEMI] = ACTIONS(8342),
    [anon_sym_PIPE] = ACTIONS(8342),
    [anon_sym_SEMI_SEMI] = ACTIONS(8340),
    [anon_sym_RBRACE] = ACTIONS(8340),
    [anon_sym_PIPE_AMP] = ACTIONS(8340),
    [anon_sym_AMP_AMP] = ACTIONS(8340),
    [anon_sym_PIPE_PIPE] = ACTIONS(8340),
    [anon_sym_LT] = ACTIONS(8342),
    [anon_sym_GT] = ACTIONS(8342),
    [anon_sym_GT_GT] = ACTIONS(8340),
    [anon_sym_AMP_GT] = ACTIONS(8342),
    [anon_sym_AMP_GT_GT] = ACTIONS(8340),
    [anon_sym_LT_AMP] = ACTIONS(8340),
    [anon_sym_GT_AMP] = ACTIONS(8340),
    [anon_sym_LT_LT] = ACTIONS(8342),
    [anon_sym_LT_LT_DASH] = ACTIONS(8340),
    [anon_sym_LT_LT_LT] = ACTIONS(8340),
    [anon_sym_DOLLAR] = ACTIONS(8342),
    [sym__special_character] = ACTIONS(8342),
    [anon_sym_DQUOTE] = ACTIONS(8340),
    [sym_raw_string] = ACTIONS(8340),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8340),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [anon_sym_LT_LPAREN] = ACTIONS(8340),
    [anon_sym_GT_LPAREN] = ACTIONS(8340),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8342),
    [anon_sym_LF] = ACTIONS(8340),
    [anon_sym_AMP] = ACTIONS(8342),
  },
  [4248] = {
    [sym__simple_heredoc_body] = ACTIONS(8344),
    [sym__heredoc_body_beginning] = ACTIONS(8344),
    [sym_file_descriptor] = ACTIONS(8344),
    [sym__concat] = ACTIONS(8344),
    [sym_variable_name] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [anon_sym_PIPE] = ACTIONS(8346),
    [anon_sym_SEMI_SEMI] = ACTIONS(8344),
    [anon_sym_RBRACE] = ACTIONS(8344),
    [anon_sym_PIPE_AMP] = ACTIONS(8344),
    [anon_sym_AMP_AMP] = ACTIONS(8344),
    [anon_sym_PIPE_PIPE] = ACTIONS(8344),
    [anon_sym_LT] = ACTIONS(8346),
    [anon_sym_GT] = ACTIONS(8346),
    [anon_sym_GT_GT] = ACTIONS(8344),
    [anon_sym_AMP_GT] = ACTIONS(8346),
    [anon_sym_AMP_GT_GT] = ACTIONS(8344),
    [anon_sym_LT_AMP] = ACTIONS(8344),
    [anon_sym_GT_AMP] = ACTIONS(8344),
    [anon_sym_LT_LT] = ACTIONS(8346),
    [anon_sym_LT_LT_DASH] = ACTIONS(8344),
    [anon_sym_LT_LT_LT] = ACTIONS(8344),
    [anon_sym_DOLLAR] = ACTIONS(8346),
    [sym__special_character] = ACTIONS(8346),
    [anon_sym_DQUOTE] = ACTIONS(8344),
    [sym_raw_string] = ACTIONS(8344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8344),
    [anon_sym_BQUOTE] = ACTIONS(8344),
    [anon_sym_LT_LPAREN] = ACTIONS(8344),
    [anon_sym_GT_LPAREN] = ACTIONS(8344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8346),
    [anon_sym_LF] = ACTIONS(8344),
    [anon_sym_AMP] = ACTIONS(8346),
  },
  [4249] = {
    [sym__simple_heredoc_body] = ACTIONS(9109),
    [sym__heredoc_body_beginning] = ACTIONS(9109),
    [sym_file_descriptor] = ACTIONS(9109),
    [anon_sym_SEMI] = ACTIONS(9111),
    [anon_sym_PIPE] = ACTIONS(9111),
    [anon_sym_SEMI_SEMI] = ACTIONS(9109),
    [anon_sym_RBRACE] = ACTIONS(9109),
    [anon_sym_PIPE_AMP] = ACTIONS(9109),
    [anon_sym_AMP_AMP] = ACTIONS(9109),
    [anon_sym_PIPE_PIPE] = ACTIONS(9109),
    [anon_sym_LT] = ACTIONS(9111),
    [anon_sym_GT] = ACTIONS(9111),
    [anon_sym_GT_GT] = ACTIONS(9109),
    [anon_sym_AMP_GT] = ACTIONS(9111),
    [anon_sym_AMP_GT_GT] = ACTIONS(9109),
    [anon_sym_LT_AMP] = ACTIONS(9109),
    [anon_sym_GT_AMP] = ACTIONS(9109),
    [anon_sym_LT_LT] = ACTIONS(9111),
    [anon_sym_LT_LT_DASH] = ACTIONS(9109),
    [anon_sym_LT_LT_LT] = ACTIONS(9109),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(9109),
    [anon_sym_AMP] = ACTIONS(9111),
  },
  [4250] = {
    [sym_do_group] = STATE(4375),
    [sym_compound_statement] = STATE(4375),
    [anon_sym_do] = ACTIONS(1953),
    [anon_sym_LBRACE] = ACTIONS(191),
    [sym_comment] = ACTIONS(57),
  },
  [4251] = {
    [sym__concat] = ACTIONS(8340),
    [anon_sym_RBRACE] = ACTIONS(8340),
    [sym_comment] = ACTIONS(57),
  },
  [4252] = {
    [sym__concat] = ACTIONS(8344),
    [anon_sym_RBRACE] = ACTIONS(8344),
    [sym_comment] = ACTIONS(57),
  },
  [4253] = {
    [sym_file_descriptor] = ACTIONS(9680),
    [anon_sym_SEMI] = ACTIONS(9682),
    [anon_sym_PIPE] = ACTIONS(9682),
    [anon_sym_SEMI_SEMI] = ACTIONS(9680),
    [anon_sym_PIPE_AMP] = ACTIONS(9680),
    [anon_sym_AMP_AMP] = ACTIONS(9680),
    [anon_sym_PIPE_PIPE] = ACTIONS(9680),
    [anon_sym_LT] = ACTIONS(9682),
    [anon_sym_GT] = ACTIONS(9682),
    [anon_sym_GT_GT] = ACTIONS(9680),
    [anon_sym_AMP_GT] = ACTIONS(9682),
    [anon_sym_AMP_GT_GT] = ACTIONS(9680),
    [anon_sym_LT_AMP] = ACTIONS(9680),
    [anon_sym_GT_AMP] = ACTIONS(9680),
    [anon_sym_LT_LT] = ACTIONS(9682),
    [anon_sym_LT_LT_DASH] = ACTIONS(9680),
    [anon_sym_LT_LT_LT] = ACTIONS(9680),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(9680),
    [anon_sym_AMP] = ACTIONS(9682),
  },
  [4254] = {
    [sym__simple_heredoc_body] = ACTIONS(7198),
    [sym__heredoc_body_beginning] = ACTIONS(7198),
    [sym_file_descriptor] = ACTIONS(7198),
    [sym__concat] = ACTIONS(7198),
    [sym_variable_name] = ACTIONS(7198),
    [anon_sym_SEMI] = ACTIONS(7200),
    [anon_sym_done] = ACTIONS(7200),
    [anon_sym_PIPE] = ACTIONS(7200),
    [anon_sym_SEMI_SEMI] = ACTIONS(7198),
    [anon_sym_PIPE_AMP] = ACTIONS(7198),
    [anon_sym_AMP_AMP] = ACTIONS(7198),
    [anon_sym_PIPE_PIPE] = ACTIONS(7198),
    [anon_sym_LT] = ACTIONS(7200),
    [anon_sym_GT] = ACTIONS(7200),
    [anon_sym_GT_GT] = ACTIONS(7198),
    [anon_sym_AMP_GT] = ACTIONS(7200),
    [anon_sym_AMP_GT_GT] = ACTIONS(7198),
    [anon_sym_LT_AMP] = ACTIONS(7198),
    [anon_sym_GT_AMP] = ACTIONS(7198),
    [anon_sym_LT_LT] = ACTIONS(7200),
    [anon_sym_LT_LT_DASH] = ACTIONS(7198),
    [anon_sym_LT_LT_LT] = ACTIONS(7198),
    [anon_sym_DOLLAR] = ACTIONS(7200),
    [sym__special_character] = ACTIONS(7198),
    [anon_sym_DQUOTE] = ACTIONS(7198),
    [sym_raw_string] = ACTIONS(7198),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7198),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7198),
    [anon_sym_BQUOTE] = ACTIONS(7198),
    [anon_sym_LT_LPAREN] = ACTIONS(7198),
    [anon_sym_GT_LPAREN] = ACTIONS(7198),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7200),
    [anon_sym_LF] = ACTIONS(7198),
    [anon_sym_AMP] = ACTIONS(7200),
  },
  [4255] = {
    [sym__simple_heredoc_body] = ACTIONS(7202),
    [sym__heredoc_body_beginning] = ACTIONS(7202),
    [sym_file_descriptor] = ACTIONS(7202),
    [sym__concat] = ACTIONS(7202),
    [sym_variable_name] = ACTIONS(7202),
    [anon_sym_SEMI] = ACTIONS(7204),
    [anon_sym_done] = ACTIONS(7204),
    [anon_sym_PIPE] = ACTIONS(7204),
    [anon_sym_SEMI_SEMI] = ACTIONS(7202),
    [anon_sym_PIPE_AMP] = ACTIONS(7202),
    [anon_sym_AMP_AMP] = ACTIONS(7202),
    [anon_sym_PIPE_PIPE] = ACTIONS(7202),
    [anon_sym_LT] = ACTIONS(7204),
    [anon_sym_GT] = ACTIONS(7204),
    [anon_sym_GT_GT] = ACTIONS(7202),
    [anon_sym_AMP_GT] = ACTIONS(7204),
    [anon_sym_AMP_GT_GT] = ACTIONS(7202),
    [anon_sym_LT_AMP] = ACTIONS(7202),
    [anon_sym_GT_AMP] = ACTIONS(7202),
    [anon_sym_LT_LT] = ACTIONS(7204),
    [anon_sym_LT_LT_DASH] = ACTIONS(7202),
    [anon_sym_LT_LT_LT] = ACTIONS(7202),
    [anon_sym_DOLLAR] = ACTIONS(7204),
    [sym__special_character] = ACTIONS(7202),
    [anon_sym_DQUOTE] = ACTIONS(7202),
    [sym_raw_string] = ACTIONS(7202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7202),
    [anon_sym_BQUOTE] = ACTIONS(7202),
    [anon_sym_LT_LPAREN] = ACTIONS(7202),
    [anon_sym_GT_LPAREN] = ACTIONS(7202),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7204),
    [anon_sym_LF] = ACTIONS(7202),
    [anon_sym_AMP] = ACTIONS(7204),
  },
  [4256] = {
    [sym__simple_heredoc_body] = ACTIONS(7206),
    [sym__heredoc_body_beginning] = ACTIONS(7206),
    [sym_file_descriptor] = ACTIONS(7206),
    [sym__concat] = ACTIONS(7206),
    [sym_variable_name] = ACTIONS(7206),
    [anon_sym_SEMI] = ACTIONS(7208),
    [anon_sym_done] = ACTIONS(7208),
    [anon_sym_PIPE] = ACTIONS(7208),
    [anon_sym_SEMI_SEMI] = ACTIONS(7206),
    [anon_sym_PIPE_AMP] = ACTIONS(7206),
    [anon_sym_AMP_AMP] = ACTIONS(7206),
    [anon_sym_PIPE_PIPE] = ACTIONS(7206),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7206),
    [anon_sym_AMP_GT] = ACTIONS(7208),
    [anon_sym_AMP_GT_GT] = ACTIONS(7206),
    [anon_sym_LT_AMP] = ACTIONS(7206),
    [anon_sym_GT_AMP] = ACTIONS(7206),
    [anon_sym_LT_LT] = ACTIONS(7208),
    [anon_sym_LT_LT_DASH] = ACTIONS(7206),
    [anon_sym_LT_LT_LT] = ACTIONS(7206),
    [anon_sym_DOLLAR] = ACTIONS(7208),
    [sym__special_character] = ACTIONS(7206),
    [anon_sym_DQUOTE] = ACTIONS(7206),
    [sym_raw_string] = ACTIONS(7206),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7206),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7206),
    [anon_sym_BQUOTE] = ACTIONS(7206),
    [anon_sym_LT_LPAREN] = ACTIONS(7206),
    [anon_sym_GT_LPAREN] = ACTIONS(7206),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7208),
    [anon_sym_LF] = ACTIONS(7206),
    [anon_sym_AMP] = ACTIONS(7208),
  },
  [4257] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9965),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4258] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9967),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4259] = {
    [sym__simple_heredoc_body] = ACTIONS(7242),
    [sym__heredoc_body_beginning] = ACTIONS(7242),
    [sym_file_descriptor] = ACTIONS(7242),
    [sym__concat] = ACTIONS(7242),
    [sym_variable_name] = ACTIONS(7242),
    [anon_sym_SEMI] = ACTIONS(7244),
    [anon_sym_done] = ACTIONS(7244),
    [anon_sym_PIPE] = ACTIONS(7244),
    [anon_sym_SEMI_SEMI] = ACTIONS(7242),
    [anon_sym_PIPE_AMP] = ACTIONS(7242),
    [anon_sym_AMP_AMP] = ACTIONS(7242),
    [anon_sym_PIPE_PIPE] = ACTIONS(7242),
    [anon_sym_LT] = ACTIONS(7244),
    [anon_sym_GT] = ACTIONS(7244),
    [anon_sym_GT_GT] = ACTIONS(7242),
    [anon_sym_AMP_GT] = ACTIONS(7244),
    [anon_sym_AMP_GT_GT] = ACTIONS(7242),
    [anon_sym_LT_AMP] = ACTIONS(7242),
    [anon_sym_GT_AMP] = ACTIONS(7242),
    [anon_sym_LT_LT] = ACTIONS(7244),
    [anon_sym_LT_LT_DASH] = ACTIONS(7242),
    [anon_sym_LT_LT_LT] = ACTIONS(7242),
    [anon_sym_DOLLAR] = ACTIONS(7244),
    [sym__special_character] = ACTIONS(7242),
    [anon_sym_DQUOTE] = ACTIONS(7242),
    [sym_raw_string] = ACTIONS(7242),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7242),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7242),
    [anon_sym_BQUOTE] = ACTIONS(7242),
    [anon_sym_LT_LPAREN] = ACTIONS(7242),
    [anon_sym_GT_LPAREN] = ACTIONS(7242),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7244),
    [anon_sym_LF] = ACTIONS(7242),
    [anon_sym_AMP] = ACTIONS(7244),
  },
  [4260] = {
    [sym__simple_heredoc_body] = ACTIONS(8340),
    [sym__heredoc_body_beginning] = ACTIONS(8340),
    [sym_file_descriptor] = ACTIONS(8340),
    [sym__concat] = ACTIONS(8340),
    [sym_variable_name] = ACTIONS(8340),
    [anon_sym_SEMI] = ACTIONS(8342),
    [anon_sym_done] = ACTIONS(8342),
    [anon_sym_PIPE] = ACTIONS(8342),
    [anon_sym_SEMI_SEMI] = ACTIONS(8340),
    [anon_sym_PIPE_AMP] = ACTIONS(8340),
    [anon_sym_AMP_AMP] = ACTIONS(8340),
    [anon_sym_PIPE_PIPE] = ACTIONS(8340),
    [anon_sym_LT] = ACTIONS(8342),
    [anon_sym_GT] = ACTIONS(8342),
    [anon_sym_GT_GT] = ACTIONS(8340),
    [anon_sym_AMP_GT] = ACTIONS(8342),
    [anon_sym_AMP_GT_GT] = ACTIONS(8340),
    [anon_sym_LT_AMP] = ACTIONS(8340),
    [anon_sym_GT_AMP] = ACTIONS(8340),
    [anon_sym_LT_LT] = ACTIONS(8342),
    [anon_sym_LT_LT_DASH] = ACTIONS(8340),
    [anon_sym_LT_LT_LT] = ACTIONS(8340),
    [anon_sym_DOLLAR] = ACTIONS(8342),
    [sym__special_character] = ACTIONS(8340),
    [anon_sym_DQUOTE] = ACTIONS(8340),
    [sym_raw_string] = ACTIONS(8340),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8340),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [anon_sym_LT_LPAREN] = ACTIONS(8340),
    [anon_sym_GT_LPAREN] = ACTIONS(8340),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8342),
    [sym_word] = ACTIONS(8342),
    [anon_sym_LF] = ACTIONS(8340),
    [anon_sym_AMP] = ACTIONS(8342),
  },
  [4261] = {
    [sym__simple_heredoc_body] = ACTIONS(8344),
    [sym__heredoc_body_beginning] = ACTIONS(8344),
    [sym_file_descriptor] = ACTIONS(8344),
    [sym__concat] = ACTIONS(8344),
    [sym_variable_name] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [anon_sym_done] = ACTIONS(8346),
    [anon_sym_PIPE] = ACTIONS(8346),
    [anon_sym_SEMI_SEMI] = ACTIONS(8344),
    [anon_sym_PIPE_AMP] = ACTIONS(8344),
    [anon_sym_AMP_AMP] = ACTIONS(8344),
    [anon_sym_PIPE_PIPE] = ACTIONS(8344),
    [anon_sym_LT] = ACTIONS(8346),
    [anon_sym_GT] = ACTIONS(8346),
    [anon_sym_GT_GT] = ACTIONS(8344),
    [anon_sym_AMP_GT] = ACTIONS(8346),
    [anon_sym_AMP_GT_GT] = ACTIONS(8344),
    [anon_sym_LT_AMP] = ACTIONS(8344),
    [anon_sym_GT_AMP] = ACTIONS(8344),
    [anon_sym_LT_LT] = ACTIONS(8346),
    [anon_sym_LT_LT_DASH] = ACTIONS(8344),
    [anon_sym_LT_LT_LT] = ACTIONS(8344),
    [anon_sym_DOLLAR] = ACTIONS(8346),
    [sym__special_character] = ACTIONS(8344),
    [anon_sym_DQUOTE] = ACTIONS(8344),
    [sym_raw_string] = ACTIONS(8344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8344),
    [anon_sym_BQUOTE] = ACTIONS(8344),
    [anon_sym_LT_LPAREN] = ACTIONS(8344),
    [anon_sym_GT_LPAREN] = ACTIONS(8344),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8346),
    [sym_word] = ACTIONS(8346),
    [anon_sym_LF] = ACTIONS(8344),
    [anon_sym_AMP] = ACTIONS(8346),
  },
  [4262] = {
    [sym__simple_heredoc_body] = ACTIONS(8340),
    [sym__heredoc_body_beginning] = ACTIONS(8340),
    [sym_file_descriptor] = ACTIONS(8340),
    [sym__concat] = ACTIONS(8340),
    [anon_sym_SEMI] = ACTIONS(8342),
    [anon_sym_done] = ACTIONS(8342),
    [anon_sym_PIPE] = ACTIONS(8342),
    [anon_sym_SEMI_SEMI] = ACTIONS(8340),
    [anon_sym_PIPE_AMP] = ACTIONS(8340),
    [anon_sym_AMP_AMP] = ACTIONS(8340),
    [anon_sym_PIPE_PIPE] = ACTIONS(8340),
    [anon_sym_LT] = ACTIONS(8342),
    [anon_sym_GT] = ACTIONS(8342),
    [anon_sym_GT_GT] = ACTIONS(8340),
    [anon_sym_AMP_GT] = ACTIONS(8342),
    [anon_sym_AMP_GT_GT] = ACTIONS(8340),
    [anon_sym_LT_AMP] = ACTIONS(8340),
    [anon_sym_GT_AMP] = ACTIONS(8340),
    [anon_sym_LT_LT] = ACTIONS(8342),
    [anon_sym_LT_LT_DASH] = ACTIONS(8340),
    [anon_sym_LT_LT_LT] = ACTIONS(8340),
    [anon_sym_DOLLAR] = ACTIONS(8342),
    [sym__special_character] = ACTIONS(8340),
    [anon_sym_DQUOTE] = ACTIONS(8340),
    [sym_raw_string] = ACTIONS(8340),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8340),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [anon_sym_LT_LPAREN] = ACTIONS(8340),
    [anon_sym_GT_LPAREN] = ACTIONS(8340),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8342),
    [sym_word] = ACTIONS(8342),
    [anon_sym_LF] = ACTIONS(8340),
    [anon_sym_AMP] = ACTIONS(8342),
  },
  [4263] = {
    [sym__simple_heredoc_body] = ACTIONS(8344),
    [sym__heredoc_body_beginning] = ACTIONS(8344),
    [sym_file_descriptor] = ACTIONS(8344),
    [sym__concat] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [anon_sym_done] = ACTIONS(8346),
    [anon_sym_PIPE] = ACTIONS(8346),
    [anon_sym_SEMI_SEMI] = ACTIONS(8344),
    [anon_sym_PIPE_AMP] = ACTIONS(8344),
    [anon_sym_AMP_AMP] = ACTIONS(8344),
    [anon_sym_PIPE_PIPE] = ACTIONS(8344),
    [anon_sym_LT] = ACTIONS(8346),
    [anon_sym_GT] = ACTIONS(8346),
    [anon_sym_GT_GT] = ACTIONS(8344),
    [anon_sym_AMP_GT] = ACTIONS(8346),
    [anon_sym_AMP_GT_GT] = ACTIONS(8344),
    [anon_sym_LT_AMP] = ACTIONS(8344),
    [anon_sym_GT_AMP] = ACTIONS(8344),
    [anon_sym_LT_LT] = ACTIONS(8346),
    [anon_sym_LT_LT_DASH] = ACTIONS(8344),
    [anon_sym_LT_LT_LT] = ACTIONS(8344),
    [anon_sym_DOLLAR] = ACTIONS(8346),
    [sym__special_character] = ACTIONS(8344),
    [anon_sym_DQUOTE] = ACTIONS(8344),
    [sym_raw_string] = ACTIONS(8344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8344),
    [anon_sym_BQUOTE] = ACTIONS(8344),
    [anon_sym_LT_LPAREN] = ACTIONS(8344),
    [anon_sym_GT_LPAREN] = ACTIONS(8344),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8346),
    [sym_word] = ACTIONS(8346),
    [anon_sym_LF] = ACTIONS(8344),
    [anon_sym_AMP] = ACTIONS(8346),
  },
  [4264] = {
    [sym__simple_heredoc_body] = ACTIONS(7198),
    [sym__heredoc_body_beginning] = ACTIONS(7198),
    [sym_file_descriptor] = ACTIONS(7198),
    [sym__concat] = ACTIONS(7198),
    [anon_sym_SEMI] = ACTIONS(7200),
    [anon_sym_done] = ACTIONS(7198),
    [anon_sym_fi] = ACTIONS(7198),
    [anon_sym_elif] = ACTIONS(7198),
    [anon_sym_else] = ACTIONS(7198),
    [anon_sym_esac] = ACTIONS(7198),
    [anon_sym_PIPE] = ACTIONS(7200),
    [anon_sym_SEMI_SEMI] = ACTIONS(7198),
    [anon_sym_PIPE_AMP] = ACTIONS(7198),
    [anon_sym_AMP_AMP] = ACTIONS(7198),
    [anon_sym_PIPE_PIPE] = ACTIONS(7198),
    [anon_sym_LT] = ACTIONS(7200),
    [anon_sym_GT] = ACTIONS(7200),
    [anon_sym_GT_GT] = ACTIONS(7198),
    [anon_sym_AMP_GT] = ACTIONS(7200),
    [anon_sym_AMP_GT_GT] = ACTIONS(7198),
    [anon_sym_LT_AMP] = ACTIONS(7198),
    [anon_sym_GT_AMP] = ACTIONS(7198),
    [anon_sym_LT_LT] = ACTIONS(7200),
    [anon_sym_LT_LT_DASH] = ACTIONS(7198),
    [anon_sym_LT_LT_LT] = ACTIONS(7198),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(7198),
    [anon_sym_AMP] = ACTIONS(7200),
  },
  [4265] = {
    [sym__simple_heredoc_body] = ACTIONS(7202),
    [sym__heredoc_body_beginning] = ACTIONS(7202),
    [sym_file_descriptor] = ACTIONS(7202),
    [sym__concat] = ACTIONS(7202),
    [anon_sym_SEMI] = ACTIONS(7204),
    [anon_sym_done] = ACTIONS(7202),
    [anon_sym_fi] = ACTIONS(7202),
    [anon_sym_elif] = ACTIONS(7202),
    [anon_sym_else] = ACTIONS(7202),
    [anon_sym_esac] = ACTIONS(7202),
    [anon_sym_PIPE] = ACTIONS(7204),
    [anon_sym_SEMI_SEMI] = ACTIONS(7202),
    [anon_sym_PIPE_AMP] = ACTIONS(7202),
    [anon_sym_AMP_AMP] = ACTIONS(7202),
    [anon_sym_PIPE_PIPE] = ACTIONS(7202),
    [anon_sym_LT] = ACTIONS(7204),
    [anon_sym_GT] = ACTIONS(7204),
    [anon_sym_GT_GT] = ACTIONS(7202),
    [anon_sym_AMP_GT] = ACTIONS(7204),
    [anon_sym_AMP_GT_GT] = ACTIONS(7202),
    [anon_sym_LT_AMP] = ACTIONS(7202),
    [anon_sym_GT_AMP] = ACTIONS(7202),
    [anon_sym_LT_LT] = ACTIONS(7204),
    [anon_sym_LT_LT_DASH] = ACTIONS(7202),
    [anon_sym_LT_LT_LT] = ACTIONS(7202),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(7202),
    [anon_sym_AMP] = ACTIONS(7204),
  },
  [4266] = {
    [sym__simple_heredoc_body] = ACTIONS(7206),
    [sym__heredoc_body_beginning] = ACTIONS(7206),
    [sym_file_descriptor] = ACTIONS(7206),
    [sym__concat] = ACTIONS(7206),
    [anon_sym_SEMI] = ACTIONS(7208),
    [anon_sym_done] = ACTIONS(7206),
    [anon_sym_fi] = ACTIONS(7206),
    [anon_sym_elif] = ACTIONS(7206),
    [anon_sym_else] = ACTIONS(7206),
    [anon_sym_esac] = ACTIONS(7206),
    [anon_sym_PIPE] = ACTIONS(7208),
    [anon_sym_SEMI_SEMI] = ACTIONS(7206),
    [anon_sym_PIPE_AMP] = ACTIONS(7206),
    [anon_sym_AMP_AMP] = ACTIONS(7206),
    [anon_sym_PIPE_PIPE] = ACTIONS(7206),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7206),
    [anon_sym_AMP_GT] = ACTIONS(7208),
    [anon_sym_AMP_GT_GT] = ACTIONS(7206),
    [anon_sym_LT_AMP] = ACTIONS(7206),
    [anon_sym_GT_AMP] = ACTIONS(7206),
    [anon_sym_LT_LT] = ACTIONS(7208),
    [anon_sym_LT_LT_DASH] = ACTIONS(7206),
    [anon_sym_LT_LT_LT] = ACTIONS(7206),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(7206),
    [anon_sym_AMP] = ACTIONS(7208),
  },
  [4267] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9969),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4268] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9971),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4269] = {
    [sym__simple_heredoc_body] = ACTIONS(7242),
    [sym__heredoc_body_beginning] = ACTIONS(7242),
    [sym_file_descriptor] = ACTIONS(7242),
    [sym__concat] = ACTIONS(7242),
    [anon_sym_SEMI] = ACTIONS(7244),
    [anon_sym_done] = ACTIONS(7242),
    [anon_sym_fi] = ACTIONS(7242),
    [anon_sym_elif] = ACTIONS(7242),
    [anon_sym_else] = ACTIONS(7242),
    [anon_sym_esac] = ACTIONS(7242),
    [anon_sym_PIPE] = ACTIONS(7244),
    [anon_sym_SEMI_SEMI] = ACTIONS(7242),
    [anon_sym_PIPE_AMP] = ACTIONS(7242),
    [anon_sym_AMP_AMP] = ACTIONS(7242),
    [anon_sym_PIPE_PIPE] = ACTIONS(7242),
    [anon_sym_LT] = ACTIONS(7244),
    [anon_sym_GT] = ACTIONS(7244),
    [anon_sym_GT_GT] = ACTIONS(7242),
    [anon_sym_AMP_GT] = ACTIONS(7244),
    [anon_sym_AMP_GT_GT] = ACTIONS(7242),
    [anon_sym_LT_AMP] = ACTIONS(7242),
    [anon_sym_GT_AMP] = ACTIONS(7242),
    [anon_sym_LT_LT] = ACTIONS(7244),
    [anon_sym_LT_LT_DASH] = ACTIONS(7242),
    [anon_sym_LT_LT_LT] = ACTIONS(7242),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(7242),
    [anon_sym_AMP] = ACTIONS(7244),
  },
  [4270] = {
    [sym__simple_heredoc_body] = ACTIONS(7198),
    [sym__heredoc_body_beginning] = ACTIONS(7198),
    [sym_file_descriptor] = ACTIONS(7198),
    [sym__concat] = ACTIONS(7198),
    [sym_variable_name] = ACTIONS(7198),
    [anon_sym_SEMI] = ACTIONS(7200),
    [anon_sym_fi] = ACTIONS(7200),
    [anon_sym_elif] = ACTIONS(7200),
    [anon_sym_else] = ACTIONS(7200),
    [anon_sym_PIPE] = ACTIONS(7200),
    [anon_sym_SEMI_SEMI] = ACTIONS(7198),
    [anon_sym_PIPE_AMP] = ACTIONS(7198),
    [anon_sym_AMP_AMP] = ACTIONS(7198),
    [anon_sym_PIPE_PIPE] = ACTIONS(7198),
    [anon_sym_LT] = ACTIONS(7200),
    [anon_sym_GT] = ACTIONS(7200),
    [anon_sym_GT_GT] = ACTIONS(7198),
    [anon_sym_AMP_GT] = ACTIONS(7200),
    [anon_sym_AMP_GT_GT] = ACTIONS(7198),
    [anon_sym_LT_AMP] = ACTIONS(7198),
    [anon_sym_GT_AMP] = ACTIONS(7198),
    [anon_sym_LT_LT] = ACTIONS(7200),
    [anon_sym_LT_LT_DASH] = ACTIONS(7198),
    [anon_sym_LT_LT_LT] = ACTIONS(7198),
    [anon_sym_DOLLAR] = ACTIONS(7200),
    [sym__special_character] = ACTIONS(7198),
    [anon_sym_DQUOTE] = ACTIONS(7198),
    [sym_raw_string] = ACTIONS(7198),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7198),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7198),
    [anon_sym_BQUOTE] = ACTIONS(7198),
    [anon_sym_LT_LPAREN] = ACTIONS(7198),
    [anon_sym_GT_LPAREN] = ACTIONS(7198),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7200),
    [anon_sym_LF] = ACTIONS(7198),
    [anon_sym_AMP] = ACTIONS(7200),
  },
  [4271] = {
    [sym__simple_heredoc_body] = ACTIONS(7202),
    [sym__heredoc_body_beginning] = ACTIONS(7202),
    [sym_file_descriptor] = ACTIONS(7202),
    [sym__concat] = ACTIONS(7202),
    [sym_variable_name] = ACTIONS(7202),
    [anon_sym_SEMI] = ACTIONS(7204),
    [anon_sym_fi] = ACTIONS(7204),
    [anon_sym_elif] = ACTIONS(7204),
    [anon_sym_else] = ACTIONS(7204),
    [anon_sym_PIPE] = ACTIONS(7204),
    [anon_sym_SEMI_SEMI] = ACTIONS(7202),
    [anon_sym_PIPE_AMP] = ACTIONS(7202),
    [anon_sym_AMP_AMP] = ACTIONS(7202),
    [anon_sym_PIPE_PIPE] = ACTIONS(7202),
    [anon_sym_LT] = ACTIONS(7204),
    [anon_sym_GT] = ACTIONS(7204),
    [anon_sym_GT_GT] = ACTIONS(7202),
    [anon_sym_AMP_GT] = ACTIONS(7204),
    [anon_sym_AMP_GT_GT] = ACTIONS(7202),
    [anon_sym_LT_AMP] = ACTIONS(7202),
    [anon_sym_GT_AMP] = ACTIONS(7202),
    [anon_sym_LT_LT] = ACTIONS(7204),
    [anon_sym_LT_LT_DASH] = ACTIONS(7202),
    [anon_sym_LT_LT_LT] = ACTIONS(7202),
    [anon_sym_DOLLAR] = ACTIONS(7204),
    [sym__special_character] = ACTIONS(7202),
    [anon_sym_DQUOTE] = ACTIONS(7202),
    [sym_raw_string] = ACTIONS(7202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7202),
    [anon_sym_BQUOTE] = ACTIONS(7202),
    [anon_sym_LT_LPAREN] = ACTIONS(7202),
    [anon_sym_GT_LPAREN] = ACTIONS(7202),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7204),
    [anon_sym_LF] = ACTIONS(7202),
    [anon_sym_AMP] = ACTIONS(7204),
  },
  [4272] = {
    [sym__simple_heredoc_body] = ACTIONS(7206),
    [sym__heredoc_body_beginning] = ACTIONS(7206),
    [sym_file_descriptor] = ACTIONS(7206),
    [sym__concat] = ACTIONS(7206),
    [sym_variable_name] = ACTIONS(7206),
    [anon_sym_SEMI] = ACTIONS(7208),
    [anon_sym_fi] = ACTIONS(7208),
    [anon_sym_elif] = ACTIONS(7208),
    [anon_sym_else] = ACTIONS(7208),
    [anon_sym_PIPE] = ACTIONS(7208),
    [anon_sym_SEMI_SEMI] = ACTIONS(7206),
    [anon_sym_PIPE_AMP] = ACTIONS(7206),
    [anon_sym_AMP_AMP] = ACTIONS(7206),
    [anon_sym_PIPE_PIPE] = ACTIONS(7206),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7206),
    [anon_sym_AMP_GT] = ACTIONS(7208),
    [anon_sym_AMP_GT_GT] = ACTIONS(7206),
    [anon_sym_LT_AMP] = ACTIONS(7206),
    [anon_sym_GT_AMP] = ACTIONS(7206),
    [anon_sym_LT_LT] = ACTIONS(7208),
    [anon_sym_LT_LT_DASH] = ACTIONS(7206),
    [anon_sym_LT_LT_LT] = ACTIONS(7206),
    [anon_sym_DOLLAR] = ACTIONS(7208),
    [sym__special_character] = ACTIONS(7206),
    [anon_sym_DQUOTE] = ACTIONS(7206),
    [sym_raw_string] = ACTIONS(7206),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7206),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7206),
    [anon_sym_BQUOTE] = ACTIONS(7206),
    [anon_sym_LT_LPAREN] = ACTIONS(7206),
    [anon_sym_GT_LPAREN] = ACTIONS(7206),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7208),
    [anon_sym_LF] = ACTIONS(7206),
    [anon_sym_AMP] = ACTIONS(7208),
  },
  [4273] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9973),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4274] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9975),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4275] = {
    [sym__simple_heredoc_body] = ACTIONS(7242),
    [sym__heredoc_body_beginning] = ACTIONS(7242),
    [sym_file_descriptor] = ACTIONS(7242),
    [sym__concat] = ACTIONS(7242),
    [sym_variable_name] = ACTIONS(7242),
    [anon_sym_SEMI] = ACTIONS(7244),
    [anon_sym_fi] = ACTIONS(7244),
    [anon_sym_elif] = ACTIONS(7244),
    [anon_sym_else] = ACTIONS(7244),
    [anon_sym_PIPE] = ACTIONS(7244),
    [anon_sym_SEMI_SEMI] = ACTIONS(7242),
    [anon_sym_PIPE_AMP] = ACTIONS(7242),
    [anon_sym_AMP_AMP] = ACTIONS(7242),
    [anon_sym_PIPE_PIPE] = ACTIONS(7242),
    [anon_sym_LT] = ACTIONS(7244),
    [anon_sym_GT] = ACTIONS(7244),
    [anon_sym_GT_GT] = ACTIONS(7242),
    [anon_sym_AMP_GT] = ACTIONS(7244),
    [anon_sym_AMP_GT_GT] = ACTIONS(7242),
    [anon_sym_LT_AMP] = ACTIONS(7242),
    [anon_sym_GT_AMP] = ACTIONS(7242),
    [anon_sym_LT_LT] = ACTIONS(7244),
    [anon_sym_LT_LT_DASH] = ACTIONS(7242),
    [anon_sym_LT_LT_LT] = ACTIONS(7242),
    [anon_sym_DOLLAR] = ACTIONS(7244),
    [sym__special_character] = ACTIONS(7242),
    [anon_sym_DQUOTE] = ACTIONS(7242),
    [sym_raw_string] = ACTIONS(7242),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7242),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7242),
    [anon_sym_BQUOTE] = ACTIONS(7242),
    [anon_sym_LT_LPAREN] = ACTIONS(7242),
    [anon_sym_GT_LPAREN] = ACTIONS(7242),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7244),
    [anon_sym_LF] = ACTIONS(7242),
    [anon_sym_AMP] = ACTIONS(7244),
  },
  [4276] = {
    [sym__simple_heredoc_body] = ACTIONS(5674),
    [sym__heredoc_body_beginning] = ACTIONS(5674),
    [sym_file_descriptor] = ACTIONS(5674),
    [sym__concat] = ACTIONS(5674),
    [sym_variable_name] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(5676),
    [anon_sym_fi] = ACTIONS(5676),
    [anon_sym_PIPE] = ACTIONS(5676),
    [anon_sym_SEMI_SEMI] = ACTIONS(5674),
    [anon_sym_PIPE_AMP] = ACTIONS(5674),
    [anon_sym_AMP_AMP] = ACTIONS(5674),
    [anon_sym_PIPE_PIPE] = ACTIONS(5674),
    [anon_sym_LT] = ACTIONS(5676),
    [anon_sym_GT] = ACTIONS(5676),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_AMP_GT] = ACTIONS(5676),
    [anon_sym_AMP_GT_GT] = ACTIONS(5674),
    [anon_sym_LT_AMP] = ACTIONS(5674),
    [anon_sym_GT_AMP] = ACTIONS(5674),
    [anon_sym_LT_LT] = ACTIONS(5676),
    [anon_sym_LT_LT_DASH] = ACTIONS(5674),
    [anon_sym_LT_LT_LT] = ACTIONS(5674),
    [anon_sym_DOLLAR] = ACTIONS(5676),
    [sym__special_character] = ACTIONS(5674),
    [anon_sym_DQUOTE] = ACTIONS(5674),
    [sym_raw_string] = ACTIONS(5674),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5674),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5674),
    [anon_sym_BQUOTE] = ACTIONS(5674),
    [anon_sym_LT_LPAREN] = ACTIONS(5674),
    [anon_sym_GT_LPAREN] = ACTIONS(5674),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5676),
    [anon_sym_LF] = ACTIONS(5674),
    [anon_sym_AMP] = ACTIONS(5676),
  },
  [4277] = {
    [sym__simple_heredoc_body] = ACTIONS(5708),
    [sym__heredoc_body_beginning] = ACTIONS(5708),
    [sym_file_descriptor] = ACTIONS(5708),
    [sym__concat] = ACTIONS(5708),
    [sym_variable_name] = ACTIONS(5708),
    [anon_sym_SEMI] = ACTIONS(5710),
    [anon_sym_fi] = ACTIONS(5710),
    [anon_sym_PIPE] = ACTIONS(5710),
    [anon_sym_SEMI_SEMI] = ACTIONS(5708),
    [anon_sym_PIPE_AMP] = ACTIONS(5708),
    [anon_sym_AMP_AMP] = ACTIONS(5708),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_LT] = ACTIONS(5710),
    [anon_sym_GT] = ACTIONS(5710),
    [anon_sym_GT_GT] = ACTIONS(5708),
    [anon_sym_AMP_GT] = ACTIONS(5710),
    [anon_sym_AMP_GT_GT] = ACTIONS(5708),
    [anon_sym_LT_AMP] = ACTIONS(5708),
    [anon_sym_GT_AMP] = ACTIONS(5708),
    [anon_sym_LT_LT] = ACTIONS(5710),
    [anon_sym_LT_LT_DASH] = ACTIONS(5708),
    [anon_sym_LT_LT_LT] = ACTIONS(5708),
    [anon_sym_DOLLAR] = ACTIONS(5710),
    [sym__special_character] = ACTIONS(5708),
    [anon_sym_DQUOTE] = ACTIONS(5708),
    [sym_raw_string] = ACTIONS(5708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5708),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5708),
    [anon_sym_BQUOTE] = ACTIONS(5708),
    [anon_sym_LT_LPAREN] = ACTIONS(5708),
    [anon_sym_GT_LPAREN] = ACTIONS(5708),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5710),
    [anon_sym_LF] = ACTIONS(5708),
    [anon_sym_AMP] = ACTIONS(5710),
  },
  [4278] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(9977),
    [sym_comment] = ACTIONS(57),
  },
  [4279] = {
    [anon_sym_RBRACE] = ACTIONS(9977),
    [sym_comment] = ACTIONS(57),
  },
  [4280] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(9979),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [4281] = {
    [sym_concatenation] = STATE(4385),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4385),
    [anon_sym_RBRACE] = ACTIONS(9981),
    [anon_sym_EQ] = ACTIONS(9983),
    [anon_sym_DASH] = ACTIONS(9983),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9983),
    [anon_sym_COLON_QMARK] = ACTIONS(9983),
    [anon_sym_COLON_DASH] = ACTIONS(9983),
    [anon_sym_PERCENT] = ACTIONS(9983),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4282] = {
    [sym__simple_heredoc_body] = ACTIONS(5725),
    [sym__heredoc_body_beginning] = ACTIONS(5725),
    [sym_file_descriptor] = ACTIONS(5725),
    [sym__concat] = ACTIONS(5725),
    [sym_variable_name] = ACTIONS(5725),
    [anon_sym_SEMI] = ACTIONS(5727),
    [anon_sym_fi] = ACTIONS(5727),
    [anon_sym_PIPE] = ACTIONS(5727),
    [anon_sym_SEMI_SEMI] = ACTIONS(5725),
    [anon_sym_PIPE_AMP] = ACTIONS(5725),
    [anon_sym_AMP_AMP] = ACTIONS(5725),
    [anon_sym_PIPE_PIPE] = ACTIONS(5725),
    [anon_sym_LT] = ACTIONS(5727),
    [anon_sym_GT] = ACTIONS(5727),
    [anon_sym_GT_GT] = ACTIONS(5725),
    [anon_sym_AMP_GT] = ACTIONS(5727),
    [anon_sym_AMP_GT_GT] = ACTIONS(5725),
    [anon_sym_LT_AMP] = ACTIONS(5725),
    [anon_sym_GT_AMP] = ACTIONS(5725),
    [anon_sym_LT_LT] = ACTIONS(5727),
    [anon_sym_LT_LT_DASH] = ACTIONS(5725),
    [anon_sym_LT_LT_LT] = ACTIONS(5725),
    [anon_sym_DOLLAR] = ACTIONS(5727),
    [sym__special_character] = ACTIONS(5725),
    [anon_sym_DQUOTE] = ACTIONS(5725),
    [sym_raw_string] = ACTIONS(5725),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5725),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5725),
    [anon_sym_BQUOTE] = ACTIONS(5725),
    [anon_sym_LT_LPAREN] = ACTIONS(5725),
    [anon_sym_GT_LPAREN] = ACTIONS(5725),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5727),
    [anon_sym_LF] = ACTIONS(5725),
    [anon_sym_AMP] = ACTIONS(5727),
  },
  [4283] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9981),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4284] = {
    [sym_concatenation] = STATE(4386),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4386),
    [anon_sym_RBRACE] = ACTIONS(9977),
    [anon_sym_EQ] = ACTIONS(9987),
    [anon_sym_DASH] = ACTIONS(9987),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(9989),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(9987),
    [anon_sym_COLON_QMARK] = ACTIONS(9987),
    [anon_sym_COLON_DASH] = ACTIONS(9987),
    [anon_sym_PERCENT] = ACTIONS(9987),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4285] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9977),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4286] = {
    [sym__simple_heredoc_body] = ACTIONS(5770),
    [sym__heredoc_body_beginning] = ACTIONS(5770),
    [sym_file_descriptor] = ACTIONS(5770),
    [sym__concat] = ACTIONS(5770),
    [sym_variable_name] = ACTIONS(5770),
    [anon_sym_SEMI] = ACTIONS(5772),
    [anon_sym_fi] = ACTIONS(5772),
    [anon_sym_PIPE] = ACTIONS(5772),
    [anon_sym_SEMI_SEMI] = ACTIONS(5770),
    [anon_sym_PIPE_AMP] = ACTIONS(5770),
    [anon_sym_AMP_AMP] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5770),
    [anon_sym_LT] = ACTIONS(5772),
    [anon_sym_GT] = ACTIONS(5772),
    [anon_sym_GT_GT] = ACTIONS(5770),
    [anon_sym_AMP_GT] = ACTIONS(5772),
    [anon_sym_AMP_GT_GT] = ACTIONS(5770),
    [anon_sym_LT_AMP] = ACTIONS(5770),
    [anon_sym_GT_AMP] = ACTIONS(5770),
    [anon_sym_LT_LT] = ACTIONS(5772),
    [anon_sym_LT_LT_DASH] = ACTIONS(5770),
    [anon_sym_LT_LT_LT] = ACTIONS(5770),
    [anon_sym_DOLLAR] = ACTIONS(5772),
    [sym__special_character] = ACTIONS(5770),
    [anon_sym_DQUOTE] = ACTIONS(5770),
    [sym_raw_string] = ACTIONS(5770),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5770),
    [anon_sym_BQUOTE] = ACTIONS(5770),
    [anon_sym_LT_LPAREN] = ACTIONS(5770),
    [anon_sym_GT_LPAREN] = ACTIONS(5770),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5772),
    [anon_sym_LF] = ACTIONS(5770),
    [anon_sym_AMP] = ACTIONS(5772),
  },
  [4287] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9991),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4288] = {
    [sym__simple_heredoc_body] = ACTIONS(7198),
    [sym__heredoc_body_beginning] = ACTIONS(7198),
    [sym_file_descriptor] = ACTIONS(7198),
    [sym__concat] = ACTIONS(7198),
    [sym_variable_name] = ACTIONS(7198),
    [anon_sym_SEMI] = ACTIONS(7200),
    [anon_sym_fi] = ACTIONS(7200),
    [anon_sym_PIPE] = ACTIONS(7200),
    [anon_sym_SEMI_SEMI] = ACTIONS(7198),
    [anon_sym_PIPE_AMP] = ACTIONS(7198),
    [anon_sym_AMP_AMP] = ACTIONS(7198),
    [anon_sym_PIPE_PIPE] = ACTIONS(7198),
    [anon_sym_LT] = ACTIONS(7200),
    [anon_sym_GT] = ACTIONS(7200),
    [anon_sym_GT_GT] = ACTIONS(7198),
    [anon_sym_AMP_GT] = ACTIONS(7200),
    [anon_sym_AMP_GT_GT] = ACTIONS(7198),
    [anon_sym_LT_AMP] = ACTIONS(7198),
    [anon_sym_GT_AMP] = ACTIONS(7198),
    [anon_sym_LT_LT] = ACTIONS(7200),
    [anon_sym_LT_LT_DASH] = ACTIONS(7198),
    [anon_sym_LT_LT_LT] = ACTIONS(7198),
    [anon_sym_DOLLAR] = ACTIONS(7200),
    [sym__special_character] = ACTIONS(7198),
    [anon_sym_DQUOTE] = ACTIONS(7198),
    [sym_raw_string] = ACTIONS(7198),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7198),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7198),
    [anon_sym_BQUOTE] = ACTIONS(7198),
    [anon_sym_LT_LPAREN] = ACTIONS(7198),
    [anon_sym_GT_LPAREN] = ACTIONS(7198),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7200),
    [sym_word] = ACTIONS(7200),
    [anon_sym_LF] = ACTIONS(7198),
    [anon_sym_AMP] = ACTIONS(7200),
  },
  [4289] = {
    [sym__simple_heredoc_body] = ACTIONS(7202),
    [sym__heredoc_body_beginning] = ACTIONS(7202),
    [sym_file_descriptor] = ACTIONS(7202),
    [sym__concat] = ACTIONS(7202),
    [sym_variable_name] = ACTIONS(7202),
    [anon_sym_SEMI] = ACTIONS(7204),
    [anon_sym_fi] = ACTIONS(7204),
    [anon_sym_PIPE] = ACTIONS(7204),
    [anon_sym_SEMI_SEMI] = ACTIONS(7202),
    [anon_sym_PIPE_AMP] = ACTIONS(7202),
    [anon_sym_AMP_AMP] = ACTIONS(7202),
    [anon_sym_PIPE_PIPE] = ACTIONS(7202),
    [anon_sym_LT] = ACTIONS(7204),
    [anon_sym_GT] = ACTIONS(7204),
    [anon_sym_GT_GT] = ACTIONS(7202),
    [anon_sym_AMP_GT] = ACTIONS(7204),
    [anon_sym_AMP_GT_GT] = ACTIONS(7202),
    [anon_sym_LT_AMP] = ACTIONS(7202),
    [anon_sym_GT_AMP] = ACTIONS(7202),
    [anon_sym_LT_LT] = ACTIONS(7204),
    [anon_sym_LT_LT_DASH] = ACTIONS(7202),
    [anon_sym_LT_LT_LT] = ACTIONS(7202),
    [anon_sym_DOLLAR] = ACTIONS(7204),
    [sym__special_character] = ACTIONS(7202),
    [anon_sym_DQUOTE] = ACTIONS(7202),
    [sym_raw_string] = ACTIONS(7202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7202),
    [anon_sym_BQUOTE] = ACTIONS(7202),
    [anon_sym_LT_LPAREN] = ACTIONS(7202),
    [anon_sym_GT_LPAREN] = ACTIONS(7202),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7204),
    [sym_word] = ACTIONS(7204),
    [anon_sym_LF] = ACTIONS(7202),
    [anon_sym_AMP] = ACTIONS(7204),
  },
  [4290] = {
    [sym__simple_heredoc_body] = ACTIONS(7206),
    [sym__heredoc_body_beginning] = ACTIONS(7206),
    [sym_file_descriptor] = ACTIONS(7206),
    [sym__concat] = ACTIONS(7206),
    [sym_variable_name] = ACTIONS(7206),
    [anon_sym_SEMI] = ACTIONS(7208),
    [anon_sym_fi] = ACTIONS(7208),
    [anon_sym_PIPE] = ACTIONS(7208),
    [anon_sym_SEMI_SEMI] = ACTIONS(7206),
    [anon_sym_PIPE_AMP] = ACTIONS(7206),
    [anon_sym_AMP_AMP] = ACTIONS(7206),
    [anon_sym_PIPE_PIPE] = ACTIONS(7206),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7206),
    [anon_sym_AMP_GT] = ACTIONS(7208),
    [anon_sym_AMP_GT_GT] = ACTIONS(7206),
    [anon_sym_LT_AMP] = ACTIONS(7206),
    [anon_sym_GT_AMP] = ACTIONS(7206),
    [anon_sym_LT_LT] = ACTIONS(7208),
    [anon_sym_LT_LT_DASH] = ACTIONS(7206),
    [anon_sym_LT_LT_LT] = ACTIONS(7206),
    [anon_sym_DOLLAR] = ACTIONS(7208),
    [sym__special_character] = ACTIONS(7206),
    [anon_sym_DQUOTE] = ACTIONS(7206),
    [sym_raw_string] = ACTIONS(7206),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7206),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7206),
    [anon_sym_BQUOTE] = ACTIONS(7206),
    [anon_sym_LT_LPAREN] = ACTIONS(7206),
    [anon_sym_GT_LPAREN] = ACTIONS(7206),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7208),
    [sym_word] = ACTIONS(7208),
    [anon_sym_LF] = ACTIONS(7206),
    [anon_sym_AMP] = ACTIONS(7208),
  },
  [4291] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9993),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4292] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9995),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4293] = {
    [sym__simple_heredoc_body] = ACTIONS(7242),
    [sym__heredoc_body_beginning] = ACTIONS(7242),
    [sym_file_descriptor] = ACTIONS(7242),
    [sym__concat] = ACTIONS(7242),
    [sym_variable_name] = ACTIONS(7242),
    [anon_sym_SEMI] = ACTIONS(7244),
    [anon_sym_fi] = ACTIONS(7244),
    [anon_sym_PIPE] = ACTIONS(7244),
    [anon_sym_SEMI_SEMI] = ACTIONS(7242),
    [anon_sym_PIPE_AMP] = ACTIONS(7242),
    [anon_sym_AMP_AMP] = ACTIONS(7242),
    [anon_sym_PIPE_PIPE] = ACTIONS(7242),
    [anon_sym_LT] = ACTIONS(7244),
    [anon_sym_GT] = ACTIONS(7244),
    [anon_sym_GT_GT] = ACTIONS(7242),
    [anon_sym_AMP_GT] = ACTIONS(7244),
    [anon_sym_AMP_GT_GT] = ACTIONS(7242),
    [anon_sym_LT_AMP] = ACTIONS(7242),
    [anon_sym_GT_AMP] = ACTIONS(7242),
    [anon_sym_LT_LT] = ACTIONS(7244),
    [anon_sym_LT_LT_DASH] = ACTIONS(7242),
    [anon_sym_LT_LT_LT] = ACTIONS(7242),
    [anon_sym_DOLLAR] = ACTIONS(7244),
    [sym__special_character] = ACTIONS(7242),
    [anon_sym_DQUOTE] = ACTIONS(7242),
    [sym_raw_string] = ACTIONS(7242),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7242),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7242),
    [anon_sym_BQUOTE] = ACTIONS(7242),
    [anon_sym_LT_LPAREN] = ACTIONS(7242),
    [anon_sym_GT_LPAREN] = ACTIONS(7242),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7244),
    [sym_word] = ACTIONS(7244),
    [anon_sym_LF] = ACTIONS(7242),
    [anon_sym_AMP] = ACTIONS(7244),
  },
  [4294] = {
    [sym__simple_heredoc_body] = ACTIONS(7198),
    [sym__heredoc_body_beginning] = ACTIONS(7198),
    [sym_file_descriptor] = ACTIONS(7198),
    [sym__concat] = ACTIONS(7198),
    [anon_sym_SEMI] = ACTIONS(7200),
    [anon_sym_fi] = ACTIONS(7200),
    [anon_sym_PIPE] = ACTIONS(7200),
    [anon_sym_SEMI_SEMI] = ACTIONS(7198),
    [anon_sym_PIPE_AMP] = ACTIONS(7198),
    [anon_sym_AMP_AMP] = ACTIONS(7198),
    [anon_sym_PIPE_PIPE] = ACTIONS(7198),
    [anon_sym_LT] = ACTIONS(7200),
    [anon_sym_GT] = ACTIONS(7200),
    [anon_sym_GT_GT] = ACTIONS(7198),
    [anon_sym_AMP_GT] = ACTIONS(7200),
    [anon_sym_AMP_GT_GT] = ACTIONS(7198),
    [anon_sym_LT_AMP] = ACTIONS(7198),
    [anon_sym_GT_AMP] = ACTIONS(7198),
    [anon_sym_LT_LT] = ACTIONS(7200),
    [anon_sym_LT_LT_DASH] = ACTIONS(7198),
    [anon_sym_LT_LT_LT] = ACTIONS(7198),
    [anon_sym_DOLLAR] = ACTIONS(7200),
    [sym__special_character] = ACTIONS(7198),
    [anon_sym_DQUOTE] = ACTIONS(7198),
    [sym_raw_string] = ACTIONS(7198),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7198),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7198),
    [anon_sym_BQUOTE] = ACTIONS(7198),
    [anon_sym_LT_LPAREN] = ACTIONS(7198),
    [anon_sym_GT_LPAREN] = ACTIONS(7198),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7200),
    [sym_word] = ACTIONS(7200),
    [anon_sym_LF] = ACTIONS(7198),
    [anon_sym_AMP] = ACTIONS(7200),
  },
  [4295] = {
    [sym__simple_heredoc_body] = ACTIONS(7202),
    [sym__heredoc_body_beginning] = ACTIONS(7202),
    [sym_file_descriptor] = ACTIONS(7202),
    [sym__concat] = ACTIONS(7202),
    [anon_sym_SEMI] = ACTIONS(7204),
    [anon_sym_fi] = ACTIONS(7204),
    [anon_sym_PIPE] = ACTIONS(7204),
    [anon_sym_SEMI_SEMI] = ACTIONS(7202),
    [anon_sym_PIPE_AMP] = ACTIONS(7202),
    [anon_sym_AMP_AMP] = ACTIONS(7202),
    [anon_sym_PIPE_PIPE] = ACTIONS(7202),
    [anon_sym_LT] = ACTIONS(7204),
    [anon_sym_GT] = ACTIONS(7204),
    [anon_sym_GT_GT] = ACTIONS(7202),
    [anon_sym_AMP_GT] = ACTIONS(7204),
    [anon_sym_AMP_GT_GT] = ACTIONS(7202),
    [anon_sym_LT_AMP] = ACTIONS(7202),
    [anon_sym_GT_AMP] = ACTIONS(7202),
    [anon_sym_LT_LT] = ACTIONS(7204),
    [anon_sym_LT_LT_DASH] = ACTIONS(7202),
    [anon_sym_LT_LT_LT] = ACTIONS(7202),
    [anon_sym_DOLLAR] = ACTIONS(7204),
    [sym__special_character] = ACTIONS(7202),
    [anon_sym_DQUOTE] = ACTIONS(7202),
    [sym_raw_string] = ACTIONS(7202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7202),
    [anon_sym_BQUOTE] = ACTIONS(7202),
    [anon_sym_LT_LPAREN] = ACTIONS(7202),
    [anon_sym_GT_LPAREN] = ACTIONS(7202),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7204),
    [sym_word] = ACTIONS(7204),
    [anon_sym_LF] = ACTIONS(7202),
    [anon_sym_AMP] = ACTIONS(7204),
  },
  [4296] = {
    [sym__simple_heredoc_body] = ACTIONS(7206),
    [sym__heredoc_body_beginning] = ACTIONS(7206),
    [sym_file_descriptor] = ACTIONS(7206),
    [sym__concat] = ACTIONS(7206),
    [anon_sym_SEMI] = ACTIONS(7208),
    [anon_sym_fi] = ACTIONS(7208),
    [anon_sym_PIPE] = ACTIONS(7208),
    [anon_sym_SEMI_SEMI] = ACTIONS(7206),
    [anon_sym_PIPE_AMP] = ACTIONS(7206),
    [anon_sym_AMP_AMP] = ACTIONS(7206),
    [anon_sym_PIPE_PIPE] = ACTIONS(7206),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7206),
    [anon_sym_AMP_GT] = ACTIONS(7208),
    [anon_sym_AMP_GT_GT] = ACTIONS(7206),
    [anon_sym_LT_AMP] = ACTIONS(7206),
    [anon_sym_GT_AMP] = ACTIONS(7206),
    [anon_sym_LT_LT] = ACTIONS(7208),
    [anon_sym_LT_LT_DASH] = ACTIONS(7206),
    [anon_sym_LT_LT_LT] = ACTIONS(7206),
    [anon_sym_DOLLAR] = ACTIONS(7208),
    [sym__special_character] = ACTIONS(7206),
    [anon_sym_DQUOTE] = ACTIONS(7206),
    [sym_raw_string] = ACTIONS(7206),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7206),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7206),
    [anon_sym_BQUOTE] = ACTIONS(7206),
    [anon_sym_LT_LPAREN] = ACTIONS(7206),
    [anon_sym_GT_LPAREN] = ACTIONS(7206),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7208),
    [sym_word] = ACTIONS(7208),
    [anon_sym_LF] = ACTIONS(7206),
    [anon_sym_AMP] = ACTIONS(7208),
  },
  [4297] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9997),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4298] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(9999),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4299] = {
    [sym__simple_heredoc_body] = ACTIONS(7242),
    [sym__heredoc_body_beginning] = ACTIONS(7242),
    [sym_file_descriptor] = ACTIONS(7242),
    [sym__concat] = ACTIONS(7242),
    [anon_sym_SEMI] = ACTIONS(7244),
    [anon_sym_fi] = ACTIONS(7244),
    [anon_sym_PIPE] = ACTIONS(7244),
    [anon_sym_SEMI_SEMI] = ACTIONS(7242),
    [anon_sym_PIPE_AMP] = ACTIONS(7242),
    [anon_sym_AMP_AMP] = ACTIONS(7242),
    [anon_sym_PIPE_PIPE] = ACTIONS(7242),
    [anon_sym_LT] = ACTIONS(7244),
    [anon_sym_GT] = ACTIONS(7244),
    [anon_sym_GT_GT] = ACTIONS(7242),
    [anon_sym_AMP_GT] = ACTIONS(7244),
    [anon_sym_AMP_GT_GT] = ACTIONS(7242),
    [anon_sym_LT_AMP] = ACTIONS(7242),
    [anon_sym_GT_AMP] = ACTIONS(7242),
    [anon_sym_LT_LT] = ACTIONS(7244),
    [anon_sym_LT_LT_DASH] = ACTIONS(7242),
    [anon_sym_LT_LT_LT] = ACTIONS(7242),
    [anon_sym_DOLLAR] = ACTIONS(7244),
    [sym__special_character] = ACTIONS(7242),
    [anon_sym_DQUOTE] = ACTIONS(7242),
    [sym_raw_string] = ACTIONS(7242),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7242),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7242),
    [anon_sym_BQUOTE] = ACTIONS(7242),
    [anon_sym_LT_LPAREN] = ACTIONS(7242),
    [anon_sym_GT_LPAREN] = ACTIONS(7242),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7244),
    [sym_word] = ACTIONS(7244),
    [anon_sym_LF] = ACTIONS(7242),
    [anon_sym_AMP] = ACTIONS(7244),
  },
  [4300] = {
    [sym__simple_heredoc_body] = ACTIONS(8340),
    [sym__heredoc_body_beginning] = ACTIONS(8340),
    [sym_file_descriptor] = ACTIONS(8340),
    [sym__concat] = ACTIONS(8340),
    [anon_sym_SEMI] = ACTIONS(8342),
    [anon_sym_fi] = ACTIONS(8342),
    [anon_sym_PIPE] = ACTIONS(8342),
    [anon_sym_SEMI_SEMI] = ACTIONS(8340),
    [anon_sym_PIPE_AMP] = ACTIONS(8340),
    [anon_sym_AMP_AMP] = ACTIONS(8340),
    [anon_sym_PIPE_PIPE] = ACTIONS(8340),
    [anon_sym_EQ_TILDE] = ACTIONS(8342),
    [anon_sym_EQ_EQ] = ACTIONS(8342),
    [anon_sym_LT] = ACTIONS(8342),
    [anon_sym_GT] = ACTIONS(8342),
    [anon_sym_GT_GT] = ACTIONS(8340),
    [anon_sym_AMP_GT] = ACTIONS(8342),
    [anon_sym_AMP_GT_GT] = ACTIONS(8340),
    [anon_sym_LT_AMP] = ACTIONS(8340),
    [anon_sym_GT_AMP] = ACTIONS(8340),
    [anon_sym_LT_LT] = ACTIONS(8342),
    [anon_sym_LT_LT_DASH] = ACTIONS(8340),
    [anon_sym_LT_LT_LT] = ACTIONS(8340),
    [anon_sym_DOLLAR] = ACTIONS(8342),
    [sym__special_character] = ACTIONS(8340),
    [anon_sym_DQUOTE] = ACTIONS(8340),
    [sym_raw_string] = ACTIONS(8340),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8340),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [anon_sym_LT_LPAREN] = ACTIONS(8340),
    [anon_sym_GT_LPAREN] = ACTIONS(8340),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8342),
    [anon_sym_LF] = ACTIONS(8340),
    [anon_sym_AMP] = ACTIONS(8342),
  },
  [4301] = {
    [sym__simple_heredoc_body] = ACTIONS(8344),
    [sym__heredoc_body_beginning] = ACTIONS(8344),
    [sym_file_descriptor] = ACTIONS(8344),
    [sym__concat] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [anon_sym_fi] = ACTIONS(8346),
    [anon_sym_PIPE] = ACTIONS(8346),
    [anon_sym_SEMI_SEMI] = ACTIONS(8344),
    [anon_sym_PIPE_AMP] = ACTIONS(8344),
    [anon_sym_AMP_AMP] = ACTIONS(8344),
    [anon_sym_PIPE_PIPE] = ACTIONS(8344),
    [anon_sym_EQ_TILDE] = ACTIONS(8346),
    [anon_sym_EQ_EQ] = ACTIONS(8346),
    [anon_sym_LT] = ACTIONS(8346),
    [anon_sym_GT] = ACTIONS(8346),
    [anon_sym_GT_GT] = ACTIONS(8344),
    [anon_sym_AMP_GT] = ACTIONS(8346),
    [anon_sym_AMP_GT_GT] = ACTIONS(8344),
    [anon_sym_LT_AMP] = ACTIONS(8344),
    [anon_sym_GT_AMP] = ACTIONS(8344),
    [anon_sym_LT_LT] = ACTIONS(8346),
    [anon_sym_LT_LT_DASH] = ACTIONS(8344),
    [anon_sym_LT_LT_LT] = ACTIONS(8344),
    [anon_sym_DOLLAR] = ACTIONS(8346),
    [sym__special_character] = ACTIONS(8344),
    [anon_sym_DQUOTE] = ACTIONS(8344),
    [sym_raw_string] = ACTIONS(8344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8344),
    [anon_sym_BQUOTE] = ACTIONS(8344),
    [anon_sym_LT_LPAREN] = ACTIONS(8344),
    [anon_sym_GT_LPAREN] = ACTIONS(8344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8346),
    [anon_sym_LF] = ACTIONS(8344),
    [anon_sym_AMP] = ACTIONS(8346),
  },
  [4302] = {
    [sym__simple_heredoc_body] = ACTIONS(8340),
    [sym__heredoc_body_beginning] = ACTIONS(8340),
    [sym_file_descriptor] = ACTIONS(8340),
    [sym__concat] = ACTIONS(8340),
    [sym_variable_name] = ACTIONS(8340),
    [anon_sym_SEMI] = ACTIONS(8342),
    [anon_sym_fi] = ACTIONS(8342),
    [anon_sym_elif] = ACTIONS(8342),
    [anon_sym_else] = ACTIONS(8342),
    [anon_sym_PIPE] = ACTIONS(8342),
    [anon_sym_SEMI_SEMI] = ACTIONS(8340),
    [anon_sym_PIPE_AMP] = ACTIONS(8340),
    [anon_sym_AMP_AMP] = ACTIONS(8340),
    [anon_sym_PIPE_PIPE] = ACTIONS(8340),
    [anon_sym_LT] = ACTIONS(8342),
    [anon_sym_GT] = ACTIONS(8342),
    [anon_sym_GT_GT] = ACTIONS(8340),
    [anon_sym_AMP_GT] = ACTIONS(8342),
    [anon_sym_AMP_GT_GT] = ACTIONS(8340),
    [anon_sym_LT_AMP] = ACTIONS(8340),
    [anon_sym_GT_AMP] = ACTIONS(8340),
    [anon_sym_LT_LT] = ACTIONS(8342),
    [anon_sym_LT_LT_DASH] = ACTIONS(8340),
    [anon_sym_LT_LT_LT] = ACTIONS(8340),
    [anon_sym_DOLLAR] = ACTIONS(8342),
    [sym__special_character] = ACTIONS(8340),
    [anon_sym_DQUOTE] = ACTIONS(8340),
    [sym_raw_string] = ACTIONS(8340),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8340),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [anon_sym_LT_LPAREN] = ACTIONS(8340),
    [anon_sym_GT_LPAREN] = ACTIONS(8340),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8342),
    [sym_word] = ACTIONS(8342),
    [anon_sym_LF] = ACTIONS(8340),
    [anon_sym_AMP] = ACTIONS(8342),
  },
  [4303] = {
    [sym__simple_heredoc_body] = ACTIONS(8344),
    [sym__heredoc_body_beginning] = ACTIONS(8344),
    [sym_file_descriptor] = ACTIONS(8344),
    [sym__concat] = ACTIONS(8344),
    [sym_variable_name] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [anon_sym_fi] = ACTIONS(8346),
    [anon_sym_elif] = ACTIONS(8346),
    [anon_sym_else] = ACTIONS(8346),
    [anon_sym_PIPE] = ACTIONS(8346),
    [anon_sym_SEMI_SEMI] = ACTIONS(8344),
    [anon_sym_PIPE_AMP] = ACTIONS(8344),
    [anon_sym_AMP_AMP] = ACTIONS(8344),
    [anon_sym_PIPE_PIPE] = ACTIONS(8344),
    [anon_sym_LT] = ACTIONS(8346),
    [anon_sym_GT] = ACTIONS(8346),
    [anon_sym_GT_GT] = ACTIONS(8344),
    [anon_sym_AMP_GT] = ACTIONS(8346),
    [anon_sym_AMP_GT_GT] = ACTIONS(8344),
    [anon_sym_LT_AMP] = ACTIONS(8344),
    [anon_sym_GT_AMP] = ACTIONS(8344),
    [anon_sym_LT_LT] = ACTIONS(8346),
    [anon_sym_LT_LT_DASH] = ACTIONS(8344),
    [anon_sym_LT_LT_LT] = ACTIONS(8344),
    [anon_sym_DOLLAR] = ACTIONS(8346),
    [sym__special_character] = ACTIONS(8344),
    [anon_sym_DQUOTE] = ACTIONS(8344),
    [sym_raw_string] = ACTIONS(8344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8344),
    [anon_sym_BQUOTE] = ACTIONS(8344),
    [anon_sym_LT_LPAREN] = ACTIONS(8344),
    [anon_sym_GT_LPAREN] = ACTIONS(8344),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8346),
    [sym_word] = ACTIONS(8346),
    [anon_sym_LF] = ACTIONS(8344),
    [anon_sym_AMP] = ACTIONS(8346),
  },
  [4304] = {
    [sym__simple_heredoc_body] = ACTIONS(8340),
    [sym__heredoc_body_beginning] = ACTIONS(8340),
    [sym_file_descriptor] = ACTIONS(8340),
    [sym__concat] = ACTIONS(8340),
    [anon_sym_SEMI] = ACTIONS(8342),
    [anon_sym_fi] = ACTIONS(8342),
    [anon_sym_elif] = ACTIONS(8342),
    [anon_sym_else] = ACTIONS(8342),
    [anon_sym_PIPE] = ACTIONS(8342),
    [anon_sym_SEMI_SEMI] = ACTIONS(8340),
    [anon_sym_PIPE_AMP] = ACTIONS(8340),
    [anon_sym_AMP_AMP] = ACTIONS(8340),
    [anon_sym_PIPE_PIPE] = ACTIONS(8340),
    [anon_sym_LT] = ACTIONS(8342),
    [anon_sym_GT] = ACTIONS(8342),
    [anon_sym_GT_GT] = ACTIONS(8340),
    [anon_sym_AMP_GT] = ACTIONS(8342),
    [anon_sym_AMP_GT_GT] = ACTIONS(8340),
    [anon_sym_LT_AMP] = ACTIONS(8340),
    [anon_sym_GT_AMP] = ACTIONS(8340),
    [anon_sym_LT_LT] = ACTIONS(8342),
    [anon_sym_LT_LT_DASH] = ACTIONS(8340),
    [anon_sym_LT_LT_LT] = ACTIONS(8340),
    [anon_sym_DOLLAR] = ACTIONS(8342),
    [sym__special_character] = ACTIONS(8340),
    [anon_sym_DQUOTE] = ACTIONS(8340),
    [sym_raw_string] = ACTIONS(8340),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8340),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [anon_sym_LT_LPAREN] = ACTIONS(8340),
    [anon_sym_GT_LPAREN] = ACTIONS(8340),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8342),
    [sym_word] = ACTIONS(8342),
    [anon_sym_LF] = ACTIONS(8340),
    [anon_sym_AMP] = ACTIONS(8342),
  },
  [4305] = {
    [sym__simple_heredoc_body] = ACTIONS(8344),
    [sym__heredoc_body_beginning] = ACTIONS(8344),
    [sym_file_descriptor] = ACTIONS(8344),
    [sym__concat] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [anon_sym_fi] = ACTIONS(8346),
    [anon_sym_elif] = ACTIONS(8346),
    [anon_sym_else] = ACTIONS(8346),
    [anon_sym_PIPE] = ACTIONS(8346),
    [anon_sym_SEMI_SEMI] = ACTIONS(8344),
    [anon_sym_PIPE_AMP] = ACTIONS(8344),
    [anon_sym_AMP_AMP] = ACTIONS(8344),
    [anon_sym_PIPE_PIPE] = ACTIONS(8344),
    [anon_sym_LT] = ACTIONS(8346),
    [anon_sym_GT] = ACTIONS(8346),
    [anon_sym_GT_GT] = ACTIONS(8344),
    [anon_sym_AMP_GT] = ACTIONS(8346),
    [anon_sym_AMP_GT_GT] = ACTIONS(8344),
    [anon_sym_LT_AMP] = ACTIONS(8344),
    [anon_sym_GT_AMP] = ACTIONS(8344),
    [anon_sym_LT_LT] = ACTIONS(8346),
    [anon_sym_LT_LT_DASH] = ACTIONS(8344),
    [anon_sym_LT_LT_LT] = ACTIONS(8344),
    [anon_sym_DOLLAR] = ACTIONS(8346),
    [sym__special_character] = ACTIONS(8344),
    [anon_sym_DQUOTE] = ACTIONS(8344),
    [sym_raw_string] = ACTIONS(8344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8344),
    [anon_sym_BQUOTE] = ACTIONS(8344),
    [anon_sym_LT_LPAREN] = ACTIONS(8344),
    [anon_sym_GT_LPAREN] = ACTIONS(8344),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8346),
    [sym_word] = ACTIONS(8346),
    [anon_sym_LF] = ACTIONS(8344),
    [anon_sym_AMP] = ACTIONS(8346),
  },
  [4306] = {
    [sym__simple_heredoc_body] = ACTIONS(4449),
    [sym__heredoc_body_beginning] = ACTIONS(4449),
    [sym_file_descriptor] = ACTIONS(4449),
    [sym_variable_name] = ACTIONS(4449),
    [anon_sym_SEMI] = ACTIONS(4451),
    [anon_sym_esac] = ACTIONS(4451),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_SEMI_SEMI] = ACTIONS(4449),
    [anon_sym_PIPE_AMP] = ACTIONS(4449),
    [anon_sym_AMP_AMP] = ACTIONS(4449),
    [anon_sym_PIPE_PIPE] = ACTIONS(4449),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_GT_GT] = ACTIONS(4449),
    [anon_sym_AMP_GT] = ACTIONS(4451),
    [anon_sym_AMP_GT_GT] = ACTIONS(4449),
    [anon_sym_LT_AMP] = ACTIONS(4449),
    [anon_sym_GT_AMP] = ACTIONS(4449),
    [anon_sym_LT_LT] = ACTIONS(4451),
    [anon_sym_LT_LT_DASH] = ACTIONS(4449),
    [anon_sym_LT_LT_LT] = ACTIONS(4449),
    [anon_sym_DOLLAR] = ACTIONS(4451),
    [sym__special_character] = ACTIONS(4449),
    [anon_sym_DQUOTE] = ACTIONS(4449),
    [sym_raw_string] = ACTIONS(4449),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4449),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4449),
    [anon_sym_BQUOTE] = ACTIONS(4449),
    [anon_sym_LT_LPAREN] = ACTIONS(4449),
    [anon_sym_GT_LPAREN] = ACTIONS(4449),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4451),
    [anon_sym_LF] = ACTIONS(4449),
    [anon_sym_AMP] = ACTIONS(4451),
  },
  [4307] = {
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(2362),
    [sym_variable_name] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_esac] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [4308] = {
    [sym_string] = STATE(4307),
    [sym_simple_expansion] = STATE(4307),
    [sym_string_expansion] = STATE(4307),
    [sym_expansion] = STATE(4307),
    [sym_command_substitution] = STATE(4307),
    [sym_process_substitution] = STATE(4307),
    [anon_sym_DOLLAR] = ACTIONS(10001),
    [sym__special_character] = ACTIONS(9814),
    [anon_sym_DQUOTE] = ACTIONS(8880),
    [sym_raw_string] = ACTIONS(9814),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8884),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8886),
    [anon_sym_BQUOTE] = ACTIONS(8888),
    [anon_sym_LT_LPAREN] = ACTIONS(8890),
    [anon_sym_GT_LPAREN] = ACTIONS(8890),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9814),
  },
  [4309] = {
    [aux_sym_concatenation_repeat1] = STATE(4309),
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(10003),
    [sym_variable_name] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_esac] = ACTIONS(2364),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [sym_raw_string] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [anon_sym_LT_LPAREN] = ACTIONS(2362),
    [anon_sym_GT_LPAREN] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2364),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [4310] = {
    [sym__simple_heredoc_body] = ACTIONS(2371),
    [sym__heredoc_body_beginning] = ACTIONS(2371),
    [sym_file_descriptor] = ACTIONS(2371),
    [sym__concat] = ACTIONS(2371),
    [sym_variable_name] = ACTIONS(2371),
    [anon_sym_SEMI] = ACTIONS(2373),
    [anon_sym_esac] = ACTIONS(2373),
    [anon_sym_PIPE] = ACTIONS(2373),
    [anon_sym_SEMI_SEMI] = ACTIONS(2371),
    [anon_sym_PIPE_AMP] = ACTIONS(2371),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_PIPE_PIPE] = ACTIONS(2371),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_GT_GT] = ACTIONS(2371),
    [anon_sym_AMP_GT] = ACTIONS(2373),
    [anon_sym_AMP_GT_GT] = ACTIONS(2371),
    [anon_sym_LT_AMP] = ACTIONS(2371),
    [anon_sym_GT_AMP] = ACTIONS(2371),
    [anon_sym_LT_LT] = ACTIONS(2373),
    [anon_sym_LT_LT_DASH] = ACTIONS(2371),
    [anon_sym_LT_LT_LT] = ACTIONS(2371),
    [anon_sym_DOLLAR] = ACTIONS(2373),
    [sym__special_character] = ACTIONS(2371),
    [anon_sym_DQUOTE] = ACTIONS(2371),
    [sym_raw_string] = ACTIONS(2371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2371),
    [anon_sym_BQUOTE] = ACTIONS(2371),
    [anon_sym_LT_LPAREN] = ACTIONS(2371),
    [anon_sym_GT_LPAREN] = ACTIONS(2371),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2373),
    [anon_sym_LF] = ACTIONS(2371),
    [anon_sym_AMP] = ACTIONS(2373),
  },
  [4311] = {
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(10006),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_POUND] = ACTIONS(1077),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_0] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(1085),
  },
  [4312] = {
    [sym_concatenation] = STATE(4396),
    [sym_string] = STATE(4395),
    [sym_simple_expansion] = STATE(4395),
    [sym_string_expansion] = STATE(4395),
    [sym_expansion] = STATE(4395),
    [sym_command_substitution] = STATE(4395),
    [sym_process_substitution] = STATE(4395),
    [aux_sym__literal_repeat1] = STATE(4397),
    [anon_sym_RBRACE] = ACTIONS(10008),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(10010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(10010),
  },
  [4313] = {
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(10012),
    [sym_comment] = ACTIONS(57),
  },
  [4314] = {
    [sym_concatenation] = STATE(4401),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4401),
    [anon_sym_RBRACE] = ACTIONS(10014),
    [anon_sym_EQ] = ACTIONS(10016),
    [anon_sym_DASH] = ACTIONS(10016),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(10018),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(10020),
    [anon_sym_COLON] = ACTIONS(10016),
    [anon_sym_COLON_QMARK] = ACTIONS(10016),
    [anon_sym_COLON_DASH] = ACTIONS(10016),
    [anon_sym_PERCENT] = ACTIONS(10016),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4315] = {
    [sym_concatenation] = STATE(4403),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4403),
    [anon_sym_RBRACE] = ACTIONS(10008),
    [anon_sym_EQ] = ACTIONS(10022),
    [anon_sym_DASH] = ACTIONS(10022),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(10024),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(10026),
    [anon_sym_COLON] = ACTIONS(10022),
    [anon_sym_COLON_QMARK] = ACTIONS(10022),
    [anon_sym_COLON_DASH] = ACTIONS(10022),
    [anon_sym_PERCENT] = ACTIONS(10022),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4316] = {
    [sym__simple_heredoc_body] = ACTIONS(2462),
    [sym__heredoc_body_beginning] = ACTIONS(2462),
    [sym_file_descriptor] = ACTIONS(2462),
    [sym__concat] = ACTIONS(2462),
    [sym_variable_name] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_esac] = ACTIONS(2464),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_SEMI_SEMI] = ACTIONS(2462),
    [anon_sym_PIPE_AMP] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_GT_GT] = ACTIONS(2462),
    [anon_sym_AMP_GT] = ACTIONS(2464),
    [anon_sym_AMP_GT_GT] = ACTIONS(2462),
    [anon_sym_LT_AMP] = ACTIONS(2462),
    [anon_sym_GT_AMP] = ACTIONS(2462),
    [anon_sym_LT_LT] = ACTIONS(2464),
    [anon_sym_LT_LT_DASH] = ACTIONS(2462),
    [anon_sym_LT_LT_LT] = ACTIONS(2462),
    [anon_sym_DOLLAR] = ACTIONS(2464),
    [sym__special_character] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [sym_raw_string] = ACTIONS(2462),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2462),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2462),
    [anon_sym_BQUOTE] = ACTIONS(2462),
    [anon_sym_LT_LPAREN] = ACTIONS(2462),
    [anon_sym_GT_LPAREN] = ACTIONS(2462),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2464),
    [anon_sym_LF] = ACTIONS(2462),
    [anon_sym_AMP] = ACTIONS(2464),
  },
  [4317] = {
    [sym_concatenation] = STATE(4406),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4406),
    [sym_regex] = ACTIONS(10028),
    [anon_sym_RBRACE] = ACTIONS(10030),
    [anon_sym_EQ] = ACTIONS(10032),
    [anon_sym_DASH] = ACTIONS(10032),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(10034),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(10032),
    [anon_sym_COLON_QMARK] = ACTIONS(10032),
    [anon_sym_COLON_DASH] = ACTIONS(10032),
    [anon_sym_PERCENT] = ACTIONS(10032),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4318] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(10030),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4319] = {
    [sym__simple_heredoc_body] = ACTIONS(2512),
    [sym__heredoc_body_beginning] = ACTIONS(2512),
    [sym_file_descriptor] = ACTIONS(2512),
    [sym__concat] = ACTIONS(2512),
    [sym_variable_name] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2514),
    [anon_sym_esac] = ACTIONS(2514),
    [anon_sym_PIPE] = ACTIONS(2514),
    [anon_sym_SEMI_SEMI] = ACTIONS(2512),
    [anon_sym_PIPE_AMP] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE_PIPE] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2514),
    [anon_sym_GT] = ACTIONS(2514),
    [anon_sym_GT_GT] = ACTIONS(2512),
    [anon_sym_AMP_GT] = ACTIONS(2514),
    [anon_sym_AMP_GT_GT] = ACTIONS(2512),
    [anon_sym_LT_AMP] = ACTIONS(2512),
    [anon_sym_GT_AMP] = ACTIONS(2512),
    [anon_sym_LT_LT] = ACTIONS(2514),
    [anon_sym_LT_LT_DASH] = ACTIONS(2512),
    [anon_sym_LT_LT_LT] = ACTIONS(2512),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [sym__special_character] = ACTIONS(2512),
    [anon_sym_DQUOTE] = ACTIONS(2512),
    [sym_raw_string] = ACTIONS(2512),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2512),
    [anon_sym_BQUOTE] = ACTIONS(2512),
    [anon_sym_LT_LPAREN] = ACTIONS(2512),
    [anon_sym_GT_LPAREN] = ACTIONS(2512),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2514),
    [anon_sym_LF] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2514),
  },
  [4320] = {
    [sym_concatenation] = STATE(4403),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4403),
    [sym_regex] = ACTIONS(10036),
    [anon_sym_RBRACE] = ACTIONS(10008),
    [anon_sym_EQ] = ACTIONS(10022),
    [anon_sym_DASH] = ACTIONS(10022),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(10024),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(10022),
    [anon_sym_COLON_QMARK] = ACTIONS(10022),
    [anon_sym_COLON_DASH] = ACTIONS(10022),
    [anon_sym_PERCENT] = ACTIONS(10022),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4321] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(10008),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4322] = {
    [sym__simple_heredoc_body] = ACTIONS(2520),
    [sym__heredoc_body_beginning] = ACTIONS(2520),
    [sym_file_descriptor] = ACTIONS(2520),
    [sym__concat] = ACTIONS(2520),
    [sym_variable_name] = ACTIONS(2520),
    [anon_sym_SEMI] = ACTIONS(2522),
    [anon_sym_esac] = ACTIONS(2522),
    [anon_sym_PIPE] = ACTIONS(2522),
    [anon_sym_SEMI_SEMI] = ACTIONS(2520),
    [anon_sym_PIPE_AMP] = ACTIONS(2520),
    [anon_sym_AMP_AMP] = ACTIONS(2520),
    [anon_sym_PIPE_PIPE] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(2522),
    [anon_sym_GT] = ACTIONS(2522),
    [anon_sym_GT_GT] = ACTIONS(2520),
    [anon_sym_AMP_GT] = ACTIONS(2522),
    [anon_sym_AMP_GT_GT] = ACTIONS(2520),
    [anon_sym_LT_AMP] = ACTIONS(2520),
    [anon_sym_GT_AMP] = ACTIONS(2520),
    [anon_sym_LT_LT] = ACTIONS(2522),
    [anon_sym_LT_LT_DASH] = ACTIONS(2520),
    [anon_sym_LT_LT_LT] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(2522),
    [sym__special_character] = ACTIONS(2520),
    [anon_sym_DQUOTE] = ACTIONS(2520),
    [sym_raw_string] = ACTIONS(2520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2520),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2520),
    [anon_sym_BQUOTE] = ACTIONS(2520),
    [anon_sym_LT_LPAREN] = ACTIONS(2520),
    [anon_sym_GT_LPAREN] = ACTIONS(2520),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2522),
    [anon_sym_LF] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2522),
  },
  [4323] = {
    [sym__simple_heredoc_body] = ACTIONS(2554),
    [sym__heredoc_body_beginning] = ACTIONS(2554),
    [sym_file_descriptor] = ACTIONS(2554),
    [sym__concat] = ACTIONS(2554),
    [sym_variable_name] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(2556),
    [anon_sym_esac] = ACTIONS(2556),
    [anon_sym_PIPE] = ACTIONS(2556),
    [anon_sym_SEMI_SEMI] = ACTIONS(2554),
    [anon_sym_PIPE_AMP] = ACTIONS(2554),
    [anon_sym_AMP_AMP] = ACTIONS(2554),
    [anon_sym_PIPE_PIPE] = ACTIONS(2554),
    [anon_sym_LT] = ACTIONS(2556),
    [anon_sym_GT] = ACTIONS(2556),
    [anon_sym_GT_GT] = ACTIONS(2554),
    [anon_sym_AMP_GT] = ACTIONS(2556),
    [anon_sym_AMP_GT_GT] = ACTIONS(2554),
    [anon_sym_LT_AMP] = ACTIONS(2554),
    [anon_sym_GT_AMP] = ACTIONS(2554),
    [anon_sym_LT_LT] = ACTIONS(2556),
    [anon_sym_LT_LT_DASH] = ACTIONS(2554),
    [anon_sym_LT_LT_LT] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2556),
    [sym__special_character] = ACTIONS(2554),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2554),
    [anon_sym_BQUOTE] = ACTIONS(2554),
    [anon_sym_LT_LPAREN] = ACTIONS(2554),
    [anon_sym_GT_LPAREN] = ACTIONS(2554),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2556),
    [anon_sym_LF] = ACTIONS(2554),
    [anon_sym_AMP] = ACTIONS(2556),
  },
  [4324] = {
    [sym__simple_heredoc_body] = ACTIONS(2719),
    [sym__heredoc_body_beginning] = ACTIONS(2719),
    [sym_file_descriptor] = ACTIONS(2719),
    [sym_variable_name] = ACTIONS(2719),
    [anon_sym_SEMI] = ACTIONS(2721),
    [anon_sym_esac] = ACTIONS(2721),
    [anon_sym_PIPE] = ACTIONS(2721),
    [anon_sym_SEMI_SEMI] = ACTIONS(2719),
    [anon_sym_PIPE_AMP] = ACTIONS(2719),
    [anon_sym_AMP_AMP] = ACTIONS(2719),
    [anon_sym_PIPE_PIPE] = ACTIONS(2719),
    [anon_sym_LT] = ACTIONS(2721),
    [anon_sym_GT] = ACTIONS(2721),
    [anon_sym_GT_GT] = ACTIONS(2719),
    [anon_sym_AMP_GT] = ACTIONS(2721),
    [anon_sym_AMP_GT_GT] = ACTIONS(2719),
    [anon_sym_LT_AMP] = ACTIONS(2719),
    [anon_sym_GT_AMP] = ACTIONS(2719),
    [anon_sym_LT_LT] = ACTIONS(2721),
    [anon_sym_LT_LT_DASH] = ACTIONS(2719),
    [anon_sym_LT_LT_LT] = ACTIONS(2719),
    [anon_sym_DOLLAR] = ACTIONS(2721),
    [sym__special_character] = ACTIONS(2719),
    [anon_sym_DQUOTE] = ACTIONS(2719),
    [sym_raw_string] = ACTIONS(2719),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2719),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2719),
    [anon_sym_BQUOTE] = ACTIONS(2719),
    [anon_sym_LT_LPAREN] = ACTIONS(2719),
    [anon_sym_GT_LPAREN] = ACTIONS(2719),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2721),
    [sym_word] = ACTIONS(2721),
    [anon_sym_LF] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2721),
  },
  [4325] = {
    [sym_concatenation] = STATE(1368),
    [sym_string] = STATE(730),
    [sym_simple_expansion] = STATE(730),
    [sym_string_expansion] = STATE(730),
    [sym_expansion] = STATE(730),
    [sym_command_substitution] = STATE(730),
    [sym_process_substitution] = STATE(730),
    [aux_sym_for_statement_repeat1] = STATE(1368),
    [aux_sym__literal_repeat1] = STATE(736),
    [anon_sym_RPAREN] = ACTIONS(10038),
    [anon_sym_DOLLAR] = ACTIONS(1406),
    [sym__special_character] = ACTIONS(1408),
    [anon_sym_DQUOTE] = ACTIONS(1410),
    [sym_raw_string] = ACTIONS(1412),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1414),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1416),
    [anon_sym_BQUOTE] = ACTIONS(1418),
    [anon_sym_LT_LPAREN] = ACTIONS(1420),
    [anon_sym_GT_LPAREN] = ACTIONS(1420),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1412),
  },
  [4326] = {
    [sym_string] = STATE(3931),
    [sym__simple_heredoc_body] = ACTIONS(4071),
    [sym__heredoc_body_beginning] = ACTIONS(4071),
    [sym_file_descriptor] = ACTIONS(4071),
    [sym_variable_name] = ACTIONS(4071),
    [anon_sym_SEMI] = ACTIONS(4073),
    [anon_sym_esac] = ACTIONS(4073),
    [anon_sym_PIPE] = ACTIONS(4073),
    [anon_sym_SEMI_SEMI] = ACTIONS(4071),
    [anon_sym_PIPE_AMP] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_PIPE_PIPE] = ACTIONS(4071),
    [anon_sym_LT] = ACTIONS(4073),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_GT_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT] = ACTIONS(4073),
    [anon_sym_AMP_GT_GT] = ACTIONS(4071),
    [anon_sym_LT_AMP] = ACTIONS(4071),
    [anon_sym_GT_AMP] = ACTIONS(4071),
    [anon_sym_LT_LT] = ACTIONS(4073),
    [anon_sym_LT_LT_DASH] = ACTIONS(4071),
    [anon_sym_LT_LT_LT] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(10040),
    [anon_sym_DOLLAR] = ACTIONS(10040),
    [sym__special_character] = ACTIONS(4071),
    [anon_sym_DQUOTE] = ACTIONS(8091),
    [sym_raw_string] = ACTIONS(8896),
    [anon_sym_POUND] = ACTIONS(8894),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4071),
    [anon_sym_BQUOTE] = ACTIONS(4071),
    [anon_sym_LT_LPAREN] = ACTIONS(4071),
    [anon_sym_GT_LPAREN] = ACTIONS(4071),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8898),
    [anon_sym_STAR] = ACTIONS(8898),
    [anon_sym_AT] = ACTIONS(8898),
    [anon_sym_QMARK] = ACTIONS(8898),
    [anon_sym_0] = ACTIONS(8898),
    [anon_sym__] = ACTIONS(8898),
    [sym_word] = ACTIONS(4073),
    [anon_sym_LF] = ACTIONS(4071),
    [anon_sym_AMP] = ACTIONS(4073),
  },
  [4327] = {
    [sym__simple_heredoc_body] = ACTIONS(4111),
    [sym__heredoc_body_beginning] = ACTIONS(4111),
    [sym_file_descriptor] = ACTIONS(4111),
    [sym__concat] = ACTIONS(4111),
    [sym_variable_name] = ACTIONS(4111),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_esac] = ACTIONS(4113),
    [anon_sym_PIPE] = ACTIONS(4113),
    [anon_sym_SEMI_SEMI] = ACTIONS(4111),
    [anon_sym_PIPE_AMP] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_LT] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4113),
    [anon_sym_GT_GT] = ACTIONS(4111),
    [anon_sym_AMP_GT] = ACTIONS(4113),
    [anon_sym_AMP_GT_GT] = ACTIONS(4111),
    [anon_sym_LT_AMP] = ACTIONS(4111),
    [anon_sym_GT_AMP] = ACTIONS(4111),
    [anon_sym_LT_LT] = ACTIONS(4113),
    [anon_sym_LT_LT_DASH] = ACTIONS(4111),
    [anon_sym_LT_LT_LT] = ACTIONS(4111),
    [anon_sym_DOLLAR] = ACTIONS(4113),
    [sym__special_character] = ACTIONS(4111),
    [anon_sym_DQUOTE] = ACTIONS(4111),
    [sym_raw_string] = ACTIONS(4111),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4111),
    [anon_sym_BQUOTE] = ACTIONS(4111),
    [anon_sym_LT_LPAREN] = ACTIONS(4111),
    [anon_sym_GT_LPAREN] = ACTIONS(4111),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4113),
    [sym_word] = ACTIONS(4113),
    [anon_sym_LF] = ACTIONS(4111),
    [anon_sym_AMP] = ACTIONS(4113),
  },
  [4328] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [sym_variable_name] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_esac] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym__special_character] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4127),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [4329] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(10042),
    [sym_comment] = ACTIONS(57),
  },
  [4330] = {
    [anon_sym_RBRACE] = ACTIONS(10042),
    [sym_comment] = ACTIONS(57),
  },
  [4331] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(10044),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [4332] = {
    [sym_concatenation] = STATE(4412),
    [sym_string] = STATE(4411),
    [sym_simple_expansion] = STATE(4411),
    [sym_string_expansion] = STATE(4411),
    [sym_expansion] = STATE(4411),
    [sym_command_substitution] = STATE(4411),
    [sym_process_substitution] = STATE(4411),
    [aux_sym__literal_repeat1] = STATE(4413),
    [anon_sym_RBRACE] = ACTIONS(10042),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(10046),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(10046),
  },
  [4333] = {
    [sym__simple_heredoc_body] = ACTIONS(4161),
    [sym__heredoc_body_beginning] = ACTIONS(4161),
    [sym_file_descriptor] = ACTIONS(4161),
    [sym__concat] = ACTIONS(4161),
    [sym_variable_name] = ACTIONS(4161),
    [anon_sym_SEMI] = ACTIONS(4163),
    [anon_sym_esac] = ACTIONS(4163),
    [anon_sym_PIPE] = ACTIONS(4163),
    [anon_sym_SEMI_SEMI] = ACTIONS(4161),
    [anon_sym_PIPE_AMP] = ACTIONS(4161),
    [anon_sym_AMP_AMP] = ACTIONS(4161),
    [anon_sym_PIPE_PIPE] = ACTIONS(4161),
    [anon_sym_LT] = ACTIONS(4163),
    [anon_sym_GT] = ACTIONS(4163),
    [anon_sym_GT_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT] = ACTIONS(4163),
    [anon_sym_AMP_GT_GT] = ACTIONS(4161),
    [anon_sym_LT_AMP] = ACTIONS(4161),
    [anon_sym_GT_AMP] = ACTIONS(4161),
    [anon_sym_LT_LT] = ACTIONS(4163),
    [anon_sym_LT_LT_DASH] = ACTIONS(4161),
    [anon_sym_LT_LT_LT] = ACTIONS(4161),
    [anon_sym_DOLLAR] = ACTIONS(4163),
    [sym__special_character] = ACTIONS(4161),
    [anon_sym_DQUOTE] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4161),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4161),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4161),
    [anon_sym_BQUOTE] = ACTIONS(4161),
    [anon_sym_LT_LPAREN] = ACTIONS(4161),
    [anon_sym_GT_LPAREN] = ACTIONS(4161),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4163),
    [sym_word] = ACTIONS(4163),
    [anon_sym_LF] = ACTIONS(4161),
    [anon_sym_AMP] = ACTIONS(4163),
  },
  [4334] = {
    [sym_concatenation] = STATE(4416),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4416),
    [sym_regex] = ACTIONS(10048),
    [anon_sym_RBRACE] = ACTIONS(10050),
    [anon_sym_EQ] = ACTIONS(10052),
    [anon_sym_DASH] = ACTIONS(10052),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(10054),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(10052),
    [anon_sym_COLON_QMARK] = ACTIONS(10052),
    [anon_sym_COLON_DASH] = ACTIONS(10052),
    [anon_sym_PERCENT] = ACTIONS(10052),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4335] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(10050),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4336] = {
    [sym_concatenation] = STATE(4418),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4418),
    [sym_regex] = ACTIONS(10056),
    [anon_sym_RBRACE] = ACTIONS(10042),
    [anon_sym_EQ] = ACTIONS(10058),
    [anon_sym_DASH] = ACTIONS(10058),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(10060),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(10058),
    [anon_sym_COLON_QMARK] = ACTIONS(10058),
    [anon_sym_COLON_DASH] = ACTIONS(10058),
    [anon_sym_PERCENT] = ACTIONS(10058),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4337] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(10042),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4338] = {
    [sym_concatenation] = STATE(4420),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4420),
    [anon_sym_RBRACE] = ACTIONS(10062),
    [anon_sym_EQ] = ACTIONS(10064),
    [anon_sym_DASH] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(10066),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(10064),
    [anon_sym_COLON_QMARK] = ACTIONS(10064),
    [anon_sym_COLON_DASH] = ACTIONS(10064),
    [anon_sym_PERCENT] = ACTIONS(10064),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4339] = {
    [sym__simple_heredoc_body] = ACTIONS(4219),
    [sym__heredoc_body_beginning] = ACTIONS(4219),
    [sym_file_descriptor] = ACTIONS(4219),
    [sym__concat] = ACTIONS(4219),
    [sym_variable_name] = ACTIONS(4219),
    [anon_sym_SEMI] = ACTIONS(4221),
    [anon_sym_esac] = ACTIONS(4221),
    [anon_sym_PIPE] = ACTIONS(4221),
    [anon_sym_SEMI_SEMI] = ACTIONS(4219),
    [anon_sym_PIPE_AMP] = ACTIONS(4219),
    [anon_sym_AMP_AMP] = ACTIONS(4219),
    [anon_sym_PIPE_PIPE] = ACTIONS(4219),
    [anon_sym_LT] = ACTIONS(4221),
    [anon_sym_GT] = ACTIONS(4221),
    [anon_sym_GT_GT] = ACTIONS(4219),
    [anon_sym_AMP_GT] = ACTIONS(4221),
    [anon_sym_AMP_GT_GT] = ACTIONS(4219),
    [anon_sym_LT_AMP] = ACTIONS(4219),
    [anon_sym_GT_AMP] = ACTIONS(4219),
    [anon_sym_LT_LT] = ACTIONS(4221),
    [anon_sym_LT_LT_DASH] = ACTIONS(4219),
    [anon_sym_LT_LT_LT] = ACTIONS(4219),
    [anon_sym_DOLLAR] = ACTIONS(4221),
    [sym__special_character] = ACTIONS(4219),
    [anon_sym_DQUOTE] = ACTIONS(4219),
    [sym_raw_string] = ACTIONS(4219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4219),
    [anon_sym_BQUOTE] = ACTIONS(4219),
    [anon_sym_LT_LPAREN] = ACTIONS(4219),
    [anon_sym_GT_LPAREN] = ACTIONS(4219),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4221),
    [sym_word] = ACTIONS(4221),
    [anon_sym_LF] = ACTIONS(4219),
    [anon_sym_AMP] = ACTIONS(4221),
  },
  [4340] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(10062),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4341] = {
    [sym_concatenation] = STATE(4418),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4418),
    [anon_sym_RBRACE] = ACTIONS(10042),
    [anon_sym_EQ] = ACTIONS(10058),
    [anon_sym_DASH] = ACTIONS(10058),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(10060),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(10058),
    [anon_sym_COLON_QMARK] = ACTIONS(10058),
    [anon_sym_COLON_DASH] = ACTIONS(10058),
    [anon_sym_PERCENT] = ACTIONS(10058),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4342] = {
    [sym_string] = STATE(3950),
    [sym__simple_heredoc_body] = ACTIONS(4071),
    [sym__heredoc_body_beginning] = ACTIONS(4071),
    [sym_file_descriptor] = ACTIONS(4071),
    [anon_sym_SEMI] = ACTIONS(4073),
    [anon_sym_esac] = ACTIONS(4073),
    [anon_sym_PIPE] = ACTIONS(4073),
    [anon_sym_SEMI_SEMI] = ACTIONS(4071),
    [anon_sym_PIPE_AMP] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_PIPE_PIPE] = ACTIONS(4071),
    [anon_sym_LT] = ACTIONS(4073),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_GT_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT] = ACTIONS(4073),
    [anon_sym_AMP_GT_GT] = ACTIONS(4071),
    [anon_sym_LT_AMP] = ACTIONS(4071),
    [anon_sym_GT_AMP] = ACTIONS(4071),
    [anon_sym_LT_LT] = ACTIONS(4073),
    [anon_sym_LT_LT_DASH] = ACTIONS(4071),
    [anon_sym_LT_LT_LT] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(10068),
    [anon_sym_DOLLAR] = ACTIONS(10068),
    [sym__special_character] = ACTIONS(4071),
    [anon_sym_DQUOTE] = ACTIONS(8111),
    [sym_raw_string] = ACTIONS(8924),
    [anon_sym_POUND] = ACTIONS(8922),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4071),
    [anon_sym_BQUOTE] = ACTIONS(4071),
    [anon_sym_LT_LPAREN] = ACTIONS(4071),
    [anon_sym_GT_LPAREN] = ACTIONS(4071),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8926),
    [anon_sym_STAR] = ACTIONS(8926),
    [anon_sym_AT] = ACTIONS(8926),
    [anon_sym_QMARK] = ACTIONS(8926),
    [anon_sym_0] = ACTIONS(8926),
    [anon_sym__] = ACTIONS(8926),
    [sym_word] = ACTIONS(4073),
    [anon_sym_LF] = ACTIONS(4071),
    [anon_sym_AMP] = ACTIONS(4073),
  },
  [4343] = {
    [sym__simple_heredoc_body] = ACTIONS(4111),
    [sym__heredoc_body_beginning] = ACTIONS(4111),
    [sym_file_descriptor] = ACTIONS(4111),
    [sym__concat] = ACTIONS(4111),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_esac] = ACTIONS(4113),
    [anon_sym_PIPE] = ACTIONS(4113),
    [anon_sym_SEMI_SEMI] = ACTIONS(4111),
    [anon_sym_PIPE_AMP] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_LT] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4113),
    [anon_sym_GT_GT] = ACTIONS(4111),
    [anon_sym_AMP_GT] = ACTIONS(4113),
    [anon_sym_AMP_GT_GT] = ACTIONS(4111),
    [anon_sym_LT_AMP] = ACTIONS(4111),
    [anon_sym_GT_AMP] = ACTIONS(4111),
    [anon_sym_LT_LT] = ACTIONS(4113),
    [anon_sym_LT_LT_DASH] = ACTIONS(4111),
    [anon_sym_LT_LT_LT] = ACTIONS(4111),
    [anon_sym_DOLLAR] = ACTIONS(4113),
    [sym__special_character] = ACTIONS(4111),
    [anon_sym_DQUOTE] = ACTIONS(4111),
    [sym_raw_string] = ACTIONS(4111),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4111),
    [anon_sym_BQUOTE] = ACTIONS(4111),
    [anon_sym_LT_LPAREN] = ACTIONS(4111),
    [anon_sym_GT_LPAREN] = ACTIONS(4111),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4113),
    [sym_word] = ACTIONS(4113),
    [anon_sym_LF] = ACTIONS(4111),
    [anon_sym_AMP] = ACTIONS(4113),
  },
  [4344] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_esac] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym__special_character] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4127),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [4345] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(10070),
    [sym_comment] = ACTIONS(57),
  },
  [4346] = {
    [anon_sym_RBRACE] = ACTIONS(10070),
    [sym_comment] = ACTIONS(57),
  },
  [4347] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(10072),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [4348] = {
    [sym_concatenation] = STATE(4424),
    [sym_string] = STATE(4423),
    [sym_simple_expansion] = STATE(4423),
    [sym_string_expansion] = STATE(4423),
    [sym_expansion] = STATE(4423),
    [sym_command_substitution] = STATE(4423),
    [sym_process_substitution] = STATE(4423),
    [aux_sym__literal_repeat1] = STATE(4425),
    [anon_sym_RBRACE] = ACTIONS(10070),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(10074),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(10074),
  },
  [4349] = {
    [sym__simple_heredoc_body] = ACTIONS(4161),
    [sym__heredoc_body_beginning] = ACTIONS(4161),
    [sym_file_descriptor] = ACTIONS(4161),
    [sym__concat] = ACTIONS(4161),
    [anon_sym_SEMI] = ACTIONS(4163),
    [anon_sym_esac] = ACTIONS(4163),
    [anon_sym_PIPE] = ACTIONS(4163),
    [anon_sym_SEMI_SEMI] = ACTIONS(4161),
    [anon_sym_PIPE_AMP] = ACTIONS(4161),
    [anon_sym_AMP_AMP] = ACTIONS(4161),
    [anon_sym_PIPE_PIPE] = ACTIONS(4161),
    [anon_sym_LT] = ACTIONS(4163),
    [anon_sym_GT] = ACTIONS(4163),
    [anon_sym_GT_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT] = ACTIONS(4163),
    [anon_sym_AMP_GT_GT] = ACTIONS(4161),
    [anon_sym_LT_AMP] = ACTIONS(4161),
    [anon_sym_GT_AMP] = ACTIONS(4161),
    [anon_sym_LT_LT] = ACTIONS(4163),
    [anon_sym_LT_LT_DASH] = ACTIONS(4161),
    [anon_sym_LT_LT_LT] = ACTIONS(4161),
    [anon_sym_DOLLAR] = ACTIONS(4163),
    [sym__special_character] = ACTIONS(4161),
    [anon_sym_DQUOTE] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4161),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4161),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4161),
    [anon_sym_BQUOTE] = ACTIONS(4161),
    [anon_sym_LT_LPAREN] = ACTIONS(4161),
    [anon_sym_GT_LPAREN] = ACTIONS(4161),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4163),
    [sym_word] = ACTIONS(4163),
    [anon_sym_LF] = ACTIONS(4161),
    [anon_sym_AMP] = ACTIONS(4163),
  },
  [4350] = {
    [sym_concatenation] = STATE(4428),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4428),
    [sym_regex] = ACTIONS(10076),
    [anon_sym_RBRACE] = ACTIONS(10078),
    [anon_sym_EQ] = ACTIONS(10080),
    [anon_sym_DASH] = ACTIONS(10080),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(10082),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(10080),
    [anon_sym_COLON_QMARK] = ACTIONS(10080),
    [anon_sym_COLON_DASH] = ACTIONS(10080),
    [anon_sym_PERCENT] = ACTIONS(10080),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4351] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(10078),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4352] = {
    [sym_concatenation] = STATE(4430),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4430),
    [sym_regex] = ACTIONS(10084),
    [anon_sym_RBRACE] = ACTIONS(10070),
    [anon_sym_EQ] = ACTIONS(10086),
    [anon_sym_DASH] = ACTIONS(10086),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(10088),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(10086),
    [anon_sym_COLON_QMARK] = ACTIONS(10086),
    [anon_sym_COLON_DASH] = ACTIONS(10086),
    [anon_sym_PERCENT] = ACTIONS(10086),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4353] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(10070),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4354] = {
    [sym_concatenation] = STATE(4432),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4432),
    [anon_sym_RBRACE] = ACTIONS(10090),
    [anon_sym_EQ] = ACTIONS(10092),
    [anon_sym_DASH] = ACTIONS(10092),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(10094),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(10092),
    [anon_sym_COLON_QMARK] = ACTIONS(10092),
    [anon_sym_COLON_DASH] = ACTIONS(10092),
    [anon_sym_PERCENT] = ACTIONS(10092),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4355] = {
    [sym__simple_heredoc_body] = ACTIONS(4219),
    [sym__heredoc_body_beginning] = ACTIONS(4219),
    [sym_file_descriptor] = ACTIONS(4219),
    [sym__concat] = ACTIONS(4219),
    [anon_sym_SEMI] = ACTIONS(4221),
    [anon_sym_esac] = ACTIONS(4221),
    [anon_sym_PIPE] = ACTIONS(4221),
    [anon_sym_SEMI_SEMI] = ACTIONS(4219),
    [anon_sym_PIPE_AMP] = ACTIONS(4219),
    [anon_sym_AMP_AMP] = ACTIONS(4219),
    [anon_sym_PIPE_PIPE] = ACTIONS(4219),
    [anon_sym_LT] = ACTIONS(4221),
    [anon_sym_GT] = ACTIONS(4221),
    [anon_sym_GT_GT] = ACTIONS(4219),
    [anon_sym_AMP_GT] = ACTIONS(4221),
    [anon_sym_AMP_GT_GT] = ACTIONS(4219),
    [anon_sym_LT_AMP] = ACTIONS(4219),
    [anon_sym_GT_AMP] = ACTIONS(4219),
    [anon_sym_LT_LT] = ACTIONS(4221),
    [anon_sym_LT_LT_DASH] = ACTIONS(4219),
    [anon_sym_LT_LT_LT] = ACTIONS(4219),
    [anon_sym_DOLLAR] = ACTIONS(4221),
    [sym__special_character] = ACTIONS(4219),
    [anon_sym_DQUOTE] = ACTIONS(4219),
    [sym_raw_string] = ACTIONS(4219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4219),
    [anon_sym_BQUOTE] = ACTIONS(4219),
    [anon_sym_LT_LPAREN] = ACTIONS(4219),
    [anon_sym_GT_LPAREN] = ACTIONS(4219),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4221),
    [sym_word] = ACTIONS(4221),
    [anon_sym_LF] = ACTIONS(4219),
    [anon_sym_AMP] = ACTIONS(4221),
  },
  [4356] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(10090),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4357] = {
    [sym_concatenation] = STATE(4430),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4430),
    [anon_sym_RBRACE] = ACTIONS(10070),
    [anon_sym_EQ] = ACTIONS(10086),
    [anon_sym_DASH] = ACTIONS(10086),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(10088),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(10086),
    [anon_sym_COLON_QMARK] = ACTIONS(10086),
    [anon_sym_COLON_DASH] = ACTIONS(10086),
    [anon_sym_PERCENT] = ACTIONS(10086),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4358] = {
    [sym__simple_heredoc_body] = ACTIONS(5674),
    [sym__heredoc_body_beginning] = ACTIONS(5674),
    [sym_file_descriptor] = ACTIONS(5674),
    [sym__concat] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(5676),
    [anon_sym_esac] = ACTIONS(5676),
    [anon_sym_PIPE] = ACTIONS(5676),
    [anon_sym_SEMI_SEMI] = ACTIONS(5674),
    [anon_sym_PIPE_AMP] = ACTIONS(5674),
    [anon_sym_AMP_AMP] = ACTIONS(5674),
    [anon_sym_PIPE_PIPE] = ACTIONS(5674),
    [anon_sym_EQ_TILDE] = ACTIONS(5676),
    [anon_sym_EQ_EQ] = ACTIONS(5676),
    [anon_sym_LT] = ACTIONS(5676),
    [anon_sym_GT] = ACTIONS(5676),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_AMP_GT] = ACTIONS(5676),
    [anon_sym_AMP_GT_GT] = ACTIONS(5674),
    [anon_sym_LT_AMP] = ACTIONS(5674),
    [anon_sym_GT_AMP] = ACTIONS(5674),
    [anon_sym_LT_LT] = ACTIONS(5676),
    [anon_sym_LT_LT_DASH] = ACTIONS(5674),
    [anon_sym_LT_LT_LT] = ACTIONS(5674),
    [anon_sym_DOLLAR] = ACTIONS(5676),
    [sym__special_character] = ACTIONS(5674),
    [anon_sym_DQUOTE] = ACTIONS(5674),
    [sym_raw_string] = ACTIONS(5674),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5674),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5674),
    [anon_sym_BQUOTE] = ACTIONS(5674),
    [anon_sym_LT_LPAREN] = ACTIONS(5674),
    [anon_sym_GT_LPAREN] = ACTIONS(5674),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5676),
    [anon_sym_LF] = ACTIONS(5674),
    [anon_sym_AMP] = ACTIONS(5676),
  },
  [4359] = {
    [sym__simple_heredoc_body] = ACTIONS(5708),
    [sym__heredoc_body_beginning] = ACTIONS(5708),
    [sym_file_descriptor] = ACTIONS(5708),
    [sym__concat] = ACTIONS(5708),
    [anon_sym_SEMI] = ACTIONS(5710),
    [anon_sym_esac] = ACTIONS(5710),
    [anon_sym_PIPE] = ACTIONS(5710),
    [anon_sym_SEMI_SEMI] = ACTIONS(5708),
    [anon_sym_PIPE_AMP] = ACTIONS(5708),
    [anon_sym_AMP_AMP] = ACTIONS(5708),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_EQ_TILDE] = ACTIONS(5710),
    [anon_sym_EQ_EQ] = ACTIONS(5710),
    [anon_sym_LT] = ACTIONS(5710),
    [anon_sym_GT] = ACTIONS(5710),
    [anon_sym_GT_GT] = ACTIONS(5708),
    [anon_sym_AMP_GT] = ACTIONS(5710),
    [anon_sym_AMP_GT_GT] = ACTIONS(5708),
    [anon_sym_LT_AMP] = ACTIONS(5708),
    [anon_sym_GT_AMP] = ACTIONS(5708),
    [anon_sym_LT_LT] = ACTIONS(5710),
    [anon_sym_LT_LT_DASH] = ACTIONS(5708),
    [anon_sym_LT_LT_LT] = ACTIONS(5708),
    [anon_sym_DOLLAR] = ACTIONS(5710),
    [sym__special_character] = ACTIONS(5708),
    [anon_sym_DQUOTE] = ACTIONS(5708),
    [sym_raw_string] = ACTIONS(5708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5708),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5708),
    [anon_sym_BQUOTE] = ACTIONS(5708),
    [anon_sym_LT_LPAREN] = ACTIONS(5708),
    [anon_sym_GT_LPAREN] = ACTIONS(5708),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5710),
    [anon_sym_LF] = ACTIONS(5708),
    [anon_sym_AMP] = ACTIONS(5710),
  },
  [4360] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(10096),
    [sym_comment] = ACTIONS(57),
  },
  [4361] = {
    [anon_sym_RBRACE] = ACTIONS(10096),
    [sym_comment] = ACTIONS(57),
  },
  [4362] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(10098),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [4363] = {
    [sym_concatenation] = STATE(4436),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4436),
    [anon_sym_RBRACE] = ACTIONS(10100),
    [anon_sym_EQ] = ACTIONS(10102),
    [anon_sym_DASH] = ACTIONS(10102),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(10104),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(10102),
    [anon_sym_COLON_QMARK] = ACTIONS(10102),
    [anon_sym_COLON_DASH] = ACTIONS(10102),
    [anon_sym_PERCENT] = ACTIONS(10102),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4364] = {
    [sym__simple_heredoc_body] = ACTIONS(5725),
    [sym__heredoc_body_beginning] = ACTIONS(5725),
    [sym_file_descriptor] = ACTIONS(5725),
    [sym__concat] = ACTIONS(5725),
    [anon_sym_SEMI] = ACTIONS(5727),
    [anon_sym_esac] = ACTIONS(5727),
    [anon_sym_PIPE] = ACTIONS(5727),
    [anon_sym_SEMI_SEMI] = ACTIONS(5725),
    [anon_sym_PIPE_AMP] = ACTIONS(5725),
    [anon_sym_AMP_AMP] = ACTIONS(5725),
    [anon_sym_PIPE_PIPE] = ACTIONS(5725),
    [anon_sym_EQ_TILDE] = ACTIONS(5727),
    [anon_sym_EQ_EQ] = ACTIONS(5727),
    [anon_sym_LT] = ACTIONS(5727),
    [anon_sym_GT] = ACTIONS(5727),
    [anon_sym_GT_GT] = ACTIONS(5725),
    [anon_sym_AMP_GT] = ACTIONS(5727),
    [anon_sym_AMP_GT_GT] = ACTIONS(5725),
    [anon_sym_LT_AMP] = ACTIONS(5725),
    [anon_sym_GT_AMP] = ACTIONS(5725),
    [anon_sym_LT_LT] = ACTIONS(5727),
    [anon_sym_LT_LT_DASH] = ACTIONS(5725),
    [anon_sym_LT_LT_LT] = ACTIONS(5725),
    [anon_sym_DOLLAR] = ACTIONS(5727),
    [sym__special_character] = ACTIONS(5725),
    [anon_sym_DQUOTE] = ACTIONS(5725),
    [sym_raw_string] = ACTIONS(5725),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5725),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5725),
    [anon_sym_BQUOTE] = ACTIONS(5725),
    [anon_sym_LT_LPAREN] = ACTIONS(5725),
    [anon_sym_GT_LPAREN] = ACTIONS(5725),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5727),
    [anon_sym_LF] = ACTIONS(5725),
    [anon_sym_AMP] = ACTIONS(5727),
  },
  [4365] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(10100),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4366] = {
    [sym_concatenation] = STATE(4437),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4437),
    [anon_sym_RBRACE] = ACTIONS(10096),
    [anon_sym_EQ] = ACTIONS(10106),
    [anon_sym_DASH] = ACTIONS(10106),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(10108),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(10106),
    [anon_sym_COLON_QMARK] = ACTIONS(10106),
    [anon_sym_COLON_DASH] = ACTIONS(10106),
    [anon_sym_PERCENT] = ACTIONS(10106),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4367] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(10096),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4368] = {
    [sym__simple_heredoc_body] = ACTIONS(5770),
    [sym__heredoc_body_beginning] = ACTIONS(5770),
    [sym_file_descriptor] = ACTIONS(5770),
    [sym__concat] = ACTIONS(5770),
    [anon_sym_SEMI] = ACTIONS(5772),
    [anon_sym_esac] = ACTIONS(5772),
    [anon_sym_PIPE] = ACTIONS(5772),
    [anon_sym_SEMI_SEMI] = ACTIONS(5770),
    [anon_sym_PIPE_AMP] = ACTIONS(5770),
    [anon_sym_AMP_AMP] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5770),
    [anon_sym_EQ_TILDE] = ACTIONS(5772),
    [anon_sym_EQ_EQ] = ACTIONS(5772),
    [anon_sym_LT] = ACTIONS(5772),
    [anon_sym_GT] = ACTIONS(5772),
    [anon_sym_GT_GT] = ACTIONS(5770),
    [anon_sym_AMP_GT] = ACTIONS(5772),
    [anon_sym_AMP_GT_GT] = ACTIONS(5770),
    [anon_sym_LT_AMP] = ACTIONS(5770),
    [anon_sym_GT_AMP] = ACTIONS(5770),
    [anon_sym_LT_LT] = ACTIONS(5772),
    [anon_sym_LT_LT_DASH] = ACTIONS(5770),
    [anon_sym_LT_LT_LT] = ACTIONS(5770),
    [anon_sym_DOLLAR] = ACTIONS(5772),
    [sym__special_character] = ACTIONS(5770),
    [anon_sym_DQUOTE] = ACTIONS(5770),
    [sym_raw_string] = ACTIONS(5770),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5770),
    [anon_sym_BQUOTE] = ACTIONS(5770),
    [anon_sym_LT_LPAREN] = ACTIONS(5770),
    [anon_sym_GT_LPAREN] = ACTIONS(5770),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5772),
    [anon_sym_LF] = ACTIONS(5770),
    [anon_sym_AMP] = ACTIONS(5772),
  },
  [4369] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(10110),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4370] = {
    [sym_string] = STATE(3406),
    [sym_simple_expansion] = STATE(3406),
    [sym_string_expansion] = STATE(3406),
    [sym_expansion] = STATE(3406),
    [sym_command_substitution] = STATE(3406),
    [sym_process_substitution] = STATE(3406),
    [anon_sym_DOLLAR] = ACTIONS(10112),
    [sym__special_character] = ACTIONS(7609),
    [anon_sym_DQUOTE] = ACTIONS(5002),
    [sym_raw_string] = ACTIONS(7609),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5006),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5008),
    [anon_sym_BQUOTE] = ACTIONS(5010),
    [anon_sym_LT_LPAREN] = ACTIONS(5012),
    [anon_sym_GT_LPAREN] = ACTIONS(5012),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7609),
  },
  [4371] = {
    [aux_sym_concatenation_repeat1] = STATE(4371),
    [sym__simple_heredoc_body] = ACTIONS(2362),
    [sym__heredoc_body_beginning] = ACTIONS(2362),
    [sym_file_descriptor] = ACTIONS(2362),
    [sym__concat] = ACTIONS(8575),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_esac] = ACTIONS(2362),
    [anon_sym_PIPE] = ACTIONS(2364),
    [anon_sym_SEMI_SEMI] = ACTIONS(2362),
    [anon_sym_PIPE_AMP] = ACTIONS(2362),
    [anon_sym_AMP_AMP] = ACTIONS(2362),
    [anon_sym_PIPE_PIPE] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2364),
    [anon_sym_GT] = ACTIONS(2364),
    [anon_sym_GT_GT] = ACTIONS(2362),
    [anon_sym_AMP_GT] = ACTIONS(2364),
    [anon_sym_AMP_GT_GT] = ACTIONS(2362),
    [anon_sym_LT_AMP] = ACTIONS(2362),
    [anon_sym_GT_AMP] = ACTIONS(2362),
    [anon_sym_LT_LT] = ACTIONS(2364),
    [anon_sym_LT_LT_DASH] = ACTIONS(2362),
    [anon_sym_LT_LT_LT] = ACTIONS(2362),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2364),
  },
  [4372] = {
    [anon_sym_SEMI] = ACTIONS(2670),
    [anon_sym_SEMI_SEMI] = ACTIONS(2606),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2672),
    [anon_sym_AMP] = ACTIONS(2672),
  },
  [4373] = {
    [anon_sym_DOLLAR] = ACTIONS(9656),
    [sym__special_character] = ACTIONS(9658),
    [anon_sym_DQUOTE] = ACTIONS(9658),
    [sym_raw_string] = ACTIONS(9658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(9658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(9658),
    [anon_sym_BQUOTE] = ACTIONS(9658),
    [anon_sym_LT_LPAREN] = ACTIONS(9658),
    [anon_sym_GT_LPAREN] = ACTIONS(9658),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9658),
  },
  [4374] = {
    [anon_sym_DOLLAR] = ACTIONS(9666),
    [sym__special_character] = ACTIONS(9668),
    [anon_sym_DQUOTE] = ACTIONS(9668),
    [sym_raw_string] = ACTIONS(9668),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(9668),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(9668),
    [anon_sym_BQUOTE] = ACTIONS(9668),
    [anon_sym_LT_LPAREN] = ACTIONS(9668),
    [anon_sym_GT_LPAREN] = ACTIONS(9668),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9668),
  },
  [4375] = {
    [sym__simple_heredoc_body] = ACTIONS(9680),
    [sym__heredoc_body_beginning] = ACTIONS(9680),
    [sym_file_descriptor] = ACTIONS(9680),
    [anon_sym_SEMI] = ACTIONS(9682),
    [anon_sym_PIPE] = ACTIONS(9682),
    [anon_sym_SEMI_SEMI] = ACTIONS(9680),
    [anon_sym_RBRACE] = ACTIONS(9680),
    [anon_sym_PIPE_AMP] = ACTIONS(9680),
    [anon_sym_AMP_AMP] = ACTIONS(9680),
    [anon_sym_PIPE_PIPE] = ACTIONS(9680),
    [anon_sym_LT] = ACTIONS(9682),
    [anon_sym_GT] = ACTIONS(9682),
    [anon_sym_GT_GT] = ACTIONS(9680),
    [anon_sym_AMP_GT] = ACTIONS(9682),
    [anon_sym_AMP_GT_GT] = ACTIONS(9680),
    [anon_sym_LT_AMP] = ACTIONS(9680),
    [anon_sym_GT_AMP] = ACTIONS(9680),
    [anon_sym_LT_LT] = ACTIONS(9682),
    [anon_sym_LT_LT_DASH] = ACTIONS(9680),
    [anon_sym_LT_LT_LT] = ACTIONS(9680),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(9680),
    [anon_sym_AMP] = ACTIONS(9682),
  },
  [4376] = {
    [sym__simple_heredoc_body] = ACTIONS(8340),
    [sym__heredoc_body_beginning] = ACTIONS(8340),
    [sym_file_descriptor] = ACTIONS(8340),
    [sym__concat] = ACTIONS(8340),
    [sym_variable_name] = ACTIONS(8340),
    [anon_sym_SEMI] = ACTIONS(8342),
    [anon_sym_done] = ACTIONS(8342),
    [anon_sym_PIPE] = ACTIONS(8342),
    [anon_sym_SEMI_SEMI] = ACTIONS(8340),
    [anon_sym_PIPE_AMP] = ACTIONS(8340),
    [anon_sym_AMP_AMP] = ACTIONS(8340),
    [anon_sym_PIPE_PIPE] = ACTIONS(8340),
    [anon_sym_LT] = ACTIONS(8342),
    [anon_sym_GT] = ACTIONS(8342),
    [anon_sym_GT_GT] = ACTIONS(8340),
    [anon_sym_AMP_GT] = ACTIONS(8342),
    [anon_sym_AMP_GT_GT] = ACTIONS(8340),
    [anon_sym_LT_AMP] = ACTIONS(8340),
    [anon_sym_GT_AMP] = ACTIONS(8340),
    [anon_sym_LT_LT] = ACTIONS(8342),
    [anon_sym_LT_LT_DASH] = ACTIONS(8340),
    [anon_sym_LT_LT_LT] = ACTIONS(8340),
    [anon_sym_DOLLAR] = ACTIONS(8342),
    [sym__special_character] = ACTIONS(8340),
    [anon_sym_DQUOTE] = ACTIONS(8340),
    [sym_raw_string] = ACTIONS(8340),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8340),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [anon_sym_LT_LPAREN] = ACTIONS(8340),
    [anon_sym_GT_LPAREN] = ACTIONS(8340),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8342),
    [anon_sym_LF] = ACTIONS(8340),
    [anon_sym_AMP] = ACTIONS(8342),
  },
  [4377] = {
    [sym__simple_heredoc_body] = ACTIONS(8344),
    [sym__heredoc_body_beginning] = ACTIONS(8344),
    [sym_file_descriptor] = ACTIONS(8344),
    [sym__concat] = ACTIONS(8344),
    [sym_variable_name] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [anon_sym_done] = ACTIONS(8346),
    [anon_sym_PIPE] = ACTIONS(8346),
    [anon_sym_SEMI_SEMI] = ACTIONS(8344),
    [anon_sym_PIPE_AMP] = ACTIONS(8344),
    [anon_sym_AMP_AMP] = ACTIONS(8344),
    [anon_sym_PIPE_PIPE] = ACTIONS(8344),
    [anon_sym_LT] = ACTIONS(8346),
    [anon_sym_GT] = ACTIONS(8346),
    [anon_sym_GT_GT] = ACTIONS(8344),
    [anon_sym_AMP_GT] = ACTIONS(8346),
    [anon_sym_AMP_GT_GT] = ACTIONS(8344),
    [anon_sym_LT_AMP] = ACTIONS(8344),
    [anon_sym_GT_AMP] = ACTIONS(8344),
    [anon_sym_LT_LT] = ACTIONS(8346),
    [anon_sym_LT_LT_DASH] = ACTIONS(8344),
    [anon_sym_LT_LT_LT] = ACTIONS(8344),
    [anon_sym_DOLLAR] = ACTIONS(8346),
    [sym__special_character] = ACTIONS(8344),
    [anon_sym_DQUOTE] = ACTIONS(8344),
    [sym_raw_string] = ACTIONS(8344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8344),
    [anon_sym_BQUOTE] = ACTIONS(8344),
    [anon_sym_LT_LPAREN] = ACTIONS(8344),
    [anon_sym_GT_LPAREN] = ACTIONS(8344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8346),
    [anon_sym_LF] = ACTIONS(8344),
    [anon_sym_AMP] = ACTIONS(8346),
  },
  [4378] = {
    [sym__simple_heredoc_body] = ACTIONS(8340),
    [sym__heredoc_body_beginning] = ACTIONS(8340),
    [sym_file_descriptor] = ACTIONS(8340),
    [sym__concat] = ACTIONS(8340),
    [anon_sym_SEMI] = ACTIONS(8342),
    [anon_sym_done] = ACTIONS(8340),
    [anon_sym_fi] = ACTIONS(8340),
    [anon_sym_elif] = ACTIONS(8340),
    [anon_sym_else] = ACTIONS(8340),
    [anon_sym_esac] = ACTIONS(8340),
    [anon_sym_PIPE] = ACTIONS(8342),
    [anon_sym_SEMI_SEMI] = ACTIONS(8340),
    [anon_sym_PIPE_AMP] = ACTIONS(8340),
    [anon_sym_AMP_AMP] = ACTIONS(8340),
    [anon_sym_PIPE_PIPE] = ACTIONS(8340),
    [anon_sym_LT] = ACTIONS(8342),
    [anon_sym_GT] = ACTIONS(8342),
    [anon_sym_GT_GT] = ACTIONS(8340),
    [anon_sym_AMP_GT] = ACTIONS(8342),
    [anon_sym_AMP_GT_GT] = ACTIONS(8340),
    [anon_sym_LT_AMP] = ACTIONS(8340),
    [anon_sym_GT_AMP] = ACTIONS(8340),
    [anon_sym_LT_LT] = ACTIONS(8342),
    [anon_sym_LT_LT_DASH] = ACTIONS(8340),
    [anon_sym_LT_LT_LT] = ACTIONS(8340),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8340),
    [anon_sym_AMP] = ACTIONS(8342),
  },
  [4379] = {
    [sym__simple_heredoc_body] = ACTIONS(8344),
    [sym__heredoc_body_beginning] = ACTIONS(8344),
    [sym_file_descriptor] = ACTIONS(8344),
    [sym__concat] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [anon_sym_done] = ACTIONS(8344),
    [anon_sym_fi] = ACTIONS(8344),
    [anon_sym_elif] = ACTIONS(8344),
    [anon_sym_else] = ACTIONS(8344),
    [anon_sym_esac] = ACTIONS(8344),
    [anon_sym_PIPE] = ACTIONS(8346),
    [anon_sym_SEMI_SEMI] = ACTIONS(8344),
    [anon_sym_PIPE_AMP] = ACTIONS(8344),
    [anon_sym_AMP_AMP] = ACTIONS(8344),
    [anon_sym_PIPE_PIPE] = ACTIONS(8344),
    [anon_sym_LT] = ACTIONS(8346),
    [anon_sym_GT] = ACTIONS(8346),
    [anon_sym_GT_GT] = ACTIONS(8344),
    [anon_sym_AMP_GT] = ACTIONS(8346),
    [anon_sym_AMP_GT_GT] = ACTIONS(8344),
    [anon_sym_LT_AMP] = ACTIONS(8344),
    [anon_sym_GT_AMP] = ACTIONS(8344),
    [anon_sym_LT_LT] = ACTIONS(8346),
    [anon_sym_LT_LT_DASH] = ACTIONS(8344),
    [anon_sym_LT_LT_LT] = ACTIONS(8344),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8344),
    [anon_sym_AMP] = ACTIONS(8346),
  },
  [4380] = {
    [sym__simple_heredoc_body] = ACTIONS(8340),
    [sym__heredoc_body_beginning] = ACTIONS(8340),
    [sym_file_descriptor] = ACTIONS(8340),
    [sym__concat] = ACTIONS(8340),
    [sym_variable_name] = ACTIONS(8340),
    [anon_sym_SEMI] = ACTIONS(8342),
    [anon_sym_fi] = ACTIONS(8342),
    [anon_sym_elif] = ACTIONS(8342),
    [anon_sym_else] = ACTIONS(8342),
    [anon_sym_PIPE] = ACTIONS(8342),
    [anon_sym_SEMI_SEMI] = ACTIONS(8340),
    [anon_sym_PIPE_AMP] = ACTIONS(8340),
    [anon_sym_AMP_AMP] = ACTIONS(8340),
    [anon_sym_PIPE_PIPE] = ACTIONS(8340),
    [anon_sym_LT] = ACTIONS(8342),
    [anon_sym_GT] = ACTIONS(8342),
    [anon_sym_GT_GT] = ACTIONS(8340),
    [anon_sym_AMP_GT] = ACTIONS(8342),
    [anon_sym_AMP_GT_GT] = ACTIONS(8340),
    [anon_sym_LT_AMP] = ACTIONS(8340),
    [anon_sym_GT_AMP] = ACTIONS(8340),
    [anon_sym_LT_LT] = ACTIONS(8342),
    [anon_sym_LT_LT_DASH] = ACTIONS(8340),
    [anon_sym_LT_LT_LT] = ACTIONS(8340),
    [anon_sym_DOLLAR] = ACTIONS(8342),
    [sym__special_character] = ACTIONS(8340),
    [anon_sym_DQUOTE] = ACTIONS(8340),
    [sym_raw_string] = ACTIONS(8340),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8340),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [anon_sym_LT_LPAREN] = ACTIONS(8340),
    [anon_sym_GT_LPAREN] = ACTIONS(8340),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8342),
    [anon_sym_LF] = ACTIONS(8340),
    [anon_sym_AMP] = ACTIONS(8342),
  },
  [4381] = {
    [sym__simple_heredoc_body] = ACTIONS(8344),
    [sym__heredoc_body_beginning] = ACTIONS(8344),
    [sym_file_descriptor] = ACTIONS(8344),
    [sym__concat] = ACTIONS(8344),
    [sym_variable_name] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [anon_sym_fi] = ACTIONS(8346),
    [anon_sym_elif] = ACTIONS(8346),
    [anon_sym_else] = ACTIONS(8346),
    [anon_sym_PIPE] = ACTIONS(8346),
    [anon_sym_SEMI_SEMI] = ACTIONS(8344),
    [anon_sym_PIPE_AMP] = ACTIONS(8344),
    [anon_sym_AMP_AMP] = ACTIONS(8344),
    [anon_sym_PIPE_PIPE] = ACTIONS(8344),
    [anon_sym_LT] = ACTIONS(8346),
    [anon_sym_GT] = ACTIONS(8346),
    [anon_sym_GT_GT] = ACTIONS(8344),
    [anon_sym_AMP_GT] = ACTIONS(8346),
    [anon_sym_AMP_GT_GT] = ACTIONS(8344),
    [anon_sym_LT_AMP] = ACTIONS(8344),
    [anon_sym_GT_AMP] = ACTIONS(8344),
    [anon_sym_LT_LT] = ACTIONS(8346),
    [anon_sym_LT_LT_DASH] = ACTIONS(8344),
    [anon_sym_LT_LT_LT] = ACTIONS(8344),
    [anon_sym_DOLLAR] = ACTIONS(8346),
    [sym__special_character] = ACTIONS(8344),
    [anon_sym_DQUOTE] = ACTIONS(8344),
    [sym_raw_string] = ACTIONS(8344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8344),
    [anon_sym_BQUOTE] = ACTIONS(8344),
    [anon_sym_LT_LPAREN] = ACTIONS(8344),
    [anon_sym_GT_LPAREN] = ACTIONS(8344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8346),
    [anon_sym_LF] = ACTIONS(8344),
    [anon_sym_AMP] = ACTIONS(8346),
  },
  [4382] = {
    [sym__simple_heredoc_body] = ACTIONS(7198),
    [sym__heredoc_body_beginning] = ACTIONS(7198),
    [sym_file_descriptor] = ACTIONS(7198),
    [sym__concat] = ACTIONS(7198),
    [sym_variable_name] = ACTIONS(7198),
    [anon_sym_SEMI] = ACTIONS(7200),
    [anon_sym_fi] = ACTIONS(7200),
    [anon_sym_PIPE] = ACTIONS(7200),
    [anon_sym_SEMI_SEMI] = ACTIONS(7198),
    [anon_sym_PIPE_AMP] = ACTIONS(7198),
    [anon_sym_AMP_AMP] = ACTIONS(7198),
    [anon_sym_PIPE_PIPE] = ACTIONS(7198),
    [anon_sym_LT] = ACTIONS(7200),
    [anon_sym_GT] = ACTIONS(7200),
    [anon_sym_GT_GT] = ACTIONS(7198),
    [anon_sym_AMP_GT] = ACTIONS(7200),
    [anon_sym_AMP_GT_GT] = ACTIONS(7198),
    [anon_sym_LT_AMP] = ACTIONS(7198),
    [anon_sym_GT_AMP] = ACTIONS(7198),
    [anon_sym_LT_LT] = ACTIONS(7200),
    [anon_sym_LT_LT_DASH] = ACTIONS(7198),
    [anon_sym_LT_LT_LT] = ACTIONS(7198),
    [anon_sym_DOLLAR] = ACTIONS(7200),
    [sym__special_character] = ACTIONS(7198),
    [anon_sym_DQUOTE] = ACTIONS(7198),
    [sym_raw_string] = ACTIONS(7198),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7198),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7198),
    [anon_sym_BQUOTE] = ACTIONS(7198),
    [anon_sym_LT_LPAREN] = ACTIONS(7198),
    [anon_sym_GT_LPAREN] = ACTIONS(7198),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7200),
    [anon_sym_LF] = ACTIONS(7198),
    [anon_sym_AMP] = ACTIONS(7200),
  },
  [4383] = {
    [sym__simple_heredoc_body] = ACTIONS(7202),
    [sym__heredoc_body_beginning] = ACTIONS(7202),
    [sym_file_descriptor] = ACTIONS(7202),
    [sym__concat] = ACTIONS(7202),
    [sym_variable_name] = ACTIONS(7202),
    [anon_sym_SEMI] = ACTIONS(7204),
    [anon_sym_fi] = ACTIONS(7204),
    [anon_sym_PIPE] = ACTIONS(7204),
    [anon_sym_SEMI_SEMI] = ACTIONS(7202),
    [anon_sym_PIPE_AMP] = ACTIONS(7202),
    [anon_sym_AMP_AMP] = ACTIONS(7202),
    [anon_sym_PIPE_PIPE] = ACTIONS(7202),
    [anon_sym_LT] = ACTIONS(7204),
    [anon_sym_GT] = ACTIONS(7204),
    [anon_sym_GT_GT] = ACTIONS(7202),
    [anon_sym_AMP_GT] = ACTIONS(7204),
    [anon_sym_AMP_GT_GT] = ACTIONS(7202),
    [anon_sym_LT_AMP] = ACTIONS(7202),
    [anon_sym_GT_AMP] = ACTIONS(7202),
    [anon_sym_LT_LT] = ACTIONS(7204),
    [anon_sym_LT_LT_DASH] = ACTIONS(7202),
    [anon_sym_LT_LT_LT] = ACTIONS(7202),
    [anon_sym_DOLLAR] = ACTIONS(7204),
    [sym__special_character] = ACTIONS(7202),
    [anon_sym_DQUOTE] = ACTIONS(7202),
    [sym_raw_string] = ACTIONS(7202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7202),
    [anon_sym_BQUOTE] = ACTIONS(7202),
    [anon_sym_LT_LPAREN] = ACTIONS(7202),
    [anon_sym_GT_LPAREN] = ACTIONS(7202),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7204),
    [anon_sym_LF] = ACTIONS(7202),
    [anon_sym_AMP] = ACTIONS(7204),
  },
  [4384] = {
    [sym__simple_heredoc_body] = ACTIONS(7206),
    [sym__heredoc_body_beginning] = ACTIONS(7206),
    [sym_file_descriptor] = ACTIONS(7206),
    [sym__concat] = ACTIONS(7206),
    [sym_variable_name] = ACTIONS(7206),
    [anon_sym_SEMI] = ACTIONS(7208),
    [anon_sym_fi] = ACTIONS(7208),
    [anon_sym_PIPE] = ACTIONS(7208),
    [anon_sym_SEMI_SEMI] = ACTIONS(7206),
    [anon_sym_PIPE_AMP] = ACTIONS(7206),
    [anon_sym_AMP_AMP] = ACTIONS(7206),
    [anon_sym_PIPE_PIPE] = ACTIONS(7206),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7206),
    [anon_sym_AMP_GT] = ACTIONS(7208),
    [anon_sym_AMP_GT_GT] = ACTIONS(7206),
    [anon_sym_LT_AMP] = ACTIONS(7206),
    [anon_sym_GT_AMP] = ACTIONS(7206),
    [anon_sym_LT_LT] = ACTIONS(7208),
    [anon_sym_LT_LT_DASH] = ACTIONS(7206),
    [anon_sym_LT_LT_LT] = ACTIONS(7206),
    [anon_sym_DOLLAR] = ACTIONS(7208),
    [sym__special_character] = ACTIONS(7206),
    [anon_sym_DQUOTE] = ACTIONS(7206),
    [sym_raw_string] = ACTIONS(7206),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7206),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7206),
    [anon_sym_BQUOTE] = ACTIONS(7206),
    [anon_sym_LT_LPAREN] = ACTIONS(7206),
    [anon_sym_GT_LPAREN] = ACTIONS(7206),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7208),
    [anon_sym_LF] = ACTIONS(7206),
    [anon_sym_AMP] = ACTIONS(7208),
  },
  [4385] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(10114),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4386] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(10116),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4387] = {
    [sym__simple_heredoc_body] = ACTIONS(7242),
    [sym__heredoc_body_beginning] = ACTIONS(7242),
    [sym_file_descriptor] = ACTIONS(7242),
    [sym__concat] = ACTIONS(7242),
    [sym_variable_name] = ACTIONS(7242),
    [anon_sym_SEMI] = ACTIONS(7244),
    [anon_sym_fi] = ACTIONS(7244),
    [anon_sym_PIPE] = ACTIONS(7244),
    [anon_sym_SEMI_SEMI] = ACTIONS(7242),
    [anon_sym_PIPE_AMP] = ACTIONS(7242),
    [anon_sym_AMP_AMP] = ACTIONS(7242),
    [anon_sym_PIPE_PIPE] = ACTIONS(7242),
    [anon_sym_LT] = ACTIONS(7244),
    [anon_sym_GT] = ACTIONS(7244),
    [anon_sym_GT_GT] = ACTIONS(7242),
    [anon_sym_AMP_GT] = ACTIONS(7244),
    [anon_sym_AMP_GT_GT] = ACTIONS(7242),
    [anon_sym_LT_AMP] = ACTIONS(7242),
    [anon_sym_GT_AMP] = ACTIONS(7242),
    [anon_sym_LT_LT] = ACTIONS(7244),
    [anon_sym_LT_LT_DASH] = ACTIONS(7242),
    [anon_sym_LT_LT_LT] = ACTIONS(7242),
    [anon_sym_DOLLAR] = ACTIONS(7244),
    [sym__special_character] = ACTIONS(7242),
    [anon_sym_DQUOTE] = ACTIONS(7242),
    [sym_raw_string] = ACTIONS(7242),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7242),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7242),
    [anon_sym_BQUOTE] = ACTIONS(7242),
    [anon_sym_LT_LPAREN] = ACTIONS(7242),
    [anon_sym_GT_LPAREN] = ACTIONS(7242),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7244),
    [anon_sym_LF] = ACTIONS(7242),
    [anon_sym_AMP] = ACTIONS(7244),
  },
  [4388] = {
    [sym__simple_heredoc_body] = ACTIONS(8340),
    [sym__heredoc_body_beginning] = ACTIONS(8340),
    [sym_file_descriptor] = ACTIONS(8340),
    [sym__concat] = ACTIONS(8340),
    [sym_variable_name] = ACTIONS(8340),
    [anon_sym_SEMI] = ACTIONS(8342),
    [anon_sym_fi] = ACTIONS(8342),
    [anon_sym_PIPE] = ACTIONS(8342),
    [anon_sym_SEMI_SEMI] = ACTIONS(8340),
    [anon_sym_PIPE_AMP] = ACTIONS(8340),
    [anon_sym_AMP_AMP] = ACTIONS(8340),
    [anon_sym_PIPE_PIPE] = ACTIONS(8340),
    [anon_sym_LT] = ACTIONS(8342),
    [anon_sym_GT] = ACTIONS(8342),
    [anon_sym_GT_GT] = ACTIONS(8340),
    [anon_sym_AMP_GT] = ACTIONS(8342),
    [anon_sym_AMP_GT_GT] = ACTIONS(8340),
    [anon_sym_LT_AMP] = ACTIONS(8340),
    [anon_sym_GT_AMP] = ACTIONS(8340),
    [anon_sym_LT_LT] = ACTIONS(8342),
    [anon_sym_LT_LT_DASH] = ACTIONS(8340),
    [anon_sym_LT_LT_LT] = ACTIONS(8340),
    [anon_sym_DOLLAR] = ACTIONS(8342),
    [sym__special_character] = ACTIONS(8340),
    [anon_sym_DQUOTE] = ACTIONS(8340),
    [sym_raw_string] = ACTIONS(8340),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8340),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [anon_sym_LT_LPAREN] = ACTIONS(8340),
    [anon_sym_GT_LPAREN] = ACTIONS(8340),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8342),
    [sym_word] = ACTIONS(8342),
    [anon_sym_LF] = ACTIONS(8340),
    [anon_sym_AMP] = ACTIONS(8342),
  },
  [4389] = {
    [sym__simple_heredoc_body] = ACTIONS(8344),
    [sym__heredoc_body_beginning] = ACTIONS(8344),
    [sym_file_descriptor] = ACTIONS(8344),
    [sym__concat] = ACTIONS(8344),
    [sym_variable_name] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [anon_sym_fi] = ACTIONS(8346),
    [anon_sym_PIPE] = ACTIONS(8346),
    [anon_sym_SEMI_SEMI] = ACTIONS(8344),
    [anon_sym_PIPE_AMP] = ACTIONS(8344),
    [anon_sym_AMP_AMP] = ACTIONS(8344),
    [anon_sym_PIPE_PIPE] = ACTIONS(8344),
    [anon_sym_LT] = ACTIONS(8346),
    [anon_sym_GT] = ACTIONS(8346),
    [anon_sym_GT_GT] = ACTIONS(8344),
    [anon_sym_AMP_GT] = ACTIONS(8346),
    [anon_sym_AMP_GT_GT] = ACTIONS(8344),
    [anon_sym_LT_AMP] = ACTIONS(8344),
    [anon_sym_GT_AMP] = ACTIONS(8344),
    [anon_sym_LT_LT] = ACTIONS(8346),
    [anon_sym_LT_LT_DASH] = ACTIONS(8344),
    [anon_sym_LT_LT_LT] = ACTIONS(8344),
    [anon_sym_DOLLAR] = ACTIONS(8346),
    [sym__special_character] = ACTIONS(8344),
    [anon_sym_DQUOTE] = ACTIONS(8344),
    [sym_raw_string] = ACTIONS(8344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8344),
    [anon_sym_BQUOTE] = ACTIONS(8344),
    [anon_sym_LT_LPAREN] = ACTIONS(8344),
    [anon_sym_GT_LPAREN] = ACTIONS(8344),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8346),
    [sym_word] = ACTIONS(8346),
    [anon_sym_LF] = ACTIONS(8344),
    [anon_sym_AMP] = ACTIONS(8346),
  },
  [4390] = {
    [sym__simple_heredoc_body] = ACTIONS(8340),
    [sym__heredoc_body_beginning] = ACTIONS(8340),
    [sym_file_descriptor] = ACTIONS(8340),
    [sym__concat] = ACTIONS(8340),
    [anon_sym_SEMI] = ACTIONS(8342),
    [anon_sym_fi] = ACTIONS(8342),
    [anon_sym_PIPE] = ACTIONS(8342),
    [anon_sym_SEMI_SEMI] = ACTIONS(8340),
    [anon_sym_PIPE_AMP] = ACTIONS(8340),
    [anon_sym_AMP_AMP] = ACTIONS(8340),
    [anon_sym_PIPE_PIPE] = ACTIONS(8340),
    [anon_sym_LT] = ACTIONS(8342),
    [anon_sym_GT] = ACTIONS(8342),
    [anon_sym_GT_GT] = ACTIONS(8340),
    [anon_sym_AMP_GT] = ACTIONS(8342),
    [anon_sym_AMP_GT_GT] = ACTIONS(8340),
    [anon_sym_LT_AMP] = ACTIONS(8340),
    [anon_sym_GT_AMP] = ACTIONS(8340),
    [anon_sym_LT_LT] = ACTIONS(8342),
    [anon_sym_LT_LT_DASH] = ACTIONS(8340),
    [anon_sym_LT_LT_LT] = ACTIONS(8340),
    [anon_sym_DOLLAR] = ACTIONS(8342),
    [sym__special_character] = ACTIONS(8340),
    [anon_sym_DQUOTE] = ACTIONS(8340),
    [sym_raw_string] = ACTIONS(8340),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8340),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [anon_sym_LT_LPAREN] = ACTIONS(8340),
    [anon_sym_GT_LPAREN] = ACTIONS(8340),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8342),
    [sym_word] = ACTIONS(8342),
    [anon_sym_LF] = ACTIONS(8340),
    [anon_sym_AMP] = ACTIONS(8342),
  },
  [4391] = {
    [sym__simple_heredoc_body] = ACTIONS(8344),
    [sym__heredoc_body_beginning] = ACTIONS(8344),
    [sym_file_descriptor] = ACTIONS(8344),
    [sym__concat] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [anon_sym_fi] = ACTIONS(8346),
    [anon_sym_PIPE] = ACTIONS(8346),
    [anon_sym_SEMI_SEMI] = ACTIONS(8344),
    [anon_sym_PIPE_AMP] = ACTIONS(8344),
    [anon_sym_AMP_AMP] = ACTIONS(8344),
    [anon_sym_PIPE_PIPE] = ACTIONS(8344),
    [anon_sym_LT] = ACTIONS(8346),
    [anon_sym_GT] = ACTIONS(8346),
    [anon_sym_GT_GT] = ACTIONS(8344),
    [anon_sym_AMP_GT] = ACTIONS(8346),
    [anon_sym_AMP_GT_GT] = ACTIONS(8344),
    [anon_sym_LT_AMP] = ACTIONS(8344),
    [anon_sym_GT_AMP] = ACTIONS(8344),
    [anon_sym_LT_LT] = ACTIONS(8346),
    [anon_sym_LT_LT_DASH] = ACTIONS(8344),
    [anon_sym_LT_LT_LT] = ACTIONS(8344),
    [anon_sym_DOLLAR] = ACTIONS(8346),
    [sym__special_character] = ACTIONS(8344),
    [anon_sym_DQUOTE] = ACTIONS(8344),
    [sym_raw_string] = ACTIONS(8344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8344),
    [anon_sym_BQUOTE] = ACTIONS(8344),
    [anon_sym_LT_LPAREN] = ACTIONS(8344),
    [anon_sym_GT_LPAREN] = ACTIONS(8344),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8346),
    [sym_word] = ACTIONS(8346),
    [anon_sym_LF] = ACTIONS(8344),
    [anon_sym_AMP] = ACTIONS(8346),
  },
  [4392] = {
    [sym_string] = STATE(4164),
    [sym__simple_heredoc_body] = ACTIONS(4071),
    [sym__heredoc_body_beginning] = ACTIONS(4071),
    [sym_file_descriptor] = ACTIONS(4071),
    [sym_variable_name] = ACTIONS(4071),
    [anon_sym_SEMI] = ACTIONS(4073),
    [anon_sym_esac] = ACTIONS(4073),
    [anon_sym_PIPE] = ACTIONS(4073),
    [anon_sym_SEMI_SEMI] = ACTIONS(4071),
    [anon_sym_PIPE_AMP] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_PIPE_PIPE] = ACTIONS(4071),
    [anon_sym_LT] = ACTIONS(4073),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_GT_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT] = ACTIONS(4073),
    [anon_sym_AMP_GT_GT] = ACTIONS(4071),
    [anon_sym_LT_AMP] = ACTIONS(4071),
    [anon_sym_GT_AMP] = ACTIONS(4071),
    [anon_sym_LT_LT] = ACTIONS(4073),
    [anon_sym_LT_LT_DASH] = ACTIONS(4071),
    [anon_sym_LT_LT_LT] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(10118),
    [anon_sym_DOLLAR] = ACTIONS(10118),
    [sym__special_character] = ACTIONS(4071),
    [anon_sym_DQUOTE] = ACTIONS(8880),
    [sym_raw_string] = ACTIONS(9394),
    [anon_sym_POUND] = ACTIONS(9392),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4071),
    [anon_sym_BQUOTE] = ACTIONS(4071),
    [anon_sym_LT_LPAREN] = ACTIONS(4071),
    [anon_sym_GT_LPAREN] = ACTIONS(4071),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(9396),
    [anon_sym_STAR] = ACTIONS(9396),
    [anon_sym_AT] = ACTIONS(9396),
    [anon_sym_QMARK] = ACTIONS(9396),
    [anon_sym_0] = ACTIONS(9396),
    [anon_sym__] = ACTIONS(9396),
    [sym_word] = ACTIONS(4073),
    [anon_sym_LF] = ACTIONS(4071),
    [anon_sym_AMP] = ACTIONS(4073),
  },
  [4393] = {
    [sym__simple_heredoc_body] = ACTIONS(4111),
    [sym__heredoc_body_beginning] = ACTIONS(4111),
    [sym_file_descriptor] = ACTIONS(4111),
    [sym__concat] = ACTIONS(4111),
    [sym_variable_name] = ACTIONS(4111),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_esac] = ACTIONS(4113),
    [anon_sym_PIPE] = ACTIONS(4113),
    [anon_sym_SEMI_SEMI] = ACTIONS(4111),
    [anon_sym_PIPE_AMP] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_LT] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4113),
    [anon_sym_GT_GT] = ACTIONS(4111),
    [anon_sym_AMP_GT] = ACTIONS(4113),
    [anon_sym_AMP_GT_GT] = ACTIONS(4111),
    [anon_sym_LT_AMP] = ACTIONS(4111),
    [anon_sym_GT_AMP] = ACTIONS(4111),
    [anon_sym_LT_LT] = ACTIONS(4113),
    [anon_sym_LT_LT_DASH] = ACTIONS(4111),
    [anon_sym_LT_LT_LT] = ACTIONS(4111),
    [anon_sym_DOLLAR] = ACTIONS(4113),
    [sym__special_character] = ACTIONS(4111),
    [anon_sym_DQUOTE] = ACTIONS(4111),
    [sym_raw_string] = ACTIONS(4111),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4111),
    [anon_sym_BQUOTE] = ACTIONS(4111),
    [anon_sym_LT_LPAREN] = ACTIONS(4111),
    [anon_sym_GT_LPAREN] = ACTIONS(4111),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4113),
    [anon_sym_LF] = ACTIONS(4111),
    [anon_sym_AMP] = ACTIONS(4113),
  },
  [4394] = {
    [sym__simple_heredoc_body] = ACTIONS(4125),
    [sym__heredoc_body_beginning] = ACTIONS(4125),
    [sym_file_descriptor] = ACTIONS(4125),
    [sym__concat] = ACTIONS(4125),
    [sym_variable_name] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4127),
    [anon_sym_esac] = ACTIONS(4127),
    [anon_sym_PIPE] = ACTIONS(4127),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_PIPE_AMP] = ACTIONS(4125),
    [anon_sym_AMP_AMP] = ACTIONS(4125),
    [anon_sym_PIPE_PIPE] = ACTIONS(4125),
    [anon_sym_LT] = ACTIONS(4127),
    [anon_sym_GT] = ACTIONS(4127),
    [anon_sym_GT_GT] = ACTIONS(4125),
    [anon_sym_AMP_GT] = ACTIONS(4127),
    [anon_sym_AMP_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_AMP] = ACTIONS(4125),
    [anon_sym_GT_AMP] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4127),
    [anon_sym_LT_LT_DASH] = ACTIONS(4125),
    [anon_sym_LT_LT_LT] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(4127),
    [sym__special_character] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(4125),
    [sym_raw_string] = ACTIONS(4125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4125),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4125),
    [anon_sym_BQUOTE] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(4125),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
  },
  [4395] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(10120),
    [sym_comment] = ACTIONS(57),
  },
  [4396] = {
    [anon_sym_RBRACE] = ACTIONS(10120),
    [sym_comment] = ACTIONS(57),
  },
  [4397] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(10122),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [4398] = {
    [sym_concatenation] = STATE(4445),
    [sym_string] = STATE(4444),
    [sym_simple_expansion] = STATE(4444),
    [sym_string_expansion] = STATE(4444),
    [sym_expansion] = STATE(4444),
    [sym_command_substitution] = STATE(4444),
    [sym_process_substitution] = STATE(4444),
    [aux_sym__literal_repeat1] = STATE(4446),
    [anon_sym_RBRACE] = ACTIONS(10120),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [sym_raw_string] = ACTIONS(10124),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2438),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2444),
    [anon_sym_GT_LPAREN] = ACTIONS(2444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(10124),
  },
  [4399] = {
    [sym__simple_heredoc_body] = ACTIONS(4161),
    [sym__heredoc_body_beginning] = ACTIONS(4161),
    [sym_file_descriptor] = ACTIONS(4161),
    [sym__concat] = ACTIONS(4161),
    [sym_variable_name] = ACTIONS(4161),
    [anon_sym_SEMI] = ACTIONS(4163),
    [anon_sym_esac] = ACTIONS(4163),
    [anon_sym_PIPE] = ACTIONS(4163),
    [anon_sym_SEMI_SEMI] = ACTIONS(4161),
    [anon_sym_PIPE_AMP] = ACTIONS(4161),
    [anon_sym_AMP_AMP] = ACTIONS(4161),
    [anon_sym_PIPE_PIPE] = ACTIONS(4161),
    [anon_sym_LT] = ACTIONS(4163),
    [anon_sym_GT] = ACTIONS(4163),
    [anon_sym_GT_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT] = ACTIONS(4163),
    [anon_sym_AMP_GT_GT] = ACTIONS(4161),
    [anon_sym_LT_AMP] = ACTIONS(4161),
    [anon_sym_GT_AMP] = ACTIONS(4161),
    [anon_sym_LT_LT] = ACTIONS(4163),
    [anon_sym_LT_LT_DASH] = ACTIONS(4161),
    [anon_sym_LT_LT_LT] = ACTIONS(4161),
    [anon_sym_DOLLAR] = ACTIONS(4163),
    [sym__special_character] = ACTIONS(4161),
    [anon_sym_DQUOTE] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4161),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4161),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4161),
    [anon_sym_BQUOTE] = ACTIONS(4161),
    [anon_sym_LT_LPAREN] = ACTIONS(4161),
    [anon_sym_GT_LPAREN] = ACTIONS(4161),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4163),
    [anon_sym_LF] = ACTIONS(4161),
    [anon_sym_AMP] = ACTIONS(4163),
  },
  [4400] = {
    [sym_concatenation] = STATE(4449),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4449),
    [sym_regex] = ACTIONS(10126),
    [anon_sym_RBRACE] = ACTIONS(10128),
    [anon_sym_EQ] = ACTIONS(10130),
    [anon_sym_DASH] = ACTIONS(10130),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(10132),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(10130),
    [anon_sym_COLON_QMARK] = ACTIONS(10130),
    [anon_sym_COLON_DASH] = ACTIONS(10130),
    [anon_sym_PERCENT] = ACTIONS(10130),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4401] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(10128),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4402] = {
    [sym_concatenation] = STATE(4451),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4451),
    [sym_regex] = ACTIONS(10134),
    [anon_sym_RBRACE] = ACTIONS(10120),
    [anon_sym_EQ] = ACTIONS(10136),
    [anon_sym_DASH] = ACTIONS(10136),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(10138),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(10136),
    [anon_sym_COLON_QMARK] = ACTIONS(10136),
    [anon_sym_COLON_DASH] = ACTIONS(10136),
    [anon_sym_PERCENT] = ACTIONS(10136),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4403] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(10120),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4404] = {
    [sym_concatenation] = STATE(4453),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4453),
    [anon_sym_RBRACE] = ACTIONS(10140),
    [anon_sym_EQ] = ACTIONS(10142),
    [anon_sym_DASH] = ACTIONS(10142),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(10144),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(10142),
    [anon_sym_COLON_QMARK] = ACTIONS(10142),
    [anon_sym_COLON_DASH] = ACTIONS(10142),
    [anon_sym_PERCENT] = ACTIONS(10142),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4405] = {
    [sym__simple_heredoc_body] = ACTIONS(4219),
    [sym__heredoc_body_beginning] = ACTIONS(4219),
    [sym_file_descriptor] = ACTIONS(4219),
    [sym__concat] = ACTIONS(4219),
    [sym_variable_name] = ACTIONS(4219),
    [anon_sym_SEMI] = ACTIONS(4221),
    [anon_sym_esac] = ACTIONS(4221),
    [anon_sym_PIPE] = ACTIONS(4221),
    [anon_sym_SEMI_SEMI] = ACTIONS(4219),
    [anon_sym_PIPE_AMP] = ACTIONS(4219),
    [anon_sym_AMP_AMP] = ACTIONS(4219),
    [anon_sym_PIPE_PIPE] = ACTIONS(4219),
    [anon_sym_LT] = ACTIONS(4221),
    [anon_sym_GT] = ACTIONS(4221),
    [anon_sym_GT_GT] = ACTIONS(4219),
    [anon_sym_AMP_GT] = ACTIONS(4221),
    [anon_sym_AMP_GT_GT] = ACTIONS(4219),
    [anon_sym_LT_AMP] = ACTIONS(4219),
    [anon_sym_GT_AMP] = ACTIONS(4219),
    [anon_sym_LT_LT] = ACTIONS(4221),
    [anon_sym_LT_LT_DASH] = ACTIONS(4219),
    [anon_sym_LT_LT_LT] = ACTIONS(4219),
    [anon_sym_DOLLAR] = ACTIONS(4221),
    [sym__special_character] = ACTIONS(4219),
    [anon_sym_DQUOTE] = ACTIONS(4219),
    [sym_raw_string] = ACTIONS(4219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4219),
    [anon_sym_BQUOTE] = ACTIONS(4219),
    [anon_sym_LT_LPAREN] = ACTIONS(4219),
    [anon_sym_GT_LPAREN] = ACTIONS(4219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4221),
    [anon_sym_LF] = ACTIONS(4219),
    [anon_sym_AMP] = ACTIONS(4221),
  },
  [4406] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(10140),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4407] = {
    [sym_concatenation] = STATE(4451),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4451),
    [anon_sym_RBRACE] = ACTIONS(10120),
    [anon_sym_EQ] = ACTIONS(10136),
    [anon_sym_DASH] = ACTIONS(10136),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(10138),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(10136),
    [anon_sym_COLON_QMARK] = ACTIONS(10136),
    [anon_sym_COLON_DASH] = ACTIONS(10136),
    [anon_sym_PERCENT] = ACTIONS(10136),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4408] = {
    [sym__simple_heredoc_body] = ACTIONS(4449),
    [sym__heredoc_body_beginning] = ACTIONS(4449),
    [sym_file_descriptor] = ACTIONS(4449),
    [sym_variable_name] = ACTIONS(4449),
    [anon_sym_SEMI] = ACTIONS(4451),
    [anon_sym_esac] = ACTIONS(4451),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_SEMI_SEMI] = ACTIONS(4449),
    [anon_sym_PIPE_AMP] = ACTIONS(4449),
    [anon_sym_AMP_AMP] = ACTIONS(4449),
    [anon_sym_PIPE_PIPE] = ACTIONS(4449),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_GT_GT] = ACTIONS(4449),
    [anon_sym_AMP_GT] = ACTIONS(4451),
    [anon_sym_AMP_GT_GT] = ACTIONS(4449),
    [anon_sym_LT_AMP] = ACTIONS(4449),
    [anon_sym_GT_AMP] = ACTIONS(4449),
    [anon_sym_LT_LT] = ACTIONS(4451),
    [anon_sym_LT_LT_DASH] = ACTIONS(4449),
    [anon_sym_LT_LT_LT] = ACTIONS(4449),
    [anon_sym_DOLLAR] = ACTIONS(4451),
    [sym__special_character] = ACTIONS(4449),
    [anon_sym_DQUOTE] = ACTIONS(4449),
    [sym_raw_string] = ACTIONS(4449),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4449),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4449),
    [anon_sym_BQUOTE] = ACTIONS(4449),
    [anon_sym_LT_LPAREN] = ACTIONS(4449),
    [anon_sym_GT_LPAREN] = ACTIONS(4449),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4451),
    [sym_word] = ACTIONS(4451),
    [anon_sym_LF] = ACTIONS(4449),
    [anon_sym_AMP] = ACTIONS(4451),
  },
  [4409] = {
    [sym__simple_heredoc_body] = ACTIONS(5674),
    [sym__heredoc_body_beginning] = ACTIONS(5674),
    [sym_file_descriptor] = ACTIONS(5674),
    [sym__concat] = ACTIONS(5674),
    [sym_variable_name] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(5676),
    [anon_sym_esac] = ACTIONS(5676),
    [anon_sym_PIPE] = ACTIONS(5676),
    [anon_sym_SEMI_SEMI] = ACTIONS(5674),
    [anon_sym_PIPE_AMP] = ACTIONS(5674),
    [anon_sym_AMP_AMP] = ACTIONS(5674),
    [anon_sym_PIPE_PIPE] = ACTIONS(5674),
    [anon_sym_LT] = ACTIONS(5676),
    [anon_sym_GT] = ACTIONS(5676),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_AMP_GT] = ACTIONS(5676),
    [anon_sym_AMP_GT_GT] = ACTIONS(5674),
    [anon_sym_LT_AMP] = ACTIONS(5674),
    [anon_sym_GT_AMP] = ACTIONS(5674),
    [anon_sym_LT_LT] = ACTIONS(5676),
    [anon_sym_LT_LT_DASH] = ACTIONS(5674),
    [anon_sym_LT_LT_LT] = ACTIONS(5674),
    [anon_sym_DOLLAR] = ACTIONS(5676),
    [sym__special_character] = ACTIONS(5674),
    [anon_sym_DQUOTE] = ACTIONS(5674),
    [sym_raw_string] = ACTIONS(5674),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5674),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5674),
    [anon_sym_BQUOTE] = ACTIONS(5674),
    [anon_sym_LT_LPAREN] = ACTIONS(5674),
    [anon_sym_GT_LPAREN] = ACTIONS(5674),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5676),
    [sym_word] = ACTIONS(5676),
    [anon_sym_LF] = ACTIONS(5674),
    [anon_sym_AMP] = ACTIONS(5676),
  },
  [4410] = {
    [sym__simple_heredoc_body] = ACTIONS(5708),
    [sym__heredoc_body_beginning] = ACTIONS(5708),
    [sym_file_descriptor] = ACTIONS(5708),
    [sym__concat] = ACTIONS(5708),
    [sym_variable_name] = ACTIONS(5708),
    [anon_sym_SEMI] = ACTIONS(5710),
    [anon_sym_esac] = ACTIONS(5710),
    [anon_sym_PIPE] = ACTIONS(5710),
    [anon_sym_SEMI_SEMI] = ACTIONS(5708),
    [anon_sym_PIPE_AMP] = ACTIONS(5708),
    [anon_sym_AMP_AMP] = ACTIONS(5708),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_LT] = ACTIONS(5710),
    [anon_sym_GT] = ACTIONS(5710),
    [anon_sym_GT_GT] = ACTIONS(5708),
    [anon_sym_AMP_GT] = ACTIONS(5710),
    [anon_sym_AMP_GT_GT] = ACTIONS(5708),
    [anon_sym_LT_AMP] = ACTIONS(5708),
    [anon_sym_GT_AMP] = ACTIONS(5708),
    [anon_sym_LT_LT] = ACTIONS(5710),
    [anon_sym_LT_LT_DASH] = ACTIONS(5708),
    [anon_sym_LT_LT_LT] = ACTIONS(5708),
    [anon_sym_DOLLAR] = ACTIONS(5710),
    [sym__special_character] = ACTIONS(5708),
    [anon_sym_DQUOTE] = ACTIONS(5708),
    [sym_raw_string] = ACTIONS(5708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5708),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5708),
    [anon_sym_BQUOTE] = ACTIONS(5708),
    [anon_sym_LT_LPAREN] = ACTIONS(5708),
    [anon_sym_GT_LPAREN] = ACTIONS(5708),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5710),
    [sym_word] = ACTIONS(5710),
    [anon_sym_LF] = ACTIONS(5708),
    [anon_sym_AMP] = ACTIONS(5710),
  },
  [4411] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(10146),
    [sym_comment] = ACTIONS(57),
  },
  [4412] = {
    [anon_sym_RBRACE] = ACTIONS(10146),
    [sym_comment] = ACTIONS(57),
  },
  [4413] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(10148),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [4414] = {
    [sym_concatenation] = STATE(4457),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4457),
    [anon_sym_RBRACE] = ACTIONS(10150),
    [anon_sym_EQ] = ACTIONS(10152),
    [anon_sym_DASH] = ACTIONS(10152),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(10154),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(10152),
    [anon_sym_COLON_QMARK] = ACTIONS(10152),
    [anon_sym_COLON_DASH] = ACTIONS(10152),
    [anon_sym_PERCENT] = ACTIONS(10152),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4415] = {
    [sym__simple_heredoc_body] = ACTIONS(5725),
    [sym__heredoc_body_beginning] = ACTIONS(5725),
    [sym_file_descriptor] = ACTIONS(5725),
    [sym__concat] = ACTIONS(5725),
    [sym_variable_name] = ACTIONS(5725),
    [anon_sym_SEMI] = ACTIONS(5727),
    [anon_sym_esac] = ACTIONS(5727),
    [anon_sym_PIPE] = ACTIONS(5727),
    [anon_sym_SEMI_SEMI] = ACTIONS(5725),
    [anon_sym_PIPE_AMP] = ACTIONS(5725),
    [anon_sym_AMP_AMP] = ACTIONS(5725),
    [anon_sym_PIPE_PIPE] = ACTIONS(5725),
    [anon_sym_LT] = ACTIONS(5727),
    [anon_sym_GT] = ACTIONS(5727),
    [anon_sym_GT_GT] = ACTIONS(5725),
    [anon_sym_AMP_GT] = ACTIONS(5727),
    [anon_sym_AMP_GT_GT] = ACTIONS(5725),
    [anon_sym_LT_AMP] = ACTIONS(5725),
    [anon_sym_GT_AMP] = ACTIONS(5725),
    [anon_sym_LT_LT] = ACTIONS(5727),
    [anon_sym_LT_LT_DASH] = ACTIONS(5725),
    [anon_sym_LT_LT_LT] = ACTIONS(5725),
    [anon_sym_DOLLAR] = ACTIONS(5727),
    [sym__special_character] = ACTIONS(5725),
    [anon_sym_DQUOTE] = ACTIONS(5725),
    [sym_raw_string] = ACTIONS(5725),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5725),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5725),
    [anon_sym_BQUOTE] = ACTIONS(5725),
    [anon_sym_LT_LPAREN] = ACTIONS(5725),
    [anon_sym_GT_LPAREN] = ACTIONS(5725),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5727),
    [sym_word] = ACTIONS(5727),
    [anon_sym_LF] = ACTIONS(5725),
    [anon_sym_AMP] = ACTIONS(5727),
  },
  [4416] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(10150),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4417] = {
    [sym_concatenation] = STATE(4458),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4458),
    [anon_sym_RBRACE] = ACTIONS(10146),
    [anon_sym_EQ] = ACTIONS(10156),
    [anon_sym_DASH] = ACTIONS(10156),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(10158),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(10156),
    [anon_sym_COLON_QMARK] = ACTIONS(10156),
    [anon_sym_COLON_DASH] = ACTIONS(10156),
    [anon_sym_PERCENT] = ACTIONS(10156),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4418] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(10146),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4419] = {
    [sym__simple_heredoc_body] = ACTIONS(5770),
    [sym__heredoc_body_beginning] = ACTIONS(5770),
    [sym_file_descriptor] = ACTIONS(5770),
    [sym__concat] = ACTIONS(5770),
    [sym_variable_name] = ACTIONS(5770),
    [anon_sym_SEMI] = ACTIONS(5772),
    [anon_sym_esac] = ACTIONS(5772),
    [anon_sym_PIPE] = ACTIONS(5772),
    [anon_sym_SEMI_SEMI] = ACTIONS(5770),
    [anon_sym_PIPE_AMP] = ACTIONS(5770),
    [anon_sym_AMP_AMP] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5770),
    [anon_sym_LT] = ACTIONS(5772),
    [anon_sym_GT] = ACTIONS(5772),
    [anon_sym_GT_GT] = ACTIONS(5770),
    [anon_sym_AMP_GT] = ACTIONS(5772),
    [anon_sym_AMP_GT_GT] = ACTIONS(5770),
    [anon_sym_LT_AMP] = ACTIONS(5770),
    [anon_sym_GT_AMP] = ACTIONS(5770),
    [anon_sym_LT_LT] = ACTIONS(5772),
    [anon_sym_LT_LT_DASH] = ACTIONS(5770),
    [anon_sym_LT_LT_LT] = ACTIONS(5770),
    [anon_sym_DOLLAR] = ACTIONS(5772),
    [sym__special_character] = ACTIONS(5770),
    [anon_sym_DQUOTE] = ACTIONS(5770),
    [sym_raw_string] = ACTIONS(5770),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5770),
    [anon_sym_BQUOTE] = ACTIONS(5770),
    [anon_sym_LT_LPAREN] = ACTIONS(5770),
    [anon_sym_GT_LPAREN] = ACTIONS(5770),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5772),
    [sym_word] = ACTIONS(5772),
    [anon_sym_LF] = ACTIONS(5770),
    [anon_sym_AMP] = ACTIONS(5772),
  },
  [4420] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(10160),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4421] = {
    [sym__simple_heredoc_body] = ACTIONS(5674),
    [sym__heredoc_body_beginning] = ACTIONS(5674),
    [sym_file_descriptor] = ACTIONS(5674),
    [sym__concat] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(5676),
    [anon_sym_esac] = ACTIONS(5676),
    [anon_sym_PIPE] = ACTIONS(5676),
    [anon_sym_SEMI_SEMI] = ACTIONS(5674),
    [anon_sym_PIPE_AMP] = ACTIONS(5674),
    [anon_sym_AMP_AMP] = ACTIONS(5674),
    [anon_sym_PIPE_PIPE] = ACTIONS(5674),
    [anon_sym_LT] = ACTIONS(5676),
    [anon_sym_GT] = ACTIONS(5676),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_AMP_GT] = ACTIONS(5676),
    [anon_sym_AMP_GT_GT] = ACTIONS(5674),
    [anon_sym_LT_AMP] = ACTIONS(5674),
    [anon_sym_GT_AMP] = ACTIONS(5674),
    [anon_sym_LT_LT] = ACTIONS(5676),
    [anon_sym_LT_LT_DASH] = ACTIONS(5674),
    [anon_sym_LT_LT_LT] = ACTIONS(5674),
    [anon_sym_DOLLAR] = ACTIONS(5676),
    [sym__special_character] = ACTIONS(5674),
    [anon_sym_DQUOTE] = ACTIONS(5674),
    [sym_raw_string] = ACTIONS(5674),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5674),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5674),
    [anon_sym_BQUOTE] = ACTIONS(5674),
    [anon_sym_LT_LPAREN] = ACTIONS(5674),
    [anon_sym_GT_LPAREN] = ACTIONS(5674),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5676),
    [sym_word] = ACTIONS(5676),
    [anon_sym_LF] = ACTIONS(5674),
    [anon_sym_AMP] = ACTIONS(5676),
  },
  [4422] = {
    [sym__simple_heredoc_body] = ACTIONS(5708),
    [sym__heredoc_body_beginning] = ACTIONS(5708),
    [sym_file_descriptor] = ACTIONS(5708),
    [sym__concat] = ACTIONS(5708),
    [anon_sym_SEMI] = ACTIONS(5710),
    [anon_sym_esac] = ACTIONS(5710),
    [anon_sym_PIPE] = ACTIONS(5710),
    [anon_sym_SEMI_SEMI] = ACTIONS(5708),
    [anon_sym_PIPE_AMP] = ACTIONS(5708),
    [anon_sym_AMP_AMP] = ACTIONS(5708),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_LT] = ACTIONS(5710),
    [anon_sym_GT] = ACTIONS(5710),
    [anon_sym_GT_GT] = ACTIONS(5708),
    [anon_sym_AMP_GT] = ACTIONS(5710),
    [anon_sym_AMP_GT_GT] = ACTIONS(5708),
    [anon_sym_LT_AMP] = ACTIONS(5708),
    [anon_sym_GT_AMP] = ACTIONS(5708),
    [anon_sym_LT_LT] = ACTIONS(5710),
    [anon_sym_LT_LT_DASH] = ACTIONS(5708),
    [anon_sym_LT_LT_LT] = ACTIONS(5708),
    [anon_sym_DOLLAR] = ACTIONS(5710),
    [sym__special_character] = ACTIONS(5708),
    [anon_sym_DQUOTE] = ACTIONS(5708),
    [sym_raw_string] = ACTIONS(5708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5708),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5708),
    [anon_sym_BQUOTE] = ACTIONS(5708),
    [anon_sym_LT_LPAREN] = ACTIONS(5708),
    [anon_sym_GT_LPAREN] = ACTIONS(5708),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5710),
    [sym_word] = ACTIONS(5710),
    [anon_sym_LF] = ACTIONS(5708),
    [anon_sym_AMP] = ACTIONS(5710),
  },
  [4423] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(10162),
    [sym_comment] = ACTIONS(57),
  },
  [4424] = {
    [anon_sym_RBRACE] = ACTIONS(10162),
    [sym_comment] = ACTIONS(57),
  },
  [4425] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(10164),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [4426] = {
    [sym_concatenation] = STATE(4463),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4463),
    [anon_sym_RBRACE] = ACTIONS(10166),
    [anon_sym_EQ] = ACTIONS(10168),
    [anon_sym_DASH] = ACTIONS(10168),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(10170),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(10168),
    [anon_sym_COLON_QMARK] = ACTIONS(10168),
    [anon_sym_COLON_DASH] = ACTIONS(10168),
    [anon_sym_PERCENT] = ACTIONS(10168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4427] = {
    [sym__simple_heredoc_body] = ACTIONS(5725),
    [sym__heredoc_body_beginning] = ACTIONS(5725),
    [sym_file_descriptor] = ACTIONS(5725),
    [sym__concat] = ACTIONS(5725),
    [anon_sym_SEMI] = ACTIONS(5727),
    [anon_sym_esac] = ACTIONS(5727),
    [anon_sym_PIPE] = ACTIONS(5727),
    [anon_sym_SEMI_SEMI] = ACTIONS(5725),
    [anon_sym_PIPE_AMP] = ACTIONS(5725),
    [anon_sym_AMP_AMP] = ACTIONS(5725),
    [anon_sym_PIPE_PIPE] = ACTIONS(5725),
    [anon_sym_LT] = ACTIONS(5727),
    [anon_sym_GT] = ACTIONS(5727),
    [anon_sym_GT_GT] = ACTIONS(5725),
    [anon_sym_AMP_GT] = ACTIONS(5727),
    [anon_sym_AMP_GT_GT] = ACTIONS(5725),
    [anon_sym_LT_AMP] = ACTIONS(5725),
    [anon_sym_GT_AMP] = ACTIONS(5725),
    [anon_sym_LT_LT] = ACTIONS(5727),
    [anon_sym_LT_LT_DASH] = ACTIONS(5725),
    [anon_sym_LT_LT_LT] = ACTIONS(5725),
    [anon_sym_DOLLAR] = ACTIONS(5727),
    [sym__special_character] = ACTIONS(5725),
    [anon_sym_DQUOTE] = ACTIONS(5725),
    [sym_raw_string] = ACTIONS(5725),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5725),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5725),
    [anon_sym_BQUOTE] = ACTIONS(5725),
    [anon_sym_LT_LPAREN] = ACTIONS(5725),
    [anon_sym_GT_LPAREN] = ACTIONS(5725),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5727),
    [sym_word] = ACTIONS(5727),
    [anon_sym_LF] = ACTIONS(5725),
    [anon_sym_AMP] = ACTIONS(5727),
  },
  [4428] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(10166),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4429] = {
    [sym_concatenation] = STATE(4464),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4464),
    [anon_sym_RBRACE] = ACTIONS(10162),
    [anon_sym_EQ] = ACTIONS(10172),
    [anon_sym_DASH] = ACTIONS(10172),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(10174),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(10172),
    [anon_sym_COLON_QMARK] = ACTIONS(10172),
    [anon_sym_COLON_DASH] = ACTIONS(10172),
    [anon_sym_PERCENT] = ACTIONS(10172),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4430] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(10162),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4431] = {
    [sym__simple_heredoc_body] = ACTIONS(5770),
    [sym__heredoc_body_beginning] = ACTIONS(5770),
    [sym_file_descriptor] = ACTIONS(5770),
    [sym__concat] = ACTIONS(5770),
    [anon_sym_SEMI] = ACTIONS(5772),
    [anon_sym_esac] = ACTIONS(5772),
    [anon_sym_PIPE] = ACTIONS(5772),
    [anon_sym_SEMI_SEMI] = ACTIONS(5770),
    [anon_sym_PIPE_AMP] = ACTIONS(5770),
    [anon_sym_AMP_AMP] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5770),
    [anon_sym_LT] = ACTIONS(5772),
    [anon_sym_GT] = ACTIONS(5772),
    [anon_sym_GT_GT] = ACTIONS(5770),
    [anon_sym_AMP_GT] = ACTIONS(5772),
    [anon_sym_AMP_GT_GT] = ACTIONS(5770),
    [anon_sym_LT_AMP] = ACTIONS(5770),
    [anon_sym_GT_AMP] = ACTIONS(5770),
    [anon_sym_LT_LT] = ACTIONS(5772),
    [anon_sym_LT_LT_DASH] = ACTIONS(5770),
    [anon_sym_LT_LT_LT] = ACTIONS(5770),
    [anon_sym_DOLLAR] = ACTIONS(5772),
    [sym__special_character] = ACTIONS(5770),
    [anon_sym_DQUOTE] = ACTIONS(5770),
    [sym_raw_string] = ACTIONS(5770),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5770),
    [anon_sym_BQUOTE] = ACTIONS(5770),
    [anon_sym_LT_LPAREN] = ACTIONS(5770),
    [anon_sym_GT_LPAREN] = ACTIONS(5770),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5772),
    [sym_word] = ACTIONS(5772),
    [anon_sym_LF] = ACTIONS(5770),
    [anon_sym_AMP] = ACTIONS(5772),
  },
  [4432] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(10176),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4433] = {
    [sym__simple_heredoc_body] = ACTIONS(7198),
    [sym__heredoc_body_beginning] = ACTIONS(7198),
    [sym_file_descriptor] = ACTIONS(7198),
    [sym__concat] = ACTIONS(7198),
    [anon_sym_SEMI] = ACTIONS(7200),
    [anon_sym_esac] = ACTIONS(7200),
    [anon_sym_PIPE] = ACTIONS(7200),
    [anon_sym_SEMI_SEMI] = ACTIONS(7198),
    [anon_sym_PIPE_AMP] = ACTIONS(7198),
    [anon_sym_AMP_AMP] = ACTIONS(7198),
    [anon_sym_PIPE_PIPE] = ACTIONS(7198),
    [anon_sym_EQ_TILDE] = ACTIONS(7200),
    [anon_sym_EQ_EQ] = ACTIONS(7200),
    [anon_sym_LT] = ACTIONS(7200),
    [anon_sym_GT] = ACTIONS(7200),
    [anon_sym_GT_GT] = ACTIONS(7198),
    [anon_sym_AMP_GT] = ACTIONS(7200),
    [anon_sym_AMP_GT_GT] = ACTIONS(7198),
    [anon_sym_LT_AMP] = ACTIONS(7198),
    [anon_sym_GT_AMP] = ACTIONS(7198),
    [anon_sym_LT_LT] = ACTIONS(7200),
    [anon_sym_LT_LT_DASH] = ACTIONS(7198),
    [anon_sym_LT_LT_LT] = ACTIONS(7198),
    [anon_sym_DOLLAR] = ACTIONS(7200),
    [sym__special_character] = ACTIONS(7198),
    [anon_sym_DQUOTE] = ACTIONS(7198),
    [sym_raw_string] = ACTIONS(7198),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7198),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7198),
    [anon_sym_BQUOTE] = ACTIONS(7198),
    [anon_sym_LT_LPAREN] = ACTIONS(7198),
    [anon_sym_GT_LPAREN] = ACTIONS(7198),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7200),
    [anon_sym_LF] = ACTIONS(7198),
    [anon_sym_AMP] = ACTIONS(7200),
  },
  [4434] = {
    [sym__simple_heredoc_body] = ACTIONS(7202),
    [sym__heredoc_body_beginning] = ACTIONS(7202),
    [sym_file_descriptor] = ACTIONS(7202),
    [sym__concat] = ACTIONS(7202),
    [anon_sym_SEMI] = ACTIONS(7204),
    [anon_sym_esac] = ACTIONS(7204),
    [anon_sym_PIPE] = ACTIONS(7204),
    [anon_sym_SEMI_SEMI] = ACTIONS(7202),
    [anon_sym_PIPE_AMP] = ACTIONS(7202),
    [anon_sym_AMP_AMP] = ACTIONS(7202),
    [anon_sym_PIPE_PIPE] = ACTIONS(7202),
    [anon_sym_EQ_TILDE] = ACTIONS(7204),
    [anon_sym_EQ_EQ] = ACTIONS(7204),
    [anon_sym_LT] = ACTIONS(7204),
    [anon_sym_GT] = ACTIONS(7204),
    [anon_sym_GT_GT] = ACTIONS(7202),
    [anon_sym_AMP_GT] = ACTIONS(7204),
    [anon_sym_AMP_GT_GT] = ACTIONS(7202),
    [anon_sym_LT_AMP] = ACTIONS(7202),
    [anon_sym_GT_AMP] = ACTIONS(7202),
    [anon_sym_LT_LT] = ACTIONS(7204),
    [anon_sym_LT_LT_DASH] = ACTIONS(7202),
    [anon_sym_LT_LT_LT] = ACTIONS(7202),
    [anon_sym_DOLLAR] = ACTIONS(7204),
    [sym__special_character] = ACTIONS(7202),
    [anon_sym_DQUOTE] = ACTIONS(7202),
    [sym_raw_string] = ACTIONS(7202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7202),
    [anon_sym_BQUOTE] = ACTIONS(7202),
    [anon_sym_LT_LPAREN] = ACTIONS(7202),
    [anon_sym_GT_LPAREN] = ACTIONS(7202),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7204),
    [anon_sym_LF] = ACTIONS(7202),
    [anon_sym_AMP] = ACTIONS(7204),
  },
  [4435] = {
    [sym__simple_heredoc_body] = ACTIONS(7206),
    [sym__heredoc_body_beginning] = ACTIONS(7206),
    [sym_file_descriptor] = ACTIONS(7206),
    [sym__concat] = ACTIONS(7206),
    [anon_sym_SEMI] = ACTIONS(7208),
    [anon_sym_esac] = ACTIONS(7208),
    [anon_sym_PIPE] = ACTIONS(7208),
    [anon_sym_SEMI_SEMI] = ACTIONS(7206),
    [anon_sym_PIPE_AMP] = ACTIONS(7206),
    [anon_sym_AMP_AMP] = ACTIONS(7206),
    [anon_sym_PIPE_PIPE] = ACTIONS(7206),
    [anon_sym_EQ_TILDE] = ACTIONS(7208),
    [anon_sym_EQ_EQ] = ACTIONS(7208),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7206),
    [anon_sym_AMP_GT] = ACTIONS(7208),
    [anon_sym_AMP_GT_GT] = ACTIONS(7206),
    [anon_sym_LT_AMP] = ACTIONS(7206),
    [anon_sym_GT_AMP] = ACTIONS(7206),
    [anon_sym_LT_LT] = ACTIONS(7208),
    [anon_sym_LT_LT_DASH] = ACTIONS(7206),
    [anon_sym_LT_LT_LT] = ACTIONS(7206),
    [anon_sym_DOLLAR] = ACTIONS(7208),
    [sym__special_character] = ACTIONS(7206),
    [anon_sym_DQUOTE] = ACTIONS(7206),
    [sym_raw_string] = ACTIONS(7206),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7206),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7206),
    [anon_sym_BQUOTE] = ACTIONS(7206),
    [anon_sym_LT_LPAREN] = ACTIONS(7206),
    [anon_sym_GT_LPAREN] = ACTIONS(7206),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7208),
    [anon_sym_LF] = ACTIONS(7206),
    [anon_sym_AMP] = ACTIONS(7208),
  },
  [4436] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(10178),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4437] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(10180),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4438] = {
    [sym__simple_heredoc_body] = ACTIONS(7242),
    [sym__heredoc_body_beginning] = ACTIONS(7242),
    [sym_file_descriptor] = ACTIONS(7242),
    [sym__concat] = ACTIONS(7242),
    [anon_sym_SEMI] = ACTIONS(7244),
    [anon_sym_esac] = ACTIONS(7244),
    [anon_sym_PIPE] = ACTIONS(7244),
    [anon_sym_SEMI_SEMI] = ACTIONS(7242),
    [anon_sym_PIPE_AMP] = ACTIONS(7242),
    [anon_sym_AMP_AMP] = ACTIONS(7242),
    [anon_sym_PIPE_PIPE] = ACTIONS(7242),
    [anon_sym_EQ_TILDE] = ACTIONS(7244),
    [anon_sym_EQ_EQ] = ACTIONS(7244),
    [anon_sym_LT] = ACTIONS(7244),
    [anon_sym_GT] = ACTIONS(7244),
    [anon_sym_GT_GT] = ACTIONS(7242),
    [anon_sym_AMP_GT] = ACTIONS(7244),
    [anon_sym_AMP_GT_GT] = ACTIONS(7242),
    [anon_sym_LT_AMP] = ACTIONS(7242),
    [anon_sym_GT_AMP] = ACTIONS(7242),
    [anon_sym_LT_LT] = ACTIONS(7244),
    [anon_sym_LT_LT_DASH] = ACTIONS(7242),
    [anon_sym_LT_LT_LT] = ACTIONS(7242),
    [anon_sym_DOLLAR] = ACTIONS(7244),
    [sym__special_character] = ACTIONS(7242),
    [anon_sym_DQUOTE] = ACTIONS(7242),
    [sym_raw_string] = ACTIONS(7242),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7242),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7242),
    [anon_sym_BQUOTE] = ACTIONS(7242),
    [anon_sym_LT_LPAREN] = ACTIONS(7242),
    [anon_sym_GT_LPAREN] = ACTIONS(7242),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7244),
    [anon_sym_LF] = ACTIONS(7242),
    [anon_sym_AMP] = ACTIONS(7244),
  },
  [4439] = {
    [sym_string] = STATE(2891),
    [sym__simple_heredoc_body] = ACTIONS(4071),
    [sym__heredoc_body_beginning] = ACTIONS(4071),
    [sym_file_descriptor] = ACTIONS(4071),
    [anon_sym_SEMI] = ACTIONS(4073),
    [anon_sym_esac] = ACTIONS(4073),
    [anon_sym_PIPE] = ACTIONS(4073),
    [anon_sym_SEMI_SEMI] = ACTIONS(4071),
    [anon_sym_PIPE_AMP] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_PIPE_PIPE] = ACTIONS(4071),
    [anon_sym_LT] = ACTIONS(4073),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_GT_GT] = ACTIONS(4071),
    [anon_sym_AMP_GT] = ACTIONS(4073),
    [anon_sym_AMP_GT_GT] = ACTIONS(4071),
    [anon_sym_LT_AMP] = ACTIONS(4071),
    [anon_sym_GT_AMP] = ACTIONS(4071),
    [anon_sym_LT_LT] = ACTIONS(4073),
    [anon_sym_LT_LT_DASH] = ACTIONS(4071),
    [anon_sym_LT_LT_LT] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(6359),
    [anon_sym_DOLLAR] = ACTIONS(6359),
    [anon_sym_DQUOTE] = ACTIONS(5002),
    [sym_raw_string] = ACTIONS(6361),
    [anon_sym_POUND] = ACTIONS(6359),
    [sym_comment] = ACTIONS(329),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6363),
    [anon_sym_STAR] = ACTIONS(6365),
    [anon_sym_AT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6365),
    [anon_sym_0] = ACTIONS(6363),
    [anon_sym__] = ACTIONS(6363),
    [anon_sym_LF] = ACTIONS(4071),
    [anon_sym_AMP] = ACTIONS(4073),
  },
  [4440] = {
    [sym__simple_heredoc_body] = ACTIONS(8340),
    [sym__heredoc_body_beginning] = ACTIONS(8340),
    [sym_file_descriptor] = ACTIONS(8340),
    [sym__concat] = ACTIONS(8340),
    [sym_variable_name] = ACTIONS(8340),
    [anon_sym_SEMI] = ACTIONS(8342),
    [anon_sym_fi] = ACTIONS(8342),
    [anon_sym_PIPE] = ACTIONS(8342),
    [anon_sym_SEMI_SEMI] = ACTIONS(8340),
    [anon_sym_PIPE_AMP] = ACTIONS(8340),
    [anon_sym_AMP_AMP] = ACTIONS(8340),
    [anon_sym_PIPE_PIPE] = ACTIONS(8340),
    [anon_sym_LT] = ACTIONS(8342),
    [anon_sym_GT] = ACTIONS(8342),
    [anon_sym_GT_GT] = ACTIONS(8340),
    [anon_sym_AMP_GT] = ACTIONS(8342),
    [anon_sym_AMP_GT_GT] = ACTIONS(8340),
    [anon_sym_LT_AMP] = ACTIONS(8340),
    [anon_sym_GT_AMP] = ACTIONS(8340),
    [anon_sym_LT_LT] = ACTIONS(8342),
    [anon_sym_LT_LT_DASH] = ACTIONS(8340),
    [anon_sym_LT_LT_LT] = ACTIONS(8340),
    [anon_sym_DOLLAR] = ACTIONS(8342),
    [sym__special_character] = ACTIONS(8340),
    [anon_sym_DQUOTE] = ACTIONS(8340),
    [sym_raw_string] = ACTIONS(8340),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8340),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [anon_sym_LT_LPAREN] = ACTIONS(8340),
    [anon_sym_GT_LPAREN] = ACTIONS(8340),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8342),
    [anon_sym_LF] = ACTIONS(8340),
    [anon_sym_AMP] = ACTIONS(8342),
  },
  [4441] = {
    [sym__simple_heredoc_body] = ACTIONS(8344),
    [sym__heredoc_body_beginning] = ACTIONS(8344),
    [sym_file_descriptor] = ACTIONS(8344),
    [sym__concat] = ACTIONS(8344),
    [sym_variable_name] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [anon_sym_fi] = ACTIONS(8346),
    [anon_sym_PIPE] = ACTIONS(8346),
    [anon_sym_SEMI_SEMI] = ACTIONS(8344),
    [anon_sym_PIPE_AMP] = ACTIONS(8344),
    [anon_sym_AMP_AMP] = ACTIONS(8344),
    [anon_sym_PIPE_PIPE] = ACTIONS(8344),
    [anon_sym_LT] = ACTIONS(8346),
    [anon_sym_GT] = ACTIONS(8346),
    [anon_sym_GT_GT] = ACTIONS(8344),
    [anon_sym_AMP_GT] = ACTIONS(8346),
    [anon_sym_AMP_GT_GT] = ACTIONS(8344),
    [anon_sym_LT_AMP] = ACTIONS(8344),
    [anon_sym_GT_AMP] = ACTIONS(8344),
    [anon_sym_LT_LT] = ACTIONS(8346),
    [anon_sym_LT_LT_DASH] = ACTIONS(8344),
    [anon_sym_LT_LT_LT] = ACTIONS(8344),
    [anon_sym_DOLLAR] = ACTIONS(8346),
    [sym__special_character] = ACTIONS(8344),
    [anon_sym_DQUOTE] = ACTIONS(8344),
    [sym_raw_string] = ACTIONS(8344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8344),
    [anon_sym_BQUOTE] = ACTIONS(8344),
    [anon_sym_LT_LPAREN] = ACTIONS(8344),
    [anon_sym_GT_LPAREN] = ACTIONS(8344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8346),
    [anon_sym_LF] = ACTIONS(8344),
    [anon_sym_AMP] = ACTIONS(8346),
  },
  [4442] = {
    [sym__simple_heredoc_body] = ACTIONS(5674),
    [sym__heredoc_body_beginning] = ACTIONS(5674),
    [sym_file_descriptor] = ACTIONS(5674),
    [sym__concat] = ACTIONS(5674),
    [sym_variable_name] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(5676),
    [anon_sym_esac] = ACTIONS(5676),
    [anon_sym_PIPE] = ACTIONS(5676),
    [anon_sym_SEMI_SEMI] = ACTIONS(5674),
    [anon_sym_PIPE_AMP] = ACTIONS(5674),
    [anon_sym_AMP_AMP] = ACTIONS(5674),
    [anon_sym_PIPE_PIPE] = ACTIONS(5674),
    [anon_sym_LT] = ACTIONS(5676),
    [anon_sym_GT] = ACTIONS(5676),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_AMP_GT] = ACTIONS(5676),
    [anon_sym_AMP_GT_GT] = ACTIONS(5674),
    [anon_sym_LT_AMP] = ACTIONS(5674),
    [anon_sym_GT_AMP] = ACTIONS(5674),
    [anon_sym_LT_LT] = ACTIONS(5676),
    [anon_sym_LT_LT_DASH] = ACTIONS(5674),
    [anon_sym_LT_LT_LT] = ACTIONS(5674),
    [anon_sym_DOLLAR] = ACTIONS(5676),
    [sym__special_character] = ACTIONS(5674),
    [anon_sym_DQUOTE] = ACTIONS(5674),
    [sym_raw_string] = ACTIONS(5674),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5674),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5674),
    [anon_sym_BQUOTE] = ACTIONS(5674),
    [anon_sym_LT_LPAREN] = ACTIONS(5674),
    [anon_sym_GT_LPAREN] = ACTIONS(5674),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5676),
    [anon_sym_LF] = ACTIONS(5674),
    [anon_sym_AMP] = ACTIONS(5676),
  },
  [4443] = {
    [sym__simple_heredoc_body] = ACTIONS(5708),
    [sym__heredoc_body_beginning] = ACTIONS(5708),
    [sym_file_descriptor] = ACTIONS(5708),
    [sym__concat] = ACTIONS(5708),
    [sym_variable_name] = ACTIONS(5708),
    [anon_sym_SEMI] = ACTIONS(5710),
    [anon_sym_esac] = ACTIONS(5710),
    [anon_sym_PIPE] = ACTIONS(5710),
    [anon_sym_SEMI_SEMI] = ACTIONS(5708),
    [anon_sym_PIPE_AMP] = ACTIONS(5708),
    [anon_sym_AMP_AMP] = ACTIONS(5708),
    [anon_sym_PIPE_PIPE] = ACTIONS(5708),
    [anon_sym_LT] = ACTIONS(5710),
    [anon_sym_GT] = ACTIONS(5710),
    [anon_sym_GT_GT] = ACTIONS(5708),
    [anon_sym_AMP_GT] = ACTIONS(5710),
    [anon_sym_AMP_GT_GT] = ACTIONS(5708),
    [anon_sym_LT_AMP] = ACTIONS(5708),
    [anon_sym_GT_AMP] = ACTIONS(5708),
    [anon_sym_LT_LT] = ACTIONS(5710),
    [anon_sym_LT_LT_DASH] = ACTIONS(5708),
    [anon_sym_LT_LT_LT] = ACTIONS(5708),
    [anon_sym_DOLLAR] = ACTIONS(5710),
    [sym__special_character] = ACTIONS(5708),
    [anon_sym_DQUOTE] = ACTIONS(5708),
    [sym_raw_string] = ACTIONS(5708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5708),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5708),
    [anon_sym_BQUOTE] = ACTIONS(5708),
    [anon_sym_LT_LPAREN] = ACTIONS(5708),
    [anon_sym_GT_LPAREN] = ACTIONS(5708),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5710),
    [anon_sym_LF] = ACTIONS(5708),
    [anon_sym_AMP] = ACTIONS(5710),
  },
  [4444] = {
    [aux_sym_concatenation_repeat1] = STATE(1932),
    [sym__concat] = ACTIONS(4137),
    [anon_sym_RBRACE] = ACTIONS(10182),
    [sym_comment] = ACTIONS(57),
  },
  [4445] = {
    [anon_sym_RBRACE] = ACTIONS(10182),
    [sym_comment] = ACTIONS(57),
  },
  [4446] = {
    [aux_sym__literal_repeat1] = STATE(1947),
    [anon_sym_RBRACE] = ACTIONS(10184),
    [sym__special_character] = ACTIONS(4157),
    [sym_comment] = ACTIONS(57),
  },
  [4447] = {
    [sym_concatenation] = STATE(4471),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4471),
    [anon_sym_RBRACE] = ACTIONS(10186),
    [anon_sym_EQ] = ACTIONS(10188),
    [anon_sym_DASH] = ACTIONS(10188),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(10190),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(10188),
    [anon_sym_COLON_QMARK] = ACTIONS(10188),
    [anon_sym_COLON_DASH] = ACTIONS(10188),
    [anon_sym_PERCENT] = ACTIONS(10188),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4448] = {
    [sym__simple_heredoc_body] = ACTIONS(5725),
    [sym__heredoc_body_beginning] = ACTIONS(5725),
    [sym_file_descriptor] = ACTIONS(5725),
    [sym__concat] = ACTIONS(5725),
    [sym_variable_name] = ACTIONS(5725),
    [anon_sym_SEMI] = ACTIONS(5727),
    [anon_sym_esac] = ACTIONS(5727),
    [anon_sym_PIPE] = ACTIONS(5727),
    [anon_sym_SEMI_SEMI] = ACTIONS(5725),
    [anon_sym_PIPE_AMP] = ACTIONS(5725),
    [anon_sym_AMP_AMP] = ACTIONS(5725),
    [anon_sym_PIPE_PIPE] = ACTIONS(5725),
    [anon_sym_LT] = ACTIONS(5727),
    [anon_sym_GT] = ACTIONS(5727),
    [anon_sym_GT_GT] = ACTIONS(5725),
    [anon_sym_AMP_GT] = ACTIONS(5727),
    [anon_sym_AMP_GT_GT] = ACTIONS(5725),
    [anon_sym_LT_AMP] = ACTIONS(5725),
    [anon_sym_GT_AMP] = ACTIONS(5725),
    [anon_sym_LT_LT] = ACTIONS(5727),
    [anon_sym_LT_LT_DASH] = ACTIONS(5725),
    [anon_sym_LT_LT_LT] = ACTIONS(5725),
    [anon_sym_DOLLAR] = ACTIONS(5727),
    [sym__special_character] = ACTIONS(5725),
    [anon_sym_DQUOTE] = ACTIONS(5725),
    [sym_raw_string] = ACTIONS(5725),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5725),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5725),
    [anon_sym_BQUOTE] = ACTIONS(5725),
    [anon_sym_LT_LPAREN] = ACTIONS(5725),
    [anon_sym_GT_LPAREN] = ACTIONS(5725),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5727),
    [anon_sym_LF] = ACTIONS(5725),
    [anon_sym_AMP] = ACTIONS(5727),
  },
  [4449] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(10186),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4450] = {
    [sym_concatenation] = STATE(4472),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(4472),
    [anon_sym_RBRACE] = ACTIONS(10182),
    [anon_sym_EQ] = ACTIONS(10192),
    [anon_sym_DASH] = ACTIONS(10192),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(10194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(10192),
    [anon_sym_COLON_QMARK] = ACTIONS(10192),
    [anon_sym_COLON_DASH] = ACTIONS(10192),
    [anon_sym_PERCENT] = ACTIONS(10192),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4451] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(10182),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4452] = {
    [sym__simple_heredoc_body] = ACTIONS(5770),
    [sym__heredoc_body_beginning] = ACTIONS(5770),
    [sym_file_descriptor] = ACTIONS(5770),
    [sym__concat] = ACTIONS(5770),
    [sym_variable_name] = ACTIONS(5770),
    [anon_sym_SEMI] = ACTIONS(5772),
    [anon_sym_esac] = ACTIONS(5772),
    [anon_sym_PIPE] = ACTIONS(5772),
    [anon_sym_SEMI_SEMI] = ACTIONS(5770),
    [anon_sym_PIPE_AMP] = ACTIONS(5770),
    [anon_sym_AMP_AMP] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5770),
    [anon_sym_LT] = ACTIONS(5772),
    [anon_sym_GT] = ACTIONS(5772),
    [anon_sym_GT_GT] = ACTIONS(5770),
    [anon_sym_AMP_GT] = ACTIONS(5772),
    [anon_sym_AMP_GT_GT] = ACTIONS(5770),
    [anon_sym_LT_AMP] = ACTIONS(5770),
    [anon_sym_GT_AMP] = ACTIONS(5770),
    [anon_sym_LT_LT] = ACTIONS(5772),
    [anon_sym_LT_LT_DASH] = ACTIONS(5770),
    [anon_sym_LT_LT_LT] = ACTIONS(5770),
    [anon_sym_DOLLAR] = ACTIONS(5772),
    [sym__special_character] = ACTIONS(5770),
    [anon_sym_DQUOTE] = ACTIONS(5770),
    [sym_raw_string] = ACTIONS(5770),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5770),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5770),
    [anon_sym_BQUOTE] = ACTIONS(5770),
    [anon_sym_LT_LPAREN] = ACTIONS(5770),
    [anon_sym_GT_LPAREN] = ACTIONS(5770),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5772),
    [anon_sym_LF] = ACTIONS(5770),
    [anon_sym_AMP] = ACTIONS(5772),
  },
  [4453] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(10196),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4454] = {
    [sym__simple_heredoc_body] = ACTIONS(7198),
    [sym__heredoc_body_beginning] = ACTIONS(7198),
    [sym_file_descriptor] = ACTIONS(7198),
    [sym__concat] = ACTIONS(7198),
    [sym_variable_name] = ACTIONS(7198),
    [anon_sym_SEMI] = ACTIONS(7200),
    [anon_sym_esac] = ACTIONS(7200),
    [anon_sym_PIPE] = ACTIONS(7200),
    [anon_sym_SEMI_SEMI] = ACTIONS(7198),
    [anon_sym_PIPE_AMP] = ACTIONS(7198),
    [anon_sym_AMP_AMP] = ACTIONS(7198),
    [anon_sym_PIPE_PIPE] = ACTIONS(7198),
    [anon_sym_LT] = ACTIONS(7200),
    [anon_sym_GT] = ACTIONS(7200),
    [anon_sym_GT_GT] = ACTIONS(7198),
    [anon_sym_AMP_GT] = ACTIONS(7200),
    [anon_sym_AMP_GT_GT] = ACTIONS(7198),
    [anon_sym_LT_AMP] = ACTIONS(7198),
    [anon_sym_GT_AMP] = ACTIONS(7198),
    [anon_sym_LT_LT] = ACTIONS(7200),
    [anon_sym_LT_LT_DASH] = ACTIONS(7198),
    [anon_sym_LT_LT_LT] = ACTIONS(7198),
    [anon_sym_DOLLAR] = ACTIONS(7200),
    [sym__special_character] = ACTIONS(7198),
    [anon_sym_DQUOTE] = ACTIONS(7198),
    [sym_raw_string] = ACTIONS(7198),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7198),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7198),
    [anon_sym_BQUOTE] = ACTIONS(7198),
    [anon_sym_LT_LPAREN] = ACTIONS(7198),
    [anon_sym_GT_LPAREN] = ACTIONS(7198),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7200),
    [sym_word] = ACTIONS(7200),
    [anon_sym_LF] = ACTIONS(7198),
    [anon_sym_AMP] = ACTIONS(7200),
  },
  [4455] = {
    [sym__simple_heredoc_body] = ACTIONS(7202),
    [sym__heredoc_body_beginning] = ACTIONS(7202),
    [sym_file_descriptor] = ACTIONS(7202),
    [sym__concat] = ACTIONS(7202),
    [sym_variable_name] = ACTIONS(7202),
    [anon_sym_SEMI] = ACTIONS(7204),
    [anon_sym_esac] = ACTIONS(7204),
    [anon_sym_PIPE] = ACTIONS(7204),
    [anon_sym_SEMI_SEMI] = ACTIONS(7202),
    [anon_sym_PIPE_AMP] = ACTIONS(7202),
    [anon_sym_AMP_AMP] = ACTIONS(7202),
    [anon_sym_PIPE_PIPE] = ACTIONS(7202),
    [anon_sym_LT] = ACTIONS(7204),
    [anon_sym_GT] = ACTIONS(7204),
    [anon_sym_GT_GT] = ACTIONS(7202),
    [anon_sym_AMP_GT] = ACTIONS(7204),
    [anon_sym_AMP_GT_GT] = ACTIONS(7202),
    [anon_sym_LT_AMP] = ACTIONS(7202),
    [anon_sym_GT_AMP] = ACTIONS(7202),
    [anon_sym_LT_LT] = ACTIONS(7204),
    [anon_sym_LT_LT_DASH] = ACTIONS(7202),
    [anon_sym_LT_LT_LT] = ACTIONS(7202),
    [anon_sym_DOLLAR] = ACTIONS(7204),
    [sym__special_character] = ACTIONS(7202),
    [anon_sym_DQUOTE] = ACTIONS(7202),
    [sym_raw_string] = ACTIONS(7202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7202),
    [anon_sym_BQUOTE] = ACTIONS(7202),
    [anon_sym_LT_LPAREN] = ACTIONS(7202),
    [anon_sym_GT_LPAREN] = ACTIONS(7202),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7204),
    [sym_word] = ACTIONS(7204),
    [anon_sym_LF] = ACTIONS(7202),
    [anon_sym_AMP] = ACTIONS(7204),
  },
  [4456] = {
    [sym__simple_heredoc_body] = ACTIONS(7206),
    [sym__heredoc_body_beginning] = ACTIONS(7206),
    [sym_file_descriptor] = ACTIONS(7206),
    [sym__concat] = ACTIONS(7206),
    [sym_variable_name] = ACTIONS(7206),
    [anon_sym_SEMI] = ACTIONS(7208),
    [anon_sym_esac] = ACTIONS(7208),
    [anon_sym_PIPE] = ACTIONS(7208),
    [anon_sym_SEMI_SEMI] = ACTIONS(7206),
    [anon_sym_PIPE_AMP] = ACTIONS(7206),
    [anon_sym_AMP_AMP] = ACTIONS(7206),
    [anon_sym_PIPE_PIPE] = ACTIONS(7206),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7206),
    [anon_sym_AMP_GT] = ACTIONS(7208),
    [anon_sym_AMP_GT_GT] = ACTIONS(7206),
    [anon_sym_LT_AMP] = ACTIONS(7206),
    [anon_sym_GT_AMP] = ACTIONS(7206),
    [anon_sym_LT_LT] = ACTIONS(7208),
    [anon_sym_LT_LT_DASH] = ACTIONS(7206),
    [anon_sym_LT_LT_LT] = ACTIONS(7206),
    [anon_sym_DOLLAR] = ACTIONS(7208),
    [sym__special_character] = ACTIONS(7206),
    [anon_sym_DQUOTE] = ACTIONS(7206),
    [sym_raw_string] = ACTIONS(7206),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7206),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7206),
    [anon_sym_BQUOTE] = ACTIONS(7206),
    [anon_sym_LT_LPAREN] = ACTIONS(7206),
    [anon_sym_GT_LPAREN] = ACTIONS(7206),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7208),
    [sym_word] = ACTIONS(7208),
    [anon_sym_LF] = ACTIONS(7206),
    [anon_sym_AMP] = ACTIONS(7208),
  },
  [4457] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(10198),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4458] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(10200),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4459] = {
    [sym__simple_heredoc_body] = ACTIONS(7242),
    [sym__heredoc_body_beginning] = ACTIONS(7242),
    [sym_file_descriptor] = ACTIONS(7242),
    [sym__concat] = ACTIONS(7242),
    [sym_variable_name] = ACTIONS(7242),
    [anon_sym_SEMI] = ACTIONS(7244),
    [anon_sym_esac] = ACTIONS(7244),
    [anon_sym_PIPE] = ACTIONS(7244),
    [anon_sym_SEMI_SEMI] = ACTIONS(7242),
    [anon_sym_PIPE_AMP] = ACTIONS(7242),
    [anon_sym_AMP_AMP] = ACTIONS(7242),
    [anon_sym_PIPE_PIPE] = ACTIONS(7242),
    [anon_sym_LT] = ACTIONS(7244),
    [anon_sym_GT] = ACTIONS(7244),
    [anon_sym_GT_GT] = ACTIONS(7242),
    [anon_sym_AMP_GT] = ACTIONS(7244),
    [anon_sym_AMP_GT_GT] = ACTIONS(7242),
    [anon_sym_LT_AMP] = ACTIONS(7242),
    [anon_sym_GT_AMP] = ACTIONS(7242),
    [anon_sym_LT_LT] = ACTIONS(7244),
    [anon_sym_LT_LT_DASH] = ACTIONS(7242),
    [anon_sym_LT_LT_LT] = ACTIONS(7242),
    [anon_sym_DOLLAR] = ACTIONS(7244),
    [sym__special_character] = ACTIONS(7242),
    [anon_sym_DQUOTE] = ACTIONS(7242),
    [sym_raw_string] = ACTIONS(7242),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7242),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7242),
    [anon_sym_BQUOTE] = ACTIONS(7242),
    [anon_sym_LT_LPAREN] = ACTIONS(7242),
    [anon_sym_GT_LPAREN] = ACTIONS(7242),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7244),
    [sym_word] = ACTIONS(7244),
    [anon_sym_LF] = ACTIONS(7242),
    [anon_sym_AMP] = ACTIONS(7244),
  },
  [4460] = {
    [sym__simple_heredoc_body] = ACTIONS(7198),
    [sym__heredoc_body_beginning] = ACTIONS(7198),
    [sym_file_descriptor] = ACTIONS(7198),
    [sym__concat] = ACTIONS(7198),
    [anon_sym_SEMI] = ACTIONS(7200),
    [anon_sym_esac] = ACTIONS(7200),
    [anon_sym_PIPE] = ACTIONS(7200),
    [anon_sym_SEMI_SEMI] = ACTIONS(7198),
    [anon_sym_PIPE_AMP] = ACTIONS(7198),
    [anon_sym_AMP_AMP] = ACTIONS(7198),
    [anon_sym_PIPE_PIPE] = ACTIONS(7198),
    [anon_sym_LT] = ACTIONS(7200),
    [anon_sym_GT] = ACTIONS(7200),
    [anon_sym_GT_GT] = ACTIONS(7198),
    [anon_sym_AMP_GT] = ACTIONS(7200),
    [anon_sym_AMP_GT_GT] = ACTIONS(7198),
    [anon_sym_LT_AMP] = ACTIONS(7198),
    [anon_sym_GT_AMP] = ACTIONS(7198),
    [anon_sym_LT_LT] = ACTIONS(7200),
    [anon_sym_LT_LT_DASH] = ACTIONS(7198),
    [anon_sym_LT_LT_LT] = ACTIONS(7198),
    [anon_sym_DOLLAR] = ACTIONS(7200),
    [sym__special_character] = ACTIONS(7198),
    [anon_sym_DQUOTE] = ACTIONS(7198),
    [sym_raw_string] = ACTIONS(7198),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7198),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7198),
    [anon_sym_BQUOTE] = ACTIONS(7198),
    [anon_sym_LT_LPAREN] = ACTIONS(7198),
    [anon_sym_GT_LPAREN] = ACTIONS(7198),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7200),
    [sym_word] = ACTIONS(7200),
    [anon_sym_LF] = ACTIONS(7198),
    [anon_sym_AMP] = ACTIONS(7200),
  },
  [4461] = {
    [sym__simple_heredoc_body] = ACTIONS(7202),
    [sym__heredoc_body_beginning] = ACTIONS(7202),
    [sym_file_descriptor] = ACTIONS(7202),
    [sym__concat] = ACTIONS(7202),
    [anon_sym_SEMI] = ACTIONS(7204),
    [anon_sym_esac] = ACTIONS(7204),
    [anon_sym_PIPE] = ACTIONS(7204),
    [anon_sym_SEMI_SEMI] = ACTIONS(7202),
    [anon_sym_PIPE_AMP] = ACTIONS(7202),
    [anon_sym_AMP_AMP] = ACTIONS(7202),
    [anon_sym_PIPE_PIPE] = ACTIONS(7202),
    [anon_sym_LT] = ACTIONS(7204),
    [anon_sym_GT] = ACTIONS(7204),
    [anon_sym_GT_GT] = ACTIONS(7202),
    [anon_sym_AMP_GT] = ACTIONS(7204),
    [anon_sym_AMP_GT_GT] = ACTIONS(7202),
    [anon_sym_LT_AMP] = ACTIONS(7202),
    [anon_sym_GT_AMP] = ACTIONS(7202),
    [anon_sym_LT_LT] = ACTIONS(7204),
    [anon_sym_LT_LT_DASH] = ACTIONS(7202),
    [anon_sym_LT_LT_LT] = ACTIONS(7202),
    [anon_sym_DOLLAR] = ACTIONS(7204),
    [sym__special_character] = ACTIONS(7202),
    [anon_sym_DQUOTE] = ACTIONS(7202),
    [sym_raw_string] = ACTIONS(7202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7202),
    [anon_sym_BQUOTE] = ACTIONS(7202),
    [anon_sym_LT_LPAREN] = ACTIONS(7202),
    [anon_sym_GT_LPAREN] = ACTIONS(7202),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7204),
    [sym_word] = ACTIONS(7204),
    [anon_sym_LF] = ACTIONS(7202),
    [anon_sym_AMP] = ACTIONS(7204),
  },
  [4462] = {
    [sym__simple_heredoc_body] = ACTIONS(7206),
    [sym__heredoc_body_beginning] = ACTIONS(7206),
    [sym_file_descriptor] = ACTIONS(7206),
    [sym__concat] = ACTIONS(7206),
    [anon_sym_SEMI] = ACTIONS(7208),
    [anon_sym_esac] = ACTIONS(7208),
    [anon_sym_PIPE] = ACTIONS(7208),
    [anon_sym_SEMI_SEMI] = ACTIONS(7206),
    [anon_sym_PIPE_AMP] = ACTIONS(7206),
    [anon_sym_AMP_AMP] = ACTIONS(7206),
    [anon_sym_PIPE_PIPE] = ACTIONS(7206),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7206),
    [anon_sym_AMP_GT] = ACTIONS(7208),
    [anon_sym_AMP_GT_GT] = ACTIONS(7206),
    [anon_sym_LT_AMP] = ACTIONS(7206),
    [anon_sym_GT_AMP] = ACTIONS(7206),
    [anon_sym_LT_LT] = ACTIONS(7208),
    [anon_sym_LT_LT_DASH] = ACTIONS(7206),
    [anon_sym_LT_LT_LT] = ACTIONS(7206),
    [anon_sym_DOLLAR] = ACTIONS(7208),
    [sym__special_character] = ACTIONS(7206),
    [anon_sym_DQUOTE] = ACTIONS(7206),
    [sym_raw_string] = ACTIONS(7206),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7206),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7206),
    [anon_sym_BQUOTE] = ACTIONS(7206),
    [anon_sym_LT_LPAREN] = ACTIONS(7206),
    [anon_sym_GT_LPAREN] = ACTIONS(7206),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7208),
    [sym_word] = ACTIONS(7208),
    [anon_sym_LF] = ACTIONS(7206),
    [anon_sym_AMP] = ACTIONS(7208),
  },
  [4463] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(10202),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4464] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(10204),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4465] = {
    [sym__simple_heredoc_body] = ACTIONS(7242),
    [sym__heredoc_body_beginning] = ACTIONS(7242),
    [sym_file_descriptor] = ACTIONS(7242),
    [sym__concat] = ACTIONS(7242),
    [anon_sym_SEMI] = ACTIONS(7244),
    [anon_sym_esac] = ACTIONS(7244),
    [anon_sym_PIPE] = ACTIONS(7244),
    [anon_sym_SEMI_SEMI] = ACTIONS(7242),
    [anon_sym_PIPE_AMP] = ACTIONS(7242),
    [anon_sym_AMP_AMP] = ACTIONS(7242),
    [anon_sym_PIPE_PIPE] = ACTIONS(7242),
    [anon_sym_LT] = ACTIONS(7244),
    [anon_sym_GT] = ACTIONS(7244),
    [anon_sym_GT_GT] = ACTIONS(7242),
    [anon_sym_AMP_GT] = ACTIONS(7244),
    [anon_sym_AMP_GT_GT] = ACTIONS(7242),
    [anon_sym_LT_AMP] = ACTIONS(7242),
    [anon_sym_GT_AMP] = ACTIONS(7242),
    [anon_sym_LT_LT] = ACTIONS(7244),
    [anon_sym_LT_LT_DASH] = ACTIONS(7242),
    [anon_sym_LT_LT_LT] = ACTIONS(7242),
    [anon_sym_DOLLAR] = ACTIONS(7244),
    [sym__special_character] = ACTIONS(7242),
    [anon_sym_DQUOTE] = ACTIONS(7242),
    [sym_raw_string] = ACTIONS(7242),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7242),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7242),
    [anon_sym_BQUOTE] = ACTIONS(7242),
    [anon_sym_LT_LPAREN] = ACTIONS(7242),
    [anon_sym_GT_LPAREN] = ACTIONS(7242),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7244),
    [sym_word] = ACTIONS(7244),
    [anon_sym_LF] = ACTIONS(7242),
    [anon_sym_AMP] = ACTIONS(7244),
  },
  [4466] = {
    [sym__simple_heredoc_body] = ACTIONS(8340),
    [sym__heredoc_body_beginning] = ACTIONS(8340),
    [sym_file_descriptor] = ACTIONS(8340),
    [sym__concat] = ACTIONS(8340),
    [anon_sym_SEMI] = ACTIONS(8342),
    [anon_sym_esac] = ACTIONS(8342),
    [anon_sym_PIPE] = ACTIONS(8342),
    [anon_sym_SEMI_SEMI] = ACTIONS(8340),
    [anon_sym_PIPE_AMP] = ACTIONS(8340),
    [anon_sym_AMP_AMP] = ACTIONS(8340),
    [anon_sym_PIPE_PIPE] = ACTIONS(8340),
    [anon_sym_EQ_TILDE] = ACTIONS(8342),
    [anon_sym_EQ_EQ] = ACTIONS(8342),
    [anon_sym_LT] = ACTIONS(8342),
    [anon_sym_GT] = ACTIONS(8342),
    [anon_sym_GT_GT] = ACTIONS(8340),
    [anon_sym_AMP_GT] = ACTIONS(8342),
    [anon_sym_AMP_GT_GT] = ACTIONS(8340),
    [anon_sym_LT_AMP] = ACTIONS(8340),
    [anon_sym_GT_AMP] = ACTIONS(8340),
    [anon_sym_LT_LT] = ACTIONS(8342),
    [anon_sym_LT_LT_DASH] = ACTIONS(8340),
    [anon_sym_LT_LT_LT] = ACTIONS(8340),
    [anon_sym_DOLLAR] = ACTIONS(8342),
    [sym__special_character] = ACTIONS(8340),
    [anon_sym_DQUOTE] = ACTIONS(8340),
    [sym_raw_string] = ACTIONS(8340),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8340),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [anon_sym_LT_LPAREN] = ACTIONS(8340),
    [anon_sym_GT_LPAREN] = ACTIONS(8340),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8342),
    [anon_sym_LF] = ACTIONS(8340),
    [anon_sym_AMP] = ACTIONS(8342),
  },
  [4467] = {
    [sym__simple_heredoc_body] = ACTIONS(8344),
    [sym__heredoc_body_beginning] = ACTIONS(8344),
    [sym_file_descriptor] = ACTIONS(8344),
    [sym__concat] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [anon_sym_esac] = ACTIONS(8346),
    [anon_sym_PIPE] = ACTIONS(8346),
    [anon_sym_SEMI_SEMI] = ACTIONS(8344),
    [anon_sym_PIPE_AMP] = ACTIONS(8344),
    [anon_sym_AMP_AMP] = ACTIONS(8344),
    [anon_sym_PIPE_PIPE] = ACTIONS(8344),
    [anon_sym_EQ_TILDE] = ACTIONS(8346),
    [anon_sym_EQ_EQ] = ACTIONS(8346),
    [anon_sym_LT] = ACTIONS(8346),
    [anon_sym_GT] = ACTIONS(8346),
    [anon_sym_GT_GT] = ACTIONS(8344),
    [anon_sym_AMP_GT] = ACTIONS(8346),
    [anon_sym_AMP_GT_GT] = ACTIONS(8344),
    [anon_sym_LT_AMP] = ACTIONS(8344),
    [anon_sym_GT_AMP] = ACTIONS(8344),
    [anon_sym_LT_LT] = ACTIONS(8346),
    [anon_sym_LT_LT_DASH] = ACTIONS(8344),
    [anon_sym_LT_LT_LT] = ACTIONS(8344),
    [anon_sym_DOLLAR] = ACTIONS(8346),
    [sym__special_character] = ACTIONS(8344),
    [anon_sym_DQUOTE] = ACTIONS(8344),
    [sym_raw_string] = ACTIONS(8344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8344),
    [anon_sym_BQUOTE] = ACTIONS(8344),
    [anon_sym_LT_LPAREN] = ACTIONS(8344),
    [anon_sym_GT_LPAREN] = ACTIONS(8344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8346),
    [anon_sym_LF] = ACTIONS(8344),
    [anon_sym_AMP] = ACTIONS(8346),
  },
  [4468] = {
    [sym__simple_heredoc_body] = ACTIONS(7198),
    [sym__heredoc_body_beginning] = ACTIONS(7198),
    [sym_file_descriptor] = ACTIONS(7198),
    [sym__concat] = ACTIONS(7198),
    [sym_variable_name] = ACTIONS(7198),
    [anon_sym_SEMI] = ACTIONS(7200),
    [anon_sym_esac] = ACTIONS(7200),
    [anon_sym_PIPE] = ACTIONS(7200),
    [anon_sym_SEMI_SEMI] = ACTIONS(7198),
    [anon_sym_PIPE_AMP] = ACTIONS(7198),
    [anon_sym_AMP_AMP] = ACTIONS(7198),
    [anon_sym_PIPE_PIPE] = ACTIONS(7198),
    [anon_sym_LT] = ACTIONS(7200),
    [anon_sym_GT] = ACTIONS(7200),
    [anon_sym_GT_GT] = ACTIONS(7198),
    [anon_sym_AMP_GT] = ACTIONS(7200),
    [anon_sym_AMP_GT_GT] = ACTIONS(7198),
    [anon_sym_LT_AMP] = ACTIONS(7198),
    [anon_sym_GT_AMP] = ACTIONS(7198),
    [anon_sym_LT_LT] = ACTIONS(7200),
    [anon_sym_LT_LT_DASH] = ACTIONS(7198),
    [anon_sym_LT_LT_LT] = ACTIONS(7198),
    [anon_sym_DOLLAR] = ACTIONS(7200),
    [sym__special_character] = ACTIONS(7198),
    [anon_sym_DQUOTE] = ACTIONS(7198),
    [sym_raw_string] = ACTIONS(7198),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7198),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7198),
    [anon_sym_BQUOTE] = ACTIONS(7198),
    [anon_sym_LT_LPAREN] = ACTIONS(7198),
    [anon_sym_GT_LPAREN] = ACTIONS(7198),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7200),
    [anon_sym_LF] = ACTIONS(7198),
    [anon_sym_AMP] = ACTIONS(7200),
  },
  [4469] = {
    [sym__simple_heredoc_body] = ACTIONS(7202),
    [sym__heredoc_body_beginning] = ACTIONS(7202),
    [sym_file_descriptor] = ACTIONS(7202),
    [sym__concat] = ACTIONS(7202),
    [sym_variable_name] = ACTIONS(7202),
    [anon_sym_SEMI] = ACTIONS(7204),
    [anon_sym_esac] = ACTIONS(7204),
    [anon_sym_PIPE] = ACTIONS(7204),
    [anon_sym_SEMI_SEMI] = ACTIONS(7202),
    [anon_sym_PIPE_AMP] = ACTIONS(7202),
    [anon_sym_AMP_AMP] = ACTIONS(7202),
    [anon_sym_PIPE_PIPE] = ACTIONS(7202),
    [anon_sym_LT] = ACTIONS(7204),
    [anon_sym_GT] = ACTIONS(7204),
    [anon_sym_GT_GT] = ACTIONS(7202),
    [anon_sym_AMP_GT] = ACTIONS(7204),
    [anon_sym_AMP_GT_GT] = ACTIONS(7202),
    [anon_sym_LT_AMP] = ACTIONS(7202),
    [anon_sym_GT_AMP] = ACTIONS(7202),
    [anon_sym_LT_LT] = ACTIONS(7204),
    [anon_sym_LT_LT_DASH] = ACTIONS(7202),
    [anon_sym_LT_LT_LT] = ACTIONS(7202),
    [anon_sym_DOLLAR] = ACTIONS(7204),
    [sym__special_character] = ACTIONS(7202),
    [anon_sym_DQUOTE] = ACTIONS(7202),
    [sym_raw_string] = ACTIONS(7202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7202),
    [anon_sym_BQUOTE] = ACTIONS(7202),
    [anon_sym_LT_LPAREN] = ACTIONS(7202),
    [anon_sym_GT_LPAREN] = ACTIONS(7202),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7204),
    [anon_sym_LF] = ACTIONS(7202),
    [anon_sym_AMP] = ACTIONS(7204),
  },
  [4470] = {
    [sym__simple_heredoc_body] = ACTIONS(7206),
    [sym__heredoc_body_beginning] = ACTIONS(7206),
    [sym_file_descriptor] = ACTIONS(7206),
    [sym__concat] = ACTIONS(7206),
    [sym_variable_name] = ACTIONS(7206),
    [anon_sym_SEMI] = ACTIONS(7208),
    [anon_sym_esac] = ACTIONS(7208),
    [anon_sym_PIPE] = ACTIONS(7208),
    [anon_sym_SEMI_SEMI] = ACTIONS(7206),
    [anon_sym_PIPE_AMP] = ACTIONS(7206),
    [anon_sym_AMP_AMP] = ACTIONS(7206),
    [anon_sym_PIPE_PIPE] = ACTIONS(7206),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7206),
    [anon_sym_AMP_GT] = ACTIONS(7208),
    [anon_sym_AMP_GT_GT] = ACTIONS(7206),
    [anon_sym_LT_AMP] = ACTIONS(7206),
    [anon_sym_GT_AMP] = ACTIONS(7206),
    [anon_sym_LT_LT] = ACTIONS(7208),
    [anon_sym_LT_LT_DASH] = ACTIONS(7206),
    [anon_sym_LT_LT_LT] = ACTIONS(7206),
    [anon_sym_DOLLAR] = ACTIONS(7208),
    [sym__special_character] = ACTIONS(7206),
    [anon_sym_DQUOTE] = ACTIONS(7206),
    [sym_raw_string] = ACTIONS(7206),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7206),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7206),
    [anon_sym_BQUOTE] = ACTIONS(7206),
    [anon_sym_LT_LPAREN] = ACTIONS(7206),
    [anon_sym_GT_LPAREN] = ACTIONS(7206),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7208),
    [anon_sym_LF] = ACTIONS(7206),
    [anon_sym_AMP] = ACTIONS(7208),
  },
  [4471] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(10206),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4472] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(637),
    [sym_simple_expansion] = STATE(637),
    [sym_string_expansion] = STATE(637),
    [sym_expansion] = STATE(637),
    [sym_command_substitution] = STATE(637),
    [sym_process_substitution] = STATE(637),
    [aux_sym__literal_repeat1] = STATE(643),
    [aux_sym_expansion_repeat1] = STATE(1280),
    [anon_sym_RBRACE] = ACTIONS(10208),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_POUND] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1141),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LT_LPAREN] = ACTIONS(1145),
    [anon_sym_GT_LPAREN] = ACTIONS(1145),
    [sym_comment] = ACTIONS(329),
    [sym_word] = ACTIONS(1147),
  },
  [4473] = {
    [sym__simple_heredoc_body] = ACTIONS(7242),
    [sym__heredoc_body_beginning] = ACTIONS(7242),
    [sym_file_descriptor] = ACTIONS(7242),
    [sym__concat] = ACTIONS(7242),
    [sym_variable_name] = ACTIONS(7242),
    [anon_sym_SEMI] = ACTIONS(7244),
    [anon_sym_esac] = ACTIONS(7244),
    [anon_sym_PIPE] = ACTIONS(7244),
    [anon_sym_SEMI_SEMI] = ACTIONS(7242),
    [anon_sym_PIPE_AMP] = ACTIONS(7242),
    [anon_sym_AMP_AMP] = ACTIONS(7242),
    [anon_sym_PIPE_PIPE] = ACTIONS(7242),
    [anon_sym_LT] = ACTIONS(7244),
    [anon_sym_GT] = ACTIONS(7244),
    [anon_sym_GT_GT] = ACTIONS(7242),
    [anon_sym_AMP_GT] = ACTIONS(7244),
    [anon_sym_AMP_GT_GT] = ACTIONS(7242),
    [anon_sym_LT_AMP] = ACTIONS(7242),
    [anon_sym_GT_AMP] = ACTIONS(7242),
    [anon_sym_LT_LT] = ACTIONS(7244),
    [anon_sym_LT_LT_DASH] = ACTIONS(7242),
    [anon_sym_LT_LT_LT] = ACTIONS(7242),
    [anon_sym_DOLLAR] = ACTIONS(7244),
    [sym__special_character] = ACTIONS(7242),
    [anon_sym_DQUOTE] = ACTIONS(7242),
    [sym_raw_string] = ACTIONS(7242),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7242),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7242),
    [anon_sym_BQUOTE] = ACTIONS(7242),
    [anon_sym_LT_LPAREN] = ACTIONS(7242),
    [anon_sym_GT_LPAREN] = ACTIONS(7242),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7244),
    [anon_sym_LF] = ACTIONS(7242),
    [anon_sym_AMP] = ACTIONS(7244),
  },
  [4474] = {
    [sym__simple_heredoc_body] = ACTIONS(8340),
    [sym__heredoc_body_beginning] = ACTIONS(8340),
    [sym_file_descriptor] = ACTIONS(8340),
    [sym__concat] = ACTIONS(8340),
    [sym_variable_name] = ACTIONS(8340),
    [anon_sym_SEMI] = ACTIONS(8342),
    [anon_sym_esac] = ACTIONS(8342),
    [anon_sym_PIPE] = ACTIONS(8342),
    [anon_sym_SEMI_SEMI] = ACTIONS(8340),
    [anon_sym_PIPE_AMP] = ACTIONS(8340),
    [anon_sym_AMP_AMP] = ACTIONS(8340),
    [anon_sym_PIPE_PIPE] = ACTIONS(8340),
    [anon_sym_LT] = ACTIONS(8342),
    [anon_sym_GT] = ACTIONS(8342),
    [anon_sym_GT_GT] = ACTIONS(8340),
    [anon_sym_AMP_GT] = ACTIONS(8342),
    [anon_sym_AMP_GT_GT] = ACTIONS(8340),
    [anon_sym_LT_AMP] = ACTIONS(8340),
    [anon_sym_GT_AMP] = ACTIONS(8340),
    [anon_sym_LT_LT] = ACTIONS(8342),
    [anon_sym_LT_LT_DASH] = ACTIONS(8340),
    [anon_sym_LT_LT_LT] = ACTIONS(8340),
    [anon_sym_DOLLAR] = ACTIONS(8342),
    [sym__special_character] = ACTIONS(8340),
    [anon_sym_DQUOTE] = ACTIONS(8340),
    [sym_raw_string] = ACTIONS(8340),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8340),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [anon_sym_LT_LPAREN] = ACTIONS(8340),
    [anon_sym_GT_LPAREN] = ACTIONS(8340),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8342),
    [sym_word] = ACTIONS(8342),
    [anon_sym_LF] = ACTIONS(8340),
    [anon_sym_AMP] = ACTIONS(8342),
  },
  [4475] = {
    [sym__simple_heredoc_body] = ACTIONS(8344),
    [sym__heredoc_body_beginning] = ACTIONS(8344),
    [sym_file_descriptor] = ACTIONS(8344),
    [sym__concat] = ACTIONS(8344),
    [sym_variable_name] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [anon_sym_esac] = ACTIONS(8346),
    [anon_sym_PIPE] = ACTIONS(8346),
    [anon_sym_SEMI_SEMI] = ACTIONS(8344),
    [anon_sym_PIPE_AMP] = ACTIONS(8344),
    [anon_sym_AMP_AMP] = ACTIONS(8344),
    [anon_sym_PIPE_PIPE] = ACTIONS(8344),
    [anon_sym_LT] = ACTIONS(8346),
    [anon_sym_GT] = ACTIONS(8346),
    [anon_sym_GT_GT] = ACTIONS(8344),
    [anon_sym_AMP_GT] = ACTIONS(8346),
    [anon_sym_AMP_GT_GT] = ACTIONS(8344),
    [anon_sym_LT_AMP] = ACTIONS(8344),
    [anon_sym_GT_AMP] = ACTIONS(8344),
    [anon_sym_LT_LT] = ACTIONS(8346),
    [anon_sym_LT_LT_DASH] = ACTIONS(8344),
    [anon_sym_LT_LT_LT] = ACTIONS(8344),
    [anon_sym_DOLLAR] = ACTIONS(8346),
    [sym__special_character] = ACTIONS(8344),
    [anon_sym_DQUOTE] = ACTIONS(8344),
    [sym_raw_string] = ACTIONS(8344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8344),
    [anon_sym_BQUOTE] = ACTIONS(8344),
    [anon_sym_LT_LPAREN] = ACTIONS(8344),
    [anon_sym_GT_LPAREN] = ACTIONS(8344),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8346),
    [sym_word] = ACTIONS(8346),
    [anon_sym_LF] = ACTIONS(8344),
    [anon_sym_AMP] = ACTIONS(8346),
  },
  [4476] = {
    [sym__simple_heredoc_body] = ACTIONS(8340),
    [sym__heredoc_body_beginning] = ACTIONS(8340),
    [sym_file_descriptor] = ACTIONS(8340),
    [sym__concat] = ACTIONS(8340),
    [anon_sym_SEMI] = ACTIONS(8342),
    [anon_sym_esac] = ACTIONS(8342),
    [anon_sym_PIPE] = ACTIONS(8342),
    [anon_sym_SEMI_SEMI] = ACTIONS(8340),
    [anon_sym_PIPE_AMP] = ACTIONS(8340),
    [anon_sym_AMP_AMP] = ACTIONS(8340),
    [anon_sym_PIPE_PIPE] = ACTIONS(8340),
    [anon_sym_LT] = ACTIONS(8342),
    [anon_sym_GT] = ACTIONS(8342),
    [anon_sym_GT_GT] = ACTIONS(8340),
    [anon_sym_AMP_GT] = ACTIONS(8342),
    [anon_sym_AMP_GT_GT] = ACTIONS(8340),
    [anon_sym_LT_AMP] = ACTIONS(8340),
    [anon_sym_GT_AMP] = ACTIONS(8340),
    [anon_sym_LT_LT] = ACTIONS(8342),
    [anon_sym_LT_LT_DASH] = ACTIONS(8340),
    [anon_sym_LT_LT_LT] = ACTIONS(8340),
    [anon_sym_DOLLAR] = ACTIONS(8342),
    [sym__special_character] = ACTIONS(8340),
    [anon_sym_DQUOTE] = ACTIONS(8340),
    [sym_raw_string] = ACTIONS(8340),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8340),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [anon_sym_LT_LPAREN] = ACTIONS(8340),
    [anon_sym_GT_LPAREN] = ACTIONS(8340),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8342),
    [sym_word] = ACTIONS(8342),
    [anon_sym_LF] = ACTIONS(8340),
    [anon_sym_AMP] = ACTIONS(8342),
  },
  [4477] = {
    [sym__simple_heredoc_body] = ACTIONS(8344),
    [sym__heredoc_body_beginning] = ACTIONS(8344),
    [sym_file_descriptor] = ACTIONS(8344),
    [sym__concat] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [anon_sym_esac] = ACTIONS(8346),
    [anon_sym_PIPE] = ACTIONS(8346),
    [anon_sym_SEMI_SEMI] = ACTIONS(8344),
    [anon_sym_PIPE_AMP] = ACTIONS(8344),
    [anon_sym_AMP_AMP] = ACTIONS(8344),
    [anon_sym_PIPE_PIPE] = ACTIONS(8344),
    [anon_sym_LT] = ACTIONS(8346),
    [anon_sym_GT] = ACTIONS(8346),
    [anon_sym_GT_GT] = ACTIONS(8344),
    [anon_sym_AMP_GT] = ACTIONS(8346),
    [anon_sym_AMP_GT_GT] = ACTIONS(8344),
    [anon_sym_LT_AMP] = ACTIONS(8344),
    [anon_sym_GT_AMP] = ACTIONS(8344),
    [anon_sym_LT_LT] = ACTIONS(8346),
    [anon_sym_LT_LT_DASH] = ACTIONS(8344),
    [anon_sym_LT_LT_LT] = ACTIONS(8344),
    [anon_sym_DOLLAR] = ACTIONS(8346),
    [sym__special_character] = ACTIONS(8344),
    [anon_sym_DQUOTE] = ACTIONS(8344),
    [sym_raw_string] = ACTIONS(8344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8344),
    [anon_sym_BQUOTE] = ACTIONS(8344),
    [anon_sym_LT_LPAREN] = ACTIONS(8344),
    [anon_sym_GT_LPAREN] = ACTIONS(8344),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8346),
    [sym_word] = ACTIONS(8346),
    [anon_sym_LF] = ACTIONS(8344),
    [anon_sym_AMP] = ACTIONS(8346),
  },
  [4478] = {
    [sym__simple_heredoc_body] = ACTIONS(8340),
    [sym__heredoc_body_beginning] = ACTIONS(8340),
    [sym_file_descriptor] = ACTIONS(8340),
    [sym__concat] = ACTIONS(8340),
    [sym_variable_name] = ACTIONS(8340),
    [anon_sym_SEMI] = ACTIONS(8342),
    [anon_sym_esac] = ACTIONS(8342),
    [anon_sym_PIPE] = ACTIONS(8342),
    [anon_sym_SEMI_SEMI] = ACTIONS(8340),
    [anon_sym_PIPE_AMP] = ACTIONS(8340),
    [anon_sym_AMP_AMP] = ACTIONS(8340),
    [anon_sym_PIPE_PIPE] = ACTIONS(8340),
    [anon_sym_LT] = ACTIONS(8342),
    [anon_sym_GT] = ACTIONS(8342),
    [anon_sym_GT_GT] = ACTIONS(8340),
    [anon_sym_AMP_GT] = ACTIONS(8342),
    [anon_sym_AMP_GT_GT] = ACTIONS(8340),
    [anon_sym_LT_AMP] = ACTIONS(8340),
    [anon_sym_GT_AMP] = ACTIONS(8340),
    [anon_sym_LT_LT] = ACTIONS(8342),
    [anon_sym_LT_LT_DASH] = ACTIONS(8340),
    [anon_sym_LT_LT_LT] = ACTIONS(8340),
    [anon_sym_DOLLAR] = ACTIONS(8342),
    [sym__special_character] = ACTIONS(8340),
    [anon_sym_DQUOTE] = ACTIONS(8340),
    [sym_raw_string] = ACTIONS(8340),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8340),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8340),
    [anon_sym_BQUOTE] = ACTIONS(8340),
    [anon_sym_LT_LPAREN] = ACTIONS(8340),
    [anon_sym_GT_LPAREN] = ACTIONS(8340),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8342),
    [anon_sym_LF] = ACTIONS(8340),
    [anon_sym_AMP] = ACTIONS(8342),
  },
  [4479] = {
    [sym__simple_heredoc_body] = ACTIONS(8344),
    [sym__heredoc_body_beginning] = ACTIONS(8344),
    [sym_file_descriptor] = ACTIONS(8344),
    [sym__concat] = ACTIONS(8344),
    [sym_variable_name] = ACTIONS(8344),
    [anon_sym_SEMI] = ACTIONS(8346),
    [anon_sym_esac] = ACTIONS(8346),
    [anon_sym_PIPE] = ACTIONS(8346),
    [anon_sym_SEMI_SEMI] = ACTIONS(8344),
    [anon_sym_PIPE_AMP] = ACTIONS(8344),
    [anon_sym_AMP_AMP] = ACTIONS(8344),
    [anon_sym_PIPE_PIPE] = ACTIONS(8344),
    [anon_sym_LT] = ACTIONS(8346),
    [anon_sym_GT] = ACTIONS(8346),
    [anon_sym_GT_GT] = ACTIONS(8344),
    [anon_sym_AMP_GT] = ACTIONS(8346),
    [anon_sym_AMP_GT_GT] = ACTIONS(8344),
    [anon_sym_LT_AMP] = ACTIONS(8344),
    [anon_sym_GT_AMP] = ACTIONS(8344),
    [anon_sym_LT_LT] = ACTIONS(8346),
    [anon_sym_LT_LT_DASH] = ACTIONS(8344),
    [anon_sym_LT_LT_LT] = ACTIONS(8344),
    [anon_sym_DOLLAR] = ACTIONS(8346),
    [sym__special_character] = ACTIONS(8344),
    [anon_sym_DQUOTE] = ACTIONS(8344),
    [sym_raw_string] = ACTIONS(8344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8344),
    [anon_sym_BQUOTE] = ACTIONS(8344),
    [anon_sym_LT_LPAREN] = ACTIONS(8344),
    [anon_sym_GT_LPAREN] = ACTIONS(8344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8346),
    [anon_sym_LF] = ACTIONS(8344),
    [anon_sym_AMP] = ACTIONS(8346),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = true}, RECOVER(),
  [3] = {.count = 1, .reusable = false}, RECOVER(),
  [5] = {.count = 1, .reusable = true}, SHIFT(2),
  [7] = {.count = 1, .reusable = true}, SHIFT(3),
  [9] = {.count = 1, .reusable = true}, REDUCE(sym_program, 0),
  [11] = {.count = 1, .reusable = false}, SHIFT(4),
  [13] = {.count = 1, .reusable = true}, SHIFT(5),
  [15] = {.count = 1, .reusable = false}, SHIFT(6),
  [17] = {.count = 1, .reusable = false}, SHIFT(7),
  [19] = {.count = 1, .reusable = false}, SHIFT(8),
  [21] = {.count = 1, .reusable = false}, SHIFT(9),
  [23] = {.count = 1, .reusable = false}, SHIFT(10),
  [25] = {.count = 1, .reusable = true}, SHIFT(11),
  [27] = {.count = 1, .reusable = false}, SHIFT(12),
  [29] = {.count = 1, .reusable = false}, SHIFT(13),
  [31] = {.count = 1, .reusable = true}, SHIFT(14),
  [33] = {.count = 1, .reusable = false}, SHIFT(15),
  [35] = {.count = 1, .reusable = false}, SHIFT(16),
  [37] = {.count = 1, .reusable = false}, SHIFT(17),
  [39] = {.count = 1, .reusable = true}, SHIFT(17),
  [41] = {.count = 1, .reusable = false}, SHIFT(18),
  [43] = {.count = 1, .reusable = false}, SHIFT(19),
  [45] = {.count = 1, .reusable = true}, SHIFT(20),
  [47] = {.count = 1, .reusable = true}, SHIFT(21),
  [49] = {.count = 1, .reusable = true}, SHIFT(22),
  [51] = {.count = 1, .reusable = true}, SHIFT(23),
  [53] = {.count = 1, .reusable = true}, SHIFT(24),
  [55] = {.count = 1, .reusable = true}, SHIFT(25),
  [57] = {.count = 1, .reusable = true}, SHIFT_EXTRA(),
  [59] = {.count = 1, .reusable = false}, SHIFT(26),
  [61] = {.count = 1, .reusable = false}, SHIFT(37),
  [63] = {.count = 1, .reusable = true}, SHIFT(37),
  [65] = {.count = 1, .reusable = true}, SHIFT(38),
  [67] = {.count = 1, .reusable = true}, SHIFT(39),
  [69] = {.count = 1, .reusable = true}, SHIFT(40),
  [71] = {.count = 1, .reusable = true}, SHIFT(41),
  [73] = {.count = 1, .reusable = true}, SHIFT(42),
  [75] = {.count = 1, .reusable = false}, SHIFT(43),
  [77] = {.count = 1, .reusable = false}, SHIFT(44),
  [79] = {.count = 1, .reusable = true}, SHIFT(45),
  [81] = {.count = 1, .reusable = true}, SHIFT(46),
  [83] = {.count = 1, .reusable = true}, SHIFT(47),
  [85] = {.count = 1, .reusable = true}, SHIFT(48),
  [87] = {.count = 1, .reusable = true}, SHIFT(49),
  [89] = {.count = 1, .reusable = true}, SHIFT(50),
  [91] = {.count = 1, .reusable = true}, SHIFT(51),
  [93] = {.count = 1, .reusable = false}, SHIFT(47),
  [95] = {.count = 1, .reusable = true}, SHIFT(43),
  [97] = {.count = 1, .reusable = true}, SHIFT(54),
  [99] = {.count = 1, .reusable = false}, SHIFT(55),
  [101] = {.count = 1, .reusable = true}, SHIFT(56),
  [103] = {.count = 1, .reusable = false}, SHIFT(57),
  [105] = {.count = 1, .reusable = false}, SHIFT(58),
  [107] = {.count = 1, .reusable = false}, SHIFT(59),
  [109] = {.count = 1, .reusable = false}, SHIFT(60),
  [111] = {.count = 1, .reusable = false}, SHIFT(61),
  [113] = {.count = 1, .reusable = true}, SHIFT(62),
  [115] = {.count = 1, .reusable = false}, SHIFT(63),
  [117] = {.count = 1, .reusable = false}, SHIFT(64),
  [119] = {.count = 1, .reusable = true}, SHIFT(65),
  [121] = {.count = 1, .reusable = false}, SHIFT(66),
  [123] = {.count = 1, .reusable = false}, SHIFT(67),
  [125] = {.count = 1, .reusable = false}, SHIFT(68),
  [127] = {.count = 1, .reusable = false}, SHIFT(69),
  [129] = {.count = 1, .reusable = true}, SHIFT(70),
  [131] = {.count = 1, .reusable = true}, SHIFT(71),
  [133] = {.count = 1, .reusable = true}, SHIFT(72),
  [135] = {.count = 1, .reusable = true}, SHIFT(73),
  [137] = {.count = 1, .reusable = true}, SHIFT(74),
  [139] = {.count = 1, .reusable = true}, SHIFT(75),
  [141] = {.count = 1, .reusable = false}, SHIFT(76),
  [143] = {.count = 1, .reusable = false}, SHIFT(86),
  [145] = {.count = 1, .reusable = true}, SHIFT(87),
  [147] = {.count = 1, .reusable = true}, SHIFT(88),
  [149] = {.count = 1, .reusable = true}, SHIFT(89),
  [151] = {.count = 1, .reusable = true}, SHIFT(90),
  [153] = {.count = 1, .reusable = true}, SHIFT(91),
  [155] = {.count = 1, .reusable = true}, SHIFT(92),
  [157] = {.count = 1, .reusable = true}, SHIFT(93),
  [159] = {.count = 1, .reusable = true}, SHIFT(96),
  [161] = {.count = 1, .reusable = true}, SHIFT(97),
  [163] = {.count = 1, .reusable = false}, SHIFT(98),
  [165] = {.count = 1, .reusable = false}, SHIFT(99),
  [167] = {.count = 1, .reusable = false}, SHIFT(100),
  [169] = {.count = 1, .reusable = false}, SHIFT(101),
  [171] = {.count = 1, .reusable = true}, SHIFT(102),
  [173] = {.count = 1, .reusable = false}, SHIFT(103),
  [175] = {.count = 1, .reusable = true}, SHIFT(112),
  [177] = {.count = 1, .reusable = false}, SHIFT(113),
  [179] = {.count = 1, .reusable = true}, SHIFT(114),
  [181] = {.count = 1, .reusable = false}, SHIFT(115),
  [183] = {.count = 1, .reusable = false}, SHIFT(116),
  [185] = {.count = 1, .reusable = false}, SHIFT(117),
  [187] = {.count = 1, .reusable = false}, SHIFT(118),
  [189] = {.count = 1, .reusable = false}, SHIFT(119),
  [191] = {.count = 1, .reusable = true}, SHIFT(120),
  [193] = {.count = 1, .reusable = true}, SHIFT(121),
  [195] = {.count = 1, .reusable = false}, SHIFT(122),
  [197] = {.count = 1, .reusable = false}, SHIFT(123),
  [199] = {.count = 1, .reusable = true}, SHIFT(124),
  [201] = {.count = 1, .reusable = false}, SHIFT(125),
  [203] = {.count = 1, .reusable = false}, SHIFT(126),
  [205] = {.count = 1, .reusable = false}, SHIFT(127),
  [207] = {.count = 1, .reusable = false}, SHIFT(128),
  [209] = {.count = 1, .reusable = true}, SHIFT(129),
  [211] = {.count = 1, .reusable = true}, SHIFT(130),
  [213] = {.count = 1, .reusable = true}, SHIFT(131),
  [215] = {.count = 1, .reusable = true}, SHIFT(132),
  [217] = {.count = 1, .reusable = true}, SHIFT(133),
  [219] = {.count = 1, .reusable = true}, SHIFT(134),
  [221] = {.count = 1, .reusable = false}, SHIFT(135),
  [223] = {.count = 1, .reusable = true}, SHIFT(145),
  [225] = {.count = 1, .reusable = true}, SHIFT(148),
  [227] = {.count = 1, .reusable = false}, SHIFT(149),
  [229] = {.count = 1, .reusable = false}, SHIFT(150),
  [231] = {.count = 1, .reusable = true}, SHIFT(151),
  [233] = {.count = 1, .reusable = true}, SHIFT(152),
  [235] = {.count = 1, .reusable = true}, SHIFT(153),
  [237] = {.count = 1, .reusable = true}, SHIFT(154),
  [239] = {.count = 1, .reusable = true}, SHIFT(155),
  [241] = {.count = 1, .reusable = true}, SHIFT(156),
  [243] = {.count = 1, .reusable = true}, SHIFT(157),
  [245] = {.count = 1, .reusable = false}, SHIFT(153),
  [247] = {.count = 1, .reusable = true}, SHIFT(149),
  [249] = {.count = 1, .reusable = false}, SHIFT(160),
  [251] = {.count = 1, .reusable = true}, SHIFT(161),
  [253] = {.count = 1, .reusable = true}, SHIFT(162),
  [255] = {.count = 1, .reusable = false}, SHIFT(162),
  [257] = {.count = 1, .reusable = true}, SHIFT(160),
  [259] = {.count = 1, .reusable = true}, REDUCE(sym_declaration_command, 1),
  [261] = {.count = 1, .reusable = true}, SHIFT(165),
  [263] = {.count = 1, .reusable = false}, REDUCE(sym_declaration_command, 1),
  [265] = {.count = 1, .reusable = false}, SHIFT(166),
  [267] = {.count = 1, .reusable = true}, SHIFT(167),
  [269] = {.count = 1, .reusable = true}, SHIFT(168),
  [271] = {.count = 1, .reusable = true}, SHIFT(169),
  [273] = {.count = 1, .reusable = true}, SHIFT(170),
  [275] = {.count = 1, .reusable = true}, SHIFT(171),
  [277] = {.count = 1, .reusable = true}, SHIFT(172),
  [279] = {.count = 1, .reusable = true}, SHIFT(173),
  [281] = {.count = 1, .reusable = false}, SHIFT(175),
  [283] = {.count = 1, .reusable = false}, SHIFT(169),
  [285] = {.count = 1, .reusable = true}, REDUCE(sym_unset_command, 1),
  [287] = {.count = 1, .reusable = false}, REDUCE(sym_unset_command, 1),
  [289] = {.count = 1, .reusable = false}, SHIFT(177),
  [291] = {.count = 1, .reusable = true}, SHIFT(178),
  [293] = {.count = 1, .reusable = true}, SHIFT(179),
  [295] = {.count = 1, .reusable = true}, SHIFT(180),
  [297] = {.count = 1, .reusable = true}, SHIFT(181),
  [299] = {.count = 1, .reusable = true}, SHIFT(182),
  [301] = {.count = 1, .reusable = true}, SHIFT(183),
  [303] = {.count = 1, .reusable = true}, SHIFT(184),
  [305] = {.count = 1, .reusable = false}, SHIFT(185),
  [307] = {.count = 1, .reusable = false}, SHIFT(180),
  [309] = {.count = 1, .reusable = false}, SHIFT(187),
  [311] = {.count = 1, .reusable = true}, SHIFT(188),
  [313] = {.count = 1, .reusable = true}, SHIFT(189),
  [315] = {.count = 1, .reusable = true}, SHIFT(190),
  [317] = {.count = 1, .reusable = true}, SHIFT(191),
  [319] = {.count = 1, .reusable = true}, SHIFT(192),
  [321] = {.count = 1, .reusable = true}, SHIFT(193),
  [323] = {.count = 1, .reusable = true}, SHIFT(194),
  [325] = {.count = 1, .reusable = true}, SHIFT(197),
  [327] = {.count = 1, .reusable = true}, SHIFT(198),
  [329] = {.count = 1, .reusable = false}, SHIFT_EXTRA(),
  [331] = {.count = 1, .reusable = false}, SHIFT(199),
  [333] = {.count = 1, .reusable = true}, SHIFT(199),
  [335] = {.count = 1, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 1),
  [337] = {.count = 1, .reusable = true}, SHIFT(200),
  [339] = {.count = 1, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 1),
  [341] = {.count = 1, .reusable = false}, SHIFT(202),
  [343] = {.count = 1, .reusable = false}, SHIFT(203),
  [345] = {.count = 1, .reusable = true}, SHIFT(204),
  [347] = {.count = 1, .reusable = false}, SHIFT(205),
  [349] = {.count = 1, .reusable = false}, SHIFT(206),
  [351] = {.count = 1, .reusable = false}, SHIFT(207),
  [353] = {.count = 1, .reusable = true}, REDUCE(sym_command_name, 1),
  [355] = {.count = 1, .reusable = false}, REDUCE(sym_command_name, 1),
  [357] = {.count = 1, .reusable = true}, SHIFT(209),
  [359] = {.count = 1, .reusable = true}, SHIFT(210),
  [361] = {.count = 1, .reusable = true}, SHIFT(211),
  [363] = {.count = 1, .reusable = false}, SHIFT(212),
  [365] = {.count = 1, .reusable = true}, SHIFT(212),
  [367] = {.count = 1, .reusable = true}, SHIFT(213),
  [369] = {.count = 1, .reusable = false}, SHIFT(214),
  [371] = {.count = 1, .reusable = true}, SHIFT(214),
  [373] = {.count = 1, .reusable = true}, SHIFT(217),
  [375] = {.count = 1, .reusable = false}, SHIFT(218),
  [377] = {.count = 1, .reusable = false}, SHIFT(219),
  [379] = {.count = 1, .reusable = false}, SHIFT(220),
  [381] = {.count = 1, .reusable = false}, SHIFT(221),
  [383] = {.count = 1, .reusable = true}, SHIFT(222),
  [385] = {.count = 1, .reusable = false}, SHIFT(223),
  [387] = {.count = 1, .reusable = true}, SHIFT(233),
  [389] = {.count = 1, .reusable = true}, ACCEPT_INPUT(),
  [391] = {.count = 1, .reusable = true}, REDUCE(sym_program, 1),
  [393] = {.count = 1, .reusable = true}, SHIFT(234),
  [395] = {.count = 1, .reusable = true}, SHIFT(235),
  [397] = {.count = 1, .reusable = true}, SHIFT(236),
  [399] = {.count = 1, .reusable = true}, REDUCE(sym__statements, 1),
  [401] = {.count = 1, .reusable = false}, SHIFT(237),
  [403] = {.count = 1, .reusable = false}, SHIFT(238),
  [405] = {.count = 1, .reusable = true}, SHIFT(237),
  [407] = {.count = 1, .reusable = true}, SHIFT(238),
  [409] = {.count = 1, .reusable = true}, SHIFT(239),
  [411] = {.count = 1, .reusable = false}, SHIFT(240),
  [413] = {.count = 1, .reusable = true}, SHIFT(240),
  [415] = {.count = 1, .reusable = false}, SHIFT(241),
  [417] = {.count = 1, .reusable = true}, SHIFT(241),
  [419] = {.count = 1, .reusable = true}, SHIFT(242),
  [421] = {.count = 1, .reusable = true}, REDUCE(sym_command, 1),
  [423] = {.count = 1, .reusable = false}, REDUCE(sym_command, 1),
  [425] = {.count = 1, .reusable = false}, SHIFT(245),
  [427] = {.count = 1, .reusable = true}, SHIFT(19),
  [429] = {.count = 1, .reusable = true}, SHIFT(246),
  [431] = {.count = 1, .reusable = false}, SHIFT(246),
  [433] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat1, 1),
  [435] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat1, 1),
  [437] = {.count = 1, .reusable = true}, REDUCE(sym_command_name, 1, .alias_sequence_id = 1),
  [439] = {.count = 1, .reusable = false}, REDUCE(sym_command_name, 1, .alias_sequence_id = 1),
  [441] = {.count = 1, .reusable = true}, SHIFT(254),
  [443] = {.count = 1, .reusable = true}, SHIFT(256),
  [445] = {.count = 1, .reusable = true}, SHIFT(259),
  [447] = {.count = 1, .reusable = true}, SHIFT(260),
  [449] = {.count = 1, .reusable = true}, SHIFT(263),
  [451] = {.count = 1, .reusable = true}, SHIFT(264),
  [453] = {.count = 1, .reusable = false}, SHIFT(265),
  [455] = {.count = 1, .reusable = true}, SHIFT(266),
  [457] = {.count = 1, .reusable = true}, SHIFT(267),
  [459] = {.count = 1, .reusable = true}, SHIFT(268),
  [461] = {.count = 1, .reusable = true}, SHIFT(269),
  [463] = {.count = 1, .reusable = true}, SHIFT(270),
  [465] = {.count = 1, .reusable = true}, SHIFT(271),
  [467] = {.count = 1, .reusable = true}, SHIFT(272),
  [469] = {.count = 1, .reusable = false}, SHIFT(274),
  [471] = {.count = 1, .reusable = true}, SHIFT(274),
  [473] = {.count = 1, .reusable = true}, SHIFT(275),
  [475] = {.count = 1, .reusable = false}, SHIFT(276),
  [477] = {.count = 1, .reusable = false}, SHIFT(277),
  [479] = {.count = 1, .reusable = true}, SHIFT(278),
  [481] = {.count = 1, .reusable = true}, SHIFT(279),
  [483] = {.count = 1, .reusable = true}, SHIFT(280),
  [485] = {.count = 1, .reusable = true}, SHIFT(281),
  [487] = {.count = 1, .reusable = true}, SHIFT(282),
  [489] = {.count = 1, .reusable = true}, SHIFT(283),
  [491] = {.count = 1, .reusable = true}, SHIFT(284),
  [493] = {.count = 1, .reusable = false}, SHIFT(280),
  [495] = {.count = 1, .reusable = true}, SHIFT(276),
  [497] = {.count = 1, .reusable = true}, SHIFT(287),
  [499] = {.count = 1, .reusable = false}, SHIFT(288),
  [501] = {.count = 1, .reusable = true}, SHIFT(288),
  [503] = {.count = 1, .reusable = true}, SHIFT(289),
  [505] = {.count = 1, .reusable = false}, SHIFT(290),
  [507] = {.count = 1, .reusable = false}, SHIFT(291),
  [509] = {.count = 1, .reusable = true}, SHIFT(292),
  [511] = {.count = 1, .reusable = true}, SHIFT(293),
  [513] = {.count = 1, .reusable = true}, SHIFT(294),
  [515] = {.count = 1, .reusable = true}, SHIFT(295),
  [517] = {.count = 1, .reusable = true}, SHIFT(296),
  [519] = {.count = 1, .reusable = true}, SHIFT(297),
  [521] = {.count = 1, .reusable = true}, SHIFT(298),
  [523] = {.count = 1, .reusable = false}, SHIFT(294),
  [525] = {.count = 1, .reusable = true}, SHIFT(290),
  [527] = {.count = 1, .reusable = true}, SHIFT(302),
  [529] = {.count = 1, .reusable = true}, SHIFT(303),
  [531] = {.count = 1, .reusable = false}, SHIFT(304),
  [533] = {.count = 1, .reusable = true}, SHIFT(304),
  [535] = {.count = 1, .reusable = true}, SHIFT(305),
  [537] = {.count = 1, .reusable = false}, SHIFT(307),
  [539] = {.count = 1, .reusable = false}, SHIFT(308),
  [541] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1),
  [543] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1),
  [545] = {.count = 1, .reusable = true}, SHIFT(310),
  [547] = {.count = 1, .reusable = true}, SHIFT(311),
  [549] = {.count = 1, .reusable = true}, SHIFT(312),
  [551] = {.count = 1, .reusable = false}, SHIFT(313),
  [553] = {.count = 1, .reusable = true}, SHIFT(313),
  [555] = {.count = 1, .reusable = true}, SHIFT(318),
  [557] = {.count = 1, .reusable = true}, SHIFT(319),
  [559] = {.count = 1, .reusable = true}, SHIFT(320),
  [561] = {.count = 1, .reusable = false}, SHIFT(319),
  [563] = {.count = 1, .reusable = true}, SHIFT(321),
  [565] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1, .alias_sequence_id = 1),
  [567] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1, .alias_sequence_id = 1),
  [569] = {.count = 1, .reusable = true}, SHIFT(322),
  [571] = {.count = 1, .reusable = true}, SHIFT(324),
  [573] = {.count = 1, .reusable = true}, SHIFT(325),
  [575] = {.count = 1, .reusable = true}, SHIFT(326),
  [577] = {.count = 1, .reusable = true}, SHIFT(330),
  [579] = {.count = 1, .reusable = true}, SHIFT(333),
  [581] = {.count = 1, .reusable = true}, SHIFT(335),
  [583] = {.count = 1, .reusable = true}, SHIFT(340),
  [585] = {.count = 1, .reusable = false}, SHIFT(341),
  [587] = {.count = 1, .reusable = true}, SHIFT(342),
  [589] = {.count = 1, .reusable = true}, SHIFT(343),
  [591] = {.count = 1, .reusable = true}, SHIFT(344),
  [593] = {.count = 1, .reusable = true}, SHIFT(345),
  [595] = {.count = 1, .reusable = true}, SHIFT(346),
  [597] = {.count = 1, .reusable = true}, SHIFT(347),
  [599] = {.count = 1, .reusable = true}, SHIFT(348),
  [601] = {.count = 1, .reusable = false}, SHIFT(350),
  [603] = {.count = 1, .reusable = false}, SHIFT(344),
  [605] = {.count = 1, .reusable = false}, SHIFT(352),
  [607] = {.count = 1, .reusable = true}, SHIFT(353),
  [609] = {.count = 1, .reusable = true}, SHIFT(354),
  [611] = {.count = 1, .reusable = true}, SHIFT(355),
  [613] = {.count = 1, .reusable = true}, SHIFT(356),
  [615] = {.count = 1, .reusable = true}, SHIFT(357),
  [617] = {.count = 1, .reusable = true}, SHIFT(358),
  [619] = {.count = 1, .reusable = true}, SHIFT(359),
  [621] = {.count = 1, .reusable = false}, SHIFT(360),
  [623] = {.count = 1, .reusable = false}, SHIFT(355),
  [625] = {.count = 1, .reusable = true}, SHIFT(362),
  [627] = {.count = 1, .reusable = true}, SHIFT(363),
  [629] = {.count = 1, .reusable = false}, SHIFT(364),
  [631] = {.count = 1, .reusable = true}, SHIFT(364),
  [633] = {.count = 1, .reusable = true}, SHIFT(365),
  [635] = {.count = 1, .reusable = false}, SHIFT(367),
  [637] = {.count = 1, .reusable = false}, SHIFT(368),
  [639] = {.count = 1, .reusable = true}, SHIFT(370),
  [641] = {.count = 1, .reusable = true}, SHIFT(371),
  [643] = {.count = 1, .reusable = true}, SHIFT(372),
  [645] = {.count = 1, .reusable = false}, SHIFT(373),
  [647] = {.count = 1, .reusable = true}, SHIFT(373),
  [649] = {.count = 1, .reusable = true}, SHIFT(378),
  [651] = {.count = 1, .reusable = true}, SHIFT(379),
  [653] = {.count = 1, .reusable = true}, SHIFT(381),
  [655] = {.count = 1, .reusable = false}, SHIFT(382),
  [657] = {.count = 1, .reusable = false}, SHIFT(383),
  [659] = {.count = 1, .reusable = true}, SHIFT(382),
  [661] = {.count = 1, .reusable = true}, SHIFT(383),
  [663] = {.count = 1, .reusable = true}, SHIFT(384),
  [665] = {.count = 1, .reusable = false}, SHIFT(385),
  [667] = {.count = 1, .reusable = true}, SHIFT(385),
  [669] = {.count = 1, .reusable = false}, SHIFT(386),
  [671] = {.count = 1, .reusable = true}, SHIFT(386),
  [673] = {.count = 1, .reusable = true}, SHIFT(387),
  [675] = {.count = 1, .reusable = false}, SHIFT(389),
  [677] = {.count = 1, .reusable = true}, SHIFT(69),
  [679] = {.count = 1, .reusable = true}, SHIFT(390),
  [681] = {.count = 1, .reusable = false}, SHIFT(390),
  [683] = {.count = 1, .reusable = true}, SHIFT(394),
  [685] = {.count = 1, .reusable = true}, SHIFT(396),
  [687] = {.count = 1, .reusable = true}, SHIFT(397),
  [689] = {.count = 1, .reusable = true}, SHIFT(398),
  [691] = {.count = 1, .reusable = false}, SHIFT(399),
  [693] = {.count = 1, .reusable = true}, SHIFT(399),
  [695] = {.count = 1, .reusable = true}, SHIFT(400),
  [697] = {.count = 1, .reusable = false}, SHIFT(402),
  [699] = {.count = 1, .reusable = false}, SHIFT(403),
  [701] = {.count = 1, .reusable = true}, SHIFT(405),
  [703] = {.count = 1, .reusable = false}, SHIFT(406),
  [705] = {.count = 1, .reusable = true}, SHIFT(406),
  [707] = {.count = 1, .reusable = true}, SHIFT(407),
  [709] = {.count = 1, .reusable = true}, SHIFT(408),
  [711] = {.count = 1, .reusable = true}, SHIFT(409),
  [713] = {.count = 1, .reusable = false}, SHIFT(410),
  [715] = {.count = 1, .reusable = true}, SHIFT(410),
  [717] = {.count = 1, .reusable = true}, SHIFT(415),
  [719] = {.count = 1, .reusable = false}, SHIFT(416),
  [721] = {.count = 1, .reusable = true}, SHIFT(416),
  [723] = {.count = 1, .reusable = true}, SHIFT(417),
  [725] = {.count = 1, .reusable = true}, SHIFT(419),
  [727] = {.count = 1, .reusable = true}, SHIFT(421),
  [729] = {.count = 1, .reusable = true}, SHIFT(422),
  [731] = {.count = 1, .reusable = true}, SHIFT(423),
  [733] = {.count = 1, .reusable = true}, SHIFT(424),
  [735] = {.count = 1, .reusable = false}, SHIFT(426),
  [737] = {.count = 1, .reusable = false}, SHIFT(424),
  [739] = {.count = 1, .reusable = true}, SHIFT(428),
  [741] = {.count = 1, .reusable = true}, SHIFT(429),
  [743] = {.count = 1, .reusable = false}, SHIFT(430),
  [745] = {.count = 1, .reusable = false}, SHIFT(429),
  [747] = {.count = 1, .reusable = true}, SHIFT(433),
  [749] = {.count = 1, .reusable = true}, SHIFT(434),
  [751] = {.count = 1, .reusable = false}, SHIFT(435),
  [753] = {.count = 1, .reusable = true}, SHIFT(435),
  [755] = {.count = 1, .reusable = true}, SHIFT(436),
  [757] = {.count = 1, .reusable = false}, SHIFT(437),
  [759] = {.count = 1, .reusable = true}, SHIFT(437),
  [761] = {.count = 1, .reusable = true}, SHIFT(438),
  [763] = {.count = 1, .reusable = false}, SHIFT(440),
  [765] = {.count = 1, .reusable = true}, SHIFT(101),
  [767] = {.count = 1, .reusable = true}, SHIFT(441),
  [769] = {.count = 1, .reusable = false}, SHIFT(441),
  [771] = {.count = 1, .reusable = true}, SHIFT(448),
  [773] = {.count = 1, .reusable = true}, SHIFT(449),
  [775] = {.count = 1, .reusable = true}, SHIFT(450),
  [777] = {.count = 1, .reusable = true}, SHIFT(454),
  [779] = {.count = 1, .reusable = true}, SHIFT(457),
  [781] = {.count = 1, .reusable = true}, SHIFT(459),
  [783] = {.count = 1, .reusable = true}, REDUCE(sym_compound_statement, 2),
  [785] = {.count = 1, .reusable = false}, REDUCE(sym_compound_statement, 2),
  [787] = {.count = 1, .reusable = true}, SHIFT(464),
  [789] = {.count = 1, .reusable = false}, SHIFT(465),
  [791] = {.count = 1, .reusable = false}, SHIFT(466),
  [793] = {.count = 1, .reusable = true}, SHIFT(467),
  [795] = {.count = 1, .reusable = true}, SHIFT(468),
  [797] = {.count = 1, .reusable = true}, SHIFT(469),
  [799] = {.count = 1, .reusable = true}, SHIFT(470),
  [801] = {.count = 1, .reusable = true}, SHIFT(471),
  [803] = {.count = 1, .reusable = true}, SHIFT(472),
  [805] = {.count = 1, .reusable = false}, SHIFT(474),
  [807] = {.count = 1, .reusable = false}, SHIFT(468),
  [809] = {.count = 1, .reusable = false}, SHIFT(476),
  [811] = {.count = 1, .reusable = false}, SHIFT(477),
  [813] = {.count = 1, .reusable = true}, SHIFT(478),
  [815] = {.count = 1, .reusable = true}, SHIFT(479),
  [817] = {.count = 1, .reusable = true}, SHIFT(480),
  [819] = {.count = 1, .reusable = true}, SHIFT(481),
  [821] = {.count = 1, .reusable = true}, SHIFT(482),
  [823] = {.count = 1, .reusable = true}, SHIFT(483),
  [825] = {.count = 1, .reusable = false}, SHIFT(484),
  [827] = {.count = 1, .reusable = false}, SHIFT(479),
  [829] = {.count = 1, .reusable = true}, SHIFT(486),
  [831] = {.count = 1, .reusable = true}, SHIFT(487),
  [833] = {.count = 1, .reusable = false}, SHIFT(488),
  [835] = {.count = 1, .reusable = true}, SHIFT(488),
  [837] = {.count = 1, .reusable = true}, SHIFT(489),
  [839] = {.count = 1, .reusable = false}, SHIFT(491),
  [841] = {.count = 1, .reusable = false}, SHIFT(492),
  [843] = {.count = 1, .reusable = true}, SHIFT(494),
  [845] = {.count = 1, .reusable = true}, SHIFT(495),
  [847] = {.count = 1, .reusable = true}, SHIFT(496),
  [849] = {.count = 1, .reusable = false}, SHIFT(497),
  [851] = {.count = 1, .reusable = true}, SHIFT(497),
  [853] = {.count = 1, .reusable = true}, SHIFT(502),
  [855] = {.count = 1, .reusable = true}, SHIFT(503),
  [857] = {.count = 1, .reusable = true}, SHIFT(504),
  [859] = {.count = 1, .reusable = true}, SHIFT(505),
  [861] = {.count = 1, .reusable = true}, SHIFT(506),
  [863] = {.count = 1, .reusable = false}, SHIFT(507),
  [865] = {.count = 1, .reusable = false}, SHIFT(508),
  [867] = {.count = 1, .reusable = true}, SHIFT(507),
  [869] = {.count = 1, .reusable = true}, SHIFT(508),
  [871] = {.count = 1, .reusable = true}, SHIFT(509),
  [873] = {.count = 1, .reusable = false}, SHIFT(510),
  [875] = {.count = 1, .reusable = true}, SHIFT(510),
  [877] = {.count = 1, .reusable = false}, SHIFT(511),
  [879] = {.count = 1, .reusable = true}, SHIFT(511),
  [881] = {.count = 1, .reusable = true}, SHIFT(512),
  [883] = {.count = 1, .reusable = false}, SHIFT(515),
  [885] = {.count = 1, .reusable = true}, SHIFT(516),
  [887] = {.count = 1, .reusable = false}, SHIFT(516),
  [889] = {.count = 1, .reusable = true}, SHIFT(128),
  [891] = {.count = 1, .reusable = false}, SHIFT(522),
  [893] = {.count = 1, .reusable = true}, SHIFT(524),
  [895] = {.count = 1, .reusable = true}, REDUCE(sym_negated_command, 2),
  [897] = {.count = 1, .reusable = false}, REDUCE(sym_negated_command, 2),
  [899] = {.count = 1, .reusable = true}, SHIFT(527),
  [901] = {.count = 1, .reusable = true}, SHIFT(528),
  [903] = {.count = 1, .reusable = false}, SHIFT(529),
  [905] = {.count = 1, .reusable = true}, SHIFT(529),
  [907] = {.count = 1, .reusable = true}, SHIFT(530),
  [909] = {.count = 1, .reusable = false}, SHIFT(532),
  [911] = {.count = 1, .reusable = false}, SHIFT(533),
  [913] = {.count = 1, .reusable = true}, SHIFT(535),
  [915] = {.count = 1, .reusable = true}, SHIFT(536),
  [917] = {.count = 1, .reusable = true}, SHIFT(537),
  [919] = {.count = 1, .reusable = false}, SHIFT(538),
  [921] = {.count = 1, .reusable = true}, SHIFT(538),
  [923] = {.count = 1, .reusable = true}, SHIFT(543),
  [925] = {.count = 1, .reusable = true}, SHIFT(544),
  [927] = {.count = 1, .reusable = false}, SHIFT(543),
  [929] = {.count = 1, .reusable = true}, SHIFT(545),
  [931] = {.count = 1, .reusable = false}, SHIFT(546),
  [933] = {.count = 1, .reusable = true}, SHIFT(550),
  [935] = {.count = 1, .reusable = true}, SHIFT(551),
  [937] = {.count = 1, .reusable = false}, SHIFT(550),
  [939] = {.count = 1, .reusable = false}, SHIFT(552),
  [941] = {.count = 1, .reusable = true}, SHIFT(554),
  [943] = {.count = 1, .reusable = true}, SHIFT(555),
  [945] = {.count = 1, .reusable = true}, SHIFT(556),
  [947] = {.count = 1, .reusable = false}, SHIFT(557),
  [949] = {.count = 1, .reusable = true}, SHIFT(557),
  [951] = {.count = 1, .reusable = true}, SHIFT(558),
  [953] = {.count = 1, .reusable = false}, SHIFT(560),
  [955] = {.count = 1, .reusable = false}, SHIFT(561),
  [957] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 1),
  [959] = {.count = 1, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 1),
  [961] = {.count = 1, .reusable = true}, SHIFT(563),
  [963] = {.count = 1, .reusable = true}, SHIFT(564),
  [965] = {.count = 1, .reusable = true}, SHIFT(565),
  [967] = {.count = 1, .reusable = false}, SHIFT(566),
  [969] = {.count = 1, .reusable = true}, SHIFT(566),
  [971] = {.count = 1, .reusable = true}, REDUCE(sym_declaration_command, 2),
  [973] = {.count = 1, .reusable = false}, REDUCE(sym_declaration_command, 2),
  [975] = {.count = 1, .reusable = false}, SHIFT(571),
  [977] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 1, .alias_sequence_id = 1),
  [979] = {.count = 1, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 1, .alias_sequence_id = 1),
  [981] = {.count = 1, .reusable = true}, SHIFT(572),
  [983] = {.count = 1, .reusable = true}, SHIFT(574),
  [985] = {.count = 1, .reusable = true}, SHIFT(575),
  [987] = {.count = 1, .reusable = false}, SHIFT(576),
  [989] = {.count = 1, .reusable = true}, SHIFT(576),
  [991] = {.count = 1, .reusable = true}, SHIFT(577),
  [993] = {.count = 1, .reusable = false}, SHIFT(579),
  [995] = {.count = 1, .reusable = false}, SHIFT(580),
  [997] = {.count = 1, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 1),
  [999] = {.count = 1, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 1),
  [1001] = {.count = 1, .reusable = true}, SHIFT(582),
  [1003] = {.count = 1, .reusable = true}, SHIFT(583),
  [1005] = {.count = 1, .reusable = true}, SHIFT(584),
  [1007] = {.count = 1, .reusable = false}, SHIFT(585),
  [1009] = {.count = 1, .reusable = true}, SHIFT(585),
  [1011] = {.count = 1, .reusable = true}, REDUCE(sym_unset_command, 2),
  [1013] = {.count = 1, .reusable = false}, REDUCE(sym_unset_command, 2),
  [1015] = {.count = 1, .reusable = false}, SHIFT(590),
  [1017] = {.count = 1, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 1, .alias_sequence_id = 1),
  [1019] = {.count = 1, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 1, .alias_sequence_id = 1),
  [1021] = {.count = 1, .reusable = true}, SHIFT(591),
  [1023] = {.count = 1, .reusable = true}, SHIFT(593),
  [1025] = {.count = 1, .reusable = true}, SHIFT(594),
  [1027] = {.count = 1, .reusable = false}, SHIFT(595),
  [1029] = {.count = 1, .reusable = true}, SHIFT(595),
  [1031] = {.count = 1, .reusable = true}, SHIFT(596),
  [1033] = {.count = 1, .reusable = false}, SHIFT(598),
  [1035] = {.count = 1, .reusable = false}, SHIFT(599),
  [1037] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 2),
  [1039] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 2),
  [1041] = {.count = 1, .reusable = true}, SHIFT(601),
  [1043] = {.count = 1, .reusable = true}, SHIFT(602),
  [1045] = {.count = 1, .reusable = true}, SHIFT(603),
  [1047] = {.count = 1, .reusable = false}, SHIFT(604),
  [1049] = {.count = 1, .reusable = true}, SHIFT(604),
  [1051] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 2, .alias_sequence_id = 2),
  [1053] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 2, .alias_sequence_id = 2),
  [1055] = {.count = 1, .reusable = true}, SHIFT(609),
  [1057] = {.count = 1, .reusable = true}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 3),
  [1059] = {.count = 1, .reusable = false}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 3),
  [1061] = {.count = 1, .reusable = true}, REDUCE(sym_string_expansion, 2),
  [1063] = {.count = 1, .reusable = false}, REDUCE(sym_string_expansion, 2),
  [1065] = {.count = 1, .reusable = true}, REDUCE(sym_simple_expansion, 2),
  [1067] = {.count = 1, .reusable = false}, REDUCE(sym_simple_expansion, 2),
  [1069] = {.count = 1, .reusable = true}, SHIFT(611),
  [1071] = {.count = 1, .reusable = true}, REDUCE(sym_concatenation, 2),
  [1073] = {.count = 1, .reusable = true}, SHIFT(612),
  [1075] = {.count = 1, .reusable = false}, REDUCE(sym_concatenation, 2),
  [1077] = {.count = 1, .reusable = true}, SHIFT(614),
  [1079] = {.count = 1, .reusable = false}, SHIFT(614),
  [1081] = {.count = 1, .reusable = false}, SHIFT(615),
  [1083] = {.count = 1, .reusable = false}, SHIFT(616),
  [1085] = {.count = 1, .reusable = false}, SHIFT(617),
  [1087] = {.count = 1, .reusable = true}, SHIFT(617),
  [1089] = {.count = 1, .reusable = true}, REDUCE(sym_string, 2),
  [1091] = {.count = 1, .reusable = false}, REDUCE(sym_string, 2),
  [1093] = {.count = 1, .reusable = true}, SHIFT(618),
  [1095] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 1),
  [1097] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_repeat1, 1),
  [1099] = {.count = 1, .reusable = true}, SHIFT(619),
  [1101] = {.count = 1, .reusable = true}, SHIFT(620),
  [1103] = {.count = 1, .reusable = true}, SHIFT(621),
  [1105] = {.count = 1, .reusable = false}, SHIFT(622),
  [1107] = {.count = 1, .reusable = true}, SHIFT(622),
  [1109] = {.count = 1, .reusable = false}, SHIFT(626),
  [1111] = {.count = 1, .reusable = true}, SHIFT(628),
  [1113] = {.count = 1, .reusable = true}, SHIFT(629),
  [1115] = {.count = 1, .reusable = true}, SHIFT(630),
  [1117] = {.count = 1, .reusable = true}, SHIFT(631),
  [1119] = {.count = 1, .reusable = false}, SHIFT(632),
  [1121] = {.count = 1, .reusable = true}, SHIFT(632),
  [1123] = {.count = 1, .reusable = true}, SHIFT(633),
  [1125] = {.count = 1, .reusable = false}, SHIFT(644),
  [1127] = {.count = 1, .reusable = false}, SHIFT(634),
  [1129] = {.count = 1, .reusable = false}, SHIFT(635),
  [1131] = {.count = 1, .reusable = true}, SHIFT(636),
  [1133] = {.count = 1, .reusable = true}, SHIFT(637),
  [1135] = {.count = 1, .reusable = true}, SHIFT(644),
  [1137] = {.count = 1, .reusable = true}, SHIFT(638),
  [1139] = {.count = 1, .reusable = true}, SHIFT(639),
  [1141] = {.count = 1, .reusable = true}, SHIFT(640),
  [1143] = {.count = 1, .reusable = true}, SHIFT(641),
  [1145] = {.count = 1, .reusable = true}, SHIFT(642),
  [1147] = {.count = 1, .reusable = false}, SHIFT(637),
  [1149] = {.count = 1, .reusable = true}, SHIFT(645),
  [1151] = {.count = 1, .reusable = false}, SHIFT(647),
  [1153] = {.count = 1, .reusable = true}, SHIFT(647),
  [1155] = {.count = 1, .reusable = true}, SHIFT(646),
  [1157] = {.count = 1, .reusable = false}, SHIFT(648),
  [1159] = {.count = 1, .reusable = true}, SHIFT(648),
  [1161] = {.count = 1, .reusable = true}, SHIFT(649),
  [1163] = {.count = 1, .reusable = true}, SHIFT(650),
  [1165] = {.count = 1, .reusable = true}, SHIFT(652),
  [1167] = {.count = 1, .reusable = true}, SHIFT(653),
  [1169] = {.count = 1, .reusable = true}, SHIFT(654),
  [1171] = {.count = 1, .reusable = true}, SHIFT(655),
  [1173] = {.count = 1, .reusable = true}, SHIFT(656),
  [1175] = {.count = 1, .reusable = false}, SHIFT(658),
  [1177] = {.count = 1, .reusable = false}, SHIFT(656),
  [1179] = {.count = 1, .reusable = true}, SHIFT(660),
  [1181] = {.count = 1, .reusable = true}, SHIFT(661),
  [1183] = {.count = 1, .reusable = false}, SHIFT(662),
  [1185] = {.count = 1, .reusable = false}, SHIFT(661),
  [1187] = {.count = 1, .reusable = true}, SHIFT(665),
  [1189] = {.count = 1, .reusable = false}, SHIFT(666),
  [1191] = {.count = 1, .reusable = false}, SHIFT(667),
  [1193] = {.count = 1, .reusable = true}, SHIFT(666),
  [1195] = {.count = 1, .reusable = true}, SHIFT(667),
  [1197] = {.count = 1, .reusable = true}, SHIFT(668),
  [1199] = {.count = 1, .reusable = false}, SHIFT(669),
  [1201] = {.count = 1, .reusable = true}, SHIFT(669),
  [1203] = {.count = 1, .reusable = true}, SHIFT(670),
  [1205] = {.count = 1, .reusable = false}, SHIFT(673),
  [1207] = {.count = 1, .reusable = true}, SHIFT(221),
  [1209] = {.count = 1, .reusable = true}, SHIFT(674),
  [1211] = {.count = 1, .reusable = false}, SHIFT(674),
  [1213] = {.count = 1, .reusable = true}, SHIFT(681),
  [1215] = {.count = 1, .reusable = true}, SHIFT(682),
  [1217] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 1),
  [1219] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_body, 1),
  [1221] = {.count = 1, .reusable = true}, SHIFT(688),
  [1223] = {.count = 1, .reusable = true}, SHIFT(683),
  [1225] = {.count = 1, .reusable = false}, SHIFT(684),
  [1227] = {.count = 1, .reusable = true}, SHIFT(685),
  [1229] = {.count = 1, .reusable = true}, SHIFT(686),
  [1231] = {.count = 1, .reusable = true}, SHIFT(687),
  [1233] = {.count = 1, .reusable = false}, SHIFT(689),
  [1235] = {.count = 1, .reusable = true}, SHIFT(689),
  [1237] = {.count = 1, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2),
  [1239] = {.count = 1, .reusable = true}, REDUCE(sym__statements, 2),
  [1241] = {.count = 1, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2),
  [1243] = {.count = 1, .reusable = true}, SHIFT(694),
  [1245] = {.count = 1, .reusable = true}, SHIFT(695),
  [1247] = {.count = 1, .reusable = true}, SHIFT(698),
  [1249] = {.count = 1, .reusable = true}, SHIFT(699),
  [1251] = {.count = 1, .reusable = false}, SHIFT(702),
  [1253] = {.count = 1, .reusable = true}, SHIFT(702),
  [1255] = {.count = 1, .reusable = true}, REDUCE(sym_redirected_statement, 2),
  [1257] = {.count = 1, .reusable = false}, REDUCE(sym_redirected_statement, 2),
  [1259] = {.count = 1, .reusable = true}, SHIFT(704),
  [1261] = {.count = 1, .reusable = true}, SHIFT(705),
  [1263] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 1),
  [1265] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 1),
  [1267] = {.count = 1, .reusable = true}, REDUCE(sym_command, 2),
  [1269] = {.count = 1, .reusable = false}, REDUCE(sym_command, 2),
  [1271] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 1, .alias_sequence_id = 1),
  [1273] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 1, .alias_sequence_id = 1),
  [1275] = {.count = 1, .reusable = false}, SHIFT(708),
  [1277] = {.count = 1, .reusable = true}, SHIFT(708),
  [1279] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(2),
  [1282] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(217),
  [1285] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(4),
  [1288] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(5),
  [1291] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(6),
  [1294] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(7),
  [1297] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(8),
  [1300] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(9),
  [1303] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(10),
  [1306] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(11),
  [1309] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(710),
  [1312] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(13),
  [1315] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(14),
  [1318] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(711),
  [1321] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(712),
  [1324] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(17),
  [1327] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(17),
  [1330] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(18),
  [1333] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(221),
  [1336] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(20),
  [1339] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(222),
  [1342] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(22),
  [1345] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(23),
  [1348] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(24),
  [1351] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(25),
  [1354] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(223),
  [1357] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(2),
  [1360] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(145),
  [1363] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(17),
  [1366] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(17),
  [1369] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat1, 2),
  [1371] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2),
  [1373] = {.count = 1, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2),
  [1375] = {.count = 1, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2),
  [1377] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(254),
  [1380] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 3),
  [1382] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 3),
  [1384] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 3, .alias_sequence_id = 4),
  [1386] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 3, .alias_sequence_id = 4),
  [1388] = {.count = 1, .reusable = true}, SHIFT(719),
  [1390] = {.count = 1, .reusable = true}, SHIFT(720),
  [1392] = {.count = 1, .reusable = true}, SHIFT(721),
  [1394] = {.count = 1, .reusable = true}, SHIFT(722),
  [1396] = {.count = 1, .reusable = true}, SHIFT(723),
  [1398] = {.count = 1, .reusable = false}, SHIFT(724),
  [1400] = {.count = 1, .reusable = true}, REDUCE(sym_variable_assignment, 3),
  [1402] = {.count = 1, .reusable = false}, REDUCE(sym_variable_assignment, 3),
  [1404] = {.count = 1, .reusable = true}, SHIFT(726),
  [1406] = {.count = 1, .reusable = false}, SHIFT(727),
  [1408] = {.count = 1, .reusable = true}, SHIFT(728),
  [1410] = {.count = 1, .reusable = true}, SHIFT(729),
  [1412] = {.count = 1, .reusable = true}, SHIFT(730),
  [1414] = {.count = 1, .reusable = true}, SHIFT(731),
  [1416] = {.count = 1, .reusable = true}, SHIFT(732),
  [1418] = {.count = 1, .reusable = true}, SHIFT(733),
  [1420] = {.count = 1, .reusable = true}, SHIFT(734),
  [1422] = {.count = 1, .reusable = true}, SHIFT(737),
  [1424] = {.count = 1, .reusable = true}, SHIFT(738),
  [1426] = {.count = 1, .reusable = false}, SHIFT(739),
  [1428] = {.count = 1, .reusable = true}, SHIFT(739),
  [1430] = {.count = 1, .reusable = true}, SHIFT(740),
  [1432] = {.count = 1, .reusable = false}, SHIFT(742),
  [1434] = {.count = 1, .reusable = false}, SHIFT(743),
  [1436] = {.count = 1, .reusable = true}, SHIFT(745),
  [1438] = {.count = 1, .reusable = true}, SHIFT(746),
  [1440] = {.count = 1, .reusable = true}, SHIFT(747),
  [1442] = {.count = 1, .reusable = false}, SHIFT(748),
  [1444] = {.count = 1, .reusable = true}, SHIFT(748),
  [1446] = {.count = 1, .reusable = true}, REDUCE(sym_variable_assignment, 3, .alias_sequence_id = 4),
  [1448] = {.count = 1, .reusable = false}, REDUCE(sym_variable_assignment, 3, .alias_sequence_id = 4),
  [1450] = {.count = 1, .reusable = true}, SHIFT(753),
  [1452] = {.count = 1, .reusable = false}, SHIFT(755),
  [1454] = {.count = 1, .reusable = true}, SHIFT(755),
  [1456] = {.count = 1, .reusable = true}, SHIFT(759),
  [1458] = {.count = 1, .reusable = true}, SHIFT(760),
  [1460] = {.count = 1, .reusable = false}, SHIFT(761),
  [1462] = {.count = 1, .reusable = true}, SHIFT(761),
  [1464] = {.count = 1, .reusable = true}, SHIFT(762),
  [1466] = {.count = 1, .reusable = false}, SHIFT(764),
  [1468] = {.count = 1, .reusable = false}, SHIFT(765),
  [1470] = {.count = 1, .reusable = true}, SHIFT(767),
  [1472] = {.count = 1, .reusable = true}, SHIFT(768),
  [1474] = {.count = 1, .reusable = true}, SHIFT(769),
  [1476] = {.count = 1, .reusable = false}, SHIFT(770),
  [1478] = {.count = 1, .reusable = true}, SHIFT(770),
  [1480] = {.count = 1, .reusable = false}, SHIFT(775),
  [1482] = {.count = 1, .reusable = true}, SHIFT(775),
  [1484] = {.count = 1, .reusable = true}, SHIFT(776),
  [1486] = {.count = 1, .reusable = true}, SHIFT(777),
  [1488] = {.count = 1, .reusable = false}, SHIFT(776),
  [1490] = {.count = 1, .reusable = true}, SHIFT(778),
  [1492] = {.count = 1, .reusable = true}, SHIFT(779),
  [1494] = {.count = 1, .reusable = false}, SHIFT(781),
  [1496] = {.count = 1, .reusable = true}, SHIFT(782),
  [1498] = {.count = 1, .reusable = true}, SHIFT(783),
  [1500] = {.count = 1, .reusable = true}, SHIFT(784),
  [1502] = {.count = 1, .reusable = true}, SHIFT(785),
  [1504] = {.count = 1, .reusable = true}, SHIFT(786),
  [1506] = {.count = 1, .reusable = true}, SHIFT(787),
  [1508] = {.count = 1, .reusable = true}, SHIFT(788),
  [1510] = {.count = 1, .reusable = true}, SHIFT(794),
  [1512] = {.count = 1, .reusable = true}, SHIFT(795),
  [1514] = {.count = 1, .reusable = false}, SHIFT(796),
  [1516] = {.count = 1, .reusable = true}, SHIFT(796),
  [1518] = {.count = 1, .reusable = true}, SHIFT(797),
  [1520] = {.count = 1, .reusable = false}, SHIFT(799),
  [1522] = {.count = 1, .reusable = false}, SHIFT(800),
  [1524] = {.count = 1, .reusable = true}, SHIFT(802),
  [1526] = {.count = 1, .reusable = true}, SHIFT(803),
  [1528] = {.count = 1, .reusable = true}, SHIFT(804),
  [1530] = {.count = 1, .reusable = false}, SHIFT(805),
  [1532] = {.count = 1, .reusable = true}, SHIFT(805),
  [1534] = {.count = 1, .reusable = true}, SHIFT(810),
  [1536] = {.count = 1, .reusable = true}, SHIFT(811),
  [1538] = {.count = 1, .reusable = true}, SHIFT(812),
  [1540] = {.count = 1, .reusable = false}, SHIFT(811),
  [1542] = {.count = 1, .reusable = true}, SHIFT(813),
  [1544] = {.count = 1, .reusable = true}, SHIFT(814),
  [1546] = {.count = 1, .reusable = true}, REDUCE(sym_unary_expression, 2),
  [1548] = {.count = 1, .reusable = true}, SHIFT(816),
  [1550] = {.count = 1, .reusable = true}, SHIFT(817),
  [1552] = {.count = 1, .reusable = false}, SHIFT(819),
  [1554] = {.count = 1, .reusable = false}, SHIFT(820),
  [1556] = {.count = 1, .reusable = true}, SHIFT(821),
  [1558] = {.count = 1, .reusable = true}, SHIFT(822),
  [1560] = {.count = 1, .reusable = true}, SHIFT(823),
  [1562] = {.count = 1, .reusable = false}, SHIFT(824),
  [1564] = {.count = 1, .reusable = true}, SHIFT(824),
  [1566] = {.count = 1, .reusable = true}, SHIFT(825),
  [1568] = {.count = 1, .reusable = false}, SHIFT(827),
  [1570] = {.count = 1, .reusable = true}, SHIFT(827),
  [1572] = {.count = 1, .reusable = true}, SHIFT(826),
  [1574] = {.count = 1, .reusable = true}, SHIFT(828),
  [1576] = {.count = 1, .reusable = false}, SHIFT(830),
  [1578] = {.count = 1, .reusable = true}, SHIFT(830),
  [1580] = {.count = 1, .reusable = true}, SHIFT(829),
  [1582] = {.count = 1, .reusable = true}, SHIFT(831),
  [1584] = {.count = 1, .reusable = true}, SHIFT(832),
  [1586] = {.count = 1, .reusable = true}, REDUCE(sym_test_command, 3),
  [1588] = {.count = 1, .reusable = false}, REDUCE(sym_test_command, 3),
  [1590] = {.count = 1, .reusable = true}, SHIFT(834),
  [1592] = {.count = 1, .reusable = true}, REDUCE(sym_postfix_expression, 2),
  [1594] = {.count = 1, .reusable = false}, REDUCE(sym_postfix_expression, 2),
  [1596] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(322),
  [1599] = {.count = 1, .reusable = true}, SHIFT(835),
  [1601] = {.count = 1, .reusable = true}, SHIFT(836),
  [1603] = {.count = 1, .reusable = false}, SHIFT(837),
  [1605] = {.count = 1, .reusable = true}, SHIFT(838),
  [1607] = {.count = 1, .reusable = true}, SHIFT(839),
  [1609] = {.count = 1, .reusable = true}, SHIFT(840),
  [1611] = {.count = 1, .reusable = true}, SHIFT(841),
  [1613] = {.count = 1, .reusable = true}, SHIFT(842),
  [1615] = {.count = 1, .reusable = true}, SHIFT(843),
  [1617] = {.count = 1, .reusable = true}, SHIFT(844),
  [1619] = {.count = 1, .reusable = false}, SHIFT(846),
  [1621] = {.count = 1, .reusable = true}, SHIFT(846),
  [1623] = {.count = 1, .reusable = true}, SHIFT(848),
  [1625] = {.count = 1, .reusable = false}, SHIFT(849),
  [1627] = {.count = 1, .reusable = true}, SHIFT(849),
  [1629] = {.count = 1, .reusable = true}, SHIFT(850),
  [1631] = {.count = 1, .reusable = true}, SHIFT(851),
  [1633] = {.count = 1, .reusable = true}, SHIFT(853),
  [1635] = {.count = 1, .reusable = true}, SHIFT(854),
  [1637] = {.count = 1, .reusable = false}, SHIFT(855),
  [1639] = {.count = 1, .reusable = true}, SHIFT(855),
  [1641] = {.count = 1, .reusable = true}, SHIFT(856),
  [1643] = {.count = 1, .reusable = false}, SHIFT(857),
  [1645] = {.count = 1, .reusable = true}, SHIFT(857),
  [1647] = {.count = 1, .reusable = true}, SHIFT(858),
  [1649] = {.count = 1, .reusable = true}, SHIFT(860),
  [1651] = {.count = 1, .reusable = true}, SHIFT(861),
  [1653] = {.count = 1, .reusable = true}, SHIFT(862),
  [1655] = {.count = 1, .reusable = true}, SHIFT(863),
  [1657] = {.count = 1, .reusable = true}, SHIFT(864),
  [1659] = {.count = 1, .reusable = false}, SHIFT(865),
  [1661] = {.count = 1, .reusable = true}, SHIFT(865),
  [1663] = {.count = 1, .reusable = true}, SHIFT(866),
  [1665] = {.count = 1, .reusable = false}, SHIFT(868),
  [1667] = {.count = 1, .reusable = false}, SHIFT(869),
  [1669] = {.count = 1, .reusable = true}, SHIFT(871),
  [1671] = {.count = 1, .reusable = true}, SHIFT(872),
  [1673] = {.count = 1, .reusable = true}, SHIFT(873),
  [1675] = {.count = 1, .reusable = false}, SHIFT(874),
  [1677] = {.count = 1, .reusable = true}, SHIFT(874),
  [1679] = {.count = 1, .reusable = false}, SHIFT(879),
  [1681] = {.count = 1, .reusable = true}, SHIFT(880),
  [1683] = {.count = 1, .reusable = true}, SHIFT(882),
  [1685] = {.count = 1, .reusable = true}, SHIFT(883),
  [1687] = {.count = 1, .reusable = false}, SHIFT(884),
  [1689] = {.count = 1, .reusable = true}, SHIFT(884),
  [1691] = {.count = 1, .reusable = true}, SHIFT(885),
  [1693] = {.count = 1, .reusable = false}, SHIFT(887),
  [1695] = {.count = 1, .reusable = false}, SHIFT(888),
  [1697] = {.count = 1, .reusable = true}, SHIFT(890),
  [1699] = {.count = 1, .reusable = true}, SHIFT(891),
  [1701] = {.count = 1, .reusable = true}, SHIFT(892),
  [1703] = {.count = 1, .reusable = false}, SHIFT(893),
  [1705] = {.count = 1, .reusable = true}, SHIFT(893),
  [1707] = {.count = 1, .reusable = false}, SHIFT(898),
  [1709] = {.count = 1, .reusable = true}, SHIFT(899),
  [1711] = {.count = 1, .reusable = true}, SHIFT(901),
  [1713] = {.count = 1, .reusable = true}, SHIFT(902),
  [1715] = {.count = 1, .reusable = false}, SHIFT(904),
  [1717] = {.count = 1, .reusable = false}, SHIFT(905),
  [1719] = {.count = 1, .reusable = true}, SHIFT(906),
  [1721] = {.count = 1, .reusable = true}, SHIFT(907),
  [1723] = {.count = 1, .reusable = true}, SHIFT(908),
  [1725] = {.count = 1, .reusable = false}, SHIFT(909),
  [1727] = {.count = 1, .reusable = true}, SHIFT(909),
  [1729] = {.count = 1, .reusable = true}, SHIFT(910),
  [1731] = {.count = 1, .reusable = false}, SHIFT(912),
  [1733] = {.count = 1, .reusable = true}, SHIFT(912),
  [1735] = {.count = 1, .reusable = true}, SHIFT(911),
  [1737] = {.count = 1, .reusable = true}, SHIFT(913),
  [1739] = {.count = 1, .reusable = false}, SHIFT(915),
  [1741] = {.count = 1, .reusable = true}, SHIFT(915),
  [1743] = {.count = 1, .reusable = true}, SHIFT(914),
  [1745] = {.count = 1, .reusable = true}, SHIFT(916),
  [1747] = {.count = 1, .reusable = true}, SHIFT(917),
  [1749] = {.count = 1, .reusable = true}, SHIFT(918),
  [1751] = {.count = 1, .reusable = true}, SHIFT(919),
  [1753] = {.count = 1, .reusable = false}, SHIFT(920),
  [1755] = {.count = 1, .reusable = false}, SHIFT(921),
  [1757] = {.count = 1, .reusable = false}, SHIFT(922),
  [1759] = {.count = 1, .reusable = false}, SHIFT(923),
  [1761] = {.count = 1, .reusable = false}, SHIFT(924),
  [1763] = {.count = 1, .reusable = false}, SHIFT(925),
  [1765] = {.count = 1, .reusable = true}, SHIFT(926),
  [1767] = {.count = 1, .reusable = true}, SHIFT(927),
  [1769] = {.count = 1, .reusable = true}, SHIFT(928),
  [1771] = {.count = 1, .reusable = true}, SHIFT(929),
  [1773] = {.count = 1, .reusable = true}, SHIFT(930),
  [1775] = {.count = 1, .reusable = true}, SHIFT(931),
  [1777] = {.count = 1, .reusable = false}, SHIFT(932),
  [1779] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 3),
  [1781] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 3),
  [1783] = {.count = 1, .reusable = false}, SHIFT(942),
  [1785] = {.count = 1, .reusable = true}, SHIFT(942),
  [1787] = {.count = 1, .reusable = true}, REDUCE(sym__terminated_statement, 2),
  [1789] = {.count = 1, .reusable = true}, SHIFT(947),
  [1791] = {.count = 1, .reusable = true}, SHIFT(948),
  [1793] = {.count = 1, .reusable = true}, SHIFT(951),
  [1795] = {.count = 1, .reusable = true}, SHIFT(952),
  [1797] = {.count = 1, .reusable = true}, SHIFT(956),
  [1799] = {.count = 1, .reusable = true}, SHIFT(957),
  [1801] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(394),
  [1804] = {.count = 1, .reusable = true}, SHIFT(961),
  [1806] = {.count = 1, .reusable = false}, SHIFT(962),
  [1808] = {.count = 1, .reusable = false}, SHIFT(963),
  [1810] = {.count = 1, .reusable = false}, SHIFT(964),
  [1812] = {.count = 1, .reusable = false}, SHIFT(965),
  [1814] = {.count = 1, .reusable = false}, SHIFT(966),
  [1816] = {.count = 1, .reusable = false}, SHIFT(967),
  [1818] = {.count = 1, .reusable = false}, SHIFT(968),
  [1820] = {.count = 1, .reusable = false}, SHIFT(969),
  [1822] = {.count = 1, .reusable = true}, SHIFT(970),
  [1824] = {.count = 1, .reusable = true}, SHIFT(971),
  [1826] = {.count = 1, .reusable = true}, SHIFT(972),
  [1828] = {.count = 1, .reusable = true}, SHIFT(973),
  [1830] = {.count = 1, .reusable = true}, SHIFT(974),
  [1832] = {.count = 1, .reusable = true}, SHIFT(975),
  [1834] = {.count = 1, .reusable = false}, SHIFT(976),
  [1836] = {.count = 1, .reusable = true}, SHIFT(988),
  [1838] = {.count = 1, .reusable = true}, SHIFT(989),
  [1840] = {.count = 1, .reusable = false}, SHIFT(991),
  [1842] = {.count = 1, .reusable = false}, SHIFT(992),
  [1844] = {.count = 1, .reusable = false}, SHIFT(993),
  [1846] = {.count = 1, .reusable = true}, SHIFT(993),
  [1848] = {.count = 1, .reusable = true}, SHIFT(994),
  [1850] = {.count = 1, .reusable = true}, SHIFT(995),
  [1852] = {.count = 1, .reusable = true}, SHIFT(996),
  [1854] = {.count = 1, .reusable = true}, SHIFT(997),
  [1856] = {.count = 1, .reusable = false}, SHIFT(998),
  [1858] = {.count = 1, .reusable = true}, SHIFT(998),
  [1860] = {.count = 1, .reusable = true}, SHIFT(999),
  [1862] = {.count = 1, .reusable = false}, SHIFT(1001),
  [1864] = {.count = 1, .reusable = true}, SHIFT(1001),
  [1866] = {.count = 1, .reusable = true}, SHIFT(1000),
  [1868] = {.count = 1, .reusable = true}, SHIFT(1002),
  [1870] = {.count = 1, .reusable = false}, SHIFT(1004),
  [1872] = {.count = 1, .reusable = true}, SHIFT(1004),
  [1874] = {.count = 1, .reusable = true}, SHIFT(1003),
  [1876] = {.count = 1, .reusable = true}, SHIFT(1005),
  [1878] = {.count = 1, .reusable = true}, SHIFT(1006),
  [1880] = {.count = 1, .reusable = false}, SHIFT(1007),
  [1882] = {.count = 1, .reusable = true}, SHIFT(1007),
  [1884] = {.count = 1, .reusable = true}, SHIFT(1008),
  [1886] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(417),
  [1889] = {.count = 1, .reusable = true}, SHIFT(1009),
  [1891] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 3),
  [1893] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 3),
  [1895] = {.count = 1, .reusable = true}, SHIFT(1010),
  [1897] = {.count = 1, .reusable = true}, SHIFT(1011),
  [1899] = {.count = 1, .reusable = true}, SHIFT(1013),
  [1901] = {.count = 1, .reusable = false}, SHIFT(1015),
  [1903] = {.count = 1, .reusable = false}, SHIFT(1018),
  [1905] = {.count = 1, .reusable = true}, REDUCE(sym_subshell, 3),
  [1907] = {.count = 1, .reusable = false}, REDUCE(sym_subshell, 3),
  [1909] = {.count = 1, .reusable = false}, SHIFT(1021),
  [1911] = {.count = 1, .reusable = true}, SHIFT(1021),
  [1913] = {.count = 1, .reusable = true}, SHIFT(1026),
  [1915] = {.count = 1, .reusable = true}, SHIFT(1027),
  [1917] = {.count = 1, .reusable = true}, SHIFT(1029),
  [1919] = {.count = 1, .reusable = true}, SHIFT(1032),
  [1921] = {.count = 1, .reusable = true}, SHIFT(1036),
  [1923] = {.count = 1, .reusable = true}, SHIFT(1037),
  [1925] = {.count = 1, .reusable = false}, SHIFT(1038),
  [1927] = {.count = 1, .reusable = true}, SHIFT(1039),
  [1929] = {.count = 1, .reusable = true}, SHIFT(1040),
  [1931] = {.count = 1, .reusable = true}, SHIFT(1041),
  [1933] = {.count = 1, .reusable = true}, SHIFT(1042),
  [1935] = {.count = 1, .reusable = true}, SHIFT(1043),
  [1937] = {.count = 1, .reusable = true}, SHIFT(1044),
  [1939] = {.count = 1, .reusable = true}, SHIFT(1045),
  [1941] = {.count = 1, .reusable = false}, SHIFT(1047),
  [1943] = {.count = 1, .reusable = true}, SHIFT(1047),
  [1945] = {.count = 1, .reusable = true}, SHIFT(1049),
  [1947] = {.count = 1, .reusable = false}, SHIFT(1050),
  [1949] = {.count = 1, .reusable = true}, SHIFT(1050),
  [1951] = {.count = 1, .reusable = true}, SHIFT(1051),
  [1953] = {.count = 1, .reusable = true}, SHIFT(1052),
  [1955] = {.count = 1, .reusable = true}, SHIFT(1054),
  [1957] = {.count = 1, .reusable = true}, SHIFT(1055),
  [1959] = {.count = 1, .reusable = false}, SHIFT(1056),
  [1961] = {.count = 1, .reusable = true}, SHIFT(1056),
  [1963] = {.count = 1, .reusable = true}, SHIFT(1057),
  [1965] = {.count = 1, .reusable = false}, SHIFT(1058),
  [1967] = {.count = 1, .reusable = true}, SHIFT(1058),
  [1969] = {.count = 1, .reusable = true}, SHIFT(1059),
  [1971] = {.count = 1, .reusable = true}, SHIFT(1061),
  [1973] = {.count = 1, .reusable = true}, SHIFT(1062),
  [1975] = {.count = 1, .reusable = true}, SHIFT(1063),
  [1977] = {.count = 1, .reusable = true}, SHIFT(1064),
  [1979] = {.count = 1, .reusable = true}, SHIFT(1065),
  [1981] = {.count = 1, .reusable = false}, SHIFT(1066),
  [1983] = {.count = 1, .reusable = true}, SHIFT(1066),
  [1985] = {.count = 1, .reusable = true}, SHIFT(1067),
  [1987] = {.count = 1, .reusable = false}, SHIFT(1069),
  [1989] = {.count = 1, .reusable = false}, SHIFT(1070),
  [1991] = {.count = 1, .reusable = true}, SHIFT(1072),
  [1993] = {.count = 1, .reusable = true}, SHIFT(1073),
  [1995] = {.count = 1, .reusable = true}, SHIFT(1074),
  [1997] = {.count = 1, .reusable = false}, SHIFT(1075),
  [1999] = {.count = 1, .reusable = true}, SHIFT(1075),
  [2001] = {.count = 1, .reusable = false}, SHIFT(1080),
  [2003] = {.count = 1, .reusable = false}, SHIFT(1081),
  [2005] = {.count = 1, .reusable = true}, SHIFT(1083),
  [2007] = {.count = 1, .reusable = true}, SHIFT(1084),
  [2009] = {.count = 1, .reusable = false}, SHIFT(1085),
  [2011] = {.count = 1, .reusable = true}, SHIFT(1085),
  [2013] = {.count = 1, .reusable = true}, SHIFT(1086),
  [2015] = {.count = 1, .reusable = false}, SHIFT(1088),
  [2017] = {.count = 1, .reusable = false}, SHIFT(1089),
  [2019] = {.count = 1, .reusable = true}, SHIFT(1091),
  [2021] = {.count = 1, .reusable = true}, SHIFT(1092),
  [2023] = {.count = 1, .reusable = true}, SHIFT(1093),
  [2025] = {.count = 1, .reusable = false}, SHIFT(1094),
  [2027] = {.count = 1, .reusable = true}, SHIFT(1094),
  [2029] = {.count = 1, .reusable = false}, SHIFT(1099),
  [2031] = {.count = 1, .reusable = false}, SHIFT(1100),
  [2033] = {.count = 1, .reusable = true}, SHIFT(1102),
  [2035] = {.count = 1, .reusable = true}, SHIFT(1103),
  [2037] = {.count = 1, .reusable = false}, SHIFT(1105),
  [2039] = {.count = 1, .reusable = false}, SHIFT(1106),
  [2041] = {.count = 1, .reusable = true}, SHIFT(1107),
  [2043] = {.count = 1, .reusable = true}, SHIFT(1108),
  [2045] = {.count = 1, .reusable = true}, SHIFT(1109),
  [2047] = {.count = 1, .reusable = false}, SHIFT(1110),
  [2049] = {.count = 1, .reusable = true}, SHIFT(1110),
  [2051] = {.count = 1, .reusable = true}, SHIFT(1111),
  [2053] = {.count = 1, .reusable = false}, SHIFT(1113),
  [2055] = {.count = 1, .reusable = true}, SHIFT(1113),
  [2057] = {.count = 1, .reusable = true}, SHIFT(1112),
  [2059] = {.count = 1, .reusable = true}, SHIFT(1114),
  [2061] = {.count = 1, .reusable = false}, SHIFT(1116),
  [2063] = {.count = 1, .reusable = true}, SHIFT(1116),
  [2065] = {.count = 1, .reusable = true}, SHIFT(1115),
  [2067] = {.count = 1, .reusable = true}, SHIFT(1117),
  [2069] = {.count = 1, .reusable = true}, SHIFT(1118),
  [2071] = {.count = 1, .reusable = true}, SHIFT(1119),
  [2073] = {.count = 1, .reusable = true}, REDUCE(sym_compound_statement, 3),
  [2075] = {.count = 1, .reusable = false}, REDUCE(sym_compound_statement, 3),
  [2077] = {.count = 1, .reusable = true}, SHIFT(1121),
  [2079] = {.count = 1, .reusable = true}, SHIFT(1120),
  [2081] = {.count = 1, .reusable = false}, SHIFT(1122),
  [2083] = {.count = 1, .reusable = true}, SHIFT(1122),
  [2085] = {.count = 1, .reusable = true}, SHIFT(1127),
  [2087] = {.count = 1, .reusable = true}, SHIFT(1128),
  [2089] = {.count = 1, .reusable = true}, SHIFT(1131),
  [2091] = {.count = 1, .reusable = true}, SHIFT(1132),
  [2093] = {.count = 1, .reusable = false}, SHIFT(1135),
  [2095] = {.count = 1, .reusable = true}, SHIFT(1135),
  [2097] = {.count = 1, .reusable = true}, SHIFT(1137),
  [2099] = {.count = 1, .reusable = true}, SHIFT(1138),
  [2101] = {.count = 1, .reusable = false}, SHIFT(1141),
  [2103] = {.count = 1, .reusable = true}, SHIFT(1141),
  [2105] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(522),
  [2108] = {.count = 1, .reusable = true}, SHIFT(1144),
  [2110] = {.count = 1, .reusable = true}, SHIFT(1145),
  [2112] = {.count = 1, .reusable = true}, SHIFT(1146),
  [2114] = {.count = 1, .reusable = true}, SHIFT(1148),
  [2116] = {.count = 1, .reusable = true}, SHIFT(1149),
  [2118] = {.count = 1, .reusable = true}, SHIFT(1150),
  [2120] = {.count = 1, .reusable = false}, SHIFT(1152),
  [2122] = {.count = 1, .reusable = false}, SHIFT(1153),
  [2124] = {.count = 1, .reusable = true}, SHIFT(1154),
  [2126] = {.count = 1, .reusable = true}, SHIFT(1155),
  [2128] = {.count = 1, .reusable = true}, SHIFT(1156),
  [2130] = {.count = 1, .reusable = false}, SHIFT(1157),
  [2132] = {.count = 1, .reusable = true}, SHIFT(1157),
  [2134] = {.count = 1, .reusable = true}, SHIFT(1158),
  [2136] = {.count = 1, .reusable = false}, SHIFT(1160),
  [2138] = {.count = 1, .reusable = true}, SHIFT(1160),
  [2140] = {.count = 1, .reusable = true}, SHIFT(1159),
  [2142] = {.count = 1, .reusable = true}, SHIFT(1161),
  [2144] = {.count = 1, .reusable = false}, SHIFT(1163),
  [2146] = {.count = 1, .reusable = true}, SHIFT(1163),
  [2148] = {.count = 1, .reusable = true}, SHIFT(1162),
  [2150] = {.count = 1, .reusable = true}, SHIFT(1164),
  [2152] = {.count = 1, .reusable = true}, SHIFT(1165),
  [2154] = {.count = 1, .reusable = true}, SHIFT(1167),
  [2156] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(546),
  [2159] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(552),
  [2162] = {.count = 1, .reusable = true}, SHIFT(1169),
  [2164] = {.count = 1, .reusable = true}, SHIFT(1170),
  [2166] = {.count = 1, .reusable = true}, SHIFT(1171),
  [2168] = {.count = 1, .reusable = true}, SHIFT(1173),
  [2170] = {.count = 1, .reusable = true}, SHIFT(1174),
  [2172] = {.count = 1, .reusable = false}, SHIFT(1176),
  [2174] = {.count = 1, .reusable = false}, SHIFT(1177),
  [2176] = {.count = 1, .reusable = true}, SHIFT(1178),
  [2178] = {.count = 1, .reusable = true}, SHIFT(1179),
  [2180] = {.count = 1, .reusable = true}, SHIFT(1180),
  [2182] = {.count = 1, .reusable = false}, SHIFT(1181),
  [2184] = {.count = 1, .reusable = true}, SHIFT(1181),
  [2186] = {.count = 1, .reusable = true}, SHIFT(1182),
  [2188] = {.count = 1, .reusable = false}, SHIFT(1184),
  [2190] = {.count = 1, .reusable = true}, SHIFT(1184),
  [2192] = {.count = 1, .reusable = true}, SHIFT(1183),
  [2194] = {.count = 1, .reusable = true}, SHIFT(1185),
  [2196] = {.count = 1, .reusable = false}, SHIFT(1187),
  [2198] = {.count = 1, .reusable = true}, SHIFT(1187),
  [2200] = {.count = 1, .reusable = true}, SHIFT(1186),
  [2202] = {.count = 1, .reusable = true}, SHIFT(1188),
  [2204] = {.count = 1, .reusable = true}, SHIFT(1189),
  [2206] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2),
  [2208] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(165),
  [2211] = {.count = 1, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2),
  [2213] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(166),
  [2216] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(167),
  [2219] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(168),
  [2222] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(169),
  [2225] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(170),
  [2228] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(171),
  [2231] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(172),
  [2234] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(173),
  [2237] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(571),
  [2240] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(169),
  [2243] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(572),
  [2246] = {.count = 1, .reusable = true}, SHIFT(1190),
  [2248] = {.count = 1, .reusable = true}, SHIFT(1191),
  [2250] = {.count = 1, .reusable = false}, SHIFT(1193),
  [2252] = {.count = 1, .reusable = false}, SHIFT(1194),
  [2254] = {.count = 1, .reusable = true}, SHIFT(1195),
  [2256] = {.count = 1, .reusable = true}, SHIFT(1196),
  [2258] = {.count = 1, .reusable = true}, SHIFT(1197),
  [2260] = {.count = 1, .reusable = false}, SHIFT(1198),
  [2262] = {.count = 1, .reusable = true}, SHIFT(1198),
  [2264] = {.count = 1, .reusable = true}, SHIFT(1199),
  [2266] = {.count = 1, .reusable = false}, SHIFT(1201),
  [2268] = {.count = 1, .reusable = true}, SHIFT(1201),
  [2270] = {.count = 1, .reusable = true}, SHIFT(1200),
  [2272] = {.count = 1, .reusable = true}, SHIFT(1202),
  [2274] = {.count = 1, .reusable = false}, SHIFT(1204),
  [2276] = {.count = 1, .reusable = true}, SHIFT(1204),
  [2278] = {.count = 1, .reusable = true}, SHIFT(1203),
  [2280] = {.count = 1, .reusable = true}, SHIFT(1205),
  [2282] = {.count = 1, .reusable = true}, SHIFT(1206),
  [2284] = {.count = 1, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2),
  [2286] = {.count = 1, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2),
  [2288] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(177),
  [2291] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(178),
  [2294] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(179),
  [2297] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(180),
  [2300] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(181),
  [2303] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(182),
  [2306] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(183),
  [2309] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(184),
  [2312] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(590),
  [2315] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(180),
  [2318] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(591),
  [2321] = {.count = 1, .reusable = true}, SHIFT(1207),
  [2323] = {.count = 1, .reusable = true}, SHIFT(1208),
  [2325] = {.count = 1, .reusable = false}, SHIFT(1210),
  [2327] = {.count = 1, .reusable = false}, SHIFT(1211),
  [2329] = {.count = 1, .reusable = true}, SHIFT(1212),
  [2331] = {.count = 1, .reusable = true}, SHIFT(1213),
  [2333] = {.count = 1, .reusable = true}, SHIFT(1214),
  [2335] = {.count = 1, .reusable = false}, SHIFT(1215),
  [2337] = {.count = 1, .reusable = true}, SHIFT(1215),
  [2339] = {.count = 1, .reusable = true}, SHIFT(1216),
  [2341] = {.count = 1, .reusable = false}, SHIFT(1218),
  [2343] = {.count = 1, .reusable = true}, SHIFT(1218),
  [2345] = {.count = 1, .reusable = true}, SHIFT(1217),
  [2347] = {.count = 1, .reusable = true}, SHIFT(1219),
  [2349] = {.count = 1, .reusable = false}, SHIFT(1221),
  [2351] = {.count = 1, .reusable = true}, SHIFT(1221),
  [2353] = {.count = 1, .reusable = true}, SHIFT(1220),
  [2355] = {.count = 1, .reusable = true}, SHIFT(1222),
  [2357] = {.count = 1, .reusable = true}, SHIFT(1223),
  [2359] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(609),
  [2362] = {.count = 1, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [2364] = {.count = 1, .reusable = false}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [2366] = {.count = 1, .reusable = false}, SHIFT(1224),
  [2368] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(200),
  [2371] = {.count = 1, .reusable = true}, REDUCE(sym_string, 3),
  [2373] = {.count = 1, .reusable = false}, REDUCE(sym_string, 3),
  [2375] = {.count = 1, .reusable = true}, SHIFT(1225),
  [2377] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2),
  [2379] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2),
  [2381] = {.count = 1, .reusable = true}, SHIFT(1226),
  [2383] = {.count = 1, .reusable = true}, SHIFT(1227),
  [2385] = {.count = 1, .reusable = true}, SHIFT(1228),
  [2387] = {.count = 1, .reusable = false}, SHIFT(1229),
  [2389] = {.count = 1, .reusable = true}, SHIFT(1229),
  [2391] = {.count = 1, .reusable = true}, SHIFT(1230),
  [2393] = {.count = 1, .reusable = false}, SHIFT(1232),
  [2395] = {.count = 1, .reusable = true}, SHIFT(1232),
  [2397] = {.count = 1, .reusable = true}, SHIFT(1231),
  [2399] = {.count = 1, .reusable = true}, SHIFT(1233),
  [2401] = {.count = 1, .reusable = false}, SHIFT(1235),
  [2403] = {.count = 1, .reusable = true}, SHIFT(1235),
  [2405] = {.count = 1, .reusable = true}, SHIFT(1234),
  [2407] = {.count = 1, .reusable = true}, SHIFT(1236),
  [2409] = {.count = 1, .reusable = false}, SHIFT(1237),
  [2411] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(1238),
  [2414] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(204),
  [2417] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(205),
  [2420] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(206),
  [2423] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(207),
  [2426] = {.count = 1, .reusable = true}, SHIFT(1239),
  [2428] = {.count = 1, .reusable = true}, SHIFT(1242),
  [2430] = {.count = 1, .reusable = false}, SHIFT(1243),
  [2432] = {.count = 1, .reusable = false}, SHIFT(1244),
  [2434] = {.count = 1, .reusable = true}, SHIFT(1245),
  [2436] = {.count = 1, .reusable = true}, SHIFT(1246),
  [2438] = {.count = 1, .reusable = true}, SHIFT(1247),
  [2440] = {.count = 1, .reusable = true}, SHIFT(1248),
  [2442] = {.count = 1, .reusable = true}, SHIFT(1249),
  [2444] = {.count = 1, .reusable = true}, SHIFT(1250),
  [2446] = {.count = 1, .reusable = true}, SHIFT(1253),
  [2448] = {.count = 1, .reusable = true}, SHIFT(1254),
  [2450] = {.count = 1, .reusable = false}, SHIFT(1256),
  [2452] = {.count = 1, .reusable = true}, SHIFT(1256),
  [2454] = {.count = 1, .reusable = true}, SHIFT(1255),
  [2456] = {.count = 1, .reusable = false}, SHIFT(1258),
  [2458] = {.count = 1, .reusable = true}, SHIFT(1258),
  [2460] = {.count = 1, .reusable = true}, SHIFT(1257),
  [2462] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 3, .alias_sequence_id = 3),
  [2464] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 3, .alias_sequence_id = 3),
  [2466] = {.count = 1, .reusable = true}, SHIFT(1259),
  [2468] = {.count = 1, .reusable = true}, SHIFT(1260),
  [2470] = {.count = 1, .reusable = false}, SHIFT(1261),
  [2472] = {.count = 1, .reusable = true}, SHIFT(1261),
  [2474] = {.count = 1, .reusable = true}, SHIFT(1262),
  [2476] = {.count = 1, .reusable = false}, SHIFT(1264),
  [2478] = {.count = 1, .reusable = false}, SHIFT(1265),
  [2480] = {.count = 1, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 1),
  [2482] = {.count = 1, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 1),
  [2484] = {.count = 1, .reusable = true}, SHIFT(1267),
  [2486] = {.count = 1, .reusable = true}, SHIFT(1268),
  [2488] = {.count = 1, .reusable = true}, SHIFT(1269),
  [2490] = {.count = 1, .reusable = false}, SHIFT(1270),
  [2492] = {.count = 1, .reusable = true}, SHIFT(1270),
  [2494] = {.count = 1, .reusable = true}, SHIFT(1271),
  [2496] = {.count = 1, .reusable = true}, SHIFT(1272),
  [2498] = {.count = 1, .reusable = false}, SHIFT(1273),
  [2500] = {.count = 1, .reusable = true}, SHIFT(1273),
  [2502] = {.count = 1, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 1, .alias_sequence_id = 1),
  [2504] = {.count = 1, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 1, .alias_sequence_id = 1),
  [2506] = {.count = 1, .reusable = false}, SHIFT(1278),
  [2508] = {.count = 1, .reusable = false}, SHIFT(1280),
  [2510] = {.count = 1, .reusable = true}, SHIFT(1280),
  [2512] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 3),
  [2514] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 3),
  [2516] = {.count = 1, .reusable = true}, SHIFT(1281),
  [2518] = {.count = 1, .reusable = true}, SHIFT(1282),
  [2520] = {.count = 1, .reusable = true}, REDUCE(sym_command_substitution, 3),
  [2522] = {.count = 1, .reusable = false}, REDUCE(sym_command_substitution, 3),
  [2524] = {.count = 1, .reusable = true}, SHIFT(1286),
  [2526] = {.count = 1, .reusable = true}, SHIFT(1287),
  [2528] = {.count = 1, .reusable = true}, SHIFT(1289),
  [2530] = {.count = 1, .reusable = false}, SHIFT(1291),
  [2532] = {.count = 1, .reusable = false}, SHIFT(1294),
  [2534] = {.count = 1, .reusable = false}, SHIFT(1297),
  [2536] = {.count = 1, .reusable = true}, SHIFT(1297),
  [2538] = {.count = 1, .reusable = true}, SHIFT(1302),
  [2540] = {.count = 1, .reusable = true}, SHIFT(1303),
  [2542] = {.count = 1, .reusable = true}, SHIFT(1305),
  [2544] = {.count = 1, .reusable = false}, SHIFT(1307),
  [2546] = {.count = 1, .reusable = true}, SHIFT(1307),
  [2548] = {.count = 1, .reusable = true}, SHIFT(1309),
  [2550] = {.count = 1, .reusable = false}, SHIFT(1312),
  [2552] = {.count = 1, .reusable = true}, SHIFT(1312),
  [2554] = {.count = 1, .reusable = true}, REDUCE(sym_process_substitution, 3),
  [2556] = {.count = 1, .reusable = false}, REDUCE(sym_process_substitution, 3),
  [2558] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 2),
  [2560] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_body, 2),
  [2562] = {.count = 1, .reusable = true}, SHIFT(1316),
  [2564] = {.count = 1, .reusable = false}, SHIFT(1317),
  [2566] = {.count = 1, .reusable = true}, SHIFT(1317),
  [2568] = {.count = 1, .reusable = true}, SHIFT(1318),
  [2570] = {.count = 1, .reusable = true}, SHIFT(1319),
  [2572] = {.count = 1, .reusable = true}, SHIFT(1320),
  [2574] = {.count = 1, .reusable = false}, SHIFT(1321),
  [2576] = {.count = 1, .reusable = true}, SHIFT(1321),
  [2578] = {.count = 1, .reusable = true}, SHIFT(1326),
  [2580] = {.count = 1, .reusable = true}, SHIFT(1325),
  [2582] = {.count = 1, .reusable = true}, SHIFT(1327),
  [2584] = {.count = 1, .reusable = true}, REDUCE(sym_pipeline, 3),
  [2586] = {.count = 1, .reusable = false}, REDUCE(sym_pipeline, 3),
  [2588] = {.count = 1, .reusable = true}, REDUCE(sym_list, 3),
  [2590] = {.count = 1, .reusable = false}, REDUCE(sym_list, 3),
  [2592] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_redirect, 2),
  [2594] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_redirect, 2),
  [2596] = {.count = 1, .reusable = true}, REDUCE(sym_herestring_redirect, 2),
  [2598] = {.count = 1, .reusable = false}, REDUCE(sym_herestring_redirect, 2),
  [2600] = {.count = 1, .reusable = true}, REDUCE(sym_herestring_redirect, 2, .alias_sequence_id = 2),
  [2602] = {.count = 1, .reusable = false}, REDUCE(sym_herestring_redirect, 2, .alias_sequence_id = 2),
  [2604] = {.count = 1, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 3),
  [2606] = {.count = 1, .reusable = true}, REDUCE(sym__statements, 3),
  [2608] = {.count = 1, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 3),
  [2610] = {.count = 1, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2),
  [2612] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(236),
  [2615] = {.count = 1, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2),
  [2617] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(240),
  [2620] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(240),
  [2623] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(241),
  [2626] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(241),
  [2629] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(242),
  [2632] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2),
  [2634] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2),
  [2636] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2, .alias_sequence_id = 2),
  [2638] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2, .alias_sequence_id = 2),
  [2640] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(245),
  [2643] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(18),
  [2646] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(19),
  [2649] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(20),
  [2652] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(246),
  [2655] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(22),
  [2658] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(23),
  [2661] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(24),
  [2664] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(25),
  [2667] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(246),
  [2670] = {.count = 1, .reusable = false}, SHIFT(1332),
  [2672] = {.count = 1, .reusable = true}, SHIFT(1332),
  [2674] = {.count = 1, .reusable = false}, SHIFT(1333),
  [2676] = {.count = 1, .reusable = false}, SHIFT(1334),
  [2678] = {.count = 1, .reusable = true}, SHIFT(1335),
  [2680] = {.count = 1, .reusable = false}, SHIFT(1336),
  [2682] = {.count = 1, .reusable = false}, SHIFT(1337),
  [2684] = {.count = 1, .reusable = true}, SHIFT(1336),
  [2686] = {.count = 1, .reusable = true}, SHIFT(1337),
  [2688] = {.count = 1, .reusable = true}, SHIFT(1338),
  [2690] = {.count = 1, .reusable = false}, SHIFT(1339),
  [2692] = {.count = 1, .reusable = true}, SHIFT(1339),
  [2694] = {.count = 1, .reusable = true}, SHIFT(1340),
  [2696] = {.count = 1, .reusable = true}, REDUCE(sym_command, 3),
  [2698] = {.count = 1, .reusable = false}, REDUCE(sym_command, 3),
  [2700] = {.count = 1, .reusable = true}, SHIFT(1345),
  [2702] = {.count = 1, .reusable = true}, SHIFT(1347),
  [2704] = {.count = 1, .reusable = false}, SHIFT(1149),
  [2706] = {.count = 1, .reusable = true}, SHIFT(1348),
  [2708] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 4),
  [2710] = {.count = 1, .reusable = true}, SHIFT(1349),
  [2712] = {.count = 1, .reusable = true}, SHIFT(1350),
  [2714] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 4, .alias_sequence_id = 4),
  [2716] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(724),
  [2719] = {.count = 1, .reusable = true}, REDUCE(sym_array, 2),
  [2721] = {.count = 1, .reusable = false}, REDUCE(sym_array, 2),
  [2723] = {.count = 1, .reusable = true}, SHIFT(1351),
  [2725] = {.count = 1, .reusable = true}, SHIFT(1352),
  [2727] = {.count = 1, .reusable = false}, SHIFT(1353),
  [2729] = {.count = 1, .reusable = true}, SHIFT(1353),
  [2731] = {.count = 1, .reusable = true}, SHIFT(1354),
  [2733] = {.count = 1, .reusable = false}, SHIFT(1356),
  [2735] = {.count = 1, .reusable = false}, SHIFT(1357),
  [2737] = {.count = 1, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 1),
  [2739] = {.count = 1, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 1),
  [2741] = {.count = 1, .reusable = true}, SHIFT(1359),
  [2743] = {.count = 1, .reusable = true}, SHIFT(1360),
  [2745] = {.count = 1, .reusable = true}, SHIFT(1361),
  [2747] = {.count = 1, .reusable = false}, SHIFT(1362),
  [2749] = {.count = 1, .reusable = true}, SHIFT(1362),
  [2751] = {.count = 1, .reusable = true}, SHIFT(1367),
  [2753] = {.count = 1, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 1, .alias_sequence_id = 1),
  [2755] = {.count = 1, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 1, .alias_sequence_id = 1),
  [2757] = {.count = 1, .reusable = true}, SHIFT(1369),
  [2759] = {.count = 1, .reusable = true}, SHIFT(1371),
  [2761] = {.count = 1, .reusable = true}, SHIFT(1372),
  [2763] = {.count = 1, .reusable = false}, SHIFT(1374),
  [2765] = {.count = 1, .reusable = false}, SHIFT(1375),
  [2767] = {.count = 1, .reusable = true}, SHIFT(1376),
  [2769] = {.count = 1, .reusable = true}, SHIFT(1377),
  [2771] = {.count = 1, .reusable = true}, SHIFT(1378),
  [2773] = {.count = 1, .reusable = false}, SHIFT(1379),
  [2775] = {.count = 1, .reusable = true}, SHIFT(1379),
  [2777] = {.count = 1, .reusable = true}, SHIFT(1380),
  [2779] = {.count = 1, .reusable = false}, SHIFT(1382),
  [2781] = {.count = 1, .reusable = true}, SHIFT(1382),
  [2783] = {.count = 1, .reusable = true}, SHIFT(1381),
  [2785] = {.count = 1, .reusable = true}, SHIFT(1383),
  [2787] = {.count = 1, .reusable = false}, SHIFT(1385),
  [2789] = {.count = 1, .reusable = true}, SHIFT(1385),
  [2791] = {.count = 1, .reusable = true}, SHIFT(1384),
  [2793] = {.count = 1, .reusable = true}, SHIFT(1386),
  [2795] = {.count = 1, .reusable = true}, SHIFT(1387),
  [2797] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(753),
  [2800] = {.count = 1, .reusable = true}, SHIFT(1388),
  [2802] = {.count = 1, .reusable = false}, SHIFT(1390),
  [2804] = {.count = 1, .reusable = true}, SHIFT(1390),
  [2806] = {.count = 1, .reusable = true}, SHIFT(1391),
  [2808] = {.count = 1, .reusable = false}, REDUCE(sym_unary_expression, 2),
  [2810] = {.count = 1, .reusable = true}, SHIFT(1392),
  [2812] = {.count = 1, .reusable = true}, SHIFT(1393),
  [2814] = {.count = 1, .reusable = false}, SHIFT(1395),
  [2816] = {.count = 1, .reusable = false}, SHIFT(1396),
  [2818] = {.count = 1, .reusable = true}, SHIFT(1397),
  [2820] = {.count = 1, .reusable = true}, SHIFT(1398),
  [2822] = {.count = 1, .reusable = true}, SHIFT(1399),
  [2824] = {.count = 1, .reusable = false}, SHIFT(1400),
  [2826] = {.count = 1, .reusable = true}, SHIFT(1400),
  [2828] = {.count = 1, .reusable = true}, SHIFT(1401),
  [2830] = {.count = 1, .reusable = false}, SHIFT(1403),
  [2832] = {.count = 1, .reusable = true}, SHIFT(1403),
  [2834] = {.count = 1, .reusable = true}, SHIFT(1402),
  [2836] = {.count = 1, .reusable = true}, SHIFT(1404),
  [2838] = {.count = 1, .reusable = false}, SHIFT(1406),
  [2840] = {.count = 1, .reusable = true}, SHIFT(1406),
  [2842] = {.count = 1, .reusable = true}, SHIFT(1405),
  [2844] = {.count = 1, .reusable = true}, SHIFT(1407),
  [2846] = {.count = 1, .reusable = true}, SHIFT(1408),
  [2848] = {.count = 1, .reusable = true}, SHIFT(1411),
  [2850] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(779),
  [2853] = {.count = 1, .reusable = true}, SHIFT(1412),
  [2855] = {.count = 1, .reusable = true}, SHIFT(1413),
  [2857] = {.count = 1, .reusable = false}, SHIFT(1414),
  [2859] = {.count = 1, .reusable = true}, SHIFT(1414),
  [2861] = {.count = 1, .reusable = true}, SHIFT(1415),
  [2863] = {.count = 1, .reusable = false}, SHIFT(1417),
  [2865] = {.count = 1, .reusable = false}, SHIFT(1418),
  [2867] = {.count = 1, .reusable = true}, SHIFT(1420),
  [2869] = {.count = 1, .reusable = true}, SHIFT(1421),
  [2871] = {.count = 1, .reusable = true}, SHIFT(1422),
  [2873] = {.count = 1, .reusable = false}, SHIFT(1423),
  [2875] = {.count = 1, .reusable = true}, SHIFT(1423),
  [2877] = {.count = 1, .reusable = false}, SHIFT(1428),
  [2879] = {.count = 1, .reusable = true}, SHIFT(1428),
  [2881] = {.count = 1, .reusable = false}, SHIFT(784),
  [2883] = {.count = 1, .reusable = true}, SHIFT(1430),
  [2885] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 4),
  [2887] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 4),
  [2889] = {.count = 1, .reusable = true}, SHIFT(1432),
  [2891] = {.count = 1, .reusable = true}, SHIFT(1433),
  [2893] = {.count = 1, .reusable = true}, SHIFT(1434),
  [2895] = {.count = 1, .reusable = false}, SHIFT(1436),
  [2897] = {.count = 1, .reusable = false}, SHIFT(1437),
  [2899] = {.count = 1, .reusable = true}, SHIFT(1438),
  [2901] = {.count = 1, .reusable = true}, SHIFT(1439),
  [2903] = {.count = 1, .reusable = true}, SHIFT(1440),
  [2905] = {.count = 1, .reusable = false}, SHIFT(1441),
  [2907] = {.count = 1, .reusable = true}, SHIFT(1441),
  [2909] = {.count = 1, .reusable = true}, SHIFT(1442),
  [2911] = {.count = 1, .reusable = false}, SHIFT(1444),
  [2913] = {.count = 1, .reusable = true}, SHIFT(1444),
  [2915] = {.count = 1, .reusable = true}, SHIFT(1443),
  [2917] = {.count = 1, .reusable = true}, SHIFT(1445),
  [2919] = {.count = 1, .reusable = false}, SHIFT(1447),
  [2921] = {.count = 1, .reusable = true}, SHIFT(1447),
  [2923] = {.count = 1, .reusable = true}, SHIFT(1446),
  [2925] = {.count = 1, .reusable = true}, SHIFT(1448),
  [2927] = {.count = 1, .reusable = true}, SHIFT(1449),
  [2929] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_expression, 3),
  [2931] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_expression, 3),
  [2933] = {.count = 1, .reusable = true}, SHIFT(1451),
  [2935] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(814),
  [2938] = {.count = 1, .reusable = false}, SHIFT(1452),
  [2940] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(305),
  [2943] = {.count = 1, .reusable = false}, SHIFT(1453),
  [2945] = {.count = 1, .reusable = true}, SHIFT(1454),
  [2947] = {.count = 1, .reusable = true}, SHIFT(1455),
  [2949] = {.count = 1, .reusable = true}, SHIFT(1458),
  [2951] = {.count = 1, .reusable = true}, SHIFT(1459),
  [2953] = {.count = 1, .reusable = false}, SHIFT(1461),
  [2955] = {.count = 1, .reusable = true}, SHIFT(1461),
  [2957] = {.count = 1, .reusable = true}, SHIFT(1460),
  [2959] = {.count = 1, .reusable = false}, SHIFT(1463),
  [2961] = {.count = 1, .reusable = true}, SHIFT(1463),
  [2963] = {.count = 1, .reusable = true}, SHIFT(1462),
  [2965] = {.count = 1, .reusable = true}, SHIFT(1464),
  [2967] = {.count = 1, .reusable = true}, SHIFT(1465),
  [2969] = {.count = 1, .reusable = false}, SHIFT(1466),
  [2971] = {.count = 1, .reusable = true}, SHIFT(1466),
  [2973] = {.count = 1, .reusable = true}, SHIFT(1467),
  [2975] = {.count = 1, .reusable = true}, REDUCE(sym_binary_expression, 3),
  [2977] = {.count = 1, .reusable = false}, REDUCE(sym_binary_expression, 3),
  [2979] = {.count = 1, .reusable = true}, SHIFT(1468),
  [2981] = {.count = 1, .reusable = true}, SHIFT(1470),
  [2983] = {.count = 1, .reusable = true}, SHIFT(1471),
  [2985] = {.count = 1, .reusable = false}, SHIFT(1472),
  [2987] = {.count = 1, .reusable = true}, SHIFT(1472),
  [2989] = {.count = 1, .reusable = true}, SHIFT(1473),
  [2991] = {.count = 1, .reusable = false}, SHIFT(1475),
  [2993] = {.count = 1, .reusable = false}, SHIFT(1476),
  [2995] = {.count = 1, .reusable = true}, SHIFT(1478),
  [2997] = {.count = 1, .reusable = true}, SHIFT(1479),
  [2999] = {.count = 1, .reusable = true}, SHIFT(1480),
  [3001] = {.count = 1, .reusable = false}, SHIFT(1481),
  [3003] = {.count = 1, .reusable = true}, SHIFT(1481),
  [3005] = {.count = 1, .reusable = true}, SHIFT(1486),
  [3007] = {.count = 1, .reusable = false}, SHIFT(1488),
  [3009] = {.count = 1, .reusable = true}, SHIFT(1488),
  [3011] = {.count = 1, .reusable = false}, SHIFT(1490),
  [3013] = {.count = 1, .reusable = true}, SHIFT(1490),
  [3015] = {.count = 1, .reusable = false}, SHIFT(1493),
  [3017] = {.count = 1, .reusable = false}, SHIFT(1495),
  [3019] = {.count = 1, .reusable = false}, SHIFT(1499),
  [3021] = {.count = 1, .reusable = true}, SHIFT(1499),
  [3023] = {.count = 1, .reusable = true}, SHIFT(1500),
  [3025] = {.count = 1, .reusable = false}, SHIFT(1501),
  [3027] = {.count = 1, .reusable = true}, SHIFT(1501),
  [3029] = {.count = 1, .reusable = true}, SHIFT(1502),
  [3031] = {.count = 1, .reusable = true}, SHIFT(1503),
  [3033] = {.count = 1, .reusable = true}, SHIFT(1504),
  [3035] = {.count = 1, .reusable = true}, SHIFT(1505),
  [3037] = {.count = 1, .reusable = true}, SHIFT(1506),
  [3039] = {.count = 1, .reusable = true}, SHIFT(1508),
  [3041] = {.count = 1, .reusable = true}, SHIFT(1509),
  [3043] = {.count = 1, .reusable = false}, SHIFT(1511),
  [3045] = {.count = 1, .reusable = false}, SHIFT(1512),
  [3047] = {.count = 1, .reusable = true}, SHIFT(1513),
  [3049] = {.count = 1, .reusable = true}, SHIFT(1514),
  [3051] = {.count = 1, .reusable = true}, SHIFT(1515),
  [3053] = {.count = 1, .reusable = false}, SHIFT(1516),
  [3055] = {.count = 1, .reusable = true}, SHIFT(1516),
  [3057] = {.count = 1, .reusable = true}, SHIFT(1517),
  [3059] = {.count = 1, .reusable = false}, SHIFT(1519),
  [3061] = {.count = 1, .reusable = true}, SHIFT(1519),
  [3063] = {.count = 1, .reusable = true}, SHIFT(1518),
  [3065] = {.count = 1, .reusable = true}, SHIFT(1520),
  [3067] = {.count = 1, .reusable = false}, SHIFT(1522),
  [3069] = {.count = 1, .reusable = true}, SHIFT(1522),
  [3071] = {.count = 1, .reusable = true}, SHIFT(1521),
  [3073] = {.count = 1, .reusable = true}, SHIFT(1523),
  [3075] = {.count = 1, .reusable = true}, SHIFT(1524),
  [3077] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(340),
  [3080] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(341),
  [3083] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(342),
  [3086] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(343),
  [3089] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(344),
  [3092] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(345),
  [3095] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(346),
  [3098] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(347),
  [3101] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(348),
  [3104] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(879),
  [3107] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(344),
  [3110] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(880),
  [3113] = {.count = 1, .reusable = true}, SHIFT(1525),
  [3115] = {.count = 1, .reusable = true}, SHIFT(1526),
  [3117] = {.count = 1, .reusable = false}, SHIFT(1528),
  [3119] = {.count = 1, .reusable = false}, SHIFT(1529),
  [3121] = {.count = 1, .reusable = true}, SHIFT(1530),
  [3123] = {.count = 1, .reusable = true}, SHIFT(1531),
  [3125] = {.count = 1, .reusable = true}, SHIFT(1532),
  [3127] = {.count = 1, .reusable = false}, SHIFT(1533),
  [3129] = {.count = 1, .reusable = true}, SHIFT(1533),
  [3131] = {.count = 1, .reusable = true}, SHIFT(1534),
  [3133] = {.count = 1, .reusable = false}, SHIFT(1536),
  [3135] = {.count = 1, .reusable = true}, SHIFT(1536),
  [3137] = {.count = 1, .reusable = true}, SHIFT(1535),
  [3139] = {.count = 1, .reusable = true}, SHIFT(1537),
  [3141] = {.count = 1, .reusable = false}, SHIFT(1539),
  [3143] = {.count = 1, .reusable = true}, SHIFT(1539),
  [3145] = {.count = 1, .reusable = true}, SHIFT(1538),
  [3147] = {.count = 1, .reusable = true}, SHIFT(1540),
  [3149] = {.count = 1, .reusable = true}, SHIFT(1541),
  [3151] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(352),
  [3154] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(353),
  [3157] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(354),
  [3160] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(355),
  [3163] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(356),
  [3166] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(357),
  [3169] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(358),
  [3172] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(359),
  [3175] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(898),
  [3178] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(355),
  [3181] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(899),
  [3184] = {.count = 1, .reusable = false}, SHIFT(1542),
  [3186] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(365),
  [3189] = {.count = 1, .reusable = false}, SHIFT(1543),
  [3191] = {.count = 1, .reusable = true}, SHIFT(1544),
  [3193] = {.count = 1, .reusable = true}, SHIFT(1545),
  [3195] = {.count = 1, .reusable = true}, SHIFT(1548),
  [3197] = {.count = 1, .reusable = true}, SHIFT(1549),
  [3199] = {.count = 1, .reusable = false}, SHIFT(1551),
  [3201] = {.count = 1, .reusable = true}, SHIFT(1551),
  [3203] = {.count = 1, .reusable = true}, SHIFT(1550),
  [3205] = {.count = 1, .reusable = false}, SHIFT(1553),
  [3207] = {.count = 1, .reusable = true}, SHIFT(1553),
  [3209] = {.count = 1, .reusable = true}, SHIFT(1552),
  [3211] = {.count = 1, .reusable = true}, SHIFT(1554),
  [3213] = {.count = 1, .reusable = true}, SHIFT(1555),
  [3215] = {.count = 1, .reusable = false}, SHIFT(1556),
  [3217] = {.count = 1, .reusable = true}, SHIFT(1556),
  [3219] = {.count = 1, .reusable = true}, SHIFT(1557),
  [3221] = {.count = 1, .reusable = true}, SHIFT(1559),
  [3223] = {.count = 1, .reusable = true}, REDUCE(sym_do_group, 2),
  [3225] = {.count = 1, .reusable = false}, REDUCE(sym_do_group, 2),
  [3227] = {.count = 1, .reusable = true}, SHIFT(1560),
  [3229] = {.count = 1, .reusable = false}, SHIFT(1561),
  [3231] = {.count = 1, .reusable = true}, SHIFT(1562),
  [3233] = {.count = 1, .reusable = true}, SHIFT(1563),
  [3235] = {.count = 1, .reusable = true}, SHIFT(1564),
  [3237] = {.count = 1, .reusable = true}, SHIFT(1565),
  [3239] = {.count = 1, .reusable = true}, SHIFT(1566),
  [3241] = {.count = 1, .reusable = true}, SHIFT(1567),
  [3243] = {.count = 1, .reusable = true}, SHIFT(1568),
  [3245] = {.count = 1, .reusable = false}, SHIFT(1570),
  [3247] = {.count = 1, .reusable = false}, SHIFT(1564),
  [3249] = {.count = 1, .reusable = false}, SHIFT(1572),
  [3251] = {.count = 1, .reusable = true}, SHIFT(1573),
  [3253] = {.count = 1, .reusable = true}, SHIFT(1574),
  [3255] = {.count = 1, .reusable = true}, SHIFT(1575),
  [3257] = {.count = 1, .reusable = true}, SHIFT(1576),
  [3259] = {.count = 1, .reusable = true}, SHIFT(1577),
  [3261] = {.count = 1, .reusable = true}, SHIFT(1578),
  [3263] = {.count = 1, .reusable = true}, SHIFT(1579),
  [3265] = {.count = 1, .reusable = false}, SHIFT(1580),
  [3267] = {.count = 1, .reusable = false}, SHIFT(1575),
  [3269] = {.count = 1, .reusable = true}, SHIFT(1582),
  [3271] = {.count = 1, .reusable = true}, SHIFT(1583),
  [3273] = {.count = 1, .reusable = false}, SHIFT(1584),
  [3275] = {.count = 1, .reusable = true}, SHIFT(1584),
  [3277] = {.count = 1, .reusable = true}, SHIFT(1585),
  [3279] = {.count = 1, .reusable = false}, SHIFT(1587),
  [3281] = {.count = 1, .reusable = false}, SHIFT(1588),
  [3283] = {.count = 1, .reusable = true}, SHIFT(1590),
  [3285] = {.count = 1, .reusable = true}, SHIFT(1591),
  [3287] = {.count = 1, .reusable = true}, SHIFT(1592),
  [3289] = {.count = 1, .reusable = false}, SHIFT(1593),
  [3291] = {.count = 1, .reusable = true}, SHIFT(1593),
  [3293] = {.count = 1, .reusable = true}, SHIFT(1598),
  [3295] = {.count = 1, .reusable = true}, SHIFT(1599),
  [3297] = {.count = 1, .reusable = false}, SHIFT(1600),
  [3299] = {.count = 1, .reusable = false}, SHIFT(1601),
  [3301] = {.count = 1, .reusable = true}, SHIFT(1600),
  [3303] = {.count = 1, .reusable = true}, SHIFT(1601),
  [3305] = {.count = 1, .reusable = true}, SHIFT(1602),
  [3307] = {.count = 1, .reusable = false}, SHIFT(1603),
  [3309] = {.count = 1, .reusable = true}, SHIFT(1603),
  [3311] = {.count = 1, .reusable = true}, SHIFT(1604),
  [3313] = {.count = 1, .reusable = false}, SHIFT(1607),
  [3315] = {.count = 1, .reusable = true}, SHIFT(925),
  [3317] = {.count = 1, .reusable = true}, SHIFT(1608),
  [3319] = {.count = 1, .reusable = false}, SHIFT(1608),
  [3321] = {.count = 1, .reusable = false}, REDUCE(sym__statements, 1),
  [3323] = {.count = 1, .reusable = true}, SHIFT(1614),
  [3325] = {.count = 1, .reusable = true}, SHIFT(1616),
  [3327] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(381),
  [3330] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(385),
  [3333] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(385),
  [3336] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(386),
  [3339] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(386),
  [3342] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(387),
  [3345] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(389),
  [3348] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(68),
  [3351] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(69),
  [3354] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(70),
  [3357] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(390),
  [3360] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(72),
  [3363] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(73),
  [3366] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(74),
  [3369] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(75),
  [3372] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(390),
  [3375] = {.count = 1, .reusable = true}, SHIFT(1621),
  [3377] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 4),
  [3379] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 4),
  [3381] = {.count = 1, .reusable = true}, SHIFT(1623),
  [3383] = {.count = 1, .reusable = false}, REDUCE(sym_else_clause, 1),
  [3385] = {.count = 1, .reusable = false}, SHIFT(1624),
  [3387] = {.count = 1, .reusable = false}, SHIFT(1625),
  [3389] = {.count = 1, .reusable = false}, SHIFT(1626),
  [3391] = {.count = 1, .reusable = false}, SHIFT(1627),
  [3393] = {.count = 1, .reusable = false}, SHIFT(1628),
  [3395] = {.count = 1, .reusable = true}, SHIFT(1629),
  [3397] = {.count = 1, .reusable = true}, SHIFT(1630),
  [3399] = {.count = 1, .reusable = true}, SHIFT(1631),
  [3401] = {.count = 1, .reusable = true}, SHIFT(1632),
  [3403] = {.count = 1, .reusable = true}, SHIFT(1633),
  [3405] = {.count = 1, .reusable = true}, SHIFT(1634),
  [3407] = {.count = 1, .reusable = false}, SHIFT(1635),
  [3409] = {.count = 1, .reusable = true}, SHIFT(1645),
  [3411] = {.count = 1, .reusable = false}, SHIFT(1646),
  [3413] = {.count = 1, .reusable = true}, SHIFT(1647),
  [3415] = {.count = 1, .reusable = true}, SHIFT(1648),
  [3417] = {.count = 1, .reusable = true}, SHIFT(1649),
  [3419] = {.count = 1, .reusable = true}, SHIFT(1650),
  [3421] = {.count = 1, .reusable = true}, SHIFT(1651),
  [3423] = {.count = 1, .reusable = true}, SHIFT(1652),
  [3425] = {.count = 1, .reusable = true}, SHIFT(1653),
  [3427] = {.count = 1, .reusable = false}, SHIFT(1655),
  [3429] = {.count = 1, .reusable = false}, SHIFT(1649),
  [3431] = {.count = 1, .reusable = false}, SHIFT(1657),
  [3433] = {.count = 1, .reusable = true}, SHIFT(1658),
  [3435] = {.count = 1, .reusable = true}, SHIFT(1659),
  [3437] = {.count = 1, .reusable = true}, SHIFT(1660),
  [3439] = {.count = 1, .reusable = true}, SHIFT(1661),
  [3441] = {.count = 1, .reusable = true}, SHIFT(1662),
  [3443] = {.count = 1, .reusable = true}, SHIFT(1663),
  [3445] = {.count = 1, .reusable = true}, SHIFT(1664),
  [3447] = {.count = 1, .reusable = false}, SHIFT(1665),
  [3449] = {.count = 1, .reusable = false}, SHIFT(1660),
  [3451] = {.count = 1, .reusable = true}, SHIFT(1667),
  [3453] = {.count = 1, .reusable = true}, SHIFT(1668),
  [3455] = {.count = 1, .reusable = false}, SHIFT(1669),
  [3457] = {.count = 1, .reusable = true}, SHIFT(1669),
  [3459] = {.count = 1, .reusable = true}, SHIFT(1670),
  [3461] = {.count = 1, .reusable = false}, SHIFT(1672),
  [3463] = {.count = 1, .reusable = false}, SHIFT(1673),
  [3465] = {.count = 1, .reusable = true}, SHIFT(1675),
  [3467] = {.count = 1, .reusable = true}, SHIFT(1676),
  [3469] = {.count = 1, .reusable = true}, SHIFT(1677),
  [3471] = {.count = 1, .reusable = false}, SHIFT(1678),
  [3473] = {.count = 1, .reusable = true}, SHIFT(1678),
  [3475] = {.count = 1, .reusable = true}, SHIFT(1683),
  [3477] = {.count = 1, .reusable = true}, SHIFT(963),
  [3479] = {.count = 1, .reusable = true}, SHIFT(964),
  [3481] = {.count = 1, .reusable = true}, SHIFT(1686),
  [3483] = {.count = 1, .reusable = false}, SHIFT(1687),
  [3485] = {.count = 1, .reusable = false}, SHIFT(1688),
  [3487] = {.count = 1, .reusable = true}, SHIFT(1687),
  [3489] = {.count = 1, .reusable = true}, SHIFT(1688),
  [3491] = {.count = 1, .reusable = true}, SHIFT(1689),
  [3493] = {.count = 1, .reusable = false}, SHIFT(1690),
  [3495] = {.count = 1, .reusable = true}, SHIFT(1690),
  [3497] = {.count = 1, .reusable = true}, SHIFT(1691),
  [3499] = {.count = 1, .reusable = false}, SHIFT(1694),
  [3501] = {.count = 1, .reusable = true}, SHIFT(969),
  [3503] = {.count = 1, .reusable = true}, SHIFT(1695),
  [3505] = {.count = 1, .reusable = false}, SHIFT(1695),
  [3507] = {.count = 1, .reusable = true}, SHIFT(1702),
  [3509] = {.count = 1, .reusable = false}, SHIFT(1704),
  [3511] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(400),
  [3514] = {.count = 1, .reusable = false}, SHIFT(1705),
  [3516] = {.count = 1, .reusable = false}, SHIFT(1706),
  [3518] = {.count = 1, .reusable = true}, SHIFT(1707),
  [3520] = {.count = 1, .reusable = true}, SHIFT(1708),
  [3522] = {.count = 1, .reusable = false}, SHIFT(1708),
  [3524] = {.count = 1, .reusable = false}, SHIFT(1713),
  [3526] = {.count = 1, .reusable = true}, SHIFT(1713),
  [3528] = {.count = 1, .reusable = true}, SHIFT(1714),
  [3530] = {.count = 1, .reusable = true}, SHIFT(1715),
  [3532] = {.count = 1, .reusable = true}, SHIFT(1718),
  [3534] = {.count = 1, .reusable = true}, SHIFT(1719),
  [3536] = {.count = 1, .reusable = false}, SHIFT(1721),
  [3538] = {.count = 1, .reusable = true}, SHIFT(1721),
  [3540] = {.count = 1, .reusable = true}, SHIFT(1720),
  [3542] = {.count = 1, .reusable = false}, SHIFT(1723),
  [3544] = {.count = 1, .reusable = true}, SHIFT(1723),
  [3546] = {.count = 1, .reusable = true}, SHIFT(1722),
  [3548] = {.count = 1, .reusable = true}, SHIFT(1724),
  [3550] = {.count = 1, .reusable = true}, SHIFT(1725),
  [3552] = {.count = 1, .reusable = false}, SHIFT(1726),
  [3554] = {.count = 1, .reusable = true}, SHIFT(1726),
  [3556] = {.count = 1, .reusable = true}, SHIFT(1727),
  [3558] = {.count = 1, .reusable = false}, SHIFT(1728),
  [3560] = {.count = 1, .reusable = false}, SHIFT(1731),
  [3562] = {.count = 1, .reusable = true}, SHIFT(1731),
  [3564] = {.count = 1, .reusable = true}, SHIFT(1735),
  [3566] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(422),
  [3569] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(423),
  [3572] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(424),
  [3575] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1015),
  [3578] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(424),
  [3581] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(428),
  [3584] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(429),
  [3587] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1018),
  [3590] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(429),
  [3593] = {.count = 1, .reusable = true}, SHIFT(1739),
  [3595] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(434),
  [3598] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(437),
  [3601] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(437),
  [3604] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(438),
  [3607] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(440),
  [3610] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(101),
  [3613] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(441),
  [3616] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(441),
  [3619] = {.count = 1, .reusable = true}, SHIFT(1743),
  [3621] = {.count = 1, .reusable = true}, SHIFT(1745),
  [3623] = {.count = 1, .reusable = true}, SHIFT(1746),
  [3625] = {.count = 1, .reusable = false}, SHIFT(1747),
  [3627] = {.count = 1, .reusable = true}, SHIFT(1747),
  [3629] = {.count = 1, .reusable = true}, SHIFT(1748),
  [3631] = {.count = 1, .reusable = false}, SHIFT(1750),
  [3633] = {.count = 1, .reusable = false}, SHIFT(1751),
  [3635] = {.count = 1, .reusable = true}, SHIFT(1753),
  [3637] = {.count = 1, .reusable = true}, SHIFT(1754),
  [3639] = {.count = 1, .reusable = true}, SHIFT(1755),
  [3641] = {.count = 1, .reusable = false}, SHIFT(1756),
  [3643] = {.count = 1, .reusable = true}, SHIFT(1756),
  [3645] = {.count = 1, .reusable = false}, SHIFT(1761),
  [3647] = {.count = 1, .reusable = false}, SHIFT(1763),
  [3649] = {.count = 1, .reusable = true}, SHIFT(1763),
  [3651] = {.count = 1, .reusable = false}, SHIFT(1765),
  [3653] = {.count = 1, .reusable = true}, SHIFT(1765),
  [3655] = {.count = 1, .reusable = false}, SHIFT(1768),
  [3657] = {.count = 1, .reusable = false}, SHIFT(1770),
  [3659] = {.count = 1, .reusable = false}, SHIFT(1774),
  [3661] = {.count = 1, .reusable = true}, SHIFT(1774),
  [3663] = {.count = 1, .reusable = true}, SHIFT(1775),
  [3665] = {.count = 1, .reusable = false}, SHIFT(1776),
  [3667] = {.count = 1, .reusable = true}, SHIFT(1776),
  [3669] = {.count = 1, .reusable = true}, SHIFT(1777),
  [3671] = {.count = 1, .reusable = true}, SHIFT(1778),
  [3673] = {.count = 1, .reusable = true}, SHIFT(1779),
  [3675] = {.count = 1, .reusable = true}, SHIFT(1780),
  [3677] = {.count = 1, .reusable = true}, SHIFT(466),
  [3679] = {.count = 1, .reusable = true}, SHIFT(1781),
  [3681] = {.count = 1, .reusable = true}, SHIFT(1783),
  [3683] = {.count = 1, .reusable = true}, SHIFT(1784),
  [3685] = {.count = 1, .reusable = false}, SHIFT(1786),
  [3687] = {.count = 1, .reusable = false}, SHIFT(1787),
  [3689] = {.count = 1, .reusable = true}, SHIFT(1788),
  [3691] = {.count = 1, .reusable = true}, SHIFT(1789),
  [3693] = {.count = 1, .reusable = true}, SHIFT(1790),
  [3695] = {.count = 1, .reusable = false}, SHIFT(1791),
  [3697] = {.count = 1, .reusable = true}, SHIFT(1791),
  [3699] = {.count = 1, .reusable = true}, SHIFT(1792),
  [3701] = {.count = 1, .reusable = false}, SHIFT(1794),
  [3703] = {.count = 1, .reusable = true}, SHIFT(1794),
  [3705] = {.count = 1, .reusable = true}, SHIFT(1793),
  [3707] = {.count = 1, .reusable = true}, SHIFT(1795),
  [3709] = {.count = 1, .reusable = false}, SHIFT(1797),
  [3711] = {.count = 1, .reusable = true}, SHIFT(1797),
  [3713] = {.count = 1, .reusable = true}, SHIFT(1796),
  [3715] = {.count = 1, .reusable = true}, SHIFT(1798),
  [3717] = {.count = 1, .reusable = true}, SHIFT(1799),
  [3719] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(464),
  [3722] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(465),
  [3725] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(466),
  [3728] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(467),
  [3731] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(468),
  [3734] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(469),
  [3737] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(470),
  [3740] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(471),
  [3743] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(472),
  [3746] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1080),
  [3749] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(468),
  [3752] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1081),
  [3755] = {.count = 1, .reusable = true}, SHIFT(1800),
  [3757] = {.count = 1, .reusable = true}, SHIFT(1801),
  [3759] = {.count = 1, .reusable = false}, SHIFT(1803),
  [3761] = {.count = 1, .reusable = false}, SHIFT(1804),
  [3763] = {.count = 1, .reusable = true}, SHIFT(1805),
  [3765] = {.count = 1, .reusable = true}, SHIFT(1806),
  [3767] = {.count = 1, .reusable = true}, SHIFT(1807),
  [3769] = {.count = 1, .reusable = false}, SHIFT(1808),
  [3771] = {.count = 1, .reusable = true}, SHIFT(1808),
  [3773] = {.count = 1, .reusable = true}, SHIFT(1809),
  [3775] = {.count = 1, .reusable = false}, SHIFT(1811),
  [3777] = {.count = 1, .reusable = true}, SHIFT(1811),
  [3779] = {.count = 1, .reusable = true}, SHIFT(1810),
  [3781] = {.count = 1, .reusable = true}, SHIFT(1812),
  [3783] = {.count = 1, .reusable = false}, SHIFT(1814),
  [3785] = {.count = 1, .reusable = true}, SHIFT(1814),
  [3787] = {.count = 1, .reusable = true}, SHIFT(1813),
  [3789] = {.count = 1, .reusable = true}, SHIFT(1815),
  [3791] = {.count = 1, .reusable = true}, SHIFT(1816),
  [3793] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(476),
  [3796] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(477),
  [3799] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(478),
  [3802] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(479),
  [3805] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(480),
  [3808] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(481),
  [3811] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(482),
  [3814] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(483),
  [3817] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1099),
  [3820] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(479),
  [3823] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1100),
  [3826] = {.count = 1, .reusable = false}, SHIFT(1817),
  [3828] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(489),
  [3831] = {.count = 1, .reusable = false}, SHIFT(1818),
  [3833] = {.count = 1, .reusable = true}, SHIFT(1819),
  [3835] = {.count = 1, .reusable = true}, SHIFT(1820),
  [3837] = {.count = 1, .reusable = true}, SHIFT(1823),
  [3839] = {.count = 1, .reusable = true}, SHIFT(1824),
  [3841] = {.count = 1, .reusable = false}, SHIFT(1826),
  [3843] = {.count = 1, .reusable = true}, SHIFT(1826),
  [3845] = {.count = 1, .reusable = true}, SHIFT(1825),
  [3847] = {.count = 1, .reusable = false}, SHIFT(1828),
  [3849] = {.count = 1, .reusable = true}, SHIFT(1828),
  [3851] = {.count = 1, .reusable = true}, SHIFT(1827),
  [3853] = {.count = 1, .reusable = true}, SHIFT(1829),
  [3855] = {.count = 1, .reusable = true}, SHIFT(1830),
  [3857] = {.count = 1, .reusable = false}, SHIFT(1831),
  [3859] = {.count = 1, .reusable = true}, SHIFT(1831),
  [3861] = {.count = 1, .reusable = true}, SHIFT(1832),
  [3863] = {.count = 1, .reusable = true}, SHIFT(1834),
  [3865] = {.count = 1, .reusable = true}, SHIFT(1835),
  [3867] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(506),
  [3870] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(510),
  [3873] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(510),
  [3876] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(511),
  [3879] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(511),
  [3882] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(512),
  [3885] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(515),
  [3888] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(127),
  [3891] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(128),
  [3894] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(129),
  [3897] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(516),
  [3900] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(131),
  [3903] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(132),
  [3906] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(133),
  [3909] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(134),
  [3912] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(516),
  [3915] = {.count = 1, .reusable = false}, SHIFT(1840),
  [3917] = {.count = 1, .reusable = true}, SHIFT(1840),
  [3919] = {.count = 1, .reusable = true}, SHIFT(1841),
  [3921] = {.count = 1, .reusable = false}, SHIFT(1843),
  [3923] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(530),
  [3926] = {.count = 1, .reusable = false}, SHIFT(1844),
  [3928] = {.count = 1, .reusable = true}, SHIFT(1845),
  [3930] = {.count = 1, .reusable = true}, SHIFT(1846),
  [3932] = {.count = 1, .reusable = true}, SHIFT(1849),
  [3934] = {.count = 1, .reusable = true}, SHIFT(1850),
  [3936] = {.count = 1, .reusable = false}, SHIFT(1852),
  [3938] = {.count = 1, .reusable = true}, SHIFT(1852),
  [3940] = {.count = 1, .reusable = true}, SHIFT(1851),
  [3942] = {.count = 1, .reusable = false}, SHIFT(1854),
  [3944] = {.count = 1, .reusable = true}, SHIFT(1854),
  [3946] = {.count = 1, .reusable = true}, SHIFT(1853),
  [3948] = {.count = 1, .reusable = true}, SHIFT(1855),
  [3950] = {.count = 1, .reusable = true}, SHIFT(1856),
  [3952] = {.count = 1, .reusable = false}, SHIFT(1857),
  [3954] = {.count = 1, .reusable = true}, SHIFT(1857),
  [3956] = {.count = 1, .reusable = true}, SHIFT(1858),
  [3958] = {.count = 1, .reusable = true}, SHIFT(1859),
  [3960] = {.count = 1, .reusable = false}, SHIFT(1861),
  [3962] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(558),
  [3965] = {.count = 1, .reusable = false}, SHIFT(1862),
  [3967] = {.count = 1, .reusable = true}, SHIFT(1863),
  [3969] = {.count = 1, .reusable = true}, SHIFT(1864),
  [3971] = {.count = 1, .reusable = true}, SHIFT(1867),
  [3973] = {.count = 1, .reusable = true}, SHIFT(1868),
  [3975] = {.count = 1, .reusable = false}, SHIFT(1870),
  [3977] = {.count = 1, .reusable = true}, SHIFT(1870),
  [3979] = {.count = 1, .reusable = true}, SHIFT(1869),
  [3981] = {.count = 1, .reusable = false}, SHIFT(1872),
  [3983] = {.count = 1, .reusable = true}, SHIFT(1872),
  [3985] = {.count = 1, .reusable = true}, SHIFT(1871),
  [3987] = {.count = 1, .reusable = true}, SHIFT(1873),
  [3989] = {.count = 1, .reusable = true}, SHIFT(1874),
  [3991] = {.count = 1, .reusable = false}, SHIFT(1875),
  [3993] = {.count = 1, .reusable = true}, SHIFT(1875),
  [3995] = {.count = 1, .reusable = true}, SHIFT(1876),
  [3997] = {.count = 1, .reusable = false}, SHIFT(1877),
  [3999] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(577),
  [4002] = {.count = 1, .reusable = false}, SHIFT(1878),
  [4004] = {.count = 1, .reusable = true}, SHIFT(1879),
  [4006] = {.count = 1, .reusable = true}, SHIFT(1880),
  [4008] = {.count = 1, .reusable = true}, SHIFT(1883),
  [4010] = {.count = 1, .reusable = true}, SHIFT(1884),
  [4012] = {.count = 1, .reusable = false}, SHIFT(1886),
  [4014] = {.count = 1, .reusable = true}, SHIFT(1886),
  [4016] = {.count = 1, .reusable = true}, SHIFT(1885),
  [4018] = {.count = 1, .reusable = false}, SHIFT(1888),
  [4020] = {.count = 1, .reusable = true}, SHIFT(1888),
  [4022] = {.count = 1, .reusable = true}, SHIFT(1887),
  [4024] = {.count = 1, .reusable = true}, SHIFT(1889),
  [4026] = {.count = 1, .reusable = true}, SHIFT(1890),
  [4028] = {.count = 1, .reusable = false}, SHIFT(1891),
  [4030] = {.count = 1, .reusable = true}, SHIFT(1891),
  [4032] = {.count = 1, .reusable = true}, SHIFT(1892),
  [4034] = {.count = 1, .reusable = false}, SHIFT(1893),
  [4036] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(596),
  [4039] = {.count = 1, .reusable = false}, SHIFT(1894),
  [4041] = {.count = 1, .reusable = true}, SHIFT(1895),
  [4043] = {.count = 1, .reusable = true}, SHIFT(1896),
  [4045] = {.count = 1, .reusable = true}, SHIFT(1899),
  [4047] = {.count = 1, .reusable = true}, SHIFT(1900),
  [4049] = {.count = 1, .reusable = false}, SHIFT(1902),
  [4051] = {.count = 1, .reusable = true}, SHIFT(1902),
  [4053] = {.count = 1, .reusable = true}, SHIFT(1901),
  [4055] = {.count = 1, .reusable = false}, SHIFT(1904),
  [4057] = {.count = 1, .reusable = true}, SHIFT(1904),
  [4059] = {.count = 1, .reusable = true}, SHIFT(1903),
  [4061] = {.count = 1, .reusable = true}, SHIFT(1905),
  [4063] = {.count = 1, .reusable = true}, SHIFT(1906),
  [4065] = {.count = 1, .reusable = false}, SHIFT(1907),
  [4067] = {.count = 1, .reusable = true}, SHIFT(1907),
  [4069] = {.count = 1, .reusable = true}, SHIFT(1908),
  [4071] = {.count = 1, .reusable = true}, REDUCE(sym_concatenation, 4),
  [4073] = {.count = 1, .reusable = false}, REDUCE(sym_concatenation, 4),
  [4075] = {.count = 1, .reusable = false}, SHIFT(197),
  [4077] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 3),
  [4079] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_repeat1, 3),
  [4081] = {.count = 1, .reusable = true}, SHIFT(1909),
  [4083] = {.count = 1, .reusable = true}, SHIFT(1910),
  [4085] = {.count = 1, .reusable = true}, SHIFT(1913),
  [4087] = {.count = 1, .reusable = true}, SHIFT(1914),
  [4089] = {.count = 1, .reusable = false}, SHIFT(1916),
  [4091] = {.count = 1, .reusable = true}, SHIFT(1916),
  [4093] = {.count = 1, .reusable = true}, SHIFT(1915),
  [4095] = {.count = 1, .reusable = false}, SHIFT(1918),
  [4097] = {.count = 1, .reusable = true}, SHIFT(1918),
  [4099] = {.count = 1, .reusable = true}, SHIFT(1917),
  [4101] = {.count = 1, .reusable = true}, SHIFT(1919),
  [4103] = {.count = 1, .reusable = true}, SHIFT(1920),
  [4105] = {.count = 1, .reusable = false}, SHIFT(1921),
  [4107] = {.count = 1, .reusable = true}, SHIFT(1921),
  [4109] = {.count = 1, .reusable = true}, SHIFT(1922),
  [4111] = {.count = 1, .reusable = true}, REDUCE(sym_string, 4),
  [4113] = {.count = 1, .reusable = false}, REDUCE(sym_string, 4),
  [4115] = {.count = 1, .reusable = true}, SHIFT(1923),
  [4117] = {.count = 1, .reusable = true}, SHIFT(1924),
  [4119] = {.count = 1, .reusable = true}, SHIFT(1925),
  [4121] = {.count = 1, .reusable = true}, SHIFT(1926),
  [4123] = {.count = 1, .reusable = true}, SHIFT(1927),
  [4125] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 4),
  [4127] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 4),
  [4129] = {.count = 1, .reusable = true}, SHIFT(1928),
  [4131] = {.count = 1, .reusable = true}, SHIFT(1929),
  [4133] = {.count = 1, .reusable = false}, SHIFT(1930),
  [4135] = {.count = 1, .reusable = true}, SHIFT(1930),
  [4137] = {.count = 1, .reusable = true}, SHIFT(1931),
  [4139] = {.count = 1, .reusable = false}, SHIFT(1933),
  [4141] = {.count = 1, .reusable = false}, SHIFT(1934),
  [4143] = {.count = 1, .reusable = true}, SHIFT(1936),
  [4145] = {.count = 1, .reusable = true}, SHIFT(1937),
  [4147] = {.count = 1, .reusable = true}, SHIFT(1938),
  [4149] = {.count = 1, .reusable = true}, SHIFT(1939),
  [4151] = {.count = 1, .reusable = false}, SHIFT(1940),
  [4153] = {.count = 1, .reusable = true}, SHIFT(1940),
  [4155] = {.count = 1, .reusable = true}, SHIFT(1945),
  [4157] = {.count = 1, .reusable = false}, SHIFT(1946),
  [4159] = {.count = 1, .reusable = true}, SHIFT(1948),
  [4161] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 4, .alias_sequence_id = 5),
  [4163] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 5),
  [4165] = {.count = 1, .reusable = true}, SHIFT(1951),
  [4167] = {.count = 1, .reusable = true}, SHIFT(1952),
  [4169] = {.count = 1, .reusable = false}, SHIFT(1953),
  [4171] = {.count = 1, .reusable = true}, SHIFT(1953),
  [4173] = {.count = 1, .reusable = true}, SHIFT(1954),
  [4175] = {.count = 1, .reusable = false}, SHIFT(1955),
  [4177] = {.count = 1, .reusable = true}, SHIFT(1955),
  [4179] = {.count = 1, .reusable = true}, SHIFT(1956),
  [4181] = {.count = 1, .reusable = true}, SHIFT(1957),
  [4183] = {.count = 1, .reusable = false}, SHIFT(1959),
  [4185] = {.count = 1, .reusable = false}, SHIFT(1960),
  [4187] = {.count = 1, .reusable = true}, SHIFT(1961),
  [4189] = {.count = 1, .reusable = true}, SHIFT(1962),
  [4191] = {.count = 1, .reusable = true}, SHIFT(1963),
  [4193] = {.count = 1, .reusable = false}, SHIFT(1964),
  [4195] = {.count = 1, .reusable = true}, SHIFT(1964),
  [4197] = {.count = 1, .reusable = true}, SHIFT(1965),
  [4199] = {.count = 1, .reusable = false}, SHIFT(1967),
  [4201] = {.count = 1, .reusable = true}, SHIFT(1967),
  [4203] = {.count = 1, .reusable = true}, SHIFT(1966),
  [4205] = {.count = 1, .reusable = true}, SHIFT(1968),
  [4207] = {.count = 1, .reusable = false}, SHIFT(1970),
  [4209] = {.count = 1, .reusable = true}, SHIFT(1970),
  [4211] = {.count = 1, .reusable = true}, SHIFT(1969),
  [4213] = {.count = 1, .reusable = true}, SHIFT(1971),
  [4215] = {.count = 1, .reusable = false}, SHIFT(1972),
  [4217] = {.count = 1, .reusable = true}, SHIFT(1972),
  [4219] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 4, .alias_sequence_id = 3),
  [4221] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 3),
  [4223] = {.count = 1, .reusable = true}, SHIFT(1973),
  [4225] = {.count = 1, .reusable = true}, SHIFT(1974),
  [4227] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1278),
  [4230] = {.count = 1, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2),
  [4232] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(1280),
  [4235] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(634),
  [4238] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(635),
  [4241] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(636),
  [4244] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(637),
  [4247] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(1280),
  [4250] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(638),
  [4253] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(640),
  [4256] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(641),
  [4259] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(642),
  [4262] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(637),
  [4265] = {.count = 1, .reusable = true}, SHIFT(1978),
  [4267] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(654),
  [4270] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(655),
  [4273] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(656),
  [4276] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1291),
  [4279] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(656),
  [4282] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(660),
  [4285] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(661),
  [4288] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1294),
  [4291] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(661),
  [4294] = {.count = 1, .reusable = true}, SHIFT(1982),
  [4296] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(665),
  [4299] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(669),
  [4302] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(669),
  [4305] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(670),
  [4308] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(673),
  [4311] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(221),
  [4314] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(674),
  [4317] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(674),
  [4320] = {.count = 1, .reusable = false}, SHIFT(1986),
  [4322] = {.count = 1, .reusable = true}, SHIFT(1986),
  [4324] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 4),
  [4326] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 4),
  [4328] = {.count = 1, .reusable = true}, SHIFT(1987),
  [4330] = {.count = 1, .reusable = true}, SHIFT(1988),
  [4332] = {.count = 1, .reusable = true}, SHIFT(1989),
  [4334] = {.count = 1, .reusable = false}, SHIFT(1990),
  [4336] = {.count = 1, .reusable = true}, SHIFT(1990),
  [4338] = {.count = 1, .reusable = true}, SHIFT(1991),
  [4340] = {.count = 1, .reusable = false}, SHIFT(1993),
  [4342] = {.count = 1, .reusable = true}, SHIFT(1993),
  [4344] = {.count = 1, .reusable = true}, SHIFT(1992),
  [4346] = {.count = 1, .reusable = true}, SHIFT(1994),
  [4348] = {.count = 1, .reusable = false}, SHIFT(1996),
  [4350] = {.count = 1, .reusable = true}, SHIFT(1996),
  [4352] = {.count = 1, .reusable = true}, SHIFT(1995),
  [4354] = {.count = 1, .reusable = true}, SHIFT(1997),
  [4356] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 3),
  [4358] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_body, 3),
  [4360] = {.count = 2, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(1326),
  [4363] = {.count = 1, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2),
  [4365] = {.count = 2, .reusable = false}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(684),
  [4368] = {.count = 2, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(685),
  [4371] = {.count = 2, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(686),
  [4374] = {.count = 2, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(687),
  [4377] = {.count = 1, .reusable = true}, SHIFT(1998),
  [4379] = {.count = 1, .reusable = true}, REDUCE(sym__statements, 4),
  [4381] = {.count = 1, .reusable = false}, SHIFT(2000),
  [4383] = {.count = 1, .reusable = true}, SHIFT(2000),
  [4385] = {.count = 1, .reusable = false}, SHIFT(710),
  [4387] = {.count = 1, .reusable = false}, SHIFT(711),
  [4389] = {.count = 1, .reusable = false}, SHIFT(712),
  [4391] = {.count = 1, .reusable = true}, SHIFT(2005),
  [4393] = {.count = 1, .reusable = true}, SHIFT(2006),
  [4395] = {.count = 1, .reusable = true}, SHIFT(2008),
  [4397] = {.count = 1, .reusable = false}, SHIFT(2010),
  [4399] = {.count = 1, .reusable = true}, SHIFT(2010),
  [4401] = {.count = 1, .reusable = false}, SHIFT(2013),
  [4403] = {.count = 1, .reusable = true}, SHIFT(2014),
  [4405] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 5),
  [4407] = {.count = 1, .reusable = true}, SHIFT(2015),
  [4409] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 5, .alias_sequence_id = 4),
  [4411] = {.count = 1, .reusable = true}, SHIFT(2016),
  [4413] = {.count = 1, .reusable = true}, SHIFT(2017),
  [4415] = {.count = 1, .reusable = false}, SHIFT(2019),
  [4417] = {.count = 1, .reusable = false}, SHIFT(2020),
  [4419] = {.count = 1, .reusable = true}, SHIFT(2021),
  [4421] = {.count = 1, .reusable = true}, SHIFT(2022),
  [4423] = {.count = 1, .reusable = true}, SHIFT(2023),
  [4425] = {.count = 1, .reusable = false}, SHIFT(2024),
  [4427] = {.count = 1, .reusable = true}, SHIFT(2024),
  [4429] = {.count = 1, .reusable = true}, SHIFT(2025),
  [4431] = {.count = 1, .reusable = false}, SHIFT(2027),
  [4433] = {.count = 1, .reusable = true}, SHIFT(2027),
  [4435] = {.count = 1, .reusable = true}, SHIFT(2026),
  [4437] = {.count = 1, .reusable = true}, SHIFT(2028),
  [4439] = {.count = 1, .reusable = false}, SHIFT(2030),
  [4441] = {.count = 1, .reusable = true}, SHIFT(2030),
  [4443] = {.count = 1, .reusable = true}, SHIFT(2029),
  [4445] = {.count = 1, .reusable = true}, SHIFT(2031),
  [4447] = {.count = 1, .reusable = true}, SHIFT(2032),
  [4449] = {.count = 1, .reusable = true}, REDUCE(sym_array, 3),
  [4451] = {.count = 1, .reusable = false}, REDUCE(sym_array, 3),
  [4453] = {.count = 1, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [4455] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(727),
  [4458] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(728),
  [4461] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(729),
  [4464] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(730),
  [4467] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(731),
  [4470] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(732),
  [4473] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(733),
  [4476] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(734),
  [4479] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1369),
  [4482] = {.count = 1, .reusable = false}, SHIFT(2033),
  [4484] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(740),
  [4487] = {.count = 1, .reusable = false}, SHIFT(2034),
  [4489] = {.count = 1, .reusable = true}, SHIFT(2035),
  [4491] = {.count = 1, .reusable = true}, SHIFT(2036),
  [4493] = {.count = 1, .reusable = true}, SHIFT(2039),
  [4495] = {.count = 1, .reusable = true}, SHIFT(2040),
  [4497] = {.count = 1, .reusable = false}, SHIFT(2042),
  [4499] = {.count = 1, .reusable = true}, SHIFT(2042),
  [4501] = {.count = 1, .reusable = true}, SHIFT(2041),
  [4503] = {.count = 1, .reusable = false}, SHIFT(2044),
  [4505] = {.count = 1, .reusable = true}, SHIFT(2044),
  [4507] = {.count = 1, .reusable = true}, SHIFT(2043),
  [4509] = {.count = 1, .reusable = true}, SHIFT(2045),
  [4511] = {.count = 1, .reusable = true}, SHIFT(2046),
  [4513] = {.count = 1, .reusable = false}, SHIFT(2047),
  [4515] = {.count = 1, .reusable = true}, SHIFT(2047),
  [4517] = {.count = 1, .reusable = true}, SHIFT(2048),
  [4519] = {.count = 1, .reusable = true}, SHIFT(2049),
  [4521] = {.count = 1, .reusable = true}, SHIFT(2051),
  [4523] = {.count = 1, .reusable = false}, SHIFT(2053),
  [4525] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(762),
  [4528] = {.count = 1, .reusable = false}, SHIFT(2054),
  [4530] = {.count = 1, .reusable = true}, SHIFT(2055),
  [4532] = {.count = 1, .reusable = true}, SHIFT(2056),
  [4534] = {.count = 1, .reusable = true}, SHIFT(2059),
  [4536] = {.count = 1, .reusable = true}, SHIFT(2060),
  [4538] = {.count = 1, .reusable = false}, SHIFT(2062),
  [4540] = {.count = 1, .reusable = true}, SHIFT(2062),
  [4542] = {.count = 1, .reusable = true}, SHIFT(2061),
  [4544] = {.count = 1, .reusable = false}, SHIFT(2064),
  [4546] = {.count = 1, .reusable = true}, SHIFT(2064),
  [4548] = {.count = 1, .reusable = true}, SHIFT(2063),
  [4550] = {.count = 1, .reusable = true}, SHIFT(2065),
  [4552] = {.count = 1, .reusable = true}, SHIFT(2066),
  [4554] = {.count = 1, .reusable = false}, SHIFT(2067),
  [4556] = {.count = 1, .reusable = true}, SHIFT(2067),
  [4558] = {.count = 1, .reusable = true}, SHIFT(2068),
  [4560] = {.count = 1, .reusable = false}, SHIFT(2069),
  [4562] = {.count = 1, .reusable = true}, SHIFT(2069),
  [4564] = {.count = 1, .reusable = true}, SHIFT(2070),
  [4566] = {.count = 1, .reusable = true}, SHIFT(2071),
  [4568] = {.count = 1, .reusable = false}, SHIFT(2073),
  [4570] = {.count = 1, .reusable = false}, SHIFT(2074),
  [4572] = {.count = 1, .reusable = true}, SHIFT(2075),
  [4574] = {.count = 1, .reusable = true}, SHIFT(2076),
  [4576] = {.count = 1, .reusable = true}, SHIFT(2077),
  [4578] = {.count = 1, .reusable = false}, SHIFT(2078),
  [4580] = {.count = 1, .reusable = true}, SHIFT(2078),
  [4582] = {.count = 1, .reusable = true}, SHIFT(2079),
  [4584] = {.count = 1, .reusable = false}, SHIFT(2081),
  [4586] = {.count = 1, .reusable = true}, SHIFT(2081),
  [4588] = {.count = 1, .reusable = true}, SHIFT(2080),
  [4590] = {.count = 1, .reusable = true}, SHIFT(2082),
  [4592] = {.count = 1, .reusable = false}, SHIFT(2084),
  [4594] = {.count = 1, .reusable = true}, SHIFT(2084),
  [4596] = {.count = 1, .reusable = true}, SHIFT(2083),
  [4598] = {.count = 1, .reusable = true}, SHIFT(2085),
  [4600] = {.count = 1, .reusable = true}, SHIFT(2086),
  [4602] = {.count = 1, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [4604] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(781),
  [4607] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(782),
  [4610] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(783),
  [4613] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(784),
  [4616] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(785),
  [4619] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(786),
  [4622] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(787),
  [4625] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(788),
  [4628] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(784),
  [4631] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1430),
  [4634] = {.count = 1, .reusable = false}, SHIFT(2088),
  [4636] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(797),
  [4639] = {.count = 1, .reusable = false}, SHIFT(2089),
  [4641] = {.count = 1, .reusable = true}, SHIFT(2090),
  [4643] = {.count = 1, .reusable = true}, SHIFT(2091),
  [4645] = {.count = 1, .reusable = true}, SHIFT(2094),
  [4647] = {.count = 1, .reusable = true}, SHIFT(2095),
  [4649] = {.count = 1, .reusable = false}, SHIFT(2097),
  [4651] = {.count = 1, .reusable = true}, SHIFT(2097),
  [4653] = {.count = 1, .reusable = true}, SHIFT(2096),
  [4655] = {.count = 1, .reusable = false}, SHIFT(2099),
  [4657] = {.count = 1, .reusable = true}, SHIFT(2099),
  [4659] = {.count = 1, .reusable = true}, SHIFT(2098),
  [4661] = {.count = 1, .reusable = true}, SHIFT(2100),
  [4663] = {.count = 1, .reusable = true}, SHIFT(2101),
  [4665] = {.count = 1, .reusable = false}, SHIFT(2102),
  [4667] = {.count = 1, .reusable = true}, SHIFT(2102),
  [4669] = {.count = 1, .reusable = true}, SHIFT(2103),
  [4671] = {.count = 1, .reusable = false}, SHIFT(302),
  [4673] = {.count = 1, .reusable = true}, SHIFT(2104),
  [4675] = {.count = 1, .reusable = true}, SHIFT(2105),
  [4677] = {.count = 1, .reusable = true}, SHIFT(2106),
  [4679] = {.count = 1, .reusable = true}, SHIFT(2109),
  [4681] = {.count = 1, .reusable = true}, SHIFT(2110),
  [4683] = {.count = 1, .reusable = false}, SHIFT(2111),
  [4685] = {.count = 1, .reusable = true}, SHIFT(2111),
  [4687] = {.count = 1, .reusable = true}, SHIFT(2112),
  [4689] = {.count = 1, .reusable = false}, SHIFT(2113),
  [4691] = {.count = 1, .reusable = true}, SHIFT(2113),
  [4693] = {.count = 1, .reusable = true}, SHIFT(2114),
  [4695] = {.count = 1, .reusable = false}, SHIFT(2115),
  [4697] = {.count = 1, .reusable = true}, SHIFT(2115),
  [4699] = {.count = 1, .reusable = true}, SHIFT(2116),
  [4701] = {.count = 1, .reusable = true}, SHIFT(2117),
  [4703] = {.count = 1, .reusable = true}, SHIFT(2118),
  [4705] = {.count = 1, .reusable = false}, SHIFT(2120),
  [4707] = {.count = 1, .reusable = false}, SHIFT(2121),
  [4709] = {.count = 1, .reusable = true}, SHIFT(2122),
  [4711] = {.count = 1, .reusable = true}, SHIFT(2123),
  [4713] = {.count = 1, .reusable = true}, SHIFT(2124),
  [4715] = {.count = 1, .reusable = false}, SHIFT(2125),
  [4717] = {.count = 1, .reusable = true}, SHIFT(2125),
  [4719] = {.count = 1, .reusable = true}, SHIFT(2126),
  [4721] = {.count = 1, .reusable = false}, SHIFT(2128),
  [4723] = {.count = 1, .reusable = true}, SHIFT(2128),
  [4725] = {.count = 1, .reusable = true}, SHIFT(2127),
  [4727] = {.count = 1, .reusable = true}, SHIFT(2129),
  [4729] = {.count = 1, .reusable = false}, SHIFT(2131),
  [4731] = {.count = 1, .reusable = true}, SHIFT(2131),
  [4733] = {.count = 1, .reusable = true}, SHIFT(2130),
  [4735] = {.count = 1, .reusable = true}, SHIFT(2132),
  [4737] = {.count = 1, .reusable = true}, SHIFT(2133),
  [4739] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1486),
  [4742] = {.count = 1, .reusable = true}, SHIFT(2134),
  [4744] = {.count = 1, .reusable = false}, SHIFT(2136),
  [4746] = {.count = 1, .reusable = true}, SHIFT(2136),
  [4748] = {.count = 1, .reusable = false}, SHIFT(2138),
  [4750] = {.count = 1, .reusable = true}, SHIFT(2138),
  [4752] = {.count = 1, .reusable = true}, SHIFT(2139),
  [4754] = {.count = 1, .reusable = true}, SHIFT(2140),
  [4756] = {.count = 1, .reusable = false}, SHIFT(2143),
  [4758] = {.count = 1, .reusable = false}, SHIFT(2146),
  [4760] = {.count = 1, .reusable = true}, SHIFT(2146),
  [4762] = {.count = 1, .reusable = false}, SHIFT(2147),
  [4764] = {.count = 1, .reusable = false}, SHIFT(2150),
  [4766] = {.count = 1, .reusable = true}, SHIFT(2150),
  [4768] = {.count = 1, .reusable = true}, SHIFT(2152),
  [4770] = {.count = 1, .reusable = false}, SHIFT(2154),
  [4772] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(866),
  [4775] = {.count = 1, .reusable = false}, SHIFT(2155),
  [4777] = {.count = 1, .reusable = true}, SHIFT(2156),
  [4779] = {.count = 1, .reusable = true}, SHIFT(2157),
  [4781] = {.count = 1, .reusable = true}, SHIFT(2160),
  [4783] = {.count = 1, .reusable = true}, SHIFT(2161),
  [4785] = {.count = 1, .reusable = false}, SHIFT(2163),
  [4787] = {.count = 1, .reusable = true}, SHIFT(2163),
  [4789] = {.count = 1, .reusable = true}, SHIFT(2162),
  [4791] = {.count = 1, .reusable = false}, SHIFT(2165),
  [4793] = {.count = 1, .reusable = true}, SHIFT(2165),
  [4795] = {.count = 1, .reusable = true}, SHIFT(2164),
  [4797] = {.count = 1, .reusable = true}, SHIFT(2166),
  [4799] = {.count = 1, .reusable = true}, SHIFT(2167),
  [4801] = {.count = 1, .reusable = false}, SHIFT(2168),
  [4803] = {.count = 1, .reusable = true}, SHIFT(2168),
  [4805] = {.count = 1, .reusable = true}, SHIFT(2169),
  [4807] = {.count = 1, .reusable = false}, SHIFT(2170),
  [4809] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(885),
  [4812] = {.count = 1, .reusable = false}, SHIFT(2171),
  [4814] = {.count = 1, .reusable = true}, SHIFT(2172),
  [4816] = {.count = 1, .reusable = true}, SHIFT(2173),
  [4818] = {.count = 1, .reusable = true}, SHIFT(2176),
  [4820] = {.count = 1, .reusable = true}, SHIFT(2177),
  [4822] = {.count = 1, .reusable = false}, SHIFT(2179),
  [4824] = {.count = 1, .reusable = true}, SHIFT(2179),
  [4826] = {.count = 1, .reusable = true}, SHIFT(2178),
  [4828] = {.count = 1, .reusable = false}, SHIFT(2181),
  [4830] = {.count = 1, .reusable = true}, SHIFT(2181),
  [4832] = {.count = 1, .reusable = true}, SHIFT(2180),
  [4834] = {.count = 1, .reusable = true}, SHIFT(2182),
  [4836] = {.count = 1, .reusable = true}, SHIFT(2183),
  [4838] = {.count = 1, .reusable = false}, SHIFT(2184),
  [4840] = {.count = 1, .reusable = true}, SHIFT(2184),
  [4842] = {.count = 1, .reusable = true}, SHIFT(2185),
  [4844] = {.count = 1, .reusable = false}, SHIFT(362),
  [4846] = {.count = 1, .reusable = true}, SHIFT(2186),
  [4848] = {.count = 1, .reusable = true}, SHIFT(2187),
  [4850] = {.count = 1, .reusable = true}, SHIFT(2188),
  [4852] = {.count = 1, .reusable = true}, SHIFT(2191),
  [4854] = {.count = 1, .reusable = true}, SHIFT(2192),
  [4856] = {.count = 1, .reusable = false}, SHIFT(2193),
  [4858] = {.count = 1, .reusable = true}, SHIFT(2193),
  [4860] = {.count = 1, .reusable = true}, SHIFT(2194),
  [4862] = {.count = 1, .reusable = false}, SHIFT(2195),
  [4864] = {.count = 1, .reusable = true}, SHIFT(2195),
  [4866] = {.count = 1, .reusable = true}, SHIFT(2196),
  [4868] = {.count = 1, .reusable = false}, SHIFT(2197),
  [4870] = {.count = 1, .reusable = true}, SHIFT(2197),
  [4872] = {.count = 1, .reusable = true}, SHIFT(2198),
  [4874] = {.count = 1, .reusable = true}, SHIFT(2199),
  [4876] = {.count = 1, .reusable = false}, SHIFT(2200),
  [4878] = {.count = 1, .reusable = true}, SHIFT(2201),
  [4880] = {.count = 1, .reusable = true}, SHIFT(2202),
  [4882] = {.count = 1, .reusable = true}, SHIFT(2203),
  [4884] = {.count = 1, .reusable = true}, SHIFT(2204),
  [4886] = {.count = 1, .reusable = true}, SHIFT(2205),
  [4888] = {.count = 1, .reusable = true}, SHIFT(2206),
  [4890] = {.count = 1, .reusable = true}, SHIFT(2207),
  [4892] = {.count = 1, .reusable = true}, SHIFT(2209),
  [4894] = {.count = 1, .reusable = true}, SHIFT(2210),
  [4896] = {.count = 1, .reusable = true}, SHIFT(2211),
  [4898] = {.count = 1, .reusable = false}, SHIFT(2212),
  [4900] = {.count = 1, .reusable = true}, SHIFT(2212),
  [4902] = {.count = 1, .reusable = true}, SHIFT(2213),
  [4904] = {.count = 1, .reusable = false}, SHIFT(2215),
  [4906] = {.count = 1, .reusable = false}, SHIFT(2216),
  [4908] = {.count = 1, .reusable = true}, SHIFT(2218),
  [4910] = {.count = 1, .reusable = true}, SHIFT(2219),
  [4912] = {.count = 1, .reusable = true}, SHIFT(2220),
  [4914] = {.count = 1, .reusable = false}, SHIFT(2221),
  [4916] = {.count = 1, .reusable = true}, SHIFT(2221),
  [4918] = {.count = 1, .reusable = false}, SHIFT(2226),
  [4920] = {.count = 1, .reusable = true}, SHIFT(2227),
  [4922] = {.count = 1, .reusable = true}, SHIFT(2229),
  [4924] = {.count = 1, .reusable = true}, SHIFT(2230),
  [4926] = {.count = 1, .reusable = false}, SHIFT(2231),
  [4928] = {.count = 1, .reusable = true}, SHIFT(2231),
  [4930] = {.count = 1, .reusable = true}, SHIFT(2232),
  [4932] = {.count = 1, .reusable = false}, SHIFT(2234),
  [4934] = {.count = 1, .reusable = false}, SHIFT(2235),
  [4936] = {.count = 1, .reusable = true}, SHIFT(2237),
  [4938] = {.count = 1, .reusable = true}, SHIFT(2238),
  [4940] = {.count = 1, .reusable = true}, SHIFT(2239),
  [4942] = {.count = 1, .reusable = false}, SHIFT(2240),
  [4944] = {.count = 1, .reusable = true}, SHIFT(2240),
  [4946] = {.count = 1, .reusable = false}, SHIFT(2245),
  [4948] = {.count = 1, .reusable = true}, SHIFT(2246),
  [4950] = {.count = 1, .reusable = true}, SHIFT(2248),
  [4952] = {.count = 1, .reusable = true}, SHIFT(2249),
  [4954] = {.count = 1, .reusable = false}, SHIFT(2251),
  [4956] = {.count = 1, .reusable = false}, SHIFT(2252),
  [4958] = {.count = 1, .reusable = true}, SHIFT(2253),
  [4960] = {.count = 1, .reusable = true}, SHIFT(2254),
  [4962] = {.count = 1, .reusable = true}, SHIFT(2255),
  [4964] = {.count = 1, .reusable = false}, SHIFT(2256),
  [4966] = {.count = 1, .reusable = true}, SHIFT(2256),
  [4968] = {.count = 1, .reusable = true}, SHIFT(2257),
  [4970] = {.count = 1, .reusable = false}, SHIFT(2259),
  [4972] = {.count = 1, .reusable = true}, SHIFT(2259),
  [4974] = {.count = 1, .reusable = true}, SHIFT(2258),
  [4976] = {.count = 1, .reusable = true}, SHIFT(2260),
  [4978] = {.count = 1, .reusable = false}, SHIFT(2262),
  [4980] = {.count = 1, .reusable = true}, SHIFT(2262),
  [4982] = {.count = 1, .reusable = true}, SHIFT(2261),
  [4984] = {.count = 1, .reusable = true}, SHIFT(2263),
  [4986] = {.count = 1, .reusable = true}, SHIFT(2264),
  [4988] = {.count = 1, .reusable = true}, REDUCE(sym_do_group, 3),
  [4990] = {.count = 1, .reusable = false}, REDUCE(sym_do_group, 3),
  [4992] = {.count = 1, .reusable = false}, SHIFT(2265),
  [4994] = {.count = 1, .reusable = true}, SHIFT(2265),
  [4996] = {.count = 1, .reusable = false}, REDUCE(sym__statements, 2),
  [4998] = {.count = 1, .reusable = false}, SHIFT(2270),
  [5000] = {.count = 1, .reusable = true}, SHIFT(2271),
  [5002] = {.count = 1, .reusable = true}, SHIFT(2272),
  [5004] = {.count = 1, .reusable = true}, SHIFT(2273),
  [5006] = {.count = 1, .reusable = true}, SHIFT(2274),
  [5008] = {.count = 1, .reusable = true}, SHIFT(2275),
  [5010] = {.count = 1, .reusable = true}, SHIFT(2276),
  [5012] = {.count = 1, .reusable = true}, SHIFT(2277),
  [5014] = {.count = 1, .reusable = true}, SHIFT(2279),
  [5016] = {.count = 1, .reusable = false}, SHIFT(2281),
  [5018] = {.count = 1, .reusable = true}, SHIFT(2281),
  [5020] = {.count = 1, .reusable = true}, SHIFT(2283),
  [5022] = {.count = 1, .reusable = true}, SHIFT(2284),
  [5024] = {.count = 1, .reusable = false}, SHIFT(2287),
  [5026] = {.count = 1, .reusable = true}, SHIFT(2287),
  [5028] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1614),
  [5031] = {.count = 1, .reusable = true}, SHIFT(2290),
  [5033] = {.count = 1, .reusable = true}, SHIFT(2292),
  [5035] = {.count = 1, .reusable = true}, SHIFT(2293),
  [5037] = {.count = 1, .reusable = false}, SHIFT(2294),
  [5039] = {.count = 1, .reusable = true}, SHIFT(2295),
  [5041] = {.count = 1, .reusable = true}, SHIFT(2296),
  [5043] = {.count = 1, .reusable = true}, SHIFT(2297),
  [5045] = {.count = 1, .reusable = true}, SHIFT(2298),
  [5047] = {.count = 1, .reusable = true}, SHIFT(2299),
  [5049] = {.count = 1, .reusable = true}, SHIFT(2300),
  [5051] = {.count = 1, .reusable = true}, SHIFT(2301),
  [5053] = {.count = 1, .reusable = true}, SHIFT(2303),
  [5055] = {.count = 1, .reusable = true}, SHIFT(2304),
  [5057] = {.count = 1, .reusable = true}, SHIFT(2305),
  [5059] = {.count = 1, .reusable = false}, SHIFT(2306),
  [5061] = {.count = 1, .reusable = true}, SHIFT(2307),
  [5063] = {.count = 1, .reusable = true}, SHIFT(2308),
  [5065] = {.count = 1, .reusable = true}, SHIFT(2309),
  [5067] = {.count = 1, .reusable = true}, SHIFT(2310),
  [5069] = {.count = 1, .reusable = true}, SHIFT(2311),
  [5071] = {.count = 1, .reusable = true}, SHIFT(2312),
  [5073] = {.count = 1, .reusable = true}, SHIFT(2313),
  [5075] = {.count = 1, .reusable = false}, SHIFT(2315),
  [5077] = {.count = 1, .reusable = false}, SHIFT(2309),
  [5079] = {.count = 1, .reusable = false}, SHIFT(2317),
  [5081] = {.count = 1, .reusable = true}, SHIFT(2318),
  [5083] = {.count = 1, .reusable = true}, SHIFT(2319),
  [5085] = {.count = 1, .reusable = true}, SHIFT(2320),
  [5087] = {.count = 1, .reusable = true}, SHIFT(2321),
  [5089] = {.count = 1, .reusable = true}, SHIFT(2322),
  [5091] = {.count = 1, .reusable = true}, SHIFT(2323),
  [5093] = {.count = 1, .reusable = true}, SHIFT(2324),
  [5095] = {.count = 1, .reusable = false}, SHIFT(2325),
  [5097] = {.count = 1, .reusable = false}, SHIFT(2320),
  [5099] = {.count = 1, .reusable = true}, SHIFT(2327),
  [5101] = {.count = 1, .reusable = true}, SHIFT(2328),
  [5103] = {.count = 1, .reusable = false}, SHIFT(2329),
  [5105] = {.count = 1, .reusable = true}, SHIFT(2329),
  [5107] = {.count = 1, .reusable = true}, SHIFT(2330),
  [5109] = {.count = 1, .reusable = false}, SHIFT(2332),
  [5111] = {.count = 1, .reusable = false}, SHIFT(2333),
  [5113] = {.count = 1, .reusable = true}, SHIFT(2335),
  [5115] = {.count = 1, .reusable = true}, SHIFT(2336),
  [5117] = {.count = 1, .reusable = true}, SHIFT(2337),
  [5119] = {.count = 1, .reusable = false}, SHIFT(2338),
  [5121] = {.count = 1, .reusable = true}, SHIFT(2338),
  [5123] = {.count = 1, .reusable = true}, REDUCE(sym_else_clause, 2),
  [5125] = {.count = 1, .reusable = true}, SHIFT(2343),
  [5127] = {.count = 1, .reusable = false}, SHIFT(2344),
  [5129] = {.count = 1, .reusable = false}, SHIFT(2345),
  [5131] = {.count = 1, .reusable = true}, SHIFT(2344),
  [5133] = {.count = 1, .reusable = true}, SHIFT(2345),
  [5135] = {.count = 1, .reusable = true}, SHIFT(2346),
  [5137] = {.count = 1, .reusable = false}, SHIFT(2347),
  [5139] = {.count = 1, .reusable = true}, SHIFT(2347),
  [5141] = {.count = 1, .reusable = true}, SHIFT(2348),
  [5143] = {.count = 1, .reusable = false}, SHIFT(2351),
  [5145] = {.count = 1, .reusable = true}, SHIFT(1628),
  [5147] = {.count = 1, .reusable = true}, SHIFT(2352),
  [5149] = {.count = 1, .reusable = false}, SHIFT(2352),
  [5151] = {.count = 1, .reusable = true}, SHIFT(2358),
  [5153] = {.count = 1, .reusable = true}, SHIFT(2360),
  [5155] = {.count = 1, .reusable = true}, SHIFT(2361),
  [5157] = {.count = 1, .reusable = true}, SHIFT(2362),
  [5159] = {.count = 1, .reusable = false}, SHIFT(2363),
  [5161] = {.count = 1, .reusable = true}, SHIFT(2363),
  [5163] = {.count = 1, .reusable = true}, SHIFT(2364),
  [5165] = {.count = 1, .reusable = false}, SHIFT(2366),
  [5167] = {.count = 1, .reusable = false}, SHIFT(2367),
  [5169] = {.count = 1, .reusable = true}, SHIFT(2369),
  [5171] = {.count = 1, .reusable = true}, SHIFT(2370),
  [5173] = {.count = 1, .reusable = true}, SHIFT(2371),
  [5175] = {.count = 1, .reusable = false}, SHIFT(2372),
  [5177] = {.count = 1, .reusable = true}, SHIFT(2372),
  [5179] = {.count = 1, .reusable = false}, SHIFT(2377),
  [5181] = {.count = 1, .reusable = true}, SHIFT(2378),
  [5183] = {.count = 1, .reusable = true}, SHIFT(2380),
  [5185] = {.count = 1, .reusable = true}, SHIFT(2381),
  [5187] = {.count = 1, .reusable = false}, SHIFT(2382),
  [5189] = {.count = 1, .reusable = true}, SHIFT(2382),
  [5191] = {.count = 1, .reusable = true}, SHIFT(2383),
  [5193] = {.count = 1, .reusable = false}, SHIFT(2385),
  [5195] = {.count = 1, .reusable = false}, SHIFT(2386),
  [5197] = {.count = 1, .reusable = true}, SHIFT(2388),
  [5199] = {.count = 1, .reusable = true}, SHIFT(2389),
  [5201] = {.count = 1, .reusable = true}, SHIFT(2390),
  [5203] = {.count = 1, .reusable = false}, SHIFT(2391),
  [5205] = {.count = 1, .reusable = true}, SHIFT(2391),
  [5207] = {.count = 1, .reusable = false}, SHIFT(2396),
  [5209] = {.count = 1, .reusable = true}, SHIFT(2397),
  [5211] = {.count = 1, .reusable = true}, SHIFT(2399),
  [5213] = {.count = 1, .reusable = true}, SHIFT(2400),
  [5215] = {.count = 1, .reusable = false}, SHIFT(2402),
  [5217] = {.count = 1, .reusable = false}, SHIFT(2403),
  [5219] = {.count = 1, .reusable = true}, SHIFT(2404),
  [5221] = {.count = 1, .reusable = true}, SHIFT(2405),
  [5223] = {.count = 1, .reusable = true}, SHIFT(2406),
  [5225] = {.count = 1, .reusable = false}, SHIFT(2407),
  [5227] = {.count = 1, .reusable = true}, SHIFT(2407),
  [5229] = {.count = 1, .reusable = true}, SHIFT(2408),
  [5231] = {.count = 1, .reusable = false}, SHIFT(2410),
  [5233] = {.count = 1, .reusable = true}, SHIFT(2410),
  [5235] = {.count = 1, .reusable = true}, SHIFT(2409),
  [5237] = {.count = 1, .reusable = true}, SHIFT(2411),
  [5239] = {.count = 1, .reusable = false}, SHIFT(2413),
  [5241] = {.count = 1, .reusable = true}, SHIFT(2413),
  [5243] = {.count = 1, .reusable = true}, SHIFT(2412),
  [5245] = {.count = 1, .reusable = true}, SHIFT(2414),
  [5247] = {.count = 1, .reusable = true}, SHIFT(2415),
  [5249] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 5),
  [5251] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 5),
  [5253] = {.count = 1, .reusable = true}, SHIFT(2416),
  [5255] = {.count = 1, .reusable = false}, SHIFT(2418),
  [5257] = {.count = 1, .reusable = true}, SHIFT(2418),
  [5259] = {.count = 1, .reusable = true}, SHIFT(2423),
  [5261] = {.count = 1, .reusable = true}, SHIFT(2424),
  [5263] = {.count = 1, .reusable = true}, SHIFT(2426),
  [5265] = {.count = 1, .reusable = false}, SHIFT(2428),
  [5267] = {.count = 1, .reusable = true}, SHIFT(2428),
  [5269] = {.count = 1, .reusable = true}, SHIFT(2430),
  [5271] = {.count = 1, .reusable = true}, SHIFT(2431),
  [5273] = {.count = 1, .reusable = false}, SHIFT(2434),
  [5275] = {.count = 1, .reusable = true}, SHIFT(2434),
  [5277] = {.count = 1, .reusable = true}, REDUCE(aux_sym_if_statement_repeat1, 2),
  [5279] = {.count = 2, .reusable = true}, REDUCE(aux_sym_if_statement_repeat1, 2), SHIFT_REPEAT(963),
  [5282] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1702),
  [5285] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 5),
  [5287] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 5),
  [5289] = {.count = 1, .reusable = true}, SHIFT(2438),
  [5291] = {.count = 1, .reusable = true}, SHIFT(2439),
  [5293] = {.count = 1, .reusable = true}, SHIFT(2441),
  [5295] = {.count = 1, .reusable = true}, SHIFT(2444),
  [5297] = {.count = 1, .reusable = false}, SHIFT(2441),
  [5299] = {.count = 1, .reusable = true}, SHIFT(2448),
  [5301] = {.count = 1, .reusable = true}, SHIFT(2449),
  [5303] = {.count = 1, .reusable = true}, SHIFT(2450),
  [5305] = {.count = 1, .reusable = true}, SHIFT(2453),
  [5307] = {.count = 1, .reusable = true}, SHIFT(2454),
  [5309] = {.count = 1, .reusable = false}, SHIFT(2455),
  [5311] = {.count = 1, .reusable = true}, SHIFT(2455),
  [5313] = {.count = 1, .reusable = true}, SHIFT(2456),
  [5315] = {.count = 1, .reusable = false}, SHIFT(2457),
  [5317] = {.count = 1, .reusable = true}, SHIFT(2457),
  [5319] = {.count = 1, .reusable = true}, SHIFT(2458),
  [5321] = {.count = 1, .reusable = false}, SHIFT(2459),
  [5323] = {.count = 1, .reusable = true}, SHIFT(2459),
  [5325] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 5, .alias_sequence_id = 2),
  [5327] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 5, .alias_sequence_id = 2),
  [5329] = {.count = 1, .reusable = true}, SHIFT(2460),
  [5331] = {.count = 1, .reusable = false}, SHIFT(2460),
  [5333] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 5),
  [5335] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 5),
  [5337] = {.count = 1, .reusable = true}, SHIFT(2465),
  [5339] = {.count = 1, .reusable = true}, SHIFT(2466),
  [5341] = {.count = 1, .reusable = true}, SHIFT(2467),
  [5343] = {.count = 1, .reusable = false}, SHIFT(2469),
  [5345] = {.count = 1, .reusable = false}, SHIFT(2470),
  [5347] = {.count = 1, .reusable = true}, SHIFT(2471),
  [5349] = {.count = 1, .reusable = true}, SHIFT(2472),
  [5351] = {.count = 1, .reusable = true}, SHIFT(2473),
  [5353] = {.count = 1, .reusable = false}, SHIFT(2474),
  [5355] = {.count = 1, .reusable = true}, SHIFT(2474),
  [5357] = {.count = 1, .reusable = true}, SHIFT(2475),
  [5359] = {.count = 1, .reusable = false}, SHIFT(2477),
  [5361] = {.count = 1, .reusable = true}, SHIFT(2477),
  [5363] = {.count = 1, .reusable = true}, SHIFT(2476),
  [5365] = {.count = 1, .reusable = true}, SHIFT(2478),
  [5367] = {.count = 1, .reusable = false}, SHIFT(2480),
  [5369] = {.count = 1, .reusable = true}, SHIFT(2480),
  [5371] = {.count = 1, .reusable = true}, SHIFT(2479),
  [5373] = {.count = 1, .reusable = true}, SHIFT(2481),
  [5375] = {.count = 1, .reusable = true}, SHIFT(2482),
  [5377] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1761),
  [5380] = {.count = 1, .reusable = true}, SHIFT(2483),
  [5382] = {.count = 1, .reusable = false}, SHIFT(2485),
  [5384] = {.count = 1, .reusable = true}, SHIFT(2485),
  [5386] = {.count = 1, .reusable = false}, SHIFT(2487),
  [5388] = {.count = 1, .reusable = true}, SHIFT(2487),
  [5390] = {.count = 1, .reusable = true}, SHIFT(2488),
  [5392] = {.count = 1, .reusable = true}, SHIFT(2489),
  [5394] = {.count = 1, .reusable = false}, SHIFT(2492),
  [5396] = {.count = 1, .reusable = false}, SHIFT(2495),
  [5398] = {.count = 1, .reusable = true}, SHIFT(2495),
  [5400] = {.count = 1, .reusable = false}, SHIFT(2496),
  [5402] = {.count = 1, .reusable = false}, SHIFT(2499),
  [5404] = {.count = 1, .reusable = true}, SHIFT(2499),
  [5406] = {.count = 1, .reusable = true}, SHIFT(2501),
  [5408] = {.count = 1, .reusable = false}, SHIFT(2503),
  [5410] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1067),
  [5413] = {.count = 1, .reusable = false}, SHIFT(2504),
  [5415] = {.count = 1, .reusable = true}, SHIFT(2505),
  [5417] = {.count = 1, .reusable = true}, SHIFT(2506),
  [5419] = {.count = 1, .reusable = true}, SHIFT(2509),
  [5421] = {.count = 1, .reusable = true}, SHIFT(2510),
  [5423] = {.count = 1, .reusable = false}, SHIFT(2512),
  [5425] = {.count = 1, .reusable = true}, SHIFT(2512),
  [5427] = {.count = 1, .reusable = true}, SHIFT(2511),
  [5429] = {.count = 1, .reusable = false}, SHIFT(2514),
  [5431] = {.count = 1, .reusable = true}, SHIFT(2514),
  [5433] = {.count = 1, .reusable = true}, SHIFT(2513),
  [5435] = {.count = 1, .reusable = true}, SHIFT(2515),
  [5437] = {.count = 1, .reusable = true}, SHIFT(2516),
  [5439] = {.count = 1, .reusable = false}, SHIFT(2517),
  [5441] = {.count = 1, .reusable = true}, SHIFT(2517),
  [5443] = {.count = 1, .reusable = true}, SHIFT(2518),
  [5445] = {.count = 1, .reusable = false}, SHIFT(2519),
  [5447] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1086),
  [5450] = {.count = 1, .reusable = false}, SHIFT(2520),
  [5452] = {.count = 1, .reusable = true}, SHIFT(2521),
  [5454] = {.count = 1, .reusable = true}, SHIFT(2522),
  [5456] = {.count = 1, .reusable = true}, SHIFT(2525),
  [5458] = {.count = 1, .reusable = true}, SHIFT(2526),
  [5460] = {.count = 1, .reusable = false}, SHIFT(2528),
  [5462] = {.count = 1, .reusable = true}, SHIFT(2528),
  [5464] = {.count = 1, .reusable = true}, SHIFT(2527),
  [5466] = {.count = 1, .reusable = false}, SHIFT(2530),
  [5468] = {.count = 1, .reusable = true}, SHIFT(2530),
  [5470] = {.count = 1, .reusable = true}, SHIFT(2529),
  [5472] = {.count = 1, .reusable = true}, SHIFT(2531),
  [5474] = {.count = 1, .reusable = true}, SHIFT(2532),
  [5476] = {.count = 1, .reusable = false}, SHIFT(2533),
  [5478] = {.count = 1, .reusable = true}, SHIFT(2533),
  [5480] = {.count = 1, .reusable = true}, SHIFT(2534),
  [5482] = {.count = 1, .reusable = false}, SHIFT(486),
  [5484] = {.count = 1, .reusable = true}, SHIFT(2535),
  [5486] = {.count = 1, .reusable = true}, SHIFT(2536),
  [5488] = {.count = 1, .reusable = true}, SHIFT(2537),
  [5490] = {.count = 1, .reusable = true}, SHIFT(2540),
  [5492] = {.count = 1, .reusable = true}, SHIFT(2541),
  [5494] = {.count = 1, .reusable = false}, SHIFT(2542),
  [5496] = {.count = 1, .reusable = true}, SHIFT(2542),
  [5498] = {.count = 1, .reusable = true}, SHIFT(2543),
  [5500] = {.count = 1, .reusable = false}, SHIFT(2544),
  [5502] = {.count = 1, .reusable = true}, SHIFT(2544),
  [5504] = {.count = 1, .reusable = true}, SHIFT(2545),
  [5506] = {.count = 1, .reusable = false}, SHIFT(2546),
  [5508] = {.count = 1, .reusable = true}, SHIFT(2546),
  [5510] = {.count = 1, .reusable = true}, SHIFT(2547),
  [5512] = {.count = 1, .reusable = true}, SHIFT(2549),
  [5514] = {.count = 1, .reusable = false}, SHIFT(527),
  [5516] = {.count = 1, .reusable = true}, SHIFT(2550),
  [5518] = {.count = 1, .reusable = true}, SHIFT(2551),
  [5520] = {.count = 1, .reusable = true}, SHIFT(2552),
  [5522] = {.count = 1, .reusable = true}, SHIFT(2555),
  [5524] = {.count = 1, .reusable = true}, SHIFT(2556),
  [5526] = {.count = 1, .reusable = false}, SHIFT(2557),
  [5528] = {.count = 1, .reusable = true}, SHIFT(2557),
  [5530] = {.count = 1, .reusable = true}, SHIFT(2558),
  [5532] = {.count = 1, .reusable = false}, SHIFT(2559),
  [5534] = {.count = 1, .reusable = true}, SHIFT(2559),
  [5536] = {.count = 1, .reusable = true}, SHIFT(2560),
  [5538] = {.count = 1, .reusable = false}, SHIFT(2561),
  [5540] = {.count = 1, .reusable = true}, SHIFT(2561),
  [5542] = {.count = 1, .reusable = true}, SHIFT(2562),
  [5544] = {.count = 1, .reusable = false}, SHIFT(555),
  [5546] = {.count = 1, .reusable = true}, SHIFT(2563),
  [5548] = {.count = 1, .reusable = true}, SHIFT(2564),
  [5550] = {.count = 1, .reusable = true}, SHIFT(2565),
  [5552] = {.count = 1, .reusable = true}, SHIFT(2568),
  [5554] = {.count = 1, .reusable = true}, SHIFT(2569),
  [5556] = {.count = 1, .reusable = false}, SHIFT(2570),
  [5558] = {.count = 1, .reusable = true}, SHIFT(2570),
  [5560] = {.count = 1, .reusable = true}, SHIFT(2571),
  [5562] = {.count = 1, .reusable = false}, SHIFT(2572),
  [5564] = {.count = 1, .reusable = true}, SHIFT(2572),
  [5566] = {.count = 1, .reusable = true}, SHIFT(2573),
  [5568] = {.count = 1, .reusable = false}, SHIFT(2574),
  [5570] = {.count = 1, .reusable = true}, SHIFT(2574),
  [5572] = {.count = 1, .reusable = false}, SHIFT(574),
  [5574] = {.count = 1, .reusable = true}, SHIFT(2575),
  [5576] = {.count = 1, .reusable = true}, SHIFT(2576),
  [5578] = {.count = 1, .reusable = true}, SHIFT(2577),
  [5580] = {.count = 1, .reusable = true}, SHIFT(2580),
  [5582] = {.count = 1, .reusable = true}, SHIFT(2581),
  [5584] = {.count = 1, .reusable = false}, SHIFT(2582),
  [5586] = {.count = 1, .reusable = true}, SHIFT(2582),
  [5588] = {.count = 1, .reusable = true}, SHIFT(2583),
  [5590] = {.count = 1, .reusable = false}, SHIFT(2584),
  [5592] = {.count = 1, .reusable = true}, SHIFT(2584),
  [5594] = {.count = 1, .reusable = true}, SHIFT(2585),
  [5596] = {.count = 1, .reusable = false}, SHIFT(2586),
  [5598] = {.count = 1, .reusable = true}, SHIFT(2586),
  [5600] = {.count = 1, .reusable = false}, SHIFT(593),
  [5602] = {.count = 1, .reusable = true}, SHIFT(2587),
  [5604] = {.count = 1, .reusable = true}, SHIFT(2588),
  [5606] = {.count = 1, .reusable = true}, SHIFT(2589),
  [5608] = {.count = 1, .reusable = true}, SHIFT(2592),
  [5610] = {.count = 1, .reusable = true}, SHIFT(2593),
  [5612] = {.count = 1, .reusable = false}, SHIFT(2594),
  [5614] = {.count = 1, .reusable = true}, SHIFT(2594),
  [5616] = {.count = 1, .reusable = true}, SHIFT(2595),
  [5618] = {.count = 1, .reusable = false}, SHIFT(2596),
  [5620] = {.count = 1, .reusable = true}, SHIFT(2596),
  [5622] = {.count = 1, .reusable = true}, SHIFT(2597),
  [5624] = {.count = 1, .reusable = false}, SHIFT(2598),
  [5626] = {.count = 1, .reusable = true}, SHIFT(2598),
  [5628] = {.count = 1, .reusable = true}, SHIFT(2599),
  [5630] = {.count = 1, .reusable = true}, SHIFT(2600),
  [5632] = {.count = 1, .reusable = true}, SHIFT(2601),
  [5634] = {.count = 1, .reusable = true}, SHIFT(2604),
  [5636] = {.count = 1, .reusable = true}, SHIFT(2605),
  [5638] = {.count = 1, .reusable = false}, SHIFT(2606),
  [5640] = {.count = 1, .reusable = true}, SHIFT(2606),
  [5642] = {.count = 1, .reusable = true}, SHIFT(2607),
  [5644] = {.count = 1, .reusable = false}, SHIFT(2608),
  [5646] = {.count = 1, .reusable = true}, SHIFT(2608),
  [5648] = {.count = 1, .reusable = true}, SHIFT(2609),
  [5650] = {.count = 1, .reusable = false}, SHIFT(2610),
  [5652] = {.count = 1, .reusable = true}, SHIFT(2610),
  [5654] = {.count = 1, .reusable = true}, SHIFT(2611),
  [5656] = {.count = 1, .reusable = true}, SHIFT(2612),
  [5658] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 4),
  [5660] = {.count = 1, .reusable = true}, SHIFT(2613),
  [5662] = {.count = 1, .reusable = true}, SHIFT(2614),
  [5664] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 4, .alias_sequence_id = 4),
  [5666] = {.count = 1, .reusable = true}, SHIFT(2615),
  [5668] = {.count = 1, .reusable = true}, SHIFT(2616),
  [5670] = {.count = 1, .reusable = false}, SHIFT(2618),
  [5672] = {.count = 1, .reusable = false}, SHIFT(2619),
  [5674] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5),
  [5676] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5),
  [5678] = {.count = 1, .reusable = true}, SHIFT(2620),
  [5680] = {.count = 1, .reusable = true}, SHIFT(2621),
  [5682] = {.count = 1, .reusable = true}, SHIFT(2622),
  [5684] = {.count = 1, .reusable = false}, SHIFT(2623),
  [5686] = {.count = 1, .reusable = true}, SHIFT(2623),
  [5688] = {.count = 1, .reusable = true}, SHIFT(2624),
  [5690] = {.count = 1, .reusable = false}, SHIFT(2626),
  [5692] = {.count = 1, .reusable = true}, SHIFT(2626),
  [5694] = {.count = 1, .reusable = true}, SHIFT(2625),
  [5696] = {.count = 1, .reusable = true}, SHIFT(2627),
  [5698] = {.count = 1, .reusable = false}, SHIFT(2629),
  [5700] = {.count = 1, .reusable = true}, SHIFT(2629),
  [5702] = {.count = 1, .reusable = true}, SHIFT(2628),
  [5704] = {.count = 1, .reusable = true}, SHIFT(2630),
  [5706] = {.count = 1, .reusable = true}, SHIFT(2631),
  [5708] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 6),
  [5710] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 6),
  [5712] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1946),
  [5715] = {.count = 1, .reusable = true}, SHIFT(2632),
  [5717] = {.count = 1, .reusable = true}, SHIFT(2633),
  [5719] = {.count = 1, .reusable = true}, SHIFT(2634),
  [5721] = {.count = 1, .reusable = false}, SHIFT(2635),
  [5723] = {.count = 1, .reusable = true}, SHIFT(2635),
  [5725] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 5),
  [5727] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 5),
  [5729] = {.count = 1, .reusable = false}, SHIFT(2636),
  [5731] = {.count = 1, .reusable = true}, SHIFT(2636),
  [5733] = {.count = 1, .reusable = false}, SHIFT(2637),
  [5735] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1262),
  [5738] = {.count = 1, .reusable = false}, SHIFT(2638),
  [5740] = {.count = 1, .reusable = true}, SHIFT(2639),
  [5742] = {.count = 1, .reusable = true}, SHIFT(2640),
  [5744] = {.count = 1, .reusable = true}, SHIFT(2643),
  [5746] = {.count = 1, .reusable = true}, SHIFT(2644),
  [5748] = {.count = 1, .reusable = false}, SHIFT(2646),
  [5750] = {.count = 1, .reusable = true}, SHIFT(2646),
  [5752] = {.count = 1, .reusable = true}, SHIFT(2645),
  [5754] = {.count = 1, .reusable = false}, SHIFT(2648),
  [5756] = {.count = 1, .reusable = true}, SHIFT(2648),
  [5758] = {.count = 1, .reusable = true}, SHIFT(2647),
  [5760] = {.count = 1, .reusable = true}, SHIFT(2649),
  [5762] = {.count = 1, .reusable = true}, SHIFT(2650),
  [5764] = {.count = 1, .reusable = false}, SHIFT(2651),
  [5766] = {.count = 1, .reusable = true}, SHIFT(2651),
  [5768] = {.count = 1, .reusable = true}, SHIFT(2652),
  [5770] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 3),
  [5772] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 3),
  [5774] = {.count = 1, .reusable = true}, SHIFT(2653),
  [5776] = {.count = 1, .reusable = true}, SHIFT(2656),
  [5778] = {.count = 1, .reusable = true}, SHIFT(2657),
  [5780] = {.count = 1, .reusable = true}, SHIFT(2660),
  [5782] = {.count = 1, .reusable = true}, SHIFT(2661),
  [5784] = {.count = 1, .reusable = false}, SHIFT(2663),
  [5786] = {.count = 1, .reusable = true}, SHIFT(2663),
  [5788] = {.count = 1, .reusable = true}, SHIFT(2662),
  [5790] = {.count = 1, .reusable = false}, SHIFT(2665),
  [5792] = {.count = 1, .reusable = true}, SHIFT(2665),
  [5794] = {.count = 1, .reusable = true}, SHIFT(2664),
  [5796] = {.count = 1, .reusable = true}, SHIFT(2666),
  [5798] = {.count = 1, .reusable = true}, SHIFT(2667),
  [5800] = {.count = 1, .reusable = false}, SHIFT(2668),
  [5802] = {.count = 1, .reusable = true}, SHIFT(2668),
  [5804] = {.count = 1, .reusable = true}, SHIFT(2669),
  [5806] = {.count = 1, .reusable = false}, SHIFT(2670),
  [5808] = {.count = 1, .reusable = true}, SHIFT(2671),
  [5810] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1335),
  [5813] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1339),
  [5816] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1339),
  [5819] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1340),
  [5822] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 6),
  [5824] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 6, .alias_sequence_id = 4),
  [5826] = {.count = 1, .reusable = false}, SHIFT(2675),
  [5828] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1354),
  [5831] = {.count = 1, .reusable = false}, SHIFT(2676),
  [5833] = {.count = 1, .reusable = true}, SHIFT(2677),
  [5835] = {.count = 1, .reusable = true}, SHIFT(2678),
  [5837] = {.count = 1, .reusable = true}, SHIFT(2681),
  [5839] = {.count = 1, .reusable = true}, SHIFT(2682),
  [5841] = {.count = 1, .reusable = false}, SHIFT(2684),
  [5843] = {.count = 1, .reusable = true}, SHIFT(2684),
  [5845] = {.count = 1, .reusable = true}, SHIFT(2683),
  [5847] = {.count = 1, .reusable = false}, SHIFT(2686),
  [5849] = {.count = 1, .reusable = true}, SHIFT(2686),
  [5851] = {.count = 1, .reusable = true}, SHIFT(2685),
  [5853] = {.count = 1, .reusable = true}, SHIFT(2687),
  [5855] = {.count = 1, .reusable = true}, SHIFT(2688),
  [5857] = {.count = 1, .reusable = false}, SHIFT(2689),
  [5859] = {.count = 1, .reusable = true}, SHIFT(2689),
  [5861] = {.count = 1, .reusable = true}, SHIFT(2690),
  [5863] = {.count = 1, .reusable = false}, SHIFT(737),
  [5865] = {.count = 1, .reusable = true}, SHIFT(2691),
  [5867] = {.count = 1, .reusable = true}, SHIFT(2692),
  [5869] = {.count = 1, .reusable = true}, SHIFT(2693),
  [5871] = {.count = 1, .reusable = true}, SHIFT(2696),
  [5873] = {.count = 1, .reusable = true}, SHIFT(2697),
  [5875] = {.count = 1, .reusable = false}, SHIFT(2698),
  [5877] = {.count = 1, .reusable = true}, SHIFT(2698),
  [5879] = {.count = 1, .reusable = true}, SHIFT(2699),
  [5881] = {.count = 1, .reusable = false}, SHIFT(2700),
  [5883] = {.count = 1, .reusable = true}, SHIFT(2700),
  [5885] = {.count = 1, .reusable = true}, SHIFT(2701),
  [5887] = {.count = 1, .reusable = false}, SHIFT(2702),
  [5889] = {.count = 1, .reusable = true}, SHIFT(2702),
  [5891] = {.count = 1, .reusable = true}, REDUCE(sym_c_style_for_statement, 6),
  [5893] = {.count = 1, .reusable = false}, REDUCE(sym_c_style_for_statement, 6),
  [5895] = {.count = 1, .reusable = true}, SHIFT(2704),
  [5897] = {.count = 1, .reusable = true}, SHIFT(2705),
  [5899] = {.count = 1, .reusable = false}, SHIFT(759),
  [5901] = {.count = 1, .reusable = true}, SHIFT(2706),
  [5903] = {.count = 1, .reusable = true}, SHIFT(2707),
  [5905] = {.count = 1, .reusable = true}, SHIFT(2708),
  [5907] = {.count = 1, .reusable = true}, SHIFT(2711),
  [5909] = {.count = 1, .reusable = true}, SHIFT(2712),
  [5911] = {.count = 1, .reusable = false}, SHIFT(2713),
  [5913] = {.count = 1, .reusable = true}, SHIFT(2713),
  [5915] = {.count = 1, .reusable = true}, SHIFT(2714),
  [5917] = {.count = 1, .reusable = false}, SHIFT(2715),
  [5919] = {.count = 1, .reusable = true}, SHIFT(2715),
  [5921] = {.count = 1, .reusable = true}, SHIFT(2716),
  [5923] = {.count = 1, .reusable = false}, SHIFT(2717),
  [5925] = {.count = 1, .reusable = true}, SHIFT(2717),
  [5927] = {.count = 1, .reusable = false}, SHIFT(2719),
  [5929] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1415),
  [5932] = {.count = 1, .reusable = false}, SHIFT(2720),
  [5934] = {.count = 1, .reusable = true}, SHIFT(2721),
  [5936] = {.count = 1, .reusable = true}, SHIFT(2722),
  [5938] = {.count = 1, .reusable = true}, SHIFT(2725),
  [5940] = {.count = 1, .reusable = true}, SHIFT(2726),
  [5942] = {.count = 1, .reusable = false}, SHIFT(2728),
  [5944] = {.count = 1, .reusable = true}, SHIFT(2728),
  [5946] = {.count = 1, .reusable = true}, SHIFT(2727),
  [5948] = {.count = 1, .reusable = false}, SHIFT(2730),
  [5950] = {.count = 1, .reusable = true}, SHIFT(2730),
  [5952] = {.count = 1, .reusable = true}, SHIFT(2729),
  [5954] = {.count = 1, .reusable = true}, SHIFT(2731),
  [5956] = {.count = 1, .reusable = true}, SHIFT(2732),
  [5958] = {.count = 1, .reusable = false}, SHIFT(2733),
  [5960] = {.count = 1, .reusable = true}, SHIFT(2733),
  [5962] = {.count = 1, .reusable = true}, SHIFT(2734),
  [5964] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 6),
  [5966] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 6),
  [5968] = {.count = 1, .reusable = false}, SHIFT(794),
  [5970] = {.count = 1, .reusable = true}, SHIFT(2735),
  [5972] = {.count = 1, .reusable = true}, SHIFT(2736),
  [5974] = {.count = 1, .reusable = true}, SHIFT(2737),
  [5976] = {.count = 1, .reusable = true}, SHIFT(2740),
  [5978] = {.count = 1, .reusable = true}, SHIFT(2741),
  [5980] = {.count = 1, .reusable = false}, SHIFT(2742),
  [5982] = {.count = 1, .reusable = true}, SHIFT(2742),
  [5984] = {.count = 1, .reusable = true}, SHIFT(2743),
  [5986] = {.count = 1, .reusable = false}, SHIFT(2744),
  [5988] = {.count = 1, .reusable = true}, SHIFT(2744),
  [5990] = {.count = 1, .reusable = true}, SHIFT(2745),
  [5992] = {.count = 1, .reusable = false}, SHIFT(2746),
  [5994] = {.count = 1, .reusable = true}, SHIFT(2746),
  [5996] = {.count = 1, .reusable = true}, SHIFT(2747),
  [5998] = {.count = 1, .reusable = true}, SHIFT(2748),
  [6000] = {.count = 1, .reusable = true}, SHIFT(2749),
  [6002] = {.count = 1, .reusable = false}, SHIFT(2750),
  [6004] = {.count = 1, .reusable = true}, SHIFT(2750),
  [6006] = {.count = 1, .reusable = false}, SHIFT(2751),
  [6008] = {.count = 1, .reusable = true}, SHIFT(2751),
  [6010] = {.count = 1, .reusable = true}, SHIFT(2752),
  [6012] = {.count = 1, .reusable = false}, SHIFT(2753),
  [6014] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1473),
  [6017] = {.count = 1, .reusable = false}, SHIFT(2754),
  [6019] = {.count = 1, .reusable = true}, SHIFT(2755),
  [6021] = {.count = 1, .reusable = true}, SHIFT(2756),
  [6023] = {.count = 1, .reusable = true}, SHIFT(2759),
  [6025] = {.count = 1, .reusable = true}, SHIFT(2760),
  [6027] = {.count = 1, .reusable = false}, SHIFT(2762),
  [6029] = {.count = 1, .reusable = true}, SHIFT(2762),
  [6031] = {.count = 1, .reusable = true}, SHIFT(2761),
  [6033] = {.count = 1, .reusable = false}, SHIFT(2764),
  [6035] = {.count = 1, .reusable = true}, SHIFT(2764),
  [6037] = {.count = 1, .reusable = true}, SHIFT(2763),
  [6039] = {.count = 1, .reusable = true}, SHIFT(2765),
  [6041] = {.count = 1, .reusable = true}, SHIFT(2766),
  [6043] = {.count = 1, .reusable = false}, SHIFT(2767),
  [6045] = {.count = 1, .reusable = true}, SHIFT(2767),
  [6047] = {.count = 1, .reusable = true}, SHIFT(2768),
  [6049] = {.count = 1, .reusable = true}, SHIFT(2769),
  [6051] = {.count = 1, .reusable = true}, SHIFT(2771),
  [6053] = {.count = 1, .reusable = false}, SHIFT(2773),
  [6055] = {.count = 1, .reusable = true}, SHIFT(2773),
  [6057] = {.count = 1, .reusable = true}, SHIFT(2775),
  [6059] = {.count = 1, .reusable = true}, SHIFT(2777),
  [6061] = {.count = 1, .reusable = false}, SHIFT(2777),
  [6063] = {.count = 1, .reusable = true}, SHIFT(2780),
  [6065] = {.count = 1, .reusable = false}, SHIFT(2780),
  [6067] = {.count = 1, .reusable = true}, SHIFT(2783),
  [6069] = {.count = 1, .reusable = false}, SHIFT(863),
  [6071] = {.count = 1, .reusable = true}, SHIFT(2784),
  [6073] = {.count = 1, .reusable = true}, SHIFT(2785),
  [6075] = {.count = 1, .reusable = true}, SHIFT(2786),
  [6077] = {.count = 1, .reusable = true}, SHIFT(2789),
  [6079] = {.count = 1, .reusable = true}, SHIFT(2790),
  [6081] = {.count = 1, .reusable = false}, SHIFT(2791),
  [6083] = {.count = 1, .reusable = true}, SHIFT(2791),
  [6085] = {.count = 1, .reusable = true}, SHIFT(2792),
  [6087] = {.count = 1, .reusable = false}, SHIFT(2793),
  [6089] = {.count = 1, .reusable = true}, SHIFT(2793),
  [6091] = {.count = 1, .reusable = true}, SHIFT(2794),
  [6093] = {.count = 1, .reusable = false}, SHIFT(2795),
  [6095] = {.count = 1, .reusable = true}, SHIFT(2795),
  [6097] = {.count = 1, .reusable = false}, SHIFT(882),
  [6099] = {.count = 1, .reusable = true}, SHIFT(2796),
  [6101] = {.count = 1, .reusable = true}, SHIFT(2797),
  [6103] = {.count = 1, .reusable = true}, SHIFT(2798),
  [6105] = {.count = 1, .reusable = true}, SHIFT(2801),
  [6107] = {.count = 1, .reusable = true}, SHIFT(2802),
  [6109] = {.count = 1, .reusable = false}, SHIFT(2803),
  [6111] = {.count = 1, .reusable = true}, SHIFT(2803),
  [6113] = {.count = 1, .reusable = true}, SHIFT(2804),
  [6115] = {.count = 1, .reusable = false}, SHIFT(2805),
  [6117] = {.count = 1, .reusable = true}, SHIFT(2805),
  [6119] = {.count = 1, .reusable = true}, SHIFT(2806),
  [6121] = {.count = 1, .reusable = false}, SHIFT(2807),
  [6123] = {.count = 1, .reusable = true}, SHIFT(2807),
  [6125] = {.count = 1, .reusable = true}, SHIFT(2808),
  [6127] = {.count = 1, .reusable = true}, SHIFT(2809),
  [6129] = {.count = 1, .reusable = true}, SHIFT(2810),
  [6131] = {.count = 1, .reusable = false}, SHIFT(2811),
  [6133] = {.count = 1, .reusable = true}, SHIFT(2811),
  [6135] = {.count = 1, .reusable = false}, SHIFT(2812),
  [6137] = {.count = 1, .reusable = true}, SHIFT(2812),
  [6139] = {.count = 1, .reusable = true}, SHIFT(2813),
  [6141] = {.count = 1, .reusable = true}, SHIFT(2814),
  [6143] = {.count = 1, .reusable = true}, SHIFT(2816),
  [6145] = {.count = 1, .reusable = true}, SHIFT(2817),
  [6147] = {.count = 1, .reusable = false}, SHIFT(2818),
  [6149] = {.count = 1, .reusable = true}, SHIFT(2818),
  [6151] = {.count = 1, .reusable = true}, SHIFT(2819),
  [6153] = {.count = 1, .reusable = false}, SHIFT(2821),
  [6155] = {.count = 1, .reusable = false}, SHIFT(2822),
  [6157] = {.count = 1, .reusable = true}, SHIFT(2824),
  [6159] = {.count = 1, .reusable = true}, SHIFT(2825),
  [6161] = {.count = 1, .reusable = true}, SHIFT(2826),
  [6163] = {.count = 1, .reusable = false}, SHIFT(2827),
  [6165] = {.count = 1, .reusable = true}, SHIFT(2827),
  [6167] = {.count = 1, .reusable = true}, SHIFT(2832),
  [6169] = {.count = 1, .reusable = true}, SHIFT(2834),
  [6171] = {.count = 1, .reusable = true}, SHIFT(2835),
  [6173] = {.count = 1, .reusable = true}, SHIFT(2836),
  [6175] = {.count = 1, .reusable = true}, SHIFT(2838),
  [6177] = {.count = 1, .reusable = true}, SHIFT(2839),
  [6179] = {.count = 1, .reusable = false}, SHIFT(2841),
  [6181] = {.count = 1, .reusable = false}, SHIFT(2842),
  [6183] = {.count = 1, .reusable = true}, SHIFT(2843),
  [6185] = {.count = 1, .reusable = true}, SHIFT(2844),
  [6187] = {.count = 1, .reusable = true}, SHIFT(2845),
  [6189] = {.count = 1, .reusable = false}, SHIFT(2846),
  [6191] = {.count = 1, .reusable = true}, SHIFT(2846),
  [6193] = {.count = 1, .reusable = true}, SHIFT(2847),
  [6195] = {.count = 1, .reusable = false}, SHIFT(2849),
  [6197] = {.count = 1, .reusable = true}, SHIFT(2849),
  [6199] = {.count = 1, .reusable = true}, SHIFT(2848),
  [6201] = {.count = 1, .reusable = true}, SHIFT(2850),
  [6203] = {.count = 1, .reusable = false}, SHIFT(2852),
  [6205] = {.count = 1, .reusable = true}, SHIFT(2852),
  [6207] = {.count = 1, .reusable = true}, SHIFT(2851),
  [6209] = {.count = 1, .reusable = true}, SHIFT(2853),
  [6211] = {.count = 1, .reusable = true}, SHIFT(2854),
  [6213] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1560),
  [6216] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1561),
  [6219] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1562),
  [6222] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1563),
  [6225] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1564),
  [6228] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1565),
  [6231] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1566),
  [6234] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1567),
  [6237] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1568),
  [6240] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2226),
  [6243] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1564),
  [6246] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(2227),
  [6249] = {.count = 1, .reusable = true}, SHIFT(2855),
  [6251] = {.count = 1, .reusable = true}, SHIFT(2856),
  [6253] = {.count = 1, .reusable = false}, SHIFT(2858),
  [6255] = {.count = 1, .reusable = false}, SHIFT(2859),
  [6257] = {.count = 1, .reusable = true}, SHIFT(2860),
  [6259] = {.count = 1, .reusable = true}, SHIFT(2861),
  [6261] = {.count = 1, .reusable = true}, SHIFT(2862),
  [6263] = {.count = 1, .reusable = false}, SHIFT(2863),
  [6265] = {.count = 1, .reusable = true}, SHIFT(2863),
  [6267] = {.count = 1, .reusable = true}, SHIFT(2864),
  [6269] = {.count = 1, .reusable = false}, SHIFT(2866),
  [6271] = {.count = 1, .reusable = true}, SHIFT(2866),
  [6273] = {.count = 1, .reusable = true}, SHIFT(2865),
  [6275] = {.count = 1, .reusable = true}, SHIFT(2867),
  [6277] = {.count = 1, .reusable = false}, SHIFT(2869),
  [6279] = {.count = 1, .reusable = true}, SHIFT(2869),
  [6281] = {.count = 1, .reusable = true}, SHIFT(2868),
  [6283] = {.count = 1, .reusable = true}, SHIFT(2870),
  [6285] = {.count = 1, .reusable = true}, SHIFT(2871),
  [6287] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1572),
  [6290] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1573),
  [6293] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1574),
  [6296] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1575),
  [6299] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1576),
  [6302] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1577),
  [6305] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1578),
  [6308] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1579),
  [6311] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2245),
  [6314] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1575),
  [6317] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(2246),
  [6320] = {.count = 1, .reusable = false}, SHIFT(2872),
  [6322] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1585),
  [6325] = {.count = 1, .reusable = false}, SHIFT(2873),
  [6327] = {.count = 1, .reusable = true}, SHIFT(2874),
  [6329] = {.count = 1, .reusable = true}, SHIFT(2875),
  [6331] = {.count = 1, .reusable = true}, SHIFT(2878),
  [6333] = {.count = 1, .reusable = true}, SHIFT(2879),
  [6335] = {.count = 1, .reusable = false}, SHIFT(2881),
  [6337] = {.count = 1, .reusable = true}, SHIFT(2881),
  [6339] = {.count = 1, .reusable = true}, SHIFT(2880),
  [6341] = {.count = 1, .reusable = false}, SHIFT(2883),
  [6343] = {.count = 1, .reusable = true}, SHIFT(2883),
  [6345] = {.count = 1, .reusable = true}, SHIFT(2882),
  [6347] = {.count = 1, .reusable = true}, SHIFT(2884),
  [6349] = {.count = 1, .reusable = true}, SHIFT(2885),
  [6351] = {.count = 1, .reusable = false}, SHIFT(2886),
  [6353] = {.count = 1, .reusable = true}, SHIFT(2886),
  [6355] = {.count = 1, .reusable = true}, SHIFT(2887),
  [6357] = {.count = 1, .reusable = true}, SHIFT(2888),
  [6359] = {.count = 1, .reusable = true}, SHIFT(2890),
  [6361] = {.count = 1, .reusable = true}, SHIFT(2891),
  [6363] = {.count = 1, .reusable = false}, SHIFT(2892),
  [6365] = {.count = 1, .reusable = true}, SHIFT(2892),
  [6367] = {.count = 1, .reusable = true}, SHIFT(2893),
  [6369] = {.count = 1, .reusable = false}, SHIFT(2895),
  [6371] = {.count = 1, .reusable = false}, SHIFT(2896),
  [6373] = {.count = 1, .reusable = true}, SHIFT(2898),
  [6375] = {.count = 1, .reusable = true}, SHIFT(2899),
  [6377] = {.count = 1, .reusable = true}, SHIFT(2900),
  [6379] = {.count = 1, .reusable = false}, SHIFT(2901),
  [6381] = {.count = 1, .reusable = true}, SHIFT(2901),
  [6383] = {.count = 1, .reusable = true}, SHIFT(2906),
  [6385] = {.count = 1, .reusable = false}, REDUCE(sym__statements, 3),
  [6387] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1599),
  [6390] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1603),
  [6393] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1603),
  [6396] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1604),
  [6399] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1607),
  [6402] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(924),
  [6405] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(925),
  [6408] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(926),
  [6411] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1608),
  [6414] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(928),
  [6417] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(929),
  [6420] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(930),
  [6423] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(931),
  [6426] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1608),
  [6429] = {.count = 1, .reusable = false}, SHIFT(2908),
  [6431] = {.count = 1, .reusable = true}, SHIFT(2908),
  [6433] = {.count = 1, .reusable = false}, SHIFT(2909),
  [6435] = {.count = 1, .reusable = true}, SHIFT(2910),
  [6437] = {.count = 1, .reusable = true}, SHIFT(2912),
  [6439] = {.count = 1, .reusable = true}, SHIFT(2913),
  [6441] = {.count = 1, .reusable = false}, SHIFT(2914),
  [6443] = {.count = 1, .reusable = true}, SHIFT(2914),
  [6445] = {.count = 1, .reusable = true}, SHIFT(2915),
  [6447] = {.count = 1, .reusable = false}, SHIFT(2917),
  [6449] = {.count = 1, .reusable = false}, SHIFT(2918),
  [6451] = {.count = 1, .reusable = true}, SHIFT(2920),
  [6453] = {.count = 1, .reusable = true}, SHIFT(2921),
  [6455] = {.count = 1, .reusable = true}, SHIFT(2922),
  [6457] = {.count = 1, .reusable = false}, SHIFT(2923),
  [6459] = {.count = 1, .reusable = true}, SHIFT(2923),
  [6461] = {.count = 1, .reusable = true}, SHIFT(2928),
  [6463] = {.count = 1, .reusable = false}, REDUCE(sym_elif_clause, 3),
  [6465] = {.count = 1, .reusable = true}, SHIFT(2931),
  [6467] = {.count = 1, .reusable = true}, SHIFT(2932),
  [6469] = {.count = 1, .reusable = false}, SHIFT(2933),
  [6471] = {.count = 1, .reusable = true}, SHIFT(2934),
  [6473] = {.count = 1, .reusable = true}, SHIFT(2935),
  [6475] = {.count = 1, .reusable = true}, SHIFT(2936),
  [6477] = {.count = 1, .reusable = true}, SHIFT(2937),
  [6479] = {.count = 1, .reusable = true}, SHIFT(2938),
  [6481] = {.count = 1, .reusable = true}, SHIFT(2939),
  [6483] = {.count = 1, .reusable = true}, SHIFT(2940),
  [6485] = {.count = 1, .reusable = true}, SHIFT(2942),
  [6487] = {.count = 1, .reusable = true}, SHIFT(2943),
  [6489] = {.count = 1, .reusable = true}, SHIFT(2944),
  [6491] = {.count = 1, .reusable = false}, SHIFT(2945),
  [6493] = {.count = 1, .reusable = true}, SHIFT(2945),
  [6495] = {.count = 1, .reusable = true}, SHIFT(2946),
  [6497] = {.count = 1, .reusable = false}, SHIFT(2948),
  [6499] = {.count = 1, .reusable = false}, SHIFT(2949),
  [6501] = {.count = 1, .reusable = true}, SHIFT(2951),
  [6503] = {.count = 1, .reusable = true}, SHIFT(2952),
  [6505] = {.count = 1, .reusable = true}, SHIFT(2953),
  [6507] = {.count = 1, .reusable = false}, SHIFT(2954),
  [6509] = {.count = 1, .reusable = true}, SHIFT(2954),
  [6511] = {.count = 1, .reusable = false}, SHIFT(2959),
  [6513] = {.count = 1, .reusable = true}, SHIFT(2960),
  [6515] = {.count = 1, .reusable = true}, SHIFT(2962),
  [6517] = {.count = 1, .reusable = true}, SHIFT(2963),
  [6519] = {.count = 1, .reusable = false}, SHIFT(2964),
  [6521] = {.count = 1, .reusable = true}, SHIFT(2964),
  [6523] = {.count = 1, .reusable = true}, SHIFT(2965),
  [6525] = {.count = 1, .reusable = false}, SHIFT(2967),
  [6527] = {.count = 1, .reusable = false}, SHIFT(2968),
  [6529] = {.count = 1, .reusable = true}, SHIFT(2970),
  [6531] = {.count = 1, .reusable = true}, SHIFT(2971),
  [6533] = {.count = 1, .reusable = true}, SHIFT(2972),
  [6535] = {.count = 1, .reusable = false}, SHIFT(2973),
  [6537] = {.count = 1, .reusable = true}, SHIFT(2973),
  [6539] = {.count = 1, .reusable = false}, SHIFT(2978),
  [6541] = {.count = 1, .reusable = true}, SHIFT(2979),
  [6543] = {.count = 1, .reusable = true}, SHIFT(2981),
  [6545] = {.count = 1, .reusable = true}, SHIFT(2982),
  [6547] = {.count = 1, .reusable = false}, SHIFT(2984),
  [6549] = {.count = 1, .reusable = false}, SHIFT(2985),
  [6551] = {.count = 1, .reusable = true}, SHIFT(2986),
  [6553] = {.count = 1, .reusable = true}, SHIFT(2987),
  [6555] = {.count = 1, .reusable = true}, SHIFT(2988),
  [6557] = {.count = 1, .reusable = false}, SHIFT(2989),
  [6559] = {.count = 1, .reusable = true}, SHIFT(2989),
  [6561] = {.count = 1, .reusable = true}, SHIFT(2990),
  [6563] = {.count = 1, .reusable = false}, SHIFT(2992),
  [6565] = {.count = 1, .reusable = true}, SHIFT(2992),
  [6567] = {.count = 1, .reusable = true}, SHIFT(2991),
  [6569] = {.count = 1, .reusable = true}, SHIFT(2993),
  [6571] = {.count = 1, .reusable = false}, SHIFT(2995),
  [6573] = {.count = 1, .reusable = true}, SHIFT(2995),
  [6575] = {.count = 1, .reusable = true}, SHIFT(2994),
  [6577] = {.count = 1, .reusable = true}, SHIFT(2996),
  [6579] = {.count = 1, .reusable = true}, SHIFT(2997),
  [6581] = {.count = 1, .reusable = false}, SHIFT(2998),
  [6583] = {.count = 1, .reusable = true}, SHIFT(2998),
  [6585] = {.count = 1, .reusable = true}, SHIFT(3003),
  [6587] = {.count = 1, .reusable = true}, SHIFT(3004),
  [6589] = {.count = 1, .reusable = true}, SHIFT(3006),
  [6591] = {.count = 1, .reusable = false}, SHIFT(3008),
  [6593] = {.count = 1, .reusable = true}, SHIFT(3008),
  [6595] = {.count = 1, .reusable = true}, SHIFT(3010),
  [6597] = {.count = 1, .reusable = true}, SHIFT(3011),
  [6599] = {.count = 1, .reusable = false}, SHIFT(3014),
  [6601] = {.count = 1, .reusable = true}, SHIFT(3014),
  [6603] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(2358),
  [6606] = {.count = 1, .reusable = true}, SHIFT(3017),
  [6608] = {.count = 1, .reusable = true}, SHIFT(3018),
  [6610] = {.count = 1, .reusable = true}, SHIFT(3019),
  [6612] = {.count = 1, .reusable = true}, SHIFT(3021),
  [6614] = {.count = 1, .reusable = true}, SHIFT(3022),
  [6616] = {.count = 1, .reusable = false}, SHIFT(3024),
  [6618] = {.count = 1, .reusable = false}, SHIFT(3025),
  [6620] = {.count = 1, .reusable = true}, SHIFT(3026),
  [6622] = {.count = 1, .reusable = true}, SHIFT(3027),
  [6624] = {.count = 1, .reusable = true}, SHIFT(3028),
  [6626] = {.count = 1, .reusable = false}, SHIFT(3029),
  [6628] = {.count = 1, .reusable = true}, SHIFT(3029),
  [6630] = {.count = 1, .reusable = true}, SHIFT(3030),
  [6632] = {.count = 1, .reusable = false}, SHIFT(3032),
  [6634] = {.count = 1, .reusable = true}, SHIFT(3032),
  [6636] = {.count = 1, .reusable = true}, SHIFT(3031),
  [6638] = {.count = 1, .reusable = true}, SHIFT(3033),
  [6640] = {.count = 1, .reusable = false}, SHIFT(3035),
  [6642] = {.count = 1, .reusable = true}, SHIFT(3035),
  [6644] = {.count = 1, .reusable = true}, SHIFT(3034),
  [6646] = {.count = 1, .reusable = true}, SHIFT(3036),
  [6648] = {.count = 1, .reusable = true}, SHIFT(3037),
  [6650] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1645),
  [6653] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1646),
  [6656] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1647),
  [6659] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1648),
  [6662] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1649),
  [6665] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1650),
  [6668] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1651),
  [6671] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1652),
  [6674] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1653),
  [6677] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2377),
  [6680] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1649),
  [6683] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(2378),
  [6686] = {.count = 1, .reusable = true}, SHIFT(3038),
  [6688] = {.count = 1, .reusable = true}, SHIFT(3039),
  [6690] = {.count = 1, .reusable = false}, SHIFT(3041),
  [6692] = {.count = 1, .reusable = false}, SHIFT(3042),
  [6694] = {.count = 1, .reusable = true}, SHIFT(3043),
  [6696] = {.count = 1, .reusable = true}, SHIFT(3044),
  [6698] = {.count = 1, .reusable = true}, SHIFT(3045),
  [6700] = {.count = 1, .reusable = false}, SHIFT(3046),
  [6702] = {.count = 1, .reusable = true}, SHIFT(3046),
  [6704] = {.count = 1, .reusable = true}, SHIFT(3047),
  [6706] = {.count = 1, .reusable = false}, SHIFT(3049),
  [6708] = {.count = 1, .reusable = true}, SHIFT(3049),
  [6710] = {.count = 1, .reusable = true}, SHIFT(3048),
  [6712] = {.count = 1, .reusable = true}, SHIFT(3050),
  [6714] = {.count = 1, .reusable = false}, SHIFT(3052),
  [6716] = {.count = 1, .reusable = true}, SHIFT(3052),
  [6718] = {.count = 1, .reusable = true}, SHIFT(3051),
  [6720] = {.count = 1, .reusable = true}, SHIFT(3053),
  [6722] = {.count = 1, .reusable = true}, SHIFT(3054),
  [6724] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1657),
  [6727] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1658),
  [6730] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1659),
  [6733] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1660),
  [6736] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1661),
  [6739] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1662),
  [6742] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1663),
  [6745] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1664),
  [6748] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2396),
  [6751] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1660),
  [6754] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(2397),
  [6757] = {.count = 1, .reusable = false}, SHIFT(3055),
  [6759] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1670),
  [6762] = {.count = 1, .reusable = false}, SHIFT(3056),
  [6764] = {.count = 1, .reusable = true}, SHIFT(3057),
  [6766] = {.count = 1, .reusable = true}, SHIFT(3058),
  [6768] = {.count = 1, .reusable = true}, SHIFT(3061),
  [6770] = {.count = 1, .reusable = true}, SHIFT(3062),
  [6772] = {.count = 1, .reusable = false}, SHIFT(3064),
  [6774] = {.count = 1, .reusable = true}, SHIFT(3064),
  [6776] = {.count = 1, .reusable = true}, SHIFT(3063),
  [6778] = {.count = 1, .reusable = false}, SHIFT(3066),
  [6780] = {.count = 1, .reusable = true}, SHIFT(3066),
  [6782] = {.count = 1, .reusable = true}, SHIFT(3065),
  [6784] = {.count = 1, .reusable = true}, SHIFT(3067),
  [6786] = {.count = 1, .reusable = true}, SHIFT(3068),
  [6788] = {.count = 1, .reusable = false}, SHIFT(3069),
  [6790] = {.count = 1, .reusable = true}, SHIFT(3069),
  [6792] = {.count = 1, .reusable = true}, SHIFT(3070),
  [6794] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 6),
  [6796] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 6),
  [6798] = {.count = 1, .reusable = true}, SHIFT(3071),
  [6800] = {.count = 1, .reusable = true}, SHIFT(3072),
  [6802] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1686),
  [6805] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1690),
  [6808] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1690),
  [6811] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1691),
  [6814] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1694),
  [6817] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(968),
  [6820] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(969),
  [6823] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(970),
  [6826] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1695),
  [6829] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(972),
  [6832] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(973),
  [6835] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(974),
  [6838] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(975),
  [6841] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1695),
  [6844] = {.count = 1, .reusable = false}, SHIFT(3076),
  [6846] = {.count = 1, .reusable = true}, SHIFT(3076),
  [6848] = {.count = 1, .reusable = true}, SHIFT(3077),
  [6850] = {.count = 1, .reusable = true}, SHIFT(3079),
  [6852] = {.count = 1, .reusable = true}, SHIFT(3082),
  [6854] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 2),
  [6856] = {.count = 1, .reusable = true}, SHIFT(3083),
  [6858] = {.count = 1, .reusable = false}, SHIFT(3084),
  [6860] = {.count = 1, .reusable = false}, SHIFT(3085),
  [6862] = {.count = 1, .reusable = false}, SHIFT(3086),
  [6864] = {.count = 1, .reusable = false}, SHIFT(3087),
  [6866] = {.count = 1, .reusable = false}, SHIFT(3088),
  [6868] = {.count = 1, .reusable = true}, SHIFT(3089),
  [6870] = {.count = 1, .reusable = true}, SHIFT(3090),
  [6872] = {.count = 1, .reusable = true}, SHIFT(3091),
  [6874] = {.count = 1, .reusable = true}, SHIFT(3092),
  [6876] = {.count = 1, .reusable = true}, SHIFT(3093),
  [6878] = {.count = 1, .reusable = true}, SHIFT(3094),
  [6880] = {.count = 1, .reusable = false}, SHIFT(3095),
  [6882] = {.count = 1, .reusable = true}, SHIFT(3105),
  [6884] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 6),
  [6886] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 6),
  [6888] = {.count = 1, .reusable = true}, SHIFT(3107),
  [6890] = {.count = 2, .reusable = false}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(291),
  [6893] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1707),
  [6896] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(293),
  [6899] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(3108),
  [6902] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(295),
  [6905] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(296),
  [6908] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(297),
  [6911] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(298),
  [6914] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 2, .alias_sequence_id = 1),
  [6916] = {.count = 1, .reusable = true}, SHIFT(3111),
  [6918] = {.count = 1, .reusable = true}, SHIFT(3113),
  [6920] = {.count = 1, .reusable = true}, SHIFT(3115),
  [6922] = {.count = 1, .reusable = true}, SHIFT(3116),
  [6924] = {.count = 1, .reusable = true}, SHIFT(3117),
  [6926] = {.count = 1, .reusable = false}, SHIFT(3118),
  [6928] = {.count = 1, .reusable = true}, SHIFT(3118),
  [6930] = {.count = 1, .reusable = false}, SHIFT(3119),
  [6932] = {.count = 1, .reusable = true}, SHIFT(3119),
  [6934] = {.count = 1, .reusable = true}, SHIFT(3120),
  [6936] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 2),
  [6938] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 2),
  [6940] = {.count = 1, .reusable = true}, SHIFT(3121),
  [6942] = {.count = 1, .reusable = false}, SHIFT(3123),
  [6944] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1748),
  [6947] = {.count = 1, .reusable = false}, SHIFT(3124),
  [6949] = {.count = 1, .reusable = true}, SHIFT(3125),
  [6951] = {.count = 1, .reusable = true}, SHIFT(3126),
  [6953] = {.count = 1, .reusable = true}, SHIFT(3129),
  [6955] = {.count = 1, .reusable = true}, SHIFT(3130),
  [6957] = {.count = 1, .reusable = false}, SHIFT(3132),
  [6959] = {.count = 1, .reusable = true}, SHIFT(3132),
  [6961] = {.count = 1, .reusable = true}, SHIFT(3131),
  [6963] = {.count = 1, .reusable = false}, SHIFT(3134),
  [6965] = {.count = 1, .reusable = true}, SHIFT(3134),
  [6967] = {.count = 1, .reusable = true}, SHIFT(3133),
  [6969] = {.count = 1, .reusable = true}, SHIFT(3135),
  [6971] = {.count = 1, .reusable = true}, SHIFT(3136),
  [6973] = {.count = 1, .reusable = false}, SHIFT(3137),
  [6975] = {.count = 1, .reusable = true}, SHIFT(3137),
  [6977] = {.count = 1, .reusable = true}, SHIFT(3138),
  [6979] = {.count = 1, .reusable = true}, SHIFT(3139),
  [6981] = {.count = 1, .reusable = true}, SHIFT(3141),
  [6983] = {.count = 1, .reusable = false}, SHIFT(3143),
  [6985] = {.count = 1, .reusable = true}, SHIFT(3143),
  [6987] = {.count = 1, .reusable = true}, SHIFT(3145),
  [6989] = {.count = 1, .reusable = true}, SHIFT(3147),
  [6991] = {.count = 1, .reusable = false}, SHIFT(3147),
  [6993] = {.count = 1, .reusable = true}, SHIFT(3150),
  [6995] = {.count = 1, .reusable = false}, SHIFT(3150),
  [6997] = {.count = 1, .reusable = true}, SHIFT(3153),
  [6999] = {.count = 1, .reusable = false}, SHIFT(1064),
  [7001] = {.count = 1, .reusable = true}, SHIFT(3154),
  [7003] = {.count = 1, .reusable = true}, SHIFT(3155),
  [7005] = {.count = 1, .reusable = true}, SHIFT(3156),
  [7007] = {.count = 1, .reusable = true}, SHIFT(3159),
  [7009] = {.count = 1, .reusable = true}, SHIFT(3160),
  [7011] = {.count = 1, .reusable = false}, SHIFT(3161),
  [7013] = {.count = 1, .reusable = true}, SHIFT(3161),
  [7015] = {.count = 1, .reusable = true}, SHIFT(3162),
  [7017] = {.count = 1, .reusable = false}, SHIFT(3163),
  [7019] = {.count = 1, .reusable = true}, SHIFT(3163),
  [7021] = {.count = 1, .reusable = true}, SHIFT(3164),
  [7023] = {.count = 1, .reusable = false}, SHIFT(3165),
  [7025] = {.count = 1, .reusable = true}, SHIFT(3165),
  [7027] = {.count = 1, .reusable = false}, SHIFT(1083),
  [7029] = {.count = 1, .reusable = true}, SHIFT(3166),
  [7031] = {.count = 1, .reusable = true}, SHIFT(3167),
  [7033] = {.count = 1, .reusable = true}, SHIFT(3168),
  [7035] = {.count = 1, .reusable = true}, SHIFT(3171),
  [7037] = {.count = 1, .reusable = true}, SHIFT(3172),
  [7039] = {.count = 1, .reusable = false}, SHIFT(3173),
  [7041] = {.count = 1, .reusable = true}, SHIFT(3173),
  [7043] = {.count = 1, .reusable = true}, SHIFT(3174),
  [7045] = {.count = 1, .reusable = false}, SHIFT(3175),
  [7047] = {.count = 1, .reusable = true}, SHIFT(3175),
  [7049] = {.count = 1, .reusable = true}, SHIFT(3176),
  [7051] = {.count = 1, .reusable = false}, SHIFT(3177),
  [7053] = {.count = 1, .reusable = true}, SHIFT(3177),
  [7055] = {.count = 1, .reusable = true}, SHIFT(3178),
  [7057] = {.count = 1, .reusable = true}, SHIFT(3179),
  [7059] = {.count = 1, .reusable = true}, SHIFT(3180),
  [7061] = {.count = 1, .reusable = false}, SHIFT(3181),
  [7063] = {.count = 1, .reusable = true}, SHIFT(3181),
  [7065] = {.count = 1, .reusable = false}, SHIFT(3182),
  [7067] = {.count = 1, .reusable = true}, SHIFT(3182),
  [7069] = {.count = 1, .reusable = true}, SHIFT(3183),
  [7071] = {.count = 1, .reusable = false}, SHIFT(3184),
  [7073] = {.count = 1, .reusable = true}, SHIFT(3185),
  [7075] = {.count = 1, .reusable = true}, SHIFT(3186),
  [7077] = {.count = 1, .reusable = true}, SHIFT(3187),
  [7079] = {.count = 1, .reusable = false}, SHIFT(3188),
  [7081] = {.count = 1, .reusable = true}, SHIFT(3188),
  [7083] = {.count = 1, .reusable = false}, SHIFT(3189),
  [7085] = {.count = 1, .reusable = true}, SHIFT(3189),
  [7087] = {.count = 1, .reusable = true}, SHIFT(3190),
  [7089] = {.count = 1, .reusable = true}, SHIFT(3191),
  [7091] = {.count = 1, .reusable = true}, SHIFT(3192),
  [7093] = {.count = 1, .reusable = true}, SHIFT(3193),
  [7095] = {.count = 1, .reusable = false}, SHIFT(3194),
  [7097] = {.count = 1, .reusable = true}, SHIFT(3194),
  [7099] = {.count = 1, .reusable = false}, SHIFT(3195),
  [7101] = {.count = 1, .reusable = true}, SHIFT(3195),
  [7103] = {.count = 1, .reusable = true}, SHIFT(3196),
  [7105] = {.count = 1, .reusable = true}, SHIFT(3197),
  [7107] = {.count = 1, .reusable = true}, SHIFT(3198),
  [7109] = {.count = 1, .reusable = true}, SHIFT(3199),
  [7111] = {.count = 1, .reusable = false}, SHIFT(3200),
  [7113] = {.count = 1, .reusable = true}, SHIFT(3200),
  [7115] = {.count = 1, .reusable = false}, SHIFT(3201),
  [7117] = {.count = 1, .reusable = true}, SHIFT(3201),
  [7119] = {.count = 1, .reusable = true}, SHIFT(3202),
  [7121] = {.count = 1, .reusable = true}, SHIFT(3203),
  [7123] = {.count = 1, .reusable = true}, SHIFT(3204),
  [7125] = {.count = 1, .reusable = true}, SHIFT(3205),
  [7127] = {.count = 1, .reusable = false}, SHIFT(3206),
  [7129] = {.count = 1, .reusable = true}, SHIFT(3206),
  [7131] = {.count = 1, .reusable = false}, SHIFT(3207),
  [7133] = {.count = 1, .reusable = true}, SHIFT(3207),
  [7135] = {.count = 1, .reusable = true}, SHIFT(3208),
  [7137] = {.count = 1, .reusable = true}, SHIFT(3209),
  [7139] = {.count = 1, .reusable = true}, SHIFT(3210),
  [7141] = {.count = 1, .reusable = true}, SHIFT(3211),
  [7143] = {.count = 1, .reusable = false}, SHIFT(3212),
  [7145] = {.count = 1, .reusable = true}, SHIFT(3212),
  [7147] = {.count = 1, .reusable = false}, SHIFT(3213),
  [7149] = {.count = 1, .reusable = true}, SHIFT(3213),
  [7151] = {.count = 1, .reusable = true}, SHIFT(3214),
  [7153] = {.count = 1, .reusable = true}, SHIFT(3215),
  [7155] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 5),
  [7157] = {.count = 1, .reusable = true}, SHIFT(3216),
  [7159] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 5, .alias_sequence_id = 4),
  [7161] = {.count = 1, .reusable = false}, SHIFT(3217),
  [7163] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1931),
  [7166] = {.count = 1, .reusable = false}, SHIFT(3218),
  [7168] = {.count = 1, .reusable = true}, SHIFT(3219),
  [7170] = {.count = 1, .reusable = true}, SHIFT(3220),
  [7172] = {.count = 1, .reusable = true}, SHIFT(3223),
  [7174] = {.count = 1, .reusable = true}, SHIFT(3224),
  [7176] = {.count = 1, .reusable = false}, SHIFT(3226),
  [7178] = {.count = 1, .reusable = true}, SHIFT(3226),
  [7180] = {.count = 1, .reusable = true}, SHIFT(3225),
  [7182] = {.count = 1, .reusable = false}, SHIFT(3228),
  [7184] = {.count = 1, .reusable = true}, SHIFT(3228),
  [7186] = {.count = 1, .reusable = true}, SHIFT(3227),
  [7188] = {.count = 1, .reusable = true}, SHIFT(3229),
  [7190] = {.count = 1, .reusable = true}, SHIFT(3230),
  [7192] = {.count = 1, .reusable = false}, SHIFT(3231),
  [7194] = {.count = 1, .reusable = true}, SHIFT(3231),
  [7196] = {.count = 1, .reusable = true}, SHIFT(3232),
  [7198] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6),
  [7200] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6),
  [7202] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 7),
  [7204] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 7),
  [7206] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 5),
  [7208] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 5),
  [7210] = {.count = 1, .reusable = true}, SHIFT(3233),
  [7212] = {.count = 1, .reusable = true}, SHIFT(3234),
  [7214] = {.count = 1, .reusable = false}, SHIFT(1259),
  [7216] = {.count = 1, .reusable = true}, SHIFT(3235),
  [7218] = {.count = 1, .reusable = true}, SHIFT(3236),
  [7220] = {.count = 1, .reusable = true}, SHIFT(3237),
  [7222] = {.count = 1, .reusable = true}, SHIFT(3240),
  [7224] = {.count = 1, .reusable = true}, SHIFT(3241),
  [7226] = {.count = 1, .reusable = false}, SHIFT(3242),
  [7228] = {.count = 1, .reusable = true}, SHIFT(3242),
  [7230] = {.count = 1, .reusable = true}, SHIFT(3243),
  [7232] = {.count = 1, .reusable = false}, SHIFT(3244),
  [7234] = {.count = 1, .reusable = true}, SHIFT(3244),
  [7236] = {.count = 1, .reusable = true}, SHIFT(3245),
  [7238] = {.count = 1, .reusable = false}, SHIFT(3246),
  [7240] = {.count = 1, .reusable = true}, SHIFT(3246),
  [7242] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 3),
  [7244] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 3),
  [7246] = {.count = 1, .reusable = true}, SHIFT(3247),
  [7248] = {.count = 1, .reusable = true}, SHIFT(3248),
  [7250] = {.count = 1, .reusable = true}, SHIFT(3249),
  [7252] = {.count = 1, .reusable = true}, SHIFT(3252),
  [7254] = {.count = 1, .reusable = true}, SHIFT(3253),
  [7256] = {.count = 1, .reusable = false}, SHIFT(3254),
  [7258] = {.count = 1, .reusable = true}, SHIFT(3254),
  [7260] = {.count = 1, .reusable = true}, SHIFT(3255),
  [7262] = {.count = 1, .reusable = false}, SHIFT(3256),
  [7264] = {.count = 1, .reusable = true}, SHIFT(3256),
  [7266] = {.count = 1, .reusable = true}, SHIFT(3257),
  [7268] = {.count = 1, .reusable = false}, SHIFT(3258),
  [7270] = {.count = 1, .reusable = true}, SHIFT(3258),
  [7272] = {.count = 1, .reusable = false}, SHIFT(1351),
  [7274] = {.count = 1, .reusable = true}, SHIFT(3260),
  [7276] = {.count = 1, .reusable = true}, SHIFT(3261),
  [7278] = {.count = 1, .reusable = true}, SHIFT(3262),
  [7280] = {.count = 1, .reusable = true}, SHIFT(3265),
  [7282] = {.count = 1, .reusable = true}, SHIFT(3266),
  [7284] = {.count = 1, .reusable = false}, SHIFT(3267),
  [7286] = {.count = 1, .reusable = true}, SHIFT(3267),
  [7288] = {.count = 1, .reusable = true}, SHIFT(3268),
  [7290] = {.count = 1, .reusable = false}, SHIFT(3269),
  [7292] = {.count = 1, .reusable = true}, SHIFT(3269),
  [7294] = {.count = 1, .reusable = true}, SHIFT(3270),
  [7296] = {.count = 1, .reusable = false}, SHIFT(3271),
  [7298] = {.count = 1, .reusable = true}, SHIFT(3271),
  [7300] = {.count = 1, .reusable = true}, SHIFT(3272),
  [7302] = {.count = 1, .reusable = true}, SHIFT(3273),
  [7304] = {.count = 1, .reusable = true}, SHIFT(3274),
  [7306] = {.count = 1, .reusable = false}, SHIFT(3275),
  [7308] = {.count = 1, .reusable = true}, SHIFT(3275),
  [7310] = {.count = 1, .reusable = false}, SHIFT(3276),
  [7312] = {.count = 1, .reusable = true}, SHIFT(3276),
  [7314] = {.count = 1, .reusable = true}, SHIFT(3277),
  [7316] = {.count = 1, .reusable = true}, REDUCE(sym_c_style_for_statement, 7),
  [7318] = {.count = 1, .reusable = false}, REDUCE(sym_c_style_for_statement, 7),
  [7320] = {.count = 1, .reusable = true}, SHIFT(3279),
  [7322] = {.count = 1, .reusable = true}, SHIFT(3280),
  [7324] = {.count = 1, .reusable = true}, SHIFT(3281),
  [7326] = {.count = 1, .reusable = true}, SHIFT(3282),
  [7328] = {.count = 1, .reusable = false}, SHIFT(3283),
  [7330] = {.count = 1, .reusable = true}, SHIFT(3283),
  [7332] = {.count = 1, .reusable = false}, SHIFT(3284),
  [7334] = {.count = 1, .reusable = true}, SHIFT(3284),
  [7336] = {.count = 1, .reusable = true}, SHIFT(3285),
  [7338] = {.count = 1, .reusable = true}, SHIFT(3286),
  [7340] = {.count = 1, .reusable = false}, SHIFT(1412),
  [7342] = {.count = 1, .reusable = true}, SHIFT(3287),
  [7344] = {.count = 1, .reusable = true}, SHIFT(3288),
  [7346] = {.count = 1, .reusable = true}, SHIFT(3289),
  [7348] = {.count = 1, .reusable = true}, SHIFT(3292),
  [7350] = {.count = 1, .reusable = true}, SHIFT(3293),
  [7352] = {.count = 1, .reusable = false}, SHIFT(3294),
  [7354] = {.count = 1, .reusable = true}, SHIFT(3294),
  [7356] = {.count = 1, .reusable = true}, SHIFT(3295),
  [7358] = {.count = 1, .reusable = false}, SHIFT(3296),
  [7360] = {.count = 1, .reusable = true}, SHIFT(3296),
  [7362] = {.count = 1, .reusable = true}, SHIFT(3297),
  [7364] = {.count = 1, .reusable = false}, SHIFT(3298),
  [7366] = {.count = 1, .reusable = true}, SHIFT(3298),
  [7368] = {.count = 1, .reusable = true}, SHIFT(3299),
  [7370] = {.count = 1, .reusable = true}, SHIFT(3300),
  [7372] = {.count = 1, .reusable = true}, SHIFT(3301),
  [7374] = {.count = 1, .reusable = false}, SHIFT(3302),
  [7376] = {.count = 1, .reusable = true}, SHIFT(3302),
  [7378] = {.count = 1, .reusable = false}, SHIFT(3303),
  [7380] = {.count = 1, .reusable = true}, SHIFT(3303),
  [7382] = {.count = 1, .reusable = true}, SHIFT(3304),
  [7384] = {.count = 1, .reusable = true}, SHIFT(3305),
  [7386] = {.count = 1, .reusable = true}, SHIFT(3306),
  [7388] = {.count = 1, .reusable = false}, SHIFT(1470),
  [7390] = {.count = 1, .reusable = true}, SHIFT(3307),
  [7392] = {.count = 1, .reusable = true}, SHIFT(3308),
  [7394] = {.count = 1, .reusable = true}, SHIFT(3309),
  [7396] = {.count = 1, .reusable = true}, SHIFT(3312),
  [7398] = {.count = 1, .reusable = true}, SHIFT(3313),
  [7400] = {.count = 1, .reusable = false}, SHIFT(3314),
  [7402] = {.count = 1, .reusable = true}, SHIFT(3314),
  [7404] = {.count = 1, .reusable = true}, SHIFT(3315),
  [7406] = {.count = 1, .reusable = false}, SHIFT(3316),
  [7408] = {.count = 1, .reusable = true}, SHIFT(3316),
  [7410] = {.count = 1, .reusable = true}, SHIFT(3317),
  [7412] = {.count = 1, .reusable = false}, SHIFT(3318),
  [7414] = {.count = 1, .reusable = true}, SHIFT(3318),
  [7416] = {.count = 1, .reusable = true}, SHIFT(3320),
  [7418] = {.count = 1, .reusable = true}, SHIFT(3321),
  [7420] = {.count = 1, .reusable = true}, SHIFT(3323),
  [7422] = {.count = 1, .reusable = true}, SHIFT(3324),
  [7424] = {.count = 1, .reusable = true}, SHIFT(3326),
  [7426] = {.count = 1, .reusable = true}, SHIFT(3328),
  [7428] = {.count = 1, .reusable = true}, SHIFT(3329),
  [7430] = {.count = 1, .reusable = true}, SHIFT(3330),
  [7432] = {.count = 1, .reusable = false}, SHIFT(3331),
  [7434] = {.count = 1, .reusable = true}, SHIFT(3331),
  [7436] = {.count = 1, .reusable = false}, SHIFT(3332),
  [7438] = {.count = 1, .reusable = true}, SHIFT(3332),
  [7440] = {.count = 1, .reusable = true}, SHIFT(3333),
  [7442] = {.count = 1, .reusable = true}, SHIFT(3334),
  [7444] = {.count = 1, .reusable = true}, SHIFT(3335),
  [7446] = {.count = 1, .reusable = true}, SHIFT(3336),
  [7448] = {.count = 1, .reusable = false}, SHIFT(3337),
  [7450] = {.count = 1, .reusable = true}, SHIFT(3337),
  [7452] = {.count = 1, .reusable = false}, SHIFT(3338),
  [7454] = {.count = 1, .reusable = true}, SHIFT(3338),
  [7456] = {.count = 1, .reusable = true}, SHIFT(3339),
  [7458] = {.count = 1, .reusable = true}, SHIFT(3340),
  [7460] = {.count = 1, .reusable = true}, SHIFT(3341),
  [7462] = {.count = 1, .reusable = true}, SHIFT(3342),
  [7464] = {.count = 1, .reusable = true}, SHIFT(3343),
  [7466] = {.count = 1, .reusable = true}, SHIFT(3344),
  [7468] = {.count = 1, .reusable = false}, SHIFT(3346),
  [7470] = {.count = 1, .reusable = false}, SHIFT(3347),
  [7472] = {.count = 1, .reusable = true}, SHIFT(3348),
  [7474] = {.count = 1, .reusable = true}, SHIFT(3349),
  [7476] = {.count = 1, .reusable = true}, SHIFT(3350),
  [7478] = {.count = 1, .reusable = false}, SHIFT(3351),
  [7480] = {.count = 1, .reusable = true}, SHIFT(3351),
  [7482] = {.count = 1, .reusable = true}, SHIFT(3352),
  [7484] = {.count = 1, .reusable = false}, SHIFT(3354),
  [7486] = {.count = 1, .reusable = true}, SHIFT(3354),
  [7488] = {.count = 1, .reusable = true}, SHIFT(3353),
  [7490] = {.count = 1, .reusable = true}, SHIFT(3355),
  [7492] = {.count = 1, .reusable = false}, SHIFT(3357),
  [7494] = {.count = 1, .reusable = true}, SHIFT(3357),
  [7496] = {.count = 1, .reusable = true}, SHIFT(3356),
  [7498] = {.count = 1, .reusable = true}, SHIFT(3358),
  [7500] = {.count = 1, .reusable = true}, SHIFT(3359),
  [7502] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(2832),
  [7505] = {.count = 1, .reusable = true}, SHIFT(3360),
  [7507] = {.count = 1, .reusable = false}, SHIFT(3362),
  [7509] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2213),
  [7512] = {.count = 1, .reusable = false}, SHIFT(3363),
  [7514] = {.count = 1, .reusable = true}, SHIFT(3364),
  [7516] = {.count = 1, .reusable = true}, SHIFT(3365),
  [7518] = {.count = 1, .reusable = true}, SHIFT(3368),
  [7520] = {.count = 1, .reusable = true}, SHIFT(3369),
  [7522] = {.count = 1, .reusable = false}, SHIFT(3371),
  [7524] = {.count = 1, .reusable = true}, SHIFT(3371),
  [7526] = {.count = 1, .reusable = true}, SHIFT(3370),
  [7528] = {.count = 1, .reusable = false}, SHIFT(3373),
  [7530] = {.count = 1, .reusable = true}, SHIFT(3373),
  [7532] = {.count = 1, .reusable = true}, SHIFT(3372),
  [7534] = {.count = 1, .reusable = true}, SHIFT(3374),
  [7536] = {.count = 1, .reusable = true}, SHIFT(3375),
  [7538] = {.count = 1, .reusable = false}, SHIFT(3376),
  [7540] = {.count = 1, .reusable = true}, SHIFT(3376),
  [7542] = {.count = 1, .reusable = true}, SHIFT(3377),
  [7544] = {.count = 1, .reusable = false}, SHIFT(3378),
  [7546] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2232),
  [7549] = {.count = 1, .reusable = false}, SHIFT(3379),
  [7551] = {.count = 1, .reusable = true}, SHIFT(3380),
  [7553] = {.count = 1, .reusable = true}, SHIFT(3381),
  [7555] = {.count = 1, .reusable = true}, SHIFT(3384),
  [7557] = {.count = 1, .reusable = true}, SHIFT(3385),
  [7559] = {.count = 1, .reusable = false}, SHIFT(3387),
  [7561] = {.count = 1, .reusable = true}, SHIFT(3387),
  [7563] = {.count = 1, .reusable = true}, SHIFT(3386),
  [7565] = {.count = 1, .reusable = false}, SHIFT(3389),
  [7567] = {.count = 1, .reusable = true}, SHIFT(3389),
  [7569] = {.count = 1, .reusable = true}, SHIFT(3388),
  [7571] = {.count = 1, .reusable = true}, SHIFT(3390),
  [7573] = {.count = 1, .reusable = true}, SHIFT(3391),
  [7575] = {.count = 1, .reusable = false}, SHIFT(3392),
  [7577] = {.count = 1, .reusable = true}, SHIFT(3392),
  [7579] = {.count = 1, .reusable = true}, SHIFT(3393),
  [7581] = {.count = 1, .reusable = false}, SHIFT(1582),
  [7583] = {.count = 1, .reusable = true}, SHIFT(3394),
  [7585] = {.count = 1, .reusable = true}, SHIFT(3395),
  [7587] = {.count = 1, .reusable = true}, SHIFT(3396),
  [7589] = {.count = 1, .reusable = true}, SHIFT(3399),
  [7591] = {.count = 1, .reusable = true}, SHIFT(3400),
  [7593] = {.count = 1, .reusable = false}, SHIFT(3401),
  [7595] = {.count = 1, .reusable = true}, SHIFT(3401),
  [7597] = {.count = 1, .reusable = true}, SHIFT(3402),
  [7599] = {.count = 1, .reusable = false}, SHIFT(3403),
  [7601] = {.count = 1, .reusable = true}, SHIFT(3403),
  [7603] = {.count = 1, .reusable = true}, SHIFT(3404),
  [7605] = {.count = 1, .reusable = false}, SHIFT(3405),
  [7607] = {.count = 1, .reusable = true}, SHIFT(3405),
  [7609] = {.count = 1, .reusable = true}, SHIFT(3406),
  [7611] = {.count = 1, .reusable = true}, SHIFT(3407),
  [7613] = {.count = 1, .reusable = false}, SHIFT(3409),
  [7615] = {.count = 1, .reusable = false}, SHIFT(3410),
  [7617] = {.count = 1, .reusable = true}, SHIFT(3411),
  [7619] = {.count = 1, .reusable = true}, SHIFT(3412),
  [7621] = {.count = 1, .reusable = true}, SHIFT(3413),
  [7623] = {.count = 1, .reusable = false}, SHIFT(3414),
  [7625] = {.count = 1, .reusable = true}, SHIFT(3414),
  [7627] = {.count = 1, .reusable = true}, SHIFT(3415),
  [7629] = {.count = 1, .reusable = false}, SHIFT(3417),
  [7631] = {.count = 1, .reusable = true}, SHIFT(3417),
  [7633] = {.count = 1, .reusable = true}, SHIFT(3416),
  [7635] = {.count = 1, .reusable = true}, SHIFT(3418),
  [7637] = {.count = 1, .reusable = false}, SHIFT(3420),
  [7639] = {.count = 1, .reusable = true}, SHIFT(3420),
  [7641] = {.count = 1, .reusable = true}, SHIFT(3419),
  [7643] = {.count = 1, .reusable = true}, SHIFT(3421),
  [7645] = {.count = 1, .reusable = true}, SHIFT(3422),
  [7647] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(2906),
  [7650] = {.count = 1, .reusable = false}, REDUCE(sym__statements, 4),
  [7652] = {.count = 1, .reusable = true}, SHIFT(3423),
  [7654] = {.count = 1, .reusable = true}, SHIFT(3424),
  [7656] = {.count = 1, .reusable = true}, SHIFT(3425),
  [7658] = {.count = 1, .reusable = false}, SHIFT(3427),
  [7660] = {.count = 1, .reusable = false}, SHIFT(3428),
  [7662] = {.count = 1, .reusable = true}, SHIFT(3429),
  [7664] = {.count = 1, .reusable = true}, SHIFT(3430),
  [7666] = {.count = 1, .reusable = true}, SHIFT(3431),
  [7668] = {.count = 1, .reusable = false}, SHIFT(3432),
  [7670] = {.count = 1, .reusable = true}, SHIFT(3432),
  [7672] = {.count = 1, .reusable = true}, SHIFT(3433),
  [7674] = {.count = 1, .reusable = false}, SHIFT(3435),
  [7676] = {.count = 1, .reusable = true}, SHIFT(3435),
  [7678] = {.count = 1, .reusable = true}, SHIFT(3434),
  [7680] = {.count = 1, .reusable = true}, SHIFT(3436),
  [7682] = {.count = 1, .reusable = false}, SHIFT(3438),
  [7684] = {.count = 1, .reusable = true}, SHIFT(3438),
  [7686] = {.count = 1, .reusable = true}, SHIFT(3437),
  [7688] = {.count = 1, .reusable = true}, SHIFT(3439),
  [7690] = {.count = 1, .reusable = true}, SHIFT(3440),
  [7692] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(2928),
  [7695] = {.count = 1, .reusable = true}, REDUCE(sym_elif_clause, 4),
  [7697] = {.count = 1, .reusable = true}, SHIFT(3441),
  [7699] = {.count = 1, .reusable = true}, SHIFT(3443),
  [7701] = {.count = 1, .reusable = true}, SHIFT(3444),
  [7703] = {.count = 1, .reusable = false}, SHIFT(3445),
  [7705] = {.count = 1, .reusable = true}, SHIFT(3445),
  [7707] = {.count = 1, .reusable = true}, SHIFT(3446),
  [7709] = {.count = 1, .reusable = false}, SHIFT(3448),
  [7711] = {.count = 1, .reusable = false}, SHIFT(3449),
  [7713] = {.count = 1, .reusable = true}, SHIFT(3451),
  [7715] = {.count = 1, .reusable = true}, SHIFT(3452),
  [7717] = {.count = 1, .reusable = true}, SHIFT(3453),
  [7719] = {.count = 1, .reusable = false}, SHIFT(3454),
  [7721] = {.count = 1, .reusable = true}, SHIFT(3454),
  [7723] = {.count = 1, .reusable = true}, SHIFT(3459),
  [7725] = {.count = 1, .reusable = true}, SHIFT(3461),
  [7727] = {.count = 1, .reusable = true}, SHIFT(3462),
  [7729] = {.count = 1, .reusable = true}, SHIFT(3463),
  [7731] = {.count = 1, .reusable = true}, SHIFT(3465),
  [7733] = {.count = 1, .reusable = true}, SHIFT(3466),
  [7735] = {.count = 1, .reusable = false}, SHIFT(3468),
  [7737] = {.count = 1, .reusable = false}, SHIFT(3469),
  [7739] = {.count = 1, .reusable = true}, SHIFT(3470),
  [7741] = {.count = 1, .reusable = true}, SHIFT(3471),
  [7743] = {.count = 1, .reusable = true}, SHIFT(3472),
  [7745] = {.count = 1, .reusable = false}, SHIFT(3473),
  [7747] = {.count = 1, .reusable = true}, SHIFT(3473),
  [7749] = {.count = 1, .reusable = true}, SHIFT(3474),
  [7751] = {.count = 1, .reusable = false}, SHIFT(3476),
  [7753] = {.count = 1, .reusable = true}, SHIFT(3476),
  [7755] = {.count = 1, .reusable = true}, SHIFT(3475),
  [7757] = {.count = 1, .reusable = true}, SHIFT(3477),
  [7759] = {.count = 1, .reusable = false}, SHIFT(3479),
  [7761] = {.count = 1, .reusable = true}, SHIFT(3479),
  [7763] = {.count = 1, .reusable = true}, SHIFT(3478),
  [7765] = {.count = 1, .reusable = true}, SHIFT(3480),
  [7767] = {.count = 1, .reusable = true}, SHIFT(3481),
  [7769] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2305),
  [7772] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2306),
  [7775] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2307),
  [7778] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2308),
  [7781] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2309),
  [7784] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2310),
  [7787] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2311),
  [7790] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2312),
  [7793] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2313),
  [7796] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2959),
  [7799] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2309),
  [7802] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(2960),
  [7805] = {.count = 1, .reusable = true}, SHIFT(3482),
  [7807] = {.count = 1, .reusable = true}, SHIFT(3483),
  [7809] = {.count = 1, .reusable = false}, SHIFT(3485),
  [7811] = {.count = 1, .reusable = false}, SHIFT(3486),
  [7813] = {.count = 1, .reusable = true}, SHIFT(3487),
  [7815] = {.count = 1, .reusable = true}, SHIFT(3488),
  [7817] = {.count = 1, .reusable = true}, SHIFT(3489),
  [7819] = {.count = 1, .reusable = false}, SHIFT(3490),
  [7821] = {.count = 1, .reusable = true}, SHIFT(3490),
  [7823] = {.count = 1, .reusable = true}, SHIFT(3491),
  [7825] = {.count = 1, .reusable = false}, SHIFT(3493),
  [7827] = {.count = 1, .reusable = true}, SHIFT(3493),
  [7829] = {.count = 1, .reusable = true}, SHIFT(3492),
  [7831] = {.count = 1, .reusable = true}, SHIFT(3494),
  [7833] = {.count = 1, .reusable = false}, SHIFT(3496),
  [7835] = {.count = 1, .reusable = true}, SHIFT(3496),
  [7837] = {.count = 1, .reusable = true}, SHIFT(3495),
  [7839] = {.count = 1, .reusable = true}, SHIFT(3497),
  [7841] = {.count = 1, .reusable = true}, SHIFT(3498),
  [7843] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2317),
  [7846] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2318),
  [7849] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2319),
  [7852] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2320),
  [7855] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2321),
  [7858] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2322),
  [7861] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2323),
  [7864] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2324),
  [7867] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2978),
  [7870] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2320),
  [7873] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(2979),
  [7876] = {.count = 1, .reusable = false}, SHIFT(3499),
  [7878] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2330),
  [7881] = {.count = 1, .reusable = false}, SHIFT(3500),
  [7883] = {.count = 1, .reusable = true}, SHIFT(3501),
  [7885] = {.count = 1, .reusable = true}, SHIFT(3502),
  [7887] = {.count = 1, .reusable = true}, SHIFT(3505),
  [7889] = {.count = 1, .reusable = true}, SHIFT(3506),
  [7891] = {.count = 1, .reusable = false}, SHIFT(3508),
  [7893] = {.count = 1, .reusable = true}, SHIFT(3508),
  [7895] = {.count = 1, .reusable = true}, SHIFT(3507),
  [7897] = {.count = 1, .reusable = false}, SHIFT(3510),
  [7899] = {.count = 1, .reusable = true}, SHIFT(3510),
  [7901] = {.count = 1, .reusable = true}, SHIFT(3509),
  [7903] = {.count = 1, .reusable = true}, SHIFT(3511),
  [7905] = {.count = 1, .reusable = true}, SHIFT(3512),
  [7907] = {.count = 1, .reusable = false}, SHIFT(3513),
  [7909] = {.count = 1, .reusable = true}, SHIFT(3513),
  [7911] = {.count = 1, .reusable = true}, SHIFT(3514),
  [7913] = {.count = 1, .reusable = true}, SHIFT(3515),
  [7915] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(2343),
  [7918] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(2347),
  [7921] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(2347),
  [7924] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(2348),
  [7927] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2351),
  [7930] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1627),
  [7933] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1628),
  [7936] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1629),
  [7939] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2352),
  [7942] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1631),
  [7945] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1632),
  [7948] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1633),
  [7951] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1634),
  [7954] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2352),
  [7957] = {.count = 1, .reusable = false}, SHIFT(3519),
  [7959] = {.count = 1, .reusable = true}, SHIFT(3519),
  [7961] = {.count = 1, .reusable = true}, SHIFT(3520),
  [7963] = {.count = 1, .reusable = false}, SHIFT(3522),
  [7965] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2364),
  [7968] = {.count = 1, .reusable = false}, SHIFT(3523),
  [7970] = {.count = 1, .reusable = true}, SHIFT(3524),
  [7972] = {.count = 1, .reusable = true}, SHIFT(3525),
  [7974] = {.count = 1, .reusable = true}, SHIFT(3528),
  [7976] = {.count = 1, .reusable = true}, SHIFT(3529),
  [7978] = {.count = 1, .reusable = false}, SHIFT(3531),
  [7980] = {.count = 1, .reusable = true}, SHIFT(3531),
  [7982] = {.count = 1, .reusable = true}, SHIFT(3530),
  [7984] = {.count = 1, .reusable = false}, SHIFT(3533),
  [7986] = {.count = 1, .reusable = true}, SHIFT(3533),
  [7988] = {.count = 1, .reusable = true}, SHIFT(3532),
  [7990] = {.count = 1, .reusable = true}, SHIFT(3534),
  [7992] = {.count = 1, .reusable = true}, SHIFT(3535),
  [7994] = {.count = 1, .reusable = false}, SHIFT(3536),
  [7996] = {.count = 1, .reusable = true}, SHIFT(3536),
  [7998] = {.count = 1, .reusable = true}, SHIFT(3537),
  [8000] = {.count = 1, .reusable = false}, SHIFT(3538),
  [8002] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2383),
  [8005] = {.count = 1, .reusable = false}, SHIFT(3539),
  [8007] = {.count = 1, .reusable = true}, SHIFT(3540),
  [8009] = {.count = 1, .reusable = true}, SHIFT(3541),
  [8011] = {.count = 1, .reusable = true}, SHIFT(3544),
  [8013] = {.count = 1, .reusable = true}, SHIFT(3545),
  [8015] = {.count = 1, .reusable = false}, SHIFT(3547),
  [8017] = {.count = 1, .reusable = true}, SHIFT(3547),
  [8019] = {.count = 1, .reusable = true}, SHIFT(3546),
  [8021] = {.count = 1, .reusable = false}, SHIFT(3549),
  [8023] = {.count = 1, .reusable = true}, SHIFT(3549),
  [8025] = {.count = 1, .reusable = true}, SHIFT(3548),
  [8027] = {.count = 1, .reusable = true}, SHIFT(3550),
  [8029] = {.count = 1, .reusable = true}, SHIFT(3551),
  [8031] = {.count = 1, .reusable = false}, SHIFT(3552),
  [8033] = {.count = 1, .reusable = true}, SHIFT(3552),
  [8035] = {.count = 1, .reusable = true}, SHIFT(3553),
  [8037] = {.count = 1, .reusable = false}, SHIFT(1667),
  [8039] = {.count = 1, .reusable = true}, SHIFT(3554),
  [8041] = {.count = 1, .reusable = true}, SHIFT(3555),
  [8043] = {.count = 1, .reusable = true}, SHIFT(3556),
  [8045] = {.count = 1, .reusable = true}, SHIFT(3559),
  [8047] = {.count = 1, .reusable = true}, SHIFT(3560),
  [8049] = {.count = 1, .reusable = false}, SHIFT(3561),
  [8051] = {.count = 1, .reusable = true}, SHIFT(3561),
  [8053] = {.count = 1, .reusable = true}, SHIFT(3562),
  [8055] = {.count = 1, .reusable = false}, SHIFT(3563),
  [8057] = {.count = 1, .reusable = true}, SHIFT(3563),
  [8059] = {.count = 1, .reusable = true}, SHIFT(3564),
  [8061] = {.count = 1, .reusable = false}, SHIFT(3565),
  [8063] = {.count = 1, .reusable = true}, SHIFT(3565),
  [8065] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 7),
  [8067] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 7),
  [8069] = {.count = 1, .reusable = true}, SHIFT(3566),
  [8071] = {.count = 1, .reusable = false}, SHIFT(3568),
  [8073] = {.count = 1, .reusable = true}, REDUCE(aux_sym_case_item_repeat1, 2),
  [8075] = {.count = 1, .reusable = true}, REDUCE(aux_sym_case_item_repeat1, 2, .alias_sequence_id = 2),
  [8077] = {.count = 1, .reusable = true}, SHIFT(3569),
  [8079] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 3),
  [8081] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 3),
  [8083] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 3),
  [8085] = {.count = 1, .reusable = true}, SHIFT(3570),
  [8087] = {.count = 1, .reusable = false}, SHIFT(3571),
  [8089] = {.count = 1, .reusable = true}, SHIFT(3572),
  [8091] = {.count = 1, .reusable = true}, SHIFT(3573),
  [8093] = {.count = 1, .reusable = true}, SHIFT(3574),
  [8095] = {.count = 1, .reusable = true}, SHIFT(3575),
  [8097] = {.count = 1, .reusable = true}, SHIFT(3576),
  [8099] = {.count = 1, .reusable = true}, SHIFT(3577),
  [8101] = {.count = 1, .reusable = true}, SHIFT(3578),
  [8103] = {.count = 1, .reusable = false}, SHIFT(3580),
  [8105] = {.count = 1, .reusable = false}, SHIFT(3574),
  [8107] = {.count = 1, .reusable = false}, SHIFT(3582),
  [8109] = {.count = 1, .reusable = true}, SHIFT(3583),
  [8111] = {.count = 1, .reusable = true}, SHIFT(3584),
  [8113] = {.count = 1, .reusable = true}, SHIFT(3585),
  [8115] = {.count = 1, .reusable = true}, SHIFT(3586),
  [8117] = {.count = 1, .reusable = true}, SHIFT(3587),
  [8119] = {.count = 1, .reusable = true}, SHIFT(3588),
  [8121] = {.count = 1, .reusable = true}, SHIFT(3589),
  [8123] = {.count = 1, .reusable = false}, SHIFT(3590),
  [8125] = {.count = 1, .reusable = false}, SHIFT(3585),
  [8127] = {.count = 1, .reusable = true}, SHIFT(3592),
  [8129] = {.count = 1, .reusable = true}, SHIFT(3593),
  [8131] = {.count = 1, .reusable = false}, SHIFT(3594),
  [8133] = {.count = 1, .reusable = true}, SHIFT(3594),
  [8135] = {.count = 1, .reusable = true}, SHIFT(3595),
  [8137] = {.count = 1, .reusable = false}, SHIFT(3597),
  [8139] = {.count = 1, .reusable = false}, SHIFT(3598),
  [8141] = {.count = 1, .reusable = true}, SHIFT(3600),
  [8143] = {.count = 1, .reusable = true}, SHIFT(3601),
  [8145] = {.count = 1, .reusable = true}, SHIFT(3602),
  [8147] = {.count = 1, .reusable = false}, SHIFT(3603),
  [8149] = {.count = 1, .reusable = true}, SHIFT(3603),
  [8151] = {.count = 1, .reusable = true}, REDUCE(sym_last_case_item, 3),
  [8153] = {.count = 1, .reusable = true}, SHIFT(3608),
  [8155] = {.count = 1, .reusable = true}, SHIFT(3609),
  [8157] = {.count = 1, .reusable = false}, SHIFT(3610),
  [8159] = {.count = 1, .reusable = false}, SHIFT(3611),
  [8161] = {.count = 1, .reusable = true}, SHIFT(3611),
  [8163] = {.count = 1, .reusable = true}, SHIFT(3612),
  [8165] = {.count = 1, .reusable = false}, SHIFT(3613),
  [8167] = {.count = 1, .reusable = true}, SHIFT(3613),
  [8169] = {.count = 1, .reusable = true}, SHIFT(3614),
  [8171] = {.count = 1, .reusable = true}, SHIFT(3610),
  [8173] = {.count = 1, .reusable = false}, SHIFT(3617),
  [8175] = {.count = 1, .reusable = true}, SHIFT(3088),
  [8177] = {.count = 1, .reusable = true}, SHIFT(3618),
  [8179] = {.count = 1, .reusable = false}, SHIFT(3618),
  [8181] = {.count = 1, .reusable = true}, SHIFT(3624),
  [8183] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_item_repeat1, 2), SHIFT_REPEAT(2438),
  [8186] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 7),
  [8188] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 7),
  [8190] = {.count = 1, .reusable = true}, SHIFT(3627),
  [8192] = {.count = 1, .reusable = true}, SHIFT(3629),
  [8194] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 3, .alias_sequence_id = 1),
  [8196] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 3, .alias_sequence_id = 1),
  [8198] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 3, .alias_sequence_id = 1),
  [8200] = {.count = 1, .reusable = true}, REDUCE(sym_last_case_item, 3, .alias_sequence_id = 1),
  [8202] = {.count = 1, .reusable = true}, SHIFT(3631),
  [8204] = {.count = 1, .reusable = true}, SHIFT(3633),
  [8206] = {.count = 1, .reusable = true}, SHIFT(3634),
  [8208] = {.count = 1, .reusable = true}, SHIFT(3635),
  [8210] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 7, .alias_sequence_id = 2),
  [8212] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 7, .alias_sequence_id = 2),
  [8214] = {.count = 1, .reusable = true}, SHIFT(3636),
  [8216] = {.count = 1, .reusable = false}, SHIFT(1745),
  [8218] = {.count = 1, .reusable = true}, SHIFT(3637),
  [8220] = {.count = 1, .reusable = true}, SHIFT(3638),
  [8222] = {.count = 1, .reusable = true}, SHIFT(3639),
  [8224] = {.count = 1, .reusable = true}, SHIFT(3642),
  [8226] = {.count = 1, .reusable = true}, SHIFT(3643),
  [8228] = {.count = 1, .reusable = false}, SHIFT(3644),
  [8230] = {.count = 1, .reusable = true}, SHIFT(3644),
  [8232] = {.count = 1, .reusable = true}, SHIFT(3645),
  [8234] = {.count = 1, .reusable = false}, SHIFT(3646),
  [8236] = {.count = 1, .reusable = true}, SHIFT(3646),
  [8238] = {.count = 1, .reusable = true}, SHIFT(3647),
  [8240] = {.count = 1, .reusable = false}, SHIFT(3648),
  [8242] = {.count = 1, .reusable = true}, SHIFT(3648),
  [8244] = {.count = 1, .reusable = true}, SHIFT(3650),
  [8246] = {.count = 1, .reusable = true}, SHIFT(3651),
  [8248] = {.count = 1, .reusable = true}, SHIFT(3653),
  [8250] = {.count = 1, .reusable = true}, SHIFT(3654),
  [8252] = {.count = 1, .reusable = true}, SHIFT(3656),
  [8254] = {.count = 1, .reusable = true}, SHIFT(3658),
  [8256] = {.count = 1, .reusable = true}, SHIFT(3659),
  [8258] = {.count = 1, .reusable = true}, SHIFT(3660),
  [8260] = {.count = 1, .reusable = false}, SHIFT(3661),
  [8262] = {.count = 1, .reusable = true}, SHIFT(3661),
  [8264] = {.count = 1, .reusable = false}, SHIFT(3662),
  [8266] = {.count = 1, .reusable = true}, SHIFT(3662),
  [8268] = {.count = 1, .reusable = true}, SHIFT(3663),
  [8270] = {.count = 1, .reusable = true}, SHIFT(3664),
  [8272] = {.count = 1, .reusable = true}, SHIFT(3665),
  [8274] = {.count = 1, .reusable = true}, SHIFT(3666),
  [8276] = {.count = 1, .reusable = false}, SHIFT(3667),
  [8278] = {.count = 1, .reusable = true}, SHIFT(3667),
  [8280] = {.count = 1, .reusable = false}, SHIFT(3668),
  [8282] = {.count = 1, .reusable = true}, SHIFT(3668),
  [8284] = {.count = 1, .reusable = true}, SHIFT(3669),
  [8286] = {.count = 1, .reusable = true}, SHIFT(3670),
  [8288] = {.count = 1, .reusable = true}, SHIFT(3671),
  [8290] = {.count = 1, .reusable = true}, SHIFT(3672),
  [8292] = {.count = 1, .reusable = true}, SHIFT(3673),
  [8294] = {.count = 1, .reusable = true}, SHIFT(3674),
  [8296] = {.count = 1, .reusable = true}, SHIFT(3675),
  [8298] = {.count = 1, .reusable = true}, SHIFT(3676),
  [8300] = {.count = 1, .reusable = true}, SHIFT(3677),
  [8302] = {.count = 1, .reusable = true}, SHIFT(3678),
  [8304] = {.count = 1, .reusable = true}, SHIFT(3679),
  [8306] = {.count = 1, .reusable = true}, SHIFT(3680),
  [8308] = {.count = 1, .reusable = true}, SHIFT(3681),
  [8310] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 6),
  [8312] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 6, .alias_sequence_id = 4),
  [8314] = {.count = 1, .reusable = true}, SHIFT(3682),
  [8316] = {.count = 1, .reusable = true}, SHIFT(3683),
  [8318] = {.count = 1, .reusable = true}, SHIFT(3684),
  [8320] = {.count = 1, .reusable = true}, SHIFT(3687),
  [8322] = {.count = 1, .reusable = true}, SHIFT(3688),
  [8324] = {.count = 1, .reusable = false}, SHIFT(3689),
  [8326] = {.count = 1, .reusable = true}, SHIFT(3689),
  [8328] = {.count = 1, .reusable = true}, SHIFT(3690),
  [8330] = {.count = 1, .reusable = false}, SHIFT(3691),
  [8332] = {.count = 1, .reusable = true}, SHIFT(3691),
  [8334] = {.count = 1, .reusable = true}, SHIFT(3692),
  [8336] = {.count = 1, .reusable = false}, SHIFT(3693),
  [8338] = {.count = 1, .reusable = true}, SHIFT(3693),
  [8340] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 7, .alias_sequence_id = 5),
  [8342] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 7, .alias_sequence_id = 5),
  [8344] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 7),
  [8346] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 7),
  [8348] = {.count = 1, .reusable = true}, SHIFT(3694),
  [8350] = {.count = 1, .reusable = true}, SHIFT(3695),
  [8352] = {.count = 1, .reusable = true}, SHIFT(3696),
  [8354] = {.count = 1, .reusable = false}, SHIFT(3697),
  [8356] = {.count = 1, .reusable = true}, SHIFT(3697),
  [8358] = {.count = 1, .reusable = false}, SHIFT(3698),
  [8360] = {.count = 1, .reusable = true}, SHIFT(3698),
  [8362] = {.count = 1, .reusable = true}, SHIFT(3699),
  [8364] = {.count = 1, .reusable = true}, SHIFT(3700),
  [8366] = {.count = 1, .reusable = true}, SHIFT(3701),
  [8368] = {.count = 1, .reusable = true}, SHIFT(3702),
  [8370] = {.count = 1, .reusable = false}, SHIFT(3703),
  [8372] = {.count = 1, .reusable = true}, SHIFT(3703),
  [8374] = {.count = 1, .reusable = false}, SHIFT(3704),
  [8376] = {.count = 1, .reusable = true}, SHIFT(3704),
  [8378] = {.count = 1, .reusable = true}, SHIFT(3705),
  [8380] = {.count = 1, .reusable = true}, SHIFT(3706),
  [8382] = {.count = 1, .reusable = true}, SHIFT(3707),
  [8384] = {.count = 1, .reusable = true}, SHIFT(3708),
  [8386] = {.count = 1, .reusable = false}, SHIFT(3709),
  [8388] = {.count = 1, .reusable = true}, SHIFT(3709),
  [8390] = {.count = 1, .reusable = false}, SHIFT(3710),
  [8392] = {.count = 1, .reusable = true}, SHIFT(3710),
  [8394] = {.count = 1, .reusable = true}, SHIFT(3711),
  [8396] = {.count = 1, .reusable = true}, SHIFT(3712),
  [8398] = {.count = 1, .reusable = true}, SHIFT(3713),
  [8400] = {.count = 1, .reusable = true}, REDUCE(sym_c_style_for_statement, 8),
  [8402] = {.count = 1, .reusable = false}, REDUCE(sym_c_style_for_statement, 8),
  [8404] = {.count = 1, .reusable = true}, SHIFT(3715),
  [8406] = {.count = 1, .reusable = true}, SHIFT(3716),
  [8408] = {.count = 1, .reusable = true}, SHIFT(3717),
  [8410] = {.count = 1, .reusable = true}, SHIFT(3718),
  [8412] = {.count = 1, .reusable = true}, SHIFT(3719),
  [8414] = {.count = 1, .reusable = true}, SHIFT(3720),
  [8416] = {.count = 1, .reusable = false}, SHIFT(3721),
  [8418] = {.count = 1, .reusable = true}, SHIFT(3721),
  [8420] = {.count = 1, .reusable = false}, SHIFT(3722),
  [8422] = {.count = 1, .reusable = true}, SHIFT(3722),
  [8424] = {.count = 1, .reusable = true}, SHIFT(3723),
  [8426] = {.count = 1, .reusable = true}, SHIFT(3724),
  [8428] = {.count = 1, .reusable = true}, SHIFT(3725),
  [8430] = {.count = 1, .reusable = true}, SHIFT(3726),
  [8432] = {.count = 1, .reusable = true}, SHIFT(3727),
  [8434] = {.count = 1, .reusable = true}, SHIFT(3728),
  [8436] = {.count = 1, .reusable = false}, SHIFT(3729),
  [8438] = {.count = 1, .reusable = true}, SHIFT(3729),
  [8440] = {.count = 1, .reusable = false}, SHIFT(3730),
  [8442] = {.count = 1, .reusable = true}, SHIFT(3730),
  [8444] = {.count = 1, .reusable = true}, SHIFT(3731),
  [8446] = {.count = 1, .reusable = true}, SHIFT(3733),
  [8448] = {.count = 1, .reusable = true}, SHIFT(3734),
  [8450] = {.count = 1, .reusable = true}, SHIFT(3735),
  [8452] = {.count = 1, .reusable = true}, SHIFT(3736),
  [8454] = {.count = 1, .reusable = true}, SHIFT(3737),
  [8456] = {.count = 1, .reusable = true}, SHIFT(3738),
  [8458] = {.count = 1, .reusable = true}, SHIFT(3739),
  [8460] = {.count = 1, .reusable = true}, SHIFT(3740),
  [8462] = {.count = 1, .reusable = false}, SHIFT(3741),
  [8464] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2819),
  [8467] = {.count = 1, .reusable = false}, SHIFT(3742),
  [8469] = {.count = 1, .reusable = true}, SHIFT(3743),
  [8471] = {.count = 1, .reusable = true}, SHIFT(3744),
  [8473] = {.count = 1, .reusable = true}, SHIFT(3747),
  [8475] = {.count = 1, .reusable = true}, SHIFT(3748),
  [8477] = {.count = 1, .reusable = false}, SHIFT(3750),
  [8479] = {.count = 1, .reusable = true}, SHIFT(3750),
  [8481] = {.count = 1, .reusable = true}, SHIFT(3749),
  [8483] = {.count = 1, .reusable = false}, SHIFT(3752),
  [8485] = {.count = 1, .reusable = true}, SHIFT(3752),
  [8487] = {.count = 1, .reusable = true}, SHIFT(3751),
  [8489] = {.count = 1, .reusable = true}, SHIFT(3753),
  [8491] = {.count = 1, .reusable = true}, SHIFT(3754),
  [8493] = {.count = 1, .reusable = false}, SHIFT(3755),
  [8495] = {.count = 1, .reusable = true}, SHIFT(3755),
  [8497] = {.count = 1, .reusable = true}, SHIFT(3756),
  [8499] = {.count = 1, .reusable = true}, SHIFT(3757),
  [8501] = {.count = 1, .reusable = false}, SHIFT(2210),
  [8503] = {.count = 1, .reusable = true}, SHIFT(3758),
  [8505] = {.count = 1, .reusable = true}, SHIFT(3759),
  [8507] = {.count = 1, .reusable = true}, SHIFT(3760),
  [8509] = {.count = 1, .reusable = true}, SHIFT(3763),
  [8511] = {.count = 1, .reusable = true}, SHIFT(3764),
  [8513] = {.count = 1, .reusable = false}, SHIFT(3765),
  [8515] = {.count = 1, .reusable = true}, SHIFT(3765),
  [8517] = {.count = 1, .reusable = true}, SHIFT(3766),
  [8519] = {.count = 1, .reusable = false}, SHIFT(3767),
  [8521] = {.count = 1, .reusable = true}, SHIFT(3767),
  [8523] = {.count = 1, .reusable = true}, SHIFT(3768),
  [8525] = {.count = 1, .reusable = false}, SHIFT(3769),
  [8527] = {.count = 1, .reusable = true}, SHIFT(3769),
  [8529] = {.count = 1, .reusable = false}, SHIFT(2229),
  [8531] = {.count = 1, .reusable = true}, SHIFT(3770),
  [8533] = {.count = 1, .reusable = true}, SHIFT(3771),
  [8535] = {.count = 1, .reusable = true}, SHIFT(3772),
  [8537] = {.count = 1, .reusable = true}, SHIFT(3775),
  [8539] = {.count = 1, .reusable = true}, SHIFT(3776),
  [8541] = {.count = 1, .reusable = false}, SHIFT(3777),
  [8543] = {.count = 1, .reusable = true}, SHIFT(3777),
  [8545] = {.count = 1, .reusable = true}, SHIFT(3778),
  [8547] = {.count = 1, .reusable = false}, SHIFT(3779),
  [8549] = {.count = 1, .reusable = true}, SHIFT(3779),
  [8551] = {.count = 1, .reusable = true}, SHIFT(3780),
  [8553] = {.count = 1, .reusable = false}, SHIFT(3781),
  [8555] = {.count = 1, .reusable = true}, SHIFT(3781),
  [8557] = {.count = 1, .reusable = true}, SHIFT(3782),
  [8559] = {.count = 1, .reusable = true}, SHIFT(3783),
  [8561] = {.count = 1, .reusable = true}, SHIFT(3784),
  [8563] = {.count = 1, .reusable = false}, SHIFT(3785),
  [8565] = {.count = 1, .reusable = true}, SHIFT(3785),
  [8567] = {.count = 1, .reusable = false}, SHIFT(3786),
  [8569] = {.count = 1, .reusable = true}, SHIFT(3786),
  [8571] = {.count = 1, .reusable = true}, SHIFT(3787),
  [8573] = {.count = 1, .reusable = false}, SHIFT(3788),
  [8575] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2893),
  [8578] = {.count = 1, .reusable = false}, SHIFT(3789),
  [8580] = {.count = 1, .reusable = true}, SHIFT(3790),
  [8582] = {.count = 1, .reusable = true}, SHIFT(3791),
  [8584] = {.count = 1, .reusable = true}, SHIFT(3794),
  [8586] = {.count = 1, .reusable = true}, SHIFT(3795),
  [8588] = {.count = 1, .reusable = false}, SHIFT(3797),
  [8590] = {.count = 1, .reusable = true}, SHIFT(3797),
  [8592] = {.count = 1, .reusable = true}, SHIFT(3796),
  [8594] = {.count = 1, .reusable = false}, SHIFT(3799),
  [8596] = {.count = 1, .reusable = true}, SHIFT(3799),
  [8598] = {.count = 1, .reusable = true}, SHIFT(3798),
  [8600] = {.count = 1, .reusable = true}, SHIFT(3800),
  [8602] = {.count = 1, .reusable = true}, SHIFT(3801),
  [8604] = {.count = 1, .reusable = false}, SHIFT(3802),
  [8606] = {.count = 1, .reusable = true}, SHIFT(3802),
  [8608] = {.count = 1, .reusable = true}, SHIFT(3803),
  [8610] = {.count = 1, .reusable = false}, SHIFT(3804),
  [8612] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2915),
  [8615] = {.count = 1, .reusable = false}, SHIFT(3805),
  [8617] = {.count = 1, .reusable = true}, SHIFT(3806),
  [8619] = {.count = 1, .reusable = true}, SHIFT(3807),
  [8621] = {.count = 1, .reusable = true}, SHIFT(3810),
  [8623] = {.count = 1, .reusable = true}, SHIFT(3811),
  [8625] = {.count = 1, .reusable = false}, SHIFT(3813),
  [8627] = {.count = 1, .reusable = true}, SHIFT(3813),
  [8629] = {.count = 1, .reusable = true}, SHIFT(3812),
  [8631] = {.count = 1, .reusable = false}, SHIFT(3815),
  [8633] = {.count = 1, .reusable = true}, SHIFT(3815),
  [8635] = {.count = 1, .reusable = true}, SHIFT(3814),
  [8637] = {.count = 1, .reusable = true}, SHIFT(3816),
  [8639] = {.count = 1, .reusable = true}, SHIFT(3817),
  [8641] = {.count = 1, .reusable = false}, SHIFT(3818),
  [8643] = {.count = 1, .reusable = true}, SHIFT(3818),
  [8645] = {.count = 1, .reusable = true}, SHIFT(3819),
  [8647] = {.count = 1, .reusable = true}, SHIFT(3820),
  [8649] = {.count = 1, .reusable = true}, SHIFT(3821),
  [8651] = {.count = 1, .reusable = true}, SHIFT(3822),
  [8653] = {.count = 1, .reusable = false}, SHIFT(3824),
  [8655] = {.count = 1, .reusable = false}, SHIFT(3825),
  [8657] = {.count = 1, .reusable = true}, SHIFT(3826),
  [8659] = {.count = 1, .reusable = true}, SHIFT(3827),
  [8661] = {.count = 1, .reusable = true}, SHIFT(3828),
  [8663] = {.count = 1, .reusable = false}, SHIFT(3829),
  [8665] = {.count = 1, .reusable = true}, SHIFT(3829),
  [8667] = {.count = 1, .reusable = true}, SHIFT(3830),
  [8669] = {.count = 1, .reusable = false}, SHIFT(3832),
  [8671] = {.count = 1, .reusable = true}, SHIFT(3832),
  [8673] = {.count = 1, .reusable = true}, SHIFT(3831),
  [8675] = {.count = 1, .reusable = true}, SHIFT(3833),
  [8677] = {.count = 1, .reusable = false}, SHIFT(3835),
  [8679] = {.count = 1, .reusable = true}, SHIFT(3835),
  [8681] = {.count = 1, .reusable = true}, SHIFT(3834),
  [8683] = {.count = 1, .reusable = true}, SHIFT(3836),
  [8685] = {.count = 1, .reusable = true}, SHIFT(3837),
  [8687] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(3459),
  [8690] = {.count = 1, .reusable = true}, SHIFT(3838),
  [8692] = {.count = 1, .reusable = false}, SHIFT(3840),
  [8694] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2946),
  [8697] = {.count = 1, .reusable = false}, SHIFT(3841),
  [8699] = {.count = 1, .reusable = true}, SHIFT(3842),
  [8701] = {.count = 1, .reusable = true}, SHIFT(3843),
  [8703] = {.count = 1, .reusable = true}, SHIFT(3846),
  [8705] = {.count = 1, .reusable = true}, SHIFT(3847),
  [8707] = {.count = 1, .reusable = false}, SHIFT(3849),
  [8709] = {.count = 1, .reusable = true}, SHIFT(3849),
  [8711] = {.count = 1, .reusable = true}, SHIFT(3848),
  [8713] = {.count = 1, .reusable = false}, SHIFT(3851),
  [8715] = {.count = 1, .reusable = true}, SHIFT(3851),
  [8717] = {.count = 1, .reusable = true}, SHIFT(3850),
  [8719] = {.count = 1, .reusable = true}, SHIFT(3852),
  [8721] = {.count = 1, .reusable = true}, SHIFT(3853),
  [8723] = {.count = 1, .reusable = false}, SHIFT(3854),
  [8725] = {.count = 1, .reusable = true}, SHIFT(3854),
  [8727] = {.count = 1, .reusable = true}, SHIFT(3855),
  [8729] = {.count = 1, .reusable = false}, SHIFT(3856),
  [8731] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2965),
  [8734] = {.count = 1, .reusable = false}, SHIFT(3857),
  [8736] = {.count = 1, .reusable = true}, SHIFT(3858),
  [8738] = {.count = 1, .reusable = true}, SHIFT(3859),
  [8740] = {.count = 1, .reusable = true}, SHIFT(3862),
  [8742] = {.count = 1, .reusable = true}, SHIFT(3863),
  [8744] = {.count = 1, .reusable = false}, SHIFT(3865),
  [8746] = {.count = 1, .reusable = true}, SHIFT(3865),
  [8748] = {.count = 1, .reusable = true}, SHIFT(3864),
  [8750] = {.count = 1, .reusable = false}, SHIFT(3867),
  [8752] = {.count = 1, .reusable = true}, SHIFT(3867),
  [8754] = {.count = 1, .reusable = true}, SHIFT(3866),
  [8756] = {.count = 1, .reusable = true}, SHIFT(3868),
  [8758] = {.count = 1, .reusable = true}, SHIFT(3869),
  [8760] = {.count = 1, .reusable = false}, SHIFT(3870),
  [8762] = {.count = 1, .reusable = true}, SHIFT(3870),
  [8764] = {.count = 1, .reusable = true}, SHIFT(3871),
  [8766] = {.count = 1, .reusable = false}, SHIFT(2327),
  [8768] = {.count = 1, .reusable = true}, SHIFT(3872),
  [8770] = {.count = 1, .reusable = true}, SHIFT(3873),
  [8772] = {.count = 1, .reusable = true}, SHIFT(3874),
  [8774] = {.count = 1, .reusable = true}, SHIFT(3877),
  [8776] = {.count = 1, .reusable = true}, SHIFT(3878),
  [8778] = {.count = 1, .reusable = false}, SHIFT(3879),
  [8780] = {.count = 1, .reusable = true}, SHIFT(3879),
  [8782] = {.count = 1, .reusable = true}, SHIFT(3880),
  [8784] = {.count = 1, .reusable = false}, SHIFT(3881),
  [8786] = {.count = 1, .reusable = true}, SHIFT(3881),
  [8788] = {.count = 1, .reusable = true}, SHIFT(3882),
  [8790] = {.count = 1, .reusable = false}, SHIFT(3883),
  [8792] = {.count = 1, .reusable = true}, SHIFT(3883),
  [8794] = {.count = 1, .reusable = true}, SHIFT(3884),
  [8796] = {.count = 1, .reusable = true}, SHIFT(3886),
  [8798] = {.count = 1, .reusable = false}, SHIFT(2361),
  [8800] = {.count = 1, .reusable = true}, SHIFT(3887),
  [8802] = {.count = 1, .reusable = true}, SHIFT(3888),
  [8804] = {.count = 1, .reusable = true}, SHIFT(3889),
  [8806] = {.count = 1, .reusable = true}, SHIFT(3892),
  [8808] = {.count = 1, .reusable = true}, SHIFT(3893),
  [8810] = {.count = 1, .reusable = false}, SHIFT(3894),
  [8812] = {.count = 1, .reusable = true}, SHIFT(3894),
  [8814] = {.count = 1, .reusable = true}, SHIFT(3895),
  [8816] = {.count = 1, .reusable = false}, SHIFT(3896),
  [8818] = {.count = 1, .reusable = true}, SHIFT(3896),
  [8820] = {.count = 1, .reusable = true}, SHIFT(3897),
  [8822] = {.count = 1, .reusable = false}, SHIFT(3898),
  [8824] = {.count = 1, .reusable = true}, SHIFT(3898),
  [8826] = {.count = 1, .reusable = false}, SHIFT(2380),
  [8828] = {.count = 1, .reusable = true}, SHIFT(3899),
  [8830] = {.count = 1, .reusable = true}, SHIFT(3900),
  [8832] = {.count = 1, .reusable = true}, SHIFT(3901),
  [8834] = {.count = 1, .reusable = true}, SHIFT(3904),
  [8836] = {.count = 1, .reusable = true}, SHIFT(3905),
  [8838] = {.count = 1, .reusable = false}, SHIFT(3906),
  [8840] = {.count = 1, .reusable = true}, SHIFT(3906),
  [8842] = {.count = 1, .reusable = true}, SHIFT(3907),
  [8844] = {.count = 1, .reusable = false}, SHIFT(3908),
  [8846] = {.count = 1, .reusable = true}, SHIFT(3908),
  [8848] = {.count = 1, .reusable = true}, SHIFT(3909),
  [8850] = {.count = 1, .reusable = false}, SHIFT(3910),
  [8852] = {.count = 1, .reusable = true}, SHIFT(3910),
  [8854] = {.count = 1, .reusable = true}, SHIFT(3911),
  [8856] = {.count = 1, .reusable = true}, SHIFT(3912),
  [8858] = {.count = 1, .reusable = true}, SHIFT(3913),
  [8860] = {.count = 1, .reusable = false}, SHIFT(3914),
  [8862] = {.count = 1, .reusable = true}, SHIFT(3914),
  [8864] = {.count = 1, .reusable = false}, SHIFT(3915),
  [8866] = {.count = 1, .reusable = true}, SHIFT(3915),
  [8868] = {.count = 1, .reusable = true}, SHIFT(3916),
  [8870] = {.count = 1, .reusable = false}, SHIFT(3917),
  [8872] = {.count = 1, .reusable = true}, SHIFT(3918),
  [8874] = {.count = 1, .reusable = true}, SHIFT(3919),
  [8876] = {.count = 1, .reusable = false}, SHIFT(3920),
  [8878] = {.count = 1, .reusable = true}, SHIFT(3921),
  [8880] = {.count = 1, .reusable = true}, SHIFT(3922),
  [8882] = {.count = 1, .reusable = true}, SHIFT(3923),
  [8884] = {.count = 1, .reusable = true}, SHIFT(3924),
  [8886] = {.count = 1, .reusable = true}, SHIFT(3925),
  [8888] = {.count = 1, .reusable = true}, SHIFT(3926),
  [8890] = {.count = 1, .reusable = true}, SHIFT(3927),
  [8892] = {.count = 1, .reusable = true}, SHIFT(3929),
  [8894] = {.count = 1, .reusable = true}, SHIFT(3930),
  [8896] = {.count = 1, .reusable = true}, SHIFT(3931),
  [8898] = {.count = 1, .reusable = false}, SHIFT(3932),
  [8900] = {.count = 1, .reusable = true}, SHIFT(3932),
  [8902] = {.count = 1, .reusable = true}, SHIFT(3933),
  [8904] = {.count = 1, .reusable = false}, SHIFT(3935),
  [8906] = {.count = 1, .reusable = false}, SHIFT(3936),
  [8908] = {.count = 1, .reusable = true}, SHIFT(3938),
  [8910] = {.count = 1, .reusable = true}, SHIFT(3939),
  [8912] = {.count = 1, .reusable = true}, SHIFT(3940),
  [8914] = {.count = 1, .reusable = false}, SHIFT(3941),
  [8916] = {.count = 1, .reusable = true}, SHIFT(3941),
  [8918] = {.count = 1, .reusable = false}, SHIFT(3946),
  [8920] = {.count = 1, .reusable = true}, SHIFT(3947),
  [8922] = {.count = 1, .reusable = true}, SHIFT(3949),
  [8924] = {.count = 1, .reusable = true}, SHIFT(3950),
  [8926] = {.count = 1, .reusable = false}, SHIFT(3951),
  [8928] = {.count = 1, .reusable = true}, SHIFT(3951),
  [8930] = {.count = 1, .reusable = true}, SHIFT(3952),
  [8932] = {.count = 1, .reusable = false}, SHIFT(3954),
  [8934] = {.count = 1, .reusable = false}, SHIFT(3955),
  [8936] = {.count = 1, .reusable = true}, SHIFT(3957),
  [8938] = {.count = 1, .reusable = true}, SHIFT(3958),
  [8940] = {.count = 1, .reusable = true}, SHIFT(3959),
  [8942] = {.count = 1, .reusable = false}, SHIFT(3960),
  [8944] = {.count = 1, .reusable = true}, SHIFT(3960),
  [8946] = {.count = 1, .reusable = false}, SHIFT(3965),
  [8948] = {.count = 1, .reusable = true}, SHIFT(3966),
  [8950] = {.count = 1, .reusable = true}, SHIFT(3968),
  [8952] = {.count = 1, .reusable = true}, SHIFT(3969),
  [8954] = {.count = 1, .reusable = false}, SHIFT(3971),
  [8956] = {.count = 1, .reusable = false}, SHIFT(3972),
  [8958] = {.count = 1, .reusable = true}, SHIFT(3973),
  [8960] = {.count = 1, .reusable = true}, SHIFT(3974),
  [8962] = {.count = 1, .reusable = true}, SHIFT(3975),
  [8964] = {.count = 1, .reusable = false}, SHIFT(3976),
  [8966] = {.count = 1, .reusable = true}, SHIFT(3976),
  [8968] = {.count = 1, .reusable = true}, SHIFT(3977),
  [8970] = {.count = 1, .reusable = false}, SHIFT(3979),
  [8972] = {.count = 1, .reusable = true}, SHIFT(3979),
  [8974] = {.count = 1, .reusable = true}, SHIFT(3978),
  [8976] = {.count = 1, .reusable = true}, SHIFT(3980),
  [8978] = {.count = 1, .reusable = false}, SHIFT(3982),
  [8980] = {.count = 1, .reusable = true}, SHIFT(3982),
  [8982] = {.count = 1, .reusable = true}, SHIFT(3981),
  [8984] = {.count = 1, .reusable = true}, SHIFT(3983),
  [8986] = {.count = 1, .reusable = true}, SHIFT(3984),
  [8988] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 4),
  [8990] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 4),
  [8992] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 4),
  [8994] = {.count = 1, .reusable = false}, SHIFT(3985),
  [8996] = {.count = 1, .reusable = true}, SHIFT(3985),
  [8998] = {.count = 1, .reusable = true}, SHIFT(3990),
  [9000] = {.count = 1, .reusable = true}, SHIFT(3991),
  [9002] = {.count = 1, .reusable = true}, SHIFT(3993),
  [9004] = {.count = 1, .reusable = false}, SHIFT(3995),
  [9006] = {.count = 1, .reusable = true}, SHIFT(3995),
  [9008] = {.count = 1, .reusable = true}, SHIFT(3997),
  [9010] = {.count = 1, .reusable = true}, SHIFT(3998),
  [9012] = {.count = 1, .reusable = false}, SHIFT(4001),
  [9014] = {.count = 1, .reusable = true}, SHIFT(4001),
  [9016] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(3624),
  [9019] = {.count = 1, .reusable = true}, REDUCE(sym_last_case_item, 4),
  [9021] = {.count = 1, .reusable = true}, SHIFT(4004),
  [9023] = {.count = 1, .reusable = true}, SHIFT(4005),
  [9025] = {.count = 1, .reusable = true}, SHIFT(4010),
  [9027] = {.count = 1, .reusable = true}, SHIFT(4011),
  [9029] = {.count = 1, .reusable = true}, SHIFT(4013),
  [9031] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 4, .alias_sequence_id = 1),
  [9033] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 4, .alias_sequence_id = 1),
  [9035] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 4, .alias_sequence_id = 1),
  [9037] = {.count = 1, .reusable = true}, REDUCE(sym_last_case_item, 4, .alias_sequence_id = 1),
  [9039] = {.count = 1, .reusable = true}, SHIFT(4014),
  [9041] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 8),
  [9043] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 8),
  [9045] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 8, .alias_sequence_id = 2),
  [9047] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 8, .alias_sequence_id = 2),
  [9049] = {.count = 1, .reusable = true}, SHIFT(4015),
  [9051] = {.count = 1, .reusable = true}, SHIFT(4016),
  [9053] = {.count = 1, .reusable = true}, SHIFT(4017),
  [9055] = {.count = 1, .reusable = false}, SHIFT(4018),
  [9057] = {.count = 1, .reusable = true}, SHIFT(4018),
  [9059] = {.count = 1, .reusable = false}, SHIFT(4019),
  [9061] = {.count = 1, .reusable = true}, SHIFT(4019),
  [9063] = {.count = 1, .reusable = true}, SHIFT(4020),
  [9065] = {.count = 1, .reusable = true}, SHIFT(4022),
  [9067] = {.count = 1, .reusable = true}, SHIFT(4023),
  [9069] = {.count = 1, .reusable = true}, SHIFT(4024),
  [9071] = {.count = 1, .reusable = true}, SHIFT(4025),
  [9073] = {.count = 1, .reusable = true}, SHIFT(4026),
  [9075] = {.count = 1, .reusable = true}, SHIFT(4027),
  [9077] = {.count = 1, .reusable = true}, SHIFT(4028),
  [9079] = {.count = 1, .reusable = true}, SHIFT(4029),
  [9081] = {.count = 1, .reusable = true}, SHIFT(4030),
  [9083] = {.count = 1, .reusable = true}, SHIFT(4031),
  [9085] = {.count = 1, .reusable = true}, SHIFT(4032),
  [9087] = {.count = 1, .reusable = false}, SHIFT(4033),
  [9089] = {.count = 1, .reusable = true}, SHIFT(4033),
  [9091] = {.count = 1, .reusable = false}, SHIFT(4034),
  [9093] = {.count = 1, .reusable = true}, SHIFT(4034),
  [9095] = {.count = 1, .reusable = true}, SHIFT(4035),
  [9097] = {.count = 1, .reusable = true}, SHIFT(4036),
  [9099] = {.count = 1, .reusable = true}, SHIFT(4037),
  [9101] = {.count = 1, .reusable = true}, SHIFT(4038),
  [9103] = {.count = 1, .reusable = true}, SHIFT(4039),
  [9105] = {.count = 1, .reusable = true}, SHIFT(4040),
  [9107] = {.count = 1, .reusable = true}, SHIFT(4041),
  [9109] = {.count = 1, .reusable = true}, REDUCE(sym_c_style_for_statement, 9),
  [9111] = {.count = 1, .reusable = false}, REDUCE(sym_c_style_for_statement, 9),
  [9113] = {.count = 1, .reusable = true}, SHIFT(4043),
  [9115] = {.count = 1, .reusable = true}, SHIFT(4044),
  [9117] = {.count = 1, .reusable = true}, SHIFT(4045),
  [9119] = {.count = 1, .reusable = true}, SHIFT(4046),
  [9121] = {.count = 1, .reusable = true}, SHIFT(4048),
  [9123] = {.count = 1, .reusable = false}, SHIFT(2816),
  [9125] = {.count = 1, .reusable = true}, SHIFT(4049),
  [9127] = {.count = 1, .reusable = true}, SHIFT(4050),
  [9129] = {.count = 1, .reusable = true}, SHIFT(4051),
  [9131] = {.count = 1, .reusable = true}, SHIFT(4054),
  [9133] = {.count = 1, .reusable = true}, SHIFT(4055),
  [9135] = {.count = 1, .reusable = false}, SHIFT(4056),
  [9137] = {.count = 1, .reusable = true}, SHIFT(4056),
  [9139] = {.count = 1, .reusable = true}, SHIFT(4057),
  [9141] = {.count = 1, .reusable = false}, SHIFT(4058),
  [9143] = {.count = 1, .reusable = true}, SHIFT(4058),
  [9145] = {.count = 1, .reusable = true}, SHIFT(4059),
  [9147] = {.count = 1, .reusable = false}, SHIFT(4060),
  [9149] = {.count = 1, .reusable = true}, SHIFT(4060),
  [9151] = {.count = 1, .reusable = true}, SHIFT(4061),
  [9153] = {.count = 1, .reusable = true}, SHIFT(4062),
  [9155] = {.count = 1, .reusable = true}, SHIFT(4063),
  [9157] = {.count = 1, .reusable = false}, SHIFT(4064),
  [9159] = {.count = 1, .reusable = true}, SHIFT(4064),
  [9161] = {.count = 1, .reusable = false}, SHIFT(4065),
  [9163] = {.count = 1, .reusable = true}, SHIFT(4065),
  [9165] = {.count = 1, .reusable = true}, SHIFT(4066),
  [9167] = {.count = 1, .reusable = true}, SHIFT(4067),
  [9169] = {.count = 1, .reusable = true}, SHIFT(4068),
  [9171] = {.count = 1, .reusable = true}, SHIFT(4069),
  [9173] = {.count = 1, .reusable = false}, SHIFT(4070),
  [9175] = {.count = 1, .reusable = true}, SHIFT(4070),
  [9177] = {.count = 1, .reusable = false}, SHIFT(4071),
  [9179] = {.count = 1, .reusable = true}, SHIFT(4071),
  [9181] = {.count = 1, .reusable = true}, SHIFT(4072),
  [9183] = {.count = 1, .reusable = true}, SHIFT(4073),
  [9185] = {.count = 1, .reusable = true}, SHIFT(4074),
  [9187] = {.count = 1, .reusable = true}, SHIFT(4075),
  [9189] = {.count = 1, .reusable = true}, SHIFT(4076),
  [9191] = {.count = 1, .reusable = true}, SHIFT(4077),
  [9193] = {.count = 1, .reusable = true}, SHIFT(4080),
  [9195] = {.count = 1, .reusable = true}, SHIFT(4081),
  [9197] = {.count = 1, .reusable = false}, SHIFT(4082),
  [9199] = {.count = 1, .reusable = true}, SHIFT(4082),
  [9201] = {.count = 1, .reusable = true}, SHIFT(4083),
  [9203] = {.count = 1, .reusable = false}, SHIFT(4084),
  [9205] = {.count = 1, .reusable = true}, SHIFT(4084),
  [9207] = {.count = 1, .reusable = true}, SHIFT(4085),
  [9209] = {.count = 1, .reusable = false}, SHIFT(4086),
  [9211] = {.count = 1, .reusable = true}, SHIFT(4086),
  [9213] = {.count = 1, .reusable = false}, SHIFT(2912),
  [9215] = {.count = 1, .reusable = true}, SHIFT(4087),
  [9217] = {.count = 1, .reusable = true}, SHIFT(4088),
  [9219] = {.count = 1, .reusable = true}, SHIFT(4089),
  [9221] = {.count = 1, .reusable = true}, SHIFT(4092),
  [9223] = {.count = 1, .reusable = true}, SHIFT(4093),
  [9225] = {.count = 1, .reusable = false}, SHIFT(4094),
  [9227] = {.count = 1, .reusable = true}, SHIFT(4094),
  [9229] = {.count = 1, .reusable = true}, SHIFT(4095),
  [9231] = {.count = 1, .reusable = false}, SHIFT(4096),
  [9233] = {.count = 1, .reusable = true}, SHIFT(4096),
  [9235] = {.count = 1, .reusable = true}, SHIFT(4097),
  [9237] = {.count = 1, .reusable = false}, SHIFT(4098),
  [9239] = {.count = 1, .reusable = true}, SHIFT(4098),
  [9241] = {.count = 1, .reusable = false}, SHIFT(4099),
  [9243] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(3446),
  [9246] = {.count = 1, .reusable = false}, SHIFT(4100),
  [9248] = {.count = 1, .reusable = true}, SHIFT(4101),
  [9250] = {.count = 1, .reusable = true}, SHIFT(4102),
  [9252] = {.count = 1, .reusable = true}, SHIFT(4105),
  [9254] = {.count = 1, .reusable = true}, SHIFT(4106),
  [9256] = {.count = 1, .reusable = false}, SHIFT(4108),
  [9258] = {.count = 1, .reusable = true}, SHIFT(4108),
  [9260] = {.count = 1, .reusable = true}, SHIFT(4107),
  [9262] = {.count = 1, .reusable = false}, SHIFT(4110),
  [9264] = {.count = 1, .reusable = true}, SHIFT(4110),
  [9266] = {.count = 1, .reusable = true}, SHIFT(4109),
  [9268] = {.count = 1, .reusable = true}, SHIFT(4111),
  [9270] = {.count = 1, .reusable = true}, SHIFT(4112),
  [9272] = {.count = 1, .reusable = false}, SHIFT(4113),
  [9274] = {.count = 1, .reusable = true}, SHIFT(4113),
  [9276] = {.count = 1, .reusable = true}, SHIFT(4114),
  [9278] = {.count = 1, .reusable = true}, SHIFT(4115),
  [9280] = {.count = 1, .reusable = false}, SHIFT(2943),
  [9282] = {.count = 1, .reusable = true}, SHIFT(4116),
  [9284] = {.count = 1, .reusable = true}, SHIFT(4117),
  [9286] = {.count = 1, .reusable = true}, SHIFT(4118),
  [9288] = {.count = 1, .reusable = true}, SHIFT(4121),
  [9290] = {.count = 1, .reusable = true}, SHIFT(4122),
  [9292] = {.count = 1, .reusable = false}, SHIFT(4123),
  [9294] = {.count = 1, .reusable = true}, SHIFT(4123),
  [9296] = {.count = 1, .reusable = true}, SHIFT(4124),
  [9298] = {.count = 1, .reusable = false}, SHIFT(4125),
  [9300] = {.count = 1, .reusable = true}, SHIFT(4125),
  [9302] = {.count = 1, .reusable = true}, SHIFT(4126),
  [9304] = {.count = 1, .reusable = false}, SHIFT(4127),
  [9306] = {.count = 1, .reusable = true}, SHIFT(4127),
  [9308] = {.count = 1, .reusable = false}, SHIFT(2962),
  [9310] = {.count = 1, .reusable = true}, SHIFT(4128),
  [9312] = {.count = 1, .reusable = true}, SHIFT(4129),
  [9314] = {.count = 1, .reusable = true}, SHIFT(4130),
  [9316] = {.count = 1, .reusable = true}, SHIFT(4133),
  [9318] = {.count = 1, .reusable = true}, SHIFT(4134),
  [9320] = {.count = 1, .reusable = false}, SHIFT(4135),
  [9322] = {.count = 1, .reusable = true}, SHIFT(4135),
  [9324] = {.count = 1, .reusable = true}, SHIFT(4136),
  [9326] = {.count = 1, .reusable = false}, SHIFT(4137),
  [9328] = {.count = 1, .reusable = true}, SHIFT(4137),
  [9330] = {.count = 1, .reusable = true}, SHIFT(4138),
  [9332] = {.count = 1, .reusable = false}, SHIFT(4139),
  [9334] = {.count = 1, .reusable = true}, SHIFT(4139),
  [9336] = {.count = 1, .reusable = true}, SHIFT(4140),
  [9338] = {.count = 1, .reusable = true}, SHIFT(4141),
  [9340] = {.count = 1, .reusable = true}, SHIFT(4142),
  [9342] = {.count = 1, .reusable = false}, SHIFT(4143),
  [9344] = {.count = 1, .reusable = true}, SHIFT(4143),
  [9346] = {.count = 1, .reusable = false}, SHIFT(4144),
  [9348] = {.count = 1, .reusable = true}, SHIFT(4144),
  [9350] = {.count = 1, .reusable = true}, SHIFT(4145),
  [9352] = {.count = 1, .reusable = false}, SHIFT(4146),
  [9354] = {.count = 1, .reusable = true}, SHIFT(4147),
  [9356] = {.count = 1, .reusable = true}, SHIFT(4148),
  [9358] = {.count = 1, .reusable = true}, SHIFT(4149),
  [9360] = {.count = 1, .reusable = false}, SHIFT(4150),
  [9362] = {.count = 1, .reusable = true}, SHIFT(4150),
  [9364] = {.count = 1, .reusable = false}, SHIFT(4151),
  [9366] = {.count = 1, .reusable = true}, SHIFT(4151),
  [9368] = {.count = 1, .reusable = true}, SHIFT(4152),
  [9370] = {.count = 1, .reusable = true}, SHIFT(4153),
  [9372] = {.count = 1, .reusable = true}, SHIFT(4154),
  [9374] = {.count = 1, .reusable = true}, SHIFT(4155),
  [9376] = {.count = 1, .reusable = false}, SHIFT(4156),
  [9378] = {.count = 1, .reusable = true}, SHIFT(4156),
  [9380] = {.count = 1, .reusable = false}, SHIFT(4157),
  [9382] = {.count = 1, .reusable = true}, SHIFT(4157),
  [9384] = {.count = 1, .reusable = true}, SHIFT(4158),
  [9386] = {.count = 1, .reusable = true}, SHIFT(4159),
  [9388] = {.count = 1, .reusable = true}, SHIFT(4160),
  [9390] = {.count = 1, .reusable = true}, SHIFT(4161),
  [9392] = {.count = 1, .reusable = true}, SHIFT(4163),
  [9394] = {.count = 1, .reusable = true}, SHIFT(4164),
  [9396] = {.count = 1, .reusable = false}, SHIFT(4165),
  [9398] = {.count = 1, .reusable = true}, SHIFT(4165),
  [9400] = {.count = 1, .reusable = true}, SHIFT(4166),
  [9402] = {.count = 1, .reusable = false}, SHIFT(4168),
  [9404] = {.count = 1, .reusable = false}, SHIFT(4169),
  [9406] = {.count = 1, .reusable = true}, SHIFT(4171),
  [9408] = {.count = 1, .reusable = true}, SHIFT(4172),
  [9410] = {.count = 1, .reusable = true}, SHIFT(4173),
  [9412] = {.count = 1, .reusable = false}, SHIFT(4174),
  [9414] = {.count = 1, .reusable = true}, SHIFT(4174),
  [9416] = {.count = 1, .reusable = true}, SHIFT(4179),
  [9418] = {.count = 1, .reusable = true}, SHIFT(4181),
  [9420] = {.count = 1, .reusable = true}, SHIFT(4182),
  [9422] = {.count = 1, .reusable = true}, SHIFT(4183),
  [9424] = {.count = 1, .reusable = true}, SHIFT(4185),
  [9426] = {.count = 1, .reusable = true}, SHIFT(4186),
  [9428] = {.count = 1, .reusable = false}, SHIFT(4188),
  [9430] = {.count = 1, .reusable = false}, SHIFT(4189),
  [9432] = {.count = 1, .reusable = true}, SHIFT(4190),
  [9434] = {.count = 1, .reusable = true}, SHIFT(4191),
  [9436] = {.count = 1, .reusable = true}, SHIFT(4192),
  [9438] = {.count = 1, .reusable = false}, SHIFT(4193),
  [9440] = {.count = 1, .reusable = true}, SHIFT(4193),
  [9442] = {.count = 1, .reusable = true}, SHIFT(4194),
  [9444] = {.count = 1, .reusable = false}, SHIFT(4196),
  [9446] = {.count = 1, .reusable = true}, SHIFT(4196),
  [9448] = {.count = 1, .reusable = true}, SHIFT(4195),
  [9450] = {.count = 1, .reusable = true}, SHIFT(4197),
  [9452] = {.count = 1, .reusable = false}, SHIFT(4199),
  [9454] = {.count = 1, .reusable = true}, SHIFT(4199),
  [9456] = {.count = 1, .reusable = true}, SHIFT(4198),
  [9458] = {.count = 1, .reusable = true}, SHIFT(4200),
  [9460] = {.count = 1, .reusable = true}, SHIFT(4201),
  [9462] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(3570),
  [9465] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(3571),
  [9468] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(3572),
  [9471] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(3573),
  [9474] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(3574),
  [9477] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(3575),
  [9480] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(3576),
  [9483] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(3577),
  [9486] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(3578),
  [9489] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(3946),
  [9492] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(3574),
  [9495] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(3947),
  [9498] = {.count = 1, .reusable = true}, SHIFT(4202),
  [9500] = {.count = 1, .reusable = true}, SHIFT(4203),
  [9502] = {.count = 1, .reusable = false}, SHIFT(4205),
  [9504] = {.count = 1, .reusable = false}, SHIFT(4206),
  [9506] = {.count = 1, .reusable = true}, SHIFT(4207),
  [9508] = {.count = 1, .reusable = true}, SHIFT(4208),
  [9510] = {.count = 1, .reusable = true}, SHIFT(4209),
  [9512] = {.count = 1, .reusable = false}, SHIFT(4210),
  [9514] = {.count = 1, .reusable = true}, SHIFT(4210),
  [9516] = {.count = 1, .reusable = true}, SHIFT(4211),
  [9518] = {.count = 1, .reusable = false}, SHIFT(4213),
  [9520] = {.count = 1, .reusable = true}, SHIFT(4213),
  [9522] = {.count = 1, .reusable = true}, SHIFT(4212),
  [9524] = {.count = 1, .reusable = true}, SHIFT(4214),
  [9526] = {.count = 1, .reusable = false}, SHIFT(4216),
  [9528] = {.count = 1, .reusable = true}, SHIFT(4216),
  [9530] = {.count = 1, .reusable = true}, SHIFT(4215),
  [9532] = {.count = 1, .reusable = true}, SHIFT(4217),
  [9534] = {.count = 1, .reusable = true}, SHIFT(4218),
  [9536] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(3582),
  [9539] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(3583),
  [9542] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(3584),
  [9545] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(3585),
  [9548] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(3586),
  [9551] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(3587),
  [9554] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(3588),
  [9557] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(3589),
  [9560] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(3965),
  [9563] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(3585),
  [9566] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(3966),
  [9569] = {.count = 1, .reusable = false}, SHIFT(4219),
  [9571] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(3595),
  [9574] = {.count = 1, .reusable = false}, SHIFT(4220),
  [9576] = {.count = 1, .reusable = true}, SHIFT(4221),
  [9578] = {.count = 1, .reusable = true}, SHIFT(4222),
  [9580] = {.count = 1, .reusable = true}, SHIFT(4225),
  [9582] = {.count = 1, .reusable = true}, SHIFT(4226),
  [9584] = {.count = 1, .reusable = false}, SHIFT(4228),
  [9586] = {.count = 1, .reusable = true}, SHIFT(4228),
  [9588] = {.count = 1, .reusable = true}, SHIFT(4227),
  [9590] = {.count = 1, .reusable = false}, SHIFT(4230),
  [9592] = {.count = 1, .reusable = true}, SHIFT(4230),
  [9594] = {.count = 1, .reusable = true}, SHIFT(4229),
  [9596] = {.count = 1, .reusable = true}, SHIFT(4231),
  [9598] = {.count = 1, .reusable = true}, SHIFT(4232),
  [9600] = {.count = 1, .reusable = false}, SHIFT(4233),
  [9602] = {.count = 1, .reusable = true}, SHIFT(4233),
  [9604] = {.count = 1, .reusable = true}, SHIFT(4234),
  [9606] = {.count = 1, .reusable = true}, SHIFT(4235),
  [9608] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(3609),
  [9611] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(3613),
  [9614] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(3613),
  [9617] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(3614),
  [9620] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(3617),
  [9623] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(3087),
  [9626] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(3088),
  [9629] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(3089),
  [9632] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(3618),
  [9635] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(3091),
  [9638] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(3092),
  [9641] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(3093),
  [9644] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(3094),
  [9647] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(3618),
  [9650] = {.count = 1, .reusable = false}, SHIFT(4239),
  [9652] = {.count = 1, .reusable = true}, SHIFT(4239),
  [9654] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 5),
  [9656] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 5),
  [9658] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 5),
  [9660] = {.count = 1, .reusable = true}, SHIFT(4240),
  [9662] = {.count = 1, .reusable = true}, SHIFT(4245),
  [9664] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 5, .alias_sequence_id = 1),
  [9666] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 5, .alias_sequence_id = 1),
  [9668] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 5, .alias_sequence_id = 1),
  [9670] = {.count = 1, .reusable = true}, SHIFT(4247),
  [9672] = {.count = 1, .reusable = true}, SHIFT(4248),
  [9674] = {.count = 1, .reusable = true}, SHIFT(4250),
  [9676] = {.count = 1, .reusable = true}, SHIFT(4251),
  [9678] = {.count = 1, .reusable = true}, SHIFT(4252),
  [9680] = {.count = 1, .reusable = true}, REDUCE(sym_c_style_for_statement, 10),
  [9682] = {.count = 1, .reusable = false}, REDUCE(sym_c_style_for_statement, 10),
  [9684] = {.count = 1, .reusable = true}, SHIFT(4254),
  [9686] = {.count = 1, .reusable = true}, SHIFT(4255),
  [9688] = {.count = 1, .reusable = true}, SHIFT(4256),
  [9690] = {.count = 1, .reusable = false}, SHIFT(4257),
  [9692] = {.count = 1, .reusable = true}, SHIFT(4257),
  [9694] = {.count = 1, .reusable = false}, SHIFT(4258),
  [9696] = {.count = 1, .reusable = true}, SHIFT(4258),
  [9698] = {.count = 1, .reusable = true}, SHIFT(4259),
  [9700] = {.count = 1, .reusable = true}, SHIFT(4260),
  [9702] = {.count = 1, .reusable = true}, SHIFT(4261),
  [9704] = {.count = 1, .reusable = true}, SHIFT(4262),
  [9706] = {.count = 1, .reusable = true}, SHIFT(4263),
  [9708] = {.count = 1, .reusable = true}, SHIFT(4264),
  [9710] = {.count = 1, .reusable = true}, SHIFT(4265),
  [9712] = {.count = 1, .reusable = true}, SHIFT(4266),
  [9714] = {.count = 1, .reusable = false}, SHIFT(4267),
  [9716] = {.count = 1, .reusable = true}, SHIFT(4267),
  [9718] = {.count = 1, .reusable = false}, SHIFT(4268),
  [9720] = {.count = 1, .reusable = true}, SHIFT(4268),
  [9722] = {.count = 1, .reusable = true}, SHIFT(4269),
  [9724] = {.count = 1, .reusable = true}, SHIFT(4270),
  [9726] = {.count = 1, .reusable = true}, SHIFT(4271),
  [9728] = {.count = 1, .reusable = true}, SHIFT(4272),
  [9730] = {.count = 1, .reusable = false}, SHIFT(4273),
  [9732] = {.count = 1, .reusable = true}, SHIFT(4273),
  [9734] = {.count = 1, .reusable = false}, SHIFT(4274),
  [9736] = {.count = 1, .reusable = true}, SHIFT(4274),
  [9738] = {.count = 1, .reusable = true}, SHIFT(4275),
  [9740] = {.count = 1, .reusable = false}, SHIFT(3443),
  [9742] = {.count = 1, .reusable = true}, SHIFT(4276),
  [9744] = {.count = 1, .reusable = true}, SHIFT(4277),
  [9746] = {.count = 1, .reusable = true}, SHIFT(4278),
  [9748] = {.count = 1, .reusable = true}, SHIFT(4281),
  [9750] = {.count = 1, .reusable = true}, SHIFT(4282),
  [9752] = {.count = 1, .reusable = false}, SHIFT(4283),
  [9754] = {.count = 1, .reusable = true}, SHIFT(4283),
  [9756] = {.count = 1, .reusable = true}, SHIFT(4284),
  [9758] = {.count = 1, .reusable = false}, SHIFT(4285),
  [9760] = {.count = 1, .reusable = true}, SHIFT(4285),
  [9762] = {.count = 1, .reusable = true}, SHIFT(4286),
  [9764] = {.count = 1, .reusable = false}, SHIFT(4287),
  [9766] = {.count = 1, .reusable = true}, SHIFT(4287),
  [9768] = {.count = 1, .reusable = true}, SHIFT(4288),
  [9770] = {.count = 1, .reusable = true}, SHIFT(4289),
  [9772] = {.count = 1, .reusable = true}, SHIFT(4290),
  [9774] = {.count = 1, .reusable = false}, SHIFT(4291),
  [9776] = {.count = 1, .reusable = true}, SHIFT(4291),
  [9778] = {.count = 1, .reusable = false}, SHIFT(4292),
  [9780] = {.count = 1, .reusable = true}, SHIFT(4292),
  [9782] = {.count = 1, .reusable = true}, SHIFT(4293),
  [9784] = {.count = 1, .reusable = true}, SHIFT(4294),
  [9786] = {.count = 1, .reusable = true}, SHIFT(4295),
  [9788] = {.count = 1, .reusable = true}, SHIFT(4296),
  [9790] = {.count = 1, .reusable = false}, SHIFT(4297),
  [9792] = {.count = 1, .reusable = true}, SHIFT(4297),
  [9794] = {.count = 1, .reusable = false}, SHIFT(4298),
  [9796] = {.count = 1, .reusable = true}, SHIFT(4298),
  [9798] = {.count = 1, .reusable = true}, SHIFT(4299),
  [9800] = {.count = 1, .reusable = true}, SHIFT(4300),
  [9802] = {.count = 1, .reusable = true}, SHIFT(4301),
  [9804] = {.count = 1, .reusable = true}, SHIFT(4302),
  [9806] = {.count = 1, .reusable = true}, SHIFT(4303),
  [9808] = {.count = 1, .reusable = true}, SHIFT(4304),
  [9810] = {.count = 1, .reusable = true}, SHIFT(4305),
  [9812] = {.count = 1, .reusable = true}, SHIFT(4306),
  [9814] = {.count = 1, .reusable = true}, SHIFT(4307),
  [9816] = {.count = 1, .reusable = true}, SHIFT(4308),
  [9818] = {.count = 1, .reusable = false}, SHIFT(4310),
  [9820] = {.count = 1, .reusable = false}, SHIFT(4311),
  [9822] = {.count = 1, .reusable = true}, SHIFT(4312),
  [9824] = {.count = 1, .reusable = true}, SHIFT(4313),
  [9826] = {.count = 1, .reusable = true}, SHIFT(4314),
  [9828] = {.count = 1, .reusable = false}, SHIFT(4315),
  [9830] = {.count = 1, .reusable = true}, SHIFT(4315),
  [9832] = {.count = 1, .reusable = true}, SHIFT(4316),
  [9834] = {.count = 1, .reusable = false}, SHIFT(4318),
  [9836] = {.count = 1, .reusable = true}, SHIFT(4318),
  [9838] = {.count = 1, .reusable = true}, SHIFT(4317),
  [9840] = {.count = 1, .reusable = true}, SHIFT(4319),
  [9842] = {.count = 1, .reusable = false}, SHIFT(4321),
  [9844] = {.count = 1, .reusable = true}, SHIFT(4321),
  [9846] = {.count = 1, .reusable = true}, SHIFT(4320),
  [9848] = {.count = 1, .reusable = true}, SHIFT(4322),
  [9850] = {.count = 1, .reusable = true}, SHIFT(4323),
  [9852] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(4179),
  [9855] = {.count = 1, .reusable = true}, SHIFT(4324),
  [9857] = {.count = 1, .reusable = false}, SHIFT(4326),
  [9859] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(3933),
  [9862] = {.count = 1, .reusable = false}, SHIFT(4327),
  [9864] = {.count = 1, .reusable = true}, SHIFT(4328),
  [9866] = {.count = 1, .reusable = true}, SHIFT(4329),
  [9868] = {.count = 1, .reusable = true}, SHIFT(4332),
  [9870] = {.count = 1, .reusable = true}, SHIFT(4333),
  [9872] = {.count = 1, .reusable = false}, SHIFT(4335),
  [9874] = {.count = 1, .reusable = true}, SHIFT(4335),
  [9876] = {.count = 1, .reusable = true}, SHIFT(4334),
  [9878] = {.count = 1, .reusable = false}, SHIFT(4337),
  [9880] = {.count = 1, .reusable = true}, SHIFT(4337),
  [9882] = {.count = 1, .reusable = true}, SHIFT(4336),
  [9884] = {.count = 1, .reusable = true}, SHIFT(4338),
  [9886] = {.count = 1, .reusable = true}, SHIFT(4339),
  [9888] = {.count = 1, .reusable = false}, SHIFT(4340),
  [9890] = {.count = 1, .reusable = true}, SHIFT(4340),
  [9892] = {.count = 1, .reusable = true}, SHIFT(4341),
  [9894] = {.count = 1, .reusable = false}, SHIFT(4342),
  [9896] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(3952),
  [9899] = {.count = 1, .reusable = false}, SHIFT(4343),
  [9901] = {.count = 1, .reusable = true}, SHIFT(4344),
  [9903] = {.count = 1, .reusable = true}, SHIFT(4345),
  [9905] = {.count = 1, .reusable = true}, SHIFT(4348),
  [9907] = {.count = 1, .reusable = true}, SHIFT(4349),
  [9909] = {.count = 1, .reusable = false}, SHIFT(4351),
  [9911] = {.count = 1, .reusable = true}, SHIFT(4351),
  [9913] = {.count = 1, .reusable = true}, SHIFT(4350),
  [9915] = {.count = 1, .reusable = false}, SHIFT(4353),
  [9917] = {.count = 1, .reusable = true}, SHIFT(4353),
  [9919] = {.count = 1, .reusable = true}, SHIFT(4352),
  [9921] = {.count = 1, .reusable = true}, SHIFT(4354),
  [9923] = {.count = 1, .reusable = true}, SHIFT(4355),
  [9925] = {.count = 1, .reusable = false}, SHIFT(4356),
  [9927] = {.count = 1, .reusable = true}, SHIFT(4356),
  [9929] = {.count = 1, .reusable = true}, SHIFT(4357),
  [9931] = {.count = 1, .reusable = false}, SHIFT(3592),
  [9933] = {.count = 1, .reusable = true}, SHIFT(4358),
  [9935] = {.count = 1, .reusable = true}, SHIFT(4359),
  [9937] = {.count = 1, .reusable = true}, SHIFT(4360),
  [9939] = {.count = 1, .reusable = true}, SHIFT(4363),
  [9941] = {.count = 1, .reusable = true}, SHIFT(4364),
  [9943] = {.count = 1, .reusable = false}, SHIFT(4365),
  [9945] = {.count = 1, .reusable = true}, SHIFT(4365),
  [9947] = {.count = 1, .reusable = true}, SHIFT(4366),
  [9949] = {.count = 1, .reusable = false}, SHIFT(4367),
  [9951] = {.count = 1, .reusable = true}, SHIFT(4367),
  [9953] = {.count = 1, .reusable = true}, SHIFT(4368),
  [9955] = {.count = 1, .reusable = false}, SHIFT(4369),
  [9957] = {.count = 1, .reusable = true}, SHIFT(4369),
  [9959] = {.count = 1, .reusable = true}, SHIFT(4370),
  [9961] = {.count = 1, .reusable = true}, SHIFT(4373),
  [9963] = {.count = 1, .reusable = true}, SHIFT(4374),
  [9965] = {.count = 1, .reusable = true}, SHIFT(4376),
  [9967] = {.count = 1, .reusable = true}, SHIFT(4377),
  [9969] = {.count = 1, .reusable = true}, SHIFT(4378),
  [9971] = {.count = 1, .reusable = true}, SHIFT(4379),
  [9973] = {.count = 1, .reusable = true}, SHIFT(4380),
  [9975] = {.count = 1, .reusable = true}, SHIFT(4381),
  [9977] = {.count = 1, .reusable = true}, SHIFT(4382),
  [9979] = {.count = 1, .reusable = true}, SHIFT(4383),
  [9981] = {.count = 1, .reusable = true}, SHIFT(4384),
  [9983] = {.count = 1, .reusable = false}, SHIFT(4385),
  [9985] = {.count = 1, .reusable = true}, SHIFT(4385),
  [9987] = {.count = 1, .reusable = false}, SHIFT(4386),
  [9989] = {.count = 1, .reusable = true}, SHIFT(4386),
  [9991] = {.count = 1, .reusable = true}, SHIFT(4387),
  [9993] = {.count = 1, .reusable = true}, SHIFT(4388),
  [9995] = {.count = 1, .reusable = true}, SHIFT(4389),
  [9997] = {.count = 1, .reusable = true}, SHIFT(4390),
  [9999] = {.count = 1, .reusable = true}, SHIFT(4391),
  [10001] = {.count = 1, .reusable = false}, SHIFT(4392),
  [10003] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(4166),
  [10006] = {.count = 1, .reusable = false}, SHIFT(4393),
  [10008] = {.count = 1, .reusable = true}, SHIFT(4394),
  [10010] = {.count = 1, .reusable = true}, SHIFT(4395),
  [10012] = {.count = 1, .reusable = true}, SHIFT(4398),
  [10014] = {.count = 1, .reusable = true}, SHIFT(4399),
  [10016] = {.count = 1, .reusable = false}, SHIFT(4401),
  [10018] = {.count = 1, .reusable = true}, SHIFT(4401),
  [10020] = {.count = 1, .reusable = true}, SHIFT(4400),
  [10022] = {.count = 1, .reusable = false}, SHIFT(4403),
  [10024] = {.count = 1, .reusable = true}, SHIFT(4403),
  [10026] = {.count = 1, .reusable = true}, SHIFT(4402),
  [10028] = {.count = 1, .reusable = true}, SHIFT(4404),
  [10030] = {.count = 1, .reusable = true}, SHIFT(4405),
  [10032] = {.count = 1, .reusable = false}, SHIFT(4406),
  [10034] = {.count = 1, .reusable = true}, SHIFT(4406),
  [10036] = {.count = 1, .reusable = true}, SHIFT(4407),
  [10038] = {.count = 1, .reusable = true}, SHIFT(4408),
  [10040] = {.count = 1, .reusable = false}, SHIFT(3930),
  [10042] = {.count = 1, .reusable = true}, SHIFT(4409),
  [10044] = {.count = 1, .reusable = true}, SHIFT(4410),
  [10046] = {.count = 1, .reusable = true}, SHIFT(4411),
  [10048] = {.count = 1, .reusable = true}, SHIFT(4414),
  [10050] = {.count = 1, .reusable = true}, SHIFT(4415),
  [10052] = {.count = 1, .reusable = false}, SHIFT(4416),
  [10054] = {.count = 1, .reusable = true}, SHIFT(4416),
  [10056] = {.count = 1, .reusable = true}, SHIFT(4417),
  [10058] = {.count = 1, .reusable = false}, SHIFT(4418),
  [10060] = {.count = 1, .reusable = true}, SHIFT(4418),
  [10062] = {.count = 1, .reusable = true}, SHIFT(4419),
  [10064] = {.count = 1, .reusable = false}, SHIFT(4420),
  [10066] = {.count = 1, .reusable = true}, SHIFT(4420),
  [10068] = {.count = 1, .reusable = false}, SHIFT(3949),
  [10070] = {.count = 1, .reusable = true}, SHIFT(4421),
  [10072] = {.count = 1, .reusable = true}, SHIFT(4422),
  [10074] = {.count = 1, .reusable = true}, SHIFT(4423),
  [10076] = {.count = 1, .reusable = true}, SHIFT(4426),
  [10078] = {.count = 1, .reusable = true}, SHIFT(4427),
  [10080] = {.count = 1, .reusable = false}, SHIFT(4428),
  [10082] = {.count = 1, .reusable = true}, SHIFT(4428),
  [10084] = {.count = 1, .reusable = true}, SHIFT(4429),
  [10086] = {.count = 1, .reusable = false}, SHIFT(4430),
  [10088] = {.count = 1, .reusable = true}, SHIFT(4430),
  [10090] = {.count = 1, .reusable = true}, SHIFT(4431),
  [10092] = {.count = 1, .reusable = false}, SHIFT(4432),
  [10094] = {.count = 1, .reusable = true}, SHIFT(4432),
  [10096] = {.count = 1, .reusable = true}, SHIFT(4433),
  [10098] = {.count = 1, .reusable = true}, SHIFT(4434),
  [10100] = {.count = 1, .reusable = true}, SHIFT(4435),
  [10102] = {.count = 1, .reusable = false}, SHIFT(4436),
  [10104] = {.count = 1, .reusable = true}, SHIFT(4436),
  [10106] = {.count = 1, .reusable = false}, SHIFT(4437),
  [10108] = {.count = 1, .reusable = true}, SHIFT(4437),
  [10110] = {.count = 1, .reusable = true}, SHIFT(4438),
  [10112] = {.count = 1, .reusable = false}, SHIFT(4439),
  [10114] = {.count = 1, .reusable = true}, SHIFT(4440),
  [10116] = {.count = 1, .reusable = true}, SHIFT(4441),
  [10118] = {.count = 1, .reusable = false}, SHIFT(4163),
  [10120] = {.count = 1, .reusable = true}, SHIFT(4442),
  [10122] = {.count = 1, .reusable = true}, SHIFT(4443),
  [10124] = {.count = 1, .reusable = true}, SHIFT(4444),
  [10126] = {.count = 1, .reusable = true}, SHIFT(4447),
  [10128] = {.count = 1, .reusable = true}, SHIFT(4448),
  [10130] = {.count = 1, .reusable = false}, SHIFT(4449),
  [10132] = {.count = 1, .reusable = true}, SHIFT(4449),
  [10134] = {.count = 1, .reusable = true}, SHIFT(4450),
  [10136] = {.count = 1, .reusable = false}, SHIFT(4451),
  [10138] = {.count = 1, .reusable = true}, SHIFT(4451),
  [10140] = {.count = 1, .reusable = true}, SHIFT(4452),
  [10142] = {.count = 1, .reusable = false}, SHIFT(4453),
  [10144] = {.count = 1, .reusable = true}, SHIFT(4453),
  [10146] = {.count = 1, .reusable = true}, SHIFT(4454),
  [10148] = {.count = 1, .reusable = true}, SHIFT(4455),
  [10150] = {.count = 1, .reusable = true}, SHIFT(4456),
  [10152] = {.count = 1, .reusable = false}, SHIFT(4457),
  [10154] = {.count = 1, .reusable = true}, SHIFT(4457),
  [10156] = {.count = 1, .reusable = false}, SHIFT(4458),
  [10158] = {.count = 1, .reusable = true}, SHIFT(4458),
  [10160] = {.count = 1, .reusable = true}, SHIFT(4459),
  [10162] = {.count = 1, .reusable = true}, SHIFT(4460),
  [10164] = {.count = 1, .reusable = true}, SHIFT(4461),
  [10166] = {.count = 1, .reusable = true}, SHIFT(4462),
  [10168] = {.count = 1, .reusable = false}, SHIFT(4463),
  [10170] = {.count = 1, .reusable = true}, SHIFT(4463),
  [10172] = {.count = 1, .reusable = false}, SHIFT(4464),
  [10174] = {.count = 1, .reusable = true}, SHIFT(4464),
  [10176] = {.count = 1, .reusable = true}, SHIFT(4465),
  [10178] = {.count = 1, .reusable = true}, SHIFT(4466),
  [10180] = {.count = 1, .reusable = true}, SHIFT(4467),
  [10182] = {.count = 1, .reusable = true}, SHIFT(4468),
  [10184] = {.count = 1, .reusable = true}, SHIFT(4469),
  [10186] = {.count = 1, .reusable = true}, SHIFT(4470),
  [10188] = {.count = 1, .reusable = false}, SHIFT(4471),
  [10190] = {.count = 1, .reusable = true}, SHIFT(4471),
  [10192] = {.count = 1, .reusable = false}, SHIFT(4472),
  [10194] = {.count = 1, .reusable = true}, SHIFT(4472),
  [10196] = {.count = 1, .reusable = true}, SHIFT(4473),
  [10198] = {.count = 1, .reusable = true}, SHIFT(4474),
  [10200] = {.count = 1, .reusable = true}, SHIFT(4475),
  [10202] = {.count = 1, .reusable = true}, SHIFT(4476),
  [10204] = {.count = 1, .reusable = true}, SHIFT(4477),
  [10206] = {.count = 1, .reusable = true}, SHIFT(4478),
  [10208] = {.count = 1, .reusable = true}, SHIFT(4479),
};

void *tree_sitter_bash_external_scanner_create();
void tree_sitter_bash_external_scanner_destroy(void *);
bool tree_sitter_bash_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_bash_external_scanner_serialize(void *, char *);
void tree_sitter_bash_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_bash() {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_word,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_bash_external_scanner_create,
      tree_sitter_bash_external_scanner_destroy,
      tree_sitter_bash_external_scanner_scan,
      tree_sitter_bash_external_scanner_serialize,
      tree_sitter_bash_external_scanner_deserialize,
    },
  };
  return &language;
}
